/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/platform","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/editor/common/core/range","vs/base/common/functional","vs/base/common/lifecycle","vs/base/common/stopwatch","vs/base/common/event","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/base/common/uri","vs/base/common/diff/diffChange","vs/base/common/iterator","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/base/common/hash","vs/editor/common/core/characterClassifier","vs/editor/common/core/selection","vs/editor/common/core/token","vs/editor/common/diff/diffComputer","vs/editor/common/model/wordHelper","vs/editor/common/modes/linkComputer","vs/editor/common/modes/supports/inplaceReplaceSupport","vs/editor/common/standalone/standaloneEnums","vs/editor/common/standalone/standaloneBase","vs/editor/common/viewModel/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],X=function(I){for(var t=[],M=0,U=I.length;M<U;M++)t[M]=Q[I[M]];return t},ve=this,Le=typeof global=="object"?global:{},K;(function(I){I.global=ve;var t=function(){function M(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1}return Object.defineProperty(M.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),M.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=M._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof I.global.importScripts=="function")},M._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},M}();I.Environment=t})(K||(K={}));var K;(function(I){var t=function(){function C(l,S,u){this.type=l,this.detail=S,this.timestamp=u}return C}();I.LoaderEvent=t;var M=function(){function C(l){this._events=[new t(1,"",l)]}return C.prototype.record=function(l,S){this._events.push(new t(l,S,I.Utilities.getHighPerformanceTimestamp()))},C.prototype.getEvents=function(){return this._events},C}();I.LoaderEventRecorder=M;var U=function(){function C(){}return C.prototype.record=function(l,S){},C.prototype.getEvents=function(){return[]},C.INSTANCE=new C,C}();I.NullLoaderEventRecorder=U})(K||(K={}));var K;(function(I){var t=function(){function M(){}return M.fileUriToFilePath=function(U,C){if(C=decodeURI(C).replace(/%23/g,"#"),U){if(/^file:\/\/\//.test(C))return C.substr(8);if(/^file:\/\//.test(C))return C.substr(5)}else if(/^file:\/\//.test(C))return C.substr(7);return C},M.startsWith=function(U,C){return U.length>=C.length&&U.substr(0,C.length)===C},M.endsWith=function(U,C){return U.length>=C.length&&U.substr(U.length-C.length)===C},M.containsQueryString=function(U){return/^[^\#]*\?/gi.test(U)},M.isAbsolutePath=function(U){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(U)},M.forEachProperty=function(U,C){if(U){var l=void 0;for(l in U)U.hasOwnProperty(l)&&C(l,U[l])}},M.isEmpty=function(U){var C=!0;return M.forEachProperty(U,function(){C=!1}),C},M.recursiveClone=function(U){if(!U||typeof U!="object"||U instanceof RegExp||!Array.isArray(U)&&Object.getPrototypeOf(U)!==Object.prototype)return U;var C=Array.isArray(U)?[]:{};return M.forEachProperty(U,function(l,S){S&&typeof S=="object"?C[l]=M.recursiveClone(S):C[l]=S}),C},M.generateAnonymousModule=function(){return"===anonymous"+M.NEXT_ANONYMOUS_ID+++"==="},M.isAnonymousModule=function(U){return M.startsWith(U,"===anonymous")},M.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=I.global.performance&&typeof I.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?I.global.performance.now():Date.now()},M.NEXT_ANONYMOUS_ID=1,M.PERFORMANCE_NOW_PROBED=!1,M.HAS_PERFORMANCE_NOW=!1,M}();I.Utilities=t})(K||(K={}));var K;(function(I){function t(C){if(C instanceof Error)return C;var l=new Error(C.message||String(C)||"Unknown Error");return C.stack&&(l.stack=C.stack),l}I.ensureError=t;var M=function(){function C(){}return C.validateConfigurationOptions=function(l){function S(o){if(o.phase==="loading"){console.error('Loading "'+o.moduleId+'" failed'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}if(o.phase==="factory"){console.error('The factory method of "'+o.moduleId+'" has thrown an exception'),console.error(o);return}}if(l=l||{},typeof l.baseUrl!="string"&&(l.baseUrl=""),typeof l.isBuild!="boolean"&&(l.isBuild=!1),typeof l.paths!="object"&&(l.paths={}),typeof l.config!="object"&&(l.config={}),typeof l.catchError=="undefined"&&(l.catchError=!1),typeof l.recordStats=="undefined"&&(l.recordStats=!1),typeof l.urlArgs!="string"&&(l.urlArgs=""),typeof l.onError!="function"&&(l.onError=S),Array.isArray(l.ignoreDuplicateModules)||(l.ignoreDuplicateModules=[]),l.baseUrl.length>0&&(I.Utilities.endsWith(l.baseUrl,"/")||(l.baseUrl+="/")),typeof l.cspNonce!="string"&&(l.cspNonce=""),typeof l.preferScriptTags=="undefined"&&(l.preferScriptTags=!1),Array.isArray(l.nodeModules)||(l.nodeModules=[]),l.nodeCachedData&&typeof l.nodeCachedData=="object"&&(typeof l.nodeCachedData.seed!="string"&&(l.nodeCachedData.seed="seed"),(typeof l.nodeCachedData.writeDelay!="number"||l.nodeCachedData.writeDelay<0)&&(l.nodeCachedData.writeDelay=1e3*7),!l.nodeCachedData.path||typeof l.nodeCachedData.path!="string")){var u=t(new Error("INVALID cached data configuration, 'path' MUST be set"));u.phase="configuration",l.onError(u),l.nodeCachedData=void 0}return l},C.mergeConfigurationOptions=function(l,S){l===void 0&&(l=null),S===void 0&&(S=null);var u=I.Utilities.recursiveClone(S||{});return I.Utilities.forEachProperty(l,function(o,c){o==="ignoreDuplicateModules"&&typeof u.ignoreDuplicateModules!="undefined"?u.ignoreDuplicateModules=u.ignoreDuplicateModules.concat(c):o==="paths"&&typeof u.paths!="undefined"?I.Utilities.forEachProperty(c,function(b,w){return u.paths[b]=w}):o==="config"&&typeof u.config!="undefined"?I.Utilities.forEachProperty(c,function(b,w){return u.config[b]=w}):u[o]=I.Utilities.recursiveClone(c)}),C.validateConfigurationOptions(u)},C}();I.ConfigurationOptionsUtil=M;var U=function(){function C(l,S){if(this._env=l,this.options=M.mergeConfigurationOptions(S),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var u=this.options.nodeRequire.main.filename,o=Math.max(u.lastIndexOf("/"),u.lastIndexOf("\\"));this.options.baseUrl=u.substring(0,o+1)}if(this.options.nodeMain&&this._env.isNode){var u=this.options.nodeMain,o=Math.max(u.lastIndexOf("/"),u.lastIndexOf("\\"));this.options.baseUrl=u.substring(0,o+1)}}}return C.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var l=0;l<this.options.ignoreDuplicateModules.length;l++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[l]]=!0},C.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var l=0,S=this.options.nodeModules;l<S.length;l++){var u=S[l];this.nodeModulesMap[u]=!0}},C.prototype._createSortedPathsRules=function(){var l=this;this.sortedPathsRules=[],I.Utilities.forEachProperty(this.options.paths,function(S,u){Array.isArray(u)?l.sortedPathsRules.push({from:S,to:u}):l.sortedPathsRules.push({from:S,to:[u]})}),this.sortedPathsRules.sort(function(S,u){return u.from.length-S.from.length})},C.prototype.cloneAndMerge=function(l){return new C(this._env,M.mergeConfigurationOptions(l,this.options))},C.prototype.getOptionsLiteral=function(){return this.options},C.prototype._applyPaths=function(l){for(var S,u=0,o=this.sortedPathsRules.length;u<o;u++)if(S=this.sortedPathsRules[u],I.Utilities.startsWith(l,S.from)){for(var c=[],b=0,w=S.to.length;b<w;b++)c.push(S.to[b]+l.substr(S.from.length));return c}return[l]},C.prototype._addUrlArgsToUrl=function(l){return I.Utilities.containsQueryString(l)?l+"&"+this.options.urlArgs:l+"?"+this.options.urlArgs},C.prototype._addUrlArgsIfNecessaryToUrl=function(l){return this.options.urlArgs?this._addUrlArgsToUrl(l):l},C.prototype._addUrlArgsIfNecessaryToUrls=function(l){if(this.options.urlArgs)for(var S=0,u=l.length;S<u;S++)l[S]=this._addUrlArgsToUrl(l[S]);return l},C.prototype.moduleIdToPaths=function(l){var S=this.nodeModulesMap[l]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(l);if(S)return this.isBuild()?["empty:"]:["node|"+l];var u=l,o;if(!I.Utilities.endsWith(u,".js")&&!I.Utilities.isAbsolutePath(u)){o=this._applyPaths(u);for(var c=0,b=o.length;c<b;c++)this.isBuild()&&o[c]==="empty:"||(I.Utilities.isAbsolutePath(o[c])||(o[c]=this.options.baseUrl+o[c]),!I.Utilities.endsWith(o[c],".js")&&!I.Utilities.containsQueryString(o[c])&&(o[c]=o[c]+".js"))}else!I.Utilities.endsWith(u,".js")&&!I.Utilities.containsQueryString(u)&&(u=u+".js"),o=[u];return this._addUrlArgsIfNecessaryToUrls(o)},C.prototype.requireToUrl=function(l){var S=l;return I.Utilities.isAbsolutePath(S)||(S=this._applyPaths(S)[0],I.Utilities.isAbsolutePath(S)||(S=this.options.baseUrl+S)),this._addUrlArgsIfNecessaryToUrl(S)},C.prototype.isBuild=function(){return this.options.isBuild},C.prototype.isDuplicateMessageIgnoredFor=function(l){return this.ignoreDuplicateModulesMap.hasOwnProperty(l)},C.prototype.getConfigForModule=function(l){if(this.options.config)return this.options.config[l]},C.prototype.shouldCatchError=function(){return this.options.catchError},C.prototype.shouldRecordStats=function(){return this.options.recordStats},C.prototype.onError=function(l){this.options.onError(l)},C}();I.Configuration=U})(K||(K={}));var K;(function(I){var t=function(){function u(o){this._env=o,this._scriptLoader=null,this._callbackMap={}}return u.prototype.load=function(o,c,b,w){var g=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new U;else if(this._env.isElectronRenderer){var a=o.getConfig().getOptionsLiteral().preferScriptTags;a?this._scriptLoader=new M:this._scriptLoader=new C(this._env)}else this._env.isNode?this._scriptLoader=new C(this._env):this._scriptLoader=new M;var d={callback:b,errorback:w};if(this._callbackMap.hasOwnProperty(c)){this._callbackMap[c].push(d);return}this._callbackMap[c]=[d],this._scriptLoader.load(o,c,function(){return g.triggerCallback(c)},function(v){return g.triggerErrorback(c,v)})},u.prototype.triggerCallback=function(o){var c=this._callbackMap[o];delete this._callbackMap[o];for(var b=0;b<c.length;b++)c[b].callback()},u.prototype.triggerErrorback=function(o,c){var b=this._callbackMap[o];delete this._callbackMap[o];for(var w=0;w<b.length;w++)b[w].errorback(c)},u}(),M=function(){function u(){}return u.prototype.attachListeners=function(o,c,b){var w=function(){o.removeEventListener("load",g),o.removeEventListener("error",a)},g=function(d){w(),c()},a=function(d){w(),b(d)};o.addEventListener("load",g),o.addEventListener("error",a)},u.prototype.load=function(o,c,b,w){if(/^node\|/.test(c)){var g=o.getConfig().getOptionsLiteral(),a=l(o.getRecorder(),g.nodeRequire||I.global.nodeRequire),d=c.split("|"),v=null;try{v=a(d[1])}catch(i){w(i);return}o.enqueueDefineAnonymousModule([],function(){return v}),b()}else{var E=document.createElement("script");E.setAttribute("async","async"),E.setAttribute("type","text/javascript"),this.attachListeners(E,b,w);var A=o.getConfig().getOptionsLiteral().trustedTypesPolicy;A&&(c=A.createScriptURL(c)),E.setAttribute("src",c);var n=o.getConfig().getOptionsLiteral().cspNonce;n&&E.setAttribute("nonce",n),document.getElementsByTagName("head")[0].appendChild(E)}},u}(),U=function(){function u(){}return u.prototype.load=function(o,c,b,w){var g=o.getConfig().getOptionsLiteral().trustedTypesPolicy,a=/^((http:)|(https:)|(file:))/.test(c)&&c.substring(0,self.origin.length)!==self.origin;if(!a){fetch(c).then(function(d){if(d.status!==200)throw new Error(d.statusText);return d.text()}).then(function(d){d=d+`
//# sourceURL=`+c;var v=g?self.eval(g.createScript("",d)):new Function(d);v.call(self),b()}).then(void 0,w);return}try{g&&(c=g.createScriptURL(c)),importScripts(c),b()}catch(d){w(d)}},u}(),C=function(){function u(o){this._env=o,this._didInitialize=!1,this._didPatchNodeRequire=!1}return u.prototype._init=function(o){this._didInitialize||(this._didInitialize=!0,this._fs=o("fs"),this._vm=o("vm"),this._path=o("path"),this._crypto=o("crypto"))},u.prototype._initNodeRequire=function(o,c){var b=c.getConfig().getOptionsLiteral().nodeCachedData;if(!b||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var w=this,g=o("module");function a(d){var v=d.constructor,E=function(n){try{return d.require(n)}finally{}};return E.resolve=function(n,i){return v._resolveFilename(n,d,!1,i)},E.resolve.paths=function(n){return v._resolveLookupPaths(n,d)},E.main=process.mainModule,E.extensions=v._extensions,E.cache=v._cache,E}g.prototype._compile=function(d,v){var E=g.wrap(d.replace(/^#!.*/,"")),A=c.getRecorder(),n=w._getCachedDataPath(b,v),i={filename:v},r;try{var s=w._fs.readFileSync(n);r=s.slice(0,16),i.cachedData=s.slice(16),A.record(60,n)}catch(P){A.record(61,n)}var f=new w._vm.Script(E,i),m=f.runInThisContext(i),h=w._path.dirname(v),_=a(this),N=[this.exports,_,this,v,h,process,Le,Buffer],p=m.apply(this.exports,N);return w._handleCachedData(f,E,n,!i.cachedData,c),w._verifyCachedData(f,E,n,r,c),p}},u.prototype.load=function(o,c,b,w){var g=this,a=o.getConfig().getOptionsLiteral(),d=l(o.getRecorder(),a.nodeRequire||I.global.nodeRequire),v=a.nodeInstrumenter||function(m){return m};this._init(d),this._initNodeRequire(d,o);var E=o.getRecorder();if(/^node\|/.test(c)){var A=c.split("|"),n=null;try{n=d(A[1])}catch(m){w(m);return}o.enqueueDefineAnonymousModule([],function(){return n}),b()}else{c=I.Utilities.fileUriToFilePath(this._env.isWindows,c);var i=this._path.normalize(c),r=this._getElectronRendererScriptPathOrUri(i),s=Boolean(a.nodeCachedData),f=s?this._getCachedDataPath(a.nodeCachedData,c):void 0;this._readSourceAndCachedData(i,f,E,function(m,h,_,N){if(m){w(m);return}var p;h.charCodeAt(0)===u._BOM?p=u._PREFIX+h.substring(1)+u._SUFFIX:p=u._PREFIX+h+u._SUFFIX,p=v(p,i);var P={filename:r,cachedData:_},F=g._createAndEvalScript(o,p,P,b,w);g._handleCachedData(F,p,f,s&&!_,o),g._verifyCachedData(F,p,f,N,o)})}},u.prototype._createAndEvalScript=function(o,c,b,w,g){var a=o.getRecorder();a.record(31,b.filename);var d=new this._vm.Script(c,b),v=d.runInThisContext(b),E=o.getGlobalAMDDefineFunc(),A=!1,n=function(){return A=!0,E.apply(null,arguments)};return n.amd=E.amd,v.call(I.global,o.getGlobalAMDRequireFunc(),n,b.filename,this._path.dirname(b.filename)),a.record(32,b.filename),A?w():g(new Error("Didn't receive define call in "+b.filename+"!")),d},u.prototype._getElectronRendererScriptPathOrUri=function(o){if(!this._env.isElectronRenderer)return o;var c=o.match(/^([a-z])\:(.*)/i);return c?"file:///"+(c[1].toUpperCase()+":"+c[2]).replace(/\\/g,"/"):"file://"+o},u.prototype._getCachedDataPath=function(o,c){var b=this._crypto.createHash("md5").update(c,"utf8").update(o.seed,"utf8").update(process.arch,"").digest("hex"),w=this._path.basename(c).replace(/\.js$/,"");return this._path.join(o.path,w+"-"+b+".code")},u.prototype._handleCachedData=function(o,c,b,w,g){var a=this;o.cachedDataRejected?this._fs.unlink(b,function(d){g.getRecorder().record(62,b),a._createAndWriteCachedData(o,c,b,g),d&&g.getConfig().onError(d)}):w&&this._createAndWriteCachedData(o,c,b,g)},u.prototype._createAndWriteCachedData=function(o,c,b,w){var g=this,a=Math.ceil(w.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),d=-1,v=0,E=void 0,A=function(){setTimeout(function(){E||(E=g._crypto.createHash("md5").update(c,"utf8").digest());var n=o.createCachedData();if(!(n.length===0||n.length===d||v>=5)){if(n.length<d){A();return}d=n.length,g._fs.writeFile(b,Buffer.concat([E,n]),function(i){i&&w.getConfig().onError(i),w.getRecorder().record(63,b),A()})}},a*Math.pow(4,v++))};A()},u.prototype._readSourceAndCachedData=function(o,c,b,w){if(!c)this._fs.readFile(o,{encoding:"utf8"},w);else{var g=void 0,a=void 0,d=void 0,v=2,E=function(A){A?w(A):--v==0&&w(void 0,g,a,d)};this._fs.readFile(o,{encoding:"utf8"},function(A,n){g=n,E(A)}),this._fs.readFile(c,function(A,n){!A&&n&&n.length>0?(d=n.slice(0,16),a=n.slice(16),b.record(60,c)):b.record(61,c),E()})}},u.prototype._verifyCachedData=function(o,c,b,w,g){var a=this;!w||o.cachedDataRejected||setTimeout(function(){var d=a._crypto.createHash("md5").update(c,"utf8").digest();w.equals(d)||(g.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+b+"' now, but a RESTART IS REQUIRED")),a._fs.unlink(b,function(v){v&&g.getConfig().onError(v)}))},Math.ceil(5e3*(1+Math.random())))},u._BOM=65279,u._PREFIX="(function (require, define, __filename, __dirname) { ",u._SUFFIX=`
});`,u}();function l(u,o){if(o.__$__isRecorded)return o;var c=function(w){u.record(33,w);try{return o(w)}finally{u.record(34,w)}};return c.__$__isRecorded=!0,c}I.ensureRecordedNodeRequire=l;function S(u){return new t(u)}I.createScriptLoader=S})(K||(K={}));var K;(function(I){var t=function(){function u(o){var c=o.lastIndexOf("/");c!==-1?this.fromModulePath=o.substr(0,c+1):this.fromModulePath=""}return u._normalizeModuleId=function(o){var c=o,b;for(b=/\/\.\//;b.test(c);)c=c.replace(b,"/");for(c=c.replace(/^\.\//g,""),b=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;b.test(c);)c=c.replace(b,"/");return c=c.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),c},u.prototype.resolveModule=function(o){var c=o;return I.Utilities.isAbsolutePath(c)||(I.Utilities.startsWith(c,"./")||I.Utilities.startsWith(c,"../"))&&(c=u._normalizeModuleId(this.fromModulePath+c)),c},u.ROOT=new u(""),u}();I.ModuleIdResolver=t;var M=function(){function u(o,c,b,w,g,a){this.id=o,this.strId=c,this.dependencies=b,this._callback=w,this._errorback=g,this.moduleIdResolver=a,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return u._safeInvokeFunction=function(o,c){try{return{returnedValue:o.apply(I.global,c),producedError:null}}catch(b){return{returnedValue:null,producedError:b}}},u._invokeFactory=function(o,c,b,w){return o.isBuild()&&!I.Utilities.isAnonymousModule(c)?{returnedValue:null,producedError:null}:o.shouldCatchError()?this._safeInvokeFunction(b,w):{returnedValue:b.apply(I.global,w),producedError:null}},u.prototype.complete=function(o,c,b){this._isComplete=!0;var w=null;if(this._callback)if(typeof this._callback=="function"){o.record(21,this.strId);var g=u._invokeFactory(c,this.strId,this._callback,b);w=g.producedError,o.record(22,this.strId),!w&&typeof g.returnedValue!="undefined"&&(!this.exportsPassedIn||I.Utilities.isEmpty(this.exports))&&(this.exports=g.returnedValue)}else this.exports=this._callback;if(w){var a=I.ensureError(w);a.phase="factory",a.moduleId=this.strId,this.error=a,c.onError(a)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},u.prototype.onDependencyError=function(o){return this._isComplete=!0,this.error=o,this._errorback?(this._errorback(o),!0):!1},u.prototype.isComplete=function(){return this._isComplete},u}();I.Module=M;var U=function(){function u(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return u.prototype.getMaxModuleId=function(){return this._nextId},u.prototype.getModuleId=function(o){var c=this._strModuleIdToIntModuleId.get(o);return typeof c=="undefined"&&(c=this._nextId++,this._strModuleIdToIntModuleId.set(o,c),this._intModuleIdToStrModuleId[c]=o),c},u.prototype.getStrModuleId=function(o){return this._intModuleIdToStrModuleId[o]},u}(),C=function(){function u(o){this.id=o}return u.EXPORTS=new u(0),u.MODULE=new u(1),u.REQUIRE=new u(2),u}();I.RegularDependency=C;var l=function(){function u(o,c,b){this.id=o,this.pluginId=c,this.pluginParam=b}return u}();I.PluginDependency=l;var S=function(){function u(o,c,b,w,g){g===void 0&&(g=0),this._env=o,this._scriptLoader=c,this._loaderAvailableTimestamp=g,this._defineFunc=b,this._requireFunc=w,this._moduleIdProvider=new U,this._config=new I.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return u.prototype.reset=function(){return new u(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},u.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},u.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},u._findRelevantLocationInStack=function(o,c){for(var b=function(r){return r.replace(/\\/g,"/")},w=b(o),g=c.split(/\n/),a=0;a<g.length;a++){var d=g[a].match(/(.*):(\d+):(\d+)\)?$/);if(d){var v=d[1],E=d[2],A=d[3],n=Math.max(v.lastIndexOf(" ")+1,v.lastIndexOf("(")+1);if(v=v.substr(n),v=b(v),v===w){var i={line:parseInt(E,10),col:parseInt(A,10)};return i.line===1&&(i.col-="(function (require, define, __filename, __dirname) { ".length),i}}}throw new Error("Could not correlate define call site for needle "+o)},u.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var o=[],c=0,b=0,w=this._modules2.length;b<w;b++){var g=this._modules2[b];if(!!g){var a=this._buildInfoPath[g.id]||null,d=this._buildInfoDefineStack[g.id]||null,v=this._buildInfoDependencies[g.id];o[c++]={id:g.strId,path:a,defineLocation:a&&d?u._findRelevantLocationInStack(a,d):null,dependencies:v,shim:null,exports:g.exports}}}return o},u.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new I.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=I.NullLoaderEventRecorder.INSTANCE),this._recorder},u.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},u.prototype.enqueueDefineAnonymousModule=function(o,c){if(this._currentAnnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var b=null;this._config.isBuild()&&(b=new Error("StackLocation").stack||null),this._currentAnnonymousDefineCall={stack:b,dependencies:o,callback:c}},u.prototype.defineModule=function(o,c,b,w,g,a){var d=this;a===void 0&&(a=new t(o));var v=this._moduleIdProvider.getModuleId(o);if(this._modules2[v]){this._config.isDuplicateMessageIgnoredFor(o)||console.warn("Duplicate definition of module '"+o+"'");return}var E=new M(v,o,this._normalizeDependencies(c,a),b,w,a);this._modules2[v]=E,this._config.isBuild()&&(this._buildInfoDefineStack[v]=g,this._buildInfoDependencies[v]=(E.dependencies||[]).map(function(A){return d._moduleIdProvider.getStrModuleId(A.id)})),this._resolve(E)},u.prototype._normalizeDependency=function(o,c){if(o==="exports")return C.EXPORTS;if(o==="module")return C.MODULE;if(o==="require")return C.REQUIRE;var b=o.indexOf("!");if(b>=0){var w=c.resolveModule(o.substr(0,b)),g=c.resolveModule(o.substr(b+1)),a=this._moduleIdProvider.getModuleId(w+"!"+g),d=this._moduleIdProvider.getModuleId(w);return new l(a,d,g)}return new C(this._moduleIdProvider.getModuleId(c.resolveModule(o)))},u.prototype._normalizeDependencies=function(o,c){for(var b=[],w=0,g=0,a=o.length;g<a;g++)b[w++]=this._normalizeDependency(o[g],c);return b},u.prototype._relativeRequire=function(o,c,b,w){if(typeof c=="string")return this.synchronousRequire(c,o);this.defineModule(I.Utilities.generateAnonymousModule(),c,b,w,null,o)},u.prototype.synchronousRequire=function(o,c){c===void 0&&(c=new t(o));var b=this._normalizeDependency(o,c),w=this._modules2[b.id];if(!w)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This is the first mention of this module!");if(!w.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This module has not been resolved completely yet.");if(w.error)throw w.error;return w.exports},u.prototype.configure=function(o,c){var b=this._config.shouldRecordStats();c?this._config=new I.Configuration(this._env,o):this._config=this._config.cloneAndMerge(o),this._config.shouldRecordStats()&&!b&&(this._recorder=null)},u.prototype.getConfig=function(){return this._config},u.prototype._onLoad=function(o){if(this._currentAnnonymousDefineCall!==null){var c=this._currentAnnonymousDefineCall;this._currentAnnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(o),c.dependencies,c.callback,null,c.stack)}},u.prototype._createLoadError=function(o,c){var b=this,w=this._moduleIdProvider.getStrModuleId(o),g=(this._inverseDependencies2[o]||[]).map(function(d){return b._moduleIdProvider.getStrModuleId(d)}),a=I.ensureError(c);return a.phase="loading",a.moduleId=w,a.neededBy=g,a},u.prototype._onLoadError=function(o,c){var b=this._createLoadError(o,c);this._modules2[o]||(this._modules2[o]=new M(o,this._moduleIdProvider.getStrModuleId(o),[],function(){},function(){},null));for(var w=[],g=0,a=this._moduleIdProvider.getMaxModuleId();g<a;g++)w[g]=!1;var d=!1,v=[];for(v.push(o),w[o]=!0;v.length>0;){var E=v.shift(),A=this._modules2[E];A&&(d=A.onDependencyError(b)||d);var n=this._inverseDependencies2[E];if(n)for(var g=0,a=n.length;g<a;g++){var i=n[g];w[i]||(v.push(i),w[i]=!0)}}d||this._config.onError(b)},u.prototype._hasDependencyPath=function(o,c){var b=this._modules2[o];if(!b)return!1;for(var w=[],g=0,a=this._moduleIdProvider.getMaxModuleId();g<a;g++)w[g]=!1;var d=[];for(d.push(b),w[o]=!0;d.length>0;){var v=d.shift(),E=v.dependencies;if(E)for(var g=0,a=E.length;g<a;g++){var A=E[g];if(A.id===c)return!0;var n=this._modules2[A.id];n&&!w[A.id]&&(w[A.id]=!0,d.push(n))}}return!1},u.prototype._findCyclePath=function(o,c,b){if(o===c||b===50)return[o];var w=this._modules2[o];if(!w)return null;var g=w.dependencies;if(g)for(var a=0,d=g.length;a<d;a++){var v=this._findCyclePath(g[a].id,c,b+1);if(v!==null)return v.push(o),v}return null},u.prototype._createRequire=function(o){var c=this,b=function(w,g,a){return c._relativeRequire(o,w,g,a)};return b.toUrl=function(w){return c._config.requireToUrl(o.resolveModule(w))},b.getStats=function(){return c.getLoaderEvents()},b.hasDependencyCycle=function(){return c._hasDependencyCycle},b.config=function(w,g){g===void 0&&(g=!1),c.configure(w,g)},b.__$__nodeRequire=I.global.nodeRequire,b},u.prototype._loadModule=function(o){var c=this;if(!(this._modules2[o]||this._knownModules2[o])){this._knownModules2[o]=!0;var b=this._moduleIdProvider.getStrModuleId(o),w=this._config.moduleIdToPaths(b),g=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(b.indexOf("/")===-1||g.test(b))&&w.push("node|"+b);var a=-1,d=function(v){if(a++,a>=w.length)c._onLoadError(o,v);else{var E=w[a],A=c.getRecorder();if(c._config.isBuild()&&E==="empty:"){c._buildInfoPath[o]=E,c.defineModule(c._moduleIdProvider.getStrModuleId(o),[],null,null,null),c._onLoad(o);return}A.record(10,E),c._scriptLoader.load(c,E,function(){c._config.isBuild()&&(c._buildInfoPath[o]=E),A.record(11,E),c._onLoad(o)},function(n){A.record(12,E),d(n)})}};d(null)}},u.prototype._loadPluginDependency=function(o,c){var b=this;if(!(this._modules2[c.id]||this._knownModules2[c.id])){this._knownModules2[c.id]=!0;var w=function(g){b.defineModule(b._moduleIdProvider.getStrModuleId(c.id),[],g,null,null)};w.error=function(g){b._config.onError(b._createLoadError(c.id,g))},o.load(c.pluginParam,this._createRequire(t.ROOT),w,this._config.getOptionsLiteral())}},u.prototype._resolve=function(o){var c=this,b=o.dependencies;if(b)for(var w=0,g=b.length;w<g;w++){var a=b[w];if(a===C.EXPORTS){o.exportsPassedIn=!0,o.unresolvedDependenciesCount--;continue}if(a===C.MODULE){o.unresolvedDependenciesCount--;continue}if(a===C.REQUIRE){o.unresolvedDependenciesCount--;continue}var d=this._modules2[a.id];if(d&&d.isComplete()){if(d.error){o.onDependencyError(d.error);return}o.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(a.id,o.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(a.id)+"' and '"+this._moduleIdProvider.getStrModuleId(o.id)+"'. The cyclic path follows:");var v=this._findCyclePath(a.id,o.id,0)||[];v.reverse(),v.push(a.id),console.warn(v.map(function(n){return c._moduleIdProvider.getStrModuleId(n)}).join(` => 
`)),o.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[a.id]=this._inverseDependencies2[a.id]||[],this._inverseDependencies2[a.id].push(o.id),a instanceof l){var E=this._modules2[a.pluginId];if(E&&E.isComplete()){this._loadPluginDependency(E.exports,a);continue}var A=this._inversePluginDependencies2.get(a.pluginId);A||(A=[],this._inversePluginDependencies2.set(a.pluginId,A)),A.push(a),this._loadModule(a.pluginId);continue}this._loadModule(a.id)}o.unresolvedDependenciesCount===0&&this._onModuleComplete(o)},u.prototype._onModuleComplete=function(o){var c=this,b=this.getRecorder();if(!o.isComplete()){var w=o.dependencies,g=[];if(w)for(var a=0,d=w.length;a<d;a++){var v=w[a];if(v===C.EXPORTS){g[a]=o.exports;continue}if(v===C.MODULE){g[a]={id:o.strId,config:function(){return c._config.getConfigForModule(o.strId)}};continue}if(v===C.REQUIRE){g[a]=this._createRequire(o.moduleIdResolver);continue}var E=this._modules2[v.id];if(E){g[a]=E.exports;continue}g[a]=null}o.complete(b,this._config,g);var A=this._inverseDependencies2[o.id];if(this._inverseDependencies2[o.id]=null,A)for(var a=0,d=A.length;a<d;a++){var n=A[a],i=this._modules2[n];i.unresolvedDependenciesCount--,i.unresolvedDependenciesCount===0&&this._onModuleComplete(i)}var r=this._inversePluginDependencies2.get(o.id);if(r){this._inversePluginDependencies2.delete(o.id);for(var a=0,d=r.length;a<d;a++)this._loadPluginDependency(o.exports,r[a])}}},u}();I.ModuleManager=S})(K||(K={}));var G,K;(function(I){var t=new I.Environment,M=null,U=function(u,o,c){typeof u!="string"&&(c=o,o=u,u=null),(typeof o!="object"||!Array.isArray(o))&&(c=o,o=null),o||(o=["require","exports","module"]),u?M.defineModule(u,o,c,null,null):M.enqueueDefineAnonymousModule(o,c)};U.amd={jQuery:!0};var C=function(u,o){o===void 0&&(o=!1),M.configure(u,o)},l=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){C(arguments[0]);return}if(typeof arguments[0]=="string")return M.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){M.defineModule(I.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};l.config=C,l.getConfig=function(){return M.getConfig().getOptionsLiteral()},l.reset=function(){M=M.reset()},l.getBuildInfo=function(){return M.getBuildInfo()},l.getStats=function(){return M.getLoaderEvents()},l.define=function(){return U.apply(null,arguments)};function S(){if(typeof I.global.require!="undefined"||typeof require!="undefined"){var u=I.global.require||require;if(typeof u=="function"&&typeof u.resolve=="function"){var o=I.ensureRecordedNodeRequire(M.getRecorder(),u);I.global.nodeRequire=o,l.nodeRequire=o,l.__$__nodeRequire=o}}t.isNode&&!t.isElectronRenderer?(module.exports=l,require=l):(t.isElectronRenderer||(I.global.define=U),I.global.require=l)}I.init=S,(typeof I.global.define!="function"||!I.global.define.amd)&&(M=new I.ModuleManager(t,I.createScriptLoader(t),U,l,I.Utilities.getHighPerformanceTimestamp()),typeof I.global.require!="undefined"&&typeof I.global.require!="function"&&l.config(I.global.require),G=function(){return U.apply(null,arguments)},G.amd=U.amd,typeof doNotInitLoader=="undefined"&&S())})(K||(K={}));var be=this,he;(function(I){var t=be||{},M=t.Plugin&&t.Plugin.Resources?t.Plugin.Resources:void 0,U=t&&t.document&&t.document.location&&t.document.location.hash.indexOf("pseudo=true")>=0;function C(c,b){var w;return b.length===0?w=c:w=c.replace(/\{(\d+)\}/g,function(g,a){var d=a[0];return typeof b[d]!="undefined"?b[d]:g}),U&&(w="\uFF3B"+w.replace(/[aouei]/g,"$&$&")+"\uFF3D"),w}function l(c,b){var w=c[b];return w||(w=c["*"],w)?w:null}function S(c,b){for(var w=[],g=0;g<arguments.length-2;g++)w[g]=arguments[g+2];return C(b,w)}function u(c){return function(b,w){var g=Array.prototype.slice.call(arguments,2);return C(c[b],g)}}var o=function(){function c(){this.localize=S}return c.prototype.setPseudoTranslation=function(b){U=b},c.prototype.create=function(b,w){return{localize:u(w[b])}},c.prototype.load=function(b,w,g,a){if(a=a||{},!b||b.length===0)g({localize:S});else{var d=void 0;if(M&&M.getString)d=".nls.keys",w([b+d],function(A){g({localize:function(n,i){if(!A[n])return"NLS error: unknown key "+n;var r=A[n].keys;if(i>=r.length)return"NLS error unknow index "+i;var s=r[i],f=[];f[0]=n+"_"+s;for(var m=0;m<arguments.length-2;m++)f[m+1]=arguments[m+2];return M.getString.apply(M,f)}})});else if(a.isBuild)w([b+".nls",b+".nls.keys"],function(A,n){c.BUILD_MAP[b]=A,c.BUILD_MAP_KEYS[b]=n,g(A)});else{var v=a["vs/nls"]||{},E=v.availableLanguages?l(v.availableLanguages,b):null;d=".nls",E!==null&&E!==c.DEFAULT_TAG&&(d=d+"."+E),w([b+d],function(A){Array.isArray(A)?A.localize=u(A):A.localize=u(A[b]),g(A)})}}},c.prototype._getEntryPointsMap=function(){return t.nlsPluginEntryPoints=t.nlsPluginEntryPoints||{},t.nlsPluginEntryPoints},c.prototype.write=function(b,w,g){var a=g.getEntryPoint(),d=this._getEntryPointsMap();d[a]=d[a]||[],d[a].push(w),w!==a&&g.asModule(b+"!"+w,"define(['vs/nls', 'vs/nls!"+a+`'], function(nls, data) { return nls.create("`+w+'", data); });')},c.prototype.writeFile=function(b,w,g,a,d){var v=this._getEntryPointsMap();if(v.hasOwnProperty(w)){for(var E=g.toUrl(w+".nls.js"),A=["/*---------------------------------------------------------"," * Copyright (c) Microsoft Corporation. All rights reserved."," *--------------------------------------------------------*/"],n=v[w],i={},r=0;r<n.length;r++)i[n[r]]=c.BUILD_MAP[n[r]];A.push('define("'+w+'.nls", '+JSON.stringify(i,null,"	")+");"),a(E,A.join(`\r
`))}},c.prototype.finishBuild=function(b){b("nls.metadata.json",JSON.stringify({keys:c.BUILD_MAP_KEYS,messages:c.BUILD_MAP,bundles:this._getEntryPointsMap()},null,"	"))},c.DEFAULT_TAG="i-default",c.BUILD_MAP={},c.BUILD_MAP_KEYS={},c}();I.NLSPlugin=o,function(){G("vs/nls",new o)}()})(he||(he={})),G(Q[15],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class M{constructor(C,l,S,u){this.originalStart=C,this.originalLength=l,this.modifiedStart=S,this.modifiedLength=u}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=M}),G(Q[4],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createErrorWithActions=t.isErrorWithActions=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isPromiseCanceledError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class M{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(f){setTimeout(()=>{throw f.stack?new Error(f.message+`

`+f.stack):f},0)}}addListener(f){return this.listeners.push(f),()=>{this._removeListener(f)}}emit(f){this.listeners.forEach(m=>{m(f)})}_removeListener(f){this.listeners.splice(this.listeners.indexOf(f),1)}setUnexpectedErrorHandler(f){this.unexpectedErrorHandler=f}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(f){this.unexpectedErrorHandler(f),this.emit(f)}onUnexpectedExternalError(f){this.unexpectedErrorHandler(f)}}t.ErrorHandler=M,t.errorHandler=new M;function U(s){t.errorHandler.setUnexpectedErrorHandler(s)}t.setUnexpectedErrorHandler=U;function C(s){o(s)||t.errorHandler.onUnexpectedError(s)}t.onUnexpectedError=C;function l(s){o(s)||t.errorHandler.onUnexpectedExternalError(s)}t.onUnexpectedExternalError=l;function S(s){if(s instanceof Error){let{name:f,message:m}=s;const h=s.stacktrace||s.stack;return{$isError:!0,name:f,message:m,stack:h}}return s}t.transformErrorForSerialization=S;const u="Canceled";function o(s){return s instanceof Error&&s.name===u&&s.message===u}t.isPromiseCanceledError=o;class c extends Error{constructor(){super(u);this.name=this.message}}t.CancellationError=c;function b(){const s=new Error(u);return s.name=s.message,s}t.canceled=b;function w(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}t.illegalArgument=w;function g(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}t.illegalState=g;function a(s){return s?new Error(`readonly property '${s} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=a;function d(s){const f=new Error(`${s} has been disposed`);return f.name="DISPOSED",f}t.disposed=d;function v(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}t.getErrorMessage=v;class E extends Error{constructor(f){super("NotImplemented");f&&(this.message=f)}}t.NotImplementedError=E;class A extends Error{constructor(f){super("NotSupported");f&&(this.message=f)}}t.NotSupportedError=A;class n extends Error{constructor(){super(...arguments);this.isExpected=!0}}t.ExpectedError=n;function i(s){const f=s;return f instanceof Error&&Array.isArray(f.actions)}t.isErrorWithActions=i;function r(s,f=Object.create(null)){const m=new Error(s);return f.actions&&(m.actions=f.actions),m}t.createErrorWithActions=r}),G(Q[7],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function M(U){const C=this;let l=!1,S;return function(){return l||(l=!0,S=U.apply(C,arguments)),S}}t.once=M}),G(Q[16],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var M;(function(U){function C(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}U.is=C;const l=Object.freeze([]);function S(){return l}U.empty=S;function*u(s){yield s}U.single=u;function o(s){return s||l}U.from=o;function c(s){return!s||s[Symbol.iterator]().next().done===!0}U.isEmpty=c;function b(s){return s[Symbol.iterator]().next().value}U.first=b;function w(s,f){for(const m of s)if(f(m))return!0;return!1}U.some=w;function g(s,f){for(const m of s)if(f(m))return m}U.find=g;function*a(s,f){for(const m of s)f(m)&&(yield m)}U.filter=a;function*d(s,f){let m=0;for(const h of s)yield f(h,m++)}U.map=d;function*v(...s){for(const f of s)for(const m of f)yield m}U.concat=v;function*E(s){for(const f of s)for(const m of f)yield m}U.concatNested=E;function A(s,f,m){let h=m;for(const _ of s)h=f(h,_);return h}U.reduce=A;function*n(s,f,m=s.length){for(f<0&&(f+=s.length),m<0?m+=s.length:m>s.length&&(m=s.length);f<m;f++)yield s[f]}U.slice=n;function i(s,f=Number.POSITIVE_INFINITY){const m=[];if(f===0)return[m,s];const h=s[Symbol.iterator]();for(let _=0;_<f;_++){const N=h.next();if(N.done)return[m,U.empty()];m.push(N.value)}return[m,{[Symbol.iterator](){return h}}]}U.consume=i;function r(s,f,m=(h,_)=>h===_){const h=s[Symbol.iterator](),_=f[Symbol.iterator]();for(;;){const N=h.next(),p=_.next();if(N.done!==p.done)return!1;if(N.done)return!0;if(!m(N.value,p.value))return!1}}U.equals=r})(M=t.Iterable||(t.Iterable={}))}),G(Q[17],X([0,1,4]),function(I,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.KeyCode=void 0;var U;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.KEY_0=21]="KEY_0",n[n.KEY_1=22]="KEY_1",n[n.KEY_2=23]="KEY_2",n[n.KEY_3=24]="KEY_3",n[n.KEY_4=25]="KEY_4",n[n.KEY_5=26]="KEY_5",n[n.KEY_6=27]="KEY_6",n[n.KEY_7=28]="KEY_7",n[n.KEY_8=29]="KEY_8",n[n.KEY_9=30]="KEY_9",n[n.KEY_A=31]="KEY_A",n[n.KEY_B=32]="KEY_B",n[n.KEY_C=33]="KEY_C",n[n.KEY_D=34]="KEY_D",n[n.KEY_E=35]="KEY_E",n[n.KEY_F=36]="KEY_F",n[n.KEY_G=37]="KEY_G",n[n.KEY_H=38]="KEY_H",n[n.KEY_I=39]="KEY_I",n[n.KEY_J=40]="KEY_J",n[n.KEY_K=41]="KEY_K",n[n.KEY_L=42]="KEY_L",n[n.KEY_M=43]="KEY_M",n[n.KEY_N=44]="KEY_N",n[n.KEY_O=45]="KEY_O",n[n.KEY_P=46]="KEY_P",n[n.KEY_Q=47]="KEY_Q",n[n.KEY_R=48]="KEY_R",n[n.KEY_S=49]="KEY_S",n[n.KEY_T=50]="KEY_T",n[n.KEY_U=51]="KEY_U",n[n.KEY_V=52]="KEY_V",n[n.KEY_W=53]="KEY_W",n[n.KEY_X=54]="KEY_X",n[n.KEY_Y=55]="KEY_Y",n[n.KEY_Z=56]="KEY_Z",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.NumLock=78]="NumLock",n[n.ScrollLock=79]="ScrollLock",n[n.US_SEMICOLON=80]="US_SEMICOLON",n[n.US_EQUAL=81]="US_EQUAL",n[n.US_COMMA=82]="US_COMMA",n[n.US_MINUS=83]="US_MINUS",n[n.US_DOT=84]="US_DOT",n[n.US_SLASH=85]="US_SLASH",n[n.US_BACKTICK=86]="US_BACKTICK",n[n.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",n[n.US_BACKSLASH=88]="US_BACKSLASH",n[n.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",n[n.US_QUOTE=90]="US_QUOTE",n[n.OEM_8=91]="OEM_8",n[n.OEM_102=92]="OEM_102",n[n.NUMPAD_0=93]="NUMPAD_0",n[n.NUMPAD_1=94]="NUMPAD_1",n[n.NUMPAD_2=95]="NUMPAD_2",n[n.NUMPAD_3=96]="NUMPAD_3",n[n.NUMPAD_4=97]="NUMPAD_4",n[n.NUMPAD_5=98]="NUMPAD_5",n[n.NUMPAD_6=99]="NUMPAD_6",n[n.NUMPAD_7=100]="NUMPAD_7",n[n.NUMPAD_8=101]="NUMPAD_8",n[n.NUMPAD_9=102]="NUMPAD_9",n[n.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",n[n.NUMPAD_ADD=104]="NUMPAD_ADD",n[n.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",n[n.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",n[n.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",n[n.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",n[n.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",n[n.ABNT_C1=110]="ABNT_C1",n[n.ABNT_C2=111]="ABNT_C2",n[n.MAX_VALUE=112]="MAX_VALUE"})(U=t.KeyCode||(t.KeyCode={}));class C{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(i,r){this._keyCodeToStr[i]=r,this._strToKeyCode[r.toLowerCase()]=i}keyCodeToStr(i){return this._keyCodeToStr[i]}strToKeyCode(i){return this._strToKeyCode[i.toLowerCase()]||0}}const l=new C,S=new C,u=new C;(function(){function n(i,r,s=r,f=s){l.define(i,r),S.define(i,s),u.define(i,f)}n(0,"unknown"),n(1,"Backspace"),n(2,"Tab"),n(3,"Enter"),n(4,"Shift"),n(5,"Ctrl"),n(6,"Alt"),n(7,"PauseBreak"),n(8,"CapsLock"),n(9,"Escape"),n(10,"Space"),n(11,"PageUp"),n(12,"PageDown"),n(13,"End"),n(14,"Home"),n(15,"LeftArrow","Left"),n(16,"UpArrow","Up"),n(17,"RightArrow","Right"),n(18,"DownArrow","Down"),n(19,"Insert"),n(20,"Delete"),n(21,"0"),n(22,"1"),n(23,"2"),n(24,"3"),n(25,"4"),n(26,"5"),n(27,"6"),n(28,"7"),n(29,"8"),n(30,"9"),n(31,"A"),n(32,"B"),n(33,"C"),n(34,"D"),n(35,"E"),n(36,"F"),n(37,"G"),n(38,"H"),n(39,"I"),n(40,"J"),n(41,"K"),n(42,"L"),n(43,"M"),n(44,"N"),n(45,"O"),n(46,"P"),n(47,"Q"),n(48,"R"),n(49,"S"),n(50,"T"),n(51,"U"),n(52,"V"),n(53,"W"),n(54,"X"),n(55,"Y"),n(56,"Z"),n(57,"Meta"),n(58,"ContextMenu"),n(59,"F1"),n(60,"F2"),n(61,"F3"),n(62,"F4"),n(63,"F5"),n(64,"F6"),n(65,"F7"),n(66,"F8"),n(67,"F9"),n(68,"F10"),n(69,"F11"),n(70,"F12"),n(71,"F13"),n(72,"F14"),n(73,"F15"),n(74,"F16"),n(75,"F17"),n(76,"F18"),n(77,"F19"),n(78,"NumLock"),n(79,"ScrollLock"),n(80,";",";","OEM_1"),n(81,"=","=","OEM_PLUS"),n(82,",",",","OEM_COMMA"),n(83,"-","-","OEM_MINUS"),n(84,".",".","OEM_PERIOD"),n(85,"/","/","OEM_2"),n(86,"`","`","OEM_3"),n(110,"ABNT_C1"),n(111,"ABNT_C2"),n(87,"[","[","OEM_4"),n(88,"\\","\\","OEM_5"),n(89,"]","]","OEM_6"),n(90,"'","'","OEM_7"),n(91,"OEM_8"),n(92,"OEM_102"),n(93,"NumPad0"),n(94,"NumPad1"),n(95,"NumPad2"),n(96,"NumPad3"),n(97,"NumPad4"),n(98,"NumPad5"),n(99,"NumPad6"),n(100,"NumPad7"),n(101,"NumPad8"),n(102,"NumPad9"),n(103,"NumPad_Multiply"),n(104,"NumPad_Add"),n(105,"NumPad_Separator"),n(106,"NumPad_Subtract"),n(107,"NumPad_Decimal"),n(108,"NumPad_Divide")})();var o;(function(n){function i(h){return l.keyCodeToStr(h)}n.toString=i;function r(h){return l.strToKeyCode(h)}n.fromString=r;function s(h){return S.keyCodeToStr(h)}n.toUserSettingsUS=s;function f(h){return u.keyCodeToStr(h)}n.toUserSettingsGeneral=f;function m(h){return S.strToKeyCode(h)||u.strToKeyCode(h)}n.fromUserSettings=m})(o=t.KeyCodeUtils||(t.KeyCodeUtils={}));var c;(function(n){n[n.CtrlCmd=2048]="CtrlCmd",n[n.Shift=1024]="Shift",n[n.Alt=512]="Alt",n[n.WinCtrl=256]="WinCtrl",n[n.KeyCode=255]="KeyCode"})(c||(c={}));var b;(function(n){n[n.CtrlCmd=2048]="CtrlCmd",n[n.Shift=1024]="Shift",n[n.Alt=512]="Alt",n[n.WinCtrl=256]="WinCtrl"})(b=t.KeyMod||(t.KeyMod={}));function w(n,i){const r=(i&65535)<<16>>>0;return(n|r)>>>0}t.KeyChord=w;function g(n,i){if(n===0)return null;const r=(n&65535)>>>0,s=(n&4294901760)>>>16;return s!==0?new v([a(r,i),a(s,i)]):new v([a(r,i)])}t.createKeybinding=g;function a(n,i){const r=!!(n&2048),s=!!(n&256),f=i===2?s:r,m=!!(n&1024),h=!!(n&512),_=i===2?r:s,N=n&255;return new d(f,m,h,_,N)}t.createSimpleKeybinding=a;class d{constructor(i,r,s,f,m){this.ctrlKey=i,this.shiftKey=r,this.altKey=s,this.metaKey=f,this.keyCode=m}equals(i){return this.ctrlKey===i.ctrlKey&&this.shiftKey===i.shiftKey&&this.altKey===i.altKey&&this.metaKey===i.metaKey&&this.keyCode===i.keyCode}getHashCode(){const i=this.ctrlKey?"1":"0",r=this.shiftKey?"1":"0",s=this.altKey?"1":"0",f=this.metaKey?"1":"0";return`${i}${r}${s}${f}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new v([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=d;class v{constructor(i){if(i.length===0)throw M.illegalArgument("parts");this.parts=i}getHashCode(){let i="";for(let r=0,s=this.parts.length;r<s;r++)r!==0&&(i+=";"),i+=this.parts[r].getHashCode();return i}equals(i){if(i===null||this.parts.length!==i.parts.length)return!1;for(let r=0;r<this.parts.length;r++)if(!this.parts[r].equals(i.parts[r]))return!1;return!0}}t.ChordKeybinding=v;class E{constructor(i,r,s,f,m,h){this.ctrlKey=i,this.shiftKey=r,this.altKey=s,this.metaKey=f,this.keyLabel=m,this.keyAriaLabel=h}}t.ResolvedKeybindingPart=E;class A{}t.ResolvedKeybinding=A}),G(Q[8],X([0,1,7,16]),function(I,t,M,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.MultiDisposeError=t.trackDisposable=t.setDisposableTracker=void 0;const C=!1;let l=null;function S(r){l=r}if(t.setDisposableTracker=S,C){const r="__is_disposable_tracked__";l=new class{trackDisposable(s){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[r]||console.log(f)},3e3)}markTracked(s){if(s&&s!==v.None)try{s[r]=!0}catch(f){}}}}function u(r){!l||l.markTracked(r)}function o(r){return l&&l.trackDisposable(r),r}t.trackDisposable=o;class c extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}t.MultiDisposeError=c;function b(r){return typeof r.dispose=="function"&&r.dispose.length===0}t.isDisposable=b;function w(r){if(U.Iterable.is(r)){let s=[];for(const f of r)if(f){u(f);try{f.dispose()}catch(m){s.push(m)}}if(s.length===1)throw s[0];if(s.length>1)throw new c(s);return Array.isArray(r)?[]:r}else if(r)return u(r),r.dispose(),r}t.dispose=w;function g(...r){return r.forEach(u),a(()=>w(r))}t.combinedDisposable=g;function a(r){const s=o({dispose:()=>{u(s),r()}});return s}t.toDisposable=a;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(u(this),this._isDisposed=!0,this.clear())}clear(){try{w(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return u(s),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}t.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new d,o(this)}dispose(){u(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}t.Disposable=v,v.None=Object.freeze({dispose(){}});class E{constructor(){this._isDisposed=!1,o(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){var f;this._isDisposed||s===this._value||((f=this._value)===null||f===void 0||f.dispose(),s&&u(s),this._value=s)}clear(){this.value=void 0}dispose(){var s;this._isDisposed=!0,u(this),(s=this._value)===null||s===void 0||s.dispose(),this._value=void 0}}t.MutableDisposable=E;class A{constructor(){this.references=new Map}acquire(s,...f){let m=this.references.get(s);m||(m={counter:0,object:this.createReferencedObject(s,...f)},this.references.set(s,m));const{object:h}=m,_=M.once(()=>{--m.counter==0&&(this.destroyReferencedObject(s,m.object),this.references.delete(s))});return m.counter++,{object:h,dispose:_}}}t.ReferenceCollection=A;class n{constructor(s){this.referenceCollection=s}async acquire(s,...f){const m=this.referenceCollection.acquire(s,...f);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(h){throw m.dispose(),h}}}t.AsyncReferenceCollection=n;class i{constructor(s){this.object=s}dispose(){}}t.ImmortalReference=i}),G(Q[18],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class M{constructor(l){this.element=l,this.next=M.Undefined,this.prev=M.Undefined}}M.Undefined=new M(void 0);class U{constructor(){this._first=M.Undefined,this._last=M.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===M.Undefined}clear(){let l=this._first;for(;l!==M.Undefined;){const S=l.next;l.prev=M.Undefined,l.next=M.Undefined,l=S}this._first=M.Undefined,this._last=M.Undefined,this._size=0}unshift(l){return this._insert(l,!1)}push(l){return this._insert(l,!0)}_insert(l,S){const u=new M(l);if(this._first===M.Undefined)this._first=u,this._last=u;else if(S){const c=this._last;this._last=u,u.prev=c,c.next=u}else{const c=this._first;this._first=u,u.next=c,c.prev=u}this._size+=1;let o=!1;return()=>{o||(o=!0,this._remove(u))}}shift(){if(this._first!==M.Undefined){const l=this._first.element;return this._remove(this._first),l}}pop(){if(this._last!==M.Undefined){const l=this._last.element;return this._remove(this._last),l}}_remove(l){if(l.prev!==M.Undefined&&l.next!==M.Undefined){const S=l.prev;S.next=l.next,l.next.prev=S}else l.prev===M.Undefined&&l.next===M.Undefined?(this._first=M.Undefined,this._last=M.Undefined):l.next===M.Undefined?(this._last=this._last.prev,this._last.next=M.Undefined):l.prev===M.Undefined&&(this._first=this._first.next,this._first.prev=M.Undefined);this._size-=1}*[Symbol.iterator](){let l=this._first;for(;l!==M.Undefined;)yield l.element,l=l.next}}t.LinkedList=U}),G(Q[2],X([0,1]),function(I,t){"use strict";var M;Object.defineProperty(t,"__esModule",{value:!0}),t.isLittleEndian=t.OS=t.OperatingSystem=t.setImmediate=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isIOS=t.isWeb=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.isPreferringBrowserCodeLoad=t.browserCodeLoadingCacheStrategy=t.isElectronSandboxed=t.globals=void 0;const U="en";let C=!1,l=!1,S=!1,u=!1,o=!1,c=!1,b=!1,w,g=U,a,d;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.process!="undefined"?v=t.globals.vscode.process:typeof process!="undefined"&&(v=process);const E=typeof((M=v==null?void 0:v.versions)===null||M===void 0?void 0:M.electron)=="string"&&v.type==="renderer";if(t.isElectronSandboxed=E&&(v==null?void 0:v.sandboxed),t.browserCodeLoadingCacheStrategy=(()=>{if(t.isElectronSandboxed)return"bypassHeatCheck";const _=v==null?void 0:v.env.VSCODE_BROWSER_CODE_LOADING;if(typeof _=="string")return _==="none"||_==="code"||_==="bypassHeatCheck"||_==="bypassHeatCheckAndEagerCompile"?_:"bypassHeatCheck"})(),t.isPreferringBrowserCodeLoad=typeof t.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!E)d=navigator.userAgent,C=d.indexOf("Windows")>=0,l=d.indexOf("Macintosh")>=0,b=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=d.indexOf("Linux")>=0,c=!0,w=navigator.language,g=w;else if(typeof v=="object"){C=v.platform==="win32",l=v.platform==="darwin",S=v.platform==="linux",u=S&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,w=U,g=U;const _=v.env.VSCODE_NLS_CONFIG;if(_)try{const N=JSON.parse(_),p=N.availableLanguages["*"];w=N.locale,g=p||U,a=N._translationsConfigFile}catch(N){}o=!0}else console.error("Unable to resolve platform.");var A;(function(_){_[_.Web=0]="Web",_[_.Mac=1]="Mac",_[_.Linux=2]="Linux",_[_.Windows=3]="Windows"})(A=t.Platform||(t.Platform={}));function n(_){switch(_){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=n;let i=0;l?i=1:C?i=3:S&&(i=2),t.isWindows=C,t.isMacintosh=l,t.isLinux=S,t.isLinuxSnap=u,t.isNative=o,t.isWeb=c,t.isIOS=b,t.platform=i,t.userAgent=d,t.language=g;var r;(function(_){function N(){return t.language}_.value=N;function p(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}_.isDefaultVariant=p;function P(){return t.language==="en"}_.isDefault=P})(r=t.Language||(t.Language={})),t.locale=w,t.translationsConfigFile=a,t.setImmediate=function(){if(t.globals.setImmediate)return t.globals.setImmediate.bind(t.globals);if(typeof t.globals.postMessage=="function"&&!t.globals.importScripts){let p=[];t.globals.addEventListener("message",F=>{if(F.data&&F.data.vscodeSetImmediateId)for(let R=0,y=p.length;R<y;R++){const q=p[R];if(q.id===F.data.vscodeSetImmediateId){p.splice(R,1),q.callback();return}}});let P=0;return F=>{const R=++P;p.push({id:R,callback:F}),t.globals.postMessage({vscodeSetImmediateId:R},"*")}}if(typeof(v==null?void 0:v.nextTick)=="function")return v.nextTick.bind(v);const N=Promise.resolve();return p=>N.then(p)}();var s;(function(_){_[_.Windows=1]="Windows",_[_.Macintosh=2]="Macintosh",_[_.Linux=3]="Linux"})(s=t.OperatingSystem||(t.OperatingSystem={})),t.OS=l||b?2:C?1:3;let f=!0,m=!1;function h(){if(!m){m=!0;const _=new Uint8Array(2);_[0]=1,_[1]=2,f=new Uint16Array(_.buffer)[0]===(2<<8)+1}return f}t.isLittleEndian=h}),G(Q[19],X([0,1,2]),function(I,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.nextTick=t.platform=t.env=t.cwd=void 0;let U;if(typeof M.globals.vscode!="undefined"&&typeof M.globals.vscode.process!="undefined"){const C=M.globals.vscode.process;U={get platform(){return C.platform},get env(){return C.env},cwd(){return C.cwd()},nextTick(l){return M.setImmediate(l)}}}else typeof process!="undefined"?U={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(C){return process.nextTick(C)}}:U={get platform(){return M.isWindows?"win32":M.isMacintosh?"darwin":"linux"},nextTick(C){return M.setImmediate(C)},get env(){return{}},cwd(){return"/"}};t.cwd=U.cwd,t.env=U.env,t.platform=U.platform,t.nextTick=U.nextTick}),G(Q[20],X([0,1,19]),function(I,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const U=65,C=97,l=90,S=122,u=46,o=47,c=92,b=58,w=63;class g extends Error{constructor(r,s,f){let m;typeof s=="string"&&s.indexOf("not ")===0?(m="must not be",s=s.replace(/^not /,"")):m="must be";const h=r.indexOf(".")!==-1?"property":"argument";let _=`The "${r}" ${h} ${m} of type ${s}`;_+=`. Received type ${typeof f}`,super(_),this.code="ERR_INVALID_ARG_TYPE"}}function a(i,r){if(typeof i!="string")throw new g(r,"string",i)}function d(i){return i===o||i===c}function v(i){return i===o}function E(i){return i>=U&&i<=l||i>=C&&i<=S}function A(i,r,s,f){let m="",h=0,_=-1,N=0,p=0;for(let P=0;P<=i.length;++P){if(P<i.length)p=i.charCodeAt(P);else{if(f(p))break;p=o}if(f(p)){if(!(_===P-1||N===1))if(N===2){if(m.length<2||h!==2||m.charCodeAt(m.length-1)!==u||m.charCodeAt(m.length-2)!==u){if(m.length>2){const F=m.lastIndexOf(s);F===-1?(m="",h=0):(m=m.slice(0,F),h=m.length-1-m.lastIndexOf(s)),_=P,N=0;continue}else if(m.length!==0){m="",h=0,_=P,N=0;continue}}r&&(m+=m.length>0?`${s}..`:"..",h=2)}else m.length>0?m+=`${s}${i.slice(_+1,P)}`:m=i.slice(_+1,P),h=P-_-1;_=P,N=0}else p===u&&N!==-1?++N:N=-1}return m}function n(i,r){if(r===null||typeof r!="object")throw new g("pathObject","Object",r);const s=r.dir||r.root,f=r.base||`${r.name||""}${r.ext||""}`;return s?s===r.root?`${s}${f}`:`${s}${i}${f}`:f}t.win32={resolve(...i){let r="",s="",f=!1;for(let m=i.length-1;m>=-1;m--){let h;if(m>=0){if(h=i[m],a(h,"path"),h.length===0)continue}else r.length===0?h=M.cwd():(h=M.env[`=${r}`]||M.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==r.toLowerCase()&&h.charCodeAt(2)===c)&&(h=`${r}\\`));const _=h.length;let N=0,p="",P=!1;const F=h.charCodeAt(0);if(_===1)d(F)&&(N=1,P=!0);else if(d(F))if(P=!0,d(h.charCodeAt(1))){let R=2,y=R;for(;R<_&&!d(h.charCodeAt(R));)R++;if(R<_&&R!==y){const q=h.slice(y,R);for(y=R;R<_&&d(h.charCodeAt(R));)R++;if(R<_&&R!==y){for(y=R;R<_&&!d(h.charCodeAt(R));)R++;(R===_||R!==y)&&(p=`\\\\${q}\\${h.slice(y,R)}`,N=R)}}}else N=1;else E(F)&&h.charCodeAt(1)===b&&(p=h.slice(0,2),N=2,_>2&&d(h.charCodeAt(2))&&(P=!0,N=3));if(p.length>0)if(r.length>0){if(p.toLowerCase()!==r.toLowerCase())continue}else r=p;if(f){if(r.length>0)break}else if(s=`${h.slice(N)}\\${s}`,f=P,P&&r.length>0)break}return s=A(s,!f,"\\",d),f?`${r}\\${s}`:`${r}${s}`||"."},normalize(i){a(i,"path");const r=i.length;if(r===0)return".";let s=0,f,m=!1;const h=i.charCodeAt(0);if(r===1)return v(h)?"\\":i;if(d(h))if(m=!0,d(i.charCodeAt(1))){let N=2,p=N;for(;N<r&&!d(i.charCodeAt(N));)N++;if(N<r&&N!==p){const P=i.slice(p,N);for(p=N;N<r&&d(i.charCodeAt(N));)N++;if(N<r&&N!==p){for(p=N;N<r&&!d(i.charCodeAt(N));)N++;if(N===r)return`\\\\${P}\\${i.slice(p)}\\`;N!==p&&(f=`\\\\${P}\\${i.slice(p,N)}`,s=N)}}}else s=1;else E(h)&&i.charCodeAt(1)===b&&(f=i.slice(0,2),s=2,r>2&&d(i.charCodeAt(2))&&(m=!0,s=3));let _=s<r?A(i.slice(s),!m,"\\",d):"";return _.length===0&&!m&&(_="."),_.length>0&&d(i.charCodeAt(r-1))&&(_+="\\"),f===void 0?m?`\\${_}`:_:m?`${f}\\${_}`:`${f}${_}`},isAbsolute(i){a(i,"path");const r=i.length;if(r===0)return!1;const s=i.charCodeAt(0);return d(s)||r>2&&E(s)&&i.charCodeAt(1)===b&&d(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let r,s;for(let h=0;h<i.length;++h){const _=i[h];a(_,"path"),_.length>0&&(r===void 0?r=s=_:r+=`\\${_}`)}if(r===void 0)return".";let f=!0,m=0;if(typeof s=="string"&&d(s.charCodeAt(0))){++m;const h=s.length;h>1&&d(s.charCodeAt(1))&&(++m,h>2&&(d(s.charCodeAt(2))?++m:f=!1))}if(f){for(;m<r.length&&d(r.charCodeAt(m));)m++;m>=2&&(r=`\\${r.slice(m)}`)}return t.win32.normalize(r)},relative(i,r){if(a(i,"from"),a(r,"to"),i===r)return"";const s=t.win32.resolve(i),f=t.win32.resolve(r);if(s===f||(i=s.toLowerCase(),r=f.toLowerCase(),i===r))return"";let m=0;for(;m<i.length&&i.charCodeAt(m)===c;)m++;let h=i.length;for(;h-1>m&&i.charCodeAt(h-1)===c;)h--;const _=h-m;let N=0;for(;N<r.length&&r.charCodeAt(N)===c;)N++;let p=r.length;for(;p-1>N&&r.charCodeAt(p-1)===c;)p--;const P=p-N,F=_<P?_:P;let R=-1,y=0;for(;y<F;y++){const j=i.charCodeAt(m+y);if(j!==r.charCodeAt(N+y))break;j===c&&(R=y)}if(y!==F){if(R===-1)return f}else{if(P>F){if(r.charCodeAt(N+y)===c)return f.slice(N+y+1);if(y===2)return f.slice(N+y)}_>F&&(i.charCodeAt(m+y)===c?R=y:y===2&&(R=3)),R===-1&&(R=0)}let q="";for(y=m+R+1;y<=h;++y)(y===h||i.charCodeAt(y)===c)&&(q+=q.length===0?"..":"\\..");return N+=R,q.length>0?`${q}${f.slice(N,p)}`:(f.charCodeAt(N)===c&&++N,f.slice(N,p))},toNamespacedPath(i){if(typeof i!="string")return i;if(i.length===0)return"";const r=t.win32.resolve(i);if(r.length<=2)return i;if(r.charCodeAt(0)===c){if(r.charCodeAt(1)===c){const s=r.charCodeAt(2);if(s!==w&&s!==u)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(E(r.charCodeAt(0))&&r.charCodeAt(1)===b&&r.charCodeAt(2)===c)return`\\\\?\\${r}`;return i},dirname(i){a(i,"path");const r=i.length;if(r===0)return".";let s=-1,f=0;const m=i.charCodeAt(0);if(r===1)return d(m)?i:".";if(d(m)){if(s=f=1,d(i.charCodeAt(1))){let N=2,p=N;for(;N<r&&!d(i.charCodeAt(N));)N++;if(N<r&&N!==p){for(p=N;N<r&&d(i.charCodeAt(N));)N++;if(N<r&&N!==p){for(p=N;N<r&&!d(i.charCodeAt(N));)N++;if(N===r)return i;N!==p&&(s=f=N+1)}}}}else E(m)&&i.charCodeAt(1)===b&&(s=r>2&&d(i.charCodeAt(2))?3:2,f=s);let h=-1,_=!0;for(let N=r-1;N>=f;--N)if(d(i.charCodeAt(N))){if(!_){h=N;break}}else _=!1;if(h===-1){if(s===-1)return".";h=s}return i.slice(0,h)},basename(i,r){r!==void 0&&a(r,"ext"),a(i,"path");let s=0,f=-1,m=!0,h;if(i.length>=2&&E(i.charCodeAt(0))&&i.charCodeAt(1)===b&&(s=2),r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let _=r.length-1,N=-1;for(h=i.length-1;h>=s;--h){const p=i.charCodeAt(h);if(d(p)){if(!m){s=h+1;break}}else N===-1&&(m=!1,N=h+1),_>=0&&(p===r.charCodeAt(_)?--_==-1&&(f=h):(_=-1,f=N))}return s===f?f=N:f===-1&&(f=i.length),i.slice(s,f)}for(h=i.length-1;h>=s;--h)if(d(i.charCodeAt(h))){if(!m){s=h+1;break}}else f===-1&&(m=!1,f=h+1);return f===-1?"":i.slice(s,f)},extname(i){a(i,"path");let r=0,s=-1,f=0,m=-1,h=!0,_=0;i.length>=2&&i.charCodeAt(1)===b&&E(i.charCodeAt(0))&&(r=f=2);for(let N=i.length-1;N>=r;--N){const p=i.charCodeAt(N);if(d(p)){if(!h){f=N+1;break}continue}m===-1&&(h=!1,m=N+1),p===u?s===-1?s=N:_!==1&&(_=1):s!==-1&&(_=-1)}return s===-1||m===-1||_===0||_===1&&s===m-1&&s===f+1?"":i.slice(s,m)},format:n.bind(null,"\\"),parse(i){a(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const s=i.length;let f=0,m=i.charCodeAt(0);if(s===1)return d(m)?(r.root=r.dir=i,r):(r.base=r.name=i,r);if(d(m)){if(f=1,d(i.charCodeAt(1))){let R=2,y=R;for(;R<s&&!d(i.charCodeAt(R));)R++;if(R<s&&R!==y){for(y=R;R<s&&d(i.charCodeAt(R));)R++;if(R<s&&R!==y){for(y=R;R<s&&!d(i.charCodeAt(R));)R++;R===s?f=R:R!==y&&(f=R+1)}}}}else if(E(m)&&i.charCodeAt(1)===b){if(s<=2)return r.root=r.dir=i,r;if(f=2,d(i.charCodeAt(2))){if(s===3)return r.root=r.dir=i,r;f=3}}f>0&&(r.root=i.slice(0,f));let h=-1,_=f,N=-1,p=!0,P=i.length-1,F=0;for(;P>=f;--P){if(m=i.charCodeAt(P),d(m)){if(!p){_=P+1;break}continue}N===-1&&(p=!1,N=P+1),m===u?h===-1?h=P:F!==1&&(F=1):h!==-1&&(F=-1)}return N!==-1&&(h===-1||F===0||F===1&&h===N-1&&h===_+1?r.base=r.name=i.slice(_,N):(r.name=i.slice(_,h),r.base=i.slice(_,N),r.ext=i.slice(h,N))),_>0&&_!==f?r.dir=i.slice(0,_-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...i){let r="",s=!1;for(let f=i.length-1;f>=-1&&!s;f--){const m=f>=0?i[f]:M.cwd();a(m,"path"),m.length!==0&&(r=`${m}/${r}`,s=m.charCodeAt(0)===o)}return r=A(r,!s,"/",v),s?`/${r}`:r.length>0?r:"."},normalize(i){if(a(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===o,s=i.charCodeAt(i.length-1)===o;return i=A(i,!r,"/",v),i.length===0?r?"/":s?"./":".":(s&&(i+="/"),r?`/${i}`:i)},isAbsolute(i){return a(i,"path"),i.length>0&&i.charCodeAt(0)===o},join(...i){if(i.length===0)return".";let r;for(let s=0;s<i.length;++s){const f=i[s];a(f,"path"),f.length>0&&(r===void 0?r=f:r+=`/${f}`)}return r===void 0?".":t.posix.normalize(r)},relative(i,r){if(a(i,"from"),a(r,"to"),i===r||(i=t.posix.resolve(i),r=t.posix.resolve(r),i===r))return"";const s=1,f=i.length,m=f-s,h=1,_=r.length-h,N=m<_?m:_;let p=-1,P=0;for(;P<N;P++){const R=i.charCodeAt(s+P);if(R!==r.charCodeAt(h+P))break;R===o&&(p=P)}if(P===N)if(_>N){if(r.charCodeAt(h+P)===o)return r.slice(h+P+1);if(P===0)return r.slice(h+P)}else m>N&&(i.charCodeAt(s+P)===o?p=P:P===0&&(p=0));let F="";for(P=s+p+1;P<=f;++P)(P===f||i.charCodeAt(P)===o)&&(F+=F.length===0?"..":"/..");return`${F}${r.slice(h+p)}`},toNamespacedPath(i){return i},dirname(i){if(a(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===o;let s=-1,f=!0;for(let m=i.length-1;m>=1;--m)if(i.charCodeAt(m)===o){if(!f){s=m;break}}else f=!1;return s===-1?r?"/":".":r&&s===1?"//":i.slice(0,s)},basename(i,r){r!==void 0&&a(r,"ext"),a(i,"path");let s=0,f=-1,m=!0,h;if(r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let _=r.length-1,N=-1;for(h=i.length-1;h>=0;--h){const p=i.charCodeAt(h);if(p===o){if(!m){s=h+1;break}}else N===-1&&(m=!1,N=h+1),_>=0&&(p===r.charCodeAt(_)?--_==-1&&(f=h):(_=-1,f=N))}return s===f?f=N:f===-1&&(f=i.length),i.slice(s,f)}for(h=i.length-1;h>=0;--h)if(i.charCodeAt(h)===o){if(!m){s=h+1;break}}else f===-1&&(m=!1,f=h+1);return f===-1?"":i.slice(s,f)},extname(i){a(i,"path");let r=-1,s=0,f=-1,m=!0,h=0;for(let _=i.length-1;_>=0;--_){const N=i.charCodeAt(_);if(N===o){if(!m){s=_+1;break}continue}f===-1&&(m=!1,f=_+1),N===u?r===-1?r=_:h!==1&&(h=1):r!==-1&&(h=-1)}return r===-1||f===-1||h===0||h===1&&r===f-1&&r===s+1?"":i.slice(r,f)},format:n.bind(null,"/"),parse(i){a(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const s=i.charCodeAt(0)===o;let f;s?(r.root="/",f=1):f=0;let m=-1,h=0,_=-1,N=!0,p=i.length-1,P=0;for(;p>=f;--p){const F=i.charCodeAt(p);if(F===o){if(!N){h=p+1;break}continue}_===-1&&(N=!1,_=p+1),F===u?m===-1?m=p:P!==1&&(P=1):m!==-1&&(P=-1)}if(_!==-1){const F=h===0&&s?1:h;m===-1||P===0||P===1&&m===_-1&&m===h+1?r.base=r.name=i.slice(F,_):(r.name=i.slice(F,m),r.base=i.slice(F,_),r.ext=i.slice(m,_))}return h>0?r.dir=i.slice(0,h-1):s&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=M.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=M.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=M.platform==="win32"?t.win32.join:t.posix.join,t.resolve=M.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=M.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=M.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=M.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=M.platform==="win32"?t.win32.extname:t.posix.extname,t.format=M.platform==="win32"?t.win32.format:t.posix.format,t.parse=M.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=M.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=M.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=M.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),G(Q[9],X([0,1,2]),function(I,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const U=M.globals.performance&&typeof M.globals.performance.now=="function";class C{constructor(S){this._highResolution=U&&S,this._startTime=this._now(),this._stopTime=-1}static create(S=!0){return new C(S)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?M.globals.performance.now():Date.now()}}t.StopWatch=C}),G(Q[10],X([0,1,4,7,8,18,9]),function(I,t,M,U,C,l,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.DebounceEmitter=t.PauseableEmitter=t.Emitter=t.setGlobalLeakWarningThreshold=t.Event=void 0;var u;(function(n){n.None=()=>C.Disposable.None;function i(H){return(e,B=null,W)=>{let V=!1,Z;return Z=H(x=>{if(!V)return Z?Z.dispose():V=!0,e.call(B,x)},null,W),V&&Z.dispose(),Z}}n.once=i;function r(H,e){return N((B,W=null,V)=>H(Z=>B.call(W,e(Z)),null,V))}n.map=r;function s(H,e){return N((B,W=null,V)=>H(Z=>{e(Z),B.call(W,Z)},null,V))}n.forEach=s;function f(H,e){return N((B,W=null,V)=>H(Z=>e(Z)&&B.call(W,Z),null,V))}n.filter=f;function m(H){return H}n.signal=m;function h(...H){return(e,B=null,W)=>C.combinedDisposable(...H.map(V=>V(Z=>e.call(B,Z),null,W)))}n.any=h;function _(H,e,B){let W=B;return r(H,V=>(W=e(W,V),W))}n.reduce=_;function N(H){let e;const B=new g({onFirstListenerAdd(){e=H(B.fire,B)},onLastListenerRemove(){e.dispose()}});return B.event}function p(H,e,B=100,W=!1,V){let Z,x,te,le=0;const ue=new g({leakWarningThreshold:V,onFirstListenerAdd(){Z=H(ce=>{le++,x=e(x,ce),W&&!te&&(ue.fire(x),x=void 0),clearTimeout(te),te=setTimeout(()=>{const fe=x;x=void 0,te=void 0,(!W||le>1)&&ue.fire(fe),le=0},B)})},onLastListenerRemove(){Z.dispose()}});return ue.event}n.debounce=p;function P(H,e=(B,W)=>B===W){let B=!0,W;return f(H,V=>{const Z=B||!e(V,W);return B=!1,W=V,Z})}n.latch=P;function F(H,e){return[n.filter(H,e),n.filter(H,B=>!e(B))]}n.split=F;function R(H,e=!1,B=[]){let W=B.slice(),V=H(te=>{W?W.push(te):x.fire(te)});const Z=()=>{W&&W.forEach(te=>x.fire(te)),W=null},x=new g({onFirstListenerAdd(){V||(V=H(te=>x.fire(te)))},onFirstListenerDidAdd(){W&&(e?setTimeout(Z):Z())},onLastListenerRemove(){V&&V.dispose(),V=null}});return x.event}n.buffer=R;class y{constructor(e){this.event=e}map(e){return new y(r(this.event,e))}forEach(e){return new y(s(this.event,e))}filter(e){return new y(f(this.event,e))}reduce(e,B){return new y(_(this.event,e,B))}latch(){return new y(P(this.event))}debounce(e,B=100,W=!1,V){return new y(p(this.event,e,B,W,V))}on(e,B,W){return this.event(e,B,W)}once(e,B,W){return i(this.event)(e,B,W)}}function q(H){return new y(H)}n.chain=q;function j(H,e,B=W=>W){const W=(...te)=>x.fire(B(...te)),V=()=>H.on(e,W),Z=()=>H.removeListener(e,W),x=new g({onFirstListenerAdd:V,onLastListenerRemove:Z});return x.event}n.fromNodeEventEmitter=j;function J(H,e,B=W=>W){const W=(...te)=>x.fire(B(...te)),V=()=>H.addEventListener(e,W),Z=()=>H.removeEventListener(e,W),x=new g({onFirstListenerAdd:V,onLastListenerRemove:Z});return x.event}n.fromDOMEventEmitter=J;function z(H){return new Promise(e=>i(H)(e))}n.toPromise=z})(u=t.Event||(t.Event={}));class o{constructor(i){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${i}_${o._idPool++}`}start(i){this._stopWatch=new S.StopWatch(!0),this._listenerCount=i}stop(){if(this._stopWatch){const i=this._stopWatch.elapsed();this._elapsedOverall+=i,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${i.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}o._idPool=0;let c=-1;function b(n){const i=c;return c=n,{dispose(){c=i}}}t.setGlobalLeakWarningThreshold=b;class w{constructor(i,r=Math.random().toString(18).slice(2,5)){this.customThreshold=i,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(i){let r=c;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),r<=0||i<r)return;this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),f=this._stacks.get(s)||0;if(this._stacks.set(s,f+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let m,h=0;for(const[_,N]of this._stacks)(!m||h<N)&&(m=_,h=N);console.warn(`[${this.name}] potential listener LEAK detected, having ${i} listeners already. MOST frequent listener (${h}):`),console.warn(m)}return()=>{const m=this._stacks.get(s)||0;this._stacks.set(s,m-1)}}}class g{constructor(i){var r;this._disposed=!1,this._options=i,this._leakageMon=c>0?new w(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((r=this._options)===null||r===void 0?void 0:r._profName)?new o(this._options._profName):void 0}get event(){return this._event||(this._event=(i,r,s)=>{var f;this._listeners||(this._listeners=new l.LinkedList);const m=this._listeners.isEmpty();m&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const h=this._listeners.push(r?[i,r]:i);m&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,i,r);const _=(f=this._leakageMon)===null||f===void 0?void 0:f.check(this._listeners.size);let N;return N={dispose:()=>{_&&_(),N.dispose=g._noop,this._disposed||(h(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},s instanceof C.DisposableStore?s.add(N):Array.isArray(s)&&s.push(N),N}),this._event}fire(i){var r,s;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new l.LinkedList);for(let f of this._listeners)this._deliveryQueue.push([f,i]);for((r=this._perfMon)===null||r===void 0||r.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[f,m]=this._deliveryQueue.shift();try{typeof f=="function"?f.call(void 0,m):f[0].call(f[1],m)}catch(h){M.onUnexpectedError(h)}}(s=this._perfMon)===null||s===void 0||s.stop()}}dispose(){var i,r,s,f,m;this._disposed||(this._disposed=!0,(i=this._listeners)===null||i===void 0||i.clear(),(r=this._deliveryQueue)===null||r===void 0||r.clear(),(f=(s=this._options)===null||s===void 0?void 0:s.onLastListenerRemove)===null||f===void 0||f.call(s),(m=this._leakageMon)===null||m===void 0||m.dispose())}}t.Emitter=g,g._noop=function(){};class a extends g{constructor(i){super(i);this._isPaused=0,this._eventQueue=new l.LinkedList,this._mergeFn=i==null?void 0:i.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const i=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(i))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(i){this._listeners&&(this._isPaused!==0?this._eventQueue.push(i):super.fire(i))}}t.PauseableEmitter=a;class d extends a{constructor(i){var r;super(i);this._delay=(r=i.delay)!==null&&r!==void 0?r:100}fire(i){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(i)}}t.DebounceEmitter=d;class v{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(i){const r={event:i,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const s=()=>{this.hasListeners&&this.unhook(r);const f=this.events.indexOf(r);this.events.splice(f,1)};return C.toDisposable(U.once(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(i=>this.hook(i))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(i=>this.unhook(i))}hook(i){i.listener=i.event(r=>this.emitter.fire(r))}unhook(i){i.listener&&i.listener.dispose(),i.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=v;class E{constructor(){this.buffers=[]}wrapEvent(i){return(r,s,f)=>i(m=>{const h=this.buffers[this.buffers.length-1];h?h.push(()=>r.call(s,m)):r.call(s,m)},void 0,f)}bufferEvents(i){const r=[];this.buffers.push(r);const s=i();return this.buffers.pop(),r.forEach(f=>f()),s}}t.EventBufferer=E;class A{constructor(){this.listening=!1,this.inputEvent=u.None,this.inputEventListener=C.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(i){this.inputEvent=i,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=i(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=A}),G(Q[21],X([0,1,10]),function(I,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const U=Object.freeze(function(u,o){const c=setTimeout(u.bind(o),0);return{dispose(){clearTimeout(c)}}});var C;(function(u){function o(c){return c===u.None||c===u.Cancelled||c instanceof l?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}u.isCancellationToken=o,u.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:M.Event.None}),u.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:U})})(C=t.CancellationToken||(t.CancellationToken={}));class l{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?U:(this._emitter||(this._emitter=new M.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class S{constructor(o){this._token=void 0,this._parentListener=void 0,this._parentListener=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new l),this._token}cancel(){this._token?this._token instanceof l&&this._token.cancel():this._token=C.Cancelled}dispose(o=!1){o&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof l&&this._token.dispose():this._token=C.None}}t.CancellationTokenSource=S}),G(Q[5],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLeftDeleteOffset=t.GraphemeBreakType=t.breakBetweenGraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsEmoji=t.containsRTL=t.decodeUTF8=t.encodeUTF8=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format=t.isFalsyOrWhitespace=void 0;function M(L){return!L||typeof L!="string"?!0:L.trim().length===0}t.isFalsyOrWhitespace=M;const U=/{(\d+)}/g;function C(L,...D){return D.length===0?L:L.replace(U,function(T,k){const O=parseInt(k,10);return isNaN(O)||O<0||O>=D.length?T:D[O]})}t.format=C;function l(L){return L.replace(/[<>&]/g,function(D){switch(D){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return D}})}t.escape=l;function S(L){return L.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=S;function u(L,D){let T=0;const k=D.charCodeAt(0);for(let O=L.length-1;O>=0;O--)L.charCodeAt(O)===k&&T++;return T}t.count=u;function o(L,D,T="\u2026"){return L.length<=D?L:`${L.substr(0,D)}${T}`}t.truncate=o;function c(L,D=" "){const T=b(L,D);return w(T,D)}t.trim=c;function b(L,D){if(!L||!D)return L;const T=D.length;if(T===0||L.length===0)return L;let k=0;for(;L.indexOf(D,k)===k;)k=k+T;return L.substring(k)}t.ltrim=b;function w(L,D){if(!L||!D)return L;const T=D.length,k=L.length;if(T===0||k===0)return L;let O=k,Y=-1;for(;Y=L.lastIndexOf(D,O-1),!(Y===-1||Y+T!==O);){if(Y===0)return"";O=Y}return L.substring(0,O)}t.rtrim=w;function g(L){return L.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=g;function a(L){return L.replace(/\*/g,"")}t.stripWildcards=a;function d(L,D,T={}){if(!L)throw new Error("Cannot create regex from empty string");D||(L=S(L)),T.wholeWord&&(/\B/.test(L.charAt(0))||(L="\\b"+L),/\B/.test(L.charAt(L.length-1))||(L=L+"\\b"));let k="";return T.global&&(k+="g"),T.matchCase||(k+="i"),T.multiline&&(k+="m"),T.unicode&&(k+="u"),new RegExp(L,k)}t.createRegExp=d;function v(L){return L.source==="^"||L.source==="^$"||L.source==="$"||L.source==="^\\s*$"?!1:!!(L.exec("")&&L.lastIndex===0)}t.regExpLeadsToEndlessLoop=v;function E(L){return!!L.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=E;function A(L){return(L.global?"g":"")+(L.ignoreCase?"i":"")+(L.multiline?"m":"")+(L.unicode?"u":"")}t.regExpFlags=A;function n(L){return L.split(/\r\n|\r|\n/)}t.splitLines=n;function i(L){for(let D=0,T=L.length;D<T;D++){const k=L.charCodeAt(D);if(k!==32&&k!==9)return D}return-1}t.firstNonWhitespaceIndex=i;function r(L,D=0,T=L.length){for(let k=D;k<T;k++){const O=L.charCodeAt(k);if(O!==32&&O!==9)return L.substring(D,k)}return L.substring(D,T)}t.getLeadingWhitespace=r;function s(L,D=L.length-1){for(let T=D;T>=0;T--){const k=L.charCodeAt(T);if(k!==32&&k!==9)return T}return-1}t.lastNonWhitespaceIndex=s;function f(L,D){return L<D?-1:L>D?1:0}t.compare=f;function m(L,D,T=0,k=L.length,O=0,Y=D.length){for(;T<k&&O<Y;T++,O++){let ne=L.charCodeAt(T),ie=D.charCodeAt(O);if(ne<ie)return-1;if(ne>ie)return 1}const $=k-T,ee=Y-O;return $<ee?-1:$>ee?1:0}t.compareSubstring=m;function h(L,D){return _(L,D,0,L.length,0,D.length)}t.compareIgnoreCase=h;function _(L,D,T=0,k=L.length,O=0,Y=D.length){for(;T<k&&O<Y;T++,O++){let ne=L.charCodeAt(T),ie=D.charCodeAt(O);if(ne===ie)continue;const se=ne-ie;if(!(se===32&&p(ie))&&!(se===-32&&p(ne)))return N(ne)&&N(ie)?se:m(L.toLowerCase(),D.toLowerCase(),T,k,O,Y)}const $=k-T,ee=Y-O;return $<ee?-1:$>ee?1:0}t.compareSubstringIgnoreCase=_;function N(L){return L>=97&&L<=122}t.isLowerAsciiLetter=N;function p(L){return L>=65&&L<=90}t.isUpperAsciiLetter=p;function P(L){return N(L)||p(L)}function F(L,D){return L.length===D.length&&R(L,D)}t.equalsIgnoreCase=F;function R(L,D,T=L.length){for(let k=0;k<T;k++){const O=L.charCodeAt(k),Y=D.charCodeAt(k);if(O!==Y){if(P(O)&&P(Y)){const $=Math.abs(O-Y);if($!==0&&$!==32)return!1}else if(String.fromCharCode(O).toLowerCase()!==String.fromCharCode(Y).toLowerCase())return!1}}return!0}function y(L,D){const T=D.length;return D.length>L.length?!1:R(L,D,T)}t.startsWithIgnoreCase=y;function q(L,D){let T,k=Math.min(L.length,D.length);for(T=0;T<k;T++)if(L.charCodeAt(T)!==D.charCodeAt(T))return T;return k}t.commonPrefixLength=q;function j(L,D){let T,k=Math.min(L.length,D.length);const O=L.length-1,Y=D.length-1;for(T=0;T<k;T++)if(L.charCodeAt(O-T)!==D.charCodeAt(Y-T))return T;return k}t.commonSuffixLength=j;function J(L){return 55296<=L&&L<=56319}t.isHighSurrogate=J;function z(L){return 56320<=L&&L<=57343}t.isLowSurrogate=z;function H(L,D){return(L-55296<<10)+(D-56320)+65536}t.computeCodePoint=H;function e(L,D,T){const k=L.charCodeAt(T);if(J(k)&&T+1<D){const O=L.charCodeAt(T+1);if(z(O))return H(k,O)}return k}t.getNextCodePoint=e;function B(L,D){const T=L.charCodeAt(D-1);if(z(T)&&D>1){const k=L.charCodeAt(D-2);if(J(k))return H(k,T)}return T}function W(L,D){const T=re.getInstance(),k=D,O=L.length,Y=e(L,O,D);D+=Y>=65536?2:1;let $=T.getGraphemeBreakType(Y);for(;D<O;){const ee=e(L,O,D),ne=T.getGraphemeBreakType(ee);if(oe($,ne))break;D+=ee>=65536?2:1,$=ne}return D-k}t.nextCharLength=W;function V(L,D){const T=re.getInstance(),k=D,O=B(L,D);D-=O>=65536?2:1;let Y=T.getGraphemeBreakType(O);for(;D>0;){const $=B(L,D),ee=T.getGraphemeBreakType($);if(oe(ee,Y))break;D-=$>=65536?2:1,Y=ee}return k-D}t.prevCharLength=V;function Z(L,D){const T=re.getInstance(),k=L.length,O=D,Y=e(L,k,D),$=T.getGraphemeBreakType(Y);D+=Y>=65536?2:1;let ee=$;for(;D<k;){const ie=e(L,k,D),se=T.getGraphemeBreakType(ie);if(oe(ee,se))break;D+=ie>=65536?2:1,ee=se}const ne=D;for(D=O,ee=$;D>0;){const ie=B(L,D),se=T.getGraphemeBreakType(ie);if(oe(se,ee))break;D-=ie>=65536?2:1,ee=se}return[D,ne]}function x(L,D){return D>0&&z(L.charCodeAt(D))?Z(L,D-1):Z(L,D)}t.getCharContainingOffset=x;function te(L){const D=L.length;let T=0,k=0;for(;k<D;){const $=e(L,D,k);k+=$>=65536?2:1,$<128?T+=1:$<2048?T+=2:$<65536?T+=3:T+=4}const O=new Uint8Array(T);k=0;let Y=0;for(;k<D;){const $=e(L,D,k);k+=$>=65536?2:1,$<128?O[Y++]=$:$<2048?(O[Y++]=192|($&1984)>>>6,O[Y++]=128|($&63)>>>0):$<65536?(O[Y++]=224|($&61440)>>>12,O[Y++]=128|($&4032)>>>6,O[Y++]=128|($&63)>>>0):(O[Y++]=240|($&1835008)>>>18,O[Y++]=128|($&258048)>>>12,O[Y++]=128|($&4032)>>>6,O[Y++]=128|($&63)>>>0)}return O}t.encodeUTF8=te;function le(L){const D=L.byteLength,T=[];let k=0;for(;k<D;){const O=L[k];let Y;if(O>=240&&k+3<D?Y=(L[k++]&7)<<18>>>0|(L[k++]&63)<<12>>>0|(L[k++]&63)<<6>>>0|(L[k++]&63)<<0>>>0:O>=224&&k+2<D?Y=(L[k++]&15)<<12>>>0|(L[k++]&63)<<6>>>0|(L[k++]&63)<<0>>>0:O>=192&&k+1<D?Y=(L[k++]&31)<<6>>>0|(L[k++]&63)<<0>>>0:Y=L[k++],Y>=0&&Y<=55295||Y>=57344&&Y<=65535)T.push(String.fromCharCode(Y));else if(Y>=65536&&Y<=1114111){const $=Y-65536,ee=55296+(($&1047552)>>>10),ne=56320+(($&1023)>>>0);T.push(String.fromCharCode(ee)),T.push(String.fromCharCode(ne))}else T.push(String.fromCharCode(65533))}return T.join("")}t.decodeUTF8=le;const ue=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ce(L){return ue.test(L)}t.containsRTL=ce;const fe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Se(L){return fe.test(L)}t.containsEmoji=Se;const Ee=/^[\t\n\r\x20-\x7E]*$/;function Ae(L){return Ee.test(L)}t.isBasicASCII=Ae,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ne(L){return t.UNUSUAL_LINE_TERMINATORS.test(L)}t.containsUnusualLineTerminators=Ne;function we(L){for(let D=0,T=L.length;D<T;D++)if(de(L.charCodeAt(D)))return!0;return!1}t.containsFullWidthCharacter=we;function de(L){return L=+L,L>=11904&&L<=55215||L>=63744&&L<=64255||L>=65281&&L<=65374}t.isFullWidthCharacter=de;function ge(L){return L>=127462&&L<=127487||L===8986||L===8987||L===9200||L===9203||L>=9728&&L<=10175||L===11088||L===11093||L>=127744&&L<=128591||L>=128640&&L<=128764||L>=128992&&L<=129003||L>=129280&&L<=129535||L>=129648&&L<=129750}t.isEmojiImprecise=ge;function Ce(L,D){if(L.length<D)return L;const T=/\b/g;let k=0;for(;T.test(L)&&!(L.length-T.lastIndex<D);)k=T.lastIndex,T.lastIndex+=1;return L.substring(k).replace(/^\s/,"")}t.lcut=Ce;const Pe=/\x1B\x5B[12]?K/g,Me=/\x1b\[\d+m/g,pe=/\x1b\[0?m/g;function De(L){return L&&(L=L.replace(Pe,""),L=L.replace(Me,""),L=L.replace(pe,"")),L}t.removeAnsiEscapeCodes=De,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function me(L){return!!(L&&L.length>0&&L.charCodeAt(0)===65279)}t.startsWithUTF8BOM=me;function Ue(L){return me(L)?L.substr(1):L}t.stripUTF8BOM=Ue;function Re(L,D){if(!L||!D||L.length<D.length)return!1;const T=D.length,k=L.toLowerCase();let O=0,Y=-1;for(;O<T;){const $=k.indexOf(D[O],Y+1);if($<0)return!1;Y=$,O++}return!0}t.fuzzyContains=Re;function Fe(L,D=!1){return L?(D&&(L=L.replace(/\\./g,"")),L.toLowerCase()!==L):!1}t.containsUppercaseCharacter=Fe;function Ie(L){return L.charAt(0).toUpperCase()+L.slice(1)}t.uppercaseFirstLetter=Ie;function Te(L,D=1){if(D===0)return"";let T=-1;do T=L.indexOf(`
`,T+1),D--;while(D>0&&T>=0);return T===-1?L:(L[T-1]==="\r"&&T--,L.substr(0,T))}t.getNLines=Te;function ke(L){const D=90-65+1;return L=L%(2*D),L<D?String.fromCharCode(97+L):String.fromCharCode(65+L-D)}t.singleLetterHash=ke;function ye(L){return re.getInstance().getGraphemeBreakType(L)}t.getGraphemeBreakType=ye;function oe(L,D){return L===0?D!==5&&D!==7:L===2&&D===3?!1:L===4||L===2||L===3||D===4||D===2||D===3?!0:!(L===8&&(D===8||D===9||D===11||D===12)||(L===11||L===9)&&(D===9||D===10)||(L===12||L===10)&&D===10||D===5||D===13||D===7||L===1||L===13&&D===14||L===6&&D===6)}t.breakBetweenGraphemeBreakType=oe;var We;(function(L){L[L.Other=0]="Other",L[L.Prepend=1]="Prepend",L[L.CR=2]="CR",L[L.LF=3]="LF",L[L.Control=4]="Control",L[L.Extend=5]="Extend",L[L.Regional_Indicator=6]="Regional_Indicator",L[L.SpacingMark=7]="SpacingMark",L[L.L=8]="L",L[L.V=9]="V",L[L.T=10]="T",L[L.LV=11]="LV",L[L.LVT=12]="LVT",L[L.ZWJ=13]="ZWJ",L[L.Extended_Pictographic=14]="Extended_Pictographic"})(We=t.GraphemeBreakType||(t.GraphemeBreakType={}));class re{constructor(){this._data=Oe()}static getInstance(){return re._INSTANCE||(re._INSTANCE=new re),re._INSTANCE}getGraphemeBreakType(D){if(D<32)return D===10?3:D===13?2:4;if(D<127)return 0;const T=this._data,k=T.length/3;let O=1;for(;O<=k;)if(D<T[3*O])O=2*O;else if(D>T[3*O+1])O=2*O+1;else return T[3*O+2];return 0}}re._INSTANCE=null;function Oe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function qe(L,D){if(L===0)return 0;const T=Be(L,D);if(T!==void 0)return T;const k=B(D,L);return L-=ae(k),L}t.getLeftDeleteOffset=qe;function Be(L,D){let T=B(D,L);for(L-=ae(T);He(T)||T===65039||T===8419;){if(L===0)return;T=B(D,L),L-=ae(T)}if(!!ge(T)){if(L>=0){const k=B(D,L);k===8205&&(L-=ae(k))}return L}}function ae(L){return L>=65536?2:1}function He(L){return 127995<=L&&L<=127999}var _e;(function(L){L[L.zwj=8205]="zwj",L[L.emojiVariantSelector=65039]="emojiVariantSelector",L[L.enclosingKeyCap=8419]="enclosingKeyCap"})(_e||(_e={}))}),G(Q[22],X([0,1,5]),function(I,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.doHash=t.hash=void 0;function U(A){return C(A,0)}t.hash=U;function C(A,n){switch(typeof A){case"object":return A===null?l(349,n):Array.isArray(A)?o(A,n):c(A,n);case"string":return u(A,n);case"boolean":return S(A,n);case"number":return l(A,n);case"undefined":return l(937,n);default:return l(617,n)}}t.doHash=C;function l(A,n){return(n<<5)-n+A|0}function S(A,n){return l(A?433:863,n)}function u(A,n){n=l(149417,n);for(let i=0,r=A.length;i<r;i++)n=l(A.charCodeAt(i),n);return n}t.stringHash=u;function o(A,n){return n=l(104579,n),A.reduce((i,r)=>C(r,i),n)}function c(A,n){return n=l(181387,n),Object.keys(A).sort().reduce((i,r)=>(i=u(r,i),C(A[r],i)),n)}class b{constructor(){this._value=0}get value(){return this._value}hash(n){return this._value=C(n,this._value),this._value}}t.Hasher=b;var w;(function(A){A[A.BLOCK_SIZE=64]="BLOCK_SIZE",A[A.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function g(A,n,i=32){const r=i-n,s=~((1<<r)-1);return(A<<n|(s&A)>>>r)>>>0}function a(A,n=0,i=A.byteLength,r=0){for(let s=0;s<i;s++)A[n+s]=r}function d(A,n,i="0"){for(;A.length<n;)A=i+A;return A}function v(A,n=32){return A instanceof ArrayBuffer?Array.from(new Uint8Array(A)).map(i=>i.toString(16).padStart(2,"0")).join(""):d((A>>>0).toString(16),n/4)}t.toHexString=v;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(n){const i=n.length;if(i===0)return;const r=this._buff;let s=this._buffLen,f=this._leftoverHighSurrogate,m,h;for(f!==0?(m=f,h=-1,f=0):(m=n.charCodeAt(0),h=0);;){let _=m;if(M.isHighSurrogate(m))if(h+1<i){const N=n.charCodeAt(h+1);M.isLowSurrogate(N)?(h++,_=M.computeCodePoint(m,N)):_=65533}else{f=m;break}else M.isLowSurrogate(m)&&(_=65533);if(s=this._push(r,s,_),h++,h<i)m=n.charCodeAt(h);else break}this._buffLen=s,this._leftoverHighSurrogate=f}_push(n,i,r){return r<128?n[i++]=r:r<2048?(n[i++]=192|(r&1984)>>>6,n[i++]=128|(r&63)>>>0):r<65536?(n[i++]=224|(r&61440)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0):(n[i++]=240|(r&1835008)>>>18,n[i++]=128|(r&258048)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0),i>=64&&(this._step(),i-=64,this._totalLen+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),i}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,a(this._buff,this._buffLen),this._buffLen>56&&(this._step(),a(this._buff));const n=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(n/4294967296),!1),this._buffDV.setUint32(60,n%4294967296,!1),this._step()}_step(){const n=E._bigBlock32,i=this._buffDV;for(let P=0;P<64;P+=4)n.setUint32(P,i.getUint32(P,!1),!1);for(let P=64;P<320;P+=4)n.setUint32(P,g(n.getUint32(P-12,!1)^n.getUint32(P-32,!1)^n.getUint32(P-56,!1)^n.getUint32(P-64,!1),1),!1);let r=this._h0,s=this._h1,f=this._h2,m=this._h3,h=this._h4,_,N,p;for(let P=0;P<80;P++)P<20?(_=s&f|~s&m,N=1518500249):P<40?(_=s^f^m,N=1859775393):P<60?(_=s&f|s&m|f&m,N=2400959708):(_=s^f^m,N=3395469782),p=g(r,5)+_+h+N+n.getUint32(P*4,!1)&4294967295,h=m,m=f,f=g(s,30),s=r,r=p;this._h0=this._h0+r&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+f&4294967295,this._h3=this._h3+m&4294967295,this._h4=this._h4+h&4294967295}}t.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),G(Q[11],X([0,1,15,22]),function(I,t,M,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.MyArray=t.Debug=t.stringDiff=t.StringDiffSequence=void 0;class C{constructor(g){this.source=g}getElements(){const g=this.source,a=new Int32Array(g.length);for(let d=0,v=g.length;d<v;d++)a[d]=g.charCodeAt(d);return a}}t.StringDiffSequence=C;function l(w,g,a){return new b(new C(w),new C(g)).ComputeDiff(a).changes}t.stringDiff=l;class S{static Assert(g,a){if(!g)throw new Error(a)}}t.Debug=S;class u{static Copy(g,a,d,v,E){for(let A=0;A<E;A++)d[v+A]=g[a+A]}static Copy2(g,a,d,v,E){for(let A=0;A<E;A++)d[v+A]=g[a+A]}}t.MyArray=u;var o;(function(w){w[w.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(o||(o={}));class c{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new M.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(g,a){this.m_originalStart=Math.min(this.m_originalStart,g),this.m_modifiedStart=Math.min(this.m_modifiedStart,a),this.m_originalCount++}AddModifiedElement(g,a){this.m_originalStart=Math.min(this.m_originalStart,g),this.m_modifiedStart=Math.min(this.m_modifiedStart,a),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class b{constructor(g,a,d=null){this.ContinueProcessingPredicate=d,this._originalSequence=g,this._modifiedSequence=a;const[v,E,A]=b._getElements(g),[n,i,r]=b._getElements(a);this._hasStrings=A&&r,this._originalStringElements=v,this._originalElementsOrHash=E,this._modifiedStringElements=n,this._modifiedElementsOrHash=i,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(g){return g.length>0&&typeof g[0]=="string"}static _getElements(g){const a=g.getElements();if(b._isStringArray(a)){const d=new Int32Array(a.length);for(let v=0,E=a.length;v<E;v++)d[v]=U.stringHash(a[v],0);return[a,d,!0]}return a instanceof Int32Array?[[],a,!1]:[[],new Int32Array(a),!1]}ElementsAreEqual(g,a){return this._originalElementsOrHash[g]!==this._modifiedElementsOrHash[a]?!1:this._hasStrings?this._originalStringElements[g]===this._modifiedStringElements[a]:!0}ElementsAreStrictEqual(g,a){if(!this.ElementsAreEqual(g,a))return!1;const d=b._getStrictElement(this._originalSequence,g),v=b._getStrictElement(this._modifiedSequence,a);return d===v}static _getStrictElement(g,a){return typeof g.getStrictElement=="function"?g.getStrictElement(a):null}OriginalElementsAreEqual(g,a){return this._originalElementsOrHash[g]!==this._originalElementsOrHash[a]?!1:this._hasStrings?this._originalStringElements[g]===this._originalStringElements[a]:!0}ModifiedElementsAreEqual(g,a){return this._modifiedElementsOrHash[g]!==this._modifiedElementsOrHash[a]?!1:this._hasStrings?this._modifiedStringElements[g]===this._modifiedStringElements[a]:!0}ComputeDiff(g){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,g)}_ComputeDiff(g,a,d,v,E){const A=[!1];let n=this.ComputeDiffRecursive(g,a,d,v,A);return E&&(n=this.PrettifyChanges(n)),{quitEarly:A[0],changes:n}}ComputeDiffRecursive(g,a,d,v,E){for(E[0]=!1;g<=a&&d<=v&&this.ElementsAreEqual(g,d);)g++,d++;for(;a>=g&&v>=d&&this.ElementsAreEqual(a,v);)a--,v--;if(g>a||d>v){let f;return d<=v?(S.Assert(g===a+1,"originalStart should only be one more than originalEnd"),f=[new M.DiffChange(g,0,d,v-d+1)]):g<=a?(S.Assert(d===v+1,"modifiedStart should only be one more than modifiedEnd"),f=[new M.DiffChange(g,a-g+1,d,0)]):(S.Assert(g===a+1,"originalStart should only be one more than originalEnd"),S.Assert(d===v+1,"modifiedStart should only be one more than modifiedEnd"),f=[]),f}const A=[0],n=[0],i=this.ComputeRecursionPoint(g,a,d,v,A,n,E),r=A[0],s=n[0];if(i!==null)return i;if(!E[0]){const f=this.ComputeDiffRecursive(g,r,d,s,E);let m=[];return E[0]?m=[new M.DiffChange(r+1,a-(r+1)+1,s+1,v-(s+1)+1)]:m=this.ComputeDiffRecursive(r+1,a,s+1,v,E),this.ConcatenateChanges(f,m)}return[new M.DiffChange(g,a-g+1,d,v-d+1)]}WALKTRACE(g,a,d,v,E,A,n,i,r,s,f,m,h,_,N,p,P,F){let R=null,y=null,q=new c,j=a,J=d,z=h[0]-p[0]-v,H=-1073741824,e=this.m_forwardHistory.length-1;do{const B=z+g;B===j||B<J&&r[B-1]<r[B+1]?(f=r[B+1],_=f-z-v,f<H&&q.MarkNextChange(),H=f,q.AddModifiedElement(f+1,_),z=B+1-g):(f=r[B-1]+1,_=f-z-v,f<H&&q.MarkNextChange(),H=f-1,q.AddOriginalElement(f,_+1),z=B-1-g),e>=0&&(r=this.m_forwardHistory[e],g=r[0],j=1,J=r.length-1)}while(--e>=-1);if(R=q.getReverseChanges(),F[0]){let B=h[0]+1,W=p[0]+1;if(R!==null&&R.length>0){const V=R[R.length-1];B=Math.max(B,V.getOriginalEnd()),W=Math.max(W,V.getModifiedEnd())}y=[new M.DiffChange(B,m-B+1,W,N-W+1)]}else{q=new c,j=A,J=n,z=h[0]-p[0]-i,H=1073741824,e=P?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const B=z+E;B===j||B<J&&s[B-1]>=s[B+1]?(f=s[B+1]-1,_=f-z-i,f>H&&q.MarkNextChange(),H=f+1,q.AddOriginalElement(f+1,_+1),z=B+1-E):(f=s[B-1],_=f-z-i,f>H&&q.MarkNextChange(),H=f,q.AddModifiedElement(f+1,_+1),z=B-1-E),e>=0&&(s=this.m_reverseHistory[e],E=s[0],j=1,J=s.length-1)}while(--e>=-1);y=q.getChanges()}return this.ConcatenateChanges(R,y)}ComputeRecursionPoint(g,a,d,v,E,A,n){let i=0,r=0,s=0,f=0,m=0,h=0;g--,d--,E[0]=0,A[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const _=a-g+(v-d),N=_+1,p=new Int32Array(N),P=new Int32Array(N),F=v-d,R=a-g,y=g-d,q=a-v,J=(R-F)%2==0;p[F]=g,P[R]=a,n[0]=!1;for(let z=1;z<=_/2+1;z++){let H=0,e=0;s=this.ClipDiagonalBound(F-z,z,F,N),f=this.ClipDiagonalBound(F+z,z,F,N);for(let W=s;W<=f;W+=2){W===s||W<f&&p[W-1]<p[W+1]?i=p[W+1]:i=p[W-1]+1,r=i-(W-F)-y;const V=i;for(;i<a&&r<v&&this.ElementsAreEqual(i+1,r+1);)i++,r++;if(p[W]=i,i+r>H+e&&(H=i,e=r),!J&&Math.abs(W-R)<=z-1&&i>=P[W])return E[0]=i,A[0]=r,V<=P[W]&&1447>0&&z<=1447+1?this.WALKTRACE(F,s,f,y,R,m,h,q,p,P,i,a,E,r,v,A,J,n):null}const B=(H-g+(e-d)-z)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(H,B))return n[0]=!0,E[0]=H,A[0]=e,B>0&&1447>0&&z<=1447+1?this.WALKTRACE(F,s,f,y,R,m,h,q,p,P,i,a,E,r,v,A,J,n):(g++,d++,[new M.DiffChange(g,a-g+1,d,v-d+1)]);m=this.ClipDiagonalBound(R-z,z,R,N),h=this.ClipDiagonalBound(R+z,z,R,N);for(let W=m;W<=h;W+=2){W===m||W<h&&P[W-1]>=P[W+1]?i=P[W+1]-1:i=P[W-1],r=i-(W-R)-q;const V=i;for(;i>g&&r>d&&this.ElementsAreEqual(i,r);)i--,r--;if(P[W]=i,J&&Math.abs(W-F)<=z&&i<=p[W])return E[0]=i,A[0]=r,V>=p[W]&&1447>0&&z<=1447+1?this.WALKTRACE(F,s,f,y,R,m,h,q,p,P,i,a,E,r,v,A,J,n):null}if(z<=1447){let W=new Int32Array(f-s+2);W[0]=F-s+1,u.Copy2(p,s,W,1,f-s+1),this.m_forwardHistory.push(W),W=new Int32Array(h-m+2),W[0]=R-m+1,u.Copy2(P,m,W,1,h-m+1),this.m_reverseHistory.push(W)}}return this.WALKTRACE(F,s,f,y,R,m,h,q,p,P,i,a,E,r,v,A,J,n)}PrettifyChanges(g){for(let a=0;a<g.length;a++){const d=g[a],v=a<g.length-1?g[a+1].originalStart:this._originalElementsOrHash.length,E=a<g.length-1?g[a+1].modifiedStart:this._modifiedElementsOrHash.length,A=d.originalLength>0,n=d.modifiedLength>0;for(;d.originalStart+d.originalLength<v&&d.modifiedStart+d.modifiedLength<E&&(!A||this.OriginalElementsAreEqual(d.originalStart,d.originalStart+d.originalLength))&&(!n||this.ModifiedElementsAreEqual(d.modifiedStart,d.modifiedStart+d.modifiedLength));){const r=this.ElementsAreStrictEqual(d.originalStart,d.modifiedStart);if(this.ElementsAreStrictEqual(d.originalStart+d.originalLength,d.modifiedStart+d.modifiedLength)&&!r)break;d.originalStart++,d.modifiedStart++}let i=[null];if(a<g.length-1&&this.ChangesOverlap(g[a],g[a+1],i)){g[a]=i[0],g.splice(a+1,1),a--;continue}}for(let a=g.length-1;a>=0;a--){const d=g[a];let v=0,E=0;if(a>0){const f=g[a-1];v=f.originalStart+f.originalLength,E=f.modifiedStart+f.modifiedLength}const A=d.originalLength>0,n=d.modifiedLength>0;let i=0,r=this._boundaryScore(d.originalStart,d.originalLength,d.modifiedStart,d.modifiedLength);for(let f=1;;f++){const m=d.originalStart-f,h=d.modifiedStart-f;if(m<v||h<E||A&&!this.OriginalElementsAreEqual(m,m+d.originalLength)||n&&!this.ModifiedElementsAreEqual(h,h+d.modifiedLength))break;const N=(m===v&&h===E?5:0)+this._boundaryScore(m,d.originalLength,h,d.modifiedLength);N>r&&(r=N,i=f)}d.originalStart-=i,d.modifiedStart-=i;const s=[null];if(a>0&&this.ChangesOverlap(g[a-1],g[a],s)){g[a-1]=s[0],g.splice(a,1),a++;continue}}if(this._hasStrings)for(let a=1,d=g.length;a<d;a++){const v=g[a-1],E=g[a],A=E.originalStart-v.originalStart-v.originalLength,n=v.originalStart,i=E.originalStart+E.originalLength,r=i-n,s=v.modifiedStart,f=E.modifiedStart+E.modifiedLength,m=f-s;if(A<5&&r<20&&m<20){const h=this._findBetterContiguousSequence(n,r,s,m,A);if(h){const[_,N]=h;(_!==v.originalStart+v.originalLength||N!==v.modifiedStart+v.modifiedLength)&&(v.originalLength=_-v.originalStart,v.modifiedLength=N-v.modifiedStart,E.originalStart=_+A,E.modifiedStart=N+A,E.originalLength=i-E.originalStart,E.modifiedLength=f-E.modifiedStart)}}}return g}_findBetterContiguousSequence(g,a,d,v,E){if(a<E||v<E)return null;const A=g+a-E+1,n=d+v-E+1;let i=0,r=0,s=0;for(let f=g;f<A;f++)for(let m=d;m<n;m++){const h=this._contiguousSequenceScore(f,m,E);h>0&&h>i&&(i=h,r=f,s=m)}return i>0?[r,s]:null}_contiguousSequenceScore(g,a,d){let v=0;for(let E=0;E<d;E++){if(!this.ElementsAreEqual(g+E,a+E))return 0;v+=this._originalStringElements[g+E].length}return v}_OriginalIsBoundary(g){return g<=0||g>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[g])}_OriginalRegionIsBoundary(g,a){if(this._OriginalIsBoundary(g)||this._OriginalIsBoundary(g-1))return!0;if(a>0){const d=g+a;if(this._OriginalIsBoundary(d-1)||this._OriginalIsBoundary(d))return!0}return!1}_ModifiedIsBoundary(g){return g<=0||g>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[g])}_ModifiedRegionIsBoundary(g,a){if(this._ModifiedIsBoundary(g)||this._ModifiedIsBoundary(g-1))return!0;if(a>0){const d=g+a;if(this._ModifiedIsBoundary(d-1)||this._ModifiedIsBoundary(d))return!0}return!1}_boundaryScore(g,a,d,v){const E=this._OriginalRegionIsBoundary(g,a)?1:0,A=this._ModifiedRegionIsBoundary(d,v)?1:0;return E+A}ConcatenateChanges(g,a){let d=[];if(g.length===0||a.length===0)return a.length>0?a:g;if(this.ChangesOverlap(g[g.length-1],a[0],d)){const v=new Array(g.length+a.length-1);return u.Copy(g,0,v,0,g.length-1),v[g.length-1]=d[0],u.Copy(a,1,v,g.length,a.length-1),v}else{const v=new Array(g.length+a.length);return u.Copy(g,0,v,0,g.length),u.Copy(a,0,v,g.length,a.length),v}}ChangesOverlap(g,a,d){if(S.Assert(g.originalStart<=a.originalStart,"Left change is not less than or equal to right change"),S.Assert(g.modifiedStart<=a.modifiedStart,"Left change is not less than or equal to right change"),g.originalStart+g.originalLength>=a.originalStart||g.modifiedStart+g.modifiedLength>=a.modifiedStart){const v=g.originalStart;let E=g.originalLength;const A=g.modifiedStart;let n=g.modifiedLength;return g.originalStart+g.originalLength>=a.originalStart&&(E=a.originalStart+a.originalLength-g.originalStart),g.modifiedStart+g.modifiedLength>=a.modifiedStart&&(n=a.modifiedStart+a.modifiedLength-g.modifiedStart),d[0]=new M.DiffChange(v,E,A,n),!0}else return d[0]=null,!1}ClipDiagonalBound(g,a,d,v){if(g>=0&&g<v)return g;const E=d,A=v-d-1,n=a%2==0;if(g<0){const i=E%2==0;return n===i?0:1}else{const i=A%2==0;return n===i?v-1:v-2}}}t.LcsDiff=b}),G(Q[12],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.assertNever=t.NotImplementedProxy=t.withUndefinedAsNull=t.withNullAsUndefined=t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isObject=t.isStringArray=t.isString=t.isArray=void 0;function M(P){return Array.isArray(P)}t.isArray=M;function U(P){return typeof P=="string"}t.isString=U;function C(P){return Array.isArray(P)&&P.every(F=>U(F))}t.isStringArray=C;function l(P){return typeof P=="object"&&P!==null&&!Array.isArray(P)&&!(P instanceof RegExp)&&!(P instanceof Date)}t.isObject=l;function S(P){return typeof P=="number"&&!isNaN(P)}t.isNumber=S;function u(P){return!!P&&typeof P[Symbol.iterator]=="function"}t.isIterable=u;function o(P){return P===!0||P===!1}t.isBoolean=o;function c(P){return typeof P=="undefined"}t.isUndefined=c;function b(P){return!w(P)}t.isDefined=b;function w(P){return c(P)||P===null}t.isUndefinedOrNull=w;function g(P,F){if(!P)throw new Error(F?`Unexpected type, expected '${F}'`:"Unexpected type")}t.assertType=g;function a(P){if(w(P))throw new Error("Assertion Failed: argument is undefined or null");return P}t.assertIsDefined=a;function d(...P){const F=[];for(let R=0;R<P.length;R++){const y=P[R];if(w(y))throw new Error(`Assertion Failed: argument at index ${R} is undefined or null`);F.push(y)}return F}t.assertAllDefined=d;const v=Object.prototype.hasOwnProperty;function E(P){if(!l(P))return!1;for(let F in P)if(v.call(P,F))return!1;return!0}t.isEmptyObject=E;function A(P){return typeof P=="function"}t.isFunction=A;function n(...P){return P.length>0&&P.every(A)}t.areFunctions=n;function i(P,F){const R=Math.min(P.length,F.length);for(let y=0;y<R;y++)r(P[y],F[y])}t.validateConstraints=i;function r(P,F){if(U(F)){if(typeof P!==F)throw new Error(`argument does not match constraint: typeof ${F}`)}else if(A(F)){try{if(P instanceof F)return}catch(R){}if(!w(P)&&P.constructor===F||F.length===1&&F.call(void 0,P)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=r;function s(P){let F=[],R=Object.getPrototypeOf(P);for(;Object.prototype!==R;)F=F.concat(Object.getOwnPropertyNames(R)),R=Object.getPrototypeOf(R);return F}t.getAllPropertyNames=s;function f(P){const F=[];for(const R of s(P))typeof P[R]=="function"&&F.push(R);return F}t.getAllMethodNames=f;function m(P,F){const R=q=>function(){const j=Array.prototype.slice.call(arguments,0);return F(q,j)};let y={};for(const q of P)y[q]=R(q);return y}t.createProxyObject=m;function h(P){return P===null?void 0:P}t.withNullAsUndefined=h;function _(P){return typeof P=="undefined"?null:P}t.withUndefinedAsNull=_;function N(P){return class{constructor(){return new Proxy({},{get(F,R){if(F[R])return F[R];throw new Error(`Not Implemented: ${P}->${String(R)}`)}})}}}t.NotImplementedProxy=N;function p(P){throw new Error("Unreachable")}t.assertNever=p}),G(Q[13],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var M;(function(l){l[l.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",l[l.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",l[l.MAX_UINT_8=255]="MAX_UINT_8",l[l.MAX_UINT_16=65535]="MAX_UINT_16",l[l.MAX_UINT_32=4294967295]="MAX_UINT_32",l[l.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(M=t.Constants||(t.Constants={}));function U(l){return l<0?0:l>255?255:l|0}t.toUint8=U;function C(l){return l<0?0:l>4294967295?4294967295:l|0}t.toUint32=C}),G(Q[14],X([0,1,2,20]),function(I,t,M,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const C=/^\w[\w\d+.-]*$/,l=/^\//,S=/^\/\//;function u(h,_){if(!h.scheme&&_)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!C.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!l.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function o(h,_){return!h&&!_?"file":h}function c(h,_){switch(h){case"https":case"http":case"file":_?_[0]!==w&&(_=w+_):_=w;break}return _}const b="",w="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{constructor(_,N,p,P,F,R=!1){typeof _=="object"?(this.scheme=_.scheme||b,this.authority=_.authority||b,this.path=_.path||b,this.query=_.query||b,this.fragment=_.fragment||b):(this.scheme=o(_,R),this.authority=N||b,this.path=c(this.scheme,p||b),this.query=P||b,this.fragment=F||b,u(this,R))}static isUri(_){return _ instanceof a?!0:_?typeof _.authority=="string"&&typeof _.fragment=="string"&&typeof _.path=="string"&&typeof _.query=="string"&&typeof _.scheme=="string"&&typeof _.fsPath=="string"&&typeof _.with=="function"&&typeof _.toString=="function":!1}get fsPath(){return i(this,!1)}with(_){if(!_)return this;let{scheme:N,authority:p,path:P,query:F,fragment:R}=_;return N===void 0?N=this.scheme:N===null&&(N=b),p===void 0?p=this.authority:p===null&&(p=b),P===void 0?P=this.path:P===null&&(P=b),F===void 0?F=this.query:F===null&&(F=b),R===void 0?R=this.fragment:R===null&&(R=b),N===this.scheme&&p===this.authority&&P===this.path&&F===this.query&&R===this.fragment?this:new v(N,p,P,F,R)}static parse(_,N=!1){const p=g.exec(_);return p?new v(p[2]||b,m(p[4]||b),m(p[5]||b),m(p[7]||b),m(p[9]||b),N):new v(b,b,b,b,b)}static file(_){let N=b;if(M.isWindows&&(_=_.replace(/\\/g,w)),_[0]===w&&_[1]===w){const p=_.indexOf(w,2);p===-1?(N=_.substring(2),_=w):(N=_.substring(2,p),_=_.substring(p)||w)}return new v("file",N,_,b,b)}static from(_){const N=new v(_.scheme,_.authority,_.path,_.query,_.fragment);return u(N,!0),N}static joinPath(_,...N){if(!_.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return M.isWindows&&_.scheme==="file"?p=a.file(U.win32.join(i(_,!0),...N)).path:p=U.posix.join(_.path,...N),_.with({path:p})}toString(_=!1){return r(this,_)}toJSON(){return this}static revive(_){if(_){if(_ instanceof a)return _;{const N=new v(_);return N._formatted=_.external,N._fsPath=_._sep===d?_.fsPath:null,N}}else return _}}t.URI=a;const d=M.isWindows?1:void 0;class v extends a{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(_=!1){return _?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const _={$mid:1};return this._fsPath&&(_.fsPath=this._fsPath,_._sep=d),this._formatted&&(_.external=this._formatted),this.path&&(_.path=this.path),this.scheme&&(_.scheme=this.scheme),this.authority&&(_.authority=this.authority),this.query&&(_.query=this.query),this.fragment&&(_.fragment=this.fragment),_}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function A(h,_){let N,p=-1;for(let P=0;P<h.length;P++){const F=h.charCodeAt(P);if(F>=97&&F<=122||F>=65&&F<=90||F>=48&&F<=57||F===45||F===46||F===95||F===126||_&&F===47)p!==-1&&(N+=encodeURIComponent(h.substring(p,P)),p=-1),N!==void 0&&(N+=h.charAt(P));else{N===void 0&&(N=h.substr(0,P));const R=E[F];R!==void 0?(p!==-1&&(N+=encodeURIComponent(h.substring(p,P)),p=-1),N+=R):p===-1&&(p=P)}}return p!==-1&&(N+=encodeURIComponent(h.substring(p))),N!==void 0?N:h}function n(h){let _;for(let N=0;N<h.length;N++){const p=h.charCodeAt(N);p===35||p===63?(_===void 0&&(_=h.substr(0,N)),_+=E[p]):_!==void 0&&(_+=h[N])}return _!==void 0?_:h}function i(h,_){let N;return h.authority&&h.path.length>1&&h.scheme==="file"?N=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===47&&(h.path.charCodeAt(1)>=65&&h.path.charCodeAt(1)<=90||h.path.charCodeAt(1)>=97&&h.path.charCodeAt(1)<=122)&&h.path.charCodeAt(2)===58?_?N=h.path.substr(1):N=h.path[1].toLowerCase()+h.path.substr(2):N=h.path,M.isWindows&&(N=N.replace(/\//g,"\\")),N}t.uriToFsPath=i;function r(h,_){const N=_?n:A;let p="",{scheme:P,authority:F,path:R,query:y,fragment:q}=h;if(P&&(p+=P,p+=":"),(F||P==="file")&&(p+=w,p+=w),F){let j=F.indexOf("@");if(j!==-1){const J=F.substr(0,j);F=F.substr(j+1),j=J.indexOf(":"),j===-1?p+=N(J,!1):(p+=N(J.substr(0,j),!1),p+=":",p+=N(J.substr(j+1),!1)),p+="@"}F=F.toLowerCase(),j=F.indexOf(":"),j===-1?p+=N(F,!1):(p+=N(F.substr(0,j),!1),p+=F.substr(j))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const j=R.charCodeAt(1);j>=65&&j<=90&&(R=`/${String.fromCharCode(j+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const j=R.charCodeAt(0);j>=65&&j<=90&&(R=`${String.fromCharCode(j+32)}:${R.substr(2)}`)}p+=N(R,!0)}return y&&(p+="?",p+=N(y,!1)),q&&(p+="#",p+=_?q:A(q,!1)),p}function s(h){try{return decodeURIComponent(h)}catch(_){return h.length>3?h.substr(0,3)+s(h.substr(3)):h}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function m(h){return h.match(f)?h.replace(f,_=>s(_)):h}}),G(Q[34],X([0,1,4,8,2,12]),function(I,t,M,U,C,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const S="$initialize";let u=!1;function o(a){!C.isWeb||(u||(u=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(a.message))}t.logOnceWebWorkerWarning=o;class c{constructor(d){this._workerId=-1,this._handler=d,this._lastSentReq=0,this._pendingReplies=Object.create(null)}setWorkerId(d){this._workerId=d}sendMessage(d,v){let E=String(++this._lastSentReq);return new Promise((A,n)=>{this._pendingReplies[E]={resolve:A,reject:n},this._send({vsWorker:this._workerId,req:E,method:d,args:v})})}handleMessage(d){!d||!d.vsWorker||this._workerId!==-1&&d.vsWorker!==this._workerId||this._handleMessage(d)}_handleMessage(d){if(d.seq){let n=d;if(!this._pendingReplies[n.seq]){console.warn("Got reply to unknown seq");return}let i=this._pendingReplies[n.seq];if(delete this._pendingReplies[n.seq],n.err){let r=n.err;n.err.$isError&&(r=new Error,r.name=n.err.name,r.message=n.err.message,r.stack=n.err.stack),i.reject(r);return}i.resolve(n.res);return}let v=d,E=v.req;this._handler.handleMessage(v.method,v.args).then(n=>{this._send({vsWorker:this._workerId,seq:E,res:n,err:void 0})},n=>{n.detail instanceof Error&&(n.detail=M.transformErrorForSerialization(n.detail)),this._send({vsWorker:this._workerId,seq:E,res:void 0,err:M.transformErrorForSerialization(n)})})}_send(d){let v=[];if(d.req){const E=d;for(let A=0;A<E.args.length;A++)E.args[A]instanceof ArrayBuffer&&v.push(E.args[A])}else{const E=d;E.res instanceof ArrayBuffer&&v.push(E.res)}this._handler.sendMessage(d,v)}}class b extends U.Disposable{constructor(d,v,E){super();let A=null;this._worker=this._register(d.create("vs/base/common/worker/simpleWorker",s=>{this._protocol.handleMessage(s)},s=>{A&&A(s)})),this._protocol=new c({sendMessage:(s,f)=>{this._worker.postMessage(s,f)},handleMessage:(s,f)=>{if(typeof E[s]!="function")return Promise.reject(new Error("Missing method "+s+" on main thread host."));try{return Promise.resolve(E[s].apply(E,f))}catch(m){return Promise.reject(m)}}}),this._protocol.setWorkerId(this._worker.getId());let n=null;typeof self.require!="undefined"&&typeof self.require.getConfig=="function"?n=self.require.getConfig():typeof self.requirejs!="undefined"&&(n=self.requirejs.s.contexts._.config);const i=l.getAllMethodNames(E);this._onModuleLoaded=this._protocol.sendMessage(S,[this._worker.getId(),JSON.parse(JSON.stringify(n)),v,i]);const r=(s,f)=>this._request(s,f);this._lazyProxy=new Promise((s,f)=>{A=f,this._onModuleLoaded.then(m=>{s(l.createProxyObject(m,r))},m=>{f(m),this._onError("Worker failed to load "+v,m)})})}getProxyObject(){return this._lazyProxy}_request(d,v){return new Promise((E,A)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(d,v).then(E,A)},A)})}_onError(d,v){console.error(d),console.info(v)}}t.SimpleWorkerClient=b;class w{constructor(d,v){this._requestHandlerFactory=v,this._requestHandler=null,this._protocol=new c({sendMessage:(E,A)=>{d(E,A)},handleMessage:(E,A)=>this._handleMessage(E,A)})}onmessage(d){this._protocol.handleMessage(d)}_handleMessage(d,v){if(d===S)return this.initialize(v[0],v[1],v[2],v[3]);if(!this._requestHandler||typeof this._requestHandler[d]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+d));try{return Promise.resolve(this._requestHandler[d].apply(this._requestHandler,v))}catch(E){return Promise.reject(E)}}initialize(d,v,E,A){this._protocol.setWorkerId(d);const n=(r,s)=>this._protocol.sendMessage(r,s),i=l.createProxyObject(A,n);return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(i),Promise.resolve(l.getAllMethodNames(this._requestHandler))):(v&&(typeof v.baseUrl!="undefined"&&delete v.baseUrl,typeof v.paths!="undefined"&&typeof v.paths.vs!="undefined"&&delete v.paths.vs,typeof v.trustedTypesPolicy!==void 0&&delete v.trustedTypesPolicy,v.catchError=!0,self.require.config(v)),new Promise((r,s)=>{self.require([E],f=>{if(this._requestHandler=f.create(i),!this._requestHandler){s(new Error("No RequestHandler!"));return}r(l.getAllMethodNames(this._requestHandler))},s)}))}}t.SimpleWorkerServer=w;function g(a){return new w(a,null)}t.create=g}),G(Q[23],X([0,1,13]),function(I,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class U{constructor(u){let o=M.toUint8(u);this._defaultValue=o,this._asciiMap=U._createAsciiMap(o),this._map=new Map}static _createAsciiMap(u){let o=new Uint8Array(256);for(let c=0;c<256;c++)o[c]=u;return o}set(u,o){let c=M.toUint8(o);u>=0&&u<256?this._asciiMap[u]=c:this._map.set(u,c)}get(u){return u>=0&&u<256?this._asciiMap[u]:this._map.get(u)||this._defaultValue}}t.CharacterClassifier=U;var C;(function(S){S[S.False=0]="False",S[S.True=1]="True"})(C||(C={}));class l{constructor(){this._actual=new U(0)}add(u){this._actual.set(u,1)}has(u){return this._actual.get(u)===1}}t.CharacterSet=l}),G(Q[3],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class M{constructor(C,l){this.lineNumber=C,this.column=l}with(C=this.lineNumber,l=this.column){return C===this.lineNumber&&l===this.column?this:new M(C,l)}delta(C=0,l=0){return this.with(this.lineNumber+C,this.column+l)}equals(C){return M.equals(this,C)}static equals(C,l){return!C&&!l?!0:!!C&&!!l&&C.lineNumber===l.lineNumber&&C.column===l.column}isBefore(C){return M.isBefore(this,C)}static isBefore(C,l){return C.lineNumber<l.lineNumber?!0:l.lineNumber<C.lineNumber?!1:C.column<l.column}isBeforeOrEqual(C){return M.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,l){return C.lineNumber<l.lineNumber?!0:l.lineNumber<C.lineNumber?!1:C.column<=l.column}static compare(C,l){let S=C.lineNumber|0,u=l.lineNumber|0;if(S===u){let o=C.column|0,c=l.column|0;return o-c}return S-u}clone(){return new M(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new M(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}t.Position=M}),G(Q[6],X([0,1,3]),function(I,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class U{constructor(l,S,u,o){l>u||l===u&&S>o?(this.startLineNumber=u,this.startColumn=o,this.endLineNumber=l,this.endColumn=S):(this.startLineNumber=l,this.startColumn=S,this.endLineNumber=u,this.endColumn=o)}isEmpty(){return U.isEmpty(this)}static isEmpty(l){return l.startLineNumber===l.endLineNumber&&l.startColumn===l.endColumn}containsPosition(l){return U.containsPosition(this,l)}static containsPosition(l,S){return!(S.lineNumber<l.startLineNumber||S.lineNumber>l.endLineNumber||S.lineNumber===l.startLineNumber&&S.column<l.startColumn||S.lineNumber===l.endLineNumber&&S.column>l.endColumn)}containsRange(l){return U.containsRange(this,l)}static containsRange(l,S){return!(S.startLineNumber<l.startLineNumber||S.endLineNumber<l.startLineNumber||S.startLineNumber>l.endLineNumber||S.endLineNumber>l.endLineNumber||S.startLineNumber===l.startLineNumber&&S.startColumn<l.startColumn||S.endLineNumber===l.endLineNumber&&S.endColumn>l.endColumn)}strictContainsRange(l){return U.strictContainsRange(this,l)}static strictContainsRange(l,S){return!(S.startLineNumber<l.startLineNumber||S.endLineNumber<l.startLineNumber||S.startLineNumber>l.endLineNumber||S.endLineNumber>l.endLineNumber||S.startLineNumber===l.startLineNumber&&S.startColumn<=l.startColumn||S.endLineNumber===l.endLineNumber&&S.endColumn>=l.endColumn)}plusRange(l){return U.plusRange(this,l)}static plusRange(l,S){let u,o,c,b;return S.startLineNumber<l.startLineNumber?(u=S.startLineNumber,o=S.startColumn):S.startLineNumber===l.startLineNumber?(u=S.startLineNumber,o=Math.min(S.startColumn,l.startColumn)):(u=l.startLineNumber,o=l.startColumn),S.endLineNumber>l.endLineNumber?(c=S.endLineNumber,b=S.endColumn):S.endLineNumber===l.endLineNumber?(c=S.endLineNumber,b=Math.max(S.endColumn,l.endColumn)):(c=l.endLineNumber,b=l.endColumn),new U(u,o,c,b)}intersectRanges(l){return U.intersectRanges(this,l)}static intersectRanges(l,S){let u=l.startLineNumber,o=l.startColumn,c=l.endLineNumber,b=l.endColumn,w=S.startLineNumber,g=S.startColumn,a=S.endLineNumber,d=S.endColumn;return u<w?(u=w,o=g):u===w&&(o=Math.max(o,g)),c>a?(c=a,b=d):c===a&&(b=Math.min(b,d)),u>c||u===c&&o>b?null:new U(u,o,c,b)}equalsRange(l){return U.equalsRange(this,l)}static equalsRange(l,S){return!!l&&!!S&&l.startLineNumber===S.startLineNumber&&l.startColumn===S.startColumn&&l.endLineNumber===S.endLineNumber&&l.endColumn===S.endColumn}getEndPosition(){return U.getEndPosition(this)}static getEndPosition(l){return new M.Position(l.endLineNumber,l.endColumn)}getStartPosition(){return U.getStartPosition(this)}static getStartPosition(l){return new M.Position(l.startLineNumber,l.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(l,S){return new U(this.startLineNumber,this.startColumn,l,S)}setStartPosition(l,S){return new U(l,S,this.endLineNumber,this.endColumn)}collapseToStart(){return U.collapseToStart(this)}static collapseToStart(l){return new U(l.startLineNumber,l.startColumn,l.startLineNumber,l.startColumn)}static fromPositions(l,S=l){return new U(l.lineNumber,l.column,S.lineNumber,S.column)}static lift(l){return l?new U(l.startLineNumber,l.startColumn,l.endLineNumber,l.endColumn):null}static isIRange(l){return l&&typeof l.startLineNumber=="number"&&typeof l.startColumn=="number"&&typeof l.endLineNumber=="number"&&typeof l.endColumn=="number"}static areIntersectingOrTouching(l,S){return!(l.endLineNumber<S.startLineNumber||l.endLineNumber===S.startLineNumber&&l.endColumn<S.startColumn||S.endLineNumber<l.startLineNumber||S.endLineNumber===l.startLineNumber&&S.endColumn<l.startColumn)}static areIntersecting(l,S){return!(l.endLineNumber<S.startLineNumber||l.endLineNumber===S.startLineNumber&&l.endColumn<=S.startColumn||S.endLineNumber<l.startLineNumber||S.endLineNumber===l.startLineNumber&&S.endColumn<=l.startColumn)}static compareRangesUsingStarts(l,S){if(l&&S){const c=l.startLineNumber|0,b=S.startLineNumber|0;if(c===b){const w=l.startColumn|0,g=S.startColumn|0;if(w===g){const a=l.endLineNumber|0,d=S.endLineNumber|0;if(a===d){const v=l.endColumn|0,E=S.endColumn|0;return v-E}return a-d}return w-g}return c-b}return(l?1:0)-(S?1:0)}static compareRangesUsingEnds(l,S){return l.endLineNumber===S.endLineNumber?l.endColumn===S.endColumn?l.startLineNumber===S.startLineNumber?l.startColumn-S.startColumn:l.startLineNumber-S.startLineNumber:l.endColumn-S.endColumn:l.endLineNumber-S.endLineNumber}static spansMultipleLines(l){return l.endLineNumber>l.startLineNumber}}t.Range=U}),G(Q[24],X([0,1,3,6]),function(I,t,M,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var C;(function(S){S[S.LTR=0]="LTR",S[S.RTL=1]="RTL"})(C=t.SelectionDirection||(t.SelectionDirection={}));class l extends U.Range{constructor(u,o,c,b){super(u,o,c,b);this.selectionStartLineNumber=u,this.selectionStartColumn=o,this.positionLineNumber=c,this.positionColumn=b}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(u){return l.selectionsEqual(this,u)}static selectionsEqual(u,o){return u.selectionStartLineNumber===o.selectionStartLineNumber&&u.selectionStartColumn===o.selectionStartColumn&&u.positionLineNumber===o.positionLineNumber&&u.positionColumn===o.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(u,o){return this.getDirection()===0?new l(this.startLineNumber,this.startColumn,u,o):new l(u,o,this.startLineNumber,this.startColumn)}getPosition(){return new M.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(u,o){return this.getDirection()===0?new l(u,o,this.endLineNumber,this.endColumn):new l(this.endLineNumber,this.endColumn,u,o)}static fromPositions(u,o=u){return new l(u.lineNumber,u.column,o.lineNumber,o.column)}static liftSelection(u){return new l(u.selectionStartLineNumber,u.selectionStartColumn,u.positionLineNumber,u.positionColumn)}static selectionsArrEqual(u,o){if(u&&!o||!u&&o)return!1;if(!u&&!o)return!0;if(u.length!==o.length)return!1;for(let c=0,b=u.length;c<b;c++)if(!this.selectionsEqual(u[c],o[c]))return!1;return!0}static isISelection(u){return u&&typeof u.selectionStartLineNumber=="number"&&typeof u.selectionStartColumn=="number"&&typeof u.positionLineNumber=="number"&&typeof u.positionColumn=="number"}static createWithDirection(u,o,c,b,w){return w===0?new l(u,o,c,b):new l(c,b,u,o)}}t.Selection=l}),G(Q[25],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationResult2=t.TokenizationResult=t.Token=void 0;class M{constructor(S,u,o){this.offset=S|0,this.type=u,this.language=o}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=M;class U{constructor(S,u){this.tokens=S,this.endState=u}}t.TokenizationResult=U;class C{constructor(S,u){this.tokens=S,this.endState=u}}t.TokenizationResult2=C}),G(Q[26],X([0,1,11,5]),function(I,t,M,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=void 0;const C=3;function l(v,E,A,n){return new M.LcsDiff(v,E,A).ComputeDiff(n)}class S{constructor(E){const A=[],n=[];for(let i=0,r=E.length;i<r;i++)A[i]=g(E[i],1),n[i]=a(E[i],1);this.lines=E,this._startColumns=A,this._endColumns=n}getElements(){const E=[];for(let A=0,n=this.lines.length;A<n;A++)E[A]=this.lines[A].substring(this._startColumns[A]-1,this._endColumns[A]-1);return E}getStrictElement(E){return this.lines[E]}getStartLineNumber(E){return E+1}getEndLineNumber(E){return E+1}createCharSequence(E,A,n){const i=[],r=[],s=[];let f=0;for(let m=A;m<=n;m++){const h=this.lines[m],_=E?this._startColumns[m]:1,N=E?this._endColumns[m]:h.length+1;for(let p=_;p<N;p++)i[f]=h.charCodeAt(p-1),r[f]=m+1,s[f]=p,f++}return new u(i,r,s)}}class u{constructor(E,A,n){this._charCodes=E,this._lineNumbers=A,this._columns=n}getElements(){return this._charCodes}getStartLineNumber(E){return this._lineNumbers[E]}getStartColumn(E){return this._columns[E]}getEndLineNumber(E){return this._lineNumbers[E]}getEndColumn(E){return this._columns[E]+1}}class o{constructor(E,A,n,i,r,s,f,m){this.originalStartLineNumber=E,this.originalStartColumn=A,this.originalEndLineNumber=n,this.originalEndColumn=i,this.modifiedStartLineNumber=r,this.modifiedStartColumn=s,this.modifiedEndLineNumber=f,this.modifiedEndColumn=m}static createFromDiffChange(E,A,n){let i,r,s,f,m,h,_,N;return E.originalLength===0?(i=0,r=0,s=0,f=0):(i=A.getStartLineNumber(E.originalStart),r=A.getStartColumn(E.originalStart),s=A.getEndLineNumber(E.originalStart+E.originalLength-1),f=A.getEndColumn(E.originalStart+E.originalLength-1)),E.modifiedLength===0?(m=0,h=0,_=0,N=0):(m=n.getStartLineNumber(E.modifiedStart),h=n.getStartColumn(E.modifiedStart),_=n.getEndLineNumber(E.modifiedStart+E.modifiedLength-1),N=n.getEndColumn(E.modifiedStart+E.modifiedLength-1)),new o(i,r,s,f,m,h,_,N)}}function c(v){if(v.length<=1)return v;const E=[v[0]];let A=E[0];for(let n=1,i=v.length;n<i;n++){const r=v[n],s=r.originalStart-(A.originalStart+A.originalLength),f=r.modifiedStart-(A.modifiedStart+A.modifiedLength);Math.min(s,f)<C?(A.originalLength=r.originalStart+r.originalLength-A.originalStart,A.modifiedLength=r.modifiedStart+r.modifiedLength-A.modifiedStart):(E.push(r),A=r)}return E}class b{constructor(E,A,n,i,r){this.originalStartLineNumber=E,this.originalEndLineNumber=A,this.modifiedStartLineNumber=n,this.modifiedEndLineNumber=i,this.charChanges=r}static createFromDiffResult(E,A,n,i,r,s,f){let m,h,_,N,p;if(A.originalLength===0?(m=n.getStartLineNumber(A.originalStart)-1,h=0):(m=n.getStartLineNumber(A.originalStart),h=n.getEndLineNumber(A.originalStart+A.originalLength-1)),A.modifiedLength===0?(_=i.getStartLineNumber(A.modifiedStart)-1,N=0):(_=i.getStartLineNumber(A.modifiedStart),N=i.getEndLineNumber(A.modifiedStart+A.modifiedLength-1)),s&&A.originalLength>0&&A.originalLength<20&&A.modifiedLength>0&&A.modifiedLength<20&&r()){const P=n.createCharSequence(E,A.originalStart,A.originalStart+A.originalLength-1),F=i.createCharSequence(E,A.modifiedStart,A.modifiedStart+A.modifiedLength-1);let R=l(P,F,r,!0).changes;f&&(R=c(R)),p=[];for(let y=0,q=R.length;y<q;y++)p.push(o.createFromDiffChange(R[y],P,F))}return new b(m,h,_,N,p)}}class w{constructor(E,A,n){this.shouldComputeCharChanges=n.shouldComputeCharChanges,this.shouldPostProcessCharChanges=n.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=n.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=n.shouldMakePrettyDiff,this.originalLines=E,this.modifiedLines=A,this.original=new S(E),this.modified=new S(A),this.continueLineDiff=d(n.maxComputationTime),this.continueCharDiff=d(n.maxComputationTime===0?0:Math.min(n.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const E=l(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),A=E.changes,n=E.quitEarly;if(this.shouldIgnoreTrimWhitespace){const f=[];for(let m=0,h=A.length;m<h;m++)f.push(b.createFromDiffResult(this.shouldIgnoreTrimWhitespace,A[m],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:n,changes:f}}const i=[];let r=0,s=0;for(let f=-1,m=A.length;f<m;f++){const h=f+1<m?A[f+1]:null,_=h?h.originalStart:this.originalLines.length,N=h?h.modifiedStart:this.modifiedLines.length;for(;r<_&&s<N;){const p=this.originalLines[r],P=this.modifiedLines[s];if(p!==P){{let F=g(p,1),R=g(P,1);for(;F>1&&R>1;){const y=p.charCodeAt(F-2),q=P.charCodeAt(R-2);if(y!==q)break;F--,R--}(F>1||R>1)&&this._pushTrimWhitespaceCharChange(i,r+1,1,F,s+1,1,R)}{let F=a(p,1),R=a(P,1);const y=p.length+1,q=P.length+1;for(;F<y&&R<q;){const j=p.charCodeAt(F-1),J=p.charCodeAt(R-1);if(j!==J)break;F++,R++}(F<y||R<q)&&this._pushTrimWhitespaceCharChange(i,r+1,F,y,s+1,R,q)}}r++,s++}h&&(i.push(b.createFromDiffResult(this.shouldIgnoreTrimWhitespace,h,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),r+=h.originalLength,s+=h.modifiedLength)}return{quitEarly:n,changes:i}}_pushTrimWhitespaceCharChange(E,A,n,i,r,s,f){if(this._mergeTrimWhitespaceCharChange(E,A,n,i,r,s,f))return;let m;this.shouldComputeCharChanges&&(m=[new o(A,n,A,i,r,s,r,f)]),E.push(new b(A,A,r,r,m))}_mergeTrimWhitespaceCharChange(E,A,n,i,r,s,f){const m=E.length;if(m===0)return!1;const h=E[m-1];return h.originalEndLineNumber===0||h.modifiedEndLineNumber===0?!1:h.originalEndLineNumber+1===A&&h.modifiedEndLineNumber+1===r?(h.originalEndLineNumber=A,h.modifiedEndLineNumber=r,this.shouldComputeCharChanges&&h.charChanges&&h.charChanges.push(new o(A,n,A,i,r,s,r,f)),!0):!1}}t.DiffComputer=w;function g(v,E){const A=U.firstNonWhitespaceIndex(v);return A===-1?E:A+1}function a(v,E){const A=U.lastNonWhitespaceIndex(v);return A===-1?E:A+2}function d(v){if(v===0)return()=>!0;const E=Date.now();return()=>Date.now()-E<v}}),G(Q[27],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function M(u=""){let o="(-?\\d*\\.\\d\\w*)|([^";for(const c of t.USUAL_WORD_SEPARATORS)u.indexOf(c)>=0||(o+="\\"+c);return o+="\\s]+)",new RegExp(o,"g")}t.DEFAULT_WORD_REGEXP=M();function U(u){let o=t.DEFAULT_WORD_REGEXP;if(u&&u instanceof RegExp)if(u.global)o=u;else{let c="g";u.ignoreCase&&(c+="i"),u.multiline&&(c+="m"),u.unicode&&(c+="u"),o=new RegExp(u.source,c)}return o.lastIndex=0,o}t.ensureValidWordDefinition=U;const C={maxLen:1e3,windowSize:15,timeBudget:150};function l(u,o,c,b,w=C){if(c.length>w.maxLen){let E=u-w.maxLen/2;return E<0?E=0:b+=E,c=c.substring(E,u+w.maxLen/2),l(u,o,c,b,w)}const g=Date.now(),a=u-1-b;let d=-1,v=null;for(let E=1;!(Date.now()-g>=w.timeBudget);E++){const A=a-w.windowSize*E;o.lastIndex=Math.max(0,A);const n=S(o,c,a,d);if(!n&&v||(v=n,A<=0))break;d=A}if(v){let E={word:v[0],startColumn:b+1+v.index,endColumn:b+1+v.index+v[0].length};return o.lastIndex=0,E}return null}t.getWordAtText=l;function S(u,o,c,b){let w;for(;w=u.exec(o);){const g=w.index||0;if(g<=c&&u.lastIndex>=c)return w;if(b>0&&g>b)return null}return null}}),G(Q[28],X([0,1,23]),function(I,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.Uint8Matrix=t.State=void 0;var U;(function(a){a[a.Invalid=0]="Invalid",a[a.Start=1]="Start",a[a.H=2]="H",a[a.HT=3]="HT",a[a.HTT=4]="HTT",a[a.HTTP=5]="HTTP",a[a.F=6]="F",a[a.FI=7]="FI",a[a.FIL=8]="FIL",a[a.BeforeColon=9]="BeforeColon",a[a.AfterColon=10]="AfterColon",a[a.AlmostThere=11]="AlmostThere",a[a.End=12]="End",a[a.Accept=13]="Accept",a[a.LastKnownState=14]="LastKnownState"})(U=t.State||(t.State={}));class C{constructor(d,v,E){const A=new Uint8Array(d*v);for(let n=0,i=d*v;n<i;n++)A[n]=E;this._data=A,this.rows=d,this.cols=v}get(d,v){return this._data[d*this.cols+v]}set(d,v,E){this._data[d*this.cols+v]=E}}t.Uint8Matrix=C;class l{constructor(d){let v=0,E=0;for(let n=0,i=d.length;n<i;n++){let[r,s,f]=d[n];s>v&&(v=s),r>E&&(E=r),f>E&&(E=f)}v++,E++;let A=new C(E,v,0);for(let n=0,i=d.length;n<i;n++){let[r,s,f]=d[n];A.set(r,s,f)}this._states=A,this._maxCharCode=v}nextState(d,v){return v<0||v>=this._maxCharCode?0:this._states.get(d,v)}}t.StateMachine=l;let S=null;function u(){return S===null&&(S=new l([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),S}var o;(function(a){a[a.None=0]="None",a[a.ForceTermination=1]="ForceTermination",a[a.CannotEndIn=2]="CannotEndIn"})(o||(o={}));let c=null;function b(){if(c===null){c=new M.CharacterClassifier(0);const a=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<a.length;v++)c.set(a.charCodeAt(v),1);const d=".,;";for(let v=0;v<d.length;v++)c.set(d.charCodeAt(v),2)}return c}class w{static _createLink(d,v,E,A,n){let i=n-1;do{const r=v.charCodeAt(i);if(d.get(r)!==2)break;i--}while(i>A);if(A>0){const r=v.charCodeAt(A-1),s=v.charCodeAt(i);(r===40&&s===41||r===91&&s===93||r===123&&s===125)&&i--}return{range:{startLineNumber:E,startColumn:A+1,endLineNumber:E,endColumn:i+2},url:v.substring(A,i+1)}}static computeLinks(d,v=u()){const E=b();let A=[];for(let n=1,i=d.getLineCount();n<=i;n++){const r=d.getLineContent(n),s=r.length;let f=0,m=0,h=0,_=1,N=!1,p=!1,P=!1,F=!1;for(;f<s;){let R=!1;const y=r.charCodeAt(f);if(_===13){let q;switch(y){case 40:N=!0,q=0;break;case 41:q=N?0:1;break;case 91:P=!0,p=!0,q=0;break;case 93:P=!1,q=p?0:1;break;case 123:F=!0,q=0;break;case 125:q=F?0:1;break;case 39:q=h===34||h===96?0:1;break;case 34:q=h===39||h===96?0:1;break;case 96:q=h===39||h===34?0:1;break;case 42:q=h===42?1:0;break;case 124:q=h===124?1:0;break;case 32:q=P?0:1;break;default:q=E.get(y)}q===1&&(A.push(w._createLink(E,r,n,m,f)),R=!0)}else if(_===12){let q;y===91?(p=!0,q=0):q=E.get(y),q===1?R=!0:_=13}else _=v.nextState(_,y),_===0&&(R=!0);R&&(_=1,N=!1,p=!1,F=!1,m=f+1,h=y),f++}_===13&&A.push(w._createLink(E,r,n,m,s))}return A}}t.LinkComputer=w;function g(a){return!a||typeof a.getLineCount!="function"||typeof a.getLineContent!="function"?[]:w.computeLinks(a)}t.computeLinks=g}),G(Q[29],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class M{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(C,l,S,u,o){if(C&&l){let c=this.doNavigateValueSet(l,o);if(c)return{range:C,value:c}}if(S&&u){let c=this.doNavigateValueSet(u,o);if(c)return{range:S,value:c}}return null}doNavigateValueSet(C,l){let S=this.numberReplace(C,l);return S!==null?S:this.textReplace(C,l)}numberReplace(C,l){let S=Math.pow(10,C.length-(C.lastIndexOf(".")+1)),u=Number(C),o=parseFloat(C);return!isNaN(u)&&!isNaN(o)&&u===o?u===0&&!l?null:(u=Math.floor(u*S),u+=l?S:-S,String(u/S)):null}textReplace(C,l){return this.valueSetsReplace(this._defaultValueSet,C,l)}valueSetsReplace(C,l,S){let u=null;for(let o=0,c=C.length;u===null&&o<c;o++)u=this.valueSetReplace(C[o],l,S);return u}valueSetReplace(C,l,S){let u=C.indexOf(l);return u>=0?(u+=S?1:-1,u<0?u=C.length-1:u%=C.length,C[u]):null}}t.BasicInplaceReplace=M,M.INSTANCE=new M}),G(Q[30],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.IndentAction=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.AccessibilitySupport=void 0;var M;(function(e){e[e.Unknown=0]="Unknown",e[e.Disabled=1]="Disabled",e[e.Enabled=2]="Enabled"})(M=t.AccessibilitySupport||(t.AccessibilitySupport={}));var U;(function(e){e[e.KeepWhitespace=1]="KeepWhitespace",e[e.InsertAsSnippet=4]="InsertAsSnippet"})(U=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var C;(function(e){e[e.Method=0]="Method",e[e.Function=1]="Function",e[e.Constructor=2]="Constructor",e[e.Field=3]="Field",e[e.Variable=4]="Variable",e[e.Class=5]="Class",e[e.Struct=6]="Struct",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Event=10]="Event",e[e.Operator=11]="Operator",e[e.Unit=12]="Unit",e[e.Value=13]="Value",e[e.Constant=14]="Constant",e[e.Enum=15]="Enum",e[e.EnumMember=16]="EnumMember",e[e.Keyword=17]="Keyword",e[e.Text=18]="Text",e[e.Color=19]="Color",e[e.File=20]="File",e[e.Reference=21]="Reference",e[e.Customcolor=22]="Customcolor",e[e.Folder=23]="Folder",e[e.TypeParameter=24]="TypeParameter",e[e.User=25]="User",e[e.Issue=26]="Issue",e[e.Snippet=27]="Snippet"})(C=t.CompletionItemKind||(t.CompletionItemKind={}));var l;(function(e){e[e.Deprecated=1]="Deprecated"})(l=t.CompletionItemTag||(t.CompletionItemTag={}));var S;(function(e){e[e.Invoke=0]="Invoke",e[e.TriggerCharacter=1]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(S=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var u;(function(e){e[e.EXACT=0]="EXACT",e[e.ABOVE=1]="ABOVE",e[e.BELOW=2]="BELOW"})(u=t.ContentWidgetPositionPreference||(t.ContentWidgetPositionPreference={}));var o;(function(e){e[e.NotSet=0]="NotSet",e[e.ContentFlush=1]="ContentFlush",e[e.RecoverFromMarkers=2]="RecoverFromMarkers",e[e.Explicit=3]="Explicit",e[e.Paste=4]="Paste",e[e.Undo=5]="Undo",e[e.Redo=6]="Redo"})(o=t.CursorChangeReason||(t.CursorChangeReason={}));var c;(function(e){e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(c=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var b;(function(e){e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"})(b=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));var w;(function(e){e[e.None=0]="None",e[e.Keep=1]="Keep",e[e.Brackets=2]="Brackets",e[e.Advanced=3]="Advanced",e[e.Full=4]="Full"})(w=t.EditorAutoIndentStrategy||(t.EditorAutoIndentStrategy={}));var g;(function(e){e[e.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",e[e.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",e[e.accessibilitySupport=2]="accessibilitySupport",e[e.accessibilityPageSize=3]="accessibilityPageSize",e[e.ariaLabel=4]="ariaLabel",e[e.autoClosingBrackets=5]="autoClosingBrackets",e[e.autoClosingDelete=6]="autoClosingDelete",e[e.autoClosingOvertype=7]="autoClosingOvertype",e[e.autoClosingQuotes=8]="autoClosingQuotes",e[e.autoIndent=9]="autoIndent",e[e.automaticLayout=10]="automaticLayout",e[e.autoSurround=11]="autoSurround",e[e.codeLens=12]="codeLens",e[e.codeLensFontFamily=13]="codeLensFontFamily",e[e.codeLensFontSize=14]="codeLensFontSize",e[e.colorDecorators=15]="colorDecorators",e[e.columnSelection=16]="columnSelection",e[e.comments=17]="comments",e[e.contextmenu=18]="contextmenu",e[e.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",e[e.cursorBlinking=20]="cursorBlinking",e[e.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",e[e.cursorStyle=22]="cursorStyle",e[e.cursorSurroundingLines=23]="cursorSurroundingLines",e[e.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",e[e.cursorWidth=25]="cursorWidth",e[e.disableLayerHinting=26]="disableLayerHinting",e[e.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",e[e.domReadOnly=28]="domReadOnly",e[e.dragAndDrop=29]="dragAndDrop",e[e.emptySelectionClipboard=30]="emptySelectionClipboard",e[e.extraEditorClassName=31]="extraEditorClassName",e[e.fastScrollSensitivity=32]="fastScrollSensitivity",e[e.find=33]="find",e[e.fixedOverflowWidgets=34]="fixedOverflowWidgets",e[e.folding=35]="folding",e[e.foldingStrategy=36]="foldingStrategy",e[e.foldingHighlight=37]="foldingHighlight",e[e.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",e[e.fontFamily=39]="fontFamily",e[e.fontInfo=40]="fontInfo",e[e.fontLigatures=41]="fontLigatures",e[e.fontSize=42]="fontSize",e[e.fontWeight=43]="fontWeight",e[e.formatOnPaste=44]="formatOnPaste",e[e.formatOnType=45]="formatOnType",e[e.glyphMargin=46]="glyphMargin",e[e.gotoLocation=47]="gotoLocation",e[e.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",e[e.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",e[e.hover=50]="hover",e[e.inDiffEditor=51]="inDiffEditor",e[e.inlineSuggest=52]="inlineSuggest",e[e.letterSpacing=53]="letterSpacing",e[e.lightbulb=54]="lightbulb",e[e.lineDecorationsWidth=55]="lineDecorationsWidth",e[e.lineHeight=56]="lineHeight",e[e.lineNumbers=57]="lineNumbers",e[e.lineNumbersMinChars=58]="lineNumbersMinChars",e[e.linkedEditing=59]="linkedEditing",e[e.links=60]="links",e[e.matchBrackets=61]="matchBrackets",e[e.minimap=62]="minimap",e[e.mouseStyle=63]="mouseStyle",e[e.mouseWheelScrollSensitivity=64]="mouseWheelScrollSensitivity",e[e.mouseWheelZoom=65]="mouseWheelZoom",e[e.multiCursorMergeOverlapping=66]="multiCursorMergeOverlapping",e[e.multiCursorModifier=67]="multiCursorModifier",e[e.multiCursorPaste=68]="multiCursorPaste",e[e.occurrencesHighlight=69]="occurrencesHighlight",e[e.overviewRulerBorder=70]="overviewRulerBorder",e[e.overviewRulerLanes=71]="overviewRulerLanes",e[e.padding=72]="padding",e[e.parameterHints=73]="parameterHints",e[e.peekWidgetDefaultFocus=74]="peekWidgetDefaultFocus",e[e.definitionLinkOpensInPeek=75]="definitionLinkOpensInPeek",e[e.quickSuggestions=76]="quickSuggestions",e[e.quickSuggestionsDelay=77]="quickSuggestionsDelay",e[e.readOnly=78]="readOnly",e[e.renameOnType=79]="renameOnType",e[e.renderControlCharacters=80]="renderControlCharacters",e[e.renderIndentGuides=81]="renderIndentGuides",e[e.renderFinalNewline=82]="renderFinalNewline",e[e.renderLineHighlight=83]="renderLineHighlight",e[e.renderLineHighlightOnlyWhenFocus=84]="renderLineHighlightOnlyWhenFocus",e[e.renderValidationDecorations=85]="renderValidationDecorations",e[e.renderWhitespace=86]="renderWhitespace",e[e.revealHorizontalRightPadding=87]="revealHorizontalRightPadding",e[e.roundedSelection=88]="roundedSelection",e[e.rulers=89]="rulers",e[e.scrollbar=90]="scrollbar",e[e.scrollBeyondLastColumn=91]="scrollBeyondLastColumn",e[e.scrollBeyondLastLine=92]="scrollBeyondLastLine",e[e.scrollPredominantAxis=93]="scrollPredominantAxis",e[e.selectionClipboard=94]="selectionClipboard",e[e.selectionHighlight=95]="selectionHighlight",e[e.selectOnLineNumbers=96]="selectOnLineNumbers",e[e.showFoldingControls=97]="showFoldingControls",e[e.showUnused=98]="showUnused",e[e.snippetSuggestions=99]="snippetSuggestions",e[e.smartSelect=100]="smartSelect",e[e.smoothScrolling=101]="smoothScrolling",e[e.stickyTabStops=102]="stickyTabStops",e[e.stopRenderingLineAfter=103]="stopRenderingLineAfter",e[e.suggest=104]="suggest",e[e.suggestFontSize=105]="suggestFontSize",e[e.suggestLineHeight=106]="suggestLineHeight",e[e.suggestOnTriggerCharacters=107]="suggestOnTriggerCharacters",e[e.suggestSelection=108]="suggestSelection",e[e.tabCompletion=109]="tabCompletion",e[e.tabIndex=110]="tabIndex",e[e.unusualLineTerminators=111]="unusualLineTerminators",e[e.useShadowDOM=112]="useShadowDOM",e[e.useTabStops=113]="useTabStops",e[e.wordSeparators=114]="wordSeparators",e[e.wordWrap=115]="wordWrap",e[e.wordWrapBreakAfterCharacters=116]="wordWrapBreakAfterCharacters",e[e.wordWrapBreakBeforeCharacters=117]="wordWrapBreakBeforeCharacters",e[e.wordWrapColumn=118]="wordWrapColumn",e[e.wordWrapOverride1=119]="wordWrapOverride1",e[e.wordWrapOverride2=120]="wordWrapOverride2",e[e.wrappingIndent=121]="wrappingIndent",e[e.wrappingStrategy=122]="wrappingStrategy",e[e.showDeprecated=123]="showDeprecated",e[e.inlayHints=124]="inlayHints",e[e.editorClassName=125]="editorClassName",e[e.pixelRatio=126]="pixelRatio",e[e.tabFocusMode=127]="tabFocusMode",e[e.layoutInfo=128]="layoutInfo",e[e.wrappingInfo=129]="wrappingInfo"})(g=t.EditorOption||(t.EditorOption={}));var a;(function(e){e[e.TextDefined=0]="TextDefined",e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(a=t.EndOfLinePreference||(t.EndOfLinePreference={}));var d;(function(e){e[e.LF=0]="LF",e[e.CRLF=1]="CRLF"})(d=t.EndOfLineSequence||(t.EndOfLineSequence={}));var v;(function(e){e[e.None=0]="None",e[e.Indent=1]="Indent",e[e.IndentOutdent=2]="IndentOutdent",e[e.Outdent=3]="Outdent"})(v=t.IndentAction||(t.IndentAction={}));var E;(function(e){e[e.Other=0]="Other",e[e.Type=1]="Type",e[e.Parameter=2]="Parameter"})(E=t.InlayHintKind||(t.InlayHintKind={}));var A;(function(e){e[e.Automatic=0]="Automatic",e[e.Explicit=1]="Explicit"})(A=t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.KEY_0=21]="KEY_0",e[e.KEY_1=22]="KEY_1",e[e.KEY_2=23]="KEY_2",e[e.KEY_3=24]="KEY_3",e[e.KEY_4=25]="KEY_4",e[e.KEY_5=26]="KEY_5",e[e.KEY_6=27]="KEY_6",e[e.KEY_7=28]="KEY_7",e[e.KEY_8=29]="KEY_8",e[e.KEY_9=30]="KEY_9",e[e.KEY_A=31]="KEY_A",e[e.KEY_B=32]="KEY_B",e[e.KEY_C=33]="KEY_C",e[e.KEY_D=34]="KEY_D",e[e.KEY_E=35]="KEY_E",e[e.KEY_F=36]="KEY_F",e[e.KEY_G=37]="KEY_G",e[e.KEY_H=38]="KEY_H",e[e.KEY_I=39]="KEY_I",e[e.KEY_J=40]="KEY_J",e[e.KEY_K=41]="KEY_K",e[e.KEY_L=42]="KEY_L",e[e.KEY_M=43]="KEY_M",e[e.KEY_N=44]="KEY_N",e[e.KEY_O=45]="KEY_O",e[e.KEY_P=46]="KEY_P",e[e.KEY_Q=47]="KEY_Q",e[e.KEY_R=48]="KEY_R",e[e.KEY_S=49]="KEY_S",e[e.KEY_T=50]="KEY_T",e[e.KEY_U=51]="KEY_U",e[e.KEY_V=52]="KEY_V",e[e.KEY_W=53]="KEY_W",e[e.KEY_X=54]="KEY_X",e[e.KEY_Y=55]="KEY_Y",e[e.KEY_Z=56]="KEY_Z",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.US_SEMICOLON=80]="US_SEMICOLON",e[e.US_EQUAL=81]="US_EQUAL",e[e.US_COMMA=82]="US_COMMA",e[e.US_MINUS=83]="US_MINUS",e[e.US_DOT=84]="US_DOT",e[e.US_SLASH=85]="US_SLASH",e[e.US_BACKTICK=86]="US_BACKTICK",e[e.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",e[e.US_BACKSLASH=88]="US_BACKSLASH",e[e.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",e[e.US_QUOTE=90]="US_QUOTE",e[e.OEM_8=91]="OEM_8",e[e.OEM_102=92]="OEM_102",e[e.NUMPAD_0=93]="NUMPAD_0",e[e.NUMPAD_1=94]="NUMPAD_1",e[e.NUMPAD_2=95]="NUMPAD_2",e[e.NUMPAD_3=96]="NUMPAD_3",e[e.NUMPAD_4=97]="NUMPAD_4",e[e.NUMPAD_5=98]="NUMPAD_5",e[e.NUMPAD_6=99]="NUMPAD_6",e[e.NUMPAD_7=100]="NUMPAD_7",e[e.NUMPAD_8=101]="NUMPAD_8",e[e.NUMPAD_9=102]="NUMPAD_9",e[e.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",e[e.NUMPAD_ADD=104]="NUMPAD_ADD",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",e[e.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",e[e.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.MAX_VALUE=112]="MAX_VALUE"})(n=t.KeyCode||(t.KeyCode={}));var i;(function(e){e[e.Hint=1]="Hint",e[e.Info=2]="Info",e[e.Warning=4]="Warning",e[e.Error=8]="Error"})(i=t.MarkerSeverity||(t.MarkerSeverity={}));var r;(function(e){e[e.Unnecessary=1]="Unnecessary",e[e.Deprecated=2]="Deprecated"})(r=t.MarkerTag||(t.MarkerTag={}));var s;(function(e){e[e.Inline=1]="Inline",e[e.Gutter=2]="Gutter"})(s=t.MinimapPosition||(t.MinimapPosition={}));var f;(function(e){e[e.UNKNOWN=0]="UNKNOWN",e[e.TEXTAREA=1]="TEXTAREA",e[e.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",e[e.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",e[e.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",e[e.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",e[e.CONTENT_TEXT=6]="CONTENT_TEXT",e[e.CONTENT_EMPTY=7]="CONTENT_EMPTY",e[e.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",e[e.CONTENT_WIDGET=9]="CONTENT_WIDGET",e[e.OVERVIEW_RULER=10]="OVERVIEW_RULER",e[e.SCROLLBAR=11]="SCROLLBAR",e[e.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",e[e.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(f=t.MouseTargetType||(t.MouseTargetType={}));var m;(function(e){e[e.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",e[e.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",e[e.TOP_CENTER=2]="TOP_CENTER"})(m=t.OverlayWidgetPositionPreference||(t.OverlayWidgetPositionPreference={}));var h;(function(e){e[e.Left=1]="Left",e[e.Center=2]="Center",e[e.Right=4]="Right",e[e.Full=7]="Full"})(h=t.OverviewRulerLane||(t.OverviewRulerLane={}));var _;(function(e){e[e.Off=0]="Off",e[e.On=1]="On",e[e.Relative=2]="Relative",e[e.Interval=3]="Interval",e[e.Custom=4]="Custom"})(_=t.RenderLineNumbersType||(t.RenderLineNumbersType={}));var N;(function(e){e[e.None=0]="None",e[e.Text=1]="Text",e[e.Blocks=2]="Blocks"})(N=t.RenderMinimap||(t.RenderMinimap={}));var p;(function(e){e[e.Smooth=0]="Smooth",e[e.Immediate=1]="Immediate"})(p=t.ScrollType||(t.ScrollType={}));var P;(function(e){e[e.Auto=1]="Auto",e[e.Hidden=2]="Hidden",e[e.Visible=3]="Visible"})(P=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));var F;(function(e){e[e.LTR=0]="LTR",e[e.RTL=1]="RTL"})(F=t.SelectionDirection||(t.SelectionDirection={}));var R;(function(e){e[e.Invoke=1]="Invoke",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.ContentChange=3]="ContentChange"})(R=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var y;(function(e){e[e.File=0]="File",e[e.Module=1]="Module",e[e.Namespace=2]="Namespace",e[e.Package=3]="Package",e[e.Class=4]="Class",e[e.Method=5]="Method",e[e.Property=6]="Property",e[e.Field=7]="Field",e[e.Constructor=8]="Constructor",e[e.Enum=9]="Enum",e[e.Interface=10]="Interface",e[e.Function=11]="Function",e[e.Variable=12]="Variable",e[e.Constant=13]="Constant",e[e.String=14]="String",e[e.Number=15]="Number",e[e.Boolean=16]="Boolean",e[e.Array=17]="Array",e[e.Object=18]="Object",e[e.Key=19]="Key",e[e.Null=20]="Null",e[e.EnumMember=21]="EnumMember",e[e.Struct=22]="Struct",e[e.Event=23]="Event",e[e.Operator=24]="Operator",e[e.TypeParameter=25]="TypeParameter"})(y=t.SymbolKind||(t.SymbolKind={}));var q;(function(e){e[e.Deprecated=1]="Deprecated"})(q=t.SymbolTag||(t.SymbolTag={}));var j;(function(e){e[e.Hidden=0]="Hidden",e[e.Blink=1]="Blink",e[e.Smooth=2]="Smooth",e[e.Phase=3]="Phase",e[e.Expand=4]="Expand",e[e.Solid=5]="Solid"})(j=t.TextEditorCursorBlinkingStyle||(t.TextEditorCursorBlinkingStyle={}));var J;(function(e){e[e.Line=1]="Line",e[e.Block=2]="Block",e[e.Underline=3]="Underline",e[e.LineThin=4]="LineThin",e[e.BlockOutline=5]="BlockOutline",e[e.UnderlineThin=6]="UnderlineThin"})(J=t.TextEditorCursorStyle||(t.TextEditorCursorStyle={}));var z;(function(e){e[e.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",e[e.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",e[e.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",e[e.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(z=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));var H;(function(e){e[e.None=0]="None",e[e.Same=1]="Same",e[e.Indent=2]="Indent",e[e.DeepIndent=3]="DeepIndent"})(H=t.WrappingIndent||(t.WrappingIndent={}))}),G(Q[31],X([0,1,21,10,17,14,3,6,24,25,30]),function(I,t,M,U,C,l,S,u,o,c,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class w{static chord(d,v){return C.KeyChord(d,v)}}t.KeyMod=w,w.CtrlCmd=2048,w.Shift=1024,w.Alt=512,w.WinCtrl=256;function g(){return{editor:void 0,languages:void 0,CancellationTokenSource:M.CancellationTokenSource,Emitter:U.Emitter,KeyCode:b.KeyCode,KeyMod:w,Position:S.Position,Range:u.Range,Selection:o.Selection,SelectionDirection:b.SelectionDirection,MarkerSeverity:b.MarkerSeverity,MarkerTag:b.MarkerTag,Uri:l.URI,Token:c.Token}}t.createMonacoBaseAPI=g}),G(Q[32],X([0,1,13]),function(I,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumComputer=t.PrefixSumIndexOfResult=void 0;class U{constructor(S,u){this.index=S,this.remainder=u}}t.PrefixSumIndexOfResult=U;class C{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,u){S=M.toUint32(S);const o=this.values,c=this.prefixSum,b=u.length;return b===0?!1:(this.values=new Uint32Array(o.length+b),this.values.set(o.subarray(0,S),0),this.values.set(o.subarray(S),S+b),this.values.set(u,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(c.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(S,u){return S=M.toUint32(S),u=M.toUint32(u),this.values[S]===u?!1:(this.values[S]=u,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,u){S=M.toUint32(S),u=M.toUint32(u);const o=this.values,c=this.prefixSum;if(S>=o.length)return!1;let b=o.length-S;return u>=b&&(u=b),u===0?!1:(this.values=new Uint32Array(o.length-u),this.values.set(o.subarray(0,S),0),this.values.set(o.subarray(S+u),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(c.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(S){return S<0?0:(S=M.toUint32(S),this._getPrefixSum(S))}_getPrefixSum(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let u=this.prefixSumValidIndex[0]+1;u===0&&(this.prefixSum[0]=this.values[0],u++),S>=this.values.length&&(S=this.values.length-1);for(let o=u;o<=S;o++)this.prefixSum[o]=this.prefixSum[o-1]+this.values[o];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let u=0,o=this.values.length-1,c=0,b=0,w=0;for(;u<=o;)if(c=u+(o-u)/2|0,b=this.prefixSum[c],w=b-this.values[c],S<w)o=c-1;else if(S>=b)u=c+1;else break;return new U(c,S-w)}}t.PrefixSumComputer=C}),G(Q[33],X([0,1,5,3,32]),function(I,t,M,U,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class l{constructor(u,o,c,b){this._uri=u,this._lines=o,this._eol=c,this._versionId=b,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(u){u.eol&&u.eol!==this._eol&&(this._eol=u.eol,this._lineStarts=null);const o=u.changes;for(const c of o)this._acceptDeleteRange(c.range),this._acceptInsertText(new U.Position(c.range.startLineNumber,c.range.startColumn),c.text);this._versionId=u.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const u=this._eol.length,o=this._lines.length,c=new Uint32Array(o);for(let b=0;b<o;b++)c[b]=this._lines[b].length+u;this._lineStarts=new C.PrefixSumComputer(c)}}_setLineText(u,o){this._lines[u]=o,this._lineStarts&&this._lineStarts.changeValue(u,this._lines[u].length+this._eol.length)}_acceptDeleteRange(u){if(u.startLineNumber===u.endLineNumber){if(u.startColumn===u.endColumn)return;this._setLineText(u.startLineNumber-1,this._lines[u.startLineNumber-1].substring(0,u.startColumn-1)+this._lines[u.startLineNumber-1].substring(u.endColumn-1));return}this._setLineText(u.startLineNumber-1,this._lines[u.startLineNumber-1].substring(0,u.startColumn-1)+this._lines[u.endLineNumber-1].substring(u.endColumn-1)),this._lines.splice(u.startLineNumber,u.endLineNumber-u.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(u.startLineNumber,u.endLineNumber-u.startLineNumber)}_acceptInsertText(u,o){if(o.length===0)return;let c=M.splitLines(o);if(c.length===1){this._setLineText(u.lineNumber-1,this._lines[u.lineNumber-1].substring(0,u.column-1)+c[0]+this._lines[u.lineNumber-1].substring(u.column-1));return}c[c.length-1]+=this._lines[u.lineNumber-1].substring(u.column-1),this._setLineText(u.lineNumber-1,this._lines[u.lineNumber-1].substring(0,u.column-1)+c[0]);let b=new Uint32Array(c.length-1);for(let w=1;w<c.length;w++)this._lines.splice(u.lineNumber+w-1,0,c[w]),b[w-1]=c[w].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(u.lineNumber,b)}}t.MirrorTextModel=l}),G(Q[35],X([0,1,11,2,14,3,6,26,33,27,28,29,31,12,9]),function(I,t,M,U,C,l,S,u,o,c,b,w,g,a,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class v extends o.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,r){let s=c.getWordAtText(i.column,c.ensureValidWordDefinition(r),this._lines[i.lineNumber-1],0);return s?new S.Range(i.lineNumber,s.startColumn,i.lineNumber,s.endColumn):null}getWordUntilPosition(i,r){const s=this.getWordAtPosition(i,r);return s?{word:this._lines[i.lineNumber-1].substring(s.startColumn-1,i.column-1),startColumn:s.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const r=this._lines,s=this._wordenize.bind(this);let f=0,m="",h=0,_=[];return{*[Symbol.iterator](){for(;;)if(h<_.length){const N=m.substring(_[h].start,_[h].end);h+=1,yield N}else if(f<r.length)m=r[f],_=s(m,i),h=0,f+=1;else break}}}getLineWords(i,r){let s=this._lines[i-1],f=this._wordenize(s,r),m=[];for(const h of f)m.push({word:s.substring(h.start,h.end),startColumn:h.start+1,endColumn:h.end+1});return m}_wordenize(i,r){const s=[];let f;for(r.lastIndex=0;(f=r.exec(i))&&f[0].length!==0;)s.push({start:f.index,end:f.index+f[0].length});return s}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);let r=this._eol,s=i.startLineNumber-1,f=i.endLineNumber-1,m=[];m.push(this._lines[s].substring(i.startColumn-1));for(let h=s+1;h<f;h++)m.push(this._lines[h]);return m.push(this._lines[f].substring(0,i.endColumn-1)),m.join(r)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();let r=this._lineStarts.getIndexOf(i),s=this._lines[r.index].length;return{lineNumber:1+r.index,column:1+Math.min(r.remainder,s)}}_validateRange(i){const r=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),s=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return r.lineNumber!==i.startLineNumber||r.column!==i.startColumn||s.lineNumber!==i.endLineNumber||s.column!==i.endColumn?{startLineNumber:r.lineNumber,startColumn:r.column,endLineNumber:s.lineNumber,endColumn:s.column}:i}_validatePosition(i){if(!l.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:r,column:s}=i,f=!1;if(r<1)r=1,s=1,f=!0;else if(r>this._lines.length)r=this._lines.length,s=this._lines[r-1].length+1,f=!0;else{let m=this._lines[r-1].length+1;s<1?(s=1,f=!0):s>m&&(s=m,f=!0)}return f?{lineNumber:r,column:s}:i}}class E{constructor(i,r){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=r,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){let i=[];return Object.keys(this._models).forEach(r=>i.push(this._models[r])),i}acceptNewModel(i){this._models[i.url]=new v(C.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,r){if(!this._models[i])return;this._models[i].onEvents(r)}acceptRemovedModel(i){!this._models[i]||delete this._models[i]}async computeDiff(i,r,s,f){const m=this._getModel(i),h=this._getModel(r);if(!m||!h)return null;const _=m.getLinesContent(),N=h.getLinesContent(),P=new u.DiffComputer(_,N,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:s,shouldMakePrettyDiff:!0,maxComputationTime:f}).computeDiff(),F=P.changes.length>0?!1:this._modelsAreIdentical(m,h);return{quitEarly:P.quitEarly,identical:F,changes:P.changes}}_modelsAreIdentical(i,r){const s=i.getLineCount(),f=r.getLineCount();if(s!==f)return!1;for(let m=1;m<=s;m++){const h=i.getLineContent(m),_=r.getLineContent(m);if(h!==_)return!1}return!0}async computeDirtyDiff(i,r,s){let f=this._getModel(i),m=this._getModel(r);if(!f||!m)return null;let h=f.getLinesContent(),_=m.getLinesContent();return new u.DiffComputer(h,_,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:s,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(i,r){const s=this._getModel(i);if(!s)return r;const f=[];let m;r=r.slice(0).sort((h,_)=>{if(h.range&&_.range)return S.Range.compareRangesUsingStarts(h.range,_.range);let N=h.range?0:1,p=_.range?0:1;return N-p});for(let{range:h,text:_,eol:N}of r){if(typeof N=="number"&&(m=N),S.Range.isEmpty(h)&&!_)continue;const p=s.getValueInRange(h);if(_=_.replace(/\r\n|\n|\r/g,s.eol),p===_)continue;if(Math.max(_.length,p.length)>E._diffLimit){f.push({range:h,text:_});continue}const P=M.stringDiff(p,_,!1),F=s.offsetAt(S.Range.lift(h).getStartPosition());for(const R of P){const y=s.positionAt(F+R.originalStart),q=s.positionAt(F+R.originalStart+R.originalLength),j={text:_.substr(R.modifiedStart,R.modifiedLength),range:{startLineNumber:y.lineNumber,startColumn:y.column,endLineNumber:q.lineNumber,endColumn:q.column}};s.getValueInRange(j.range)!==j.text&&f.push(j)}}return typeof m=="number"&&f.push({eol:m,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),f}async computeLinks(i){let r=this._getModel(i);return r?b.computeLinks(r):null}async textualSuggest(i,r,s,f){const m=new d.StopWatch(!0),h=new RegExp(s,f),_=new Set;e:for(let N of i){const p=this._getModel(N);if(!!p){for(let P of p.words(h))if(!(P===r||!isNaN(Number(P)))&&(_.add(P),_.size>E._suggestionsLimit))break e}}return{words:Array.from(_),duration:m.elapsed()}}async computeWordRanges(i,r,s,f){let m=this._getModel(i);if(!m)return Object.create(null);const h=new RegExp(s,f),_=Object.create(null);for(let N=r.startLineNumber;N<r.endLineNumber;N++){let p=m.getLineWords(N,h);for(const P of p){if(!isNaN(Number(P.word)))continue;let F=_[P.word];F||(F=[],_[P.word]=F),F.push({startLineNumber:N,startColumn:P.startColumn,endLineNumber:N,endColumn:P.endColumn})}}return _}async navigateValueSet(i,r,s,f,m){let h=this._getModel(i);if(!h)return null;let _=new RegExp(f,m);r.startColumn===r.endColumn&&(r={startLineNumber:r.startLineNumber,startColumn:r.startColumn,endLineNumber:r.endLineNumber,endColumn:r.endColumn+1});let N=h.getValueInRange(r),p=h.getWordAtPosition({lineNumber:r.startLineNumber,column:r.startColumn},_);if(!p)return null;let P=h.getValueInRange(p);return w.BasicInplaceReplace.INSTANCE.navigateValueSet(r,N,p,P,s)}loadForeignModule(i,r,s){const f=(_,N)=>this._host.fhr(_,N);let h={host:a.createProxyObject(s,f),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(h,r),Promise.resolve(a.getAllMethodNames(this._foreignModule))):new Promise((_,N)=>{I([i],p=>{this._foreignModule=p.create(h,r),_(a.getAllMethodNames(this._foreignModule))},N)})}fmr(i,r){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,r))}catch(s){return Promise.reject(s)}}}t.EditorSimpleWorker=E,E._diffLimit=1e5,E._suggestionsLimit=1e4;function A(n){return new E(n,null)}t.create=A,typeof importScripts=="function"&&(U.globals.monaco=g.createMonacoBaseAPI())}),function(){var I,t;const M=self.MonacoEnvironment,U=M&&M.baseUrl?M.baseUrl:"../../../",C=typeof((I=self.trustedTypes)===null||I===void 0?void 0:I.createPolicy)=="function"?(t=self.trustedTypes)===null||t===void 0?void 0:t.createPolicy("amdLoader",{createScriptURL:c=>c,createScript:(c,...b)=>{const w=b.slice(0,-1).join(","),g=b.pop().toString();return`(function anonymous(${w}) {
${g}
})`}}):void 0;function l(){return new Promise((c,b)=>{if(typeof self.define=="function"&&self.define.amd)return c();const w=U+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(w)&&w.substring(0,self.origin.length)!==self.origin)){fetch(w).then(a=>{if(a.status!==200)throw new Error(a.statusText);return a.text()}).then(a=>{a=`${a}
//# sourceURL=${w}`,(C?self.eval(C.createScript("",a)):new Function(a)).call(self),c()}).then(void 0,b);return}C?importScripts(C.createScriptURL(w)):importScripts(w),c()})}const S=function(c){l().then(()=>{require.config({baseUrl:U,catchError:!0,trustedTypesPolicy:C}),require([c],function(b){setTimeout(function(){let w=b.create((g,a)=>{self.postMessage(g,a)},null);for(self.onmessage=g=>w.onmessage(g.data);o.length>0;)self.onmessage(o.shift())},0)})})};let u=!0,o=[];self.onmessage=c=>{if(!u){o.push(c);return}u=!1,S(c.data)}}()}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9744231fc12f1aed21089180b3f0394d694bd2a2/core/vs/base/worker/workerMain.js.map
