/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/platform","vs/base/common/path","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/resources","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/log/common/log","vs/base/common/types","vs/base/common/network","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/strings","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/buffer","vs/base/common/objects","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/registry/common/platform","vs/base/common/json","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/process","os","vs/base/parts/ipc/common/ipc","vs/platform/configuration/common/configurationRegistry","vs/base/common/map","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/common/extpath","child_process","vs/base/common/errorMessage","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/codicons","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","util","path","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ee=function(G){for(var e=[],v=0,L=G.length;v<L;v++)e[v]=Z[G[v]];return e};define(Z[88],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(L,k){if(!L)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=v}),define(Z[63],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const v=Object.prototype.hasOwnProperty;function L(n){const m=[];for(let h in n)v.call(n,h)&&m.push(n[h]);return m}e.values=L;function k(n,m){for(let h in n)if(v.call(n,h)&&m({key:h,value:n[h]},function(){delete n[h]})===!1)return}e.forEach=k;function A(n,m){const h=Object.create(null);for(const b of n){const f=m(b);let C=h[f];C||(C=h[f]=[]),C.push(b)}return h}e.groupBy=A;function T(n){const m=Object.create(null);return n&&n.forEach((h,b)=>{m[b]=h}),m}e.fromMap=T;function R(n,m){const h=[],b=[];for(let f of n)m.has(f)||h.push(f);for(let f of m)n.has(f)||b.push(f);return{removed:h,added:b}}e.diffSets=R;function y(n,m){const h=[],b=[];for(let[f,C]of n)m.has(f)||h.push(C);for(let[f,C]of m)n.has(f)||b.push(C);return{removed:h,added:b}}e.diffMaps=y;class p{constructor(){this.map=new Map}add(m,h){let b=this.map.get(m);b||(b=new Set,this.map.set(m,b)),b.add(h)}delete(m,h){const b=this.map.get(m);!b||(b.delete(h),b.size===0&&this.map.delete(m))}forEach(m,h){const b=this.map.get(m);!b||b.forEach(h)}}e.SetMap=p}),define(Z[64],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(T){return(R,y,p)=>{let n=null,m=null;if(typeof p.value=="function"?(n="value",m=p.value):typeof p.get=="function"&&(n="get",m=p.get),!m)throw new Error("not supported");p[n]=T(m,y)}}e.createDecorator=v;function L(T,R,y){let p=null,n=null;if(typeof y.value=="function"?(p="value",n=y.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(p="get",n=y.get),!n)throw new Error("not supported");const m=`$memoize$${R}`;y[p]=function(...h){return this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,h)}),this[m]}}e.memoize=L;function k(T,R,y){return v((p,n)=>{const m=`$debounce$${n}`,h=`$debounce$result$${n}`;return function(...b){this[h]||(this[h]=y?y():void 0),clearTimeout(this[m]),R&&(this[h]=R(this[h],...b),b=[this[h]]),this[m]=setTimeout(()=>{p.apply(this,b),this[h]=y?y():void 0},T)}})}e.debounce=k;function A(T,R,y){return v((p,n)=>{const m=`$throttle$timer$${n}`,h=`$throttle$result$${n}`,b=`$throttle$lastRun$${n}`,f=`$throttle$pending$${n}`;return function(...C){if(this[h]||(this[h]=y?y():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),R&&(this[h]=R(this[h],...C)),this[f])return;const P=this[b]+T;P<=Date.now()?(this[b]=Date.now(),p.apply(this,[this[h]]),this[h]=y?y():void 0):(this[f]=!0,this[m]=setTimeout(()=>{this[f]=!1,this[b]=Date.now(),p.apply(this,[this[h]]),this[h]=y?y():void 0},P-Date.now()))}})}e.throttle=A}),define(Z[11],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function L(s){e.errorHandler.setUnexpectedErrorHandler(s)}e.setUnexpectedErrorHandler=L;function k(s){y(s)||e.errorHandler.onUnexpectedError(s)}e.onUnexpectedError=k;function A(s){y(s)||e.errorHandler.onUnexpectedExternalError(s)}e.onUnexpectedExternalError=A;function T(s){if(s instanceof Error){let{name:t,message:r}=s;const i=s.stacktrace||s.stack;return{$isError:!0,name:t,message:r,stack:i}}return s}e.transformErrorForSerialization=T;const R="Canceled";function y(s){return s instanceof Error&&s.name===R&&s.message===R}e.isPromiseCanceledError=y;class p extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=p;function n(){const s=new Error(R);return s.name=s.message,s}e.canceled=n;function m(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}e.illegalArgument=m;function h(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}e.illegalState=h;function b(s){return s?new Error(`readonly property '${s} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function f(s){const t=new Error(`${s} has been disposed`);return t.name="DISPOSED",t}e.disposed=f;function C(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}e.getErrorMessage=C;class P extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=P;class E extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=E;class I extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=I;function d(s){const t=s;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=d;function o(s,t=Object.create(null)){const r=new Error(s);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=o}),define(Z[19],ee([0,1,11]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(N,O=0){return N[N.length-(1+O)]}e.tail=L;function k(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=k;function A(N,O,D=(M,_)=>M===_){if(N===O)return!0;if(!N||!O||N.length!==O.length)return!1;for(let M=0,_=N.length;M<_;M++)if(!D(N[M],O[M]))return!1;return!0}e.equals=A;function T(N,O,D){let M=0,_=N.length-1;for(;M<=_;){const x=(M+_)/2|0,B=D(N[x],O);if(B<0)M=x+1;else if(B>0)_=x-1;else return x}return-(M+1)}e.binarySearch=T;function R(N,O){let D=0,M=N.length;if(M===0)return 0;for(;D<M;){const _=Math.floor((D+M)/2);O(N[_])?M=_:D=_+1}return D}e.findFirstInSorted=R;function y(N,O,D){if(N=N|0,N>=O.length)throw new TypeError("invalid index");let M=O[Math.floor(O.length*Math.random())],_=[],x=[],B=[];for(let J of O){const X=D(J,M);X<0?_.push(J):X>0?x.push(J):B.push(J)}return N<_.length?y(N,_,D):N<_.length+B.length?B[0]:y(N-(_.length+B.length),x,D)}e.quickSelect=y;function p(N,O){const D=[];let M;for(const _ of N.slice(0).sort(O))!M||O(M[0],_)!==0?(M=[_],D.push(M)):M.push(_);return D}e.groupBy=p;function n(N,O,D){const M=[];function _(J,X,te){if(X===0&&te.length===0)return;const ie=M[M.length-1];ie&&ie.start+ie.deleteCount===J?(ie.deleteCount+=X,ie.toInsert.push(...te)):M.push({start:J,deleteCount:X,toInsert:te})}let x=0,B=0;for(;;){if(x===N.length){_(x,0,O.slice(B));break}if(B===O.length){_(x,N.length-x,[]);break}const J=N[x],X=O[B],te=D(J,X);te===0?(x+=1,B+=1):te<0?(_(x,1,[]),x+=1):te>0&&(_(x,0,[X]),B+=1)}return M}e.sortedDiff=n;function m(N,O,D){const M=n(N,O,D),_=[],x=[];for(const B of M)_.push(...N.slice(B.start,B.start+B.deleteCount)),x.push(...B.toInsert);return{removed:_,added:x}}e.delta=m;function h(N,O,D){if(D===0)return[];const M=N.slice(0,D).sort(O);return f(N,O,M,D,N.length),M}e.top=h;function b(N,O,D,M,_){return D===0?Promise.resolve([]):new Promise((x,B)=>{(async()=>{const J=N.length,X=N.slice(0,D).sort(O);for(let te=D,ie=Math.min(D+M,J);te<J;te=ie,ie=Math.min(ie+M,J)){if(te>D&&await new Promise(ce=>setTimeout(ce)),_&&_.isCancellationRequested)throw v.canceled();f(N,O,X,te,ie)}return X})().then(x,B)})}e.topAsync=b;function f(N,O,D,M,_){for(const x=D.length;M<_;M++){const B=N[M];if(O(B,D[x-1])<0){D.pop();const J=R(D,X=>O(B,X)<0);D.splice(J,0,B)}}}function C(N){return N.filter(O=>!!O)}e.coalesce=C;function P(N){let O=0;for(let D=0;D<N.length;D++)N[D]&&(N[O]=N[D],O+=1);N.length=O}e.coalesceInPlace=P;function E(N,O,D){N.splice(D,0,N.splice(O,1)[0])}e.move=E;function I(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=I;function d(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=d;function o(N,O){if(!O)return N.filter((M,_)=>N.indexOf(M)===_);const D=Object.create(null);return N.filter(M=>{const _=O(M);return D[_]?!1:(D[_]=!0,!0)})}e.distinct=o;function s(N){const O=new Set;return N.filter(D=>O.has(D)?!1:(O.add(D),!0))}e.distinctES6=s;function t(N){const O=Object.create(null);return D=>{const M=N(D);return O[M]?!1:(O[M]=!0,!0)}}e.uniqueFilter=t;function r(N,O){for(let D=N.length-1;D>=0;D--){const M=N[D];if(O(M))return D}return-1}e.lastIndex=r;function i(N,O){return N.length>0?N[0]:O}e.firstOrDefault=i;function a(N,O,D=(M,_)=>M===_){let M=0;for(let _=0,x=Math.min(N.length,O.length);_<x&&D(N[_],O[_]);_++)M++;return M}e.commonPrefixLength=a;function u(N){return[].concat(...N)}e.flatten=u;function c(N,O){let D=typeof O=="number"?N:0;typeof O=="number"?D=N:(D=0,O=N);const M=[];if(D<=O)for(let _=D;_<O;_++)M.push(_);else for(let _=D;_>O;_--)M.push(_);return M}e.range=c;function l(N,O,D){return N.reduce((M,_)=>(M[O(_)]=D?D(_):_,M),Object.create(null))}e.index=l;function S(N,O){return N.push(O),()=>w(N,O)}e.insert=S;function w(N,O){const D=N.indexOf(O);if(D>-1)return N.splice(D,1),O}e.remove=w;function g(N,O,D){const M=N.slice(0,O),_=N.slice(O);return M.concat(D,_)}e.arrayInsert=g;function U(N,O){let D;if(typeof O=="number"){let M=O;D=()=>{const _=Math.sin(M++)*179426549;return _-Math.floor(_)}}else D=Math.random;for(let M=N.length-1;M>0;M-=1){const _=Math.floor(D()*(M+1)),x=N[M];N[M]=N[_],N[_]=x}}e.shuffle=U;function F(N,O){const D=N.indexOf(O);D>-1&&(N.splice(D,1),N.unshift(O))}e.pushToStart=F;function j(N,O){const D=N.indexOf(O);D>-1&&(N.splice(D,1),N.push(O))}e.pushToEnd=j;function $(N,O){return Array.isArray(N)?N.map(O):O(N)}e.mapArrayOrNot=$;function V(N){return Array.isArray(N)?N:[N]}e.asArray=V;function q(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=q;function z(N,O){for(const D of N){const M=O(D);if(M!==void 0)return M}}e.mapFind=z;function H(N,O){let D=Number.MAX_SAFE_INTEGER,M=0;return N.forEach((_,x)=>{const B=O(_);B<D&&(D=B,M=x)}),M}e.minIndex=H;function Q(N,O){let D=Number.MIN_SAFE_INTEGER,M=0;return N.forEach((_,x)=>{const B=O(_);B>D&&(D=B,M=x)}),M}e.maxIndex=Q}),define(Z[65],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(L){const k=this;let A=!1,T;return function(){return A||(A=!0,T=L.apply(k,arguments)),T}}e.once=v}),define(Z[53],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(L){function k(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}L.is=k;const A=Object.freeze([]);function T(){return A}L.empty=T;function*R(s){yield s}L.single=R;function y(s){return s||A}L.from=y;function p(s){return!s||s[Symbol.iterator]().next().done===!0}L.isEmpty=p;function n(s){return s[Symbol.iterator]().next().value}L.first=n;function m(s,t){for(const r of s)if(t(r))return!0;return!1}L.some=m;function h(s,t){for(const r of s)if(t(r))return r}L.find=h;function*b(s,t){for(const r of s)t(r)&&(yield r)}L.filter=b;function*f(s,t){let r=0;for(const i of s)yield t(i,r++)}L.map=f;function*C(...s){for(const t of s)for(const r of t)yield r}L.concat=C;function*P(s){for(const t of s)for(const r of t)yield r}L.concatNested=P;function E(s,t,r){let i=r;for(const a of s)i=t(i,a);return i}L.reduce=E;function*I(s,t,r=s.length){for(t<0&&(t+=s.length),r<0?r+=s.length:r>s.length&&(r=s.length);t<r;t++)yield s[t]}L.slice=I;function d(s,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,s];const i=s[Symbol.iterator]();for(let a=0;a<t;a++){const u=i.next();if(u.done)return[r,L.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return i}}]}L.consume=d;function o(s,t,r=(i,a)=>i===a){const i=s[Symbol.iterator](),a=t[Symbol.iterator]();for(;;){const u=i.next(),c=a.next();if(u.done!==c.done)return!1;if(u.done)return!0;if(!r(u.value,c.value))return!1}}L.equals=o})(v=e.Iterable||(e.Iterable={}))}),define(Z[32],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function T(t,r=!1){let i=0,a=t.length,u="",c=0,l=16,S=0;function w(q){let z=0,H=0;for(;z<q;){const Q=t.charCodeAt(i);if(Q>=48&&Q<=57)H=H*16+Q-48;else if(Q>=65&&Q<=70)H=H*16+Q-65+10;else if(Q>=97&&Q<=102)H=H*16+Q-97+10;else break;i++,z++}return z<q&&(H=-1),H}function g(q){i=q,u="",c=0,l=16,S=0}function U(){const q=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&p(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&p(t.charCodeAt(i)))for(i++;i<t.length&&p(t.charCodeAt(i));)i++;else return S=3,t.substring(q,i);let z=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&p(t.charCodeAt(i))){for(i++;i<t.length&&p(t.charCodeAt(i));)i++;z=i}else S=3;return t.substring(q,z)}function F(){let q="",z=i;for(;;){if(i>=a){q+=t.substring(z,i),S=2;break}const H=t.charCodeAt(i);if(H===34){q+=t.substring(z,i),i++;break}if(H===92){if(q+=t.substring(z,i),i++,i>=a){S=2;break}switch(t.charCodeAt(i++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:const N=w(4);N>=0?q+=String.fromCharCode(N):S=4;break;default:S=5}z=i;continue}if(H>=0&&H<=31)if(y(H)){q+=t.substring(z,i),S=2;break}else S=6;i++}return q}function j(){if(u="",S=0,c=i,i>=a)return c=a,l=17;let q=t.charCodeAt(i);if(R(q)){do i++,u+=String.fromCharCode(q),q=t.charCodeAt(i);while(R(q));return l=15}if(y(q))return i++,u+=String.fromCharCode(q),q===13&&t.charCodeAt(i)===10&&(i++,u+=`
`),l=14;switch(q){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,u=F(),l=10;case 47:const z=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<a&&!y(t.charCodeAt(i));)i++;return u=t.substring(z,i),l=12}if(t.charCodeAt(i+1)===42){i+=2;const H=a-1;let Q=!1;for(;i<H;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,Q=!0;break}i++}return Q||(i++,S=1),u=t.substring(z,i),l=13}return u+=String.fromCharCode(q),i++,l=16;case 45:if(u+=String.fromCharCode(q),i++,i===a||!p(t.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=U(),l=11;default:for(;i<a&&$(q);)i++,q=t.charCodeAt(i);if(c!==i){switch(u=t.substring(c,i),u){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return u+=String.fromCharCode(q),i++,l=16}}function $(q){if(R(q)||y(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let q;do q=j();while(q>=12&&q<=15);return q}return{setPosition:g,getPosition:()=>i,scan:r?V:j,getToken:()=>l,getTokenValue:()=>u,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>S}}e.createScanner=T;function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function p(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function m(t,r){const i=[],a=new Object;let u;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function S(w,g,U,F){c.value=w,c.offset=g,c.length=U,c.type=F,c.colonOffset=void 0,u=c}try{d(t,{onObjectBegin:(w,g)=>{if(r<=w)throw a;u=void 0,l=r>w,i.push("")},onObjectProperty:(w,g,U)=>{if(r<g||(S(w,g,U,"property"),i[i.length-1]=w,r<=g+U))throw a},onObjectEnd:(w,g)=>{if(r<=w)throw a;u=void 0,i.pop()},onArrayBegin:(w,g)=>{if(r<=w)throw a;u=void 0,i.push(0)},onArrayEnd:(w,g)=>{if(r<=w)throw a;u=void 0,i.pop()},onLiteralValue:(w,g,U)=>{if(r<g||(S(w,g,U,s(w)),r<=g+U))throw a},onSeparator:(w,g,U)=>{if(r<=g)throw a;if(w===":"&&u&&u.type==="property")u.colonOffset=g,l=!1,u=void 0;else if(w===","){const F=i[i.length-1];typeof F=="number"?i[i.length-1]=F+1:(l=!0,i[i.length-1]=""),u=void 0}}})}catch(w){if(w!==a)throw w}return{path:i,previousNode:u,isAtPropertyKey:l,matches:w=>{let g=0;for(let U=0;g<w.length&&U<i.length;U++)if(w[g]===i[U]||w[g]==="*")g++;else if(w[g]!=="**")return!1;return g===w.length}}}e.getLocation=m;function h(t,r=[],i=A.DEFAULT){let a=null,u=[];const c=[];function l(w){Array.isArray(u)?u.push(w):a!==null&&(u[a]=w)}return d(t,{onObjectBegin:()=>{const w={};l(w),c.push(u),u=w,a=null},onObjectProperty:w=>{a=w},onObjectEnd:()=>{u=c.pop()},onArrayBegin:()=>{const w=[];l(w),c.push(u),u=w,a=null},onArrayEnd:()=>{u=c.pop()},onLiteralValue:l,onError:(w,g,U)=>{r.push({error:w,offset:g,length:U})}},i),u[0]}e.parse=h;function b(t,r=[],i=A.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(w){a.type==="property"&&(a.length=w-a.offset,a=a.parent)}function c(w){return a.children.push(w),w}d(t,{onObjectBegin:w=>{a=c({type:"object",offset:w,length:-1,parent:a,children:[]})},onObjectProperty:(w,g,U)=>{a=c({type:"property",offset:g,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:w,offset:g,length:U,parent:a})},onObjectEnd:(w,g)=>{a.length=w+g-a.offset,a=a.parent,u(w+g)},onArrayBegin:(w,g)=>{a=c({type:"array",offset:w,length:-1,parent:a,children:[]})},onArrayEnd:(w,g)=>{a.length=w+g-a.offset,a=a.parent,u(w+g)},onLiteralValue:(w,g,U)=>{c({type:s(w),offset:g,length:U,parent:a,value:w}),u(g+U)},onSeparator:(w,g,U)=>{a.type==="property"&&(w===":"?a.colonOffset=g:w===","&&u(g))},onError:(w,g,U)=>{r.push({error:w,offset:g,length:U})}},i);const S=a.children[0];return S&&delete S.parent,S}e.parseTree=b;function f(t,r){if(!t)return;let i=t;for(let a of r)if(typeof a=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let u=!1;for(const c of i.children)if(Array.isArray(c.children)&&c.children[0].value===a){i=c.children[1],u=!0;break}if(!u)return}else{const u=a;if(i.type!=="array"||u<0||!Array.isArray(i.children)||u>=i.children.length)return;i=i.children[u]}return i}e.findNodeAtLocation=f;function C(t){if(!t.parent||!t.parent.children)return[];const r=C(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}e.getNodePath=C;function P(t){switch(t.type){case"array":return t.children.map(P);case"object":const r=Object.create(null);for(let i of t.children){const a=i.children[1];a&&(r[i.children[0].value]=P(a))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=P;function E(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}e.contains=E;function I(t,r,i=!1){if(E(t,r,i)){const a=t.children;if(Array.isArray(a))for(let u=0;u<a.length&&a[u].offset<=r;u++){const c=I(a[u],r,i);if(c)return c}return t}}e.findNodeAtOffset=I;function d(t,r,i=A.DEFAULT){const a=T(t,!1);function u(B){return B?()=>B(a.getTokenOffset(),a.getTokenLength()):()=>!0}function c(B){return B?J=>B(J,a.getTokenOffset(),a.getTokenLength()):()=>!0}const l=u(r.onObjectBegin),S=c(r.onObjectProperty),w=u(r.onObjectEnd),g=u(r.onArrayBegin),U=u(r.onArrayEnd),F=c(r.onLiteralValue),j=c(r.onSeparator),$=u(r.onComment),V=c(r.onError),q=i&&i.disallowComments,z=i&&i.allowTrailingComma;function H(){for(;;){const B=a.scan();switch(a.getTokenError()){case 4:Q(14);break;case 5:Q(15);break;case 3:Q(13);break;case 1:q||Q(11);break;case 2:Q(12);break;case 6:Q(16);break}switch(B){case 12:case 13:q?Q(10):$();break;case 16:Q(1);break;case 15:case 14:break;default:return B}}}function Q(B,J=[],X=[]){if(V(B),J.length+X.length>0){let te=a.getToken();for(;te!==17;){if(J.indexOf(te)!==-1){H();break}else if(X.indexOf(te)!==-1)break;te=H()}}}function N(B){const J=a.getTokenValue();return B?F(J):S(J),H(),!0}function O(){switch(a.getToken()){case 11:let B=0;try{B=JSON.parse(a.getTokenValue()),typeof B!="number"&&(Q(2),B=0)}catch(J){Q(2)}F(B);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return H(),!0}function D(){return a.getToken()!==10?(Q(3,[],[2,5]),!1):(N(!1),a.getToken()===6?(j(":"),H(),x()||Q(4,[],[2,5])):Q(5,[],[2,5]),!0)}function M(){l(),H();let B=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(B||Q(4,[],[]),j(","),H(),a.getToken()===2&&z)break}else B&&Q(6,[],[]);D()||Q(4,[],[2,5]),B=!0}return w(),a.getToken()!==2?Q(7,[2],[]):H(),!0}function _(){g(),H();let B=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(B||Q(4,[],[]),j(","),H(),a.getToken()===4&&z)break}else B&&Q(6,[],[]);x()||Q(4,[],[4,5]),B=!0}return U(),a.getToken()!==4?Q(8,[4],[]):H(),!0}function x(){switch(a.getToken()){case 3:return _();case 1:return M();case 10:return N(!0);default:return O()}}return H(),a.getToken()===17?i.allowEmptyContent?!0:(Q(4,[],[]),!1):x()?(a.getToken()!==17&&Q(9,[],[]),!0):(Q(4,[],[]),!1)}e.visit=d;function o(t,r){let i=T(t),a=[],u,c=0,l;do switch(l=i.getPosition(),u=i.scan(),u){case 12:case 13:case 17:c!==l&&a.push(t.substring(c,l)),r!==void 0&&a.push(i.getTokenValue().replace(/[^\r\n]/g,r)),c=i.getPosition();break}while(u!==17);return a.join("")}e.stripComments=o;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),define(Z[46],ee([0,1,32]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(y,p,n){let m,h,b,f,C;if(p){for(f=p.offset,C=f+p.length,b=f;b>0&&!R(y,b-1);)b--;let c=C;for(;c<y.length&&!R(y,c);)c++;h=y.substring(b,c),m=A(h,n)}else h=y,m=0,b=0,f=0,C=y.length;const P=T(n,y);let E=!1,I=0,d;n.insertSpaces?d=k(" ",n.tabSize||4):d="	";const o=v.createScanner(h,!1);let s=!1;function t(){return P+k(d,m+I)}function r(){let c=o.scan();for(E=!1;c===15||c===14;)E=E||c===14,c=o.scan();return s=c===16||o.getTokenError()!==0,c}const i=[];function a(c,l,S){!s&&l<C&&S>f&&y.substring(l,S)!==c&&i.push({offset:l,length:S-l,content:c})}let u=r();if(u!==17){const c=o.getTokenOffset()+b,l=k(d,m);a(l,b,c)}for(;u!==17;){let c=o.getTokenOffset()+o.getTokenLength()+b,l=r(),S="";for(;!E&&(l===12||l===13);){const g=o.getTokenOffset()+b;a(" ",c,g),c=o.getTokenOffset()+o.getTokenLength()+b,S=l===12?t():"",l=r()}if(l===2)u!==1&&(I--,S=t());else if(l===4)u!==3&&(I--,S=t());else{switch(u){case 3:case 1:I++,S=t();break;case 5:case 12:S=t();break;case 13:E?S=t():S=" ";break;case 6:S=" ";break;case 10:if(l===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?S=" ":l!==5&&l!==17&&(s=!0);break;case 16:s=!0;break}E&&(l===12||l===13)&&(S=t())}const w=o.getTokenOffset()+b;a(S,c,w),u=l}return i}e.format=L;function k(y,p){let n="";for(let m=0;m<p;m++)n+=y;return n}function A(y,p){let n=0,m=0;const h=p.tabSize||4;for(;n<y.length;){const b=y.charAt(n);if(b===" ")m++;else if(b==="	")m+=h;else break;n++}return Math.floor(m/h)}function T(y,p){for(let n=0;n<p.length;n++){const m=p.charAt(n);if(m==="\r")return n+1<p.length&&p.charAt(n+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=T;function R(y,p){return`\r
`.indexOf(y.charAt(p))!==-1}e.isEOL=R}),define(Z[40],ee([0,1,32,46]),function(G,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(p,n,m){return A(p,n,void 0,m)}e.removeProperty=k;function A(p,n,m,h,b){const f=n.slice(),C=[],P=v.parseTree(p,C);let E,I;for(;f.length>0&&(I=f.pop(),E=v.findNodeAtLocation(P,f),E===void 0&&m!==void 0);)typeof I=="string"?m={[I]:m}:m=[m];if(E)if(E.type==="object"&&typeof I=="string"&&Array.isArray(E.children)){const d=v.findNodeAtLocation(E,[I]);if(d!==void 0)if(m===void 0){if(!d.parent)throw new Error("Malformed AST");const o=E.children.indexOf(d.parent);let s,t=d.parent.offset+d.parent.length;if(o>0){const r=E.children[o-1];s=r.offset+r.length}else s=E.offset+1,E.children.length>1&&(t=E.children[1].offset);return T(p,{offset:s,length:t-s,content:""},h)}else return T(p,{offset:d.offset,length:d.length,content:JSON.stringify(m)},h);else{if(m===void 0)return[];const o=`${JSON.stringify(I)}: ${JSON.stringify(m)}`,s=b?b(E.children.map(r=>r.children[0].value)):E.children.length;let t;if(s>0){const r=E.children[s-1];t={offset:r.offset+r.length,length:0,content:","+o}}else E.children.length===0?t={offset:E.offset+1,length:0,content:o}:t={offset:E.offset+1,length:0,content:o+","};return T(p,t,h)}}else if(E.type==="array"&&typeof I=="number"&&Array.isArray(E.children))if(m!==void 0){const d=`${JSON.stringify(m)}`;let o;if(E.children.length===0||I===0)o={offset:E.offset+1,length:0,content:E.children.length===0?d:d+","};else{const s=I===-1||I>E.children.length?E.children.length:I,t=E.children[s-1];o={offset:t.offset+t.length,length:0,content:","+d}}return T(p,o,h)}else{const d=I,o=E.children[d];let s;if(E.children.length===1)s={offset:E.offset+1,length:E.length-2,content:""};else if(E.children.length-1===d){const t=E.children[d-1],r=t.offset+t.length,i=E.offset+E.length;s={offset:r,length:i-2-r,content:""}}else s={offset:o.offset,length:E.children[d+1].offset-o.offset,content:""};return T(p,s,h)}else throw new Error(`Can not add ${typeof I!="number"?"index":"property"} to parent of type ${E.type}`);else{if(m===void 0)throw new Error("Can not delete in empty document");return T(p,{offset:P?P.offset:0,length:P?P.length:0,content:JSON.stringify(m)},h)}}e.setProperty=A;function T(p,n,m){let h=R(p,n),b=n.offset,f=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;b>0&&!L.isEOL(h,b-1);)b--;for(;f<h.length&&!L.isEOL(h,f);)f++}const C=L.format(h,{offset:b,length:f-b},m);for(let E=C.length-1;E>=0;E--){const I=C[E];h=R(h,I),b=Math.min(b,I.offset),f=Math.max(f,I.offset+I.length),f+=I.content.length-I.length}const P=p.length-(h.length-f)-b;return[{offset:b,length:P,content:h.substring(b,f)}]}e.withFormatting=T;function R(p,n){return p.substring(0,n.offset)+n.content+p.substring(n.offset+n.length)}e.applyEdit=R;function y(p,n){let m=n.slice(0).sort((b,f)=>{const C=b.offset-f.offset;return C===0?b.length-f.length:C}),h=p.length;for(let b=m.length-1;b>=0;b--){let f=m[b];if(f.offset+f.length<=h)p=R(p,f);else throw new Error("Overlapping edit");h=f.offset}return p}e.applyEdits=y}),define(Z[2],ee([0,1,65,53]),function(G,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const k=!1;let A=null;function T(o){A=o}if(e.setDisposableTracker=T,k){const o="__is_disposable_tracked__";A=new class{trackDisposable(s){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[o]||console.log(t)},3e3)}markTracked(s){if(s&&s!==C.None)try{s[o]=!0}catch(t){}}}}function R(o){!A||A.markTracked(o)}function y(o){return A&&A.trackDisposable(o),o}e.trackDisposable=y;class p extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=p;function n(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=n;function m(o){if(L.Iterable.is(o)){let s=[];for(const t of o)if(t){R(t);try{t.dispose()}catch(r){s.push(r)}}if(s.length===1)throw s[0];if(s.length>1)throw new p(s);return Array.isArray(o)?[]:o}else if(o)return R(o),o.dispose(),o}e.dispose=m;function h(...o){return o.forEach(R),b(()=>m(o))}e.combinedDisposable=h;function b(o){const s=y({dispose:()=>{R(s),o()}});return s}e.toDisposable=b;class f{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(R(this),this._isDisposed=!0,this.clear())}clear(){try{m(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return R(s),this._isDisposed?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class C{constructor(){this._store=new f,y(this)}dispose(){R(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=C,C.None=Object.freeze({dispose(){}});class P{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){var t;this._isDisposed||s===this._value||((t=this._value)===null||t===void 0||t.dispose(),s&&R(s),this._value=s)}clear(){this.value=void 0}dispose(){var s;this._isDisposed=!0,R(this),(s=this._value)===null||s===void 0||s.dispose(),this._value=void 0}}e.MutableDisposable=P;class E{constructor(){this.references=new Map}acquire(s,...t){let r=this.references.get(s);r||(r={counter:0,object:this.createReferencedObject(s,...t)},this.references.set(s,r));const{object:i}=r,a=v.once(()=>{--r.counter==0&&(this.destroyReferencedObject(s,r.object),this.references.delete(s))});return r.counter++,{object:i,dispose:a}}}e.ReferenceCollection=E;class I{constructor(s){this.referenceCollection=s}async acquire(s,...t){const r=this.referenceCollection.acquire(s,...t);try{return{object:await r.object,dispose:()=>r.dispose()}}catch(i){throw r.dispose(),i}}}e.AsyncReferenceCollection=I;class d{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=d}),define(Z[66],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(A){this.element=A,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class L{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let A=this._first;for(;A!==v.Undefined;){const T=A.next;A.prev=v.Undefined,A.next=v.Undefined,A=T}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,T){const R=new v(A);if(this._first===v.Undefined)this._first=R,this._last=R;else if(T){const p=this._last;this._last=R,R.prev=p,p.next=R}else{const p=this._first;this._first=R,R.next=p,p.prev=R}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(R))}}shift(){if(this._first!==v.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==v.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==v.Undefined&&A.next!==v.Undefined){const T=A.prev;T.next=A.next,A.next.prev=T}else A.prev===v.Undefined&&A.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):A.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):A.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==v.Undefined;)yield A.element,A=A.next}}e.LinkedList=L}),function(){function G(k){const A=[];typeof k=="number"&&A.push("code/timeOrigin",k);function T(y){A.push(y,Date.now())}function R(){const y=[];for(let p=0;p<A.length;p+=2)y.push({name:A[p],startTime:A[p+1]});return y}return{mark:T,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const T of performance.getEntriesByType("mark"))A.push({name:T.name,startTime:Math.round(k+T.startTime)});return A}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function v(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=v(L))}(),define(Z[7],ee([0,1]),function(G,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const L="en";let k=!1,A=!1,T=!1,R=!1,y=!1,p=!1,n=!1,m,h=L,b,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let C;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?C=e.globals.vscode.process:typeof process!="undefined"&&(C=process);const P=typeof((v=C==null?void 0:C.versions)===null||v===void 0?void 0:v.electron)=="string"&&C.type==="renderer";if(e.isElectronSandboxed=P&&(C==null?void 0:C.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const a=C==null?void 0:C.env.VSCODE_BROWSER_CODE_LOADING;if(typeof a=="string")return a==="none"||a==="code"||a==="bypassHeatCheck"||a==="bypassHeatCheckAndEagerCompile"?a:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!P)f=navigator.userAgent,k=f.indexOf("Windows")>=0,A=f.indexOf("Macintosh")>=0,n=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=f.indexOf("Linux")>=0,p=!0,m=navigator.language,h=m;else if(typeof C=="object"){k=C.platform==="win32",A=C.platform==="darwin",T=C.platform==="linux",R=T&&!!C.env.SNAP&&!!C.env.SNAP_REVISION,m=L,h=L;const a=C.env.VSCODE_NLS_CONFIG;if(a)try{const u=JSON.parse(a),c=u.availableLanguages["*"];m=u.locale,h=c||L,b=u._translationsConfigFile}catch(u){}y=!0}else console.error("Unable to resolve platform.");var E;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function I(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=I;let d=0;A?d=1:k?d=3:T&&(d=2),e.isWindows=k,e.isMacintosh=A,e.isLinux=T,e.isLinuxSnap=R,e.isNative=y,e.isWeb=p,e.isIOS=n,e.platform=d,e.userAgent=f,e.language=h;var o;(function(a){function u(){return e.language}a.value=u;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=c;function l(){return e.language==="en"}a.isDefault=l})(o=e.Language||(e.Language={})),e.locale=m,e.translationsConfigFile=b,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeSetImmediateId)for(let w=0,g=c.length;w<g;w++){const U=c[w];if(U.id===S.data.vscodeSetImmediateId){c.splice(w,1),U.callback();return}}});let l=0;return S=>{const w=++l;c.push({id:w,callback:S}),e.globals.postMessage({vscodeSetImmediateId:w},"*")}}if(typeof(C==null?void 0:C.nextTick)=="function")return C.nextTick.bind(C);const u=Promise.resolve();return c=>u.then(c)}();var s;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=A||n?2:k?1:3;let t=!0,r=!1;function i(){if(!r){r=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,t=new Uint16Array(a.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=i}),define(Z[34],ee([0,1,7]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const k=v.globals.vscode.process;L={get platform(){return k.platform},get env(){return k.env},cwd(){return k.cwd()},nextTick(A){return v.setImmediate(A)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:L={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(k){return v.setImmediate(k)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(Z[8],ee([0,1,34]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,k=97,A=90,T=122,R=46,y=47,p=92,n=58,m=63;class h extends Error{constructor(o,s,t){let r;typeof s=="string"&&s.indexOf("not ")===0?(r="must not be",s=s.replace(/^not /,"")):r="must be";const i=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${i} ${r} of type ${s}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function b(d,o){if(typeof d!="string")throw new h(o,"string",d)}function f(d){return d===y||d===p}function C(d){return d===y}function P(d){return d>=L&&d<=A||d>=k&&d<=T}function E(d,o,s,t){let r="",i=0,a=-1,u=0,c=0;for(let l=0;l<=d.length;++l){if(l<d.length)c=d.charCodeAt(l);else{if(t(c))break;c=y}if(t(c)){if(!(a===l-1||u===1))if(u===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==R||r.charCodeAt(r.length-2)!==R){if(r.length>2){const S=r.lastIndexOf(s);S===-1?(r="",i=0):(r=r.slice(0,S),i=r.length-1-r.lastIndexOf(s)),a=l,u=0;continue}else if(r.length!==0){r="",i=0,a=l,u=0;continue}}o&&(r+=r.length>0?`${s}..`:"..",i=2)}else r.length>0?r+=`${s}${d.slice(a+1,l)}`:r=d.slice(a+1,l),i=l-a-1;a=l,u=0}else c===R&&u!==-1?++u:u=-1}return r}function I(d,o){if(o===null||typeof o!="object")throw new h("pathObject","Object",o);const s=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${t}`:`${s}${d}${t}`:t}e.win32={resolve(...d){let o="",s="",t=!1;for(let r=d.length-1;r>=-1;r--){let i;if(r>=0){if(i=d[r],b(i,"path"),i.length===0)continue}else o.length===0?i=v.cwd():(i=v.env[`=${o}`]||v.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==o.toLowerCase()&&i.charCodeAt(2)===p)&&(i=`${o}\\`));const a=i.length;let u=0,c="",l=!1;const S=i.charCodeAt(0);if(a===1)f(S)&&(u=1,l=!0);else if(f(S))if(l=!0,f(i.charCodeAt(1))){let w=2,g=w;for(;w<a&&!f(i.charCodeAt(w));)w++;if(w<a&&w!==g){const U=i.slice(g,w);for(g=w;w<a&&f(i.charCodeAt(w));)w++;if(w<a&&w!==g){for(g=w;w<a&&!f(i.charCodeAt(w));)w++;(w===a||w!==g)&&(c=`\\\\${U}\\${i.slice(g,w)}`,u=w)}}}else u=1;else P(S)&&i.charCodeAt(1)===n&&(c=i.slice(0,2),u=2,a>2&&f(i.charCodeAt(2))&&(l=!0,u=3));if(c.length>0)if(o.length>0){if(c.toLowerCase()!==o.toLowerCase())continue}else o=c;if(t){if(o.length>0)break}else if(s=`${i.slice(u)}\\${s}`,t=l,l&&o.length>0)break}return s=E(s,!t,"\\",f),t?`${o}\\${s}`:`${o}${s}`||"."},normalize(d){b(d,"path");const o=d.length;if(o===0)return".";let s=0,t,r=!1;const i=d.charCodeAt(0);if(o===1)return C(i)?"\\":d;if(f(i))if(r=!0,f(d.charCodeAt(1))){let u=2,c=u;for(;u<o&&!f(d.charCodeAt(u));)u++;if(u<o&&u!==c){const l=d.slice(c,u);for(c=u;u<o&&f(d.charCodeAt(u));)u++;if(u<o&&u!==c){for(c=u;u<o&&!f(d.charCodeAt(u));)u++;if(u===o)return`\\\\${l}\\${d.slice(c)}\\`;u!==c&&(t=`\\\\${l}\\${d.slice(c,u)}`,s=u)}}}else s=1;else P(i)&&d.charCodeAt(1)===n&&(t=d.slice(0,2),s=2,o>2&&f(d.charCodeAt(2))&&(r=!0,s=3));let a=s<o?E(d.slice(s),!r,"\\",f):"";return a.length===0&&!r&&(a="."),a.length>0&&f(d.charCodeAt(o-1))&&(a+="\\"),t===void 0?r?`\\${a}`:a:r?`${t}\\${a}`:`${t}${a}`},isAbsolute(d){b(d,"path");const o=d.length;if(o===0)return!1;const s=d.charCodeAt(0);return f(s)||o>2&&P(s)&&d.charCodeAt(1)===n&&f(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let o,s;for(let i=0;i<d.length;++i){const a=d[i];b(a,"path"),a.length>0&&(o===void 0?o=s=a:o+=`\\${a}`)}if(o===void 0)return".";let t=!0,r=0;if(typeof s=="string"&&f(s.charCodeAt(0))){++r;const i=s.length;i>1&&f(s.charCodeAt(1))&&(++r,i>2&&(f(s.charCodeAt(2))?++r:t=!1))}if(t){for(;r<o.length&&f(o.charCodeAt(r));)r++;r>=2&&(o=`\\${o.slice(r)}`)}return e.win32.normalize(o)},relative(d,o){if(b(d,"from"),b(o,"to"),d===o)return"";const s=e.win32.resolve(d),t=e.win32.resolve(o);if(s===t||(d=s.toLowerCase(),o=t.toLowerCase(),d===o))return"";let r=0;for(;r<d.length&&d.charCodeAt(r)===p;)r++;let i=d.length;for(;i-1>r&&d.charCodeAt(i-1)===p;)i--;const a=i-r;let u=0;for(;u<o.length&&o.charCodeAt(u)===p;)u++;let c=o.length;for(;c-1>u&&o.charCodeAt(c-1)===p;)c--;const l=c-u,S=a<l?a:l;let w=-1,g=0;for(;g<S;g++){const F=d.charCodeAt(r+g);if(F!==o.charCodeAt(u+g))break;F===p&&(w=g)}if(g!==S){if(w===-1)return t}else{if(l>S){if(o.charCodeAt(u+g)===p)return t.slice(u+g+1);if(g===2)return t.slice(u+g)}a>S&&(d.charCodeAt(r+g)===p?w=g:g===2&&(w=3)),w===-1&&(w=0)}let U="";for(g=r+w+1;g<=i;++g)(g===i||d.charCodeAt(g)===p)&&(U+=U.length===0?"..":"\\..");return u+=w,U.length>0?`${U}${t.slice(u,c)}`:(t.charCodeAt(u)===p&&++u,t.slice(u,c))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const o=e.win32.resolve(d);if(o.length<=2)return d;if(o.charCodeAt(0)===p){if(o.charCodeAt(1)===p){const s=o.charCodeAt(2);if(s!==m&&s!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(P(o.charCodeAt(0))&&o.charCodeAt(1)===n&&o.charCodeAt(2)===p)return`\\\\?\\${o}`;return d},dirname(d){b(d,"path");const o=d.length;if(o===0)return".";let s=-1,t=0;const r=d.charCodeAt(0);if(o===1)return f(r)?d:".";if(f(r)){if(s=t=1,f(d.charCodeAt(1))){let u=2,c=u;for(;u<o&&!f(d.charCodeAt(u));)u++;if(u<o&&u!==c){for(c=u;u<o&&f(d.charCodeAt(u));)u++;if(u<o&&u!==c){for(c=u;u<o&&!f(d.charCodeAt(u));)u++;if(u===o)return d;u!==c&&(s=t=u+1)}}}}else P(r)&&d.charCodeAt(1)===n&&(s=o>2&&f(d.charCodeAt(2))?3:2,t=s);let i=-1,a=!0;for(let u=o-1;u>=t;--u)if(f(d.charCodeAt(u))){if(!a){i=u;break}}else a=!1;if(i===-1){if(s===-1)return".";i=s}return d.slice(0,i)},basename(d,o){o!==void 0&&b(o,"ext"),b(d,"path");let s=0,t=-1,r=!0,i;if(d.length>=2&&P(d.charCodeAt(0))&&d.charCodeAt(1)===n&&(s=2),o!==void 0&&o.length>0&&o.length<=d.length){if(o===d)return"";let a=o.length-1,u=-1;for(i=d.length-1;i>=s;--i){const c=d.charCodeAt(i);if(f(c)){if(!r){s=i+1;break}}else u===-1&&(r=!1,u=i+1),a>=0&&(c===o.charCodeAt(a)?--a==-1&&(t=i):(a=-1,t=u))}return s===t?t=u:t===-1&&(t=d.length),d.slice(s,t)}for(i=d.length-1;i>=s;--i)if(f(d.charCodeAt(i))){if(!r){s=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":d.slice(s,t)},extname(d){b(d,"path");let o=0,s=-1,t=0,r=-1,i=!0,a=0;d.length>=2&&d.charCodeAt(1)===n&&P(d.charCodeAt(0))&&(o=t=2);for(let u=d.length-1;u>=o;--u){const c=d.charCodeAt(u);if(f(c)){if(!i){t=u+1;break}continue}r===-1&&(i=!1,r=u+1),c===R?s===-1?s=u:a!==1&&(a=1):s!==-1&&(a=-1)}return s===-1||r===-1||a===0||a===1&&s===r-1&&s===t+1?"":d.slice(s,r)},format:I.bind(null,"\\"),parse(d){b(d,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return o;const s=d.length;let t=0,r=d.charCodeAt(0);if(s===1)return f(r)?(o.root=o.dir=d,o):(o.base=o.name=d,o);if(f(r)){if(t=1,f(d.charCodeAt(1))){let w=2,g=w;for(;w<s&&!f(d.charCodeAt(w));)w++;if(w<s&&w!==g){for(g=w;w<s&&f(d.charCodeAt(w));)w++;if(w<s&&w!==g){for(g=w;w<s&&!f(d.charCodeAt(w));)w++;w===s?t=w:w!==g&&(t=w+1)}}}}else if(P(r)&&d.charCodeAt(1)===n){if(s<=2)return o.root=o.dir=d,o;if(t=2,f(d.charCodeAt(2))){if(s===3)return o.root=o.dir=d,o;t=3}}t>0&&(o.root=d.slice(0,t));let i=-1,a=t,u=-1,c=!0,l=d.length-1,S=0;for(;l>=t;--l){if(r=d.charCodeAt(l),f(r)){if(!c){a=l+1;break}continue}u===-1&&(c=!1,u=l+1),r===R?i===-1?i=l:S!==1&&(S=1):i!==-1&&(S=-1)}return u!==-1&&(i===-1||S===0||S===1&&i===u-1&&i===a+1?o.base=o.name=d.slice(a,u):(o.name=d.slice(a,i),o.base=d.slice(a,u),o.ext=d.slice(i,u))),a>0&&a!==t?o.dir=d.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let o="",s=!1;for(let t=d.length-1;t>=-1&&!s;t--){const r=t>=0?d[t]:v.cwd();b(r,"path"),r.length!==0&&(o=`${r}/${o}`,s=r.charCodeAt(0)===y)}return o=E(o,!s,"/",C),s?`/${o}`:o.length>0?o:"."},normalize(d){if(b(d,"path"),d.length===0)return".";const o=d.charCodeAt(0)===y,s=d.charCodeAt(d.length-1)===y;return d=E(d,!o,"/",C),d.length===0?o?"/":s?"./":".":(s&&(d+="/"),o?`/${d}`:d)},isAbsolute(d){return b(d,"path"),d.length>0&&d.charCodeAt(0)===y},join(...d){if(d.length===0)return".";let o;for(let s=0;s<d.length;++s){const t=d[s];b(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(d,o){if(b(d,"from"),b(o,"to"),d===o||(d=e.posix.resolve(d),o=e.posix.resolve(o),d===o))return"";const s=1,t=d.length,r=t-s,i=1,a=o.length-i,u=r<a?r:a;let c=-1,l=0;for(;l<u;l++){const w=d.charCodeAt(s+l);if(w!==o.charCodeAt(i+l))break;w===y&&(c=l)}if(l===u)if(a>u){if(o.charCodeAt(i+l)===y)return o.slice(i+l+1);if(l===0)return o.slice(i+l)}else r>u&&(d.charCodeAt(s+l)===y?c=l:l===0&&(c=0));let S="";for(l=s+c+1;l<=t;++l)(l===t||d.charCodeAt(l)===y)&&(S+=S.length===0?"..":"/..");return`${S}${o.slice(i+c)}`},toNamespacedPath(d){return d},dirname(d){if(b(d,"path"),d.length===0)return".";const o=d.charCodeAt(0)===y;let s=-1,t=!0;for(let r=d.length-1;r>=1;--r)if(d.charCodeAt(r)===y){if(!t){s=r;break}}else t=!1;return s===-1?o?"/":".":o&&s===1?"//":d.slice(0,s)},basename(d,o){o!==void 0&&b(o,"ext"),b(d,"path");let s=0,t=-1,r=!0,i;if(o!==void 0&&o.length>0&&o.length<=d.length){if(o===d)return"";let a=o.length-1,u=-1;for(i=d.length-1;i>=0;--i){const c=d.charCodeAt(i);if(c===y){if(!r){s=i+1;break}}else u===-1&&(r=!1,u=i+1),a>=0&&(c===o.charCodeAt(a)?--a==-1&&(t=i):(a=-1,t=u))}return s===t?t=u:t===-1&&(t=d.length),d.slice(s,t)}for(i=d.length-1;i>=0;--i)if(d.charCodeAt(i)===y){if(!r){s=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":d.slice(s,t)},extname(d){b(d,"path");let o=-1,s=0,t=-1,r=!0,i=0;for(let a=d.length-1;a>=0;--a){const u=d.charCodeAt(a);if(u===y){if(!r){s=a+1;break}continue}t===-1&&(r=!1,t=a+1),u===R?o===-1?o=a:i!==1&&(i=1):o!==-1&&(i=-1)}return o===-1||t===-1||i===0||i===1&&o===t-1&&o===s+1?"":d.slice(o,t)},format:I.bind(null,"/"),parse(d){b(d,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return o;const s=d.charCodeAt(0)===y;let t;s?(o.root="/",t=1):t=0;let r=-1,i=0,a=-1,u=!0,c=d.length-1,l=0;for(;c>=t;--c){const S=d.charCodeAt(c);if(S===y){if(!u){i=c+1;break}continue}a===-1&&(u=!1,a=c+1),S===R?r===-1?r=c:l!==1&&(l=1):r!==-1&&(l=-1)}if(a!==-1){const S=i===0&&s?1:i;r===-1||l===0||l===1&&r===a-1&&r===i+1?o.base=o.name=d.slice(S,a):(o.name=d.slice(S,r),o.base=d.slice(S,a),o.ext=d.slice(r,a))}return i>0?o.dir=d.slice(0,i-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var L in v)(typeof exports=="object"?exports:G)[L]=v[L]}}(typeof self!="undefined"?self:this,function(){return function(G){var e={};function v(L){if(e[L])return e[L].exports;var k=e[L]={i:L,l:!1,exports:{}};return G[L].call(k.exports,k,k.exports,v),k.l=!0,k.exports}return v.m=G,v.c=e,v.d=function(L,k,A){v.o(L,k)||Object.defineProperty(L,k,{enumerable:!0,get:A})},v.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},v.t=function(L,k){if(1&k&&(L=v(L)),8&k||4&k&&typeof L=="object"&&L&&L.__esModule)return L;var A=Object.create(null);if(v.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:L}),2&k&&typeof L!="string")for(var T in L)v.d(A,T,function(R){return L[R]}.bind(null,T));return A},v.n=function(L){var k=L&&L.__esModule?function(){return L.default}:function(){return L};return v.d(k,"a",k),k},v.o=function(L,k){return Object.prototype.hasOwnProperty.call(L,k)},v.p="",v(v.s=0)}([function(G,e,v){(function(L){var k;e=G.exports=X,k=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],y=e.src=[],p=0,n=p++;y[n]="0|[1-9]\\d*";var m=p++;y[m]="[0-9]+";var h=p++;y[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=p++;y[b]="("+y[n]+")\\.("+y[n]+")\\.("+y[n]+")";var f=p++;y[f]="("+y[m]+")\\.("+y[m]+")\\.("+y[m]+")";var C=p++;y[C]="(?:"+y[n]+"|"+y[h]+")";var P=p++;y[P]="(?:"+y[m]+"|"+y[h]+")";var E=p++;y[E]="(?:-("+y[C]+"(?:\\."+y[C]+")*))";var I=p++;y[I]="(?:-?("+y[P]+"(?:\\."+y[P]+")*))";var d=p++;y[d]="[0-9A-Za-z-]+";var o=p++;y[o]="(?:\\+("+y[d]+"(?:\\."+y[d]+")*))";var s=p++,t="v?"+y[b]+y[E]+"?"+y[o]+"?";y[s]="^"+t+"$";var r="[v=\\s]*"+y[f]+y[I]+"?"+y[o]+"?",i=p++;y[i]="^"+r+"$";var a=p++;y[a]="((?:<|>)?=?)";var u=p++;y[u]=y[m]+"|x|X|\\*";var c=p++;y[c]=y[n]+"|x|X|\\*";var l=p++;y[l]="[v=\\s]*("+y[c]+")(?:\\.("+y[c]+")(?:\\.("+y[c]+")(?:"+y[E]+")?"+y[o]+"?)?)?";var S=p++;y[S]="[v=\\s]*("+y[u]+")(?:\\.("+y[u]+")(?:\\.("+y[u]+")(?:"+y[I]+")?"+y[o]+"?)?)?";var w=p++;y[w]="^"+y[a]+"\\s*"+y[l]+"$";var g=p++;y[g]="^"+y[a]+"\\s*"+y[S]+"$";var U=p++;y[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=p++;y[F]="(?:~>?)";var j=p++;y[j]="(\\s*)"+y[F]+"\\s+",R[j]=new RegExp(y[j],"g");var $=p++;y[$]="^"+y[F]+y[l]+"$";var V=p++;y[V]="^"+y[F]+y[S]+"$";var q=p++;y[q]="(?:\\^)";var z=p++;y[z]="(\\s*)"+y[q]+"\\s+",R[z]=new RegExp(y[z],"g");var H=p++;y[H]="^"+y[q]+y[l]+"$";var Q=p++;y[Q]="^"+y[q]+y[S]+"$";var N=p++;y[N]="^"+y[a]+"\\s*("+r+")$|^$";var O=p++;y[O]="^"+y[a]+"\\s*("+t+")$|^$";var D=p++;y[D]="(\\s*)"+y[a]+"\\s*("+r+"|"+y[l]+")",R[D]=new RegExp(y[D],"g");var M=p++;y[M]="^\\s*("+y[l]+")\\s+-\\s+("+y[l]+")\\s*$";var _=p++;y[_]="^\\s*("+y[S]+")\\s+-\\s+("+y[S]+")\\s*$";var x=p++;y[x]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)k(B,y[B]),R[B]||(R[B]=new RegExp(y[B]));function J(Y,re){if(Y instanceof X)return Y;if(typeof Y!="string"||Y.length>A||!(re?R[i]:R[s]).test(Y))return null;try{return new X(Y,re)}catch(se){return null}}function X(Y,re){if(Y instanceof X){if(Y.loose===re)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof X))return new X(Y,re);k("SemVer",Y,re),this.loose=re;var se=Y.trim().match(re?R[i]:R[s]);if(!se)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+se[1],this.minor=+se[2],this.patch=+se[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");se[4]?this.prerelease=se[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var Se=+me;if(Se>=0&&Se<T)return Se}return me}):this.prerelease=[],this.build=se[5]?se[5].split("."):[],this.format()}e.parse=J,e.valid=function(Y,re){var se=J(Y,re);return se?se.version:null},e.clean=function(Y,re){var se=J(Y.trim().replace(/^[=v]+/,""),re);return se?se.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(Y){return k("SemVer.compare",this.version,this.loose,Y),Y instanceof X||(Y=new X(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},X.prototype.compareMain=function(Y){return Y instanceof X||(Y=new X(Y,this.loose)),ie(this.major,Y.major)||ie(this.minor,Y.minor)||ie(this.patch,Y.patch)},X.prototype.comparePre=function(Y){if(Y instanceof X||(Y=new X(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var re=0;do{var se=this.prerelease[re],me=Y.prerelease[re];if(k("prerelease compare",re,se,me),se===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(se===void 0)return-1;if(se!==me)return ie(se,me)}while(++re)},X.prototype.inc=function(Y,re){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",re),this.inc("pre",re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",re),this.inc("pre",re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var se=this.prerelease.length;--se>=0;)typeof this.prerelease[se]=="number"&&(this.prerelease[se]++,se=-2);se===-1&&this.prerelease.push(0)}re&&(this.prerelease[0]===re?isNaN(this.prerelease[1])&&(this.prerelease=[re,0]):this.prerelease=[re,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,re,se,me){typeof se=="string"&&(me=se,se=void 0);try{return new X(Y,se).inc(re,me).version}catch(Se){return null}},e.diff=function(Y,re){if(pe(Y,re))return null;var se=J(Y),me=J(re);if(se.prerelease.length||me.prerelease.length){for(var Se in se)if((Se==="major"||Se==="minor"||Se==="patch")&&se[Se]!==me[Se])return"pre"+Se;return"prerelease"}for(var Se in se)if((Se==="major"||Se==="minor"||Se==="patch")&&se[Se]!==me[Se])return Se},e.compareIdentifiers=ie;var te=/^[0-9]+$/;function ie(Y,re){var se=te.test(Y),me=te.test(re);return se&&me&&(Y=+Y,re=+re),se&&!me?-1:me&&!se?1:Y<re?-1:Y>re?1:0}function ce(Y,re,se){return new X(Y,se).compare(new X(re,se))}function le(Y,re,se){return ce(Y,re,se)>0}function ve(Y,re,se){return ce(Y,re,se)<0}function pe(Y,re,se){return ce(Y,re,se)===0}function Ce(Y,re,se){return ce(Y,re,se)!==0}function Ae(Y,re,se){return ce(Y,re,se)>=0}function Me(Y,re,se){return ce(Y,re,se)<=0}function Te(Y,re,se,me){var Se;switch(re){case"===":typeof Y=="object"&&(Y=Y.version),typeof se=="object"&&(se=se.version),Se=Y===se;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof se=="object"&&(se=se.version),Se=Y!==se;break;case"":case"=":case"==":Se=pe(Y,se,me);break;case"!=":Se=Ce(Y,se,me);break;case">":Se=le(Y,se,me);break;case">=":Se=Ae(Y,se,me);break;case"<":Se=ve(Y,se,me);break;case"<=":Se=Me(Y,se,me);break;default:throw new TypeError("Invalid operator: "+re)}return Se}function ke(Y,re){if(Y instanceof ke){if(Y.loose===re)return Y;Y=Y.value}if(!(this instanceof ke))return new ke(Y,re);k("comparator",Y,re),this.loose=re,this.parse(Y),this.semver===je?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(Y,re){return ie(re,Y)},e.major=function(Y,re){return new X(Y,re).major},e.minor=function(Y,re){return new X(Y,re).minor},e.patch=function(Y,re){return new X(Y,re).patch},e.compare=ce,e.compareLoose=function(Y,re){return ce(Y,re,!0)},e.rcompare=function(Y,re,se){return ce(re,Y,se)},e.sort=function(Y,re){return Y.sort(function(se,me){return e.compare(se,me,re)})},e.rsort=function(Y,re){return Y.sort(function(se,me){return e.rcompare(se,me,re)})},e.gt=le,e.lt=ve,e.eq=pe,e.neq=Ce,e.gte=Ae,e.lte=Me,e.cmp=Te,e.Comparator=ke;var je={};function Ie(Y,re){if(Y instanceof Ie)return Y.loose===re?Y:new Ie(Y.raw,re);if(Y instanceof ke)return new Ie(Y.value,re);if(!(this instanceof Ie))return new Ie(Y,re);if(this.loose=re,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(se){return this.parseRange(se.trim())},this).filter(function(se){return se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function Oe(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function Ye(Y,re,se,me,Se,De,be,Ue,Pe,W,ne,ae,oe){return((re=Oe(se)?"":Oe(me)?">="+se+".0.0":Oe(Se)?">="+se+"."+me+".0":">="+re)+" "+(Ue=Oe(Pe)?"":Oe(W)?"<"+(+Pe+1)+".0.0":Oe(ne)?"<"+Pe+"."+(+W+1)+".0":ae?"<="+Pe+"."+W+"."+ne+"-"+ae:"<="+Ue)).trim()}function Je(Y,re){for(var se=0;se<Y.length;se++)if(!Y[se].test(re))return!1;if(re.prerelease.length){for(se=0;se<Y.length;se++)if(k(Y[se].semver),Y[se].semver!==je&&Y[se].semver.prerelease.length>0){var me=Y[se].semver;if(me.major===re.major&&me.minor===re.minor&&me.patch===re.patch)return!0}return!1}return!0}function $e(Y,re,se){try{re=new Ie(re,se)}catch(me){return!1}return re.test(Y)}function xe(Y,re,se,me){var Se,De,be,Ue,Pe;switch(Y=new X(Y,me),re=new Ie(re,me),se){case">":Se=le,De=Me,be=ve,Ue=">",Pe=">=";break;case"<":Se=ve,De=Ae,be=le,Ue="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(Y,re,me))return!1;for(var W=0;W<re.set.length;++W){var ne=re.set[W],ae=null,oe=null;if(ne.forEach(function(he){he.semver===je&&(he=new ke(">=0.0.0")),ae=ae||he,oe=oe||he,Se(he.semver,ae.semver,me)?ae=he:be(he.semver,oe.semver,me)&&(oe=he)}),ae.operator===Ue||ae.operator===Pe||(!oe.operator||oe.operator===Ue)&&De(Y,oe.semver)||oe.operator===Pe&&be(Y,oe.semver))return!1}return!0}ke.prototype.parse=function(Y){var re=this.loose?R[N]:R[O],se=Y.match(re);if(!se)throw new TypeError("Invalid comparator: "+Y);this.operator=se[1],this.operator==="="&&(this.operator=""),se[2]?this.semver=new X(se[2],this.loose):this.semver=je},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(Y){return k("Comparator.test",Y,this.loose),this.semver===je||(typeof Y=="string"&&(Y=new X(Y,this.loose)),Te(Y,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(Y,re){if(!(Y instanceof ke))throw new TypeError("a Comparator is required");var se;if(this.operator==="")return se=new Ie(Y.value,re),$e(this.value,se,re);if(Y.operator==="")return se=new Ie(this.value,re),$e(Y.semver,se,re);var me=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),Se=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),De=this.semver.version===Y.semver.version,be=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),Ue=Te(this.semver,"<",Y.semver,re)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),Pe=Te(this.semver,">",Y.semver,re)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return me||Se||De&&be||Ue||Pe},e.Range=Ie,Ie.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},Ie.prototype.toString=function(){return this.range},Ie.prototype.parseRange=function(Y){var re=this.loose;Y=Y.trim(),k("range",Y,re);var se=re?R[_]:R[M];Y=Y.replace(se,Ye),k("hyphen replace",Y),Y=Y.replace(R[D],"$1$2$3"),k("comparator trim",Y,R[D]),Y=(Y=(Y=Y.replace(R[j],"$1~")).replace(R[z],"$1^")).split(/\s+/).join(" ");var me=re?R[N]:R[O],Se=Y.split(" ").map(function(De){return function(be,Ue){return k("comp",be),be=function(Pe,W){return Pe.trim().split(/\s+/).map(function(ne){return function(ae,oe){k("caret",ae,oe);var he=oe?R[Q]:R[H];return ae.replace(he,function(ge,fe,ye,we,Ee){var ue;return k("caret",ae,ge,fe,ye,we,Ee),Oe(fe)?ue="":Oe(ye)?ue=">="+fe+".0.0 <"+(+fe+1)+".0.0":Oe(we)?ue=fe==="0"?">="+fe+"."+ye+".0 <"+fe+"."+(+ye+1)+".0":">="+fe+"."+ye+".0 <"+(+fe+1)+".0.0":Ee?(k("replaceCaret pr",Ee),Ee.charAt(0)!=="-"&&(Ee="-"+Ee),ue=fe==="0"?ye==="0"?">="+fe+"."+ye+"."+we+Ee+" <"+fe+"."+ye+"."+(+we+1):">="+fe+"."+ye+"."+we+Ee+" <"+fe+"."+(+ye+1)+".0":">="+fe+"."+ye+"."+we+Ee+" <"+(+fe+1)+".0.0"):(k("no pr"),ue=fe==="0"?ye==="0"?">="+fe+"."+ye+"."+we+" <"+fe+"."+ye+"."+(+we+1):">="+fe+"."+ye+"."+we+" <"+fe+"."+(+ye+1)+".0":">="+fe+"."+ye+"."+we+" <"+(+fe+1)+".0.0"),k("caret return",ue),ue})}(ne,W)}).join(" ")}(be,Ue),k("caret",be),be=function(Pe,W){return Pe.trim().split(/\s+/).map(function(ne){return function(ae,oe){var he=oe?R[V]:R[$];return ae.replace(he,function(ge,fe,ye,we,Ee){var ue;return k("tilde",ae,ge,fe,ye,we,Ee),Oe(fe)?ue="":Oe(ye)?ue=">="+fe+".0.0 <"+(+fe+1)+".0.0":Oe(we)?ue=">="+fe+"."+ye+".0 <"+fe+"."+(+ye+1)+".0":Ee?(k("replaceTilde pr",Ee),Ee.charAt(0)!=="-"&&(Ee="-"+Ee),ue=">="+fe+"."+ye+"."+we+Ee+" <"+fe+"."+(+ye+1)+".0"):ue=">="+fe+"."+ye+"."+we+" <"+fe+"."+(+ye+1)+".0",k("tilde return",ue),ue})}(ne,W)}).join(" ")}(be,Ue),k("tildes",be),be=function(Pe,W){return k("replaceXRanges",Pe,W),Pe.split(/\s+/).map(function(ne){return function(ae,oe){ae=ae.trim();var he=oe?R[g]:R[w];return ae.replace(he,function(ge,fe,ye,we,Ee,ue){k("xRange",ae,ge,fe,ye,we,Ee,ue);var Re=Oe(ye),Fe=Re||Oe(we),_e=Fe||Oe(Ee);return fe==="="&&_e&&(fe=""),Re?ge=fe===">"||fe==="<"?"<0.0.0":"*":fe&&_e?(Fe&&(we=0),_e&&(Ee=0),fe===">"?(fe=">=",Fe?(ye=+ye+1,we=0,Ee=0):_e&&(we=+we+1,Ee=0)):fe==="<="&&(fe="<",Fe?ye=+ye+1:we=+we+1),ge=fe+ye+"."+we+"."+Ee):Fe?ge=">="+ye+".0.0 <"+(+ye+1)+".0.0":_e&&(ge=">="+ye+"."+we+".0 <"+ye+"."+(+we+1)+".0"),k("xRange return",ge),ge})}(ne,W)}).join(" ")}(be,Ue),k("xrange",be),be=function(Pe,W){return k("replaceStars",Pe,W),Pe.trim().replace(R[x],"")}(be,Ue),k("stars",be),be}(De,re)}).join(" ").split(/\s+/);return this.loose&&(Se=Se.filter(function(De){return!!De.match(me)})),Se=Se.map(function(De){return new ke(De,re)})},Ie.prototype.intersects=function(Y,re){if(!(Y instanceof Ie))throw new TypeError("a Range is required");return this.set.some(function(se){return se.every(function(me){return Y.set.some(function(Se){return Se.every(function(De){return me.intersects(De,re)})})})})},e.toComparators=function(Y,re){return new Ie(Y,re).set.map(function(se){return se.map(function(me){return me.value}).join(" ").trim().split(" ")})},Ie.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new X(Y,this.loose));for(var re=0;re<this.set.length;re++)if(Je(this.set[re],Y))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(Y,re,se){var me=null,Se=null;try{var De=new Ie(re,se)}catch(be){return null}return Y.forEach(function(be){De.test(be)&&(me&&Se.compare(be)!==-1||(Se=new X(me=be,se)))}),me},e.minSatisfying=function(Y,re,se){var me=null,Se=null;try{var De=new Ie(re,se)}catch(be){return null}return Y.forEach(function(be){De.test(be)&&(me&&Se.compare(be)!==1||(Se=new X(me=be,se)))}),me},e.validRange=function(Y,re){try{return new Ie(Y,re).range||"*"}catch(se){return null}},e.ltr=function(Y,re,se){return xe(Y,re,"<",se)},e.gtr=function(Y,re,se){return xe(Y,re,">",se)},e.outside=xe,e.prerelease=function(Y,re){var se=J(Y,re);return se&&se.prerelease.length?se.prerelease:null},e.intersects=function(Y,re,se){return Y=new Ie(Y,se),re=new Ie(re,se),Y.intersects(re)},e.coerce=function(Y){if(Y instanceof X)return Y;if(typeof Y!="string")return null;var re=Y.match(R[U]);return re==null?null:J((re[1]||"0")+"."+(re[2]||"0")+"."+(re[3]||"0"))}}).call(this,v(1))},function(G,e){var v,L,k=G.exports={};function A(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function R(P){if(v===setTimeout)return setTimeout(P,0);if((v===A||!v)&&setTimeout)return v=setTimeout,setTimeout(P,0);try{return v(P,0)}catch(E){try{return v.call(null,P,0)}catch(I){return v.call(this,P,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:A}catch(P){v=A}try{L=typeof clearTimeout=="function"?clearTimeout:T}catch(P){L=T}})();var y,p=[],n=!1,m=-1;function h(){n&&y&&(n=!1,y.length?p=y.concat(p):m=-1,p.length&&b())}function b(){if(!n){var P=R(h);n=!0;for(var E=p.length;E;){for(y=p,p=[];++m<E;)y&&y[m].run();m=-1,E=p.length}y=null,n=!1,function(I){if(L===clearTimeout)return clearTimeout(I);if((L===T||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(I);try{L(I)}catch(d){try{return L.call(null,I)}catch(o){return L.call(this,I)}}}(P)}}function f(P,E){this.fun=P,this.array=E}function C(){}k.nextTick=function(P){var E=new Array(arguments.length-1);if(arguments.length>1)for(var I=1;I<arguments.length;I++)E[I-1]=arguments[I];p.push(new f(P,E)),p.length!==1||n||R(b)},f.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=C,k.addListener=C,k.once=C,k.off=C,k.removeListener=C,k.removeAllListeners=C,k.emit=C,k.prependListener=C,k.prependOnceListener=C,k.listeners=function(P){return[]},k.binding=function(P){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(P){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Z[89],ee([0,1,7]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=v.globals.performance&&typeof v.globals.performance.now=="function";class k{constructor(T){this._highResolution=L&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new k(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=k}),define(Z[3],ee([0,1,11,65,2,66,89]),function(G,e,v,L,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var R;(function(I){I.None=()=>k.Disposable.None;function d(V){return(q,z=null,H)=>{let Q=!1,N;return N=V(O=>{if(!Q)return N?N.dispose():Q=!0,q.call(z,O)},null,H),Q&&N.dispose(),N}}I.once=d;function o(V,q){return u((z,H=null,Q)=>V(N=>z.call(H,q(N)),null,Q))}I.map=o;function s(V,q){return u((z,H=null,Q)=>V(N=>{q(N),z.call(H,N)},null,Q))}I.forEach=s;function t(V,q){return u((z,H=null,Q)=>V(N=>q(N)&&z.call(H,N),null,Q))}I.filter=t;function r(V){return V}I.signal=r;function i(...V){return(q,z=null,H)=>k.combinedDisposable(...V.map(Q=>Q(N=>q.call(z,N),null,H)))}I.any=i;function a(V,q,z){let H=z;return o(V,Q=>(H=q(H,Q),H))}I.reduce=a;function u(V){let q;const z=new h({onFirstListenerAdd(){q=V(z.fire,z)},onLastListenerRemove(){q.dispose()}});return z.event}function c(V,q,z=100,H=!1,Q){let N,O,D,M=0;const _=new h({leakWarningThreshold:Q,onFirstListenerAdd(){N=V(x=>{M++,O=q(O,x),H&&!D&&(_.fire(O),O=void 0),clearTimeout(D),D=setTimeout(()=>{const B=O;O=void 0,D=void 0,(!H||M>1)&&_.fire(B),M=0},z)})},onLastListenerRemove(){N.dispose()}});return _.event}I.debounce=c;function l(V,q=(z,H)=>z===H){let z=!0,H;return t(V,Q=>{const N=z||!q(Q,H);return z=!1,H=Q,N})}I.latch=l;function S(V,q){return[I.filter(V,q),I.filter(V,z=>!q(z))]}I.split=S;function w(V,q=!1,z=[]){let H=z.slice(),Q=V(D=>{H?H.push(D):O.fire(D)});const N=()=>{H&&H.forEach(D=>O.fire(D)),H=null},O=new h({onFirstListenerAdd(){Q||(Q=V(D=>O.fire(D)))},onFirstListenerDidAdd(){H&&(q?setTimeout(N):N())},onLastListenerRemove(){Q&&Q.dispose(),Q=null}});return O.event}I.buffer=w;class g{constructor(q){this.event=q}map(q){return new g(o(this.event,q))}forEach(q){return new g(s(this.event,q))}filter(q){return new g(t(this.event,q))}reduce(q,z){return new g(a(this.event,q,z))}latch(){return new g(l(this.event))}debounce(q,z=100,H=!1,Q){return new g(c(this.event,q,z,H,Q))}on(q,z,H){return this.event(q,z,H)}once(q,z,H){return d(this.event)(q,z,H)}}function U(V){return new g(V)}I.chain=U;function F(V,q,z=H=>H){const H=(...D)=>O.fire(z(...D)),Q=()=>V.on(q,H),N=()=>V.removeListener(q,H),O=new h({onFirstListenerAdd:Q,onLastListenerRemove:N});return O.event}I.fromNodeEventEmitter=F;function j(V,q,z=H=>H){const H=(...D)=>O.fire(z(...D)),Q=()=>V.addEventListener(q,H),N=()=>V.removeEventListener(q,H),O=new h({onFirstListenerAdd:Q,onLastListenerRemove:N});return O.event}I.fromDOMEventEmitter=j;function $(V){return new Promise(q=>d(V)(q))}I.toPromise=$})(R=e.Event||(e.Event={}));class y{constructor(d){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${d}_${y._idPool++}`}start(d){this._stopWatch=new T.StopWatch(!0),this._listenerCount=d}stop(){if(this._stopWatch){const d=this._stopWatch.elapsed();this._elapsedOverall+=d,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${d.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let p=-1;function n(I){const d=p;return p=I,{dispose(){p=d}}}e.setGlobalLeakWarningThreshold=n;class m{constructor(d,o=Math.random().toString(18).slice(2,5)){this.customThreshold=d,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(d){let o=p;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||d<o)return;this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),t=this._stacks.get(s)||0;if(this._stacks.set(s,t+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let r,i=0;for(const[a,u]of this._stacks)(!r||i<u)&&(r=a,i=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${d} listeners already. MOST frequent listener (${i}):`),console.warn(r)}return()=>{const r=this._stacks.get(s)||0;this._stacks.set(s,r-1)}}}class h{constructor(d){var o;this._disposed=!1,this._options=d,this._leakageMon=p>0?new m(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((o=this._options)===null||o===void 0?void 0:o._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(d,o,s)=>{var t;this._listeners||(this._listeners=new A.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(o?[d,o]:d);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,d,o);const a=(t=this._leakageMon)===null||t===void 0?void 0:t.check(this._listeners.size);let u;return u={dispose:()=>{a&&a(),u.dispose=h._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},s instanceof k.DisposableStore?s.add(u):Array.isArray(s)&&s.push(u),u}),this._event}fire(d){var o,s;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,d]);for((o=this._perfMon)===null||o===void 0||o.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,r]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,r):t[0].call(t[1],r)}catch(i){v.onUnexpectedError(i)}}(s=this._perfMon)===null||s===void 0||s.stop()}}dispose(){var d,o,s,t,r;this._disposed||(this._disposed=!0,(d=this._listeners)===null||d===void 0||d.clear(),(o=this._deliveryQueue)===null||o===void 0||o.clear(),(t=(s=this._options)===null||s===void 0?void 0:s.onLastListenerRemove)===null||t===void 0||t.call(s),(r=this._leakageMon)===null||r===void 0||r.dispose())}}e.Emitter=h,h._noop=function(){};class b extends h{constructor(d){super(d);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=d==null?void 0:d.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const d=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(d))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(d){this._listeners&&(this._isPaused!==0?this._eventQueue.push(d):super.fire(d))}}e.PauseableEmitter=b;class f extends b{constructor(d){var o;super(d);this._delay=(o=d.delay)!==null&&o!==void 0?o:100}fire(d){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(d)}}e.DebounceEmitter=f;class C{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new h({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(d){const o={event:d,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const s=()=>{this.hasListeners&&this.unhook(o);const t=this.events.indexOf(o);this.events.splice(t,1)};return k.toDisposable(L.once(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(d=>this.hook(d))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(d=>this.unhook(d))}hook(d){d.listener=d.event(o=>this.emitter.fire(o))}unhook(d){d.listener&&d.listener.dispose(),d.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=C;class P{constructor(){this.buffers=[]}wrapEvent(d){return(o,s,t)=>d(r=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>o.call(s,r)):o.call(s,r)},void 0,t)}bufferEvents(d){const o=[];this.buffers.push(o);const s=d();return this.buffers.pop(),o.forEach(t=>t()),s}}e.EventBufferer=P;class E{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=k.Disposable.None,this.emitter=new h({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(d){this.inputEvent=d,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=d(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(Z[29],ee([0,1,3]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(R,y){const p=setTimeout(R.bind(y),0);return{dispose(){clearTimeout(p)}}});var k;(function(R){function y(p){return p===R.None||p===R.Cancelled||p instanceof A?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}R.isCancellationToken=y,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(k=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=k.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=T}),define(Z[54],ee([0,1,3]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(m){const h=this._icons.get(m.id);h?m.description?h.description=m.description:console.error(`Duplicate registration of codicon ${m.id}`):(this._icons.set(m.id,m),this._onDidRegister.fire(m))}get(m){return this._icons.get(m)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new L;e.iconRegistry=k;function A(n,m){return new R(n,m)}e.registerCodicon=A;function T(n){return n?n.replace(/\$\((.*?)\)/g,(m,h)=>` ${h} `).trim():""}e.getCodiconAriaLabel=T;class R{constructor(m,h,b){this.id=m,this.definition=h,this.description=b,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=R;function y(n,m){const h=["codicon","codicon-"+n];return m&&h.push("codicon-modifier-"+m),h}e.getClassNamesArray=y;var p;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const m=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function h(C){if(C instanceof R)return["codicon","codicon-"+C.id];const P=m.exec(C.id);if(!P)return h(R.error);let[,E,I]=P;const d=["codicon","codicon-"+E];return I&&d.push("codicon-modifier-"+I.substr(1)),d}n.asClassNameArray=h;function b(C){return h(C).join(" ")}n.asClassName=b;function f(C){return"."+h(C).join(".")}n.asCSSSelector=f})(p=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(R=e.Codicon||(e.Codicon={}))}),define(Z[47],ee([0,1,11,2]),function(G,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(d){const o=d;return o?[o.on,o.pause,o.resume,o.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=k;function A(d){const o=d;return o?k(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=A;function T(d,o){return new R(d,o)}e.newWriteableStream=T;class R{constructor(o,s){this.reducer=o,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){var s;if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof((s=this.options)===null||s===void 0?void 0:s.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(s=>s(o))}emitError(o){this.listeners.error.length===0?v.onUnexpectedError(o):this.listeners.error.slice(0).forEach(s=>s(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,s){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(o,s){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(s);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(d,o){const s=[];let t;for(;(t=d.read())!==null;)s.push(t);return o(s)}e.consumeReadable=y;function p(d,o,s){const t=[];let r;for(;(r=d.read())!==null&&t.length<s;)t.push(r);return r===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return d.read()}}}e.peekReadable=p;function n(d,o){return new Promise((s,t)=>{const r=[];m(d,{onData:i=>{o&&r.push(i)},onError:i=>{o?t(i):s(void 0)},onEnd:()=>{s(o?o(r):void 0)}})})}e.consumeStream=n;function m(d,o){d.on("error",s=>o.onError(s)),d.on("end",()=>o.onEnd()),d.on("data",s=>o.onData(s))}e.listenStream=m;function h(d,o){return new Promise((s,t)=>{const r=new L.DisposableStore,i=[],a=l=>{if(i.push(l),i.length>o)return r.dispose(),d.pause(),s({stream:d,buffer:i,ended:!1})},u=l=>t(l),c=()=>s({stream:d,buffer:i,ended:!0});r.add(L.toDisposable(()=>d.removeListener("error",u))),d.on("error",u),r.add(L.toDisposable(()=>d.removeListener("end",c))),d.on("end",c),r.add(L.toDisposable(()=>d.removeListener("data",a))),d.on("data",a)})}e.peekStream=h;function b(d,o){const s=T(o);return s.end(d),s}e.toStream=b;function f(){const d=T(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=f;function C(d){let o=!1;return{read:()=>o?null:(o=!0,d)}}e.toReadable=C;function P(d,o,s){const t=T(s);return m(d,{onData:r=>t.write(o.data(r)),onError:r=>t.error(o.error?o.error(r):r),onEnd:()=>t.end()}),t}e.transform=P;function E(d,o,s){let t=!1;return{read:()=>{const r=o.read();return t?r:(t=!0,r!==null?s([d,r]):d)}}}e.prefixedReadable=E;function I(d,o,s){let t=!1;const r=T(s);return m(o,{onData:i=>t?r.write(i):(t=!0,r.write(s([d,i]))),onError:i=>r.error(i),onEnd:()=>{t||(t=!0,r.write(d)),r.end()}}),r}e.prefixedStream=I}),define(Z[20],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function v(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=v;const L=/{(\d+)}/g;function k(W,...ne){return ne.length===0?W:W.replace(L,function(ae,oe){const he=parseInt(oe,10);return isNaN(he)||he<0||he>=ne.length?ae:ne[he]})}e.format=k;function A(W){return W.replace(/[<>&]/g,function(ne){switch(ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ne}})}e.escape=A;function T(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=T;function R(W,ne){let ae=0;const oe=ne.charCodeAt(0);for(let he=W.length-1;he>=0;he--)W.charCodeAt(he)===oe&&ae++;return ae}e.count=R;function y(W,ne,ae="\u2026"){return W.length<=ne?W:`${W.substr(0,ne)}${ae}`}e.truncate=y;function p(W,ne=" "){const ae=n(W,ne);return m(ae,ne)}e.trim=p;function n(W,ne){if(!W||!ne)return W;const ae=ne.length;if(ae===0||W.length===0)return W;let oe=0;for(;W.indexOf(ne,oe)===oe;)oe=oe+ae;return W.substring(oe)}e.ltrim=n;function m(W,ne){if(!W||!ne)return W;const ae=ne.length,oe=W.length;if(ae===0||oe===0)return W;let he=oe,ge=-1;for(;ge=W.lastIndexOf(ne,he-1),!(ge===-1||ge+ae!==he);){if(ge===0)return"";he=ge}return W.substring(0,he)}e.rtrim=m;function h(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function b(W){return W.replace(/\*/g,"")}e.stripWildcards=b;function f(W,ne,ae={}){if(!W)throw new Error("Cannot create regex from empty string");ne||(W=T(W)),ae.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let oe="";return ae.global&&(oe+="g"),ae.matchCase||(oe+="i"),ae.multiline&&(oe+="m"),ae.unicode&&(oe+="u"),new RegExp(W,oe)}e.createRegExp=f;function C(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=C;function P(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=P;function E(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=E;function I(W){return W.split(/\r\n|\r|\n/)}e.splitLines=I;function d(W){for(let ne=0,ae=W.length;ne<ae;ne++){const oe=W.charCodeAt(ne);if(oe!==32&&oe!==9)return ne}return-1}e.firstNonWhitespaceIndex=d;function o(W,ne=0,ae=W.length){for(let oe=ne;oe<ae;oe++){const he=W.charCodeAt(oe);if(he!==32&&he!==9)return W.substring(ne,oe)}return W.substring(ne,ae)}e.getLeadingWhitespace=o;function s(W,ne=W.length-1){for(let ae=ne;ae>=0;ae--){const oe=W.charCodeAt(ae);if(oe!==32&&oe!==9)return ae}return-1}e.lastNonWhitespaceIndex=s;function t(W,ne){return W<ne?-1:W>ne?1:0}e.compare=t;function r(W,ne,ae=0,oe=W.length,he=0,ge=ne.length){for(;ae<oe&&he<ge;ae++,he++){let we=W.charCodeAt(ae),Ee=ne.charCodeAt(he);if(we<Ee)return-1;if(we>Ee)return 1}const fe=oe-ae,ye=ge-he;return fe<ye?-1:fe>ye?1:0}e.compareSubstring=r;function i(W,ne){return a(W,ne,0,W.length,0,ne.length)}e.compareIgnoreCase=i;function a(W,ne,ae=0,oe=W.length,he=0,ge=ne.length){for(;ae<oe&&he<ge;ae++,he++){let we=W.charCodeAt(ae),Ee=ne.charCodeAt(he);if(we===Ee)continue;const ue=we-Ee;if(!(ue===32&&c(Ee))&&!(ue===-32&&c(we)))return u(we)&&u(Ee)?ue:r(W.toLowerCase(),ne.toLowerCase(),ae,oe,he,ge)}const fe=oe-ae,ye=ge-he;return fe<ye?-1:fe>ye?1:0}e.compareSubstringIgnoreCase=a;function u(W){return W>=97&&W<=122}e.isLowerAsciiLetter=u;function c(W){return W>=65&&W<=90}e.isUpperAsciiLetter=c;function l(W){return u(W)||c(W)}function S(W,ne){return W.length===ne.length&&w(W,ne)}e.equalsIgnoreCase=S;function w(W,ne,ae=W.length){for(let oe=0;oe<ae;oe++){const he=W.charCodeAt(oe),ge=ne.charCodeAt(oe);if(he!==ge){if(l(he)&&l(ge)){const fe=Math.abs(he-ge);if(fe!==0&&fe!==32)return!1}else if(String.fromCharCode(he).toLowerCase()!==String.fromCharCode(ge).toLowerCase())return!1}}return!0}function g(W,ne){const ae=ne.length;return ne.length>W.length?!1:w(W,ne,ae)}e.startsWithIgnoreCase=g;function U(W,ne){let ae,oe=Math.min(W.length,ne.length);for(ae=0;ae<oe;ae++)if(W.charCodeAt(ae)!==ne.charCodeAt(ae))return ae;return oe}e.commonPrefixLength=U;function F(W,ne){let ae,oe=Math.min(W.length,ne.length);const he=W.length-1,ge=ne.length-1;for(ae=0;ae<oe;ae++)if(W.charCodeAt(he-ae)!==ne.charCodeAt(ge-ae))return ae;return oe}e.commonSuffixLength=F;function j(W){return 55296<=W&&W<=56319}e.isHighSurrogate=j;function $(W){return 56320<=W&&W<=57343}e.isLowSurrogate=$;function V(W,ne){return(W-55296<<10)+(ne-56320)+65536}e.computeCodePoint=V;function q(W,ne,ae){const oe=W.charCodeAt(ae);if(j(oe)&&ae+1<ne){const he=W.charCodeAt(ae+1);if($(he))return V(oe,he)}return oe}e.getNextCodePoint=q;function z(W,ne){const ae=W.charCodeAt(ne-1);if($(ae)&&ne>1){const oe=W.charCodeAt(ne-2);if(j(oe))return V(oe,ae)}return ae}function H(W,ne){const ae=se.getInstance(),oe=ne,he=W.length,ge=q(W,he,ne);ne+=ge>=65536?2:1;let fe=ae.getGraphemeBreakType(ge);for(;ne<he;){const ye=q(W,he,ne),we=ae.getGraphemeBreakType(ye);if(Y(fe,we))break;ne+=ye>=65536?2:1,fe=we}return ne-oe}e.nextCharLength=H;function Q(W,ne){const ae=se.getInstance(),oe=ne,he=z(W,ne);ne-=he>=65536?2:1;let ge=ae.getGraphemeBreakType(he);for(;ne>0;){const fe=z(W,ne),ye=ae.getGraphemeBreakType(fe);if(Y(ye,ge))break;ne-=fe>=65536?2:1,ge=ye}return oe-ne}e.prevCharLength=Q;function N(W,ne){const ae=se.getInstance(),oe=W.length,he=ne,ge=q(W,oe,ne),fe=ae.getGraphemeBreakType(ge);ne+=ge>=65536?2:1;let ye=fe;for(;ne<oe;){const Ee=q(W,oe,ne),ue=ae.getGraphemeBreakType(Ee);if(Y(ye,ue))break;ne+=Ee>=65536?2:1,ye=ue}const we=ne;for(ne=he,ye=fe;ne>0;){const Ee=z(W,ne),ue=ae.getGraphemeBreakType(Ee);if(Y(ue,ye))break;ne-=Ee>=65536?2:1,ye=ue}return[ne,we]}function O(W,ne){return ne>0&&$(W.charCodeAt(ne))?N(W,ne-1):N(W,ne)}e.getCharContainingOffset=O;function D(W){const ne=W.length;let ae=0,oe=0;for(;oe<ne;){const fe=q(W,ne,oe);oe+=fe>=65536?2:1,fe<128?ae+=1:fe<2048?ae+=2:fe<65536?ae+=3:ae+=4}const he=new Uint8Array(ae);oe=0;let ge=0;for(;oe<ne;){const fe=q(W,ne,oe);oe+=fe>=65536?2:1,fe<128?he[ge++]=fe:fe<2048?(he[ge++]=192|(fe&1984)>>>6,he[ge++]=128|(fe&63)>>>0):fe<65536?(he[ge++]=224|(fe&61440)>>>12,he[ge++]=128|(fe&4032)>>>6,he[ge++]=128|(fe&63)>>>0):(he[ge++]=240|(fe&1835008)>>>18,he[ge++]=128|(fe&258048)>>>12,he[ge++]=128|(fe&4032)>>>6,he[ge++]=128|(fe&63)>>>0)}return he}e.encodeUTF8=D;function M(W){const ne=W.byteLength,ae=[];let oe=0;for(;oe<ne;){const he=W[oe];let ge;if(he>=240&&oe+3<ne?ge=(W[oe++]&7)<<18>>>0|(W[oe++]&63)<<12>>>0|(W[oe++]&63)<<6>>>0|(W[oe++]&63)<<0>>>0:he>=224&&oe+2<ne?ge=(W[oe++]&15)<<12>>>0|(W[oe++]&63)<<6>>>0|(W[oe++]&63)<<0>>>0:he>=192&&oe+1<ne?ge=(W[oe++]&31)<<6>>>0|(W[oe++]&63)<<0>>>0:ge=W[oe++],ge>=0&&ge<=55295||ge>=57344&&ge<=65535)ae.push(String.fromCharCode(ge));else if(ge>=65536&&ge<=1114111){const fe=ge-65536,ye=55296+((fe&1047552)>>>10),we=56320+((fe&1023)>>>0);ae.push(String.fromCharCode(ye)),ae.push(String.fromCharCode(we))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=M;const _=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function x(W){return _.test(W)}e.containsRTL=x;const B=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function J(W){return B.test(W)}e.containsEmoji=J;const X=/^[\t\n\r\x20-\x7E]*$/;function te(W){return X.test(W)}e.isBasicASCII=te,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ie(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=ie;function ce(W){for(let ne=0,ae=W.length;ne<ae;ne++)if(le(W.charCodeAt(ne)))return!0;return!1}e.containsFullWidthCharacter=ce;function le(W){return W=+W,W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=le;function ve(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129003||W>=129280&&W<=129535||W>=129648&&W<=129750}e.isEmojiImprecise=ve;function pe(W,ne){if(W.length<ne)return W;const ae=/\b/g;let oe=0;for(;ae.test(W)&&!(W.length-ae.lastIndex<ne);)oe=ae.lastIndex,ae.lastIndex+=1;return W.substring(oe).replace(/^\s/,"")}e.lcut=pe;const Ce=/\x1B\x5B[12]?K/g,Ae=/\x1b\[\d+m/g,Me=/\x1b\[0?m/g;function Te(W){return W&&(W=W.replace(Ce,""),W=W.replace(Ae,""),W=W.replace(Me,"")),W}e.removeAnsiEscapeCodes=Te,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function je(W){return ke(W)?W.substr(1):W}e.stripUTF8BOM=je;function Ie(W,ne){if(!W||!ne||W.length<ne.length)return!1;const ae=ne.length,oe=W.toLowerCase();let he=0,ge=-1;for(;he<ae;){const fe=oe.indexOf(ne[he],ge+1);if(fe<0)return!1;ge=fe,he++}return!0}e.fuzzyContains=Ie;function Oe(W,ne=!1){return W?(ne&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=Oe;function Ye(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=Ye;function Je(W,ne=1){if(ne===0)return"";let ae=-1;do ae=W.indexOf(`
`,ae+1),ne--;while(ne>0&&ae>=0);return ae===-1?W:(W[ae-1]==="\r"&&ae--,W.substr(0,ae))}e.getNLines=Je;function $e(W){const ne=90-65+1;return W=W%(2*ne),W<ne?String.fromCharCode(97+W):String.fromCharCode(65+W-ne)}e.singleLetterHash=$e;function xe(W){return se.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=xe;function Y(W,ne){return W===0?ne!==5&&ne!==7:W===2&&ne===3?!1:W===4||W===2||W===3||ne===4||ne===2||ne===3?!0:!(W===8&&(ne===8||ne===9||ne===11||ne===12)||(W===11||W===9)&&(ne===9||ne===10)||(W===12||W===10)&&ne===10||ne===5||ne===13||ne===7||W===1||W===13&&ne===14||W===6&&ne===6)}e.breakBetweenGraphemeBreakType=Y;var re;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class se{constructor(){this._data=me()}static getInstance(){return se._INSTANCE||(se._INSTANCE=new se),se._INSTANCE}getGraphemeBreakType(ne){if(ne<32)return ne===10?3:ne===13?2:4;if(ne<127)return 0;const ae=this._data,oe=ae.length/3;let he=1;for(;he<=oe;)if(ne<ae[3*he])he=2*he;else if(ne>ae[3*he+1])he=2*he+1;else return ae[3*he+2];return 0}}se._INSTANCE=null;function me(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Se(W,ne){if(W===0)return 0;const ae=De(W,ne);if(ae!==void 0)return ae;const oe=z(ne,W);return W-=be(oe),W}e.getLeftDeleteOffset=Se;function De(W,ne){let ae=z(ne,W);for(W-=be(ae);Ue(ae)||ae===65039||ae===8419;){if(W===0)return;ae=z(ne,W),W-=be(ae)}if(!!ve(ae)){if(W>=0){const oe=z(ne,W);oe===8205&&(W-=be(oe))}return W}}function be(W){return W>=65536?2:1}function Ue(W){return 127995<=W&&W<=127999}var Pe;(function(W){W[W.zwj=8205]="zwj",W[W.emojiVariantSelector=65039]="emojiVariantSelector",W[W.enclosingKeyCap=8419]="enclosingKeyCap"})(Pe||(Pe={}))}),define(Z[25],ee([0,1,20,47]),function(G,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer!="undefined",A=typeof TextEncoder!="undefined",T=typeof TextDecoder!="undefined";let R,y;class p{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return k?new p(Buffer.allocUnsafe(l)):new p(new Uint8Array(l))}static wrap(l){return k&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new p(l)}static fromString(l,S){return!((S==null?void 0:S.dontUseNodeBuffer)||!1)&&k?new p(Buffer.from(l)):A?(R||(R=new TextEncoder),new p(R.encode(l))):new p(v.encodeUTF8(l))}static concat(l,S){if(typeof S=="undefined"){S=0;for(let U=0,F=l.length;U<F;U++)S+=l[U].byteLength}const w=p.alloc(S);let g=0;for(let U=0,F=l.length;U<F;U++){const j=l[U];w.set(j,g),g+=j.byteLength}return w}toString(){return k?this.buffer.toString():T?(y||(y=new TextDecoder),y.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(l,S){return new p(this.buffer.subarray(l,S))}set(l,S){l instanceof p?this.buffer.set(l.buffer,S):this.buffer.set(l,S)}readUInt32BE(l){return h(this.buffer,l)}writeUInt32BE(l,S){b(this.buffer,l,S)}readUInt32LE(l){return f(this.buffer,l)}writeUInt32LE(l,S){C(this.buffer,l,S)}readUInt8(l){return P(this.buffer,l)}writeUInt8(l,S){E(this.buffer,l,S)}}e.VSBuffer=p;function n(c,l){return c[l+0]<<0>>>0|c[l+1]<<8>>>0}e.readUInt16LE=n;function m(c,l,S){c[S+0]=l&255,l=l>>>8,c[S+1]=l&255}e.writeUInt16LE=m;function h(c,l){return c[l]*2**24+c[l+1]*2**16+c[l+2]*2**8+c[l+3]}e.readUInt32BE=h;function b(c,l,S){c[S+3]=l,l=l>>>8,c[S+2]=l,l=l>>>8,c[S+1]=l,l=l>>>8,c[S]=l}e.writeUInt32BE=b;function f(c,l){return c[l+0]<<0>>>0|c[l+1]<<8>>>0|c[l+2]<<16>>>0|c[l+3]<<24>>>0}e.readUInt32LE=f;function C(c,l,S){c[S+0]=l&255,l=l>>>8,c[S+1]=l&255,l=l>>>8,c[S+2]=l&255,l=l>>>8,c[S+3]=l&255}e.writeUInt32LE=C;function P(c,l){return c[l]}e.readUInt8=P;function E(c,l,S){c[S]=l}e.writeUInt8=E;function I(c){return L.consumeReadable(c,l=>p.concat(l))}e.readableToBuffer=I;function d(c){return L.toReadable(c)}e.bufferToReadable=d;function o(c){return L.consumeStream(c,l=>p.concat(l))}e.streamToBuffer=o;async function s(c){return c.ended?p.concat(c.buffer):p.concat([...c.buffer,await o(c.stream)])}e.bufferedStreamToBuffer=s;function t(c){return L.toStream(c,l=>p.concat(l))}e.bufferToStream=t;function r(c){return L.transform(c,{data:l=>typeof l=="string"?p.fromString(l):p.wrap(l)},l=>p.concat(l))}e.streamToBufferReadableStream=r;function i(c){return L.newWriteableStream(l=>p.concat(l),c)}e.newWriteableBufferStream=i;function a(c,l){return L.prefixedReadable(c,l,S=>p.concat(S))}e.prefixedBufferReadable=a;function u(c,l){return L.prefixedStream(c,l,S=>p.concat(S))}e.prefixedBufferStream=u}),define(Z[16],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(l){return Array.isArray(l)}e.isArray=v;function L(l){return typeof l=="string"}e.isString=L;function k(l){return Array.isArray(l)&&l.every(S=>L(S))}e.isStringArray=k;function A(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.isObject=A;function T(l){return typeof l=="number"&&!isNaN(l)}e.isNumber=T;function R(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.isIterable=R;function y(l){return l===!0||l===!1}e.isBoolean=y;function p(l){return typeof l=="undefined"}e.isUndefined=p;function n(l){return!m(l)}e.isDefined=n;function m(l){return p(l)||l===null}e.isUndefinedOrNull=m;function h(l,S){if(!l)throw new Error(S?`Unexpected type, expected '${S}'`:"Unexpected type")}e.assertType=h;function b(l){if(m(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.assertIsDefined=b;function f(...l){const S=[];for(let w=0;w<l.length;w++){const g=l[w];if(m(g))throw new Error(`Assertion Failed: argument at index ${w} is undefined or null`);S.push(g)}return S}e.assertAllDefined=f;const C=Object.prototype.hasOwnProperty;function P(l){if(!A(l))return!1;for(let S in l)if(C.call(l,S))return!1;return!0}e.isEmptyObject=P;function E(l){return typeof l=="function"}e.isFunction=E;function I(...l){return l.length>0&&l.every(E)}e.areFunctions=I;function d(l,S){const w=Math.min(l.length,S.length);for(let g=0;g<w;g++)o(l[g],S[g])}e.validateConstraints=d;function o(l,S){if(L(S)){if(typeof l!==S)throw new Error(`argument does not match constraint: typeof ${S}`)}else if(E(S)){try{if(l instanceof S)return}catch(w){}if(!m(l)&&l.constructor===S||S.length===1&&S.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function s(l){let S=[],w=Object.getPrototypeOf(l);for(;Object.prototype!==w;)S=S.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return S}e.getAllPropertyNames=s;function t(l){const S=[];for(const w of s(l))typeof l[w]=="function"&&S.push(w);return S}e.getAllMethodNames=t;function r(l,S){const w=U=>function(){const F=Array.prototype.slice.call(arguments,0);return S(U,F)};let g={};for(const U of l)g[U]=w(U);return g}e.createProxyObject=r;function i(l){return l===null?void 0:l}e.withNullAsUndefined=i;function a(l){return typeof l=="undefined"?null:l}e.withUndefinedAsNull=a;function u(l){return class{constructor(){return new Proxy({},{get(S,w){if(S[w])return S[w];throw new Error(`Not Implemented: ${l}->${String(w)}`)}})}}}e.NotImplementedProxy=u;function c(l){throw new Error("Unreachable")}e.assertNever=c}),define(Z[41],ee([0,1,7,20,8,16]),function(G,e,v,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(i){return i===47||i===92}e.isPathSeparator=T;function R(i){return i.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=R;function y(i){return i.indexOf("/")===-1&&(i=R(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=y;function p(i,a=k.posix.sep){if(!i)return"";const u=i.length,c=i.charCodeAt(0);if(T(c)){if(T(i.charCodeAt(1))&&!T(i.charCodeAt(2))){let S=3;const w=S;for(;S<u&&!T(i.charCodeAt(S));S++);if(w!==S&&!T(i.charCodeAt(S+1))){for(S+=1;S<u;S++)if(T(i.charCodeAt(S)))return i.slice(0,S+1).replace(/[\\/]/g,a)}}return a}else if(E(c)&&i.charCodeAt(1)===58)return T(i.charCodeAt(2))?i.slice(0,2)+a:i.slice(0,2);let l=i.indexOf("://");if(l!==-1){for(l+=3;l<u;l++)if(T(i.charCodeAt(l)))return i.slice(0,l+1)}return""}e.getRoot=p;function n(i){if(!v.isWindows||!i||i.length<5)return!1;let a=i.charCodeAt(0);if(a!==92||(a=i.charCodeAt(1),a!==92))return!1;let u=2;const c=u;for(;u<i.length&&(a=i.charCodeAt(u),a!==92);u++);return!(c===u||(a=i.charCodeAt(u+1),isNaN(a)||a===92))}e.isUNC=n;const m=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(i,a=v.isWindows){const u=a?m:h;return!(!i||i.length===0||/^\s+$/.test(i)||(u.lastIndex=0,u.test(i))||a&&b.test(i)||i==="."||i===".."||a&&i[i.length-1]==="."||a&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=f;function C(i,a,u){const c=i===a;return!u||c?c:!i||!a?!1:L.equalsIgnoreCase(i,a)}e.isEqual=C;function P(i,a,u,c=k.sep){if(i===a)return!0;if(!i||!a||a.length>i.length)return!1;if(u){if(!L.startsWithIgnoreCase(i,a))return!1;if(a.length===i.length)return!0;let S=a.length;return a.charAt(a.length-1)===c&&S--,i.charAt(S)===c}return a.charAt(a.length-1)!==c&&(a+=c),i.indexOf(a)===0}e.isEqualOrParent=P;function E(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=E;function I(i,a){return v.isWindows&&i.endsWith(":")&&(i+=k.sep),k.isAbsolute(i)||(i=k.join(a,i)),i=k.normalize(i),v.isWindows?(i=L.rtrim(i,k.sep),i.endsWith(":")&&(i+=k.sep)):(i=L.rtrim(i,k.sep),i||(i=k.sep)),i}e.sanitizeFilePath=I;function d(i){const a=k.normalize(i);return v.isWindows?i.length>3?!1:o(a)&&(i.length===2||a.charCodeAt(2)===92):a===k.posix.sep}e.isRootOrDriveLetter=d;function o(i){return v.isWindows?E(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function s(i){return o(i)?i[0]:void 0}e.getDriveLetter=s;function t(i,a,u){return a.length>i.length?-1:i===a?0:(u&&(i=i.toLowerCase(),a=a.toLowerCase()),i.indexOf(a))}e.indexOfPath=t;function r(i){const a=i.split(":");let u,c,l;if(a.forEach(S=>{const w=Number(S);A.isNumber(w)?c===void 0?c=w:l===void 0&&(l=w):u=u?[u,S].join(":"):S}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:c!==void 0?c:void 0,column:l!==void 0?l:c!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(Z[26],ee([0,1,16]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(C){if(!C||typeof C!="object"||C instanceof RegExp)return C;const P=Array.isArray(C)?[]:{};return Object.keys(C).forEach(E=>{C[E]&&typeof C[E]=="object"?P[E]=L(C[E]):P[E]=C[E]}),P}e.deepClone=L;function k(C){if(!C||typeof C!="object")return C;const P=[C];for(;P.length>0;){const E=P.shift();Object.freeze(E);for(const I in E)if(A.call(E,I)){const d=E[I];typeof d=="object"&&!Object.isFrozen(d)&&P.push(d)}}return C}e.deepFreeze=k;const A=Object.prototype.hasOwnProperty;function T(C,P){return R(C,P,new Set)}e.cloneAndChange=T;function R(C,P,E){if(v.isUndefinedOrNull(C))return C;const I=P(C);if(typeof I!="undefined")return I;if(v.isArray(C)){const d=[];for(const o of C)d.push(R(o,P,E));return d}if(v.isObject(C)){if(E.has(C))throw new Error("Cannot clone recursive data-structure");E.add(C);const d={};for(let o in C)A.call(C,o)&&(d[o]=R(C[o],P,E));return E.delete(C),d}return C}function y(C,P,E=!0){return v.isObject(C)?(v.isObject(P)&&Object.keys(P).forEach(I=>{I in C?E&&(v.isObject(C[I])&&v.isObject(P[I])?y(C[I],P[I],E):C[I]=P[I]):C[I]=P[I]}),C):P}e.mixin=y;function p(C,P){if(C===P)return!0;if(C==null||P===null||P===void 0||typeof C!=typeof P||typeof C!="object"||Array.isArray(C)!==Array.isArray(P))return!1;let E,I;if(Array.isArray(C)){if(C.length!==P.length)return!1;for(E=0;E<C.length;E++)if(!p(C[E],P[E]))return!1}else{const d=[];for(I in C)d.push(I);d.sort();const o=[];for(I in P)o.push(I);if(o.sort(),!p(d,o))return!1;for(E=0;E<d.length;E++)if(!p(C[d[E]],P[d[E]]))return!1}return!0}e.equals=p;function n(C){const P=new Set;return JSON.stringify(C,(E,I)=>{if(v.isObject(I)||Array.isArray(I)){if(P.has(I))return"[Circular]";P.add(I)}return I})}e.safeStringify=n;function m(C,P,E){const I=P(C);return typeof I=="undefined"?E:I}e.getOrDefault=m;function h(C,P){const E=Object.create(null);return!C||!P||Object.keys(P).forEach(d=>{const o=C[d],s=P[d];p(o,s)||(E[d]=s)}),E}e.distinct=h;function b(C,P){const E=P.toLowerCase(),I=Object.keys(C).find(d=>d.toLowerCase()===E);return I?C[I]:C[P]}e.getCaseInsensitive=b;function f(C,P){const E=Object.create(null);for(const I of Object.keys(C))P(I,C[I])&&(E[I]=C[I]);return E}e.filter=f}),define(Z[5],ee([0,1,7,8]),function(G,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,A=/^\//,T=/^\/\//;function R(i,a){if(!i.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!k.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(i,a){return!i&&!a?"file":i}function p(i,a){switch(i){case"https":case"http":case"file":a?a[0]!==m&&(a=m+a):a=m;break}return a}const n="",m="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(a,u,c,l,S,w=!1){typeof a=="object"?(this.scheme=a.scheme||n,this.authority=a.authority||n,this.path=a.path||n,this.query=a.query||n,this.fragment=a.fragment||n):(this.scheme=y(a,w),this.authority=u||n,this.path=p(this.scheme,c||n),this.query=l||n,this.fragment=S||n,R(this,w))}static isUri(a){return a instanceof b?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return d(this,!1)}with(a){if(!a)return this;let{scheme:u,authority:c,path:l,query:S,fragment:w}=a;return u===void 0?u=this.scheme:u===null&&(u=n),c===void 0?c=this.authority:c===null&&(c=n),l===void 0?l=this.path:l===null&&(l=n),S===void 0?S=this.query:S===null&&(S=n),w===void 0?w=this.fragment:w===null&&(w=n),u===this.scheme&&c===this.authority&&l===this.path&&S===this.query&&w===this.fragment?this:new C(u,c,l,S,w)}static parse(a,u=!1){const c=h.exec(a);return c?new C(c[2]||n,r(c[4]||n),r(c[5]||n),r(c[7]||n),r(c[9]||n),u):new C(n,n,n,n,n)}static file(a){let u=n;if(v.isWindows&&(a=a.replace(/\\/g,m)),a[0]===m&&a[1]===m){const c=a.indexOf(m,2);c===-1?(u=a.substring(2),a=m):(u=a.substring(2,c),a=a.substring(c)||m)}return new C("file",u,a,n,n)}static from(a){const u=new C(a.scheme,a.authority,a.path,a.query,a.fragment);return R(u,!0),u}static joinPath(a,...u){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return v.isWindows&&a.scheme==="file"?c=b.file(L.win32.join(d(a,!0),...u)).path:c=L.posix.join(a.path,...u),a.with({path:c})}toString(a=!1){return o(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof b)return a;{const u=new C(a);return u._formatted=a.external,u._fsPath=a._sep===f?a.fsPath:null,u}}else return a}}e.URI=b;const f=v.isWindows?1:void 0;class C extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(a=!1){return a?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=f),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const P={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function E(i,a){let u,c=-1;for(let l=0;l<i.length;l++){const S=i.charCodeAt(l);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||a&&S===47)c!==-1&&(u+=encodeURIComponent(i.substring(c,l)),c=-1),u!==void 0&&(u+=i.charAt(l));else{u===void 0&&(u=i.substr(0,l));const w=P[S];w!==void 0?(c!==-1&&(u+=encodeURIComponent(i.substring(c,l)),c=-1),u+=w):c===-1&&(c=l)}}return c!==-1&&(u+=encodeURIComponent(i.substring(c))),u!==void 0?u:i}function I(i){let a;for(let u=0;u<i.length;u++){const c=i.charCodeAt(u);c===35||c===63?(a===void 0&&(a=i.substr(0,u)),a+=P[c]):a!==void 0&&(a+=i[u])}return a!==void 0?a:i}function d(i,a){let u;return i.authority&&i.path.length>1&&i.scheme==="file"?u=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?a?u=i.path.substr(1):u=i.path[1].toLowerCase()+i.path.substr(2):u=i.path,v.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=d;function o(i,a){const u=a?I:E;let c="",{scheme:l,authority:S,path:w,query:g,fragment:U}=i;if(l&&(c+=l,c+=":"),(S||l==="file")&&(c+=m,c+=m),S){let F=S.indexOf("@");if(F!==-1){const j=S.substr(0,F);S=S.substr(F+1),F=j.indexOf(":"),F===-1?c+=u(j,!1):(c+=u(j.substr(0,F),!1),c+=":",c+=u(j.substr(F+1),!1)),c+="@"}S=S.toLowerCase(),F=S.indexOf(":"),F===-1?c+=u(S,!1):(c+=u(S.substr(0,F),!1),c+=S.substr(F))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const F=w.charCodeAt(1);F>=65&&F<=90&&(w=`/${String.fromCharCode(F+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const F=w.charCodeAt(0);F>=65&&F<=90&&(w=`${String.fromCharCode(F+32)}:${w.substr(2)}`)}c+=u(w,!0)}return g&&(c+="?",c+=u(g,!1)),U&&(c+="#",c+=a?U:E(U,!1)),c}function s(i){try{return decodeURIComponent(i)}catch(a){return i.length>3?i.substr(0,3)+s(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(t)?i.replace(t,a=>s(a)):i}}),define(Z[90],ee([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(p){const n=p;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=L;function k(p){const n=[];let m;try{const h=JSON.parse(p.arguments),b=h[h.length-1];b&&b.__$stack&&(h.pop(),m=b.__$stack),n.push(...h)}catch(h){n.push("Unable to log remote console arguments",p.arguments)}return{args:n,stack:m}}e.parse=k;function A(p){if(typeof p!="string")return A(k(p).stack);const n=p;if(n){const m=T(n),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(m||"");if(h&&h.length===4)return{uri:v.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}e.getFirstFrame=A;function T(p){if(!p)return p;const n=p.indexOf(`
`);return n===-1?p:p.substring(0,n)}function R(p,n){const{args:m,stack:h}=k(p),b=typeof m[0]=="string"&&m.length===1;let f=T(h);f&&(f=`(${f.trim()})`);let C=[];if(typeof m[0]=="string"?f&&b?C=[`%c[${n}] %c${m[0]} %c${f}`,y("blue"),y(""),y("grey")]:C=[`%c[${n}] %c${m[0]}`,y("blue"),y(""),...m.slice(1)]:C=[`%c[${n}]%`,y("blue"),...m],f&&!b&&C.push(f),typeof console[p.severity]!="function")throw new Error("Unknown console method");console[p.severity].apply(console,C)}e.log=R;function y(p){return`color: ${p}`}});var dt=this&&this.__classPrivateFieldSet||function(G,e,v,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!k:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(G,v):k?k.value=v:e.set(G,v),v},ze=this&&this.__classPrivateFieldGet||function(G,e,v,L){if(v==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!L:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?L:v==="a"?L.call(G):L?L.value:e.get(G)};define(Z[38],ee([0,1,5,20]),function(G,e,v,L){"use strict";var k,A,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(t,r,i){let a=t.get(r);return a===void 0&&(a=i,t.set(r,a)),a}e.getOrSet=R;function y(t){const r=[];return t.forEach((i,a)=>{r.push(`${a} => ${i}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=y;function p(t){const r=[];return t.forEach(i=>{r.push(i)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=p;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),a=this._value.charCodeAt(this._pos);return i-a}value(){return this._value[this._pos]}}e.StringIterator=n;class m{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?L.compareSubstring(r,this._value,0,r.length,this._from,this._to):L.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=m;class h{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?L.compareSubstring(r,this._value,0,r.length,this._from,this._to):L.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=h;var b;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(b||(b={}));class f{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new h(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return L.compareIgnoreCase(r,this._value.scheme);if(this._states[this._stateIdx]===2)return L.compareIgnoreCase(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return L.compare(r,this._value.query);if(this._states[this._stateIdx]===5)return L.compare(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class C{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class P{constructor(r){this._iter=r}static forUris(r=()=>!1){return new P(new f(r))}static forPaths(){return new P(new h)}static forStrings(){return new P(new n)}static forConfigKeys(){return new P(new m)}clear(){this._root=void 0}set(r,i){const a=this._iter.reset(r);let u;for(this._root||(this._root=new C,this._root.segment=a.value()),u=this._root;;){const l=a.cmp(u.segment);if(l>0)u.left||(u.left=new C,u.left.segment=a.value()),u=u.left;else if(l<0)u.right||(u.right=new C,u.right.segment=a.value()),u=u.right;else if(a.hasNext())a.next(),u.mid||(u.mid=new C,u.mid.segment=a.value()),u=u.mid;else break}const c=u.value;return u.value=i,u.key=r,c}get(r){var i;return(i=this._getNode(r))===null||i===void 0?void 0:i.value}_getNode(r){const i=this._iter.reset(r);let a=this._root;for(;a;){const u=i.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(i.hasNext())i.next(),a=a.mid;else break}return a}has(r){const i=this._getNode(r);return!((i==null?void 0:i.value)===void 0&&(i==null?void 0:i.mid)===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const a=this._iter.reset(r),u=[];let c=this._root;for(;c;){const l=a.cmp(c.segment);if(l>0)u.push([1,c]),c=c.left;else if(l<0)u.push([-1,c]),c=c.right;else if(a.hasNext())a.next(),u.push([0,c]),c=c.mid;else{for(i?(c.left=void 0,c.mid=void 0,c.right=void 0):c.value=void 0;u.length>0&&c.isEmpty();){let[S,w]=u.pop();switch(S){case 1:w.left=void 0;break;case 0:w.mid=void 0;break;case-1:w.right=void 0;break}c=w}break}}}findSubstr(r){const i=this._iter.reset(r);let a=this._root,u;for(;a;){const c=i.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(i.hasNext())i.next(),u=a.value||u,a=a.mid;else break}return a&&a.value||u}findSuperstr(r){const i=this._iter.reset(r);let a=this._root;for(;a;){const u=i.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(i.hasNext())i.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(r){for(const[i,a]of this)r(a,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const i=[r];for(;i.length>0;){const a=i.pop();a&&(a.value&&(yield[a.key,a.value]),a.left&&i.push(a.left),a.mid&&i.push(a.mid),a.right&&i.push(a.right))}}}e.TernarySearchTree=P;class E{constructor(r,i){this[k]="ResourceMap",r instanceof E?(this.map=new Map(r.map),this.toKey=i??E.defaultToKey):(this.map=new Map,this.toKey=r??E.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[a,u]of this.map)r(u,v.URI.parse(a),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield v.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[v.URI.parse(r[0]),r[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[v.URI.parse(r[0]),r[1]]}}e.ResourceMap=E,E.defaultToKey=t=>t.toString();var I;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(I=e.Touch||(e.Touch={}));class d{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var r;return(r=this._head)===null||r===void 0?void 0:r.value}get last(){var r;return(r=this._tail)===null||r===void 0?void 0:r.value}has(r){return this._map.has(r)}get(r,i=0){const a=this._map.get(r);if(!!a)return i!==0&&this.touch(a,i),a.value}set(r,i,a=0){let u=this._map.get(r);if(u)u.value=i,a!==0&&this.touch(u,a);else{switch(u={key:r,value:i,next:void 0,previous:void 0},a){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(r,u),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const a=this._state;let u=this._head;for(;u;){if(i?r.bind(i)(u.value,u.key,this):r(u.value,u.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,i=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const c={value:a.key,done:!1};return a=a.next,c}else return{value:void 0,done:!0}}};return u}values(){const r=this,i=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const c={value:a.value,done:!1};return a=a.next,c}else return{value:void 0,done:!0}}};return u}entries(){const r=this,i=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const c={value:[a.key,a.value],done:!1};return a=a.next,c}else return{value:void 0,done:!0}}};return u}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,a=this.size;for(;i&&a>r;)this._map.delete(i.key),i=i.next,a--;this._head=i,this._size=a,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,a=r.previous;if(!i||!a)throw new Error("Invalid list");i.previous=a,a.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const a=r.next,u=r.previous;r===this._tail?(u.next=void 0,this._tail=u):(a.previous=u,u.next=a),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const a=r.next,u=r.previous;r===this._head?(a.previous=void 0,this._head=a):(a.previous=u,u.next=a),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,a)=>{r.push([a,i])}),r}fromJSON(r){this.clear();for(const[i,a]of r)this.set(i,a)}}e.LinkedMap=d;class o extends d{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class s{constructor(r){T.set(this,void 0),dt(this,T,r,"f")}get size(){return ze(this,T,"f").size}forEach(r,i){ze(this,T,"f").forEach(r,i)}get(r){return ze(this,T,"f").get(r)}has(r){return ze(this,T,"f").has(r)}entries(){return ze(this,T,"f").entries()}keys(){return ze(this,T,"f").keys()}values(){return ze(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return ze(this,T,"f").entries()}}e.ReadonlyMapView=s}),define(Z[91],ee([0,1,25,20,5]),function(G,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(n){return JSON.stringify(n,y)}e.stringify=A;function T(n){let m=JSON.parse(n);return m=p(m),m}e.parse=T;var R;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(R=e.MarshalledId||(e.MarshalledId={}));function y(n,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:L.regExpFlags(m)}:m}function p(n,m=0){if(!n||m>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return k.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof v.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let h=0;h<n.length;++h)n[h]=p(n[h],m+1);else for(const h in n)Object.hasOwnProperty.call(n,h)&&(n[h]=p(n[h],m+1))}return n}e.revive=p}),define(Z[17],ee([0,1,5,7]),function(G,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,p,n){this._hosts[y]=p,this._ports[y]=n}setConnectionToken(y,p){this._connectionTokens[y]=p}rewrite(y){if(this._delegate)return this._delegate(y);const p=y.authority;let n=this._hosts[p];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const m=this._ports[p],h=this._connectionTokens[p];let b=`path=${encodeURIComponent(y.path)}`;return typeof h=="string"&&(b+=`&tkn=${encodeURIComponent(h)}`),v.URI.from({scheme:L.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${n}:${m}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new A;class T{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,p,n){const m=this.toUri(y,p);if(m.scheme===k.vscodeRemote)return e.RemoteAuthorities.rewrite(m);let h=!1;return L.isNative&&(n||L.isPreferringBrowserCodeLoad)&&m.scheme===k.file&&(h=!0),m.scheme===k.file&&typeof L.globals.importScripts=="function"&&L.globals.origin==="vscode-file://vscode-app"&&(h=!0),h?m.with({scheme:k.vscodeFileResource,authority:m.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):m}asFileUri(y,p){const n=this.toUri(y,p);return n.scheme===k.vscodeFileResource?n.with({scheme:k.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(y,p){return v.URI.isUri(y)?y:v.URI.parse(p.toUrl(y))}}e.FileAccess=new T}),define(Z[67],ee([0,1,38]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const L=new v.LRUCache(1e4);function k(p){return y(p,"NFC",L)}e.normalizeNFC=k;const A=new v.LRUCache(1e4);function T(p){return y(p,"NFD",A)}e.normalizeNFD=T;const R=/[^\u0000-\u0080]/;function y(p,n,m){if(!e.canNormalize||!p)return p;const h=m.get(p);if(h)return h;let b;return R.test(p)?b=p.normalize(n):b=p,m.set(p,b),b}e.removeAccents=function(){if(e.canNormalize){const p=/[\u0300-\u036f]/g;return function(n){return T(n).replace(p,"")}}else return function(p){return p}}()}),define(Z[12],ee([0,1,41,8,5,20,17,7]),function(G,e,v,L,k,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(b){return k.uriToFsPath(b,!0)}e.originalFSPath=y;class p{constructor(f){this._ignorePathCasing=f}compare(f,C,P=!1){return f===C?0:A.compare(this.getComparisonKey(f,P),this.getComparisonKey(C,P))}isEqual(f,C,P=!1){return f===C?!0:!f||!C?!1:this.getComparisonKey(f,P)===this.getComparisonKey(C,P)}getComparisonKey(f,C=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:C?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,C,P=!1){if(f.scheme===C.scheme){if(f.scheme===T.Schemas.file)return v.isEqualOrParent(y(f),y(C),this._ignorePathCasing(f))&&f.query===C.query&&(P||f.fragment===C.fragment);if(e.isEqualAuthority(f.authority,C.authority))return v.isEqualOrParent(f.path,C.path,this._ignorePathCasing(f),"/")&&f.query===C.query&&(P||f.fragment===C.fragment)}return!1}joinPath(f,...C){return k.URI.joinPath(f,...C)}basenameOrAuthority(f){return e.basename(f)||f.authority}basename(f){return L.posix.basename(f.path)}extname(f){return L.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let C;return f.scheme===T.Schemas.file?C=k.URI.file(L.dirname(y(f))).path:(C=L.posix.dirname(f.path),f.authority&&C.length&&C.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),C="/")),f.with({path:C})}normalizePath(f){if(!f.path.length)return f;let C;return f.scheme===T.Schemas.file?C=k.URI.file(L.normalize(y(f))).path:C=L.posix.normalize(f.path),f.with({path:C})}relativePath(f,C){if(f.scheme!==C.scheme||!e.isEqualAuthority(f.authority,C.authority))return;if(f.scheme===T.Schemas.file){const I=L.relative(y(f),y(C));return R.isWindows?v.toSlashes(I):I}let P=f.path||"/",E=C.path||"/";if(this._ignorePathCasing(f)){let I=0;for(const d=Math.min(P.length,E.length);I<d&&!(P.charCodeAt(I)!==E.charCodeAt(I)&&P.charAt(I).toLowerCase()!==E.charAt(I).toLowerCase());I++);P=E.substr(0,I)+P.substr(I)}return L.posix.relative(P,E)}resolvePath(f,C){if(f.scheme===T.Schemas.file){const P=k.URI.file(L.resolve(y(f),C));return f.with({authority:P.authority,path:P.path})}return C=v.toPosixPath(C),f.with({path:L.posix.resolve(f.path,C)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,C){return f===C||A.equalsIgnoreCase(f,C)}hasTrailingPathSeparator(f,C=L.sep){if(f.scheme===T.Schemas.file){const P=y(f);return P.length>v.getRoot(P).length&&P[P.length-1]===C}else{const P=f.path;return P.length>1&&P.charCodeAt(P.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,C=L.sep){return e.hasTrailingPathSeparator(f,C)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,C=L.sep){let P=!1;if(f.scheme===T.Schemas.file){const E=y(f);P=E!==void 0&&E.length===v.getRoot(E).length&&E[E.length-1]===C}else{C="/";const E=f.path;P=E.length===1&&E.charCodeAt(E.length-1)===47}return!P&&!e.hasTrailingPathSeparator(f,C)?f.with({path:f.path+"/"}):f}}e.ExtUri=p,e.extUri=new p(()=>!1),e.extUriBiasedIgnorePathCase=new p(b=>b.scheme===T.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new p(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(b,f){const C=[];for(let P=0;P<b.length;P++){const E=f(b[P]);b.some((I,d)=>d===P?!1:e.isEqualOrParent(E,f(I)))||C.push(b[P])}return C}e.distinctParents=n;var m;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function f(C){const P=new Map;C.path.substring(C.path.indexOf(";")+1,C.path.lastIndexOf(";")).split(";").forEach(d=>{const[o,s]=d.split(":");o&&s&&P.set(o,s)});const I=C.path.substring(0,C.path.indexOf(";"));return I&&P.set(b.META_DATA_MIME,I),P}b.parseMetaData=f})(m=e.DataUri||(e.DataUri={}));function h(b,f,C){if(f){let P=b.path;return P&&P[0]!==L.posix.sep&&(P=L.posix.sep+P),b.with({scheme:C,authority:f,path:P})}return b.with({scheme:C})}e.toLocalResource=h}),define(Z[6],ee([0,1,29,11,3,2,66,12]),function(G,e,v,L,k,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(O){return!!O&&typeof O.then=="function"}e.isThenable=y;function p(O){const D=new v.CancellationTokenSource,M=O(D.token),_=new Promise((x,B)=>{D.token.onCancellationRequested(()=>{B(L.canceled())}),Promise.resolve(M).then(J=>{D.dispose(),x(J)},J=>{D.dispose(),B(J)})});return new class{cancel(){D.cancel()}then(x,B){return _.then(x,B)}catch(x){return this.then(void 0,x)}finally(x){return _.finally(x)}}}e.createCancelablePromise=p;function n(O,D,M){return Promise.race([O,new Promise(_=>D.onCancellationRequested(()=>_(M)))])}e.raceCancellation=n;async function m(O){let D=-1;const M=O.map((x,B)=>x.then(J=>(D=B,J))),_=await Promise.race(M);return O.forEach((x,B)=>{B!==D&&x.cancel()}),_}e.raceCancellablePromises=m;function h(O,D,M){let _;const x=setTimeout(()=>{_==null||_(void 0),M==null||M()},D);return Promise.race([O.finally(()=>clearTimeout(x)),new Promise(B=>_=B)])}e.raceTimeout=h;function b(O){return new Promise((D,M)=>{const _=O();y(_)?_.then(D,M):D(_)})}e.asPromise=b;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(D){if(this.activePromise){if(this.queuedPromiseFactory=D,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(M,M).then(_)})}return new Promise((M,_)=>{this.queuedPromise.then(M,_)})}return this.activePromise=D(),new Promise((M,_)=>{this.activePromise.then(x=>{this.activePromise=null,M(x)},x=>{this.activePromise=null,_(x)})})}}e.Throttler=f;class C{constructor(){this.current=Promise.resolve(null)}queue(D){return this.current=this.current.then(()=>D(),()=>D())}}e.Sequencer=C;class P{constructor(){this.promiseMap=new Map}queue(D,M){var _;const B=((_=this.promiseMap.get(D))!==null&&_!==void 0?_:Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(D)===B&&this.promiseMap.delete(D)});return this.promiseMap.set(D,B),B}}e.SequencerByKey=P;class E{constructor(D){this.defaultDelay=D,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(D,M=this.defaultDelay){return this.task=D,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((_,x)=>{this.doResolve=_,this.doReject=x}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const _=this.task;return this.task=null,_()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},M),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(L.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=E;class I{constructor(D){this.delayer=new E(D),this.throttler=new f}trigger(D,M){return this.delayer.trigger(()=>this.throttler.queue(D),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=I;class d{constructor(){this._isOpen=!1,this._promise=new Promise((D,M)=>{this._completePromise=D})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=d;class o extends d{constructor(D){super();this._timeout=setTimeout(()=>this.open(),D)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function s(O,D){return D?new Promise((M,_)=>{const x=setTimeout(M,O);D.onCancellationRequested(()=>{clearTimeout(x),_(L.canceled())})}):p(M=>s(O,M))}e.timeout=s;function t(O,D=0){const M=setTimeout(O,D);return A.toDisposable(()=>clearTimeout(M))}e.disposableTimeout=t;function r(O){return O.then(void 0,D=>{})}e.ignoreErrors=r;function i(O){const D=[];let M=0;const _=O.length;function x(){return M<_?O[M++]():null}function B(J){J!=null&&D.push(J);const X=x();return X?X.then(B):Promise.resolve(D)}return Promise.resolve(null).then(B)}e.sequence=i;function a(O,D=_=>!!_,M=null){let _=0;const x=O.length,B=()=>{if(_>=x)return Promise.resolve(M);const J=O[_++];return Promise.resolve(J()).then(te=>D(te)?Promise.resolve(te):B())};return B()}e.first=a;function u(O,D=_=>!!_,M=null){if(O.length===0)return Promise.resolve(M);let _=O.length;const x=()=>{var B,J;_=-1;for(const X of O)(J=(B=X).cancel)===null||J===void 0||J.call(B)};return new Promise((B,J)=>{for(const X of O)X.then(te=>{--_>=0&&D(te)?(x(),B(te)):_===0&&B(M)}).catch(te=>{--_>=0&&(x(),J(te))})})}e.firstParallel=u;class c{constructor(D){this._size=0,this.maxDegreeOfParalellism=D,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(D){return this._size++,new Promise((M,_)=>{this.outstandingPromises.push({factory:D,c:M,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const D=this.outstandingPromises.shift();this.runningPromises++;const M=D.factory();M.then(D.c,D.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=c;class l extends c{constructor(){super(1)}}e.Queue=l;class S{constructor(){this.queues=new Map}queueFor(D,M=R.extUri){const _=M.getComparisonKey(D);let x=this.queues.get(_);return x||(x=new l,k.Event.once(x.onFinished)(()=>{x==null||x.dispose(),this.queues.delete(_)}),this.queues.set(_,x)),x}dispose(){this.queues.forEach(D=>D.dispose()),this.queues.clear()}}e.ResourceQueue=S;class w{constructor(D,M){this._token=-1,typeof D=="function"&&typeof M=="number"&&this.setIfNotSet(D,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(D,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,D()},M)}setIfNotSet(D,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,D()},M))}}e.TimeoutTimer=w;class g{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(D,M){this.cancel(),this._token=setInterval(()=>{D()},M)}}e.IntervalTimer=g;class U{constructor(D,M){this.timeoutToken=-1,this.runner=D,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(D=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,D)}get delay(){return this.timeout}set delay(D){this.timeout=D}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=U;class F extends U{constructor(D,M){super(D,M);this.units=[]}work(D){this.units.push(D),this.isScheduled()||this.schedule()}doRun(){const D=this.units;this.units=[],this.runner&&this.runner(D)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F;class j extends A.Disposable{constructor(D,M,_,x){super();this.maxWorkChunkSize=D,this.maxPendingWork=M,this.throttleDelay=_,this.handler=x,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(D){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+D.length>this.maxPendingWork)return!1}else if(this.pending+D.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...D),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new U(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=j,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const O=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=D=>{const M=setTimeout(()=>D(O));let _=!1;return{dispose(){_||(_=!0,clearTimeout(M))}}}}else e.runWhenIdle=(O,D)=>{const M=requestIdleCallback(O,typeof D=="number"?{timeout:D}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(M))}}}}();class ${constructor(D){this._didRun=!1,this._executor=()=>{try{this._value=D()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=$;async function V(O,D,M){let _;for(let x=0;x<M;x++)try{return await O()}catch(B){_=B,await s(D)}throw _}e.retry=V;class q{hasPending(D){return this._pending?typeof D=="number"?this._pending.taskId===D:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var D;(D=this._pending)===null||D===void 0||D.cancel()}setPending(D,M,_){return this._pending={taskId:D,cancel:()=>_==null?void 0:_(),promise:M},M.then(()=>this.donePending(D),()=>this.donePending(D)),M}donePending(D){this._pending&&D===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const D=this._next;this._next=void 0,D.run().then(D.promiseResolve,D.promiseReject)}}setNext(D){if(this._next)this._next.run=D;else{let M,_;const x=new Promise((B,J)=>{M=B,_=J});this._next={run:D,promise:x,promiseResolve:M,promiseReject:_}}return this._next.promise}}e.TaskSequentializer=q;class z{constructor(D){this.interval=D,this.lastIncrementTime=0,this.value=0}increment(){const D=Date.now();return D-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=D,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class H{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((D,M)=>{this.completeCallback=D,this.errorCallback=M})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(D){return new Promise(M=>{this.completeCallback(D),this.resolved=!0,M()})}error(D){return new Promise(M=>{this.errorCallback(D),this.rejected=!0,M()})}cancel(){new Promise(D=>{this.errorCallback(L.canceled()),this.rejected=!0,D()})}}e.DeferredPromise=H;class Q extends k.Emitter{async fireAsync(D,M,_){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const x of this._listeners)this._asyncDeliveryQueue.push([x,D]);for(;this._asyncDeliveryQueue.size>0&&!M.isCancellationRequested;){const[x,B]=this._asyncDeliveryQueue.shift(),J=[],X=Object.assign(Object.assign({},B),{waitUntil:te=>{if(Object.isFrozen(J))throw new Error("waitUntil can NOT be called asynchronous");_&&(te=_(te,typeof x=="function"?x:x[0])),J.push(te)}});try{typeof x=="function"?x.call(void 0,X):x[0].call(x[1],X)}catch(te){L.onUnexpectedError(te);continue}Object.freeze(J),await N.settled(J).catch(te=>L.onUnexpectedError(te))}}}}e.AsyncEmitter=Q;var N;(function(O){async function D(B){return typeof Promise.allSettled=="function"?M(B):_(B)}O.allSettled=D;async function M(B){return Promise.allSettled(B)}async function _(B){return Promise.all(B.map(J=>J.then(X=>({status:"fulfilled",value:X}),X=>({status:"rejected",reason:X}))))}async function x(B){let J;const X=await Promise.all(B.map(te=>te.then(ie=>ie,ie=>{J||(J=ie)})));if(typeof J!="undefined")throw J;return X}O.settled=x})(N=e.Promises||(e.Promises={}))}),define(Z[68],ee([0,1,20,41,8,38,6]),function(G,e,v,L,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function R(){return Object.create(null)}e.getEmptyExpression=R;const y="**",p="/",n="[/\\\\]",m="[^/\\\\]",h=/\//g;function b(D){switch(D){case 0:return"";case 1:return`${m}*?`;default:return`(?:${n}|${m}+${n}|${n}${m}+)*?`}}function f(D,M){if(!D)return[];const _=[];let x=!1,B=!1,J="";for(const X of D){switch(X){case M:if(!x&&!B){_.push(J),J="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":B=!0;break;case"]":B=!1;break}J+=X}return J&&_.push(J),_}e.splitGlobAware=f;function C(D){if(!D)return"";let M="";const _=f(D,p);if(_.every(x=>x===y))M=".*";else{let x=!1;_.forEach((B,J)=>{if(B===y){x||(M+=b(2),x=!0);return}let X=!1,te="",ie=!1,ce="";for(const le of B){if(le!=="}"&&X){te+=le;continue}if(ie&&(le!=="]"||!ce)){let ve;le==="-"?ve=le:(le==="^"||le==="!")&&!ce?ve="^":le===p?ve="":ve=v.escapeRegExpCharacters(le),ce+=ve;continue}switch(le){case"{":X=!0;continue;case"[":ie=!0;continue;case"}":M+=`(?:${f(te,",").map(Ce=>C(Ce)).join("|")})`,X=!1,te="";break;case"]":M+="["+ce+"]",ie=!1,ce="";break;case"?":M+=m;continue;case"*":M+=b(1);continue;default:M+=v.escapeRegExpCharacters(le)}}J<_.length-1&&(_[J+1]!==y||J+2<_.length)&&(M+=n),x=!1})}return M}const P=/^\*\*\/\*\.[\w\.-]+$/,E=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),r=function(){return!1},i=function(){return null};function a(D,M){if(!D)return i;let _;typeof D!="string"?_=D.pattern:_=D,_=_.trim();const x=`${_}_${!!M.trimForExclusions}`;let B=t.get(x);if(B)return u(B,D);let J;if(P.test(_)){const X=_.substr(4);B=function(te,ie){return typeof te=="string"&&te.endsWith(X)?_:null}}else(J=E.exec(c(_,M)))?B=l(J[1],_):(M.trimForExclusions?d:I).test(_)?B=S(_,M):(J=o.exec(c(_,M)))?B=w(J[1].substr(1),_,!0):(J=s.exec(c(_,M)))?B=w(J[1],_,!1):B=g(_);return t.set(x,B),u(B,D)}function u(D,M){return typeof M=="string"?D:function(_,x){return L.isEqualOrParent(_,M.base)?D(k.relative(M.base,_),x):null}}function c(D,M){return M.trimForExclusions&&D.endsWith("/**")?D.substr(0,D.length-2):D}function l(D,M){const _=`/${D}`,x=`\\${D}`,B=function(X,te){return typeof X!="string"?null:te?te===D?M:null:X===D||X.endsWith(_)||X.endsWith(x)?M:null},J=[D];return B.basenames=J,B.patterns=[M],B.allBasenames=J,B}function S(D,M){const _=O(D.slice(1,-1).split(",").map(te=>a(te,M)).filter(te=>te!==i),D),x=_.length;if(!x)return i;if(x===1)return _[0];const B=function(te,ie){for(let ce=0,le=_.length;ce<le;ce++)if(_[ce](te,ie))return D;return null},J=_.find(te=>!!te.allBasenames);J&&(B.allBasenames=J.allBasenames);const X=_.reduce((te,ie)=>ie.allPaths?te.concat(ie.allPaths):te,[]);return X.length&&(B.allPaths=X),B}function w(D,M,_){const x=k.sep===k.posix.sep,B=x?D:D.replace(h,k.sep),J=k.sep+B,X=k.posix.sep+D,te=_?function(ie,ce){return typeof ie=="string"&&(ie===B||ie.endsWith(J)||!x&&(ie===D||ie.endsWith(X)))?M:null}:function(ie,ce){return typeof ie=="string"&&(ie===B||!x&&ie===D)?M:null};return te.allPaths=[(_?"*/":"./")+D],te}function g(D){try{const M=new RegExp(`^${C(D)}$`);return function(_){return M.lastIndex=0,typeof _=="string"&&M.test(_)?D:null}}catch(M){return i}}function U(D,M,_){return!D||typeof M!="string"?!1:F(D)(M,void 0,_)}e.match=U;function F(D,M={}){if(!D)return r;if(typeof D=="string"||q(D)){const _=a(D,M);if(_===i)return r;const x=function(B,J){return!!_(B,J)};return _.allBasenames&&(x.allBasenames=_.allBasenames),_.allPaths&&(x.allPaths=_.allPaths),x}return Q(D,M)}e.parse=F;function j(D){if(!D)return;let M;return _=>(M||(M=(D()||Promise.resolve([])).then(x=>x?V(x):{})),M.then(x=>!!x[_]))}e.hasSiblingPromiseFn=j;function $(D){if(!D)return;let M;return _=>{if(!M){const x=D();M=x?V(x):{}}return!!M[_]}}e.hasSiblingFn=$;function V(D){const M={};for(const _ of D)M[_]=!0;return M}function q(D){const M=D;return M&&typeof M.base=="string"&&typeof M.pattern=="string"}e.isRelativePattern=q;function z(D){return D.allBasenames||[]}e.getBasenameTerms=z;function H(D){return D.allPaths||[]}e.getPathTerms=H;function Q(D,M){const _=O(Object.getOwnPropertyNames(D).map(te=>N(te,D[te],M)).filter(te=>te!==i)),x=_.length;if(!x)return i;if(!_.some(te=>!!te.requiresSiblings)){if(x===1)return _[0];const te=function(le,ve){for(let pe=0,Ce=_.length;pe<Ce;pe++){const Ae=_[pe](le,ve);if(Ae)return Ae}return null},ie=_.find(le=>!!le.allBasenames);ie&&(te.allBasenames=ie.allBasenames);const ce=_.reduce((le,ve)=>ve.allPaths?le.concat(ve.allPaths):le,[]);return ce.length&&(te.allPaths=ce),te}const B=function(te,ie,ce){let le;for(let ve=0,pe=_.length;ve<pe;ve++){const Ce=_[ve];Ce.requiresSiblings&&ce&&(ie||(ie=k.basename(te)),le||(le=ie.substr(0,ie.length-k.extname(te).length)));const Ae=Ce(te,ie,le,ce);if(Ae)return Ae}return null},J=_.find(te=>!!te.allBasenames);J&&(B.allBasenames=J.allBasenames);const X=_.reduce((te,ie)=>ie.allPaths?te.concat(ie.allPaths):te,[]);return X.length&&(B.allPaths=X),B}function N(D,M,_){if(M===!1)return i;const x=a(D,_);if(x===i)return i;if(typeof M=="boolean")return x;if(M){const B=M.when;if(typeof B=="string"){const J=(X,te,ie,ce)=>{if(!ce||!x(X,te))return null;const le=B.replace("$(basename)",ie),ve=ce(le);return T.isThenable(ve)?ve.then(pe=>pe?D:null):ve?D:null};return J.requiresSiblings=!0,J}}return x}function O(D,M){const _=D.filter(te=>!!te.basenames);if(_.length<2)return D;const x=_.reduce((te,ie)=>{const ce=ie.basenames;return ce?te.concat(ce):te},[]);let B;if(M){B=[];for(let te=0,ie=x.length;te<ie;te++)B.push(M)}else B=_.reduce((te,ie)=>{const ce=ie.patterns;return ce?te.concat(ce):te},[]);const J=function(te,ie){if(typeof te!="string")return null;if(!ie){let le;for(le=te.length;le>0;le--){const ve=te.charCodeAt(le-1);if(ve===47||ve===92)break}ie=te.substr(le)}const ce=x.indexOf(ie);return ce!==-1?B[ce]:null};J.basenames=x,J.patterns=B,J.allBasenames=x;const X=D.filter(te=>!te.basenames);return X.push(J),X}}),define(Z[92],ee([0,1,8,20,68,17,12]),function(G,e,v,L,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var R;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(R=e.Mimes||(e.Mimes={}));let y=[],p=[],n=[];function m(r,i=!1){const a=h(r);y.push(a),a.userConfigured?n.push(a):p.push(a),i&&!a.userConfigured&&y.forEach(u=>{u.mime===a.mime||u.userConfigured||(a.extension&&u.extension===a.extension&&console.warn(`Overwriting extension <<${a.extension}>> to now point to mime <<${a.mime}>>`),a.filename&&u.filename===a.filename&&console.warn(`Overwriting filename <<${a.filename}>> to now point to mime <<${a.mime}>>`),a.filepattern&&u.filepattern===a.filepattern&&console.warn(`Overwriting filepattern <<${a.filepattern}>> to now point to mime <<${a.mime}>>`),a.firstline&&u.firstline===a.firstline&&console.warn(`Overwriting firstline <<${a.firstline}>> to now point to mime <<${a.mime}>>`))})}e.registerTextMime=m;function h(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?r.filepattern.toLowerCase():void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(v.posix.sep)>=0:!1}}function b(r){r?(y=y.filter(i=>!i.userConfigured),n=[]):(y=[],p=[],n=[])}e.clearTextMimes=b;function f(r,i){let a;if(r)switch(r.scheme){case A.Schemas.file:a=r.fsPath;break;case A.Schemas.data:a=T.DataUri.parseMetaData(r).get(T.DataUri.META_DATA_LABEL);break;default:a=r.path}if(!a)return[R.unknown];a=a.toLowerCase();const u=v.basename(a),c=C(a,u,n);if(c)return[c,R.text];const l=C(a,u,p);if(l)return[l,R.text];if(i){const S=P(i);if(S)return[S,R.text]}return[R.unknown]}e.guessMimeTypes=f;function C(r,i,a){let u=null,c=null,l=null;for(let S=a.length-1;S>=0;S--){const w=a[S];if(i===w.filenameLowercase){u=w;break}if(w.filepattern&&(!c||w.filepattern.length>c.filepattern.length)){const g=w.filepatternOnPath?r:i;k.match(w.filepatternLowercase,g)&&(c=w)}w.extension&&(!l||w.extension.length>l.extension.length)&&i.endsWith(w.extensionLowercase)&&(l=w)}return u?u.mime:c?c.mime:l?l.mime:null}function P(r){if(L.startsWithUTF8BOM(r)&&(r=r.substr(1)),r.length>0)for(let i=y.length-1;i>=0;i--){const a=y[i];if(!a.firstline)continue;const u=r.match(a.firstline);if(u&&u.length>0)return a.mime}return null}function E(r){return r?typeof r=="string"?r===R.binary||r===R.text||r===R.unknown:r.length===1&&E(r[0]):!0}e.isUnspecific=E;const I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function d(r){const i=v.extname(r);return I[i.toLowerCase()]}e.getMediaMime=d;function o(r){for(const i in I)if(I[i]===r)return i}e.getExtensionForMimeType=o;const s=/^(.+)\/(.+?)(;.+)?$/;function t(r,i){var a;const u=s.exec(r);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${(a=u[3])!==null&&a!==void 0?a:""}`:i?void 0:r}e.normalizeMimeType=t}),define(Z[93],ee([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(n){return n.toJSON()}class k{constructor(m){this._uriTransformer=m}transformIncoming(m){const h=this._uriTransformer.transformIncoming(m);return h===m?m:L(v.URI.from(h))}transformOutgoing(m){const h=this._uriTransformer.transformOutgoing(m);return h===m?m:L(v.URI.from(h))}transformOutgoingURI(m){const h=this._uriTransformer.transformOutgoing(m);return h===m?m:v.URI.from(h)}transformOutgoingScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function A(n,m,h){if(!n||h>200)return null;if(typeof n=="object"){if(n instanceof v.URI)return m.transformOutgoing(n);for(let b in n)if(Object.hasOwnProperty.call(n,b)){const f=A(n[b],m,h+1);f!==null&&(n[b]=f)}}return null}function T(n,m){const h=A(n,m,0);return h===null?n:h}e.transformOutgoingURIs=T;function R(n,m,h,b){if(!n||b>200)return null;if(typeof n=="object"){if(n.$mid===1)return h?v.URI.revive(m.transformIncoming(n)):m.transformIncoming(n);for(let f in n)if(Object.hasOwnProperty.call(n,f)){const C=R(n[f],m,h,b+1);C!==null&&(n[f]=C)}}return null}function y(n,m){const h=R(n,m,!1,0);return h===null?n:h}e.transformIncomingURIs=y;function p(n,m){const h=R(n,m,!0,0);return h===null?n:h}e.transformAndReviveIncomingURIs=p}),define(Z[30],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(y){return v.test(y)}e.isUUID=L;const k=new Uint8Array(16),A=[];for(let y=0;y<256;y++)A.push(y.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(y){for(let p=0;p<y.length;p++)y[p]=Math.floor(Math.random()*256);return y};function R(){T(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let y=0,p="";return p+=A[k[y++]],p+=A[k[y++]],p+=A[k[y++]],p+=A[k[y++]],p+="-",p+=A[k[y++]],p+=A[k[y++]],p+="-",p+=A[k[y++]],p+=A[k[y++]],p+="-",p+=A[k[y++]],p+=A[k[y++]],p+="-",p+=A[k[y++]],p+=A[k[y++]],p+=A[k[y++]],p+=A[k[y++]],p+=A[k[y++]],p+=A[k[y++]],p}e.generateUuid=R}),define(Z[69],ee([0,1,207]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(A="utf8"){this.stringDecoder=new v.StringDecoder(A),this.remaining=null}write(A){const T=[],R=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(R.length<1)return T;let y=0,p,n=y;for(;n<R.length;)if(p=R.charCodeAt(n),p===13||p===10){if(T.push(R.substring(y,n)),n++,n<R.length){const m=p;p=R.charCodeAt(n),(m===13&&p===10||m===10&&p===13)&&n++}y=n}else n++;return this.remaining=y<R.length?R.substr(y):null,T}end(){return this.remaining}}e.LineDecoder=L}),define(Z[94],ee([0,1,35]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(R){const y=R.replace(/\-/g,":").toLowerCase();return!L.has(y)}function A(){return new Promise(async(R,y)=>{const p=setTimeout(()=>y("Unable to retrieve mac address (timeout after 10s)"),1e4);try{R(await T())}catch(n){y(n)}finally{clearTimeout(p)}})}e.getMac=A;function T(){return new Promise((R,y)=>{try{const p=v.networkInterfaces();for(let n in p){const m=p[n];if(m){for(const{mac:h}of m)if(k(h))return R(h)}}y("Unable to retrieve mac address (unexpected format)")}catch(p){y(p)}})}}),define(Z[95],ee([0,1,11,30,35,38,94]),function(G,e,v,L,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=A.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,m=0;const h=k.networkInterfaces();for(let b in h){const f=h[b];if(f)for(const{mac:C,internal:P}of f)P||(m+=1,this._isVirtualMachineMacAdress(C.toUpperCase())&&(n+=1))}this._value=m>0?n/m:0}return this._value}};let R;async function y(){return R||(R=(async()=>await p()||L.generateUuid())()),R}e.getMachineId=y;async function p(){try{const n=await new Promise((h,b)=>{G(["crypto"],h,b)}),m=await T.getMac();return n.createHash("sha256").update(m,"utf8").digest("hex")}catch(n){v.onUnexpectedError(n);return}}}),define(Z[18],ee([0,1,48,35,208,8,6,7,41,30,67,12,5]),function(G,e,v,L,k,A,T,R,y,p,n,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function f(z,H=b.UNLINK){if(y.isRootOrDriveLetter(z))throw new Error("rimraf - will refuse to recursively delete root");return H===b.UNLINK?P(z):C(z)}async function C(z){try{const H=A.join(L.tmpdir(),p.generateUuid());try{await e.Promises.rename(z,H)}catch(Q){return P(z)}P(H).catch(Q=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function P(z){return e.Promises.rmdir(z,{recursive:!0,maxRetries:3})}function E(z){if(y.isRootOrDriveLetter(z))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(z,{recursive:!0})}e.rimrafSync=E;async function I(z,H){return s(await(H?d(z):k.promisify(v.readdir)(z)))}async function d(z){try{return await k.promisify(v.readdir)(z,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const H=[],Q=await I(z);for(const N of Q){let O=!1,D=!1,M=!1;try{const _=await e.Promises.lstat(A.join(z,N));O=_.isFile(),D=_.isDirectory(),M=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}H.push({name:N,isFile:()=>O,isDirectory:()=>D,isSymbolicLink:()=>M})}return H}function o(z){return s(v.readdirSync(z))}e.readdirSync=o;function s(z){return z.map(H=>typeof H=="string"?R.isMacintosh?n.normalizeNFC(H):H:(H.name=R.isMacintosh?n.normalizeNFC(H.name):H.name,H))}async function t(z){const H=await I(z),Q=[];for(const N of H)await i.existsDirectory(A.join(z,N))&&Q.push(N);return Q}function r(z,H=1e3){return new Promise(Q=>{let N=!1;const O=setInterval(()=>{N||(N=!0,v.access(z,D=>{N=!1,D&&(clearInterval(O),Q(void 0))}))},H)})}e.whenDeleted=r;var i;(function(z){async function H(O){let D;try{if(D=await e.Promises.lstat(O),!D.isSymbolicLink())return{stat:D}}catch(M){}try{return{stat:await e.Promises.stat(O),symbolicLink:(D==null?void 0:D.isSymbolicLink())?{dangling:!1}:void 0}}catch(M){if(M.code==="ENOENT"&&D)return{stat:D,symbolicLink:{dangling:!0}};if(R.isWindows&&M.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(O)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&D)return{stat:D,symbolicLink:{dangling:!0}};throw _}throw M}}z.stat=H;async function Q(O){try{const{stat:D,symbolicLink:M}=await z.stat(O);return D.isFile()&&(M==null?void 0:M.dangling)!==!0}catch(D){}return!1}z.existsFile=Q;async function N(O){try{const{stat:D,symbolicLink:M}=await z.stat(O);return D.isDirectory()&&(M==null?void 0:M.dangling)!==!0}catch(D){}return!1}z.existsDirectory=N})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const a=new T.ResourceQueue;function u(z,H,Q){return a.queueFor(h.URI.file(z),m.extUriBiasedIgnorePathCase).queue(()=>{const N=w(Q);return new Promise((O,D)=>l(z,H,N,M=>M?D(M):O()))})}let c=!0;function l(z,H,Q,N){if(!c)return v.writeFile(z,H,{mode:Q.mode,flag:Q.flag},N);v.open(z,Q.flag,Q.mode,(O,D)=>{if(O)return N(O);v.writeFile(D,H,M=>{if(M)return v.close(D,()=>N(M));v.fdatasync(D,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),c=!1),v.close(D,x=>N(x))))})})}function S(z,H,Q){const N=w(Q);if(!c)return v.writeFileSync(z,H,{mode:N.mode,flag:N.flag});const O=v.openSync(z,N.flag,N.mode);try{v.writeFileSync(O,H);try{v.fdatasyncSync(O)}catch(D){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",D),c=!1}}finally{v.closeSync(O)}}e.writeFileSync=S;function w(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function g(z,H){if(z===H)return;async function Q(N){try{const O=await e.Promises.lstat(N);if(O.isDirectory()||O.isSymbolicLink())return;await e.Promises.utimes(N,O.atime,new Date)}catch(O){}}try{await e.Promises.rename(z,H),await Q(H)}catch(N){if(z.toLowerCase()!==H.toLowerCase()&&N.code==="EXDEV"||z.endsWith("."))await U(z,H,{preserveSymlinks:!1}),await f(z,b.MOVE),await Q(H);else throw N}}async function U(z,H,Q){return j(z,H,{root:{source:z,target:H},options:Q,handledSourcePaths:new Set})}const F=511;async function j(z,H,Q){if(Q.handledSourcePaths.has(z))return;Q.handledSourcePaths.add(z);const{stat:N,symbolicLink:O}=await i.stat(z);if(O){if(Q.options.preserveSymlinks)try{return await q(z,H,Q)}catch(D){console.warn("[node.js fs] copy of symlink failed: ",D)}if(O.dangling)return}return N.isDirectory()?$(z,H,N.mode&F,Q):V(z,H,N.mode&F)}async function $(z,H,Q,N){await e.Promises.mkdir(H,{recursive:!0,mode:Q});const O=await I(z);for(const D of O)await j(A.join(z,D),A.join(H,D),N)}async function V(z,H,Q){await e.Promises.copyFile(z,H),await e.Promises.chmod(H,Q)}async function q(z,H,Q){let N=await e.Promises.readlink(z);y.isEqualOrParent(N,Q.root.source,!R.isLinux)&&(N=A.join(Q.root.target,N.substr(Q.root.source.length+1))),await e.Promises.symlink(N,H)}e.Promises=new class{get access(){return k.promisify(v.access)}get stat(){return k.promisify(v.stat)}get lstat(){return k.promisify(v.lstat)}get utimes(){return k.promisify(v.utimes)}get read(){return k.promisify(v.read)}get readFile(){return k.promisify(v.readFile)}get write(){return k.promisify(v.write)}get appendFile(){return k.promisify(v.appendFile)}get fdatasync(){return k.promisify(v.fdatasync)}get truncate(){return k.promisify(v.truncate)}get rename(){return k.promisify(v.rename)}get copyFile(){return k.promisify(v.copyFile)}get open(){return k.promisify(v.open)}get close(){return k.promisify(v.close)}get symlink(){return k.promisify(v.symlink)}get readlink(){return k.promisify(v.readlink)}get chmod(){return k.promisify(v.chmod)}get mkdir(){return k.promisify(v.mkdir)}get unlink(){return k.promisify(v.unlink)}get rmdir(){return k.promisify(v.rmdir)}get realpath(){return k.promisify(v.realpath)}async exists(z){try{return await e.Promises.access(z),!0}catch(H){return!1}}get readdir(){return I}get readDirsInDir(){return t}get writeFile(){return u}get rm(){return f}get move(){return g}get copy(){return U}}}),define(Z[96],ee([0,1,48,20,8,18]),function(G,e,v,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function T(n){const m=k.dirname(n);if(n===m)return n;const h=(k.basename(n)||n).toLowerCase();try{const f=A.readdirSync(m).filter(C=>C.toLowerCase()===h);if(f.length===1){const C=T(m);if(C)return k.join(C,f[0])}else if(f.length>1){const C=f.indexOf(h);if(C>=0){const P=T(m);if(P)return k.join(P,f[C])}}}catch(b){}return null}e.realcaseSync=T;async function R(n){try{return await A.Promises.realpath(n)}catch(m){const h=p(n);return await A.Promises.access(h,v.constants.R_OK),h}}e.realpath=R;function y(n){try{return v.realpathSync(n)}catch(m){const h=p(n);return v.accessSync(h,v.constants.R_OK),h}}e.realpathSync=y;function p(n){return L.rtrim(k.normalize(n),k.sep)}});var Le=this&&this.__await||function(G){return this instanceof Le?(this.v=G,this):new Le(G)},ut=this&&this.__asyncGenerator||function(G,e,v){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var L=v.apply(G,e||[]),k,A=[];return k={},T("next"),T("throw"),T("return"),k[Symbol.asyncIterator]=function(){return this},k;function T(h){L[h]&&(k[h]=function(b){return new Promise(function(f,C){A.push([h,b,f,C])>1||R(h,b)})})}function R(h,b){try{y(L[h](b))}catch(f){m(A[0][3],f)}}function y(h){h.value instanceof Le?Promise.resolve(h.value.v).then(p,n):m(A[0][2],h)}function p(h){R("next",h)}function n(h){R("throw",h)}function m(h,b){h(b),A.shift(),A.length&&R(A[0][0],A[0][1])}},tt=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],v;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),v={},L("next"),L("throw"),L("return"),v[Symbol.asyncIterator]=function(){return this},v);function L(A){v[A]=G[A]&&function(T){return new Promise(function(R,y){T=G[A](T),k(R,y,T.done,T.value)})}}function k(A,T,R,y){Promise.resolve(y).then(function(p){A({value:p,done:R})},T)}};define(Z[97],ee([0,1,18,35,8]),function(G,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,T=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var y;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(y||(y={}));let p;switch(process.arch){case"ia32":case"x32":p=1;break;case"arm":case"arm64":p=2;break;default:p=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class m{constructor(s,t,r){this.exePath=s,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await v.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:o=!1}={}){return o?p===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function b({useAlternateBitness:o=!1,findPreview:s=!1}={}){const t=h({useAlternateBitness:o});if(!t)return null;const r=k.join(t,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(r))return null;let i=-1,a=null;for(const l of await v.Promises.readdir(r)){let S=-1;if(s){const g=l.indexOf("-");if(g<0)continue;const U=l.substring(0,g);if(!A.test(U)||l.substring(g+1)!=="preview")continue;S=parseInt(U,10)}else{if(!A.test(l))continue;S=parseInt(l,10)}if(S<=i)continue;const w=k.join(r,l,"pwsh.exe");!await v.SymlinkSupport.existsFile(w)||(a=w,i=S)}if(!a)return null;const u=t.includes("x86")?" (x86)":"",c=s?" Preview":"";return new m(a,`PowerShell${c}${u}`,!0)}async function f({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const s=k.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=o?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const i of await v.Promises.readdir(s))if(t.test(i)){const a=k.join(s,i,"pwsh.exe");return new m(a,r)}return null}function C(){const o=k.join(L.homedir(),".dotnet","tools","pwsh.exe");return new m(o,".NET Core PowerShell Global Tool")}function P(){const o=k.join(process.env.windir,p===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new m(o,"Windows PowerShell",!0)}function E(){return ut(this,arguments,function*(){let s=yield Le(b());s&&(yield yield Le(s)),s=yield Le(b({useAlternateBitness:!0})),s&&(yield yield Le(s)),s=yield Le(f()),s&&(yield yield Le(s)),s=C(),s&&(yield yield Le(s)),s=yield Le(b({findPreview:!0})),s&&(yield yield Le(s)),s=yield Le(f({findPreview:!0})),s&&(yield yield Le(s)),s=yield Le(b({useAlternateBitness:!0,findPreview:!0})),s&&(yield yield Le(s)),s=P(),s&&(yield yield Le(s))})}function I(){return ut(this,arguments,function*(){var s,t;try{for(var r=tt(E()),i;i=yield Le(r.next()),!i.done;){const a=i.value;(yield Le(a.exists()))&&(yield yield Le(a))}}catch(a){s={error:a}}finally{try{i&&!i.done&&(t=r.return)&&(yield Le(t.call(r)))}finally{if(s)throw s.error}}})}e.enumeratePowerShellInstallations=I;async function d(){var o,s;try{for(var t=tt(I()),r;r=await t.next(),!r.done;)return r.value}catch(i){o={error:i}}finally{try{r&&!r.done&&(s=t.return)&&await s.call(t)}finally{if(o)throw o.error}}return null}e.getFirstAvailablePowerShellInstallation=d}),define(Z[98],ee([0,1,42,17]),function(G,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(T){return new Promise((R,y)=>{let p;const n=new Map;function m(b,f,C,P,E){const I=n.get(f);if(b===T||I){const d={name:h(C),cmd:C,pid:b,ppid:f,load:P,mem:E};n.set(b,d),b===T&&(p=d),I&&(I.children||(I.children=[]),I.children.push(d),I.children.length>1&&(I.children=I.children.sort((o,s)=>o.pid-s.pid)))}}function h(b){const f=/--disable-blink-features=Auxclick/,C=/\\watcher\\win32\\CodeHelper\.exe/,P=/--crashes-directory/,E=/\\pipe\\winpty-control/,I=/conhost\.exe/,d=/--type=([a-zA-Z-]+)/;if(C.exec(b))return"watcherService ";if(P.exec(b))return"electron-crash-reporter";if(E.exec(b))return"winpty-process";if(I.exec(b))return"console-window-host (Windows internal process)";let o=d.exec(b);if(o&&o.length===2)return o[1]==="renderer"?f.exec(b)?"shared-process":"window":o[1];const s=/[a-zA-Z-]+\.js/g;let t="";do o=s.exec(b),o&&(t+=o+" ");while(o);return t&&b.indexOf("node ")<0&&b.indexOf("node.exe")<0?`electron_node ${t}`:b}if(process.platform==="win32"){const b=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,C)=>{G(["windows-process-tree"],f,C)}).then(f=>{f.getProcessList(T,C=>{f.getProcessCpuUsage(C,P=>{const E=new Map;P.forEach(I=>{const d=b(I.commandLine||"");E.set(I.pid,{name:h(d),cmd:d,pid:I.pid,ppid:I.ppid,load:I.cpu||0,mem:I.memory||0})}),p=E.get(T),p?(E.forEach(I=>{const d=E.get(I.ppid);d&&(d.children||(d.children=[]),d.children.push(I))}),E.forEach(I=>{I.children&&(I.children=I.children.sort((d,o)=>d.pid-o.pid))}),R(p)):y(new Error(`Root process ${T} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let b=function(){let f=[p];const C=[];for(;f.length;){const E=f.shift();E&&(C.push(E.pid),E.children&&(f=f.concat(E.children)))}let P=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",G).fsPath);P+=" "+C.join(" "),v.exec(P,{},(E,I,d)=>{if(E||d)y(E||new Error(d.toString()));else{const o=I.toString().split(`
`);for(let s=0;s<C.length;s++){const t=n.get(C[s]);t.load=parseFloat(o[s])}if(!p){y(new Error(`Root process ${T} not found`));return}R(p)}})};v.exec("which ps",{},(f,C,P)=>{if(f||P)if(process.platform!=="linux")y(f||new Error(P.toString()));else{const E=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",G).fsPath);v.exec(E,{},(I,d,o)=>{I||o?y(I||new Error(o.toString())):(A(d,m),b())})}else{const E=C.toString().trim(),I="-ax -o pid=,ppid=,pcpu=,pmem=,command=";v.exec(`${E} ${I}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,o,s)=>{d||s&&!s.includes("screen size is bogus")?y(d||new Error(s.toString())):(A(o,m),process.platform==="linux"?b():p?R(p):y(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=k;function A(T,R){const y=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,p=T.toString().split(`
`);for(const n of p){const m=y.exec(n.trim());m&&m.length===6&&R(parseInt(m[1]),parseInt(m[2]),m[5],parseFloat(m[3]),parseFloat(m[4]))}}}),define(Z[99],ee([0,1,8,48,7,67,2,18]),function(G,e,v,L,k,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function y(m,h,b){return n({path:m,isDirectory:!1},h,b)}e.watchFile=y;function p(m,h,b){return n({path:m,isDirectory:!0},h,b)}e.watchFolder=p,e.CHANGE_BUFFER_DELAY=100;function n(m,h,b){const f=v.basename(m.path),C=new Map;let P=!1,E=[T.toDisposable(()=>{C.forEach(I=>T.dispose(I)),C.clear()})];try{const I=L.watch(m.path);E.push(T.toDisposable(()=>{I.removeAllListeners(),I.close()}));const d=new Set;m.isDirectory&&R.Promises.readdir(m.path).then(o=>o.forEach(s=>d.add(s))),I.on("error",(o,s)=>{P||b(`Failed to watch ${m.path} for changes using fs.watch() (${o}, ${s})`)}),I.on("change",(o,s)=>{if(P)return;let t="";if(s&&(t=s.toString(),k.isMacintosh&&(t=A.normalizeNFC(t))),!t||o!=="change"&&o!=="rename")return;const r=m.isDirectory?v.join(m.path,t):m.path;if(m.isDirectory)if(o==="rename"){const i=C.get(r);i&&T.dispose(i);const a=setTimeout(async()=>{C.delete(r);const u=await R.Promises.exists(r);if(P)return;let c;u?d.has(t)?c="changed":(c="added",d.add(t)):(d.delete(t),c="deleted"),h(c,r)},e.CHANGE_BUFFER_DELAY);C.set(r,T.toDisposable(()=>clearTimeout(a)))}else{let i;d.has(t)?i="changed":(i="added",d.add(t)),h(i,r)}else if(o==="rename"||t!==f){const i=setTimeout(async()=>{const a=await R.Promises.exists(r);P||(a?(h("changed",r),E=[n(m,h,b)]):h("deleted",r))},e.CHANGE_BUFFER_DELAY);T.dispose(E),E=[T.toDisposable(()=>clearTimeout(i))]}else h("changed",r)})}catch(I){R.Promises.exists(m.path).then(d=>{d&&!P&&b(`Failed to watch ${m.path} for changes using fs.watch() (${I.toString()})`)})}return T.toDisposable(()=>{P=!0,E=T.dispose(E)})}});var de=this&&this.__decorate||function(G,e,v,L){var k=arguments.length,A=k<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,v):L,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(G,e,v,L);else for(var R=G.length-1;R>=0;R--)(T=G[R])&&(A=(k<3?T(A):k>3?T(e,v,A):T(e,v))||A);return k>3&&A&&Object.defineProperty(e,v,A),A};define(Z[36],ee([0,1,3,2,6,29,11,25,19,16,91,20,64]),function(G,e,v,L,k,A,T,R,y,p,n,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(O){O[O.Promise=100]="Promise",O[O.PromiseCancel=101]="PromiseCancel",O[O.EventListen=102]="EventListen",O[O.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function f(O){switch(O){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var C;(function(O){O[O.Initialize=200]="Initialize",O[O.PromiseSuccess=201]="PromiseSuccess",O[O.PromiseError=202]="PromiseError",O[O.PromiseErrorObj=203]="PromiseErrorObj",O[O.EventFire=204]="EventFire"})(C=e.ResponseType||(e.ResponseType={}));function P(O){switch(O){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(O){O[O.Uninitialized=0]="Uninitialized",O[O.Idle=1]="Idle"})(E||(E={}));class I{constructor(D){this.buffer=D,this.pos=0}read(D){const M=this.buffer.slice(this.pos,this.pos+D);return this.pos+=M.byteLength,M}}class d{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(D){this.buffers.push(D)}}var o;(function(O){O[O.Undefined=0]="Undefined",O[O.String=1]="String",O[O.Buffer=2]="Buffer",O[O.VSBuffer=3]="VSBuffer",O[O.Array=4]="Array",O[O.Object=5]="Object"})(o||(o={}));function s(O){const D=R.VSBuffer.alloc(4);return D.writeUInt32BE(O,0),D}function t(O){return O.read(4).readUInt32BE(0)}function r(O){const D=R.VSBuffer.alloc(1);return D.writeUInt8(O,0),D}const i={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object)},a=typeof Buffer!="undefined";function u(O,D){if(typeof D=="undefined")O.write(i.Undefined);else if(typeof D=="string"){const M=R.VSBuffer.fromString(D);O.write(i.String),O.write(s(M.byteLength)),O.write(M)}else if(a&&Buffer.isBuffer(D)){const M=R.VSBuffer.wrap(D);O.write(i.Buffer),O.write(s(M.byteLength)),O.write(M)}else if(D instanceof R.VSBuffer)O.write(i.VSBuffer),O.write(s(D.byteLength)),O.write(D);else if(Array.isArray(D)){O.write(i.Array),O.write(s(D.length));for(const M of D)u(O,M)}else{const M=R.VSBuffer.fromString(JSON.stringify(D));O.write(i.Object),O.write(s(M.byteLength)),O.write(M)}}function c(O){switch(O.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return O.read(t(O)).toString();case o.Buffer:return O.read(t(O)).buffer;case o.VSBuffer:return O.read(t(O));case o.Array:{const M=t(O),_=[];for(let x=0;x<M;x++)_.push(c(O));return _}case o.Object:return JSON.parse(O.read(t(O)).toString())}}class l{constructor(D,M,_=null,x=1e3){this.protocol=D,this.ctx=M,this.logger=_,this.timeoutDelay=x,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(D,M){this.channels.set(D,M),setTimeout(()=>this.flushPendingRequests(D),0)}sendResponse(D){switch(D.type){case 200:{const M=this.send([D.type]);this.logger&&this.logger.logOutgoing(M,0,1,P(D.type));return}case 201:case 202:case 204:case 203:{const M=this.send([D.type,D.id],D.data);this.logger&&this.logger.logOutgoing(M,D.id,1,P(D.type),D.data);return}}}send(D,M=void 0){const _=new d;return u(_,D),u(_,M),this.sendBuffer(_.buffer)}sendBuffer(D){try{return this.protocol.send(D),D.byteLength}catch(M){return 0}}onRawMessage(D){const M=new I(D),_=c(M),x=c(M),B=_[0];switch(B){case 100:return this.logger&&this.logger.logIncoming(D.byteLength,_[1],1,`${f(B)}: ${_[2]}.${_[3]}`,x),this.onPromise({type:B,id:_[1],channelName:_[2],name:_[3],arg:x});case 102:return this.logger&&this.logger.logIncoming(D.byteLength,_[1],1,`${f(B)}: ${_[2]}.${_[3]}`,x),this.onEventListen({type:B,id:_[1],channelName:_[2],name:_[3],arg:x});case 101:return this.logger&&this.logger.logIncoming(D.byteLength,_[1],1,`${f(B)}`),this.disposeActiveRequest({type:B,id:_[1]});case 103:return this.logger&&this.logger.logIncoming(D.byteLength,_[1],1,`${f(B)}`),this.disposeActiveRequest({type:B,id:_[1]})}}onPromise(D){const M=this.channels.get(D.channelName);if(!M){this.collectPendingRequest(D);return}const _=new A.CancellationTokenSource;let x;try{x=M.call(this.ctx,D.name,D.arg,_.token)}catch(X){x=Promise.reject(X)}const B=D.id;x.then(X=>{this.sendResponse({id:B,data:X,type:201}),this.activeRequests.delete(D.id)},X=>{X instanceof Error?this.sendResponse({id:B,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split?X.stack.split(`
`):X.stack:void 0},type:202}):this.sendResponse({id:B,data:X,type:203}),this.activeRequests.delete(D.id)});const J=L.toDisposable(()=>_.cancel());this.activeRequests.set(D.id,J)}onEventListen(D){const M=this.channels.get(D.channelName);if(!M){this.collectPendingRequest(D);return}const _=D.id,B=M.listen(this.ctx,D.name,D.arg)(J=>this.sendResponse({id:_,data:J,type:204}));this.activeRequests.set(D.id,B)}disposeActiveRequest(D){const M=this.activeRequests.get(D.id);M&&(M.dispose(),this.activeRequests.delete(D.id))}collectPendingRequest(D){let M=this.pendingRequests.get(D.channelName);M||(M=[],this.pendingRequests.set(D.channelName,M));const _=setTimeout(()=>{console.error(`Unknown channel: ${D.channelName}`),D.type===100&&this.sendResponse({id:D.id,data:{name:"Unknown channel",message:`Channel name '${D.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);M.push({request:D,timeoutTimer:_})}flushPendingRequests(D){const M=this.pendingRequests.get(D);if(M){for(const _ of M)switch(clearTimeout(_.timeoutTimer),_.request.type){case 100:this.onPromise(_.request);break;case 102:this.onEventListen(_.request);break}this.pendingRequests.delete(D)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(D=>D.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var S;(function(O){O[O.LocalSide=0]="LocalSide",O[O.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(D,M=null){this.protocol=D,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(_=>this.onBuffer(_)),this.logger=M}getChannel(D){const M=this;return{call(_,x,B){return M.isDisposed?Promise.reject(T.canceled()):M.requestPromise(D,_,x,B)},listen(_,x){return M.isDisposed?Promise.reject(T.canceled()):M.requestEvent(D,_,x)}}}requestPromise(D,M,_,x=A.CancellationToken.None){const B=this.lastRequestId++,X={id:B,type:100,channelName:D,name:M,arg:_};if(x.isCancellationRequested)return Promise.reject(T.canceled());let te;return new Promise((ce,le)=>{if(x.isCancellationRequested)return le(T.canceled());const ve=()=>{const Me=Te=>{switch(Te.type){case 201:this.handlers.delete(B),ce(Te.data);break;case 202:this.handlers.delete(B);const ke=new Error(Te.data.message);ke.stack=Te.data.stack,ke.name=Te.data.name,le(ke);break;case 203:this.handlers.delete(B),le(Te.data);break}};this.handlers.set(B,Me),this.sendRequest(X)};let pe=null;this.state===E.Idle?ve():(pe=k.createCancelablePromise(Me=>this.whenInitialized()),pe.then(()=>{pe=null,ve()}));const Ce=()=>{pe?(pe.cancel(),pe=null):this.sendRequest({id:B,type:101}),le(T.canceled())},Ae=x.onCancellationRequested(Ce);te=L.combinedDisposable(L.toDisposable(Ce),Ae),this.activeRequests.add(te)}).finally(()=>{this.activeRequests.delete(te)})}requestEvent(D,M,_){const x=this.lastRequestId++,J={id:x,type:102,channelName:D,name:M,arg:_};let X=null;const te=new v.Emitter({onFirstListenerAdd:()=>{X=k.createCancelablePromise(ce=>this.whenInitialized()),X.then(()=>{X=null,this.activeRequests.add(te),this.sendRequest(J)})},onLastListenerRemove:()=>{X?(X.cancel(),X=null):(this.activeRequests.delete(te),this.sendRequest({id:x,type:103}))}}),ie=ce=>te.fire(ce.data);return this.handlers.set(x,ie),te.event}sendRequest(D){switch(D.type){case 100:case 102:{const M=this.send([D.type,D.id,D.channelName,D.name],D.arg);this.logger&&this.logger.logOutgoing(M,D.id,0,`${f(D.type)}: ${D.channelName}.${D.name}`,D.arg);return}case 101:case 103:{const M=this.send([D.type,D.id]);this.logger&&this.logger.logOutgoing(M,D.id,0,f(D.type));return}}}send(D,M=void 0){const _=new d;return u(_,D),u(_,M),this.sendBuffer(_.buffer)}sendBuffer(D){try{return this.protocol.send(D),D.byteLength}catch(M){return 0}}onBuffer(D){const M=new I(D),_=c(M),x=c(M),B=_[0];switch(B){case 200:return this.logger&&this.logger.logIncoming(D.byteLength,0,0,P(B)),this.onResponse({type:_[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(D.byteLength,_[1],0,P(B),x),this.onResponse({type:_[0],id:_[1],data:x})}}onResponse(D){if(D.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}const M=this.handlers.get(D.id);M&&M(D)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===E.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(D=>D.dispose()),this.activeRequests.clear()}}de([h.memoize],w.prototype,"onDidInitializePromise",null),e.ChannelClient=w;class g{constructor(D){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,D(({protocol:M,onDidClientDisconnect:_})=>{v.Event.once(M.onMessage)(B=>{const J=new I(B),X=c(J),te=new l(M,X),ie=new w(M);this.channels.forEach((le,ve)=>te.registerChannel(ve,le));const ce={channelServer:te,channelClient:ie,ctx:X};this._connections.add(ce),this._onDidAddConnection.fire(ce),_(()=>{te.dispose(),ie.dispose(),this._connections.delete(ce),this._onDidRemoveConnection.fire(ce)})})})}get connections(){const D=[];return this._connections.forEach(M=>D.push(M)),D}getChannel(D,M){const _=this;return{call(x,B,J){let X;if(p.isFunction(M)){let ie=y.getRandomElement(_.connections.filter(M));X=ie?Promise.resolve(ie):v.Event.toPromise(v.Event.filter(_.onDidAddConnection,M))}else X=M.routeCall(_,x,B);const te=X.then(ie=>ie.channelClient.getChannel(D));return F(te).call(x,B,J)},listen(x,B){if(p.isFunction(M))return _.getMulticastEvent(D,M,x,B);const J=M.routeEvent(_,x,B).then(X=>X.channelClient.getChannel(D));return F(J).listen(x,B)}}}getMulticastEvent(D,M,_,x){const B=this;let J=new L.DisposableStore;const X=new v.Emitter({onFirstListenerAdd:()=>{J=new L.DisposableStore;const te=new v.EventMultiplexer,ie=new Map,ce=ve=>{const Ce=ve.channelClient.getChannel(D).listen(_,x),Ae=te.add(Ce);ie.set(ve,Ae)},le=ve=>{const pe=ie.get(ve);!pe||(pe.dispose(),ie.delete(ve))};B.connections.filter(M).forEach(ce),v.Event.filter(B.onDidAddConnection,M)(ce,void 0,J),B.onDidRemoveConnection(le,void 0,J),te.event(X.fire,X,J),J.add(te)},onLastListenerRemove:()=>{J.dispose()}});return X.event}registerChannel(D,M){this.channels.set(D,M),this._connections.forEach(_=>{_.channelServer.registerChannel(D,M)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=g;class U{constructor(D,M,_=null){const x=new d;u(x,M),D.send(x.buffer),this.channelClient=new w(D,_),this.channelServer=new l(D,M,_)}getChannel(D){return this.channelClient.getChannel(D)}registerChannel(D,M){this.channelServer.registerChannel(D,M)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=U;function F(O){return{call(D,M,_){return O.then(x=>x.call(D,M,_))},listen(D,M){const _=new v.Relay;return O.then(x=>_.input=x.listen(D,M)),_.event}}}e.getDelayedChannel=F;function j(O){let D=!1;return{call(M,_,x){return D?O.call(M,_,x):k.timeout(0).then(()=>D=!0).then(()=>O.call(M,_,x))},listen(M,_){if(D)return O.listen(M,_);const x=new v.Relay;return k.timeout(0).then(()=>D=!0).then(()=>x.input=O.listen(M,_)),x.event}}}e.getNextTickChannel=j;class ${constructor(D){this.fn=D}routeCall(D){return this.route(D)}routeEvent(D){return this.route(D)}async route(D){for(const M of D.connections)if(await Promise.resolve(this.fn(M.ctx)))return Promise.resolve(M);return await v.Event.toPromise(D.onDidAddConnection),await this.route(D)}}e.StaticRouter=$;var V;(function(O){function D(x,B){const J=x,X=B&&B.disableMarshalling,te=new Map;for(const ie in J)_(ie)&&te.set(ie,v.Event.buffer(J[ie],!0));return new class{listen(ie,ce){const le=te.get(ce);if(le)return le;throw new Error(`Event not found: ${ce}`)}call(ie,ce,le){const ve=J[ce];if(typeof ve=="function"){if(!X&&Array.isArray(le))for(let pe=0;pe<le.length;pe++)le[pe]=n.revive(le[pe]);return ve.apply(J,le)}throw new Error(`Method not found: ${ce}`)}}}O.fromService=D;function M(x,B){const J=B&&B.disableMarshalling;return new Proxy({},{get(X,te){var ie;if(typeof te=="string")return((ie=B==null?void 0:B.properties)===null||ie===void 0?void 0:ie.has(te))?B.properties.get(te):_(te)?x.listen(te):async function(...ce){let le;B&&!p.isUndefinedOrNull(B.context)?le=[B.context,...ce]:le=ce;const ve=await x.call(te,le);return J?ve:n.revive(ve)};throw new Error(`Property not found: ${String(te)}`)}})}O.toService=M;function _(x){return x[0]==="o"&&x[1]==="n"&&m.isUpperAsciiLetter(x.charCodeAt(2))}})(V=e.ProxyChannel||(e.ProxyChannel={}));const q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function z(O){if(Array.isArray(O))return O;if(O&&typeof O=="object"&&typeof O.toString=="function"){let D=O.toString();if(D!=="[object Object]")return D}return O}function H(O){return Array.isArray(O)?O.map(z):z(O)}function Q(O,D,M,_,x,B,J){J=H(J);const X=q[x],te=X[_%X.length];let ie=[`%c[${O}]%c[${String(D).padStart(7," ")}]%c[len: ${String(M).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${te}`];/\($/.test(B)?(ie=ie.concat(J),ie.push(")")):ie.push(J),console.log.apply(console,ie)}e.logWithColors=Q;class N{constructor(D,M){this._outgoingPrefix=D,this._incomingPrefix=M,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(D,M,_,x,B){this._totalOutgoing+=D,Q(this._outgoingPrefix,this._totalOutgoing,D,M,_,x,B)}logIncoming(D,M,_,x,B){this._totalIncoming+=D,Q(this._incomingPrefix,this._totalIncoming,D,M,_,x,B)}}e.IPCLogger=N}),define(Z[100],ee([0,1,3,36,25]),function(G,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(y){this.port=y,this.onMessage=v.Event.fromDOMEventEmitter(this.port,"message",p=>k.VSBuffer.wrap(p.data)),y.start()}send(y){this.port.postMessage(y.buffer)}disconnect(){this.port.close()}}e.Protocol=A;class T extends L.IPCClient{constructor(y,p){const n=new A(y);super(n,p);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=T}),define(Z[101],ee([0,1,102,3,36,100]),function(G,e,v,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class T extends k.IPCServer{static getOnDidClientConnect(){const y=L.Event.fromNodeEventEmitter(v.ipcRenderer,"vscode:createMessageChannel",(p,n)=>n);return L.Event.map(y,p=>{const{port1:n,port2:m}=new MessageChannel,b={protocol:new A.Protocol(n),onDidClientDisconnect:L.Event.fromDOMEventEmitter(n,"close")};return v.ipcRenderer.postMessage("vscode:createMessageChannelResult",p,[m]),b})}constructor(){super(T.getOnDidClientConnect())}}e.Server=T}),define(Z[103],ee([0,1,11,25]),function(G,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function k(R,y){R.proxyAuthorization&&(R.headers=Object.assign(Object.assign({},R.headers||{}),{"Proxy-Authorization":R.proxyAuthorization}));const p=new XMLHttpRequest;return new Promise((n,m)=>{p.open(R.type||"GET",R.url||"",!0,R.user,R.password),A(p,R),p.responseType="arraybuffer",p.onerror=h=>m(new Error(p.statusText&&"XHR failed: "+p.statusText||"XHR failed")),p.onload=h=>{n({res:{statusCode:p.status,headers:T(p)},stream:L.bufferToStream(L.VSBuffer.wrap(new Uint8Array(p.response)))})},p.ontimeout=h=>m(new Error(`XHR timeout: ${R.timeout}ms`)),R.timeout&&(p.timeout=R.timeout),p.send(R.data),y.onCancellationRequested(()=>{p.abort(),m(v.canceled())})})}e.request=k;function A(R,y){if(y.headers){e:for(let p in y.headers){switch(p){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}R.setRequestHeader(p,y.headers[p])}}}function T(R){const y=Object.create(null);for(const p of R.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(p){const n=p.indexOf(":");y[p.substr(0,n).trim().toLowerCase()]=p.substr(n+1).trim()}return y}}),define(Z[70],ee([0,1,2,3,6,16]),function(G,e,v,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var T;(function(n){n[n.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=e.StorageHint||(e.StorageHint={}));var R;(function(n){n[n.None=0]="None",n[n.Initialized=1]="Initialized",n[n.Closed=2]="Closed"})(R||(R={}));class y extends v.Disposable{constructor(m,h=Object.create(null)){super();this.database=m,this.options=h,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=R.None,this.cache=new Map,this.flushDelayer=new k.ThrottledDelayer(y.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){var h,b;(h=m.changed)===null||h===void 0||h.forEach((f,C)=>this.accept(C,f)),(b=m.deleted)===null||b===void 0||b.forEach(f=>this.accept(f,void 0))}accept(m,h){if(this.state===R.Closed)return;let b=!1;A.isUndefinedOrNull(h)?b=this.cache.delete(m):this.cache.get(m)!==h&&(this.cache.set(m,h),b=!0),b&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===R.None&&(this.state=R.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,h){const b=this.cache.get(m);return A.isUndefinedOrNull(b)?h:b}getBoolean(m,h){const b=this.get(m);return A.isUndefinedOrNull(b)?h:b==="true"}getNumber(m,h){const b=this.get(m);return A.isUndefinedOrNull(b)?h:parseInt(b,10)}async set(m,h){if(this.state===R.Closed)return;if(A.isUndefinedOrNull(h))return this.delete(m);const b=String(h);if(this.cache.get(m)!==b)return this.cache.set(m,b),this.pendingInserts.set(m,b),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.flushDelayer.trigger(()=>this.flushPending())}async delete(m){if(!(this.state===R.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=R.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(m){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{var h;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(h=this.whenFlushedCallbacks.pop())===null||h===void 0||h()})}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=y,y.DEFAULT_FLUSH_DELAY=100;class p{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert&&m.insert.forEach((h,b)=>this.items.set(b,h)),m.delete&&m.delete.forEach(h=>this.items.delete(h))}async close(){}}e.InMemoryStorageDatabase=p}),define(Z[104],ee([13,14]),function(G,e){return G.create("vs/base/common/date",e)}),define(Z[55],ee([0,1,104]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,k=L*60,A=k*24,T=A*7,R=A*30,y=A*365;function p(m,h){typeof m!="number"&&(m=m.getTime());const b=Math.round((new Date().getTime()-m)/1e3);if(b<-30)return v.localize(0,null,p(new Date().getTime()+b*1e3,!1));if(b<30)return v.localize(1,null);let f;return b<L?(f=b,h?f===1?v.localize(2,null,f):v.localize(3,null,f):f===1?v.localize(4,null,f):v.localize(5,null,f)):b<k?(f=Math.floor(b/L),h?f===1?v.localize(6,null,f):v.localize(7,null,f):f===1?v.localize(8,null,f):v.localize(9,null,f)):b<A?(f=Math.floor(b/k),h?f===1?v.localize(10,null,f):v.localize(11,null,f):f===1?v.localize(12,null,f):v.localize(13,null,f)):b<T?(f=Math.floor(b/A),h?f===1?v.localize(14,null,f):v.localize(15,null,f):f===1?v.localize(16,null,f):v.localize(17,null,f)):b<R?(f=Math.floor(b/T),h?f===1?v.localize(18,null,f):v.localize(19,null,f):f===1?v.localize(20,null,f):v.localize(21,null,f)):b<y?(f=Math.floor(b/R),h?f===1?v.localize(22,null,f):v.localize(23,null,f):f===1?v.localize(24,null,f):v.localize(25,null,f)):(f=Math.floor(b/y),h?f===1?v.localize(26,null,f):v.localize(27,null,f):f===1?v.localize(28,null,f):v.localize(29,null,f))}e.fromNow=p;function n(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(Z[105],ee([13,14]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(Z[43],ee([0,1,105,16,19]),function(G,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(p,n){return n&&(p.stack||p.stacktrace)?v.localize(0,null,R(p),T(p.stack)||T(p.stacktrace)):R(p)}function T(p){return Array.isArray(p)?p.join(`
`):p}function R(p){return typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?v.localize(1,null,p.message):p.message||v.localize(2,null)}function y(p=null,n=!1){if(!p)return v.localize(3,null);if(Array.isArray(p)){const m=k.coalesce(p),h=y(m[0],n);return m.length>1?v.localize(4,null,h,m.length):h}if(L.isString(p))return p;if(p.detail){const m=p.detail;if(m.error)return A(m.error,n);if(m.exception)return A(m.exception,n)}return p.stack?A(p,n):p.message?p.message:v.localize(5,null)}e.toErrorMessage=y}),define(Z[106],ee([13,14]),function(G,e){return G.create("vs/base/node/processes",e)}),define(Z[107],ee([0,1,8,18,42,106,34,16,26,41,7,69,17]),function(G,e,v,L,k,A,T,R,y,p,n,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function b(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function f(o,s){if(n.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};s&&(t.cwd=s);const r=k.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],t);return new Promise(i=>{r.once("error",a=>{i({success:!1,error:a})}),r.once("exit",(a,u)=>{i(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?b(t.status):1})}else if(n.isLinux||n.isMacintosh)try{const t=h.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(r=>{k.execFile(t,[o.pid.toString()],{encoding:"utf8",shell:!0},(i,a,u)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function C(o=T.env){return o.comspec||"cmd.exe"}e.getWindowsShell=C;class P{constructor(s,t,r,i){if(t!==void 0&&r!==void 0&&i!==void 0)this.cmd=s,this.args=t,this.shell=r,this.options=i;else{const a=s;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(T.env).forEach(u=>{a[u]=T.env[u]}),Object.keys(this.options.env).forEach(u=>{a[u]=this.options.env[u]}),this.options.env=a}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const t=s.lastIndexOf(v.sep);return t!==-1&&(s=s.substring(t+1)),P.WellKnowCommands[s]?s:"other"}start(s){return n.isWindows&&(this.options&&this.options.cwd&&p.isUNC(this.options.cwd)||!this.options&&p.isUNC(T.cwd()))?Promise.reject(new Error(A.localize(0,null))):this.useExec().then(t=>{let r,i;const a=new Promise((u,c)=>{r=u,i=c});if(t){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=k.exec(u,this.options,(c,l,S)=>{this.childProcess=null;const w=c;w&&w.killed?i({killed:this.terminateRequested,stdout:l.toString(),stderr:S.toString()}):this.handleExec(r,s,c,l,S)})}else{let u=null;const c=l=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(l,r,s,i);const S={terminated:this.terminateRequested};R.isNumber(l)&&(S.cmdCode=l),r(S)};if(this.shell&&n.isWindows){const l=y.deepClone(this.options);l.windowsVerbatimArguments=!0,l.detached=!1;let S=!1,w=!1;const g=[];let U=this.ensureQuotes(this.cmd);g.push(U.value),S=U.quoted,this.args&&this.args.forEach(j=>{U=this.ensureQuotes(j),g.push(U.value),w=w&&U.quoted});const F=["/s","/c"];S?w?F.push('"'+g.join(" ")+'"'):g.length>1?F.push('"'+g[0]+'" '+g.slice(1).join(" ")):F.push('"'+g[0]+'"'):F.push(g.join(" ")),u=k.spawn(C(),F,l)}else this.cmd&&(u=k.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(R.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",l=>{this.childProcess=null,i({terminated:this.terminateRequested,error:l})}),u.pid&&(this.childProcess.on("close",c),this.handleSpawn(u,r,s,i,!0)))}return a})}handleClose(s,t,r,i){}ensureQuotes(s){return P.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,f(s,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!n.isWindows)return s(!1);const t=k.spawn(C(),["/s","/c"]);t.on("error",r=>s(!0)),t.on("exit",r=>s(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class E extends P{constructor(s,t,r,i){super(s,t,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,t,r,i,a){[i,a].forEach((u,c)=>{const l=new m.LineDecoder;l.write(u).forEach(g=>{t({line:g,source:c===0?0:1})});const w=l.end();w&&t({line:w,source:c===0?0:1})}),s({terminated:this.terminateRequested,error:r})}handleSpawn(s,t,r,i,a){const u=new m.LineDecoder,c=new m.LineDecoder;s.stdout.on("data",l=>{u.write(l).forEach(w=>r({line:w,source:0}))}),s.stderr.on("data",l=>{c.write(l).forEach(w=>r({line:w,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=c}handleClose(s,t,r,i){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&r({line:a,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&r({line:u,source:1})}}e.LineProcess=E;function I(o){let s=[],t=!1;const r=function(i){if(t){s.push(i);return}(!o.send(i,u=>{if(u&&console.error(u),t=!1,s.length>0){const c=s.slice(0);s=[],c.forEach(l=>r(l))}})||n.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=I;var d;(function(o){async function s(t,r,i){if(v.isAbsolute(t))return t;if(r===void 0&&(r=T.cwd()),v.dirname(t)!=="."||(i===void 0&&R.isString(T.env.PATH)&&(i=T.env.PATH.split(v.delimiter)),i===void 0||i.length===0))return v.join(r,t);async function u(c){return await L.Promises.exists(c)?!(await L.Promises.stat(c)).isDirectory():!1}for(let c of i){let l;if(v.isAbsolute(c)?l=v.join(c,t):l=v.join(r,c,t),await u(l))return l;let S=l+".com";if(await u(S)||(S=l+".exe",await u(S)))return S}return v.join(r,t)}o.findExecutable=s})(d=e.win32||(e.win32={}))}),define(Z[49],ee([0,1,42,2,6,26,3,107,36,90,29,11,25,7]),function(G,e,v,L,k,A,T,R,y,p,n,m,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends y.ChannelServer{constructor(E){super({send:I=>{try{process.send&&process.send(I.buffer.toString("base64"))}catch(d){}},onMessage:T.Event.fromNodeEventEmitter(process,"message",I=>h.VSBuffer.wrap(Buffer.from(I,"base64")))},E);process.once("disconnect",()=>this.dispose())}}e.Server=f;class C{constructor(E,I){this.modulePath=E,this.options=I,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new T.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const d=I&&I.timeout?I.timeout:6e4;this.disposeDelayer=new k.Delayer(d),this.child=null,this._client=null}getChannel(E){const I=this;return{call(d,o,s){return I.requestPromise(E,d,o,s)},listen(d,o){return I.requestEvent(E,d,o)}}}requestPromise(E,I,d,o=n.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(m.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(E),t=k.createCancelablePromise(a=>s.call(I,d,a)),r=o.onCancellationRequested(()=>t.cancel()),i=L.toDisposable(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(E,I,d){if(!this.disposeDelayer)return T.Event.None;this.disposeDelayer.cancel();let o;const s=new T.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(E).listen(I,d)(s.fire,s),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const E=this.options&&this.options.args?this.options.args:[],I=Object.create(null);I.env=Object.assign(Object.assign({},A.deepClone(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(I.env=Object.assign(Object.assign({},I.env),this.options.env)),this.options&&this.options.freshExecArgv&&(I.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(I.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(I.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),I.execArgv===void 0&&(I.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u))),b.isMacintosh&&I.env&&delete I.env.DYLD_LIBRARY_PATH,this.child=v.fork(this.modulePath,E,I);const d=new T.Emitter;T.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if(p.isRemoteConsoleLog(u)){p.log(u,`IPC Library: ${this.options.serverName}`);return}d.fire(h.VSBuffer.wrap(Buffer.from(u,"base64")))});const s=this.options.useQueue?R.createQueuedSender(this.child):this.child,t=u=>this.child&&this.child.connected&&s.send(u.buffer.toString("base64")),r=d.event,i={send:t,onMessage:r};this._client=new y.ChannelClient(i);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,c)=>{process.removeListener("exit",a),this.activeRequests.forEach(l=>L.dispose(l)),this.activeRequests.clear(),u!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+c),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:c})})}return this._client}getCachedChannel(E){let I=this.channels.get(E);return I||(I=this.client.getChannel(E),this.channels.set(E,I)),I}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=C}),define(Z[108],ee([13,14]),function(G,e){return G.create("vs/base/node/zip",e)}),define(Z[109],ee([13,14]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[110],ee([13,14]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[111],ee([13,14]),function(G,e){return G.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Z[112],ee([13,14]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[113],ee([13,14]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[114],ee([13,14]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Z[115],ee([13,14]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[116],ee([13,14]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(Z[117],ee([13,14]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(Z[118],ee([13,14]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(Z[119],ee([13,14]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[120],ee([13,14]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(Z[121],ee([13,14]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[122],ee([13,14]),function(G,e){return G.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(Z[123],ee([13,14]),function(G,e){return G.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Z[124],ee([13,14]),function(G,e){return G.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Z[125],ee([13,14]),function(G,e){return G.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Z[126],ee([13,14]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Z[127],ee([13,14]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Z[128],ee([13,14]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(Z[129],ee([0,1,8,12,64,55,17,5,34]),function(G,e,v,L,k,A,T,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class p{constructor(f,C,P){this._args=f,this.paths=C,this.productService=P}get appRoot(){return v.dirname(T.FileAccess.asFileUri("",G).fsPath)}get userHome(){return R.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return R.URI.file(v.join(this.userDataPath,"User"))}get tmpDir(){return R.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return L.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return L.joinPath(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const f=A.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=v.join(this.userDataPath,"logs",f)}return this.args.logsPath}get userDataSyncLogResource(){return R.URI.file(v.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return L.joinPath(R.URI.file(v.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return R.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return R.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return L.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return L.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=y.env.VSCODE_PORTABLE;return f?R.URI.file(v.join(f,"argv.json")):L.joinPath(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return L.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return R.URI.file(v.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return v.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?v.resolve(f):v.normalize(v.join(T.FileAccess.asFileUri("",G).fsPath,"..","extensions"))}get extensionsDownloadPath(){const f=this.args["extensions-download-dir"];return f?v.resolve(f):v.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return v.resolve(f);const C=y.env.VSCODE_EXTENSIONS;if(C)return C;const P=y.env.VSCODE_PORTABLE;return P?v.join(P,"extensions"):L.joinPath(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(C=>/^[^:/?#]+?:\/\//.test(C)?R.URI.parse(C):R.URI.file(v.normalize(C)))}get extensionDevelopmentKind(){var f;return(f=this.args.extensionDevelopmentKind)===null||f===void 0?void 0:f.map(C=>C==="ui"||C==="workspace"||C==="web"?C:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?R.URI.parse(f):R.URI.file(v.normalize(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!y.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return L.joinPath(R.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return R.URI.file(v.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([k.memoize],p.prototype,"appRoot",null),de([k.memoize],p.prototype,"userHome",null),de([k.memoize],p.prototype,"userDataPath",null),de([k.memoize],p.prototype,"appSettingsHome",null),de([k.memoize],p.prototype,"tmpDir",null),de([k.memoize],p.prototype,"userRoamingDataHome",null),de([k.memoize],p.prototype,"settingsResource",null),de([k.memoize],p.prototype,"userDataSyncHome",null),de([k.memoize],p.prototype,"userDataSyncLogResource",null),de([k.memoize],p.prototype,"sync",null),de([k.memoize],p.prototype,"machineSettingsResource",null),de([k.memoize],p.prototype,"globalStorageHome",null),de([k.memoize],p.prototype,"workspaceStorageHome",null),de([k.memoize],p.prototype,"keybindingsResource",null),de([k.memoize],p.prototype,"keyboardLayoutResource",null),de([k.memoize],p.prototype,"argvResource",null),de([k.memoize],p.prototype,"snippetsHome",null),de([k.memoize],p.prototype,"isExtensionDevelopment",null),de([k.memoize],p.prototype,"untitledWorkspacesHome",null),de([k.memoize],p.prototype,"installSourcePath",null),de([k.memoize],p.prototype,"builtinExtensionsPath",null),de([k.memoize],p.prototype,"extensionsPath",null),de([k.memoize],p.prototype,"extensionDevelopmentLocationURI",null),de([k.memoize],p.prototype,"extensionDevelopmentKind",null),de([k.memoize],p.prototype,"extensionTestsLocationURI",null),de([k.memoize],p.prototype,"debugExtensionHost",null),de([k.memoize],p.prototype,"serviceMachineIdResource",null),de([k.memoize],p.prototype,"telemetryLogResource",null),de([k.memoize],p.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=p;function n(b,f){return h(b["inspect-extensions"],b["inspect-brk-extensions"],5870,f,b.debugId)}e.parseExtensionHostPort=n;function m(b,f){return h(b["inspect-search"],b["inspect-brk-search"],5876,f)}e.parseSearchPort=m;function h(b,f,C,P,E){const d=Number(f||b)||(P?null:C),o=d?Boolean(!!f):!1;return{port:d,break:o,debugId:E}}}),function(){"use strict";function G(e,v,L,k){function A(R){const y=T(R),p=[y];return e.isAbsolute(y)||p.unshift(k),e.resolve(...p)}function T(R){const y=process.env.VSCODE_PORTABLE;if(y)return e.join(y,"user-data");const p=R["user-data-dir"];if(p)return p;let n=process.env.VSCODE_APPDATA;if(!n)switch(process.platform){case"win32":if(n=process.env.APPDATA,!n){const m=process.env.USERPROFILE;if(typeof m!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");n=e.join(m,"AppData","Roaming")}break;case"darwin":n=e.join(v.homedir(),"Library","Application Support");break;case"linux":n=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(n,L)}return{getUserDataPath:A}}if(typeof define=="function")define(Z[130],ee([0,209,35,17,12,34]),function(e,v,L,k,A,T){const R=A.dirname(k.FileAccess.asFileUri("",e)),y=e.__$__nodeRequire(A.joinPath(R,"package.json").fsPath);return G(v,L,y.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),L=require("os");module.exports=G(v,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[131],ee([0,1,35,130,129]),function(G,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class A extends k.AbstractNativeEnvironmentService{constructor(R,y){super(R,{homeDir:v.homedir(),tmpDir:v.tmpdir(),userDataDir:L.getUserDataPath(R)},y)}}e.NativeEnvironmentService=A}),define(Z[132],ee([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,k=/^([^@:]+@)?([^:]+):(.+)$/,A=/^([^@]+@)?([^:]+)(:\d+)?$/,T=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,y=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function p(P){const E=P.match(T);return E?E[1]:null}function n(P){if(P.indexOf("://")===-1){const E=P.match(L);return E?p(E[2]):null}try{const E=v.URI.parse(P);if(E.authority)return p(E.authority)}catch(E){}return null}function m(P,E){const I=new Set;let d;for(;d=R.exec(P);){const s=n(d[1]);s&&I.add(s)}const o=new Set(E);return Array.from(I).map(s=>o.has(s)?s:s.replace(y,"a"))}e.getDomainsOfRemotes=m;function h(P){const E=P.match(A);return E?E[2]:null}function b(P,E,I){return P&&E?(I&&E.endsWith(".git")&&(E=E.substr(0,E.length-4)),E.indexOf("/")===0?`${P}${E}`:`${P}/${E}`):null}function f(P,E){if(P.indexOf("://")===-1){const I=P.match(k);if(I)return b(I[2],I[3],E)}try{const I=v.URI.parse(P);if(I.authority)return b(h(I.authority),I.path,E)}catch(I){}return null}function C(P,E=!1){const I=[];let d;for(;d=R.exec(P);){const o=f(d[1],E);o&&I.push(o)}return I}e.getRemotes=C}),define(Z[133],ee([0,1,3,5,93,26,2]),function(G,e,v,L,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function R(f,C){return L.URI.revive(C?C.transformIncoming(f):f)}function y(f,C){return C?C.transformOutgoingURI(f):f}function p(f,C){C=C||k.DefaultURITransformer;const P=f.manifest,E=k.transformAndReviveIncomingURIs(Object.assign(Object.assign({},f),{manifest:void 0}),C);return Object.assign(Object.assign({},E),{manifest:P})}function n(f,C){return C?A.cloneAndChange(f,P=>P instanceof L.URI?C.transformOutgoingURI(P):void 0):f}class m{constructor(C,P){this.service=C,this.getUriTransformer=P,this.onInstallExtension=v.Event.buffer(C.onInstallExtension,!0),this.onDidInstallExtension=v.Event.buffer(C.onDidInstallExtension,!0),this.onUninstallExtension=v.Event.buffer(C.onUninstallExtension,!0),this.onDidUninstallExtension=v.Event.buffer(C.onDidUninstallExtension,!0)}listen(C,P){const E=this.getUriTransformer(C);switch(P){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return v.Event.map(this.onDidInstallExtension,I=>Object.assign(Object.assign({},I),{local:I.local?n(I.local,E):I.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(C,P,E){const I=this.getUriTransformer(C);switch(P){case"zip":return this.service.zip(p(E[0],I)).then(d=>y(d,I));case"unzip":return this.service.unzip(R(E[0],I));case"install":return this.service.install(R(E[0],I),E[1]);case"getManifest":return this.service.getManifest(R(E[0],I));case"canInstall":return this.service.canInstall(E[0]);case"installFromGallery":return this.service.installFromGallery(E[0],E[1]);case"uninstall":return this.service.uninstall(p(E[0],I),E[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(p(E[0],I));case"getInstalled":return this.service.getInstalled(E[0]).then(d=>d.map(o=>n(o,I)));case"updateMetadata":return this.service.updateMetadata(p(E[0],I),E[1]).then(d=>n(d,I));case"updateExtensionScope":return this.service.updateExtensionScope(p(E[0],I),E[1]).then(d=>n(d,I));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=m;class h extends T.Disposable{constructor(C){super();this.channel=C,this._onInstallExtension=this._register(new v.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new v.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new v.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new v.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(P=>this._onInstallExtension.fire(P))),this._register(this.channel.listen("onDidInstallExtension")(P=>this._onDidInstallExtension.fire(Object.assign(Object.assign({},P),{local:P.local?p(P.local,null):P.local})))),this._register(this.channel.listen("onUninstallExtension")(P=>this._onUninstallExtension.fire(P))),this._register(this.channel.listen("onDidUninstallExtension")(P=>this._onDidUninstallExtension.fire(P)))}zip(C){return Promise.resolve(this.channel.call("zip",[C]).then(P=>L.URI.revive(P)))}unzip(C){return Promise.resolve(this.channel.call("unzip",[C]))}install(C,P){return Promise.resolve(this.channel.call("install",[C,P])).then(E=>p(E,null))}getManifest(C){return Promise.resolve(this.channel.call("getManifest",[C]))}async canInstall(C){return!0}installFromGallery(C,P){return Promise.resolve(this.channel.call("installFromGallery",[C,P])).then(E=>p(E,null))}uninstall(C,P){return Promise.resolve(this.channel.call("uninstall",[C,P]))}reinstallFromGallery(C){return Promise.resolve(this.channel.call("reinstallFromGallery",[C]))}getInstalled(C=null){return Promise.resolve(this.channel.call("getInstalled",[C])).then(P=>P.map(E=>p(E,null)))}updateMetadata(C,P){return Promise.resolve(this.channel.call("updateMetadata",[C,P])).then(E=>p(E,null))}updateExtensionScope(C,P){return Promise.resolve(this.channel.call("updateExtensionScope",[C,P])).then(E=>p(E,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=h;class b{constructor(C){this.service=C}listen(C,P){throw new Error("Invalid listen")}call(C,P,E){switch(P){case"getConfigBasedTips":return this.service.getConfigBasedTips(L.URI.revive(E[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=b}),define(Z[134],ee([0,1,26]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function k(A,T){const R=y=>{var p;if(typeof y!="string")return;const n=L.exec(y);if(!n)return;const m=(p=T[n[1]])!==null&&p!==void 0?p:y;return typeof m=="string"?m:typeof m.message=="string"?m.message:y};return v.cloneAndChange(A,R)}e.localizeManifest=k}),define(Z[135],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class v{constructor(A){this.channel=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A,T,R,y){return this.channel.call("promptImportantExtensionsInstallNotification",[A,T,R,y])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=v;class L{constructor(A){this.service=A}listen(A,T){throw new Error(`Event not found: ${T}`)}call(A,T,R){switch(T){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(Z[71],ee([0,1,115]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function A(h){return h=h.trim(),h==="*"||L.test(h)}e.isValidVersionStr=A;function T(h){if(!A(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=h.match(L);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=T;function R(h){if(!h)return null;let b=h.majorBase,f=h.majorMustEqual,C=h.minorBase,P=h.minorMustEqual,E=h.patchBase,I=h.patchMustEqual;h.hasCaret&&(b===0||(P=!1),I=!1);let d=0;if(h.preRelease){const o=k.exec(h.preRelease);if(o){const[,s,t,r]=o;d=Date.UTC(Number(s),Number(t)-1,Number(r))}}return{majorBase:b,majorMustEqual:f,minorBase:C,minorMustEqual:P,patchBase:E,patchMustEqual:I,isMinimum:h.hasGreaterEquals,notBefore:d}}e.normalizeVersion=R;function y(h,b,f){let C;typeof h=="string"?C=R(T(h)):C=h;let P;b instanceof Date?P=b.getTime():typeof b=="string"&&(P=new Date(b).getTime());let E;if(typeof f=="string"?E=R(T(f)):E=f,!C||!E)return!1;let I=C.majorBase,d=C.minorBase,o=C.patchBase,s=E.majorBase,t=E.minorBase,r=E.patchBase,i=E.notBefore,a=E.majorMustEqual,u=E.minorMustEqual,c=E.patchMustEqual;return E.isMinimum?I>s?!0:I<s?!1:d>t?!0:d<t||P&&P<i?!1:o>=r:(I===1&&s===0&&(!a||!u||!c)&&(s=1,t=0,r=0,a=!0,u=!1,c=!1),I<s?!1:I>s?!a:d<t?!1:d>t?!u:o<r?!1:o>r?!c:!(P&&P<i))}e.isValidVersion=y;function p(h,b,f,C){return f.isBuiltin||typeof f.main=="undefined"?!0:m(h,b,f.engines.vscode,C)}e.isValidExtensionVersion=p;function n(h,b,f){return h==="*"||m(b,f,h)}e.isEngineValid=n;function m(h,b,f,C=[]){let P=R(T(f));if(!P)return C.push(v.localize(0,null,f)),!1;if(P.majorBase===0){if(!P.majorMustEqual||!P.minorMustEqual)return C.push(v.localize(1,null,f)),!1}else if(!P.majorMustEqual)return C.push(v.localize(2,null,f)),!1;return y(h,b,P)?!0:(C.push(v.localize(3,null,h,f)),!1)}}),define(Z[136],ee([0,1,36,49,2,17]),function(G,e,v,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class T extends k.Disposable{constructor(y,p,n,m){super();this.folders=y,this.onDidFilesChange=p,this.onLogMessage=n,this.verboseLogging=m,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const y=this._register(new L.Client(A.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(y.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=T.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService(v.getNextTickChannel(y.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(p=>!this.isDisposed&&this.onDidFilesChange(p))),this._register(this.service.onDidLogMessage(p=>this.onLogMessage(p))),this.setFolders(this.folders)}setVerboseLogging(y){this.verboseLogging=y,!this.isDisposed&&this.service&&this.service.setVerboseLogging(y)}error(y){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${y}`})}setFolders(y){this.folders=y,this.service&&this.service.setRoots(y)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=T,T.MAX_RESTARTS=5}),define(Z[137],ee([0,1,36,49,2,17]),function(G,e,v,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class T extends k.Disposable{constructor(y,p,n,m,h={}){super();this.folders=y,this.onDidFilesChange=p,this.onLogMessage=n,this.verboseLogging=m,this.watcherOptions=h,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const y=this._register(new L.Client(A.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(y.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=T.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService(v.getNextTickChannel(y.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(p=>!this.isDisposed&&this.onDidFilesChange(p))),this._register(this.service.onDidLogMessage(p=>this.onLogMessage(p))),this.service.setRoots(this.folders)}error(y){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${y}`})}setVerboseLogging(y){this.verboseLogging=y,this.service&&this.service.setVerboseLogging(y)}setFolders(y){this.folders=y,this.service&&this.service.setRoots(y)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=T,T.MAX_RESTARTS=5}),define(Z[138],ee([0,1,42,69,68,17]),function(G,e,v,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class T{constructor(y,p,n,m,h){this.watchedFolder=y,this.eventCallback=n,this.logCallback=m,this.verboseLogging=h,this.restartCounter=0,Array.isArray(p)?this.ignored=p.map(b=>k.parse(b)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${y}, excludes: ${p.join(",")}`),this.startWatcher()}startWatcher(){const y=[this.watchedFolder];this.verboseLogging&&y.push("-verbose"),this.handle=v.spawn(A.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",G).fsPath,y);const p=new L.LineDecoder;this.handle.stdout.on("data",n=>{const m=[];for(const h of p.write(n)){const b=h.split("|");if(b.length===2){const f=Number(b[0]),C=b[1];if(f>=0&&f<3){if(this.ignored&&this.ignored.some(P=>P(C))){this.verboseLogging&&this.log(C);continue}m.push({type:T.changeTypeMap[f],path:C})}else this.log(b[1])}}m.length>0&&this.eventCallback(m)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,m)=>this.onExit(n,m))}onError(y){this.error("process error: "+y.toString())}onExit(y,p){this.handle&&(this.error(`terminated unexpectedly (code: ${y}, signal: ${p})`),this.restartCounter<=T.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(y){this.logCallback({type:"error",message:`[File Watcher (C#)] ${y}`})}log(y){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${y}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=T,T.MAX_RESTARTS=5,T.changeTypeMap=[0,1,2]}),define(Z[139],ee([0,1,138,8,20]),function(G,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A{constructor(R,y,p,n){this.onDidFilesChange=y,this.onLogMessage=p,this.verboseLogging=n,this.service=void 0,this.folder=R[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(L.posix.sep)&&(this.folder.path=k.rtrim(this.folder.path,L.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new v.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,R=>this.onFileEvents(R),R=>this.onLogMessage(R),this.verboseLogging)}setVerboseLogging(R){this.verboseLogging=R,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(R){this.isDisposed||R.length>0&&this.onDidFilesChange(R)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=A}),define(Z[50],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class v{constructor(A,T=[],R=!1){this.ctor=A,this.staticArguments=T,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=v;const L=(k,...A)=>new v(k,A);e.createSyncDescriptor=L}),define(Z[140],ee([0,1,50]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function k(T,R,y){R instanceof v.SyncDescriptor||(R=new v.SyncDescriptor(R,[],y)),L.push([T,R])}e.registerSingleton=k;function A(){return L}e.getSingletonServiceDescriptors=A}),define(Z[141],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=v;class L{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let T of this._nodes.values())T.outgoing.size===0&&A.push(T);return A}insertEdge(A,T){const R=this.lookupOrInsertNode(A),y=this.lookupOrInsertNode(T);R.outgoing.set(this._hashFn(T),y),y.incoming.set(this._hashFn(A),R)}removeNode(A){const T=this._hashFn(A);this._nodes.delete(T);for(let R of this._nodes.values())R.outgoing.delete(T),R.incoming.delete(T)}lookupOrInsertNode(A){const T=this._hashFn(A);let R=this._nodes.get(T);return R||(R=new v(A),this._nodes.set(T,R)),R}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[T,R]of this._nodes)A.push(`${T}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,T]of this._nodes){const R=new Set([A]),y=this._findCycle(T,R);if(y)return y}}_findCycle(A,T){for(let[R,y]of A.outgoing){if(T.has(R))return[...T,R].join(" -> ");T.add(R);const p=this._findCycle(y,T);if(p)return p;T.delete(R)}}}e.Graph=L}),define(Z[4],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function y(p){return p[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=y})(v=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function L(R,y,p,n){y[v.DI_TARGET]===y?y[v.DI_DEPENDENCIES].push({id:R,index:p,optional:n}):(y[v.DI_DEPENDENCIES]=[{id:R,index:p,optional:n}],y[v.DI_TARGET]=y)}function k(R){if(v.serviceIds.has(R))return v.serviceIds.get(R);const y=function(p,n,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(y,p,m,!1)};return y.toString=()=>R,v.serviceIds.set(R,y),y}e.createDecorator=k;function A(R){return R}e.refineServiceDecorator=A;function T(R){return function(y,p,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(R,y,n,!0)}}e.optional=T}),define(Z[142],ee([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=v.createDecorator("checksumService")}),define(Z[143],ee([0,1,20,4,7]),function(G,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=k.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",k.isMacintosh),T.set("isLinux",k.isLinux),T.set("isWindows",k.isWindows),T.set("isWeb",k.isWeb),T.set("isMacNative",k.isMacintosh&&!k.isWeb),T.set("isEdge",A.indexOf("Edg/")>=0),T.set("isFirefox",A.indexOf("Firefox")>=0),T.set("isChrome",A.indexOf("Chrome")>=0),T.set("isSafari",A.indexOf("Safari")>=0);const R=Object.prototype.hasOwnProperty;var y;(function(w){w[w.False=0]="False",w[w.True=1]="True",w[w.Defined=2]="Defined",w[w.Not=3]="Not",w[w.Equals=4]="Equals",w[w.NotEquals=5]="NotEquals",w[w.And=6]="And",w[w.Regex=7]="Regex",w[w.NotRegex=8]="NotRegex",w[w.Or=9]="Or",w[w.In=10]="In",w[w.NotIn=11]="NotIn",w[w.Greater=12]="Greater",w[w.GreaterEquals=13]="GreaterEquals",w[w.Smaller=14]="Smaller",w[w.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class p{static false(){return m.INSTANCE}static true(){return h.INSTANCE}static has(g){return b.create(g)}static equals(g,U){return f.create(g,U)}static notEquals(g,U){return E.create(g,U)}static regex(g,U){return r.create(g,U)}static in(g,U){return C.create(g,U)}static not(g){return I.create(g)}static and(...g){return a.create(g)}static or(...g){return u.create(g)}static greater(g,U){return d.create(g,U)}static less(g,U){return s.create(g,U)}static deserialize(g,U=!1){if(!!g)return this._deserializeOrExpression(g,U)}static _deserializeOrExpression(g,U){let F=g.split("||");return u.create(F.map(j=>this._deserializeAndExpression(j,U)))}static _deserializeAndExpression(g,U){let F=g.split("&&");return a.create(F.map(j=>this._deserializeOne(j,U)))}static _deserializeOne(g,U){if(g=g.trim(),g.indexOf("!=")>=0){let F=g.split("!=");return E.create(F[0].trim(),this._deserializeValue(F[1],U))}if(g.indexOf("==")>=0){let F=g.split("==");return f.create(F[0].trim(),this._deserializeValue(F[1],U))}if(g.indexOf("=~")>=0){let F=g.split("=~");return r.create(F[0].trim(),this._deserializeRegexValue(F[1],U))}if(g.indexOf(" in ")>=0){let F=g.split(" in ");return C.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(g)){const F=g.split(">=");return o.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(g)){const F=g.split(">");return d.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(g)){const F=g.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(g)){const F=g.split("<");return s.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(g)?I.create(g.substr(1).trim()):b.create(g)}static _deserializeValue(g,U){if(g=g.trim(),g==="true")return!0;if(g==="false")return!1;let F=/^'([^']*)'$/.exec(g);return F?F[1].trim():g}static _deserializeRegexValue(g,U){if(v.isFalsyOrWhitespace(g)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=g.indexOf("/"),j=g.lastIndexOf("/");if(F===j||F<0){if(U)throw new Error(`bad regexp-value '${g}', missing /-enclosure`);return console.warn(`bad regexp-value '${g}', missing /-enclosure`),null}let $=g.slice(F+1,j),V=g[j+1]==="i"?"i":"";try{return new RegExp($,V)}catch(q){if(U)throw new Error(`bad regexp-value '${g}', parse error: ${q}`);return console.warn(`bad regexp-value '${g}', parse error: ${q}`),null}}}e.ContextKeyExpr=p;function n(w,g){return w.cmp(g)}class m{constructor(){this.type=0}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}evaluate(g){return!1}serialize(){return"false"}keys(){return[]}map(g){return this}negate(){return h.INSTANCE}}e.ContextKeyFalseExpr=m,m.INSTANCE=new m;class h{constructor(){this.type=1}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}evaluate(g){return!0}serialize(){return"true"}keys(){return[]}map(g){return this}negate(){return m.INSTANCE}}e.ContextKeyTrueExpr=h,h.INSTANCE=new h;class b{constructor(g){this.key=g,this.type=2}static create(g){const U=T.get(g);return typeof U=="boolean"?U?h.INSTANCE:m.INSTANCE:new b(g)}cmp(g){return g.type!==this.type?this.type-g.type:l(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}evaluate(g){return!!g.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(g){return g.mapDefined(this.key)}negate(){return I.create(this.key)}}e.ContextKeyDefinedExpr=b;class f{constructor(g,U){this.key=g,this.value=U,this.type=4}static create(g,U){if(typeof U=="boolean")return U?b.create(g):I.create(g);const F=T.get(g);return typeof F=="boolean"?U===(F?"true":"false")?h.INSTANCE:m.INSTANCE:new f(g,U)}cmp(g){return g.type!==this.type?this.type-g.type:S(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return g.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(g){return g.mapEquals(this.key,this.value)}negate(){return E.create(this.key,this.value)}}e.ContextKeyEqualsExpr=f;class C{constructor(g,U){this.key=g,this.valueKey=U,this.type=10}static create(g,U){return new C(g,U)}cmp(g){return g.type!==this.type?this.type-g.type:S(this.key,this.valueKey,g.key,g.valueKey)}equals(g){return g.type===this.type?this.key===g.key&&this.valueKey===g.valueKey:!1}evaluate(g){const U=g.getValue(this.valueKey),F=g.getValue(this.key);return Array.isArray(U)?U.indexOf(F)>=0:typeof F=="string"&&typeof U=="object"&&U!==null?R.call(U,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(g){return g.mapIn(this.key,this.valueKey)}negate(){return P.create(this)}}e.ContextKeyInExpr=C;class P{constructor(g){this._actual=g,this.type=11}static create(g){return new P(g)}cmp(g){return g.type!==this.type?this.type-g.type:this._actual.cmp(g._actual)}equals(g){return g.type===this.type?this._actual.equals(g._actual):!1}evaluate(g){return!this._actual.evaluate(g)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(g){return new P(this._actual.map(g))}negate(){return this._actual}}e.ContextKeyNotInExpr=P;class E{constructor(g,U){this.key=g,this.value=U,this.type=5}static create(g,U){if(typeof U=="boolean")return U?I.create(g):b.create(g);const F=T.get(g);return typeof F=="boolean"?U===(F?"true":"false")?m.INSTANCE:h.INSTANCE:new E(g,U)}cmp(g){return g.type!==this.type?this.type-g.type:S(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return g.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(g){return g.mapNotEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=E;class I{constructor(g){this.key=g,this.type=3}static create(g){const U=T.get(g);return typeof U=="boolean"?U?m.INSTANCE:h.INSTANCE:new I(g)}cmp(g){return g.type!==this.type?this.type-g.type:l(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}evaluate(g){return!g.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(g){return g.mapNot(this.key)}negate(){return b.create(this.key)}}e.ContextKeyNotExpr=I;class d{constructor(g,U){this.key=g,this.value=U,this.type=12}static create(g,U){return new d(g,U)}cmp(g){return g.type!==this.type?this.type-g.type:S(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(g){return g.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=d;class o{constructor(g,U){this.key=g,this.value=U,this.type=13}static create(g,U){return new o(g,U)}cmp(g){return g.type!==this.type?this.type-g.type:S(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(g){return g.mapGreaterEquals(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=o;class s{constructor(g,U){this.key=g,this.value=U,this.type=14}static create(g,U){return new s(g,U)}cmp(g){return g.type!==this.type?this.type-g.type:S(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(g){return g.mapSmaller(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeySmallerExpr=s;class t{constructor(g,U){this.key=g,this.value=U,this.type=15}static create(g,U){return new t(g,U)}cmp(g){return g.type!==this.type?this.type-g.type:S(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(g){return g.mapSmallerEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(g,U){this.key=g,this.regexp=U,this.type=7}static create(g,U){return new r(g,U)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.key<g.key)return-1;if(this.key>g.key)return 1;const U=this.regexp?this.regexp.source:"",F=g.regexp?g.regexp.source:"";return U<F?-1:U>F?1:0}equals(g){if(g.type===this.type){const U=this.regexp?this.regexp.source:"",F=g.regexp?g.regexp.source:"";return this.key===g.key&&U===F}return!1}evaluate(g){let U=g.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const g=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${g}`}keys(){return[this.key]}map(g){return g.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=r;class i{constructor(g){this._actual=g,this.type=8}static create(g){return new i(g)}cmp(g){return g.type!==this.type?this.type-g.type:this._actual.cmp(g._actual)}equals(g){return g.type===this.type?this._actual.equals(g._actual):!1}evaluate(g){return!this._actual.evaluate(g)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(g){return new i(this._actual.map(g))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class a{constructor(g){this.expr=g,this.type=6}static create(g){return a._normalizeArr(g)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const j=n(this.expr[U],g.expr[U]);if(j!==0)return j}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(g.expr[U]))return!1;return!0}return!1}evaluate(g){for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].evaluate(g))return!1;return!0}static _normalizeArr(g){const U=[];let F=!1;for(const j of g)if(!!j){if(j.type===1){F=!0;continue}if(j.type===0)return m.INSTANCE;if(j.type===6){U.push(...j.expr);continue}U.push(j)}if(U.length===0&&F)return h.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];for(U.sort(n);U.length>1;){const j=U[U.length-1];if(j.type!==9)break;U.pop();const $=U.pop(),V=u.create(j.expr.map(q=>a.create([q,$])));V&&(U.push(V),U.sort(n))}return U.length===1?U[0]:new a(U)}}serialize(){return this.expr.map(g=>g.serialize()).join(" && ")}keys(){const g=[];for(let U of this.expr)g.push(...U.keys());return g}map(g){return new a(this.expr.map(U=>U.map(g)))}negate(){let g=[];for(let U of this.expr)g.push(U.negate());return u.create(g)}}e.ContextKeyAndExpr=a;class u{constructor(g){this.expr=g,this.type=9}static create(g){const U=u._normalizeArr(g);if(U.length!==0)return U.length===1?U[0]:new u(U)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const j=n(this.expr[U],g.expr[U]);if(j!==0)return j}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(g.expr[U]))return!1;return!0}return!1}evaluate(g){for(let U=0,F=this.expr.length;U<F;U++)if(this.expr[U].evaluate(g))return!0;return!1}static _normalizeArr(g){let U=[],F=!1;if(g){for(let j=0,$=g.length;j<$;j++){const V=g[j];if(!!V){if(V.type===0){F=!0;continue}if(V.type===1)return[h.INSTANCE];if(V.type===9){U=U.concat(V.expr);continue}U.push(V)}}if(U.length===0&&F)return[m.INSTANCE];U.sort(n)}return U}serialize(){return this.expr.map(g=>g.serialize()).join(" || ")}keys(){const g=[];for(let U of this.expr)g.push(...U.keys());return g}map(g){return new u(this.expr.map(U=>U.map(g)))}negate(){let g=[];for(let F of this.expr)g.push(F.negate());const U=F=>F.type===9?F.expr:[F];for(;g.length>1;){const F=g.shift(),j=g.shift(),$=[];for(const V of U(F))for(const q of U(j))$.push(p.and(V,q));g.unshift(p.or(...$))}return g[0]}}e.ContextKeyOrExpr=u;class c extends b{constructor(g,U,F){super(g);this._defaultValue=U,typeof F=="object"?c._info.push(Object.assign(Object.assign({},F),{key:g})):F!==!0&&c._info.push({key:g,description:F,type:U!=null?typeof U:void 0})}static all(){return c._info.values()}bindTo(g){return g.createKey(this.key,this._defaultValue)}getValue(g){return g.getContextKeyValue(this.key)}toNegated(){return p.not(this.key)}isEqualTo(g){return p.equals(this.key,g)}notEqualsTo(g){return p.notEquals(this.key,g)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=L.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function l(w,g){return w<g?-1:w>g?1:0}function S(w,g,U,F){return w<U?-1:w>U?1:g<F?-1:g>F?1:0}}),define(Z[72],ee([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=v.createDecorator(e.ID);function L(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=L}),define(Z[73],ee([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=v.createDecorator("downloadService")}),define(Z[9],ee([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=v.createDecorator("environmentService"),e.INativeEnvironmentService=v.refineServiceDecorator(e.IEnvironmentService)}),define(Z[28],ee([0,1,110,4,17]),function(G,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function A(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=A;var T;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=5]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(T=e.SortBy||(e.SortBy={}));var R;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(R=e.SortOrder||(e.SortOrder={}));var y;(function(m){m.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var p;(function(m){m[m.None=0]="None",m[m.Install=1]="Install",m[m.Update=2]="Update"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=L.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(h,b){super(h);this.code=b}}e.ExtensionManagementError=n,e.IExtensionManagementService=L.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=L.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=L.createDecorator("IExtensionTipsService"),e.DefaultIconPath=k.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),e.ExtensionsLabel=v.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=v.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=L.createDecorator("IExtensionManagementCLIService")});var K=this&&this.__param||function(G,e){return function(v,L){e(v,L,G)}};define(Z[144],ee([0,1,2,28]),function(G,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let k=class extends v.Disposable{constructor(T){super();this.extensionManagementService=T,this._register(T),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};k=de([K(0,L.IExtensionManagementService)],k),e.DeprecatedExtensionsCleaner=k}),define(Z[74],ee([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function k(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=k;var A;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(A=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=v.createDecorator("IExtensionRecommendationNotificationService")}),define(Z[75],ee([0,1,20,4]),function(G,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function k(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkpaceSupportTypeMessage=k;function A(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class R{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,h){if(typeof m=="undefined"||m===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof m=="string"||typeof h=="string"){let b=typeof m=="string"?m:m.value,f=typeof h=="string"?h:h.value;return v.equalsIgnoreCase(b,f)}return m._lower===h._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=R;function y(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function p(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=p,e.IBuiltinExtensionsScannerService=L.createDecorator("IBuiltinExtensionsScannerService")}),define(Z[33],ee([0,1,20,75]),function(G,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(b,f){return b.uuid&&f.uuid?b.uuid===f.uuid:b.id===f.id?!0:v.compareIgnoreCase(b.id,f.id)===0}e.areSameExtensions=k;class A{constructor(f,C){this.version=C,this.id=f.id,this.uuid=f.uuid}key(){return`${this.id}-${this.version}`}equals(f){return f instanceof A?k(this,f)&&this.version===f.version:!1}}e.ExtensionIdentifierWithVersion=A;function T(b,f){return`${b}.${f}`}e.getExtensionId=T;function R(b){return b.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function y(b,f){return R(T(b,f))}e.getGalleryExtensionId=y;function p(b,f){const C=[],P=E=>{for(const I of C)if(I.some(d=>k(f(d),f(E))))return I;return null};for(const E of b){const I=P(E);I?I.push(E):C.push([E])}return C}e.groupByExtension=p;function n(b){return{id:b.identifier.id,name:b.manifest.name,galleryId:null,publisherId:b.publisherId,publisherName:b.manifest.publisher,publisherDisplayName:b.publisherDisplayName,dependencies:b.manifest.extensionDependencies&&b.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function m(b){return Object.assign({id:b.identifier.id,name:b.name,galleryId:b.identifier.uuid,publisherId:b.publisherId,publisherName:b.publisher,publisherDisplayName:b.publisherDisplayName,dependencies:!!(b.properties.dependencies&&b.properties.dependencies.length>0)},b.telemetryData)}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function h(b){const f=new Set;for(const C of b)C.malicious&&f.add(C.id.id);return f}e.getMaliciousExtensionsSet=h}),define(Z[145],ee([0,1,2,8,75,18]),function(G,e,v,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends v.Disposable{constructor(y,p){super();this.environmentService=y,this.extensionsManifestCache=L.join(this.environmentService.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this._register(p.onDidInstallExtension(n=>this.onDidInstallExtension(n))),this._register(p.onDidUninstallExtension(n=>this.onDidUnInstallExtension(n)))}onDidInstallExtension(y){y.error||this.invalidate()}onDidUnInstallExtension(y){y.error||this.invalidate()}invalidate(){A.Promises.rm(this.extensionsManifestCache,A.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(Z[10],ee([0,1,117,8,5,4,20,16,38]),function(G,e,v,L,k,A,T,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=A.createDecorator("fileService");function p(z){return z.create===!0}e.isFileOpenForWriteOptions=p;var n;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var m;(function(z){z[z.Readonly=1]="Readonly"})(m=e.FilePermission||(e.FilePermission={}));var h;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock"})(h=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=b;function f(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=f;function C(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=C;function P(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=P;var E;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class I extends Error{constructor(H,Q){super(H);this.code=Q}}e.FileSystemProviderError=I;function d(z,H){const Q=new I(z.toString(),H);return s(Q,H),Q}e.createFileSystemProviderError=d;function o(z){return z||d(v.localize(0,null),E.Unknown)}e.ensureFileSystemProviderError=o;function s(z,H){return z.name=H?`${H} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=s;function t(z){if(!z)return E.Unknown;if(z instanceof I)return z.code;const H=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!H)return E.Unknown;switch(H[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=t;function r(z){if(z instanceof S)return z.fileOperationResult;switch(t(z)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class a{constructor(H,Q,N){this.resource=H,this.operation=Q,this.target=N}isOperation(H){return this.operation===H}}e.FileOperationEvent=a;var u;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class c{constructor(H,Q){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const N of H)switch(N.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>Q)),this.added.set(N.resource,N);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>Q)),this.updated.set(N.resource,N);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>Q)),this.deleted.set(N.resource,N);break}}contains(H,...Q){return this.doContains(H,{includeChildren:!1},...Q)}affects(H,...Q){return this.doContains(H,{includeChildren:!0},...Q)}doContains(H,Q,...N){var O,D,M,_,x,B;if(!H)return!1;const J=N.length>0;return!!((!J||N.includes(1))&&(((O=this.added)===null||O===void 0?void 0:O.get(H))||Q.includeChildren&&((D=this.added)===null||D===void 0?void 0:D.findSuperstr(H)))||(!J||N.includes(0))&&(((M=this.updated)===null||M===void 0?void 0:M.get(H))||Q.includeChildren&&((_=this.updated)===null||_===void 0?void 0:_.findSuperstr(H)))||(!J||N.includes(2))&&(((x=this.deleted)===null||x===void 0?void 0:x.findSubstr(H))||Q.includeChildren&&((B=this.deleted)===null||B===void 0?void 0:B.findSuperstr(H))))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=c;function l(z,H,Q){return!z||!H||z===H||H.length>z.length?!1:(H.charAt(H.length-1)!==L.sep&&(H+=L.sep),Q?T.startsWithIgnoreCase(z,H):z.indexOf(H)===0)}e.isParent=l;class S extends Error{constructor(H,Q,N){super(H);this.fileOperationResult=Q,this.options=N}}e.FileOperationError=S;class w extends S{constructor(H,Q,N){super(H,2,N);this.stat=Q}}e.NotModifiedSinceFileOperationError=w;var g;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(g=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=F;async function j(z,H){if(!H.canHandleResource(k.URI.from({scheme:z.scheme})))return new Promise(Q=>{const N=H.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===z.scheme&&O.added&&(N.dispose(),Q())})})}e.whenProviderRegistered=j,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(H){return R.isNumber(H)||(H=0),H<$.KB?v.localize(1,null,H.toFixed(0)):H<$.MB?v.localize(2,null,(H/$.KB).toFixed(2)):H<$.GB?v.localize(3,null,(H/$.MB).toFixed(2)):H<$.TB?v.localize(4,null,(H/$.GB).toFixed(2)):v.localize(5,null,(H/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var V;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function q(z){return{maxFileSize:z===0?300*$.MB:16*$.GB,maxHeapSize:z===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=q}),define(Z[146],ee([0,1,147,47,10]),function(G,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let A=class{constructor(R){this.fileService=R}checksum(R){return new Promise(async(y,p)=>{const n=v.createHash("md5"),m=(await this.fileService.readFileStream(R)).value;L.listenStream(m,{onData:h=>n.update(h.buffer),onError:h=>p(h),onEnd:()=>y(n.digest("base64").replace(/=+$/,""))})})}};A=de([K(0,k.IFileService)],A),e.ChecksumService=A}),define(Z[76],ee([0,1,5,10,7]),function(G,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function A(y){return y.map(p=>({type:p.type,resource:v.URI.file(p.path)}))}e.toFileChanges=A;function T(y){const p=new R;for(const n of y)p.processEvent(n);return p.normalize()}e.normalizeFileChanges=T;class R{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(p){const n=this.mapPathToChange.get(p.path);if(n){const m=n.type,h=p.type;m===1&&h===2?(this.mapPathToChange.delete(p.path),this.normalized.splice(this.normalized.indexOf(n),1)):m===2&&h===1?n.type=0:m===1&&h===0||(n.type=h)}else this.normalized.push(p),this.mapPathToChange.set(p.path,p)}normalize(){const p=[],n=[];return this.normalized.filter(m=>m.type!==2?(p.push(m),!1):!0).sort((m,h)=>m.path.length-h.path.length).filter(m=>n.some(h=>L.isParent(m.path,h,!k.isLinux))?!1:(n.push(m.path),!0)).concat(p)}}}),define(Z[148],ee([0,1,76,2,18,96,99,6,8]),function(G,e,v,L,k,A,T,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class p extends L.Disposable{constructor(m,h,b,f){super();this.path=m,this.onDidFilesChange=h,this.onLogMessage=b,this.verboseLogging=f,this.fileChangesDelayer=this._register(new R.ThrottledDelayer(T.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(m){this.verboseLogging=m}async startWatching(){try{const{stat:m,symbolicLink:h}=await k.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let b=this.path;if(h)try{b=await A.realpath(b)}catch(f){if(this.onError(f),h.dangling)return}m.isDirectory()?this._register(T.watchFolder(b,(f,C)=>{this.onFileChange({type:f==="changed"?0:f==="added"?1:2,path:y.join(this.path,y.basename(C))})},f=>this.onError(f))):this._register(T.watchFile(b,f=>{this.onFileChange({type:f==="changed"?0:2,path:this.path})},f=>this.onError(f)))}catch(m){m.code!=="ENOENT"&&this.onError(m)}}onFileChange(m){this.fileChangesBuffer.push(m),this.verboseLogging&&this.onVerbose(`${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`),this.fileChangesDelayer.trigger(async()=>{const h=this.fileChangesBuffer;this.fileChangesBuffer=[];const b=v.normalizeFileChanges(h);if(this.verboseLogging)for(const f of b)this.onVerbose(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`);b.length>0&&this.onDidFilesChange(b)})}onError(m){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${m}`})}onVerbose(m){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${m}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=p}),define(Z[77],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...k){this._entries=new Map;for(let[A,T]of k)this.set(A,T)}set(k,A){const T=this._entries.get(k);return this._entries.set(k,A),T}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=v}),define(Z[149],ee([0,1,11,141,50,4,77,6]),function(G,e,v,L,k,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class p extends Error{constructor(f){var C;super("cyclic dependency between services");this.message=(C=f.findCycleSlow())!==null&&C!==void 0?C:`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class n{constructor(f=new T.ServiceCollection,C=!1,P){this._activeInstantiations=new Set,this._services=f,this._strict=C,this._parent=P,this._services.set(A.IInstantiationService,this)}createChild(f){return new n(f,this._strict,this)}invokeFunction(f,...C){let P=h.traceInvocation(f),E=!1;try{return f({get:(d,o)=>{if(E)throw v.illegalState("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(d,P);if(!s&&o!==A.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return s}},...C)}finally{E=!0,P.stop()}}createInstance(f,...C){let P,E;return f instanceof k.SyncDescriptor?(P=h.traceCreation(f.ctor),E=this._createInstance(f.ctor,f.staticArguments.concat(C),P)):(P=h.traceCreation(f),E=this._createInstance(f,C,P)),P.stop(),E}_createInstance(f,C=[],P){let E=A._util.getServiceDependencies(f).sort((o,s)=>o.index-s.index),I=[];for(const o of E){let s=this._getOrCreateServiceInstance(o.id,P);if(!s&&this._strict&&!o.optional)throw new Error(`[createInstance] ${f.name} depends on UNKNOWN service ${o.id}.`);I.push(s)}let d=E.length>0?E[0].index:C.length;if(C.length!==d){console.warn(`[createInstance] First service dependency of ${f.name} at position ${d+1} conflicts with ${C.length} static arguments`);let o=d-C.length;o>0?C=C.concat(new Array(o)):C=C.slice(0,d)}return new f(...[...C,...I])}_setServiceInstance(f,C){if(this._services.get(f)instanceof k.SyncDescriptor)this._services.set(f,C);else if(this._parent)this._parent._setServiceInstance(f,C);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){let C=this._services.get(f);return!C&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):C}_getOrCreateServiceInstance(f,C){let P=this._getServiceInstanceOrDescriptor(f);return P instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,P,C.branch(f,!0)):(C.branch(f,!1),P)}_safeCreateAndCacheServiceInstance(f,C,P){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,C,P)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,C,P){const E=new L.Graph(o=>o.id.toString());let I=0;const d=[{id:f,desc:C,_trace:P}];for(;d.length;){const o=d.pop();if(E.lookupOrInsertNode(o),I++>1e3)throw new p(E);for(let s of A._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(s.id);if(!t&&!s.optional&&console.warn(`[createInstance] ${f} depends on ${s.id} which is NOT registered.`),t instanceof k.SyncDescriptor){const r={id:s.id,desc:t,_trace:o._trace.branch(s.id,!0)};E.insertEdge(o,r),d.push(r)}}}for(;;){const o=E.roots();if(o.length===0){if(!E.isEmpty())throw new p(E);break}for(const{data:s}of o){if(this._getServiceInstanceOrDescriptor(s.id)instanceof k.SyncDescriptor){const r=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,r)}E.removeNode(s)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,C,P=[],E,I){if(this._services.get(f)instanceof k.SyncDescriptor)return this._createServiceInstance(C,P,E,I);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,C,P,E,I);throw new Error(`illegalState - creating UNKNOWN service instance ${C.name}`)}_createServiceInstance(f,C=[],P,E){if(P){const I=new R.IdleValue(()=>this._createInstance(f,C,E));return new Proxy(Object.create(null),{get(d,o){if(o in d)return d[o];let s=I.value,t=s[o];return typeof t!="function"||(t=t.bind(s),d[o]=t),t},set(d,o,s){return I.value[o]=s,!0}})}else return this._createInstance(f,C,E)}}e.InstantiationService=n;var m;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(m||(m={}));class h{constructor(f,C){this.type=f,this.name=C,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return y?new h(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(f){return y?new h(0,f.name):h._None}branch(f,C){let P=new h(2,f.toString());return this._dep.push([f,C,P]),P}stop(){let f=Date.now()-this._start;h._totals+=f;let C=!1;function P(I,d){let o=[],s=new Array(I+1).join("	");for(const[t,r,i]of d._dep)if(r&&i){C=!0,o.push(`${s}CREATES -> ${t}`);let a=P(I+1,i);a&&o.push(a)}else o.push(`${s}uses -> ${t}`);return o.join(`
`)}let E=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${P(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(f>2||C)&&console.log(E.join(`
`))}}h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0}),define(Z[150],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class v{constructor(k,A){this.server=k,this.router=A}getChannel(k){return this.server.getChannel(k,this.router)}registerChannel(k,A){this.server.registerChannel(k,A)}}e.MessagePortMainProcessService=v}),define(Z[151],ee([0,1,36,50,140,4]),function(G,e,v,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class T{constructor(b,f,C){const P=C.getChannel(b);return R(f)?new f.channelClientCtor(P):v.ProxyChannel.toService(P,f==null?void 0:f.proxyOptions)}}function R(h){const b=h;return!!(b==null?void 0:b.channelClientCtor)}e.IMainProcessService=A.createDecorator("mainProcessService");let y=class extends T{constructor(b,f,C){super(b,f,C)}};y=de([K(2,e.IMainProcessService)],y);function p(h,b,f){k.registerSingleton(h,new L.SyncDescriptor(y,[b,f],f==null?void 0:f.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=p,e.ISharedProcessService=A.createDecorator("sharedProcessService");let n=class extends T{constructor(b,f,C){super(b,f,C)}};n=de([K(2,e.ISharedProcessService)],n);function m(h,b,f){k.registerSingleton(h,new L.SyncDescriptor(n,[b,f],f==null?void 0:f.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=m}),define(Z[56],ee([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=v.createDecorator("localizationsService");function L(k){if(typeof k.languageId!="string"||!Array.isArray(k.translations)||k.translations.length===0)return!1;for(const A of k.translations)if(typeof A.id!="string"||typeof A.path!="string")return!1;return!(k.languageName&&typeof k.languageName!="string"||k.localizedLanguageName&&typeof k.localizedLanguageName!="string")}e.isValidLocalization=L}),define(Z[152],ee([0,1,2,56]),function(G,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let k=class extends v.Disposable{constructor(T){super();this.localizationsService=T,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};k=de([K(0,L.ILocalizationsService)],k),e.LocalizationsUpdater=k}),define(Z[15],ee([0,1,4,2,7,3,43]),function(G,e,v,L,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=v.createDecorator("logService"),e.ILoggerService=v.createDecorator("loggerService");function R(){return new Date().toISOString()}var y;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class p extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=p;class n extends p{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(y.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(y.Error,this.format(i))}else this.log(y.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let i=0;i<t.length;i++){let a=t[i];if(typeof a=="object")try{a=JSON.stringify(a)}catch(u){}r+=(i>0?" ":"")+a}return r}}e.AbstractMessageLogger=n;class m extends p{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!k.isWindows}trace(t,...r){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,t,...r):console.log(`[main ${R()}]`,t,...r))}debug(t,...r){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,t,...r):console.log(`[main ${R()}]`,t,...r))}info(t,...r){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,t,...r):console.log(`[main ${R()}]`,t,...r))}warn(t,...r){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,t,...r):console.warn(`[main ${R()}]`,t,...r))}error(t,...r){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,t,...r):console.error(`[main ${R()}]`,t,...r))}critical(t,...r){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,t,...r):console.error(`[main ${R()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class h extends p{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=h;class b extends p{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:T.toErrorMessage(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class f extends p{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const i of this.logServices)i.trace(t,...r)}debug(t,...r){for(const i of this.logServices)i.debug(t,...r)}info(t,...r){for(const i of this.logServices)i.info(t,...r)}warn(t,...r){for(const i of this.logServices)i.warn(t,...r)}error(t,...r){for(const i of this.logServices)i.error(t,...r)}critical(t,...r){for(const i of this.logServices)i.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=f;class C extends L.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=C;class P extends L.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(i))}))}createLogger(t,r){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,(r==null?void 0:r.always)?y.Trace:this.logLevel,r),this.loggers.set(t.toString(),i),(r==null?void 0:r.always)||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class E{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=E;function I(s){if(s.verbose)return y.Trace;if(typeof s.logLevel=="string"){const t=d(s.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=I;function d(s){switch(s){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=d;function o(s){switch(s){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=o}),define(Z[153],ee([0,1,9,8,18,11,2,6,15]),function(G,e,v,L,k,A,T,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let p=class extends T.Disposable{constructor(m,h){super();this.environmentService=m,this.logService=h,this._register(new R.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const m=L.basename(this.environmentService.logsPath),h=L.dirname(this.environmentService.logsPath),C=(await k.Promises.readdir(h)).filter(E=>/^\d{8}T\d{6}$/.test(E)).sort().filter(E=>E!==m),P=C.slice(0,Math.max(0,C.length-9));P.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${P.join(", ")}'`),await Promise.all(P.map(E=>k.Promises.rm(L.join(h,E)))))}catch(m){A.onUnexpectedError(m)}}};p=de([K(0,v.IEnvironmentService),K(1,y.ILogService)],p),e.LogsDataCleaner=p}),define(Z[154],ee([0,1,9,8,18,11,2,6,15]),function(G,e,v,L,k,A,T,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let p=class ft extends T.Disposable{constructor(m,h,b){super();this.backupWorkspacesPath=m,this.environmentService=h,this.logService=b,this._register(new R.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const m=await k.Promises.readFile(this.backupWorkspacesPath,"utf8"),b=JSON.parse(m).emptyWorkspaceInfos.map(C=>C.backupFolder),f=await k.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(f.map(async C=>{C.length!==ft.NON_EMPTY_WORKSPACE_ID_LENGTH&&b.indexOf(C)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${C}.`),await k.Promises.rm(L.join(this.environmentService.workspaceStorageHome.fsPath,C)))}))}catch(m){A.onUnexpectedError(m)}}};p.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,p=de([K(1,v.INativeEnvironmentService),K(2,y.ILogService)],p),e.StorageDataCleaner=p}),define(Z[155],ee([0,1,18,2,10,28,9,5,12,33,15,30,57,7,6,11]),function(G,e,v,L,k,A,T,R,y,p,n,m,h,b,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let E=class extends L.Disposable{constructor(d,o,s,t){super();this.fileService=o,this.extensionGalleryService=s,this.logService=t,this.extensionsDownloadDir=R.URI.file(d.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(d,o){await this.cleanUpPromise;const s=this.getName(d),t=y.joinPath(this.extensionsDownloadDir,s);if(!await this.fileService.exists(t)){const r=y.joinPath(this.extensionsDownloadDir,`.${m.generateUuid()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(d,r,o);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(r)}catch(a){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",d.identifier.id);else throw this.logService.info(`Rename failed because of ${C.getErrorMessage(i)}. Deleted the vsix from downloaded location`,r.path),i}}return t}async delete(d){}async rename(d,o,s){try{await v.Promises.rename(d.fsPath,o.fsPath)}catch(t){if(b.isWindows&&t&&t.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${d} to ${o} with 'EPERM' error. Trying again...`),this.rename(d,o,s);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const d=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(d.children){const o=[],s=[];for(const i of d.children){const a=this.parse(i.name);a&&s.push([a,i])}const t=p.groupByExtension(s,([i])=>i),r=[];for(const i of t)i.sort((a,u)=>h.rcompare(a[0].version,u[0].version)),o.push(...i.slice(1).map(a=>a[1].resource)),r.push(i[0][1]);r.sort((i,a)=>i.mtime-a.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(i=>i.resource)),await f.Promises.settled(o.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(d){this.logService.error(d)}}getName(d){return this.cache?new p.ExtensionIdentifierWithVersion(d.identifier,d.version).key().toLowerCase():m.generateUuid()}parse(d){const o=P.exec(d);return o&&o[1]&&o[2]?new p.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};E=de([K(0,T.INativeEnvironmentService),K(1,k.IFileService),K(2,A.IExtensionGalleryService),K(3,n.ILogService)],E),e.ExtensionsDownloader=E}),define(Z[156],ee([0,1,2,15,42,43,8,6,3,17,18,9]),function(G,e,v,L,k,A,T,R,y,p,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let h=class extends v.Disposable{constructor(f,C){super();this.environmentService=f,this.logService=C,this.processesLimiter=new R.Limiter(5)}async postUninstall(f){const C=this.parseScript(f,"uninstall");return C&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(C.script,"uninstall",C.args,!0,f).then(()=>this.logService.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),P=>this.logService.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${P}`)))),n.Promises.rm(this.getExtensionStoragePath(f)).then(void 0,P=>this.logService.error("Error while removing extension storage path",P))}parseScript(f,C){const P=`vscode:${C}`;if(f.location.scheme===p.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[P]=="string"){const E=f.manifest.scripts[P].split(" ");return E.length<2||E[0]!=="node"||!E[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${P} should be a node script`),null):{script:T.join(f.location.fsPath,E[1]),args:E.slice(2)||[]}}return null}runLifecycleHook(f,C,P,E,I){return new Promise((d,o)=>{const s=this.start(f,C,P,I);let t;const r=i=>{t&&(clearTimeout(t),t=null),i?o(i):d(void 0)};s.on("error",i=>{r(A.toErrorMessage(i)||"Unknown")}),s.on("exit",(i,a)=>{r(i?`post-${C} process exited with code ${i}`:void 0)}),E&&(t=setTimeout(()=>{t=null,s.kill(),o("timed out")},5e3))})}start(f,C,P,E){const I={silent:!0,execArgv:void 0},d=k.fork(f,[`--type=extension-post-${C}`,...P],I);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const o=y.Event.fromNodeEventEmitter(d.stdout,"data"),s=y.Event.fromNodeEventEmitter(d.stderr,"data");o(i=>this.logService.info(E.identifier.id,E.manifest.version,`post-${C}`,i)),s(i=>this.logService.error(E.identifier.id,E.manifest.version,`post-${C}`,i));const t=y.Event.any(y.Event.map(o,i=>({data:`%c${i}`,format:[""]})),y.Event.map(s,i=>({data:`%c${i}`,format:["color: red"]})));return y.Event.debounce(t,(i,a)=>i?{data:i.data+a.data,format:[...i.format,...a.format]}:{data:a.data,format:a.format},100)(i=>{console.group(E.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),d}getExtensionStoragePath(f){return T.join(this.environmentService.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};h=de([K(0,m.IEnvironmentService),K(1,L.ILogService)],h),e.ExtensionsLifecycle=h}),define(Z[157],ee([0,1,2,9,3,10,5,33,12,15]),function(G,e,v,L,k,A,T,R,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let n=class extends v.Disposable{constructor(h,b,f,C){super();this.extensionsManagementService=h,this.logService=C,this._onDidChangeExtensionsByAnotherSource=this._register(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(I=>{this.installedExtensions=I.map(d=>d.identifier),this.startTimestamp=Date.now()}),this._register(h.onInstallExtension(I=>this.onInstallExtension(I))),this._register(h.onDidInstallExtension(I=>this.onDidInstallExtension(I))),this._register(h.onDidUninstallExtension(I=>this.onDidUninstallExtension(I)));const P=T.URI.file(f.extensionsPath),E=new y.ExtUri(I=>!b.hasCapability(I,1024));this._register(b.watch(P)),this._register(k.Event.filter(b.onDidChangeFilesRaw,I=>I.changes.some(d=>this.doesChangeAffects(d,P,E)))(()=>this.onDidChange()))}doesChangeAffects(h,b,f){return f.isEqual(f.dirname(h.resource),b)?f.isEqual(h.resource,f.joinPath(b,".obsolete"))?!0:!(h.type!==1&&h.type!==2||f.basename(h.resource).startsWith(".")):!1}onInstallExtension(h){this.addInstallingExtension(h.identifier)}onDidInstallExtension(h){this.removeInstallingExtension(h.identifier),h.error||this.addInstalledExtension(h.identifier)}onDidUninstallExtension(h){h.error||this.removeInstalledExtension(h.identifier)}addInstallingExtension(h){this.removeInstallingExtension(h),this.installingExtensions.push(h)}removeInstallingExtension(h){this.installingExtensions=this.installingExtensions.filter(b=>!R.areSameExtensions(b,h))}addInstalledExtension(h){this.installedExtensions&&(this.removeInstalledExtension(h),this.installedExtensions.push(h))}removeInstalledExtension(h){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(b=>!R.areSameExtensions(b,h)))}async onDidChange(){if(this.installedExtensions){const h=await this.extensionsManagementService.getInstalled(1),b=h.filter(C=>[...this.installingExtensions,...this.installedExtensions].some(P=>R.areSameExtensions(P,C.identifier))?!1:C.installedTimestamp&&C.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",C.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",C.identifier.id),!1)),f=this.installedExtensions.filter(C=>this.installingExtensions.some(P=>R.areSameExtensions(P,C))?!1:h.every(P=>!R.areSameExtensions(P.identifier,C))?(this.logService.info("Detected extension removed from another source",C.id),!0):!1);this.installedExtensions=h.map(C=>C.identifier),(b.length||f.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:b,removed:f})}}};n=de([K(1,A.IFileService),K(2,L.INativeEnvironmentService),K(3,p.ILogService)],n),e.ExtensionsWatcher=n}),define(Z[158],ee([0,1,18,147,28,2,9,6,33,15,56,19,3,17,8]),function(G,e,v,L,k,A,T,R,y,p,n,m,h,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let C=class extends A.Disposable{constructor(I,d,o){super();this.extensionManagementService=I,this.logService=o,this._onDidLanguagesChange=this._register(new h.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new P(d,o)),this._register(I.onDidInstallExtension(({local:s})=>this.onDidInstallExtension(s))),this._register(I.onDidUninstallExtension(({identifier:s})=>this.onDidUninstallExtension(s)))}getLanguageIds(){return this.cache.getLanguagePacks().then(I=>{const d=["en",...Object.keys(I)];return m.distinct(d)})}onDidInstallExtension(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",I.identifier.id),this.update().then(d=>{d&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(I){this.cache.getLanguagePacks().then(d=>{Object.keys(d).some(o=>d[o]&&d[o].extensions.some(s=>y.areSameExtensions(s.extensionIdentifier,I)))&&(this.logService.debug("Removing language packs from the extension",I.id),this.update().then(o=>{o&&this._onDidLanguagesChange.fire()}))})}async update(){const[I,d]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),o=await this.cache.update(d);return!m.equals(Object.keys(I),Object.keys(o))}};C=de([K(0,k.IExtensionManagementService),K(1,T.INativeEnvironmentService),K(2,p.ILogService)],C),e.LocalizationsService=C;let P=class extends A.Disposable{constructor(I,d){super();this.logService=d,this.languagePacks={},this.languagePacksFilePath=f.join(I.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(I){return this.withLanguagePacks(d=>{Object.keys(d).forEach(o=>delete d[o]),this.createLanguagePacksFromExtensions(d,...I)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(I,...d){for(const o of d)o&&o.manifest&&o.manifest.contributes&&o.manifest.contributes.localizations&&o.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(I,o);Object.keys(I).forEach(o=>this.updateHash(I[o]))}createLanguagePacksFromExtension(I,d){const o=d.identifier,s=d.manifest.contributes&&d.manifest.contributes.localizations?d.manifest.contributes.localizations:[];for(const t of s)if(d.location.scheme===b.Schemas.file&&n.isValidLocalization(t)){let r=I[t.languageId];r||(r={hash:"",extensions:[],translations:{}},I[t.languageId]=r);let i=r.extensions.filter(a=>y.areSameExtensions(a.extensionIdentifier,o))[0];i?i.version=d.manifest.version:r.extensions.push({extensionIdentifier:o,version:d.manifest.version});for(const a of t.translations)r.translations[a.id]=f.join(d.location.fsPath,a.path)}}updateHash(I){if(I){const d=L.createHash("md5");for(const o of I.extensions)d.update(o.extensionIdentifier.uuid||o.extensionIdentifier.id).update(o.version);I.hash=d.digest("hex")}}withLanguagePacks(I=()=>null){return this.languagePacksFileLimiter.queue(()=>{let d=null;return v.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,o=>o.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(o)).then(o=>{try{return JSON.parse(o)}catch(s){return{}}}).then(o=>(d=I(o),o)).then(o=>{for(const t of Object.keys(o))o[t]||delete o[t];this.languagePacks=o,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),v.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>d,o=>this.logService.error(o))})}};P=de([K(0,T.INativeEnvironmentService),K(1,p.ILogService)],P)}),define(Z[78],ee([0,1,15,3,5]),function(G,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class A{constructor(h){this.service=h,this.onDidChangeLogLevel=L.Event.buffer(h.onDidChangeLogLevel,!0)}listen(h,b){switch(b){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${b}`)}async call(h,b,f){switch(b){case"setLevel":return this.service.setLevel(f)}throw new Error(`Call not found: ${b}`)}}e.LogLevelChannel=A;class T{constructor(h){this.channel=h}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(h){T.setLevel(this.channel,h)}static setLevel(h,b){return h.call("setLevel",b)}}e.LogLevelChannelClient=T;class R{constructor(h){this.loggerService=h,this.loggers=new Map}listen(h,b){throw new Error(`Event not found: ${b}`)}async call(h,b,f){switch(b){case"createLogger":this.createLogger(k.URI.revive(f[0]),f[1]);return;case"log":return this.log(k.URI.revive(f[0]),f[1]);case"consoleLog":return this.consoleLog(f[0],f[1])}throw new Error(`Call not found: ${b}`)}createLogger(h,b){this.loggers.set(h.toString(),this.loggerService.createLogger(h,b))}consoleLog(h,b){let f=console.log;switch(h){case v.LogLevel.Error:f=console.error;break;case v.LogLevel.Warning:f=console.warn;break;case v.LogLevel.Info:f=console.info;break}f.call(console,...b)}log(h,b){const f=this.loggers.get(h.toString());if(!f)throw new Error("Create the logger before logging");for(const[C,P]of b)switch(C){case v.LogLevel.Trace:f.trace(P);break;case v.LogLevel.Debug:f.debug(P);break;case v.LogLevel.Info:f.info(P);break;case v.LogLevel.Warning:f.warn(P);break;case v.LogLevel.Error:f.error(P);break;case v.LogLevel.Critical:f.critical(P);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=R;class y extends v.AbstractLoggerService{constructor(h,b,f){super(h,b);this.channel=f}createConsoleMainLogger(){return new v.AdapterLogger({log:(h,b)=>{this.channel.call("consoleLog",[h,b])}})}doCreateLogger(h,b,f){return new p(this.channel,h,b,f)}}e.LoggerChannelClient=y;class p extends v.AbstractMessageLogger{constructor(h,b,f,C){super(C==null?void 0:C.always);this.channel=h,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.channel.call("createLogger",[b,C]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(h,b){const f=[[h,b]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(h){this.channel.call("log",[this.file,h])}}class n extends v.LogService{constructor(h,b){super(b);this.parent=h,this._register(h.onDidChangeLogLevel(f=>b.setLevel(f)))}setLevel(h){super.setLevel(h),this.parent.setLevel(h)}}e.FollowerLogService=n}),define(Z[58],ee([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=v.createDecorator("nativeHostService")}),define(Z[51],ee([0,1,17,7,34,12]),function(G,e,v,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const R=L.globals.vscode.context.configuration();if(R)T=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(G==null?void 0:G.__$__nodeRequire)=="function"){const R=A.dirname(v.FileAccess.asFileUri("",G));T=G.__$__nodeRequire(A.joinPath(R,"product.json").fsPath);const y=G.__$__nodeRequire(A.joinPath(R,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:y.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.58.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T}),define(Z[79],ee([0,1,118,25,10,11,51]),function(G,e,v,L,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function R(m,h,b,f,C,P){let E;try{await y(m,h,b,f,C,P)}catch(I){E=I}finally{E&&C.errorTransformer&&(E=C.errorTransformer(E)),typeof E!="undefined"&&b.error(E),b.end()}}e.readFileIntoStream=R;async function y(m,h,b,f,C,P){p(P);const E=await m.open(h,{create:!1});try{p(P);let I=0,d=0,o=C&&typeof C.length=="number"?C.length:void 0,s=L.VSBuffer.alloc(Math.min(C.bufferSize,typeof o=="number"?o:C.bufferSize)),t=C&&typeof C.position=="number"?C.position:0,r=0;do d=await m.read(E,t,s.buffer,r,s.byteLength-r),t+=d,r+=d,I+=d,typeof o=="number"&&(o-=d),r===s.byteLength&&(await b.write(f(s)),s=L.VSBuffer.alloc(Math.min(C.bufferSize,typeof o=="number"?o:C.bufferSize)),r=0);while(d>0&&(typeof o!="number"||o>0)&&p(P)&&n(I,C));if(r>0){let i=r;typeof o=="number"&&(i=Math.min(r,o)),b.write(f(s.slice(0,i)))}}catch(I){throw k.ensureFileSystemProviderError(I)}finally{await m.close(E)}}function p(m){if(m.isCancellationRequested)throw A.canceled();return!0}function n(m,h){if(h==null?void 0:h.limits){if(typeof h.limits.memory=="number"&&m>h.limits.memory)throw k.createFileSystemProviderError(v.localize(0,null,T.default.nameShort),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof h.limits.size=="number"&&m>h.limits.size)throw k.createFileSystemProviderError(v.localize(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[159],ee([0,1,116,160,2,10,3,12,38,19,15,25,47,6,29,17,79,53]),function(G,e,v,L,k,A,T,R,y,p,n,m,h,b,f,C,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let I=class qe extends k.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new T.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new b.ThrottledWorker(qe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,qe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,qe.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new A.FileChangesEvent(s,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new b.ThrottledWorker(qe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,qe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,qe.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new A.FileChangesEvent(s,!0)))),this.watchedResources=y.TernarySearchTree.forUris(s=>{const t=this.getProvider(s.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new b.ResourceQueue)}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);L.mark(`code/registerFilesystem/${o}`),this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s});const t=new k.DisposableStore;return t.add(s.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(s)))),t.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),typeof s.onDidErrorOccur=="function"&&t.add(s.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),k.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),k.dispose(t)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){s.push(t)}}),!this.provider.has(o)&&await b.Promises.settled(s)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,s){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&s)}listCapabilities(){return E.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!R.isAbsolutePath(o))throw new A.FileOperationError(v.localize(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const t=new Error;throw t.name="ENOPRO",t.message=v.localize(1,null,o.toString()),t}return s}async withReadProvider(o){const s=await this.withProvider(o);if(A.hasOpenReadWriteCloseCapability(s)||A.hasReadWriteCapability(s)||A.hasFileReadStreamCapability(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if(A.hasOpenReadWriteCloseCapability(s)||A.hasReadWriteCapability(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(t){throw A.toFileSystemProviderErrorCode(t)===A.FileSystemProviderErrorCode.FileNotFound?new A.FileOperationError(v.localize(2,null,this.resourceForError(o)),1):A.ensureFileSystemProviderError(t)}}async doResolveFile(o,s){const t=await this.withProvider(o),r=this.isPathCaseSensitive(t),i=s==null?void 0:s.resolveTo,a=s==null?void 0:s.resolveSingleChildDescendants,u=s==null?void 0:s.resolveMetadata,c=await t.stat(o);let l;return this.toFileStat(t,o,c,void 0,!!u,(S,w)=>(l||(l=y.TernarySearchTree.forUris(()=>!r),l.set(o,!0),p.isNonEmptyArray(i)&&i.forEach(g=>l.set(g,!0))),Boolean(l.findSuperstr(S.resource)||l.get(S.resource))?!0:S.isDirectory&&a?w===1:!1))}async toFileStat(o,s,t,r,i,a){var u;const{providerExtUri:c}=this.getExtUri(o),l={resource:s,name:c.basename(s),isFile:(t.type&A.FileType.File)!=0,isDirectory:(t.type&A.FileType.Directory)!=0,isSymbolicLink:(t.type&A.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean(((u=t.permissions)!==null&&u!==void 0?u:0)&A.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:A.etag({mtime:t.mtime,size:t.size})};if(l.isDirectory&&a(l,r)){try{const S=await o.readdir(s),w=await b.Promises.settled(S.map(async([g,U])=>{try{const F=c.joinPath(s,g),j=i?await o.stat(F):{type:U};return await this.toFileStat(o,F,j,S.length,i,a)}catch(F){return this.logService.trace(F),null}}));l.children=p.coalesce(w)}catch(S){this.logService.trace(S),l.children=[]}return l}return l}async resolveAll(o){return b.Promises.settled(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch(t){return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(t){return t}return!0}async doValidateCreateFile(o,s){if(!(s==null?void 0:s.overwrite)&&await this.exists(o))throw new A.FileOperationError(v.localize(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=m.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const r=await this.writeFile(o,s);return this._onDidRunOperation.fire(new A.FileOperationEvent(o,0,r)),r}async writeFile(o,s,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,o,t)||await this.mkdirp(r,i.dirname(o));let u;if(A.hasReadWriteCapability(r)&&!(s instanceof m.VSBuffer))if(h.isReadableStream(s)){const c=await h.peekStream(s,3);c.ended?u=m.VSBuffer.concat(c.buffer):u=c}else u=h.peekReadable(s,c=>m.VSBuffer.concat(c),3);else u=s;!A.hasOpenReadWriteCloseCapability(r)||A.hasReadWriteCapability(r)&&u instanceof m.VSBuffer?await this.doWriteUnbuffered(r,o,t,u):await this.doWriteBuffered(r,o,t,u instanceof m.VSBuffer?m.bufferToReadable(u):u)}catch(a){throw new A.FileOperationError(v.localize(4,null,this.resourceForError(o),A.ensureFileSystemProviderError(a).toString()),A.toFileOperationResult(a),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,t){if(!!(t==null?void 0:t.unlock)&&!(o.capabilities&8192))throw new Error(v.localize(5,null,this.resourceForError(s)));let i;try{i=await o.stat(s)}catch(a){return}if((i.type&A.FileType.Directory)!=0)throw new A.FileOperationError(v.localize(6,null,this.resourceForError(s)),0,t);if(this.throwIfFileIsReadonly(s,i),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==A.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&t.mtime<i.mtime&&t.etag!==A.etag({mtime:t.mtime,size:i.size}))throw new A.FileOperationError(v.localize(7,null),3,t);return i}async readFile(o,s){const t=await this.withReadProvider(o);return(s==null?void 0:s.atomic)?this.doReadFileAtomic(t,o,s):this.doReadFile(t,o,s)}async doReadFileAtomic(o,s,t){return new Promise((r,i)=>{this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(o,s,t);r(a)}catch(a){i(a)}})})}async doReadFile(o,s,t){const r=await this.doReadFileStream(o,s,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},r),{value:await m.streamToBuffer(r.value)})}async readFileStream(o,s){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,s)}async doReadFileStream(o,s,t){const r=new f.CancellationTokenSource,i=this.validateReadFile(s,t).then(u=>u,u=>{throw r.cancel(),u});let a;try{t&&typeof t.etag=="string"&&t.etag!==A.ETAG_DISABLED&&await i,!(A.hasOpenReadWriteCloseCapability(o)||A.hasFileReadStreamCapability(o))||A.hasReadWriteCapability(o)&&(t==null?void 0:t.preferUnbuffered)?a=this.readFileUnbuffered(o,s,t):A.hasFileReadStreamCapability(o)?a=this.readFileStreamed(o,s,r.token,t):a=this.readFileBuffered(o,s,r.token,t);const u=await i;return Object.assign(Object.assign({},u),{value:a})}catch(u){a&&await h.consumeStream(a);const c=v.localize(8,null,this.resourceForError(s),A.ensureFileSystemProviderError(u).toString());throw u instanceof A.NotModifiedSinceFileOperationError?new A.NotModifiedSinceFileOperationError(c,u.stat,t):new A.FileOperationError(c,A.toFileOperationResult(u),t)}}readFileStreamed(o,s,t,r=Object.create(null)){const i=o.readFileStream(s,r,t);return h.transform(i,{data:a=>a instanceof m.VSBuffer?a:m.VSBuffer.wrap(a),error:a=>new A.FileOperationError(v.localize(9,null,this.resourceForError(s),A.ensureFileSystemProviderError(a).toString()),A.toFileOperationResult(a),r)},a=>m.VSBuffer.concat(a))}readFileBuffered(o,s,t,r=Object.create(null)){const i=m.newWriteableBufferStream();return P.readFileIntoStream(o,s,i,a=>a,Object.assign(Object.assign({},r),{bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new A.FileOperationError(v.localize(10,null,this.resourceForError(s),A.ensureFileSystemProviderError(a).toString()),A.toFileOperationResult(a),r)}),t),i}readFileUnbuffered(o,s,t){const r=h.newWriteableStream(i=>m.VSBuffer.concat(i));return(async()=>{try{let i=await o.readFile(s);t&&typeof t.position=="number"&&(i=i.slice(t.position)),t&&typeof t.length=="number"&&(i=i.slice(0,t.length)),this.validateReadFileLimits(s,i.byteLength,t),r.end(m.VSBuffer.wrap(i))}catch(i){r.error(i),r.end()}})(),r}async validateReadFile(o,s){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new A.FileOperationError(v.localize(11,null,this.resourceForError(o)),0,s);if(s&&typeof s.etag=="string"&&s.etag!==A.ETAG_DISABLED&&s.etag===t.etag)throw new A.NotModifiedSinceFileOperationError(v.localize(12,null),t,s);return this.validateReadFileLimits(o,t.size,s),t}validateReadFileLimits(o,s,t){if(t==null?void 0:t.limits){let r;if(typeof t.limits.memory=="number"&&s>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&s>t.limits.size&&(r=7),typeof r=="number")throw new A.FileOperationError(v.localize(13,null,this.resourceForError(o)),r)}}async canMove(o,s,t){return this.doCanMoveCopy(o,s,"move",t)}async canCopy(o,s,t){return this.doCanMoveCopy(o,s,"copy",t)}async doCanMoveCopy(o,s,t,r){if(o.toString()!==s.toString())try{const i=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(i,o,a,s,t,r)}catch(i){return i}return!0}async move(o,s,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),a=await this.doMoveCopy(r,o,i,s,"move",!!t),u=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new A.FileOperationEvent(o,a==="move"?2:3,u)),u}async copy(o,s,t){const r=await this.withReadProvider(o),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),a=await this.doMoveCopy(r,o,i,s,"copy",!!t),u=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new A.FileOperationEvent(o,a==="copy"?3:2,u)),u}async doMoveCopy(o,s,t,r,i,a){if(s.toString()===r.toString())return i;const{exists:u,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(o,s,t,r,i,a);if(u&&!c&&a&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),i==="copy"){if(o===t&&A.hasFileFolderCopyCapability(o))await o.copy(s,r,{overwrite:a});else{const l=await this.resolve(s);l.isDirectory?await this.doCopyFolder(o,l,t,r):await this.doCopyFile(o,s,t,r)}return i}else return o===t?(await o.rename(s,r,{overwrite:a}),i):(await this.doMoveCopy(o,s,t,r,"copy",a),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,t,r){if(A.hasOpenReadWriteCloseCapability(o)&&A.hasOpenReadWriteCloseCapability(t))return this.doPipeBuffered(o,s,t,r);if(A.hasOpenReadWriteCloseCapability(o)&&A.hasReadWriteCapability(t))return this.doPipeBufferedToUnbuffered(o,s,t,r);if(A.hasReadWriteCapability(o)&&A.hasOpenReadWriteCloseCapability(t))return this.doPipeUnbufferedToBuffered(o,s,t,r);if(A.hasReadWriteCapability(o)&&A.hasReadWriteCapability(t))return this.doPipeUnbuffered(o,s,t,r)}async doCopyFolder(o,s,t,r){await t.mkdir(r),Array.isArray(s.children)&&await b.Promises.settled(s.children.map(async i=>{const a=this.getExtUri(t).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(o,await this.resolve(i.resource),t,a):this.doCopyFile(o,i.resource,t,a)}))}async doValidateMoveCopy(o,s,t,r,i,a){let u=!1;if(o===t){const{providerExtUri:l,isPathCaseSensitive:S}=this.getExtUri(o);if(S||(u=l.isEqual(s,r)),u&&i==="copy")throw new Error(v.localize(14,null,this.resourceForError(s),this.resourceForError(r)));if(!u&&l.isEqualOrParent(r,s))throw new Error(v.localize(15,null,this.resourceForError(s),this.resourceForError(r)))}const c=await this.exists(r);if(c&&!u){if(!a)throw new A.FileOperationError(v.localize(16,null,this.resourceForError(s),this.resourceForError(r)),4);if(o===t){const{providerExtUri:l}=this.getExtUri(o);if(l.isEqualOrParent(s,r))throw new Error(v.localize(17,null,this.resourceForError(s),this.resourceForError(r)))}}return{exists:c,isSameResourceWithDifferentPathCase:u}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?R.extUri:R.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new A.FileOperationEvent(o,0,t)),t}async mkdirp(o,s){const t=[],{providerExtUri:r}=this.getExtUri(o);for(;!r.isEqual(s,r.dirname(s));)try{if(((await o.stat(s)).type&A.FileType.Directory)==0)throw new Error(v.localize(18,null,this.resourceForError(s)));break}catch(i){if(A.toFileSystemProviderErrorCode(i)!==A.FileSystemProviderErrorCode.FileNotFound)throw i;t.push(r.basename(s)),s=r.dirname(s)}for(let i=t.length-1;i>=0;i--){s=r.joinPath(s,t[i]);try{await o.mkdir(s)}catch(a){if(A.toFileSystemProviderErrorCode(a)!==A.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(t){return t}return!0}async doValidateDelete(o,s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!(s==null?void 0:s.useTrash)&&!(t.capabilities&4096))throw new Error(v.localize(19,null,this.resourceForError(o)));let i;try{i=await t.stat(o)}catch(u){}if(i)this.throwIfFileIsReadonly(o,i);else throw new A.FileOperationError(v.localize(20,null,this.resourceForError(o)),1);if(!!!(s==null?void 0:s.recursive)){const u=await this.resolve(o);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error(v.localize(21,null,this.resourceForError(o)))}return t}async del(o,s){const t=await this.doValidateDelete(o,s),r=!!(s==null?void 0:s.useTrash),i=!!(s==null?void 0:s.recursive);await t.delete(o,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new A.FileOperationEvent(o,1))}onDidChangeFile(o,s){this._onDidChangeFilesRaw.fire({changes:o});let t,r;{for(const i of o)this.watchedResources.has(i.resource)?(t||(t=[]),t.push(i)):(r||(r=[]),r.push(i));t&&this._onDidFilesChange.fire(new A.FileChangesEvent(t,!s))}if(r){const i=s?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(r)&&qe.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,s={recursive:!1,excludes:[]}){var t;const r=new k.DisposableStore;{let i=!1,a=()=>{i=!0};r.add(k.toDisposable(()=>a())),this.doWatch(o,s).then(u=>{i?k.dispose(u):a=()=>k.dispose(u)},u=>this.logService.error(u))}return s.recursive||(this.watchedResources.set(o,((t=this.watchedResources.get(o))!==null&&t!==void 0?t:0)+1),r.add(k.toDisposable(()=>{const i=this.watchedResources.get(o);typeof i=="number"&&(i<=1?this.watchedResources.delete(o):this.watchedResources.set(o,i-1))}))),r}async doWatch(o,s){const t=await this.withProvider(o),r=this.toWatchKey(t,o,s),i=this.activeWatchers.get(r)||{count:0,disposable:t.watch(o,s)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,i),i.count+=1,k.toDisposable(()=>{i.count--,i.count===0&&(k.dispose(i.disposable),this.activeWatchers.delete(r))})}toWatchKey(o,s,t){const{providerExtUri:r}=this.getExtUri(o);return[r.getComparisonKey(s),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(o=>k.dispose(o.disposable)),this.activeWatchers.clear()}async doWriteBuffered(o,s,t,r){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{var i;const a=await o.open(s,{create:!0,unlock:(i=t==null?void 0:t.unlock)!==null&&i!==void 0?i:!1});try{h.isReadableStream(r)||h.isReadableBufferedStream(r)?await this.doWriteStreamBufferedQueued(o,a,r):await this.doWriteReadableBufferedQueued(o,a,r)}catch(u){throw A.ensureFileSystemProviderError(u)}finally{await o.close(a)}})}async doWriteStreamBufferedQueued(o,s,t){let r=0,i;if(h.isReadableBufferedStream(t)){if(t.buffer.length>0){const a=m.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,s,a,a.byteLength,r,0),r+=a.byteLength}if(t.ended)return;i=t.stream}else i=t;return new Promise(async(a,u)=>{h.listenStream(i,{onData:async c=>{i.pause();try{await this.doWriteBuffer(o,s,c,c.byteLength,r,0)}catch(l){return u(l)}r+=c.byteLength,setTimeout(()=>i.resume())},onError:c=>u(c),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(o,s,t){let r=0,i;for(;(i=t.read())!==null;)await this.doWriteBuffer(o,s,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(o,s,t,r,i,a){let u=0;for(;u<r;)u+=await o.write(s,i+u,t.buffer,a+u,r-u)}async doWriteUnbuffered(o,s,t,r){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,s,t,r))}async doWriteUnbufferedQueued(o,s,t,r){var i;let a;r instanceof m.VSBuffer?a=r:h.isReadableStream(r)?a=await m.streamToBuffer(r):h.isReadableBufferedStream(r)?a=await m.bufferedStreamToBuffer(r):a=m.readableToBuffer(r),await o.writeFile(s,a.buffer,{create:!0,overwrite:!0,unlock:(i=t==null?void 0:t.unlock)!==null&&i!==void 0?i:!1})}async doPipeBuffered(o,s,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,s,t,r))}async doPipeBufferedQueued(o,s,t,r){let i,a;try{i=await o.open(s,{create:!1}),a=await t.open(r,{create:!0,unlock:!1});const u=m.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,l=0,S=0;do S=await o.read(i,c,u.buffer,l,u.byteLength-l),await this.doWriteBuffer(t,a,u,S,c,l),c+=S,l+=S,l===u.byteLength&&(l=0);while(S>0)}catch(u){throw A.ensureFileSystemProviderError(u)}finally{await b.Promises.settled([typeof i=="number"?o.close(i):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async doPipeUnbuffered(o,s,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,s,t,r))}async doPipeUnbufferedQueued(o,s,t,r){return t.writeFile(r,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,s,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,s,t,r))}async doPipeUnbufferedToBufferedQueued(o,s,t,r){const i=await t.open(r,{create:!0,unlock:!1});try{const a=await o.readFile(s);await this.doWriteBuffer(t,i,m.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw A.ensureFileSystemProviderError(a)}finally{await t.close(i)}}async doPipeBufferedToUnbuffered(o,s,t,r){const i=await m.streamToBuffer(this.readFileBuffered(o,s,f.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,i)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new A.FileOperationError(v.localize(22,null,this.resourceForError(s)),6);return o}throwIfFileIsReadonly(o,s){var t;if(((t=s.permissions)!==null&&t!==void 0?t:0)&A.FilePermission.Readonly)throw new A.FileOperationError(v.localize(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===C.Schemas.file?o.fsPath:o.toString(!0)}};I.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},I=de([K(0,n.ILogService)],I),e.FileService=I}),define(Z[161],ee([0,1,2,10,3,7,18,8,12,41,6,15,119,76,137,139,136,148,47,79,19,25]),function(G,e,v,L,k,A,T,R,y,p,n,m,h,b,f,C,P,E,I,d,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends v.Disposable{constructor(i,a){var u;super();this.logService=i,this.options=a,this.BUFFER_SIZE=((u=this.options)===null||u===void 0?void 0:u.bufferSize)||64*1024,this.onDidChangeCapabilities=k.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new k.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,A.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:a,symbolicLink:u}=await T.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(a,u),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(i){try{const a=await T.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),u=[];return await Promise.all(a.map(async c=>{try{let l;c.isSymbolicLink()?l=(await this.stat(y.joinPath(i,c.name))).type:l=this.toType(c),u.push([c.name,l])}catch(l){this.logService.trace(l)}})),u}catch(a){throw this.toFileSystemProviderError(a)}}toType(i,a){let u;return(a==null?void 0:a.dangling)?u=L.FileType.Unknown:i.isFile()?u=L.FileType.File:i.isDirectory()?u=L.FileType.Directory:u=L.FileType.Unknown,a&&(u|=L.FileType.SymbolicLink),u}async readFile(i){try{const a=this.toFilePath(i);return await T.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(i,a,u){const c=I.newWriteableStream(l=>s.VSBuffer.concat(l.map(S=>s.VSBuffer.wrap(S))).buffer);return d.readFileIntoStream(this,i,c,l=>l.buffer,Object.assign(Object.assign({},a),{bufferSize:this.BUFFER_SIZE}),u),c}async writeFile(i,a,u){let c;try{const l=this.toFilePath(i);if(!u.create||!u.overwrite){if(await T.Promises.exists(l)){if(!u.overwrite)throw L.createFileSystemProviderError(h.localize(0,null),L.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw L.createFileSystemProviderError(h.localize(1,null),L.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(i,{create:!0,unlock:u.unlock}),await this.write(c,0,a,0,a.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(i,l)}finally{typeof c=="number"&&await this.close(c)}}async open(i,a){try{const u=this.toFilePath(i);if(L.isFileOpenForWriteOptions(a)&&a.unlock)try{const{stat:S}=await T.SymlinkSupport.stat(u);S.mode&128||await T.Promises.chmod(u,S.mode|128)}catch(S){this.logService.trace(S)}let c;if(L.isFileOpenForWriteOptions(a)){if(A.isWindows)try{await T.Promises.truncate(u,0),c="r+"}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}c||(c="w")}else c="r";const l=await T.Promises.open(u,c);return this.mapHandleToPos.set(l,0),L.isFileOpenForWriteOptions(a)&&this.writeHandles.set(l,i),l}catch(u){throw L.isFileOpenForWriteOptions(a)?await this.toFileSystemProviderWriteError(i,u):this.toFileSystemProviderError(u)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await T.Promises.fdatasync(i)}catch(a){this.canFlush=!1,this.logService.error(a)}return await T.Promises.close(i)}catch(a){throw this.toFileSystemProviderError(a)}}async read(i,a,u,c,l){const S=this.normalizePos(i,a);let w=null;try{const g=await T.Promises.read(i,u,c,l,S);return typeof g=="number"?w=g:w=g.bytesRead,w}catch(g){throw this.toFileSystemProviderError(g)}finally{this.updatePos(i,S,w)}}normalizePos(i,a){return a===this.mapHandleToPos.get(i)?null:a}updatePos(i,a,u){const c=this.mapHandleToPos.get(i);typeof c=="number"&&(typeof a=="number"||(typeof u=="number"?this.mapHandleToPos.set(i,c+u):this.mapHandleToPos.delete(i)))}async write(i,a,u,c,l){return n.retry(()=>this.doWrite(i,a,u,c,l),100,3)}async doWrite(i,a,u,c,l){const S=this.normalizePos(i,a);let w=null;try{const g=await T.Promises.write(i,u,c,l,S);return typeof g=="number"?w=g:w=g.bytesWritten,w}catch(g){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),g)}finally{this.updatePos(i,S,w)}}async mkdir(i){try{await T.Promises.mkdir(this.toFilePath(i))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(i,a){try{const u=this.toFilePath(i);await this.doDelete(u,a)}catch(u){throw this.toFileSystemProviderError(u)}}async doDelete(i,a){a.recursive?await T.Promises.rm(i,T.RimRafMode.MOVE):await T.Promises.unlink(i)}async rename(i,a,u){const c=this.toFilePath(i),l=this.toFilePath(a);if(c!==l)try{await this.validateTargetDeleted(i,a,"move",u.overwrite),await T.Promises.move(c,l)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error(h.localize(2,null,R.basename(c),R.basename(R.dirname(l)),S.toString()))),this.toFileSystemProviderError(S)}}async copy(i,a,u){const c=this.toFilePath(i),l=this.toFilePath(a);if(c!==l)try{await this.validateTargetDeleted(i,a,"copy",u.overwrite),await T.Promises.copy(c,l,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error(h.localize(3,null,R.basename(c),R.basename(R.dirname(l)),S.toString()))),this.toFileSystemProviderError(S)}}async validateTargetDeleted(i,a,u,c){const l=this.toFilePath(i),S=this.toFilePath(a);let w=!1;if(!!(this.capabilities&1024)||(w=p.isEqual(l,S,!0)),w&&u==="copy")throw L.createFileSystemProviderError(h.localize(4,null),L.FileSystemProviderErrorCode.FileExists);if(!w&&await T.Promises.exists(S)){if(!c)throw L.createFileSystemProviderError(h.localize(5,null),L.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(i,a){return a.recursive?this.watchRecursive(i,a.excludes):this.watchNonRecursive(i)}watchRecursive(i,a){const u={path:this.toFilePath(i),excludes:a},c=o.insert(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),v.toDisposable(()=>{c(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var i,a,u;if(this.recursiveWatcher instanceof P.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(v.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let c,l;((a=(i=this.options)===null||i===void 0?void 0:i.watcher)===null||a===void 0?void 0:a.usePolling)?(c=f.FileWatcher,l=(u=this.options)===null||u===void 0?void 0:u.watcher):this.recursiveFoldersToWatch.length===1?A.isWindows?c=C.FileWatcher:c=f.FileWatcher:c=P.FileWatcher,this.recursiveWatcher=new c(this.recursiveFoldersToWatch,S=>this._onDidChangeFile.fire(b.toFileChanges(S)),S=>{S.type==="error"&&this._onDidWatchErrorOccur.fire(S.message),this.logService[S.type](S.message)},this.logService.getLevel()===m.LogLevel.Trace,l),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))}}watchNonRecursive(i){const a=new E.FileWatcher(this.toFilePath(i),c=>this._onDidChangeFile.fire(b.toFileChanges(c)),c=>{c.type==="error"&&this._onDidWatchErrorOccur.fire(c.message),this.logService[c.type](c.message)},this.logService.getLevel()===m.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)});return v.combinedDisposable(a,u)}toFilePath(i){return R.normalize(i.fsPath)}toFileSystemProviderError(i){if(i instanceof L.FileSystemProviderError)return i;let a;switch(i.code){case"ENOENT":a=L.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=L.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=L.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=L.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=L.FileSystemProviderErrorCode.NoPermissions;break;default:a=L.FileSystemProviderErrorCode.Unknown}return L.createFileSystemProviderError(i,a)}async toFileSystemProviderWriteError(i,a){let u=this.toFileSystemProviderError(a);if(i&&u.code===L.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await T.SymlinkSupport.stat(this.toFilePath(i));c.mode&128||(u=L.createFileSystemProviderError(a,L.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return u}dispose(){super.dispose(),v.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,v.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(Z[27],ee([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=v.createDecorator("productService")}),define(Z[162],ee([0,1,8,11,2,18,27,6,15]),function(G,e,v,L,k,A,T,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let p=class extends k.Disposable{constructor(m,h,b){super();this.productService=h,this.logService=b,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,m&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpCodeCaches(m)},30*1e3)).schedule()}async cleanUpCodeCaches(m){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const h=Date.now(),b=v.dirname(m),f=v.basename(m),C=await A.Promises.readdir(b);await Promise.all(C.map(async P=>{if(P===f)return;const E=v.join(b,P),I=await A.Promises.stat(E);if(I.isDirectory()&&h-I.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${P}.`),A.Promises.rm(E)}))}catch(h){L.onUnexpectedError(h)}}};p=de([K(1,T.IProductService),K(2,y.ILogService)],p),e.CodeCacheCleaner=p}),define(Z[163],ee([0,1,8,18,27,2,11,15,9,6]),function(G,e,v,L,k,A,T,R,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let n=class extends A.Disposable{constructor(h,b,f){super();this.environmentService=h,this.logService=b,this.productService=f,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new p.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const h=Object.create(null),b=JSON.parse(await L.Promises.readFile(v.join(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let I of Object.keys(b)){const d=b[I];h[`${d.hash}.${I}`]=!0}const f=v.join(this.environmentService.userDataPath,"clp");if(!await L.Promises.exists(f))return;const P=await L.Promises.readdir(f);for(const I of P){if(h[I]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${I}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${I}`),await L.Promises.rm(v.join(f,I))}const E=Date.now();for(const I of Object.keys(h)){const d=v.join(f,I),o=await L.Promises.readdir(d);for(const s of o){if(s==="tcf.json")continue;const t=v.join(d,s),r=await L.Promises.stat(t);r.isDirectory()&&E-r.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${v.join(I,s)}`),await L.Promises.rm(t))}}}catch(h){T.onUnexpectedError(h)}}};n=de([K(0,y.INativeEnvironmentService),K(1,R.ILogService),K(2,k.IProductService)],n),e.LanguagePackCachedDataCleaner=n}),define(Z[31],ee([0,1,16,88]),function(G,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(T,R){L.ok(v.isString(T)),L.ok(v.isObject(R)),L.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,R)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new k}),define(Z[80],ee([0,1,31,3]),function(G,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class A{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,p){this.schemasById[k(y)]=p,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new A;v.Registry.add(e.Extensions.JSONContribution,T)}),define(Z[37],ee([0,1,109,3,31,16,80]),function(G,e,v,L,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(P){P[P.APPLICATION=1]="APPLICATION",P[P.MACHINE=2]="MACHINE",P[P.WINDOW=3]="WINDOW",P[P.RESOURCE=4]="RESOURCE",P[P.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",P[P.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=k.Registry.as(T.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(E,I=!0){this.registerConfigurations([E],I)}registerConfigurations(E,I=!0){const d=[];E.forEach(o=>{d.push(...this.validateAndRegisterProperties(o,I,o.extensionInfo)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterConfigurations(E){const I=[],d=o=>{if(o.properties)for(const s in o.properties)I.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,o.properties[s]);o.allOf&&o.allOf.forEach(s=>d(s))};for(const o of E){d(o);const s=this.configurationContributors.indexOf(o);s!==-1&&this.configurationContributors.splice(s,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}registerDefaultConfigurations(E){const I=[],d=[];for(const o of E)for(const s in o)if(I.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]=Object.assign(Object.assign({},this.defaultValues[s]||{}),o[s]);const t={type:"object",default:this.defaultValues[s],description:v.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};d.push(m(s)),this.configurationProperties[s]=t,this.defaultLanguageConfigurationOverridesNode.properties[s]=t}else{this.defaultValues[s]=o[s];const t=this.configurationProperties[s];t&&(this.updatePropertyDefaultValue(s,t),this.updateSchema(s,t))}this.registerOverrideIdentifiers(d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}deregisterDefaultConfigurations(E){const I=[];for(const d of E)for(const o in d)if(I.push(o),delete this.defaultValues[o],e.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const s=this.configurationProperties[o];s&&(this.updatePropertyDefaultValue(o,s),this.updateSchema(o,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const I of E)this.overrideIdentifiers.add(I);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(E,I=!0,d,o=3){var s;o=A.isUndefinedOrNull(E.scope)?o:E.scope;let t=[],r=E.properties;if(r)for(let a in r){if(I&&f(a)){delete r[a];continue}const u=r[a];if(this.updatePropertyDefaultValue(a,u),e.OVERRIDE_PROPERTY_PATTERN.test(a)?u.scope=void 0:(u.scope=A.isUndefinedOrNull(u.scope)?o:u.scope,u.restricted=A.isUndefinedOrNull(u.restricted)?!!((s=d==null?void 0:d.restrictedConfigurations)===null||s===void 0?void 0:s.includes(a)):u.restricted),r[a].hasOwnProperty("included")&&!r[a].included){this.excludedConfigurationProperties[a]=r[a],delete r[a];continue}else this.configurationProperties[a]=r[a];!r[a].deprecationMessage&&r[a].markdownDeprecationMessage&&(r[a].deprecationMessage=r[a].markdownDeprecationMessage),t.push(a)}let i=E.allOf;if(i)for(let a of i)t.push(...this.validateAndRegisterProperties(a,I,d,o));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(E){const I=d=>{let o=d.properties;if(o)for(const t in o)this.updateSchema(t,o[t]);let s=d.allOf;s&&s.forEach(I)};I(E)}updateSchema(E,I){switch(e.allSettings.properties[E]=I,I.scope){case 1:e.applicationSettings.properties[E]=I;break;case 2:e.machineSettings.properties[E]=I;break;case 6:e.machineOverridableSettings.properties[E]=I;break;case 3:e.windowSettings.properties[E]=I;break;case 4:e.resourceSettings.properties[E]=I;break;case 5:e.resourceSettings.properties[E]=I,this.resourceLanguageSettingsSchema.properties[E]=I;break}}removeFromSchema(E,I){switch(delete e.allSettings.properties[E],I.scope){case 1:delete e.applicationSettings.properties[E];break;case 2:delete e.machineSettings.properties[E];break;case 6:delete e.machineOverridableSettings.properties[E];break;case 3:delete e.windowSettings.properties[E];break;case 4:case 5:delete e.resourceSettings.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const I=`[${E}]`,d={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(I,d),e.allSettings.properties[I]=d,e.applicationSettings.properties[I]=d,e.machineSettings.properties[I]=d,e.machineOverridableSettings.properties[I]=d,e.windowSettings.properties[I]=d,e.resourceSettings.properties[I]=d}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,I){let d=this.defaultValues[E];A.isUndefined(d)&&(d=I.default),A.isUndefined(d)&&(d=h(I.type)),I.default=d}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function m(P){return P.substring(1,P.length-1)}e.overrideIdentifierFromKey=m;function h(P){switch(Array.isArray(P)?P[0]:P){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const b=new p;k.Registry.add(e.Extensions.Configuration,b);function f(P){return P.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(P)?v.localize(5,null,P):b.getConfigurationProperties()[P]!==void 0?v.localize(6,null,P):null:v.localize(4,null)}e.validateProperty=f;function C(){const P=[],E=b.getConfigurationProperties();for(const I of Object.keys(E))P.push([I,E[I].scope]);return P.push(["launch",4]),P.push(["task",4]),P}e.getScopes=C}),define(Z[23],ee([0,1,26,16,5,31,4,37]),function(G,e,v,L,k,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=T.createDecorator("configurationService");function y(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof k.URI)}e.isConfigurationOverrides=y;var p;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(p=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function m(r,i){const a=i?r?i.keys.filter(U=>r.keys.indexOf(U)===-1):[...i.keys]:[],u=r?i?r.keys.filter(U=>i.keys.indexOf(U)===-1):[...r.keys]:[],c=[];if(i&&r){for(const U of r.keys)if(i.keys.indexOf(U)!==-1){const F=E(r.contents,U),j=E(i.contents,U);v.equals(F,j)||c.push(U)}}const l=[],S=U=>{const F={};for(const j of U)for(const $ of j.identifiers)F[s($)]=j;return F},w=i?S(i.overrides):{},g=r?S(r.overrides):{};if(Object.keys(w).length)for(const U of a){const F=w[U];F&&l.push([R.overrideIdentifierFromKey(U),F.keys])}if(Object.keys(g).length)for(const U of u){const F=g[U];F&&l.push([R.overrideIdentifierFromKey(U),F.keys])}if(Object.keys(w).length&&Object.keys(g).length)for(const U of c){const F=g[U],j=w[U];if(F&&j){const $=m({contents:F.contents,keys:F.keys,overrides:[]},{contents:j.contents,keys:j.keys,overrides:[]});l.push([R.overrideIdentifierFromKey(U),[...$.added,...$.removed,...$.updated]])}}return{added:a,removed:u,updated:c,overrides:l}}e.compare=m;function h(r,i){const a=[];for(const u of Object.keys(r))if(R.OVERRIDE_PROPERTY_PATTERN.test(u)){const c={};for(const l in r[u])c[l]=r[u][l];a.push({identifiers:[R.overrideIdentifierFromKey(u).trim()],keys:Object.keys(c),contents:b(c,i)})}return a}e.toOverrides=h;function b(r,i){const a=Object.create(null);for(let u in r)f(a,u,r[u],i);return a}e.toValuesTree=b;function f(r,i,a,u){const c=i.split("."),l=c.pop();let S=r;for(let w=0;w<c.length;w++){let g=c[w],U=S[g];switch(typeof U){case"undefined":U=S[g]=Object.create(null);break;case"object":break;default:u(`Ignoring ${i} as ${c.slice(0,w+1).join(".")} is ${JSON.stringify(U)}`);return}S=U}if(typeof S=="object"&&S!==null)try{S[l]=a}catch(w){u(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(S)}`)}else u(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(S)}`)}e.addToValueTree=f;function C(r,i){const a=i.split(".");P(r,a)}e.removeFromValueTree=C;function P(r,i){const a=i.shift();if(i.length===0){delete r[a];return}if(Object.keys(r).indexOf(a)!==-1){const u=r[a];typeof u=="object"&&!Array.isArray(u)&&(P(u,i),Object.keys(u).length===0&&delete r[a])}}function E(r,i,a){function u(S,w){let g=S;for(const U of w){if(typeof g!="object"||g===null)return;g=g[U]}return g}const c=i.split("."),l=u(r,c);return typeof l=="undefined"?a:l}e.getConfigurationValue=E;function I(r,i,a){Object.keys(i).forEach(u=>{u!=="__proto__"&&(u in r?L.isObject(r[u])&&L.isObject(i[u])?I(r[u],i[u],a):a&&(r[u]=i[u]):r[u]=i[u])})}e.merge=I;function d(){const r=A.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=d;function o(){const r=Object.create(null),i=A.Registry.as(R.Extensions.Configuration).getConfigurationProperties();for(let a in i){let u=i[a].default;f(r,a,u,c=>console.error(`Conflict in default settings: ${c}`))}return r}e.getDefaultValues=o;function s(r){return`[${r}]`}e.keyFromOverrideIdentifier=s;function t(r,i,a){const u=r.inspect(i),c=r.inspect(a);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:u.defaultValue}e.getMigratedSettingValue=t}),define(Z[164],ee([0,1,32,38,19,16,26,5,37,23,31,2,3]),function(G,e,v,L,k,A,T,R,y,p,n,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(t={},r=[],i=[]){this._contents=t,this._keys=r,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?p.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,r){const i=this.getContentsForOverrideIdentifer(r);return i?t?p.getConfigurationValue(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const a of k.distinct([...Object.keys(this.contents),...Object.keys(r)])){let u=this.contents[a],c=r[a];c&&(typeof u=="object"&&typeof c=="object"?(u=T.deepClone(u),this.mergeContents(u,c)):u=c),i[a]=u}return new b(i,this.keys,this.overrides)}merge(...t){const r=T.deepClone(this.contents),i=T.deepClone(this.overrides),a=[...this.keys];for(const u of t){this.mergeContents(r,u.contents);for(const c of u.overrides){const[l]=i.filter(S=>k.equals(S.identifiers,c.identifiers));l?this.mergeContents(l.contents,c.contents):i.push(T.deepClone(c))}for(const c of u.keys)a.indexOf(c)===-1&&a.push(c)}return new b(r,a,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const i of Object.keys(r)){if(i in t&&A.isObject(t[i])&&A.isObject(r[i])){this.mergeContents(t[i],r[i]);continue}t[i]=T.deepClone(r[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?T.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),p.addToValueTree(this.contents,t,r,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&p.removeFromValueTree(this.contents,t)}addKey(t){let r=this.keys.length;for(let i=0;i<r;i++)t.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=b;class f extends b{constructor(){const t=p.getDefaultValues(),r=p.getConfigurationKeys(),i=[];for(const a of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(a)&&i.push({identifiers:[y.overrideIdentifierFromKey(a).trim()],keys:Object.keys(t[a]),contents:p.toValuesTree(t[a],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,r,i)}}e.DefaultConfigurationModel=f;class C{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!A.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:i,keys:a,overrides:u,restricted:c}=this.doParseRaw(t,r);this._configurationModel=new b(i,a,u),this._restrictedConfigurations=c||[]}doParseContent(t){let r={},i=null,a=[],u=[],c=[];function l(w){Array.isArray(a)?a.push(w):i&&(a[i]=w)}let S={onObjectBegin:()=>{let w={};l(w),u.push(a),a=w,i=null},onObjectProperty:w=>{i=w},onObjectEnd:()=>{a=u.pop()},onArrayBegin:()=>{let w=[];l(w),u.push(a),a=w,i=null},onArrayEnd:()=>{a=u.pop()},onLiteralValue:l,onError:(w,g,U)=>{c.push({error:w,offset:g,length:U})}};if(t)try{v.visit(t,S),r=a[0]||{}}catch(w){console.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return r}doParseRaw(t,r){const i=n.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),a=this.filter(t,i,!0,r);t=a.raw;const u=p.toValuesTree(t,S=>console.error(`Conflict in settings file ${this._name}: ${S}`)),c=Object.keys(t),l=p.toOverrides(t,S=>console.error(`Conflict in settings file ${this._name}: ${S}`));return{contents:u,keys:c,overrides:l,restricted:a.restricted}}filter(t,r,i,a){if(!(a==null?void 0:a.scopes)&&!(a==null?void 0:a.skipRestricted))return{raw:t,restricted:[]};const u={},c=[];for(let l in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(l)&&i){const S=this.filter(t[l],r,!1,a);u[l]=S.raw,c.push(...S.restricted)}else{const S=r[l],w=S?typeof S.scope!="undefined"?S.scope:3:void 0;(S==null?void 0:S.restricted)&&c.push(l),(w===void 0||a.scopes===void 0||a.scopes.includes(w))&&(a.skipRestricted&&(S==null?void 0:S.restricted)||(u[l]=t[l]))}return{raw:u,restricted:c}}}e.ConfigurationModelParser=C;class P extends m.Disposable{constructor(t,r,i,a){super();this.userSettingsResource=t,this.scopes=r,this.fileService=a,this._onDidChange=this._register(new h.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new C(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(h.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=P;class E{constructor(t,r,i=new b,a=new b,u=new L.ResourceMap,c=new b,l=new L.ResourceMap,S=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=a,this._folderConfigurations=u,this._memoryConfiguration=c,this._memoryConfigurationByResource=l,this._freeze=S,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(t)}updateValue(t,r,i={}){let a;i.resource?(a=this._memoryConfigurationByResource.get(i.resource),a||(a=new b,this._memoryConfigurationByResource.set(i.resource,a))):a=this._memoryConfiguration,r===void 0?a.removeValue(t):a.setValue(t,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,i){const a=this.getConsolidateConfigurationModel(r,i),u=this.getFolderConfigurationModelForResource(r.resource,i),c=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,l=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),S=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),w=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),g=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),U=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=u?r.overrideIdentifier?u.freeze().override(r.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,j=r.overrideIdentifier?c.override(r.overrideIdentifier).getValue(t):c.getValue(t),$=a.getValue(t),V=k.distinct(k.flatten(a.overrides.map(q=>q.identifiers))).filter(q=>a.getOverrideValue(t,q)!==void 0);return{defaultValue:l,userValue:S,userLocalValue:w,userRemoteValue:g,workspaceValue:U,workspaceFolderValue:F,memoryValue:j,value:$,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:S!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:w!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:g!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:u==null?void 0:u.freeze().getValue(t),override:r.overrideIdentifier?u==null?void 0:u.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:j!==void 0?{value:c.getValue(t),override:r.overrideIdentifier?c.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const i=r.filter(a=>y.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const u=y.overrideIdentifierFromKey(a),c=this._defaultConfiguration.getKeysForOverrideIdentifier(u),l=t.getKeysForOverrideIdentifier(u),S=[...l.filter(w=>c.indexOf(w)===-1),...c.filter(w=>l.indexOf(w)===-1),...c.filter(w=>!T.equals(this._defaultConfiguration.override(u).getValue(w),t.override(u).getValue(w)))];return[u,S]});return this.updateDefaultConfiguration(t),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:i,removed:a,overrides:u}=p.compare(this.localUserConfiguration,t),c=[...r,...i,...a];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:i,removed:a,overrides:u}=p.compare(this.remoteUserConfiguration,t);let c=[...r,...i,...a];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:i,removed:a,overrides:u}=p.compare(this.workspaceConfiguration,t);let c=[...r,...i,...a];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:u}}compareAndUpdateFolderConfiguration(t,r){const i=this.folderConfigurations.get(t),{added:a,updated:u,removed:c,overrides:l}=p.compare(i,r);let S=[...a,...u,...c];return(S.length||!i)&&this.updateFolderConfiguration(t,r),{keys:S,overrides:l}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:a,removed:u,overrides:c}=p.compare(r,void 0);return{keys:[...i,...a,...u],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let i=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const a=r.getFolder(t);a&&(i=this.getFolderConsolidatedConfiguration(a.uri)||i);const u=this._memoryConfigurationByResource.get(t);u&&(i=i.merge(u))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(r=i.merge(a),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=i}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const i=r.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:i,overrides:a,keys:u}=this._folderConfigurations.get(r);return t.push([r,{contents:i,overrides:a,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((c,l)=>(c.set(R.URI.revive(l[0]),this.parseConfigurationModel(l[1])),c),new L.ResourceMap);return new E(r,i,new b,a,u,new b,new L.ResourceMap,!1)}static parseConfigurationModel(t){return new b(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=E;function I(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,r=new Map;for(const a of s)a.keys.forEach(u=>t.add(u)),a.overrides.forEach(([u,c])=>{const l=L.getOrSet(r,u,new Set);c.forEach(S=>l.add(S))});const i=[];return r.forEach((a,u)=>i.push([u,[...a.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=I;class d{constructor(t,r,i,a){this.change=t,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=a,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(l=>u.add(l)),t.overrides.forEach(([,l])=>l.forEach(S=>u.add(S))),this.affectedKeys=[...u.values()];const c=new b;this.affectedKeys.forEach(l=>c.setValue(l,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var i;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const a=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(i=this.previous)===null||i===void 0?void 0:i.workspace):void 0,u=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!T.equals(a,u)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let i=p.toValuesTree({[r]:!0},()=>{}),a;for(;typeof i=="object"&&(a=Object.keys(i)[0]);){if(t=t[a],!t)return!1;i=i[a]}return!0}}e.ConfigurationChangeEvent=d;class o extends d{constructor(t,r,i,a){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=i,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=o}),define(Z[165],ee([0,1,31,37,2,23,164,3,6,12]),function(G,e,v,L,k,A,T,R,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends k.Disposable{constructor(h,b){super();this.settingsResource=h,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new T.UserSettings(this.settingsResource,void 0,p.extUriBiasedIgnorePathCase,b)),this.configuration=new T.Configuration(new T.DefaultConfigurationModel,new T.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new y.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(v.Registry.as(L.Extensions.Configuration).onDidUpdateConfiguration(f=>this.onDidDefaultConfigurationChange(f))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const h=await this.userConfiguration.loadConfiguration();this.configuration=new T.Configuration(new T.DefaultConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(h,b){const f=typeof h=="string"?h:void 0,C=A.isConfigurationOverrides(h)?h:A.isConfigurationOverrides(b)?b:{};return this.configuration.getValue(f,C,void 0)}updateValue(h,b,f,C){return Promise.reject(new Error("not supported"))}inspect(h){return this.configuration.inspect(h,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const h=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(h)}onDidChangeUserConfiguration(h){const b=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(h);this.trigger(f,b,1)}onDidDefaultConfigurationChange(h){const b=this.configuration.toData(),f=this.configuration.compareAndUpdateDefaultConfiguration(new T.DefaultConfigurationModel,h);this.trigger(f,b,6)}trigger(h,b,f){const C=new T.ConfigurationChangeEvent(h,{data:b},this.configuration);C.source=f,C.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(C)}getTargetConfiguration(h){switch(h){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(Z[166],ee([0,1,23,15,103]),function(G,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let A=class{constructor(R,y){this.configurationService=R,this.logService=y}request(R,y){return this.logService.trace("RequestService#request",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),k.request(R,y)}async resolveProxy(R){}};A=de([K(0,v.IConfigurationService),K(1,L.ILogService)],A),e.RequestService=A}),define(Z[39],ee([0,1,120,4,37,31,25]),function(G,e,v,L,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=L.createDecorator("requestService");function R(f){return f.res.statusCode&&f.res.statusCode>=200&&f.res.statusCode<300||f.res.statusCode===1223}e.isSuccess=R;function y(f){return f.res.statusCode===204}async function p(f){if(!R(f))throw new Error("Server returned "+f.res.statusCode);return y(f)?null:(await T.streamToBuffer(f.stream)).toString()}e.asText=p;async function n(f){if(!R(f))throw new Error("Server returned "+f.res.statusCode);if(y(f))return null;const P=(await T.streamToBuffer(f.stream)).toString();try{return JSON.parse(P)}catch(E){throw E.message+=`:
`+P,E}}e.asJson=n;function m(f){b(f)}e.updateProxyConfigurationsScope=m;let h;function b(f){const C=A.Registry.as(k.Extensions.Configuration);h&&C.deregisterConfigurations([h]),h={id:"http",order:15,title:v.localize(0,null),type:"object",scope:f,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:v.localize(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:v.localize(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:v.localize(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[v.localize(4,null),v.localize(5,null),v.localize(6,null),v.localize(7,null)],default:"override",description:v.localize(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:v.localize(9,null),restricted:!0}}},C.registerConfiguration(h)}b(2)}),define(Z[167],ee([0,1,39,29,10,17]),function(G,e,v,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(y,p){this.requestService=y,this.fileService=p}async download(y,p,n=L.CancellationToken.None){if(y.scheme===A.Schemas.file||y.scheme===A.Schemas.vscodeRemote){await this.fileService.copy(y,p);return}const m={type:"GET",url:y.toString()},h=await this.requestService.request(m,n);if(h.res.statusCode===200)await this.fileService.writeFile(p,h.stream);else{const b=await v.asText(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${b}`)}}};T=de([K(0,v.IRequestService),K(1,k.IFileService)],T),e.DownloadService=T}),define(Z[168],ee([0,1,27,10,19,63,39,29,15,12,132,2]),function(G,e,v,L,k,A,T,R,y,p,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let h=class extends m.Disposable{constructor(f,C,P,E){super();this.fileService=f,this.productService=C,this.requestService=P,this.logService=E,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&A.forEach(this.productService.configBasedExtensionTips,({value:I})=>this.allConfigBasedTips.set(I.configPath,I))}getConfigBasedTips(f){return this.getValidConfigBasedTips(f)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(f){const C=[];for(const[P,E]of this.allConfigBasedTips)try{const I=await this.fileService.readFile(p.joinPath(f,P)),d=new Map;A.forEach(E.recommendations,({key:s,value:t})=>{if(k.isNonEmptyArray(t.remotes))for(const r of t.remotes)d.set(r,{extensionId:s,extensionName:t.name,configName:E.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else C.push({extensionId:s,extensionName:t.name,configName:E.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const o=n.getDomainsOfRemotes(I.value.toString(),[...d.keys()]);for(const s of o){const t=d.get(s);t&&C.push(t)}}catch(I){}return C}async fetchWorkspacesTips(){var f,C;if(!((f=this.productService.extensionsGallery)===null||f===void 0?void 0:f.recommendationsUrl))return[];try{const P=await this.requestService.request({type:"GET",url:(C=this.productService.extensionsGallery)===null||C===void 0?void 0:C.recommendationsUrl},R.CancellationToken.None);if(P.res.statusCode!==200)return[];const E=await T.asJson(P);return E?E.workspaceRecommendations||[]:[]}catch(P){return this.logService.error(P),[]}}};h=de([K(0,L.IFileService),K(1,v.IProductService),K(2,T.IRequestService),K(3,y.ILogService)],h),e.ExtensionTipsService=h}),define(Z[44],ee([0,1,30,25]),function(G,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(A,T,R){let y=R&&R.get("storage.serviceMachineId",0)||null;if(y)return y;try{const n=(await T.readFile(A.serviceMachineIdResource)).value.toString();y=v.isUUID(n)?n:null}catch(p){y=null}if(!y){y=v.generateUuid();try{await T.writeFile(A.serviceMachineIdResource,L.VSBuffer.fromString(y))}catch(p){}}return R&&R.store("storage.serviceMachineId",y,0,1),y}e.getServiceMachineId=k}),define(Z[21],ee([0,1,4,3,2,16,70,6]),function(G,e,v,L,k,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const y="__$__targetStorageMarker";e.IStorageService=v.createDecorator("storageService");var p;(function(C){C[C.NONE=0]="NONE",C[C.SHUTDOWN=1]="SHUTDOWN"})(p=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(C){C[C.GLOBAL=0]="GLOBAL",C[C.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var m;(function(C){C[C.USER=0]="USER",C[C.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));class h extends k.Disposable{constructor(P={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super();this.options=P,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=R.runWhenIdle(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){k.dispose([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(P,E){E===y?(P===0?this._globalKeyTargets=void 0:P===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:P})):this._onDidChangeValue.fire({scope:P,key:E,target:this.getKeyTargets(P)[E]})}emitWillSaveState(P){this._onWillSaveState.fire({reason:P})}get(P,E,I){var d;return(d=this.getStorage(E))===null||d===void 0?void 0:d.get(P,I)}getBoolean(P,E,I){var d;return(d=this.getStorage(E))===null||d===void 0?void 0:d.getBoolean(P,I)}getNumber(P,E,I){var d;return(d=this.getStorage(E))===null||d===void 0?void 0:d.getNumber(P,I)}store(P,E,I,d){if(A.isUndefinedOrNull(E)){this.remove(P,I);return}this.withPausedEmitters(()=>{var o;this.updateKeyTarget(P,I,d),(o=this.getStorage(I))===null||o===void 0||o.set(P,E)})}remove(P,E){this.withPausedEmitters(()=>{var I;this.updateKeyTarget(P,E,void 0),(I=this.getStorage(E))===null||I===void 0||I.delete(P)})}withPausedEmitters(P){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{P()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(P,E){const I=[],d=this.getKeyTargets(P);for(const o of Object.keys(d))d[o]===E&&I.push(o);return I}updateKeyTarget(P,E,I){var d,o;const s=this.getKeyTargets(E);typeof I=="number"?s[P]!==I&&(s[P]=I,(d=this.getStorage(E))===null||d===void 0||d.set(y,JSON.stringify(s))):typeof s[P]=="number"&&(delete s[P],(o=this.getStorage(E))===null||o===void 0||o.set(y,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(P){return P===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(P){const E=this.get(y,P);if(E)try{return JSON.parse(E)}catch(I){}return Object.create(null)}isNew(P){return this.getBoolean(e.IS_NEW_KEY,P)===!0}async flush(){var P,E,I,d;this._onWillSaveState.fire({reason:p.NONE}),await R.Promises.settled([(E=(P=this.getStorage(0))===null||P===void 0?void 0:P.whenFlushed())!==null&&E!==void 0?E:Promise.resolve(),(d=(I=this.getStorage(1))===null||I===void 0?void 0:I.whenFlushed())!==null&&d!==void 0?d:Promise.resolve()])}async logStorage(){var P,E,I,d,o,s;const t=(E=(P=this.getStorage(0))===null||P===void 0?void 0:P.items)!==null&&E!==void 0?E:new Map,r=(d=(I=this.getStorage(1))===null||I===void 0?void 0:I.items)!==null&&d!==void 0?d:new Map;return f(t,r,(o=this.getLogDetails(0))!==null&&o!==void 0?o:"",(s=this.getLogDetails(1))!==null&&s!==void 0?s:"")}}e.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;class b extends h{constructor(){super();this.globalStorage=this._register(new T.Storage(new T.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new T.Storage(new T.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(P=>this.emitDidChangeValue(1,P))),this._register(this.globalStorage.onDidChangeStorage(P=>this.emitDidChangeValue(0,P)))}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(P){}}e.InMemoryStorageService=b;async function f(C,P,E,I){const d=u=>{try{return JSON.parse(u)}catch(c){return u}},o=new Map,s=new Map;C.forEach((u,c)=>{o.set(c,u),s.set(c,d(u))});const t=new Map,r=new Map;P.forEach((u,c)=>{t.set(c,u),r.set(c,d(u))}),console.group(`Storage: Global (path: ${E})`);let i=[];o.forEach((u,c)=>{i.push({key:c,value:u})}),console.table(i),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${I})`);let a=[];t.forEach((u,c)=>{a.push({key:c,value:u})}),console.table(a),console.groupEnd(),console.log(r)}e.logStorage=f}),define(Z[169],ee([0,1,3,2,28,33,21,16]),function(G,e,v,L,k,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let y=class extends L.Disposable{constructor(m){super();this._onDidChangeEnablement=new v.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new p(m)),this._register(this.storageManger.onDidChange(h=>this._onDidChangeEnablement.fire({extensions:h,source:"storage"})))}async enableExtension(m,h){return this._removeFromDisabledExtensions(m)?(this._onDidChangeEnablement.fire({extensions:[m],source:h}),!0):!1}async disableExtension(m,h){return this._addToDisabledExtensions(m)?(this._onDidChangeEnablement.fire({extensions:[m],source:h}),!0):!1}getDisabledExtensions(){return this._getExtensions(k.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(m){let h=this.getDisabledExtensions();return h.every(b=>!A.areSameExtensions(b,m))?(h.push(m),this._setDisabledExtensions(h),!0):!1}_removeFromDisabledExtensions(m){let h=this.getDisabledExtensions();for(let b=0;b<h.length;b++){const f=h[b];if(A.areSameExtensions(f,m))return h.splice(b,1),this._setDisabledExtensions(h),!0}return!1}_setDisabledExtensions(m){this._setExtensions(k.DISABLED_EXTENSIONS_STORAGE_PATH,m)}_getExtensions(m){return this.storageManger.get(m,0)}_setExtensions(m,h){this.storageManger.set(m,h,0)}};y=de([K(0,T.IStorageService)],y),e.GlobalExtensionEnablementService=y;class p extends L.Disposable{constructor(m){super();this.storageService=m,this.storage=Object.create(null),this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this._register(m.onDidChangeValue(h=>this.onDidStorageChange(h)))}get(m,h){let b;return h===0?(R.isUndefinedOrNull(this.storage[m])&&(this.storage[m]=this._get(m,h)),b=this.storage[m]):b=this._get(m,h),JSON.parse(b)}set(m,h,b){let f=JSON.stringify(h.map(({id:P,uuid:E})=>({id:P,uuid:E})));this._get(m,b)!==f&&(b===0&&(h.length?this.storage[m]=f:delete this.storage[m]),this._set(m,h.length?f:void 0,b))}onDidStorageChange(m){if(m.scope===0&&!R.isUndefinedOrNull(this.storage[m.key])&&this._get(m.key,m.scope)!==this.storage[m.key]){const b=this.get(m.key,m.scope);delete this.storage[m.key];const f=this.get(m.key,m.scope),C=b.filter(E=>!f.some(I=>A.areSameExtensions(E,I))),P=f.filter(E=>!b.some(I=>A.areSameExtensions(I,E)));(C.length||P.length)&&this._onDidChange.fire([...C,...P])}}_get(m,h){return this.storageService.get(m,h,"[]")}_set(m,h,b){h?this.storageService.store(m,h,b,1):this.storageService.remove(m,b)}}e.StorageManager=p}),define(Z[170],ee([0,1,3,2]),function(G,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class k extends L.Disposable{constructor(p,n){super();this.channel=p,this.workspace=n}async getItems(){const p={workspace:this.workspace},n=await this.channel.call("getItems",p);return new Map(n)}updateItems(p){const n={workspace:this.workspace};return p.insert&&(n.insert=Array.from(p.insert.entries())),p.delete&&(n.delete=Array.from(p.delete.values())),this.channel.call("updateItems",n)}}class A extends k{constructor(p){super(p,void 0);this._onDidChangeItemsExternal=this._register(new v.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(p=>this.onDidChangeGlobalStorage(p)))}onDidChangeGlobalStorage(p){(Array.isArray(p.changed)||Array.isArray(p.deleted))&&this._onDidChangeItemsExternal.fire({changed:p.changed?new Map(p.changed):void 0,deleted:p.deleted?new Set(p.deleted):void 0})}async close(){this.dispose()}}class T extends k{constructor(p,n){super(p,n);this.onDidChangeItemsExternal=v.Event.None}async close(){const p={workspace:this.workspace};return this.channel.call("close",p)}}class R extends L.Disposable{constructor(p,n){super();this.channel=p,this.workspace=n,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new A(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new T(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=R}),define(Z[171],ee([0,1,2,21,70,6,160,170,12]),function(G,e,v,L,k,A,T,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class p extends L.AbstractStorageService{constructor(m,h,b){super();this.mainProcessService=h,this.environmentService=b,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new v.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(m)}createGlobalStorage(){const m=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),h=new k.Storage(m.globalStorage);return this._register(h.onDidChangeStorage(b=>this.emitDidChangeValue(0,b))),h}createWorkspaceStorage(m){const h=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),m);if(h.workspaceStorage){const b=new k.Storage(h.workspaceStorage);return this.workspaceStorageDisposable.value=b.onDidChangeStorage(f=>this.emitDidChangeValue(1,f)),this.workspaceStorageId=m==null?void 0:m.id,b}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){var m,h;T.mark("code/willInitStorage");try{await A.Promises.settled([this.globalStorage.init(),(h=(m=this.workspaceStorage)===null||m===void 0?void 0:m.init())!==null&&h!==void 0?h:Promise.resolve()])}finally{T.mark("code/didInitStorage")}}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${y.joinPath(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){var m,h;this.stopFlushWhenIdle(),this.emitWillSaveState(L.WillSaveStateReason.SHUTDOWN),await A.Promises.settled([this.globalStorage.close(),(h=(m=this.workspaceStorage)===null||m===void 0?void 0:m.close())!==null&&h!==void 0?h:Promise.resolve()])}async migrate(m){var h;const b=this.workspaceStorage,f=(h=b==null?void 0:b.items)!==null&&h!==void 0?h:new Map;b&&(await b.close(),b.dispose()),this.workspaceStorage=this.createWorkspaceStorage(m),await this.workspaceStorage.init();for(const[C,P]of f)this.workspaceStorage.set(C,P)}}e.NativeStorageService=p}),define(Z[172],ee([0,1,7,34,30,5]),function(G,e,v,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(p){if(v.platform===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}async function R(p,n,m,h,b,f,C,P,E,I){const d=Object.create(null);d["common.machineId"]=C,d.sessionID=k.generateUuid()+Date.now(),d.commitHash=b,d.version=f,d["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=v.PlatformToString(v.platform),d["common.nodePlatform"]=L.platform,d["common.nodeArch"]=h,d["common.product"]=I||"desktop";const o=y(P||[]);o&&(d["common.msftInternal"]=o);let s=0;const t=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),v.isLinuxSnap&&(d["common.snap"]="true");const r=T(m);r&&(d["common.platformDetail"]=r);try{const i=await p.readFile(A.URI.file(E));d["common.source"]=i.value.toString().slice(0,30)}catch(i){}return d}e.resolveCommonProperties=R;function y(p){const n=L.env.USERDNSDOMAIN;if(!n)return!1;const m=n.toLowerCase();return p.some(h=>m===h)}e.verifyMicrosoftInternalDomain=y}),define(Z[24],ee([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=v.createDecorator("telemetryService"),e.ICustomEndpointTelemetryService=v.createDecorator("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Z[173],ee([0,1,35,95,72,8,32,98,27,7,5,24,53,17,10,18]),function(G,e,v,L,k,A,T,R,y,p,n,m,h,b,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function P(s,t){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],i=new Map,a=new Map,u=2e4;function c(w,g,U,F){const j=g.substring(w.length+1);return new Promise(async $=>{var V,q,z;let H;try{H=await C.Promises.readdir(g,{withFileTypes:!0})}catch(O){$();return}if(F.count>=u){F.count+=H.length,F.maxReached=!0,$();return}let Q=H.length;if(Q===0){$();return}let N=H;F.count+H.length>u&&(F.maxReached=!0,Q=u-F.count,N=H.slice(0,Q)),F.count+=H.length;for(const O of N)if(O.isDirectory()){if(U.includes(O.name)||await c(w,A.join(g,O.name),U,F),--Q==0){$();return}}else{const D=O.name.lastIndexOf(".");if(D>=0){const M=O.name.substring(D+1);M&&i.set(M,((V=i.get(M))!==null&&V!==void 0?V:0)+1)}for(const M of r)((q=M.relativePathPattern)===null||q===void 0?void 0:q.test(j))!==!1&&M.filePattern.test(O.name)&&a.set(M.tag,((z=a.get(M.tag))!==null&&z!==void 0?z:0)+1);if(--Q==0){$();return}}})}const l={count:0,maxReached:!1};await c(s,s,t,l);const S=await d(s);return{configFiles:E(a),fileTypes:E(i),fileCount:l.count,maxFilesReached:l.maxReached,launchConfigFiles:S}}e.collectWorkspaceStats=P;function E(s){return[...h.Iterable.map(s.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function I(){const s={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(L.virtualMachineHint.value()*100)}%`},t=v.cpus();return t&&t.length>0&&(s.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),s}e.getMachineInfo=I;async function d(s){try{const t=new Map,r=A.join(s,".vscode","launch.json"),i=await C.Promises.readFile(r),a=[],u=T.parse(i.toString(),a);if(a.length)return console.log(`Unable to parse ${r}`),[];if(T.getNodeType(u)==="object"&&u.configurations)for(const c of u.configurations){const l=c.type;l&&(t.has(l)?t.set(l,t.get(l)+1):t.set(l,1))}return E(t)}catch(t){return[]}}e.collectLaunchConfigs=d;let o=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const i=v.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(v.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),p.isWindows||r.push(`Load (avg):       ${v.loadavg().map(a=>Math.round(a)).join(", ")}`),r.push(`VM:               ${Math.round(L.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([R.listProcesses(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async i=>{let[a,u]=i,c=this.formatProcessList(t,a);return r.forEach(l=>{if(k.isRemoteDiagnosticError(l))c+=`
${l.errorMessage}`,u+=`
${l.errorMessage}`;else if(c+=`

Remote: ${l.hostName}`,l.processes&&(c+=`
${this.formatProcessList(t,l.processes)}`),l.workspaceMetadata){u+=`
|  Remote: ${l.hostName}`;for(const S of Object.keys(l.workspaceMetadata)){const w=l.workspaceMetadata[S];let g=`${w.fileCount} files`;w.maxFilesReached&&(g=`more than ${g}`),u+=`|    Folder (${S}): ${g}`,u+=this.formatWorkspaceStats(w)}}}),{processInfo:c,workspaceInfo:u}})}async getSystemInfo(t,r){const{memory:i,vmHint:a,os:u,cpus:c}=I(),l={os:u,memory:i,cpus:c,vmHint:a,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return p.isWindows||(l.load=`${v.loadavg().map(S=>Math.round(S)).join(", ")}`),p.isLinux&&(l.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(l)}async getDiagnostics(t,r){const i=[];return R.listProcesses(t.mainPID).then(async a=>(i.push(""),i.push(this.formatEnvironment(t)),i.push(""),i.push(this.formatProcessList(t,a)),t.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(t))),r.forEach(u=>{if(k.isRemoteDiagnosticError(u))i.push(`
${u.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${u.hostName}`),i.push(this.formatMachineInfo(u.machineInfo)),u.processes&&i.push(this.formatProcessList(t,u.processes)),u.workspaceMetadata)for(const c of Object.keys(u.workspaceMetadata)){const l=u.workspaceMetadata[c];let S=`${l.fileCount} files`;l.maxFilesReached&&(S=`more than ${S}`),i.push(`Folder (${c}): ${S}`),i.push(this.formatWorkspaceStats(l))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(t){const r=[],i=60;let a=0;const u=(w,g)=>{const U=` ${w}(${g})`;a+U.length>i?(r.push(c),c="|                 ",a=c.length):a+=U.length,c+=U};let c="|      File types:";const l=10;let S=t.fileTypes.length>l?l:t.fileTypes.length;for(let w=0;w<S;w++){const g=t.fileTypes[w];u(g.name,g.count)}if(r.push(c),t.configFiles.length>=0&&(c="|      Conf files:",a=0,t.configFiles.forEach(w=>{u(w.name,w.count)}),r.push(c)),t.launchConfigFiles.length>0){let w="|      Launch Configs:";t.launchConfigFiles.forEach(g=>{w+=g.count>1?` ${g.name}(${g.count})`:` ${g.name}`}),r.push(w)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(i=>i.length));return Object.keys(t).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${t[i]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],i=[];return t.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(r.push(`|  Window (${a.title})`),a.folderURIs.forEach(u=>{const c=n.URI.revive(u);if(c.scheme===b.Schemas.file){const l=c.fsPath;i.push(P(l,["node_modules",".git"]).then(S=>{let w=`${S.fileCount} files`;S.maxFilesReached&&(w=`more than ${w}`),r.push(`|    Folder (${A.basename(l)}): ${w}`),r.push(this.formatWorkspaceStats(S))}).catch(S=>{r.push(`|      Error: Unable to collect workspace stats for folder ${l} (${S.toString()})`)}))}else r.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(a=>r.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(t,r){const i=new Map;t.windows.forEach(u=>i.set(u.pid,u.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,i,a,r,0),a.join(`
`)}formatProcessItem(t,r,i,a,u){const c=u===0;let l;c?l=a.pid===t?`${this.productService.applicationName} main`:"remote agent":(l=`${"  ".repeat(u)} ${a.name}`,a.name==="window"&&(l=`${l} (${r.get(a.pid)})`));const S=process.platform==="win32"?a.mem:v.totalmem()*(a.mem/100);i.push(`${a.load.toFixed(0).padStart(5," ")}	${(S/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${l}`),Array.isArray(a.children)&&a.children.forEach(w=>this.formatProcessItem(t,r,i,w,u+1))}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const i=n.URI.revive(r);if(i.scheme!==b.Schemas.file)continue;const a=i.fsPath;try{const u=await P(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),u.fileTypes.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})}),u.launchConfigFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})}),u.configFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})})}catch(u){}}}};o=de([K(0,m.ITelemetryService),K(1,y.IProductService)],o),e.DiagnosticsService=o}),define(Z[174],ee([0,1,11,28,33,26,24,39,71,9,29,15,10,5,27,21,44,4,12]),function(G,e,v,L,k,A,T,R,y,p,n,m,h,b,f,C,P,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var d;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished"})(d||(d={}));function o(...O){return String(O.reduce((D,M)=>D|M,0))}var s;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:d.None,criteria:[],assetTypes:[]};class u{constructor(D=a){this.state=D}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(D,M=this.state.pageSize){return new u(Object.assign(Object.assign({},this.state),{pageNumber:D,pageSize:M}))}withFilter(D,...M){const _=[...this.state.criteria,...M.length?M.map(x=>({filterType:D,value:x})):[{filterType:D}]];return new u(Object.assign(Object.assign({},this.state),{criteria:_}))}withSortBy(D){return new u(Object.assign(Object.assign({},this.state),{sortBy:D}))}withSortOrder(D){return new u(Object.assign(Object.assign({},this.state),{sortOrder:D}))}withFlags(...D){return new u(Object.assign(Object.assign({},this.state),{flags:D.reduce((M,_)=>M|_,0)}))}withAssetTypes(...D){return new u(Object.assign(Object.assign({},this.state),{assetTypes:D}))}get raw(){const{criteria:D,pageNumber:M,pageSize:_,sortBy:x,sortOrder:B,flags:J,assetTypes:X}=this.state;return{filters:[{criteria:D,pageNumber:M,pageSize:_,sortBy:x,sortOrder:B}],assetTypes:X,flags:J}}get searchText(){const D=this.state.criteria.filter(M=>M.filterType===s.SearchText)[0];return D&&D.value?D.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(D=>String(D.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function c(O,D){const M=(O||[]).filter(_=>_.statisticName===D)[0];return M?M.value:0}function l(O){const D="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(_=>_.assetType.indexOf(D)===0).reduce((_,x)=>{const B=U(O,x.assetType);return B&&_.push([x.assetType.substring(D.length),B]),_},[])}function S(O){if(O.properties){const D=O.properties.filter(x=>x.key===t.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),_=D.filter(x=>M.test(x.value))[0];return _?{uri:_.value,fallbackUri:_.value}:null}return U(O,t.Repository)}function w(O){return{uri:`${O.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${O.fallbackAssetUri}/${t.VSIX}`}}function g(O){const D=U(O,t.Icon);if(D)return D;const M=L.DefaultIconPath;return{uri:M,fallbackUri:M}}function U(O,D){return O.files.filter(_=>_.assetType===D)[0]?{uri:`${O.assetUri}/${D}`,fallbackUri:`${O.fallbackAssetUri}/${D}`}:null}function F(O,D){const M=O.properties?O.properties.filter(x=>x.key===D):[],_=M.length>0&&M[0].value;return _?_.split(",").map(x=>k.adoptToGalleryExtensionId(x)):[]}function j(O){const D=O.properties?O.properties.filter(M=>M.key===r.Engine):[];return D.length>0&&D[0].value||""}function $(O){const D=O.properties?O.properties.filter(_=>_.key===r.LocalizedLanguages):[],M=D.length>0&&D[0].value||"";return M?M.split(","):[]}function V(O){return O.indexOf("preview")!==-1}function q(O){const D=O.properties?O.properties.find(M=>M.key===r.WebExtension):void 0;return!!D&&D.value==="true"}function z(O){return O.files.some(D=>D.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?I.joinPath(b.URI.parse(O.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function H(O,D,M,_,x){const B={manifest:U(D,t.Manifest),readme:U(D,t.Details),changelog:U(D,t.Changelog),license:U(D,t.License),repository:S(D),download:w(D),icon:g(D),coreTranslations:l(D)};return{identifier:{id:k.getGalleryExtensionId(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:D.version,date:D.lastUpdated,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,description:O.shortDescription||"",installCount:c(O.statistics,"install"),rating:c(O.statistics,"averagerating"),ratingCount:c(O.statistics,"ratingcount"),assetUri:b.URI.parse(D.assetUri),webResource:z(D),assetTypes:D.files.map(({assetType:J})=>J),assets:B,properties:{dependencies:F(D,r.Dependency),extensionPack:F(D,r.ExtensionPack),engine:j(D),localizedLanguages:$(D),webExtension:q(D)},telemetryData:{index:(_.pageNumber-1)*_.pageSize+M,querySource:x},preview:V(O.flags)}}let Q=class{constructor(D,M,_,x,B,J,X){this.requestService=D,this.logService=M,this.environmentService=_,this.telemetryService=x,this.fileService=B,this.productService=J;const te=J.extensionsGallery;this.extensionsGalleryUrl=te&&te.serviceUrl,this.extensionsControlUrl=te&&te.controlUrl,this.commonHeadersPromise=N(J.version,this.environmentService,this.fileService,X)}api(D=""){return`${this.extensionsGalleryUrl}${D}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(D,M){const _=[];let{total:x,firstPage:B,getPage:J}=await this.query({names:D,pageSize:D.length},M);_.push(...B);for(let X=1;_.length<x&&(B=await J(X,M),B.length);X++)_.push(...B);return _}async getCompatibleExtension(D,M){const _=await this.getCompatibleExtensionByEngine(D,M);return(_==null?void 0:_.properties.webExtension)?_.webResource?_:null:_}async getCompatibleExtensionByEngine(D,M){const _=L.isIExtensionIdentifier(D)?null:D;if(_&&_.properties.engine&&y.isEngineValid(_.properties.engine,this.productService.version,this.productService.date))return _;const{id:x,uuid:B}=_?_.identifier:D;let J=new u().withFlags(d.IncludeAssetUri,d.IncludeStatistics,d.IncludeFiles,d.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");B?J=J.withFilter(s.ExtensionId,B):J=J.withFilter(s.ExtensionName,x);const{galleryExtensions:X}=await this.queryGallery(J,n.CancellationToken.None),[te]=X;if(!te||!te.versions.length)return null;if(M){const ce=te.versions.filter(le=>le.version===M)[0];if(ce){const le=H(te,ce,0,J);if(le.properties.engine&&y.isEngineValid(le.properties.engine,this.productService.version,this.productService.date))return le}return null}const ie=await this.getLastValidExtensionVersion(te,te.versions);return ie?H(te,ie,0,J):null}async query(D,M){const _=n.CancellationToken.isCancellationToken(D)?{}:D,x=n.CancellationToken.isCancellationToken(D)?D:M;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let B=_.text||"";const J=A.getOrDefault(_,ve=>ve.pageSize,50);let X=new u().withFlags(d.IncludeLatestVersionOnly,d.IncludeAssetUri,d.IncludeStatistics,d.IncludeFiles,d.IncludeVersionProperties).withPage(1,J).withFilter(s.Target,"Microsoft.VisualStudio.Code");B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,pe,Ce)=>(X=X.withFilter(s.Category,Ce||pe),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,pe,Ce)=>(X=X.withFilter(s.Tag,Ce||pe),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(s.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),X=X.withFilter(s.SearchText,B)),X=X.withSortBy(0)):_.ids?X=X.withFilter(s.ExtensionId,..._.ids):_.names?X=X.withFilter(s.ExtensionName,..._.names):X=X.withSortBy(4),typeof _.sortBy=="number"&&(X=X.withSortBy(_.sortBy)),typeof _.sortOrder=="number"&&(X=X.withSortOrder(_.sortOrder));const{galleryExtensions:te,total:ie}=await this.queryGallery(X,x),ce=te.map((ve,pe)=>H(ve,ve.versions[0],pe,X,_.source)),le=async(ve,pe)=>{if(pe.isCancellationRequested)throw v.canceled();const Ce=X.withPage(ve+1),{galleryExtensions:Ae}=await this.queryGallery(Ce,pe);return Ae.map((Me,Te)=>H(Me,Me.versions[0],Te,Ce,_.source))};return{firstPage:ce,total:ie,pageSize:X.pageSize,getPage:le}}async queryGallery(D,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");D=D.withFlags(D.flags,d.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,o(d.Unpublished));const _=await this.commonHeadersPromise,x=JSON.stringify(D.raw),B=Object.assign(Object.assign({},_),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(x.length)}),J=new Date().getTime();let X,te,ie=0;try{if(X=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:x,headers:B},M),X.res.statusCode&&X.res.statusCode>=400&&X.res.statusCode<500)return{galleryExtensions:[],total:ie};const ce=await R.asJson(X);if(ce){const le=ce.results[0],ve=le.extensions,pe=le.resultMetadata&&le.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return ie=pe&&pe.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:ve,total:ie}}return{galleryExtensions:[],total:ie}}catch(ce){throw te=ce,ce}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},D.telemetryData),{requestBodySize:String(x.length),duration:new Date().getTime()-J,success:!!X&&R.isSuccess(X),responseBodySize:X==null?void 0:X.res.headers["Content-Length"],statusCode:X?String(X.res.statusCode):void 0,errorCode:te?v.isPromiseCanceledError(te)?"canceled":v.getErrorMessage(te).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ie)}))}}async reportStatistic(D,M,_,x){if(!this.isEnabled())return;const B=await this.commonHeadersPromise,J=Object.assign(Object.assign({},B),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${D}/extensions/${M}/${_}/stats?statType=${x}`),headers:J},n.CancellationToken.None)}catch(X){}}async download(D,M,_){this.logService.trace("ExtensionGalleryService#download",D.identifier.id);const x=k.getGalleryExtensionTelemetryData(D),B=new Date().getTime(),J=ce=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},x),{duration:ce})),X=_===1?"install":_===2?"update":"",te=X?{uri:`${D.assets.download.uri}&${X}=true`,fallbackUri:`${D.assets.download.fallbackUri}?${X}=true`}:D.assets.download,ie=await this.getAsset(te);await this.fileService.writeFile(M,ie.stream),J(new Date().getTime()-B)}async getReadme(D,M){if(D.assets.readme){const _=await this.getAsset(D.assets.readme,{},M);return await R.asText(_)||""}return""}async getManifest(D,M){if(D.assets.manifest){const _=await this.getAsset(D.assets.manifest,{},M),x=await R.asText(_);return x?JSON.parse(x):null}return null}async getCoreTranslation(D,M){const _=D.assets.coreTranslations.filter(x=>x[0]===M.toUpperCase())[0];if(_){const x=await this.getAsset(_[1]),B=await R.asText(x);return B?JSON.parse(B):null}return null}async getChangelog(D,M){if(D.assets.changelog){const _=await this.getAsset(D.assets.changelog,{},M);return await R.asText(_)||""}return""}async getAllVersions(D,M){let _=new u().withFlags(d.IncludeVersions,d.IncludeFiles,d.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");D.identifier.uuid?_=_.withFilter(s.ExtensionId,D.identifier.uuid):_=_.withFilter(s.ExtensionName,D.identifier.id);const x=[],{galleryExtensions:B}=await this.queryGallery(_,n.CancellationToken.None);return B.length&&(M?await Promise.all(B[0].versions.map(async J=>{let X;try{X=await this.getEngine(J)}catch(te){}X&&y.isEngineValid(X,this.productService.version,this.productService.date)&&x.push({version:J.version,date:J.lastUpdated})})):x.push(...B[0].versions.map(J=>({version:J.version,date:J.lastUpdated})))),x}async getAsset(D,M={},_=n.CancellationToken.None){const x=await this.commonHeadersPromise,B={type:"GET"},J=Object.assign(Object.assign({},x),M.headers||{});M=Object.assign(Object.assign(Object.assign({},M),B),{headers:J});const X=D.uri,te=D.fallbackUri,ie=Object.assign(Object.assign({},M),{url:X});try{const ce=await this.requestService.request(ie,_);if(ce.res.statusCode===200)return ce;const le=await R.asText(ce);throw new Error(`Expected 200, got back ${ce.res.statusCode} instead.

${le}`)}catch(ce){if(v.isPromiseCanceledError(ce))throw ce;const le=v.getErrorMessage(ce);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:X,message:le});const ve=Object.assign(Object.assign({},M),{url:te});return this.requestService.request(ve,_)}}async getLastValidExtensionVersion(D,M){const _=this.getLastValidExtensionVersionFromProperties(D,M);return _||this.getLastValidExtensionVersionRecursively(D,M)}getLastValidExtensionVersionFromProperties(D,M){for(const _ of M){const x=j(_);if(!x)return null;if(y.isEngineValid(x,this.productService.version,this.productService.date))return _}return null}async getEngine(D){const M=j(D);if(M)return M;const _=U(D,t.Manifest);if(!_)throw new Error("Manifest was not found");const x={"Accept-Encoding":"gzip"},B=await this.getAsset(_,{headers:x}),J=await R.asJson(B);if(J)return J.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(D,M){if(!M.length)return null;const _=M[0],x=await this.getEngine(_);return y.isEngineValid(x,this.productService.version,this.productService.date)?Object.assign(Object.assign({},_),{properties:[..._.properties||[],{key:r.Engine,value:x}]}):this.getLastValidExtensionVersionRecursively(D,M.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const D=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(D.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await R.asJson(D),_=new Map;if(M)for(const x of M.malicious){const B=_.get(x)||{id:{id:x},malicious:!0,slow:!1};B.malicious=!0,_.set(x,B)}return[..._.values()]}};Q=de([K(0,R.IRequestService),K(1,m.ILogService),K(2,p.IEnvironmentService),K(3,T.ITelemetryService),K(4,h.IFileService),K(5,f.IProductService),K(6,E.optional(C.IStorageService))],Q),e.ExtensionGalleryService=Q;async function N(O,D,M,_){const x={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O}`},B=await P.getServiceMachineId(D,M,_);return x["X-Market-User-Id"]=B,x}e.resolveMarketplaceHeaders=N}),define(Z[175],ee([0,1,5,8,27,9,34,10,7,19,28,63,39,15,168,6,24,74,111,21,3,58]),function(G,e,v,L,k,A,T,R,y,p,n,m,h,b,f,C,P,E,I,d,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let i=class extends f.ExtensionTipsService{constructor(u,c,l,S,w,g,U,F,j,$){super(U,F,j,$);this.environmentService=u,this.telemetryService=c,this.extensionManagementService=l,this.storageService=S,this.nativeHostService=w,this.extensionRecommendationNotificationService=g,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,F.exeBasedExtensionTips&&m.forEach(F.exeBasedExtensionTips,({key:V,value:q})=>{const z=[],H=[],Q=[];m.forEach(q.recommendations,({key:N,value:O})=>{O.important?q.important?z.push({extensionId:N,extensionName:O.name,isExtensionPack:!!O.isExtensionPack}):H.push({extensionId:N,extensionName:O.name,isExtensionPack:!!O.isExtensionPack}):Q.push({extensionId:N,extensionName:O.name,isExtensionPack:!!O.isExtensionPack})}),z.length&&this.highImportanceExecutableTips.set(V,{exeFriendlyName:q.friendlyName,windowsPath:q.windowsPath,recommendations:z}),H.length&&this.mediumImportanceExecutableTips.set(V,{exeFriendlyName:q.friendlyName,windowsPath:q.windowsPath,recommendations:H}),Q.length&&this.allOtherExecutableTips.set(V,{exeFriendlyName:q.friendlyName,windowsPath:q.windowsPath,recommendations:Q})}),C.timeout(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...u,...c]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),l=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(u,l),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(c,l)}groupImportantTipsByExe(u,c){const l=new Map;u.forEach(F=>l.set(F.extensionId.toLowerCase(),F));const{installed:S,uninstalled:w}=this.groupByInstalled([...l.keys()],c);for(const F of S){const j=l.get(F);j&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:F,exeName:L.basename(j.windowsPath)})}for(const F of w){const j=l.get(F);j&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:F,exeName:L.basename(j.windowsPath)})}const g=this.getPromptedExecutableTips(),U=new Map;for(const F of w){const j=l.get(F);if(j&&(!g[j.exeName]||!g[j.exeName].includes(j.extensionId))){let $=U.get(j.exeName);$||($=[],U.set(j.exeName,$)),$.push(j)}}return U}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[u,c]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(c).then(l=>{switch(l){case"reacted":this.addToRecommendedExecutables(c[0].exeName,c);break;case"ignored":this.highImportanceTipsByExe.delete(u);break;case"incompatibleWindow":const S=o.Event.once(o.Event.latch(o.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(S(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const w=this._register(C.disposableTimeout(()=>{w.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const u=this.getLastPromptedMediumExeTime(),c=Date.now()-u,l=7*24*60*60*1e3;if(c<l){const g=this._register(C.disposableTimeout(()=>{g.dispose(),this.promptMediumImportanceExeBasedTip()},l-c));return}const[S,w]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(w).then(g=>{switch(g){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(S),this.addToRecommendedExecutables(w[0].exeName,w);const U=this._register(C.disposableTimeout(()=>{U.dispose(),this.promptMediumImportanceExeBasedTip()},l));break;case"ignored":this.mediumImportanceTipsByExe.delete(S),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const F=o.Event.once(o.Event.latch(o.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(F(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const j=this._register(C.disposableTimeout(()=>{j.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(u){const c=u.map(({extensionId:S})=>S.toLowerCase()),l=I.localize(0,null,u[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(c,l,`@exe:"${u[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let u=this.storageService.getNumber(r,0);return u||(u=Date.now(),this.updateLastPromptedMediumExeTime(u)),u}updateLastPromptedMediumExeTime(u){this.storageService.store(r,u,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(u,c){const l=this.getPromptedExecutableTips();l[u]=c.map(({extensionId:S})=>S.toLowerCase()),this.storageService.store(t,JSON.stringify(l),0,0)}groupByInstalled(u,c){const l=[],S=[],w=c.reduce((g,U)=>(g.add(U.identifier.id.toLowerCase()),g),new Set);return u.forEach(g=>{w.has(g.toLowerCase())?l.push(g):S.push(g)}),{installed:l,uninstalled:S}}async getValidExecutableBasedExtensionTips(u){const c=[],l=new Map;for(const S of u.keys()){const w=u.get(S);if(!w||!p.isNonEmptyArray(w.recommendations))continue;const g=[];y.isWindows?w.windowsPath&&g.push(w.windowsPath.replace("%USERPROFILE%",T.env.USERPROFILE).replace("%ProgramFiles(x86)%",T.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",T.env.ProgramFiles).replace("%APPDATA%",T.env.APPDATA).replace("%WINDIR%",T.env.WINDIR)):(g.push(L.join("/usr/local/bin",S)),g.push(L.join("/usr/bin",S)),g.push(L.join(this.environmentService.userHome.fsPath,S)));for(const U of g){let F=l.get(U);if(F===void 0&&(F=await this.fileService.exists(v.URI.file(U)),l.set(U,F)),F)for(const{extensionId:j,extensionName:$,isExtensionPack:V}of w.recommendations)c.push({extensionId:j,extensionName:$,isExtensionPack:V,exeName:S,exeFriendlyName:w.exeFriendlyName,windowsPath:w.windowsPath})}}return c}};i=de([K(0,A.INativeEnvironmentService),K(1,P.ITelemetryService),K(2,n.IExtensionManagementService),K(3,d.IStorageService),K(4,s.INativeHostService),K(5,E.IExtensionRecommendationNotificationService),K(6,R.IFileService),K(7,k.IProductService),K(8,h.IRequestService),K(9,b.ILogService)],i),e.ExtensionTipsService=i}),define(Z[81],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(A){this.appender=A}listen(A,T){throw new Error(`Event not found: ${T}`)}call(A,T,{eventName:R,data:y}){return this.appender.log(R,y),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class L{constructor(A){this.channel=A}log(A,T){return this.channel.call("log",{eventName:A,data:T}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(Z[82],ee([0,1,51,121,20,4,23,37,2,26,31]),function(G,e,v,L,k,A,T,R,y,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{constructor(f,C){this._configurationService=C,this._experimentProperties={},this._disposables=new y.DisposableStore,this._cleanupPatterns=[],this._appender=f.appender,this._commonProperties=f.commonProperties||Promise.resolve({}),this._piiPaths=f.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp(k.escapeRegExpCharacters(P),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(P=>{const E=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!E})}))}setExperimentProperty(f,C){this._experimentProperties[f]=C}setEnabled(f){this._enabled=f}_updateUserOptIn(){var f;const C=(f=this._configurationService)===null||f===void 0?void 0:f.getValue(h);this._userOptIn=C?C.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const f=await this._commonProperties;let C=f.sessionID,P=f["common.instanceId"],E=f["common.machineId"],I=f["common.firstSessionDate"],d=f["common.msftInternal"];return{sessionId:C,instanceId:P,machineId:E,firstSessionDate:I,msftInternal:d}}dispose(){this._disposables.dispose()}publicLog(f,C,P){return this.isOptedIn?this._commonProperties.then(E=>{C=p.mixin(C,E),C=p.mixin(C,this._experimentProperties),C=p.cloneAndChange(C,I=>{if(typeof I=="string")return this._cleanupInfo(I,P)}),this._appender.log(f,C)},E=>{console.error(E)}):Promise.resolve(void 0)}publicLog2(f,C,P){return this.publicLog(f,C,P)}publicLogError(f,C){return this.sendErrorTelemetry?this.publicLog(f,C,!0):Promise.resolve(void 0)}publicLogError2(f,C){return this.publicLogError(f,C)}_cleanupInfo(f,C){let P=f;if(C){const E=[];for(let s of this._cleanupPatterns)for(;;){const t=s.exec(f);if(!t)break;E.push([t.index,s.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(P="";;){const s=d.exec(f);if(!s)break;!I.test(s[0])&&E.every(([t,r])=>s.index<t||s.index>=r)&&(P+=f.substring(o,s.index)+"<REDACTED: user-file-path>",o=d.lastIndex)}o<f.length&&(P+=f.substr(o))}for(let E of this._cleanupPatterns)P=P.replace(E,"");return P}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=de([K(1,A.optional(T.IConfigurationService))],m),e.TelemetryService=m;const h="telemetry";n.Registry.as(R.Extensions.Configuration).registerConfiguration({id:h,order:110,type:"object",title:L.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:v.default.privacyStatementUrl?L.localize(2,null,v.default.privacyStatementUrl):L.localize(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(Z[59],ee([0,1,23,26,16,6]),function(G,e,v,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(f,C){return Promise.resolve(void 0)}publicLog2(f,C){return this.publicLog(f,C)}publicLogError(f,C){return Promise.resolve(void 0)}publicLogError2(f,C){return this.publicLogError(f,C)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class T{async publicLog(C,P,E){}async publicLogError(C,P,E){}}e.NullEndpointTelemetryService=T;function R(...f){return{log:(C,P)=>f.forEach(E=>E.log(C,P)),flush:()=>A.Promises.settled(f.map(C=>C.flush()))}}e.combinedAppender=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(f,C){return C.onDidChangeConfiguration(P=>{P.source!==6&&f.publicLog2("updateConfiguration",{configurationSource:v.ConfigurationTargetToString(P.source),configurationKeys:h(P.sourceConfig)})})}e.configurationTelemetry=y;function p(f){const C=Object.create(null),P=Object.create(null),E=Object.create(null);m(f,E);for(let I in E){I=I.length>150?I.substr(I.length-149):I;const d=E[I];typeof d=="number"?P[I]=d:typeof d=="boolean"?P[I]=d?1:0:typeof d=="string"?C[I]=d.substring(0,1023):typeof d!="undefined"&&d!==null&&(C[I]=d)}return{properties:C,measurements:P}}e.validateTelemetryData=p;function n(f){if(!f)return"none";let C="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(E=>{f.indexOf(`${E}+`)===0&&(C=E)}),C}e.cleanRemoteAuthority=n;function m(f,C,P=0,E){if(!!f)for(let I of Object.getOwnPropertyNames(f)){const d=f[I],o=E?E+I:I;Array.isArray(d)?C[o]=L.safeStringify(d):d instanceof Date?C[o]=d.toISOString():k.isObject(d)?P<2?m(d,C,P+1,o+"."):C[o]=L.safeStringify(d):C[o]=d}}function h(f){if(!f)return[];const C=[];return b(C,"",f),C}function b(f,C,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(E=>b(f,C?`${C}.${E}`:E,P[E])):f.push(C)}}),define(Z[176],ee([0,1,2,9,15,59]),function(G,e,v,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let T=class extends v.Disposable{constructor(y,p){super();this.logger=this._register(y.createLogger(p.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(y,p){this.logger.trace(`telemetry/${y}`,A.validateTelemetryData(p))}};T=de([K(0,k.ILoggerService),K(1,L.IEnvironmentService)],T),e.TelemetryLogAppender=T}),define(Z[177],ee([0,1,11,26,59]),function(G,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function A(R){const y=await new Promise((n,m)=>{G(["applicationinsights"],n,m)});let p;return y.defaultClient?(p=new y.TelemetryClient(R),p.channel.setUseDiskRetryCaching(!0)):(y.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),p=y.defaultClient),R.indexOf("AIF-")===0&&(p.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),p}class T{constructor(y,p,n){this._eventPrefix=y,this._defaultData=p,this._defaultData||(this._defaultData=Object.create(null)),typeof n=="function"?this._aiClient=n():this._aiClient=n,this._asyncAIClient=null}_withAIClient(y){if(!!this._aiClient){if(typeof this._aiClient!="string"){y(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=A(this._aiClient)),this._asyncAIClient.then(p=>{y(p)},p=>{v.onUnexpectedError(p),console.error(p)})}}log(y,p){!this._aiClient||(p=L.mixin(p,this._defaultData),p=k.validateTelemetryData(p),this._withAIClient(n=>n.trackEvent({name:this._eventPrefix+"/"+y,properties:p.properties,measurements:p.measurements})))}flush(){return this._aiClient?new Promise(y=>{this._withAIClient(p=>{p.flush({callback:()=>{this._aiClient=void 0,y(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=T}),define(Z[178],ee([0,1,49,81,17,82,23,24]),function(G,e,v,L,k,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let y=class{constructor(n,m){this.configurationService=n,this.telemetryService=m,this.customTelemetryServices=new Map}async getCustomTelemetryService(n){if(!this.customTelemetryServices.has(n.id)){const{machineId:m,sessionId:h}=await this.telemetryService.getTelemetryInfo(),b=Object.create(null);b["common.vscodemachineid"]=m,b["common.vscodesessionid"]=h;const f=[n.id,JSON.stringify(b),n.aiKey],P=new v.Client(k.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:f,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),E=new L.TelemetryAppenderClient(P);this.customTelemetryServices.set(n.id,new A.TelemetryService({appender:E,sendErrorTelemetry:n.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(n.id)}async publicLog(n,m,h){await(await this.getCustomTelemetryService(n)).publicLog(m,h)}async publicLogError(n,m,h){await(await this.getCustomTelemetryService(n)).publicLogError(m,h)}};y=de([K(0,T.IConfigurationService),K(1,R.ITelemetryService)],y),e.CustomEndpointTelemetryService=y}),define(Z[83],ee([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.HeartbeatConstants=e.IPtyService=e.ILocalTerminalService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(h){h.Shell="terminal.integrated.shell.",h.ShellArgs="terminal.integrated.shellArgs.",h.DefaultProfile="terminal.integrated.defaultProfile.",h.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var k;(function(h){h.ShellLinux="terminal.integrated.shell.linux",h.ShellMacOs="terminal.integrated.shell.osx",h.ShellWindows="terminal.integrated.shell.windows",h.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",h.AutomationShellLinux="terminal.integrated.automationShell.linux",h.AutomationShellMacOs="terminal.integrated.automationShell.osx",h.AutomationShellWindows="terminal.integrated.automationShell.windows",h.ShellArgsLinux="terminal.integrated.shellArgs.linux",h.ShellArgsMacOs="terminal.integrated.shellArgs.osx",h.ShellArgsWindows="terminal.integrated.shellArgs.windows",h.ProfilesWindows="terminal.integrated.profiles.windows",h.ProfilesMacOs="terminal.integrated.profiles.osx",h.ProfilesLinux="terminal.integrated.profiles.linux",h.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",h.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",h.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",h.UseWslProfiles="terminal.integrated.useWslProfiles",h.TabsEnabled="terminal.integrated.tabs.enabled",h.TabsHideCondition="terminal.integrated.tabs.hideCondition",h.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",h.TabsShowActions="terminal.integrated.tabs.showActions",h.TabsLocation="terminal.integrated.tabs.location",h.TabsFocusMode="terminal.integrated.tabs.focusMode",h.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",h.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",h.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",h.CopyOnSelection="terminal.integrated.copyOnSelection",h.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",h.FontFamily="terminal.integrated.fontFamily",h.FontSize="terminal.integrated.fontSize",h.LetterSpacing="terminal.integrated.letterSpacing",h.LineHeight="terminal.integrated.lineHeight",h.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",h.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",h.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",h.BellDuration="terminal.integrated.bellDuration",h.FontWeight="terminal.integrated.fontWeight",h.FontWeightBold="terminal.integrated.fontWeightBold",h.CursorBlinking="terminal.integrated.cursorBlinking",h.CursorStyle="terminal.integrated.cursorStyle",h.CursorWidth="terminal.integrated.cursorWidth",h.Scrollback="terminal.integrated.scrollback",h.DetectLocale="terminal.integrated.detectLocale",h.DefaultLocation="terminal.integrated.defaultLocation",h.GpuAcceleration="terminal.integrated.gpuAcceleration",h.RightClickBehavior="terminal.integrated.rightClickBehavior",h.Cwd="terminal.integrated.cwd",h.ConfirmOnExit="terminal.integrated.confirmOnExit",h.EnableBell="terminal.integrated.enableBell",h.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",h.AllowChords="terminal.integrated.allowChords",h.AllowMnemonics="terminal.integrated.allowMnemonics",h.EnvMacOs="terminal.integrated.env.osx",h.EnvLinux="terminal.integrated.env.linux",h.EnvWindows="terminal.integrated.env.windows",h.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",h.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",h.ShowExitAlert="terminal.integrated.showExitAlert",h.SplitCwd="terminal.integrated.splitCwd",h.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",h.WordSeparators="terminal.integrated.wordSeparators",h.TitleMode="terminal.integrated.titleMode",h.EnableFileLinks="terminal.integrated.enableFileLinks",h.UnicodeVersion="terminal.integrated.unicodeVersion",h.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",h.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",h.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",h.LocalEchoStyle="terminal.integrated.localEchoStyle",h.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",h.InheritEnv="terminal.integrated.inheritEnv",h.ShowLinkHover="terminal.integrated.showLinkHover"})(k=e.TerminalSettingId||(e.TerminalSettingId={}));var A;(function(h){h.CommandPrompt="cmd",h.PowerShell="pwsh",h.Wsl="wsl",h.GitBash="gitbash"})(A=e.WindowsShellType||(e.WindowsShellType={}));var T;(function(h){h[h.Api=0]="Api",h[h.Process=1]="Process",h[h.Sequence=2]="Sequence"})(T=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(h){h.LocalPty="localPty",h.PtyHost="ptyHost",h.Log="log",h.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.ILocalTerminalService=v.createDecorator("localTerminalService"),e.IPtyService=v.createDecorator("ptyService");var y;(function(h){h[h.BeatInterval=5e3]="BeatInterval",h[h.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",h[h.SecondWaitMultiplier=1]="SecondWaitMultiplier",h[h.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(y=e.HeartbeatConstants||(e.HeartbeatConstants={}));var p;(function(h){h[h.GraceTime=6e4]="GraceTime",h[h.ShortGraceTime=6e3]="ShortGraceTime"})(p=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var n;(function(h){h[h.HighWatermarkChars=1e5]="HighWatermarkChars",h[h.LowWatermarkChars=5e3]="LowWatermarkChars",h[h.CharCountAckSize=5e3]="CharCountAckSize"})(n=e.FlowControlConstants||(e.FlowControlConstants={}));var m;(function(h){h.GitBash="Git Bash",h.Pwsh="PowerShell"})(m=e.ProfileSource||(e.ProfileSource={}))}),define(Z[179],ee([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=v.createDecorator("localPtyService")}),define(Z[180],ee([0,1,35,8,34,18,16,26,7]),function(G,e,v,L,k,A,T,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function p(){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(v.release());let h=0;return m&&m.length===4&&(h=parseInt(m[3])),h}e.getWindowsBuildNumber=p;async function n(m,h,b,f=k.env,C=A.Promises.exists){if(L.isAbsolute(m))return await C(m)?m:void 0;if(h===void 0&&(h=k.cwd()),L.dirname(m)!=="."){const d=L.join(h,m);return await C(d)?d:void 0}const E=R.getCaseInsensitive(f,"PATH");if(b===void 0&&T.isString(E)&&(b=E.split(L.delimiter)),b===void 0||b.length===0){const d=L.join(h,m);return await C(d)?d:void 0}for(let d of b){let o;if(L.isAbsolute(d)?o=L.join(d,m):o=L.join(h,d,m),await C(o))return o;if(y.isWindows){let s=o+".com";if(await C(s)||(s=o+".exe",await C(s)))return s}}const I=L.join(h,m);return await C(I)?I:void 0}e.findExecutable=n}),define(Z[181],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(Z[84],ee([0,1,4,2,31,3,181,54]),function(G,e,v,L,k,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=v.createDecorator("themeService");var y;(function(P){function E(I){return I&&typeof I=="object"&&typeof I.id=="string"}P.isThemeColor=E})(y=e.ThemeColor||(e.ThemeColor={}));function p(P){return{id:P}}e.themeColorFromId=p;var n;(function(P){function E(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||y.isThemeColor(r.color))}P.isThemeIcon=E;const I=new RegExp(`^\\$\\((${R.CSSIcon.iconNameExpression}(?:${R.CSSIcon.iconModifierExpression})?)\\)$`);function d(r){const i=I.exec(r);if(!i)return;let[,a]=i;return{id:a}}P.fromString=d;function o(r,i){let a=r.id;const u=a.lastIndexOf("~");return u!==-1&&(a=a.substring(0,u)),i&&(a=`${a}~${i}`),{id:a}}P.modify=o;function s(r,i){var a,u;return r.id===i.id&&((a=r.color)===null||a===void 0?void 0:a.id)===((u=i.color)===null||u===void 0?void 0:u.id)}P.isEqual=s;function t(r){return{id:r.id}}P.asThemeIcon=t,P.asClassNameArray=R.CSSIcon.asClassNameArray,P.asClassName=R.CSSIcon.asClassName,P.asCSSSelector=R.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=R.Codicon.file,e.FolderThemeIcon=R.Codicon.folder;function m(P){switch(P){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=m,e.Extensions={ThemingContribution:"base.contributions.theming"};class h{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new A.Emitter}onColorThemeChange(E){return this.themingParticipants.push(E),this.onThemingParticipantAddedEmitter.fire(E),L.toDisposable(()=>{const I=this.themingParticipants.indexOf(E);this.themingParticipants.splice(I,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let b=new h;k.Registry.add(e.Extensions.ThemingContribution,b);function f(P){return b.onColorThemeChange(P)}e.registerThemingParticipant=f;class C extends L.Disposable{constructor(E){super();this.themeService=E,this.theme=E.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(I=>this.onThemeChange(I)))}onThemeChange(E){this.theme=E,this.updateStyles()}updateStyles(){}getColor(E,I){let d=this.theme.getColor(E);return d&&I&&(d=I(d,this.theme)),d?d.toString():null}}e.Themable=C}),define(Z[182],ee([0,1,37,122,31,54,84]),function(G,e,v,L,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const R={args:{description:L.localize(0,null),type:"array",items:{type:"string"}},overrideName:{description:L.localize(1,null),type:"boolean"},icon:{description:L.localize(2,null),type:"string",enum:Array.from(A.iconRegistry.all,E=>E.id),markdownEnumDescriptions:Array.from(A.iconRegistry.all,E=>`$(${E.id})`)},color:{description:L.localize(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:L.localize(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},y={type:"object",required:["path"],properties:Object.assign({path:{description:L.localize(5,null),type:["string","array"],items:{type:"string"}}},R)},p=L.localize(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),n=L.localize(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),m=L.localize(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),h={id:"terminal",order:100,title:L.localize(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:L.localize(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:L.localize(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:L.localize(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:L.localize(13,null),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:L.localize(14,null),type:["string","null"],default:null,markdownDeprecationMessage:n},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:L.localize(15,null),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:L.localize(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:p},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:L.localize(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:n},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:L.localize(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:L.localize(19,null)}},{type:"string",markdownDescription:L.localize(20,null)}],default:[],markdownDeprecationMessage:m},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:L.localize(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:Object.assign({source:{description:L.localize(22,null),enum:["PowerShell","Git Bash"]}},R)},{type:"null"},y]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:L.localize(23,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},y]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:L.localize(24,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},y]}},["terminal.integrated.useWslProfiles"]:{description:L.localize(25,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:L.localize(26,null),type:"boolean",default:!0},["terminal.integrated.showLinkHover"]:{scope:1,description:L.localize(27,null),type:"boolean",default:!0}}};function b(){k.Registry.as(v.Extensions.Configuration).registerConfiguration(h),C()}e.registerTerminalPlatformConfiguration=b;let f;function C(E){const I=k.Registry.as(v.Extensions.Configuration);f&&I.deregisterConfigurations([f]);let d,o;if(E){const s=E.profiles.map(t=>({name:t.profileName,description:P(t)}));d=s.map(t=>t.name),o=s.map(t=>t.description)}f={id:"terminal",order:100,title:L.localize(28,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:L.localize(29,null,"`#terminal.integrated.shell.linux#`","`#terminal.integrated.shellArgs.linux#`"),type:["string","null"],default:null,enum:(E==null?void 0:E.os)===3?d:void 0,markdownEnumDescriptions:(E==null?void 0:E.os)===3?o:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:L.localize(30,null,"`#terminal.integrated.shell.osx#`","`#terminal.integrated.shellArgs.osx#`"),type:["string","null"],default:null,enum:(E==null?void 0:E.os)===2?d:void 0,markdownEnumDescriptions:(E==null?void 0:E.os)===2?o:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:L.localize(31,null,"`#terminal.integrated.shell.windows#`","`#terminal.integrated.shellArgs.windows#`"),type:["string","null"],default:null,enum:(E==null?void 0:E.os)===1?d:void 0,markdownEnumDescriptions:(E==null?void 0:E.os)===1?o:void 0}}},I.registerConfiguration(f)}e.registerTerminalDefaultProfileConfiguration=C;function P(E){let I=`$(${T.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:A.Codicon.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?I+=`
- args: "${E.args}"`:I+=`
- args: [${E.args.length===0?"":E.args.join("','")}]`),E.overrideName!==void 0&&(I+=`
- overrideName: ${E.overrideName}`),E.color&&(I+=`
- color: ${E.color}`),E.env&&(I+=`
- env: ${JSON.stringify(E.env)}`),I}});var tt=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],v;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),v={},L("next"),L("throw"),L("return"),v[Symbol.asyncIterator]=function(){return this},v);function L(A){v[A]=G[A]&&function(T){return new Promise(function(R,y){T=G[A](T),k(R,y,T.done,T.value)})}}function k(A,T,R,y){Promise.resolve(y).then(function(p){A({value:p,done:R})},T)}};define(Z[183],ee([0,1,8,97,180,42,18,54,7,84]),function(G,e,v,L,k,A,T,R,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n;function m(s,t,r,i,a,u,c,l){return a=a||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},y.isWindows?h(r,a,u,i.getValue("terminal.integrated.useWslProfiles")!==!1,s&&typeof s=="object"?Object.assign({},s):i.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:i.getValue("terminal.integrated.defaultProfile.windows"),l,c):I(a,u,r,s&&typeof s=="object"?Object.assign({},s):i.getValue(y.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:i.getValue(y.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),l,c)}e.detectAvailableProfiles=m;async function h(s,t,r,i,a,u,c,l){const S=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),w=`${process.env.windir}\\${S?"Sysnative":"System32"}`;let g=!1;k.getWindowsBuildNumber()>=16299&&(g=!0),await f(c);const U=new Map;s&&(U.set("PowerShell",{source:"PowerShell",icon:R.Codicon.terminalPowershell,isAutoDetected:!0}),U.set("Windows PowerShell",{path:`${w}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.Codicon.terminalPowershell,isAutoDetected:!0}),U.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),U.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),U.set("Command Prompt",{path:`${w}\\cmd.exe`,icon:R.Codicon.terminalCmd,isAutoDetected:!0})),d(a,U);const F=await b(U.entries(),u,t,r,l);if(s||!s&&i)try{const j=await P(`${w}\\${g?"wsl":"bash"}.exe`,u);for(const $ of j)(!a||!($.profileName in a))&&F.push($)}catch(j){r==null||r.info("WSL is not installed, so could not detect WSL profiles")}return F}async function b(s,t,r,i,a){const u=[];for(const[c,l]of s){if(l===null)continue;let S,w,g;if("source"in l){const j=n==null?void 0:n.get(l.source);if(!j)continue;S=j.paths,w=l.args||j.args,l.icon?g=l.icon:j.icon&&(g=j.icon)}else S=Array.isArray(l.path)?l.path:[l.path],w=y.isWindows||Array.isArray(l.args)?l.args:void 0,g=l.icon||void 0;const U=await(a==null?void 0:a(S))||S.slice(),F=await o(c,t,U,r,w,l.env,l.overrideName,l.isAutoDetected,i);F?(F.isAutoDetected=l.isAutoDetected,F.icon=g,F.color=l.color,u.push(F)):i==null||i.trace("profile not validated",c,S)}return u}async function f(s){n&&!s||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:s||await C(),icon:p.ThemeIcon.asThemeIcon(R.Codicon.terminalPowershell)}))}async function C(){var s,t;const r=[];try{for(var i=tt(L.enumeratePowerShellInstallations()),a;a=await i.next(),!a.done;){const u=a.value;r.push(u.exePath)}}catch(u){s={error:u}}finally{try{a&&!a.done&&(t=i.return)&&await t.call(i)}finally{if(s)throw s.error}}return r}async function P(s,t){const r=[],i=await new Promise((c,l)=>{A.exec("wsl.exe -l -q",{encoding:"utf16le"},(S,w)=>{if(S)return l("Problem occurred when getting wsl distros");c(w)})});if(!i)return[];const a=new RegExp(/[\r?\n]/),u=i.split(a).filter(c=>c.trim().length>0&&c!=="");for(const c of u){if(c===""||c.startsWith("docker-desktop"))continue;const l=`${c} (WSL)`,S={profileName:l,path:s,args:["-d",`${c}`],isDefault:l===t,icon:E(c)};r.push(S)}return r}function E(s){return s.includes("Ubuntu")?p.ThemeIcon.asThemeIcon(R.Codicon.terminalUbuntu):s.includes("Debian")?p.ThemeIcon.asThemeIcon(R.Codicon.terminalDebian):p.ThemeIcon.asThemeIcon(R.Codicon.terminalLinux)}async function I(s,t,r,i,a,u,c){const l=new Map;if(r){const S=(await s.readFile("/etc/shells")).toString(),w=u||S.split(`
`).filter(U=>U.trim().indexOf("#")!==0&&U.trim().length>0),g=new Map;for(const U of w){let F=v.basename(U),j=g.get(F)||0;j++,j>1&&(F=`${F} (${j})`),g.set(F,j),l.set(F,{path:U,isAutoDetected:!0})}}return d(i,l),await b(l.entries(),a,s,t,c)}function d(s,t){if(!!s)for(const[r,i]of Object.entries(s))i===null||!("path"in i)&&!("source"in i)?t.delete(r):t.set(r,i)}async function o(s,t,r,i,a,u,c,l,S){if(r.length===0)return Promise.resolve(void 0);const w=r.shift();if(w==="")return o(s,t,r,i,a,u,c,l);const g={profileName:s,path:w,args:a,env:u,overrideName:c,isAutoDetected:l,isDefault:s===t};if(v.basename(w)===w){const F=process.env.PATH?process.env.PATH.split(v.delimiter):void 0;return await k.findExecutable(w,void 0,F,void 0,i.existsFile)?g:o(s,t,r,i,a)}return await i.existsFile(v.normalize(w))?g:o(s,t,r,i,a,u,c,l)}}),define(Z[184],ee([0,1,2,15,83,49,17,36,3,78,24,183,23,182]),function(G,e,v,L,k,A,T,R,y,p,n,m,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var f;(function(I){I[I.MaxRestarts=5]="MaxRestarts"})(f||(f={}));let C=0,P=0,E=class extends v.Disposable{constructor(d,o,s,t){super();this._reconnectConstants=d,this._configurationService=o,this._logService=s,this._telemetryService=t,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new y.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new y.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new y.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new y.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new y.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new y.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new y.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new y.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new y.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new y.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new y.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new y.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new y.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new y.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._pendingResolveVariablesRequests=new Map,b.registerTerminalPlatformConfiguration(),this._register(v.toDisposable(()=>this._disposePtyHost())),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const d=new A.Client(T.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:C,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.GraceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.ShortGraceTime}});this._onPtyHostStart.fire(),R.ProxyChannel.toService(d.getChannel(k.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(d.onDidProcessExit(r=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(r.code),this._isDisposed||(this._restartCount<=f.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const s=d.getChannel(k.TerminalIpcChannels.Log);p.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{p.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const t=R.ProxyChannel.toService(d.getChannel(k.TerminalIpcChannels.PtyHost));return this._register(t.onProcessData(r=>this._onProcessData.fire(r))),this._register(t.onProcessExit(r=>this._onProcessExit.fire(r))),this._register(t.onProcessReady(r=>this._onProcessReady.fire(r))),this._register(t.onProcessTitleChanged(r=>this._onProcessTitleChanged.fire(r))),this._register(t.onProcessShellTypeChanged(r=>this._onProcessShellTypeChanged.fire(r))),this._register(t.onProcessOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r))),this._register(t.onProcessResolvedShellLaunchConfig(r=>this._onProcessResolvedShellLaunchConfig.fire(r))),this._register(t.onProcessReplay(r=>this._onProcessReplay.fire(r))),this._register(t.onProcessOrphanQuestion(r=>this._onProcessOrphanQuestion.fire(r))),[d,t]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(d,o,s,t,r,i,a,u,c,l){const S=setTimeout(()=>this._handleUnresponsiveCreateProcess(),k.HeartbeatConstants.CreateProcessTimeout),w=await this._proxy.createProcess(d,o,s,t,r,i,a,u,c,l);return clearTimeout(S),C=Math.max(C,w),w}updateTitle(d,o,s){return this._proxy.updateTitle(d,o,s)}updateIcon(d,o,s){return this._proxy.updateIcon(d,o,s)}attachToProcess(d){return this._proxy.attachToProcess(d)}detachFromProcess(d){return this._proxy.detachFromProcess(d)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(d){return this._proxy.start(d)}shutdown(d,o){return this._proxy.shutdown(d,o)}input(d,o){return this._proxy.input(d,o)}processBinary(d,o){return this._proxy.processBinary(d,o)}resize(d,o,s){return this._proxy.resize(d,o,s)}acknowledgeDataEvent(d,o){return this._proxy.acknowledgeDataEvent(d,o)}getInitialCwd(d){return this._proxy.getInitialCwd(d)}getCwd(d){return this._proxy.getCwd(d)}getLatency(d){return this._proxy.getLatency(d)}orphanQuestionReply(d){return this._proxy.orphanQuestionReply(d)}getDefaultSystemShell(d){return this._proxy.getDefaultSystemShell(d)}async getProfiles(d,o,s=!1){return m.detectAvailableProfiles(d,o,s,this._configurationService,void 0,this._logService,this._resolveVariables.bind(this))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(d){return this._proxy.getWslPath(d)}setTerminalLayoutInfo(d){return this._proxy.setTerminalLayoutInfo(d)}async getTerminalLayoutInfo(d){return await this._proxy.getTerminalLayoutInfo(d)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier+k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${k.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(d){return new Promise(o=>{const s=++P;this._pendingResolveVariablesRequests.set(s,o),this._onPtyHostRequestResolveVariables.fire({id:s,originalText:d})})}async acceptPtyHostResolvedVariables(d,o){const s=this._pendingResolveVariablesRequests.get(d);s?(s(o),this._pendingResolveVariablesRequests.delete(d)):this._logService.warn(`Resolved variables received without matching request ${d}`)}};E=de([K(1,h.IConfigurationService),K(2,L.ILogService),K(3,n.ITelemetryService)],E),e.PtyHostService=E}),define(Z[52],ee([0,1,40]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(T,R,y,p){const n=v.setProperty(T,R,y,p)[0];return n&&(T=T.substring(0,n.offset)+n.content+T.substring(n.offset+n.length)),T}e.edit=L;function k(T,R,y){let p=y;for(;p>=0;){if(T.charAt(p)===R.charAt(R.length-1)&&R.length===1)return p+1;if(p--,R.length===2&&p>=0&&T.charAt(p)===R.charAt(0))return p+2}return 0}e.getLineStartOffset=k;function A(T,R,y){let p=y;for(;p>=0;)if(T.charAt(p)===R.charAt(R.length-1)&&R.length===1||(p++,R.length===2&&p>=0&&T.charAt(p)===R.charAt(1)))return p;return T.length-1}e.getLineEndOffset=A}),define(Z[185],ee([0,1,26,57]),function(G,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(m,h,b,f,C){var P,E;const I=[],d=[],o=[];if(!h){const j=m.filter(({identifier:$})=>C.every(V=>V.toLowerCase()!==$.id.toLowerCase()));return{local:{added:I,removed:d,updated:o},remote:j.length>0?{added:j,updated:[],removed:[],all:j}:null}}m=m.map(p),h=h.map(p),b=b?b.map(p):null;const s=new Map,t=j=>{j.uuid&&s.set(j.id.toLowerCase(),j.uuid)};m.forEach(({identifier:j})=>t(j)),h.forEach(({identifier:j})=>t(j)),b&&b.forEach(({identifier:j})=>t(j));const r=j=>{const $=j.identifier.uuid||s.get(j.identifier.id.toLowerCase());return $?`uuid:${$}`:`id:${j.identifier.id.toLowerCase()}`},i=(j,$)=>(j.set(r($),$),j),a=m.reduce(i,new Map),u=h.reduce(i,new Map),c=h.reduce((j,$)=>{const V=r($);$=v.deepClone($);const q=a.get(V);return q&&(q.installed&&($.installed=!0),$.version||($.version=q.version)),i(j,$)},new Map),l=b?b.reduce(i,new Map):null,S=f.reduce(i,new Map),w=C.reduce((j,$)=>{const V=s.get($.toLowerCase());return j.add(V?`uuid:${V}`:`id:${$.toLowerCase()}`)},new Set),g=A(a,u,w);if(g.added.size>0||g.removed.size>0||g.updated.size>0){const j=A(l,a,w),$=A(l,u,w),V=(q,z)=>{const H=a.get(q);if(H){const Q=u.get(q);return Object.assign(Object.assign({},z?Q:H),{version:(Q.version&&L.gt(Q.version,H.version),H.version),state:T(H,Q,l==null?void 0:l.get(q))})}};for(const q of $.removed.values()){const z=a.get(q);z&&d.push(z.identifier)}for(const q of $.added.values())if(j.added.has(q)){if(g.updated.has(q)){const z=V(q,!0);z&&(o.push(n(z,q)),c.set(q,z))}}else{const z=u.get(q);z.installed&&I.push(n(z,q))}for(const q of $.updated.values()){const z=V(q,!0);z&&(o.push(n(z,q)),c.set(q,z))}for(const q of j.added.values())$.added.has(q)||c.set(q,a.get(q));for(const q of j.updated.values())if(!$.removed.has(q)&&!$.updated.has(q)){const z=V(q,!1);z&&(((P=c.get(q))===null||P===void 0?void 0:P.installed)&&(z.installed=!0),c.set(q,z))}for(const q of j.removed.values())!S.has(q)&&!$.updated.has(q)&&((E=l==null?void 0:l.get(q))===null||E===void 0?void 0:E.installed)&&c.delete(q)}const U=[],F=A(u,c,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(F.added.size>0||F.updated.size>0||F.removed.size>0)&&c.forEach((j,$)=>U.push(n(j,$))),{local:{added:I,removed:d,updated:o},remote:U.length?{added:[...F.added].map(j=>c.get(j)),updated:[...F.updated].map(j=>c.get(j)),removed:[...F.removed].map(j=>u.get(j)),all:U}:null}}e.merge=k;function A(m,h,b,{checkInstalledProperty:f,checkVersionProperty:C}={checkInstalledProperty:!1,checkVersionProperty:!1}){const P=m?[...m.keys()].filter(s=>!b.has(s)):[],E=[...h.keys()].filter(s=>!b.has(s)),I=E.filter(s=>P.indexOf(s)===-1).reduce((s,t)=>(s.add(t),s),new Set),d=P.filter(s=>E.indexOf(s)===-1).reduce((s,t)=>(s.add(t),s),new Set),o=new Set;for(const s of P){if(d.has(s))continue;const t=m.get(s),r=h.get(s);(!r||t.disabled!==r.disabled||!y(t.state,r.state)||C&&t.version!==r.version||f&&t.installed!==r.installed)&&o.add(s)}return{added:I,removed:d,updated:o}}function T(m,h,b){const f=m.state,C=h.state,P=b==null?void 0:b.state;if(!h.version||f&&L.gt(m.version,h.version))return f;if(C&&L.gt(h.version,m.version)||!f)return C;if(!C)return f;const E=v.deepClone(f),I=P?R(P,C):{added:Object.keys(C).reduce((o,s)=>(o.add(s),o),new Set),removed:new Set,updated:new Set},d=P?R(P,f):{added:Object.keys(f).reduce((o,s)=>(o.add(s),o),new Set),removed:new Set,updated:new Set};for(const o of[...I.added.values(),...I.updated.values()])E[o]=C[o];for(const o of I.removed.values())d.updated.has(o)||delete E[o];return E}function R(m,h){const b=Object.keys(m),f=Object.keys(h),C=f.filter(I=>b.indexOf(I)===-1).reduce((I,d)=>(I.add(d),I),new Set),P=b.filter(I=>f.indexOf(I)===-1).reduce((I,d)=>(I.add(d),I),new Set),E=new Set;for(const I of b){if(P.has(I))continue;const d=m[I],o=h[I];v.equals(d,o)||E.add(I)}return{added:C,removed:P,updated:E}}function y(m={},h={}){const{added:b,removed:f,updated:C}=R(m,h);return b.size===0&&f.size===0&&C.size===0}function p(m){return Object.assign(Object.assign({},m),{disabled:!!m.disabled,installed:!!m.installed})}function n(m,h){const b={identifier:{id:m.identifier.id,uuid:h.startsWith("uuid:")?h.substring("uuid:".length):void 0}};return m.version&&(b.version=m.version),m.disabled&&(b.disabled=!0),m.installed&&(b.installed=!0),m.state&&(b.state=m.state),b}}),define(Z[85],ee([0,1,19,3,2,33,4,27,21]),function(G,e,v,L,k,A,T,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=T.createDecorator("IExtensionsStorageSyncService");const p=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let n=class et extends k.Disposable{constructor(h,b){super();this.storageService=h,this.productService=b,this._onDidChangeExtensionsStorage=this._register(new L.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(f=>this.onDidChangeStorageValue(f)))}static toKey(h){return`extensionKeys/${A.adoptToGalleryExtensionId(h.id)}@${h.version}`}static fromKey(h){const b=p.exec(h);if(b&&b[1])return{id:b[1],version:b[2]}}initialize(){const h=this.storageService.keys(0,1);for(const b of h){const f=et.fromKey(b);f&&this.extensionsWithKeysForSync.add(f.id.toLowerCase())}}onDidChangeStorageValue(h){if(h.scope!==0)return;if(this.extensionsWithKeysForSync.has(h.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const b=et.fromKey(h.key);if(b){this.extensionsWithKeysForSync.add(b.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(h,b){this.storageService.store(et.toKey(h),JSON.stringify(b),0,1)}getKeysForSync(h){var b;const f=(b=this.productService.extensionSyncedKeys)===null||b===void 0?void 0:b[h.id.toLowerCase()],C=this.storageService.get(et.toKey(h),0),P=C?JSON.parse(C):void 0;return P&&f?v.distinct([...P,...f]):P||f}};n=de([K(0,y.IStorageService),K(1,R.IProductService)],n),e.ExtensionsStorageSyncService=n}),define(Z[86],ee([0,1,19,23,4]),function(G,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=k.createDecorator("IIgnoredExtensionsManagementService");let A=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,y){let p=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return p=p.filter(n=>n!==R&&n!==`-${R}`),y&&p.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",p.length?p:void 0,1)}updateSynchronizedExtensions(R,y){let p=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return p=p.filter(n=>n!==R&&n!==`-${R}`),y&&p.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",p.length?p:void 0,1)}getIgnoredExtensions(R){const y=R.filter(h=>h.isMachineScoped).map(h=>h.identifier.id.toLowerCase()),p=this.getConfiguredIgnoredExtensions().map(h=>h.toLowerCase()),n=[],m=[];if(Array.isArray(p))for(const h of p)h.startsWith("-")?m.push(h.substring(1)):n.push(h);return v.distinct([...y,...n].filter(h=>m.indexOf(h)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(y=>y.toLowerCase())}};A=de([K(0,L.IConfigurationService)],A),e.IgnoredExtensionsManagementService=A}),define(Z[186],ee([0,1,26,32,19,143,52]),function(G,e,v,L,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(o){return L.parse(o)||[]}e.parseKeybindings=R;async function y(o,s,t,r,i){const a=R(o),u=R(s),c=t?R(t):null,l=[...a,...u,...c||[]].map(H=>H.key),S=await i.resolveUserBindings(l);let w=n(a,u,c,S);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:o,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:s,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};const g=h(a),U=h(u),F=c?h(c):null,j=f(g,U,S),$=F?f(F,g,S):{added:[...g.keys()].reduce((H,Q)=>(H.add(Q),H),new Set),removed:new Set,updated:new Set},V=F?f(F,U,S):{added:[...U.keys()].reduce((H,Q)=>(H.add(Q),H),new Set),removed:new Set,updated:new Set},q=p(j,$,V);let z=o;for(const H of q.removed.values())q.conflicts.has(H)||(z=I(z,H,r));for(const H of q.added.values()){if(q.conflicts.has(H))continue;const Q=U.get(H);if(Q.some(N=>N.command!==`-${H}`&&w.conflicts.has(S[N.key]))){q.conflicts.add(H);continue}z=E(z,Q,r)}for(const H of q.updated.values()){if(q.conflicts.has(H))continue;const Q=U.get(H);if(Q.some(N=>N.command!==`-${H}`&&w.conflicts.has(S[N.key]))){q.conflicts.add(H);continue}z=d(z,H,Q,r)}return{mergeContent:z,hasChanges:!0,hasConflicts:q.conflicts.size>0}}e.merge=y;function p(o,s,t){const r=new Set,i=new Set,a=new Set,u=new Set;for(const c of s.removed.values())t.updated.has(c)&&u.add(c);for(const c of t.removed.values())u.has(c)||(s.updated.has(c)?u.add(c):i.add(c));for(const c of s.added.values())u.has(c)||t.added.has(c)&&o.updated.has(c)&&u.add(c);for(const c of t.added.values())u.has(c)||(s.added.has(c)?o.updated.has(c)&&u.add(c):r.add(c));for(const c of s.updated.values())u.has(c)||t.updated.has(c)&&o.updated.has(c)&&u.add(c);for(const c of t.updated.values())u.has(c)||(s.updated.has(c)?o.updated.has(c)&&u.add(c):a.add(c));return{added:r,removed:i,updated:a,conflicts:u}}function n(o,s,t,r){const i=new Set,a=m(o,r),u=m(s,r),c=t?m(t,r):null,l=b(a,u);if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const S=c?b(c,a):{added:[...a.keys()].reduce(($,V)=>($.add(V),$),new Set),removed:new Set,updated:new Set};if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const w=c?b(c,u):{added:[...u.keys()].reduce(($,V)=>($.add(V),$),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:g,removed:U,updated:F,conflicts:j}=p(l,S,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:g,removed:U,updated:F,conflicts:j}}function m(o,s){const t=new Map;for(const r of o){const i=s[r.key];let a=t.get(i);a||(a=[],t.set(i,a)),a.push(r)}return t}function h(o){const s=new Map;for(const t of o){const r=t.command[0]==="-"?t.command.substring(1):t.command;let i=s.get(r);i||(i=[],s.set(r,i)),i.push(t)}return s}function b(o,s){const t=[...o.keys()],r=[...s.keys()],i=r.filter(c=>t.indexOf(c)===-1).reduce((c,l)=>(c.add(l),c),new Set),a=t.filter(c=>r.indexOf(c)===-1).reduce((c,l)=>(c.add(l),c),new Set),u=new Set;for(const c of t){if(a.has(c))continue;const l=o.get(c).map(w=>Object.assign(Object.assign({},w),{key:c})),S=s.get(c).map(w=>Object.assign(Object.assign({},w),{key:c}));k.equals(l,S,(w,g)=>P(w,g))||u.add(c)}return{added:i,removed:a,updated:u}}function f(o,s,t){const r=[...o.keys()],i=[...s.keys()],a=i.filter(l=>r.indexOf(l)===-1).reduce((l,S)=>(l.add(S),l),new Set),u=r.filter(l=>i.indexOf(l)===-1).reduce((l,S)=>(l.add(S),l),new Set),c=new Set;for(const l of r){if(u.has(l))continue;const S=o.get(l).map(g=>Object.assign(Object.assign({},g),{key:t[g.key]})),w=s.get(l).map(g=>Object.assign(Object.assign({},g),{key:t[g.key]}));C(S,w)||c.add(l)}return{added:a,removed:u,updated:c}}function C(o,s){return!(!k.equals(o.filter(({command:t})=>t[0]!=="-"),s.filter(({command:t})=>t[0]!=="-"),(t,r)=>P(t,r))||!k.equals(o.filter(({command:t})=>t[0]==="-"),s.filter(({command:t})=>t[0]==="-"),(t,r)=>P(t,r)))}function P(o,s){if(o.command!==s.command||o.key!==s.key)return!1;const t=A.ContextKeyExpr.deserialize(o.when),r=A.ContextKeyExpr.deserialize(s.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!v.equals(o.args,s.args))}function E(o,s,t){for(const r of s)o=T.edit(o,[-1],r,t);return o}function I(o,s,t){const r=R(o);for(let i=r.length-1;i>=0;i--)(r[i].command===s||r[i].command===`-${s}`)&&(o=T.edit(o,[i],void 0,t));return o}function d(o,s,t,r){const i=R(o),a=i.findIndex(u=>u.command===s||u.command===`-${s}`);for(let u=i.length-1;u>=0;u--)(i[u].command===s||i[u].command===`-${s}`)&&(o=T.edit(o,[u],void 0,r));for(let u=t.length-1;u>=0;u--)o=T.edit(o,[a],t[u],r);return o}}),define(Z[187],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function v(A,T,R){const y={},p={},n=new Set;if(!T)return{local:{added:y,updated:p,removed:[...n.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const m=L(A,T);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{local:{added:y,updated:p,removed:[...n.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const h=L(R,A),b=L(R,T),f={},C={},P=new Set,E=new Set;for(const I of h.removed.values())b.updated.has(I)?y[I]=T[I]:P.add(I);for(const I of b.removed.values())E.has(I)||(h.updated.has(I)?E.add(I):n.add(I));for(const I of h.updated.values())E.has(I)||(b.updated.has(I)?m.updated.has(I)&&E.add(I):C[I]=A[I]);for(const I of b.updated.values())E.has(I)||(h.updated.has(I)?m.updated.has(I)&&E.add(I):A[I]!==void 0&&(p[I]=T[I]));for(const I of h.added.values())E.has(I)||(b.added.has(I)?m.updated.has(I)&&E.add(I):f[I]=A[I]);for(const I of b.added.values())E.has(I)||(h.added.has(I)?m.updated.has(I)&&E.add(I):y[I]=T[I]);return{local:{added:y,removed:[...n.values()],updated:p},remote:{added:f,removed:[...P.values()],updated:C},conflicts:[...E.values()]}}e.merge=v;function L(A,T){const R=A?Object.keys(A):[],y=T?Object.keys(T):[],p=y.filter(h=>R.indexOf(h)===-1).reduce((h,b)=>(h.add(b),h),new Set),n=R.filter(h=>y.indexOf(h)===-1).reduce((h,b)=>(h.add(b),h),new Set),m=new Set;for(const h of R){if(n.has(h))continue;const b=A[h],f=T[h];b!==f&&m.add(h)}return{added:p,removed:n,updated:m}}function k(A,T){const{added:R,removed:y,updated:p}=L(A,T);return R.size===0&&y.size===0&&p.size===0}e.areSame=k}),define(Z[22],ee([0,1,4,28,31,37,127,80,12,19,16]),function(G,e,v,L,k,A,T,R,y,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function m(){const c=k.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(c).filter(l=>!!c[l].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=m;function h(){const c=k.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(c).filter(g=>!!c[g].ignoreSync),S=Object.keys(c).filter(g=>c[g].scope===2||c[g].scope===6),w=m();return p.distinct([e.CONFIGURATION_SYNC_STORE_KEY,...l,...S,...w])}e.getDefaultIgnoredSettings=h;function b(){const c="vscode://schemas/ignoredSettings",l=k.Registry.as(A.Extensions.Configuration);l.registerConfiguration({id:"settingsSync",order:30,title:T.localize(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:T.localize(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:T.localize(2,null),items:[{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN,errorMessage:T.localize(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:T.localize(4,null),default:[],scope:1,$ref:c,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const S=k.Registry.as(R.Extensions.JSONContribution),w=()=>{const g=m(),U=h().filter(V=>V!==e.CONFIGURATION_SYNC_STORE_KEY),F=Object.keys(A.allSettings.properties).filter(V=>U.indexOf(V)===-1),j=U.filter(V=>g.indexOf(V)===-1),$={items:{type:"string",enum:[...F,...j.map(V=>`-${V}`)]}};S.registerSchema(c,$)};return l.onDidUpdateConfiguration(()=>w())}e.registerConfiguration=b;function f(c){return c&&n.isObject(c)&&n.isString(c.id)&&n.isArray(c.scopes)}e.isAuthenticationProvider=f;var C;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Extensions="extensions",c.GlobalState="globalState"})(C=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function P(c,l,S){return S.joinPath(l.userDataSyncHome,c,`lastSync${c}.json`)}e.getLastSyncResourceUri=P,e.IUserDataSyncStoreManagementService=v.createDecorator("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=v.createDecorator("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=v.createDecorator("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function E(c){const l={};return l[e.HEADER_EXECUTION_ID]=c,l}e.createSyncHeaders=E;var I;(function(c){c.Unauthorized="Unauthorized",c.Conflict="Conflict",c.Gone="Gone",c.PreconditionFailed="PreconditionFailed",c.TooLarge="TooLarge",c.UpgradeRequired="UpgradeRequired",c.PreconditionRequired="PreconditionRequired",c.TooManyRequests="RemoteTooManyRequests",c.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",c.RequestFailed="RequestFailed",c.RequestCanceled="RequestCanceled",c.RequestTimeout="RequestTimeout",c.NoRef="NoRef",c.TurnedOff="TurnedOff",c.SessionExpired="SessionExpired",c.ServiceChanged="ServiceChanged",c.DefaultServiceChanged="DefaultServiceChanged",c.LocalTooManyRequests="LocalTooManyRequests",c.LocalPreconditionFailed="LocalPreconditionFailed",c.LocalInvalidContent="LocalInvalidContent",c.LocalError="LocalError",c.IncompatibleLocalContent="IncompatibleLocalContent",c.IncompatibleRemoteContent="IncompatibleRemoteContent",c.UnresolvedConflicts="UnresolvedConflicts",c.Unknown="Unknown"})(I=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class d extends Error{constructor(l,S,w,g){super(l);this.code=S,this.resource=w,this.operationId=g,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=d;class o extends d{constructor(l,S,w,g){super(l,w,void 0,g);this.url=S}}e.UserDataSyncStoreError=o;class s extends d{constructor(l,S){super(l,S)}}e.UserDataAutoSyncError=s,function(c){function l(S){if(S instanceof c)return S;const w=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(S.name);if(w&&w[1]){const g=w[2]==="unknown"?void 0:w[2],U=w[3]==="unknown"?void 0:w[3];return new c(S.message,w[1],g,U)}return new c(S.message,I.Unknown)}c.toUserDataSyncError=l}(d=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(c){c.Uninitialized="uninitialized",c.Idle="idle",c.Syncing="syncing",c.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var r;(function(c){c[c.None=0]="None",c[c.Added=1]="Added",c[c.Modified=2]="Modified",c[c.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var i;(function(c){c.Preview="preview",c.Conflict="conflict",c.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function a(c){return`sync.enable.${c}`}e.getEnablementKey=a,e.IUserDataSyncResourceEnablementService=v.createDecorator("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=v.createDecorator("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=v.createDecorator("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=v.createDecorator("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=v.createDecorator("IUserDataSyncUtilService"),e.IUserDataSyncLogService=v.createDecorator("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function u(c,l){if(c.scheme!==e.USER_DATA_SYNC_SCHEME)return c=c.with({scheme:l.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(S=>y.isEqualOrParent(c,y.joinPath(l.userDataSyncHome,S,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=u}),define(Z[45],ee([0,1,2,10,25,5,22,9,12,6,3,24,32,123,23,16,20,19,44,21,29]),function(G,e,v,L,k,A,T,R,y,p,n,m,h,b,f,C,P,E,I,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function s(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}e.isSyncData=s;let t=class extends v.Disposable{constructor(c,l,S,w,g,U,F,j,$,V){super();this.resource=c,this.fileService=l,this.environmentService=S,this.userDataSyncStoreService=g,this.userDataSyncBackupStoreService=U,this.userDataSyncResourceEnablementService=F,this.telemetryService=j,this.logService=$,this.configurationService=V,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new n.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new n.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new p.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new n.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=P.uppercaseFirstLetter(this.resource),this.extUri=this.fileService.hasCapability(S.userDataSyncHome,1024)?y.extUri:y.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(S.userDataSyncHome,c),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,T.PREVIEW_DIR_NAME),this.lastSyncResource=T.getLastSyncResourceUri(c,S,this.extUri),this.currentMachineIdPromise=I.getServiceMachineId(S,l,w)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const c=await this.syncPreviewPromise;this.syncPreviewPromise=null;const l=await this.performSync(c.remoteUserData,c.lastSyncUserData,!0);this.setStatus(l)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const c=await this.getLastSyncUserData();(c?(await this.doGenerateSyncResourcePreview(c,c,!0,o.CancellationToken.None)).resourcePreviews.some(({remoteChange:S})=>S!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(c){if(this._status!==c){const l=this._status;c==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),l==="hasConflicts"&&c==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=c,this._onDidChangStatus.fire(c)}}async sync(c,l={}){await this._sync(c,!0,l)}async preview(c,l={}){return this._sync(c,!1,l)}async apply(c,l={}){try{this.syncHeaders=Object.assign({},l);const S=await this.doApply(c);return this.setStatus(S),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(c,l,S){try{if(this.syncHeaders=Object.assign({},S),!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let w="idle";try{const g=await this.getLastSyncUserData(),U=await this.getLatestRemoteUserData(c,g);return w=await this.performSync(U,g,l),w==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):w==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(w)}}finally{this.syncHeaders={}}}async replace(c){const l=await this.resolveContent(c);if(!l)return!1;const S=this.parseSyncData(l);if(!S)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const w=await this.getLastSyncUserData(),g=await this.getLatestRemoteUserData(null,w),U=await this.isRemoteDataFromCurrentMachine(g),F=await this.generateSyncPreview({ref:g.ref,syncData:S},w,U,o.CancellationToken.None),j=[];for(const $ of F){const V=await this.getAcceptResult($,$.remoteResource,void 0,o.CancellationToken.None),{remoteChange:q}=await this.getAcceptResult($,$.previewResource,$.remoteContent,o.CancellationToken.None);j.push([$,Object.assign(Object.assign({},V),{remoteChange:q!==0?q:2})])}await this.applyResult(g,w,j,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(c){var l;const S=await this.currentMachineIdPromise;return!!((l=c.syncData)===null||l===void 0?void 0:l.machineId)&&c.syncData.machineId===S}async getLatestRemoteUserData(c,l){if(l){const S=c&&c.latest?c.latest[this.resource]:void 0;if(l.ref===S||S===void 0&&l.syncData===null)return l}return this.getRemoteUserData(l)}async performSync(c,l,S){if(c.syncData&&c.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new T.UserDataSyncError(b.localize(0,null,this.resource,this.version,c.syncData.version),T.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(c,l,S)}catch(w){if(w instanceof T.UserDataSyncError)switch(w.code){case T.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(c,l,S);case T.UserDataSyncErrorCode.Conflict:case T.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),c=await this.getRemoteUserData(null),l=await this.getLastSyncUserData(),this.performSync(c,l,S)}throw w}}async doSync(c,l,S){try{this.syncPreviewPromise||(this.syncPreviewPromise=p.createCancelablePromise(g=>this.doGenerateSyncResourcePreview(c,l,S,g)));const w=await this.syncPreviewPromise;return this.updateConflicts(w.resourcePreviews),w.resourcePreviews.some(({mergeState:g})=>g==="conflict")?"hasConflicts":S?await this.doApply(!1):"syncing"}catch(w){throw this.syncPreviewPromise=null,w}}async merge(c){return await this.updateSyncResourcePreview(c,async l=>{const S=await this.getMergeResult(l,o.CancellationToken.None);await this.fileService.writeFile(l.previewResource,k.VSBuffer.fromString((S==null?void 0:S.content)||""));const w=S&&!S.hasConflicts?await this.getAcceptResult(l,l.previewResource,void 0,o.CancellationToken.None):void 0;return l.acceptResult=w,l.mergeState=S.hasConflicts?"conflict":w?"accepted":"preview",l.localChange=w?w.localChange:S.localChange,l.remoteChange=w?w.remoteChange:S.remoteChange,l}),this.syncPreviewPromise}async accept(c,l){return await this.updateSyncResourcePreview(c,async S=>{const w=await this.getAcceptResult(S,c,l,o.CancellationToken.None);return S.acceptResult=w,S.mergeState="accepted",S.localChange=w.localChange,S.remoteChange=w.remoteChange,S}),this.syncPreviewPromise}async discard(c){return await this.updateSyncResourcePreview(c,async l=>{const S=await this.getMergeResult(l,o.CancellationToken.None);return await this.fileService.writeFile(l.previewResource,k.VSBuffer.fromString(S.content||"")),l.acceptResult=void 0,l.mergeState="preview",l.localChange=S.localChange,l.remoteChange=S.remoteChange,l}),this.syncPreviewPromise}async updateSyncResourcePreview(c,l){if(!this.syncPreviewPromise)return;let S=await this.syncPreviewPromise;const w=S.resourcePreviews.findIndex(({localResource:g,remoteResource:U,previewResource:F})=>this.extUri.isEqual(g,c)||this.extUri.isEqual(U,c)||this.extUri.isEqual(F,c));w!==-1&&(this.syncPreviewPromise=p.createCancelablePromise(async g=>{const U=[...S.resourcePreviews];return U[w]=await l(U[w]),Object.assign(Object.assign({},S),{resourcePreviews:U})}),S=await this.syncPreviewPromise,this.updateConflicts(S.resourcePreviews),S.resourcePreviews.some(({mergeState:g})=>g==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(c){if(!this.syncPreviewPromise)return"idle";const l=await this.syncPreviewPromise;return l.resourcePreviews.some(({mergeState:S})=>S==="conflict")?"hasConflicts":l.resourcePreviews.some(({mergeState:S})=>S!=="accepted")?"syncing":(await this.applyResult(l.remoteUserData,l.lastSyncUserData,l.resourcePreviews.map(S=>[S,S.acceptResult]),c),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(c){}}updateConflicts(c){const l=c.filter(({mergeState:S})=>S==="conflict");E.equals(this._conflicts,l,(S,w)=>this.extUri.isEqual(S.previewResource,w.previewResource))||(this._conflicts=l,this._onDidChangeConflicts.fire(l))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:l,ref:S})=>({created:l,uri:this.toRemoteBackupResource(S)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:l,ref:S})=>({created:l,uri:this.toLocalBackupResource(S)}))}toRemoteBackupResource(c){return A.URI.from({scheme:T.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${c}`})}toLocalBackupResource(c){return A.URI.from({scheme:T.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${c}`})}async getMachineId({uri:c}){const l=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(l))){const{content:S}=await this.getUserData(l);if(S){const w=this.parseSyncData(S);return w==null?void 0:w.machineId}}}async resolveContent(c){const l=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(l))){const{content:S}=await this.getUserData(l);return S}return this.extUri.isEqual(c,this.toLocalBackupResource(l))?this.userDataSyncBackupStoreService.resolveContent(this.resource,l):null}async resolvePreviewContent(c){const l=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(l)for(const S of l.resourcePreviews){if(this.extUri.isEqual(S.acceptedResource,c))return S.acceptResult?S.acceptResult.content:null;if(this.extUri.isEqual(S.remoteResource,c))return S.remoteContent;if(this.extUri.isEqual(S.localResource,c))return S.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(c){}}async doGenerateSyncResourcePreview(c,l,S,w){const g=await this.isRemoteDataFromCurrentMachine(c),U=await this.generateSyncPreview(c,l,g,w),F=[];for(const j of U){const $=j.previewResource.with({scheme:T.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(j.localChange===0&&j.remoteChange===0)F.push(Object.assign(Object.assign({},j),{acceptedResource:$,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"}));else{const V=S?await this.getMergeResult(j,w):void 0;if(w.isCancellationRequested)break;await this.fileService.writeFile(j.previewResource,k.VSBuffer.fromString((V==null?void 0:V.content)||""));const q=V&&!V.hasConflicts?await this.getAcceptResult(j,j.previewResource,void 0,w):void 0;F.push(Object.assign(Object.assign({},j),{acceptResult:q,mergeState:(V==null?void 0:V.hasConflicts)?"conflict":q?"accepted":"preview",localChange:q?q.localChange:V?V.localChange:j.localChange,remoteChange:q?q.remoteChange:V?V.remoteChange:j.remoteChange}))}}return{remoteUserData:c,lastSyncUserData:l,resourcePreviews:F,isLastSyncFromCurrentMachine:g}}async getLastSyncUserData(){try{const c=await this.fileService.readFile(this.lastSyncResource),l=JSON.parse(c.value.toString()),S=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=l.version&&S&&l.version!==S,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${l.version} is not compatible with current sync state version ${S}.`),await this.resetLocal(),null;const w=l;if(w.content===null)return{ref:l.ref,syncData:null};const g=JSON.parse(w.content);if(s(g))return Object.assign(Object.assign({},l),{syncData:g,content:void 0})}catch(c){c instanceof L.FileOperationError&&c.fileOperationResult===1||this.logService.error(c)}return null}async updateLastSyncUserData(c,l={}){if(l.ref||l.content||l.version)throw new Error("Cannot have core properties as additional");const S=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),w=Object.assign({ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,version:S},l);await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(w)))}async getRemoteUserData(c){const{ref:l,content:S}=await this.getUserData(c);let w=null;return S!==null&&(w=this.parseSyncData(S)),{ref:l,syncData:w}}parseSyncData(c){try{const l=JSON.parse(c);if(s(l))return l}catch(l){this.logService.error(l)}throw new T.UserDataSyncError(b.localize(1,null),T.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(c){if(C.isString(c)){const l=await this.userDataSyncStoreService.resolveContent(this.resource,c);return{ref:c,content:l}}else{const l=c?{ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,l,this.syncHeaders)}}async updateRemoteUserData(c,l){const S=await this.currentMachineIdPromise,w={version:this.version,machineId:S,content:c};return l=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(w),l,this.syncHeaders),{ref:l,syncData:w}}async backupLocal(c){const l={version:this.version,content:c};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(l))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};t=de([K(1,L.IFileService),K(2,R.IEnvironmentService),K(3,d.IStorageService),K(4,T.IUserDataSyncStoreService),K(5,T.IUserDataSyncBackupStoreService),K(6,T.IUserDataSyncResourceEnablementService),K(7,m.ITelemetryService),K(8,T.IUserDataSyncLogService),K(9,f.IConfigurationService)],t),e.AbstractSynchroniser=t;let r=class extends t{constructor(c,l,S,w,g,U,F,j,$,V,q){super(l,S,w,g,U,F,j,$,V,q);this.file=c,this._register(this.fileService.watch(this.extUri.dirname(c))),this._register(this.fileService.onDidFilesChange(z=>this.onFileChanges(z)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(c){return null}}async updateLocalFileContent(c,l,S){try{l?await this.fileService.writeFile(this.file,k.VSBuffer.fromString(c),S?void 0:l):await this.fileService.createFile(this.file,k.VSBuffer.fromString(c),{overwrite:S})}catch(w){throw w instanceof L.FileOperationError&&w.fileOperationResult===1||w instanceof L.FileOperationError&&w.fileOperationResult===3?new T.UserDataSyncError(w.message,T.UserDataSyncErrorCode.LocalPreconditionFailed):w}}onFileChanges(c){!c.contains(this.file)||this.triggerLocalChange()}};r=de([K(2,L.IFileService),K(3,R.IEnvironmentService),K(4,d.IStorageService),K(5,T.IUserDataSyncStoreService),K(6,T.IUserDataSyncBackupStoreService),K(7,T.IUserDataSyncResourceEnablementService),K(8,m.ITelemetryService),K(9,T.IUserDataSyncLogService),K(10,f.IConfigurationService)],r),e.AbstractFileSynchroniser=r;let i=class extends r{constructor(c,l,S,w,g,U,F,j,$,V,q,z){super(c,l,S,w,g,U,F,j,$,V,z);this.userDataSyncUtilService=q,this._formattingOptions=void 0}hasErrors(c){const l=[];return h.parse(c,l,{allowEmptyContent:!0,allowTrailingComma:!0}),l.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};i=de([K(2,L.IFileService),K(3,R.IEnvironmentService),K(4,d.IStorageService),K(5,T.IUserDataSyncStoreService),K(6,T.IUserDataSyncBackupStoreService),K(7,T.IUserDataSyncResourceEnablementService),K(8,m.ITelemetryService),K(9,T.IUserDataSyncLogService),K(10,T.IUserDataSyncUtilService),K(11,f.IConfigurationService)],i),e.AbstractJsonFileSynchroniser=i;let a=class{constructor(c,l,S,w){this.resource=c,this.environmentService=l,this.logService=S,this.fileService=w,this.extUri=this.fileService.hasCapability(l.userDataSyncHome,1024)?y.extUri:y.extUriIgnorePathCase,this.lastSyncResource=T.getLastSyncResourceUri(this.resource,l,y.extUri)}async initialize({ref:c,content:l}){if(!l){this.logService.info("Remote content does not exist.",this.resource);return}const S=this.parseSyncData(l);if(!S)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:c,syncData:S})}catch(g){this.logService.error(g)}}parseSyncData(c){try{const l=JSON.parse(c);if(s(l))return l}catch(l){this.logService.error(l)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(c,l={}){const S=Object.assign({ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null},l);await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(S)))}};a=de([K(1,R.IEnvironmentService),K(2,T.IUserDataSyncLogService),K(3,L.IFileService)],a),e.AbstractInitializer=a}),define(Z[188],ee([0,1,22,3,9,28,33,10,23,185,45,24,5,46,40,20,21,86,11,85,6]),function(G,e,v,L,k,A,T,R,y,p,n,m,h,b,f,C,P,E,I,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function s(u,c){const l=JSON.parse(u.content);if(u.version===1||u.version===2){const S=(await c.getInstalled(0)).filter(w=>w.isBuiltin);for(const w of l)u.version===1&&(w.enabled===!1&&(w.disabled=!0),delete w.enabled),u.version===2&&S.every(g=>!T.areSameExtensions(g.identifier,w.identifier))&&(w.installed=!0)}return l}function t(u,c,l){const S=l.get(T.getExtensionId(u,c),0)||"{}";return JSON.parse(S)}e.getExtensionStorageState=t;function r(u,c,l,S){S.store(T.getExtensionId(u,c),JSON.stringify(l),0,1)}e.storeExtensionStorageState=r;let i=class ct extends n.AbstractSynchroniser{constructor(c,l,S,w,g,U,F,j,$,V,q,z,H,Q){super("extensions",l,c,S,w,g,z,H,$,q);this.storageService=S,this.extensionManagementService=U,this.extensionEnablementService=F,this.ignoredExtensionsManagementService=j,this.extensionGalleryService=V,this.extensionsStorageSyncService=Q,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.debounce(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtension,N=>!!N.gallery),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,N=>!N.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(c,l){const S=c.syncData?await s(c.syncData,this.extensionManagementService):null,w=(l==null?void 0:l.skippedExtensions)||[],g=(l==null?void 0:l.syncData)?await s(l.syncData,this.extensionManagementService):null,U=await this.extensionManagementService.getInstalled(),F=this.getLocalExtensions(U),j=this.ignoredExtensionsManagementService.getIgnoredExtensions(U);S?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:$,remote:V}=p.merge(F,S,g,w,j),q={local:$,remote:V,content:this.getPreviewContent(F,$.added,$.updated,$.removed),localChange:$.added.length>0||$.removed.length>0||$.updated.length>0?2:0,remoteChange:V!==null?2:0};return[{skippedExtensions:w,localResource:this.localResource,localContent:this.format(F),localExtensions:F,remoteResource:this.remoteResource,remoteContent:S?this.format(S):null,previewResource:this.previewResource,previewResult:q,localChange:q.localChange,remoteChange:q.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(c,l,S,w){const g=[...l,...S],U=new Set,F=j=>{U.add(j.id.toLowerCase()),j.uuid&&U.add(j.uuid)};g.forEach(({identifier:j})=>F(j)),w.forEach(F);for(const j of c)U.has(j.identifier.id.toLowerCase())||j.identifier.uuid&&U.has(j.identifier.uuid)||g.push(j);return this.format(g)}async getMergeResult(c,l){return Object.assign(Object.assign({},c.previewResult),{hasConflicts:!1})}async getAcceptResult(c,l,S,w){if(this.extUri.isEqual(l,this.localResource))return this.acceptLocal(c);if(this.extUri.isEqual(l,this.remoteResource))return this.acceptRemote(c);if(this.extUri.isEqual(l,this.previewResource))return c.previewResult;throw new Error(`Invalid Resource: ${l.toString()}`)}async acceptLocal(c){const l=await this.extensionManagementService.getInstalled(),S=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),w=p.merge(c.localExtensions,null,null,c.skippedExtensions,S),{local:g,remote:U}=w;return{content:c.localContent,local:g,remote:U,localChange:g.added.length>0||g.removed.length>0||g.updated.length>0?2:0,remoteChange:U!==null?2:0}}async acceptRemote(c){const l=await this.extensionManagementService.getInstalled(),S=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),w=c.remoteContent?JSON.parse(c.remoteContent):null;if(w!==null){const g=p.merge(c.localExtensions,w,c.localExtensions,[],S),{local:U,remote:F}=g;return{content:c.remoteContent,local:U,remote:F,localChange:U.added.length>0||U.removed.length>0||U.updated.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:c.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(c,l,S,w){let{skippedExtensions:g,localExtensions:U}=S[0][0],{local:F,remote:j,localChange:$,remoteChange:V}=S[0][1];if($===0&&V===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),$!==0&&(await this.backupLocal(JSON.stringify(U)),g=await this.updateLocalExtensions(F.added,F.removed,F.updated,g)),j){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const q=JSON.stringify(j.all);c=await this.updateRemoteUserData(q,w?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${j.added.length?` Added: ${JSON.stringify(j.added.map(z=>z.identifier.id))}.`:""}${j.updated.length?` Updated: ${JSON.stringify(j.updated.map(z=>z.identifier.id))}.`:""}${j.removed.length?` Removed: ${JSON.stringify(j.removed.map(z=>z.identifier.id))}.`:""}`)}(l==null?void 0:l.ref)!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(c,{skippedExtensions:g}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${g.length?` Skipped: ${JSON.stringify(g.map(q=>q.identifier.id))}.`:""}`))}async getAssociatedResources({uri:c}){return[{resource:this.extUri.joinPath(c,"extensions.json"),comparableResource:ct.EXTENSIONS_DATA_URI}]}async resolveContent(c){if(this.extUri.isEqual(c,ct.EXTENSIONS_DATA_URI)){const S=await this.extensionManagementService.getInstalled(),w=this.ignoredExtensionsManagementService.getIgnoredExtensions(S),g=this.getLocalExtensions(S).filter(U=>!w.some(F=>T.areSameExtensions({id:F},U.identifier)));return this.format(g)}if(this.extUri.isEqual(this.remoteResource,c)||this.extUri.isEqual(this.localResource,c)||this.extUri.isEqual(this.acceptedResource,c))return this.resolvePreviewContent(c);let l=await super.resolveContent(c);if(l)return l;if(l=await super.resolveContent(this.extUri.dirname(c)),l){const S=this.parseSyncData(l);if(S)switch(this.extUri.basename(c)){case"extensions.json":return this.format(this.parseExtensions(S))}}return null}format(c){c.sort((w,g)=>!w.identifier.uuid&&g.identifier.uuid?-1:w.identifier.uuid&&!g.identifier.uuid?1:C.compare(w.identifier.id,g.identifier.id));const l=JSON.stringify(c),S=b.format(l,void 0,{});return f.applyEdits(l,S)}async hasLocalData(){try{const c=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(c).some(S=>S.installed||S.disabled))return!0}catch(c){}return!1}async updateLocalExtensions(c,l,S,w){const g=[],U=[],F=await this.extensionManagementService.getInstalled();if(l.length){const $=F.filter(({identifier:V,isBuiltin:q})=>!q&&l.some(z=>T.areSameExtensions(V,z)));await o.Promises.settled($.map(async V=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,V.identifier.id),await this.extensionManagementService.uninstall(V,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,V.identifier.id),g.push(V.identifier)}))}(c.length||S.length)&&await o.Promises.settled([...c,...S].map(async $=>{const V=F.find(z=>T.areSameExtensions(z.identifier,$.identifier));if(V&&V.isBuiltin){$.state&&V.manifest.version===$.version&&this.updateExtensionState($.state,V.manifest.publisher,V.manifest.name,V.manifest.version),$.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,$.identifier.id),await this.extensionEnablementService.disableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,$.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,$.identifier.id),await this.extensionEnablementService.enableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,$.identifier.id)),g.push($.identifier);return}const q=await this.extensionGalleryService.getCompatibleExtension($.identifier);if($.state&&(V?V.manifest.version===$.version:!!q)){const z=V?V.manifest.publisher:q.publisher,H=V?V.manifest.name:q.name;this.updateExtensionState($.state,z,H,V==null?void 0:V.manifest.version)}if(q)try{$.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,$.identifier.id,q.version),await this.extensionEnablementService.disableExtension(q.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,$.identifier.id,q.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,$.identifier.id,q.version),await this.extensionEnablementService.enableExtension(q.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,$.identifier.id,q.version)),V||(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,$.identifier.id,q.version),await this.extensionManagementService.installFromGallery(q,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,$.identifier.id,q.version),g.push(q.identifier))}catch(z){U.push($),this.logService.error(z),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,q.displayName||q.identifier.id)}else U.push($)}));const j=[];for(const $ of w)g.some(V=>T.areSameExtensions(V,$.identifier))||j.push($);for(const $ of U)j.some(V=>T.areSameExtensions(V.identifier,$.identifier))||j.push($);return j}updateExtensionState(c,l,S,w){const g=t(l,S,this.storageService),U=w?this.extensionsStorageSyncService.getKeysForSync({id:T.getGalleryExtensionId(l,S),version:w}):void 0;U?U.forEach(F=>{g[F]=c[F]}):Object.keys(c).forEach(F=>g[F]=c[F]),r(l,S,g,this.storageService)}parseExtensions(c){return JSON.parse(c.content)}getLocalExtensions(c){const l=this.extensionEnablementService.getDisabledExtensions();return c.map(({identifier:S,isBuiltin:w,manifest:g})=>{const U={identifier:S,version:g.version};l.some(F=>T.areSameExtensions(F,S))&&(U.disabled=!0),w||(U.installed=!0);try{const F=this.extensionsStorageSyncService.getKeysForSync({id:S.id,version:g.version});if(F){const j=t(g.publisher,g.name,this.storageService);U.state=Object.keys(j).reduce(($,V)=>(F.includes(V)&&($[V]=j[V]),$),{})}}catch(F){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,I.getErrorMessage(F))}return U})}};i.EXTENSIONS_DATA_URI=h.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=de([K(0,k.IEnvironmentService),K(1,R.IFileService),K(2,P.IStorageService),K(3,v.IUserDataSyncStoreService),K(4,v.IUserDataSyncBackupStoreService),K(5,A.IExtensionManagementService),K(6,A.IGlobalExtensionEnablementService),K(7,E.IIgnoredExtensionsManagementService),K(8,v.IUserDataSyncLogService),K(9,A.IExtensionGalleryService),K(10,y.IConfigurationService),K(11,v.IUserDataSyncResourceEnablementService),K(12,m.ITelemetryService),K(13,d.IExtensionsStorageSyncService)],i),e.ExtensionsSynchroniser=i;let a=class extends n.AbstractInitializer{constructor(c,l,S,w,g){super("extensions",w,g,S);this.extensionManagementService=c,this.ignoredExtensionsManagementService=l}async parseExtensions(c){return c.syncData?await s(c.syncData,this.extensionManagementService):null}generatePreview(c,l){const S=[],w=[],g=[];for(const U of c){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(U.identifier.id))continue;const F=l.find(j=>T.areSameExtensions(j.identifier,U.identifier));F?(S.push(F),U.disabled&&g.push(U.identifier)):U.installed&&(w.push(U.identifier),U.disabled&&g.push(U.identifier))}return{installedExtensions:S,newExtensions:w,disabledExtensions:g,remoteExtensions:c}}};a=de([K(0,A.IExtensionManagementService),K(1,E.IIgnoredExtensionsManagementService),K(2,R.IFileService),K(3,k.IEnvironmentService),K(4,v.IUserDataSyncLogService)],a),e.AbstractExtensionsInitializer=a}),define(Z[189],ee([0,1,26,22]),function(G,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(R,y,p,n,m){if(!y)return{remote:Object.keys(R).length>0?R:null,local:{added:{},removed:[],updated:{}}};const h=A(R,y);if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const b=p?A(p,y):{added:Object.keys(y).reduce((I,d)=>(I.add(d),I),new Set),removed:new Set,updated:new Set},f=p?A(p,R):{added:Object.keys(R).reduce((I,d)=>(I.add(d),I),new Set),removed:new Set,updated:new Set},C={added:{},removed:[],updated:{}},P=v.deepClone(y),E=!p;for(const I of f.added.values())I!==L.SYNC_SERVICE_URL_TYPE&&E&&b.added.has(I)||(P[I]=R[I]);for(const I of f.updated.values())P[I]=R[I];for(const I of f.removed.values())n.unregistered.includes(I)||delete P[I];for(const I of b.added.values()){const d=y[I];if(n.machine.includes(I)){m.info(`GlobalState: Skipped adding ${I} in local storage because it is declared as machine scoped.`);continue}if(p&&f.added.has(I))continue;const o=R[I];o&&o.value===d.value||I===L.SYNC_SERVICE_URL_TYPE&&E&&f.added.has(I)||(o?C.updated[I]=d:C.added[I]=d)}for(const I of b.updated.values()){const d=y[I];if(n.machine.includes(I)){m.info(`GlobalState: Skipped updating ${I} in local storage because it is declared as machine scoped.`);continue}if(f.updated.has(I)||f.removed.has(I))continue;const o=R[I];o&&o.value===d.value||(C.updated[I]=d)}for(const I of b.removed.values()){if(n.machine.includes(I)){m.trace(`GlobalState: Skipped removing ${I} in local storage because it is declared as machine scoped.`);continue}f.updated.has(I)||f.removed.has(I)||C.removed.push(I)}return{local:C,remote:T(P,y)?null:P}}e.merge=k;function A(R,y){const p=Object.keys(R),n=Object.keys(y),m=n.filter(f=>p.indexOf(f)===-1).reduce((f,C)=>(f.add(C),f),new Set),h=p.filter(f=>n.indexOf(f)===-1).reduce((f,C)=>(f.add(C),f),new Set),b=new Set;for(const f of p){if(h.has(f))continue;const C=R[f],P=y[f];v.equals(C,P)||b.add(f)}return{added:m,removed:h,updated:b}}function T(R,y){const{added:p,removed:n,updated:m}=A(R,y);return p.size===0&&n.size===0&&m.size===0}}),define(Z[190],ee([0,1,22,25,3,9,10,52,189,32,45,24,23,5,46,40,21,7,44,30,15]),function(G,e,v,L,k,A,T,R,y,p,n,m,h,b,f,C,P,E,I,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const s="globalState.argv.",t=["locale"];function r(l){const S=l.storage?Object.keys(l.storage).sort():[],w={};S.forEach(F=>w[F]=l.storage[F]),l.storage=w;const g=JSON.stringify(l),U=f.format(g,void 0,{});return C.applyEdits(g,U)}const i=1;let a=class lt extends n.AbstractSynchroniser{constructor(S,w,g,U,F,j,$,V,q){super("globalState",S,F,q,w,g,j,$,U,V);this.storageService=q,this.version=i,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(S.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(k.Event.any(k.Event.filter(S.onDidFilesChange,z=>z.contains(this.environmentService.argvResource)),k.Event.filter(q.onDidChangeValue,z=>z.scope===0&&z.target!==void 0?z.target===0:q.keys(0,0).includes(z.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(S,w,g,U){const F=S.syncData?JSON.parse(S.syncData.content):null;w=w===null&&g?S:w;const j=w&&w.syncData?JSON.parse(w.syncData.content):null,$=await this.getLocalGlobalState();F?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const V=this.getStorageKeys(j),{local:q,remote:z}=y.merge($.storage,F?F.storage:null,j?j.storage:null,V,this.logService),H={content:null,local:q,remote:z,localChange:Object.keys(q.added).length>0||Object.keys(q.updated).length>0||q.removed.length>0?2:0,remoteChange:z!==null?2:0};return[{localResource:this.localResource,localContent:r($),localUserData:$,remoteResource:this.remoteResource,remoteContent:F?r(F):null,previewResource:this.previewResource,previewResult:H,localChange:H.localChange,remoteChange:H.remoteChange,acceptedResource:this.acceptedResource,storageKeys:V}]}async getMergeResult(S,w){return Object.assign(Object.assign({},S.previewResult),{hasConflicts:!1})}async getAcceptResult(S,w,g,U){if(this.extUri.isEqual(w,this.localResource))return this.acceptLocal(S);if(this.extUri.isEqual(w,this.remoteResource))return this.acceptRemote(S);if(this.extUri.isEqual(w,this.previewResource))return S.previewResult;throw new Error(`Invalid Resource: ${w.toString()}`)}async acceptLocal(S){return{content:S.localContent,local:{added:{},removed:[],updated:{}},remote:S.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(S){if(S.remoteContent!==null){const w=JSON.parse(S.remoteContent),{local:g,remote:U}=y.merge(S.localUserData.storage,w.storage,null,S.storageKeys,this.logService);return{content:S.remoteContent,local:g,remote:U,localChange:Object.keys(g.added).length>0||Object.keys(g.updated).length>0||g.removed.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:S.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(S,w,g,U){let{localUserData:F}=g[0][0],{local:j,remote:$,localChange:V,remoteChange:q}=g[0][1];if(V===0&&q===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),V!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(F)),await this.writeLocalGlobalState(j),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),q!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const z=JSON.stringify({storage:$});S=await this.updateRemoteUserData(z,U?null:S.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}(w==null?void 0:w.ref)!==S.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(S),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:S}){return[{resource:this.extUri.joinPath(S,"globalState.json"),comparableResource:lt.GLOBAL_STATE_DATA_URI}]}async resolveContent(S){if(this.extUri.isEqual(S,lt.GLOBAL_STATE_DATA_URI)){const g=await this.getLocalGlobalState();return r(g)}if(this.extUri.isEqual(this.remoteResource,S)||this.extUri.isEqual(this.localResource,S)||this.extUri.isEqual(this.acceptedResource,S))return this.resolvePreviewContent(S);let w=await super.resolveContent(S);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(S)),w){const g=this.parseSyncData(w);if(g)switch(this.extUri.basename(S)){case"globalState.json":return r(JSON.parse(g.content))}}return null}async hasLocalData(){var S;try{const{storage:w}=await this.getLocalGlobalState();if(Object.keys(w).length>1||((S=w[`${s}.locale`])===null||S===void 0?void 0:S.value)!=="en")return!0}catch(w){}return!1}async getLocalGlobalState(){const S={},w=await this.getLocalArgvContent(),g=p.parse(w);for(const U of t)g[U]!==void 0&&(S[`${s}${U}`]={version:1,value:g[U]});for(const U of this.storageService.keys(0,0)){const F=this.storageService.get(U,0);F&&(S[U]={version:1,value:F})}return{storage:S}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(S){}return"{}"}async writeLocalGlobalState({added:S,removed:w,updated:g}){const U={},F={},j=(V,q)=>{for(const z of V){if(z.startsWith(s)){U[z.substring(s.length)]=q?q[z].value:void 0;continue}if(q){const H=q[z];H.value!==String(this.storageService.get(z,0))&&(F[z]=H.value)}else this.storageService.get(z,0)!==void 0&&(F[z]=void 0)}};if(j(Object.keys(S),S),j(Object.keys(g),g),j(w),Object.keys(U).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(U),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(F).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const V of Object.keys(F))this.storageService.store(V,F[V],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(F))}}async updateArgv(S){const w=await this.getLocalArgvContent();let g=w;for(const U of Object.keys(S))g=R.edit(g,[U],S[U],{});w!==g&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(g)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(S){const w=this.storageService.keys(0,0),g=this.storageService.keys(0,1),U=[...w,...g],F=(S==null?void 0:S.storage)?Object.keys(S.storage).filter(j=>!j.startsWith(s)&&!U.includes(j)&&this.storageService.get(j,0)!==void 0):[];if(!E.isWeb){const j=[...v.ALL_SYNC_RESOURCES.map($=>v.getEnablementKey($)),v.SYNC_SERVICE_URL_TYPE];F.push(...j),g.push(...j)}return{user:w,machine:g,unregistered:F}}};a.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),a=de([K(0,T.IFileService),K(1,v.IUserDataSyncStoreService),K(2,v.IUserDataSyncBackupStoreService),K(3,v.IUserDataSyncLogService),K(4,A.IEnvironmentService),K(5,v.IUserDataSyncResourceEnablementService),K(6,m.ITelemetryService),K(7,h.IConfigurationService),K(8,P.IStorageService)],a),e.GlobalStateSynchroniser=a;let u=class extends n.AbstractInitializer{constructor(S,w,g,U){super("globalState",g,U,w);this.storageService=S}async doInitialize(S){const w=S.syncData?JSON.parse(S.syncData.content):null;if(!w){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const g={},U={};for(const F of Object.keys(w.storage))F.startsWith(s)?g[F.substring(s.length)]=w.storage[F].value:this.storageService.get(F,0)===void 0&&(U[F]=w.storage[F].value);if(Object.keys(g).length){let F="{}";try{F=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(j){}for(const j of Object.keys(g))F=R.edit(F,[j],g[j],{});await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(F))}if(Object.keys(U).length)for(const F of Object.keys(U))this.storageService.store(F,U[F],0,0)}};u=de([K(0,P.IStorageService),K(1,T.IFileService),K(2,A.IEnvironmentService),K(3,v.IUserDataSyncLogService)],u),e.GlobalStateInitializer=u;let c=class{constructor(S,w,g,U,F){this.userDataSyncStoreClient=S,this.storageService=w,this.environmentService=g,this.fileService=U,this.logService=F}getSyncStoreType(S){var w;const g=this.parseGlobalState(S);return(w=g==null?void 0:g.storage[v.SYNC_SERVICE_URL_TYPE])===null||w===void 0?void 0:w.value}async sync(S){const w=v.createSyncHeaders(d.generateUuid());try{return await this.doSync(S,w)}catch(g){if(g instanceof v.UserDataSyncError)switch(g.code){case v.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(S,w)}throw g}}async doSync(S,w){const g=await this.userDataSyncStoreClient.read("globalState",null,w),U=this.parseGlobalState(g)||{storage:{}};U.storage[v.SYNC_SERVICE_URL_TYPE]={value:S,version:i};const F=await I.getServiceMachineId(this.environmentService,this.fileService,this.storageService),j={version:i,machineId:F,content:r(U)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(j),g.ref,w)}parseGlobalState({content:S}){if(!S)return null;const w=JSON.parse(S);if(n.isSyncData(w))return w?JSON.parse(w.content):null;throw new Error("Invalid remote data")}};c=de([K(1,P.IStorageService),K(2,A.IEnvironmentService),K(3,T.IFileService),K(4,o.ILogService)],c),e.UserDataSyncStoreTypeSynchronizer=c}),define(Z[191],ee([0,1,10,22,186,32,124,9,23,7,16,19,45,24,21,25,3]),function(G,e,v,L,k,A,T,R,y,p,n,m,h,b,f,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function E(o,s){const t=JSON.parse(o);if(!s)return n.isUndefined(t.all)?null:t.all;switch(p.OS){case 2:return n.isUndefined(t.mac)?null:t.mac;case 3:return n.isUndefined(t.linux)?null:t.linux;case 1:return n.isUndefined(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=E;let I=class extends h.AbstractJsonFileSynchroniser{constructor(s,t,r,i,a,u,c,l,S,w){super(c.keybindingsResource,"keybindings",u,c,l,s,t,a,w,r,S,i);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(P.Event.filter(i.onDidChangeConfiguration,g=>g.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(s,t,r,i){const a=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null;t=t===null&&r?s:t;const u=t?this.getKeybindingsContentFromLastSyncUserData(t):null,c=await this.getLocalFileContent(),l=await this.getFormattingOptions();let S=null,w=!1,g=!1,U=!1;if(a){let j=c?c.value.toString():"[]";if(j=j||"[]",this.hasErrors(j))throw new L.UserDataSyncError(T.localize(0,null),L.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!u||u!==j||u!==a){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const $=await k.merge(j,a,u,l,this.userDataSyncUtilService);$.hasChanges&&(S=$.mergeContent,U=$.hasConflicts,w=U||$.mergeContent!==j,g=U||$.mergeContent!==a)}}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),S=c.value.toString(),g=!0);const F={content:S,localChange:w?c?2:1:0,remoteChange:g?2:0,hasConflicts:U};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:a,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async getMergeResult(s,t){return s.previewResult}async getAcceptResult(s,t,r,i){if(this.extUri.isEqual(t,this.localResource))return{content:s.fileContent?s.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:s.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(s,t,r,i){var a;const{fileContent:u}=r[0][0];let{content:c,localChange:l,remoteChange:S}=r[0][1];if(l===0&&S===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),c!==null&&(c=c.trim(),c=c||"[]",this.hasErrors(c)))throw new L.UserDataSyncError(T.localize(1,null),L.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),u&&await this.backupLocal(this.toSyncContent(u.value.toString())),await this.updateLocalFileContent(c||"[]",u,i),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),S!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const w=this.toSyncContent(c||"[]",(a=s.syncData)===null||a===void 0?void 0:a.content);s=await this.updateRemoteUserData(w,i?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(w){}(t==null?void 0:t.ref)!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(s,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const t=A.parse(s.value.toString());if(m.isNonEmptyArray(t))return!0}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"keybindings.json"),comparableResource:t}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s))return this.resolvePreviewContent(s);let t=await super.resolveContent(s);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(s)),t){const r=this.parseSyncData(t);if(r)switch(this.extUri.basename(s)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(r.content)}}return null}getKeybindingsContentFromLastSyncUserData(s){return!s.syncData||s.platformSpecific!==void 0&&s.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(s.syncData.content)}getKeybindingsContentFromSyncContent(s){try{return E(s,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(s,t){let r={};try{r=JSON.parse(t||"{}")}catch(i){this.logService.error(i)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=s,p.OS){case 2:r.mac=s;break;case 3:r.linux=s;break;case 1:r.windows=s;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){let s=this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return s!==void 0||(s=this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,s!==void 0)?s:this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};I=de([K(0,L.IUserDataSyncStoreService),K(1,L.IUserDataSyncBackupStoreService),K(2,L.IUserDataSyncLogService),K(3,y.IConfigurationService),K(4,L.IUserDataSyncResourceEnablementService),K(5,v.IFileService),K(6,R.IEnvironmentService),K(7,f.IStorageService),K(8,L.IUserDataSyncUtilService),K(9,b.ITelemetryService)],I),e.KeybindingsSynchroniser=I;let d=class extends h.AbstractInitializer{constructor(s,t,r){super("keybindings",t,r,s)}async doInitialize(s){const t=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,C.VSBuffer.fromString(t)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.environmentService.settingsResource),t=A.parse(s.value.toString());return!m.isNonEmptyArray(t)}catch(s){return s.fileOperationResult===1}}getKeybindingsContentFromSyncContent(s){try{return E(s,!0)}catch(t){return this.logService.error(t),null}}};d=de([K(0,v.IFileService),K(1,R.IEnvironmentService),K(2,L.IUserDataSyncLogService)],d),e.KeybindingsInitializer=d}),define(Z[192],ee([0,1,26,32,40,46,52,22,19]),function(G,e,v,L,k,A,T,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function p(c,l,S){let w=[];S?w=m(S):w=n(l);const g=[],U=[...R.getDisallowedIgnoredSettings()];if(Array.isArray(w))for(const F of w)F.startsWith("-")?U.push(F.substring(1)):g.push(F);return y.distinct([...c,...g].filter(F=>U.indexOf(F)===-1))}e.getIgnoredSettings=p;function n(c){let l=c.inspect("settingsSync.ignoredSettings").userValue;return l!==void 0||(l=c.inspect("sync.ignoredSettings").userValue,l!==void 0)?l:c.getValue("settingsSync.ignoredSettings")||[]}function m(c){const l=L.parse(c);return l?l["settingsSync.ignoredSettings"]||l["sync.ignoredSettings"]||[]:[]}function h(c,l,S,w){if(S.length){const g=u(l),U=L.parse(l),F=L.parse(c),j=[];for(const $ of S){const V=U[$],q=F[$];V===void 0?c=T.edit(c,[$],void 0,w):q!==void 0?c=T.edit(c,[$],V,w):j.push(s($,g))}j.sort(($,V)=>$.startOffset-V.startOffset),j.forEach($=>c=E($.setting.key,l,c,w))}return c}e.updateIgnoredSettings=h;function b(c,l,S,w,g,U){const F=h(c,l,w,U),j=S!==F,$=S!==l;if(!j&&!$)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(j&&!$)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if($&&!j)return{conflictsSettings:[],localContent:h(l,c,w,U),remoteContent:null,hasConflicts:!1};if(S===null&&C(c)){const ie=f(c,l,w)?null:h(l,c,w,U);return{conflictsSettings:[],localContent:ie,remoteContent:null,hasConflicts:!1}}let V=c,q=l;const z=L.parse(c),H=L.parse(l),Q=S?L.parse(S):null,N=w.reduce((ie,ce)=>(ie.add(ce),ie),new Set),O=P(z,H,N),D=P(Q,z,N),M=P(Q,H,N),_=new Map,x=new Set,B=ie=>{x.add(ie);const ce=g.filter(({key:le})=>le===ie)[0];ce?(V=T.edit(V,[ie],ce.value,U),q=T.edit(q,[ie],ce.value,U)):_.set(ie,{key:ie,localValue:z[ie],remoteValue:H[ie]})};for(const ie of D.removed.values())M.updated.has(ie)?B(ie):q=T.edit(q,[ie],void 0,U);for(const ie of M.removed.values())x.has(ie)||(D.updated.has(ie)?B(ie):V=T.edit(V,[ie],void 0,U));for(const ie of D.updated.values())x.has(ie)||(M.updated.has(ie)?O.updated.has(ie)&&B(ie):q=T.edit(q,[ie],z[ie],U));for(const ie of M.updated.values())x.has(ie)||(D.updated.has(ie)?O.updated.has(ie)&&B(ie):V=T.edit(V,[ie],H[ie],U));for(const ie of D.added.values())x.has(ie)||(M.added.has(ie)?O.updated.has(ie)&&B(ie):q=E(ie,V,q,U));for(const ie of M.added.values())x.has(ie)||(D.added.has(ie)?O.updated.has(ie)&&B(ie):V=E(ie,q,V,U));const J=_.size>0||!f(V,q,w),X=J||!f(V,c,[]),te=J||!f(q,l,[]);return{localContent:X?V:null,remoteContent:te?q:null,conflictsSettings:[..._.values()],hasConflicts:J}}e.merge=b;function f(c,l,S){if(c===l)return!0;const w=L.parse(c),g=L.parse(l),U=S.reduce(($,V)=>($.add(V),$),new Set),F=u(c).filter($=>!($.setting&&U.has($.setting.key))),j=u(l).filter($=>!($.setting&&U.has($.setting.key)));if(F.length!==j.length)return!1;for(let $=0;$<F.length;$++){const V=F[$],q=j[$];if(V.setting&&q.setting){if(V.setting.key!==q.setting.key||!v.equals(w[V.setting.key],g[V.setting.key]))return!1}else if(!V.setting&&!q.setting){if(V.value!==q.value)return!1}else return!1}return!0}e.areSame=f;function C(c){return c?u(c).length===0:!0}e.isEmpty=C;function P(c,l,S){const w=c?Object.keys(c).filter($=>!S.has($)):[],g=Object.keys(l).filter($=>!S.has($)),U=g.filter($=>w.indexOf($)===-1).reduce(($,V)=>($.add(V),$),new Set),F=w.filter($=>g.indexOf($)===-1).reduce(($,V)=>($.add(V),$),new Set),j=new Set;if(c)for(const $ of w){if(F.has($))continue;const V=c[$],q=l[$];v.equals(V,q)||j.add($)}return{added:U,removed:F,updated:j}}function E(c,l,S,w){const g=L.parse(l),U=u(l),F=u(S),j=I(c,U,F);return d(S,c,g[c],j,F,w)}e.addSetting=E;function I(c,l,S){const w=l.findIndex(U=>{var F;return((F=U.setting)===null||F===void 0?void 0:F.key)===c}),g=l[w-1];if(g){if(g.setting){const F=s(g.setting.key,S);if(F)return{index:S.indexOf(F),insertAfter:!0}}else{const F=t(w,l);if(F){const j=s(F.setting.key,S);if(j){const $=r(S.indexOf(j),S),V=i(l,F,l[w]);if($){const q=i(S,j,$),z=a(V,q);return z?{index:S.indexOf(z),insertAfter:!0}:{index:S.indexOf($),insertAfter:!1}}else{const q=i(S,j,S[S.length-1]),z=a(V,q);return z?{index:S.indexOf(z),insertAfter:!0}:{index:S.length-1,insertAfter:!0}}}}}const U=l[w+1];if(U)if(U.setting){const F=s(U.setting.key,S);if(F)return{index:S.indexOf(F),insertAfter:!1}}else{const F=r(w,l);if(F){const j=s(F.setting.key,S);if(j){const $=t(S.indexOf(j),S),V=i(l,l[w],F);if($){const q=i(S,$,j),z=a(V.reverse(),q.reverse());return z?{index:S.indexOf(z),insertAfter:!1}:{index:S.indexOf($),insertAfter:!0}}else{const q=i(S,S[0],j),z=a(V.reverse(),q.reverse());return z?{index:S.indexOf(z),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:S.length-1,insertAfter:!0}}function d(c,l,S,w,g,U){let F;return w.index===-1?F=k.setProperty(c,[l],S,U):F=o(c,l,S,w,g,U).map(j=>k.withFormatting(c,j,U)[0]),k.applyEdits(c,F)}function o(c,l,S,w,g,U){var F;const j=`${JSON.stringify(l)}: ${JSON.stringify(S)}`,$=A.getEOL(U,c),V=g[w.index];if(w.insertAfter){const q=[];if(V.setting)q.push({offset:V.endOffset,length:0,content:","+j});else{const z=r(w.index,g),H=t(w.index,g),Q=(F=H==null?void 0:H.setting)===null||F===void 0?void 0:F.commaOffset;H&&Q===void 0&&q.push({offset:H.endOffset,length:0,content:","});const N=Q!==void 0&&Q>V.endOffset;q.push({offset:N?Q+1:V.endOffset,length:0,content:z?$+j+",":$+j})}return q}else{if(V.setting)return[{offset:V.startOffset,length:0,content:j+","}];const q=(g[w.index-1]&&!g[w.index-1].setting?$:"")+j+(r(w.index,g)?",":"")+$;return[{offset:V.startOffset,length:0,content:q}]}}function s(c,l){return l.filter(S=>{var w;return((w=S.setting)===null||w===void 0?void 0:w.key)===c})[0]}function t(c,l){for(let S=c-1;S>=0;S--)if(l[S].setting)return l[S]}function r(c,l){for(let S=c+1;S<l.length;S++)if(l[S].setting)return l[S]}function i(c,l,S){const w=c.indexOf(l),g=c.indexOf(S);return c.filter((U,F)=>w<F&&F<g)}function a(c,l){if(c.length&&l.length){let S=0;for(;S<l.length&&S<c.length;S++)if(c[S].value!==l[S].value)return l[S-1];return l[S-1]}}function u(c){const l=[];let S=-1,w,g;const U={onObjectBegin:F=>{S++},onObjectProperty:(F,j,$)=>{S===0&&(w=j,g=F)},onObjectEnd:(F,j)=>{S--,S===0&&l.push({startOffset:w,endOffset:F+j,value:c.substring(w,F+j),setting:{key:g,commaOffset:void 0}})},onArrayBegin:(F,j)=>{S++},onArrayEnd:(F,j)=>{S--,S===0&&l.push({startOffset:w,endOffset:F+j,value:c.substring(w,F+j),setting:{key:g,commaOffset:void 0}})},onLiteralValue:(F,j,$)=>{S===0&&l.push({startOffset:w,endOffset:j+$,value:c.substring(w,j+$),setting:{key:g,commaOffset:void 0}})},onSeparator:(F,j,$)=>{if(S===0&&F===","){let V=l.length-1;for(;V>=0&&!l[V].setting;V--);const q=l[V];q&&l.splice(V,1,{startOffset:q.startOffset,endOffset:q.endOffset,value:q.value,setting:{key:q.setting.key,commaOffset:j}})}},onComment:(F,j)=>{S===0&&l.push({startOffset:F,endOffset:F+j,value:c.substring(F,F+j)})}};return L.visit(c,U),l}}),define(Z[193],ee([0,1,10,22,25,125,3,9,23,192,52,45,24,28,21,40]),function(G,e,v,L,k,A,T,R,y,p,n,m,h,b,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function P(s){return s&&s.settings&&typeof s.settings=="string"&&Object.keys(s).length===1}function E(s){const t=JSON.parse(s);return P(t)?t:{settings:s}}e.parseSettingsSyncContent=E;let I=class extends m.AbstractJsonFileSynchroniser{constructor(t,r,i,a,u,c,l,S,w,g,U){super(r.settingsResource,"settings",t,r,i,a,u,w,g,c,l,S);this.extensionManagementService=U,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,r,i,a){const u=await this.getLocalFileContent(),c=await this.getFormattingOptions(),l=this.getSettingsSyncContent(t);r=r===null&&i?t:r;const S=r?this.getSettingsSyncContent(r):null,w=await this.getIgnoredSettings();let g=null,U=!1,F=!1,j=!1;if(l){let V=u?u.value.toString().trim():"{}";V=V||"{}",this.validateContent(V),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const q=p.merge(V,l.settings,S?S.settings:null,w,[],c);g=q.localContent||q.remoteContent,U=q.localContent!==null,F=q.remoteContent!==null,j=q.hasConflicts}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),g=u.value.toString(),F=!0);const $={content:g,localChange:U?2:0,remoteChange:F?2:0,hasConflicts:j};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:$.localChange,remoteResource:this.remoteResource,remoteContent:l?l.settings:null,remoteChange:$.remoteChange,previewResource:this.previewResource,previewResult:$,acceptedResource:this.acceptedResource}]}async getMergeResult(t,r){const i=await this.getFormattingOptions(),a=await this.getIgnoredSettings();return Object.assign(Object.assign({},t.previewResult),{content:t.previewResult.content?p.updateIgnoredSettings(t.previewResult.content,"{}",a,i):null})}async getAcceptResult(t,r,i,a){const u=await this.getFormattingOptions(),c=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?p.updateIgnoredSettings(t.fileContent.value.toString(),"{}",c,u):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?p.updateIgnoredSettings(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",c,u):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return i===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:i!==null?p.updateIgnoredSettings(i,t.fileContent?t.fileContent.value.toString():"{}",c,u):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,i,a){const{fileContent:u}=i[0][0];let{content:c,localChange:l,remoteChange:S}=i[0][1];if(l===0&&S===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),c=c?c.trim():"{}",c=c||"{}",this.validateContent(c),l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),u&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(u.value.toString()))),await this.updateLocalFileContent(c,u,a),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),S!==0){const w=await this.getFormattingOptions(),g=this.getSettingsSyncContent(t),U=await this.getIgnoredSettings(c);c=p.updateIgnoredSettings(c,g?g.settings:"{}",U,w),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(c)),a?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(w){}(r==null?void 0:r.ref)!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=await this.getFormattingOptions(),i=n.edit(t.value.toString(),[L.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!p.isEmpty(i)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const i=this.parseSyncData(r);if(i){const a=this.parseSettingsSyncContent(i.content);if(a)switch(this.extUri.basename(t)){case"settings.json":return a.settings}}}return null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const i=await this.getFormattingOptions(),a=await this.getIgnoredSettings();r=p.updateIgnoredSettings(r,"{}",a,i)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return E(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtension,a=>!!a.gallery),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,a=>!a.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return p.getIgnoredSettings(r,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new L.UserDataSyncError(A.localize(0,null),L.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const r=JSON.parse(t.value.toString());if(!o(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const i=this.parseSettingsSyncContent(r.content);if(!i||!i.settings)return;let a=i.settings;const u=await this.getFormattingOptions();for(const c in r)if(["version","content","machineId"].indexOf(c)===-1&&r[c]!==void 0){const l=C.setProperty(a,[c],r[c],u);l.length&&(a=C.applyEdits(a,l))}await this.fileService.writeFile(this.file,k.VSBuffer.fromString(a))}catch(t){}}};I=de([K(0,v.IFileService),K(1,R.IEnvironmentService),K(2,f.IStorageService),K(3,L.IUserDataSyncStoreService),K(4,L.IUserDataSyncBackupStoreService),K(5,L.IUserDataSyncLogService),K(6,L.IUserDataSyncUtilService),K(7,y.IConfigurationService),K(8,L.IUserDataSyncResourceEnablementService),K(9,h.ITelemetryService),K(10,b.IExtensionManagementService)],I),e.SettingsSynchroniser=I;let d=class extends m.AbstractInitializer{constructor(t,r,i){super("settings",r,i,t)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,k.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return p.isEmpty(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return E(t)}catch(r){this.logService.error(r)}return null}};d=de([K(0,v.IFileService),K(1,R.IEnvironmentService),K(2,L.IUserDataSyncLogService)],d),e.SettingsInitializer=d;function o(s){return!!(s&&s.version!==void 0&&typeof s.version=="number"&&s.content!==void 0&&typeof s.content=="string"&&s.machineId!==void 0&&typeof s.machineId=="string")}}),define(Z[194],ee([0,1,22,9,10,23,45,24,25,187,21,26,3]),function(G,e,v,L,k,A,T,R,y,p,n,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let b=class extends T.AbstractSynchroniser{constructor(P,E,I,d,o,s,t,r,i){super("snippets",E,P,I,d,o,r,i,s,t);this.version=1,this.snippetsFolder=P.snippetsHome,this._register(this.fileService.watch(P.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(h.Event.filter(this.fileService.onDidFilesChange,a=>a.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(P,E,I,d){const o=await this.getSnippetsFileContents(),s=this.toSnippetsContents(o),t=P.syncData?this.parseSnippets(P.syncData):null;E=E===null&&I?P:E;const r=E&&E.syncData?this.parseSnippets(E.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=p.merge(s,t,r);return this.getResourcePreviews(i,o,t||{})}async getMergeResult(P,E){return P.previewResult}async getAcceptResult(P,E,I,d){if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:P.fileContent?P.fileContent.value.toString():null,localChange:0,remoteChange:P.fileContent?P.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:P.remoteContent,localChange:P.remoteContent!==null?P.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder))return I===void 0?{content:P.previewResult.content,localChange:P.previewResult.localChange,remoteChange:P.previewResult.remoteChange}:{content:I,localChange:I===null?P.fileContent!==null?3:0:2,remoteChange:I===null?P.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${E.toString()}`)}async applyResult(P,E,I,d){const o=I.map(([s,t])=>Object.assign(Object.assign({},s),{acceptResult:t}));o.every(({localChange:s,remoteChange:t})=>s===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:s})=>s!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,d)),o.some(({remoteChange:s})=>s!==0)&&(P=await this.updateRemoteSnippets(o,P,d)),(E==null?void 0:E.ref)!==P.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(P),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:s}of o)try{await this.fileService.del(s)}catch(t){}}getResourcePreviews(P,E,I){const d=new Map;for(const o of Object.keys(P.local.added)){const s={content:P.local.added[o],hasConflicts:!1,localChange:1,remoteChange:0};d.set(o,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(P.local.updated)){const s={content:P.local.updated[o],hasConflicts:!1,localChange:2,remoteChange:0};d.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[o],localContent:E[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of P.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0};d.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[o],localContent:E[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(P.remote.added)){const s={content:P.remote.added[o],hasConflicts:!1,localChange:0,remoteChange:1};d.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[o],localContent:E[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(P.remote.updated)){const s={content:P.remote.updated[o],hasConflicts:!1,localChange:0,remoteChange:2};d.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[o],localContent:E[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of P.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};d.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of P.conflicts){const s={content:E[o]?E[o].value.toString():null,hasConflicts:!0,localChange:E[o]?2:1,remoteChange:I[o]?2:1};d.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[o]||null,localContent:E[o]?E[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(E))if(!d.has(o)){const s={content:E[o]?E[o].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};d.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[o]||null,localContent:E[o]?E[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...d.values()]}async getAssociatedResources({uri:P}){let E=await super.resolveContent(P);if(E){const I=this.parseSyncData(E);if(I){const d=this.parseSnippets(I),o=[];for(const s of Object.keys(d)){const t=this.extUri.joinPath(P,s),r=this.extUri.joinPath(this.snippetsFolder,s),i=await this.fileService.exists(r);o.push({resource:t,comparableResource:i?r:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"})})}return o}}return[]}async resolveContent(P){if(this.extUri.isEqualOrParent(P,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(P,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(P,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(P);let E=await super.resolveContent(P);if(E)return E;if(E=await super.resolveContent(this.extUri.dirname(P)),E){const I=this.parseSyncData(E);if(I)return this.parseSnippets(I)[this.extUri.basename(P)]||null}return null}async hasLocalData(){try{const P=await this.getSnippetsFileContents();if(Object.keys(P).length)return!0}catch(P){}return!1}async updateLocalBackup(P){const E={};for(const I of P)I.fileContent&&(E[this.extUri.basename(I.localResource)]=I.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(E)))}async updateLocalSnippets(P,E){for(const{fileContent:I,acceptResult:d,localResource:o,remoteResource:s,localChange:t}of P)if(t!==0){const r=s?this.extUri.basename(s):this.extUri.basename(o),i=this.extUri.joinPath(this.snippetsFolder,r);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(i)),await this.fileService.del(i),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(i))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(i)),await this.fileService.createFile(i,y.VSBuffer.fromString(d.content),{overwrite:E}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(i))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(i)),await this.fileService.writeFile(i,y.VSBuffer.fromString(d.content),E?void 0:I),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(i)))}}async updateRemoteSnippets(P,E,I){const d=E.syncData?this.parseSnippets(E.syncData):{},o=m.deepClone(d);for(const{acceptResult:s,localResource:t,remoteResource:r,remoteChange:i}of P)if(i!==0){const a=t?this.extUri.basename(t):this.extUri.basename(r);i===3?delete o[a]:o[a]=s.content}return p.areSame(d,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),E=await this.updateRemoteUserData(JSON.stringify(o),I?null:E.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),E}parseSnippets(P){return JSON.parse(P.content)}toSnippetsContents(P){const E={};for(const I of Object.keys(P))E[I]=P[I].value.toString();return E}async getSnippetsFileContents(){const P={};let E;try{E=await this.fileService.resolve(this.snippetsFolder)}catch(I){if(I instanceof k.FileOperationError&&I.fileOperationResult===1)return P;throw I}for(const I of E.children||[]){const d=I.resource,o=this.extUri.extname(d);if(o===".json"||o===".code-snippets"){const s=this.extUri.relativePath(this.snippetsFolder,d),t=await this.fileService.readFile(d);P[s]=t}}return P}};b=de([K(0,L.IEnvironmentService),K(1,k.IFileService),K(2,n.IStorageService),K(3,v.IUserDataSyncStoreService),K(4,v.IUserDataSyncBackupStoreService),K(5,v.IUserDataSyncLogService),K(6,A.IConfigurationService),K(7,v.IUserDataSyncResourceEnablementService),K(8,R.ITelemetryService)],b),e.SnippetsSynchroniser=b;let f=class extends T.AbstractInitializer{constructor(P,E,I){super("snippets",E,I,P)}async doInitialize(P){const E=P.syncData?JSON.parse(P.syncData.content):null;if(!E){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const d of Object.keys(E)){const o=E[d];if(o){const s=this.extUri.joinPath(this.environmentService.snippetsHome,d);await this.fileService.createFile(s,y.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(s))}}await this.updateLastSyncUserData(P)}async isEmpty(){var P;try{return!((P=(await this.fileService.resolve(this.environmentService.snippetsHome)).children)===null||P===void 0?void 0:P.length)}catch(E){return E.fileOperationResult===1}}};f=de([K(0,k.IFileService),K(1,L.IEnvironmentService),K(2,v.IUserDataSyncLogService)],f),e.SnippetsInitializer=f}),define(Z[60],ee([0,1,4,3,2,22]),function(G,e,v,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=v.createDecorator("IUserDataSyncAccountService");let T=class extends k.Disposable{constructor(y){super();this.userDataSyncStoreService=y,this._onDidChangeAccount=this._register(new L.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(y.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(y.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(y){(y&&this._account?y.token!==this._account.token||y.authenticationProviderId!==this._account.authenticationProviderId:y!==this._account)&&(this._account=y,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(y))}};T=de([K(0,A.IUserDataSyncStoreService)],T),e.UserDataSyncAccountService=T}),define(Z[195],ee([0,1,2,22,12,23,10,9,55,25,6]),function(G,e,v,L,k,A,T,R,y,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let m=class extends v.Disposable{constructor(b,f,C,P){super();this.environmentService=b,this.fileService=f,this.configurationService=C,this.logService=P,L.ALL_SYNC_RESOURCES.forEach(E=>this.cleanUpBackup(E))}async getAllRefs(b){const f=k.joinPath(this.environmentService.userDataSyncHome,b),C=await this.fileService.resolve(f);return C.children?C.children.filter(E=>E.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(E.name)).sort().reverse().map(E=>({ref:E.name,created:this.getCreationTime(E)})):[]}async resolveContent(b,f){if(!f){const C=await this.getAllRefs(b);C.length&&(f=C[C.length-1].ref)}if(f){const C=k.joinPath(this.environmentService.userDataSyncHome,b,f);return(await this.fileService.readFile(C)).value.toString()}return null}async backup(b,f){const C=k.joinPath(this.environmentService.userDataSyncHome,b),P=k.joinPath(C,`${y.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(P,p.VSBuffer.fromString(f))}catch(E){this.logService.error(E)}try{this.cleanUpBackup(b)}catch(E){}}async cleanUpBackup(b){const f=k.joinPath(this.environmentService.userDataSyncHome,b);try{try{if(!await this.fileService.exists(f))return}catch(P){return}const C=await this.fileService.resolve(f);if(C.children){const P=C.children.filter(o=>o.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(o.name)).sort(),E=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let I=P.filter(o=>Date.now()-this.getCreationTime(o)>E);const d=P.length-I.length;d<10&&(I=I.slice(10-d)),await n.Promises.settled(I.map(async o=>{this.logService.info("Deleting from backup",o.resource.path),await this.fileService.del(o.resource)}))}}catch(C){this.logService.error(C)}}getCreationTime(b){return b.ctime||new Date(parseInt(b.name.substring(0,4)),parseInt(b.name.substring(4,6))-1,parseInt(b.name.substring(6,8)),parseInt(b.name.substring(9,11)),parseInt(b.name.substring(11,13)),parseInt(b.name.substring(13,15))).getTime()}};m=de([K(0,R.IEnvironmentService),K(1,T.IFileService),K(2,A.IConfigurationService),K(3,L.IUserDataSyncLogService)],m),e.UserDataSyncBackupStoreService=m}),define(Z[196],ee([0,1,5,2]),function(G,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class k{constructor(h){this.service=h}listen(h,b){switch(b){case"onError":return this.service.onError}throw new Error(`Event not found: ${b}`)}call(h,b,f){switch(b){case"triggerSync":return this.service.triggerSync(f[0],f[1],f[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(f[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=k;class A{constructor(h){this.service=h}listen(h,b){throw new Error(`Event not found: ${b}`)}call(h,b,f){switch(b){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(f[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(v.URI.revive(f[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=A;class T{constructor(h){this.channel=h}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(h){return this.channel.call("resolveUserKeybindings",[h])}async resolveFormattingOptions(h){return this.channel.call("resolveFormattingOptions",[h])}}e.UserDataSyncUtilServiceClient=T;class R{constructor(h){this.service=h}listen(h,b){switch(b){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${b}`)}async call(h,b,f){switch(b){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(f[0],f[1]);case"setEnablement":return this.service.setEnablement(f[0],f[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class y{constructor(h){this.service=h}listen(h,b){switch(b){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${b}`)}call(h,b,f){switch(b){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(f)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=y;class p{constructor(h){this.service=h}listen(h,b){switch(b){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${b}`)}call(h,b,f){switch(b){case"switch":return this.service.switch(f[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=p;class n extends L.Disposable{constructor(h){super();this.channel=h,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(h){return this.channel.call("switch",[h])}async getPreviousUserDataSyncStore(){const h=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(h)}revive(h){return{url:v.URI.revive(h.url),type:h.type,defaultUrl:v.URI.revive(h.defaultUrl),insidersUrl:v.URI.revive(h.insidersUrl),stableUrl:v.URI.revive(h.stableUrl),canSwitch:h.canSwitch,authenticationProviders:h.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=n}),define(Z[197],ee([0,1,15,9]),function(G,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let k=class extends v.AbstractLogger{constructor(T,R){super();this.logger=this._register(T.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(T,...R){this.logger.trace(T,...R)}debug(T,...R){this.logger.debug(T,...R)}info(T,...R){this.logger.info(T,...R)}warn(T,...R){this.logger.warn(T,...R)}error(T,...R){this.logger.error(T,...R)}critical(T,...R){this.logger.critical(T,...R)}flush(){this.logger.flush()}};k=de([K(0,v.ILoggerService),K(1,L.IEnvironmentService)],k),e.UserDataSyncLogService=k}),define(Z[61],ee([0,1,4,2,44,9,10,21,22,128,27,7,20,3]),function(G,e,v,L,k,A,T,R,y,p,n,m,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=v.createDecorator("IUserDataSyncMachinesService");const f="sync.currentMachineName";let C=class Ke extends L.Disposable{constructor(E,I,d,o,s,t){super();this.storageService=d,this.userDataSyncStoreService=o,this.logService=s,this.productService=t,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=k.getServiceMachineId(E,I,d)}async getMachines(E){const I=await this.currentMachineIdPromise;return(await this.readMachinesData(E)).machines.map(o=>Object.assign(Object.assign({},o),{isCurrent:o.id===I}))}async addCurrentMachine(E){const I=await this.currentMachineIdPromise,d=await this.readMachinesData(E);d.machines.some(({id:o})=>o===I)||(d.machines.push({id:I,name:this.computeCurrentMachineName(d.machines)}),await this.writeMachinesData(d))}async removeCurrentMachine(E){const I=await this.currentMachineIdPromise,d=await this.readMachinesData(E),o=d.machines.filter(({id:s})=>s!==I);o.length!==d.machines.length&&(d.machines=o,await this.writeMachinesData(d))}async renameMachine(E,I,d){const o=await this.currentMachineIdPromise,s=await this.readMachinesData(d),t=s.machines.find(({id:r})=>r===E);t&&(t.name=I,await this.writeMachinesData(s),s.machines.some(({id:r})=>r===o)&&this.storageService.store(f,I,0,1))}async setEnablement(E,I){const d=await this.readMachinesData(),o=d.machines.find(({id:s})=>s===E);o&&(o.disabled=I?void 0:!0,await this.writeMachinesData(d))}computeCurrentMachineName(E){const I=this.storageService.get(f,0);if(I)return I;const d=`${this.productService.nameLong} (${m.PlatformToString(m.isWeb?0:m.platform)})`,o=new RegExp(`${h.escapeRegExpCharacters(d)}\\s#(\\d+)`);let s=0;for(const t of E){const r=o.exec(t.name),i=r?parseInt(r[1]):0;s=i>s?i:s}return`${d} #${s+1}`}async readMachinesData(E){this.userData=await this.readUserData(E);const I=this.parse(this.userData);if(I.version!==Ke.VERSION)throw new Error(p.localize(0,null,this.productService.nameLong));return I}async writeMachinesData(E){var I;const d=JSON.stringify(E),o=await this.userDataSyncStoreService.write(Ke.RESOURCE,d,((I=this.userData)===null||I===void 0?void 0:I.ref)||null);this.userData={ref:o,content:d},this._onDidChange.fire()}async readUserData(E){if(this.userData){const I=E&&E.latest?E.latest[Ke.RESOURCE]:void 0;if(this.userData.ref===I)return this.userData;if(I===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ke.RESOURCE,this.userData)}parse(E){if(E.content!==null)try{return JSON.parse(E.content)}catch(I){this.logService.error(I)}return{version:Ke.VERSION,machines:[]}}};C.VERSION=1,C.RESOURCE="machines",C=de([K(0,A.IEnvironmentService),K(1,T.IFileService),K(2,R.IStorageService),K(3,y.IUserDataSyncStoreService),K(4,y.IUserDataSyncLogService),K(5,n.IProductService)],C),e.UserDataSyncMachinesService=C}),define(Z[87],ee([0,1,6,3,2,22,60,24,11,21,9,61,126,55,5,12,7,27]),function(G,e,v,L,k,A,T,R,y,p,n,m,h,b,f,C,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const I="sync.enable",d="sync.disableMachineEventually",o="sync.sessionId",s="sync.storeUrl",t="sync.productQuality";let r=class extends k.Disposable{constructor(c,l,S){super();this.storageService=c,this.environmentService=l,this.userDataSyncStoreManagementService=S,this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(c.onDidChangeValue(w=>this.onDidStorageChange(w)))}isEnabled(c){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(I,0,!!c)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(c){c&&!this.canToggleEnablement()||this.storageService.store(I,c,0,1)}onDidStorageChange(c){if(c.scope===0&&I===c.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};r=de([K(0,p.IStorageService),K(1,n.IEnvironmentService),K(2,A.IUserDataSyncStoreManagementService)],r),e.UserDataAutoSyncEnablementService=r;let i=class extends k.Disposable{constructor(c,l,S,w,g,U,F,j,$,V,q){var z;super();this.userDataSyncStoreManagementService=l,this.userDataSyncStoreService=S,this.userDataSyncResourceEnablementService=w,this.userDataSyncService=g,this.logService=U,this.userDataSyncAccountService=F,this.telemetryService=j,this.userDataSyncMachinesService=$,this.storageService=V,this.autoSync=this._register(new k.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=q,this.syncTriggerDelayer=this._register(new v.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=(z=l.userDataSyncStore)===null||z===void 0?void 0:z.url,this.previousProductQuality=this.productQuality,this.productQuality=c.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(l.onDidChangeUserDataSyncStore(()=>{var H,Q;C.isEqual(this.syncUrl,(H=l.userDataSyncStore)===null||H===void 0?void 0:H.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=(Q=l.userDataSyncStore)===null||Q===void 0?void 0:Q.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(F.onDidChangeAccount(()=>this.updateAutoSync())),this._register(S.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(L.Event.debounce(g.onDidChangeLocal,(H,Q)=>H?[...H,Q]:[Q],1e3)(H=>this.triggerSync(H,!1,!1))),this._register(L.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,H])=>H)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const c=this.storageService.get(s,0);return c?f.URI.parse(c):void 0}set syncUrl(c){c?this.storageService.store(s,c.toString(),0,1):this.storageService.remove(s,0)}get productQuality(){return this.storageService.get(t,0)}set productQuality(c){c?this.storageService.store(t,c,0,1):this.storageService.remove(t,0)}updateAutoSync(){const{enabled:c,message:l}=this.isAutoSyncEnabled();c?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(S=>this.onDidFinishSync(S))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(l&&this.logService.info(l),this.autoSync.clear()):l&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(l))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${b.toLocalISOString(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(c,l,S){try{this.userDataSyncAccountService.account&&!S&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(o,0),c?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(w){if(l)this.logService.error(w),this.updateEnablement(!1);else throw w}}updateEnablement(c){this.userDataAutoSyncEnablementService.isEnabled()!==c&&(this.telemetryService.publicLog2(I,{enabled:c}),this.userDataAutoSyncEnablementService.setEnablement(c),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(c){if(!c){this.successiveFailures=0;return}const l=A.UserDataSyncError.toUserDataSyncError(c);l instanceof A.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:l.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),l.code===A.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):l.code===A.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):l.code===A.UserDataSyncErrorCode.LocalTooManyRequests||l.code===A.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):l.code===A.UserDataSyncErrorCode.UpgradeRequired||l.code===A.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):l.code===A.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${l.resource} content with newer version than of client. Requires client upgrade.`)):l.code===A.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${l.resource} content with older version than of client. Requires server reset.`)):l.code===A.UserDataSyncErrorCode.ServiceChanged||l.code===A.UserDataSyncErrorCode.DefaultServiceChanged?P.isWeb&&l.code===A.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(l),this.successiveFailures++),this._onError.fire(l)}async disableMachineEventually(){this.storageService.store(d,!0,0,1),await v.timeout(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(d,0,!1)}stopDisableMachineEventually(){this.storageService.remove(d,0)}async triggerSync(c,l,S){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(l&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...c),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",S)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};i=de([K(0,E.IProductService),K(1,A.IUserDataSyncStoreManagementService),K(2,A.IUserDataSyncStoreService),K(3,A.IUserDataSyncResourceEnablementService),K(4,A.IUserDataSyncService),K(5,A.IUserDataSyncLogService),K(6,T.IUserDataSyncAccountService),K(7,R.ITelemetryService),K(8,m.IUserDataSyncMachinesService),K(9,p.IStorageService),K(10,A.IUserDataAutoSyncEnablementService)],i),e.UserDataAutoSyncService=i;class a extends k.Disposable{constructor(c,l,S,w,g,U,F,j){super();this.lastSyncUrl=c,this.interval=l,this.userDataSyncStoreManagementService=S,this.userDataSyncStoreService=w,this.userDataSyncService=g,this.userDataSyncMachinesService=U,this.logService=F,this.storageService=j,this.intervalHandler=this._register(new k.MutableDisposable),this._onDidStartSync=this._register(new L.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new L.Emitter),this.onDidFinishSync=this._onDidFinishSync.event}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register(k.toDisposable(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=v.disposableTimeout(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(c,l){const S=v.createCancelablePromise(async w=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(g){if(y.isPromiseCanceledError(g))return}return this.doSync(c,l,w)});return this.syncPromise=S,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){var c;return this.lastSyncUrl!==void 0&&!C.isEqual(this.lastSyncUrl,(c=this.userDataSyncStoreManagementService.userDataSyncStore)===null||c===void 0?void 0:c.url)}async hasDefaultServiceChanged(){const c=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),l=this.userDataSyncStoreManagementService.userDataSyncStore;return!!l&&!!c&&(!C.isEqual(l.defaultUrl,c.defaultUrl)||!C.isEqual(l.insidersUrl,c.insidersUrl)||!C.isEqual(l.stableUrl,c.stableUrl))}async doSync(c,l,S){this.logService.info(`Auto Sync: Triggered by ${c}`),this._onDidStartSync.fire();let w;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(l),S.isCancellationRequested)return;let g=this.syncTask.manifest;if(g===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new A.UserDataAutoSyncError(h.localize(0,null),A.UserDataSyncErrorCode.DefaultServiceChanged):new A.UserDataAutoSyncError(h.localize(1,null),A.UserDataSyncErrorCode.ServiceChanged):new A.UserDataAutoSyncError(h.localize(2,null),A.UserDataSyncErrorCode.TurnedOff);const U=this.storageService.get(o,0);if(U&&g&&U!==g.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new A.UserDataAutoSyncError(h.localize(3,null),A.UserDataSyncErrorCode.DefaultServiceChanged):new A.UserDataAutoSyncError(h.localize(4,null),A.UserDataSyncErrorCode.ServiceChanged):new A.UserDataAutoSyncError(h.localize(5,null),A.UserDataSyncErrorCode.SessionExpired);const F=await this.userDataSyncMachinesService.getMachines(g||void 0);if(S.isCancellationRequested)return;const j=F.find($=>$.isCurrent);if(j==null?void 0:j.disabled)throw new A.UserDataAutoSyncError(h.localize(6,null),A.UserDataSyncErrorCode.TurnedOff);if(await this.syncTask.run(),g===null&&(g=await this.userDataSyncStoreService.manifest()),g&&g.session!==U&&this.storageService.store(o,g.session,0,1),S.isCancellationRequested)return;j||await this.userDataSyncMachinesService.addCurrentMachine(g||void 0)}catch(g){this.logService.error(g),w=g}this._onDidFinishSync.fire(w)}register(c){return super._register(c)}}a.INTERVAL_SYNCING="Interval"}),define(Z[198],ee([0,1,22,2,3,21,24,7]),function(G,e,v,L,k,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let y=class extends L.Disposable{constructor(n,m){super();this.storageService=n,this.telemetryService=m,this._onDidChangeResourceEnablement=new k.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(n.onDidChangeValue(h=>this.onDidStorageChange(h)))}isResourceEnabled(n){return this.storageService.getBoolean(v.getEnablementKey(n),0,!0)}setResourceEnablement(n,m){if(this.isResourceEnabled(n)!==m){const h=v.getEnablementKey(n);this.telemetryService.publicLog2(h,{enabled:m}),this.storeResourceEnablement(h,m)}}getResourceSyncStateVersion(n){}storeResourceEnablement(n,m){this.storageService.store(n,m,0,R.isWeb?0:1)}onDidStorageChange(n){if(n.scope===0){const m=v.ALL_SYNC_RESOURCES.filter(h=>v.getEnablementKey(h)===n.key)[0];if(m){this._onDidChangeResourceEnablement.fire([m,this.isResourceEnabled(m)]);return}}}};y=de([K(0,A.IStorageService),K(1,T.ITelemetryService)],y),e.UserDataSyncResourceEnablementService=y}),define(Z[199],ee([0,1,22,2,4,3,188,191,190,43,24,19,21,193,12,194,30,6,11]),function(G,e,v,L,k,A,T,R,y,p,n,m,h,b,f,C,P,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const d="sync.lastSyncTime";let o=class extends L.Disposable{constructor(i,a,u,c,l,S){super();this.userDataSyncStoreService=i,this.userDataSyncStoreManagementService=a,this.instantiationService=u,this.logService=c,this.telemetryService=l,this.storageService=S,this._status="uninitialized",this._onDidChangeStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new A.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new A.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new A.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new A.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(b.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(R.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(C.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(y.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(T.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(A.Event.any(...this.synchronisers.map(w=>A.Event.map(w.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(A.Event.any(...this.synchronisers.map(w=>A.Event.map(w.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(d,0,void 0),this.onDidChangeLocal=A.Event.any(...this.synchronisers.map(w=>A.Event.map(w.onDidChangeLocal,()=>w.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(i){await this.checkEnablement();const a=P.generateUuid();let u;try{const w=v.createSyncHeaders(a);i&&(w["Cache-Control"]="no-cache"),u=await this.userDataSyncStoreService.manifest(w)}catch(w){const g=v.UserDataSyncError.toUserDataSyncError(w);throw this.reportUserDataSyncError(g,a),g}let c=!1;const l=this;let S;return{manifest:u,run(){if(c)throw new Error("Can run a task only once");return S=E.createCancelablePromise(w=>l.sync(u,a,w)),S.finally(()=>S=void 0)},async stop(){if(S&&S.cancel(),l.status!=="idle")return l.stop()}}}async createManualSyncTask(){await this.checkEnablement();const i=P.generateUuid(),a=v.createSyncHeaders(i);let u;try{u=await this.userDataSyncStoreService.manifest(a)}catch(c){const l=v.UserDataSyncError.toUserDataSyncError(c);throw this.reportUserDataSyncError(l,i),l}return new s(i,u,a,this.synchronisers,this.logService)}async sync(i,a,u){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),u.isCancellationRequested)return;const c=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const l=v.createSyncHeaders(a);for(const S of this.synchronisers){if(u.isCancellationRequested)return;try{await S.sync(i,l)}catch(w){if(w instanceof v.UserDataSyncError)switch(w.code){case v.UserDataSyncErrorCode.TooLarge:throw new v.UserDataSyncError(w.message,w.code,S.resource);case v.UserDataSyncErrorCode.TooManyRequests:case v.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case v.UserDataSyncErrorCode.LocalTooManyRequests:case v.UserDataSyncErrorCode.Gone:case v.UserDataSyncErrorCode.UpgradeRequired:case v.UserDataSyncErrorCode.IncompatibleRemoteContent:case v.UserDataSyncErrorCode.IncompatibleLocalContent:throw w}const g=v.UserDataSyncError.toUserDataSyncError(w);this.reportUserDataSyncError(g,a),this.logService.error(w),this.logService.error(`${S.resource}: ${p.toErrorMessage(w)}`),this._syncErrors.push([S.resource,g])}}this.logService.info(`Sync done. Took ${new Date().getTime()-c}ms`),this.updateLastSyncTime()}catch(l){const S=v.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(S,a),S}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const i of this.synchronisers)try{i.status!=="idle"&&await i.stop()}catch(a){this.logService.error(a)}}async replace(i){await this.checkEnablement();for(const a of this.synchronisers)if(await a.replace(i))return}async accept(i,a,u,c){await this.checkEnablement();const l=this.getSynchroniser(i);await l.accept(a,u),c&&await l.apply(!1,v.createSyncHeaders(P.generateUuid()))}async resolveContent(i){for(const a of this.synchronisers){const u=await a.resolveContent(i);if(u)return u}return null}getRemoteSyncResourceHandles(i){return this.getSynchroniser(i).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(i){return this.getSynchroniser(i).getLocalSyncResourceHandles()}getAssociatedResources(i,a){return this.getSynchroniser(i).getAssociatedResources(a)}getMachineId(i,a){return this.getSynchroniser(i).getMachineId(a)}async hasLocalData(){const i=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const a of i)if(await a.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(i){this.logService.error(i)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(d,0);for(const i of this.synchronisers)try{await i.resetLocal()}catch(a){this.logService.error(`${i.resource}: ${p.toErrorMessage(a)}`),this.logService.error(a)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const i of this.synchronisers)if(await i.hasPreviouslySynced())return!0;return!1}setStatus(i){const a=this._status;this._status!==i&&(this._status=i,this._onDidChangeStatus.fire(i),a==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const i=this.computeStatus();this.setStatus(i)}updateConflicts(){const i=this.computeConflicts();m.equals(this._conflicts,i,([a,u],[c,l])=>a===a&&m.equals(u,l,(S,w)=>f.isEqual(S.previewResource,w.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(i))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(d,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(i,a){this.telemetryService.publicLog2("sync/error",{code:i.code,url:i instanceof v.UserDataSyncStoreError?i.url:void 0,resource:i.resource,executionId:a,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(i=>i.status==="hasConflicts").map(i=>[i.resource,i.conflicts.map(t)])}getSynchroniser(i){return this.synchronisers.find(a=>a.resource===i)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};o=de([K(0,v.IUserDataSyncStoreService),K(1,v.IUserDataSyncStoreManagementService),K(2,k.IInstantiationService),K(3,v.IUserDataSyncLogService),K(4,n.ITelemetryService),K(5,h.IStorageService)],o),e.UserDataSyncService=o;class s extends L.Disposable{constructor(i,a,u,c,l){super();this.id=i,this.manifest=a,this.syncHeaders=u,this.synchronisers=c,this.logService=l,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new A.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=E.createCancelablePromise(i=>this.getPreviews(i))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(i){throw this.logService.error(i),i}}async accept(i,a){try{return await this.performAction(i,u=>u.accept(i,a))}catch(u){throw this.logService.error(u),u}}async merge(i){try{return i?await this.performAction(i,a=>a.merge(i)):await this.mergeAll()}catch(a){throw this.logService.error(a),a}}async discard(i){try{return await this.performAction(i,a=>a.discard(i))}catch(a){throw this.logService.error(a),a}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const i=[];for(const[,a]of this.previews)for(const u of a.resourcePreviews)u.mergeState==="conflict"&&i.push(u.previewResource);for(const a of i)await this.discard(a);return this.previews}catch(i){throw this.logService.error(i),i}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const i=[];for(const[a,u]of this.previews){this.synchronizingResources.push([a,u.resourcePreviews.map(S=>S.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(S=>S.resource===a);for(const S of u.resourcePreviews)(S.localChange!==0||S.remoteChange!==0)&&S.mergeState==="preview"&&await c.merge(S.previewResource);const l=await c.apply(!1,this.syncHeaders);l&&i.push(this.toSyncResourcePreview(c.resource,l)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(S=>S[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}catch(i){throw this.logService.error(i),i}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,a]of this.previews){this.synchronizingResources.push([i,a.resourcePreviews.map(c=>c.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(c=>c.resource===i);for(const c of a.resourcePreviews)await u.accept(c.remoteResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(c=>c[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,a]of this.previews){this.synchronizingResources.push([i,a.resourcePreviews.map(c=>c.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(c=>c.resource===i);for(const c of a.resourcePreviews)await u.accept(c.localResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(c=>c[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async stop(){for(const i of this.synchronisers)try{await i.stop()}catch(a){I.isPromiseCanceledError(a)||this.logService.error(a)}this.reset()}async performAction(i,a){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const u=this.previews.findIndex(([,j])=>j.resourcePreviews.some(({localResource:$,previewResource:V,remoteResource:q})=>f.isEqual(i,$)||f.isEqual(i,V)||f.isEqual(i,q)));if(u===-1)return this.previews;const[c,l]=this.previews[u],S=l.resourcePreviews.find(({localResource:j,remoteResource:$,previewResource:V})=>f.isEqual(j,i)||f.isEqual($,i)||f.isEqual(V,i));if(!S)return this.previews;let w=this.synchronizingResources.find(j=>j[0]===c);w||(w=[c,[]],this.synchronizingResources.push(w)),w[1].some(j=>f.isEqual(j,S.localResource))||(w[1].push(S.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const g=this.synchronisers.find(j=>j.resource===this.previews[u][0]),U=await a(g);U?this.previews.splice(u,1,this.toSyncResourcePreview(g.resource,U)):this.previews.splice(u,1);const F=this.synchronizingResources.findIndex(j=>j[0]===c);return this.synchronizingResources[F][1].splice(w[1].findIndex(j=>f.isEqual(j,S.localResource)),1),w[1].length||(this.synchronizingResources.splice(F,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const i=[];for(const[a,u]of this.previews){this.synchronizingResources.push([a,u.resourcePreviews.map(S=>S.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(S=>S.resource===a);let l=u;for(const S of u.resourcePreviews)(S.localChange!==0||S.remoteChange!==0)&&S.mergeState==="preview"&&(l=await c.merge(S.previewResource));l&&i.push(this.toSyncResourcePreview(c.resource,l)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(S=>S[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}async getPreviews(i){const a=[];for(const u of this.synchronisers){if(i.isCancellationRequested)return[];const c=await u.preview(this.manifest,this.syncHeaders);c&&a.push(this.toSyncResourcePreview(u.resource,c))}return a}toSyncResourcePreview(i,a){return[i,{isLastSyncFromCurrentMachine:a.isLastSyncFromCurrentMachine,resourcePreviews:a.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(Z[200],ee([0,1,3,22,5,2,16]),function(G,e,v,L,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class R{constructor(m,h){this.service=m,this.logService=h,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new v.Emitter}listen(m,h){switch(h){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${h}`)}async call(m,h,b){try{return await this._call(m,h,b)}catch(f){throw this.logService.error(f),f}}async _call(m,h,b){switch(h){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(k.URI.revive(b[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(b[0],k.URI.revive(b[1]),b[2],b[3]);case"resolveContent":return this.service.resolveContent(k.URI.revive(b[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(b[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(b[0]);case"getAssociatedResources":return this.service.getAssociatedResources(b[0],{created:b[1].created,uri:k.URI.revive(b[1].uri)});case"getMachineId":return this.service.getMachineId(b[0],{created:b[1].created,uri:k.URI.revive(b[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(h.startsWith("manualSync/")){const f=h.substring("manualSync/".length),C=b[0],P=this.getManualSyncTask(C);switch(b=b.slice(1),f){case"preview":return P.preview();case"accept":return P.accept(k.URI.revive(b[0]),b[1]);case"merge":return P.merge(k.URI.revive(b[0]));case"discard":return P.discard(k.URI.revive(b[0]));case"discardConflicts":return P.discardConflicts();case"apply":return P.apply();case"pull":return P.pull();case"push":return P.push();case"stop":return P.stop();case"_getStatus":return P.status;case"dispose":return this.disposeManualSyncTask(P)}}throw new Error("Invalid call")}getManualSyncTask(m){const h=this.manualSyncTasks.get(this.createKey(m));if(!h)throw new Error(`Manual sync taks not found: ${m}`);return h.manualSyncTask}async createManualSyncTask(){const m=new A.DisposableStore,h=m.add(await this.service.createManualSyncTask());return m.add(h.onSynchronizeResources(b=>this.onManualSynchronizeResources.fire({manualSyncTaskId:h.id,data:b}))),this.manualSyncTasks.set(this.createKey(h.id),{manualSyncTask:h,disposables:m}),{id:h.id,manifest:h.manifest,status:h.status}}disposeManualSyncTask(m){var h;m.dispose();const b=this.createKey(m.id);(h=this.manualSyncTasks.get(b))===null||h===void 0||h.disposables.dispose(),this.manualSyncTasks.delete(b)}createKey(m){return`manualSyncTask-${m}`}}e.UserDataSyncChannel=R;class y extends A.Disposable{constructor(m){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new v.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new v.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new v.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new v.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(h,b,f){return m.call(h,b,f).then(null,C=>{throw L.UserDataSyncError.toUserDataSyncError(C)})},listen(h,b){return m.listen(h,b)}},this.channel.call("_getInitialData").then(([h,b,f])=>{this.updateStatus(h),this.updateConflicts(b),f&&this.updateLastSyncTime(f),this._register(this.channel.listen("onDidChangeStatus")(C=>this.updateStatus(C))),this._register(this.channel.listen("onDidChangeLastSyncTime")(C=>this.updateLastSyncTime(C)))}),this._register(this.channel.listen("onDidChangeConflicts")(h=>this.updateConflicts(h))),this._register(this.channel.listen("onSyncErrors")(h=>this._onSyncErrors.fire(h.map(([b,f])=>[b,L.UserDataSyncError.toUserDataSyncError(f)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:m,manifest:h,status:b}=await this.channel.call("createManualSyncTask"),f=this,C=new p(m,h,b,{async call(P,E,I){return f.channel.call(`manualSync/${P}`,[m,...T.isArray(E)?E:[E]],I)},listen(P,E){return v.Event.map(v.Event.filter(f.channel.listen(`manualSync/${P}`,E),I=>!C.isDiposed()&&I.manualSyncTaskId===m),I=>I.data)}});return C}replace(m){return this.channel.call("replace",[m])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(m,h,b,f){return this.channel.call("accept",[m,h,b,f])}resolveContent(m){return this.channel.call("resolveContent",[m])}async getLocalSyncResourceHandles(m){return(await this.channel.call("getLocalSyncResourceHandles",[m])).map(({created:b,uri:f})=>({created:b,uri:k.URI.revive(f)}))}async getRemoteSyncResourceHandles(m){return(await this.channel.call("getRemoteSyncResourceHandles",[m])).map(({created:b,uri:f})=>({created:b,uri:k.URI.revive(f)}))}async getAssociatedResources(m,h){return(await this.channel.call("getAssociatedResources",[m,h])).map(({resource:f,comparableResource:C})=>({resource:k.URI.revive(f),comparableResource:k.URI.revive(C)}))}async getMachineId(m,h){return this.channel.call("getMachineId",[m,h])}async updateStatus(m){this._status=m,this._onDidChangeStatus.fire(m)}async updateConflicts(m){this._conflicts=m.map(([h,b])=>[h,b.map(f=>Object.assign(Object.assign({},f),{localResource:k.URI.revive(f.localResource),remoteResource:k.URI.revive(f.remoteResource),previewResource:k.URI.revive(f.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(m){this._lastSyncTime!==m&&(this._lastSyncTime=m,this._onDidChangeLastSyncTime.fire(m))}}e.UserDataSyncChannelClient=y;class p extends A.Disposable{constructor(m,h,b,f){super();this.id=m,this.manifest=h,this._disposed=!1,this._status=b;const C=this;this.channel={async call(P,E,I){try{const d=await f.call(P,E,I);return C.isDiposed()||(C._status=await f.call("_getStatus")),d}catch(d){throw L.UserDataSyncError.toUserDataSyncError(d)}},listen(P,E){return f.listen(P,E)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const m=await this.channel.call("preview");return this.deserializePreviews(m)}async accept(m,h){const b=await this.channel.call("accept",[m,h]);return this.deserializePreviews(b)}async merge(m){const h=await this.channel.call("merge",[m]);return this.deserializePreviews(h)}async discard(m){const h=await this.channel.call("discard",[m]);return this.deserializePreviews(h)}async discardConflicts(){const m=await this.channel.call("discardConflicts");return this.deserializePreviews(m)}async apply(){const m=await this.channel.call("apply");return this.deserializePreviews(m)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(m){return m.map(([h,b])=>[h,{isLastSyncFromCurrentMachine:b.isLastSyncFromCurrentMachine,resourcePreviews:b.resourcePreviews.map(f=>Object.assign(Object.assign({},f),{localResource:k.URI.revive(f.localResource),remoteResource:k.URI.revive(f.remoteResource),previewResource:k.URI.revive(f.previewResource),acceptedResource:k.URI.revive(f.acceptedResource)}))}])}}}),define(Z[201],ee([0,1,2,22,39,12,29,23,27,44,9,10,21,30,7,3,6,16,5,11,92]),function(G,e,v,L,k,A,T,R,y,p,n,m,h,b,f,C,P,E,I,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const s="sync.previous.store",t="sync.donot-make-requests-until",r="sync.user-session-id",i="sync.machine-session-id",a=100,u=1e3*60*5;let c=class extends v.Disposable{constructor(F,j,$){super();this.productService=F,this.configurationService=j,this.storageService=$,this._onDidChangeUserDataSyncStore=this._register(new C.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(C.Event.filter($.onDidChangeValue,V=>{var q;return V.key===L.SYNC_SERVICE_URL_TYPE&&V.scope===0&&this.userDataSyncStoreType!==((q=this.userDataSyncStore)===null||q===void 0?void 0:q.type)})(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(L.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(F){this.storageService.store(L.SYNC_SERVICE_URL_TYPE,F,0,f.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[L.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(L.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(F,j){F=f.isWeb&&(F==null?void 0:F.web)?Object.assign(Object.assign({},F),F.web):F;const $=Object.assign(Object.assign({},F||{}),j||{});if($&&E.isString($.url)&&E.isObject($.authenticationProviders)&&Object.keys($.authenticationProviders).every(V=>E.isArray($.authenticationProviders[V].scopes))){const V=$,q=!!V.canSwitch&&!(j==null?void 0:j.url),z=V.url===V.insidersUrl?"insiders":"stable",H=(q?this.userDataSyncStoreType:void 0)||z,Q=(j==null?void 0:j.url)||(H==="insiders"?V.insidersUrl:H==="stable"?V.stableUrl:V.url);return{url:I.URI.parse(Q),type:H,defaultType:z,defaultUrl:I.URI.parse(V.url),stableUrl:I.URI.parse(V.stableUrl),insidersUrl:I.URI.parse(V.insidersUrl),canSwitch:q,authenticationProviders:Object.keys(V.authenticationProviders).reduce((N,O)=>(N.push({id:O,scopes:V.authenticationProviders[O].scopes}),N),[])}}}};c=de([K(0,y.IProductService),K(1,R.IConfigurationService),K(2,h.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let l=class extends c{constructor(F,j,$){super(F,j,$);const V=this.storageService.get(s,0);V&&(this.previousConfigurationSyncStore=JSON.parse(V));const q=this.productService[L.CONFIGURATION_SYNC_STORE_KEY];q?this.storageService.store(s,JSON.stringify(q),0,1):this.storageService.remove(s,0)}async switch(F){F!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=F,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};l=de([K(0,y.IProductService),K(1,R.IConfigurationService),K(2,h.IStorageService)],l),e.UserDataSyncStoreManagementService=l;let S=class extends v.Disposable{constructor(F,j,$,V,q,z,H){super();this.requestService=$,this.logService=V,this.storageService=H,this._onTokenFailed=this._register(new C.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new C.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new C.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(F),this.commonHeadersPromise=p.getServiceMachineId(q,z,H).then(Q=>{const N={"X-Client-Name":`${j.applicationName}${f.isWeb?"-web":""}`,"X-Client-Version":j.version,"X-Machine-Id":Q};return j.commit&&(N["X-Client-Commit"]=j.commit),N}),this.session=new g(a,u,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register(v.toDisposable(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(F,j){this.authToken={token:F,type:j}}updateUserDataSyncStoreUrl(F){this.userDataSyncStoreUrl=F?A.joinPath(F,"v1"):void 0}initDonotMakeRequestsUntil(){const F=this.storageService.getNumber(t,0);F&&Date.now()<F&&this.setDonotMakeRequestsUntil(new Date(F))}setDonotMakeRequestsUntil(F){var j;((j=this._donotMakeRequestsUntil)===null||j===void 0?void 0:j.getTime())!==(F==null?void 0:F.getTime())&&(this._donotMakeRequestsUntil=F,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=P.createCancelablePromise($=>P.timeout(this._donotMakeRequestsUntil.getTime()-Date.now(),$).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,$=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=A.joinPath(this.userDataSyncStoreUrl,"resource",F),$={},V=await this.request(j.toString(),{type:"GET",headers:$},[],T.CancellationToken.None);return(await k.asJson(V)||[]).map(({url:z,created:H})=>({ref:A.relativePath(j,j.with({path:z})),created:H*1e3}))}async resolveContent(F,j){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=A.joinPath(this.userDataSyncStoreUrl,"resource",F,j).toString(),V={};V["Cache-Control"]="no-cache";const q=await this.request($,{type:"GET",headers:V},[],T.CancellationToken.None);return await k.asText(q)}async delete(F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=A.joinPath(this.userDataSyncStoreUrl,"resource",F).toString(),$={};await this.request(j,{type:"DELETE",headers:$},[],T.CancellationToken.None)}async read(F,j,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const V=A.joinPath(this.userDataSyncStoreUrl,"resource",F,"latest").toString();$=Object.assign({},$),$["Cache-Control"]="no-cache",j&&($["If-None-Match"]=j.ref);const q=await this.request(V,{type:"GET",headers:$},[304],T.CancellationToken.None);if(q.res.statusCode===304)return j;const z=q.res.headers.etag;if(!z)throw new L.UserDataSyncStoreError("Server did not return the ref",V,L.UserDataSyncErrorCode.NoRef,q.res.headers[L.HEADER_OPERATION_ID]);const H=await k.asText(q);return{ref:z,content:H}}async write(F,j,$,V={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=A.joinPath(this.userDataSyncStoreUrl,"resource",F).toString();V=Object.assign({},V),V["Content-Type"]=o.Mimes.text,$&&(V["If-Match"]=$);const z=await this.request(q,{type:"POST",data:j,headers:V},[],T.CancellationToken.None),H=z.res.headers.etag;if(!H)throw new L.UserDataSyncStoreError("Server did not return the ref",q,L.UserDataSyncErrorCode.NoRef,z.res.headers[L.HEADER_OPERATION_ID]);return H}async manifest(F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=A.joinPath(this.userDataSyncStoreUrl,"manifest").toString();F=Object.assign({},F),F["Content-Type"]="application/json";const $=await this.request(j,{type:"GET",headers:F},[],T.CancellationToken.None),V=await k.asJson($),q=this.storageService.get(r,0);return q&&V&&q!==V.session&&this.clearSession(),V===null&&q&&this.clearSession(),V&&this.storageService.store(r,V.session,0,1),V}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=A.joinPath(this.userDataSyncStoreUrl,"resource").toString(),j={"Content-Type":o.Mimes.text};await this.request(F,{type:"DELETE",headers:j},[],T.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(r,0),this.storageService.remove(i,0)}async request(F,j,$,V){if(!this.authToken)throw new L.UserDataSyncStoreError("No Auth Token Available",F,L.UserDataSyncErrorCode.Unauthorized,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new L.UserDataSyncStoreError(`${j.type} request '${F}' failed because of too many requests (429).`,F,L.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0);this.setDonotMakeRequestsUntil(void 0);const q=await this.commonHeadersPromise;j.headers=Object.assign(Object.assign(Object.assign({},j.headers||{}),q),{"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`}),this.addSessionHeaders(j.headers),this.logService.trace("Sending request to server",{url:F,type:j.type,headers:Object.assign(Object.assign({},j.headers),{authorization:void 0})});let z;try{z=await this.session.request(F,j,V)}catch(O){if(!(O instanceof L.UserDataSyncStoreError)){const D=d.isPromiseCanceledError(O)?L.UserDataSyncErrorCode.RequestCanceled:d.getErrorMessage(O).startsWith("XHR timeout")?L.UserDataSyncErrorCode.RequestTimeout:L.UserDataSyncErrorCode.RequestFailed;O=new L.UserDataSyncStoreError(`Connection refused for the request '${F}'.`,F,D,void 0)}throw this.logService.info("Request failed",F),O}const H=z.res.headers[L.HEADER_OPERATION_ID],Q={url:F,status:z.res.statusCode,"execution-id":j.headers[L.HEADER_EXECUTION_ID],"operation-id":H},N=k.isSuccess(z)||z.res.statusCode&&$.indexOf(z.res.statusCode)!==-1;if(N?this.logService.trace("Request succeeded",Q):this.logService.info("Request failed",Q),z.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new L.UserDataSyncStoreError(`Request '${F}' failed because of Unauthorized (401).`,F,L.UserDataSyncErrorCode.Unauthorized,H);if(this._onTokenSucceed.fire(),z.res.statusCode===409)throw new L.UserDataSyncStoreError(`${j.type} request '${F}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,F,L.UserDataSyncErrorCode.Conflict,H);if(z.res.statusCode===410)throw new L.UserDataSyncStoreError(`${j.type} request '${F}' failed because the requested resource is not longer available (410).`,F,L.UserDataSyncErrorCode.Gone,H);if(z.res.statusCode===412)throw new L.UserDataSyncStoreError(`${j.type} request '${F}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,F,L.UserDataSyncErrorCode.PreconditionFailed,H);if(z.res.statusCode===413)throw new L.UserDataSyncStoreError(`${j.type} request '${F}' failed because of too large payload (413).`,F,L.UserDataSyncErrorCode.TooLarge,H);if(z.res.statusCode===426)throw new L.UserDataSyncStoreError(`${j.type} request '${F}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,F,L.UserDataSyncErrorCode.UpgradeRequired,H);if(z.res.statusCode===429){const O=z.res.headers["retry-after"];throw O?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(O)*1e3)),new L.UserDataSyncStoreError(`${j.type} request '${F}' failed because of too many requests (429).`,F,L.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,H)):new L.UserDataSyncStoreError(`${j.type} request '${F}' failed because of too many requests (429).`,F,L.UserDataSyncErrorCode.TooManyRequests,H)}if(!N)throw new L.UserDataSyncStoreError("Server returned "+z.res.statusCode,F,L.UserDataSyncErrorCode.Unknown,H);return z}addSessionHeaders(F){let j=this.storageService.get(i,0);j===void 0&&(j=b.generateUuid(),this.storageService.store(i,j,0,1)),F["X-Machine-Session-Id"]=j;const $=this.storageService.get(r,0);$!==void 0&&(F["X-User-Session-Id"]=$)}};S=de([K(1,y.IProductService),K(2,k.IRequestService),K(3,L.IUserDataSyncLogService),K(4,n.IEnvironmentService),K(5,m.IFileService),K(6,h.IStorageService)],S),e.UserDataSyncStoreClient=S;let w=class extends S{constructor(F,j,$,V,q,z,H){var Q;super((Q=F.userDataSyncStore)===null||Q===void 0?void 0:Q.url,j,$,V,q,z,H);this._register(F.onDidChangeUserDataSyncStore(()=>{var N;return this.updateUserDataSyncStoreUrl((N=F.userDataSyncStore)===null||N===void 0?void 0:N.url)}))}};w=de([K(0,L.IUserDataSyncStoreManagementService),K(1,y.IProductService),K(2,k.IRequestService),K(3,L.IUserDataSyncLogService),K(4,n.IEnvironmentService),K(5,m.IFileService),K(6,h.IStorageService)],w),e.UserDataSyncStoreService=w;class g{constructor(F,j,$,V){this.limit=F,this.interval=j,this.requestService=$,this.logService=V,this.requests=[],this.startTime=void 0}request(F,j,$){if(this.isExpired()&&this.reset(),j.url=F,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new L.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,F,L.UserDataSyncErrorCode.LocalTooManyRequests,void 0);return this.startTime=this.startTime||new Date,this.requests.push(F),this.requestService.request(j,$)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=g}),define(Z[202],ee([0,1,22,3,58,87,60,24,21,61,27]),function(G,e,v,L,k,A,T,R,y,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let m=class extends A.UserDataAutoSyncService{constructor(b,f,C,P,E,I,d,o,s,t,r,i){super(b,f,C,P,E,d,o,s,t,r,i);this._register(L.Event.debounce(L.Event.any(L.Event.map(I.onDidFocusWindow,()=>"windowFocus"),L.Event.map(I.onDidOpenWindow,()=>"windowOpen")),(a,u)=>a?[...a,u]:[u],1e3)(a=>this.triggerSync(a,!0,!1)))}};m=de([K(0,n.IProductService),K(1,v.IUserDataSyncStoreManagementService),K(2,v.IUserDataSyncStoreService),K(3,v.IUserDataSyncResourceEnablementService),K(4,v.IUserDataSyncService),K(5,k.INativeHostService),K(6,v.IUserDataSyncLogService),K(7,T.IUserDataSyncAccountService),K(8,R.ITelemetryService),K(9,p.IUserDataSyncMachinesService),K(10,y.IStorageService),K(11,v.IUserDataAutoSyncEnablementService)],m),e.UserDataAutoSyncService=m}),define(Z[203],ee([0,1,3,2,6]),function(G,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends L.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:y,getActiveWindowId:p}){super();this.disposables=this._register(new L.DisposableStore),v.Event.latch(v.Event.any(R,y))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=k.createCancelablePromise(()=>p()),(async()=>{try{const m=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:m}catch(m){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=A}),define(Z[62],ee([0,1,108,8,48,6,18,210,211,16]),function(G,e,v,L,k,A,T,R,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class n extends Error{constructor(t,r){let i=r.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=t,this.cause=r}}e.ExtractError=n;function m(s){const t=s.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,i)=>r+i,t&61440)}function h(s){if(s instanceof n)return s;let t;return/end of central directory record signature not found/.test(s.message)&&(t="CorruptZip"),new n(t,s)}function b(s,t,r,i,a,u){const c=L.dirname(t),l=L.join(i,c);if(!l.startsWith(i))return Promise.reject(new Error(v.localize(0,null,t)));const S=L.join(i,t);let w;return u.onCancellationRequested(()=>{w&&w.destroy()}),Promise.resolve(T.Promises.mkdir(l,{recursive:!0})).then(()=>new Promise((g,U)=>{if(!u.isCancellationRequested)try{w=k.createWriteStream(S,{mode:r}),w.once("close",()=>g()),w.once("error",U),s.once("error",U),s.pipe(w)}catch(F){U(F)}}))}function f(s,t,r,i){let a=A.createCancelablePromise(()=>Promise.resolve()),u=0;return i.onCancellationRequested(()=>{a.cancel(),s.close()}),new Promise((c,l)=>{const S=new A.Sequencer,w=g=>{g.isCancellationRequested||(u++,s.readEntry())};s.once("error",l),s.once("close",()=>a.then(()=>{i.isCancellationRequested||s.entryCount===u?c():l(new n("Incomplete",new Error(v.localize(1,null,u,s.entryCount))))},l)),s.readEntry(),s.on("entry",g=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(g.fileName)){w(i);return}const U=g.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(U)){const $=L.join(t,U);a=A.createCancelablePromise(V=>T.Promises.mkdir($,{recursive:!0}).then(()=>w(V)).then(void 0,l));return}const F=P(s,g),j=m(g);a=A.createCancelablePromise($=>S.queue(()=>F.then(V=>b(V,U,j,t,r,$).then(()=>w($)))).then(null,l))})})}function C(s,t=!1){return new Promise((r,i)=>{R.open(s,t?{lazyEntries:!0}:void 0,(a,u)=>{a?i(h(a)):r(p.assertIsDefined(u))})})}function P(s,t){return new Promise((r,i)=>{s.openReadStream(t,(a,u)=>{a?i(h(a)):r(p.assertIsDefined(u))})})}function E(s,t){return new Promise((r,i)=>{const a=new y.ZipFile;t.forEach(c=>{c.contents?a.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&a.addFile(c.localPath,c.path)}),a.end();const u=k.createWriteStream(s);a.outputStream.pipe(u),a.outputStream.once("error",i),u.once("error",i),u.once("finish",()=>r(s))})}e.zip=E;function I(s,t,r={},i){const a=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let u=C(s,!0);return r.overwrite&&(u=u.then(c=>T.Promises.rm(t).then(()=>c))),u.then(c=>f(c,t,{sourcePathRegex:a},i))}e.extract=I;function d(s,t){return C(s).then(r=>new Promise((i,a)=>{r.on("entry",u=>{u.fileName===t&&P(r,u).then(c=>i(c),c=>a(c))}),r.once("close",()=>a(new Error(v.localize(2,null,t))))}))}function o(s,t){return d(s,t).then(r=>new Promise((i,a)=>{const u=[];r.once("error",a),r.on("data",c=>u.push(c)),r.on("end",()=>i(Buffer.concat(u)))}))}e.buffer=o}),define(Z[204],ee([0,1,62,113]),function(G,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(A){return v.buffer(A,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch(R){throw new Error(L.localize(0,null))}})}e.getManifest=k}),define(Z[205],ee([0,1,57,2,18,8,15,28,33,6,5,9,134,114,27,62,7,19,17,10,12,30,11]),function(G,e,v,L,k,A,T,R,y,p,n,m,h,b,f,C,P,E,I,d,o,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",i="scanningUser",a="extracting",u="deleting",c="renaming";let l=class extends L.Disposable{constructor(w,g,U,F,j){super();this.beforeRemovingExtension=w,this.fileService=g,this.logService=U,this.environmentService=F,this.productService=j,this._devSystemExtensionsPath=null,this.systemExtensionsPath=F.builtinExtensionsPath,this.extensionsPath=F.extensionsPath,this.uninstalledPath=A.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new p.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(w){const g=[];(w===null||w===0)&&g.push(this.scanSystemExtensions().then(null,U=>Promise.reject(new R.ExtensionManagementError(this.joinErrors(U).message,r)))),(w===null||w===1)&&g.push(this.scanUserExtensions(!0).then(null,U=>Promise.reject(new R.ExtensionManagementError(this.joinErrors(U).message,i))));try{const U=await Promise.all(g);return E.flatten(U)}catch(U){throw this.joinErrors(U)}}async scanUserExtensions(w){this.logService.trace("Started scanning user extensions");let[g,U]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return U=U.filter(F=>!g[new y.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).key()]),w&&(U=y.groupByExtension(U,j=>j.identifier).map(j=>j.sort(($,V)=>v.rcompare($.manifest.version,V.manifest.version))[0])),this.logService.trace("Scanned user extensions:",U.length),U}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(w,g,U){const F=w.key(),j=A.join(this.extensionsPath,`.${s.generateUuid()}`),$=A.join(this.extensionsPath,F);try{await k.Promises.rm($)}catch(q){try{await k.Promises.rm($)}catch(z){}throw new R.ExtensionManagementError(b.localize(0,null,$,w.id),u)}await this.extractAtLocation(w,g,j,U);let V=await this.scanExtension(n.URI.file(j),1);if(!V)throw new Error(b.localize(1,null,j));await this.storeMetadata(V,{installedTimestamp:Date.now()});try{await this.rename(w,j,$,Date.now()+2*60*1e3),this.logService.info("Renamed to",$)}catch(q){try{await k.Promises.rm(j)}catch(z){}if(q.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",w.id);else throw this.logService.info(`Rename failed because of ${t.getErrorMessage(q)}. Deleted from extracted location`,j),q}try{V=await this.scanExtension(n.URI.file($),1)}catch(q){}if(V)return V;throw new Error(b.localize(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(w,g){return this.setMetadata(w,g),await this.storeMetadata(w,Object.assign(Object.assign({},g),{installedTimestamp:w.installedTimestamp})),w}async storeMetadata(w,g){g.isMachineScoped=g.isMachineScoped||void 0,g.isBuiltin=g.isBuiltin||void 0,g.installedTimestamp=g.installedTimestamp||void 0;const U=A.join(w.location.fsPath,"package.json"),F=await k.Promises.readFile(U,"utf8"),{manifest:j}=await this.parseManifest(F);return j.__metadata=g,await k.Promises.writeFile(U,JSON.stringify(j,null,"	")),w}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...w){const g=w.map(U=>new y.ExtensionIdentifierWithVersion(U.identifier,U.manifest.version));await this.withUninstalledExtensions(U=>{g.forEach(F=>U[F.key()]=!0)})}async setInstalled(w){await this.withUninstalledExtensions(F=>delete F[w.key()]);const U=(await this.scanExtensions(1)).find(F=>new y.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).equals(w))||null;return U?(await this.storeMetadata(U,{installedTimestamp:Date.now()}),this.scanExtension(U.location,1)):null}async withUninstalledExtensions(w){return this.uninstalledFileLimiter.queue(async()=>{let g;try{g=await k.Promises.readFile(this.uninstalledPath,"utf8")}catch(F){if(F.code!=="ENOENT")throw F}let U={};if(g)try{U=JSON.parse(g)}catch(F){}return w&&(w(U),Object.keys(U).length?await k.Promises.writeFile(this.uninstalledPath,JSON.stringify(U)):await k.Promises.rm(this.uninstalledPath)),U})}async removeExtension(w,g){this.logService.trace(`Deleting ${g} extension from disk`,w.identifier.id,w.location.fsPath),await k.Promises.rm(w.location.fsPath),this.logService.info("Deleted from disk",w.identifier.id,w.location.fsPath)}async removeUninstalledExtension(w){await this.removeExtension(w,"uninstalled"),await this.withUninstalledExtensions(g=>delete g[new y.ExtensionIdentifierWithVersion(w.identifier,w.manifest.version).key()])}async extractAtLocation(w,g,U,F){this.logService.trace(`Started extracting the extension from ${g} to ${U}`);try{await k.Promises.rm(U)}catch(j){throw new R.ExtensionManagementError(this.joinErrors(j).message,u)}try{await C.extract(g,U,{sourcePath:"extension",overwrite:!0},F),this.logService.info(`Extracted extension to ${U}:`,w.id)}catch(j){try{await k.Promises.rm(U)}catch($){}throw new R.ExtensionManagementError(j.message,j instanceof C.ExtractError&&j.type?j.type:a)}}async rename(w,g,U,F){try{await k.Promises.rename(g,U)}catch(j){if(P.isWindows&&j&&j.code==="EPERM"&&Date.now()<F)return this.logService.info(`Failed renaming ${g} to ${U} with 'EPERM' error. Trying again...`,w.id),this.rename(w,g,U,F);throw new R.ExtensionManagementError(j.message||b.localize(3,null,g,U),j.code||c)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const w=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return w;const g=this.scanDevSystemExtensions(),[U,F]=await Promise.all([w,g]);return[...U,...F]}async scanExtensionsInDir(w,g){const U=new p.Limiter(10),F=await this.fileService.resolve(n.URI.file(w));return F.children?(await Promise.all(F.children.filter($=>$.isDirectory).map($=>U.queue(async()=>g===1&&o.basename($.resource).indexOf(".")===0?null:this.scanExtension($.resource,g))))).filter($=>$&&$.identifier):[]}async scanExtension(w,g){var U,F;try{const j=await this.fileService.resolve(w);if(j.children){const{manifest:$,metadata:V}=await this.readManifest(w.fsPath),q=(U=j.children.find(({name:N})=>/^readme(\.txt|\.md|)$/i.test(N)))===null||U===void 0?void 0:U.resource,z=(F=j.children.find(({name:N})=>/^changelog(\.txt|\.md|)$/i.test(N)))===null||F===void 0?void 0:F.resource,H={id:y.getGalleryExtensionId($.publisher,$.name)},Q={type:g,identifier:H,manifest:$,location:w,readmeUrl:q,changelogUrl:z,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:g===0};return V&&(this.setMetadata(Q,V),Q.installedTimestamp=V.installedTimestamp),Q}}catch(j){g!==0&&this.logService.trace(j)}return null}async scanDefaultSystemExtensions(){const w=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",w.length),w}async scanDevSystemExtensions(){const w=this.getDevSystemExtensionsList();if(w.length){const g=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",g.length),g.filter(U=>w.some(F=>y.areSameExtensions(U.identifier,{id:F})))}else return[]}setMetadata(w,g){w.publisherDisplayName=g.publisherDisplayName||null,w.publisherId=g.publisherId||null,w.identifier.uuid=g.id,w.isMachineScoped=!!g.isMachineScoped,w.isBuiltin=w.type===0||!!g.isBuiltin}async removeUninstalledExtensions(){const w=await this.getUninstalledExtensions(),g=await this.scanAllUserExtensions(),U=new Set;for(const $ of g)w[new y.ExtensionIdentifierWithVersion($.identifier,$.manifest.version).key()]||U.add($.identifier.id.toLowerCase());const F=y.groupByExtension(g,$=>$.identifier);await p.Promises.settled(F.map(async $=>{const V=$.sort((q,z)=>v.rcompare(q.manifest.version,z.manifest.version))[0];U.has(V.identifier.id.toLowerCase())||await this.beforeRemovingExtension(V)}));const j=g.filter($=>w[new y.ExtensionIdentifierWithVersion($.identifier,$.manifest.version).key()]);await p.Promises.settled(j.map($=>this.removeUninstalledExtension($)))}async removeOutdatedExtensions(){const w=await this.scanAllUserExtensions(),g=[],U=y.groupByExtension(w,F=>F.identifier);g.push(...E.flatten(U.map(F=>F.sort((j,$)=>v.rcompare(j.manifest.version,$.manifest.version)).slice(1)))),await p.Promises.settled(g.map(F=>this.removeExtension(F,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(w=>w.name)}joinErrors(w){const g=Array.isArray(w)?w:[w];return g.length===1?g[0]instanceof Error?g[0]:new Error(g[0]):g.reduce((U,F)=>new Error(`${U.message}${U.message?",":""}${F instanceof Error?F.message:F}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=A.normalize(A.join(I.FileAccess.asFileUri("",G).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(w){const g=[k.Promises.readFile(A.join(w,"package.json"),"utf8").then($=>this.parseManifest($)),k.Promises.readFile(A.join(w,"package.nls.json"),"utf8").then(void 0,$=>$.code!=="ENOENT"?Promise.reject($):"{}").then($=>JSON.parse($))],[{manifest:U,metadata:F},j]=await Promise.all(g);return{manifest:h.localizeManifest(U,j),metadata:F}}parseManifest(w){return new Promise((g,U)=>{try{const F=JSON.parse(w),j=F.__metadata||null;g({manifest:F,metadata:j})}catch(F){U(new Error(b.localize(4,null)))}})}};l=de([K(1,d.IFileService),K(2,T.ILogService),K(3,m.INativeEnvironmentService),K(4,f.IProductService)],l),e.ExtensionsScanner=l}),define(Z[206],ee([0,1,112,8,18,2,19,62,28,33,9,6,3,57,5,51,7,15,145,43,24,71,12,30,73,4,17,29,204,155,205,156,157,10]),function(G,e,v,L,k,A,T,R,y,p,n,m,h,b,f,C,P,E,I,d,o,s,t,r,i,a,u,c,l,S,w,g,U,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const j="unsetUninstalled",$="downloading",V="validating",q="local",z="unknown";let H=class extends A.Disposable{constructor(N,O,D,M,_,x,B){super();this.environmentService=N,this.galleryService=O,this.logService=D,this.downloadService=M,this.telemetryService=_,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new h.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new h.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new h.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new h.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const J=this._register(x.createInstance(g.ExtensionsLifecycle));this.extensionsScanner=this._register(x.createInstance(w.ExtensionsScanner,te=>J.postUninstall(te))),this.manifestCache=this._register(new I.ExtensionsManifestCache(N,this)),this.extensionsDownloader=this._register(x.createInstance(S.ExtensionsDownloader));const X=this._register(new U.ExtensionsWatcher(this,B,N,D));this._register(X.onDidChangeExtensionsByAnotherSource(({added:te,removed:ie})=>{te.forEach(ce=>this._onDidInstallExtension.fire({identifier:ce.identifier,operation:0,local:ce})),ie.forEach(ce=>this._onDidUninstallExtension.fire({identifier:ce}))})),this._register(A.toDisposable(()=>{this.installingExtensions.forEach(te=>te.cancel()),this.uninstallingExtensions.forEach(te=>te.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(N){this.logService.trace("ExtensionManagementService#zip",N.identifier.id);const O=await this.collectFiles(N),D=await R.zip(t.joinPath(this.environmentService.tmpDir,r.generateUuid()).fsPath,O);return f.URI.file(D)}async unzip(N){return this.logService.trace("ExtensionManagementService#unzip",N.toString()),(await this.install(N)).identifier}async getManifest(N){const O=await this.downloadVsix(N),D=L.resolve(O.fsPath);return l.getManifest(D)}async collectFiles(N){const O=async M=>{let _=await k.Promises.readdir(M);_=_.map(J=>L.join(M,J));const x=await Promise.all(_.map(J=>k.Promises.stat(J)));let B=Promise.resolve([]);return x.forEach((J,X)=>{const te=_[X];J.isFile()&&(B=B.then(ie=>[...ie,te])),J.isDirectory()&&(B=B.then(ie=>O(te).then(ce=>[...ie,...ce])))}),B};return(await O(N.location.fsPath)).map(M=>({path:`extension/${L.relative(N.location.fsPath,M)}`,localPath:M}))}async install(N,O={}){return this.logService.trace("ExtensionManagementService#install",N.toString()),m.createCancelablePromise(async D=>{const M=await this.downloadVsix(N),_=L.resolve(M.fsPath),x=await l.getManifest(_),B={id:p.getGalleryExtensionId(x.publisher,x.name)};let J=1;if(x.engines&&x.engines.vscode&&!s.isEngineValid(x.engines.vscode,C.default.version,C.default.date))throw new Error(v.localize(0,null,B.id,C.default.version));const X=new p.ExtensionIdentifierWithVersion(B,x.version),ie=(await this.getInstalled(1)).find(le=>p.areSameExtensions(B,le.identifier));if(ie)if(O.isMachineScoped=O.isMachineScoped||ie.isMachineScoped,O.isBuiltin=O.isBuiltin||ie.isBuiltin,J=2,X.equals(new p.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version)))try{await this.extensionsScanner.removeExtension(ie,"existing")}catch(le){throw new Error(v.localize(1,null,x.displayName||x.name))}else b.gt(ie.manifest.version,x.version)&&await this.uninstallExtension(ie);else{const le=await this.unsetUninstalledAndGetLocal(X);if(le)try{await this.extensionsScanner.removeExtension(le,"existing")}catch(ve){throw new Error(v.localize(2,null,x.displayName||x.name))}}this.logService.info("Installing the extension:",B.id),this._onInstallExtension.fire({identifier:B,zipPath:_});let ce;try{ce=await this.getGalleryMetadata(p.getGalleryExtensionId(x.publisher,x.name))}catch(le){}try{const le=await this.installFromZipPath(X,_,O.installOnlyNewlyAddedFromExtensionPack?ie:void 0,Object.assign(Object.assign({},ce||{}),O),O,J,D);return this.logService.info("Successfully installed the extension:",B.id),le}catch(le){throw this.logService.error("Failed to install the extension:",B.id,le.message),le}})}async downloadVsix(N){if(N.scheme===u.Schemas.file)return N;if(!this.downloadService)throw new Error("Download service is not available");const O=t.joinPath(this.environmentService.tmpDir,r.generateUuid());return await this.downloadService.download(N,O),O}async installFromZipPath(N,O,D,M,_,x,B){try{const J=await this.installExtension({zipPath:O,identifierWithVersion:N,metadata:M},B);try{_.donotIncludePackAndDependencies||await this.installDependenciesAndPackExtensions(J,D,_)}catch(X){T.isNonEmptyArray(J.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",J.identifier.id,X.message),T.isNonEmptyArray(J.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",J.identifier.id,X.message)}return this._onDidInstallExtension.fire({identifier:N,zipPath:O,local:J,operation:x}),J}catch(J){throw this._onDidInstallExtension.fire({identifier:N,zipPath:O,operation:x,error:J}),J}}async canInstall(N){return!0}async installFromGallery(N,O={}){if(!this.galleryService.isEnabled())throw new Error(v.localize(3,null));try{N=await this.checkAndGetCompatibleVersion(N)}catch(_){const x=_&&_.code?_.code:z;throw this.logService.error("Failed to install extension:",N.identifier.id,_?_.message:x),this.reportTelemetry(this.getTelemetryEvent(1),p.getGalleryExtensionTelemetryData(N),void 0,_),_ instanceof Error&&(_.name=x),_}const D=new p.ExtensionIdentifierWithVersion(N.identifier,N.version).key();let M=this.installingExtensions.get(D);return M||(M=m.createCancelablePromise(_=>this.doInstallFromGallery(N,O,_)),this.installingExtensions.set(D,M),M.finally(()=>this.installingExtensions.delete(D))),M}async doInstallFromGallery(N,O,D){const M=new Date().getTime();let _=1;this.logService.info("Installing extension:",N.identifier.id),this._onInstallExtension.fire({identifier:N.identifier,gallery:N});try{const B=(await this.getInstalled(1)).find(te=>p.areSameExtensions(te.identifier,N.identifier));B&&(_=2);const J=await this.downloadInstallableExtension(N,_);J.metadata.isMachineScoped=O.isMachineScoped||(B==null?void 0:B.isMachineScoped),J.metadata.isBuiltin=O.isBuiltin||(B==null?void 0:B.isBuiltin);const X=await this.installExtension(J,D);try{await this.extensionsDownloader.delete(f.URI.file(J.zipPath))}catch(te){}if(!O.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(X,B,O)}catch(te){try{await this.uninstall(X)}catch(ie){}throw te}return B&&b.neq(B.manifest.version,N.version)&&await this.extensionsScanner.setUninstalled(B),this.logService.info("Extensions installed successfully:",N.identifier.id),this._onDidInstallExtension.fire({identifier:N.identifier,gallery:N,local:X,operation:_}),this.reportTelemetry(this.getTelemetryEvent(_),p.getGalleryExtensionTelemetryData(N),new Date().getTime()-M,void 0),X}catch(x){const B=x&&x.code?x.code:z;throw this.logService.error("Failed to install extension:",N.identifier.id,x?x.message:B),this._onDidInstallExtension.fire({identifier:N.identifier,gallery:N,operation:_,error:B}),this.reportTelemetry(this.getTelemetryEvent(_),p.getGalleryExtensionTelemetryData(N),new Date().getTime()-M,x),x instanceof Error&&(x.name=B),x}}async checkAndGetCompatibleVersion(N){if(await this.isMalicious(N))throw new y.ExtensionManagementError(v.localize(4,null),y.INSTALL_ERROR_MALICIOUS);const O=await this.galleryService.getCompatibleExtension(N);if(!O)throw new y.ExtensionManagementError(v.localize(5,null,N.identifier.id,C.default.version),y.INSTALL_ERROR_INCOMPATIBLE);return O}async reinstallFromGallery(N){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",N.identifier.id),!this.galleryService.isEnabled())throw new Error(v.localize(6,null));const O=await this.findGalleryExtension(N);if(!O)throw new Error(v.localize(7,null));await this.extensionsScanner.setUninstalled(N);try{await this.extensionsScanner.removeUninstalledExtension(N)}catch(D){throw new Error(v.localize(8,null,d.toErrorMessage(D)))}await this.installFromGallery(O)}getTelemetryEvent(N){return N===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(N){const O=await this.getExtensionsReport();return p.getMaliciousExtensionsSet(O).has(N.identifier.id)}async downloadInstallableExtension(N,O){const D={id:N.identifier.uuid,publisherId:N.publisherId,publisherDisplayName:N.publisherDisplayName};let M;try{this.logService.trace("Started downloading extension:",N.identifier.id),M=(await this.extensionsDownloader.downloadExtension(N,O)).fsPath,this.logService.info("Downloaded extension:",N.identifier.id,M)}catch(_){throw new y.ExtensionManagementError(this.joinErrors(_).message,$)}try{const _=await l.getManifest(M);return{zipPath:M,identifierWithVersion:new p.ExtensionIdentifierWithVersion(N.identifier,_.version),metadata:D}}catch(_){throw new y.ExtensionManagementError(this.joinErrors(_).message,V)}}async installExtension(N,O){try{const D=await this.unsetUninstalledAndGetLocal(N.identifierWithVersion);if(D)return N.metadata?this.extensionsScanner.saveMetadataForLocalExtension(D,N.metadata):D}catch(D){throw P.isMacintosh?new y.ExtensionManagementError(v.localize(9,null),j):new y.ExtensionManagementError(v.localize(10,null),j)}return this.extractAndInstall(N,O)}async unsetUninstalledAndGetLocal(N){if(!await this.isUninstalled(N))return null;this.logService.trace("Removing the extension from uninstalled list:",N.id);const D=await this.extensionsScanner.setInstalled(N);return this.logService.info("Removed the extension from uninstalled list:",N.id),D}async extractAndInstall({zipPath:N,identifierWithVersion:O,metadata:D},M){let _=await this.extensionsScanner.extractUserExtension(O,N,M);return this.logService.info("Installation completed.",O.id),D&&(_=await this.extensionsScanner.saveMetadataForLocalExtension(_,D)),_}async installDependenciesAndPackExtensions(N,O,D){if(!this.galleryService.isEnabled())return;const M=N.manifest.extensionDependencies||[];if(N.manifest.extensionPack)for(const _ of N.manifest.extensionPack)O&&O.manifest.extensionPack&&O.manifest.extensionPack.some(x=>p.areSameExtensions({id:x},{id:_}))||M.every(x=>!p.areSameExtensions({id:x},{id:_}))&&M.push(_);if(M.length){const _=await this.getInstalled(),x=M.filter(B=>_.every(({identifier:J})=>!p.areSameExtensions(J,{id:B})));if(x.length){const J=(await this.galleryService.query({names:x,pageSize:M.length},c.CancellationToken.None)).firstPage;try{await m.Promises.settled(J.map(X=>this.installFromGallery(X,D)))}catch(X){try{await this.rollback(J)}catch(te){}throw X}}}}async rollback(N){const D=(await this.getInstalled(1)).filter(M=>N.some(_=>new p.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version).equals(new p.ExtensionIdentifierWithVersion(_.identifier,_.version))));await m.Promises.settled(D.map(M=>this.uninstall(M)))}async uninstall(N,O={}){this.logService.trace("ExtensionManagementService#uninstall",N.identifier.id);const D=await this.getInstalled(1),M=D.find(_=>p.areSameExtensions(_.identifier,N.identifier));if(!M)throw new Error(v.localize(11,null,N.manifest.displayName||N.manifest.name));try{await this.checkForDependenciesAndUninstall(M,D,O)}catch(_){throw this.joinErrors(_)}}async updateMetadata(N,O){return this.logService.trace("ExtensionManagementService#updateMetadata",N.identifier.id),N=await this.extensionsScanner.saveMetadataForLocalExtension(N,Object.assign(Object.assign({},N.manifest.__metadata||{}),O)),this.manifestCache.invalidate(),N}async updateExtensionScope(N,O){return this.logService.trace("ExtensionManagementService#updateExtensionScope",N.identifier.id),N=await this.extensionsScanner.saveMetadataForLocalExtension(N,Object.assign(Object.assign({},N.manifest.__metadata||{}),{isMachineScoped:O})),this.manifestCache.invalidate(),N}async getGalleryMetadata(N){const O=await this.findGalleryExtensionByName(N);return O?{id:O.identifier.uuid,publisherDisplayName:O.publisherDisplayName,publisherId:O.publisherId}:void 0}async findGalleryExtension(N){if(N.identifier.uuid){const O=await this.findGalleryExtensionById(N.identifier.uuid);return O||this.findGalleryExtensionByName(N.identifier.id)}return this.findGalleryExtensionByName(N.identifier.id)}async findGalleryExtensionById(N){return(await this.galleryService.query({ids:[N],pageSize:1},c.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(N){return(await this.galleryService.query({names:[N],pageSize:1},c.CancellationToken.None)).firstPage[0]}joinErrors(N){const O=Array.isArray(N)?N:[N];return O.length===1?O[0]instanceof Error?O[0]:new Error(O[0]):O.reduce((D,M)=>new Error(`${D.message}${D.message?",":""}${M instanceof Error?M.message:M}`),new Error(""))}async checkForDependenciesAndUninstall(N,O,D){try{await this.preUninstallExtension(N);const M=D.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(N,O);await this.uninstallExtensions(N,M,O,D)}catch(M){throw await this.postUninstallExtension(N,new y.ExtensionManagementError(M instanceof Error?M.message:M,q)),M}await this.postUninstallExtension(N)}async uninstallExtensions(N,O,D,M){const _=[N,...O];if(!M.donotCheckDependents)for(const x of _)this.checkForDependents(x,_,D,N);await m.Promises.settled([this.uninstallExtension(N),...O.map(x=>this.doUninstall(x))])}checkForDependents(N,O,D,M){const _=this.getDependents(N,D);if(_.length){const x=_.filter(B=>O.indexOf(B)===-1);if(x.length)throw new Error(this.getDependentsErrorMessage(N,x,M))}}getDependentsErrorMessage(N,O,D){return D===N?O.length===1?v.localize(12,null,D.manifest.displayName||D.manifest.name,O[0].manifest.displayName||O[0].manifest.name):O.length===2?v.localize(13,null,D.manifest.displayName||D.manifest.name,O[0].manifest.displayName||O[0].manifest.name,O[1].manifest.displayName||O[1].manifest.name):v.localize(14,null,D.manifest.displayName||D.manifest.name,O[0].manifest.displayName||O[0].manifest.name,O[1].manifest.displayName||O[1].manifest.name):O.length===1?v.localize(15,null,D.manifest.displayName||D.manifest.name,N.manifest.displayName||N.manifest.name,O[0].manifest.displayName||O[0].manifest.name):O.length===2?v.localize(16,null,D.manifest.displayName||D.manifest.name,N.manifest.displayName||N.manifest.name,O[0].manifest.displayName||O[0].manifest.name,O[1].manifest.displayName||O[1].manifest.name):v.localize(17,null,D.manifest.displayName||D.manifest.name,N.manifest.displayName||N.manifest.name,O[0].manifest.displayName||O[0].manifest.name,O[1].manifest.displayName||O[1].manifest.name)}getAllPackExtensionsToUninstall(N,O,D=[]){if(D.indexOf(N)!==-1)return[];D.push(N);const M=N.manifest.extensionPack?N.manifest.extensionPack:[];if(M.length){const _=O.filter(B=>!B.isBuiltin&&M.some(J=>p.areSameExtensions({id:J},B.identifier))),x=[];for(const B of _)x.push(...this.getAllPackExtensionsToUninstall(B,O,D));return[..._,...x]}return[]}getDependents(N,O){return O.filter(D=>D.manifest.extensionDependencies&&D.manifest.extensionDependencies.some(M=>p.areSameExtensions({id:M},N.identifier)))}async doUninstall(N){try{await this.preUninstallExtension(N),await this.uninstallExtension(N)}catch(O){throw await this.postUninstallExtension(N,new y.ExtensionManagementError(O instanceof Error?O.message:O,q)),O}await this.postUninstallExtension(N)}async preUninstallExtension(N){if(!await k.Promises.exists(N.location.fsPath))throw new Error(v.localize(18,null));this.logService.info("Uninstalling extension:",N.identifier.id),this._onUninstallExtension.fire(N.identifier)}async uninstallExtension(N){let O=this.uninstallingExtensions.get(N.identifier.id);return O||(O=m.createCancelablePromise(async()=>{const D=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...D.filter(M=>p.areSameExtensions(M.identifier,N.identifier)))}),this.uninstallingExtensions.set(N.identifier.id,O),O.finally(()=>this.uninstallingExtensions.delete(N.identifier.id))),O}async postUninstallExtension(N,O){if(O)this.logService.error("Failed to uninstall extension:",N.identifier.id,O.message);else if(this.logService.info("Successfully uninstalled extension:",N.identifier.id),N.identifier.uuid)try{await this.galleryService.reportStatistic(N.manifest.publisher,N.manifest.name,N.manifest.version,"uninstall")}catch(M){}this.reportTelemetry("extensionGallery:uninstall",p.getLocalExtensionTelemetryData(N),void 0,O);const D=O?O instanceof y.ExtensionManagementError?O.code:z:void 0;this._onDidUninstallExtension.fire({identifier:N.identifier,error:D})}getInstalled(N=null){return this.extensionsScanner.scanExtensions(N)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(N){return(await this.filterUninstalled(N)).length===1}async filterUninstalled(...N){const O=[],D=await this.extensionsScanner.getUninstalledExtensions();for(const M of N)D[M.key()]&&O.push(M.key());return O}getExtensionsReport(){const N=new Date().getTime();return(!this.reportedExtensions||N-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=N),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const N=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${N.length} reported extensions from service`),N}catch(N){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(N,O,D,M){const _=M?M instanceof y.ExtensionManagementError?M.code:z:void 0;this.telemetryService.publicLogError(N,Object.assign(Object.assign({},O),{success:!M,duration:D,errorcode:_}))}};H=de([K(0,n.INativeEnvironmentService),K(1,y.IExtensionGalleryService),K(2,E.ILogService),K(3,a.optional(i.IDownloadService)),K(4,o.ITelemetryService),K(5,a.IInstantiationService),K(6,F.IFileService)],H),e.ExtensionManagementService=H}),define(Z[212],ee([0,1,48,35,213,102,51,101,36,77,50,149,9,131,133,28,206,174,23,165,39,166,24,59,172,81,82,177,15,78,158,56,2,167,73,162,163,154,153,151,150,173,72,159,10,161,17,27,22,199,201,196,58,197,202,171,21,169,198,60,195,175,61,74,135,203,176,87,86,85,4,152,144,11,43,83,184,179,200,142,146,178,5,12]),function(G,e,v,L,k,A,T,R,y,p,n,m,h,b,f,C,P,E,I,d,o,s,t,r,i,a,u,c,l,S,w,g,U,F,j,$,V,q,z,H,Q,N,O,D,M,_,x,B,J,X,te,ie,ce,le,ve,pe,Ce,Ae,Me,Te,ke,je,Ie,Oe,Ye,Je,$e,xe,Y,re,se,me,Se,De,be,Ue,Pe,W,ne,ae,oe,he,ge,fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ye extends U.Disposable{constructor(ue){super();this.configuration=ue,this.server=this._register(new R.Server),k.gracefulify(v),this.registerListeners()}registerListeners(){const ue=()=>this.dispose();process.once("exit",ue),A.ipcRenderer.once("vscode:electron-main->shared-process=exit",ue)}async open(){const ue=await this.initServices();J.registerConfiguration(),ue.invokeFunction(Re=>{const Fe=Re.get(l.ILogService);Fe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Re),this.registerErrorHandler(Fe)}),this._register(U.combinedDisposable(ue.createInstance($.CodeCacheCleaner,this.configuration.codeCachePath),ue.createInstance(V.LanguagePackCachedDataCleaner),ue.createInstance(q.StorageDataCleaner,this.configuration.backupWorkspacesPath),ue.createInstance(z.LogsDataCleaner),ue.createInstance(me.LocalizationsUpdater),ue.createInstance(Se.DeprecatedExtensionsCleaner)))}async initServices(){const ue=new p.ServiceCollection,Re=Object.assign({_serviceBrand:void 0},T.default);ue.set(B.IProductService,Re);const Fe=new y.StaticRouter(Be=>Be==="main"),_e=new Q.MessagePortMainProcessService(this.server,Fe);ue.set(H.IMainProcessService,_e);const Ne=new b.NativeEnvironmentService(this.configuration.args,Re);ue.set(h.INativeEnvironmentService,Ne);const nt=new S.LogLevelChannelClient(this.server.getChannel("logLevel",Fe)),Xe=new S.LoggerChannelClient(this.configuration.logLevel,nt.onDidChangeLogLevel,_e.getChannel("logger"));ue.set(l.ILoggerService,Xe);const rt=this._register(new l.MultiplexLogService([this._register(new l.ConsoleLogger(this.configuration.logLevel)),this._register(Xe.createLogger(fe.joinPath(ge.URI.file(Ne.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ve=this._register(new S.FollowerLogService(nt,rt));ue.set(l.ILogService,Ve);const He=this._register(new D.FileService(Ve));ue.set(M.IFileService,He);const st=this._register(new _.DiskFileSystemProvider(Ve));He.registerProvider(x.Schemas.file,st);const We=this._register(new d.ConfigurationService(Ne.settingsResource,He));ue.set(I.IConfigurationService,We),await We.initialize();const Qe=new pe.NativeStorageService(void 0,_e,Ne);ue.set(Ce.IStorageService,Qe),await Qe.initialize(),this._register(U.toDisposable(()=>Qe.flush())),ue.set(o.IRequestService,new n.SyncDescriptor(s.RequestService)),ue.set(ae.IChecksumService,new n.SyncDescriptor(oe.ChecksumService));const it=y.ProxyChannel.toService(_e.getChannel("nativeHost"),{context:this.configuration.windowId});ue.set(ce.INativeHostService,it),ue.set(j.IDownloadService,new n.SyncDescriptor(F.DownloadService));const at=this._register(new Je.ActiveWindowManager(it)),gt=new y.StaticRouter(Be=>at.getActiveClientId().then(ot=>Be===ot));ue.set(Oe.IExtensionRecommendationNotificationService,new Ye.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",gt)));let Ze,Ge;if(!Ne.isExtensionDevelopment&&!Ne.disableTelemetry&&Re.enableTelemetry){Ge=new $e.TelemetryLogAppender(Xe,Ne);const{appRoot:Be,extensionsPath:ot,isBuilt:vt,installSourcePath:yt}=Ne;if(Re.aiConfig&&Re.aiConfig.asimovKey&&vt){const ht=new c.AppInsightsAppender("monacoworkbench",null,Re.aiConfig.asimovKey);this._register(U.toDisposable(()=>ht.flush())),Ge=r.combinedAppender(ht,Ge)}Ze=new u.TelemetryService({appender:Ge,commonProperties:i.resolveCommonProperties(He,L.release(),L.hostname(),process.arch,Re.commit,Re.version,this.configuration.machineId,Re.msftInternalDomains,yt),sendErrorTelemetry:!0,piiPaths:[Be,ot]},We)}else Ze=r.NullTelemetryService,Ge=r.NullAppender;this.server.registerChannel("telemetryAppender",new a.TelemetryAppenderChannel(Ge)),ue.set(t.ITelemetryService,Ze);const mt=new he.CustomEndpointTelemetryService(We,Ze);return ue.set(t.ICustomEndpointTelemetryService,mt),ue.set(C.IExtensionManagementService,new n.SyncDescriptor(P.ExtensionManagementService)),ue.set(C.IExtensionGalleryService,new n.SyncDescriptor(E.ExtensionGalleryService)),ue.set(C.IExtensionTipsService,new n.SyncDescriptor(je.ExtensionTipsService)),ue.set(g.ILocalizationsService,new n.SyncDescriptor(w.LocalizationsService)),ue.set(O.IDiagnosticsService,new n.SyncDescriptor(N.DiagnosticsService)),ue.set(Te.IUserDataSyncAccountService,new n.SyncDescriptor(Te.UserDataSyncAccountService)),ue.set(J.IUserDataSyncLogService,new n.SyncDescriptor(le.UserDataSyncLogService)),ue.set(J.IUserDataSyncUtilService,new ie.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Be=>Be.ctx!=="main"))),ue.set(C.IGlobalExtensionEnablementService,new n.SyncDescriptor(Ae.GlobalExtensionEnablementService)),ue.set(Y.IIgnoredExtensionsManagementService,new n.SyncDescriptor(Y.IgnoredExtensionsManagementService)),ue.set(re.IExtensionsStorageSyncService,new n.SyncDescriptor(re.ExtensionsStorageSyncService)),ue.set(J.IUserDataSyncStoreManagementService,new n.SyncDescriptor(te.UserDataSyncStoreManagementService)),ue.set(J.IUserDataSyncStoreService,new n.SyncDescriptor(te.UserDataSyncStoreService)),ue.set(Ie.IUserDataSyncMachinesService,new n.SyncDescriptor(Ie.UserDataSyncMachinesService)),ue.set(J.IUserDataSyncBackupStoreService,new n.SyncDescriptor(ke.UserDataSyncBackupStoreService)),ue.set(J.IUserDataAutoSyncEnablementService,new n.SyncDescriptor(xe.UserDataAutoSyncEnablementService)),ue.set(J.IUserDataSyncResourceEnablementService,new n.SyncDescriptor(Me.UserDataSyncResourceEnablementService)),ue.set(J.IUserDataSyncService,new n.SyncDescriptor(X.UserDataSyncService)),ue.set(W.ILocalPtyService,this._register(new Pe.PtyHostService({GraceTime:6e4,ShortGraceTime:6e3},We,Ve,Ze))),new m.InstantiationService(ue)}initChannels(ue){const Re=new f.ExtensionManagementChannel(ue.get(C.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Re);const Fe=y.ProxyChannel.fromService(ue.get(g.ILocalizationsService));this.server.registerChannel("localizations",Fe);const _e=y.ProxyChannel.fromService(ue.get(O.IDiagnosticsService));this.server.registerChannel("diagnostics",_e);const Ne=new f.ExtensionTipsChannel(ue.get(C.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ne);const nt=y.ProxyChannel.fromService(ue.get(ae.IChecksumService));this.server.registerChannel("checksum",nt);const Xe=new ie.UserDataSyncMachinesServiceChannel(ue.get(Ie.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Xe);const rt=y.ProxyChannel.fromService(ue.get(t.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",rt);const Ve=new ie.UserDataSyncAccountServiceChannel(ue.get(Te.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ve);const He=new ie.UserDataSyncStoreManagementServiceChannel(ue.get(J.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",He);const st=new ne.UserDataSyncChannel(ue.get(J.IUserDataSyncService),ue.get(l.ILogService));this.server.registerChannel("userDataSync",st);const We=this._register(ue.get(se.IInstantiationService).createInstance(ve.UserDataAutoSyncService)),Qe=new ie.UserDataAutoSyncChannel(We);this.server.registerChannel("userDataAutoSync",Qe);const it=ue.get(W.ILocalPtyService),at=y.ProxyChannel.fromService(it);this.server.registerChannel(Ue.TerminalIpcChannels.LocalPty,at)}registerErrorHandler(ue){window.addEventListener("unhandledrejection",Re=>{De.onUnexpectedError(Re.reason),Re.preventDefault()}),De.setUnexpectedErrorHandler(Re=>{const Fe=be.toErrorMessage(Re,!0);!Fe||ue.error(`[uncaught exception in sharedProcess]: ${Fe}`)})}}async function we(Ee){const ue=new ye(Ee);A.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ue.open(),A.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=we})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9744231fc12f1aed21089180b3f0394d694bd2a2/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
