/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","os","vs/base/common/uuid","vs/platform/workspaces/common/workspaces","fs","vs/base/common/extpath","vs/base/common/labels","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/arrays","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/tunnel","vs/platform/sign/common/sign","vs/platform/webview/common/webviewManagerService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/processes","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/code/electron-main/auth","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.snap","vs/platform/update/electron-main/updateService.win32","vs/platform/issue/electron-main/issueMainService","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],x=function($){for(var e=[],m=0,L=$.length;m<L;m++)e[m]=Z[$[m]];return e};define(Z[104],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(L,R){if(!L)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=m}),define(Z[46],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(I){return(n,v,y)=>{let i=null,E=null;if(typeof y.value=="function"?(i="value",E=y.value):typeof y.get=="function"&&(i="get",E=y.get),!E)throw new Error("not supported");y[i]=I(E,v)}}e.createDecorator=m;function L(I,n,v){let y=null,i=null;if(typeof v.value=="function"?(y="value",i=v.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(y="get",i=v.get),!i)throw new Error("not supported");const E=`$memoize$${n}`;v[y]=function(...M){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,M)}),this[E]}}e.memoize=L;function R(I,n,v){return m((y,i)=>{const E=`$debounce$${i}`,M=`$debounce$result$${i}`;return function(...p){this[M]||(this[M]=v?v():void 0),clearTimeout(this[E]),n&&(this[M]=n(this[M],...p),p=[this[M]]),this[E]=setTimeout(()=>{y.apply(this,p),this[M]=v?v():void 0},I)}})}e.debounce=R;function S(I,n,v){return m((y,i)=>{const E=`$throttle$timer$${i}`,M=`$throttle$result$${i}`,p=`$throttle$lastRun$${i}`,d=`$throttle$pending$${i}`;return function(...g){if(this[M]||(this[M]=v?v():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),n&&(this[M]=n(this[M],...g)),this[d])return;const k=this[p]+I;k<=Date.now()?(this[p]=Date.now(),y.apply(this,[this[M]]),this[M]=v?v():void 0):(this[d]=!0,this[E]=setTimeout(()=>{this[d]=!1,this[p]=Date.now(),y.apply(this,[this[M]]),this[M]=v?v():void 0},k-Date.now()))}})}e.throttle=S}),define(Z[16],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=m,e.errorHandler=new m;function L(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=L;function R(l){v(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=R;function S(l){v(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=S;function I(l){if(l instanceof Error){let{name:t,message:r}=l;const s=l.stacktrace||l.stack;return{$isError:!0,name:t,message:r,stack:s}}return l}e.transformErrorForSerialization=I;const n="Canceled";function v(l){return l instanceof Error&&l.name===n&&l.message===n}e.isPromiseCanceledError=v;class y extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=y;function i(){const l=new Error(n);return l.name=l.message,l}e.canceled=i;function E(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=E;function M(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=M;function p(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function d(l){const t=new Error(`${l} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function g(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=g;class k extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=k;class P extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=P;class c extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=c;function h(l){const t=l;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=h;function o(l,t=Object.create(null)){const r=new Error(l);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=o}),define(Z[36],x([0,1,16]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(H,W=0){return H[H.length-(1+W)]}e.tail=L;function R(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.tail2=R;function S(H,W,D=(O,F)=>O===F){if(H===W)return!0;if(!H||!W||H.length!==W.length)return!1;for(let O=0,F=H.length;O<F;O++)if(!D(H[O],W[O]))return!1;return!0}e.equals=S;function I(H,W,D){let O=0,F=H.length-1;for(;O<=F;){const T=(O+F)/2|0,_=D(H[T],W);if(_<0)O=T+1;else if(_>0)F=T-1;else return T}return-(O+1)}e.binarySearch=I;function n(H,W){let D=0,O=H.length;if(O===0)return 0;for(;D<O;){const F=Math.floor((D+O)/2);W(H[F])?O=F:D=F+1}return D}e.findFirstInSorted=n;function v(H,W,D){if(H=H|0,H>=W.length)throw new TypeError("invalid index");let O=W[Math.floor(W.length*Math.random())],F=[],T=[],_=[];for(let N of W){const K=D(N,O);K<0?F.push(N):K>0?T.push(N):_.push(N)}return H<F.length?v(H,F,D):H<F.length+_.length?_[0]:v(H-(F.length+_.length),T,D)}e.quickSelect=v;function y(H,W){const D=[];let O;for(const F of H.slice(0).sort(W))!O||W(O[0],F)!==0?(O=[F],D.push(O)):O.push(F);return D}e.groupBy=y;function i(H,W,D){const O=[];function F(N,K,V){if(K===0&&V.length===0)return;const Q=O[O.length-1];Q&&Q.start+Q.deleteCount===N?(Q.deleteCount+=K,Q.toInsert.push(...V)):O.push({start:N,deleteCount:K,toInsert:V})}let T=0,_=0;for(;;){if(T===H.length){F(T,0,W.slice(_));break}if(_===W.length){F(T,H.length-T,[]);break}const N=H[T],K=W[_],V=D(N,K);V===0?(T+=1,_+=1):V<0?(F(T,1,[]),T+=1):V>0&&(F(T,0,[K]),_+=1)}return O}e.sortedDiff=i;function E(H,W,D){const O=i(H,W,D),F=[],T=[];for(const _ of O)F.push(...H.slice(_.start,_.start+_.deleteCount)),T.push(..._.toInsert);return{removed:F,added:T}}e.delta=E;function M(H,W,D){if(D===0)return[];const O=H.slice(0,D).sort(W);return d(H,W,O,D,H.length),O}e.top=M;function p(H,W,D,O,F){return D===0?Promise.resolve([]):new Promise((T,_)=>{(async()=>{const N=H.length,K=H.slice(0,D).sort(W);for(let V=D,Q=Math.min(D+O,N);V<N;V=Q,Q=Math.min(Q+O,N)){if(V>D&&await new Promise(ne=>setTimeout(ne)),F&&F.isCancellationRequested)throw m.canceled();d(H,W,K,V,Q)}return K})().then(T,_)})}e.topAsync=p;function d(H,W,D,O,F){for(const T=D.length;O<F;O++){const _=H[O];if(W(_,D[T-1])<0){D.pop();const N=n(D,K=>W(_,K)<0);D.splice(N,0,_)}}}function g(H){return H.filter(W=>!!W)}e.coalesce=g;function k(H){let W=0;for(let D=0;D<H.length;D++)H[D]&&(H[W]=H[D],W+=1);H.length=W}e.coalesceInPlace=k;function P(H,W,D){H.splice(D,0,H.splice(W,1)[0])}e.move=P;function c(H){return!Array.isArray(H)||H.length===0}e.isFalsyOrEmpty=c;function h(H){return Array.isArray(H)&&H.length>0}e.isNonEmptyArray=h;function o(H,W){if(!W)return H.filter((O,F)=>H.indexOf(O)===F);const D=Object.create(null);return H.filter(O=>{const F=W(O);return D[F]?!1:(D[F]=!0,!0)})}e.distinct=o;function l(H){const W=new Set;return H.filter(D=>W.has(D)?!1:(W.add(D),!0))}e.distinctES6=l;function t(H){const W=Object.create(null);return D=>{const O=H(D);return W[O]?!1:(W[O]=!0,!0)}}e.uniqueFilter=t;function r(H,W){for(let D=H.length-1;D>=0;D--){const O=H[D];if(W(O))return D}return-1}e.lastIndex=r;function s(H,W){return H.length>0?H[0]:W}e.firstOrDefault=s;function a(H,W,D=(O,F)=>O===F){let O=0;for(let F=0,T=Math.min(H.length,W.length);F<T&&D(H[F],W[F]);F++)O++;return O}e.commonPrefixLength=a;function u(H){return[].concat(...H)}e.flatten=u;function w(H,W){let D=typeof W=="number"?H:0;typeof W=="number"?D=H:(D=0,W=H);const O=[];if(D<=W)for(let F=D;F<W;F++)O.push(F);else for(let F=D;F>W;F--)O.push(F);return O}e.range=w;function f(H,W,D){return H.reduce((O,F)=>(O[W(F)]=D?D(F):F,O),Object.create(null))}e.index=f;function b(H,W){return H.push(W),()=>A(H,W)}e.insert=b;function A(H,W){const D=H.indexOf(W);if(D>-1)return H.splice(D,1),W}e.remove=A;function U(H,W,D){const O=H.slice(0,W),F=H.slice(W);return O.concat(D,F)}e.arrayInsert=U;function q(H,W){let D;if(typeof W=="number"){let O=W;D=()=>{const F=Math.sin(O++)*179426549;return F-Math.floor(F)}}else D=Math.random;for(let O=H.length-1;O>0;O-=1){const F=Math.floor(D()*(O+1)),T=H[O];H[O]=H[F],H[F]=T}}e.shuffle=q;function J(H,W){const D=H.indexOf(W);D>-1&&(H.splice(D,1),H.unshift(W))}e.pushToStart=J;function te(H,W){const D=H.indexOf(W);D>-1&&(H.splice(D,1),H.push(W))}e.pushToEnd=te;function B(H,W){return Array.isArray(H)?H.map(W):W(H)}e.mapArrayOrNot=B;function Y(H){return Array.isArray(H)?H:[H]}e.asArray=Y;function G(H){return H[Math.floor(Math.random()*H.length)]}e.getRandomElement=G;function C(H,W){for(const D of H){const O=W(D);if(O!==void 0)return O}}e.mapFind=C;function z(H,W){let D=Number.MAX_SAFE_INTEGER,O=0;return H.forEach((F,T)=>{const _=W(F);_<D&&(D=_,O=T)}),O}e.minIndex=z;function X(H,W){let D=Number.MIN_SAFE_INTEGER,O=0;return H.forEach((F,T)=>{const _=W(F);_>D&&(D=_,O=T)}),O}e.maxIndex=X}),define(Z[43],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(L){const R=this;let S=!1,I;return function(){return S||(S=!0,I=L.apply(R,arguments)),I}}e.once=m}),define(Z[63],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(L){function R(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}L.is=R;const S=Object.freeze([]);function I(){return S}L.empty=I;function*n(l){yield l}L.single=n;function v(l){return l||S}L.from=v;function y(l){return!l||l[Symbol.iterator]().next().done===!0}L.isEmpty=y;function i(l){return l[Symbol.iterator]().next().value}L.first=i;function E(l,t){for(const r of l)if(t(r))return!0;return!1}L.some=E;function M(l,t){for(const r of l)if(t(r))return r}L.find=M;function*p(l,t){for(const r of l)t(r)&&(yield r)}L.filter=p;function*d(l,t){let r=0;for(const s of l)yield t(s,r++)}L.map=d;function*g(...l){for(const t of l)for(const r of t)yield r}L.concat=g;function*k(l){for(const t of l)for(const r of t)yield r}L.concatNested=k;function P(l,t,r){let s=r;for(const a of l)s=t(s,a);return s}L.reduce=P;function*c(l,t,r=l.length){for(t<0&&(t+=l.length),r<0?r+=l.length:r>l.length&&(r=l.length);t<r;t++)yield l[t]}L.slice=c;function h(l,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,l];const s=l[Symbol.iterator]();for(let a=0;a<t;a++){const u=s.next();if(u.done)return[r,L.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return s}}]}L.consume=h;function o(l,t,r=(s,a)=>s===a){const s=l[Symbol.iterator](),a=t[Symbol.iterator]();for(;;){const u=s.next(),w=a.next();if(u.done!==w.done)return!1;if(u.done)return!0;if(!r(u.value,w.value))return!1}}L.equals=o})(m=e.Iterable||(e.Iterable={}))}),define(Z[40],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(t){t.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function I(t,r=!1){let s=0,a=t.length,u="",w=0,f=16,b=0;function A(G){let C=0,z=0;for(;C<G;){const X=t.charCodeAt(s);if(X>=48&&X<=57)z=z*16+X-48;else if(X>=65&&X<=70)z=z*16+X-65+10;else if(X>=97&&X<=102)z=z*16+X-97+10;else break;s++,C++}return C<G&&(z=-1),z}function U(G){s=G,u="",w=0,f=16,b=0}function q(){const G=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&y(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&y(t.charCodeAt(s)))for(s++;s<t.length&&y(t.charCodeAt(s));)s++;else return b=3,t.substring(G,s);let C=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&y(t.charCodeAt(s))){for(s++;s<t.length&&y(t.charCodeAt(s));)s++;C=s}else b=3;return t.substring(G,C)}function J(){let G="",C=s;for(;;){if(s>=a){G+=t.substring(C,s),b=2;break}const z=t.charCodeAt(s);if(z===34){G+=t.substring(C,s),s++;break}if(z===92){if(G+=t.substring(C,s),s++,s>=a){b=2;break}switch(t.charCodeAt(s++)){case 34:G+='"';break;case 92:G+="\\";break;case 47:G+="/";break;case 98:G+="\b";break;case 102:G+="\f";break;case 110:G+=`
`;break;case 114:G+="\r";break;case 116:G+="	";break;case 117:const H=A(4);H>=0?G+=String.fromCharCode(H):b=4;break;default:b=5}C=s;continue}if(z>=0&&z<=31)if(v(z)){G+=t.substring(C,s),b=2;break}else b=6;s++}return G}function te(){if(u="",b=0,w=s,s>=a)return w=a,f=17;let G=t.charCodeAt(s);if(n(G)){do s++,u+=String.fromCharCode(G),G=t.charCodeAt(s);while(n(G));return f=15}if(v(G))return s++,u+=String.fromCharCode(G),G===13&&t.charCodeAt(s)===10&&(s++,u+=`
`),f=14;switch(G){case 123:return s++,f=1;case 125:return s++,f=2;case 91:return s++,f=3;case 93:return s++,f=4;case 58:return s++,f=6;case 44:return s++,f=5;case 34:return s++,u=J(),f=10;case 47:const C=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<a&&!v(t.charCodeAt(s));)s++;return u=t.substring(C,s),f=12}if(t.charCodeAt(s+1)===42){s+=2;const z=a-1;let X=!1;for(;s<z;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,X=!0;break}s++}return X||(s++,b=1),u=t.substring(C,s),f=13}return u+=String.fromCharCode(G),s++,f=16;case 45:if(u+=String.fromCharCode(G),s++,s===a||!y(t.charCodeAt(s)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=q(),f=11;default:for(;s<a&&B(G);)s++,G=t.charCodeAt(s);if(w!==s){switch(u=t.substring(w,s),u){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return u+=String.fromCharCode(G),s++,f=16}}function B(G){if(n(G)||v(G))return!1;switch(G){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Y(){let G;do G=te();while(G>=12&&G<=15);return G}return{setPosition:U,getPosition:()=>s,scan:r?Y:te,getToken:()=>f,getTokenValue:()=>u,getTokenOffset:()=>w,getTokenLength:()=>s-w,getTokenError:()=>b}}e.createScanner=I;function n(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function v(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function E(t,r){const s=[],a=new Object;let u;const w={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function b(A,U,q,J){w.value=A,w.offset=U,w.length=q,w.type=J,w.colonOffset=void 0,u=w}try{h(t,{onObjectBegin:(A,U)=>{if(r<=A)throw a;u=void 0,f=r>A,s.push("")},onObjectProperty:(A,U,q)=>{if(r<U||(b(A,U,q,"property"),s[s.length-1]=A,r<=U+q))throw a},onObjectEnd:(A,U)=>{if(r<=A)throw a;u=void 0,s.pop()},onArrayBegin:(A,U)=>{if(r<=A)throw a;u=void 0,s.push(0)},onArrayEnd:(A,U)=>{if(r<=A)throw a;u=void 0,s.pop()},onLiteralValue:(A,U,q)=>{if(r<U||(b(A,U,q,l(A)),r<=U+q))throw a},onSeparator:(A,U,q)=>{if(r<=U)throw a;if(A===":"&&u&&u.type==="property")u.colonOffset=U,f=!1,u=void 0;else if(A===","){const J=s[s.length-1];typeof J=="number"?s[s.length-1]=J+1:(f=!0,s[s.length-1]=""),u=void 0}}})}catch(A){if(A!==a)throw A}return{path:s,previousNode:u,isAtPropertyKey:f,matches:A=>{let U=0;for(let q=0;U<A.length&&q<s.length;q++)if(A[U]===s[q]||A[U]==="*")U++;else if(A[U]!=="**")return!1;return U===A.length}}}e.getLocation=E;function M(t,r=[],s=S.DEFAULT){let a=null,u=[];const w=[];function f(A){Array.isArray(u)?u.push(A):a!==null&&(u[a]=A)}return h(t,{onObjectBegin:()=>{const A={};f(A),w.push(u),u=A,a=null},onObjectProperty:A=>{a=A},onObjectEnd:()=>{u=w.pop()},onArrayBegin:()=>{const A=[];f(A),w.push(u),u=A,a=null},onArrayEnd:()=>{u=w.pop()},onLiteralValue:f,onError:(A,U,q)=>{r.push({error:A,offset:U,length:q})}},s),u[0]}e.parse=M;function p(t,r=[],s=S.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(A){a.type==="property"&&(a.length=A-a.offset,a=a.parent)}function w(A){return a.children.push(A),A}h(t,{onObjectBegin:A=>{a=w({type:"object",offset:A,length:-1,parent:a,children:[]})},onObjectProperty:(A,U,q)=>{a=w({type:"property",offset:U,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:A,offset:U,length:q,parent:a})},onObjectEnd:(A,U)=>{a.length=A+U-a.offset,a=a.parent,u(A+U)},onArrayBegin:(A,U)=>{a=w({type:"array",offset:A,length:-1,parent:a,children:[]})},onArrayEnd:(A,U)=>{a.length=A+U-a.offset,a=a.parent,u(A+U)},onLiteralValue:(A,U,q)=>{w({type:l(A),offset:U,length:q,parent:a,value:A}),u(U+q)},onSeparator:(A,U,q)=>{a.type==="property"&&(A===":"?a.colonOffset=U:A===","&&u(U))},onError:(A,U,q)=>{r.push({error:A,offset:U,length:q})}},s);const b=a.children[0];return b&&delete b.parent,b}e.parseTree=p;function d(t,r){if(!t)return;let s=t;for(let a of r)if(typeof a=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let u=!1;for(const w of s.children)if(Array.isArray(w.children)&&w.children[0].value===a){s=w.children[1],u=!0;break}if(!u)return}else{const u=a;if(s.type!=="array"||u<0||!Array.isArray(s.children)||u>=s.children.length)return;s=s.children[u]}return s}e.findNodeAtLocation=d;function g(t){if(!t.parent||!t.parent.children)return[];const r=g(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}e.getNodePath=g;function k(t){switch(t.type){case"array":return t.children.map(k);case"object":const r=Object.create(null);for(let s of t.children){const a=s.children[1];a&&(r[s.children[0].value]=k(a))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=k;function P(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}e.contains=P;function c(t,r,s=!1){if(P(t,r,s)){const a=t.children;if(Array.isArray(a))for(let u=0;u<a.length&&a[u].offset<=r;u++){const w=c(a[u],r,s);if(w)return w}return t}}e.findNodeAtOffset=c;function h(t,r,s=S.DEFAULT){const a=I(t,!1);function u(_){return _?()=>_(a.getTokenOffset(),a.getTokenLength()):()=>!0}function w(_){return _?N=>_(N,a.getTokenOffset(),a.getTokenLength()):()=>!0}const f=u(r.onObjectBegin),b=w(r.onObjectProperty),A=u(r.onObjectEnd),U=u(r.onArrayBegin),q=u(r.onArrayEnd),J=w(r.onLiteralValue),te=w(r.onSeparator),B=u(r.onComment),Y=w(r.onError),G=s&&s.disallowComments,C=s&&s.allowTrailingComma;function z(){for(;;){const _=a.scan();switch(a.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:G||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(_){case 12:case 13:G?X(10):B();break;case 16:X(1);break;case 15:case 14:break;default:return _}}}function X(_,N=[],K=[]){if(Y(_),N.length+K.length>0){let V=a.getToken();for(;V!==17;){if(N.indexOf(V)!==-1){z();break}else if(K.indexOf(V)!==-1)break;V=z()}}}function H(_){const N=a.getTokenValue();return _?J(N):b(N),z(),!0}function W(){switch(a.getToken()){case 11:let _=0;try{_=JSON.parse(a.getTokenValue()),typeof _!="number"&&(X(2),_=0)}catch(N){X(2)}J(_);break;case 7:J(null);break;case 8:J(!0);break;case 9:J(!1);break;default:return!1}return z(),!0}function D(){return a.getToken()!==10?(X(3,[],[2,5]),!1):(H(!1),a.getToken()===6?(te(":"),z(),T()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function O(){f(),z();let _=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(_||X(4,[],[]),te(","),z(),a.getToken()===2&&C)break}else _&&X(6,[],[]);D()||X(4,[],[2,5]),_=!0}return A(),a.getToken()!==2?X(7,[2],[]):z(),!0}function F(){U(),z();let _=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(_||X(4,[],[]),te(","),z(),a.getToken()===4&&C)break}else _&&X(6,[],[]);T()||X(4,[],[4,5]),_=!0}return q(),a.getToken()!==4?X(8,[4],[]):z(),!0}function T(){switch(a.getToken()){case 3:return F();case 1:return O();case 10:return H(!0);default:return W()}}return z(),a.getToken()===17?s.allowEmptyContent?!0:(X(4,[],[]),!1):T()?(a.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.visit=h;function o(t,r){let s=I(t),a=[],u,w=0,f;do switch(f=s.getPosition(),u=s.scan(),u){case 12:case 13:case 17:w!==f&&a.push(t.substring(w,f)),r!==void 0&&a.push(s.getTokenValue().replace(/[^\r\n]/g,r)),w=s.getPosition();break}while(u!==17);return a.join("")}e.stripComments=o;function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(Z[105],x([0,1,40]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(v,y,i){let E,M,p,d,g;if(y){for(d=y.offset,g=d+y.length,p=d;p>0&&!n(v,p-1);)p--;let w=g;for(;w<v.length&&!n(v,w);)w++;M=v.substring(p,w),E=S(M,i)}else M=v,E=0,p=0,d=0,g=v.length;const k=I(i,v);let P=!1,c=0,h;i.insertSpaces?h=R(" ",i.tabSize||4):h="	";const o=m.createScanner(M,!1);let l=!1;function t(){return k+R(h,E+c)}function r(){let w=o.scan();for(P=!1;w===15||w===14;)P=P||w===14,w=o.scan();return l=w===16||o.getTokenError()!==0,w}const s=[];function a(w,f,b){!l&&f<g&&b>d&&v.substring(f,b)!==w&&s.push({offset:f,length:b-f,content:w})}let u=r();if(u!==17){const w=o.getTokenOffset()+p,f=R(h,E);a(f,p,w)}for(;u!==17;){let w=o.getTokenOffset()+o.getTokenLength()+p,f=r(),b="";for(;!P&&(f===12||f===13);){const U=o.getTokenOffset()+p;a(" ",w,U),w=o.getTokenOffset()+o.getTokenLength()+p,b=f===12?t():"",f=r()}if(f===2)u!==1&&(c--,b=t());else if(f===4)u!==3&&(c--,b=t());else{switch(u){case 3:case 1:c++,b=t();break;case 5:case 12:b=t();break;case 13:P?b=t():b=" ";break;case 6:b=" ";break;case 10:if(f===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?b=" ":f!==5&&f!==17&&(l=!0);break;case 16:l=!0;break}P&&(f===12||f===13)&&(b=t())}const A=o.getTokenOffset()+p;a(b,w,A),u=f}return s}e.format=L;function R(v,y){let i="";for(let E=0;E<y;E++)i+=v;return i}function S(v,y){let i=0,E=0;const M=y.tabSize||4;for(;i<v.length;){const p=v.charAt(i);if(p===" ")E++;else if(p==="	")E+=M;else break;i++}return Math.floor(E/M)}function I(v,y){for(let i=0;i<y.length;i++){const E=y.charAt(i);if(E==="\r")return i+1<y.length&&y.charAt(i+1)===`
`?`\r
`:"\r";if(E===`
`)return`
`}return v&&v.eol||`
`}e.getEOL=I;function n(v,y){return`\r
`.indexOf(v.charAt(y))!==-1}e.isEOL=n}),define(Z[78],x([0,1,40,105]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(y,i,E){return S(y,i,void 0,E)}e.removeProperty=R;function S(y,i,E,M,p){const d=i.slice(),g=[],k=m.parseTree(y,g);let P,c;for(;d.length>0&&(c=d.pop(),P=m.findNodeAtLocation(k,d),P===void 0&&E!==void 0);)typeof c=="string"?E={[c]:E}:E=[E];if(P)if(P.type==="object"&&typeof c=="string"&&Array.isArray(P.children)){const h=m.findNodeAtLocation(P,[c]);if(h!==void 0)if(E===void 0){if(!h.parent)throw new Error("Malformed AST");const o=P.children.indexOf(h.parent);let l,t=h.parent.offset+h.parent.length;if(o>0){const r=P.children[o-1];l=r.offset+r.length}else l=P.offset+1,P.children.length>1&&(t=P.children[1].offset);return I(y,{offset:l,length:t-l,content:""},M)}else return I(y,{offset:h.offset,length:h.length,content:JSON.stringify(E)},M);else{if(E===void 0)return[];const o=`${JSON.stringify(c)}: ${JSON.stringify(E)}`,l=p?p(P.children.map(r=>r.children[0].value)):P.children.length;let t;if(l>0){const r=P.children[l-1];t={offset:r.offset+r.length,length:0,content:","+o}}else P.children.length===0?t={offset:P.offset+1,length:0,content:o}:t={offset:P.offset+1,length:0,content:o+","};return I(y,t,M)}}else if(P.type==="array"&&typeof c=="number"&&Array.isArray(P.children))if(E!==void 0){const h=`${JSON.stringify(E)}`;let o;if(P.children.length===0||c===0)o={offset:P.offset+1,length:0,content:P.children.length===0?h:h+","};else{const l=c===-1||c>P.children.length?P.children.length:c,t=P.children[l-1];o={offset:t.offset+t.length,length:0,content:","+h}}return I(y,o,M)}else{const h=c,o=P.children[h];let l;if(P.children.length===1)l={offset:P.offset+1,length:P.length-2,content:""};else if(P.children.length-1===h){const t=P.children[h-1],r=t.offset+t.length,s=P.offset+P.length;l={offset:r,length:s-2-r,content:""}}else l={offset:o.offset,length:P.children[h+1].offset-o.offset,content:""};return I(y,l,M)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${P.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return I(y,{offset:k?k.offset:0,length:k?k.length:0,content:JSON.stringify(E)},M)}}e.setProperty=S;function I(y,i,E){let M=n(y,i),p=i.offset,d=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;p>0&&!L.isEOL(M,p-1);)p--;for(;d<M.length&&!L.isEOL(M,d);)d++}const g=L.format(M,{offset:p,length:d-p},E);for(let P=g.length-1;P>=0;P--){const c=g[P];M=n(M,c),p=Math.min(p,c.offset),d=Math.max(d,c.offset+c.length),d+=c.content.length-c.length}const k=y.length-(M.length-d)-p;return[{offset:p,length:k,content:M.substring(p,d)}]}e.withFormatting=I;function n(y,i){return y.substring(0,i.offset)+i.content+y.substring(i.offset+i.length)}e.applyEdit=n;function v(y,i){let E=i.slice(0).sort((p,d)=>{const g=p.offset-d.offset;return g===0?p.length-d.length:g}),M=y.length;for(let p=E.length-1;p>=0;p--){let d=E[p];if(d.offset+d.length<=M)y=n(y,d);else throw new Error("Overlapping edit");M=d.offset}return y}e.applyEdits=v}),define(Z[57],x([0,1,16]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var L;(function(c){c[c.DependsOnKbLayout=-1]="DependsOnKbLayout",c[c.Unknown=0]="Unknown",c[c.Backspace=1]="Backspace",c[c.Tab=2]="Tab",c[c.Enter=3]="Enter",c[c.Shift=4]="Shift",c[c.Ctrl=5]="Ctrl",c[c.Alt=6]="Alt",c[c.PauseBreak=7]="PauseBreak",c[c.CapsLock=8]="CapsLock",c[c.Escape=9]="Escape",c[c.Space=10]="Space",c[c.PageUp=11]="PageUp",c[c.PageDown=12]="PageDown",c[c.End=13]="End",c[c.Home=14]="Home",c[c.LeftArrow=15]="LeftArrow",c[c.UpArrow=16]="UpArrow",c[c.RightArrow=17]="RightArrow",c[c.DownArrow=18]="DownArrow",c[c.Insert=19]="Insert",c[c.Delete=20]="Delete",c[c.KEY_0=21]="KEY_0",c[c.KEY_1=22]="KEY_1",c[c.KEY_2=23]="KEY_2",c[c.KEY_3=24]="KEY_3",c[c.KEY_4=25]="KEY_4",c[c.KEY_5=26]="KEY_5",c[c.KEY_6=27]="KEY_6",c[c.KEY_7=28]="KEY_7",c[c.KEY_8=29]="KEY_8",c[c.KEY_9=30]="KEY_9",c[c.KEY_A=31]="KEY_A",c[c.KEY_B=32]="KEY_B",c[c.KEY_C=33]="KEY_C",c[c.KEY_D=34]="KEY_D",c[c.KEY_E=35]="KEY_E",c[c.KEY_F=36]="KEY_F",c[c.KEY_G=37]="KEY_G",c[c.KEY_H=38]="KEY_H",c[c.KEY_I=39]="KEY_I",c[c.KEY_J=40]="KEY_J",c[c.KEY_K=41]="KEY_K",c[c.KEY_L=42]="KEY_L",c[c.KEY_M=43]="KEY_M",c[c.KEY_N=44]="KEY_N",c[c.KEY_O=45]="KEY_O",c[c.KEY_P=46]="KEY_P",c[c.KEY_Q=47]="KEY_Q",c[c.KEY_R=48]="KEY_R",c[c.KEY_S=49]="KEY_S",c[c.KEY_T=50]="KEY_T",c[c.KEY_U=51]="KEY_U",c[c.KEY_V=52]="KEY_V",c[c.KEY_W=53]="KEY_W",c[c.KEY_X=54]="KEY_X",c[c.KEY_Y=55]="KEY_Y",c[c.KEY_Z=56]="KEY_Z",c[c.Meta=57]="Meta",c[c.ContextMenu=58]="ContextMenu",c[c.F1=59]="F1",c[c.F2=60]="F2",c[c.F3=61]="F3",c[c.F4=62]="F4",c[c.F5=63]="F5",c[c.F6=64]="F6",c[c.F7=65]="F7",c[c.F8=66]="F8",c[c.F9=67]="F9",c[c.F10=68]="F10",c[c.F11=69]="F11",c[c.F12=70]="F12",c[c.F13=71]="F13",c[c.F14=72]="F14",c[c.F15=73]="F15",c[c.F16=74]="F16",c[c.F17=75]="F17",c[c.F18=76]="F18",c[c.F19=77]="F19",c[c.NumLock=78]="NumLock",c[c.ScrollLock=79]="ScrollLock",c[c.US_SEMICOLON=80]="US_SEMICOLON",c[c.US_EQUAL=81]="US_EQUAL",c[c.US_COMMA=82]="US_COMMA",c[c.US_MINUS=83]="US_MINUS",c[c.US_DOT=84]="US_DOT",c[c.US_SLASH=85]="US_SLASH",c[c.US_BACKTICK=86]="US_BACKTICK",c[c.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",c[c.US_BACKSLASH=88]="US_BACKSLASH",c[c.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",c[c.US_QUOTE=90]="US_QUOTE",c[c.OEM_8=91]="OEM_8",c[c.OEM_102=92]="OEM_102",c[c.NUMPAD_0=93]="NUMPAD_0",c[c.NUMPAD_1=94]="NUMPAD_1",c[c.NUMPAD_2=95]="NUMPAD_2",c[c.NUMPAD_3=96]="NUMPAD_3",c[c.NUMPAD_4=97]="NUMPAD_4",c[c.NUMPAD_5=98]="NUMPAD_5",c[c.NUMPAD_6=99]="NUMPAD_6",c[c.NUMPAD_7=100]="NUMPAD_7",c[c.NUMPAD_8=101]="NUMPAD_8",c[c.NUMPAD_9=102]="NUMPAD_9",c[c.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",c[c.NUMPAD_ADD=104]="NUMPAD_ADD",c[c.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",c[c.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",c[c.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",c[c.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",c[c.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",c[c.ABNT_C1=110]="ABNT_C1",c[c.ABNT_C2=111]="ABNT_C2",c[c.MAX_VALUE=112]="MAX_VALUE"})(L=e.KeyCode||(e.KeyCode={}));class R{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,o){this._keyCodeToStr[h]=o,this._strToKeyCode[o.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const S=new R,I=new R,n=new R;(function(){function c(h,o,l=o,t=l){S.define(h,o),I.define(h,l),n.define(h,t)}c(0,"unknown"),c(1,"Backspace"),c(2,"Tab"),c(3,"Enter"),c(4,"Shift"),c(5,"Ctrl"),c(6,"Alt"),c(7,"PauseBreak"),c(8,"CapsLock"),c(9,"Escape"),c(10,"Space"),c(11,"PageUp"),c(12,"PageDown"),c(13,"End"),c(14,"Home"),c(15,"LeftArrow","Left"),c(16,"UpArrow","Up"),c(17,"RightArrow","Right"),c(18,"DownArrow","Down"),c(19,"Insert"),c(20,"Delete"),c(21,"0"),c(22,"1"),c(23,"2"),c(24,"3"),c(25,"4"),c(26,"5"),c(27,"6"),c(28,"7"),c(29,"8"),c(30,"9"),c(31,"A"),c(32,"B"),c(33,"C"),c(34,"D"),c(35,"E"),c(36,"F"),c(37,"G"),c(38,"H"),c(39,"I"),c(40,"J"),c(41,"K"),c(42,"L"),c(43,"M"),c(44,"N"),c(45,"O"),c(46,"P"),c(47,"Q"),c(48,"R"),c(49,"S"),c(50,"T"),c(51,"U"),c(52,"V"),c(53,"W"),c(54,"X"),c(55,"Y"),c(56,"Z"),c(57,"Meta"),c(58,"ContextMenu"),c(59,"F1"),c(60,"F2"),c(61,"F3"),c(62,"F4"),c(63,"F5"),c(64,"F6"),c(65,"F7"),c(66,"F8"),c(67,"F9"),c(68,"F10"),c(69,"F11"),c(70,"F12"),c(71,"F13"),c(72,"F14"),c(73,"F15"),c(74,"F16"),c(75,"F17"),c(76,"F18"),c(77,"F19"),c(78,"NumLock"),c(79,"ScrollLock"),c(80,";",";","OEM_1"),c(81,"=","=","OEM_PLUS"),c(82,",",",","OEM_COMMA"),c(83,"-","-","OEM_MINUS"),c(84,".",".","OEM_PERIOD"),c(85,"/","/","OEM_2"),c(86,"`","`","OEM_3"),c(110,"ABNT_C1"),c(111,"ABNT_C2"),c(87,"[","[","OEM_4"),c(88,"\\","\\","OEM_5"),c(89,"]","]","OEM_6"),c(90,"'","'","OEM_7"),c(91,"OEM_8"),c(92,"OEM_102"),c(93,"NumPad0"),c(94,"NumPad1"),c(95,"NumPad2"),c(96,"NumPad3"),c(97,"NumPad4"),c(98,"NumPad5"),c(99,"NumPad6"),c(100,"NumPad7"),c(101,"NumPad8"),c(102,"NumPad9"),c(103,"NumPad_Multiply"),c(104,"NumPad_Add"),c(105,"NumPad_Separator"),c(106,"NumPad_Subtract"),c(107,"NumPad_Decimal"),c(108,"NumPad_Divide")})();var v;(function(c){function h(s){return S.keyCodeToStr(s)}c.toString=h;function o(s){return S.strToKeyCode(s)}c.fromString=o;function l(s){return I.keyCodeToStr(s)}c.toUserSettingsUS=l;function t(s){return n.keyCodeToStr(s)}c.toUserSettingsGeneral=t;function r(s){return I.strToKeyCode(s)||n.strToKeyCode(s)}c.fromUserSettings=r})(v=e.KeyCodeUtils||(e.KeyCodeUtils={}));var y;(function(c){c[c.CtrlCmd=2048]="CtrlCmd",c[c.Shift=1024]="Shift",c[c.Alt=512]="Alt",c[c.WinCtrl=256]="WinCtrl",c[c.KeyCode=255]="KeyCode"})(y||(y={}));var i;(function(c){c[c.CtrlCmd=2048]="CtrlCmd",c[c.Shift=1024]="Shift",c[c.Alt=512]="Alt",c[c.WinCtrl=256]="WinCtrl"})(i=e.KeyMod||(e.KeyMod={}));function E(c,h){const o=(h&65535)<<16>>>0;return(c|o)>>>0}e.KeyChord=E;function M(c,h){if(c===0)return null;const o=(c&65535)>>>0,l=(c&4294901760)>>>16;return l!==0?new g([p(o,h),p(l,h)]):new g([p(o,h)])}e.createKeybinding=M;function p(c,h){const o=!!(c&2048),l=!!(c&256),t=h===2?l:o,r=!!(c&1024),s=!!(c&512),a=h===2?o:l,u=c&255;return new d(t,r,s,a,u)}e.createSimpleKeybinding=p;class d{constructor(h,o,l,t,r){this.ctrlKey=h,this.shiftKey=o,this.altKey=l,this.metaKey=t,this.keyCode=r}equals(h){return this.ctrlKey===h.ctrlKey&&this.shiftKey===h.shiftKey&&this.altKey===h.altKey&&this.metaKey===h.metaKey&&this.keyCode===h.keyCode}getHashCode(){const h=this.ctrlKey?"1":"0",o=this.shiftKey?"1":"0",l=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${h}${o}${l}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new g([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=d;class g{constructor(h){if(h.length===0)throw m.illegalArgument("parts");this.parts=h}getHashCode(){let h="";for(let o=0,l=this.parts.length;o<l;o++)o!==0&&(h+=";"),h+=this.parts[o].getHashCode();return h}equals(h){if(h===null||this.parts.length!==h.parts.length)return!1;for(let o=0;o<this.parts.length;o++)if(!this.parts[o].equals(h.parts[o]))return!1;return!0}}e.ChordKeybinding=g;class k{constructor(h,o,l,t,r,s){this.ctrlKey=h,this.shiftKey=o,this.altKey=l,this.metaKey=t,this.keyLabel=r,this.keyAriaLabel=s}}e.ResolvedKeybindingPart=k;class P{}e.ResolvedKeybinding=P}),define(Z[2],x([0,1,43,63]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const R=!1;let S=null;function I(o){S=o}if(e.setDisposableTracker=I,R){const o="__is_disposable_tracked__";S=new class{trackDisposable(l){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[o]||console.log(t)},3e3)}markTracked(l){if(l&&l!==g.None)try{l[o]=!0}catch(t){}}}}function n(o){!S||S.markTracked(o)}function v(o){return S&&S.trackDisposable(o),o}e.trackDisposable=v;class y extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=y;function i(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=i;function E(o){if(L.Iterable.is(o)){let l=[];for(const t of o)if(t){n(t);try{t.dispose()}catch(r){l.push(r)}}if(l.length===1)throw l[0];if(l.length>1)throw new y(l);return Array.isArray(o)?[]:o}else if(o)return n(o),o.dispose(),o}e.dispose=E;function M(...o){return o.forEach(n),p(()=>E(o))}e.combinedDisposable=M;function p(o){const l=v({dispose:()=>{n(l),o()}});return l}e.toDisposable=p;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(n(this),this._isDisposed=!0,this.clear())}clear(){try{E(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return n(l),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this._store=new d,v(this)}dispose(){n(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class k{constructor(){this._isDisposed=!1,v(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var t;this._isDisposed||l===this._value||((t=this._value)===null||t===void 0||t.dispose(),l&&n(l),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,n(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}e.MutableDisposable=k;class P{constructor(){this.references=new Map}acquire(l,...t){let r=this.references.get(l);r||(r={counter:0,object:this.createReferencedObject(l,...t)},this.references.set(l,r));const{object:s}=r,a=m.once(()=>{--r.counter==0&&(this.destroyReferencedObject(l,r.object),this.references.delete(l))});return r.counter++,{object:s,dispose:a}}}e.ReferenceCollection=P;class c{constructor(l){this.referenceCollection=l}async acquire(l,...t){const r=this.referenceCollection.acquire(l,...t);try{return{object:await r.object,dispose:()=>r.dispose()}}catch(s){throw r.dispose(),s}}}e.AsyncReferenceCollection=c;class h{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=h}),define(Z[79],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(S){this.element=S,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class L{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let S=this._first;for(;S!==m.Undefined;){const I=S.next;S.prev=m.Undefined,S.next=m.Undefined,S=I}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(S){return this._insert(S,!1)}push(S){return this._insert(S,!0)}_insert(S,I){const n=new m(S);if(this._first===m.Undefined)this._first=n,this._last=n;else if(I){const y=this._last;this._last=n,n.prev=y,y.next=n}else{const y=this._first;this._first=n,n.next=y,y.prev=n}this._size+=1;let v=!1;return()=>{v||(v=!0,this._remove(n))}}shift(){if(this._first!==m.Undefined){const S=this._first.element;return this._remove(this._first),S}}pop(){if(this._last!==m.Undefined){const S=this._last.element;return this._remove(this._last),S}}_remove(S){if(S.prev!==m.Undefined&&S.next!==m.Undefined){const I=S.prev;I.next=S.next,S.next.prev=I}else S.prev===m.Undefined&&S.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):S.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):S.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let S=this._first;for(;S!==m.Undefined;)yield S.element,S=S.next}}e.LinkedList=L}),function(){function $(R){const S=[];typeof R=="number"&&S.push("code/timeOrigin",R);function I(v){S.push(v,Date.now())}function n(){const v=[];for(let y=0;y<S.length;y+=2)v.push({name:S[y],startTime:S[y+1]});return v}return{mark:I,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const I of performance.getEntriesByType("mark"))S.push({name:I.name,startTime:Math.round(R+I.startTime)});return S}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function m(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=m(L))}(),define(Z[3],x([0,1]),function($,e){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const L="en";let R=!1,S=!1,I=!1,n=!1,v=!1,y=!1,i=!1,E,M=L,p,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?g=e.globals.vscode.process:typeof process!="undefined"&&(g=process);const k=typeof((m=g==null?void 0:g.versions)===null||m===void 0?void 0:m.electron)=="string"&&g.type==="renderer";if(e.isElectronSandboxed=k&&(g==null?void 0:g.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const a=g==null?void 0:g.env.VSCODE_BROWSER_CODE_LOADING;if(typeof a=="string")return a==="none"||a==="code"||a==="bypassHeatCheck"||a==="bypassHeatCheckAndEagerCompile"?a:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!k)d=navigator.userAgent,R=d.indexOf("Windows")>=0,S=d.indexOf("Macintosh")>=0,i=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=d.indexOf("Linux")>=0,y=!0,E=navigator.language,M=E;else if(typeof g=="object"){R=g.platform==="win32",S=g.platform==="darwin",I=g.platform==="linux",n=I&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,E=L,M=L;const a=g.env.VSCODE_NLS_CONFIG;if(a)try{const u=JSON.parse(a),w=u.availableLanguages["*"];E=u.locale,M=w||L,p=u._translationsConfigFile}catch(u){}v=!0}else console.error("Unable to resolve platform.");var P;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(P=e.Platform||(e.Platform={}));function c(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let h=0;S?h=1:R?h=3:I&&(h=2),e.isWindows=R,e.isMacintosh=S,e.isLinux=I,e.isLinuxSnap=n,e.isNative=v,e.isWeb=y,e.isIOS=i,e.platform=h,e.userAgent=d,e.language=M;var o;(function(a){function u(){return e.language}a.value=u;function w(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=w;function f(){return e.language==="en"}a.isDefault=f})(o=e.Language||(e.Language={})),e.locale=E,e.translationsConfigFile=p,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let w=[];e.globals.addEventListener("message",b=>{if(b.data&&b.data.vscodeSetImmediateId)for(let A=0,U=w.length;A<U;A++){const q=w[A];if(q.id===b.data.vscodeSetImmediateId){w.splice(A,1),q.callback();return}}});let f=0;return b=>{const A=++f;w.push({id:A,callback:b}),e.globals.postMessage({vscodeSetImmediateId:A},"*")}}if(typeof(g==null?void 0:g.nextTick)=="function")return g.nextTick.bind(g);const u=Promise.resolve();return w=>u.then(w)}();var l;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=S||i?2:R?1:3;let t=!0,r=!1;function s(){if(!r){r=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,t=new Uint16Array(a.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(Z[33],x([0,1,3]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const R=m.globals.vscode.process;L={get platform(){return R.platform},get env(){return R.env},cwd(){return R.cwd()},nextTick(S){return m.setImmediate(S)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(R){return process.nextTick(R)}}:L={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},nextTick(R){return m.setImmediate(R)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(Z[8],x([0,1,33]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,R=97,S=90,I=122,n=46,v=47,y=92,i=58,E=63;class M extends Error{constructor(o,l,t){let r;typeof l=="string"&&l.indexOf("not ")===0?(r="must not be",l=l.replace(/^not /,"")):r="must be";const s=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${s} ${r} of type ${l}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function p(h,o){if(typeof h!="string")throw new M(o,"string",h)}function d(h){return h===v||h===y}function g(h){return h===v}function k(h){return h>=L&&h<=S||h>=R&&h<=I}function P(h,o,l,t){let r="",s=0,a=-1,u=0,w=0;for(let f=0;f<=h.length;++f){if(f<h.length)w=h.charCodeAt(f);else{if(t(w))break;w=v}if(t(w)){if(!(a===f-1||u===1))if(u===2){if(r.length<2||s!==2||r.charCodeAt(r.length-1)!==n||r.charCodeAt(r.length-2)!==n){if(r.length>2){const b=r.lastIndexOf(l);b===-1?(r="",s=0):(r=r.slice(0,b),s=r.length-1-r.lastIndexOf(l)),a=f,u=0;continue}else if(r.length!==0){r="",s=0,a=f,u=0;continue}}o&&(r+=r.length>0?`${l}..`:"..",s=2)}else r.length>0?r+=`${l}${h.slice(a+1,f)}`:r=h.slice(a+1,f),s=f-a-1;a=f,u=0}else w===n&&u!==-1?++u:u=-1}return r}function c(h,o){if(o===null||typeof o!="object")throw new M("pathObject","Object",o);const l=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return l?l===o.root?`${l}${t}`:`${l}${h}${t}`:t}e.win32={resolve(...h){let o="",l="",t=!1;for(let r=h.length-1;r>=-1;r--){let s;if(r>=0){if(s=h[r],p(s,"path"),s.length===0)continue}else o.length===0?s=m.cwd():(s=m.env[`=${o}`]||m.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==o.toLowerCase()&&s.charCodeAt(2)===y)&&(s=`${o}\\`));const a=s.length;let u=0,w="",f=!1;const b=s.charCodeAt(0);if(a===1)d(b)&&(u=1,f=!0);else if(d(b))if(f=!0,d(s.charCodeAt(1))){let A=2,U=A;for(;A<a&&!d(s.charCodeAt(A));)A++;if(A<a&&A!==U){const q=s.slice(U,A);for(U=A;A<a&&d(s.charCodeAt(A));)A++;if(A<a&&A!==U){for(U=A;A<a&&!d(s.charCodeAt(A));)A++;(A===a||A!==U)&&(w=`\\\\${q}\\${s.slice(U,A)}`,u=A)}}}else u=1;else k(b)&&s.charCodeAt(1)===i&&(w=s.slice(0,2),u=2,a>2&&d(s.charCodeAt(2))&&(f=!0,u=3));if(w.length>0)if(o.length>0){if(w.toLowerCase()!==o.toLowerCase())continue}else o=w;if(t){if(o.length>0)break}else if(l=`${s.slice(u)}\\${l}`,t=f,f&&o.length>0)break}return l=P(l,!t,"\\",d),t?`${o}\\${l}`:`${o}${l}`||"."},normalize(h){p(h,"path");const o=h.length;if(o===0)return".";let l=0,t,r=!1;const s=h.charCodeAt(0);if(o===1)return g(s)?"\\":h;if(d(s))if(r=!0,d(h.charCodeAt(1))){let u=2,w=u;for(;u<o&&!d(h.charCodeAt(u));)u++;if(u<o&&u!==w){const f=h.slice(w,u);for(w=u;u<o&&d(h.charCodeAt(u));)u++;if(u<o&&u!==w){for(w=u;u<o&&!d(h.charCodeAt(u));)u++;if(u===o)return`\\\\${f}\\${h.slice(w)}\\`;u!==w&&(t=`\\\\${f}\\${h.slice(w,u)}`,l=u)}}}else l=1;else k(s)&&h.charCodeAt(1)===i&&(t=h.slice(0,2),l=2,o>2&&d(h.charCodeAt(2))&&(r=!0,l=3));let a=l<o?P(h.slice(l),!r,"\\",d):"";return a.length===0&&!r&&(a="."),a.length>0&&d(h.charCodeAt(o-1))&&(a+="\\"),t===void 0?r?`\\${a}`:a:r?`${t}\\${a}`:`${t}${a}`},isAbsolute(h){p(h,"path");const o=h.length;if(o===0)return!1;const l=h.charCodeAt(0);return d(l)||o>2&&k(l)&&h.charCodeAt(1)===i&&d(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let o,l;for(let s=0;s<h.length;++s){const a=h[s];p(a,"path"),a.length>0&&(o===void 0?o=l=a:o+=`\\${a}`)}if(o===void 0)return".";let t=!0,r=0;if(typeof l=="string"&&d(l.charCodeAt(0))){++r;const s=l.length;s>1&&d(l.charCodeAt(1))&&(++r,s>2&&(d(l.charCodeAt(2))?++r:t=!1))}if(t){for(;r<o.length&&d(o.charCodeAt(r));)r++;r>=2&&(o=`\\${o.slice(r)}`)}return e.win32.normalize(o)},relative(h,o){if(p(h,"from"),p(o,"to"),h===o)return"";const l=e.win32.resolve(h),t=e.win32.resolve(o);if(l===t||(h=l.toLowerCase(),o=t.toLowerCase(),h===o))return"";let r=0;for(;r<h.length&&h.charCodeAt(r)===y;)r++;let s=h.length;for(;s-1>r&&h.charCodeAt(s-1)===y;)s--;const a=s-r;let u=0;for(;u<o.length&&o.charCodeAt(u)===y;)u++;let w=o.length;for(;w-1>u&&o.charCodeAt(w-1)===y;)w--;const f=w-u,b=a<f?a:f;let A=-1,U=0;for(;U<b;U++){const J=h.charCodeAt(r+U);if(J!==o.charCodeAt(u+U))break;J===y&&(A=U)}if(U!==b){if(A===-1)return t}else{if(f>b){if(o.charCodeAt(u+U)===y)return t.slice(u+U+1);if(U===2)return t.slice(u+U)}a>b&&(h.charCodeAt(r+U)===y?A=U:U===2&&(A=3)),A===-1&&(A=0)}let q="";for(U=r+A+1;U<=s;++U)(U===s||h.charCodeAt(U)===y)&&(q+=q.length===0?"..":"\\..");return u+=A,q.length>0?`${q}${t.slice(u,w)}`:(t.charCodeAt(u)===y&&++u,t.slice(u,w))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const o=e.win32.resolve(h);if(o.length<=2)return h;if(o.charCodeAt(0)===y){if(o.charCodeAt(1)===y){const l=o.charCodeAt(2);if(l!==E&&l!==n)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(k(o.charCodeAt(0))&&o.charCodeAt(1)===i&&o.charCodeAt(2)===y)return`\\\\?\\${o}`;return h},dirname(h){p(h,"path");const o=h.length;if(o===0)return".";let l=-1,t=0;const r=h.charCodeAt(0);if(o===1)return d(r)?h:".";if(d(r)){if(l=t=1,d(h.charCodeAt(1))){let u=2,w=u;for(;u<o&&!d(h.charCodeAt(u));)u++;if(u<o&&u!==w){for(w=u;u<o&&d(h.charCodeAt(u));)u++;if(u<o&&u!==w){for(w=u;u<o&&!d(h.charCodeAt(u));)u++;if(u===o)return h;u!==w&&(l=t=u+1)}}}}else k(r)&&h.charCodeAt(1)===i&&(l=o>2&&d(h.charCodeAt(2))?3:2,t=l);let s=-1,a=!0;for(let u=o-1;u>=t;--u)if(d(h.charCodeAt(u))){if(!a){s=u;break}}else a=!1;if(s===-1){if(l===-1)return".";s=l}return h.slice(0,s)},basename(h,o){o!==void 0&&p(o,"ext"),p(h,"path");let l=0,t=-1,r=!0,s;if(h.length>=2&&k(h.charCodeAt(0))&&h.charCodeAt(1)===i&&(l=2),o!==void 0&&o.length>0&&o.length<=h.length){if(o===h)return"";let a=o.length-1,u=-1;for(s=h.length-1;s>=l;--s){const w=h.charCodeAt(s);if(d(w)){if(!r){l=s+1;break}}else u===-1&&(r=!1,u=s+1),a>=0&&(w===o.charCodeAt(a)?--a==-1&&(t=s):(a=-1,t=u))}return l===t?t=u:t===-1&&(t=h.length),h.slice(l,t)}for(s=h.length-1;s>=l;--s)if(d(h.charCodeAt(s))){if(!r){l=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":h.slice(l,t)},extname(h){p(h,"path");let o=0,l=-1,t=0,r=-1,s=!0,a=0;h.length>=2&&h.charCodeAt(1)===i&&k(h.charCodeAt(0))&&(o=t=2);for(let u=h.length-1;u>=o;--u){const w=h.charCodeAt(u);if(d(w)){if(!s){t=u+1;break}continue}r===-1&&(s=!1,r=u+1),w===n?l===-1?l=u:a!==1&&(a=1):l!==-1&&(a=-1)}return l===-1||r===-1||a===0||a===1&&l===r-1&&l===t+1?"":h.slice(l,r)},format:c.bind(null,"\\"),parse(h){p(h,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return o;const l=h.length;let t=0,r=h.charCodeAt(0);if(l===1)return d(r)?(o.root=o.dir=h,o):(o.base=o.name=h,o);if(d(r)){if(t=1,d(h.charCodeAt(1))){let A=2,U=A;for(;A<l&&!d(h.charCodeAt(A));)A++;if(A<l&&A!==U){for(U=A;A<l&&d(h.charCodeAt(A));)A++;if(A<l&&A!==U){for(U=A;A<l&&!d(h.charCodeAt(A));)A++;A===l?t=A:A!==U&&(t=A+1)}}}}else if(k(r)&&h.charCodeAt(1)===i){if(l<=2)return o.root=o.dir=h,o;if(t=2,d(h.charCodeAt(2))){if(l===3)return o.root=o.dir=h,o;t=3}}t>0&&(o.root=h.slice(0,t));let s=-1,a=t,u=-1,w=!0,f=h.length-1,b=0;for(;f>=t;--f){if(r=h.charCodeAt(f),d(r)){if(!w){a=f+1;break}continue}u===-1&&(w=!1,u=f+1),r===n?s===-1?s=f:b!==1&&(b=1):s!==-1&&(b=-1)}return u!==-1&&(s===-1||b===0||b===1&&s===u-1&&s===a+1?o.base=o.name=h.slice(a,u):(o.name=h.slice(a,s),o.base=h.slice(a,u),o.ext=h.slice(s,u))),a>0&&a!==t?o.dir=h.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let o="",l=!1;for(let t=h.length-1;t>=-1&&!l;t--){const r=t>=0?h[t]:m.cwd();p(r,"path"),r.length!==0&&(o=`${r}/${o}`,l=r.charCodeAt(0)===v)}return o=P(o,!l,"/",g),l?`/${o}`:o.length>0?o:"."},normalize(h){if(p(h,"path"),h.length===0)return".";const o=h.charCodeAt(0)===v,l=h.charCodeAt(h.length-1)===v;return h=P(h,!o,"/",g),h.length===0?o?"/":l?"./":".":(l&&(h+="/"),o?`/${h}`:h)},isAbsolute(h){return p(h,"path"),h.length>0&&h.charCodeAt(0)===v},join(...h){if(h.length===0)return".";let o;for(let l=0;l<h.length;++l){const t=h[l];p(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(h,o){if(p(h,"from"),p(o,"to"),h===o||(h=e.posix.resolve(h),o=e.posix.resolve(o),h===o))return"";const l=1,t=h.length,r=t-l,s=1,a=o.length-s,u=r<a?r:a;let w=-1,f=0;for(;f<u;f++){const A=h.charCodeAt(l+f);if(A!==o.charCodeAt(s+f))break;A===v&&(w=f)}if(f===u)if(a>u){if(o.charCodeAt(s+f)===v)return o.slice(s+f+1);if(f===0)return o.slice(s+f)}else r>u&&(h.charCodeAt(l+f)===v?w=f:f===0&&(w=0));let b="";for(f=l+w+1;f<=t;++f)(f===t||h.charCodeAt(f)===v)&&(b+=b.length===0?"..":"/..");return`${b}${o.slice(s+w)}`},toNamespacedPath(h){return h},dirname(h){if(p(h,"path"),h.length===0)return".";const o=h.charCodeAt(0)===v;let l=-1,t=!0;for(let r=h.length-1;r>=1;--r)if(h.charCodeAt(r)===v){if(!t){l=r;break}}else t=!1;return l===-1?o?"/":".":o&&l===1?"//":h.slice(0,l)},basename(h,o){o!==void 0&&p(o,"ext"),p(h,"path");let l=0,t=-1,r=!0,s;if(o!==void 0&&o.length>0&&o.length<=h.length){if(o===h)return"";let a=o.length-1,u=-1;for(s=h.length-1;s>=0;--s){const w=h.charCodeAt(s);if(w===v){if(!r){l=s+1;break}}else u===-1&&(r=!1,u=s+1),a>=0&&(w===o.charCodeAt(a)?--a==-1&&(t=s):(a=-1,t=u))}return l===t?t=u:t===-1&&(t=h.length),h.slice(l,t)}for(s=h.length-1;s>=0;--s)if(h.charCodeAt(s)===v){if(!r){l=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":h.slice(l,t)},extname(h){p(h,"path");let o=-1,l=0,t=-1,r=!0,s=0;for(let a=h.length-1;a>=0;--a){const u=h.charCodeAt(a);if(u===v){if(!r){l=a+1;break}continue}t===-1&&(r=!1,t=a+1),u===n?o===-1?o=a:s!==1&&(s=1):o!==-1&&(s=-1)}return o===-1||t===-1||s===0||s===1&&o===t-1&&o===l+1?"":h.slice(o,t)},format:c.bind(null,"/"),parse(h){p(h,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return o;const l=h.charCodeAt(0)===v;let t;l?(o.root="/",t=1):t=0;let r=-1,s=0,a=-1,u=!0,w=h.length-1,f=0;for(;w>=t;--w){const b=h.charCodeAt(w);if(b===v){if(!u){s=w+1;break}continue}a===-1&&(u=!1,a=w+1),b===n?r===-1?r=w:f!==1&&(f=1):r!==-1&&(f=-1)}if(a!==-1){const b=s===0&&l?1:s;r===-1||f===0||f===1&&r===a-1&&r===s+1?o.base=o.name=h.slice(b,a):(o.name=h.slice(b,r),o.base=h.slice(b,a),o.ext=h.slice(r,a))}return s>0?o.dir=h.slice(0,s-1):l&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[106],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var L;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(S,...I){const n=I.reduce((i,E)=>(i[E]=!0,i),{}),v=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(i=>!n[i]).forEach(i=>{for(let E=0;E<v.length;E++)if(i.search(v[E])!==-1){delete S[i];break}})}e.sanitizeProcessEnvironment=R}),define(Z[80],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var m;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(m=e.ScanCode||(e.ScanCode={}));const L=[],R=Object.create(null),S=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>S[n]||0,toEnum:n=>R[n]||0,toString:n=>L[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class I{constructor(v,y,i,E,M){this.ctrlKey=v,this.shiftKey=y,this.altKey=i,this.metaKey=E,this.scanCode=M}equals(v){return this.ctrlKey===v.ctrlKey&&this.shiftKey===v.shiftKey&&this.altKey===v.altKey&&this.metaKey===v.metaKey&&this.scanCode===v.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=I,function(){function n(v,y){L[v]=y,R[y]=v,S[y.toLowerCase()]=v}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let v=0;v<=193;v++)e.IMMUTABLE_CODE_TO_KEY_CODE[v]=-1;for(let v=0;v<=112;v++)e.IMMUTABLE_KEY_CODE_TO_CODE[v]=-1;function n(v,y){e.IMMUTABLE_CODE_TO_KEY_CODE[v]=y,y!==0&&y!==3&&y!==5&&y!==4&&y!==6&&y!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[y]=v)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(Z[107],x([0,1,57,80]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class R{static _readModifiers(I){I=I.toLowerCase().trim();let n=!1,v=!1,y=!1,i=!1,E;do E=!1,/^ctrl(\+|\-)/.test(I)&&(n=!0,I=I.substr("ctrl-".length),E=!0),/^shift(\+|\-)/.test(I)&&(v=!0,I=I.substr("shift-".length),E=!0),/^alt(\+|\-)/.test(I)&&(y=!0,I=I.substr("alt-".length),E=!0),/^meta(\+|\-)/.test(I)&&(i=!0,I=I.substr("meta-".length),E=!0),/^win(\+|\-)/.test(I)&&(i=!0,I=I.substr("win-".length),E=!0),/^cmd(\+|\-)/.test(I)&&(i=!0,I=I.substr("cmd-".length),E=!0);while(E);let M;const p=I.indexOf(" ");return p>0?(M=I.substring(0,p),I=I.substring(p)):(M=I,I=""),{remains:I,ctrl:n,shift:v,alt:y,meta:i,key:M}}static parseSimpleKeybinding(I){const n=this._readModifiers(I),v=m.KeyCodeUtils.fromUserSettings(n.key);return[new m.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,v),n.remains]}static parseKeybinding(I,n){if(!I)return null;const v=[];let y;do[y,I]=this.parseSimpleKeybinding(I),v.push(y);while(I.length>0);return new m.ChordKeybinding(v)}static parseSimpleUserBinding(I){const n=this._readModifiers(I),v=n.key.match(/^\[([^\]]+)\]$/);if(v){const i=v[1],E=L.ScanCodeUtils.lowerCaseToEnum(i);return[new L.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,E),n.remains]}const y=m.KeyCodeUtils.fromUserSettings(n.key);return[new m.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,y),n.remains]}static parseUserBinding(I){if(!I)return[];const n=[];let v;for(;I.length>0;)[v,I]=this.parseSimpleUserBinding(I),n.push(v);return n}}e.KeybindingParser=R}),define(Z[108],x([0,1,3]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=m.globals.performance&&typeof m.globals.performance.now=="function";class R{constructor(I){this._highResolution=L&&I,this._startTime=this._now(),this._stopTime=-1}static create(I=!0){return new R(I)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=R}),define(Z[5],x([0,1,16,43,2,79,108]),function($,e,m,L,R,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(c){c.None=()=>R.Disposable.None;function h(Y){return(G,C=null,z)=>{let X=!1,H;return H=Y(W=>{if(!X)return H?H.dispose():X=!0,G.call(C,W)},null,z),X&&H.dispose(),H}}c.once=h;function o(Y,G){return u((C,z=null,X)=>Y(H=>C.call(z,G(H)),null,X))}c.map=o;function l(Y,G){return u((C,z=null,X)=>Y(H=>{G(H),C.call(z,H)},null,X))}c.forEach=l;function t(Y,G){return u((C,z=null,X)=>Y(H=>G(H)&&C.call(z,H),null,X))}c.filter=t;function r(Y){return Y}c.signal=r;function s(...Y){return(G,C=null,z)=>R.combinedDisposable(...Y.map(X=>X(H=>G.call(C,H),null,z)))}c.any=s;function a(Y,G,C){let z=C;return o(Y,X=>(z=G(z,X),z))}c.reduce=a;function u(Y){let G;const C=new M({onFirstListenerAdd(){G=Y(C.fire,C)},onLastListenerRemove(){G.dispose()}});return C.event}function w(Y,G,C=100,z=!1,X){let H,W,D,O=0;const F=new M({leakWarningThreshold:X,onFirstListenerAdd(){H=Y(T=>{O++,W=G(W,T),z&&!D&&(F.fire(W),W=void 0),clearTimeout(D),D=setTimeout(()=>{const _=W;W=void 0,D=void 0,(!z||O>1)&&F.fire(_),O=0},C)})},onLastListenerRemove(){H.dispose()}});return F.event}c.debounce=w;function f(Y,G=(C,z)=>C===z){let C=!0,z;return t(Y,X=>{const H=C||!G(X,z);return C=!1,z=X,H})}c.latch=f;function b(Y,G){return[c.filter(Y,G),c.filter(Y,C=>!G(C))]}c.split=b;function A(Y,G=!1,C=[]){let z=C.slice(),X=Y(D=>{z?z.push(D):W.fire(D)});const H=()=>{z&&z.forEach(D=>W.fire(D)),z=null},W=new M({onFirstListenerAdd(){X||(X=Y(D=>W.fire(D)))},onFirstListenerDidAdd(){z&&(G?setTimeout(H):H())},onLastListenerRemove(){X&&X.dispose(),X=null}});return W.event}c.buffer=A;class U{constructor(G){this.event=G}map(G){return new U(o(this.event,G))}forEach(G){return new U(l(this.event,G))}filter(G){return new U(t(this.event,G))}reduce(G,C){return new U(a(this.event,G,C))}latch(){return new U(f(this.event))}debounce(G,C=100,z=!1,X){return new U(w(this.event,G,C,z,X))}on(G,C,z){return this.event(G,C,z)}once(G,C,z){return h(this.event)(G,C,z)}}function q(Y){return new U(Y)}c.chain=q;function J(Y,G,C=z=>z){const z=(...D)=>W.fire(C(...D)),X=()=>Y.on(G,z),H=()=>Y.removeListener(G,z),W=new M({onFirstListenerAdd:X,onLastListenerRemove:H});return W.event}c.fromNodeEventEmitter=J;function te(Y,G,C=z=>z){const z=(...D)=>W.fire(C(...D)),X=()=>Y.addEventListener(G,z),H=()=>Y.removeEventListener(G,z),W=new M({onFirstListenerAdd:X,onLastListenerRemove:H});return W.event}c.fromDOMEventEmitter=te;function B(Y){return new Promise(G=>h(Y)(G))}c.toPromise=B})(n=e.Event||(e.Event={}));class v{constructor(h){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${h}_${v._idPool++}`}start(h){this._stopWatch=new I.StopWatch(!0),this._listenerCount=h}stop(){if(this._stopWatch){const h=this._stopWatch.elapsed();this._elapsedOverall+=h,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${h.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}v._idPool=0;let y=-1;function i(c){const h=y;return y=c,{dispose(){y=h}}}e.setGlobalLeakWarningThreshold=i;class E{constructor(h,o=Math.random().toString(18).slice(2,5)){this.customThreshold=h,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(h){let o=y;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||h<o)return;this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),t=this._stacks.get(l)||0;if(this._stacks.set(l,t+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let r,s=0;for(const[a,u]of this._stacks)(!r||s<u)&&(r=a,s=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${s}):`),console.warn(r)}return()=>{const r=this._stacks.get(l)||0;this._stacks.set(l,r-1)}}}class M{constructor(h){var o;this._disposed=!1,this._options=h,this._leakageMon=y>0?new E(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((o=this._options)===null||o===void 0?void 0:o._profName)?new v(this._options._profName):void 0}get event(){return this._event||(this._event=(h,o,l)=>{var t;this._listeners||(this._listeners=new S.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(o?[h,o]:h);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,h,o);const a=(t=this._leakageMon)===null||t===void 0?void 0:t.check(this._listeners.size);let u;return u={dispose:()=>{a&&a(),u.dispose=M._noop,this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},l instanceof R.DisposableStore?l.add(u):Array.isArray(l)&&l.push(u),u}),this._event}fire(h){var o,l;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,h]);for((o=this._perfMon)===null||o===void 0||o.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,r]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,r):t[0].call(t[1],r)}catch(s){m.onUnexpectedError(s)}}(l=this._perfMon)===null||l===void 0||l.stop()}}dispose(){var h,o,l,t,r;this._disposed||(this._disposed=!0,(h=this._listeners)===null||h===void 0||h.clear(),(o=this._deliveryQueue)===null||o===void 0||o.clear(),(t=(l=this._options)===null||l===void 0?void 0:l.onLastListenerRemove)===null||t===void 0||t.call(l),(r=this._leakageMon)===null||r===void 0||r.dispose())}}e.Emitter=M,M._noop=function(){};class p extends M{constructor(h){super(h);this._isPaused=0,this._eventQueue=new S.LinkedList,this._mergeFn=h==null?void 0:h.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const h=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(h))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(h){this._listeners&&(this._isPaused!==0?this._eventQueue.push(h):super.fire(h))}}e.PauseableEmitter=p;class d extends p{constructor(h){var o;super(h);this._delay=(o=h.delay)!==null&&o!==void 0?o:100}fire(h){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(h)}}e.DebounceEmitter=d;class g{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new M({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(h){const o={event:h,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const l=()=>{this.hasListeners&&this.unhook(o);const t=this.events.indexOf(o);this.events.splice(t,1)};return R.toDisposable(L.once(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(h=>this.hook(h))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(h=>this.unhook(h))}hook(h){h.listener=h.event(o=>this.emitter.fire(o))}unhook(h){h.listener&&h.listener.dispose(),h.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=g;class k{constructor(){this.buffers=[]}wrapEvent(h){return(o,l,t)=>h(r=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>o.call(l,r)):o.call(l,r)},void 0,t)}bufferEvents(h){const o=[];this.buffers.push(o);const l=h();return this.buffers.pop(),o.forEach(t=>t()),l}}e.EventBufferer=k;class P{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=R.Disposable.None,this.emitter=new M({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(h){this.inputEvent=h,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=h(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=P}),define(Z[25],x([0,1,5]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(n,v){const y=setTimeout(n.bind(v),0);return{dispose(){clearTimeout(y)}}});var R;(function(n){function v(y){return y===n.None||y===n.Cancelled||y instanceof S?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}n.isCancellationToken=v,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(R=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class I{constructor(v){this._token=void 0,this._parentListener=void 0,this._parentListener=v&&v.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new S),this._token}cancel(){this._token?this._token instanceof S&&this._token.cancel():this._token=R.Cancelled}dispose(v=!1){v&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof S&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=I}),define(Z[109],x([0,1,5]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(E){const M=this._icons.get(E.id);M?E.description?M.description=E.description:console.error(`Duplicate registration of codicon ${E.id}`):(this._icons.set(E.id,E),this._onDidRegister.fire(E))}get(E){return this._icons.get(E)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new L;e.iconRegistry=R;function S(i,E){return new n(i,E)}e.registerCodicon=S;function I(i){return i?i.replace(/\$\((.*?)\)/g,(E,M)=>` ${M} `).trim():""}e.getCodiconAriaLabel=I;class n{constructor(E,M,p){this.id=E,this.definition=M,this.description=p,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n;function v(i,E){const M=["codicon","codicon-"+i];return E&&M.push("codicon-modifier-"+E),M}e.getClassNamesArray=v;var y;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const E=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function M(g){if(g instanceof n)return["codicon","codicon-"+g.id];const k=E.exec(g.id);if(!k)return M(n.error);let[,P,c]=k;const h=["codicon","codicon-"+P];return c&&h.push("codicon-modifier-"+c.substr(1)),h}i.asClassNameArray=M;function p(g){return M(g).join(" ")}i.asClassName=p;function d(g){return"."+M(g).join(".")}i.asCSSSelector=d})(y=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(n=e.Codicon||(e.Codicon={}))}),define(Z[64],x([0,1,16,2]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(h){const o=h;return o?[o.on,o.pause,o.resume,o.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=R;function S(h){const o=h;return o?R(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=S;function I(h,o){return new n(h,o)}e.newWriteableStream=I;class n{constructor(o,l){this.reducer=o,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){var l;if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof((l=this.options)===null||l===void 0?void 0:l.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(l=>l(o))}emitError(o){this.listeners.error.length===0?m.onUnexpectedError(o):this.listeners.error.slice(0).forEach(l=>l(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,l){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(o,l){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(l);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function v(h,o){const l=[];let t;for(;(t=h.read())!==null;)l.push(t);return o(l)}e.consumeReadable=v;function y(h,o,l){const t=[];let r;for(;(r=h.read())!==null&&t.length<l;)t.push(r);return r===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return h.read()}}}e.peekReadable=y;function i(h,o){return new Promise((l,t)=>{const r=[];E(h,{onData:s=>{o&&r.push(s)},onError:s=>{o?t(s):l(void 0)},onEnd:()=>{l(o?o(r):void 0)}})})}e.consumeStream=i;function E(h,o){h.on("error",l=>o.onError(l)),h.on("end",()=>o.onEnd()),h.on("data",l=>o.onData(l))}e.listenStream=E;function M(h,o){return new Promise((l,t)=>{const r=new L.DisposableStore,s=[],a=f=>{if(s.push(f),s.length>o)return r.dispose(),h.pause(),l({stream:h,buffer:s,ended:!1})},u=f=>t(f),w=()=>l({stream:h,buffer:s,ended:!0});r.add(L.toDisposable(()=>h.removeListener("error",u))),h.on("error",u),r.add(L.toDisposable(()=>h.removeListener("end",w))),h.on("end",w),r.add(L.toDisposable(()=>h.removeListener("data",a))),h.on("data",a)})}e.peekStream=M;function p(h,o){const l=I(o);return l.end(h),l}e.toStream=p;function d(){const h=I(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=d;function g(h){let o=!1;return{read:()=>o?null:(o=!0,h)}}e.toReadable=g;function k(h,o,l){const t=I(l);return E(h,{onData:r=>t.write(o.data(r)),onError:r=>t.error(o.error?o.error(r):r),onEnd:()=>t.end()}),t}e.transform=k;function P(h,o,l){let t=!1;return{read:()=>{const r=o.read();return t?r:(t=!0,r!==null?l([h,r]):h)}}}e.prefixedReadable=P;function c(h,o,l){let t=!1;const r=I(l);return E(o,{onData:s=>t?r.write(s):(t=!0,r.write(l([h,s]))),onError:s=>r.error(s),onEnd:()=>{t||(t=!0,r.write(h)),r.end()}}),r}e.prefixedStream=c}),define(Z[23],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function m(j){return!j||typeof j!="string"?!0:j.trim().length===0}e.isFalsyOrWhitespace=m;const L=/{(\d+)}/g;function R(j,...ie){return ie.length===0?j:j.replace(L,function(oe,ce){const fe=parseInt(ce,10);return isNaN(fe)||fe<0||fe>=ie.length?oe:ie[fe]})}e.format=R;function S(j){return j.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=S;function I(j){return j.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function n(j,ie){let oe=0;const ce=ie.charCodeAt(0);for(let fe=j.length-1;fe>=0;fe--)j.charCodeAt(fe)===ce&&oe++;return oe}e.count=n;function v(j,ie,oe="\u2026"){return j.length<=ie?j:`${j.substr(0,ie)}${oe}`}e.truncate=v;function y(j,ie=" "){const oe=i(j,ie);return E(oe,ie)}e.trim=y;function i(j,ie){if(!j||!ie)return j;const oe=ie.length;if(oe===0||j.length===0)return j;let ce=0;for(;j.indexOf(ie,ce)===ce;)ce=ce+oe;return j.substring(ce)}e.ltrim=i;function E(j,ie){if(!j||!ie)return j;const oe=ie.length,ce=j.length;if(oe===0||ce===0)return j;let fe=ce,Se=-1;for(;Se=j.lastIndexOf(ie,fe-1),!(Se===-1||Se+oe!==fe);){if(Se===0)return"";fe=Se}return j.substring(0,fe)}e.rtrim=E;function M(j){return j.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=M;function p(j){return j.replace(/\*/g,"")}e.stripWildcards=p;function d(j,ie,oe={}){if(!j)throw new Error("Cannot create regex from empty string");ie||(j=I(j)),oe.wholeWord&&(/\B/.test(j.charAt(0))||(j="\\b"+j),/\B/.test(j.charAt(j.length-1))||(j=j+"\\b"));let ce="";return oe.global&&(ce+="g"),oe.matchCase||(ce+="i"),oe.multiline&&(ce+="m"),oe.unicode&&(ce+="u"),new RegExp(j,ce)}e.createRegExp=d;function g(j){return j.source==="^"||j.source==="^$"||j.source==="$"||j.source==="^\\s*$"?!1:!!(j.exec("")&&j.lastIndex===0)}e.regExpLeadsToEndlessLoop=g;function k(j){return!!j.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=k;function P(j){return(j.global?"g":"")+(j.ignoreCase?"i":"")+(j.multiline?"m":"")+(j.unicode?"u":"")}e.regExpFlags=P;function c(j){return j.split(/\r\n|\r|\n/)}e.splitLines=c;function h(j){for(let ie=0,oe=j.length;ie<oe;ie++){const ce=j.charCodeAt(ie);if(ce!==32&&ce!==9)return ie}return-1}e.firstNonWhitespaceIndex=h;function o(j,ie=0,oe=j.length){for(let ce=ie;ce<oe;ce++){const fe=j.charCodeAt(ce);if(fe!==32&&fe!==9)return j.substring(ie,ce)}return j.substring(ie,oe)}e.getLeadingWhitespace=o;function l(j,ie=j.length-1){for(let oe=ie;oe>=0;oe--){const ce=j.charCodeAt(oe);if(ce!==32&&ce!==9)return oe}return-1}e.lastNonWhitespaceIndex=l;function t(j,ie){return j<ie?-1:j>ie?1:0}e.compare=t;function r(j,ie,oe=0,ce=j.length,fe=0,Se=ie.length){for(;oe<ce&&fe<Se;oe++,fe++){let Ce=j.charCodeAt(oe),$e=ie.charCodeAt(fe);if(Ce<$e)return-1;if(Ce>$e)return 1}const ke=ce-oe,Fe=Se-fe;return ke<Fe?-1:ke>Fe?1:0}e.compareSubstring=r;function s(j,ie){return a(j,ie,0,j.length,0,ie.length)}e.compareIgnoreCase=s;function a(j,ie,oe=0,ce=j.length,fe=0,Se=ie.length){for(;oe<ce&&fe<Se;oe++,fe++){let Ce=j.charCodeAt(oe),$e=ie.charCodeAt(fe);if(Ce===$e)continue;const de=Ce-$e;if(!(de===32&&w($e))&&!(de===-32&&w(Ce)))return u(Ce)&&u($e)?de:r(j.toLowerCase(),ie.toLowerCase(),oe,ce,fe,Se)}const ke=ce-oe,Fe=Se-fe;return ke<Fe?-1:ke>Fe?1:0}e.compareSubstringIgnoreCase=a;function u(j){return j>=97&&j<=122}e.isLowerAsciiLetter=u;function w(j){return j>=65&&j<=90}e.isUpperAsciiLetter=w;function f(j){return u(j)||w(j)}function b(j,ie){return j.length===ie.length&&A(j,ie)}e.equalsIgnoreCase=b;function A(j,ie,oe=j.length){for(let ce=0;ce<oe;ce++){const fe=j.charCodeAt(ce),Se=ie.charCodeAt(ce);if(fe!==Se){if(f(fe)&&f(Se)){const ke=Math.abs(fe-Se);if(ke!==0&&ke!==32)return!1}else if(String.fromCharCode(fe).toLowerCase()!==String.fromCharCode(Se).toLowerCase())return!1}}return!0}function U(j,ie){const oe=ie.length;return ie.length>j.length?!1:A(j,ie,oe)}e.startsWithIgnoreCase=U;function q(j,ie){let oe,ce=Math.min(j.length,ie.length);for(oe=0;oe<ce;oe++)if(j.charCodeAt(oe)!==ie.charCodeAt(oe))return oe;return ce}e.commonPrefixLength=q;function J(j,ie){let oe,ce=Math.min(j.length,ie.length);const fe=j.length-1,Se=ie.length-1;for(oe=0;oe<ce;oe++)if(j.charCodeAt(fe-oe)!==ie.charCodeAt(Se-oe))return oe;return ce}e.commonSuffixLength=J;function te(j){return 55296<=j&&j<=56319}e.isHighSurrogate=te;function B(j){return 56320<=j&&j<=57343}e.isLowSurrogate=B;function Y(j,ie){return(j-55296<<10)+(ie-56320)+65536}e.computeCodePoint=Y;function G(j,ie,oe){const ce=j.charCodeAt(oe);if(te(ce)&&oe+1<ie){const fe=j.charCodeAt(oe+1);if(B(fe))return Y(ce,fe)}return ce}e.getNextCodePoint=G;function C(j,ie){const oe=j.charCodeAt(ie-1);if(B(oe)&&ie>1){const ce=j.charCodeAt(ie-2);if(te(ce))return Y(ce,oe)}return oe}function z(j,ie){const oe=ze.getInstance(),ce=ie,fe=j.length,Se=G(j,fe,ie);ie+=Se>=65536?2:1;let ke=oe.getGraphemeBreakType(Se);for(;ie<fe;){const Fe=G(j,fe,ie),Ce=oe.getGraphemeBreakType(Fe);if(He(ke,Ce))break;ie+=Fe>=65536?2:1,ke=Ce}return ie-ce}e.nextCharLength=z;function X(j,ie){const oe=ze.getInstance(),ce=ie,fe=C(j,ie);ie-=fe>=65536?2:1;let Se=oe.getGraphemeBreakType(fe);for(;ie>0;){const ke=C(j,ie),Fe=oe.getGraphemeBreakType(ke);if(He(Fe,Se))break;ie-=ke>=65536?2:1,Se=Fe}return ce-ie}e.prevCharLength=X;function H(j,ie){const oe=ze.getInstance(),ce=j.length,fe=ie,Se=G(j,ce,ie),ke=oe.getGraphemeBreakType(Se);ie+=Se>=65536?2:1;let Fe=ke;for(;ie<ce;){const $e=G(j,ce,ie),de=oe.getGraphemeBreakType($e);if(He(Fe,de))break;ie+=$e>=65536?2:1,Fe=de}const Ce=ie;for(ie=fe,Fe=ke;ie>0;){const $e=C(j,ie),de=oe.getGraphemeBreakType($e);if(He(de,Fe))break;ie-=$e>=65536?2:1,Fe=de}return[ie,Ce]}function W(j,ie){return ie>0&&B(j.charCodeAt(ie))?H(j,ie-1):H(j,ie)}e.getCharContainingOffset=W;function D(j){const ie=j.length;let oe=0,ce=0;for(;ce<ie;){const ke=G(j,ie,ce);ce+=ke>=65536?2:1,ke<128?oe+=1:ke<2048?oe+=2:ke<65536?oe+=3:oe+=4}const fe=new Uint8Array(oe);ce=0;let Se=0;for(;ce<ie;){const ke=G(j,ie,ce);ce+=ke>=65536?2:1,ke<128?fe[Se++]=ke:ke<2048?(fe[Se++]=192|(ke&1984)>>>6,fe[Se++]=128|(ke&63)>>>0):ke<65536?(fe[Se++]=224|(ke&61440)>>>12,fe[Se++]=128|(ke&4032)>>>6,fe[Se++]=128|(ke&63)>>>0):(fe[Se++]=240|(ke&1835008)>>>18,fe[Se++]=128|(ke&258048)>>>12,fe[Se++]=128|(ke&4032)>>>6,fe[Se++]=128|(ke&63)>>>0)}return fe}e.encodeUTF8=D;function O(j){const ie=j.byteLength,oe=[];let ce=0;for(;ce<ie;){const fe=j[ce];let Se;if(fe>=240&&ce+3<ie?Se=(j[ce++]&7)<<18>>>0|(j[ce++]&63)<<12>>>0|(j[ce++]&63)<<6>>>0|(j[ce++]&63)<<0>>>0:fe>=224&&ce+2<ie?Se=(j[ce++]&15)<<12>>>0|(j[ce++]&63)<<6>>>0|(j[ce++]&63)<<0>>>0:fe>=192&&ce+1<ie?Se=(j[ce++]&31)<<6>>>0|(j[ce++]&63)<<0>>>0:Se=j[ce++],Se>=0&&Se<=55295||Se>=57344&&Se<=65535)oe.push(String.fromCharCode(Se));else if(Se>=65536&&Se<=1114111){const ke=Se-65536,Fe=55296+((ke&1047552)>>>10),Ce=56320+((ke&1023)>>>0);oe.push(String.fromCharCode(Fe)),oe.push(String.fromCharCode(Ce))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=O;const F=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function T(j){return F.test(j)}e.containsRTL=T;const _=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function N(j){return _.test(j)}e.containsEmoji=N;const K=/^[\t\n\r\x20-\x7E]*$/;function V(j){return K.test(j)}e.isBasicASCII=V,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Q(j){return e.UNUSUAL_LINE_TERMINATORS.test(j)}e.containsUnusualLineTerminators=Q;function ne(j){for(let ie=0,oe=j.length;ie<oe;ie++)if(se(j.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=ne;function se(j){return j=+j,j>=11904&&j<=55215||j>=63744&&j<=64255||j>=65281&&j<=65374}e.isFullWidthCharacter=se;function ae(j){return j>=127462&&j<=127487||j===8986||j===8987||j===9200||j===9203||j>=9728&&j<=10175||j===11088||j===11093||j>=127744&&j<=128591||j>=128640&&j<=128764||j>=128992&&j<=129003||j>=129280&&j<=129535||j>=129648&&j<=129750}e.isEmojiImprecise=ae;function le(j,ie){if(j.length<ie)return j;const oe=/\b/g;let ce=0;for(;oe.test(j)&&!(j.length-oe.lastIndex<ie);)ce=oe.lastIndex,oe.lastIndex+=1;return j.substring(ce).replace(/^\s/,"")}e.lcut=le;const re=/\x1B\x5B[12]?K/g,ue=/\x1b\[\d+m/g,Ee=/\x1b\[0?m/g;function we(j){return j&&(j=j.replace(re,""),j=j.replace(ue,""),j=j.replace(Ee,"")),j}e.removeAnsiEscapeCodes=we,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ie(j){return!!(j&&j.length>0&&j.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ie;function Te(j){return Ie(j)?j.substr(1):j}e.stripUTF8BOM=Te;function ye(j,ie){if(!j||!ie||j.length<ie.length)return!1;const oe=ie.length,ce=j.toLowerCase();let fe=0,Se=-1;for(;fe<oe;){const ke=ce.indexOf(ie[fe],Se+1);if(ke<0)return!1;Se=ke,fe++}return!0}e.fuzzyContains=ye;function me(j,ie=!1){return j?(ie&&(j=j.replace(/\\./g,"")),j.toLowerCase()!==j):!1}e.containsUppercaseCharacter=me;function Pe(j){return j.charAt(0).toUpperCase()+j.slice(1)}e.uppercaseFirstLetter=Pe;function Le(j,ie=1){if(ie===0)return"";let oe=-1;do oe=j.indexOf(`
`,oe+1),ie--;while(ie>0&&oe>=0);return oe===-1?j:(j[oe-1]==="\r"&&oe--,j.substr(0,oe))}e.getNLines=Le;function _e(j){const ie=90-65+1;return j=j%(2*ie),j<ie?String.fromCharCode(97+j):String.fromCharCode(65+j-ie)}e.singleLetterHash=_e;function Be(j){return ze.getInstance().getGraphemeBreakType(j)}e.getGraphemeBreakType=Be;function He(j,ie){return j===0?ie!==5&&ie!==7:j===2&&ie===3?!1:j===4||j===2||j===3||ie===4||ie===2||ie===3?!0:!(j===8&&(ie===8||ie===9||ie===11||ie===12)||(j===11||j===9)&&(ie===9||ie===10)||(j===12||j===10)&&ie===10||ie===5||ie===13||ie===7||j===1||j===13&&ie===14||j===6&&ie===6)}e.breakBetweenGraphemeBreakType=He;var tt;(function(j){j[j.Other=0]="Other",j[j.Prepend=1]="Prepend",j[j.CR=2]="CR",j[j.LF=3]="LF",j[j.Control=4]="Control",j[j.Extend=5]="Extend",j[j.Regional_Indicator=6]="Regional_Indicator",j[j.SpacingMark=7]="SpacingMark",j[j.L=8]="L",j[j.V=9]="V",j[j.T=10]="T",j[j.LV=11]="LV",j[j.LVT=12]="LVT",j[j.ZWJ=13]="ZWJ",j[j.Extended_Pictographic=14]="Extended_Pictographic"})(tt=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=ot()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const oe=this._data,ce=oe.length/3;let fe=1;for(;fe<=ce;)if(ie<oe[3*fe])fe=2*fe;else if(ie>oe[3*fe+1])fe=2*fe+1;else return oe[3*fe+2];return 0}}ze._INSTANCE=null;function ot(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function it(j,ie){if(j===0)return 0;const oe=ht(j,ie);if(oe!==void 0)return oe;const ce=C(ie,j);return j-=Xe(ce),j}e.getLeftDeleteOffset=it;function ht(j,ie){let oe=C(ie,j);for(j-=Xe(oe);dt(oe)||oe===65039||oe===8419;){if(j===0)return;oe=C(ie,j),j-=Xe(oe)}if(!!ae(oe)){if(j>=0){const ce=C(ie,j);ce===8205&&(j-=Xe(ce))}return j}}function Xe(j){return j>=65536?2:1}function dt(j){return 127995<=j&&j<=127999}var at;(function(j){j[j.zwj=8205]="zwj",j[j.emojiVariantSelector=65039]="emojiVariantSelector",j[j.enclosingKeyCap=8419]="enclosingKeyCap"})(at||(at={}))}),define(Z[17],x([0,1,23,64]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer!="undefined",S=typeof TextEncoder!="undefined",I=typeof TextDecoder!="undefined";let n,v;class y{constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}static alloc(f){return R?new y(Buffer.allocUnsafe(f)):new y(new Uint8Array(f))}static wrap(f){return R&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new y(f)}static fromString(f,b){return!((b==null?void 0:b.dontUseNodeBuffer)||!1)&&R?new y(Buffer.from(f)):S?(n||(n=new TextEncoder),new y(n.encode(f))):new y(m.encodeUTF8(f))}static concat(f,b){if(typeof b=="undefined"){b=0;for(let q=0,J=f.length;q<J;q++)b+=f[q].byteLength}const A=y.alloc(b);let U=0;for(let q=0,J=f.length;q<J;q++){const te=f[q];A.set(te,U),U+=te.byteLength}return A}toString(){return R?this.buffer.toString():I?(v||(v=new TextDecoder),v.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(f,b){return new y(this.buffer.subarray(f,b))}set(f,b){f instanceof y?this.buffer.set(f.buffer,b):this.buffer.set(f,b)}readUInt32BE(f){return M(this.buffer,f)}writeUInt32BE(f,b){p(this.buffer,f,b)}readUInt32LE(f){return d(this.buffer,f)}writeUInt32LE(f,b){g(this.buffer,f,b)}readUInt8(f){return k(this.buffer,f)}writeUInt8(f,b){P(this.buffer,f,b)}}e.VSBuffer=y;function i(w,f){return w[f+0]<<0>>>0|w[f+1]<<8>>>0}e.readUInt16LE=i;function E(w,f,b){w[b+0]=f&255,f=f>>>8,w[b+1]=f&255}e.writeUInt16LE=E;function M(w,f){return w[f]*2**24+w[f+1]*2**16+w[f+2]*2**8+w[f+3]}e.readUInt32BE=M;function p(w,f,b){w[b+3]=f,f=f>>>8,w[b+2]=f,f=f>>>8,w[b+1]=f,f=f>>>8,w[b]=f}e.writeUInt32BE=p;function d(w,f){return w[f+0]<<0>>>0|w[f+1]<<8>>>0|w[f+2]<<16>>>0|w[f+3]<<24>>>0}e.readUInt32LE=d;function g(w,f,b){w[b+0]=f&255,f=f>>>8,w[b+1]=f&255,f=f>>>8,w[b+2]=f&255,f=f>>>8,w[b+3]=f&255}e.writeUInt32LE=g;function k(w,f){return w[f]}e.readUInt8=k;function P(w,f,b){w[b]=f}e.writeUInt8=P;function c(w){return L.consumeReadable(w,f=>y.concat(f))}e.readableToBuffer=c;function h(w){return L.toReadable(w)}e.bufferToReadable=h;function o(w){return L.consumeStream(w,f=>y.concat(f))}e.streamToBuffer=o;async function l(w){return w.ended?y.concat(w.buffer):y.concat([...w.buffer,await o(w.stream)])}e.bufferedStreamToBuffer=l;function t(w){return L.toStream(w,f=>y.concat(f))}e.bufferToStream=t;function r(w){return L.transform(w,{data:f=>typeof f=="string"?y.fromString(f):y.wrap(f)},f=>y.concat(f))}e.streamToBufferReadableStream=r;function s(w){return L.newWriteableStream(f=>y.concat(f),w)}e.newWriteableBufferStream=s;function a(w,f){return L.prefixedReadable(w,f,b=>y.concat(b))}e.prefixedBufferReadable=a;function u(w,f){return L.prefixedStream(w,f,b=>y.concat(b))}e.prefixedBufferStream=u}),define(Z[81],x([0,1,23]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(P){return R(P,0)}e.hash=L;function R(P,c){switch(typeof P){case"object":return P===null?S(349,c):Array.isArray(P)?v(P,c):y(P,c);case"string":return n(P,c);case"boolean":return I(P,c);case"number":return S(P,c);case"undefined":return S(937,c);default:return S(617,c)}}e.doHash=R;function S(P,c){return(c<<5)-c+P|0}function I(P,c){return S(P?433:863,c)}function n(P,c){c=S(149417,c);for(let h=0,o=P.length;h<o;h++)c=S(P.charCodeAt(h),c);return c}e.stringHash=n;function v(P,c){return c=S(104579,c),P.reduce((h,o)=>R(o,h),c)}function y(P,c){return c=S(181387,c),Object.keys(P).sort().reduce((h,o)=>(h=n(o,h),R(P[o],h)),c)}class i{constructor(){this._value=0}get value(){return this._value}hash(c){return this._value=R(c,this._value),this._value}}e.Hasher=i;var E;(function(P){P[P.BLOCK_SIZE=64]="BLOCK_SIZE",P[P.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function M(P,c,h=32){const o=h-c,l=~((1<<o)-1);return(P<<c|(l&P)>>>o)>>>0}function p(P,c=0,h=P.byteLength,o=0){for(let l=0;l<h;l++)P[c+l]=o}function d(P,c,h="0"){for(;P.length<c;)P=h+P;return P}function g(P,c=32){return P instanceof ArrayBuffer?Array.from(new Uint8Array(P)).map(h=>h.toString(16).padStart(2,"0")).join(""):d((P>>>0).toString(16),c/4)}e.toHexString=g;class k{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(c){const h=c.length;if(h===0)return;const o=this._buff;let l=this._buffLen,t=this._leftoverHighSurrogate,r,s;for(t!==0?(r=t,s=-1,t=0):(r=c.charCodeAt(0),s=0);;){let a=r;if(m.isHighSurrogate(r))if(s+1<h){const u=c.charCodeAt(s+1);m.isLowSurrogate(u)?(s++,a=m.computeCodePoint(r,u)):a=65533}else{t=r;break}else m.isLowSurrogate(r)&&(a=65533);if(l=this._push(o,l,a),s++,s<h)r=c.charCodeAt(s);else break}this._buffLen=l,this._leftoverHighSurrogate=t}_push(c,h,o){return o<128?c[h++]=o:o<2048?(c[h++]=192|(o&1984)>>>6,c[h++]=128|(o&63)>>>0):o<65536?(c[h++]=224|(o&61440)>>>12,c[h++]=128|(o&4032)>>>6,c[h++]=128|(o&63)>>>0):(c[h++]=240|(o&1835008)>>>18,c[h++]=128|(o&258048)>>>12,c[h++]=128|(o&4032)>>>6,c[h++]=128|(o&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const c=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(c/4294967296),!1),this._buffDV.setUint32(60,c%4294967296,!1),this._step()}_step(){const c=k._bigBlock32,h=this._buffDV;for(let f=0;f<64;f+=4)c.setUint32(f,h.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)c.setUint32(f,M(c.getUint32(f-12,!1)^c.getUint32(f-32,!1)^c.getUint32(f-56,!1)^c.getUint32(f-64,!1),1),!1);let o=this._h0,l=this._h1,t=this._h2,r=this._h3,s=this._h4,a,u,w;for(let f=0;f<80;f++)f<20?(a=l&t|~l&r,u=1518500249):f<40?(a=l^t^r,u=1859775393):f<60?(a=l&t|l&r|t&r,u=2400959708):(a=l^t^r,u=3395469782),w=M(o,5)+a+s+u+c.getUint32(f*4,!1)&4294967295,s=r,r=t,t=M(l,30),l=o,o=w;this._h0=this._h0+o&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=k,k._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Z[13],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(f){return Array.isArray(f)}e.isArray=m;function L(f){return typeof f=="string"}e.isString=L;function R(f){return Array.isArray(f)&&f.every(b=>L(b))}e.isStringArray=R;function S(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=S;function I(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=I;function n(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=n;function v(f){return f===!0||f===!1}e.isBoolean=v;function y(f){return typeof f=="undefined"}e.isUndefined=y;function i(f){return!E(f)}e.isDefined=i;function E(f){return y(f)||f===null}e.isUndefinedOrNull=E;function M(f,b){if(!f)throw new Error(b?`Unexpected type, expected '${b}'`:"Unexpected type")}e.assertType=M;function p(f){if(E(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=p;function d(...f){const b=[];for(let A=0;A<f.length;A++){const U=f[A];if(E(U))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);b.push(U)}return b}e.assertAllDefined=d;const g=Object.prototype.hasOwnProperty;function k(f){if(!S(f))return!1;for(let b in f)if(g.call(f,b))return!1;return!0}e.isEmptyObject=k;function P(f){return typeof f=="function"}e.isFunction=P;function c(...f){return f.length>0&&f.every(P)}e.areFunctions=c;function h(f,b){const A=Math.min(f.length,b.length);for(let U=0;U<A;U++)o(f[U],b[U])}e.validateConstraints=h;function o(f,b){if(L(b)){if(typeof f!==b)throw new Error(`argument does not match constraint: typeof ${b}`)}else if(P(b)){try{if(f instanceof b)return}catch(A){}if(!E(f)&&f.constructor===b||b.length===1&&b.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function l(f){let b=[],A=Object.getPrototypeOf(f);for(;Object.prototype!==A;)b=b.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return b}e.getAllPropertyNames=l;function t(f){const b=[];for(const A of l(f))typeof f[A]=="function"&&b.push(A);return b}e.getAllMethodNames=t;function r(f,b){const A=q=>function(){const J=Array.prototype.slice.call(arguments,0);return b(q,J)};let U={};for(const q of f)U[q]=A(q);return U}e.createProxyObject=r;function s(f){return f===null?void 0:f}e.withNullAsUndefined=s;function a(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=a;function u(f){return class{constructor(){return new Proxy({},{get(b,A){if(b[A])return b[A];throw new Error(`Not Implemented: ${f}->${String(A)}`)}})}}}e.NotImplementedProxy=u;function w(f){throw new Error("Unreachable")}e.assertNever=w}),define(Z[30],x([0,1,3,23,8,13]),function($,e,m,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(s){return s===47||s===92}e.isPathSeparator=I;function n(s){return s.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=n;function v(s){return s.indexOf("/")===-1&&(s=n(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=v;function y(s,a=R.posix.sep){if(!s)return"";const u=s.length,w=s.charCodeAt(0);if(I(w)){if(I(s.charCodeAt(1))&&!I(s.charCodeAt(2))){let b=3;const A=b;for(;b<u&&!I(s.charCodeAt(b));b++);if(A!==b&&!I(s.charCodeAt(b+1))){for(b+=1;b<u;b++)if(I(s.charCodeAt(b)))return s.slice(0,b+1).replace(/[\\/]/g,a)}}return a}else if(P(w)&&s.charCodeAt(1)===58)return I(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let f=s.indexOf("://");if(f!==-1){for(f+=3;f<u;f++)if(I(s.charCodeAt(f)))return s.slice(0,f+1)}return""}e.getRoot=y;function i(s){if(!m.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let u=2;const w=u;for(;u<s.length&&(a=s.charCodeAt(u),a!==92);u++);return!(w===u||(a=s.charCodeAt(u+1),isNaN(a)||a===92))}e.isUNC=i;const E=/[\\/:\*\?"<>\|]/g,M=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(s,a=m.isWindows){const u=a?E:M;return!(!s||s.length===0||/^\s+$/.test(s)||(u.lastIndex=0,u.test(s))||a&&p.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=d;function g(s,a,u){const w=s===a;return!u||w?w:!s||!a?!1:L.equalsIgnoreCase(s,a)}e.isEqual=g;function k(s,a,u,w=R.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(u){if(!L.startsWithIgnoreCase(s,a))return!1;if(a.length===s.length)return!0;let b=a.length;return a.charAt(a.length-1)===w&&b--,s.charAt(b)===w}return a.charAt(a.length-1)!==w&&(a+=w),s.indexOf(a)===0}e.isEqualOrParent=k;function P(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=P;function c(s,a){return m.isWindows&&s.endsWith(":")&&(s+=R.sep),R.isAbsolute(s)||(s=R.join(a,s)),s=R.normalize(s),m.isWindows?(s=L.rtrim(s,R.sep),s.endsWith(":")&&(s+=R.sep)):(s=L.rtrim(s,R.sep),s||(s=R.sep)),s}e.sanitizeFilePath=c;function h(s){const a=R.normalize(s);return m.isWindows?s.length>3?!1:o(a)&&(s.length===2||a.charCodeAt(2)===92):a===R.posix.sep}e.isRootOrDriveLetter=h;function o(s){return m.isWindows?P(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function l(s){return o(s)?s[0]:void 0}e.getDriveLetter=l;function t(s,a,u){return a.length>s.length?-1:s===a?0:(u&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=t;function r(s){const a=s.split(":");let u,w,f;if(a.forEach(b=>{const A=Number(b);S.isNumber(A)?w===void 0?w=A:f===void 0&&(f=A):u=u?[u,b].join(":"):b}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:w!==void 0?w:void 0,column:f!==void 0?f:w!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(Z[44],x([0,1,13]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const k=Array.isArray(g)?[]:{};return Object.keys(g).forEach(P=>{g[P]&&typeof g[P]=="object"?k[P]=L(g[P]):k[P]=g[P]}),k}e.deepClone=L;function R(g){if(!g||typeof g!="object")return g;const k=[g];for(;k.length>0;){const P=k.shift();Object.freeze(P);for(const c in P)if(S.call(P,c)){const h=P[c];typeof h=="object"&&!Object.isFrozen(h)&&k.push(h)}}return g}e.deepFreeze=R;const S=Object.prototype.hasOwnProperty;function I(g,k){return n(g,k,new Set)}e.cloneAndChange=I;function n(g,k,P){if(m.isUndefinedOrNull(g))return g;const c=k(g);if(typeof c!="undefined")return c;if(m.isArray(g)){const h=[];for(const o of g)h.push(n(o,k,P));return h}if(m.isObject(g)){if(P.has(g))throw new Error("Cannot clone recursive data-structure");P.add(g);const h={};for(let o in g)S.call(g,o)&&(h[o]=n(g[o],k,P));return P.delete(g),h}return g}function v(g,k,P=!0){return m.isObject(g)?(m.isObject(k)&&Object.keys(k).forEach(c=>{c in g?P&&(m.isObject(g[c])&&m.isObject(k[c])?v(g[c],k[c],P):g[c]=k[c]):g[c]=k[c]}),g):k}e.mixin=v;function y(g,k){if(g===k)return!0;if(g==null||k===null||k===void 0||typeof g!=typeof k||typeof g!="object"||Array.isArray(g)!==Array.isArray(k))return!1;let P,c;if(Array.isArray(g)){if(g.length!==k.length)return!1;for(P=0;P<g.length;P++)if(!y(g[P],k[P]))return!1}else{const h=[];for(c in g)h.push(c);h.sort();const o=[];for(c in k)o.push(c);if(o.sort(),!y(h,o))return!1;for(P=0;P<h.length;P++)if(!y(g[h[P]],k[h[P]]))return!1}return!0}e.equals=y;function i(g){const k=new Set;return JSON.stringify(g,(P,c)=>{if(m.isObject(c)||Array.isArray(c)){if(k.has(c))return"[Circular]";k.add(c)}return c})}e.safeStringify=i;function E(g,k,P){const c=k(g);return typeof c=="undefined"?P:c}e.getOrDefault=E;function M(g,k){const P=Object.create(null);return!g||!k||Object.keys(k).forEach(h=>{const o=g[h],l=k[h];y(o,l)||(P[h]=l)}),P}e.distinct=M;function p(g,k){const P=k.toLowerCase(),c=Object.keys(g).find(h=>h.toLowerCase()===P);return c?g[c]:g[k]}e.getCaseInsensitive=p;function d(g,k){const P=Object.create(null);for(const c of Object.keys(g))k(c,g[c])&&(P[c]=g[c]);return P}e.filter=d}),define(Z[7],x([0,1,3,8]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,S=/^\//,I=/^\/\//;function n(s,a){if(!s.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!R.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!S.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(s,a){return!s&&!a?"file":s}function y(s,a){switch(s){case"https":case"http":case"file":a?a[0]!==E&&(a=E+a):a=E;break}return a}const i="",E="/",M=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(a,u,w,f,b,A=!1){typeof a=="object"?(this.scheme=a.scheme||i,this.authority=a.authority||i,this.path=a.path||i,this.query=a.query||i,this.fragment=a.fragment||i):(this.scheme=v(a,A),this.authority=u||i,this.path=y(this.scheme,w||i),this.query=f||i,this.fragment=b||i,n(this,A))}static isUri(a){return a instanceof p?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return h(this,!1)}with(a){if(!a)return this;let{scheme:u,authority:w,path:f,query:b,fragment:A}=a;return u===void 0?u=this.scheme:u===null&&(u=i),w===void 0?w=this.authority:w===null&&(w=i),f===void 0?f=this.path:f===null&&(f=i),b===void 0?b=this.query:b===null&&(b=i),A===void 0?A=this.fragment:A===null&&(A=i),u===this.scheme&&w===this.authority&&f===this.path&&b===this.query&&A===this.fragment?this:new g(u,w,f,b,A)}static parse(a,u=!1){const w=M.exec(a);return w?new g(w[2]||i,r(w[4]||i),r(w[5]||i),r(w[7]||i),r(w[9]||i),u):new g(i,i,i,i,i)}static file(a){let u=i;if(m.isWindows&&(a=a.replace(/\\/g,E)),a[0]===E&&a[1]===E){const w=a.indexOf(E,2);w===-1?(u=a.substring(2),a=E):(u=a.substring(2,w),a=a.substring(w)||E)}return new g("file",u,a,i,i)}static from(a){const u=new g(a.scheme,a.authority,a.path,a.query,a.fragment);return n(u,!0),u}static joinPath(a,...u){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return m.isWindows&&a.scheme==="file"?w=p.file(L.win32.join(h(a,!0),...u)).path:w=L.posix.join(a.path,...u),a.with({path:w})}toString(a=!1){return o(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof p)return a;{const u=new g(a);return u._formatted=a.external,u._fsPath=a._sep===d?a.fsPath:null,u}}else return a}}e.URI=p;const d=m.isWindows?1:void 0;class g extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(a=!1){return a?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=d),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const k={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function P(s,a){let u,w=-1;for(let f=0;f<s.length;f++){const b=s.charCodeAt(f);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||a&&b===47)w!==-1&&(u+=encodeURIComponent(s.substring(w,f)),w=-1),u!==void 0&&(u+=s.charAt(f));else{u===void 0&&(u=s.substr(0,f));const A=k[b];A!==void 0?(w!==-1&&(u+=encodeURIComponent(s.substring(w,f)),w=-1),u+=A):w===-1&&(w=f)}}return w!==-1&&(u+=encodeURIComponent(s.substring(w))),u!==void 0?u:s}function c(s){let a;for(let u=0;u<s.length;u++){const w=s.charCodeAt(u);w===35||w===63?(a===void 0&&(a=s.substr(0,u)),a+=k[w]):a!==void 0&&(a+=s[u])}return a!==void 0?a:s}function h(s,a){let u;return s.authority&&s.path.length>1&&s.scheme==="file"?u=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?a?u=s.path.substr(1):u=s.path[1].toLowerCase()+s.path.substr(2):u=s.path,m.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=h;function o(s,a){const u=a?c:P;let w="",{scheme:f,authority:b,path:A,query:U,fragment:q}=s;if(f&&(w+=f,w+=":"),(b||f==="file")&&(w+=E,w+=E),b){let J=b.indexOf("@");if(J!==-1){const te=b.substr(0,J);b=b.substr(J+1),J=te.indexOf(":"),J===-1?w+=u(te,!1):(w+=u(te.substr(0,J),!1),w+=":",w+=u(te.substr(J+1),!1)),w+="@"}b=b.toLowerCase(),J=b.indexOf(":"),J===-1?w+=u(b,!1):(w+=u(b.substr(0,J),!1),w+=b.substr(J))}if(A){if(A.length>=3&&A.charCodeAt(0)===47&&A.charCodeAt(2)===58){const J=A.charCodeAt(1);J>=65&&J<=90&&(A=`/${String.fromCharCode(J+32)}:${A.substr(3)}`)}else if(A.length>=2&&A.charCodeAt(1)===58){const J=A.charCodeAt(0);J>=65&&J<=90&&(A=`${String.fromCharCode(J+32)}:${A.substr(2)}`)}w+=u(A,!0)}return U&&(w+="?",w+=u(U,!1)),q&&(w+="#",w+=a?q:P(q,!1)),w}function l(s){try{return decodeURIComponent(s)}catch(a){return s.length>3?s.substr(0,3)+l(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(s){return s.match(t)?s.replace(t,a=>l(a)):s}}),define(Z[110],x([0,1,7]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(y){const i=y;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=L;function R(y){const i=[];let E;try{const M=JSON.parse(y.arguments),p=M[M.length-1];p&&p.__$stack&&(M.pop(),E=p.__$stack),i.push(...M)}catch(M){i.push("Unable to log remote console arguments",y.arguments)}return{args:i,stack:E}}e.parse=R;function S(y){if(typeof y!="string")return S(R(y).stack);const i=y;if(i){const E=I(i),M=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(M&&M.length===4)return{uri:m.URI.file(M[1]),line:Number(M[2]),column:Number(M[3])}}}e.getFirstFrame=S;function I(y){if(!y)return y;const i=y.indexOf(`
`);return i===-1?y:y.substring(0,i)}function n(y,i){const{args:E,stack:M}=R(y),p=typeof E[0]=="string"&&E.length===1;let d=I(M);d&&(d=`(${d.trim()})`);let g=[];if(typeof E[0]=="string"?d&&p?g=[`%c[${i}] %c${E[0]} %c${d}`,v("blue"),v(""),v("grey")]:g=[`%c[${i}] %c${E[0]}`,v("blue"),v(""),...E.slice(1)]:g=[`%c[${i}]%`,v("blue"),...E],d&&!p&&g.push(d),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,g)}e.log=n;function v(y){return`color: ${y}`}});var Pt=this&&this.__classPrivateFieldSet||function($,e,m,L,R){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?$!==e||!R:!e.has($))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?R.call($,m):R?R.value=m:e.set($,m),m},Ye=this&&this.__classPrivateFieldGet||function($,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?$!==e||!L:!e.has($))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call($):L?L.value:e.get($)};define(Z[37],x([0,1,7,23]),function($,e,m,L){"use strict";var R,S,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function n(t,r,s){let a=t.get(r);return a===void 0&&(a=s,t.set(r,a)),a}e.getOrSet=n;function v(t){const r=[];return t.forEach((s,a)=>{r.push(`${a} => ${s}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=v;function y(t){const r=[];return t.forEach(s=>{r.push(s)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=y;class i{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),a=this._value.charCodeAt(this._pos);return s-a}value(){return this._value[this._pos]}}e.StringIterator=i;class E{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?L.compareSubstring(r,this._value,0,r.length,this._from,this._to):L.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class M{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?L.compareSubstring(r,this._value,0,r.length,this._from,this._to):L.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=M;var p;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(p||(p={}));class d{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new M(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return L.compareIgnoreCase(r,this._value.scheme);if(this._states[this._stateIdx]===2)return L.compareIgnoreCase(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return L.compare(r,this._value.query);if(this._states[this._stateIdx]===5)return L.compare(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class g{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class k{constructor(r){this._iter=r}static forUris(r=()=>!1){return new k(new d(r))}static forPaths(){return new k(new M)}static forStrings(){return new k(new i)}static forConfigKeys(){return new k(new E)}clear(){this._root=void 0}set(r,s){const a=this._iter.reset(r);let u;for(this._root||(this._root=new g,this._root.segment=a.value()),u=this._root;;){const f=a.cmp(u.segment);if(f>0)u.left||(u.left=new g,u.left.segment=a.value()),u=u.left;else if(f<0)u.right||(u.right=new g,u.right.segment=a.value()),u=u.right;else if(a.hasNext())a.next(),u.mid||(u.mid=new g,u.mid.segment=a.value()),u=u.mid;else break}const w=u.value;return u.value=s,u.key=r,w}get(r){var s;return(s=this._getNode(r))===null||s===void 0?void 0:s.value}_getNode(r){const s=this._iter.reset(r);let a=this._root;for(;a;){const u=s.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else break}return a}has(r){const s=this._getNode(r);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const a=this._iter.reset(r),u=[];let w=this._root;for(;w;){const f=a.cmp(w.segment);if(f>0)u.push([1,w]),w=w.left;else if(f<0)u.push([-1,w]),w=w.right;else if(a.hasNext())a.next(),u.push([0,w]),w=w.mid;else{for(s?(w.left=void 0,w.mid=void 0,w.right=void 0):w.value=void 0;u.length>0&&w.isEmpty();){let[b,A]=u.pop();switch(b){case 1:A.left=void 0;break;case 0:A.mid=void 0;break;case-1:A.right=void 0;break}w=A}break}}}findSubstr(r){const s=this._iter.reset(r);let a=this._root,u;for(;a;){const w=s.cmp(a.segment);if(w>0)a=a.left;else if(w<0)a=a.right;else if(s.hasNext())s.next(),u=a.value||u,a=a.mid;else break}return a&&a.value||u}findSuperstr(r){const s=this._iter.reset(r);let a=this._root;for(;a;){const u=s.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(r){for(const[s,a]of this)r(a,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const a=s.pop();a&&(a.value&&(yield[a.key,a.value]),a.left&&s.push(a.left),a.mid&&s.push(a.mid),a.right&&s.push(a.right))}}}e.TernarySearchTree=k;class P{constructor(r,s){this[R]="ResourceMap",r instanceof P?(this.map=new Map(r.map),this.toKey=s??P.defaultToKey):(this.map=new Map,this.toKey=r??P.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[a,u]of this.map)r(u,m.URI.parse(a),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield m.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[m.URI.parse(r[0]),r[1]]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[m.URI.parse(r[0]),r[1]]}}e.ResourceMap=P,P.defaultToKey=t=>t.toString();var c;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class h{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var r;return(r=this._head)===null||r===void 0?void 0:r.value}get last(){var r;return(r=this._tail)===null||r===void 0?void 0:r.value}has(r){return this._map.has(r)}get(r,s=0){const a=this._map.get(r);if(!!a)return s!==0&&this.touch(a,s),a.value}set(r,s,a=0){let u=this._map.get(r);if(u)u.value=s,a!==0&&this.touch(u,a);else{switch(u={key:r,value:s,next:void 0,previous:void 0},a){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(r,u),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const a=this._state;let u=this._head;for(;u;){if(s?r.bind(s)(u.value,u.key,this):r(u.value,u.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,s=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const w={value:a.key,done:!1};return a=a.next,w}else return{value:void 0,done:!0}}};return u}values(){const r=this,s=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const w={value:a.value,done:!1};return a=a.next,w}else return{value:void 0,done:!0}}};return u}entries(){const r=this,s=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const w={value:[a.key,a.value],done:!1};return a=a.next,w}else return{value:void 0,done:!0}}};return u}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,a=this.size;for(;s&&a>r;)this._map.delete(s.key),s=s.next,a--;this._head=s,this._size=a,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,a=r.previous;if(!s||!a)throw new Error("Invalid list");s.previous=a,a.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const a=r.next,u=r.previous;r===this._tail?(u.next=void 0,this._tail=u):(a.previous=u,u.next=a),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const a=r.next,u=r.previous;r===this._head?(a.previous=void 0,this._head=a):(a.previous=u,u.next=a),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,a)=>{r.push([a,s])}),r}fromJSON(r){this.clear();for(const[s,a]of r)this.set(s,a)}}e.LinkedMap=h;class o extends h{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class l{constructor(r){I.set(this,void 0),Pt(this,I,r,"f")}get size(){return Ye(this,I,"f").size}forEach(r,s){Ye(this,I,"f").forEach(r,s)}get(r){return Ye(this,I,"f").get(r)}has(r){return Ye(this,I,"f").has(r)}entries(){return Ye(this,I,"f").entries()}keys(){return Ye(this,I,"f").keys()}values(){return Ye(this,I,"f").values()}[(I=new WeakMap,Symbol.iterator)](){return Ye(this,I,"f").entries()}}e.ReadonlyMapView=l}),define(Z[111],x([0,1,17,23,7]),function($,e,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function S(i){return JSON.stringify(i,v)}e.stringify=S;function I(i){let E=JSON.parse(i);return E=y(E),E}e.parse=I;var n;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(n=e.MarshalledId||(e.MarshalledId={}));function v(i,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:L.regExpFlags(E)}:E}function y(i,E=0){if(!i||E>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return R.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof m.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let M=0;M<i.length;++M)i[M]=y(i[M],E+1);else for(const M in i)Object.hasOwnProperty.call(i,M)&&(i[M]=y(i[M],E+1))}return i}e.revive=y}),define(Z[10],x([0,1,7,3]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractive="vscode-interactive",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp"})(R=e.Schemas||(e.Schemas={}));class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(v){this._preferredWebSchema=v}setDelegate(v){this._delegate=v}set(v,y,i){this._hosts[v]=y,this._ports[v]=i}setConnectionToken(v,y){this._connectionTokens[v]=y}rewrite(v){if(this._delegate)return this._delegate(v);const y=v.authority;let i=this._hosts[y];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const E=this._ports[y],M=this._connectionTokens[y];let p=`path=${encodeURIComponent(v.path)}`;return typeof M=="string"&&(p+=`&tkn=${encodeURIComponent(M)}`),m.URI.from({scheme:L.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${i}:${E}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new S;class I{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(v,y,i){const E=this.toUri(v,y);if(E.scheme===R.vscodeRemote)return e.RemoteAuthorities.rewrite(E);let M=!1;return L.isNative&&(i||L.isPreferringBrowserCodeLoad)&&E.scheme===R.file&&(M=!0),E.scheme===R.file&&typeof L.globals.importScripts=="function"&&L.globals.origin==="vscode-file://vscode-app"&&(M=!0),M?E.with({scheme:R.vscodeFileResource,authority:E.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):E}asFileUri(v,y){const i=this.toUri(v,y);return i.scheme===R.vscodeFileResource?i.with({scheme:R.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(v,y){return m.URI.isUri(v)?v:m.URI.parse(y.toUrl(v))}}e.FileAccess=new I}),define(Z[65],x([0,1,37]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const L=new m.LRUCache(1e4);function R(y){return v(y,"NFC",L)}e.normalizeNFC=R;const S=new m.LRUCache(1e4);function I(y){return v(y,"NFD",S)}e.normalizeNFD=I;const n=/[^\u0000-\u0080]/;function v(y,i,E){if(!e.canNormalize||!y)return y;const M=E.get(y);if(M)return M;let p;return n.test(y)?p=y.normalize(i):p=y,E.set(y,p),p}e.removeAccents=function(){if(e.canNormalize){const y=/[\u0300-\u036f]/g;return function(i){return I(i).replace(y,"")}}else return function(y){return y}}()}),define(Z[15],x([0,1,30,8,7,23,10,3]),function($,e,m,L,R,S,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function v(p){return R.uriToFsPath(p,!0)}e.originalFSPath=v;class y{constructor(d){this._ignorePathCasing=d}compare(d,g,k=!1){return d===g?0:S.compare(this.getComparisonKey(d,k),this.getComparisonKey(g,k))}isEqual(d,g,k=!1){return d===g?!0:!d||!g?!1:this.getComparisonKey(d,k)===this.getComparisonKey(g,k)}getComparisonKey(d,g=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,g,k=!1){if(d.scheme===g.scheme){if(d.scheme===I.Schemas.file)return m.isEqualOrParent(v(d),v(g),this._ignorePathCasing(d))&&d.query===g.query&&(k||d.fragment===g.fragment);if(e.isEqualAuthority(d.authority,g.authority))return m.isEqualOrParent(d.path,g.path,this._ignorePathCasing(d),"/")&&d.query===g.query&&(k||d.fragment===g.fragment)}return!1}joinPath(d,...g){return R.URI.joinPath(d,...g)}basenameOrAuthority(d){return e.basename(d)||d.authority}basename(d){return L.posix.basename(d.path)}extname(d){return L.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let g;return d.scheme===I.Schemas.file?g=R.URI.file(L.dirname(v(d))).path:(g=L.posix.dirname(d.path),d.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),g="/")),d.with({path:g})}normalizePath(d){if(!d.path.length)return d;let g;return d.scheme===I.Schemas.file?g=R.URI.file(L.normalize(v(d))).path:g=L.posix.normalize(d.path),d.with({path:g})}relativePath(d,g){if(d.scheme!==g.scheme||!e.isEqualAuthority(d.authority,g.authority))return;if(d.scheme===I.Schemas.file){const c=L.relative(v(d),v(g));return n.isWindows?m.toSlashes(c):c}let k=d.path||"/",P=g.path||"/";if(this._ignorePathCasing(d)){let c=0;for(const h=Math.min(k.length,P.length);c<h&&!(k.charCodeAt(c)!==P.charCodeAt(c)&&k.charAt(c).toLowerCase()!==P.charAt(c).toLowerCase());c++);k=P.substr(0,c)+k.substr(c)}return L.posix.relative(k,P)}resolvePath(d,g){if(d.scheme===I.Schemas.file){const k=R.URI.file(L.resolve(v(d),g));return d.with({authority:k.authority,path:k.path})}return g=m.toPosixPath(g),d.with({path:L.posix.resolve(d.path,g)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,g){return d===g||S.equalsIgnoreCase(d,g)}hasTrailingPathSeparator(d,g=L.sep){if(d.scheme===I.Schemas.file){const k=v(d);return k.length>m.getRoot(k).length&&k[k.length-1]===g}else{const k=d.path;return k.length>1&&k.charCodeAt(k.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,g=L.sep){return e.hasTrailingPathSeparator(d,g)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,g=L.sep){let k=!1;if(d.scheme===I.Schemas.file){const P=v(d);k=P!==void 0&&P.length===m.getRoot(P).length&&P[P.length-1]===g}else{g="/";const P=d.path;k=P.length===1&&P.charCodeAt(P.length-1)===47}return!k&&!e.hasTrailingPathSeparator(d,g)?d.with({path:d.path+"/"}):d}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(p=>p.scheme===I.Schemas.file?!n.isLinux:!0),e.extUriIgnorePathCase=new y(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(p,d){const g=[];for(let k=0;k<p.length;k++){const P=d(p[k]);p.some((c,h)=>h===k?!1:e.isEqualOrParent(P,d(c)))||g.push(p[k])}return g}e.distinctParents=i;var E;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function d(g){const k=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(h=>{const[o,l]=h.split(":");o&&l&&k.set(o,l)});const c=g.path.substring(0,g.path.indexOf(";"));return c&&k.set(p.META_DATA_MIME,c),k}p.parseMetaData=d})(E=e.DataUri||(e.DataUri={}));function M(p,d,g){if(d){let k=p.path;return k&&k[0]!==L.posix.sep&&(k=L.posix.sep+k),p.with({scheme:g,authority:d,path:k})}return p.with({scheme:g})}e.toLocalResource=M}),define(Z[9],x([0,1,25,16,5,2,79,15]),function($,e,m,L,R,S,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function v(W){return!!W&&typeof W.then=="function"}e.isThenable=v;function y(W){const D=new m.CancellationTokenSource,O=W(D.token),F=new Promise((T,_)=>{D.token.onCancellationRequested(()=>{_(L.canceled())}),Promise.resolve(O).then(N=>{D.dispose(),T(N)},N=>{D.dispose(),_(N)})});return new class{cancel(){D.cancel()}then(T,_){return F.then(T,_)}catch(T){return this.then(void 0,T)}finally(T){return F.finally(T)}}}e.createCancelablePromise=y;function i(W,D,O){return Promise.race([W,new Promise(F=>D.onCancellationRequested(()=>F(O)))])}e.raceCancellation=i;async function E(W){let D=-1;const O=W.map((T,_)=>T.then(N=>(D=_,N))),F=await Promise.race(O);return W.forEach((T,_)=>{_!==D&&T.cancel()}),F}e.raceCancellablePromises=E;function M(W,D,O){let F;const T=setTimeout(()=>{F==null||F(void 0),O==null||O()},D);return Promise.race([W.finally(()=>clearTimeout(T)),new Promise(_=>F=_)])}e.raceTimeout=M;function p(W){return new Promise((D,O)=>{const F=W();v(F)?F.then(D,O):D(F)})}e.asPromise=p;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(D){if(this.activePromise){if(this.queuedPromiseFactory=D,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(O,O).then(F)})}return new Promise((O,F)=>{this.queuedPromise.then(O,F)})}return this.activePromise=D(),new Promise((O,F)=>{this.activePromise.then(T=>{this.activePromise=null,O(T)},T=>{this.activePromise=null,F(T)})})}}e.Throttler=d;class g{constructor(){this.current=Promise.resolve(null)}queue(D){return this.current=this.current.then(()=>D(),()=>D())}}e.Sequencer=g;class k{constructor(){this.promiseMap=new Map}queue(D,O){var F;const _=((F=this.promiseMap.get(D))!==null&&F!==void 0?F:Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(D)===_&&this.promiseMap.delete(D)});return this.promiseMap.set(D,_),_}}e.SequencerByKey=k;class P{constructor(D){this.defaultDelay=D,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(D,O=this.defaultDelay){return this.task=D,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,T)=>{this.doResolve=F,this.doReject=T}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},O),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(L.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=P;class c{constructor(D){this.delayer=new P(D),this.throttler=new d}trigger(D,O){return this.delayer.trigger(()=>this.throttler.queue(D),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class h{constructor(){this._isOpen=!1,this._promise=new Promise((D,O)=>{this._completePromise=D})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=h;class o extends h{constructor(D){super();this._timeout=setTimeout(()=>this.open(),D)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function l(W,D){return D?new Promise((O,F)=>{const T=setTimeout(O,W);D.onCancellationRequested(()=>{clearTimeout(T),F(L.canceled())})}):y(O=>l(W,O))}e.timeout=l;function t(W,D=0){const O=setTimeout(W,D);return S.toDisposable(()=>clearTimeout(O))}e.disposableTimeout=t;function r(W){return W.then(void 0,D=>{})}e.ignoreErrors=r;function s(W){const D=[];let O=0;const F=W.length;function T(){return O<F?W[O++]():null}function _(N){N!=null&&D.push(N);const K=T();return K?K.then(_):Promise.resolve(D)}return Promise.resolve(null).then(_)}e.sequence=s;function a(W,D=F=>!!F,O=null){let F=0;const T=W.length,_=()=>{if(F>=T)return Promise.resolve(O);const N=W[F++];return Promise.resolve(N()).then(V=>D(V)?Promise.resolve(V):_())};return _()}e.first=a;function u(W,D=F=>!!F,O=null){if(W.length===0)return Promise.resolve(O);let F=W.length;const T=()=>{var _,N;F=-1;for(const K of W)(N=(_=K).cancel)===null||N===void 0||N.call(_)};return new Promise((_,N)=>{for(const K of W)K.then(V=>{--F>=0&&D(V)?(T(),_(V)):F===0&&_(O)}).catch(V=>{--F>=0&&(T(),N(V))})})}e.firstParallel=u;class w{constructor(D){this._size=0,this.maxDegreeOfParalellism=D,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(D){return this._size++,new Promise((O,F)=>{this.outstandingPromises.push({factory:D,c:O,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const D=this.outstandingPromises.shift();this.runningPromises++;const O=D.factory();O.then(D.c,D.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=w;class f extends w{constructor(){super(1)}}e.Queue=f;class b{constructor(){this.queues=new Map}queueFor(D,O=n.extUri){const F=O.getComparisonKey(D);let T=this.queues.get(F);return T||(T=new f,R.Event.once(T.onFinished)(()=>{T==null||T.dispose(),this.queues.delete(F)}),this.queues.set(F,T)),T}dispose(){this.queues.forEach(D=>D.dispose()),this.queues.clear()}}e.ResourceQueue=b;class A{constructor(D,O){this._token=-1,typeof D=="function"&&typeof O=="number"&&this.setIfNotSet(D,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(D,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,D()},O)}setIfNotSet(D,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,D()},O))}}e.TimeoutTimer=A;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(D,O){this.cancel(),this._token=setInterval(()=>{D()},O)}}e.IntervalTimer=U;class q{constructor(D,O){this.timeoutToken=-1,this.runner=D,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(D=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,D)}get delay(){return this.timeout}set delay(D){this.timeout=D}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=q;class J extends q{constructor(D,O){super(D,O);this.units=[]}work(D){this.units.push(D),this.isScheduled()||this.schedule()}doRun(){const D=this.units;this.units=[],this.runner&&this.runner(D)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=J;class te extends S.Disposable{constructor(D,O,F,T){super();this.maxWorkChunkSize=D,this.maxPendingWork=O,this.throttleDelay=F,this.handler=T,this.pendingWork=[],this.throttler=this._register(new S.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(D){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+D.length>this.maxPendingWork)return!1}else if(this.pending+D.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...D),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new q(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=te,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const W=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=D=>{const O=setTimeout(()=>D(W));let F=!1;return{dispose(){F||(F=!0,clearTimeout(O))}}}}else e.runWhenIdle=(W,D)=>{const O=requestIdleCallback(W,typeof D=="number"?{timeout:D}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(O))}}}}();class B{constructor(D){this._didRun=!1,this._executor=()=>{try{this._value=D()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=B;async function Y(W,D,O){let F;for(let T=0;T<O;T++)try{return await W()}catch(_){F=_,await l(D)}throw F}e.retry=Y;class G{hasPending(D){return this._pending?typeof D=="number"?this._pending.taskId===D:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var D;(D=this._pending)===null||D===void 0||D.cancel()}setPending(D,O,F){return this._pending={taskId:D,cancel:()=>F==null?void 0:F(),promise:O},O.then(()=>this.donePending(D),()=>this.donePending(D)),O}donePending(D){this._pending&&D===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const D=this._next;this._next=void 0,D.run().then(D.promiseResolve,D.promiseReject)}}setNext(D){if(this._next)this._next.run=D;else{let O,F;const T=new Promise((_,N)=>{O=_,F=N});this._next={run:D,promise:T,promiseResolve:O,promiseReject:F}}return this._next.promise}}e.TaskSequentializer=G;class C{constructor(D){this.interval=D,this.lastIncrementTime=0,this.value=0}increment(){const D=Date.now();return D-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=D,this.value=0),this.value++,this.value}}e.IntervalCounter=C;class z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((D,O)=>{this.completeCallback=D,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(D){return new Promise(O=>{this.completeCallback(D),this.resolved=!0,O()})}error(D){return new Promise(O=>{this.errorCallback(D),this.rejected=!0,O()})}cancel(){new Promise(D=>{this.errorCallback(L.canceled()),this.rejected=!0,D()})}}e.DeferredPromise=z;class X extends R.Emitter{async fireAsync(D,O,F){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new I.LinkedList);for(const T of this._listeners)this._asyncDeliveryQueue.push([T,D]);for(;this._asyncDeliveryQueue.size>0&&!O.isCancellationRequested;){const[T,_]=this._asyncDeliveryQueue.shift(),N=[],K=Object.assign(Object.assign({},_),{waitUntil:V=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");F&&(V=F(V,typeof T=="function"?T:T[0])),N.push(V)}});try{typeof T=="function"?T.call(void 0,K):T[0].call(T[1],K)}catch(V){L.onUnexpectedError(V);continue}Object.freeze(N),await H.settled(N).catch(V=>L.onUnexpectedError(V))}}}}e.AsyncEmitter=X;var H;(function(W){async function D(_){return typeof Promise.allSettled=="function"?O(_):F(_)}W.allSettled=D;async function O(_){return Promise.allSettled(_)}async function F(_){return Promise.all(_.map(N=>N.then(K=>({status:"fulfilled",value:K}),K=>({status:"rejected",reason:K}))))}async function T(_){let N;const K=await Promise.all(_.map(V=>V.then(Q=>Q,Q=>{N||(N=Q)})));if(typeof N!="undefined")throw N;return K}W.settled=T})(H=e.Promises||(e.Promises={}))}),define(Z[112],x([0,1,23,30,8,37,9]),function($,e,m,L,R,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const v="**",y="/",i="[/\\\\]",E="[^/\\\\]",M=/\//g;function p(D){switch(D){case 0:return"";case 1:return`${E}*?`;default:return`(?:${i}|${E}+${i}|${i}${E}+)*?`}}function d(D,O){if(!D)return[];const F=[];let T=!1,_=!1,N="";for(const K of D){switch(K){case O:if(!T&&!_){F.push(N),N="";continue}break;case"{":T=!0;break;case"}":T=!1;break;case"[":_=!0;break;case"]":_=!1;break}N+=K}return N&&F.push(N),F}e.splitGlobAware=d;function g(D){if(!D)return"";let O="";const F=d(D,y);if(F.every(T=>T===v))O=".*";else{let T=!1;F.forEach((_,N)=>{if(_===v){T||(O+=p(2),T=!0);return}let K=!1,V="",Q=!1,ne="";for(const se of _){if(se!=="}"&&K){V+=se;continue}if(Q&&(se!=="]"||!ne)){let ae;se==="-"?ae=se:(se==="^"||se==="!")&&!ne?ae="^":se===y?ae="":ae=m.escapeRegExpCharacters(se),ne+=ae;continue}switch(se){case"{":K=!0;continue;case"[":Q=!0;continue;case"}":O+=`(?:${d(V,",").map(re=>g(re)).join("|")})`,K=!1,V="";break;case"]":O+="["+ne+"]",Q=!1,ne="";break;case"?":O+=E;continue;case"*":O+=p(1);continue;default:O+=m.escapeRegExpCharacters(se)}}N<F.length-1&&(F[N+1]!==v||N+2<F.length)&&(O+=i),T=!1})}return O}const k=/^\*\*\/\*\.[\w\.-]+$/,P=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new S.LRUCache(1e4),r=function(){return!1},s=function(){return null};function a(D,O){if(!D)return s;let F;typeof D!="string"?F=D.pattern:F=D,F=F.trim();const T=`${F}_${!!O.trimForExclusions}`;let _=t.get(T);if(_)return u(_,D);let N;if(k.test(F)){const K=F.substr(4);_=function(V,Q){return typeof V=="string"&&V.endsWith(K)?F:null}}else(N=P.exec(w(F,O)))?_=f(N[1],F):(O.trimForExclusions?h:c).test(F)?_=b(F,O):(N=o.exec(w(F,O)))?_=A(N[1].substr(1),F,!0):(N=l.exec(w(F,O)))?_=A(N[1],F,!1):_=U(F);return t.set(T,_),u(_,D)}function u(D,O){return typeof O=="string"?D:function(F,T){return L.isEqualOrParent(F,O.base)?D(R.relative(O.base,F),T):null}}function w(D,O){return O.trimForExclusions&&D.endsWith("/**")?D.substr(0,D.length-2):D}function f(D,O){const F=`/${D}`,T=`\\${D}`,_=function(K,V){return typeof K!="string"?null:V?V===D?O:null:K===D||K.endsWith(F)||K.endsWith(T)?O:null},N=[D];return _.basenames=N,_.patterns=[O],_.allBasenames=N,_}function b(D,O){const F=W(D.slice(1,-1).split(",").map(V=>a(V,O)).filter(V=>V!==s),D),T=F.length;if(!T)return s;if(T===1)return F[0];const _=function(V,Q){for(let ne=0,se=F.length;ne<se;ne++)if(F[ne](V,Q))return D;return null},N=F.find(V=>!!V.allBasenames);N&&(_.allBasenames=N.allBasenames);const K=F.reduce((V,Q)=>Q.allPaths?V.concat(Q.allPaths):V,[]);return K.length&&(_.allPaths=K),_}function A(D,O,F){const T=R.sep===R.posix.sep,_=T?D:D.replace(M,R.sep),N=R.sep+_,K=R.posix.sep+D,V=F?function(Q,ne){return typeof Q=="string"&&(Q===_||Q.endsWith(N)||!T&&(Q===D||Q.endsWith(K)))?O:null}:function(Q,ne){return typeof Q=="string"&&(Q===_||!T&&Q===D)?O:null};return V.allPaths=[(F?"*/":"./")+D],V}function U(D){try{const O=new RegExp(`^${g(D)}$`);return function(F){return O.lastIndex=0,typeof F=="string"&&O.test(F)?D:null}}catch(O){return s}}function q(D,O,F){return!D||typeof O!="string"?!1:J(D)(O,void 0,F)}e.match=q;function J(D,O={}){if(!D)return r;if(typeof D=="string"||G(D)){const F=a(D,O);if(F===s)return r;const T=function(_,N){return!!F(_,N)};return F.allBasenames&&(T.allBasenames=F.allBasenames),F.allPaths&&(T.allPaths=F.allPaths),T}return X(D,O)}e.parse=J;function te(D){if(!D)return;let O;return F=>(O||(O=(D()||Promise.resolve([])).then(T=>T?Y(T):{})),O.then(T=>!!T[F]))}e.hasSiblingPromiseFn=te;function B(D){if(!D)return;let O;return F=>{if(!O){const T=D();O=T?Y(T):{}}return!!O[F]}}e.hasSiblingFn=B;function Y(D){const O={};for(const F of D)O[F]=!0;return O}function G(D){const O=D;return O&&typeof O.base=="string"&&typeof O.pattern=="string"}e.isRelativePattern=G;function C(D){return D.allBasenames||[]}e.getBasenameTerms=C;function z(D){return D.allPaths||[]}e.getPathTerms=z;function X(D,O){const F=W(Object.getOwnPropertyNames(D).map(V=>H(V,D[V],O)).filter(V=>V!==s)),T=F.length;if(!T)return s;if(!F.some(V=>!!V.requiresSiblings)){if(T===1)return F[0];const V=function(se,ae){for(let le=0,re=F.length;le<re;le++){const ue=F[le](se,ae);if(ue)return ue}return null},Q=F.find(se=>!!se.allBasenames);Q&&(V.allBasenames=Q.allBasenames);const ne=F.reduce((se,ae)=>ae.allPaths?se.concat(ae.allPaths):se,[]);return ne.length&&(V.allPaths=ne),V}const _=function(V,Q,ne){let se;for(let ae=0,le=F.length;ae<le;ae++){const re=F[ae];re.requiresSiblings&&ne&&(Q||(Q=R.basename(V)),se||(se=Q.substr(0,Q.length-R.extname(V).length)));const ue=re(V,Q,se,ne);if(ue)return ue}return null},N=F.find(V=>!!V.allBasenames);N&&(_.allBasenames=N.allBasenames);const K=F.reduce((V,Q)=>Q.allPaths?V.concat(Q.allPaths):V,[]);return K.length&&(_.allPaths=K),_}function H(D,O,F){if(O===!1)return s;const T=a(D,F);if(T===s)return s;if(typeof O=="boolean")return T;if(O){const _=O.when;if(typeof _=="string"){const N=(K,V,Q,ne)=>{if(!ne||!T(K,V))return null;const se=_.replace("$(basename)",Q),ae=ne(se);return I.isThenable(ae)?ae.then(le=>le?D:null):ae?D:null};return N.requiresSiblings=!0,N}}return T}function W(D,O){const F=D.filter(V=>!!V.basenames);if(F.length<2)return D;const T=F.reduce((V,Q)=>{const ne=Q.basenames;return ne?V.concat(ne):V},[]);let _;if(O){_=[];for(let V=0,Q=T.length;V<Q;V++)_.push(O)}else _=F.reduce((V,Q)=>{const ne=Q.patterns;return ne?V.concat(ne):V},[]);const N=function(V,Q){if(typeof V!="string")return null;if(!Q){let se;for(se=V.length;se>0;se--){const ae=V.charCodeAt(se-1);if(ae===47||ae===92)break}Q=V.substr(se)}const ne=T.indexOf(Q);return ne!==-1?_[ne]:null};N.basenames=T,N.patterns=_,N.allBasenames=T;const K=D.filter(V=>!V.basenames);return K.push(N),K}}),define(Z[31],x([0,1,7,8,23,10,3,15,30]),function($,e,m,L,R,S,I,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function y(a,u,w){if(typeof a=="string"&&(a=m.URI.file(a)),w){const b=w.getWorkspaceFolder(a);if(b){const A=w.getWorkspace().folders.length>1;let U;if(n.isEqual(b.uri,a)?U="":U=n.relativePath(b.uri,a),A){const q=b.name?b.name:n.basename(b.uri);U=U?q+" \u2022 "+U:q}return U}}if(a.scheme!==S.Schemas.file&&a.scheme!==S.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if(v.hasDriveLetter(a.fsPath))return L.normalize(E(a.fsPath));let f=L.normalize(a.fsPath);return!I.isWindows&&(u==null?void 0:u.userHome)&&(f=p(f,u.userHome.fsPath)),f}e.getPathLabel=y;function i(a){if(!a)return;typeof a=="string"&&(a=m.URI.file(a));const u=n.basename(a)||(a.scheme===S.Schemas.file?a.fsPath:a.path);return I.isWindows&&v.isRootOrDriveLetter(u)?E(u):u}e.getBaseLabel=i;function E(a){return v.hasDriveLetter(a)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=E;let M=Object.create(null);function p(a,u){if(I.isWindows||!a||!u)return a;let w=M.original===u?M.normalized:void 0;return w||(w=`${R.rtrim(u,L.posix.sep)}${L.posix.sep}`,M={original:u,normalized:w}),(I.isLinux?a.startsWith(w):R.startsWithIgnoreCase(a,w))&&(a=`~/${a.substr(w.length)}`),a}e.tildify=p;function d(a,u){return a.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=d;const g="\u2026",k="\\\\",P="~";function c(a,u=L.sep){const w=new Array(a.length);let f=!1;for(let b=0;b<a.length;b++){let A=a[b];if(A===""){w[b]=`.${u}`;continue}if(!A){w[b]=A;continue}f=!0;let U="";A.indexOf(k)===0?(U=A.substr(0,A.indexOf(k)+k.length),A=A.substr(A.indexOf(k)+k.length)):A.indexOf(u)===0?(U=A.substr(0,A.indexOf(u)+u.length),A=A.substr(A.indexOf(u)+u.length)):A.indexOf(P)===0&&(U=A.substr(0,A.indexOf(P)+P.length),A=A.substr(A.indexOf(P)+P.length));const q=A.split(u);for(let J=1;f&&J<=q.length;J++)for(let te=q.length-J;f&&te>=0;te--){f=!1;let B=q.slice(te,te+J).join(u);for(let Y=0;!f&&Y<a.length;Y++)if(Y!==b&&a[Y]&&a[Y].indexOf(B)>-1){const G=te+J===q.length,C=te>0&&a[Y].indexOf(u)>-1?u+B:B,z=a[Y].endsWith(C);f=!G||z}if(!f){let Y="";(q[0].endsWith(":")||U!=="")&&(te===1&&(te=0,J++,B=q[0]+u+B),te>0&&(Y=q[0]+u),Y=U+Y),te>0&&(Y=Y+g+u),Y=Y+B,te+J<q.length&&(Y=Y+u+g),w[b]=Y}}f&&(w[b]=A)}return w}e.shorten=c;var h;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function o(a,u=Object.create(null)){const w=[];let f=!1,b="";for(const A of a)if(A==="$"||f&&A==="{")b&&w.push({value:b,type:h.TEXT}),b="",f=!0;else if(A==="}"&&f){const U=u[b];if(typeof U=="string")U.length&&w.push({value:U,type:h.VARIABLE});else if(U){const q=w[w.length-1];(!q||q.type!==h.SEPARATOR)&&w.push({value:U.label,type:h.SEPARATOR})}b="",f=!1}else b+=A;return b&&!f&&w.push({value:b,type:h.TEXT}),w.filter((A,U)=>{if(A.type===h.SEPARATOR){const q=w[U-1],J=w[U+1];return[q,J].every(te=>te&&(te.type===h.VARIABLE||te.type===h.TEXT)&&te.value.length>0)}return!0}).map(A=>A.value).join("")}e.template=o;function l(a,u){return I.isMacintosh||u?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):a.replace(/&&|&/g,w=>w==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function t(a,u){return I.isMacintosh||u?a.replace(/\(&&\w\)|&&/g,""):I.isWindows?a.replace(/&&|&/g,w=>w==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(a){const u=a.indexOf("/")!==-1?L.posix:L.win32,w=u.basename(a),f=u.dirname(a);return w.length?{name:w,parentPath:f}:{name:f,parentPath:""}}e.splitName=s}),define(Z[27],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(v){return m.test(v)}e.isUUID=L;const R=new Uint8Array(16),S=[];for(let v=0;v<256;v++)S.push(v.toString(16).padStart(2,"0"));let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(v){for(let y=0;y<v.length;y++)v[y]=Math.floor(Math.random()*256);return v};function n(){I(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let v=0,y="";return y+=S[R[v++]],y+=S[R[v++]],y+=S[R[v++]],y+=S[R[v++]],y+="-",y+=S[R[v++]],y+=S[R[v++]],y+="-",y+=S[R[v++]],y+=S[R[v++]],y+="-",y+=S[R[v++]],y+=S[R[v++]],y+="-",y+=S[R[v++]],y+=S[R[v++]],y+=S[R[v++]],y+=S[R[v++]],y+=S[R[v++]],y+=S[R[v++]],y}e.generateUuid=n}),define(Z[113],x([0,1,29,58,43]),function($,e,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function S(I,n){if(await new Promise((i,E)=>{const M=m.createReadStream(I),p=L.createHash("sha1");M.pipe(p);const d=R.once((g,k)=>{M.removeAllListeners(),p.removeAllListeners(),g?E(g):i(k)});M.once("error",d),M.once("end",d),p.once("error",d),p.once("data",g=>d(void 0,g.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=S}),define(Z[82],x([0,1,239]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(S="utf8"){this.stringDecoder=new m.StringDecoder(S),this.remaining=null}write(S){const I=[],n=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(n.length<1)return I;let v=0,y,i=v;for(;i<n.length;)if(y=n.charCodeAt(i),y===13||y===10){if(I.push(n.substring(v,i)),i++,i<n.length){const E=y;y=n.charCodeAt(i),(E===13&&y===10||E===10&&y===13)&&i++}v=i}else i++;return this.remaining=v<n.length?n.substr(v):null,I}end(){return this.remaining}}e.LineDecoder=L}),define(Z[114],x([0,1,26]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(n){const v=n.replace(/\-/g,":").toLowerCase();return!L.has(v)}function S(){return new Promise(async(n,v)=>{const y=setTimeout(()=>v("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await I())}catch(i){v(i)}finally{clearTimeout(y)}})}e.getMac=S;function I(){return new Promise((n,v)=>{try{const y=m.networkInterfaces();for(let i in y){const E=y[i];if(E){for(const{mac:M}of E)if(R(M))return n(M)}}v("Unable to retrieve mac address (unexpected format)")}catch(y){v(y)}})}}),define(Z[66],x([0,1,16,27,26,37,114]),function($,e,m,L,R,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=S.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,E=0;const M=R.networkInterfaces();for(let p in M){const d=M[p];if(d)for(const{mac:g,internal:k}of d)k||(E+=1,this._isVirtualMachineMacAdress(g.toUpperCase())&&(i+=1))}this._value=E>0?i/E:0}return this._value}};let n;async function v(){return n||(n=(async()=>await y()||L.generateUuid())()),n}e.getMachineId=v;async function y(){try{const i=await new Promise((M,p)=>{$(["crypto"],M,p)}),E=await I.getMac();return i.createHash("sha256").update(E,"utf8").digest("hex")}catch(i){m.onUnexpectedError(i);return}}}),define(Z[18],x([0,1,29,26,115,8,9,3,30,27,65,15,7]),function($,e,m,L,R,S,I,n,v,y,i,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(C){C[C.UNLINK=0]="UNLINK",C[C.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function d(C,z=p.UNLINK){if(v.isRootOrDriveLetter(C))throw new Error("rimraf - will refuse to recursively delete root");return z===p.UNLINK?k(C):g(C)}async function g(C){try{const z=S.join(L.tmpdir(),y.generateUuid());try{await e.Promises.rename(C,z)}catch(X){return k(C)}k(z).catch(X=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function k(C){return e.Promises.rmdir(C,{recursive:!0,maxRetries:3})}function P(C){if(v.isRootOrDriveLetter(C))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(C,{recursive:!0})}e.rimrafSync=P;async function c(C,z){return l(await(z?h(C):R.promisify(m.readdir)(C)))}async function h(C){try{return await R.promisify(m.readdir)(C,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const z=[],X=await c(C);for(const H of X){let W=!1,D=!1,O=!1;try{const F=await e.Promises.lstat(S.join(C,H));W=F.isFile(),D=F.isDirectory(),O=F.isSymbolicLink()}catch(F){console.warn("[node.js fs] unexpected error from lstat after readdir: ",F)}z.push({name:H,isFile:()=>W,isDirectory:()=>D,isSymbolicLink:()=>O})}return z}function o(C){return l(m.readdirSync(C))}e.readdirSync=o;function l(C){return C.map(z=>typeof z=="string"?n.isMacintosh?i.normalizeNFC(z):z:(z.name=n.isMacintosh?i.normalizeNFC(z.name):z.name,z))}async function t(C){const z=await c(C),X=[];for(const H of z)await s.existsDirectory(S.join(C,H))&&X.push(H);return X}function r(C,z=1e3){return new Promise(X=>{let H=!1;const W=setInterval(()=>{H||(H=!0,m.access(C,D=>{H=!1,D&&(clearInterval(W),X(void 0))}))},z)})}e.whenDeleted=r;var s;(function(C){async function z(W){let D;try{if(D=await e.Promises.lstat(W),!D.isSymbolicLink())return{stat:D}}catch(O){}try{return{stat:await e.Promises.stat(W),symbolicLink:(D==null?void 0:D.isSymbolicLink())?{dangling:!1}:void 0}}catch(O){if(O.code==="ENOENT"&&D)return{stat:D,symbolicLink:{dangling:!0}};if(n.isWindows&&O.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(F){if(F.code==="ENOENT"&&D)return{stat:D,symbolicLink:{dangling:!0}};throw F}throw O}}C.stat=z;async function X(W){try{const{stat:D,symbolicLink:O}=await C.stat(W);return D.isFile()&&(O==null?void 0:O.dangling)!==!0}catch(D){}return!1}C.existsFile=X;async function H(W){try{const{stat:D,symbolicLink:O}=await C.stat(W);return D.isDirectory()&&(O==null?void 0:O.dangling)!==!0}catch(D){}return!1}C.existsDirectory=H})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const a=new I.ResourceQueue;function u(C,z,X){return a.queueFor(M.URI.file(C),E.extUriBiasedIgnorePathCase).queue(()=>{const H=A(X);return new Promise((W,D)=>f(C,z,H,O=>O?D(O):W()))})}let w=!0;function f(C,z,X,H){if(!w)return m.writeFile(C,z,{mode:X.mode,flag:X.flag},H);m.open(C,X.flag,X.mode,(W,D)=>{if(W)return H(W);m.writeFile(D,z,O=>{if(O)return m.close(D,()=>H(O));m.fdatasync(D,F=>(F&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",F),w=!1),m.close(D,T=>H(T))))})})}function b(C,z,X){const H=A(X);if(!w)return m.writeFileSync(C,z,{mode:H.mode,flag:H.flag});const W=m.openSync(C,H.flag,H.mode);try{m.writeFileSync(W,z);try{m.fdatasyncSync(W)}catch(D){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",D),w=!1}}finally{m.closeSync(W)}}e.writeFileSync=b;function A(C){return C?{mode:typeof C.mode=="number"?C.mode:438,flag:typeof C.flag=="string"?C.flag:"w"}:{mode:438,flag:"w"}}async function U(C,z){if(C===z)return;async function X(H){try{const W=await e.Promises.lstat(H);if(W.isDirectory()||W.isSymbolicLink())return;await e.Promises.utimes(H,W.atime,new Date)}catch(W){}}try{await e.Promises.rename(C,z),await X(z)}catch(H){if(C.toLowerCase()!==z.toLowerCase()&&H.code==="EXDEV"||C.endsWith("."))await q(C,z,{preserveSymlinks:!1}),await d(C,p.MOVE),await X(z);else throw H}}async function q(C,z,X){return te(C,z,{root:{source:C,target:z},options:X,handledSourcePaths:new Set})}const J=511;async function te(C,z,X){if(X.handledSourcePaths.has(C))return;X.handledSourcePaths.add(C);const{stat:H,symbolicLink:W}=await s.stat(C);if(W){if(X.options.preserveSymlinks)try{return await G(C,z,X)}catch(D){console.warn("[node.js fs] copy of symlink failed: ",D)}if(W.dangling)return}return H.isDirectory()?B(C,z,H.mode&J,X):Y(C,z,H.mode&J)}async function B(C,z,X,H){await e.Promises.mkdir(z,{recursive:!0,mode:X});const W=await c(C);for(const D of W)await te(S.join(C,D),S.join(z,D),H)}async function Y(C,z,X){await e.Promises.copyFile(C,z),await e.Promises.chmod(z,X)}async function G(C,z,X){let H=await e.Promises.readlink(C);v.isEqualOrParent(H,X.root.source,!n.isLinux)&&(H=S.join(X.root.target,H.substr(X.root.source.length+1))),await e.Promises.symlink(H,z)}e.Promises=new class{get access(){return R.promisify(m.access)}get stat(){return R.promisify(m.stat)}get lstat(){return R.promisify(m.lstat)}get utimes(){return R.promisify(m.utimes)}get read(){return R.promisify(m.read)}get readFile(){return R.promisify(m.readFile)}get write(){return R.promisify(m.write)}get appendFile(){return R.promisify(m.appendFile)}get fdatasync(){return R.promisify(m.fdatasync)}get truncate(){return R.promisify(m.truncate)}get rename(){return R.promisify(m.rename)}get copyFile(){return R.promisify(m.copyFile)}get open(){return R.promisify(m.open)}get close(){return R.promisify(m.close)}get symlink(){return R.promisify(m.symlink)}get readlink(){return R.promisify(m.readlink)}get chmod(){return R.promisify(m.chmod)}get mkdir(){return R.promisify(m.mkdir)}get unlink(){return R.promisify(m.unlink)}get rmdir(){return R.promisify(m.rmdir)}get realpath(){return R.promisify(m.realpath)}async exists(C){try{return await e.Promises.access(C),!0}catch(z){return!1}}get readdir(){return c}get readDirsInDir(){return t}get writeFile(){return u}get rm(){return d}get move(){return U}get copy(){return q}}}),define(Z[83],x([0,1,29,23,8,18]),function($,e,m,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function I(i){const E=R.dirname(i);if(i===E)return i;const M=(R.basename(i)||i).toLowerCase();try{const d=S.readdirSync(E).filter(g=>g.toLowerCase()===M);if(d.length===1){const g=I(E);if(g)return R.join(g,d[0])}else if(d.length>1){const g=d.indexOf(M);if(g>=0){const k=I(E);if(k)return R.join(k,d[g])}}}catch(p){}return null}e.realcaseSync=I;async function n(i){try{return await S.Promises.realpath(i)}catch(E){const M=y(i);return await S.Promises.access(M,m.constants.R_OK),M}}e.realpath=n;function v(i){try{return m.realpathSync(i)}catch(E){const M=y(i);return m.accessSync(M,m.constants.R_OK),M}}e.realpathSync=v;function y(i){return L.rtrim(R.normalize(i),R.sep)}}),define(Z[116],x([0,1,59]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(n,v,y){let i=!1;return new Promise(E=>{const M=setTimeout(()=>{if(!i)return i=!0,E(0)},y);R(n,v,p=>{if(!i)return i=!0,clearTimeout(M),E(p)})})}e.findFreePort=L;function R(n,v,y){if(v===0)return y(0);const i=new m.Socket;i.once("connect",()=>(I(i),R(n+1,v-1,y))),i.once("data",()=>{}),i.once("error",E=>(I(i),E.code!=="ECONNREFUSED"?R(n+1,v-1,y):y(n))),i.connect(n,"127.0.0.1")}function S(n,v,y){let i=!1,E,M=1;const p=m.createServer({pauseOnConnect:!0});function d(g,k){i||(i=!0,p.removeAllListeners(),p.close(),E&&clearTimeout(E),k(g))}return new Promise(g=>{E=setTimeout(()=>{d(0,g)},y),p.on("listening",()=>{d(n,g)}),p.on("error",k=>{k&&(k.code==="EADDRINUSE"||k.code==="EACCES")&&M<v?(n++,M++,p.listen(n,"127.0.0.1")):d(0,g)}),p.on("close",()=>{d(0,g)}),p.listen(n,"127.0.0.1")})}e.findFreePortFaster=S;function I(n){try{n.removeAllListeners("connect"),n.removeAllListeners("error"),n.end(),n.destroy(),n.unref()}catch(v){console.error(v)}}});var Oe=this&&this.__await||function($){return this instanceof Oe?(this.v=$,this):new Oe($)},pt=this&&this.__asyncGenerator||function($,e,m){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var L=m.apply($,e||[]),R,S=[];return R={},I("next"),I("throw"),I("return"),R[Symbol.asyncIterator]=function(){return this},R;function I(M){L[M]&&(R[M]=function(p){return new Promise(function(d,g){S.push([M,p,d,g])>1||n(M,p)})})}function n(M,p){try{v(L[M](p))}catch(d){E(S[0][3],d)}}function v(M){M.value instanceof Oe?Promise.resolve(M.value.v).then(y,i):E(S[0][2],M)}function y(M){n("next",M)}function i(M){n("throw",M)}function E(M,p){M(p),S.shift(),S.length&&n(S[0][0],S[0][1])}},yt=this&&this.__asyncValues||function($){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=$[Symbol.asyncIterator],m;return e?e.call($):($=typeof __values=="function"?__values($):$[Symbol.iterator](),m={},L("next"),L("throw"),L("return"),m[Symbol.asyncIterator]=function(){return this},m);function L(S){m[S]=$[S]&&function(I){return new Promise(function(n,v){I=$[S](I),R(n,v,I.done,I.value)})}}function R(S,I,n,v){Promise.resolve(v).then(function(y){S({value:y,done:n})},I)}};define(Z[117],x([0,1,18,26,8]),function($,e,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const S=/^\d+$/,I=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var v;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(v||(v={}));let y;switch(process.arch){case"ia32":case"x32":y=1;break;case"arm":case"arm64":y=2;break;default:y=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class E{constructor(l,t,r){this.exePath=l,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await m.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function M({useAlternateBitness:o=!1}={}){return o?y===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:o=!1,findPreview:l=!1}={}){const t=M({useAlternateBitness:o});if(!t)return null;const r=R.join(t,"PowerShell");if(!await m.SymlinkSupport.existsDirectory(r))return null;let s=-1,a=null;for(const f of await m.Promises.readdir(r)){let b=-1;if(l){const U=f.indexOf("-");if(U<0)continue;const q=f.substring(0,U);if(!S.test(q)||f.substring(U+1)!=="preview")continue;b=parseInt(q,10)}else{if(!S.test(f))continue;b=parseInt(f,10)}if(b<=s)continue;const A=R.join(r,f,"pwsh.exe");!await m.SymlinkSupport.existsFile(A)||(a=A,s=b)}if(!a)return null;const u=t.includes("x86")?" (x86)":"",w=l?" Preview":"";return new E(a,`PowerShell${w}${u}`,!0)}async function d({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const l=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await m.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=o?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:I,pwshMsixName:"PowerShell (Store)"};for(const s of await m.Promises.readdir(l))if(t.test(s)){const a=R.join(l,s,"pwsh.exe");return new E(a,r)}return null}function g(){const o=R.join(L.homedir(),".dotnet","tools","pwsh.exe");return new E(o,".NET Core PowerShell Global Tool")}function k(){const o=R.join(process.env.windir,y===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(o,"Windows PowerShell",!0)}function P(){return pt(this,arguments,function*(){let l=yield Oe(p());l&&(yield yield Oe(l)),l=yield Oe(p({useAlternateBitness:!0})),l&&(yield yield Oe(l)),l=yield Oe(d()),l&&(yield yield Oe(l)),l=g(),l&&(yield yield Oe(l)),l=yield Oe(p({findPreview:!0})),l&&(yield yield Oe(l)),l=yield Oe(d({findPreview:!0})),l&&(yield yield Oe(l)),l=yield Oe(p({useAlternateBitness:!0,findPreview:!0})),l&&(yield yield Oe(l)),l=k(),l&&(yield yield Oe(l))})}function c(){return pt(this,arguments,function*(){var l,t;try{for(var r=yt(P()),s;s=yield Oe(r.next()),!s.done;){const a=s.value;(yield Oe(a.exists()))&&(yield yield Oe(a))}}catch(a){l={error:a}}finally{try{s&&!s.done&&(t=r.return)&&(yield Oe(t.call(r)))}finally{if(l)throw l.error}}})}e.enumeratePowerShellInstallations=c;async function h(){var o,l;try{for(var t=yt(c()),r;r=await t.next(),!r.done;)return r.value}catch(s){o={error:s}}finally{try{r&&!r.done&&(l=t.return)&&await l.call(t)}finally{if(o)throw o.error}}return null}e.getFirstAvailablePowerShellInstallation=h}),define(Z[84],x([0,1,41,10]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(I){return new Promise((n,v)=>{let y;const i=new Map;function E(p,d,g,k,P){const c=i.get(d);if(p===I||c){const h={name:M(g),cmd:g,pid:p,ppid:d,load:k,mem:P};i.set(p,h),p===I&&(y=h),c&&(c.children||(c.children=[]),c.children.push(h),c.children.length>1&&(c.children=c.children.sort((o,l)=>o.pid-l.pid)))}}function M(p){const d=/--disable-blink-features=Auxclick/,g=/\\watcher\\win32\\CodeHelper\.exe/,k=/--crashes-directory/,P=/\\pipe\\winpty-control/,c=/conhost\.exe/,h=/--type=([a-zA-Z-]+)/;if(g.exec(p))return"watcherService ";if(k.exec(p))return"electron-crash-reporter";if(P.exec(p))return"winpty-process";if(c.exec(p))return"console-window-host (Windows internal process)";let o=h.exec(p);if(o&&o.length===2)return o[1]==="renderer"?d.exec(p)?"shared-process":"window":o[1];const l=/[a-zA-Z-]+\.js/g;let t="";do o=l.exec(p),o&&(t+=o+" ");while(o);return t&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${t}`:p}if(process.platform==="win32"){const p=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,g)=>{$(["windows-process-tree"],d,g)}).then(d=>{d.getProcessList(I,g=>{d.getProcessCpuUsage(g,k=>{const P=new Map;k.forEach(c=>{const h=p(c.commandLine||"");P.set(c.pid,{name:M(h),cmd:h,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),y=P.get(I),y?(P.forEach(c=>{const h=P.get(c.ppid);h&&(h.children||(h.children=[]),h.children.push(c))}),P.forEach(c=>{c.children&&(c.children=c.children.sort((h,o)=>h.pid-o.pid))}),n(y)):v(new Error(`Root process ${I} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let p=function(){let d=[y];const g=[];for(;d.length;){const P=d.shift();P&&(g.push(P.pid),P.children&&(d=d.concat(P.children)))}let k=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",$).fsPath);k+=" "+g.join(" "),m.exec(k,{},(P,c,h)=>{if(P||h)v(P||new Error(h.toString()));else{const o=c.toString().split(`
`);for(let l=0;l<g.length;l++){const t=i.get(g[l]);t.load=parseFloat(o[l])}if(!y){v(new Error(`Root process ${I} not found`));return}n(y)}})};m.exec("which ps",{},(d,g,k)=>{if(d||k)if(process.platform!=="linux")v(d||new Error(k.toString()));else{const P=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",$).fsPath);m.exec(P,{},(c,h,o)=>{c||o?v(c||new Error(o.toString())):(S(h,E),p())})}else{const P=g.toString().trim(),c="-ax -o pid=,ppid=,pcpu=,pmem=,command=";m.exec(`${P} ${c}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,o,l)=>{h||l&&!l.includes("screen size is bogus")?v(h||new Error(l.toString())):(S(o,E),process.platform==="linux"?p():y?n(y):v(new Error(`Root process ${I} not found`)))})}})}})}e.listProcesses=R;function S(I,n){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=I.toString().split(`
`);for(const i of y){const E=v.exec(i.trim());E&&E.length===6&&n(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(Z[118],x([0,1,8,29,3,65,2,18]),function($,e,m,L,R,S,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function v(E,M,p){return i({path:E,isDirectory:!1},M,p)}e.watchFile=v;function y(E,M,p){return i({path:E,isDirectory:!0},M,p)}e.watchFolder=y,e.CHANGE_BUFFER_DELAY=100;function i(E,M,p){const d=m.basename(E.path),g=new Map;let k=!1,P=[I.toDisposable(()=>{g.forEach(c=>I.dispose(c)),g.clear()})];try{const c=L.watch(E.path);P.push(I.toDisposable(()=>{c.removeAllListeners(),c.close()}));const h=new Set;E.isDirectory&&n.Promises.readdir(E.path).then(o=>o.forEach(l=>h.add(l))),c.on("error",(o,l)=>{k||p(`Failed to watch ${E.path} for changes using fs.watch() (${o}, ${l})`)}),c.on("change",(o,l)=>{if(k)return;let t="";if(l&&(t=l.toString(),R.isMacintosh&&(t=S.normalizeNFC(t))),!t||o!=="change"&&o!=="rename")return;const r=E.isDirectory?m.join(E.path,t):E.path;if(E.isDirectory)if(o==="rename"){const s=g.get(r);s&&I.dispose(s);const a=setTimeout(async()=>{g.delete(r);const u=await n.Promises.exists(r);if(k)return;let w;u?h.has(t)?w="changed":(w="added",h.add(t)):(h.delete(t),w="deleted"),M(w,r)},e.CHANGE_BUFFER_DELAY);g.set(r,I.toDisposable(()=>clearTimeout(a)))}else{let s;h.has(t)?s="changed":(s="added",h.add(t)),M(s,r)}else if(o==="rename"||t!==d){const s=setTimeout(async()=>{const a=await n.Promises.exists(r);k||(a?(M("changed",r),P=[i(E,M,p)]):M("deleted",r))},e.CHANGE_BUFFER_DELAY);I.dispose(P),P=[I.toDisposable(()=>clearTimeout(s))]}else M("changed",r)})}catch(c){n.Promises.exists(E.path).then(h=>{h&&!k&&p(`Failed to watch ${E.path} for changes using fs.watch() (${c.toString()})`)})}return I.toDisposable(()=>{k=!0,P=I.dispose(P)})}}),define(Z[119],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[120],x([0,1,14,119,13]),function($,e,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function S(){m.ipcMain.on(L.CONTEXT_MENU_CHANNEL,(n,v,y,i,E)=>{const M=I(n,i,y);M.popup({window:R.withNullAsUndefined(m.BrowserWindow.fromWebContents(n.sender)),x:E?E.x:void 0,y:E?E.y:void 0,positioningItem:E?E.positioningItem:void 0,callback:()=>{M&&n.sender.send(L.CONTEXT_MENU_CLOSE_CHANNEL,v)}})})}e.registerContextMenuListener=S;function I(n,v,y){const i=new m.Menu;return y.forEach(E=>{let M;E.type==="separator"?M=new m.MenuItem({type:E.type}):Array.isArray(E.submenu)?M=new m.MenuItem({submenu:I(n,v,E.submenu),label:E.label}):M=new m.MenuItem({label:E.label,type:E.type,accelerator:E.accelerator,checked:E.checked,enabled:E.enabled,visible:E.visible,click:(p,d,g)=>n.sender.send(v,E.id,g)}),i.append(M)}),i}});var he=this&&this.__decorate||function($,e,m,L){var R=arguments.length,S=R<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,m):L,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate($,e,m,L);else for(var n=$.length-1;n>=0;n--)(I=$[n])&&(S=(R<3?I(S):R>3?I(e,m,S):I(e,m))||S);return R>3&&S&&Object.defineProperty(e,m,S),S};define(Z[34],x([0,1,5,2,9,25,16,17,36,13,111,23,46]),function($,e,m,L,R,S,I,n,v,y,i,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function d(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function k(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var P;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(P||(P={}));class c{constructor(D){this.buffer=D,this.pos=0}read(D){const O=this.buffer.slice(this.pos,this.pos+D);return this.pos+=O.byteLength,O}}class h{constructor(){this.buffers=[]}get buffer(){return n.VSBuffer.concat(this.buffers)}write(D){this.buffers.push(D)}}var o;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(o||(o={}));function l(W){const D=n.VSBuffer.alloc(4);return D.writeUInt32BE(W,0),D}function t(W){return W.read(4).readUInt32BE(0)}function r(W){const D=n.VSBuffer.alloc(1);return D.writeUInt8(W,0),D}const s={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object)},a=typeof Buffer!="undefined";function u(W,D){if(typeof D=="undefined")W.write(s.Undefined);else if(typeof D=="string"){const O=n.VSBuffer.fromString(D);W.write(s.String),W.write(l(O.byteLength)),W.write(O)}else if(a&&Buffer.isBuffer(D)){const O=n.VSBuffer.wrap(D);W.write(s.Buffer),W.write(l(O.byteLength)),W.write(O)}else if(D instanceof n.VSBuffer)W.write(s.VSBuffer),W.write(l(D.byteLength)),W.write(D);else if(Array.isArray(D)){W.write(s.Array),W.write(l(D.length));for(const O of D)u(W,O)}else{const O=n.VSBuffer.fromString(JSON.stringify(D));W.write(s.Object),W.write(l(O.byteLength)),W.write(O)}}function w(W){switch(W.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return W.read(t(W)).toString();case o.Buffer:return W.read(t(W)).buffer;case o.VSBuffer:return W.read(t(W));case o.Array:{const O=t(W),F=[];for(let T=0;T<O;T++)F.push(w(W));return F}case o.Object:return JSON.parse(W.read(t(W)).toString())}}class f{constructor(D,O,F=null,T=1e3){this.protocol=D,this.ctx=O,this.logger=F,this.timeoutDelay=T,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(_=>this.onRawMessage(_)),this.sendResponse({type:200})}registerChannel(D,O){this.channels.set(D,O),setTimeout(()=>this.flushPendingRequests(D),0)}sendResponse(D){switch(D.type){case 200:{const O=this.send([D.type]);this.logger&&this.logger.logOutgoing(O,0,1,k(D.type));return}case 201:case 202:case 204:case 203:{const O=this.send([D.type,D.id],D.data);this.logger&&this.logger.logOutgoing(O,D.id,1,k(D.type),D.data);return}}}send(D,O=void 0){const F=new h;return u(F,D),u(F,O),this.sendBuffer(F.buffer)}sendBuffer(D){try{return this.protocol.send(D),D.byteLength}catch(O){return 0}}onRawMessage(D){const O=new c(D),F=w(O),T=w(O),_=F[0];switch(_){case 100:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${d(_)}: ${F[2]}.${F[3]}`,T),this.onPromise({type:_,id:F[1],channelName:F[2],name:F[3],arg:T});case 102:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${d(_)}: ${F[2]}.${F[3]}`,T),this.onEventListen({type:_,id:F[1],channelName:F[2],name:F[3],arg:T});case 101:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${d(_)}`),this.disposeActiveRequest({type:_,id:F[1]});case 103:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${d(_)}`),this.disposeActiveRequest({type:_,id:F[1]})}}onPromise(D){const O=this.channels.get(D.channelName);if(!O){this.collectPendingRequest(D);return}const F=new S.CancellationTokenSource;let T;try{T=O.call(this.ctx,D.name,D.arg,F.token)}catch(K){T=Promise.reject(K)}const _=D.id;T.then(K=>{this.sendResponse({id:_,data:K,type:201}),this.activeRequests.delete(D.id)},K=>{K instanceof Error?this.sendResponse({id:_,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.sendResponse({id:_,data:K,type:203}),this.activeRequests.delete(D.id)});const N=L.toDisposable(()=>F.cancel());this.activeRequests.set(D.id,N)}onEventListen(D){const O=this.channels.get(D.channelName);if(!O){this.collectPendingRequest(D);return}const F=D.id,_=O.listen(this.ctx,D.name,D.arg)(N=>this.sendResponse({id:F,data:N,type:204}));this.activeRequests.set(D.id,_)}disposeActiveRequest(D){const O=this.activeRequests.get(D.id);O&&(O.dispose(),this.activeRequests.delete(D.id))}collectPendingRequest(D){let O=this.pendingRequests.get(D.channelName);O||(O=[],this.pendingRequests.set(D.channelName,O));const F=setTimeout(()=>{console.error(`Unknown channel: ${D.channelName}`),D.type===100&&this.sendResponse({id:D.id,data:{name:"Unknown channel",message:`Channel name '${D.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:D,timeoutTimer:F})}flushPendingRequests(D){const O=this.pendingRequests.get(D);if(O){for(const F of O)switch(clearTimeout(F.timeoutTimer),F.request.type){case 100:this.onPromise(F.request);break;case 102:this.onEventListen(F.request);break}this.pendingRequests.delete(D)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(D=>D.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var b;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(b=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(D,O=null){this.protocol=D,this.isDisposed=!1,this.state=P.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(F=>this.onBuffer(F)),this.logger=O}getChannel(D){const O=this;return{call(F,T,_){return O.isDisposed?Promise.reject(I.canceled()):O.requestPromise(D,F,T,_)},listen(F,T){return O.isDisposed?Promise.reject(I.canceled()):O.requestEvent(D,F,T)}}}requestPromise(D,O,F,T=S.CancellationToken.None){const _=this.lastRequestId++,K={id:_,type:100,channelName:D,name:O,arg:F};if(T.isCancellationRequested)return Promise.reject(I.canceled());let V;return new Promise((ne,se)=>{if(T.isCancellationRequested)return se(I.canceled());const ae=()=>{const Ee=we=>{switch(we.type){case 201:this.handlers.delete(_),ne(we.data);break;case 202:this.handlers.delete(_);const Ie=new Error(we.data.message);Ie.stack=we.data.stack,Ie.name=we.data.name,se(Ie);break;case 203:this.handlers.delete(_),se(we.data);break}};this.handlers.set(_,Ee),this.sendRequest(K)};let le=null;this.state===P.Idle?ae():(le=R.createCancelablePromise(Ee=>this.whenInitialized()),le.then(()=>{le=null,ae()}));const re=()=>{le?(le.cancel(),le=null):this.sendRequest({id:_,type:101}),se(I.canceled())},ue=T.onCancellationRequested(re);V=L.combinedDisposable(L.toDisposable(re),ue),this.activeRequests.add(V)}).finally(()=>{this.activeRequests.delete(V)})}requestEvent(D,O,F){const T=this.lastRequestId++,N={id:T,type:102,channelName:D,name:O,arg:F};let K=null;const V=new m.Emitter({onFirstListenerAdd:()=>{K=R.createCancelablePromise(ne=>this.whenInitialized()),K.then(()=>{K=null,this.activeRequests.add(V),this.sendRequest(N)})},onLastListenerRemove:()=>{K?(K.cancel(),K=null):(this.activeRequests.delete(V),this.sendRequest({id:T,type:103}))}}),Q=ne=>V.fire(ne.data);return this.handlers.set(T,Q),V.event}sendRequest(D){switch(D.type){case 100:case 102:{const O=this.send([D.type,D.id,D.channelName,D.name],D.arg);this.logger&&this.logger.logOutgoing(O,D.id,0,`${d(D.type)}: ${D.channelName}.${D.name}`,D.arg);return}case 101:case 103:{const O=this.send([D.type,D.id]);this.logger&&this.logger.logOutgoing(O,D.id,0,d(D.type));return}}}send(D,O=void 0){const F=new h;return u(F,D),u(F,O),this.sendBuffer(F.buffer)}sendBuffer(D){try{return this.protocol.send(D),D.byteLength}catch(O){return 0}}onBuffer(D){const O=new c(D),F=w(O),T=w(O),_=F[0];switch(_){case 200:return this.logger&&this.logger.logIncoming(D.byteLength,0,0,k(_)),this.onResponse({type:F[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],0,k(_),T),this.onResponse({type:F[0],id:F[1],data:T})}}onResponse(D){if(D.type===200){this.state=P.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(D.id);O&&O(D)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===P.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(D=>D.dispose()),this.activeRequests.clear()}}he([M.memoize],A.prototype,"onDidInitializePromise",null),e.ChannelClient=A;class U{constructor(D){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,D(({protocol:O,onDidClientDisconnect:F})=>{m.Event.once(O.onMessage)(_=>{const N=new c(_),K=w(N),V=new f(O,K),Q=new A(O);this.channels.forEach((se,ae)=>V.registerChannel(ae,se));const ne={channelServer:V,channelClient:Q,ctx:K};this._connections.add(ne),this._onDidAddConnection.fire(ne),F(()=>{V.dispose(),Q.dispose(),this._connections.delete(ne),this._onDidRemoveConnection.fire(ne)})})})}get connections(){const D=[];return this._connections.forEach(O=>D.push(O)),D}getChannel(D,O){const F=this;return{call(T,_,N){let K;if(y.isFunction(O)){let Q=v.getRandomElement(F.connections.filter(O));K=Q?Promise.resolve(Q):m.Event.toPromise(m.Event.filter(F.onDidAddConnection,O))}else K=O.routeCall(F,T,_);const V=K.then(Q=>Q.channelClient.getChannel(D));return J(V).call(T,_,N)},listen(T,_){if(y.isFunction(O))return F.getMulticastEvent(D,O,T,_);const N=O.routeEvent(F,T,_).then(K=>K.channelClient.getChannel(D));return J(N).listen(T,_)}}}getMulticastEvent(D,O,F,T){const _=this;let N=new L.DisposableStore;const K=new m.Emitter({onFirstListenerAdd:()=>{N=new L.DisposableStore;const V=new m.EventMultiplexer,Q=new Map,ne=ae=>{const re=ae.channelClient.getChannel(D).listen(F,T),ue=V.add(re);Q.set(ae,ue)},se=ae=>{const le=Q.get(ae);!le||(le.dispose(),Q.delete(ae))};_.connections.filter(O).forEach(ne),m.Event.filter(_.onDidAddConnection,O)(ne,void 0,N),_.onDidRemoveConnection(se,void 0,N),V.event(K.fire,K,N),N.add(V)},onLastListenerRemove:()=>{N.dispose()}});return K.event}registerChannel(D,O){this.channels.set(D,O),this._connections.forEach(F=>{F.channelServer.registerChannel(D,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=U;class q{constructor(D,O,F=null){const T=new h;u(T,O),D.send(T.buffer),this.channelClient=new A(D,F),this.channelServer=new f(D,O,F)}getChannel(D){return this.channelClient.getChannel(D)}registerChannel(D,O){this.channelServer.registerChannel(D,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=q;function J(W){return{call(D,O,F){return W.then(T=>T.call(D,O,F))},listen(D,O){const F=new m.Relay;return W.then(T=>F.input=T.listen(D,O)),F.event}}}e.getDelayedChannel=J;function te(W){let D=!1;return{call(O,F,T){return D?W.call(O,F,T):R.timeout(0).then(()=>D=!0).then(()=>W.call(O,F,T))},listen(O,F){if(D)return W.listen(O,F);const T=new m.Relay;return R.timeout(0).then(()=>D=!0).then(()=>T.input=W.listen(O,F)),T.event}}}e.getNextTickChannel=te;class B{constructor(D){this.fn=D}routeCall(D){return this.route(D)}routeEvent(D){return this.route(D)}async route(D){for(const O of D.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await m.Event.toPromise(D.onDidAddConnection),await this.route(D)}}e.StaticRouter=B;var Y;(function(W){function D(T,_){const N=T,K=_&&_.disableMarshalling,V=new Map;for(const Q in N)F(Q)&&V.set(Q,m.Event.buffer(N[Q],!0));return new class{listen(Q,ne){const se=V.get(ne);if(se)return se;throw new Error(`Event not found: ${ne}`)}call(Q,ne,se){const ae=N[ne];if(typeof ae=="function"){if(!K&&Array.isArray(se))for(let le=0;le<se.length;le++)se[le]=i.revive(se[le]);return ae.apply(N,se)}throw new Error(`Method not found: ${ne}`)}}}W.fromService=D;function O(T,_){const N=_&&_.disableMarshalling;return new Proxy({},{get(K,V){var Q;if(typeof V=="string")return((Q=_==null?void 0:_.properties)===null||Q===void 0?void 0:Q.has(V))?_.properties.get(V):F(V)?T.listen(V):async function(...ne){let se;_&&!y.isUndefinedOrNull(_.context)?se=[_.context,...ne]:se=ne;const ae=await T.call(V,se);return N?ae:i.revive(ae)};throw new Error(`Property not found: ${String(V)}`)}})}W.toService=O;function F(T){return T[0]==="o"&&T[1]==="n"&&E.isUpperAsciiLetter(T.charCodeAt(2))}})(Y=e.ProxyChannel||(e.ProxyChannel={}));const G=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function C(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){let D=W.toString();if(D!=="[object Object]")return D}return W}function z(W){return Array.isArray(W)?W.map(C):C(W)}function X(W,D,O,F,T,_,N){N=z(N);const K=G[T],V=K[F%K.length];let Q=[`%c[${W}]%c[${String(D).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(F).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(_)?(Q=Q.concat(N),Q.push(")")):Q.push(N),console.log.apply(console,Q)}e.logWithColors=X;class H{constructor(D,O){this._outgoingPrefix=D,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(D,O,F,T,_){this._totalOutgoing+=D,X(this._outgoingPrefix,this._totalOutgoing,D,O,F,T,_)}logIncoming(D,O,F,T,_){this._totalIncoming+=D,X(this._incomingPrefix,this._totalIncoming,D,O,F,T,_)}}e.IPCLogger=H}),define(Z[121],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class m{constructor(R,S){this.sender=R,this.onMessage=S}send(R){try{this.sender.send("vscode:message",R.buffer)}catch(S){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=m}),define(Z[122],x([0,1,5,34,17]),function($,e,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class S{constructor(v){this.port=v,this.onMessage=m.Event.fromDOMEventEmitter(this.port,"message",y=>R.VSBuffer.wrap(y.data)),v.start()}send(v){this.port.postMessage(v.buffer)}disconnect(){this.port.close()}}e.Protocol=S;class I extends L.IPCClient{constructor(v,y){const i=new S(v);super(i,y);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=I}),define(Z[85],x([0,1,5,34,2,17,3,33]),function($,e,m,L,R,S,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var v;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v=e.SocketCloseEventType||(e.SocketCloseEventType={}));let y=null;function i(){return y||(y=S.VSBuffer.alloc(0)),y}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(a){this._chunks.push(a),this._totalLength+=a.byteLength}read(a){return this._read(a,!0)}peek(a){return this._read(a,!1)}_read(a,u){if(a===0)return i();if(a>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===a){const A=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=a),A}if(this._chunks[0].byteLength>a){const A=this._chunks[0].slice(0,a);return u&&(this._chunks[0]=this._chunks[0].slice(a),this._totalLength-=a),A}let w=S.VSBuffer.alloc(a),f=0,b=0;for(;a>0;){const A=this._chunks[b];if(A.byteLength>a){const U=A.slice(0,a);w.set(U,f),f+=a,u&&(this._chunks[b]=A.slice(a),this._totalLength-=a),a-=a}else w.set(A,f),f+=A.byteLength,u?(this._chunks.shift(),this._totalLength-=A.byteLength):b++,a-=A.byteLength}return w}}e.ChunkStream=E;var M;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(M||(M={}));var p;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(a,u,w,f){this.type=a,this.id=u,this.ack=w,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends R.Disposable{constructor(a){super();this._onMessage=this._register(new m.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=a,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5);else{const w=this._state.messageType,f=this._state.id,b=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(w,f,b,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class k{constructor(a){this._isDisposed=!1,this._socket=a,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(a){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(a){if(this._isDisposed)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=S.VSBuffer.alloc(13);u.writeUInt8(a.type,0),u.writeUInt32BE(a.id,1),u.writeUInt32BE(a.ack,5),u.writeUInt32BE(a.data.byteLength,9),this._writeSoon(u,a.data)}_bufferAdd(a,u){const w=this._totalLength===0;return this._data.push(a,u),this._totalLength+=a.byteLength+u.byteLength,w}_bufferTake(){const a=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,a}_writeSoon(a,u){this._bufferAdd(a,u)&&I.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class P extends R.Disposable{constructor(a){super();this._onMessage=new m.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new m.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=a,this._socketWriter=this._register(new k(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(a){this._socketWriter.write(new d(1,0,0,a))}}e.Protocol=P;class c extends L.IPCClient{constructor(a,u,w=null){super(a,u,w);this.protocol=a}static fromSocket(a,u){return new c(new P(a),u)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const a=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),a.end()}}e.Client=c;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new m.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,n.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(a){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(a):this._emitter.fire(a):this._bufferedMessages.push(a)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class o{constructor(a){this.data=a,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let a=[],u=0,w=this._first;for(;w;)a[u++]=w.data,w=w.next;return a}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(a){const u=new o(a);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class t{constructor(){this.lastRuns=[];const a=Date.now();for(let u=0;u<t._HISTORY_LENGTH;u++)this.lastRuns[u]=a-1e3*u;setInterval(()=>{for(let u=t._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const a=Date.now(),u=(1+t._HISTORY_LENGTH)*1e3;let w=0;for(let f=0;f<t._HISTORY_LENGTH;f++)a-this.lastRuns[f]<=u&&w++;return 1-w/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class r{constructor(a,u=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=a,this._socketWriter=new k(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(w=>this._receiveMessage(w))),this._socketDisposables.push(this._socket.onClose(w=>this._onSocketClose.fire(w))),u&&this._socketReader.acceptChunk(u),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=R.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const a=new d(5,0,0,i());this._socketWriter.write(a),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const a=Date.now()-this._socketWriter.lastWriteTime;if(a>=5e3){const u=new d(4,0,0,i());this._socketWriter.write(u),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-a+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const a=Date.now()-this._socketReader.lastReadTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-a,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(a,u){this._isReconnecting=!0,this._socketDisposables=R.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=a,this._socketWriter=new k(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(w=>this._receiveMessage(w))),this._socketDisposables.push(this._socket.onClose(w=>this._onSocketClose.fire(w))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1;const a=this._outgoingUnackMsg.toArray();for(let u=0,w=a.length;u<w;u++)this._socketWriter.write(a[u]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(a){if(a.ack>this._outgoingAckId){this._outgoingAckId=a.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=a.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(a.type===1){if(a.id>this._incomingMsgId)if(a.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new d(6,0,0,i())))}else this._incomingMsgId=a.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(a.data)}else if(a.type===2)this._onControlMessage.fire(a.data);else if(a.type===5)this._onDidDispose.fire();else if(a.type===6){const u=this._outgoingUnackMsg.toArray();for(let w=0,f=u.length;w<f;w++)this._socketWriter.write(u[w]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(a){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const w=new d(1,u,this._incomingAckId,a);this._outgoingUnackMsg.push(w),this._isReconnecting||(this._socketWriter.write(w),this._recvAckCheck())}sendControl(a){const u=new d(2,0,0,a);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const a=Date.now()-this._incomingMsgLastTime;if(a>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-a+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const a=this._outgoingUnackMsg.peek(),u=Date.now()-a.writtenTime;if(u>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-u,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const a=new d(3,0,this._incomingAckId,i());this._socketWriter.write(a)}}e.PersistentProtocol=r}),define(Z[123],x([0,1,14,5,34,121,2,17]),function($,e,m,L,R,S,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function v(i,E){const M=L.Event.fromNodeEventEmitter(m.ipcMain,E,(d,g)=>({event:d,message:g})),p=L.Event.filter(M,({event:d})=>d.sender.id===i);return L.Event.map(p,({message:d})=>d&&n.VSBuffer.wrap(d))}class y extends R.IPCServer{constructor(){super(y.getOnDidClientConnect())}static getOnDidClientConnect(){const E=L.Event.fromNodeEventEmitter(m.ipcMain,"vscode:hello",({sender:M})=>M);return L.Event.map(E,M=>{const p=M.id,d=y.Clients.get(p);d&&d.dispose();const g=new L.Emitter;y.Clients.set(p,I.toDisposable(()=>g.fire()));const k=v(p,"vscode:message"),P=L.Event.any(L.Event.signal(v(p,"vscode:disconnect")),g.event);return{protocol:new S.Protocol(M,k),onDidClientDisconnect:P}})}}e.Server=y,y.Clients=new Map}),define(Z[86],x([0,1,14,5,27,122]),function($,e,m,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class I extends S.Client{constructor(y,i){super({addEventListener:(E,M)=>y.addListener(E,M),removeEventListener:(E,M)=>y.removeListener(E,M),postMessage:E=>y.postMessage(E),start:()=>y.start(),close:()=>y.close()},i)}}e.Client=I;async function n(v){if(v.isDestroyed()||v.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const y=R.generateUuid();v.webContents.send("vscode:createMessageChannel",y);const i=L.Event.fromNodeEventEmitter(m.ipcMain,"vscode:createMessageChannelResult",(M,p)=>({nonce:p,port:M.ports[0]})),{port:E}=await L.Event.toPromise(L.Event.once(L.Event.filter(i,M=>M.nonce===y)));return E}e.connect=n}),define(Z[87],x([0,1,2,5,9,13]),function($,e,m,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var I;(function(i){i[i.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(I=e.StorageHint||(e.StorageHint={}));var n;(function(i){i[i.None=0]="None",i[i.Initialized=1]="Initialized",i[i.Closed=2]="Closed"})(n||(n={}));class v extends m.Disposable{constructor(E,M=Object.create(null)){super();this.database=E,this.options=M,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=n.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(v.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(E=>this.onDidChangeItemsExternal(E)))}onDidChangeItemsExternal(E){var M,p;(M=E.changed)===null||M===void 0||M.forEach((d,g)=>this.accept(g,d)),(p=E.deleted)===null||p===void 0||p.forEach(d=>this.accept(d,void 0))}accept(E,M){if(this.state===n.Closed)return;let p=!1;S.isUndefinedOrNull(M)?p=this.cache.delete(E):this.cache.get(E)!==M&&(this.cache.set(E,M),p=!0),p&&this._onDidChangeStorage.fire(E)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===n.None&&(this.state=n.Initialized,this.options.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(E,M){const p=this.cache.get(E);return S.isUndefinedOrNull(p)?M:p}getBoolean(E,M){const p=this.get(E);return S.isUndefinedOrNull(p)?M:p==="true"}getNumber(E,M){const p=this.get(E);return S.isUndefinedOrNull(p)?M:parseInt(p,10)}async set(E,M){if(this.state===n.Closed)return;if(S.isUndefinedOrNull(M))return this.delete(E);const p=String(M);if(this.cache.get(E)!==p)return this.cache.set(E,p),this.pendingInserts.set(E,p),this.pendingDeletes.delete(E),this._onDidChangeStorage.fire(E),this.flushDelayer.trigger(()=>this.flushPending())}async delete(E){if(!(this.state===n.Closed||!this.cache.delete(E)))return this.pendingDeletes.has(E)||this.pendingDeletes.add(E),this.pendingInserts.delete(E),this._onDidChangeStorage.fire(E),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=n.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(E){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const E={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(E).finally(()=>{var M;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(M=this.whenFlushedCallbacks.pop())===null||M===void 0||M()})}async whenFlushed(){if(!!this.hasPending)return new Promise(E=>this.whenFlushedCallbacks.push(E))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=v,v.DEFAULT_FLUSH_DELAY=100;class y{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(E){E.insert&&E.insert.forEach((M,p)=>this.items.set(p,M)),E.delete&&E.delete.forEach(M=>this.items.delete(M))}async close(){}}e.InMemoryStorageDatabase=y}),define(Z[124],x([0,1,5,9,37,8,18]),function($,e,m,L,R,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class n{constructor(i,E=Object.create(null)){this.path=i,this.options=E,this.name=S.basename(this.path),this.logger=new v(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return m.Event.None}async getItems(){const i=await this.whenConnected,E=new Map;return(await this.all(i,"SELECT * FROM ItemTable")).forEach(p=>E.set(p.key,p.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${E.size} rows`),E}async updateItems(i){const E=await this.whenConnected;return this.doUpdateItems(E,i)}doUpdateItems(i,E){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${E.insert?R.mapToString(E.insert):"0"}), delete(${E.delete?R.setToString(E.delete):"0"})`),this.transaction(i,()=>{const M=E.insert,p=E.delete;if(M&&M.size>0){const d=[];d.push([]);let g=0;M.forEach((k,P)=>{let c=d[g];c.length>n.MAX_HOST_PARAMETERS&&(g++,c=[],d.push(c)),c.push(P,k)}),d.forEach(k=>{this.prepare(i,`INSERT INTO ItemTable VALUES ${new Array(k.length/2).fill("(?,?)").join(",")}`,P=>P.run(k),()=>{const P=[];let c=0;return M.forEach((h,o)=>{P.push(o),c+=h.length}),`Keys: ${P.join(", ")} Length: ${c}`})})}if(p&&p.size){const d=[];d.push([]);let g=0;p.forEach(k=>{let P=d[g];P.length>n.MAX_HOST_PARAMETERS&&(g++,P=[],d.push(P)),P.push(k)}),d.forEach(k=>{this.prepare(i,`DELETE FROM ItemTable WHERE key IN (${new Array(k.length).fill("?").join(",")})`,P=>P.run(k),()=>{const P=[];return p.forEach(c=>{P.push(c)}),`Keys: ${P.join(", ")}`})})}})}async close(i){this.logger.trace(`[storage ${this.name}] close()`);const E=await this.whenConnected;return this.doClose(E,i)}doClose(i,E){return new Promise((M,p)=>{i.db.close(d=>(d&&this.handleSQLiteError(i,`[storage ${this.name}] close(): ${d}`),this.path===n.IN_MEMORY_PATH?M():!i.isErroneous&&!i.isInMemory?this.backup().then(M,g=>(this.logger.error(`[storage ${this.name}] backup(): ${g}`),M())):typeof E=="function"?I.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(g=>{const k=()=>this.doClose(g,void 0);return this.doUpdateItems(g,{insert:E()}).then(()=>k(),P=>(k(),Promise.reject(P)))})).then(M,p):p(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const i=this.toBackupPath(this.path);return I.Promises.copy(this.path,i,{preserveSymlinks:!1})}toBackupPath(i){return`${i}.backup`}async checkIntegrity(i){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${i})`);const E=await this.whenConnected,M=await this.get(E,i?"PRAGMA integrity_check":"PRAGMA quick_check"),p=i?M.integrity_check:M.quick_check;return E.isErroneous?`${p} (last error: ${E.lastError})`:E.isInMemory?`${p} (in-memory!)`:p}async connect(i,E=!0){this.logger.trace(`[storage ${this.name}] open(${i}, retryOnBusy: ${E})`);try{return await this.doConnect(i)}catch(M){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${M}`),M.code==="SQLITE_BUSY"&&E)return await L.timeout(n.BUSY_OPEN_TIMEOUT),this.connect(i,!1);try{await I.Promises.unlink(i);try{await I.Promises.rename(this.toBackupPath(i),i)}catch(p){}return await this.doConnect(i)}catch(p){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${p}`),this.doConnect(n.IN_MEMORY_PATH)}}}handleSQLiteError(i,E){i.isErroneous=!0,i.lastError=E,this.logger.error(E)}doConnect(i){return new Promise((E,M)=>{new Promise((p,d)=>{$(["vscode-sqlite3"],p,d)}).then(p=>{const d={db:new(this.logger.isTracing?p.verbose().Database:p.Database)(i,g=>g?d.db?d.db.close(()=>M(g)):M(g):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>E(d),k=>d.db.close(()=>M(k)))),isInMemory:i===n.IN_MEMORY_PATH};d.db.on("error",g=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${g}`)),this.logger.isTracing&&d.db.on("trace",g=>this.logger.trace(`[storage ${this.name}] Trace (event): ${g}`))},M)})}exec(i,E){return new Promise((M,p)=>{i.db.exec(E,d=>d?(this.handleSQLiteError(i,`[storage ${this.name}] exec(): ${d}`),p(d)):M())})}get(i,E){return new Promise((M,p)=>{i.db.get(E,(d,g)=>d?(this.handleSQLiteError(i,`[storage ${this.name}] get(): ${d}`),p(d)):M(g))})}all(i,E){return new Promise((M,p)=>{i.db.all(E,(d,g)=>d?(this.handleSQLiteError(i,`[storage ${this.name}] all(): ${d}`),p(d)):M(g))})}transaction(i,E){return new Promise((M,p)=>{i.db.serialize(()=>{i.db.run("BEGIN TRANSACTION"),E(),i.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(i,`[storage ${this.name}] transaction(): ${d}`),p(d)):M())})})}prepare(i,E,M,p){const d=i.db.prepare(E),g=k=>{this.handleSQLiteError(i,`[storage ${this.name}] prepare(): ${k} (${E}). Details: ${p()}`)};d.on("error",g),M(d),d.finalize(k=>{k&&g(k),d.removeListener("error",g)})}}e.SQLiteStorageDatabase=n,n.IN_MEMORY_PATH=":memory:",n.BUSY_OPEN_TIMEOUT=2e3,n.MAX_HOST_PARAMETERS=256;class v{constructor(i){i&&typeof i.logTrace=="function"&&process.env[v.VSCODE_TRACE_STORAGE]&&(this.logTrace=i.logTrace),i&&typeof i.logError=="function"&&(this.logError=i.logError)}get isTracing(){return!!this.logTrace}trace(i){this.logTrace&&this.logTrace(i)}error(i){this.logError&&this.logError(i)}}v.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[125],x([12,11]),function($,e){return $.create("vs/base/common/date",e)}),define(Z[126],x([0,1,125]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,R=L*60,S=R*24,I=S*7,n=S*30,v=S*365;function y(E,M){typeof E!="number"&&(E=E.getTime());const p=Math.round((new Date().getTime()-E)/1e3);if(p<-30)return m.localize(0,null,y(new Date().getTime()+p*1e3,!1));if(p<30)return m.localize(1,null);let d;return p<L?(d=p,M?d===1?m.localize(2,null,d):m.localize(3,null,d):d===1?m.localize(4,null,d):m.localize(5,null,d)):p<R?(d=Math.floor(p/L),M?d===1?m.localize(6,null,d):m.localize(7,null,d):d===1?m.localize(8,null,d):m.localize(9,null,d)):p<S?(d=Math.floor(p/R),M?d===1?m.localize(10,null,d):m.localize(11,null,d):d===1?m.localize(12,null,d):m.localize(13,null,d)):p<I?(d=Math.floor(p/S),M?d===1?m.localize(14,null,d):m.localize(15,null,d):d===1?m.localize(16,null,d):m.localize(17,null,d)):p<n?(d=Math.floor(p/I),M?d===1?m.localize(18,null,d):m.localize(19,null,d):d===1?m.localize(20,null,d):m.localize(21,null,d)):p<v?(d=Math.floor(p/n),M?d===1?m.localize(22,null,d):m.localize(23,null,d):d===1?m.localize(24,null,d):m.localize(25,null,d)):(d=Math.floor(p/v),M?d===1?m.localize(26,null,d):m.localize(27,null,d):d===1?m.localize(28,null,d):m.localize(29,null,d))}e.fromNow=y;function i(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(Z[127],x([12,11]),function($,e){return $.create("vs/base/common/errorMessage",e)}),define(Z[67],x([0,1,127,13,36]),function($,e,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function S(y,i){return i&&(y.stack||y.stacktrace)?m.localize(0,null,n(y),I(y.stack)||I(y.stacktrace)):n(y)}function I(y){return Array.isArray(y)?y.join(`
`):y}function n(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?m.localize(1,null,y.message):y.message||m.localize(2,null)}function v(y=null,i=!1){if(!y)return m.localize(3,null);if(Array.isArray(y)){const E=R.coalesce(y),M=v(E[0],i);return E.length>1?m.localize(4,null,M,E.length):M}if(L.isString(y))return y;if(y.detail){const E=y.detail;if(E.error)return S(E.error,i);if(E.exception)return S(E.exception,i)}return y.stack?S(y,i):y.message?y.message:m.localize(5,null)}e.toErrorMessage=v}),define(Z[128],x([12,11]),function($,e){return $.create("vs/base/common/keybindingLabels",e)}),define(Z[129],x([0,1,128]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class L{constructor(I,n,v=n){this.modifierLabels=[null],this.modifierLabels[2]=I,this.modifierLabels[1]=n,this.modifierLabels[3]=v}toLabel(I,n,v){if(n.length===0)return null;const y=[];for(let i=0,E=n.length;i<E;i++){const M=n[i],p=v(M);if(p===null)return null;y[i]=R(M,p,this.modifierLabels[I])}return y.join(" ")}}e.ModifierLabelProvider=L,e.UILabelProvider=new L({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:m.localize(0,null),shiftKey:m.localize(1,null),altKey:m.localize(2,null),metaKey:m.localize(3,null),separator:"+"},{ctrlKey:m.localize(4,null),shiftKey:m.localize(5,null),altKey:m.localize(6,null),metaKey:m.localize(7,null),separator:"+"}),e.AriaLabelProvider=new L({ctrlKey:m.localize(8,null),shiftKey:m.localize(9,null),altKey:m.localize(10,null),metaKey:m.localize(11,null),separator:"+"},{ctrlKey:m.localize(12,null),shiftKey:m.localize(13,null),altKey:m.localize(14,null),metaKey:m.localize(15,null),separator:"+"},{ctrlKey:m.localize(16,null),shiftKey:m.localize(17,null),altKey:m.localize(18,null),metaKey:m.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new L({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new L({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function R(S,I,n){if(I===null)return"";const v=[];return S.ctrlKey&&v.push(n.ctrlKey),S.shiftKey&&v.push(n.shiftKey),S.altKey&&v.push(n.altKey),S.metaKey&&v.push(n.metaKey),I!==""&&v.push(I),v.join(n.separator)}}),define(Z[130],x([12,11]),function($,e){return $.create("vs/base/node/processes",e)}),define(Z[68],x([0,1,8,18,41,130,33,13,44,30,3,82,10]),function($,e,m,L,R,S,I,n,v,y,i,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function p(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(o,l){if(i.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};l&&(t.cwd=l);const r=R.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],t);return new Promise(s=>{r.once("error",a=>{s({success:!1,error:a})}),r.once("exit",(a,u)=>{s(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?p(t.status):1})}else if(i.isLinux||i.isMacintosh)try{const t=M.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(r=>{R.execFile(t,[o.pid.toString()],{encoding:"utf8",shell:!0},(s,a,u)=>{r(s?{success:!1,error:s}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function g(o=I.env){return o.comspec||"cmd.exe"}e.getWindowsShell=g;class k{constructor(l,t,r,s){if(t!==void 0&&r!==void 0&&s!==void 0)this.cmd=l,this.args=t,this.shell=r,this.options=s;else{const a=l;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(I.env).forEach(u=>{a[u]=I.env[u]}),Object.keys(this.options.env).forEach(u=>{a[u]=this.options.env[u]}),this.options.env=a}}getSanitizedCommand(){let l=this.cmd.toLowerCase();const t=l.lastIndexOf(m.sep);return t!==-1&&(l=l.substring(t+1)),k.WellKnowCommands[l]?l:"other"}start(l){return i.isWindows&&(this.options&&this.options.cwd&&y.isUNC(this.options.cwd)||!this.options&&y.isUNC(I.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(t=>{let r,s;const a=new Promise((u,w)=>{r=u,s=w});if(t){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=R.exec(u,this.options,(w,f,b)=>{this.childProcess=null;const A=w;A&&A.killed?s({killed:this.terminateRequested,stdout:f.toString(),stderr:b.toString()}):this.handleExec(r,l,w,f,b)})}else{let u=null;const w=f=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(f,r,l,s);const b={terminated:this.terminateRequested};n.isNumber(f)&&(b.cmdCode=f),r(b)};if(this.shell&&i.isWindows){const f=v.deepClone(this.options);f.windowsVerbatimArguments=!0,f.detached=!1;let b=!1,A=!1;const U=[];let q=this.ensureQuotes(this.cmd);U.push(q.value),b=q.quoted,this.args&&this.args.forEach(te=>{q=this.ensureQuotes(te),U.push(q.value),A=A&&q.quoted});const J=["/s","/c"];b?A?J.push('"'+U.join(" ")+'"'):U.length>1?J.push('"'+U[0]+'" '+U.slice(1).join(" ")):J.push('"'+U[0]+'"'):J.push(U.join(" ")),u=R.spawn(g(),J,f)}else this.cmd&&(u=R.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(n.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",f=>{this.childProcess=null,s({terminated:this.terminateRequested,error:f})}),u.pid&&(this.childProcess.on("close",w),this.handleSpawn(u,r,l,s,!0)))}return a})}handleClose(l,t,r,s){}ensureQuotes(l){return k.regexp.test(l)?{value:'"'+l+'"',quoted:!0}:{value:l,quoted:l.length>0&&l[0]==='"'&&l[l.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(l=>l.pid,l=>-1):new Promise(l=>{this.pidResolve=l})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(l=>(this.terminateRequested=!0,d(l,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),l=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(l=>{if(!this.shell||!i.isWindows)return l(!1);const t=R.spawn(g(),["/s","/c"]);t.on("error",r=>l(!0)),t.on("exit",r=>l(!1))})}}e.AbstractProcess=k,k.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},k.regexp=/^[^"].* .*[^"]/;class P extends k{constructor(l,t,r,s){super(l,t,r,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(l,t,r,s,a){[s,a].forEach((u,w)=>{const f=new E.LineDecoder;f.write(u).forEach(U=>{t({line:U,source:w===0?0:1})});const A=f.end();A&&t({line:A,source:w===0?0:1})}),l({terminated:this.terminateRequested,error:r})}handleSpawn(l,t,r,s,a){const u=new E.LineDecoder,w=new E.LineDecoder;l.stdout.on("data",f=>{u.write(f).forEach(A=>r({line:A,source:0}))}),l.stderr.on("data",f=>{w.write(f).forEach(A=>r({line:A,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=w}handleClose(l,t,r,s){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&r({line:a,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&r({line:u,source:1})}}e.LineProcess=P;function c(o){let l=[],t=!1;const r=function(s){if(t){l.push(s);return}(!o.send(s,u=>{if(u&&console.error(u),t=!1,l.length>0){const w=l.slice(0);l=[],w.forEach(f=>r(f))}})||i.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=c;var h;(function(o){async function l(t,r,s){if(m.isAbsolute(t))return t;if(r===void 0&&(r=I.cwd()),m.dirname(t)!=="."||(s===void 0&&n.isString(I.env.PATH)&&(s=I.env.PATH.split(m.delimiter)),s===void 0||s.length===0))return m.join(r,t);async function u(w){return await L.Promises.exists(w)?!(await L.Promises.stat(w)).isDirectory():!1}for(let w of s){let f;if(m.isAbsolute(w)?f=m.join(w,t):f=m.join(r,w,t),await u(f))return f;let b=f+".com";if(await u(b)||(b=f+".exe",await u(b)))return b}return m.join(r,t)}o.findExecutable=l})(h=e.win32||(e.win32={}))}),define(Z[131],x([0,1,26,3,117,68]),function($,e,m,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function I(p,d){return p===1?L.isWindows?E():S.getWindowsShell(d):y(p,d)}e.getSystemShell=I;function n(p,d){return p===1?L.isWindows?M(d):S.getWindowsShell(d):y(p,d)}e.getSystemShellSync=n;let v=null;function y(p,d){if(L.isLinux&&p===2||L.isMacintosh&&p===3)return"/bin/bash";if(!v){let g;if(L.isWindows)g="/bin/bash";else{if(g=d.SHELL,!g)try{g=m.userInfo().shell}catch(k){}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}v=g}return v}let i=null;async function E(){return i||(i=(await R.getFirstAvailablePowerShellInstallation()).exePath),i}function M(p){if(i)return i;const d=L.isWindows&&parseFloat(m.release())>=10,g=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),k=`${p.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?k:S.getWindowsShell(p)}}),define(Z[88],x([0,1,41,2,9,44,5,68,34,110,25,16,17,3]),function($,e,m,L,R,S,I,n,v,y,i,E,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends v.ChannelServer{constructor(P){super({send:c=>{try{process.send&&process.send(c.buffer.toString("base64"))}catch(h){}},onMessage:I.Event.fromNodeEventEmitter(process,"message",c=>M.VSBuffer.wrap(Buffer.from(c,"base64")))},P);process.once("disconnect",()=>this.dispose())}}e.Server=d;class g{constructor(P,c){this.modulePath=P,this.options=c,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new I.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=c&&c.timeout?c.timeout:6e4;this.disposeDelayer=new R.Delayer(h),this.child=null,this._client=null}getChannel(P){const c=this;return{call(h,o,l){return c.requestPromise(P,h,o,l)},listen(h,o){return c.requestEvent(P,h,o)}}}requestPromise(P,c,h,o=i.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(P),t=R.createCancelablePromise(a=>l.call(c,h,a)),r=o.onCancellationRequested(()=>t.cancel()),s=L.toDisposable(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{r.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(P,c,h){if(!this.disposeDelayer)return I.Event.None;this.disposeDelayer.cancel();let o;const l=new I.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(P).listen(c,h)(l.fire,l),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const P=this.options&&this.options.args?this.options.args:[],c=Object.create(null);c.env=Object.assign(Object.assign({},S.deepClone(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(c.env=Object.assign(Object.assign({},c.env),this.options.env)),this.options&&this.options.freshExecArgv&&(c.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u))),p.isMacintosh&&c.env&&delete c.env.DYLD_LIBRARY_PATH,this.child=m.fork(this.modulePath,P,c);const h=new I.Emitter;I.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if(y.isRemoteConsoleLog(u)){y.log(u,`IPC Library: ${this.options.serverName}`);return}h.fire(M.VSBuffer.wrap(Buffer.from(u,"base64")))});const l=this.options.useQueue?n.createQueuedSender(this.child):this.child,t=u=>this.child&&this.child.connected&&l.send(u.buffer.toString("base64")),r=h.event,s={send:t,onMessage:r};this._client=new v.ChannelClient(s);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,w)=>{process.removeListener("exit",a),this.activeRequests.forEach(f=>L.dispose(f)),this.activeRequests.clear(),u!==0&&w!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+w),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:w})})}return this._client}getCachedChannel(P){let c=this.channels.get(P);return c||(c=this.client.getChannel(P),this.channels.set(P,c)),c}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=g}),define(Z[132],x([12,11]),function($,e){return $.create("vs/code/electron-main/app",e)}),define(Z[133],x([12,11]),function($,e){return $.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[134],x([12,11]),function($,e){return $.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[135],x([12,11]),function($,e){return $.create("vs/platform/environment/node/argv",e)}),define(Z[136],x([12,11]),function($,e){return $.create("vs/platform/environment/node/argvHelper",e)}),define(Z[137],x([12,11]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[138],x([12,11]),function($,e){return $.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[139],x([12,11]),function($,e){return $.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[140],x([12,11]),function($,e){return $.create("vs/platform/files/common/fileService",e)}),define(Z[141],x([12,11]),function($,e){return $.create("vs/platform/files/common/files",e)}),define(Z[142],x([12,11]),function($,e){return $.create("vs/platform/files/common/io",e)}),define(Z[143],x([12,11]),function($,e){return $.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[144],x([12,11]),function($,e){return $.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[145],x([12,11]),function($,e){return $.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[146],x([12,11]),function($,e){return $.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[147],x([12,11]),function($,e){return $.create("vs/platform/request/common/request",e)}),define(Z[148],x([12,11]),function($,e){return $.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[149],x([12,11]),function($,e){return $.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[150],x([12,11]),function($,e){return $.create("vs/platform/windows/electron-main/window",e)}),define(Z[151],x([12,11]),function($,e){return $.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[152],x([12,11]),function($,e){return $.create("vs/platform/workspaces/common/workspaces",e)}),define(Z[153],x([12,11]),function($,e){return $.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[154],x([12,11]),function($,e){return $.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[155],x([0,1,5,2]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class R{constructor(){this._onCloseEmitter=new m.Emitter,this._onReloadEmitter=new m.Emitter,this._onTerminateEmitter=new m.Emitter,this._onAttachEmitter=new m.Emitter}call(n,v,y){switch(v){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:y[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:y[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:y[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:y[0],port:y[1],subId:y[2]}))}throw new Error("Method not implemented.")}listen(n,v,y){switch(v){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=R,R.ChannelName="extensionhostdebugservice";class S extends L.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,v,y){this.channel.call("attach",[n,v,y])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,v){this.channel.call("terminate",[n,v])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,v,y){return this.channel.call("openExtensionDevelopmentHostWindow",[n,v||{},y])}}e.ExtensionHostDebugChannelClient=S}),define(Z[156],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class m{constructor(I){this.driver=I}listen(I,n){throw new Error(`No event found: ${n}`)}call(I,n,v){switch(n){case"click":return this.driver.click(v[0],v[1],v[2]);case"doubleClick":return this.driver.doubleClick(v);case"setValue":return this.driver.setValue(v[0],v[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(v);case"getElements":return this.driver.getElements(v[0],v[1]);case"getElementXY":return this.driver.getElementXY(v[0],v[1],v[2]);case"typeInEditor":return this.driver.typeInEditor(v[0],v[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(v);case"writeInTerminal":return this.driver.writeInTerminal(v[0],v[1]);case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${n}`)}}e.WindowDriverChannel=m;class L{constructor(I){this.channel=I}click(I,n,v){return this.channel.call("click",[I,n,v])}doubleClick(I){return this.channel.call("doubleClick",I)}setValue(I,n){return this.channel.call("setValue",[I,n])}getTitle(){return this.channel.call("getTitle")}isActiveElement(I){return this.channel.call("isActiveElement",I)}getElements(I,n){return this.channel.call("getElements",[I,n])}getElementXY(I,n,v){return this.channel.call("getElementXY",[I,n,v])}typeInEditor(I,n){return this.channel.call("typeInEditor",[I,n])}getTerminalBuffer(I){return this.channel.call("getTerminalBuffer",I)}writeInTerminal(I,n){return this.channel.call("writeInTerminal",[I,n])}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=L;class R{constructor(I){this.channel=I}registerWindowDriver(I){return this.channel.call("registerWindowDriver",I)}reloadWindowDriver(I){return this.channel.call("reloadWindowDriver",I)}}e.WindowDriverRegistryChannelClient=R}),define(Z[157],x([0,1,8,15,46,126,10,7,33]),function($,e,m,L,R,S,I,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class y{constructor(d,g,k){this._args=d,this.paths=g,this.productService=k}get appRoot(){return m.dirname(I.FileAccess.asFileUri("",$).fsPath)}get userHome(){return n.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return n.URI.file(m.join(this.userDataPath,"User"))}get tmpDir(){return n.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return L.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return L.joinPath(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=S.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=m.join(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return n.URI.file(m.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return L.joinPath(n.URI.file(m.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return n.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return n.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return L.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return L.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=v.env.VSCODE_PORTABLE;return d?n.URI.file(m.join(d,"argv.json")):L.joinPath(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return L.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return n.URI.file(m.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return m.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?m.resolve(d):m.normalize(m.join(I.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?m.resolve(d):m.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return m.resolve(d);const g=v.env.VSCODE_EXTENSIONS;if(g)return g;const k=v.env.VSCODE_PORTABLE;return k?m.join(k,"extensions"):L.joinPath(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(g=>/^[^:/?#]+?:\/\//.test(g)?n.URI.parse(g):n.URI.file(m.normalize(g)))}get extensionDevelopmentKind(){var d;return(d=this.args.extensionDevelopmentKind)===null||d===void 0?void 0:d.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?n.URI.parse(d):n.URI.file(m.normalize(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!v.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return L.joinPath(n.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return n.URI.file(m.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([R.memoize],y.prototype,"appRoot",null),he([R.memoize],y.prototype,"userHome",null),he([R.memoize],y.prototype,"userDataPath",null),he([R.memoize],y.prototype,"appSettingsHome",null),he([R.memoize],y.prototype,"tmpDir",null),he([R.memoize],y.prototype,"userRoamingDataHome",null),he([R.memoize],y.prototype,"settingsResource",null),he([R.memoize],y.prototype,"userDataSyncHome",null),he([R.memoize],y.prototype,"userDataSyncLogResource",null),he([R.memoize],y.prototype,"sync",null),he([R.memoize],y.prototype,"machineSettingsResource",null),he([R.memoize],y.prototype,"globalStorageHome",null),he([R.memoize],y.prototype,"workspaceStorageHome",null),he([R.memoize],y.prototype,"keybindingsResource",null),he([R.memoize],y.prototype,"keyboardLayoutResource",null),he([R.memoize],y.prototype,"argvResource",null),he([R.memoize],y.prototype,"snippetsHome",null),he([R.memoize],y.prototype,"isExtensionDevelopment",null),he([R.memoize],y.prototype,"untitledWorkspacesHome",null),he([R.memoize],y.prototype,"installSourcePath",null),he([R.memoize],y.prototype,"builtinExtensionsPath",null),he([R.memoize],y.prototype,"extensionsPath",null),he([R.memoize],y.prototype,"extensionDevelopmentLocationURI",null),he([R.memoize],y.prototype,"extensionDevelopmentKind",null),he([R.memoize],y.prototype,"extensionTestsLocationURI",null),he([R.memoize],y.prototype,"debugExtensionHost",null),he([R.memoize],y.prototype,"serviceMachineIdResource",null),he([R.memoize],y.prototype,"telemetryLogResource",null),he([R.memoize],y.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=y;function i(p,d){return M(p["inspect-extensions"],p["inspect-brk-extensions"],5870,d,p.debugId)}e.parseExtensionHostPort=i;function E(p,d){return M(p["inspect-search"],p["inspect-brk-search"],5876,d)}e.parseSearchPort=E;function M(p,d,g,k,P){const h=Number(d||p)||(k?null:g),o=h?Boolean(!!d):!1;return{port:h,break:o,debugId:P}}}),define(Z[89],x([0,1,240,135,3]),function($,e,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const S={o:L.localize(0,null),e:L.localize(1,null),t:L.localize(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:L.localize(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:L.localize(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:L.localize(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:L.localize(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:L.localize(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:L.localize(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:L.localize(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:L.localize(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:L.localize(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:L.localize(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:L.localize(13,null)},"show-versions":{type:"boolean",cat:"e",description:L.localize(14,null)},category:{type:"string",cat:"e",description:L.localize(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:L.localize(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:L.localize(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:L.localize(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:L.localize(19,null)},verbose:{type:"boolean",cat:"t",description:L.localize(20,null)},log:{type:"string",cat:"t",args:"level",description:L.localize(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:L.localize(22,null)},"prof-startup":{type:"boolean",cat:"t",description:L.localize(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:L.localize(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:L.localize(25,null)},sync:{type:"string",cat:"t",description:L.localize(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:L.localize(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:L.localize(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:L.localize(29,null)},"max-memory":{type:"string",cat:"t",description:L.localize(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:L.localize(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const I={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(d,g,k=I){const P={},c=[],h=[];for(let r in g){const s=g[r];s.alias&&(P[r]=s.alias),s.type==="string"||s.type==="string[]"?(c.push(r),s.deprecates&&c.push(s.deprecates)):s.type==="boolean"&&(h.push(r),s.deprecates&&h.push(s.deprecates))}const o=m(d,{string:c,boolean:h,alias:P}),l={},t=o;l._=o._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in g){const s=g[r];s.alias&&delete t[s.alias];let a=t[r];s.deprecates&&t.hasOwnProperty(s.deprecates)&&(a||(a=t[s.deprecates]),delete t[s.deprecates]),typeof a!="undefined"&&(s.type==="string[]"?a&&!Array.isArray(a)&&(a=[a]):s.type==="string"&&Array.isArray(a)&&(a=a.pop(),k.onMultipleValues(r,a)),l[r]=a),delete t[r]}for(let r in t)k.onUnknownOption(r);return l}e.parseArgs=n;function v(d,g){let k="";return g.args&&(Array.isArray(g.args)?k=` <${g.args.join("> <")}>`:k=` <${g.args}>`),g.alias?`-${g.alias} --${d}${k}`:`--${d}${k}`}function y(d,g){let k=0,P=[];for(const l in d){const t=d[l],r=v(l,t);k=Math.max(k,r.length),P.push([r,t.description])}let c=k+2+1;if(g-c<25)return P.reduce((l,t)=>l.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let h=g-c-1,o=[];for(const l of P){let t=l[0],r=E(l[1],h),s=i(c-t.length-2);o.push("  "+t+s+r[0]);for(let a=1;a<r.length;a++)o.push(i(c)+r[a])}return o}e.formatOptions=y;function i(d){return" ".repeat(d)}function E(d,g){let k=[];for(;d.length;){let P=d.length<g?d.length:d.lastIndexOf(" ",g),c=d.slice(0,P).trim();d=d.slice(P),k.push(c)}return k}function M(d,g,k,P,c=!0){const h=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${d} ${k}`];o.push(""),o.push(`${L.localize(32,null)}: ${g} [${L.localize(33,null)}][${L.localize(34,null)}...]`),o.push(""),c&&(R.isWindows?o.push(L.localize(35,null,g)):o.push(L.localize(36,null,g)),o.push(""));const l={};for(const t in P){const r=P[t];if(r.description&&r.cat){let s=l[r.cat];s||(l[r.cat]=s={}),s[t]=r}}for(let t in l){const r=t;let s=l[r];s&&(o.push(S[r]),o.push(...y(s,h)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=M;function p(d,g){return`${d||L.localize(37,null)}
${g||L.localize(38,null)}
${process.arch}`}e.buildVersionMessage=p}),define(Z[158],x([0,1,89,59,155]),function($,e,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class S extends R.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,v,y){return v==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(y[0],y[1],y[2]):super.call(n,v,y)}async openExtensionDevelopmentHostWindow(n,v,y){const i=m.parseArgs(n,m.OPTIONS);i.debugRenderer=y;const E=i.extensionDevelopmentPath;if(!E)return{success:!1};let M;const p=Object.keys(v);for(let h of p){let o=v[h];o===null||(M||(M=Object.create(null)),M[h]=o)}const[d]=this.windowsMainService.openExtensionDevelopmentHostWindow(E,{context:5,cli:i,userEnv:M});if(!y)return{success:!0};const g=d.win;if(!g)return{success:!0};const k=g.webContents.debugger;let P=k.isAttached()?Infinity:0;const c=L.createServer(h=>{P++==0&&k.attach();let o=!1;const l=s=>{o||h.write(JSON.stringify(s)+"\0")},t=(s,a,u,w)=>l({method:a,params:u,sessionId:w});g.on("close",()=>{k.removeListener("message",t),h.end(),o=!0}),k.addListener("message",t);let r=Buffer.alloc(0);h.on("data",s=>{r=Buffer.concat([r,s]);for(let a=r.indexOf(0);a!==-1;a=r.indexOf(0)){let u;try{const w=r.slice(0,a).toString("utf8");r=r.slice(a+1),u=JSON.parse(w)}catch(w){console.error("error reading cdp line",w)}k.sendCommand(u.method,u.params,u.sessionId).then(w=>l({id:u.id,sessionId:u.sessionId,result:w})).catch(w=>l({id:u.id,sessionId:u.sessionId,error:{code:0,message:w.message}}))}}),h.on("error",s=>{console.error("error on cdp pipe:",s)}),h.on("close",()=>{o=!0,--P==0&&k.detach()})});return await new Promise(h=>c.listen(0,h)),g.on("close",()=>c.close()),{rendererDebugPort:c.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=S}),function(){"use strict";function $(e,m,L,R){function S(n){const v=I(n),y=[v];return e.isAbsolute(v)||y.unshift(R),e.resolve(...y)}function I(n){const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");const y=n["user-data-dir"];if(y)return y;let i=process.env.VSCODE_APPDATA;if(!i)switch(process.platform){case"win32":if(i=process.env.APPDATA,!i){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");i=e.join(E,"AppData","Roaming")}break;case"darwin":i=e.join(m.homedir(),"Library","Application Support");break;case"linux":i=process.env.XDG_CONFIG_HOME||e.join(m.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(i,L)}return{getUserDataPath:S}}if(typeof define=="function")define(Z[159],x([0,160,26,10,15,33]),function(e,m,L,R,S,I){const n=S.dirname(R.FileAccess.asFileUri("",e)),v=e.__$__nodeRequire(S.joinPath(n,"package.json").fsPath);return $(m,L,v.name,I.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),m=require("path"),L=require("os");module.exports=$(m,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[161],x([0,1,26,159,157]),function($,e,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class S extends R.AbstractNativeEnvironmentService{constructor(n,v){super(n,{homeDir:m.homedir(),tmpDir:m.tmpdir(),userDataDir:L.getUserDataPath(n)},v)}}e.NativeEnvironmentService=S}),define(Z[162],x([0,1,29,26,8]),function($,e,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function S(I){const n=R.join(L.tmpdir(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return m.writeFileSync(n,""),I&&console.log(`Marker file for --wait created: ${n}`),n}catch(v){I&&console.error(`Failed to create marker file for --wait: ${v}`);return}}e.createWaitMarkerFile=S}),define(Z[163],x([0,1,138]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function S(M){return M=M.trim(),M==="*"||L.test(M)}e.isValidVersionStr=S;function I(M){if(!S(M))return null;if(M=M.trim(),M==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=M.match(L);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=I;function n(M){if(!M)return null;let p=M.majorBase,d=M.majorMustEqual,g=M.minorBase,k=M.minorMustEqual,P=M.patchBase,c=M.patchMustEqual;M.hasCaret&&(p===0||(k=!1),c=!1);let h=0;if(M.preRelease){const o=R.exec(M.preRelease);if(o){const[,l,t,r]=o;h=Date.UTC(Number(l),Number(t)-1,Number(r))}}return{majorBase:p,majorMustEqual:d,minorBase:g,minorMustEqual:k,patchBase:P,patchMustEqual:c,isMinimum:M.hasGreaterEquals,notBefore:h}}e.normalizeVersion=n;function v(M,p,d){let g;typeof M=="string"?g=n(I(M)):g=M;let k;p instanceof Date?k=p.getTime():typeof p=="string"&&(k=new Date(p).getTime());let P;if(typeof d=="string"?P=n(I(d)):P=d,!g||!P)return!1;let c=g.majorBase,h=g.minorBase,o=g.patchBase,l=P.majorBase,t=P.minorBase,r=P.patchBase,s=P.notBefore,a=P.majorMustEqual,u=P.minorMustEqual,w=P.patchMustEqual;return P.isMinimum?c>l?!0:c<l?!1:h>t?!0:h<t||k&&k<s?!1:o>=r:(c===1&&l===0&&(!a||!u||!w)&&(l=1,t=0,r=0,a=!0,u=!1,w=!1),c<l?!1:c>l?!a:h<t?!1:h>t?!u:o<r?!1:o>r?!w:!(k&&k<s))}e.isValidVersion=v;function y(M,p,d,g){return d.isBuiltin||typeof d.main=="undefined"?!0:E(M,p,d.engines.vscode,g)}e.isValidExtensionVersion=y;function i(M,p,d){return M==="*"||E(p,d,M)}e.isEngineValid=i;function E(M,p,d,g=[]){let k=n(I(d));if(!k)return g.push(m.localize(0,null,d)),!1;if(k.majorBase===0){if(!k.majorMustEqual||!k.minorMustEqual)return g.push(m.localize(1,null,d)),!1}else if(!k.majorMustEqual)return g.push(m.localize(2,null,d)),!1;return v(M,p,k)?!0:(g.push(m.localize(3,null,M,d)),!1)}}),define(Z[164],x([0,1,34,88,2,10]),function($,e,m,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class I extends R.Disposable{constructor(v,y,i,E){super();this.folders=v,this.onDidFilesChange=y,this.onLogMessage=i,this.verboseLogging=E,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const v=this._register(new L.Client(S.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(v.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=I.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService(m.getNextTickChannel(v.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(y=>!this.isDisposed&&this.onDidFilesChange(y))),this._register(this.service.onDidLogMessage(y=>this.onLogMessage(y))),this.setFolders(this.folders)}setVerboseLogging(v){this.verboseLogging=v,!this.isDisposed&&this.service&&this.service.setVerboseLogging(v)}error(v){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${v}`})}setFolders(v){this.folders=v,this.service&&this.service.setRoots(v)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=I,I.MAX_RESTARTS=5}),define(Z[165],x([0,1,34,88,2,10]),function($,e,m,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class I extends R.Disposable{constructor(v,y,i,E,M={}){super();this.folders=v,this.onDidFilesChange=y,this.onLogMessage=i,this.verboseLogging=E,this.watcherOptions=M,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const v=this._register(new L.Client(S.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(v.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=I.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService(m.getNextTickChannel(v.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(y=>!this.isDisposed&&this.onDidFilesChange(y))),this._register(this.service.onDidLogMessage(y=>this.onLogMessage(y))),this.service.setRoots(this.folders)}error(v){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${v}`})}setVerboseLogging(v){this.verboseLogging=v,this.service&&this.service.setVerboseLogging(v)}setFolders(v){this.folders=v,this.service&&this.service.setRoots(v)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=I,I.MAX_RESTARTS=5}),define(Z[166],x([0,1,41,82,112,10]),function($,e,m,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class I{constructor(v,y,i,E,M){this.watchedFolder=v,this.eventCallback=i,this.logCallback=E,this.verboseLogging=M,this.restartCounter=0,Array.isArray(y)?this.ignored=y.map(p=>R.parse(p)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${v}, excludes: ${y.join(",")}`),this.startWatcher()}startWatcher(){const v=[this.watchedFolder];this.verboseLogging&&v.push("-verbose"),this.handle=m.spawn(S.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",$).fsPath,v);const y=new L.LineDecoder;this.handle.stdout.on("data",i=>{const E=[];for(const M of y.write(i)){const p=M.split("|");if(p.length===2){const d=Number(p[0]),g=p[1];if(d>=0&&d<3){if(this.ignored&&this.ignored.some(k=>k(g))){this.verboseLogging&&this.log(g);continue}E.push({type:I.changeTypeMap[d],path:g})}else this.log(p[1])}}E.length>0&&this.eventCallback(E)}),this.handle.on("error",i=>this.onError(i)),this.handle.stderr.on("data",i=>this.onError(i)),this.handle.on("exit",(i,E)=>this.onExit(i,E))}onError(v){this.error("process error: "+v.toString())}onExit(v,y){this.handle&&(this.error(`terminated unexpectedly (code: ${v}, signal: ${y})`),this.restartCounter<=I.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(v){this.logCallback({type:"error",message:`[File Watcher (C#)] ${v}`})}log(v){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${v}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=I,I.MAX_RESTARTS=5,I.changeTypeMap=[0,1,2]}),define(Z[167],x([0,1,166,8,23]),function($,e,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class S{constructor(n,v,y,i){this.onDidFilesChange=v,this.onLogMessage=y,this.verboseLogging=i,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(L.posix.sep)&&(this.folder.path=R.rtrim(this.folder.path,L.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new m.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=S}),define(Z[69],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class m{constructor(S,I=[],n=!1){this.ctor=S,this.staticArguments=I,this.supportsDelayedInstantiation=n}}e.SyncDescriptor=m;const L=(R,...S)=>new m(R,S);e.createSyncDescriptor=L}),define(Z[168],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}e.Node=m;class L{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let I of this._nodes.values())I.outgoing.size===0&&S.push(I);return S}insertEdge(S,I){const n=this.lookupOrInsertNode(S),v=this.lookupOrInsertNode(I);n.outgoing.set(this._hashFn(I),v),v.incoming.set(this._hashFn(S),n)}removeNode(S){const I=this._hashFn(S);this._nodes.delete(I);for(let n of this._nodes.values())n.outgoing.delete(I),n.incoming.delete(I)}lookupOrInsertNode(S){const I=this._hashFn(S);let n=this._nodes.get(I);return n||(n=new m(S),this._nodes.set(I,n)),n}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[I,n]of this._nodes)S.push(`${I}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return S.join(`
`)}findCycleSlow(){for(let[S,I]of this._nodes){const n=new Set([S]),v=this._findCycle(I,n);if(v)return v}}_findCycle(S,I){for(let[n,v]of S.outgoing){if(I.has(n))return[...I,n].join(" -> ");I.add(n);const y=this._findCycle(v,I);if(y)return y;I.delete(n)}}}e.Graph=L}),define(Z[4],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function v(y){return y[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=v})(m=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function L(n,v,y,i){v[m.DI_TARGET]===v?v[m.DI_DEPENDENCIES].push({id:n,index:y,optional:i}):(v[m.DI_DEPENDENCIES]=[{id:n,index:y,optional:i}],v[m.DI_TARGET]=v)}function R(n){if(m.serviceIds.has(n))return m.serviceIds.get(n);const v=function(y,i,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(v,y,E,!1)};return v.toString=()=>n,m.serviceIds.set(n,v),v}e.createDecorator=R;function S(n){return n}e.refineServiceDecorator=S;function I(n){return function(v,y,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(n,v,i,!0)}}e.optional=I}),define(Z[70],x([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=m.createDecorator(e.ID);function L(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=L}),define(Z[90],x([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=m.createDecorator("encryptionMainService");class L{constructor(S){this.machineId=S}encryption(){return new Promise((S,I)=>$(["vscode-encrypt"],S,I))}async encrypt(S){try{return(await this.encryption()).encrypt(this.machineId,S)}catch(I){return S}}async decrypt(S){try{return(await this.encryption()).decrypt(this.machineId,S)}catch(I){return S}}}e.EncryptionMainService=L}),define(Z[47],x([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=m.createDecorator("environmentService"),e.INativeEnvironmentService=m.refineServiceDecorator(e.IEnvironmentService)}),define(Z[169],x([0,1,137,4,10]),function($,e,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function S(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}e.isIExtensionIdentifier=S;var I;(function(E){E[E.NoneOrRelevance=0]="NoneOrRelevance",E[E.LastUpdatedDate=1]="LastUpdatedDate",E[E.Title=2]="Title",E[E.PublisherName=3]="PublisherName",E[E.InstallCount=4]="InstallCount",E[E.PublishedDate=5]="PublishedDate",E[E.AverageRating=6]="AverageRating",E[E.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var n;(function(E){E[E.Default=0]="Default",E[E.Ascending=1]="Ascending",E[E.Descending=2]="Descending"})(n=e.SortOrder||(e.SortOrder={}));var v;(function(E){E.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var y;(function(E){E[E.None=0]="None",E[E.Install=1]="Install",E[E.Update=2]="Update"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=L.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(M,p){super(M);this.code=p}}e.ExtensionManagementError=i,e.IExtensionManagementService=L.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=L.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=L.createDecorator("IExtensionTipsService"),e.DefaultIconPath=R.FileAccess.asBrowserUri("./media/defaultIcon.png",$).toString(!0),e.ExtensionsLabel=m.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=m.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=L.createDecorator("IExtensionManagementCLIService")}),define(Z[170],x([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=m.createDecorator("extensionUrlTrustService")}),define(Z[171],x([0,1,23,4]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function R(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkpaceSupportTypeMessage=R;function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=S,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class n{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,M){if(typeof E=="undefined"||E===null)return typeof M=="undefined"||M===null;if(typeof M=="undefined"||M===null)return!1;if(typeof E=="string"||typeof M=="string"){let p=typeof E=="string"?E:E.value,d=typeof M=="string"?M:M.value;return m.equalsIgnoreCase(p,d)}return E._lower===M._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=n;function v(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=v;function y(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y,e.IBuiltinExtensionsScannerService=L.createDecorator("IBuiltinExtensionsScannerService")}),define(Z[172],x([0,1,23,171]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(p,d){return p.uuid&&d.uuid?p.uuid===d.uuid:p.id===d.id?!0:m.compareIgnoreCase(p.id,d.id)===0}e.areSameExtensions=R;class S{constructor(d,g){this.version=g,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof S?R(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=S;function I(p,d){return`${p}.${d}`}e.getExtensionId=I;function n(p){return p.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function v(p,d){return n(I(p,d))}e.getGalleryExtensionId=v;function y(p,d){const g=[],k=P=>{for(const c of g)if(c.some(h=>R(d(h),d(P))))return c;return null};for(const P of p){const c=k(P);c?c.push(P):g.push([P])}return g}e.groupByExtension=y;function i(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function E(p){return Object.assign({id:p.identifier.id,name:p.name,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0)},p.telemetryData)}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function M(p){const d=new Set;for(const g of p)g.malicious&&d.add(g.id.id);return d}e.getMaliciousExtensionsSet=M}),define(Z[91],x([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=m.createDecorator("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=m.createDecorator("externalTerminal")}),define(Z[173],x([0,1,41,8,68,139,18,3,91,10,106]),function($,e,m,L,R,S,I,n,v,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const E=S.localize(0,null);class M{async getDefaultTerminalForPlatforms(){const o=await g.getDefaultTerminalLinuxReady();return{windows:p.getDefaultTerminalWindows(),linux:o,osx:"xterm"}}}class p extends M{openTerminal(o,l){return this.spawnTerminal(m,o,R.getWindowsShell(),l)}spawnTerminal(o,l,t,r){const s=l.windowsExec||p.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const a=L.basename(s).toLowerCase();if(a==="cmder"||a==="cmder.exe")return o.spawn(s,r?[r]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return s.indexOf(" ")>=0&&u.push('""'),u.push(s),(a==="wt"||a==="wt.exe")&&u.push("-d ."),new Promise((w,f)=>{const b=k(process),A=o.spawn(t,u,{cwd:r,env:b});A.on("error",f),A.on("exit",()=>w())})}runInTerminal(o,l,t,r,s){const a="windowsExec"in s&&s.windowsExec?s.windowsExec:p.getDefaultTerminalWindows();return new Promise((u,w)=>{const f=`"${l} - ${E}"`,b=`""${t.join('" "')}" & pause"`,A=["/c","start",f,"/wait",a,"/c",b],U=Object.assign({},k(process),r);Object.keys(U).filter(te=>U[te]===null).forEach(te=>delete U[te]);const q={cwd:l,env:U,windowsVerbatimArguments:!0};m.spawn(p.CMD,A,q).on("error",te=>{w(P(te))}),u(void 0)})}static getDefaultTerminalWindows(){if(!p._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return p._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=p,p.CMD="cmd.exe";class d extends M{openTerminal(o,l){return this.spawnTerminal(m,o,l)}runInTerminal(o,l,t,r,s){const a=s.osxExec||v.DEFAULT_TERMINAL_OSX;return new Promise((u,w)=>{if(a===v.DEFAULT_TERMINAL_OSX||a==="iTerm.app"){const f=a===v.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",A=[y.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${f}.scpt`,$).fsPath,"-t",o||E,"-w",l];for(let J of t)A.push("-a"),A.push(J);if(r)for(let J in r){const te=r[J];te===null?(A.push("-u"),A.push(J)):(A.push("-e"),A.push(`${J}=${te}`))}let U="";const q=m.spawn(d.OSASCRIPT,A);q.on("error",J=>{w(P(J))}),q.stderr.on("data",J=>{U+=J.toString()}),q.on("exit",J=>{if(J===0)u(void 0);else if(U){const te=U.split(`
`,1);w(new Error(te[0]))}else w(new Error(S.localize(1,null,f,J)))})}else w(new Error(S.localize(2,null,a)))})}spawnTerminal(o,l,t){const r=l.osxExec||v.DEFAULT_TERMINAL_OSX;return new Promise((s,a)=>{const u=["-a",r];t&&u.push(t);const w=o.spawn("/usr/bin/open",u);w.on("error",a),w.on("exit",()=>s())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class g extends M{openTerminal(o,l){return this.spawnTerminal(m,o,l)}runInTerminal(o,l,t,r,s){const a=s.linuxExec?Promise.resolve(s.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((u,w)=>{let f=[];a.then(b=>{b.indexOf("gnome-terminal")>=0?f.push("-x"):f.push("-e"),f.push("bash"),f.push("-c");const A=`${c(t)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;f.push(`''${A}''`);const U=Object.assign({},process.env,r);Object.keys(U).filter(B=>U[B]===null).forEach(B=>delete U[B]);const q={cwd:l,env:U};let J="";const te=m.spawn(b,f,q);te.on("error",B=>{w(P(B))}),te.stderr.on("data",B=>{J+=B.toString()}),te.on("exit",B=>{if(B===0)u(void 0);else if(J){const Y=J.split(`
`,1);w(new Error(Y[0]))}else w(new Error(S.localize(4,null,b,B)))})})})}static async getDefaultTerminalLinuxReady(){return g._DEFAULT_TERMINAL_LINUX_READY||(g._DEFAULT_TERMINAL_LINUX_READY=new Promise(async o=>{n.isLinux?await I.Promises.exists("/etc/debian_version")?o("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?o("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?o("konsole"):process.env.COLORTERM?o(process.env.COLORTERM):process.env.TERM?o(process.env.TERM):o("xterm"):o("xterm")})),g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,l,t){const r=l.linuxExec?Promise.resolve(l.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((s,a)=>{r.then(u=>{const w=k(process),f=o.spawn(u,[],{cwd:t,env:w});f.on("error",a),f.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=S.localize(3,null);function k(h){const o=h.env;return i.sanitizeProcessEnvironment(o),o}function P(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(S.localize(5,null,h.path)):h}function c(h){let o="";for(let l of h)l.indexOf(" ")>=0?o+='"'+l+'"':o+=l,o+=" ";return o}}),define(Z[19],x([0,1,141,8,7,4,23,13,37]),function($,e,m,L,R,S,I,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=S.createDecorator("fileService");function y(C){return C.create===!0}e.isFileOpenForWriteOptions=y;var i;(function(C){C[C.Unknown=0]="Unknown",C[C.File=1]="File",C[C.Directory=2]="Directory",C[C.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var E;(function(C){C[C.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var M;(function(C){C[C.FileReadWrite=2]="FileReadWrite",C[C.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",C[C.FileReadStream=16]="FileReadStream",C[C.FileFolderCopy=8]="FileFolderCopy",C[C.PathCaseSensitive=1024]="PathCaseSensitive",C[C.Readonly=2048]="Readonly",C[C.Trash=4096]="Trash",C[C.FileWriteUnlock=8192]="FileWriteUnlock"})(M=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(C){return!!(C.capabilities&2)}e.hasReadWriteCapability=p;function d(C){return!!(C.capabilities&8)}e.hasFileFolderCopyCapability=d;function g(C){return!!(C.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function k(C){return!!(C.capabilities&16)}e.hasFileReadStreamCapability=k;var P;(function(C){C.FileExists="EntryExists",C.FileNotFound="EntryNotFound",C.FileNotADirectory="EntryNotADirectory",C.FileIsADirectory="EntryIsADirectory",C.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",C.FileTooLarge="EntryTooLarge",C.FileWriteLocked="EntryWriteLocked",C.NoPermissions="NoPermissions",C.Unavailable="Unavailable",C.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(z,X){super(z);this.code=X}}e.FileSystemProviderError=c;function h(C,z){const X=new c(C.toString(),z);return l(X,z),X}e.createFileSystemProviderError=h;function o(C){return C||h(m.localize(0,null),P.Unknown)}e.ensureFileSystemProviderError=o;function l(C,z){return C.name=z?`${z} (FileSystemError)`:"FileSystemError",C}e.markAsFileSystemProviderError=l;function t(C){if(!C)return P.Unknown;if(C instanceof c)return C.code;const z=/^(.+) \(FileSystemError\)$/.exec(C.name);if(!z)return P.Unknown;switch(z[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=t;function r(C){if(C instanceof b)return C.fileOperationResult;switch(t(C)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(C){C[C.CREATE=0]="CREATE",C[C.DELETE=1]="DELETE",C[C.MOVE=2]="MOVE",C[C.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class a{constructor(z,X,H){this.resource=z,this.operation=X,this.target=H}isOperation(z){return this.operation===z}}e.FileOperationEvent=a;var u;(function(C){C[C.UPDATED=0]="UPDATED",C[C.ADDED=1]="ADDED",C[C.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class w{constructor(z,X){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const H of z)switch(H.type){case 1:this.added||(this.added=v.TernarySearchTree.forUris(()=>X)),this.added.set(H.resource,H);break;case 0:this.updated||(this.updated=v.TernarySearchTree.forUris(()=>X)),this.updated.set(H.resource,H);break;case 2:this.deleted||(this.deleted=v.TernarySearchTree.forUris(()=>X)),this.deleted.set(H.resource,H);break}}contains(z,...X){return this.doContains(z,{includeChildren:!1},...X)}affects(z,...X){return this.doContains(z,{includeChildren:!0},...X)}doContains(z,X,...H){var W,D,O,F,T,_;if(!z)return!1;const N=H.length>0;return!!((!N||H.includes(1))&&(((W=this.added)===null||W===void 0?void 0:W.get(z))||X.includeChildren&&((D=this.added)===null||D===void 0?void 0:D.findSuperstr(z)))||(!N||H.includes(0))&&(((O=this.updated)===null||O===void 0?void 0:O.get(z))||X.includeChildren&&((F=this.updated)===null||F===void 0?void 0:F.findSuperstr(z)))||(!N||H.includes(2))&&(((T=this.deleted)===null||T===void 0?void 0:T.findSubstr(z))||X.includeChildren&&((_=this.deleted)===null||_===void 0?void 0:_.findSuperstr(z))))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=w;function f(C,z,X){return!C||!z||C===z||z.length>C.length?!1:(z.charAt(z.length-1)!==L.sep&&(z+=L.sep),X?I.startsWithIgnoreCase(C,z):C.indexOf(z)===0)}e.isParent=f;class b extends Error{constructor(z,X,H){super(z);this.fileOperationResult=X,this.options=H}}e.FileOperationError=b;class A extends b{constructor(z,X,H){super(z,2,H);this.stat=X}}e.NotModifiedSinceFileOperationError=A;var U;(function(C){C[C.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",C[C.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",C[C.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",C[C.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",C[C.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",C[C.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",C[C.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",C[C.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",C[C.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",C[C.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",C[C.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",C[C.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(U=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var q;(function(C){C[C.FILE=0]="FILE",C[C.FOLDER=1]="FOLDER",C[C.ROOT_FOLDER=2]="ROOT_FOLDER"})(q=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function J(C){if(!(typeof C.size!="number"||typeof C.mtime!="number"))return C.mtime.toString(29)+C.size.toString(31)}e.etag=J;async function te(C,z){if(!z.canHandleResource(R.URI.from({scheme:C.scheme})))return new Promise(X=>{const H=z.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===C.scheme&&W.added&&(H.dispose(),X())})})}e.whenProviderRegistered=te,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize(z){return n.isNumber(z)||(z=0),z<B.KB?m.localize(1,null,z.toFixed(0)):z<B.MB?m.localize(2,null,(z/B.KB).toFixed(2)):z<B.GB?m.localize(3,null,(z/B.MB).toFixed(2)):z<B.TB?m.localize(4,null,(z/B.GB).toFixed(2)):m.localize(5,null,(z/B.TB).toFixed(2))}}e.ByteSize=B,B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB;var Y;(function(C){C[C.IA32=0]="IA32",C[C.OTHER=1]="OTHER"})(Y=e.Arch||(e.Arch={}));function G(C){return{maxFileSize:C===0?300*B.MB:16*B.GB,maxHeapSize:C===0?700*B.MB:2*700*B.MB}}e.getPlatformLimits=G}),define(Z[54],x([0,1,241,136,19,89]),function($,e,m,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function I(M,p){const d={onUnknownOption:k=>{console.warn(L.localize(0,null,k))},onMultipleValues:(k,P)=>{console.warn(L.localize(1,null,k,P))}},g=S.parseArgs(M,S.OPTIONS,p?d:void 0);return g.goto&&g._.forEach(k=>m(/^(\w:)?[^:]+(:\d*){0,2}$/.test(k),L.localize(2,null))),g["max-memory"]&&m(parseInt(g["max-memory"])>=R.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${R.MIN_MAX_MEMORY_SIZE_MB} MB.`),g}function n(M){const p=M.findIndex(d=>!/^-/.test(d));if(p>-1)return[...M.slice(0,p),...M.slice(p+1)]}function v(M){let[,...p]=M;process.env.VSCODE_DEV&&(p=n(p)||[]);const d=!E(process.env);return I(p,d)}e.parseMainProcessArgv=v;function y(M){const[,,...p]=M;return I(p,!0)}e.parseCLIProcessArgv=y;function i(M,...p){const d=M.indexOf("--");return d===-1?M.push(...p):M.splice(d,0,...p),M}e.addArg=i;function E(M){return M.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),define(Z[92],x([0,1,160,41,27,3,54,67,131,25,16]),function($,e,m,L,R,S,I,n,v,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function E(d,g,k){return g["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):S.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):I.isLaunchedFromCli(k)&&!g["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):(I.isLaunchedFromCli(k)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),M||(M=new Promise(async P=>{const c=new y.CancellationTokenSource,h=setTimeout(()=>{d.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),c.dispose(!0),P({})},1e4);try{const o=await p(d,c.token);P(o)}catch(o){i.isPromiseCanceledError(o)||d.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),P({})}finally{clearTimeout(h),c.dispose()}})),M)}e.resolveShellEnv=E;let M;async function p(d,g){const k=new Promise(async(P,c)=>{const h=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",h);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",o);const l=R.generateUuid().replace(/-/g,"").substr(0,12),t=new RegExp(l+"(.*)"+l),r=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});d.trace("getUnixShellEnvironment#env",r);const s=await v.getSystemShell(S.OS,r);if(d.trace("getUnixShellEnvironment#shell",s),g.isCancellationRequested)return c(i.canceled);const a=m.basename(s);let u,w;/^pwsh(-preview)?$/.test(a)?(u=`& '${process.execPath}' -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,w=["-Login","-Command"]):(u=`'${process.execPath}' -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,w=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(w),u);const f=L.spawn(s,[...w,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});g.onCancellationRequested(()=>(f.kill(),c(i.canceled))),f.on("error",U=>{d.error("getUnixShellEnvironment#errorChildProcess",n.toErrorMessage(U)),P({})});const b=[];f.stdout.on("data",U=>b.push(U));const A=[];f.stderr.on("data",U=>A.push(U)),f.on("close",(U,q)=>{const J=Buffer.concat(b).toString("utf8");d.trace("getUnixShellEnvironment#raw",J);const te=Buffer.concat(A).toString("utf8");if(te.trim()&&d.trace("getUnixShellEnvironment#stderr",te),U||q)return c(new Error(`Failed to get environment (code ${U}, signal ${q})`));const B=t.exec(J),Y=B?B[1]:"{}";try{const G=JSON.parse(Y);h?G.ELECTRON_RUN_AS_NODE=h:delete G.ELECTRON_RUN_AS_NODE,o?G.ELECTRON_NO_ATTACH_CONSOLE=o:delete G.ELECTRON_NO_ATTACH_CONSOLE,delete G.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",G),P(G)}catch(G){d.error("getUnixShellEnvironment#errorCaught",n.toErrorMessage(G)),c(G)}})});try{return await k}catch(P){return d.error("getUnixShellEnvironment#error",n.toErrorMessage(P)),{}}}}),define(Z[93],x([0,1,7,19,3]),function($,e,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function S(v){return v.map(y=>({type:y.type,resource:m.URI.file(y.path)}))}e.toFileChanges=S;function I(v){const y=new n;for(const i of v)y.processEvent(i);return y.normalize()}e.normalizeFileChanges=I;class n{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(y){const i=this.mapPathToChange.get(y.path);if(i){const E=i.type,M=y.type;E===1&&M===2?(this.mapPathToChange.delete(y.path),this.normalized.splice(this.normalized.indexOf(i),1)):E===2&&M===1?i.type=0:E===1&&M===0||(i.type=M)}else this.normalized.push(y),this.mapPathToChange.set(y.path,y)}normalize(){const y=[],i=[];return this.normalized.filter(E=>E.type!==2?(y.push(E),!1):!0).sort((E,M)=>E.path.length-M.path.length).filter(E=>i.some(M=>L.isParent(E.path,M,!R.isLinux))?!1:(i.push(E.path),!0)).concat(y)}}}),define(Z[174],x([0,1,93,2,18,83,118,9,8]),function($,e,m,L,R,S,I,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class y extends L.Disposable{constructor(E,M,p,d){super();this.path=E,this.onDidFilesChange=M,this.onLogMessage=p,this.verboseLogging=d,this.fileChangesDelayer=this._register(new n.ThrottledDelayer(I.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(E){this.verboseLogging=E}async startWatching(){try{const{stat:E,symbolicLink:M}=await R.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let p=this.path;if(M)try{p=await S.realpath(p)}catch(d){if(this.onError(d),M.dangling)return}E.isDirectory()?this._register(I.watchFolder(p,(d,g)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:v.join(this.path,v.basename(g))})},d=>this.onError(d))):this._register(I.watchFile(p,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(E){E.code!=="ENOENT"&&this.onError(E)}}onFileChange(E){this.fileChangesBuffer.push(E),this.verboseLogging&&this.onVerbose(`${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.path}`),this.fileChangesDelayer.trigger(async()=>{const M=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=m.normalizeFileChanges(M);if(this.verboseLogging)for(const d of p)this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);p.length>0&&this.onDidFilesChange(p)})}onError(E){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${E}`})}onVerbose(E){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${E}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=y}),define(Z[71],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...R){this._entries=new Map;for(let[S,I]of R)this.set(S,I)}set(R,S){const I=this._entries.get(R);return this._entries.set(R,S),I}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=m}),define(Z[175],x([0,1,16,168,69,4,71,9]),function($,e,m,L,R,S,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const v=!1;class y extends Error{constructor(d){var g;super("cyclic dependency between services");this.message=(g=d.findCycleSlow())!==null&&g!==void 0?g:`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class i{constructor(d=new I.ServiceCollection,g=!1,k){this._activeInstantiations=new Set,this._services=d,this._strict=g,this._parent=k,this._services.set(S.IInstantiationService,this)}createChild(d){return new i(d,this._strict,this)}invokeFunction(d,...g){let k=M.traceInvocation(d),P=!1;try{return d({get:(h,o)=>{if(P)throw m.illegalState("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(h,k);if(!l&&o!==S.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return l}},...g)}finally{P=!0,k.stop()}}createInstance(d,...g){let k,P;return d instanceof R.SyncDescriptor?(k=M.traceCreation(d.ctor),P=this._createInstance(d.ctor,d.staticArguments.concat(g),k)):(k=M.traceCreation(d),P=this._createInstance(d,g,k)),k.stop(),P}_createInstance(d,g=[],k){let P=S._util.getServiceDependencies(d).sort((o,l)=>o.index-l.index),c=[];for(const o of P){let l=this._getOrCreateServiceInstance(o.id,k);if(!l&&this._strict&&!o.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${o.id}.`);c.push(l)}let h=P.length>0?P[0].index:g.length;if(g.length!==h){console.warn(`[createInstance] First service dependency of ${d.name} at position ${h+1} conflicts with ${g.length} static arguments`);let o=h-g.length;o>0?g=g.concat(new Array(o)):g=g.slice(0,h)}return new d(...[...g,...c])}_setServiceInstance(d,g){if(this._services.get(d)instanceof R.SyncDescriptor)this._services.set(d,g);else if(this._parent)this._parent._setServiceInstance(d,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let g=this._services.get(d);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):g}_getOrCreateServiceInstance(d,g){let k=this._getServiceInstanceOrDescriptor(d);return k instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,k,g.branch(d,!0)):(g.branch(d,!1),k)}_safeCreateAndCacheServiceInstance(d,g,k){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,g,k)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,g,k){const P=new L.Graph(o=>o.id.toString());let c=0;const h=[{id:d,desc:g,_trace:k}];for(;h.length;){const o=h.pop();if(P.lookupOrInsertNode(o),c++>1e3)throw new y(P);for(let l of S._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(l.id);if(!t&&!l.optional&&console.warn(`[createInstance] ${d} depends on ${l.id} which is NOT registered.`),t instanceof R.SyncDescriptor){const r={id:l.id,desc:t,_trace:o._trace.branch(l.id,!0)};P.insertEdge(o,r),h.push(r)}}}for(;;){const o=P.roots();if(o.length===0){if(!P.isEmpty())throw new y(P);break}for(const{data:l}of o){if(this._getServiceInstanceOrDescriptor(l.id)instanceof R.SyncDescriptor){const r=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,r)}P.removeNode(l)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,g,k=[],P,c){if(this._services.get(d)instanceof R.SyncDescriptor)return this._createServiceInstance(g,k,P,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,g,k,P,c);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(d,g=[],k,P){if(k){const c=new n.IdleValue(()=>this._createInstance(d,g,P));return new Proxy(Object.create(null),{get(h,o){if(o in h)return h[o];let l=c.value,t=l[o];return typeof t!="function"||(t=t.bind(l),h[o]=t),t},set(h,o,l){return c.value[o]=l,!0}})}else return this._createInstance(d,g,P)}}e.InstantiationService=i;var E;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(E||(E={}));class M{constructor(d,g){this.type=d,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return v?new M(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):M._None}static traceCreation(d){return v?new M(0,d.name):M._None}branch(d,g){let k=new M(2,d.toString());return this._dep.push([d,g,k]),k}stop(){let d=Date.now()-this._start;M._totals+=d;let g=!1;function k(c,h){let o=[],l=new Array(c+1).join("	");for(const[t,r,s]of h._dep)if(r&&s){g=!0,o.push(`${l}CREATES -> ${t}`);let a=k(c+1,s);a&&o.push(a)}else o.push(`${l}uses -> ${t}`);return o.join(`
`)}let P=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${k(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${M._totals.toFixed(2)}ms)`];(d>2||g)&&console.log(P.join(`
`))}}M._None=new class extends M{constructor(){super(-1,null)}stop(){}branch(){return this}},M._totals=0}),define(Z[176],x([0,1,16,129,57]),function($,e,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class S extends R.ResolvedKeybinding{constructor(n,v){super();if(v.length===0)throw m.illegalArgument("parts");this._os=n,this._parts=v}getLabel(){return L.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return L.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:L.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return L.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new R.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=S}),define(Z[177],x([0,1,57,176]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class R extends L.BaseResolvedKeybinding{constructor(I,n){super(n,I.parts)}_keyCodeToUILabel(I){if(this._os===2)switch(I){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return m.KeyCodeUtils.toString(I)}_getLabel(I){return I.isDuplicateModifierCase()?"":this._keyCodeToUILabel(I.keyCode)}_getAriaLabel(I){return I.isDuplicateModifierCase()?"":m.KeyCodeUtils.toString(I.keyCode)}_keyCodeToElectronAccelerator(I){if(I>=93&&I<=108)return null;switch(I){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return m.KeyCodeUtils.toString(I)}_getElectronAccelerator(I){return I.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(I.keyCode)}_getUserSettingsLabel(I){if(I.isDuplicateModifierCase())return"";const n=m.KeyCodeUtils.toUserSettingsUS(I.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(I){return R.getDispatchStr(I)}static getDispatchStr(I){if(I.isModifierKey())return null;let n="";return I.ctrlKey&&(n+="ctrl+"),I.shiftKey&&(n+="shift+"),I.altKey&&(n+="alt+"),I.metaKey&&(n+="meta+"),n+=m.KeyCodeUtils.toString(I.keyCode),n}_getSingleModifierDispatchPart(I){return I.keyCode===5&&!I.shiftKey&&!I.altKey&&!I.metaKey?"ctrl":I.keyCode===4&&!I.ctrlKey&&!I.altKey&&!I.metaKey?"shift":I.keyCode===6&&!I.ctrlKey&&!I.shiftKey&&!I.metaKey?"alt":I.keyCode===57&&!I.ctrlKey&&!I.shiftKey&&!I.altKey?"meta":null}}e.USLayoutResolvedKeybinding=R}),define(Z[178],x([0,1,9]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function L(R,S){if(R.length===0)return Promise.resolve(!1);const I=[];let n=!1;for(let v of R){if(v===!0)return Promise.resolve(!0);m.isThenable(v)&&I.push(v.then(y=>{y&&(n=!0)},y=>{S(y),n=!0}))}return m.Promises.settled(I).then(()=>n)}e.handleVetos=L}),define(Z[6],x([0,1,4,2,3,5,67]),function($,e,m,L,R,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=m.createDecorator("logService"),e.ILoggerService=m.createDecorator("loggerService");function n(){return new Date().toISOString()}var v;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;class y extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class i extends y{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(v.Trace)&&this.log(v.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(v.Debug)&&this.log(v.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(v.Info)&&this.log(v.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(v.Warning)&&this.log(v.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(v.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(v.Error,this.format(s))}else this.log(v.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(v.Critical)&&this.log(v.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let s=0;s<t.length;s++){let a=t[s];if(typeof a=="object")try{a=JSON.stringify(a)}catch(u){}r+=(s>0?" ":"")+a}return r}}e.AbstractMessageLogger=i;class E extends y{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!R.isWindows}trace(t,...r){this.getLevel()<=v.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...r):console.log(`[main ${n()}]`,t,...r))}debug(t,...r){this.getLevel()<=v.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...r):console.log(`[main ${n()}]`,t,...r))}info(t,...r){this.getLevel()<=v.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...r):console.log(`[main ${n()}]`,t,...r))}warn(t,...r){this.getLevel()<=v.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,t,...r):console.warn(`[main ${n()}]`,t,...r))}error(t,...r){this.getLevel()<=v.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,t,...r):console.error(`[main ${n()}]`,t,...r))}critical(t,...r){this.getLevel()<=v.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,t,...r):console.error(`[main ${n()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class M extends y{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=v.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=v.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=v.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=v.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=v.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=v.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=M;class p extends y{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=v.Trace&&this.adapter.log(v.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=v.Debug&&this.adapter.log(v.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=v.Info&&this.adapter.log(v.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=v.Warning&&this.adapter.log(v.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=v.Error&&this.adapter.log(v.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=v.Critical&&this.adapter.log(v.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:I.toErrorMessage(t,this.getLevel()<=v.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class d extends y{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const s of this.logServices)s.trace(t,...r)}debug(t,...r){for(const s of this.logServices)s.debug(t,...r)}info(t,...r){for(const s of this.logServices)s.info(t,...r)}warn(t,...r){for(const s of this.logServices)s.warn(t,...r)}error(t,...r){for(const s of this.logServices)s.error(t,...r)}critical(t,...r){for(const s of this.logServices)s.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=d;class g extends L.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=g;class k extends L.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(s))}))}createLogger(t,r){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(r==null?void 0:r.always)?v.Trace:this.logLevel,r),this.loggers.set(t.toString(),s),(r==null?void 0:r.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=k;class P{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(t){}getLevel(){return v.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=P;function c(l){if(l.verbose)return v.Trace;if(typeof l.logLevel=="string"){const t=h(l.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function h(l){switch(l){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Critical;case"off":return v.Off}}e.parseLogLevel=h;function o(l){switch(l){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Critical:return"critical";case v.Off:return"off"}}e.LogLevelToString=o});var ee=this&&this.__param||function($,e){return function(m,L){e(m,L,$)}};define(Z[179],x([0,1,9,17,40,78,47,19,4,6]),function($,e,m,L,R,S,I,n,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var i;(function(M){M.ERROR_INVALID_FILE="ERROR_INVALID_FILE",M.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(i=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=v.createDecorator(e.UserConfigurationFileServiceId);let E=class{constructor(p,d,g){this.environmentService=p,this.fileService=d,this.logService=g,this.queue=new m.Queue}async updateSettings(p,d){return this.queue.queue(()=>this.doWrite(this.environmentService.settingsResource,p,d))}async doWrite(p,d,g){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,p.toString(),d);const{value:k,mtime:P,etag:c}=await this.fileService.readFile(p,{atomic:!0});let h=k.toString();const o=[];if(R.parse(h,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length)throw new Error("ERROR_INVALID_FILE");const l=this.getEdits(d,h,g)[0];if(l){h=h.substring(0,l.offset)+l.content+h.substring(l.offset+l.length);try{await this.fileService.writeFile(p,L.VSBuffer.fromString(h),{etag:c,mtime:P})}catch(t){if(t.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}getEdits({value:p,path:d},g,k){return d.length?S.setProperty(g,d,p,k):[{content:JSON.stringify(p,null,k.insertSpaces&&k.tabSize?" ".repeat(k.tabSize):"	"),length:g.length,offset:0}]}};E=he([ee(0,I.IEnvironmentService),ee(1,n.IFileService),ee(2,y.ILogService)],E),e.UserConfigurationFileService=E}),define(Z[94],x([0,1,6]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function L(S,I){switch(I){case m.LogLevel.Trace:return S.trace;case m.LogLevel.Debug:return S.debug;case m.LogLevel.Info:return S.info;case m.LogLevel.Warning:return S.warn;case m.LogLevel.Error:return S.error;case m.LogLevel.Critical:return S.critical;default:throw new Error("Invalid log level")}}class R extends m.AbstractLogger{constructor(I=m.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(I),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(I){this._logger=I;for(const{level:n,args:v}of this.buffer)L(I,n).apply(I,v);this.buffer=[]}_log(I,...n){this._logger?L(this._logger,I).apply(this._logger,n):this.getLevel()<=I&&this.buffer.push({level:I,args:n})}trace(I,...n){this._log(m.LogLevel.Trace,I,...n)}debug(I,...n){this._log(m.LogLevel.Debug,I,...n)}info(I,...n){this._log(m.LogLevel.Info,I,...n)}warn(I,...n){this._log(m.LogLevel.Warning,I,...n)}error(I,...n){this._log(m.LogLevel.Error,I,...n)}critical(I,...n){this._log(m.LogLevel.Critical,I,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=R}),define(Z[180],x([0,1,6,19,9,17,15,4,94]),function($,e,m,L,R,S,I,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const y=5*L.ByteSize.MB;let i=class extends m.AbstractLogger{constructor(p,d,g,k){super();this.name=p,this.resource=d,this.fileService=k,this.backupIndex=1,this.setLevel(g),this.queue=this._register(new R.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=m.LogLevel.Trace&&this._log(m.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=m.LogLevel.Debug&&this._log(m.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=m.LogLevel.Info&&this._log(m.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=m.LogLevel.Warning&&this._log(m.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=m.LogLevel.Error){const p=arguments[0];if(p instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=p.stack,this._log(m.LogLevel.Error,this.format(d))}else this._log(m.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=m.LogLevel.Critical&&this._log(m.LogLevel.Critical,this.format(arguments))}flush(){}log(p,d){this._log(p,this.format(d))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(p){if(p.fileOperationResult!==3)throw p}}_log(p,d){this.queue.queue(async()=>{await this.initializePromise;let g=await this.loadContent();g.length>y&&(await this.fileService.writeFile(this.getBackupResource(),S.VSBuffer.fromString(g)),g=""),g+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(p)}] ${d}
`,await this.fileService.writeFile(this.resource,S.VSBuffer.fromString(g))})}getCurrentTimestamp(){const p=k=>k<10?`0${k}`:k,d=k=>k<10?`00${k}`:k<100?`0${k}`:k,g=new Date;return`${g.getFullYear()}-${p(g.getMonth()+1)}-${p(g.getDate())} ${p(g.getHours())}:${p(g.getMinutes())}:${p(g.getSeconds())}.${d(g.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,I.joinPath(I.dirname(this.resource),`${I.basename(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(p){return""}}stringifyLogLevel(p){switch(p){case m.LogLevel.Critical:return"critical";case m.LogLevel.Debug:return"debug";case m.LogLevel.Error:return"error";case m.LogLevel.Info:return"info";case m.LogLevel.Trace:return"trace";case m.LogLevel.Warning:return"warning"}return""}format(p){let d="";for(let g=0;g<p.length;g++){let k=p[g];if(typeof k=="object")try{k=JSON.stringify(k)}catch(P){}d+=(g>0?" ":"")+k}return d}};i=he([ee(3,L.IFileService)],i),e.FileLogger=i;let E=class extends m.AbstractLoggerService{constructor(p,d,g){super(p.getLevel(),p.onDidChangeLogLevel);this.instantiationService=d,this.fileService=g}doCreateLogger(p,d){const g=new v.BufferLogService(d);return L.whenProviderRegistered(p,this.fileService).then(()=>g.logger=this.instantiationService.createInstance(i,I.basename(p),p,g.getLevel())),g}};E=he([ee(0,m.ILogService),ee(1,n.IInstantiationService),ee(2,L.IFileService)],E),e.FileLoggerService=E}),define(Z[181],x([0,1,6,5,7]),function($,e,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class S{constructor(M){this.service=M,this.onDidChangeLogLevel=L.Event.buffer(M.onDidChangeLogLevel,!0)}listen(M,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(M,p,d){switch(p){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=S;class I{constructor(M){this.channel=M}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(M){I.setLevel(this.channel,M)}static setLevel(M,p){return M.call("setLevel",p)}}e.LogLevelChannelClient=I;class n{constructor(M){this.loggerService=M,this.loggers=new Map}listen(M,p){throw new Error(`Event not found: ${p}`)}async call(M,p,d){switch(p){case"createLogger":this.createLogger(R.URI.revive(d[0]),d[1]);return;case"log":return this.log(R.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${p}`)}createLogger(M,p){this.loggers.set(M.toString(),this.loggerService.createLogger(M,p))}consoleLog(M,p){let d=console.log;switch(M){case m.LogLevel.Error:d=console.error;break;case m.LogLevel.Warning:d=console.warn;break;case m.LogLevel.Info:d=console.info;break}d.call(console,...p)}log(M,p){const d=this.loggers.get(M.toString());if(!d)throw new Error("Create the logger before logging");for(const[g,k]of p)switch(g){case m.LogLevel.Trace:d.trace(k);break;case m.LogLevel.Debug:d.debug(k);break;case m.LogLevel.Info:d.info(k);break;case m.LogLevel.Warning:d.warn(k);break;case m.LogLevel.Error:d.error(k);break;case m.LogLevel.Critical:d.critical(k);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class v extends m.AbstractLoggerService{constructor(M,p,d){super(M,p);this.channel=d}createConsoleMainLogger(){return new m.AdapterLogger({log:(M,p)=>{this.channel.call("consoleLog",[M,p])}})}doCreateLogger(M,p,d){return new y(this.channel,M,p,d)}}e.LoggerChannelClient=v;class y extends m.AbstractMessageLogger{constructor(M,p,d,g){super(g==null?void 0:g.always);this.channel=M,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[p,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(M,p){const d=[[M,p]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(M){this.channel.call("log",[this.file,M])}}class i extends m.LogService{constructor(M,p){super(p);this.parent=M,this._register(M.onDidChangeLogLevel(d=>p.setLevel(d)))}setLevel(M){super.setLevel(M),this.parent.setLevel(M)}}e.FollowerLogService=i}),define(Z[95],x([0,1,6,19]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function R(v,y,i,E){try{const M=await new Promise((p,d)=>{$(["spdlog"],p,d)});return M.setFlushOn(m.LogLevel.Trace),M.createAsyncRotatingLogger(v,y,i,E)}catch(M){console.error(M)}return null}function S(v,y,i,E){const M=$.__$__nodeRequire("spdlog");return M.setFlushOn(m.LogLevel.Trace),M.createRotatingLogger(v,y,i,E)}e.createRotatingLogger=S;function I(v,y,i){switch(y){case m.LogLevel.Trace:v.trace(i);break;case m.LogLevel.Debug:v.debug(i);break;case m.LogLevel.Info:v.info(i);break;case m.LogLevel.Warning:v.warn(i);break;case m.LogLevel.Error:v.error(i);break;case m.LogLevel.Critical:v.critical(i);break;default:throw new Error("Invalid log level")}}class n extends m.AbstractMessageLogger{constructor(y,i,E,M){super();this.name=y,this.filepath=i,this.rotating=E,this.buffer=[],this.setLevel(M),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}_createSpdLogLogger(){const y=this.rotating?6:1,i=30/y*L.ByteSize.MB;return R(this.name,this.filepath,i,y).then(E=>{if(E){this._logger=E,this._logger.setLevel(this.getLevel());for(const{level:M,message:p}of this.buffer)I(this._logger,M,p);this.buffer=[]}})}log(y,i){this._logger?I(this._logger,y,i):this.getLevel()<=y&&this.buffer.push({level:y,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(Z[182],x([0,1,6,15,10,180,95,19,27]),function($,e,m,L,R,S,I,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let y=class extends m.AbstractLoggerService{constructor(E,M){super(E.getLevel(),E.onDidChangeLogLevel);this.fileService=M}doCreateLogger(E,M,p){var d;if(E.scheme===R.Schemas.file){const g=new I.SpdLogLogger((p==null?void 0:p.name)||v.generateUuid(),E.fsPath,!(p==null?void 0:p.donotRotate),M);return(p==null?void 0:p.donotUseFormatters)&&g.clearFormatters(),g}else return new S.FileLogger((d=p==null?void 0:p.name)!==null&&d!==void 0?d:L.basename(E),E,M,this.fileService)}};y=he([ee(0,m.ILogService),ee(1,n.IFileService)],y),e.LoggerService=y}),define(Z[183],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function m(I){return I.submenu!==void 0}e.isMenubarMenuItemSubmenu=m;function L(I){return I.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function R(I){return I.uri!==void 0}e.isMenubarMenuItemRecentAction=R;function S(I){return!m(I)&&!L(I)&&!R(I)}e.isMenubarMenuItemAction=S}),define(Z[48],x([0,1,10,3,33,15]),function($,e,m,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let I;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const n=L.globals.vscode.context.configuration();if(n)I=n.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof($==null?void 0:$.__$__nodeRequire)=="function"){const n=S.dirname(m.FileAccess.asFileUri("",$));I=$.__$__nodeRequire(S.joinPath(n,"product.json").fsPath);const v=$.__$__nodeRequire(S.joinPath(n,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(I,{nameShort:`${I.nameShort} Dev`,nameLong:`${I.nameLong} Dev`,dataFolderName:`${I.dataFolderName}-dev`}),Object.assign(I,{version:v.version})}else I={},Object.keys(I).length===0&&Object.assign(I,{version:"1.58.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=I}),define(Z[96],x([0,1,142,17,19,16,48]),function($,e,m,L,R,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(E,M,p,d,g,k){let P;try{await v(E,M,p,d,g,k)}catch(c){P=c}finally{P&&g.errorTransformer&&(P=g.errorTransformer(P)),typeof P!="undefined"&&p.error(P),p.end()}}e.readFileIntoStream=n;async function v(E,M,p,d,g,k){y(k);const P=await E.open(M,{create:!1});try{y(k);let c=0,h=0,o=g&&typeof g.length=="number"?g.length:void 0,l=L.VSBuffer.alloc(Math.min(g.bufferSize,typeof o=="number"?o:g.bufferSize)),t=g&&typeof g.position=="number"?g.position:0,r=0;do h=await E.read(P,t,l.buffer,r,l.byteLength-r),t+=h,r+=h,c+=h,typeof o=="number"&&(o-=h),r===l.byteLength&&(await p.write(d(l)),l=L.VSBuffer.alloc(Math.min(g.bufferSize,typeof o=="number"?o:g.bufferSize)),r=0);while(h>0&&(typeof o!="number"||o>0)&&y(k)&&i(c,g));if(r>0){let s=r;typeof o=="number"&&(s=Math.min(r,o)),p.write(d(l.slice(0,s)))}}catch(c){throw R.ensureFileSystemProviderError(c)}finally{await E.close(P)}}function y(E){if(E.isCancellationRequested)throw S.canceled();return!0}function i(E,M){if(M==null?void 0:M.limits){if(typeof M.limits.memory=="number"&&E>M.limits.memory)throw R.createFileSystemProviderError(m.localize(0,null,I.default.nameShort),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof M.limits.size=="number"&&E>M.limits.size)throw R.createFileSystemProviderError(m.localize(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[184],x([0,1,140,72,2,19,5,15,37,36,6,17,64,9,25,10,96,63]),function($,e,m,L,R,S,I,n,v,y,i,E,M,p,d,g,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class Je extends R.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new I.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new I.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new I.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new I.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new I.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new I.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new p.ThrottledWorker(Je.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Je.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Je.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new S.FileChangesEvent(l,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new p.ThrottledWorker(Je.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Je.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Je.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new S.FileChangesEvent(l,!0)))),this.watchedResources=v.TernarySearchTree.forUris(l=>{const t=this.getProvider(l.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new p.ResourceQueue)}registerProvider(o,l){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);L.mark(`code/registerFilesystem/${o}`),this.provider.set(o,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:l});const t=new R.DisposableStore;return t.add(l.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(l)))),t.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:o}))),typeof l.onDidErrorOccur=="function"&&t.add(l.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),R.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:l}),this.provider.delete(o),R.dispose(t)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){l.push(t)}}),!this.provider.has(o)&&await p.Promises.settled(l)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,l){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&l)}listCapabilities(){return P.Iterable.map(this.provider,([o,l])=>({scheme:o,capabilities:l.capabilities}))}async withProvider(o){if(!n.isAbsolutePath(o))throw new S.FileOperationError(m.localize(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const l=this.provider.get(o.scheme);if(!l){const t=new Error;throw t.name="ENOPRO",t.message=m.localize(1,null,o.toString()),t}return l}async withReadProvider(o){const l=await this.withProvider(o);if(S.hasOpenReadWriteCloseCapability(l)||S.hasReadWriteCapability(l)||S.hasFileReadStreamCapability(l))return l;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const l=await this.withProvider(o);if(S.hasOpenReadWriteCloseCapability(l)||S.hasReadWriteCapability(l))return l;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,l){try{return await this.doResolveFile(o,l)}catch(t){throw S.toFileSystemProviderErrorCode(t)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError(m.localize(2,null,this.resourceForError(o)),1):S.ensureFileSystemProviderError(t)}}async doResolveFile(o,l){const t=await this.withProvider(o),r=this.isPathCaseSensitive(t),s=l==null?void 0:l.resolveTo,a=l==null?void 0:l.resolveSingleChildDescendants,u=l==null?void 0:l.resolveMetadata,w=await t.stat(o);let f;return this.toFileStat(t,o,w,void 0,!!u,(b,A)=>(f||(f=v.TernarySearchTree.forUris(()=>!r),f.set(o,!0),y.isNonEmptyArray(s)&&s.forEach(U=>f.set(U,!0))),Boolean(f.findSuperstr(b.resource)||f.get(b.resource))?!0:b.isDirectory&&a?A===1:!1))}async toFileStat(o,l,t,r,s,a){var u;const{providerExtUri:w}=this.getExtUri(o),f={resource:l,name:w.basename(l),isFile:(t.type&S.FileType.File)!=0,isDirectory:(t.type&S.FileType.Directory)!=0,isSymbolicLink:(t.type&S.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean(((u=t.permissions)!==null&&u!==void 0?u:0)&S.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:S.etag({mtime:t.mtime,size:t.size})};if(f.isDirectory&&a(f,r)){try{const b=await o.readdir(l),A=await p.Promises.settled(b.map(async([U,q])=>{try{const J=w.joinPath(l,U),te=s?await o.stat(J):{type:q};return await this.toFileStat(o,J,te,b.length,s,a)}catch(J){return this.logService.trace(J),null}}));f.children=y.coalesce(A)}catch(b){this.logService.trace(b),f.children=[]}return f}return f}async resolveAll(o){return p.Promises.settled(o.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const l=await this.withProvider(o);try{return!!await l.stat(o)}catch(t){return!1}}async canCreateFile(o,l){try{await this.doValidateCreateFile(o,l)}catch(t){return t}return!0}async doValidateCreateFile(o,l){if(!(l==null?void 0:l.overwrite)&&await this.exists(o))throw new S.FileOperationError(m.localize(3,null,this.resourceForError(o)),3,l)}async createFile(o,l=E.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const r=await this.writeFile(o,l);return this._onDidRunOperation.fire(new S.FileOperationEvent(o,0,r)),r}async writeFile(o,l,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:s}=this.getExtUri(r);try{await this.validateWriteFile(r,o,t)||await this.mkdirp(r,s.dirname(o));let u;if(S.hasReadWriteCapability(r)&&!(l instanceof E.VSBuffer))if(M.isReadableStream(l)){const w=await M.peekStream(l,3);w.ended?u=E.VSBuffer.concat(w.buffer):u=w}else u=M.peekReadable(l,w=>E.VSBuffer.concat(w),3);else u=l;!S.hasOpenReadWriteCloseCapability(r)||S.hasReadWriteCapability(r)&&u instanceof E.VSBuffer?await this.doWriteUnbuffered(r,o,t,u):await this.doWriteBuffered(r,o,t,u instanceof E.VSBuffer?E.bufferToReadable(u):u)}catch(a){throw new S.FileOperationError(m.localize(4,null,this.resourceForError(o),S.ensureFileSystemProviderError(a).toString()),S.toFileOperationResult(a),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,l,t){if(!!(t==null?void 0:t.unlock)&&!(o.capabilities&8192))throw new Error(m.localize(5,null,this.resourceForError(l)));let s;try{s=await o.stat(l)}catch(a){return}if((s.type&S.FileType.Directory)!=0)throw new S.FileOperationError(m.localize(6,null,this.resourceForError(l)),0,t);if(this.throwIfFileIsReadonly(l,s),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&t.mtime<s.mtime&&t.etag!==S.etag({mtime:t.mtime,size:s.size}))throw new S.FileOperationError(m.localize(7,null),3,t);return s}async readFile(o,l){const t=await this.withReadProvider(o);return(l==null?void 0:l.atomic)?this.doReadFileAtomic(t,o,l):this.doReadFile(t,o,l)}async doReadFileAtomic(o,l,t){return new Promise((r,s)=>{this.writeQueue.queueFor(l,this.getExtUri(o).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(o,l,t);r(a)}catch(a){s(a)}})})}async doReadFile(o,l,t){const r=await this.doReadFileStream(o,l,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},r),{value:await E.streamToBuffer(r.value)})}async readFileStream(o,l){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,l)}async doReadFileStream(o,l,t){const r=new d.CancellationTokenSource,s=this.validateReadFile(l,t).then(u=>u,u=>{throw r.cancel(),u});let a;try{t&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&await s,!(S.hasOpenReadWriteCloseCapability(o)||S.hasFileReadStreamCapability(o))||S.hasReadWriteCapability(o)&&(t==null?void 0:t.preferUnbuffered)?a=this.readFileUnbuffered(o,l,t):S.hasFileReadStreamCapability(o)?a=this.readFileStreamed(o,l,r.token,t):a=this.readFileBuffered(o,l,r.token,t);const u=await s;return Object.assign(Object.assign({},u),{value:a})}catch(u){a&&await M.consumeStream(a);const w=m.localize(8,null,this.resourceForError(l),S.ensureFileSystemProviderError(u).toString());throw u instanceof S.NotModifiedSinceFileOperationError?new S.NotModifiedSinceFileOperationError(w,u.stat,t):new S.FileOperationError(w,S.toFileOperationResult(u),t)}}readFileStreamed(o,l,t,r=Object.create(null)){const s=o.readFileStream(l,r,t);return M.transform(s,{data:a=>a instanceof E.VSBuffer?a:E.VSBuffer.wrap(a),error:a=>new S.FileOperationError(m.localize(9,null,this.resourceForError(l),S.ensureFileSystemProviderError(a).toString()),S.toFileOperationResult(a),r)},a=>E.VSBuffer.concat(a))}readFileBuffered(o,l,t,r=Object.create(null)){const s=E.newWriteableBufferStream();return k.readFileIntoStream(o,l,s,a=>a,Object.assign(Object.assign({},r),{bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new S.FileOperationError(m.localize(10,null,this.resourceForError(l),S.ensureFileSystemProviderError(a).toString()),S.toFileOperationResult(a),r)}),t),s}readFileUnbuffered(o,l,t){const r=M.newWriteableStream(s=>E.VSBuffer.concat(s));return(async()=>{try{let s=await o.readFile(l);t&&typeof t.position=="number"&&(s=s.slice(t.position)),t&&typeof t.length=="number"&&(s=s.slice(0,t.length)),this.validateReadFileLimits(l,s.byteLength,t),r.end(E.VSBuffer.wrap(s))}catch(s){r.error(s),r.end()}})(),r}async validateReadFile(o,l){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new S.FileOperationError(m.localize(11,null,this.resourceForError(o)),0,l);if(l&&typeof l.etag=="string"&&l.etag!==S.ETAG_DISABLED&&l.etag===t.etag)throw new S.NotModifiedSinceFileOperationError(m.localize(12,null),t,l);return this.validateReadFileLimits(o,t.size,l),t}validateReadFileLimits(o,l,t){if(t==null?void 0:t.limits){let r;if(typeof t.limits.memory=="number"&&l>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&l>t.limits.size&&(r=7),typeof r=="number")throw new S.FileOperationError(m.localize(13,null,this.resourceForError(o)),r)}}async canMove(o,l,t){return this.doCanMoveCopy(o,l,"move",t)}async canCopy(o,l,t){return this.doCanMoveCopy(o,l,"copy",t)}async doCanMoveCopy(o,l,t,r){if(o.toString()!==l.toString())try{const s=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(s,o,a,l,t,r)}catch(s){return s}return!0}async move(o,l,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),a=await this.doMoveCopy(r,o,s,l,"move",!!t),u=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(o,a==="move"?2:3,u)),u}async copy(o,l,t){const r=await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),a=await this.doMoveCopy(r,o,s,l,"copy",!!t),u=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(o,a==="copy"?3:2,u)),u}async doMoveCopy(o,l,t,r,s,a){if(l.toString()===r.toString())return s;const{exists:u,isSameResourceWithDifferentPathCase:w}=await this.doValidateMoveCopy(o,l,t,r,s,a);if(u&&!w&&a&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),s==="copy"){if(o===t&&S.hasFileFolderCopyCapability(o))await o.copy(l,r,{overwrite:a});else{const f=await this.resolve(l);f.isDirectory?await this.doCopyFolder(o,f,t,r):await this.doCopyFile(o,l,t,r)}return s}else return o===t?(await o.rename(l,r,{overwrite:a}),s):(await this.doMoveCopy(o,l,t,r,"copy",a),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(o,l,t,r){if(S.hasOpenReadWriteCloseCapability(o)&&S.hasOpenReadWriteCloseCapability(t))return this.doPipeBuffered(o,l,t,r);if(S.hasOpenReadWriteCloseCapability(o)&&S.hasReadWriteCapability(t))return this.doPipeBufferedToUnbuffered(o,l,t,r);if(S.hasReadWriteCapability(o)&&S.hasOpenReadWriteCloseCapability(t))return this.doPipeUnbufferedToBuffered(o,l,t,r);if(S.hasReadWriteCapability(o)&&S.hasReadWriteCapability(t))return this.doPipeUnbuffered(o,l,t,r)}async doCopyFolder(o,l,t,r){await t.mkdir(r),Array.isArray(l.children)&&await p.Promises.settled(l.children.map(async s=>{const a=this.getExtUri(t).providerExtUri.joinPath(r,s.name);return s.isDirectory?this.doCopyFolder(o,await this.resolve(s.resource),t,a):this.doCopyFile(o,s.resource,t,a)}))}async doValidateMoveCopy(o,l,t,r,s,a){let u=!1;if(o===t){const{providerExtUri:f,isPathCaseSensitive:b}=this.getExtUri(o);if(b||(u=f.isEqual(l,r)),u&&s==="copy")throw new Error(m.localize(14,null,this.resourceForError(l),this.resourceForError(r)));if(!u&&f.isEqualOrParent(r,l))throw new Error(m.localize(15,null,this.resourceForError(l),this.resourceForError(r)))}const w=await this.exists(r);if(w&&!u){if(!a)throw new S.FileOperationError(m.localize(16,null,this.resourceForError(l),this.resourceForError(r)),4);if(o===t){const{providerExtUri:f}=this.getExtUri(o);if(f.isEqualOrParent(l,r))throw new Error(m.localize(17,null,this.resourceForError(l),this.resourceForError(r)))}}return{exists:w,isSameResourceWithDifferentPathCase:u}}getExtUri(o){const l=this.isPathCaseSensitive(o);return{providerExtUri:l?n.extUri:n.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(l,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(o,0,t)),t}async mkdirp(o,l){const t=[],{providerExtUri:r}=this.getExtUri(o);for(;!r.isEqual(l,r.dirname(l));)try{if(((await o.stat(l)).type&S.FileType.Directory)==0)throw new Error(m.localize(18,null,this.resourceForError(l)));break}catch(s){if(S.toFileSystemProviderErrorCode(s)!==S.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(r.basename(l)),l=r.dirname(l)}for(let s=t.length-1;s>=0;s--){l=r.joinPath(l,t[s]);try{await o.mkdir(l)}catch(a){if(S.toFileSystemProviderErrorCode(a)!==S.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,l){try{await this.doValidateDelete(o,l)}catch(t){return t}return!0}async doValidateDelete(o,l){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!(l==null?void 0:l.useTrash)&&!(t.capabilities&4096))throw new Error(m.localize(19,null,this.resourceForError(o)));let s;try{s=await t.stat(o)}catch(u){}if(s)this.throwIfFileIsReadonly(o,s);else throw new S.FileOperationError(m.localize(20,null,this.resourceForError(o)),1);if(!!!(l==null?void 0:l.recursive)){const u=await this.resolve(o);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error(m.localize(21,null,this.resourceForError(o)))}return t}async del(o,l){const t=await this.doValidateDelete(o,l),r=!!(l==null?void 0:l.useTrash),s=!!(l==null?void 0:l.recursive);await t.delete(o,{recursive:s,useTrash:r}),this._onDidRunOperation.fire(new S.FileOperationEvent(o,1))}onDidChangeFile(o,l){this._onDidChangeFilesRaw.fire({changes:o});let t,r;{for(const s of o)this.watchedResources.has(s.resource)?(t||(t=[]),t.push(s)):(r||(r=[]),r.push(s));t&&this._onDidFilesChange.fire(new S.FileChangesEvent(t,!l))}if(r){const s=l?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!s.work(r)&&Je.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),s.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${s.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,l={recursive:!1,excludes:[]}){var t;const r=new R.DisposableStore;{let s=!1,a=()=>{s=!0};r.add(R.toDisposable(()=>a())),this.doWatch(o,l).then(u=>{s?R.dispose(u):a=()=>R.dispose(u)},u=>this.logService.error(u))}return l.recursive||(this.watchedResources.set(o,((t=this.watchedResources.get(o))!==null&&t!==void 0?t:0)+1),r.add(R.toDisposable(()=>{const s=this.watchedResources.get(o);typeof s=="number"&&(s<=1?this.watchedResources.delete(o):this.watchedResources.set(o,s-1))}))),r}async doWatch(o,l){const t=await this.withProvider(o),r=this.toWatchKey(t,o,l),s=this.activeWatchers.get(r)||{count:0,disposable:t.watch(o,l)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,s),s.count+=1,R.toDisposable(()=>{s.count--,s.count===0&&(R.dispose(s.disposable),this.activeWatchers.delete(r))})}toWatchKey(o,l,t){const{providerExtUri:r}=this.getExtUri(o);return[r.getComparisonKey(l),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(o=>R.dispose(o.disposable)),this.activeWatchers.clear()}async doWriteBuffered(o,l,t,r){return this.writeQueue.queueFor(l,this.getExtUri(o).providerExtUri).queue(async()=>{var s;const a=await o.open(l,{create:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1});try{M.isReadableStream(r)||M.isReadableBufferedStream(r)?await this.doWriteStreamBufferedQueued(o,a,r):await this.doWriteReadableBufferedQueued(o,a,r)}catch(u){throw S.ensureFileSystemProviderError(u)}finally{await o.close(a)}})}async doWriteStreamBufferedQueued(o,l,t){let r=0,s;if(M.isReadableBufferedStream(t)){if(t.buffer.length>0){const a=E.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,l,a,a.byteLength,r,0),r+=a.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise(async(a,u)=>{M.listenStream(s,{onData:async w=>{s.pause();try{await this.doWriteBuffer(o,l,w,w.byteLength,r,0)}catch(f){return u(f)}r+=w.byteLength,setTimeout(()=>s.resume())},onError:w=>u(w),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(o,l,t){let r=0,s;for(;(s=t.read())!==null;)await this.doWriteBuffer(o,l,s,s.byteLength,r,0),r+=s.byteLength}async doWriteBuffer(o,l,t,r,s,a){let u=0;for(;u<r;)u+=await o.write(l,s+u,t.buffer,a+u,r-u)}async doWriteUnbuffered(o,l,t,r){return this.writeQueue.queueFor(l,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,l,t,r))}async doWriteUnbufferedQueued(o,l,t,r){var s;let a;r instanceof E.VSBuffer?a=r:M.isReadableStream(r)?a=await E.streamToBuffer(r):M.isReadableBufferedStream(r)?a=await E.bufferedStreamToBuffer(r):a=E.readableToBuffer(r),await o.writeFile(l,a.buffer,{create:!0,overwrite:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1})}async doPipeBuffered(o,l,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,l,t,r))}async doPipeBufferedQueued(o,l,t,r){let s,a;try{s=await o.open(l,{create:!1}),a=await t.open(r,{create:!0,unlock:!1});const u=E.VSBuffer.alloc(this.BUFFER_SIZE);let w=0,f=0,b=0;do b=await o.read(s,w,u.buffer,f,u.byteLength-f),await this.doWriteBuffer(t,a,u,b,w,f),w+=b,f+=b,f===u.byteLength&&(f=0);while(b>0)}catch(u){throw S.ensureFileSystemProviderError(u)}finally{await p.Promises.settled([typeof s=="number"?o.close(s):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async doPipeUnbuffered(o,l,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,l,t,r))}async doPipeUnbufferedQueued(o,l,t,r){return t.writeFile(r,await o.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,l,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,l,t,r))}async doPipeUnbufferedToBufferedQueued(o,l,t,r){const s=await t.open(r,{create:!0,unlock:!1});try{const a=await o.readFile(l);await this.doWriteBuffer(t,s,E.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw S.ensureFileSystemProviderError(a)}finally{await t.close(s)}}async doPipeBufferedToUnbuffered(o,l,t,r){const s=await E.streamToBuffer(this.readFileBuffered(o,l,d.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,s)}throwIfFileSystemIsReadonly(o,l){if(o.capabilities&2048)throw new S.FileOperationError(m.localize(22,null,this.resourceForError(l)),6);return o}throwIfFileIsReadonly(o,l){var t;if(((t=l.permissions)!==null&&t!==void 0?t:0)&S.FilePermission.Readonly)throw new S.FileOperationError(m.localize(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===g.Schemas.file?o.fsPath:o.toString(!0)}};c.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},c=he([ee(0,i.ILogService)],c),e.FileService=c}),define(Z[185],x([0,1,2,19,5,3,18,8,15,30,9,6,143,93,165,167,164,174,64,96,36,17]),function($,e,m,L,R,S,I,n,v,y,i,E,M,p,d,g,k,P,c,h,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends m.Disposable{constructor(s,a){var u;super();this.logService=s,this.options=a,this.BUFFER_SIZE=((u=this.options)===null||u===void 0?void 0:u.bufferSize)||64*1024,this.onDidChangeCapabilities=R.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new R.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new i.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,S.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:a,symbolicLink:u}=await I.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(a,u),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(s){try{const a=await I.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),u=[];return await Promise.all(a.map(async w=>{try{let f;w.isSymbolicLink()?f=(await this.stat(v.joinPath(s,w.name))).type:f=this.toType(w),u.push([w.name,f])}catch(f){this.logService.trace(f)}})),u}catch(a){throw this.toFileSystemProviderError(a)}}toType(s,a){let u;return(a==null?void 0:a.dangling)?u=L.FileType.Unknown:s.isFile()?u=L.FileType.File:s.isDirectory()?u=L.FileType.Directory:u=L.FileType.Unknown,a&&(u|=L.FileType.SymbolicLink),u}async readFile(s){try{const a=this.toFilePath(s);return await I.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(s,a,u){const w=c.newWriteableStream(f=>l.VSBuffer.concat(f.map(b=>l.VSBuffer.wrap(b))).buffer);return h.readFileIntoStream(this,s,w,f=>f.buffer,Object.assign(Object.assign({},a),{bufferSize:this.BUFFER_SIZE}),u),w}async writeFile(s,a,u){let w;try{const f=this.toFilePath(s);if(!u.create||!u.overwrite){if(await I.Promises.exists(f)){if(!u.overwrite)throw L.createFileSystemProviderError(M.localize(0,null),L.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw L.createFileSystemProviderError(M.localize(1,null),L.FileSystemProviderErrorCode.FileNotFound)}w=await this.open(s,{create:!0,unlock:u.unlock}),await this.write(w,0,a,0,a.byteLength)}catch(f){throw await this.toFileSystemProviderWriteError(s,f)}finally{typeof w=="number"&&await this.close(w)}}async open(s,a){try{const u=this.toFilePath(s);if(L.isFileOpenForWriteOptions(a)&&a.unlock)try{const{stat:b}=await I.SymlinkSupport.stat(u);b.mode&128||await I.Promises.chmod(u,b.mode|128)}catch(b){this.logService.trace(b)}let w;if(L.isFileOpenForWriteOptions(a)){if(S.isWindows)try{await I.Promises.truncate(u,0),w="r+"}catch(b){b.code!=="ENOENT"&&this.logService.trace(b)}w||(w="w")}else w="r";const f=await I.Promises.open(u,w);return this.mapHandleToPos.set(f,0),L.isFileOpenForWriteOptions(a)&&this.writeHandles.set(f,s),f}catch(u){throw L.isFileOpenForWriteOptions(a)?await this.toFileSystemProviderWriteError(s,u):this.toFileSystemProviderError(u)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await I.Promises.fdatasync(s)}catch(a){this.canFlush=!1,this.logService.error(a)}return await I.Promises.close(s)}catch(a){throw this.toFileSystemProviderError(a)}}async read(s,a,u,w,f){const b=this.normalizePos(s,a);let A=null;try{const U=await I.Promises.read(s,u,w,f,b);return typeof U=="number"?A=U:A=U.bytesRead,A}catch(U){throw this.toFileSystemProviderError(U)}finally{this.updatePos(s,b,A)}}normalizePos(s,a){return a===this.mapHandleToPos.get(s)?null:a}updatePos(s,a,u){const w=this.mapHandleToPos.get(s);typeof w=="number"&&(typeof a=="number"||(typeof u=="number"?this.mapHandleToPos.set(s,w+u):this.mapHandleToPos.delete(s)))}async write(s,a,u,w,f){return i.retry(()=>this.doWrite(s,a,u,w,f),100,3)}async doWrite(s,a,u,w,f){const b=this.normalizePos(s,a);let A=null;try{const U=await I.Promises.write(s,u,w,f,b);return typeof U=="number"?A=U:A=U.bytesWritten,A}catch(U){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),U)}finally{this.updatePos(s,b,A)}}async mkdir(s){try{await I.Promises.mkdir(this.toFilePath(s))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(s,a){try{const u=this.toFilePath(s);await this.doDelete(u,a)}catch(u){throw this.toFileSystemProviderError(u)}}async doDelete(s,a){a.recursive?await I.Promises.rm(s,I.RimRafMode.MOVE):await I.Promises.unlink(s)}async rename(s,a,u){const w=this.toFilePath(s),f=this.toFilePath(a);if(w!==f)try{await this.validateTargetDeleted(s,a,"move",u.overwrite),await I.Promises.move(w,f)}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error(M.localize(2,null,n.basename(w),n.basename(n.dirname(f)),b.toString()))),this.toFileSystemProviderError(b)}}async copy(s,a,u){const w=this.toFilePath(s),f=this.toFilePath(a);if(w!==f)try{await this.validateTargetDeleted(s,a,"copy",u.overwrite),await I.Promises.copy(w,f,{preserveSymlinks:!0})}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error(M.localize(3,null,n.basename(w),n.basename(n.dirname(f)),b.toString()))),this.toFileSystemProviderError(b)}}async validateTargetDeleted(s,a,u,w){const f=this.toFilePath(s),b=this.toFilePath(a);let A=!1;if(!!(this.capabilities&1024)||(A=y.isEqual(f,b,!0)),A&&u==="copy")throw L.createFileSystemProviderError(M.localize(4,null),L.FileSystemProviderErrorCode.FileExists);if(!A&&await I.Promises.exists(b)){if(!w)throw L.createFileSystemProviderError(M.localize(5,null),L.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(s,a){return a.recursive?this.watchRecursive(s,a.excludes):this.watchNonRecursive(s)}watchRecursive(s,a){const u={path:this.toFilePath(s),excludes:a},w=o.insert(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),m.toDisposable(()=>{w(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var s,a,u;if(this.recursiveWatcher instanceof k.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(m.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let w,f;((a=(s=this.options)===null||s===void 0?void 0:s.watcher)===null||a===void 0?void 0:a.usePolling)?(w=d.FileWatcher,f=(u=this.options)===null||u===void 0?void 0:u.watcher):this.recursiveFoldersToWatch.length===1?S.isWindows?w=g.FileWatcher:w=d.FileWatcher:w=k.FileWatcher,this.recursiveWatcher=new w(this.recursiveFoldersToWatch,b=>this._onDidChangeFile.fire(p.toFileChanges(b)),b=>{b.type==="error"&&this._onDidWatchErrorOccur.fire(b.message),this.logService[b.type](b.message)},this.logService.getLevel()===E.LogLevel.Trace,f),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)}))}}watchNonRecursive(s){const a=new P.FileWatcher(this.toFilePath(s),w=>this._onDidChangeFile.fire(p.toFileChanges(w)),w=>{w.type==="error"&&this._onDidWatchErrorOccur.fire(w.message),this.logService[w.type](w.message)},this.logService.getLevel()===E.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)});return m.combinedDisposable(a,u)}toFilePath(s){return n.normalize(s.fsPath)}toFileSystemProviderError(s){if(s instanceof L.FileSystemProviderError)return s;let a;switch(s.code){case"ENOENT":a=L.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=L.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=L.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=L.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=L.FileSystemProviderErrorCode.NoPermissions;break;default:a=L.FileSystemProviderErrorCode.Unknown}return L.createFileSystemProviderError(s,a)}async toFileSystemProviderWriteError(s,a){let u=this.toFileSystemProviderError(a);if(s&&u.code===L.FileSystemProviderErrorCode.NoPermissions)try{const{stat:w}=await I.SymlinkSupport.stat(this.toFilePath(s));w.mode&128||(u=L.createFileSystemProviderError(a,L.FileSystemProviderErrorCode.FileWriteLocked))}catch(w){this.logService.trace(w)}return u}dispose(){super.dispose(),m.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,m.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(Z[20],x([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=m.createDecorator("productService")}),define(Z[186],x([0,1,58,6,20]),function($,e,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let S=class{constructor(n,v){this.productService=n,this.logService=v,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,v){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const y=/^(.*)#([^#]+)$/.exec(v);if(!y)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",v),!1;const[,i,E]=y;let M=this.trustedExtensionUrlPublicKeys.get(n);if(!M){if(M=this.productService.trustedExtensionUrlPublicKeys[n],!M||M.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...M])}const p=Buffer.from(decodeURIComponent(E),"base64");if(p.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",v),!1;const d=p.slice(0,6),g=p.readUIntBE(0,6),k=Date.now()-g;if(k<0||k>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",v),!1;const P=p.slice(6),c=m.createVerify("SHA256");c.write(d),c.write(Buffer.from(i)),c.end();for(let h=0;h<M.length;h++){let o=M[h];if(o!==null){if(typeof o=="string")try{o=m.createPublicKey({key:Buffer.from(o,"base64"),format:"der",type:"spki"}),M[h]=o}catch(l){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${h+1} for ${n}:`,l),M[h]=null;continue}if(c.verify(o,P))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",v),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",v),!1}};S=he([ee(0,R.IProductService),ee(1,L.ILogService)],S),e.ExtensionUrlTrustService=S}),define(Z[55],x([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=m.createDecorator("protocolMainService")}),define(Z[187],x([0,1,2,10,7,47,14,6,37,3,15,27]),function($,e,m,L,R,S,I,n,v,y,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let M=class extends m.Disposable{constructor(d,g){super();this.logService=g,this.validRoots=v.TernarySearchTree.forUris(()=>!y.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(R.URI.file(d.appRoot)),this.addValidFileRoot(R.URI.file(d.extensionsPath)),this.addValidFileRoot(d.globalStorageHome),this.addValidFileRoot(d.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:d}=I.session;d.protocol.registerFileProtocol(L.Schemas.vscodeFileResource,(g,k)=>this.handleResourceRequest(g,k)),d.protocol.interceptFileProtocol(L.Schemas.file,(g,k)=>this.handleFileRequest(g,k)),this._register(m.toDisposable(()=>{d.protocol.unregisterProtocol(L.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(L.Schemas.file)}))}addValidFileRoot(d){return this.validRoots.get(d)?m.Disposable.None:(this.validRoots.set(d,!0),m.toDisposable(()=>this.validRoots.delete(d)))}handleFileRequest(d,g){const k=R.URI.parse(d.url);return y.isPreferringBrowserCodeLoad?(this.logService.error(`Refused to load resource ${k.fsPath} from ${L.Schemas.file}: protocol (original URL: ${d.url})`),g({error:-3})):this.validRoots.findSubstr(k)?g({path:k.fsPath}):this.validExtensions.has(i.extname(k))?g({path:k.fsPath}):(this.logService.error(`${L.Schemas.file}: Refused to load resource ${k.fsPath} from ${L.Schemas.file}: protocol (original URL: ${d.url})`),g({error:-3}))}handleResourceRequest(d,g){const k=R.URI.parse(d.url),P=L.FileAccess.asFileUri(k);return this.validRoots.findSubstr(P)?g({path:P.fsPath}):this.validExtensions.has(i.extname(P))?g({path:P.fsPath}):(this.logService.error(`${L.Schemas.vscodeFileResource}: Refused to load resource ${P.fsPath} from ${L.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),g({error:-3}))}createIPCObjectUrl(){let d;const g=R.URI.from({scheme:"vscode",path:E.generateUuid()}),k=g.toString(),P=async()=>d;return I.ipcMain.handle(k,P),this.logService.trace(`IPC Object URL: Registered new channel ${k}.`),{resource:g,update:c=>d=c,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${k}.`),I.ipcMain.removeHandler(k)}}}};M=he([ee(0,S.INativeEnvironmentService),ee(1,n.ILogService)],M),e.ProtocolMainService=M}),define(Z[38],x([0,1,13,104]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(I,n){L.ok(m.isString(I)),L.ok(m.isObject(n)),L.ok(!this.data.has(I),"There is already an extension with this id"),this.data.set(I,n)}knows(I){return this.data.has(I)}as(I){return this.data.get(I)||null}}e.Registry=new R}),define(Z[188],x([0,1,38,5]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class S{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(v,y){this.schemasById[R(v)]=y,this._onDidChangeSchema.fire(v)}notifySchemaChanged(v){this._onDidChangeSchema.fire(v)}getSchemaContributions(){return{schemas:this.schemasById}}}const I=new S;m.Registry.add(e.Extensions.JSONContribution,I)}),define(Z[49],x([0,1,133,5,38,13,188]),function($,e,m,L,R,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var n;(function(k){k[k.APPLICATION=1]="APPLICATION",k[k.MACHINE=2]="MACHINE",k[k.WINDOW=3]="WINDOW",k[k.RESOURCE=4]="RESOURCE",k[k.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",k[k.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(n=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const v=R.Registry.as(I.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(P,c=!0){this.registerConfigurations([P],c)}registerConfigurations(P,c=!0){const h=[];P.forEach(o=>{h.push(...this.validateAndRegisterProperties(o,c,o.extensionInfo)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterConfigurations(P){const c=[],h=o=>{if(o.properties)for(const l in o.properties)c.push(l),delete this.configurationProperties[l],this.removeFromSchema(l,o.properties[l]);o.allOf&&o.allOf.forEach(l=>h(l))};for(const o of P){h(o);const l=this.configurationContributors.indexOf(o);l!==-1&&this.configurationContributors.splice(l,1)}v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}registerDefaultConfigurations(P){const c=[],h=[];for(const o of P)for(const l in o)if(c.push(l),e.OVERRIDE_PROPERTY_PATTERN.test(l)){this.defaultValues[l]=Object.assign(Object.assign({},this.defaultValues[l]||{}),o[l]);const t={type:"object",default:this.defaultValues[l],description:m.localize(1,null,l),$ref:e.resourceLanguageSettingsSchemaId};h.push(E(l)),this.configurationProperties[l]=t,this.defaultLanguageConfigurationOverridesNode.properties[l]=t}else{this.defaultValues[l]=o[l];const t=this.configurationProperties[l];t&&(this.updatePropertyDefaultValue(l,t),this.updateSchema(l,t))}this.registerOverrideIdentifiers(h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterDefaultConfigurations(P){const c=[];for(const h of P)for(const o in h)if(c.push(o),delete this.defaultValues[o],e.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const l=this.configurationProperties[o];l&&(this.updatePropertyDefaultValue(o,l),this.updateSchema(o,l))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}notifyConfigurationSchemaUpdated(...P){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(P){for(const c of P)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(P,c=!0,h,o=3){var l;o=S.isUndefinedOrNull(P.scope)?o:P.scope;let t=[],r=P.properties;if(r)for(let a in r){if(c&&d(a)){delete r[a];continue}const u=r[a];if(this.updatePropertyDefaultValue(a,u),e.OVERRIDE_PROPERTY_PATTERN.test(a)?u.scope=void 0:(u.scope=S.isUndefinedOrNull(u.scope)?o:u.scope,u.restricted=S.isUndefinedOrNull(u.restricted)?!!((l=h==null?void 0:h.restrictedConfigurations)===null||l===void 0?void 0:l.includes(a)):u.restricted),r[a].hasOwnProperty("included")&&!r[a].included){this.excludedConfigurationProperties[a]=r[a],delete r[a];continue}else this.configurationProperties[a]=r[a];!r[a].deprecationMessage&&r[a].markdownDeprecationMessage&&(r[a].deprecationMessage=r[a].markdownDeprecationMessage),t.push(a)}let s=P.allOf;if(s)for(let a of s)t.push(...this.validateAndRegisterProperties(a,c,h,o));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(P){const c=h=>{let o=h.properties;if(o)for(const t in o)this.updateSchema(t,o[t]);let l=h.allOf;l&&l.forEach(c)};c(P)}updateSchema(P,c){switch(e.allSettings.properties[P]=c,c.scope){case 1:e.applicationSettings.properties[P]=c;break;case 2:e.machineSettings.properties[P]=c;break;case 6:e.machineOverridableSettings.properties[P]=c;break;case 3:e.windowSettings.properties[P]=c;break;case 4:e.resourceSettings.properties[P]=c;break;case 5:e.resourceSettings.properties[P]=c,this.resourceLanguageSettingsSchema.properties[P]=c;break}}removeFromSchema(P,c){switch(delete e.allSettings.properties[P],c.scope){case 1:delete e.applicationSettings.properties[P];break;case 2:delete e.machineSettings.properties[P];break;case 6:delete e.machineOverridableSettings.properties[P];break;case 3:delete e.windowSettings.properties[P];break;case 4:case 5:delete e.resourceSettings.properties[P];break}}updateOverridePropertyPatternKey(){for(const P of this.overrideIdentifiers.values()){const c=`[${P}]`,h={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,h),e.allSettings.properties[c]=h,e.applicationSettings.properties[c]=h,e.machineSettings.properties[c]=h,e.machineOverridableSettings.properties[c]=h,e.windowSettings.properties[c]=h,e.resourceSettings.properties[c]=h}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(P,c){let h=this.defaultValues[P];S.isUndefined(h)&&(h=c.default),S.isUndefined(h)&&(h=M(c.type)),c.default=h}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function E(k){return k.substring(1,k.length-1)}e.overrideIdentifierFromKey=E;function M(k){switch(Array.isArray(k)?k[0]:k){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=M;const p=new y;R.Registry.add(e.Extensions.Configuration,p);function d(k){return k.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(k)?m.localize(5,null,k):p.getConfigurationProperties()[k]!==void 0?m.localize(6,null,k):null:m.localize(4,null)}e.validateProperty=d;function g(){const k=[],P=p.getConfigurationProperties();for(const c of Object.keys(P))k.push([c,P[c].scope]);return k.push(["launch",4]),k.push(["task",4]),k}e.getScopes=g}),define(Z[21],x([0,1,44,13,7,38,4,49]),function($,e,m,L,R,S,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=I.createDecorator("configurationService");function v(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof R.URI)}e.isConfigurationOverrides=v;var y;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(y=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function E(r,s){const a=s?r?s.keys.filter(q=>r.keys.indexOf(q)===-1):[...s.keys]:[],u=r?s?r.keys.filter(q=>s.keys.indexOf(q)===-1):[...r.keys]:[],w=[];if(s&&r){for(const q of r.keys)if(s.keys.indexOf(q)!==-1){const J=P(r.contents,q),te=P(s.contents,q);m.equals(J,te)||w.push(q)}}const f=[],b=q=>{const J={};for(const te of q)for(const B of te.identifiers)J[l(B)]=te;return J},A=s?b(s.overrides):{},U=r?b(r.overrides):{};if(Object.keys(A).length)for(const q of a){const J=A[q];J&&f.push([n.overrideIdentifierFromKey(q),J.keys])}if(Object.keys(U).length)for(const q of u){const J=U[q];J&&f.push([n.overrideIdentifierFromKey(q),J.keys])}if(Object.keys(A).length&&Object.keys(U).length)for(const q of w){const J=U[q],te=A[q];if(J&&te){const B=E({contents:J.contents,keys:J.keys,overrides:[]},{contents:te.contents,keys:te.keys,overrides:[]});f.push([n.overrideIdentifierFromKey(q),[...B.added,...B.removed,...B.updated]])}}return{added:a,removed:u,updated:w,overrides:f}}e.compare=E;function M(r,s){const a=[];for(const u of Object.keys(r))if(n.OVERRIDE_PROPERTY_PATTERN.test(u)){const w={};for(const f in r[u])w[f]=r[u][f];a.push({identifiers:[n.overrideIdentifierFromKey(u).trim()],keys:Object.keys(w),contents:p(w,s)})}return a}e.toOverrides=M;function p(r,s){const a=Object.create(null);for(let u in r)d(a,u,r[u],s);return a}e.toValuesTree=p;function d(r,s,a,u){const w=s.split("."),f=w.pop();let b=r;for(let A=0;A<w.length;A++){let U=w[A],q=b[U];switch(typeof q){case"undefined":q=b[U]=Object.create(null);break;case"object":break;default:u(`Ignoring ${s} as ${w.slice(0,A+1).join(".")} is ${JSON.stringify(q)}`);return}b=q}if(typeof b=="object"&&b!==null)try{b[f]=a}catch(A){u(`Ignoring ${s} as ${w.join(".")} is ${JSON.stringify(b)}`)}else u(`Ignoring ${s} as ${w.join(".")} is ${JSON.stringify(b)}`)}e.addToValueTree=d;function g(r,s){const a=s.split(".");k(r,a)}e.removeFromValueTree=g;function k(r,s){const a=s.shift();if(s.length===0){delete r[a];return}if(Object.keys(r).indexOf(a)!==-1){const u=r[a];typeof u=="object"&&!Array.isArray(u)&&(k(u,s),Object.keys(u).length===0&&delete r[a])}}function P(r,s,a){function u(b,A){let U=b;for(const q of A){if(typeof U!="object"||U===null)return;U=U[q]}return U}const w=s.split("."),f=u(r,w);return typeof f=="undefined"?a:f}e.getConfigurationValue=P;function c(r,s,a){Object.keys(s).forEach(u=>{u!=="__proto__"&&(u in r?L.isObject(r[u])&&L.isObject(s[u])?c(r[u],s[u],a):a&&(r[u]=s[u]):r[u]=s[u])})}e.merge=c;function h(){const r=S.Registry.as(n.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=h;function o(){const r=Object.create(null),s=S.Registry.as(n.Extensions.Configuration).getConfigurationProperties();for(let a in s){let u=s[a].default;d(r,a,u,w=>console.error(`Conflict in default settings: ${w}`))}return r}e.getDefaultValues=o;function l(r){return`[${r}]`}e.keyFromOverrideIdentifier=l;function t(r,s,a){const u=r.inspect(s),w=r.inspect(a);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof w.userValue!="undefined"||typeof w.workspaceValue!="undefined"||typeof w.workspaceFolderValue!="undefined"?w.value:u.defaultValue}e.getMigratedSettingValue=t}),define(Z[189],x([0,1,40,37,36,13,44,7,49,21,38,2,5]),function($,e,m,L,R,S,I,n,v,y,i,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(t={},r=[],s=[]){this._contents=t,this._keys=r,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?y.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,r){const s=this.getContentsForOverrideIdentifer(r);return s?t?y.getConfigurationValue(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let s={};for(const a of R.distinct([...Object.keys(this.contents),...Object.keys(r)])){let u=this.contents[a],w=r[a];w&&(typeof u=="object"&&typeof w=="object"?(u=I.deepClone(u),this.mergeContents(u,w)):u=w),s[a]=u}return new p(s,this.keys,this.overrides)}merge(...t){const r=I.deepClone(this.contents),s=I.deepClone(this.overrides),a=[...this.keys];for(const u of t){this.mergeContents(r,u.contents);for(const w of u.overrides){const[f]=s.filter(b=>R.equals(b.identifiers,w.identifiers));f?this.mergeContents(f.contents,w.contents):s.push(I.deepClone(w))}for(const w of u.keys)a.indexOf(w)===-1&&a.push(w)}return new p(r,a,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const s of Object.keys(r)){if(s in t&&S.isObject(t[s])&&S.isObject(r[s])){this.mergeContents(t[s],r[s]);continue}t[s]=I.deepClone(r[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?I.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),y.addToValueTree(this.contents,t,r,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&y.removeFromValueTree(this.contents,t)}addKey(t){let r=this.keys.length;for(let s=0;s<r;s++)t.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=p;class d extends p{constructor(){const t=y.getDefaultValues(),r=y.getConfigurationKeys(),s=[];for(const a of Object.keys(t))v.OVERRIDE_PROPERTY_PATTERN.test(a)&&s.push({identifiers:[v.overrideIdentifierFromKey(a).trim()],keys:Object.keys(t[a]),contents:y.toValuesTree(t[a],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,r,s)}}e.DefaultConfigurationModel=d;class g{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!S.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:s,keys:a,overrides:u,restricted:w}=this.doParseRaw(t,r);this._configurationModel=new p(s,a,u),this._restrictedConfigurations=w||[]}doParseContent(t){let r={},s=null,a=[],u=[],w=[];function f(A){Array.isArray(a)?a.push(A):s&&(a[s]=A)}let b={onObjectBegin:()=>{let A={};f(A),u.push(a),a=A,s=null},onObjectProperty:A=>{s=A},onObjectEnd:()=>{a=u.pop()},onArrayBegin:()=>{let A=[];f(A),u.push(a),a=A,s=null},onArrayEnd:()=>{a=u.pop()},onLiteralValue:f,onError:(A,U,q)=>{w.push({error:A,offset:U,length:q})}};if(t)try{m.visit(t,b),r=a[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return r}doParseRaw(t,r){const s=i.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),a=this.filter(t,s,!0,r);t=a.raw;const u=y.toValuesTree(t,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),w=Object.keys(t),f=y.toOverrides(t,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:u,keys:w,overrides:f,restricted:a.restricted}}filter(t,r,s,a){if(!(a==null?void 0:a.scopes)&&!(a==null?void 0:a.skipRestricted))return{raw:t,restricted:[]};const u={},w=[];for(let f in t)if(v.OVERRIDE_PROPERTY_PATTERN.test(f)&&s){const b=this.filter(t[f],r,!1,a);u[f]=b.raw,w.push(...b.restricted)}else{const b=r[f],A=b?typeof b.scope!="undefined"?b.scope:3:void 0;(b==null?void 0:b.restricted)&&w.push(f),(A===void 0||a.scopes===void 0||a.scopes.includes(A))&&(a.skipRestricted&&(b==null?void 0:b.restricted)||(u[f]=t[f]))}return{raw:u,restricted:w}}}e.ConfigurationModelParser=g;class k extends E.Disposable{constructor(t,r,s,a){super();this.userSettingsResource=t,this.scopes=r,this.fileService=a,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=k;class P{constructor(t,r,s=new p,a=new p,u=new L.ResourceMap,w=new p,f=new L.ResourceMap,b=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=a,this._folderConfigurations=u,this._memoryConfiguration=w,this._memoryConfigurationByResource=f,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,r,s){return this.getConsolidateConfigurationModel(r,s).getValue(t)}updateValue(t,r,s={}){let a;s.resource?(a=this._memoryConfigurationByResource.get(s.resource),a||(a=new p,this._memoryConfigurationByResource.set(s.resource,a))):a=this._memoryConfiguration,r===void 0?a.removeValue(t):a.setValue(t,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,s){const a=this.getConsolidateConfigurationModel(r,s),u=this.getFolderConfigurationModelForResource(r.resource,s),w=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,f=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),b=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),A=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),U=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),q=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,J=u?r.overrideIdentifier?u.freeze().override(r.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,te=r.overrideIdentifier?w.override(r.overrideIdentifier).getValue(t):w.getValue(t),B=a.getValue(t),Y=R.distinct(R.flatten(a.overrides.map(G=>G.identifiers))).filter(G=>a.getOverrideValue(t,G)!==void 0);return{defaultValue:f,userValue:b,userLocalValue:A,userRemoteValue:U,workspaceValue:q,workspaceFolderValue:J,memoryValue:te,value:B,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:A!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:q!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:J!==void 0?{value:u==null?void 0:u.freeze().getValue(t),override:r.overrideIdentifier?u==null?void 0:u.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:te!==void 0?{value:w.getValue(t),override:r.overrideIdentifier?w.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Y.length?Y:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const s=r.filter(a=>v.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const u=v.overrideIdentifierFromKey(a),w=this._defaultConfiguration.getKeysForOverrideIdentifier(u),f=t.getKeysForOverrideIdentifier(u),b=[...f.filter(A=>w.indexOf(A)===-1),...w.filter(A=>f.indexOf(A)===-1),...w.filter(A=>!I.equals(this._defaultConfiguration.override(u).getValue(A),t.override(u).getValue(A)))];return[u,b]});return this.updateDefaultConfiguration(t),{keys:r,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:s,removed:a,overrides:u}=y.compare(this.localUserConfiguration,t),w=[...r,...s,...a];return w.length&&this.updateLocalUserConfiguration(t),{keys:w,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:s,removed:a,overrides:u}=y.compare(this.remoteUserConfiguration,t);let w=[...r,...s,...a];return w.length&&this.updateRemoteUserConfiguration(t),{keys:w,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:s,removed:a,overrides:u}=y.compare(this.workspaceConfiguration,t);let w=[...r,...s,...a];return w.length&&this.updateWorkspaceConfiguration(t),{keys:w,overrides:u}}compareAndUpdateFolderConfiguration(t,r){const s=this.folderConfigurations.get(t),{added:a,updated:u,removed:w,overrides:f}=y.compare(s,r);let b=[...a,...u,...w];return(b.length||!s)&&this.updateFolderConfiguration(t,r),{keys:b,overrides:f}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:a,removed:u,overrides:w}=y.compare(r,void 0);return{keys:[...s,...a,...u],overrides:w}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const a=r.getFolder(t);a&&(s=this.getFolderConsolidatedConfiguration(a.uri)||s);const u=this._memoryConfigurationByResource.get(t);u&&(s=s.merge(u))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(r=s.merge(a),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=s}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const s=r.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:s,overrides:a,keys:u}=this._folderConfigurations.get(r);return t.push([r,{contents:s,overrides:a,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((w,f)=>(w.set(n.URI.revive(f[0]),this.parseConfigurationModel(f[1])),w),new L.ResourceMap);return new P(r,s,new p,a,u,new p,new L.ResourceMap,!1)}static parseConfigurationModel(t){return new p(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=P;function c(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const t=new Set,r=new Map;for(const a of l)a.keys.forEach(u=>t.add(u)),a.overrides.forEach(([u,w])=>{const f=L.getOrSet(r,u,new Set);w.forEach(b=>f.add(b))});const s=[];return r.forEach((a,u)=>s.push([u,[...a.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=c;class h{constructor(t,r,s,a){this.change=t,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=a,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(f=>u.add(f)),t.overrides.forEach(([,f])=>f.forEach(b=>u.add(b))),this.affectedKeys=[...u.values()];const w=new p;this.affectedKeys.forEach(f=>w.setValue(f,{})),this.affectedKeysTree=w.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=P.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const a=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,u=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!I.equals(a,u)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let s=y.toValuesTree({[r]:!0},()=>{}),a;for(;typeof s=="object"&&(a=Object.keys(s)[0]);){if(t=t[a],!t)return!1;s=s[a]}return!0}}e.ConfigurationChangeEvent=h;class o extends h{constructor(t,r,s,a){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=s,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=o}),define(Z[190],x([0,1,38,49,2,21,189,5,9,15]),function($,e,m,L,R,S,I,n,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends R.Disposable{constructor(M,p){super();this.settingsResource=M,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,y.extUriBiasedIgnorePathCase,p)),this.configuration=new I.Configuration(new I.DefaultConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(L.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const M=await this.userConfiguration.loadConfiguration();this.configuration=new I.Configuration(new I.DefaultConfigurationModel,M)}getConfigurationData(){return this.configuration.toData()}getValue(M,p){const d=typeof M=="string"?M:void 0,g=S.isConfigurationOverrides(M)?M:S.isConfigurationOverrides(p)?p:{};return this.configuration.getValue(d,g,void 0)}updateValue(M,p,d,g){return Promise.reject(new Error("not supported"))}inspect(M){return this.configuration.inspect(M,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const M=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(M)}onDidChangeUserConfiguration(M){const p=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(M);this.trigger(d,p,1)}onDidDefaultConfigurationChange(M){const p=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new I.DefaultConfigurationModel,M);this.trigger(d,p,6)}trigger(M,p,d){const g=new I.ConfigurationChangeEvent(M,{data:p},this.configuration);g.source=d,g.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(M){switch(M){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(Z[191],x([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=m.createDecorator("remoteAuthorityResolverService");var L;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends Error{constructor(I,n=L.Unknown,v){super(I);this._message=I,this._code=n,this._detail=v,this.isHandled=n===L.NotAvailable&&v===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(I){return I instanceof R&&I._code===L.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof R&&I._code===L.NoResolverFound}static isHandled(I){return I instanceof R&&I.isHandled}}e.RemoteAuthorityResolverError=R}),define(Z[192],x([0,1,85,27,2,17,5,191,16,9,25]),function($,e,m,L,R,S,I,n,v,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var M;(function(F){F[F.Management=1]="Management",F[F.ExtensionHost=2]="ExtensionHost",F[F.Tunnel=3]="Tunnel"})(M=e.ConnectionType||(e.ConnectionType={}));function p(F){switch(F){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(F){const T=new i.CancellationTokenSource;return setTimeout(()=>T.cancel(),F),T.token}function g(F,T){if(F.isCancellationRequested||T.isCancellationRequested)return i.CancellationToken.Cancelled;const _=new i.CancellationTokenSource;return F.onCancellationRequested(()=>_.cancel()),T.onCancellationRequested(()=>_.cancel()),_.token}class k{constructor(T){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((_,N)=>{this._resolvePromise=_,this._rejectPromise=N}),T.isCancellationRequested?this._timeout():this._disposables.add(T.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(T){this._state==="pending"?this._disposables.add(T):T.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const T=new Error("Time limit reached");return T.code="ETIMEDOUT",T.syscall="connect",T}resolve(T){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(T))}reject(T){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(T))}}function P(F,T){const _=new k(T);return _.registerDisposable(F.onControlMessage(N=>{const K=JSON.parse(N.toString()),V=X(K);V?_.reject(V):_.resolve(K)})),_.promise}function c(F,T,_,N,K,V){const Q=new k(V);return T.connect(_,N,K,(ne,se)=>{Q.didTimeout?(ne&&F.error(ne),se==null||se.dispose()):ne||!se?Q.reject(ne):Q.resolve(se)}),Q.promise}function h(F,T){const _=new k(T);return F.then(N=>{_.didTimeout||_.resolve(N)},N=>{_.didTimeout||_.reject(N)}),_.promise}async function o(F,T,_,N){const K=D(F,T);F.logService.trace(`${K} 1/6. invoking socketFactory.connect().`);let V;try{V=await c(F.logService,F.socketFactory,F.host,F.port,`reconnectionToken=${F.reconnectionToken}&reconnection=${F.reconnectionProtocol?"true":"false"}`,N)}catch(ae){throw F.logService.error(`${K} socketFactory.connect() failed or timed out. Error:`),F.logService.error(ae),ae}F.logService.trace(`${K} 2/6. socketFactory.connect() was successful.`);let Q,ne;F.reconnectionProtocol?(F.reconnectionProtocol.beginAcceptReconnection(V,null),Q=F.reconnectionProtocol,ne=!1):(Q=new m.PersistentProtocol(V,null),ne=!0),F.logService.trace(`${K} 3/6. sending AuthRequest control message.`);const se={type:"auth",auth:F.connectionToken||"00000000000000000000"};Q.sendControl(S.VSBuffer.fromString(JSON.stringify(se)));try{const ae=await P(Q,g(N,d(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const ue=new Error("Unexpected handshake message");throw ue.code="VSCODE_CONNECTION_ERROR",ue}F.logService.trace(`${K} 4/6. received SignRequest control message.`);const le=await h(F.signService.sign(ae.data),N),re={type:"connectionType",commit:F.commit,signedData:le,desiredConnectionType:T};return _&&(re.args=_),F.logService.trace(`${K} 5/6. sending ConnectionTypeRequest control message.`),Q.sendControl(S.VSBuffer.fromString(JSON.stringify(re))),{protocol:Q,ownsProtocol:ne}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(F.logService.error(`${K} the handshake timed out. Error:`),F.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(F.logService.error(`${K} received error control message when negotiating connection. Error:`),F.logService.error(ae)),ne&&z(Q),ae}}async function l(F,T,_,N){const K=Date.now(),V=D(F,T),{protocol:Q,ownsProtocol:ne}=await o(F,T,_,N),se=new k(N);return se.registerDisposable(Q.onControlMessage(ae=>{const le=JSON.parse(ae.toString()),re=X(le);re?(F.logService.error(`${V} received error control message when negotiating connection. Error:`),F.logService.error(re),ne&&z(Q),se.reject(re)):(F.reconnectionProtocol&&F.reconnectionProtocol.endAcceptReconnection(),F.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${O(K)}!`),se.resolve({protocol:Q,firstMessage:le}))})),se.promise}async function t(F,T){const{protocol:_}=await l(F,1,void 0,T);return{protocol:_}}async function r(F,T,_){const{protocol:N,firstMessage:K}=await l(F,2,T,_),V=K&&K.debugPort;return{protocol:N,debugPort:V}}async function s(F,T,_){const N=Date.now(),K=D(F,3),{protocol:V}=await o(F,3,T,_);return F.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${O(N)}!`),V}async function a(F,T,_){const{host:N,port:K,connectionToken:V}=await F.addressProvider.getAddress();return{commit:F.commit,host:N,port:K,connectionToken:V,reconnectionToken:T,reconnectionProtocol:_,socketFactory:F.socketFactory,signService:F.signService,logService:F.logService}}async function u(F,T,_){try{const N=L.generateUuid(),K=await a(F,N,null),{protocol:V}=await t(K,i.CancellationToken.None);return new G(F,T,_,N,V)}catch(N){throw F.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),F.logService.error(N),Y.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(N)),N}}e.connectRemoteAgentManagement=u;async function w(F,T){try{const _=L.generateUuid(),N=await a(F,_,null),{protocol:K,debugPort:V}=await r(N,T,i.CancellationToken.None);return new C(F,T,_,K,V)}catch(_){throw F.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),F.logService.error(_),Y.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(_)),_}}e.connectRemoteAgentExtensionHost=w;async function f(F,T){const _=await a(F,L.generateUuid(),null);return await s(_,{port:T},i.CancellationToken.None)}e.connectRemoteAgentTunnel=f;function b(F){return y.createCancelablePromise(T=>new Promise((_,N)=>{const K=setTimeout(_,F*1e3);T.onCancellationRequested(()=>{clearTimeout(K),_()})}))}var A;(function(F){F[F.ConnectionLost=0]="ConnectionLost",F[F.ReconnectionWait=1]="ReconnectionWait",F[F.ReconnectionRunning=2]="ReconnectionRunning",F[F.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",F[F.ConnectionGain=4]="ConnectionGain"})(A=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class U{constructor(T,_){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.type=0}}e.ConnectionLostEvent=U;class q{constructor(T,_,N,K){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.durationSeconds=N,this.cancellableTimer=K,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=q;class J{constructor(T,_,N){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.attempt=N,this.type=2}}e.ReconnectionRunningEvent=J;class te{constructor(T,_,N){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.attempt=N,this.type=4}}e.ConnectionGainEvent=te;class B{constructor(T,_,N,K){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.attempt=N,this.handled=K,this.type=3}}e.ReconnectionPermanentFailureEvent=B;class Y extends R.Disposable{constructor(T,_,N,K){super();this._connectionType=T,this._onDidStateChange=this._register(new I.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=_,this.reconnectionToken=N,this.protocol=K,this._isReconnecting=!1,this._onDidStateChange.fire(new te(this.reconnectionToken,0,0)),this._register(K.onSocketClose(V=>{const Q=W(this._connectionType,this.reconnectionToken,!0);V?V.type===0?(this._options.logService.info(`${Q} received socket close event (hadError: ${V.hadError}).`),V.error&&this._options.logService.error(V.error)):(this._options.logService.info(`${Q} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this._options.logService.error(V.event)):this._options.logService.info(`${Q} received socket close event.`),this._beginReconnecting()})),this._register(K.onSocketTimeout(()=>{const V=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${V} received socket timeout event.`),this._beginReconnecting()})),Y._instances.push(this),Y._permanentFailure&&this._gotoPermanentFailure(Y._permanentFailureMillisSinceLastIncomingData,Y._permanentFailureAttempt,Y._permanentFailureHandled)}static triggerPermanentFailure(T,_,N){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=T,this._permanentFailureAttempt=_,this._permanentFailureHandled=N,this._instances.forEach(K=>K._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(Y._permanentFailure)return;const T=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${T} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30];let N=-1;do{N++;const K=N<_.length?_[N]:_[_.length-1];try{if(K>0){const Q=b(K);this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K,Q)),this._options.logService.info(`${T} waiting for ${K} seconds before reconnecting...`);try{await Q}catch(ne){}}if(Y._permanentFailure){this._options.logService.error(`${T} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1)),this._options.logService.info(`${T} resolving connection...`);const V=await a(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${T} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,d(E)),this._options.logService.info(`${T} reconnected!`),this._onDidStateChange.fire(new te(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${T} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(N>360){this._options.logService.error(`${T} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(n.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${T} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${T} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(v.isPromiseCanceledError(V)){this._options.logService.info(`${T} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof n.RemoteAuthorityResolverError){this._options.logService.error(`${T} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,n.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${T} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}}while(!Y._permanentFailure)}_gotoPermanentFailure(T,_,N){this._onDidStateChange.fire(new B(this.reconnectionToken,T,_,N)),z(this.protocol)}}Y._permanentFailure=!1,Y._permanentFailureMillisSinceLastIncomingData=0,Y._permanentFailureAttempt=0,Y._permanentFailureHandled=!1,Y._instances=[];class G extends Y{constructor(T,_,N,K,V){super(1,T,K,V);this.client=this._register(new m.Client(V,{remoteAuthority:_,clientId:N},T.ipcLogger))}async _reconnect(T,_){await t(T,_)}}e.ManagementPersistentConnection=G;class C extends Y{constructor(T,_,N,K,V){super(2,T,N,K);this._startArguments=_,this.debugPort=V}async _reconnect(T,_){await r(T,this._startArguments,_)}}e.ExtensionHostPersistentConnection=C;function z(F){try{F.acceptDisconnect();const T=F.getSocket();F.dispose(),T.dispose()}catch(T){v.onUnexpectedError(T)}}function X(F){if(F&&F.type==="error"){const T=new Error(`Connection error: ${F.reason}`);return T.code="VSCODE_CONNECTION_ERROR",T}return null}function H(F,T){for(;F.length<T;)F+=" ";return F}function W(F,T,_){return`[remote-connection][${H(p(F),13)}][${T.substr(0,5)}\u2026][${_?"reconnect":"initial"}]`}function D(F,T){return`${W(T,F.reconnectionToken,!!F.reconnectionProtocol)}[${F.host}:${F.port}]`}function O(F){return`${Date.now()-F} ms`}}),define(Z[73],x([0,1,10]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(y){return y.scheme===m.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=L;function R(y){if(!y)return;const i=y.indexOf("+");return i<0?y:y.substr(0,i)}e.getRemoteName=R;function S(y){return y.scheme!==m.Schemas.file&&y.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=S;function I(y){if(y.folders.length)return y.folders.every(i=>S(i.uri))?y.folders[0].uri:void 0;if(y.configuration&&S(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=I;function n(y){var i;return(i=I(y))===null||i===void 0?void 0:i.scheme}e.getVirtualWorkspaceScheme=n;function v(y){return I(y)!==void 0}e.isVirtualWorkspace=v}),define(Z[74],x([0,1,5,3,4,6]),function($,e,m,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=R.createDecorator("tunnelService");var I;(function(p){p.Http="http",p.Https="https"})(I=e.TunnelProtocol||(e.TunnelProtocol={}));var n;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(n=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function v(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=v,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=y,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function i(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=i;function E(p,d){return d?d!==1&&p<1024:!L.isWindows&&p<1024}e.isPortPrivileged=E;let M=class{constructor(d){this.logService=d,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new m.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d,g){return this._tunnelProvider=d,d?(this._canElevate=g.elevation,this._canMakePublic=g.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async d=>{const g=[],k=Array.from(this._tunnels.values());for(let P of k){const c=Array.from(P.values());for(let h of c){const o=await h.value;o&&g.push(o)}}d(g)})}async dispose(){for(const d of this._tunnels.values()){for(const{value:g}of d.values())await g.then(k=>k==null?void 0:k.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,g,k,P,c=!1,h=!1,o){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${k} on local port ${P}.`),!d)return;g||(g="localhost");const l=this.retainOrCreateTunnel(d,g,k,P,c,h,o);return l?l.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,k);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(t);return(t.tunnelRemoteHost!==g||t.tunnelRemotePort!==k)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,public:d.public,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const g=this._tunnels.get(d.tunnelRemoteHost);if(g){const k=g.get(d.tunnelRemotePort);k&&(k.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,k))}}}}async tryDisposeTunnel(d,g,k){if(k.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${g}.`);const P=k.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(g),P}}async closeTunnel(d,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${g} `);const k=this._tunnels.get(d);if(k&&k.has(g)){const P=k.get(g);P.refcount=0,await this.tryDisposeTunnel(d,g,P)}}addTunnelToMap(d,g,k){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(g,{refcount:1,value:k})}async removeEmptyTunnelFromMap(d,g){const k=this._tunnels.get(d);k&&(await k.get(g)||k.delete(g),k.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,g){let k=[d];y(d)?(k.push(...e.LOCALHOST_ADDRESSES),k.push(...e.ALL_INTERFACES_ADDRESSES)):i(d)&&k.push(...e.ALL_INTERFACES_ADDRESSES);const P=k.map(c=>this._tunnels.get(c));for(const c of P){const h=c==null?void 0:c.get(g);if(h)return h}}canTunnel(d){return!!v(d)}createWithProvider(d,g,k,P,c,h,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${k} on local port ${P}.`);const t={elevationRequired:c?E(P===void 0?k:P):!1},r={remoteAddress:{host:g,port:k},localAddressPort:P,public:h,protocol:o},s=d.forwardPort(r,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),s&&this.addTunnelToMap(g,k,s),s}};M=he([ee(0,S.ILogService)],M),e.AbstractTunnelService=M}),define(Z[50],x([0,1,147,4,49,38,17]),function($,e,m,L,R,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=L.createDecorator("requestService");function n(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=n;function v(d){return d.res.statusCode===204}async function y(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);return v(d)?null:(await I.streamToBuffer(d.stream)).toString()}e.asText=y;async function i(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);if(v(d))return null;const k=(await I.streamToBuffer(d.stream)).toString();try{return JSON.parse(k)}catch(P){throw P.message+=`:
`+k,P}}e.asJson=i;function E(d){p(d)}e.updateProxyConfigurationsScope=E;let M;function p(d){const g=S.Registry.as(R.Extensions.Configuration);M&&g.deregisterConfigurations([M]),M={id:"http",order:15,title:m.localize(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:m.localize(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:m.localize(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:m.localize(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[m.localize(4,null),m.localize(5,null),m.localize(6,null),m.localize(7,null)],default:"override",description:m.localize(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:m.localize(9,null),restricted:!0}}},g.registerConfiguration(M)}p(2)}),define(Z[193],x([0,1,194,13]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function R(I,n){return I.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:I.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function S(I,n,v={}){const y=m.parse(I),i=v.proxyUrl||R(y,n);if(!i)return null;const E=m.parse(i);if(!/^https?:$/.test(E.protocol||""))return null;const M={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:L.isBoolean(v.strictSSL)?v.strictSSL:!0};return y.protocol==="http:"?new(await new Promise((p,d)=>{$(["http-proxy-agent"],p,d)}))(M):new(await new Promise((p,d)=>{$(["https-proxy-agent"],p,d)}))(M)}e.getProxyAgent=S}),define(Z[195],x([0,1,27,17]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(S,I,n){let v=n&&n.get("storage.serviceMachineId",0)||null;if(v)return v;try{const i=(await I.readFile(S.serviceMachineIdResource)).value.toString();v=m.isUUID(i)?i:null}catch(y){v=null}if(!v){v=m.generateUuid();try{await I.writeFile(S.serviceMachineIdResource,L.VSBuffer.fromString(v))}catch(y){}}return n&&n.store("storage.serviceMachineId",v,0,1),v}e.getServiceMachineId=R}),define(Z[75],x([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=m.createDecorator(e.SIGN_SERVICE_ID)}),define(Z[196],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{vsda(){return new Promise((R,S)=>$(["vsda"],R,S))}async sign(R){try{const S=await this.vsda(),I=new S.signer;if(I)return I.sign(R)}catch(S){}return R}}e.SignService=m}),define(Z[39],x([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=m.createDecorator("stateMainService")}),define(Z[22],x([0,1,14,6,39,5,4,178,3,2,9,13,33]),function($,e,m,L,R,S,I,n,v,y,i,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.UnloadReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=I.createDecorator("lifecycleMainService");var p;(function(k){k[k.CLOSE=1]="CLOSE",k[k.QUIT=2]="QUIT",k[k.RELOAD=3]="RELOAD",k[k.LOAD=4]="LOAD"})(p=e.UnloadReason||(e.UnloadReason={}));var d;(function(k){k[k.Starting=1]="Starting",k[k.Ready=2]="Ready",k[k.AfterWindowOpen=3]="AfterWindowOpen"})(d=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let g=class ct extends y.Disposable{constructor(P,c){super();this.logService=P,this.stateMainService=c,this._onBeforeShutdown=this._register(new S.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new S.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new S.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new S.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new S.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(ct.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(ct.QUIT_AND_RESTART_KEY)}registerListeners(){const P=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),v.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};m.app.addListener("before-quit",P);const c=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!v.isMacintosh)&&m.app.quit()};m.app.addListener("window-all-closed",c),m.app.once("will-quit",h=>{this.logService.trace("Lifecycle#app.on(will-quit)"),h.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),m.app.removeListener("before-quit",P),m.app.removeListener("window-all-closed",c),m.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const P=[];return this._onWillShutdown.fire({join(c){P.push(c)}}),this.pendingWillShutdownPromise=(async()=>{try{await i.Promises.settled(P)}catch(c){this.logService.error(c)}try{await this.stateMainService.close()}catch(c){this.logService.error(c)}})(),this.pendingWillShutdownPromise}set phase(P){if(P<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===P)return;this.logService.trace(`lifecycle (main): phase changed (value: ${P})`),this._phase=P;const c=this.phaseWhen.get(this._phase);c&&(c.open(),this.phaseWhen.delete(this._phase))}async when(P){if(P<=this._phase)return;let c=this.phaseWhen.get(P);c||(c=new i.Barrier,this.phaseWhen.set(P,c)),await c.wait()}registerWindow(P){const c=new y.DisposableStore;this.windowCounter++,c.add(P.onWillLoad(o=>this._onWillLoadWindow.fire({window:P,workspace:o.workspace})));const h=E.assertIsDefined(P.win);h.on("close",o=>{const l=P.id;if(this.windowToCloseRequest.has(l)){this.windowToCloseRequest.delete(l);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${P.id}`),o.preventDefault(),this.unload(P,1).then(t=>{if(t){this.windowToCloseRequest.delete(l);return}this.windowToCloseRequest.add(l),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${l}`),this._onBeforeCloseWindow.fire(P),P.close()})}),h.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${P.id}`),this.windowCounter--,c.dispose(),this.windowCounter===0&&(!v.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(P,c){await this.unload(P,3)||P.reload(c)}async unload(P,c){if(!P.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${P.id}`);const h=this._quitRequested?2:c;let o=await this.onBeforeUnloadWindowInRenderer(P,h);return o?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${P.id})`),this.handleWindowUnloadVeto(o)):(o=await this.onBeforeUnloadWindowInMain(P,h),o?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${P.id})`),this.handleWindowUnloadVeto(o)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${P.id})`),await this.onWillUnloadWindowInRenderer(P,h),!1))}handleWindowUnloadVeto(P){return P?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(P){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(P),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(P,c){return new Promise(h=>{const o=this.oneTimeListenerTokenGenerator++,l=`vscode:ok${o}`,t=`vscode:cancel${o}`;m.ipcMain.once(l,()=>{h(!1)}),m.ipcMain.once(t,()=>{h(!0)}),P.send("vscode:onBeforeUnload",{okChannel:l,cancelChannel:t,reason:c})})}onBeforeUnloadWindowInMain(P,c){const h=[];return this._onBeforeUnloadWindow.fire({reason:c,window:P,veto(o){h.push(o)}}),n.handleVetos(h,o=>this.logService.error(o))}onWillUnloadWindowInRenderer(P,c){return new Promise(h=>{const l=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;m.ipcMain.once(l,()=>h()),P.send("vscode:onWillUnload",{replyChannel:l,reason:c})})}quit(P){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${P}`),P&&this.stateMainService.setItem(ct.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(c=>{this.pendingQuitPromiseResolve=c,this.logService.trace("Lifecycle#quit() - calling app.quit()"),m.app.quit()}),this.pendingQuitPromise)}async relaunch(P){this.logService.trace("Lifecycle#relaunch()");const c=process.argv.slice(1);if((P==null?void 0:P.addArgs)&&c.push(...P.addArgs),P==null?void 0:P.removeArgs)for(const l of P.removeArgs){const t=c.indexOf(l);t>=0&&c.splice(t,1)}const h=()=>{try{if(v.isWindows){const l=M.cwd();l!==process.cwd()&&process.chdir(l)}}catch(l){this.logService.error(l)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),m.app.relaunch({args:c})};m.app.once("quit",h),await this.quit(!0)&&m.app.removeListener("quit",h)}async kill(P){this.logService.trace("Lifecycle#kill()"),await Promise.race([i.timeout(1e3),(async()=>{for(const c of m.BrowserWindow.getAllWindows())if(c&&!c.isDestroyed()){let h;c.webContents&&!c.webContents.isDestroyed()?h=new Promise(o=>c.once("closed",o)):h=Promise.resolve(),c.destroy(),await h}})()]),m.app.exit(P)}};g.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",g=he([ee(0,L.ILogService),ee(1,R.IStateMainService)],g),e.LifecycleMainService=g}),define(Z[197],x([0,1,4,5,2,22]),function($,e,m,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=m.createDecorator("keyboardLayoutMainService");let I=class extends R.Disposable{constructor(y){super();this._onDidChangeKeyboardLayout=this._register(new L.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,y.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const y=await new Promise((i,E)=>{$(["native-keymap"],i,E)});this._keyboardLayoutData=n(y),y.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(y),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};I=he([ee(0,S.ILifecycleMainService)],I),e.KeyboardLayoutMainService=I;function n(v){const y=v.getKeyMap(),i=v.getCurrentKeyboardLayout();return{keyboardMapping:y,keyboardLayoutInfo:i}}}),define(Z[97],x([0,1,4,5,2,13,87,9]),function($,e,m,L,R,S,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const v="__$__targetStorageMarker";e.IStorageService=m.createDecorator("storageService");var y;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var E;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(E=e.StorageTarget||(e.StorageTarget={}));class M extends R.Disposable{constructor(k={flushInterval:M.DEFAULT_FLUSH_INTERVAL}){super();this.options=k,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new n.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=n.runWhenIdle(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){R.dispose([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(k,P){P===v?(k===0?this._globalKeyTargets=void 0:k===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:k})):this._onDidChangeValue.fire({scope:k,key:P,target:this.getKeyTargets(k)[P]})}emitWillSaveState(k){this._onWillSaveState.fire({reason:k})}get(k,P,c){var h;return(h=this.getStorage(P))===null||h===void 0?void 0:h.get(k,c)}getBoolean(k,P,c){var h;return(h=this.getStorage(P))===null||h===void 0?void 0:h.getBoolean(k,c)}getNumber(k,P,c){var h;return(h=this.getStorage(P))===null||h===void 0?void 0:h.getNumber(k,c)}store(k,P,c,h){if(S.isUndefinedOrNull(P)){this.remove(k,c);return}this.withPausedEmitters(()=>{var o;this.updateKeyTarget(k,c,h),(o=this.getStorage(c))===null||o===void 0||o.set(k,P)})}remove(k,P){this.withPausedEmitters(()=>{var c;this.updateKeyTarget(k,P,void 0),(c=this.getStorage(P))===null||c===void 0||c.delete(k)})}withPausedEmitters(k){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{k()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(k,P){const c=[],h=this.getKeyTargets(k);for(const o of Object.keys(h))h[o]===P&&c.push(o);return c}updateKeyTarget(k,P,c){var h,o;const l=this.getKeyTargets(P);typeof c=="number"?l[k]!==c&&(l[k]=c,(h=this.getStorage(P))===null||h===void 0||h.set(v,JSON.stringify(l))):typeof l[k]=="number"&&(delete l[k],(o=this.getStorage(P))===null||o===void 0||o.set(v,JSON.stringify(l)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(k){return k===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(k){const P=this.get(v,k);if(P)try{return JSON.parse(P)}catch(c){}return Object.create(null)}isNew(k){return this.getBoolean(e.IS_NEW_KEY,k)===!0}async flush(){var k,P,c,h;this._onWillSaveState.fire({reason:y.NONE}),await n.Promises.settled([(P=(k=this.getStorage(0))===null||k===void 0?void 0:k.whenFlushed())!==null&&P!==void 0?P:Promise.resolve(),(h=(c=this.getStorage(1))===null||c===void 0?void 0:c.whenFlushed())!==null&&h!==void 0?h:Promise.resolve()])}async logStorage(){var k,P,c,h,o,l;const t=(P=(k=this.getStorage(0))===null||k===void 0?void 0:k.items)!==null&&P!==void 0?P:new Map,r=(h=(c=this.getStorage(1))===null||c===void 0?void 0:c.items)!==null&&h!==void 0?h:new Map;return d(t,r,(o=this.getLogDetails(0))!==null&&o!==void 0?o:"",(l=this.getLogDetails(1))!==null&&l!==void 0?l:"")}}e.AbstractStorageService=M,M.DEFAULT_FLUSH_INTERVAL=60*1e3;class p extends M{constructor(){super();this.globalStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(k=>this.emitDidChangeValue(1,k))),this._register(this.globalStorage.onDidChangeStorage(k=>this.emitDidChangeValue(0,k)))}getStorage(k){return k===0?this.globalStorage:this.workspaceStorage}getLogDetails(k){return k===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(k){}}e.InMemoryStorageService=p;async function d(g,k,P,c){const h=u=>{try{return JSON.parse(u)}catch(w){return u}},o=new Map,l=new Map;g.forEach((u,w)=>{o.set(w,u),l.set(w,h(u))});const t=new Map,r=new Map;k.forEach((u,w)=>{t.set(w,u),r.set(w,h(u))}),console.group(`Storage: Global (path: ${P})`);let s=[];o.forEach((u,w)=>{s.push({key:w,value:u})}),console.table(s),console.groupEnd(),console.log(l),console.group(`Storage: Workspace (path: ${c})`);let a=[];t.forEach((u,w)=>{a.push({key:w,value:u})}),console.table(a),console.groupEnd(),console.log(r)}e.logStorage=d}),define(Z[198],x([0,1,3,33,27,7]),function($,e,m,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function I(y){if(m.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}async function n(y,i,E,M,p,d,g,k,P,c){const h=Object.create(null);h["common.machineId"]=g,h.sessionID=R.generateUuid()+Date.now(),h.commitHash=p,h.version=d,h["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=m.PlatformToString(m.platform),h["common.nodePlatform"]=L.platform,h["common.nodeArch"]=M,h["common.product"]=c||"desktop";const o=v(k||[]);o&&(h["common.msftInternal"]=o);let l=0;const t=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),m.isLinuxSnap&&(h["common.snap"]="true");const r=I(E);r&&(h["common.platformDetail"]=r);try{const s=await y.readFile(S.URI.file(P));h["common.source"]=s.value.toString().slice(0,30)}catch(s){}return h}e.resolveCommonProperties=n;function v(y){const i=L.env.USERDNSDOMAIN;if(!i)return!1;const E=i.toLowerCase();return y.some(M=>E===M)}e.verifyMicrosoftInternalDomain=v}),define(Z[32],x([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=m.createDecorator("telemetryService"),e.ICustomEndpointTelemetryService=m.createDecorator("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Z[199],x([0,1,26,66,70,8,40,84,20,3,7,32,63,10,19,18]),function($,e,m,L,R,S,I,n,v,y,i,E,M,p,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function k(l,t){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],s=new Map,a=new Map,u=2e4;function w(A,U,q,J){const te=U.substring(A.length+1);return new Promise(async B=>{var Y,G,C;let z;try{z=await g.Promises.readdir(U,{withFileTypes:!0})}catch(W){B();return}if(J.count>=u){J.count+=z.length,J.maxReached=!0,B();return}let X=z.length;if(X===0){B();return}let H=z;J.count+z.length>u&&(J.maxReached=!0,X=u-J.count,H=z.slice(0,X)),J.count+=z.length;for(const W of H)if(W.isDirectory()){if(q.includes(W.name)||await w(A,S.join(U,W.name),q,J),--X==0){B();return}}else{const D=W.name.lastIndexOf(".");if(D>=0){const O=W.name.substring(D+1);O&&s.set(O,((Y=s.get(O))!==null&&Y!==void 0?Y:0)+1)}for(const O of r)((G=O.relativePathPattern)===null||G===void 0?void 0:G.test(te))!==!1&&O.filePattern.test(W.name)&&a.set(O.tag,((C=a.get(O.tag))!==null&&C!==void 0?C:0)+1);if(--X==0){B();return}}})}const f={count:0,maxReached:!1};await w(l,l,t,f);const b=await h(l);return{configFiles:P(a),fileTypes:P(s),fileCount:f.count,maxFilesReached:f.maxReached,launchConfigFiles:b}}e.collectWorkspaceStats=k;function P(l){return[...M.Iterable.map(l.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function c(){const l={os:`${m.type()} ${m.arch()} ${m.release()}`,memory:`${(m.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(L.virtualMachineHint.value()*100)}%`},t=m.cpus();return t&&t.length>0&&(l.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),l}e.getMachineInfo=c;async function h(l){try{const t=new Map,r=S.join(l,".vscode","launch.json"),s=await g.Promises.readFile(r),a=[],u=I.parse(s.toString(),a);if(a.length)return console.log(`Unable to parse ${r}`),[];if(I.getNodeType(u)==="object"&&u.configurations)for(const w of u.configurations){const f=w.type;f&&(t.has(f)?t.set(f,t.get(f)+1):t.set(f,1))}return P(t)}catch(t){return[]}}e.collectLaunchConfigs=h;let o=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${m.type()} ${m.arch()} ${m.release()}`);const s=m.cpus();return s&&s.length>0&&r.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),r.push(`Memory (System):  ${(m.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),y.isWindows||r.push(`Load (avg):       ${m.loadavg().map(a=>Math.round(a)).join(", ")}`),r.push(`VM:               ${Math.round(L.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([n.listProcesses(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async s=>{let[a,u]=s,w=this.formatProcessList(t,a);return r.forEach(f=>{if(R.isRemoteDiagnosticError(f))w+=`
${f.errorMessage}`,u+=`
${f.errorMessage}`;else if(w+=`

Remote: ${f.hostName}`,f.processes&&(w+=`
${this.formatProcessList(t,f.processes)}`),f.workspaceMetadata){u+=`
|  Remote: ${f.hostName}`;for(const b of Object.keys(f.workspaceMetadata)){const A=f.workspaceMetadata[b];let U=`${A.fileCount} files`;A.maxFilesReached&&(U=`more than ${U}`),u+=`|    Folder (${b}): ${U}`,u+=this.formatWorkspaceStats(A)}}}),{processInfo:w,workspaceInfo:u}})}async getSystemInfo(t,r){const{memory:s,vmHint:a,os:u,cpus:w}=c(),f={os:u,memory:s,cpus:w,vmHint:a,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return y.isWindows||(f.load=`${m.loadavg().map(b=>Math.round(b)).join(", ")}`),y.isLinux&&(f.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(f)}async getDiagnostics(t,r){const s=[];return n.listProcesses(t.mainPID).then(async a=>(s.push(""),s.push(this.formatEnvironment(t)),s.push(""),s.push(this.formatProcessList(t,a)),t.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(t))),r.forEach(u=>{if(R.isRemoteDiagnosticError(u))s.push(`
${u.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${u.hostName}`),s.push(this.formatMachineInfo(u.machineInfo)),u.processes&&s.push(this.formatProcessList(t,u.processes)),u.workspaceMetadata)for(const w of Object.keys(u.workspaceMetadata)){const f=u.workspaceMetadata[w];let b=`${f.fileCount} files`;f.maxFilesReached&&(b=`more than ${b}`),s.push(`Folder (${w}): ${b}`),s.push(this.formatWorkspaceStats(f))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(t){const r=[],s=60;let a=0;const u=(A,U)=>{const q=` ${A}(${U})`;a+q.length>s?(r.push(w),w="|                 ",a=w.length):a+=q.length,w+=q};let w="|      File types:";const f=10;let b=t.fileTypes.length>f?f:t.fileTypes.length;for(let A=0;A<b;A++){const U=t.fileTypes[A];u(U.name,U.count)}if(r.push(w),t.configFiles.length>=0&&(w="|      Conf files:",a=0,t.configFiles.forEach(A=>{u(A.name,A.count)}),r.push(w)),t.launchConfigFiles.length>0){let A="|      Launch Configs:";t.launchConfigFiles.forEach(U=>{A+=U.count>1?` ${U.name}(${U.count})`:` ${U.name}`}),r.push(A)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(s=>s.length));return Object.keys(t).map(s=>`${s}:  ${" ".repeat(r-s.length)}  ${t[s]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],s=[];return t.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(r.push(`|  Window (${a.title})`),a.folderURIs.forEach(u=>{const w=i.URI.revive(u);if(w.scheme===p.Schemas.file){const f=w.fsPath;s.push(k(f,["node_modules",".git"]).then(b=>{let A=`${b.fileCount} files`;b.maxFilesReached&&(A=`more than ${A}`),r.push(`|    Folder (${S.basename(f)}): ${A}`),r.push(this.formatWorkspaceStats(b))}).catch(b=>{r.push(`|      Error: Unable to collect workspace stats for folder ${f} (${b.toString()})`)}))}else r.push(`|    Folder (${w.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(a=>r.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(t,r){const s=new Map;t.windows.forEach(u=>s.set(u.pid,u.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,s,a,r,0),a.join(`
`)}formatProcessItem(t,r,s,a,u){const w=u===0;let f;w?f=a.pid===t?`${this.productService.applicationName} main`:"remote agent":(f=`${"  ".repeat(u)} ${a.name}`,a.name==="window"&&(f=`${f} (${r.get(a.pid)})`));const b=process.platform==="win32"?a.mem:m.totalmem()*(a.mem/100);s.push(`${a.load.toFixed(0).padStart(5," ")}	${(b/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${f}`),Array.isArray(a.children)&&a.children.forEach(A=>this.formatProcessItem(t,r,s,A,u+1))}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const s=i.URI.revive(r);if(s.scheme!==p.Schemas.file)continue;const a=s.fsPath;try{const u=await k(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),u.fileTypes.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:w.name,count:w.count})}),u.launchConfigFiles.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:w.name,count:w.count})}),u.configFiles.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:w.name,count:w.count})})}catch(u){}}}};o=he([ee(0,E.ITelemetryService),ee(1,v.IProductService)],o),e.DiagnosticsService=o}),define(Z[200],x([0,1,16,169,172,44,32,50,163,47,25,6,19,7,20,97,195,4,15]),function($,e,m,L,R,S,I,n,v,y,i,E,M,p,d,g,k,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var h;(function(W){W[W.None=0]="None",W[W.IncludeVersions=1]="IncludeVersions",W[W.IncludeFiles=2]="IncludeFiles",W[W.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",W[W.IncludeSharedAccounts=8]="IncludeSharedAccounts",W[W.IncludeVersionProperties=16]="IncludeVersionProperties",W[W.ExcludeNonValidated=32]="ExcludeNonValidated",W[W.IncludeInstallationTargets=64]="IncludeInstallationTargets",W[W.IncludeAssetUri=128]="IncludeAssetUri",W[W.IncludeStatistics=256]="IncludeStatistics",W[W.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",W[W.Unpublished=4096]="Unpublished"})(h||(h={}));function o(...W){return String(W.reduce((D,O)=>D|O,0))}var l;(function(W){W[W.Tag=1]="Tag",W[W.ExtensionId=4]="ExtensionId",W[W.Category=5]="Category",W[W.ExtensionName=7]="ExtensionName",W[W.Target=8]="Target",W[W.Featured=9]="Featured",W[W.SearchText=10]="SearchText",W[W.ExcludeWithFlags=12]="ExcludeWithFlags"})(l||(l={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:h.None,criteria:[],assetTypes:[]};class u{constructor(D=a){this.state=D}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(D,O=this.state.pageSize){return new u(Object.assign(Object.assign({},this.state),{pageNumber:D,pageSize:O}))}withFilter(D,...O){const F=[...this.state.criteria,...O.length?O.map(T=>({filterType:D,value:T})):[{filterType:D}]];return new u(Object.assign(Object.assign({},this.state),{criteria:F}))}withSortBy(D){return new u(Object.assign(Object.assign({},this.state),{sortBy:D}))}withSortOrder(D){return new u(Object.assign(Object.assign({},this.state),{sortOrder:D}))}withFlags(...D){return new u(Object.assign(Object.assign({},this.state),{flags:D.reduce((O,F)=>O|F,0)}))}withAssetTypes(...D){return new u(Object.assign(Object.assign({},this.state),{assetTypes:D}))}get raw(){const{criteria:D,pageNumber:O,pageSize:F,sortBy:T,sortOrder:_,flags:N,assetTypes:K}=this.state;return{filters:[{criteria:D,pageNumber:O,pageSize:F,sortBy:T,sortOrder:_}],assetTypes:K,flags:N}}get searchText(){const D=this.state.criteria.filter(O=>O.filterType===l.SearchText)[0];return D&&D.value?D.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(D=>String(D.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function w(W,D){const O=(W||[]).filter(F=>F.statisticName===D)[0];return O?O.value:0}function f(W){const D="Microsoft.VisualStudio.Code.Translation.";return W.files.filter(F=>F.assetType.indexOf(D)===0).reduce((F,T)=>{const _=q(W,T.assetType);return _&&F.push([T.assetType.substring(D.length),_]),F},[])}function b(W){if(W.properties){const D=W.properties.filter(T=>T.key===t.Repository),O=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=D.filter(T=>O.test(T.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return q(W,t.Repository)}function A(W){return{uri:`${W.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${W.fallbackAssetUri}/${t.VSIX}`}}function U(W){const D=q(W,t.Icon);if(D)return D;const O=L.DefaultIconPath;return{uri:O,fallbackUri:O}}function q(W,D){return W.files.filter(F=>F.assetType===D)[0]?{uri:`${W.assetUri}/${D}`,fallbackUri:`${W.fallbackAssetUri}/${D}`}:null}function J(W,D){const O=W.properties?W.properties.filter(T=>T.key===D):[],F=O.length>0&&O[0].value;return F?F.split(",").map(T=>R.adoptToGalleryExtensionId(T)):[]}function te(W){const D=W.properties?W.properties.filter(O=>O.key===r.Engine):[];return D.length>0&&D[0].value||""}function B(W){const D=W.properties?W.properties.filter(F=>F.key===r.LocalizedLanguages):[],O=D.length>0&&D[0].value||"";return O?O.split(","):[]}function Y(W){return W.indexOf("preview")!==-1}function G(W){const D=W.properties?W.properties.find(O=>O.key===r.WebExtension):void 0;return!!D&&D.value==="true"}function C(W){return W.files.some(D=>D.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?c.joinPath(p.URI.parse(W.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function z(W,D,O,F,T){const _={manifest:q(D,t.Manifest),readme:q(D,t.Details),changelog:q(D,t.Changelog),license:q(D,t.License),repository:b(D),download:A(D),icon:U(D),coreTranslations:f(D)};return{identifier:{id:R.getGalleryExtensionId(W.publisher.publisherName,W.extensionName),uuid:W.extensionId},name:W.extensionName,version:D.version,date:D.lastUpdated,displayName:W.displayName,publisherId:W.publisher.publisherId,publisher:W.publisher.publisherName,publisherDisplayName:W.publisher.displayName,description:W.shortDescription||"",installCount:w(W.statistics,"install"),rating:w(W.statistics,"averagerating"),ratingCount:w(W.statistics,"ratingcount"),assetUri:p.URI.parse(D.assetUri),webResource:C(D),assetTypes:D.files.map(({assetType:N})=>N),assets:_,properties:{dependencies:J(D,r.Dependency),extensionPack:J(D,r.ExtensionPack),engine:te(D),localizedLanguages:B(D),webExtension:G(D)},telemetryData:{index:(F.pageNumber-1)*F.pageSize+O,querySource:T},preview:Y(W.flags)}}let X=class{constructor(D,O,F,T,_,N,K){this.requestService=D,this.logService=O,this.environmentService=F,this.telemetryService=T,this.fileService=_,this.productService=N;const V=N.extensionsGallery;this.extensionsGalleryUrl=V&&V.serviceUrl,this.extensionsControlUrl=V&&V.controlUrl,this.commonHeadersPromise=H(N.version,this.environmentService,this.fileService,K)}api(D=""){return`${this.extensionsGalleryUrl}${D}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(D,O){const F=[];let{total:T,firstPage:_,getPage:N}=await this.query({names:D,pageSize:D.length},O);F.push(..._);for(let K=1;F.length<T&&(_=await N(K,O),_.length);K++)F.push(..._);return F}async getCompatibleExtension(D,O){const F=await this.getCompatibleExtensionByEngine(D,O);return(F==null?void 0:F.properties.webExtension)?F.webResource?F:null:F}async getCompatibleExtensionByEngine(D,O){const F=L.isIExtensionIdentifier(D)?null:D;if(F&&F.properties.engine&&v.isEngineValid(F.properties.engine,this.productService.version,this.productService.date))return F;const{id:T,uuid:_}=F?F.identifier:D;let N=new u().withFlags(h.IncludeAssetUri,h.IncludeStatistics,h.IncludeFiles,h.IncludeVersionProperties).withPage(1,1).withFilter(l.Target,"Microsoft.VisualStudio.Code");_?N=N.withFilter(l.ExtensionId,_):N=N.withFilter(l.ExtensionName,T);const{galleryExtensions:K}=await this.queryGallery(N,i.CancellationToken.None),[V]=K;if(!V||!V.versions.length)return null;if(O){const ne=V.versions.filter(se=>se.version===O)[0];if(ne){const se=z(V,ne,0,N);if(se.properties.engine&&v.isEngineValid(se.properties.engine,this.productService.version,this.productService.date))return se}return null}const Q=await this.getLastValidExtensionVersion(V,V.versions);return Q?z(V,Q,0,N):null}async query(D,O){const F=i.CancellationToken.isCancellationToken(D)?{}:D,T=i.CancellationToken.isCancellationToken(D)?D:O;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let _=F.text||"";const N=S.getOrDefault(F,ae=>ae.pageSize,50);let K=new u().withFlags(h.IncludeLatestVersionOnly,h.IncludeAssetUri,h.IncludeStatistics,h.IncludeFiles,h.IncludeVersionProperties).withPage(1,N).withFilter(l.Target,"Microsoft.VisualStudio.Code");_?(_=_.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ae,le,re)=>(K=K.withFilter(l.Category,re||le),"")),_=_.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ae,le,re)=>(K=K.withFilter(l.Tag,re||le),"")),_=_.replace(/\bfeatured(\s+|\b|$)/g,()=>(K=K.withFilter(l.Featured),"")),_=_.trim(),_&&(_=_.length<200?_:_.substring(0,200),K=K.withFilter(l.SearchText,_)),K=K.withSortBy(0)):F.ids?K=K.withFilter(l.ExtensionId,...F.ids):F.names?K=K.withFilter(l.ExtensionName,...F.names):K=K.withSortBy(4),typeof F.sortBy=="number"&&(K=K.withSortBy(F.sortBy)),typeof F.sortOrder=="number"&&(K=K.withSortOrder(F.sortOrder));const{galleryExtensions:V,total:Q}=await this.queryGallery(K,T),ne=V.map((ae,le)=>z(ae,ae.versions[0],le,K,F.source)),se=async(ae,le)=>{if(le.isCancellationRequested)throw m.canceled();const re=K.withPage(ae+1),{galleryExtensions:ue}=await this.queryGallery(re,le);return ue.map((Ee,we)=>z(Ee,Ee.versions[0],we,re,F.source))};return{firstPage:ne,total:Q,pageSize:K.pageSize,getPage:se}}async queryGallery(D,O){if(!this.isEnabled())throw new Error("No extension gallery service configured.");D=D.withFlags(D.flags,h.ExcludeNonValidated).withFilter(l.ExcludeWithFlags,o(h.Unpublished));const F=await this.commonHeadersPromise,T=JSON.stringify(D.raw),_=Object.assign(Object.assign({},F),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(T.length)}),N=new Date().getTime();let K,V,Q=0;try{if(K=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:T,headers:_},O),K.res.statusCode&&K.res.statusCode>=400&&K.res.statusCode<500)return{galleryExtensions:[],total:Q};const ne=await n.asJson(K);if(ne){const se=ne.results[0],ae=se.extensions,le=se.resultMetadata&&se.resultMetadata.filter(re=>re.metadataType==="ResultCount")[0];return Q=le&&le.metadataItems.filter(re=>re.name==="TotalCount")[0].count||0,{galleryExtensions:ae,total:Q}}return{galleryExtensions:[],total:Q}}catch(ne){throw V=ne,ne}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},D.telemetryData),{requestBodySize:String(T.length),duration:new Date().getTime()-N,success:!!K&&n.isSuccess(K),responseBodySize:K==null?void 0:K.res.headers["Content-Length"],statusCode:K?String(K.res.statusCode):void 0,errorCode:V?m.isPromiseCanceledError(V)?"canceled":m.getErrorMessage(V).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Q)}))}}async reportStatistic(D,O,F,T){if(!this.isEnabled())return;const _=await this.commonHeadersPromise,N=Object.assign(Object.assign({},_),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${D}/extensions/${O}/${F}/stats?statType=${T}`),headers:N},i.CancellationToken.None)}catch(K){}}async download(D,O,F){this.logService.trace("ExtensionGalleryService#download",D.identifier.id);const T=R.getGalleryExtensionTelemetryData(D),_=new Date().getTime(),N=ne=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},T),{duration:ne})),K=F===1?"install":F===2?"update":"",V=K?{uri:`${D.assets.download.uri}&${K}=true`,fallbackUri:`${D.assets.download.fallbackUri}?${K}=true`}:D.assets.download,Q=await this.getAsset(V);await this.fileService.writeFile(O,Q.stream),N(new Date().getTime()-_)}async getReadme(D,O){if(D.assets.readme){const F=await this.getAsset(D.assets.readme,{},O);return await n.asText(F)||""}return""}async getManifest(D,O){if(D.assets.manifest){const F=await this.getAsset(D.assets.manifest,{},O),T=await n.asText(F);return T?JSON.parse(T):null}return null}async getCoreTranslation(D,O){const F=D.assets.coreTranslations.filter(T=>T[0]===O.toUpperCase())[0];if(F){const T=await this.getAsset(F[1]),_=await n.asText(T);return _?JSON.parse(_):null}return null}async getChangelog(D,O){if(D.assets.changelog){const F=await this.getAsset(D.assets.changelog,{},O);return await n.asText(F)||""}return""}async getAllVersions(D,O){let F=new u().withFlags(h.IncludeVersions,h.IncludeFiles,h.IncludeVersionProperties).withPage(1,1).withFilter(l.Target,"Microsoft.VisualStudio.Code");D.identifier.uuid?F=F.withFilter(l.ExtensionId,D.identifier.uuid):F=F.withFilter(l.ExtensionName,D.identifier.id);const T=[],{galleryExtensions:_}=await this.queryGallery(F,i.CancellationToken.None);return _.length&&(O?await Promise.all(_[0].versions.map(async N=>{let K;try{K=await this.getEngine(N)}catch(V){}K&&v.isEngineValid(K,this.productService.version,this.productService.date)&&T.push({version:N.version,date:N.lastUpdated})})):T.push(..._[0].versions.map(N=>({version:N.version,date:N.lastUpdated})))),T}async getAsset(D,O={},F=i.CancellationToken.None){const T=await this.commonHeadersPromise,_={type:"GET"},N=Object.assign(Object.assign({},T),O.headers||{});O=Object.assign(Object.assign(Object.assign({},O),_),{headers:N});const K=D.uri,V=D.fallbackUri,Q=Object.assign(Object.assign({},O),{url:K});try{const ne=await this.requestService.request(Q,F);if(ne.res.statusCode===200)return ne;const se=await n.asText(ne);throw new Error(`Expected 200, got back ${ne.res.statusCode} instead.

${se}`)}catch(ne){if(m.isPromiseCanceledError(ne))throw ne;const se=m.getErrorMessage(ne);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:K,message:se});const ae=Object.assign(Object.assign({},O),{url:V});return this.requestService.request(ae,F)}}async getLastValidExtensionVersion(D,O){const F=this.getLastValidExtensionVersionFromProperties(D,O);return F||this.getLastValidExtensionVersionRecursively(D,O)}getLastValidExtensionVersionFromProperties(D,O){for(const F of O){const T=te(F);if(!T)return null;if(v.isEngineValid(T,this.productService.version,this.productService.date))return F}return null}async getEngine(D){const O=te(D);if(O)return O;const F=q(D,t.Manifest);if(!F)throw new Error("Manifest was not found");const T={"Accept-Encoding":"gzip"},_=await this.getAsset(F,{headers:T}),N=await n.asJson(_);if(N)return N.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(D,O){if(!O.length)return null;const F=O[0],T=await this.getEngine(F);return v.isEngineValid(T,this.productService.version,this.productService.date)?Object.assign(Object.assign({},F),{properties:[...F.properties||[],{key:r.Engine,value:T}]}):this.getLastValidExtensionVersionRecursively(D,O.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const D=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},i.CancellationToken.None);if(D.res.statusCode!==200)throw new Error("Could not get extensions report.");const O=await n.asJson(D),F=new Map;if(O)for(const T of O.malicious){const _=F.get(T)||{id:{id:T},malicious:!0,slow:!1};_.malicious=!0,F.set(T,_)}return[...F.values()]}};X=he([ee(0,n.IRequestService),ee(1,E.ILogService),ee(2,y.IEnvironmentService),ee(3,I.ITelemetryService),ee(4,M.IFileService),ee(5,d.IProductService),ee(6,P.optional(g.IStorageService))],X),e.ExtensionGalleryService=X;async function H(W,D,O,F){const T={"X-Market-Client-Id":`VSCode ${W}`,"User-Agent":`VSCode ${W}`},_=await k.getServiceMachineId(D,O,F);return T["X-Market-User-Id"]=_,T}e.resolveMarketplaceHeaders=H}),define(Z[201],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class m{constructor(S){this.appender=S}listen(S,I){throw new Error(`Event not found: ${I}`)}call(S,I,{eventName:n,data:v}){return this.appender.log(n,v),Promise.resolve(null)}}e.TelemetryAppenderChannel=m;class L{constructor(S){this.channel=S}log(S,I){return this.channel.call("log",{eventName:S,data:I}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(Z[202],x([0,1,48,148,23,4,21,49,2,44,38]),function($,e,m,L,R,S,I,n,v,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let E=class{constructor(d,g){this._configurationService=g,this._experimentProperties={},this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appender=d.appender,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let k of this._piiPaths)this._cleanupPatterns.push(new RegExp(R.escapeRegExpCharacters(k),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(k=>{const P=/^[a-f0-9]+$/i.test(k["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!P})}))}setExperimentProperty(d,g){this._experimentProperties[d]=g}setEnabled(d){this._enabled=d}_updateUserOptIn(){var d;const g=(d=this._configurationService)===null||d===void 0?void 0:d.getValue(M);this._userOptIn=g?g.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const d=await this._commonProperties;let g=d.sessionID,k=d["common.instanceId"],P=d["common.machineId"],c=d["common.firstSessionDate"],h=d["common.msftInternal"];return{sessionId:g,instanceId:k,machineId:P,firstSessionDate:c,msftInternal:h}}dispose(){this._disposables.dispose()}publicLog(d,g,k){return this.isOptedIn?this._commonProperties.then(P=>{g=y.mixin(g,P),g=y.mixin(g,this._experimentProperties),g=y.cloneAndChange(g,c=>{if(typeof c=="string")return this._cleanupInfo(c,k)}),this._appender.log(d,g)},P=>{console.error(P)}):Promise.resolve(void 0)}publicLog2(d,g,k){return this.publicLog(d,g,k)}publicLogError(d,g){return this.sendErrorTelemetry?this.publicLog(d,g,!0):Promise.resolve(void 0)}publicLogError2(d,g){return this.publicLogError(d,g)}_cleanupInfo(d,g){let k=d;if(g){const P=[];for(let l of this._cleanupPatterns)for(;;){const t=l.exec(d);if(!t)break;P.push([t.index,l.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(k="";;){const l=h.exec(d);if(!l)break;!c.test(l[0])&&P.every(([t,r])=>l.index<t||l.index>=r)&&(k+=d.substring(o,l.index)+"<REDACTED: user-file-path>",o=h.lastIndex)}o<d.length&&(k+=d.substr(o))}for(let P of this._cleanupPatterns)k=k.replace(P,"");return k}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=he([ee(1,S.optional(I.IConfigurationService))],E),e.TelemetryService=E;const M="telemetry";i.Registry.as(n.Extensions.Configuration).registerConfiguration({id:M,order:110,type:"object",title:L.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?L.localize(2,null,m.default.privacyStatementUrl):L.localize(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(Z[98],x([0,1,21,44,13,9]),function($,e,m,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(d,g){return Promise.resolve(void 0)}publicLog2(d,g){return this.publicLog(d,g)}publicLogError(d,g){return Promise.resolve(void 0)}publicLogError2(d,g){return this.publicLogError(d,g)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class I{async publicLog(g,k,P){}async publicLogError(g,k,P){}}e.NullEndpointTelemetryService=I;function n(...d){return{log:(g,k)=>d.forEach(P=>P.log(g,k)),flush:()=>S.Promises.settled(d.map(g=>g.flush()))}}e.combinedAppender=n,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(d,g){return g.onDidChangeConfiguration(k=>{k.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:m.ConfigurationTargetToString(k.source),configurationKeys:M(k.sourceConfig)})})}e.configurationTelemetry=v;function y(d){const g=Object.create(null),k=Object.create(null),P=Object.create(null);E(d,P);for(let c in P){c=c.length>150?c.substr(c.length-149):c;const h=P[c];typeof h=="number"?k[c]=h:typeof h=="boolean"?k[c]=h?1:0:typeof h=="string"?g[c]=h.substring(0,1023):typeof h!="undefined"&&h!==null&&(g[c]=h)}return{properties:g,measurements:k}}e.validateTelemetryData=y;function i(d){if(!d)return"none";let g="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(P=>{d.indexOf(`${P}+`)===0&&(g=P)}),g}e.cleanRemoteAuthority=i;function E(d,g,k=0,P){if(!!d)for(let c of Object.getOwnPropertyNames(d)){const h=d[c],o=P?P+c:c;Array.isArray(h)?g[o]=L.safeStringify(h):h instanceof Date?g[o]=h.toISOString():R.isObject(h)?k<2?E(h,g,k+1,o+"."):g[o]=L.safeStringify(h):g[o]=h}}function M(d){if(!d)return[];const g=[];return p(g,"",d),g}function p(d,g,k){k&&typeof k=="object"&&!Array.isArray(k)?Object.keys(k).forEach(P=>p(d,g?`${g}.${P}`:P,k[P])):d.push(g)}}),define(Z[203],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(Z[204],x([0,1,4,2,38,5,203,109]),function($,e,m,L,R,S,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=m.createDecorator("themeService");var v;(function(k){function P(c){return c&&typeof c=="object"&&typeof c.id=="string"}k.isThemeColor=P})(v=e.ThemeColor||(e.ThemeColor={}));function y(k){return{id:k}}e.themeColorFromId=y;var i;(function(k){function P(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||v.isThemeColor(r.color))}k.isThemeIcon=P;const c=new RegExp(`^\\$\\((${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?)\\)$`);function h(r){const s=c.exec(r);if(!s)return;let[,a]=s;return{id:a}}k.fromString=h;function o(r,s){let a=r.id;const u=a.lastIndexOf("~");return u!==-1&&(a=a.substring(0,u)),s&&(a=`${a}~${s}`),{id:a}}k.modify=o;function l(r,s){var a,u;return r.id===s.id&&((a=r.color)===null||a===void 0?void 0:a.id)===((u=s.color)===null||u===void 0?void 0:u.id)}k.isEqual=l;function t(r){return{id:r.id}}k.asThemeIcon=t,k.asClassNameArray=n.CSSIcon.asClassNameArray,k.asClassName=n.CSSIcon.asClassName,k.asCSSSelector=n.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=n.Codicon.file,e.FolderThemeIcon=n.Codicon.folder;function E(k){switch(k){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class M{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new S.Emitter}onColorThemeChange(P){return this.themingParticipants.push(P),this.onThemingParticipantAddedEmitter.fire(P),L.toDisposable(()=>{const c=this.themingParticipants.indexOf(P);this.themingParticipants.splice(c,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new M;R.Registry.add(e.Extensions.ThemingContribution,p);function d(k){return p.onColorThemeChange(k)}e.registerThemingParticipant=d;class g extends L.Disposable{constructor(P){super();this.themeService=P,this.theme=P.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(c=>this.onThemeChange(c)))}onThemeChange(P){this.theme=P,this.updateStyles()}updateStyles(){}getColor(P,c){let h=this.theme.getColor(P);return h&&c&&(h=c(h,this.theme)),h?h.toString():null}}e.Themable=g}),define(Z[60],x([0,1,14,3,39,4]),function($,e,m,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const I="#FFFFFF",n="#1E1E1E",v="#000000",y="theme",i="themeBackground",E="windowSplash";e.IThemeMainService=S.createDecorator("themeMainService");let M=class{constructor(d){this.stateMainService=d}getBackgroundColor(){if((L.isWindows||L.isMacintosh)&&m.nativeTheme.shouldUseInvertedColorScheme)return v;let d=this.stateMainService.getItem(i,null);if(!d){let g;(L.isWindows||L.isMacintosh)&&m.nativeTheme.shouldUseInvertedColorScheme?g="hc-black":g=this.stateMainService.getItem(y,"vs-dark").split(" ")[0],d=g==="hc-black"?v:g==="vs"?I:n}return L.isMacintosh&&d.toUpperCase()===n&&(d="#171717"),d}saveWindowSplash(d,g){this.stateMainService.setItems([{key:y,data:g.baseTheme},{key:i,data:g.colorInfo.background},{key:E,data:g}]),typeof d=="number"&&this.updateBackgroundColor(d,g)}updateBackgroundColor(d,g){for(const k of m.BrowserWindow.getAllWindows())if(k.id===d){k.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(E)}};M=he([ee(0,R.IStateMainService)],M),e.ThemeMainService=M}),define(Z[42],x([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(S){S.Uninitialized="uninitialized",S.Idle="idle",S.CheckingForUpdates="checking for updates",S.AvailableForDownload="available for download",S.Downloading="downloading",S.Downloaded="downloaded",S.Updating="updating",S.Ready="ready"})(L=e.StateType||(e.StateType={}));var R;(function(S){S[S.Setup=0]="Setup",S[S.Archive=1]="Archive",S[S.Snap=2]="Snap"})(R=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(S,I)=>({type:"idle",updateType:S,error:I}),CheckingForUpdates:S=>({type:"checking for updates",explicit:S}),AvailableForDownload:S=>({type:"available for download",update:S}),Downloading:S=>({type:"downloading",update:S}),Downloaded:S=>({type:"downloaded",update:S}),Updating:S=>({type:"updating",update:S}),Ready:S=>({type:"ready",update:S})},e.IUpdateService=m.createDecorator("updateService")}),define(Z[205],x([0,1,38,49,149,3]),function($,e,m,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),m.Registry.as(L.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:R.localize(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:R.localize(1,null),tags:["usesOnlineServices"],enumDescriptions:[R.localize(2,null),R.localize(3,null),R.localize(4,null),R.localize(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:R.localize(6,null),deprecationMessage:R.localize(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:R.localize(8,null),description:R.localize(9,null),included:S.isWindows&&!S.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:R.localize(10,null),tags:["usesOnlineServices"]}}})}),define(Z[206],x([0,1,5,42]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class R{constructor(n){this.service=n}listen(n,v){switch(v){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${v}`)}call(n,v,y){switch(v){case"checkForUpdates":return this.service.checkForUpdates(y);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${v}`)}}e.UpdateChannel=R;class S{constructor(n){this.channel=n,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(v=>this.state=v),this.channel.call("_getInitialState").then(v=>this.state=v)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=S}),define(Z[99],x([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=m.createDecorator("urlService")}),define(Z[207],x([0,1,7]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(n){this.handler=n}listen(n,v){throw new Error(`Event not found: ${v}`)}call(n,v,y){switch(v){case"handleURL":return this.handler.handleURL(m.URI.revive(y[0]),y[1])}throw new Error(`Call not found: ${v}`)}}e.URLHandlerChannel=L;class R{constructor(n){this.channel=n}handleURL(n,v){return this.channel.call("handleURL",[n.toJSON(),v])}}e.URLHandlerChannelClient=R;class S{constructor(n){this.next=n}async routeCall(n,v,y,i){if(v!=="handleURL")throw new Error(`Call not found: ${v}`);if(y){const E=m.URI.revive(y);if(E&&E.query){const M=/\bwindowId=(\d+)/.exec(E.query);if(M){const p=M[1],d=new RegExp(`window:${p}`),g=n.connections.find(k=>d.test(k.ctx));if(g)return g}}}return this.next.routeCall(n,v,y,i)}routeEvent(n,v){throw new Error(`Event not found: ${v}`)}}e.URLHandlerRouter=S}),define(Z[208],x([0,1,7,9,2,20]),function($,e,m,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class I extends R.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(y,i){const E=[...this.handlers.values()];return L.first(E.map(M=>()=>M.handleURL(y,i)),void 0,!1).then(M=>M||!1)}registerHandler(y){return this.handlers.add(y),R.toDisposable(()=>this.handlers.delete(y))}}e.AbstractURLService=I;let n=class extends I{constructor(y){super();this.productService=y}create(y){let{authority:i,path:E,query:M,fragment:p}=y||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return i&&E&&E.indexOf("/")!==0&&(E=`/${E}`),m.URI.from({scheme:this.productService.urlProtocol,authority:i,path:E,query:M,fragment:p})}};n=he([ee(0,S.IProductService)],n),e.NativeURLService=n}),define(Z[209],x([0,1,5,14,7,2,3,9]),function($,e,m,L,R,S,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function v(i){try{return R.URI.parse(i)}catch(E){return null}}class y{constructor(E,M,p,d,g){if(this.urlService=M,this.uris=[],this.retryCount=0,this.flushDisposable=S.Disposable.None,this.disposables=new S.DisposableStore,this.uris=E,I.isWindows){const c=d.isBuilt?[]:[`"${d.appRoot}"`];c.push("--open-url","--"),L.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,c)}const k=m.Event.map(m.Event.fromNodeEventEmitter(L.app,"open-url",(c,h)=>({event:c,url:h})),({event:c,url:h})=>(c.preventDefault(),h));this.disposables.add(k(c=>{const h=v(c);!h||this.urlService.open(h,{originalUrl:c})})),p.getWindows().filter(c=>c.isReady).length>0?this.flush():m.Event.once(p.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const E=[];for(const M of this.uris)await this.urlService.open(M.uri,{originalUrl:M.url})||E.push(M);E.length!==0&&(this.uris=E,this.flushDisposable=n.disposableTimeout(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=y}),define(Z[76],x([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewPartitionId=e.IWebviewManagerService=void 0,e.IWebviewManagerService=m.createDecorator("webviewManagerService"),e.webviewPartitionId="webview"}),define(Z[210],x([0,1,14,2,10,7,76]),function($,e,m,L,R,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class n extends L.Disposable{constructor(){super();const y=m.session.fromPartition(I.webviewPartitionId),i=this.handleWebviewRequest.bind(this);m.protocol.registerFileProtocol(R.Schemas.vscodeWebview,i),y.protocol.registerFileProtocol(R.Schemas.vscodeWebview,i)}async handleWebviewRequest(y,i){try{const E=S.URI.parse(y.url),M=n.validWebviewFilePaths.get(E.path);if(typeof M=="string"){const p=E.path.startsWith("/electron-browser")?`vs/workbench/contrib/webview/electron-browser/pre/${M}`:`vs/workbench/contrib/webview/browser/pre/${M}`,d=R.FileAccess.asFileUri(p,$);return i(decodeURIComponent(d.fsPath))}}catch(E){}i({error:-10})}}e.WebviewProtocolProvider=n,n.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/electron-browser-index.html","index.html"],["/main.js","main.js"],["/host.js","host.js"],["/service-worker.js","service-worker.js"]])}),define(Z[61],x([0,1,3]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(y){return!!y.workspaceUri}e.isWorkspaceToOpen=L;function R(y){return!!y.folderUri}e.isFolderToOpen=R;function S(y){return!!y.fileUri}e.isFileToOpen=S;function I(y){const i=n(y),E=y.getValue("window.menuBarVisibility");return E==="default"||i==="native"&&E==="compact"||m.isMacintosh&&m.isNative?"classic":E}e.getMenuBarVisibility=I;function n(y){if(m.isWeb)return"custom";const i=y.getValue("window");if(i){if(m.isMacintosh&&i.nativeTabs===!0||m.isMacintosh&&i.nativeFullScreen===!1)return"native";const p=i.titleBarStyle;if(p==="native"||p==="custom")return p}return m.isLinux?"native":"custom"}e.getTitleBarStyle=n;function v(y=0){return Math.pow(1.2,y)}e.zoomLevelToZoomFactor=v}),define(Z[35],x([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=void 0;var L;(function(n){n[n.CLI=0]="CLI",n[n.DOCK=1]="DOCK",n[n.MENU=2]="MENU",n[n.DIALOG=3]="DIALOG",n[n.DESKTOP=4]="DESKTOP",n[n.API=5]="API"})(L=e.OpenContext||(e.OpenContext={}));const R=function(n=1){return{width:1024,height:768,mode:n}};e.defaultWindowState=R;var S;(function(n){n[n.Maximized=0]="Maximized",n[n.Normal=1]="Normal",n[n.Minimized=2]="Minimized",n[n.Fullscreen=3]="Fullscreen"})(S=e.WindowMode||(e.WindowMode={}));var I;(function(n){n[n.UNRESPONSIVE=1]="UNRESPONSIVE",n[n.CRASHED=2]="CRASHED",n[n.LOAD=3]="LOAD"})(I=e.WindowError||(e.WindowError={})),e.IWindowsMainService=m.createDecorator("windowsMainService")}),define(Z[211],x([0,1,14,2,74,76,210,35]),function($,e,m,L,R,S,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let v=class extends L.Disposable{constructor(i,E){super();this.windowsMainService=E,this._register(new I.WebviewProtocolProvider);const M=m.session.fromPartition(S.webviewPartitionId);M.setPermissionRequestHandler((p,d,g)=>g(d==="clipboard-read")),M.setPermissionCheckHandler((p,d)=>d==="clipboard-read")}async setIgnoreMenuShortcuts(i,E){let M;if(typeof i.windowId=="number"){const{windowId:p}=i,d=this.windowsMainService.getWindowById(p);if(!(d==null?void 0:d.win))throw new Error(`Invalid windowId: ${p}`);M=d.win.webContents}else{const{webContentsId:p}=i;if(M=m.webContents.fromId(p),!M)throw new Error(`Invalid webContentsId: ${p}`)}M.isDestroyed()||M.setIgnoreMenuShortcuts(E)}};v=he([ee(0,R.ITunnelService),ee(1,n.IWindowsMainService)],v),e.WebviewMainService=v}),define(Z[212],x([0,1,5,2,9]),function($,e,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class S extends L.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:v,getActiveWindowId:y}){super();this.disposables=this._register(new L.DisposableStore),m.Event.latch(m.Event.any(n,v))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=R.createCancelablePromise(()=>y()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch(E){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=S}),define(Z[213],x([0,1,7,15,4,37]),function($,e,m,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=R.createDecorator("contextService");var I;(function(M){M[M.EMPTY=1]="EMPTY",M[M.FOLDER=2]="FOLDER",M[M.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function n(M){const p=M;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=n;function v(M){const p=M;return!!(p&&typeof p=="object"&&m.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=v;class y{constructor(p,d,g,k){this._id=p,this._configuration=g,this._ignorePathCasing=k,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(p){this._id=p.id,this._configuration=p.configuration,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=y;class i{constructor(p,d){this.raw=d,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return L.joinPath(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function E(M){return new i({uri:M,index:0,name:L.basenameOrAuthority(M)},{uri:M.toString()})}e.toWorkspaceFolder=E}),define(Z[28],x([0,1,4,152,213,7,3,8,15,78,40,10,31,30,73]),function($,e,m,L,R,S,I,n,v,y,i,E,M,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:L.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function k(C){return(typeof C=="string"?n.extname(C):v.extname(C))===g}e.hasWorkspaceFileExtension=k,e.IWorkspacesService=m.createDecorator("workspacesService");function P(C){return C.hasOwnProperty("workspace")}e.isRecentWorkspace=P;function c(C){return C.hasOwnProperty("folderUri")}e.isRecentFolder=c;function h(C){return C.hasOwnProperty("fileUri")}e.isRecentFile=h;function o(C){const z=C;return typeof(z==null?void 0:z.id)=="string"&&S.URI.isUri(z.uri)}e.isSingleFolderWorkspaceIdentifier=o;function l(C){if(C.configuration)return{id:C.id,configPath:C.configuration};if(C.folders.length===1)return{id:C.id,uri:C.folders[0].uri}}e.toWorkspaceIdentifier=l;function t(C){const z=C;return typeof(z==null?void 0:z.id)=="string"&&S.URI.isUri(z.configPath)}e.isWorkspaceIdentifier=t;function r(C){const z=C;if(z==null?void 0:z.uri)return{id:z.id,uri:S.URI.revive(z.uri)};const X=C;if(X==null?void 0:X.configPath)return{id:X.id,configPath:S.URI.revive(X.configPath)};if(C==null?void 0:C.id)return{id:C.id}}e.reviveIdentifier=r;function s(C,z){return v.extUriBiasedIgnorePathCase.isEqualOrParent(C,z.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function a(C){return u(C)||w(C)}e.isStoredWorkspaceFolder=a;function u(C){const z=C;return typeof(z==null?void 0:z.path)=="string"&&(!z.name||typeof z.name=="string")}e.isRawFileWorkspaceFolder=u;function w(C){const z=C;return typeof(z==null?void 0:z.uri)=="string"&&(!z.name||typeof z.name=="string")}e.isRawUriWorkspaceFolder=w;function f(C,z,X,H,W=!I.isWindows,D){if(C.scheme!==H.scheme)return{name:X,uri:C.toString(!0)};let O=z?void 0:D.relativePath(H,C);if(O!==void 0)O.length===0?O=".":I.isWindows&&C.scheme===E.Schemas.file&&!W&&(O=O.replace(/\//g,"\\"));else if(C.scheme===E.Schemas.file)O=C.fsPath,I.isWindows&&(O=M.normalizeDriveLetter(O),W&&(O=p.toSlashes(O)));else{if(!D.isEqualAuthority(C.authority,H.authority))return{name:X,uri:C.toString(!0)};O=C.path}return{name:X,path:O}}e.getStoredWorkspaceFolder=f;function b(C,z,X){let H=[],W=new Set;const D=X.dirname(z);for(let O of C){let F;if(u(O))O.path&&(F=X.resolvePath(D,O.path));else if(w(O))try{F=S.URI.parse(O.uri),F.path[0]!=="/"&&(F=F.with({path:"/"+F.path}))}catch(T){console.warn(T)}if(F){let T=X.getComparisonKey(F);if(!W.has(T)){W.add(T);const _=O.name||X.basenameOrAuthority(F);H.push(new R.WorkspaceFolder({uri:F,name:_,index:H.length},O))}}}return H}e.toWorkspaceFolders=b;function A(C,z,X,H,W){let D=U(z,C);const O=W.dirname(z),F=W.dirname(H),T=[],_=q(D.folders);for(const Q of D.folders){const ne=u(Q)?W.resolvePath(O,Q.path):S.URI.parse(Q.uri);let se;X?se=!1:se=!u(Q)||n.isAbsolute(Q.path),T.push(f(ne,se,Q.name,F,_,W))}const N={insertSpaces:!1,tabSize:4,eol:I.isLinux||I.isMacintosh?`
`:`\r
`},K=y.setProperty(C,["folders"],T,N);let V=y.applyEdits(C,K);return D.remoteAuthority===d.getRemoteAuthority(H)&&(V=y.applyEdits(V,y.removeProperty(V,["remoteAuthority"],N))),V}e.rewriteWorkspaceFileForNewLocation=A;function U(C,z){let X=i.parse(z);if(X&&Array.isArray(X.folders))X.folders=X.folders.filter(H=>a(H));else throw new Error(`${C} looks like an invalid workspace file.`);return X}function q(C){return I.isWindows?C.some(z=>u(z)&&z.path.indexOf("/")>=0):!0}e.useSlashForPath=q;function J(C){return C.workspace&&typeof C.workspace=="object"&&typeof C.workspace.id=="string"&&typeof C.workspace.configPath=="string"}function te(C){return typeof C.folderUri=="string"}function B(C){return typeof C.fileUri=="string"}function Y(C,z){const X={workspaces:[],files:[]};if(C){const H=function(D,O){for(let F=0;F<D.length;F++)try{O(D[F],F)}catch(T){z.warn(`Error restoring recent entry ${JSON.stringify(D[F])}: ${T.toString()}. Skip entry.`)}},W=C;if(Array.isArray(W.entries))H(W.entries,D=>{const O=D.label,F=D.remoteAuthority;J(D)?X.workspaces.push({label:O,remoteAuthority:F,workspace:{id:D.workspace.id,configPath:S.URI.parse(D.workspace.configPath)}}):te(D)?X.workspaces.push({label:O,remoteAuthority:F,folderUri:S.URI.parse(D.folderUri)}):B(D)&&X.files.push({label:O,remoteAuthority:F,fileUri:S.URI.parse(D.fileUri)})});else{const D=C;Array.isArray(D.workspaces3)&&H(D.workspaces3,(O,F)=>{const T=Array.isArray(D.workspaceLabels)&&D.workspaceLabels[F]||void 0;typeof O=="object"&&typeof O.id=="string"&&typeof O.configURIPath=="string"?X.workspaces.push({label:T,workspace:{id:O.id,configPath:S.URI.parse(O.configURIPath)}}):typeof O=="string"&&X.workspaces.push({label:T,folderUri:S.URI.parse(O)})}),Array.isArray(D.files2)&&H(D.files2,(O,F)=>{const T=Array.isArray(D.fileLabels)&&D.fileLabels[F]||void 0;typeof O=="string"&&X.files.push({label:T,fileUri:S.URI.parse(O)})})}}return X}e.restoreRecentlyOpened=Y;function G(C){const z={entries:[]};for(const X of C.workspaces)c(X)?z.entries.push({folderUri:X.folderUri.toString(),label:X.label,remoteAuthority:X.remoteAuthority}):z.entries.push({workspace:{id:X.workspace.id,configPath:X.workspace.configPath.toString()},label:X.label,remoteAuthority:X.remoteAuthority});for(const X of C.files)z.entries.push({fileUri:X.fileUri.toString(),label:X.label,remoteAuthority:X.remoteAuthority});return z}e.toStoreData=G}),define(Z[51],x([0,1,4,28]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=m.createDecorator("backupMainService");function R(S){const I=S;return I&&L.isWorkspaceIdentifier(I.workspace)}e.isWorkspaceBackupInfo=R}),define(Z[52],x([0,1,4,14,9,39,3,8,65,18,13,134,28,31,2,81]),function($,e,m,L,R,S,I,n,v,y,i,E,M,p,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=m.createDecorator("dialogMainService");let k=class mt{constructor(c){this.stateMainService=c,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new R.Queue}pickFileFolder(c,h){return this.doPick(Object.assign(Object.assign({},c),{pickFolders:!0,pickFiles:!0,title:E.localize(0,null)}),h)}pickFolder(c,h){return this.doPick(Object.assign(Object.assign({},c),{pickFolders:!0,title:E.localize(1,null)}),h)}pickFile(c,h){return this.doPick(Object.assign(Object.assign({},c),{pickFiles:!0,title:E.localize(2,null)}),h)}pickWorkspace(c,h){const o=E.localize(3,null),l=p.mnemonicButtonLabel(E.localize(4,null)),t=M.WORKSPACE_FILTER;return this.doPick(Object.assign(Object.assign({},c),{pickFiles:!0,title:o,filters:t,buttonLabel:l}),h)}async doPick(c,h){const o={title:c.title,buttonLabel:c.buttonLabel,filters:c.filters};o.defaultPath=c.defaultPath||this.stateMainService.getItem(mt.workingDirPickerStorageKey),(typeof c.pickFiles=="boolean"||typeof c.pickFolders=="boolean")&&(o.properties=void 0,c.pickFiles&&c.pickFolders&&(o.properties=["multiSelections","openDirectory","openFile","createDirectory"])),o.properties||(o.properties=["multiSelections",c.pickFolders?"openDirectory":"openFile","createDirectory"]),I.isMacintosh&&o.properties.push("treatPackageAsDirectory");const l=h||L.BrowserWindow.getFocusedWindow(),t=await this.showOpenDialog(o,i.withNullAsUndefined(l));if(t&&t.filePaths&&t.filePaths.length>0)return this.stateMainService.setItem(mt.workingDirPickerStorageKey,n.dirname(t.filePaths[0])),t.filePaths}getWindowDialogQueue(c){if(c){let h=this.windowDialogQueues.get(c.id);return h||(h=new R.Queue,this.windowDialogQueues.set(c.id,h)),h}else return this.noWindowDialogueQueue}showMessageBox(c,h){return this.getWindowDialogQueue(h).queue(async()=>h?L.dialog.showMessageBox(h,c):L.dialog.showMessageBox(c))}async showSaveDialog(c,h){const o=this.acquireFileDialogLock(c,h);if(!o)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(h).queue(async()=>{let l;return h?l=await L.dialog.showSaveDialog(h,c):l=await L.dialog.showSaveDialog(c),l.filePath=this.normalizePath(l.filePath),l})}finally{d.dispose(o)}}normalizePath(c){return c&&I.isMacintosh&&(c=v.normalizeNFC(c)),c}normalizePaths(c){return c.map(h=>this.normalizePath(h))}async showOpenDialog(c,h){c.defaultPath&&(await y.Promises.exists(c.defaultPath)||(c.defaultPath=void 0));const o=this.acquireFileDialogLock(c,h);if(!o)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(h).queue(async()=>{let l;return h?l=await L.dialog.showOpenDialog(h,c):l=await L.dialog.showOpenDialog(c),l.filePaths=this.normalizePaths(l.filePaths),l})}finally{d.dispose(o)}}acquireFileDialogLock(c,h){if(!h)return d.Disposable.None;let o=this.windowFileDialogLocks.get(h.id);o||(o=new Set,this.windowFileDialogLocks.set(h.id,o));const l=g.hash(c);if(!o.has(l))return o.add(l),d.toDisposable(()=>{o==null||o.delete(l),(o==null?void 0:o.size)===0&&this.windowFileDialogLocks.delete(h.id)})}};k.workingDirPickerStorageKey="pickerWorkingDir",k=he([ee(0,S.IStateMainService)],k),e.DialogMainService=k}),define(Z[214],x([0,1,5,2,28]),function($,e,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class S extends L.Disposable{constructor(n,v){super();this.logService=n,this.storageMainService=v,this._onDidChangeGlobalStorage=this._register(new m.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(m.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,v)=>(n?n.push(v):n=[v],n),S.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const v=new Map,y=new Set;return n.forEach(i=>{const E=this.storageMainService.globalStorage.get(i.key);typeof E=="string"?v.set(i.key,E):y.add(i.key)}),{changed:Array.from(v.entries()),deleted:Array.from(y.values())}}listen(n,v){switch(v){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${v}`)}async call(n,v,y){const i=R.reviveIdentifier(y.workspace),E=await this.withStorageInitialized(i);switch(v){case"getItems":return Array.from(E.items.entries());case"updateItems":{const M=y;if(M.insert)for(const[p,d]of M.insert)E.set(p,d);M.delete&&M.delete.forEach(p=>E.delete(p));break}case"close":{if(i)return E.close();break}default:throw new Error(`Call not found: ${v}`)}}async withStorageInitialized(n){const v=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await v.init()}catch(y){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${y}`)}return v}}e.StorageDatabaseChannel=S,S.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[215],x([0,1,18,5,2,6,124,87,8,97,32,27,28]),function($,e,m,L,R,S,I,n,v,y,i,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class p extends R.Disposable{constructor(P){super();this.logService=P,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new L.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const P=await this.doCreate();this.storage.dispose(),this.storage=P,this._register(P.onDidChangeStorage(h=>this._onDidChangeStorage.fire({key:h}))),await this.doInit(P);const c=P.getBoolean(y.IS_NEW_KEY);c===void 0?P.set(y.IS_NEW_KEY,!0):c&&P.set(y.IS_NEW_KEY,!1)}catch(P){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${P}`)}})()),this.initializePromise}createLogginOptions(){return{logTrace:this.logService.getLevel()===S.LogLevel.Trace?P=>this.logService.trace(P):void 0,logError:P=>this.logService.error(P)}}doInit(P){return P.init()}get items(){return this.storage.items}get(P,c){return this.storage.get(P,c)}set(P,c){return this.storage.set(P,c)}delete(P){return this.storage.delete(P)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class d extends p{constructor(P,c,h){super(c);this.options=P,this.environmentService=h}async doCreate(){let P;return this.options.useInMemoryStorage?P=I.SQLiteStorageDatabase.IN_MEMORY_PATH:P=v.join(this.environmentService.globalStorageHome.fsPath,d.STORAGE_NAME),new n.Storage(new I.SQLiteStorageDatabase(P,{logging:this.createLogginOptions()}))}async doInit(P){await super.doInit(P),this.updateTelemetryState(P)}updateTelemetryState(P){P.get(i.instanceStorageKey,void 0)===void 0&&P.set(i.instanceStorageKey,E.generateUuid()),P.get(i.firstSessionDateStorageKey,void 0)===void 0&&P.set(i.firstSessionDateStorageKey,new Date().toUTCString());const o=P.get(i.currentSessionDateStorageKey,void 0),l=new Date().toUTCString();P.set(i.lastSessionDateStorageKey,typeof o=="undefined"?null:o),P.set(i.currentSessionDateStorageKey,l)}}e.GlobalStorageMain=d,d.STORAGE_NAME="state.vscdb";class g extends p{constructor(P,c,h,o){super(h);this.workspace=P,this.options=c,this.environmentService=o}async doCreate(){const{storageFilePath:P,wasCreated:c}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new I.SQLiteStorageDatabase(P,{logging:this.createLogginOptions()}),{hint:c?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:I.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const P=v.join(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),c=v.join(P,g.WORKSPACE_STORAGE_NAME);return await m.Promises.exists(P)?{storageFilePath:c,wasCreated:!1}:(await m.Promises.mkdir(P,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(P),{storageFilePath:c,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(P){let c;if(M.isSingleFolderWorkspaceIdentifier(this.workspace)?c={folder:this.workspace.uri.toString()}:M.isWorkspaceIdentifier(this.workspace)&&(c={workspace:this.workspace.configPath.toString()}),c)try{const h=v.join(P,g.WORKSPACE_META_NAME);await m.Promises.exists(h)||await m.Promises.writeFile(h,JSON.stringify(c,void 0,2))}catch(h){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${h}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json"}),define(Z[100],x([0,1,43,2,47,4,22,6,215]),function($,e,m,L,R,S,I,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=S.createDecorator("storageMainService");let y=class extends L.Disposable{constructor(E,M,p){super();this.logService=E,this.environmentService=M,this.lifecycleMainService=p,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async E=>{E.workspace&&this.workspaceStorage(E.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(E=>{E.join(this.globalStorage.close());for(const[,M]of this.mapWorkspaceToStorage)E.join(M.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const E=new v.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return m.once(E.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),E}createWorkspaceStorage(E){return new v.WorkspaceStorageMain(E,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(E){let M=this.mapWorkspaceToStorage.get(E.id);return M||(this.logService.trace(`StorageMainService: creating workspace storage (${E.id})`),M=this.createWorkspaceStorage(E),this.mapWorkspaceToStorage.set(E.id,M),m.once(M.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${E.id})`),this.mapWorkspaceToStorage.delete(E.id)})),M}};y=he([ee(0,n.ILogService),ee(1,R.IEnvironmentService),ee(2,I.ILifecycleMainService)],y),e.StorageMainService=y}),define(Z[101],x([0,1,7,28,15]),function($,e,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function S(v,y,i){for(const M of v){const p=M.openedWorkspace;if(L.isWorkspaceIdentifier(p)){const d=i(p);if(d){if(d.folders.some(g=>R.extUriBiasedIgnorePathCase.isEqualOrParent(y,g.uri)))return M}else if(R.extUriBiasedIgnorePathCase.isEqualOrParent(y,p.configPath))return M}}const E=v.filter(M=>L.isSingleFolderWorkspaceIdentifier(M.openedWorkspace)&&R.extUriBiasedIgnorePathCase.isEqualOrParent(y,M.openedWorkspace.uri));if(E.length)return E.sort((M,p)=>-(M.openedWorkspace.uri.path.length-p.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=S;function I(v,y){for(const i of v)if(L.isWorkspaceIdentifier(i.openedWorkspace)&&R.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,y)||L.isSingleFolderWorkspaceIdentifier(i.openedWorkspace)&&R.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.uri,y))return i}e.findWindowOnWorkspaceOrFolder=I;function n(v,y){var i,E;const M=p=>y.some(d=>R.extUriBiasedIgnorePathCase.isEqual(m.URI.file(d),m.URI.file(p)));for(const p of v)if((E=(i=p.config)===null||i===void 0?void 0:i.extensionDevelopmentPath)===null||E===void 0?void 0:E.some(d=>M(d)))return p}e.findWindowOnExtensionDevelopmentPath=n}),define(Z[216],x([0,1,14,2,3,15,7,21,22,6,39,35,28]),function($,e,m,L,R,S,I,n,v,y,i,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let p=class vt extends L.Disposable{constructor(h,o,l,t,r){super();this.windowsMainService=h,this.stateMainService=o,this.lifecycleMainService=l,this.logService=t,this.configurationService=r,this._state=d(this.stateMainService.getItem(vt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){m.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(h=>this.onBeforeCloseWindow(h)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(h=>this.onBeforeCloseWindow(h))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const h={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!h.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),t&&(h.lastActiveWindow=this.toWindowState(t))}const o=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);o&&(h.lastPluginDevelopmentHostWindow=this.toWindowState(o)),this.windowsMainService.getWindowCount()>1&&(h.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const l=k(h);this.stateMainService.setItem(vt.windowsStateStorageKey,l),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",l)}onBeforeCloseWindow(h){if(this.lifecycleMainService.quitRequested)return;const o=this.toWindowState(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=o:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this._state.openedWindows.forEach(l=>{var t;const r=M.isWorkspaceIdentifier(h.openedWorkspace)&&((t=l.workspace)===null||t===void 0?void 0:t.id)===h.openedWorkspace.id,s=M.isSingleFolderWorkspaceIdentifier(h.openedWorkspace)&&l.folderUri&&S.extUriBiasedIgnorePathCase.isEqual(l.folderUri,h.openedWorkspace.uri);(r||s)&&(l.uiState=o.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=o)}toWindowState(h){return{workspace:M.isWorkspaceIdentifier(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:M.isSingleFolderWorkspaceIdentifier(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const o=this.doGetNewWindowState(h),l=this.configurationService.getValue("window");let t;return o.hasDefaultState?t=!!((l==null?void 0:l.newWindowDimensions)&&["fullscreen","inherit","offset"].indexOf(l.newWindowDimensions)>=0)||R.isMacintosh&&(l==null?void 0:l.nativeFullScreen)!==!1:(t=!!(this.lifecycleMainService.wasRestarted||(l==null?void 0:l.restoreFullscreen)),t&&R.isMacintosh&&this.windowsMainService.getWindows().some(r=>r.isFullScreen)&&(t=!1)),o.mode===3&&!t&&(o.mode=1),o}doGetNewWindowState(h){const o=this.windowsMainService.getLastActiveWindow();if(!h.extensionTestsPath){if(!!h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const u=h.workspace;if(M.isWorkspaceIdentifier(u)){const f=this.state.openedWindows.filter(b=>b.workspace&&b.workspace.id===u.id).map(b=>b.uiState);if(f.length)return f[0]}if(M.isSingleFolderWorkspaceIdentifier(u)){const f=this.state.openedWindows.filter(b=>b.folderUri&&S.extUriBiasedIgnorePathCase.isEqual(b.folderUri,u.uri)).map(b=>b.uiState);if(f.length)return f[0]}else if(h.backupPath){const f=this.state.openedWindows.filter(b=>b.backupPath===h.backupPath).map(b=>b.uiState);if(f.length)return f[0]}const w=this.lastClosedState||this.state.lastActiveWindow;if(!o&&w)return w.uiState}let l;const t=m.screen.getAllDisplays();if(t.length===1)l=t[0];else{if(R.isMacintosh){const u=m.screen.getCursorScreenPoint();l=m.screen.getDisplayNearestPoint(u)}!l&&o&&(l=m.screen.getDisplayMatching(o.getBounds())),l||(l=m.screen.getPrimaryDisplay()||t[0])}let r=E.defaultWindowState();r.x=Math.round(l.bounds.x+l.bounds.width/2-r.width/2),r.y=Math.round(l.bounds.y+l.bounds.height/2-r.height/2);const s=this.configurationService.getValue("window");let a=!0;if(R.isMacintosh&&(s==null?void 0:s.nativeFullScreen)!==!1&&(o==null?void 0:o.isFullScreen))r.mode=3;else if(s==null?void 0:s.newWindowDimensions){if(s.newWindowDimensions==="maximized")r.mode=0,a=!1;else if(s.newWindowDimensions==="fullscreen")r.mode=3,a=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&o){const u=o.serializeWindowState();u.mode===3?r.mode=3:r=u,a=r.mode!==3&&s.newWindowDimensions==="offset"}}return a&&(r=this.ensureNoOverlap(r)),r.hasDefaultState=!0,r}ensureNoOverlap(h){if(this.windowsMainService.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const o=this.windowsMainService.getWindows().map(l=>l.getBounds());for(;o.some(l=>l.x===h.x||l.y===h.y);)h.x+=30,h.y+=30;return h}};p.windowsStateStorageKey="windowsState",p=he([ee(0,E.IWindowsMainService),ee(1,i.IStateMainService),ee(2,v.ILifecycleMainService),ee(3,y.ILogService),ee(4,n.IConfigurationService)],p),e.WindowsStateHandler=p;function d(c){const h={openedWindows:[]},o=c||{openedWindows:[]};return o.lastActiveWindow&&(h.lastActiveWindow=g(o.lastActiveWindow)),o.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=g(o.lastPluginDevelopmentHostWindow)),Array.isArray(o.openedWindows)&&(h.openedWindows=o.openedWindows.map(l=>g(l))),h}e.restoreWindowsState=d;function g(c){const h={uiState:c.uiState};return c.backupPath&&(h.backupPath=c.backupPath),c.remoteAuthority&&(h.remoteAuthority=c.remoteAuthority),c.folder&&(h.folderUri=I.URI.parse(c.folder)),c.workspaceIdentifier&&(h.workspace={id:c.workspaceIdentifier.id,configPath:I.URI.parse(c.workspaceIdentifier.configURIPath)}),h}function k(c){return{lastActiveWindow:c.lastActiveWindow&&P(c.lastActiveWindow),lastPluginDevelopmentHostWindow:c.lastPluginDevelopmentHostWindow&&P(c.lastPluginDevelopmentHostWindow),openedWindows:c.openedWindows.map(h=>P(h))}}e.getWindowsStateStoreData=k;function P(c){return{workspaceIdentifier:c.workspace&&{id:c.workspace.id,configURIPath:c.workspace.configPath.toString()},folder:c.folderUri&&c.folderUri.toString(),backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.uiState}}}),define(Z[102],x([0,1,29,3,58,10,15]),function($,e,m,L,R,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function n(y){function i(){let E=y.scheme===S.Schemas.file?I.originalFSPath(y):y.toString();return L.isLinux||(E=E.toLowerCase()),R.createHash("md5").update(E).digest("hex")}return{id:i(),configPath:y}}e.getWorkspaceIdentifier=n;function v(y,i){function E(){if(y.scheme!==S.Schemas.file)return R.createHash("md5").update(y.toString()).digest("hex");if(!i)try{i=m.statSync(y.fsPath)}catch(d){return}let p;return L.isLinux?p=i.ino:L.isMacintosh?p=i.birthtime.getTime():L.isWindows&&(typeof i.birthtimeMs=="number"?p=Math.floor(i.birthtimeMs):p=i.birthtime.getTime()),R.createHash("md5").update(y.fsPath).update(p?String(p):"").digest("hex")}const M=E();if(typeof M=="string")return{id:M,uri:y}}e.getSingleFolderWorkspaceIdentifier=v}),define(Z[56],x([0,1,58,59,217,5,34,8,26,27,2,17,85,16,3]),function($,e,m,L,R,S,I,n,v,y,i,E,M,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(f){this.socket=f,this._errorListener=b=>{if(b){if(b.code==="EPIPE")return;p.onUnexpectedError(b)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(f){const b=A=>f(E.VSBuffer.wrap(A));return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(f){const b=A=>{f({type:0,hadError:A,error:void 0})};return this.socket.on("close",b),{dispose:()=>this.socket.off("close",b)}}onEnd(f){return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(f){if(!this.socket.destroyed)try{this.socket.write(f.buffer,b=>{if(b){if(b.code==="EPIPE")return;p.onUnexpectedError(b)}})}catch(b){if(b.code==="EPIPE")return;p.onUnexpectedError(b)}}end(){this.socket.end()}drain(){return new Promise((f,b)=>{if(this.socket.bufferSize===0){f();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),f()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.NodeSocket=g;var k;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize"})(k||(k={}));var P;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(P||(P={}));class c extends i.Disposable{constructor(f,b,A,U){super();this._onDidZlibFlush=this._register(new S.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=f,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=b,this._recordInflateBytes=U,b?(this._zlibInflate=R.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",q=>{console.error(q),p.onUnexpectedError(q),this._onClose.fire({type:0,hadError:!0,error:q})}),this._zlibInflate.on("data",q=>{this._pendingInflateData.push(q)}),A&&(this._zlibInflate.write(A.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=R.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",q=>{console.error(q),p.onUnexpectedError(q),this._onClose.fire({type:0,hadError:!0,error:q})}),this._zlibDeflate.on("data",q=>{this._pendingDeflateData.push(q)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new M.ChunkStream,this._register(this.socket.onData(q=>this._acceptChunk(q))),this._register(this.socket.onClose(q=>this._onClose.fire(q)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?E.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):E.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this._onData.event(f)}onClose(f){return this._onClose.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){this._totalOutgoingDataBytes+=f.byteLength,this._zlibDeflate?(this._zlibDeflate.write(f.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let b=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,b=b.slice(0,b.length-4),this._isEnded||this._write(E.VSBuffer.wrap(b),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(f,!1)}_write(f,b){let A=2;f.byteLength<126?A+=0:f.byteLength<2**16?A+=2:A+=8;const U=E.VSBuffer.alloc(A);if(b?U.writeUInt8(194,0):U.writeUInt8(130,0),f.byteLength<126)U.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){U.writeUInt8(126,1);let q=1;U.writeUInt8(f.byteLength>>>8&255,++q),U.writeUInt8(f.byteLength>>>0&255,++q)}else{U.writeUInt8(127,1);let q=1;U.writeUInt8(0,++q),U.writeUInt8(0,++q),U.writeUInt8(0,++q),U.writeUInt8(0,++q),U.writeUInt8(f.byteLength>>>24&255,++q),U.writeUInt8(f.byteLength>>>16&255,++q),U.writeUInt8(f.byteLength>>>8&255,++q),U.writeUInt8(f.byteLength>>>0&255,++q)}this._totalOutgoingWireBytes+=U.byteLength+f.byteLength,this.socket.write(E.VSBuffer.concat([U,f]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(f){if(f.byteLength!==0){for(this._totalIncomingWireBytes+=f.byteLength,this._incomingData.acceptChunk(f);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const b=this._incomingData.peek(this._state.readLen),U=(b.readUInt8(0)&128)>>>7,q=b.readUInt8(1),J=(q&128)>>>7,te=q&127;this._state.state=2,this._state.readLen=2+(J?4:0)+(te===126?2:0)+(te===127?8:0),this._state.fin=U,this._state.mask=0}else if(this._state.state===2){const b=this._incomingData.read(this._state.readLen),A=b.readUInt8(1),U=(A&128)>>>7;let q=A&127,J=1;q===126?q=b.readUInt8(++J)*2**8+b.readUInt8(++J):q===127&&(q=b.readUInt8(++J)*0+b.readUInt8(++J)*0+b.readUInt8(++J)*0+b.readUInt8(++J)*0+b.readUInt8(++J)*2**24+b.readUInt8(++J)*2**16+b.readUInt8(++J)*2**8+b.readUInt8(++J));let te=0;U&&(te=b.readUInt8(++J)*2**24+b.readUInt8(++J)*2**16+b.readUInt8(++J)*2**8+b.readUInt8(++J)),this._state.state=3,this._state.readLen=q,this._state.mask=te}else if(this._state.state===3){const b=this._incomingData.read(this._state.readLen);h(b,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(b.buffer)),this._zlibInflate.write(b.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const A=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=A.length,this._onData.fire(E.VSBuffer.wrap(A))})):(this._totalIncomingDataBytes+=b.byteLength,this._onData.fire(b))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await S.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=c;function h(w,f){if(f===0)return;let b=w.byteLength>>>2;for(let B=0;B<b;B++){const Y=w.readUInt32BE(B*4);w.writeUInt32BE(Y^f,B*4)}let A=b*4,U=w.byteLength-A;const q=f>>>24&255,J=f>>>16&255,te=f>>>8&255;U>=1&&w.writeUInt8(w.readUInt8(A)^q,A),U>=2&&w.writeUInt8(w.readUInt8(A+1)^J,A+1),U>=3&&w.writeUInt8(w.readUInt8(A+2)^te,A+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function l(){const w=y.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;let f;return e.XDG_RUNTIME_DIR?f=n.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${w}.sock`):f=n.join(v.tmpdir(),`vscode-ipc-${w}.sock`),r(f),f}e.createRandomIPCHandle=l;function t(w,f,b){const A=m.createHash("md5").update(w).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${b}-${f}-sock`;let U;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?U=n.join(e.XDG_RUNTIME_DIR,`vscode-${A.substr(0,8)}-${b}-${f}.sock`):U=n.join(w,`${b}-${f}.sock`),r(U),U}e.createStaticIPCHandle=t;function r(w){const f=o[d.platform];typeof f=="number"&&w.length>=f&&console.warn(`WARNING: IPC handle "${w}" is longer than ${f} chars, try a shorter --user-data-dir`)}class s extends I.IPCServer{constructor(f){super(s.toClientConnectionEvent(f));this.server=f}static toClientConnectionEvent(f){const b=S.Event.fromNodeEventEmitter(f,"connection");return S.Event.map(b,A=>({protocol:new M.Protocol(new g(A)),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(A,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function a(w){return new Promise((f,b)=>{const A=L.createServer();A.on("error",b),A.listen(w,()=>{A.removeListener("error",b),f(new s(A))})})}e.serve=a;function u(w,f){return new Promise((b,A)=>{const U=L.createConnection(w,()=>{U.removeListener("error",A),b(M.Client.fromSocket(new g(U),f))});U.once("error",A)})}e.connect=u}),define(Z[218],x([0,1,56]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class L{constructor(v){this.driver=v}listen(v,y){throw new Error("No event found")}call(v,y,i){switch(y){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(i);case"reloadWindow":return this.driver.reloadWindow(i);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(i[0],i[1]);case"click":return this.driver.click(i[0],i[1],i[2],i[3]);case"doubleClick":return this.driver.doubleClick(i[0],i[1]);case"setValue":return this.driver.setValue(i[0],i[1],i[2]);case"getTitle":return this.driver.getTitle(i[0]);case"isActiveElement":return this.driver.isActiveElement(i[0],i[1]);case"getElements":return this.driver.getElements(i[0],i[1],i[2]);case"getElementXY":return this.driver.getElementXY(i[0],i[1],i[2]);case"typeInEditor":return this.driver.typeInEditor(i[0],i[1],i[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(i[0],i[1]);case"writeInTerminal":return this.driver.writeInTerminal(i[0],i[1],i[2]);case"getLocalizedStrings":return this.driver.getLocalizedStrings(i)}throw new Error(`Call not found: ${y}`)}}e.DriverChannel=L;class R{constructor(v){this.channel=v}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(v){return this.channel.call("capturePage",v)}reloadWindow(v){return this.channel.call("reloadWindow",v)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(v,y){return this.channel.call("dispatchKeybinding",[v,y])}click(v,y,i,E){return this.channel.call("click",[v,y,i,E])}doubleClick(v,y){return this.channel.call("doubleClick",[v,y])}setValue(v,y,i){return this.channel.call("setValue",[v,y,i])}getTitle(v){return this.channel.call("getTitle",[v])}isActiveElement(v,y){return this.channel.call("isActiveElement",[v,y])}getElements(v,y,i){return this.channel.call("getElements",[v,y,i])}getElementXY(v,y,i,E){return this.channel.call("getElementXY",[v,y,i,E])}typeInEditor(v,y,i){return this.channel.call("typeInEditor",[v,y,i])}getTerminalBuffer(v,y){return this.channel.call("getTerminalBuffer",[v,y])}writeInTerminal(v,y,i){return this.channel.call("writeInTerminal",[v,y,i])}getLocalizedStrings(v){return this.channel.call("getLocalizedStrings",v)}}e.DriverChannelClient=R;class S{constructor(v){this.registry=v}listen(v,y){throw new Error(`Event not found: ${y}`)}call(v,y,i){switch(y){case"registerWindowDriver":return this.registry.registerWindowDriver(i);case"reloadWindowDriver":return this.registry.reloadWindowDriver(i)}throw new Error(`Call not found: ${y}`)}}e.WindowDriverRegistryChannel=S;async function I(n){const v=await m.connect(n,"driverClient"),y=v.getChannel("driver"),i=new R(y);return{client:v,driver:i}}e.connect=I}),define(Z[24],x([0,1,8,46,4,47,161,56]),function($,e,m,L,R,S,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=R.refineServiceDecorator(S.IEnvironmentService);class v extends I.NativeEnvironmentService{get cachedLanguagesPath(){return m.join(this.userDataPath,"clp")}get backupHome(){return m.join(this.userDataPath,"Backups")}get backupWorkspacesPath(){return m.join(this.backupHome,"workspaces.json")}get mainIPCHandle(){return n.createStaticIPCHandle(this.userDataPath,"main",this.productService.version)}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}}he([L.memoize],v.prototype,"cachedLanguagesPath",null),he([L.memoize],v.prototype,"backupHome",null),he([L.memoize],v.prototype,"backupWorkspacesPath",null),he([L.memoize],v.prototype,"mainIPCHandle",null),he([L.memoize],v.prototype,"sandbox",null),he([L.memoize],v.prototype,"driverVerbose",null),he([L.memoize],v.prototype,"disableUpdates",null),he([L.memoize],v.prototype,"disableKeytar",null),he([L.memoize],v.prototype,"codeCachePath",null),e.EnvironmentMainService=v}),define(Z[219],x([0,1,29,58,8,3,18,51,24,21,19,6,28,7,30,10,15]),function($,e,m,L,R,S,I,n,v,y,i,E,M,p,d,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let P=class{constructor(h,o,l){this.configurationService=o,this.logService=l,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=k.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,r)=>d.isEqual(t,r,!S.isLinux)},this.backupHome=h.backupHome,this.workspacesJsonPath=h.backupWorkspacesPath}async initialize(){let h;try{h=JSON.parse(await I.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){h=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(h.emptyWorkspaceInfos);let o=[];try{Array.isArray(h.rootURIWorkspaces)&&(o=h.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:p.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(o);let l=[];try{Array.isArray(h.folderURIWorkspaces)&&(l=h.folderURIWorkspaces.map(t=>p.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(l),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==i.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===i.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){var h;const o=this.configurationService.getValue();return((h=o==null?void 0:o.files)===null||h===void 0?void 0:h.hotExit)||i.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(h,o){this.workspaces.some(t=>h.workspace.id===t.workspace.id)||(this.workspaces.push(h),this.saveSync());const l=this.getBackupPath(h.workspace.id);return o&&this.moveBackupFolderSync(l,o),l}moveBackupFolderSync(h,o){if(m.existsSync(h)&&this.convertToEmptyWindowBackupSync(h),m.existsSync(o))try{m.renameSync(o,h)}catch(l){this.logService.error(`Backup: Could not move backup folder to new location: ${l.toString()}`)}}unregisterWorkspaceBackupSync(h){const o=h.id,l=this.workspaces.findIndex(t=>t.workspace.id===o);l!==-1&&(this.workspaces.splice(l,1),this.saveSync())}registerFolderBackupSync(h){return this.folders.some(o=>this.backupUriComparer.isEqual(h,o))||(this.folders.push(h),this.saveSync()),this.getBackupPath(this.getFolderHash(h))}unregisterFolderBackupSync(h){const o=this.folders.findIndex(l=>this.backupUriComparer.isEqual(h,l));o!==-1&&(this.folders.splice(o,1),this.saveSync())}registerEmptyWindowBackupSync(h,o){const l=h||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,l))||(this.emptyWindows.push({backupFolder:l,remoteAuthority:o}),this.saveSync()),this.getBackupPath(l)}unregisterEmptyWindowBackupSync(h){const o=this.emptyWindows.findIndex(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,h));o!==-1&&(this.emptyWindows.splice(o,1),this.saveSync())}getBackupPath(h){return R.join(this.backupHome,h)}async validateWorkspaces(h){if(!Array.isArray(h))return[];const o=new Set,l=[];for(let t of h){const r=t.workspace;if(!M.isWorkspaceIdentifier(r))return[];if(!o.has(r.id)){o.add(r.id);const s=this.getBackupPath(r.id);await this.doHasBackups(s)?r.configPath.scheme!==g.Schemas.file||await I.Promises.exists(r.configPath.fsPath)?l.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return l}async validateFolders(h){if(!Array.isArray(h))return[];const o=[],l=new Set;for(let t of h){const r=this.backupUriComparer.getComparisonKey(t);if(!l.has(r)){l.add(r);const s=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(s)?t.scheme!==g.Schemas.file||await I.Promises.exists(t.fsPath)?o.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return o}async validateEmptyWorkspaces(h){if(!Array.isArray(h))return[];const o=[],l=new Set;for(let t of h){const r=t.backupFolder;if(typeof r!="string")return[];if(!l.has(r)){l.add(r);const s=this.getBackupPath(r);await this.doHasBackups(s)?o.push(t):await this.deleteStaleBackup(s)}}return o}async deleteStaleBackup(h){try{await I.Promises.exists(h)&&await I.Promises.rm(h,I.RimRafMode.MOVE)}catch(o){this.logService.error(`Backup: Could not delete stale backup: ${o.toString()}`)}}async convertToEmptyWindowBackup(h){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,o));)o=this.getRandomEmptyWindowId();const l=this.getBackupPath(o);try{await I.Promises.rename(h,l)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}convertToEmptyWindowBackupSync(h){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,o));)o=this.getRandomEmptyWindowId();const l=this.getBackupPath(o);try{m.renameSync(h,l)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}async getDirtyWorkspaces(){const h=[];for(const o of this.workspaces)await this.hasBackups(o)&&h.push(o.workspace);for(const o of this.folders)await this.hasBackups(o)&&h.push(o);return h}hasBackups(h){let o;return p.URI.isUri(h)?o=this.getBackupPath(this.getFolderHash(h)):n.isWorkspaceBackupInfo(h)?o=this.getBackupPath(h.workspace.id):o=h.backupFolder,this.doHasBackups(o)}async doHasBackups(h){try{const o=await I.Promises.readdir(h);for(const l of o)try{if((await I.Promises.readdir(R.join(h,l))).length>0)return!0}catch(t){}}catch(o){}return!1}saveSync(){try{I.writeFileSync(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}async save(){try{await I.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(h=>({id:h.workspace.id,configURIPath:h.workspace.configPath.toString(),remoteAuthority:h.remoteAuthority})),folderURIWorkspaces:this.folders.map(h=>h.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(h){let o;return h.scheme===g.Schemas.file?o=S.isLinux?h.fsPath:h.fsPath.toLowerCase():o=h.toString().toLowerCase(),L.createHash("md5").update(o).digest("hex")}};P=he([ee(0,v.IEnvironmentMainService),ee(1,y.IConfigurationService),ee(2,E.ILogService)],P),e.BackupMainService=P}),define(Z[45],x([0,1,41,115,146,83,5,35,14,22,3,24,52,18,7,32,4,26,66,6,8,20,46,2,60,31]),function($,e,m,L,R,S,I,n,v,y,i,E,M,p,d,g,k,P,c,h,o,l,t,r,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=k.createDecorator("nativeHostMainService");let u=class ut extends r.Disposable{constructor(f,b,A,U,q,J,te,B,Y){super();this.sharedProcess=f,this.windowsMainService=b,this.dialogMainService=A,this.lifecycleMainService=U,this.environmentMainService=q,this.telemetryService=J,this.logService=te,this.productService=B,this.themeMainService=Y,this.onDidOpenWindow=I.Event.map(this.windowsMainService.onDidOpenWindow,G=>G.id),this.onDidMaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(v.app,"browser-window-maximize",(G,C)=>C.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidUnmaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(v.app,"browser-window-unmaximize",(G,C)=>C.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidBlurWindow=I.Event.filter(I.Event.fromNodeEventEmitter(v.app,"browser-window-blur",(G,C)=>C.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidFocusWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),G=>!!G),G=>G.id),I.Event.filter(I.Event.fromNodeEventEmitter(v.app,"browser-window-focus",(G,C)=>C.id),G=>!!this.windowsMainService.getWindowById(G))),this.onDidResumeOS=I.Event.fromNodeEventEmitter(v.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new I.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new I.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(v.screen,"display-metrics-changed",(G,C,z)=>z),G=>!(Array.isArray(G)&&G.length===1&&G[0]==="workArea")),I.Event.fromNodeEventEmitter(v.screen,"display-added"),I.Event.fromNodeEventEmitter(v.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){v.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors,dark:v.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(b=>{var A,U;return{id:b.id,workspace:b.openedWorkspace,title:(U=(A=b.win)===null||A===void 0?void 0:A.getTitle())!==null&&U!==void 0?U:"",filename:b.getRepresentedFilename(),dirty:b.isDocumentEdited()}})}async getWindowCount(f){return this.windowsMainService.getWindowCount()}async getActiveWindowId(f){const b=v.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(b)return b.id}openWindow(f,b,A){return Array.isArray(b)?this.doOpenWindow(f,b,A):this.doOpenEmptyWindow(f,b)}async doOpenWindow(f,b,A=Object.create(null)){b.length>0&&this.windowsMainService.open({context:5,contextWindowId:f,urisToOpen:b,cli:this.environmentMainService.args,forceNewWindow:A.forceNewWindow,forceReuseWindow:A.forceReuseWindow,preferNewWindow:A.preferNewWindow,diffMode:A.diffMode,addMode:A.addMode,gotoLineMode:A.gotoLineMode,noRecentEntry:A.noRecentEntry,waitMarkerFileURI:A.waitMarkerFileURI,remoteAuthority:A.remoteAuthority||void 0})}async doOpenEmptyWindow(f,b){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:f},b)}async toggleFullScreen(f){const b=this.windowById(f);b&&b.toggleFullScreen()}async handleTitleDoubleClick(f){const b=this.windowById(f);b&&b.handleTitleDoubleClick()}async isMaximized(f){const b=this.windowById(f);return(b==null?void 0:b.win)?b.win.isMaximized():!1}async maximizeWindow(f){const b=this.windowById(f);(b==null?void 0:b.win)&&b.win.maximize()}async unmaximizeWindow(f){const b=this.windowById(f);(b==null?void 0:b.win)&&b.win.unmaximize()}async minimizeWindow(f){const b=this.windowById(f);(b==null?void 0:b.win)&&b.win.minimize()}async focusWindow(f,b){var A;b&&typeof b.windowId=="number"&&(f=b.windowId);const U=this.windowById(f);U&&U.focus({force:(A=b==null?void 0:b.force)!==null&&A!==void 0?A:!1})}async setMinimumSize(f,b,A){const U=this.windowById(f);if(U==null?void 0:U.win){const[q,J]=U.win.getSize(),[te,B]=U.win.getMinimumSize(),[Y,G]=[b??te,A??B],[C,z]=[Math.max(q,Y),Math.max(J,G)];(te!==Y||B!==G)&&U.win.setMinimumSize(Y,G),(q!==C||J!==z)&&U.win.setSize(C,z)}}async saveWindowSplash(f,b){this.themeMainService.saveWindowSplash(f,b)}async installShellCommand(f){const{source:b,target:A}=await this.getShellCommandLink();try{const{symbolicLink:U}=await p.SymlinkSupport.stat(b);if(U&&!U.dangling){const q=await S.realpath(b);if(A===q)return}await p.Promises.unlink(b)}catch(U){if(U.code!=="ENOENT")throw U}try{await p.Promises.symlink(A,b)}catch(U){if(U.code!=="EACCES"&&U.code!=="ENOENT")throw U;const{response:q}=await this.showMessageBox(f,{title:this.productService.nameLong,type:"info",message:R.localize(0,null,this.productService.nameShort),buttons:[a.mnemonicButtonLabel(R.localize(1,null)),a.mnemonicButtonLabel(R.localize(2,null))],noLink:!0,defaultId:0,cancelId:1});if(q===0)try{const J=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${A}' '${b}'\\" with administrator privileges"`;await L.promisify(m.exec)(J)}catch(J){throw new Error(R.localize(3,null,b))}}}async uninstallShellCommand(f){const{source:b}=await this.getShellCommandLink();try{await p.Promises.unlink(b)}catch(A){switch(A.code){case"EACCES":const{response:U}=await this.showMessageBox(f,{title:this.productService.nameLong,type:"info",message:R.localize(4,null,this.productService.nameShort),buttons:[a.mnemonicButtonLabel(R.localize(5,null)),a.mnemonicButtonLabel(R.localize(6,null))],noLink:!0,defaultId:0,cancelId:1});if(U===0)try{const q=`osascript -e "do shell script \\"rm '${b}'\\" with administrator privileges"`;await L.promisify(m.exec)(q)}catch(q){throw new Error(R.localize(7,null,b))}break;case"ENOENT":break;default:throw A}}}async getShellCommandLink(){const f=o.resolve(this.environmentMainService.appRoot,"bin","code"),b=`/usr/local/bin/${this.productService.applicationName}`;if(!await p.Promises.exists(f))throw new Error(R.localize(8,null,f));return{source:b,target:f}}async showMessageBox(f,b){return this.dialogMainService.showMessageBox(b,this.toBrowserWindow(f))}async showSaveDialog(f,b){return this.dialogMainService.showSaveDialog(b,this.toBrowserWindow(f))}async showOpenDialog(f,b){return this.dialogMainService.showOpenDialog(b,this.toBrowserWindow(f))}toBrowserWindow(f){const b=this.windowById(f);if(b==null?void 0:b.win)return b.win}async pickFileFolderAndOpen(f,b){const A=await this.dialogMainService.pickFileFolder(b);A&&(this.sendPickerTelemetry(A,b.telemetryEventName||"openFileFolder",b.telemetryExtraData),this.doOpenPicked(await Promise.all(A.map(async U=>await p.SymlinkSupport.existsDirectory(U)?{folderUri:d.URI.file(U)}:{fileUri:d.URI.file(U)})),b,f))}async pickFolderAndOpen(f,b){const A=await this.dialogMainService.pickFolder(b);A&&(this.sendPickerTelemetry(A,b.telemetryEventName||"openFolder",b.telemetryExtraData),this.doOpenPicked(A.map(U=>({folderUri:d.URI.file(U)})),b,f))}async pickFileAndOpen(f,b){const A=await this.dialogMainService.pickFile(b);A&&(this.sendPickerTelemetry(A,b.telemetryEventName||"openFile",b.telemetryExtraData),this.doOpenPicked(A.map(U=>({fileUri:d.URI.file(U)})),b,f))}async pickWorkspaceAndOpen(f,b){const A=await this.dialogMainService.pickWorkspace(b);A&&(this.sendPickerTelemetry(A,b.telemetryEventName||"openWorkspace",b.telemetryExtraData),this.doOpenPicked(A.map(U=>({workspaceUri:d.URI.file(U)})),b,f))}doOpenPicked(f,b,A){this.windowsMainService.open({context:3,contextWindowId:A,cli:this.environmentMainService.args,urisToOpen:f,forceNewWindow:b.forceNewWindow})}sendPickerTelemetry(f,b,A){const U=f?f.length:0;this.telemetryService.publicLog(b,Object.assign(Object.assign({},A),{outcome:U?"success":"canceled",numberOfPaths:U}))}async showItemInFolder(f,b){v.shell.showItemInFolder(b)}async setRepresentedFilename(f,b){const A=this.windowById(f);A&&A.setRepresentedFilename(b)}async setDocumentEdited(f,b){const A=this.windowById(f);A&&A.setDocumentEdited(b)}async openExternal(f,b){return i.isLinuxSnap?this.safeSnapOpenExternal(b):v.shell.openExternal(b),!0}safeSnapOpenExternal(f){const b=process.env.GDK_PIXBUF_MODULE_FILE,A=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,v.shell.openExternal(f),process.env.GDK_PIXBUF_MODULE_FILE=b,process.env.GDK_PIXBUF_MODULEDIR=A}moveItemToTrash(f,b){return v.shell.trashItem(b)}async isAdmin(){let f;return i.isWindows?f=(await new Promise((b,A)=>{$(["native-is-elevated"],b,A)}))():f=process.getuid()===0,f}async writeElevated(f,b,A,U){const q=await new Promise((J,te)=>{$(["sudo-prompt"],J,te)});return new Promise((J,te)=>{const B=[`"${this.cliPath}"`];(U==null?void 0:U.unlock)&&B.push("--file-chmod"),B.push("--file-write",`"${b.fsPath}"`,`"${A.fsPath}"`);const Y={name:this.productService.nameLong.replace("-",""),icns:i.isMacintosh&&this.environmentMainService.isBuilt?o.join(o.dirname(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};q.exec(B.join(" "),Y,(G,C,z)=>{C&&this.logService.trace(`[sudo-prompt] received stdout: ${C}`),z&&this.logService.trace(`[sudo-prompt] received stderr: ${z}`),G?te(G):J(void 0)})})}get cliPath(){return i.isWindows?this.environmentMainService.isBuilt?o.join(o.dirname(process.execPath),"bin",`${this.productService.applicationName}.cmd`):o.join(this.environmentMainService.appRoot,"scripts","code-cli.bat"):i.isLinux?this.environmentMainService.isBuilt?o.join(o.dirname(process.execPath),"bin",`${this.productService.applicationName}`):o.join(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?o.join(this.environmentMainService.appRoot,"bin","code"):o.join(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:P.totalmem(),freemem:P.freemem(),loadavg:P.loadavg()}}async getOSProperties(){return{arch:P.arch(),platform:P.platform(),release:P.release(),type:P.type(),cpus:P.cpus()}}async getOSVirtualMachineHint(){return c.virtualMachineHint.value()}async killProcess(f,b,A){process.kill(b,A)}async readClipboardText(f,b){return v.clipboard.readText(b)}async writeClipboardText(f,b,A){return v.clipboard.writeText(b,A)}async readClipboardFindText(f){return v.clipboard.readFindText()}async writeClipboardFindText(f,b){return v.clipboard.writeFindText(b)}async writeClipboardBuffer(f,b,A,U){return v.clipboard.writeBuffer(b,Buffer.from(A),U)}async readClipboardBuffer(f,b){return v.clipboard.readBuffer(b)}async hasClipboard(f,b,A){return v.clipboard.has(b,A)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){v.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){v.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){v.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){v.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){v.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(f,b){const A=this.windowById(f);A&&A.updateTouchBar(b)}async notifyReady(f){const b=this.windowById(f);b&&b.setReady()}async relaunch(f,b){return this.lifecycleMainService.relaunch(b)}async reload(f,b){const A=this.windowById(f);if(A)return this.lifecycleMainService.reload(A,(b==null?void 0:b.disableExtensions)!==void 0?{_:[],"disable-extensions":b==null?void 0:b.disableExtensions}:void 0)}async closeWindow(f){this.closeWindowById(f,f)}async closeWindowById(f,b){const A=this.windowById(b);if(A==null?void 0:A.win)return A.win.close()}async quit(f){const b=this.windowsMainService.getLastActiveWindow();(b==null?void 0:b.isExtensionDevelopmentHost)&&this.windowsMainService.getWindowCount()>1&&b.win?b.win.close():this.lifecycleMainService.quit()}async exit(f,b){await this.lifecycleMainService.kill(b)}async resolveProxy(f,b){var A,U;const q=this.windowById(f),J=(U=(A=q==null?void 0:q.win)===null||A===void 0?void 0:A.webContents)===null||U===void 0?void 0:U.session;if(J)return J.resolveProxy(b)}async openDevTools(f,b){const A=this.windowById(f);(A==null?void 0:A.win)&&A.win.webContents.openDevTools(b)}async toggleDevTools(f){const b=this.windowById(f);(b==null?void 0:b.win)&&b.win.webContents.toggleDevTools()}async sendInputEvent(f,b){const A=this.windowById(f);(A==null?void 0:A.win)&&(b.type==="mouseDown"||b.type==="mouseUp")&&A.win.webContents.sendInputEvent(b)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(f,b,A,U){if(!i.isWindows)return;const q=await new Promise((J,te)=>{$(["vscode-windows-registry"],J,te)});try{return q.GetStringRegKey(b,A,U)}catch(J){return}}async getPassword(f,b,A){const U=await this.withKeytar(),q=await U.getPassword(b,A);if(q)try{let{content:J,hasNextChunk:te}=JSON.parse(q);if(!J||!te)return q;let B=1;for(;te;){const Y=await U.getPassword(b,`${A}-${B}`),G=JSON.parse(Y);J+=G.content,te=G.hasNextChunk,B++}return J}catch(J){return q}return q}async setPassword(f,b,A,U){const q=await this.withKeytar(),J=3,te=async(B,Y,G)=>{let C=0,z;for(;C<J;)try{await q.setPassword(B,Y,G);return}catch(X){z=X,this.logService.warn("Error attempting to set a password: ",X),C++,await new Promise(H=>setTimeout(H,200))}throw z};if(i.isWindows&&U.length>ut.MAX_PASSWORD_LENGTH){let B=0,Y=0,G=!0;for(;G;){const C=U.substring(B,B+ut.PASSWORD_CHUNK_SIZE);B+=ut.PASSWORD_CHUNK_SIZE,G=U.length-B>0;const z={content:C,hasNextChunk:G};await te(b,Y?`${A}-${Y}`:A,JSON.stringify(z)),Y++}}else await te(b,A,U);this._onDidChangePassword.fire({service:b,account:A})}async deletePassword(f,b,A){const q=await(await this.withKeytar()).deletePassword(b,A);return q&&this._onDidChangePassword.fire({service:b,account:A}),q}async findPassword(f,b){return(await this.withKeytar()).findPassword(b)}async findCredentials(f,b){return(await this.withKeytar()).findCredentials(b)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((f,b)=>{$(["keytar"],f,b)})}windowById(f){if(typeof f=="number")return this.windowsMainService.getWindowById(f)}};u.MAX_PASSWORD_LENGTH=2500,u.PASSWORD_CHUNK_SIZE=u.MAX_PASSWORD_LENGTH-100,he([t.memoize],u.prototype,"cliPath",null),u=he([ee(1,n.IWindowsMainService),ee(2,M.IDialogMainService),ee(3,y.ILifecycleMainService),ee(4,E.IEnvironmentMainService),ee(5,g.ITelemetryService),ee(6,h.ILogService),ee(7,l.IProductService),ee(8,s.IThemeMainService)],u),e.NativeHostMainService=u}),define(Z[220],x([0,1,2,5,81,14,6,35,45,90,27,20,25]),function($,e,m,L,R,S,I,n,v,y,i,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var p;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let d=class extends m.Disposable{constructor(k,P,c,h,o){super();this.logService=k,this.windowsMainService=P,this.nativeHostMainService=c,this.encryptionMainService=h,this.productService=o,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=p.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const k=L.Event.fromNodeEventEmitter(S.app,"login",(P,c,h,o,l)=>({event:P,webContents:c,req:h,authInfo:o,callback:l}));this._register(k(this.onLogin,this))}async onLogin({event:k,authInfo:P,req:c,callback:h}){if(!P.isProxy)return;if(!this.pendingProxyResolve&&this.state===p.LoginDialogShown&&c.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}k.preventDefault();let o;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),o=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(P);try{o=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}h(o==null?void 0:o.username,o==null?void 0:o.password)}async resolveProxyCredentials(k){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const P=await this.doResolveProxyCredentials(k);if(P)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),P;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(k){var P,c,h,o;this.logService.trace("auth#doResolveProxyCredentials - enter",k);const l=String(R.hash({scheme:k.scheme,host:k.host,port:k.port}));let t,r;try{const w=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,l);if(w){const f=JSON.parse(await this.encryptionMainService.decrypt(w));t=f.username,r=f.password}}catch(w){this.logService.error(w)}if(this.state!==p.StoredCredentialsUsed&&typeof t=="string"&&typeof r=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=p.StoredCredentialsUsed,{username:t,password:r};const s=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!s){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${s.id} to handle proxy login`);const a={authInfo:k,username:(c=(P=this.sessionCredentials)===null||P===void 0?void 0:P.username)!==null&&c!==void 0?c:t,password:(o=(h=this.sessionCredentials)===null||h===void 0?void 0:h.password)!==null&&o!==void 0?o:r,replyChannel:`vscode:proxyAuthResponse:${i.generateUuid()}`};s.sendWhenReady("vscode:openProxyAuthenticationDialog",M.CancellationToken.None,a),this.state=p.LoginDialogShown;const u=await new Promise(w=>{var f;const b=async(A,U,q)=>{var J;if(U===a.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${s.id}`),(J=s.win)===null||J===void 0||J.webContents.off("ipc-message",b),q){const te={username:q.username,password:q.password};try{if(q.remember){const B=await this.encryptionMainService.encrypt(JSON.stringify(te));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,l,B)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,l)}catch(B){this.logService.error(B)}w({username:te.username,password:te.password})}else w(void 0)};(f=s.win)===null||f===void 0||f.webContents.on("ipc-message",b)});return this.sessionCredentials=u,u}};d=he([ee(0,I.ILogService),ee(1,n.IWindowsMainService),ee(2,v.INativeHostMainService),ee(3,y.IEncryptionMainService),ee(4,E.IProductService)],d),e.ProxyAuthHandler=d}),define(Z[221],x([0,1,218,156,35,56,2,34,57,177,3,5,80,107,9,22,45]),function($,e,m,L,R,S,I,n,v,y,i,E,M,p,d,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function P(o){return o<21}let c=class{constructor(l,t,r,s,a){this.windowServer=l,this.options=t,this.windowsMainService=r,this.lifecycleMainService=s,this.nativeHostMainService=a,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new E.Emitter}async registerWindowDriver(l){return this.registeredWindowIds.add(l),this.reloadingWindowIds.delete(l),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(l){this.reloadingWindowIds.add(l)}async getWindowIds(){return this.windowsMainService.getWindows().map(l=>l.id).filter(l=>this.registeredWindowIds.has(l)&&!this.reloadingWindowIds.has(l))}async capturePage(l){await this.whenUnfrozen(l);const t=this.windowsMainService.getWindowById(l);if(!(t==null?void 0:t.win))throw new Error("Invalid window");return(await t.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(l){await this.whenUnfrozen(l);const t=this.windowsMainService.getWindowById(l);if(!t)throw new Error("Invalid window");this.reloadingWindowIds.add(l),this.lifecycleMainService.reload(t)}async exitApplication(){return this.nativeHostMainService.quit(void 0)}async dispatchKeybinding(l,t){await this.whenUnfrozen(l);const r=p.KeybindingParser.parseUserBinding(t);for(let s of r)await this._dispatchKeybinding(l,s)}async _dispatchKeybinding(l,t){if(t instanceof M.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const r=this.windowsMainService.getWindowById(l);if(!(r==null?void 0:r.win))throw new Error("Invalid window");const s=r.win.webContents,a=new v.SimpleKeybinding(!1,!1,!1,!1,t.keyCode),w=new y.USLayoutResolvedKeybinding(a.toChord(),i.OS).getElectronAccelerator(),f=[];t.ctrlKey&&f.push("ctrl"),t.metaKey&&f.push("meta"),t.shiftKey&&f.push("shift"),t.altKey&&f.push("alt"),s.sendInputEvent({type:"keyDown",keyCode:w,modifiers:f}),P(t.keyCode)||s.sendInputEvent({type:"char",keyCode:w,modifiers:f}),s.sendInputEvent({type:"keyUp",keyCode:w,modifiers:f}),await d.timeout(100)}async click(l,t,r,s){await(await this.getWindowDriver(l)).click(t,r,s)}async doubleClick(l,t){await(await this.getWindowDriver(l)).doubleClick(t)}async setValue(l,t,r){await(await this.getWindowDriver(l)).setValue(t,r)}async getTitle(l){return await(await this.getWindowDriver(l)).getTitle()}async isActiveElement(l,t){return await(await this.getWindowDriver(l)).isActiveElement(t)}async getElements(l,t,r){return await(await this.getWindowDriver(l)).getElements(t,r)}async getElementXY(l,t,r,s){return await(await this.getWindowDriver(l)).getElementXY(t,r,s)}async typeInEditor(l,t,r){await(await this.getWindowDriver(l)).typeInEditor(t,r)}async getTerminalBuffer(l,t){return await(await this.getWindowDriver(l)).getTerminalBuffer(t)}async writeInTerminal(l,t,r){await(await this.getWindowDriver(l)).writeInTerminal(t,r)}async getLocalizedStrings(l){return await(await this.getWindowDriver(l)).getLocalizedStrings()}async getWindowDriver(l){await this.whenUnfrozen(l);const t=`window:${l}`,r=new n.StaticRouter(a=>a===t),s=this.windowServer.getChannel("windowDriver",r);return new L.WindowDriverChannelClient(s)}async whenUnfrozen(l){for(;this.reloadingWindowIds.has(l);)await E.Event.toPromise(this.onDidReloadingChange.event)}};c=he([ee(2,R.IWindowsMainService),ee(3,g.ILifecycleMainService),ee(4,k.INativeHostMainService)],c),e.Driver=c;async function h(o,l,t,r){const s=t.driverVerbose,a=r.createInstance(c,o,{verbose:s}),u=new m.WindowDriverRegistryChannel(a);o.registerChannel("windowDriverRegistry",u);const w=await S.serve(l),f=new m.DriverChannel(a);return w.registerChannel("driver",f),I.combinedDisposable(w,o)}e.serve=h}),define(Z[222],x([0,1,59,56]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(R,S,I,n){const v=i=>n(i,void 0),y=m.createConnection({host:R,port:S},()=>{y.removeListener("error",v);const i=Buffer.alloc(16);for(let d=0;d<16;d++)i[d]=Math.round(Math.random()*256);const E=i.toString("base64");let M=[`GET ws://${/:/.test(R)?`[${R}]`:R}:${S}/?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`];y.write(M.join(`\r
`)+`\r
\r
`);const p=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(y.off("data",p),n(void 0,new L.NodeSocket(y)))};y.on("data",p)});y.once("error",v)}}}),define(Z[223],x([0,1,59,9,2,116,21,6,20,192,74,222,75]),function($,e,m,L,R,S,I,n,v,y,i,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function p(P,c,h,o,l){return new d(P,c,h,o,l).waitForReady()}class d extends R.Disposable{constructor(c,h,o,l,t){super();this.defaultTunnelHost=h,this.suggestedLocalPort=t,this.public=!1,this._socketsDispose=new Map,this._options=c,this._server=m.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=l,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(h=>{h()})}async waitForReady(){var c;let h=await S.findFreePortFaster((c=this.suggestedLocalPort)!==null&&c!==void 0?c:this.tunnelRemotePort,2,1e3),o=null;return this._server.listen(h,this.defaultTunnelHost),await this._barrier.wait(),o=this._server.address(),o||(h=0,this._server.listen(h,this.defaultTunnelHost),await this._barrier.wait(),o=this._server.address()),this.tunnelLocalPort=o.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${o.port}`,this}async _onConnection(c){c.pause();const h=await y.connectRemoteAgentTunnel(this._options,this.tunnelRemotePort),o=h.getSocket().socket,l=h.readEntireBuffer();h.dispose(),l.byteLength>0&&c.write(l.buffer),c.on("end",()=>{this._socketsDispose.delete(c.localAddress),o.end()}),c.on("close",()=>o.end()),c.on("error",()=>{this._socketsDispose.delete(c.localAddress),o.destroy()}),o.on("end",()=>c.end()),o.on("close",()=>c.end()),o.on("error",()=>{c.destroy()}),c.pipe(o),o.pipe(c),this._socketsDispose.set(c.localAddress,()=>{c.end(),o.end()})}}let g=class extends i.AbstractTunnelService{constructor(c,h,o,l,t){super(h);this.socketFactory=c,this.signService=o,this.productService=l,this.configurationService=t}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(c,h,o,l,t,r,s){const a=this.getTunnelFromMap(h,o);if(a)return++a.refcount,a.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,h,o,l,t,r,s);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${o} on local port ${l}.`);const u={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},w=p(u,this.defaultTunnelHost,h,o,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(h,o,w),w}}};g=he([ee(1,n.ILogService),ee(2,M.ISignService),ee(3,v.IProductService),ee(4,I.IConfigurationService)],g),e.BaseTunnelService=g;let k=class extends g{constructor(c,h,o,l){super(E.nodeSocketFactory,c,h,o,l)}};k=he([ee(0,n.ILogService),ee(1,M.ISignService),ee(2,v.IProductService),ee(3,I.IConfigurationService)],k),e.TunnelService=k}),define(Z[224],x([0,1,217,194,2,13,16,193,21,6,17,47,92]),function($,e,m,L,R,S,I,n,v,y,i,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let p=class extends R.Disposable{constructor(g,k,P){super();this.environmentService=k,this.logService=P,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,k){this.logService.trace("RequestService#request",g.url);const{proxyUrl:P,strictSSL:c}=this,h=Object.assign(Object.assign({},process.env),await M.resolveShellEnv(this.logService,this.environmentService.args,process.env)),o=g.agent?g.agent:await n.getProxyAgent(g.url||"",h,{proxyUrl:P,strictSSL:c});return g.agent=o,g.strictSSL=c,this.authorization&&(g.headers=Object.assign(Object.assign({},g.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(g,k)}async getNodeRequest(g){return(L.parse(g.url).protocol==="https:"?await new Promise((c,h)=>{$(["https"],c,h)}):await new Promise((c,h)=>{$(["http"],c,h)})).request}_request(g,k){return new Promise(async(P,c)=>{let h;const o=L.parse(g.url),l=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),t={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:S.isBoolean(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(t.auth=g.user+":"+g.password),h=l(t,r=>{const s=S.isNumber(g.followRedirects)?g.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&s>0&&r.headers.location)this._request(Object.assign(Object.assign({},g),{url:r.headers.location,followRedirects:s-1}),k).then(P,c);else{let a=r;r.headers["content-encoding"]==="gzip"&&(a=r.pipe(m.createGunzip())),P({res:r,stream:i.streamToBufferReadableStream(a)})}}),h.on("error",c),g.timeout&&h.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&h.write(g.data),h.end(),k.onCancellationRequested(()=>{h.abort(),c(I.canceled())})})}async resolveProxy(g){}};p=he([ee(0,v.IConfigurationService),ee(1,E.INativeEnvironmentService),ee(2,y.ILogService)],p),e.RequestService=p}),define(Z[225],x([0,1,224,14]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function R(I){return L.net.request}class S extends m.RequestService{request(n,v){return super.request(Object.assign(Object.assign({},n||{}),{getRawRequest:R}),v)}}e.RequestMainService=S}),define(Z[226],x([0,1,48,14,24,9,6,22,60,10,3,2,86,13,5,55]),function($,e,m,L,R,S,I,n,v,y,i,E,M,p,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let k=class extends E.Disposable{constructor(c,h,o,l,t,r,s){super();this.machineId=c,this.userEnv=h,this.environmentMainService=o,this.lifecycleMainService=l,this.logService=t,this.themeMainService=r,this.protocolMainService=s,this.firstWindowConnectionBarrier=new S.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new d.Emitter),this.onDidError=d.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),L.ipcMain.on("vscode:createSharedProcessMessageChannel",async(c,h)=>this.onWindowConnection(c,h))}async onWindowConnection(c,h){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const o=await this.connect();if(c.sender.isDestroyed())return o.close();c.sender.postMessage("vscode:createSharedProcessMessageChannelResult",h,[o])}onWillShutdown(){const c=this.window;!c||(!c.isDestroyed()&&!c.webContents.isDestroyed()&&c.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(c.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{c.close()}catch(h){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(c=>L.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),c()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(c=>L.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),c()}))})()),this._whenIpcReady}createWindow(){const c=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new L.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`],v8CacheOptions:i.browserCodeLoadingCacheStrategy,nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),c.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:m.default}),this.window.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",$).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=c=>{var h;this.logService.trace("SharedProcess#close prevented"),c.preventDefault(),((h=this.window)===null||h===void 0?void 0:h.isVisible())&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(c,h)=>this._onDidError.fire({type:2,details:h})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(c,h,o)=>this._onDidError.fire({type:3,details:{reason:o,exitCode:h}})))}async connect(){await this.whenIpcReady;const c=p.assertIsDefined(this.window);return M.connect(c)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){var c,h;return(h=(c=this.window)===null||c===void 0?void 0:c.isVisible())!==null&&h!==void 0?h:!1}};k=he([ee(2,R.IEnvironmentMainService),ee(3,n.ILifecycleMainService),ee(4,I.ILogService),ee(5,v.IThemeMainService),ee(6,g.IProtocolMainService)],k),e.SharedProcess=k}),define(Z[227],x([0,1,7,8,13,6,24,9,19,17]),function($,e,m,L,R,S,I,n,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class i{constructor(p,d,g){this.storagePath=p,this.logService=d,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new n.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(p){p.fileOperationResult!==1&&this.logService.error(p)}}getItem(p,d){const g=this.storage[p];return R.isUndefinedOrNull(g)?d:g}setItem(p,d){this.setItems([{key:p,data:d}])}setItems(p){let d=!1;for(const{key:g,data:k}of p)this.storage[g]!==k&&(R.isUndefinedOrNull(k)?R.isUndefined(this.storage[g])||(this.storage[g]=void 0,d=!0):(this.storage[g]=k,d=!0));d&&this.save()}removeItem(p){R.isUndefined(this.storage[p])||(this.storage[p]=void 0,this.save())}async save(p){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),p)}async doSave(){if(!this.initializing)return;await this.initializing;const p=JSON.stringify(this.storage,null,4);if(p!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,y.VSBuffer.fromString(p)),this.lastSavedStorageContents=p}catch(d){this.logService.error(d)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=i;let E=class Et{constructor(p,d,g){this.fileStorage=new i(m.URI.file(L.join(p.userDataPath,Et.STATE_FILE)),d,g)}async init(){return this.fileStorage.init()}getItem(p,d){return this.fileStorage.getItem(p,d)}setItem(p,d){this.fileStorage.setItem(p,d)}setItems(p){this.fileStorage.setItems(p)}removeItem(p){this.fileStorage.removeItem(p)}close(){return this.fileStorage.close()}};E.STATE_FILE="storage.json",E=he([ee(0,I.IEnvironmentMainService),ee(1,S.ILogService),ee(2,v.IFileService)],E),e.StateMainService=E}),define(Z[77],x([0,1,5,9,21,22,20,42,24,6,50,25]),function($,e,m,L,R,S,I,n,v,y,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function M(d,g,k){return`${k.updateUrl}/api/update/${d}/${g}/${k.commit}`}e.createUpdateURL=M;let p=class{constructor(g,k,P,c,h,o){this.lifecycleMainService=g,this.configurationService=k,this.environmentMainService=P,this.requestService=c,this.logService=h,this.productService=o,this._state=n.State.Uninitialized,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const g=R.getMigratedSettingValue(this.configurationService,"update.mode","update.channel"),k=this.getProductQuality(g);if(!k){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(k),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(n.State.Idle(this.getUpdateType())),g==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,P=>this.logService.error(P))}getProductQuality(g){return g==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(g=60*60*1e3){return L.timeout(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(g){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},E.CancellationToken.None).then(g=>g.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};p=he([ee(0,S.ILifecycleMainService),ee(1,R.IConfigurationService),ee(2,v.IEnvironmentMainService),ee(3,i.IRequestService),ee(4,y.ILogService),ee(5,I.IProductService)],p),e.AbstractUpdateService=p}),define(Z[228],x([0,1,14,2,5,46,21,22,42,32,24,6,77,50,20]),function($,e,m,L,R,S,I,n,v,y,i,E,M,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let g=class extends M.AbstractUpdateService{constructor(P,c,h,o,l,t,r){super(P,c,o,l,t,r);this.telemetryService=h,this.disposables=new L.DisposableStore}get onRawError(){return R.Event.fromNodeEventEmitter(m.autoUpdater,"error",(P,c)=>c)}get onRawUpdateNotAvailable(){return R.Event.fromNodeEventEmitter(m.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return R.Event.fromNodeEventEmitter(m.autoUpdater,"update-available",(P,c,h)=>({url:c,version:h,productVersion:h}))}get onRawUpdateDownloaded(){return R.Event.fromNodeEventEmitter(m.autoUpdater,"update-downloaded",(P,c,h,o)=>({releaseNotes:c,version:h,productVersion:h,date:o}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(P){this.logService.error("UpdateService error:",P);const h=(this.state.type==="checking for updates"?this.state.explicit:!0)?P:void 0;this.setState(v.State.Idle(1,h))}buildUpdateFeedUrl(P){let c;this.productService.darwinUniversalAssetId?c=this.productService.darwinUniversalAssetId:c=process.arch==="x64"?"darwin":"darwin-arm64";const h=M.createUpdateURL(c,P,this.productService);try{m.autoUpdater.setFeedURL({url:h})}catch(o){this.logService.error("Failed to set update feed URL",o);return}return h}doCheckForUpdates(P){this.setState(v.State.CheckingForUpdates(P)),m.autoUpdater.checkForUpdates()}onUpdateAvailable(P){this.state.type==="checking for updates"&&this.setState(v.State.Downloading(P))}onUpdateDownloaded(P){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:P.version}),this.setState(v.State.Ready(P)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(v.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),m.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([S.memoize],g.prototype,"onRawError",null),he([S.memoize],g.prototype,"onRawUpdateNotAvailable",null),he([S.memoize],g.prototype,"onRawUpdateAvailable",null),he([S.memoize],g.prototype,"onRawUpdateDownloaded",null),g=he([ee(0,n.ILifecycleMainService),ee(1,I.IConfigurationService),ee(2,y.ITelemetryService),ee(3,i.IEnvironmentMainService),ee(4,p.IRequestService),ee(5,E.ILogService),ee(6,d.IProductService)],g),e.DarwinUpdateService=g}),define(Z[229],x([0,1,20,21,22,42,32,24,6,77,50,25,45]),function($,e,m,L,R,S,I,n,v,y,i,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let p=class extends y.AbstractUpdateService{constructor(g,k,P,c,h,o,l,t){super(g,k,c,h,o,t);this.telemetryService=P,this.nativeHostMainService=l}buildUpdateFeedUrl(g){return y.createUpdateURL(`linux-${process.arch}`,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(S.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},E.CancellationToken.None).then(i.asJson).then(k=>{!k||!k.url||!k.version||!k.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(S.State.Idle(1))):this.setState(S.State.AvailableForDownload(k))}).then(void 0,k=>{this.logService.error(k),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const P=g?k.message||k:void 0;this.setState(S.State.Idle(1,P))}))}async doDownloadUpdate(g){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(S.State.Idle(1))}};p=he([ee(0,R.ILifecycleMainService),ee(1,L.IConfigurationService),ee(2,I.ITelemetryService),ee(3,n.IEnvironmentMainService),ee(4,i.IRequestService),ee(5,v.ILogService),ee(6,M.INativeHostMainService),ee(7,m.IProductService)],p),e.LinuxUpdateService=p}),define(Z[230],x([0,1,5,9,22,42,24,6,8,29,41,32]),function($,e,m,L,R,S,I,n,v,y,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let M=class{constructor(g,k,P){if(this.lifecycleMainService=g,this.logService=P,this._state=S.State.Uninitialized,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event,k.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(S.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,c=>this.logService.error(c))}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}scheduleCheckForUpdates(g=60*60*1e3){return L.timeout(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(g){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};M=he([ee(0,R.ILifecycleMainService),ee(1,I.IEnvironmentMainService),ee(2,n.ILogService)],M);let p=class extends M{constructor(g,k,P,c,h,o){super(P,c,h);this.snap=g,this.snapRevision=k,this.telemetryService=o;const l=y.watch(v.dirname(this.snap)),t=m.Event.fromNodeEventEmitter(l,"change",(u,w)=>w),r=m.Event.filter(t,u=>u==="current"),a=m.Event.debounce(r,(u,w)=>w,2e3)(()=>this.checkForUpdates(!1));P.onWillShutdown(()=>{a.dispose(),l.close()})}doCheckForUpdates(){this.setState(S.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(g=>{g?this.setState(S.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2)))},g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2,g.message||g))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),i.spawn("sleep 3 && "+v.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const g=await new Promise((P,c)=>y.realpath(`${v.dirname(this.snap)}/current`,(h,o)=>h?c(h):P(o))),k=v.basename(g);return this.snapRevision!==k}isLatestVersion(){return this.isUpdateAvailable().then(void 0,g=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};p=he([ee(2,R.ILifecycleMainService),ee(3,I.IEnvironmentMainService),ee(4,n.ILogService),ee(5,E.ITelemetryService)],p),e.SnapUpdateService=p}),define(Z[231],x([0,1,29,8,18,46,21,22,20,42,32,24,6,77,50,113,26,41,25,9,19,7,45]),function($,e,m,L,R,S,I,n,v,y,i,E,M,p,d,g,k,P,c,h,o,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(w,f=1e3){for(;!w();)await h.timeout(f)}let s;function a(){return typeof s=="undefined"&&(s=m.existsSync(L.join(L.dirname(process.execPath),"unins000.exe"))?0:1),s}let u=class extends p.AbstractUpdateService{constructor(f,b,A,U,q,J,te,B,Y){super(f,b,U,q,J,Y);this.telemetryService=A,this.fileService=te,this.nativeHostMainService=B}get cachePath(){const f=L.join(k.tmpdir(),`vscode-update-${this.productService.target}-${process.arch}`);return R.Promises.mkdir(f,{recursive:!0}).then(()=>f)}initialize(){super.initialize(),a()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(f){let b="win32";return process.arch!=="ia32"&&(b+=`-${process.arch}`),a()===1?b+="-archive":this.productService.target==="user"&&(b+="-user"),p.createUpdateURL(b,f,this.productService)}doCheckForUpdates(f){!this.url||(this.setState(y.State.CheckingForUpdates(f)),this.requestService.request({url:this.url},c.CancellationToken.None).then(d.asJson).then(b=>{const A=a();return!b||!b.url||!b.version||!b.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!f}),this.setState(y.State.Idle(A)),Promise.resolve(null)):A===1?(this.setState(y.State.AvailableForDownload(b)),Promise.resolve(null)):(this.setState(y.State.Downloading(b)),this.cleanup(b.version).then(()=>this.getUpdatePackagePath(b.version).then(U=>R.Promises.exists(U).then(q=>{if(q)return Promise.resolve(U);const J=b.url,te=b.hash,B=`${U}.tmp`;return this.requestService.request({url:J},c.CancellationToken.None).then(Y=>this.fileService.writeFile(l.URI.file(B),Y.stream)).then(te?()=>g.checksum(B,b.hash):()=>{}).then(()=>R.Promises.rename(B,U)).then(()=>U)})).then(U=>{const q=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:U},q&&b.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(y.State.Downloaded(b)):this.setState(y.State.Ready(b))})))}).then(void 0,b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!f});const A=f?b.message||b:void 0;this.setState(y.State.Idle(a(),A))}))}async doDownloadUpdate(f){f.update.url&&this.nativeHostMainService.openExternal(void 0,f.update.url),this.setState(y.State.Idle(a()))}async getUpdatePackagePath(f){const b=await this.cachePath;return L.join(b,`CodeSetup-${this.productService.quality}-${f}.exe`)}async cleanup(f=null){const b=f?J=>!new RegExp(`${this.productService.quality}-${f}\\.exe$`).test(J):()=>!0,A=await this.cachePath,q=(await R.Promises.readdir(A)).filter(b).map(async J=>{try{await R.Promises.unlink(L.join(A,J))}catch(te){}});await Promise.all(q)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const f=this.state.update;this.setState(y.State.Updating(f));const b=await this.cachePath;this.availableUpdate.updateFilePath=L.join(b,`CodeSetup-${this.productService.quality}-${f.version}.flag`),await R.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),P.spawn(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(y.State.Idle(a()))});const U=`${this.productService.win32MutexName}-ready`,q=await new Promise((J,te)=>{$(["windows-mutex"],J,te)});r(()=>q.isActive(U)).then(()=>this.setState(y.State.Ready(f)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?m.unlinkSync(this.availableUpdate.updateFilePath):P.spawn(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return a()}};he([S.memoize],u.prototype,"cachePath",null),u=he([ee(0,n.ILifecycleMainService),ee(1,I.IConfigurationService),ee(2,i.ITelemetryService),ee(3,E.IEnvironmentMainService),ee(4,d.IRequestService),ee(5,M.ILogService),ee(6,o.IFileService),ee(7,t.INativeHostMainService),ee(8,v.IProductService)],u),e.Win32UpdateService=u}),define(Z[53],x([0,1,28,24,8,18,29,3,5,6,102,40,10,2,15,4,154,20,14,13,51,52,101,31]),function($,e,m,L,R,S,I,n,v,y,i,E,M,p,d,g,k,P,c,h,o,l,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=g.createDecorator("workspacesManagementMainService");let s=class extends p.Disposable{constructor(u,w,f,b,A){super();this.environmentMainService=u,this.logService=w,this.backupMainService=f,this.dialogMainService=b,this.productService=A,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new v.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new v.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(u){return this.doResolveLocalWorkspace(u,w=>I.readFileSync(w,"utf8"))}resolveLocalWorkspace(u){return this.doResolveLocalWorkspace(u,w=>S.Promises.readFile(w,"utf8"))}doResolveLocalWorkspace(u,w){if(!!this.isWorkspacePath(u)&&u.scheme===M.Schemas.file)try{const f=w(u.fsPath);return f instanceof Promise?f.then(b=>this.doResolveWorkspace(u,b),b=>{}):this.doResolveWorkspace(u,f)}catch(f){return}}isWorkspacePath(u){return m.isUntitledWorkspace(u,this.environmentMainService)||m.hasWorkspaceFileExtension(u)}doResolveWorkspace(u,w){try{const f=this.doParseStoredWorkspace(u,w),b=i.getWorkspaceIdentifier(u);return{id:b.id,configPath:b.configPath,folders:m.toWorkspaceFolders(f.folders,b.configPath,d.extUriBiasedIgnorePathCase),remoteAuthority:f.remoteAuthority,transient:f.transient}}catch(f){this.logService.warn(f.toString())}}doParseStoredWorkspace(u,w){const f=E.parse(w);if(f&&Array.isArray(f.folders))f.folders=f.folders.filter(b=>m.isStoredWorkspaceFolder(b));else throw new Error(`${u.toString(!0)} looks like an invalid workspace file.`);return f}async createUntitledWorkspace(u,w){const{workspace:f,storedWorkspace:b}=this.newUntitledWorkspace(u,w),A=f.configPath.fsPath;return await S.Promises.mkdir(R.dirname(A),{recursive:!0}),await S.Promises.writeFile(A,JSON.stringify(b,null,"	")),f}createUntitledWorkspaceSync(u,w){const{workspace:f,storedWorkspace:b}=this.newUntitledWorkspace(u,w),A=f.configPath.fsPath;return I.mkdirSync(R.dirname(A),{recursive:!0}),S.writeFileSync(A,JSON.stringify(b,null,"	")),f}newUntitledWorkspace(u=[],w){const f=(Date.now()+Math.round(Math.random()*1e3)).toString(),b=d.joinPath(this.untitledWorkspacesHome,f),A=d.joinPath(b,m.UNTITLED_WORKSPACE_NAME),U=[];for(const q of u)U.push(m.getStoredWorkspaceFolder(q.uri,!0,q.name,b,!n.isWindows,d.extUriBiasedIgnorePathCase));return{workspace:i.getWorkspaceIdentifier(A),storedWorkspace:{folders:U,remoteAuthority:w}}}async getWorkspaceIdentifier(u){return i.getWorkspaceIdentifier(u)}isUntitledWorkspace(u){return m.isUntitledWorkspace(u.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(u){!this.isUntitledWorkspace(u)||(this.doDeleteUntitledWorkspaceSync(u),this._onDidDeleteUntitledWorkspace.fire(u))}async deleteUntitledWorkspace(u){this.deleteUntitledWorkspaceSync(u)}doDeleteUntitledWorkspaceSync(u){const w=d.originalFSPath(u.configPath);try{S.rimrafSync(R.dirname(w));const f=R.join(this.environmentMainService.workspaceStorageHome.fsPath,u.id);I.existsSync(f)&&S.writeFileSync(R.join(f,"obsolete"),"")}catch(f){this.logService.warn(`Unable to delete untitled workspace ${w} (${f}).`)}}getUntitledWorkspacesSync(){const u=[];try{const w=S.readdirSync(this.untitledWorkspacesHome.fsPath).map(f=>d.joinPath(this.untitledWorkspacesHome,f,m.UNTITLED_WORKSPACE_NAME));for(const f of w){const b=i.getWorkspaceIdentifier(f),A=this.resolveLocalWorkspaceSync(f);A?u.push({workspace:b,remoteAuthority:A.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(b)}}catch(w){w.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${w}).`)}return u}async enterWorkspace(u,w,f){if(!u||!u.win||!u.isReady||!await this.isValidTargetWorkspacePath(u,w,f))return;const A=this.doEnterWorkspace(u,i.getWorkspaceIdentifier(f));if(!!A)return this._onDidEnterWorkspace.fire({window:u,workspace:A.workspace}),A}async isValidTargetWorkspacePath(u,w,f){if(!f)return!0;if(m.isWorkspaceIdentifier(u.openedWorkspace)&&d.extUriBiasedIgnorePathCase.isEqual(u.openedWorkspace.configPath,f))return!1;if(t.findWindowOnWorkspaceOrFolder(w,f)){const b={title:this.productService.nameLong,type:"info",buttons:[r.mnemonicButtonLabel(k.localize(0,null))],message:k.localize(1,null,d.basename(f)),detail:k.localize(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(b,h.withNullAsUndefined(c.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(u,w){if(!u.config)return;u.focus();let f;return u.config.extensionDevelopmentPath||(f=this.backupMainService.registerWorkspaceBackupSync({workspace:w,remoteAuthority:u.remoteAuthority},u.config.backupPath)),m.isWorkspaceIdentifier(u.openedWorkspace)&&this.isUntitledWorkspace(u.openedWorkspace)&&this.deleteUntitledWorkspaceSync(u.openedWorkspace),u.config.workspace=w,u.config.backupPath=f,{workspace:w,backupPath:f}}};s=he([ee(0,L.IEnvironmentMainService),ee(1,y.ILogService),ee(2,o.IBackupMainService),ee(3,l.IDialogMainService),ee(4,P.IProductService)],s),e.WorkspacesManagementMainService=s}),define(Z[103],x([0,1,6,99,3,4,35,18,53,21,7,14,36,54,25,28,13]),function($,e,m,L,R,S,I,n,v,y,i,E,M,p,d,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=S.createDecorator(e.ID);let P=class{constructor(h,o,l,t,r){this.logService=h,this.windowsMainService=o,this.urlService=l,this.workspacesManagementMainService=t,this.configurationService=r}async start(h,o){this.logService.trace("Received data from other instance: ",h,o),R.isMacintosh&&E.app.focus({steal:!0});const l=this.parseOpenUrl(h);if(l.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:r,url:s}of l)this.urlService.open(r,{originalUrl:s})})}else return this.startOpenWindow(h,o)}parseOpenUrl(h){return h["open-url"]&&h._urls&&h._urls.length>0?M.coalesce(h._urls.map(o=>{try{return{uri:i.URI.parse(o),url:o}}catch(l){return null}})):[]}async startOpenWindow(h,o){const l=p.isLaunchedFromCli(o)?0:4;let t=[];const r=h.wait&&h.waitMarkerFilePath?i.URI.file(h.waitMarkerFilePath):void 0,s=h.remote||void 0;if(h.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(h.extensionDevelopmentPath,{context:l,cli:h,userEnv:o,waitMarkerFileURI:r,remoteAuthority:s});else if(!h._.length&&!h["folder-uri"]&&!h["file-uri"]){let a=!1;if(h["new-window"]||h["unity-launch"])a=!0;else if(h["reuse-window"])a=!1;else{const u=this.configurationService.getValue("window");switch((u==null?void 0:u.openWithoutArgumentsInNewWindow)||"default"){case"on":a=!0;break;case"off":a=!1;break;default:a=!R.isMacintosh}}if(a)t=this.windowsMainService.open({context:l,cli:h,userEnv:o,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:r,remoteAuthority:s});else{const u=this.windowsMainService.getLastActiveWindow();u?(u.focus(),t=[u]):t=this.windowsMainService.open({context:l,cli:h,forceEmpty:!0,remoteAuthority:s})}}else t=this.windowsMainService.open({context:l,cli:h,userEnv:o,forceNewWindow:h["new-window"],preferNewWindow:!h["reuse-window"]&&!h.wait,forceReuseWindow:h["reuse-window"],diffMode:h.diff,addMode:h.add,noRecentEntry:!!h["skip-add-to-recently-opened"],waitMarkerFileURI:r,gotoLineMode:h.goto,remoteAuthority:s});if(r&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,n.whenDeleted(r.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const h=[];return E.BrowserWindow.getAllWindows().forEach(o=>{const l=this.windowsMainService.getWindowById(o.id);l?h.push(this.codeWindowToInfo(l)):h.push(this.browserWindowToInfo(o))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(h){const o=this.windowsMainService.getWindows();return(await Promise.all(o.map(t=>new Promise(r=>{const s=t.remoteAuthority;if(s){const a=`vscode:getDiagnosticInfoResponse${t.id}`,u={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",d.CancellationToken.None,{replyChannel:a,args:u}),E.ipcMain.once(a,(w,f)=>{f||r({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),r(f)}),setTimeout(()=>{r({hostName:s,errorMessage:`Fetching remote diagnostics for '${s}' timed out.`})},5e3)}else r(void 0)})))).filter(t=>!!t)}getFolderURIs(h){const o=[],l=h.openedWorkspace;if(g.isSingleFolderWorkspaceIdentifier(l))o.push(l.uri);else if(g.isWorkspaceIdentifier(l)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(l.configPath);t&&t.folders.forEach(s=>{o.push(s.uri)})}return o}codeWindowToInfo(h){const o=this.getFolderURIs(h),l=k.assertIsDefined(h.win);return this.browserWindowToInfo(l,o,h.remoteAuthority)}browserWindowToInfo(h,o=[],l){return{pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:o,remoteAuthority:l}}};P=he([ee(0,m.ILogService),ee(1,I.IWindowsMainService),ee(2,L.IURLService),ee(3,v.IWorkspacesManagementMainService),ee(4,y.IConfigurationService)],P),e.LaunchMainService=P}),define(Z[232],x([0,1,144,26,48,14,103,70,24,3,6,84,52,4,61,10,45,55,2,31,20]),function($,e,m,L,R,S,I,n,v,y,i,E,M,p,d,g,k,P,c,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=p.createDecorator("issueMainService");let l=class It{constructor(r,s,a,u,w,f,b,A,U){this.userEnv=r,this.environmentMainService=s,this.launchMainService=a,this.logService=u,this.diagnosticsService=w,this.dialogMainService=f,this.nativeHostMainService=b,this.protocolMainService=A,this.productService=U,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){S.ipcMain.on("vscode:issueSystemInfoRequest",async r=>{const[s,a]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),u=await this.diagnosticsService.getSystemInfo(s,a);this.safeSend(r,"vscode:issueSystemInfoResponse",u)}),S.ipcMain.on("vscode:listProcesses",async r=>{const s=[];try{const a=await this.launchMainService.getMainProcessId();s.push({name:m.localize(0,null),rootProcess:await E.listProcesses(a)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(w=>{n.isRemoteDiagnosticError(w)?s.push({name:w.hostName,rootProcess:w}):w.processes&&s.push({name:w.hostName,rootProcess:w.processes})})}catch(a){this.logService.error(`Listing processes failed: ${a}`)}this.safeSend(r,"vscode:listProcessesResponse",s)}),S.ipcMain.on("vscode:issueReporterClipboard",async r=>{const s={title:this.productService.nameLong,message:m.localize(1,null),type:"warning",buttons:[h.mnemonicButtonLabel(m.localize(2,null)),h.mnemonicButtonLabel(m.localize(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const a=await this.dialogMainService.showMessageBox(s,this.issueReporterWindow);this.safeSend(r,"vscode:issueReporterClipboardResponse",a.response===0)}}),S.ipcMain.on("vscode:issuePerformanceInfoRequest",async r=>{const s=await this.getPerformanceInfo();this.safeSend(r,"vscode:issuePerformanceInfoResponse",s)}),S.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const r={title:this.productService.nameLong,message:m.localize(4,null),type:"warning",buttons:[h.mnemonicButtonLabel(m.localize(5,null)),h.mnemonicButtonLabel(m.localize(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(r,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),S.ipcMain.on("vscode:workbenchCommand",(r,s)=>{const{id:a,from:u,args:w}=s;let f;switch(u){case"issueReporter":f=this.issueReporterParentWindow;break;case"processExplorer":f=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${u}`)}f&&f.webContents.send("vscode:runAction",{id:a,from:u,args:w})}),S.ipcMain.on("vscode:openExternal",(r,s)=>{this.nativeHostMainService.openExternal(void 0,s)}),S.ipcMain.on("vscode:closeIssueReporter",r=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),S.ipcMain.on("vscode:closeProcessExplorer",r=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),S.ipcMain.on("vscode:windowsInfoRequest",async r=>{const s=await this.launchMainService.getMainProcessInfo();this.safeSend(r,"vscode:windowsInfoResponse",s.windows)})}safeSend(r,s,...a){r.sender.isDestroyed()||r.sender.send(s,...a)}async openReporter(r){var s;if(!this.issueReporterWindow&&(this.issueReporterParentWindow=S.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const a=new c.DisposableStore,u=a.add(this.protocolMainService.createIPCObjectUrl()),w=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(w,u,{backgroundColor:r.styles.backgroundColor,title:m.localize(7,null),zoomLevel:r.zoomLevel,alwaysOnTop:!1}),u.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:r,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:L.type(),arch:L.arch(),release:L.release()},product:R.default}),this.issueReporterWindow.loadURL(g.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",$,!0).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,a.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,a.dispose())})}(s=this.issueReporterWindow)===null||s===void 0||s.focus()}async openProcessExplorer(r){var s;if(!this.processExplorerWindow&&(this.processExplorerParentWindow=S.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const a=new c.DisposableStore,u=a.add(this.protocolMainService.createIPCObjectUrl()),w=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(w,u,{backgroundColor:r.styles.backgroundColor,title:m.localize(8,null),zoomLevel:r.zoomLevel,alwaysOnTop:!0}),u.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:r,product:R.default}),this.processExplorerWindow.loadURL(g.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",$,!0).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,a.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,a.dispose())})}(s=this.processExplorerWindow)===null||s===void 0||s.focus()}createBrowserWindow(r,s,a){const u=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:r.width,height:r.height,minWidth:300,minHeight:200,x:r.x,y:r.y,title:a.title,backgroundColor:a.backgroundColor||It.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:g.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,additionalArguments:[`--vscode-window-config=${s.resource.toString()}`,"--context-isolation"],v8CacheOptions:y.browserCodeLoadingCacheStrategy,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:d.zoomLevelToZoomFactor(a.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:a.alwaysOnTop});return u.setMenuBarVisibility(!1),u}async getSystemStatus(){const[r,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(r,s)}getWindowPosition(r,s,a){let u;const w=S.screen.getAllDisplays();if(w.length===1)u=w[0];else{if(y.isMacintosh){const A=S.screen.getCursorScreenPoint();u=S.screen.getDisplayNearestPoint(A)}!u&&r&&(u=S.screen.getDisplayMatching(r.getBounds())),u||(u=S.screen.getPrimaryDisplay()||w[0])}const f={width:s,height:a},b=u.bounds;return f.x=b.x+b.width/2-f.width/2,f.y=b.y+b.height/2-f.height/2,b.width>0&&b.height>0&&(f.x<b.x&&(f.x=b.x),f.y<b.y&&(f.y=b.y),f.x>b.x+b.width&&(f.x=b.x),f.y>b.y+b.height&&(f.y=b.y),f.width>b.width&&(f.width=b.width),f.height>b.height&&(f.height=b.height)),f}async getPerformanceInfo(){try{const[r,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(r,s)}catch(r){throw this.logService.warn("issueService#getPerformanceInfo ",r.message),r}}};l.DEFAULT_BACKGROUND_COLOR="#1E1E1E",l=he([ee(1,v.IEnvironmentMainService),ee(2,I.ILaunchMainService),ee(3,i.ILogService),ee(4,n.IDiagnosticsService),ee(5,M.IDialogMainService),ee(6,k.INativeHostMainService),ee(7,P.IProtocolMainService),ee(8,o.IProductService)],l),e.IssueMainService=l}),define(Z[233],x([0,1,8,150,72,5,7,14,24,6,21,20,61,2,3,35,28,53,51,200,60,32,52,31,204,22,100,19,10,54,25,55]),function($,e,m,L,R,S,I,n,v,y,i,E,M,p,d,g,k,P,c,h,o,l,t,r,s,a,u,w,f,b,A,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var q;(function(te){te[te.NONE=0]="NONE",te[te.LOADING=1]="LOADING",te[te.NAVIGATING=2]="NAVIGATING",te[te.READY=3]="READY"})(q||(q={}));let J=class extends p.Disposable{constructor(B,Y,G,C,z,X,H,W,D,O,F,T,_,N){super();this.logService=Y,this.environmentMainService=G,this.fileService=C,this.configurationService=X,this.themeMainService=H,this.workspacesManagementMainService=W,this.backupMainService=D,this.telemetryService=O,this.dialogMainService=F,this.lifecycleMainService=T,this.productService=_,this.protocolMainService=N,this._onWillLoad=this._register(new S.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new S.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new S.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new S.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this._lastFocusTime=-1,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.readyState=0;{const[K,V]=this.restoreWindowState(B.state);this.windowState=K,this.logService.trace("window#ctor: using window state",K);const Q=this.windowState.mode===0||this.windowState.mode===3,ne=this.configurationService.getValue("window"),se={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:M.WindowMinimumSize.WIDTH,minHeight:M.WindowMinimumSize.HEIGHT,show:!Q,title:this.productService.nameLong,webPreferences:Object.assign({preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,additionalArguments:this.environmentMainService.sandbox?[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`,"--context-isolation"]:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:d.browserCodeLoadingCacheStrategy,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,webviewTag:!0,zoomFactor:M.zoomLevelToZoomFactor(ne==null?void 0:ne.zoomLevel)},this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1})};d.browserCodeLoadingCacheStrategy?this.logService.info(`window: using vscode-file:// protocol and V8 cache options: ${d.browserCodeLoadingCacheStrategy}`):this.logService.info("window: vscode-file:// protocol is explicitly disabled"),d.isLinux?se.icon=m.join(this.environmentMainService.appRoot,"resources/linux/code.png"):d.isWindows&&!this.environmentMainService.isBuilt&&(se.icon=m.join(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),d.isMacintosh&&!this.useNativeFullScreen()&&(se.fullscreenable=!1),d.isMacintosh&&(se.acceptFirstMouse=!0,(ne==null?void 0:ne.clickThroughInactive)===!1&&(se.acceptFirstMouse=!1));const ae=d.isMacintosh&&(ne==null?void 0:ne.nativeTabs)===!0;ae&&(se.tabbingIdentifier=this.productService.nameShort);const le=M.getTitleBarStyle(this.configurationService)==="custom";if(le&&(se.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,d.isMacintosh||(se.frame=!1)),R.mark("code/willCreateCodeBrowserWindow"),this._win=new n.BrowserWindow(se),R.mark("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),d.isMacintosh&&le&&this._win.setSheetOffset(22),d.isMacintosh&&V&&(!ae||n.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(re=>typeof re=="number")){const re=this.windowState;this._win.setBounds({width:re.width,height:re.height,x:re.x,y:re.y})}Q&&(R.mark("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),R.mark("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=h.resolveMarketplaceHeaders(this.productService.version,this.environmentMainService,this.fileService,{get:K=>z.globalStorage.get(K),store:(K,V)=>z.globalStorage.set(K,V)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){var B;return(B=this.currentConfig)===null||B===void 0?void 0:B.backupPath}get openedWorkspace(){var B;return(B=this.currentConfig)===null||B===void 0?void 0:B.workspace}get remoteAuthority(){var B;return(B=this.currentConfig)===null||B===void 0?void 0:B.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){var B;return!!((B=this.currentConfig)===null||B===void 0?void 0:B.extensionDevelopmentPath)}get isExtensionTestHost(){var B;return!!((B=this.currentConfig)===null||B===void 0?void 0:B.extensionTestsPath)}get isExtensionDevelopmentTestFromCli(){var B;return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!((B=this.currentConfig)===null||B===void 0?void 0:B.debugId)}setRepresentedFilename(B){d.isMacintosh?this._win.setRepresentedFilename(B):this.representedFilename=B}getRepresentedFilename(){return d.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(B){d.isMacintosh&&this._win.setDocumentEdited(B),this.documentEdited=B}isDocumentEdited(){return d.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(B){d.isMacintosh&&(B==null?void 0:B.force)&&n.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(B=>{if(this.isReady)return B(this);this.whenReadyCallbacks.push(B)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(B=>{function Y(){G.dispose(),C.dispose(),B()}const G=this.onDidClose(()=>Y()),C=this.onWillLoad(()=>Y())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(z,X)=>this.onWindowError(2,X)),this._win.webContents.on("did-fail-load",(z,X,H)=>this.onWindowError(3,{reason:H,exitCode:X})),this._win.webContents.on("will-prevent-unload",z=>{z.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const B=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),Y=z=>{for(let X=z;X;X=X.parent)if(X.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},G=z=>z.resourceType==="xhr"||Y(z.frame);this._win.webContents.session.webRequest.onBeforeRequest((z,X)=>{const H=I.URI.parse(z.url);return H.path.endsWith(".svg")&&!(B.has(H.scheme)||H.path.includes(f.Schemas.vscodeRemoteResource))?X({cancel:!G(z)}):X({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((z,X)=>{const H=z.responseHeaders,W=H["content-type"]||H["Content-Type"];if(W&&Array.isArray(W)){const D=I.URI.parse(z.url);if(D.path.endsWith(".svg")&&B.has(D.scheme))return H["Content-Type"]=["image/svg+xml"],X({cancel:!1,responseHeaders:H});if(!D.path.includes(f.Schemas.vscodeRemoteResource)&&W.some(O=>O.toLowerCase().includes("image/svg")))return X({cancel:!G(z)})}return X({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",z=>{this.currentConfig&&(this.currentConfig.maximized=!0),n.app.emit("browser-window-maximize",z,this._win)}),this._win.on("unmaximize",z=>{this.currentConfig&&(this.currentConfig.maximized=!1),n.app.emit("browser-window-unmaximize",z,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",A.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",A.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(z=>this.onDidDeleteUntitledWorkspace(z)));const C=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:C},async(z,X)=>{const H=await this.marketplaceHeadersPromise;X({cancel:!1,requestHeaders:Object.assign(z.requestHeaders,H)})})}async onWindowError(B,Y){var G;switch(B){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${(Y==null?void 0:Y.reason)||"<unknown>"}, code: ${(Y==null?void 0:Y.exitCode)||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${(Y==null?void 0:Y.reason)||"<unknown>"}, code: ${(Y==null?void 0:Y.exitCode)||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:B,reason:Y==null?void 0:Y.reason,code:Y==null?void 0:Y.exitCode}),B){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(B===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const C=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[r.mnemonicButtonLabel(L.localize(0,null)),r.mnemonicButtonLabel(L.localize(1,null)),r.mnemonicButtonLabel(L.localize(2,null))],message:L.localize(3,null),detail:L.localize(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(!this._win)return;C.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):C.response===2&&this.destroyWindow()}else if(B===2){let C;Y?C=L.localize(6,null,Y.reason,(G=Y.exitCode)!==null&&G!==void 0?G:"<unknown>"):C=L.localize(5,null);const z=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[r.mnemonicButtonLabel(L.localize(7,null)),r.mnemonicButtonLabel(L.localize(8,null))],message:C,detail:L.localize(9,null),noLink:!0,defaultId:0},this._win);if(!this._win)return;z.response===0?this.reload():z.response===1&&this.destroyWindow()}break}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(B){var Y;((Y=this.openedWorkspace)===null||Y===void 0?void 0:Y.id)===B.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const B=this.getMenuBarVisibility();B!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=B,this.setMenuBarVisibility(B));let Y=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;(Y==null?void 0:Y.endsWith("/"))&&(Y=Y.substr(0,Y.length-1));const G=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((Y||"").indexOf("@")===-1&&(Y!==this.currentHttpProxy||G!==this.currentNoProxy)){this.currentHttpProxy=Y,this.currentNoProxy=G;const C=Y||"",z=G?`${G},<local>`:"<local>";this.logService.trace(`Setting proxy to '${C}', bypassing '${z}'`),this._win.webContents.session.setProxy({proxyRules:C,proxyBypassRules:z,pacScript:""})}}addTabbedWindow(B){d.isMacintosh&&B.win&&this._win.addTabbedWindow(B.win)}load(B,Y=Object.create(null)){this.isDocumentEdited()&&(!Y.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),Y.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(B,Y),this.readyState===0?this.currentConfig=B:(this.pendingLoadConfig=B,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",$).toString(!0)),!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&(this.showTimeoutHandle=setTimeout(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)),this._onWillLoad.fire({workspace:B.workspace})}updateConfiguration(B,Y){var G,C;const z=(C=(G=this.currentConfig)!==null&&G!==void 0?G:this.pendingLoadConfig)===null||C===void 0?void 0:C.userEnv;z&&b.isLaunchedFromCli(z)&&!b.isLaunchedFromCli(B.userEnv)&&(B.userEnv=Object.assign(Object.assign({},z),B.userEnv)),process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(B.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),Y.disableExtensions!==void 0&&(B["disable-extensions"]=Y.disableExtensions),B.fullscreen=this.isFullScreen,B.maximized=this._win.isMaximized(),B.partsSplash=this.themeMainService.getWindowSplash(),R.mark("code/willOpenNewWindow"),B.perfMarks=R.getMarks(),this.configObjectUrl.update(B)}async reload(B){const Y=Object.assign({},this.currentConfig);Y.workspace=await this.validateWorkspaceBeforeReload(Y),delete Y.filesToOpenOrCreate,delete Y.filesToDiff,delete Y.filesToWait,this.isExtensionDevelopmentHost&&B&&(Y.verbose=B.verbose,Y.debugId=B.debugId,Y["inspect-extensions"]=B["inspect-extensions"],Y["inspect-brk-extensions"]=B["inspect-brk-extensions"],Y["extensions-dir"]=B["extensions-dir"]),Y.isInitialStartup=!1,this.load(Y,{isReload:!0,disableExtensions:B==null?void 0:B["disable-extensions"]})}async validateWorkspaceBeforeReload(B){if(k.isWorkspaceIdentifier(B.workspace)){const Y=B.workspace.configPath;if(Y.scheme===f.Schemas.file){const G=await this.workspacesManagementMainService.resolveLocalWorkspace(Y);if(!G||G.transient)return}}else if(k.isSingleFolderWorkspaceIdentifier(B.workspace)){const Y=B.workspace.uri;if(Y.scheme===f.Schemas.file&&!await this.fileService.exists(Y))return}return B.workspace}serializeWindowState(){if(!this._win)return g.defaultWindowState();if(this.isFullScreen){let G;try{G=n.screen.getDisplayMatching(this.getBounds())}catch(X){}const C=g.defaultWindowState();return{mode:3,display:G?G.id:void 0,width:this.windowState.width||C.width,height:this.windowState.height||C.height,x:this.windowState.x||0,y:this.windowState.y||0}}const B=Object.create(null);let Y;if(!d.isMacintosh&&this._win.isMaximized()?Y=0:Y=1,Y===0?B.mode=0:B.mode=1,Y===1||Y===0){let G;Y===1?G=this.getBounds():G=this._win.getNormalBounds(),B.x=G.x,B.y=G.y,B.width=G.width,B.height=G.height}return B}restoreWindowState(B){R.mark("code/willRestoreCodeWindowState");let Y=!1;if(B)try{const G=n.screen.getAllDisplays();Y=G.length>1,B=this.validateWindowState(B,G)}catch(G){this.logService.warn(`Unexpected error validating window state: ${G}
${G.stack}`)}return R.mark("code/didRestoreCodeWindowState"),[B||g.defaultWindowState(),Y]}validateWindowState(B,Y){var G,C;if(this.logService.trace(`window#validateWindowState: validating window state on ${Y.length} display(s)`,B),typeof B.x!="number"||typeof B.y!="number"||typeof B.width!="number"||typeof B.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(B.width<=0||B.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(Y.length===1){const H=this.getWorkingArea(Y[0]);if(H){let W=function(){!B||typeof B.x!="number"||typeof B.y!="number"||!H||(B.x<H.x&&(B.x=H.x),B.y<H.y&&(B.y=H.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",H),W(),B.width>H.width&&(B.width=H.width),B.height>H.height&&(B.height=H.height),B.x>H.x+H.width-128&&(B.x=H.x+H.width-B.width),B.y>H.y+H.height-128&&(B.y=H.y+H.height-B.height),W()}return B}if(B.display&&B.mode===3){const H=Y.find(W=>W.id===B.display);if(H&&typeof((G=H.bounds)===null||G===void 0?void 0:G.x)=="number"&&typeof((C=H.bounds)===null||C===void 0?void 0:C.y)=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const W=g.defaultWindowState(3);return W.x=H.bounds.x,W.y=H.bounds.y,W}}let z,X;try{z=n.screen.getDisplayMatching({x:B.x,y:B.y,width:B.width,height:B.height}),X=this.getWorkingArea(z)}catch(H){}if(z&&X&&B.x+B.width>X.x&&B.y+B.height>X.y&&B.x<X.x+X.width&&B.y<X.y+X.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",X),B}getWorkingArea(B){if(B.workArea.width>0&&B.workArea.height>0)return B.workArea;if(B.bounds.width>0&&B.bounds.height>0)return B.bounds}getBounds(){const[B,Y]=this._win.getPosition(),[G,C]=this._win.getSize();return{x:B,y:Y,width:G,height:C}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(B){this.useNativeFullScreen()?this.setNativeFullScreen(B):this.setSimpleFullScreen(B),this.sendWhenReady(B?"vscode:enterFullScreen":"vscode:leaveFullScreen",A.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(B){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(B)}setSimpleFullScreen(B){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(B),this._win.webContents.focus()}useNativeFullScreen(){const B=this.configurationService.getValue("window");return!B||typeof B.nativeFullScreen!="boolean"||B.nativeTabs?!0:B.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let B=M.getMenuBarVisibility(this.configurationService);return["visible","toggle","hidden"].indexOf(B)<0&&(B="classic"),B}setMenuBarVisibility(B,Y=!0){d.isMacintosh||(B==="toggle"&&Y&&this.send("vscode:showInfoMessage",L.localize(10,null)),B==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(B)}):this.doSetMenuBarVisibility(B))}doSetMenuBarVisibility(B){const Y=this.isFullScreen;switch(B){case"classic":this._win.setMenuBarVisibility(!Y),this._win.autoHideMenuBar=Y;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(d.isMacintosh)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(B,Y,...G){this.isReady?this.send(B,...G):this.ready().then(()=>{Y.isCancellationRequested||this.send(B,...G)})}send(B,...Y){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${B} for window that is destroyed`);return}this._win.webContents.send(B,...Y)}}updateTouchBar(B){!d.isMacintosh||this.touchBarGroups.forEach((Y,G)=>{const C=B[G];Y.segments=this.createTouchBarGroupSegments(C)})}createTouchBar(){if(!!d.isMacintosh){for(let B=0;B<10;B++){const Y=this.createTouchBarGroup();this.touchBarGroups.push(Y)}this._win.setTouchBar(new n.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(B=[]){const Y=this.createTouchBarGroupSegments(B),G=new n.TouchBar.TouchBarSegmentedControl({segments:Y,mode:"buttons",segmentStyle:"automatic",change:C=>{this.sendWhenReady("vscode:runAction",A.CancellationToken.None,{id:G.segments[C].id,from:"touchbar"})}});return G}createTouchBarGroupSegments(B=[]){return B.map(G=>{var C,z;let X;G.icon&&!s.ThemeIcon.isThemeIcon(G.icon)&&((z=(C=G.icon)===null||C===void 0?void 0:C.dark)===null||z===void 0?void 0:z.scheme)===f.Schemas.file&&(X=n.nativeImage.createFromPath(I.URI.revive(G.icon.dark).fsPath),X.isEmpty()&&(X=void 0));let H;return typeof G.title=="string"?H=G.title:H=G.title.value,{id:G.id,label:X?void 0:H,icon:X}})}dispose(){super.dispose(),this.showTimeoutHandle&&clearTimeout(this.showTimeoutHandle),this._win=null}};J=he([ee(1,y.ILogService),ee(2,v.IEnvironmentMainService),ee(3,w.IFileService),ee(4,u.IStorageMainService),ee(5,i.IConfigurationService),ee(6,o.IThemeMainService),ee(7,P.IWorkspacesManagementMainService),ee(8,c.IBackupMainService),ee(9,l.ITelemetryService),ee(10,t.IDialogMainService),ee(11,a.ILifecycleMainService),ee(12,E.IProductService),ee(13,U.IProtocolMainService)],J),e.CodeWindow=J}),define(Z[62],x([0,1,153,36,39,14,6,31,5,3,28,53,9,15,7,10,18,22,4,2]),function($,e,m,L,R,S,I,n,v,y,i,E,M,p,d,g,k,P,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=c.createDecorator("workspacesHistoryMainService");let o=class Ke extends h.Disposable{constructor(w,f,b,A){super();this.stateMainService=w,this.logService=f,this.workspacesManagementMainService=b,this.lifecycleMainService=A,this._onDidChangeRecentlyOpened=this._register(new v.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new M.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(w=>this.addRecentlyOpened([{workspace:w.workspace}])))}handleWindowsJumpList(){!y.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(w){const f=[],b=[];for(let A of w)if(i.isRecentWorkspace(A))!this.workspacesManagementMainService.isUntitledWorkspace(A.workspace)&&r(f,A.workspace)===-1&&f.push(A);else if(i.isRecentFolder(A))s(f,A.folderUri)===-1&&f.push(A);else{const U=a(b,A.fileUri)>=0,q=A.fileUri.scheme===g.Schemas.file&&Ke.COMMON_FILES_FILTER.indexOf(p.basename(A.fileUri))>=0;!U&&!q&&(b.push(A),y.isWindows&&A.fileUri.scheme===g.Schemas.file&&S.app.addRecentDocument(A.fileUri.fsPath))}this.addEntriesFromStorage(f,b),f.length>Ke.MAX_TOTAL_RECENT_ENTRIES&&(f.length=Ke.MAX_TOTAL_RECENT_ENTRIES),b.length>Ke.MAX_TOTAL_RECENT_ENTRIES&&(b.length=Ke.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:f,files:b}),this._onDidChangeRecentlyOpened.fire(),y.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(w){const f=q=>{const J=t(q);for(const te of w)if(p.extUriBiasedIgnorePathCase.isEqual(te,J))return!1;return!0},b=this.getRecentlyOpened(),A=b.workspaces.filter(f),U=b.files.filter(f);(A.length!==b.workspaces.length||U.length!==b.files.length)&&(this.saveRecentlyOpened({files:U,workspaces:A}),this._onDidChangeRecentlyOpened.fire(),y.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!y.isMacintosh)return;S.app.clearRecentDocuments();const w=this.getRecentlyOpened(),f=[];let b=0;for(let U=0;U<w.workspaces.length&&b<Ke.MAX_MACOS_DOCK_RECENT_WORKSPACES;U++){const q=t(w.workspaces[U]);if(q.scheme===g.Schemas.file){const J=p.originalFSPath(q);await k.Promises.exists(J)&&(f.push(J),b++)}}const A=[];for(let U=0;U<w.files.length&&b<Ke.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;U++){const q=t(w.files[U]);if(q.scheme===g.Schemas.file){const J=p.originalFSPath(q);if(Ke.COMMON_FILES_FILTER.includes(p.basename(q))||f.includes(J))continue;await k.Promises.exists(J)&&(A.push(J),b++)}}A.reverse().forEach(U=>S.app.addRecentDocument(U)),f.reverse().forEach(U=>S.app.addRecentDocument(U))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(w){var f,b;const A=[],U=[],q=(f=w==null?void 0:w.config)===null||f===void 0?void 0:f.workspace;i.isWorkspaceIdentifier(q)&&!this.workspacesManagementMainService.isUntitledWorkspace(q)?A.push({workspace:q}):i.isSingleFolderWorkspaceIdentifier(q)&&A.push({folderUri:q.uri});const J=(b=w==null?void 0:w.config)===null||b===void 0?void 0:b.filesToOpenOrCreate;if(J)for(let te of J){const B=te.fileUri;B&&a(U,B)===-1&&U.push({fileUri:B})}return this.addEntriesFromStorage(A,U),{workspaces:A,files:U}}addEntriesFromStorage(w,f){let b=this.getRecentlyOpenedFromStorage();for(let A of b.workspaces){let U=i.isRecentFolder(A)?s(w,A.folderUri):r(w,A.workspace);U>=0?w[U].label=w[U].label||A.label:w.push(A)}for(let A of b.files){let U=a(f,A.fileUri);U>=0?f[U].label=f[U].label||A.label:f.push(A)}}getRecentlyOpenedFromStorage(){const w=this.stateMainService.getItem(Ke.recentlyOpenedStorageKey);return i.restoreRecentlyOpened(w,this.logService)}saveRecentlyOpened(w){const f=i.toStoreData(w);this.stateMainService.setItem(Ke.recentlyOpenedStorageKey,f)}updateWindowsJumpList(){if(!y.isWindows)return;const w=[];if(w.push({type:"tasks",items:[{type:"task",title:m.localize(0,null),description:m.localize(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let f=[];for(let U of S.app.getJumpListSettings().removedItems){const q=U.args;if(q){const J=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(q);J&&f.push(d.URI.parse(J[2]))}}this.removeRecentlyOpened(f);let b=!1;const A=L.coalesce(this.getRecentlyOpened().workspaces.slice(0,7).map(U=>{const q=i.isRecentWorkspace(U)?U.workspace:U.folderUri,{title:J,description:te}=this.getWindowsJumpListLabel(q,U.label);let B;return d.URI.isUri(q)?B=`--folder-uri "${q.toString()}"`:(b=!0,B=`--file-uri "${q.configPath.toString()}"`),{type:"task",title:J.substr(0,255),description:te.substr(0,255),program:process.execPath,args:B,iconPath:"explorer.exe",iconIndex:0}}));A.length>0&&w.push({type:"custom",name:b?m.localize(2,null):m.localize(3,null),items:A})}w.push({type:"recent"});try{S.app.setJumpList(w)}catch(f){this.logService.warn("updateWindowsJumpList#setJumpList",f)}}getWindowsJumpListLabel(w,f){if(f)return{title:n.splitName(f).name,description:f};if(d.URI.isUri(w))return{title:p.basename(w),description:l(w)};if(this.workspacesManagementMainService.isUntitledWorkspace(w))return{title:m.localize(4,null),description:""};let b=p.basename(w.configPath);return b.endsWith(i.WORKSPACE_EXTENSION)&&(b=b.substr(0,b.length-i.WORKSPACE_EXTENSION.length-1)),{title:m.localize(5,null,b),description:l(w.configPath)}}};o.MAX_TOTAL_RECENT_ENTRIES=100,o.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,o.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],o.recentlyOpenedStorageKey="openedPathsList",o=he([ee(0,R.IStateMainService),ee(1,I.ILogService),ee(2,E.IWorkspacesManagementMainService),ee(3,P.ILifecycleMainService)],o),e.WorkspacesHistoryMainService=o;function l(u){return u.scheme==="file"?n.normalizeDriveLetter(u.fsPath):u.toString()}function t(u){return i.isRecentFolder(u)?u.folderUri:i.isRecentFile(u)?u.fileUri:u.workspace.configPath}function r(u,w){return u.findIndex(f=>i.isRecentWorkspace(f)&&f.workspace.id===w.id)}function s(u,w){return u.findIndex(f=>i.isRecentFolder(f)&&p.extUriBiasedIgnorePathCase.isEqual(f.folderUri,w))}function a(u,w){return u.findIndex(f=>p.extUriBiasedIgnorePathCase.isEqual(f.fileUri,w))}}),define(Z[234],x([0,1,145,3,24,14,61,21,32,42,20,9,6,31,35,62,183,7,39,22,45,25]),function($,e,m,L,R,S,I,n,v,y,i,E,M,p,d,g,k,P,c,h,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let r=class wt{constructor(u,w,f,b,A,U,q,J,te,B,Y){this.updateService=u,this.configurationService=w,this.windowsMainService=f,this.environmentMainService=b,this.telemetryService=A,this.workspacesHistoryMainService=U,this.stateMainService=q,this.lifecycleMainService=J,this.logService=te,this.nativeHostMainService=B,this.productService=Y,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new E.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new E.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(L.isMacintosh||I.getTitleBarStyle(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const u=this.stateMainService.getItem(wt.lastKnownMenubarStorageKey);u&&(u.menus&&(this.menubarMenus=u.menus),u.keybindings&&(this.keybindings=u.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(U,q,J)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:q==null?void 0:q.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(U,q,J)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:q==null?void 0:q.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(U,q,J)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(J),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(U,q,J)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(J),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const u=this.productService.twitterUrl;u&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(u,"openTwitterUrl"));const w=this.productService.requestFeatureUrl;w&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(w,"openUserVoiceUrl"));const f=this.productService.reportIssueUrl;f&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(f,"openReportIssues"));const b=this.productService.licenseUrl;b&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(L.language){const U=b.indexOf("?")>0?"&":"?";this.openUrl(`${b}${U}lang=${L.language}`,"openLicenseUrl")}else this.openUrl(b,"openLicenseUrl")});const A=this.productService.privacyStatementUrl;A&&b&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{if(L.language){const U=b.indexOf("?")>0?"&":"?";this.openUrl(`${A}${U}lang=${L.language}`,"openPrivacyStatement")}else this.openUrl(A,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(u=>this.onDidChangeWindowsCount(u)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let u=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof u!="boolean"&&(u=!0),u}get currentEnableNativeTabs(){if(!L.isMacintosh)return!1;let u=this.configurationService.getValue("window.nativeTabs");return typeof u!="boolean"&&(u=!1),u}updateMenu(u,w){this.menubarMenus=u.menus,this.keybindings=u.keybindings,this.stateMainService.setItem(wt.lastKnownMenubarStorageKey,u),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(u){!L.isMacintosh||(u.oldCount===0&&u.newCount>0||u.oldCount>0&&u.newCount===0)&&(this.closedLastWindow=u.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!L.isMacintosh||(this.noActiveWindow=!S.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const u=S.Menu.getApplicationMenu();if(u&&this.oldMenus.push(u),Object.keys(this.menubarMenus).length===0){S.Menu.setApplicationMenu(L.isMacintosh?new S.Menu:null);return}const w=new S.Menu;let f;if(L.isMacintosh){const A=new S.Menu;f=new S.MenuItem({label:this.productService.nameShort,submenu:A}),this.setMacApplicationMenu(A),w.append(f)}if(L.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const A=new S.Menu;A.append(new S.MenuItem({label:this.mnemonicLabel(m.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),S.app.dock.setMenu(A)}if(this.shouldDrawMenu("File")){const A=new S.Menu,U=new S.MenuItem({label:this.mnemonicLabel(m.localize(1,null)),submenu:A});this.setMenuById(A,"File"),w.append(U)}if(this.shouldDrawMenu("Edit")){const A=new S.Menu,U=new S.MenuItem({label:this.mnemonicLabel(m.localize(2,null)),submenu:A});this.setMenuById(A,"Edit"),w.append(U)}if(this.shouldDrawMenu("Selection")){const A=new S.Menu,U=new S.MenuItem({label:this.mnemonicLabel(m.localize(3,null)),submenu:A});this.setMenuById(A,"Selection"),w.append(U)}if(this.shouldDrawMenu("View")){const A=new S.Menu,U=new S.MenuItem({label:this.mnemonicLabel(m.localize(4,null)),submenu:A});this.setMenuById(A,"View"),w.append(U)}if(this.shouldDrawMenu("Go")){const A=new S.Menu,U=new S.MenuItem({label:this.mnemonicLabel(m.localize(5,null)),submenu:A});this.setMenuById(A,"Go"),w.append(U)}if(this.shouldDrawMenu("Run")){const A=new S.Menu,U=new S.MenuItem({label:this.mnemonicLabel(m.localize(6,null)),submenu:A});this.setMenuById(A,"Run"),w.append(U)}if(this.shouldDrawMenu("Terminal")){const A=new S.Menu,U=new S.MenuItem({label:this.mnemonicLabel(m.localize(7,null)),submenu:A});this.setMenuById(A,"Terminal"),w.append(U)}let b;if(this.shouldDrawMenu("Window")){const A=new S.Menu;b=new S.MenuItem({label:this.mnemonicLabel(m.localize(8,null)),submenu:A,role:"window"}),this.setMacWindowMenu(A)}if(b&&w.append(b),this.shouldDrawMenu("Help")){const A=new S.Menu,U=new S.MenuItem({label:this.mnemonicLabel(m.localize(9,null)),submenu:A,role:"help"});this.setMenuById(A,"Help"),w.append(U)}w.items&&w.items.length>0?S.Menu.setApplicationMenu(w):S.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(u){const w=this.createMenuItem(m.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),f=this.getUpdateMenuItems();let b;if(this.shouldDrawMenu("Preferences")){const G=new S.Menu;this.setMenuById(G,"Preferences"),b=new S.MenuItem({label:this.mnemonicLabel(m.localize(11,null)),submenu:G})}const A=new S.Menu,U=new S.MenuItem({label:m.localize(12,null),role:"services",submenu:A}),q=new S.MenuItem({label:m.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),J=new S.MenuItem({label:m.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),te=new S.MenuItem({label:m.localize(15,null),role:"unhide"}),B=new S.MenuItem(this.likeAction("workbench.action.quit",{label:m.localize(16,null,this.productService.nameLong),click:()=>{const G=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!S.BrowserWindow.getFocusedWindow()||(G==null?void 0:G.isMinimized()))&&this.nativeHostMainService.quit(void 0)}})),Y=[w];Y.push(...f),b&&Y.push(s(),b),Y.push(s(),U,s(),q,J,te,s(),B),Y.forEach(G=>u.append(G))}shouldDrawMenu(u){if(!L.isMacintosh&&I.getTitleBarStyle(this.configurationService)==="custom")return!1;switch(u){case"File":case"Help":if(L.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[u];case"Window":if(L.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[u]}}setMenu(u,w){w.forEach(f=>{if(k.isMenubarMenuItemSeparator(f))u.append(s());else if(k.isMenubarMenuItemSubmenu(f)){const b=new S.Menu,A=new S.MenuItem({label:this.mnemonicLabel(f.label),submenu:b});this.setMenu(b,f.submenu.items),u.append(A)}else k.isMenubarMenuItemRecentAction(f)?u.append(this.createOpenRecentMenuItem(f)):k.isMenubarMenuItemAction(f)&&(f.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(u),L.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[f.id]?u.append(new S.MenuItem(this.likeAction(f.id,{label:this.mnemonicLabel(f.label),click:this.fallbackMenuHandlers[f.id]}))):u.append(this.createMenuItem(f.label,f.id,!1,f.checked)):u.append(this.createMenuItem(f.label,f.id,f.enabled!==!1,!!f.checked)):u.append(this.createMenuItem(f.label,f.id,f.enabled!==!1,!!f.checked)))})}setMenuById(u,w){this.menubarMenus&&this.menubarMenus[w]&&this.setMenu(u,this.menubarMenus[w].items)}insertCheckForUpdatesItems(u){const w=this.getUpdateMenuItems();w.length&&(w.forEach(f=>u.append(f)),u.append(s()))}createOpenRecentMenuItem(u){const w=P.URI.revive(u.uri),f=u.id,b=f==="openRecentFile"?{fileUri:w}:f==="openRecentWorkspace"?{workspaceUri:w}:{folderUri:w};return new S.MenuItem(this.likeAction(f,{label:u.label,click:(A,U,q)=>{const J=this.isOptionClick(q);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[b],forceNewWindow:J,gotoLineMode:!1,remoteAuthority:u.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([w])}},!1))}isOptionClick(u){return!!(u&&(!L.isMacintosh&&(u.ctrlKey||u.shiftKey)||L.isMacintosh&&(u.metaKey||u.altKey)))}createRoleMenuItem(u,w,f){const b={label:this.mnemonicLabel(u),role:f,enabled:!0};return new S.MenuItem(this.withKeybinding(w,b))}setMacWindowMenu(u){const w=new S.MenuItem({label:m.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),f=new S.MenuItem({label:m.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),b=new S.MenuItem({label:m.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),A=this.createMenuItem(m.localize(20,null),"workbench.action.switchWindow"),U=[];this.currentEnableNativeTabs&&(U.push(s()),U.push(this.createMenuItem(m.localize(21,null),"workbench.action.newWindowTab")),U.push(this.createRoleMenuItem(m.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),U.push(this.createRoleMenuItem(m.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),U.push(this.createRoleMenuItem(m.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),U.push(this.createRoleMenuItem(m.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[w,f,s(),A,...U,s(),b].forEach(q=>u.append(q))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new S.MenuItem({label:this.mnemonicLabel(m.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:m.localize(27,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.mnemonicLabel(m.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:m.localize(29,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.mnemonicLabel(m.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new S.MenuItem({label:m.localize(31,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.mnemonicLabel(m.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(u,w,f,b){const A=this.mnemonicLabel(u),U=typeof w=="function"?w:(Y,G,C)=>{const z=Y?Y.userSettingsLabel:null;let X=w;Array.isArray(w)&&(X=this.isOptionClick(C)?w[1]:w[0]),z&&C.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:z}):this.runActionInRenderer({type:"commandId",commandId:X})},q=typeof f=="boolean"?f:this.windowsMainService.getWindowCount()>0,J=typeof b=="boolean"?b:!1,te={label:A,click:U,enabled:q};J&&(te.type="checkbox",te.checked=J);let B;return typeof w=="string"?B=w:Array.isArray(w)&&(B=w[0]),L.isMacintosh&&(B==="editor.action.clipboardCutAction"?te.role="cut":B==="editor.action.clipboardCopyAction"?te.role="copy":B==="editor.action.clipboardPasteAction"&&(te.role="paste"),B==="undo"?te.click=this.makeContextAwareClickHandler(U,{inDevTools:Y=>Y.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):B==="redo"?te.click=this.makeContextAwareClickHandler(U,{inDevTools:Y=>Y.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):B==="editor.action.selectAll"&&(te.click=this.makeContextAwareClickHandler(U,{inDevTools:Y=>Y.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.withKeybinding(B,te))}makeContextAwareClickHandler(u,w){return(f,b,A)=>{const U=S.BrowserWindow.getFocusedWindow();if(!U)return w.inNoWindow();if(U.webContents.isDevToolsFocused()&&U.webContents.devToolsWebContents)return w.inDevTools(U.webContents.devToolsWebContents);u(f,b||U,A)}}runActionInRenderer(u){let w=S.BrowserWindow.getFocusedWindow();if(!w){const b=this.windowsMainService.getLastActiveWindow();(b==null?void 0:b.isMinimized())&&(w=b.win)}const f=w?this.windowsMainService.getWindowById(w.id):void 0;if(f){if(this.logService.trace("menubar#runActionInRenderer",u),L.isMacintosh&&!this.environmentMainService.isBuilt&&!f.isReady&&(u.type==="commandId"&&u.commandId==="workbench.action.toggleDevTools"||u.type!=="commandId"&&u.userSettingsLabel==="alt+cmd+i"))return;if(u.type==="commandId"){const b={id:u.commandId,from:"menu"};f.sendWhenReady("vscode:runAction",l.CancellationToken.None,b)}else{const b={userSettingsLabel:u.userSettingsLabel};f.sendWhenReady("vscode:runKeybinding",l.CancellationToken.None,b)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",u)}withKeybinding(u,w){const f=typeof u=="string"?this.keybindings[u]:void 0;if(f==null?void 0:f.label){if(f.isNative!==!1)w.accelerator=f.label,w.userSettingsLabel=f.userSettingsLabel;else if(typeof w.label=="string"){const b=w.label.indexOf("[");b>=0?w.label=`${w.label.substr(0,b)} [${f.label}]`:w.label=`${w.label} [${f.label}]`}}else w.accelerator=void 0;return w}likeAction(u,w,f=!w.accelerator){f&&(w=this.withKeybinding(u,w));const b=w.click;return w.click=(A,U,q)=>{this.reportMenuActionTelemetry(u),b&&b(A,U,q)},w}openUrl(u,w){this.nativeHostMainService.openExternal(void 0,u),this.reportMenuActionTelemetry(w)}reportMenuActionTelemetry(u){this.telemetryService.publicLog2("workbenchActionExecuted",{id:u,from:t})}mnemonicLabel(u){return p.mnemonicMenuLabel(u,!this.currentEnableMenuBarMnemonics)}};r.lastKnownMenubarStorageKey="lastKnownMenubarData",r=he([ee(0,y.IUpdateService),ee(1,n.IConfigurationService),ee(2,d.IWindowsMainService),ee(3,R.IEnvironmentMainService),ee(4,v.ITelemetryService),ee(5,g.IWorkspacesHistoryMainService),ee(6,c.IStateMainService),ee(7,h.ILifecycleMainService),ee(8,M.ILogService),ee(9,o.INativeHostMainService),ee(10,i.IProductService)],r),e.Menubar=r;function s(){return new S.MenuItem({type:"separator"})}}),define(Z[235],x([0,1,234,6,4,22]),function($,e,m,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=R.createDecorator("menubarMainService");let I=class{constructor(v,y,i){this.instantiationService=v,this.lifecycleMainService=y,this.logService=i,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(m.Menubar)}async updateMenubar(v,y){this.logService.trace("menubarService#updateMenubar",v),(await this.menubar).updateMenu(y,v)}};I=he([ee(0,R.IInstantiationService),ee(1,S.ILifecycleMainService),ee(2,L.ILogService)],I),e.MenubarMainService=I}),define(Z[236],x([0,1,29,26,48,72,8,151,36,51,24,39,233,14,22,21,6,61,101,5,20,62,3,28,4,10,7,15,73,216,53,102,43,2,52,13,30,31,25,19,33,55]),function($,e,m,L,R,S,I,n,v,y,i,E,M,p,d,g,k,P,c,h,o,l,t,r,s,a,u,w,f,b,A,U,q,J,te,B,Y,G,C,z,X,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function W(F){return r.isWorkspaceIdentifier(F==null?void 0:F.workspace)}function D(F){return r.isSingleFolderWorkspaceIdentifier(F==null?void 0:F.workspace)}let O=class et extends J.Disposable{constructor(T,_,N,K,V,Q,ne,se,ae,le,re,ue,Ee,we,Ie){super();this.machineId=T,this.initialUserEnv=_,this.logService=N,this.stateMainService=K,this.environmentMainService=V,this.lifecycleMainService=Q,this.backupMainService=ne,this.configurationService=se,this.workspacesHistoryMainService=ae,this.workspacesManagementMainService=le,this.instantiationService=re,this.dialogMainService=ue,this.fileService=Ee,this.productService=we,this.protocolMainService=Ie,this._onDidOpenWindow=this._register(new h.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new h.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new h.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new h.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new b.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(T=>this._onDidSignalReadyWindow.fire(T.window))),this._register(this.onDidSignalReadyWindow(T=>{var _,N;if(((_=T.config)===null||_===void 0?void 0:_.extensionDevelopmentPath)||((N=T.config)===null||N===void 0?void 0:N.extensionTestsPath)){const K=new J.DisposableStore;if(K.add(h.Event.any(T.onDidClose,T.onDidDestroy)(()=>K.dispose())),T.config.extensionDevelopmentPath)for(const V of T.config.extensionDevelopmentPath)K.add(this.protocolMainService.addValidFileRoot(u.URI.file(V)));T.config.extensionTestsPath&&K.add(this.protocolMainService.addValidFileRoot(u.URI.file(T.config.extensionTestsPath)))}}))}openEmptyWindow(T,_){let N=this.environmentMainService.args;const K=(_==null?void 0:_.remoteAuthority)||void 0,V=!0,Q=_==null?void 0:_.forceReuseWindow,ne=!Q;return this.open(Object.assign(Object.assign({},T),{cli:N,forceEmpty:V,forceNewWindow:ne,forceReuseWindow:Q,remoteAuthority:K}))}open(T){this.logService.trace("windowsManager#open"),T.addMode&&(T.initialStartup||!this.getLastActiveWindow())&&(T.addMode=!1);const _=[],N=[],K=[],V=[],Q=[];let ne,se=0;const ae=this.getPathsToOpen(T);this.logService.trace("windowsManager#open pathsToOpen",ae);for(const we of ae)D(we)?T.addMode?_.push(we):N.push(we):W(we)?K.push(we):we.fileUri?(ne||(ne={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:we.remoteAuthority}),ne.filesToOpenOrCreate.push(we)):we.backupPath?Q.push({backupFolder:I.basename(we.backupPath),remoteAuthority:we.remoteAuthority}):se++;T.diffMode&&(ne==null?void 0:ne.filesToOpenOrCreate.length)===2&&(ne.filesToDiff=ne.filesToOpenOrCreate,ne.filesToOpenOrCreate=[]),ne&&T.waitMarkerFileURI&&(ne.filesToWait={paths:[...ne.filesToDiff,...ne.filesToOpenOrCreate],waitMarkerFileUri:T.waitMarkerFileURI}),T.initialStartup?(V.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),K.push(...V),Q.push(...this.backupMainService.getEmptyWindowBackupPaths())):Q.length=0;const{windows:le,filesOpenedInWindow:re}=this.doOpen(T,K,N,Q,se,ne,_);if(this.logService.trace(`windowsManager#open used window count ${le.length} (workspacesToOpen: ${K.length}, foldersToOpen: ${N.length}, emptyToRestore: ${Q.length}, emptyToOpen: ${se})`),le.length>1)if(re)re.focus();else{const we=this.windowsStateHandler.state.lastActiveWindow&&!T.forceEmpty&&!T.cli._.length&&!T.cli["file-uri"]&&!T.cli["folder-uri"]&&!(T.urisToOpen&&T.urisToOpen.length);let Ie=!0,Te=!0;if(we){const ye=le.filter(me=>this.windowsStateHandler.state.lastActiveWindow&&me.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ye.length&&(ye[0].focus(),Ie=!1,Te=!1)}if(Ie)for(let ye=le.length-1;ye>=0;ye--){const me=le[ye];if(!(me.openedWorkspace&&V.some(Pe=>me.openedWorkspace&&Pe.workspace.id===me.openedWorkspace.id)||me.backupPath&&Q.some(Pe=>me.backupPath&&Pe.backupFolder===I.basename(me.backupPath)))){me.focus(),Te=!1;break}}Te&&le[le.length-1].focus()}const ue=ne&&ne.filesToDiff.length>0;if(!le.some(we=>we.isExtensionDevelopmentHost)&&!ue&&!T.noRecentEntry){const we=[];for(const Ie of ae)W(Ie)?we.push({label:Ie.label,workspace:Ie.workspace,remoteAuthority:Ie.remoteAuthority}):D(Ie)?we.push({label:Ie.label,folderUri:Ie.workspace.uri,remoteAuthority:Ie.remoteAuthority}):Ie.fileUri&&we.push({label:Ie.label,fileUri:Ie.fileUri,remoteAuthority:Ie.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(we)}const Ee=T.waitMarkerFileURI;return T.context===0&&Ee&&le.length===1&&le[0]&&(async()=>{await le[0].whenClosedOrLoaded;try{await this.fileService.del(Ee)}catch(we){}})(),le}doOpen(T,_,N,K,V,Q,ne){const se=[];let ae;function le(ye,me){se.push(ye),me&&(ae=ye,Q=void 0)}let{openFolderInNewWindow:re,openFilesInNewWindow:ue}=this.shouldOpenNewWindow(T);if(!T.initialStartup&&ne.length>0){const ye=ne[0].remoteAuthority,me=this.getLastActiveWindowForAuthority(ye);me&&le(this.doAddFoldersToExistingWindow(me,ne.map(Pe=>Pe.workspace.uri)))}const Ee=N.length+_.length+K.length;if(Q&&Ee===0){const ye=Q.filesToOpenOrCreate[0]||Q.filesToDiff[0],me=this.getWindows().filter(Le=>Q&&Le.remoteAuthority===Q.remoteAuthority);let Pe;(ye==null?void 0:ye.fileUri)&&!ue&&((T.context===4||T.context===0||T.context===1)&&(Pe=c.findWindowOnFile(me,ye.fileUri,Le=>Le.configPath.scheme===a.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Le.configPath):void 0)),Pe||(Pe=this.doGetLastActiveWindow(me))),Pe?r.isWorkspaceIdentifier(Pe.openedWorkspace)?_.push({workspace:Pe.openedWorkspace,remoteAuthority:Pe.remoteAuthority}):r.isSingleFolderWorkspaceIdentifier(Pe.openedWorkspace)?N.push({workspace:Pe.openedWorkspace,remoteAuthority:Pe.remoteAuthority}):le(this.doOpenFilesInExistingWindow(T,Pe,Q),!0):le(this.openInBrowserWindow({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,filesToOpen:Q,forceNewWindow:!0,remoteAuthority:Q.remoteAuthority,forceNewTabbedWindow:T.forceNewTabbedWindow}),!0)}const we=v.distinct(_,ye=>ye.workspace.id);if(we.length>0){const ye=v.coalesce(we.map(me=>c.findWindowOnWorkspaceOrFolder(this.getWindows(),me.workspace.configPath)));if(ye.length>0){const me=ye[0],Pe=(Q==null?void 0:Q.remoteAuthority)===me.remoteAuthority?Q:void 0;le(this.doOpenFilesInExistingWindow(T,me,Pe),!!Pe),re=!0}we.forEach(me=>{if(ye.some(_e=>_e.openedWorkspace&&_e.openedWorkspace.id===me.workspace.id))return;const Pe=me.remoteAuthority,Le=(Q==null?void 0:Q.remoteAuthority)===Pe?Q:void 0;le(this.doOpenFolderOrWorkspace(T,me,re,Le),!!Le),re=!0})}const Ie=v.distinct(N,ye=>w.extUriBiasedIgnorePathCase.getComparisonKey(ye.workspace.uri));if(Ie.length>0){const ye=v.coalesce(Ie.map(me=>c.findWindowOnWorkspaceOrFolder(this.getWindows(),me.workspace.uri)));if(ye.length>0){const me=ye[0],Pe=(Q==null?void 0:Q.remoteAuthority)===me.remoteAuthority?Q:void 0;le(this.doOpenFilesInExistingWindow(T,me,Pe),!!Pe),re=!0}Ie.forEach(me=>{if(ye.some(_e=>r.isSingleFolderWorkspaceIdentifier(_e.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(_e.openedWorkspace.uri,me.workspace.uri)))return;const Pe=me.remoteAuthority,Le=(Q==null?void 0:Q.remoteAuthority)===Pe?Q:void 0;le(this.doOpenFolderOrWorkspace(T,me,re,Le),!!Le),re=!0})}const Te=v.distinct(K,ye=>ye.backupFolder);if(Te.length>0&&Te.forEach(ye=>{const me=ye.remoteAuthority,Pe=(Q==null?void 0:Q.remoteAuthority)===me?Q:void 0;le(this.openInBrowserWindow({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,filesToOpen:Pe,remoteAuthority:me,forceNewWindow:!0,forceNewTabbedWindow:T.forceNewTabbedWindow,emptyWindowBackupInfo:ye}),!!Pe),re=!0}),se.length===0||Q){Q&&!V&&V++;const ye=Q?Q.remoteAuthority:T.remoteAuthority;for(let me=0;me<V;me++)le(this.doOpenEmpty(T,re,ye,Q),!!Q),re=!0}return{windows:v.distinct(se),filesOpenedInWindow:ae}}doOpenFilesInExistingWindow(T,_,N){var K;this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),_.focus();const V={filesToOpenOrCreate:N==null?void 0:N.filesToOpenOrCreate,filesToDiff:N==null?void 0:N.filesToDiff,filesToWait:N==null?void 0:N.filesToWait,termProgram:(K=T==null?void 0:T.userEnv)===null||K===void 0?void 0:K.TERM_PROGRAM};return _.sendWhenReady("vscode:openFiles",C.CancellationToken.None,V),_}doAddFoldersToExistingWindow(T,_){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),T.focus();const N={foldersToAdd:_};return T.sendWhenReady("vscode:addFolders",C.CancellationToken.None,N),T}doOpenEmpty(T,_,N,K,V){return!_&&!V&&typeof T.contextWindowId=="number"&&(V=this.getWindowById(T.contextWindowId)),this.openInBrowserWindow({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:N,forceNewWindow:_,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:K,windowToUse:V})}doOpenFolderOrWorkspace(T,_,N,K,V){return!N&&!V&&typeof T.contextWindowId=="number"&&(V=this.getWindowById(T.contextWindowId)),this.openInBrowserWindow({workspace:_.workspace,userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:_.remoteAuthority,forceNewWindow:N,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:K,windowToUse:V})}getPathsToOpen(T){var _;let N,K=!1,V=!1;if(T.urisToOpen&&T.urisToOpen.length>0?(N=this.doExtractPathsFromAPI(T),K=!0):T.forceEmpty?N=[Object.create(null)]:T.cli._.length||T.cli["folder-uri"]||T.cli["file-uri"]?(N=this.doExtractPathsFromCLI(T.cli),N.length===0&&N.push(Object.create(null)),K=!0):(N=this.doGetPathsFromLastSession(),N.length===0&&N.push(Object.create(null)),V=!0),!T.addMode&&K){const Q=N.filter(ne=>D(ne));if(Q.length>1){const ne=Q[0].remoteAuthority;if(Q.every(se=>se.remoteAuthority===ne)){const se=this.workspacesManagementMainService.createUntitledWorkspaceSync(Q.map(ae=>({uri:ae.workspace.uri})));N.push({workspace:se,remoteAuthority:ne}),N=N.filter(ae=>!D(ae))}}}return T.initialStartup&&!V&&((_=this.configurationService.getValue("window"))===null||_===void 0?void 0:_.restoreWindows)==="preserve"&&N.unshift(...this.doGetPathsFromLastSession().filter(Q=>W(Q)||D(Q)||Q.backupPath)),N}doExtractPathsFromAPI(T){const _=[],N={gotoLineMode:T.gotoLineMode,remoteAuthority:T.remoteAuthority};for(const K of v.coalesce(T.urisToOpen||[])){const V=this.resolveOpenable(K,N);if(V)V.label=K.label,_.push(V);else{const Q=this.resourceFromOpenable(K),ne={title:this.productService.nameLong,type:"info",buttons:[G.mnemonicButtonLabel(n.localize(0,null))],defaultId:0,message:Q.scheme===a.Schemas.file?n.localize(1,null):n.localize(2,null),detail:Q.scheme===a.Schemas.file?n.localize(3,null,G.getPathLabel(Q.fsPath,this.environmentMainService)):n.localize(4,null,Q.toString()),noLink:!0};this.dialogMainService.showMessageBox(ne,B.withNullAsUndefined(p.BrowserWindow.getFocusedWindow()))}}return _}doExtractPathsFromCLI(T){const _=[],N={ignoreFileNotFound:!0,gotoLineMode:T.goto,remoteAuthority:T.remote||void 0,forceOpenWorkspaceAsFile:!1},K=T["folder-uri"];if(K)for(const ne of K){const se=this.cliArgToUri(ne);if(se){const ae=this.resolveOpenable({folderUri:se},N);ae&&_.push(ae)}}const V=T["file-uri"];if(V)for(const ne of V){const se=this.cliArgToUri(ne);if(se){const ae=this.resolveOpenable(r.hasWorkspaceFileExtension(ne)?{workspaceUri:se}:{fileUri:se},N);ae&&_.push(ae)}}const Q=T._;for(const ne of Q){const se=N.remoteAuthority?this.doResolvePathRemote(ne,N):this.doResolveFilePath(ne,N);se&&_.push(se)}return _}cliArgToUri(T){try{const _=u.URI.parse(T);if(!_.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${T}`);return}return _}catch(_){this.logService.error(`Invalid URI input string: ${T}, ${_.message}`)}}doGetPathsFromLastSession(){const T=this.getRestoreWindowsSetting();switch(T){case"none":return[];case"one":case"all":case"preserve":case"folders":const _=[];T!=="one"&&_.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&_.push(this.windowsStateHandler.state.lastActiveWindow);const N=[];for(const K of _)if(K.workspace){const V=this.resolveOpenable({workspaceUri:K.workspace.configPath},{remoteAuthority:K.remoteAuthority});W(V)&&N.push(V)}else if(K.folderUri){const V=this.resolveOpenable({folderUri:K.folderUri},{remoteAuthority:K.remoteAuthority});D(V)&&N.push(V)}else T!=="folders"&&K.backupPath&&N.push({backupPath:K.backupPath,remoteAuthority:K.remoteAuthority});return N}}getRestoreWindowsSetting(){let T;if(this.lifecycleMainService.wasRestarted)T="all";else{const _=this.configurationService.getValue("window");T=(_==null?void 0:_.restoreWindows)||"all",["preserve","all","folders","one","none"].includes(T)||(T="all")}return T}resolveOpenable(T,_={}){let N=this.resourceFromOpenable(T);return N.scheme===a.Schemas.file?(P.isFileToOpen(T)&&(_=Object.assign(Object.assign({},_),{forceOpenWorkspaceAsFile:!0})),this.doResolveFilePath(N.fsPath,_)):this.doResolveRemoteOpenable(T,_)}doResolveRemoteOpenable(T,_){let N=this.resourceFromOpenable(T);const K=f.getRemoteAuthority(N)||_.remoteAuthority;if(N=w.removeTrailingPathSeparator(w.normalizePath(N)),P.isFileToOpen(T)){if(_.gotoLineMode){const{path:V,line:Q,column:ne}=Y.parseLineAndColumnAware(N.path);return{fileUri:N.with({path:V}),lineNumber:Q,columnNumber:ne,remoteAuthority:K}}return{fileUri:N,remoteAuthority:K}}else if(P.isWorkspaceToOpen(T))return{workspace:U.getWorkspaceIdentifier(N),remoteAuthority:K};return{workspace:U.getSingleFolderWorkspaceIdentifier(N),remoteAuthority:K}}resourceFromOpenable(T){return P.isWorkspaceToOpen(T)?T.workspaceUri:P.isFolderToOpen(T)?T.folderUri:T.fileUri}doResolveFilePath(T,_){let N,K;_.gotoLineMode&&({path:T,line:N,column:K}=Y.parseLineAndColumnAware(T)),T=Y.sanitizeFilePath(I.normalize(T),X.cwd());try{const V=m.statSync(T);if(V.isFile()){if(!_.forceOpenWorkspaceAsFile){const Q=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.URI.file(T));if(Q)return{workspace:{id:Q.id,configPath:Q.configPath},remoteAuthority:Q.remoteAuthority,exists:!0}}return{fileUri:u.URI.file(T),lineNumber:N,columnNumber:K,exists:!0}}else if(V.isDirectory())return{workspace:U.getSingleFolderWorkspaceIdentifier(u.URI.file(T),V),exists:!0}}catch(V){const Q=u.URI.file(T);if(this.workspacesHistoryMainService.removeRecentlyOpened([Q]),_.ignoreFileNotFound)return{fileUri:Q,exists:!1}}}doResolvePathRemote(T,_){const N=T.charCodeAt(0),K=_.remoteAuthority;let V,Q;_.gotoLineMode&&({path:T,line:V,column:Q}=Y.parseLineAndColumnAware(T)),N!==47&&(Y.isWindowsDriveLetter(N)&&T.charCodeAt(T.charCodeAt(1))===58&&(T=Y.toSlashes(T)),T=`/${T}`);const ne=u.URI.from({scheme:a.Schemas.vscodeRemote,authority:K,path:T});if(T.charCodeAt(T.length-1)!==47){if(r.hasWorkspaceFileExtension(T))return _.forceOpenWorkspaceAsFile?{fileUri:ne,lineNumber:V,columnNumber:Q,remoteAuthority:_.remoteAuthority}:{workspace:U.getWorkspaceIdentifier(ne),remoteAuthority:K};if(_.gotoLineMode||I.posix.basename(T).indexOf(".")!==-1)return{fileUri:ne,lineNumber:V,columnNumber:Q,remoteAuthority:K}}return{workspace:U.getSingleFolderWorkspaceIdentifier(ne),remoteAuthority:K}}shouldOpenNewWindow(T){const _=this.configurationService.getValue("window"),N=(_==null?void 0:_.openFoldersInNewWindow)||"default",K=(_==null?void 0:_.openFilesInNewWindow)||"off";let V=(T.preferNewWindow||T.forceNewWindow)&&!T.forceReuseWindow;!T.forceNewWindow&&!T.forceReuseWindow&&(N==="on"||N==="off")&&(V=N==="on");let Q=!1;return T.forceNewWindow||T.forceReuseWindow?Q=!!T.forceNewWindow&&!T.forceReuseWindow:(t.isMacintosh?T.context===1&&(Q=!0):T.context!==3&&T.context!==2&&!(T.userEnv&&T.userEnv.TERM_PROGRAM==="vscode")&&(Q=!0),!T.cli.extensionDevelopmentPath&&(K==="on"||K==="off")&&(Q=K==="on")),{openFolderInNewWindow:!!V,openFilesInNewWindow:Q}}openExtensionDevelopmentHostWindow(T,_){const N=c.findWindowOnExtensionDevelopmentPath(this.getWindows(),T);if(N)return this.lifecycleMainService.reload(N,_.cli),N.focus(),[N];let K=_.cli["folder-uri"]||[],V=_.cli["file-uri"]||[],Q=_.cli._;if(!Q.length&&!K.length&&!V.length&&!_.cli.extensionTestsPath){const le=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,re=le&&(le.workspace||le.folderUri);re&&(u.URI.isUri(re)?re.scheme===a.Schemas.file?Q=[re.fsPath]:K=[re.toString()]:re.configPath.scheme===a.Schemas.file?Q=[w.originalFSPath(re.configPath)]:V=[re.configPath.toString()])}let ne=_.remoteAuthority;for(const le of T)if(le.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const re=u.URI.parse(le),ue=f.getRemoteAuthority(re);ue&&(ne?ue!==ne&&this.logService.error("more than one extension development path authority"):ne=ue)}Q=Q.filter(le=>{const re=u.URI.file(le);return c.findWindowOnWorkspaceOrFolder(this.getWindows(),re)?!1:f.getRemoteAuthority(re)===ne}),K=K.filter(le=>{const re=this.cliArgToUri(le);return re&&!!c.findWindowOnWorkspaceOrFolder(this.getWindows(),re)?!1:re?f.getRemoteAuthority(re)===ne:!1}),V=V.filter(le=>{const re=this.cliArgToUri(le);return re&&!!c.findWindowOnWorkspaceOrFolder(this.getWindows(),re)?!1:re?f.getRemoteAuthority(re)===ne:!1}),_.cli._=Q,_.cli["folder-uri"]=K,_.cli["file-uri"]=V;const se=!Q.length&&!K.length&&!V.length,ae={context:_.context,cli:_.cli,forceNewWindow:!0,forceEmpty:se,userEnv:_.userEnv,noRecentEntry:!0,waitMarkerFileURI:_.waitMarkerFileURI,remoteAuthority:ne};return this.open(ae)}openInBrowserWindow(T){var _,N,K,V,Q;const ne=this.configurationService.getValue("window"),se=Object.assign(Object.assign(Object.assign({},this.environmentMainService.args),T.cli),{machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:T.emptyWindowBackupInfo?I.join(this.environmentMainService.backupHome,T.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:T.remoteAuthority,workspace:T.workspace,userEnv:Object.assign(Object.assign({},this.initialUserEnv),T.userEnv),filesToOpenOrCreate:(_=T.filesToOpen)===null||_===void 0?void 0:_.filesToOpenOrCreate,filesToDiff:(N=T.filesToOpen)===null||N===void 0?void 0:N.filesToDiff,filesToWait:(K=T.filesToOpen)===null||K===void 0?void 0:K.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:R.default,isInitialStartup:T.initialStartup,perfMarks:S.getMarks(),os:{release:L.release(),hostname:L.hostname()},zoomLevel:typeof(ne==null?void 0:ne.zoomLevel)=="number"?ne.zoomLevel:void 0,autoDetectHighContrast:(V=ne==null?void 0:ne.autoDetectHighContrast)!==null&&V!==void 0?V:!0,accessibilitySupport:p.app.accessibilitySupportEnabled,colorScheme:{dark:p.nativeTheme.shouldUseDarkColors,highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors}});let ae;if(!T.forceNewWindow&&!T.forceNewTabbedWindow&&(ae=T.windowToUse||this.getLastActiveWindow(),ae&&ae.focus()),ae){const le=ae.config;!se.extensionDevelopmentPath&&le&&!!le.extensionDevelopmentPath&&(se.extensionDevelopmentPath=le.extensionDevelopmentPath,se.verbose=le.verbose,se["inspect-brk-extensions"]=le["inspect-brk-extensions"],se.debugId=le.debugId,se["inspect-extensions"]=le["inspect-extensions"],se["extensions-dir"]=le["extensions-dir"])}else{const le=this.windowsStateHandler.getNewWindowState(se);S.mark("code/willCreateCodeWindow");const re=ae=this.instantiationService.createInstance(M.CodeWindow,{state:le,extensionDevelopmentPath:se.extensionDevelopmentPath,isExtensionTestHost:!!se.extensionTestsPath});if(S.mark("code/didCreateCodeWindow"),T.forceNewTabbedWindow){const Ee=this.getLastActiveWindow();Ee&&Ee.addTabbedWindow(re)}et.WINDOWS.push(re),this._onDidOpenWindow.fire(re),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),q.once(re.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(re)),q.once(re.onDidClose)(()=>this.onWindowClosed(re)),q.once(re.onDidDestroy)(()=>this._onDidDestroyWindow.fire(re));const ue=B.assertIsDefined((Q=re.win)===null||Q===void 0?void 0:Q.webContents);ue.removeAllListeners("devtools-reload-page"),ue.on("devtools-reload-page",()=>this.lifecycleMainService.reload(re)),this.lifecycleMainService.registerWindow(re)}return se.windowId=ae.id,ae.isReady?this.lifecycleMainService.unload(ae,4).then(le=>{le||this.doOpenInBrowserWindow(ae,se,T)}):this.doOpenInBrowserWindow(ae,se,T),ae}doOpenInBrowserWindow(T,_,N){if(!_.extensionDevelopmentPath)if(r.isWorkspaceIdentifier(_.workspace))_.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:_.workspace,remoteAuthority:_.remoteAuthority});else if(r.isSingleFolderWorkspaceIdentifier(_.workspace))_.backupPath=this.backupMainService.registerFolderBackupSync(_.workspace.uri);else{const K=N.emptyWindowBackupInfo&&N.emptyWindowBackupInfo.backupFolder;_.backupPath=this.backupMainService.registerEmptyWindowBackupSync(K,_.remoteAuthority)}T.load(_)}onWindowClosed(T){const _=et.WINDOWS.indexOf(T);et.WINDOWS.splice(_,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const T=p.BrowserWindow.getFocusedWindow();if(T)return this.getWindowById(T.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(T){return this.doGetLastActiveWindow(this.getWindows().filter(_=>_.remoteAuthority===T))}doGetLastActiveWindow(T){const _=Math.max.apply(Math,T.map(N=>N.lastFocusTime));return T.find(N=>N.lastFocusTime===_)}sendToFocused(T,..._){const N=this.getFocusedWindow()||this.getLastActiveWindow();N&&N.sendWhenReady(T,C.CancellationToken.None,..._)}sendToAll(T,_,N){for(const K of this.getWindows())N&&N.indexOf(K.id)>=0||K.sendWhenReady(T,C.CancellationToken.None,_)}getWindows(){return et.WINDOWS}getWindowCount(){return et.WINDOWS.length}getWindowById(T){const _=this.getWindows().filter(N=>N.id===T);return v.firstOrDefault(_)}getWindowByWebContents(T){const _=p.BrowserWindow.fromWebContents(T);if(!!_)return this.getWindowById(_.id)}};O.WINDOWS=[],O=he([ee(2,k.ILogService),ee(3,E.IStateMainService),ee(4,i.IEnvironmentMainService),ee(5,d.ILifecycleMainService),ee(6,y.IBackupMainService),ee(7,g.IConfigurationService),ee(8,l.IWorkspacesHistoryMainService),ee(9,A.IWorkspacesManagementMainService),ee(10,s.IInstantiationService),ee(11,te.IDialogMainService),ee(12,z.IFileService),ee(13,o.IProductService),ee(14,H.IProtocolMainService)],O),e.WindowsMainService=O}),define(Z[237],x([0,1,53,35,62,51]),function($,e,m,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let I=class{constructor(v,y,i,E){this.workspacesManagementMainService=v,this.windowsMainService=y,this.workspacesHistoryMainService=i,this.backupMainService=E,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(v,y){const i=this.windowsMainService.getWindowById(v);if(i)return this.workspacesManagementMainService.enterWorkspace(i,this.windowsMainService.getWindows(),y)}createUntitledWorkspace(v,y,i){return this.workspacesManagementMainService.createUntitledWorkspace(y,i)}deleteUntitledWorkspace(v,y){return this.workspacesManagementMainService.deleteUntitledWorkspace(y)}getWorkspaceIdentifier(v,y){return this.workspacesManagementMainService.getWorkspaceIdentifier(y)}async getRecentlyOpened(v){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(v))}async addRecentlyOpened(v,y){return this.workspacesHistoryMainService.addRecentlyOpened(y)}async removeRecentlyOpened(v,y){return this.workspacesHistoryMainService.removeRecentlyOpened(y)}async clearRecentlyOpened(v){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};I=he([ee(0,m.IWorkspacesManagementMainService),ee(1,L.IWindowsMainService),ee(2,R.IWorkspacesHistoryMainService),ee(3,S.IBackupMainService)],I),e.WorkspacesMainService=I}),define(Z[238],x([0,1,26,29,14,3,236,22,92,42,206,34,123,86,226,103,4,71,69,6,39,24,21,99,207,32,98,201,202,198,20,220,2,35,7,28,237,66,231,229,228,232,181,16,209,221,235,120,8,15,132,10,230,100,214,219,51,62,208,53,70,158,45,52,13,31,211,76,19,40,27,17,90,212,197,54,30,170,186,43,73,75,91,173,179]),function($,e,m,L,R,S,I,n,v,y,i,E,M,p,d,g,k,P,c,h,o,l,t,r,s,a,u,w,f,b,A,U,q,J,te,B,Y,G,C,z,X,H,W,D,O,F,T,_,N,K,V,Q,ne,se,ae,le,re,ue,Ee,we,Ie,Te,ye,me,Pe,Le,_e,Be,He,tt,ze,ot,it,ht,Xe,dt,at,j,ie,oe,ce,fe,Se,ke,Fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ce=class extends q.Disposable{constructor(de,pe,ve,ge,be,De,Re,Ae,Me,Ne){super();this.mainProcessNodeIpcServer=de,this.userEnv=pe,this.mainInstantiationService=ve,this.logService=ge,this.environmentMainService=be,this.lifecycleMainService=De,this.configurationService=Re,this.stateMainService=Ae,this.fileService=Me,this.productService=Ne,this.configureSession(),this.registerListeners()}configureSession(){const de=ve=>ve.startsWith(`${Q.Schemas.vscodeWebview}://`);R.session.defaultSession.setPermissionRequestHandler((ve,ge,be,De)=>de(De.requestingUrl)?be(ge==="clipboard-read"):be(!1)),R.session.defaultSession.setPermissionCheckHandler((ve,ge,be,De)=>de(De.requestingUrl)?ge==="clipboard-read":!1);const pe=R.session.defaultSession;typeof pe.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&pe.setCodeCachePath(N.join(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){D.setUnexpectedErrorHandler(ve=>this.onUnexpectedError(ve)),process.on("uncaughtException",ve=>this.onUnexpectedError(ve)),process.on("unhandledRejection",ve=>D.onUnexpectedError(ve)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),_.registerContextMenuListener(),R.app.on("accessibility-support-changed",(ve,ge)=>{var be;(be=this.windowsMainService)===null||be===void 0||be.sendToAll("vscode:accessibilitySupportChanged",ge)}),R.app.on("activate",(ve,ge)=>{var be;this.logService.trace("app#activate"),ge||(be=this.windowsMainService)===null||be===void 0||be.openEmptyWindow({context:1})}),R.app.on("web-contents-created",(ve,ge)=>{ge.on("will-attach-webview",(be,De,Re)=>{const Ae=Me=>{if(!Me)return!1;const Ne=te.URI.parse(Me);if(Ne.scheme===Q.Schemas.vscodeWebview)return Ne.path==="/index.html"||Ne.path==="/electron-browser-index.html";const je=Ne.fsPath.toLowerCase(),qe=te.URI.file(this.environmentMainService.appRoot).fsPath.toLowerCase();return je.startsWith(qe+N.sep)};delete De.preload,De.nodeIntegration=!1,!(Ae(Re.src)&&Ae(De.preloadURL))&&(delete De.preloadURL,this.logService.error("webContents#web-contents-created: Prevented webview attach"),be.preventDefault())}),ge.on("will-navigate",be=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),be.preventDefault()}),ge.setWindowOpenHandler(({url:be})=>{var De;return(De=this.nativeHostMainService)===null||De===void 0||De.openExternal(void 0,be),{action:"deny"}})});let de=[],pe;R.app.on("open-file",(ve,ge)=>{this.logService.trace("app#open-file: ",ge),ve.preventDefault(),de.push(this.getWindowOpenableFromPathSync(ge)),pe!==void 0&&(clearTimeout(pe),pe=void 0),pe=setTimeout(()=>{var be;(be=this.windowsMainService)===null||be===void 0||be.open({context:1,cli:this.environmentMainService.args,urisToOpen:de,gotoLineMode:!1,preferNewWindow:!0}),de=[],pe=void 0},100)}),R.app.on("new-window-for-tab",()=>{var ve;(ve=this.windowsMainService)===null||ve===void 0||ve.openEmptyWindow({context:4})}),R.ipcMain.handle("vscode:fetchShellEnv",ve=>{var ge;const be=(ge=this.windowsMainService)===null||ge===void 0?void 0:ge.getWindowByWebContents(ve.sender);let De,Re;return(be==null?void 0:be.config)?(De=be.config,Re=Object.assign(Object.assign({},process.env),be.config.userEnv)):(De=this.environmentMainService.args,Re=process.env),v.resolveShellEnv(this.logService,De,Re)}),R.ipcMain.handle("vscode:writeNlsFile",(ve,ge,be)=>{const De=this.validateNlsPath([ge]);if(!De||typeof be!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,ot.VSBuffer.fromString(be))}),R.ipcMain.handle("vscode:readNlsFile",async(ve,...ge)=>{const be=this.validateNlsPath(ge);if(!be)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(be)).value.toString()}),R.ipcMain.on("vscode:toggleDevTools",ve=>ve.sender.toggleDevTools()),R.ipcMain.on("vscode:openDevTools",ve=>ve.sender.openDevTools()),R.ipcMain.on("vscode:reloadWindow",ve=>ve.sender.reload())}validateNlsPath(de){let pe;for(const ve of de)typeof ve=="string"&&(typeof pe!="string"?pe=ve:pe=N.join(pe,ve));if(!(typeof pe!="string"||!N.isAbsolute(pe)||!at.isEqualOrParent(pe,this.environmentMainService.cachedLanguagesPath,!S.isLinux)))return te.URI.file(pe)}onUnexpectedError(de){var pe;if(de){const ve={message:`[uncaught exception in main]: ${de.message}`,stack:de.stack};(pe=this.windowsMainService)===null||pe===void 0||pe.sendToFocused("vscode:reportError",JSON.stringify(ve))}this.logService.error(`[uncaught exception in main]: ${de}`),de.stack&&this.logService.error(de.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const de=this.productService.win32AppUserModelId;S.isWindows&&de&&R.app.setAppUserModelId(de);try{S.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!R.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&R.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Me){this.logService.error(Me)}const pe=new M.Server;this.logService.trace("Resolving machine identifier...");const ve=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${ve}`);const{sharedProcess:ge,sharedProcessReady:be,sharedProcessClient:De}=this.setupSharedProcess(ve),Re=await this.initServices(ve,ge,be);if(this.environmentMainService.driverHandle){const Me=await F.serve(pe,this.environmentMainService.driverHandle,this.environmentMainService,Re);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Me)}this._register(Re.createInstance(U.ProxyAuthHandler)),Re.invokeFunction(Me=>this.initChannels(Me,pe,De));const Ae=Re.invokeFunction(Me=>this.openFirstWindow(Me,pe));Re.invokeFunction(Me=>this.afterWindowOpen(Me,ge)),this.environmentMainService.args.trace&&Re.invokeFunction(Me=>this.stopTracingEventually(Me,Ae))}async resolveMachineId(){let de=this.stateMainService.getItem(a.machineIdKey);return(!de||S.isMacintosh&&de==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(de=await G.getMachineId(),this.stateMainService.setItem(a.machineIdKey,de)),de}setupSharedProcess(de){const pe=this._register(this.mainInstantiationService.createInstance(d.SharedProcess,de,this.userEnv)),ve=(async()=>{this.logService.trace("Main->SharedProcess#connect");const be=await pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new p.Client(be,"main")})(),ge=(async()=>(await pe.whenReady(),ve))();return{sharedProcess:pe,sharedProcessReady:ge,sharedProcessClient:ve}}async initServices(de,pe,ve){const ge=new P.ServiceCollection;switch(process.platform){case"win32":ge.set(y.IUpdateService,new c.SyncDescriptor(C.Win32UpdateService));break;case"linux":S.isLinuxSnap?ge.set(y.IUpdateService,new c.SyncDescriptor(ne.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ge.set(y.IUpdateService,new c.SyncDescriptor(z.LinuxUpdateService));break;case"darwin":ge.set(y.IUpdateService,new c.SyncDescriptor(X.DarwinUpdateService));break}ge.set(J.IWindowsMainService,new c.SyncDescriptor(I.WindowsMainService,[de,this.userEnv])),ge.set(me.IDialogMainService,new c.SyncDescriptor(me.DialogMainService)),ge.set(g.ILaunchMainService,new c.SyncDescriptor(g.LaunchMainService)),ge.set(Ie.IDiagnosticsService,E.ProxyChannel.toService(E.getDelayedChannel(ve.then(De=>De.getChannel("diagnostics"))))),ge.set(H.IIssueMainService,new c.SyncDescriptor(H.IssueMainService,[this.userEnv])),ge.set(it.IEncryptionMainService,new c.SyncDescriptor(it.EncryptionMainService,[de])),ge.set(Xe.IKeyboardLayoutMainService,new c.SyncDescriptor(Xe.KeyboardLayoutMainService)),ge.set(ye.INativeHostMainService,new c.SyncDescriptor(ye.NativeHostMainService,[pe])),ge.set(Be.IWebviewManagerService,new c.SyncDescriptor(_e.WebviewMainService)),ge.set(B.IWorkspacesService,new c.SyncDescriptor(Y.WorkspacesMainService)),ge.set(we.IWorkspacesManagementMainService,new c.SyncDescriptor(we.WorkspacesManagementMainService)),ge.set(ue.IWorkspacesHistoryMainService,new c.SyncDescriptor(ue.WorkspacesHistoryMainService)),ge.set(T.IMenubarMainService,new c.SyncDescriptor(T.MenubarMainService)),ge.set(j.IExtensionUrlTrustService,new c.SyncDescriptor(ie.ExtensionUrlTrustService)),ge.set(se.IStorageMainService,new c.SyncDescriptor(se.StorageMainService)),S.isWindows?ge.set(Se.IExternalTerminalMainService,new c.SyncDescriptor(ke.WindowsExternalTerminalService)):S.isMacintosh?ge.set(Se.IExternalTerminalMainService,new c.SyncDescriptor(ke.MacExternalTerminalService)):S.isLinux&&ge.set(Se.IExternalTerminalMainService,new c.SyncDescriptor(ke.LinuxExternalTerminalService));const be=new le.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ge.set(re.IBackupMainService,be),ge.set(r.IURLService,new c.SyncDescriptor(Ee.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!this.productService.enableTelemetry){const De=E.getDelayedChannel(ve.then(je=>je.getChannel("telemetryAppender"))),Re=new w.TelemetryAppenderClient(De),Ae=b.resolveCommonProperties(this.fileService,m.release(),m.hostname(),process.arch,this.productService.commit,this.productService.version,de,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Me=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Ne={appender:Re,commonProperties:Ae,piiPaths:Me,sendErrorTelemetry:!0};ge.set(a.ITelemetryService,new c.SyncDescriptor(f.TelemetryService,[Ne]))}else ge.set(a.ITelemetryService,u.NullTelemetryService);return await be.initialize(),this.mainInstantiationService.createChild(ge)}initChannels(de,pe,ve){const ge=E.ProxyChannel.fromService(de.get(g.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ge),pe.registerChannel(Fe.UserConfigurationFileServiceId,E.ProxyChannel.fromService(new Fe.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService)));const be=new i.UpdateChannel(de.get(y.IUpdateService));pe.registerChannel("update",be);const De=E.ProxyChannel.fromService(de.get(H.IIssueMainService));pe.registerChannel("issue",De);const Re=E.ProxyChannel.fromService(de.get(it.IEncryptionMainService));pe.registerChannel("encryption",Re);const Ae=E.ProxyChannel.fromService(de.get(fe.ISignService));pe.registerChannel("sign",Ae);const Me=E.ProxyChannel.fromService(de.get(Xe.IKeyboardLayoutMainService));pe.registerChannel("keyboardLayout",Me),this.nativeHostMainService=de.get(ye.INativeHostMainService);const Ne=E.ProxyChannel.fromService(this.nativeHostMainService);pe.registerChannel("nativeHost",Ne),ve.then(Ve=>Ve.registerChannel("nativeHost",Ne));const je=E.ProxyChannel.fromService(de.get(B.IWorkspacesService));pe.registerChannel("workspaces",je);const qe=E.ProxyChannel.fromService(de.get(T.IMenubarMainService));pe.registerChannel("menubar",qe);const Ge=E.ProxyChannel.fromService(de.get(r.IURLService));pe.registerChannel("url",Ge);const Qe=E.ProxyChannel.fromService(de.get(j.IExtensionUrlTrustService));pe.registerChannel("extensionUrlTrust",Qe);const Ue=E.ProxyChannel.fromService(de.get(Be.IWebviewManagerService));pe.registerChannel("webview",Ue);const nt=this._register(new ae.StorageDatabaseChannel(this.logService,de.get(se.IStorageMainService)));pe.registerChannel("storage",nt),ve.then(Ve=>Ve.registerChannel("storage",nt));const rt=E.ProxyChannel.fromService(de.get(Se.IExternalTerminalMainService));pe.registerChannel("externalTerminal",rt);const xe=new W.LogLevelChannel(de.get(h.ILogService));pe.registerChannel("logLevel",xe),ve.then(Ve=>Ve.registerChannel("logLevel",xe));const st=new W.LoggerChannel(de.get(h.ILoggerService));pe.registerChannel("logger",st),ve.then(Ve=>Ve.registerChannel("logger",st));const lt=new Te.ElectronExtensionHostDebugBroadcastChannel(de.get(J.IWindowsMainService));pe.registerChannel("extensionhostdebugservice",lt)}openFirstWindow(de,pe){const ve=this.windowsMainService=de.get(J.IWindowsMainService),ge=de.get(r.IURLService),be=de.get(ye.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],Re=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(We=>{try{return{uri:te.URI.parse(We),url:We}}catch(Ze){return}}).filter(We=>{if(!We||this.shouldBlockURI(We.uri))return!1;const Ze=this.getWindowOpenableFromProtocolLink(We.uri);return Ze?(De.push(Ze),!1):!0}),Ae=this,Me=this.environmentMainService,Ne=this.productService;ge.registerHandler({async handleURL(We,Ze){if(We.scheme===Ne.urlProtocol&&We.path==="workspace"&&(We=We.with({authority:"file",path:te.URI.parse(We.query).path,query:""})),Ae.shouldBlockURI(We))return!0;const bt=Ae.getWindowOpenableFromProtocolLink(We);if(bt){const[gt]=ve.open({context:5,cli:Object.assign({},Me.args),urisToOpen:[bt],gotoLineMode:!0});return gt.focus(),!0}if(S.isMacintosh&&ve.getWindowCount()===0){const[gt]=ve.open({context:5,cli:Object.assign({},Me.args),forceEmpty:!0,gotoLineMode:!0,remoteAuthority:ce.getRemoteAuthority(We)});return await gt.ready(),ge.open(We,Ze)}return!1}});const je=this._register(new ht.ActiveWindowManager({onDidOpenWindow:be.onDidOpenWindow,onDidFocusWindow:be.onDidFocusWindow,getActiveWindowId:()=>be.getActiveWindowId(-1)})),qe=new E.StaticRouter(We=>je.getActiveClientId().then(Ze=>We===Ze)),Ge=new s.URLHandlerRouter(qe),Qe=pe.getChannel("urlHandler",Ge);ge.registerHandler(new s.URLHandlerChannelClient(Qe)),this._register(new O.ElectronURLListener(Re,ge,ve,this.environmentMainService,this.productService));const Ue=this.environmentMainService.args,nt=global.macOpenFiles,rt=dt.isLaunchedFromCli(process.env)?0:4,xe=Ue._.length,st=!!Ue["folder-uri"],lt=!!Ue["file-uri"],Ve=Ue["skip-add-to-recently-opened"]===!0,ft=Ue.wait&&Ue.waitMarkerFilePath?te.URI.file(Ue.waitMarkerFilePath):void 0,St=Ue.remote||void 0;return De.length>0?ve.open({context:rt,cli:Ue,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):Ue["new-window"]&&!xe&&!st&&!lt?ve.open({context:rt,cli:Ue,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ve,waitMarkerFileURI:ft,initialStartup:!0,remoteAuthority:St}):nt.length&&!xe&&!st&&!lt?ve.open({context:1,cli:Ue,urisToOpen:nt.map(We=>this.getWindowOpenableFromPathSync(We)),noRecentEntry:Ve,waitMarkerFileURI:ft,initialStartup:!0}):ve.open({context:rt,cli:Ue,forceNewWindow:Ue["new-window"]||!xe&&Ue["unity-launch"],diffMode:Ue.diff,noRecentEntry:Ve,waitMarkerFileURI:ft,gotoLineMode:Ue.goto,initialStartup:!0,remoteAuthority:St})}shouldBlockURI(de){return!!(de.authority===Q.Schemas.file&&S.isWindows&&R.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[Le.mnemonicButtonLabel(V.localize(0,null)),Le.mnemonicButtonLabel(V.localize(1,null))],defaultId:0,cancelId:1,message:V.localize(2,null,Le.getPathLabel(de.fsPath,this.environmentMainService),this.productService.nameShort),detail:V.localize(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(de){if(!!de.path){if(de.authority===Q.Schemas.file)return{fileUri:te.URI.file(de.fsPath)};if(de.authority===Q.Schemas.vscodeRemote){const pe=de.path.indexOf(N.posix.sep,1);if(pe!==-1){const ve=de.path.substring(1,pe),ge=de.path.substring(pe),be=te.URI.from({scheme:Q.Schemas.vscodeRemote,authority:ve,path:ge,query:de.query,fragment:de.fragment});return B.hasWorkspaceFileExtension(ge)?{workspaceUri:be}:/:[\d]+$/.test(ge)?{fileUri:be}:{folderUri:be}}}}}getWindowOpenableFromPathSync(de){try{if(L.statSync(de).isDirectory())return{folderUri:te.URI.file(de)};if(B.hasWorkspaceFileExtension(de))return{workspaceUri:te.URI.file(de)}}catch(pe){}return{fileUri:te.URI.file(de)}}async afterWindowOpen(de,pe){var ve;this.lifecycleMainService.phase=3;let ge=!1;oe.once(this.lifecycleMainService.onWillShutdown)(()=>ge=!0);const be=de.get(a.ITelemetryService);this._register(pe.onDidError(({type:Ae,details:Me})=>{var Ne,je,qe,Ge;let Qe;switch(Ae){case 1:Qe="SharedProcess: detected unresponsive window";break;case 2:Qe=`SharedProcess: crashed (detail: ${(Ne=Me==null?void 0:Me.reason)!==null&&Ne!==void 0?Ne:"<unknown>"}, code: ${(je=Me==null?void 0:Me.exitCode)!==null&&je!==void 0?je:"<unknown>"})`;break;case 3:Qe=`SharedProcess: failed to load (detail: ${(qe=Me==null?void 0:Me.reason)!==null&&qe!==void 0?qe:"<unknown>"}, code: ${(Ge=Me==null?void 0:Me.exitCode)!==null&&Ge!==void 0?Ge:"<unknown>"})`;break}D.onUnexpectedError(new Error(Qe)),be.publicLog2("sharedprocesserror",{type:Ae,reason:Me==null?void 0:Me.reason,code:Me==null?void 0:Me.exitCode,visible:pe.isVisible(),shuttingdown:ge})}));const De=this.productService.win32MutexName;if(S.isWindows&&De)try{const Ae=$.__$__nodeRequire("windows-mutex").Mutex,Me=new Ae(De);oe.once(this.lifecycleMainService.onWillShutdown)(()=>Me.release())}catch(Ae){this.logService.error(Ae)}R.protocol.registerHttpProtocol(Q.Schemas.vscodeRemoteResource,(Ae,Me)=>{Me({url:Ae.url.replace(/^vscode-remote-resource:/,"http:"),method:Ae.method})});const Re=de.get(y.IUpdateService);(Re instanceof C.Win32UpdateService||Re instanceof z.LinuxUpdateService||Re instanceof X.DarwinUpdateService)&&Re.initialize(),v.resolveShellEnv(this.logService,this.environmentMainService.args,process.env);try{const Me=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse(tt.stripComments(Me))["enable-crash-reporter"]===void 0){const je=(ve=this.configurationService.getValue("telemetry.enableCrashReporter"))!==null&&ve!==void 0?ve:!0,qe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${je},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${ze.generateUuid()}"`,"}"],Ge=Me.substring(0,Me.length-2).concat(`,
`,qe.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,ot.VSBuffer.fromString(Ge))}}catch(Ae){this.logService.error(Ae)}}stopTracingEventually(de,pe){this.logService.info("Tracing: waiting for windows to get ready...");const ve=de.get(me.IDialogMainService);let ge=!1;const be=async Re=>{if(ge)return;ge=!0;const Ae=await R.contentTracing.stopRecording(K.joinPath(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Re?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Ae}`):ve.showMessageBox({title:this.productService.nameLong,type:"info",message:V.localize(4,null),detail:V.localize(5,null,Ae),buttons:[Le.mnemonicButtonLabel(V.localize(6,null))],defaultId:0,noLink:!0},Pe.withNullAsUndefined(R.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>be(!0),3e4);Promise.all(pe.map(Re=>Re.ready())).then(()=>{clearTimeout(De),be(!1)})}};Ce=he([ee(2,k.IInstantiationService),ee(3,h.ILogService),ee(4,l.IEnvironmentMainService),ee(5,n.ILifecycleMainService),ee(6,t.IConfigurationService),ee(7,o.IStateMainService),ee(8,He.IFileService),ee(9,A.IProductService)],Ce),e.CodeApplication=Ce}),define(Z[242],x([0,1,14,29,18,11,3,72,48,54,162,22,34,56,175,71,69,6,227,39,21,190,50,225,238,31,95,94,16,60,43,75,196,199,184,185,10,19,74,223,20,30,23,8,36,24,67,98,182,33,55,187,9,205]),function($,e,m,L,R,S,I,n,v,y,i,E,M,p,d,g,k,P,c,h,o,l,t,r,s,a,u,w,f,b,A,U,q,J,te,B,Y,G,C,z,X,H,W,D,O,F,T,_,N,K,V,Q,ne){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class se{main(){try{this.startup()}catch(re){console.error(re.message),m.app.exit(1)}}async startup(){f.setUnexpectedErrorHandler(me=>console.error(me));const[re,ue,Ee,we,Ie,Te,ye]=this.createServices();try{try{await this.initServices(Ee,we,Ie)}catch(me){throw this.handleStartupDataDirError(Ee,ye.nameLong,me),me}await re.invokeFunction(async me=>{const Pe=me.get(P.ILogService),Le=me.get(E.ILifecycleMainService),_e=me.get(G.IFileService),Be=await this.claimInstance(Pe,Ee,Le,re,ye,!0);return Te.logger=new u.SpdLogLogger("main",D.join(Ee.logsPath,"main.log"),!0,Te.getLevel()),A.once(Le.onWillShutdown)(()=>{_e.dispose(),we.dispose()}),re.createInstance(s.CodeApplication,Be,ue).startup()})}catch(me){re.invokeFunction(this.quit,me)}}createServices(){const re=new g.ServiceCollection,ue=Object.assign({_serviceBrand:void 0},v.default);re.set(X.IProductService,ue);const Ee=new F.EnvironmentMainService(this.resolveArgs(),ue),we=this.patchEnvironment(Ee);re.set(F.IEnvironmentMainService,Ee);const Ie=new w.BufferLogService,Te=new P.MultiplexLogService([new P.ConsoleMainLogger(P.getLogLevel(Ee)),Ie]);process.once("exit",()=>Te.dispose()),re.set(P.ILogService,Te);const ye=new te.FileService(Te);re.set(G.IFileService,ye);const me=new B.DiskFileSystemProvider(Te);ye.registerProvider(Y.Schemas.file,me),re.set(P.ILoggerService,new N.LoggerService(Te,ye));const Pe=new l.ConfigurationService(Ee.settingsResource,ye);re.set(o.IConfigurationService,Pe),re.set(E.ILifecycleMainService,new k.SyncDescriptor(E.LifecycleMainService));const Le=new c.StateMainService(Ee,Te,ye);return re.set(h.IStateMainService,Le),re.set(t.IRequestService,new k.SyncDescriptor(r.RequestMainService)),re.set(b.IThemeMainService,new k.SyncDescriptor(b.ThemeMainService)),re.set(U.ISignService,new k.SyncDescriptor(q.SignService)),re.set(C.ITunnelService,new k.SyncDescriptor(z.TunnelService)),re.set(V.IProtocolMainService,new k.SyncDescriptor(Q.ProtocolMainService)),[new d.InstantiationService(re,!0),we,Ee,Pe,Le,Ie,ue]}patchEnvironment(re){const ue={VSCODE_IPC_HOOK:re.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Ee=>{const we=process.env[Ee];typeof we=="string"&&(ue[Ee]=we)}),Object.assign(process.env,ue),ue}initServices(re,ue,Ee){return ne.Promises.settled([Promise.all([re.extensionsPath,re.codeCachePath,re.logsPath,re.globalStorageHome.fsPath,re.workspaceStorageHome.fsPath,re.backupHome].map(we=>we?R.Promises.mkdir(we,{recursive:!0}):void 0)),ue.initialize(),Ee.init()])}async claimInstance(re,ue,Ee,we,Ie,Te){let ye;try{n.mark("code/willStartMainServer"),ye=await p.serve(ue.mainIPCHandle),n.mark("code/didStartMainServer"),A.once(Ee.onWillShutdown)(()=>ye.dispose())}catch(me){if(me.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ue,Ie.nameLong,me),me;let Pe;try{Pe=await p.connect(ue.mainIPCHandle,"main")}catch(Be){if(!Te||I.isWindows||Be.code!=="ECONNREFUSED")throw Be.code==="EPERM"&&this.showStartupWarningDialog(S.localize(0,null,Ie.nameShort),S.localize(1,null),Ie.nameLong),Be;try{L.unlinkSync(ue.mainIPCHandle)}catch(He){throw re.warn("Could not delete obsolete instance handle",He),He}return this.claimInstance(re,ue,Ee,we,Ie,!1)}if(ue.extensionTestsLocationURI&&!ue.debugExtensionHost.break){const Be="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw re.error(Be),Pe.dispose(),new Error(Be)}let Le;!ue.args.wait&&!ue.args.status&&(Le=setTimeout(()=>{this.showStartupWarningDialog(S.localize(2,null,Ie.nameShort),S.localize(3,null),Ie.nameLong)},1e4));const _e=M.ProxyChannel.toService(Pe.getChannel("launch"),{disableMarshalling:!0});if(ue.args.status)return we.invokeFunction(async()=>{const Be=new J.DiagnosticsService(_.NullTelemetryService,Ie),He=await _e.getMainProcessInfo(),tt=await _e.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),ze=await Be.getDiagnostics(He,tt);throw console.log(ze),new f.ExpectedError});throw I.isWindows&&await this.windowsAllowSetForegroundWindow(_e,re),re.trace("Sending env to running instance..."),await _e.start(ue.args,process.env),Pe.dispose(),Le&&clearTimeout(Le),new f.ExpectedError("Sent env to running instance. Terminating...")}if(ue.args.status)throw re.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new f.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),ye}handleStartupDataDirError(re,ue,Ee){if(Ee.code==="EACCES"||Ee.code==="EPERM"){const we=O.coalesce([re.userDataPath,re.extensionsPath,p.XDG_RUNTIME_DIR]).map(Ie=>a.getPathLabel(Ie,re));this.showStartupWarningDialog(S.localize(4,null),S.localize(5,null,T.toErrorMessage(Ee),we.join(`
`)),ue)}}showStartupWarningDialog(re,ue,Ee){m.dialog.showMessageBoxSync({title:Ee,type:"warning",buttons:[a.mnemonicButtonLabel(S.localize(6,null))],message:re,detail:ue,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(re,ue){if(I.isWindows){const Ee=await re.getMainProcessId();ue.trace("Sending some foreground love to the running instance:",Ee);try{(await new Promise((we,Ie)=>{$(["windows-foreground-love"],we,Ie)})).allowSetForegroundWindow(Ee)}catch(we){ue.error(we)}}}quit(re,ue){const Ee=re.get(P.ILogService),we=re.get(E.ILifecycleMainService);let Ie=0;ue&&(ue.isExpected?ue.message&&Ee.trace(ue.message):(Ie=1,ue.stack?Ee.error(ue.stack):Ee.error(`Startup error: ${ue.toString()}`))),we.kill(Ie)}resolveArgs(){const re=this.validatePaths(y.parseMainProcessArgv(process.argv));if(re.wait&&!re.waitMarkerFilePath){const ue=i.createWaitMarkerFile(re.verbose);ue&&(y.addArg(process.argv,"--waitMarkerFilePath",ue),re.waitMarkerFilePath=ue)}return re}validatePaths(re){if(re["open-url"]&&(re._urls=re._,re._=[]),!re.remote){const ue=this.doValidatePaths(re._,re.goto);re._=ue}return re}doValidatePaths(re,ue){const Ee=K.cwd(),we=re.map(ye=>{let me=String(ye),Pe;ue&&(Pe=H.parseLineAndColumnAware(me),me=Pe.path),me&&(me=this.preparePath(Ee,me));const Le=H.sanitizeFilePath(me,Ee),_e=D.basename(Le);return _e&&!H.isValidBasename(_e)?null:ue&&Pe?(Pe.path=Le,this.toPath(Pe)):Le}),Ie=I.isWindows||I.isMacintosh,Te=O.distinct(we,ye=>ye&&Ie?ye.toLowerCase():ye||"");return O.coalesce(Te)}preparePath(re,ue){return I.isWindows&&(ue=W.rtrim(ue,'"')),ue=W.trim(W.trim(ue," "),"	"),I.isWindows&&(ue=D.resolve(re,ue),ue=W.rtrim(ue,".")),ue}toPath(re){const ue=[re.path];return typeof re.line=="number"&&ue.push(String(re.line)),typeof re.column=="number"&&ue.push(String(re.column)),ue.join(":")}}new se().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9744231fc12f1aed21089180b3f0394d694bd2a2/core/vs/code/electron-main/main.js.map
