/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/network","vs/base/node/pfs","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/errors","vs/base/common/types","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/buffer","vs/base/common/resources","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/objects","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","os","child_process","vs/base/common/process","vs/base/common/stream","vs/base/common/extpath","fs","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","crypto","vs/base/common/performance","vs/base/common/iterator","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],Y=function(_){for(var t=[],g=0,A=_.length;g<A;g++)t[g]=J[_[g]];return t};define(J[57],Y([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function g(A,I){if(!A)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}t.ok=g}),define(J[44],Y([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function g(F){return(R,u,h)=>{let S=null,y=null;if(typeof h.value=="function"?(S="value",y=h.value):typeof h.get=="function"&&(S="get",y=h.get),!y)throw new Error("not supported");h[S]=F(y,u)}}t.createDecorator=g;function A(F,R,u){let h=null,S=null;if(typeof u.value=="function"?(h="value",S=u.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(h="get",S=u.get),!S)throw new Error("not supported");const y=`$memoize$${R}`;u[h]=function(...w){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,w)}),this[y]}}t.memoize=A;function I(F,R,u){return g((h,S)=>{const y=`$debounce$${S}`,w=`$debounce$result$${S}`;return function(...O){this[w]||(this[w]=u?u():void 0),clearTimeout(this[y]),R&&(this[w]=R(this[w],...O),O=[this[w]]),this[y]=setTimeout(()=>{h.apply(this,O),this[w]=u?u():void 0},F)}})}t.debounce=I;function L(F,R,u){return g((h,S)=>{const y=`$throttle$timer$${S}`,w=`$throttle$result$${S}`,O=`$throttle$lastRun$${S}`,c=`$throttle$pending$${S}`;return function(...f){if(this[w]||(this[w]=u?u():void 0),(this[O]===null||this[O]===void 0)&&(this[O]=-Number.MAX_VALUE),R&&(this[w]=R(this[w],...f)),this[c])return;const b=this[O]+F;b<=Date.now()?(this[O]=Date.now(),h.apply(this,[this[w]]),this[w]=u?u():void 0):(this[c]=!0,this[y]=setTimeout(()=>{this[c]=!1,this[O]=Date.now(),h.apply(this,[this[w]]),this[w]=u?u():void 0},b-Date.now()))}})}t.throttle=L}),define(J[22],Y([0,1,12]),function(_,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.maxIndex=t.minIndex=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function A(T,d=0){return T[T.length-(1+d)]}t.tail=A;function I(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}t.tail2=I;function L(T,d,a=(v,p)=>v===p){if(T===d)return!0;if(!T||!d||T.length!==d.length)return!1;for(let v=0,p=T.length;v<p;v++)if(!a(T[v],d[v]))return!1;return!0}t.equals=L;function F(T,d,a){let v=0,p=T.length-1;for(;v<=p;){const N=(v+p)/2|0,M=a(T[N],d);if(M<0)v=N+1;else if(M>0)p=N-1;else return N}return-(v+1)}t.binarySearch=F;function R(T,d){let a=0,v=T.length;if(v===0)return 0;for(;a<v;){const p=Math.floor((a+v)/2);d(T[p])?v=p:a=p+1}return a}t.findFirstInSorted=R;function u(T,d,a){if(T=T|0,T>=d.length)throw new TypeError("invalid index");let v=d[Math.floor(d.length*Math.random())],p=[],N=[],M=[];for(let x of d){const B=a(x,v);B<0?p.push(x):B>0?N.push(x):M.push(x)}return T<p.length?u(T,p,a):T<p.length+M.length?M[0]:u(T-(p.length+M.length),N,a)}t.quickSelect=u;function h(T,d){const a=[];let v;for(const p of T.slice(0).sort(d))!v||d(v[0],p)!==0?(v=[p],a.push(v)):v.push(p);return a}t.groupBy=h;function S(T,d,a){const v=[];function p(x,B,W){if(B===0&&W.length===0)return;const H=v[v.length-1];H&&H.start+H.deleteCount===x?(H.deleteCount+=B,H.toInsert.push(...W)):v.push({start:x,deleteCount:B,toInsert:W})}let N=0,M=0;for(;;){if(N===T.length){p(N,0,d.slice(M));break}if(M===d.length){p(N,T.length-N,[]);break}const x=T[N],B=d[M],W=a(x,B);W===0?(N+=1,M+=1):W<0?(p(N,1,[]),N+=1):W>0&&(p(N,0,[B]),M+=1)}return v}t.sortedDiff=S;function y(T,d,a){const v=S(T,d,a),p=[],N=[];for(const M of v)p.push(...T.slice(M.start,M.start+M.deleteCount)),N.push(...M.toInsert);return{removed:p,added:N}}t.delta=y;function w(T,d,a){if(a===0)return[];const v=T.slice(0,a).sort(d);return c(T,d,v,a,T.length),v}t.top=w;function O(T,d,a,v,p){return a===0?Promise.resolve([]):new Promise((N,M)=>{(async()=>{const x=T.length,B=T.slice(0,a).sort(d);for(let W=a,H=Math.min(a+v,x);W<x;W=H,H=Math.min(H+v,x)){if(W>a&&await new Promise(X=>setTimeout(X)),p&&p.isCancellationRequested)throw g.canceled();c(T,d,B,W,H)}return B})().then(N,M)})}t.topAsync=O;function c(T,d,a,v,p){for(const N=a.length;v<p;v++){const M=T[v];if(d(M,a[N-1])<0){a.pop();const x=R(a,B=>d(M,B)<0);a.splice(x,0,M)}}}function f(T){return T.filter(d=>!!d)}t.coalesce=f;function b(T){let d=0;for(let a=0;a<T.length;a++)T[a]&&(T[d]=T[a],d+=1);T.length=d}t.coalesceInPlace=b;function C(T,d,a){T.splice(a,0,T.splice(d,1)[0])}t.move=C;function D(T){return!Array.isArray(T)||T.length===0}t.isFalsyOrEmpty=D;function m(T){return Array.isArray(T)&&T.length>0}t.isNonEmptyArray=m;function o(T,d){if(!d)return T.filter((v,p)=>T.indexOf(v)===p);const a=Object.create(null);return T.filter(v=>{const p=d(v);return a[p]?!1:(a[p]=!0,!0)})}t.distinct=o;function r(T){const d=new Set;return T.filter(a=>d.has(a)?!1:(d.add(a),!0))}t.distinctES6=r;function e(T){const d=Object.create(null);return a=>{const v=T(a);return d[v]?!1:(d[v]=!0,!0)}}t.uniqueFilter=e;function i(T,d){for(let a=T.length-1;a>=0;a--){const v=T[a];if(d(v))return a}return-1}t.lastIndex=i;function n(T,d){return T.length>0?T[0]:d}t.firstOrDefault=n;function s(T,d,a=(v,p)=>v===p){let v=0;for(let p=0,N=Math.min(T.length,d.length);p<N&&a(T[p],d[p]);p++)v++;return v}t.commonPrefixLength=s;function l(T){return[].concat(...T)}t.flatten=l;function E(T,d){let a=typeof d=="number"?T:0;typeof d=="number"?a=T:(a=0,d=T);const v=[];if(a<=d)for(let p=a;p<d;p++)v.push(p);else for(let p=a;p>d;p--)v.push(p);return v}t.range=E;function P(T,d,a){return T.reduce((v,p)=>(v[d(p)]=a?a(p):p,v),Object.create(null))}t.index=P;function U(T,d){return T.push(d),()=>k(T,d)}t.insert=U;function k(T,d){const a=T.indexOf(d);if(a>-1)return T.splice(a,1),d}t.remove=k;function j(T,d,a){const v=T.slice(0,d),p=T.slice(d);return v.concat(a,p)}t.arrayInsert=j;function V(T,d){let a;if(typeof d=="number"){let v=d;a=()=>{const p=Math.sin(v++)*179426549;return p-Math.floor(p)}}else a=Math.random;for(let v=T.length-1;v>0;v-=1){const p=Math.floor(a()*(v+1)),N=T[v];T[v]=T[p],T[p]=N}}t.shuffle=V;function $(T,d){const a=T.indexOf(d);a>-1&&(T.splice(a,1),T.unshift(d))}t.pushToStart=$;function K(T,d){const a=T.indexOf(d);a>-1&&(T.splice(a,1),T.push(d))}t.pushToEnd=K;function ee(T,d){return Array.isArray(T)?T.map(d):d(T)}t.mapArrayOrNot=ee;function te(T){return Array.isArray(T)?T:[T]}t.asArray=te;function Q(T){return T[Math.floor(Math.random()*T.length)]}t.getRandomElement=Q;function ae(T,d){for(const a of T){const v=d(a);if(v!==void 0)return v}}t.mapFind=ae;function se(T,d){let a=Number.MAX_SAFE_INTEGER,v=0;return T.forEach((p,N)=>{const M=d(p);M<a&&(a=M,v=N)}),v}t.minIndex=se;function re(T,d){let a=Number.MIN_SAFE_INTEGER,v=0;return T.forEach((p,N)=>{const M=d(p);M>a&&(a=M,v=N)}),v}t.maxIndex=re}),define(J[58],Y([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var g;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(g=t.ScanError||(t.ScanError={}));var A;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(A=t.SyntaxKind||(t.SyntaxKind={}));var I;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(I=t.ParseErrorCode||(t.ParseErrorCode={}));var L;(function(e){e.DEFAULT={allowTrailingComma:!0}})(L=t.ParseOptions||(t.ParseOptions={}));function F(e,i=!1){let n=0,s=e.length,l="",E=0,P=16,U=0;function k(Q){let ae=0,se=0;for(;ae<Q;){const re=e.charCodeAt(n);if(re>=48&&re<=57)se=se*16+re-48;else if(re>=65&&re<=70)se=se*16+re-65+10;else if(re>=97&&re<=102)se=se*16+re-97+10;else break;n++,ae++}return ae<Q&&(se=-1),se}function j(Q){n=Q,l="",E=0,P=16,U=0}function V(){const Q=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&h(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&h(e.charCodeAt(n)))for(n++;n<e.length&&h(e.charCodeAt(n));)n++;else return U=3,e.substring(Q,n);let ae=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&h(e.charCodeAt(n))){for(n++;n<e.length&&h(e.charCodeAt(n));)n++;ae=n}else U=3;return e.substring(Q,ae)}function $(){let Q="",ae=n;for(;;){if(n>=s){Q+=e.substring(ae,n),U=2;break}const se=e.charCodeAt(n);if(se===34){Q+=e.substring(ae,n),n++;break}if(se===92){if(Q+=e.substring(ae,n),n++,n>=s){U=2;break}switch(e.charCodeAt(n++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:const T=k(4);T>=0?Q+=String.fromCharCode(T):U=4;break;default:U=5}ae=n;continue}if(se>=0&&se<=31)if(u(se)){Q+=e.substring(ae,n),U=2;break}else U=6;n++}return Q}function K(){if(l="",U=0,E=n,n>=s)return E=s,P=17;let Q=e.charCodeAt(n);if(R(Q)){do n++,l+=String.fromCharCode(Q),Q=e.charCodeAt(n);while(R(Q));return P=15}if(u(Q))return n++,l+=String.fromCharCode(Q),Q===13&&e.charCodeAt(n)===10&&(n++,l+=`
`),P=14;switch(Q){case 123:return n++,P=1;case 125:return n++,P=2;case 91:return n++,P=3;case 93:return n++,P=4;case 58:return n++,P=6;case 44:return n++,P=5;case 34:return n++,l=$(),P=10;case 47:const ae=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<s&&!u(e.charCodeAt(n));)n++;return l=e.substring(ae,n),P=12}if(e.charCodeAt(n+1)===42){n+=2;const se=s-1;let re=!1;for(;n<se;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,re=!0;break}n++}return re||(n++,U=1),l=e.substring(ae,n),P=13}return l+=String.fromCharCode(Q),n++,P=16;case 45:if(l+=String.fromCharCode(Q),n++,n===s||!h(e.charCodeAt(n)))return P=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=V(),P=11;default:for(;n<s&&ee(Q);)n++,Q=e.charCodeAt(n);if(E!==n){switch(l=e.substring(E,n),l){case"true":return P=8;case"false":return P=9;case"null":return P=7}return P=16}return l+=String.fromCharCode(Q),n++,P=16}}function ee(Q){if(R(Q)||u(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function te(){let Q;do Q=K();while(Q>=12&&Q<=15);return Q}return{setPosition:j,getPosition:()=>n,scan:i?te:K,getToken:()=>P,getTokenValue:()=>l,getTokenOffset:()=>E,getTokenLength:()=>n-E,getTokenError:()=>U}}t.createScanner=F;function R(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function u(e){return e===10||e===13||e===8232||e===8233}function h(e){return e>=48&&e<=57}var S;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(S||(S={}));function y(e,i){const n=[],s=new Object;let l;const E={value:{},offset:0,length:0,type:"object",parent:void 0};let P=!1;function U(k,j,V,$){E.value=k,E.offset=j,E.length=V,E.type=$,E.colonOffset=void 0,l=E}try{m(e,{onObjectBegin:(k,j)=>{if(i<=k)throw s;l=void 0,P=i>k,n.push("")},onObjectProperty:(k,j,V)=>{if(i<j||(U(k,j,V,"property"),n[n.length-1]=k,i<=j+V))throw s},onObjectEnd:(k,j)=>{if(i<=k)throw s;l=void 0,n.pop()},onArrayBegin:(k,j)=>{if(i<=k)throw s;l=void 0,n.push(0)},onArrayEnd:(k,j)=>{if(i<=k)throw s;l=void 0,n.pop()},onLiteralValue:(k,j,V)=>{if(i<j||(U(k,j,V,r(k)),i<=j+V))throw s},onSeparator:(k,j,V)=>{if(i<=j)throw s;if(k===":"&&l&&l.type==="property")l.colonOffset=j,P=!1,l=void 0;else if(k===","){const $=n[n.length-1];typeof $=="number"?n[n.length-1]=$+1:(P=!0,n[n.length-1]=""),l=void 0}}})}catch(k){if(k!==s)throw k}return{path:n,previousNode:l,isAtPropertyKey:P,matches:k=>{let j=0;for(let V=0;j<k.length&&V<n.length;V++)if(k[j]===n[V]||k[j]==="*")j++;else if(k[j]!=="**")return!1;return j===k.length}}}t.getLocation=y;function w(e,i=[],n=L.DEFAULT){let s=null,l=[];const E=[];function P(k){Array.isArray(l)?l.push(k):s!==null&&(l[s]=k)}return m(e,{onObjectBegin:()=>{const k={};P(k),E.push(l),l=k,s=null},onObjectProperty:k=>{s=k},onObjectEnd:()=>{l=E.pop()},onArrayBegin:()=>{const k=[];P(k),E.push(l),l=k,s=null},onArrayEnd:()=>{l=E.pop()},onLiteralValue:P,onError:(k,j,V)=>{i.push({error:k,offset:j,length:V})}},n),l[0]}t.parse=w;function O(e,i=[],n=L.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(k){s.type==="property"&&(s.length=k-s.offset,s=s.parent)}function E(k){return s.children.push(k),k}m(e,{onObjectBegin:k=>{s=E({type:"object",offset:k,length:-1,parent:s,children:[]})},onObjectProperty:(k,j,V)=>{s=E({type:"property",offset:j,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:k,offset:j,length:V,parent:s})},onObjectEnd:(k,j)=>{s.length=k+j-s.offset,s=s.parent,l(k+j)},onArrayBegin:(k,j)=>{s=E({type:"array",offset:k,length:-1,parent:s,children:[]})},onArrayEnd:(k,j)=>{s.length=k+j-s.offset,s=s.parent,l(k+j)},onLiteralValue:(k,j,V)=>{E({type:r(k),offset:j,length:V,parent:s,value:k}),l(j+V)},onSeparator:(k,j,V)=>{s.type==="property"&&(k===":"?s.colonOffset=j:k===","&&l(j))},onError:(k,j,V)=>{i.push({error:k,offset:j,length:V})}},n);const U=s.children[0];return U&&delete U.parent,U}t.parseTree=O;function c(e,i){if(!e)return;let n=e;for(let s of i)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let l=!1;for(const E of n.children)if(Array.isArray(E.children)&&E.children[0].value===s){n=E.children[1],l=!0;break}if(!l)return}else{const l=s;if(n.type!=="array"||l<0||!Array.isArray(n.children)||l>=n.children.length)return;n=n.children[l]}return n}t.findNodeAtLocation=c;function f(e){if(!e.parent||!e.parent.children)return[];const i=f(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=f;function b(e){switch(e.type){case"array":return e.children.map(b);case"object":const i=Object.create(null);for(let n of e.children){const s=n.children[1];s&&(i[n.children[0].value]=b(s))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=b;function C(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=C;function D(e,i,n=!1){if(C(e,i,n)){const s=e.children;if(Array.isArray(s))for(let l=0;l<s.length&&s[l].offset<=i;l++){const E=D(s[l],i,n);if(E)return E}return e}}t.findNodeAtOffset=D;function m(e,i,n=L.DEFAULT){const s=F(e,!1);function l(M){return M?()=>M(s.getTokenOffset(),s.getTokenLength()):()=>!0}function E(M){return M?x=>M(x,s.getTokenOffset(),s.getTokenLength()):()=>!0}const P=l(i.onObjectBegin),U=E(i.onObjectProperty),k=l(i.onObjectEnd),j=l(i.onArrayBegin),V=l(i.onArrayEnd),$=E(i.onLiteralValue),K=E(i.onSeparator),ee=l(i.onComment),te=E(i.onError),Q=n&&n.disallowComments,ae=n&&n.allowTrailingComma;function se(){for(;;){const M=s.scan();switch(s.getTokenError()){case 4:re(14);break;case 5:re(15);break;case 3:re(13);break;case 1:Q||re(11);break;case 2:re(12);break;case 6:re(16);break}switch(M){case 12:case 13:Q?re(10):ee();break;case 16:re(1);break;case 15:case 14:break;default:return M}}}function re(M,x=[],B=[]){if(te(M),x.length+B.length>0){let W=s.getToken();for(;W!==17;){if(x.indexOf(W)!==-1){se();break}else if(B.indexOf(W)!==-1)break;W=se()}}}function T(M){const x=s.getTokenValue();return M?$(x):U(x),se(),!0}function d(){switch(s.getToken()){case 11:let M=0;try{M=JSON.parse(s.getTokenValue()),typeof M!="number"&&(re(2),M=0)}catch(x){re(2)}$(M);break;case 7:$(null);break;case 8:$(!0);break;case 9:$(!1);break;default:return!1}return se(),!0}function a(){return s.getToken()!==10?(re(3,[],[2,5]),!1):(T(!1),s.getToken()===6?(K(":"),se(),N()||re(4,[],[2,5])):re(5,[],[2,5]),!0)}function v(){P(),se();let M=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(M||re(4,[],[]),K(","),se(),s.getToken()===2&&ae)break}else M&&re(6,[],[]);a()||re(4,[],[2,5]),M=!0}return k(),s.getToken()!==2?re(7,[2],[]):se(),!0}function p(){j(),se();let M=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(M||re(4,[],[]),K(","),se(),s.getToken()===4&&ae)break}else M&&re(6,[],[]);N()||re(4,[],[4,5]),M=!0}return V(),s.getToken()!==4?re(8,[4],[]):se(),!0}function N(){switch(s.getToken()){case 3:return p();case 1:return v();case 10:return T(!0);default:return d()}}return se(),s.getToken()===17?n.allowEmptyContent?!0:(re(4,[],[]),!1):N()?(s.getToken()!==17&&re(9,[],[]),!0):(re(4,[],[]),!1)}t.visit=m;function o(e,i){let n=F(e),s=[],l,E=0,P;do switch(P=n.getPosition(),l=n.scan(),l){case 12:case 13:case 17:E!==P&&s.push(e.substring(E,P)),i!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,i)),E=n.getPosition();break}while(l!==17);return s.join("")}t.stripComments=o;function r(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=r}),function(){function _(I){const L=[];typeof I=="number"&&L.push("code/timeOrigin",I);function F(u){L.push(u,Date.now())}function R(){const u=[];for(let h=0;h<L.length;h+=2)u.push({name:L[h],startTime:L[h+1]});return u}return{mark:F,getMarks:R}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?_():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const F of performance.getEntriesByType("mark"))L.push({name:F.name,startTime:Math.round(I+F.startTime)});return L}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return _(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),_()}function g(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=t()),I.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=g(A))}(),function(_,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var g=t();for(var A in g)(typeof exports=="object"?exports:_)[A]=g[A]}}(typeof self!="undefined"?self:this,function(){return function(_){var t={};function g(A){if(t[A])return t[A].exports;var I=t[A]={i:A,l:!1,exports:{}};return _[A].call(I.exports,I,I.exports,g),I.l=!0,I.exports}return g.m=_,g.c=t,g.d=function(A,I,L){g.o(A,I)||Object.defineProperty(A,I,{enumerable:!0,get:L})},g.r=function(A){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},g.t=function(A,I){if(1&I&&(A=g(A)),8&I||4&I&&typeof A=="object"&&A&&A.__esModule)return A;var L=Object.create(null);if(g.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:A}),2&I&&typeof A!="string")for(var F in A)g.d(L,F,function(R){return A[R]}.bind(null,F));return L},g.n=function(A){var I=A&&A.__esModule?function(){return A.default}:function(){return A};return g.d(I,"a",I),I},g.o=function(A,I){return Object.prototype.hasOwnProperty.call(A,I)},g.p="",g(g.s=0)}([function(_,t,g){(function(A){var I;t=_.exports=B,I=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var L=256,F=Number.MAX_SAFE_INTEGER||9007199254740991,R=t.re=[],u=t.src=[],h=0,S=h++;u[S]="0|[1-9]\\d*";var y=h++;u[y]="[0-9]+";var w=h++;u[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var O=h++;u[O]="("+u[S]+")\\.("+u[S]+")\\.("+u[S]+")";var c=h++;u[c]="("+u[y]+")\\.("+u[y]+")\\.("+u[y]+")";var f=h++;u[f]="(?:"+u[S]+"|"+u[w]+")";var b=h++;u[b]="(?:"+u[y]+"|"+u[w]+")";var C=h++;u[C]="(?:-("+u[f]+"(?:\\."+u[f]+")*))";var D=h++;u[D]="(?:-?("+u[b]+"(?:\\."+u[b]+")*))";var m=h++;u[m]="[0-9A-Za-z-]+";var o=h++;u[o]="(?:\\+("+u[m]+"(?:\\."+u[m]+")*))";var r=h++,e="v?"+u[O]+u[C]+"?"+u[o]+"?";u[r]="^"+e+"$";var i="[v=\\s]*"+u[c]+u[D]+"?"+u[o]+"?",n=h++;u[n]="^"+i+"$";var s=h++;u[s]="((?:<|>)?=?)";var l=h++;u[l]=u[y]+"|x|X|\\*";var E=h++;u[E]=u[S]+"|x|X|\\*";var P=h++;u[P]="[v=\\s]*("+u[E]+")(?:\\.("+u[E]+")(?:\\.("+u[E]+")(?:"+u[C]+")?"+u[o]+"?)?)?";var U=h++;u[U]="[v=\\s]*("+u[l]+")(?:\\.("+u[l]+")(?:\\.("+u[l]+")(?:"+u[D]+")?"+u[o]+"?)?)?";var k=h++;u[k]="^"+u[s]+"\\s*"+u[P]+"$";var j=h++;u[j]="^"+u[s]+"\\s*"+u[U]+"$";var V=h++;u[V]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var $=h++;u[$]="(?:~>?)";var K=h++;u[K]="(\\s*)"+u[$]+"\\s+",R[K]=new RegExp(u[K],"g");var ee=h++;u[ee]="^"+u[$]+u[P]+"$";var te=h++;u[te]="^"+u[$]+u[U]+"$";var Q=h++;u[Q]="(?:\\^)";var ae=h++;u[ae]="(\\s*)"+u[Q]+"\\s+",R[ae]=new RegExp(u[ae],"g");var se=h++;u[se]="^"+u[Q]+u[P]+"$";var re=h++;u[re]="^"+u[Q]+u[U]+"$";var T=h++;u[T]="^"+u[s]+"\\s*("+i+")$|^$";var d=h++;u[d]="^"+u[s]+"\\s*("+e+")$|^$";var a=h++;u[a]="(\\s*)"+u[s]+"\\s*("+i+"|"+u[P]+")",R[a]=new RegExp(u[a],"g");var v=h++;u[v]="^\\s*("+u[P]+")\\s+-\\s+("+u[P]+")\\s*$";var p=h++;u[p]="^\\s*("+u[U]+")\\s+-\\s+("+u[U]+")\\s*$";var N=h++;u[N]="(<|>)?=?\\s*\\*";for(var M=0;M<35;M++)I(M,u[M]),R[M]||(R[M]=new RegExp(u[M]));function x(z,q){if(z instanceof B)return z;if(typeof z!="string"||z.length>L||!(q?R[n]:R[r]).test(z))return null;try{return new B(z,q)}catch(G){return null}}function B(z,q){if(z instanceof B){if(z.loose===q)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof B))return new B(z,q);I("SemVer",z,q),this.loose=q;var G=z.trim().match(q?R[n]:R[r]);if(!G)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+G[1],this.minor=+G[2],this.patch=+G[3],this.major>F||this.major<0)throw new TypeError("Invalid major version");if(this.minor>F||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>F||this.patch<0)throw new TypeError("Invalid patch version");G[4]?this.prerelease=G[4].split(".").map(function(ne){if(/^[0-9]+$/.test(ne)){var oe=+ne;if(oe>=0&&oe<F)return oe}return ne}):this.prerelease=[],this.build=G[5]?G[5].split("."):[],this.format()}t.parse=x,t.valid=function(z,q){var G=x(z,q);return G?G.version:null},t.clean=function(z,q){var G=x(z.trim().replace(/^[=v]+/,""),q);return G?G.version:null},t.SemVer=B,B.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},B.prototype.toString=function(){return this.version},B.prototype.compare=function(z){return I("SemVer.compare",this.version,this.loose,z),z instanceof B||(z=new B(z,this.loose)),this.compareMain(z)||this.comparePre(z)},B.prototype.compareMain=function(z){return z instanceof B||(z=new B(z,this.loose)),H(this.major,z.major)||H(this.minor,z.minor)||H(this.patch,z.patch)},B.prototype.comparePre=function(z){if(z instanceof B||(z=new B(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var q=0;do{var G=this.prerelease[q],ne=z.prerelease[q];if(I("prerelease compare",q,G,ne),G===void 0&&ne===void 0)return 0;if(ne===void 0)return 1;if(G===void 0)return-1;if(G!==ne)return H(G,ne)}while(++q)},B.prototype.inc=function(z,q){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",q),this.inc("pre",q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",q),this.inc("pre",q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var G=this.prerelease.length;--G>=0;)typeof this.prerelease[G]=="number"&&(this.prerelease[G]++,G=-2);G===-1&&this.prerelease.push(0)}q&&(this.prerelease[0]===q?isNaN(this.prerelease[1])&&(this.prerelease=[q,0]):this.prerelease=[q,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},t.inc=function(z,q,G,ne){typeof G=="string"&&(ne=G,G=void 0);try{return new B(z,G).inc(q,ne).version}catch(oe){return null}},t.diff=function(z,q){if(ce(z,q))return null;var G=x(z),ne=x(q);if(G.prerelease.length||ne.prerelease.length){for(var oe in G)if((oe==="major"||oe==="minor"||oe==="patch")&&G[oe]!==ne[oe])return"pre"+oe;return"prerelease"}for(var oe in G)if((oe==="major"||oe==="minor"||oe==="patch")&&G[oe]!==ne[oe])return oe},t.compareIdentifiers=H;var W=/^[0-9]+$/;function H(z,q){var G=W.test(z),ne=W.test(q);return G&&ne&&(z=+z,q=+q),G&&!ne?-1:ne&&!G?1:z<q?-1:z>q?1:0}function X(z,q,G){return new B(z,G).compare(new B(q,G))}function Z(z,q,G){return X(z,q,G)>0}function ie(z,q,G){return X(z,q,G)<0}function ce(z,q,G){return X(z,q,G)===0}function ge(z,q,G){return X(z,q,G)!==0}function Pe(z,q,G){return X(z,q,G)>=0}function Fe(z,q,G){return X(z,q,G)<=0}function Re(z,q,G,ne){var oe;switch(q){case"===":typeof z=="object"&&(z=z.version),typeof G=="object"&&(G=G.version),oe=z===G;break;case"!==":typeof z=="object"&&(z=z.version),typeof G=="object"&&(G=G.version),oe=z!==G;break;case"":case"=":case"==":oe=ce(z,G,ne);break;case"!=":oe=ge(z,G,ne);break;case">":oe=Z(z,G,ne);break;case">=":oe=Pe(z,G,ne);break;case"<":oe=ie(z,G,ne);break;case"<=":oe=Fe(z,G,ne);break;default:throw new TypeError("Invalid operator: "+q)}return oe}function Se(z,q){if(z instanceof Se){if(z.loose===q)return z;z=z.value}if(!(this instanceof Se))return new Se(z,q);I("comparator",z,q),this.loose=q,this.parse(z),this.semver===ke?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}t.rcompareIdentifiers=function(z,q){return H(q,z)},t.major=function(z,q){return new B(z,q).major},t.minor=function(z,q){return new B(z,q).minor},t.patch=function(z,q){return new B(z,q).patch},t.compare=X,t.compareLoose=function(z,q){return X(z,q,!0)},t.rcompare=function(z,q,G){return X(q,z,G)},t.sort=function(z,q){return z.sort(function(G,ne){return t.compare(G,ne,q)})},t.rsort=function(z,q){return z.sort(function(G,ne){return t.rcompare(G,ne,q)})},t.gt=Z,t.lt=ie,t.eq=ce,t.neq=ge,t.gte=Pe,t.lte=Fe,t.cmp=Re,t.Comparator=Se;var ke={};function pe(z,q){if(z instanceof pe)return z.loose===q?z:new pe(z.raw,q);if(z instanceof Se)return new pe(z.value,q);if(!(this instanceof pe))return new pe(z,q);if(this.loose=q,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(G){return this.parseRange(G.trim())},this).filter(function(G){return G.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function Ce(z){return!z||z.toLowerCase()==="x"||z==="*"}function _e(z,q,G,ne,oe,be,de,Oe,Ee,Le,Ne,we,Ie){return((q=Ce(G)?"":Ce(ne)?">="+G+".0.0":Ce(oe)?">="+G+"."+ne+".0":">="+q)+" "+(Oe=Ce(Ee)?"":Ce(Le)?"<"+(+Ee+1)+".0.0":Ce(Ne)?"<"+Ee+"."+(+Le+1)+".0":we?"<="+Ee+"."+Le+"."+Ne+"-"+we:"<="+Oe)).trim()}function $e(z,q){for(var G=0;G<z.length;G++)if(!z[G].test(q))return!1;if(q.prerelease.length){for(G=0;G<z.length;G++)if(I(z[G].semver),z[G].semver!==ke&&z[G].semver.prerelease.length>0){var ne=z[G].semver;if(ne.major===q.major&&ne.minor===q.minor&&ne.patch===q.patch)return!0}return!1}return!0}function ze(z,q,G){try{q=new pe(q,G)}catch(ne){return!1}return q.test(z)}function Ve(z,q,G,ne){var oe,be,de,Oe,Ee;switch(z=new B(z,ne),q=new pe(q,ne),G){case">":oe=Z,be=Fe,de=ie,Oe=">",Ee=">=";break;case"<":oe=ie,be=Pe,de=Z,Oe="<",Ee="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(z,q,ne))return!1;for(var Le=0;Le<q.set.length;++Le){var Ne=q.set[Le],we=null,Ie=null;if(Ne.forEach(function(Te){Te.semver===ke&&(Te=new Se(">=0.0.0")),we=we||Te,Ie=Ie||Te,oe(Te.semver,we.semver,ne)?we=Te:de(Te.semver,Ie.semver,ne)&&(Ie=Te)}),we.operator===Oe||we.operator===Ee||(!Ie.operator||Ie.operator===Oe)&&be(z,Ie.semver)||Ie.operator===Ee&&de(z,Ie.semver))return!1}return!0}Se.prototype.parse=function(z){var q=this.loose?R[T]:R[d],G=z.match(q);if(!G)throw new TypeError("Invalid comparator: "+z);this.operator=G[1],this.operator==="="&&(this.operator=""),G[2]?this.semver=new B(G[2],this.loose):this.semver=ke},Se.prototype.toString=function(){return this.value},Se.prototype.test=function(z){return I("Comparator.test",z,this.loose),this.semver===ke||(typeof z=="string"&&(z=new B(z,this.loose)),Re(z,this.operator,this.semver,this.loose))},Se.prototype.intersects=function(z,q){if(!(z instanceof Se))throw new TypeError("a Comparator is required");var G;if(this.operator==="")return G=new pe(z.value,q),ze(this.value,G,q);if(z.operator==="")return G=new pe(this.value,q),ze(z.semver,G,q);var ne=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),oe=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),be=this.semver.version===z.semver.version,de=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Oe=Re(this.semver,"<",z.semver,q)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),Ee=Re(this.semver,">",z.semver,q)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return ne||oe||be&&de||Oe||Ee},t.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(z){var q=this.loose;z=z.trim(),I("range",z,q);var G=q?R[p]:R[v];z=z.replace(G,_e),I("hyphen replace",z),z=z.replace(R[a],"$1$2$3"),I("comparator trim",z,R[a]),z=(z=(z=z.replace(R[K],"$1~")).replace(R[ae],"$1^")).split(/\s+/).join(" ");var ne=q?R[T]:R[d],oe=z.split(" ").map(function(be){return function(de,Oe){return I("comp",de),de=function(Ee,Le){return Ee.trim().split(/\s+/).map(function(Ne){return function(we,Ie){I("caret",we,Ie);var Te=Ie?R[re]:R[se];return we.replace(Te,function(Ae,le,he,me,ve){var De;return I("caret",we,Ae,le,he,me,ve),Ce(le)?De="":Ce(he)?De=">="+le+".0.0 <"+(+le+1)+".0.0":Ce(me)?De=le==="0"?">="+le+"."+he+".0 <"+le+"."+(+he+1)+".0":">="+le+"."+he+".0 <"+(+le+1)+".0.0":ve?(I("replaceCaret pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),De=le==="0"?he==="0"?">="+le+"."+he+"."+me+ve+" <"+le+"."+he+"."+(+me+1):">="+le+"."+he+"."+me+ve+" <"+le+"."+(+he+1)+".0":">="+le+"."+he+"."+me+ve+" <"+(+le+1)+".0.0"):(I("no pr"),De=le==="0"?he==="0"?">="+le+"."+he+"."+me+" <"+le+"."+he+"."+(+me+1):">="+le+"."+he+"."+me+" <"+le+"."+(+he+1)+".0":">="+le+"."+he+"."+me+" <"+(+le+1)+".0.0"),I("caret return",De),De})}(Ne,Le)}).join(" ")}(de,Oe),I("caret",de),de=function(Ee,Le){return Ee.trim().split(/\s+/).map(function(Ne){return function(we,Ie){var Te=Ie?R[te]:R[ee];return we.replace(Te,function(Ae,le,he,me,ve){var De;return I("tilde",we,Ae,le,he,me,ve),Ce(le)?De="":Ce(he)?De=">="+le+".0.0 <"+(+le+1)+".0.0":Ce(me)?De=">="+le+"."+he+".0 <"+le+"."+(+he+1)+".0":ve?(I("replaceTilde pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),De=">="+le+"."+he+"."+me+ve+" <"+le+"."+(+he+1)+".0"):De=">="+le+"."+he+"."+me+" <"+le+"."+(+he+1)+".0",I("tilde return",De),De})}(Ne,Le)}).join(" ")}(de,Oe),I("tildes",de),de=function(Ee,Le){return I("replaceXRanges",Ee,Le),Ee.split(/\s+/).map(function(Ne){return function(we,Ie){we=we.trim();var Te=Ie?R[j]:R[k];return we.replace(Te,function(Ae,le,he,me,ve,De){I("xRange",we,Ae,le,he,me,ve,De);var We=Ce(he),je=We||Ce(me),Ue=je||Ce(ve);return le==="="&&Ue&&(le=""),We?Ae=le===">"||le==="<"?"<0.0.0":"*":le&&Ue?(je&&(me=0),Ue&&(ve=0),le===">"?(le=">=",je?(he=+he+1,me=0,ve=0):Ue&&(me=+me+1,ve=0)):le==="<="&&(le="<",je?he=+he+1:me=+me+1),Ae=le+he+"."+me+"."+ve):je?Ae=">="+he+".0.0 <"+(+he+1)+".0.0":Ue&&(Ae=">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0"),I("xRange return",Ae),Ae})}(Ne,Le)}).join(" ")}(de,Oe),I("xrange",de),de=function(Ee,Le){return I("replaceStars",Ee,Le),Ee.trim().replace(R[N],"")}(de,Oe),I("stars",de),de}(be,q)}).join(" ").split(/\s+/);return this.loose&&(oe=oe.filter(function(be){return!!be.match(ne)})),oe=oe.map(function(be){return new Se(be,q)})},pe.prototype.intersects=function(z,q){if(!(z instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(G){return G.every(function(ne){return z.set.some(function(oe){return oe.every(function(be){return ne.intersects(be,q)})})})})},t.toComparators=function(z,q){return new pe(z,q).set.map(function(G){return G.map(function(ne){return ne.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new B(z,this.loose));for(var q=0;q<this.set.length;q++)if($e(this.set[q],z))return!0;return!1},t.satisfies=ze,t.maxSatisfying=function(z,q,G){var ne=null,oe=null;try{var be=new pe(q,G)}catch(de){return null}return z.forEach(function(de){be.test(de)&&(ne&&oe.compare(de)!==-1||(oe=new B(ne=de,G)))}),ne},t.minSatisfying=function(z,q,G){var ne=null,oe=null;try{var be=new pe(q,G)}catch(de){return null}return z.forEach(function(de){be.test(de)&&(ne&&oe.compare(de)!==1||(oe=new B(ne=de,G)))}),ne},t.validRange=function(z,q){try{return new pe(z,q).range||"*"}catch(G){return null}},t.ltr=function(z,q,G){return Ve(z,q,"<",G)},t.gtr=function(z,q,G){return Ve(z,q,">",G)},t.outside=Ve,t.prerelease=function(z,q){var G=x(z,q);return G&&G.prerelease.length?G.prerelease:null},t.intersects=function(z,q,G){return z=new pe(z,G),q=new pe(q,G),z.intersects(q)},t.coerce=function(z){if(z instanceof B)return z;if(typeof z!="string")return null;var q=z.match(R[V]);return q==null?null:x((q[1]||"0")+"."+(q[2]||"0")+"."+(q[3]||"0"))}}).call(this,g(1))},function(_,t){var g,A,I=_.exports={};function L(){throw new Error("setTimeout has not been defined")}function F(){throw new Error("clearTimeout has not been defined")}function R(b){if(g===setTimeout)return setTimeout(b,0);if((g===L||!g)&&setTimeout)return g=setTimeout,setTimeout(b,0);try{return g(b,0)}catch(C){try{return g.call(null,b,0)}catch(D){return g.call(this,b,0)}}}(function(){try{g=typeof setTimeout=="function"?setTimeout:L}catch(b){g=L}try{A=typeof clearTimeout=="function"?clearTimeout:F}catch(b){A=F}})();var u,h=[],S=!1,y=-1;function w(){S&&u&&(S=!1,u.length?h=u.concat(h):y=-1,h.length&&O())}function O(){if(!S){var b=R(w);S=!0;for(var C=h.length;C;){for(u=h,h=[];++y<C;)u&&u[y].run();y=-1,C=h.length}u=null,S=!1,function(D){if(A===clearTimeout)return clearTimeout(D);if((A===F||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(D);try{A(D)}catch(m){try{return A.call(null,D)}catch(o){return A.call(this,D)}}}(b)}}function c(b,C){this.fun=b,this.array=C}function f(){}I.nextTick=function(b){var C=new Array(arguments.length-1);if(arguments.length>1)for(var D=1;D<arguments.length;D++)C[D-1]=arguments[D];h.push(new c(b,C)),h.length!==1||S||R(O)},c.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=f,I.addListener=f,I.once=f,I.off=f,I.removeListener=f,I.removeAllListeners=f,I.emit=f,I.prependListener=f,I.prependOnceListener=f,I.listeners=function(b){return[]},I.binding=function(b){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(b){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(J[34],Y([0,1,12,2]),function(_,t,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function I(m){const o=m;return o?[o.on,o.pause,o.resume,o.destroy].every(r=>typeof r=="function"):!1}t.isReadableStream=I;function L(m){const o=m;return o?I(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}t.isReadableBufferedStream=L;function F(m,o){return new R(m,o)}t.newWriteableStream=F;class R{constructor(o,r){this.reducer=o,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){var r;if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof((r=this.options)===null||r===void 0?void 0:r.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(e=>this.pendingWritePromises.push(e))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(r=>r(o))}emitError(o){this.listeners.error.length===0?g.onUnexpectedError(o):this.listeners.error.slice(0).forEach(r=>r(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,r){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(o,r){if(this.state.destroyed)return;let e;switch(o){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(r);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function u(m,o){const r=[];let e;for(;(e=m.read())!==null;)r.push(e);return o(r)}t.consumeReadable=u;function h(m,o,r){const e=[];let i;for(;(i=m.read())!==null&&e.length<r;)e.push(i);return i===null&&e.length>0?o(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return m.read()}}}t.peekReadable=h;function S(m,o){return new Promise((r,e)=>{const i=[];y(m,{onData:n=>{o&&i.push(n)},onError:n=>{o?e(n):r(void 0)},onEnd:()=>{r(o?o(i):void 0)}})})}t.consumeStream=S;function y(m,o){m.on("error",r=>o.onError(r)),m.on("end",()=>o.onEnd()),m.on("data",r=>o.onData(r))}t.listenStream=y;function w(m,o){return new Promise((r,e)=>{const i=new A.DisposableStore,n=[],s=P=>{if(n.push(P),n.length>o)return i.dispose(),m.pause(),r({stream:m,buffer:n,ended:!1})},l=P=>e(P),E=()=>r({stream:m,buffer:n,ended:!0});i.add(A.toDisposable(()=>m.removeListener("error",l))),m.on("error",l),i.add(A.toDisposable(()=>m.removeListener("end",E))),m.on("end",E),i.add(A.toDisposable(()=>m.removeListener("data",s))),m.on("data",s)})}t.peekStream=w;function O(m,o){const r=F(o);return r.end(m),r}t.toStream=O;function c(){const m=F(()=>{throw new Error("not supported")});return m.end(),m}t.emptyStream=c;function f(m){let o=!1;return{read:()=>o?null:(o=!0,m)}}t.toReadable=f;function b(m,o,r){const e=F(r);return y(m,{onData:i=>e.write(o.data(i)),onError:i=>e.error(o.error?o.error(i):i),onEnd:()=>e.end()}),e}t.transform=b;function C(m,o,r){let e=!1;return{read:()=>{const i=o.read();return e?i:(e=!0,i!==null?r([m,i]):m)}}}t.prefixedReadable=C;function D(m,o,r){let e=!1;const i=F(r);return y(o,{onData:n=>e?i.write(n):(e=!0,i.write(r([m,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(m)),i.end()}}),i}t.prefixedStream=D}),define(J[16],Y([0,1,19,34]),function(_,t,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const I=typeof Buffer!="undefined",L=typeof TextEncoder!="undefined",F=typeof TextDecoder!="undefined";let R,u;class h{constructor(P){this.buffer=P,this.byteLength=this.buffer.byteLength}static alloc(P){return I?new h(Buffer.allocUnsafe(P)):new h(new Uint8Array(P))}static wrap(P){return I&&!Buffer.isBuffer(P)&&(P=Buffer.from(P.buffer,P.byteOffset,P.byteLength)),new h(P)}static fromString(P,U){return!((U==null?void 0:U.dontUseNodeBuffer)||!1)&&I?new h(Buffer.from(P)):L?(R||(R=new TextEncoder),new h(R.encode(P))):new h(g.encodeUTF8(P))}static concat(P,U){if(typeof U=="undefined"){U=0;for(let V=0,$=P.length;V<$;V++)U+=P[V].byteLength}const k=h.alloc(U);let j=0;for(let V=0,$=P.length;V<$;V++){const K=P[V];k.set(K,j),j+=K.byteLength}return k}toString(){return I?this.buffer.toString():F?(u||(u=new TextDecoder),u.decode(this.buffer)):g.decodeUTF8(this.buffer)}slice(P,U){return new h(this.buffer.subarray(P,U))}set(P,U){P instanceof h?this.buffer.set(P.buffer,U):this.buffer.set(P,U)}readUInt32BE(P){return w(this.buffer,P)}writeUInt32BE(P,U){O(this.buffer,P,U)}readUInt32LE(P){return c(this.buffer,P)}writeUInt32LE(P,U){f(this.buffer,P,U)}readUInt8(P){return b(this.buffer,P)}writeUInt8(P,U){C(this.buffer,P,U)}}t.VSBuffer=h;function S(E,P){return E[P+0]<<0>>>0|E[P+1]<<8>>>0}t.readUInt16LE=S;function y(E,P,U){E[U+0]=P&255,P=P>>>8,E[U+1]=P&255}t.writeUInt16LE=y;function w(E,P){return E[P]*2**24+E[P+1]*2**16+E[P+2]*2**8+E[P+3]}t.readUInt32BE=w;function O(E,P,U){E[U+3]=P,P=P>>>8,E[U+2]=P,P=P>>>8,E[U+1]=P,P=P>>>8,E[U]=P}t.writeUInt32BE=O;function c(E,P){return E[P+0]<<0>>>0|E[P+1]<<8>>>0|E[P+2]<<16>>>0|E[P+3]<<24>>>0}t.readUInt32LE=c;function f(E,P,U){E[U+0]=P&255,P=P>>>8,E[U+1]=P&255,P=P>>>8,E[U+2]=P&255,P=P>>>8,E[U+3]=P&255}t.writeUInt32LE=f;function b(E,P){return E[P]}t.readUInt8=b;function C(E,P,U){E[U]=P}t.writeUInt8=C;function D(E){return A.consumeReadable(E,P=>h.concat(P))}t.readableToBuffer=D;function m(E){return A.toReadable(E)}t.bufferToReadable=m;function o(E){return A.consumeStream(E,P=>h.concat(P))}t.streamToBuffer=o;async function r(E){return E.ended?h.concat(E.buffer):h.concat([...E.buffer,await o(E.stream)])}t.bufferedStreamToBuffer=r;function e(E){return A.toStream(E,P=>h.concat(P))}t.bufferToStream=e;function i(E){return A.transform(E,{data:P=>typeof P=="string"?h.fromString(P):h.wrap(P)},P=>h.concat(P))}t.streamToBufferReadableStream=i;function n(E){return A.newWriteableStream(P=>h.concat(P),E)}t.newWriteableBufferStream=n;function s(E,P){return A.prefixedReadable(E,P,U=>h.concat(U))}t.prefixedBufferReadable=s;function l(E,P){return A.prefixedStream(E,P,U=>h.concat(U))}t.prefixedBufferStream=l}),define(J[20],Y([0,1,13]),function(_,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function A(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const b=Array.isArray(f)?[]:{};return Object.keys(f).forEach(C=>{f[C]&&typeof f[C]=="object"?b[C]=A(f[C]):b[C]=f[C]}),b}t.deepClone=A;function I(f){if(!f||typeof f!="object")return f;const b=[f];for(;b.length>0;){const C=b.shift();Object.freeze(C);for(const D in C)if(L.call(C,D)){const m=C[D];typeof m=="object"&&!Object.isFrozen(m)&&b.push(m)}}return f}t.deepFreeze=I;const L=Object.prototype.hasOwnProperty;function F(f,b){return R(f,b,new Set)}t.cloneAndChange=F;function R(f,b,C){if(g.isUndefinedOrNull(f))return f;const D=b(f);if(typeof D!="undefined")return D;if(g.isArray(f)){const m=[];for(const o of f)m.push(R(o,b,C));return m}if(g.isObject(f)){if(C.has(f))throw new Error("Cannot clone recursive data-structure");C.add(f);const m={};for(let o in f)L.call(f,o)&&(m[o]=R(f[o],b,C));return C.delete(f),m}return f}function u(f,b,C=!0){return g.isObject(f)?(g.isObject(b)&&Object.keys(b).forEach(D=>{D in f?C&&(g.isObject(f[D])&&g.isObject(b[D])?u(f[D],b[D],C):f[D]=b[D]):f[D]=b[D]}),f):b}t.mixin=u;function h(f,b){if(f===b)return!0;if(f==null||b===null||b===void 0||typeof f!=typeof b||typeof f!="object"||Array.isArray(f)!==Array.isArray(b))return!1;let C,D;if(Array.isArray(f)){if(f.length!==b.length)return!1;for(C=0;C<f.length;C++)if(!h(f[C],b[C]))return!1}else{const m=[];for(D in f)m.push(D);m.sort();const o=[];for(D in b)o.push(D);if(o.sort(),!h(m,o))return!1;for(C=0;C<m.length;C++)if(!h(f[m[C]],b[m[C]]))return!1}return!0}t.equals=h;function S(f){const b=new Set;return JSON.stringify(f,(C,D)=>{if(g.isObject(D)||Array.isArray(D)){if(b.has(D))return"[Circular]";b.add(D)}return D})}t.safeStringify=S;function y(f,b,C){const D=b(f);return typeof D=="undefined"?C:D}t.getOrDefault=y;function w(f,b){const C=Object.create(null);return!f||!b||Object.keys(b).forEach(m=>{const o=f[m],r=b[m];h(o,r)||(C[m]=r)}),C}t.distinct=w;function O(f,b){const C=b.toLowerCase(),D=Object.keys(f).find(m=>m.toLowerCase()===C);return D?f[D]:f[b]}t.getCaseInsensitive=O;function c(f,b){const C=Object.create(null);for(const D of Object.keys(f))b(D,f[D])&&(C[D]=f[D]);return C}t.filter=c}),define(J[59],Y([0,1,7]),function(_,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function A(h){const S=h;return S&&typeof S.type=="string"&&typeof S.severity=="string"}t.isRemoteConsoleLog=A;function I(h){const S=[];let y;try{const w=JSON.parse(h.arguments),O=w[w.length-1];O&&O.__$stack&&(w.pop(),y=O.__$stack),S.push(...w)}catch(w){S.push("Unable to log remote console arguments",h.arguments)}return{args:S,stack:y}}t.parse=I;function L(h){if(typeof h!="string")return L(I(h).stack);const S=h;if(S){const y=F(S),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(w&&w.length===4)return{uri:g.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}t.getFirstFrame=L;function F(h){if(!h)return h;const S=h.indexOf(`
`);return S===-1?h:h.substring(0,S)}function R(h,S){const{args:y,stack:w}=I(h),O=typeof y[0]=="string"&&y.length===1;let c=F(w);c&&(c=`(${c.trim()})`);let f=[];if(typeof y[0]=="string"?c&&O?f=[`%c[${S}] %c${y[0]} %c${c}`,u("blue"),u(""),u("grey")]:f=[`%c[${S}] %c${y[0]}`,u("blue"),u(""),...y.slice(1)]:f=[`%c[${S}]%`,u("blue"),...y],c&&!O&&f.push(c),typeof console[h.severity]!="function")throw new Error("Unknown console method");console[h.severity].apply(console,f)}t.log=R;function u(h){return`color: ${h}`}}),define(J[60],Y([0,1,16,19,7]),function(_,t,g,A,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function L(S){return JSON.stringify(S,u)}t.stringify=L;function F(S){let y=JSON.parse(S);return y=h(y),y}t.parse=F;var R;(function(S){S[S.Uri=1]="Uri",S[S.Regexp=2]="Regexp",S[S.ScmResource=3]="ScmResource",S[S.ScmResourceGroup=4]="ScmResourceGroup",S[S.ScmProvider=5]="ScmProvider",S[S.CommentController=6]="CommentController",S[S.CommentThread=7]="CommentThread",S[S.CommentThreadReply=8]="CommentThreadReply",S[S.CommentNode=9]="CommentNode",S[S.CommentThreadNode=10]="CommentThreadNode",S[S.TimelineActionContext=11]="TimelineActionContext",S[S.NotebookCellActionContext=12]="NotebookCellActionContext",S[S.TestItemContext=13]="TestItemContext"})(R=t.MarshalledId||(t.MarshalledId={}));function u(S,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:A.regExpFlags(y)}:y}function h(S,y=0){if(!S||y>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return I.URI.revive(S);case 2:return new RegExp(S.source,S.flags)}if(S instanceof g.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let w=0;w<S.length;++w)S[w]=h(S[w],y+1);else for(const w in S)Object.hasOwnProperty.call(S,w)&&(S[w]=h(S[w],y+1))}return S}t.revive=h}),define(J[61],Y([0,1,19,35,3,45,4]),function(_,t,g,A,I,L,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function R(){return Object.create(null)}t.getEmptyExpression=R;const u="**",h="/",S="[/\\\\]",y="[^/\\\\]",w=/\//g;function O(a){switch(a){case 0:return"";case 1:return`${y}*?`;default:return`(?:${S}|${y}+${S}|${S}${y}+)*?`}}function c(a,v){if(!a)return[];const p=[];let N=!1,M=!1,x="";for(const B of a){switch(B){case v:if(!N&&!M){p.push(x),x="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":M=!0;break;case"]":M=!1;break}x+=B}return x&&p.push(x),p}t.splitGlobAware=c;function f(a){if(!a)return"";let v="";const p=c(a,h);if(p.every(N=>N===u))v=".*";else{let N=!1;p.forEach((M,x)=>{if(M===u){N||(v+=O(2),N=!0);return}let B=!1,W="",H=!1,X="";for(const Z of M){if(Z!=="}"&&B){W+=Z;continue}if(H&&(Z!=="]"||!X)){let ie;Z==="-"?ie=Z:(Z==="^"||Z==="!")&&!X?ie="^":Z===h?ie="":ie=g.escapeRegExpCharacters(Z),X+=ie;continue}switch(Z){case"{":B=!0;continue;case"[":H=!0;continue;case"}":v+=`(?:${c(W,",").map(ge=>f(ge)).join("|")})`,B=!1,W="";break;case"]":v+="["+X+"]",H=!1,X="";break;case"?":v+=y;continue;case"*":v+=O(1);continue;default:v+=g.escapeRegExpCharacters(Z)}}x<p.length-1&&(p[x+1]!==u||x+2<p.length)&&(v+=S),N=!1})}return v}const b=/^\*\*\/\*\.[\w\.-]+$/,C=/^\*\*\/([\w\.-]+)\/?$/,D=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,m=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new L.LRUCache(1e4),i=function(){return!1},n=function(){return null};function s(a,v){if(!a)return n;let p;typeof a!="string"?p=a.pattern:p=a,p=p.trim();const N=`${p}_${!!v.trimForExclusions}`;let M=e.get(N);if(M)return l(M,a);let x;if(b.test(p)){const B=p.substr(4);M=function(W,H){return typeof W=="string"&&W.endsWith(B)?p:null}}else(x=C.exec(E(p,v)))?M=P(x[1],p):(v.trimForExclusions?m:D).test(p)?M=U(p,v):(x=o.exec(E(p,v)))?M=k(x[1].substr(1),p,!0):(x=r.exec(E(p,v)))?M=k(x[1],p,!1):M=j(p);return e.set(N,M),l(M,a)}function l(a,v){return typeof v=="string"?a:function(p,N){return A.isEqualOrParent(p,v.base)?a(I.relative(v.base,p),N):null}}function E(a,v){return v.trimForExclusions&&a.endsWith("/**")?a.substr(0,a.length-2):a}function P(a,v){const p=`/${a}`,N=`\\${a}`,M=function(B,W){return typeof B!="string"?null:W?W===a?v:null:B===a||B.endsWith(p)||B.endsWith(N)?v:null},x=[a];return M.basenames=x,M.patterns=[v],M.allBasenames=x,M}function U(a,v){const p=d(a.slice(1,-1).split(",").map(W=>s(W,v)).filter(W=>W!==n),a),N=p.length;if(!N)return n;if(N===1)return p[0];const M=function(W,H){for(let X=0,Z=p.length;X<Z;X++)if(p[X](W,H))return a;return null},x=p.find(W=>!!W.allBasenames);x&&(M.allBasenames=x.allBasenames);const B=p.reduce((W,H)=>H.allPaths?W.concat(H.allPaths):W,[]);return B.length&&(M.allPaths=B),M}function k(a,v,p){const N=I.sep===I.posix.sep,M=N?a:a.replace(w,I.sep),x=I.sep+M,B=I.posix.sep+a,W=p?function(H,X){return typeof H=="string"&&(H===M||H.endsWith(x)||!N&&(H===a||H.endsWith(B)))?v:null}:function(H,X){return typeof H=="string"&&(H===M||!N&&H===a)?v:null};return W.allPaths=[(p?"*/":"./")+a],W}function j(a){try{const v=new RegExp(`^${f(a)}$`);return function(p){return v.lastIndex=0,typeof p=="string"&&v.test(p)?a:null}}catch(v){return n}}function V(a,v,p){return!a||typeof v!="string"?!1:$(a)(v,void 0,p)}t.match=V;function $(a,v={}){if(!a)return i;if(typeof a=="string"||Q(a)){const p=s(a,v);if(p===n)return i;const N=function(M,x){return!!p(M,x)};return p.allBasenames&&(N.allBasenames=p.allBasenames),p.allPaths&&(N.allPaths=p.allPaths),N}return re(a,v)}t.parse=$;function K(a){if(!a)return;let v;return p=>(v||(v=(a()||Promise.resolve([])).then(N=>N?te(N):{})),v.then(N=>!!N[p]))}t.hasSiblingPromiseFn=K;function ee(a){if(!a)return;let v;return p=>{if(!v){const N=a();v=N?te(N):{}}return!!v[p]}}t.hasSiblingFn=ee;function te(a){const v={};for(const p of a)v[p]=!0;return v}function Q(a){const v=a;return v&&typeof v.base=="string"&&typeof v.pattern=="string"}t.isRelativePattern=Q;function ae(a){return a.allBasenames||[]}t.getBasenameTerms=ae;function se(a){return a.allPaths||[]}t.getPathTerms=se;function re(a,v){const p=d(Object.getOwnPropertyNames(a).map(W=>T(W,a[W],v)).filter(W=>W!==n)),N=p.length;if(!N)return n;if(!p.some(W=>!!W.requiresSiblings)){if(N===1)return p[0];const W=function(Z,ie){for(let ce=0,ge=p.length;ce<ge;ce++){const Pe=p[ce](Z,ie);if(Pe)return Pe}return null},H=p.find(Z=>!!Z.allBasenames);H&&(W.allBasenames=H.allBasenames);const X=p.reduce((Z,ie)=>ie.allPaths?Z.concat(ie.allPaths):Z,[]);return X.length&&(W.allPaths=X),W}const M=function(W,H,X){let Z;for(let ie=0,ce=p.length;ie<ce;ie++){const ge=p[ie];ge.requiresSiblings&&X&&(H||(H=I.basename(W)),Z||(Z=H.substr(0,H.length-I.extname(W).length)));const Pe=ge(W,H,Z,X);if(Pe)return Pe}return null},x=p.find(W=>!!W.allBasenames);x&&(M.allBasenames=x.allBasenames);const B=p.reduce((W,H)=>H.allPaths?W.concat(H.allPaths):W,[]);return B.length&&(M.allPaths=B),M}function T(a,v,p){if(v===!1)return n;const N=s(a,p);if(N===n)return n;if(typeof v=="boolean")return N;if(v){const M=v.when;if(typeof M=="string"){const x=(B,W,H,X)=>{if(!X||!N(B,W))return null;const Z=M.replace("$(basename)",H),ie=X(Z);return F.isThenable(ie)?ie.then(ce=>ce?a:null):ie?a:null};return x.requiresSiblings=!0,x}}return N}function d(a,v){const p=a.filter(W=>!!W.basenames);if(p.length<2)return a;const N=p.reduce((W,H)=>{const X=H.basenames;return X?W.concat(X):W},[]);let M;if(v){M=[];for(let W=0,H=N.length;W<H;W++)M.push(v)}else M=p.reduce((W,H)=>{const X=H.patterns;return X?W.concat(X):W},[]);const x=function(W,H){if(typeof W!="string")return null;if(!H){let Z;for(Z=W.length;Z>0;Z--){const ie=W.charCodeAt(Z-1);if(ie===47||ie===92)break}H=W.substr(Z)}const X=N.indexOf(H);return X!==-1?M[X]:null};x.basenames=N,x.patterns=M,x.allBasenames=N;const B=a.filter(W=>!W.basenames);return B.push(x),B}}),define(J[62],Y([0,1,7,3,19,8,14,17,35]),function(_,t,g,A,I,L,F,R,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function h(s,l,E){if(typeof s=="string"&&(s=g.URI.file(s)),E){const U=E.getWorkspaceFolder(s);if(U){const k=E.getWorkspace().folders.length>1;let j;if(R.isEqual(U.uri,s)?j="":j=R.relativePath(U.uri,s),k){const V=U.name?U.name:R.basename(U.uri);j=j?V+" \u2022 "+j:V}return j}}if(s.scheme!==L.Schemas.file&&s.scheme!==L.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if(u.hasDriveLetter(s.fsPath))return A.normalize(y(s.fsPath));let P=A.normalize(s.fsPath);return!F.isWindows&&(l==null?void 0:l.userHome)&&(P=O(P,l.userHome.fsPath)),P}t.getPathLabel=h;function S(s){if(!s)return;typeof s=="string"&&(s=g.URI.file(s));const l=R.basename(s)||(s.scheme===L.Schemas.file?s.fsPath:s.path);return F.isWindows&&u.isRootOrDriveLetter(l)?y(l):l}t.getBaseLabel=S;function y(s){return u.hasDriveLetter(s)?s.charAt(0).toUpperCase()+s.slice(1):s}t.normalizeDriveLetter=y;let w=Object.create(null);function O(s,l){if(F.isWindows||!s||!l)return s;let E=w.original===l?w.normalized:void 0;return E||(E=`${I.rtrim(l,A.posix.sep)}${A.posix.sep}`,w={original:l,normalized:E}),(F.isLinux?s.startsWith(E):I.startsWithIgnoreCase(s,E))&&(s=`~/${s.substr(E.length)}`),s}t.tildify=O;function c(s,l){return s.replace(/^~($|\/|\\)/,`${l}$1`)}t.untildify=c;const f="\u2026",b="\\\\",C="~";function D(s,l=A.sep){const E=new Array(s.length);let P=!1;for(let U=0;U<s.length;U++){let k=s[U];if(k===""){E[U]=`.${l}`;continue}if(!k){E[U]=k;continue}P=!0;let j="";k.indexOf(b)===0?(j=k.substr(0,k.indexOf(b)+b.length),k=k.substr(k.indexOf(b)+b.length)):k.indexOf(l)===0?(j=k.substr(0,k.indexOf(l)+l.length),k=k.substr(k.indexOf(l)+l.length)):k.indexOf(C)===0&&(j=k.substr(0,k.indexOf(C)+C.length),k=k.substr(k.indexOf(C)+C.length));const V=k.split(l);for(let $=1;P&&$<=V.length;$++)for(let K=V.length-$;P&&K>=0;K--){P=!1;let ee=V.slice(K,K+$).join(l);for(let te=0;!P&&te<s.length;te++)if(te!==U&&s[te]&&s[te].indexOf(ee)>-1){const Q=K+$===V.length,ae=K>0&&s[te].indexOf(l)>-1?l+ee:ee,se=s[te].endsWith(ae);P=!Q||se}if(!P){let te="";(V[0].endsWith(":")||j!=="")&&(K===1&&(K=0,$++,ee=V[0]+l+ee),K>0&&(te=V[0]+l),te=j+te),K>0&&(te=te+f+l),te=te+ee,K+$<V.length&&(te=te+l+f),E[U]=te}}P&&(E[U]=k)}return E}t.shorten=D;var m;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function o(s,l=Object.create(null)){const E=[];let P=!1,U="";for(const k of s)if(k==="$"||P&&k==="{")U&&E.push({value:U,type:m.TEXT}),U="",P=!0;else if(k==="}"&&P){const j=l[U];if(typeof j=="string")j.length&&E.push({value:j,type:m.VARIABLE});else if(j){const V=E[E.length-1];(!V||V.type!==m.SEPARATOR)&&E.push({value:j.label,type:m.SEPARATOR})}U="",P=!1}else U+=k;return U&&!P&&E.push({value:U,type:m.TEXT}),E.filter((k,j)=>{if(k.type===m.SEPARATOR){const V=E[j-1],$=E[j+1];return[V,$].every(K=>K&&(K.type===m.VARIABLE||K.type===m.TEXT)&&K.value.length>0)}return!0}).map(k=>k.value).join("")}t.template=o;function r(s,l){return F.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.isMacintosh?"&":"&&"):s.replace(/&&|&/g,E=>E==="&"?"&&":"&")}t.mnemonicMenuLabel=r;function e(s,l){return F.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,""):F.isWindows?s.replace(/&&|&/g,E=>E==="&"?"&&":"&"):s.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(s){return s.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(s){const l=s.indexOf("/")!==-1?A.posix:A.win32,E=l.basename(s),P=l.dirname(s);return E.length?{name:E,parentPath:P}:{name:P,parentPath:""}}t.splitName=n}),define(J[46],Y([0,1,124]),function(_,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class A{constructor(L="utf8"){this.stringDecoder=new g.StringDecoder(L),this.remaining=null}write(L){const F=[],R=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(R.length<1)return F;let u=0,h,S=u;for(;S<R.length;)if(h=R.charCodeAt(S),h===13||h===10){if(F.push(R.substring(u,S)),S++,S<R.length){const y=h;h=R.charCodeAt(S),(y===13&&h===10||y===10&&h===13)&&S++}u=S}else S++;return this.remaining=u<R.length?R.substr(u):null,F}end(){return this.remaining}}t.LineDecoder=A}),define(J[63],Y([0,1,36,19,3,9]),function(_,t,g,A,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function F(S){const y=I.dirname(S);if(S===y)return S;const w=(I.basename(S)||S).toLowerCase();try{const c=L.readdirSync(y).filter(f=>f.toLowerCase()===w);if(c.length===1){const f=F(y);if(f)return I.join(f,c[0])}else if(c.length>1){const f=c.indexOf(w);if(f>=0){const b=F(y);if(b)return I.join(b,c[f])}}}catch(O){}return null}t.realcaseSync=F;async function R(S){try{return await L.Promises.realpath(S)}catch(y){const w=h(S);return await L.Promises.access(w,g.constants.R_OK),w}}t.realpath=R;function u(S){try{return g.realpathSync(S)}catch(y){const w=h(S);return g.accessSync(w,g.constants.R_OK),w}}t.realpathSync=u;function h(S){return A.rtrim(I.normalize(S),I.sep)}});var ye=this&&this.__await||function(_){return this instanceof ye?(this.v=_,this):new ye(_)},Be=this&&this.__asyncGenerator||function(_,t,g){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var A=g.apply(_,t||[]),I,L=[];return I={},F("next"),F("throw"),F("return"),I[Symbol.asyncIterator]=function(){return this},I;function F(w){A[w]&&(I[w]=function(O){return new Promise(function(c,f){L.push([w,O,c,f])>1||R(w,O)})})}function R(w,O){try{u(A[w](O))}catch(c){y(L[0][3],c)}}function u(w){w.value instanceof ye?Promise.resolve(w.value.v).then(h,S):y(L[0][2],w)}function h(w){R("next",w)}function S(w){R("throw",w)}function y(w,O){w(O),L.shift(),L.length&&R(L[0][0],L[0][1])}},xe=this&&this.__asyncValues||function(_){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var t=_[Symbol.asyncIterator],g;return t?t.call(_):(_=typeof __values=="function"?__values(_):_[Symbol.iterator](),g={},A("next"),A("throw"),A("return"),g[Symbol.asyncIterator]=function(){return this},g);function A(L){g[L]=_[L]&&function(F){return new Promise(function(R,u){F=_[L](F),I(R,u,F.done,F.value)})}}function I(L,F,R,u){Promise.resolve(u).then(function(h){L({value:h,done:R})},F)}};define(J[64],Y([0,1,9,31,3]),function(_,t,g,A,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,F=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var u;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(u||(u={}));let h;switch(process.arch){case"ia32":case"x32":h=1;break;case"arm":case"arm64":h=2;break;default:h=0;break}let S;process.env.PROCESSOR_ARCHITEW6432?S=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?S=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?S=1:S=0;class y{constructor(r,e,i){this.exePath=r,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await g.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function w({useAlternateBitness:o=!1}={}){return o?h===0?process.env["ProgramFiles(x86)"]||null:S===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function O({useAlternateBitness:o=!1,findPreview:r=!1}={}){const e=w({useAlternateBitness:o});if(!e)return null;const i=I.join(e,"PowerShell");if(!await g.SymlinkSupport.existsDirectory(i))return null;let n=-1,s=null;for(const P of await g.Promises.readdir(i)){let U=-1;if(r){const j=P.indexOf("-");if(j<0)continue;const V=P.substring(0,j);if(!L.test(V)||P.substring(j+1)!=="preview")continue;U=parseInt(V,10)}else{if(!L.test(P))continue;U=parseInt(P,10)}if(U<=n)continue;const k=I.join(i,P,"pwsh.exe");!await g.SymlinkSupport.existsFile(k)||(s=k,n=U)}if(!s)return null;const l=e.includes("x86")?" (x86)":"",E=r?" Preview":"";return new y(s,`PowerShell${E}${l}`,!0)}async function c({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const r=I.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await g.SymlinkSupport.existsDirectory(r))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=o?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:F,pwshMsixName:"PowerShell (Store)"};for(const n of await g.Promises.readdir(r))if(e.test(n)){const s=I.join(r,n,"pwsh.exe");return new y(s,i)}return null}function f(){const o=I.join(A.homedir(),".dotnet","tools","pwsh.exe");return new y(o,".NET Core PowerShell Global Tool")}function b(){const o=I.join(process.env.windir,h===1&&S!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(o,"Windows PowerShell",!0)}function C(){return Be(this,arguments,function*(){let r=yield ye(O());r&&(yield yield ye(r)),r=yield ye(O({useAlternateBitness:!0})),r&&(yield yield ye(r)),r=yield ye(c()),r&&(yield yield ye(r)),r=f(),r&&(yield yield ye(r)),r=yield ye(O({findPreview:!0})),r&&(yield yield ye(r)),r=yield ye(c({findPreview:!0})),r&&(yield yield ye(r)),r=yield ye(O({useAlternateBitness:!0,findPreview:!0})),r&&(yield yield ye(r)),r=b(),r&&(yield yield ye(r))})}function D(){return Be(this,arguments,function*(){var r,e;try{for(var i=xe(C()),n;n=yield ye(i.next()),!n.done;){const s=n.value;(yield ye(s.exists()))&&(yield yield ye(s))}}catch(s){r={error:s}}finally{try{n&&!n.done&&(e=i.return)&&(yield ye(e.call(i)))}finally{if(r)throw r.error}}})}t.enumeratePowerShellInstallations=D;async function m(){var o,r;try{for(var e=xe(D()),i;i=await e.next(),!i.done;)return i.value}catch(n){o={error:n}}finally{try{i&&!i.done&&(r=e.return)&&await r.call(e)}finally{if(o)throw o.error}}return null}t.getFirstAvailablePowerShellInstallation=m}),define(J[65],Y([0,1,3,36,14,125,2,9]),function(_,t,g,A,I,L,F,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function u(y,w,O){return S({path:y,isDirectory:!1},w,O)}t.watchFile=u;function h(y,w,O){return S({path:y,isDirectory:!0},w,O)}t.watchFolder=h,t.CHANGE_BUFFER_DELAY=100;function S(y,w,O){const c=g.basename(y.path),f=new Map;let b=!1,C=[F.toDisposable(()=>{f.forEach(D=>F.dispose(D)),f.clear()})];try{const D=A.watch(y.path);C.push(F.toDisposable(()=>{D.removeAllListeners(),D.close()}));const m=new Set;y.isDirectory&&R.Promises.readdir(y.path).then(o=>o.forEach(r=>m.add(r))),D.on("error",(o,r)=>{b||O(`Failed to watch ${y.path} for changes using fs.watch() (${o}, ${r})`)}),D.on("change",(o,r)=>{if(b)return;let e="";if(r&&(e=r.toString(),I.isMacintosh&&(e=L.normalizeNFC(e))),!e||o!=="change"&&o!=="rename")return;const i=y.isDirectory?g.join(y.path,e):y.path;if(y.isDirectory)if(o==="rename"){const n=f.get(i);n&&F.dispose(n);const s=setTimeout(async()=>{f.delete(i);const l=await R.Promises.exists(i);if(b)return;let E;l?m.has(e)?E="changed":(E="added",m.add(e)):(m.delete(e),E="deleted"),w(E,i)},t.CHANGE_BUFFER_DELAY);f.set(i,F.toDisposable(()=>clearTimeout(s)))}else{let n;m.has(e)?n="changed":(n="added",m.add(e)),w(n,i)}else if(o==="rename"||e!==c){const n=setTimeout(async()=>{const s=await R.Promises.exists(i);b||(s?(w("changed",i),C=[S(y,w,O)]):w("deleted",i))},t.CHANGE_BUFFER_DELAY);F.dispose(C),C=[F.toDisposable(()=>clearTimeout(n))]}else w("changed",i)})}catch(D){R.Promises.exists(y.path).then(m=>{m&&!b&&O(`Failed to watch ${y.path} for changes using fs.watch() (${D.toString()})`)})}return F.toDisposable(()=>{b=!0,C=F.dispose(C)})}});var ue=this&&this.__decorate||function(_,t,g,A){var I=arguments.length,L=I<3?t:A===null?A=Object.getOwnPropertyDescriptor(t,g):A,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(_,t,g,A);else for(var R=_.length-1;R>=0;R--)(F=_[R])&&(L=(I<3?F(L):I>3?F(t,g,L):F(t,g))||L);return I>3&&L&&Object.defineProperty(t,g,L),L};define(J[37],Y([0,1,10,2,4,26,12,16,22,13,60,19,44]),function(_,t,g,A,I,L,F,R,u,h,S,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var O;(function(d){d[d.Promise=100]="Promise",d[d.PromiseCancel=101]="PromiseCancel",d[d.EventListen=102]="EventListen",d[d.EventDispose=103]="EventDispose"})(O=t.RequestType||(t.RequestType={}));function c(d){switch(d){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(d){d[d.Initialize=200]="Initialize",d[d.PromiseSuccess=201]="PromiseSuccess",d[d.PromiseError=202]="PromiseError",d[d.PromiseErrorObj=203]="PromiseErrorObj",d[d.EventFire=204]="EventFire"})(f=t.ResponseType||(t.ResponseType={}));function b(d){switch(d){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var C;(function(d){d[d.Uninitialized=0]="Uninitialized",d[d.Idle=1]="Idle"})(C||(C={}));class D{constructor(a){this.buffer=a,this.pos=0}read(a){const v=this.buffer.slice(this.pos,this.pos+a);return this.pos+=v.byteLength,v}}class m{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(a){this.buffers.push(a)}}var o;(function(d){d[d.Undefined=0]="Undefined",d[d.String=1]="String",d[d.Buffer=2]="Buffer",d[d.VSBuffer=3]="VSBuffer",d[d.Array=4]="Array",d[d.Object=5]="Object"})(o||(o={}));function r(d){const a=R.VSBuffer.alloc(4);return a.writeUInt32BE(d,0),a}function e(d){return d.read(4).readUInt32BE(0)}function i(d){const a=R.VSBuffer.alloc(1);return a.writeUInt8(d,0),a}const n={Undefined:i(o.Undefined),String:i(o.String),Buffer:i(o.Buffer),VSBuffer:i(o.VSBuffer),Array:i(o.Array),Object:i(o.Object)},s=typeof Buffer!="undefined";function l(d,a){if(typeof a=="undefined")d.write(n.Undefined);else if(typeof a=="string"){const v=R.VSBuffer.fromString(a);d.write(n.String),d.write(r(v.byteLength)),d.write(v)}else if(s&&Buffer.isBuffer(a)){const v=R.VSBuffer.wrap(a);d.write(n.Buffer),d.write(r(v.byteLength)),d.write(v)}else if(a instanceof R.VSBuffer)d.write(n.VSBuffer),d.write(r(a.byteLength)),d.write(a);else if(Array.isArray(a)){d.write(n.Array),d.write(r(a.length));for(const v of a)l(d,v)}else{const v=R.VSBuffer.fromString(JSON.stringify(a));d.write(n.Object),d.write(r(v.byteLength)),d.write(v)}}function E(d){switch(d.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return d.read(e(d)).toString();case o.Buffer:return d.read(e(d)).buffer;case o.VSBuffer:return d.read(e(d));case o.Array:{const v=e(d),p=[];for(let N=0;N<v;N++)p.push(E(d));return p}case o.Object:return JSON.parse(d.read(e(d)).toString())}}class P{constructor(a,v,p=null,N=1e3){this.protocol=a,this.ctx=v,this.logger=p,this.timeoutDelay=N,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(M=>this.onRawMessage(M)),this.sendResponse({type:200})}registerChannel(a,v){this.channels.set(a,v),setTimeout(()=>this.flushPendingRequests(a),0)}sendResponse(a){switch(a.type){case 200:{const v=this.send([a.type]);this.logger&&this.logger.logOutgoing(v,0,1,b(a.type));return}case 201:case 202:case 204:case 203:{const v=this.send([a.type,a.id],a.data);this.logger&&this.logger.logOutgoing(v,a.id,1,b(a.type),a.data);return}}}send(a,v=void 0){const p=new m;return l(p,a),l(p,v),this.sendBuffer(p.buffer)}sendBuffer(a){try{return this.protocol.send(a),a.byteLength}catch(v){return 0}}onRawMessage(a){const v=new D(a),p=E(v),N=E(v),M=p[0];switch(M){case 100:return this.logger&&this.logger.logIncoming(a.byteLength,p[1],1,`${c(M)}: ${p[2]}.${p[3]}`,N),this.onPromise({type:M,id:p[1],channelName:p[2],name:p[3],arg:N});case 102:return this.logger&&this.logger.logIncoming(a.byteLength,p[1],1,`${c(M)}: ${p[2]}.${p[3]}`,N),this.onEventListen({type:M,id:p[1],channelName:p[2],name:p[3],arg:N});case 101:return this.logger&&this.logger.logIncoming(a.byteLength,p[1],1,`${c(M)}`),this.disposeActiveRequest({type:M,id:p[1]});case 103:return this.logger&&this.logger.logIncoming(a.byteLength,p[1],1,`${c(M)}`),this.disposeActiveRequest({type:M,id:p[1]})}}onPromise(a){const v=this.channels.get(a.channelName);if(!v){this.collectPendingRequest(a);return}const p=new L.CancellationTokenSource;let N;try{N=v.call(this.ctx,a.name,a.arg,p.token)}catch(B){N=Promise.reject(B)}const M=a.id;N.then(B=>{this.sendResponse({id:M,data:B,type:201}),this.activeRequests.delete(a.id)},B=>{B instanceof Error?this.sendResponse({id:M,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.sendResponse({id:M,data:B,type:203}),this.activeRequests.delete(a.id)});const x=A.toDisposable(()=>p.cancel());this.activeRequests.set(a.id,x)}onEventListen(a){const v=this.channels.get(a.channelName);if(!v){this.collectPendingRequest(a);return}const p=a.id,M=v.listen(this.ctx,a.name,a.arg)(x=>this.sendResponse({id:p,data:x,type:204}));this.activeRequests.set(a.id,M)}disposeActiveRequest(a){const v=this.activeRequests.get(a.id);v&&(v.dispose(),this.activeRequests.delete(a.id))}collectPendingRequest(a){let v=this.pendingRequests.get(a.channelName);v||(v=[],this.pendingRequests.set(a.channelName,v));const p=setTimeout(()=>{console.error(`Unknown channel: ${a.channelName}`),a.type===100&&this.sendResponse({id:a.id,data:{name:"Unknown channel",message:`Channel name '${a.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);v.push({request:a,timeoutTimer:p})}flushPendingRequests(a){const v=this.pendingRequests.get(a);if(v){for(const p of v)switch(clearTimeout(p.timeoutTimer),p.request.type){case 100:this.onPromise(p.request);break;case 102:this.onEventListen(p.request);break}this.pendingRequests.delete(a)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(a=>a.dispose()),this.activeRequests.clear()}}t.ChannelServer=P;var U;(function(d){d[d.LocalSide=0]="LocalSide",d[d.OtherSide=1]="OtherSide"})(U=t.RequestInitiator||(t.RequestInitiator={}));class k{constructor(a,v=null){this.protocol=a,this.isDisposed=!1,this.state=C.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new g.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(p=>this.onBuffer(p)),this.logger=v}getChannel(a){const v=this;return{call(p,N,M){return v.isDisposed?Promise.reject(F.canceled()):v.requestPromise(a,p,N,M)},listen(p,N){return v.isDisposed?Promise.reject(F.canceled()):v.requestEvent(a,p,N)}}}requestPromise(a,v,p,N=L.CancellationToken.None){const M=this.lastRequestId++,B={id:M,type:100,channelName:a,name:v,arg:p};if(N.isCancellationRequested)return Promise.reject(F.canceled());let W;return new Promise((X,Z)=>{if(N.isCancellationRequested)return Z(F.canceled());const ie=()=>{const Fe=Re=>{switch(Re.type){case 201:this.handlers.delete(M),X(Re.data);break;case 202:this.handlers.delete(M);const Se=new Error(Re.data.message);Se.stack=Re.data.stack,Se.name=Re.data.name,Z(Se);break;case 203:this.handlers.delete(M),Z(Re.data);break}};this.handlers.set(M,Fe),this.sendRequest(B)};let ce=null;this.state===C.Idle?ie():(ce=I.createCancelablePromise(Fe=>this.whenInitialized()),ce.then(()=>{ce=null,ie()}));const ge=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:M,type:101}),Z(F.canceled())},Pe=N.onCancellationRequested(ge);W=A.combinedDisposable(A.toDisposable(ge),Pe),this.activeRequests.add(W)}).finally(()=>{this.activeRequests.delete(W)})}requestEvent(a,v,p){const N=this.lastRequestId++,x={id:N,type:102,channelName:a,name:v,arg:p};let B=null;const W=new g.Emitter({onFirstListenerAdd:()=>{B=I.createCancelablePromise(X=>this.whenInitialized()),B.then(()=>{B=null,this.activeRequests.add(W),this.sendRequest(x)})},onLastListenerRemove:()=>{B?(B.cancel(),B=null):(this.activeRequests.delete(W),this.sendRequest({id:N,type:103}))}}),H=X=>W.fire(X.data);return this.handlers.set(N,H),W.event}sendRequest(a){switch(a.type){case 100:case 102:{const v=this.send([a.type,a.id,a.channelName,a.name],a.arg);this.logger&&this.logger.logOutgoing(v,a.id,0,`${c(a.type)}: ${a.channelName}.${a.name}`,a.arg);return}case 101:case 103:{const v=this.send([a.type,a.id]);this.logger&&this.logger.logOutgoing(v,a.id,0,c(a.type));return}}}send(a,v=void 0){const p=new m;return l(p,a),l(p,v),this.sendBuffer(p.buffer)}sendBuffer(a){try{return this.protocol.send(a),a.byteLength}catch(v){return 0}}onBuffer(a){const v=new D(a),p=E(v),N=E(v),M=p[0];switch(M){case 200:return this.logger&&this.logger.logIncoming(a.byteLength,0,0,b(M)),this.onResponse({type:p[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(a.byteLength,p[1],0,b(M),N),this.onResponse({type:p[0],id:p[1],data:N})}}onResponse(a){if(a.type===200){this.state=C.Idle,this._onDidInitialize.fire();return}const v=this.handlers.get(a.id);v&&v(a)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===C.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(a=>a.dispose()),this.activeRequests.clear()}}ue([w.memoize],k.prototype,"onDidInitializePromise",null),t.ChannelClient=k;class j{constructor(a){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new g.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new g.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,a(({protocol:v,onDidClientDisconnect:p})=>{g.Event.once(v.onMessage)(M=>{const x=new D(M),B=E(x),W=new P(v,B),H=new k(v);this.channels.forEach((Z,ie)=>W.registerChannel(ie,Z));const X={channelServer:W,channelClient:H,ctx:B};this._connections.add(X),this._onDidAddConnection.fire(X),p(()=>{W.dispose(),H.dispose(),this._connections.delete(X),this._onDidRemoveConnection.fire(X)})})})}get connections(){const a=[];return this._connections.forEach(v=>a.push(v)),a}getChannel(a,v){const p=this;return{call(N,M,x){let B;if(h.isFunction(v)){let H=u.getRandomElement(p.connections.filter(v));B=H?Promise.resolve(H):g.Event.toPromise(g.Event.filter(p.onDidAddConnection,v))}else B=v.routeCall(p,N,M);const W=B.then(H=>H.channelClient.getChannel(a));return $(W).call(N,M,x)},listen(N,M){if(h.isFunction(v))return p.getMulticastEvent(a,v,N,M);const x=v.routeEvent(p,N,M).then(B=>B.channelClient.getChannel(a));return $(x).listen(N,M)}}}getMulticastEvent(a,v,p,N){const M=this;let x=new A.DisposableStore;const B=new g.Emitter({onFirstListenerAdd:()=>{x=new A.DisposableStore;const W=new g.EventMultiplexer,H=new Map,X=ie=>{const ge=ie.channelClient.getChannel(a).listen(p,N),Pe=W.add(ge);H.set(ie,Pe)},Z=ie=>{const ce=H.get(ie);!ce||(ce.dispose(),H.delete(ie))};M.connections.filter(v).forEach(X),g.Event.filter(M.onDidAddConnection,v)(X,void 0,x),M.onDidRemoveConnection(Z,void 0,x),W.event(B.fire,B,x),x.add(W)},onLastListenerRemove:()=>{x.dispose()}});return B.event}registerChannel(a,v){this.channels.set(a,v),this._connections.forEach(p=>{p.channelServer.registerChannel(a,v)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=j;class V{constructor(a,v,p=null){const N=new m;l(N,v),a.send(N.buffer),this.channelClient=new k(a,p),this.channelServer=new P(a,v,p)}getChannel(a){return this.channelClient.getChannel(a)}registerChannel(a,v){this.channelServer.registerChannel(a,v)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=V;function $(d){return{call(a,v,p){return d.then(N=>N.call(a,v,p))},listen(a,v){const p=new g.Relay;return d.then(N=>p.input=N.listen(a,v)),p.event}}}t.getDelayedChannel=$;function K(d){let a=!1;return{call(v,p,N){return a?d.call(v,p,N):I.timeout(0).then(()=>a=!0).then(()=>d.call(v,p,N))},listen(v,p){if(a)return d.listen(v,p);const N=new g.Relay;return I.timeout(0).then(()=>a=!0).then(()=>N.input=d.listen(v,p)),N.event}}}t.getNextTickChannel=K;class ee{constructor(a){this.fn=a}routeCall(a){return this.route(a)}routeEvent(a){return this.route(a)}async route(a){for(const v of a.connections)if(await Promise.resolve(this.fn(v.ctx)))return Promise.resolve(v);return await g.Event.toPromise(a.onDidAddConnection),await this.route(a)}}t.StaticRouter=ee;var te;(function(d){function a(N,M){const x=N,B=M&&M.disableMarshalling,W=new Map;for(const H in x)p(H)&&W.set(H,g.Event.buffer(x[H],!0));return new class{listen(H,X){const Z=W.get(X);if(Z)return Z;throw new Error(`Event not found: ${X}`)}call(H,X,Z){const ie=x[X];if(typeof ie=="function"){if(!B&&Array.isArray(Z))for(let ce=0;ce<Z.length;ce++)Z[ce]=S.revive(Z[ce]);return ie.apply(x,Z)}throw new Error(`Method not found: ${X}`)}}}d.fromService=a;function v(N,M){const x=M&&M.disableMarshalling;return new Proxy({},{get(B,W){var H;if(typeof W=="string")return((H=M==null?void 0:M.properties)===null||H===void 0?void 0:H.has(W))?M.properties.get(W):p(W)?N.listen(W):async function(...X){let Z;M&&!h.isUndefinedOrNull(M.context)?Z=[M.context,...X]:Z=X;const ie=await N.call(W,Z);return x?ie:S.revive(ie)};throw new Error(`Property not found: ${String(W)}`)}})}d.toService=v;function p(N){return N[0]==="o"&&N[1]==="n"&&y.isUpperAsciiLetter(N.charCodeAt(2))}})(te=t.ProxyChannel||(t.ProxyChannel={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ae(d){if(Array.isArray(d))return d;if(d&&typeof d=="object"&&typeof d.toString=="function"){let a=d.toString();if(a!=="[object Object]")return a}return d}function se(d){return Array.isArray(d)?d.map(ae):ae(d)}function re(d,a,v,p,N,M,x){x=se(x);const B=Q[N],W=B[p%B.length];let H=[`%c[${d}]%c[${String(a).padStart(7," ")}]%c[len: ${String(v).padStart(5," ")}]%c${String(p).padStart(5," ")} - ${M}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(M)?(H=H.concat(x),H.push(")")):H.push(x),console.log.apply(console,H)}t.logWithColors=re;class T{constructor(a,v){this._outgoingPrefix=a,this._incomingPrefix=v,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(a,v,p,N,M){this._totalOutgoing+=a,re(this._outgoingPrefix,this._totalOutgoing,a,v,p,N,M)}logIncoming(a,v,p,N,M){this._totalIncoming+=a,re(this._incomingPrefix,this._totalIncoming,a,v,p,N,M)}}t.IPCLogger=T}),define(J[66],Y([0,1,2,10,4,13]),function(_,t,g,A,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var F;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(F=t.StorageHint||(t.StorageHint={}));var R;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(R||(R={}));class u extends g.Disposable{constructor(y,w=Object.create(null)){super();this.database=y,this.options=w,this._onDidChangeStorage=this._register(new A.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=R.None,this.cache=new Map,this.flushDelayer=new I.ThrottledDelayer(u.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(y=>this.onDidChangeItemsExternal(y)))}onDidChangeItemsExternal(y){var w,O;(w=y.changed)===null||w===void 0||w.forEach((c,f)=>this.accept(f,c)),(O=y.deleted)===null||O===void 0||O.forEach(c=>this.accept(c,void 0))}accept(y,w){if(this.state===R.Closed)return;let O=!1;L.isUndefinedOrNull(w)?O=this.cache.delete(y):this.cache.get(y)!==w&&(this.cache.set(y,w),O=!0),O&&this._onDidChangeStorage.fire(y)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===R.None&&(this.state=R.Initialized,this.options.hint!==F.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(y,w){const O=this.cache.get(y);return L.isUndefinedOrNull(O)?w:O}getBoolean(y,w){const O=this.get(y);return L.isUndefinedOrNull(O)?w:O==="true"}getNumber(y,w){const O=this.get(y);return L.isUndefinedOrNull(O)?w:parseInt(O,10)}async set(y,w){if(this.state===R.Closed)return;if(L.isUndefinedOrNull(w))return this.delete(y);const O=String(w);if(this.cache.get(y)!==O)return this.cache.set(y,O),this.pendingInserts.set(y,O),this.pendingDeletes.delete(y),this._onDidChangeStorage.fire(y),this.flushDelayer.trigger(()=>this.flushPending())}async delete(y){if(!(this.state===R.Closed||!this.cache.delete(y)))return this.pendingDeletes.has(y)||this.pendingDeletes.add(y),this.pendingInserts.delete(y),this._onDidChangeStorage.fire(y),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=R.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(y){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const y={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(y).finally(()=>{var w;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(w=this.whenFlushedCallbacks.pop())===null||w===void 0||w()})}async whenFlushed(){if(!!this.hasPending)return new Promise(y=>this.whenFlushedCallbacks.push(y))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}t.Storage=u,u.DEFAULT_FLUSH_DELAY=100;class h{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(y){y.insert&&y.insert.forEach((w,O)=>this.items.set(O,w)),y.delete&&y.delete.forEach(w=>this.items.delete(w))}async close(){}}t.InMemoryStorageDatabase=h}),define(J[67],Y([5,6]),function(_,t){return _.create("vs/base/common/date",t)}),define(J[68],Y([0,1,67]),function(_,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const A=60,I=A*60,L=I*24,F=L*7,R=L*30,u=L*365;function h(y,w){typeof y!="number"&&(y=y.getTime());const O=Math.round((new Date().getTime()-y)/1e3);if(O<-30)return g.localize(0,null,h(new Date().getTime()+O*1e3,!1));if(O<30)return g.localize(1,null);let c;return O<A?(c=O,w?c===1?g.localize(2,null,c):g.localize(3,null,c):c===1?g.localize(4,null,c):g.localize(5,null,c)):O<I?(c=Math.floor(O/A),w?c===1?g.localize(6,null,c):g.localize(7,null,c):c===1?g.localize(8,null,c):g.localize(9,null,c)):O<L?(c=Math.floor(O/I),w?c===1?g.localize(10,null,c):g.localize(11,null,c):c===1?g.localize(12,null,c):g.localize(13,null,c)):O<F?(c=Math.floor(O/L),w?c===1?g.localize(14,null,c):g.localize(15,null,c):c===1?g.localize(16,null,c):g.localize(17,null,c)):O<R?(c=Math.floor(O/F),w?c===1?g.localize(18,null,c):g.localize(19,null,c):c===1?g.localize(20,null,c):g.localize(21,null,c)):O<u?(c=Math.floor(O/R),w?c===1?g.localize(22,null,c):g.localize(23,null,c):c===1?g.localize(24,null,c):g.localize(25,null,c)):(c=Math.floor(O/u),w?c===1?g.localize(26,null,c):g.localize(27,null,c):c===1?g.localize(28,null,c):g.localize(29,null,c))}t.fromNow=h;function S(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=S}),define(J[69],Y([5,6]),function(_,t){return _.create("vs/base/common/errorMessage",t)}),define(J[28],Y([0,1,69,13,22]),function(_,t,g,A,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function L(h,S){return S&&(h.stack||h.stacktrace)?g.localize(0,null,R(h),F(h.stack)||F(h.stacktrace)):R(h)}function F(h){return Array.isArray(h)?h.join(`
`):h}function R(h){return typeof h.code=="string"&&typeof h.errno=="number"&&typeof h.syscall=="string"?g.localize(1,null,h.message):h.message||g.localize(2,null)}function u(h=null,S=!1){if(!h)return g.localize(3,null);if(Array.isArray(h)){const y=I.coalesce(h),w=u(y[0],S);return y.length>1?g.localize(4,null,w,y.length):w}if(A.isString(h))return h;if(h.detail){const y=h.detail;if(y.error)return L(y.error,S);if(y.exception)return L(y.exception,S)}return h.stack?L(h,S):h.message?h.message:g.localize(5,null)}t.toErrorMessage=u}),define(J[70],Y([5,6]),function(_,t){return _.create("vs/base/node/processes",t)}),define(J[47],Y([0,1,3,9,32,70,33,13,20,35,14,46,8]),function(_,t,g,A,I,L,F,R,u,h,S,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function O(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(o,r){if(S.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};r&&(e.cwd=r);const i=I.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],e);return new Promise(n=>{i.once("error",s=>{n({success:!1,error:s})}),i.once("exit",(s,l)=>{n(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?O(e.status):1})}else if(S.isLinux||S.isMacintosh)try{const e=w.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",_).fsPath;return new Promise(i=>{I.execFile(e,[o.pid.toString()],{encoding:"utf8",shell:!0},(n,s,l)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function f(o=F.env){return o.comspec||"cmd.exe"}t.getWindowsShell=f;class b{constructor(r,e,i,n){if(e!==void 0&&i!==void 0&&n!==void 0)this.cmd=r,this.args=e,this.shell=i,this.options=n;else{const s=r;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(F.env).forEach(l=>{s[l]=F.env[l]}),Object.keys(this.options.env).forEach(l=>{s[l]=this.options.env[l]}),this.options.env=s}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const e=r.lastIndexOf(g.sep);return e!==-1&&(r=r.substring(e+1)),b.WellKnowCommands[r]?r:"other"}start(r){return S.isWindows&&(this.options&&this.options.cwd&&h.isUNC(this.options.cwd)||!this.options&&h.isUNC(F.cwd()))?Promise.reject(new Error(L.localize(0,null))):this.useExec().then(e=>{let i,n;const s=new Promise((l,E)=>{i=l,n=E});if(e){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=I.exec(l,this.options,(E,P,U)=>{this.childProcess=null;const k=E;k&&k.killed?n({killed:this.terminateRequested,stdout:P.toString(),stderr:U.toString()}):this.handleExec(i,r,E,P,U)})}else{let l=null;const E=P=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(P,i,r,n);const U={terminated:this.terminateRequested};R.isNumber(P)&&(U.cmdCode=P),i(U)};if(this.shell&&S.isWindows){const P=u.deepClone(this.options);P.windowsVerbatimArguments=!0,P.detached=!1;let U=!1,k=!1;const j=[];let V=this.ensureQuotes(this.cmd);j.push(V.value),U=V.quoted,this.args&&this.args.forEach(K=>{V=this.ensureQuotes(K),j.push(V.value),k=k&&V.quoted});const $=["/s","/c"];U?k?$.push('"'+j.join(" ")+'"'):j.length>1?$.push('"'+j[0]+'" '+j.slice(1).join(" ")):$.push('"'+j[0]+'"'):$.push(j.join(" ")),l=I.spawn(f(),$,P)}else this.cmd&&(l=I.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(R.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",P=>{this.childProcess=null,n({terminated:this.terminateRequested,error:P})}),l.pid&&(this.childProcess.on("close",E),this.handleSpawn(l,i,r,n,!0)))}return s})}handleClose(r,e,i,n){}ensureQuotes(r){return b.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,c(r,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!S.isWindows)return r(!1);const e=I.spawn(f(),["/s","/c"]);e.on("error",i=>r(!0)),e.on("exit",i=>r(!1))})}}t.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class C extends b{constructor(r,e,i,n){super(r,e,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,e,i,n,s){[n,s].forEach((l,E)=>{const P=new y.LineDecoder;P.write(l).forEach(j=>{e({line:j,source:E===0?0:1})});const k=P.end();k&&e({line:k,source:E===0?0:1})}),r({terminated:this.terminateRequested,error:i})}handleSpawn(r,e,i,n,s){const l=new y.LineDecoder,E=new y.LineDecoder;r.stdout.on("data",P=>{l.write(P).forEach(k=>i({line:k,source:0}))}),r.stderr.on("data",P=>{E.write(P).forEach(k=>i({line:k,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=E}handleClose(r,e,i,n){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&i({line:s,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&i({line:l,source:1})}}t.LineProcess=C;function D(o){let r=[],e=!1;const i=function(n){if(e){r.push(n);return}(!o.send(n,l=>{if(l&&console.error(l),e=!1,r.length>0){const E=r.slice(0);r=[],E.forEach(P=>i(P))}})||S.isWindows)&&(e=!0)};return{send:i}}t.createQueuedSender=D;var m;(function(o){async function r(e,i,n){if(g.isAbsolute(e))return e;if(i===void 0&&(i=F.cwd()),g.dirname(e)!=="."||(n===void 0&&R.isString(F.env.PATH)&&(n=F.env.PATH.split(g.delimiter)),n===void 0||n.length===0))return g.join(i,e);async function l(E){return await A.Promises.exists(E)?!(await A.Promises.stat(E)).isDirectory():!1}for(let E of n){let P;if(g.isAbsolute(E)?P=g.join(E,e):P=g.join(i,E,e),await l(P))return P;let U=P+".com";if(await l(U)||(U=P+".exe",await l(U)))return U}return g.join(i,e)}o.findExecutable=r})(m=t.win32||(t.win32={}))}),define(J[71],Y([0,1,31,14,64,47]),function(_,t,g,A,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function F(O,c){return O===1?A.isWindows?y():L.getWindowsShell(c):h(O,c)}t.getSystemShell=F;function R(O,c){return O===1?A.isWindows?w(c):L.getWindowsShell(c):h(O,c)}t.getSystemShellSync=R;let u=null;function h(O,c){if(A.isLinux&&O===2||A.isMacintosh&&O===3)return"/bin/bash";if(!u){let f;if(A.isWindows)f="/bin/bash";else{if(f=c.SHELL,!f)try{f=g.userInfo().shell}catch(b){}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}u=f}return u}let S=null;async function y(){return S||(S=(await I.getFirstAvailablePowerShellInstallation()).exePath),S}function w(O){if(S)return S;const c=A.isWindows&&parseFloat(g.release())>=10,f=O.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${O.windir}\\${f?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return c?b:L.getWindowsShell(O)}}),define(J[48],Y([0,1,32,2,4,20,10,47,37,59,26,12,16,14]),function(_,t,g,A,I,L,F,R,u,h,S,y,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class c extends u.ChannelServer{constructor(C){super({send:D=>{try{process.send&&process.send(D.buffer.toString("base64"))}catch(m){}},onMessage:F.Event.fromNodeEventEmitter(process,"message",D=>w.VSBuffer.wrap(Buffer.from(D,"base64")))},C);process.once("disconnect",()=>this.dispose())}}t.Server=c;class f{constructor(C,D){this.modulePath=C,this.options=D,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new F.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const m=D&&D.timeout?D.timeout:6e4;this.disposeDelayer=new I.Delayer(m),this.child=null,this._client=null}getChannel(C){const D=this;return{call(m,o,r){return D.requestPromise(C,m,o,r)},listen(m,o){return D.requestEvent(C,m,o)}}}requestPromise(C,D,m,o=S.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(y.canceled());this.disposeDelayer.cancel();const r=this.getCachedChannel(C),e=I.createCancelablePromise(s=>r.call(D,m,s)),i=o.onCancellationRequested(()=>e.cancel()),n=A.toDisposable(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(C,D,m){if(!this.disposeDelayer)return F.Event.None;this.disposeDelayer.cancel();let o;const r=new F.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(C).listen(D,m)(r.fire,r),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return r.event}get client(){if(!this._client){const C=this.options&&this.options.args?this.options.args:[],D=Object.create(null);D.env=Object.assign(Object.assign({},L.deepClone(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(D.env=Object.assign(Object.assign({},D.env),this.options.env)),this.options&&this.options.freshExecArgv&&(D.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(D.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(D.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),D.execArgv===void 0&&(D.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l))),O.isMacintosh&&D.env&&delete D.env.DYLD_LIBRARY_PATH,this.child=g.fork(this.modulePath,C,D);const m=new F.Emitter;F.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if(h.isRemoteConsoleLog(l)){h.log(l,`IPC Library: ${this.options.serverName}`);return}m.fire(w.VSBuffer.wrap(Buffer.from(l,"base64")))});const r=this.options.useQueue?R.createQueuedSender(this.child):this.child,e=l=>this.child&&this.child.connected&&r.send(l.buffer.toString("base64")),i=m.event,n={send:e,onMessage:i};this._client=new u.ChannelClient(n);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,E)=>{process.removeListener("exit",s),this.activeRequests.forEach(P=>A.dispose(P)),this.activeRequests.clear(),l!==0&&E!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+E),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:E})})}return this._client}getCachedChannel(C){let D=this.channels.get(C);return D||(D=this.client.getChannel(C),this.channels.set(C,D)),D}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=f}),define(J[72],Y([5,6]),function(_,t){return _.create("vs/base/node/zip",t)}),define(J[73],Y([5,6]),function(_,t){return _.create("vs/platform/configuration/common/configurationRegistry",t)}),define(J[74],Y([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(J[75],Y([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(J[76],Y([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(J[77],Y([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(J[78],Y([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(J[79],Y([5,6]),function(_,t){return _.create("vs/platform/extensions/common/extensionValidator",t)}),define(J[80],Y([5,6]),function(_,t){return _.create("vs/platform/files/common/fileService",t)}),define(J[81],Y([5,6]),function(_,t){return _.create("vs/platform/files/common/io",t)}),define(J[82],Y([5,6]),function(_,t){return _.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(J[83],Y([5,6]),function(_,t){return _.create("vs/platform/request/common/request",t)}),define(J[84],Y([5,6]),function(_,t){return _.create("vs/platform/telemetry/common/telemetryService",t)}),define(J[85],Y([0,1,3,17,44,68,8,7,33]),function(_,t,g,A,I,L,F,R,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class h{constructor(c,f,b){this._args=c,this.paths=f,this.productService=b}get appRoot(){return g.dirname(F.FileAccess.asFileUri("",_).fsPath)}get userHome(){return R.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return R.URI.file(g.join(this.userDataPath,"User"))}get tmpDir(){return R.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return A.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return A.joinPath(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const c=L.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=g.join(this.userDataPath,"logs",c)}return this.args.logsPath}get userDataSyncLogResource(){return R.URI.file(g.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return A.joinPath(R.URI.file(g.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return R.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return R.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return A.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return A.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=u.env.VSCODE_PORTABLE;return c?R.URI.file(g.join(c,"argv.json")):A.joinPath(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return A.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return R.URI.file(g.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return g.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?g.resolve(c):g.normalize(g.join(F.FileAccess.asFileUri("",_).fsPath,"..","extensions"))}get extensionsDownloadPath(){const c=this.args["extensions-download-dir"];return c?g.resolve(c):g.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return g.resolve(c);const f=u.env.VSCODE_EXTENSIONS;if(f)return f;const b=u.env.VSCODE_PORTABLE;return b?g.join(b,"extensions"):A.joinPath(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(f=>/^[^:/?#]+?:\/\//.test(f)?R.URI.parse(f):R.URI.file(g.normalize(f)))}get extensionDevelopmentKind(){var c;return(c=this.args.extensionDevelopmentKind)===null||c===void 0?void 0:c.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?R.URI.parse(c):R.URI.file(g.normalize(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!u.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return A.joinPath(R.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return R.URI.file(g.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([I.memoize],h.prototype,"appRoot",null),ue([I.memoize],h.prototype,"userHome",null),ue([I.memoize],h.prototype,"userDataPath",null),ue([I.memoize],h.prototype,"appSettingsHome",null),ue([I.memoize],h.prototype,"tmpDir",null),ue([I.memoize],h.prototype,"userRoamingDataHome",null),ue([I.memoize],h.prototype,"settingsResource",null),ue([I.memoize],h.prototype,"userDataSyncHome",null),ue([I.memoize],h.prototype,"userDataSyncLogResource",null),ue([I.memoize],h.prototype,"sync",null),ue([I.memoize],h.prototype,"machineSettingsResource",null),ue([I.memoize],h.prototype,"globalStorageHome",null),ue([I.memoize],h.prototype,"workspaceStorageHome",null),ue([I.memoize],h.prototype,"keybindingsResource",null),ue([I.memoize],h.prototype,"keyboardLayoutResource",null),ue([I.memoize],h.prototype,"argvResource",null),ue([I.memoize],h.prototype,"snippetsHome",null),ue([I.memoize],h.prototype,"isExtensionDevelopment",null),ue([I.memoize],h.prototype,"untitledWorkspacesHome",null),ue([I.memoize],h.prototype,"installSourcePath",null),ue([I.memoize],h.prototype,"builtinExtensionsPath",null),ue([I.memoize],h.prototype,"extensionsPath",null),ue([I.memoize],h.prototype,"extensionDevelopmentLocationURI",null),ue([I.memoize],h.prototype,"extensionDevelopmentKind",null),ue([I.memoize],h.prototype,"extensionTestsLocationURI",null),ue([I.memoize],h.prototype,"debugExtensionHost",null),ue([I.memoize],h.prototype,"serviceMachineIdResource",null),ue([I.memoize],h.prototype,"telemetryLogResource",null),ue([I.memoize],h.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=h;function S(O,c){return w(O["inspect-extensions"],O["inspect-brk-extensions"],5870,c,O.debugId)}t.parseExtensionHostPort=S;function y(O,c){return w(O["inspect-search"],O["inspect-brk-search"],5876,c)}t.parseSearchPort=y;function w(O,c,f,b,C){const m=Number(c||O)||(b?null:f),o=m?Boolean(!!c):!1;return{port:m,break:o,debugId:C}}}),function(){"use strict";function _(t,g,A,I){function L(R){const u=F(R),h=[u];return t.isAbsolute(u)||h.unshift(I),t.resolve(...h)}function F(R){const u=process.env.VSCODE_PORTABLE;if(u)return t.join(u,"user-data");const h=R["user-data-dir"];if(h)return h;let S=process.env.VSCODE_APPDATA;if(!S)switch(process.platform){case"win32":if(S=process.env.APPDATA,!S){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");S=t.join(y,"AppData","Roaming")}break;case"darwin":S=t.join(g.homedir(),"Library","Application Support");break;case"linux":S=process.env.XDG_CONFIG_HOME||t.join(g.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(S,A)}return{getUserDataPath:L}}if(typeof define=="function")define(J[86],Y([0,87,31,8,17,33]),function(t,g,A,I,L,F){const R=L.dirname(I.FileAccess.asFileUri("",t)),u=t.__$__nodeRequire(L.joinPath(R,"package.json").fsPath);return _(g,A,u.name,F.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),g=require("path"),A=require("os");module.exports=_(g,A,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[88],Y([0,1,31,86,85]),function(_,t,g,A,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class L extends I.AbstractNativeEnvironmentService{constructor(R,u){super(R,{homeDir:g.homedir(),tmpDir:g.tmpdir(),userDataDir:A.getUserDataPath(R)},u)}}t.NativeEnvironmentService=L}),define(J[89],Y([0,1,20]),function(_,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const A=/^%([\w\d.-]+)%$/i;function I(L,F){const R=u=>{var h;if(typeof u!="string")return;const S=A.exec(u);if(!S)return;const y=(h=F[S[1]])!==null&&h!==void 0?h:u;return typeof y=="string"?y:typeof y.message=="string"?y.message:u};return g.cloneAndChange(L,R)}t.localizeManifest=I}),define(J[49],Y([0,1,79]),function(_,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function L(w){return w=w.trim(),w==="*"||A.test(w)}t.isValidVersionStr=L;function F(w){if(!L(w))return null;if(w=w.trim(),w==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let O=w.match(A);return O?{hasCaret:O[1]==="^",hasGreaterEquals:O[1]===">=",majorBase:O[2]==="x"?0:parseInt(O[2],10),majorMustEqual:O[2]!=="x",minorBase:O[4]==="x"?0:parseInt(O[4],10),minorMustEqual:O[4]!=="x",patchBase:O[6]==="x"?0:parseInt(O[6],10),patchMustEqual:O[6]!=="x",preRelease:O[8]||null}:null}t.parseVersion=F;function R(w){if(!w)return null;let O=w.majorBase,c=w.majorMustEqual,f=w.minorBase,b=w.minorMustEqual,C=w.patchBase,D=w.patchMustEqual;w.hasCaret&&(O===0||(b=!1),D=!1);let m=0;if(w.preRelease){const o=I.exec(w.preRelease);if(o){const[,r,e,i]=o;m=Date.UTC(Number(r),Number(e)-1,Number(i))}}return{majorBase:O,majorMustEqual:c,minorBase:f,minorMustEqual:b,patchBase:C,patchMustEqual:D,isMinimum:w.hasGreaterEquals,notBefore:m}}t.normalizeVersion=R;function u(w,O,c){let f;typeof w=="string"?f=R(F(w)):f=w;let b;O instanceof Date?b=O.getTime():typeof O=="string"&&(b=new Date(O).getTime());let C;if(typeof c=="string"?C=R(F(c)):C=c,!f||!C)return!1;let D=f.majorBase,m=f.minorBase,o=f.patchBase,r=C.majorBase,e=C.minorBase,i=C.patchBase,n=C.notBefore,s=C.majorMustEqual,l=C.minorMustEqual,E=C.patchMustEqual;return C.isMinimum?D>r?!0:D<r?!1:m>e?!0:m<e||b&&b<n?!1:o>=i:(D===1&&r===0&&(!s||!l||!E)&&(r=1,e=0,i=0,s=!0,l=!1,E=!1),D<r?!1:D>r?!s:m<e?!1:m>e?!l:o<i?!1:o>i?!E:!(b&&b<n))}t.isValidVersion=u;function h(w,O,c,f){return c.isBuiltin||typeof c.main=="undefined"?!0:y(w,O,c.engines.vscode,f)}t.isValidExtensionVersion=h;function S(w,O,c){return w==="*"||y(O,c,w)}t.isEngineValid=S;function y(w,O,c,f=[]){let b=R(F(c));if(!b)return f.push(g.localize(0,null,c)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return f.push(g.localize(1,null,c)),!1}else if(!b.majorMustEqual)return f.push(g.localize(2,null,c)),!1;return u(w,O,b)?!0:(f.push(g.localize(3,null,w,c)),!1)}}),define(J[90],Y([0,1,37,48,2,8]),function(_,t,g,A,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class F extends I.Disposable{constructor(u,h,S,y){super();this.folders=u,this.onDidFilesChange=h,this.onLogMessage=S,this.verboseLogging=y,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const u=this._register(new A.Client(L.FileAccess.asFileUri("bootstrap-fork",_).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(u.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=F.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=g.ProxyChannel.toService(g.getNextTickChannel(u.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(h=>!this.isDisposed&&this.onDidFilesChange(h))),this._register(this.service.onDidLogMessage(h=>this.onLogMessage(h))),this.setFolders(this.folders)}setVerboseLogging(u){this.verboseLogging=u,!this.isDisposed&&this.service&&this.service.setVerboseLogging(u)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${u}`})}setFolders(u){this.folders=u,this.service&&this.service.setRoots(u)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=F,F.MAX_RESTARTS=5}),define(J[91],Y([0,1,37,48,2,8]),function(_,t,g,A,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class F extends I.Disposable{constructor(u,h,S,y,w={}){super();this.folders=u,this.onDidFilesChange=h,this.onLogMessage=S,this.verboseLogging=y,this.watcherOptions=w,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const u=this._register(new A.Client(L.FileAccess.asFileUri("bootstrap-fork",_).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(u.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=F.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=g.ProxyChannel.toService(g.getNextTickChannel(u.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(h=>!this.isDisposed&&this.onDidFilesChange(h))),this._register(this.service.onDidLogMessage(h=>this.onLogMessage(h))),this.service.setRoots(this.folders)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${u}`})}setVerboseLogging(u){this.verboseLogging=u,this.service&&this.service.setVerboseLogging(u)}setFolders(u){this.folders=u,this.service&&this.service.setRoots(u)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=F,F.MAX_RESTARTS=5}),define(J[92],Y([0,1,32,46,61,8]),function(_,t,g,A,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class F{constructor(u,h,S,y,w){this.watchedFolder=u,this.eventCallback=S,this.logCallback=y,this.verboseLogging=w,this.restartCounter=0,Array.isArray(h)?this.ignored=h.map(O=>I.parse(O)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${u}, excludes: ${h.join(",")}`),this.startWatcher()}startWatcher(){const u=[this.watchedFolder];this.verboseLogging&&u.push("-verbose"),this.handle=g.spawn(L.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",_).fsPath,u);const h=new A.LineDecoder;this.handle.stdout.on("data",S=>{const y=[];for(const w of h.write(S)){const O=w.split("|");if(O.length===2){const c=Number(O[0]),f=O[1];if(c>=0&&c<3){if(this.ignored&&this.ignored.some(b=>b(f))){this.verboseLogging&&this.log(f);continue}y.push({type:F.changeTypeMap[c],path:f})}else this.log(O[1])}}y.length>0&&this.eventCallback(y)}),this.handle.on("error",S=>this.onError(S)),this.handle.stderr.on("data",S=>this.onError(S)),this.handle.on("exit",(S,y)=>this.onExit(S,y))}onError(u){this.error("process error: "+u.toString())}onExit(u,h){this.handle&&(this.error(`terminated unexpectedly (code: ${u}, signal: ${h})`),this.restartCounter<=F.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(u){this.logCallback({type:"error",message:`[File Watcher (C#)] ${u}`})}log(u){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${u}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=F,F.MAX_RESTARTS=5,F.changeTypeMap=[0,1,2]}),define(J[93],Y([0,1,92,3,19]),function(_,t,g,A,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class L{constructor(R,u,h,S){this.onDidFilesChange=u,this.onLogMessage=h,this.verboseLogging=S,this.service=void 0,this.folder=R[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(A.posix.sep)&&(this.folder.path=I.rtrim(this.folder.path,A.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new g.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,R=>this.onFileEvents(R),R=>this.onLogMessage(R),this.verboseLogging)}setVerboseLogging(R){this.verboseLogging=R,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(R){this.isDisposed||R.length>0&&this.onDidFilesChange(R)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=L}),define(J[50],Y([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSyncDescriptor=t.SyncDescriptor=void 0;class g{constructor(L,F=[],R=!1){this.ctor=L,this.staticArguments=F,this.supportsDelayedInstantiation=R}}t.SyncDescriptor=g;const A=(I,...L)=>new g(I,L);t.createSyncDescriptor=A}),define(J[94],Y([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class g{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}t.Node=g;class A{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(let F of this._nodes.values())F.outgoing.size===0&&L.push(F);return L}insertEdge(L,F){const R=this.lookupOrInsertNode(L),u=this.lookupOrInsertNode(F);R.outgoing.set(this._hashFn(F),u),u.incoming.set(this._hashFn(L),R)}removeNode(L){const F=this._hashFn(L);this._nodes.delete(F);for(let R of this._nodes.values())R.outgoing.delete(F),R.incoming.delete(F)}lookupOrInsertNode(L){const F=this._hashFn(L);let R=this._nodes.get(F);return R||(R=new g(L),this._nodes.set(F,R)),R}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){let L=[];for(let[F,R]of this._nodes)L.push(`${F}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(let[L,F]of this._nodes){const R=new Set([L]),u=this._findCycle(F,R);if(u)return u}}_findCycle(L,F){for(let[R,u]of L.outgoing){if(F.has(R))return[...F,R].join(" -> ");F.add(R);const h=this._findCycle(u,F);if(h)return h;F.delete(R)}}}t.Graph=A}),define(J[95],Y([0,1,11]),function(_,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=g.createDecorator("downloadService")}),define(J[21],Y([0,1,11]),function(_,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=g.createDecorator("environmentService"),t.INativeEnvironmentService=g.refineServiceDecorator(t.IEnvironmentService)}),define(J[23],Y([0,1,74,11,8]),function(_,t,g,A,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN);function L(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}t.isIExtensionIdentifier=L;var F;(function(y){y[y.NoneOrRelevance=0]="NoneOrRelevance",y[y.LastUpdatedDate=1]="LastUpdatedDate",y[y.Title=2]="Title",y[y.PublisherName=3]="PublisherName",y[y.InstallCount=4]="InstallCount",y[y.PublishedDate=5]="PublishedDate",y[y.AverageRating=6]="AverageRating",y[y.WeightedRating=12]="WeightedRating"})(F=t.SortBy||(t.SortBy={}));var R;(function(y){y[y.Default=0]="Default",y[y.Ascending=1]="Ascending",y[y.Descending=2]="Descending"})(R=t.SortOrder||(t.SortOrder={}));var u;(function(y){y.Uninstall="uninstall"})(u=t.StatisticType||(t.StatisticType={}));var h;(function(y){y[y.None=0]="None",y[y.Install=1]="Install",y[y.Update=2]="Update"})(h=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=A.createDecorator("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class S extends Error{constructor(w,O){super(w);this.code=O}}t.ExtensionManagementError=S,t.IExtensionManagementService=A.createDecorator("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=A.createDecorator("IGlobalExtensionEnablementService"),t.IExtensionTipsService=A.createDecorator("IExtensionTipsService"),t.DefaultIconPath=I.FileAccess.asBrowserUri("./media/defaultIcon.png",_).toString(!0),t.ExtensionsLabel=g.localize(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=g.localize(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=A.createDecorator("IExtensionManagementCLIService")}),define(J[38],Y([0,1,19,11]),function(_,t,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkpaceSupportTypeMessage=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin";function I(S){if(typeof S=="object"&&S!==null&&S.supported!==!0)return S.description}t.getWorkpaceSupportTypeMessage=I;function L(S){return S&&typeof S=="object"&&typeof S.id=="string"&&(!S.uuid||typeof S.uuid=="string")}t.isIExtensionIdentifier=L,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var F;(function(S){S[S.System=0]="System",S[S.User=1]="User"})(F=t.ExtensionType||(t.ExtensionType={}));class R{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,w){if(typeof y=="undefined"||y===null)return typeof w=="undefined"||w===null;if(typeof w=="undefined"||w===null)return!1;if(typeof y=="string"||typeof w=="string"){let O=typeof y=="string"?y:y.value,c=typeof w=="string"?w:w.value;return g.equalsIgnoreCase(O,c)}return y._lower===w._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}t.ExtensionIdentifier=R;function u(S){return S.contributes&&S.contributes.localizations?S.contributes.localizations.length>0:!1}t.isLanguagePackExtension=u;function h(S){return S.contributes&&S.contributes.authentication?S.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=h,t.IBuiltinExtensionsScannerService=A.createDecorator("IBuiltinExtensionsScannerService")}),define(J[24],Y([0,1,19,38]),function(_,t,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function I(O,c){return O.uuid&&c.uuid?O.uuid===c.uuid:O.id===c.id?!0:g.compareIgnoreCase(O.id,c.id)===0}t.areSameExtensions=I;class L{constructor(c,f){this.version=f,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof L?I(this,c)&&this.version===c.version:!1}}t.ExtensionIdentifierWithVersion=L;function F(O,c){return`${O}.${c}`}t.getExtensionId=F;function R(O){return O.toLocaleLowerCase()}t.adoptToGalleryExtensionId=R;function u(O,c){return R(F(O,c))}t.getGalleryExtensionId=u;function h(O,c){const f=[],b=C=>{for(const D of f)if(D.some(m=>I(c(m),c(C))))return D;return null};for(const C of O){const D=b(C);D?D.push(C):f.push([C])}return f}t.groupByExtension=h;function S(O){return{id:O.identifier.id,name:O.manifest.name,galleryId:null,publisherId:O.publisherId,publisherName:O.manifest.publisher,publisherDisplayName:O.publisherDisplayName,dependencies:O.manifest.extensionDependencies&&O.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=S;function y(O){return Object.assign({id:O.identifier.id,name:O.name,galleryId:O.identifier.uuid,publisherId:O.publisherId,publisherName:O.publisher,publisherDisplayName:O.publisherDisplayName,dependencies:!!(O.properties.dependencies&&O.properties.dependencies.length>0)},O.telemetryData)}t.getGalleryExtensionTelemetryData=y,t.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function w(O){const c=new Set;for(const f of O)f.malicious&&c.add(f.id.id);return c}t.getMaliciousExtensionsSet=w});var fe=this&&this.__param||function(_,t){return function(g,A){t(g,A,_)}};define(J[96],Y([0,1,75,12,7,39,23,24,38,62,26,8]),function(_,t,g,A,I,L,F,R,u,h,S,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const w=D=>g.localize(0,null,D),O=g.localize(1,null,"ms-dotnettools.csharp");function c(D,m){return m?`${D.publisher}.${D.name}@${D.version}`:`${D.publisher}.${D.name}`}const f=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function b(D){const m=f.exec(D);return m&&m[1]?[R.adoptToGalleryExtensionId(m[1]),m[2]]:[R.adoptToGalleryExtensionId(D),void 0]}t.getIdAndVersion=b;let C=class{constructor(m,o){this.extensionManagementService=m,this.extensionGalleryService=o}get location(){}async listExtensions(m,o,r=console){let e=await this.extensionManagementService.getInstalled(1);const i=u.EXTENSION_CATEGORIES.map(s=>s.toLowerCase());if(o&&o!==""){if(i.indexOf(o.toLowerCase())<0){r.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(s=>s.manifest.categories?s.manifest.categories.map(E=>E.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){r.log("Possible Categories: "),i.forEach(s=>{r.log(s)});return}this.location&&r.log(g.localize(2,null,this.location)),e=e.sort((s,l)=>s.identifier.id.localeCompare(l.identifier.id));let n;for(let s of e)n!==s.identifier.id&&(n=s.identifier.id,r.log(c(s.manifest,m)))}async installExtensions(m,o,r,e,i=console){const n=[],s=[];m.length&&i.log(this.location?g.localize(3,null,this.location):g.localize(4,null));const l=await this.extensionManagementService.getInstalled(1),E=(k,j)=>{const V=l.find($=>R.areSameExtensions($.identifier,{id:k}));if(V){if(!j&&!e)return i.log(g.localize(5,null,k,V.manifest.version,k)),!1;if(j&&V.manifest.version===j)return i.log(g.localize(6,null,`${k}@${j}`)),!1}return!0},P=[],U=[];for(const k of m)if(k instanceof I.URI)P.push(k);else{const[j,V]=b(k);E(j,V)&&U.push({id:j,version:V,installOptions:{isBuiltin:!1,isMachineScoped:r}})}for(const k of o){const[j,V]=b(k);E(j,V)&&U.push({id:j,version:V,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(P.length&&await Promise.all(P.map(async k=>{try{const j=await this.installVSIX(k,{isBuiltin:!1,isMachineScoped:r},e,i);j&&s.push(j)}catch(j){i.error(j.message||j.stack||j),n.push(k.toString())}})),U.length){const k=await this.getGalleryExtensions(U);await Promise.all(U.map(async j=>{const V=k.get(j.id.toLowerCase());if(V)try{const $=await this.installFromGallery(j,V,l,e,i);$&&s.push($)}catch($){i.error($.message||$.stack||$),n.push(j.id)}else i.error(`${w(j.version?`${j.id}@${j.version}`:j.id)}
${O}`),n.push(j.id)}))}if(n.length)throw new Error(g.localize(7,null,n.join(", ")))}async installVSIX(m,o,r,e){const i=await this.extensionManagementService.getManifest(m);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,r,e))try{return await this.extensionManagementService.install(m,o),e.log(g.localize(8,null,h.getBaseLabel(m))),i}catch(s){if(A.isPromiseCanceledError(s))return e.log(g.localize(9,null,h.getBaseLabel(m))),null;throw s}return null}async getGalleryExtensions(m){const o=m.filter(({version:i})=>i===void 0).map(({id:i})=>i),r=m.filter(({version:i})=>i!==void 0),e=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(o,S.CancellationToken.None)).forEach(n=>e.set(n.identifier.id.toLowerCase(),n))})(),Promise.all(r.map(async({id:i,version:n})=>{const s=await this.extensionGalleryService.getCompatibleExtension({id:i},n);s&&e.set(s.identifier.id.toLowerCase(),s)}))]),e}async installFromGallery({id:m,version:o,installOptions:r},e,i,n,s){const l=await this.extensionGalleryService.getManifest(e,S.CancellationToken.None);if(l&&!this.validateExtensionKind(l,s))return null;const E=i.find(P=>R.areSameExtensions(P.identifier,e.identifier));if(E){if(e.version===E.manifest.version)return s.log(g.localize(10,null,o?`${m}@${o}`:m)),null;s.log(g.localize(11,null,m,e.version))}try{return r.isBuiltin?s.log(o?g.localize(12,null,m,o):g.localize(13,null,m)):s.log(o?g.localize(14,null,m,o):g.localize(15,null,m)),await this.extensionManagementService.installFromGallery(e,r),s.log(g.localize(16,null,m,e.version)),l}catch(P){if(A.isPromiseCanceledError(P))return s.log(g.localize(17,null,m)),null;throw P}}validateExtensionKind(m,o){return!0}async validateVSIX(m,o,r){const e={id:R.getGalleryExtensionId(m.publisher,m.name)},n=(await this.extensionManagementService.getInstalled(1)).find(s=>R.areSameExtensions(e,s.identifier)&&L.gt(s.manifest.version,m.version));return n&&!o?(r.log(g.localize(18,null,n.identifier.id,n.manifest.version,m.version)),!1):this.validateExtensionKind(m,r)}async uninstallExtensions(m,o,r=console){const e=async n=>{if(n instanceof I.URI){const s=await this.extensionManagementService.getManifest(n);return c(s)}return n},i=[];for(const n of m){const s=await e(n),E=(await this.extensionManagementService.getInstalled()).filter(P=>R.areSameExtensions(P.identifier,{id:s}));if(!E.length)throw new Error(`${this.notInstalled(s)}
${O}`);if(E.some(P=>P.type===0)){r.log(g.localize(19,null,s));return}if(!o&&E.some(P=>P.isBuiltin)){r.log(g.localize(20,null,s));return}r.log(g.localize(21,null,s));for(const P of E)await this.extensionManagementService.uninstall(P),i.push(P);this.location?r.log(g.localize(22,null,s,this.location)):r.log(g.localize(23,null,s))}}async locateExtension(m,o=console){const r=await this.extensionManagementService.getInstalled();m.forEach(e=>{r.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===y.Schemas.file){o.log(i.location.fsPath);return}})})}notInstalled(m){return this.location?g.localize(24,null,m,this.location):g.localize(25,null,m)}};C=ue([fe(0,F.IExtensionManagementService),fe(1,F.IExtensionGalleryService)],C),t.ExtensionManagementCLIService=C}),define(J[97],Y([0,1,2,3,38,9]),function(_,t,g,A,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class F extends g.Disposable{constructor(u,h){super();this.environmentService=u,this.extensionsManifestCache=A.join(this.environmentService.userDataPath,I.MANIFEST_CACHE_FOLDER,I.USER_MANIFEST_CACHE_FILE),this._register(h.onDidInstallExtension(S=>this.onDidInstallExtension(S))),this._register(h.onDidUninstallExtension(S=>this.onDidUnInstallExtension(S)))}onDidInstallExtension(u){u.error||this.invalidate()}onDidUnInstallExtension(u){u.error||this.invalidate()}invalidate(){L.Promises.rm(this.extensionsManifestCache,L.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=F}),define(J[98],Y([0,1,87,32,29,14,126,28,71,26,12]),function(_,t,g,A,I,L,F,R,u,h,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function y(c,f,b){return f["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):L.isWindows?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):F.isLaunchedFromCli(b)&&!f["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):(F.isLaunchedFromCli(b)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=new Promise(async C=>{const D=new h.CancellationTokenSource,m=setTimeout(()=>{c.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),D.dispose(!0),C({})},1e4);try{const o=await O(c,D.token);C(o)}catch(o){S.isPromiseCanceledError(o)||c.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),C({})}finally{clearTimeout(m),D.dispose()}})),w)}t.resolveShellEnv=y;let w;async function O(c,f){const b=new Promise(async(C,D)=>{const m=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",m);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",o);const r=I.generateUuid().replace(/-/g,"").substr(0,12),e=new RegExp(r+"(.*)"+r),i=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});c.trace("getUnixShellEnvironment#env",i);const n=await u.getSystemShell(L.OS,i);if(c.trace("getUnixShellEnvironment#shell",n),f.isCancellationRequested)return D(S.canceled);const s=g.basename(n);let l,E;/^pwsh(-preview)?$/.test(s)?(l=`& '${process.execPath}' -p '''${r}'' + JSON.stringify(process.env) + ''${r}'''`,E=["-Login","-Command"]):(l=`'${process.execPath}' -p '"${r}" + JSON.stringify(process.env) + "${r}"'`,E=["-ilc"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(E),l);const P=A.spawn(n,[...E,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});f.onCancellationRequested(()=>(P.kill(),D(S.canceled))),P.on("error",j=>{c.error("getUnixShellEnvironment#errorChildProcess",R.toErrorMessage(j)),C({})});const U=[];P.stdout.on("data",j=>U.push(j));const k=[];P.stderr.on("data",j=>k.push(j)),P.on("close",(j,V)=>{const $=Buffer.concat(U).toString("utf8");c.trace("getUnixShellEnvironment#raw",$);const K=Buffer.concat(k).toString("utf8");if(K.trim()&&c.trace("getUnixShellEnvironment#stderr",K),j||V)return D(new Error(`Failed to get environment (code ${j}, signal ${V})`));const ee=e.exec($),te=ee?ee[1]:"{}";try{const Q=JSON.parse(te);m?Q.ELECTRON_RUN_AS_NODE=m:delete Q.ELECTRON_RUN_AS_NODE,o?Q.ELECTRON_NO_ATTACH_CONSOLE=o:delete Q.ELECTRON_NO_ATTACH_CONSOLE,delete Q.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",Q),C(Q)}catch(Q){c.error("getUnixShellEnvironment#errorCaught",R.toErrorMessage(Q)),D(Q)}})});try{return await b}catch(C){return c.error("getUnixShellEnvironment#error",R.toErrorMessage(C)),{}}}}),define(J[51],Y([0,1,7,18,14]),function(_,t,g,A,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function L(u){return u.map(h=>({type:h.type,resource:g.URI.file(h.path)}))}t.toFileChanges=L;function F(u){const h=new R;for(const S of u)h.processEvent(S);return h.normalize()}t.normalizeFileChanges=F;class R{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(h){const S=this.mapPathToChange.get(h.path);if(S){const y=S.type,w=h.type;y===1&&w===2?(this.mapPathToChange.delete(h.path),this.normalized.splice(this.normalized.indexOf(S),1)):y===2&&w===1?S.type=0:y===1&&w===0||(S.type=w)}else this.normalized.push(h),this.mapPathToChange.set(h.path,h)}normalize(){const h=[],S=[];return this.normalized.filter(y=>y.type!==2?(h.push(y),!1):!0).sort((y,w)=>y.path.length-w.path.length).filter(y=>S.some(w=>A.isParent(y.path,w,!I.isLinux))?!1:(S.push(y.path),!0)).concat(h)}}}),define(J[99],Y([0,1,51,2,9,63,65,4,3]),function(_,t,g,A,I,L,F,R,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class h extends A.Disposable{constructor(y,w,O,c){super();this.path=y,this.onDidFilesChange=w,this.onLogMessage=O,this.verboseLogging=c,this.fileChangesDelayer=this._register(new R.ThrottledDelayer(F.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(y){this.verboseLogging=y}async startWatching(){try{const{stat:y,symbolicLink:w}=await I.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let O=this.path;if(w)try{O=await L.realpath(O)}catch(c){if(this.onError(c),w.dangling)return}y.isDirectory()?this._register(F.watchFolder(O,(c,f)=>{this.onFileChange({type:c==="changed"?0:c==="added"?1:2,path:u.join(this.path,u.basename(f))})},c=>this.onError(c))):this._register(F.watchFile(O,c=>{this.onFileChange({type:c==="changed"?0:2,path:this.path})},c=>this.onError(c)))}catch(y){y.code!=="ENOENT"&&this.onError(y)}}onFileChange(y){this.fileChangesBuffer.push(y),this.verboseLogging&&this.onVerbose(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),this.fileChangesDelayer.trigger(async()=>{const w=this.fileChangesBuffer;this.fileChangesBuffer=[];const O=g.normalizeFileChanges(w);if(this.verboseLogging)for(const c of O)this.onVerbose(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);O.length>0&&this.onDidFilesChange(O)})}onError(y){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${y}`})}onVerbose(y){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=h}),define(J[52],Y([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class g{constructor(...I){this._entries=new Map;for(let[L,F]of I)this.set(L,F)}set(I,L){const F=this._entries.get(I);return this._entries.set(I,L),F}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}t.ServiceCollection=g}),define(J[100],Y([0,1,12,94,50,11,52,4]),function(_,t,g,A,I,L,F,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const u=!1;class h extends Error{constructor(c){var f;super("cyclic dependency between services");this.message=(f=c.findCycleSlow())!==null&&f!==void 0?f:`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class S{constructor(c=new F.ServiceCollection,f=!1,b){this._activeInstantiations=new Set,this._services=c,this._strict=f,this._parent=b,this._services.set(L.IInstantiationService,this)}createChild(c){return new S(c,this._strict,this)}invokeFunction(c,...f){let b=w.traceInvocation(c),C=!1;try{return c({get:(m,o)=>{if(C)throw g.illegalState("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(m,b);if(!r&&o!==L.optional)throw new Error(`[invokeFunction] unknown service '${m}'`);return r}},...f)}finally{C=!0,b.stop()}}createInstance(c,...f){let b,C;return c instanceof I.SyncDescriptor?(b=w.traceCreation(c.ctor),C=this._createInstance(c.ctor,c.staticArguments.concat(f),b)):(b=w.traceCreation(c),C=this._createInstance(c,f,b)),b.stop(),C}_createInstance(c,f=[],b){let C=L._util.getServiceDependencies(c).sort((o,r)=>o.index-r.index),D=[];for(const o of C){let r=this._getOrCreateServiceInstance(o.id,b);if(!r&&this._strict&&!o.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${o.id}.`);D.push(r)}let m=C.length>0?C[0].index:f.length;if(f.length!==m){console.warn(`[createInstance] First service dependency of ${c.name} at position ${m+1} conflicts with ${f.length} static arguments`);let o=m-f.length;o>0?f=f.concat(new Array(o)):f=f.slice(0,m)}return new c(...[...f,...D])}_setServiceInstance(c,f){if(this._services.get(c)instanceof I.SyncDescriptor)this._services.set(c,f);else if(this._parent)this._parent._setServiceInstance(c,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let f=this._services.get(c);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):f}_getOrCreateServiceInstance(c,f){let b=this._getServiceInstanceOrDescriptor(c);return b instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,b,f.branch(c,!0)):(f.branch(c,!1),b)}_safeCreateAndCacheServiceInstance(c,f,b){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,f,b)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,f,b){const C=new A.Graph(o=>o.id.toString());let D=0;const m=[{id:c,desc:f,_trace:b}];for(;m.length;){const o=m.pop();if(C.lookupOrInsertNode(o),D++>1e3)throw new h(C);for(let r of L._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(r.id);if(!e&&!r.optional&&console.warn(`[createInstance] ${c} depends on ${r.id} which is NOT registered.`),e instanceof I.SyncDescriptor){const i={id:r.id,desc:e,_trace:o._trace.branch(r.id,!0)};C.insertEdge(o,i),m.push(i)}}}for(;;){const o=C.roots();if(o.length===0){if(!C.isEmpty())throw new h(C);break}for(const{data:r}of o){if(this._getServiceInstanceOrDescriptor(r.id)instanceof I.SyncDescriptor){const i=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,i)}C.removeNode(r)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,f,b=[],C,D){if(this._services.get(c)instanceof I.SyncDescriptor)return this._createServiceInstance(f,b,C,D);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,f,b,C,D);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(c,f=[],b,C){if(b){const D=new R.IdleValue(()=>this._createInstance(c,f,C));return new Proxy(Object.create(null),{get(m,o){if(o in m)return m[o];let r=D.value,e=r[o];return typeof e!="function"||(e=e.bind(r),m[o]=e),e},set(m,o,r){return D.value[o]=r,!0}})}else return this._createInstance(c,f,C)}}t.InstantiationService=S;var y;(function(O){O[O.Creation=0]="Creation",O[O.Invocation=1]="Invocation",O[O.Branch=2]="Branch"})(y||(y={}));class w{constructor(c,f){this.type=c,this.name=f,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return u?new w(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):w._None}static traceCreation(c){return u?new w(0,c.name):w._None}branch(c,f){let b=new w(2,c.toString());return this._dep.push([c,f,b]),b}stop(){let c=Date.now()-this._start;w._totals+=c;let f=!1;function b(D,m){let o=[],r=new Array(D+1).join("	");for(const[e,i,n]of m._dep)if(i&&n){f=!0,o.push(`${r}CREATES -> ${e}`);let s=b(D+1,n);s&&o.push(s)}else o.push(`${r}uses -> ${e}`);return o.join(`
`)}let C=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${w._totals.toFixed(2)}ms)`];(c>2||f)&&console.log(C.join(`
`))}}w._None=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w._totals=0}),define(J[53],Y([0,1,11]),function(_,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=g.createDecorator("localizationsService");function A(I){if(typeof I.languageId!="string"||!Array.isArray(I.translations)||I.translations.length===0)return!1;for(const L of I.translations)if(typeof L.id!="string"||typeof L.path!="string")return!1;return!(I.languageName&&typeof I.languageName!="string"||I.localizedLanguageName&&typeof I.localizedLanguageName!="string")}t.isValidLocalization=A}),define(J[15],Y([0,1,11,2,14,10,28]),function(_,t,g,A,I,L,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=g.createDecorator("logService"),t.ILoggerService=g.createDecorator("loggerService");function R(){return new Date().toISOString()}var u;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(u=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=u.Info;class h extends A.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=h;class S extends h{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(u.Trace)&&this.log(u.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(u.Debug)&&this.log(u.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(u.Info)&&this.log(u.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(u.Warning)&&this.log(u.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(u.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(u.Error,this.format(n))}else this.log(u.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(u.Critical)&&this.log(u.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let s=e[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch(l){}i+=(n>0?" ":"")+s}return i}}t.AbstractMessageLogger=S;class y extends h{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!I.isWindows}trace(e,...i){this.getLevel()<=u.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,e,...i):console.log(`[main ${R()}]`,e,...i))}debug(e,...i){this.getLevel()<=u.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,e,...i):console.log(`[main ${R()}]`,e,...i))}info(e,...i){this.getLevel()<=u.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,e,...i):console.log(`[main ${R()}]`,e,...i))}warn(e,...i){this.getLevel()<=u.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,e,...i):console.warn(`[main ${R()}]`,e,...i))}error(e,...i){this.getLevel()<=u.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,e,...i):console.error(`[main ${R()}]`,e,...i))}critical(e,...i){this.getLevel()<=u.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,e,...i):console.error(`[main ${R()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=y;class w extends h{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=u.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=u.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=u.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=u.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=u.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=u.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=w;class O extends h{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=u.Trace&&this.adapter.log(u.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=u.Debug&&this.adapter.log(u.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=u.Info&&this.adapter.log(u.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=u.Warning&&this.adapter.log(u.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=u.Error&&this.adapter.log(u.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=u.Critical&&this.adapter.log(u.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:F.toErrorMessage(e,this.getLevel()<=u.Trace)}dispose(){}flush(){}}t.AdapterLogger=O;class c extends h{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=c;class f extends A.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=f;class b extends A.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(n))}))}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,(i==null?void 0:i.always)?u.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=b;class C{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(e){}getLevel(){return u.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=C;function D(r){if(r.verbose)return u.Trace;if(typeof r.logLevel=="string"){const e=m(r.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=D;function m(r){switch(r){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Critical;case"off":return u.Off}}t.parseLogLevel=m;function o(r){switch(r){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Critical:return"critical";case u.Off:return"off"}}t.LogLevelToString=o}),define(J[101],Y([0,1,9,2,18,23,21,7,17,24,15,29,39,14,4,12]),function(_,t,g,A,I,L,F,R,u,h,S,y,w,O,c,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let C=class extends A.Disposable{constructor(m,o,r,e){super();this.fileService=o,this.extensionGalleryService=r,this.logService=e,this.extensionsDownloadDir=R.URI.file(m.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(m,o){await this.cleanUpPromise;const r=this.getName(m),e=u.joinPath(this.extensionsDownloadDir,r);if(!await this.fileService.exists(e)){const i=u.joinPath(this.extensionsDownloadDir,`.${y.generateUuid()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(m,i,o);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(s){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",m.identifier.id);else throw this.logService.info(`Rename failed because of ${f.getErrorMessage(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(m){}async rename(m,o,r){try{await g.Promises.rename(m.fsPath,o.fsPath)}catch(e){if(O.isWindows&&e&&e.code==="EPERM"&&Date.now()<r)return this.logService.info(`Failed renaming ${m} to ${o} with 'EPERM' error. Trying again...`),this.rename(m,o,r);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const m=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(m.children){const o=[],r=[];for(const n of m.children){const s=this.parse(n.name);s&&r.push([s,n])}const e=h.groupByExtension(r,([n])=>n),i=[];for(const n of e)n.sort((s,l)=>w.rcompare(s[0].version,l[0].version)),o.push(...n.slice(1).map(s=>s[1].resource)),i.push(n[0][1]);i.sort((n,s)=>n.mtime-s.mtime),o.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await c.Promises.settled(o.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(m){this.logService.error(m)}}getName(m){return this.cache?new h.ExtensionIdentifierWithVersion(m.identifier,m.version).key().toLowerCase():y.generateUuid()}parse(m){const o=b.exec(m);return o&&o[1]&&o[2]?new h.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};C=ue([fe(0,F.INativeEnvironmentService),fe(1,I.IFileService),fe(2,L.IExtensionGalleryService),fe(3,S.ILogService)],C),t.ExtensionsDownloader=C}),define(J[102],Y([0,1,2,15,32,28,3,4,10,8,9,21]),function(_,t,g,A,I,L,F,R,u,h,S,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let w=class extends g.Disposable{constructor(c,f){super();this.environmentService=c,this.logService=f,this.processesLimiter=new R.Limiter(5)}async postUninstall(c){const f=this.parseScript(c,"uninstall");return f&&(this.logService.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(f.script,"uninstall",f.args,!0,c).then(()=>this.logService.info(c.identifier.id,c.manifest.version,"Finished running post uninstall script"),b=>this.logService.error(c.identifier.id,c.manifest.version,`Failed to run post uninstall script: ${b}`)))),S.Promises.rm(this.getExtensionStoragePath(c)).then(void 0,b=>this.logService.error("Error while removing extension storage path",b))}parseScript(c,f){const b=`vscode:${f}`;if(c.location.scheme===h.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[b]=="string"){const C=c.manifest.scripts[b].split(" ");return C.length<2||C[0]!=="node"||!C[1]?(this.logService.warn(c.identifier.id,c.manifest.version,`${b} should be a node script`),null):{script:F.join(c.location.fsPath,C[1]),args:C.slice(2)||[]}}return null}runLifecycleHook(c,f,b,C,D){return new Promise((m,o)=>{const r=this.start(c,f,b,D);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?o(n):m(void 0)};r.on("error",n=>{i(L.toErrorMessage(n)||"Unknown")}),r.on("exit",(n,s)=>{i(n?`post-${f} process exited with code ${n}`:void 0)}),C&&(e=setTimeout(()=>{e=null,r.kill(),o("timed out")},5e3))})}start(c,f,b,C){const D={silent:!0,execArgv:void 0},m=I.fork(c,[`--type=extension-post-${f}`,...b],D);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const o=u.Event.fromNodeEventEmitter(m.stdout,"data"),r=u.Event.fromNodeEventEmitter(m.stderr,"data");o(n=>this.logService.info(C.identifier.id,C.manifest.version,`post-${f}`,n)),r(n=>this.logService.error(C.identifier.id,C.manifest.version,`post-${f}`,n));const e=u.Event.any(u.Event.map(o,n=>({data:`%c${n}`,format:[""]})),u.Event.map(r,n=>({data:`%c${n}`,format:["color: red"]})));return u.Event.debounce(e,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(C.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),m}getExtensionStoragePath(c){return F.join(this.environmentService.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};w=ue([fe(0,y.IEnvironmentService),fe(1,A.ILogService)],w),t.ExtensionsLifecycle=w}),define(J[103],Y([0,1,2,21,10,18,7,24,17,15]),function(_,t,g,A,I,L,F,R,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let S=class extends g.Disposable{constructor(w,O,c,f){super();this.extensionsManagementService=w,this.logService=f,this._onDidChangeExtensionsByAnotherSource=this._register(new I.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(D=>{this.installedExtensions=D.map(m=>m.identifier),this.startTimestamp=Date.now()}),this._register(w.onInstallExtension(D=>this.onInstallExtension(D))),this._register(w.onDidInstallExtension(D=>this.onDidInstallExtension(D))),this._register(w.onDidUninstallExtension(D=>this.onDidUninstallExtension(D)));const b=F.URI.file(c.extensionsPath),C=new u.ExtUri(D=>!O.hasCapability(D,1024));this._register(O.watch(b)),this._register(I.Event.filter(O.onDidChangeFilesRaw,D=>D.changes.some(m=>this.doesChangeAffects(m,b,C)))(()=>this.onDidChange()))}doesChangeAffects(w,O,c){return c.isEqual(c.dirname(w.resource),O)?c.isEqual(w.resource,c.joinPath(O,".obsolete"))?!0:!(w.type!==1&&w.type!==2||c.basename(w.resource).startsWith(".")):!1}onInstallExtension(w){this.addInstallingExtension(w.identifier)}onDidInstallExtension(w){this.removeInstallingExtension(w.identifier),w.error||this.addInstalledExtension(w.identifier)}onDidUninstallExtension(w){w.error||this.removeInstalledExtension(w.identifier)}addInstallingExtension(w){this.removeInstallingExtension(w),this.installingExtensions.push(w)}removeInstallingExtension(w){this.installingExtensions=this.installingExtensions.filter(O=>!R.areSameExtensions(O,w))}addInstalledExtension(w){this.installedExtensions&&(this.removeInstalledExtension(w),this.installedExtensions.push(w))}removeInstalledExtension(w){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(O=>!R.areSameExtensions(O,w)))}async onDidChange(){if(this.installedExtensions){const w=await this.extensionsManagementService.getInstalled(1),O=w.filter(f=>[...this.installingExtensions,...this.installedExtensions].some(b=>R.areSameExtensions(b,f.identifier))?!1:f.installedTimestamp&&f.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",f.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",f.identifier.id),!1)),c=this.installedExtensions.filter(f=>this.installingExtensions.some(b=>R.areSameExtensions(b,f))?!1:w.every(b=>!R.areSameExtensions(b.identifier,f))?(this.logService.info("Detected extension removed from another source",f.id),!0):!1);this.installedExtensions=w.map(f=>f.identifier),(O.length||c.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:O,removed:c})}}};S=ue([fe(1,L.IFileService),fe(2,A.INativeEnvironmentService),fe(3,h.ILogService)],S),t.ExtensionsWatcher=S}),define(J[104],Y([0,1,9,127,23,2,21,4,24,15,53,22,10,8,3]),function(_,t,g,A,I,L,F,R,u,h,S,y,w,O,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let f=class extends L.Disposable{constructor(D,m,o){super();this.extensionManagementService=D,this.logService=o,this._onDidLanguagesChange=this._register(new w.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new b(m,o)),this._register(D.onDidInstallExtension(({local:r})=>this.onDidInstallExtension(r))),this._register(D.onDidUninstallExtension(({identifier:r})=>this.onDidUninstallExtension(r)))}getLanguageIds(){return this.cache.getLanguagePacks().then(D=>{const m=["en",...Object.keys(D)];return y.distinct(m)})}onDidInstallExtension(D){D&&D.manifest&&D.manifest.contributes&&D.manifest.contributes.localizations&&D.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",D.identifier.id),this.update().then(m=>{m&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(D){this.cache.getLanguagePacks().then(m=>{Object.keys(m).some(o=>m[o]&&m[o].extensions.some(r=>u.areSameExtensions(r.extensionIdentifier,D)))&&(this.logService.debug("Removing language packs from the extension",D.id),this.update().then(o=>{o&&this._onDidLanguagesChange.fire()}))})}async update(){const[D,m]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),o=await this.cache.update(m);return!y.equals(Object.keys(D),Object.keys(o))}};f=ue([fe(0,I.IExtensionManagementService),fe(1,F.INativeEnvironmentService),fe(2,h.ILogService)],f),t.LocalizationsService=f;let b=class extends L.Disposable{constructor(D,m){super();this.logService=m,this.languagePacks={},this.languagePacksFilePath=c.join(D.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(D){return this.withLanguagePacks(m=>{Object.keys(m).forEach(o=>delete m[o]),this.createLanguagePacksFromExtensions(m,...D)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(D,...m){for(const o of m)o&&o.manifest&&o.manifest.contributes&&o.manifest.contributes.localizations&&o.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(D,o);Object.keys(D).forEach(o=>this.updateHash(D[o]))}createLanguagePacksFromExtension(D,m){const o=m.identifier,r=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const e of r)if(m.location.scheme===O.Schemas.file&&S.isValidLocalization(e)){let i=D[e.languageId];i||(i={hash:"",extensions:[],translations:{}},D[e.languageId]=i);let n=i.extensions.filter(s=>u.areSameExtensions(s.extensionIdentifier,o))[0];n?n.version=m.manifest.version:i.extensions.push({extensionIdentifier:o,version:m.manifest.version});for(const s of e.translations)i.translations[s.id]=c.join(m.location.fsPath,s.path)}}updateHash(D){if(D){const m=A.createHash("md5");for(const o of D.extensions)m.update(o.extensionIdentifier.uuid||o.extensionIdentifier.id).update(o.version);D.hash=m.digest("hex")}}withLanguagePacks(D=()=>null){return this.languagePacksFileLimiter.queue(()=>{let m=null;return g.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,o=>o.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(o)).then(o=>{try{return JSON.parse(o)}catch(r){return{}}}).then(o=>(m=D(o),o)).then(o=>{for(const e of Object.keys(o))o[e]||delete o[e];this.languagePacks=o,this.initializedCache=!0;const r=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",r),g.Promises.writeFile(this.languagePacksFilePath,r)}).then(()=>m,o=>this.logService.error(o))})}};b=ue([fe(0,F.INativeEnvironmentService),fe(1,h.ILogService)],b)}),define(J[105],Y([0,1,15,18]),function(_,t,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function I(u,h,S,y){try{const w=await new Promise((O,c)=>{_(["spdlog"],O,c)});return w.setFlushOn(g.LogLevel.Trace),w.createAsyncRotatingLogger(u,h,S,y)}catch(w){console.error(w)}return null}function L(u,h,S,y){const w=_.__$__nodeRequire("spdlog");return w.setFlushOn(g.LogLevel.Trace),w.createRotatingLogger(u,h,S,y)}t.createRotatingLogger=L;function F(u,h,S){switch(h){case g.LogLevel.Trace:u.trace(S);break;case g.LogLevel.Debug:u.debug(S);break;case g.LogLevel.Info:u.info(S);break;case g.LogLevel.Warning:u.warn(S);break;case g.LogLevel.Error:u.error(S);break;case g.LogLevel.Critical:u.critical(S);break;default:throw new Error("Invalid log level")}}class R extends g.AbstractMessageLogger{constructor(h,S,y,w){super();this.name=h,this.filepath=S,this.rotating=y,this.buffer=[],this.setLevel(w),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(O=>{this._logger&&this._logger.setLevel(O)}))}_createSpdLogLogger(){const h=this.rotating?6:1,S=30/h*A.ByteSize.MB;return I(this.name,this.filepath,S,h).then(y=>{if(y){this._logger=y,this._logger.setLevel(this.getLevel());for(const{level:w,message:O}of this.buffer)F(this._logger,w,O);this.buffer=[]}})}log(h,S){this._logger?F(this._logger,h,S):this.getLevel()<=h&&this.buffer.push({level:h,message:S})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=R}),define(J[54],Y([0,1,81,16,18,12,40]),function(_,t,g,A,I,L,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function R(y,w,O,c,f,b){let C;try{await u(y,w,O,c,f,b)}catch(D){C=D}finally{C&&f.errorTransformer&&(C=f.errorTransformer(C)),typeof C!="undefined"&&O.error(C),O.end()}}t.readFileIntoStream=R;async function u(y,w,O,c,f,b){h(b);const C=await y.open(w,{create:!1});try{h(b);let D=0,m=0,o=f&&typeof f.length=="number"?f.length:void 0,r=A.VSBuffer.alloc(Math.min(f.bufferSize,typeof o=="number"?o:f.bufferSize)),e=f&&typeof f.position=="number"?f.position:0,i=0;do m=await y.read(C,e,r.buffer,i,r.byteLength-i),e+=m,i+=m,D+=m,typeof o=="number"&&(o-=m),i===r.byteLength&&(await O.write(c(r)),r=A.VSBuffer.alloc(Math.min(f.bufferSize,typeof o=="number"?o:f.bufferSize)),i=0);while(m>0&&(typeof o!="number"||o>0)&&h(b)&&S(D,f));if(i>0){let n=i;typeof o=="number"&&(n=Math.min(i,o)),O.write(c(r.slice(0,n)))}}catch(D){throw I.ensureFileSystemProviderError(D)}finally{await y.close(C)}}function h(y){if(y.isCancellationRequested)throw L.canceled();return!0}function S(y,w){if(w==null?void 0:w.limits){if(typeof w.limits.memory=="number"&&y>w.limits.memory)throw I.createFileSystemProviderError(g.localize(0,null,F.default.nameShort),I.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&y>w.limits.size)throw I.createFileSystemProviderError(g.localize(1,null),I.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[106],Y([0,1,80,128,2,18,10,17,45,22,15,16,34,4,26,8,54,129]),function(_,t,g,A,I,L,F,R,u,h,S,y,w,O,c,f,b,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let D=class Me extends I.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new F.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new F.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new F.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new F.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new F.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new F.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new F.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new O.ThrottledWorker(Me.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Me.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Me.FILE_EVENTS_THROTTLING.coolDownDelay,r=>this._onDidFilesChange.fire(new L.FileChangesEvent(r,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new O.ThrottledWorker(Me.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Me.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Me.FILE_EVENTS_THROTTLING.coolDownDelay,r=>this._onDidFilesChange.fire(new L.FileChangesEvent(r,!0)))),this.watchedResources=u.TernarySearchTree.forUris(r=>{const e=this.getProvider(r.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new O.ResourceQueue)}registerProvider(o,r){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);A.mark(`code/registerFilesystem/${o}`),this.provider.set(o,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:r});const e=new I.DisposableStore;return e.add(r.onDidChangeFile(i=>this.onDidChangeFile(i,this.isPathCaseSensitive(r)))),e.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:o}))),typeof r.onDidErrorOccur=="function"&&e.add(r.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),I.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:r}),this.provider.delete(o),I.dispose(e)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){r.push(e)}}),!this.provider.has(o)&&await O.Promises.settled(r)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,r){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&r)}listCapabilities(){return C.Iterable.map(this.provider,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async withProvider(o){if(!R.isAbsolutePath(o))throw new L.FileOperationError(g.localize(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const r=this.provider.get(o.scheme);if(!r){const e=new Error;throw e.name="ENOPRO",e.message=g.localize(1,null,o.toString()),e}return r}async withReadProvider(o){const r=await this.withProvider(o);if(L.hasOpenReadWriteCloseCapability(r)||L.hasReadWriteCapability(r)||L.hasFileReadStreamCapability(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const r=await this.withProvider(o);if(L.hasOpenReadWriteCloseCapability(r)||L.hasReadWriteCapability(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.doResolveFile(o,r)}catch(e){throw L.toFileSystemProviderErrorCode(e)===L.FileSystemProviderErrorCode.FileNotFound?new L.FileOperationError(g.localize(2,null,this.resourceForError(o)),1):L.ensureFileSystemProviderError(e)}}async doResolveFile(o,r){const e=await this.withProvider(o),i=this.isPathCaseSensitive(e),n=r==null?void 0:r.resolveTo,s=r==null?void 0:r.resolveSingleChildDescendants,l=r==null?void 0:r.resolveMetadata,E=await e.stat(o);let P;return this.toFileStat(e,o,E,void 0,!!l,(U,k)=>(P||(P=u.TernarySearchTree.forUris(()=>!i),P.set(o,!0),h.isNonEmptyArray(n)&&n.forEach(j=>P.set(j,!0))),Boolean(P.findSuperstr(U.resource)||P.get(U.resource))?!0:U.isDirectory&&s?k===1:!1))}async toFileStat(o,r,e,i,n,s){var l;const{providerExtUri:E}=this.getExtUri(o),P={resource:r,name:E.basename(r),isFile:(e.type&L.FileType.File)!=0,isDirectory:(e.type&L.FileType.Directory)!=0,isSymbolicLink:(e.type&L.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean(((l=e.permissions)!==null&&l!==void 0?l:0)&L.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:L.etag({mtime:e.mtime,size:e.size})};if(P.isDirectory&&s(P,i)){try{const U=await o.readdir(r),k=await O.Promises.settled(U.map(async([j,V])=>{try{const $=E.joinPath(r,j),K=n?await o.stat($):{type:V};return await this.toFileStat(o,$,K,U.length,n,s)}catch($){return this.logService.trace($),null}}));P.children=h.coalesce(k)}catch(U){this.logService.trace(U),P.children=[]}return P}return P}async resolveAll(o){return O.Promises.settled(o.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const r=await this.withProvider(o);try{return!!await r.stat(o)}catch(e){return!1}}async canCreateFile(o,r){try{await this.doValidateCreateFile(o,r)}catch(e){return e}return!0}async doValidateCreateFile(o,r){if(!(r==null?void 0:r.overwrite)&&await this.exists(o))throw new L.FileOperationError(g.localize(3,null,this.resourceForError(o)),3,r)}async createFile(o,r=y.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const i=await this.writeFile(o,r);return this._onDidRunOperation.fire(new L.FileOperationEvent(o,0,i)),i}async writeFile(o,r,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,o,e)||await this.mkdirp(i,n.dirname(o));let l;if(L.hasReadWriteCapability(i)&&!(r instanceof y.VSBuffer))if(w.isReadableStream(r)){const E=await w.peekStream(r,3);E.ended?l=y.VSBuffer.concat(E.buffer):l=E}else l=w.peekReadable(r,E=>y.VSBuffer.concat(E),3);else l=r;!L.hasOpenReadWriteCloseCapability(i)||L.hasReadWriteCapability(i)&&l instanceof y.VSBuffer?await this.doWriteUnbuffered(i,o,e,l):await this.doWriteBuffered(i,o,e,l instanceof y.VSBuffer?y.bufferToReadable(l):l)}catch(s){throw new L.FileOperationError(g.localize(4,null,this.resourceForError(o),L.ensureFileSystemProviderError(s).toString()),L.toFileOperationResult(s),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,r,e){if(!!(e==null?void 0:e.unlock)&&!(o.capabilities&8192))throw new Error(g.localize(5,null,this.resourceForError(r)));let n;try{n=await o.stat(r)}catch(s){return}if((n.type&L.FileType.Directory)!=0)throw new L.FileOperationError(g.localize(6,null,this.resourceForError(r)),0,e);if(this.throwIfFileIsReadonly(r,n),e&&typeof e.mtime=="number"&&typeof e.etag=="string"&&e.etag!==L.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==L.etag({mtime:e.mtime,size:n.size}))throw new L.FileOperationError(g.localize(7,null),3,e);return n}async readFile(o,r){const e=await this.withReadProvider(o);return(r==null?void 0:r.atomic)?this.doReadFileAtomic(e,o,r):this.doReadFile(e,o,r)}async doReadFileAtomic(o,r,e){return new Promise((i,n)=>{this.writeQueue.queueFor(r,this.getExtUri(o).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(o,r,e);i(s)}catch(s){n(s)}})})}async doReadFile(o,r,e){const i=await this.doReadFileStream(o,r,Object.assign(Object.assign({},e),{preferUnbuffered:!0}));return Object.assign(Object.assign({},i),{value:await y.streamToBuffer(i.value)})}async readFileStream(o,r){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,r)}async doReadFileStream(o,r,e){const i=new c.CancellationTokenSource,n=this.validateReadFile(r,e).then(l=>l,l=>{throw i.cancel(),l});let s;try{e&&typeof e.etag=="string"&&e.etag!==L.ETAG_DISABLED&&await n,!(L.hasOpenReadWriteCloseCapability(o)||L.hasFileReadStreamCapability(o))||L.hasReadWriteCapability(o)&&(e==null?void 0:e.preferUnbuffered)?s=this.readFileUnbuffered(o,r,e):L.hasFileReadStreamCapability(o)?s=this.readFileStreamed(o,r,i.token,e):s=this.readFileBuffered(o,r,i.token,e);const l=await n;return Object.assign(Object.assign({},l),{value:s})}catch(l){s&&await w.consumeStream(s);const E=g.localize(8,null,this.resourceForError(r),L.ensureFileSystemProviderError(l).toString());throw l instanceof L.NotModifiedSinceFileOperationError?new L.NotModifiedSinceFileOperationError(E,l.stat,e):new L.FileOperationError(E,L.toFileOperationResult(l),e)}}readFileStreamed(o,r,e,i=Object.create(null)){const n=o.readFileStream(r,i,e);return w.transform(n,{data:s=>s instanceof y.VSBuffer?s:y.VSBuffer.wrap(s),error:s=>new L.FileOperationError(g.localize(9,null,this.resourceForError(r),L.ensureFileSystemProviderError(s).toString()),L.toFileOperationResult(s),i)},s=>y.VSBuffer.concat(s))}readFileBuffered(o,r,e,i=Object.create(null)){const n=y.newWriteableBufferStream();return b.readFileIntoStream(o,r,n,s=>s,Object.assign(Object.assign({},i),{bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new L.FileOperationError(g.localize(10,null,this.resourceForError(r),L.ensureFileSystemProviderError(s).toString()),L.toFileOperationResult(s),i)}),e),n}readFileUnbuffered(o,r,e){const i=w.newWriteableStream(n=>y.VSBuffer.concat(n));return(async()=>{try{let n=await o.readFile(r);e&&typeof e.position=="number"&&(n=n.slice(e.position)),e&&typeof e.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(r,n.byteLength,e),i.end(y.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(o,r){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new L.FileOperationError(g.localize(11,null,this.resourceForError(o)),0,r);if(r&&typeof r.etag=="string"&&r.etag!==L.ETAG_DISABLED&&r.etag===e.etag)throw new L.NotModifiedSinceFileOperationError(g.localize(12,null),e,r);return this.validateReadFileLimits(o,e.size,r),e}validateReadFileLimits(o,r,e){if(e==null?void 0:e.limits){let i;if(typeof e.limits.memory=="number"&&r>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&r>e.limits.size&&(i=7),typeof i=="number")throw new L.FileOperationError(g.localize(13,null,this.resourceForError(o)),i)}}async canMove(o,r,e){return this.doCanMoveCopy(o,r,"move",e)}async canCopy(o,r,e){return this.doCanMoveCopy(o,r,"copy",e)}async doCanMoveCopy(o,r,e,i){if(o.toString()!==r.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(n,o,s,r,e,i)}catch(n){return n}return!0}async move(o,r,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(i,o,n,r,"move",!!e),l=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new L.FileOperationEvent(o,s==="move"?2:3,l)),l}async copy(o,r,e){const i=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(i,o,n,r,"copy",!!e),l=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new L.FileOperationEvent(o,s==="copy"?3:2,l)),l}async doMoveCopy(o,r,e,i,n,s){if(r.toString()===i.toString())return n;const{exists:l,isSameResourceWithDifferentPathCase:E}=await this.doValidateMoveCopy(o,r,e,i,n,s);if(l&&!E&&s&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(o===e&&L.hasFileFolderCopyCapability(o))await o.copy(r,i,{overwrite:s});else{const P=await this.resolve(r);P.isDirectory?await this.doCopyFolder(o,P,e,i):await this.doCopyFile(o,r,e,i)}return n}else return o===e?(await o.rename(r,i,{overwrite:s}),n):(await this.doMoveCopy(o,r,e,i,"copy",s),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(o,r,e,i){if(L.hasOpenReadWriteCloseCapability(o)&&L.hasOpenReadWriteCloseCapability(e))return this.doPipeBuffered(o,r,e,i);if(L.hasOpenReadWriteCloseCapability(o)&&L.hasReadWriteCapability(e))return this.doPipeBufferedToUnbuffered(o,r,e,i);if(L.hasReadWriteCapability(o)&&L.hasOpenReadWriteCloseCapability(e))return this.doPipeUnbufferedToBuffered(o,r,e,i);if(L.hasReadWriteCapability(o)&&L.hasReadWriteCapability(e))return this.doPipeUnbuffered(o,r,e,i)}async doCopyFolder(o,r,e,i){await e.mkdir(i),Array.isArray(r.children)&&await O.Promises.settled(r.children.map(async n=>{const s=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),e,s):this.doCopyFile(o,n.resource,e,s)}))}async doValidateMoveCopy(o,r,e,i,n,s){let l=!1;if(o===e){const{providerExtUri:P,isPathCaseSensitive:U}=this.getExtUri(o);if(U||(l=P.isEqual(r,i)),l&&n==="copy")throw new Error(g.localize(14,null,this.resourceForError(r),this.resourceForError(i)));if(!l&&P.isEqualOrParent(i,r))throw new Error(g.localize(15,null,this.resourceForError(r),this.resourceForError(i)))}const E=await this.exists(i);if(E&&!l){if(!s)throw new L.FileOperationError(g.localize(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(o===e){const{providerExtUri:P}=this.getExtUri(o);if(P.isEqualOrParent(r,i))throw new Error(g.localize(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:E,isSameResourceWithDifferentPathCase:l}}getExtUri(o){const r=this.isPathCaseSensitive(o);return{providerExtUri:r?R.extUri:R.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(r,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new L.FileOperationEvent(o,0,e)),e}async mkdirp(o,r){const e=[],{providerExtUri:i}=this.getExtUri(o);for(;!i.isEqual(r,i.dirname(r));)try{if(((await o.stat(r)).type&L.FileType.Directory)==0)throw new Error(g.localize(18,null,this.resourceForError(r)));break}catch(n){if(L.toFileSystemProviderErrorCode(n)!==L.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(r)),r=i.dirname(r)}for(let n=e.length-1;n>=0;n--){r=i.joinPath(r,e[n]);try{await o.mkdir(r)}catch(s){if(L.toFileSystemProviderErrorCode(s)!==L.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,r){try{await this.doValidateDelete(o,r)}catch(e){return e}return!0}async doValidateDelete(o,r){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!(r==null?void 0:r.useTrash)&&!(e.capabilities&4096))throw new Error(g.localize(19,null,this.resourceForError(o)));let n;try{n=await e.stat(o)}catch(l){}if(n)this.throwIfFileIsReadonly(o,n);else throw new L.FileOperationError(g.localize(20,null,this.resourceForError(o)),1);if(!!!(r==null?void 0:r.recursive)){const l=await this.resolve(o);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error(g.localize(21,null,this.resourceForError(o)))}return e}async del(o,r){const e=await this.doValidateDelete(o,r),i=!!(r==null?void 0:r.useTrash),n=!!(r==null?void 0:r.recursive);await e.delete(o,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new L.FileOperationEvent(o,1))}onDidChangeFile(o,r){this._onDidChangeFilesRaw.fire({changes:o});let e,i;{for(const n of o)this.watchedResources.has(n.resource)?(e||(e=[]),e.push(n)):(i||(i=[]),i.push(n));e&&this._onDidFilesChange.fire(new L.FileChangesEvent(e,!r))}if(i){const n=r?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(i)&&Me.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,r={recursive:!1,excludes:[]}){var e;const i=new I.DisposableStore;{let n=!1,s=()=>{n=!0};i.add(I.toDisposable(()=>s())),this.doWatch(o,r).then(l=>{n?I.dispose(l):s=()=>I.dispose(l)},l=>this.logService.error(l))}return r.recursive||(this.watchedResources.set(o,((e=this.watchedResources.get(o))!==null&&e!==void 0?e:0)+1),i.add(I.toDisposable(()=>{const n=this.watchedResources.get(o);typeof n=="number"&&(n<=1?this.watchedResources.delete(o):this.watchedResources.set(o,n-1))}))),i}async doWatch(o,r){const e=await this.withProvider(o),i=this.toWatchKey(e,o,r),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(o,r)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,I.toDisposable(()=>{n.count--,n.count===0&&(I.dispose(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(o,r,e){const{providerExtUri:i}=this.getExtUri(o);return[i.getComparisonKey(r),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(o=>I.dispose(o.disposable)),this.activeWatchers.clear()}async doWriteBuffered(o,r,e,i){return this.writeQueue.queueFor(r,this.getExtUri(o).providerExtUri).queue(async()=>{var n;const s=await o.open(r,{create:!0,unlock:(n=e==null?void 0:e.unlock)!==null&&n!==void 0?n:!1});try{w.isReadableStream(i)||w.isReadableBufferedStream(i)?await this.doWriteStreamBufferedQueued(o,s,i):await this.doWriteReadableBufferedQueued(o,s,i)}catch(l){throw L.ensureFileSystemProviderError(l)}finally{await o.close(s)}})}async doWriteStreamBufferedQueued(o,r,e){let i=0,n;if(w.isReadableBufferedStream(e)){if(e.buffer.length>0){const s=y.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,r,s,s.byteLength,i,0),i+=s.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise(async(s,l)=>{w.listenStream(n,{onData:async E=>{n.pause();try{await this.doWriteBuffer(o,r,E,E.byteLength,i,0)}catch(P){return l(P)}i+=E.byteLength,setTimeout(()=>n.resume())},onError:E=>l(E),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(o,r,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(o,r,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(o,r,e,i,n,s){let l=0;for(;l<i;)l+=await o.write(r,n+l,e.buffer,s+l,i-l)}async doWriteUnbuffered(o,r,e,i){return this.writeQueue.queueFor(r,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,r,e,i))}async doWriteUnbufferedQueued(o,r,e,i){var n;let s;i instanceof y.VSBuffer?s=i:w.isReadableStream(i)?s=await y.streamToBuffer(i):w.isReadableBufferedStream(i)?s=await y.bufferedStreamToBuffer(i):s=y.readableToBuffer(i),await o.writeFile(r,s.buffer,{create:!0,overwrite:!0,unlock:(n=e==null?void 0:e.unlock)!==null&&n!==void 0?n:!1})}async doPipeBuffered(o,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,r,e,i))}async doPipeBufferedQueued(o,r,e,i){let n,s;try{n=await o.open(r,{create:!1}),s=await e.open(i,{create:!0,unlock:!1});const l=y.VSBuffer.alloc(this.BUFFER_SIZE);let E=0,P=0,U=0;do U=await o.read(n,E,l.buffer,P,l.byteLength-P),await this.doWriteBuffer(e,s,l,U,E,P),E+=U,P+=U,P===l.byteLength&&(P=0);while(U>0)}catch(l){throw L.ensureFileSystemProviderError(l)}finally{await O.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof s=="number"?e.close(s):Promise.resolve()])}}async doPipeUnbuffered(o,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,r,e,i))}async doPipeUnbufferedQueued(o,r,e,i){return e.writeFile(i,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,r,e,i))}async doPipeUnbufferedToBufferedQueued(o,r,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const s=await o.readFile(r);await this.doWriteBuffer(e,n,y.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw L.ensureFileSystemProviderError(s)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(o,r,e,i){const n=await y.streamToBuffer(this.readFileBuffered(o,r,c.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(o,r){if(o.capabilities&2048)throw new L.FileOperationError(g.localize(22,null,this.resourceForError(r)),6);return o}throwIfFileIsReadonly(o,r){var e;if(((e=r.permissions)!==null&&e!==void 0?e:0)&L.FilePermission.Readonly)throw new L.FileOperationError(g.localize(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===f.Schemas.file?o.fsPath:o.toString(!0)}};D.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},D=ue([fe(0,S.ILogService)],D),t.FileService=D}),define(J[107],Y([0,1,2,18,10,14,9,3,17,35,4,15,82,51,91,93,90,99,34,54,22,16]),function(_,t,g,A,I,L,F,R,u,h,S,y,w,O,c,f,b,C,D,m,o,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class e extends g.Disposable{constructor(n,s){var l;super();this.logService=n,this.options=s,this.BUFFER_SIZE=((l=this.options)===null||l===void 0?void 0:l.bufferSize)||64*1024,this.onDidChangeCapabilities=I.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new I.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new S.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,L.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:s,symbolicLink:l}=await F.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(s,l),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(n){try{const s=await F.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),l=[];return await Promise.all(s.map(async E=>{try{let P;E.isSymbolicLink()?P=(await this.stat(u.joinPath(n,E.name))).type:P=this.toType(E),l.push([E.name,P])}catch(P){this.logService.trace(P)}})),l}catch(s){throw this.toFileSystemProviderError(s)}}toType(n,s){let l;return(s==null?void 0:s.dangling)?l=A.FileType.Unknown:n.isFile()?l=A.FileType.File:n.isDirectory()?l=A.FileType.Directory:l=A.FileType.Unknown,s&&(l|=A.FileType.SymbolicLink),l}async readFile(n){try{const s=this.toFilePath(n);return await F.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}}readFileStream(n,s,l){const E=D.newWriteableStream(P=>r.VSBuffer.concat(P.map(U=>r.VSBuffer.wrap(U))).buffer);return m.readFileIntoStream(this,n,E,P=>P.buffer,Object.assign(Object.assign({},s),{bufferSize:this.BUFFER_SIZE}),l),E}async writeFile(n,s,l){let E;try{const P=this.toFilePath(n);if(!l.create||!l.overwrite){if(await F.Promises.exists(P)){if(!l.overwrite)throw A.createFileSystemProviderError(w.localize(0,null),A.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw A.createFileSystemProviderError(w.localize(1,null),A.FileSystemProviderErrorCode.FileNotFound)}E=await this.open(n,{create:!0,unlock:l.unlock}),await this.write(E,0,s,0,s.byteLength)}catch(P){throw await this.toFileSystemProviderWriteError(n,P)}finally{typeof E=="number"&&await this.close(E)}}async open(n,s){try{const l=this.toFilePath(n);if(A.isFileOpenForWriteOptions(s)&&s.unlock)try{const{stat:U}=await F.SymlinkSupport.stat(l);U.mode&128||await F.Promises.chmod(l,U.mode|128)}catch(U){this.logService.trace(U)}let E;if(A.isFileOpenForWriteOptions(s)){if(L.isWindows)try{await F.Promises.truncate(l,0),E="r+"}catch(U){U.code!=="ENOENT"&&this.logService.trace(U)}E||(E="w")}else E="r";const P=await F.Promises.open(l,E);return this.mapHandleToPos.set(P,0),A.isFileOpenForWriteOptions(s)&&this.writeHandles.set(P,n),P}catch(l){throw A.isFileOpenForWriteOptions(s)?await this.toFileSystemProviderWriteError(n,l):this.toFileSystemProviderError(l)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await F.Promises.fdatasync(n)}catch(s){this.canFlush=!1,this.logService.error(s)}return await F.Promises.close(n)}catch(s){throw this.toFileSystemProviderError(s)}}async read(n,s,l,E,P){const U=this.normalizePos(n,s);let k=null;try{const j=await F.Promises.read(n,l,E,P,U);return typeof j=="number"?k=j:k=j.bytesRead,k}catch(j){throw this.toFileSystemProviderError(j)}finally{this.updatePos(n,U,k)}}normalizePos(n,s){return s===this.mapHandleToPos.get(n)?null:s}updatePos(n,s,l){const E=this.mapHandleToPos.get(n);typeof E=="number"&&(typeof s=="number"||(typeof l=="number"?this.mapHandleToPos.set(n,E+l):this.mapHandleToPos.delete(n)))}async write(n,s,l,E,P){return S.retry(()=>this.doWrite(n,s,l,E,P),100,3)}async doWrite(n,s,l,E,P){const U=this.normalizePos(n,s);let k=null;try{const j=await F.Promises.write(n,l,E,P,U);return typeof j=="number"?k=j:k=j.bytesWritten,k}catch(j){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),j)}finally{this.updatePos(n,U,k)}}async mkdir(n){try{await F.Promises.mkdir(this.toFilePath(n))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(n,s){try{const l=this.toFilePath(n);await this.doDelete(l,s)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(n,s){s.recursive?await F.Promises.rm(n,F.RimRafMode.MOVE):await F.Promises.unlink(n)}async rename(n,s,l){const E=this.toFilePath(n),P=this.toFilePath(s);if(E!==P)try{await this.validateTargetDeleted(n,s,"move",l.overwrite),await F.Promises.move(E,P)}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error(w.localize(2,null,R.basename(E),R.basename(R.dirname(P)),U.toString()))),this.toFileSystemProviderError(U)}}async copy(n,s,l){const E=this.toFilePath(n),P=this.toFilePath(s);if(E!==P)try{await this.validateTargetDeleted(n,s,"copy",l.overwrite),await F.Promises.copy(E,P,{preserveSymlinks:!0})}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error(w.localize(3,null,R.basename(E),R.basename(R.dirname(P)),U.toString()))),this.toFileSystemProviderError(U)}}async validateTargetDeleted(n,s,l,E){const P=this.toFilePath(n),U=this.toFilePath(s);let k=!1;if(!!(this.capabilities&1024)||(k=h.isEqual(P,U,!0)),k&&l==="copy")throw A.createFileSystemProviderError(w.localize(4,null),A.FileSystemProviderErrorCode.FileExists);if(!k&&await F.Promises.exists(U)){if(!E)throw A.createFileSystemProviderError(w.localize(5,null),A.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}watch(n,s){return s.recursive?this.watchRecursive(n,s.excludes):this.watchNonRecursive(n)}watchRecursive(n,s){const l={path:this.toFilePath(n),excludes:s},E=o.insert(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),g.toDisposable(()=>{E(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var n,s,l;if(this.recursiveWatcher instanceof b.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(g.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let E,P;((s=(n=this.options)===null||n===void 0?void 0:n.watcher)===null||s===void 0?void 0:s.usePolling)?(E=c.FileWatcher,P=(l=this.options)===null||l===void 0?void 0:l.watcher):this.recursiveFoldersToWatch.length===1?L.isWindows?E=f.FileWatcher:E=c.FileWatcher:E=b.FileWatcher,this.recursiveWatcher=new E(this.recursiveFoldersToWatch,U=>this._onDidChangeFile.fire(O.toFileChanges(U)),U=>{U.type==="error"&&this._onDidWatchErrorOccur.fire(U.message),this.logService[U.type](U.message)},this.logService.getLevel()===y.LogLevel.Trace,P),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)}))}}watchNonRecursive(n){const s=new C.FileWatcher(this.toFilePath(n),E=>this._onDidChangeFile.fire(O.toFileChanges(E)),E=>{E.type==="error"&&this._onDidWatchErrorOccur.fire(E.message),this.logService[E.type](E.message)},this.logService.getLevel()===y.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{s.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)});return g.combinedDisposable(s,l)}toFilePath(n){return R.normalize(n.fsPath)}toFileSystemProviderError(n){if(n instanceof A.FileSystemProviderError)return n;let s;switch(n.code){case"ENOENT":s=A.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=A.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=A.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=A.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=A.FileSystemProviderErrorCode.NoPermissions;break;default:s=A.FileSystemProviderErrorCode.Unknown}return A.createFileSystemProviderError(n,s)}async toFileSystemProviderWriteError(n,s){let l=this.toFileSystemProviderError(s);if(n&&l.code===A.FileSystemProviderErrorCode.NoPermissions)try{const{stat:E}=await F.SymlinkSupport.stat(this.toFilePath(n));E.mode&128||(l=A.createFileSystemProviderError(s,A.FileSystemProviderErrorCode.FileWriteLocked))}catch(E){this.logService.trace(E)}return l}dispose(){super.dispose(),g.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,g.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=e}),define(J[41],Y([0,1,11]),function(_,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=g.createDecorator("productService")}),define(J[25],Y([0,1,13,57]),function(_,t,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class I{constructor(){this.data=new Map}add(F,R){A.ok(g.isString(F)),A.ok(g.isObject(R)),A.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,R)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}t.Registry=new I}),define(J[108],Y([0,1,25,10]),function(_,t,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function I(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class L{constructor(){this._onDidChangeSchema=new A.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,h){this.schemasById[I(u)]=h,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new L;g.Registry.add(t.Extensions.JSONContribution,F)}),define(J[30],Y([0,1,73,10,25,13,108]),function(_,t,g,A,I,L,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=void 0,t.Extensions={Configuration:"base.contributions.configuration"};var R;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const u=I.Registry.as(F.Extensions.JSONContribution);class h{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new A.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new A.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:g.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},u.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(C,D=!0){this.registerConfigurations([C],D)}registerConfigurations(C,D=!0){const m=[];C.forEach(o=>{m.push(...this.validateAndRegisterProperties(o,D,o.extensionInfo)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),u.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(m)}deregisterConfigurations(C){const D=[],m=o=>{if(o.properties)for(const r in o.properties)D.push(r),delete this.configurationProperties[r],this.removeFromSchema(r,o.properties[r]);o.allOf&&o.allOf.forEach(r=>m(r))};for(const o of C){m(o);const r=this.configurationContributors.indexOf(o);r!==-1&&this.configurationContributors.splice(r,1)}u.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}registerDefaultConfigurations(C){const D=[],m=[];for(const o of C)for(const r in o)if(D.push(r),t.OVERRIDE_PROPERTY_PATTERN.test(r)){this.defaultValues[r]=Object.assign(Object.assign({},this.defaultValues[r]||{}),o[r]);const e={type:"object",default:this.defaultValues[r],description:g.localize(1,null,r),$ref:t.resourceLanguageSettingsSchemaId};m.push(y(r)),this.configurationProperties[r]=e,this.defaultLanguageConfigurationOverridesNode.properties[r]=e}else{this.defaultValues[r]=o[r];const e=this.configurationProperties[r];e&&(this.updatePropertyDefaultValue(r,e),this.updateSchema(r,e))}this.registerOverrideIdentifiers(m),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}deregisterDefaultConfigurations(C){const D=[];for(const m of C)for(const o in m)if(D.push(o),delete this.defaultValues[o],t.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const r=this.configurationProperties[o];r&&(this.updatePropertyDefaultValue(o,r),this.updateSchema(o,r))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}notifyConfigurationSchemaUpdated(...C){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(C){for(const D of C)this.overrideIdentifiers.add(D);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(C,D=!0,m,o=3){var r;o=L.isUndefinedOrNull(C.scope)?o:C.scope;let e=[],i=C.properties;if(i)for(let s in i){if(D&&c(s)){delete i[s];continue}const l=i[s];if(this.updatePropertyDefaultValue(s,l),t.OVERRIDE_PROPERTY_PATTERN.test(s)?l.scope=void 0:(l.scope=L.isUndefinedOrNull(l.scope)?o:l.scope,l.restricted=L.isUndefinedOrNull(l.restricted)?!!((r=m==null?void 0:m.restrictedConfigurations)===null||r===void 0?void 0:r.includes(s)):l.restricted),i[s].hasOwnProperty("included")&&!i[s].included){this.excludedConfigurationProperties[s]=i[s],delete i[s];continue}else this.configurationProperties[s]=i[s];!i[s].deprecationMessage&&i[s].markdownDeprecationMessage&&(i[s].deprecationMessage=i[s].markdownDeprecationMessage),e.push(s)}let n=C.allOf;if(n)for(let s of n)e.push(...this.validateAndRegisterProperties(s,D,m,o));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(C){const D=m=>{let o=m.properties;if(o)for(const e in o)this.updateSchema(e,o[e]);let r=m.allOf;r&&r.forEach(D)};D(C)}updateSchema(C,D){switch(t.allSettings.properties[C]=D,D.scope){case 1:t.applicationSettings.properties[C]=D;break;case 2:t.machineSettings.properties[C]=D;break;case 6:t.machineOverridableSettings.properties[C]=D;break;case 3:t.windowSettings.properties[C]=D;break;case 4:t.resourceSettings.properties[C]=D;break;case 5:t.resourceSettings.properties[C]=D,this.resourceLanguageSettingsSchema.properties[C]=D;break}}removeFromSchema(C,D){switch(delete t.allSettings.properties[C],D.scope){case 1:delete t.applicationSettings.properties[C];break;case 2:delete t.machineSettings.properties[C];break;case 6:delete t.machineOverridableSettings.properties[C];break;case 3:delete t.windowSettings.properties[C];break;case 4:case 5:delete t.resourceSettings.properties[C];break}}updateOverridePropertyPatternKey(){for(const C of this.overrideIdentifiers.values()){const D=`[${C}]`,m={type:"object",description:g.localize(2,null),errorMessage:g.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(D,m),t.allSettings.properties[D]=m,t.applicationSettings.properties[D]=m,t.machineSettings.properties[D]=m,t.machineOverridableSettings.properties[D]=m,t.windowSettings.properties[D]=m,t.resourceSettings.properties[D]=m}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(C,D){let m=this.defaultValues[C];L.isUndefined(m)&&(m=D.default),L.isUndefined(m)&&(m=w(D.type)),D.default=m}}const S="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(S);function y(b){return b.substring(1,b.length-1)}t.overrideIdentifierFromKey=y;function w(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=w;const O=new h;I.Registry.add(t.Extensions.Configuration,O);function c(b){return b.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(b)?g.localize(5,null,b):O.getConfigurationProperties()[b]!==void 0?g.localize(6,null,b):null:g.localize(4,null)}t.validateProperty=c;function f(){const b=[],C=O.getConfigurationProperties();for(const D of Object.keys(C))b.push([D,C[D].scope]);return b.push(["launch",4]),b.push(["task",4]),b}t.getScopes=f}),define(J[27],Y([0,1,20,13,7,25,11,30]),function(_,t,g,A,I,L,F,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=F.createDecorator("configurationService");function u(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof I.URI)}t.isConfigurationOverrides=u;var h;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(h=t.ConfigurationTarget||(t.ConfigurationTarget={}));function S(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=S;function y(i,n){const s=n?i?n.keys.filter(V=>i.keys.indexOf(V)===-1):[...n.keys]:[],l=i?n?i.keys.filter(V=>n.keys.indexOf(V)===-1):[...i.keys]:[],E=[];if(n&&i){for(const V of i.keys)if(n.keys.indexOf(V)!==-1){const $=C(i.contents,V),K=C(n.contents,V);g.equals($,K)||E.push(V)}}const P=[],U=V=>{const $={};for(const K of V)for(const ee of K.identifiers)$[r(ee)]=K;return $},k=n?U(n.overrides):{},j=i?U(i.overrides):{};if(Object.keys(k).length)for(const V of s){const $=k[V];$&&P.push([R.overrideIdentifierFromKey(V),$.keys])}if(Object.keys(j).length)for(const V of l){const $=j[V];$&&P.push([R.overrideIdentifierFromKey(V),$.keys])}if(Object.keys(k).length&&Object.keys(j).length)for(const V of E){const $=j[V],K=k[V];if($&&K){const ee=y({contents:$.contents,keys:$.keys,overrides:[]},{contents:K.contents,keys:K.keys,overrides:[]});P.push([R.overrideIdentifierFromKey(V),[...ee.added,...ee.removed,...ee.updated]])}}return{added:s,removed:l,updated:E,overrides:P}}t.compare=y;function w(i,n){const s=[];for(const l of Object.keys(i))if(R.OVERRIDE_PROPERTY_PATTERN.test(l)){const E={};for(const P in i[l])E[P]=i[l][P];s.push({identifiers:[R.overrideIdentifierFromKey(l).trim()],keys:Object.keys(E),contents:O(E,n)})}return s}t.toOverrides=w;function O(i,n){const s=Object.create(null);for(let l in i)c(s,l,i[l],n);return s}t.toValuesTree=O;function c(i,n,s,l){const E=n.split("."),P=E.pop();let U=i;for(let k=0;k<E.length;k++){let j=E[k],V=U[j];switch(typeof V){case"undefined":V=U[j]=Object.create(null);break;case"object":break;default:l(`Ignoring ${n} as ${E.slice(0,k+1).join(".")} is ${JSON.stringify(V)}`);return}U=V}if(typeof U=="object"&&U!==null)try{U[P]=s}catch(k){l(`Ignoring ${n} as ${E.join(".")} is ${JSON.stringify(U)}`)}else l(`Ignoring ${n} as ${E.join(".")} is ${JSON.stringify(U)}`)}t.addToValueTree=c;function f(i,n){const s=n.split(".");b(i,s)}t.removeFromValueTree=f;function b(i,n){const s=n.shift();if(n.length===0){delete i[s];return}if(Object.keys(i).indexOf(s)!==-1){const l=i[s];typeof l=="object"&&!Array.isArray(l)&&(b(l,n),Object.keys(l).length===0&&delete i[s])}}function C(i,n,s){function l(U,k){let j=U;for(const V of k){if(typeof j!="object"||j===null)return;j=j[V]}return j}const E=n.split("."),P=l(i,E);return typeof P=="undefined"?s:P}t.getConfigurationValue=C;function D(i,n,s){Object.keys(n).forEach(l=>{l!=="__proto__"&&(l in i?A.isObject(i[l])&&A.isObject(n[l])?D(i[l],n[l],s):s&&(i[l]=n[l]):i[l]=n[l])})}t.merge=D;function m(){const i=L.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=m;function o(){const i=Object.create(null),n=L.Registry.as(R.Extensions.Configuration).getConfigurationProperties();for(let s in n){let l=n[s].default;c(i,s,l,E=>console.error(`Conflict in default settings: ${E}`))}return i}t.getDefaultValues=o;function r(i){return`[${i}]`}t.keyFromOverrideIdentifier=r;function e(i,n,s){const l=i.inspect(n),E=i.inspect(s);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof E.userValue!="undefined"||typeof E.workspaceValue!="undefined"||typeof E.workspaceFolderValue!="undefined"?E.value:l.defaultValue}t.getMigratedSettingValue=e}),define(J[109],Y([0,1,58,45,22,13,20,7,30,27,25,2,10]),function(_,t,g,A,I,L,F,R,u,h,S,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class O{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?h.getConfigurationValue(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?h.getConfigurationValue(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const s of I.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[s],E=i[s];E&&(typeof l=="object"&&typeof E=="object"?(l=F.deepClone(l),this.mergeContents(l,E)):l=E),n[s]=l}return new O(n,this.keys,this.overrides)}merge(...e){const i=F.deepClone(this.contents),n=F.deepClone(this.overrides),s=[...this.keys];for(const l of e){this.mergeContents(i,l.contents);for(const E of l.overrides){const[P]=n.filter(U=>I.equals(U.identifiers,E.identifiers));P?this.mergeContents(P.contents,E.contents):n.push(F.deepClone(E))}for(const E of l.keys)s.indexOf(E)===-1&&s.push(E)}return new O(i,s,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&L.isObject(e[n])&&L.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=F.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?F.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),h.addToValueTree(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&h.removeFromValueTree(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=O;class c extends O{constructor(){const e=h.getDefaultValues(),i=h.getConfigurationKeys(),n=[];for(const s of Object.keys(e))u.OVERRIDE_PROPERTY_PATTERN.test(s)&&n.push({identifiers:[u.overrideIdentifierFromKey(s).trim()],keys:Object.keys(e[s]),contents:h.toValuesTree(e[s],l=>console.error(`Conflict in default settings file: ${l}`))});super(e,i,n)}}t.DefaultConfigurationModel=c;class f{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new O}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!L.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:s,overrides:l,restricted:E}=this.doParseRaw(e,i);this._configurationModel=new O(n,s,l),this._restrictedConfigurations=E||[]}doParseContent(e){let i={},n=null,s=[],l=[],E=[];function P(k){Array.isArray(s)?s.push(k):n&&(s[n]=k)}let U={onObjectBegin:()=>{let k={};P(k),l.push(s),s=k,n=null},onObjectProperty:k=>{n=k},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{let k=[];P(k),l.push(s),s=k,n=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:P,onError:(k,j,V)=>{E.push({error:k,offset:j,length:V})}};if(e)try{g.visit(e,U),i=s[0]||{}}catch(k){console.error(`Error while parsing settings file ${this._name}: ${k}`),this._parseErrors=[k]}return i}doParseRaw(e,i){const n=S.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),s=this.filter(e,n,!0,i);e=s.raw;const l=h.toValuesTree(e,U=>console.error(`Conflict in settings file ${this._name}: ${U}`)),E=Object.keys(e),P=h.toOverrides(e,U=>console.error(`Conflict in settings file ${this._name}: ${U}`));return{contents:l,keys:E,overrides:P,restricted:s.restricted}}filter(e,i,n,s){if(!(s==null?void 0:s.scopes)&&!(s==null?void 0:s.skipRestricted))return{raw:e,restricted:[]};const l={},E=[];for(let P in e)if(u.OVERRIDE_PROPERTY_PATTERN.test(P)&&n){const U=this.filter(e[P],i,!1,s);l[P]=U.raw,E.push(...U.restricted)}else{const U=i[P],k=U?typeof U.scope!="undefined"?U.scope:3:void 0;(U==null?void 0:U.restricted)&&E.push(P),(k===void 0||s.scopes===void 0||s.scopes.includes(k))&&(s.skipRestricted&&(U==null?void 0:U.restricted)||(l[P]=e[P]))}return{raw:l,restricted:E}}}t.ConfigurationModelParser=f;class b extends y.Disposable{constructor(e,i,n,s){super();this.userSettingsResource=e,this.scopes=i,this.fileService=s,this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(w.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new O}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=b;class C{constructor(e,i,n=new O,s=new O,l=new A.ResourceMap,E=new O,P=new A.ResourceMap,U=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=s,this._folderConfigurations=l,this._memoryConfiguration=E,this._memoryConfigurationByResource=P,this._freeze=U,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let s;n.resource?(s=this._memoryConfigurationByResource.get(n.resource),s||(s=new O,this._memoryConfigurationByResource.set(n.resource,s))):s=this._memoryConfiguration,i===void 0?s.removeValue(e):s.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const s=this.getConsolidateConfigurationModel(i,n),l=this.getFolderConfigurationModelForResource(i.resource,n),E=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,P=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),U=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),k=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),j=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),V=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,$=l?i.overrideIdentifier?l.freeze().override(i.overrideIdentifier).getValue(e):l.freeze().getValue(e):void 0,K=i.overrideIdentifier?E.override(i.overrideIdentifier).getValue(e):E.getValue(e),ee=s.getValue(e),te=I.distinct(I.flatten(s.overrides.map(Q=>Q.identifiers))).filter(Q=>s.getOverrideValue(e,Q)!==void 0);return{defaultValue:P,userValue:U,userLocalValue:k,userRemoteValue:j,workspaceValue:V,workspaceFolderValue:$,memoryValue:K,value:ee,default:P!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:U!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:k!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:j!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:V!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:$!==void 0?{value:l==null?void 0:l.freeze().getValue(e),override:i.overrideIdentifier?l==null?void 0:l.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:K!==void 0?{value:E.getValue(e),override:i.overrideIdentifier?E.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:te.length?te:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(s=>u.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const l=u.overrideIdentifierFromKey(s),E=this._defaultConfiguration.getKeysForOverrideIdentifier(l),P=e.getKeysForOverrideIdentifier(l),U=[...P.filter(k=>E.indexOf(k)===-1),...E.filter(k=>P.indexOf(k)===-1),...E.filter(k=>!F.equals(this._defaultConfiguration.override(l).getValue(k),e.override(l).getValue(k)))];return[l,U]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:s,overrides:l}=h.compare(this.localUserConfiguration,e),E=[...i,...n,...s];return E.length&&this.updateLocalUserConfiguration(e),{keys:E,overrides:l}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:s,overrides:l}=h.compare(this.remoteUserConfiguration,e);let E=[...i,...n,...s];return E.length&&this.updateRemoteUserConfiguration(e),{keys:E,overrides:l}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:s,overrides:l}=h.compare(this.workspaceConfiguration,e);let E=[...i,...n,...s];return E.length&&this.updateWorkspaceConfiguration(e),{keys:E,overrides:l}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:s,updated:l,removed:E,overrides:P}=h.compare(n,i);let U=[...s,...l,...E];return(U.length||!n)&&this.updateFolderConfiguration(e,i),{keys:U,overrides:P}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:s,removed:l,overrides:E}=h.compare(i,void 0);return{keys:[...n,...s,...l],overrides:E}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const s=i.getFolder(e);s&&(n=this.getFolderConsolidatedConfiguration(s.uri)||n);const l=this._memoryConfigurationByResource.get(e);l&&(n=n.merge(l))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(e);s?(i=n.merge(s),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:s,keys:l}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:s,keys:l}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(s=>i.add(s))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),s=this.parseConfigurationModel(e.workspace),l=e.folders.reduce((E,P)=>(E.set(R.URI.revive(P[0]),this.parseConfigurationModel(P[1])),E),new A.ResourceMap);return new C(i,n,new O,s,l,new O,new A.ResourceMap,!1)}static parseConfigurationModel(e){return new O(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=C;function D(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,i=new Map;for(const s of r)s.keys.forEach(l=>e.add(l)),s.overrides.forEach(([l,E])=>{const P=A.getOrSet(i,l,new Set);E.forEach(U=>P.add(U))});const n=[];return i.forEach((s,l)=>n.push([l,[...s.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=D;class m{constructor(e,i,n,s){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=s,this._previousConfiguration=void 0;const l=new Set;e.keys.forEach(P=>l.add(P)),e.overrides.forEach(([,P])=>P.forEach(U=>l.add(U))),this.affectedKeys=[...l.values()];const E=new O;this.affectedKeys.forEach(P=>E.setValue(P,{})),this.affectedKeysTree=E.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=C.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){var n;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(e,i,(n=this.previous)===null||n===void 0?void 0:n.workspace):void 0,l=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!F.equals(s,l)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=h.toValuesTree({[i]:!0},()=>{}),s;for(;typeof n=="object"&&(s=Object.keys(n)[0]);){if(e=e[s],!e)return!1;n=n[s]}return!0}}t.ConfigurationChangeEvent=m;class o extends m{constructor(e,i,n,s){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=s}}t.AllKeysConfigurationChangeEvent=o}),define(J[110],Y([0,1,25,30,2,27,109,10,4,17]),function(_,t,g,A,I,L,F,R,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class S extends I.Disposable{constructor(w,O){super();this.settingsResource=w,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new F.UserSettings(this.settingsResource,void 0,h.extUriBiasedIgnorePathCase,O)),this.configuration=new F.Configuration(new F.DefaultConfigurationModel,new F.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new u.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(g.Registry.as(A.Extensions.Configuration).onDidUpdateConfiguration(c=>this.onDidDefaultConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const w=await this.userConfiguration.loadConfiguration();this.configuration=new F.Configuration(new F.DefaultConfigurationModel,w)}getConfigurationData(){return this.configuration.toData()}getValue(w,O){const c=typeof w=="string"?w:void 0,f=L.isConfigurationOverrides(w)?w:L.isConfigurationOverrides(O)?O:{};return this.configuration.getValue(c,f,void 0)}updateValue(w,O,c,f){return Promise.reject(new Error("not supported"))}inspect(w){return this.configuration.inspect(w,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const w=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(w)}onDidChangeUserConfiguration(w){const O=this.configuration.toData(),c=this.configuration.compareAndUpdateLocalUserConfiguration(w);this.trigger(c,O,1)}onDidDefaultConfigurationChange(w){const O=this.configuration.toData(),c=this.configuration.compareAndUpdateDefaultConfiguration(new F.DefaultConfigurationModel,w);this.trigger(c,O,6)}trigger(w,O,c){const f=new F.ConfigurationChangeEvent(w,{data:O},this.configuration);f.source=c,f.sourceConfig=this.getTargetConfiguration(c),this._onDidChangeConfiguration.fire(f)}getTargetConfiguration(w){switch(w){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=S}),define(J[55],Y([0,1,83,11,30,25,16]),function(_,t,g,A,I,L,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=A.createDecorator("requestService");function R(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}t.isSuccess=R;function u(c){return c.res.statusCode===204}async function h(c){if(!R(c))throw new Error("Server returned "+c.res.statusCode);return u(c)?null:(await F.streamToBuffer(c.stream)).toString()}t.asText=h;async function S(c){if(!R(c))throw new Error("Server returned "+c.res.statusCode);if(u(c))return null;const b=(await F.streamToBuffer(c.stream)).toString();try{return JSON.parse(b)}catch(C){throw C.message+=`:
`+b,C}}t.asJson=S;function y(c){O(c)}t.updateProxyConfigurationsScope=y;let w;function O(c){const f=L.Registry.as(I.Extensions.Configuration);w&&f.deregisterConfigurations([w]),w={id:"http",order:15,title:g.localize(0,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:g.localize(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:g.localize(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:g.localize(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[g.localize(4,null),g.localize(5,null),g.localize(6,null),g.localize(7,null)],default:"override",description:g.localize(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:g.localize(9,null),restricted:!0}}},f.registerConfiguration(w)}O(2)}),define(J[111],Y([0,1,112,13]),function(_,t,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function I(F,R){return F.protocol==="http:"?R.HTTP_PROXY||R.http_proxy||null:F.protocol==="https:"&&(R.HTTPS_PROXY||R.https_proxy||R.HTTP_PROXY||R.http_proxy)||null}async function L(F,R,u={}){const h=g.parse(F),S=u.proxyUrl||I(h,R);if(!S)return null;const y=g.parse(S);if(!/^https?:$/.test(y.protocol||""))return null;const w={host:y.hostname||"",port:y.port||(y.protocol==="https"?"443":"80"),auth:y.auth,rejectUnauthorized:A.isBoolean(u.strictSSL)?u.strictSSL:!0};return h.protocol==="http:"?new(await new Promise((O,c)=>{_(["http-proxy-agent"],O,c)}))(w):new(await new Promise((O,c)=>{_(["https-proxy-agent"],O,c)}))(w)}t.getProxyAgent=L}),define(J[113],Y([0,1,29,16]),function(_,t,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function I(L,F,R){let u=R&&R.get("storage.serviceMachineId",0)||null;if(u)return u;try{const S=(await F.readFile(L.serviceMachineIdResource)).value.toString();u=g.isUUID(S)?S:null}catch(h){u=null}if(!u){u=g.generateUuid();try{await F.writeFile(L.serviceMachineIdResource,A.VSBuffer.fromString(u))}catch(h){}}return R&&R.store("storage.serviceMachineId",u,0,1),u}t.getServiceMachineId=I}),define(J[114],Y([0,1,11,10,2,13,66,4]),function(_,t,g,A,I,L,F,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const u="__$__targetStorageMarker";t.IStorageService=g.createDecorator("storageService");var h;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(h=t.WillSaveStateReason||(t.WillSaveStateReason={}));var S;(function(f){f[f.GLOBAL=0]="GLOBAL",f[f.WORKSPACE=1]="WORKSPACE"})(S=t.StorageScope||(t.StorageScope={}));var y;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(y=t.StorageTarget||(t.StorageTarget={}));class w extends I.Disposable{constructor(b={flushInterval:w.DEFAULT_FLUSH_INTERVAL}){super();this.options=b,this._onDidChangeValue=this._register(new A.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new A.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new A.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new I.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=R.runWhenIdle(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){I.dispose([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,C){C===u?(b===0?this._globalKeyTargets=void 0:b===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:b})):this._onDidChangeValue.fire({scope:b,key:C,target:this.getKeyTargets(b)[C]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,C,D){var m;return(m=this.getStorage(C))===null||m===void 0?void 0:m.get(b,D)}getBoolean(b,C,D){var m;return(m=this.getStorage(C))===null||m===void 0?void 0:m.getBoolean(b,D)}getNumber(b,C,D){var m;return(m=this.getStorage(C))===null||m===void 0?void 0:m.getNumber(b,D)}store(b,C,D,m){if(L.isUndefinedOrNull(C)){this.remove(b,D);return}this.withPausedEmitters(()=>{var o;this.updateKeyTarget(b,D,m),(o=this.getStorage(D))===null||o===void 0||o.set(b,C)})}remove(b,C){this.withPausedEmitters(()=>{var D;this.updateKeyTarget(b,C,void 0),(D=this.getStorage(C))===null||D===void 0||D.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,C){const D=[],m=this.getKeyTargets(b);for(const o of Object.keys(m))m[o]===C&&D.push(o);return D}updateKeyTarget(b,C,D){var m,o;const r=this.getKeyTargets(C);typeof D=="number"?r[b]!==D&&(r[b]=D,(m=this.getStorage(C))===null||m===void 0||m.set(u,JSON.stringify(r))):typeof r[b]=="number"&&(delete r[b],(o=this.getStorage(C))===null||o===void 0||o.set(u,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(b){return b===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(b){const C=this.get(u,b);if(C)try{return JSON.parse(C)}catch(D){}return Object.create(null)}isNew(b){return this.getBoolean(t.IS_NEW_KEY,b)===!0}async flush(){var b,C,D,m;this._onWillSaveState.fire({reason:h.NONE}),await R.Promises.settled([(C=(b=this.getStorage(0))===null||b===void 0?void 0:b.whenFlushed())!==null&&C!==void 0?C:Promise.resolve(),(m=(D=this.getStorage(1))===null||D===void 0?void 0:D.whenFlushed())!==null&&m!==void 0?m:Promise.resolve()])}async logStorage(){var b,C,D,m,o,r;const e=(C=(b=this.getStorage(0))===null||b===void 0?void 0:b.items)!==null&&C!==void 0?C:new Map,i=(m=(D=this.getStorage(1))===null||D===void 0?void 0:D.items)!==null&&m!==void 0?m:new Map;return c(e,i,(o=this.getLogDetails(0))!==null&&o!==void 0?o:"",(r=this.getLogDetails(1))!==null&&r!==void 0?r:"")}}t.AbstractStorageService=w,w.DEFAULT_FLUSH_INTERVAL=60*1e3;class O extends w{constructor(){super();this.globalStorage=this._register(new F.Storage(new F.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new F.Storage(new F.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.globalStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b)))}getStorage(b){return b===0?this.globalStorage:this.workspaceStorage}getLogDetails(b){return b===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(b){}}t.InMemoryStorageService=O;async function c(f,b,C,D){const m=l=>{try{return JSON.parse(l)}catch(E){return l}},o=new Map,r=new Map;f.forEach((l,E)=>{o.set(E,l),r.set(E,m(l))});const e=new Map,i=new Map;b.forEach((l,E)=>{e.set(E,l),i.set(E,m(l))}),console.group(`Storage: Global (path: ${C})`);let n=[];o.forEach((l,E)=>{n.push({key:E,value:l})}),console.table(n),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${D})`);let s=[];e.forEach((l,E)=>{s.push({key:E,value:l})}),console.table(s),console.groupEnd(),console.log(i)}t.logStorage=c}),define(J[115],Y([0,1,14,33,29,7]),function(_,t,g,A,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function F(h){if(g.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}async function R(h,S,y,w,O,c,f,b,C,D){const m=Object.create(null);m["common.machineId"]=f,m.sessionID=I.generateUuid()+Date.now(),m.commitHash=O,m.version=c,m["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=g.PlatformToString(g.platform),m["common.nodePlatform"]=A.platform,m["common.nodeArch"]=w,m["common.product"]=D||"desktop";const o=u(b||[]);o&&(m["common.msftInternal"]=o);let r=0;const e=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),g.isLinuxSnap&&(m["common.snap"]="true");const i=F(y);i&&(m["common.platformDetail"]=i);try{const n=await h.readFile(L.URI.file(C));m["common.source"]=n.value.toString().slice(0,30)}catch(n){}return m}t.resolveCommonProperties=R;function u(h){const S=A.env.USERDNSDOMAIN;if(!S)return!1;const y=S.toLowerCase();return h.some(w=>y===w)}t.verifyMicrosoftInternalDomain=u}),define(J[42],Y([0,1,11]),function(_,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=g.createDecorator("telemetryService"),t.ICustomEndpointTelemetryService=g.createDecorator("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(J[116],Y([0,1,12,23,24,20,42,55,49,21,26,15,18,7,41,114,113,11,17]),function(_,t,g,A,I,L,F,R,u,h,S,y,w,O,c,f,b,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var m;(function(d){d[d.None=0]="None",d[d.IncludeVersions=1]="IncludeVersions",d[d.IncludeFiles=2]="IncludeFiles",d[d.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",d[d.IncludeSharedAccounts=8]="IncludeSharedAccounts",d[d.IncludeVersionProperties=16]="IncludeVersionProperties",d[d.ExcludeNonValidated=32]="ExcludeNonValidated",d[d.IncludeInstallationTargets=64]="IncludeInstallationTargets",d[d.IncludeAssetUri=128]="IncludeAssetUri",d[d.IncludeStatistics=256]="IncludeStatistics",d[d.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",d[d.Unpublished=4096]="Unpublished"})(m||(m={}));function o(...d){return String(d.reduce((a,v)=>a|v,0))}var r;(function(d){d[d.Tag=1]="Tag",d[d.ExtensionId=4]="ExtensionId",d[d.Category=5]="Category",d[d.ExtensionName=7]="ExtensionName",d[d.Target=8]="Target",d[d.Featured=9]="Featured",d[d.SearchText=10]="SearchText",d[d.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const e={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},s={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:m.None,criteria:[],assetTypes:[]};class l{constructor(a=s){this.state=a}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(a,v=this.state.pageSize){return new l(Object.assign(Object.assign({},this.state),{pageNumber:a,pageSize:v}))}withFilter(a,...v){const p=[...this.state.criteria,...v.length?v.map(N=>({filterType:a,value:N})):[{filterType:a}]];return new l(Object.assign(Object.assign({},this.state),{criteria:p}))}withSortBy(a){return new l(Object.assign(Object.assign({},this.state),{sortBy:a}))}withSortOrder(a){return new l(Object.assign(Object.assign({},this.state),{sortOrder:a}))}withFlags(...a){return new l(Object.assign(Object.assign({},this.state),{flags:a.reduce((v,p)=>v|p,0)}))}withAssetTypes(...a){return new l(Object.assign(Object.assign({},this.state),{assetTypes:a}))}get raw(){const{criteria:a,pageNumber:v,pageSize:p,sortBy:N,sortOrder:M,flags:x,assetTypes:B}=this.state;return{filters:[{criteria:a,pageNumber:v,pageSize:p,sortBy:N,sortOrder:M}],assetTypes:B,flags:x}}get searchText(){const a=this.state.criteria.filter(v=>v.filterType===r.SearchText)[0];return a&&a.value?a.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(a=>String(a.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function E(d,a){const v=(d||[]).filter(p=>p.statisticName===a)[0];return v?v.value:0}function P(d){const a="Microsoft.VisualStudio.Code.Translation.";return d.files.filter(p=>p.assetType.indexOf(a)===0).reduce((p,N)=>{const M=V(d,N.assetType);return M&&p.push([N.assetType.substring(a.length),M]),p},[])}function U(d){if(d.properties){const a=d.properties.filter(N=>N.key===e.Repository),v=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),p=a.filter(N=>v.test(N.value))[0];return p?{uri:p.value,fallbackUri:p.value}:null}return V(d,e.Repository)}function k(d){return{uri:`${d.fallbackAssetUri}/${e.VSIX}?redirect=true`,fallbackUri:`${d.fallbackAssetUri}/${e.VSIX}`}}function j(d){const a=V(d,e.Icon);if(a)return a;const v=A.DefaultIconPath;return{uri:v,fallbackUri:v}}function V(d,a){return d.files.filter(p=>p.assetType===a)[0]?{uri:`${d.assetUri}/${a}`,fallbackUri:`${d.fallbackAssetUri}/${a}`}:null}function $(d,a){const v=d.properties?d.properties.filter(N=>N.key===a):[],p=v.length>0&&v[0].value;return p?p.split(",").map(N=>I.adoptToGalleryExtensionId(N)):[]}function K(d){const a=d.properties?d.properties.filter(v=>v.key===i.Engine):[];return a.length>0&&a[0].value||""}function ee(d){const a=d.properties?d.properties.filter(p=>p.key===i.LocalizedLanguages):[],v=a.length>0&&a[0].value||"";return v?v.split(","):[]}function te(d){return d.indexOf("preview")!==-1}function Q(d){const a=d.properties?d.properties.find(v=>v.key===i.WebExtension):void 0;return!!a&&a.value==="true"}function ae(d){return d.files.some(a=>a.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?D.joinPath(O.URI.parse(d.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function se(d,a,v,p,N){const M={manifest:V(a,e.Manifest),readme:V(a,e.Details),changelog:V(a,e.Changelog),license:V(a,e.License),repository:U(a),download:k(a),icon:j(a),coreTranslations:P(a)};return{identifier:{id:I.getGalleryExtensionId(d.publisher.publisherName,d.extensionName),uuid:d.extensionId},name:d.extensionName,version:a.version,date:a.lastUpdated,displayName:d.displayName,publisherId:d.publisher.publisherId,publisher:d.publisher.publisherName,publisherDisplayName:d.publisher.displayName,description:d.shortDescription||"",installCount:E(d.statistics,"install"),rating:E(d.statistics,"averagerating"),ratingCount:E(d.statistics,"ratingcount"),assetUri:O.URI.parse(a.assetUri),webResource:ae(a),assetTypes:a.files.map(({assetType:x})=>x),assets:M,properties:{dependencies:$(a,i.Dependency),extensionPack:$(a,i.ExtensionPack),engine:K(a),localizedLanguages:ee(a),webExtension:Q(a)},telemetryData:{index:(p.pageNumber-1)*p.pageSize+v,querySource:N},preview:te(d.flags)}}let re=class{constructor(a,v,p,N,M,x,B){this.requestService=a,this.logService=v,this.environmentService=p,this.telemetryService=N,this.fileService=M,this.productService=x;const W=x.extensionsGallery;this.extensionsGalleryUrl=W&&W.serviceUrl,this.extensionsControlUrl=W&&W.controlUrl,this.commonHeadersPromise=T(x.version,this.environmentService,this.fileService,B)}api(a=""){return`${this.extensionsGalleryUrl}${a}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(a,v){const p=[];let{total:N,firstPage:M,getPage:x}=await this.query({names:a,pageSize:a.length},v);p.push(...M);for(let B=1;p.length<N&&(M=await x(B,v),M.length);B++)p.push(...M);return p}async getCompatibleExtension(a,v){const p=await this.getCompatibleExtensionByEngine(a,v);return(p==null?void 0:p.properties.webExtension)?p.webResource?p:null:p}async getCompatibleExtensionByEngine(a,v){const p=A.isIExtensionIdentifier(a)?null:a;if(p&&p.properties.engine&&u.isEngineValid(p.properties.engine,this.productService.version,this.productService.date))return p;const{id:N,uuid:M}=p?p.identifier:a;let x=new l().withFlags(m.IncludeAssetUri,m.IncludeStatistics,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");M?x=x.withFilter(r.ExtensionId,M):x=x.withFilter(r.ExtensionName,N);const{galleryExtensions:B}=await this.queryGallery(x,S.CancellationToken.None),[W]=B;if(!W||!W.versions.length)return null;if(v){const X=W.versions.filter(Z=>Z.version===v)[0];if(X){const Z=se(W,X,0,x);if(Z.properties.engine&&u.isEngineValid(Z.properties.engine,this.productService.version,this.productService.date))return Z}return null}const H=await this.getLastValidExtensionVersion(W,W.versions);return H?se(W,H,0,x):null}async query(a,v){const p=S.CancellationToken.isCancellationToken(a)?{}:a,N=S.CancellationToken.isCancellationToken(a)?a:v;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let M=p.text||"";const x=L.getOrDefault(p,ie=>ie.pageSize,50);let B=new l().withFlags(m.IncludeLatestVersionOnly,m.IncludeAssetUri,m.IncludeStatistics,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,x).withFilter(r.Target,"Microsoft.VisualStudio.Code");M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ie,ce,ge)=>(B=B.withFilter(r.Category,ge||ce),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ie,ce,ge)=>(B=B.withFilter(r.Tag,ge||ce),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(B=B.withFilter(r.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),B=B.withFilter(r.SearchText,M)),B=B.withSortBy(0)):p.ids?B=B.withFilter(r.ExtensionId,...p.ids):p.names?B=B.withFilter(r.ExtensionName,...p.names):B=B.withSortBy(4),typeof p.sortBy=="number"&&(B=B.withSortBy(p.sortBy)),typeof p.sortOrder=="number"&&(B=B.withSortOrder(p.sortOrder));const{galleryExtensions:W,total:H}=await this.queryGallery(B,N),X=W.map((ie,ce)=>se(ie,ie.versions[0],ce,B,p.source)),Z=async(ie,ce)=>{if(ce.isCancellationRequested)throw g.canceled();const ge=B.withPage(ie+1),{galleryExtensions:Pe}=await this.queryGallery(ge,ce);return Pe.map((Fe,Re)=>se(Fe,Fe.versions[0],Re,ge,p.source))};return{firstPage:X,total:H,pageSize:B.pageSize,getPage:Z}}async queryGallery(a,v){if(!this.isEnabled())throw new Error("No extension gallery service configured.");a=a.withFlags(a.flags,m.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,o(m.Unpublished));const p=await this.commonHeadersPromise,N=JSON.stringify(a.raw),M=Object.assign(Object.assign({},p),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(N.length)}),x=new Date().getTime();let B,W,H=0;try{if(B=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:N,headers:M},v),B.res.statusCode&&B.res.statusCode>=400&&B.res.statusCode<500)return{galleryExtensions:[],total:H};const X=await R.asJson(B);if(X){const Z=X.results[0],ie=Z.extensions,ce=Z.resultMetadata&&Z.resultMetadata.filter(ge=>ge.metadataType==="ResultCount")[0];return H=ce&&ce.metadataItems.filter(ge=>ge.name==="TotalCount")[0].count||0,{galleryExtensions:ie,total:H}}return{galleryExtensions:[],total:H}}catch(X){throw W=X,X}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},a.telemetryData),{requestBodySize:String(N.length),duration:new Date().getTime()-x,success:!!B&&R.isSuccess(B),responseBodySize:B==null?void 0:B.res.headers["Content-Length"],statusCode:B?String(B.res.statusCode):void 0,errorCode:W?g.isPromiseCanceledError(W)?"canceled":g.getErrorMessage(W).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(H)}))}}async reportStatistic(a,v,p,N){if(!this.isEnabled())return;const M=await this.commonHeadersPromise,x=Object.assign(Object.assign({},M),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${a}/extensions/${v}/${p}/stats?statType=${N}`),headers:x},S.CancellationToken.None)}catch(B){}}async download(a,v,p){this.logService.trace("ExtensionGalleryService#download",a.identifier.id);const N=I.getGalleryExtensionTelemetryData(a),M=new Date().getTime(),x=X=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},N),{duration:X})),B=p===1?"install":p===2?"update":"",W=B?{uri:`${a.assets.download.uri}&${B}=true`,fallbackUri:`${a.assets.download.fallbackUri}?${B}=true`}:a.assets.download,H=await this.getAsset(W);await this.fileService.writeFile(v,H.stream),x(new Date().getTime()-M)}async getReadme(a,v){if(a.assets.readme){const p=await this.getAsset(a.assets.readme,{},v);return await R.asText(p)||""}return""}async getManifest(a,v){if(a.assets.manifest){const p=await this.getAsset(a.assets.manifest,{},v),N=await R.asText(p);return N?JSON.parse(N):null}return null}async getCoreTranslation(a,v){const p=a.assets.coreTranslations.filter(N=>N[0]===v.toUpperCase())[0];if(p){const N=await this.getAsset(p[1]),M=await R.asText(N);return M?JSON.parse(M):null}return null}async getChangelog(a,v){if(a.assets.changelog){const p=await this.getAsset(a.assets.changelog,{},v);return await R.asText(p)||""}return""}async getAllVersions(a,v){let p=new l().withFlags(m.IncludeVersions,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");a.identifier.uuid?p=p.withFilter(r.ExtensionId,a.identifier.uuid):p=p.withFilter(r.ExtensionName,a.identifier.id);const N=[],{galleryExtensions:M}=await this.queryGallery(p,S.CancellationToken.None);return M.length&&(v?await Promise.all(M[0].versions.map(async x=>{let B;try{B=await this.getEngine(x)}catch(W){}B&&u.isEngineValid(B,this.productService.version,this.productService.date)&&N.push({version:x.version,date:x.lastUpdated})})):N.push(...M[0].versions.map(x=>({version:x.version,date:x.lastUpdated})))),N}async getAsset(a,v={},p=S.CancellationToken.None){const N=await this.commonHeadersPromise,M={type:"GET"},x=Object.assign(Object.assign({},N),v.headers||{});v=Object.assign(Object.assign(Object.assign({},v),M),{headers:x});const B=a.uri,W=a.fallbackUri,H=Object.assign(Object.assign({},v),{url:B});try{const X=await this.requestService.request(H,p);if(X.res.statusCode===200)return X;const Z=await R.asText(X);throw new Error(`Expected 200, got back ${X.res.statusCode} instead.

${Z}`)}catch(X){if(g.isPromiseCanceledError(X))throw X;const Z=g.getErrorMessage(X);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:B,message:Z});const ie=Object.assign(Object.assign({},v),{url:W});return this.requestService.request(ie,p)}}async getLastValidExtensionVersion(a,v){const p=this.getLastValidExtensionVersionFromProperties(a,v);return p||this.getLastValidExtensionVersionRecursively(a,v)}getLastValidExtensionVersionFromProperties(a,v){for(const p of v){const N=K(p);if(!N)return null;if(u.isEngineValid(N,this.productService.version,this.productService.date))return p}return null}async getEngine(a){const v=K(a);if(v)return v;const p=V(a,e.Manifest);if(!p)throw new Error("Manifest was not found");const N={"Accept-Encoding":"gzip"},M=await this.getAsset(p,{headers:N}),x=await R.asJson(M);if(x)return x.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(a,v){if(!v.length)return null;const p=v[0],N=await this.getEngine(p);return u.isEngineValid(N,this.productService.version,this.productService.date)?Object.assign(Object.assign({},p),{properties:[...p.properties||[],{key:i.Engine,value:N}]}):this.getLastValidExtensionVersionRecursively(a,v.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const a=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},S.CancellationToken.None);if(a.res.statusCode!==200)throw new Error("Could not get extensions report.");const v=await R.asJson(a),p=new Map;if(v)for(const N of v.malicious){const M=p.get(N)||{id:{id:N},malicious:!0,slow:!1};M.malicious=!0,p.set(N,M)}return[...p.values()]}};re=ue([fe(0,R.IRequestService),fe(1,y.ILogService),fe(2,h.IEnvironmentService),fe(3,F.ITelemetryService),fe(4,w.IFileService),fe(5,c.IProductService),fe(6,C.optional(f.IStorageService))],re),t.ExtensionGalleryService=re;async function T(d,a,v,p){const N={"X-Market-Client-Id":`VSCode ${d}`,"User-Agent":`VSCode ${d}`},M=await b.getServiceMachineId(a,v,p);return N["X-Market-User-Id"]=M,N}t.resolveMarketplaceHeaders=T}),define(J[117],Y([0,1,40,84,19,11,27,30,2,20,25]),function(_,t,g,A,I,L,F,R,u,h,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let y=class{constructor(c,f){this._configurationService=f,this._experimentProperties={},this._disposables=new u.DisposableStore,this._cleanupPatterns=[],this._appender=c.appender,this._commonProperties=c.commonProperties||Promise.resolve({}),this._piiPaths=c.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!c.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let b of this._piiPaths)this._cleanupPatterns.push(new RegExp(I.escapeRegExpCharacters(b),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(b=>{const C=/^[a-f0-9]+$/i.test(b["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!C})}))}setExperimentProperty(c,f){this._experimentProperties[c]=f}setEnabled(c){this._enabled=c}_updateUserOptIn(){var c;const f=(c=this._configurationService)===null||c===void 0?void 0:c.getValue(w);this._userOptIn=f?f.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const c=await this._commonProperties;let f=c.sessionID,b=c["common.instanceId"],C=c["common.machineId"],D=c["common.firstSessionDate"],m=c["common.msftInternal"];return{sessionId:f,instanceId:b,machineId:C,firstSessionDate:D,msftInternal:m}}dispose(){this._disposables.dispose()}publicLog(c,f,b){return this.isOptedIn?this._commonProperties.then(C=>{f=h.mixin(f,C),f=h.mixin(f,this._experimentProperties),f=h.cloneAndChange(f,D=>{if(typeof D=="string")return this._cleanupInfo(D,b)}),this._appender.log(c,f)},C=>{console.error(C)}):Promise.resolve(void 0)}publicLog2(c,f,b){return this.publicLog(c,f,b)}publicLogError(c,f){return this.sendErrorTelemetry?this.publicLog(c,f,!0):Promise.resolve(void 0)}publicLogError2(c,f){return this.publicLogError(c,f)}_cleanupInfo(c,f){let b=c;if(f){const C=[];for(let r of this._cleanupPatterns)for(;;){const e=r.exec(c);if(!e)break;C.push([e.index,r.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(b="";;){const r=m.exec(c);if(!r)break;!D.test(r[0])&&C.every(([e,i])=>r.index<e||r.index>=i)&&(b+=c.substring(o,r.index)+"<REDACTED: user-file-path>",o=m.lastIndex)}o<c.length&&(b+=c.substr(o))}for(let C of this._cleanupPatterns)b=b.replace(C,"");return b}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=ue([fe(1,L.optional(F.IConfigurationService))],y),t.TelemetryService=y;const w="telemetry";S.Registry.as(R.Extensions.Configuration).registerConfiguration({id:w,order:110,type:"object",title:A.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:g.default.privacyStatementUrl?A.localize(2,null,g.default.privacyStatementUrl):A.localize(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(J[56],Y([0,1,27,20,13,4]),function(_,t,g,A,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(c,f){return Promise.resolve(void 0)}publicLog2(c,f){return this.publicLog(c,f)}publicLogError(c,f){return Promise.resolve(void 0)}publicLogError2(c,f){return this.publicLogError(c,f)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class F{async publicLog(f,b,C){}async publicLogError(f,b,C){}}t.NullEndpointTelemetryService=F;function R(...c){return{log:(f,b)=>c.forEach(C=>C.log(f,b)),flush:()=>L.Promises.settled(c.map(f=>f.flush()))}}t.combinedAppender=R,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function u(c,f){return f.onDidChangeConfiguration(b=>{b.source!==6&&c.publicLog2("updateConfiguration",{configurationSource:g.ConfigurationTargetToString(b.source),configurationKeys:w(b.sourceConfig)})})}t.configurationTelemetry=u;function h(c){const f=Object.create(null),b=Object.create(null),C=Object.create(null);y(c,C);for(let D in C){D=D.length>150?D.substr(D.length-149):D;const m=C[D];typeof m=="number"?b[D]=m:typeof m=="boolean"?b[D]=m?1:0:typeof m=="string"?f[D]=m.substring(0,1023):typeof m!="undefined"&&m!==null&&(f[D]=m)}return{properties:f,measurements:b}}t.validateTelemetryData=h;function S(c){if(!c)return"none";let f="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(C=>{c.indexOf(`${C}+`)===0&&(f=C)}),f}t.cleanRemoteAuthority=S;function y(c,f,b=0,C){if(!!c)for(let D of Object.getOwnPropertyNames(c)){const m=c[D],o=C?C+D:D;Array.isArray(m)?f[o]=A.safeStringify(m):m instanceof Date?f[o]=m.toISOString():I.isObject(m)?b<2?y(m,f,b+1,o+"."):f[o]=A.safeStringify(m):f[o]=m}}function w(c){if(!c)return[];const f=[];return O(f,"",c),f}function O(c,f,b){b&&typeof b=="object"&&!Array.isArray(b)?Object.keys(b).forEach(C=>O(c,f?`${f}.${C}`:C,b[C])):c.push(f)}}),define(J[118],Y([0,1,12,20,56]),function(_,t,g,A,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function L(R){const u=await new Promise((S,y)=>{_(["applicationinsights"],S,y)});let h;return u.defaultClient?(h=new u.TelemetryClient(R),h.channel.setUseDiskRetryCaching(!0)):(u.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),h=u.defaultClient),R.indexOf("AIF-")===0&&(h.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),h}class F{constructor(u,h,S){this._eventPrefix=u,this._defaultData=h,this._defaultData||(this._defaultData=Object.create(null)),typeof S=="function"?this._aiClient=S():this._aiClient=S,this._asyncAIClient=null}_withAIClient(u){if(!!this._aiClient){if(typeof this._aiClient!="string"){u(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=L(this._aiClient)),this._asyncAIClient.then(h=>{u(h)},h=>{g.onUnexpectedError(h),console.error(h)})}}log(u,h){!this._aiClient||(h=A.mixin(h,this._defaultData),h=I.validateTelemetryData(h),this._withAIClient(S=>S.trackEvent({name:this._eventPrefix+"/"+u,properties:h.properties,measurements:h.measurements})))}flush(){return this._aiClient?new Promise(u=>{this._withAIClient(h=>{h.flush({callback:()=>{this._aiClient=void 0,u(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=F}),define(J[119],Y([0,1,9,3]),function(_,t,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function I(L,F){const R=Object.create(null),u=(S,y)=>{const w=JSON.parse(S);R[y]=w};if(F){const S=[],y=await g.Promises.readdir(F);for(const O of y)try{(await g.Promises.stat(A.join(F,O))).isDirectory()&&S.push(O)}catch(c){}const w=[];for(const O of S)(await g.Promises.readdir(A.join(F,O))).filter(f=>f==="telemetry.json").length===1&&w.push(O);for(const O of w){const c=(await g.Promises.readFile(A.join(F,O,"telemetry.json"))).toString();u(c,O)}}let h=(await g.Promises.readFile(A.join(L,"telemetry-core.json"))).toString();return u(h,"vscode-core"),h=(await g.Promises.readFile(A.join(L,"telemetry-extensions.json"))).toString(),u(h,"vscode-extensions"),JSON.stringify(R,null,4)}t.buildTelemetryMessage=I}),define(J[43],Y([0,1,72,3,36,4,9,130,131,13]),function(_,t,g,A,I,L,F,R,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class S extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=S;function y(r){const e=r.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function w(r){if(r instanceof S)return r;let e;return/end of central directory record signature not found/.test(r.message)&&(e="CorruptZip"),new S(e,r)}function O(r,e,i,n,s,l){const E=A.dirname(e),P=A.join(n,E);if(!P.startsWith(n))return Promise.reject(new Error(g.localize(0,null,e)));const U=A.join(n,e);let k;return l.onCancellationRequested(()=>{k&&k.destroy()}),Promise.resolve(F.Promises.mkdir(P,{recursive:!0})).then(()=>new Promise((j,V)=>{if(!l.isCancellationRequested)try{k=I.createWriteStream(U,{mode:i}),k.once("close",()=>j()),k.once("error",V),r.once("error",V),r.pipe(k)}catch($){V($)}}))}function c(r,e,i,n){let s=L.createCancelablePromise(()=>Promise.resolve()),l=0;return n.onCancellationRequested(()=>{s.cancel(),r.close()}),new Promise((E,P)=>{const U=new L.Sequencer,k=j=>{j.isCancellationRequested||(l++,r.readEntry())};r.once("error",P),r.once("close",()=>s.then(()=>{n.isCancellationRequested||r.entryCount===l?E():P(new S("Incomplete",new Error(g.localize(1,null,l,r.entryCount))))},P)),r.readEntry(),r.on("entry",j=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(j.fileName)){k(n);return}const V=j.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(V)){const ee=A.join(e,V);s=L.createCancelablePromise(te=>F.Promises.mkdir(ee,{recursive:!0}).then(()=>k(te)).then(void 0,P));return}const $=b(r,j),K=y(j);s=L.createCancelablePromise(ee=>U.queue(()=>$.then(te=>O(te,V,K,e,i,ee).then(()=>k(ee)))).then(null,P))})})}function f(r,e=!1){return new Promise((i,n)=>{R.open(r,e?{lazyEntries:!0}:void 0,(s,l)=>{s?n(w(s)):i(h.assertIsDefined(l))})})}function b(r,e){return new Promise((i,n)=>{r.openReadStream(e,(s,l)=>{s?n(w(s)):i(h.assertIsDefined(l))})})}function C(r,e){return new Promise((i,n)=>{const s=new u.ZipFile;e.forEach(E=>{E.contents?s.addBuffer(typeof E.contents=="string"?Buffer.from(E.contents,"utf8"):E.contents,E.path):E.localPath&&s.addFile(E.localPath,E.path)}),s.end();const l=I.createWriteStream(r);s.outputStream.pipe(l),s.outputStream.once("error",n),l.once("error",n),l.once("finish",()=>i(r))})}t.zip=C;function D(r,e,i={},n){const s=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let l=f(r,!0);return i.overwrite&&(l=l.then(E=>F.Promises.rm(e).then(()=>E))),l.then(E=>c(E,e,{sourcePathRegex:s},n))}t.extract=D;function m(r,e){return f(r).then(i=>new Promise((n,s)=>{i.on("entry",l=>{l.fileName===e&&b(i,l).then(E=>n(E),E=>s(E))}),i.once("close",()=>s(new Error(g.localize(2,null,e))))}))}function o(r,e){return m(r,e).then(i=>new Promise((n,s)=>{const l=[];i.once("error",s),i.on("data",E=>l.push(E)),i.on("end",()=>n(Buffer.concat(l)))}))}t.buffer=o}),define(J[120],Y([0,1,43,77]),function(_,t,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function I(L){return g.buffer(L,"extension/package.json").then(F=>{try{return JSON.parse(F.toString("utf8"))}catch(R){throw new Error(A.localize(0,null))}})}t.getManifest=I}),define(J[121],Y([0,1,39,2,9,3,15,23,24,4,7,21,89,78,41,43,14,22,8,18,17,29,12]),function(_,t,g,A,I,L,F,R,u,h,S,y,w,O,c,f,b,C,D,m,o,r,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const i="scanningSystem",n="scanningUser",s="extracting",l="deleting",E="renaming";let P=class extends A.Disposable{constructor(k,j,V,$,K){super();this.beforeRemovingExtension=k,this.fileService=j,this.logService=V,this.environmentService=$,this.productService=K,this._devSystemExtensionsPath=null,this.systemExtensionsPath=$.builtinExtensionsPath,this.extensionsPath=$.extensionsPath,this.uninstalledPath=L.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new h.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(k){const j=[];(k===null||k===0)&&j.push(this.scanSystemExtensions().then(null,V=>Promise.reject(new R.ExtensionManagementError(this.joinErrors(V).message,i)))),(k===null||k===1)&&j.push(this.scanUserExtensions(!0).then(null,V=>Promise.reject(new R.ExtensionManagementError(this.joinErrors(V).message,n))));try{const V=await Promise.all(j);return C.flatten(V)}catch(V){throw this.joinErrors(V)}}async scanUserExtensions(k){this.logService.trace("Started scanning user extensions");let[j,V]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return V=V.filter($=>!j[new u.ExtensionIdentifierWithVersion($.identifier,$.manifest.version).key()]),k&&(V=u.groupByExtension(V,K=>K.identifier).map(K=>K.sort((ee,te)=>g.rcompare(ee.manifest.version,te.manifest.version))[0])),this.logService.trace("Scanned user extensions:",V.length),V}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(k,j,V){const $=k.key(),K=L.join(this.extensionsPath,`.${r.generateUuid()}`),ee=L.join(this.extensionsPath,$);try{await I.Promises.rm(ee)}catch(Q){try{await I.Promises.rm(ee)}catch(ae){}throw new R.ExtensionManagementError(O.localize(0,null,ee,k.id),l)}await this.extractAtLocation(k,j,K,V);let te=await this.scanExtension(S.URI.file(K),1);if(!te)throw new Error(O.localize(1,null,K));await this.storeMetadata(te,{installedTimestamp:Date.now()});try{await this.rename(k,K,ee,Date.now()+2*60*1e3),this.logService.info("Renamed to",ee)}catch(Q){try{await I.Promises.rm(K)}catch(ae){}if(Q.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",k.id);else throw this.logService.info(`Rename failed because of ${e.getErrorMessage(Q)}. Deleted from extracted location`,K),Q}try{te=await this.scanExtension(S.URI.file(ee),1)}catch(Q){}if(te)return te;throw new Error(O.localize(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(k,j){return this.setMetadata(k,j),await this.storeMetadata(k,Object.assign(Object.assign({},j),{installedTimestamp:k.installedTimestamp})),k}async storeMetadata(k,j){j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,j.installedTimestamp=j.installedTimestamp||void 0;const V=L.join(k.location.fsPath,"package.json"),$=await I.Promises.readFile(V,"utf8"),{manifest:K}=await this.parseManifest($);return K.__metadata=j,await I.Promises.writeFile(V,JSON.stringify(K,null,"	")),k}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...k){const j=k.map(V=>new u.ExtensionIdentifierWithVersion(V.identifier,V.manifest.version));await this.withUninstalledExtensions(V=>{j.forEach($=>V[$.key()]=!0)})}async setInstalled(k){await this.withUninstalledExtensions($=>delete $[k.key()]);const V=(await this.scanExtensions(1)).find($=>new u.ExtensionIdentifierWithVersion($.identifier,$.manifest.version).equals(k))||null;return V?(await this.storeMetadata(V,{installedTimestamp:Date.now()}),this.scanExtension(V.location,1)):null}async withUninstalledExtensions(k){return this.uninstalledFileLimiter.queue(async()=>{let j;try{j=await I.Promises.readFile(this.uninstalledPath,"utf8")}catch($){if($.code!=="ENOENT")throw $}let V={};if(j)try{V=JSON.parse(j)}catch($){}return k&&(k(V),Object.keys(V).length?await I.Promises.writeFile(this.uninstalledPath,JSON.stringify(V)):await I.Promises.rm(this.uninstalledPath)),V})}async removeExtension(k,j){this.logService.trace(`Deleting ${j} extension from disk`,k.identifier.id,k.location.fsPath),await I.Promises.rm(k.location.fsPath),this.logService.info("Deleted from disk",k.identifier.id,k.location.fsPath)}async removeUninstalledExtension(k){await this.removeExtension(k,"uninstalled"),await this.withUninstalledExtensions(j=>delete j[new u.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version).key()])}async extractAtLocation(k,j,V,$){this.logService.trace(`Started extracting the extension from ${j} to ${V}`);try{await I.Promises.rm(V)}catch(K){throw new R.ExtensionManagementError(this.joinErrors(K).message,l)}try{await f.extract(j,V,{sourcePath:"extension",overwrite:!0},$),this.logService.info(`Extracted extension to ${V}:`,k.id)}catch(K){try{await I.Promises.rm(V)}catch(ee){}throw new R.ExtensionManagementError(K.message,K instanceof f.ExtractError&&K.type?K.type:s)}}async rename(k,j,V,$){try{await I.Promises.rename(j,V)}catch(K){if(b.isWindows&&K&&K.code==="EPERM"&&Date.now()<$)return this.logService.info(`Failed renaming ${j} to ${V} with 'EPERM' error. Trying again...`,k.id),this.rename(k,j,V,$);throw new R.ExtensionManagementError(K.message||O.localize(3,null,j,V),K.code||E)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const k=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return k;const j=this.scanDevSystemExtensions(),[V,$]=await Promise.all([k,j]);return[...V,...$]}async scanExtensionsInDir(k,j){const V=new h.Limiter(10),$=await this.fileService.resolve(S.URI.file(k));return $.children?(await Promise.all($.children.filter(ee=>ee.isDirectory).map(ee=>V.queue(async()=>j===1&&o.basename(ee.resource).indexOf(".")===0?null:this.scanExtension(ee.resource,j))))).filter(ee=>ee&&ee.identifier):[]}async scanExtension(k,j){var V,$;try{const K=await this.fileService.resolve(k);if(K.children){const{manifest:ee,metadata:te}=await this.readManifest(k.fsPath),Q=(V=K.children.find(({name:T})=>/^readme(\.txt|\.md|)$/i.test(T)))===null||V===void 0?void 0:V.resource,ae=($=K.children.find(({name:T})=>/^changelog(\.txt|\.md|)$/i.test(T)))===null||$===void 0?void 0:$.resource,se={id:u.getGalleryExtensionId(ee.publisher,ee.name)},re={type:j,identifier:se,manifest:ee,location:k,readmeUrl:Q,changelogUrl:ae,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:j===0};return te&&(this.setMetadata(re,te),re.installedTimestamp=te.installedTimestamp),re}}catch(K){j!==0&&this.logService.trace(K)}return null}async scanDefaultSystemExtensions(){const k=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",k.length),k}async scanDevSystemExtensions(){const k=this.getDevSystemExtensionsList();if(k.length){const j=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",j.length),j.filter(V=>k.some($=>u.areSameExtensions(V.identifier,{id:$})))}else return[]}setMetadata(k,j){k.publisherDisplayName=j.publisherDisplayName||null,k.publisherId=j.publisherId||null,k.identifier.uuid=j.id,k.isMachineScoped=!!j.isMachineScoped,k.isBuiltin=k.type===0||!!j.isBuiltin}async removeUninstalledExtensions(){const k=await this.getUninstalledExtensions(),j=await this.scanAllUserExtensions(),V=new Set;for(const ee of j)k[new u.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]||V.add(ee.identifier.id.toLowerCase());const $=u.groupByExtension(j,ee=>ee.identifier);await h.Promises.settled($.map(async ee=>{const te=ee.sort((Q,ae)=>g.rcompare(Q.manifest.version,ae.manifest.version))[0];V.has(te.identifier.id.toLowerCase())||await this.beforeRemovingExtension(te)}));const K=j.filter(ee=>k[new u.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]);await h.Promises.settled(K.map(ee=>this.removeUninstalledExtension(ee)))}async removeOutdatedExtensions(){const k=await this.scanAllUserExtensions(),j=[],V=u.groupByExtension(k,$=>$.identifier);j.push(...C.flatten(V.map($=>$.sort((K,ee)=>g.rcompare(K.manifest.version,ee.manifest.version)).slice(1)))),await h.Promises.settled(j.map($=>this.removeExtension($,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(k=>k.name)}joinErrors(k){const j=Array.isArray(k)?k:[k];return j.length===1?j[0]instanceof Error?j[0]:new Error(j[0]):j.reduce((V,$)=>new Error(`${V.message}${V.message?",":""}${$ instanceof Error?$.message:$}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=L.normalize(L.join(D.FileAccess.asFileUri("",_).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(k){const j=[I.Promises.readFile(L.join(k,"package.json"),"utf8").then(ee=>this.parseManifest(ee)),I.Promises.readFile(L.join(k,"package.nls.json"),"utf8").then(void 0,ee=>ee.code!=="ENOENT"?Promise.reject(ee):"{}").then(ee=>JSON.parse(ee))],[{manifest:V,metadata:$},K]=await Promise.all(j);return{manifest:w.localizeManifest(V,K),metadata:$}}parseManifest(k){return new Promise((j,V)=>{try{const $=JSON.parse(k),K=$.__metadata||null;j({manifest:$,metadata:K})}catch($){V(new Error(O.localize(4,null)))}})}};P=ue([fe(1,m.IFileService),fe(2,F.ILogService),fe(3,y.INativeEnvironmentService),fe(4,c.IProductService)],P),t.ExtensionsScanner=P}),define(J[122],Y([0,1,76,3,9,2,22,43,23,24,21,4,10,39,7,40,14,15,97,28,42,49,17,29,95,11,8,26,120,101,121,102,103,18]),function(_,t,g,A,I,L,F,R,u,h,S,y,w,O,c,f,b,C,D,m,o,r,e,i,n,s,l,E,P,U,k,j,V,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const K="unsetUninstalled",ee="downloading",te="validating",Q="local",ae="unknown";let se=class extends L.Disposable{constructor(T,d,a,v,p,N,M){super();this.environmentService=T,this.galleryService=d,this.logService=a,this.downloadService=v,this.telemetryService=p,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new w.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new w.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new w.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new w.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const x=this._register(N.createInstance(j.ExtensionsLifecycle));this.extensionsScanner=this._register(N.createInstance(k.ExtensionsScanner,W=>x.postUninstall(W))),this.manifestCache=this._register(new D.ExtensionsManifestCache(T,this)),this.extensionsDownloader=this._register(N.createInstance(U.ExtensionsDownloader));const B=this._register(new V.ExtensionsWatcher(this,M,T,a));this._register(B.onDidChangeExtensionsByAnotherSource(({added:W,removed:H})=>{W.forEach(X=>this._onDidInstallExtension.fire({identifier:X.identifier,operation:0,local:X})),H.forEach(X=>this._onDidUninstallExtension.fire({identifier:X}))})),this._register(L.toDisposable(()=>{this.installingExtensions.forEach(W=>W.cancel()),this.uninstallingExtensions.forEach(W=>W.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(T){this.logService.trace("ExtensionManagementService#zip",T.identifier.id);const d=await this.collectFiles(T),a=await R.zip(e.joinPath(this.environmentService.tmpDir,i.generateUuid()).fsPath,d);return c.URI.file(a)}async unzip(T){return this.logService.trace("ExtensionManagementService#unzip",T.toString()),(await this.install(T)).identifier}async getManifest(T){const d=await this.downloadVsix(T),a=A.resolve(d.fsPath);return P.getManifest(a)}async collectFiles(T){const d=async v=>{let p=await I.Promises.readdir(v);p=p.map(x=>A.join(v,x));const N=await Promise.all(p.map(x=>I.Promises.stat(x)));let M=Promise.resolve([]);return N.forEach((x,B)=>{const W=p[B];x.isFile()&&(M=M.then(H=>[...H,W])),x.isDirectory()&&(M=M.then(H=>d(W).then(X=>[...H,...X])))}),M};return(await d(T.location.fsPath)).map(v=>({path:`extension/${A.relative(T.location.fsPath,v)}`,localPath:v}))}async install(T,d={}){return this.logService.trace("ExtensionManagementService#install",T.toString()),y.createCancelablePromise(async a=>{const v=await this.downloadVsix(T),p=A.resolve(v.fsPath),N=await P.getManifest(p),M={id:h.getGalleryExtensionId(N.publisher,N.name)};let x=1;if(N.engines&&N.engines.vscode&&!r.isEngineValid(N.engines.vscode,f.default.version,f.default.date))throw new Error(g.localize(0,null,M.id,f.default.version));const B=new h.ExtensionIdentifierWithVersion(M,N.version),H=(await this.getInstalled(1)).find(Z=>h.areSameExtensions(M,Z.identifier));if(H)if(d.isMachineScoped=d.isMachineScoped||H.isMachineScoped,d.isBuiltin=d.isBuiltin||H.isBuiltin,x=2,B.equals(new h.ExtensionIdentifierWithVersion(H.identifier,H.manifest.version)))try{await this.extensionsScanner.removeExtension(H,"existing")}catch(Z){throw new Error(g.localize(1,null,N.displayName||N.name))}else O.gt(H.manifest.version,N.version)&&await this.uninstallExtension(H);else{const Z=await this.unsetUninstalledAndGetLocal(B);if(Z)try{await this.extensionsScanner.removeExtension(Z,"existing")}catch(ie){throw new Error(g.localize(2,null,N.displayName||N.name))}}this.logService.info("Installing the extension:",M.id),this._onInstallExtension.fire({identifier:M,zipPath:p});let X;try{X=await this.getGalleryMetadata(h.getGalleryExtensionId(N.publisher,N.name))}catch(Z){}try{const Z=await this.installFromZipPath(B,p,d.installOnlyNewlyAddedFromExtensionPack?H:void 0,Object.assign(Object.assign({},X||{}),d),d,x,a);return this.logService.info("Successfully installed the extension:",M.id),Z}catch(Z){throw this.logService.error("Failed to install the extension:",M.id,Z.message),Z}})}async downloadVsix(T){if(T.scheme===l.Schemas.file)return T;if(!this.downloadService)throw new Error("Download service is not available");const d=e.joinPath(this.environmentService.tmpDir,i.generateUuid());return await this.downloadService.download(T,d),d}async installFromZipPath(T,d,a,v,p,N,M){try{const x=await this.installExtension({zipPath:d,identifierWithVersion:T,metadata:v},M);try{p.donotIncludePackAndDependencies||await this.installDependenciesAndPackExtensions(x,a,p)}catch(B){F.isNonEmptyArray(x.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",x.identifier.id,B.message),F.isNonEmptyArray(x.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",x.identifier.id,B.message)}return this._onDidInstallExtension.fire({identifier:T,zipPath:d,local:x,operation:N}),x}catch(x){throw this._onDidInstallExtension.fire({identifier:T,zipPath:d,operation:N,error:x}),x}}async canInstall(T){return!0}async installFromGallery(T,d={}){if(!this.galleryService.isEnabled())throw new Error(g.localize(3,null));try{T=await this.checkAndGetCompatibleVersion(T)}catch(p){const N=p&&p.code?p.code:ae;throw this.logService.error("Failed to install extension:",T.identifier.id,p?p.message:N),this.reportTelemetry(this.getTelemetryEvent(1),h.getGalleryExtensionTelemetryData(T),void 0,p),p instanceof Error&&(p.name=N),p}const a=new h.ExtensionIdentifierWithVersion(T.identifier,T.version).key();let v=this.installingExtensions.get(a);return v||(v=y.createCancelablePromise(p=>this.doInstallFromGallery(T,d,p)),this.installingExtensions.set(a,v),v.finally(()=>this.installingExtensions.delete(a))),v}async doInstallFromGallery(T,d,a){const v=new Date().getTime();let p=1;this.logService.info("Installing extension:",T.identifier.id),this._onInstallExtension.fire({identifier:T.identifier,gallery:T});try{const M=(await this.getInstalled(1)).find(W=>h.areSameExtensions(W.identifier,T.identifier));M&&(p=2);const x=await this.downloadInstallableExtension(T,p);x.metadata.isMachineScoped=d.isMachineScoped||(M==null?void 0:M.isMachineScoped),x.metadata.isBuiltin=d.isBuiltin||(M==null?void 0:M.isBuiltin);const B=await this.installExtension(x,a);try{await this.extensionsDownloader.delete(c.URI.file(x.zipPath))}catch(W){}if(!d.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(B,M,d)}catch(W){try{await this.uninstall(B)}catch(H){}throw W}return M&&O.neq(M.manifest.version,T.version)&&await this.extensionsScanner.setUninstalled(M),this.logService.info("Extensions installed successfully:",T.identifier.id),this._onDidInstallExtension.fire({identifier:T.identifier,gallery:T,local:B,operation:p}),this.reportTelemetry(this.getTelemetryEvent(p),h.getGalleryExtensionTelemetryData(T),new Date().getTime()-v,void 0),B}catch(N){const M=N&&N.code?N.code:ae;throw this.logService.error("Failed to install extension:",T.identifier.id,N?N.message:M),this._onDidInstallExtension.fire({identifier:T.identifier,gallery:T,operation:p,error:M}),this.reportTelemetry(this.getTelemetryEvent(p),h.getGalleryExtensionTelemetryData(T),new Date().getTime()-v,N),N instanceof Error&&(N.name=M),N}}async checkAndGetCompatibleVersion(T){if(await this.isMalicious(T))throw new u.ExtensionManagementError(g.localize(4,null),u.INSTALL_ERROR_MALICIOUS);const d=await this.galleryService.getCompatibleExtension(T);if(!d)throw new u.ExtensionManagementError(g.localize(5,null,T.identifier.id,f.default.version),u.INSTALL_ERROR_INCOMPATIBLE);return d}async reinstallFromGallery(T){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",T.identifier.id),!this.galleryService.isEnabled())throw new Error(g.localize(6,null));const d=await this.findGalleryExtension(T);if(!d)throw new Error(g.localize(7,null));await this.extensionsScanner.setUninstalled(T);try{await this.extensionsScanner.removeUninstalledExtension(T)}catch(a){throw new Error(g.localize(8,null,m.toErrorMessage(a)))}await this.installFromGallery(d)}getTelemetryEvent(T){return T===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(T){const d=await this.getExtensionsReport();return h.getMaliciousExtensionsSet(d).has(T.identifier.id)}async downloadInstallableExtension(T,d){const a={id:T.identifier.uuid,publisherId:T.publisherId,publisherDisplayName:T.publisherDisplayName};let v;try{this.logService.trace("Started downloading extension:",T.identifier.id),v=(await this.extensionsDownloader.downloadExtension(T,d)).fsPath,this.logService.info("Downloaded extension:",T.identifier.id,v)}catch(p){throw new u.ExtensionManagementError(this.joinErrors(p).message,ee)}try{const p=await P.getManifest(v);return{zipPath:v,identifierWithVersion:new h.ExtensionIdentifierWithVersion(T.identifier,p.version),metadata:a}}catch(p){throw new u.ExtensionManagementError(this.joinErrors(p).message,te)}}async installExtension(T,d){try{const a=await this.unsetUninstalledAndGetLocal(T.identifierWithVersion);if(a)return T.metadata?this.extensionsScanner.saveMetadataForLocalExtension(a,T.metadata):a}catch(a){throw b.isMacintosh?new u.ExtensionManagementError(g.localize(9,null),K):new u.ExtensionManagementError(g.localize(10,null),K)}return this.extractAndInstall(T,d)}async unsetUninstalledAndGetLocal(T){if(!await this.isUninstalled(T))return null;this.logService.trace("Removing the extension from uninstalled list:",T.id);const a=await this.extensionsScanner.setInstalled(T);return this.logService.info("Removed the extension from uninstalled list:",T.id),a}async extractAndInstall({zipPath:T,identifierWithVersion:d,metadata:a},v){let p=await this.extensionsScanner.extractUserExtension(d,T,v);return this.logService.info("Installation completed.",d.id),a&&(p=await this.extensionsScanner.saveMetadataForLocalExtension(p,a)),p}async installDependenciesAndPackExtensions(T,d,a){if(!this.galleryService.isEnabled())return;const v=T.manifest.extensionDependencies||[];if(T.manifest.extensionPack)for(const p of T.manifest.extensionPack)d&&d.manifest.extensionPack&&d.manifest.extensionPack.some(N=>h.areSameExtensions({id:N},{id:p}))||v.every(N=>!h.areSameExtensions({id:N},{id:p}))&&v.push(p);if(v.length){const p=await this.getInstalled(),N=v.filter(M=>p.every(({identifier:x})=>!h.areSameExtensions(x,{id:M})));if(N.length){const x=(await this.galleryService.query({names:N,pageSize:v.length},E.CancellationToken.None)).firstPage;try{await y.Promises.settled(x.map(B=>this.installFromGallery(B,a)))}catch(B){try{await this.rollback(x)}catch(W){}throw B}}}}async rollback(T){const a=(await this.getInstalled(1)).filter(v=>T.some(p=>new h.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).equals(new h.ExtensionIdentifierWithVersion(p.identifier,p.version))));await y.Promises.settled(a.map(v=>this.uninstall(v)))}async uninstall(T,d={}){this.logService.trace("ExtensionManagementService#uninstall",T.identifier.id);const a=await this.getInstalled(1),v=a.find(p=>h.areSameExtensions(p.identifier,T.identifier));if(!v)throw new Error(g.localize(11,null,T.manifest.displayName||T.manifest.name));try{await this.checkForDependenciesAndUninstall(v,a,d)}catch(p){throw this.joinErrors(p)}}async updateMetadata(T,d){return this.logService.trace("ExtensionManagementService#updateMetadata",T.identifier.id),T=await this.extensionsScanner.saveMetadataForLocalExtension(T,Object.assign(Object.assign({},T.manifest.__metadata||{}),d)),this.manifestCache.invalidate(),T}async updateExtensionScope(T,d){return this.logService.trace("ExtensionManagementService#updateExtensionScope",T.identifier.id),T=await this.extensionsScanner.saveMetadataForLocalExtension(T,Object.assign(Object.assign({},T.manifest.__metadata||{}),{isMachineScoped:d})),this.manifestCache.invalidate(),T}async getGalleryMetadata(T){const d=await this.findGalleryExtensionByName(T);return d?{id:d.identifier.uuid,publisherDisplayName:d.publisherDisplayName,publisherId:d.publisherId}:void 0}async findGalleryExtension(T){if(T.identifier.uuid){const d=await this.findGalleryExtensionById(T.identifier.uuid);return d||this.findGalleryExtensionByName(T.identifier.id)}return this.findGalleryExtensionByName(T.identifier.id)}async findGalleryExtensionById(T){return(await this.galleryService.query({ids:[T],pageSize:1},E.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(T){return(await this.galleryService.query({names:[T],pageSize:1},E.CancellationToken.None)).firstPage[0]}joinErrors(T){const d=Array.isArray(T)?T:[T];return d.length===1?d[0]instanceof Error?d[0]:new Error(d[0]):d.reduce((a,v)=>new Error(`${a.message}${a.message?",":""}${v instanceof Error?v.message:v}`),new Error(""))}async checkForDependenciesAndUninstall(T,d,a){try{await this.preUninstallExtension(T);const v=a.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(T,d);await this.uninstallExtensions(T,v,d,a)}catch(v){throw await this.postUninstallExtension(T,new u.ExtensionManagementError(v instanceof Error?v.message:v,Q)),v}await this.postUninstallExtension(T)}async uninstallExtensions(T,d,a,v){const p=[T,...d];if(!v.donotCheckDependents)for(const N of p)this.checkForDependents(N,p,a,T);await y.Promises.settled([this.uninstallExtension(T),...d.map(N=>this.doUninstall(N))])}checkForDependents(T,d,a,v){const p=this.getDependents(T,a);if(p.length){const N=p.filter(M=>d.indexOf(M)===-1);if(N.length)throw new Error(this.getDependentsErrorMessage(T,N,v))}}getDependentsErrorMessage(T,d,a){return a===T?d.length===1?g.localize(12,null,a.manifest.displayName||a.manifest.name,d[0].manifest.displayName||d[0].manifest.name):d.length===2?g.localize(13,null,a.manifest.displayName||a.manifest.name,d[0].manifest.displayName||d[0].manifest.name,d[1].manifest.displayName||d[1].manifest.name):g.localize(14,null,a.manifest.displayName||a.manifest.name,d[0].manifest.displayName||d[0].manifest.name,d[1].manifest.displayName||d[1].manifest.name):d.length===1?g.localize(15,null,a.manifest.displayName||a.manifest.name,T.manifest.displayName||T.manifest.name,d[0].manifest.displayName||d[0].manifest.name):d.length===2?g.localize(16,null,a.manifest.displayName||a.manifest.name,T.manifest.displayName||T.manifest.name,d[0].manifest.displayName||d[0].manifest.name,d[1].manifest.displayName||d[1].manifest.name):g.localize(17,null,a.manifest.displayName||a.manifest.name,T.manifest.displayName||T.manifest.name,d[0].manifest.displayName||d[0].manifest.name,d[1].manifest.displayName||d[1].manifest.name)}getAllPackExtensionsToUninstall(T,d,a=[]){if(a.indexOf(T)!==-1)return[];a.push(T);const v=T.manifest.extensionPack?T.manifest.extensionPack:[];if(v.length){const p=d.filter(M=>!M.isBuiltin&&v.some(x=>h.areSameExtensions({id:x},M.identifier))),N=[];for(const M of p)N.push(...this.getAllPackExtensionsToUninstall(M,d,a));return[...p,...N]}return[]}getDependents(T,d){return d.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(v=>h.areSameExtensions({id:v},T.identifier)))}async doUninstall(T){try{await this.preUninstallExtension(T),await this.uninstallExtension(T)}catch(d){throw await this.postUninstallExtension(T,new u.ExtensionManagementError(d instanceof Error?d.message:d,Q)),d}await this.postUninstallExtension(T)}async preUninstallExtension(T){if(!await I.Promises.exists(T.location.fsPath))throw new Error(g.localize(18,null));this.logService.info("Uninstalling extension:",T.identifier.id),this._onUninstallExtension.fire(T.identifier)}async uninstallExtension(T){let d=this.uninstallingExtensions.get(T.identifier.id);return d||(d=y.createCancelablePromise(async()=>{const a=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...a.filter(v=>h.areSameExtensions(v.identifier,T.identifier)))}),this.uninstallingExtensions.set(T.identifier.id,d),d.finally(()=>this.uninstallingExtensions.delete(T.identifier.id))),d}async postUninstallExtension(T,d){if(d)this.logService.error("Failed to uninstall extension:",T.identifier.id,d.message);else if(this.logService.info("Successfully uninstalled extension:",T.identifier.id),T.identifier.uuid)try{await this.galleryService.reportStatistic(T.manifest.publisher,T.manifest.name,T.manifest.version,"uninstall")}catch(v){}this.reportTelemetry("extensionGallery:uninstall",h.getLocalExtensionTelemetryData(T),void 0,d);const a=d?d instanceof u.ExtensionManagementError?d.code:ae:void 0;this._onDidUninstallExtension.fire({identifier:T.identifier,error:a})}getInstalled(T=null){return this.extensionsScanner.scanExtensions(T)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(T){return(await this.filterUninstalled(T)).length===1}async filterUninstalled(...T){const d=[],a=await this.extensionsScanner.getUninstalledExtensions();for(const v of T)a[v.key()]&&d.push(v.key());return d}getExtensionsReport(){const T=new Date().getTime();return(!this.reportedExtensions||T-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=T),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const T=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${T.length} reported extensions from service`),T}catch(T){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(T,d,a,v){const p=v?v instanceof u.ExtensionManagementError?v.code:ae:void 0;this.telemetryService.publicLogError(T,Object.assign(Object.assign({},d),{success:!v,duration:a,errorcode:p}))}};se=ue([fe(0,S.INativeEnvironmentService),fe(1,u.IExtensionGalleryService),fe(2,C.ILogService),fe(3,s.optional(n.IDownloadService)),fe(4,o.ITelemetryService),fe(5,s.IInstantiationService),fe(6,$.IFileService)],se),t.ExtensionManagementService=se}),define(J[123],Y([0,1,132,112,2,13,12,111,27,15,16,21,98]),function(_,t,g,A,I,L,F,R,u,h,S,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let O=class extends I.Disposable{constructor(f,b,C){super();this.environmentService=b,this.logService=C,this.configure(f.getValue()),this._register(f.onDidChangeConfiguration(()=>this.configure(f.getValue()),this))}configure(f){this.proxyUrl=f.http&&f.http.proxy,this.strictSSL=!!(f.http&&f.http.proxyStrictSSL),this.authorization=f.http&&f.http.proxyAuthorization}async request(f,b){this.logService.trace("RequestService#request",f.url);const{proxyUrl:C,strictSSL:D}=this,m=Object.assign(Object.assign({},process.env),await w.resolveShellEnv(this.logService,this.environmentService.args,process.env)),o=f.agent?f.agent:await R.getProxyAgent(f.url||"",m,{proxyUrl:C,strictSSL:D});return f.agent=o,f.strictSSL=D,this.authorization&&(f.headers=Object.assign(Object.assign({},f.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(f,b)}async getNodeRequest(f){return(A.parse(f.url).protocol==="https:"?await new Promise((D,m)=>{_(["https"],D,m)}):await new Promise((D,m)=>{_(["http"],D,m)})).request}_request(f,b){return new Promise(async(C,D)=>{let m;const o=A.parse(f.url),r=f.getRawRequest?f.getRawRequest(f):await this.getNodeRequest(f),e={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:L.isBoolean(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(e.auth=f.user+":"+f.password),m=r(e,i=>{const n=L.isNumber(f.followRedirects)?f.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request(Object.assign(Object.assign({},f),{url:i.headers.location,followRedirects:n-1}),b).then(C,D);else{let s=i;i.headers["content-encoding"]==="gzip"&&(s=i.pipe(g.createGunzip())),C({res:i,stream:S.streamToBufferReadableStream(s)})}}),m.on("error",D),f.timeout&&m.setTimeout(f.timeout),f.data&&typeof f.data=="string"&&m.write(f.data),m.end(),b.onCancellationRequested(()=>{m.abort(),D(F.canceled())})})}async resolveProxy(f){}};O=ue([fe(0,u.IConfigurationService),fe(1,y.INativeEnvironmentService),fe(2,h.ILogService)],O),t.RequestService=O}),define(J[133],Y([0,1,31,36,134,9,3,4,40,52,50,100,21,88,23,122,116,42,56,117,115,55,123,27,110,118,15,8,105,119,106,18,107,2,41,96,7,104,53,12,28,16,33]),function(_,t,g,A,I,L,F,R,u,h,S,y,w,O,c,f,b,C,D,m,o,r,e,i,n,s,l,E,P,U,k,j,V,$,K,ee,te,Q,ae,se,re,T,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class a extends $.Disposable{constructor(N){super();this.argv=N,I.gracefulify(A),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[N,M]=await this.initServices();return N.invokeFunction(async x=>{const B=x.get(l.ILogService),W=x.get(j.IFileService),H=x.get(w.INativeEnvironmentService),X=x.get(c.IExtensionManagementCLIService);return B.info("CLI main",this.argv),this.registerErrorHandler(B),await this.doRun(H,X,W),R.raceTimeout(D.combinedAppender(...M).flush(),1e3)})}async initServices(){const N=new h.ServiceCollection,M=Object.assign({_serviceBrand:void 0},u.default);N.set(K.IProductService,M);const x=new O.NativeEnvironmentService(this.argv,M);N.set(w.INativeEnvironmentService,x),await Promise.all([x.appSettingsHome.fsPath,x.extensionsPath].map(ge=>ge?L.Promises.mkdir(ge,{recursive:!0}):void 0));const B=l.getLogLevel(x),W=[];W.push(new P.SpdLogLogger("cli",F.join(x.logsPath,"cli.log"),!0,B)),B===l.LogLevel.Trace&&W.push(new l.ConsoleLogger(B));const H=this._register(new l.MultiplexLogService(W));N.set(l.ILogService,H);const X=this._register(new k.FileService(H));N.set(j.IFileService,X);const Z=this._register(new V.DiskFileSystemProvider(H));X.registerProvider(E.Schemas.file,Z);const ie=this._register(new n.ConfigurationService(x.settingsResource,X));N.set(i.IConfigurationService,ie),await ie.initialize(),N.set(r.IRequestService,new S.SyncDescriptor(e.RequestService)),N.set(c.IExtensionManagementService,new S.SyncDescriptor(f.ExtensionManagementService)),N.set(c.IExtensionGalleryService,new S.SyncDescriptor(b.ExtensionGalleryService)),N.set(c.IExtensionManagementCLIService,new S.SyncDescriptor(ee.ExtensionManagementCLIService)),N.set(ae.ILocalizationsService,new S.SyncDescriptor(Q.LocalizationsService));const ce=[];if(x.isBuilt&&!x.isExtensionDevelopment&&!x.disableTelemetry&&M.enableTelemetry){M.aiConfig&&M.aiConfig.asimovKey&&ce.push(new s.AppInsightsAppender("monacoworkbench",null,M.aiConfig.asimovKey));const{appRoot:ge,extensionsPath:Pe,installSourcePath:Fe}=x,Re={appender:D.combinedAppender(...ce),sendErrorTelemetry:!1,commonProperties:(async()=>{let Se;try{const ke=await L.Promises.readFile(F.join(x.userDataPath,"storage.json"));Se=JSON.parse(ke.toString())[C.machineIdKey]}catch(ke){ke.code!=="ENOENT"&&H.error(ke)}return o.resolveCommonProperties(X,g.release(),g.hostname(),process.arch,M.commit,M.version,Se,M.msftInternalDomains,Fe)})(),piiPaths:[ge,Pe]};N.set(C.ITelemetryService,new S.SyncDescriptor(m.TelemetryService,[Re]))}else N.set(C.ITelemetryService,D.NullTelemetryService);return[new y.InstantiationService(N),ce]}registerErrorHandler(N){se.setUnexpectedErrorHandler(M=>{const x=re.toErrorMessage(M,!0);!x||N.error(`[uncaught exception in CLI]: ${x}`)})}async doRun(N,M,x){if(this.argv["install-source"])return this.setInstallSource(N,x,this.argv["install-source"]);if(this.argv["list-extensions"])return M.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return M.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return M.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return M.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await U.buildTelemetryMessage(N.appRoot,N.extensionsPath))}asExtensionIdOrVSIX(N){return N.map(M=>/\.vsix$/i.test(M)?te.URI.file(F.isAbsolute(M)?M:F.join(d.cwd(),M)):M)}async setInstallSource(N,M,x){await M.writeFile(te.URI.file(N.installSourcePath),T.VSBuffer.fromString(x.slice(0,30)))}}async function v(p){const N=new a(p);try{await N.run()}finally{N.dispose()}}t.main=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9744231fc12f1aed21089180b3f0394d694bd2a2/core/vs/code/node/cliProcessMain.js.map
