/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/types","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/editor/common/core/position","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/json","vs/base/common/severity","vs/base/common/marshalling","fs","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/codicons","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","os","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],pe=function(X){for(var e=[],p=0,R=X.length;p<R;p++)e[p]=ge[X[p]];return e};define(ge[50],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(R,C){if(!R)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=p}),define(ge[68],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const p=Object.prototype.hasOwnProperty;function R(r){const P=[];for(let l in r)p.call(r,l)&&P.push(r[l]);return P}e.values=R;function C(r,P){for(let l in r)if(p.call(r,l)&&P({key:l,value:r[l]},function(){delete r[l]})===!1)return}e.forEach=C;function y(r,P){const l=Object.create(null);for(const f of r){const c=P(f);let h=l[c];h||(h=l[c]=[]),h.push(f)}return l}e.groupBy=y;function A(r){const P=Object.create(null);return r&&r.forEach((l,f)=>{P[f]=l}),P}e.fromMap=A;function I(r,P){const l=[],f=[];for(let c of r)P.has(c)||l.push(c);for(let c of P)r.has(c)||f.push(c);return{removed:l,added:f}}e.diffSets=I;function E(r,P){const l=[],f=[];for(let[c,h]of r)P.has(c)||l.push(h);for(let[c,h]of P)r.has(c)||f.push(h);return{removed:l,added:f}}e.diffMaps=E;class k{constructor(){this.map=new Map}add(P,l){let f=this.map.get(P);f||(f=new Set,this.map.set(P,f)),f.add(l)}delete(P,l){const f=this.map.get(P);!f||(f.delete(l),f.size===0&&this.map.delete(P))}forEach(P,l){const f=this.map.get(P);!f||f.forEach(l)}}e.SetMap=k}),define(ge[51],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(A){return(I,E,k)=>{let r=null,P=null;if(typeof k.value=="function"?(r="value",P=k.value):typeof k.get=="function"&&(r="get",P=k.get),!P)throw new Error("not supported");k[r]=A(P,E)}}e.createDecorator=p;function R(A,I,E){let k=null,r=null;if(typeof E.value=="function"?(k="value",r=E.value,r.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(k="get",r=E.get),!r)throw new Error("not supported");const P=`$memoize$${I}`;E[k]=function(...l){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:r.apply(this,l)}),this[P]}}e.memoize=R;function C(A,I,E){return p((k,r)=>{const P=`$debounce$${r}`,l=`$debounce$result$${r}`;return function(...f){this[l]||(this[l]=E?E():void 0),clearTimeout(this[P]),I&&(this[l]=I(this[l],...f),f=[this[l]]),this[P]=setTimeout(()=>{k.apply(this,f),this[l]=E?E():void 0},A)}})}e.debounce=C;function y(A,I,E){return p((k,r)=>{const P=`$throttle$timer$${r}`,l=`$throttle$result$${r}`,f=`$throttle$lastRun$${r}`,c=`$throttle$pending$${r}`;return function(...h){if(this[l]||(this[l]=E?E():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),I&&(this[l]=I(this[l],...h)),this[c])return;const _=this[f]+A;_<=Date.now()?(this[f]=Date.now(),k.apply(this,[this[l]]),this[l]=E?E():void 0):(this[c]=!0,this[P]=setTimeout(()=>{this[c]=!1,this[f]=Date.now(),k.apply(this,[this[l]]),this[l]=E?E():void 0},_-Date.now()))}})}e.throttle=y}),define(ge[14],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=p,e.errorHandler=new p;function R(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=R;function C(g){E(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=C;function y(g){E(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=y;function A(g){if(g instanceof Error){let{name:t,message:i}=g;const s=g.stacktrace||g.stack;return{$isError:!0,name:t,message:i,stack:s}}return g}e.transformErrorForSerialization=A;const I="Canceled";function E(g){return g instanceof Error&&g.name===I&&g.message===I}e.isPromiseCanceledError=E;class k extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=k;function r(){const g=new Error(I);return g.name=g.message,g}e.canceled=r;function P(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=P;function l(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=l;function f(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function c(g){const t=new Error(`${g} has been disposed`);return t.name="DISPOSED",t}e.disposed=c;function h(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=h;class _ extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=_;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function d(g){const t=g;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=d;function u(g,t=Object.create(null)){const i=new Error(g);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=u}),define(ge[18],pe([0,1,14]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(q,O=0){return q[q.length-(1+O)]}e.tail=R;function C(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=C;function y(q,O,F=(B,$)=>B===$){if(q===O)return!0;if(!q||!O||q.length!==O.length)return!1;for(let B=0,$=q.length;B<$;B++)if(!F(q[B],O[B]))return!1;return!0}e.equals=y;function A(q,O,F){let B=0,$=q.length-1;for(;B<=$;){const Y=(B+$)/2|0,ce=F(q[Y],O);if(ce<0)B=Y+1;else if(ce>0)$=Y-1;else return Y}return-(B+1)}e.binarySearch=A;function I(q,O){let F=0,B=q.length;if(B===0)return 0;for(;F<B;){const $=Math.floor((F+B)/2);O(q[$])?B=$:F=$+1}return F}e.findFirstInSorted=I;function E(q,O,F){if(q=q|0,q>=O.length)throw new TypeError("invalid index");let B=O[Math.floor(O.length*Math.random())],$=[],Y=[],ce=[];for(let we of O){const Re=F(we,B);Re<0?$.push(we):Re>0?Y.push(we):ce.push(we)}return q<$.length?E(q,$,F):q<$.length+ce.length?ce[0]:E(q-($.length+ce.length),Y,F)}e.quickSelect=E;function k(q,O){const F=[];let B;for(const $ of q.slice(0).sort(O))!B||O(B[0],$)!==0?(B=[$],F.push(B)):B.push($);return F}e.groupBy=k;function r(q,O,F){const B=[];function $(we,Re,ke){if(Re===0&&ke.length===0)return;const Me=B[B.length-1];Me&&Me.start+Me.deleteCount===we?(Me.deleteCount+=Re,Me.toInsert.push(...ke)):B.push({start:we,deleteCount:Re,toInsert:ke})}let Y=0,ce=0;for(;;){if(Y===q.length){$(Y,0,O.slice(ce));break}if(ce===O.length){$(Y,q.length-Y,[]);break}const we=q[Y],Re=O[ce],ke=F(we,Re);ke===0?(Y+=1,ce+=1):ke<0?($(Y,1,[]),Y+=1):ke>0&&($(Y,0,[Re]),ce+=1)}return B}e.sortedDiff=r;function P(q,O,F){const B=r(q,O,F),$=[],Y=[];for(const ce of B)$.push(...q.slice(ce.start,ce.start+ce.deleteCount)),Y.push(...ce.toInsert);return{removed:$,added:Y}}e.delta=P;function l(q,O,F){if(F===0)return[];const B=q.slice(0,F).sort(O);return c(q,O,B,F,q.length),B}e.top=l;function f(q,O,F,B,$){return F===0?Promise.resolve([]):new Promise((Y,ce)=>{(async()=>{const we=q.length,Re=q.slice(0,F).sort(O);for(let ke=F,Me=Math.min(F+B,we);ke<we;ke=Me,Me=Math.min(Me+B,we)){if(ke>F&&await new Promise(Ge=>setTimeout(Ge)),$&&$.isCancellationRequested)throw p.canceled();c(q,O,Re,ke,Me)}return Re})().then(Y,ce)})}e.topAsync=f;function c(q,O,F,B,$){for(const Y=F.length;B<$;B++){const ce=q[B];if(O(ce,F[Y-1])<0){F.pop();const we=I(F,Re=>O(ce,Re)<0);F.splice(we,0,ce)}}}function h(q){return q.filter(O=>!!O)}e.coalesce=h;function _(q){let O=0;for(let F=0;F<q.length;F++)q[F]&&(q[O]=q[F],O+=1);q.length=O}e.coalesceInPlace=_;function w(q,O,F){q.splice(F,0,q.splice(O,1)[0])}e.move=w;function b(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=b;function d(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=d;function u(q,O){if(!O)return q.filter((B,$)=>q.indexOf(B)===$);const F=Object.create(null);return q.filter(B=>{const $=O(B);return F[$]?!1:(F[$]=!0,!0)})}e.distinct=u;function g(q){const O=new Set;return q.filter(F=>O.has(F)?!1:(O.add(F),!0))}e.distinctES6=g;function t(q){const O=Object.create(null);return F=>{const B=q(F);return O[B]?!1:(O[B]=!0,!0)}}e.uniqueFilter=t;function i(q,O){for(let F=q.length-1;F>=0;F--){const B=q[F];if(O(B))return F}return-1}e.lastIndex=i;function s(q,O){return q.length>0?q[0]:O}e.firstOrDefault=s;function n(q,O,F=(B,$)=>B===$){let B=0;for(let $=0,Y=Math.min(q.length,O.length);$<Y&&F(q[$],O[$]);$++)B++;return B}e.commonPrefixLength=n;function o(q){return[].concat(...q)}e.flatten=o;function v(q,O){let F=typeof O=="number"?q:0;typeof O=="number"?F=q:(F=0,O=q);const B=[];if(F<=O)for(let $=F;$<O;$++)B.push($);else for(let $=F;$>O;$--)B.push($);return B}e.range=v;function m(q,O,F){return q.reduce((B,$)=>(B[O($)]=F?F($):$,B),Object.create(null))}e.index=m;function S(q,O){return q.push(O),()=>D(q,O)}e.insert=S;function D(q,O){const F=q.indexOf(O);if(F>-1)return q.splice(F,1),O}e.remove=D;function a(q,O,F){const B=q.slice(0,O),$=q.slice(O);return B.concat(F,$)}e.arrayInsert=a;function T(q,O){let F;if(typeof O=="number"){let B=O;F=()=>{const $=Math.sin(B++)*179426549;return $-Math.floor($)}}else F=Math.random;for(let B=q.length-1;B>0;B-=1){const $=Math.floor(F()*(B+1)),Y=q[B];q[B]=q[$],q[$]=Y}}e.shuffle=T;function L(q,O){const F=q.indexOf(O);F>-1&&(q.splice(F,1),q.unshift(O))}e.pushToStart=L;function U(q,O){const F=q.indexOf(O);F>-1&&(q.splice(F,1),q.push(O))}e.pushToEnd=U;function G(q,O){return Array.isArray(q)?q.map(O):O(q)}e.mapArrayOrNot=G;function te(q){return Array.isArray(q)?q:[q]}e.asArray=te;function V(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=V;function N(q,O){for(const F of q){const B=O(F);if(B!==void 0)return B}}e.mapFind=N;function W(q,O){let F=Number.MAX_SAFE_INTEGER,B=0;return q.forEach(($,Y)=>{const ce=O($);ce<F&&(F=ce,B=Y)}),B}e.minIndex=W;function M(q,O){let F=Number.MIN_SAFE_INTEGER,B=0;return q.forEach(($,Y)=>{const ce=O($);ce>F&&(F=ce,B=Y)}),B}e.maxIndex=M}),define(ge[69],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(R){const C=this;let y=!1,A;return function(){return y||(y=!0,A=R.apply(C,arguments)),A}}e.once=p}),define(ge[70],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class p{constructor(C){this._prefix=C,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=p,e.defaultGenerator=new p("id#")}),define(ge[52],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(R){function C(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}R.is=C;const y=Object.freeze([]);function A(){return y}R.empty=A;function*I(g){yield g}R.single=I;function E(g){return g||y}R.from=E;function k(g){return!g||g[Symbol.iterator]().next().done===!0}R.isEmpty=k;function r(g){return g[Symbol.iterator]().next().value}R.first=r;function P(g,t){for(const i of g)if(t(i))return!0;return!1}R.some=P;function l(g,t){for(const i of g)if(t(i))return i}R.find=l;function*f(g,t){for(const i of g)t(i)&&(yield i)}R.filter=f;function*c(g,t){let i=0;for(const s of g)yield t(s,i++)}R.map=c;function*h(...g){for(const t of g)for(const i of t)yield i}R.concat=h;function*_(g){for(const t of g)for(const i of t)yield i}R.concatNested=_;function w(g,t,i){let s=i;for(const n of g)s=t(s,n);return s}R.reduce=w;function*b(g,t,i=g.length){for(t<0&&(t+=g.length),i<0?i+=g.length:i>g.length&&(i=g.length);t<i;t++)yield g[t]}R.slice=b;function d(g,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,g];const s=g[Symbol.iterator]();for(let n=0;n<t;n++){const o=s.next();if(o.done)return[i,R.empty()];i.push(o.value)}return[i,{[Symbol.iterator](){return s}}]}R.consume=d;function u(g,t,i=(s,n)=>s===n){const s=g[Symbol.iterator](),n=t[Symbol.iterator]();for(;;){const o=s.next(),v=n.next();if(o.done!==v.done)return!1;if(o.done)return!0;if(!i(o.value,v.value))return!1}}R.equals=u})(p=e.Iterable||(e.Iterable={}))}),define(ge[53],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var y;(function(t){t.DEFAULT={allowTrailingComma:!0}})(y=e.ParseOptions||(e.ParseOptions={}));function A(t,i=!1){let s=0,n=t.length,o="",v=0,m=16,S=0;function D(V){let N=0,W=0;for(;N<V;){const M=t.charCodeAt(s);if(M>=48&&M<=57)W=W*16+M-48;else if(M>=65&&M<=70)W=W*16+M-65+10;else if(M>=97&&M<=102)W=W*16+M-97+10;else break;s++,N++}return N<V&&(W=-1),W}function a(V){s=V,o="",v=0,m=16,S=0}function T(){const V=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&k(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&k(t.charCodeAt(s)))for(s++;s<t.length&&k(t.charCodeAt(s));)s++;else return S=3,t.substring(V,s);let N=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&k(t.charCodeAt(s))){for(s++;s<t.length&&k(t.charCodeAt(s));)s++;N=s}else S=3;return t.substring(V,N)}function L(){let V="",N=s;for(;;){if(s>=n){V+=t.substring(N,s),S=2;break}const W=t.charCodeAt(s);if(W===34){V+=t.substring(N,s),s++;break}if(W===92){if(V+=t.substring(N,s),s++,s>=n){S=2;break}switch(t.charCodeAt(s++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:const q=D(4);q>=0?V+=String.fromCharCode(q):S=4;break;default:S=5}N=s;continue}if(W>=0&&W<=31)if(E(W)){V+=t.substring(N,s),S=2;break}else S=6;s++}return V}function U(){if(o="",S=0,v=s,s>=n)return v=n,m=17;let V=t.charCodeAt(s);if(I(V)){do s++,o+=String.fromCharCode(V),V=t.charCodeAt(s);while(I(V));return m=15}if(E(V))return s++,o+=String.fromCharCode(V),V===13&&t.charCodeAt(s)===10&&(s++,o+=`
`),m=14;switch(V){case 123:return s++,m=1;case 125:return s++,m=2;case 91:return s++,m=3;case 93:return s++,m=4;case 58:return s++,m=6;case 44:return s++,m=5;case 34:return s++,o=L(),m=10;case 47:const N=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<n&&!E(t.charCodeAt(s));)s++;return o=t.substring(N,s),m=12}if(t.charCodeAt(s+1)===42){s+=2;const W=n-1;let M=!1;for(;s<W;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,M=!0;break}s++}return M||(s++,S=1),o=t.substring(N,s),m=13}return o+=String.fromCharCode(V),s++,m=16;case 45:if(o+=String.fromCharCode(V),s++,s===n||!k(t.charCodeAt(s)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=T(),m=11;default:for(;s<n&&G(V);)s++,V=t.charCodeAt(s);if(v!==s){switch(o=t.substring(v,s),o){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return o+=String.fromCharCode(V),s++,m=16}}function G(V){if(I(V)||E(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function te(){let V;do V=U();while(V>=12&&V<=15);return V}return{setPosition:a,getPosition:()=>s,scan:i?te:U,getToken:()=>m,getTokenValue:()=>o,getTokenOffset:()=>v,getTokenLength:()=>s-v,getTokenError:()=>S}}e.createScanner=A;function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var r;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(r||(r={}));function P(t,i){const s=[],n=new Object;let o;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function S(D,a,T,L){v.value=D,v.offset=a,v.length=T,v.type=L,v.colonOffset=void 0,o=v}try{d(t,{onObjectBegin:(D,a)=>{if(i<=D)throw n;o=void 0,m=i>D,s.push("")},onObjectProperty:(D,a,T)=>{if(i<a||(S(D,a,T,"property"),s[s.length-1]=D,i<=a+T))throw n},onObjectEnd:(D,a)=>{if(i<=D)throw n;o=void 0,s.pop()},onArrayBegin:(D,a)=>{if(i<=D)throw n;o=void 0,s.push(0)},onArrayEnd:(D,a)=>{if(i<=D)throw n;o=void 0,s.pop()},onLiteralValue:(D,a,T)=>{if(i<a||(S(D,a,T,g(D)),i<=a+T))throw n},onSeparator:(D,a,T)=>{if(i<=a)throw n;if(D===":"&&o&&o.type==="property")o.colonOffset=a,m=!1,o=void 0;else if(D===","){const L=s[s.length-1];typeof L=="number"?s[s.length-1]=L+1:(m=!0,s[s.length-1]=""),o=void 0}}})}catch(D){if(D!==n)throw D}return{path:s,previousNode:o,isAtPropertyKey:m,matches:D=>{let a=0;for(let T=0;a<D.length&&T<s.length;T++)if(D[a]===s[T]||D[a]==="*")a++;else if(D[a]!=="**")return!1;return a===D.length}}}e.getLocation=P;function l(t,i=[],s=y.DEFAULT){let n=null,o=[];const v=[];function m(D){Array.isArray(o)?o.push(D):n!==null&&(o[n]=D)}return d(t,{onObjectBegin:()=>{const D={};m(D),v.push(o),o=D,n=null},onObjectProperty:D=>{n=D},onObjectEnd:()=>{o=v.pop()},onArrayBegin:()=>{const D=[];m(D),v.push(o),o=D,n=null},onArrayEnd:()=>{o=v.pop()},onLiteralValue:m,onError:(D,a,T)=>{i.push({error:D,offset:a,length:T})}},s),o[0]}e.parse=l;function f(t,i=[],s=y.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(D){n.type==="property"&&(n.length=D-n.offset,n=n.parent)}function v(D){return n.children.push(D),D}d(t,{onObjectBegin:D=>{n=v({type:"object",offset:D,length:-1,parent:n,children:[]})},onObjectProperty:(D,a,T)=>{n=v({type:"property",offset:a,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:D,offset:a,length:T,parent:n})},onObjectEnd:(D,a)=>{n.length=D+a-n.offset,n=n.parent,o(D+a)},onArrayBegin:(D,a)=>{n=v({type:"array",offset:D,length:-1,parent:n,children:[]})},onArrayEnd:(D,a)=>{n.length=D+a-n.offset,n=n.parent,o(D+a)},onLiteralValue:(D,a,T)=>{v({type:g(D),offset:a,length:T,parent:n,value:D}),o(a+T)},onSeparator:(D,a,T)=>{n.type==="property"&&(D===":"?n.colonOffset=a:D===","&&o(a))},onError:(D,a,T)=>{i.push({error:D,offset:a,length:T})}},s);const S=n.children[0];return S&&delete S.parent,S}e.parseTree=f;function c(t,i){if(!t)return;let s=t;for(let n of i)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let o=!1;for(const v of s.children)if(Array.isArray(v.children)&&v.children[0].value===n){s=v.children[1],o=!0;break}if(!o)return}else{const o=n;if(s.type!=="array"||o<0||!Array.isArray(s.children)||o>=s.children.length)return;s=s.children[o]}return s}e.findNodeAtLocation=c;function h(t){if(!t.parent||!t.parent.children)return[];const i=h(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;i.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&i.push(s)}return i}e.getNodePath=h;function _(t){switch(t.type){case"array":return t.children.map(_);case"object":const i=Object.create(null);for(let s of t.children){const n=s.children[1];n&&(i[s.children[0].value]=_(n))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=_;function w(t,i,s=!1){return i>=t.offset&&i<t.offset+t.length||s&&i===t.offset+t.length}e.contains=w;function b(t,i,s=!1){if(w(t,i,s)){const n=t.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=i;o++){const v=b(n[o],i,s);if(v)return v}return t}}e.findNodeAtOffset=b;function d(t,i,s=y.DEFAULT){const n=A(t,!1);function o(ce){return ce?()=>ce(n.getTokenOffset(),n.getTokenLength()):()=>!0}function v(ce){return ce?we=>ce(we,n.getTokenOffset(),n.getTokenLength()):()=>!0}const m=o(i.onObjectBegin),S=v(i.onObjectProperty),D=o(i.onObjectEnd),a=o(i.onArrayBegin),T=o(i.onArrayEnd),L=v(i.onLiteralValue),U=v(i.onSeparator),G=o(i.onComment),te=v(i.onError),V=s&&s.disallowComments,N=s&&s.allowTrailingComma;function W(){for(;;){const ce=n.scan();switch(n.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:V||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(ce){case 12:case 13:V?M(10):G();break;case 16:M(1);break;case 15:case 14:break;default:return ce}}}function M(ce,we=[],Re=[]){if(te(ce),we.length+Re.length>0){let ke=n.getToken();for(;ke!==17;){if(we.indexOf(ke)!==-1){W();break}else if(Re.indexOf(ke)!==-1)break;ke=W()}}}function q(ce){const we=n.getTokenValue();return ce?L(we):S(we),W(),!0}function O(){switch(n.getToken()){case 11:let ce=0;try{ce=JSON.parse(n.getTokenValue()),typeof ce!="number"&&(M(2),ce=0)}catch(we){M(2)}L(ce);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return W(),!0}function F(){return n.getToken()!==10?(M(3,[],[2,5]),!1):(q(!1),n.getToken()===6?(U(":"),W(),Y()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function B(){m(),W();let ce=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ce||M(4,[],[]),U(","),W(),n.getToken()===2&&N)break}else ce&&M(6,[],[]);F()||M(4,[],[2,5]),ce=!0}return D(),n.getToken()!==2?M(7,[2],[]):W(),!0}function $(){a(),W();let ce=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ce||M(4,[],[]),U(","),W(),n.getToken()===4&&N)break}else ce&&M(6,[],[]);Y()||M(4,[],[4,5]),ce=!0}return T(),n.getToken()!==4?M(8,[4],[]):W(),!0}function Y(){switch(n.getToken()){case 3:return $();case 1:return B();case 10:return q(!0);default:return O()}}return W(),n.getToken()===17?s.allowEmptyContent?!0:(M(4,[],[]),!1):Y()?(n.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=d;function u(t,i){let s=A(t),n=[],o,v=0,m;do switch(m=s.getPosition(),o=s.scan(),o){case 12:case 13:case 17:v!==m&&n.push(t.substring(v,m)),i!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,i)),v=s.getPosition();break}while(o!==17);return n.join("")}e.stripComments=u;function g(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(ge[132],pe([0,1,53]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(E,k,r){let P,l,f,c,h;if(k){for(c=k.offset,h=c+k.length,f=c;f>0&&!I(E,f-1);)f--;let v=h;for(;v<E.length&&!I(E,v);)v++;l=E.substring(f,v),P=y(l,r)}else l=E,P=0,f=0,c=0,h=E.length;const _=A(r,E);let w=!1,b=0,d;r.insertSpaces?d=C(" ",r.tabSize||4):d="	";const u=p.createScanner(l,!1);let g=!1;function t(){return _+C(d,P+b)}function i(){let v=u.scan();for(w=!1;v===15||v===14;)w=w||v===14,v=u.scan();return g=v===16||u.getTokenError()!==0,v}const s=[];function n(v,m,S){!g&&m<h&&S>c&&E.substring(m,S)!==v&&s.push({offset:m,length:S-m,content:v})}let o=i();if(o!==17){const v=u.getTokenOffset()+f,m=C(d,P);n(m,f,v)}for(;o!==17;){let v=u.getTokenOffset()+u.getTokenLength()+f,m=i(),S="";for(;!w&&(m===12||m===13);){const a=u.getTokenOffset()+f;n(" ",v,a),v=u.getTokenOffset()+u.getTokenLength()+f,S=m===12?t():"",m=i()}if(m===2)o!==1&&(b--,S=t());else if(m===4)o!==3&&(b--,S=t());else{switch(o){case 3:case 1:b++,S=t();break;case 5:case 12:S=t();break;case 13:w?S=t():S=" ";break;case 6:S=" ";break;case 10:if(m===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?S=" ":m!==5&&m!==17&&(g=!0);break;case 16:g=!0;break}w&&(m===12||m===13)&&(S=t())}const D=u.getTokenOffset()+f;n(S,v,D),o=m}return s}e.format=R;function C(E,k){let r="";for(let P=0;P<k;P++)r+=E;return r}function y(E,k){let r=0,P=0;const l=k.tabSize||4;for(;r<E.length;){const f=E.charAt(r);if(f===" ")P++;else if(f==="	")P+=l;else break;r++}return Math.floor(P/l)}function A(E,k){for(let r=0;r<k.length;r++){const P=k.charAt(r);if(P==="\r")return r+1<k.length&&k.charAt(r+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=A;function I(E,k){return`\r
`.indexOf(E.charAt(k))!==-1}e.isEOL=I}),define(ge[133],pe([0,1,53,132]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(k,r,P){return y(k,r,void 0,P)}e.removeProperty=C;function y(k,r,P,l,f){const c=r.slice(),h=[],_=p.parseTree(k,h);let w,b;for(;c.length>0&&(b=c.pop(),w=p.findNodeAtLocation(_,c),w===void 0&&P!==void 0);)typeof b=="string"?P={[b]:P}:P=[P];if(w)if(w.type==="object"&&typeof b=="string"&&Array.isArray(w.children)){const d=p.findNodeAtLocation(w,[b]);if(d!==void 0)if(P===void 0){if(!d.parent)throw new Error("Malformed AST");const u=w.children.indexOf(d.parent);let g,t=d.parent.offset+d.parent.length;if(u>0){const i=w.children[u-1];g=i.offset+i.length}else g=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return A(k,{offset:g,length:t-g,content:""},l)}else return A(k,{offset:d.offset,length:d.length,content:JSON.stringify(P)},l);else{if(P===void 0)return[];const u=`${JSON.stringify(b)}: ${JSON.stringify(P)}`,g=f?f(w.children.map(i=>i.children[0].value)):w.children.length;let t;if(g>0){const i=w.children[g-1];t={offset:i.offset+i.length,length:0,content:","+u}}else w.children.length===0?t={offset:w.offset+1,length:0,content:u}:t={offset:w.offset+1,length:0,content:u+","};return A(k,t,l)}}else if(w.type==="array"&&typeof b=="number"&&Array.isArray(w.children))if(P!==void 0){const d=`${JSON.stringify(P)}`;let u;if(w.children.length===0||b===0)u={offset:w.offset+1,length:0,content:w.children.length===0?d:d+","};else{const g=b===-1||b>w.children.length?w.children.length:b,t=w.children[g-1];u={offset:t.offset+t.length,length:0,content:","+d}}return A(k,u,l)}else{const d=b,u=w.children[d];let g;if(w.children.length===1)g={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===d){const t=w.children[d-1],i=t.offset+t.length,s=w.offset+w.length;g={offset:i,length:s-2-i,content:""}}else g={offset:u.offset,length:w.children[d+1].offset-u.offset,content:""};return A(k,g,l)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${w.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return A(k,{offset:_?_.offset:0,length:_?_.length:0,content:JSON.stringify(P)},l)}}e.setProperty=y;function A(k,r,P){let l=I(k,r),f=r.offset,c=r.offset+r.content.length;if(r.length===0||r.content.length===0){for(;f>0&&!R.isEOL(l,f-1);)f--;for(;c<l.length&&!R.isEOL(l,c);)c++}const h=R.format(l,{offset:f,length:c-f},P);for(let w=h.length-1;w>=0;w--){const b=h[w];l=I(l,b),f=Math.min(f,b.offset),c=Math.max(c,b.offset+b.length),c+=b.content.length-b.length}const _=k.length-(l.length-c)-f;return[{offset:f,length:_,content:l.substring(f,c)}]}e.withFormatting=A;function I(k,r){return k.substring(0,r.offset)+r.content+k.substring(r.offset+r.length)}e.applyEdit=I;function E(k,r){let P=r.slice(0).sort((f,c)=>{const h=f.offset-c.offset;return h===0?f.length-c.length:h}),l=k.length;for(let f=P.length-1;f>=0;f--){let c=P[f];if(c.offset+c.length<=l)k=I(k,c);else throw new Error("Overlapping edit");l=c.offset}return k}e.applyEdits=E}),define(ge[134],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class p{constructor(C){this.executor=C,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(C){this._error=C}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(C){return new p(()=>C(this.getValue()))}}e.Lazy=p}),define(ge[6],pe([0,1,69,52]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const C=!1;let y=null;function A(u){y=u}if(e.setDisposableTracker=A,C){const u="__is_disposable_tracked__";y=new class{trackDisposable(g){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{g[u]||console.log(t)},3e3)}markTracked(g){if(g&&g!==h.None)try{g[u]=!0}catch(t){}}}}function I(u){!y||y.markTracked(u)}function E(u){return y&&y.trackDisposable(u),u}e.trackDisposable=E;class k extends Error{constructor(g){super(`Encountered errors while disposing of store. Errors: [${g.join(", ")}]`);this.errors=g}}e.MultiDisposeError=k;function r(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=r;function P(u){if(R.Iterable.is(u)){let g=[];for(const t of u)if(t){I(t);try{t.dispose()}catch(i){g.push(i)}}if(g.length===1)throw g[0];if(g.length>1)throw new k(g);return Array.isArray(u)?[]:u}else if(u)return I(u),u.dispose(),u}e.dispose=P;function l(...u){return u.forEach(I),f(()=>P(u))}e.combinedDisposable=l;function f(u){const g=E({dispose:()=>{I(g),u()}});return g}e.toDisposable=f;class c{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(I(this),this._isDisposed=!0,this.clear())}clear(){try{P(this._toDispose.values())}finally{this._toDispose.clear()}}add(g){if(!g)return g;if(g===this)throw new Error("Cannot register a disposable on itself!");return I(g),this._isDisposed?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(g),g}}e.DisposableStore=c,c.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this._store=new c,E(this)}dispose(){I(this),this._store.dispose()}_register(g){if(g===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(g)}}e.Disposable=h,h.None=Object.freeze({dispose(){}});class _{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(g){var t;this._isDisposed||g===this._value||((t=this._value)===null||t===void 0||t.dispose(),g&&I(g),this._value=g)}clear(){this.value=void 0}dispose(){var g;this._isDisposed=!0,I(this),(g=this._value)===null||g===void 0||g.dispose(),this._value=void 0}}e.MutableDisposable=_;class w{constructor(){this.references=new Map}acquire(g,...t){let i=this.references.get(g);i||(i={counter:0,object:this.createReferencedObject(g,...t)},this.references.set(g,i));const{object:s}=i,n=p.once(()=>{--i.counter==0&&(this.destroyReferencedObject(g,i.object),this.references.delete(g))});return i.counter++,{object:s,dispose:n}}}e.ReferenceCollection=w;class b{constructor(g){this.referenceCollection=g}async acquire(g,...t){const i=this.referenceCollection.acquire(g,...t);try{return{object:await i.object,dispose:()=>i.dispose()}}catch(s){throw i.dispose(),s}}}e.AsyncReferenceCollection=b;class d{constructor(g){this.object=g}dispose(){}}e.ImmortalReference=d}),define(ge[71],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(y){this.element=y,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class R{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let y=this._first;for(;y!==p.Undefined;){const A=y.next;y.prev=p.Undefined,y.next=p.Undefined,y=A}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,A){const I=new p(y);if(this._first===p.Undefined)this._first=I,this._last=I;else if(A){const k=this._last;this._last=I,I.prev=k,k.next=I}else{const k=this._first;this._first=I,I.next=k,k.prev=I}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(I))}}shift(){if(this._first!==p.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==p.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==p.Undefined&&y.next!==p.Undefined){const A=y.prev;A.next=y.next,y.next.prev=A}else y.prev===p.Undefined&&y.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):y.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):y.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==p.Undefined;)yield y.element,y=y.next}}e.LinkedList=R}),function(X,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(X=typeof globalThis!="undefined"?globalThis:X||self,X.marked=e())}(this,function(){"use strict";function X(De,_e){for(var Pe=0;Pe<_e.length;Pe++){var ae=_e[Pe];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(De,ae.key,ae)}}function e(De,_e,Pe){return _e&&X(De.prototype,_e),Pe&&X(De,Pe),De}function p(De,_e){if(!!De){if(typeof De=="string")return R(De,_e);var Pe=Object.prototype.toString.call(De).slice(8,-1);if(Pe==="Object"&&De.constructor&&(Pe=De.constructor.name),Pe==="Map"||Pe==="Set")return Array.from(De);if(Pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Pe))return R(De,_e)}}function R(De,_e){(_e==null||_e>De.length)&&(_e=De.length);for(var Pe=0,ae=new Array(_e);Pe<_e;Pe++)ae[Pe]=De[Pe];return ae}function C(De,_e){var Pe;if(typeof Symbol=="undefined"||De[Symbol.iterator]==null){if(Array.isArray(De)||(Pe=p(De))||_e&&De&&typeof De.length=="number"){Pe&&(De=Pe);var ae=0;return function(){return ae>=De.length?{done:!0}:{done:!1,value:De[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Pe=De[Symbol.iterator](),Pe.next.bind(Pe)}function y(De){var _e={exports:{}};return De(_e,_e.exports),_e.exports}var A=y(function(De){function _e(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Pe(ae){De.exports.defaults=ae}De.exports={defaults:_e(),getDefaults:_e,changeDefaults:Pe}}),I=/[&<>"']/,E=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,r=/[<>"']|&(?!#?\w+;)/g,P={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(_e){return P[_e]};function f(De,_e){if(_e){if(I.test(De))return De.replace(E,l)}else if(k.test(De))return De.replace(r,l);return De}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(De){return De.replace(c,function(_e,Pe){return Pe=Pe.toLowerCase(),Pe==="colon"?":":Pe.charAt(0)==="#"?Pe.charAt(1)==="x"?String.fromCharCode(parseInt(Pe.substring(2),16)):String.fromCharCode(+Pe.substring(1)):""})}var _=/(^|[^\[])\^/g;function w(De,_e){De=De.source||De,_e=_e||"";var Pe={replace:function(he,H){return H=H.source||H,H=H.replace(_,"$1"),De=De.replace(he,H),Pe},getRegex:function(){return new RegExp(De,_e)}};return Pe}var b=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(De,_e,Pe){if(De){var ae;try{ae=decodeURIComponent(h(Pe)).replace(b,"").toLowerCase()}catch(he){return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}_e&&!d.test(Pe)&&(Pe=n(_e,Pe));try{Pe=encodeURI(Pe).replace(/%25/g,"%")}catch(he){return null}return Pe}var g={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(De,_e){g[" "+De]||(t.test(De)?g[" "+De]=De+"/":g[" "+De]=S(De,"/",!0)),De=g[" "+De];var Pe=De.indexOf(":")===-1;return _e.substring(0,2)==="//"?Pe?_e:De.replace(i,"$1")+_e:_e.charAt(0)==="/"?Pe?_e:De.replace(s,"$1")+_e:De+_e}var o={exec:function(){}};function v(De){for(var _e=1,Pe,ae;_e<arguments.length;_e++){Pe=arguments[_e];for(ae in Pe)Object.prototype.hasOwnProperty.call(Pe,ae)&&(De[ae]=Pe[ae])}return De}function m(De,_e){var Pe=De.replace(/\|/g,function(H,ee,ue){for(var Ie=!1,Te=ee;--Te>=0&&ue[Te]==="\\";)Ie=!Ie;return Ie?"|":" |"}),ae=Pe.split(/ \|/),he=0;if(ae.length>_e)ae.splice(_e);else for(;ae.length<_e;)ae.push("");for(;he<ae.length;he++)ae[he]=ae[he].trim().replace(/\\\|/g,"|");return ae}function S(De,_e,Pe){var ae=De.length;if(ae===0)return"";for(var he=0;he<ae;){var H=De.charAt(ae-he-1);if(H===_e&&!Pe)he++;else if(H!==_e&&Pe)he++;else break}return De.substr(0,ae-he)}function D(De,_e){if(De.indexOf(_e[1])===-1)return-1;for(var Pe=De.length,ae=0,he=0;he<Pe;he++)if(De[he]==="\\")he++;else if(De[he]===_e[0])ae++;else if(De[he]===_e[1]&&(ae--,ae<0))return he;return-1}function a(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function T(De,_e){if(_e<1)return"";for(var Pe="";_e>1;)_e&1&&(Pe+=De),_e>>=1,De+=De;return Pe+De}var L={escape:f,unescape:h,edit:w,cleanUrl:u,resolveUrl:n,noopTest:o,merge:v,splitCells:m,rtrim:S,findClosingBracket:D,checkSanitizeDeprecation:a,repeatString:T},U=A.defaults,G=L.rtrim,te=L.splitCells,V=L.escape,N=L.findClosingBracket;function W(De,_e,Pe){var ae=_e.href,he=_e.title?V(_e.title):null,H=De[1].replace(/\\([\[\]])/g,"$1");return De[0].charAt(0)!=="!"?{type:"link",raw:Pe,href:ae,title:he,text:H}:{type:"image",raw:Pe,href:ae,title:he,text:V(H)}}function M(De,_e){var Pe=De.match(/^(\s+)(?:```)/);if(Pe===null)return _e;var ae=Pe[1];return _e.split(`
`).map(function(he){var H=he.match(/^\s+/);if(H===null)return he;var ee=H[0];return ee.length>=ae.length?he.slice(ae.length):he}).join(`
`)}var q=function(){function De(Pe){this.options=Pe||U}var _e=De.prototype;return _e.space=function(ae){var he=this.rules.block.newline.exec(ae);if(he)return he[0].length>1?{type:"space",raw:he[0]}:{raw:`
`}},_e.code=function(ae){var he=this.rules.block.code.exec(ae);if(he){var H=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?H:G(H,`
`)}}},_e.fences=function(ae){var he=this.rules.block.fences.exec(ae);if(he){var H=he[0],ee=M(H,he[3]||"");return{type:"code",raw:H,lang:he[2]?he[2].trim():he[2],text:ee}}},_e.heading=function(ae){var he=this.rules.block.heading.exec(ae);if(he){var H=he[2].trim();if(/#$/.test(H)){var ee=G(H,"#");(this.options.pedantic||!ee||/ $/.test(ee))&&(H=ee.trim())}return{type:"heading",raw:he[0],depth:he[1].length,text:H}}},_e.nptable=function(ae){var he=this.rules.block.nptable.exec(ae);if(he){var H={type:"table",header:te(he[1].replace(/^ *| *\| *$/g,"")),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:he[3]?he[3].replace(/\n$/,"").split(`
`):[],raw:he[0]};if(H.header.length===H.align.length){var ee=H.align.length,ue;for(ue=0;ue<ee;ue++)/^ *-+: *$/.test(H.align[ue])?H.align[ue]="right":/^ *:-+: *$/.test(H.align[ue])?H.align[ue]="center":/^ *:-+ *$/.test(H.align[ue])?H.align[ue]="left":H.align[ue]=null;for(ee=H.cells.length,ue=0;ue<ee;ue++)H.cells[ue]=te(H.cells[ue],H.header.length);return H}}},_e.hr=function(ae){var he=this.rules.block.hr.exec(ae);if(he)return{type:"hr",raw:he[0]}},_e.blockquote=function(ae){var he=this.rules.block.blockquote.exec(ae);if(he){var H=he[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:he[0],text:H}}},_e.list=function(ae){var he=this.rules.block.list.exec(ae);if(he){var H=he[0],ee=he[2],ue=ee.length>1,Ie={type:"list",raw:H,ordered:ue,start:ue?+ee.slice(0,-1):"",loose:!1,items:[]},Te=he[0].match(this.rules.block.item),Ue=!1,He,et,Je,Ye,nt,gt,Ee,ye,de=Te.length;Je=this.rules.block.listItemStart.exec(Te[0]);for(var Q=0;Q<de;Q++){if(He=Te[Q],H=He,Q!==de-1){if(Ye=this.rules.block.listItemStart.exec(Te[Q+1]),this.options.pedantic?Ye[1].length>Je[1].length:Ye[1].length>Je[0].length||Ye[1].length>3){Te.splice(Q,2,Te[Q]+`
`+Te[Q+1]),Q--,de--;continue}else(!this.options.pedantic||this.options.smartLists?Ye[2][Ye[2].length-1]!==ee[ee.length-1]:ue===(Ye[2].length===1))&&(nt=Te.slice(Q+1).join(`
`),Ie.raw=Ie.raw.substring(0,Ie.raw.length-nt.length),Q=de-1);Je=Ye}et=He.length,He=He.replace(/^ *([*+-]|\d+[.)]) ?/,""),~He.indexOf(`
 `)&&(et-=He.length,He=this.options.pedantic?He.replace(/^ {1,4}/gm,""):He.replace(new RegExp("^ {1,"+et+"}","gm"),"")),gt=Ue||/\n\n(?!\s*$)/.test(He),Q!==de-1&&(Ue=He.charAt(He.length-1)===`
`,gt||(gt=Ue)),gt&&(Ie.loose=!0),this.options.gfm&&(Ee=/^\[[ xX]\] /.test(He),ye=void 0,Ee&&(ye=He[1]!==" ",He=He.replace(/^\[[ xX]\] +/,""))),Ie.items.push({type:"list_item",raw:H,task:Ee,checked:ye,loose:gt,text:He})}return Ie}},_e.html=function(ae){var he=this.rules.block.html.exec(ae);if(he)return{type:this.options.sanitize?"paragraph":"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):V(he[0]):he[0]}},_e.def=function(ae){var he=this.rules.block.def.exec(ae);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var H=he[1].toLowerCase().replace(/\s+/g," ");return{tag:H,raw:he[0],href:he[2],title:he[3]}}},_e.table=function(ae){var he=this.rules.block.table.exec(ae);if(he){var H={type:"table",header:te(he[1].replace(/^ *| *\| *$/g,"")),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:he[3]?he[3].replace(/\n$/,"").split(`
`):[]};if(H.header.length===H.align.length){H.raw=he[0];var ee=H.align.length,ue;for(ue=0;ue<ee;ue++)/^ *-+: *$/.test(H.align[ue])?H.align[ue]="right":/^ *:-+: *$/.test(H.align[ue])?H.align[ue]="center":/^ *:-+ *$/.test(H.align[ue])?H.align[ue]="left":H.align[ue]=null;for(ee=H.cells.length,ue=0;ue<ee;ue++)H.cells[ue]=te(H.cells[ue].replace(/^ *\| *| *\| *$/g,""),H.header.length);return H}}},_e.lheading=function(ae){var he=this.rules.block.lheading.exec(ae);if(he)return{type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1]}},_e.paragraph=function(ae){var he=this.rules.block.paragraph.exec(ae);if(he)return{type:"paragraph",raw:he[0],text:he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1]}},_e.text=function(ae){var he=this.rules.block.text.exec(ae);if(he)return{type:"text",raw:he[0],text:he[0]}},_e.escape=function(ae){var he=this.rules.inline.escape.exec(ae);if(he)return{type:"escape",raw:he[0],text:V(he[1])}},_e.tag=function(ae,he,H){var ee=this.rules.inline.tag.exec(ae);if(ee)return!he&&/^<a /i.test(ee[0])?he=!0:he&&/^<\/a>/i.test(ee[0])&&(he=!1),!H&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?H=!0:H&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(H=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:he,inRawBlock:H,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):V(ee[0]):ee[0]}},_e.link=function(ae){var he=this.rules.inline.link.exec(ae);if(he){var H=he[2].trim();if(!this.options.pedantic&&/^</.test(H)){if(!/>$/.test(H))return;var ee=G(H.slice(0,-1),"\\");if((H.length-ee.length)%2==0)return}else{var ue=N(he[2],"()");if(ue>-1){var Ie=he[0].indexOf("!")===0?5:4,Te=Ie+he[1].length+ue;he[2]=he[2].substring(0,ue),he[0]=he[0].substring(0,Te).trim(),he[3]=""}}var Ue=he[2],He="";if(this.options.pedantic){var et=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ue);et&&(Ue=et[1],He=et[3])}else He=he[3]?he[3].slice(1,-1):"";return Ue=Ue.trim(),/^</.test(Ue)&&(this.options.pedantic&&!/>$/.test(H)?Ue=Ue.slice(1):Ue=Ue.slice(1,-1)),W(he,{href:Ue&&Ue.replace(this.rules.inline._escapes,"$1"),title:He&&He.replace(this.rules.inline._escapes,"$1")},he[0])}},_e.reflink=function(ae,he){var H;if((H=this.rules.inline.reflink.exec(ae))||(H=this.rules.inline.nolink.exec(ae))){var ee=(H[2]||H[1]).replace(/\s+/g," ");if(ee=he[ee.toLowerCase()],!ee||!ee.href){var ue=H[0].charAt(0);return{type:"text",raw:ue,text:ue}}return W(H,ee,H[0])}},_e.emStrong=function(ae,he,H){H===void 0&&(H="");var ee=this.rules.inline.emStrong.lDelim.exec(ae);if(!!ee&&!(ee[3]&&H.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ue=ee[1]||ee[2]||"";if(!ue||ue&&(H===""||this.rules.inline.punctuation.exec(H))){var Ie=ee[0].length-1,Te,Ue,He=Ie,et=0,Je=ee[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Je.lastIndex=0,he=he.slice(-1*ae.length+Ie);(ee=Je.exec(he))!=null;)if(Te=ee[1]||ee[2]||ee[3]||ee[4]||ee[5]||ee[6],!!Te){if(Ue=Te.length,ee[3]||ee[4]){He+=Ue;continue}else if((ee[5]||ee[6])&&Ie%3&&!((Ie+Ue)%3)){et+=Ue;continue}if(He-=Ue,!(He>0)){if(He+et-Ue<=0&&!he.slice(Je.lastIndex).match(Je)&&(Ue=Math.min(Ue,Ue+He+et)),Math.min(Ie,Ue)%2)return{type:"em",raw:ae.slice(0,Ie+ee.index+Ue+1),text:ae.slice(1,Ie+ee.index+Ue)};if(Math.min(Ie,Ue)%2==0)return{type:"strong",raw:ae.slice(0,Ie+ee.index+Ue+1),text:ae.slice(2,Ie+ee.index+Ue-1)}}}}}},_e.codespan=function(ae){var he=this.rules.inline.code.exec(ae);if(he){var H=he[2].replace(/\n/g," "),ee=/[^ ]/.test(H),ue=/^ /.test(H)&&/ $/.test(H);return ee&&ue&&(H=H.substring(1,H.length-1)),H=V(H,!0),{type:"codespan",raw:he[0],text:H}}},_e.br=function(ae){var he=this.rules.inline.br.exec(ae);if(he)return{type:"br",raw:he[0]}},_e.del=function(ae){var he=this.rules.inline.del.exec(ae);if(he)return{type:"del",raw:he[0],text:he[2]}},_e.autolink=function(ae,he){var H=this.rules.inline.autolink.exec(ae);if(H){var ee,ue;return H[2]==="@"?(ee=V(this.options.mangle?he(H[1]):H[1]),ue="mailto:"+ee):(ee=V(H[1]),ue=ee),{type:"link",raw:H[0],text:ee,href:ue,tokens:[{type:"text",raw:ee,text:ee}]}}},_e.url=function(ae,he){var H;if(H=this.rules.inline.url.exec(ae)){var ee,ue;if(H[2]==="@")ee=V(this.options.mangle?he(H[0]):H[0]),ue="mailto:"+ee;else{var Ie;do Ie=H[0],H[0]=this.rules.inline._backpedal.exec(H[0])[0];while(Ie!==H[0]);ee=V(H[0]),H[1]==="www."?ue="http://"+ee:ue=ee}return{type:"link",raw:H[0],text:ee,href:ue,tokens:[{type:"text",raw:ee,text:ee}]}}},_e.inlineText=function(ae,he,H){var ee=this.rules.inline.text.exec(ae);if(ee){var ue;return he?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):V(ee[0]):ee[0]:ue=V(this.options.smartypants?H(ee[0]):ee[0]),{type:"text",raw:ee[0],text:ue}}},De}(),O=L.noopTest,F=L.edit,B=L.merge,$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:O,table:O,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=F($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,$.item=F($.item,"gm").replace(/bull/g,$.bullet).getRegex(),$.listItemStart=F(/^( *)(bull)/).replace("bull",$.bullet).getRegex(),$.list=F($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=F($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=F($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",$._tag).getRegex(),$.blockquote=F($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=B({},$),$.gfm=B({},$.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.nptable=F($.gfm.nptable).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",$._tag).getRegex(),$.gfm.table=F($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",$._tag).getRegex(),$.pedantic=B({},$.normal,{html:F(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:O,paragraph:F($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Y={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:O,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:O,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Y._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Y.punctuation=F(Y.punctuation).replace(/punctuation/g,Y._punctuation).getRegex(),Y.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Y.escapedEmSt=/\\\*|\\_/g,Y._comment=F($._comment).replace("(?:-->|$)","-->").getRegex(),Y.emStrong.lDelim=F(Y.emStrong.lDelim).replace(/punct/g,Y._punctuation).getRegex(),Y.emStrong.rDelimAst=F(Y.emStrong.rDelimAst,"g").replace(/punct/g,Y._punctuation).getRegex(),Y.emStrong.rDelimUnd=F(Y.emStrong.rDelimUnd,"g").replace(/punct/g,Y._punctuation).getRegex(),Y._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Y._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Y._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Y.autolink=F(Y.autolink).replace("scheme",Y._scheme).replace("email",Y._email).getRegex(),Y._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Y.tag=F(Y.tag).replace("comment",Y._comment).replace("attribute",Y._attribute).getRegex(),Y._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Y._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Y._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Y.link=F(Y.link).replace("label",Y._label).replace("href",Y._href).replace("title",Y._title).getRegex(),Y.reflink=F(Y.reflink).replace("label",Y._label).getRegex(),Y.reflinkSearch=F(Y.reflinkSearch,"g").replace("reflink",Y.reflink).replace("nolink",Y.nolink).getRegex(),Y.normal=B({},Y),Y.pedantic=B({},Y.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:F(/^!?\[(label)\]\((.*?)\)/).replace("label",Y._label).getRegex(),reflink:F(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Y._label).getRegex()}),Y.gfm=B({},Y.normal,{escape:F(Y.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),Y.gfm.url=F(Y.gfm.url,"i").replace("email",Y.gfm._extended_email).getRegex(),Y.breaks=B({},Y.gfm,{br:F(Y.br).replace("{2,}","*").getRegex(),text:F(Y.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ce={block:$,inline:Y},we=A.defaults,Re=ce.block,ke=ce.inline,Me=L.repeatString;function Ge(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ze(De){var _e="",Pe,ae,he=De.length;for(Pe=0;Pe<he;Pe++)ae=De.charCodeAt(Pe),Math.random()>.5&&(ae="x"+ae.toString(16)),_e+="&#"+ae+";";return _e}var je=function(){function De(Pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=Pe||we,this.options.tokenizer=this.options.tokenizer||new q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var ae={block:Re.normal,inline:ke.normal};this.options.pedantic?(ae.block=Re.pedantic,ae.inline=ke.pedantic):this.options.gfm&&(ae.block=Re.gfm,this.options.breaks?ae.inline=ke.breaks:ae.inline=ke.gfm),this.tokenizer.rules=ae}De.lex=function(ae,he){var H=new De(he);return H.lex(ae)},De.lexInline=function(ae,he){var H=new De(he);return H.inlineTokens(ae)};var _e=De.prototype;return _e.lex=function(ae){return ae=ae.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ae,this.tokens,!0),this.inline(this.tokens),this.tokens},_e.blockTokens=function(ae,he,H){he===void 0&&(he=[]),H===void 0&&(H=!0),this.options.pedantic&&(ae=ae.replace(/^ +$/gm,""));for(var ee,ue,Ie,Te;ae;){if(ee=this.tokenizer.space(ae)){ae=ae.substring(ee.raw.length),ee.type&&he.push(ee);continue}if(ee=this.tokenizer.code(ae)){ae=ae.substring(ee.raw.length),Te=he[he.length-1],Te&&Te.type==="paragraph"?(Te.raw+=`
`+ee.raw,Te.text+=`
`+ee.text):he.push(ee);continue}if(ee=this.tokenizer.fences(ae)){ae=ae.substring(ee.raw.length),he.push(ee);continue}if(ee=this.tokenizer.heading(ae)){ae=ae.substring(ee.raw.length),he.push(ee);continue}if(ee=this.tokenizer.nptable(ae)){ae=ae.substring(ee.raw.length),he.push(ee);continue}if(ee=this.tokenizer.hr(ae)){ae=ae.substring(ee.raw.length),he.push(ee);continue}if(ee=this.tokenizer.blockquote(ae)){ae=ae.substring(ee.raw.length),ee.tokens=this.blockTokens(ee.text,[],H),he.push(ee);continue}if(ee=this.tokenizer.list(ae)){for(ae=ae.substring(ee.raw.length),Ie=ee.items.length,ue=0;ue<Ie;ue++)ee.items[ue].tokens=this.blockTokens(ee.items[ue].text,[],!1);he.push(ee);continue}if(ee=this.tokenizer.html(ae)){ae=ae.substring(ee.raw.length),he.push(ee);continue}if(H&&(ee=this.tokenizer.def(ae))){ae=ae.substring(ee.raw.length),this.tokens.links[ee.tag]||(this.tokens.links[ee.tag]={href:ee.href,title:ee.title});continue}if(ee=this.tokenizer.table(ae)){ae=ae.substring(ee.raw.length),he.push(ee);continue}if(ee=this.tokenizer.lheading(ae)){ae=ae.substring(ee.raw.length),he.push(ee);continue}if(H&&(ee=this.tokenizer.paragraph(ae))){ae=ae.substring(ee.raw.length),he.push(ee);continue}if(ee=this.tokenizer.text(ae)){ae=ae.substring(ee.raw.length),Te=he[he.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+ee.raw,Te.text+=`
`+ee.text):he.push(ee);continue}if(ae){var Ue="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(Ue);break}else throw new Error(Ue)}}return he},_e.inline=function(ae){var he,H,ee,ue,Ie,Te,Ue=ae.length;for(he=0;he<Ue;he++)switch(Te=ae[he],Te.type){case"paragraph":case"text":case"heading":{Te.tokens=[],this.inlineTokens(Te.text,Te.tokens);break}case"table":{for(Te.tokens={header:[],cells:[]},ue=Te.header.length,H=0;H<ue;H++)Te.tokens.header[H]=[],this.inlineTokens(Te.header[H],Te.tokens.header[H]);for(ue=Te.cells.length,H=0;H<ue;H++)for(Ie=Te.cells[H],Te.tokens.cells[H]=[],ee=0;ee<Ie.length;ee++)Te.tokens.cells[H][ee]=[],this.inlineTokens(Ie[ee],Te.tokens.cells[H][ee]);break}case"blockquote":{this.inline(Te.tokens);break}case"list":{for(ue=Te.items.length,H=0;H<ue;H++)this.inline(Te.items[H].tokens);break}}return ae},_e.inlineTokens=function(ae,he,H,ee){he===void 0&&(he=[]),H===void 0&&(H=!1),ee===void 0&&(ee=!1);var ue,Ie,Te=ae,Ue,He,et;if(this.tokens.links){var Je=Object.keys(this.tokens.links);if(Je.length>0)for(;(Ue=this.tokenizer.rules.inline.reflinkSearch.exec(Te))!=null;)Je.includes(Ue[0].slice(Ue[0].lastIndexOf("[")+1,-1))&&(Te=Te.slice(0,Ue.index)+"["+Me("a",Ue[0].length-2)+"]"+Te.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ue=this.tokenizer.rules.inline.blockSkip.exec(Te))!=null;)Te=Te.slice(0,Ue.index)+"["+Me("a",Ue[0].length-2)+"]"+Te.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ue=this.tokenizer.rules.inline.escapedEmSt.exec(Te))!=null;)Te=Te.slice(0,Ue.index)+"++"+Te.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;){if(He||(et=""),He=!1,ue=this.tokenizer.escape(ae)){ae=ae.substring(ue.raw.length),he.push(ue);continue}if(ue=this.tokenizer.tag(ae,H,ee)){ae=ae.substring(ue.raw.length),H=ue.inLink,ee=ue.inRawBlock;var Ye=he[he.length-1];Ye&&ue.type==="text"&&Ye.type==="text"?(Ye.raw+=ue.raw,Ye.text+=ue.text):he.push(ue);continue}if(ue=this.tokenizer.link(ae)){ae=ae.substring(ue.raw.length),ue.type==="link"&&(ue.tokens=this.inlineTokens(ue.text,[],!0,ee)),he.push(ue);continue}if(ue=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(ue.raw.length);var nt=he[he.length-1];ue.type==="link"?(ue.tokens=this.inlineTokens(ue.text,[],!0,ee),he.push(ue)):nt&&ue.type==="text"&&nt.type==="text"?(nt.raw+=ue.raw,nt.text+=ue.text):he.push(ue);continue}if(ue=this.tokenizer.emStrong(ae,Te,et)){ae=ae.substring(ue.raw.length),ue.tokens=this.inlineTokens(ue.text,[],H,ee),he.push(ue);continue}if(ue=this.tokenizer.codespan(ae)){ae=ae.substring(ue.raw.length),he.push(ue);continue}if(ue=this.tokenizer.br(ae)){ae=ae.substring(ue.raw.length),he.push(ue);continue}if(ue=this.tokenizer.del(ae)){ae=ae.substring(ue.raw.length),ue.tokens=this.inlineTokens(ue.text,[],H,ee),he.push(ue);continue}if(ue=this.tokenizer.autolink(ae,ze)){ae=ae.substring(ue.raw.length),he.push(ue);continue}if(!H&&(ue=this.tokenizer.url(ae,ze))){ae=ae.substring(ue.raw.length),he.push(ue);continue}if(ue=this.tokenizer.inlineText(ae,ee,Ge)){ae=ae.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(et=ue.raw.slice(-1)),He=!0,Ie=he[he.length-1],Ie&&Ie.type==="text"?(Ie.raw+=ue.raw,Ie.text+=ue.text):he.push(ue);continue}if(ae){var gt="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(gt);break}else throw new Error(gt)}}return he},e(De,null,[{key:"rules",get:function(){return{block:Re,inline:ke}}}]),De}(),j=A.defaults,Z=L.cleanUrl,ie=L.escape,oe=function(){function De(Pe){this.options=Pe||j}var _e=De.prototype;return _e.code=function(ae,he,H){var ee=(he||"").match(/\S*/)[0];if(this.options.highlight){var ue=this.options.highlight(ae,ee);ue!=null&&ue!==ae&&(H=!0,ae=ue)}return ae=ae.replace(/\n$/,"")+`
`,ee?'<pre><code class="'+this.options.langPrefix+ie(ee,!0)+'">'+(H?ae:ie(ae,!0))+`</code></pre>
`:"<pre><code>"+(H?ae:ie(ae,!0))+`</code></pre>
`},_e.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},_e.html=function(ae){return ae},_e.heading=function(ae,he,H,ee){return this.options.headerIds?"<h"+he+' id="'+this.options.headerPrefix+ee.slug(H)+'">'+ae+"</h"+he+`>
`:"<h"+he+">"+ae+"</h"+he+`>
`},_e.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},_e.list=function(ae,he,H){var ee=he?"ol":"ul",ue=he&&H!==1?' start="'+H+'"':"";return"<"+ee+ue+`>
`+ae+"</"+ee+`>
`},_e.listitem=function(ae){return"<li>"+ae+`</li>
`},_e.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},_e.paragraph=function(ae){return"<p>"+ae+`</p>
`},_e.table=function(ae,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+he+`</table>
`},_e.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},_e.tablecell=function(ae,he){var H=he.header?"th":"td",ee=he.align?"<"+H+' align="'+he.align+'">':"<"+H+">";return ee+ae+"</"+H+`>
`},_e.strong=function(ae){return"<strong>"+ae+"</strong>"},_e.em=function(ae){return"<em>"+ae+"</em>"},_e.codespan=function(ae){return"<code>"+ae+"</code>"},_e.br=function(){return this.options.xhtml?"<br/>":"<br>"},_e.del=function(ae){return"<del>"+ae+"</del>"},_e.link=function(ae,he,H){if(ae=Z(this.options.sanitize,this.options.baseUrl,ae),ae===null)return H;var ee='<a href="'+ie(ae)+'"';return he&&(ee+=' title="'+he+'"'),ee+=">"+H+"</a>",ee},_e.image=function(ae,he,H){if(ae=Z(this.options.sanitize,this.options.baseUrl,ae),ae===null)return H;var ee='<img src="'+ae+'" alt="'+H+'"';return he&&(ee+=' title="'+he+'"'),ee+=this.options.xhtml?"/>":">",ee},_e.text=function(ae){return ae},De}(),J=function(){function De(){}var _e=De.prototype;return _e.strong=function(ae){return ae},_e.em=function(ae){return ae},_e.codespan=function(ae){return ae},_e.del=function(ae){return ae},_e.html=function(ae){return ae},_e.text=function(ae){return ae},_e.link=function(ae,he,H){return""+H},_e.image=function(ae,he,H){return""+H},_e.br=function(){return""},De}(),le=function(){function De(){this.seen={}}var _e=De.prototype;return _e.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},_e.getNextSafeSlug=function(ae,he){var H=ae,ee=0;if(this.seen.hasOwnProperty(H)){ee=this.seen[ae];do ee++,H=ae+"-"+ee;while(this.seen.hasOwnProperty(H))}return he||(this.seen[ae]=ee,this.seen[H]=0),H},_e.slug=function(ae,he){he===void 0&&(he={});var H=this.serialize(ae);return this.getNextSafeSlug(H,he.dryrun)},De}(),me=A.defaults,Le=L.unescape,We=function(){function De(Pe){this.options=Pe||me,this.options.renderer=this.options.renderer||new oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new J,this.slugger=new le}De.parse=function(ae,he){var H=new De(he);return H.parse(ae)},De.parseInline=function(ae,he){var H=new De(he);return H.parseInline(ae)};var _e=De.prototype;return _e.parse=function(ae,he){he===void 0&&(he=!0);var H="",ee,ue,Ie,Te,Ue,He,et,Je,Ye,nt,gt,Ee,ye,de,Q,xe,Se,qe,Ze=ae.length;for(ee=0;ee<Ze;ee++)switch(nt=ae[ee],nt.type){case"space":continue;case"hr":{H+=this.renderer.hr();continue}case"heading":{H+=this.renderer.heading(this.parseInline(nt.tokens),nt.depth,Le(this.parseInline(nt.tokens,this.textRenderer)),this.slugger);continue}case"code":{H+=this.renderer.code(nt.text,nt.lang,nt.escaped);continue}case"table":{for(Je="",et="",Te=nt.header.length,ue=0;ue<Te;ue++)et+=this.renderer.tablecell(this.parseInline(nt.tokens.header[ue]),{header:!0,align:nt.align[ue]});for(Je+=this.renderer.tablerow(et),Ye="",Te=nt.cells.length,ue=0;ue<Te;ue++){for(He=nt.tokens.cells[ue],et="",Ue=He.length,Ie=0;Ie<Ue;Ie++)et+=this.renderer.tablecell(this.parseInline(He[Ie]),{header:!1,align:nt.align[Ie]});Ye+=this.renderer.tablerow(et)}H+=this.renderer.table(Je,Ye);continue}case"blockquote":{Ye=this.parse(nt.tokens),H+=this.renderer.blockquote(Ye);continue}case"list":{for(gt=nt.ordered,Ee=nt.start,ye=nt.loose,Te=nt.items.length,Ye="",ue=0;ue<Te;ue++)Q=nt.items[ue],xe=Q.checked,Se=Q.task,de="",Q.task&&(qe=this.renderer.checkbox(xe),ye?Q.tokens.length>0&&Q.tokens[0].type==="text"?(Q.tokens[0].text=qe+" "+Q.tokens[0].text,Q.tokens[0].tokens&&Q.tokens[0].tokens.length>0&&Q.tokens[0].tokens[0].type==="text"&&(Q.tokens[0].tokens[0].text=qe+" "+Q.tokens[0].tokens[0].text)):Q.tokens.unshift({type:"text",text:qe}):de+=qe),de+=this.parse(Q.tokens,ye),Ye+=this.renderer.listitem(de,Se,xe);H+=this.renderer.list(Ye,gt,Ee);continue}case"html":{H+=this.renderer.html(nt.text);continue}case"paragraph":{H+=this.renderer.paragraph(this.parseInline(nt.tokens));continue}case"text":{for(Ye=nt.tokens?this.parseInline(nt.tokens):nt.text;ee+1<Ze&&ae[ee+1].type==="text";)nt=ae[++ee],Ye+=`
`+(nt.tokens?this.parseInline(nt.tokens):nt.text);H+=he?this.renderer.paragraph(Ye):Ye;continue}default:{var tt='Token with "'+nt.type+'" type was not found.';if(this.options.silent){console.error(tt);return}else throw new Error(tt)}}return H},_e.parseInline=function(ae,he){he=he||this.renderer;var H="",ee,ue,Ie=ae.length;for(ee=0;ee<Ie;ee++)switch(ue=ae[ee],ue.type){case"escape":{H+=he.text(ue.text);break}case"html":{H+=he.html(ue.text);break}case"link":{H+=he.link(ue.href,ue.title,this.parseInline(ue.tokens,he));break}case"image":{H+=he.image(ue.href,ue.title,ue.text);break}case"strong":{H+=he.strong(this.parseInline(ue.tokens,he));break}case"em":{H+=he.em(this.parseInline(ue.tokens,he));break}case"codespan":{H+=he.codespan(ue.text);break}case"br":{H+=he.br();break}case"del":{H+=he.del(this.parseInline(ue.tokens,he));break}case"text":{H+=he.text(ue.text);break}default:{var Te='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(Te);return}else throw new Error(Te)}}return H},De}(),be=L.merge,Qe=L.checkSanitizeDeprecation,K=L.escape,re=A.getDefaults,ve=A.changeDefaults,Fe=A.defaults;function Oe(De,_e,Pe){if(typeof De=="undefined"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof _e=="function"&&(Pe=_e,_e=null),_e=be({},Oe.defaults,_e||{}),Qe(_e),Pe){var ae=_e.highlight,he;try{he=je.lex(De,_e)}catch(Ie){return Pe(Ie)}var H=function(Te){var Ue;if(!Te)try{Ue=We.parse(he,_e)}catch(He){Te=He}return _e.highlight=ae,Te?Pe(Te):Pe(null,Ue)};if(!ae||ae.length<3||(delete _e.highlight,!he.length))return H();var ee=0;Oe.walkTokens(he,function(Ie){Ie.type==="code"&&(ee++,setTimeout(function(){ae(Ie.text,Ie.lang,function(Te,Ue){if(Te)return H(Te);Ue!=null&&Ue!==Ie.text&&(Ie.text=Ue,Ie.escaped=!0),ee--,ee===0&&H()})},0))}),ee===0&&H();return}try{var ue=je.lex(De,_e);return _e.walkTokens&&Oe.walkTokens(ue,_e.walkTokens),We.parse(ue,_e)}catch(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,_e.silent)return"<p>An error occurred:</p><pre>"+K(Ie.message+"",!0)+"</pre>";throw Ie}}Oe.options=Oe.setOptions=function(De){return be(Oe.defaults,De),ve(Oe.defaults),Oe},Oe.getDefaults=re,Oe.defaults=Fe,Oe.use=function(De){var _e=be({},De);if(De.renderer&&function(){var ae=Oe.defaults.renderer||new oe,he=function(ue){var Ie=ae[ue];ae[ue]=function(){for(var Te=arguments.length,Ue=new Array(Te),He=0;He<Te;He++)Ue[He]=arguments[He];var et=De.renderer[ue].apply(ae,Ue);return et===!1&&(et=Ie.apply(ae,Ue)),et}};for(var H in De.renderer)he(H);_e.renderer=ae}(),De.tokenizer&&function(){var ae=Oe.defaults.tokenizer||new q,he=function(ue){var Ie=ae[ue];ae[ue]=function(){for(var Te=arguments.length,Ue=new Array(Te),He=0;He<Te;He++)Ue[He]=arguments[He];var et=De.tokenizer[ue].apply(ae,Ue);return et===!1&&(et=Ie.apply(ae,Ue)),et}};for(var H in De.tokenizer)he(H);_e.tokenizer=ae}(),De.walkTokens){var Pe=Oe.defaults.walkTokens;_e.walkTokens=function(ae){De.walkTokens(ae),Pe&&Pe(ae)}}Oe.setOptions(_e)},Oe.walkTokens=function(De,_e){for(var Pe=C(De),ae;!(ae=Pe()).done;){var he=ae.value;switch(_e(he),he.type){case"table":{for(var H=C(he.tokens.header),ee;!(ee=H()).done;){var ue=ee.value;Oe.walkTokens(ue,_e)}for(var Ie=C(he.tokens.cells),Te;!(Te=Ie()).done;)for(var Ue=Te.value,He=C(Ue),et;!(et=He()).done;){var Je=et.value;Oe.walkTokens(Je,_e)}break}case"list":{Oe.walkTokens(he.items,_e);break}default:he.tokens&&Oe.walkTokens(he.tokens,_e)}}},Oe.parseInline=function(De,_e){if(typeof De=="undefined"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");_e=be({},Oe.defaults,_e||{}),Qe(_e);try{var Pe=je.lexInline(De,_e);return _e.walkTokens&&Oe.walkTokens(Pe,_e.walkTokens),We.parseInline(Pe,_e)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,_e.silent)return"<p>An error occurred:</p><pre>"+K(ae.message+"",!0)+"</pre>";throw ae}},Oe.Parser=We,Oe.parser=We.parse,Oe.Renderer=oe,Oe.TextRenderer=J,Oe.Lexer=je,Oe.lexer=je.lex,Oe.Tokenizer=q,Oe.Slugger=le,Oe.parse=Oe;var Xe=Oe;return Xe}),define(ge[72],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function p(A,I,E){return Math.min(Math.max(A,I),E)}e.clamp=p;function R(A,I){return(I+A%I)%I}e.rot=R;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class y{constructor(){this._n=1,this._val=0}update(I){return this._val=this._val+(I-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=y}),function(){function X(C){const y=[];typeof C=="number"&&y.push("code/timeOrigin",C);function A(E){y.push(E,Date.now())}function I(){const E=[];for(let k=0;k<y.length;k+=2)E.push({name:y[k],startTime:y[k+1]});return E}return{mark:A,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const y=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))y.push({name:A.name,startTime:Math.round(C+A.startTime)});return y}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function p(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=p(R))}(),define(ge[11],pe([0,1]),function(X,e){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const R="en";let C=!1,y=!1,A=!1,I=!1,E=!1,k=!1,r=!1,P,l=R,f,c;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const _=typeof((p=h==null?void 0:h.versions)===null||p===void 0?void 0:p.electron)=="string"&&h.type==="renderer";if(e.isElectronSandboxed=_&&(h==null?void 0:h.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const n=h==null?void 0:h.env.VSCODE_BROWSER_CODE_LOADING;if(typeof n=="string")return n==="none"||n==="code"||n==="bypassHeatCheck"||n==="bypassHeatCheckAndEagerCompile"?n:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!_)c=navigator.userAgent,C=c.indexOf("Windows")>=0,y=c.indexOf("Macintosh")>=0,r=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=c.indexOf("Linux")>=0,k=!0,P=navigator.language,l=P;else if(typeof h=="object"){C=h.platform==="win32",y=h.platform==="darwin",A=h.platform==="linux",I=A&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,P=R,l=R;const n=h.env.VSCODE_NLS_CONFIG;if(n)try{const o=JSON.parse(n),v=o.availableLanguages["*"];P=o.locale,l=v||R,f=o._translationsConfigFile}catch(o){}E=!0}else console.error("Unable to resolve platform.");var w;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function b(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let d=0;y?d=1:C?d=3:A&&(d=2),e.isWindows=C,e.isMacintosh=y,e.isLinux=A,e.isLinuxSnap=I,e.isNative=E,e.isWeb=k,e.isIOS=r,e.platform=d,e.userAgent=c,e.language=l;var u;(function(n){function o(){return e.language}n.value=o;function v(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=v;function m(){return e.language==="en"}n.isDefault=m})(u=e.Language||(e.Language={})),e.locale=P,e.translationsConfigFile=f,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let v=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeSetImmediateId)for(let D=0,a=v.length;D<a;D++){const T=v[D];if(T.id===S.data.vscodeSetImmediateId){v.splice(D,1),T.callback();return}}});let m=0;return S=>{const D=++m;v.push({id:D,callback:S}),e.globals.postMessage({vscodeSetImmediateId:D},"*")}}if(typeof(h==null?void 0:h.nextTick)=="function")return h.nextTick.bind(h);const o=Promise.resolve();return v=>o.then(v)}();var g;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(g=e.OperatingSystem||(e.OperatingSystem={})),e.OS=y||r?2:C?1:3;let t=!0,i=!1;function s(){if(!i){i=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,t=new Uint16Array(n.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(ge[37],pe([0,1,11]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const C=p.globals.vscode.process;R={get platform(){return C.platform},get env(){return C.env},cwd(){return C.cwd()},nextTick(y){return p.setImmediate(y)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(C){return process.nextTick(C)}}:R={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},nextTick(C){return p.setImmediate(C)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(ge[9],pe([0,1,37]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,C=97,y=90,A=122,I=46,E=47,k=92,r=58,P=63;class l extends Error{constructor(u,g,t){let i;typeof g=="string"&&g.indexOf("not ")===0?(i="must not be",g=g.replace(/^not /,"")):i="must be";const s=u.indexOf(".")!==-1?"property":"argument";let n=`The "${u}" ${s} ${i} of type ${g}`;n+=`. Received type ${typeof t}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function f(d,u){if(typeof d!="string")throw new l(u,"string",d)}function c(d){return d===E||d===k}function h(d){return d===E}function _(d){return d>=R&&d<=y||d>=C&&d<=A}function w(d,u,g,t){let i="",s=0,n=-1,o=0,v=0;for(let m=0;m<=d.length;++m){if(m<d.length)v=d.charCodeAt(m);else{if(t(v))break;v=E}if(t(v)){if(!(n===m-1||o===1))if(o===2){if(i.length<2||s!==2||i.charCodeAt(i.length-1)!==I||i.charCodeAt(i.length-2)!==I){if(i.length>2){const S=i.lastIndexOf(g);S===-1?(i="",s=0):(i=i.slice(0,S),s=i.length-1-i.lastIndexOf(g)),n=m,o=0;continue}else if(i.length!==0){i="",s=0,n=m,o=0;continue}}u&&(i+=i.length>0?`${g}..`:"..",s=2)}else i.length>0?i+=`${g}${d.slice(n+1,m)}`:i=d.slice(n+1,m),s=m-n-1;n=m,o=0}else v===I&&o!==-1?++o:o=-1}return i}function b(d,u){if(u===null||typeof u!="object")throw new l("pathObject","Object",u);const g=u.dir||u.root,t=u.base||`${u.name||""}${u.ext||""}`;return g?g===u.root?`${g}${t}`:`${g}${d}${t}`:t}e.win32={resolve(...d){let u="",g="",t=!1;for(let i=d.length-1;i>=-1;i--){let s;if(i>=0){if(s=d[i],f(s,"path"),s.length===0)continue}else u.length===0?s=p.cwd():(s=p.env[`=${u}`]||p.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==u.toLowerCase()&&s.charCodeAt(2)===k)&&(s=`${u}\\`));const n=s.length;let o=0,v="",m=!1;const S=s.charCodeAt(0);if(n===1)c(S)&&(o=1,m=!0);else if(c(S))if(m=!0,c(s.charCodeAt(1))){let D=2,a=D;for(;D<n&&!c(s.charCodeAt(D));)D++;if(D<n&&D!==a){const T=s.slice(a,D);for(a=D;D<n&&c(s.charCodeAt(D));)D++;if(D<n&&D!==a){for(a=D;D<n&&!c(s.charCodeAt(D));)D++;(D===n||D!==a)&&(v=`\\\\${T}\\${s.slice(a,D)}`,o=D)}}}else o=1;else _(S)&&s.charCodeAt(1)===r&&(v=s.slice(0,2),o=2,n>2&&c(s.charCodeAt(2))&&(m=!0,o=3));if(v.length>0)if(u.length>0){if(v.toLowerCase()!==u.toLowerCase())continue}else u=v;if(t){if(u.length>0)break}else if(g=`${s.slice(o)}\\${g}`,t=m,m&&u.length>0)break}return g=w(g,!t,"\\",c),t?`${u}\\${g}`:`${u}${g}`||"."},normalize(d){f(d,"path");const u=d.length;if(u===0)return".";let g=0,t,i=!1;const s=d.charCodeAt(0);if(u===1)return h(s)?"\\":d;if(c(s))if(i=!0,c(d.charCodeAt(1))){let o=2,v=o;for(;o<u&&!c(d.charCodeAt(o));)o++;if(o<u&&o!==v){const m=d.slice(v,o);for(v=o;o<u&&c(d.charCodeAt(o));)o++;if(o<u&&o!==v){for(v=o;o<u&&!c(d.charCodeAt(o));)o++;if(o===u)return`\\\\${m}\\${d.slice(v)}\\`;o!==v&&(t=`\\\\${m}\\${d.slice(v,o)}`,g=o)}}}else g=1;else _(s)&&d.charCodeAt(1)===r&&(t=d.slice(0,2),g=2,u>2&&c(d.charCodeAt(2))&&(i=!0,g=3));let n=g<u?w(d.slice(g),!i,"\\",c):"";return n.length===0&&!i&&(n="."),n.length>0&&c(d.charCodeAt(u-1))&&(n+="\\"),t===void 0?i?`\\${n}`:n:i?`${t}\\${n}`:`${t}${n}`},isAbsolute(d){f(d,"path");const u=d.length;if(u===0)return!1;const g=d.charCodeAt(0);return c(g)||u>2&&_(g)&&d.charCodeAt(1)===r&&c(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let u,g;for(let s=0;s<d.length;++s){const n=d[s];f(n,"path"),n.length>0&&(u===void 0?u=g=n:u+=`\\${n}`)}if(u===void 0)return".";let t=!0,i=0;if(typeof g=="string"&&c(g.charCodeAt(0))){++i;const s=g.length;s>1&&c(g.charCodeAt(1))&&(++i,s>2&&(c(g.charCodeAt(2))?++i:t=!1))}if(t){for(;i<u.length&&c(u.charCodeAt(i));)i++;i>=2&&(u=`\\${u.slice(i)}`)}return e.win32.normalize(u)},relative(d,u){if(f(d,"from"),f(u,"to"),d===u)return"";const g=e.win32.resolve(d),t=e.win32.resolve(u);if(g===t||(d=g.toLowerCase(),u=t.toLowerCase(),d===u))return"";let i=0;for(;i<d.length&&d.charCodeAt(i)===k;)i++;let s=d.length;for(;s-1>i&&d.charCodeAt(s-1)===k;)s--;const n=s-i;let o=0;for(;o<u.length&&u.charCodeAt(o)===k;)o++;let v=u.length;for(;v-1>o&&u.charCodeAt(v-1)===k;)v--;const m=v-o,S=n<m?n:m;let D=-1,a=0;for(;a<S;a++){const L=d.charCodeAt(i+a);if(L!==u.charCodeAt(o+a))break;L===k&&(D=a)}if(a!==S){if(D===-1)return t}else{if(m>S){if(u.charCodeAt(o+a)===k)return t.slice(o+a+1);if(a===2)return t.slice(o+a)}n>S&&(d.charCodeAt(i+a)===k?D=a:a===2&&(D=3)),D===-1&&(D=0)}let T="";for(a=i+D+1;a<=s;++a)(a===s||d.charCodeAt(a)===k)&&(T+=T.length===0?"..":"\\..");return o+=D,T.length>0?`${T}${t.slice(o,v)}`:(t.charCodeAt(o)===k&&++o,t.slice(o,v))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const u=e.win32.resolve(d);if(u.length<=2)return d;if(u.charCodeAt(0)===k){if(u.charCodeAt(1)===k){const g=u.charCodeAt(2);if(g!==P&&g!==I)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(_(u.charCodeAt(0))&&u.charCodeAt(1)===r&&u.charCodeAt(2)===k)return`\\\\?\\${u}`;return d},dirname(d){f(d,"path");const u=d.length;if(u===0)return".";let g=-1,t=0;const i=d.charCodeAt(0);if(u===1)return c(i)?d:".";if(c(i)){if(g=t=1,c(d.charCodeAt(1))){let o=2,v=o;for(;o<u&&!c(d.charCodeAt(o));)o++;if(o<u&&o!==v){for(v=o;o<u&&c(d.charCodeAt(o));)o++;if(o<u&&o!==v){for(v=o;o<u&&!c(d.charCodeAt(o));)o++;if(o===u)return d;o!==v&&(g=t=o+1)}}}}else _(i)&&d.charCodeAt(1)===r&&(g=u>2&&c(d.charCodeAt(2))?3:2,t=g);let s=-1,n=!0;for(let o=u-1;o>=t;--o)if(c(d.charCodeAt(o))){if(!n){s=o;break}}else n=!1;if(s===-1){if(g===-1)return".";s=g}return d.slice(0,s)},basename(d,u){u!==void 0&&f(u,"ext"),f(d,"path");let g=0,t=-1,i=!0,s;if(d.length>=2&&_(d.charCodeAt(0))&&d.charCodeAt(1)===r&&(g=2),u!==void 0&&u.length>0&&u.length<=d.length){if(u===d)return"";let n=u.length-1,o=-1;for(s=d.length-1;s>=g;--s){const v=d.charCodeAt(s);if(c(v)){if(!i){g=s+1;break}}else o===-1&&(i=!1,o=s+1),n>=0&&(v===u.charCodeAt(n)?--n==-1&&(t=s):(n=-1,t=o))}return g===t?t=o:t===-1&&(t=d.length),d.slice(g,t)}for(s=d.length-1;s>=g;--s)if(c(d.charCodeAt(s))){if(!i){g=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":d.slice(g,t)},extname(d){f(d,"path");let u=0,g=-1,t=0,i=-1,s=!0,n=0;d.length>=2&&d.charCodeAt(1)===r&&_(d.charCodeAt(0))&&(u=t=2);for(let o=d.length-1;o>=u;--o){const v=d.charCodeAt(o);if(c(v)){if(!s){t=o+1;break}continue}i===-1&&(s=!1,i=o+1),v===I?g===-1?g=o:n!==1&&(n=1):g!==-1&&(n=-1)}return g===-1||i===-1||n===0||n===1&&g===i-1&&g===t+1?"":d.slice(g,i)},format:b.bind(null,"\\"),parse(d){f(d,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return u;const g=d.length;let t=0,i=d.charCodeAt(0);if(g===1)return c(i)?(u.root=u.dir=d,u):(u.base=u.name=d,u);if(c(i)){if(t=1,c(d.charCodeAt(1))){let D=2,a=D;for(;D<g&&!c(d.charCodeAt(D));)D++;if(D<g&&D!==a){for(a=D;D<g&&c(d.charCodeAt(D));)D++;if(D<g&&D!==a){for(a=D;D<g&&!c(d.charCodeAt(D));)D++;D===g?t=D:D!==a&&(t=D+1)}}}}else if(_(i)&&d.charCodeAt(1)===r){if(g<=2)return u.root=u.dir=d,u;if(t=2,c(d.charCodeAt(2))){if(g===3)return u.root=u.dir=d,u;t=3}}t>0&&(u.root=d.slice(0,t));let s=-1,n=t,o=-1,v=!0,m=d.length-1,S=0;for(;m>=t;--m){if(i=d.charCodeAt(m),c(i)){if(!v){n=m+1;break}continue}o===-1&&(v=!1,o=m+1),i===I?s===-1?s=m:S!==1&&(S=1):s!==-1&&(S=-1)}return o!==-1&&(s===-1||S===0||S===1&&s===o-1&&s===n+1?u.base=u.name=d.slice(n,o):(u.name=d.slice(n,s),u.base=d.slice(n,o),u.ext=d.slice(s,o))),n>0&&n!==t?u.dir=d.slice(0,n-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let u="",g=!1;for(let t=d.length-1;t>=-1&&!g;t--){const i=t>=0?d[t]:p.cwd();f(i,"path"),i.length!==0&&(u=`${i}/${u}`,g=i.charCodeAt(0)===E)}return u=w(u,!g,"/",h),g?`/${u}`:u.length>0?u:"."},normalize(d){if(f(d,"path"),d.length===0)return".";const u=d.charCodeAt(0)===E,g=d.charCodeAt(d.length-1)===E;return d=w(d,!u,"/",h),d.length===0?u?"/":g?"./":".":(g&&(d+="/"),u?`/${d}`:d)},isAbsolute(d){return f(d,"path"),d.length>0&&d.charCodeAt(0)===E},join(...d){if(d.length===0)return".";let u;for(let g=0;g<d.length;++g){const t=d[g];f(t,"path"),t.length>0&&(u===void 0?u=t:u+=`/${t}`)}return u===void 0?".":e.posix.normalize(u)},relative(d,u){if(f(d,"from"),f(u,"to"),d===u||(d=e.posix.resolve(d),u=e.posix.resolve(u),d===u))return"";const g=1,t=d.length,i=t-g,s=1,n=u.length-s,o=i<n?i:n;let v=-1,m=0;for(;m<o;m++){const D=d.charCodeAt(g+m);if(D!==u.charCodeAt(s+m))break;D===E&&(v=m)}if(m===o)if(n>o){if(u.charCodeAt(s+m)===E)return u.slice(s+m+1);if(m===0)return u.slice(s+m)}else i>o&&(d.charCodeAt(g+m)===E?v=m:m===0&&(v=0));let S="";for(m=g+v+1;m<=t;++m)(m===t||d.charCodeAt(m)===E)&&(S+=S.length===0?"..":"/..");return`${S}${u.slice(s+v)}`},toNamespacedPath(d){return d},dirname(d){if(f(d,"path"),d.length===0)return".";const u=d.charCodeAt(0)===E;let g=-1,t=!0;for(let i=d.length-1;i>=1;--i)if(d.charCodeAt(i)===E){if(!t){g=i;break}}else t=!1;return g===-1?u?"/":".":u&&g===1?"//":d.slice(0,g)},basename(d,u){u!==void 0&&f(u,"ext"),f(d,"path");let g=0,t=-1,i=!0,s;if(u!==void 0&&u.length>0&&u.length<=d.length){if(u===d)return"";let n=u.length-1,o=-1;for(s=d.length-1;s>=0;--s){const v=d.charCodeAt(s);if(v===E){if(!i){g=s+1;break}}else o===-1&&(i=!1,o=s+1),n>=0&&(v===u.charCodeAt(n)?--n==-1&&(t=s):(n=-1,t=o))}return g===t?t=o:t===-1&&(t=d.length),d.slice(g,t)}for(s=d.length-1;s>=0;--s)if(d.charCodeAt(s)===E){if(!i){g=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":d.slice(g,t)},extname(d){f(d,"path");let u=-1,g=0,t=-1,i=!0,s=0;for(let n=d.length-1;n>=0;--n){const o=d.charCodeAt(n);if(o===E){if(!i){g=n+1;break}continue}t===-1&&(i=!1,t=n+1),o===I?u===-1?u=n:s!==1&&(s=1):u!==-1&&(s=-1)}return u===-1||t===-1||s===0||s===1&&u===t-1&&u===g+1?"":d.slice(u,t)},format:b.bind(null,"/"),parse(d){f(d,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return u;const g=d.charCodeAt(0)===E;let t;g?(u.root="/",t=1):t=0;let i=-1,s=0,n=-1,o=!0,v=d.length-1,m=0;for(;v>=t;--v){const S=d.charCodeAt(v);if(S===E){if(!o){s=v+1;break}continue}n===-1&&(o=!1,n=v+1),S===I?i===-1?i=v:m!==1&&(m=1):i!==-1&&(m=-1)}if(n!==-1){const S=s===0&&g?1:s;i===-1||m===0||m===1&&i===n-1&&i===s+1?u.base=u.name=d.slice(S,n):(u.name=d.slice(S,i),u.base=d.slice(S,n),u.ext=d.slice(i,n))}return s>0?u.dir=d.slice(0,s-1):g&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ge[135],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var R;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(y,...A){const I=A.reduce((r,P)=>(r[P]=!0,r),{}),E=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(r=>!I[r]).forEach(r=>{for(let P=0;P<E.length;P++)if(r.search(E[P])!==-1){delete y[r];break}})}e.sanitizeProcessEnvironment=C}),define(ge[43],pe([0,1,11]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=p.globals.performance&&typeof p.globals.performance.now=="function";class C{constructor(A){this._highResolution=R&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new C(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=C}),define(ge[3],pe([0,1,14,69,6,71,43]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(b){b.None=()=>C.Disposable.None;function d(te){return(V,N=null,W)=>{let M=!1,q;return q=te(O=>{if(!M)return q?q.dispose():M=!0,V.call(N,O)},null,W),M&&q.dispose(),q}}b.once=d;function u(te,V){return o((N,W=null,M)=>te(q=>N.call(W,V(q)),null,M))}b.map=u;function g(te,V){return o((N,W=null,M)=>te(q=>{V(q),N.call(W,q)},null,M))}b.forEach=g;function t(te,V){return o((N,W=null,M)=>te(q=>V(q)&&N.call(W,q),null,M))}b.filter=t;function i(te){return te}b.signal=i;function s(...te){return(V,N=null,W)=>C.combinedDisposable(...te.map(M=>M(q=>V.call(N,q),null,W)))}b.any=s;function n(te,V,N){let W=N;return u(te,M=>(W=V(W,M),W))}b.reduce=n;function o(te){let V;const N=new l({onFirstListenerAdd(){V=te(N.fire,N)},onLastListenerRemove(){V.dispose()}});return N.event}function v(te,V,N=100,W=!1,M){let q,O,F,B=0;const $=new l({leakWarningThreshold:M,onFirstListenerAdd(){q=te(Y=>{B++,O=V(O,Y),W&&!F&&($.fire(O),O=void 0),clearTimeout(F),F=setTimeout(()=>{const ce=O;O=void 0,F=void 0,(!W||B>1)&&$.fire(ce),B=0},N)})},onLastListenerRemove(){q.dispose()}});return $.event}b.debounce=v;function m(te,V=(N,W)=>N===W){let N=!0,W;return t(te,M=>{const q=N||!V(M,W);return N=!1,W=M,q})}b.latch=m;function S(te,V){return[b.filter(te,V),b.filter(te,N=>!V(N))]}b.split=S;function D(te,V=!1,N=[]){let W=N.slice(),M=te(F=>{W?W.push(F):O.fire(F)});const q=()=>{W&&W.forEach(F=>O.fire(F)),W=null},O=new l({onFirstListenerAdd(){M||(M=te(F=>O.fire(F)))},onFirstListenerDidAdd(){W&&(V?setTimeout(q):q())},onLastListenerRemove(){M&&M.dispose(),M=null}});return O.event}b.buffer=D;class a{constructor(V){this.event=V}map(V){return new a(u(this.event,V))}forEach(V){return new a(g(this.event,V))}filter(V){return new a(t(this.event,V))}reduce(V,N){return new a(n(this.event,V,N))}latch(){return new a(m(this.event))}debounce(V,N=100,W=!1,M){return new a(v(this.event,V,N,W,M))}on(V,N,W){return this.event(V,N,W)}once(V,N,W){return d(this.event)(V,N,W)}}function T(te){return new a(te)}b.chain=T;function L(te,V,N=W=>W){const W=(...F)=>O.fire(N(...F)),M=()=>te.on(V,W),q=()=>te.removeListener(V,W),O=new l({onFirstListenerAdd:M,onLastListenerRemove:q});return O.event}b.fromNodeEventEmitter=L;function U(te,V,N=W=>W){const W=(...F)=>O.fire(N(...F)),M=()=>te.addEventListener(V,W),q=()=>te.removeEventListener(V,W),O=new l({onFirstListenerAdd:M,onLastListenerRemove:q});return O.event}b.fromDOMEventEmitter=U;function G(te){return new Promise(V=>d(te)(V))}b.toPromise=G})(I=e.Event||(e.Event={}));class E{constructor(d){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${d}_${E._idPool++}`}start(d){this._stopWatch=new A.StopWatch(!0),this._listenerCount=d}stop(){if(this._stopWatch){const d=this._stopWatch.elapsed();this._elapsedOverall+=d,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${d.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}E._idPool=0;let k=-1;function r(b){const d=k;return k=b,{dispose(){k=d}}}e.setGlobalLeakWarningThreshold=r;class P{constructor(d,u=Math.random().toString(18).slice(2,5)){this.customThreshold=d,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(d){let u=k;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),u<=0||d<u)return;this._stacks||(this._stacks=new Map);const g=new Error().stack.split(`
`).slice(3).join(`
`),t=this._stacks.get(g)||0;if(this._stacks.set(g,t+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let i,s=0;for(const[n,o]of this._stacks)(!i||s<o)&&(i=n,s=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${d} listeners already. MOST frequent listener (${s}):`),console.warn(i)}return()=>{const i=this._stacks.get(g)||0;this._stacks.set(g,i-1)}}}class l{constructor(d){var u;this._disposed=!1,this._options=d,this._leakageMon=k>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((u=this._options)===null||u===void 0?void 0:u._profName)?new E(this._options._profName):void 0}get event(){return this._event||(this._event=(d,u,g)=>{var t;this._listeners||(this._listeners=new y.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(u?[d,u]:d);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,d,u);const n=(t=this._leakageMon)===null||t===void 0?void 0:t.check(this._listeners.size);let o;return o={dispose:()=>{n&&n(),o.dispose=l._noop,this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},g instanceof C.DisposableStore?g.add(o):Array.isArray(g)&&g.push(o),o}),this._event}fire(d){var u,g;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,d]);for((u=this._perfMon)===null||u===void 0||u.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,i]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,i):t[0].call(t[1],i)}catch(s){p.onUnexpectedError(s)}}(g=this._perfMon)===null||g===void 0||g.stop()}}dispose(){var d,u,g,t,i;this._disposed||(this._disposed=!0,(d=this._listeners)===null||d===void 0||d.clear(),(u=this._deliveryQueue)===null||u===void 0||u.clear(),(t=(g=this._options)===null||g===void 0?void 0:g.onLastListenerRemove)===null||t===void 0||t.call(g),(i=this._leakageMon)===null||i===void 0||i.dispose())}}e.Emitter=l,l._noop=function(){};class f extends l{constructor(d){super(d);this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=d==null?void 0:d.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const d=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(d))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(d){this._listeners&&(this._isPaused!==0?this._eventQueue.push(d):super.fire(d))}}e.PauseableEmitter=f;class c extends f{constructor(d){var u;super(d);this._delay=(u=d.delay)!==null&&u!==void 0?u:100}fire(d){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(d)}}e.DebounceEmitter=c;class h{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(d){const u={event:d,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const g=()=>{this.hasListeners&&this.unhook(u);const t=this.events.indexOf(u);this.events.splice(t,1)};return C.toDisposable(R.once(g))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(d=>this.hook(d))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(d=>this.unhook(d))}hook(d){d.listener=d.event(u=>this.emitter.fire(u))}unhook(d){d.listener&&d.listener.dispose(),d.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=h;class _{constructor(){this.buffers=[]}wrapEvent(d){return(u,g,t)=>d(i=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>u.call(g,i)):u.call(g,i)},void 0,t)}bufferEvents(d){const u=[];this.buffers.push(u);const g=d();return this.buffers.pop(),u.forEach(t=>t()),g}}e.EventBufferer=_;class w{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=C.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(d){this.inputEvent=d,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=d(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w}),define(ge[21],pe([0,1,3]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(I,E){const k=setTimeout(I.bind(E),0);return{dispose(){clearTimeout(k)}}});var C;(function(I){function E(k){return k===I.None||k===I.Cancelled||k instanceof y?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}I.isCancellationToken=E,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(C=e.CancellationToken||(e.CancellationToken={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=C.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=A}),define(ge[90],pe([0,1,3]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(P){const l=this._icons.get(P.id);l?P.description?l.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const C=new R;e.iconRegistry=C;function y(r,P){return new I(r,P)}e.registerCodicon=y;function A(r){return r?r.replace(/\$\((.*?)\)/g,(P,l)=>` ${l} `).trim():""}e.getCodiconAriaLabel=A;class I{constructor(P,l,f){this.id=P,this.definition=l,this.description=f,C.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=I;function E(r,P){const l=["codicon","codicon-"+r];return P&&l.push("codicon-modifier-"+P),l}e.getClassNamesArray=E;var k;(function(r){r.iconNameSegment="[A-Za-z0-9]+",r.iconNameExpression="[A-Za-z0-9\\-]+",r.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${r.iconNameExpression})(${r.iconModifierExpression})?$`);function l(h){if(h instanceof I)return["codicon","codicon-"+h.id];const _=P.exec(h.id);if(!_)return l(I.error);let[,w,b]=_;const d=["codicon","codicon-"+w];return b&&d.push("codicon-modifier-"+b.substr(1)),d}r.asClassNameArray=l;function f(h){return l(h).join(" ")}r.asClassName=f;function c(h){return"."+l(h).join(".")}r.asCSSSelector=c})(k=e.CSSIcon||(e.CSSIcon={})),function(r){r.add=new r("add",{fontCharacter:"\\ea60"}),r.plus=new r("plus",{fontCharacter:"\\ea60"}),r.gistNew=new r("gist-new",{fontCharacter:"\\ea60"}),r.repoCreate=new r("repo-create",{fontCharacter:"\\ea60"}),r.lightbulb=new r("lightbulb",{fontCharacter:"\\ea61"}),r.lightBulb=new r("light-bulb",{fontCharacter:"\\ea61"}),r.repo=new r("repo",{fontCharacter:"\\ea62"}),r.repoDelete=new r("repo-delete",{fontCharacter:"\\ea62"}),r.gistFork=new r("gist-fork",{fontCharacter:"\\ea63"}),r.repoForked=new r("repo-forked",{fontCharacter:"\\ea63"}),r.gitPullRequest=new r("git-pull-request",{fontCharacter:"\\ea64"}),r.gitPullRequestAbandoned=new r("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),r.recordKeys=new r("record-keys",{fontCharacter:"\\ea65"}),r.keyboard=new r("keyboard",{fontCharacter:"\\ea65"}),r.tag=new r("tag",{fontCharacter:"\\ea66"}),r.tagAdd=new r("tag-add",{fontCharacter:"\\ea66"}),r.tagRemove=new r("tag-remove",{fontCharacter:"\\ea66"}),r.person=new r("person",{fontCharacter:"\\ea67"}),r.personFollow=new r("person-follow",{fontCharacter:"\\ea67"}),r.personOutline=new r("person-outline",{fontCharacter:"\\ea67"}),r.personFilled=new r("person-filled",{fontCharacter:"\\ea67"}),r.gitBranch=new r("git-branch",{fontCharacter:"\\ea68"}),r.gitBranchCreate=new r("git-branch-create",{fontCharacter:"\\ea68"}),r.gitBranchDelete=new r("git-branch-delete",{fontCharacter:"\\ea68"}),r.sourceControl=new r("source-control",{fontCharacter:"\\ea68"}),r.mirror=new r("mirror",{fontCharacter:"\\ea69"}),r.mirrorPublic=new r("mirror-public",{fontCharacter:"\\ea69"}),r.star=new r("star",{fontCharacter:"\\ea6a"}),r.starAdd=new r("star-add",{fontCharacter:"\\ea6a"}),r.starDelete=new r("star-delete",{fontCharacter:"\\ea6a"}),r.starEmpty=new r("star-empty",{fontCharacter:"\\ea6a"}),r.comment=new r("comment",{fontCharacter:"\\ea6b"}),r.commentAdd=new r("comment-add",{fontCharacter:"\\ea6b"}),r.alert=new r("alert",{fontCharacter:"\\ea6c"}),r.warning=new r("warning",{fontCharacter:"\\ea6c"}),r.search=new r("search",{fontCharacter:"\\ea6d"}),r.searchSave=new r("search-save",{fontCharacter:"\\ea6d"}),r.logOut=new r("log-out",{fontCharacter:"\\ea6e"}),r.signOut=new r("sign-out",{fontCharacter:"\\ea6e"}),r.logIn=new r("log-in",{fontCharacter:"\\ea6f"}),r.signIn=new r("sign-in",{fontCharacter:"\\ea6f"}),r.eye=new r("eye",{fontCharacter:"\\ea70"}),r.eyeUnwatch=new r("eye-unwatch",{fontCharacter:"\\ea70"}),r.eyeWatch=new r("eye-watch",{fontCharacter:"\\ea70"}),r.circleFilled=new r("circle-filled",{fontCharacter:"\\ea71"}),r.primitiveDot=new r("primitive-dot",{fontCharacter:"\\ea71"}),r.closeDirty=new r("close-dirty",{fontCharacter:"\\ea71"}),r.debugBreakpoint=new r("debug-breakpoint",{fontCharacter:"\\ea71"}),r.debugBreakpointDisabled=new r("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),r.debugHint=new r("debug-hint",{fontCharacter:"\\ea71"}),r.primitiveSquare=new r("primitive-square",{fontCharacter:"\\ea72"}),r.edit=new r("edit",{fontCharacter:"\\ea73"}),r.pencil=new r("pencil",{fontCharacter:"\\ea73"}),r.info=new r("info",{fontCharacter:"\\ea74"}),r.issueOpened=new r("issue-opened",{fontCharacter:"\\ea74"}),r.gistPrivate=new r("gist-private",{fontCharacter:"\\ea75"}),r.gitForkPrivate=new r("git-fork-private",{fontCharacter:"\\ea75"}),r.lock=new r("lock",{fontCharacter:"\\ea75"}),r.mirrorPrivate=new r("mirror-private",{fontCharacter:"\\ea75"}),r.close=new r("close",{fontCharacter:"\\ea76"}),r.removeClose=new r("remove-close",{fontCharacter:"\\ea76"}),r.x=new r("x",{fontCharacter:"\\ea76"}),r.repoSync=new r("repo-sync",{fontCharacter:"\\ea77"}),r.sync=new r("sync",{fontCharacter:"\\ea77"}),r.clone=new r("clone",{fontCharacter:"\\ea78"}),r.desktopDownload=new r("desktop-download",{fontCharacter:"\\ea78"}),r.beaker=new r("beaker",{fontCharacter:"\\ea79"}),r.microscope=new r("microscope",{fontCharacter:"\\ea79"}),r.vm=new r("vm",{fontCharacter:"\\ea7a"}),r.deviceDesktop=new r("device-desktop",{fontCharacter:"\\ea7a"}),r.file=new r("file",{fontCharacter:"\\ea7b"}),r.fileText=new r("file-text",{fontCharacter:"\\ea7b"}),r.more=new r("more",{fontCharacter:"\\ea7c"}),r.ellipsis=new r("ellipsis",{fontCharacter:"\\ea7c"}),r.kebabHorizontal=new r("kebab-horizontal",{fontCharacter:"\\ea7c"}),r.mailReply=new r("mail-reply",{fontCharacter:"\\ea7d"}),r.reply=new r("reply",{fontCharacter:"\\ea7d"}),r.organization=new r("organization",{fontCharacter:"\\ea7e"}),r.organizationFilled=new r("organization-filled",{fontCharacter:"\\ea7e"}),r.organizationOutline=new r("organization-outline",{fontCharacter:"\\ea7e"}),r.newFile=new r("new-file",{fontCharacter:"\\ea7f"}),r.fileAdd=new r("file-add",{fontCharacter:"\\ea7f"}),r.newFolder=new r("new-folder",{fontCharacter:"\\ea80"}),r.fileDirectoryCreate=new r("file-directory-create",{fontCharacter:"\\ea80"}),r.trash=new r("trash",{fontCharacter:"\\ea81"}),r.trashcan=new r("trashcan",{fontCharacter:"\\ea81"}),r.history=new r("history",{fontCharacter:"\\ea82"}),r.clock=new r("clock",{fontCharacter:"\\ea82"}),r.folder=new r("folder",{fontCharacter:"\\ea83"}),r.fileDirectory=new r("file-directory",{fontCharacter:"\\ea83"}),r.symbolFolder=new r("symbol-folder",{fontCharacter:"\\ea83"}),r.logoGithub=new r("logo-github",{fontCharacter:"\\ea84"}),r.markGithub=new r("mark-github",{fontCharacter:"\\ea84"}),r.github=new r("github",{fontCharacter:"\\ea84"}),r.terminal=new r("terminal",{fontCharacter:"\\ea85"}),r.console=new r("console",{fontCharacter:"\\ea85"}),r.repl=new r("repl",{fontCharacter:"\\ea85"}),r.zap=new r("zap",{fontCharacter:"\\ea86"}),r.symbolEvent=new r("symbol-event",{fontCharacter:"\\ea86"}),r.error=new r("error",{fontCharacter:"\\ea87"}),r.stop=new r("stop",{fontCharacter:"\\ea87"}),r.variable=new r("variable",{fontCharacter:"\\ea88"}),r.symbolVariable=new r("symbol-variable",{fontCharacter:"\\ea88"}),r.array=new r("array",{fontCharacter:"\\ea8a"}),r.symbolArray=new r("symbol-array",{fontCharacter:"\\ea8a"}),r.symbolModule=new r("symbol-module",{fontCharacter:"\\ea8b"}),r.symbolPackage=new r("symbol-package",{fontCharacter:"\\ea8b"}),r.symbolNamespace=new r("symbol-namespace",{fontCharacter:"\\ea8b"}),r.symbolObject=new r("symbol-object",{fontCharacter:"\\ea8b"}),r.symbolMethod=new r("symbol-method",{fontCharacter:"\\ea8c"}),r.symbolFunction=new r("symbol-function",{fontCharacter:"\\ea8c"}),r.symbolConstructor=new r("symbol-constructor",{fontCharacter:"\\ea8c"}),r.symbolBoolean=new r("symbol-boolean",{fontCharacter:"\\ea8f"}),r.symbolNull=new r("symbol-null",{fontCharacter:"\\ea8f"}),r.symbolNumeric=new r("symbol-numeric",{fontCharacter:"\\ea90"}),r.symbolNumber=new r("symbol-number",{fontCharacter:"\\ea90"}),r.symbolStructure=new r("symbol-structure",{fontCharacter:"\\ea91"}),r.symbolStruct=new r("symbol-struct",{fontCharacter:"\\ea91"}),r.symbolParameter=new r("symbol-parameter",{fontCharacter:"\\ea92"}),r.symbolTypeParameter=new r("symbol-type-parameter",{fontCharacter:"\\ea92"}),r.symbolKey=new r("symbol-key",{fontCharacter:"\\ea93"}),r.symbolText=new r("symbol-text",{fontCharacter:"\\ea93"}),r.symbolReference=new r("symbol-reference",{fontCharacter:"\\ea94"}),r.goToFile=new r("go-to-file",{fontCharacter:"\\ea94"}),r.symbolEnum=new r("symbol-enum",{fontCharacter:"\\ea95"}),r.symbolValue=new r("symbol-value",{fontCharacter:"\\ea95"}),r.symbolRuler=new r("symbol-ruler",{fontCharacter:"\\ea96"}),r.symbolUnit=new r("symbol-unit",{fontCharacter:"\\ea96"}),r.activateBreakpoints=new r("activate-breakpoints",{fontCharacter:"\\ea97"}),r.archive=new r("archive",{fontCharacter:"\\ea98"}),r.arrowBoth=new r("arrow-both",{fontCharacter:"\\ea99"}),r.arrowDown=new r("arrow-down",{fontCharacter:"\\ea9a"}),r.arrowLeft=new r("arrow-left",{fontCharacter:"\\ea9b"}),r.arrowRight=new r("arrow-right",{fontCharacter:"\\ea9c"}),r.arrowSmallDown=new r("arrow-small-down",{fontCharacter:"\\ea9d"}),r.arrowSmallLeft=new r("arrow-small-left",{fontCharacter:"\\ea9e"}),r.arrowSmallRight=new r("arrow-small-right",{fontCharacter:"\\ea9f"}),r.arrowSmallUp=new r("arrow-small-up",{fontCharacter:"\\eaa0"}),r.arrowUp=new r("arrow-up",{fontCharacter:"\\eaa1"}),r.bell=new r("bell",{fontCharacter:"\\eaa2"}),r.bold=new r("bold",{fontCharacter:"\\eaa3"}),r.book=new r("book",{fontCharacter:"\\eaa4"}),r.bookmark=new r("bookmark",{fontCharacter:"\\eaa5"}),r.debugBreakpointConditionalUnverified=new r("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),r.debugBreakpointConditional=new r("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),r.debugBreakpointConditionalDisabled=new r("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),r.debugBreakpointDataUnverified=new r("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),r.debugBreakpointData=new r("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),r.debugBreakpointDataDisabled=new r("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),r.debugBreakpointLogUnverified=new r("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),r.debugBreakpointLog=new r("debug-breakpoint-log",{fontCharacter:"\\eaab"}),r.debugBreakpointLogDisabled=new r("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),r.briefcase=new r("briefcase",{fontCharacter:"\\eaac"}),r.broadcast=new r("broadcast",{fontCharacter:"\\eaad"}),r.browser=new r("browser",{fontCharacter:"\\eaae"}),r.bug=new r("bug",{fontCharacter:"\\eaaf"}),r.calendar=new r("calendar",{fontCharacter:"\\eab0"}),r.caseSensitive=new r("case-sensitive",{fontCharacter:"\\eab1"}),r.check=new r("check",{fontCharacter:"\\eab2"}),r.checklist=new r("checklist",{fontCharacter:"\\eab3"}),r.chevronDown=new r("chevron-down",{fontCharacter:"\\eab4"}),r.chevronLeft=new r("chevron-left",{fontCharacter:"\\eab5"}),r.chevronRight=new r("chevron-right",{fontCharacter:"\\eab6"}),r.chevronUp=new r("chevron-up",{fontCharacter:"\\eab7"}),r.chromeClose=new r("chrome-close",{fontCharacter:"\\eab8"}),r.chromeMaximize=new r("chrome-maximize",{fontCharacter:"\\eab9"}),r.chromeMinimize=new r("chrome-minimize",{fontCharacter:"\\eaba"}),r.chromeRestore=new r("chrome-restore",{fontCharacter:"\\eabb"}),r.circleOutline=new r("circle-outline",{fontCharacter:"\\eabc"}),r.debugBreakpointUnverified=new r("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),r.circleSlash=new r("circle-slash",{fontCharacter:"\\eabd"}),r.circuitBoard=new r("circuit-board",{fontCharacter:"\\eabe"}),r.clearAll=new r("clear-all",{fontCharacter:"\\eabf"}),r.clippy=new r("clippy",{fontCharacter:"\\eac0"}),r.closeAll=new r("close-all",{fontCharacter:"\\eac1"}),r.cloudDownload=new r("cloud-download",{fontCharacter:"\\eac2"}),r.cloudUpload=new r("cloud-upload",{fontCharacter:"\\eac3"}),r.code=new r("code",{fontCharacter:"\\eac4"}),r.collapseAll=new r("collapse-all",{fontCharacter:"\\eac5"}),r.colorMode=new r("color-mode",{fontCharacter:"\\eac6"}),r.commentDiscussion=new r("comment-discussion",{fontCharacter:"\\eac7"}),r.compareChanges=new r("compare-changes",{fontCharacter:"\\eafd"}),r.creditCard=new r("credit-card",{fontCharacter:"\\eac9"}),r.dash=new r("dash",{fontCharacter:"\\eacc"}),r.dashboard=new r("dashboard",{fontCharacter:"\\eacd"}),r.database=new r("database",{fontCharacter:"\\eace"}),r.debugContinue=new r("debug-continue",{fontCharacter:"\\eacf"}),r.debugDisconnect=new r("debug-disconnect",{fontCharacter:"\\ead0"}),r.debugPause=new r("debug-pause",{fontCharacter:"\\ead1"}),r.debugRestart=new r("debug-restart",{fontCharacter:"\\ead2"}),r.debugStart=new r("debug-start",{fontCharacter:"\\ead3"}),r.debugStepInto=new r("debug-step-into",{fontCharacter:"\\ead4"}),r.debugStepOut=new r("debug-step-out",{fontCharacter:"\\ead5"}),r.debugStepOver=new r("debug-step-over",{fontCharacter:"\\ead6"}),r.debugStop=new r("debug-stop",{fontCharacter:"\\ead7"}),r.debug=new r("debug",{fontCharacter:"\\ead8"}),r.deviceCameraVideo=new r("device-camera-video",{fontCharacter:"\\ead9"}),r.deviceCamera=new r("device-camera",{fontCharacter:"\\eada"}),r.deviceMobile=new r("device-mobile",{fontCharacter:"\\eadb"}),r.diffAdded=new r("diff-added",{fontCharacter:"\\eadc"}),r.diffIgnored=new r("diff-ignored",{fontCharacter:"\\eadd"}),r.diffModified=new r("diff-modified",{fontCharacter:"\\eade"}),r.diffRemoved=new r("diff-removed",{fontCharacter:"\\eadf"}),r.diffRenamed=new r("diff-renamed",{fontCharacter:"\\eae0"}),r.diff=new r("diff",{fontCharacter:"\\eae1"}),r.discard=new r("discard",{fontCharacter:"\\eae2"}),r.editorLayout=new r("editor-layout",{fontCharacter:"\\eae3"}),r.emptyWindow=new r("empty-window",{fontCharacter:"\\eae4"}),r.exclude=new r("exclude",{fontCharacter:"\\eae5"}),r.extensions=new r("extensions",{fontCharacter:"\\eae6"}),r.eyeClosed=new r("eye-closed",{fontCharacter:"\\eae7"}),r.fileBinary=new r("file-binary",{fontCharacter:"\\eae8"}),r.fileCode=new r("file-code",{fontCharacter:"\\eae9"}),r.fileMedia=new r("file-media",{fontCharacter:"\\eaea"}),r.filePdf=new r("file-pdf",{fontCharacter:"\\eaeb"}),r.fileSubmodule=new r("file-submodule",{fontCharacter:"\\eaec"}),r.fileSymlinkDirectory=new r("file-symlink-directory",{fontCharacter:"\\eaed"}),r.fileSymlinkFile=new r("file-symlink-file",{fontCharacter:"\\eaee"}),r.fileZip=new r("file-zip",{fontCharacter:"\\eaef"}),r.files=new r("files",{fontCharacter:"\\eaf0"}),r.filter=new r("filter",{fontCharacter:"\\eaf1"}),r.flame=new r("flame",{fontCharacter:"\\eaf2"}),r.foldDown=new r("fold-down",{fontCharacter:"\\eaf3"}),r.foldUp=new r("fold-up",{fontCharacter:"\\eaf4"}),r.fold=new r("fold",{fontCharacter:"\\eaf5"}),r.folderActive=new r("folder-active",{fontCharacter:"\\eaf6"}),r.folderOpened=new r("folder-opened",{fontCharacter:"\\eaf7"}),r.gear=new r("gear",{fontCharacter:"\\eaf8"}),r.gift=new r("gift",{fontCharacter:"\\eaf9"}),r.gistSecret=new r("gist-secret",{fontCharacter:"\\eafa"}),r.gist=new r("gist",{fontCharacter:"\\eafb"}),r.gitCommit=new r("git-commit",{fontCharacter:"\\eafc"}),r.gitCompare=new r("git-compare",{fontCharacter:"\\eafd"}),r.gitMerge=new r("git-merge",{fontCharacter:"\\eafe"}),r.githubAction=new r("github-action",{fontCharacter:"\\eaff"}),r.githubAlt=new r("github-alt",{fontCharacter:"\\eb00"}),r.globe=new r("globe",{fontCharacter:"\\eb01"}),r.grabber=new r("grabber",{fontCharacter:"\\eb02"}),r.graph=new r("graph",{fontCharacter:"\\eb03"}),r.gripper=new r("gripper",{fontCharacter:"\\eb04"}),r.heart=new r("heart",{fontCharacter:"\\eb05"}),r.home=new r("home",{fontCharacter:"\\eb06"}),r.horizontalRule=new r("horizontal-rule",{fontCharacter:"\\eb07"}),r.hubot=new r("hubot",{fontCharacter:"\\eb08"}),r.inbox=new r("inbox",{fontCharacter:"\\eb09"}),r.issueClosed=new r("issue-closed",{fontCharacter:"\\eb0a"}),r.issueReopened=new r("issue-reopened",{fontCharacter:"\\eb0b"}),r.issues=new r("issues",{fontCharacter:"\\eb0c"}),r.italic=new r("italic",{fontCharacter:"\\eb0d"}),r.jersey=new r("jersey",{fontCharacter:"\\eb0e"}),r.json=new r("json",{fontCharacter:"\\eb0f"}),r.kebabVertical=new r("kebab-vertical",{fontCharacter:"\\eb10"}),r.key=new r("key",{fontCharacter:"\\eb11"}),r.law=new r("law",{fontCharacter:"\\eb12"}),r.lightbulbAutofix=new r("lightbulb-autofix",{fontCharacter:"\\eb13"}),r.linkExternal=new r("link-external",{fontCharacter:"\\eb14"}),r.link=new r("link",{fontCharacter:"\\eb15"}),r.listOrdered=new r("list-ordered",{fontCharacter:"\\eb16"}),r.listUnordered=new r("list-unordered",{fontCharacter:"\\eb17"}),r.liveShare=new r("live-share",{fontCharacter:"\\eb18"}),r.loading=new r("loading",{fontCharacter:"\\eb19"}),r.location=new r("location",{fontCharacter:"\\eb1a"}),r.mailRead=new r("mail-read",{fontCharacter:"\\eb1b"}),r.mail=new r("mail",{fontCharacter:"\\eb1c"}),r.markdown=new r("markdown",{fontCharacter:"\\eb1d"}),r.megaphone=new r("megaphone",{fontCharacter:"\\eb1e"}),r.mention=new r("mention",{fontCharacter:"\\eb1f"}),r.milestone=new r("milestone",{fontCharacter:"\\eb20"}),r.mortarBoard=new r("mortar-board",{fontCharacter:"\\eb21"}),r.move=new r("move",{fontCharacter:"\\eb22"}),r.multipleWindows=new r("multiple-windows",{fontCharacter:"\\eb23"}),r.mute=new r("mute",{fontCharacter:"\\eb24"}),r.noNewline=new r("no-newline",{fontCharacter:"\\eb25"}),r.note=new r("note",{fontCharacter:"\\eb26"}),r.octoface=new r("octoface",{fontCharacter:"\\eb27"}),r.openPreview=new r("open-preview",{fontCharacter:"\\eb28"}),r.package_=new r("package",{fontCharacter:"\\eb29"}),r.paintcan=new r("paintcan",{fontCharacter:"\\eb2a"}),r.pin=new r("pin",{fontCharacter:"\\eb2b"}),r.play=new r("play",{fontCharacter:"\\eb2c"}),r.run=new r("run",{fontCharacter:"\\eb2c"}),r.plug=new r("plug",{fontCharacter:"\\eb2d"}),r.preserveCase=new r("preserve-case",{fontCharacter:"\\eb2e"}),r.preview=new r("preview",{fontCharacter:"\\eb2f"}),r.project=new r("project",{fontCharacter:"\\eb30"}),r.pulse=new r("pulse",{fontCharacter:"\\eb31"}),r.question=new r("question",{fontCharacter:"\\eb32"}),r.quote=new r("quote",{fontCharacter:"\\eb33"}),r.radioTower=new r("radio-tower",{fontCharacter:"\\eb34"}),r.reactions=new r("reactions",{fontCharacter:"\\eb35"}),r.references=new r("references",{fontCharacter:"\\eb36"}),r.refresh=new r("refresh",{fontCharacter:"\\eb37"}),r.regex=new r("regex",{fontCharacter:"\\eb38"}),r.remoteExplorer=new r("remote-explorer",{fontCharacter:"\\eb39"}),r.remote=new r("remote",{fontCharacter:"\\eb3a"}),r.remove=new r("remove",{fontCharacter:"\\eb3b"}),r.replaceAll=new r("replace-all",{fontCharacter:"\\eb3c"}),r.replace=new r("replace",{fontCharacter:"\\eb3d"}),r.repoClone=new r("repo-clone",{fontCharacter:"\\eb3e"}),r.repoForcePush=new r("repo-force-push",{fontCharacter:"\\eb3f"}),r.repoPull=new r("repo-pull",{fontCharacter:"\\eb40"}),r.repoPush=new r("repo-push",{fontCharacter:"\\eb41"}),r.report=new r("report",{fontCharacter:"\\eb42"}),r.requestChanges=new r("request-changes",{fontCharacter:"\\eb43"}),r.rocket=new r("rocket",{fontCharacter:"\\eb44"}),r.rootFolderOpened=new r("root-folder-opened",{fontCharacter:"\\eb45"}),r.rootFolder=new r("root-folder",{fontCharacter:"\\eb46"}),r.rss=new r("rss",{fontCharacter:"\\eb47"}),r.ruby=new r("ruby",{fontCharacter:"\\eb48"}),r.saveAll=new r("save-all",{fontCharacter:"\\eb49"}),r.saveAs=new r("save-as",{fontCharacter:"\\eb4a"}),r.save=new r("save",{fontCharacter:"\\eb4b"}),r.screenFull=new r("screen-full",{fontCharacter:"\\eb4c"}),r.screenNormal=new r("screen-normal",{fontCharacter:"\\eb4d"}),r.searchStop=new r("search-stop",{fontCharacter:"\\eb4e"}),r.server=new r("server",{fontCharacter:"\\eb50"}),r.settingsGear=new r("settings-gear",{fontCharacter:"\\eb51"}),r.settings=new r("settings",{fontCharacter:"\\eb52"}),r.shield=new r("shield",{fontCharacter:"\\eb53"}),r.smiley=new r("smiley",{fontCharacter:"\\eb54"}),r.sortPrecedence=new r("sort-precedence",{fontCharacter:"\\eb55"}),r.splitHorizontal=new r("split-horizontal",{fontCharacter:"\\eb56"}),r.splitVertical=new r("split-vertical",{fontCharacter:"\\eb57"}),r.squirrel=new r("squirrel",{fontCharacter:"\\eb58"}),r.starFull=new r("star-full",{fontCharacter:"\\eb59"}),r.starHalf=new r("star-half",{fontCharacter:"\\eb5a"}),r.symbolClass=new r("symbol-class",{fontCharacter:"\\eb5b"}),r.symbolColor=new r("symbol-color",{fontCharacter:"\\eb5c"}),r.symbolConstant=new r("symbol-constant",{fontCharacter:"\\eb5d"}),r.symbolEnumMember=new r("symbol-enum-member",{fontCharacter:"\\eb5e"}),r.symbolField=new r("symbol-field",{fontCharacter:"\\eb5f"}),r.symbolFile=new r("symbol-file",{fontCharacter:"\\eb60"}),r.symbolInterface=new r("symbol-interface",{fontCharacter:"\\eb61"}),r.symbolKeyword=new r("symbol-keyword",{fontCharacter:"\\eb62"}),r.symbolMisc=new r("symbol-misc",{fontCharacter:"\\eb63"}),r.symbolOperator=new r("symbol-operator",{fontCharacter:"\\eb64"}),r.symbolProperty=new r("symbol-property",{fontCharacter:"\\eb65"}),r.wrench=new r("wrench",{fontCharacter:"\\eb65"}),r.wrenchSubaction=new r("wrench-subaction",{fontCharacter:"\\eb65"}),r.symbolSnippet=new r("symbol-snippet",{fontCharacter:"\\eb66"}),r.tasklist=new r("tasklist",{fontCharacter:"\\eb67"}),r.telescope=new r("telescope",{fontCharacter:"\\eb68"}),r.textSize=new r("text-size",{fontCharacter:"\\eb69"}),r.threeBars=new r("three-bars",{fontCharacter:"\\eb6a"}),r.thumbsdown=new r("thumbsdown",{fontCharacter:"\\eb6b"}),r.thumbsup=new r("thumbsup",{fontCharacter:"\\eb6c"}),r.tools=new r("tools",{fontCharacter:"\\eb6d"}),r.triangleDown=new r("triangle-down",{fontCharacter:"\\eb6e"}),r.triangleLeft=new r("triangle-left",{fontCharacter:"\\eb6f"}),r.triangleRight=new r("triangle-right",{fontCharacter:"\\eb70"}),r.triangleUp=new r("triangle-up",{fontCharacter:"\\eb71"}),r.twitter=new r("twitter",{fontCharacter:"\\eb72"}),r.unfold=new r("unfold",{fontCharacter:"\\eb73"}),r.unlock=new r("unlock",{fontCharacter:"\\eb74"}),r.unmute=new r("unmute",{fontCharacter:"\\eb75"}),r.unverified=new r("unverified",{fontCharacter:"\\eb76"}),r.verified=new r("verified",{fontCharacter:"\\eb77"}),r.versions=new r("versions",{fontCharacter:"\\eb78"}),r.vmActive=new r("vm-active",{fontCharacter:"\\eb79"}),r.vmOutline=new r("vm-outline",{fontCharacter:"\\eb7a"}),r.vmRunning=new r("vm-running",{fontCharacter:"\\eb7b"}),r.watch=new r("watch",{fontCharacter:"\\eb7c"}),r.whitespace=new r("whitespace",{fontCharacter:"\\eb7d"}),r.wholeWord=new r("whole-word",{fontCharacter:"\\eb7e"}),r.window=new r("window",{fontCharacter:"\\eb7f"}),r.wordWrap=new r("word-wrap",{fontCharacter:"\\eb80"}),r.zoomIn=new r("zoom-in",{fontCharacter:"\\eb81"}),r.zoomOut=new r("zoom-out",{fontCharacter:"\\eb82"}),r.listFilter=new r("list-filter",{fontCharacter:"\\eb83"}),r.listFlat=new r("list-flat",{fontCharacter:"\\eb84"}),r.listSelection=new r("list-selection",{fontCharacter:"\\eb85"}),r.selection=new r("selection",{fontCharacter:"\\eb85"}),r.listTree=new r("list-tree",{fontCharacter:"\\eb86"}),r.debugBreakpointFunctionUnverified=new r("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),r.debugBreakpointFunction=new r("debug-breakpoint-function",{fontCharacter:"\\eb88"}),r.debugBreakpointFunctionDisabled=new r("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),r.debugStackframeActive=new r("debug-stackframe-active",{fontCharacter:"\\eb89"}),r.debugStackframeDot=new r("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),r.debugStackframe=new r("debug-stackframe",{fontCharacter:"\\eb8b"}),r.debugStackframeFocused=new r("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),r.debugBreakpointUnsupported=new r("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),r.symbolString=new r("symbol-string",{fontCharacter:"\\eb8d"}),r.debugReverseContinue=new r("debug-reverse-continue",{fontCharacter:"\\eb8e"}),r.debugStepBack=new r("debug-step-back",{fontCharacter:"\\eb8f"}),r.debugRestartFrame=new r("debug-restart-frame",{fontCharacter:"\\eb90"}),r.callIncoming=new r("call-incoming",{fontCharacter:"\\eb92"}),r.callOutgoing=new r("call-outgoing",{fontCharacter:"\\eb93"}),r.menu=new r("menu",{fontCharacter:"\\eb94"}),r.expandAll=new r("expand-all",{fontCharacter:"\\eb95"}),r.feedback=new r("feedback",{fontCharacter:"\\eb96"}),r.groupByRefType=new r("group-by-ref-type",{fontCharacter:"\\eb97"}),r.ungroupByRefType=new r("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),r.account=new r("account",{fontCharacter:"\\eb99"}),r.bellDot=new r("bell-dot",{fontCharacter:"\\eb9a"}),r.debugConsole=new r("debug-console",{fontCharacter:"\\eb9b"}),r.library=new r("library",{fontCharacter:"\\eb9c"}),r.output=new r("output",{fontCharacter:"\\eb9d"}),r.runAll=new r("run-all",{fontCharacter:"\\eb9e"}),r.syncIgnored=new r("sync-ignored",{fontCharacter:"\\eb9f"}),r.pinned=new r("pinned",{fontCharacter:"\\eba0"}),r.githubInverted=new r("github-inverted",{fontCharacter:"\\eba1"}),r.debugAlt=new r("debug-alt",{fontCharacter:"\\eb91"}),r.serverProcess=new r("server-process",{fontCharacter:"\\eba2"}),r.serverEnvironment=new r("server-environment",{fontCharacter:"\\eba3"}),r.pass=new r("pass",{fontCharacter:"\\eba4"}),r.stopCircle=new r("stop-circle",{fontCharacter:"\\eba5"}),r.playCircle=new r("play-circle",{fontCharacter:"\\eba6"}),r.record=new r("record",{fontCharacter:"\\eba7"}),r.debugAltSmall=new r("debug-alt-small",{fontCharacter:"\\eba8"}),r.vmConnect=new r("vm-connect",{fontCharacter:"\\eba9"}),r.cloud=new r("cloud",{fontCharacter:"\\ebaa"}),r.merge=new r("merge",{fontCharacter:"\\ebab"}),r.exportIcon=new r("export",{fontCharacter:"\\ebac"}),r.graphLeft=new r("graph-left",{fontCharacter:"\\ebad"}),r.magnet=new r("magnet",{fontCharacter:"\\ebae"}),r.notebook=new r("notebook",{fontCharacter:"\\ebaf"}),r.redo=new r("redo",{fontCharacter:"\\ebb0"}),r.checkAll=new r("check-all",{fontCharacter:"\\ebb1"}),r.pinnedDirty=new r("pinned-dirty",{fontCharacter:"\\ebb2"}),r.passFilled=new r("pass-filled",{fontCharacter:"\\ebb3"}),r.circleLargeFilled=new r("circle-large-filled",{fontCharacter:"\\ebb4"}),r.circleLargeOutline=new r("circle-large-outline",{fontCharacter:"\\ebb5"}),r.combine=new r("combine",{fontCharacter:"\\ebb6"}),r.gather=new r("gather",{fontCharacter:"\\ebb6"}),r.table=new r("table",{fontCharacter:"\\ebb7"}),r.variableGroup=new r("variable-group",{fontCharacter:"\\ebb8"}),r.typeHierarchy=new r("type-hierarchy",{fontCharacter:"\\ebb9"}),r.typeHierarchySub=new r("type-hierarchy-sub",{fontCharacter:"\\ebba"}),r.typeHierarchySuper=new r("type-hierarchy-super",{fontCharacter:"\\ebbb"}),r.gitPullRequestCreate=new r("git-pull-request-create",{fontCharacter:"\\ebbc"}),r.runAbove=new r("run-above",{fontCharacter:"\\ebbd"}),r.runBelow=new r("run-below",{fontCharacter:"\\ebbe"}),r.notebookTemplate=new r("notebook-template",{fontCharacter:"\\ebbf"}),r.debugRerun=new r("debug-rerun",{fontCharacter:"\\ebc0"}),r.workspaceTrusted=new r("workspace-trusted",{fontCharacter:"\\ebc1"}),r.workspaceUntrusted=new r("workspace-untrusted",{fontCharacter:"\\ebc2"}),r.workspaceUnspecified=new r("workspace-unspecified",{fontCharacter:"\\ebc3"}),r.terminalCmd=new r("terminal-cmd",{fontCharacter:"\\ebc4"}),r.terminalDebian=new r("terminal-debian",{fontCharacter:"\\ebc5"}),r.terminalLinux=new r("terminal-linux",{fontCharacter:"\\ebc6"}),r.terminalPowershell=new r("terminal-powershell",{fontCharacter:"\\ebc7"}),r.terminalTmux=new r("terminal-tmux",{fontCharacter:"\\ebc8"}),r.terminalUbuntu=new r("terminal-ubuntu",{fontCharacter:"\\ebc9"}),r.terminalBash=new r("terminal-bash",{fontCharacter:"\\ebca"}),r.arrowSwap=new r("arrow-swap",{fontCharacter:"\\ebcb"}),r.copy=new r("copy",{fontCharacter:"\\ebcc"}),r.personAdd=new r("person-add",{fontCharacter:"\\ebcd"}),r.filterFilled=new r("filter-filled",{fontCharacter:"\\ebce"}),r.wand=new r("wand",{fontCharacter:"\\ebcf"}),r.debugLineByLine=new r("debug-line-by-line",{fontCharacter:"\\ebd0"}),r.inspect=new r("inspect",{fontCharacter:"\\ebd1"}),r.dropDownButton=new r("drop-down-button",r.chevronDown.definition)}(I=e.Codicon||(e.Codicon={}))}),define(ge[91],pe([0,1,14,6]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function C(d){const u=d;return u?[u.on,u.pause,u.resume,u.destroy].every(g=>typeof g=="function"):!1}e.isReadableStream=C;function y(d){const u=d;return u?C(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=y;function A(d,u){return new I(d,u)}e.newWriteableStream=A;class I{constructor(u,g){this.reducer=u,this.options=g,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){var g;if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof((g=this.options)===null||g===void 0?void 0:g.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u!="undefined"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(g=>g(u))}emitError(u){this.listeners.error.length===0?p.onUnexpectedError(u):this.listeners.error.slice(0).forEach(g=>g(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,g){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(g),this.resume();break;case"end":this.listeners.end.push(g),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(g),this.state.flowing&&this.flowErrors();break}}removeListener(u,g){if(this.state.destroyed)return;let t;switch(u){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const i=t.indexOf(g);i>=0&&t.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const g=[...this.pendingWritePromises];this.pendingWritePromises.length=0,g.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function E(d,u){const g=[];let t;for(;(t=d.read())!==null;)g.push(t);return u(g)}e.consumeReadable=E;function k(d,u,g){const t=[];let i;for(;(i=d.read())!==null&&t.length<g;)t.push(i);return i===null&&t.length>0?u(t):{read:()=>{if(t.length>0)return t.shift();if(typeof i!="undefined"){const s=i;return i=void 0,s}return d.read()}}}e.peekReadable=k;function r(d,u){return new Promise((g,t)=>{const i=[];P(d,{onData:s=>{u&&i.push(s)},onError:s=>{u?t(s):g(void 0)},onEnd:()=>{g(u?u(i):void 0)}})})}e.consumeStream=r;function P(d,u){d.on("error",g=>u.onError(g)),d.on("end",()=>u.onEnd()),d.on("data",g=>u.onData(g))}e.listenStream=P;function l(d,u){return new Promise((g,t)=>{const i=new R.DisposableStore,s=[],n=m=>{if(s.push(m),s.length>u)return i.dispose(),d.pause(),g({stream:d,buffer:s,ended:!1})},o=m=>t(m),v=()=>g({stream:d,buffer:s,ended:!0});i.add(R.toDisposable(()=>d.removeListener("error",o))),d.on("error",o),i.add(R.toDisposable(()=>d.removeListener("end",v))),d.on("end",v),i.add(R.toDisposable(()=>d.removeListener("data",n))),d.on("data",n)})}e.peekStream=l;function f(d,u){const g=A(u);return g.end(d),g}e.toStream=f;function c(){const d=A(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=c;function h(d){let u=!1;return{read:()=>u?null:(u=!0,d)}}e.toReadable=h;function _(d,u,g){const t=A(g);return P(d,{onData:i=>t.write(u.data(i)),onError:i=>t.error(u.error?u.error(i):i),onEnd:()=>t.end()}),t}e.transform=_;function w(d,u,g){let t=!1;return{read:()=>{const i=u.read();return t?i:(t=!0,i!==null?g([d,i]):d)}}}e.prefixedReadable=w;function b(d,u,g){let t=!1;const i=A(g);return P(u,{onData:s=>t?i.write(s):(t=!0,i.write(g([d,s]))),onError:s=>i.error(s),onEnd:()=>{t||(t=!0,i.write(d)),i.end()}}),i}e.prefixedStream=b}),define(ge[8],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function p(H){return!H||typeof H!="string"?!0:H.trim().length===0}e.isFalsyOrWhitespace=p;const R=/{(\d+)}/g;function C(H,...ee){return ee.length===0?H:H.replace(R,function(ue,Ie){const Te=parseInt(Ie,10);return isNaN(Te)||Te<0||Te>=ee.length?ue:ee[Te]})}e.format=C;function y(H){return H.replace(/[<>&]/g,function(ee){switch(ee){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ee}})}e.escape=y;function A(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=A;function I(H,ee){let ue=0;const Ie=ee.charCodeAt(0);for(let Te=H.length-1;Te>=0;Te--)H.charCodeAt(Te)===Ie&&ue++;return ue}e.count=I;function E(H,ee,ue="\u2026"){return H.length<=ee?H:`${H.substr(0,ee)}${ue}`}e.truncate=E;function k(H,ee=" "){const ue=r(H,ee);return P(ue,ee)}e.trim=k;function r(H,ee){if(!H||!ee)return H;const ue=ee.length;if(ue===0||H.length===0)return H;let Ie=0;for(;H.indexOf(ee,Ie)===Ie;)Ie=Ie+ue;return H.substring(Ie)}e.ltrim=r;function P(H,ee){if(!H||!ee)return H;const ue=ee.length,Ie=H.length;if(ue===0||Ie===0)return H;let Te=Ie,Ue=-1;for(;Ue=H.lastIndexOf(ee,Te-1),!(Ue===-1||Ue+ue!==Te);){if(Ue===0)return"";Te=Ue}return H.substring(0,Te)}e.rtrim=P;function l(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function f(H){return H.replace(/\*/g,"")}e.stripWildcards=f;function c(H,ee,ue={}){if(!H)throw new Error("Cannot create regex from empty string");ee||(H=A(H)),ue.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let Ie="";return ue.global&&(Ie+="g"),ue.matchCase||(Ie+="i"),ue.multiline&&(Ie+="m"),ue.unicode&&(Ie+="u"),new RegExp(H,Ie)}e.createRegExp=c;function h(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function _(H){return!!H.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=_;function w(H){return(H.global?"g":"")+(H.ignoreCase?"i":"")+(H.multiline?"m":"")+(H.unicode?"u":"")}e.regExpFlags=w;function b(H){return H.split(/\r\n|\r|\n/)}e.splitLines=b;function d(H){for(let ee=0,ue=H.length;ee<ue;ee++){const Ie=H.charCodeAt(ee);if(Ie!==32&&Ie!==9)return ee}return-1}e.firstNonWhitespaceIndex=d;function u(H,ee=0,ue=H.length){for(let Ie=ee;Ie<ue;Ie++){const Te=H.charCodeAt(Ie);if(Te!==32&&Te!==9)return H.substring(ee,Ie)}return H.substring(ee,ue)}e.getLeadingWhitespace=u;function g(H,ee=H.length-1){for(let ue=ee;ue>=0;ue--){const Ie=H.charCodeAt(ue);if(Ie!==32&&Ie!==9)return ue}return-1}e.lastNonWhitespaceIndex=g;function t(H,ee){return H<ee?-1:H>ee?1:0}e.compare=t;function i(H,ee,ue=0,Ie=H.length,Te=0,Ue=ee.length){for(;ue<Ie&&Te<Ue;ue++,Te++){let Je=H.charCodeAt(ue),Ye=ee.charCodeAt(Te);if(Je<Ye)return-1;if(Je>Ye)return 1}const He=Ie-ue,et=Ue-Te;return He<et?-1:He>et?1:0}e.compareSubstring=i;function s(H,ee){return n(H,ee,0,H.length,0,ee.length)}e.compareIgnoreCase=s;function n(H,ee,ue=0,Ie=H.length,Te=0,Ue=ee.length){for(;ue<Ie&&Te<Ue;ue++,Te++){let Je=H.charCodeAt(ue),Ye=ee.charCodeAt(Te);if(Je===Ye)continue;const nt=Je-Ye;if(!(nt===32&&v(Ye))&&!(nt===-32&&v(Je)))return o(Je)&&o(Ye)?nt:i(H.toLowerCase(),ee.toLowerCase(),ue,Ie,Te,Ue)}const He=Ie-ue,et=Ue-Te;return He<et?-1:He>et?1:0}e.compareSubstringIgnoreCase=n;function o(H){return H>=97&&H<=122}e.isLowerAsciiLetter=o;function v(H){return H>=65&&H<=90}e.isUpperAsciiLetter=v;function m(H){return o(H)||v(H)}function S(H,ee){return H.length===ee.length&&D(H,ee)}e.equalsIgnoreCase=S;function D(H,ee,ue=H.length){for(let Ie=0;Ie<ue;Ie++){const Te=H.charCodeAt(Ie),Ue=ee.charCodeAt(Ie);if(Te!==Ue){if(m(Te)&&m(Ue)){const He=Math.abs(Te-Ue);if(He!==0&&He!==32)return!1}else if(String.fromCharCode(Te).toLowerCase()!==String.fromCharCode(Ue).toLowerCase())return!1}}return!0}function a(H,ee){const ue=ee.length;return ee.length>H.length?!1:D(H,ee,ue)}e.startsWithIgnoreCase=a;function T(H,ee){let ue,Ie=Math.min(H.length,ee.length);for(ue=0;ue<Ie;ue++)if(H.charCodeAt(ue)!==ee.charCodeAt(ue))return ue;return Ie}e.commonPrefixLength=T;function L(H,ee){let ue,Ie=Math.min(H.length,ee.length);const Te=H.length-1,Ue=ee.length-1;for(ue=0;ue<Ie;ue++)if(H.charCodeAt(Te-ue)!==ee.charCodeAt(Ue-ue))return ue;return Ie}e.commonSuffixLength=L;function U(H){return 55296<=H&&H<=56319}e.isHighSurrogate=U;function G(H){return 56320<=H&&H<=57343}e.isLowSurrogate=G;function te(H,ee){return(H-55296<<10)+(ee-56320)+65536}e.computeCodePoint=te;function V(H,ee,ue){const Ie=H.charCodeAt(ue);if(U(Ie)&&ue+1<ee){const Te=H.charCodeAt(ue+1);if(G(Te))return te(Ie,Te)}return Ie}e.getNextCodePoint=V;function N(H,ee){const ue=H.charCodeAt(ee-1);if(G(ue)&&ee>1){const Ie=H.charCodeAt(ee-2);if(U(Ie))return te(Ie,ue)}return ue}function W(H,ee){const ue=Oe.getInstance(),Ie=ee,Te=H.length,Ue=V(H,Te,ee);ee+=Ue>=65536?2:1;let He=ue.getGraphemeBreakType(Ue);for(;ee<Te;){const et=V(H,Te,ee),Je=ue.getGraphemeBreakType(et);if(ve(He,Je))break;ee+=et>=65536?2:1,He=Je}return ee-Ie}e.nextCharLength=W;function M(H,ee){const ue=Oe.getInstance(),Ie=ee,Te=N(H,ee);ee-=Te>=65536?2:1;let Ue=ue.getGraphemeBreakType(Te);for(;ee>0;){const He=N(H,ee),et=ue.getGraphemeBreakType(He);if(ve(et,Ue))break;ee-=He>=65536?2:1,Ue=et}return Ie-ee}e.prevCharLength=M;function q(H,ee){const ue=Oe.getInstance(),Ie=H.length,Te=ee,Ue=V(H,Ie,ee),He=ue.getGraphemeBreakType(Ue);ee+=Ue>=65536?2:1;let et=He;for(;ee<Ie;){const Ye=V(H,Ie,ee),nt=ue.getGraphemeBreakType(Ye);if(ve(et,nt))break;ee+=Ye>=65536?2:1,et=nt}const Je=ee;for(ee=Te,et=He;ee>0;){const Ye=N(H,ee),nt=ue.getGraphemeBreakType(Ye);if(ve(nt,et))break;ee-=Ye>=65536?2:1,et=nt}return[ee,Je]}function O(H,ee){return ee>0&&G(H.charCodeAt(ee))?q(H,ee-1):q(H,ee)}e.getCharContainingOffset=O;function F(H){const ee=H.length;let ue=0,Ie=0;for(;Ie<ee;){const He=V(H,ee,Ie);Ie+=He>=65536?2:1,He<128?ue+=1:He<2048?ue+=2:He<65536?ue+=3:ue+=4}const Te=new Uint8Array(ue);Ie=0;let Ue=0;for(;Ie<ee;){const He=V(H,ee,Ie);Ie+=He>=65536?2:1,He<128?Te[Ue++]=He:He<2048?(Te[Ue++]=192|(He&1984)>>>6,Te[Ue++]=128|(He&63)>>>0):He<65536?(Te[Ue++]=224|(He&61440)>>>12,Te[Ue++]=128|(He&4032)>>>6,Te[Ue++]=128|(He&63)>>>0):(Te[Ue++]=240|(He&1835008)>>>18,Te[Ue++]=128|(He&258048)>>>12,Te[Ue++]=128|(He&4032)>>>6,Te[Ue++]=128|(He&63)>>>0)}return Te}e.encodeUTF8=F;function B(H){const ee=H.byteLength,ue=[];let Ie=0;for(;Ie<ee;){const Te=H[Ie];let Ue;if(Te>=240&&Ie+3<ee?Ue=(H[Ie++]&7)<<18>>>0|(H[Ie++]&63)<<12>>>0|(H[Ie++]&63)<<6>>>0|(H[Ie++]&63)<<0>>>0:Te>=224&&Ie+2<ee?Ue=(H[Ie++]&15)<<12>>>0|(H[Ie++]&63)<<6>>>0|(H[Ie++]&63)<<0>>>0:Te>=192&&Ie+1<ee?Ue=(H[Ie++]&31)<<6>>>0|(H[Ie++]&63)<<0>>>0:Ue=H[Ie++],Ue>=0&&Ue<=55295||Ue>=57344&&Ue<=65535)ue.push(String.fromCharCode(Ue));else if(Ue>=65536&&Ue<=1114111){const He=Ue-65536,et=55296+((He&1047552)>>>10),Je=56320+((He&1023)>>>0);ue.push(String.fromCharCode(et)),ue.push(String.fromCharCode(Je))}else ue.push(String.fromCharCode(65533))}return ue.join("")}e.decodeUTF8=B;const $=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Y(H){return $.test(H)}e.containsRTL=Y;const ce=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function we(H){return ce.test(H)}e.containsEmoji=we;const Re=/^[\t\n\r\x20-\x7E]*$/;function ke(H){return Re.test(H)}e.isBasicASCII=ke,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Me(H){return e.UNUSUAL_LINE_TERMINATORS.test(H)}e.containsUnusualLineTerminators=Me;function Ge(H){for(let ee=0,ue=H.length;ee<ue;ee++)if(ze(H.charCodeAt(ee)))return!0;return!1}e.containsFullWidthCharacter=Ge;function ze(H){return H=+H,H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}e.isFullWidthCharacter=ze;function je(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129003||H>=129280&&H<=129535||H>=129648&&H<=129750}e.isEmojiImprecise=je;function j(H,ee){if(H.length<ee)return H;const ue=/\b/g;let Ie=0;for(;ue.test(H)&&!(H.length-ue.lastIndex<ee);)Ie=ue.lastIndex,ue.lastIndex+=1;return H.substring(Ie).replace(/^\s/,"")}e.lcut=j;const Z=/\x1B\x5B[12]?K/g,ie=/\x1b\[\d+m/g,oe=/\x1b\[0?m/g;function J(H){return H&&(H=H.replace(Z,""),H=H.replace(ie,""),H=H.replace(oe,"")),H}e.removeAnsiEscapeCodes=J,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function le(H){return!!(H&&H.length>0&&H.charCodeAt(0)===65279)}e.startsWithUTF8BOM=le;function me(H){return le(H)?H.substr(1):H}e.stripUTF8BOM=me;function Le(H,ee){if(!H||!ee||H.length<ee.length)return!1;const ue=ee.length,Ie=H.toLowerCase();let Te=0,Ue=-1;for(;Te<ue;){const He=Ie.indexOf(ee[Te],Ue+1);if(He<0)return!1;Ue=He,Te++}return!0}e.fuzzyContains=Le;function We(H,ee=!1){return H?(ee&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}e.containsUppercaseCharacter=We;function be(H){return H.charAt(0).toUpperCase()+H.slice(1)}e.uppercaseFirstLetter=be;function Qe(H,ee=1){if(ee===0)return"";let ue=-1;do ue=H.indexOf(`
`,ue+1),ee--;while(ee>0&&ue>=0);return ue===-1?H:(H[ue-1]==="\r"&&ue--,H.substr(0,ue))}e.getNLines=Qe;function K(H){const ee=90-65+1;return H=H%(2*ee),H<ee?String.fromCharCode(97+H):String.fromCharCode(65+H-ee)}e.singleLetterHash=K;function re(H){return Oe.getInstance().getGraphemeBreakType(H)}e.getGraphemeBreakType=re;function ve(H,ee){return H===0?ee!==5&&ee!==7:H===2&&ee===3?!1:H===4||H===2||H===3||ee===4||ee===2||ee===3?!0:!(H===8&&(ee===8||ee===9||ee===11||ee===12)||(H===11||H===9)&&(ee===9||ee===10)||(H===12||H===10)&&ee===10||ee===5||ee===13||ee===7||H===1||H===13&&ee===14||H===6&&ee===6)}e.breakBetweenGraphemeBreakType=ve;var Fe;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})(Fe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Oe{constructor(){this._data=Xe()}static getInstance(){return Oe._INSTANCE||(Oe._INSTANCE=new Oe),Oe._INSTANCE}getGraphemeBreakType(ee){if(ee<32)return ee===10?3:ee===13?2:4;if(ee<127)return 0;const ue=this._data,Ie=ue.length/3;let Te=1;for(;Te<=Ie;)if(ee<ue[3*Te])Te=2*Te;else if(ee>ue[3*Te+1])Te=2*Te+1;else return ue[3*Te+2];return 0}}Oe._INSTANCE=null;function Xe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function De(H,ee){if(H===0)return 0;const ue=_e(H,ee);if(ue!==void 0)return ue;const Ie=N(ee,H);return H-=Pe(Ie),H}e.getLeftDeleteOffset=De;function _e(H,ee){let ue=N(ee,H);for(H-=Pe(ue);ae(ue)||ue===65039||ue===8419;){if(H===0)return;ue=N(ee,H),H-=Pe(ue)}if(!!je(ue)){if(H>=0){const Ie=N(ee,H);Ie===8205&&(H-=Pe(Ie))}return H}}function Pe(H){return H>=65536?2:1}function ae(H){return 127995<=H&&H<=127999}var he;(function(H){H[H.zwj=8205]="zwj",H[H.emojiVariantSelector=65039]="emojiVariantSelector",H[H.enclosingKeyCap=8419]="enclosingKeyCap"})(he||(he={}))}),define(ge[22],pe([0,1,8,91]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer!="undefined",y=typeof TextEncoder!="undefined",A=typeof TextDecoder!="undefined";let I,E;class k{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return C?new k(Buffer.allocUnsafe(m)):new k(new Uint8Array(m))}static wrap(m){return C&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new k(m)}static fromString(m,S){return!((S==null?void 0:S.dontUseNodeBuffer)||!1)&&C?new k(Buffer.from(m)):y?(I||(I=new TextEncoder),new k(I.encode(m))):new k(p.encodeUTF8(m))}static concat(m,S){if(typeof S=="undefined"){S=0;for(let T=0,L=m.length;T<L;T++)S+=m[T].byteLength}const D=k.alloc(S);let a=0;for(let T=0,L=m.length;T<L;T++){const U=m[T];D.set(U,a),a+=U.byteLength}return D}toString(){return C?this.buffer.toString():A?(E||(E=new TextDecoder),E.decode(this.buffer)):p.decodeUTF8(this.buffer)}slice(m,S){return new k(this.buffer.subarray(m,S))}set(m,S){m instanceof k?this.buffer.set(m.buffer,S):this.buffer.set(m,S)}readUInt32BE(m){return l(this.buffer,m)}writeUInt32BE(m,S){f(this.buffer,m,S)}readUInt32LE(m){return c(this.buffer,m)}writeUInt32LE(m,S){h(this.buffer,m,S)}readUInt8(m){return _(this.buffer,m)}writeUInt8(m,S){w(this.buffer,m,S)}}e.VSBuffer=k;function r(v,m){return v[m+0]<<0>>>0|v[m+1]<<8>>>0}e.readUInt16LE=r;function P(v,m,S){v[S+0]=m&255,m=m>>>8,v[S+1]=m&255}e.writeUInt16LE=P;function l(v,m){return v[m]*2**24+v[m+1]*2**16+v[m+2]*2**8+v[m+3]}e.readUInt32BE=l;function f(v,m,S){v[S+3]=m,m=m>>>8,v[S+2]=m,m=m>>>8,v[S+1]=m,m=m>>>8,v[S]=m}e.writeUInt32BE=f;function c(v,m){return v[m+0]<<0>>>0|v[m+1]<<8>>>0|v[m+2]<<16>>>0|v[m+3]<<24>>>0}e.readUInt32LE=c;function h(v,m,S){v[S+0]=m&255,m=m>>>8,v[S+1]=m&255,m=m>>>8,v[S+2]=m&255,m=m>>>8,v[S+3]=m&255}e.writeUInt32LE=h;function _(v,m){return v[m]}e.readUInt8=_;function w(v,m,S){v[S]=m}e.writeUInt8=w;function b(v){return R.consumeReadable(v,m=>k.concat(m))}e.readableToBuffer=b;function d(v){return R.toReadable(v)}e.bufferToReadable=d;function u(v){return R.consumeStream(v,m=>k.concat(m))}e.streamToBuffer=u;async function g(v){return v.ended?k.concat(v.buffer):k.concat([...v.buffer,await u(v.stream)])}e.bufferedStreamToBuffer=g;function t(v){return R.toStream(v,m=>k.concat(m))}e.bufferToStream=t;function i(v){return R.transform(v,{data:m=>typeof m=="string"?k.fromString(m):k.wrap(m)},m=>k.concat(m))}e.streamToBufferReadableStream=i;function s(v){return R.newWriteableStream(m=>k.concat(m),v)}e.newWriteableBufferStream=s;function n(v,m){return R.prefixedReadable(v,m,S=>k.concat(S))}e.prefixedBufferReadable=n;function o(v,m){return R.prefixedStream(v,m,S=>k.concat(S))}e.prefixedBufferStream=o}),define(ge[73],pe([0,1,8]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(w){return C(w,0)}e.hash=R;function C(w,b){switch(typeof w){case"object":return w===null?y(349,b):Array.isArray(w)?E(w,b):k(w,b);case"string":return I(w,b);case"boolean":return A(w,b);case"number":return y(w,b);case"undefined":return y(937,b);default:return y(617,b)}}e.doHash=C;function y(w,b){return(b<<5)-b+w|0}function A(w,b){return y(w?433:863,b)}function I(w,b){b=y(149417,b);for(let d=0,u=w.length;d<u;d++)b=y(w.charCodeAt(d),b);return b}e.stringHash=I;function E(w,b){return b=y(104579,b),w.reduce((d,u)=>C(u,d),b)}function k(w,b){return b=y(181387,b),Object.keys(w).sort().reduce((d,u)=>(d=I(u,d),C(w[u],d)),b)}class r{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=C(b,this._value),this._value}}e.Hasher=r;var P;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function l(w,b,d=32){const u=d-b,g=~((1<<u)-1);return(w<<b|(g&w)>>>u)>>>0}function f(w,b=0,d=w.byteLength,u=0){for(let g=0;g<d;g++)w[b+g]=u}function c(w,b,d="0"){for(;w.length<b;)w=d+w;return w}function h(w,b=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(d=>d.toString(16).padStart(2,"0")).join(""):c((w>>>0).toString(16),b/4)}e.toHexString=h;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const d=b.length;if(d===0)return;const u=this._buff;let g=this._buffLen,t=this._leftoverHighSurrogate,i,s;for(t!==0?(i=t,s=-1,t=0):(i=b.charCodeAt(0),s=0);;){let n=i;if(p.isHighSurrogate(i))if(s+1<d){const o=b.charCodeAt(s+1);p.isLowSurrogate(o)?(s++,n=p.computeCodePoint(i,o)):n=65533}else{t=i;break}else p.isLowSurrogate(i)&&(n=65533);if(g=this._push(u,g,n),s++,s<d)i=b.charCodeAt(s);else break}this._buffLen=g,this._leftoverHighSurrogate=t}_push(b,d,u){return u<128?b[d++]=u:u<2048?(b[d++]=192|(u&1984)>>>6,b[d++]=128|(u&63)>>>0):u<65536?(b[d++]=224|(u&61440)>>>12,b[d++]=128|(u&4032)>>>6,b[d++]=128|(u&63)>>>0):(b[d++]=240|(u&1835008)>>>18,b[d++]=128|(u&258048)>>>12,b[d++]=128|(u&4032)>>>6,b[d++]=128|(u&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=_._bigBlock32,d=this._buffDV;for(let m=0;m<64;m+=4)b.setUint32(m,d.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)b.setUint32(m,l(b.getUint32(m-12,!1)^b.getUint32(m-32,!1)^b.getUint32(m-56,!1)^b.getUint32(m-64,!1),1),!1);let u=this._h0,g=this._h1,t=this._h2,i=this._h3,s=this._h4,n,o,v;for(let m=0;m<80;m++)m<20?(n=g&t|~g&i,o=1518500249):m<40?(n=g^t^i,o=1859775393):m<60?(n=g&t|g&i|t&i,o=2400959708):(n=g^t^i,o=3395469782),v=l(u,5)+n+s+o+b.getUint32(m*4,!1)&4294967295,s=i,i=t,t=l(g,30),g=u,u=v;this._h0=this._h0+u&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ge[54],pe([0,1,8]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(R||(R={})),function(C){const y="error",A="warning",I="warn",E="info",k="ignore";function r(l){return l?p.equalsIgnoreCase(y,l)?C.Error:p.equalsIgnoreCase(A,l)||p.equalsIgnoreCase(I,l)?C.Warning:p.equalsIgnoreCase(E,l)?C.Info:C.Ignore:C.Ignore}C.fromValue=r;function P(l){switch(l){case C.Error:return y;case C.Warning:return A;case C.Info:return E;default:return k}}C.toString=P}(R||(R={})),e.default=R}),define(ge[15],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(m){return Array.isArray(m)}e.isArray=p;function R(m){return typeof m=="string"}e.isString=R;function C(m){return Array.isArray(m)&&m.every(S=>R(S))}e.isStringArray=C;function y(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}e.isObject=y;function A(m){return typeof m=="number"&&!isNaN(m)}e.isNumber=A;function I(m){return!!m&&typeof m[Symbol.iterator]=="function"}e.isIterable=I;function E(m){return m===!0||m===!1}e.isBoolean=E;function k(m){return typeof m=="undefined"}e.isUndefined=k;function r(m){return!P(m)}e.isDefined=r;function P(m){return k(m)||m===null}e.isUndefinedOrNull=P;function l(m,S){if(!m)throw new Error(S?`Unexpected type, expected '${S}'`:"Unexpected type")}e.assertType=l;function f(m){if(P(m))throw new Error("Assertion Failed: argument is undefined or null");return m}e.assertIsDefined=f;function c(...m){const S=[];for(let D=0;D<m.length;D++){const a=m[D];if(P(a))throw new Error(`Assertion Failed: argument at index ${D} is undefined or null`);S.push(a)}return S}e.assertAllDefined=c;const h=Object.prototype.hasOwnProperty;function _(m){if(!y(m))return!1;for(let S in m)if(h.call(m,S))return!1;return!0}e.isEmptyObject=_;function w(m){return typeof m=="function"}e.isFunction=w;function b(...m){return m.length>0&&m.every(w)}e.areFunctions=b;function d(m,S){const D=Math.min(m.length,S.length);for(let a=0;a<D;a++)u(m[a],S[a])}e.validateConstraints=d;function u(m,S){if(R(S)){if(typeof m!==S)throw new Error(`argument does not match constraint: typeof ${S}`)}else if(w(S)){try{if(m instanceof S)return}catch(D){}if(!P(m)&&m.constructor===S||S.length===1&&S.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function g(m){let S=[],D=Object.getPrototypeOf(m);for(;Object.prototype!==D;)S=S.concat(Object.getOwnPropertyNames(D)),D=Object.getPrototypeOf(D);return S}e.getAllPropertyNames=g;function t(m){const S=[];for(const D of g(m))typeof m[D]=="function"&&S.push(D);return S}e.getAllMethodNames=t;function i(m,S){const D=T=>function(){const L=Array.prototype.slice.call(arguments,0);return S(T,L)};let a={};for(const T of m)a[T]=D(T);return a}e.createProxyObject=i;function s(m){return m===null?void 0:m}e.withNullAsUndefined=s;function n(m){return typeof m=="undefined"?null:m}e.withUndefinedAsNull=n;function o(m){return class{constructor(){return new Proxy({},{get(S,D){if(S[D])return S[D];throw new Error(`Not Implemented: ${m}->${String(D)}`)}})}}}e.NotImplementedProxy=o;function v(m){throw new Error("Unreachable")}e.assertNever=v}),define(ge[29],pe([0,1,11,8,9,15]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(s){return s===47||s===92}e.isPathSeparator=A;function I(s){return s.replace(/[\\/]/g,C.posix.sep)}e.toSlashes=I;function E(s){return s.indexOf("/")===-1&&(s=I(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=E;function k(s,n=C.posix.sep){if(!s)return"";const o=s.length,v=s.charCodeAt(0);if(A(v)){if(A(s.charCodeAt(1))&&!A(s.charCodeAt(2))){let S=3;const D=S;for(;S<o&&!A(s.charCodeAt(S));S++);if(D!==S&&!A(s.charCodeAt(S+1))){for(S+=1;S<o;S++)if(A(s.charCodeAt(S)))return s.slice(0,S+1).replace(/[\\/]/g,n)}}return n}else if(w(v)&&s.charCodeAt(1)===58)return A(s.charCodeAt(2))?s.slice(0,2)+n:s.slice(0,2);let m=s.indexOf("://");if(m!==-1){for(m+=3;m<o;m++)if(A(s.charCodeAt(m)))return s.slice(0,m+1)}return""}e.getRoot=k;function r(s){if(!p.isWindows||!s||s.length<5)return!1;let n=s.charCodeAt(0);if(n!==92||(n=s.charCodeAt(1),n!==92))return!1;let o=2;const v=o;for(;o<s.length&&(n=s.charCodeAt(o),n!==92);o++);return!(v===o||(n=s.charCodeAt(o+1),isNaN(n)||n===92))}e.isUNC=r;const P=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(s,n=p.isWindows){const o=n?P:l;return!(!s||s.length===0||/^\s+$/.test(s)||(o.lastIndex=0,o.test(s))||n&&f.test(s)||s==="."||s===".."||n&&s[s.length-1]==="."||n&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=c;function h(s,n,o){const v=s===n;return!o||v?v:!s||!n?!1:R.equalsIgnoreCase(s,n)}e.isEqual=h;function _(s,n,o,v=C.sep){if(s===n)return!0;if(!s||!n||n.length>s.length)return!1;if(o){if(!R.startsWithIgnoreCase(s,n))return!1;if(n.length===s.length)return!0;let S=n.length;return n.charAt(n.length-1)===v&&S--,s.charAt(S)===v}return n.charAt(n.length-1)!==v&&(n+=v),s.indexOf(n)===0}e.isEqualOrParent=_;function w(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=w;function b(s,n){return p.isWindows&&s.endsWith(":")&&(s+=C.sep),C.isAbsolute(s)||(s=C.join(n,s)),s=C.normalize(s),p.isWindows?(s=R.rtrim(s,C.sep),s.endsWith(":")&&(s+=C.sep)):(s=R.rtrim(s,C.sep),s||(s=C.sep)),s}e.sanitizeFilePath=b;function d(s){const n=C.normalize(s);return p.isWindows?s.length>3?!1:u(n)&&(s.length===2||n.charCodeAt(2)===92):n===C.posix.sep}e.isRootOrDriveLetter=d;function u(s){return p.isWindows?w(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function g(s){return u(s)?s[0]:void 0}e.getDriveLetter=g;function t(s,n,o){return n.length>s.length?-1:s===n?0:(o&&(s=s.toLowerCase(),n=n.toLowerCase()),s.indexOf(n))}e.indexOfPath=t;function i(s){const n=s.split(":");let o,v,m;if(n.forEach(S=>{const D=Number(S);y.isNumber(D)?v===void 0?v=D:m===void 0&&(m=D):o=o?[o,S].join(":"):S}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:v!==void 0?v:void 0,column:m!==void 0?m:v!==void 0?1:void 0}}e.parseLineAndColumnAware=i}),define(ge[25],pe([0,1,15]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const _=Array.isArray(h)?[]:{};return Object.keys(h).forEach(w=>{h[w]&&typeof h[w]=="object"?_[w]=R(h[w]):_[w]=h[w]}),_}e.deepClone=R;function C(h){if(!h||typeof h!="object")return h;const _=[h];for(;_.length>0;){const w=_.shift();Object.freeze(w);for(const b in w)if(y.call(w,b)){const d=w[b];typeof d=="object"&&!Object.isFrozen(d)&&_.push(d)}}return h}e.deepFreeze=C;const y=Object.prototype.hasOwnProperty;function A(h,_){return I(h,_,new Set)}e.cloneAndChange=A;function I(h,_,w){if(p.isUndefinedOrNull(h))return h;const b=_(h);if(typeof b!="undefined")return b;if(p.isArray(h)){const d=[];for(const u of h)d.push(I(u,_,w));return d}if(p.isObject(h)){if(w.has(h))throw new Error("Cannot clone recursive data-structure");w.add(h);const d={};for(let u in h)y.call(h,u)&&(d[u]=I(h[u],_,w));return w.delete(h),d}return h}function E(h,_,w=!0){return p.isObject(h)?(p.isObject(_)&&Object.keys(_).forEach(b=>{b in h?w&&(p.isObject(h[b])&&p.isObject(_[b])?E(h[b],_[b],w):h[b]=_[b]):h[b]=_[b]}),h):_}e.mixin=E;function k(h,_){if(h===_)return!0;if(h==null||_===null||_===void 0||typeof h!=typeof _||typeof h!="object"||Array.isArray(h)!==Array.isArray(_))return!1;let w,b;if(Array.isArray(h)){if(h.length!==_.length)return!1;for(w=0;w<h.length;w++)if(!k(h[w],_[w]))return!1}else{const d=[];for(b in h)d.push(b);d.sort();const u=[];for(b in _)u.push(b);if(u.sort(),!k(d,u))return!1;for(w=0;w<d.length;w++)if(!k(h[d[w]],_[d[w]]))return!1}return!0}e.equals=k;function r(h){const _=new Set;return JSON.stringify(h,(w,b)=>{if(p.isObject(b)||Array.isArray(b)){if(_.has(b))return"[Circular]";_.add(b)}return b})}e.safeStringify=r;function P(h,_,w){const b=_(h);return typeof b=="undefined"?w:b}e.getOrDefault=P;function l(h,_){const w=Object.create(null);return!h||!_||Object.keys(_).forEach(d=>{const u=h[d],g=_[d];k(u,g)||(w[d]=g)}),w}e.distinct=l;function f(h,_){const w=_.toLowerCase(),b=Object.keys(h).find(d=>d.toLowerCase()===w);return b?h[b]:h[_]}e.getCaseInsensitive=f;function c(h,_){const w=Object.create(null);for(const b of Object.keys(h))_(b,h[b])&&(w[b]=h[b]);return w}e.filter=c}),define(ge[92],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var p;(function(y){y[y.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",y[y.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",y[y.MAX_UINT_8=255]="MAX_UINT_8",y[y.MAX_UINT_16=65535]="MAX_UINT_16",y[y.MAX_UINT_32=4294967295]="MAX_UINT_32",y[y.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(p=e.Constants||(e.Constants={}));function R(y){return y<0?0:y>255?255:y|0}e.toUint8=R;function C(y){return y<0?0:y>4294967295?4294967295:y|0}e.toUint32=C}),define(ge[2],pe([0,1,11,9]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,y=/^\//,A=/^\/\//;function I(s,n){if(!s.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!C.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!y.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(s,n){return!s&&!n?"file":s}function k(s,n){switch(s){case"https":case"http":case"file":n?n[0]!==P&&(n=P+n):n=P;break}return n}const r="",P="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(n,o,v,m,S,D=!1){typeof n=="object"?(this.scheme=n.scheme||r,this.authority=n.authority||r,this.path=n.path||r,this.query=n.query||r,this.fragment=n.fragment||r):(this.scheme=E(n,D),this.authority=o||r,this.path=k(this.scheme,v||r),this.query=m||r,this.fragment=S||r,I(this,D))}static isUri(n){return n instanceof f?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return d(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:v,path:m,query:S,fragment:D}=n;return o===void 0?o=this.scheme:o===null&&(o=r),v===void 0?v=this.authority:v===null&&(v=r),m===void 0?m=this.path:m===null&&(m=r),S===void 0?S=this.query:S===null&&(S=r),D===void 0?D=this.fragment:D===null&&(D=r),o===this.scheme&&v===this.authority&&m===this.path&&S===this.query&&D===this.fragment?this:new h(o,v,m,S,D)}static parse(n,o=!1){const v=l.exec(n);return v?new h(v[2]||r,i(v[4]||r),i(v[5]||r),i(v[7]||r),i(v[9]||r),o):new h(r,r,r,r,r)}static file(n){let o=r;if(p.isWindows&&(n=n.replace(/\\/g,P)),n[0]===P&&n[1]===P){const v=n.indexOf(P,2);v===-1?(o=n.substring(2),n=P):(o=n.substring(2,v),n=n.substring(v)||P)}return new h("file",o,n,r,r)}static from(n){const o=new h(n.scheme,n.authority,n.path,n.query,n.fragment);return I(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return p.isWindows&&n.scheme==="file"?v=f.file(R.win32.join(d(n,!0),...o)).path:v=R.posix.join(n.path,...o),n.with({path:v})}toString(n=!1){return u(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof f)return n;{const o=new h(n);return o._formatted=n.external,o._fsPath=n._sep===c?n.fsPath:null,o}}else return n}}e.URI=f;const c=p.isWindows?1:void 0;class h extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(n=!1){return n?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=c),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(s,n){let o,v=-1;for(let m=0;m<s.length;m++){const S=s.charCodeAt(m);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||n&&S===47)v!==-1&&(o+=encodeURIComponent(s.substring(v,m)),v=-1),o!==void 0&&(o+=s.charAt(m));else{o===void 0&&(o=s.substr(0,m));const D=_[S];D!==void 0?(v!==-1&&(o+=encodeURIComponent(s.substring(v,m)),v=-1),o+=D):v===-1&&(v=m)}}return v!==-1&&(o+=encodeURIComponent(s.substring(v))),o!==void 0?o:s}function b(s){let n;for(let o=0;o<s.length;o++){const v=s.charCodeAt(o);v===35||v===63?(n===void 0&&(n=s.substr(0,o)),n+=_[v]):n!==void 0&&(n+=s[o])}return n!==void 0?n:s}function d(s,n){let o;return s.authority&&s.path.length>1&&s.scheme==="file"?o=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?n?o=s.path.substr(1):o=s.path[1].toLowerCase()+s.path.substr(2):o=s.path,p.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=d;function u(s,n){const o=n?b:w;let v="",{scheme:m,authority:S,path:D,query:a,fragment:T}=s;if(m&&(v+=m,v+=":"),(S||m==="file")&&(v+=P,v+=P),S){let L=S.indexOf("@");if(L!==-1){const U=S.substr(0,L);S=S.substr(L+1),L=U.indexOf(":"),L===-1?v+=o(U,!1):(v+=o(U.substr(0,L),!1),v+=":",v+=o(U.substr(L+1),!1)),v+="@"}S=S.toLowerCase(),L=S.indexOf(":"),L===-1?v+=o(S,!1):(v+=o(S.substr(0,L),!1),v+=S.substr(L))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const L=D.charCodeAt(1);L>=65&&L<=90&&(D=`/${String.fromCharCode(L+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const L=D.charCodeAt(0);L>=65&&L<=90&&(D=`${String.fromCharCode(L+32)}:${D.substr(2)}`)}v+=o(D,!0)}return a&&(v+="?",v+=o(a,!1)),T&&(v+="#",v+=n?T:w(T,!1)),v}function g(s){try{return decodeURIComponent(s)}catch(n){return s.length>3?s.substr(0,3)+g(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(s){return s.match(t)?s.replace(t,n=>g(n)):s}});var rt=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},Be=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(ge[23],pe([0,1,2,8]),function(X,e,p,R){"use strict";var C,y,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(t,i,s){let n=t.get(i);return n===void 0&&(n=s,t.set(i,n)),n}e.getOrSet=I;function E(t){const i=[];return t.forEach((s,n)=>{i.push(`${n} => ${s}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=E;function k(t){const i=[];return t.forEach(s=>{i.push(s)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=k;class r{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),n=this._value.charCodeAt(this._pos);return s-n}value(){return this._value[this._pos]}}e.StringIterator=r;class P{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?R.compareSubstring(i,this._value,0,i.length,this._from,this._to):R.compareSubstringIgnoreCase(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class l{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?R.compareSubstring(i,this._value,0,i.length,this._from,this._to):R.compareSubstringIgnoreCase(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var f;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(f||(f={}));class c{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return R.compareIgnoreCase(i,this._value.scheme);if(this._states[this._stateIdx]===2)return R.compareIgnoreCase(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return R.compare(i,this._value.query);if(this._states[this._stateIdx]===5)return R.compare(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=c;class h{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class _{constructor(i){this._iter=i}static forUris(i=()=>!1){return new _(new c(i))}static forPaths(){return new _(new l)}static forStrings(){return new _(new r)}static forConfigKeys(){return new _(new P)}clear(){this._root=void 0}set(i,s){const n=this._iter.reset(i);let o;for(this._root||(this._root=new h,this._root.segment=n.value()),o=this._root;;){const m=n.cmp(o.segment);if(m>0)o.left||(o.left=new h,o.left.segment=n.value()),o=o.left;else if(m<0)o.right||(o.right=new h,o.right.segment=n.value()),o=o.right;else if(n.hasNext())n.next(),o.mid||(o.mid=new h,o.mid.segment=n.value()),o=o.mid;else break}const v=o.value;return o.value=s,o.key=i,v}get(i){var s;return(s=this._getNode(i))===null||s===void 0?void 0:s.value}_getNode(i){const s=this._iter.reset(i);let n=this._root;for(;n;){const o=s.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(s.hasNext())s.next(),n=n.mid;else break}return n}has(i){const s=this._getNode(i);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const n=this._iter.reset(i),o=[];let v=this._root;for(;v;){const m=n.cmp(v.segment);if(m>0)o.push([1,v]),v=v.left;else if(m<0)o.push([-1,v]),v=v.right;else if(n.hasNext())n.next(),o.push([0,v]),v=v.mid;else{for(s?(v.left=void 0,v.mid=void 0,v.right=void 0):v.value=void 0;o.length>0&&v.isEmpty();){let[S,D]=o.pop();switch(S){case 1:D.left=void 0;break;case 0:D.mid=void 0;break;case-1:D.right=void 0;break}v=D}break}}}findSubstr(i){const s=this._iter.reset(i);let n=this._root,o;for(;n;){const v=s.cmp(n.segment);if(v>0)n=n.left;else if(v<0)n=n.right;else if(s.hasNext())s.next(),o=n.value||o,n=n.mid;else break}return n&&n.value||o}findSuperstr(i){const s=this._iter.reset(i);let n=this._root;for(;n;){const o=s.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(s.hasNext())s.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(i){for(const[s,n]of this)i(n,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){if(!i)return;const s=[i];for(;s.length>0;){const n=s.pop();n&&(n.value&&(yield[n.key,n.value]),n.left&&s.push(n.left),n.mid&&s.push(n.mid),n.right&&s.push(n.right))}}}e.TernarySearchTree=_;class w{constructor(i,s){this[C]="ResourceMap",i instanceof w?(this.map=new Map(i.map),this.toKey=s??w.defaultToKey):(this.map=new Map,this.toKey=i??w.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),s),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(let[n,o]of this.map)i(o,p.URI.parse(n),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield p.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[p.URI.parse(i[0]),i[1]]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[p.URI.parse(i[0]),i[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var b;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class d{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,s=0){const n=this._map.get(i);if(!!n)return s!==0&&this.touch(n,s),n.value}set(i,s,n=0){let o=this._map.get(i);if(o)o.value=s,n!==0&&this.touch(o,n);else{switch(o={key:i,value:s,next:void 0,previous:void 0},n){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(i,o),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const n=this._state;let o=this._head;for(;o;){if(s?i.bind(s)(o.value,o.key,this):i(o.value,o.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const i=this,s=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(n){const v={value:n.key,done:!1};return n=n.next,v}else return{value:void 0,done:!0}}};return o}values(){const i=this,s=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(n){const v={value:n.value,done:!1};return n=n.next,v}else return{value:void 0,done:!0}}};return o}entries(){const i=this,s=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(n){const v={value:[n.key,n.value],done:!1};return n=n.next,v}else return{value:void 0,done:!0}}};return o}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,n=this.size;for(;s&&n>i;)this._map.delete(s.key),s=s.next,n--;this._head=s,this._size=n,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,n=i.previous;if(!s||!n)throw new Error("Invalid list");s.previous=n,n.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const n=i.next,o=i.previous;i===this._tail?(o.next=void 0,this._tail=o):(n.previous=o,o.next=n),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const n=i.next,o=i.previous;i===this._head?(n.previous=void 0,this._head=n):(n.previous=o,o.next=n),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,n)=>{i.push([n,s])}),i}fromJSON(i){this.clear();for(const[s,n]of i)this.set(s,n)}}e.LinkedMap=d;class u extends d{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u;class g{constructor(i){A.set(this,void 0),rt(this,A,i,"f")}get size(){return Be(this,A,"f").size}forEach(i,s){Be(this,A,"f").forEach(i,s)}get(i){return Be(this,A,"f").get(i)}has(i){return Be(this,A,"f").has(i)}entries(){return Be(this,A,"f").entries()}keys(){return Be(this,A,"f").keys()}values(){return Be(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return Be(this,A,"f").entries()}}e.ReadonlyMapView=g}),define(ge[93],pe([0,1,23,8]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...J){return function(le,me){for(let Le=0,We=J.length;Le<We;Le++){const be=J[Le](le,me);if(be)return be}return null}}e.or=C,e.matchesStrictPrefix=y.bind(void 0,!1),e.matchesPrefix=y.bind(void 0,!0);function y(J,le,me){if(!me||me.length<le.length)return null;let Le;return J?Le=R.startsWithIgnoreCase(me,le):Le=me.indexOf(le)===0,Le?le.length>0?[{start:0,end:le.length}]:[]:null}function A(J,le){const me=le.toLowerCase().indexOf(J.toLowerCase());return me===-1?null:[{start:me,end:me+J.length}]}e.matchesContiguousSubString=A;function I(J,le){return E(J.toLowerCase(),le.toLowerCase(),0,0)}e.matchesSubString=I;function E(J,le,me,Le){if(me===J.length)return[];if(Le===le.length)return null;if(J[me]===le[Le]){let We=null;return(We=E(J,le,me+1,Le+1))?w({start:Le,end:Le+1},We):null}return E(J,le,me,Le+1)}function k(J){return 97<=J&&J<=122}function r(J){return 65<=J&&J<=90}e.isUpper=r;function P(J){return 48<=J&&J<=57}function l(J){return J===32||J===9||J===10||J===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(J=>f.add(J.charCodeAt(0)));function c(J){return l(J)||f.has(J)}function h(J,le){return J===le||c(J)&&c(le)}function _(J){return k(J)||r(J)||P(J)}function w(J,le){return le.length===0?le=[J]:J.end===le[0].start?le[0].start=J.start:le.unshift(J),le}function b(J,le){for(let me=le;me<J.length;me++){const Le=J.charCodeAt(me);if(r(Le)||P(Le)||me>0&&!_(J.charCodeAt(me-1)))return me}return J.length}function d(J,le,me,Le){if(me===J.length)return[];if(Le===le.length)return null;if(J[me]!==le[Le].toLowerCase())return null;{let We=null,be=Le+1;for(We=d(J,le,me+1,Le+1);!We&&(be=b(le,be))<le.length;)We=d(J,le,me+1,be),be++;return We===null?null:w({start:Le,end:Le+1},We)}}function u(J){let le=0,me=0,Le=0,We=0,be=0;for(let Fe=0;Fe<J.length;Fe++)be=J.charCodeAt(Fe),r(be)&&le++,k(be)&&me++,_(be)&&Le++,P(be)&&We++;const Qe=le/J.length,K=me/J.length,re=Le/J.length,ve=We/J.length;return{upperPercent:Qe,lowerPercent:K,alphaPercent:re,numericPercent:ve}}function g(J){const{upperPercent:le,lowerPercent:me}=J;return me===0&&le>.6}function t(J){const{upperPercent:le,lowerPercent:me,alphaPercent:Le,numericPercent:We}=J;return me>.2&&le<.8&&Le>.6&&We<.2}function i(J){let le=0,me=0,Le=0,We=0;for(let be=0;be<J.length;be++)Le=J.charCodeAt(be),r(Le)&&le++,k(Le)&&me++,l(Le)&&We++;return(le===0||me===0)&&We===0?J.length<=30:le<=5}function s(J,le){if(!le||(le=le.trim(),le.length===0)||!i(J)||le.length>60)return null;const me=u(le);if(!t(me)){if(!g(me))return null;le=le.toLowerCase()}let Le=null,We=0;for(J=J.toLowerCase();We<le.length&&(Le=d(J,le,0,We))===null;)We=b(le,We+1);return Le}e.matchesCamelCase=s;function n(J,le,me=!1){if(!le||le.length===0)return null;let Le=null,We=0;for(J=J.toLowerCase(),le=le.toLowerCase();We<le.length&&(Le=o(J,le,0,We,me))===null;)We=v(le,We+1);return Le}e.matchesWords=n;function o(J,le,me,Le,We){if(me===J.length)return[];if(Le===le.length)return null;if(h(J.charCodeAt(me),le.charCodeAt(Le))){let be=null,Qe=Le+1;if(be=o(J,le,me+1,Le+1,We),!We)for(;!be&&(Qe=v(le,Qe))<le.length;)be=o(J,le,me+1,Qe,We),Qe++;return be===null?null:w({start:Le,end:Le+1},be)}else return null}function v(J,le){for(let me=le;me<J.length;me++)if(c(J.charCodeAt(me))||me>0&&c(J.charCodeAt(me-1)))return me;return J.length}const m=C(e.matchesPrefix,s,A),S=C(e.matchesPrefix,s,I),D=new p.LRUCache(1e4);function a(J,le,me=!1){if(typeof J!="string"||typeof le!="string")return null;let Le=D.get(J);Le||(Le=new RegExp(R.convertSimple2RegExpPattern(J),"i"),D.set(J,Le));const We=Le.exec(le);return We?[{start:We.index,end:We.index+We[0].length}]:me?S(J,le):m(J,le)}e.matchesFuzzy=a;function T(J,le){const me=Ge(J,J.toLowerCase(),0,le,le.toLowerCase(),0,!0);return me?U(me):null}e.matchesFuzzy2=T;function L(J,le,me,Le,We,be){const Qe=Math.min(13,J.length);for(;me<Qe;me++){const K=Ge(J,le,me,Le,We,be,!1);if(K)return K}return[0,be]}e.anyScore=L;function U(J){if(typeof J=="undefined")return[];const le=[],me=J[1];for(let Le=J.length-1;Le>1;Le--){const We=J[Le]+me,be=le[le.length-1];be&&be.end===We?be.end=We+1:le.push({start:We,end:We+1})}return le}e.createMatches=U;const G=128;function te(){const J=[],le=[];for(let me=0;me<=G;me++)le[me]=0;for(let me=0;me<=G;me++)J.push(le.slice(0));return J}function V(J){const le=[];for(let me=0;me<=J;me++)le[me]=0;return le}const N=V(2*G),W=V(2*G),M=te(),q=te(),O=te(),F=!1;function B(J,le,me,Le,We){function be(K,re,ve=" "){for(;K.length<re;)K=ve+K;return K}let Qe=` |   |${Le.split("").map(K=>be(K,3)).join("|")}
`;for(let K=0;K<=me;K++)K===0?Qe+=" |":Qe+=`${le[K-1]}|`,Qe+=J[K].slice(0,We+1).map(re=>be(re.toString(),3)).join("|")+`
`;return Qe}function $(J,le,me,Le){J=J.substr(le),me=me.substr(Le),console.log(B(q,J,J.length,me,me.length)),console.log(B(O,J,J.length,me,me.length)),console.log(B(M,J,J.length,me,me.length))}function Y(J,le){if(le<0||le>=J.length)return!1;const me=J.codePointAt(le);switch(me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(me)}}function ce(J,le){if(le<0||le>=J.length)return!1;switch(J.charCodeAt(le)){case 32:case 9:return!0;default:return!1}}function we(J,le,me){return le[J]!==me[J]}function Re(J,le,me,Le,We,be,Qe=!1){for(;le<me&&We<be;)J[le]===Le[We]&&(Qe&&(N[le]=We),le+=1),We+=1;return le===me}e.isPatternInWord=Re;var ke;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(ke||(ke={}));var Me;(function(J){J.Default=[-100,0];function le(me){return!me||me.length===2&&me[0]===-100&&me[1]===0}J.isDefault=le})(Me=e.FuzzyScore||(e.FuzzyScore={}));function Ge(J,le,me,Le,We,be,Qe){const K=J.length>G?G:J.length,re=Le.length>G?G:Le.length;if(me>=K||be>=re||K-me>re-be||!Re(le,me,K,We,be,re,!0))return;ze(K,re,me,be,le,We);let ve=1,Fe=1,Oe=me,Xe=be;const De=[!1];for(ve=1,Oe=me;Oe<K;ve++,Oe++){const H=N[Oe],ee=W[Oe],ue=Oe+1<K?W[Oe+1]:re;for(Fe=H-be+1,Xe=H;Xe<ue;Fe++,Xe++){let Ie=Number.MIN_SAFE_INTEGER,Te=!1;Xe<=ee&&(Ie=je(J,le,Oe,me,Le,We,Xe,re,be,M[ve-1][Fe-1]===0,De));let Ue=0;Ie!==Number.MAX_SAFE_INTEGER&&(Te=!0,Ue=Ie+q[ve-1][Fe-1]);const He=Xe>H,et=He?q[ve][Fe-1]+(M[ve][Fe-1]>0?-5:0):0,Je=Xe>H+1&&M[ve][Fe-1]>0,Ye=Je?q[ve][Fe-2]+(M[ve][Fe-2]>0?-5:0):0;if(Je&&(!He||Ye>=et)&&(!Te||Ye>=Ue))q[ve][Fe]=Ye,O[ve][Fe]=3,M[ve][Fe]=0;else if(He&&(!Te||et>=Ue))q[ve][Fe]=et,O[ve][Fe]=2,M[ve][Fe]=0;else if(Te)q[ve][Fe]=Ue,O[ve][Fe]=1,M[ve][Fe]=M[ve-1][Fe-1]+1;else throw new Error("not possible")}}if(F&&$(J,me,Le,be),!De[0]&&!Qe)return;ve--,Fe--;const _e=[q[ve][Fe],be];let Pe=0,ae=0;for(;ve>=1;){let H=Fe;do{const ee=O[ve][H];if(ee===3)H=H-2;else if(ee===2)H=H-1;else break}while(H>=1);Pe>1&&le[me+ve-1]===We[be+Fe-1]&&!we(H+be-1,Le,We)&&Pe+1>M[ve][H]&&(H=Fe),H===Fe?Pe++:Pe=1,ae||(ae=H),ve--,Fe=H-1,_e.push(Fe)}re===K&&(_e[0]+=2);const he=ae-K;return _e[0]-=he,_e}e.fuzzyScore=Ge;function ze(J,le,me,Le,We,be){let Qe=J-1,K=le-1;for(;Qe>=me&&K>=Le;)We[Qe]===be[K]&&(W[Qe]=K,Qe--),K--}function je(J,le,me,Le,We,be,Qe,K,re,ve,Fe){if(le[me]!==be[Qe])return Number.MIN_SAFE_INTEGER;let Oe=1,Xe=!1;return Qe===me-Le?Oe=J[me]===We[Qe]?7:5:we(Qe,We,be)&&(Qe===0||!we(Qe-1,We,be))?(Oe=J[me]===We[Qe]?7:5,Xe=!0):Y(be,Qe)&&(Qe===0||!Y(be,Qe-1))?Oe=5:(Y(be,Qe-1)||ce(be,Qe-1))&&(Oe=5,Xe=!0),Oe>1&&me===Le&&(Fe[0]=!0),Xe||(Xe=we(Qe,We,be)||Y(be,Qe-1)||ce(be,Qe-1)),me===Le?Qe>re&&(Oe-=Xe?3:5):ve?Oe+=Xe?2:0:Oe+=Xe?0:1,Qe+1===K&&(Oe-=Xe?3:5),Oe}function j(J,le,me,Le,We,be,Qe){return ie(J,le,me,Le,We,be,!0,Qe)}e.fuzzyScoreGracefulAggressive=j;function Z(J,le,me,Le,We,be,Qe){return ie(J,le,me,Le,We,be,!1,Qe)}e.fuzzyScoreGraceful=Z;function ie(J,le,me,Le,We,be,Qe,K){let re=Ge(J,le,me,Le,We,be,K);if(re&&!Qe)return re;if(J.length>=3){const ve=Math.min(7,J.length-1);for(let Fe=me+1;Fe<ve;Fe++){const Oe=oe(J,Fe);if(Oe){const Xe=Ge(Oe,Oe.toLowerCase(),me,Le,We,be,K);Xe&&(Xe[0]-=3,(!re||Xe[0]>re[0])&&(re=Xe))}}}return re}function oe(J,le){if(le+1>=J.length)return;const me=J[le],Le=J[le+1];if(me!==Le)return J.slice(0,le)+Le+me+J.slice(le+2)}}),define(ge[136],pe([0,1,90,93,8]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const y=new RegExp(`\\$\\(${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${y.source}`,"g");function I(h){return h.replace(A,(_,w)=>w?_:`\\${_}`)}e.escapeIcons=I;const E=new RegExp(`\\\\${y.source}`,"g");function k(h){return h.replace(E,_=>`\\${_}`)}e.markdownEscapeEscapedIcons=k;const r=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function P(h){return h.indexOf(e.iconStartMarker)===-1?h:h.replace(r,(_,w,b,d)=>b?_:w||d||"")}e.stripIcons=P;function l(h){const _=h.indexOf(e.iconStartMarker);return _===-1?{text:h}:f(h,_)}e.parseLabelWithIcons=l;function f(h,_){const w=[];let b="";function d(v){if(v){b+=v;for(const m of v)w.push(t)}}let u=-1,g="",t=0,i,s,n=_;const o=h.length;for(d(h.substr(0,_));n<o;)i=h[n],s=h[n+1],i===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(u=n,d(g),g=e.iconStartMarker,n++):i===")"&&u!==-1?(t+=n-u+1,u=-1,g=""):u!==-1?/^[a-z0-9\-]$/i.test(i)?g+=i:(d(g),u=-1,g=""):d(i),n++;return d(g),{text:b,iconOffsets:w}}function c(h,_,w=!1){const{text:b,iconOffsets:d}=_;if(!d||d.length===0)return R.matchesFuzzy(h,b,w);const u=C.ltrim(b," "),g=b.length-u.length,t=R.matchesFuzzy(h,u,w);if(t)for(const i of t){const s=d[i.start+g]+g;i.start+=s,i.end+=s}return t}e.matchesFuzzyIconAware=c}),define(ge[94],pe([0,1,136,14]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var C;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(C=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(f="",c=!1){var h,_;if(this.value=f,typeof this.value!="string")throw R.illegalArgument("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1):(this.isTrusted=(h=c.isTrusted)!==null&&h!==void 0?h:void 0,this.supportThemeIcons=(_=c.supportThemeIcons)!==null&&_!==void 0?_:!1)}appendText(f,c=0){return this.value+=k(this.supportThemeIcons?p.escapeIcons(f):f).replace(/([ \t]+)/g,(h,_)=>"&nbsp;".repeat(_.length)).replace(/^>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,c){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}}e.MarkdownString=y;function A(l){return I(l)?!l.value:Array.isArray(l)?l.every(A):!0}e.isEmptyMarkdownString=A;function I(l){return l instanceof y?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=I;function E(l,f){return l===f?!0:!l||!f?!1:l.value===f.value&&l.isTrusted===f.isTrusted&&l.supportThemeIcons===f.supportThemeIcons}e.markdownStringEqual=E;function k(l){return l.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=k;function r(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=r;function P(l){const f=[],c=l.split("|").map(_=>_.trim());l=c[0];const h=c[1];if(h){const _=/height=(\d+)/.exec(h),w=/width=(\d+)/.exec(h),b=_?_[1]:"",d=w?w[1]:"",u=isFinite(parseInt(d)),g=isFinite(parseInt(b));u&&f.push(`width="${d}"`),g&&f.push(`height="${b}"`)}return{href:l,dimensions:f}}e.parseHrefAndDimensions=P}),define(ge[55],pe([0,1,22,8,2]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function y(r){return JSON.stringify(r,E)}e.stringify=y;function A(r){let P=JSON.parse(r);return P=k(P),P}e.parse=A;var I;(function(r){r[r.Uri=1]="Uri",r[r.Regexp=2]="Regexp",r[r.ScmResource=3]="ScmResource",r[r.ScmResourceGroup=4]="ScmResourceGroup",r[r.ScmProvider=5]="ScmProvider",r[r.CommentController=6]="CommentController",r[r.CommentThread=7]="CommentThread",r[r.CommentThreadReply=8]="CommentThreadReply",r[r.CommentNode=9]="CommentNode",r[r.CommentThreadNode=10]="CommentThreadNode",r[r.TimelineActionContext=11]="TimelineActionContext",r[r.NotebookCellActionContext=12]="NotebookCellActionContext",r[r.TestItemContext=13]="TestItemContext"})(I=e.MarshalledId||(e.MarshalledId={}));function E(r,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:R.regExpFlags(P)}:P}function k(r,P=0){if(!r||P>200)return r;if(typeof r=="object"){switch(r.$mid){case 1:return C.URI.revive(r);case 2:return new RegExp(r.source,r.flags)}if(r instanceof p.VSBuffer||r instanceof Uint8Array)return r;if(Array.isArray(r))for(let l=0;l<r.length;++l)r[l]=k(r[l],P+1);else for(const l in r)Object.hasOwnProperty.call(r,l)&&(r[l]=k(r[l],P+1))}return r}e.revive=k}),define(ge[10],pe([0,1,2,11]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var C;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp"})(C=e.Schemas||(e.Schemas={}));class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}set(E,k,r){this._hosts[E]=k,this._ports[E]=r}setConnectionToken(E,k){this._connectionTokens[E]=k}rewrite(E){if(this._delegate)return this._delegate(E);const k=E.authority;let r=this._hosts[k];r&&r.indexOf(":")!==-1&&(r=`[${r}]`);const P=this._ports[k],l=this._connectionTokens[k];let f=`path=${encodeURIComponent(E.path)}`;return typeof l=="string"&&(f+=`&tkn=${encodeURIComponent(l)}`),p.URI.from({scheme:R.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${r}:${P}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new y;class A{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(E,k,r){const P=this.toUri(E,k);if(P.scheme===C.vscodeRemote)return e.RemoteAuthorities.rewrite(P);let l=!1;return R.isNative&&(r||R.isPreferringBrowserCodeLoad)&&P.scheme===C.file&&(l=!0),P.scheme===C.file&&typeof R.globals.importScripts=="function"&&R.globals.origin==="vscode-file://vscode-app"&&(l=!0),l?P.with({scheme:C.vscodeFileResource,authority:P.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(E,k){const r=this.toUri(E,k);return r.scheme===C.vscodeFileResource?r.with({scheme:C.file,authority:r.authority!==this.FALLBACK_AUTHORITY?r.authority:null,query:null,fragment:null}):r}toUri(E,k){return p.URI.isUri(E)?E:p.URI.parse(k.toUrl(E))}}e.FileAccess=new A}),define(ge[74],pe([0,1,23]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const R=new p.LRUCache(1e4);function C(k){return E(k,"NFC",R)}e.normalizeNFC=C;const y=new p.LRUCache(1e4);function A(k){return E(k,"NFD",y)}e.normalizeNFD=A;const I=/[^\u0000-\u0080]/;function E(k,r,P){if(!e.canNormalize||!k)return k;const l=P.get(k);if(l)return l;let f;return I.test(k)?f=k.normalize(r):f=k,P.set(k,f),f}e.removeAccents=function(){if(e.canNormalize){const k=/[\u0300-\u036f]/g;return function(r){return A(r).replace(k,"")}}else return function(k){return k}}()}),define(ge[24],pe([0,1,29,9,2,8,10,11]),function(X,e,p,R,C,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(f){return C.uriToFsPath(f,!0)}e.originalFSPath=E;class k{constructor(c){this._ignorePathCasing=c}compare(c,h,_=!1){return c===h?0:y.compare(this.getComparisonKey(c,_),this.getComparisonKey(h,_))}isEqual(c,h,_=!1){return c===h?!0:!c||!h?!1:this.getComparisonKey(c,_)===this.getComparisonKey(h,_)}getComparisonKey(c,h=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,h,_=!1){if(c.scheme===h.scheme){if(c.scheme===A.Schemas.file)return p.isEqualOrParent(E(c),E(h),this._ignorePathCasing(c))&&c.query===h.query&&(_||c.fragment===h.fragment);if(e.isEqualAuthority(c.authority,h.authority))return p.isEqualOrParent(c.path,h.path,this._ignorePathCasing(c),"/")&&c.query===h.query&&(_||c.fragment===h.fragment)}return!1}joinPath(c,...h){return C.URI.joinPath(c,...h)}basenameOrAuthority(c){return e.basename(c)||c.authority}basename(c){return R.posix.basename(c.path)}extname(c){return R.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let h;return c.scheme===A.Schemas.file?h=C.URI.file(R.dirname(E(c))).path:(h=R.posix.dirname(c.path),c.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),h="/")),c.with({path:h})}normalizePath(c){if(!c.path.length)return c;let h;return c.scheme===A.Schemas.file?h=C.URI.file(R.normalize(E(c))).path:h=R.posix.normalize(c.path),c.with({path:h})}relativePath(c,h){if(c.scheme!==h.scheme||!e.isEqualAuthority(c.authority,h.authority))return;if(c.scheme===A.Schemas.file){const b=R.relative(E(c),E(h));return I.isWindows?p.toSlashes(b):b}let _=c.path||"/",w=h.path||"/";if(this._ignorePathCasing(c)){let b=0;for(const d=Math.min(_.length,w.length);b<d&&!(_.charCodeAt(b)!==w.charCodeAt(b)&&_.charAt(b).toLowerCase()!==w.charAt(b).toLowerCase());b++);_=w.substr(0,b)+_.substr(b)}return R.posix.relative(_,w)}resolvePath(c,h){if(c.scheme===A.Schemas.file){const _=C.URI.file(R.resolve(E(c),h));return c.with({authority:_.authority,path:_.path})}return h=p.toPosixPath(h),c.with({path:R.posix.resolve(c.path,h)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,h){return c===h||y.equalsIgnoreCase(c,h)}hasTrailingPathSeparator(c,h=R.sep){if(c.scheme===A.Schemas.file){const _=E(c);return _.length>p.getRoot(_).length&&_[_.length-1]===h}else{const _=c.path;return _.length>1&&_.charCodeAt(_.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,h=R.sep){return e.hasTrailingPathSeparator(c,h)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,h=R.sep){let _=!1;if(c.scheme===A.Schemas.file){const w=E(c);_=w!==void 0&&w.length===p.getRoot(w).length&&w[w.length-1]===h}else{h="/";const w=c.path;_=w.length===1&&w.charCodeAt(w.length-1)===47}return!_&&!e.hasTrailingPathSeparator(c,h)?c.with({path:c.path+"/"}):c}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(f=>f.scheme===A.Schemas.file?!I.isLinux:!0),e.extUriIgnorePathCase=new k(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function r(f,c){const h=[];for(let _=0;_<f.length;_++){const w=c(f[_]);f.some((b,d)=>d===_?!1:e.isEqualOrParent(w,c(b)))||h.push(f[_])}return h}e.distinctParents=r;var P;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function c(h){const _=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(d=>{const[u,g]=d.split(":");u&&g&&_.set(u,g)});const b=h.path.substring(0,h.path.indexOf(";"));return b&&_.set(f.META_DATA_MIME,b),_}f.parseMetaData=c})(P=e.DataUri||(e.DataUri={}));function l(f,c,h){if(c){let _=f.path;return _&&_[0]!==R.posix.sep&&(_=R.posix.sep+_),f.with({scheme:h,authority:c,path:_})}return f.with({scheme:h})}e.toLocalResource=l}),define(ge[16],pe([0,1,21,14,3,6,71,24]),function(X,e,p,R,C,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(O){return!!O&&typeof O.then=="function"}e.isThenable=E;function k(O){const F=new p.CancellationTokenSource,B=O(F.token),$=new Promise((Y,ce)=>{F.token.onCancellationRequested(()=>{ce(R.canceled())}),Promise.resolve(B).then(we=>{F.dispose(),Y(we)},we=>{F.dispose(),ce(we)})});return new class{cancel(){F.cancel()}then(Y,ce){return $.then(Y,ce)}catch(Y){return this.then(void 0,Y)}finally(Y){return $.finally(Y)}}}e.createCancelablePromise=k;function r(O,F,B){return Promise.race([O,new Promise($=>F.onCancellationRequested(()=>$(B)))])}e.raceCancellation=r;async function P(O){let F=-1;const B=O.map((Y,ce)=>Y.then(we=>(F=ce,we))),$=await Promise.race(B);return O.forEach((Y,ce)=>{ce!==F&&Y.cancel()}),$}e.raceCancellablePromises=P;function l(O,F,B){let $;const Y=setTimeout(()=>{$==null||$(void 0),B==null||B()},F);return Promise.race([O.finally(()=>clearTimeout(Y)),new Promise(ce=>$=ce)])}e.raceTimeout=l;function f(O){return new Promise((F,B)=>{const $=O();E($)?$.then(F,B):F($)})}e.asPromise=f;class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const B=()=>{this.queuedPromise=null;const $=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,$};this.queuedPromise=new Promise($=>{this.activePromise.then(B,B).then($)})}return new Promise((B,$)=>{this.queuedPromise.then(B,$)})}return this.activePromise=F(),new Promise((B,$)=>{this.activePromise.then(Y=>{this.activePromise=null,B(Y)},Y=>{this.activePromise=null,$(Y)})})}}e.Throttler=c;class h{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=h;class _{constructor(){this.promiseMap=new Map}queue(F,B){var $;const ce=(($=this.promiseMap.get(F))!==null&&$!==void 0?$:Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.promiseMap.get(F)===ce&&this.promiseMap.delete(F)});return this.promiseMap.set(F,ce),ce}}e.SequencerByKey=_;class w{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,B=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise(($,Y)=>{this.doResolve=$,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const $=this.task;return this.task=null,$()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},B),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(R.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=w;class b{constructor(F){this.delayer=new w(F),this.throttler=new c}trigger(F,B){return this.delayer.trigger(()=>this.throttler.queue(F),B)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class d{constructor(){this._isOpen=!1,this._promise=new Promise((F,B)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=d;class u extends d{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function g(O,F){return F?new Promise((B,$)=>{const Y=setTimeout(B,O);F.onCancellationRequested(()=>{clearTimeout(Y),$(R.canceled())})}):k(B=>g(O,B))}e.timeout=g;function t(O,F=0){const B=setTimeout(O,F);return y.toDisposable(()=>clearTimeout(B))}e.disposableTimeout=t;function i(O){return O.then(void 0,F=>{})}e.ignoreErrors=i;function s(O){const F=[];let B=0;const $=O.length;function Y(){return B<$?O[B++]():null}function ce(we){we!=null&&F.push(we);const Re=Y();return Re?Re.then(ce):Promise.resolve(F)}return Promise.resolve(null).then(ce)}e.sequence=s;function n(O,F=$=>!!$,B=null){let $=0;const Y=O.length,ce=()=>{if($>=Y)return Promise.resolve(B);const we=O[$++];return Promise.resolve(we()).then(ke=>F(ke)?Promise.resolve(ke):ce())};return ce()}e.first=n;function o(O,F=$=>!!$,B=null){if(O.length===0)return Promise.resolve(B);let $=O.length;const Y=()=>{var ce,we;$=-1;for(const Re of O)(we=(ce=Re).cancel)===null||we===void 0||we.call(ce)};return new Promise((ce,we)=>{for(const Re of O)Re.then(ke=>{--$>=0&&F(ke)?(Y(),ce(ke)):$===0&&ce(B)}).catch(ke=>{--$>=0&&(Y(),we(ke))})})}e.firstParallel=o;class v{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new C.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((B,$)=>{this.outstandingPromises.push({factory:F,c:B,e:$}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const B=F.factory();B.then(F.c,F.e),B.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=v;class m extends v{constructor(){super(1)}}e.Queue=m;class S{constructor(){this.queues=new Map}queueFor(F,B=I.extUri){const $=B.getComparisonKey(F);let Y=this.queues.get($);return Y||(Y=new m,C.Event.once(Y.onFinished)(()=>{Y==null||Y.dispose(),this.queues.delete($)}),this.queues.set($,Y)),Y}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=S;class D{constructor(F,B){this._token=-1,typeof F=="function"&&typeof B=="number"&&this.setIfNotSet(F,B)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,B){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},B)}setIfNotSet(F,B){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},B))}}e.TimeoutTimer=D;class a{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,B){this.cancel(),this._token=setInterval(()=>{F()},B)}}e.IntervalTimer=a;class T{constructor(F,B){this.timeoutToken=-1,this.runner=F,this.timeout=B,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=T;class L extends T{constructor(F,B){super(F,B);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L;class U extends y.Disposable{constructor(F,B,$,Y){super();this.maxWorkChunkSize=F,this.maxPendingWork=B,this.throttleDelay=$,this.handler=Y,this.pendingWork=[],this.throttler=this._register(new y.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.maxPendingWork)return!1}else if(this.pending+F.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new T(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const O=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const B=setTimeout(()=>F(O));let $=!1;return{dispose(){$||($=!0,clearTimeout(B))}}}}else e.runWhenIdle=(O,F)=>{const B=requestIdleCallback(O,typeof F=="number"?{timeout:F}:void 0);let $=!1;return{dispose(){$||($=!0,cancelIdleCallback(B))}}}}();class G{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(B){this._error=B}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=G;async function te(O,F,B){let $;for(let Y=0;Y<B;Y++)try{return await O()}catch(ce){$=ce,await g(F)}throw $}e.retry=te;class V{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var F;(F=this._pending)===null||F===void 0||F.cancel()}setPending(F,B,$){return this._pending={taskId:F,cancel:()=>$==null?void 0:$(),promise:B},B.then(()=>this.donePending(F),()=>this.donePending(F)),B}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let B,$;const Y=new Promise((ce,we)=>{B=ce,$=we});this._next={run:F,promise:Y,promiseResolve:B,promiseReject:$}}return this._next.promise}}e.TaskSequentializer=V;class N{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=N;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,B)=>{this.completeCallback=F,this.errorCallback=B})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(B=>{this.completeCallback(F),this.resolved=!0,B()})}error(F){return new Promise(B=>{this.errorCallback(F),this.rejected=!0,B()})}cancel(){new Promise(F=>{this.errorCallback(R.canceled()),this.rejected=!0,F()})}}e.DeferredPromise=W;class M extends C.Emitter{async fireAsync(F,B,$){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const Y of this._listeners)this._asyncDeliveryQueue.push([Y,F]);for(;this._asyncDeliveryQueue.size>0&&!B.isCancellationRequested;){const[Y,ce]=this._asyncDeliveryQueue.shift(),we=[],Re=Object.assign(Object.assign({},ce),{waitUntil:ke=>{if(Object.isFrozen(we))throw new Error("waitUntil can NOT be called asynchronous");$&&(ke=$(ke,typeof Y=="function"?Y:Y[0])),we.push(ke)}});try{typeof Y=="function"?Y.call(void 0,Re):Y[0].call(Y[1],Re)}catch(ke){R.onUnexpectedError(ke);continue}Object.freeze(we),await q.settled(we).catch(ke=>R.onUnexpectedError(ke))}}}}e.AsyncEmitter=M;var q;(function(O){async function F(ce){return typeof Promise.allSettled=="function"?B(ce):$(ce)}O.allSettled=F;async function B(ce){return Promise.allSettled(ce)}async function $(ce){return Promise.all(ce.map(we=>we.then(Re=>({status:"fulfilled",value:Re}),Re=>({status:"rejected",reason:Re}))))}async function Y(ce){let we;const Re=await Promise.all(ce.map(ke=>ke.then(Me=>Me,Me=>{we||(we=Me)})));if(typeof we!="undefined")throw we;return Re}O.settled=Y})(q=e.Promises||(e.Promises={}))}),define(ge[95],pe([0,1,9,16]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new R.IdleValue(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),y=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(D,a,T=!1){const L=D||"",U=a||"",G=C.value.collator.compare(L,U);return C.value.collatorIsNumeric&&G===0&&L!==U?L<U?-1:1:G}e.compareFileNames=I;function E(D,a){const T=y.value.collator;return D=D||"",a=a||"",g(T,D,a)}e.compareFileNamesDefault=E;function k(D,a){const T=y.value.collator;return D=D||"",a=a||"",n(D,a)||g(T,D,a)}e.compareFileNamesUpper=k;function r(D,a){const T=y.value.collator;return D=D||"",a=a||"",s(D,a)||g(T,D,a)}e.compareFileNamesLower=r;function P(D,a){return D=D||"",a=a||"",D===a?0:D<a?-1:1}e.compareFileNamesUnicode=P;function l(D,a,T=!1){T||(D=D&&D.toLowerCase(),a=a&&a.toLowerCase());const[L,U]=d(D),[G,te]=d(a);return L!==G?L<G?-1:1:U===te?0:U<te?-1:1}e.noIntlCompareFileNames=l;function f(D,a){const[T,L]=d(D),[U,G]=d(a);let te=C.value.collator.compare(L,G);if(te===0){if(C.value.collatorIsNumeric&&L!==G)return L<G?-1:1;if(te=C.value.collator.compare(T,U),C.value.collatorIsNumeric&&te===0&&T!==U)return T<U?-1:1}return te}e.compareFileExtensions=f;function c(D,a){D=D||"",a=a||"";const T=u(D),L=u(a),U=y.value.collator,G=A.value.collator;return g(G,T,L)||g(U,D,a)}e.compareFileExtensionsDefault=c;function h(D,a){D=D||"",a=a||"";const T=u(D),L=u(a),U=y.value.collator,G=A.value.collator;return g(G,T,L)||n(D,a)||g(U,D,a)}e.compareFileExtensionsUpper=h;function _(D,a){D=D||"",a=a||"";const T=u(D),L=u(a),U=y.value.collator,G=A.value.collator;return g(G,T,L)||s(D,a)||g(U,D,a)}e.compareFileExtensionsLower=_;function w(D,a){D=D||"",a=a||"";const T=u(D).toLowerCase(),L=u(a).toLowerCase();return T!==L?T<L?-1:1:D!==a?D<a?-1:1:0}e.compareFileExtensionsUnicode=w;const b=/^(.*?)(\.([^.]*))?$/;function d(D,a=!1){const T=D?b.exec(D):[];let L=[T&&T[1]||"",T&&T[3]||""];return a&&(!L[0]&&L[1]||L[0]&&L[0].charAt(0)===".")&&(L=[L[0]+"."+L[1],""]),L}function u(D){const a=D?b.exec(D):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function g(D,a,T){let L=D.compare(a,T);return L!==0?L:a.length!==T.length?a.length<T.length?-1:1:0}function t(D){const a=D.charAt(0);return a.toLocaleUpperCase()!==a}function i(D){const a=D.charAt(0);return a.toLocaleLowerCase()!==a}function s(D,a){return t(D)&&i(a)?-1:i(D)&&t(a)?1:0}function n(D,a){return i(D)&&t(a)?-1:t(D)&&i(a)?1:0}function o(D,a,T=!1){return T||(D=D&&D.toLowerCase(),a=a&&a.toLowerCase()),D===a?0:D<a?-1:1}function v(D,a,T=!1){const L=D.split(p.sep),U=a.split(p.sep),G=L.length-1,te=U.length-1;let V,N;for(let W=0;;W++){if(V=G===W,N=te===W,V&&N)return I(L[W],U[W],T);if(V)return-1;if(N)return 1;const M=o(L[W],U[W],T);if(M!==0)return M}}e.comparePaths=v;function m(D,a,T){const L=D.toLowerCase(),U=a.toLowerCase(),G=S(D,a,T);if(G)return G;const te=L.endsWith(T),V=U.endsWith(T);if(te!==V)return te?-1:1;const N=I(L,U);return N!==0?N:L.localeCompare(U)}e.compareAnything=m;function S(D,a,T){const L=D.toLowerCase(),U=a.toLowerCase(),G=L.startsWith(T),te=U.startsWith(T);if(G!==te)return G?-1:1;if(G&&te){if(L.length<U.length)return-1;if(L.length>U.length)return 1}return 0}e.compareByPrefix=S}),define(ge[96],pe([0,1,95,93,9,11,8]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const I=0,E=[I,[]];function k(V,N,W,M){if(!V||!N)return E;const q=V.length,O=N.length;if(q<O)return E;const F=V.toLowerCase();return!M&&!F.includes(W)?E:r(N,W,O,V,F,q)}e.scoreFuzzy=k;function r(V,N,W,M,q,O){const F=[],B=[];for(let we=0;we<W;we++){const Re=we*O,ke=Re-O,Me=we>0,Ge=V[we],ze=N[we];for(let je=0;je<O;je++){const j=je>0,Z=Re+je,ie=Z-1,oe=ke+je-1,J=j?F[ie]:0,le=Me&&j?F[oe]:0,me=Me&&j?B[oe]:0;let Le;!le&&Me?Le=0:Le=P(Ge,ze,M,q,je,me),Le&&le+Le>=J?(B[Z]=me+1,F[Z]=le+Le):(B[Z]=I,F[Z]=J)}}const $=[];let Y=W-1,ce=O-1;for(;Y>=0&&ce>=0;){const we=Y*O+ce;B[we]===I||($.push(ce),Y--),ce--}return[F[W*O-1],$.reverse()]}function P(V,N,W,M,q,O){let F=0;if(!l(N,M[q]))return F;if(F+=1,O>0&&(F+=O*5),V===W[q]&&(F+=1),q===0)F+=8;else{const B=f(W.charCodeAt(q-1));B?F+=B:R.isUpper(W.charCodeAt(q))&&(F+=2)}return F}function l(V,N){return V===N?!0:V==="/"||V==="\\"?N==="/"||N==="\\":!1}function f(V){switch(V){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const c=[void 0,[]];function h(V,N,W=0,M=0){const q=N;return q.values&&q.values.length>1?_(V,q.values,W,M):w(V,N,W,M)}e.scoreFuzzy2=h;function _(V,N,W,M){let q=0;const O=[];for(const F of N){const[B,$]=w(V,F,W,M);if(typeof B!="number")return c;q+=B,O.push(...$)}return[q,v(O)]}function w(V,N,W,M){const q=R.fuzzyScore(N.original,N.originalLowercase,W,V,V.toLowerCase(),M,!0);return q?[q[0],R.createMatches(q)]:c}const b=Object.freeze({score:0}),d=1<<18,u=1<<17,g=1<<16;function t(V,N,W,M,q){if(!V||!N.normalized)return b;const O=M.getItemLabel(V);if(!O)return b;const F=M.getItemDescription(V);let B;F?B=`${O}${F}${N.normalized}${Array.isArray(N.values)?N.values.length:""}${W}`:B=`${O}${N.normalized}${Array.isArray(N.values)?N.values.length:""}${W}`;const $=q[B];if($)return $;const Y=i(O,F,M.getItemPath(V),N,W);return q[B]=Y,Y}e.scoreItemFuzzy=t;function i(V,N,W,M,q){const O=!W||!M.containsPathSeparator;return W&&(y.isLinux?M.pathNormalized===W:A.equalsIgnoreCase(M.pathNormalized,W))?{score:d,labelMatch:[{start:0,end:V.length}],descriptionMatch:N?[{start:0,end:N.length}]:void 0}:M.values&&M.values.length>1?s(V,N,W,M.values,O,q):n(V,N,W,M,O,q)}function s(V,N,W,M,q,O){let F=0;const B=[],$=[];for(const Y of M){const{score:ce,labelMatch:we,descriptionMatch:Re}=n(V,N,W,Y,q,O);if(ce===I)return b;F+=ce,we&&B.push(...we),Re&&$.push(...Re)}return{score:F,labelMatch:v(B),descriptionMatch:v($)}}function n(V,N,W,M,q,O){if(q||!N){const[F,B]=k(V,M.normalized,M.normalizedLowercase,O);if(F){const $=R.matchesPrefix(M.normalized,V);let Y;return $?(Y=u,Y+=Math.round(M.normalized.length/V.length*100)):Y=g,{score:Y+F,labelMatch:$||o(B)}}}if(N){let F=N;W&&(F=`${N}${C.sep}`);const B=F.length,$=`${F}${V}`,[Y,ce]=k($,M.normalized,M.normalizedLowercase,O);if(Y){const we=o(ce),Re=[],ke=[];return we.forEach(Me=>{Me.start<B&&Me.end>B?(Re.push({start:0,end:Me.end-B}),ke.push({start:Me.start,end:B})):Me.start>=B?Re.push({start:Me.start-B,end:Me.end-B}):ke.push(Me)}),{score:Y,labelMatch:Re,descriptionMatch:ke}}}return b}function o(V){const N=[];if(!V)return N;let W;for(const M of V)W&&W.end===M?W.end+=1:(W={start:M,end:M+1},N.push(W));return N}function v(V){const N=V.sort((q,O)=>q.start-O.start),W=[];let M;for(const q of N)!M||!m(M,q)?(M=q,W.push(q)):(M.start=Math.min(M.start,q.start),M.end=Math.max(M.end,q.end));return W}function m(V,N){return!(V.end<N.start||N.end<V.start)}function S(V,N,W,M,q,O){const F=t(V,W,M,q,O),B=t(N,W,M,q,O),$=F.score,Y=B.score;if(($===d||Y===d)&&$!==Y)return $===d?-1:1;if($>g||Y>g){if($!==Y)return $>Y?-1:1;if($<u&&Y<u){const ze=a(F.labelMatch,B.labelMatch);if(ze!==0)return ze}const Me=q.getItemLabel(V)||"",Ge=q.getItemLabel(N)||"";if(Me.length!==Ge.length)return Me.length-Ge.length}if($!==Y)return $>Y?-1:1;const ce=Array.isArray(F.labelMatch)&&F.labelMatch.length>0,we=Array.isArray(B.labelMatch)&&B.labelMatch.length>0;if(ce&&!we)return-1;if(we&&!ce)return 1;const Re=D(V,F,q),ke=D(N,B,q);return Re&&ke&&Re!==ke?ke>Re?-1:1:T(V,N,W,q)}e.compareItemsByFuzzyScore=S;function D(V,N,W){let M=-1,q=-1;if(N.descriptionMatch&&N.descriptionMatch.length?M=N.descriptionMatch[0].start:N.labelMatch&&N.labelMatch.length&&(M=N.labelMatch[0].start),N.labelMatch&&N.labelMatch.length){if(q=N.labelMatch[N.labelMatch.length-1].end,N.descriptionMatch&&N.descriptionMatch.length){const O=W.getItemDescription(V);O&&(q+=O.length)}}else N.descriptionMatch&&N.descriptionMatch.length&&(q=N.descriptionMatch[N.descriptionMatch.length-1].end);return q-M}function a(V,N){if(!V&&!N||(!V||!V.length)&&(!N||!N.length))return 0;if(!N||!N.length)return-1;if(!V||!V.length)return 1;const W=V[0].start,q=V[V.length-1].end-W,O=N[0].start,B=N[N.length-1].end-O;return q===B?0:B<q?1:-1}function T(V,N,W,M){const q=M.getItemLabel(V)||"",O=M.getItemLabel(N)||"",F=M.getItemDescription(V),B=M.getItemDescription(N),$=q.length+(F?F.length:0),Y=O.length+(B?B.length:0);if($!==Y)return $-Y;const ce=M.getItemPath(V),we=M.getItemPath(N);return ce&&we&&ce.length!==we.length?ce.length-we.length:q!==O?p.compareAnything(q,O,W.normalized):F&&B&&F!==B?p.compareAnything(F,B,W.normalized):ce&&we&&ce!==we?p.compareAnything(ce,we,W.normalized):0}const L=" ";function U(V){typeof V!="string"&&(V="");const N=V.toLowerCase(),{pathNormalized:W,normalized:M,normalizedLowercase:q}=G(V),O=W.indexOf(C.sep)>=0;let F;const B=V.split(L);if(B.length>1)for(const $ of B){const{pathNormalized:Y,normalized:ce,normalizedLowercase:we}=G($);ce&&(F||(F=[]),F.push({original:$,originalLowercase:$.toLowerCase(),pathNormalized:Y,normalized:ce,normalizedLowercase:we}))}return{original:V,originalLowercase:N,pathNormalized:W,normalized:M,normalizedLowercase:q,values:F,containsPathSeparator:O}}e.prepareQuery=U;function G(V){let N;y.isWindows?N=V.replace(/\//g,C.sep):N=V.replace(/\\/g,C.sep);const W=A.stripWildcards(N).replace(/\s/g,"");return{pathNormalized:N,normalized:W,normalizedLowercase:W.toLowerCase()}}function te(V){return Array.isArray(V)?U(V.map(N=>N.original).join(L)):U(V.original)}e.pieceToQuery=te}),define(ge[30],pe([0,1,8,29,9,23,16]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I;const E="**",k="/",r="[/\\\\]",P="[^/\\\\]",l=/\//g;function f(F){switch(F){case 0:return"";case 1:return`${P}*?`;default:return`(?:${r}|${P}+${r}|${r}${P}+)*?`}}function c(F,B){if(!F)return[];const $=[];let Y=!1,ce=!1,we="";for(const Re of F){switch(Re){case B:if(!Y&&!ce){$.push(we),we="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}we+=Re}return we&&$.push(we),$}e.splitGlobAware=c;function h(F){if(!F)return"";let B="";const $=c(F,k);if($.every(Y=>Y===E))B=".*";else{let Y=!1;$.forEach((ce,we)=>{if(ce===E){Y||(B+=f(2),Y=!0);return}let Re=!1,ke="",Me=!1,Ge="";for(const ze of ce){if(ze!=="}"&&Re){ke+=ze;continue}if(Me&&(ze!=="]"||!Ge)){let je;ze==="-"?je=ze:(ze==="^"||ze==="!")&&!Ge?je="^":ze===k?je="":je=p.escapeRegExpCharacters(ze),Ge+=je;continue}switch(ze){case"{":Re=!0;continue;case"[":Me=!0;continue;case"}":B+=`(?:${c(ke,",").map(Z=>h(Z)).join("|")})`,Re=!1,ke="";break;case"]":B+="["+Ge+"]",Me=!1,Ge="";break;case"?":B+=P;continue;case"*":B+=f(1);continue;default:B+=p.escapeRegExpCharacters(ze)}}we<$.length-1&&($[we+1]!==E||we+2<$.length)&&(B+=r),Y=!1})}return B}const _=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new y.LRUCache(1e4),i=function(){return!1},s=function(){return null};function n(F,B){if(!F)return s;let $;typeof F!="string"?$=F.pattern:$=F,$=$.trim();const Y=`${$}_${!!B.trimForExclusions}`;let ce=t.get(Y);if(ce)return o(ce,F);let we;if(_.test($)){const Re=$.substr(4);ce=function(ke,Me){return typeof ke=="string"&&ke.endsWith(Re)?$:null}}else(we=w.exec(v($,B)))?ce=m(we[1],$):(B.trimForExclusions?d:b).test($)?ce=S($,B):(we=u.exec(v($,B)))?ce=D(we[1].substr(1),$,!0):(we=g.exec(v($,B)))?ce=D(we[1],$,!1):ce=a($);return t.set(Y,ce),o(ce,F)}function o(F,B){return typeof B=="string"?F:function($,Y){return R.isEqualOrParent($,B.base)?F(C.relative(B.base,$),Y):null}}function v(F,B){return B.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function m(F,B){const $=`/${F}`,Y=`\\${F}`,ce=function(Re,ke){return typeof Re!="string"?null:ke?ke===F?B:null:Re===F||Re.endsWith($)||Re.endsWith(Y)?B:null},we=[F];return ce.basenames=we,ce.patterns=[B],ce.allBasenames=we,ce}function S(F,B){const $=O(F.slice(1,-1).split(",").map(ke=>n(ke,B)).filter(ke=>ke!==s),F),Y=$.length;if(!Y)return s;if(Y===1)return $[0];const ce=function(ke,Me){for(let Ge=0,ze=$.length;Ge<ze;Ge++)if($[Ge](ke,Me))return F;return null},we=$.find(ke=>!!ke.allBasenames);we&&(ce.allBasenames=we.allBasenames);const Re=$.reduce((ke,Me)=>Me.allPaths?ke.concat(Me.allPaths):ke,[]);return Re.length&&(ce.allPaths=Re),ce}function D(F,B,$){const Y=C.sep===C.posix.sep,ce=Y?F:F.replace(l,C.sep),we=C.sep+ce,Re=C.posix.sep+F,ke=$?function(Me,Ge){return typeof Me=="string"&&(Me===ce||Me.endsWith(we)||!Y&&(Me===F||Me.endsWith(Re)))?B:null}:function(Me,Ge){return typeof Me=="string"&&(Me===ce||!Y&&Me===F)?B:null};return ke.allPaths=[($?"*/":"./")+F],ke}function a(F){try{const B=new RegExp(`^${h(F)}$`);return function($){return B.lastIndex=0,typeof $=="string"&&B.test($)?F:null}}catch(B){return s}}function T(F,B,$){return!F||typeof B!="string"?!1:L(F)(B,void 0,$)}e.match=T;function L(F,B={}){if(!F)return i;if(typeof F=="string"||V(F)){const $=n(F,B);if($===s)return i;const Y=function(ce,we){return!!$(ce,we)};return $.allBasenames&&(Y.allBasenames=$.allBasenames),$.allPaths&&(Y.allPaths=$.allPaths),Y}return M(F,B)}e.parse=L;function U(F){if(!F)return;let B;return $=>(B||(B=(F()||Promise.resolve([])).then(Y=>Y?te(Y):{})),B.then(Y=>!!Y[$]))}e.hasSiblingPromiseFn=U;function G(F){if(!F)return;let B;return $=>{if(!B){const Y=F();B=Y?te(Y):{}}return!!B[$]}}e.hasSiblingFn=G;function te(F){const B={};for(const $ of F)B[$]=!0;return B}function V(F){const B=F;return B&&typeof B.base=="string"&&typeof B.pattern=="string"}e.isRelativePattern=V;function N(F){return F.allBasenames||[]}e.getBasenameTerms=N;function W(F){return F.allPaths||[]}e.getPathTerms=W;function M(F,B){const $=O(Object.getOwnPropertyNames(F).map(ke=>q(ke,F[ke],B)).filter(ke=>ke!==s)),Y=$.length;if(!Y)return s;if(!$.some(ke=>!!ke.requiresSiblings)){if(Y===1)return $[0];const ke=function(ze,je){for(let j=0,Z=$.length;j<Z;j++){const ie=$[j](ze,je);if(ie)return ie}return null},Me=$.find(ze=>!!ze.allBasenames);Me&&(ke.allBasenames=Me.allBasenames);const Ge=$.reduce((ze,je)=>je.allPaths?ze.concat(je.allPaths):ze,[]);return Ge.length&&(ke.allPaths=Ge),ke}const ce=function(ke,Me,Ge){let ze;for(let je=0,j=$.length;je<j;je++){const Z=$[je];Z.requiresSiblings&&Ge&&(Me||(Me=C.basename(ke)),ze||(ze=Me.substr(0,Me.length-C.extname(ke).length)));const ie=Z(ke,Me,ze,Ge);if(ie)return ie}return null},we=$.find(ke=>!!ke.allBasenames);we&&(ce.allBasenames=we.allBasenames);const Re=$.reduce((ke,Me)=>Me.allPaths?ke.concat(Me.allPaths):ke,[]);return Re.length&&(ce.allPaths=Re),ce}function q(F,B,$){if(B===!1)return s;const Y=n(F,$);if(Y===s)return s;if(typeof B=="boolean")return Y;if(B){const ce=B.when;if(typeof ce=="string"){const we=(Re,ke,Me,Ge)=>{if(!Ge||!Y(Re,ke))return null;const ze=ce.replace("$(basename)",Me),je=Ge(ze);return A.isThenable(je)?je.then(j=>j?F:null):je?F:null};return we.requiresSiblings=!0,we}}return Y}function O(F,B){const $=F.filter(ke=>!!ke.basenames);if($.length<2)return F;const Y=$.reduce((ke,Me)=>{const Ge=Me.basenames;return Ge?ke.concat(Ge):ke},[]);let ce;if(B){ce=[];for(let ke=0,Me=Y.length;ke<Me;ke++)ce.push(B)}else ce=$.reduce((ke,Me)=>{const Ge=Me.patterns;return Ge?ke.concat(Ge):ke},[]);const we=function(ke,Me){if(typeof ke!="string")return null;if(!Me){let ze;for(ze=ke.length;ze>0;ze--){const je=ke.charCodeAt(ze-1);if(je===47||je===92)break}Me=ke.substr(ze)}const Ge=Y.indexOf(Me);return Ge!==-1?ce[Ge]:null};we.basenames=Y,we.patterns=ce,we.allBasenames=Y;const Re=F.filter(ke=>!ke.basenames);return Re.push(we),Re}}),define(ge[75],pe([0,1,2,9,8,10,11,24,29]),function(X,e,p,R,C,y,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(n,o,v){if(typeof n=="string"&&(n=p.URI.file(n)),v){const S=v.getWorkspaceFolder(n);if(S){const D=v.getWorkspace().folders.length>1;let a;if(I.isEqual(S.uri,n)?a="":a=I.relativePath(S.uri,n),D){const T=S.name?S.name:I.basename(S.uri);a=a?T+" \u2022 "+a:T}return a}}if(n.scheme!==y.Schemas.file&&n.scheme!==y.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if(E.hasDriveLetter(n.fsPath))return R.normalize(P(n.fsPath));let m=R.normalize(n.fsPath);return!A.isWindows&&(o==null?void 0:o.userHome)&&(m=f(m,o.userHome.fsPath)),m}e.getPathLabel=k;function r(n){if(!n)return;typeof n=="string"&&(n=p.URI.file(n));const o=I.basename(n)||(n.scheme===y.Schemas.file?n.fsPath:n.path);return A.isWindows&&E.isRootOrDriveLetter(o)?P(o):o}e.getBaseLabel=r;function P(n){return E.hasDriveLetter(n)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=P;let l=Object.create(null);function f(n,o){if(A.isWindows||!n||!o)return n;let v=l.original===o?l.normalized:void 0;return v||(v=`${C.rtrim(o,R.posix.sep)}${R.posix.sep}`,l={original:o,normalized:v}),(A.isLinux?n.startsWith(v):C.startsWithIgnoreCase(n,v))&&(n=`~/${n.substr(v.length)}`),n}e.tildify=f;function c(n,o){return n.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=c;const h="\u2026",_="\\\\",w="~";function b(n,o=R.sep){const v=new Array(n.length);let m=!1;for(let S=0;S<n.length;S++){let D=n[S];if(D===""){v[S]=`.${o}`;continue}if(!D){v[S]=D;continue}m=!0;let a="";D.indexOf(_)===0?(a=D.substr(0,D.indexOf(_)+_.length),D=D.substr(D.indexOf(_)+_.length)):D.indexOf(o)===0?(a=D.substr(0,D.indexOf(o)+o.length),D=D.substr(D.indexOf(o)+o.length)):D.indexOf(w)===0&&(a=D.substr(0,D.indexOf(w)+w.length),D=D.substr(D.indexOf(w)+w.length));const T=D.split(o);for(let L=1;m&&L<=T.length;L++)for(let U=T.length-L;m&&U>=0;U--){m=!1;let G=T.slice(U,U+L).join(o);for(let te=0;!m&&te<n.length;te++)if(te!==S&&n[te]&&n[te].indexOf(G)>-1){const V=U+L===T.length,N=U>0&&n[te].indexOf(o)>-1?o+G:G,W=n[te].endsWith(N);m=!V||W}if(!m){let te="";(T[0].endsWith(":")||a!=="")&&(U===1&&(U=0,L++,G=T[0]+o+G),U>0&&(te=T[0]+o),te=a+te),U>0&&(te=te+h+o),te=te+G,U+L<T.length&&(te=te+o+h),v[S]=te}}m&&(v[S]=D)}return v}e.shorten=b;var d;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function u(n,o=Object.create(null)){const v=[];let m=!1,S="";for(const D of n)if(D==="$"||m&&D==="{")S&&v.push({value:S,type:d.TEXT}),S="",m=!0;else if(D==="}"&&m){const a=o[S];if(typeof a=="string")a.length&&v.push({value:a,type:d.VARIABLE});else if(a){const T=v[v.length-1];(!T||T.type!==d.SEPARATOR)&&v.push({value:a.label,type:d.SEPARATOR})}S="",m=!1}else S+=D;return S&&!m&&v.push({value:S,type:d.TEXT}),v.filter((D,a)=>{if(D.type===d.SEPARATOR){const T=v[a-1],L=v[a+1];return[T,L].every(U=>U&&(U.type===d.VARIABLE||U.type===d.TEXT)&&U.value.length>0)}return!0}).map(D=>D.value).join("")}e.template=u;function g(n,o){return A.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):n.replace(/&&|&/g,v=>v==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function t(n,o){return A.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,""):A.isWindows?n.replace(/&&|&/g,v=>v==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=i;function s(n){const o=n.indexOf("/")!==-1?R.posix:R.win32,v=o.basename(n),m=o.dirname(n);return v.length?{name:v,parentPath:m}:{name:m,parentPath:""}}e.splitName=s}),define(ge[97],pe([0,1,9,8,30,10,24]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var I;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown"})(I=e.Mimes||(e.Mimes={}));let E=[],k=[],r=[];function P(i,s=!1){const n=l(i);E.push(n),n.userConfigured?r.push(n):k.push(n),s&&!n.userConfigured&&E.forEach(o=>{o.mime===n.mime||o.userConfigured||(n.extension&&o.extension===n.extension&&console.warn(`Overwriting extension <<${n.extension}>> to now point to mime <<${n.mime}>>`),n.filename&&o.filename===n.filename&&console.warn(`Overwriting filename <<${n.filename}>> to now point to mime <<${n.mime}>>`),n.filepattern&&o.filepattern===n.filepattern&&console.warn(`Overwriting filepattern <<${n.filepattern}>> to now point to mime <<${n.mime}>>`),n.firstline&&o.firstline===n.firstline&&console.warn(`Overwriting firstline <<${n.firstline}>> to now point to mime <<${n.mime}>>`))})}e.registerTextMime=P;function l(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?i.filepattern.toLowerCase():void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(p.posix.sep)>=0:!1}}function f(i){i?(E=E.filter(s=>!s.userConfigured),r=[]):(E=[],k=[],r=[])}e.clearTextMimes=f;function c(i,s){let n;if(i)switch(i.scheme){case y.Schemas.file:n=i.fsPath;break;case y.Schemas.data:n=A.DataUri.parseMetaData(i).get(A.DataUri.META_DATA_LABEL);break;default:n=i.path}if(!n)return[I.unknown];n=n.toLowerCase();const o=p.basename(n),v=h(n,o,r);if(v)return[v,I.text];const m=h(n,o,k);if(m)return[m,I.text];if(s){const S=_(s);if(S)return[S,I.text]}return[I.unknown]}e.guessMimeTypes=c;function h(i,s,n){let o=null,v=null,m=null;for(let S=n.length-1;S>=0;S--){const D=n[S];if(s===D.filenameLowercase){o=D;break}if(D.filepattern&&(!v||D.filepattern.length>v.filepattern.length)){const a=D.filepatternOnPath?i:s;C.match(D.filepatternLowercase,a)&&(v=D)}D.extension&&(!m||D.extension.length>m.extension.length)&&s.endsWith(D.extensionLowercase)&&(m=D)}return o?o.mime:v?v.mime:m?m.mime:null}function _(i){if(R.startsWithUTF8BOM(i)&&(i=i.substr(1)),i.length>0)for(let s=E.length-1;s>=0;s--){const n=E[s];if(!n.firstline)continue;const o=i.match(n.firstline);if(o&&o.length>0)return n.mime}return null}function w(i){return i?typeof i=="string"?i===I.binary||i===I.text||i===I.unknown:i.length===1&&w(i[0]):!0}e.isUnspecific=w;const b={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function d(i){const s=p.extname(i);return b[s.toLowerCase()]}e.getMediaMime=d;function u(i){for(const s in b)if(b[s]===i)return s}e.getExtensionForMimeType=u;const g=/^(.+)\/(.+?)(;.+)?$/;function t(i,s){var n;const o=g.exec(i);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${(n=o[3])!==null&&n!==void 0?n:""}`:s?void 0:i}e.normalizeMimeType=t}),define(ge[98],pe([0,1,2]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(r){return r.toJSON()}class C{constructor(P){this._uriTransformer=P}transformIncoming(P){const l=this._uriTransformer.transformIncoming(P);return l===P?P:R(p.URI.from(l))}transformOutgoing(P){const l=this._uriTransformer.transformOutgoing(P);return l===P?P:R(p.URI.from(l))}transformOutgoingURI(P){const l=this._uriTransformer.transformOutgoing(P);return l===P?P:p.URI.from(l)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(r){return r}transformOutgoing(r){return r}transformOutgoingURI(r){return r}transformOutgoingScheme(r){return r}};function y(r,P,l){if(!r||l>200)return null;if(typeof r=="object"){if(r instanceof p.URI)return P.transformOutgoing(r);for(let f in r)if(Object.hasOwnProperty.call(r,f)){const c=y(r[f],P,l+1);c!==null&&(r[f]=c)}}return null}function A(r,P){const l=y(r,P,0);return l===null?r:l}e.transformOutgoingURIs=A;function I(r,P,l,f){if(!r||f>200)return null;if(typeof r=="object"){if(r.$mid===1)return l?p.URI.revive(P.transformIncoming(r)):P.transformIncoming(r);for(let c in r)if(Object.hasOwnProperty.call(r,c)){const h=I(r[c],P,l,f+1);h!==null&&(r[c]=h)}}return null}function E(r,P){const l=I(r,P,!1,0);return l===null?r:l}e.transformIncomingURIs=E;function k(r,P){const l=I(r,P,!0,0);return l===null?r:l}e.transformAndReviveIncomingURIs=k}),define(ge[32],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(E){return p.test(E)}e.isUUID=R;const C=new Uint8Array(16),y=[];for(let E=0;E<256;E++)y.push(E.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(E){for(let k=0;k<E.length;k++)E[k]=Math.floor(Math.random()*256);return E};function I(){A(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let E=0,k="";return k+=y[C[E++]],k+=y[C[E++]],k+=y[C[E++]],k+=y[C[E++]],k+="-",k+=y[C[E++]],k+=y[C[E++]],k+="-",k+=y[C[E++]],k+=y[C[E++]],k+="-",k+=y[C[E++]],k+=y[C[E++]],k+="-",k+=y[C[E++]],k+=y[C[E++]],k+=y[C[E++]],k+=y[C[E++]],k+=y[C[E++]],k+=y[C[E++]],k}e.generateUuid=I}),define(ge[137],pe([0,1,99]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(y="utf8"){this.stringDecoder=new p.StringDecoder(y),this.remaining=null}write(y){const A=[],I=this.remaining?this.remaining+this.stringDecoder.write(y):this.stringDecoder.write(y);if(I.length<1)return A;let E=0,k,r=E;for(;r<I.length;)if(k=I.charCodeAt(r),k===13||k===10){if(A.push(I.substring(E,r)),r++,r<I.length){const P=k;k=I.charCodeAt(r),(P===13&&k===10||P===10&&k===13)&&r++}E=r}else r++;return this.remaining=E<I.length?I.substr(E):null,A}end(){return this.remaining}}e.LineDecoder=R}),define(ge[28],pe([0,1,56,100,277,9,16,11,29,32,74,24,2]),function(X,e,p,R,C,y,A,I,E,k,r,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var f;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function c(N,W=f.UNLINK){if(E.isRootOrDriveLetter(N))throw new Error("rimraf - will refuse to recursively delete root");return W===f.UNLINK?_(N):h(N)}async function h(N){try{const W=y.join(R.tmpdir(),k.generateUuid());try{await e.Promises.rename(N,W)}catch(M){return _(N)}_(W).catch(M=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function _(N){return e.Promises.rmdir(N,{recursive:!0,maxRetries:3})}function w(N){if(E.isRootOrDriveLetter(N))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(N,{recursive:!0})}e.rimrafSync=w;async function b(N,W){return g(await(W?d(N):C.promisify(p.readdir)(N)))}async function d(N){try{return await C.promisify(p.readdir)(N,{withFileTypes:!0})}catch(q){console.warn("[node.js fs] readdir with filetypes failed with error: ",q)}const W=[],M=await b(N);for(const q of M){let O=!1,F=!1,B=!1;try{const $=await e.Promises.lstat(y.join(N,q));O=$.isFile(),F=$.isDirectory(),B=$.isSymbolicLink()}catch($){console.warn("[node.js fs] unexpected error from lstat after readdir: ",$)}W.push({name:q,isFile:()=>O,isDirectory:()=>F,isSymbolicLink:()=>B})}return W}function u(N){return g(p.readdirSync(N))}e.readdirSync=u;function g(N){return N.map(W=>typeof W=="string"?I.isMacintosh?r.normalizeNFC(W):W:(W.name=I.isMacintosh?r.normalizeNFC(W.name):W.name,W))}async function t(N){const W=await b(N),M=[];for(const q of W)await s.existsDirectory(y.join(N,q))&&M.push(q);return M}function i(N,W=1e3){return new Promise(M=>{let q=!1;const O=setInterval(()=>{q||(q=!0,p.access(N,F=>{q=!1,F&&(clearInterval(O),M(void 0))}))},W)})}e.whenDeleted=i;var s;(function(N){async function W(O){let F;try{if(F=await e.Promises.lstat(O),!F.isSymbolicLink())return{stat:F}}catch(B){}try{return{stat:await e.Promises.stat(O),symbolicLink:(F==null?void 0:F.isSymbolicLink())?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(I.isWindows&&B.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(O)),symbolicLink:{dangling:!1}}}catch($){if($.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw $}throw B}}N.stat=W;async function M(O){try{const{stat:F,symbolicLink:B}=await N.stat(O);return F.isFile()&&(B==null?void 0:B.dangling)!==!0}catch(F){}return!1}N.existsFile=M;async function q(O){try{const{stat:F,symbolicLink:B}=await N.stat(O);return F.isDirectory()&&(B==null?void 0:B.dangling)!==!0}catch(F){}return!1}N.existsDirectory=q})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new A.ResourceQueue;function o(N,W,M){return n.queueFor(l.URI.file(N),P.extUriBiasedIgnorePathCase).queue(()=>{const q=D(M);return new Promise((O,F)=>m(N,W,q,B=>B?F(B):O()))})}let v=!0;function m(N,W,M,q){if(!v)return p.writeFile(N,W,{mode:M.mode,flag:M.flag},q);p.open(N,M.flag,M.mode,(O,F)=>{if(O)return q(O);p.writeFile(F,W,B=>{if(B)return p.close(F,()=>q(B));p.fdatasync(F,$=>($&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",$),v=!1),p.close(F,Y=>q(Y))))})})}function S(N,W,M){const q=D(M);if(!v)return p.writeFileSync(N,W,{mode:q.mode,flag:q.flag});const O=p.openSync(N,q.flag,q.mode);try{p.writeFileSync(O,W);try{p.fdatasyncSync(O)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),v=!1}}finally{p.closeSync(O)}}e.writeFileSync=S;function D(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function a(N,W){if(N===W)return;async function M(q){try{const O=await e.Promises.lstat(q);if(O.isDirectory()||O.isSymbolicLink())return;await e.Promises.utimes(q,O.atime,new Date)}catch(O){}}try{await e.Promises.rename(N,W),await M(W)}catch(q){if(N.toLowerCase()!==W.toLowerCase()&&q.code==="EXDEV"||N.endsWith("."))await T(N,W,{preserveSymlinks:!1}),await c(N,f.MOVE),await M(W);else throw q}}async function T(N,W,M){return U(N,W,{root:{source:N,target:W},options:M,handledSourcePaths:new Set})}const L=511;async function U(N,W,M){if(M.handledSourcePaths.has(N))return;M.handledSourcePaths.add(N);const{stat:q,symbolicLink:O}=await s.stat(N);if(O){if(M.options.preserveSymlinks)try{return await V(N,W,M)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(O.dangling)return}return q.isDirectory()?G(N,W,q.mode&L,M):te(N,W,q.mode&L)}async function G(N,W,M,q){await e.Promises.mkdir(W,{recursive:!0,mode:M});const O=await b(N);for(const F of O)await U(y.join(N,F),y.join(W,F),q)}async function te(N,W,M){await e.Promises.copyFile(N,W),await e.Promises.chmod(W,M)}async function V(N,W,M){let q=await e.Promises.readlink(N);E.isEqualOrParent(q,M.root.source,!I.isLinux)&&(q=y.join(M.root.target,q.substr(M.root.source.length+1))),await e.Promises.symlink(q,W)}e.Promises=new class{get access(){return C.promisify(p.access)}get stat(){return C.promisify(p.stat)}get lstat(){return C.promisify(p.lstat)}get utimes(){return C.promisify(p.utimes)}get read(){return C.promisify(p.read)}get readFile(){return C.promisify(p.readFile)}get write(){return C.promisify(p.write)}get appendFile(){return C.promisify(p.appendFile)}get fdatasync(){return C.promisify(p.fdatasync)}get truncate(){return C.promisify(p.truncate)}get rename(){return C.promisify(p.rename)}get copyFile(){return C.promisify(p.copyFile)}get open(){return C.promisify(p.open)}get close(){return C.promisify(p.close)}get symlink(){return C.promisify(p.symlink)}get readlink(){return C.promisify(p.readlink)}get chmod(){return C.promisify(p.chmod)}get mkdir(){return C.promisify(p.mkdir)}get unlink(){return C.promisify(p.unlink)}get rmdir(){return C.promisify(p.rmdir)}get realpath(){return C.promisify(p.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch(W){return!1}}get readdir(){return b}get readDirsInDir(){return t}get writeFile(){return o}get rm(){return c}get move(){return a}get copy(){return T}}}),define(ge[101],pe([0,1,56,8,9,28]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(r){const P=C.dirname(r);if(r===P)return r;const l=(C.basename(r)||r).toLowerCase();try{const c=y.readdirSync(P).filter(h=>h.toLowerCase()===l);if(c.length===1){const h=A(P);if(h)return C.join(h,c[0])}else if(c.length>1){const h=c.indexOf(l);if(h>=0){const _=A(P);if(_)return C.join(_,c[h])}}}catch(f){}return null}e.realcaseSync=A;async function I(r){try{return await y.Promises.realpath(r)}catch(P){const l=k(r);return await y.Promises.access(l,p.constants.R_OK),l}}e.realpath=I;function E(r){try{return p.realpathSync(r)}catch(P){const l=k(r);return p.accessSync(l,p.constants.R_OK),l}}e.realpathSync=E;function k(r){return R.rtrim(C.normalize(r),C.sep)}});var Ve=this&&this.__decorate||function(X,e,p,R){var C=arguments.length,y=C<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,p):R,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(X,e,p,R);else for(var I=X.length-1;I>=0;I--)(A=X[I])&&(y=(C<3?A(y):C>3?A(e,p,y):A(e,p))||y);return C>3&&y&&Object.defineProperty(e,p,y),y};define(ge[102],pe([0,1,3,6,16,21,14,22,18,15,55,8,51]),function(X,e,p,R,C,y,A,I,E,k,r,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var f;(function(O){O[O.Promise=100]="Promise",O[O.PromiseCancel=101]="PromiseCancel",O[O.EventListen=102]="EventListen",O[O.EventDispose=103]="EventDispose"})(f=e.RequestType||(e.RequestType={}));function c(O){switch(O){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(O){O[O.Initialize=200]="Initialize",O[O.PromiseSuccess=201]="PromiseSuccess",O[O.PromiseError=202]="PromiseError",O[O.PromiseErrorObj=203]="PromiseErrorObj",O[O.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function _(O){switch(O){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(O){O[O.Uninitialized=0]="Uninitialized",O[O.Idle=1]="Idle"})(w||(w={}));class b{constructor(F){this.buffer=F,this.pos=0}read(F){const B=this.buffer.slice(this.pos,this.pos+F);return this.pos+=B.byteLength,B}}class d{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var u;(function(O){O[O.Undefined=0]="Undefined",O[O.String=1]="String",O[O.Buffer=2]="Buffer",O[O.VSBuffer=3]="VSBuffer",O[O.Array=4]="Array",O[O.Object=5]="Object"})(u||(u={}));function g(O){const F=I.VSBuffer.alloc(4);return F.writeUInt32BE(O,0),F}function t(O){return O.read(4).readUInt32BE(0)}function i(O){const F=I.VSBuffer.alloc(1);return F.writeUInt8(O,0),F}const s={Undefined:i(u.Undefined),String:i(u.String),Buffer:i(u.Buffer),VSBuffer:i(u.VSBuffer),Array:i(u.Array),Object:i(u.Object)},n=typeof Buffer!="undefined";function o(O,F){if(typeof F=="undefined")O.write(s.Undefined);else if(typeof F=="string"){const B=I.VSBuffer.fromString(F);O.write(s.String),O.write(g(B.byteLength)),O.write(B)}else if(n&&Buffer.isBuffer(F)){const B=I.VSBuffer.wrap(F);O.write(s.Buffer),O.write(g(B.byteLength)),O.write(B)}else if(F instanceof I.VSBuffer)O.write(s.VSBuffer),O.write(g(F.byteLength)),O.write(F);else if(Array.isArray(F)){O.write(s.Array),O.write(g(F.length));for(const B of F)o(O,B)}else{const B=I.VSBuffer.fromString(JSON.stringify(F));O.write(s.Object),O.write(g(B.byteLength)),O.write(B)}}function v(O){switch(O.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return O.read(t(O)).toString();case u.Buffer:return O.read(t(O)).buffer;case u.VSBuffer:return O.read(t(O));case u.Array:{const B=t(O),$=[];for(let Y=0;Y<B;Y++)$.push(v(O));return $}case u.Object:return JSON.parse(O.read(t(O)).toString())}}class m{constructor(F,B,$=null,Y=1e3){this.protocol=F,this.ctx=B,this.logger=$,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ce=>this.onRawMessage(ce)),this.sendResponse({type:200})}registerChannel(F,B){this.channels.set(F,B),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const B=this.send([F.type]);this.logger&&this.logger.logOutgoing(B,0,1,_(F.type));return}case 201:case 202:case 204:case 203:{const B=this.send([F.type,F.id],F.data);this.logger&&this.logger.logOutgoing(B,F.id,1,_(F.type),F.data);return}}}send(F,B=void 0){const $=new d;return o($,F),o($,B),this.sendBuffer($.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(B){return 0}}onRawMessage(F){const B=new b(F),$=v(B),Y=v(B),ce=$[0];switch(ce){case 100:return this.logger&&this.logger.logIncoming(F.byteLength,$[1],1,`${c(ce)}: ${$[2]}.${$[3]}`,Y),this.onPromise({type:ce,id:$[1],channelName:$[2],name:$[3],arg:Y});case 102:return this.logger&&this.logger.logIncoming(F.byteLength,$[1],1,`${c(ce)}: ${$[2]}.${$[3]}`,Y),this.onEventListen({type:ce,id:$[1],channelName:$[2],name:$[3],arg:Y});case 101:return this.logger&&this.logger.logIncoming(F.byteLength,$[1],1,`${c(ce)}`),this.disposeActiveRequest({type:ce,id:$[1]});case 103:return this.logger&&this.logger.logIncoming(F.byteLength,$[1],1,`${c(ce)}`),this.disposeActiveRequest({type:ce,id:$[1]})}}onPromise(F){const B=this.channels.get(F.channelName);if(!B){this.collectPendingRequest(F);return}const $=new y.CancellationTokenSource;let Y;try{Y=B.call(this.ctx,F.name,F.arg,$.token)}catch(Re){Y=Promise.reject(Re)}const ce=F.id;Y.then(Re=>{this.sendResponse({id:ce,data:Re,type:201}),this.activeRequests.delete(F.id)},Re=>{Re instanceof Error?this.sendResponse({id:ce,data:{message:Re.message,name:Re.name,stack:Re.stack?Re.stack.split?Re.stack.split(`
`):Re.stack:void 0},type:202}):this.sendResponse({id:ce,data:Re,type:203}),this.activeRequests.delete(F.id)});const we=R.toDisposable(()=>$.cancel());this.activeRequests.set(F.id,we)}onEventListen(F){const B=this.channels.get(F.channelName);if(!B){this.collectPendingRequest(F);return}const $=F.id,ce=B.listen(this.ctx,F.name,F.arg)(we=>this.sendResponse({id:$,data:we,type:204}));this.activeRequests.set(F.id,ce)}disposeActiveRequest(F){const B=this.activeRequests.get(F.id);B&&(B.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let B=this.pendingRequests.get(F.channelName);B||(B=[],this.pendingRequests.set(F.channelName,B));const $=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);B.push({request:F,timeoutTimer:$})}flushPendingRequests(F){const B=this.pendingRequests.get(F);if(B){for(const $ of B)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}e.ChannelServer=m;var S;(function(O){O[O.LocalSide=0]="LocalSide",O[O.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));class D{constructor(F,B=null){this.protocol=F,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=B}getChannel(F){const B=this;return{call($,Y,ce){return B.isDisposed?Promise.reject(A.canceled()):B.requestPromise(F,$,Y,ce)},listen($,Y){return B.isDisposed?Promise.reject(A.canceled()):B.requestEvent(F,$,Y)}}}requestPromise(F,B,$,Y=y.CancellationToken.None){const ce=this.lastRequestId++,Re={id:ce,type:100,channelName:F,name:B,arg:$};if(Y.isCancellationRequested)return Promise.reject(A.canceled());let ke;return new Promise((Ge,ze)=>{if(Y.isCancellationRequested)return ze(A.canceled());const je=()=>{const oe=J=>{switch(J.type){case 201:this.handlers.delete(ce),Ge(J.data);break;case 202:this.handlers.delete(ce);const le=new Error(J.data.message);le.stack=J.data.stack,le.name=J.data.name,ze(le);break;case 203:this.handlers.delete(ce),ze(J.data);break}};this.handlers.set(ce,oe),this.sendRequest(Re)};let j=null;this.state===w.Idle?je():(j=C.createCancelablePromise(oe=>this.whenInitialized()),j.then(()=>{j=null,je()}));const Z=()=>{j?(j.cancel(),j=null):this.sendRequest({id:ce,type:101}),ze(A.canceled())},ie=Y.onCancellationRequested(Z);ke=R.combinedDisposable(R.toDisposable(Z),ie),this.activeRequests.add(ke)}).finally(()=>{this.activeRequests.delete(ke)})}requestEvent(F,B,$){const Y=this.lastRequestId++,we={id:Y,type:102,channelName:F,name:B,arg:$};let Re=null;const ke=new p.Emitter({onFirstListenerAdd:()=>{Re=C.createCancelablePromise(Ge=>this.whenInitialized()),Re.then(()=>{Re=null,this.activeRequests.add(ke),this.sendRequest(we)})},onLastListenerRemove:()=>{Re?(Re.cancel(),Re=null):(this.activeRequests.delete(ke),this.sendRequest({id:Y,type:103}))}}),Me=Ge=>ke.fire(Ge.data);return this.handlers.set(Y,Me),ke.event}sendRequest(F){switch(F.type){case 100:case 102:{const B=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger&&this.logger.logOutgoing(B,F.id,0,`${c(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const B=this.send([F.type,F.id]);this.logger&&this.logger.logOutgoing(B,F.id,0,c(F.type));return}}}send(F,B=void 0){const $=new d;return o($,F),o($,B),this.sendBuffer($.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(B){return 0}}onBuffer(F){const B=new b(F),$=v(B),Y=v(B),ce=$[0];switch(ce){case 200:return this.logger&&this.logger.logIncoming(F.byteLength,0,0,_(ce)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(F.byteLength,$[1],0,_(ce),Y),this.onResponse({type:$[0],id:$[1],data:Y})}}onResponse(F){if(F.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const B=this.handlers.get(F.id);B&&B(F)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}Ve([l.memoize],D.prototype,"onDidInitializePromise",null),e.ChannelClient=D;class a{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:B,onDidClientDisconnect:$})=>{p.Event.once(B.onMessage)(ce=>{const we=new b(ce),Re=v(we),ke=new m(B,Re),Me=new D(B);this.channels.forEach((ze,je)=>ke.registerChannel(je,ze));const Ge={channelServer:ke,channelClient:Me,ctx:Re};this._connections.add(Ge),this._onDidAddConnection.fire(Ge),$(()=>{ke.dispose(),Me.dispose(),this._connections.delete(Ge),this._onDidRemoveConnection.fire(Ge)})})})}get connections(){const F=[];return this._connections.forEach(B=>F.push(B)),F}getChannel(F,B){const $=this;return{call(Y,ce,we){let Re;if(k.isFunction(B)){let Me=E.getRandomElement($.connections.filter(B));Re=Me?Promise.resolve(Me):p.Event.toPromise(p.Event.filter($.onDidAddConnection,B))}else Re=B.routeCall($,Y,ce);const ke=Re.then(Me=>Me.channelClient.getChannel(F));return L(ke).call(Y,ce,we)},listen(Y,ce){if(k.isFunction(B))return $.getMulticastEvent(F,B,Y,ce);const we=B.routeEvent($,Y,ce).then(Re=>Re.channelClient.getChannel(F));return L(we).listen(Y,ce)}}}getMulticastEvent(F,B,$,Y){const ce=this;let we=new R.DisposableStore;const Re=new p.Emitter({onFirstListenerAdd:()=>{we=new R.DisposableStore;const ke=new p.EventMultiplexer,Me=new Map,Ge=je=>{const Z=je.channelClient.getChannel(F).listen($,Y),ie=ke.add(Z);Me.set(je,ie)},ze=je=>{const j=Me.get(je);!j||(j.dispose(),Me.delete(je))};ce.connections.filter(B).forEach(Ge),p.Event.filter(ce.onDidAddConnection,B)(Ge,void 0,we),ce.onDidRemoveConnection(ze,void 0,we),ke.event(Re.fire,Re,we),we.add(ke)},onLastListenerRemove:()=>{we.dispose()}});return Re.event}registerChannel(F,B){this.channels.set(F,B),this._connections.forEach($=>{$.channelServer.registerChannel(F,B)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=a;class T{constructor(F,B,$=null){const Y=new d;o(Y,B),F.send(Y.buffer),this.channelClient=new D(F,$),this.channelServer=new m(F,B,$)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,B){this.channelServer.registerChannel(F,B)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function L(O){return{call(F,B,$){return O.then(Y=>Y.call(F,B,$))},listen(F,B){const $=new p.Relay;return O.then(Y=>$.input=Y.listen(F,B)),$.event}}}e.getDelayedChannel=L;function U(O){let F=!1;return{call(B,$,Y){return F?O.call(B,$,Y):C.timeout(0).then(()=>F=!0).then(()=>O.call(B,$,Y))},listen(B,$){if(F)return O.listen(B,$);const Y=new p.Relay;return C.timeout(0).then(()=>F=!0).then(()=>Y.input=O.listen(B,$)),Y.event}}}e.getNextTickChannel=U;class G{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const B of F.connections)if(await Promise.resolve(this.fn(B.ctx)))return Promise.resolve(B);return await p.Event.toPromise(F.onDidAddConnection),await this.route(F)}}e.StaticRouter=G;var te;(function(O){function F(Y,ce){const we=Y,Re=ce&&ce.disableMarshalling,ke=new Map;for(const Me in we)$(Me)&&ke.set(Me,p.Event.buffer(we[Me],!0));return new class{listen(Me,Ge){const ze=ke.get(Ge);if(ze)return ze;throw new Error(`Event not found: ${Ge}`)}call(Me,Ge,ze){const je=we[Ge];if(typeof je=="function"){if(!Re&&Array.isArray(ze))for(let j=0;j<ze.length;j++)ze[j]=r.revive(ze[j]);return je.apply(we,ze)}throw new Error(`Method not found: ${Ge}`)}}}O.fromService=F;function B(Y,ce){const we=ce&&ce.disableMarshalling;return new Proxy({},{get(Re,ke){var Me;if(typeof ke=="string")return((Me=ce==null?void 0:ce.properties)===null||Me===void 0?void 0:Me.has(ke))?ce.properties.get(ke):$(ke)?Y.listen(ke):async function(...Ge){let ze;ce&&!k.isUndefinedOrNull(ce.context)?ze=[ce.context,...Ge]:ze=Ge;const je=await Y.call(ke,ze);return we?je:r.revive(je)};throw new Error(`Property not found: ${String(ke)}`)}})}O.toService=B;function $(Y){return Y[0]==="o"&&Y[1]==="n"&&P.isUpperAsciiLetter(Y.charCodeAt(2))}})(te=e.ProxyChannel||(e.ProxyChannel={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(O){if(Array.isArray(O))return O;if(O&&typeof O=="object"&&typeof O.toString=="function"){let F=O.toString();if(F!=="[object Object]")return F}return O}function W(O){return Array.isArray(O)?O.map(N):N(O)}function M(O,F,B,$,Y,ce,we){we=W(we);const Re=V[Y],ke=Re[$%Re.length];let Me=[`%c[${O}]%c[${String(F).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String($).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${ke}`];/\($/.test(ce)?(Me=Me.concat(we),Me.push(")")):Me.push(we),console.log.apply(console,Me)}e.logWithColors=M;class q{constructor(F,B){this._outgoingPrefix=F,this._incomingPrefix=B,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,B,$,Y,ce){this._totalOutgoing+=F,M(this._outgoingPrefix,this._totalOutgoing,F,B,$,Y,ce)}logIncoming(F,B,$,Y,ce){this._totalIncoming+=F,M(this._incomingPrefix,this._totalIncoming,F,B,$,Y,ce)}}e.IPCLogger=q}),define(ge[103],pe([0,1,3,102,6,22,11,37]),function(X,e,p,R,C,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var E;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let k=null;function r(){return k||(k=y.VSBuffer.alloc(0)),k}class P{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,o){if(n===0)return r();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const D=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=n),D}if(this._chunks[0].byteLength>n){const D=this._chunks[0].slice(0,n);return o&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),D}let v=y.VSBuffer.alloc(n),m=0,S=0;for(;n>0;){const D=this._chunks[S];if(D.byteLength>n){const a=D.slice(0,n);v.set(a,m),m+=n,o&&(this._chunks[S]=D.slice(n),this._totalLength-=n),n-=n}else v.set(D,m),m+=D.byteLength,o?(this._chunks.shift(),this._totalLength-=D.byteLength):S++,n-=D.byteLength}return v}}e.ChunkStream=P;var l;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(l||(l={}));var f;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class c{constructor(n,o,v,m){this.type=n,this.id=o,this.ack=v,this.data=m,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends C.Disposable{constructor(n){super();this._onMessage=this._register(new p.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5);else{const v=this._state.messageType,m=this._state.id,S=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new c(v,m,S,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class _{constructor(n){this._isDisposed=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(n){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=y.VSBuffer.alloc(13);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this._writeSoon(o,n.data)}_bufferAdd(n,o){const v=this._totalLength===0;return this._data.push(n,o),this._totalLength+=n.byteLength+o.byteLength,v}_bufferTake(){const n=y.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,o){this._bufferAdd(n,o)&&A.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class w extends C.Disposable{constructor(n){super();this._onMessage=new p.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new p.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new _(this._socket)),this._socketReader=this._register(new h(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new c(1,0,0,n))}}e.Protocol=w;class b extends R.IPCClient{constructor(n,o,v=null){super(n,o,v);this.protocol=n}static fromSocket(n,o){return new b(new w(n),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=b;class d{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new p.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,I.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=d;class u{constructor(n){this.data=n,this.next=null}}class g{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],o=0,v=this._first;for(;v;)n[o++]=v.data,v=v.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const o=new u(n);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class t{constructor(){this.lastRuns=[];const n=Date.now();for(let o=0;o<t._HISTORY_LENGTH;o++)this.lastRuns[o]=n-1e3*o;setInterval(()=>{for(let o=t._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const n=Date.now(),o=(1+t._HISTORY_LENGTH)*1e3;let v=0;for(let m=0;m<t._HISTORY_LENGTH;m++)n-this.lastRuns[m]<=o&&v++;return 1-v/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class i{constructor(n,o=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new d,this.onControlMessage=this._onControlMessage.event,this._onMessage=new d,this.onMessage=this._onMessage.event,this._onDidDispose=new d,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new d,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new d,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new g,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=n,this._socketWriter=new _(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new h(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(v=>this._receiveMessage(v))),this._socketDisposables.push(this._socket.onClose(v=>this._onSocketClose.fire(v))),o&&this._socketReader.acceptChunk(o),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=C.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new c(5,0,0,r());this._socketWriter.write(n),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const n=Date.now()-this._socketWriter.lastWriteTime;if(n>=5e3){const o=new c(4,0,0,r());this._socketWriter.write(o),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-n+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const n=Date.now()-this._socketReader.lastReadTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-n,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,o){this._isReconnecting=!0,this._socketDisposables=C.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=n,this._socketWriter=new _(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new h(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(v=>this._receiveMessage(v))),this._socketDisposables.push(this._socket.onClose(v=>this._onSocketClose.fire(v))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1;const n=this._outgoingUnackMsg.toArray();for(let o=0,v=n.length;o<v;o++)this._socketWriter.write(n[o]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(n.type===1){if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new c(6,0,0,r())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data)}else if(n.type===2)this._onControlMessage.fire(n.data);else if(n.type===5)this._onDidDispose.fire();else if(n.type===6){const o=this._outgoingUnackMsg.toArray();for(let v=0,m=o.length;v<m;v++)this._socketWriter.write(o[v]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const v=new c(1,o,this._incomingAckId,n);this._outgoingUnackMsg.push(v),this._isReconnecting||(this._socketWriter.write(v),this._recvAckCheck())}sendControl(n){const o=new c(2,0,0,n);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const n=this._outgoingUnackMsg.peek(),o=Date.now()-n.writtenTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-o,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new c(3,0,this._incomingAckId,r());this._socketWriter.write(n)}}e.PersistentProtocol=i}),define(ge[104],pe([0,1,92]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(I){let E=p.toUint8(I);this._defaultValue=E,this._asciiMap=R._createAsciiMap(E),this._map=new Map}static _createAsciiMap(I){let E=new Uint8Array(256);for(let k=0;k<256;k++)E[k]=I;return E}set(I,E){let k=p.toUint8(E);I>=0&&I<256?this._asciiMap[I]=k:this._map.set(I,k)}get(I){return I>=0&&I<256?this._asciiMap[I]:this._map.get(I)||this._defaultValue}}e.CharacterClassifier=R;var C;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(C||(C={}));class y{constructor(){this._actual=new R(0)}add(I){this._actual.set(I,1)}has(I){return this._actual.get(I)===1}}e.CharacterSet=y}),define(ge[138],pe([0,1,104]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class C extends p.CharacterClassifier{constructor(I){super(0);for(let E=0,k=I.length;E<k;E++)this.set(I.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=C;function y(A){let I={};return E=>(I.hasOwnProperty(E)||(I[E]=A(E)),I[E])}e.getMapForWordSeparators=y(A=>new C(A))}),define(ge[44],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class p{constructor(C,y){this.lineNumber=C,this.column=y}with(C=this.lineNumber,y=this.column){return C===this.lineNumber&&y===this.column?this:new p(C,y)}delta(C=0,y=0){return this.with(this.lineNumber+C,this.column+y)}equals(C){return p.equals(this,C)}static equals(C,y){return!C&&!y?!0:!!C&&!!y&&C.lineNumber===y.lineNumber&&C.column===y.column}isBefore(C){return p.isBefore(this,C)}static isBefore(C,y){return C.lineNumber<y.lineNumber?!0:y.lineNumber<C.lineNumber?!1:C.column<y.column}isBeforeOrEqual(C){return p.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,y){return C.lineNumber<y.lineNumber?!0:y.lineNumber<C.lineNumber?!1:C.column<=y.column}static compare(C,y){let A=C.lineNumber|0,I=y.lineNumber|0;if(A===I){let E=C.column|0,k=y.column|0;return E-k}return A-I}clone(){return new p(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new p(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}e.Position=p}),define(ge[40],pe([0,1,44]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(y,A,I,E){y>I||y===I&&A>E?(this.startLineNumber=I,this.startColumn=E,this.endLineNumber=y,this.endColumn=A):(this.startLineNumber=y,this.startColumn=A,this.endLineNumber=I,this.endColumn=E)}isEmpty(){return R.isEmpty(this)}static isEmpty(y){return y.startLineNumber===y.endLineNumber&&y.startColumn===y.endColumn}containsPosition(y){return R.containsPosition(this,y)}static containsPosition(y,A){return!(A.lineNumber<y.startLineNumber||A.lineNumber>y.endLineNumber||A.lineNumber===y.startLineNumber&&A.column<y.startColumn||A.lineNumber===y.endLineNumber&&A.column>y.endColumn)}containsRange(y){return R.containsRange(this,y)}static containsRange(y,A){return!(A.startLineNumber<y.startLineNumber||A.endLineNumber<y.startLineNumber||A.startLineNumber>y.endLineNumber||A.endLineNumber>y.endLineNumber||A.startLineNumber===y.startLineNumber&&A.startColumn<y.startColumn||A.endLineNumber===y.endLineNumber&&A.endColumn>y.endColumn)}strictContainsRange(y){return R.strictContainsRange(this,y)}static strictContainsRange(y,A){return!(A.startLineNumber<y.startLineNumber||A.endLineNumber<y.startLineNumber||A.startLineNumber>y.endLineNumber||A.endLineNumber>y.endLineNumber||A.startLineNumber===y.startLineNumber&&A.startColumn<=y.startColumn||A.endLineNumber===y.endLineNumber&&A.endColumn>=y.endColumn)}plusRange(y){return R.plusRange(this,y)}static plusRange(y,A){let I,E,k,r;return A.startLineNumber<y.startLineNumber?(I=A.startLineNumber,E=A.startColumn):A.startLineNumber===y.startLineNumber?(I=A.startLineNumber,E=Math.min(A.startColumn,y.startColumn)):(I=y.startLineNumber,E=y.startColumn),A.endLineNumber>y.endLineNumber?(k=A.endLineNumber,r=A.endColumn):A.endLineNumber===y.endLineNumber?(k=A.endLineNumber,r=Math.max(A.endColumn,y.endColumn)):(k=y.endLineNumber,r=y.endColumn),new R(I,E,k,r)}intersectRanges(y){return R.intersectRanges(this,y)}static intersectRanges(y,A){let I=y.startLineNumber,E=y.startColumn,k=y.endLineNumber,r=y.endColumn,P=A.startLineNumber,l=A.startColumn,f=A.endLineNumber,c=A.endColumn;return I<P?(I=P,E=l):I===P&&(E=Math.max(E,l)),k>f?(k=f,r=c):k===f&&(r=Math.min(r,c)),I>k||I===k&&E>r?null:new R(I,E,k,r)}equalsRange(y){return R.equalsRange(this,y)}static equalsRange(y,A){return!!y&&!!A&&y.startLineNumber===A.startLineNumber&&y.startColumn===A.startColumn&&y.endLineNumber===A.endLineNumber&&y.endColumn===A.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(y){return new p.Position(y.endLineNumber,y.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(y){return new p.Position(y.startLineNumber,y.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(y,A){return new R(this.startLineNumber,this.startColumn,y,A)}setStartPosition(y,A){return new R(y,A,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(y){return new R(y.startLineNumber,y.startColumn,y.startLineNumber,y.startColumn)}static fromPositions(y,A=y){return new R(y.lineNumber,y.column,A.lineNumber,A.column)}static lift(y){return y?new R(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):null}static isIRange(y){return y&&typeof y.startLineNumber=="number"&&typeof y.startColumn=="number"&&typeof y.endLineNumber=="number"&&typeof y.endColumn=="number"}static areIntersectingOrTouching(y,A){return!(y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<A.startColumn||A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<y.startColumn)}static areIntersecting(y,A){return!(y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<=A.startColumn||A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<=y.startColumn)}static compareRangesUsingStarts(y,A){if(y&&A){const k=y.startLineNumber|0,r=A.startLineNumber|0;if(k===r){const P=y.startColumn|0,l=A.startColumn|0;if(P===l){const f=y.endLineNumber|0,c=A.endLineNumber|0;if(f===c){const h=y.endColumn|0,_=A.endColumn|0;return h-_}return f-c}return P-l}return k-r}return(y?1:0)-(A?1:0)}static compareRangesUsingEnds(y,A){return y.endLineNumber===A.endLineNumber?y.endColumn===A.endColumn?y.startLineNumber===A.startLineNumber?y.startColumn-A.startColumn:y.startLineNumber-A.startLineNumber:y.endColumn-A.endColumn:y.endLineNumber-A.endLineNumber}static spansMultipleLines(y){return y.endLineNumber>y.startLineNumber}}e.Range=R}),define(ge[139],pe([0,1,44,40]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var C;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(C=e.SelectionDirection||(e.SelectionDirection={}));class y extends R.Range{constructor(I,E,k,r){super(I,E,k,r);this.selectionStartLineNumber=I,this.selectionStartColumn=E,this.positionLineNumber=k,this.positionColumn=r}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(I){return y.selectionsEqual(this,I)}static selectionsEqual(I,E){return I.selectionStartLineNumber===E.selectionStartLineNumber&&I.selectionStartColumn===E.selectionStartColumn&&I.positionLineNumber===E.positionLineNumber&&I.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(I,E){return this.getDirection()===0?new y(this.startLineNumber,this.startColumn,I,E):new y(I,E,this.startLineNumber,this.startColumn)}getPosition(){return new p.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(I,E){return this.getDirection()===0?new y(I,E,this.endLineNumber,this.endColumn):new y(this.endLineNumber,this.endColumn,I,E)}static fromPositions(I,E=I){return new y(I.lineNumber,I.column,E.lineNumber,E.column)}static liftSelection(I){return new y(I.selectionStartLineNumber,I.selectionStartColumn,I.positionLineNumber,I.positionColumn)}static selectionsArrEqual(I,E){if(I&&!E||!I&&E)return!1;if(!I&&!E)return!0;if(I.length!==E.length)return!1;for(let k=0,r=I.length;k<r;k++)if(!this.selectionsEqual(I[k],E[k]))return!1;return!0}static isISelection(I){return I&&typeof I.selectionStartLineNumber=="number"&&typeof I.selectionStartColumn=="number"&&typeof I.positionLineNumber=="number"&&typeof I.positionColumn=="number"}static createWithDirection(I,E,k,r,P){return P===0?new y(I,E,k,r):new y(k,r,I,E)}}e.Selection=y}),define(ge[105],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var p;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=4]="Right",c[c.Full=7]="Full"})(p=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(c){c[c.Inline=1]="Inline",c[c.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(c){c[c.TextDefined=0]="TextDefined",c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var y;(function(c){c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(y=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var A;(function(c){c[c.LF=0]="LF",c[c.CRLF=1]="CRLF"})(A=e.EndOfLineSequence||(e.EndOfLineSequence={}));class I{constructor(h){this.tabSize=Math.max(1,h.tabSize|0),this.indentSize=h.tabSize|0,this.insertSpaces=Boolean(h.insertSpaces),this.defaultEOL=h.defaultEOL|0,this.trimAutoWhitespace=Boolean(h.trimAutoWhitespace)}equals(h){return this.tabSize===h.tabSize&&this.indentSize===h.indentSize&&this.insertSpaces===h.insertSpaces&&this.defaultEOL===h.defaultEOL&&this.trimAutoWhitespace===h.trimAutoWhitespace}createChangeEvent(h){return{tabSize:this.tabSize!==h.tabSize,indentSize:this.indentSize!==h.indentSize,insertSpaces:this.insertSpaces!==h.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==h.trimAutoWhitespace}}}e.TextModelResolvedOptions=I;class E{constructor(h,_){this.range=h,this.matches=_}}e.FindMatch=E;var k;(function(c){c[c.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",c[c.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",c[c.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",c[c.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var r;(function(c){c[c.Left=0]="Left",c[c.Right=1]="Right"})(r=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var P;(function(c){c[c.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(P=e.ModelConstants||(e.ModelConstants={}));class l{constructor(h,_,w,b,d,u){this.identifier=h,this.range=_,this.text=w,this.forceMoveMarkers=b,this.isAutoWhitespaceEdit=d,this._isTracked=u}}e.ValidAnnotatedEditOperation=l;class f{constructor(h,_,w){this.reverseEdits=h,this.changes=_,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=f}),define(ge[140],pe([0,1,8,138,44,40,105]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const I=999;class E{constructor(d,u,g,t){this.searchString=d,this.isRegex=u,this.matchCase=g,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let d;this.isRegex?d=k(this.searchString):d=this.searchString.indexOf(`
`)>=0;let u=null;try{u=p.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:d,global:!0,unicode:!0})}catch(t){return null}if(!u)return null;let g=!this.isRegex&&!d;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new r(u,this.wordSeparators?R.getMapForWordSeparators(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=E;function k(b){if(!b||b.length===0)return!1;for(let d=0,u=b.length;d<u;d++)if(b.charCodeAt(d)===92){if(d++,d>=u)break;const t=b.charCodeAt(d);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=k;class r{constructor(d,u,g){this.regex=d,this.wordSeparators=u,this.simpleSearch=g}}e.SearchData=r;function P(b,d,u){if(!u)return new A.FindMatch(b,null);let g=[];for(let t=0,i=d.length;t<i;t++)g[t]=d[t];return new A.FindMatch(b,g)}e.createFindMatch=P;class l{constructor(d){let u=[],g=0;for(let t=0,i=d.length;t<i;t++)d.charCodeAt(t)===10&&(u[g++]=t);this._lineFeedsOffsets=u}findLineFeedCountBeforeOffset(d){const u=this._lineFeedsOffsets;let g=0,t=u.length-1;if(t===-1||d<=u[0])return 0;for(;g<t;){const i=g+((t-g)/2>>0);u[i]>=d?t=i-1:u[i+1]>=d?(g=i,t=i):g=i+1}return g+1}}class f{static findMatches(d,u,g,t,i){const s=u.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(d,g,new w(s.wordSeparators,s.regex),t,i):this._doFindMatchesLineByLine(d,g,s,t,i):[]}static _getMultilineMatchRange(d,u,g,t,i,s){let n,o=0;t?(o=t.findLineFeedCountBeforeOffset(i),n=u+i+o):n=u+i;let v;if(t){let a=t.findLineFeedCountBeforeOffset(i+s.length)-o;v=n+s.length+a}else v=n+s.length;const m=d.getPositionAt(n),S=d.getPositionAt(v);return new y.Range(m.lineNumber,m.column,S.lineNumber,S.column)}static _doFindMatchesMultiline(d,u,g,t,i){const s=d.getOffsetAt(u.getStartPosition()),n=d.getValueInRange(u,1),o=d.getEOL()===`\r
`?new l(n):null,v=[];let m=0,S;for(g.reset(0);S=g.next(n);)if(v[m++]=P(this._getMultilineMatchRange(d,s,n,o,S.index,S[0]),S,t),m>=i)return v;return v}static _doFindMatchesLineByLine(d,u,g,t,i){const s=[];let n=0;if(u.startLineNumber===u.endLineNumber){const v=d.getLineContent(u.startLineNumber).substring(u.startColumn-1,u.endColumn-1);return n=this._findMatchesInLine(g,v,u.startLineNumber,u.startColumn-1,n,s,t,i),s}const o=d.getLineContent(u.startLineNumber).substring(u.startColumn-1);n=this._findMatchesInLine(g,o,u.startLineNumber,u.startColumn-1,n,s,t,i);for(let v=u.startLineNumber+1;v<u.endLineNumber&&n<i;v++)n=this._findMatchesInLine(g,d.getLineContent(v),v,0,n,s,t,i);if(n<i){const v=d.getLineContent(u.endLineNumber).substring(0,u.endColumn-1);n=this._findMatchesInLine(g,v,u.endLineNumber,0,n,s,t,i)}return s}static _findMatchesInLine(d,u,g,t,i,s,n,o){const v=d.wordSeparators;if(!n&&d.simpleSearch){const D=d.simpleSearch,a=D.length,T=u.length;let L=-a;for(;(L=u.indexOf(D,L+a))!==-1;)if((!v||_(v,u,T,L,a))&&(s[i++]=new A.FindMatch(new y.Range(g,L+1+t,g,L+1+a+t),null),i>=o))return i;return i}const m=new w(d.wordSeparators,d.regex);let S;m.reset(0);do if(S=m.next(u),S&&(s[i++]=P(new y.Range(g,S.index+1+t,g,S.index+1+S[0].length+t),S,n),i>=o))return i;while(S);return i}static findNextMatch(d,u,g,t){const i=u.parseSearchRequest();if(!i)return null;const s=new w(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(d,g,s,t):this._doFindNextMatchLineByLine(d,g,s,t)}static _doFindNextMatchMultiline(d,u,g,t){const i=new C.Position(u.lineNumber,1),s=d.getOffsetAt(i),n=d.getLineCount(),o=d.getValueInRange(new y.Range(i.lineNumber,i.column,n,d.getLineMaxColumn(n)),1),v=d.getEOL()===`\r
`?new l(o):null;g.reset(u.column-1);let m=g.next(o);return m?P(this._getMultilineMatchRange(d,s,o,v,m.index,m[0]),m,t):u.lineNumber!==1||u.column!==1?this._doFindNextMatchMultiline(d,new C.Position(1,1),g,t):null}static _doFindNextMatchLineByLine(d,u,g,t){const i=d.getLineCount(),s=u.lineNumber,n=d.getLineContent(s),o=this._findFirstMatchInLine(g,n,s,u.column,t);if(o)return o;for(let v=1;v<=i;v++){const m=(s+v-1)%i,S=d.getLineContent(m+1),D=this._findFirstMatchInLine(g,S,m+1,1,t);if(D)return D}return null}static _findFirstMatchInLine(d,u,g,t,i){d.reset(t-1);const s=d.next(u);return s?P(new y.Range(g,s.index+1,g,s.index+1+s[0].length),s,i):null}static findPreviousMatch(d,u,g,t){const i=u.parseSearchRequest();if(!i)return null;const s=new w(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(d,g,s,t):this._doFindPreviousMatchLineByLine(d,g,s,t)}static _doFindPreviousMatchMultiline(d,u,g,t){const i=this._doFindMatchesMultiline(d,new y.Range(1,1,u.lineNumber,u.column),g,t,10*I);if(i.length>0)return i[i.length-1];const s=d.getLineCount();return u.lineNumber!==s||u.column!==d.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(d,new C.Position(s,d.getLineMaxColumn(s)),g,t):null}static _doFindPreviousMatchLineByLine(d,u,g,t){const i=d.getLineCount(),s=u.lineNumber,n=d.getLineContent(s).substring(0,u.column-1),o=this._findLastMatchInLine(g,n,s,t);if(o)return o;for(let v=1;v<=i;v++){const m=(i+s-v-1)%i,S=d.getLineContent(m+1),D=this._findLastMatchInLine(g,S,m+1,t);if(D)return D}return null}static _findLastMatchInLine(d,u,g,t){let i=null,s;for(d.reset(0);s=d.next(u);)i=P(new y.Range(g,s.index+1,g,s.index+1+s[0].length),s,t);return i}}e.TextModelSearch=f;function c(b,d,u,g,t){if(g===0)return!0;const i=d.charCodeAt(g-1);if(b.get(i)!==0||i===13||i===10)return!0;if(t>0){const s=d.charCodeAt(g);if(b.get(s)!==0)return!0}return!1}function h(b,d,u,g,t){if(g+t===u)return!0;const i=d.charCodeAt(g+t);if(b.get(i)!==0||i===13||i===10)return!0;if(t>0){const s=d.charCodeAt(g+t-1);if(b.get(s)!==0)return!0}return!1}function _(b,d,u,g,t){return c(b,d,u,g,t)&&h(b,d,u,g,t)}e.isValidMatch=_;class w{constructor(d,u){this._wordSeparators=d,this._searchRegex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(d){this._searchRegex.lastIndex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(d){const u=d.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===u||(g=this._searchRegex.exec(d),!g))return null;const t=g.index,i=g[0].length;if(t===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){p.getNextCodePoint(d,u,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=i,!this._wordSeparators||_(this._wordSeparators,d,u,t,i))return g}while(g);return null}}e.Searcher=w}),define(ge[106],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function p(I=""){let E="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)I.indexOf(k)>=0||(E+="\\"+k);return E+="\\s]+)",new RegExp(E,"g")}e.DEFAULT_WORD_REGEXP=p();function R(I){let E=e.DEFAULT_WORD_REGEXP;if(I&&I instanceof RegExp)if(I.global)E=I;else{let k="g";I.ignoreCase&&(k+="i"),I.multiline&&(k+="m"),I.unicode&&(k+="u"),E=new RegExp(I.source,k)}return E.lastIndex=0,E}e.ensureValidWordDefinition=R;const C={maxLen:1e3,windowSize:15,timeBudget:150};function y(I,E,k,r,P=C){if(k.length>P.maxLen){let _=I-P.maxLen/2;return _<0?_=0:r+=_,k=k.substring(_,I+P.maxLen/2),y(I,E,k,r,P)}const l=Date.now(),f=I-1-r;let c=-1,h=null;for(let _=1;!(Date.now()-l>=P.timeBudget);_++){const w=f-P.windowSize*_;E.lastIndex=Math.max(0,w);const b=A(E,k,f,c);if(!b&&h||(h=b,w<=0))break;c=w}if(h){let _={word:h[0],startColumn:r+1+h.index,endColumn:r+1+h.index+h[0].length};return E.lastIndex=0,_}return null}e.getWordAtText=y;function A(I,E,k,r){let P;for(;P=I.exec(E);){const l=P.index||0;if(l<=k&&I.lastIndex>=k)return P;if(r>0&&l>r)return null}return null}}),define(ge[141],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var p;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(p=e.IndentAction||(e.IndentAction={}));class R{constructor(I){if(this.open=I.open,this.close=I.close,this._standardTokenMask=0,Array.isArray(I.notIn))for(let E=0,k=I.notIn.length;E<k;E++)switch(I.notIn[E]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(I){return(this._standardTokenMask&I)==0}}e.StandardAutoClosingPairConditional=R;class C{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of I)y(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),y(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),y(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),y(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&y(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=C;function y(A,I,E){A.has(I)?A.get(I).push(E):A.set(I,[E])}}),define(ge[76],pe([0,1,30,9]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(y,A,I,E){if(Array.isArray(y)){let k=0;for(const r of y){const P=C(r,A,I,E);if(P===10)return P;P>k&&(k=P)}return k}else{if(typeof y=="string")return E?y==="*"?5:y===I?10:0:0;if(y){const{language:k,pattern:r,scheme:P,hasAccessToAllModels:l}=y;if(!E&&!l)return 0;let f=0;if(P)if(P===A.scheme)f=10;else if(P==="*")f=5;else return 0;if(k)if(k===I)f=10;else if(k==="*")f=Math.max(f,5);else return 0;if(r){let c;if(typeof r=="string"?c=r:c=Object.assign(Object.assign({},r),{base:R.normalize(r.base)}),c===A.fsPath||p.match(c,A.fsPath))f=10;else return 0}return f}else return 0}}e.score=C}),define(ge[142],pe([0,1,104]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class C{constructor(c,h,_){const w=new Uint8Array(c*h);for(let b=0,d=c*h;b<d;b++)w[b]=_;this._data=w,this.rows=c,this.cols=h}get(c,h){return this._data[c*this.cols+h]}set(c,h,_){this._data[c*this.cols+h]=_}}e.Uint8Matrix=C;class y{constructor(c){let h=0,_=0;for(let b=0,d=c.length;b<d;b++){let[u,g,t]=c[b];g>h&&(h=g),u>_&&(_=u),t>_&&(_=t)}h++,_++;let w=new C(_,h,0);for(let b=0,d=c.length;b<d;b++){let[u,g,t]=c[b];w.set(u,g,t)}this._states=w,this._maxCharCode=h}nextState(c,h){return h<0||h>=this._maxCharCode?0:this._states.get(c,h)}}e.StateMachine=y;let A=null;function I(){return A===null&&(A=new y([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var E;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let k=null;function r(){if(k===null){k=new p.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<f.length;h++)k.set(f.charCodeAt(h),1);const c=".,;";for(let h=0;h<c.length;h++)k.set(c.charCodeAt(h),2)}return k}class P{static _createLink(c,h,_,w,b){let d=b-1;do{const u=h.charCodeAt(d);if(c.get(u)!==2)break;d--}while(d>w);if(w>0){const u=h.charCodeAt(w-1),g=h.charCodeAt(d);(u===40&&g===41||u===91&&g===93||u===123&&g===125)&&d--}return{range:{startLineNumber:_,startColumn:w+1,endLineNumber:_,endColumn:d+2},url:h.substring(w,d+1)}}static computeLinks(c,h=I()){const _=r();let w=[];for(let b=1,d=c.getLineCount();b<=d;b++){const u=c.getLineContent(b),g=u.length;let t=0,i=0,s=0,n=1,o=!1,v=!1,m=!1,S=!1;for(;t<g;){let D=!1;const a=u.charCodeAt(t);if(n===13){let T;switch(a){case 40:o=!0,T=0;break;case 41:T=o?0:1;break;case 91:m=!0,v=!0,T=0;break;case 93:m=!1,T=v?0:1;break;case 123:S=!0,T=0;break;case 125:T=S?0:1;break;case 39:T=s===34||s===96?0:1;break;case 34:T=s===39||s===96?0:1;break;case 96:T=s===39||s===34?0:1;break;case 42:T=s===42?1:0;break;case 124:T=s===124?1:0;break;case 32:T=m?0:1;break;default:T=_.get(a)}T===1&&(w.push(P._createLink(_,u,b,i,t)),D=!0)}else if(n===12){let T;a===91?(v=!0,T=0):T=_.get(a),T===1?D=!0:n=13}else n=h.nextState(n,a),n===0&&(D=!0);D&&(n=1,o=!1,v=!1,S=!1,i=t+1,s=a),t++}n===13&&w.push(P._createLink(_,u,b,i,g))}return w}}e.LinkComputer=P;function l(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:P.computeLinks(f)}e.computeLinks=l}),define(ge[143],pe([0,1,3,6]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class C{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new p.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(A){this._onDidChange.fire({changedLanguages:A,changedColorMap:!1})}register(A,I){return this._map.set(A,I),this.fire([A]),R.toDisposable(()=>{this._map.get(A)===I&&(this._map.delete(A),this.fire([A]))})}registerPromise(A,I){let E=null,k=!1;return this._promises.set(A,I.then(r=>{this._promises.delete(A),!(k||!r)&&(E=this.register(A,r))})),R.toDisposable(()=>{k=!0,E&&E.dispose()})}getPromise(A){const I=this.get(A);if(I)return Promise.resolve(I);const E=this._promises.get(A);return E?E.then(k=>this.get(A)):null}get(A){return this._map.get(A)||null}setColorMap(A){this._colorMap=A,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=C}),define(ge[107],pe([0,1,22,11]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(C||(C={}));function y(P){for(let l=0,f=P.length;l<f;l+=4){const c=P[l+0],h=P[l+1],_=P[l+2],w=P[l+3];P[l+0]=w,P[l+1]=_,P[l+2]=h,P[l+3]=c}}function A(P){const l=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return R.isLittleEndian()||y(l),p.VSBuffer.wrap(l)}function I(P){const l=P.buffer;if(R.isLittleEndian()||y(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const f=new Uint8Array(l.byteLength);return f.set(l),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function E(P){const l=new Uint32Array(k(P));let f=0;if(l[f++]=P.id,P.type==="full")l[f++]=1,l[f++]=P.data.length,l.set(P.data,f),f+=P.data.length;else{l[f++]=2,l[f++]=P.deltas.length;for(const c of P.deltas)l[f++]=c.start,l[f++]=c.deleteCount,c.data?(l[f++]=c.data.length,l.set(c.data,f),f+=c.data.length):l[f++]=0}return A(l)}e.encodeSemanticTokensDto=E;function k(P){let l=0;if(l+=1+1,P.type==="full")l+=1+P.data.length;else{l+=1,l+=(1+1+1)*P.deltas.length;for(const f of P.deltas)f.data&&(l+=f.data.length)}return l}function r(P){const l=I(P);let f=0;const c=l[f++];if(l[f++]===1){const b=l[f++],d=l.subarray(f,f+b);return f+=b,{id:c,type:"full",data:d}}const _=l[f++];let w=[];for(let b=0;b<_;b++){const d=l[f++],u=l[f++],g=l[f++];let t;g>0&&(t=l.subarray(f,f+g),f+=g),w[b]={start:d,deleteCount:u,data:t}}return{id:c,type:"delta",deltas:w}}e.decodeSemanticTokensDto=r}),define(ge[108],pe([0,1,92]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(A,I){this.index=A,this.remainder=I}}e.PrefixSumIndexOfResult=R;class C{constructor(A){this.values=A,this.prefixSum=new Uint32Array(A.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(A,I){A=p.toUint32(A);const E=this.values,k=this.prefixSum,r=I.length;return r===0?!1:(this.values=new Uint32Array(E.length+r),this.values.set(E.subarray(0,A),0),this.values.set(E.subarray(A),A+r),this.values.set(I,A),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(A,I){return A=p.toUint32(A),I=p.toUint32(I),this.values[A]===I?!1:(this.values[A]=I,A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),!0)}removeValues(A,I){A=p.toUint32(A),I=p.toUint32(I);const E=this.values,k=this.prefixSum;if(A>=E.length)return!1;let r=E.length-A;return I>=r&&(I=r),I===0?!1:(this.values=new Uint32Array(E.length-I),this.values.set(E.subarray(0,A),0),this.values.set(E.subarray(A+I),A),this.prefixSum=new Uint32Array(this.values.length),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(A){return A<0?0:(A=p.toUint32(A),this._getPrefixSum(A))}_getPrefixSum(A){if(A<=this.prefixSumValidIndex[0])return this.prefixSum[A];let I=this.prefixSumValidIndex[0]+1;I===0&&(this.prefixSum[0]=this.values[0],I++),A>=this.values.length&&(A=this.values.length-1);for(let E=I;E<=A;E++)this.prefixSum[E]=this.prefixSum[E-1]+this.values[E];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],A),this.prefixSum[A]}getIndexOf(A){A=Math.floor(A),this.getTotalSum();let I=0,E=this.values.length-1,k=0,r=0,P=0;for(;I<=E;)if(k=I+(E-I)/2|0,r=this.prefixSum[k],P=r-this.values[k],A<P)E=k-1;else if(A>=r)I=k+1;else break;return new R(k,A-P)}}e.PrefixSumComputer=C}),define(ge[144],pe([0,1,8,44,108]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class y{constructor(I,E,k,r){this._uri=I,this._lines=E,this._eol=k,this._versionId=r,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(I){I.eol&&I.eol!==this._eol&&(this._eol=I.eol,this._lineStarts=null);const E=I.changes;for(const k of E)this._acceptDeleteRange(k.range),this._acceptInsertText(new R.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=I.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const I=this._eol.length,E=this._lines.length,k=new Uint32Array(E);for(let r=0;r<E;r++)k[r]=this._lines[r].length+I;this._lineStarts=new C.PrefixSumComputer(k)}}_setLineText(I,E){this._lines[I]=E,this._lineStarts&&this._lineStarts.changeValue(I,this._lines[I].length+this._eol.length)}_acceptDeleteRange(I){if(I.startLineNumber===I.endLineNumber){if(I.startColumn===I.endColumn)return;this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.startLineNumber-1].substring(I.endColumn-1));return}this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.endLineNumber-1].substring(I.endColumn-1)),this._lines.splice(I.startLineNumber,I.endLineNumber-I.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(I.startLineNumber,I.endLineNumber-I.startLineNumber)}_acceptInsertText(I,E){if(E.length===0)return;let k=p.splitLines(E);if(k.length===1){this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+k[0]+this._lines[I.lineNumber-1].substring(I.column-1));return}k[k.length-1]+=this._lines[I.lineNumber-1].substring(I.column-1),this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+k[0]);let r=new Uint32Array(k.length-1);for(let P=1;P<k.length;P++)this._lines.splice(I.lineNumber+P-1,0,k[P]),r[P-1]=k[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(I.lineNumber,r)}}e.MirrorTextModel=y}),define(ge[145],pe([19,20]),function(X,e){return X.create("vs/base/common/date",e)}),define(ge[146],pe([0,1,145]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,C=R*60,y=C*24,A=y*7,I=y*30,E=y*365;function k(P,l){typeof P!="number"&&(P=P.getTime());const f=Math.round((new Date().getTime()-P)/1e3);if(f<-30)return p.localize(0,null,k(new Date().getTime()+f*1e3,!1));if(f<30)return p.localize(1,null);let c;return f<R?(c=f,l?c===1?p.localize(2,null,c):p.localize(3,null,c):c===1?p.localize(4,null,c):p.localize(5,null,c)):f<C?(c=Math.floor(f/R),l?c===1?p.localize(6,null,c):p.localize(7,null,c):c===1?p.localize(8,null,c):p.localize(9,null,c)):f<y?(c=Math.floor(f/C),l?c===1?p.localize(10,null,c):p.localize(11,null,c):c===1?p.localize(12,null,c):p.localize(13,null,c)):f<A?(c=Math.floor(f/y),l?c===1?p.localize(14,null,c):p.localize(15,null,c):c===1?p.localize(16,null,c):p.localize(17,null,c)):f<I?(c=Math.floor(f/A),l?c===1?p.localize(18,null,c):p.localize(19,null,c):c===1?p.localize(20,null,c):p.localize(21,null,c)):f<E?(c=Math.floor(f/I),l?c===1?p.localize(22,null,c):p.localize(23,null,c):c===1?p.localize(24,null,c):p.localize(25,null,c)):(c=Math.floor(f/E),l?c===1?p.localize(26,null,c):p.localize(27,null,c):c===1?p.localize(28,null,c):p.localize(29,null,c))}e.fromNow=k;function r(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=r}),define(ge[147],pe([19,20]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(ge[57],pe([0,1,147,15,18]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function y(k,r){return r&&(k.stack||k.stacktrace)?p.localize(0,null,I(k),A(k.stack)||A(k.stacktrace)):I(k)}function A(k){return Array.isArray(k)?k.join(`
`):k}function I(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?p.localize(1,null,k.message):k.message||p.localize(2,null)}function E(k=null,r=!1){if(!k)return p.localize(3,null);if(Array.isArray(k)){const P=C.coalesce(k),l=E(P[0],r);return P.length>1?p.localize(4,null,l,P.length):l}if(R.isString(k))return k;if(k.detail){const P=k.detail;if(P.error)return y(P.error,r);if(P.exception)return y(P.exception,r)}return k.stack?y(k,r):k.message?k.message:p.localize(5,null)}e.toErrorMessage=E}),define(ge[148],pe([19,20]),function(X,e){return X.create("vs/base/node/processes",e)}),define(ge[109],pe([0,1,9,28,38,148,37,15,25,29,11,137,10]),function(X,e,p,R,C,y,A,I,E,k,r,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function f(u){switch(u){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(u,g){if(r.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};g&&(t.cwd=g);const i=C.execFile("taskkill",["/T","/F","/PID",u.pid.toString()],t);return new Promise(s=>{i.once("error",n=>{s({success:!1,error:n})}),i.once("exit",(n,o)=>{s(n===0?{success:!0}:{success:!1,code:n!==null?n:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?f(t.status):1})}else if(r.isLinux||r.isMacintosh)try{const t=l.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",X).fsPath;return new Promise(i=>{C.execFile(t,[u.pid.toString()],{encoding:"utf8",shell:!0},(s,n,o)=>{i(s?{success:!1,error:s}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else u.kill("SIGKILL");return Promise.resolve({success:!0})}function h(u=A.env){return u.comspec||"cmd.exe"}e.getWindowsShell=h;class _{constructor(g,t,i,s){if(t!==void 0&&i!==void 0&&s!==void 0)this.cmd=g,this.args=t,this.shell=i,this.options=s;else{const n=g;this.cmd=n.command,this.shell=n.isShellCommand,this.args=n.args.slice(0),this.options=n.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const n=Object.create(null);Object.keys(A.env).forEach(o=>{n[o]=A.env[o]}),Object.keys(this.options.env).forEach(o=>{n[o]=this.options.env[o]}),this.options.env=n}}getSanitizedCommand(){let g=this.cmd.toLowerCase();const t=g.lastIndexOf(p.sep);return t!==-1&&(g=g.substring(t+1)),_.WellKnowCommands[g]?g:"other"}start(g){return r.isWindows&&(this.options&&this.options.cwd&&k.isUNC(this.options.cwd)||!this.options&&k.isUNC(A.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(t=>{let i,s;const n=new Promise((o,v)=>{i=o,s=v});if(t){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=C.exec(o,this.options,(v,m,S)=>{this.childProcess=null;const D=v;D&&D.killed?s({killed:this.terminateRequested,stdout:m.toString(),stderr:S.toString()}):this.handleExec(i,g,v,m,S)})}else{let o=null;const v=m=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(m,i,g,s);const S={terminated:this.terminateRequested};I.isNumber(m)&&(S.cmdCode=m),i(S)};if(this.shell&&r.isWindows){const m=E.deepClone(this.options);m.windowsVerbatimArguments=!0,m.detached=!1;let S=!1,D=!1;const a=[];let T=this.ensureQuotes(this.cmd);a.push(T.value),S=T.quoted,this.args&&this.args.forEach(U=>{T=this.ensureQuotes(U),a.push(T.value),D=D&&T.quoted});const L=["/s","/c"];S?D?L.push('"'+a.join(" ")+'"'):a.length>1?L.push('"'+a[0]+'" '+a.slice(1).join(" ")):L.push('"'+a[0]+'"'):L.push(a.join(" ")),o=C.spawn(h(),L,m)}else this.cmd&&(o=C.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(I.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",m=>{this.childProcess=null,s({terminated:this.terminateRequested,error:m})}),o.pid&&(this.childProcess.on("close",v),this.handleSpawn(o,i,g,s,!0)))}return n})}handleClose(g,t,i,s){}ensureQuotes(g){return _.regexp.test(g)?{value:'"'+g+'"',quoted:!0}:{value:g,quoted:g.length>0&&g[0]==='"'&&g[g.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(g=>g.pid,g=>-1):new Promise(g=>{this.pidResolve=g})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(g=>(this.terminateRequested=!0,c(g,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),g=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(g=>{if(!this.shell||!r.isWindows)return g(!1);const t=C.spawn(h(),["/s","/c"]);t.on("error",i=>g(!0)),t.on("exit",i=>g(!1))})}}e.AbstractProcess=_,_.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},_.regexp=/^[^"].* .*[^"]/;class w extends _{constructor(g,t,i,s){super(g,t,i,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(g,t,i,s,n){[s,n].forEach((o,v)=>{const m=new P.LineDecoder;m.write(o).forEach(a=>{t({line:a,source:v===0?0:1})});const D=m.end();D&&t({line:D,source:v===0?0:1})}),g({terminated:this.terminateRequested,error:i})}handleSpawn(g,t,i,s,n){const o=new P.LineDecoder,v=new P.LineDecoder;g.stdout.on("data",m=>{o.write(m).forEach(D=>i({line:D,source:0}))}),g.stderr.on("data",m=>{v.write(m).forEach(D=>i({line:D,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=v}handleClose(g,t,i,s){const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&i({line:n,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&i({line:o,source:1})}}e.LineProcess=w;function b(u){let g=[],t=!1;const i=function(s){if(t){g.push(s);return}(!u.send(s,o=>{if(o&&console.error(o),t=!1,g.length>0){const v=g.slice(0);g=[],v.forEach(m=>i(m))}})||r.isWindows)&&(t=!0)};return{send:i}}e.createQueuedSender=b;var d;(function(u){async function g(t,i,s){if(p.isAbsolute(t))return t;if(i===void 0&&(i=A.cwd()),p.dirname(t)!=="."||(s===void 0&&I.isString(A.env.PATH)&&(s=A.env.PATH.split(p.delimiter)),s===void 0||s.length===0))return p.join(i,t);async function o(v){return await R.Promises.exists(v)?!(await R.Promises.stat(v)).isDirectory():!1}for(let v of s){let m;if(p.isAbsolute(v)?m=p.join(v,t):m=p.join(i,v,t),await o(m))return m;let S=m+".com";if(await o(S)||(S=m+".exe",await o(S)))return S}return p.join(i,t)}u.findExecutable=g})(d=e.win32||(e.win32={}))}),define(ge[149],pe([19,20]),function(X,e){return X.create("vs/editor/common/config/editorOptions",e)}),define(ge[150],pe([0,1,149,11,106]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(K){K[K.None=0]="None",K[K.Keep=1]="Keep",K[K.Brackets=2]="Brackets",K[K.Advanced=3]="Advanced",K[K.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class A{constructor(re){this._values=re}hasChanged(re){return this._values[re]}}e.ConfigurationChangedEvent=A;class I{constructor(){this._values=[]}_read(re){return this._values[re]}get(re){return this._values[re]}_write(re,ve){this._values[re]=ve}}e.ValidatedEditorOptions=I;class E{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=E;class k{constructor(re,ve,Fe,Oe){this.id=re,this.name=ve,this.defaultValue=Fe,this.schema=Oe}compute(re,ve,Fe){return Fe}}class r{constructor(re,ve=null){this.schema=void 0,this.id=re,this.name="_never_",this.defaultValue=void 0,this.deps=ve}validate(re){return this.defaultValue}}class P{constructor(re,ve,Fe,Oe){this.id=re,this.name=ve,this.defaultValue=Fe,this.schema=Oe}validate(re){return typeof re=="undefined"?this.defaultValue:re}compute(re,ve,Fe){return Fe}}function l(K,re){return typeof K=="undefined"?re:K==="false"?!1:Boolean(K)}e.boolean=l;class f extends P{constructor(re,ve,Fe,Oe=void 0){typeof Oe!="undefined"&&(Oe.type="boolean",Oe.default=Fe),super(re,ve,Fe,Oe)}validate(re){return l(re,this.defaultValue)}}class c extends P{constructor(re,ve,Fe,Oe,Xe,De=void 0){typeof De!="undefined"&&(De.type="integer",De.default=Fe,De.minimum=Oe,De.maximum=Xe),super(re,ve,Fe,De),this.minimum=Oe,this.maximum=Xe}static clampedInt(re,ve,Fe,Oe){if(typeof re=="undefined")return ve;let Xe=parseInt(re,10);return isNaN(Xe)?ve:(Xe=Math.max(Fe,Xe),Xe=Math.min(Oe,Xe),Xe|0)}validate(re){return c.clampedInt(re,this.defaultValue,this.minimum,this.maximum)}}class h extends P{constructor(re,ve,Fe,Oe,Xe){typeof Xe!="undefined"&&(Xe.type="number",Xe.default=Fe),super(re,ve,Fe,Xe),this.validationFn=Oe}static clamp(re,ve,Fe){return re<ve?ve:re>Fe?Fe:re}static float(re,ve){if(typeof re=="number")return re;if(typeof re=="undefined")return ve;const Fe=parseFloat(re);return isNaN(Fe)?ve:Fe}validate(re){return this.validationFn(h.float(re,this.defaultValue))}}class _ extends P{static string(re,ve){return typeof re!="string"?ve:re}constructor(re,ve,Fe,Oe=void 0){typeof Oe!="undefined"&&(Oe.type="string",Oe.default=Fe),super(re,ve,Fe,Oe)}validate(re){return _.string(re,this.defaultValue)}}function w(K,re,ve){return typeof K!="string"||ve.indexOf(K)===-1?re:K}e.stringSet=w;class b extends P{constructor(re,ve,Fe,Oe,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="string",Xe.enum=Oe,Xe.default=Fe),super(re,ve,Fe,Xe),this._allowedValues=Oe}validate(re){return w(re,this.defaultValue,this._allowedValues)}}class d extends k{constructor(re,ve,Fe,Oe,Xe,De,_e=void 0){typeof _e!="undefined"&&(_e.type="string",_e.enum=Xe,_e.default=Oe),super(re,ve,Fe,_e),this._allowedValues=Xe,this._convert=De}validate(re){return typeof re!="string"?this.defaultValue:this._allowedValues.indexOf(re)===-1?this.defaultValue:this._convert(re)}}function u(K){switch(K){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class g extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",description:p.localize(3,null)})}validate(re){switch(re){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(re,ve,Fe){return Fe===0?re.accessibilitySupport:Fe}}class t extends k{constructor(){const re={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",re,{"editor.comments.insertSpace":{type:"boolean",default:re.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:re.ignoreEmptyLines,description:p.localize(5,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{insertSpace:l(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(K){K[K.Hidden=0]="Hidden",K[K.Blink=1]="Blink",K[K.Smooth=2]="Smooth",K[K.Phase=3]="Phase",K[K.Expand=4]="Expand",K[K.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(K){switch(K){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var n;(function(K){K[K.Line=1]="Line",K[K.Block=2]="Block",K[K.Underline=3]="Underline",K[K.LineThin=4]="LineThin",K[K.BlockOutline=5]="BlockOutline",K[K.UnderlineThin=6]="UnderlineThin"})(n=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function o(K){switch(K){case n.Line:return"line";case n.Block:return"block";case n.Underline:return"underline";case n.LineThin:return"line-thin";case n.BlockOutline:return"block-outline";case n.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=o;function v(K){switch(K){case"line":return n.Line;case"block":return n.Block;case"underline":return n.Underline;case"line-thin":return n.LineThin;case"block-outline":return n.BlockOutline;case"underline-thin":return n.UnderlineThin}}class m extends r{constructor(){super(125,[63,31])}compute(re,ve,Fe){const Oe=["monaco-editor"];return ve.get(31)&&Oe.push(ve.get(31)),re.extraEditorClassName&&Oe.push(re.extraEditorClassName),ve.get(63)==="default"?Oe.push("mouse-default"):ve.get(63)==="copy"&&Oe.push("mouse-copy"),ve.get(98)&&Oe.push("showUnused"),ve.get(123)&&Oe.push("showDeprecated"),Oe.join(" ")}}class S extends f{constructor(){super(30,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(re,ve,Fe){return Fe&&re.emptySelectionClipboard}}class D extends k{constructor(){const re={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",re,{"editor.find.cursorMoveOnType":{type:"boolean",default:re.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:re.seedSearchStringFromSelection,description:p.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:re.autoFindInSelection,enumDescriptions:[p.localize(9,null),p.localize(10,null),p.localize(11,null)],description:p.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:re.globalFindClipboard,description:p.localize(13,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:re.addExtraSpaceOnTop,description:p.localize(14,null)},"editor.find.loop":{type:"boolean",default:re.loop,description:p.localize(15,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{cursorMoveOnType:l(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:l(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof re.autoFindInSelection=="boolean"?re.autoFindInSelection?"always":"never":w(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(ve.loop,this.defaultValue.loop)}}}class a extends k{constructor(){super(41,"fontLigatures",a.OFF,{anyOf:[{type:"boolean",description:p.localize(16,null)},{type:"string",description:p.localize(17,null)}],description:p.localize(18,null),default:!1})}validate(re){return typeof re=="undefined"?this.defaultValue:typeof re=="string"?re==="false"?a.OFF:re==="true"?a.ON:re:Boolean(re)?a.ON:a.OFF}}e.EditorFontLigatures=a,a.OFF='"liga" off, "calt" off',a.ON='"liga" on, "calt" on';class T extends r{constructor(){super(40)}compute(re,ve,Fe){return re.fontInfo}}class L extends P{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(19,null)})}validate(re){let ve=h.float(re,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(ve,6,100)}compute(re,ve,Fe){return re.fontInfo.fontSize}}class U extends k{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:U.MINIMUM_VALUE,maximum:U.MAXIMUM_VALUE,errorMessage:p.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:U.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(21,null)})}validate(re){return re==="normal"||re==="bold"?re:String(c.clampedInt(re,e.EDITOR_FONT_DEFAULTS.fontWeight,U.MINIMUM_VALUE,U.MAXIMUM_VALUE))}}U.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],U.MINIMUM_VALUE=1,U.MAXIMUM_VALUE=1e3;class G extends k{constructor(){const re={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:re.multiple,enumDescriptions:[p.localize(22,null),p.localize(23,null),p.localize(24,null)]},Fe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",re,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:p.localize(26,null)},ve),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:p.localize(27,null)},ve),"editor.gotoLocation.multipleDeclarations":Object.assign({description:p.localize(28,null)},ve),"editor.gotoLocation.multipleImplementations":Object.assign({description:p.localize(29,null)},ve),"editor.gotoLocation.multipleReferences":Object.assign({description:p.localize(30,null)},ve),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:re.alternativeDefinitionCommand,enum:Fe,description:p.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:re.alternativeTypeDefinitionCommand,enum:Fe,description:p.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:re.alternativeDeclarationCommand,enum:Fe,description:p.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:re.alternativeImplementationCommand,enum:Fe,description:p.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:re.alternativeReferenceCommand,enum:Fe,description:p.localize(35,null)}})}validate(re){var ve,Fe,Oe,Xe,De;if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{multiple:w(_e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ve=_e.multipleDefinitions)!==null&&ve!==void 0?ve:w(_e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Fe=_e.multipleTypeDefinitions)!==null&&Fe!==void 0?Fe:w(_e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Oe=_e.multipleDeclarations)!==null&&Oe!==void 0?Oe:w(_e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Xe=_e.multipleImplementations)!==null&&Xe!==void 0?Xe:w(_e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(De=_e.multipleReferences)!==null&&De!==void 0?De:w(_e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:_.string(_e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:_.string(_e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:_.string(_e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:_.string(_e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:_.string(_e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class te extends k{constructor(){const re={enabled:!0,delay:300,sticky:!0};super(50,"hover",re,{"editor.hover.enabled":{type:"boolean",default:re.enabled,description:p.localize(36,null)},"editor.hover.delay":{type:"number",default:re.delay,description:p.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:re.sticky,description:p.localize(38,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{enabled:l(ve.enabled,this.defaultValue.enabled),delay:c.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:l(ve.sticky,this.defaultValue.sticky)}}}var V;(function(K){K[K.None=0]="None",K[K.Text=1]="Text",K[K.Blocks=2]="Blocks"})(V=e.RenderMinimap||(e.RenderMinimap={}));class N extends r{constructor(){super(128,[46,55,35,62,90,57,58,92,115,118,119,120,2])}compute(re,ve,Fe){return N.computeLayout(ve,{memory:re.memory,outerWidth:re.outerWidth,outerHeight:re.outerHeight,isDominatedByLongLines:re.isDominatedByLongLines,lineHeight:re.fontInfo.lineHeight,viewLineCount:re.viewLineCount,lineNumbersDigitCount:re.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:re.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:re.fontInfo.maxDigitWidth,pixelRatio:re.pixelRatio})}static computeContainedMinimapLineCount(re){const ve=re.height/re.lineHeight,Fe=re.scrollBeyondLastLine?ve-1:0,Oe=(re.viewLineCount+Fe)/(re.pixelRatio*re.height),Xe=Math.floor(re.viewLineCount/Oe);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:Fe,desiredRatio:Oe,minimapLineCount:Xe}}static _computeMinimapLayout(re,ve){const Fe=re.outerWidth,Oe=re.outerHeight,Xe=re.pixelRatio;if(!re.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*Oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Oe};const De=ve.stableMinimapLayoutInput,_e=De&&re.outerHeight===De.outerHeight&&re.lineHeight===De.lineHeight&&re.typicalHalfwidthCharacterWidth===De.typicalHalfwidthCharacterWidth&&re.pixelRatio===De.pixelRatio&&re.scrollBeyondLastLine===De.scrollBeyondLastLine&&re.minimap.enabled===De.minimap.enabled&&re.minimap.side===De.minimap.side&&re.minimap.size===De.minimap.size&&re.minimap.showSlider===De.minimap.showSlider&&re.minimap.renderCharacters===De.minimap.renderCharacters&&re.minimap.maxColumn===De.minimap.maxColumn&&re.minimap.scale===De.minimap.scale&&re.verticalScrollbarWidth===De.verticalScrollbarWidth&&re.isViewportWrapping===De.isViewportWrapping,Pe=re.lineHeight,ae=re.typicalHalfwidthCharacterWidth,he=re.scrollBeyondLastLine,H=re.minimap.renderCharacters;let ee=Xe>=2?Math.round(re.minimap.scale*2):re.minimap.scale;const ue=re.minimap.maxColumn,Ie=re.minimap.size,Te=re.minimap.side,Ue=re.verticalScrollbarWidth,He=re.viewLineCount,et=re.remainingWidth,Je=re.isViewportWrapping,Ye=H?2:3;let nt=Math.floor(Xe*Oe);const gt=nt/Xe;let Ee=!1,ye=!1,de=Ye*ee,Q=ee/Xe,xe=1;if(Ie==="fill"||Ie==="fit"){const{typicalViewportLineCount:wt,extraLinesBeyondLastLine:Et,desiredRatio:vt,minimapLineCount:xt}=N.computeContainedMinimapLineCount({viewLineCount:He,scrollBeyondLastLine:he,height:Oe,lineHeight:Pe,pixelRatio:Xe});if(He/xt>1)Ee=!0,ye=!0,ee=1,de=1,Q=ee/Xe;else{let dt=!1,ct=ee+1;if(Ie==="fit"){const ht=Math.ceil((He+Et)*de);Je&&_e&&et<=ve.stableFitRemainingWidth?(dt=!0,ct=ve.stableFitMaxMinimapScale):dt=ht>nt}if(Ie==="fill"||dt){Ee=!0;const ht=ee;de=Math.min(Pe*Xe,Math.max(1,Math.floor(1/vt))),Je&&_e&&et<=ve.stableFitRemainingWidth&&(ct=ve.stableFitMaxMinimapScale),ee=Math.min(ct,Math.max(1,Math.floor(de/Ye))),ee>ht&&(xe=Math.min(2,ee/ht)),Q=ee/Xe/xe,nt=Math.ceil(Math.max(wt,He+Et)*de),Je?(ve.stableMinimapLayoutInput=re,ve.stableFitRemainingWidth=et,ve.stableFitMaxMinimapScale=ee):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0)}}}const Se=Math.floor(ue*Q),qe=Math.min(Se,Math.max(0,Math.floor((et-Ue-2)*Q/(ae+Q)))+e.MINIMAP_GUTTER_WIDTH);let Ze=Math.floor(Xe*qe);const tt=Ze/Xe;Ze=Math.floor(Ze*xe);const st=H?1:2,pt=Te==="left"?0:Fe-qe-Ue;return{renderMinimap:st,minimapLeft:pt,minimapWidth:qe,minimapHeightIsEditorHeight:Ee,minimapIsSampling:ye,minimapScale:ee,minimapLineHeight:de,minimapCanvasInnerWidth:Ze,minimapCanvasInnerHeight:nt,minimapCanvasOuterWidth:tt,minimapCanvasOuterHeight:gt}}static computeLayout(re,ve){const Fe=ve.outerWidth|0,Oe=ve.outerHeight|0,Xe=ve.lineHeight|0,De=ve.lineNumbersDigitCount|0,_e=ve.typicalHalfwidthCharacterWidth,Pe=ve.maxDigitWidth,ae=ve.pixelRatio,he=ve.viewLineCount,H=re.get(120),ee=H==="inherit"?re.get(119):H,ue=ee==="inherit"?re.get(115):ee,Ie=re.get(118),Te=re.get(2),Ue=ve.isDominatedByLongLines,He=re.get(46),et=re.get(57).renderType!==0,Je=re.get(58),Ye=re.get(92),nt=re.get(62),gt=re.get(90),Ee=gt.verticalScrollbarSize,ye=gt.verticalHasArrows,de=gt.arrowSize,Q=gt.horizontalScrollbarSize,xe=re.get(55),Se=re.get(35);let qe;if(typeof xe=="string"&&/^\d+(\.\d+)?ch$/.test(xe)){const At=parseFloat(xe.substr(0,xe.length-2));qe=c.clampedInt(At*_e,0,0,1e3)}else qe=c.clampedInt(xe,0,0,1e3);Se&&(qe+=16);let Ze=0;if(et){const At=Math.max(De,Je);Ze=Math.round(At*Pe)}let tt=0;He&&(tt=Xe);let st=0,pt=st+tt,wt=pt+Ze,Et=wt+qe;const vt=Fe-tt-Ze-qe;let xt=!1,_t=!1,dt=-1;Te!==2&&(ee==="inherit"&&Ue?(xt=!0,_t=!0):ue==="on"||ue==="bounded"?_t=!0:ue==="wordWrapColumn"&&(dt=Ie));const ct=N._computeMinimapLayout({outerWidth:Fe,outerHeight:Oe,lineHeight:Xe,typicalHalfwidthCharacterWidth:_e,pixelRatio:ae,scrollBeyondLastLine:Ye,minimap:nt,verticalScrollbarWidth:Ee,viewLineCount:he,remainingWidth:vt,isViewportWrapping:_t},ve.memory||new E);ct.renderMinimap!==0&&ct.minimapLeft===0&&(st+=ct.minimapWidth,pt+=ct.minimapWidth,wt+=ct.minimapWidth,Et+=ct.minimapWidth);const ht=vt-ct.minimapWidth,Ht=Math.max(1,Math.floor((ht-Ee-2)/_e)),kt=ye?de:0;return _t&&(dt=Math.max(1,Ht),ue==="bounded"&&(dt=Math.min(dt,Ie))),{width:Fe,height:Oe,glyphMarginLeft:st,glyphMarginWidth:tt,lineNumbersLeft:pt,lineNumbersWidth:Ze,decorationsLeft:wt,decorationsWidth:qe,contentLeft:Et,contentWidth:ht,minimap:ct,viewportColumn:Ht,isWordWrapMinified:xt,isViewportWrapping:_t,wrappingColumn:dt,verticalScrollbarWidth:Ee,horizontalScrollbarHeight:Q,overviewRuler:{top:kt,width:Ee,height:Oe-2*kt,right:0}}}}e.EditorLayoutInfoComputer=N;class W extends k{constructor(){const re={enabled:!0};super(54,"lightbulb",re,{"editor.lightbulb.enabled":{type:"boolean",default:re.enabled,description:p.localize(39,null)}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{enabled:l(re.enabled,this.defaultValue.enabled)}}}class M extends k{constructor(){const re={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(124,"inlayHints",re,{"editor.inlayHints.enabled":{type:"boolean",default:re.enabled,description:p.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:re.fontSize,markdownDescription:p.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:re.fontFamily,description:p.localize(42,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{enabled:l(ve.enabled,this.defaultValue.enabled),fontSize:c.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:_.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class q extends h{constructor(){super(56,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,re=>h.clamp(re,0,150),{markdownDescription:p.localize(43,null)})}compute(re,ve,Fe){return re.fontInfo.lineHeight}}class O extends k{constructor(){const re={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(62,"minimap",re,{"editor.minimap.enabled":{type:"boolean",default:re.enabled,description:p.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(45,null),p.localize(46,null),p.localize(47,null)],default:re.size,description:p.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:re.side,description:p.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:re.showSlider,description:p.localize(50,null)},"editor.minimap.scale":{type:"number",default:re.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:re.renderCharacters,description:p.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:re.maxColumn,description:p.localize(53,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{enabled:l(ve.enabled,this.defaultValue.enabled),size:w(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(ve.side,this.defaultValue.side,["right","left"]),showSlider:w(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(ve.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(ve.scale,1,1,3),maxColumn:c.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function F(K){return K==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class B extends k{constructor(){super(72,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(55,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{top:c.clampedInt(ve.top,0,0,1e3),bottom:c.clampedInt(ve.bottom,0,0,1e3)}}}class $ extends k{constructor(){const re={enabled:!0,cycle:!1};super(73,"parameterHints",re,{"editor.parameterHints.enabled":{type:"boolean",default:re.enabled,description:p.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:re.cycle,description:p.localize(57,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{enabled:l(ve.enabled,this.defaultValue.enabled),cycle:l(ve.cycle,this.defaultValue.cycle)}}}class Y extends r{constructor(){super(126)}compute(re,ve,Fe){return re.pixelRatio}}class ce extends k{constructor(){const re={other:!0,comments:!1,strings:!1};super(76,"quickSuggestions",re,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:re.strings,description:p.localize(58,null)},comments:{type:"boolean",default:re.comments,description:p.localize(59,null)},other:{type:"boolean",default:re.other,description:p.localize(60,null)}}}],default:re,description:p.localize(61,null)});this.defaultValue=re}validate(re){if(typeof re=="boolean")return re;if(re&&typeof re=="object"){const ve=re,Fe={other:l(ve.other,this.defaultValue.other),comments:l(ve.comments,this.defaultValue.comments),strings:l(ve.strings,this.defaultValue.strings)};return Fe.other&&Fe.comments&&Fe.strings?!0:!Fe.other&&!Fe.comments&&!Fe.strings?!1:Fe}return this.defaultValue}}var we;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval",K[K.Custom=4]="Custom"})(we=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Re extends k{constructor(){super(57,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(62,null),p.localize(63,null),p.localize(64,null),p.localize(65,null)],default:"on",description:p.localize(66,null)})}validate(re){let ve=this.defaultValue.renderType,Fe=this.defaultValue.renderFn;return typeof re!="undefined"&&(typeof re=="function"?(ve=4,Fe=re):re==="interval"?ve=3:re==="relative"?ve=2:re==="on"?ve=1:ve=0),{renderType:ve,renderFn:Fe}}}function ke(K){const re=K.get(85);return re==="editable"?K.get(78):re!=="on"}e.filterValidationDecorations=ke;class Me extends k{constructor(){const re=[],ve={type:"number",description:p.localize(67,null)};super(89,"rulers",re,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:p.localize(68,null),format:"color-hex"}}}]},default:re,description:p.localize(69,null)})}validate(re){if(Array.isArray(re)){let ve=[];for(let Fe of re)if(typeof Fe=="number")ve.push({column:c.clampedInt(Fe,0,0,1e4),color:null});else if(Fe&&typeof Fe=="object"){const Oe=Fe;ve.push({column:c.clampedInt(Oe.column,0,0,1e4),color:Oe.color})}return ve.sort((Fe,Oe)=>Fe.column-Oe.column),ve}return this.defaultValue}}function Ge(K,re){if(typeof K!="string")return re;switch(K){case"hidden":return 2;case"visible":return 3;default:return 1}}class ze extends k{constructor(){super(90,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re,Fe=c.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Oe=c.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ge(ve.vertical,this.defaultValue.vertical),horizontal:Ge(ve.horizontal,this.defaultValue.horizontal),useShadows:l(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Fe,horizontalSliderSize:c.clampedInt(ve.horizontalSliderSize,Fe,0,1e3),verticalScrollbarSize:Oe,verticalSliderSize:c.clampedInt(ve.verticalSliderSize,Oe,0,1e3),scrollByPage:l(ve.scrollByPage,this.defaultValue.scrollByPage)}}}class je extends k{constructor(){const re={enabled:!1,mode:"prefix"};super(52,"inlineSuggest",re,{"editor.inlineSuggest.enabled":{type:"boolean",default:re.enabled,description:p.localize(70,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subwordDiff"],enumDescriptions:[p.localize(71,null),p.localize(72,null)],default:re.mode,description:p.localize(73,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{enabled:l(ve.enabled,this.defaultValue.enabled),mode:w(ve.mode,this.defaultValue.mode,["prefix","subwordDiff"])}}}class j extends k{constructor(){const re={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordDiff",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(104,"suggest",re,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(74,null),p.localize(75,null)],default:re.insertMode,description:p.localize(76,null)},"editor.suggest.filterGraceful":{type:"boolean",default:re.filterGraceful,description:p.localize(77,null)},"editor.suggest.localityBonus":{type:"boolean",default:re.localityBonus,description:p.localize(78,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:re.shareSuggestSelections,markdownDescription:p.localize(79,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:re.snippetsPreventQuickSuggestions,description:p.localize(80,null)},"editor.suggest.showIcons":{type:"boolean",default:re.showIcons,description:p.localize(81,null)},"editor.suggest.showStatusBar":{type:"boolean",default:re.showStatusBar,description:p.localize(82,null)},"editor.suggest.preview":{type:"boolean",default:re.preview,description:p.localize(83,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subwordDiff"],enumDescriptions:[p.localize(84,null),p.localize(85,null)],default:re.previewMode,description:p.localize(86,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:re.showInlineDetails,description:p.localize(87,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(88,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(89,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(90,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(91,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(92,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(93,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(94,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(95,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(96,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(97,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(98,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(99,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(100,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(101,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(102,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(103,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(104,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(105,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(106,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(107,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(108,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(109,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(110,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(111,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(112,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(113,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(114,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(115,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(116,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(117,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(118,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{insertMode:w(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:l(ve.showIcons,this.defaultValue.showIcons),showStatusBar:l(ve.showStatusBar,this.defaultValue.showStatusBar),preview:l(ve.preview,this.defaultValue.preview),previewMode:w(ve.previewMode,this.defaultValue.previewMode,["prefix","subwordDiff"]),showInlineDetails:l(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(ve.showMethods,this.defaultValue.showMethods),showFunctions:l(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:l(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(ve.showDeprecated,this.defaultValue.showDeprecated),showFields:l(ve.showFields,this.defaultValue.showFields),showVariables:l(ve.showVariables,this.defaultValue.showVariables),showClasses:l(ve.showClasses,this.defaultValue.showClasses),showStructs:l(ve.showStructs,this.defaultValue.showStructs),showInterfaces:l(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:l(ve.showModules,this.defaultValue.showModules),showProperties:l(ve.showProperties,this.defaultValue.showProperties),showEvents:l(ve.showEvents,this.defaultValue.showEvents),showOperators:l(ve.showOperators,this.defaultValue.showOperators),showUnits:l(ve.showUnits,this.defaultValue.showUnits),showValues:l(ve.showValues,this.defaultValue.showValues),showConstants:l(ve.showConstants,this.defaultValue.showConstants),showEnums:l(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:l(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(ve.showKeywords,this.defaultValue.showKeywords),showWords:l(ve.showWords,this.defaultValue.showWords),showColors:l(ve.showColors,this.defaultValue.showColors),showFiles:l(ve.showFiles,this.defaultValue.showFiles),showReferences:l(ve.showReferences,this.defaultValue.showReferences),showFolders:l(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:l(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(ve.showSnippets,this.defaultValue.showSnippets),showUsers:l(ve.showUsers,this.defaultValue.showUsers),showIssues:l(ve.showIssues,this.defaultValue.showIssues)}}}class Z extends k{constructor(){super(100,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(119,null),default:!0,type:"boolean"}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(re.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ie extends r{constructor(){super(127,[78])}compute(re,ve,Fe){return ve.get(78)?!0:re.tabFocusMode}}var oe;(function(K){K[K.None=0]="None",K[K.Same=1]="Same",K[K.Indent=2]="Indent",K[K.DeepIndent=3]="DeepIndent"})(oe=e.WrappingIndent||(e.WrappingIndent={}));function J(K){switch(K){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class le extends r{constructor(){super(129,[128])}compute(re,ve,Fe){const Oe=ve.get(128);return{isDominatedByLongLines:re.isDominatedByLongLines,isWordWrapMinified:Oe.isWordWrapMinified,isViewportWrapping:Oe.isViewportWrapping,wrappingColumn:Oe.wrappingColumn}}}const me="Consolas, 'Courier New', monospace",Le="Menlo, Monaco, 'Courier New', monospace",We="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?Le:R.isLinux?We:me,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function be(K){return e.editorOptionsRegistry[K.id]=K,K}var Qe;(function(K){K[K.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",K[K.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",K[K.accessibilitySupport=2]="accessibilitySupport",K[K.accessibilityPageSize=3]="accessibilityPageSize",K[K.ariaLabel=4]="ariaLabel",K[K.autoClosingBrackets=5]="autoClosingBrackets",K[K.autoClosingDelete=6]="autoClosingDelete",K[K.autoClosingOvertype=7]="autoClosingOvertype",K[K.autoClosingQuotes=8]="autoClosingQuotes",K[K.autoIndent=9]="autoIndent",K[K.automaticLayout=10]="automaticLayout",K[K.autoSurround=11]="autoSurround",K[K.codeLens=12]="codeLens",K[K.codeLensFontFamily=13]="codeLensFontFamily",K[K.codeLensFontSize=14]="codeLensFontSize",K[K.colorDecorators=15]="colorDecorators",K[K.columnSelection=16]="columnSelection",K[K.comments=17]="comments",K[K.contextmenu=18]="contextmenu",K[K.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",K[K.cursorBlinking=20]="cursorBlinking",K[K.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",K[K.cursorStyle=22]="cursorStyle",K[K.cursorSurroundingLines=23]="cursorSurroundingLines",K[K.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",K[K.cursorWidth=25]="cursorWidth",K[K.disableLayerHinting=26]="disableLayerHinting",K[K.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",K[K.domReadOnly=28]="domReadOnly",K[K.dragAndDrop=29]="dragAndDrop",K[K.emptySelectionClipboard=30]="emptySelectionClipboard",K[K.extraEditorClassName=31]="extraEditorClassName",K[K.fastScrollSensitivity=32]="fastScrollSensitivity",K[K.find=33]="find",K[K.fixedOverflowWidgets=34]="fixedOverflowWidgets",K[K.folding=35]="folding",K[K.foldingStrategy=36]="foldingStrategy",K[K.foldingHighlight=37]="foldingHighlight",K[K.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",K[K.fontFamily=39]="fontFamily",K[K.fontInfo=40]="fontInfo",K[K.fontLigatures=41]="fontLigatures",K[K.fontSize=42]="fontSize",K[K.fontWeight=43]="fontWeight",K[K.formatOnPaste=44]="formatOnPaste",K[K.formatOnType=45]="formatOnType",K[K.glyphMargin=46]="glyphMargin",K[K.gotoLocation=47]="gotoLocation",K[K.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",K[K.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",K[K.hover=50]="hover",K[K.inDiffEditor=51]="inDiffEditor",K[K.inlineSuggest=52]="inlineSuggest",K[K.letterSpacing=53]="letterSpacing",K[K.lightbulb=54]="lightbulb",K[K.lineDecorationsWidth=55]="lineDecorationsWidth",K[K.lineHeight=56]="lineHeight",K[K.lineNumbers=57]="lineNumbers",K[K.lineNumbersMinChars=58]="lineNumbersMinChars",K[K.linkedEditing=59]="linkedEditing",K[K.links=60]="links",K[K.matchBrackets=61]="matchBrackets",K[K.minimap=62]="minimap",K[K.mouseStyle=63]="mouseStyle",K[K.mouseWheelScrollSensitivity=64]="mouseWheelScrollSensitivity",K[K.mouseWheelZoom=65]="mouseWheelZoom",K[K.multiCursorMergeOverlapping=66]="multiCursorMergeOverlapping",K[K.multiCursorModifier=67]="multiCursorModifier",K[K.multiCursorPaste=68]="multiCursorPaste",K[K.occurrencesHighlight=69]="occurrencesHighlight",K[K.overviewRulerBorder=70]="overviewRulerBorder",K[K.overviewRulerLanes=71]="overviewRulerLanes",K[K.padding=72]="padding",K[K.parameterHints=73]="parameterHints",K[K.peekWidgetDefaultFocus=74]="peekWidgetDefaultFocus",K[K.definitionLinkOpensInPeek=75]="definitionLinkOpensInPeek",K[K.quickSuggestions=76]="quickSuggestions",K[K.quickSuggestionsDelay=77]="quickSuggestionsDelay",K[K.readOnly=78]="readOnly",K[K.renameOnType=79]="renameOnType",K[K.renderControlCharacters=80]="renderControlCharacters",K[K.renderIndentGuides=81]="renderIndentGuides",K[K.renderFinalNewline=82]="renderFinalNewline",K[K.renderLineHighlight=83]="renderLineHighlight",K[K.renderLineHighlightOnlyWhenFocus=84]="renderLineHighlightOnlyWhenFocus",K[K.renderValidationDecorations=85]="renderValidationDecorations",K[K.renderWhitespace=86]="renderWhitespace",K[K.revealHorizontalRightPadding=87]="revealHorizontalRightPadding",K[K.roundedSelection=88]="roundedSelection",K[K.rulers=89]="rulers",K[K.scrollbar=90]="scrollbar",K[K.scrollBeyondLastColumn=91]="scrollBeyondLastColumn",K[K.scrollBeyondLastLine=92]="scrollBeyondLastLine",K[K.scrollPredominantAxis=93]="scrollPredominantAxis",K[K.selectionClipboard=94]="selectionClipboard",K[K.selectionHighlight=95]="selectionHighlight",K[K.selectOnLineNumbers=96]="selectOnLineNumbers",K[K.showFoldingControls=97]="showFoldingControls",K[K.showUnused=98]="showUnused",K[K.snippetSuggestions=99]="snippetSuggestions",K[K.smartSelect=100]="smartSelect",K[K.smoothScrolling=101]="smoothScrolling",K[K.stickyTabStops=102]="stickyTabStops",K[K.stopRenderingLineAfter=103]="stopRenderingLineAfter",K[K.suggest=104]="suggest",K[K.suggestFontSize=105]="suggestFontSize",K[K.suggestLineHeight=106]="suggestLineHeight",K[K.suggestOnTriggerCharacters=107]="suggestOnTriggerCharacters",K[K.suggestSelection=108]="suggestSelection",K[K.tabCompletion=109]="tabCompletion",K[K.tabIndex=110]="tabIndex",K[K.unusualLineTerminators=111]="unusualLineTerminators",K[K.useShadowDOM=112]="useShadowDOM",K[K.useTabStops=113]="useTabStops",K[K.wordSeparators=114]="wordSeparators",K[K.wordWrap=115]="wordWrap",K[K.wordWrapBreakAfterCharacters=116]="wordWrapBreakAfterCharacters",K[K.wordWrapBreakBeforeCharacters=117]="wordWrapBreakBeforeCharacters",K[K.wordWrapColumn=118]="wordWrapColumn",K[K.wordWrapOverride1=119]="wordWrapOverride1",K[K.wordWrapOverride2=120]="wordWrapOverride2",K[K.wrappingIndent=121]="wrappingIndent",K[K.wrappingStrategy=122]="wrappingStrategy",K[K.showDeprecated=123]="showDeprecated",K[K.inlayHints=124]="inlayHints",K[K.editorClassName=125]="editorClassName",K[K.pixelRatio=126]="pixelRatio",K[K.tabFocusMode=127]="tabFocusMode",K[K.layoutInfo=128]="layoutInfo",K[K.wrappingInfo=129]="wrappingInfo"})(Qe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:be(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(120,null)})),acceptSuggestionOnEnter:be(new b(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(121,null),""],markdownDescription:p.localize(122,null)})),accessibilitySupport:be(new g),accessibilityPageSize:be(new c(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(123,null)})),ariaLabel:be(new _(4,"ariaLabel",p.localize(124,null))),autoClosingBrackets:be(new b(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(125,null),p.localize(126,null),""],description:p.localize(127,null)})),autoClosingDelete:be(new b(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(128,null),""],description:p.localize(129,null)})),autoClosingOvertype:be(new b(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(130,null),""],description:p.localize(131,null)})),autoClosingQuotes:be(new b(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(132,null),p.localize(133,null),""],description:p.localize(134,null)})),autoIndent:be(new d(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null),p.localize(138,null),p.localize(139,null)],description:p.localize(140,null)})),automaticLayout:be(new f(10,"automaticLayout",!1)),autoSurround:be(new b(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(141,null),p.localize(142,null),p.localize(143,null),""],description:p.localize(144,null)})),stickyTabStops:be(new f(102,"stickyTabStops",!1,{description:p.localize(145,null)})),codeLens:be(new f(12,"codeLens",!0,{description:p.localize(146,null)})),codeLensFontFamily:be(new _(13,"codeLensFontFamily","",{description:p.localize(147,null)})),codeLensFontSize:be(new c(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(148,null)})),colorDecorators:be(new f(15,"colorDecorators",!0,{description:p.localize(149,null)})),columnSelection:be(new f(16,"columnSelection",!1,{description:p.localize(150,null)})),comments:be(new t),contextmenu:be(new f(18,"contextmenu",!0)),copyWithSyntaxHighlighting:be(new f(19,"copyWithSyntaxHighlighting",!0,{description:p.localize(151,null)})),cursorBlinking:be(new d(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:p.localize(152,null)})),cursorSmoothCaretAnimation:be(new f(21,"cursorSmoothCaretAnimation",!1,{description:p.localize(153,null)})),cursorStyle:be(new d(22,"cursorStyle",n.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],v,{description:p.localize(154,null)})),cursorSurroundingLines:be(new c(23,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(155,null)})),cursorSurroundingLinesStyle:be(new b(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(156,null),p.localize(157,null)],description:p.localize(158,null)})),cursorWidth:be(new c(25,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(159,null)})),disableLayerHinting:be(new f(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:be(new f(27,"disableMonospaceOptimizations",!1)),domReadOnly:be(new f(28,"domReadOnly",!1)),dragAndDrop:be(new f(29,"dragAndDrop",!0,{description:p.localize(160,null)})),emptySelectionClipboard:be(new S),extraEditorClassName:be(new _(31,"extraEditorClassName","")),fastScrollSensitivity:be(new h(32,"fastScrollSensitivity",5,K=>K<=0?5:K,{markdownDescription:p.localize(161,null)})),find:be(new D),fixedOverflowWidgets:be(new f(34,"fixedOverflowWidgets",!1)),folding:be(new f(35,"folding",!0,{description:p.localize(162,null)})),foldingStrategy:be(new b(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(163,null),p.localize(164,null)],description:p.localize(165,null)})),foldingHighlight:be(new f(37,"foldingHighlight",!0,{description:p.localize(166,null)})),unfoldOnClickAfterEndOfLine:be(new f(38,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(167,null)})),fontFamily:be(new _(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(168,null)})),fontInfo:be(new T),fontLigatures2:be(new a),fontSize:be(new L),fontWeight:be(new U),formatOnPaste:be(new f(44,"formatOnPaste",!1,{description:p.localize(169,null)})),formatOnType:be(new f(45,"formatOnType",!1,{description:p.localize(170,null)})),glyphMargin:be(new f(46,"glyphMargin",!0,{description:p.localize(171,null)})),gotoLocation:be(new G),hideCursorInOverviewRuler:be(new f(48,"hideCursorInOverviewRuler",!1,{description:p.localize(172,null)})),highlightActiveIndentGuide:be(new f(49,"highlightActiveIndentGuide",!0,{description:p.localize(173,null)})),hover:be(new te),inDiffEditor:be(new f(51,"inDiffEditor",!1)),letterSpacing:be(new h(53,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,K=>h.clamp(K,-5,20),{description:p.localize(174,null)})),lightbulb:be(new W),lineDecorationsWidth:be(new P(55,"lineDecorationsWidth",10)),lineHeight:be(new q),lineNumbers:be(new Re),lineNumbersMinChars:be(new c(58,"lineNumbersMinChars",5,1,300)),linkedEditing:be(new f(59,"linkedEditing",!1,{description:p.localize(175,null)})),links:be(new f(60,"links",!0,{description:p.localize(176,null)})),matchBrackets:be(new b(61,"matchBrackets","always",["always","near","never"],{description:p.localize(177,null)})),minimap:be(new O),mouseStyle:be(new b(63,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:be(new h(64,"mouseWheelScrollSensitivity",1,K=>K===0?1:K,{markdownDescription:p.localize(178,null)})),mouseWheelZoom:be(new f(65,"mouseWheelZoom",!1,{markdownDescription:p.localize(179,null)})),multiCursorMergeOverlapping:be(new f(66,"multiCursorMergeOverlapping",!0,{description:p.localize(180,null)})),multiCursorModifier:be(new d(67,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],F,{markdownEnumDescriptions:[p.localize(181,null),p.localize(182,null)],markdownDescription:p.localize(183,null)})),multiCursorPaste:be(new b(68,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(184,null),p.localize(185,null)],markdownDescription:p.localize(186,null)})),occurrencesHighlight:be(new f(69,"occurrencesHighlight",!0,{description:p.localize(187,null)})),overviewRulerBorder:be(new f(70,"overviewRulerBorder",!0,{description:p.localize(188,null)})),overviewRulerLanes:be(new c(71,"overviewRulerLanes",3,0,3)),padding:be(new B),parameterHints:be(new $),peekWidgetDefaultFocus:be(new b(74,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(189,null),p.localize(190,null)],description:p.localize(191,null)})),definitionLinkOpensInPeek:be(new f(75,"definitionLinkOpensInPeek",!1,{description:p.localize(192,null)})),quickSuggestions:be(new ce),quickSuggestionsDelay:be(new c(77,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(193,null)})),readOnly:be(new f(78,"readOnly",!1)),renameOnType:be(new f(79,"renameOnType",!1,{description:p.localize(194,null),markdownDeprecationMessage:p.localize(195,null)})),renderControlCharacters:be(new f(80,"renderControlCharacters",!1,{description:p.localize(196,null)})),renderIndentGuides:be(new f(81,"renderIndentGuides",!0,{description:p.localize(197,null)})),renderFinalNewline:be(new f(82,"renderFinalNewline",!0,{description:p.localize(198,null)})),renderLineHighlight:be(new b(83,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(199,null)],description:p.localize(200,null)})),renderLineHighlightOnlyWhenFocus:be(new f(84,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(201,null)})),renderValidationDecorations:be(new b(85,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:be(new b(86,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(202,null),p.localize(203,null),p.localize(204,null),""],description:p.localize(205,null)})),revealHorizontalRightPadding:be(new c(87,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:be(new f(88,"roundedSelection",!0,{description:p.localize(206,null)})),rulers:be(new Me),scrollbar:be(new ze),scrollBeyondLastColumn:be(new c(91,"scrollBeyondLastColumn",5,0,1073741824,{description:p.localize(207,null)})),scrollBeyondLastLine:be(new f(92,"scrollBeyondLastLine",!0,{description:p.localize(208,null)})),scrollPredominantAxis:be(new f(93,"scrollPredominantAxis",!0,{description:p.localize(209,null)})),selectionClipboard:be(new f(94,"selectionClipboard",!0,{description:p.localize(210,null),included:R.isLinux})),selectionHighlight:be(new f(95,"selectionHighlight",!0,{description:p.localize(211,null)})),selectOnLineNumbers:be(new f(96,"selectOnLineNumbers",!0)),showFoldingControls:be(new b(97,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[p.localize(212,null),p.localize(213,null)],description:p.localize(214,null)})),showUnused:be(new f(98,"showUnused",!0,{description:p.localize(215,null)})),showDeprecated:be(new f(123,"showDeprecated",!0,{description:p.localize(216,null)})),inlayHints:be(new M),snippetSuggestions:be(new b(99,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(217,null),p.localize(218,null),p.localize(219,null),p.localize(220,null)],description:p.localize(221,null)})),smartSelect:be(new Z),smoothScrolling:be(new f(101,"smoothScrolling",!1,{description:p.localize(222,null)})),stopRenderingLineAfter:be(new c(103,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:be(new j),inlineSuggest:be(new je),suggestFontSize:be(new c(105,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(223,null)})),suggestLineHeight:be(new c(106,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(224,null)})),suggestOnTriggerCharacters:be(new f(107,"suggestOnTriggerCharacters",!0,{description:p.localize(225,null)})),suggestSelection:be(new b(108,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(226,null),p.localize(227,null),p.localize(228,null)],description:p.localize(229,null)})),tabCompletion:be(new b(109,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(230,null),p.localize(231,null),p.localize(232,null)],description:p.localize(233,null)})),tabIndex:be(new c(110,"tabIndex",0,-1,1073741824)),unusualLineTerminators:be(new b(111,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(234,null),p.localize(235,null),p.localize(236,null)],description:p.localize(237,null)})),useShadowDOM:be(new f(112,"useShadowDOM",!0)),useTabStops:be(new f(113,"useTabStops",!0,{description:p.localize(238,null)})),wordSeparators:be(new _(114,"wordSeparators",C.USUAL_WORD_SEPARATORS,{description:p.localize(239,null)})),wordWrap:be(new b(115,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(240,null),p.localize(241,null),p.localize(242,null),p.localize(243,null)],description:p.localize(244,null)})),wordWrapBreakAfterCharacters:be(new _(116,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:be(new _(117,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:be(new c(118,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(245,null)})),wordWrapOverride1:be(new b(119,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:be(new b(120,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:be(new d(121,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],J,{enumDescriptions:[p.localize(246,null),p.localize(247,null),p.localize(248,null),p.localize(249,null)],description:p.localize(250,null)})),wrappingStrategy:be(new b(122,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[p.localize(251,null),p.localize(252,null)],description:p.localize(253,null)})),editorClassName:be(new m),pixelRatio:be(new Y),tabFocusMode:be(new ie),layoutInfo:be(new N),wrappingInfo:be(new le)}}),define(ge[151],pe([19,20]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ge[152],pe([19,20]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ge[153],pe([19,20]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(ge[154],pe([19,20]),function(X,e){return X.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ge[155],pe([19,20]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(ge[156],pe([19,20]),function(X,e){return X.create("vs/platform/markers/common/markers",e)}),define(ge[157],pe([19,20]),function(X,e){return X.create("vs/platform/workspaces/common/workspaces",e)}),define(ge[158],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ge[159],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ge[160],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostProgress",e)}),define(ge[161],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ge[162],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ge[163],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ge[164],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ge[165],pe([19,20]),function(X,e){return X.create("vs/workbench/api/node/extHostDebugService",e)}),define(ge[166],pe([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ge[167],pe([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ge[168],pe([19,20]),function(X,e){return X.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ge[169],pe([19,20]),function(X,e){return X.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ge[170],pe([19,20]),function(X,e){return X.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ge[171],pe([0,1,2]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=e.isResourceEditorInput=void 0;function R(E){const k=E;return p.URI.isUri(k==null?void 0:k.resource)}e.isResourceEditorInput=R;var C;(function(E){E[E.ACTIVATE=0]="ACTIVATE",E[E.RESTORE=1]="RESTORE",E[E.PRESERVE=2]="PRESERVE"})(C=e.EditorActivation||(e.EditorActivation={}));var y;(function(E){E[E.PICK=0]="PICK",E[E.DISABLED=1]="DISABLED",E[E.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(y=e.EditorOverride||(e.EditorOverride={}));var A;(function(E){E[E.API=0]="API",E[E.USER=1]="USER"})(A=e.EditorOpenContext||(e.EditorOpenContext={}));var I;(function(E){E[E.Center=0]="Center",E[E.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",E[E.NearTop=2]="NearTop",E[E.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(I=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ge[172],pe([0,1,153]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function y(l){return l=l.trim(),l==="*"||R.test(l)}e.isValidVersionStr=y;function A(l){if(!y(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=l.match(R);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=A;function I(l){if(!l)return null;let f=l.majorBase,c=l.majorMustEqual,h=l.minorBase,_=l.minorMustEqual,w=l.patchBase,b=l.patchMustEqual;l.hasCaret&&(f===0||(_=!1),b=!1);let d=0;if(l.preRelease){const u=C.exec(l.preRelease);if(u){const[,g,t,i]=u;d=Date.UTC(Number(g),Number(t)-1,Number(i))}}return{majorBase:f,majorMustEqual:c,minorBase:h,minorMustEqual:_,patchBase:w,patchMustEqual:b,isMinimum:l.hasGreaterEquals,notBefore:d}}e.normalizeVersion=I;function E(l,f,c){let h;typeof l=="string"?h=I(A(l)):h=l;let _;f instanceof Date?_=f.getTime():typeof f=="string"&&(_=new Date(f).getTime());let w;if(typeof c=="string"?w=I(A(c)):w=c,!h||!w)return!1;let b=h.majorBase,d=h.minorBase,u=h.patchBase,g=w.majorBase,t=w.minorBase,i=w.patchBase,s=w.notBefore,n=w.majorMustEqual,o=w.minorMustEqual,v=w.patchMustEqual;return w.isMinimum?b>g?!0:b<g?!1:d>t?!0:d<t||_&&_<s?!1:u>=i:(b===1&&g===0&&(!n||!o||!v)&&(g=1,t=0,i=0,n=!0,o=!1,v=!1),b<g?!1:b>g?!n:d<t?!1:d>t?!o:u<i?!1:u>i?!v:!(_&&_<s))}e.isValidVersion=E;function k(l,f,c,h){return c.isBuiltin||typeof c.main=="undefined"?!0:P(l,f,c.engines.vscode,h)}e.isValidExtensionVersion=k;function r(l,f,c){return l==="*"||P(f,c,l)}e.isEngineValid=r;function P(l,f,c,h=[]){let _=I(A(c));if(!_)return h.push(p.localize(0,null,c)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return h.push(p.localize(1,null,c)),!1}else if(!_.majorMustEqual)return h.push(p.localize(2,null,c)),!1;return E(l,f,_)?!0:(h.push(p.localize(3,null,l,c)),!1)}}),define(ge[110],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class p{constructor(y,A=[],I=!1){this.ctor=y,this.staticArguments=A,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=p;const R=(C,...y)=>new p(C,y);e.createSyncDescriptor=R}),define(ge[77],pe([0,1,110]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function C(A,I,E){I instanceof p.SyncDescriptor||(I=new p.SyncDescriptor(I,[],E)),R.push([A,I])}e.registerSingleton=C;function y(){return R}e.getSingletonServiceDescriptors=y}),define(ge[173],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(y){this.incoming=new Map,this.outgoing=new Map,this.data=y}}e.Node=p;class R{constructor(y){this._hashFn=y,this._nodes=new Map}roots(){const y=[];for(let A of this._nodes.values())A.outgoing.size===0&&y.push(A);return y}insertEdge(y,A){const I=this.lookupOrInsertNode(y),E=this.lookupOrInsertNode(A);I.outgoing.set(this._hashFn(A),E),E.incoming.set(this._hashFn(y),I)}removeNode(y){const A=this._hashFn(y);this._nodes.delete(A);for(let I of this._nodes.values())I.outgoing.delete(A),I.incoming.delete(A)}lookupOrInsertNode(y){const A=this._hashFn(y);let I=this._nodes.get(A);return I||(I=new p(y),this._nodes.set(A,I)),I}lookup(y){return this._nodes.get(this._hashFn(y))}isEmpty(){return this._nodes.size===0}toString(){let y=[];for(let[A,I]of this._nodes)y.push(`${A}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return y.join(`
`)}findCycleSlow(){for(let[y,A]of this._nodes){const I=new Set([y]),E=this._findCycle(A,I);if(E)return E}}_findCycle(y,A){for(let[I,E]of y.outgoing){if(A.has(I))return[...A,I].join(" -> ");A.add(I);const k=this._findCycle(E,A);if(k)return k;A.delete(I)}}}e.Graph=R}),define(ge[4],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function E(k){return k[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=E})(p=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function R(I,E,k,r){E[p.DI_TARGET]===E?E[p.DI_DEPENDENCIES].push({id:I,index:k,optional:r}):(E[p.DI_DEPENDENCIES]=[{id:I,index:k,optional:r}],E[p.DI_TARGET]=E)}function C(I){if(p.serviceIds.has(I))return p.serviceIds.get(I);const E=function(k,r,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(E,k,P,!1)};return E.toString=()=>I,p.serviceIds.set(I,E),E}e.createDecorator=C;function y(I){return I}e.refineServiceDecorator=y;function A(I){return function(E,k,r){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(I,E,r,!0)}}e.optional=A}),define(ge[174],pe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=p.createDecorator("modelService");function R(C){return!C.isTooLargeForSyncing()&&!C.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(ge[175],pe([0,1,3,73,6,23,72,76,174]),function(X,e,p,R,C,y,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(l){return typeof l=="string"?!1:Array.isArray(l)?l.every(k):!!l.exclusive}class r{constructor(){this._clock=0,this._entries=[],this._onDidChange=new p.Emitter}get onDidChange(){return this._onDidChange.event}register(f,c){let h={selector:f,provider:c,_score:-1,_time:this._clock++};return this._entries.push(h),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),C.toDisposable(()=>{if(h){let _=this._entries.indexOf(h);_>=0&&(this._entries.splice(_,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),h=void 0)}})}has(f){return this.all(f).length>0}all(f){if(!f)return[];this._updateScores(f);const c=[];for(let h of this._entries)h._score>0&&c.push(h.provider);return c}ordered(f){const c=[];return this._orderedForEach(f,h=>c.push(h.provider)),c}orderedGroups(f){const c=[];let h,_;return this._orderedForEach(f,w=>{h&&_===w._score?h.push(w.provider):(_=w._score,h=[w.provider],c.push(h))}),c}_orderedForEach(f,c){if(!!f){this._updateScores(f);for(const h of this._entries)h._score>0&&c(h)}}_updateScores(f){let c={uri:f.uri.toString(),language:f.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===c.language&&this._lastCandidate.uri===c.uri)){this._lastCandidate=c;for(let h of this._entries)if(h._score=I.score(h.selector,f.uri,f.getLanguageIdentifier().language,E.shouldSynchronizeModel(f)),k(h.selector)&&h._score>0){for(let _ of this._entries)_._score=0;h._score=1e3;break}this._entries.sort(r._compareByScoreAndTime)}}static _compareByScoreAndTime(f,c){return f._score<c._score?1:f._score>c._score?-1:f._time<c._time?1:f._time>c._time?-1:0}}e.LanguageFeatureRegistry=r;class P{constructor(f,c,h=Number.MAX_SAFE_INTEGER){this._registry=f,this.min=c,this.max=h,this._cache=new y.LRUCache(50,.7)}_key(f){return f.id+R.hash(this._registry.all(f))}_clamp(f){return f===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(f*1.3)))}get(f){const c=this._key(f),h=this._cache.get(c);return this._clamp(h==null?void 0:h.value)}update(f,c){const h=this._key(f);let _=this._cache.get(h);return _||(_=new A.MovingAverage,this._cache.set(h,_)),_.update(c),this.get(f)}}e.LanguageFeatureRequestDelays=P}),define(ge[78],pe([0,1,2,40,175,143,90]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var I;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(I=e.LanguageId||(e.LanguageId={}));class E{constructor(T,L){this.language=T,this.id=L}}e.LanguageIdentifier=E;var k;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline"})(k=e.FontStyle||(e.FontStyle={}));var r;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(r=e.ColorId||(e.ColorId={}));var P;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=4]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var l;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",a[a.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(l=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(T){return(T&255)>>>0}static getTokenType(T){return(T&1792)>>>8}static getFontStyle(T){return(T&14336)>>>11}static getForeground(T){return(T&8372224)>>>14}static getBackground(T){return(T&4286578688)>>>23}static getClassNameFromMetadata(T){let L=this.getForeground(T),U="mtk"+L,G=this.getFontStyle(T);return G&1&&(U+=" mtki"),G&2&&(U+=" mtkb"),G&4&&(U+=" mtku"),U}static getInlineStyleFromMetadata(T,L){const U=this.getForeground(T),G=this.getFontStyle(T);let te=`color: ${L[U]};`;return G&1&&(te+="font-style: italic;"),G&2&&(te+="font-weight: bold;"),G&4&&(te+="text-decoration: underline;"),te}}e.TokenMetadata=f;var c;(function(a){a[a.Method=0]="Method",a[a.Function=1]="Function",a[a.Constructor=2]="Constructor",a[a.Field=3]="Field",a[a.Variable=4]="Variable",a[a.Class=5]="Class",a[a.Struct=6]="Struct",a[a.Interface=7]="Interface",a[a.Module=8]="Module",a[a.Property=9]="Property",a[a.Event=10]="Event",a[a.Operator=11]="Operator",a[a.Unit=12]="Unit",a[a.Value=13]="Value",a[a.Constant=14]="Constant",a[a.Enum=15]="Enum",a[a.EnumMember=16]="EnumMember",a[a.Keyword=17]="Keyword",a[a.Text=18]="Text",a[a.Color=19]="Color",a[a.File=20]="File",a[a.Reference=21]="Reference",a[a.Customcolor=22]="Customcolor",a[a.Folder=23]="Folder",a[a.TypeParameter=24]="TypeParameter",a[a.User=25]="User",a[a.Issue=26]="Issue",a[a.Snippet=27]="Snippet"})(c=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let a=Object.create(null);return a[0]="symbol-method",a[1]="symbol-function",a[2]="symbol-constructor",a[3]="symbol-field",a[4]="symbol-variable",a[5]="symbol-class",a[6]="symbol-struct",a[7]="symbol-interface",a[8]="symbol-module",a[9]="symbol-property",a[10]="symbol-event",a[11]="symbol-operator",a[12]="symbol-unit",a[13]="symbol-value",a[14]="symbol-constant",a[15]="symbol-enum",a[16]="symbol-enum-member",a[17]="symbol-keyword",a[27]="symbol-snippet",a[18]="symbol-text",a[19]="symbol-color",a[20]="symbol-file",a[21]="symbol-reference",a[22]="symbol-customcolor",a[23]="symbol-folder",a[24]="symbol-type-parameter",a[25]="account",a[26]="issues",function(T){const L=a[T];let U=L&&A.iconRegistry.get(L);return U||(console.info("No codicon found for CompletionItemKind "+T),U=A.Codicon.symbolProperty),U.classNames}}(),e.completionKindFromString=function(){let a=Object.create(null);return a.method=0,a.function=1,a.constructor=2,a.field=3,a.variable=4,a.class=5,a.struct=6,a.interface=7,a.module=8,a.property=9,a.event=10,a.operator=11,a.unit=12,a.value=13,a.constant=14,a.enum=15,a["enum-member"]=16,a.enumMember=16,a.keyword=17,a.snippet=27,a.text=18,a.color=19,a.file=20,a.reference=21,a.customcolor=22,a.folder=23,a["type-parameter"]=24,a.typeParameter=24,a.account=25,a.issue=26,function(T,L){let U=a[T];return typeof U=="undefined"&&!L&&(U=9),U}}();var h;(function(a){a[a.Deprecated=1]="Deprecated"})(h=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(a){a[a.KeepWhitespace=1]="KeepWhitespace",a[a.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(a){a[a.Invoke=0]="Invoke",a[a.TriggerCharacter=1]="TriggerCharacter",a[a.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(b=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var d;(function(a){a[a.Invoke=1]="Invoke",a[a.Auto=2]="Auto"})(d=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var u;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(u=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var g;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(g=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(a){return a&&p.URI.isUri(a.uri)&&R.Range.isIRange(a.range)&&(R.Range.isIRange(a.originSelectionRange)||R.Range.isIRange(a.targetSelectionRange))}e.isLocationLink=t;var i;(function(a){a[a.File=0]="File",a[a.Module=1]="Module",a[a.Namespace=2]="Namespace",a[a.Package=3]="Package",a[a.Class=4]="Class",a[a.Method=5]="Method",a[a.Property=6]="Property",a[a.Field=7]="Field",a[a.Constructor=8]="Constructor",a[a.Enum=9]="Enum",a[a.Interface=10]="Interface",a[a.Function=11]="Function",a[a.Variable=12]="Variable",a[a.Constant=13]="Constant",a[a.String=14]="String",a[a.Number=15]="Number",a[a.Boolean=16]="Boolean",a[a.Array=17]="Array",a[a.Object=18]="Object",a[a.Key=19]="Key",a[a.Null=20]="Null",a[a.EnumMember=21]="EnumMember",a[a.Struct=22]="Struct",a[a.Event=23]="Event",a[a.Operator=24]="Operator",a[a.TypeParameter=25]="TypeParameter"})(i=e.SymbolKind||(e.SymbolKind={}));var s;(function(a){a[a.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var n;(function(a){const T=new Map;T.set("file",0),T.set("module",1),T.set("namespace",2),T.set("package",3),T.set("class",4),T.set("method",5),T.set("property",6),T.set("field",7),T.set("constructor",8),T.set("enum",9),T.set("interface",10),T.set("function",11),T.set("variable",12),T.set("constant",13),T.set("string",14),T.set("number",15),T.set("boolean",16),T.set("array",17),T.set("object",18),T.set("key",19),T.set("null",20),T.set("enum-member",21),T.set("struct",22),T.set("event",23),T.set("operator",24),T.set("type-parameter",25);const L=new Map;L.set(0,"file"),L.set(1,"module"),L.set(2,"namespace"),L.set(3,"package"),L.set(4,"class"),L.set(5,"method"),L.set(6,"property"),L.set(7,"field"),L.set(8,"constructor"),L.set(9,"enum"),L.set(10,"interface"),L.set(11,"function"),L.set(12,"variable"),L.set(13,"constant"),L.set(14,"string"),L.set(15,"number"),L.set(16,"boolean"),L.set(17,"array"),L.set(18,"object"),L.set(19,"key"),L.set(20,"null"),L.set(21,"enum-member"),L.set(22,"struct"),L.set(23,"event"),L.set(24,"operator"),L.set(25,"type-parameter");function U(V){return T.get(V)}a.fromString=U;function G(V){return L.get(V)}a.toString=G;function te(V,N){const W=L.get(V);let M=W&&A.iconRegistry.get("symbol-"+W);return M||(console.info("No codicon found for SymbolKind "+V),M=A.Codicon.symbolProperty),`${N?"inline":"block"} ${M.classNames}`}a.toCssClassName=te})(n=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(T){this.value=T}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var v;(function(a){a[a.Collapsed=0]="Collapsed",a[a.Expanded=1]="Expanded"})(v=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var m;(function(a){a[a.Editing=0]="Editing",a[a.Preview=1]="Preview"})(m=e.CommentMode||(e.CommentMode={}));var S;(function(a){a[a.Other=0]="Other",a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(S=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new C.LanguageFeatureRegistry,e.RenameProviderRegistry=new C.LanguageFeatureRegistry,e.CompletionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new C.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new C.LanguageFeatureRegistry,e.HoverProviderRegistry=new C.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new C.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new C.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new C.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new C.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new C.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.LinkProviderRegistry=new C.LanguageFeatureRegistry,e.ColorProviderRegistry=new C.LanguageFeatureRegistry,e.SelectionRangeRegistry=new C.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.TokenizationRegistry=new y.TokenizationRegistryImpl;var D;(function(a){a[a.None=0]="None",a[a.Option=1]="Option",a[a.Default=2]="Default",a[a.Preferred=3]="Preferred"})(D=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ge[111],pe([0,1,8,4,11]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let y=C.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",C.isMacintosh),A.set("isLinux",C.isLinux),A.set("isWindows",C.isWindows),A.set("isWeb",C.isWeb),A.set("isMacNative",C.isMacintosh&&!C.isWeb),A.set("isEdge",y.indexOf("Edg/")>=0),A.set("isFirefox",y.indexOf("Firefox")>=0),A.set("isChrome",y.indexOf("Chrome")>=0),A.set("isSafari",y.indexOf("Safari")>=0);const I=Object.prototype.hasOwnProperty;var E;(function(D){D[D.False=0]="False",D[D.True=1]="True",D[D.Defined=2]="Defined",D[D.Not=3]="Not",D[D.Equals=4]="Equals",D[D.NotEquals=5]="NotEquals",D[D.And=6]="And",D[D.Regex=7]="Regex",D[D.NotRegex=8]="NotRegex",D[D.Or=9]="Or",D[D.In=10]="In",D[D.NotIn=11]="NotIn",D[D.Greater=12]="Greater",D[D.GreaterEquals=13]="GreaterEquals",D[D.Smaller=14]="Smaller",D[D.SmallerEquals=15]="SmallerEquals"})(E=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return P.INSTANCE}static true(){return l.INSTANCE}static has(a){return f.create(a)}static equals(a,T){return c.create(a,T)}static notEquals(a,T){return w.create(a,T)}static regex(a,T){return i.create(a,T)}static in(a,T){return h.create(a,T)}static not(a){return b.create(a)}static and(...a){return n.create(a)}static or(...a){return o.create(a)}static greater(a,T){return d.create(a,T)}static less(a,T){return g.create(a,T)}static deserialize(a,T=!1){if(!!a)return this._deserializeOrExpression(a,T)}static _deserializeOrExpression(a,T){let L=a.split("||");return o.create(L.map(U=>this._deserializeAndExpression(U,T)))}static _deserializeAndExpression(a,T){let L=a.split("&&");return n.create(L.map(U=>this._deserializeOne(U,T)))}static _deserializeOne(a,T){if(a=a.trim(),a.indexOf("!=")>=0){let L=a.split("!=");return w.create(L[0].trim(),this._deserializeValue(L[1],T))}if(a.indexOf("==")>=0){let L=a.split("==");return c.create(L[0].trim(),this._deserializeValue(L[1],T))}if(a.indexOf("=~")>=0){let L=a.split("=~");return i.create(L[0].trim(),this._deserializeRegexValue(L[1],T))}if(a.indexOf(" in ")>=0){let L=a.split(" in ");return h.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(a)){const L=a.split(">=");return u.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(a)){const L=a.split(">");return d.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(a)){const L=a.split("<=");return t.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(a)){const L=a.split("<");return g.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(a)?b.create(a.substr(1).trim()):f.create(a)}static _deserializeValue(a,T){if(a=a.trim(),a==="true")return!0;if(a==="false")return!1;let L=/^'([^']*)'$/.exec(a);return L?L[1].trim():a}static _deserializeRegexValue(a,T){if(p.isFalsyOrWhitespace(a)){if(T)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=a.indexOf("/"),U=a.lastIndexOf("/");if(L===U||L<0){if(T)throw new Error(`bad regexp-value '${a}', missing /-enclosure`);return console.warn(`bad regexp-value '${a}', missing /-enclosure`),null}let G=a.slice(L+1,U),te=a[U+1]==="i"?"i":"";try{return new RegExp(G,te)}catch(V){if(T)throw new Error(`bad regexp-value '${a}', parse error: ${V}`);return console.warn(`bad regexp-value '${a}', parse error: ${V}`),null}}}e.ContextKeyExpr=k;function r(D,a){return D.cmp(a)}class P{constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class l{constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=l,l.INSTANCE=new l;class f{constructor(a){this.key=a,this.type=2}static create(a){const T=A.get(a);return typeof T=="boolean"?T?l.INSTANCE:P.INSTANCE:new f(a)}cmp(a){return a.type!==this.type?this.type-a.type:m(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return b.create(this.key)}}e.ContextKeyDefinedExpr=f;class c{constructor(a,T){this.key=a,this.value=T,this.type=4}static create(a,T){if(typeof T=="boolean")return T?f.create(a):b.create(a);const L=A.get(a);return typeof L=="boolean"?T===(L?"true":"false")?l.INSTANCE:P.INSTANCE:new c(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:S(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(a){return a.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=c;class h{constructor(a,T){this.key=a,this.valueKey=T,this.type=10}static create(a,T){return new h(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:S(this.key,this.valueKey,a.key,a.valueKey)}equals(a){return a.type===this.type?this.key===a.key&&this.valueKey===a.valueKey:!1}evaluate(a){const T=a.getValue(this.valueKey),L=a.getValue(this.key);return Array.isArray(T)?T.indexOf(L)>=0:typeof L=="string"&&typeof T=="object"&&T!==null?I.call(T,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(a){return a.mapIn(this.key,this.valueKey)}negate(){return _.create(this)}}e.ContextKeyInExpr=h;class _{constructor(a){this._actual=a,this.type=11}static create(a){return new _(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new _(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotInExpr=_;class w{constructor(a,T){this.key=a,this.value=T,this.type=5}static create(a,T){if(typeof T=="boolean")return T?b.create(a):f.create(a);const L=A.get(a);return typeof L=="boolean"?T===(L?"true":"false")?P.INSTANCE:l.INSTANCE:new w(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:S(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(a){return a.mapNotEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class b{constructor(a){this.key=a,this.type=3}static create(a){const T=A.get(a);return typeof T=="boolean"?T?P.INSTANCE:l.INSTANCE:new b(a)}cmp(a){return a.type!==this.type?this.type-a.type:m(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!a.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(a){return a.mapNot(this.key)}negate(){return f.create(this.key)}}e.ContextKeyNotExpr=b;class d{constructor(a,T){this.key=a,this.value=T,this.type=12}static create(a,T){return new d(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:S(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=d;class u{constructor(a,T){this.key=a,this.value=T,this.type=13}static create(a,T){return new u(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:S(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreaterEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=u;class g{constructor(a,T){this.key=a,this.value=T,this.type=14}static create(a,T){return new g(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:S(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmaller(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerExpr=g;class t{constructor(a,T){this.key=a,this.value=T,this.type=15}static create(a,T){return new t(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:S(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmallerEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(a,T){this.key=a,this.regexp=T,this.type=7}static create(a,T){return new i(a,T)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.key<a.key)return-1;if(this.key>a.key)return 1;const T=this.regexp?this.regexp.source:"",L=a.regexp?a.regexp.source:"";return T<L?-1:T>L?1:0}equals(a){if(a.type===this.type){const T=this.regexp?this.regexp.source:"",L=a.regexp?a.regexp.source:"";return this.key===a.key&&T===L}return!1}evaluate(a){let T=a.getValue(this.key);return this.regexp?this.regexp.test(T):!1}serialize(){const a=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${a}`}keys(){return[this.key]}map(a){return a.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=i;class s{constructor(a){this._actual=a,this.type=8}static create(a){return new s(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new s(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class n{constructor(a){this.expr=a,this.type=6}static create(a){return n._normalizeArr(a)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let T=0,L=this.expr.length;T<L;T++){const U=r(this.expr[T],a.expr[T]);if(U!==0)return U}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let T=0,L=this.expr.length;T<L;T++)if(!this.expr[T].equals(a.expr[T]))return!1;return!0}return!1}evaluate(a){for(let T=0,L=this.expr.length;T<L;T++)if(!this.expr[T].evaluate(a))return!1;return!0}static _normalizeArr(a){const T=[];let L=!1;for(const U of a)if(!!U){if(U.type===1){L=!0;continue}if(U.type===0)return P.INSTANCE;if(U.type===6){T.push(...U.expr);continue}T.push(U)}if(T.length===0&&L)return l.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];for(T.sort(r);T.length>1;){const U=T[T.length-1];if(U.type!==9)break;T.pop();const G=T.pop(),te=o.create(U.expr.map(V=>n.create([V,G])));te&&(T.push(te),T.sort(r))}return T.length===1?T[0]:new n(T)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(let T of this.expr)a.push(...T.keys());return a}map(a){return new n(this.expr.map(T=>T.map(a)))}negate(){let a=[];for(let T of this.expr)a.push(T.negate());return o.create(a)}}e.ContextKeyAndExpr=n;class o{constructor(a){this.expr=a,this.type=9}static create(a){const T=o._normalizeArr(a);if(T.length!==0)return T.length===1?T[0]:new o(T)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let T=0,L=this.expr.length;T<L;T++){const U=r(this.expr[T],a.expr[T]);if(U!==0)return U}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let T=0,L=this.expr.length;T<L;T++)if(!this.expr[T].equals(a.expr[T]))return!1;return!0}return!1}evaluate(a){for(let T=0,L=this.expr.length;T<L;T++)if(this.expr[T].evaluate(a))return!0;return!1}static _normalizeArr(a){let T=[],L=!1;if(a){for(let U=0,G=a.length;U<G;U++){const te=a[U];if(!!te){if(te.type===0){L=!0;continue}if(te.type===1)return[l.INSTANCE];if(te.type===9){T=T.concat(te.expr);continue}T.push(te)}}if(T.length===0&&L)return[P.INSTANCE];T.sort(r)}return T}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(let T of this.expr)a.push(...T.keys());return a}map(a){return new o(this.expr.map(T=>T.map(a)))}negate(){let a=[];for(let L of this.expr)a.push(L.negate());const T=L=>L.type===9?L.expr:[L];for(;a.length>1;){const L=a.shift(),U=a.shift(),G=[];for(const te of T(L))for(const V of T(U))G.push(k.and(te,V));a.unshift(k.or(...G))}return a[0]}}e.ContextKeyOrExpr=o;class v extends f{constructor(a,T,L){super(a);this._defaultValue=T,typeof L=="object"?v._info.push(Object.assign(Object.assign({},L),{key:a})):L!==!0&&v._info.push({key:a,description:L,type:T!=null?typeof T:void 0})}static all(){return v._info.values()}bindTo(a){return a.createKey(this.key,this._defaultValue)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return k.not(this.key)}isEqualTo(a){return k.equals(this.key,a)}notEqualsTo(a){return k.notEquals(this.key,a)}}e.RawContextKey=v,v._info=[],e.IContextKeyService=R.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(D,a){return D<a?-1:D>a?1:0}function S(D,a,T,L){return D<T?-1:D>T?1:a<L?-1:a>L?1:0}}),define(ge[176],pe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=p.createDecorator("environmentService"),e.INativeEnvironmentService=p.refineServiceDecorator(e.IEnvironmentService)}),define(ge[177],pe([0,1,152,4,10]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function y(P){return P&&typeof P=="object"&&typeof P.id=="string"&&(!P.uuid||typeof P.uuid=="string")}e.isIExtensionIdentifier=y;var A;(function(P){P[P.NoneOrRelevance=0]="NoneOrRelevance",P[P.LastUpdatedDate=1]="LastUpdatedDate",P[P.Title=2]="Title",P[P.PublisherName=3]="PublisherName",P[P.InstallCount=4]="InstallCount",P[P.PublishedDate=5]="PublishedDate",P[P.AverageRating=6]="AverageRating",P[P.WeightedRating=12]="WeightedRating"})(A=e.SortBy||(e.SortBy={}));var I;(function(P){P[P.Default=0]="Default",P[P.Ascending=1]="Ascending",P[P.Descending=2]="Descending"})(I=e.SortOrder||(e.SortOrder={}));var E;(function(P){P.Uninstall="uninstall"})(E=e.StatisticType||(e.StatisticType={}));var k;(function(P){P[P.None=0]="None",P[P.Install=1]="Install",P[P.Update=2]="Update"})(k=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=R.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class r extends Error{constructor(l,f){super(l);this.code=f}}e.ExtensionManagementError=r,e.IExtensionManagementService=R.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=R.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=R.createDecorator("IExtensionTipsService"),e.DefaultIconPath=C.FileAccess.asBrowserUri("./media/defaultIcon.png",X).toString(!0),e.ExtensionsLabel=p.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=p.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=R.createDecorator("IExtensionManagementCLIService")}),define(ge[26],pe([0,1,8,4]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function C(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.getWorkpaceSupportTypeMessage=C;function y(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class I{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,l){if(typeof P=="undefined"||P===null)return typeof l=="undefined"||l===null;if(typeof l=="undefined"||l===null)return!1;if(typeof P=="string"||typeof l=="string"){let f=typeof P=="string"?P:P.value,c=typeof l=="string"?l:l.value;return p.equalsIgnoreCase(f,c)}return P._lower===l._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=I;function E(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function k(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=k,e.IBuiltinExtensionsScannerService=R.createDecorator("IBuiltinExtensionsScannerService")}),define(ge[178],pe([0,1,8,26]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function C(f,c){return f.uuid&&c.uuid?f.uuid===c.uuid:f.id===c.id?!0:p.compareIgnoreCase(f.id,c.id)===0}e.areSameExtensions=C;class y{constructor(c,h){this.version=h,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof y?C(this,c)&&this.version===c.version:!1}}e.ExtensionIdentifierWithVersion=y;function A(f,c){return`${f}.${c}`}e.getExtensionId=A;function I(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function E(f,c){return I(A(f,c))}e.getGalleryExtensionId=E;function k(f,c){const h=[],_=w=>{for(const b of h)if(b.some(d=>C(c(d),c(w))))return b;return null};for(const w of f){const b=_(w);b?b.push(w):h.push([w])}return h}e.groupByExtension=k;function r(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=r;function P(f){return Object.assign({id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0)},f.telemetryData)}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function l(f){const c=new Set;for(const h of f)h.malicious&&c.add(h.id.id);return c}e.getMaliciousExtensionsSet=l}),define(ge[179],pe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=p.createDecorator("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=p.createDecorator("externalTerminal")}),define(ge[180],pe([0,1,38,9,109,154,28,11,179,10,135]),function(X,e,p,R,C,y,A,I,E,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=y.localize(0,null);class l{async getDefaultTerminalForPlatforms(){const u=await h.getDefaultTerminalLinuxReady();return{windows:f.getDefaultTerminalWindows(),linux:u,osx:"xterm"}}}class f extends l{openTerminal(u,g){return this.spawnTerminal(p,u,C.getWindowsShell(),g)}spawnTerminal(u,g,t,i){const s=g.windowsExec||f.getDefaultTerminalWindows();i&&i[1]===":"&&(i=i[0].toUpperCase()+i.substr(1));const n=R.basename(s).toLowerCase();if(n==="cmder"||n==="cmder.exe")return u.spawn(s,i?[i]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return s.indexOf(" ")>=0&&o.push('""'),o.push(s),(n==="wt"||n==="wt.exe")&&o.push("-d ."),new Promise((v,m)=>{const S=_(process),D=u.spawn(t,o,{cwd:i,env:S});D.on("error",m),D.on("exit",()=>v())})}runInTerminal(u,g,t,i,s){const n="windowsExec"in s&&s.windowsExec?s.windowsExec:f.getDefaultTerminalWindows();return new Promise((o,v)=>{const m=`"${g} - ${P}"`,S=`""${t.join('" "')}" & pause"`,D=["/c","start",m,"/wait",n,"/c",S],a=Object.assign({},_(process),i);Object.keys(a).filter(U=>a[U]===null).forEach(U=>delete a[U]);const T={cwd:g,env:a,windowsVerbatimArguments:!0};p.spawn(f.CMD,D,T).on("error",U=>{v(w(U))}),o(void 0)})}static getDefaultTerminalWindows(){if(!f._DEFAULT_TERMINAL_WINDOWS){const u=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${u?"Sysnative":"System32"}\\cmd.exe`}return f._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=f,f.CMD="cmd.exe";class c extends l{openTerminal(u,g){return this.spawnTerminal(p,u,g)}runInTerminal(u,g,t,i,s){const n=s.osxExec||E.DEFAULT_TERMINAL_OSX;return new Promise((o,v)=>{if(n===E.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const m=n===E.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",D=[k.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${m}.scpt`,X).fsPath,"-t",u||P,"-w",g];for(let L of t)D.push("-a"),D.push(L);if(i)for(let L in i){const U=i[L];U===null?(D.push("-u"),D.push(L)):(D.push("-e"),D.push(`${L}=${U}`))}let a="";const T=p.spawn(c.OSASCRIPT,D);T.on("error",L=>{v(w(L))}),T.stderr.on("data",L=>{a+=L.toString()}),T.on("exit",L=>{if(L===0)o(void 0);else if(a){const U=a.split(`
`,1);v(new Error(U[0]))}else v(new Error(y.localize(1,null,m,L)))})}else v(new Error(y.localize(2,null,n)))})}spawnTerminal(u,g,t){const i=g.osxExec||E.DEFAULT_TERMINAL_OSX;return new Promise((s,n)=>{const o=["-a",i];t&&o.push(t);const v=u.spawn("/usr/bin/open",o);v.on("error",n),v.on("exit",()=>s())})}}e.MacExternalTerminalService=c,c.OSASCRIPT="/usr/bin/osascript";class h extends l{openTerminal(u,g){return this.spawnTerminal(p,u,g)}runInTerminal(u,g,t,i,s){const n=s.linuxExec?Promise.resolve(s.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((o,v)=>{let m=[];n.then(S=>{S.indexOf("gnome-terminal")>=0?m.push("-x"):m.push("-e"),m.push("bash"),m.push("-c");const D=`${b(t)}; echo; read -p "${h.WAIT_MESSAGE}" -n1;`;m.push(`''${D}''`);const a=Object.assign({},process.env,i);Object.keys(a).filter(G=>a[G]===null).forEach(G=>delete a[G]);const T={cwd:g,env:a};let L="";const U=p.spawn(S,m,T);U.on("error",G=>{v(w(G))}),U.stderr.on("data",G=>{L+=G.toString()}),U.on("exit",G=>{if(G===0)o(void 0);else if(L){const te=L.split(`
`,1);v(new Error(te[0]))}else v(new Error(y.localize(4,null,S,G)))})})})}static async getDefaultTerminalLinuxReady(){return h._DEFAULT_TERMINAL_LINUX_READY||(h._DEFAULT_TERMINAL_LINUX_READY=new Promise(async u=>{I.isLinux?await A.Promises.exists("/etc/debian_version")?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm"):u("xterm")})),h._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(u,g,t){const i=g.linuxExec?Promise.resolve(g.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((s,n)=>{i.then(o=>{const v=_(process),m=u.spawn(o,[],{cwd:t,env:v});m.on("error",n),m.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=h,h.WAIT_MESSAGE=y.localize(3,null);function _(d){const u=d.env;return r.sanitizeProcessEnvironment(u),u}function w(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(y.localize(5,null,d.path)):d}function b(d){let u="";for(let g of d)g.indexOf(" ")>=0?u+='"'+g+'"':u+=g,u+=" ";return u}}),define(ge[41],pe([0,1,155,9,2,4,8,15,23]),function(X,e,p,R,C,y,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=y.createDecorator("fileService");function k(N){return N.create===!0}e.isFileOpenForWriteOptions=k;var r;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(r=e.FileType||(e.FileType={}));var P;(function(N){N[N.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var l;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=f;function c(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=c;function h(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function _(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=_;var w;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(W,M){super(W);this.code=M}}e.FileSystemProviderError=b;function d(N,W){const M=new b(N.toString(),W);return g(M,W),M}e.createFileSystemProviderError=d;function u(N){return N||d(p.localize(0,null),w.Unknown)}e.ensureFileSystemProviderError=u;function g(N,W){return N.name=W?`${W} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=g;function t(N){if(!N)return w.Unknown;if(N instanceof b)return N.code;const W=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!W)return w.Unknown;switch(W[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function i(N){if(N instanceof S)return N.fileOperationResult;switch(t(N)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var s;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class n{constructor(W,M,q){this.resource=W,this.operation=M,this.target=q}isOperation(W){return this.operation===W}}e.FileOperationEvent=n;var o;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class v{constructor(W,M){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const q of W)switch(q.type){case 1:this.added||(this.added=E.TernarySearchTree.forUris(()=>M)),this.added.set(q.resource,q);break;case 0:this.updated||(this.updated=E.TernarySearchTree.forUris(()=>M)),this.updated.set(q.resource,q);break;case 2:this.deleted||(this.deleted=E.TernarySearchTree.forUris(()=>M)),this.deleted.set(q.resource,q);break}}contains(W,...M){return this.doContains(W,{includeChildren:!1},...M)}affects(W,...M){return this.doContains(W,{includeChildren:!0},...M)}doContains(W,M,...q){var O,F,B,$,Y,ce;if(!W)return!1;const we=q.length>0;return!!((!we||q.includes(1))&&(((O=this.added)===null||O===void 0?void 0:O.get(W))||M.includeChildren&&((F=this.added)===null||F===void 0?void 0:F.findSuperstr(W)))||(!we||q.includes(0))&&(((B=this.updated)===null||B===void 0?void 0:B.get(W))||M.includeChildren&&(($=this.updated)===null||$===void 0?void 0:$.findSuperstr(W)))||(!we||q.includes(2))&&(((Y=this.deleted)===null||Y===void 0?void 0:Y.findSubstr(W))||M.includeChildren&&((ce=this.deleted)===null||ce===void 0?void 0:ce.findSuperstr(W))))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=v;function m(N,W,M){return!N||!W||N===W||W.length>N.length?!1:(W.charAt(W.length-1)!==R.sep&&(W+=R.sep),M?A.startsWithIgnoreCase(N,W):N.indexOf(W)===0)}e.isParent=m;class S extends Error{constructor(W,M,q){super(W);this.fileOperationResult=M,this.options=q}}e.FileOperationError=S;class D extends S{constructor(W,M,q){super(W,2,q);this.stat=M}}e.NotModifiedSinceFileOperationError=D;var a;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(a=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=L;async function U(N,W){if(!W.canHandleResource(C.URI.from({scheme:N.scheme})))return new Promise(M=>{const q=W.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===N.scheme&&O.added&&(q.dispose(),M())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class G{static formatSize(W){return I.isNumber(W)||(W=0),W<G.KB?p.localize(1,null,W.toFixed(0)):W<G.MB?p.localize(2,null,(W/G.KB).toFixed(2)):W<G.GB?p.localize(3,null,(W/G.MB).toFixed(2)):W<G.TB?p.localize(4,null,(W/G.GB).toFixed(2)):p.localize(5,null,(W/G.TB).toFixed(2))}}e.ByteSize=G,G.KB=1024,G.MB=G.KB*G.KB,G.GB=G.MB*G.KB,G.TB=G.GB*G.KB;var te;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(te=e.Arch||(e.Arch={}));function V(N){return{maxFileSize:N===0?300*G.MB:16*G.GB,maxHeapSize:N===0?700*G.MB:2*700*G.MB}}e.getPlatformLimits=V}),define(ge[79],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...C){this._entries=new Map;for(let[y,A]of C)this.set(y,A)}set(C,y){const A=this._entries.get(C);return this._entries.set(C,y),A}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=p}),define(ge[181],pe([0,1,14,173,110,4,79,16]),function(X,e,p,R,C,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const E=!1;class k extends Error{constructor(c){var h;super("cyclic dependency between services");this.message=(h=c.findCycleSlow())!==null&&h!==void 0?h:`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class r{constructor(c=new A.ServiceCollection,h=!1,_){this._activeInstantiations=new Set,this._services=c,this._strict=h,this._parent=_,this._services.set(y.IInstantiationService,this)}createChild(c){return new r(c,this._strict,this)}invokeFunction(c,...h){let _=l.traceInvocation(c),w=!1;try{return c({get:(d,u)=>{if(w)throw p.illegalState("service accessor is only valid during the invocation of its target method");const g=this._getOrCreateServiceInstance(d,_);if(!g&&u!==y.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return g}},...h)}finally{w=!0,_.stop()}}createInstance(c,...h){let _,w;return c instanceof C.SyncDescriptor?(_=l.traceCreation(c.ctor),w=this._createInstance(c.ctor,c.staticArguments.concat(h),_)):(_=l.traceCreation(c),w=this._createInstance(c,h,_)),_.stop(),w}_createInstance(c,h=[],_){let w=y._util.getServiceDependencies(c).sort((u,g)=>u.index-g.index),b=[];for(const u of w){let g=this._getOrCreateServiceInstance(u.id,_);if(!g&&this._strict&&!u.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${u.id}.`);b.push(g)}let d=w.length>0?w[0].index:h.length;if(h.length!==d){console.warn(`[createInstance] First service dependency of ${c.name} at position ${d+1} conflicts with ${h.length} static arguments`);let u=d-h.length;u>0?h=h.concat(new Array(u)):h=h.slice(0,d)}return new c(...[...h,...b])}_setServiceInstance(c,h){if(this._services.get(c)instanceof C.SyncDescriptor)this._services.set(c,h);else if(this._parent)this._parent._setServiceInstance(c,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let h=this._services.get(c);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):h}_getOrCreateServiceInstance(c,h){let _=this._getServiceInstanceOrDescriptor(c);return _ instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,_,h.branch(c,!0)):(h.branch(c,!1),_)}_safeCreateAndCacheServiceInstance(c,h,_){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,h,_)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,h,_){const w=new R.Graph(u=>u.id.toString());let b=0;const d=[{id:c,desc:h,_trace:_}];for(;d.length;){const u=d.pop();if(w.lookupOrInsertNode(u),b++>1e3)throw new k(w);for(let g of y._util.getServiceDependencies(u.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(g.id);if(!t&&!g.optional&&console.warn(`[createInstance] ${c} depends on ${g.id} which is NOT registered.`),t instanceof C.SyncDescriptor){const i={id:g.id,desc:t,_trace:u._trace.branch(g.id,!0)};w.insertEdge(u,i),d.push(i)}}}for(;;){const u=w.roots();if(u.length===0){if(!w.isEmpty())throw new k(w);break}for(const{data:g}of u){if(this._getServiceInstanceOrDescriptor(g.id)instanceof C.SyncDescriptor){const i=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,i)}w.removeNode(g)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,h,_=[],w,b){if(this._services.get(c)instanceof C.SyncDescriptor)return this._createServiceInstance(h,_,w,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,h,_,w,b);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(c,h=[],_,w){if(_){const b=new I.IdleValue(()=>this._createInstance(c,h,w));return new Proxy(Object.create(null),{get(d,u){if(u in d)return d[u];let g=b.value,t=g[u];return typeof t!="function"||(t=t.bind(g),d[u]=t),t},set(d,u,g){return b.value[u]=g,!0}})}else return this._createInstance(c,h,w)}}e.InstantiationService=r;var P;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(P||(P={}));class l{constructor(c,h){this.type=c,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return E?new l(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(c){return E?new l(0,c.name):l._None}branch(c,h){let _=new l(2,c.toString());return this._dep.push([c,h,_]),_}stop(){let c=Date.now()-this._start;l._totals+=c;let h=!1;function _(b,d){let u=[],g=new Array(b+1).join("	");for(const[t,i,s]of d._dep)if(i&&s){h=!0,u.push(`${g}CREATES -> ${t}`);let n=_(b+1,s);n&&u.push(n)}else u.push(`${g}uses -> ${t}`);return u.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${_(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(c>2||h)&&console.log(w.join(`
`))}}l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(ge[12],pe([0,1,4,6,11,3,57]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=p.createDecorator("logService"),e.ILoggerService=p.createDecorator("loggerService");function I(){return new Date().toISOString()}var E;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;class k extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class r extends k{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(E.Trace)&&this.log(E.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(E.Debug)&&this.log(E.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(E.Info)&&this.log(E.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(E.Warning)&&this.log(E.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(E.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(E.Error,this.format(s))}else this.log(E.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(E.Critical)&&this.log(E.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let s=0;s<t.length;s++){let n=t[s];if(typeof n=="object")try{n=JSON.stringify(n)}catch(o){}i+=(s>0?" ":"")+n}return i}}e.AbstractMessageLogger=r;class P extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!C.isWindows}trace(t,...i){this.getLevel()<=E.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,t,...i):console.log(`[main ${I()}]`,t,...i))}debug(t,...i){this.getLevel()<=E.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,t,...i):console.log(`[main ${I()}]`,t,...i))}info(t,...i){this.getLevel()<=E.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,t,...i):console.log(`[main ${I()}]`,t,...i))}warn(t,...i){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,t,...i):console.warn(`[main ${I()}]`,t,...i))}error(t,...i){this.getLevel()<=E.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,t,...i):console.error(`[main ${I()}]`,t,...i))}critical(t,...i){this.getLevel()<=E.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,t,...i):console.error(`[main ${I()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class l extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=l;class f extends k{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:A.toErrorMessage(t,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class c extends k{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const s of this.logServices)s.trace(t,...i)}debug(t,...i){for(const s of this.logServices)s.debug(t,...i)}info(t,...i){for(const s of this.logServices)s.info(t,...i)}warn(t,...i){for(const s of this.logServices)s.warn(t,...i)}error(t,...i){for(const s of this.logServices)s.error(t,...i)}critical(t,...i){for(const s of this.logServices)s.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=c;class h extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=h;class _ extends R.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(s))}))}createLogger(t,i){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(i==null?void 0:i.always)?E.Trace:this.logLevel,i),this.loggers.set(t.toString(),s),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class w{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(t){}getLevel(){return E.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=w;function b(g){if(g.verbose)return E.Trace;if(typeof g.logLevel=="string"){const t=d(g.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function d(g){switch(g){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=d;function u(g){switch(g){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=u}),define(ge[112],pe([0,1,12,41]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function C(E,k,r,P){try{const l=await new Promise((f,c)=>{X(["spdlog"],f,c)});return l.setFlushOn(p.LogLevel.Trace),l.createAsyncRotatingLogger(E,k,r,P)}catch(l){console.error(l)}return null}function y(E,k,r,P){const l=X.__$__nodeRequire("spdlog");return l.setFlushOn(p.LogLevel.Trace),l.createRotatingLogger(E,k,r,P)}e.createRotatingLogger=y;function A(E,k,r){switch(k){case p.LogLevel.Trace:E.trace(r);break;case p.LogLevel.Debug:E.debug(r);break;case p.LogLevel.Info:E.info(r);break;case p.LogLevel.Warning:E.warn(r);break;case p.LogLevel.Error:E.error(r);break;case p.LogLevel.Critical:E.critical(r);break;default:throw new Error("Invalid log level")}}class I extends p.AbstractMessageLogger{constructor(k,r,P,l){super();this.name=k,this.filepath=r,this.rotating=P,this.buffer=[],this.setLevel(l),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(f=>{this._logger&&this._logger.setLevel(f)}))}_createSpdLogLogger(){const k=this.rotating?6:1,r=30/k*R.ByteSize.MB;return C(this.name,this.filepath,r,k).then(P=>{if(P){this._logger=P,this._logger.setLevel(this.getLevel());for(const{level:l,message:f}of this.buffer)A(this._logger,l,f);this.buffer=[]}})}log(k,r){this._logger?A(this._logger,k,r):this.getLevel()<=k&&this.buffer.push({level:k,message:r})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=I}),define(ge[113],pe([0,1,4,156,54]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var y;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(y=e.MarkerTag||(e.MarkerTag={}));var A;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(A=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function k(c,h){return h-c}E.compare=k;const r=Object.create(null);r[E.Error]=R.localize(0,null),r[E.Warning]=R.localize(1,null),r[E.Info]=R.localize(2,null);function P(c){return r[c]||""}E.toString=P;function l(c){switch(c){case C.default.Error:return E.Error;case C.default.Warning:return E.Warning;case C.default.Info:return E.Info;case C.default.Ignore:return E.Hint}}E.fromSeverity=l;function f(c){switch(c){case E.Error:return C.default.Error;case E.Warning:return C.default.Warning;case E.Info:return C.default.Info;case E.Hint:return C.default.Ignore}}E.toSeverity=f}(A=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(E){const k="";function r(l){return P(l,!0)}E.makeKey=r;function P(l,f){let c=[k];return l.source?c.push(l.source.replace("\xA6","\\\xA6")):c.push(k),l.code?typeof l.code=="string"?c.push(l.code.replace("\xA6","\\\xA6")):c.push(l.code.value.replace("\xA6","\\\xA6")):c.push(k),l.severity!==void 0&&l.severity!==null?c.push(A.toString(l.severity)):c.push(k),l.message&&f?c.push(l.message.replace("\xA6","\\\xA6")):c.push(k),l.startLineNumber!==void 0&&l.startLineNumber!==null?c.push(l.startLineNumber.toString()):c.push(k),l.startColumn!==void 0&&l.startColumn!==null?c.push(l.startColumn.toString()):c.push(k),l.endLineNumber!==void 0&&l.endLineNumber!==null?c.push(l.endLineNumber.toString()):c.push(k),l.endColumn!==void 0&&l.endColumn!==null?c.push(l.endColumn.toString()):c.push(k),c.push(k),c.join("\xA6")}E.makeKeyOptionalMessage=P})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=p.createDecorator("markerService")}),define(ge[182],pe([0,1,54,4,3]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=p.default,e.INotificationService=R.createDecorator("notificationService");var y;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(y=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var A;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(A=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new E,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(r){}updateMessage(r){}updateActions(r){}close(){}}e.NoOpNotification=I;class E{infinite(){}done(){}total(r){}worked(r){}}e.NoOpProgress=E}),define(ge[183],pe([0,1,6,8,2,4]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=y.createDecorator("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return p.Disposable.None},registerValidator(){return p.Disposable.None},registerExternalUriResolver(){return p.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return p.Disposable.None},async open(){return!1},async resolveExternalUri(I){return{resolved:I,dispose(){}}}});function A(I,E){return C.URI.isUri(I)?R.equalsIgnoreCase(I.scheme,E):R.startsWithIgnoreCase(I,E+":")}e.matchesScheme=A}),define(ge[184],pe([0,1,10,11,37,24]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const I=R.globals.vscode.context.configuration();if(I)A=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(X==null?void 0:X.__$__nodeRequire)=="function"){const I=y.dirname(p.FileAccess.asFileUri("",X));A=X.__$__nodeRequire(y.joinPath(I,"product.json").fsPath);const E=X.__$__nodeRequire(y.joinPath(I,"package.json").fsPath);C.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:E.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.58.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A});var $e=this&&this.__param||function(X,e){return function(p,R){e(p,R,X)}};define(ge[114],pe([0,1,4,21,6,16]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=p.createDecorator("progressService");var A;(function(r){r[r.Explorer=1]="Explorer",r[r.Scm=3]="Scm",r[r.Extensions=5]="Extensions",r[r.Window=10]="Window",r[r.Notification=15]="Notification",r[r.Dialog=20]="Dialog"})(A=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{constructor(P){this.callback=P}get value(){return this._value}report(P){this._value=P,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let E=class extends C.Disposable{constructor(P,l){super();this.deferred=new y.DeferredPromise,l.withProgress(P,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register(C.toDisposable(()=>this.deferred.complete()))}report(P){this.reporter?this.reporter.report(P):this.lastStep=P}};E=Ve([$e(1,e.IProgressService)],E),e.UnmanagedProgress=E;class k extends C.Disposable{constructor(P){super();this.progressIndicator=P,this.currentOperationId=0,this.currentOperationDisposables=this._register(new C.DisposableStore)}start(P){this.stop();const l=++this.currentOperationId,f=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},P),this.currentOperationDisposables.add(C.toDisposable(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add(C.toDisposable(()=>f.cancel())),this.currentOperationDisposables.add(C.toDisposable(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:f.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(P){this.currentOperationId===P&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=p.createDecorator("editorProgressService")}),define(ge[58],pe([0,1,15,50]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(A,I){R.ok(p.isString(A)),R.ok(p.isObject(I)),R.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,I)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new C}),define(ge[185],pe([0,1,58,3]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class y{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,k){this.schemasById[C(E)]=k,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new y;p.Registry.add(e.Extensions.JSONContribution,A)}),define(ge[80],pe([0,1,151,3,58,15,185]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(_){_[_.APPLICATION=1]="APPLICATION",_[_.MACHINE=2]="MACHINE",_[_.WINDOW=3]="WINDOW",_[_.RESOURCE=4]="RESOURCE",_[_.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",_[_.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const E=C.Registry.as(A.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:p.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,b=!0){this.registerConfigurations([w],b)}registerConfigurations(w,b=!0){const d=[];w.forEach(u=>{d.push(...this.validateAndRegisterProperties(u,b,u.extensionInfo)),this.configurationContributors.push(u),this.registerJSONConfiguration(u)}),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterConfigurations(w){const b=[],d=u=>{if(u.properties)for(const g in u.properties)b.push(g),delete this.configurationProperties[g],this.removeFromSchema(g,u.properties[g]);u.allOf&&u.allOf.forEach(g=>d(g))};for(const u of w){d(u);const g=this.configurationContributors.indexOf(u);g!==-1&&this.configurationContributors.splice(g,1)}E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}registerDefaultConfigurations(w){const b=[],d=[];for(const u of w)for(const g in u)if(b.push(g),e.OVERRIDE_PROPERTY_PATTERN.test(g)){this.defaultValues[g]=Object.assign(Object.assign({},this.defaultValues[g]||{}),u[g]);const t={type:"object",default:this.defaultValues[g],description:p.localize(1,null,g),$ref:e.resourceLanguageSettingsSchemaId};d.push(P(g)),this.configurationProperties[g]=t,this.defaultLanguageConfigurationOverridesNode.properties[g]=t}else{this.defaultValues[g]=u[g];const t=this.configurationProperties[g];t&&(this.updatePropertyDefaultValue(g,t),this.updateSchema(g,t))}this.registerOverrideIdentifiers(d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}deregisterDefaultConfigurations(w){const b=[];for(const d of w)for(const u in d)if(b.push(u),delete this.defaultValues[u],e.OVERRIDE_PROPERTY_PATTERN.test(u))delete this.configurationProperties[u],delete this.defaultLanguageConfigurationOverridesNode.properties[u];else{const g=this.configurationProperties[u];g&&(this.updatePropertyDefaultValue(u,g),this.updateSchema(u,g))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const b of w)this.overrideIdentifiers.add(b);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,b=!0,d,u=3){var g;u=y.isUndefinedOrNull(w.scope)?u:w.scope;let t=[],i=w.properties;if(i)for(let n in i){if(b&&c(n)){delete i[n];continue}const o=i[n];if(this.updatePropertyDefaultValue(n,o),e.OVERRIDE_PROPERTY_PATTERN.test(n)?o.scope=void 0:(o.scope=y.isUndefinedOrNull(o.scope)?u:o.scope,o.restricted=y.isUndefinedOrNull(o.restricted)?!!((g=d==null?void 0:d.restrictedConfigurations)===null||g===void 0?void 0:g.includes(n)):o.restricted),i[n].hasOwnProperty("included")&&!i[n].included){this.excludedConfigurationProperties[n]=i[n],delete i[n];continue}else this.configurationProperties[n]=i[n];!i[n].deprecationMessage&&i[n].markdownDeprecationMessage&&(i[n].deprecationMessage=i[n].markdownDeprecationMessage),t.push(n)}let s=w.allOf;if(s)for(let n of s)t.push(...this.validateAndRegisterProperties(n,b,d,u));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const b=d=>{let u=d.properties;if(u)for(const t in u)this.updateSchema(t,u[t]);let g=d.allOf;g&&g.forEach(b)};b(w)}updateSchema(w,b){switch(e.allSettings.properties[w]=b,b.scope){case 1:e.applicationSettings.properties[w]=b;break;case 2:e.machineSettings.properties[w]=b;break;case 6:e.machineOverridableSettings.properties[w]=b;break;case 3:e.windowSettings.properties[w]=b;break;case 4:e.resourceSettings.properties[w]=b;break;case 5:e.resourceSettings.properties[w]=b,this.resourceLanguageSettingsSchema.properties[w]=b;break}}removeFromSchema(w,b){switch(delete e.allSettings.properties[w],b.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const b=`[${w}]`,d={type:"object",description:p.localize(2,null),errorMessage:p.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(b,d),e.allSettings.properties[b]=d,e.applicationSettings.properties[b]=d,e.machineSettings.properties[b]=d,e.machineOverridableSettings.properties[b]=d,e.windowSettings.properties[b]=d,e.resourceSettings.properties[b]=d}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,b){let d=this.defaultValues[w];y.isUndefined(d)&&(d=b.default),y.isUndefined(d)&&(d=l(b.type)),b.default=d}}const r="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(r);function P(_){return _.substring(1,_.length-1)}e.overrideIdentifierFromKey=P;function l(_){switch(Array.isArray(_)?_[0]:_){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const f=new k;C.Registry.add(e.Extensions.Configuration,f);function c(_){return _.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(_)?p.localize(5,null,_):f.getConfigurationProperties()[_]!==void 0?p.localize(6,null,_):null:p.localize(4,null)}e.validateProperty=c;function h(){const _=[],w=f.getConfigurationProperties();for(const b of Object.keys(w))_.push([b,w[b].scope]);return _.push(["launch",4]),_.push(["task",4]),_}e.getScopes=h}),define(ge[115],pe([0,1,25,15,2,58,4,80]),function(X,e,p,R,C,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=A.createDecorator("configurationService");function E(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof C.URI)}e.isConfigurationOverrides=E;var k;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function r(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=r;function P(i,s){const n=s?i?s.keys.filter(T=>i.keys.indexOf(T)===-1):[...s.keys]:[],o=i?s?i.keys.filter(T=>s.keys.indexOf(T)===-1):[...i.keys]:[],v=[];if(s&&i){for(const T of i.keys)if(s.keys.indexOf(T)!==-1){const L=w(i.contents,T),U=w(s.contents,T);p.equals(L,U)||v.push(T)}}const m=[],S=T=>{const L={};for(const U of T)for(const G of U.identifiers)L[g(G)]=U;return L},D=s?S(s.overrides):{},a=i?S(i.overrides):{};if(Object.keys(D).length)for(const T of n){const L=D[T];L&&m.push([I.overrideIdentifierFromKey(T),L.keys])}if(Object.keys(a).length)for(const T of o){const L=a[T];L&&m.push([I.overrideIdentifierFromKey(T),L.keys])}if(Object.keys(D).length&&Object.keys(a).length)for(const T of v){const L=a[T],U=D[T];if(L&&U){const G=P({contents:L.contents,keys:L.keys,overrides:[]},{contents:U.contents,keys:U.keys,overrides:[]});m.push([I.overrideIdentifierFromKey(T),[...G.added,...G.removed,...G.updated]])}}return{added:n,removed:o,updated:v,overrides:m}}e.compare=P;function l(i,s){const n=[];for(const o of Object.keys(i))if(I.OVERRIDE_PROPERTY_PATTERN.test(o)){const v={};for(const m in i[o])v[m]=i[o][m];n.push({identifiers:[I.overrideIdentifierFromKey(o).trim()],keys:Object.keys(v),contents:f(v,s)})}return n}e.toOverrides=l;function f(i,s){const n=Object.create(null);for(let o in i)c(n,o,i[o],s);return n}e.toValuesTree=f;function c(i,s,n,o){const v=s.split("."),m=v.pop();let S=i;for(let D=0;D<v.length;D++){let a=v[D],T=S[a];switch(typeof T){case"undefined":T=S[a]=Object.create(null);break;case"object":break;default:o(`Ignoring ${s} as ${v.slice(0,D+1).join(".")} is ${JSON.stringify(T)}`);return}S=T}if(typeof S=="object"&&S!==null)try{S[m]=n}catch(D){o(`Ignoring ${s} as ${v.join(".")} is ${JSON.stringify(S)}`)}else o(`Ignoring ${s} as ${v.join(".")} is ${JSON.stringify(S)}`)}e.addToValueTree=c;function h(i,s){const n=s.split(".");_(i,n)}e.removeFromValueTree=h;function _(i,s){const n=s.shift();if(s.length===0){delete i[n];return}if(Object.keys(i).indexOf(n)!==-1){const o=i[n];typeof o=="object"&&!Array.isArray(o)&&(_(o,s),Object.keys(o).length===0&&delete i[n])}}function w(i,s,n){function o(S,D){let a=S;for(const T of D){if(typeof a!="object"||a===null)return;a=a[T]}return a}const v=s.split("."),m=o(i,v);return typeof m=="undefined"?n:m}e.getConfigurationValue=w;function b(i,s,n){Object.keys(s).forEach(o=>{o!=="__proto__"&&(o in i?R.isObject(i[o])&&R.isObject(s[o])?b(i[o],s[o],n):n&&(i[o]=s[o]):i[o]=s[o])})}e.merge=b;function d(){const i=y.Registry.as(I.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=d;function u(){const i=Object.create(null),s=y.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(let n in s){let o=s[n].default;c(i,n,o,v=>console.error(`Conflict in default settings: ${v}`))}return i}e.getDefaultValues=u;function g(i){return`[${i}]`}e.keyFromOverrideIdentifier=g;function t(i,s,n){const o=i.inspect(s),v=i.inspect(n);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:o.defaultValue}e.getMigratedSettingValue=t}),define(ge[186],pe([0,1,53,23,18,15,25,2,80,115,58,6,3]),function(X,e,p,R,C,y,A,I,E,k,r,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},i=[],s=[]){this._contents=t,this._keys=i,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?k.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,i){const s=this.getContentsForOverrideIdentifer(i);return s?t?k.getConfigurationValue(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const n of C.distinct([...Object.keys(this.contents),...Object.keys(i)])){let o=this.contents[n],v=i[n];v&&(typeof o=="object"&&typeof v=="object"?(o=A.deepClone(o),this.mergeContents(o,v)):o=v),s[n]=o}return new f(s,this.keys,this.overrides)}merge(...t){const i=A.deepClone(this.contents),s=A.deepClone(this.overrides),n=[...this.keys];for(const o of t){this.mergeContents(i,o.contents);for(const v of o.overrides){const[m]=s.filter(S=>C.equals(S.identifiers,v.identifiers));m?this.mergeContents(m.contents,v.contents):s.push(A.deepClone(v))}for(const v of o.keys)n.indexOf(v)===-1&&n.push(v)}return new f(i,n,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const s of Object.keys(i)){if(s in t&&y.isObject(t[s])&&y.isObject(i[s])){this.mergeContents(t[s],i[s]);continue}t[s]=A.deepClone(i[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),k.addToValueTree(this.contents,t,i,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&k.removeFromValueTree(this.contents,t)}addKey(t){let i=this.keys.length;for(let s=0;s<i;s++)t.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=f;class c extends f{constructor(){const t=k.getDefaultValues(),i=k.getConfigurationKeys(),s=[];for(const n of Object.keys(t))E.OVERRIDE_PROPERTY_PATTERN.test(n)&&s.push({identifiers:[E.overrideIdentifierFromKey(n).trim()],keys:Object.keys(t[n]),contents:k.toValuesTree(t[n],o=>console.error(`Conflict in default settings file: ${o}`))});super(t,i,s)}}e.DefaultConfigurationModel=c;class h{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!y.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:s,keys:n,overrides:o,restricted:v}=this.doParseRaw(t,i);this._configurationModel=new f(s,n,o),this._restrictedConfigurations=v||[]}doParseContent(t){let i={},s=null,n=[],o=[],v=[];function m(D){Array.isArray(n)?n.push(D):s&&(n[s]=D)}let S={onObjectBegin:()=>{let D={};m(D),o.push(n),n=D,s=null},onObjectProperty:D=>{s=D},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{let D=[];m(D),o.push(n),n=D,s=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:m,onError:(D,a,T)=>{v.push({error:D,offset:a,length:T})}};if(t)try{p.visit(t,S),i=n[0]||{}}catch(D){console.error(`Error while parsing settings file ${this._name}: ${D}`),this._parseErrors=[D]}return i}doParseRaw(t,i){const s=r.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,s,!0,i);t=n.raw;const o=k.toValuesTree(t,S=>console.error(`Conflict in settings file ${this._name}: ${S}`)),v=Object.keys(t),m=k.toOverrides(t,S=>console.error(`Conflict in settings file ${this._name}: ${S}`));return{contents:o,keys:v,overrides:m,restricted:n.restricted}}filter(t,i,s,n){if(!(n==null?void 0:n.scopes)&&!(n==null?void 0:n.skipRestricted))return{raw:t,restricted:[]};const o={},v=[];for(let m in t)if(E.OVERRIDE_PROPERTY_PATTERN.test(m)&&s){const S=this.filter(t[m],i,!1,n);o[m]=S.raw,v.push(...S.restricted)}else{const S=i[m],D=S?typeof S.scope!="undefined"?S.scope:3:void 0;(S==null?void 0:S.restricted)&&v.push(m),(D===void 0||n.scopes===void 0||n.scopes.includes(D))&&(n.skipRestricted&&(S==null?void 0:S.restricted)||(o[m]=t[m]))}return{raw:o,restricted:v}}}e.ConfigurationModelParser=h;class _ extends P.Disposable{constructor(t,i,s,n){super();this.userSettingsResource=t,this.scopes=i,this.fileService=n,this._onDidChange=this._register(new l.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(l.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=_;class w{constructor(t,i,s=new f,n=new f,o=new R.ResourceMap,v=new f,m=new R.ResourceMap,S=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=n,this._folderConfigurations=o,this._memoryConfiguration=v,this._memoryConfigurationByResource=m,this._freeze=S,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(t)}updateValue(t,i,s={}){let n;s.resource?(n=this._memoryConfigurationByResource.get(s.resource),n||(n=new f,this._memoryConfigurationByResource.set(s.resource,n))):n=this._memoryConfiguration,i===void 0?n.removeValue(t):n.setValue(t,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,s){const n=this.getConsolidateConfigurationModel(i,s),o=this.getFolderConfigurationModelForResource(i.resource,s),v=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,m=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),S=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),D=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),a=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),T=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=o?i.overrideIdentifier?o.freeze().override(i.overrideIdentifier).getValue(t):o.freeze().getValue(t):void 0,U=i.overrideIdentifier?v.override(i.overrideIdentifier).getValue(t):v.getValue(t),G=n.getValue(t),te=C.distinct(C.flatten(n.overrides.map(V=>V.identifiers))).filter(V=>n.getOverrideValue(t,V)!==void 0);return{defaultValue:m,userValue:S,userLocalValue:D,userRemoteValue:a,workspaceValue:T,workspaceFolderValue:L,memoryValue:U,value:G,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:S!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:D!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:a!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:o==null?void 0:o.freeze().getValue(t),override:i.overrideIdentifier?o==null?void 0:o.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:v.getValue(t),override:i.overrideIdentifier?v.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:te.length?te:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=i.filter(n=>E.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const o=E.overrideIdentifierFromKey(n),v=this._defaultConfiguration.getKeysForOverrideIdentifier(o),m=t.getKeysForOverrideIdentifier(o),S=[...m.filter(D=>v.indexOf(D)===-1),...v.filter(D=>m.indexOf(D)===-1),...v.filter(D=>!A.equals(this._defaultConfiguration.override(o).getValue(D),t.override(o).getValue(D)))];return[o,S]});return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:n,overrides:o}=k.compare(this.localUserConfiguration,t),v=[...i,...s,...n];return v.length&&this.updateLocalUserConfiguration(t),{keys:v,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:n,overrides:o}=k.compare(this.remoteUserConfiguration,t);let v=[...i,...s,...n];return v.length&&this.updateRemoteUserConfiguration(t),{keys:v,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:n,overrides:o}=k.compare(this.workspaceConfiguration,t);let v=[...i,...s,...n];return v.length&&this.updateWorkspaceConfiguration(t),{keys:v,overrides:o}}compareAndUpdateFolderConfiguration(t,i){const s=this.folderConfigurations.get(t),{added:n,updated:o,removed:v,overrides:m}=k.compare(s,i);let S=[...n,...o,...v];return(S.length||!s)&&this.updateFolderConfiguration(t,i),{keys:S,overrides:m}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:n,removed:o,overrides:v}=k.compare(i,void 0);return{keys:[...s,...n,...o],overrides:v}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let s=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const n=i.getFolder(t);n&&(s=this.getFolderConsolidatedConfiguration(n.uri)||s);const o=this._memoryConfigurationByResource.get(t);o&&(s=s.merge(o))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(i=s.merge(n),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=s}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:s,overrides:n,keys:o}=this._folderConfigurations.get(i);return t.push([i,{contents:s,overrides:n,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),n=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((v,m)=>(v.set(I.URI.revive(m[0]),this.parseConfigurationModel(m[1])),v),new R.ResourceMap);return new w(i,s,new f,n,o,new f,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function b(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const t=new Set,i=new Map;for(const n of g)n.keys.forEach(o=>t.add(o)),n.overrides.forEach(([o,v])=>{const m=R.getOrSet(i,o,new Set);v.forEach(S=>m.add(S))});const s=[];return i.forEach((n,o)=>s.push([o,[...n.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=b;class d{constructor(t,i,s,n){this.change=t,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=n,this._previousConfiguration=void 0;const o=new Set;t.keys.forEach(m=>o.add(m)),t.overrides.forEach(([,m])=>m.forEach(S=>o.add(S))),this.affectedKeys=[...o.values()];const v=new f;this.affectedKeys.forEach(m=>v.setValue(m,{})),this.affectedKeysTree=v.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,o=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!A.equals(n,o)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let s=k.toValuesTree({[i]:!0},()=>{}),n;for(;typeof s=="object"&&(n=Object.keys(s)[0]);){if(t=t[n],!t)return!1;s=s[n]}return!0}}e.ConfigurationChangeEvent=d;class u extends d{constructor(t,i,s,n){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=s,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=u}),define(ge[116],pe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=p.createDecorator("remoteAuthorityResolverService");var R;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends Error{constructor(A,I=R.Unknown,E){super(A);this._message=A,this._code=I,this._detail=E,this.isHandled=I===R.NotAvailable&&E===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype)}static isTemporarilyNotAvailable(A){return A instanceof C&&A._code===R.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof C&&A._code===R.NoResolverFound}static isHandled(A){return A instanceof C&&A.isHandled}}e.RemoteAuthorityResolverError=C}),define(ge[81],pe([0,1,10]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function R(k){return k.scheme===p.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=R;function C(k){if(!k)return;const r=k.indexOf("+");return r<0?k:k.substr(0,r)}e.getRemoteName=C;function y(k){return k.scheme!==p.Schemas.file&&k.scheme!==p.Schemas.vscodeRemote}e.isVirtualResource=y;function A(k){if(k.folders.length)return k.folders.every(r=>y(r.uri))?k.folders[0].uri:void 0;if(k.configuration&&y(k.configuration))return k.configuration}e.getVirtualWorkspaceLocation=A;function I(k){var r;return(r=A(k))===null||r===void 0?void 0:r.scheme}e.getVirtualWorkspaceScheme=I;function E(k){return A(k)!==void 0}e.isVirtualWorkspace=E}),define(ge[187],pe([0,1,3,11,4,12]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=C.createDecorator("tunnelService");var A;(function(f){f.Http="http",f.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function E(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!c)return{address:c[1],port:+c[2]}}e.extractLocalHostUriMetaDataForPortMapping=E,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=k,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function r(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=r;function P(f,c){return c?c!==1&&f<1024:!R.isWindows&&f<1024}e.isPortPrivileged=P;let l=class{constructor(c){this.logService=c,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(c,h){return this._tunnelProvider=c,c?(this._canElevate=h.elevation,this._canMakePublic=h.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async c=>{const h=[],_=Array.from(this._tunnels.values());for(let w of _){const b=Array.from(w.values());for(let d of b){const u=await d.value;u&&h.push(u)}}c(h)})}async dispose(){for(const c of this._tunnels.values()){for(const{value:h}of c.values())await h.then(_=>_==null?void 0:_.dispose());c.clear()}this._tunnels.clear()}openTunnel(c,h,_,w,b=!1,d=!1,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${_} on local port ${w}.`),!c)return;h||(h="localhost");const g=this.retainOrCreateTunnel(c,h,_,w,b,d,u);return g?g.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(h,_);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(t);return(t.tunnelRemoteHost!==h||t.tunnelRemotePort!==_)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),g)}makeTunnel(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,public:c.public,protocol:c.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const h=this._tunnels.get(c.tunnelRemoteHost);if(h){const _=h.get(c.tunnelRemotePort);_&&(_.refcount--,await this.tryDisposeTunnel(c.tunnelRemoteHost,c.tunnelRemotePort,_))}}}}async tryDisposeTunnel(c,h,_){if(_.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${h}.`);const w=_.value.then(async b=>{b&&(await b.dispose(!0),this._onTunnelClosed.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this._tunnels.has(c)&&this._tunnels.get(c).delete(h),w}}async closeTunnel(c,h){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${h} `);const _=this._tunnels.get(c);if(_&&_.has(h)){const w=_.get(h);w.refcount=0,await this.tryDisposeTunnel(c,h,w)}}addTunnelToMap(c,h,_){this._tunnels.has(c)||this._tunnels.set(c,new Map),this._tunnels.get(c).set(h,{refcount:1,value:_})}async removeEmptyTunnelFromMap(c,h){const _=this._tunnels.get(c);_&&(await _.get(h)||_.delete(h),_.size===0&&this._tunnels.delete(c))}getTunnelFromMap(c,h){let _=[c];k(c)?(_.push(...e.LOCALHOST_ADDRESSES),_.push(...e.ALL_INTERFACES_ADDRESSES)):r(c)&&_.push(...e.ALL_INTERFACES_ADDRESSES);const w=_.map(b=>this._tunnels.get(b));for(const b of w){const d=b==null?void 0:b.get(h);if(d)return d}}canTunnel(c){return!!E(c)}createWithProvider(c,h,_,w,b,d,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${_} on local port ${w}.`);const t={elevationRequired:b?P(w===void 0?_:w):!1},i={remoteAddress:{host:h,port:_},localAddressPort:w,public:d,protocol:u},s=c.forwardPort(i,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),s&&this.addTunnelToMap(h,_,s),s}};l=Ve([$e(0,y.ILogService)],l),e.AbstractTunnelService=l}),define(ge[188],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{vsda(){return new Promise((C,y)=>X(["vsda"],C,y))}async sign(C){try{const y=await this.vsda(),A=new y.signer;if(A)return A.sign(C)}catch(y){}return C}}e.SignService=p}),define(ge[189],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class p{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,y,A=5){let I;return I=y(E=>{const k=typeof E=="string"?E:E.data;let r=this._terminalBufferMap.get(C);if(r){r.data.push(k);return}const P=setTimeout(()=>this.flushBuffer(C),A);r={data:[k],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(C),I.dispose()}},this._terminalBufferMap.set(C,r)}),I}stopBuffering(C){const y=this._terminalBufferMap.get(C);y&&y.dispose()}flushBuffer(C){const y=this._terminalBufferMap.get(C);y&&(this._terminalBufferMap.delete(C),this._callback(C,y.data.join("")))}}e.TerminalDataBufferer=p}),define(ge[45],pe([0,1,2,24,4,23]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=C.createDecorator("contextService");var A;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(A=e.WorkbenchState||(e.WorkbenchState={}));function I(l){const f=l;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=I;function E(l){const f=l;return!!(f&&typeof f=="object"&&p.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=E;class k{constructor(f,c,h,_){this._id=f,this._configuration=h,this._ignorePathCasing=_,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=k;class r{constructor(f,c){this.raw=c,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return R.joinPath(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=r;function P(l){return new r({uri:l,index:0,name:R.basenameOrAuthority(l)},{uri:l.toString()})}e.toWorkspaceFolder=P}),define(ge[190],pe([0,1,4,157,45,2,11,9,24,133,53,10,75,29,81]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const h=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:R.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(N){return(typeof N=="string"?I.extname(N):E.extname(N))===h}e.hasWorkspaceFileExtension=_,e.IWorkspacesService=p.createDecorator("workspacesService");function w(N){return N.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function b(N){return N.hasOwnProperty("folderUri")}e.isRecentFolder=b;function d(N){return N.hasOwnProperty("fileUri")}e.isRecentFile=d;function u(N){const W=N;return typeof(W==null?void 0:W.id)=="string"&&y.URI.isUri(W.uri)}e.isSingleFolderWorkspaceIdentifier=u;function g(N){if(N.configuration)return{id:N.id,configPath:N.configuration};if(N.folders.length===1)return{id:N.id,uri:N.folders[0].uri}}e.toWorkspaceIdentifier=g;function t(N){const W=N;return typeof(W==null?void 0:W.id)=="string"&&y.URI.isUri(W.configPath)}e.isWorkspaceIdentifier=t;function i(N){const W=N;if(W==null?void 0:W.uri)return{id:W.id,uri:y.URI.revive(W.uri)};const M=N;if(M==null?void 0:M.configPath)return{id:M.id,configPath:y.URI.revive(M.configPath)};if(N==null?void 0:N.id)return{id:N.id}}e.reviveIdentifier=i;function s(N,W){return E.extUriBiasedIgnorePathCase.isEqualOrParent(N,W.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function n(N){return o(N)||v(N)}e.isStoredWorkspaceFolder=n;function o(N){const W=N;return typeof(W==null?void 0:W.path)=="string"&&(!W.name||typeof W.name=="string")}e.isRawFileWorkspaceFolder=o;function v(N){const W=N;return typeof(W==null?void 0:W.uri)=="string"&&(!W.name||typeof W.name=="string")}e.isRawUriWorkspaceFolder=v;function m(N,W,M,q,O=!A.isWindows,F){if(N.scheme!==q.scheme)return{name:M,uri:N.toString(!0)};let B=W?void 0:F.relativePath(q,N);if(B!==void 0)B.length===0?B=".":A.isWindows&&N.scheme===P.Schemas.file&&!O&&(B=B.replace(/\//g,"\\"));else if(N.scheme===P.Schemas.file)B=N.fsPath,A.isWindows&&(B=l.normalizeDriveLetter(B),O&&(B=f.toSlashes(B)));else{if(!F.isEqualAuthority(N.authority,q.authority))return{name:M,uri:N.toString(!0)};B=N.path}return{name:M,path:B}}e.getStoredWorkspaceFolder=m;function S(N,W,M){let q=[],O=new Set;const F=M.dirname(W);for(let B of N){let $;if(o(B))B.path&&($=M.resolvePath(F,B.path));else if(v(B))try{$=y.URI.parse(B.uri),$.path[0]!=="/"&&($=$.with({path:"/"+$.path}))}catch(Y){console.warn(Y)}if($){let Y=M.getComparisonKey($);if(!O.has(Y)){O.add(Y);const ce=B.name||M.basenameOrAuthority($);q.push(new C.WorkspaceFolder({uri:$,name:ce,index:q.length},B))}}}return q}e.toWorkspaceFolders=S;function D(N,W,M,q,O){let F=a(W,N);const B=O.dirname(W),$=O.dirname(q),Y=[],ce=T(F.folders);for(const Me of F.folders){const Ge=o(Me)?O.resolvePath(B,Me.path):y.URI.parse(Me.uri);let ze;M?ze=!1:ze=!o(Me)||I.isAbsolute(Me.path),Y.push(m(Ge,ze,Me.name,$,ce,O))}const we={insertSpaces:!1,tabSize:4,eol:A.isLinux||A.isMacintosh?`
`:`\r
`},Re=k.setProperty(N,["folders"],Y,we);let ke=k.applyEdits(N,Re);return F.remoteAuthority===c.getRemoteAuthority(q)&&(ke=k.applyEdits(ke,k.removeProperty(ke,["remoteAuthority"],we))),ke}e.rewriteWorkspaceFileForNewLocation=D;function a(N,W){let M=r.parse(W);if(M&&Array.isArray(M.folders))M.folders=M.folders.filter(q=>n(q));else throw new Error(`${N} looks like an invalid workspace file.`);return M}function T(N){return A.isWindows?N.some(W=>o(W)&&W.path.indexOf("/")>=0):!0}e.useSlashForPath=T;function L(N){return N.workspace&&typeof N.workspace=="object"&&typeof N.workspace.id=="string"&&typeof N.workspace.configPath=="string"}function U(N){return typeof N.folderUri=="string"}function G(N){return typeof N.fileUri=="string"}function te(N,W){const M={workspaces:[],files:[]};if(N){const q=function(F,B){for(let $=0;$<F.length;$++)try{B(F[$],$)}catch(Y){W.warn(`Error restoring recent entry ${JSON.stringify(F[$])}: ${Y.toString()}. Skip entry.`)}},O=N;if(Array.isArray(O.entries))q(O.entries,F=>{const B=F.label,$=F.remoteAuthority;L(F)?M.workspaces.push({label:B,remoteAuthority:$,workspace:{id:F.workspace.id,configPath:y.URI.parse(F.workspace.configPath)}}):U(F)?M.workspaces.push({label:B,remoteAuthority:$,folderUri:y.URI.parse(F.folderUri)}):G(F)&&M.files.push({label:B,remoteAuthority:$,fileUri:y.URI.parse(F.fileUri)})});else{const F=N;Array.isArray(F.workspaces3)&&q(F.workspaces3,(B,$)=>{const Y=Array.isArray(F.workspaceLabels)&&F.workspaceLabels[$]||void 0;typeof B=="object"&&typeof B.id=="string"&&typeof B.configURIPath=="string"?M.workspaces.push({label:Y,workspace:{id:B.id,configPath:y.URI.parse(B.configURIPath)}}):typeof B=="string"&&M.workspaces.push({label:Y,folderUri:y.URI.parse(B)})}),Array.isArray(F.files2)&&q(F.files2,(B,$)=>{const Y=Array.isArray(F.fileLabels)&&F.fileLabels[$]||void 0;typeof B=="string"&&M.files.push({label:Y,fileUri:y.URI.parse(B)})})}}return M}e.restoreRecentlyOpened=te;function V(N){const W={entries:[]};for(const M of N.workspaces)b(M)?W.entries.push({folderUri:M.folderUri.toString(),label:M.label,remoteAuthority:M.remoteAuthority}):W.entries.push({workspace:{id:M.workspace.id,configPath:M.workspace.configPath.toString()},label:M.label,remoteAuthority:M.remoteAuthority});for(const M of N.files)W.entries.push({fileUri:M.fileUri.toString(),label:M.label,remoteAuthority:M.remoteAuthority});return W}e.toStoreData=V}),define(ge[82],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class p{constructor(C){this.id=C,this._data=new Map,this._idPool=1}add(C){const y=this._idPool++;return this._data.set(y,C),this.logDebugInfo(),y}get(C,y){return this._data.has(C)?this._data.get(C)[y]:void 0}delete(C){this._data.delete(C),this.logDebugInfo()}logDebugInfo(){!p.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=p,p.enableDebugLogging=!1}),define(ge[46],pe([0,1,2,3,4]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=C.createDecorator("IExtHostEditorTabs");class y{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(I){this._tabs=I.map(E=>({name:E.name,group:E.group,resource:p.URI.revive(E.resource),isActive:E.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=y}),define(ge[59],pe([0,1,10,4]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(p.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(A,I){I===null?this._providerInfo.delete(A):this._providerInfo.set(A,I)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=R.createDecorator("IExtHostFileSystemInfo")}),define(ge[27],pe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=p.createDecorator("IExtHostInitDataService")}),define(ge[191],pe([0,1,16]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(A,I,E){this._deferredPromises=new Map,this._id=A,this._shared=I,this._storage=E,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new p.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const r of k.values())r.complete()}catch(r){for(const P of k.values())P.error(r)}})()},0)}get keys(){var A;return Object.entries((A=this._value)!==null&&A!==void 0?A:{}).filter(([,I])=>I!==void 0).map(([I])=>I)}get whenReady(){return this._init}get(A,I){let E=this._value[A];return typeof E=="undefined"&&(E=I),E}update(A,I){this._value[A]=I;let E=this._deferredPromises.get(A);if(E!==void 0)return E.p;const k=new p.DeferredPromise;return this._deferredPromises.set(A,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class C extends R{constructor(A,I){super(A.identifier.value,!0,I);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=C}),define(ge[192],pe([0,1,3,2,12]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let y=class{constructor(I,E){this._logService=I,this._notebooksAndEditors=E,this._onDidChangeNotebookDocumentMetadata=new p.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new p.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(I,E,k){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(I)).acceptModelChanged(E,k)}$acceptDirtyStateChanged(I,E){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(I)).acceptDirty(E)}$acceptModelSaved(I){const E=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(I));this._onDidSaveNotebookDocument.fire(E.apiNotebook)}$acceptDocumentPropertiesChanged(I,E){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",I.path,E);const k=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(I));k.acceptDocumentPropertiesChanged(E),E.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:k.apiNotebook})}};y=Ve([$e(0,C.ILogService)],y),e.ExtHostNotebookDocuments=y}),define(ge[13],pe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=p.createDecorator("IExtHostRpcService");class R{constructor(y){this.getProxy=y.getProxy.bind(y),this.set=y.set.bind(y),this.assertRegistered=y.assertRegistered.bind(y),this.drain=y.drain.bind(y)}}e.ExtHostRpcService=R});var rt=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},Be=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(ge[193],pe([0,1,26,3]),function(X,e,p,R){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class y{constructor(I,E){C.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=p.ExtensionIdentifier.toKey(I.identifier),rt(this,C,E,"f"),Be(this,C,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(I){return Be(this,C,"f").get(this._id,I)}store(I,E){return Be(this,C,"f").store(this._id,I,E)}delete(I){return Be(this,C,"f").delete(this._id,I)}}e.ExtensionSecrets=y,C=new WeakMap}),define(ge[117],pe([0,1,4,3]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class C{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(A){this._enabled=A}$onDidChangeTelemetryEnabled(A){this._enabled=A,this._onDidChangeTelemetryEnabled.fire(A)}}e.ExtHostTelemetry=C,e.IExtHostTelemetry=p.createDecorator("IExtHostTelemetry")}),define(ge[118],pe([0,1,3]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var R;(function(A){A[A.NewChild=0]="NewChild",A[A.Disposed=1]="Disposed",A[A.Invalidated=2]="Invalidated",A[A.SetProp=3]="SetProp"})(R=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const C=new WeakMap,y=A=>{let I=C.get(A);return I||(I={children:new Map,bus:new p.Emitter},C.set(A,I)),I};e.getPrivateApiFor=y}),define(ge[47],pe([0,1,4,3,13]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var y;(function(I){function E(r){return{remoteAddress:r.remoteAddress,localAddress:r.localAddress,public:!!r.public,protocol:r.protocol}}I.fromApiTunnel=E;function k(r){return{remoteAddress:{host:r.tunnelRemoteHost,port:r.tunnelRemotePort},localAddress:r.localAddress,public:r.public,protocol:r.protocol}}I.fromServiceTunnel=k})(y=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=p.createDecorator("IExtHostTunnelService");let A=class{constructor(E){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(E){return E}async openTunnel(E,k){}async getTunnels(){return[]}async setTunnelExtensionFunctions(E){return{dispose:()=>{}}}registerPortsAttributesProvider(E,k){return{dispose:()=>{}}}async $providePortAttributes(E,k,r,P,l){return[]}async $forwardPort(E,k){}async $closeTunnel(E){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=Ve([$e(0,C.IExtHostRpcService)],A),e.ExtHostTunnelService=A});var rt=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},Be=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(ge[7],pe([0,1,18,14,94,23,97,15,2,32,41,116,118]),function(X,e,p,R,C,y,A,I,E,k,r,P,l){"use strict";var f,c,h,_,w,b,d,u,g,t,i,s,n,o,v,m,S,D;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestRunRequest=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function a(z){function x(){return Reflect.construct(z,arguments,this.constructor)}return Object.defineProperty(x,"name",Object.getOwnPropertyDescriptor(z,"name")),Object.setPrototypeOf(x,z),Object.setPrototypeOf(x.prototype,z.prototype),x}let T=w=class{constructor(x){f.set(this,void 0),rt(this,f,x,"f")}static from(...x){let se=x;return new w(function(){if(se){for(const Ce of se)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();se=void 0}})}dispose(){typeof Be(this,f,"f")=="function"&&(Be(this,f,"f").call(this),rt(this,f,void 0,"f"))}};f=new WeakMap,T=w=Ve([a],T),e.Disposable=T;let L=b=class{constructor(x,se){if(x<0)throw R.illegalArgument("line must be non-negative");if(se<0)throw R.illegalArgument("character must be non-negative");this._line=x,this._character=se}static Min(...x){if(x.length===0)throw new TypeError;let se=x[0];for(let Ce=1;Ce<x.length;Ce++){const Ke=x[Ce];Ke.isBefore(se)&&(se=Ke)}return se}static Max(...x){if(x.length===0)throw new TypeError;let se=x[0];for(let Ce=1;Ce<x.length;Ce++){const Ke=x[Ce];Ke.isAfter(se)&&(se=Ke)}return se}static isPosition(x){if(!x)return!1;if(x instanceof b)return!0;let{line:se,character:Ce}=x;return typeof se=="number"&&typeof Ce=="number"}get line(){return this._line}get character(){return this._character}isBefore(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<x._character}isBeforeOrEqual(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<=x._character}isAfter(x){return!this.isBeforeOrEqual(x)}isAfterOrEqual(x){return!this.isBefore(x)}isEqual(x){return this._line===x._line&&this._character===x._character}compareTo(x){return this._line<x._line?-1:this._line>x.line?1:this._character<x._character?-1:this._character>x._character?1:0}translate(x,se=0){if(x===null||se===null)throw R.illegalArgument();let Ce;return typeof x=="undefined"?Ce=0:typeof x=="number"?Ce=x:(Ce=typeof x.lineDelta=="number"?x.lineDelta:0,se=typeof x.characterDelta=="number"?x.characterDelta:0),Ce===0&&se===0?this:new b(this.line+Ce,this.character+se)}with(x,se=this.character){if(x===null||se===null)throw R.illegalArgument();let Ce;return typeof x=="undefined"?Ce=this.line:typeof x=="number"?Ce=x:(Ce=typeof x.line=="number"?x.line:this.line,se=typeof x.character=="number"?x.character:this.character),Ce===this.line&&se===this.character?this:new b(Ce,se)}toJSON(){return{line:this.line,character:this.character}}};L=b=Ve([a],L),e.Position=L;let U=d=class{constructor(x,se,Ce,Ke){let it,ot;if(typeof x=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof Ke=="number"?(it=new L(x,se),ot=new L(Ce,Ke)):x instanceof L&&se instanceof L&&(it=x,ot=se),!it||!ot)throw new Error("Invalid arguments");it.isBefore(ot)?(this._start=it,this._end=ot):(this._start=ot,this._end=it)}static isRange(x){return x instanceof d?!0:x?L.isPosition(x.start)&&L.isPosition(x.end):!1}get start(){return this._start}get end(){return this._end}contains(x){return x instanceof d?this.contains(x._start)&&this.contains(x._end):x instanceof L?!(x.isBefore(this._start)||this._end.isBefore(x)):!1}isEqual(x){return this._start.isEqual(x._start)&&this._end.isEqual(x._end)}intersection(x){const se=L.Max(x.start,this._start),Ce=L.Min(x.end,this._end);if(!se.isAfter(Ce))return new d(se,Ce)}union(x){if(this.contains(x))return this;if(x.contains(this))return x;const se=L.Min(x.start,this._start),Ce=L.Max(x.end,this.end);return new d(se,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(x,se=this.end){if(x===null||se===null)throw R.illegalArgument();let Ce;return x?L.isPosition(x)?Ce=x:(Ce=x.start||this.start,se=x.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&se.isEqual(this.end)?this:new d(Ce,se)}toJSON(){return[this.start,this.end]}};U=d=Ve([a],U),e.Range=U;let G=u=class extends U{constructor(x,se,Ce,Ke){let it,ot;if(typeof x=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof Ke=="number"?(it=new L(x,se),ot=new L(Ce,Ke)):x instanceof L&&se instanceof L&&(it=x,ot=se),!it||!ot)throw new Error("Invalid arguments");super(it,ot);this._anchor=it,this._active=ot}static isSelection(x){return x instanceof u?!0:x?U.isRange(x)&&L.isPosition(x.anchor)&&L.isPosition(x.active)&&typeof x.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};G=u=Ve([a],G),e.Selection=G;class te{constructor(x,se,Ce){if(typeof x!="string"||x.length===0)throw R.illegalArgument("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw R.illegalArgument("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw R.illegalArgument("connectionToken");this.host=x,this.port=Math.round(se),this.connectionToken=Ce}}e.ResolvedAuthority=te;class V extends Error{constructor(x,se=P.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(x);this._message=x,this._code=se,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype)}static NotAvailable(x,se){return new V(x,P.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(x){return new V(x,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=V;var N;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(N=e.EndOfLine||(e.EndOfLine={}));var W;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(W=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let M=g=class{constructor(x,se){this._range=x,this._newText=se}static isTextEdit(x){return x instanceof g?!0:x?U.isRange(x)&&typeof x.newText=="string":!1}static replace(x,se){return new g(x,se)}static insert(x,se){return g.replace(new U(x,x),se)}static delete(x){return g.replace(x,"")}static setEndOfLine(x){const se=new g(new U(new L(0,0),new L(0,0)),"");return se.newEol=x,se}get range(){return this._range}set range(x){if(x&&!U.isRange(x))throw R.illegalArgument("range");this._range=x}get newText(){return this._newText||""}set newText(x){if(x&&typeof x!="string")throw R.illegalArgument("newText");this._newText=x}get newEol(){return this._newEol}set newEol(x){if(x&&typeof x!="number")throw R.illegalArgument("newEol");this._newEol=x}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};M=g=Ve([a],M),e.TextEdit=M;var q;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace"})(q=e.FileEditType||(e.FileEditType={}));let O=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(x,se,Ce,Ke){this._edits.push({_type:1,from:x,to:se,options:Ce,metadata:Ke})}createFile(x,se,Ce){this._edits.push({_type:1,from:void 0,to:x,options:se,metadata:Ce})}deleteFile(x,se,Ce){this._edits.push({_type:1,from:x,to:void 0,options:se,metadata:Ce})}replaceNotebookMetadata(x,se,Ce){this._edits.push({_type:3,metadata:Ce,uri:x,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(x,se,Ce,Ke,it){let ot,lt,yt=[],Pt;if(qt.isNotebookRange(se)&&Rt.isNotebookCellDataArray(Ce)&&!Rt.isNotebookCellDataArray(Ke)?(ot=se.start,lt=se.end,yt=Ce,Pt=Ke):typeof se=="number"&&typeof Ce=="number"&&Rt.isNotebookCellDataArray(Ke)&&(ot=se,lt=Ce,yt=Ke,Pt=it),ot===void 0||lt===void 0)throw new Error("Invalid arguments");(ot!==lt||yt.length>0)&&this._edits.push({_type:5,uri:x,index:ot,count:lt-ot,cells:yt,metadata:Pt})}replaceNotebookCellMetadata(x,se,Ce,Ke){this._edits.push({_type:3,metadata:Ke,uri:x,edit:{editType:8,index:se,metadata:Ce}})}replace(x,se,Ce,Ke){this._edits.push({_type:2,uri:x,edit:new M(se,Ce),metadata:Ke})}insert(x,se,Ce,Ke){this.replace(x,new U(se,se),Ce,Ke)}delete(x,se,Ce){this.replace(x,se,"",Ce)}has(x){return this._edits.some(se=>se._type===2&&se.uri.toString()===x.toString())}set(x,se){if(se)for(const Ce of se)Ce&&this._edits.push({_type:2,uri:x,edit:Ce});else{for(let Ce=0;Ce<this._edits.length;Ce++){const Ke=this._edits[Ce];Ke._type===2&&Ke.uri.toString()===x.toString()&&(this._edits[Ce]=void 0)}p.coalesceInPlace(this._edits)}}get(x){const se=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===x.toString()&&se.push(Ce.edit);return se}entries(){const x=new y.ResourceMap;for(let se of this._edits)if(se._type===2){let Ce=x.get(se.uri);Ce||(Ce=[se.uri,[]],x.set(se.uri,Ce)),Ce[1].push(se.edit)}return[...x.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};O=Ve([a],O),e.WorkspaceEdit=O;let F=t=class{constructor(x){this._tabstop=1,this.value=x||""}static isSnippetString(x){return x instanceof t?!0:x?typeof x.value=="string":!1}static _escape(x){return x.replace(/\$|}|\\/g,"\\$&")}appendText(x){return this.value+=t._escape(x),this}appendTabstop(x=this._tabstop++){return this.value+="$",this.value+=x,this}appendPlaceholder(x,se=this._tabstop++){if(typeof x=="function"){const Ce=new t;Ce._tabstop=this._tabstop,x(Ce),this._tabstop=Ce._tabstop,x=Ce.value}else x=t._escape(x);return this.value+="${",this.value+=se,this.value+=":",this.value+=x,this.value+="}",this}appendChoice(x,se=this._tabstop++){const Ce=x.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(x,se){if(typeof se=="function"){const Ce=new t;Ce._tabstop=this._tabstop,se(Ce),this._tabstop=Ce._tabstop,se=Ce.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=x,se&&(this.value+=":",this.value+=se),this.value+="}",this}};F=t=Ve([a],F),e.SnippetString=F;var B;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(B=e.DiagnosticTag||(e.DiagnosticTag={}));var $;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})($=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Y=i=class{constructor(x,se){if(this.uri=x,se)if(se instanceof U)this.range=se;else if(se instanceof L)this.range=new U(se,se);else throw new Error("Illegal argument")}static isLocation(x){return x instanceof i?!0:x?U.isRange(x.range)&&E.URI.isUri(x.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Y=i=Ve([a],Y),e.Location=Y;let ce=class{constructor(x,se){this.location=x,this.message=se}static is(x){return x?typeof x.message=="string"&&x.location&&U.isRange(x.location.range)&&E.URI.isUri(x.location.uri):!1}static isEqual(x,se){return x===se?!0:!x||!se?!1:x.message===se.message&&x.location.range.isEqual(se.location.range)&&x.location.uri.toString()===se.location.uri.toString()}};ce=Ve([a],ce),e.DiagnosticRelatedInformation=ce;let we=class{constructor(x,se,Ce=$.Error){if(!U.isRange(x))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=x,this.message=se,this.severity=Ce}toJSON(){return{severity:$[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(x,se){return x===se?!0:!x||!se?!1:x.message===se.message&&x.severity===se.severity&&x.code===se.code&&x.severity===se.severity&&x.source===se.source&&x.range.isEqual(se.range)&&p.equals(x.tags,se.tags)&&p.equals(x.relatedInformation,se.relatedInformation,ce.isEqual)}};we=Ve([a],we),e.Diagnostic=we;let Re=class{constructor(x,se){if(!x)throw new Error("Illegal argument, contents must be defined");Array.isArray(x)?this.contents=x:this.contents=[x],this.range=se}};Re=Ve([a],Re),e.Hover=Re;var ke;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(ke=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Me=class{constructor(x,se=ke.Text){this.range=x,this.kind=se}toJSON(){return{range:this.range,kind:ke[this.kind]}}};Me=Ve([a],Me),e.DocumentHighlight=Me;var Ge;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(Ge=e.SymbolKind||(e.SymbolKind={}));var ze;(function(z){z[z.Deprecated=1]="Deprecated"})(ze=e.SymbolTag||(e.SymbolTag={}));let je=s=class{constructor(x,se,Ce,Ke,it){this.name=x,this.kind=se,this.containerName=it,typeof Ce=="string"&&(this.containerName=Ce),Ke instanceof Y?this.location=Ke:Ce instanceof U&&(this.location=new Y(Ke,Ce)),s.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ge[this.kind],location:this.location,containerName:this.containerName}}};je=s=Ve([a],je),e.SymbolInformation=je;let j=n=class{constructor(x,se,Ce,Ke,it){this.name=x,this.detail=se,this.kind=Ce,this.range=Ke,this.selectionRange=it,this.children=[],n.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy");if(!x.range.contains(x.selectionRange))throw new Error("selectionRange must be contained in fullRange");x.children&&x.children.forEach(n.validate)}};j=n=Ve([a],j),e.DocumentSymbol=j;var Z;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(Z=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ie=class{constructor(x,se){this.title=x,this.kind=se}};ie=Ve([a],ie),e.CodeAction=ie;let oe=o=class{constructor(x){this.value=x}append(x){return new o(this.value?this.value+o.sep+x:x)}intersects(x){return this.contains(x)||x.contains(this)}contains(x){return this.value===x.value||x.value.startsWith(this.value+o.sep)}};oe.sep=".",oe=o=Ve([a],oe),e.CodeActionKind=oe,oe.Empty=new oe(""),oe.QuickFix=oe.Empty.append("quickfix"),oe.Refactor=oe.Empty.append("refactor"),oe.RefactorExtract=oe.Refactor.append("extract"),oe.RefactorInline=oe.Refactor.append("inline"),oe.RefactorRewrite=oe.Refactor.append("rewrite"),oe.Source=oe.Empty.append("source"),oe.SourceOrganizeImports=oe.Source.append("organizeImports"),oe.SourceFixAll=oe.Source.append("fixAll");let J=class{constructor(x,se){if(this.range=x,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};J=Ve([a],J),e.SelectionRange=J;class le{constructor(x,se,Ce,Ke,it,ot){this.kind=x,this.name=se,this.detail=Ce,this.uri=Ke,this.range=it,this.selectionRange=ot}}e.CallHierarchyItem=le;class me{constructor(x,se){this.fromRanges=se,this.from=x}}e.CallHierarchyIncomingCall=me;class Le{constructor(x,se){this.fromRanges=se,this.to=x}}e.CallHierarchyOutgoingCall=Le;let We=class{constructor(x,se){this.range=x,this.command=se}get isResolved(){return!!this.command}};We=Ve([a],We),e.CodeLens=We;let be=v=class{constructor(x,se=!1){c.set(this,void 0),rt(this,c,new C.MarkdownString(x,{supportThemeIcons:se}),"f")}static isMarkdownString(x){return x instanceof v?!0:x&&x.appendCodeblock&&x.appendMarkdown&&x.appendText&&x.value!==void 0}get value(){return Be(this,c,"f").value}set value(x){Be(this,c,"f").value=x}get isTrusted(){return Be(this,c,"f").isTrusted}set isTrusted(x){Be(this,c,"f").isTrusted=x}get supportThemeIcons(){return Be(this,c,"f").supportThemeIcons}set supportThemeIcons(x){Be(this,c,"f").supportThemeIcons=x}appendText(x){return Be(this,c,"f").appendText(x),this}appendMarkdown(x){return Be(this,c,"f").appendMarkdown(x),this}appendCodeblock(x,se){return Be(this,c,"f").appendCodeblock(se??"",x),this}};c=new WeakMap,be=v=Ve([a],be),e.MarkdownString=be;let Qe=class{constructor(x,se){this.label=x,this.documentation=se}};Qe=Ve([a],Qe),e.ParameterInformation=Qe;let K=class{constructor(x,se){this.label=x,this.documentation=se,this.parameters=[]}};K=Ve([a],K),e.SignatureInformation=K;let re=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};re=Ve([a],re),e.SignatureHelp=re;var ve;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(ve=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Fe;(function(z){z[z.Other=0]="Other",z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(Fe=e.InlayHintKind||(e.InlayHintKind={}));let Oe=class{constructor(x,se,Ce){this.text=x,this.position=se,this.kind=Ce}};Oe=Ve([a],Oe),e.InlayHint=Oe;var Xe;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var De;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(De=e.CompletionItemKind||(e.CompletionItemKind={}));var _e;(function(z){z[z.Deprecated=1]="Deprecated"})(_e=e.CompletionItemTag||(e.CompletionItemTag={}));let Pe=class{constructor(x,se){this.label=x,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&De[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Pe=Ve([a],Pe),e.CompletionItem=Pe;let ae=class{constructor(x=[],se=!1){this.items=x,this.isIncomplete=se}};ae=Ve([a],ae),e.CompletionList=ae;let he=class{constructor(x,se,Ce){this.text=x,this.range=se,this.command=Ce}};he=Ve([a],he),e.InlineSuggestion=he;let H=class{constructor(x){this.items=x}};H=Ve([a],H),e.InlineSuggestions=H;var ee;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(ee=e.ViewColumn||(e.ViewColumn={}));var ue;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(ue=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ie;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(Ie=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Te;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Te=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ue;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Ue=e.TextEditorRevealType||(e.TextEditorRevealType={}));var He;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(He=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var et;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(et=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function x(se){switch(se){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=x}(He=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Je=class{constructor(x,se){if(se&&!E.URI.isUri(se))throw R.illegalArgument("target");if(!U.isRange(x)||x.isEmpty)throw R.illegalArgument("range");this.range=x,this.target=se}};Je=Ve([a],Je),e.DocumentLink=Je;let Ye=class{constructor(x,se,Ce,Ke){this.red=x,this.green=se,this.blue=Ce,this.alpha=Ke}};Ye=Ve([a],Ye),e.Color=Ye;let nt=class{constructor(x,se){if(se&&!(se instanceof Ye))throw R.illegalArgument("color");if(!U.isRange(x)||x.isEmpty)throw R.illegalArgument("range");this.range=x,this.color=se}};nt=Ve([a],nt),e.ColorInformation=nt;let gt=class{constructor(x){if(!x||typeof x!="string")throw R.illegalArgument("label");this.label=x}};gt=Ve([a],gt),e.ColorPresentation=gt;var Ee;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Ee=e.ColorFormat||(e.ColorFormat={}));var ye;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(ye=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class de{constructor(x,se,Ce){if(this.startIndex=x,this.length=se,this.tooltip=Ce,typeof x!="number"||x<0)throw R.illegalArgument("startIndex");if(typeof se!="number"||se<1)throw R.illegalArgument("length");if(Ce!==void 0&&typeof Ce!="string")throw R.illegalArgument("tooltip")}}e.TerminalLink=de;class Q{constructor(x){this.options=x,typeof x!="object"&&R.illegalArgument("options")}}e.TerminalProfile=Q;var xe;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(xe=e.TaskRevealKind||(e.TaskRevealKind={}));var Se;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(Se=e.TaskPanelKind||(e.TaskPanelKind={}));let qe=m=class{constructor(x,se){if(typeof x!="string"||typeof se!="string")throw R.illegalArgument("name");this._id=x}static from(x){switch(x){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}get id(){return this._id}};qe.Clean=new m("clean","Clean"),qe.Build=new m("build","Build"),qe.Rebuild=new m("rebuild","Rebuild"),qe.Test=new m("test","Test"),qe=m=Ve([a],qe),e.TaskGroup=qe;function Ze(z){let x="";for(let se=0;se<z.length;se++)x+=z[se].replace(/,/g,",,")+",";return x}let tt=class{constructor(x,se,Ce){if(typeof x!="string")throw R.illegalArgument("process");this._args=[],this._process=x,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=Ce):this._options=se)}get process(){return this._process}set process(x){if(typeof x!="string")throw R.illegalArgument("process");this._process=x}get args(){return this._args}set args(x){Array.isArray(x)||(x=[]),this._args=x}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("process"),this._process!==void 0&&x.push(this._process),this._args&&this._args.length>0)for(let se of this._args)x.push(se);return Ze(x)}};tt=Ve([a],tt),e.ProcessExecution=tt;let st=class{constructor(x,se,Ce){if(this._args=[],Array.isArray(se)){if(!x)throw R.illegalArgument("command can't be undefined or null");if(typeof x!="string"&&typeof x.value!="string")throw R.illegalArgument("command");this._command=x,this._args=se,this._options=Ce}else{if(typeof x!="string")throw R.illegalArgument("commandLine");this._commandLine=x,this._options=se}}get commandLine(){return this._commandLine}set commandLine(x){if(typeof x!="string")throw R.illegalArgument("commandLine");this._commandLine=x}get command(){return this._command?this._command:""}set command(x){if(typeof x!="string"&&typeof x.value!="string")throw R.illegalArgument("command");this._command=x}get args(){return this._args}set args(x){this._args=x||[]}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("shell"),this._commandLine!==void 0&&x.push(this._commandLine),this._command!==void 0&&x.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)x.push(typeof se=="string"?se:se.value);return Ze(x)}};st=Ve([a],st),e.ShellExecution=st;var pt;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(pt=e.ShellQuoting||(e.ShellQuoting={}));var wt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(wt=e.TaskScope||(e.TaskScope={}));class Et{constructor(x){this._callback=x}computeId(){return"customExecution"+k.generateUuid()}set callback(x){this._callback=x}get callback(){return this._callback}}e.CustomExecution=Et;let vt=S=class{constructor(x,se,Ce,Ke,it,ot){this.__deprecated=!1,this._definition=this.definition=x;let lt;typeof se=="string"?(this._name=this.name=se,this._source=this.source=Ce,this.execution=Ke,lt=it,this.__deprecated=!0):se===wt.Global||se===wt.Workspace?(this.target=se,this._name=this.name=Ce,this._source=this.source=Ke,this.execution=it,lt=ot):(this.target=se,this._name=this.name=Ce,this._source=this.source=Ke,this.execution=it,lt=ot),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(x){this.__id=x}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof tt?this._definition={type:S.ProcessType,id:this._execution.computeId()}:this._execution instanceof st?this._definition={type:S.ShellType,id:this._execution.computeId()}:this._execution instanceof Et?this._definition={type:S.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:S.EmptyType,id:k.generateUuid()}}get definition(){return this._definition}set definition(x){if(x==null)throw R.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=x}get scope(){return this._scope}set target(x){this.clear(),this._scope=x}get name(){return this._name}set name(x){if(typeof x!="string")throw R.illegalArgument("name");this.clear(),this._name=x}get execution(){return this._execution}set execution(x){x===null&&(x=void 0),this.clear(),this._execution=x;const se=this._definition.type;(S.EmptyType===se||S.ProcessType===se||S.ShellType===se||S.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(x){if(Array.isArray(x))this.clear(),this._problemMatchers=x,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(x){x!==!0&&x!==!1&&(x=!1),this.clear(),this._isBackground=x}get source(){return this._source}set source(x){if(typeof x!="string"||x.length===0)throw R.illegalArgument("source must be a string of length > 0");this.clear(),this._source=x}get group(){return this._group}set group(x){x===null&&(x=void 0),this.clear(),this._group=x}get detail(){return this._detail}set detail(x){x===null&&(x=void 0),this._detail=x}get presentationOptions(){return this._presentationOptions}set presentationOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._presentationOptions=x}get runOptions(){return this._runOptions}set runOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._runOptions=x}};vt.ExtensionCallbackType="customExecution",vt.ProcessType="process",vt.ShellType="shell",vt.EmptyType="$empty",vt=S=Ve([a],vt),e.Task=vt;var xt;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(xt=e.ProgressLocation||(e.ProgressLocation={}));let _t=class{constructor(x,se=dt.None){this.collapsibleState=se,E.URI.isUri(x)?this.resourceUri=x:this.label=x}};_t=Ve([a],_t),e.TreeItem=_t;var dt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(dt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ct=class{constructor(x,se){this.id=x,this.color=se}};ct=Ve([a],ct),e.ThemeIcon=ct,ct.File=new ct("file"),ct.Folder=new ct("folder");let ht=class{constructor(x){this.id=x}};ht=Ve([a],ht),e.ThemeColor=ht;var Ht;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(Ht=e.ConfigurationTarget||(e.ConfigurationTarget={}));let kt=class{constructor(x,se){if(typeof x!="string"&&(!x||!E.URI.isUri(x)&&!E.URI.isUri(x.uri)))throw R.illegalArgument("base");if(typeof se!="string")throw R.illegalArgument("pattern");typeof x=="string"?(this.baseFolder=E.URI.file(x),this.base=x):E.URI.isUri(x)?(this.baseFolder=x,this.base=x.fsPath):(this.baseFolder=x.uri,this.base=x.uri.fsPath),this.pattern=se}};kt=Ve([a],kt),e.RelativePattern=kt;let At=class{constructor(x,se,Ce,Ke){this.enabled=typeof x=="boolean"?x:!0,typeof se=="string"&&(this.condition=se),typeof Ce=="string"&&(this.hitCondition=Ce),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=k.generateUuid()),this._id}};At=Ve([a],At),e.Breakpoint=At;let Kt=class extends At{constructor(x,se,Ce,Ke,it){super(se,Ce,Ke,it);if(x===null)throw R.illegalArgument("location");this.location=x}};Kt=Ve([a],Kt),e.SourceBreakpoint=Kt;let St=class extends At{constructor(x,se,Ce,Ke,it){super(se,Ce,Ke,it);this.functionName=x}};St=Ve([a],St),e.FunctionBreakpoint=St;let en=class extends At{constructor(x,se,Ce,Ke,it,ot,lt){super(Ke,it,ot,lt);if(!se)throw R.illegalArgument("dataId");this.label=x,this.dataId=se,this.canPersist=Ce}};en=Ve([a],en),e.DataBreakpoint=en;let tn=class{constructor(x,se,Ce){this.command=x,this.args=se||[],this.options=Ce}};tn=Ve([a],tn),e.DebugAdapterExecutable=tn;let mt=class{constructor(x,se){this.port=x,this.host=se}};mt=Ve([a],mt),e.DebugAdapterServer=mt;let Qt=class{constructor(x){this.path=x}};Qt=Ve([a],Qt),e.DebugAdapterNamedPipeServer=Qt;let zt=class{constructor(x){this.implementation=x}};zt=Ve([a],zt),e.DebugAdapterInlineImplementation=zt;let nn=class{constructor(x,se){this.range=x,this.expression=se}};nn=Ve([a],nn),e.EvaluatableExpression=nn;var _n;(function(z){z[z.Automatic=0]="Automatic",z[z.Explicit=1]="Explicit"})(_n=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Dt=class{constructor(x,se){this.range=x,this.text=se}};Dt=Ve([a],Dt),e.InlineValueText=Dt;let Xt=class{constructor(x,se,Ce=!0){this.range=x,this.variableName=se,this.caseSensitiveLookup=Ce}};Xt=Ve([a],Xt),e.InlineValueVariableLookup=Xt;let rn=class{constructor(x,se){this.range=x,this.expression=se}};rn=Ve([a],rn),e.InlineValueEvaluatableExpression=rn;let Bt=class{constructor(x,se){this.frameId=x,this.stoppedLocation=se}};Bt=Ve([a],Bt),e.InlineValueContext=Bt;var ut;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(ut=e.FileChangeType||(e.FileChangeType={}));let sn=D=class extends Error{constructor(x,se=r.FileSystemProviderErrorCode.Unknown,Ce){var Ke;super(E.URI.isUri(x)?x.toString(!0):x);this.code=(Ke=Ce==null?void 0:Ce.name)!==null&&Ke!==void 0?Ke:"Unknown",r.markAsFileSystemProviderError(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists(x){return new D(x,r.FileSystemProviderErrorCode.FileExists,D.FileExists)}static FileNotFound(x){return new D(x,r.FileSystemProviderErrorCode.FileNotFound,D.FileNotFound)}static FileNotADirectory(x){return new D(x,r.FileSystemProviderErrorCode.FileNotADirectory,D.FileNotADirectory)}static FileIsADirectory(x){return new D(x,r.FileSystemProviderErrorCode.FileIsADirectory,D.FileIsADirectory)}static NoPermissions(x){return new D(x,r.FileSystemProviderErrorCode.NoPermissions,D.NoPermissions)}static Unavailable(x){return new D(x,r.FileSystemProviderErrorCode.Unavailable,D.Unavailable)}};sn=D=Ve([a],sn),e.FileSystemError=sn;let Tt=class{constructor(x,se,Ce){this.start=x,this.end=se,this.kind=Ce}};Tt=Ve([a],Tt),e.FoldingRange=Tt;var Vt;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(Vt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hn;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(hn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Sn;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Sn=e.CommentMode||(e.CommentMode={}));class fn{constructor(x,se=[]){this.tokenTypes=x,this.tokenModifiers=se}}e.SemanticTokensLegend=fn;function yn(z){return typeof z=="undefined"||I.isStringArray(z)}class Yt{constructor(x){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,x){this._hasLegend=!0;for(let se=0,Ce=x.tokenTypes.length;se<Ce;se++)this._tokenTypeStrToInt.set(x.tokenTypes[se],se);for(let se=0,Ce=x.tokenModifiers.length;se<Ce;se++)this._tokenModifierStrToInt.set(x.tokenModifiers[se],se)}}push(x,se,Ce,Ke,it){if(typeof x=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof Ke=="number"&&(typeof it=="number"||typeof it=="undefined"))return typeof it=="undefined"&&(it=0),this._pushEncoded(x,se,Ce,Ke,it);if(U.isRange(x)&&typeof se=="string"&&yn(Ce))return this._push(x,se,Ce);throw R.illegalArgument()}_push(x,se,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(x.start.line!==x.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const Ke=x.start.line,it=x.start.character,ot=x.end.character-x.start.character,lt=this._tokenTypeStrToInt.get(se);let yt=0;if(Ce)for(const Pt of Ce){if(!this._tokenModifierStrToInt.has(Pt))throw new Error("`tokenModifier` is not in the provided legend");const Lt=this._tokenModifierStrToInt.get(Pt);yt|=1<<Lt>>>0}this._pushEncoded(Ke,it,ot,lt,yt)}_pushEncoded(x,se,Ce,Ke,it){if(this._dataIsSortedAndDeltaEncoded&&(x<this._prevLine||x===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let Pt=0,Lt=0;for(let Mt=0;Mt<yt;Mt++){let Nt=this._data[5*Mt],un=this._data[5*Mt+1];Nt===0?(Nt=Pt,un+=Lt):Nt+=Pt,this._data[5*Mt]=Nt,this._data[5*Mt+1]=un,Pt=Nt,Lt=un}}let ot=x,lt=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=it,this._prevLine=x,this._prevChar=se}static _sortAndDeltaEncode(x){let se=[];const Ce=x.length/5|0;for(let lt=0;lt<Ce;lt++)se[lt]=lt;se.sort((lt,yt)=>{const Pt=x[5*lt],Lt=x[5*yt];if(Pt===Lt){const Mt=x[5*lt+1],Nt=x[5*yt+1];return Mt-Nt}return Pt-Lt});const Ke=new Uint32Array(x.length);let it=0,ot=0;for(let lt=0;lt<Ce;lt++){const yt=5*se[lt],Pt=x[yt+0],Lt=x[yt+1],Mt=x[yt+2],Nt=x[yt+3],un=x[yt+4],On=Pt-it,Hn=On===0?Lt-ot:Lt,dn=5*lt;Ke[dn+0]=On,Ke[dn+1]=Hn,Ke[dn+2]=Mt,Ke[dn+3]=Nt,Ke[dn+4]=un,it=Pt,ot=Lt}return Ke}build(x){return this._dataIsSortedAndDeltaEncoded?new Ft(new Uint32Array(this._data),x):new Ft(Yt._sortAndDeltaEncode(this._data),x)}}e.SemanticTokensBuilder=Yt;class Ft{constructor(x,se){this.resultId=se,this.data=x}}e.SemanticTokens=Ft;class Dn{constructor(x,se,Ce){this.start=x,this.deleteCount=se,this.data=Ce}}e.SemanticTokensEdit=Dn;class on{constructor(x,se){this.resultId=se,this.edits=x}}e.SemanticTokensEdits=on;var an;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(an=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Cn;(function(z){z[z.Initial=1]="Initial",z[z.Dynamic=2]="Dynamic"})(Cn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Jt=class{constructor(){}};Jt.Back={iconPath:new ct("arrow-left")},Jt=Ve([a],Jt),e.QuickInputButtons=Jt;var jt;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(jt=e.ExtensionKind||(e.ExtensionKind={}));class kn{constructor(x,se,Ce){this.badge=x,this.tooltip=se,this.color=Ce}static validate(x){if(x.badge&&x.badge.length!==1&&x.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!x.color&&!x.badge&&!x.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=kn;let ln=class{constructor(x){this.kind=x}};ln=Ve([a],ln),e.ColorTheme=ln;var Pn;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast"})(Pn=e.ColorThemeKind||(e.ColorThemeKind={}));class qt{constructor(x,se){if(x<0)throw R.illegalArgument("start must be positive");if(se<0)throw R.illegalArgument("end must be positive");x<=se?(this._start=x,this._end=se):(this._start=se,this._end=x)}static isNotebookRange(x){return x instanceof qt?!0:x?typeof x.start=="number"&&typeof x.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(x){let se=this._start,Ce=this._end;return x.start!==void 0&&(se=x.start),x.end!==void 0&&(Ce=x.end),se===this._start&&Ce===this._end?this:new qt(se,Ce)}}e.NotebookRange=qt;class Rt{constructor(x,se,Ce,Ke,it,ot,lt){this.kind=x,this.value=se,this.languageId=Ce,this.mime=Ke,this.outputs=it??[],this.metadata=ot,this.executionSummary=lt,Rt.validate(this)}static validate(x){if(typeof x.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof x.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof x.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(x){return Array.isArray(x)&&x.every(se=>Rt.isNotebookCellData(se))}static isNotebookCellData(x){return!0}}e.NotebookCellData=Rt;class mn{constructor(x){this.cells=x}}e.NotebookData=mn;class It{constructor(x,se){this.data=x,this.mime=se;const Ce=A.normalizeMimeType(se,!0);if(!Ce)throw new Error("INVALID mime type, must not be empty or falsy: "+se);this.mime=Ce}static isNotebookCellOutputItem(x){return x instanceof It?!0:x?typeof x.mime=="string"&&x.data instanceof Uint8Array:!1}static error(x){const se={name:x.name,message:x.message,stack:x.stack};return It.json(se,"application/vnd.code.notebook.error")}static stdout(x){return It.text(x,"application/vnd.code.notebook.stdout")}static stderr(x){return It.text(x,"application/vnd.code.notebook.stderr")}static bytes(x,se="application/octet-stream"){return new It(x,se)}static text(x,se=A.Mimes.text){const Ce=Be(It,h,"f",_).encode(String(x));return new It(Ce,se)}static json(x,se="application/json"){const Ce=JSON.stringify(x,void 0,"	");return It.text(Ce,se)}}e.NotebookCellOutputItem=It,h=It,_={value:new TextEncoder};class $t{constructor(x,se,Ce){this.items=$t.ensureUniqueMimeTypes(x,!0),typeof se=="string"?(this.id=se,this.metadata=Ce):(this.id=k.generateUuid(),this.metadata=se??Ce)}static isNotebookCellOutput(x){return x instanceof $t?!0:!x||typeof x!="object"?!1:typeof x.id=="string"&&I.isArray(x.items)}static ensureUniqueMimeTypes(x,se=!1){const Ce=new Set,Ke=new Set;for(let it=0;it<x.length;it++){const ot=x[it],lt=A.normalizeMimeType(ot.mime);if(!Ce.has(lt)){Ce.add(lt);continue}Ke.add(it),se&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Ke.size===0?x:x.filter((it,ot)=>!Ke.has(ot))}}e.NotebookCellOutput=$t;var Ne;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(Ne=e.NotebookCellKind||(e.NotebookCellKind={}));var cn;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(cn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var gn;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(gn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var ft;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(ft=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class In{constructor(x,se){this.text=x,this.alignment=se}}e.NotebookCellStatusBarItem=In;var An;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(An=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class pn{constructor(x,se=[]){this.uri=x,this.provides=p.asArray(se)}}e.NotebookRendererScript=pn;let Zt=class{constructor(x,se){this.label=x,this.timestamp=se}};Zt=Ve([a],Zt),e.TimelineItem=Zt;var Tn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(Tn=e.ExtensionMode||(e.ExtensionMode={}));var Rn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(Rn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ln;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=4]="RegEx"})(Ln=e.StandardTokenType||(e.StandardTokenType={}));class Fn{constructor(x,se){this.ranges=x,this.wordPattern=se}}e.LinkedEditingRanges=Fn;class vn{constructor(x,se){this._port=x,this._autoForwardAction=se}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=vn;var Mn;(function(z){z[z.Unset=0]="Unset",z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(Mn=e.TestResultState||(e.TestResultState={}));var wn;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information",z[z.Hint=3]="Hint"})(wn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var bn;(function(z){z[z.Pending=0]="Pending",z[z.Resolved=1]="Resolved"})(bn=e.TestItemStatus||(e.TestItemStatus={}));const Ot=(z,x,se,Ce)=>{let Ke=se;return{enumerable:!0,configurable:!1,get(){return Ke},set(it){Ce(Ke,it)||(Ke=it,z.bus.fire([3,x,it]))}}},Wt=(z,x)=>z===x,ne=(z,x)=>z===x?!0:!z||!x?!1:z.isEqual(x);class fe{constructor(x,se,Ce=!1){this.tests=x,this.exclude=se,this.debug=Ce}}e.TestRunRequest=fe;class Ae{constructor(x,se,Ce,Ke,it){this.data=Ke;const ot=l.getPrivateApiFor(this);if(Object.defineProperties(this,{id:{value:x,enumerable:!0,writable:!1},uri:{value:Ce,enumerable:!0,writable:!1},parent:{enumerable:!1,value:it,writable:!1},children:{value:new y.ReadonlyMapView(ot.children),enumerable:!0,writable:!1},range:Ot(ot,"range",void 0,ne),label:Ot(ot,"label",se,Wt),description:Ot(ot,"description",void 0,Wt),runnable:Ot(ot,"runnable",!0,Wt),debuggable:Ot(ot,"debuggable",!1,Wt),status:Ot(ot,"status",bn.Resolved,Wt),error:Ot(ot,"error",void 0,Wt)}),it){if(!(it instanceof Ae))throw new Error(`The "parent" passed in for TestItem ${x} is invalid`);const lt=l.getPrivateApiFor(it);if(lt.children.has(x))throw new Error(`Attempted to insert a duplicate test item ID ${x}`);lt.children.set(x,this),lt.bus.fire([0,this])}}invalidate(){l.getPrivateApiFor(this).bus.fire([2])}dispose(){this.parent&&l.getPrivateApiFor(this.parent).children.delete(this.id),l.getPrivateApiFor(this).bus.fire([1])}}e.TestItemImpl=Ae;class at{constructor(x){this.message=x,this.severity=wn.Error}static diff(x,se,Ce){const Ke=new at(x);return Ke.expectedOutput=se,Ke.actualOutput=Ce,Ke}}e.TestMessage=at;var bt;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(bt=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Ct;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(Ct=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Wn;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(Wn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ge[119],pe([0,1,50,10,8,144,106,7,18]),function(X,e,p,R,C,y,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function r(c,h){h?k.set(c,h):k.delete(c)}e.setWordDefinitionFor=r;function P(c){return k.get(c)}e.getWordDefinitionFor=P;class l extends y.MirrorTextModel{constructor(h,_,w,b,d,u,g,t){super(_,w,b,d);this._proxy=h,this._languageId=u,this._isDirty=g,this._notebook=t,this._isDisposed=!1}dispose(){p.ok(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(h){return E.equals(this._lines,h)}get document(){if(!this._document){const h=this;this._document={get uri(){return h._uri},get fileName(){return h._uri.fsPath},get isUntitled(){return h._uri.scheme===R.Schemas.untitled},get languageId(){return h._languageId},get version(){return h._versionId},get isClosed(){return h._isDisposed},get isDirty(){return h._isDirty},get notebook(){return h._notebook},save(){return h._save()},getText(_){return _?h._getTextInRange(_):h.getText()},get eol(){return h._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return h._lines.length},lineAt(_){return h._lineAt(_)},offsetAt(_){return h._offsetAt(_)},positionAt(_){return h._positionAt(_)},validateRange(_){return h._validateRange(_)},validatePosition(_){return h._validatePosition(_)},getWordRangeAtPosition(_,w){return h._getWordRangeAtPosition(_,w)}}}return Object.freeze(this._document)}_acceptLanguageId(h){p.ok(!this._isDisposed),this._languageId=h}_acceptIsDirty(h){p.ok(!this._isDisposed),this._isDirty=h}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(h){const _=this._validateRange(h);if(_.isEmpty)return"";if(_.isSingleLine)return this._lines[_.start.line].substring(_.start.character,_.end.character);const w=this._eol,b=_.start.line,d=_.end.line,u=[];u.push(this._lines[b].substring(_.start.character));for(let g=b+1;g<d;g++)u.push(this._lines[g]);return u.push(this._lines[d].substring(0,_.end.character)),u.join(w)}_lineAt(h){let _;if(h instanceof I.Position?_=h.line:typeof h=="number"&&(_=h),typeof _!="number"||_<0||_>=this._lines.length||Math.floor(_)!==_)throw new Error("Illegal value for `line`");return new f(_,this._lines[_],_===this._lines.length-1)}_offsetAt(h){return h=this._validatePosition(h),this._ensureLineStarts(),this._lineStarts.getPrefixSum(h.line-1)+h.character}_positionAt(h){h=Math.floor(h),h=Math.max(0,h),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(h),w=this._lines[_.index].length;return new I.Position(_.index,Math.min(_.remainder,w))}_validateRange(h){if(!(h instanceof I.Range))throw new Error("Invalid argument");const _=this._validatePosition(h.start),w=this._validatePosition(h.end);return _===h.start&&w===h.end?h:new I.Range(_.line,_.character,w.line,w.character)}_validatePosition(h){if(!(h instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return h.with(0,0);let{line:_,character:w}=h,b=!1;if(_<0)_=0,w=0,b=!0;else if(_>=this._lines.length)_=this._lines.length-1,w=this._lines[_].length,b=!0;else{const d=this._lines[_].length;w<0?(w=0,b=!0):w>d&&(w=d,b=!0)}return b?new I.Position(_,w):h}_getWordRangeAtPosition(h,_){const w=this._validatePosition(h);if(!_)_=P(this._languageId);else if(C.regExpLeadsToEndlessLoop(_))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${_.source}' because it matches the empty string.`);const b=A.getWordAtText(w.character+1,A.ensureValidWordDefinition(_),this._lines[w.line],0);if(b)return new I.Range(w.line,b.startColumn-1,w.line,b.endColumn-1)}}e.ExtHostDocumentData=l;class f{constructor(h,_,w){this._line=h,this._text=_,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(ge[194],pe([0,1,7,3,108,6,76,23,2,32]),function(X,e,p,R,C,y,A,I,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class r{constructor(l,f,c,h){this._notebook=c,this._selector=h,this._disposables=new y.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=E.URI.from({scheme:"vscode-concat-doc",path:k.generateUuid()}),this._init(),this._disposables.add(f.onDidChangeDocument(w=>{const b=this._cellUris.get(w.document.uri);b!==void 0&&(this._cellLengths.changeValue(b,this._cells[b].document.getText().length+1),this._cellLines.changeValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const _=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(w=>_(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const l=[],f=[];for(const c of this._notebook.getCells())c.kind===p.NotebookCellKind.Code&&(!this._selector||A.score(this._selector,c.document.uri,c.document.languageId,!0))&&(this._cellUris.set(c.document.uri,this._cells.length),this._cells.push(c),l.push(c.document.getText().length+1),f.push(c.document.lineCount));this._cellLengths=new C.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new C.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(l){var f,c;if(!l){let d="";for(const u of this._cells)d+=u.document.getText()+`
`;return d=d.slice(0,-1),d}if(l.isEmpty)return"";const h=this.locationAt(l.start),_=this.locationAt(l.end),w=this._cells[(f=this._cellUris.get(h.uri))!==null&&f!==void 0?f:-1],b=this._cells[(c=this._cellUris.get(_.uri))!==null&&c!==void 0?c:-1];if(!w||!b)return"";if(w===b)return w.document.getText(new p.Range(h.range.start,_.range.end));{const d=w.document.getText(new p.Range(h.range.start,new p.Position(w.document.lineCount,0))),u=b.document.getText(new p.Range(new p.Position(0,0),_.range.end));return d+`
`+u}}offsetAt(l){const f=this._cellLines.getIndexOf(l.line),c=this._cellLengths.getPrefixSum(f.index-1),h=this._cells[f.index].document.offsetAt(l.with(f.remainder));return c+h}positionAt(l){if(typeof l=="number"){const c=this._cellLengths.getIndexOf(l),h=this._cellLines.getPrefixSum(c.index-1);return this._cells[c.index].document.positionAt(c.remainder).translate(h)}const f=this._cellUris.get(l.uri);if(f!==void 0){const c=this._cellLines.getPrefixSum(f-1);return new p.Position(c+l.range.start.line,l.range.start.character)}return new p.Position(0,0)}locationAt(l){p.Range.isRange(l)||(l=new p.Range(l,l));const f=this._cellLines.getIndexOf(l.start.line);let c=f;l.isEmpty||(c=this._cellLines.getIndexOf(l.end.line));const h=new p.Position(f.remainder,l.start.character),_=new p.Position(c.remainder,l.end.character),w=new p.Range(h,_),b=this._cells[f.index];return new p.Location(b.document.uri,b.document.validateRange(w))}contains(l){return this._cellUris.has(l)}validateRange(l){const f=this.validatePosition(l.start),c=this.validatePosition(l.end);return l.with(f,c)}validatePosition(l){const f=this._cellLines.getIndexOf(l.line),c=new p.Position(f.remainder,l.character),h=this._cells[f.index].document.validatePosition(c),_=this._cellLines.getPrefixSum(f.index-1);return new p.Position(_+h.line,h.character)}}e.ExtHostNotebookConcatDocument=r}),define(ge[195],pe([0,1,7,13,3]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let y=class{constructor(I){this._actual=new p.ColorTheme(p.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new C.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let E=I==="light"?p.ColorThemeKind.Light:I==="dark"?p.ColorThemeKind.Dark:p.ColorThemeKind.HighContrast;this._actual=new p.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};y=Ve([$e(0,R.IExtHostRpcService)],y),e.ExtHostTheming=y}),define(ge[60],pe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=p.createDecorator("IURITransformerService");class R{constructor(y){y?(this.transformIncoming=y.transformIncoming.bind(y),this.transformOutgoing=y.transformOutgoing.bind(y),this.transformOutgoingURI=y.transformOutgoingURI.bind(y),this.transformOutgoingScheme=y.transformOutgoingScheme.bind(y)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=R}),define(ge[196],pe([0,1,22]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(E){let k=this.buffers.indexOf(E);return k<0&&(k=this.buffers.length,this.buffers.push(E)),k}}function C(I,E){if(E.serializeBuffersForPostMessage){const k=new R,r=(f,c)=>{if(c instanceof ArrayBuffer){const h=k.add(c);return{$$vscode_array_buffer_reference$$:!0,index:h}}else if(ArrayBuffer.isView(c)){const h=y(c);if(h){const _=k.add(c.buffer);return{$$vscode_array_buffer_reference$$:!0,index:_,view:{type:h,byteLength:c.byteLength,byteOffset:c.byteOffset}}}}return c},P=JSON.stringify(I,r),l=k.buffers.map(f=>{const c=new Uint8Array(f);return p.VSBuffer.wrap(c)});return{message:P,buffers:l}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=C;function y(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(I,E){const k=E.map(l=>{const f=new ArrayBuffer(l.byteLength);return new Uint8Array(f).set(l.buffer),f}),r=E.length?(l,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const c=f,{index:h}=c,_=k[h];if(c.view)switch(c.view.type){case 1:return new Int8Array(_,c.view.byteOffset,c.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(_,c.view.byteOffset,c.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(_,c.view.byteOffset,c.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(_,c.view.byteOffset,c.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(_,c.view.byteOffset,c.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(_,c.view.byteOffset,c.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(_,c.view.byteOffset,c.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(_,c.view.byteOffset,c.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(_,c.view.byteOffset,c.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(_,c.view.byteOffset,c.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(_,c.view.byteOffset,c.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return _}return f}:void 0;return{message:JSON.parse(I,r),arrayBuffers:k}}e.deserializeWebviewMessage=A}),define(ge[83],pe([0,1,10,2]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function C(y,A){return y.scheme===p.Schemas.http||y.scheme===p.Schemas.https?y:(A&&A.authority&&A.isRemote&&y.scheme===p.Schemas.file&&(y=R.URI.from({scheme:p.Schemas.vscodeRemote,authority:A.authority,path:y.path})),R.URI.from({scheme:p.Schemas.https,authority:`${y.scheme}+${y.authority}.${e.webviewRootResourceAuthority}`,path:y.path,fragment:y.fragment,query:y.query}))}e.asWebviewUri=C}),define(ge[197],pe([0,1,3,6,83]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(I,E,k){this._proxy=I,this._editors=E,this._initData=k,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(E.onDidChangeVisibleTextEditors(()=>{const r=E.getVisibleTextEditors();for(const P of this._insets.values())r.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,E,k,r,P){let l;for(const d of this._editors.getVisibleTextEditors(!0))if(d.value===I){l=d;break}if(!l)throw new Error("not a visible editor");const f=this,c=this._handlePool++,h=new p.Emitter,_=new p.Emitter,w=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(d){return C.asWebviewUri(d,f._initData.remote)}get cspSource(){return C.webviewGenericCspSource}set options(d){this._options=d,f._proxy.$setOptions(c,d)}get options(){return this._options}set html(d){this._html=d,f._proxy.$setHtml(c,d)}get html(){return this._html}get onDidReceiveMessage(){return h.event}postMessage(d){return f._proxy.$postMessage(c,d)}},b=new class{constructor(){this.editor=I,this.line=E,this.height=k,this.webview=w,this.onDidDispose=_.event}dispose(){f._insets.has(c)&&(f._insets.delete(c),f._proxy.$disposeEditorInset(c),_.fire(),_.dispose(),h.dispose())}};return this._proxy.$createEditorInset(c,l.id,l.value.document.uri,E+1,k,r||{},P.identifier,P.extensionLocation),this._insets.set(c,{editor:I,inset:b,onDidReceiveMessage:h}),b}$onDidDispose(I){const E=this._insets.get(I);E&&E.inset.dispose()}$onDidReceiveMessage(I,E){const k=this._insets.get(I);k&&k.onDidReceiveMessage.fire(E)}}e.ExtHostEditorInsets=y}),define(ge[120],pe([0,1,3,16,166]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class y{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new p.Emitter,this._onExit=new p.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,E,k,r){const P={command:I};if(E&&Object.keys(E).length>0&&(P.arguments=E),this.internalSend("request",P),typeof r=="number"){const l=setTimeout(()=>{clearTimeout(l);const f=this.pendingRequests.get(P.seq);if(f){this.pendingRequests.delete(P.seq);const c={type:"response",seq:0,request_seq:P.seq,success:!1,command:I,message:C.localize(0,null,r,I)};f(c)}},r)}return k&&this.pendingRequests.set(P.seq,k),P.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,E){return I.type!=="event"||E.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await R.timeout(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback&&this.eventCallback(I);break;case"request":this.requestCallback&&this.requestCallback(I);break;case"response":const E=I,k=this.pendingRequests.get(E.request_seq);k&&(this.pendingRequests.delete(E.request_seq),k(E));break}}}internalSend(I,E){E.type=I,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((E,k)=>I.set(k,E)),await R.timeout(500),I.forEach((E,k)=>{E({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=y}),define(ge[198],pe([0,1,8,2,9,25,10]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function E(i,s,n){return i.replace(I,function(o,v){return s&&v.length>0&&v[0]!=="_"?o:n&&n.hasOwnProperty(v)?n[v]:o})}e.formatPII=E;function k(i){const s={};for(const n of Object.keys(i))n.startsWith("!")||(s[n]=i[n]);return s}e.filterExceptionsFromTelemetry=k;function r(i){return i.configuration.request==="attach"&&!P(i)&&(!i.parentSession||r(i.parentSession))}e.isSessionAttach=r;function P(i){let s=i.configuration.type;if(!!s)return s==="vslsShare"&&(s=i.configuration.adapterProxy.configuration.type),p.equalsIgnoreCase(s,"extensionhost")||p.equalsIgnoreCase(s,"pwa-extensionhost")?i:i.parentSession?P(i.parentSession):void 0}e.getExtensionHostDebugSession=P;function l(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=l;function f(i,s,n){let o,v=0,m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,S=null;for(;S=m.exec(i);){let D=S.index+1,a=D+S[0].length;if(D<=s&&a>=n){o=S[0],v=D;break}}if(o){let D=/\w+/g,a=null;for(;(a=D.exec(o))&&!(a.index+1+v+a[0].length>=n););a&&(o=o.substring(0,D.lastIndex))}return o?{start:v,end:v+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(i){return!!(i&&i.match(c))}e.isUri=h;function _(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(h(i.path))return R.URI.parse(i.path);if(C.isAbsolute(i.path))return R.URI.file(i.path)}return i.path}function w(i){if(typeof i.path=="object"){const s=R.URI.revive(i.path);if(s)return s.scheme===A.Schemas.file?s.fsPath:s.toString()}return i.path}function b(i,s){const n=s?_:w,o=y.deepClone(i);return u(o,(v,m)=>{v&&m&&(m.path=n(m))}),o}e.convertToDAPaths=b;function d(i,s){const n=s?_:w,o=y.deepClone(i);return u(o,(v,m)=>{!v&&m&&(m.path=n(m))}),o}e.convertToVSCPaths=d;function u(i,s){switch(i.type){case"event":const n=i;switch(n.event){case"output":s(!1,n.body.source);break;case"loadedSource":s(!1,n.body.source);break;case"breakpoint":s(!1,n.body.breakpoint.source);break;default:break}break;case"request":const o=i;switch(o.command){case"setBreakpoints":s(!0,o.arguments.source);break;case"breakpointLocations":s(!0,o.arguments.source);break;case"source":s(!0,o.arguments.source);break;case"gotoTargets":s(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(m=>s(!1,m));break;default:break}break;case"response":const v=i;if(v.success&&v.body)switch(v.command){case"stackTrace":v.body.stackFrames.forEach(m=>s(!1,m.source));break;case"loadedSources":v.body.sources.forEach(m=>s(!1,m));break;case"scopes":v.body.scopes.forEach(m=>s(!1,m.source));break;case"setFunctionBreakpoints":v.body.breakpoints.forEach(m=>s(!1,m.source));break;case"setBreakpoints":v.body.breakpoints.forEach(m=>s(!1,m.source));break;default:break}break}}function g(i){return i.filter(s=>{var n;return!((n=s.presentation)===null||n===void 0?void 0:n.hidden)}).sort((s,n)=>s.presentation?n.presentation?s.presentation.group?n.presentation.group?s.presentation.group!==n.presentation.group?s.presentation.group.localeCompare(n.presentation.group):t(s.presentation.order,n.presentation.order):-1:n.presentation.group?1:t(s.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=g;function t(i,s){return typeof i!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:i-s}}),define(ge[199],pe([0,1,28,38,167,121,9,8,25,11,177,120]),function(X,e,p,R,C,y,A,I,E,k,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class l extends P.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,d){this.outputStream=d,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",u=>this.handleData(u))}sendMessage(b){if(this.outputStream){const d=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(d,"utf8")}${l.TWO_CRLF}${d}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const d=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,d.length>0)try{this.acceptMessage(JSON.parse(d))}catch(u){this._onError.fire(new Error((u.message||u)+`
`+d))}continue}}else{const d=this.rawData.indexOf(l.TWO_CRLF);if(d!==-1){const g=this.rawData.toString("utf8",0,d).split(l.HEADER_LINESEPARATOR);for(const t of g){const i=t.split(l.HEADER_FIELDSEPARATOR);i[0]==="Content-Length"&&(this.contentLength=Number(i[1]))}this.rawData=this.rawData.slice(d+l.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=l,l.TWO_CRLF=`\r
\r
`,l.HEADER_LINESEPARATOR=/\r?\n/,l.HEADER_FIELDSEPARATOR=/: */;class f extends l{startSession(){return new Promise((b,d)=>{let u=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),u=!0}),this.socket.on("close",()=>{u?this._onError.fire(new Error("connection closed")):d(new Error("connection closed"))}),this.socket.on("error",g=>{u?this._onError.fire(g):d(g)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=f;class c extends f{constructor(b){super();this.adapterServer=b}createConnection(b){return y.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=c;class h extends f{constructor(b){super();this.adapterServer=b}createConnection(b){return y.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=h;class _ extends l{constructor(b,d,u){super();this.adapterExecutable=b,this.debugType=d,this.outputService=u}async startSession(){const b=this.adapterExecutable.command,d=this.adapterExecutable.args,u=this.adapterExecutable.options||{};try{if(b)if(A.isAbsolute(b)){if(!await p.Promises.exists(b))throw new Error(C.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.debugType));let g=process.env;if(u.env&&Object.keys(u.env).length>0&&(g=E.mixin(E.deepClone(process.env),u.env)),b==="node")if(Array.isArray(d)&&d.length>0){const i=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:g,execArgv:i?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};u.cwd&&(s.cwd=u.cwd);const n=R.fork(d[0],d.slice(1),s);if(!n.pid)throw new Error(C.localize(2,null,d[0]));this.serverProcess=n}else throw new Error(C.localize(3,null));else{const i={env:g};u.cwd&&(i.cwd=u.cwd),this.serverProcess=R.spawn(b,d,i)}this.serverProcess.on("error",i=>{this._onError.fire(i)}),this.serverProcess.on("exit",(i,s)=>{this._onExit.fire(i)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",i=>{this._onError.fire(i)}),this.serverProcess.stdin.on("error",i=>{this._onError.fire(i)});const t=this.outputService;if(t){const i=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const n=t.getChannel(r.ExtensionsChannelId);n&&n.append(i(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(g){this._onError.fire(g)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),k.isWindows?new Promise((b,d)=>{const u=R.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(g,t,i){if(g)return d(g)});u.on("exit",b),u.on("error",d)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,d){if(!b)return;const u=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?u.runtime=A.join(d,b.runtime):u.runtime=b.runtime),b.runtimeArgs&&(u.runtimeArgs=b.runtimeArgs),b.program&&(A.isAbsolute(b.program)?u.program=b.program:u.program=A.join(d,b.program)),b.args&&(u.args=b.args);const g=b;return g.win&&(u.win=_.extract(g.win,d)),g.winx86&&(u.winx86=_.extract(g.winx86,d)),g.windows&&(u.windows=_.extract(g.windows,d)),g.osx&&(u.osx=_.extract(g.osx,d)),g.linux&&(u.linux=_.extract(g.linux,d)),u}static platformAdapterExecutable(b,d){let u=Object.create(null);d=d.toLowerCase();for(const o of b)if(o.contributes){const v=o.contributes.debuggers;v&&v.length>0&&v.filter(m=>typeof m.type=="string"&&I.equalsIgnoreCase(m.type,d)).forEach(m=>{const S=_.extract(m,o.extensionLocation.fsPath);u=E.mixin(u,S,o.isBuiltin)})}let g;k.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=u.winx86||u.win||u.windows:k.isWindows?g=u.win||u.windows:k.isMacintosh?g=u.osx:k.isLinux&&(g=u.linux),g=g||u;let t=g.program||u.program;const i=g.args||u.args;let s=g.runtime||u.runtime;const n=g.runtimeArgs||u.runtimeArgs;if(s)return{type:"executable",command:s,args:(n||[]).concat(typeof t=="string"?[t]:[]).concat(i||[])};if(t)return{type:"executable",command:t,args:i||[]}}}e.ExecutableDebugAdapter=_}),define(ge[200],pe([0,1,38,11,29,180]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function A(l,f){return new Promise((c,h)=>{let _="";const w=p.spawn(l,f);w.pid&&w.stdout.on("data",b=>{_+=b.toString()}),w.on("error",b=>{h(b)}),w.on("close",b=>{c(_)})})}let I;function E(l,f){if(!I)if(R.isWindows)I=new y.WindowsExternalTerminalService;else if(R.isMacintosh)I=new y.MacExternalTerminalService;else if(R.isLinux)I=new y.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const c=f.getConfiguration("terminal");return I.runInTerminal(l.title,l.cwd,l.args,l.env||{},c.external||{})}e.runInExternalTerminal=E;function k(l){return l?R.isWindows?new Promise(async f=>{(await new Promise((h,_)=>{X(["windows-process-tree"],h,_)})).getProcessTree(l,h=>{f(h.children.length>0)})}):A("/usr/bin/pgrep",["-lP",String(l)]).then(f=>{const c=f.trim();return!(c.length===0||c.indexOf(" tmux")>=0)},f=>!0):Promise.resolve(!0)}e.hasChildProcesses=k;var r;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(r||(r={}));function P(l,f,c,h){l=l.trim().toLowerCase();let _;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?_=1:l.indexOf("cmd.exe")>=0?_=0:l.indexOf("bash")>=0?_=2:R.isWindows?_=0:_=2;let w,b=" ";switch(_){case 1:if(w=u=>(u=u.replace(/\'/g,"''"),u.length>0&&u.charAt(u.length-1)==="\\"?`'${u}\\'`:`'${u}'`),c){const u=C.getDriveLetter(c);u&&(b+=`${u}:; `),b+=`cd ${w(c)}; `}if(h)for(let u in h){const g=h[u];g===null?b+=`Remove-Item env:${u}; `:b+=`\${env:${u}}='${g}'; `}if(f.length>0){const u=w(f.shift());b+=u[0]==="'"?`& ${u} `:`${u} `;for(let g of f)b+=`${w(g)} `}break;case 0:if(w=u=>(u=u.replace(/\"/g,'""'),u.indexOf(" ")>=0||u.indexOf('"')>=0||u.length===0?`"${u}"`:u),c){const u=C.getDriveLetter(c);u&&(b+=`${u}: && `),b+=`cd ${w(c)} && `}if(h){b+='cmd /C "';for(let u in h){let g=h[u];g===null?b+=`set "${u}=" && `:(g=g.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),b+=`set "${u}=${g}" && `)}}for(let u of f)b+=`${w(u)} `;h&&(b+='"');break;case 2:w=u=>(u=u.replace(/(["'\\\$])/g,"\\$1"),u.indexOf(" ")>=0||u.indexOf(";")>=0||u.length===0?`"${u}"`:u);const d=u=>/[^\w@%\/+=,.:^-]/.test(u)?`'${u.replace(/'/g,"'\\''")}'`:u;if(c&&(b+=`cd ${w(c)} ; `),h){b+="/usr/bin/env";for(let u in h){const g=h[u];g===null?b+=` -u ${d(u)}`:b+=` ${d(`${u}=${g}`)}`}b+=" "}for(let u of f)b+=`${w(u)} `;break}return b}e.prepareCommand=P}),define(ge[84],pe([0,1,30,97,10,9,11,111]),function(X,e,p,R,C,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var E;(function(a){a[a.Markup=1]="Markup",a[a.Code=2]="Code"})(E=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(a){a[a.Running=1]="Running",a[a.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var r;(function(a){a[a.Pending=2]="Pending",a[a.Executing=3]="Executing"})(r=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var P;(function(a){a[a.WithHardKernelDependency=0]="WithHardKernelDependency",a[a.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",a[a.Pure=2]="Pure",a[a.Never=3]="Never"})(P=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var l;(function(a){a.Always="always",a.Never="never",a.Optional="optional"})(l=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(a){a[a.ModelChange=1]="ModelChange",a[a.Move=2]="Move",a[a.ChangeLanguage=5]="ChangeLanguage",a[a.Initialize=6]="Initialize",a[a.ChangeCellMetadata=7]="ChangeCellMetadata",a[a.Output=8]="Output",a[a.OutputItem=9]="OutputItem",a[a.ChangeCellContent=10]="ChangeCellContent",a[a.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",a[a.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",a[a.ChangeCellMime=13]="ChangeCellMime",a[a.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(a){a[a.Handle=0]="Handle",a[a.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(a){a[a.Replace=1]="Replace",a[a.Output=2]="Output",a[a.Metadata=3]="Metadata",a[a.CellLanguage=4]="CellLanguage",a[a.DocumentMetadata=5]="DocumentMetadata",a[a.Move=6]="Move",a[a.OutputItems=7]="OutputItems",a[a.PartialMetadata=8]="PartialMetadata",a[a.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var _;(function(a){a.scheme=C.Schemas.vscodeNotebookCell;const T=/^ch(\d{7,})/;function L(N,W){return N.with({scheme:a.scheme,fragment:`ch${W.toString().padStart(7,"0")}${N.scheme!==C.Schemas.file?N.scheme:""}`})}a.generate=L;function U(N){if(N.scheme!==a.scheme)return;const W=T.exec(N.fragment);return W?{handle:Number(W[1]),notebook:N.with({scheme:N.fragment.substr(W[0].length)||C.Schemas.file,fragment:null})}:void 0}a.parse=U;function G(N){if(N.scheme!==C.Schemas.vscodeNotebookCellMetadata)return;const W=T.exec(N.fragment);return W?{handle:Number(W[1]),notebook:N.with({scheme:N.fragment.substr(W[0].length)||C.Schemas.file,fragment:null})}:void 0}a.parseCellMetadataUri=G;function te(N,W,M){return N.with({scheme:M,fragment:`ch${W.toString().padStart(7,"0")}${N.scheme!==C.Schemas.file?N.scheme:""}`})}a.generateCellUri=te;function V(N,W){if(N.scheme!==W)return;const M=T.exec(N.fragment);return M?{handle:Number(M[1]),notebook:N.with({scheme:N.fragment.substr(M[0].length)||C.Schemas.file,fragment:null})}:void 0}a.parseCellUri=V})(_=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function b(a){var T,L;return(L=(T=w.get(a))===null||T===void 0?void 0:T.alwaysSecure)!==null&&L!==void 0?L:!1}e.mimeTypeIsAlwaysSecure=b;function d(a){var T,L;return(L=(T=w.get(a))===null||T===void 0?void 0:T.supportedByCore)!==null&&L!==void 0?L:!1}e.mimeTypeSupportedByCore=d;function u(a){var T,L;return(L=(T=w.get(a))===null||T===void 0?void 0:T.mergeable)!==null&&L!==void 0?L:!1}e.mimeTypeIsMergeable=u;function g(a,T){return A.isWindows&&(a=a.replace(/\//g,"\\"),T=T.replace(/\//g,"\\")),p.match(a,T)}function t(a,T,L){let U=0;for(let G=0;G<T.length;G++){if(g(T[G],a))return U;U++}for(let G=0;G<L.length;G++){if(g(L[G],a))return U;U++}return U}function i(a,T,L){return a.sort((U,G)=>t(U,T,L)-t(G,T,L))}e.sortMimeTypes=i;function s(a,T,L,U=(G,te)=>G===te){const G=[];function te(W,M,q){if(M===0&&q.length===0)return;const O=G[G.length-1];O&&O.start+O.deleteCount===W?(O.deleteCount+=M,O.toInsert.push(...q)):G.push({start:W,deleteCount:M,toInsert:q})}let V=0,N=0;for(;;){if(V===a.length){te(V,0,T.slice(N));break}if(N===T.length){te(V,a.length-V,[]);break}const W=a[V],M=T[N];if(U(W,M)){V+=1,N+=1;continue}L(M)?(te(V,1,[]),V+=1):(te(V,0,[M]),N+=1)}return G}e.diff=s,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(a){a.default="default",a.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(a){const T=a;return!!((typeof T.include=="string"||p.isRelativePattern(T.include))&&(typeof T.exclude=="string"||p.isRelativePattern(T.exclude)))}e.isDocumentExcludePattern=o;function v(a,T,L){if(Array.isArray(a.viewType)&&a.viewType.indexOf(T)>=0||a.viewType===T)return!0;if(a.filenamePattern){let U=o(a.filenamePattern)?a.filenamePattern.include:a.filenamePattern,G=o(a.filenamePattern)?a.filenamePattern.exclude:void 0;if(p.match(U,y.basename(L.fsPath).toLowerCase()))return!(G&&p.match(G,y.basename(L.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=v;class m{constructor(T){this.textModel=T}getElements(){const T=new Int32Array(this.textModel.cells.length);for(let L=0;L<this.textModel.cells.length;L++)T[L]=this.textModel.cells[L].getHashValue();return T}}e.CellSequence=m,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var S;(function(a){a[a.Left=1]="Left",a[a.Right=2]="Right"})(S=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class D{static create(T){return`${D._prefix}${T}`}static parse(T){if(T.startsWith(D._prefix))return T.substr(D._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=D,D._prefix="notebook/"}),define(ge[201],pe([0,1,169,4,111]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new C.RawContextKey("customExecutionSupported",!0,p.localize(0,null)),e.ShellExecutionSupportedContext=new C.RawContextKey("shellExecutionSupported",!1,p.localize(1,null)),e.ProcessExecutionSupportedContext=new C.RawContextKey("processExecutionSupported",!1,p.localize(2,null)),e.ITaskService=R.createDecorator("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ge[202],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function p(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=p;function R(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=R}),define(ge[122],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=e.identifyTest=void 0;const p=E=>({testId:E.item.extId,controllerId:E.controllerId});e.identifyTest=p;var R;(function(E){E[E.NotExpandable=0]="NotExpandable",E[E.Expandable=1]="Expandable",E[E.BusyExpanding=2]="BusyExpanding",E[E.Expanded=3]="Expanded"})(R=e.TestItemExpandState||(e.TestItemExpandState={}));const C=(E,k)=>{k.expand!==void 0&&(E.expand=k.expand),k.item!==void 0&&(E.item=E.item?Object.assign(E.item,k.item):k.item)};e.applyTestItemUpdate=C;var y;(function(E){E[E.Add=0]="Add",E[E.Update=1]="Update",E[E.Remove=2]="Remove",E[E.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",E[E.Retire=4]="Retire"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class A{add(k){}update(k){}remove(k,r){}complete(){}}e.IncrementalChangeCollector=A;class I{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(k){const r=this.createChangeCollector();for(const P of k)switch(P[0]){case 0:{const l=P[1];if(l.parent){if(this.items.has(l.parent)){const f=this.items.get(l.parent);f.children.add(l.item.extId);const c=this.createItem(l,f);this.items.set(l.item.extId,c),r.add(c)}}else{const f=this.createItem(l);this.roots.add(f),this.items.set(l.item.extId,f),r.add(f)}l.expand===2&&this.busyControllerCount++;break}case 1:{const l=P[1],f=this.items.get(l.extId);if(!f)break;l.expand!==void 0&&(f.expand===2&&this.busyControllerCount--,l.expand===2&&this.busyControllerCount++),e.applyTestItemUpdate(f,l),r.update(f);break}case 2:{const l=this.items.get(P[1]);if(!l)break;l.parent?this.items.get(l.parent).children.delete(l.item.extId):this.roots.delete(l);const f=[[P[1]]];for(;f.length;)for(const c of f.pop()){const h=this.items.get(c);h&&(f.push(h.children),this.items.delete(c),r.remove(h,h!==l),h.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(P[1]);break;case 3:this.updatePendingRoots(P[1]);break}r.complete()}retireTest(k){}updatePendingRoots(k){this.pendingRootCount+=k}createChangeCollector(){return new A}}e.AbstractIncrementalTestCollection=I}),define(ge[203],pe([0,1,9,37,15,25,11,75,170]),function(X,e,p,R,C,y,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(P,l,f){this._contributedVariables=new Map,this._context=P,this._labelService=l,f&&(this._envVariablesPromise=f.then(c=>this.prepareEnv(c)))}prepareEnv(P){if(A.isWindows){const l=Object.create(null);return Object.keys(P).forEach(f=>{l[f.toLowerCase()]=P[f]}),l}return P}resolveWithEnvironment(P,l,f){return this.recursiveResolve(this.prepareEnv(P),l?l.uri:void 0,f)}async resolveAsync(P,l){return this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,l)}async resolveAnyBase(P,l,f,c){const h=y.deepClone(l);return A.isWindows&&h.windows?Object.keys(h.windows).forEach(_=>h[_]=h.windows[_]):A.isMacintosh&&h.osx?Object.keys(h.osx).forEach(_=>h[_]=h.osx[_]):A.isLinux&&h.linux&&Object.keys(h.linux).forEach(_=>h[_]=h.linux[_]),delete h.windows,delete h.osx,delete h.linux,this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,h,f,c)}async resolveAnyAsync(P,l,f){return this.resolveAnyBase(P,l,f)}async resolveAnyMap(P,l,f){const c=new Map;return{newConfig:await this.resolveAnyBase(P,l,f,c),resolvedVariables:c}}resolveWithInteractionReplace(P,l,f,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,l,f,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,l){if(this._contributedVariables.has(P))throw new Error("Variable "+P+" is contributed twice.");this._contributedVariables.set(P,l)}recursiveResolve(P,l,f,c,h){if(C.isString(f))return this.resolveString(P,l,f,c,h);if(C.isArray(f))return f.map(_=>this.recursiveResolve(P,l,_,c,h));if(C.isObject(f)){let _=Object.create(null);return Object.keys(f).forEach(w=>{const b=this.resolveString(P,l,w,c,h);_[b]=this.recursiveResolve(P,l,f[w],c,h)}),_}return f}resolveString(P,l,f,c,h){return f.replace(k.VARIABLE_REGEXP,(w,b)=>{if(b.includes(k.VARIABLE_LHS))return w;let d=this.evaluateSingleVariable(P,w,b,l,c);return h&&h.set(b,d),d!==w&&C.isString(d)&&d.match(k.VARIABLE_REGEXP)&&(d=this.resolveString(P,l,d,c,h)),d})}fsPath(P){return this._labelService?this._labelService.getUriLabel(P,{noPrefix:!0}):P.fsPath}evaluateSingleVariable(P,l,f,c,h){let _;const w=f.split(":");w.length>1&&(f=w[0],_=w[1]);const b=()=>{const g=this._context.getFilePath();if(g)return g;throw new Error(E.localize(0,null,l))},d=()=>{const g=b();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error(E.localize(1,null,l,p.basename(g)))},u=()=>{if(_){const g=this._context.getFolderUri(_);if(g)return g;throw new Error(E.localize(2,null,l,_))}if(c)return c;throw this._context.getWorkspaceFolderCount()>1?new Error(E.localize(3,null,l)):new Error(E.localize(4,null,l))};switch(f){case"env":if(_){if(P){const g=P[A.isWindows?_.toLowerCase():_];if(C.isString(g))return g}return""}throw new Error(E.localize(5,null,l));case"config":if(_){const g=this._context.getConfigurationValue(c,_);if(C.isUndefinedOrNull(g))throw new Error(E.localize(6,null,l,_));if(C.isObject(g))throw new Error(E.localize(7,null,l,_));return g}throw new Error(E.localize(8,null,l));case"command":return this.resolveFromMap(l,_,h,"command");case"input":return this.resolveFromMap(l,_,h,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return I.normalizeDriveLetter(this.fsPath(u()));case"cwd":return c||_?I.normalizeDriveLetter(this.fsPath(u())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return p.basename(this.fsPath(u()));case"lineNumber":const g=this._context.getLineNumber();if(g)return g;throw new Error(E.localize(9,null,l));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error(E.localize(10,null,l));case"file":return b();case"fileWorkspaceFolder":return d();case"relativeFile":return c||_?p.relative(this.fsPath(u()),b()):b();case"relativeFileDirname":const i=p.dirname(b());if(c||_){const v=p.relative(this.fsPath(u()),i);return v.length===0?".":v}return i;case"fileDirname":return p.dirname(b());case"fileExtname":return p.extname(b());case"fileBasename":return p.basename(b());case"fileBasenameNoExtension":const s=p.basename(b());return s.slice(0,s.length-p.extname(s).length);case"fileDirnameBasename":return p.basename(p.dirname(b()));case"execPath":const n=this._context.getExecPath();return n||l;case"execInstallFolder":const o=this._context.getAppRoot();return o||l;case"pathSeparator":return p.sep;default:try{const v=_?`${f}:${_}`:f;return this.resolveFromMap(l,v,h,void 0)}catch(v){return l}}}}resolveFromMap(P,l,f,c){if(l&&f){const h=c===void 0?f[l]:f[c+":"+l];if(typeof h=="string")return h;throw new Error(E.localize(11,null,P))}return P}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ge[204],pe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=p.createDecorator("editorGroupsService");var R;(function(l){l[l.UP=0]="UP",l[l.DOWN=1]="DOWN",l[l.LEFT=2]="LEFT",l[l.RIGHT=3]="RIGHT"})(R=e.GroupDirection||(e.GroupDirection={}));var C;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(l){l[l.FIRST=0]="FIRST",l[l.LAST=1]="LAST",l[l.NEXT=2]="NEXT",l[l.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var A;(function(l){l[l.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",l[l.EVEN=1]="EVEN",l[l.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var I;(function(l){l[l.COPY_EDITORS=0]="COPY_EDITORS",l[l.MOVE_EDITORS=1]="MOVE_EDITORS"})(I=e.MergeGroupMode||(e.MergeGroupMode={}));var E;(function(l){l[l.CREATION_TIME=0]="CREATION_TIME",l[l.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",l[l.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(E=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(l){l[l.GROUP_ACTIVE=0]="GROUP_ACTIVE",l[l.GROUP_INDEX=1]="GROUP_INDEX",l[l.EDITOR_OPEN=2]="EDITOR_OPEN",l[l.EDITOR_CLOSE=3]="EDITOR_CLOSE",l[l.EDITOR_MOVE=4]="EDITOR_MOVE",l[l.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",l[l.EDITOR_LABEL=6]="EDITOR_LABEL",l[l.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",l[l.EDITOR_PIN=8]="EDITOR_PIN",l[l.EDITOR_STICKY=9]="EDITOR_STICKY",l[l.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var r;(function(l){l[l.NEW_EDITOR=1]="NEW_EDITOR",l[l.MOVE_EDITOR=2]="MOVE_EDITOR",l[l.COPY_EDITOR=3]="COPY_EDITOR"})(r=e.OpenEditorContext||(e.OpenEditorContext={}));function P(l){return l.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=P}),define(ge[205],pe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=p.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ge[17],pe([0,1,18,94,278,55,25,15,2,40,78,171,113,84,205,7]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var _;(function(Ee){function ye(Q){const{selectionStartLineNumber:xe,selectionStartColumn:Se,positionLineNumber:qe,positionColumn:Ze}=Q,tt=new h.Position(xe-1,Se-1),st=new h.Position(qe-1,Ze-1);return new h.Selection(tt,st)}Ee.to=ye;function de(Q){const{anchor:xe,active:Se}=Q;return{selectionStartLineNumber:xe.line+1,selectionStartColumn:xe.character+1,positionLineNumber:Se.line+1,positionColumn:Se.character+1}}Ee.from=de})(_=e.Selection||(e.Selection={}));var w;(function(Ee){function ye(Q){if(!Q)return;const{start:xe,end:Se}=Q;return{startLineNumber:xe.line+1,startColumn:xe.character+1,endLineNumber:Se.line+1,endColumn:Se.character+1}}Ee.from=ye;function de(Q){if(!Q)return;const{startLineNumber:xe,startColumn:Se,endLineNumber:qe,endColumn:Ze}=Q;return new h.Range(xe-1,Se-1,qe-1,Ze-1)}Ee.to=de})(w=e.Range||(e.Range={}));var b;(function(Ee){function ye(de){switch(de){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 4:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}Ee.to=ye})(b=e.TokenType||(e.TokenType={}));var d;(function(Ee){function ye(Q){return new h.Position(Q.lineNumber-1,Q.column-1)}Ee.to=ye;function de(Q){return{lineNumber:Q.line+1,column:Q.character+1}}Ee.from=de})(d=e.Position||(e.Position={}));var u;(function(Ee){function ye(Q){switch(Q){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}Ee.from=ye;function de(Q){switch(Q){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}Ee.to=de})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var g;(function(Ee){function ye(Q){let xe;return Q.code&&(I.isString(Q.code)||I.isNumber(Q.code)?xe=String(Q.code):xe={value:String(Q.code.value),target:Q.code.target}),Object.assign(Object.assign({},w.from(Q.range)),{message:Q.message,source:Q.source,code:xe,severity:i.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(t.from),tags:Array.isArray(Q.tags)?p.coalesce(Q.tags.map(u.from)):void 0})}Ee.from=ye;function de(Q){var xe;const Se=new h.Diagnostic(w.to(Q),Q.message,i.to(Q.severity));return Se.source=Q.source,Se.code=I.isString(Q.code)?Q.code:(xe=Q.code)===null||xe===void 0?void 0:xe.value,Se.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(t.to),Se.tags=Q.tags&&p.coalesce(Q.tags.map(u.to)),Se}Ee.to=de})(g=e.Diagnostic||(e.Diagnostic={}));var t;(function(Ee){function ye(Q){return Object.assign(Object.assign({},w.from(Q.location.range)),{message:Q.message,resource:Q.location.uri})}Ee.from=ye;function de(Q){return new h.DiagnosticRelatedInformation(new h.Location(Q.resource,w.to(Q)),Q.message)}Ee.to=de})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(Ee){function ye(Q){switch(Q){case h.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}Ee.from=ye;function de(Q){switch(Q){case l.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}Ee.to=de})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(Ee){function ye(Q){return typeof Q=="number"&&Q>=h.ViewColumn.One?Q-1:Q===h.ViewColumn.Beside?c.SIDE_GROUP:c.ACTIVE_GROUP}Ee.from=ye;function de(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=de})(s=e.ViewColumn||(e.ViewColumn={}));function n(Ee){return typeof Ee.range!="undefined"}function o(Ee){return Ee.length===0?!0:!!n(Ee[0])}e.isDecorationOptionsArr=o;var v;(function(Ee){function ye(Ze){return Ze.map(Ee.from)}Ee.fromMany=ye;function de(Ze){return Ze&&typeof Ze=="object"&&typeof Ze.language=="string"&&typeof Ze.value=="string"}function Q(Ze){let tt;if(de(Ze)){const{language:Et,value:vt}=Ze;tt={value:"```"+Et+`
`+vt+"\n```\n"}}else h.MarkdownString.isMarkdownString(Ze)?tt={value:Ze.value,isTrusted:Ze.isTrusted,supportThemeIcons:Ze.supportThemeIcons}:typeof Ze=="string"?tt={value:Ze}:tt={value:""};const st=Object.create(null);tt.uris=st;const pt=Et=>{try{let vt=E.URI.parse(Et,!0);vt=vt.with({query:xe(vt.query,st)}),st[Et]=vt}catch(vt){}return""},wt=new C.Renderer;return wt.link=pt,wt.image=Et=>pt(R.parseHrefAndDimensions(Et).href),C(tt.value,{renderer:wt}),tt}Ee.from=Q;function xe(Ze,tt){if(!Ze)return Ze;let st;try{st=y.parse(Ze)}catch(wt){}if(!st)return Ze;let pt=!1;return st=A.cloneAndChange(st,wt=>{if(E.URI.isUri(wt)){const Et=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[Et]=wt,pt=!0,Et}else return}),pt?JSON.stringify(st):Ze}function Se(Ze){const tt=new h.MarkdownString(Ze.value,Ze.supportThemeIcons);return tt.isTrusted=Ze.isTrusted,tt}Ee.to=Se;function qe(Ze){if(!!Ze)return typeof Ze=="string"?Ze:Ee.from(Ze)}Ee.fromStrict=qe})(v=e.MarkdownString||(e.MarkdownString={}));function m(Ee){return o(Ee)?Ee.map(ye=>({range:w.from(ye.range),hoverMessage:Array.isArray(ye.hoverMessage)?v.fromMany(ye.hoverMessage):ye.hoverMessage?v.from(ye.hoverMessage):void 0,renderOptions:ye.renderOptions})):Ee.map(ye=>({range:w.from(ye)}))}e.fromRangeOrRangeWithMessage=m;function S(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?E.URI.file(Ee):Ee}e.pathOrURIToURI=S;var D;(function(Ee){function ye(de){return typeof de=="undefined"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?S(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}Ee.from=ye})(D=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var a;(function(Ee){function ye(de){return typeof de=="undefined"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?S(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?D.from(de.before):void 0,after:de.after?D.from(de.after):void 0}}Ee.from=ye})(a=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var T;(function(Ee){function ye(de){if(typeof de=="undefined")return de;switch(de){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=ye})(T=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(Ee){function ye(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?T.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?a.from(de.light):void 0,dark:de.dark?a.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?S(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?D.from(de.before):void 0,after:de.after?D.from(de.after):void 0}}Ee.from=ye})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var U;(function(Ee){function ye(Q){return{text:Q.newText,eol:Q.newEol&&K.from(Q.newEol),range:w.from(Q.range)}}Ee.from=ye;function de(Q){const xe=new h.TextEdit(w.to(Q.range),Q.text);return xe.newEol=typeof Q.eol=="undefined"?void 0:K.to(Q.eol),xe}Ee.to=de})(U=e.TextEdit||(e.TextEdit={}));var G;(function(Ee){function ye(Q,xe,Se){var qe,Ze;const tt={edits:[]};if(Q instanceof h.WorkspaceEdit)for(let st of Q._allEntries())if(st._type===1)tt.edits.push({_type:1,oldUri:st.from,newUri:st.to,options:st.options,metadata:st.metadata});else if(st._type===2){const pt=xe==null?void 0:xe.getDocument(st.uri);tt.edits.push({_type:2,resource:st.uri,edit:U.from(st.edit),modelVersionId:pt==null?void 0:pt.version,metadata:st.metadata})}else st._type===3?tt.edits.push({_type:3,metadata:st.metadata,resource:st.uri,edit:st.edit,notebookMetadata:st.notebookMetadata,notebookVersionId:(qe=Se==null?void 0:Se.getNotebookDocument(st.uri,!0))===null||qe===void 0?void 0:qe.apiNotebook.version}):st._type===5&&tt.edits.push({_type:3,metadata:st.metadata,resource:st.uri,notebookVersionId:(Ze=Se==null?void 0:Se.getNotebookDocument(st.uri,!0))===null||Ze===void 0?void 0:Ze.apiNotebook.version,edit:{editType:1,index:st.index,count:st.count,cells:st.cells.map(H.from)}});return tt}Ee.from=ye;function de(Q){const xe=new h.WorkspaceEdit;for(const Se of Q.edits)Se.edit?xe.replace(E.URI.revive(Se.resource),w.to(Se.edit.range),Se.edit.text):xe.renameFile(E.URI.revive(Se.oldUri),E.URI.revive(Se.newUri),Se.options);return xe}Ee.to=de})(G=e.WorkspaceEdit||(e.WorkspaceEdit={}));var te;(function(Ee){const ye=Object.create(null);ye[h.SymbolKind.File]=0,ye[h.SymbolKind.Module]=1,ye[h.SymbolKind.Namespace]=2,ye[h.SymbolKind.Package]=3,ye[h.SymbolKind.Class]=4,ye[h.SymbolKind.Method]=5,ye[h.SymbolKind.Property]=6,ye[h.SymbolKind.Field]=7,ye[h.SymbolKind.Constructor]=8,ye[h.SymbolKind.Enum]=9,ye[h.SymbolKind.Interface]=10,ye[h.SymbolKind.Function]=11,ye[h.SymbolKind.Variable]=12,ye[h.SymbolKind.Constant]=13,ye[h.SymbolKind.String]=14,ye[h.SymbolKind.Number]=15,ye[h.SymbolKind.Boolean]=16,ye[h.SymbolKind.Array]=17,ye[h.SymbolKind.Object]=18,ye[h.SymbolKind.Key]=19,ye[h.SymbolKind.Null]=20,ye[h.SymbolKind.EnumMember]=21,ye[h.SymbolKind.Struct]=22,ye[h.SymbolKind.Event]=23,ye[h.SymbolKind.Operator]=24,ye[h.SymbolKind.TypeParameter]=25;function de(xe){return typeof ye[xe]=="number"?ye[xe]:6}Ee.from=de;function Q(xe){for(const Se in ye)if(ye[Se]===xe)return Number(Se);return h.SymbolKind.Property}Ee.to=Q})(te=e.SymbolKind||(e.SymbolKind={}));var V;(function(Ee){function ye(Q){switch(Q){case h.SymbolTag.Deprecated:return 1}}Ee.from=ye;function de(Q){switch(Q){case 1:return h.SymbolTag.Deprecated}}Ee.to=de})(V=e.SymbolTag||(e.SymbolTag={}));var N;(function(Ee){function ye(Q){return{name:Q.name,kind:te.from(Q.kind),tags:Q.tags&&Q.tags.map(V.from),containerName:Q.containerName,location:F.from(Q.location)}}Ee.from=ye;function de(Q){const xe=new h.SymbolInformation(Q.name,te.to(Q.kind),Q.containerName,F.to(Q.location));return xe.tags=Q.tags&&Q.tags.map(V.to),xe}Ee.to=de})(N=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var W;(function(Ee){function ye(Q){var xe,Se;const qe={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:w.from(Q.range),selectionRange:w.from(Q.selectionRange),kind:te.from(Q.kind),tags:(Se=(xe=Q.tags)===null||xe===void 0?void 0:xe.map(V.from))!==null&&Se!==void 0?Se:[]};return Q.children&&(qe.children=Q.children.map(ye)),qe}Ee.from=ye;function de(Q){const xe=new h.DocumentSymbol(Q.name,Q.detail,te.to(Q.kind),w.to(Q.range),w.to(Q.selectionRange));return p.isNonEmptyArray(Q.tags)&&(xe.tags=Q.tags.map(V.to)),Q.children&&(xe.children=Q.children.map(de)),xe}Ee.to=de})(W=e.DocumentSymbol||(e.DocumentSymbol={}));var M;(function(Ee){function ye(de){const Q=new h.CallHierarchyItem(te.to(de.kind),de.name,de.detail||"",E.URI.revive(de.uri),w.to(de.range),w.to(de.selectionRange));return Q._sessionId=de._sessionId,Q._itemId=de._itemId,Q}Ee.to=ye})(M=e.CallHierarchyItem||(e.CallHierarchyItem={}));var q;(function(Ee){function ye(de){return new h.CallHierarchyIncomingCall(M.to(de.from),de.fromRanges.map(Q=>w.to(Q)))}Ee.to=ye})(q=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var O;(function(Ee){function ye(de){return new h.CallHierarchyOutgoingCall(M.to(de.to),de.fromRanges.map(Q=>w.to(Q)))}Ee.to=ye})(O=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var F;(function(Ee){function ye(Q){return{range:Q.range&&w.from(Q.range),uri:Q.uri}}Ee.from=ye;function de(Q){return new h.Location(E.URI.revive(Q.uri),w.to(Q.range))}Ee.to=de})(F=e.location||(e.location={}));var B;(function(Ee){function ye(Q){const xe=Q,Se=Q;return{originSelectionRange:xe.originSelectionRange?w.from(xe.originSelectionRange):void 0,uri:xe.targetUri?xe.targetUri:Se.uri,range:w.from(xe.targetRange?xe.targetRange:Se.range),targetSelectionRange:xe.targetSelectionRange?w.from(xe.targetSelectionRange):void 0}}Ee.from=ye;function de(Q){return{targetUri:E.URI.revive(Q.uri),targetRange:w.to(Q.range),targetSelectionRange:Q.targetSelectionRange?w.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?w.to(Q.originSelectionRange):void 0}}Ee.to=de})(B=e.DefinitionLink||(e.DefinitionLink={}));var $;(function(Ee){function ye(Q){return{range:w.from(Q.range),contents:v.fromMany(Q.contents)}}Ee.from=ye;function de(Q){return new h.Hover(Q.contents.map(v.to),w.to(Q.range))}Ee.to=de})($=e.Hover||(e.Hover={}));var Y;(function(Ee){function ye(Q){return{range:w.from(Q.range),expression:Q.expression}}Ee.from=ye;function de(Q){return new h.EvaluatableExpression(w.to(Q.range),Q.expression)}Ee.to=de})(Y=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ce;(function(Ee){function ye(Q){if(Q instanceof h.InlineValueText)return{type:"text",range:w.from(Q.range),text:Q.text};if(Q instanceof h.InlineValueVariableLookup)return{type:"variable",range:w.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof h.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=ye;function de(Q){switch(Q.type){case"text":return{range:w.to(Q.range),text:Q.text};case"variable":return{range:w.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:w.to(Q.range),expression:Q.expression}}}Ee.to=de})(ce=e.InlineValue||(e.InlineValue={}));var we;(function(Ee){function ye(Q){return{frameId:Q.frameId,stoppedLocation:w.from(Q.stoppedLocation)}}Ee.from=ye;function de(Q){return new h.InlineValueContext(Q.frameId,w.to(Q.stoppedLocation))}Ee.to=de})(we=e.InlineValueContext||(e.InlineValueContext={}));var Re;(function(Ee){function ye(Q){return{range:w.from(Q.range),kind:Q.kind}}Ee.from=ye;function de(Q){return new h.DocumentHighlight(w.to(Q.range),Q.kind)}Ee.to=de})(Re=e.DocumentHighlight||(e.DocumentHighlight={}));var ke;(function(Ee){function ye(de){switch(de){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}Ee.to=ye})(ke=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Me;(function(Ee){function ye(de){return{triggerKind:ke.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}Ee.to=ye})(Me=e.CompletionContext||(e.CompletionContext={}));var Ge;(function(Ee){function ye(Q){switch(Q){case h.CompletionItemTag.Deprecated:return 1}}Ee.from=ye;function de(Q){switch(Q){case 1:return h.CompletionItemTag.Deprecated}}Ee.to=de})(Ge=e.CompletionItemTag||(e.CompletionItemTag={}));var ze;(function(Ee){const ye=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function de(Se){var qe;return(qe=ye.get(Se))!==null&&qe!==void 0?qe:9}Ee.from=de;const Q=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function xe(Se){var qe;return(qe=Q.get(Se))!==null&&qe!==void 0?qe:h.CompletionItemKind.Property}Ee.to=xe})(ze=e.CompletionItemKind||(e.CompletionItemKind={}));var je;(function(Ee){function ye(de,Q){var xe;const Se=new h.CompletionItem(de.label);return Se.insertText=de.insertText,Se.kind=ze.to(de.kind),Se.tags=(xe=de.tags)===null||xe===void 0?void 0:xe.map(Ge.to),Se.detail=de.detail,Se.documentation=R.isMarkdownString(de.documentation)?v.to(de.documentation):de.documentation,Se.sortText=de.sortText,Se.filterText=de.filterText,Se.preselect=de.preselect,Se.commitCharacters=de.commitCharacters,k.Range.isIRange(de.range)?Se.range=w.to(de.range):typeof de.range=="object"&&(Se.range={inserting:w.to(de.range.insert),replacing:w.to(de.range.replace)}),Se.keepWhitespace=typeof de.insertTextRules=="undefined"?!1:Boolean(de.insertTextRules&1),typeof de.insertTextRules!="undefined"&&de.insertTextRules&4?Se.insertText=new h.SnippetString(de.insertText):(Se.insertText=de.insertText,Se.textEdit=Se.range instanceof h.Range?new h.TextEdit(Se.range,Se.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Se.additionalTextEdits=de.additionalTextEdits.map(qe=>U.to(qe))),Se.command=Q&&de.command?Q.fromInternal(de.command):void 0,Se}Ee.to=ye})(je=e.CompletionItem||(e.CompletionItem={}));var j;(function(Ee){function ye(Q){return{label:Q.label,documentation:Q.documentation?v.fromStrict(Q.documentation):void 0}}Ee.from=ye;function de(Q){return{label:Q.label,documentation:R.isMarkdownString(Q.documentation)?v.to(Q.documentation):Q.documentation}}Ee.to=de})(j=e.ParameterInformation||(e.ParameterInformation={}));var Z;(function(Ee){function ye(Q){return{label:Q.label,documentation:Q.documentation?v.fromStrict(Q.documentation):void 0,parameters:Array.isArray(Q.parameters)?Q.parameters.map(j.from):[],activeParameter:Q.activeParameter}}Ee.from=ye;function de(Q){return{label:Q.label,documentation:R.isMarkdownString(Q.documentation)?v.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(j.to):[],activeParameter:Q.activeParameter}}Ee.to=de})(Z=e.SignatureInformation||(e.SignatureInformation={}));var ie;(function(Ee){function ye(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(Z.from):[]}}Ee.from=ye;function de(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(Z.to):[]}}Ee.to=de})(ie=e.SignatureHelp||(e.SignatureHelp={}));var oe;(function(Ee){function ye(Q){var xe;return{text:Q.text,position:d.from(Q.position),kind:J.from((xe=Q.kind)!==null&&xe!==void 0?xe:h.InlayHintKind.Other),whitespaceBefore:Q.whitespaceBefore,whitespaceAfter:Q.whitespaceAfter}}Ee.from=ye;function de(Q){const xe=new h.InlayHint(Q.text,d.to(Q.position),J.to(Q.kind));return xe.whitespaceAfter=Q.whitespaceAfter,xe.whitespaceBefore=Q.whitespaceBefore,xe}Ee.to=de})(oe=e.InlayHint||(e.InlayHint={}));var J;(function(Ee){function ye(Q){return Q}Ee.from=ye;function de(Q){return Q}Ee.to=de})(J=e.InlayHintKind||(e.InlayHintKind={}));var le;(function(Ee){function ye(Q){return{range:w.from(Q.range),url:Q.target,tooltip:Q.tooltip}}Ee.from=ye;function de(Q){let xe;if(Q.url)try{xe=typeof Q.url=="string"?E.URI.parse(Q.url,!0):E.URI.revive(Q.url)}catch(Se){}return new h.DocumentLink(w.to(Q.range),xe)}Ee.to=de})(le=e.DocumentLink||(e.DocumentLink={}));var me;(function(Ee){function ye(Q){const xe=new h.ColorPresentation(Q.label);return Q.textEdit&&(xe.textEdit=U.to(Q.textEdit)),Q.additionalTextEdits&&(xe.additionalTextEdits=Q.additionalTextEdits.map(Se=>U.to(Se))),xe}Ee.to=ye;function de(Q){return{label:Q.label,textEdit:Q.textEdit?U.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(xe=>U.from(xe)):void 0}}Ee.from=de})(me=e.ColorPresentation||(e.ColorPresentation={}));var Le;(function(Ee){function ye(Q){return new h.Color(Q[0],Q[1],Q[2],Q[3])}Ee.to=ye;function de(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}Ee.from=de})(Le=e.Color||(e.Color={}));var We;(function(Ee){function ye(Q){return{range:w.from(Q.range)}}Ee.from=ye;function de(Q){return new h.SelectionRange(w.to(Q.range))}Ee.to=de})(We=e.SelectionRange||(e.SelectionRange={}));var be;(function(Ee){function ye(de){switch(de){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}Ee.to=ye})(be=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Qe;(function(Ee){function ye(Q){switch(Q){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=ye;function de(Q){switch(Q){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 1:default:return h.TextEditorLineNumbersStyle.On}}Ee.to=de})(Qe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var K;(function(Ee){function ye(Q){if(Q===h.EndOfLine.CRLF)return 1;if(Q===h.EndOfLine.LF)return 0}Ee.from=ye;function de(Q){if(Q===1)return h.EndOfLine.CRLF;if(Q===0)return h.EndOfLine.LF}Ee.to=de})(K=e.EndOfLine||(e.EndOfLine={}));var re;(function(Ee){function ye(de){if(typeof de=="object")return de.viewId;switch(de){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=ye})(re=e.ProgressLocation||(e.ProgressLocation={}));var ve;(function(Ee){function ye(de){const Q={start:de.start+1,end:de.end+1};return de.kind&&(Q.kind=Fe.from(de.kind)),Q}Ee.from=ye})(ve=e.FoldingRange||(e.FoldingRange={}));var Fe;(function(Ee){function ye(de){if(de)switch(de){case h.FoldingRangeKind.Comment:return r.FoldingRangeKind.Comment;case h.FoldingRangeKind.Imports:return r.FoldingRangeKind.Imports;case h.FoldingRangeKind.Region:return r.FoldingRangeKind.Region}}Ee.from=ye})(Fe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Oe;(function(Ee){function ye(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?w.from(de.selection):void 0,override:typeof de.override=="boolean"?P.EditorOverride.DISABLED:void 0}}Ee.from=ye})(Oe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Xe;(function(Ee){function ye(Q){return Q instanceof h.RelativePattern||typeof Q=="string"?Q:de(Q)?new h.RelativePattern(Q.base,Q.pattern):Q}Ee.from=ye;function de(Q){const xe=Q;return xe&&typeof xe.base=="string"&&typeof xe.pattern=="string"}})(Xe=e.GlobPattern||(e.GlobPattern={}));var De;(function(Ee){function ye(de){if(de){if(Array.isArray(de))return de.map(ye);if(typeof de=="string")return de;{const Q=de;return{language:Q.language,scheme:Q.scheme,pattern:typeof Q.pattern=="undefined"?void 0:Xe.from(Q.pattern),exclusive:Q.exclusive}}}else return}Ee.from=ye})(De=e.LanguageSelector||(e.LanguageSelector={}));var _e;(function(Ee){function ye(Q){return{start:Q.start,end:Q.end}}Ee.from=ye;function de(Q){return new h.NotebookRange(Q.start,Q.end)}Ee.to=de})(_e=e.NotebookRange||(e.NotebookRange={}));var Pe;(function(Ee){function ye(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}Ee.to=ye;function de(Q){var xe,Se;return{lastRunSuccess:Q.success,runStartTime:(xe=Q.timing)===null||xe===void 0?void 0:xe.startTime,runEndTime:(Se=Q.timing)===null||Se===void 0?void 0:Se.endTime,executionOrder:Q.executionOrder}}Ee.from=de})(Pe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var ae;(function(Ee){function ye(Q){switch(Q){case h.NotebookCellKind.Markup:return f.CellKind.Markup;case h.NotebookCellKind.Code:default:return f.CellKind.Code}}Ee.from=ye;function de(Q){switch(Q){case f.CellKind.Markup:return h.NotebookCellKind.Markup;case f.CellKind.Code:default:return h.NotebookCellKind.Code}}Ee.to=de})(ae=e.NotebookCellKind||(e.NotebookCellKind={}));var he;(function(Ee){function ye(Q){var xe;const Se={metadata:(xe=Q.metadata)!==null&&xe!==void 0?xe:Object.create(null),cells:[]};for(let qe of Q.cells)h.NotebookCellData.validate(qe),Se.cells.push(H.from(qe));return Se}Ee.from=ye;function de(Q){const xe=new h.NotebookData(Q.cells.map(H.to));return I.isEmptyObject(Q.metadata)||(xe.metadata=Q.metadata),xe}Ee.to=de})(he=e.NotebookData||(e.NotebookData={}));var H;(function(Ee){function ye(Q){var xe;return{cellKind:ae.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:Pe.from((xe=Q.executionSummary)!==null&&xe!==void 0?xe:{}),outputs:Q.outputs?Q.outputs.map(ue.from):[]}}Ee.from=ye;function de(Q){return new h.NotebookCellData(ae.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(ue.to):void 0,Q.metadata,Q.internalMetadata?Pe.to(Q.internalMetadata):void 0)}Ee.to=de})(H=e.NotebookCellData||(e.NotebookCellData={}));var ee;(function(Ee){function ye(Q){return{mime:Q.mime,valueBytes:Array.from(Q.data)}}Ee.from=ye;function de(Q){return new h.NotebookCellOutputItem(new Uint8Array(Q.valueBytes),Q.mime)}Ee.to=de})(ee=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ue;(function(Ee){function ye(Q){return{outputId:Q.id,items:Q.items.map(ee.from),metadata:Q.metadata}}Ee.from=ye;function de(Q){const xe=Q.items.map(ee.to);return new h.NotebookCellOutput(xe,Q.outputId,Q.metadata)}Ee.to=de})(ue=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ie;(function(Ee){function ye(Se){if(Se!=null){if(Se instanceof h.RelativePattern||typeof Se=="string")return Se;if(xe(Se))return new h.RelativePattern(Se.base,Se.pattern);if(Q(Se))return{include:Xe.from(Se.include)||void 0,exclude:Xe.from(Se.exclude)||void 0}}}Ee.from=ye;function de(Se){return typeof Se=="string"?Se:xe(Se)?{base:Se.base,pattern:Se.pattern}:{include:Se.include,exclude:Se.exclude}}Ee.to=de;function Q(Se){const qe=Se,Ze=Xe.from(qe.include);if(!(Ze&&Ze instanceof h.RelativePattern||typeof Ze=="string"))return!1;const tt=Xe.from(qe.exclude);return!!(tt&&tt instanceof h.RelativePattern||typeof tt=="string")}function xe(Se){const qe=Se;return qe&&typeof qe.base=="string"&&typeof qe.pattern=="string"}})(Ie=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Te;(function(Ee){function ye(de){return{backgroundColor:de.backgroundColor,borderColor:de.borderColor,top:de.top?D.from(de.top):void 0}}Ee.from=ye})(Te=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ue;(function(Ee){function ye(de,Q,xe){const Se=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===h.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(Se,xe),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}Ee.from=ye})(Ue=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var He;(function(Ee){function ye(de){var Q,xe,Se;return{transientOutputs:(Q=de==null?void 0:de.transientOutputs)!==null&&Q!==void 0?Q:!1,transientCellMetadata:(xe=de==null?void 0:de.transientCellMetadata)!==null&&xe!==void 0?xe:{},transientDocumentMetadata:(Se=de==null?void 0:de.transientDocumentMetadata)!==null&&Se!==void 0?Se:{}}}Ee.from=ye})(He=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var et;(function(Ee){function ye(Q){return{uri:Q.uri,provides:Q.provides}}Ee.from=ye;function de(Q){return new h.NotebookRendererScript(E.URI.revive(Q.uri),Q.provides)}Ee.to=de})(et=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Je;(function(Ee){function ye(Q){return{message:v.fromStrict(Q.message)||"",severity:Q.severity,expectedOutput:Q.expectedOutput,actualOutput:Q.actualOutput,location:Q.location?F.from(Q.location):void 0}}Ee.from=ye;function de(Q){const xe=new h.TestMessage(typeof Q.message=="string"?Q.message:v.to(Q.message));return xe.severity=Q.severity,xe.actualOutput=Q.actualOutput,xe.expectedOutput=Q.expectedOutput,xe}Ee.to=de})(Je=e.TestMessage||(e.TestMessage={}));var Ye;(function(Ee){function ye(qe){var Ze,tt;return{extId:qe.id,label:qe.label,uri:qe.uri,range:w.from(qe.range)||null,debuggable:(Ze=qe.debuggable)!==null&&Ze!==void 0?Ze:!1,description:qe.description||null,runnable:(tt=qe.runnable)!==null&&tt!==void 0?tt:!0,error:qe.error&&v.fromStrict(qe.error)||null}}Ee.from=ye;function de(qe){return{extId:qe.id,label:qe.label,uri:qe.uri,range:w.from(qe.range)||null,debuggable:!1,description:qe.description||null,error:null,runnable:!0}}Ee.fromResultSnapshot=de;function Q(qe){return{id:qe.extId,label:qe.label,uri:E.URI.revive(qe.uri),range:w.to(qe.range||void 0),dispose:()=>{},status:h.TestItemStatus.Pending,data:void 0,debuggable:qe.debuggable,description:qe.description||void 0,runnable:qe.runnable}}Ee.toPlain=Q;function xe(qe,Ze){const tt=new h.TestItemImpl(qe.extId,qe.label,E.URI.revive(qe.uri),void 0,Ze);return tt.range=w.to(qe.range||void 0),tt.debuggable=qe.debuggable,tt.description=qe.description||void 0,tt.runnable=qe.runnable,tt}Ee.to=xe;function Se(qe){let Ze;for(const tt of qe.tests)Ze=xe(tt.item,Ze);return Ze}Ee.toItemFromContext=Se})(Ye=e.TestItem||(e.TestItem={}));var nt;(function(Ee){const ye=(Q,xe)=>Object.assign(Object.assign({},Ye.toPlain(Q.item)),{taskStates:Q.tasks.map(Se=>({state:Se.state,duration:Se.duration,messages:Se.messages.map(Je.to)})),children:Q.children.map(Se=>xe.get(Se)).filter(I.isDefined).map(Se=>ye(Se,xe))});function de(Q){const xe=[],Se=new Map;for(const qe of Q.items)Se.set(qe.item.extId,qe),qe.direct&&xe.push(qe);return{completedAt:Q.completedAt,results:xe.map(qe=>ye(qe,Se))}}Ee.to=de})(nt=e.TestResults||(e.TestResults={}));var gt;(function(Ee){function ye(de){switch(de){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}Ee.to=ye})(gt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ge[206],pe([0,1,2,14,7,17,71]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(k,r,P,l={timeout:1500,errors:3}){this._logService=k,this._documents=r,this._mainThreadBulkEdits=P,this._thresholds=l,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(r,P,l)=>{const c={dispose:this._callbacks.push([r,P,k])};return Array.isArray(l)&&l.push(c),c}}async $participateInSave(k,r){const P=p.URI.revive(k);let l=!1;const f=setTimeout(()=>l=!0,this._thresholds.timeout),c=[];try{for(let h of[...this._callbacks]){if(l)break;const _=this._documents.getDocument(P),w=await this._deliverEventAsyncAndBlameBadListeners(h,{document:_,reason:y.TextDocumentSaveReason.to(r)});c.push(w)}}finally{clearTimeout(f)}return c}_deliverEventAsyncAndBlameBadListeners([k,r,P],l){const f=this._badListeners.get(k);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,k,r,l).then(()=>!0,c=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(c),!(c instanceof Error)||c.message!=="concurrent_edits"){const h=this._badListeners.get(k);this._badListeners.set(k,h?h+1:1),typeof h=="number"&&h>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,r,P,l){const f=[],c=Date.now(),{document:h,reason:_}=l,{version:w}=h,b=Object.freeze({document:h,reason:_,waitUntil(d){if(Object.isFrozen(f))throw R.illegalState("waitUntil can not be called async");f.push(Promise.resolve(d))}});try{r.apply(P,[b])}catch(d){return Promise.reject(d)}return Object.freeze(f),new Promise((d,u)=>{const g=setTimeout(()=>u(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(g),d(t)}).catch(t=>{clearTimeout(g),u(t)})}).then(d=>{const u={edits:[]};for(const g of d)if(Array.isArray(g)&&g.every(t=>t instanceof C.TextEdit))for(const{newText:t,newEol:i,range:s}of g)u.edits.push({_type:2,resource:h.uri,edit:{range:s&&y.Range.from(s),text:t,eol:i&&y.EndOfLine.from(i)}});if(u.edits.length!==0)return w===h.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(ge[207],pe([0,1,3,16,30,2,17,7]),function(X,e,p,R,C,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class E{constructor(P,l,f,c,h){this._onDidCreate=new p.Emitter,this._onDidChange=new p.Emitter,this._onDidDelete=new p.Emitter,this._config=0,f&&(this._config+=1),c&&(this._config+=2),h&&(this._config+=4);const _=C.parse(l),w=P(b=>{if(!f)for(let d of b.created){const u=y.URI.revive(d);_(u.fsPath)&&this._onDidCreate.fire(u)}if(!c)for(let d of b.changed){const u=y.URI.revive(d);_(u.fsPath)&&this._onDidChange.fire(u)}if(!h)for(let d of b.deleted){const u=y.URI.revive(d);_(u.fsPath)&&this._onDidDelete.fire(u)}});this._disposable=I.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(P,l,f){this._logService=l,this._extHostDocumentsAndEditors=f,this._onFileSystemEvent=new p.Emitter,this._onDidRenameFile=new p.Emitter,this._onDidCreateFile=new p.Emitter,this._onDidDeleteFile=new p.Emitter,this._onWillRenameFile=new R.AsyncEmitter,this._onWillCreateFile=new R.AsyncEmitter,this._onWillDeleteFile=new R.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(P,l,f,c){return new E(this._onFileSystemEvent.event,P,l,f,c)}$onFileEvent(P){this._onFileSystemEvent.fire(P)}$onDidRunFileOperation(P,l){switch(P){case 2:this._onDidRenameFile.fire(Object.freeze({files:l.map(f=>({oldUri:y.URI.revive(f.source),newUri:y.URI.revive(f.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:l.map(f=>y.URI.revive(f.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:l.map(f=>y.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(P){return this._createWillExecuteEvent(P,this._onWillRenameFile)}getOnWillCreateFileEvent(P){return this._createWillExecuteEvent(P,this._onWillCreateFile)}getOnWillDeleteFileEvent(P){return this._createWillExecuteEvent(P,this._onWillDeleteFile)}_createWillExecuteEvent(P,l){return(f,c,h)=>{const _=function(b){f.call(c,b)};return _.extension=P,l.event(_,void 0,h)}}async $onWillRunFileOperation(P,l,f,c){switch(P){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:l.map(h=>({oldUri:y.URI.revive(h.source),newUri:y.URI.revive(h.target)}))},f,c);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:l.map(h=>y.URI.revive(h.target))},f,c);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:l.map(h=>y.URI.revive(h.target))},f,c)}}async _fireWillEvent(P,l,f,c){const h=new Set,_=[];if(await P.fireAsync(l,c,async(b,d)=>{var u;const g=Date.now(),t=await Promise.resolve(b);t instanceof I.WorkspaceEdit&&(_.push(t),h.add((u=d.extension.displayName)!==null&&u!==void 0?u:d.extension.identifier.value)),Date.now()-g>f&&this._logService.warn("SLOW file-participant",d.extension.identifier)}),c.isCancellationRequested||_.length===0)return;const w={edits:[]};for(let b of _){let{edits:d}=A.WorkspaceEdit.from(b,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(d)}return{edit:w,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=k}),define(ge[208],pe([0,1,10,25,2,17,7,84]),function(X,e,p,R,C,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class E{constructor(l,f,c,h){this.start=l,this.deletedCount=f,this.deletedItems=c,this.items=h}static asApiEvents(l){return l.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(c=>c.apiCell)}))}}class k{constructor(l,f,c){var h,_,w;this.notebook=l,this._extHostDocument=f,this._cellData=c,this.handle=c.handle,this.uri=C.URI.revive(c.uri),this.cellKind=c.cellKind,this._outputs=c.outputs.map(y.NotebookCellOutput.to),this._internalMetadata=(h=c.internalMetadata)!==null&&h!==void 0?h:{},this._metadata=(_=c.metadata)!==null&&_!==void 0?_:{},this._previousResult=y.NotebookCellExecutionSummary.to((w=c.internalMetadata)!==null&&w!==void 0?w:{})}static asModelAddData(l,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:l}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const l=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return l.notebook.getCellIndex(l)},notebook:l.notebook.apiNotebook,kind:y.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return l._mime},set mime(c){l._mime=c},get outputs(){return l._outputs.slice(0)},get metadata(){return l._metadata},get executionSummary(){return l._previousResult}})}return this._apiCell}setOutputs(l){this._outputs=l.map(y.NotebookCellOutput.to)}setOutputItems(l,f,c){const h=c.map(y.NotebookCellOutputItem.to),_=this._outputs.find(w=>w.id===l);_&&(f||(_.items.length=0),_.items.push(...h))}setMetadata(l){this._metadata=l}setInternalMetadata(l){this._internalMetadata=l,this._previousResult=y.NotebookCellExecutionSummary.to(l)}setMime(l){}}e.ExtHostCell=k;class r{constructor(l,f,c,h,_,w){var b;this._proxy=l,this._textDocumentsAndEditors=f,this._textDocuments=c,this._emitter=h,this.uri=_,this.handle=r._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=w.viewType,this._metadata=(b=w.metadata)!==null&&b!==void 0?b:Object.create(null),this._spliceNotebookCells([[0,0,w.cells]],!0),this._versionId=w.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const l=this;this._notebook={get uri(){return l.uri},get version(){return l._versionId},get notebookType(){return l._notebookType},get isDirty(){return l._isDirty},get isUntitled(){return l.uri.scheme===p.Schemas.untitled},get isClosed(){return l._disposed},get metadata(){return l._metadata},get cellCount(){return l._cells.length},cellAt(f){return f=l._validateIndex(f),l._cells[f].apiCell},getCells(f){return(f?l._getCells(f):l._cells).map(h=>h.apiCell)},save(){return l._save()}}}return this._notebook}updateBackup(l){var f;(f=this._backup)===null||f===void 0||f.delete(),this._backup=l}disposeBackup(){var l;(l=this._backup)===null||l===void 0||l.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(l){l.metadata&&(this._metadata=Object.assign(Object.assign({},this._metadata),l.metadata))}acceptDirty(l){this._isDirty=l}acceptModelChanged(l,f){this._versionId=l.versionId,this._isDirty=f;for(const c of l.rawEvents)c.kind===I.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(c.changes,!1):c.kind===I.NotebookCellsChangeType.Move?this._moveCell(c.index,c.newIdx):c.kind===I.NotebookCellsChangeType.Output?this._setCellOutputs(c.index,c.outputs):c.kind===I.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(c.index,c.outputId,c.append,c.outputItems):c.kind===I.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(c.index,c.language):c.kind===I.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(c.index,c.mime):c.kind===I.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(c.index,c.metadata):c.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(c.index,c.internalMetadata)}_validateIndex(l){return l=l|0,l<0?0:l>=this._cells.length?this._cells.length-1:l}_validateRange(l){let f=l.start|0,c=l.end|0;return f<0&&(f=0),c>this._cells.length&&(c=this._cells.length),l.with({start:f,end:c})}_getCells(l){l=this._validateRange(l);const f=[];for(let c=l.start;c<l.end;c++)f.push(this._cells[c]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(l,f){if(this._disposed)return;const c=[],h=[],_=[];l.reverse().forEach(w=>{const d=w[2].map(t=>{const i=new k(this,this._textDocumentsAndEditors,t);return f||h.push(k.asModelAddData(this.apiNotebook,t)),i}),u=new E(w[0],w[1],[],d),g=this._cells.splice(w[0],w[1],...d);for(const t of g)_.push(t.uri),u.deletedItems.push(t.apiCell);c.push(u)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:_}),f||this._emitter.emitModelChange(R.deepFreeze({document:this.apiNotebook,changes:E.asApiEvents(c)}))}_moveCell(l,f){const c=this._cells.splice(l,1);this._cells.splice(f,0,...c);const h=[new E(l,1,c.map(_=>_.apiCell),[]),new E(f,0,[],c)];this._emitter.emitModelChange(R.deepFreeze({document:this.apiNotebook,changes:E.asApiEvents(h)}))}_setCellOutputs(l,f){const c=this._cells[l];c.setOutputs(f),this._emitter.emitCellOutputsChange(R.deepFreeze({document:this.apiNotebook,cells:[c.apiCell]}))}_setCellOutputItems(l,f,c,h){const _=this._cells[l];_.setOutputItems(f,c,h),this._emitter.emitCellOutputsChange(R.deepFreeze({document:this.apiNotebook,cells:[_.apiCell]}))}_changeCellLanguage(l,f){const c=this._cells[l];c.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(c.uri,f)}_changeCellMime(l,f){const c=this._cells[l];c.apiCell.mime=f}_changeCellMetadata(l,f){const c=this._cells[l],h=c.apiCell.metadata;c.setMetadata(f);const _=c.apiCell.metadata;R.equals(h,_)||this._emitter.emitCellMetadataChange(R.deepFreeze({document:this.apiNotebook,cell:c.apiCell}))}_changeCellInternalMetadata(l,f){var c;const h=this._cells[l],_=h.internalMetadata;if(h.setInternalMetadata(f),_.runState!==f.runState){const w=(c=f.runState)!==null&&c!==void 0?c:A.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange(R.deepFreeze({document:this.apiNotebook,cell:h.apiCell,state:w}))}}getCellFromApiCell(l){return this._cells.find(f=>f.apiCell===l)}getCellFromIndex(l){return this._cells[l]}getCell(l){return this._cells.find(f=>f.handle===l)}getCellIndex(l){return this._cells.indexOf(l)}}e.ExtHostNotebookDocument=r,r._handlePool=0}),define(ge[123],pe([0,1,7,17,14]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class y{constructor(E){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=E}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(E){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:E})}replaceCellMetadata(E,k){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:E,metadata:k})}replaceCells(E,k,r){this._throwIfFinalized(),!(E===k&&r.length===0)&&this._collectedEdits.push({editType:1,index:E,count:k-E,cells:r.map(R.NotebookCellData.from)})}}class A{constructor(E,k,r,P,l,f){this.id=E,this._proxy=k,this.notebookData=r,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=P,this._viewColumn=f}get apiEditor(){if(!this._editor){const E=this;this._editor={get document(){return E.notebookData.apiNotebook},get selections(){return E._selections},set selections(k){if(!Array.isArray(k)||!k.every(p.NotebookRange.isNotebookRange))throw C.illegalArgument("selections");E._selections=k,E._trySetSelections(k)},get visibleRanges(){return E._visibleRanges},revealRange(k,r){E._proxy.$tryRevealRange(E.id,R.NotebookRange.from(k),r??p.NotebookEditorRevealType.Default)},get viewColumn(){return E._viewColumn},edit(k){const r=new y(this.document.version);return k(r),E._applyEdit(r.finalize())},setDecorations(k,r){return E.setDecorations(k,r)}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(E){this._visible=E}_acceptVisibleRanges(E){this._visibleRanges=E}_acceptSelections(E){this._selections=E}_trySetSelections(E){this._proxy.$trySetSelections(this.id,E.map(R.NotebookRange.from))}_acceptViewColumn(E){this._viewColumn=E}_applyEdit(E){if(E.cellEdits.length===0)return Promise.resolve(!0);const k=[];let r=-1;for(let P=0;P<E.cellEdits.length;P++){if(r<0){k.push(E.cellEdits[P]),r++;continue}const f=k[r],c=E.cellEdits[P];if(f.editType===1&&c.editType===1&&f.index===c.index){f.cells.push(...E.cellEdits[P].cells),f.count+=E.cellEdits[P].count;continue}k.push(E.cellEdits[P]),r++}return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,k)}setDecorations(E,k){if(!(k.isEmpty&&!this._hasDecorationsForKey.has(E.key)))return k.isEmpty?this._hasDecorationsForKey.delete(E.key):this._hasDecorationsForKey.add(E.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(k),E.key)}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(ge[209],pe([0,1,17,114,160,21,51]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class I{constructor(P){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=P}withProgress(P,l,f){const c=this._handles++,{title:h,location:_,cancellable:w}=l,b={label:C.localize(0,null,P.displayName||P.name),id:P.identifier.value};return this._proxy.$startProgress(c,{location:p.ProgressLocation.from(_),title:h,source:b,cancellable:w},P),this._withProgress(c,f,!!w)}_withProgress(P,l,f){let c;f&&(c=new y.CancellationTokenSource,this._mapHandleToCancellationSource.set(P,c));const h=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),c&&c.dispose()};let _;try{_=l(new k(this._proxy,P),f&&c?c.token:y.CancellationToken.None)}catch(w){throw h(P),w}return _.then(w=>h(P),w=>h(P)),_}$acceptProgressCanceled(P){const l=this._mapHandleToCancellationSource.get(P);l&&(l.cancel(),this._mapHandleToCancellationSource.delete(P))}}e.ExtHostProgress=I;function E(r,P){return r.message=P.message,typeof P.increment=="number"&&(typeof r.increment=="number"?r.increment+=P.increment:r.increment=P.increment),r}class k extends R.Progress{constructor(P,l){super(f=>this.throttledReport(f));this._proxy=P,this._handle=l}throttledReport(P){this._proxy.$progressReport(this._handle,P)}}Ve([A.throttle(100,(r,P)=>E(r,P),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(ge[124],pe([0,1,50,14,70,17,7]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(l,f,c){const h=I._Keys.nextId();l.$registerTextEditorDecorationType(f.identifier,h,y.DecorationRenderOptions.from(c)),this.value=Object.freeze({key:h,dispose(){l.$removeTextEditorDecorationType(h)}})}}e.TextEditorDecorationType=I,I._Keys=new C.IdGenerator("TextEditorDecorationType");class E{constructor(l,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,f){this._throwIfFinalized();let c=null;if(l instanceof A.Position)c=new A.Range(l,l);else if(l instanceof A.Range)c=l;else throw new Error("Unrecognized location");this._pushEdit(c,f,!1)}insert(l,f){this._throwIfFinalized(),this._pushEdit(new A.Range(l,l),f,!0)}delete(l){this._throwIfFinalized();let f=null;if(l instanceof A.Range)f=l;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(l,f,c){const h=this._document.validateRange(l);this._collectedEdits.push({range:h,text:f,forceMoveMarkers:c})}setEndOfLine(l){if(this._throwIfFinalized(),l!==A.EndOfLine.LF&&l!==A.EndOfLine.CRLF)throw R.illegalArgument("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=E;class k{constructor(l,f,c,h){this._proxy=l,this._id=f,this._accept(c),this._logService=h;const _=this;this.value={get tabSize(){return _._tabSize},set tabSize(w){_._setTabSize(w)},get insertSpaces(){return _._insertSpaces},set insertSpaces(w){_._setInsertSpaces(w)},get cursorStyle(){return _._cursorStyle},set cursorStyle(w){_._setCursorStyle(w)},get lineNumbers(){return _._lineNumbers},set lineNumbers(w){_._setLineNumbers(w)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=y.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const f=Math.floor(l);return f>0?f:null}if(typeof l=="string"){const f=parseInt(l,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(l){const f=this._validateTabSize(l);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const f=this._validateInsertSpaces(l);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:y.TextEditorLineNumbersStyle.from(l)})))}assign(l){const f={};let c=!1;if(typeof l.tabSize!="undefined"){const h=this._validateTabSize(l.tabSize);h==="auto"?(c=!0,f.tabSize=h):typeof h=="number"&&this._tabSize!==h&&(this._tabSize=h,c=!0,f.tabSize=h)}if(typeof l.insertSpaces!="undefined"){const h=this._validateInsertSpaces(l.insertSpaces);h==="auto"?(c=!0,f.insertSpaces=h):this._insertSpaces!==h&&(this._insertSpaces=h,c=!0,f.insertSpaces=h)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,c=!0,f.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,c=!0,f.lineNumbers=y.TextEditorLineNumbersStyle.from(l.lineNumbers)),c&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(l){l.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=k;class r{constructor(l,f,c,h,_,w,b,d){this.id=l,this._proxy=f,this._logService=c,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=_,this._options=new k(this._proxy,this.id,w,c),this._visibleRanges=b,this._viewColumn=d;const u=this;this.value=Object.freeze({get document(){return h.getValue()},set document(g){throw R.readonly("document")},get selection(){return u._selections&&u._selections[0]},set selection(g){if(!(g instanceof A.Selection))throw R.illegalArgument("selection");u._selections=[g],u._trySetSelection()},get selections(){return u._selections},set selections(g){if(!Array.isArray(g)||g.some(t=>!(t instanceof A.Selection)))throw R.illegalArgument("selections");u._selections=g,u._trySetSelection()},get visibleRanges(){return u._visibleRanges},set visibleRanges(g){throw R.readonly("visibleRanges")},get options(){return u._options.value},set options(g){u._disposed||u._options.assign(g)},get viewColumn(){return u._viewColumn},set viewColumn(g){throw R.readonly("viewColumn")},edit(g,t={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new E(h.getValue(),t);return g(i),u._applyEdit(i)},insertSnippet(g,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=u._selections.map(n=>y.Range.from(n));else if(t instanceof A.Position){const{lineNumber:n,column:o}=y.Position.from(t);s=[{startLineNumber:n,startColumn:o,endLineNumber:n,endColumn:o}]}else if(t instanceof A.Range)s=[y.Range.from(t)];else{s=[];for(const n of t)if(n instanceof A.Range)s.push(y.Range.from(n));else{const{lineNumber:o,column:v}=y.Position.from(n);s.push({startLineNumber:o,startColumn:v,endLineNumber:o,endColumn:v})}}return f.$tryInsertSnippet(l,g.value,s,i)},setDecorations(g,t){const i=t.length===0;i&&!u._hasDecorationsForKey.has(g.key)||(i?u._hasDecorationsForKey.delete(g.key):u._hasDecorationsForKey.add(g.key),u._runOnProxy(()=>{if(y.isDecorationOptionsArr(t))return f.$trySetDecorations(l,g.key,y.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let n=0,o=t.length;n<o;n++){const v=t[n];s[4*n]=v.start.line+1,s[4*n+1]=v.start.character+1,s[4*n+2]=v.end.line+1,s[4*n+3]=v.end.character+1}return f.$trySetDecorationsFast(l,g.key,s)}}))},revealRange(g,t){u._runOnProxy(()=>f.$tryRevealRange(l,y.Range.from(g),t||A.TextEditorRevealType.Default))},show(g){f.$tryShowEditor(l,y.ViewColumn.from(g))},hide(){f.$tryHideEditor(l)}})}dispose(){p.ok(!this._disposed),this._disposed=!0}_acceptOptions(l){p.ok(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){p.ok(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){p.ok(!this._disposed),this._viewColumn=l}_acceptSelections(l){p.ok(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(y.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const f=l.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const c=f.edits.map(_=>_.range);c.sort((_,w)=>_.end.line===w.end.line?_.end.character===w.end.character?_.start.line===w.start.line?_.start.character-w.start.character:_.start.line-w.start.line:_.end.character-w.end.character:_.end.line-w.end.line);for(let _=0,w=c.length-1;_<w;_++){const b=c[_].end;if(c[_+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=f.edits.map(_=>({range:y.Range.from(_.range),text:_.text,forceMoveMarkers:_.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,h,{setEndOfLine:typeof f.setEndOfLine=="number"?y.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=r}),define(ge[210],pe([0,1,163,24,2,3,6,16,7,15,18,17,21]),function(X,e,p,R,C,y,A,I,E,k,r,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(_,w){if(k.isString(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let b;return Array.isArray(_.highlights)&&(b=_.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),b=b.length?b:void 0),{label:_.label,highlights:b}}}class c{constructor(w,b,d){this._proxy=w,this.commands=b,this.logService=d,this.treeViews=new Map;function u(g){return g&&g.$treeViewId&&g.$treeItemHandle}b.registerArgumentProcessor({processArgument:g=>u(g)?this.convertArgument(g):Array.isArray(g)&&g.length>0?g.map(t=>u(t)?this.convertArgument(t):t):g})}registerTreeDataProvider(w,b,d){const u=this.createTreeView(w,{treeDataProvider:b},d);return{dispose:()=>u.dispose()}}createTreeView(w,b,d){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=b.dragAndDropController!==void 0,g=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany,canDragAndDrop:u}),t=this.createExtHostTreeView(w,b,d);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(i){t.message=i},get title(){return t.title},set title(i){t.title=i},get description(){return t.description},set description(i){t.description=i},reveal:(i,s)=>t.reveal(i,s),dispose:async()=>{await g,this.treeViews.delete(w),t.dispose()}}}$getChildren(w,b){const d=this.treeViews.get(w);return d?d.getChildren(b):Promise.reject(new Error(p.localize(0,null,w)))}$onDrop(w,b,d){const u=this.treeViews.get(w);return u?u.onDrop(b,d):Promise.reject(new Error(p.localize(1,null,w)))}async $hasResolve(w){const b=this.treeViews.get(w);if(!b)throw new Error(p.localize(2,null,w));return b.hasResolve}$resolve(w,b,d){const u=this.treeViews.get(w);if(!u)throw new Error(p.localize(3,null,w));return u.resolveTreeItem(b,d)}$setExpanded(w,b,d){const u=this.treeViews.get(w);if(!u)throw new Error(p.localize(4,null,w));u.setExpanded(b,d)}$setSelection(w,b){const d=this.treeViews.get(w);if(!d)throw new Error(p.localize(5,null,w));d.setSelection(b)}$setVisible(w,b){const d=this.treeViews.get(w);if(!d)throw new Error(p.localize(6,null,w));d.setVisible(b)}createExtHostTreeView(w,b,d){const u=new h(w,b,this._proxy,this.commands.converter,this.logService,d);return this.treeViews.set(w,u),u}convertArgument(w){const b=this.treeViews.get(w.$treeViewId);return b?b.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=c;class h extends A.Disposable{constructor(w,b,d,u,g,t){super();if(this.viewId=w,this.proxy=d,this.commands=u,this.logService=g,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new l.CancellationTokenSource,t.contributes&&t.contributes.views)for(const n in t.contributes.views)for(const o of t.contributes.views[n])o.id===w&&(this._title=o.name);this.dataProvider=b.treeDataProvider,this.dndController=b.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(n=>this._onDidChangeData.fire({message:!1,element:n}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(n=>this._onDidChangeData.fire({message:!1,element:n})));let i,s;this._register(y.Event.debounce(this._onDidChangeData.event,(n,o)=>(n||(n={message:!1,elements:[]}),o.element!==!1&&(i||(i=new Promise(v=>s=v),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(o.element)?n.elements.push(...o.element):n.elements.push(o.element)),o.message&&(n.message=!0),n),200,!0)(({message:n,elements:o})=>{o.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const v=s;return i=null,this.refresh(o).then(()=>v())})),n&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!k.isUndefinedOrNull(w))}getChildren(w){const b=w?this.getExtensionElement(w):void 0;if(w&&!b)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);const d=this.getChildrenNodes(w);return(d?Promise.resolve(d):this.fetchChildrenNodes(b)).then(u=>u.map(g=>g.item))}getExtensionElement(w){return this.elements.get(w)}reveal(w,b){b=b||{select:!0,focus:!1};const d=k.isUndefinedOrNull(b.select)?!0:b.select,u=k.isUndefinedOrNull(b.focus)?!1:b.focus,g=k.isUndefinedOrNull(b.expand)?!1:b.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(t=>this.resolveTreeNode(w,t[t.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:t.map(s=>s.item)},{select:d,focus:u,expand:g})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:d,focus:u,expand:g})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,b){const d=this.getExtensionElement(w);d&&(b?this._onDidExpandElement.fire(Object.freeze({element:d})):this._onDidCollapseElement.fire(Object.freeze({element:d})))}setSelection(w){r.equals(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(w,b){const d=w.map(g=>this.getExtensionElement(g)).filter(g=>!k.isUndefinedOrNull(g)),u=this.getExtensionElement(b);return d&&u?I.asPromise(()=>{var g;return(g=this.dndController)===null||g===void 0?void 0:g.onDrop(d,u)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,b){var d;if(!this.dataProvider.resolveTreeItem)return;const u=this.elements.get(w);if(u){const g=this.nodes.get(u);if(g){const t=(d=await this.dataProvider.resolveTreeItem(g.extensionItem,u,b))!==null&&d!==void 0?d:g.extensionItem;return g.item.tooltip=this.getTooltip(t.tooltip),g.item.command=this.getCommand(g.disposableStore,t.command),g.item}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(b=>b?this.resolveUnknownParentChain(b).then(d=>this.resolveTreeNode(b,d[d.length-1]).then(u=>(d.push(u),d))):Promise.resolve([]))}resolveParent(w){const b=this.nodes.get(w);return b?Promise.resolve(b.parent?this.elements.get(b.parent.item.handle):void 0):I.asPromise(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,b){const d=this.nodes.get(w);return d?Promise.resolve(d):I.asPromise(()=>this.dataProvider.getTreeItem(w)).then(u=>this.createHandle(w,u,b,!0)).then(u=>this.getChildren(b?b.item.handle:void 0).then(()=>{const g=this.getExtensionElement(u);if(g){const t=this.nodes.get(g);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(w){if(w){let b;if(typeof w=="string"){const d=this.getExtensionElement(w);b=d?this.nodes.get(d):void 0}else b=w;return b&&b.children||null}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const b=new l.CancellationTokenSource(this._refreshCancellationSource.token);try{const d=w?this.nodes.get(w):void 0,u=await this.dataProvider.getChildren(w);if(b.token.isCancellationRequested)return[];const g=await Promise.all(r.coalesce(u||[]).map(async t=>{const i=await this.dataProvider.getTreeItem(t);return i&&!b.token.isCancellationRequested?this.createAndRegisterTreeNode(t,i,d):null}));return b.token.isCancellationRequested?[]:r.coalesce(g)}finally{b.dispose()}}refresh(w){if(w.some(d=>!d))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new l.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const d=this.getHandlesToRefresh(w);if(d.length)return this.refreshHandles(d)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const b=new Set,d=w.map(g=>this.nodes.get(g));for(const g of d)if(g&&!b.has(g.item.handle)){let t=g;for(;t&&t.parent&&d.findIndex(i=>t&&t.parent&&i&&i.item.handle===t.parent.item.handle)===-1;){const i=this.elements.get(t.parent.item.handle);t=i?this.nodes.get(i):void 0}t&&!t.parent&&b.add(g.item.handle)}const u=[];return b.forEach(g=>{const t=this.elements.get(g);if(t){const i=this.nodes.get(t);i&&(!i.parent||!b.has(i.parent.item.handle))&&u.push(g)}}),u}refreshHandles(w){const b={};return Promise.all(w.map(d=>this.refreshNode(d).then(u=>{u&&(b[d]=u.item)}))).then(()=>Object.keys(b).length?this.proxy.$refresh(this.viewId,b):void 0)}refreshNode(w){const b=this.getExtensionElement(w);if(b){const d=this.nodes.get(b);if(d)return this.clearChildren(b),I.asPromise(()=>this.dataProvider.getTreeItem(b)).then(u=>{if(u){const g=this.createTreeNode(b,u,d.parent);return this.updateNodeCache(b,g,d,d.parent),d.dispose(),g}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,b,d){const u=this.createTreeNode(w,b,d);if(b.id&&this.elements.has(u.item.handle))throw new Error(p.localize(7,null,b.id));return this.addNodeToCache(w,u),this.addNodeToParentCache(u,d),u}getTooltip(w){return E.MarkdownString.isMarkdownString(w)?P.MarkdownString.from(w):w}getCommand(w,b){return b?this.commands.toInternal(b,w):void 0}createTreeNode(w,b,d){const u=new A.DisposableStore,g=this.createHandle(w,b,d),t=this.getLightIconPath(b);return{item:{handle:g,parentHandle:d?d.item.handle:void 0,label:f(b.label,this.extension),description:b.description,resourceUri:b.resourceUri,tooltip:this.getTooltip(b.tooltip),command:this.getCommand(u,b.command),contextValue:b.contextValue,icon:t,iconDark:this.getDarkIconPath(b)||t,themeIcon:this.getThemeIcon(b),collapsibleState:k.isUndefinedOrNull(b.collapsibleState)?E.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation},extensionItem:b,parent:d,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(w){return w.iconPath instanceof E.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:b,label:d,resourceUri:u},g,t){if(b)return`${h.ID_HANDLE_PREFIX}/${b}`;const i=f(d,this.extension),s=g?g.item.handle:h.LABEL_HANDLE_PREFIX;let n=i?i.label:u?R.basename(u):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const o=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,v=this.getChildrenNodes(g)||[];let m,S=0;do{if(m=`${s}/${S}:${n}`,t||!this.elements.has(m)||o===m)break;S++}while(S<=v.length);return m}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof E.ThemeIcon))return typeof w.iconPath=="string"||C.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof E.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return C.URI.isUri(w)?w:C.URI.file(w)}addNodeToCache(w,b){this.elements.set(b.item.handle,w),this.nodes.set(w,b)}updateNodeCache(w,b,d,u){this.elements.delete(b.item.handle),this.nodes.delete(w),b.item.handle!==d.item.handle&&this.elements.delete(d.item.handle),this.addNodeToCache(w,b);const g=this.getChildrenNodes(u)||[],t=g.filter(i=>i.item.handle===d.item.handle)[0];t&&g.splice(g.indexOf(t),1,b)}addNodeToParentCache(w,b){b?(b.children||(b.children=[]),b.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const b=this.nodes.get(w);if(b){if(b.children)for(const d of b.children){const u=this.elements.get(d.item.handle);u&&this.clear(u)}b.children=void 0}}else this.clearAll()}clear(w){const b=this.nodes.get(w);if(b){if(b.children)for(const d of b.children){const u=this.elements.get(d.item.handle);u&&this.clear(u)}this.nodes.delete(w),this.elements.delete(b.item.handle),b.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}h.LABEL_HANDLE_PREFIX="0",h.ID_HANDLE_PREFIX="1"}),define(ge[211],pe([0,1,16,21,3,52,6,15,118,17,7,122]),function(X,e,p,R,C,y,A,I,E,k,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=void 0;var l;(function(h){h[h.Disconnected=0]="Disconnected",h[h.IsChild=1]="IsChild",h[h.IsParent=2]="IsParent",h[h.IsSame=3]="IsSame"})(l=e.TestPosition||(e.TestPosition={}));class f{constructor(){this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(_){if(this.map.has(_.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${_.item.extId}`);this.map.set(_.item.extId,_),_.parent||this._roots.add(_)}has(_){return this.map.has(_)}delete(_){const w=this.map.get(_);return w?(this.map.delete(_),this._roots.delete(w),!0):!1}get(_){return this.map.get(_)}comparePositions(_,w){const b=typeof _=="string"?this.map.get(_):_,d=typeof w=="string"?this.map.get(w):w;if(!b||!d)return 0;if(b===d)return 3;for(let u=this.map.get(d.parent);u;u=this.map.get(u.parent))if(u===b)return 1;for(let u=this.map.get(b.parent);u;u=this.map.get(u.parent))if(u===d)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=f;class c extends A.Disposable{constructor(_){super();this.controllerId=_,this.testItemToInternal=new Map,this.debounceSendDiff=this._register(new p.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new C.Emitter),this.root=new r.TestItemImpl(`${this.controllerId}Root`,this.controllerId,void 0,void 0,void 0),this.tree=new f,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.addItemInner(this.root,null)}set resolveHandler(_){this._resolveHandler=_;for(const w of this.testItemToInternal.values())this.updateExpandability(w)}get roots(){return y.Iterable.filter(this.testItemToInternal.values(),_=>_.parent===null)}getTestByReference(_){return this.testItemToInternal.get(_)}collectDiff(){const _=this.diff;return this.diff=[],_}pushDiff(_){const w=this.diff[this.diff.length-1];if(w&&_[0]===1){if(w[0]===1&&w[1].extId===_[1].extId){P.applyTestItemUpdate(w[1],_[1]);return}if(w[0]===0&&w[1].item.extId===_[1].extId){P.applyTestItemUpdate(w[1],_[1]);return}}this.diff.push(_),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(_,w){var b;const d=this.tree.get(_);if(!!d){if((d.expandLevels===void 0||w>d.expandLevels)&&(d.expandLevels=w),d.expand===1){const u=this.refreshChildren(d);return u.isSettled?this.expandChildren(d,w-1):u.p.then(()=>this.expandChildren(d,w-1))}else if(d.expand===3)return((b=d.initialExpand)===null||b===void 0?void 0:b.isSettled)===!1?d.initialExpand.p.then(()=>this.expandChildren(d,w-1)):this.expandChildren(d,w-1)}}dispose(){var _;for(const w of this.testItemToInternal.values())(_=w.discoverCts)===null||_===void 0||_.dispose(!0),E.getPrivateApiFor(w.actual).bus.dispose();this.diff=[],super.dispose()}onTestItemEvent(_,w){const b=_==null?void 0:_.actual.id;switch(w[0]){case 2:this.pushDiff([4,b]);break;case 1:this.removeItem(_);break;case 0:this.addItemInner(w[1],_);break;case 3:const[d,u,g]=w;switch(u){case"status":this.updateExpandability(_);break;case"range":this.pushDiff([1,{extId:b,item:{range:k.Range.from(g)}}]);break;case"error":this.pushDiff([1,{extId:b,item:{error:k.MarkdownString.fromStrict(g)||null}}]);break;default:this.pushDiff([1,{extId:b,item:{[u]:g??null}}]);break}break;default:I.assertNever(w[0])}}addItemInner(_,w){if(!(_ instanceof r.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${_.id} did not`);if(this.testItemToInternal.has(_))throw new Error(`Attempted to add a single TestItem ${_.id} multiple times to the tree`);if(this.tree.has(_.id))throw new Error(`Attempted to insert a duplicate test item ID ${_.id}`);const b=w?w.item.extId:null,d=w?w.expandLevels:1,u={actual:_,parent:b,item:k.TestItem.from(_),expandLevels:d?d-1:void 0,expand:0,controllerId:this.controllerId};this.tree.add(u),this.testItemToInternal.set(_,u),this.pushDiff([0,{parent:b,controllerId:this.controllerId,expand:u.expand,item:u.item}]);const g=E.getPrivateApiFor(_);g.bus.event(this.onTestItemEvent.bind(this,u)),this.updateExpandability(u);for(const t of g.children.values())this.testItemToInternal.has(t)||this.addItemInner(t,u)}updateExpandability(_){var w;let b;this._resolveHandler?_.actual.status===r.TestItemStatus.Pending?b=_.discoverCts?2:1:((w=_.initialExpand)===null||w===void 0||w.complete(),b=_.actual.children.size>0?3:0):b=0,b!==_.expand&&(_.expand=b,this.pushDiff([1,{extId:_.actual.id,expand:b}]),b===1&&_.expandLevels!==void 0&&this.refreshChildren(_))}expandChildren(_,w){if(w<0)return;const b=[..._.actual.children.values()].map(d=>this.expand(d.id,w)).filter(p.isThenable);if(b.length)return Promise.all(b).then(()=>{})}refreshChildren(_){if(_.discoverCts&&_.discoverCts.dispose(!0),!this._resolveHandler){const w=new p.DeferredPromise;return w.complete(),w}return _.expand=2,_.discoverCts=new R.CancellationTokenSource,this.pushExpandStateUpdate(_),_.initialExpand=new p.DeferredPromise,this._resolveHandler(_.actual,_.discoverCts.token),_.initialExpand}pushExpandStateUpdate(_){this.pushDiff([1,{extId:_.actual.id,expand:_.expand}])}removeItem(_){var w;this.pushDiff([2,_.actual.id]);const b=[_];for(;b.length;){const d=b.pop();if(!!d){(w=d.discoverCts)===null||w===void 0||w.dispose(!0),this.tree.delete(d.item.extId),this.testItemToInternal.delete(d.actual);for(const u of d.actual.children.values())b.push(this.tree.get(u.id))}}}flushDiff(){const _=this.collectDiff();_.length&&this.diffOpEmitter.fire(_)}}e.SingleUseTestCollection=c}),define(ge[212],pe([0,1,4,176]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=p.refineServiceDecorator(R.IEnvironmentService)}),define(ge[213],pe([0,1,26,3,9]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class y{constructor(r){this.removedDueToLooping=r}}e.DeltaExtensionsResult=y;class A{constructor(r){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=r,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const r of this._extensionDescriptions){if(this._extensionsMap.has(p.ExtensionIdentifier.toKey(r.identifier))){console.error("Extension `"+r.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(p.ExtensionIdentifier.toKey(r.identifier),r),this._extensionsArr.push(r),Array.isArray(r.activationEvents))for(let P of r.activationEvents)P==="onUri"&&(P=`onUri:${p.ExtensionIdentifier.toKey(r.identifier)}`),this._activationMap.has(P)||this._activationMap.set(P,[]),this._activationMap.get(P).push(r)}}keepOnly(r){const P=new Set;r.forEach(l=>P.add(p.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>P.has(p.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(r,P){r.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(r));const l=A._findLoopingExtensions(this._extensionDescriptions);if(P=P.concat(l.map(f=>f.identifier)),P.length>0){const f=new Set;P.forEach(c=>f.add(p.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>!f.has(p.ExtensionIdentifier.toKey(c.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new y(l)}static _findLoopingExtensions(r){const P=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(_){this._nodesSet.has(_)||(this._nodesSet.add(_),this._nodesArr.push(_))}addArc(_,w){this.addNode(_),this.addNode(w),this._arcs.has(_)?this._arcs.get(_).push(w):this._arcs.set(_,[w])}getArcs(_){return this._arcs.has(_)?this._arcs.get(_):[]}hasOnlyGoodArcs(_,w){const b=P.getArcs(_);for(let d=0;d<b.length;d++)if(!w.has(b[d]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let _ of r){const w=p.ExtensionIdentifier.toKey(_.identifier);if(l.set(w,_),_.extensionDependencies)for(let b of _.extensionDependencies){const d=p.ExtensionIdentifier.toKey(b);P.addArc(w,d)}}let f=new Set;P.getNodes().filter(_=>P.getArcs(_).length===0).forEach(_=>f.add(_));let c=P.getNodes().filter(_=>!f.has(_)),h;do{h=!1;for(let _=0;_<c.length;_++){const w=c[_];P.hasOnlyGoodArcs(w,f)&&(c.splice(_,1),_--,f.add(w),h=!0)}}while(h);return c.map(_=>l.get(_))}containsActivationEvent(r){return this._activationMap.has(r)}containsExtension(r){return this._extensionsMap.has(p.ExtensionIdentifier.toKey(r))}getExtensionDescriptionsForActivationEvent(r){const P=this._activationMap.get(r);return P?P.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(r){const P=this._extensionsMap.get(p.ExtensionIdentifier.toKey(r));return P||void 0}}e.ExtensionDescriptionRegistry=A;var I;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(I||(I={}));function E(k,r){const P=k.isBuiltin?0:k.isUnderDevelopment?2:1,l=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(P!==l)return P-l;const f=C.posix.basename(k.extensionLocation.path),c=C.posix.basename(r.extensionLocation.path);return f<c?-1:f>c?1:0}}),define(ge[214],pe([0,1,22]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var C;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(C=e.MessageType||(e.MessageType={}));function y(I){const E=p.VSBuffer.alloc(1);switch(I){case 0:E.writeUInt8(1,0);break;case 1:E.writeUInt8(2,0);break;case 2:E.writeUInt8(3,0);break}return E}e.createMessageOfType=y;function A(I,E){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return E===0;case 2:return E===1;case 3:return E===2;default:return!1}}e.isMessageOfType=A}),define(ge[34],pe([0,1,3,2,4,26,178]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new y.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=C.createDecorator("extensionService");class I{constructor(b){this.dependency=b}}e.MissingExtensionDependency=I;var E;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(E=e.ExtensionHostKind||(e.ExtensionHostKind={}));class k{constructor(b,d,u,g){this.codeLoadingTime=b,this.activateCallTime=d,this.activateResolvedTime=u,this.activationReason=g}}e.ActivationTimes=k;class r{constructor(b,d){this.description=b,this.value=d}}e.ExtensionPointContribution=r,e.ExtensionHostLogFileName="exthost";var P;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(P=e.ActivationKind||(e.ActivationKind={}));function l(w){w.enableProposedApi||f(w)}e.checkProposedApiEnabled=l;function f(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=f;function c(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:A.getGalleryExtensionId(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=c;function h(w,b){return Object.assign(Object.assign({identifier:new y.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!!b,extensionLocation:w.location},w.manifest),{uuid:w.identifier.uuid})}e.toExtensionDescription=h;class _{constructor(){this.onDidRegisterExtensions=p.Event.None,this.onDidChangeExtensionsStatus=p.Event.None,this.onDidChangeExtensions=p.Event.None,this.onWillActivateByEvent=p.Event.None,this.onDidChangeResponsiveChange=p.Event.None}activateByEvent(b){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(b){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(b){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(b){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(b,d){return Promise.resolve()}_onWillActivateExtension(b){}_onDidActivateExtension(b,d,u,g,t){}_onDidActivateExtensionError(b,d){}_onExtensionRuntimeError(b,d){}_onExtensionHostExit(b){}}e.NullExtensionService=_}),define(ge[215],pe([0,1,26,34,12]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class A{constructor(c,h,_,w){this.startup=c,this.codeLoadingTime=h,this.activateCallTime=_,this.activateResolvedTime=w}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class I{constructor(c){this._startup=c,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(c,h){return c===-1||h===-1?-1:h-c}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=I;class E{constructor(c,h,_,w,b,d){this.activationFailed=c,this.activationFailedError=h,this.activationTimes=_,this.module=w,this.exports=b,this.subscriptions=d}}e.ActivatedExtension=E;class k extends E{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class r extends E{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=r;class P extends E{constructor(c){super(!0,c,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=P;let l=class{constructor(c,h,_,w,b){this._logService=b,this._registry=c,this._resolvedExtensionsSet=new Set,h.forEach(d=>this._resolvedExtensionsSet.add(p.ExtensionIdentifier.toKey(d))),this._hostExtensionsMap=new Map,_.forEach(d=>this._hostExtensionsMap.set(p.ExtensionIdentifier.toKey(d),d)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(c){const h=p.ExtensionIdentifier.toKey(c);return this._activatedExtensions.has(h)}getActivatedExtension(c){const h=p.ExtensionIdentifier.toKey(c),_=this._activatedExtensions.get(h);if(!_)throw new Error("Extension `"+c.value+"` is not known or not activated");return _}activateByEvent(c,h){if(this._alreadyActivatedEvents[c])return y;const _=this._registry.getExtensionDescriptionsForActivationEvent(c);return this._activateExtensions(_.map(w=>({id:w.identifier,reason:{startup:h,extensionId:w.identifier,activationEvent:c}}))).then(()=>{this._alreadyActivatedEvents[c]=!0})}activateById(c,h){const _=this._registry.getExtensionDescription(c);if(!_)throw new Error("Extension `"+c+"` is not known");return this._activateExtensions([{id:_.identifier,reason:h}])}_handleActivateRequest(c,h,_){if(this._hostExtensionsMap.has(p.ExtensionIdentifier.toKey(c.id))){h[p.ExtensionIdentifier.toKey(c.id)]=c;return}const w=this._registry.getExtensionDescription(c.id);if(!w){const u=new Error(`Cannot activate unknown extension '${c.id.value}'`);this._host.onExtensionActivationError(c.id,u,new R.MissingExtensionDependency(c.id.value)),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(c.id),new P(u));return}const b=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let d=!0;for(let u=0,g=b.length;u<g;u++){const t=b[u];if(this._resolvedExtensionsSet.has(p.ExtensionIdentifier.toKey(t)))continue;const i=this._activatedExtensions.get(p.ExtensionIdentifier.toKey(t));if(i&&!i.activationFailed)continue;if(i&&i.activationFailed){const v=w.displayName||w.identifier.value,m=this._registry.getExtensionDescription(t),S=m&&m.displayName||t,D=new Error(`Cannot activate the '${v}' extension because its dependency '${S}' failed to activate`);D.detail=i.activationFailedError,this._host.onExtensionActivationError(w.identifier,D,null),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(w.identifier),new P(D));return}if(this._hostExtensionsMap.has(p.ExtensionIdentifier.toKey(t))){d=!1,h[p.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(p.ExtensionIdentifier.toKey(t)),reason:c.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){d=!1,h[p.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:c.reason};continue}const n=w.displayName||w.identifier.value,o=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(w.identifier,o,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(w.identifier),new P(o));return}d?h[p.ExtensionIdentifier.toKey(w.identifier)]=c:_.push(c)}_activateExtensions(c){if(c.length===0||(c=c.filter(b=>!this._activatedExtensions.has(p.ExtensionIdentifier.toKey(b.id))),c.length===0))return Promise.resolve(void 0);const h=Object.create(null),_=[];for(let b=0,d=c.length;b<d;b++)this._handleActivateRequest(c[b],h,_);for(let b=0,d=_.length;b<d;b++){const u=p.ExtensionIdentifier.toKey(_[b].id);h[u]&&delete h[u]}const w=Object.keys(h).map(b=>h[b]);return _.length===0?Promise.all(w.map(b=>this._activateExtension(b.id,b.reason))).then(b=>{}):this._activateExtensions(w).then(b=>this._activateExtensions(_))}_activateExtension(c,h){const _=p.ExtensionIdentifier.toKey(c);if(this._activatedExtensions.has(_))return Promise.resolve(void 0);const w=this._activatingExtensions.get(_);if(w)return w;const b=this._host.actualActivateExtension(c,h).then(void 0,d=>{const u=new Error;return d&&d.name&&(u.name=d.name),d&&d.message?u.message=`Activating extension '${c.value}' failed: ${d.message}.`:u.message=`Activating extension '${c.value}' failed: ${d}.`,d&&d.stack&&(u.stack=d.stack),this._host.onExtensionActivationError(c,u,null),this._logService.error(`Activating extension ${c.value} failed due to an error:`),this._logService.error(d),new P(d)}).then(d=>{this._activatedExtensions.set(_,d),this._activatingExtensions.delete(_)});return this._activatingExtensions.set(_,b),b}};l=Ve([$e(4,C.ILogService)],l),e.ExtensionsActivator=l}),define(ge[216],pe([0,1,12,34,27,10,112]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let I=class extends p.LogService{constructor(k){if(k.logFile.scheme!==y.Schemas.file)throw new Error("Only file-logging supported");super(new A.SpdLogLogger(R.ExtensionHostLogFileName,k.logFile.fsPath,!0,k.logLevel))}$setLevel(k){this.setLevel(k)}};I=Ve([$e(0,C.IExtHostInitDataService)],I),e.ExtHostLogService=I}),define(ge[217],pe([0,1,14]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,A)=>{this._actualOk=y,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):p.onUnexpectedError(y))}then(y,A){return this._ensureActual().then(y,A)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=R}),define(ge[125],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class p{constructor(E,k){this.isMain=E,this.sid=k,this.nid=++p.count}}e.ProxyIdentifier=p,p.count=0;const R=[];function C(I){const E=new p(!0,I);return R[E.nid]=E,E}e.createMainContextProxyIdentifier=C;function y(I){const E=new p(!1,I);return R[E.nid]=E,E}e.createExtHostContextProxyIdentifier=y;function A(I){return R[I].sid}e.getStringIdentifierForProxy=A}),define(ge[5],pe([0,1,55,2,125]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var y;(function(d){d[d.Desktop=1]="Desktop",d[d.Web=2]="Web"})(y=e.UIKind||(e.UIKind={}));var A;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var E;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(E=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(k=e.CellOutputKind||(e.CellOutputKind={}));var r;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(r=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var P;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(P=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(d){d.name="$ident";function u(t,i){return Object.defineProperty(t,d.name,{value:i,enumerable:!0}),t}d.mixin=u;function g(t){return t[d.name]}d.of=g})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(u){return u._id=f._n++,u}}e.IdObject=f,f._n=0;var c;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.command="m",d.kindModifier="n"})(c=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var h;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(h=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var _;(function(d){d[d.File=1]="File",d[d.Text=2]="Text",d[d.Cell=3]="Cell"})(_=e.WorkspaceEditType||(e.WorkspaceEditType={}));function w(d){if(d&&d.edits)for(const u of d.edits)typeof u.resource=="object"?u.resource=R.URI.revive(u.resource):(u.newUri=R.URI.revive(u.newUri),u.oldUri=R.URI.revive(u.oldUri)),u.metadata&&u.metadata.iconPath&&(u.metadata=p.revive(u.metadata));return d}e.reviveWorkspaceEditDto=w;var b;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:C.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadBulkEdits:C.createMainContextProxyIdentifier("MainThreadBulkEdits"),MainThreadClipboard:C.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:C.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:C.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:C.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:C.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:C.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:C.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:C.createMainContextProxyIdentifier("MainThreadDiagnostics"),MainThreadDialogs:C.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:C.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:C.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:C.createMainContextProxyIdentifier("MainThreadTextEditors"),MainThreadEditorInsets:C.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadEditorTabs:C.createMainContextProxyIdentifier("MainThreadEditorTabs"),MainThreadErrors:C.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:C.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:C.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:C.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:C.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:C.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:C.createMainContextProxyIdentifier("MainThread"),MainThreadMessageService:C.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:C.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:C.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:C.createMainContextProxyIdentifier("MainThreadQuickOpen"),MainThreadStatusBar:C.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadSecretState:C.createMainContextProxyIdentifier("MainThreadSecretState"),MainThreadStorage:C.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:C.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:C.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:C.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadWebviewPanels:C.createMainContextProxyIdentifier("MainThreadWebviewPanels"),MainThreadWebviewViews:C.createMainContextProxyIdentifier("MainThreadWebviewViews"),MainThreadCustomEditors:C.createMainContextProxyIdentifier("MainThreadCustomEditors"),MainThreadUrls:C.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadUriOpeners:C.createMainContextProxyIdentifier("MainThreadUriOpeners"),MainThreadWorkspace:C.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:C.createMainContextProxyIdentifier("MainThreadFileSystem"),MainThreadExtensionService:C.createMainContextProxyIdentifier("MainThreadExtensionService"),MainThreadSCM:C.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:C.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:C.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:C.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:C.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:C.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadNotebookDocuments:C.createMainContextProxyIdentifier("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:C.createMainContextProxyIdentifier("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:C.createMainContextProxyIdentifier("MainThreadNotebookKernels"),MainThreadNotebookRenderers:C.createMainContextProxyIdentifier("MainThreadNotebookRenderers"),MainThreadTheming:C.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:C.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:C.createMainContextProxyIdentifier("MainThreadTimeline"),MainThreadTesting:C.createMainContextProxyIdentifier("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:C.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:C.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:C.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),ExtHostDebugService:C.createExtHostContextProxyIdentifier("ExtHostDebugService"),ExtHostDecorations:C.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:C.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:C.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:C.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:C.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:C.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:C.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:C.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemInfo:C.createExtHostContextProxyIdentifier("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:C.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:C.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),ExtHostQuickOpen:C.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:C.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:C.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:C.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:C.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:C.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:C.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:C.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:C.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:C.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostWebviewPanels:C.createExtHostContextProxyIdentifier("ExtHostWebviewPanels"),ExtHostCustomEditors:C.createExtHostContextProxyIdentifier("ExtHostCustomEditors"),ExtHostWebviewViews:C.createExtHostContextProxyIdentifier("ExtHostWebviewViews"),ExtHostEditorInsets:C.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostEditorTabs:C.createExtHostContextProxyIdentifier("ExtHostEditorTabs"),ExtHostProgress:C.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:C.createMainContextProxyIdentifier("ExtHostComments"),ExtHostSecretState:C.createMainContextProxyIdentifier("ExtHostSecretState"),ExtHostStorage:C.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:C.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostUriOpeners:C.createExtHostContextProxyIdentifier("ExtHostUriOpeners"),ExtHostOutputService:C.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:C.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:C.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostNotebookDocuments:C.createMainContextProxyIdentifier("ExtHostNotebookDocuments"),ExtHostNotebookEditors:C.createMainContextProxyIdentifier("ExtHostNotebookEditors"),ExtHostNotebookKernels:C.createMainContextProxyIdentifier("ExtHostNotebookKernels"),ExtHostNotebookRenderers:C.createMainContextProxyIdentifier("ExtHostNotebookRenderers"),ExtHostTheming:C.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:C.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:C.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:C.createMainContextProxyIdentifier("ExtHostTimeline"),ExtHostTesting:C.createMainContextProxyIdentifier("ExtHostTesting"),ExtHostTelemetry:C.createMainContextProxyIdentifier("ExtHostTelemetry")}}),define(ge[85],pe([0,1,5,3,4]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class y{constructor(I){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(p.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,E){return this._proxy.$getPassword(I,E)}store(I,E,k){return this._proxy.$setPassword(I,E,k)}delete(I,E){return this._proxy.$deletePassword(I,E)}}e.ExtHostSecretState=y,e.IExtHostSecretState=C.createDecorator("IExtHostSecretState")}),define(ge[61],pe([0,1,4,12,5,13]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=p.createDecorator("IExtHostApiDeprecationService");let A=class{constructor(E,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(C.MainContext.MainThreadTelemetry)}report(E,k,r){const P=this.getUsageKey(E,k);this._reportedUsages.has(P)||(this._reportedUsages.add(P),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${r}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:E}))}getUsageKey(E,k){return`${E}-${k.identifier.value}`}};A=Ve([$e(0,y.IExtHostRpcService),$e(1,R.ILogService)],A),e.ExtHostApiDeprecationService=A,e.NullApiDeprecationService=Object.freeze(new class{report(I,E,k){}})}),define(ge[218],pe([0,1,3,5,7,26]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new p.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new p.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=E.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(E,k,r,P={}){const l=y.ExtensionIdentifier.toKey(E.identifier),f=this._inFlightRequests.get(l)||[],c=[...r].sort().join(" ");let h=f.find(_=>_.scopes===c);if(h)return h.result;{const _=this._getSession(E,l,k,r,P);h={scopes:c,result:_},f.push(h),this._inFlightRequests.set(l,f);try{await _}finally{const w=f.findIndex(b=>b.scopes===c);w>-1&&(f.splice(w),this._inFlightRequests.set(l,f))}return _}}async _getSession(E,k,r,P,l={}){await this._proxy.$ensureProvider(r);const f=E.displayName||E.name;return this._proxy.$getSession(r,P,k,f,l)}async removeSession(E,k){const r=this._authenticationProviders.get(E);return r?r.provider.removeSession(k):this._proxy.$removeSession(E,k)}registerAuthenticationProvider(E,k,r,P){var l;if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:k,provider:r,options:P??{supportsMultipleAccounts:!1}}),this._providers.find(c=>c.id===E)||this._providers.push({id:E,label:k});const f=r.onDidChangeSessions(c=>{var h,_,w;this._proxy.$sendDidChangeSessions(E,{added:(h=c.added)!==null&&h!==void 0?h:[],changed:(_=c.changed)!==null&&_!==void 0?_:[],removed:(w=c.removed)!==null&&w!==void 0?w:[]})});return this._proxy.$registerAuthenticationProvider(E,k,(l=P==null?void 0:P.supportsMultipleAccounts)!==null&&l!==void 0?l:!1),new C.Disposable(()=>{f.dispose(),this._authenticationProviders.delete(E);const c=this._providers.findIndex(h=>h.id===E);c>-1&&this._providers.splice(c),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,k){const r=this._authenticationProviders.get(E);if(r)return Promise.resolve(r.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,k){const r=this._authenticationProviders.get(E);if(r)return Promise.resolve(r.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,k){const r=this._authenticationProviders.get(E);if(r)return Promise.resolve(r.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,k){return this._onDidChangeSessions.fire({provider:{id:E,label:k}}),Promise.resolve()}$onDidChangeAuthenticationProviders(E,k){return E.forEach(r=>{this._providers.some(P=>P.id===r.id)||this._providers.push(r)}),k.forEach(r=>{const P=this._providers.findIndex(l=>l.id===r.id);P>-1&&this._providers.splice(P)}),this._onDidChangeAuthenticationProviders.fire({added:E,removed:k}),Promise.resolve()}}e.ExtHostAuthentication=A}),define(ge[219],pe([0,1,5,13,17]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let y=class{constructor(I,E){this._extHostDocumentsAndEditors=E,this._proxy=I.getProxy(p.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(I){const E=C.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(E)}};y=Ve([$e(0,R.IExtHostRpcService)],y),e.ExtHostBulkEdits=y}),define(ge[220],pe([0,1,5]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(y){const A=y.getProxy(p.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(I){return A.$writeText(I)}})}}e.ExtHostClipboard=R}),define(ge[48],pe([0,1,15,7,17,25,5,18,12,55,40,44,2,6,4,13]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let _=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(A.MainContext.MainThreadCommands),this._logService=i,this.converter=new w(this,s=>{const n=this._apiCommands.get(s);return(n==null?void 0:n.result)===d.Void?n:void 0},i),this._argumentProcessors=[{processArgument(s){return k.revive(s)}},{processArgument(s){return y.cloneAndChange(s,function(n){if(r.Range.isIRange(n))return C.Range.to(n);if(P.Position.isIPosition(n))return C.Position.to(n);if(r.Range.isIRange(n.range)&&l.URI.isUri(n.uri))return C.location.to(n);if(!Array.isArray(n))return n})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...s)=>{const n=t.args.map((v,m)=>{if(!v.validate(s[m]))throw new Error(`Invalid argument '${v.name}' when running '${t.id}', received: ${s[m]}`);return v.convert(s[m])}),o=await this.executeCommand(t.internalId,...n);return t.result.convert(o,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,s,n,o){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:s,thisArg:n,description:o}),t&&this._proxy.$registerCommand(i),new R.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,s){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const n=y.cloneAndChange(i,function(o){if(o instanceof R.Position)return C.Position.from(o);if(o instanceof R.Range)return C.Range.from(o);if(o instanceof R.Location)return C.location.from(o);if(R.NotebookRange.isNotebookRange(o))return C.NotebookRange.from(o);if(!Array.isArray(o))return o});try{const o=await this._proxy.$executeCommand(t,n,s);return k.revive(o)}catch(o){if(o instanceof Error&&o.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw o}}}async _executeContributedCommand(t,i){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:n,thisArg:o,description:v}=s;if(v)for(let m=0;m<v.args.length;m++)try{p.validateConstraint(i[m],v.args[m].constraint)}catch(S){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${v.args[m].name}' - ${v.args[m].description}`)}try{return await n.apply(o,i)}catch(m){if(t===this.converter.delegatingCommandId){const S=this.converter.getActualCommand(...i);S&&(t=S.command)}throw this._logService.error(m,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(s=>this._argumentProcessors.reduce((n,o)=>o.processArgument(n),s)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(s=>s[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,s]of this._commands){let{description:n}=s;n&&(t[i]=n)}return Promise.resolve(t)}};_=Ve([$e(0,h.IExtHostRpcService),$e(1,E.ILogService)],_),e.ExtHostCommands=_,e.IExtHostCommands=c.createDecorator("IExtHostCommands");class w{constructor(t,i,s){this._commands=t,this._lookupApiCommand=i,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!t)return;const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const n=this._lookupApiCommand(t.command);if(n)s.id=n.internalId,s.arguments=n.args.map((o,v)=>o.convert(t.arguments&&t.arguments[v]));else if(I.isNonEmptyArray(t.arguments)){const o=++this._cachIdPool;this._cache.set(o,t),i.add(f.toDisposable(()=>{this._cache.delete(o),this._logService.trace("CommandsConverter#DISPOSE",o)})),s.$ident=o,s.id=this.delegatingCommandId,s.arguments=[o],this._logService.trace("CommandsConverter#CREATE",t.command,o)}return s}fromInternal(t){const i=A.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class b{constructor(t,i,s,n){this.name=t,this.description=i,this.validate=s,this.convert=n}optional(){return new b(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new b(t??this.name,i??this.description,this.validate,this.convert)}}e.ApiCommandArgument=b,b.Uri=new b("uri","Uri of a text document",g=>l.URI.isUri(g),g=>g),b.Position=new b("position","A position in a text document",g=>R.Position.isPosition(g),C.Position.from),b.Range=new b("range","A range in a text document",g=>R.Range.isRange(g),C.Range.from),b.Selection=new b("selection","A selection in a text document",g=>R.Selection.isSelection(g),C.Selection.from),b.Number=new b("number","",g=>typeof g=="number",g=>g),b.String=new b("string","",g=>typeof g=="string",g=>g),b.CallHierarchyItem=new b("item","A call hierarchy item",g=>g instanceof R.CallHierarchyItem,C.CallHierarchyItem.to);class d{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=d,d.Void=new d("no result",g=>g);class u{constructor(t,i,s,n,o){this.id=t,this.internalId=i,this.description=s,this.args=n,this.result=o}}e.ApiCommand=u}),define(ge[221],pe([0,1,17,7,78,48,18,107]),function(X,e,p,R,C,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const E=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",r(p.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,f)=>{if(A.isFalsyOrEmpty(l))return;class c extends R.SymbolInformation{static to(_){const w=new c(_.name,p.SymbolKind.to(_.kind),_.containerName||"",new R.Location(f[0],p.Range.to(_.range)));return w.detail=_.detail,w.range=w.location.range,w.selectionRange=p.Range.to(_.selectionRange),w.children=_.children?_.children.map(c.to):[],w}}return l.map(c.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",r(p.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",r(p.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",r(p.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",r(p.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",r(p.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(f=>R.Position.isPosition(f)),l=>l.map(p.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(f=>{let c;for(const h of f.reverse())c=new R.SelectionRange(p.Range.to(h),c);return c}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>{const f=[];if(Array.isArray(l))for(let c of l)f.push(...c[1].map(p.WorkspaceSymbol.to));return f})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(p.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(p.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(p.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return p.WorkspaceEdit.to(l)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(p.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const f=I.decodeSemanticTokensDto(l);if(f.type==="full")return new R.SemanticTokens(f.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const f=I.decodeSemanticTokensDto(l);if(f.type==="full")return new R.SemanticTokens(f.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,f,c)=>{if(!l)return new R.CompletionList([]);const h=l.suggestions.map(_=>p.CompletionItem.to(_,c));return new R.CompletionList(h,l.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return p.SignatureHelp.to(l)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,f,c)=>r(h=>new R.CodeLens(p.Range.to(h.range),h.command&&c.fromInternal(h.command)))(l))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>R.Range.isRange(l),l=>R.Selection.isSelection(l)?p.Selection.from(l):p.Range.from(l)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,f,c)=>r(h=>{if(h._isSynthetic){if(!h.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(h.command)}else{const _=new R.CodeAction(h.title,h.kind?new R.CodeActionKind(h.kind):void 0);return h.edit&&(_.edit=p.WorkspaceEdit.to(h.edit)),h.command&&(_.command=c.fromInternal(h.command)),_.isPreferred=h.isPreferred,_}})(l))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(f=>new R.ColorInformation(p.Range.to(f.range),p.Color.to(f.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",l=>l instanceof R.Color,p.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:p.Range.from(l.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(p.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",l=>l.map(p.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",r(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(f=>p.NotebookExclusiveDocumentPattern.to(f))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(p.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[p.ViewColumn.from(l.viewColumn),p.TextEditorOpenOptions.from(l)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[p.ViewColumn.from(l.viewColumn),p.TextEditorOpenOptions.from(l)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[p.ViewColumn.from(l.viewColumn),p.TextEditorOpenOptions.from(l)]).optional()],y.ApiCommandResult.Void)];class k{static register(f){E.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=k;function r(l){return f=>{if(Array.isArray(f))return f.map(l)}}function P(l){if(!Array.isArray(l))return;const f=[];for(const c of l)C.isLocationLink(c)?f.push(p.DefinitionLink.to(c)):f.push(p.location.to(c));return f}}),define(ge[222],pe([0,1,16,51,3,6,2,78,26,17,7,5]),function(X,e,p,R,C,y,A,I,E,k,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class l{constructor(u,g,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=u.getProxy(P.MainContext.MainThreadComments),g.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const s=this._commentControllers.get(i.handle);return s||i}else if(i&&i.$mid===7){const s=this._commentControllers.get(i.commentControlHandle);if(!s)return i;const n=s.getCommentThread(i.commentThreadHandle);return n||i}else if(i&&i.$mid===8){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const n=s.getCommentThread(i.thread.commentThreadHandle);return n?{thread:n,text:i.text}:i}else if(i&&i.$mid===9){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const n=s.getCommentThread(i.thread.commentThreadHandle);if(!n)return i;let o=i.commentUniqueId,v=n.getCommentByUniqueId(o);return v||i}else if(i&&i.$mid===10){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const n=s.getCommentThread(i.thread.commentThreadHandle);if(!n)return i;let o=i.text,v=i.commentUniqueId,m=n.getCommentByUniqueId(v);return m?(m.body=o,m):i}return i}})}createCommentController(u,g,t){const i=l.handlePool++,s=new c(u,i,this._proxy,g,t);this._commentControllers.set(s.handle,s);const n=this._commentControllersByExtension.get(E.ExtensionIdentifier.toKey(u.identifier))||[];return n.push(s),this._commentControllersByExtension.set(E.ExtensionIdentifier.toKey(u.identifier),n),s}$createCommentThreadTemplate(u,g,t){const i=this._commentControllers.get(u);!i||i.$createCommentThreadTemplate(g,t)}async $updateCommentThreadTemplate(u,g,t){const i=this._commentControllers.get(u);!i||i.$updateCommentThreadTemplate(g,t)}$deleteCommentThread(u,g){const t=this._commentControllers.get(u);t&&t.$deleteCommentThread(g)}$provideCommentingRanges(u,g,t){const i=this._commentControllers.get(u);if(!i||!i.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(A.URI.revive(g));return p.asPromise(()=>i.commentingRangeProvider.provideCommentingRanges(s,t)).then(n=>n?n.map(o=>k.Range.from(o)):void 0)}$toggleReaction(u,g,t,i,s){const n=this._commentControllers.get(u);return!n||!n.reactionHandler?Promise.resolve(void 0):p.asPromise(()=>{const o=n.getCommentThread(g);if(o){const v=o.getCommentByUniqueId(i.uniqueIdInThread);if(n!==void 0&&v&&n.reactionHandler)return n.reactionHandler(v,w(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=l,l.handlePool=0;class f{constructor(u,g,t,i,s,n,o){this._proxy=u,this._commentController=g,this._id=t,this._uri=i,this._range=s,this._comments=n,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new C.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputDisposables.value=new y.DisposableStore,this._id===void 0&&(this._id=`${g.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,k.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=n}set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){u.isEqual(this._range)||(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new y.DisposableStore);const u=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),g={};u("range")&&(g.range=k.Range.from(this._range)),u("label")&&(g.label=this.label),u("contextValue")&&(g.contextValue=this.contextValue),u("comments")&&(g.comments=this._comments.map(t=>h(this,this._commentController,t,this._commentsMap))),u("collapsibleState")&&(g.collapseState=b(this._collapseState)),u("canReply")&&(g.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,g)}getCommentByUniqueId(u){for(let g of this._commentsMap){let t=g[0],i=g[1];if(u===i)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}f._handlePool=0,Ve([R.debounce(100)],f.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=f;class c{constructor(u,g,t,i,s){this._extension=u,this._handle=g,this._proxy=t,this._id=i,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,i,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(u,g,t,i){if(typeof u=="string"){const s=new f(this._proxy,this,u,g,t,i,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new f(this._proxy,this,void 0,u,g,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(u,g){const t=new f(this._proxy,this,void 0,A.URI.revive(u),k.Range.to(g),[],this._extension.identifier);return t.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(u,g){let t=this._threads.get(u);t&&(t.range=k.Range.to(g))}$deleteCommentThread(u){let g=this._threads.get(u);g&&g.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function h(d,u,g,t){let i=t.get(g);i||(i=++d.commentHandle,t.set(g,i));const s=g.author&&g.author.iconPath?g.author.iconPath.toString():void 0;return{mode:g.mode,contextValue:g.contextValue,uniqueIdInThread:i,body:k.MarkdownString.from(g.body),userName:g.author.name,userIconPath:s,label:g.label,commentReactions:g.reactions?g.reactions.map(n=>_(n)):void 0}}function _(d){return{label:d.label,iconPath:d.iconPath?k.pathOrURIToURI(d.iconPath):void 0,count:d.count,hasReacted:d.authorHasReacted}}function w(d){return{label:d.label||"",count:d.count||0,iconPath:d.iconPath?A.URI.revive(d.iconPath):"",authorHasReacted:d.hasReacted||!1}}function b(d){if(d!==void 0)switch(d){case r.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case r.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}}),define(ge[126],pe([0,1,2,5,7,4,13,12,18,8,9]),function(X,e,p,R,C,y,A,I,E,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let P=class En{constructor(f,c){this._logService=c,this._provider=new Map,this._proxy=f.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,c){const h=En._handlePool++;this._provider.set(h,{provider:f,extensionId:c}),this._proxy.$registerDecorationProvider(h,c.value);const _=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(h,null);return}let b=E.asArray(w);if(b.length<=En._maxEventSize){this._proxy.$onDidChange(h,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",c.value,b.length);const d=b.map(t=>({uri:t,rank:k.count(t.path,"/")})),u=E.groupBy(d,(t,i)=>t.rank-i.rank||k.compare(t.uri.path,i.uri.path));let g=[];e:for(let t of u){let i;for(let s of t){let n=r.dirname(s.uri.path);if(i!==n&&(i=n,g.push(s.uri)>=En._maxEventSize))break e}}this._proxy.$onDidChange(h,g)});return new C.Disposable(()=>{_==null||_.dispose(),this._proxy.$unregisterDecorationProvider(h),this._provider.delete(h)})}async $provideDecorations(f,c,h){if(!this._provider.has(f))return Object.create(null);const _=Object.create(null),{provider:w,extensionId:b}=this._provider.get(f);return await Promise.all(c.map(async d=>{try{const{uri:u,id:g}=d,t=await Promise.resolve(w.provideFileDecoration(p.URI.revive(u),h));if(!t)return;try{C.FileDecoration.validate(t),_[g]=[t.propagate,t.tooltip,t.badge,t.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${b.value}': ${i}`)}}catch(u){this._logService.error(u)}})),_}};P._handlePool=0,P._maxEventSize=250,P=Ve([$e(0,A.IExtHostRpcService),$e(1,I.ILogService)],P),e.ExtHostDecorations=P,e.IExtHostDecorations=y.createDecorator("IExtHostDecorations")}),define(ge[223],pe([0,1,158,113,2,5,7,17,3,12,23]),function(X,e,p,R,C,y,A,I,E,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class P{constructor(c,h,_,w,b){this._name=c,this._owner=h,this._maxDiagnosticsPerFile=_,this._proxy=w,this._onDidChangeDiagnostics=b,this._isDisposed=!1,this._data=new r.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(c,h){if(!c){this.clear();return}this._checkDisposed();let _=[];if(C.URI.isUri(c)){if(!h){this.delete(c);return}this._data.set(c,h.slice()),_=[c]}else if(Array.isArray(c)){_=[];let b;c=[...c].sort(P._compareIndexedTuplesByUri);for(const d of c){const[u,g]=d;if((!b||u.toString()!==b.toString())&&(b&&this._data.get(b).length===0&&this._data.delete(b),b=u,_.push(u),this._data.set(u,[])),g){const t=this._data.get(u);t&&t.push(...g)}else{const t=this._data.get(u);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(_),!this._proxy)return;const w=[];for(let b of _){let d=[];const u=this._data.get(b);if(u)if(u.length>this._maxDiagnosticsPerFile){d=[];const g=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let i of u)if(i.severity===g[t]&&d.push(I.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;d.push({severity:R.MarkerSeverity.Info,message:p.localize(0,null,u.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=u.map(g=>I.Diagnostic.from(g));w.push([b,d])}this._proxy.$changeMany(this._owner,w)}delete(c){this._checkDisposed(),this._onDidChangeDiagnostics.fire([c]),this._data.delete(c),this._proxy&&this._proxy.$changeMany(this._owner,[[c,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(c,h){this._checkDisposed();for(let _ of this._data.keys())c.apply(h,[_,this.get(_),this])}get(c){this._checkDisposed();const h=this._data.get(c);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(c){return this._checkDisposed(),Array.isArray(this._data.get(c))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(c,h){return c[0].toString()<h[0].toString()?-1:c[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=P;let l=class Gt{constructor(c,h){this._logService=h,this._collections=new Map,this._onDidChangeDiagnostics=new E.Emitter,this.onDidChangeDiagnostics=E.Event.map(E.Event.debounce(this._onDidChangeDiagnostics.event,Gt._debouncer,50),Gt._mapper),this._proxy=c.getProxy(y.MainContext.MainThreadDiagnostics)}static _debouncer(c,h){return c?c.concat(h):h}static _mapper(c){const h=new r.ResourceMap;for(const _ of c)h.set(_,_);return{uris:Object.freeze(Array.from(h.values()))}}createDiagnosticCollection(c,h){const{_collections:_,_proxy:w,_onDidChangeDiagnostics:b,_logService:d}=this,u=new class{$changeMany(i,s){w.$changeMany(i,s),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,i,s.length===0?"CLEARING":s)}$clear(i){w.$clear(i),d.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,i)}dispose(){w.dispose()}};let g;if(!h)h="_generated_diagnostic_collection_name_#"+Gt._idPool++,g=h;else if(!_.has(h))g=h;else{this._logService.warn(`DiagnosticCollection with name '${h}' does already exist.`);do g=h+Gt._idPool++;while(_.has(g))}return new class extends P{constructor(){super(h,g,Gt._maxDiagnosticsPerFile,u,b);_.set(g,this)}dispose(){super.dispose(),_.delete(g)}}}getDiagnostics(c){if(c)return this._getDiagnostics(c);{const h=new Map,_=[];for(const w of this._collections.values())w.forEach((b,d)=>{let u=h.get(b.toString());typeof u=="undefined"&&(u=_.length,h.set(b.toString(),u),_.push([b,[]])),_[u][1]=_[u][1].concat(...d)});return _}}_getDiagnostics(c){let h=[];for(let _ of this._collections.values())_.has(c)&&(h=h.concat(_.get(c)));return h}$acceptMarkersChange(c){if(!this._mirrorCollection){const h="_generated_mirror",_=new P(h,h,Gt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(h,_),this._mirrorCollection=_}for(const[h,_]of c)this._mirrorCollection.set(C.URI.revive(h),_.map(I.Diagnostic.to))}};l._idPool=0,l._maxDiagnosticsPerFile=1e3,l=Ve([$e(1,k.ILogService)],l),e.ExtHostDiagnostics=l}),define(ge[224],pe([0,1,2,5]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class C{constructor(A){this._proxy=A.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(A){return this._proxy.$showOpenDialog(A).then(I=>I?I.map(E=>p.URI.revive(E)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(I=>I?p.URI.revive(I):void 0)}}e.ExtHostDialogs=C}),define(ge[225],pe([0,1,14,2,7,5,10,21,8]),function(X,e,p,R,C,y,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(P,l,f){this._documentsAndEditors=l,this._logService=f,this._documentContentProviders=new Map,this._proxy=P.getProxy(y.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,l){if(Object.keys(A.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const f=k._handlePool++;this._documentContentProviders.set(f,l),this._proxy.$registerTextContentProvider(f,P);let c;return typeof l.onDidChange=="function"&&(c=l.onDidChange(h=>{if(h.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(h)&&this.$provideTextDocumentContent(f,h).then(_=>{if(!_&&typeof _!="string")return;const w=this._documentsAndEditors.getDocument(h);if(!w)return;const b=E.splitLines(_);if(!w.equalLines(b))return this._proxy.$onVirtualDocumentChange(h,_)},p.onUnexpectedError)})),new C.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),c&&(c.dispose(),c=void 0)})}$provideTextDocumentContent(P,l){const f=this._documentContentProviders.get(P);return f?Promise.resolve(f.provideTextDocumentContent(R.URI.revive(l),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(ge[226],pe([0,1,3,6,2,5,119,17,15,25]),function(X,e,p,R,C,y,A,I,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class r{constructor(l,f){this._onDidAddDocument=new p.Emitter,this._onDidRemoveDocument=new p.Emitter,this._onDidChangeDocument=new p.Emitter,this._onDidSaveDocument=new p.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=l.getProxy(y.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(c=>{for(const h of c)this._onDidRemoveDocument.fire(h.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(c=>{for(const h of c)this._onDidAddDocument.fire(h.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(l){if(!l)return;const f=this._documentsAndEditors.getDocument(l);if(f)return f}getDocument(l){const f=this.getDocumentData(l);if(!(f==null?void 0:f.document))throw new Error(`Unable to retrieve document from URI '${l}'`);return f.document}ensureDocumentData(l){const f=this._documentsAndEditors.getDocument(l);if(f)return Promise.resolve(f);let c=this._documentLoader.get(l.toString());return c||(c=this._proxy.$tryOpenDocument(l).then(h=>{this._documentLoader.delete(l.toString());const _=C.URI.revive(h);return E.assertIsDefined(this._documentsAndEditors.getDocument(_))},h=>(this._documentLoader.delete(l.toString()),Promise.reject(h))),this._documentLoader.set(l.toString(),c)),c}createDocumentData(l){return this._proxy.$tryCreateDocument(l).then(f=>C.URI.revive(f))}$acceptModelModeChanged(l,f){const c=C.URI.revive(l),h=this._documentsAndEditors.getDocument(c);if(!h)throw new Error("unknown document");this._onDidRemoveDocument.fire(h.document),h._acceptLanguageId(f),this._onDidAddDocument.fire(h.document)}$acceptModelSaved(l){const f=C.URI.revive(l),c=this._documentsAndEditors.getDocument(f);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(l,!1),this._onDidSaveDocument.fire(c.document)}$acceptDirtyStateChanged(l,f){const c=C.URI.revive(l),h=this._documentsAndEditors.getDocument(c);if(!h)throw new Error("unknown document");h._acceptIsDirty(f),this._onDidChangeDocument.fire({document:h.document,contentChanges:[]})}$acceptModelChanged(l,f,c){const h=C.URI.revive(l),_=this._documentsAndEditors.getDocument(h);if(!_)throw new Error("unknown document");_._acceptIsDirty(c),_.onEvents(f),this._onDidChangeDocument.fire(k.deepFreeze({document:_.document,contentChanges:f.changes.map(w=>({range:I.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text}))}))}setWordDefinitionFor(l,f){A.setWordDefinitionFor(l,f)}}e.ExtHostDocuments=r}),define(ge[42],pe([0,1,50,3,6,2,4,5,119,13,124,17,12,23,10,52,134]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(u){this.value=u,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(u,g){this._extHostRpc=u,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const g=[],t=[],i=[];if(u.removedDocuments)for(const s of u.removedDocuments){const n=y.URI.revive(s),o=this._documents.get(n);(o==null?void 0:o.unref())&&(this._documents.delete(n),g.push(o.value))}if(u.addedDocuments)for(const s of u.addedDocuments){const n=y.URI.revive(s.uri);let o=this._documents.get(n);if(o&&n.scheme!==c.Schemas.vscodeNotebookCell)throw new Error(`document '${n} already exists!'`);o||(o=new w(new E.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),n,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(n,o),t.push(o.value)),o.ref()}if(u.removedEditors)for(const s of u.removedEditors){const n=this._editors.get(s);this._editors.delete(s),n&&i.push(n)}if(u.addedEditors)for(const s of u.addedEditors){const n=y.URI.revive(s.documentUri);p.ok(this._documents.has(n),`document '${n}' does not exist`),p.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const o=this._documents.get(n).value,v=new r.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new _.Lazy(()=>o.document),s.selections.map(P.Selection.to),s.options,s.visibleRanges.map(m=>P.Range.to(m)),typeof s.editorPosition=="number"?P.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,v)}u.newActiveEditor!==void 0&&(p.ok(u.newActiveEditor===null||this._editors.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this._activeEditorId=u.newActiveEditor),C.dispose(g),C.dispose(i),u.removedDocuments&&this._onDidRemoveDocuments.fire(g),u.addedDocuments&&this._onDidAddDocuments.fire(t),(u.removedEditors||u.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),u.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(u){var g;return(g=this._documents.get(u))===null||g===void 0?void 0:g.value}allDocuments(){return h.Iterable.map(this._documents.values(),u=>u.value)}getEditor(u){return this._editors.get(u)}activeEditor(u){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return u?g:g==null?void 0:g.value}allEditors(){return[...this._editors.values()]}};b=Ve([$e(0,k.IExtHostRpcService),$e(1,l.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=A.createDecorator("IExtHostDocumentsAndEditors")}),define(ge[227],pe([0,1,2,5,6,7,17,142,8,22]),function(X,e,p,R,C,y,A,I,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class r{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const c=this._schemes.indexOf(f);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),c=[];let h,_,w=14,b=14;for(const d of f){let u=h?E.commonPrefixLength(h,d):0;for(u===0?_=1:_=b;u<d.length;u++)u+1===d.length?(w=b,b=9):b+=1,c.push([_,d.toUpperCase().charCodeAt(u),b]),c.push([_,d.toLowerCase().charCodeAt(u),b]),_=b;h=d,b=w}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new I.StateMachine(c)}}provideDocumentLinks(f){this._initStateMachine();const c=[],h=I.LinkComputer.computeLinks({getLineContent(_){return f.lineAt(_-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const _ of h){const w=A.DocumentLink.to(_);w.target&&c.push(w)}return c}}class P{constructor(f,c){this._extHostLanguageFeatures=c,this._linkProvider=new r,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=f.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){var f;(f=this._linkProviderRegistration)===null||f===void 0||f.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,c,h,_={},w){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const b=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(b,h),this._enableProposedApi.set(b,w??!1);let d=2;_.isCaseSensitive&&(d+=1024),_.isReadonly&&(d+=2048),typeof h.copy=="function"&&(d+=8),typeof h.open=="function"&&typeof h.close=="function"&&typeof h.read=="function"&&typeof h.write=="function"&&(d+=4),this._proxy.$registerFileSystemProvider(b,c,d).catch(g=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${c}`),console.error(g)});const u=h.onDidChangeFile(g=>{const t=[];for(const i of g){let{uri:s,type:n}=i;if(s.scheme!==c)continue;let o;switch(n){case y.FileChangeType.Changed:o=0;break;case y.FileChangeType.Created:o=1;break;case y.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:o})}this._proxy.$onFileSystemChange(b,t)});return C.toDisposable(()=>{u.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(b),this._enableProposedApi.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(f,c){const{type:h,ctime:_,mtime:w,size:b,permissions:d}=f;return c?{type:h,ctime:_,mtime:w,size:b,permissions:d}:{type:h,ctime:_,mtime:w,size:b}}$stat(f,c){return Promise.resolve(this._getFsProvider(f).stat(p.URI.revive(c))).then(h=>{var _;return P._asIStat(h,(_=this._enableProposedApi.get(f))!==null&&_!==void 0?_:!1)})}$readdir(f,c){return Promise.resolve(this._getFsProvider(f).readDirectory(p.URI.revive(c)))}$readFile(f,c){return Promise.resolve(this._getFsProvider(f).readFile(p.URI.revive(c))).then(h=>k.VSBuffer.wrap(h))}$writeFile(f,c,h,_){return Promise.resolve(this._getFsProvider(f).writeFile(p.URI.revive(c),h.buffer,_))}$delete(f,c,h){return Promise.resolve(this._getFsProvider(f).delete(p.URI.revive(c),h))}$rename(f,c,h,_){return Promise.resolve(this._getFsProvider(f).rename(p.URI.revive(c),p.URI.revive(h),_))}$copy(f,c,h,_){const w=this._getFsProvider(f);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(p.URI.revive(c),p.URI.revive(h),_))}$mkdir(f,c){return Promise.resolve(this._getFsProvider(f).createDirectory(p.URI.revive(c)))}$watch(f,c,h,_){const w=this._getFsProvider(f).watch(p.URI.revive(h),_);this._watches.set(c,w)}$unwatch(f,c){const h=this._watches.get(c);h&&(h.dispose(),this._watches.delete(c))}$open(f,c,h){const _=this._getFsProvider(f);if(!_.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(_.open(p.URI.revive(c),h))}$close(f,c){const h=this._getFsProvider(f);if(!h.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(h.close(c))}$read(f,c,h,_){const w=this._getFsProvider(f);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const b=k.VSBuffer.alloc(_);return Promise.resolve(w.read(c,h,b.buffer,0,_)).then(d=>b.slice(0,d))}$write(f,c,h,_){const w=this._getFsProvider(f);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(c,h,_.buffer,0,_.byteLength))}_getFsProvider(f){const c=this._fsProvider.get(f);if(!c){const h=new Error;throw h.name="ENOPRO",h.message="no provider",h}return c}}e.ExtHostFileSystem=P}),define(ge[86],pe([0,1,5,41,7,22,4,13,59]),function(X,e,p,R,C,y,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Ut{constructor(P,l){const f=P.getProxy(p.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(c){return f.$stat(c).catch(Ut._handleError)},readDirectory(c){return f.$readdir(c).catch(Ut._handleError)},createDirectory(c){return f.$mkdir(c).catch(Ut._handleError)},async readFile(c){return f.$readFile(c).then(h=>h.buffer).catch(Ut._handleError)},writeFile(c,h){return f.$writeFile(c,y.VSBuffer.wrap(h)).catch(Ut._handleError)},delete(c,h){return f.$delete(c,Object.assign({recursive:!1,useTrash:!1},h)).catch(Ut._handleError)},rename(c,h,_){return f.$rename(c,h,Object.assign({overwrite:!1},_)).catch(Ut._handleError)},copy(c,h,_){return f.$copy(c,h,Object.assign({overwrite:!1},_)).catch(Ut._handleError)},isWritableFileSystem(c){const h=l.getCapabilities(c);if(typeof h=="number")return!(h&2048)}})}static _handleError(P){if(!(P instanceof Error))throw new C.FileSystemError(String(P));if(P.name==="ENOPRO")throw C.FileSystemError.Unavailable(P.message);switch(P.name){case R.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(P.message);case R.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(P.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(P.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(P.message);case R.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(P.message);case R.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(P.message);default:throw new C.FileSystemError(P.message,P.name)}}};k=Ve([$e(0,I.IExtHostRpcService),$e(1,E.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=A.createDecorator("IExtHostConsumerFileSystem")}),define(ge[228],pe([0,1,6,5]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(A){this._handlePool=0,this._proxy=A.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,A),p.toDisposable(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=C}),define(ge[229],pe([0,1,2,25,17,7,16,5,8,40,18,15,139,6,107,70,82,43,14,3]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h,_,w,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class u{constructor(j,Z){this._documents=j,this._provider=Z}provideDocumentSymbols(j,Z){const ie=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentSymbols(ie,Z)).then(oe=>{if(!r.isFalsyOrEmpty(oe))return oe[0]instanceof y.DocumentSymbol?oe.map(C.DocumentSymbol.from):u._asDocumentSymbolTree(oe)})}static _asDocumentSymbolTree(j){var Z;j=j.slice(0).sort((J,le)=>{let me=J.location.range.start.compareTo(le.location.range.start);return me===0&&(me=le.location.range.end.compareTo(J.location.range.end)),me});const ie=[],oe=[];for(const J of j){const le={name:J.name||"!!MISSING: name!!",kind:C.SymbolKind.from(J.kind),tags:((Z=J.tags)===null||Z===void 0?void 0:Z.map(C.SymbolTag.from))||[],detail:"",containerName:J.containerName,range:C.Range.from(J.location.range),selectionRange:C.Range.from(J.location.range),children:[]};for(;;){if(oe.length===0){oe.push(le),ie.push(le);break}const me=oe[oe.length-1];if(k.Range.containsRange(me.range,le.range)&&!k.Range.equalsRange(me.range,le.range)){me.children&&me.children.push(le),oe.push(le);break}oe.pop()}}return ie}}class g{constructor(j,Z,ie){this._documents=j,this._commands=Z,this._provider=ie,this._cache=new _.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(j,Z){const ie=this._documents.getDocument(j),oe=await this._provider.provideCodeLenses(ie,Z);if(!oe||Z.isCancellationRequested)return;const J=this._cache.add(oe),le=new f.DisposableStore;this._disposables.set(J,le);const me={cacheId:J,lenses:[]};for(let Le=0;Le<oe.length;Le++)me.lenses.push({cacheId:[J,Le],range:C.Range.from(oe[Le].range),command:this._commands.toInternal(oe[Le].command,le)});return me}async resolveCodeLens(j,Z){var ie;const oe=j.cacheId&&this._cache.get(...j.cacheId);if(!oe)return;let J;if(typeof this._provider.resolveCodeLens!="function"||oe.isResolved?J=oe:J=await this._provider.resolveCodeLens(oe,Z),J||(J=oe),Z.isCancellationRequested)return;const le=j.cacheId&&this._disposables.get(j.cacheId[0]);if(!!le)return j.command=this._commands.toInternal((ie=J.command)!==null&&ie!==void 0?ie:g._badCmd,le),j}releaseCodeLenses(j){var Z;(Z=this._disposables.get(j))===null||Z===void 0||Z.dispose(),this._disposables.delete(j),this._cache.delete(j)}}g._badCmd={command:"missing",title:"!!MISSING: command!!"};function t(je){return Array.isArray(je)?je.map(C.DefinitionLink.from):je?[C.DefinitionLink.from(je)]:[]}class i{constructor(j,Z){this._documents=j,this._provider=Z}provideDefinition(j,Z,ie){const oe=this._documents.getDocument(j),J=C.Position.to(Z);return A.asPromise(()=>this._provider.provideDefinition(oe,J,ie)).then(t)}}class s{constructor(j,Z){this._documents=j,this._provider=Z}provideDeclaration(j,Z,ie){const oe=this._documents.getDocument(j),J=C.Position.to(Z);return A.asPromise(()=>this._provider.provideDeclaration(oe,J,ie)).then(t)}}class n{constructor(j,Z){this._documents=j,this._provider=Z}provideImplementation(j,Z,ie){const oe=this._documents.getDocument(j),J=C.Position.to(Z);return A.asPromise(()=>this._provider.provideImplementation(oe,J,ie)).then(t)}}class o{constructor(j,Z){this._documents=j,this._provider=Z}provideTypeDefinition(j,Z,ie){const oe=this._documents.getDocument(j),J=C.Position.to(Z);return A.asPromise(()=>this._provider.provideTypeDefinition(oe,J,ie)).then(t)}}class v{constructor(j,Z){this._documents=j,this._provider=Z}provideHover(j,Z,ie){const oe=this._documents.getDocument(j),J=C.Position.to(Z);return A.asPromise(()=>this._provider.provideHover(oe,J,ie)).then(le=>{if(!(!le||r.isFalsyOrEmpty(le.contents)))return le.range||(le.range=oe.getWordRangeAtPosition(J)),le.range||(le.range=new y.Range(J,J)),C.Hover.from(le)})}}class m{constructor(j,Z){this._documents=j,this._provider=Z}provideEvaluatableExpression(j,Z,ie){const oe=this._documents.getDocument(j),J=C.Position.to(Z);return A.asPromise(()=>this._provider.provideEvaluatableExpression(oe,J,ie)).then(le=>{if(le)return C.EvaluatableExpression.from(le)})}}class S{constructor(j,Z){this._documents=j,this._provider=Z}provideInlineValues(j,Z,ie,oe){const J=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideInlineValues(J,C.Range.to(Z),C.InlineValueContext.to(ie),oe)).then(le=>{if(Array.isArray(le))return le.map(me=>C.InlineValue.from(me))})}}class D{constructor(j,Z){this._documents=j,this._provider=Z}provideDocumentHighlights(j,Z,ie){const oe=this._documents.getDocument(j),J=C.Position.to(Z);return A.asPromise(()=>this._provider.provideDocumentHighlights(oe,J,ie)).then(le=>{if(Array.isArray(le))return le.map(C.DocumentHighlight.from)})}}class a{constructor(j,Z){this._documents=j,this._provider=Z}provideLinkedEditingRanges(j,Z,ie){const oe=this._documents.getDocument(j),J=C.Position.to(Z);return A.asPromise(()=>this._provider.provideLinkedEditingRanges(oe,J,ie)).then(le=>{if(le&&Array.isArray(le.ranges))return{ranges:r.coalesce(le.ranges.map(C.Range.from)),wordPattern:le.wordPattern}})}}class T{constructor(j,Z){this._documents=j,this._provider=Z}provideReferences(j,Z,ie,oe){const J=this._documents.getDocument(j),le=C.Position.to(Z);return A.asPromise(()=>this._provider.provideReferences(J,le,ie,oe)).then(me=>{if(Array.isArray(me))return me.map(C.location.from)})}}class L{constructor(j,Z,ie,oe,J,le,me){this._documents=j,this._commands=Z,this._diagnostics=ie,this._provider=oe,this._logService=J,this._extension=le,this._apiDeprecation=me,this._cache=new _.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(j,Z,ie,oe){const J=this._documents.getDocument(j),le=l.Selection.isISelection(Z)?C.Selection.to(Z):C.Range.to(Z),me=[];for(const We of this._diagnostics.getDiagnostics(j))if(le.intersection(We.range)&&me.push(We)>L._maxCodeActionsPerFile)break;const Le={diagnostics:me,only:ie.only?new y.CodeActionKind(ie.only):void 0,triggerKind:C.CodeActionTriggerKind.to(ie.trigger)};return A.asPromise(()=>this._provider.provideCodeActions(J,le,Le,oe)).then(We=>{var be;if(!r.isNonEmptyArray(We)||oe.isCancellationRequested)return;const Qe=this._cache.add(We),K=new f.DisposableStore;this._disposables.set(Qe,K);const re=[];for(let ve=0;ve<We.length;ve++){const Fe=We[ve];!Fe||(L._isCommand(Fe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),re.push({_isSynthetic:!0,title:Fe.title,command:this._commands.toInternal(Fe,K)})):(Le.only&&(Fe.kind?Le.only.contains(Fe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action is of kind '${Fe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),re.push({cacheId:[Qe,ve],title:Fe.title,command:Fe.command&&this._commands.toInternal(Fe.command,K),diagnostics:Fe.diagnostics&&Fe.diagnostics.map(C.Diagnostic.from),edit:Fe.edit&&C.WorkspaceEdit.from(Fe.edit),kind:Fe.kind&&Fe.kind.value,isPreferred:Fe.isPreferred,disabled:(be=Fe.disabled)===null||be===void 0?void 0:be.reason})))}return{cacheId:Qe,actions:re}})}async resolveCodeAction(j,Z){var ie;const[oe,J]=j,le=this._cache.get(oe,J);if(!le||L._isCommand(le)||!this._provider.resolveCodeAction)return;const me=(ie=await this._provider.resolveCodeAction(le,Z))!==null&&ie!==void 0?ie:le;return(me==null?void 0:me.edit)?C.WorkspaceEdit.from(me.edit):void 0}releaseCodeActions(j){var Z;(Z=this._disposables.get(j))===null||Z===void 0||Z.dispose(),this._disposables.delete(j),this._cache.delete(j)}static _isCommand(j){return typeof j.command=="string"&&typeof j.title=="string"}}L._maxCodeActionsPerFile=1e3;class U{constructor(j,Z){this._documents=j,this._provider=Z}provideDocumentFormattingEdits(j,Z,ie){const oe=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentFormattingEdits(oe,Z,ie)).then(J=>{if(Array.isArray(J))return J.map(C.TextEdit.from)})}}class G{constructor(j,Z){this._documents=j,this._provider=Z}provideDocumentRangeFormattingEdits(j,Z,ie,oe){const J=this._documents.getDocument(j),le=C.Range.to(Z);return A.asPromise(()=>this._provider.provideDocumentRangeFormattingEdits(J,le,ie,oe)).then(me=>{if(Array.isArray(me))return me.map(C.TextEdit.from)})}}class te{constructor(j,Z){this._documents=j,this._provider=Z,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(j,Z,ie,oe,J){const le=this._documents.getDocument(j),me=C.Position.to(Z);return A.asPromise(()=>this._provider.provideOnTypeFormattingEdits(le,me,ie,oe,J)).then(Le=>{if(Array.isArray(Le))return Le.map(C.TextEdit.from)})}}class V{constructor(j,Z){this._provider=j,this._logService=Z,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(j,Z){const ie=I.IdObject.mixin({symbols:[]});return A.asPromise(()=>this._provider.provideWorkspaceSymbols(j,Z)).then(oe=>{if(r.isNonEmptyArray(oe))for(const J of oe){if(!J)continue;if(!J.name){this._logService.warn("INVALID SymbolInformation, lacks name",J);continue}const le=I.IdObject.mixin(C.WorkspaceSymbol.from(J));this._symbolCache.set(le._id,J),ie.symbols.push(le)}}).then(()=>(ie.symbols.length>0&&this._resultCache.set(ie._id,[ie.symbols[0]._id,ie.symbols[ie.symbols.length-1]._id]),ie))}async resolveWorkspaceSymbol(j,Z){if(typeof this._provider.resolveWorkspaceSymbol!="function")return j;const ie=this._symbolCache.get(j._id);if(ie){const oe=await A.asPromise(()=>this._provider.resolveWorkspaceSymbol(ie,Z));return oe&&R.mixin(j,C.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(j){const Z=this._resultCache.get(j);if(Z){for(let[ie,oe]=Z;ie<=oe;ie++)this._symbolCache.delete(ie);this._resultCache.delete(j)}}}class N{constructor(j,Z,ie){this._documents=j,this._provider=Z,this._logService=ie}static supportsResolving(j){return typeof j.prepareRename=="function"}provideRenameEdits(j,Z,ie,oe){const J=this._documents.getDocument(j),le=C.Position.to(Z);return A.asPromise(()=>this._provider.provideRenameEdits(J,le,ie,oe)).then(me=>{if(!!me)return C.WorkspaceEdit.from(me)},me=>{const Le=N._asMessage(me);return Le?{rejectReason:Le,edits:void 0}:Promise.reject(me)})}resolveRenameLocation(j,Z,ie){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument(j),J=C.Position.to(Z);return A.asPromise(()=>this._provider.prepareRename(oe,J,ie)).then(le=>{let me,Le;if(y.Range.isRange(le)?(me=le,Le=oe.getText(le)):P.isObject(le)&&(me=le.range,Le=le.placeholder),!!me){if(me.start.line>J.line||me.end.line<J.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(me),text:Le}}},le=>{const me=N._asMessage(le);return me?{rejectReason:me,range:void 0,text:void 0}:Promise.reject(le)})}static _asMessage(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class W{constructor(j,Z){this.resultId=j,this.tokens=Z}}class M{constructor(j,Z){this._documents=j,this._provider=Z,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(j,Z,ie){const oe=this._documents.getDocument(j),J=Z!==0?this._previousResults.get(Z):null;return A.asPromise(()=>J&&typeof J.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(oe,J.resultId,ie):this._provider.provideDocumentSemanticTokens(oe,ie)).then(le=>(J&&this._previousResults.delete(Z),le?(le=M._fixProvidedSemanticTokens(le),this._send(M._convertToEdits(J,le),le)):null))}async releaseDocumentSemanticColoring(j){this._previousResults.delete(j)}static _fixProvidedSemanticTokens(j){return M._isSemanticTokens(j)?M._isCorrectSemanticTokens(j)?j:new y.SemanticTokens(new Uint32Array(j.data),j.resultId):M._isSemanticTokensEdits(j)?M._isCorrectSemanticTokensEdits(j)?j:new y.SemanticTokensEdits(j.edits.map(Z=>new y.SemanticTokensEdit(Z.start,Z.deleteCount,Z.data?new Uint32Array(Z.data):Z.data)),j.resultId):j}static _isSemanticTokens(j){return j&&!!j.data}static _isCorrectSemanticTokens(j){return j.data instanceof Uint32Array}static _isSemanticTokensEdits(j){return j&&Array.isArray(j.edits)}static _isCorrectSemanticTokensEdits(j){for(const Z of j.edits)if(!(Z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(j,Z){if(!M._isSemanticTokens(Z)||!j||!j.tokens)return Z;const ie=j.tokens,oe=ie.length,J=Z.data,le=J.length;let me=0;const Le=Math.min(oe,le);for(;me<Le&&ie[me]===J[me];)me++;if(me===oe&&me===le)return new y.SemanticTokensEdits([],Z.resultId);let We=0;const be=Le-me;for(;We<be&&ie[oe-We-1]===J[le-We-1];)We++;return new y.SemanticTokensEdits([{start:me,deleteCount:oe-me-We,data:J.subarray(me,le-We)}],Z.resultId)}_send(j,Z){if(M._isSemanticTokens(j)){const ie=this._nextResultId++;return this._previousResults.set(ie,new W(j.resultId,j.data)),c.encodeSemanticTokensDto({id:ie,type:"full",data:j.data})}if(M._isSemanticTokensEdits(j)){const ie=this._nextResultId++;return M._isSemanticTokens(Z)?this._previousResults.set(ie,new W(Z.resultId,Z.data)):this._previousResults.set(ie,new W(j.resultId)),c.encodeSemanticTokensDto({id:ie,type:"delta",deltas:(j.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}e.DocumentSemanticTokensAdapter=M;class q{constructor(j,Z){this._documents=j,this._provider=Z}provideDocumentRangeSemanticTokens(j,Z,ie){const oe=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentRangeSemanticTokens(oe,C.Range.to(Z),ie)).then(J=>J?this._send(J):null)}_send(j){return c.encodeSemanticTokensDto({id:0,type:"full",data:j.data})}}e.DocumentRangeSemanticTokensAdapter=q;class O{constructor(j,Z,ie,oe,J){this._documents=j,this._commands=Z,this._provider=ie,this._apiDeprecation=oe,this._extension=J,this._cache=new _.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}async provideCompletionItems(j,Z,ie,oe){const J=this._documents.getDocument(j),le=C.Position.to(Z),me=J.getWordRangeAtPosition(le)||new y.Range(le,le),Le=me.with({end:le}),We=new w.StopWatch(!0),be=await A.asPromise(()=>this._provider.provideCompletionItems(J,le,oe,C.CompletionContext.to(ie)));if(!be||oe.isCancellationRequested)return;const Qe=Array.isArray(be)?new y.CompletionList(be):be,K=O.supportsResolving(this._provider)?this._cache.add(Qe.items):this._cache.add([]),re=new f.DisposableStore;this._disposables.set(K,re);const ve=[],Fe={x:K,b:ve,a:{replace:C.Range.from(me),insert:C.Range.from(Le)},c:Qe.isIncomplete||void 0,d:We.elapsed()};for(let Oe=0;Oe<Qe.items.length;Oe++){const Xe=Qe.items[Oe],De=this._convertCompletionItem(Xe,[K,Oe],Le,me);ve.push(De)}return Fe}async resolveCompletionItem(j,Z){if(typeof this._provider.resolveCompletionItem!="function")return;const ie=this._cache.get(...j);if(!ie)return;const oe=await A.asPromise(()=>this._provider.resolveCompletionItem(ie,Z));if(!!oe)return this._convertCompletionItem(oe,j)}releaseCompletionItems(j){var Z;(Z=this._disposables.get(j))===null||Z===void 0||Z.dispose(),this._disposables.delete(j),this._cache.delete(j)}_convertCompletionItem(j,Z,ie,oe){const J=this._disposables.get(Z[0]);if(!J)throw Error("DisposableStore is missing...");const le={x:Z,a:j.label,b:j.kind!==void 0?C.CompletionItemKind.from(j.kind):void 0,n:j.tags&&j.tags.map(C.CompletionItemTag.from),c:j.detail,d:typeof j.documentation=="undefined"?void 0:C.MarkdownString.fromStrict(j.documentation),e:j.sortText!==j.label?j.sortText:void 0,f:j.filterText!==j.label?j.filterText:void 0,g:j.preselect||void 0,i:j.keepWhitespace?1:0,k:j.commitCharacters,l:j.additionalTextEdits&&j.additionalTextEdits.map(C.TextEdit.from),m:this._commands.toInternal(j.command,J)};j.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),le.h=j.textEdit.newText):typeof j.insertText=="string"?le.h=j.insertText:j.insertText instanceof y.SnippetString&&(le.h=j.insertText.value,le.i|=4);let me;return j.textEdit?me=j.textEdit.range:j.range&&(me=j.range),y.Range.isRange(me)?le.j=C.Range.from(me):me&&(!(ie==null?void 0:ie.isEqual(me.inserting))||!(oe==null?void 0:oe.isEqual(me.replacing)))&&(le.j={insert:C.Range.from(me.inserting),replace:C.Range.from(me.replacing)}),le}}class F{constructor(j,Z,ie){this._documents=j,this._provider=Z,this._commands=ie,this._cache=new _.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(j,Z,ie,oe){const J=this._documents.getDocument(j),le=C.Position.to(Z),me=await A.asPromise(()=>this._provider.provideInlineCompletionItems(J,le,ie,oe));if(!me||oe.isCancellationRequested)return;const Le=P.isArray(me)?{items:me}:me,We=this._cache.add(Le.items);let be;return{pid:We,items:Le.items.map((Qe,K)=>{let re;return Qe.command&&(be||(be=new f.DisposableStore,this._disposables.set(We,be)),re=this._commands.toInternal(Qe.command,be)),{text:Qe.text,range:Qe.range?C.Range.from(Qe.range):void 0,command:re,idx:K}})}}disposeCompletions(j){this._cache.delete(j);const Z=this._disposables.get(j);Z&&Z.clear(),this._disposables.delete(j)}handleDidShowCompletionItem(j,Z){const ie=this._cache.get(j,Z);ie&&B.get(this._provider).fireOnDidShowCompletionItem({completionItem:ie})}}class B{constructor(){this._onDidShowCompletionItemEmitter=new d.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(j){let Z=B.map.get(j);return Z||(Z=new B,B.map.set(j,Z)),Z}fireOnDidShowCompletionItem(j){this._onDidShowCompletionItemEmitter.fire(j)}}e.InlineCompletionController=B,B.map=new WeakMap;class ${constructor(j,Z){this._documents=j,this._provider=Z,this._cache=new _.Cache("SignatureHelp")}provideSignatureHelp(j,Z,ie,oe){const J=this._documents.getDocument(j),le=C.Position.to(Z),me=this.reviveContext(ie);return A.asPromise(()=>this._provider.provideSignatureHelp(J,le,oe,me)).then(Le=>{if(Le){const We=this._cache.add([Le]);return Object.assign(Object.assign({},C.SignatureHelp.from(Le)),{id:We})}})}reviveContext(j){let Z;if(j.activeSignatureHelp){const ie=C.SignatureHelp.to(j.activeSignatureHelp),oe=this._cache.get(j.activeSignatureHelp.id,0);oe?(Z=oe,Z.activeSignature=ie.activeSignature,Z.activeParameter=ie.activeParameter):Z=ie}return Object.assign(Object.assign({},j),{activeSignatureHelp:Z})}releaseSignatureHelp(j){this._cache.delete(j)}}class Y{constructor(j,Z){this._documents=j,this._provider=Z}provideInlayHints(j,Z,ie){const oe=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideInlayHints(oe,C.Range.to(Z),ie)).then(J=>J?{hints:J.map(C.InlayHint.from)}:void 0)}}class ce{constructor(j,Z){this._documents=j,this._provider=Z,this._cache=new _.Cache("DocumentLink")}async provideLinks(j,Z){const ie=this._documents.getDocument(j),oe=await A.asPromise(()=>this._provider.provideDocumentLinks(ie,Z));if(!(!Array.isArray(oe)||oe.length===0)&&!Z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.filter(ce._validateLink).map(C.DocumentLink.from)};{const J=this._cache.add(oe),le={links:[],id:J};for(let me=0;me<oe.length;me++){if(!ce._validateLink(oe[me]))continue;const Le=C.DocumentLink.from(oe[me]);Le.cacheId=[J,me],le.links.push(Le)}return le}}}static _validateLink(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,Z){if(typeof this._provider.resolveDocumentLink!="function")return;const ie=this._cache.get(...j);if(!ie)return;const oe=await A.asPromise(()=>this._provider.resolveDocumentLink(ie,Z));if(!(!oe||!ce._validateLink(oe)))return C.DocumentLink.from(oe)}releaseLinks(j){this._cache.delete(j)}}class we{constructor(j,Z){this._documents=j,this._provider=Z}provideColors(j,Z){const ie=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentColors(ie,Z)).then(oe=>Array.isArray(oe)?oe.map(le=>({color:C.Color.from(le.color),range:C.Range.from(le.range)})):[])}provideColorPresentations(j,Z,ie){const oe=this._documents.getDocument(j),J=C.Range.to(Z.range),le=C.Color.to(Z.color);return A.asPromise(()=>this._provider.provideColorPresentations(le,{document:oe,range:J},ie)).then(me=>{if(!!Array.isArray(me))return me.map(C.ColorPresentation.from)})}}class Re{constructor(j,Z){this._documents=j,this._provider=Z}provideFoldingRanges(j,Z,ie){const oe=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideFoldingRanges(oe,Z,ie)).then(J=>{if(!!Array.isArray(J))return J.map(C.FoldingRange.from)})}}class ke{constructor(j,Z,ie){this._documents=j,this._provider=Z,this._logService=ie}provideSelectionRanges(j,Z,ie){const oe=this._documents.getDocument(j),J=Z.map(C.Position.to);return A.asPromise(()=>this._provider.provideSelectionRanges(oe,J,ie)).then(le=>{if(!r.isNonEmptyArray(le))return[];if(le.length!==J.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const me=[];for(let Le=0;Le<J.length;Le++){const We=[];me.push(We);let be=J[Le],Qe=le[Le];for(;;){if(!Qe.range.contains(be))throw new Error("INVALID selection range, must contain the previous range");if(We.push(C.SelectionRange.from(Qe)),!Qe.parent)break;be=Qe.range,Qe=Qe.parent}}return me})}}class Me{constructor(j,Z){this._documents=j,this._provider=Z,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(j,Z,ie){const oe=this._documents.getDocument(j),J=C.Position.to(Z),le=await this._provider.prepareCallHierarchy(oe,J,ie);if(!le)return;const me=this._idPool.nextId();return this._cache.set(me,new Map),Array.isArray(le)?le.map(Le=>this._cacheAndConvertItem(me,Le)):[this._cacheAndConvertItem(me,le)]}async provideCallsTo(j,Z,ie){const oe=this._itemFromCache(j,Z);if(!oe)throw new Error("missing call hierarchy item");const J=await this._provider.provideCallHierarchyIncomingCalls(oe,ie);if(!!J)return J.map(le=>({from:this._cacheAndConvertItem(j,le.from),fromRanges:le.fromRanges.map(me=>C.Range.from(me))}))}async provideCallsFrom(j,Z,ie){const oe=this._itemFromCache(j,Z);if(!oe)throw new Error("missing call hierarchy item");const J=await this._provider.provideCallHierarchyOutgoingCalls(oe,ie);if(!!J)return J.map(le=>({to:this._cacheAndConvertItem(j,le.to),fromRanges:le.fromRanges.map(me=>C.Range.from(me))}))}releaseSession(j){this._cache.delete(j)}_cacheAndConvertItem(j,Z){var ie;const oe=this._cache.get(j),J={_sessionId:j,_itemId:oe.size.toString(36),name:Z.name,detail:Z.detail,kind:C.SymbolKind.from(Z.kind),uri:Z.uri,range:C.Range.from(Z.range),selectionRange:C.Range.from(Z.selectionRange),tags:(ie=Z.tags)===null||ie===void 0?void 0:ie.map(C.SymbolTag.from)};return oe.set(J._itemId,Z),J}_itemFromCache(j,Z){const ie=this._cache.get(j);return ie==null?void 0:ie.get(Z)}}class Ge{constructor(j,Z){this.adapter=j,this.extension=Z}}class ze{constructor(j,Z,ie,oe,J,le,me){this._adapter=new Map,this._uriTransformer=Z,this._proxy=j.getProxy(I.MainContext.MainThreadLanguageFeatures),this._documents=ie,this._commands=oe,this._diagnostics=J,this._logService=le,this._apiDeprecation=me}_transformDocumentSelector(j){return r.coalesce(r.asArray(j).map(Z=>this._doTransformDocumentSelector(Z)))}_doTransformDocumentSelector(j){if(typeof j=="string")return{$serialized:!0,language:j};if(j)return{$serialized:!0,language:j.language,scheme:this._transformScheme(j.scheme),pattern:typeof j.pattern=="undefined"?void 0:C.GlobPattern.from(j.pattern),exclusive:j.exclusive}}_transformScheme(j){return this._uriTransformer&&typeof j=="string"?this._uriTransformer.transformOutgoingScheme(j):j}_createDisposable(j){return new y.Disposable(()=>{this._adapter.delete(j),this._proxy.$unregister(j)})}_nextHandle(){return ze._handlePool++}_withAdapter(j,Z,ie,oe,J=!1){const le=this._adapter.get(j);if(!le)return Promise.resolve(oe);if(le.adapter instanceof Z){let me;le.extension&&(me=Date.now(),this._logService.trace(`[${le.extension.identifier.value}] INVOKE provider '${Z.name}'`));const Le=ie(le.adapter,le.extension),We=le.extension;return We&&Promise.resolve(Le).then(()=>this._logService.trace(`[${We.identifier.value}] provider DONE after ${Date.now()-me}ms`),be=>{J&&be instanceof b.CancellationError||(this._logService.error(`[${We.identifier.value}] provider FAILED`),this._logService.error(be))}),Le}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(j,Z){const ie=this._nextHandle();return this._adapter.set(ie,new Ge(j,Z)),ie}static _extLabel(j){return j.displayName||j.name}registerDocumentSymbolProvider(j,Z,ie,oe){const J=this._addNewAdapter(new u(this._documents,ie),j),le=oe&&oe.label||ze._extLabel(j);return this._proxy.$registerDocumentSymbolProvider(J,this._transformDocumentSelector(Z),le),this._createDisposable(J)}$provideDocumentSymbols(j,Z,ie){return this._withAdapter(j,u,oe=>oe.provideDocumentSymbols(p.URI.revive(Z),ie),void 0)}registerCodeLensProvider(j,Z,ie){const oe=this._nextHandle(),J=typeof ie.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Ge(new g(this._documents,this._commands.converter,ie),j)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(Z),J);let le=this._createDisposable(oe);if(J!==void 0){const me=ie.onDidChangeCodeLenses(Le=>this._proxy.$emitCodeLensEvent(J));le=y.Disposable.from(le,me)}return le}$provideCodeLenses(j,Z,ie){return this._withAdapter(j,g,oe=>oe.provideCodeLenses(p.URI.revive(Z),ie),void 0)}$resolveCodeLens(j,Z,ie){return this._withAdapter(j,g,oe=>oe.resolveCodeLens(Z,ie),void 0)}$releaseCodeLenses(j,Z){this._withAdapter(j,g,ie=>Promise.resolve(ie.releaseCodeLenses(Z)),void 0)}registerDefinitionProvider(j,Z,ie){const oe=this._addNewAdapter(new i(this._documents,ie),j);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideDefinition(j,Z,ie,oe){return this._withAdapter(j,i,J=>J.provideDefinition(p.URI.revive(Z),ie,oe),[])}registerDeclarationProvider(j,Z,ie){const oe=this._addNewAdapter(new s(this._documents,ie),j);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideDeclaration(j,Z,ie,oe){return this._withAdapter(j,s,J=>J.provideDeclaration(p.URI.revive(Z),ie,oe),[])}registerImplementationProvider(j,Z,ie){const oe=this._addNewAdapter(new n(this._documents,ie),j);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideImplementation(j,Z,ie,oe){return this._withAdapter(j,n,J=>J.provideImplementation(p.URI.revive(Z),ie,oe),[])}registerTypeDefinitionProvider(j,Z,ie){const oe=this._addNewAdapter(new o(this._documents,ie),j);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideTypeDefinition(j,Z,ie,oe){return this._withAdapter(j,o,J=>J.provideTypeDefinition(p.URI.revive(Z),ie,oe),[])}registerHoverProvider(j,Z,ie,oe){const J=this._addNewAdapter(new v(this._documents,ie),j);return this._proxy.$registerHoverProvider(J,this._transformDocumentSelector(Z)),this._createDisposable(J)}$provideHover(j,Z,ie,oe){return this._withAdapter(j,v,J=>J.provideHover(p.URI.revive(Z),ie,oe),void 0)}registerEvaluatableExpressionProvider(j,Z,ie,oe){const J=this._addNewAdapter(new m(this._documents,ie),j);return this._proxy.$registerEvaluatableExpressionProvider(J,this._transformDocumentSelector(Z)),this._createDisposable(J)}$provideEvaluatableExpression(j,Z,ie,oe){return this._withAdapter(j,m,J=>J.provideEvaluatableExpression(p.URI.revive(Z),ie,oe),void 0)}registerInlineValuesProvider(j,Z,ie,oe){const J=typeof ie.onDidChangeInlineValues=="function"?this._nextHandle():void 0,le=this._addNewAdapter(new S(this._documents,ie),j);this._proxy.$registerInlineValuesProvider(le,this._transformDocumentSelector(Z),J);let me=this._createDisposable(le);if(J!==void 0){const Le=ie.onDidChangeInlineValues(We=>this._proxy.$emitInlineValuesEvent(J));me=y.Disposable.from(me,Le)}return me}$provideInlineValues(j,Z,ie,oe,J){return this._withAdapter(j,S,le=>le.provideInlineValues(p.URI.revive(Z),ie,oe,J),void 0)}registerDocumentHighlightProvider(j,Z,ie){const oe=this._addNewAdapter(new D(this._documents,ie),j);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideDocumentHighlights(j,Z,ie,oe){return this._withAdapter(j,D,J=>J.provideDocumentHighlights(p.URI.revive(Z),ie,oe),void 0)}registerLinkedEditingRangeProvider(j,Z,ie){const oe=this._addNewAdapter(new a(this._documents,ie),j);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideLinkedEditingRanges(j,Z,ie,oe){return this._withAdapter(j,a,async J=>{const le=await J.provideLinkedEditingRanges(p.URI.revive(Z),ie,oe);if(le)return{ranges:le.ranges,wordPattern:le.wordPattern?ze._serializeRegExp(le.wordPattern):void 0}},void 0)}registerReferenceProvider(j,Z,ie){const oe=this._addNewAdapter(new T(this._documents,ie),j);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideReferences(j,Z,ie,oe,J){return this._withAdapter(j,T,le=>le.provideReferences(p.URI.revive(Z),ie,oe,J),void 0)}registerCodeActionProvider(j,Z,ie,oe){var J,le;const me=new f.DisposableStore,Le=this._addNewAdapter(new L(this._documents,this._commands.converter,this._diagnostics,ie,this._logService,j,this._apiDeprecation),j);return this._proxy.$registerQuickFixSupport(Le,this._transformDocumentSelector(Z),{providedKinds:(J=oe==null?void 0:oe.providedCodeActionKinds)===null||J===void 0?void 0:J.map(We=>We.value),documentation:(le=oe==null?void 0:oe.documentation)===null||le===void 0?void 0:le.map(We=>({kind:We.kind.value,command:this._commands.converter.toInternal(We.command,me)}))},ze._extLabel(j),Boolean(ie.resolveCodeAction)),me.add(this._createDisposable(Le)),me}$provideCodeActions(j,Z,ie,oe,J){return this._withAdapter(j,L,le=>le.provideCodeActions(p.URI.revive(Z),ie,oe,J),void 0)}$resolveCodeAction(j,Z,ie){return this._withAdapter(j,L,oe=>oe.resolveCodeAction(Z,ie),void 0)}$releaseCodeActions(j,Z){this._withAdapter(j,L,ie=>Promise.resolve(ie.releaseCodeActions(Z)),void 0)}registerDocumentFormattingEditProvider(j,Z,ie){const oe=this._addNewAdapter(new U(this._documents,ie),j);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(Z),j.identifier,j.displayName||j.name),this._createDisposable(oe)}$provideDocumentFormattingEdits(j,Z,ie,oe){return this._withAdapter(j,U,J=>J.provideDocumentFormattingEdits(p.URI.revive(Z),ie,oe),void 0)}registerDocumentRangeFormattingEditProvider(j,Z,ie){const oe=this._addNewAdapter(new G(this._documents,ie),j);return this._proxy.$registerRangeFormattingSupport(oe,this._transformDocumentSelector(Z),j.identifier,j.displayName||j.name),this._createDisposable(oe)}$provideDocumentRangeFormattingEdits(j,Z,ie,oe,J){return this._withAdapter(j,G,le=>le.provideDocumentRangeFormattingEdits(p.URI.revive(Z),ie,oe,J),void 0)}registerOnTypeFormattingEditProvider(j,Z,ie,oe){const J=this._addNewAdapter(new te(this._documents,ie),j);return this._proxy.$registerOnTypeFormattingSupport(J,this._transformDocumentSelector(Z),oe,j.identifier),this._createDisposable(J)}$provideOnTypeFormattingEdits(j,Z,ie,oe,J,le){return this._withAdapter(j,te,me=>me.provideOnTypeFormattingEdits(p.URI.revive(Z),ie,oe,J,le),void 0)}registerWorkspaceSymbolProvider(j,Z){const ie=this._addNewAdapter(new V(Z,this._logService),j);return this._proxy.$registerNavigateTypeSupport(ie),this._createDisposable(ie)}$provideWorkspaceSymbols(j,Z,ie){return this._withAdapter(j,V,oe=>oe.provideWorkspaceSymbols(Z,ie),{symbols:[]})}$resolveWorkspaceSymbol(j,Z,ie){return this._withAdapter(j,V,oe=>oe.resolveWorkspaceSymbol(Z,ie),void 0)}$releaseWorkspaceSymbols(j,Z){this._withAdapter(j,V,ie=>ie.releaseWorkspaceSymbols(Z),void 0)}registerRenameProvider(j,Z,ie){const oe=this._addNewAdapter(new N(this._documents,ie,this._logService),j);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(Z),N.supportsResolving(ie)),this._createDisposable(oe)}$provideRenameEdits(j,Z,ie,oe,J){return this._withAdapter(j,N,le=>le.provideRenameEdits(p.URI.revive(Z),ie,oe,J),void 0)}$resolveRenameLocation(j,Z,ie,oe){return this._withAdapter(j,N,J=>J.resolveRenameLocation(p.URI.revive(Z),ie,oe),void 0)}registerDocumentSemanticTokensProvider(j,Z,ie,oe){const J=this._nextHandle(),le=typeof ie.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(J,new Ge(new M(this._documents,ie),j)),this._proxy.$registerDocumentSemanticTokensProvider(J,this._transformDocumentSelector(Z),oe,le);let me=this._createDisposable(J);if(le){const Le=ie.onDidChangeSemanticTokens(We=>this._proxy.$emitDocumentSemanticTokensEvent(le));me=y.Disposable.from(me,Le)}return me}$provideDocumentSemanticTokens(j,Z,ie,oe){return this._withAdapter(j,M,J=>J.provideDocumentSemanticTokens(p.URI.revive(Z),ie,oe),null,!0)}$releaseDocumentSemanticTokens(j,Z){this._withAdapter(j,M,ie=>ie.releaseDocumentSemanticColoring(Z),void 0)}registerDocumentRangeSemanticTokensProvider(j,Z,ie,oe){const J=this._addNewAdapter(new q(this._documents,ie),j);return this._proxy.$registerDocumentRangeSemanticTokensProvider(J,this._transformDocumentSelector(Z),oe),this._createDisposable(J)}$provideDocumentRangeSemanticTokens(j,Z,ie,oe){return this._withAdapter(j,q,J=>J.provideDocumentRangeSemanticTokens(p.URI.revive(Z),ie,oe),null,!0)}registerCompletionItemProvider(j,Z,ie,oe){const J=this._addNewAdapter(new O(this._documents,this._commands.converter,ie,this._apiDeprecation,j),j);return this._proxy.$registerSuggestSupport(J,this._transformDocumentSelector(Z),oe,O.supportsResolving(ie),`${j.identifier.value}(${oe.join("")})`),this._createDisposable(J)}$provideCompletionItems(j,Z,ie,oe,J){return this._withAdapter(j,O,le=>le.provideCompletionItems(p.URI.revive(Z),ie,oe,J),void 0)}$resolveCompletionItem(j,Z,ie){return this._withAdapter(j,O,oe=>oe.resolveCompletionItem(Z,ie),void 0)}$releaseCompletionItems(j,Z){this._withAdapter(j,O,ie=>ie.releaseCompletionItems(Z),void 0)}registerInlineCompletionsProvider(j,Z,ie){const oe=this._addNewAdapter(new F(this._documents,ie,this._commands.converter),j);return this._proxy.$registerInlineCompletionsSupport(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideInlineCompletions(j,Z,ie,oe,J){return this._withAdapter(j,F,le=>le.provideInlineCompletions(p.URI.revive(Z),ie,oe,J),void 0)}$handleInlineCompletionDidShow(j,Z,ie){this._withAdapter(j,F,async oe=>{oe.handleDidShowCompletionItem(Z,ie)},void 0)}$freeInlineCompletionsList(j,Z){this._withAdapter(j,F,async ie=>{ie.disposeCompletions(Z)},void 0)}registerSignatureHelpProvider(j,Z,ie,oe){const J=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,le=this._addNewAdapter(new $(this._documents,ie),j);return this._proxy.$registerSignatureHelpProvider(le,this._transformDocumentSelector(Z),J),this._createDisposable(le)}$provideSignatureHelp(j,Z,ie,oe,J){return this._withAdapter(j,$,le=>le.provideSignatureHelp(p.URI.revive(Z),ie,oe,J),void 0)}$releaseSignatureHelp(j,Z){this._withAdapter(j,$,ie=>ie.releaseSignatureHelp(Z),void 0)}registerInlayHintsProvider(j,Z,ie){const oe=typeof ie.onDidChangeInlayHints=="function"?this._nextHandle():void 0,J=this._addNewAdapter(new Y(this._documents,ie),j);this._proxy.$registerInlayHintsProvider(J,this._transformDocumentSelector(Z),oe);let le=this._createDisposable(J);if(oe!==void 0){const me=ie.onDidChangeInlayHints(Le=>this._proxy.$emitInlayHintsEvent(oe));le=y.Disposable.from(le,me)}return le}$provideInlayHints(j,Z,ie,oe){return this._withAdapter(j,Y,J=>J.provideInlayHints(p.URI.revive(Z),ie,oe),void 0)}registerDocumentLinkProvider(j,Z,ie){const oe=this._addNewAdapter(new ce(this._documents,ie),j);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(Z),typeof ie.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks(j,Z,ie){return this._withAdapter(j,ce,oe=>oe.provideLinks(p.URI.revive(Z),ie),void 0)}$resolveDocumentLink(j,Z,ie){return this._withAdapter(j,ce,oe=>oe.resolveLink(Z,ie),void 0)}$releaseDocumentLinks(j,Z){this._withAdapter(j,ce,ie=>ie.releaseLinks(Z),void 0)}registerColorProvider(j,Z,ie){const oe=this._addNewAdapter(new we(this._documents,ie),j);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideDocumentColors(j,Z,ie){return this._withAdapter(j,we,oe=>oe.provideColors(p.URI.revive(Z),ie),[])}$provideColorPresentations(j,Z,ie,oe){return this._withAdapter(j,we,J=>J.provideColorPresentations(p.URI.revive(Z),ie,oe),void 0)}registerFoldingRangeProvider(j,Z,ie){const oe=this._nextHandle(),J=typeof ie.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Ge(new Re(this._documents,ie),j)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(Z),J);let le=this._createDisposable(oe);if(J!==void 0){const me=ie.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(J));le=y.Disposable.from(le,me)}return le}$provideFoldingRanges(j,Z,ie,oe){return this._withAdapter(j,Re,J=>J.provideFoldingRanges(p.URI.revive(Z),ie,oe),void 0)}registerSelectionRangeProvider(j,Z,ie){const oe=this._addNewAdapter(new ke(this._documents,ie,this._logService),j);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideSelectionRanges(j,Z,ie,oe){return this._withAdapter(j,ke,J=>J.provideSelectionRanges(p.URI.revive(Z),ie,oe),[])}registerCallHierarchyProvider(j,Z,ie){const oe=this._addNewAdapter(new Me(this._documents,ie),j);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$prepareCallHierarchy(j,Z,ie,oe){return this._withAdapter(j,Me,J=>Promise.resolve(J.prepareSession(p.URI.revive(Z),ie,oe)),void 0)}$provideCallHierarchyIncomingCalls(j,Z,ie,oe){return this._withAdapter(j,Me,J=>J.provideCallsTo(Z,ie,oe),void 0)}$provideCallHierarchyOutgoingCalls(j,Z,ie,oe){return this._withAdapter(j,Me,J=>J.provideCallsFrom(Z,ie,oe),void 0)}$releaseCallHierarchy(j,Z){this._withAdapter(j,Me,ie=>Promise.resolve(ie.releaseSession(Z)),void 0)}static _serializeRegExp(j){return{pattern:j.source,flags:E.regExpFlags(j)}}static _serializeIndentationRule(j){return{decreaseIndentPattern:ze._serializeRegExp(j.decreaseIndentPattern),increaseIndentPattern:ze._serializeRegExp(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?ze._serializeRegExp(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?ze._serializeRegExp(j.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(j){return{beforeText:ze._serializeRegExp(j.beforeText),afterText:j.afterText?ze._serializeRegExp(j.afterText):void 0,previousLineText:j.previousLineText?ze._serializeRegExp(j.previousLineText):void 0,action:j.action}}static _serializeOnEnterRules(j){return j.map(ze._serializeOnEnterRule)}setLanguageConfiguration(j,Z,ie){let{wordPattern:oe}=ie;if(oe&&E.regExpLeadsToEndlessLoop(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(Z,oe):this._documents.setWordDefinitionFor(Z,void 0),ie.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),ie.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const J=this._nextHandle(),le={comments:ie.comments,brackets:ie.brackets,wordPattern:ie.wordPattern?ze._serializeRegExp(ie.wordPattern):void 0,indentationRules:ie.indentationRules?ze._serializeIndentationRule(ie.indentationRules):void 0,onEnterRules:ie.onEnterRules?ze._serializeOnEnterRules(ie.onEnterRules):void 0,__electricCharacterSupport:ie.__electricCharacterSupport,__characterPairSupport:ie.__characterPairSupport};return this._proxy.$setLanguageConfiguration(J,Z,le),this._createDisposable(J)}$setWordDefinitions(j){for(const Z of j)this._documents.setWordDefinitionFor(Z.languageId,new RegExp(Z.regexSource,Z.regexFlags))}}e.ExtHostLanguageFeatures=ze,ze._handlePool=0}),define(ge[230],pe([0,1,5,17,7]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(I,E){this._proxy=I.getProxy(p.MainContext.MainThreadLanguages),this._documents=E}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(I,E){await this._proxy.$changeLanguage(I,E);const k=this._documents.getDocumentData(I);if(!k)throw new Error(`document '${I.toString}' NOT found`);return k.document}async tokenAtPosition(I,E){var k;const r=I.version,P=R.Position.from(E),l=await this._proxy.$tokensAtPosition(I.uri,P),f={type:C.StandardTokenType.Other,range:(k=I.getWordRangeAtPosition(E))!==null&&k!==void 0?k:new C.Range(E.line,E.character,E.line,E.character)};if(!l)return f;const c={range:R.Range.to(l.range),type:R.TokenType.to(l.type)};return!c.range.contains(E)||r!==I.version?f:c}}e.ExtHostLanguages=y}),define(ge[231],pe([0,1,5,12,34]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function y(I){return I&&I.title}let A=class{constructor(E,k){this._logService=k,this._proxy=E.getProxy(p.MainContext.MainThreadMessageService)}showMessage(E,k,r,P,l){const f={extension:E};let c;typeof P=="string"||y(P)?c=[P,...l]:(f.modal=P==null?void 0:P.modal,f.useCustom=P==null?void 0:P.useCustom,f.detail=P==null?void 0:P.detail,c=l),f.useCustom&&C.checkProposedApiEnabled(E);const h=[];for(let _=0;_<c.length;_++){const w=c[_];if(typeof w=="string")h.push({title:w,handle:_,isCloseAffordance:!1});else if(typeof w=="object"){let{title:b,isCloseAffordance:d}=w;h.push({title:b,isCloseAffordance:!!d,handle:_})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(k,r,f,h).then(_=>{if(typeof _=="number")return c[_]})}};A=Ve([$e(1,R.ILogService)],A),e.ExtHostMessageService=A}),define(ge[232],pe([0,1,22,3,73,6,23,8,15,2,82,5,17,7,208,123]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class _{constructor(b,d,u,g,t){this._textDocumentsAndEditors=u,this._textDocuments=g,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new r.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=b.getProxy(P.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=b.getProxy(P.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=b.getProxy(P.MainContext.MainThreadNotebookEditors),this._commandsConverter=d.converter,d.registerArgumentProcessor({processArgument:i=>{var s;if(i&&i.$mid===12){const n=(s=i.notebookEditor)===null||s===void 0?void 0:s.notebookUri,o=i.cell.handle,v=this._documents.get(n),m=v==null?void 0:v.getCell(o);if(m)return m.apiCell}return i}})}get activeNotebookEditor(){var b;return(b=this._activeNotebookEditor)===null||b===void 0?void 0:b.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(b=>b.apiEditor)}getEditorById(b){const d=this._editors.get(b);if(!d)throw new Error(`unknown text editor: ${b}. known editors: ${[...this._editors.keys()]} `);return d}getIdByEditor(b){for(const[d,u]of this._editors)if(u.apiEditor===b)return d}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(b,d){const u=this._documents.get(b);if(!u&&!d)throw new Error(`NO notebook document for '${b}'`);return u}_getProviderData(b){const d=this._notebookContentProviders.get(b);if(!d)throw new Error(`NO provider for '${b}'`);return d}registerNotebookContentProvider(b,d,u,g,t){if(I.isFalsyOrWhitespace(d))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(d))throw new Error(`Notebook provider for '${d}' already registered`);this._notebookContentProviders.set(d,{extension:b,provider:u});let i;return u.onDidChangeNotebookContentOptions&&(i=u.onDidChangeNotebookContentOptions(()=>{const s=l.NotebookDocumentContentOptions.from(u.options);this._notebookProxy.$updateNotebookProviderOptions(d,s)})),this._notebookProxy.$registerNotebookProvider({id:b.identifier,location:b.extensionLocation},d,l.NotebookDocumentContentOptions.from(g),_._convertNotebookRegistrationData(b,t)),new f.Disposable(()=>{i==null||i.dispose(),this._notebookContentProviders.delete(d),this._notebookProxy.$unregisterNotebookProvider(d)})}static _convertNotebookRegistrationData(b,d){if(!d)return;const u=d.filenamePattern.map(g=>l.NotebookExclusiveDocumentPattern.from(g)).filter(g=>g!==void 0);if(d.filenamePattern&&!u){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:d.displayName,filenamePattern:u,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,d,u){const g=_._notebookStatusBarItemProviderHandlePool++,t=typeof u.onDidChangeCellStatusBarItems=="function"?_._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(g,u),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(g,t,d);let i;return t!==void 0&&(i=u.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(t))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(g),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(g,t),i&&i.dispose()})}async createNotebookDocument(b){const d=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:b.viewType,content:b.content&&l.NotebookData.from(b.content)});return k.URI.revive(d)}async openNotebookDocument(b){const d=this._documents.get(b);if(d)return d.apiNotebook;const u=await this._notebookDocumentsProxy.$tryOpenNotebook(b),g=this._documents.get(k.URI.revive(u));return E.assertIsDefined(g==null?void 0:g.apiNotebook)}async showNotebookDocument(b,d){var u;k.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let g;typeof d=="object"?g={position:l.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(l.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:g={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(b.uri,b.notebookType,g),i=t&&((u=this._editors.get(t))===null||u===void 0?void 0:u.apiEditor);if(i)return i;throw t?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,d,u,g){const t=this._notebookStatusBarItemProviders.get(b),i=k.URI.revive(d),s=this._documents.get(i);if(!s||!t)return;const n=s.getCellFromIndex(u);if(!n)return;const o=await t.provideCellStatusBarItems(n.apiCell,g);if(!o)return;const v=new y.DisposableStore,m=this._statusBarCache.add([v]),D=(Array.isArray(o)?o:[o]).map(a=>l.NotebookStatusBarItem.from(a,this._commandsConverter,v));return{cacheId:m,items:D}}$releaseNotebookCellStatusBarItems(b){this._statusBarCache.delete(b)}registerNotebookSerializer(b,d,u,g,t){if(I.isFalsyOrWhitespace(d))throw new Error("viewType cannot be empty or just whitespace");const i=this._handlePool++;return this._notebookSerializer.set(i,u),this._notebookProxy.$registerNotebookSerializer(i,{id:b.identifier,location:b.extensionLocation},d,l.NotebookDocumentContentOptions.from(g),_._convertNotebookRegistrationData(b,t)),y.toDisposable(()=>{this._notebookProxy.$unregisterNotebookSerializer(i)})}async $dataToNotebook(b,d,u){const g=this._notebookSerializer.get(b);if(!g)throw new Error("NO serializer found");const t=await g.deserializeNotebook(d.buffer,u);return l.NotebookData.from(t)}async $notebookToData(b,d,u){const g=this._notebookSerializer.get(b);if(!g)throw new Error("NO serializer found");const t=await g.serializeNotebook(l.NotebookData.to(d),u);return p.VSBuffer.wrap(t)}async $openNotebook(b,d,u,g,t){var i;const{provider:s}=this._getProviderData(b),n=await s.openNotebook(k.URI.revive(d),{backupId:u,untitledDocumentData:g==null?void 0:g.buffer},t);return{metadata:(i=n.metadata)!==null&&i!==void 0?i:Object.create(null),cells:n.cells.map(l.NotebookCellData.from)}}async $saveNotebook(b,d,u){const g=this.getNotebookDocument(k.URI.revive(d)),{provider:t}=this._getProviderData(b);return await t.saveNotebook(g.apiNotebook,u),!0}async $saveNotebookAs(b,d,u,g){const t=this.getNotebookDocument(k.URI.revive(d)),{provider:i}=this._getProviderData(b);return await i.saveNotebookAs(k.URI.revive(u),t.apiNotebook,g),!0}async $backupNotebook(b,d,u){var g;const t=this.getNotebookDocument(k.URI.revive(d)),i=this._getProviderData(b),s=(g=this._extensionStoragePaths.workspaceValue(i.extension))!==null&&g!==void 0?g:this._extensionStoragePaths.globalValue(i.extension),n=String(C.hash([t.uri.toString(),this._backupIdPool++])),o=k.URI.joinPath(s,n),v=await i.provider.backupNotebook(t.apiNotebook,{destination:o},u);return t.updateBackup(v),v.id}_createExtHostEditor(b,d,u){if(this._editors.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const g=new h.ExtHostNotebookEditor(d,this._notebookEditorsProxy,b,u.visibleRanges.map(l.NotebookRange.to),u.selections.map(l.NotebookRange.to),typeof u.viewColumn=="number"?l.ViewColumn.to(u.viewColumn):void 0);this._editors.set(d,g)}$acceptDocumentAndEditorsDelta(b){var d,u,g;if(b.removedDocuments)for(const i of b.removedDocuments){const s=k.URI.revive(i),n=this._documents.get(s);n&&(n.dispose(),this._documents.delete(s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:n.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(n.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===s.toString()&&this._editors.delete(o.id)}if(b.addedDocuments){const i=[];for(const s of b.addedDocuments){const n=k.URI.revive(s.uri);if(this._documents.has(n))throw new Error(`adding EXISTING notebook ${n} `);const o=this,v=new c.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(m){o._onDidChangeNotebookCells.fire(m)},emitCellOutputsChange(m){o._onDidChangeCellOutputs.fire(m)},emitCellMetadataChange(m){o._onDidChangeCellMetadata.fire(m)},emitCellExecutionStateChange(m){o._onDidChangeCellExecutionState.fire(m)}},n,s);i.push(...s.cells.map(m=>c.ExtHostCell.asModelAddData(v.apiNotebook,m))),(d=this._documents.get(n))===null||d===void 0||d.dispose(),this._documents.set(n,v),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:i}),this._onDidOpenNotebookDocument.fire(v.apiNotebook)}}if(b.addedEditors)for(const i of b.addedEditors){if(this._editors.has(i.id))return;const s=k.URI.revive(i.documentUri),n=this._documents.get(s);n&&this._createExtHostEditor(n,i.id,i)}const t=[];if(b.removedEditors)for(const i of b.removedEditors){const s=this._editors.get(i);s&&(this._editors.delete(i),((u=this._activeNotebookEditor)===null||u===void 0?void 0:u.id)===s.id&&(this._activeNotebookEditor=void 0),t.push(s))}if(b.visibleEditors){this._visibleNotebookEditors=b.visibleEditors.map(s=>this._editors.get(s)).filter(s=>!!s);const i=new Set;this._visibleNotebookEditors.forEach(s=>i.add(s.id));for(const s of this._editors.values()){const n=i.has(s.id);s._acceptVisibility(n)}this._visibleNotebookEditors=[...this._editors.values()].map(s=>s).filter(s=>s.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}b.newActiveEditor===null?this._activeNotebookEditor=void 0:b.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(b.newActiveEditor)),b.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((g=this._activeNotebookEditor)===null||g===void 0?void 0:g.apiEditor)}}e.ExtHostNotebookController=_,_._notebookStatusBarItemProviderHandlePool=0}),define(ge[233],pe([0,1,3,70,12,5,13,17]),function(X,e,p,R,C,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class E{constructor(P,l){const f=E._Keys.nextId();P.$registerNotebookEditorDecorationType(f,I.NotebookDecorationRenderOptions.from(l)),this.value={key:f,dispose(){P.$removeNotebookEditorDecorationType(f)}}}}E._Keys=new R.IdGenerator("NotebookEditorDecorationType");let k=class{constructor(P,l,f){this._logService=P,this._extHostRpc=l,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new p.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new p.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(P){return new E(this._extHostRpc.getProxy(y.MainContext.MainThreadNotebookEditors),P).value}$acceptEditorPropertiesChanged(P,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",P,l);const f=this._notebooksAndEditors.getEditorById(P);l.visibleRanges&&f._acceptVisibleRanges(l.visibleRanges.ranges.map(I.NotebookRange.to)),l.selections&&f._acceptSelections(l.selections.selections.map(I.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:f.apiEditor,visibleRanges:f.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:f.apiEditor,selections:f.apiEditor.selections}))}$acceptEditorViewColumns(P){for(const l in P)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(I.ViewColumn.to(P[l]))}};k=Ve([$e(0,C.ILogService),$e(1,A.IExtHostRpcService)],k),e.ExtHostNotebookEditors=k}),define(ge[234],pe([0,1,3,6,5,26,2,17,83,23,16,84,21,18,12,7,34]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let w=class{constructor(t,i,s,n){this._initData=i,this._extHostNotebook=s,this._logService=n,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(C.MainContext.MainThreadNotebookKernels)}createNotebookController(t,i,s,n,o,v){for(let O of this._kernelData.values())if(O.controller.id===i&&y.ExtensionIdentifier.equals(t.identifier,O.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const m=this._handlePool++,S=this;this._logService.trace(`NotebookController[${m}], CREATED by ${t.identifier.value}, ${i}`);const D=()=>console.warn(`NO execute handler from notebook controller '${G.id}' of extension: '${t.identifier}'`);let a=!1;const T=new R.DisposableStore,L=new p.Emitter,U=new p.Emitter,G={id:`${t.identifier.value}/${i}`,notebookType:s,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:n||t.identifier.value,preloads:v?v.map(I.NotebookRendererScript.from):[]};let te=o??D,V;this._proxy.$addKernel(m,G).catch(O=>{console.log(O),a=!0});let N=0;const W=()=>{if(a)return;const O=++N;Promise.resolve().then(()=>{O===N&&this._proxy.$updateKernel(m,G)})},M=new k.ResourceMap,q={get id(){return i},get notebookType(){return G.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return G.label},set label(O){var F;G.label=(F=O??t.displayName)!==null&&F!==void 0?F:t.name,W()},get detail(){var O;return(O=G.detail)!==null&&O!==void 0?O:""},set detail(O){G.detail=O,W()},get description(){var O;return(O=G.description)!==null&&O!==void 0?O:""},set description(O){G.description=O,W()},get supportedLanguages(){return G.supportedLanguages},set supportedLanguages(O){G.supportedLanguages=O,W()},get supportsExecutionOrder(){var O;return(O=G.supportsExecutionOrder)!==null&&O!==void 0?O:!1},set supportsExecutionOrder(O){G.supportsExecutionOrder=O,W()},get rendererScripts(){return G.preloads?G.preloads.map(I.NotebookRendererScript.to):[]},get executeHandler(){return te},set executeHandler(O){te=O??D},get interruptHandler(){return V},set interruptHandler(O){V=O,G.supportsInterrupt=Boolean(O),W()},createNotebookCellExecution(O){if(a)throw new Error("notebook controller is DISPOSED");if(!M.has(O.notebook.uri))throw S._logService.trace(`NotebookController[${m}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(M.keys()).map(F=>F.toString())),new Error(`notebook controller is NOT associated to notebook: ${O.notebook.uri.toString()}`);return S._createNotebookCellExecution(O)},dispose:()=>{a||(this._logService.trace(`NotebookController[${m}], DISPOSED`),a=!0,this._kernelData.delete(m),T.dispose(),L.dispose(),U.dispose(),this._proxy.$removeKernel(m))},updateNotebookAffinity(O,F){S._proxy.$updateNotebookPriority(m,O.uri,F)},onDidReceiveMessage:U.event,postMessage(O,F){return _.checkProposedApiEnabled(t),S._proxy.$postMessage(m,F&&S._extHostNotebook.getIdByEditor(F),O)},asWebviewUri(O){return _.checkProposedApiEnabled(t),E.asWebviewUri(O,S._initData.remote)}};return this._kernelData.set(m,{extensionId:t.identifier,controller:q,onDidReceiveMessage:U,onDidChangeSelection:L,associatedNotebooks:M}),q}$acceptNotebookAssociation(t,i,s){const n=this._kernelData.get(t);if(n){const o=this._extHostNotebook.getNotebookDocument(A.URI.revive(i));s?n.associatedNotebooks.set(o.uri,!0):n.associatedNotebooks.delete(o.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,o.uri.toString(),s),n.onDidChangeSelection.fire({selected:s,notebook:o.apiNotebook})}}async $executeCells(t,i,s){const n=this._kernelData.get(t);if(!n)return;const o=this._extHostNotebook.getNotebookDocument(A.URI.revive(i)),v=[];for(let m of s){const S=o.getCell(m);S&&v.push(S.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,o.uri.toString(),v.length),await n.controller.executeHandler.call(n.controller,v,o.apiNotebook,n.controller)}catch(m){this._logService.error(`NotebookController[${t}] execute cells FAILED`,m),console.error(m)}}async $cancelCells(t,i,s){var n;const o=this._kernelData.get(t);if(!o)return;const v=this._extHostNotebook.getNotebookDocument(A.URI.revive(i));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,v.apiNotebook);else for(let m of s){const S=v.getCell(m);S&&((n=this._activeExecutions.get(S.uri))===null||n===void 0||n.cancel())}}$acceptKernelMessageFromRenderer(t,i,s){const n=this._kernelData.get(t);if(!n)return;const o=this._extHostNotebook.getEditorById(i);n.onDidReceiveMessage.fire(Object.freeze({editor:o.apiEditor,message:s}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const n=new d(s.notebook,s,this._proxy);this._activeExecutions.set(s.uri,n);const o=n.onDidChangeState(()=>{n.state===b.Resolved&&(n.dispose(),o.dispose(),this._activeExecutions.delete(s.uri))});return n.asApiObject()}};w=Ve([$e(3,c.ILogService)],w),e.ExtHostNotebookKernels=w;var b;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(b||(b={}));class d extends R.Disposable{constructor(t,i,s){super();this._document=t,this._cell=i,this._proxy=s,this._onDidChangeState=new p.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=b.Init,this._tokenSource=this._register(new l.CancellationTokenSource),this._collector=new u(10,n=>this.applyEdits(n)),this._executionOrder=i.internalMetadata.executionOrder,this.mixinMetadata({runState:P.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===b.Init)throw new Error("Must call start before modifying cell output");if(this._state===b.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let i=this._cell;if(t&&(i=this._document.getCellFromApiCell(t)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(t){return t.map(i=>{const s=h.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return s===i.items?I.NotebookCellOutput.from(i):I.NotebookCellOutput.from({items:s,id:i.id,metadata:i.metadata})})}async updateOutputs(t,i,s){const n=this.cellIndexToHandle(i),o=this.validateAndConvertOutputs(f.asArray(t));return this.applyEditSoon({editType:2,handle:n,append:s,outputs:o})}async updateOutputItems(t,i,s){return t=h.NotebookCellOutput.ensureUniqueMimeTypes(f.asArray(t),!0),this.applyEditSoon({editType:7,items:t.map(I.NotebookCellOutputItem.from),outputId:i.id,append:s})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(s){t._executionOrder=s,t.mixinMetadata({executionOrder:s})},start(s){if(t._state===b.Resolved||t._state===b.Started)throw new Error("Cannot call start again");t._state=b.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:P.NotebookCellExecutionState.Executing,runStartTime:s??null})},end(s,n){if(t._state===b.Resolved)throw new Error("Cannot call resolve twice");t._state=b.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:s??null,runEndTime:n??null})},clearOutput(s){return t.verifyStateForOutput(),t.updateOutputs([],s,!1)},appendOutput(s,n){return t.verifyStateForOutput(),t.updateOutputs(s,n,!0)},replaceOutput(s,n){return t.verifyStateForOutput(),t.updateOutputs(s,n,!1)},appendOutputItems(s,n){return t.verifyStateForOutput(),t.updateOutputItems(s,n,!0)},replaceOutputItems(s,n){return t.verifyStateForOutput(),t.updateOutputItems(s,n,!1)}})}}class u{constructor(t,i){this.delay=t,this.callback=i,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=r.timeout(this.delay).then(()=>{this.waitPromise=void 0;const i=this.batch;return this.batch=[],this.callback(i)})),this.waitPromise}}}),define(ge[235],pe([0,1,3,5,123]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class y{constructor(I,E){this._extHostNotebook=E,this._rendererMessageEmitters=new Map,this.proxy=I.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(I,E,k){var r;const P=this._extHostNotebook.getEditorById(I);(r=this._rendererMessageEmitters.get(E))===null||r===void 0||r.fire({editor:P.apiEditor,message:k})}createRendererMessaging(I){return{onDidReceiveMessage:(...k)=>this.getOrCreateEmitterFor(I).event(...k),postMessage:(k,r)=>{const P=C.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);if(!P)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(P.id,I,r)}}}getOrCreateEmitterFor(I){let E=this._rendererMessageEmitters.get(I);return E||(E=new p.Emitter({onLastListenerRemove:()=>{E==null||E.dispose(),this._rendererMessageEmitters.delete(I)}}),this._rendererMessageEmitters.set(I,E),E)}}e.ExtHostNotebookRenderers=y}),define(ge[62],pe([0,1,5,3,6,22,4,13]),function(X,e,p,R,C,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class E extends C.Disposable{constructor(c,h,_,w){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=c,this._proxy=w,this._id=w.$register(this.name,h,_),this._disposed=!1,this._offset=0}get name(){return this._name}append(c){this.validate(),this._offset+=c?y.VSBuffer.fromString(c).byteLength:0}update(){this._id.then(c=>this._proxy.$update(c))}appendLine(c){this.validate(),this.append(c+`
`)}clear(){this.validate();const c=this._offset;this._id.then(h=>this._proxy.$clear(h,c))}show(c,h){this.validate(),this._id.then(_=>this._proxy.$reveal(_,!!(typeof c=="boolean"?c:h)))}hide(){this.validate(),this._id.then(c=>this._proxy.$close(c))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(c=>this._proxy.$dispose(c)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=E;class k extends E{constructor(c,h){super(c,!1,void 0,h)}append(c){super.append(c),this._id.then(h=>this._proxy.$append(h,c)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class r extends E{constructor(c,h,_){super(c,!0,h,_)}append(c){throw new Error("Not supported")}}class P{constructor(c,h){this.name=c,this._channel=h}append(c){this._channel.then(h=>h.append(c))}appendLine(c){this._channel.then(h=>h.appendLine(c))}clear(){this._channel.then(c=>c.clear())}show(c,h){this._channel.then(_=>_.show(c,h))}hide(){this._channel.then(c=>c.hide())}dispose(){this._channel.then(c=>c.dispose())}}e.LazyOutputChannel=P;let l=class{constructor(c){this._proxy=c.getProxy(p.MainContext.MainThreadOutputService)}$setVisibleChannel(c){}createOutputChannel(c){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");return new k(c,this._proxy)}createOutputChannelFromLogFile(c,h){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");if(!h)throw new Error("illegal argument `file`. must not be falsy");return new r(c,h,this._proxy)}};l=Ve([$e(0,I.IExtHostRpcService)],l),e.ExtHostOutputService=l,e.IExtHostOutputService=A.createDecorator("IExtHostOutputService")}),define(ge[236],pe([0,1,16,21,3,6,5,2,7,14,18,54]),function(X,e,p,R,C,y,A,I,E,k,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function l(f,c,h){const _=f.getProxy(A.MainContext.MainThreadQuickOpen);class w{constructor(n,o){this._sessions=new Map,this._instances=0,this._workspace=n,this._commands=o}showQuickPick(n,o,v,m=R.CancellationToken.None){this._onDidSelectItem=void 0;const S=Promise.resolve(n),D=++this._instances,a=_.$show(D,{title:v==null?void 0:v.title,placeHolder:v==null?void 0:v.placeHolder,matchOnDescription:v==null?void 0:v.matchOnDescription,matchOnDetail:v==null?void 0:v.matchOnDetail,ignoreFocusLost:v==null?void 0:v.ignoreFocusOut,canPickMany:v==null?void 0:v.canPickMany},m),T={},L=a.then(()=>T);return Promise.race([L,S]).then(U=>{if(U!==T)return S.then(G=>{const te=[];for(let V=0;V<G.length;V++){const N=G[V];let W,M,q,O,F;typeof N=="string"?W=N:(W=N.label,M=N.description,q=N.detail,O=N.picked,F=N.alwaysShow),te.push({label:W,description:M,handle:V,detail:q,picked:O,alwaysShow:F})}return v&&typeof v.onDidSelectItem=="function"&&(this._onDidSelectItem=V=>{v.onDidSelectItem(G[V])}),_.$setItems(D,te),a.then(V=>{if(typeof V=="number")return G[V];if(Array.isArray(V))return V.map(N=>G[N])})})}).then(void 0,U=>{if(!k.isPromiseCanceledError(U))return _.$setError(D,U),Promise.reject(U)})}$onItemSelected(n){this._onDidSelectItem&&this._onDidSelectItem(n)}showInput(n,o=R.CancellationToken.None){return this._validateInput=n?n.validateInput:void 0,_.$input(n,typeof this._validateInput=="function",o).then(void 0,v=>{if(!k.isPromiseCanceledError(v))return Promise.reject(v)})}$validateInput(n){return this._validateInput?p.asPromise(()=>this._validateInput(n)):Promise.resolve(void 0)}async showWorkspaceFolderPick(n,o=R.CancellationToken.None){const v=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!v)return;const m=await this._workspace.getWorkspaceFolders2();if(!!m)return m.find(S=>S.uri.toString()===v.uri.toString())}createQuickPick(n,o){const v=new t(n,o,()=>this._sessions.delete(v._id));return this._sessions.set(v._id,v),v}createInputBox(n){const o=new i(n,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}$onDidChangeValue(n,o){const v=this._sessions.get(n);v&&v._fireDidChangeValue(o)}$onDidAccept(n){const o=this._sessions.get(n);o&&o._fireDidAccept()}$onDidChangeActive(n,o){const v=this._sessions.get(n);v instanceof t&&v._fireDidChangeActive(o)}$onDidChangeSelection(n,o){const v=this._sessions.get(n);v instanceof t&&v._fireDidChangeSelection(o)}$onDidTriggerButton(n,o){const v=this._sessions.get(n);v&&v._fireDidTriggerButton(o)}$onDidHide(n){const o=this._sessions.get(n);o&&o._fireDidHide()}}class b{constructor(n,o){this._extensionId=n,this._onDidDispose=o,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(n){this._title=n,this.update({title:n})}get step(){return this._steps}set step(n){this._steps=n,this.update({step:n})}get totalSteps(){return this._totalSteps}set totalSteps(n){this._totalSteps=n,this.update({totalSteps:n})}get enabled(){return this._enabled}set enabled(n){this._enabled=n,this.update({enabled:n})}get busy(){return this._busy}set busy(n){this._busy=n,this.update({busy:n})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(n){this._ignoreFocusOut=n,this.update({ignoreFocusOut:n})}get value(){return this._value}set value(n){this._value=n,this.update({value:n})}get placeholder(){return this._placeholder}set placeholder(n){this._placeholder=n,this.update({placeholder:n})}get buttons(){return this._buttons}set buttons(n){this._buttons=n.slice(),this._handlesToButtons.clear(),n.forEach((o,v)=>{const m=o===E.QuickInputButtons.Back?-1:v;this._handlesToButtons.set(m,o)}),this.update({buttons:n.map((o,v)=>({iconPath:d(o.iconPath),tooltip:o.tooltip,handle:o===E.QuickInputButtons.Back?-1:v}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(n){this._value=n,this._onDidChangeValueEmitter.fire(n)}_fireDidTriggerButton(n){const o=this._handlesToButtons.get(n);o&&this._onDidTriggerButtonEmitter.fire(o)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=y.dispose(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),_.$dispose(this._id))}update(n){if(!this._disposed){for(const o of Object.keys(n)){const v=n[o];this._pendingUpdate[o]=v===void 0?null:v}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){_.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}b._nextId=1;function d(s){if(s instanceof E.ThemeIcon)return{id:s.id};const n=g(s),o=u(s);return{dark:typeof n=="string"?I.URI.file(n):n,light:typeof o=="string"?I.URI.file(o):o}}function u(s){return typeof s=="object"&&"light"in s?s.light:s}function g(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends b{constructor(n,o,v){super(n,v);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(n){this._items=n.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),n.forEach((o,v)=>{this._handlesToItems.set(v,o),this._itemsToHandles.set(o,v)}),this.update({items:n.map((o,v)=>({label:o.label,description:o.description,handle:v,detail:o.detail,picked:o.picked,alwaysShow:o.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(n){this._canSelectMany=n,this.update({canSelectMany:n})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(n){this._matchOnDescription=n,this.update({matchOnDescription:n})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(n){this._matchOnDetail=n,this.update({matchOnDetail:n})}get sortByLabel(){return this._sortByLabel}set sortByLabel(n){this._sortByLabel=n,this.update({sortByLabel:n})}get activeItems(){return this._activeItems}set activeItems(n){this._activeItems=n.filter(o=>this._itemsToHandles.has(o)),this.update({activeItems:this._activeItems.map(o=>this._itemsToHandles.get(o))})}get selectedItems(){return this._selectedItems}set selectedItems(n){this._selectedItems=n.filter(o=>this._itemsToHandles.has(o)),this.update({selectedItems:this._selectedItems.map(o=>this._itemsToHandles.get(o))})}_fireDidChangeActive(n){const o=r.coalesce(n.map(v=>this._handlesToItems.get(v)));this._activeItems=o,this._onDidChangeActiveEmitter.fire(o)}_fireDidChangeSelection(n){const o=r.coalesce(n.map(v=>this._handlesToItems.get(v)));this._selectedItems=o,this._onDidChangeSelectionEmitter.fire(o)}}class i extends b{constructor(n,o){super(n,o);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(n){this._password=n,this.update({password:n})}get prompt(){return this._prompt}set prompt(n){this._prompt=n,this.update({prompt:n})}get validationMessage(){return this._validationMessage}set validationMessage(n){this._validationMessage=n,this.update({validationMessage:n,severity:n?P.default.Error:P.default.Ignore})}}return new w(c,h)}e.createExtHostQuickOpen=l}),define(ge[237],pe([0,1,2,3,51,6,16,5,18,95,12,26,34]),function(X,e,p,R,C,y,A,I,E,k,r,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(n){if(n)return typeof n.iconPath=="string"?p.URI.file(n.iconPath):n.iconPath}function c(n,o){if(!n.iconPath&&!o.iconPath)return 0;if(n.iconPath){if(!o.iconPath)return 1}else return-1;const v=typeof n.iconPath=="string"?n.iconPath:n.iconPath.fsPath,m=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath;return k.comparePaths(v,m)}function h(n,o){let v=0;if(n.strikeThrough!==o.strikeThrough)return n.strikeThrough?1:-1;if(n.faded!==o.faded)return n.faded?1:-1;if(n.tooltip!==o.tooltip)return(n.tooltip||"").localeCompare(o.tooltip||"");if(v=c(n,o),v!==0)return v;if(n.light&&o.light)v=c(n.light,o.light);else{if(n.light)return 1;if(o.light)return-1}if(v!==0)return v;if(n.dark&&o.dark)v=c(n.dark,o.dark);else{if(n.dark)return 1;if(o.dark)return-1}return v}function _(n,o){if(n.command!==o.command)return n.command<o.command?-1:1;if(n.title!==o.title)return n.title<o.title?-1:1;if(n.tooltip!==o.tooltip){if(n.tooltip!==void 0&&o.tooltip!==void 0)return n.tooltip<o.tooltip?-1:1;if(n.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(n.arguments===o.arguments)return 0;if(n.arguments)if(o.arguments){if(n.arguments.length!==o.arguments.length)return n.arguments.length-o.arguments.length}else return 1;else return-1;for(let v=0;v<n.arguments.length;v++){const m=n.arguments[v],S=o.arguments[v];if(m!==S)return m<S?-1:1}return 0}function w(n,o){let v=k.comparePaths(n.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(v!==0)return v;if(n.command&&o.command)v=_(n.command,o.command);else{if(n.command)return 1;if(o.command)return-1}if(v!==0)return v;if(n.decorations&&o.decorations)v=h(n.decorations,o.decorations);else{if(n.decorations)return 1;if(o.decorations)return-1}return v}function b(n,o){for(let v=0;v<n.length;v++)if(n[v]!==o[v])return!1;return!0}function d(n,o){return n.command===o.command&&n.title===o.title&&n.tooltip===o.tooltip&&(n.arguments&&o.arguments?b(n.arguments,o.arguments):n.arguments===o.arguments)}function u(n,o){return E.equals(n,o,d)}class g{constructor(o,v,m){this._extension=o,this._proxy=v,this._sourceControlHandle=m,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(o){this._proxy.$setInputBoxValue(this._sourceControlHandle,o),this.updateValue(o)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(o){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,o),this._placeholder=o}get validateInput(){return l.checkProposedApiEnabled(this._extension),this._validateInput}set validateInput(o){if(l.checkProposedApiEnabled(this._extension),o&&typeof o!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=o,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!o)}get visible(){return this._visible}set visible(o){o=!!o,this._visible!==o&&(this._visible=o,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,o))}focus(){l.checkProposedApiEnabled(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(o,v){l.checkProposedApiEnabled(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,o,v)}$onInputBoxValueChange(o){this.updateValue(o)}updateValue(o){this._value=o,this._onDidChange.fire(o)}}e.ExtHostSCMInputBox=g;class t{constructor(o,v,m,S,D){this._proxy=o,this._commands=v,this._sourceControlHandle=m,this._id=S,this._label=D,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(o){this._label=o,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,o)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(o){this._hideWhenEmpty=o,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(o){this._resourceStates=[...o],this._onDidUpdateResourceStates.fire()}getResourceState(o){return this._resourceStatesMap.get(o)}$executeResourceCommand(o,v){const m=this._resourceStatesCommandsMap.get(o);return m?A.asPromise(()=>this._commands.executeCommand(m.command,...m.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var o;const v=[...this._resourceStates].sort(w),S=E.sortedDiff(this._resourceSnapshot,v,w).map(T=>{const L=T.toInsert.map(U=>{const G=this._resourceHandlePool++;this._resourceStatesMap.set(G,U);const te=U.resourceUri,V=f(U.decorations),N=U.decorations&&f(U.decorations.light)||V,W=U.decorations&&f(U.decorations.dark)||V,M=[];let q;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"){const ce=new y.DisposableStore;q=this._commands.converter.toInternal(U.command,ce),this._resourceStatesDisposablesMap.set(G,ce)}else this._resourceStatesCommandsMap.set(G,U.command);N&&M.push(N),W&&W.toString()!==(N==null?void 0:N.toString())&&M.push(W);const O=U.decorations&&U.decorations.tooltip||"",F=U.decorations&&!!U.decorations.strikeThrough,B=U.decorations&&!!U.decorations.faded,$=U.contextValue||"";return{rawResource:[G,te,M,O,F,B,$,q],handle:G}});return{start:T.start,deleteCount:T.deleteCount,toInsert:L}}),D=S.map(({start:T,deleteCount:L,toInsert:U})=>[T,L,U.map(G=>G.rawResource)]),a=S.reverse();for(const{start:T,deleteCount:L,toInsert:U}of a){const G=U.map(V=>V.handle),te=this._handlesSnapshot.splice(T,L,...G);for(const V of te)this._resourceStatesMap.delete(V),this._resourceStatesCommandsMap.delete(V),(o=this._resourceStatesDisposablesMap.get(V))===null||o===void 0||o.dispose(),this._resourceStatesDisposablesMap.delete(V)}return this._resourceSnapshot=v,D}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class i{constructor(o,v,m,S,D,a){this._proxy=v,this._commands=m,this._id=S,this._label=D,this._rootUri=a,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new y.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new g(o,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,S,D,a)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(o){this._count!==o&&(this._count=o,this._proxy.$updateSourceControl(this.handle,{count:o}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(o){this._quickDiffProvider=o,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!o})}get commitTemplate(){return this._commitTemplate}set commitTemplate(o){o!==this._commitTemplate&&(this._commitTemplate=o,this._proxy.$updateSourceControl(this.handle,{commitTemplate:o}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(o){this._acceptInputDisposables.value=new y.DisposableStore,this._acceptInputCommand=o;const v=this._commands.converter.toInternal(o,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:v})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(o){if(this._statusBarCommands&&o&&u(this._statusBarCommands,o))return;this._statusBarDisposables.value=new y.DisposableStore,this._statusBarCommands=o;const v=(o||[]).map(m=>this._commands.converter.toInternal(m,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:v})}get selected(){return this._selected}createResourceGroup(o,v){const m=new t(this._proxy,this._commands,this.handle,o,v),S=R.Event.once(m.onDidDispose)(()=>this.createdResourceGroups.delete(m));return this.createdResourceGroups.set(m,S),this.eventuallyAddResourceGroups(),m}eventuallyAddResourceGroups(){const o=[],v=[];for(const[m,S]of this.createdResourceGroups){S.dispose();const D=m.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(m),this.eventuallyUpdateResourceStates()});R.Event.once(m.onDidDispose)(()=>{this.updatedResourceGroups.delete(m),D.dispose(),this._groups.delete(m.handle),this._proxy.$unregisterGroup(this.handle,m.handle)}),o.push([m.handle,m.id,m.label,m.features]);const a=m._takeResourceStateSnapshot();a.length>0&&v.push([m.handle,a]),this._groups.set(m.handle,m)}this._proxy.$registerGroups(this.handle,o,v),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const o=[];this.updatedResourceGroups.forEach(v=>{const m=v._takeResourceStateSnapshot();m.length!==0&&o.push([v.handle,m])}),o.length>0&&this._proxy.$spliceResourceStates(this.handle,o),this.updatedResourceGroups.clear()}getResourceGroup(o){return this._groups.get(o)}setSelectionState(o){this._selected=o,this._onDidChangeSelection.fire(o)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(o=>o.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,Ve([C.debounce(100)],i.prototype,"eventuallyAddResourceGroups",null),Ve([C.debounce(100)],i.prototype,"eventuallyUpdateResourceStates",null);let s=class Nn{constructor(o,v,m){this._commands=v,this.logService=m,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=o.getProxy(I.MainContext.MainThreadSCM),this._telemetry=o.getProxy(I.MainContext.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===3){const D=this._sourceControls.get(S.sourceControlHandle);if(!D)return S;const a=D.getResourceGroup(S.groupHandle);return a?a.getResourceState(S.handle):S}else if(S&&S.$mid===4){const D=this._sourceControls.get(S.sourceControlHandle);return D?D.getResourceGroup(S.groupHandle):S}else if(S&&S.$mid===5){const D=this._sourceControls.get(S.handle);return D||S}return S}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(o,v,m,S){this.logService.trace("ExtHostSCM#createSourceControl",o.identifier.value,v,m,S),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const D=Nn._handlePool++,a=new i(o,this._proxy,this._commands,v,m,S);this._sourceControls.set(D,a);const T=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(o.identifier))||[];return T.push(a),this._sourceControlsByExtension.set(P.ExtensionIdentifier.toKey(o.identifier),T),a}getLastInputBox(o){this.logService.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const v=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(o.identifier)),m=v&&v[v.length-1];return m&&m.inputBox}$provideOriginalResource(o,v,m){const S=p.URI.revive(v);this.logService.trace("ExtHostSCM#$provideOriginalResource",o,S.toString());const D=this._sourceControls.get(o);return!D||!D.quickDiffProvider||!D.quickDiffProvider.provideOriginalResource?Promise.resolve(null):A.asPromise(()=>D.quickDiffProvider.provideOriginalResource(S,m)).then(a=>a||null)}$onInputBoxValueChange(o,v){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",o);const m=this._sourceControls.get(o);return m&&m.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(o,v,m,S){this.logService.trace("ExtHostSCM#$executeResourceCommand",o,v,m);const D=this._sourceControls.get(o);if(!D)return Promise.resolve(void 0);const a=D.getResourceGroup(v);return a?a.$executeResourceCommand(m,S):Promise.resolve(void 0)}$validateInput(o,v,m){this.logService.trace("ExtHostSCM#$validateInput",o);const S=this._sourceControls.get(o);return!S||!S.inputBox.validateInput?Promise.resolve(void 0):A.asPromise(()=>S.inputBox.validateInput(v,m)).then(D=>D?Promise.resolve([D.message,D.type]):Promise.resolve(void 0))}$setSelectedSourceControl(o){var v,m;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&((v=this._sourceControls.get(o))===null||v===void 0||v.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((m=this._sourceControls.get(this._selectedSourceControlHandle))===null||m===void 0||m.setSelectionState(!1)),this._selectedSourceControlHandle=o,Promise.resolve(void 0)}};s._handlePool=0,s=Ve([$e(2,r.ILogService)],s),e.ExtHostSCM=s});var rt=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},Be=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(ge[238],pe([0,1,7,5,161,6,17]),function(X,e,p,R,C,y,A){"use strict";var I,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class k{constructor(f,c,h,_,w=p.StatusBarAlignment.Left,b){I.set(this,void 0),E.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new y.DisposableStore,rt(this,I,f,"f"),rt(this,E,c,"f"),this._entryId=k.ID_GEN++,this._extension=h,this._id=_,this._alignment=w,this._priority=b}get id(){var f;return(f=this._id)!==null&&f!==void 0?f:this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get tooltip2(){return this._tooltip2}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var f;return(f=this._command)===null||f===void 0?void 0:f.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set tooltip2(f){this._tooltip2=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!k.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){var c;((c=this._command)===null||c===void 0?void 0:c.fromApi)!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Be(this,E,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Be(this,E,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,I,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var f;this._timeoutHandle=void 0;let c;this._extension?this._id?c=`${this._extension.identifier.value}.${this._id}`:c=this._extension.identifier.value:c=this._id;let h;this._name?h=this._name:h=C.localize(0,null,this._extension.displayName||this._extension.name);let _=this._color;this._backgroundColor&&(_=k.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const w=this._tooltip2!==void 0?A.MarkdownString.fromStrict(this._tooltip2):this.tooltip;Be(this,I,"f").$setEntry(this._entryId,c,h,this._text,w,(f=this._command)===null||f===void 0?void 0:f.internal,_,this._backgroundColor,this._alignment===p.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=k,I=new WeakMap,E=new WeakMap,k.ID_GEN=0,k.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new p.ThemeColor("statusBarItem.errorForeground")]]);class r{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",p.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=C.localize(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const c={message:f};return this._messages.unshift(c),this._update(),new p.Disposable(()=>{const h=this._messages.indexOf(c);h>=0&&(this._messages.splice(h,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class P{constructor(f,c){this._proxy=f.getProxy(R.MainContext.MainThreadStatusBar),this._commands=c,this._statusMessage=new r(this)}createStatusBarEntry(f,c,h,_){return new k(this._proxy,this._commands,f,c,h,_)}setStatusBarMessage(f,c){const h=this._statusMessage.setMessage(f);let _;return typeof c=="number"?_=setTimeout(()=>h.dispose(),c):typeof c!="undefined"&&c.then(()=>h.dispose(),()=>h.dispose()),new p.Disposable(()=>{h.dispose(),clearTimeout(_)})}}e.ExtHostStatusBar=P}),define(ge[87],pe([0,1,5,3,4]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class y{constructor(I){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(p.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,E){this._proxy.$registerExtensionStorageKeysToSync(I,E)}getValue(I,E,k){return this._proxy.$getValue(I,E).then(r=>r||k)}setValue(I,E,k){return this._proxy.$setValue(I,E,k)}$acceptValue(I,E,k){this._onDidChangeStorage.fire({shared:I,key:E,value:k})}}e.ExtHostStorage=y,e.IExtHostStorage=C.createDecorator("IExtHostStorage")}),define(ge[88],pe([0,1,4,27,12,86,2]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=p.createDecorator("IExtensionStoragePaths");let I=class{constructor(k,r,P){var l;this._logService=r,this._extHostFileSystem=P,this._workspace=(l=k.workspace)!==null&&l!==void 0?l:void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(f=>this._value=f)}async _getOrCreateWorkspaceStoragePath(){var k;if(!this._workspace)return Promise.resolve(void 0);const r=this._workspace.id,P=A.URI.joinPath(this._environment.workspaceStorageHome,r);try{return await this._extHostFileSystem.value.stat(P),this._logService.trace("[ExtHostStorage] storage dir already exists",P),P}catch(l){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",P),await this._extHostFileSystem.value.createDirectory(P),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(k=A.URI.revive(this._workspace.configuration))===null||k===void 0?void 0:k.toString(),name:this._workspace.name},void 0,2))),P}catch(l){this._logService.error("[ExtHostStorage]",l);return}}workspaceValue(k){if(this._value)return A.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return A.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}};I=Ve([$e(0,R.IExtHostInitDataService),$e(1,C.ILogService),$e(2,y.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(ge[33],pe([0,1,3,5,4,2,13,6,7,162,14,202,21,32,189,15]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=C.createDecorator("IExtHostTerminalService");class _{constructor(s,n,o,v){this._proxy=s,this._id=n,this._creationOptions=o,this._name=v,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(S=>this._pidPromiseComplete=S);const m=this;this.value={get name(){return m._name||""},get processId(){return m._pidPromise},get creationOptions(){return m._creationOptions},get exitStatus(){return m._exitStatus},sendText(S,D=!0){m._checkDisposed(),m._proxy.$sendText(m._id,S,D)},show(S){m._checkDisposed(),m._proxy.$show(m._id,S)},hide(){m._checkDisposed(),m._proxy.$hide(m._id)},dispose(){m._disposed||(m._disposed=!0,m._proxy.$dispose(m._id))},get dimensions(){if(!(m._cols===void 0||m._rows===void 0))return{columns:m._cols,rows:m._rows}}}}async create(s,n){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:s.name,shellPath:h.withNullAsUndefined(s.shellPath),shellArgs:h.withNullAsUndefined(s.shellArgs),cwd:h.withNullAsUndefined(s.cwd),env:h.withNullAsUndefined(s.env),icon:h.withNullAsUndefined(t(s.iconPath)),initialText:h.withNullAsUndefined(s.message),strictEnv:h.withNullAsUndefined(s.strictEnv),hideFromUser:h.withNullAsUndefined(s.hideFromUser),isFeatureTerminal:h.withNullAsUndefined(n==null?void 0:n.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:h.withNullAsUndefined(n==null?void 0:n.useShellEnvironment),isSplitTerminal:h.withNullAsUndefined(n==null?void 0:n.isSplitTerminal)})}async createExtensionTerminal(s,n){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:n,isSplitTerminal:s}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(s){this._name=s}setExitCode(s){this._exitStatus=Object.freeze({code:s})}setDimensions(s,n){return s===this._cols&&n===this._rows||s===0||n===0?!1:(this._cols=s,this._rows=n,!0)}_setProcessId(s){this._pidPromiseComplete?(this._pidPromiseComplete(s),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==s&&(this._pidPromise=Promise.resolve(s))})}}e.ExtHostTerminal=_;class w{constructor(s){this._pty=s,this.id=0,this.shouldPersist=!1,this._onProcessData=new p.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new p.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new p.Emitter,this._onProcessTitleChanged=new p.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new p.Emitter,this._onProcessShellTypeChanged=new p.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(s){this._pty.handleInput&&this._pty.handleInput(s)}resize(s,n){this._pty.setDimensions&&this._pty.setDimensions({columns:s,rows:n})}async processBinary(s){}acknowledgeDataEvent(s){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(s){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(s||void 0),this._pty.setDimensions&&s&&this._pty.setDimensions(s),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=w;let b=1,d=class extends I.Disposable{constructor(s,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new p.Emitter,this._onDidOpenTerminal=new p.Emitter,this._onDidChangeActiveTerminal=new p.Emitter,this._onDidChangeTerminalDimensions=new p.Emitter,this._proxy=n.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new c.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new p.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(s),this._register({dispose:()=>{for(const[o,v]of this._terminalProcesses)v.shutdown(!0)}})}get activeTerminal(){var s;return(s=this._activeTerminal)===null||s===void 0?void 0:s.value}get terminals(){return this._terminals.map(s=>s.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(s){const n=s?this._defaultAutomationProfile:this._defaultProfile;return(n==null?void 0:n.path)||""}getDefaultShellArgs(s){const n=s?this._defaultAutomationProfile:this._defaultProfile;return(n==null?void 0:n.args)||[]}createExtensionTerminal(s,n){const o=new _(this._proxy,f.generateUuid(),s,s.name),v=new w(s.pty);return o.createExtensionTerminal(n==null?void 0:n.isSplitTerminal,t(s.iconPath)).then(m=>{const S=this._setupExtHostProcessListeners(m,v);this._terminalProcessDisposables[m]=S}),this._terminals.push(o),o.value}attachPtyToTerminal(s,n){if(!this._getTerminalById(s))throw new Error(`Cannot resolve terminal with id ${s} for virtual process`);const v=new w(n),m=this._setupExtHostProcessListeners(s,v);this._terminalProcessDisposables[s]=m}async $acceptActiveTerminalChanged(s){const n=this._activeTerminal;if(s===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const o=this._getTerminalById(s);o&&(this._activeTerminal=o,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(s,n){const o=this._getTerminalById(s);o&&this._onDidWriteTerminalData.fire({terminal:o.value,data:n})}async $acceptTerminalDimensions(s,n,o){const v=this._getTerminalById(s);v&&v.setDimensions(n,o)&&this._onDidChangeTerminalDimensions.fire({terminal:v.value,dimensions:v.value.dimensions})}async $acceptTerminalMaximumDimensions(s,n,o){var v;(v=this._terminalProcesses.get(s))===null||v===void 0||v.resize(n,o)}async $acceptTerminalTitleChange(s,n){const o=this._getTerminalById(s);o&&(o.name=n)}async $acceptTerminalClosed(s,n){const o=this._getTerminalObjectIndexById(this._terminals,s);if(o!==null){const v=this._terminals.splice(o,1)[0];v.setExitCode(n),this._onDidCloseTerminal.fire(v.value)}}$acceptTerminalOpened(s,n,o,v){if(n){const D=this._getTerminalObjectIndexById(this._terminals,n);if(D!==null){this._terminals[D]._id=s,this._onDidOpenTerminal.fire(this.terminals[D]),this._terminals[D].isOpen=!0;return}}const m={name:v.name,shellPath:v.executable,shellArgs:v.args,cwd:typeof v.cwd=="string"?v.cwd:y.URI.revive(v.cwd),env:v.env,hideFromUser:v.hideFromUser},S=new _(this._proxy,s,m,o);this._terminals.push(S),this._onDidOpenTerminal.fire(S.value),S.isOpen=!0}async $acceptTerminalProcessId(s,n){const o=this._getTerminalById(s);o&&o._setProcessId(n)}async $startExtensionTerminal(s,n){const o=this._getTerminalById(s);if(!o)return{message:k.localize(0,null,s)};o.isOpen||await new Promise(m=>{const S=this.onDidOpenTerminal(async D=>{D===o.value&&(S.dispose(),m())})});const v=this._terminalProcesses.get(s);v?v.startSendingEvents(n):this._extensionTerminalAwaitingStart[s]={initialDimensions:n}}_setupExtHostProcessListeners(s,n){const o=new I.DisposableStore;o.add(n.onProcessReady(m=>this._proxy.$sendProcessReady(s,m.pid,m.cwd))),o.add(n.onProcessTitleChanged(m=>this._proxy.$sendProcessTitle(s,m))),this._bufferer.startBuffering(s,n.onProcessData),o.add(n.onProcessExit(m=>this._onProcessExit(s,m))),n.onProcessOverrideDimensions&&o.add(n.onProcessOverrideDimensions(m=>this._proxy.$sendOverrideDimensions(s,m))),this._terminalProcesses.set(s,n);const v=this._extensionTerminalAwaitingStart[s];return v&&n instanceof w&&(n.startSendingEvents(v.initialDimensions),delete this._extensionTerminalAwaitingStart[s]),o}$acceptProcessAckDataEvent(s,n){var o;(o=this._terminalProcesses.get(s))===null||o===void 0||o.acknowledgeDataEvent(n)}$acceptProcessInput(s,n){var o;(o=this._terminalProcesses.get(s))===null||o===void 0||o.input(n)}$acceptProcessResize(s,n,o){var v;try{(v=this._terminalProcesses.get(s))===null||v===void 0||v.resize(n,o)}catch(m){if(m.code!=="EPIPE"&&m.code!=="ERR_IPC_CHANNEL_CLOSED")throw m}}$acceptProcessShutdown(s,n){var o;(o=this._terminalProcesses.get(s))===null||o===void 0||o.shutdown(n)}$acceptProcessRequestInitialCwd(s){var n;(n=this._terminalProcesses.get(s))===null||n===void 0||n.getInitialCwd().then(o=>this._proxy.$sendProcessInitialCwd(s,o))}$acceptProcessRequestCwd(s){var n;(n=this._terminalProcesses.get(s))===null||n===void 0||n.getCwd().then(o=>this._proxy.$sendProcessCwd(s,o))}$acceptProcessRequestLatency(s){return s}registerLinkProvider(s){return this._linkProviders.add(s),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(s),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(s,n,o){if(this._profileProviders.has(n))throw new Error(`Terminal profile provider "${n}" already registered`);return this._profileProviders.set(n,o),this._proxy.$registerProfileProvider(n,s.identifier.value),new E.Disposable(()=>{this._profileProviders.delete(n),this._proxy.$unregisterProfileProvider(n)})}async $createContributedProfileTerminal(s,n){var o;const v=new l.CancellationTokenSource().token,m=await((o=this._profileProviders.get(s))===null||o===void 0?void 0:o.provideTerminalProfile(v));if(!v.isCancellationRequested){if(!m||!("options"in m))throw new Error(`No terminal profile options provided for id "${s}"`);if("pty"in m.options){this.createExtensionTerminal(m.options,{isSplitTerminal:n});return}this.createTerminalFromOptions(m.options,{isSplitTerminal:n})}}async $provideLinks(s,n){const o=this._getTerminalById(s);if(!o)return[];this._terminalLinkCache.delete(s);const v=this._terminalLinkCancellationSource.get(s);v&&v.dispose(!0);const m=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(s,m);const S=[],D={terminal:o.value,line:n},a=[];for(const U of this._linkProviders)a.push(new Promise(async G=>{m.token.onCancellationRequested(()=>G({provider:U,links:[]}));const te=await U.provideTerminalLinks(D,m.token)||[];m.token.isCancellationRequested||G({provider:U,links:te})}));const T=await Promise.all(a);if(m.token.isCancellationRequested)return[];const L=new Map;for(const U of T)U&&U.links.length>0&&S.push(...U.links.map(G=>{const te={id:b++,startIndex:G.startIndex,length:G.length,label:G.tooltip};return L.set(te.id,{provider:U.provider,link:G}),te}));return this._terminalLinkCache.set(s,L),S}$activateLink(s,n){var o;const v=(o=this._terminalLinkCache.get(s))===null||o===void 0?void 0:o.get(n);!v||v.provider.handleTerminalLink(v.link)}_onProcessExit(s,n){this._bufferer.stopBuffering(s),this._terminalProcesses.delete(s),delete this._extensionTerminalAwaitingStart[s];const o=this._terminalProcessDisposables[s];o&&(o.dispose(),delete this._terminalProcessDisposables[s]),this._proxy.$sendProcessExit(s,n)}_getTerminalById(s){return this._getTerminalObjectById(this._terminals,s)}_getTerminalObjectById(s,n){const o=this._getTerminalObjectIndexById(s,n);return o!==null?s[o]:null}_getTerminalObjectIndexById(s,n){let o=null;return s.some((v,m)=>v._id===n?(o=m,!0):!1),o}getEnvironmentVariableCollection(s){let n=this._environmentVariableCollections.get(s.identifier.value);return n||(n=new u,this._setEnvironmentVariableCollection(s.identifier.value,n)),n}_syncEnvironmentVariableCollection(s,n){const o=P.serializeEnvironmentVariableCollection(n.map);this._proxy.$setEnvironmentVariableCollection(s,n.persistent,o.length===0?void 0:o)}$initEnvironmentVariableCollections(s){s.forEach(n=>{const o=n[0],v=new u(n[1]);this._setEnvironmentVariableCollection(o,v)})}$acceptDefaultProfile(s,n){this._defaultProfile=s,this._defaultAutomationProfile=n}_setEnvironmentVariableCollection(s,n){this._environmentVariableCollections.set(s,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(s,n)})}};d=Ve([$e(1,A.IExtHostRpcService)],d),e.BaseExtHostTerminalService=d;class u{constructor(s){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new p.Emitter,this.map=new Map(s)}get persistent(){return this._persistent}set persistent(s){this._persistent=s,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(s,n){this._setIfDiffers(s,{value:n,type:E.EnvironmentVariableMutatorType.Replace})}append(s,n){this._setIfDiffers(s,{value:n,type:E.EnvironmentVariableMutatorType.Append})}prepend(s,n){this._setIfDiffers(s,{value:n,type:E.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(s,n){const o=this.map.get(s);(!o||o.value!==n.value||o.type!==n.type)&&(this.map.set(s,n),this._onDidChangeCollection.fire())}get(s){return this.map.get(s)}forEach(s,n){this.map.forEach((o,v)=>s.call(n,v,o,this))}delete(s){this.map.delete(s),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=u;let g=class extends d{constructor(s){super(!1,s)}createTerminal(s,n,o){throw new r.NotSupportedError}createTerminalFromOptions(s,n){throw new r.NotSupportedError}};g=Ve([$e(0,A.IExtHostRpcService)],g),e.WorkerExtHostTerminalService=g;function t(i){if(!!i)return"id"in i?{id:i.id,color:i.color}:i}});var rt=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},Be=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(ge[239],pe([0,1,18,16,22,21,3,69,52,6,25,15,32,5,13,17,7,211,122]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h,_,w,b){"use strict";var d,u,g,t,i;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(L,U){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(f.MainContext.MainThreadTesting),this.observer=new a(this.proxy),this.runTracker=new o(this.proxy),U.registerArgumentProcessor({processArgument:G=>(G==null?void 0:G.$mid)===13?h.TestItem.toItemFromContext(G):G})}createTestController(L){const U=new k.DisposableStore,G=U.add(new w.SingleUseTestCollection(L)),te=U.add(new R.RunOnceScheduler(()=>G.expand(G.root.id,0),0)),V={root:G.root,createTestRun:(N,W,M=!0)=>this.runTracker.createTestRun(L,N,W,M),createTestItem(N,W,M,q,O){if(!(M instanceof _.TestItemImpl))throw new Error(`The "parent" passed in for TestItem ${N} is invalid`);return new _.TestItemImpl(N,W,q,O,M)},set resolveChildrenHandler(N){G.resolveHandler=N,N&&te.schedule()},get resolveChildrenHandler(){return G.resolveHandler},dispose:()=>{U.dispose()}};return this.proxy.$registerTestController(L),U.add(k.toDisposable(()=>this.proxy.$unregisterTestController(L))),this.controllers.set(L,{controller:V,collection:G}),U.add(k.toDisposable(()=>this.controllers.delete(L))),U.add(G.onDidGenerateDiff(N=>this.proxy.$publishDiff(L,N))),V}createTestObserver(){return this.observer.checkout()}async runTests(L,U=y.CancellationToken.None){const G=te=>te.map(this.getInternalTestForReference,this).filter(P.isDefined).map(V=>({controllerId:V.controllerId,testId:V.item.extId}));await this.proxy.$runTests({exclude:L.exclude?G(L.exclude).map(te=>te.testId):void 0,tests:G(L.tests),debug:L.debug},U)}$publishTestResults(L){this.results=Object.freeze(L.map(U=>r.deepFreeze(h.TestResults.to(U))).concat(this.results).sort((U,G)=>G.completedAt-U.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest({controllerId:L,testId:U},G){var te;const V=(te=this.controllers.get(L))===null||te===void 0?void 0:te.collection;V&&(await V.expand(U,G<0?Infinity:G),V.flushDiff())}$acceptDiff(L){this.observer.applyDiff(L)}async $runControllerTests(L,U){var G;const te=this.controllers.get(L.controllerId);if(!te)return;const{controller:V,collection:N}=te,W=L.testIds.map(F=>N.tree.get(F)).filter(P.isDefined),M=L.excludeExtIds.map(F=>te.collection.tree.get(F)).filter(P.isDefined).filter(F=>W.some(B=>N.tree.comparePositions(B,F)===1));if(!W.length)return;const q={tests:W.map(F=>F.actual),exclude:M.map(F=>F.actual),debug:L.debug},O=this.runTracker.prepareForMainThreadTestRun(q,v.fromInternal(L),U);try{await((G=V.runHandler)===null||G===void 0?void 0:G.call(V,q,U))}finally{O.isRunning&&!U.isCancellationRequested&&await A.Event.toPromise(O.onEnd),this.runTracker.cancelRunById(L.runId)}}$cancelExtensionTestRun(L){L===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(L)}getInternalTestForReference(L){var U;return(U=p.mapFind(this.controllers.values(),({collection:G})=>G.getTestByReference(L)))!==null&&U!==void 0?U:this.observer.getMirroredTestDataByReference(L)}};s=Ve([$e(0,c.IExtHostRpcService)],s),e.ExtHostTesting=s;class n extends k.Disposable{constructor(L,U,G){super();this.dto=L,this.proxy=U,this.task=new Set,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new y.CancellationTokenSource(G)),this._register(this.cts.token.onCancellationRequested(()=>{for(const te of this.task)te.end()}))}get isRunning(){return this.task.size>0}get id(){return this.dto.id}createRun(L){const U=new m(L,this.cts.token,this.dto,this.sharedTestIds,this.proxy,()=>{this.task.delete(U),this.isRunning||this.dispose()});return this.task.add(U),U}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}}class o{constructor(L){this.proxy=L,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(L,U,G){return this.getTracker(L,U,G)}cancelRunById(L){for(const U of this.tracked.values())if(U.id===L){U.dispose();return}}cancelAllRuns(){for(const L of this.tracked.values())L.dispose()}createTestRun(L,U,G,te){var V,N;const W=this.tracked.get(U);if(W)return W.createRun(G);const M=v.fromPublic(L,U);this.proxy.$startedExtensionTestRun({debug:U.debug,exclude:(N=(V=U.exclude)===null||V===void 0?void 0:V.map(O=>O.id))!==null&&N!==void 0?N:[],id:M.id,tests:U.tests.map(O=>O.id),persist:te});const q=this.getTracker(U,M);return q.onEnd(()=>this.proxy.$finishedExtensionTestRun(M.id)),q.createRun(G)}getTracker(L,U,G){const te=new n(U,this.proxy,G);return this.tracked.set(L,te),te.onEnd(()=>this.tracked.delete(L)),te}}e.TestRunCoordinator=o;class v{constructor(L,U,G,te){this.controllerId=L,this.id=U,this.include=G,this.exclude=te}static fromPublic(L,U){var G,te;return new v(L,l.generateUuid(),new Set(U.tests.map(V=>V.id)),new Set((te=(G=U.exclude)===null||G===void 0?void 0:G.map(V=>V.id))!==null&&te!==void 0?te:E.Iterable.empty()))}static fromInternal(L){return new v(L.controllerId,L.runId,new Set(L.testIds),new Set(L.excludeExtIds))}isIncluded(L){for(let U=L;U;U=U.parent){if(this.include.has(U.id))return!0;if(this.exclude.has(U.id))return!1}return!1}}e.TestRunDto=v;class m{constructor(L,U,G,te,V,N){this.name=L,this.token=U,d.set(this,void 0),u.set(this,void 0),g.set(this,void 0),t.set(this,void 0),i.set(this,!1),this.taskId=l.generateUuid(),rt(this,t,N,"f"),rt(this,d,V,"f"),rt(this,u,G,"f"),rt(this,g,te,"f"),V.$startedTestRunTask(G.id,{id:this.taskId,name:L,running:!0})}setState(L,U,G){!Be(this,i,"f")&&Be(this,u,"f").isIncluded(L)&&(this.ensureTestIsKnown(L),Be(this,d,"f").$updateTestStateInRun(Be(this,u,"f").id,this.taskId,L.id,U,G))}appendMessage(L,U){!Be(this,i,"f")&&Be(this,u,"f").isIncluded(L)&&(this.ensureTestIsKnown(L),Be(this,d,"f").$appendTestMessageInRun(Be(this,u,"f").id,this.taskId,L.id,h.TestMessage.from(U)))}appendOutput(L){Be(this,i,"f")||Be(this,d,"f").$appendOutputToRun(Be(this,u,"f").id,this.taskId,C.VSBuffer.fromString(L))}end(){Be(this,i,"f")||(rt(this,i,!0,"f"),Be(this,d,"f").$finishedTestRunTask(Be(this,u,"f").id,this.taskId),Be(this,t,"f").call(this))}ensureTestIsKnown(L){const U=Be(this,g,"f");if(U.has(L.id))return;const G=[];for(;G.unshift(h.TestItem.from(L)),!(U.has(L.id)||(U.add(L.id),!L.parent));)L=L.parent;Be(this,d,"f").$addTestsToRun(Be(this,u,"f").controllerId,Be(this,u,"f").id,G)}}d=new WeakMap,u=new WeakMap,g=new WeakMap,t=new WeakMap,i=new WeakMap;class S extends b.IncrementalChangeCollector{constructor(L){super();this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(L){this.added.add(L)}update(L){Object.assign(L.revived,h.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}if(this.updated.delete(L),L.parent&&this.alreadyRemoved.has(L.parent)){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:U,removed:G}=this;return{get added(){return[...L].map(te=>te.revived)},get updated(){return[...U].map(te=>te.revived)},get removed(){return[...G].map(te=>te.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class D extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,U){return Object.assign(Object.assign({},L),{revived:h.TestItem.toPlain(L.item),depth:U?U.depth+1:0,children:new Set})}createChangeCollector(){return new S(this.changeEmitter)}}e.MirroredTestCollection=D;class a{constructor(L){this.proxy=L}checkout(){this.current||(this.current=this.createObserverData());const L=this.current;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(U=>U.revived)},dispose:I.once(()=>{--L.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(L){var U;return(U=this.current)===null||U===void 0?void 0:U.tests.getMirroredTestDataByReference(L)}applyDiff(L){var U;(U=this.current)===null||U===void 0||U.tests.apply(L)}createObserverData(){const L=new D;return this.proxy.$subscribeToDiffs(),{observers:0,tests:L}}}}),define(ge[240],pe([0,1,3,18,5,124,17,7]),function(X,e,p,R,C,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(r,P){this._extHostDocumentsAndEditors=P,this._onDidChangeTextEditorSelection=new p.Emitter,this._onDidChangeTextEditorOptions=new p.Emitter,this._onDidChangeTextEditorVisibleRanges=new p.Emitter,this._onDidChangeTextEditorViewColumn=new p.Emitter,this._onDidChangeActiveTextEditor=new p.Emitter,this._onDidChangeVisibleTextEditors=new p.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=r.getProxy(C.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(r){const P=this._extHostDocumentsAndEditors.allEditors();return r?P:P.map(l=>l.value)}async showTextDocument(r,P,l){let f;typeof P=="number"?f={position:A.ViewColumn.from(P),preserveFocus:l}:typeof P=="object"?f={position:A.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?A.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:f={preserveFocus:!1};const c=await this._proxy.$tryShowTextDocument(r.uri,f),h=c&&this._extHostDocumentsAndEditors.getEditor(c);if(h)return h.value;throw c?new Error(`Could NOT open editor for "${r.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${r.uri.toString()}".`)}createTextEditorDecorationType(r,P){return new y.TextEditorDecorationType(this._proxy,r,P).value}$acceptEditorPropertiesChanged(r,P){const l=this._extHostDocumentsAndEditors.getEditor(r);if(!l)throw new Error("unknown text editor");if(P.options&&l._acceptOptions(P.options),P.selections){const f=P.selections.selections.map(A.Selection.to);l._acceptSelections(f)}if(P.visibleRanges){const f=R.coalesce(P.visibleRanges.map(A.Range.to));l._acceptVisibleRanges(f)}if(P.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:Object.assign(Object.assign({},P.options),{lineNumbers:A.TextEditorLineNumbersStyle.to(P.options.lineNumbers)})}),P.selections){const f=I.TextEditorSelectionChangeKind.fromValue(P.selections.source),c=P.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:c,kind:f})}if(P.visibleRanges){const f=R.coalesce(P.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:f})}}$acceptEditorPositionData(r){for(const P in r){const l=this._extHostDocumentsAndEditors.getEditor(P);if(!l)throw new Error("Unknown text editor");const f=A.ViewColumn.to(r[P]);l.value.viewColumn!==f&&(l._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:f}))}}getDiffInformation(r){return Promise.resolve(this._proxy.$getDiffInformation(r))}}e.ExtHostEditors=E});var $n=this&&this.__rest||function(X,e){var p={};for(var R in X)Object.prototype.hasOwnProperty.call(X,R)&&e.indexOf(R)<0&&(p[R]=X[R]);if(X!=null&&typeof Object.getOwnPropertySymbols=="function")for(var C=0,R=Object.getOwnPropertySymbols(X);C<R.length;C++)e.indexOf(R[C])<0&&Object.prototype.propertyIsEnumerable.call(X,R[C])&&(p[R[C]]=X[R[C]]);return p};define(ge[241],pe([0,1,2,4,5,6,7]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=R.createDecorator("IExtHostTimeline");class I{constructor(r,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=r.getProxy(C.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:l=>{var f,c;if(l&&l.$mid===11){const h=l.uri===void 0?void 0:p.URI.revive(l.uri);return(c=(f=this._itemsBySourceAndUriMap.get(l.source))===null||f===void 0?void 0:f.get(E(h)))===null||c===void 0?void 0:c.get(l.handle)}return l}})}async $getTimeline(r,P,l,f,c){const h=this._providers.get(r);return h==null?void 0:h.provideTimeline(p.URI.revive(P),l,f,c)}registerTimelineProvider(r,P,l,f){const c=new y.DisposableStore,h=this.convertTimelineItem(P.id,f,c).bind(this);let _;P.onDidChange&&(_=P.onDidChange(b=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},b),{id:P.id})),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},P),{scheme:r,onDidChange:void 0,async provideTimeline(b,d,u,g){var t;(g==null?void 0:g.resetCache)&&(c.clear(),(t=w.get(P.id))===null||t===void 0||t.clear());const i=await P.provideTimeline(b,d,u);if(i==null)return;const s=h(b,g);return Object.assign(Object.assign({},i),{source:P.id,items:i.items.map(s)})},dispose(){var b;for(const d of w.values())(b=d.get(P.id))===null||b===void 0||b.clear();_==null||_.dispose(),c.dispose()}}))}convertTimelineItem(r,P,l){return(f,c)=>{let h;if(c==null?void 0:c.cacheResults){let _=this._itemsBySourceAndUriMap.get(r);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(r,_));const w=E(f);h=_.get(w),h===void 0&&(h=new Map,_.set(w,h))}return _=>{var w,b;const{iconPath:d}=_,u=$n(_,["iconPath"]),g=`${r}|${(w=_.id)!==null&&w!==void 0?w:_.timestamp}`;h==null||h.set(g,_);let t,i,s;return _.iconPath&&(d instanceof A.ThemeIcon?s={id:d.id}:p.URI.isUri(d)?(t=d,i=d):{light:t,dark:i}=d),Object.assign(Object.assign({},u),{id:(b=u.id)!==null&&b!==void 0?b:void 0,handle:g,source:r,command:_.command?P.toInternal(_.command,l):void 0,icon:t,iconDark:i,themeIcon:s,accessibilityInformation:_.accessibilityInformation})}}}registerTimelineProviderCore(r){if(this._providers.get(r.id))throw new Error(`Timeline Provider ${r.id} already exists.`);return this._proxy.$registerTimelineProvider({id:r.id,label:r.label,scheme:r.scheme}),this._providers.set(r.id,r),y.toDisposable(()=>{var l;for(const f of this._itemsBySourceAndUriMap.values())(l=f.get(r.id))===null||l===void 0||l.clear();this._providers.delete(r.id),this._proxy.$unregisterTimelineProvider(r.id),r.dispose()})}}e.ExtHostTimeline=I;function E(k){return k==null?void 0:k.toString()}}),define(ge[242],pe([0,1,6,10,2,5]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(E){this._openers=new Map,this._proxy=E.getProxy(y.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,k,r,P){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const l=P.schemes.find(f=>!A.supportedSchemes.has(f));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,r),this._proxy.$registerUriOpener(k,P.schemes,E,P.label),p.toDisposable(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(E,k,r){const P=this._openers.get(E);if(!P)throw new Error(`Unknown opener with id: ${E}`);const l=C.URI.revive(k);return P.canOpenExternalUri(l,r)}async $openUri(E,k,r){const P=this._openers.get(E);if(!P)throw new Error(`Unknown opener id: '${E}'`);return P.openExternalUri(C.URI.revive(k.resolvedUri),{sourceUri:C.URI.revive(k.sourceUri)},r)}}e.ExtHostUriOpeners=A,A.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(ge[243],pe([0,1,5,2,6,14,26]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(p.MainContext.MainThreadUrls)}registerUriHandler(k,r){if(this.handles.has(A.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const P=I.HandlePool++;return this.handles.add(A.ExtensionIdentifier.toKey(k)),this.handlers.set(P,r),this._proxy.$registerUriHandler(P,k),C.toDisposable(()=>{this.handles.delete(A.ExtensionIdentifier.toKey(k)),this.handlers.delete(P),this._proxy.$unregisterUriHandler(P)})}$handleExternalUri(k,r){const P=this.handlers.get(k);if(!P)return Promise.resolve(void 0);try{P.handleUri(R.URI.revive(r))}catch(l){y.onUnexpectedError(l)}return Promise.resolve(void 0)}async createAppUri(k){return R.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=I,I.HandlePool=0});var rt=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},Be=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(ge[63],pe([0,1,3,2,172,196,83,5]),function(X,e,p,R,C,y,A,I){"use strict";var E,k,r,P,l,f,c,h,_,w,b,d;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class u{constructor(m,S,D,a,T,L,U){E.set(this,void 0),k.set(this,void 0),r.set(this,void 0),P.set(this,void 0),l.set(this,void 0),f.set(this,void 0),c.set(this,""),h.set(this,void 0),_.set(this,!1),w.set(this,!1),b.set(this,!1),this._onMessageEmitter=new p.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,d.set(this,new p.Emitter),this._onDidDispose=Be(this,d,"f").event,rt(this,E,m,"f"),rt(this,k,S,"f"),rt(this,h,D,"f"),rt(this,P,a,"f"),rt(this,l,T,"f"),rt(this,f,L,"f"),rt(this,b,g(L),"f"),rt(this,r,U,"f")}dispose(){rt(this,_,!0,"f"),Be(this,d,"f").fire(),Be(this,d,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return rt(this,w,!0,"f"),A.asWebviewUri(m,Be(this,P,"f").remote)}get cspSource(){return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Be(this,c,"f")}set html(m){this.assertNotDisposed(),Be(this,c,"f")!==m&&(rt(this,c,m,"f"),!Be(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(rt(this,w,!0,"f"),Be(this,r,"f").report("Webview vscode-resource: uris",Be(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,k,"f").$setHtml(Be(this,E,"f"),m))}get options(){return this.assertNotDisposed(),Be(this,h,"f")}set options(m){this.assertNotDisposed(),Be(this,k,"f").$setOptions(Be(this,E,"f"),s(Be(this,f,"f"),Be(this,l,"f"),m)),rt(this,h,m,"f")}async postMessage(m){if(Be(this,_,"f"))return!1;const S=y.serializeWebviewMessage(m,{serializeBuffersForPostMessage:Be(this,b,"f")});return Be(this,k,"f").$postMessage(Be(this,E,"f"),S.message,...S.buffers)}assertNotDisposed(){if(Be(this,_,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=u,E=new WeakMap,k=new WeakMap,r=new WeakMap,P=new WeakMap,l=new WeakMap,f=new WeakMap,c=new WeakMap,h=new WeakMap,_=new WeakMap,w=new WeakMap,b=new WeakMap,d=new WeakMap;function g(v){try{const m=C.normalizeVersion(C.parseVersion(v.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch(m){return!1}}e.shouldSerializeBuffersForPostMessage=g;class t{constructor(m,S,D,a,T){this.initData=S,this.workspace=D,this._logService=a,this._deprecationService=T,this._webviews=new Map,this._webviewProxy=m.getProxy(I.MainContext.MainThreadWebviews)}$onMessage(m,S,...D){const a=this.getWebview(m);if(a){const{message:T}=y.deserializeWebviewMessage(S,D);a._onMessageEmitter.fire(T)}}$onMissingCsp(m,S){this._logService.warn(`${S} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,S,D){const a=new u(m,this._webviewProxy,n(S),this.initData,this.workspace,D,this._deprecationService);return this._webviews.set(m,a),a._onDidDispose(()=>{this._webviews.delete(m)}),a}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=t;function i(v){return{id:v.identifier,location:v.extensionLocation}}e.toExtensionData=i;function s(v,m,S){return{enableCommandUris:S.enableCommandUris,enableScripts:S.enableScripts,portMapping:S.portMapping,localResourceRoots:S.localResourceRoots||o(v,m)}}e.serializeWebviewOptions=s;function n(v){var m;return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,portMapping:v.portMapping,localResourceRoots:(m=v.localResourceRoots)===null||m===void 0?void 0:m.map(S=>R.URI.from(S))}}e.reviveOptions=n;function o(v,m){return[...((m==null?void 0:m.getWorkspaceFolders())||[]).map(S=>S.uri),v.extensionLocation]}}),define(ge[244],pe([0,1,21,73,6,10,24,2,17,63,82,5,7]),function(X,e,p,R,C,y,A,I,E,k,r,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,i){this.document=t,this._storagePath=i,this._backupCounter=1,this._edits=new r.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,i){await this.getEdit(t).undo(),i||this.disposeBackup()}async redo(t,i){await this.getEdit(t).redo(),i||this.disposeBackup()}disposeEdits(t){for(const i of t)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=u(this.document.uri)+this._backupCounter++;return A.joinPath(this._storagePath,t)}updateBackup(t){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const i=this._edits.get(t,0);if(!i)throw new Error("No edit found");return i}}class c{constructor(){this._documents=new Map}get(t,i){return this._documents.get(this.key(t,i))}add(t,i,s){const n=this.key(t,i.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${t} resource:${i.uri}`);const o=new f(i,s);return this._documents.set(n,o),o}delete(t,i){const s=this.key(t,i.uri);this._documents.delete(s)}key(t,i){return`${t}@@@${i}`}}var h;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(h||(h={}));class _{constructor(){this._providers=new Map}addTextProvider(t,i,s){return this.add(0,t,i,s)}addCustomProvider(t,i,s){return this.add(1,t,i,s)}get(t){return this._providers.get(t)}add(t,i,s,n){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:t,extension:s,provider:n}),new l.Disposable(()=>this._providers.delete(i))}}class w{constructor(t,i,s,n,o){this._extHostDocuments=i,this._extensionStoragePaths=s,this._extHostWebview=n,this._extHostWebviewPanels=o,this._editorProviders=new _,this._documents=new c,this._proxy=t.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,i,s,n){const o=new C.DisposableStore;return b(s)?(o.add(this._editorProviders.addTextProvider(i,t,s)),this._proxy.$registerTextEditorProvider(k.toExtensionData(t),i,n.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},k.shouldSerializeBuffersForPostMessage(t))):(o.add(this._editorProviders.addCustomProvider(i,t,s)),this.supportEditing(s)&&o.add(s.onDidChangeCustomDocument(v=>{const m=this.getCustomDocumentEntry(i,v.document.uri);if(d(v)){const S=m.addEdit(v);this._proxy.$onDidEdit(v.document.uri,i,S,v.label)}else this._proxy.$onContentChange(v.document.uri,i)})),this._proxy.$registerCustomEditorProvider(k.toExtensionData(t),i,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,k.shouldSerializeBuffersForPostMessage(t))),l.Disposable.from(o,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(t,i,s,n,o){var v;const m=this._editorProviders.get(i);if(!m)throw new Error(`No provider found for '${i}'`);if(m.type!==1)throw new Error(`Invalid provide type for '${i}'`);const S=I.URI.revive(t),D=await m.provider.openCustomDocument(S,{backupId:s,untitledDocumentData:n==null?void 0:n.buffer},o);let a;return this.supportEditing(m.provider)&&this._extensionStoragePaths&&(a=(v=this._extensionStoragePaths.workspaceValue(m.extension))!==null&&v!==void 0?v:this._extensionStoragePaths.globalValue(m.extension)),this._documents.add(i,D,a),{editable:this.supportEditing(m.provider)}}async $disposeCustomDocument(t,i){const s=this._editorProviders.get(i);if(!s)throw new Error(`No provider found for '${i}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${i}'`);const n=I.URI.revive(t),{document:o}=this.getCustomDocumentEntry(i,n);this._documents.delete(i,o),o.dispose()}async $resolveWebviewEditor(t,i,s,n,o,v){const m=this._editorProviders.get(s);if(!m)throw new Error(`No provider found for '${s}'`);const S=E.ViewColumn.to(o),D=this._extHostWebview.createNewWebview(i,n.webviewOptions,m.extension),a=this._extHostWebviewPanels.createNewWebviewPanel(i,s,n.title,S,n.panelOptions,D),T=I.URI.revive(t);switch(m.type){case 1:{const{document:L}=this.getCustomDocumentEntry(s,T);return m.provider.resolveCustomEditor(L,a,v)}case 0:{const L=this._extHostDocuments.getDocument(T);return m.provider.resolveCustomTextEditor(L,a,v)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,i,s){this.getCustomDocumentEntry(i,t).disposeEdits(s)}async $onMoveCustomEditor(t,i,s){const n=this._editorProviders.get(s);if(!n)throw new Error(`No provider found for '${s}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const o=this._extHostWebviewPanels.getWebviewPanel(t);if(!o)throw new Error("No webview found");const v=I.URI.revive(i),m=this._extHostDocuments.getDocument(v);await n.provider.moveCustomTextEditor(m,o,p.CancellationToken.None)}async $undo(t,i,s,n){return this.getCustomDocumentEntry(i,t).undo(s,n)}async $redo(t,i,s,n){return this.getCustomDocumentEntry(i,t).redo(s,n)}async $revert(t,i,s){const n=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).revertCustomDocument(n.document,s),n.disposeBackup()}async $onSave(t,i,s){const n=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).saveCustomDocument(n.document,s),n.disposeBackup()}async $onSaveAs(t,i,s,n){const o=this.getCustomDocumentEntry(i,t);return this.getCustomEditorProvider(i).saveCustomDocumentAs(o.document,I.URI.revive(s),n)}async $backup(t,i,s){const n=this.getCustomDocumentEntry(i,t),v=await this.getCustomEditorProvider(i).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},s);return n.updateBackup(v),v.id}getCustomDocumentEntry(t,i){const s=this._documents.get(t,I.URI.revive(i));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const i=this._editorProviders.get(t),s=i==null?void 0:i.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function b(g){return typeof g.resolveCustomTextEditor=="function"}function d(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function u(g){const t=g.scheme===y.Schemas.file||g.scheme===y.Schemas.untitled?g.fsPath:g.toString();return R.hash(t)+""}});var rt=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},Be=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(ge[245],pe([0,1,3,6,2,32,17,63,5,7]),function(X,e,p,R,C,y,A,I,E,k){"use strict";var r,P,l,f,c,h,_,w,b,d,u,g,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends R.Disposable{constructor(v,m,S,D,a,T,L){super();r.set(this,void 0),P.set(this,void 0),l.set(this,void 0),f.set(this,void 0),c.set(this,void 0),h.set(this,void 0),_.set(this,void 0),w.set(this,void 0),b.set(this,!0),d.set(this,!0),u.set(this,!1),g.set(this,this._register(new p.Emitter)),this.onDidDispose=Be(this,g,"f").event,t.set(this,this._register(new p.Emitter)),this.onDidChangeViewState=Be(this,t,"f").event,rt(this,r,v,"f"),rt(this,P,m,"f"),rt(this,l,S,"f"),rt(this,c,T,"f"),rt(this,w,a,"f"),rt(this,h,D,"f"),rt(this,f,L,"f")}dispose(){Be(this,u,"f")||(rt(this,u,!0,"f"),Be(this,g,"f").fire(),Be(this,P,"f").$disposeWebview(Be(this,r,"f")),Be(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,f,"f")}get viewType(){return this.assertNotDisposed(),Be(this,l,"f")}get title(){return this.assertNotDisposed(),Be(this,h,"f")}set title(v){this.assertNotDisposed(),Be(this,h,"f")!==v&&(rt(this,h,v,"f"),Be(this,P,"f").$setTitle(Be(this,r,"f"),v))}get iconPath(){return this.assertNotDisposed(),Be(this,_,"f")}set iconPath(v){this.assertNotDisposed(),Be(this,_,"f")!==v&&(rt(this,_,v,"f"),Be(this,P,"f").$setIconPath(Be(this,r,"f"),C.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return Be(this,c,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,w,"f")=="number"&&Be(this,w,"f")<0))return Be(this,w,"f")}get active(){return this.assertNotDisposed(),Be(this,d,"f")}get visible(){return this.assertNotDisposed(),Be(this,b,"f")}_updateViewState(v){Be(this,u,"f")||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(rt(this,d,v.active,"f"),rt(this,b,v.visible,"f"),rt(this,w,v.viewColumn,"f"),Be(this,t,"f").fire({webviewPanel:this}))}reveal(v,m){this.assertNotDisposed(),Be(this,P,"f").$reveal(Be(this,r,"f"),{viewColumn:v?A.ViewColumn.from(v):void 0,preserveFocus:!!m})}assertNotDisposed(){if(Be(this,u,"f"))throw new Error("Webview is disposed")}}r=new WeakMap,P=new WeakMap,l=new WeakMap,f=new WeakMap,c=new WeakMap,h=new WeakMap,_=new WeakMap,w=new WeakMap,b=new WeakMap,d=new WeakMap,u=new WeakMap,g=new WeakMap,t=new WeakMap;class s{constructor(v,m,S){this.webviews=m,this.workspace=S,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=v.getProxy(E.MainContext.MainThreadWebviewPanels)}static newHandle(){return y.generateUuid()}createWebviewPanel(v,m,S,D,a={}){const T=typeof D=="object"?D.viewColumn:D,L={viewColumn:A.ViewColumn.from(T),preserveFocus:typeof D=="object"&&!!D.preserveFocus},U=I.shouldSerializeBuffersForPostMessage(v),G=s.newHandle();this._proxy.$createWebviewPanel(I.toExtensionData(v),G,m,{title:S,panelOptions:n(a),webviewOptions:I.serializeWebviewOptions(v,this.workspace,a),serializeBuffersForPostMessage:U},L);const te=this.webviews.createNewWebview(G,a,v);return this.createNewWebviewPanel(G,m,S,T,a,te)}$onDidChangeWebviewPanelViewStates(v){const m=Object.keys(v);m.sort((S,D)=>{const a=v[S],T=v[D];return a.active?1:T.active?-1:+a.visible-+T.visible});for(const S of m){const D=this.getWebviewPanel(S);if(!D)continue;const a=v[S];D._updateViewState({active:a.active,visible:a.visible,viewColumn:A.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(v){const m=this.getWebviewPanel(v);m==null||m.dispose(),this._webviewPanels.delete(v),this.webviews.deleteWebview(v)}registerWebviewPanelSerializer(v,m,S){if(this._serializers.has(m))throw new Error(`Serializer for '${m}' already registered`);return this._serializers.set(m,{serializer:S,extension:v}),this._proxy.$registerSerializer(m,{serializeBuffersForPostMessage:I.shouldSerializeBuffersForPostMessage(v)}),new k.Disposable(()=>{this._serializers.delete(m),this._proxy.$unregisterSerializer(m)})}async $deserializeWebviewPanel(v,m,S,D){const a=this._serializers.get(m);if(!a)throw new Error(`No serializer found for '${m}'`);const{serializer:T,extension:L}=a,U=this.webviews.createNewWebview(v,S.webviewOptions,L),G=this.createNewWebviewPanel(v,m,S.title,D,S.panelOptions,U);await T.deserializeWebviewPanel(G,S.state)}createNewWebviewPanel(v,m,S,D,a,T){const L=new i(v,this._proxy,m,S,D,a,T);return this._webviewPanels.set(v,L),L}getWebviewPanel(v){return this._webviewPanels.get(v)}}e.ExtHostWebviewPanels=s;function n(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var rt=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},Be=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(ge[246],pe([0,1,3,6,63,5,7]),function(X,e,p,R,C,y,A){"use strict";var I,E,k,r,P,l,f,c,h,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends R.Disposable{constructor(u,g,t,i,s,n){super();I.set(this,void 0),E.set(this,void 0),k.set(this,void 0),r.set(this,void 0),P.set(this,!1),l.set(this,void 0),f.set(this,void 0),c.set(this,void 0),h.set(this,this._register(new p.Emitter)),this.onDidChangeVisibility=Be(this,h,"f").event,_.set(this,this._register(new p.Emitter)),this.onDidDispose=Be(this,_,"f").event,rt(this,k,t,"f"),rt(this,f,i,"f"),rt(this,I,u,"f"),rt(this,E,g,"f"),rt(this,r,s,"f"),rt(this,l,n,"f")}dispose(){Be(this,P,"f")||(rt(this,P,!0,"f"),Be(this,_,"f").fire(),Be(this,r,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,f,"f")}set title(u){this.assertNotDisposed(),Be(this,f,"f")!==u&&(rt(this,f,u,"f"),Be(this,E,"f").$setWebviewViewTitle(Be(this,I,"f"),u))}get description(){return this.assertNotDisposed(),Be(this,c,"f")}set description(u){this.assertNotDisposed(),Be(this,c,"f")!==u&&(rt(this,c,u,"f"),Be(this,E,"f").$setWebviewViewDescription(Be(this,I,"f"),u))}get visible(){return Be(this,l,"f")}get webview(){return Be(this,r,"f")}get viewType(){return Be(this,k,"f")}_setVisible(u){u===Be(this,l,"f")||Be(this,P,"f")||(rt(this,l,u,"f"),Be(this,h,"f").fire())}show(u){this.assertNotDisposed(),Be(this,E,"f").$show(Be(this,I,"f"),!!u)}assertNotDisposed(){if(Be(this,P,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,E=new WeakMap,k=new WeakMap,r=new WeakMap,P=new WeakMap,l=new WeakMap,f=new WeakMap,c=new WeakMap,h=new WeakMap,_=new WeakMap;class b{constructor(u,g){this._extHostWebview=g,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=u.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(u,g,t,i){if(this._viewProviders.has(g))throw new Error(`View provider for '${g}' already registered`);return this._viewProviders.set(g,{provider:t,extension:u}),this._proxy.$registerWebviewViewProvider(C.toExtensionData(u),g,{retainContextWhenHidden:i==null?void 0:i.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new A.Disposable(()=>{this._viewProviders.delete(g),this._proxy.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(u,g,t,i,s){const n=this._viewProviders.get(g);if(!n)throw new Error(`No view provider found for '${g}'`);const{provider:o,extension:v}=n,m=this._extHostWebview.createNewWebview(u,{},v),S=new w(u,this._proxy,g,t,m,!0);this._webviewViews.set(u,S),await o.resolveWebviewView(S,{state:i},s)}async $onDidChangeWebviewViewVisibility(u,g){this.getWebviewView(u)._setVisible(g)}async $disposeWebviewView(u){const g=this.getWebviewView(u);this._webviewViews.delete(u),g.dispose(),this._extHostWebview.deleteWebview(u)}getWebviewView(u){const g=this._webviewViews.get(u);if(!g)throw new Error("No webview found");return g}}e.ExtHostWebviewViews=b}),define(ge[127],pe([0,1,3,5,2,10,8,4,13]),function(X,e,p,R,C,y,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Un{constructor(P){this._onDidChangeWindowState=new p.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Un.InitialState,this._proxy=P.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(P){P!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:P}),this._onDidChangeWindowState.fire(this._state))}openUri(P,l){let f;if(typeof P=="string"){f=P;try{P=C.URI.parse(P)}catch(c){return Promise.reject(`Invalid uri - '${P}'`)}}return A.isFalsyOrWhitespace(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===y.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this._proxy.$openUri(P,f,l)}async asExternalUri(P,l){if(A.isFalsyOrWhitespace(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(P,l);return C.URI.from(f)}};k.InitialState={focused:!0},k=Ve([$e(0,E.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=I.createDecorator("IExtHostWindow")}),define(ge[247],pe([0,1,9,100,32,48,6,5,2,13]),function(X,e,p,R,C,y,A,I,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let r=class extends A.Disposable{constructor(l,f){super();const c=l.getProxy(I.MainContext.MainThreadDownloadService);f.registerCommand(!1,"_workbench.downloadResource",async h=>{const _=E.URI.file(p.join(R.tmpdir(),C.generateUuid()));return await c.$download(h,_),_})}};r=Ve([$e(0,k.IExtHostRpcService),$e(1,y.IExtHostCommands)],r),e.ExtHostDownloadService=r}),define(ge[248],pe([0,1,2,9,146,28,62,27,13,6,12,112,41]),function(X,e,p,R,C,y,A,I,E,k,r,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class f{constructor(w,b,d){this.name=w,this.file=b,this.appender=d}static async create(w,b){const d=await P.createRotatingLogger(w,b,30*l.ByteSize.MB,1);return d.clearFormatters(),new f(w,b,d)}append(w){this.appender.critical(w)}flush(){this.appender.flush()}}class c extends A.AbstractExtHostOutputChannel{constructor(w,b,d){super(w,!1,p.URI.file(b.file),d);this._appender=b}append(w){super.append(w),this._appender.append(w),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(w,b){this._appender.flush(),super.show(w,b)}clear(){this._appender.flush(),super.clear()}}let h=class extends A.ExtHostOutputService{constructor(w,b,d){super(w);this.logService=b,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new k.MutableDisposable,this._logsLocation=d.logsLocation}$setVisibleChannel(w){if(w){const b=this._channels.get(w);b&&(this._visibleChannelDisposable.value=b.onDidAppend(()=>b.update()))}}createOutputChannel(w){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const b=this._doCreateOutChannel(w);return b.then(d=>d._id.then(u=>this._channels.set(u,d))),new A.LazyOutputChannel(w,b)}async _doCreateOutChannel(w){try{const b=R.join(this._logsLocation.fsPath,`output_logging_${C.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await y.SymlinkSupport.existsDirectory(b)||await y.Promises.mkdir(b,{recursive:!0});const u=`${this._namePool++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}`,g=p.URI.file(R.join(b,`${u}.log`)),t=await f.create(u,g.fsPath);return new c(w,t,this._proxy)}catch(b){return this.logService.error(b),new A.ExtHostPushOutputChannel(w,this._proxy)}}};h=Ve([$e(0,E.IExtHostRpcService),$e(1,r.ILogService),$e(2,I.IExtHostInitDataService)],h),e.ExtHostOutputService2=h}),define(ge[249],pe([0,1,32,13,33]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let y=class extends C.BaseExtHostTerminalService{constructor(I){super(!0,I)}createTerminal(I,E,k){return this.createTerminalFromOptions({name:I,shellPath:E,shellArgs:k})}createTerminalFromOptions(I,E){const k=new C.ExtHostTerminal(this._proxy,p.generateUuid(),I,I.name);return this._terminals.push(k),k.create(I,E),k.value}};y=Ve([$e(0,R.IExtHostRpcService)],y),e.ExtHostTerminalService=y}),define(ge[250],pe([0,1,5,13,6,27,2,38,24,28,7,11,47,3,187,72,12]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class w{constructor(m,S,D){this.remoteAddress=m,this.localAddress=S,this._dispose=D,this._onDispose=new f.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function b(v){const m=v.trim().split(`
`),S=[];return m.forEach(a=>{const T=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(a);T&&T.length>=3&&S.push({pid:parseInt(T[1],10),socket:parseInt(T[2],10)})}),S.reduce((a,T)=>(a[T.socket]=T,a),{})}e.getSockets=b;function d(...v){const m=[].concat(...v.map(g));return[...new Map(m.filter(S=>S.st==="0A").map(S=>{const D=S.local_address.split(":");return{socket:parseInt(S.inode,10),ip:u(D[0]),port:parseInt(D[1],16)}}).map(S=>[S.ip+":"+S.port,S])).values()]}e.loadListeningPorts=d;function u(v){let m="";if(v.length===8)for(let S=v.length-2;S>=0;S-=2)m+=parseInt(v.substr(S,2),16),S!==0&&(m+=".");else for(let S=v.length-4;S>=0;S-=4)m+=parseInt(v.substr(S,4),16).toString(16),S!==0&&(m+=":");return m}e.parseIpAddress=u;function g(v){const m=v.trim().split(`
`),S=m.shift().trim().split(/\s+/).filter(a=>a!=="rx_queue"&&a!=="tm->when");return m.map(a=>a.trim().split(/\s+/).reduce((T,L,U)=>(T[S[U]||U]=L,T),{}))}e.loadConnectionTable=g;function t(v){return!!v.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||v.indexOf("out/vs/server/main.js")!==-1||v.indexOf("_productName=VSCode")!==-1}function i(v){const m=v.trim().split(`
`),S=[];return m.forEach(D=>{const a=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(D);a&&a.length>=4&&S.push({pid:parseInt(a[1],10),ppid:parseInt(a[2]),cmd:a[3]})}),S}e.getRootProcesses=i;async function s(v,m,S){const D=S.reduce((T,L)=>(T[L.pid]=L,T),{}),a=[];return v.forEach(({socket:T,ip:L,port:U})=>{var G;const te=m[T]?m[T].pid:void 0,V=te?(G=D[te])===null||G===void 0?void 0:G.cmd:void 0;te&&V&&!t(V)&&a.push({host:L,port:U,detail:V,pid:te})}),a}e.findPorts=s;function n(v,m,S){const D=new Map,a=i(m);for(const T of v){const L=S.get(T.port);if(L){D.set(T.port,L);continue}const U=a.find(G=>G.cmd.includes(`${T.port}`));if(U){let G=U,te;do te=a.find(V=>V.ppid===G.pid),te&&(G=te);while(te);D.set(T.port,{host:T.ip,port:T.port,pid:G.pid,detail:G.cmd,ppid:G.ppid})}else D.set(T.port,{host:T.ip,port:T.port,ppid:Number.MAX_VALUE})}return D}e.tryFindRootPorts=n;let o=class extends C.Disposable{constructor(m,S,D){super();this.logService=D,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new f.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(p.MainContext.MainThreadTunnelService),P.isLinux&&S.remote.isRemote&&S.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,S){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier.value} called openTunnel API for ${S.remoteAddress.host}:${S.remoteAddress.port}.`);const D=await this._proxy.$openTunnel(S,m.displayName);if(D){const a=new w(D.remoteAddress,D.localAddress,()=>this._proxy.$closeTunnel(D.remoteAddress));return this._register(a),a}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,S){const D=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(D,{selector:m,provider:S}),this._proxy.$registerPortsAttributesProvider(m,D),new r.Disposable(()=>{this._portAttributesProviders.delete(D),this._proxy.$unregisterPortsAttributesProvider(D)})}async $providePortAttributes(m,S,D,a,T){const L=[];for(const G of m){const te=this._portAttributesProviders.get(G);if(!te)return[];L.push(...await Promise.all(S.map(async V=>te.provider.providePortAttributes(V,D,a,T))))}const U=L.filter(G=>!!G);return U.length>0?U.map(G=>({autoForwardAction:G.autoForwardAction,port:G.port})):[]}async $registerCandidateFinder(m){if(m&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=m;let S=new h.MovingAverage,D;for(;this._candidateFindingEnabled;){const a=new Date().getTime(),T=(await this.findCandidatePorts()).filter(U=>c.isLocalhost(U.host)||c.isAllInterfaces(U.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${T.map(U=>U.port).join(", ")}`);const L=new Date().getTime()-a;S.update(L),(!D||JSON.stringify(D)!==JSON.stringify(T))&&(D=T,await this._proxy.$onFoundNewCandidates(D)),await new Promise(U=>setTimeout(()=>U(),this.calculateDelay(S.value)))}}async setTunnelExtensionFunctions(m){var S;return m?(m.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,this._proxy.$setCandidateFilter()),m.tunnelFactory&&(this._forwardPortProvider=m.tunnelFactory,this._proxy.$setTunnelProvider((S=m.tunnelFeatures)!==null&&S!==void 0?S:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,C.toDisposable(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,S){if(this._extensionTunnels.has(m.host)){const D=this._extensionTunnels.get(m.host);D.has(m.port)&&(S&&D.get(m.port).disposeListener.dispose(),await D.get(m.port).tunnel.dispose(),D.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,S){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const D=this._forwardPortProvider(m,S);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),D!==void 0){const a=await D;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const T=this._register(a.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(a.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:a,disposeListener:T}),l.TunnelDto.fromApiTunnel(a)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(D){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const S=await Promise.all(m.map(a=>{var T;return this._showCandidatePort(a.host,a.port,(T=a.detail)!==null&&T!==void 0?T:"")})),D=m.filter((a,T)=>S[T]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(a=>a.port).join(", ")} to ${D.map(a=>a.port).join(", ")}`),D}async findCandidatePorts(){let m="",S="";try{m=await k.Promises.readFile("/proc/net/tcp","utf8"),S=await k.Promises.readFile("/proc/net/tcp6","utf8")}catch(W){}const D=d(m,S),a=await new Promise(W=>{I.exec("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(M,q,O)=>{W(q)})}),T=b(a),L=await k.Promises.readdir("/proc"),U=[];for(let W of L)try{const M=Number(W),q=E.joinPath(A.URI.file("/proc"),W);if((await k.Promises.stat(q.fsPath)).isDirectory()&&!isNaN(M)){const F=await k.Promises.readlink(E.joinPath(q,"cwd").fsPath),B=await k.Promises.readFile(E.joinPath(q,"cmdline").fsPath,"utf8");U.push({pid:M,cwd:F,cmd:B})}}catch(M){}const G=[],te=D.filter(W=>{const M=T[W.socket];return M||G.push(W),M}),V=s(te,T,U);let N;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${G.length}`),G.length>0){const W=await new Promise(M=>{I.exec("ps -F -A -l | grep root",(q,O,F)=>{M(O)})});this._foundRootPorts=n(G,W,this._foundRootPorts),N=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${N.join(", ")}`)}return V.then(W=>N?W.concat(N):W)}};o=Ve([$e(0,R.IExtHostRpcService),$e(1,y.IExtHostInitDataService),$e(2,_.ILogService)],o),e.ExtHostTunnelService=o}),define(ge[251],pe([0,1,16,21,14,3,6,98,217,125,22]),function(X,e,p,R,C,y,A,I,E,k,r){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function l(n,o){try{return JSON.stringify(n,o)}catch(v){return"null"}}function f(n,o){return JSON.stringify(n,o)}function c(n){return n?(o,v)=>v&&v.$mid===1?n.transformOutgoing(v):v:null}var h;(function(n){n[n.LocalSide=0]="LocalSide",n[n.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));var _;(function(n){n[n.Responsive=0]="Responsive",n[n.Unresponsive=1]="Unresponsive"})(_=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},b=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class u extends A.Disposable{constructor(o,v=null,m=null){super();this[P]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=o,this._logger=v,this._uriTransformer=m,this._uriReplacer=c(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let S=0,D=k.ProxyIdentifier.count;S<D;S++)this._locals[S]=null,this._proxies[S]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new p.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(S=>this._receiveOneMessage(S))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(o=>{this._pendingRPCReplies[o].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(o){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(o){this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(o){this._responsiveState!==o&&(this._responsiveState=o,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(o){return this._uriTransformer?I.transformIncomingURIs(o,this._uriTransformer):o}getProxy(o){const{nid:v,sid:m}=o;return this._proxies[v]||(this._proxies[v]=this._createProxy(v,m)),this._proxies[v]}_createProxy(o,v){let m={get:(S,D)=>(typeof D=="string"&&!S[D]&&D.charCodeAt(0)===36&&(S[D]=(...a)=>this._remoteCall(o,D,a)),D===d?v:S[D])};return new Proxy(Object.create(null),m)}set(o,v){return this._locals[o.nid]=v,v}assertRegistered(o){for(let v=0,m=o.length;v<m;v++){const S=o[v];if(!this._locals[S.nid])throw new Error(`Missing actor ${S.sid} (isMain: ${S.isMain})`)}}_receiveOneMessage(o){if(this._isDisposed)return;const v=o.byteLength,m=g.read(o,0),S=m.readUInt8(),D=m.readUInt32();switch(S){case 1:case 2:{let{rpcId:a,method:T,args:L}=t.deserializeRequestJSONArgs(m);this._uriTransformer&&(L=I.transformIncomingURIs(L,this._uriTransformer)),this._receiveRequest(v,D,a,T,L,S===2);break}case 3:case 4:{let{rpcId:a,method:T,args:L}=t.deserializeRequestMixedArgs(m);this._uriTransformer&&(L=I.transformIncomingURIs(L,this._uriTransformer)),this._receiveRequest(v,D,a,T,L,S===4);break}case 5:{this._logger&&this._logger.logIncoming(v,D,0,"ack"),this._onDidReceiveAcknowledge(D);break}case 6:{this._receiveCancel(v,D);break}case 7:{this._receiveReply(v,D,void 0);break}case 9:{let a=t.deserializeReplyOKJSON(m);this._uriTransformer&&(a=I.transformIncomingURIs(a,this._uriTransformer)),this._receiveReply(v,D,a);break}case 8:{let a=t.deserializeReplyOKVSBuffer(m);this._receiveReply(v,D,a);break}case 10:{let a=t.deserializeReplyErrError(m);this._uriTransformer&&(a=I.transformIncomingURIs(a,this._uriTransformer)),this._receiveReplyErr(v,D,a);break}case 11:{this._receiveReplyErr(v,D,void 0);break}default:console.error("received unexpected message"),console.error(o)}}_receiveRequest(o,v,m,S,D,a){this._logger&&this._logger.logIncoming(o,v,1,`receiveRequest ${k.getStringIdentifierForProxy(m)}.${S}(`,D);const T=String(v);let L,U;if(a){const te=new R.CancellationTokenSource;D.push(te.token),L=this._invokeHandler(m,S,D),U=()=>te.cancel()}else L=this._invokeHandler(m,S,D),U=w;this._cancelInvokedHandlers[T]=U;const G=t.serializeAcknowledged(v);this._logger&&this._logger.logOutgoing(G.byteLength,v,1,"ack"),this._protocol.send(G),L.then(te=>{delete this._cancelInvokedHandlers[T];const V=t.serializeReplyOK(v,te,this._uriReplacer);this._logger&&this._logger.logOutgoing(V.byteLength,v,1,"reply:",te),this._protocol.send(V)},te=>{delete this._cancelInvokedHandlers[T];const V=t.serializeReplyErr(v,te);this._logger&&this._logger.logOutgoing(V.byteLength,v,1,"replyErr:",te),this._protocol.send(V)})}_receiveCancel(o,v){this._logger&&this._logger.logIncoming(o,v,1,"receiveCancel");const m=String(v);this._cancelInvokedHandlers[m]&&this._cancelInvokedHandlers[m]()}_receiveReply(o,v,m){this._logger&&this._logger.logIncoming(o,v,0,"receiveReply:",m);const S=String(v);if(!this._pendingRPCReplies.hasOwnProperty(S))return;const D=this._pendingRPCReplies[S];delete this._pendingRPCReplies[S],D.resolveOk(m)}_receiveReplyErr(o,v,m){this._logger&&this._logger.logIncoming(o,v,0,"receiveReplyErr:",m);const S=String(v);if(!this._pendingRPCReplies.hasOwnProperty(S))return;const D=this._pendingRPCReplies[S];delete this._pendingRPCReplies[S];let a;m&&(m.$isError?(a=new Error,a.name=m.name,a.message=m.message,a.stack=m.stack):a=m),D.resolveErr(a)}_invokeHandler(o,v,m){try{return Promise.resolve(this._doInvokeHandler(o,v,m))}catch(S){return Promise.reject(S)}}_doInvokeHandler(o,v,m){const S=this._locals[o];if(!S)throw new Error("Unknown actor "+k.getStringIdentifierForProxy(o));let D=S[v];if(typeof D!="function")throw new Error("Unknown method "+v+" on actor "+k.getStringIdentifierForProxy(o));return D.apply(S,m)}_remoteCall(o,v,m){if(this._isDisposed)return Promise.reject(C.canceled());let S=null;if(m.length>0&&R.CancellationToken.isCancellationToken(m[m.length-1])&&(S=m.pop()),S&&S.isCancellationRequested)return Promise.reject(C.canceled());const D=t.serializeRequestArguments(m,this._uriReplacer),a=++this._lastMessageId,T=String(a),L=new E.LazyPromise;S&&S.onCancellationRequested(()=>{const G=t.serializeCancel(a);this._logger&&this._logger.logOutgoing(G.byteLength,a,0,"cancel"),this._protocol.send(t.serializeCancel(a))}),this._pendingRPCReplies[T]=L,this._onWillSendRequest(a);const U=t.serializeRequest(a,o,v,D,!!S);return this._logger&&this._logger.logOutgoing(U.byteLength,a,0,`request: ${k.getStringIdentifierForProxy(o)}.${v}(`,m),this._protocol.send(U),L}}e.RPCProtocol=u,P=b,u.UNRESPONSIVE_TIME=3*1e3;class g{constructor(o,v){this._buff=o,this._offset=v}static alloc(o,v,m){let S=new g(r.VSBuffer.alloc(m+1+4),0);return S.writeUInt8(o),S.writeUInt32(v),S}static read(o,v){return new g(o,v)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(o){this._buff.writeUInt8(o,this._offset),this._offset+=1}readUInt8(){const o=this._buff.readUInt8(this._offset);return this._offset+=1,o}writeUInt32(o){this._buff.writeUInt32BE(o,this._offset),this._offset+=4}readUInt32(){const o=this._buff.readUInt32BE(this._offset);return this._offset+=4,o}static sizeShortString(o){return 1+o.byteLength}writeShortString(o){this._buff.writeUInt8(o.byteLength,this._offset),this._offset+=1,this._buff.set(o,this._offset),this._offset+=o.byteLength}readShortString(){const o=this._buff.readUInt8(this._offset);this._offset+=1;const m=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,m}static sizeLongString(o){return 4+o.byteLength}writeLongString(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readLongString(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const m=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,m}writeBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}static sizeVSBuffer(o){return 4+o.byteLength}writeVSBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readVSBuffer(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const v=this._buff.slice(this._offset,this._offset+o);return this._offset+=o,v}static sizeMixedArray(o,v){let m=0;m+=1;for(let S=0,D=o.length;S<D;S++){const a=o[S],T=v[S];switch(m+=1,T){case 1:m+=this.sizeLongString(a);break;case 2:m+=this.sizeVSBuffer(a);break;case 3:break}}return m}writeMixedArray(o,v){this._buff.writeUInt8(o.length,this._offset),this._offset+=1;for(let m=0,S=o.length;m<S;m++){const D=o[m];switch(v[m]){case 1:this.writeUInt8(1),this.writeLongString(D);break;case 2:this.writeUInt8(2),this.writeVSBuffer(D);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const o=this._buff.readUInt8(this._offset);this._offset+=1;let v=new Array(o);for(let m=0;m<o;m++)switch(this.readUInt8()){case 1:v[m]=this.readLongString();break;case 2:v[m]=this.readVSBuffer();break;case 3:v[m]=void 0;break}return v}}class t{static _arrayContainsBufferOrUndefined(o){for(let v=0,m=o.length;v<m;v++)if(o[v]instanceof r.VSBuffer||typeof o[v]=="undefined")return!0;return!1}static serializeRequestArguments(o,v){if(this._arrayContainsBufferOrUndefined(o)){let m=[],S=[];for(let D=0,a=o.length;D<a;D++){const T=o[D];T instanceof r.VSBuffer?(m[D]=T,S[D]=2):typeof T=="undefined"?(m[D]=r.VSBuffer.alloc(0),S[D]=3):(m[D]=r.VSBuffer.fromString(f(T,v)),S[D]=1)}return{type:"mixed",args:m,argsType:S}}return{type:"simple",args:f(o,v)}}static serializeRequest(o,v,m,S,D){return S.type==="mixed"?this._requestMixedArgs(o,v,m,S.args,S.argsType,D):this._requestJSONArgs(o,v,m,S.args,D)}static _requestJSONArgs(o,v,m,S,D){const a=r.VSBuffer.fromString(m),T=r.VSBuffer.fromString(S);let L=0;L+=g.sizeUInt8(),L+=g.sizeShortString(a),L+=g.sizeLongString(T);let U=g.alloc(D?2:1,o,L);return U.writeUInt8(v),U.writeShortString(a),U.writeLongString(T),U.buffer}static deserializeRequestJSONArgs(o){const v=o.readUInt8(),m=o.readShortString(),S=o.readLongString();return{rpcId:v,method:m,args:JSON.parse(S)}}static _requestMixedArgs(o,v,m,S,D,a){const T=r.VSBuffer.fromString(m);let L=0;L+=g.sizeUInt8(),L+=g.sizeShortString(T),L+=g.sizeMixedArray(S,D);let U=g.alloc(a?4:3,o,L);return U.writeUInt8(v),U.writeShortString(T),U.writeMixedArray(S,D),U.buffer}static deserializeRequestMixedArgs(o){const v=o.readUInt8(),m=o.readShortString(),S=o.readMixedArray(),D=new Array(S.length);for(let a=0,T=S.length;a<T;a++){const L=S[a];typeof L=="string"?D[a]=JSON.parse(L):D[a]=L}return{rpcId:v,method:m,args:D}}static serializeAcknowledged(o){return g.alloc(5,o,0).buffer}static serializeCancel(o){return g.alloc(6,o,0).buffer}static serializeReplyOK(o,v,m){return typeof v=="undefined"?this._serializeReplyOKEmpty(o):v instanceof r.VSBuffer?this._serializeReplyOKVSBuffer(o,v):this._serializeReplyOKJSON(o,l(v,m))}static _serializeReplyOKEmpty(o){return g.alloc(7,o,0).buffer}static _serializeReplyOKVSBuffer(o,v){let m=0;m+=g.sizeVSBuffer(v);let S=g.alloc(8,o,m);return S.writeVSBuffer(v),S.buffer}static deserializeReplyOKVSBuffer(o){return o.readVSBuffer()}static _serializeReplyOKJSON(o,v){const m=r.VSBuffer.fromString(v);let S=0;S+=g.sizeLongString(m);let D=g.alloc(9,o,S);return D.writeLongString(m),D.buffer}static deserializeReplyOKJSON(o){const v=o.readLongString();return JSON.parse(v)}static serializeReplyErr(o,v){return v?this._serializeReplyErrEror(o,v):this._serializeReplyErrEmpty(o)}static _serializeReplyErrEror(o,v){const m=r.VSBuffer.fromString(l(C.transformErrorForSerialization(v),null));let S=0;S+=g.sizeLongString(m);let D=g.alloc(10,o,S);return D.writeLongString(m),D.buffer}static deserializeReplyErrError(o){const v=o.readLongString();return JSON.parse(v)}static _serializeReplyErrEmpty(o){return g.alloc(11,o,0).buffer}}var i;(function(n){n[n.RequestJSONArgs=1]="RequestJSONArgs",n[n.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",n[n.RequestMixedArgs=3]="RequestMixedArgs",n[n.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",n[n.Acknowledged=5]="Acknowledged",n[n.Cancel=6]="Cancel",n[n.ReplyOKEmpty=7]="ReplyOKEmpty",n[n.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",n[n.ReplyOKJSON=9]="ReplyOKJSON",n[n.ReplyErrError=10]="ReplyErrError",n[n.ReplyErrEmpty=11]="ReplyErrEmpty"})(i||(i={}));var s;(function(n){n[n.String=1]="String",n[n.VSBuffer=2]="VSBuffer",n[n.Undefined=3]="Undefined"})(s||(s={}))}),define(ge[252],pe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=p.createDecorator("remoteAgentService")}),define(ge[253],pe([0,1,10,9,11,2,4,81,45,212,252]),function(X,e,p,R,C,y,A,I,E,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=A.createDecorator("pathService");let P=class xn{constructor(f,c,h,_){this.localUserHome=f,this.remoteAgentService=c,this.environmentService=h,this.contextService=_,this.resolveOS=(async()=>{const w=await this.remoteAgentService.getEnvironment();return(w==null?void 0:w.os)||C.OS})(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(w==null?void 0:w.userHome)||f})()}get defaultUriScheme(){return xn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,c){if(f.remoteAuthority)return p.Schemas.vscodeRemote;const h=I.getVirtualWorkspaceScheme(c.getWorkspace());if(h)return h;const _=c.getWorkspace().folders[0];if(_)return _.uri.scheme;const w=c.getWorkspace().configuration;return w?w.scheme:p.Schemas.file}async userHome(f){return(f==null?void 0:f.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?R.win32:R.posix)}async fileURI(f){let c="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const _=f.indexOf("/",2);_===-1?(c=f.substring(2),f="/"):(c=f.substring(2,_),f=f.substring(_)||"/")}return y.URI.from({scheme:p.Schemas.file,authority:c,path:f,query:"",fragment:""})}};P=Ve([$e(1,r.IRemoteAgentService),$e(2,k.IWorkbenchEnvironmentService),$e(3,E.IWorkspaceContextService)],P),e.AbstractPathService=P}),define(ge[64],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class p{constructor(A,I){this.line=A,this.character=I}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,I){return new p(0,0)}with(A){return new p(0,0)}}e.Position=p;class R{constructor(A,I,E,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new p(A,I),this.end=new p(E,k)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new R(0,0,0,0)}with(A){return new R(0,0,0,0)}}e.Range=R;var C;(function(y){y[y.Information=1]="Information",y[y.Warning=2]="Warning"})(C=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ge[31],pe([0,1,18,30,25,29,8,4,9,14,64]),function(X,e,p,R,C,y,A,I,E,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return r.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const P="\u27EA ",l=" characters skipped \u27EB",f=(P.length+l.length+5)*2;e.ISearchService=I.createDecorator("searchService");var c;(function(M){M[M.file=0]="file",M[M.text=1]="text"})(c=e.SearchProviderType||(e.SearchProviderType={}));var h;(function(M){M[M.File=1]="File",M[M.Text=2]="Text"})(h=e.QueryType||(e.QueryType={}));function _(M){return!!M.preview}e.resultIsMatch=_;function w(M){return!!M.resource}e.isFileMatch=w;function b(M){return!!M.message}e.isProgressMessage=b;var d;(function(M){M[M.Normal=0]="Normal",M[M.NewSearchStarted=1]="NewSearchStarted"})(d=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class u{constructor(q){this.resource=q,this.results=[]}}e.FileMatch=u;class g{constructor(q,O,F){this.ranges=O;const B=Array.isArray(O)?O:[O];if(F&&F.matchLines===1&&t(B)){q=A.getNLines(q,F.matchLines);let $="",Y=0,ce=0;const we=Math.floor(F.charsPerLine/5),Re=[];for(const ke of B){const Me=Math.max(ke.startColumn-we,0),Ge=ke.startColumn+F.charsPerLine;if(Me>ce+we+f){const ze=P+(Me-ce)+l;$+=ze+q.slice(Me,Ge),Y+=Me-(ce+ze.length)}else $+=q.slice(ce,Ge);Re.push(new s(0,ke.startColumn-Y,ke.endColumn-Y)),ce=Ge}this.preview={text:$,matches:Array.isArray(this.ranges)?Re:Re[0]}}else{const $=Array.isArray(O)?O[0].startLineNumber:O.startLineNumber;this.preview={text:q,matches:p.mapArrayOrNot(O,Y=>new i(Y.startLineNumber-$,Y.startColumn,Y.endLineNumber-$,Y.endColumn))}}}}e.TextSearchMatch=g;function t(M){const q=M[0].startLineNumber;for(const O of M)if(O.startLineNumber!==q||O.endLineNumber!==q)return!1;return!0}class i{constructor(q,O,F,B){this.startLineNumber=q,this.startColumn=O,this.endLineNumber=F,this.endColumn=B}}e.SearchRange=i;class s extends i{constructor(q,O,F){super(q,O,q,F)}}e.OneLineRange=s;var n;(function(M){M.Default="default",M.FileNames="fileNames",M.Type="type",M.Modified="modified",M.CountDescending="countDescending",M.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function o(M,q=!0){const O=M&&M.files&&M.files.exclude,F=q&&M&&M.search&&M.search.exclude;if(!O&&!F)return;if(!O||!F)return O||F;let B=Object.create(null);return B=C.mixin(B,C.deepClone(O)),B=C.mixin(B,C.deepClone(F),!0),B}e.getExcludes=o;function v(M,q){return M.excludePattern&&R.match(M.excludePattern,q)?!1:M.includePattern||M.usingSearchPaths?M.includePattern&&R.match(M.includePattern,q)?!0:M.usingSearchPaths?!!M.folderQueries&&M.folderQueries.some(O=>{const F=O.folder.fsPath;if(y.isEqualOrParent(q,F)){const B=E.relative(F,q);return!O.includePattern||!!R.match(O.includePattern,B)}else return!1}):!1:!0}e.pathIncludedInQuery=v;var m;(function(M){M[M.unknownEncoding=1]="unknownEncoding",M[M.regexParseError=2]="regexParseError",M[M.globParseError=3]="globParseError",M[M.invalidLiteral=4]="invalidLiteral",M[M.rgProcessError=5]="rgProcessError",M[M.other=6]="other",M[M.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class S extends Error{constructor(q,O){super(q);this.code=O}}e.SearchError=S;function D(M){const q=M.message;if(k.isPromiseCanceledError(M))return new S(q,m.canceled);try{const O=JSON.parse(q);return new S(O.message,O.code)}catch(O){return new S(q,m.other)}}e.deserializeSearchError=D;function a(M){const q={message:M.message,code:M.code};return new Error(JSON.stringify(q))}e.serializeSearchError=a;function T(M){return M.type==="error"?!0:M.type==="success"}e.isSerializedSearchComplete=T;function L(M){return M.type==="success"}e.isSerializedSearchSuccess=L;function U(M){return!!M.path}e.isSerializedFileMatch=U;function G(M,q){const O=M.searchPath?M.searchPath:M.relativePath;return A.fuzzyContains(O,q)}e.isFilePatternMatch=G;class te{constructor(q){this.path=q,this.results=[]}addMatch(q){this.results.push(q)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=te;function V(M,q){const O=Object.assign(Object.assign({},M||{}),q||{});return Object.keys(O).filter(F=>{const B=O[F];return typeof B=="boolean"&&B})}e.resolvePatternsForProvider=V;class N{constructor(q,O){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},q.excludePattern||{}),O.excludePattern||{}),this._parsedExcludeExpression=R.parse(this._excludeExpression);let F=q.includePattern;O.includePattern&&(F?F=Object.assign(Object.assign({},F),O.includePattern):F=O.includePattern),F&&(this._parsedIncludeExpression=R.parse(F))}includedInQuerySync(q,O,F){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(q,O,F)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(q,O,F))}includedInQuery(q,O,F){return Promise.resolve(this._parsedExcludeExpression(q,O,F)).then($=>!!$).then($=>$?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(q,O,F)).then(Y=>!!Y):Promise.resolve(!0)).then($=>$)}hasSiblingExcludeClauses(){return W(this._excludeExpression)}}e.QueryGlobTester=N;function W(M){for(const q in M)if(typeof M[q]!="boolean")return!0;return!1}}),define(ge[35],pe([0,1,18,16,21,3,23,10,72,24,8,15,2,164,4,12,182,45,59,27,13,7,31,5]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h,_,w,b,d,u,g,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(T,L,U){return new k.ExtUri(G=>m(G,U)).isEqual(T,L)}function n(T,L,U){return s(T.uri,L.uri,U)?0:r.compare(T.uri.toString(),L.uri.toString())}function o(T,L,U){return T.index!==L.index?T.index<L.index?-1:1:s(T.uri,L.uri,U)?r.compare(T.name,L.name):r.compare(T.uri.toString(),L.uri.toString())}function v(T,L,U,G){const te=T.slice(0).sort((N,W)=>U(N,W,G)),V=L.slice(0).sort((N,W)=>U(N,W,G));return p.delta(te,V,(N,W)=>U(N,W,G))}function m(T,L){const U=L.getCapabilities(T.scheme);return!(U&&U&1024)}class S extends w.Workspace{constructor(L,U,G,te,V,N){super(L,G.map(W=>new w.WorkspaceFolder(W)),te,N);this._name=U,this._isUntitled=V,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(N),G.forEach(W=>{this._workspaceFolders.push(W),this._structure.set(W.uri,W)})}static toExtHostWorkspace(L,U,G,te){if(!L)return{workspace:null,added:[],removed:[]};const{id:V,name:N,folders:W,configuration:M,isUntitled:q}=L,O=[],F=U;U?W.forEach((ce,we)=>{const Re=l.URI.revive(ce.uri),ke=S._findFolder(G||U,Re,te);ke?(ke.name=ce.name,ke.index=ce.index,O.push(ke)):O.push({uri:Re,name:ce.name,index:we})}):O.push(...W.map(({uri:ce,name:we,index:Re})=>({uri:l.URI.revive(ce),name:we,index:Re}))),O.sort((ce,we)=>ce.index<we.index?-1:1);const B=new S(V,N,O,M?l.URI.revive(M):null,!!q,ce=>m(ce,te)),{added:$,removed:Y}=v(F?F.workspaceFolders:[],B.workspaceFolders,n,te);return{workspace:B,added:$,removed:Y}}static _findFolder(L,U,G){for(let te=0;te<L.folders.length;te++){const V=L.workspaceFolders[te];if(s(V.uri,U,G))return V}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,U){return U&&this._structure.get(L)&&(L=k.dirname(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let D=class{constructor(L,U,G,te){this._onDidChangeWorkspace=new y.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new y.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=te,this._extHostFileSystemInfo=G,this._requestIdProvider=new E.Counter,this._barrier=new R.Barrier,this._proxy=L.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(i.MainContext.MainThreadMessageService);const V=U.workspace;this._confirmedWorkspace=V?new S(V.id,V.name,[],V.configuration?l.URI.revive(V.configuration):null,!!V.isUntitled,N=>m(N,G)):void 0}$initializeWorkspace(L,U){this._trusted=U,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:I.Schemas.untitled,path:k.basename(k.dirname(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,U,G,...te){const V=[];if(Array.isArray(te)&&te.forEach(O=>{l.URI.isUri(O.uri)&&!V.some(F=>s(F.uri,O.uri,this._extHostFileSystemInfo))&&V.push({uri:O.uri,name:O.name||k.basenameOrAuthority(O.uri)})}),this._unconfirmedWorkspace||[U,G].some(O=>typeof O!="number"||O<0)||G===0&&V.length===0)return!1;const N=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(U+G>N.length)return!1;const W=N.slice(0);W.splice(U,G,...V.map(O=>({uri:O.uri,name:O.name||k.basenameOrAuthority(O.uri),index:void 0})));for(let O=0;O<W.length;O++){const F=W[O];if(W.some((B,$)=>$!==O&&s(F.uri,B.uri,this._extHostFileSystemInfo)))return!1}W.forEach((O,F)=>O.index=F);const{added:M,removed:q}=v(N,W,o,this._extHostFileSystemInfo);if(M.length===0&&q.length===0)return!1;if(this._proxy){const O=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(O,U,G,V).then(void 0,F=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(_.Severity.Error,f.localize(0,null,O,F.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(W),!0}getWorkspaceFolder(L,U){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,U)}async getWorkspaceFolder2(L,U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,U)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,U){let G,te="";if(typeof L=="string"?(G=l.URI.file(L),te=L):typeof L!="undefined"&&(G=L,te=L.fsPath),!G)return te;const V=this.getWorkspaceFolder(G,!0);if(!V)return te;typeof U=="undefined"&&this._actualWorkspace&&(U=this._actualWorkspace.folders.length>1);let N=k.relativePath(V.uri,G);return U&&V.name&&(N=`${V.name}/${N}`),N}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=S.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:U,added:G,removed:te}=S.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=U||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:G,removed:te}))}findFiles(L,U,G,te,V=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${te.value}, entryPoint: findFiles`);let N;if(U===null?N=!1:U&&(typeof U=="string"?N=U:N=U.pattern),V&&V.isCancellationRequested)return Promise.resolve([]);const{includePattern:W,folder:M}=a(L);return this._proxy.$startFileSearch(P.withUndefinedAsNull(W),P.withUndefinedAsNull(M),P.withUndefinedAsNull(N),P.withUndefinedAsNull(G),V).then(q=>Array.isArray(q)?q.map(O=>l.URI.revive(O)):[])}async findTextInFiles(L,U,G,te,V=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${te.value}, entryPoint: findTextInFiles`);const N=this._requestIdProvider.getNext(),W=typeof U.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:M,folder:q}=a(U.include),O=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,F={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:W,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:M,excludePattern:O},B=!1;if(this._activeSearchCallbacks[N]=$=>{if(B)return;const Y=l.URI.revive($.resource);$.results.forEach(ce=>{t.resultIsMatch(ce)?G({uri:Y,preview:{text:ce.preview.text,matches:p.mapArrayOrNot(ce.preview.matches,we=>new g.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:p.mapArrayOrNot(ce.ranges,we=>new g.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):G({uri:Y,text:ce.text,lineNumber:ce.lineNumber})})},V.isCancellationRequested)return{};try{const $=await this._proxy.$startTextSearch(L,P.withUndefinedAsNull(q),F,N,V);return delete this._activeSearchCallbacks[N],$||{}}catch($){throw delete this._activeSearchCallbacks[N],$}}$handleTextSearchResult(L,U){this._activeSearchCallbacks[U]&&this._activeSearchCallbacks[U](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};D=Ve([$e(0,u.IExtHostRpcService),$e(1,d.IExtHostInitDataService),$e(2,b.IExtHostFileSystemInfo),$e(3,h.ILogService)],D),e.ExtHostWorkspace=D,e.IExtHostWorkspace=c.createDecorator("IExtHostWorkspace");function a(T){let L,U;return T&&(typeof T=="string"?L=T:(L=T.pattern,U=T.baseFolder||l.URI.file(T.base))),{includePattern:L,folder:U}}}),define(ge[36],pe([0,1,25,3,35,5,7,186,80,15,16,4,13,12,2]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(i,s){if(s){const n=s.split(".");let o=i;for(let v=0;o&&v<n.length;v++)o=o[n[v]];return o}}function _(i){return i instanceof c.URI}function w(i){return i&&i.uri instanceof c.URI&&i.languageId&&typeof i.languageId=="string"}function b(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function d(i){return i&&i.uri instanceof c.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function u(i){if(_(i))return{resource:i};if(w(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(b(i))return{overrideIdentifier:i.languageId};if(d(i))return{resource:i.uri};if(i===null)return{resource:null}}let g=class{constructor(s,n,o){this._proxy=s.getProxy(y.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=o,this._barrier=new r.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,n){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(s,n))}};g=Ve([$e(0,l.IExtHostRpcService),$e(1,C.IExtHostWorkspace),$e(2,f.ILogService)],g),e.ExtHostConfiguration=g;class t{constructor(s,n,o,v){this._onDidChangeConfiguration=new R.Emitter,this._proxy=s,this._logService=v,this._extHostWorkspace=n,this._configuration=I.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,n){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,o))}getConfiguration(s,n,o){const v=u(n)||{},m=this._toReadonlyValue(s?h(this._configuration.getValue(void 0,v,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,v,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,v,o==null?void 0:o.identifier);function S(a){if(a==null)return null;if(typeof a=="boolean")return a?1:4;switch(a){case A.ConfigurationTarget.Global:return 1;case A.ConfigurationTarget.Workspace:return 4;case A.ConfigurationTarget.WorkspaceFolder:return 5}}const D={has(a){return typeof h(m,a)!="undefined"},get:(a,T)=>{this._validateConfigurationAccess(s?`${s}.${a}`:a,v,o==null?void 0:o.identifier);let L=h(m,a);if(typeof L=="undefined")L=T;else{let U;const G=(te,V)=>{let N;const W=()=>{U=U||p.deepClone(m),N=N||h(U,V)};return k.isObject(te)?new Proxy(te,{get:(M,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return W(),()=>N;if(U)return N=N||h(U,V),N[q];const O=M[q];return typeof q=="string"?G(O,`${V}.${q}`):O},set:(M,q,O)=>(W(),N&&(N[q]=O),!0),deleteProperty:(M,q)=>(W(),N&&delete N[q],!0),defineProperty:(M,q,O)=>(W(),N&&Object.defineProperty(N,q,O),!0)}):te};L=G(L,a)}return L},update:(a,T,L,U)=>{a=s?`${s}.${a}`:a;const G=S(L);return T!==void 0?this._proxy.$updateConfigurationOption(G,a,T,v,U):this._proxy.$removeConfigurationOption(G,a,v,U)},inspect:a=>{var T,L,U,G,te,V,N,W;a=s?`${s}.${a}`:a;const M=p.deepClone(this._configuration.inspect(a,v,this._extHostWorkspace.workspace));if(M)return{key:a,defaultValue:(T=M.default)===null||T===void 0?void 0:T.value,globalValue:(L=M.user)===null||L===void 0?void 0:L.value,workspaceValue:(U=M.workspace)===null||U===void 0?void 0:U.value,workspaceFolderValue:(G=M.workspaceFolder)===null||G===void 0?void 0:G.value,defaultLanguageValue:(te=M.default)===null||te===void 0?void 0:te.override,globalLanguageValue:(V=M.user)===null||V===void 0?void 0:V.override,workspaceLanguageValue:(N=M.workspace)===null||N===void 0?void 0:N.override,workspaceFolderLanguageValue:(W=M.workspaceFolder)===null||W===void 0?void 0:W.override,languageIds:M.overrideIdentifiers}}};return typeof m=="object"&&p.mixin(D,m,!1),Object.freeze(D)}_toReadonlyValue(s){const n=o=>k.isObject(o)?new Proxy(o,{get:(v,m)=>n(v[m]),set:(v,m,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(v,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(v,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:v=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return n(s)}_validateConfigurationAccess(s,n,o){const v=E.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),m=o?`[${o.value}] `:"";if(v===4){typeof(n==null?void 0:n.resource)=="undefined"&&this._logService.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(v===3){(n==null?void 0:n.resource)&&this._logService.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,n){const o=new I.ConfigurationChangeEvent(s,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(v,m)=>o.affectsConfiguration(v,u(m))})}_toMap(s){return s.reduce((n,o)=>(n.set(o[0],o[1]),n),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=P.createDecorator("IExtHostConfiguration")});var rt=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},Be=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(ge[65],pe([0,1,2,16,3,5,7,35,42,36,21,33,13,27,4,10,11,12,61,201,14]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h,_,w,b,d,u){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(te){function V(W){if(W!=null)return W}te.from=V;function N(W){if(W!=null)return W}te.to=N})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var i;(function(te){function V(W){if(W!=null)return W}te.from=V;function N(W){if(W!=null)return W}te.to=N})(i=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(te){function V(W){if(W!=null)return W}te.from=V;function N(W){if(W!=null)return W}te.to=N})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(te){function V(M){if(M){const q=M;return q&&!!q.process}else return!1}te.is=V;function N(M){if(M==null)return;const q={process:M.process,args:M.args};return M.options&&(q.options=s.from(M.options)),q}te.from=N;function W(M){if(M!=null)return new A.ProcessExecution(M.process,M.args,M.options)}te.to=W})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(te){function V(W){if(W!=null)return W}te.from=V;function N(W){if(W!=null)return W}te.to=N})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var v;(function(te){function V(M){if(M){const q=M;return q&&(!!q.commandLine||!!q.command)}else return!1}te.is=V;function N(M){if(M==null)return;const q={};return M.commandLine!==void 0?q.commandLine=M.commandLine:(q.command=M.command,q.args=M.args),M.options&&(q.options=o.from(M.options)),q}te.from=N;function W(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new A.ShellExecution(M.commandLine,M.options):new A.ShellExecution(M.command,M.args?M.args:[],M.options)}te.to=W})(v=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var m;(function(te){function V(M){if(M){let q=M;return q&&q.customExecution==="customExecution"}else return!1}te.is=V;function N(M){return{customExecution:"customExecution"}}te.from=N;function W(M,q){return q.get(M)}te.to=W})(m=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var S;(function(te){function V(N,W){let M;return N.scope!==void 0&&typeof N.scope!="number"?M=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===A.TaskScope.Workspace&&W&&W.workspaceFile?M=W.workspaceFile:M=d.USER_TASKS_GROUP_KEY),{id:N._id,workspaceFolder:M}}te.from=V})(S=e.TaskHandleDTO||(e.TaskHandleDTO={}));var D;(function(te){function V(M,q){if(M==null)return[];const O=[];for(let F of M){const B=N(F,q);B&&O.push(B)}return O}te.fromMany=V;function N(M,q){if(M==null)return;let O;M.execution instanceof A.ProcessExecution?O=n.from(M.execution):M.execution instanceof A.ShellExecution?O=v.from(M.execution):M.execution&&M.execution instanceof A.CustomExecution&&(O=m.from(M.execution));const F=t.from(M.definition);let B;if(M.scope?typeof M.scope=="number"?B=M.scope:B=M.scope.uri:B=A.TaskScope.Workspace,!F||!B)return;const $=M.group?M.group.id:void 0;return{_id:M._id,definition:F,name:M.name,source:{extensionId:q.identifier.value,label:M.source,scope:B},execution:O,isBackground:M.isBackground,group:$,presentationOptions:i.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}te.from=N;async function W(M,q,O){if(M==null)return;let F;n.is(M.execution)?F=n.to(M.execution):v.is(M.execution)?F=v.to(M.execution):m.is(M.execution)&&(F=m.to(M._id,O));const B=t.to(M.definition);let $;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?$=M.source.scope:$=await q.resolveWorkspaceFolder(p.URI.revive(M.source.scope)):$=A.TaskScope.Workspace),!B||!$)return;const Y=new A.Task(B,$,M.name,M.source.label,F,M.problemMatchers);return M.isBackground!==void 0&&(Y.isBackground=M.isBackground),M.group!==void 0&&(Y.group=A.TaskGroup.from(M.group)),M.presentationOptions&&(Y.presentationOptions=i.to(M.presentationOptions)),M._id&&(Y._id=M._id),M.detail&&(Y.detail=M.detail),Y}te.to=W})(D=e.TaskDTO||(e.TaskDTO={}));var a;(function(te){function V(W){return W}te.from=V;function N(W){if(!!W)return Object.assign(Object.create(null),W)}te.to=N})(a=e.TaskFilterDTO||(e.TaskFilterDTO={}));class T{constructor(V,N,W){this._id=N,this._task=W,g.set(this,void 0),rt(this,g,V,"f")}get task(){return this._task}terminate(){Be(this,g,"f").terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}g=new WeakMap;var L;(function(te){function V(N){return{id:N._id,task:void 0}}te.from=V})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let U=class{constructor(V,N,W,M,q,O,F,B){this._onDidExecuteTask=new C.Emitter,this._onDidTerminateTask=new C.Emitter,this._onDidTaskProcessStarted=new C.Emitter,this._onDidTaskProcessEnded=new C.Emitter,this._proxy=V.getProxy(y.MainContext.MainThreadTask),this._workspaceProvider=W,this._editorService=M,this._configurationService=q,this._terminalService=O,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=F,this._deprecationService=B,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(V,N,W){if(!W)return new A.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:N,provider:W,extension:V}),this._proxy.$registerTaskProvider(M,N),new A.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(V,N){this._proxy.$registerTaskSystem(V,N)}fetchTasks(V){return this._proxy.$fetchTasks(a.from(V)).then(async N=>{const W=[];for(let M of N){const q=await D.to(M,this._workspaceProvider,this._providedCustomExecutions2);q&&W.push(q)}return W})}get taskExecutions(){const V=[];return this._taskExecutions.forEach(N=>V.push(N)),V}terminateTask(V){if(!(V instanceof T))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(V._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(V,N,W){const M=this._providedCustomExecutions2.get(V.id);if(M){if(this._activeCustomExecutions2.get(V.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(V.id,M),this._terminalService.attachPtyToTerminal(N,await M.callback(W))}this._lastStartedTask=V.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(V)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(V){const N=await this.getTaskExecution(V);this._taskExecutionPromises.delete(V.id),this._taskExecutions.delete(V.id),this.customExecutionComplete(V),this._onDidTerminateTask.fire({execution:N})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(V){const N=await this.getTaskExecution(V.id);this._onDidTaskProcessStarted.fire({execution:N,processId:V.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(V){const N=await this.getTaskExecution(V.id);this._onDidTaskProcessEnded.fire({execution:N,exitCode:V.exitCode})}$provideTasks(V,N){const W=this._handlers.get(V);if(!W)return Promise.reject(new Error("no handler found"));const M=[],q=R.asPromise(()=>W.provider.provideTasks(r.CancellationToken.None)).then(O=>this.provideTasksInternal(N,M,W,O));return new Promise(O=>{q.then(F=>{Promise.all(M).then(()=>{O(F)})})})}async $resolveTask(V,N){const W=this._handlers.get(V);if(!W)return Promise.reject(new Error("no handler found"));if(N.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${W.type}].`);const M=await D.to(N,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const q=await W.provider.resolveTask(M,r.CancellationToken.None);if(!q)return;this.checkDeprecation(q,W);const O=D.from(q,W.extension);if(!O)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(O.execution)&&await this.addCustomExecution(O,q,!0),await this.resolveTaskInternal(O)}nextHandle(){return this._handleCounter++}async addCustomExecution(V,N,W){const M=await this._proxy.$createTaskId(V);!W&&!this._providedCustomExecutions2.has(M)&&this._notProvidedCustomExecutions.add(M),this._providedCustomExecutions2.set(M,N.execution)}async getTaskExecution(V,N){if(typeof V=="string"){const q=this._taskExecutionPromises.get(V);if(!q)throw new Error("Unexpected: The specified task is missing an execution");return q}let W=this._taskExecutionPromises.get(V.id);if(W)return W;const M=new Promise(async(q,O)=>{const F=N||await D.to(V.task,this._workspaceProvider,this._providedCustomExecutions2);F?q(new T(this,V.id,F)):O("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(V.id,M),M.then(q=>(this._taskExecutions.set(V.id,q),q),q=>Promise.reject(q))}checkDeprecation(V,N){V._deprecated&&this._deprecationService.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(V){this._activeCustomExecutions2.get(V.id)&&this._activeCustomExecutions2.delete(V.id),this._notProvidedCustomExecutions.has(V.id)&&this._lastStartedTask!==V.id&&(this._providedCustomExecutions2.delete(V.id),this._notProvidedCustomExecutions.delete(V.id));let W=this._notProvidedCustomExecutions.values(),M=W.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=W.next()}};U=Ve([$e(0,l.IExtHostRpcService),$e(1,f.IExtHostInitDataService),$e(2,I.IExtHostWorkspace),$e(3,E.IExtHostDocumentsAndEditors),$e(4,k.IExtHostConfiguration),$e(5,P.IExtHostTerminalService),$e(6,w.ILogService),$e(7,b.IExtHostApiDeprecationService)],U),e.ExtHostTaskBase=U;let G=class extends U{constructor(V,N,W,M,q,O,F,B){super(V,N,W,M,q,O,F,B);this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:_.PlatformToString(0)})}async executeTask(V,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const W=D.from(N,V);if(W===void 0)throw new Error("Task is not valid");if(m.is(W.execution))await this.addCustomExecution(W,N,!1);else throw new u.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(W),N);return this._proxy.$executeTask(W).catch(q=>{throw new Error(q)}),M}provideTasksInternal(V,N,W,M){const q=[];if(M)for(let O of M){this.checkDeprecation(O,W),(!O.definition||!V[O.definition.type])&&this._logService.warn(`The task [${O.source}, ${O.name}] uses an undefined task type. The task will be ignored in the future.`);const F=D.from(O,W.extension);F&&m.is(F.execution)?(q.push(F),N.push(this.addCustomExecution(F,O,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:q,extension:W.extension}}async resolveTaskInternal(V){if(m.is(V.execution))return V;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(V,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,N,W){}};G=Ve([$e(0,l.IExtHostRpcService),$e(1,f.IExtHostInitDataService),$e(2,I.IExtHostWorkspace),$e(3,E.IExtHostDocumentsAndEditors),$e(4,k.IExtHostConfiguration),$e(5,P.IExtHostTerminalService),$e(6,w.ILogService),$e(7,b.IExtHostApiDeprecationService)],G),e.WorkerExtHostTask=G,e.IExtHostTask=c.createDecorator("IExtHostTask")}),define(ge[254],pe([0,1,18,68,30,75,23,10,9,24,8,15,2,140,168,115,45,204,253,31]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h,_,w,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(S,D,a,T){this.configurationService=S,this.workspaceContextService=D,this.editorGroupsService=a,this.pathService=T}text(S,D,a={}){S=this.getContentPattern(S,a);const T=this.configurationService.getValue(),L=D&&D.some(G=>!this.configurationService.getValue({resource:G}).search.useRipgrep),U=this.commonQuery(D==null?void 0:D.map(_.toWorkspaceFolder),a);return Object.assign(Object.assign({},U),{type:2,contentPattern:S,previewOptions:a.previewOptions,maxFileSize:a.maxFileSize,usePCRE2:T.search.usePCRE2||L||!1,beforeContext:a.beforeContext,afterContext:a.afterContext,userDisabledExcludesAndIgnoreFiles:a.disregardExcludeSettings&&a.disregardIgnoreFiles})}getContentPattern(S,D){const a=this.configurationService.getValue();S.isRegExp&&(S.pattern=S.pattern.replace(/\r?\n/g,"\\n"));const T=Object.assign(Object.assign({},S),{wordSeparators:a.editor.wordSeparators});return this.isCaseSensitive(S,D)&&(T.isCaseSensitive=!0),this.isMultiline(S)&&(T.isMultiline=!0),T}file(S,D={}){const a=this.commonQuery(S,D);return Object.assign(Object.assign({},a),{type:1,filePattern:D.filePattern?D.filePattern.trim():D.filePattern,exists:D.exists,sortByScore:D.sortByScore,cacheKey:D.cacheKey})}handleIncludeExclude(S,D){return S?(S=Array.isArray(S)?S.map(n):n(S),D?this.parseSearchPaths(S):{pattern:t(...Array.isArray(S)?S:[S])}):{}}commonQuery(S=[],D={}){const a=this.handleIncludeExclude(D.includePattern,D.expandPatterns),T=this.handleIncludeExclude(D.excludePattern,D.expandPatterns),L=S.length>1,U=(a.searchPaths&&a.searchPaths.length?a.searchPaths.map(V=>this.getFolderQueryForSearchPath(V,D,T)):S.map(V=>this.getFolderQueryForRoot(V,D,T,L))).filter(V=>!!V),G={_reason:D._reason,folderQueries:U,usingSearchPaths:!!(a.searchPaths&&a.searchPaths.length),extraFileResources:D.extraFileResources,excludePattern:T.pattern,includePattern:a.pattern,onlyOpenEditors:D.onlyOpenEditors,maxResults:D.maxResults};if(D.onlyOpenEditors){const N=p.coalesce(p.flatten(this.editorGroupsService.groups.map(M=>M.editors.map(q=>q.resource)))).filter(M=>d.pathIncludedInQuery(G,M.fsPath)),W=this.commonQueryFromFileList(N);return Object.assign(Object.assign({},G),W)}const te=D.extraFileResources&&D.extraFileResources.filter(V=>d.pathIncludedInQuery(G,V.fsPath));return G.extraFileResources=te&&te.length?te:void 0,G}commonQueryFromFileList(S){const D=[],a=new A.ResourceMap,T={};let L=!1;return S.forEach(U=>{var G,te;if(U.scheme===I.Schemas.walkThrough)return;if(k.isAbsolutePath(U)){const N=(te=(G=this.workspaceContextService.getWorkspaceFolder(U))===null||G===void 0?void 0:G.uri)!==null&&te!==void 0?te:U.with({path:E.dirname(U.fsPath)});let W=a.get(N);W||(L=!0,W={folder:N,includePattern:{}},D.push(W),a.set(N,W));const M=E.relative(N.fsPath,U.fsPath);P.assertIsDefined(W.includePattern)[M.replace(/\\/g,"/")]=!0}else U.fsPath&&(L=!0,T[U.fsPath]=!0)}),{folderQueries:D,includePattern:T,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(S,D){if(D.isSmartCase){if(S.isRegExp){if(r.containsUppercaseCharacter(S.pattern,!0))return!0}else if(r.containsUppercaseCharacter(S.pattern))return!0}return!!S.isCaseSensitive}isMultiline(S){return S.isMultiline||S.isRegExp&&f.isMultilineRegexSource(S.pattern)||S.pattern.indexOf(`
`)>=0?!0:!!S.isMultiline}parseSearchPaths(S){const D=W=>E.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),T=(Array.isArray(S)?S:i(S)).map(W=>{const M=this.pathService.resolvedUserHome;return M?y.untildify(W,M.scheme===I.Schemas.file?M.fsPath:M.path):W}),L=R.groupBy(T,W=>D(W)?"searchPaths":"exprSegments"),U=(L.exprSegments||[]).map(W=>r.rtrim(W,"/")).map(W=>r.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),s(W))),G={},te=this.expandSearchPathPatterns(L.searchPaths||[]);te&&te.length&&(G.searchPaths=te);const V=p.flatten(U),N=t(...V);return N&&(G.pattern=N),G}getExcludesForFolder(S,D){return D.disregardExcludeSettings?void 0:d.getExcludes(S,!D.disregardSearchExcludeSettings)}expandSearchPathPatterns(S){if(!S||!S.length)return[];const D=p.flatten(S.map(T=>{let{pathPortion:L,globPortion:U}=g(T);U&&(U=o(U));const G=this.expandOneSearchPath(L);return p.flatten(G.map(te=>this.resolveOneSearchPathPattern(te,U)))})),a=new Map;return D.forEach(T=>{const L=T.searchPath.toString(),U=a.get(L);U?T.pattern&&(U.pattern=U.pattern||{},U.pattern[T.pattern]=!0):a.set(L,{searchPath:T.searchPath,pattern:T.pattern?t(T.pattern):void 0})}),Array.from(a.values())}expandOneSearchPath(S){if(E.isAbsolute(S)){const D=this.workspaceContextService.getWorkspace().folders;return D[0]&&D[0].uri.scheme!==I.Schemas.file?[{searchPath:D[0].uri.with({path:S})}]:[{searchPath:l.URI.file(E.normalize(S))}]}if(this.workspaceContextService.getWorkbenchState()===2){const D=this.workspaceContextService.getWorkspace().folders[0].uri;if(S=n(S),S.startsWith("../")||S===".."){const T=E.posix.resolve(D.path,S);return[{searchPath:D.with({path:T})}]}const a=o(S);return[{searchPath:D,pattern:a}]}else{if(S==="./"||S===".\\")return[];{const D=S.replace(/^\.[\/\\]/,""),T=this.workspaceContextService.getWorkspace().folders.map(L=>{const U=D.match(new RegExp(`^${r.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return U?{match:U,folder:L}:null}).filter(P.isDefined);if(T.length)return T.map(L=>{const U=L.match[1];return{searchPath:L.folder.uri,pattern:U&&o(U)}});{const L=S.match(/\.[\/\\](.+)[\/\\]?/),U=L?L[1]:S,G=c.localize(0,null,U);throw new Error(G)}}}}resolveOneSearchPathPattern(S,D){const a=S.pattern&&D?`${S.pattern}/${D}`:S.pattern||D,T=[{searchPath:S.searchPath,pattern:a}];return a&&!a.endsWith("**")&&T.push({searchPath:S.searchPath,pattern:a+"/**"}),T}getFolderQueryForSearchPath(S,D,a){const T=this.getFolderQueryForRoot(_.toWorkspaceFolder(S.searchPath),D,a,!1);return T?Object.assign(Object.assign({},T),{includePattern:S.pattern}):null}getFolderQueryForRoot(S,D,a,T){let L;const U=l.URI.isUri(S)?S:S.uri;if(a.searchPaths){const W=a.searchPaths.filter(M=>k.isEqual(M.searchPath,U))[0];if(W&&!W.pattern)return null;W&&(L=W.pattern)}const G=this.configurationService.getValue({resource:U}),te=this.getExcludesForFolder(G,D),V=Object.assign(Object.assign({},te||{}),L||{}),N=l.URI.isUri(S)?k.basename(S):S.name;return{folder:U,folderName:T?N:void 0,excludePattern:Object.keys(V).length>0?V:void 0,fileEncoding:G.files&&G.files.encoding,disregardIgnoreFiles:typeof D.disregardIgnoreFiles=="boolean"?D.disregardIgnoreFiles:!G.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof D.disregardGlobalIgnoreFiles=="boolean"?D.disregardGlobalIgnoreFiles:!G.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof D.ignoreSymlinks=="boolean"?D.ignoreSymlinks:!G.search.followSymlinks}}};u=Ve([$e(0,h.IConfigurationService),$e(1,_.IWorkspaceContextService),$e(2,w.IEditorGroupsService),$e(3,b.IPathService)],u),e.QueryBuilder=u;function g(m){const S=m.match(/[\*\{\}\(\)\[\]\?]/);if(S){const D=S.index,a=m.substr(0,D).match(/[/|\\][^/\\]*$/);if(a){let T=m.substr(0,a.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:m.substr((a.index||0)+1)}}}return{pathPortion:m}}function t(...m){return m.length?m.reduce((S,D)=>(S[D]=!0,S),Object.create(null)):void 0}function i(m){return C.splitGlobAware(m,",").map(S=>S.trim()).filter(S=>!!S.length)}function s(m){return[`**/${m}/**`,`**/${m}`].map(D=>D.replace(/\*\*\/\*\*/g,"**"))}function n(m){return m.replace(/\\/g,"/")}function o(m){return n(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function v(m,S){m=p.distinct(m,T=>T.toString());const D=[],a=S.getWorkspace();return m&&m.forEach(T=>{let L;if(S.getWorkbenchState()===2)L=k.relativePath(a.folders[0].uri,T),L&&L!=="."&&(L="./"+L);else{const U=S.getWorkspaceFolder(T);if(U){const G=U.name;if(a.folders.filter(V=>V.name===G).length===1){const V=k.relativePath(U.uri,T);V===""?L=`./${U.name}`:L=`./${U.name}/${V}`}else L=T.fsPath}}L&&D.push(L)}),D}e.resolveResourcesForSearchIncludes=v}),define(ge[255],pe([0,1,24,2,21,14,4,254,31,45]),function(X,e,p,R,C,y,A,I,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const r=7e3;function P(h,_){const w=_.activationEvents;if(!w)return Promise.resolve(void 0);const b=[],d=[];for(const n of w)if(/^workspaceContains:/.test(n)){const o=n.substr("workspaceContains:".length);o.indexOf("*")>=0||o.indexOf("?")>=0||h.forceUsingSearch?d.push(o):b.push(o)}if(b.length===0&&d.length===0)return Promise.resolve(void 0);let u;const g=new Promise((n,o)=>{u=n}),t=n=>u({activationEvent:n}),i=Promise.all(b.map(n=>l(h,n,t))).then(()=>{}),s=f(h,_.identifier,d,t);return Promise.all([i,s]).then(()=>{u(void 0)}),g}e.checkActivateWorkspaceContainsExtension=P;async function l(h,_,w){for(const b of h.folders)if(await h.exists(p.joinPath(R.URI.revive(b),_))){w(`workspaceContains:${_}`);return}}async function f(h,_,w,b){if(w.length===0)return Promise.resolve(void 0);const d=new C.CancellationTokenSource,u=h.checkExists(h.folders,w,d.token),g=setTimeout(async()=>{d.cancel(),b(`workspaceContainsTimeout:${w.join(",")}`)},r);let t=!1;try{t=await u}catch(i){y.isPromiseCanceledError(i)||y.onUnexpectedError(i)}d.dispose(),clearTimeout(g),t&&b(`workspaceContains:${w.join(",")}`)}function c(h,_,w,b){const d=h.get(A.IInstantiationService),u=h.get(E.ISearchService),t=d.createInstance(I.QueryBuilder).file(_.map(i=>k.toWorkspaceFolder(R.URI.revive(i))),{_reason:"checkExists",includePattern:w,exists:!0});return u.fileSearch(t,b).then(i=>!!i.limitHit,i=>y.isPromiseCanceledError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=c});var rt=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},Be=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(ge[39],pe([0,1,159,9,66,24,16,6,23,2,12,5,36,215,87,35,34,213,14,26,22,191,7,116,4,27,88,13,79,47,33,3,255,85,193]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h,_,w,b,d,u,g,t,i,s,n,o,v,m,S,D,a,T,L,U){"use strict";var G,te,V;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=s.createDecorator("IHostUtils");let N=class Bn extends I.Disposable{constructor(O,F,B,$,Y,ce,we,Re,ke,Me){super();this._onDidChangeRemoteConnectionData=this._register(new a.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=F,this._extHostContext=B,this._initData=we,this._extHostWorkspace=$,this._extHostConfiguration=Y,this._logService=ce,this._extHostTunnelService=ke,this._extHostTerminalService=Me,this._disposables=new I.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new c.ExtHostStorage(this._extHostContext),this._secretState=new L.ExtHostSecretState(this._extHostContext),this._storagePath=Re,this._instaService=O.createChild(new m.ServiceCollection([c.IExtHostStorage,this._storage],[L.IExtHostSecretState,this._secretState]));const Ge=new Set;this._initData.hostExtensions.forEach(ze=>Ge.add(d.ExtensionIdentifier.toKey(ze))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ze,je,j)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ze,b.transformErrorForSerialization(je),j)},actualActivateExtension:async(ze,je)=>{if(Ge.has(d.ExtensionIdentifier.toKey(ze)))return await this._mainThreadExtensionsProxy.$activateExtension(ze,je),new f.HostExtension;const j=this._registry.getExtensionDescription(ze);return this._activateExtension(j,je)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),C.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){b.onUnexpectedError(O)}}async deactivateAll(){let O=[];try{O=this._registry.getAllExtensionDescriptions().map(Y=>Y.identifier).filter(Y=>this.isActivated(Y)).map(Y=>this._deactivate(Y))}catch(F){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,F){return this._activator.activateByEvent(O,F)}_activateById(O,F){return this._activator.activateById(O,F)}activateByIdWithErrors(O,F){return this._activateById(O,F).then(()=>{const B=this._activator.getActivatedExtension(O);if(B.activationFailed)return Promise.reject(B.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const O=E.TernarySearchTree.forPaths(),F=this._registry.getAllExtensionDescriptions().map(B=>{if(!!this._getEntryPoint(B))return this._hostUtils.realpath(B.extensionLocation.fsPath).then($=>O.set(k.URI.file($).fsPath,B))});this._extensionPathIndex=Promise.all(F).then(()=>O)}return this._extensionPathIndex}_deactivate(O){let F=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return F;const B=this._activator.getActivatedExtension(O);if(!B)return F;try{typeof B.module.deactivate=="function"&&(F=Promise.resolve(B.module.deactivate()).then(void 0,$=>(this._logService.error($),Promise.resolve(void 0))))}catch($){this._logService.error($)}try{I.dispose(B.subscriptions)}catch($){this._logService.error($)}return F}async _activateExtension(O,F){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,F).then(B=>{const $=B.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,$.codeLoadingTime,$.activateCallTime,$.activateResolvedTime,F),this._logExtensionActivationTimes(O,F,"success",$),B},B=>{throw this._logExtensionActivationTimes(O,F,"failure"),B})}_logExtensionActivationTimes(O,F,B,$){const Y=W(O,F);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},Y),$||{}),{outcome:B}))}_doActivateExtension(O,F){const B=W(O,F);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",B);const $=this._getEntryPoint(O);if(!$)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value} ${JSON.stringify(F)}`),this._logService.flush();const Y=new f.ExtensionActivationTimesBuilder(F.startup);return Promise.all([this._loadCommonJSModule(O.identifier,y.joinPath(O.extensionLocation,$),Y),this._loadExtensionContext(O)]).then(ce=>(C.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),Bn._callActivate(this._logService,O.identifier,ce[0],ce[1],Y))).then(ce=>(C.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),ce))}_loadExtensionContext(O){const F=new g.ExtensionGlobalMemento(O,this._storage),B=new g.ExtensionMemento(O.identifier.value,!1,this._storage),$=new U.ExtensionSecrets(O,this._secretState),Y=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ce=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([F.whenReady,B.whenReady,this._storagePath.whenReady]).then(()=>{const we=this;let Re;return Object.freeze({globalState:F,workspaceState:B,secrets:$,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(ke){return R.join(O.extensionLocation.fsPath,ke)},get storagePath(){var ke;return(ke=we._storagePath.workspaceValue(O))===null||ke===void 0?void 0:ke.fsPath},get globalStoragePath(){return we._storagePath.globalValue(O).fsPath},get logPath(){return R.join(we._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return k.URI.joinPath(we._initData.logsLocation,O.identifier.value)},get storageUri(){return we._storagePath.workspaceValue(O)},get globalStorageUri(){return we._storagePath.globalValue(O)},get extensionMode(){return Y},get extension(){return Re===void 0&&(Re=new M(we,O.identifier,O,ce)),Re},get extensionRuntime(){return _.checkProposedApiEnabled(O),we.extensionRuntime},get environmentVariableCollection(){return we._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,F,B,$,Y){return B=B||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,F,B,$,Y).then(ce=>new f.ActivatedExtension(!1,null,Y.build(),B,ce,$.subscriptions))}static _callActivateOptional(O,F,B,$,Y){if(typeof B.activate=="function")try{Y.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${F.value}`);const ce=typeof global=="object"?global:self,we=B.activate.apply(ce,[$]);return Y.activateCallStop(),Y.activateResolveStart(),Promise.resolve(we).then(Re=>(Y.activateResolveStop(),Re))}catch(ce){return Promise.reject(ce)}else return Promise.resolve(B)}_activateOneStartupFinished(O,F){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:F}).then(void 0,B=>{this._logService.error(B)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(C.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const F of O.activationEvents)F==="onStartupFinished"&&this._activateOneStartupFinished(O,F)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,Y=>{this._logService.error(Y)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Y=>this._handleWorkspaceContainsEagerExtensions(Y.added)));const F=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],B=this._handleWorkspaceContainsEagerExtensions(F),$=Promise.all([O,B]).then(()=>{});return Promise.race([$,A.timeout(1e4)]).then(()=>{this._activateAllStartupFinished()}),$}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(F=>this._handleWorkspaceContainsEagerExtension(O,F))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,F){if(this.isActivated(F.identifier))return;const B=!this._initData.remote.isRemote&&!!this._initData.remote.authority,$={folders:O.map(ce=>ce.uri),forceUsingSearch:B,exists:ce=>this._hostUtils.exists(ce.fsPath),checkExists:(ce,we,Re)=>this._mainThreadWorkspaceProxy.$checkExists(ce,we,Re)},Y=await T.checkActivateWorkspaceContainsExtension($,F);if(!!Y)return this._activateById(F.identifier,{startup:!0,extensionId:F.identifier,activationEvent:Y.activationEvent}).then(void 0,ce=>this._logService.error(ce))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:F}=this._initData.environment;if(!O||!F)throw new Error(p.localize(0,null));const B=await this._loadCommonJSModule(null,F,new f.ExtensionActivationTimesBuilder(!1));if(!B||typeof B.run!="function")throw new Error(p.localize(1,null,F.toString()));return new Promise(($,Y)=>{const ce=(ke,Me)=>{ke?Y(ke):$(typeof Me=="number"&&Me>0?1:0)},we=y.originalFSPath(F),Re=B.run(we,ce);Re&&Re.then&&Re.then(()=>{$(0)}).catch(ke=>{Y(ke.toString())})})}async $extensionTestsExit(O){this._logService.info(`extension host terminating: test runner requested exit with code ${O}`),this._logService.info(`exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(O,F){return this._resolvers[O]=F,I.toDisposable(()=>{delete this._resolvers[O]})}async _activateAndGetResolver(O){const F=O.indexOf("+");if(F===-1)throw new Error("Not an authority that can be resolved!");const B=O.substr(0,F);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${B}`,!1),{authorityPrefix:B,resolver:this._resolvers[B]}}async $resolveAuthority(O,F){const{authorityPrefix:B,resolver:$}=await this._activateAndGetResolver(O);if(!$)return{type:"error",error:{code:i.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${B}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions($)),C.mark(`code/extHost/willResolveAuthority/${B}`);const Y=await $.resolve(O,{resolveAttempt:F});C.mark(`code/extHost/didResolveAuthorityOK/${B}`);const ce={authority:O,host:Y.host,port:Y.port,connectionToken:Y.connectionToken},we={extensionHostEnv:Y.extensionHostEnv,isTrusted:Y.isTrusted};return{type:"ok",value:{authority:ce,options:we,tunnelInformation:{environmentTunnels:Y.environmentTunnels}}}}catch(Y){if(C.mark(`code/extHost/didResolveAuthorityError/${B}`),Y instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Y._code,message:Y._message,detail:Y._detail}};throw Y}}async $getCanonicalURI(O,F){const{authorityPrefix:B,resolver:$}=await this._activateAndGetResolver(O);if(!$)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${B}`);const Y=k.URI.revive(F);if(typeof $.getCanonicalURI=="undefined")return Y;const ce=await A.asPromise(()=>$.getCanonicalURI(Y));return ce||Y}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,F){return F===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(B=>this._activateByEvent(O,!1))}async $activate(O,F){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,F),!0):!1}async $deltaExtensions(O,F){O.forEach($=>$.extensionLocation=k.URI.revive($.extensionLocation));const B=await this.getExtensionPathIndex();return await Promise.all(F.map(async $=>{const Y=this._registry.getExtensionDescription($);if(!Y)return;const ce=await this._hostUtils.realpath(Y.extensionLocation.fsPath);B.delete(k.URI.file(ce).fsPath)})),await Promise.all(O.map(async $=>{const Y=await this._hostUtils.realpath($.extensionLocation.fsPath);B.set(k.URI.file(Y).fsPath,$)})),this._registry.deltaExtensions(O,F),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let F=u.VSBuffer.alloc(O),B=Math.random()%256;for(let $=0;$<O;$++)F.writeUInt8(B,$);return F}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};N=Ve([$e(0,s.IInstantiationService),$e(1,e.IHostUtils),$e(2,v.IExtHostRpcService),$e(3,h.IExtHostWorkspace),$e(4,l.IExtHostConfiguration),$e(5,r.ILogService),$e(6,n.IExtHostInitDataService),$e(7,o.IExtensionStoragePaths),$e(8,S.IExtHostTunnelService),$e(9,D.IExtHostTerminalService)],N),e.AbstractExtHostExtensionService=N;function W(q,O){return{id:q.identifier.value,name:q.name,extensionVersion:q.version,publisherDisplayName:q.publisher,activationEvents:q.activationEvents?q.activationEvents.join(","):null,isBuiltin:q.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=s.createDecorator("IExtHostExtensionService");class M{constructor(O,F,B,$){G.set(this,void 0),te.set(this,void 0),V.set(this,void 0),rt(this,G,O,"f"),rt(this,te,F,"f"),rt(this,V,B.identifier,"f"),this.id=B.identifier.value,this.extensionUri=B.extensionLocation,this.extensionPath=R.normalize(y.originalFSPath(B.extensionLocation)),this.packageJSON=B,this.extensionKind=$}get isActive(){return Be(this,G,"f").isActivated(Be(this,V,"f"))}get exports(){if(this.packageJSON.api!=="none")return Be(this,G,"f").getExtensionExports(Be(this,V,"f"))}activate(){return Be(this,G,"f").activateByIdWithErrors(Be(this,V,"f"),{startup:!1,extensionId:Be(this,te,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=M,G=new WeakMap,te=new WeakMap,V=new WeakMap}),define(ge[49],pe([0,1,9,2,3,16,5,7,120,35,39,42,203,36,198,13,4,15,37,46]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h,_,w,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=_.createDecorator("IExtHostDebugService");let u=class{constructor(m,S,D,a,T,L){this._workspaceService=S,this._extensionService=D,this._editorsService=a,this._configurationService=T,this._editorTabs=L,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=m.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(U=>{U.onDidChange(G=>{this.registerAllDebugTypes(U)}),this.registerAllDebugTypes(U)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(m,S){const D=m;if(typeof D.sourceReference=="number"&&D.sourceReference>0){let a=`debug:${encodeURIComponent(D.path||"")}`,T="?";return S&&(a+=`${T}session=${encodeURIComponent(S.id)}`,T="&"),a+=`${T}ref=${D.sourceReference}`,R.URI.parse(a)}else{if(D.path)return R.URI.file(D.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(m){const S=[];for(const D of m.getAllExtensionDescriptions())if(D.contributes){const a=D.contributes.debuggers;if(a&&a.length>0)for(const T of a)c.isDebuggerMainContribution(T)&&S.push(T.type)}this._debugServiceProxy.$registerDebugTypes(S)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const m=[];return this._breakpoints.forEach(S=>m.push(S)),m}addBreakpoints(m){this.startBreakpoints();const S=m.filter(T=>{const L=T.id;return this._breakpoints.has(L)?!1:(this._breakpoints.set(L,T),!0)});this.fireBreakpointChanges(S,[],[]);const D=[],a=new Map;for(const T of S)if(T instanceof I.SourceBreakpoint){let L=a.get(T.location.uri.toString());L||(L={type:"sourceMulti",uri:T.location.uri,lines:[]},a.set(T.location.uri.toString(),L),D.push(L)),L.lines.push({id:T.id,enabled:T.enabled,condition:T.condition,hitCondition:T.hitCondition,logMessage:T.logMessage,line:T.location.range.start.line,character:T.location.range.start.character})}else T instanceof I.FunctionBreakpoint&&D.push({type:"function",id:T.id,enabled:T.enabled,hitCondition:T.hitCondition,logMessage:T.logMessage,condition:T.condition,functionName:T.functionName});return this._debugServiceProxy.$registerBreakpoints(D)}removeBreakpoints(m){this.startBreakpoints();const S=m.filter(L=>this._breakpoints.delete(L.id));this.fireBreakpointChanges([],S,[]);const D=S.filter(L=>L instanceof I.SourceBreakpoint).map(L=>L.id),a=S.filter(L=>L instanceof I.FunctionBreakpoint).map(L=>L.id),T=S.filter(L=>L instanceof I.DataBreakpoint).map(L=>L.id);return this._debugServiceProxy.$unregisterBreakpoints(D,a,T)}startDebugging(m,S,D){return this._debugServiceProxy.$startDebugging(m?m.uri:void 0,S,{parentSessionID:D.parentSession?D.parentSession.id:void 0,repl:D.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:D.noDebug,compact:D.compact})}stopDebugging(m){return this._debugServiceProxy.$stopDebugging(m?m.id:void 0)}registerDebugConfigurationProvider(m,S,D){if(!S)return new I.Disposable(()=>{});const a=this._configProviderHandleCounter++;return this._configProviders.push({type:m,handle:a,provider:S}),this._debugServiceProxy.$registerDebugConfigurationProvider(m,D,!!S.provideDebugConfigurations,!!S.resolveDebugConfiguration,!!S.resolveDebugConfigurationWithSubstitutedVariables,a),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(T=>T.provider!==S),this._debugServiceProxy.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(m,S,D){if(!D)return new I.Disposable(()=>{});if(!this.definesDebugType(m,S))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${S}' debugger.`);if(this.getAdapterDescriptorFactoryByType(S))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:S,handle:a,factory:D}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(S,a),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(T=>T.factory!==D),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(m,S){if(!S)return new I.Disposable(()=>{});const D=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:m,handle:D,factory:S}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(a=>a.factory!==S)})}async $runInTerminal(m,S){return Promise.resolve(void 0)}async $substituteVariables(m,S){if(!this._variableResolver){const[T,L]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(T||[],this._editorsService,L)}let D;const a=await this.getFolder(m);return a&&(D={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(D,S)}createDebugAdapter(m,S){if(m.type==="implementation")return new n(m.implementation)}createSignService(){}async $startDASession(m,S){const D=this,a=await this.getSession(S);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(a.type),a).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const L=this.convertToDto(T),U=this.createDebugAdapter(L,a);if(!U)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const G=U;return this._debugAdapters.set(m,G),this.getDebugAdapterTrackers(a).then(te=>(te&&this._debugAdaptersTrackers.set(m,te),G.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const N=V,W={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(N.arguments.value);W.body={signature:M},G.sendResponse(W)}else throw new Error("no signer")}catch(M){W.success=!1,W.message=M.message,G.sendResponse(W)}}else te&&te.onDidSendMessage&&te.onDidSendMessage(V),V=c.convertToVSCPaths(V,!0),D._debugServiceProxy.$acceptDAMessage(m,V)}),G.onError(V=>{te&&te.onError&&te.onError(V),this._debugServiceProxy.$acceptDAError(m,V.name,V.message,V.stack)}),G.onExit(V=>{te&&te.onExit&&te.onExit(w.withNullAsUndefined(V),void 0),this._debugServiceProxy.$acceptDAExit(m,w.withNullAsUndefined(V),void 0)}),te&&te.onWillStartSession&&te.onWillStartSession(),G.startSession()))})}$sendDAMessage(m,S){S=c.convertToDAPaths(S,!1);const D=this._debugAdaptersTrackers.get(m);D&&D.onWillReceiveMessage&&D.onWillReceiveMessage(S);const a=this._debugAdapters.get(m);a&&a.sendMessage(S)}$stopDASession(m){const S=this._debugAdaptersTrackers.get(m);this._debugAdaptersTrackers.delete(m),S&&S.onWillStopSession&&S.onWillStopSession();const D=this._debugAdapters.get(m);return this._debugAdapters.delete(m),D?D.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(m){const S=[],D=[],a=[];if(m.added)for(const T of m.added){const L=T.id;if(L&&!this._breakpoints.has(L)){let U;if(T.type==="function")U=new I.FunctionBreakpoint(T.functionName,T.enabled,T.condition,T.hitCondition,T.logMessage);else if(T.type==="data")U=new I.DataBreakpoint(T.label,T.dataId,T.canPersist,T.enabled,T.hitCondition,T.condition,T.logMessage);else{const G=R.URI.revive(T.uri);U=new I.SourceBreakpoint(new I.Location(G,new I.Position(T.line,T.character)),T.enabled,T.condition,T.hitCondition,T.logMessage)}U._id=L,this._breakpoints.set(L,U),S.push(U)}}if(m.removed)for(const T of m.removed){const L=this._breakpoints.get(T);L&&(this._breakpoints.delete(T),D.push(L))}if(m.changed){for(const T of m.changed)if(T.id){const L=this._breakpoints.get(T.id);if(L){if(L instanceof I.FunctionBreakpoint&&T.type==="function"){const U=L;U.enabled=T.enabled,U.condition=T.condition,U.hitCondition=T.hitCondition,U.logMessage=T.logMessage,U.functionName=T.functionName}else if(L instanceof I.SourceBreakpoint&&T.type==="source"){const U=L;U.enabled=T.enabled,U.condition=T.condition,U.hitCondition=T.hitCondition,U.logMessage=T.logMessage,U.location=new I.Location(R.URI.revive(T.uri),new I.Position(T.line,T.character))}a.push(L)}}}this.fireBreakpointChanges(S,D,a)}$provideDebugConfigurations(m,S,D){return y.asPromise(async()=>{const a=this.getConfigProviderByHandle(m);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const T=await this.getFolder(S);return a.provideDebugConfigurations(T,D)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(m,S,D,a){return y.asPromise(async()=>{const T=this.getConfigProviderByHandle(m);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.getFolder(S);return T.resolveDebugConfiguration(L,D,a)})}$resolveDebugConfigurationWithSubstitutedVariables(m,S,D,a){return y.asPromise(async()=>{const T=this.getConfigProviderByHandle(m);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.getFolder(S);return T.resolveDebugConfigurationWithSubstitutedVariables(L,D,a)})}async $provideDebugAdapter(m,S){const D=this.getAdapterDescriptorFactoryByHandle(m);if(!D)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.getSession(S);return this.getAdapterDescriptor(D,a).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.convertToDto(T)})}async $acceptDebugSessionStarted(m){const S=await this.getSession(m);this._onDidStartDebugSession.fire(S)}async $acceptDebugSessionTerminated(m){const S=await this.getSession(m);S&&(this._onDidTerminateDebugSession.fire(S),this._debugSessions.delete(S.id))}async $acceptDebugSessionActiveChanged(m){this._activeDebugSession=m?await this.getSession(m):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(m,S){const D=await this.getSession(m);D&&D._acceptNameChanged(S)}async $acceptDebugSessionCustomEvent(m,S){const a={session:await this.getSession(m),event:S.event,body:S.body};this._onDidReceiveDebugSessionCustomEvent.fire(a)}convertToDto(m){if(m instanceof I.DebugAdapterExecutable)return{type:"executable",command:m.command,args:m.args,options:m.options};if(m instanceof I.DebugAdapterServer)return{type:"server",port:m.port,host:m.host};if(m instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:m.path};if(m instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:m.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(m){const S=this._adapterFactories.filter(D=>D.type===m);if(S.length>0)return S[0].factory}getAdapterDescriptorFactoryByHandle(m){const S=this._adapterFactories.filter(D=>D.handle===m);if(S.length>0)return S[0].factory}getConfigProviderByHandle(m){const S=this._configProviders.filter(D=>D.handle===m);if(S.length>0)return S[0].provider}definesDebugType(m,S){if(m.contributes){const D=m.contributes.debuggers;if(D&&D.length>0){for(const a of D)if(a.label&&a.type&&a.type===S)return!0}}return!1}getDebugAdapterTrackers(m){const D=m.configuration.type,a=this._trackerFactories.filter(T=>T.type===D||T.type==="*").map(T=>y.asPromise(()=>T.factory.createDebugAdapterTracker(m)).then(L=>L,L=>null));return Promise.race([Promise.all(a).then(T=>{const L=T.filter(U=>!!U);if(L.length>0)return new s(L)}),new Promise((T,L)=>{const U=setTimeout(()=>{clearTimeout(U),L(new Error("timeout"))},1e3)})]).catch(T=>{})}async getAdapterDescriptor(m,S){const D=S.configuration.debugServer;if(typeof D=="number")return Promise.resolve(new I.DebugAdapterServer(D));if(m){const T=await this._extensionService.getExtensionRegistry();return y.asPromise(()=>m.createDebugAdapterDescriptor(S,this.daExecutableFromPackage(S,T))).then(L=>{if(L)return L})}const a=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(S,a))}daExecutableFromPackage(m,S){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(m,S,D){(m.length>0||S.length>0||D.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:m,removed:S,changed:D}))}async getSession(m){if(m)if(typeof m=="string"){const S=this._debugSessions.get(m);if(S)return S}else{let S=this._debugSessions.get(m.id);if(!S){const D=await this.getFolder(m.folderUri),a=m.parent?this._debugSessions.get(m.parent):void 0;S=new g(this._debugServiceProxy,m.id,m.type,m.name,D,m.configuration,a),this._debugSessions.set(S.id,S),this._debugServiceProxy.$sessionCached(S.id)}return S}throw new Error("cannot find session")}getFolder(m){if(m){const S=R.URI.revive(m);return this._workspaceService.resolveWorkspaceFolder(S)}return Promise.resolve(void 0)}};u=Ve([$e(0,h.IExtHostRpcService),$e(1,k.IExtHostWorkspace),$e(2,r.IExtHostExtensionService),$e(3,P.IExtHostDocumentsAndEditors),$e(4,f.IExtHostConfiguration),$e(5,d.IExtHostEditorTabs)],u),e.ExtHostDebugServiceBase=u;class g{constructor(m,S,D,a,T,L,U){this._debugServiceProxy=m,this._id=S,this._type=D,this._name=a,this._workspaceFolder=T,this._configuration=L,this._parentSession=U}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(m){this._name=m,this._debugServiceProxy.$setDebugSessionName(this._id,m)}get parentSession(){return this._parentSession}_acceptNameChanged(m){this._name=m}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(m,S){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,m,S)}getDebugProtocolBreakpoint(m){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,m.id)}}e.ExtHostDebugSession=g;class t{constructor(m){this.value=Object.freeze({append(S){m.$appendDebugConsole(S)},appendLine(S){this.append(S+`
`)}})}}e.ExtHostDebugConsole=t;class i extends l.AbstractVariableResolverService{constructor(m,S,D,a,T){function L(){if(S){const U=S.activeEditor();if(U)return U.document.uri;const G=a.tabs.filter(te=>te.isActive);if(G.length>0)return G[0].resource}}super({getFolderUri:U=>{const G=m.filter(te=>te.name===U);if(G&&G.length>0)return G[0].uri},getWorkspaceFolderCount:()=>m.length,getConfigurationValue:(U,G)=>D.getConfiguration(void 0,U).get(G),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const U=L();if(U)return p.normalize(U.fsPath)},getWorkspaceFolderPathForFile:()=>{if(T){const U=L();if(U){const G=T.getWorkspaceFolder(U);if(G)return p.normalize(G.uri.fsPath)}}},getSelectedText:()=>{if(S){const U=S.activeEditor();if(U&&!U.selection.isEmpty)return U.document.getText(U.selection)}},getLineNumber:()=>{if(S){const U=S.activeEditor();if(U)return String(U.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=i;class s{constructor(m){this.trackers=m}onWillStartSession(){this.trackers.forEach(m=>m.onWillStartSession?m.onWillStartSession():void 0)}onWillReceiveMessage(m){this.trackers.forEach(S=>S.onWillReceiveMessage?S.onWillReceiveMessage(m):void 0)}onDidSendMessage(m){this.trackers.forEach(S=>S.onDidSendMessage?S.onDidSendMessage(m):void 0)}onWillStopSession(){this.trackers.forEach(m=>m.onWillStopSession?m.onWillStopSession():void 0)}onError(m){this.trackers.forEach(S=>S.onError?S.onError(m):void 0)}onExit(m,S){this.trackers.forEach(D=>D.onExit?D.onExit(m,S):void 0)}}class n extends E.AbstractDebugAdapter{constructor(m){super();this.implementation=m,m.onDidSendMessage(S=>{this.acceptMessage(S)})}startSession(){return Promise.resolve(void 0)}sendMessage(m){this.implementation.handleMessage(m)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends u{constructor(m,S,D,a,T,L){super(m,S,D,a,T,L)}createVariableResolver(m,S,D){return new i(m,S,D,this._editorTabs)}};o=Ve([$e(0,h.IExtHostRpcService),$e(1,k.IExtHostWorkspace),$e(2,r.IExtHostExtensionService),$e(3,P.IExtHostDocumentsAndEditors),$e(4,f.IExtHostConfiguration),$e(5,d.IExtHostEditorTabs)],o),e.WorkerExtHostDebugService=o}),define(ge[256],pe([0,1,66,2,5,36,34,26,13,27,4,39,37,12]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let c=class{constructor(d,u,g,t,i,s,n){this._apiFactory=d,this._extensionRegistry=u,this._instaService=g,this._extHostConfiguration=t,this._extHostExtensionService=i,this._initData=s,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),p.mark("code/extHost/willWaitForConfig");const d=await this._extHostConfiguration.getConfigProvider();p.mark("code/extHost/didWaitForConfig");const u=await this._extHostExtensionService.getExtensionPathIndex();this.register(new h(this._apiFactory,u,this._extensionRegistry,d,this._logService)),this.register(this._instaService.createInstance(_)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,u,this._initData.environment.appUriScheme))}register(d){if(Array.isArray(d.nodeModuleName))for(let u of d.nodeModuleName)this._factories.set(u,d);else this._factories.set(d.nodeModuleName,d);typeof d.alternativeModuleName=="function"&&this._alternatives.push(u=>d.alternativeModuleName(u))}};c=Ve([$e(2,r.IInstantiationService),$e(3,y.IExtHostConfiguration),$e(4,P.IExtHostExtensionService),$e(5,k.IExtHostInitDataService),$e(6,f.ILogService)],c),e.RequireInterceptor=c;class h{constructor(d,u,g,t,i){this._apiFactory=d,this._extensionPaths=u,this._extensionRegistry=g,this._configProvider=t,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(d,u){const g=this._extensionPaths.findSubstr(u.fsPath);if(g){let t=this._extApiImpl.get(I.ExtensionIdentifier.toKey(g.identifier));return t||(t=this._apiFactory(g,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(g.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((i,s)=>t+=`	${s} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${u.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(d,u){this.nodeModuleName="keytar";const{environment:g}=u,t=d.getProxy(C.MainContext.MainThreadKeytar);if(g.appRoot){let i=g.appRoot.fsPath;l.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,s)=>t.$getPassword(i,s),setPassword:(i,s,n)=>t.$setPassword(i,s,n),deletePassword:(i,s)=>t.$deletePassword(i,s),findPassword:i=>t.$findPassword(i),findCredentials(i){return t.$findCredentials(i)}}}load(d,u){return this._impl}alternativeModuleName(d){const u=d.length;if(u<=7||!this.alternativeNames)return;const g=u-7;if((d.charAt(g)==="/"||d.charAt(g)==="\\")&&d.endsWith("keytar")&&(d=d.replace(/\\/g,"/"),this.alternativeNames.has(d)))return"keytar"}};_=Ve([$e(0,E.IExtHostRpcService),$e(1,k.IExtHostInitDataService)],_);let w=class{constructor(d,u,g){this._extensionPaths=d,this._appUriScheme=u,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=g.getProxy(C.MainContext.MainThreadTelemetry);const t=g.getProxy(C.MainContext.MainThreadWindow);this._impl=(i,s)=>{const n=R.URI.parse(i);return s?this.callOriginal(i,s):n.scheme==="http"||n.scheme==="https"?t.$openUri(n,i,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?t.$openUri(n,i,{}):this.callOriginal(i,s)}}load(d,u,g){const t=this._extensionPaths.findSubstr(u.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=g(d),this._impl}callOriginal(d,u){return this.sendNoForwardTelemetry(),this._original(d,u)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=Ve([$e(2,E.IExtHostRpcService)],w)}),define(ge[257],pe([0,1,165,11,7,199,35,39,42,36,33,13,49,188,16,200,46]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let w=class extends l.ExtHostDebugServiceBase{constructor(u,g,t,i,s,n,o){super(u,g,t,i,s,o);this._terminalService=n,this._integratedTerminalInstances=new b}createDebugAdapter(u,g){switch(u.type){case"server":return new y.SocketDebugAdapter(u);case"pipeServer":return new y.NamedPipeDebugAdapter(u);case"executable":return new y.ExecutableDebugAdapter(u,g.type)}return super.createDebugAdapter(u,g)}daExecutableFromPackage(u,g){const t=y.ExecutableDebugAdapter.platformAdapterExecutable(g.getAllExtensionDescriptions(),u.type);if(t)return new C.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new f.SignService}async $runInTerminal(u,g){if(u.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const t=await this._configurationService.getConfigProvider(),i=this._terminalService.getDefaultShell(!0),s=this._terminalService.getDefaultShellArgs(!0),n=u.title||p.localize(0,null),o=JSON.stringify({shell:i,shellArgs:s});let v=await this._integratedTerminalInstances.checkout(o,n),m,S=!1;if(v)m=u.cwd;else{const L={shellPath:i,shellArgs:s,cwd:u.cwd,name:n};S=!0,v=this._terminalService.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(v,o)}v.show(!0);const D=await v.processId;S?await new Promise(L=>setTimeout(L,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(i.indexOf("powershell")>=0||i.indexOf("pwsh")>=0||i.indexOf("cmd.exe")>=0?v.sendText("cls"):i.indexOf("bash")>=0?v.sendText("clear"):R.isWindows?v.sendText("cls"):v.sendText("clear"));const a=h.prepareCommand(i,u.args,m,u.env);v.sendText(a);const T=this.onDidTerminateDebugSession(L=>{L.id===g&&(this._integratedTerminalInstances.free(v),T.dispose())});return D}else if(u.kind==="external")return h.runInExternalTerminal(u,await this._configurationService.getConfigProvider());return super.$runInTerminal(u,g)}createVariableResolver(u,g,t){return new l.ExtHostVariableResolverService(u,g,t,this._editorTabs,this._workspaceService)}};w=Ve([$e(0,P.IExtHostRpcService),$e(1,A.IExtHostWorkspace),$e(2,I.IExtHostExtensionService),$e(3,E.IExtHostDocumentsAndEditors),$e(4,k.IExtHostConfiguration),$e(5,r.IExtHostTerminalService),$e(6,_.IExtHostEditorTabs)],w),e.ExtHostDebugService=w;class b{constructor(){this._terminalInstances=new Map}async checkout(u,g){const i=[...this._terminalInstances.entries()].map(([s,n])=>c.createCancelablePromise(async o=>{if(s.name!==g||n.lastUsedAt!==-1&&await h.hasChildProcesses(await s.processId))return null;const v=Date.now();return n.lastUsedAt+b.minUseDelay>v||o.isCancellationRequested||n.config!==u?null:(n.lastUsedAt=v,s)}));return await c.firstParallel(i,s=>!!s)}insert(u,g){this._terminalInstances.set(u,{lastUsedAt:Date.now(),config:g})}free(u){const g=this._terminalInstances.get(u);g&&(g.lastUsedAt=-1)}onTerminalClosed(u){this._terminalInstances.delete(u)}}b.minUseDelay=1e3}),define(ge[258],pe([0,1,9,2,109,35,49,42,36,33,13,27,65,10,12,61,46]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let w=class extends l.ExtHostTaskBase{constructor(d,u,g,t,i,s,n,o,v){super(d,u,g,t,i,s,n,o);this.workspaceService=g,this.editorTabs=v,u.remote.isRemote&&u.remote.authority?this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:u.remote.authority,platform:process.platform}):this.registerTaskSystem(f.Schemas.file,{scheme:f.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(d,u){const g=u;if(!u.execution&&g._id===void 0)throw new Error("Tasks to execute must include an execution");if(g._id!==void 0){const t=l.TaskHandleDTO.from(g,this.workspaceService),i=await this._proxy.$getTaskExecution(t);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.getTaskExecution(i,u);return this._proxy.$executeTask(t).catch(()=>{}),s}else{const t=l.TaskDTO.from(u,d);if(t===void 0)return Promise.reject(new Error("Task is not valid"));l.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,u,!1);const i=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),u);return this._proxy.$executeTask(t).catch(()=>{}),i}}provideTasksInternal(d,u,g,t){const i=[];if(t)for(let s of t){this.checkDeprecation(s,g),(!s.definition||!d[s.definition.type])&&this._logService.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const n=l.TaskDTO.from(s,g.extension);n&&(i.push(n),l.CustomExecutionDTO.is(n.execution)&&u.push(this.addCustomExecution(n,s,!0)))}return{tasks:i,extension:g.extension}}async resolveTaskInternal(d){return d}async getVariableResolver(d){if(this._variableResolver===void 0){const u=await this._configurationService.getConfigProvider();this._variableResolver=new A.ExtHostVariableResolverService(d,this._editorService,u,this.editorTabs,this.workspaceService)}return this._variableResolver}async $resolveVariables(d,u){const g=R.URI.revive(d),t={process:void 0,variables:Object.create(null)},i=await this._workspaceProvider.resolveWorkspaceFolder(g),s=await this._workspaceProvider.getWorkspaceFolders2();if(!s||!i)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const n=await this.getVariableResolver(s),o={uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}};for(let v of u.variables)t.variables[v]=await n.resolveAsync(o,v);if(u.process!==void 0){let v;if(u.process.path!==void 0){v=u.process.path.split(p.delimiter);for(let m=0;m<v.length;m++)v[m]=await n.resolveAsync(o,v[m])}t.process=await C.win32.findExecutable(await n.resolveAsync(o,u.process.name),u.process.cwd!==void 0?await n.resolveAsync(o,u.process.cwd):void 0,v)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(d,u,g){return C.win32.findExecutable(d,u,g)}};w=Ve([$e(0,r.IExtHostRpcService),$e(1,P.IExtHostInitDataService),$e(2,y.IExtHostWorkspace),$e(3,I.IExtHostDocumentsAndEditors),$e(4,E.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,c.ILogService),$e(7,h.IExtHostApiDeprecationService),$e(8,_.IExtHostEditorTabs)],w),e.ExtHostTask=w}),define(ge[259],pe([0,1,16,14,66,6,2,5,251,12,77,79,27,181,13,60,39,33]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(u,g,t,i){this._disposables=new y.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new E.RPCProtocol(u,null,i),g=b._transform(g,this._rpcProtocol);const s=new P.ServiceCollection(...r.getSingletonServiceDescriptors());s.set(l.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},g)),s.set(c.IExtHostRpcService,new c.ExtHostRpcService(this._rpcProtocol)),s.set(h.IURITransformerService,new h.URITransformerService(i)),s.set(_.IHostUtils,t);const n=new f.InstantiationService(s,!0),o=n.invokeFunction(D=>D.get(w.IExtHostTerminalService));this._disposables.add(o),this._logService=n.invokeFunction(D=>D.get(k.ILogService)),C.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",g),this._extensionService=n.invokeFunction(D=>D.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const v=new WeakMap;this._extensionService.getExtensionPathIndex().then(D=>{Error.prepareStackTrace=(a,T)=>{let L="",U,G;for(const te of T)L+=`
	at ${te.toString()}`,G=te.getFileName(),!U&&G&&(U=D.findSubstr(G));return v.set(a,U),`${a.name||"Error"}: ${a.message||""}${L}`}});const m=this._rpcProtocol.getProxy(I.MainContext.MainThreadExtensionService),S=this._rpcProtocol.getProxy(I.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(D=>{const a=R.transformErrorForSerialization(D),T=v.get(D);T?m.$onExtensionRuntimeError(T.identifier,a):S.$onUnexpectedError(a)})}terminate(u){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${u}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const g=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([p.timeout(4e3),g]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(u,g){u.extensions.forEach(i=>i.extensionLocation=A.URI.revive(g.transformIncomingURIs(i.extensionLocation))),u.environment.appRoot=A.URI.revive(g.transformIncomingURIs(u.environment.appRoot));const t=u.environment.extensionDevelopmentLocationURI;return t&&(u.environment.extensionDevelopmentLocationURI=t.map(i=>A.URI.revive(g.transformIncomingURIs(i)))),u.environment.extensionTestsLocationURI=A.URI.revive(g.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=A.URI.revive(g.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=A.URI.revive(g.transformIncomingURIs(u.environment.workspaceStorageHome)),u.logsLocation=A.URI.revive(g.transformIncomingURIs(u.logsLocation)),u.logFile=A.URI.revive(g.transformIncomingURIs(u.logFile)),u.workspace=g.transformIncomingURIs(u.workspace),u}}e.ExtensionHostMain=b}),define(ge[260],pe([0,1,9,21,57,30,24,43,31]),function(X,e,p,R,C,y,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(l,f,c){this.config=l,this.provider=f,this.sessionToken=c,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&y.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&y.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const f=this.config.folderQueries||[];return new Promise((c,h)=>{const _=w=>{this.resultCount++,l(w)};if(this.isCanceled)return c({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const b=w.toString(),d=p.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,d)||this.matchFile(_,{base:w,basename:d})}),Promise.all(f.map(w=>this.searchInFolder(w,_))).then(w=>{c({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{h(new Error(C.toErrorMessage(w)))})})}async searchInFolder(l,f){const c=new R.CancellationTokenSource,h=this.getSearchOptionsForFolder(l),_=this.initDirectoryTree(),w=new E.QueryGlobTester(this.config,l),b=!w.hasSiblingExcludeClauses();let d;try{this.activeCancellationTokens.add(c),d=I.StopWatch.create();const u=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},h,c.token),g=d.elapsed(),t=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(u&&u.forEach(i=>{const s=p.posix.relative(l.folder.path,i.path);if(b){const n=p.basename(i.path);this.matchFile(f,{base:l.folder,relativePath:s,basename:n});return}this.addDirectoryEntries(_,l.folder,s,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(_,w,f),{providerTime:g,postProcessTime:t.elapsed()})}finally{c.dispose(),this.activeCancellationTokens.delete(c)}}getSearchOptionsForFolder(l){const f=E.resolvePatternsForProvider(this.config.includePattern,l.includePattern),c=E.resolvePatternsForProvider(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:c,includes:f,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},f,c,h){if(c===this.filePattern){const w=p.basename(this.filePattern);this.matchFile(h,{base:f,relativePath:this.filePattern,basename:w})}function _(w){const b=p.basename(w),d=p.dirname(w);let u=l[d];u||(u=l[d]=[],_(d)),u.push({base:f,relativePath:w,basename:b})}_(c)}matchDirectoryTree({rootEntries:l,pathToEntries:f},c,h){const _=this,w=this.filePattern;function b(d){const u=y.hasSiblingFn(()=>d.map(g=>g.basename));for(let g=0,t=d.length;g<t;g++){const i=d[g],{relativePath:s,basename:n}=i;if(!c.includedInQuerySync(s,n,w!==n?u:void 0))continue;const o=f[s];if(o)b(o);else{if(s===w)continue;_.matchFile(h,i)}if(_.isLimitHit)break}}b(l)}matchFile(l,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(f))}}class r{constructor(){this.sessions=new Map}fileSearch(l,f,c,h){const _=this.getSessionTokenSource(l.cacheKey),w=new k(l,f,_&&_.token);let b=0;const d=u=>{b+=u.length,c(u.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(w,r.BATCH_SIZE,d,h).then(u=>({limitHit:u.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:u.stats}}))}clearCache(l){const f=this.getSessionTokenSource(l);f&&f.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new R.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:A.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,f,c,h){h.onCancellationRequested(()=>{l.cancel()});const _=b=>{b&&(w.push(b),f>0&&w.length>=f&&(c(w),w=[]))};let w=[];return l.search(_).then(b=>(w.length&&c(w),b),b=>(w.length&&c(w),Promise.reject(b)))}}e.FileSearchManager=r,r.BATCH_SIZE=512}),define(ge[128],pe([0,1,9,18,21,57,24,30,2,31,10,15]),function(X,e,p,R,C,y,A,I,E,k,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class l{constructor(d,u,g){this.query=d,this.provider=u,this.fileUtils=g,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(d,u){const g=this.query.folderQueries||[],t=new C.CancellationTokenSource;return u.onCancellationRequested(()=>t.cancel()),new Promise((i,s)=>{this.collector=new c(d);let n=!1;const o=(v,m)=>{if(!n&&!this.isLimitHit){const S=this.resultSize(v);_(v)&&typeof this.query.maxResults=="number"&&this.resultCount+S>this.query.maxResults&&(this.isLimitHit=!0,n=!0,t.cancel(),v=this.trimResultToSize(v,this.query.maxResults-this.resultCount));const D=this.resultSize(v);this.resultCount+=D,(D>0||!_(v))&&this.collector.add(v,m)}};Promise.all(g.map((v,m)=>this.searchInFolder(v,S=>o(S,m),t.token))).then(v=>{t.dispose(),this.collector.flush();const m=v.some(S=>!!S&&!!S.limitHit);i({limitHit:this.isLimitHit||m,messages:R.flatten(v.map(S=>(S==null?void 0:S.message)?P.isArray(S.message)?S.message:[S.message]:[])),stats:{type:"textSearchProvider"}})},v=>{t.dispose();const m=y.toErrorMessage(v);s(new Error(m))})})}resultSize(d){return _(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}trimResultToSize(d,u){const g=Array.isArray(d.ranges)?d.ranges:[d.ranges],t=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:g.slice(0,u),preview:{matches:t.slice(0,u),text:d.preview.text},uri:d.uri}}async searchInFolder(d,u,g){const t=new k.QueryGlobTester(this.query,d),i=[],s={report:v=>{if(!this.validateProviderResult(v))return;const m=d.folder.scheme===r.Schemas.file?I.hasSiblingPromiseFn(()=>this.fileUtils.readdir(A.dirname(v.uri))):void 0,S=A.relativePath(d.folder,v.uri);S&&i.push(t.includedInQuery(S,p.basename(S),m).then(D=>{D&&u(v)}))}},n=this.getSearchOptionsForFolder(d),o=await this.provider.provideTextSearchResults(f(this.query.contentPattern),n,s,g);return await Promise.all(i),o}validateProviderResult(d){if(_(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(d){const u=k.resolvePatternsForProvider(this.query.includePattern,d.includePattern),g=k.resolvePatternsForProvider(this.query.excludePattern,d.excludePattern),t={folder:E.URI.from(d.folder),excludes:g,includes:u,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.fileUtils.toCanonicalName(d.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=l;function f(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class c{constructor(d){this._onResult=d,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,u=>this.sendItems(u))}add(d,u){this._currentFileMatch&&(this._currentFolderIdx!==u||!A.isEqual(this._currentUri,d.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=u,this._currentFileMatch={resource:d.uri,results:[]}),this._currentFileMatch.results.push(h(d))}pushToCollector(){const d=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,d)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(d){this._onResult(d)}}e.TextSearchResultsCollector=c;function h(b){return _(b)?{preview:{matches:R.mapArrayOrNot(b.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:b.preview.text},ranges:R.mapArrayOrNot(b.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function _(b){return!!b.preview}e.extensionResultIsMatch=_;class w{constructor(d,u){this.maxBatchSize=d,this.cb=u,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(d,u){!d||this.addItemToBatch(d,u)}addItems(d,u){!d||this.addItemsToBatch(d,u)}addItemToBatch(d,u){this.batch.push(d),this.batchSize+=u,this.onUpdate()}addItemsToBatch(d,u){this.batch=this.batch.concat(d),this.batchSize+=u,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(ge[67],pe([0,1,6,5,4,260,13,60,12,2,128]),function(X,e,p,R,C,y,A,I,E,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=C.createDecorator("IExtHostSearch");let P=class{constructor(h,_,w){this.extHostRpc=h,this._uriTransformer=_,this._logService=w,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new y.FileSearchManager}_transformScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}registerTextSearchProvider(h,_){if(this._textSearchUsedSchemes.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this._textSearchUsedSchemes.add(h);const w=this._handlePool++;return this._textSearchProvider.set(w,_),this._proxy.$registerTextSearchProvider(w,this._transformScheme(h)),p.toDisposable(()=>{this._textSearchUsedSchemes.delete(h),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(h,_){if(this._fileSearchUsedSchemes.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this._fileSearchUsedSchemes.add(h);const w=this._handlePool++;return this._fileSearchProvider.set(w,_),this._proxy.$registerFileSearchProvider(w,this._transformScheme(h)),p.toDisposable(()=>{this._fileSearchUsedSchemes.delete(h),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(h,_,w,b){const d=l(w),u=this._fileSearchProvider.get(h);if(u)return this._fileSearchManager.fileSearch(d,u,g=>{this._proxy.$handleFileMatch(h,_,g.map(t=>t.resource))},b);throw new Error("unknown provider: "+h)}$clearCache(h){return this._fileSearchManager.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,_,w,b){const d=this._textSearchProvider.get(h);if(!d||!d.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const u=l(w);return this.createTextSearchManager(u,d).search(t=>this._proxy.$handleTextMatch(h,_,t),b)}createTextSearchManager(h,_){return new r.TextSearchManager(h,_,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};P=Ve([$e(0,A.IExtHostRpcService),$e(1,I.IURITransformerService),$e(2,E.ILogService)],P),e.ExtHostSearch=P;function l(c){return Object.assign(Object.assign({},c),{folderQueries:c.folderQueries&&c.folderQueries.map(f),extraFileResources:c.extraFileResources&&c.extraFileResources.map(h=>k.URI.revive(h))})}e.reviveQuery=l;function f(c){return Object.assign(Object.assign({},c),{folder:k.URI.revive(c.folder)})}}),define(ge[261],pe([0,1,21,14,3,54,2,150,105,141,76,41,5,221,220,48,222,36,223,224,225,206,226,42,39,227,207,229,230,231,62,209,236,237,238,87,33,240,210,17,7,243,63,127,35,34,68,197,228,81,126,65,49,67,12,60,13,27,232,195,47,61,218,241,194,88,86,246,244,245,219,59,239,242,85,46,117,234,64,235,10,183,233,192]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h,_,w,b,d,u,g,t,i,s,n,o,v,m,S,D,a,T,L,U,G,te,V,N,W,M,q,O,F,B,$,Y,ce,we,Re,ke,Me,Ge,ze,je,j,Z,ie,oe,J,le,me,Le,We,be,Qe,K,re,ve,Fe,Oe,Xe,De,_e,Pe,ae,he,H,ee,ue,Ie,Te,Ue,He){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function et(Je){const Ye=Je.get(ie.IExtHostInitDataService),nt=Je.get(Xe.IExtHostFileSystemInfo),gt=Je.get(K.IExtHostConsumerFileSystem),Ee=Je.get(s.IExtHostExtensionService),ye=Je.get(B.IExtHostWorkspace),de=Je.get(he.IExtHostTelemetry),Q=Je.get(w.IExtHostConfiguration),xe=Je.get(j.IURITransformerService),Se=Je.get(Z.IExtHostRpcService),qe=Je.get(G.IExtHostStorage),Ze=Je.get(Qe.IExtensionStoragePaths),tt=Je.get(je.ILogService),st=Je.get(le.IExtHostTunnelService),pt=Je.get(me.IExtHostApiDeprecationService),wt=Je.get(F.IExtHostWindow),Et=Je.get(Pe.IExtHostSecretState),vt=Je.get(ae.IExtHostEditorTabs);Se.set(l.ExtHostContext.ExtHostFileSystemInfo,nt),Se.set(l.ExtHostContext.ExtHostLogService,tt),Se.set(l.ExtHostContext.ExtHostWorkspace,ye),Se.set(l.ExtHostContext.ExtHostConfiguration,Q),Se.set(l.ExtHostContext.ExtHostExtensionService,Ee),Se.set(l.ExtHostContext.ExtHostStorage,qe),Se.set(l.ExtHostContext.ExtHostTunnelService,st),Se.set(l.ExtHostContext.ExtHostWindow,wt),Se.set(l.ExtHostContext.ExtHostSecretState,Et),Se.set(l.ExtHostContext.ExtHostTelemetry,de),Se.set(l.ExtHostContext.ExtHostEditorTabs,vt);const xt=Se.set(l.ExtHostContext.ExtHostDecorations,Je.get(ke.IExtHostDecorations)),_t=Se.set(l.ExtHostContext.ExtHostDocumentsAndEditors,Je.get(i.IExtHostDocumentsAndEditors)),dt=Se.set(l.ExtHostContext.ExtHostCommands,Je.get(h.IExtHostCommands)),ct=Se.set(l.ExtHostContext.ExtHostTerminalService,Je.get(te.IExtHostTerminalService)),ht=Se.set(l.ExtHostContext.ExtHostDebugService,Je.get(Ge.IExtHostDebugService)),Ht=Se.set(l.ExtHostContext.ExtHostSearch,Je.get(ze.IExtHostSearch)),kt=Se.set(l.ExtHostContext.ExtHostTask,Je.get(Me.IExtHostTask)),At=Se.set(l.ExtHostContext.ExtHostOutputService,Je.get(D.IExtHostOutputService)),Kt=Se.set(l.ExtHostContext.ExtHostUrls,new q.ExtHostUrls(Se)),St=Se.set(l.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(Se,_t)),en=Se.set(l.ExtHostContext.ExtHostDocumentContentProviders,new u.ExtHostDocumentContentProvider(Se,_t,tt)),tn=Se.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new g.ExtHostDocumentSaveParticipant(tt,St,Se.getProxy(l.MainContext.MainThreadBulkEdits))),mt=Se.set(l.ExtHostContext.ExtHostNotebook,new oe.ExtHostNotebookController(Se,dt,_t,St,Ze)),Qt=Se.set(l.ExtHostContext.ExtHostNotebookDocuments,new He.ExtHostNotebookDocuments(tt,mt)),zt=Se.set(l.ExtHostContext.ExtHostNotebookEditors,new Ue.ExtHostNotebookEditors(tt,Se,mt)),nn=Se.set(l.ExtHostContext.ExtHostNotebookKernels,new H.ExtHostNotebookKernels(Se,Ye,mt,tt)),_n=Se.set(l.ExtHostContext.ExtHostNotebookRenderers,new ue.ExtHostNotebookRenderers(Se,mt)),Dt=Se.set(l.ExtHostContext.ExtHostEditors,new V.ExtHostEditors(Se,_t)),Xt=Se.set(l.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(Se.getProxy(l.MainContext.MainThreadTreeViews),dt,tt)),rn=Se.set(l.ExtHostContext.ExtHostEditorInsets,new ce.ExtHostEditorInsets(Se.getProxy(l.MainContext.MainThreadEditorInsets),Dt,Ye)),Bt=Se.set(l.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(Se,tt)),ut=Se.set(l.ExtHostContext.ExtHostLanguageFeatures,new v.ExtHostLanguageFeatures(Se,xe,St,dt,Bt,tt,pt)),sn=Se.set(l.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(Se,ut)),Tt=Se.set(l.ExtHostContext.ExtHostFileSystemEventService,new o.ExtHostFileSystemEventService(Se,tt,_t)),Vt=Se.set(l.ExtHostContext.ExtHostQuickOpen,T.createExtHostQuickOpen(Se,ye,dt)),hn=Se.set(l.ExtHostContext.ExtHostSCM,new L.ExtHostSCM(Se,dt,tt)),Sn=Se.set(l.ExtHostContext.ExtHostComments,new _.ExtHostComments(Se,dt,St)),fn=Se.set(l.ExtHostContext.ExtHostProgress,new a.ExtHostProgress(Se.getProxy(l.MainContext.MainThreadProgress))),yn=Se.set(l.ExtHostContext.ExtHosLabelService,new we.ExtHostLabelService(Se)),Yt=Se.set(l.ExtHostContext.ExtHostTheming,new J.ExtHostTheming(Se)),Ft=Se.set(l.ExtHostContext.ExtHostAuthentication,new Le.ExtHostAuthentication(Se)),Dn=Se.set(l.ExtHostContext.ExtHostTimeline,new We.ExtHostTimeline(Se,dt)),on=Se.set(l.ExtHostContext.ExtHostWebviews,new O.ExtHostWebviews(Se,{remote:Ye.remote},ye,tt,pt)),an=Se.set(l.ExtHostContext.ExtHostWebviewPanels,new Fe.ExtHostWebviewPanels(Se,on,ye)),Cn=Se.set(l.ExtHostContext.ExtHostCustomEditors,new ve.ExtHostCustomEditors(Se,St,Ze,on,an)),Jt=Se.set(l.ExtHostContext.ExtHostWebviewViews,new re.ExtHostWebviewViews(Se,on)),jt=Se.set(l.ExtHostContext.ExtHostTesting,new De.ExtHostTesting(Se,dt)),kn=Se.set(l.ExtHostContext.ExtHostUriOpeners,new _e.ExtHostUriOpeners(Se)),ln=Y.values(l.ExtHostContext);Se.assertRegistered(ln);const Pn=new Oe.ExtHostBulkEdits(Se,_t),qt=new c.ExtHostClipboard(Se),Rt=new S.ExtHostMessageService(Se,tt),mn=new d.ExtHostDialogs(Se),It=new U.ExtHostStatusBar(Se,dt.converter),$t=new m.ExtHostLanguages(Se,St);return f.ExtHostApiCommands.register(dt),function(Ne,cn,gn){const ft=function(){let ne=!Ne.isUnderDevelopment;function fe(Ae){ne||(tt.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Ae(at){if(Array.isArray(at))at.forEach(Ae);else if(typeof at=="string")fe(at);else{const bt=at;typeof bt.scheme=="undefined"&&fe(at),!Ne.enableProposedApi&&typeof bt.exclusive=="boolean"&&$.throwProposedApiError(Ne)}return at}}(),In={getSession(ne,fe,Ae){return Ft.getSession(Ne,ne,fe,Ae)},get onDidChangeSessions(){return Ft.onDidChangeSessions},registerAuthenticationProvider(ne,fe,Ae,at){return Ft.registerAuthenticationProvider(ne,fe,Ae,at)},get onDidChangeAuthenticationProviders(){return $.checkProposedApiEnabled(Ne),Ft.onDidChangeAuthenticationProviders},get providers(){return $.checkProposedApiEnabled(Ne),Ft.providers},logout(ne,fe){return $.checkProposedApiEnabled(Ne),Ft.removeSession(ne,fe)}},An={registerCommand(ne,fe,Ae){return dt.registerCommand(!0,ne,fe,Ae)},registerTextEditorCommand(ne,fe,Ae){return dt.registerCommand(!0,ne,(...at)=>{const bt=Dt.getActiveTextEditor();if(!bt){tt.warn("Cannot execute "+ne+" because there is no active text editor.");return}return bt.edit(Ct=>{fe.apply(Ae,[bt,Ct,...at])}).then(Ct=>{Ct||tt.warn("Edits from command "+ne+" were not applied.")},Ct=>{tt.warn("An error occurred while running command "+ne,Ct)})})},registerDiffInformationCommand:(ne,fe,Ae)=>($.checkProposedApiEnabled(Ne),dt.registerCommand(!0,ne,async(...at)=>{const bt=_t.activeEditor(!0);if(!bt){tt.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Ct=await Dt.getDiffInformation(bt.id);fe.apply(Ae,[Ct,...at])})),executeCommand(ne,...fe){return dt.executeCommand(ne,...fe)},getCommands(ne=!1){return dt.getCommands(ne)}},pn={get machineId(){return Ye.telemetryInfo.machineId},get sessionId(){return Ye.telemetryInfo.sessionId},get language(){return Ye.environment.appLanguage},get appName(){return Ye.environment.appName},get appRoot(){var ne,fe;return(fe=(ne=Ye.environment.appRoot)===null||ne===void 0?void 0:ne.fsPath)!==null&&fe!==void 0?fe:""},get uriScheme(){return Ye.environment.appUriScheme},get clipboard(){return qt.value},get shell(){return ct.getDefaultShell(!1)},get isTelemetryEnabled(){return de.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return de.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ne=Date.now()-new Date(Ye.telemetryInfo.firstSessionDate).getTime();return isNaN(ne)?!1:ne<1e3*60*60*24},openExternal(ne,fe){return wt.openUri(ne,{allowTunneling:!!Ye.remote.authority,allowContributedOpeners:fe==null?void 0:fe.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===Ye.environment.appUriScheme)return Kt.createAppUri(ne);const fe=Te.matchesScheme(ne,Ie.Schemas.http)||Te.matchesScheme(ne,Ie.Schemas.https);fe||$.checkProposedApiEnabled(Ne);try{return await wt.asExternalUri(ne,{allowTunneling:!!Ye.remote.authority})}catch(Ae){if(fe)return ne;throw Ae}},get remoteName(){return Re.getRemoteName(Ye.remote.authority)},get uiKind(){return Ye.uiKind}};Ye.environment.extensionTestsLocationURI||Object.freeze(pn);const Zt=Ye.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,Tn={createTestController(ne){return $.checkProposedApiEnabled(Ne),jt.createTestController(ne)},createTestObserver(){return $.checkProposedApiEnabled(Ne),jt.createTestObserver()},runTests(ne){return $.checkProposedApiEnabled(Ne),jt.runTests(ne)},get onDidChangeTestResults(){return $.checkProposedApiEnabled(Ne),jt.onResultsChanged},get testResults(){return $.checkProposedApiEnabled(Ne),jt.results}},Rn={getExtension(ne){const fe=cn.getExtensionDescription(ne);if(fe)return new s.Extension(Ee,Ne.identifier,fe,Zt)},get all(){return cn.getAllExtensionDescriptions().map(ne=>new s.Extension(Ee,Ne.identifier,ne,Zt))},get onDidChange(){return cn.onDidChange}},Ln={createDiagnosticCollection(ne){return Bt.createDiagnosticCollection(Ne.identifier,ne)},get onDidChangeDiagnostics(){return Bt.onDidChangeDiagnostics},getDiagnostics:ne=>Bt.getDiagnostics(ne),getLanguages(){return $t.getLanguages()},setTextDocumentLanguage(ne,fe){return $t.changeLanguage(ne.uri,fe)},match(ne,fe){return r.score(W.LanguageSelector.from(ne),fe.uri,fe.languageId,!0)},registerCodeActionsProvider(ne,fe,Ae){return ut.registerCodeActionProvider(Ne,ft(ne),fe,Ae)},registerCodeLensProvider(ne,fe){return ut.registerCodeLensProvider(Ne,ft(ne),fe)},registerDefinitionProvider(ne,fe){return ut.registerDefinitionProvider(Ne,ft(ne),fe)},registerDeclarationProvider(ne,fe){return ut.registerDeclarationProvider(Ne,ft(ne),fe)},registerImplementationProvider(ne,fe){return ut.registerImplementationProvider(Ne,ft(ne),fe)},registerTypeDefinitionProvider(ne,fe){return ut.registerTypeDefinitionProvider(Ne,ft(ne),fe)},registerHoverProvider(ne,fe){return ut.registerHoverProvider(Ne,ft(ne),fe,Ne.identifier)},registerEvaluatableExpressionProvider(ne,fe){return ut.registerEvaluatableExpressionProvider(Ne,ft(ne),fe,Ne.identifier)},registerInlineValuesProvider(ne,fe){return ut.registerInlineValuesProvider(Ne,ft(ne),fe,Ne.identifier)},registerDocumentHighlightProvider(ne,fe){return ut.registerDocumentHighlightProvider(Ne,ft(ne),fe)},registerLinkedEditingRangeProvider(ne,fe){return ut.registerLinkedEditingRangeProvider(Ne,ft(ne),fe)},registerReferenceProvider(ne,fe){return ut.registerReferenceProvider(Ne,ft(ne),fe)},registerRenameProvider(ne,fe){return ut.registerRenameProvider(Ne,ft(ne),fe)},registerDocumentSymbolProvider(ne,fe,Ae){return ut.registerDocumentSymbolProvider(Ne,ft(ne),fe,Ae)},registerWorkspaceSymbolProvider(ne){return ut.registerWorkspaceSymbolProvider(Ne,ne)},registerDocumentFormattingEditProvider(ne,fe){return ut.registerDocumentFormattingEditProvider(Ne,ft(ne),fe)},registerDocumentRangeFormattingEditProvider(ne,fe){return ut.registerDocumentRangeFormattingEditProvider(Ne,ft(ne),fe)},registerOnTypeFormattingEditProvider(ne,fe,Ae,...at){return ut.registerOnTypeFormattingEditProvider(Ne,ft(ne),fe,[Ae].concat(at))},registerDocumentSemanticTokensProvider(ne,fe,Ae){return ut.registerDocumentSemanticTokensProvider(Ne,ft(ne),fe,Ae)},registerDocumentRangeSemanticTokensProvider(ne,fe,Ae){return ut.registerDocumentRangeSemanticTokensProvider(Ne,ft(ne),fe,Ae)},registerSignatureHelpProvider(ne,fe,Ae,...at){return typeof Ae=="object"?ut.registerSignatureHelpProvider(Ne,ft(ne),fe,Ae):ut.registerSignatureHelpProvider(Ne,ft(ne),fe,typeof Ae=="undefined"?[]:[Ae,...at])},registerCompletionItemProvider(ne,fe,...Ae){return ut.registerCompletionItemProvider(Ne,ft(ne),fe,Ae)},registerInlineCompletionItemProvider(ne,fe){return $.checkProposedApiEnabled(Ne),ut.registerInlineCompletionsProvider(Ne,ft(ne),fe)},registerDocumentLinkProvider(ne,fe){return ut.registerDocumentLinkProvider(Ne,ft(ne),fe)},registerColorProvider(ne,fe){return ut.registerColorProvider(Ne,ft(ne),fe)},registerFoldingRangeProvider(ne,fe){return ut.registerFoldingRangeProvider(Ne,ft(ne),fe)},registerSelectionRangeProvider(ne,fe){return ut.registerSelectionRangeProvider(Ne,ne,fe)},registerCallHierarchyProvider(ne,fe){return ut.registerCallHierarchyProvider(Ne,ne,fe)},setLanguageConfiguration:(ne,fe)=>ut.setLanguageConfiguration(Ne,ne,fe),getTokenInformationAtPosition(ne,fe){return $.checkProposedApiEnabled(Ne),$t.tokenAtPosition(ne,fe)},registerInlayHintsProvider(ne,fe){return $.checkProposedApiEnabled(Ne),ut.registerInlayHintsProvider(Ne,ne,fe)}},Fn={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return ct.activeTerminal},get terminals(){return ct.terminals},async showTextDocument(ne,fe,Ae){const at=await(A.URI.isUri(ne)?Promise.resolve(vn.openTextDocument(ne)):Promise.resolve(ne));return Dt.showTextDocument(at,fe,Ae)},createTextEditorDecorationType(ne){return Dt.createTextEditorDecorationType(Ne,ne)},onDidChangeActiveTextEditor(ne,fe,Ae){return Dt.onDidChangeActiveTextEditor(ne,fe,Ae)},onDidChangeVisibleTextEditors(ne,fe,Ae){return Dt.onDidChangeVisibleTextEditors(ne,fe,Ae)},onDidChangeTextEditorSelection(ne,fe,Ae){return Dt.onDidChangeTextEditorSelection(ne,fe,Ae)},onDidChangeTextEditorOptions(ne,fe,Ae){return Dt.onDidChangeTextEditorOptions(ne,fe,Ae)},onDidChangeTextEditorVisibleRanges(ne,fe,Ae){return Dt.onDidChangeTextEditorVisibleRanges(ne,fe,Ae)},onDidChangeTextEditorViewColumn(ne,fe,Ae){return Dt.onDidChangeTextEditorViewColumn(ne,fe,Ae)},onDidCloseTerminal(ne,fe,Ae){return ct.onDidCloseTerminal(ne,fe,Ae)},onDidOpenTerminal(ne,fe,Ae){return ct.onDidOpenTerminal(ne,fe,Ae)},onDidChangeActiveTerminal(ne,fe,Ae){return ct.onDidChangeActiveTerminal(ne,fe,Ae)},onDidChangeTerminalDimensions(ne,fe,Ae){return $.checkProposedApiEnabled(Ne),ct.onDidChangeTerminalDimensions(ne,fe,Ae)},onDidWriteTerminalData(ne,fe,Ae){return $.checkProposedApiEnabled(Ne),ct.onDidWriteTerminalData(ne,fe,Ae)},get state(){return wt.state},onDidChangeWindowState(ne,fe,Ae){return wt.onDidChangeWindowState(ne,fe,Ae)},showInformationMessage(ne,...fe){return Rt.showMessage(Ne,y.default.Info,ne,fe[0],fe.slice(1))},showWarningMessage(ne,...fe){return Rt.showMessage(Ne,y.default.Warning,ne,fe[0],fe.slice(1))},showErrorMessage(ne,...fe){return Rt.showMessage(Ne,y.default.Error,ne,fe[0],fe.slice(1))},showQuickPick(ne,fe,Ae){return Vt.showQuickPick(ne,!!Ne.enableProposedApi,fe,Ae)},showWorkspaceFolderPick(ne){return Vt.showWorkspaceFolderPick(ne)},showInputBox(ne,fe){return Vt.showInput(ne,fe)},showOpenDialog(ne){return mn.showOpenDialog(ne)},showSaveDialog(ne){return mn.showSaveDialog(ne)},createStatusBarItem(ne,fe,Ae){let at,bt,Ct;return typeof ne=="string"?(at=ne,bt=fe,Ct=Ae):(bt=ne,Ct=fe),It.createStatusBarEntry(Ne,at,bt,Ct)},setStatusBarMessage(ne,fe){return It.setStatusBarMessage(ne,fe)},withScmProgress(ne){return pt.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),fn.withProgress(Ne,{location:M.ProgressLocation.SourceControl},(fe,Ae)=>ne({report(at){}}))},withProgress(ne,fe){return fn.withProgress(Ne,ne,fe)},createOutputChannel(ne){return At.createOutputChannel(ne)},createWebviewPanel(ne,fe,Ae,at){return an.createWebviewPanel(Ne,ne,fe,Ae,at)},createWebviewTextEditorInset(ne,fe,Ae,at){return $.checkProposedApiEnabled(Ne),rn.createWebviewEditorInset(ne,fe,Ae,at,Ne)},createTerminal(ne,fe,Ae){return typeof ne=="object"?"pty"in ne?ct.createExtensionTerminal(ne):ct.createTerminalFromOptions(ne):ct.createTerminal(ne,fe,Ae)},registerTerminalLinkProvider(ne){return ct.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,fe){return ct.registerProfileProvider(Ne,ne,fe)},registerTreeDataProvider(ne,fe){return Xt.registerTreeDataProvider(ne,fe,Ne)},createTreeView(ne,fe){return Xt.createTreeView(ne,fe,Ne)},registerWebviewPanelSerializer:(ne,fe)=>an.registerWebviewPanelSerializer(Ne,ne,fe),registerCustomEditorProvider:(ne,fe,Ae={})=>Cn.registerCustomEditorProvider(Ne,ne,fe,Ae),registerFileDecorationProvider(ne){return xt.registerFileDecorationProvider(ne,Ne.identifier)},registerUriHandler(ne){return Kt.registerUriHandler(Ne.identifier,ne)},createQuickPick(){return Vt.createQuickPick(Ne.identifier,!!Ne.enableProposedApi)},createInputBox(){return Vt.createInputBox(Ne.identifier)},get activeColorTheme(){return Yt.activeColorTheme},onDidChangeActiveColorTheme(ne,fe,Ae){return Yt.onDidChangeActiveColorTheme(ne,fe,Ae)},registerWebviewViewProvider(ne,fe,Ae){return Jt.registerWebviewViewProvider(Ne,ne,fe,Ae==null?void 0:Ae.webviewOptions)},get activeNotebookEditor(){return $.checkProposedApiEnabled(Ne),mt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,fe,Ae){return $.checkProposedApiEnabled(Ne),mt.onDidChangeActiveNotebookEditor(ne,fe,Ae)},get visibleNotebookEditors(){return $.checkProposedApiEnabled(Ne),mt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return $.checkProposedApiEnabled(Ne),mt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,fe,Ae){return $.checkProposedApiEnabled(Ne),zt.onDidChangeNotebookEditorSelection(ne,fe,Ae)},onDidChangeNotebookEditorVisibleRanges(ne,fe,Ae){return $.checkProposedApiEnabled(Ne),zt.onDidChangeNotebookEditorVisibleRanges(ne,fe,Ae)},showNotebookDocument(ne,fe){return $.checkProposedApiEnabled(Ne),mt.showNotebookDocument(ne,fe)},registerExternalUriOpener(ne,fe,Ae){return $.checkProposedApiEnabled(Ne),kn.registerExternalUriOpener(Ne.identifier,ne,fe,Ae)},get openEditors(){return $.checkProposedApiEnabled(Ne),vt.tabs},get onDidChangeOpenEditors(){return $.checkProposedApiEnabled(Ne),vt.onDidChangeTabs},getInlineCompletionItemController(ne){return $.checkProposedApiEnabled(Ne),v.InlineCompletionController.get(ne)}},vn={get rootPath(){return pt.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ye.getPath()},set rootPath(ne){throw R.readonly()},getWorkspaceFolder(ne){return ye.getWorkspaceFolder(ne)},get workspaceFolders(){return ye.getWorkspaceFolders()},get name(){return ye.name},set name(ne){throw R.readonly()},get workspaceFile(){return ye.workspaceFile},set workspaceFile(ne){throw R.readonly()},updateWorkspaceFolders:(ne,fe,...Ae)=>ye.updateWorkspaceFolders(Ne,ne,fe||0,...Ae),onDidChangeWorkspaceFolders:function(ne,fe,Ae){return ye.onDidChangeWorkspace(ne,fe,Ae)},asRelativePath:(ne,fe)=>ye.getRelativePath(ne,fe),findFiles:(ne,fe,Ae,at)=>ye.findFiles(W.GlobPattern.from(ne),W.GlobPattern.from(fe),Ae,Ne.identifier,at),findTextInFiles:(ne,fe,Ae,at)=>{let bt,Ct;return typeof fe=="object"?(bt=fe,Ct=Ae):(bt={},Ct=fe,at=Ae),ye.findTextInFiles(ne,bt||{},Ct,Ne.identifier,at)},saveAll:ne=>ye.saveAll(ne),applyEdit(ne){return Pn.applyWorkspaceEdit(ne)},createFileSystemWatcher:(ne,fe,Ae,at)=>Tt.createFileSystemWatcher(W.GlobPattern.from(ne),fe,Ae,at),get textDocuments(){return St.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw R.readonly()},openTextDocument(ne){let fe;const Ae=ne;if(typeof ne=="string")fe=Promise.resolve(A.URI.file(ne));else if(A.URI.isUri(ne))fe=Promise.resolve(ne);else if(!Ae||typeof Ae=="object")fe=St.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(at=>St.ensureDocumentData(at).then(bt=>bt.document))},onDidOpenTextDocument:(ne,fe,Ae)=>St.onDidAddDocument(ne,fe,Ae),onDidCloseTextDocument:(ne,fe,Ae)=>St.onDidRemoveDocument(ne,fe,Ae),onDidChangeTextDocument:(ne,fe,Ae)=>St.onDidChangeDocument(ne,fe,Ae),onDidSaveTextDocument:(ne,fe,Ae)=>St.onDidSaveDocument(ne,fe,Ae),onWillSaveTextDocument:(ne,fe,Ae)=>tn.getOnWillSaveTextDocumentEvent(Ne)(ne,fe,Ae),get notebookDocuments(){return mt.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,fe){let Ae;if(A.URI.isUri(ne))Ae=ne,await mt.openNotebookDocument(ne);else if(typeof ne=="string")Ae=A.URI.revive(await mt.createNotebookDocument({viewType:ne,content:fe}));else throw new Error("Invalid arguments");return mt.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return mt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return mt.onDidCloseNotebookDocument},registerNotebookSerializer(ne,fe,Ae,at){return mt.registerNotebookSerializer(Ne,ne,fe,Ae,Ne.enableProposedApi?at:void 0)},registerNotebookContentProvider:(ne,fe,Ae,at)=>($.checkProposedApiEnabled(Ne),mt.registerNotebookContentProvider(Ne,ne,fe,Ae,Ne.enableProposedApi?at:void 0)),onDidChangeConfiguration:(ne,fe,Ae)=>gn.onDidChangeConfiguration(ne,fe,Ae),getConfiguration(ne,fe){return fe=arguments.length===1?void 0:fe,gn.getConfiguration(ne,fe,Ne)},registerTextDocumentContentProvider(ne,fe){return en.registerTextDocumentContentProvider(ne,fe)},registerTaskProvider:(ne,fe)=>(pt.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),kt.registerTaskProvider(Ne,ne,fe)),registerFileSystemProvider(ne,fe,Ae){return sn.registerFileSystemProvider(Ne.identifier,ne,fe,Ae,Ne.enableProposedApi)},get fs(){return gt.value},registerFileSearchProvider:(ne,fe)=>($.checkProposedApiEnabled(Ne),Ht.registerFileSearchProvider(ne,fe)),registerTextSearchProvider:(ne,fe)=>($.checkProposedApiEnabled(Ne),Ht.registerTextSearchProvider(ne,fe)),registerRemoteAuthorityResolver:(ne,fe)=>($.checkProposedApiEnabled(Ne),Ee.registerRemoteAuthorityResolver(ne,fe)),registerResourceLabelFormatter:ne=>($.checkProposedApiEnabled(Ne),yn.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,fe,Ae)=>Tt.onDidCreateFile(ne,fe,Ae),onDidDeleteFiles:(ne,fe,Ae)=>Tt.onDidDeleteFile(ne,fe,Ae),onDidRenameFiles:(ne,fe,Ae)=>Tt.onDidRenameFile(ne,fe,Ae),onWillCreateFiles:(ne,fe,Ae)=>Tt.getOnWillCreateFileEvent(Ne)(ne,fe,Ae),onWillDeleteFiles:(ne,fe,Ae)=>Tt.getOnWillDeleteFileEvent(Ne)(ne,fe,Ae),onWillRenameFiles:(ne,fe,Ae)=>Tt.getOnWillRenameFileEvent(Ne)(ne,fe,Ae),openTunnel:ne=>($.checkProposedApiEnabled(Ne),st.openTunnel(Ne,ne).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return $.checkProposedApiEnabled(Ne),st.getTunnels()},onDidChangeTunnels:(ne,fe,Ae)=>($.checkProposedApiEnabled(Ne),st.onDidChangeTunnels(ne,fe,Ae)),registerPortAttributesProvider:(ne,fe)=>($.checkProposedApiEnabled(Ne),st.registerPortsAttributesProvider(ne,fe)),registerTimelineProvider:(ne,fe)=>($.checkProposedApiEnabled(Ne),Dn.registerTimelineProvider(ne,fe,Ne.identifier,dt.converter)),get isTrusted(){return ye.trusted},requestWorkspaceTrust:ne=>($.checkProposedApiEnabled(Ne),ye.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,fe,Ae)=>ye.onDidGrantWorkspaceTrust(ne,fe,Ae)},Mn={get inputBox(){return pt.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),hn.getLastInputBox(Ne)},createSourceControl(ne,fe,Ae){return hn.createSourceControl(Ne,ne,fe,Ae)}},wn={createCommentController(ne,fe){return Sn.createCommentController(Ne,ne,fe)}},bn={get activeDebugSession(){return ht.activeDebugSession},get activeDebugConsole(){return ht.activeDebugConsole},get breakpoints(){return ht.breakpoints},onDidStartDebugSession(ne,fe,Ae){return ht.onDidStartDebugSession(ne,fe,Ae)},onDidTerminateDebugSession(ne,fe,Ae){return ht.onDidTerminateDebugSession(ne,fe,Ae)},onDidChangeActiveDebugSession(ne,fe,Ae){return ht.onDidChangeActiveDebugSession(ne,fe,Ae)},onDidReceiveDebugSessionCustomEvent(ne,fe,Ae){return ht.onDidReceiveDebugSessionCustomEvent(ne,fe,Ae)},onDidChangeBreakpoints(ne,fe,Ae){return ht.onDidChangeBreakpoints(ne,fe,Ae)},registerDebugConfigurationProvider(ne,fe,Ae){return ht.registerDebugConfigurationProvider(ne,fe,Ae||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,fe){return ht.registerDebugAdapterDescriptorFactory(Ne,ne,fe)},registerDebugAdapterTrackerFactory(ne,fe){return ht.registerDebugAdapterTrackerFactory(ne,fe)},startDebugging(ne,fe,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?ht.startDebugging(ne,fe,{parentSession:Ae}):ht.startDebugging(ne,fe,Ae||{})},stopDebugging(ne){return ht.stopDebugging(ne)},addBreakpoints(ne){return ht.addBreakpoints(ne)},removeBreakpoints(ne){return ht.removeBreakpoints(ne)},asDebugSourceUri(ne,fe){return ht.asDebugSourceUri(ne,fe)}},Ot={registerTaskProvider:(ne,fe)=>kt.registerTaskProvider(Ne,ne,fe),fetchTasks:ne=>kt.fetchTasks(ne),executeTask:ne=>kt.executeTask(Ne,ne),get taskExecutions(){return kt.taskExecutions},onDidStartTask:(ne,fe,Ae)=>kt.onDidStartTask(ne,fe,Ae),onDidEndTask:(ne,fe,Ae)=>kt.onDidEndTask(ne,fe,Ae),onDidStartTaskProcess:(ne,fe,Ae)=>kt.onDidStartTaskProcess(ne,fe,Ae),onDidEndTaskProcess:(ne,fe,Ae)=>kt.onDidEndTaskProcess(ne,fe,Ae)},Wt={createNotebookController(ne,fe,Ae,at,bt){return nn.createNotebookController(Ne,ne,fe,Ae,at,Ne.enableProposedApi?bt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,fe)=>mt.registerNotebookCellStatusBarItemProvider(Ne,ne,fe),get onDidSaveNotebookDocument(){return $.checkProposedApiEnabled(Ne),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ne){return $.checkProposedApiEnabled(Ne),zt.createNotebookEditorDecorationType(ne)},createRendererMessaging(ne){return $.checkProposedApiEnabled(Ne),_n.createRendererMessaging(ne)},onDidChangeNotebookDocumentMetadata(ne,fe,Ae){return $.checkProposedApiEnabled(Ne),Qt.onDidChangeNotebookDocumentMetadata(ne,fe,Ae)},onDidChangeNotebookCells(ne,fe,Ae){return $.checkProposedApiEnabled(Ne),mt.onDidChangeNotebookCells(ne,fe,Ae)},onDidChangeNotebookCellExecutionState(ne,fe,Ae){return $.checkProposedApiEnabled(Ne),mt.onDidChangeNotebookCellExecutionState(ne,fe,Ae)},onDidChangeCellOutputs(ne,fe,Ae){return $.checkProposedApiEnabled(Ne),mt.onDidChangeCellOutputs(ne,fe,Ae)},onDidChangeCellMetadata(ne,fe,Ae){return $.checkProposedApiEnabled(Ne),mt.onDidChangeCellMetadata(ne,fe,Ae)},createConcatTextDocument(ne,fe){return $.checkProposedApiEnabled(Ne),new be.ExtHostNotebookConcatDocument(mt,St,ne,fe)}};return{version:Ye.version,authentication:In,commands:An,comments:wn,debug:bn,env:pn,extensions:Rn,languages:Ln,notebooks:Wt,scm:Mn,tasks:Ot,test:Tn,window:Fn,workspace:vn,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:p.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:M.InlineCompletionTriggerKind,EventEmitter:C.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,InlineCompletionItem:M.InlineSuggestion,InlineCompletionList:M.InlineSuggestions,Hover:M.Hover,IndentAction:k.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TerminalLink:M.TerminalLink,TerminalProfile:M.TerminalProfile,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,UIKind:l.UIKind,Uri:A.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlayHint:M.InlayHint,InlayHintKind:M.InlayHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookRange:M.NotebookRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookRendererScript:M.NotebookRendererScript,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,NotebookCellStatusBarItem:M.NotebookCellStatusBarItem,NotebookControllerAffinity:M.NotebookControllerAffinity,PortAttributes:M.PortAttributes,LinkedEditingRanges:M.LinkedEditingRanges,TestItemStatus:M.TestItemStatus,TestResultState:M.TestResultState,TestRunRequest:M.TestRunRequest,TestMessage:M.TestMessage,TextSearchCompleteMessageType:ee.TextSearchCompleteMessageType,TestMessageSeverity:M.TestMessageSeverity,WorkspaceTrustState:M.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=et}),define(ge[262],pe([0,1,77,62,35,126,36,48,42,33,65,49,67,88,87,47,61,127,86,59,85,117,46]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h,_,w,b,d,u,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),p.registerSingleton(f.IExtensionStoragePaths,f.ExtensionStoragePaths),p.registerSingleton(_.IExtHostApiDeprecationService,_.ExtHostApiDeprecationService),p.registerSingleton(I.IExtHostCommands,I.ExtHostCommands),p.registerSingleton(A.IExtHostConfiguration,A.ExtHostConfiguration),p.registerSingleton(b.IExtHostConsumerFileSystem,b.ExtHostConsumerFileSystem),p.registerSingleton(P.IExtHostDebugService,P.WorkerExtHostDebugService),p.registerSingleton(y.IExtHostDecorations,y.ExtHostDecorations),p.registerSingleton(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors),p.registerSingleton(d.IExtHostFileSystemInfo,d.ExtHostFileSystemInfo),p.registerSingleton(R.IExtHostOutputService,R.ExtHostOutputService),p.registerSingleton(l.IExtHostSearch,l.ExtHostSearch),p.registerSingleton(c.IExtHostStorage,c.ExtHostStorage),p.registerSingleton(r.IExtHostTask,r.WorkerExtHostTask),p.registerSingleton(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),p.registerSingleton(h.IExtHostTunnelService,h.ExtHostTunnelService),p.registerSingleton(w.IExtHostWindow,w.ExtHostWindow),p.registerSingleton(C.IExtHostWorkspace,C.ExtHostWorkspace),p.registerSingleton(u.IExtHostSecretState,u.ExtHostSecretState),p.registerSingleton(g.IExtHostTelemetry,g.ExtHostTelemetry),p.registerSingleton(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(ge[89],pe([0,1,18,12,31,64]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function A(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=A;function I(P,l,f,c){const h=p.mapArrayOrNot(f,E),_=new C.TextSearchMatch(l,h,c),w=_.preview.matches;return{ranges:p.mapArrayOrNot(h,k),uri:P,preview:{text:_.preview.text,matches:p.mapArrayOrNot(w,k)}}}e.createTextSearchResult=I;function E(P){return new C.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function k(P){return new y.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let r=class{constructor(l,f){this.prefix=l,this.logService=f}appendLine(l){this.logService.debug(`${this.prefix}#search`,l)}};r=Ve([$e(1,R.ILogService)],r),e.OutputChannel=r}),define(ge[263],pe([0,1,91,22]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function C(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===t)}e.isUTFEncoding=C,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const y=512,A=512,I=512*8,E=512*128;class k{constructor(i){this.iconvLiteDecoder=i}static async create(i){let s;if(i!==e.UTF8)s=(await new Promise((o,v)=>{X(["iconv-lite-umd"],o,v)})).getDecoder(f(i));else{const n=new TextDecoder;s={write(o){return n.decode(o,{stream:!0})},end(){return n.decode()}}}return new k(s)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function r(t,i){var s;const n=((s=i.minBytesRequiredForDetection)!==null&&s!==void 0?s:i.guessEncoding)?I:A;return new Promise((o,v)=>{const m=p.newWriteableStream(L=>L.join("")),S=[];let D=0,a;const T=async()=>{try{const L=await g({buffer:R.VSBuffer.concat(S),bytesRead:D},i.guessEncoding);L.encoding=await i.overwriteEncoding(L.encoding),a=await k.create(L.encoding);const U=a.write(R.VSBuffer.concat(S).buffer);m.write(U),S.length=0,D=0,o({stream:m,detected:L})}catch(L){v(L)}};p.listenStream(t,{onData:async L=>{a?m.write(a.write(L.buffer)):(S.push(L),D+=L.byteLength,D>=n&&(t.pause(),await T(),setTimeout(()=>t.resume())))},onError:L=>m.error(L),onEnd:async()=>{a||await T(),m.end(a==null?void 0:a.end())}})})}e.toDecodeStream=r;async function P(t,i,s){const o=(await new Promise((S,D)=>{X(["iconv-lite-umd"],S,D)})).getEncoder(f(i),s);let v=!1,m=!1;return{read(){if(m)return null;const S=t.read();if(typeof S!="string"){if(m=!0,!v&&(s==null?void 0:s.addBOM))switch(i){case e.UTF8:case e.UTF8_with_bom:return R.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const D=o.end();return D&&D.length>0?(v=!0,R.VSBuffer.wrap(D)):null}return v=!0,R.VSBuffer.wrap(o.write(S))}}}e.toEncodeReadable=P;async function l(t){return(await new Promise((s,n)=>{X(["iconv-lite-umd"],s,n)})).encodingExists(f(t))}e.encodingExists=l;function f(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=f;function c(t,i){if(!t||i<e.UTF16be_BOM.length)return null;const s=t.readUInt8(0),n=t.readUInt8(1);if(s===e.UTF16be_BOM[0]&&n===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&n===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const o=t.readUInt8(2);return s===e.UTF8_BOM[0]&&n===e.UTF8_BOM[1]&&o===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=c;const h=["ascii","utf-16","utf-32"];async function _(t){const i=await new Promise((m,S)=>{X(["jschardet"],m,S)}),s=t.slice(0,E),n=d(s.buffer),o=i.detect(n);if(!o||!o.encoding)return null;const v=o.encoding.toLowerCase();return 0<=h.indexOf(v)?null:b(o.encoding)}const w={ibm866:"cp866",big5:"cp950"};function b(t){const i=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return w[i]||i}function d(t){let i="";for(let s=0;s<t.length;s++)i+=String.fromCharCode(t[s]);return i}function u(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const i=t.match(/windows(\d+)/);return i?"windows-"+i[1]:t}}e.toCanonicalName=u;function g({buffer:t,bytesRead:i},s){let n=c(t,i),o=!1;if(n!==e.UTF16be&&n!==e.UTF16le&&t){let v=!0,m=!0,S=!1;for(let D=0;D<i&&D<y;D++){const a=D%2==1,T=t.readUInt8(D)===0;if(T&&(S=!0),v&&(a&&!T||!a&&T)&&(v=!1),m&&(a&&T||!a&&!T)&&(m=!1),T&&!v&&!m)break}S&&(v?n=e.UTF16le:m?n=e.UTF16be:o=!0)}return s&&!o&&!n&&t?_(t.slice(0,i)).then(v=>({seemsBinary:!1,encoding:v})):{seemsBinary:o,encoding:n}}e.detectEncodingFromBuffer=g,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ge[129],pe([0,1,263,28,128]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class y extends C.TextSearchManager{constructor(I,E,k=R){super(I,E,{readdir:r=>k.Promises.readdir(r.fsPath),toCanonicalName:r=>p.toCanonicalName(r)})}}e.NativeTextSearchManager=y}),define(ge[264],pe([0,1,265,279,280,2,281]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function I(P,l,f,c,h,_){const w=_.environment.useHostProxy,b=typeof w=="boolean"?w:!_.remote.isRemote,d=A.createProxyResolver({resolveProxy:g=>P.resolveProxy(g),getHttpProxySetting:()=>l.getConfiguration("http").get("proxy"),log:(g,t,...i)=>{switch(g){case A.LogLevel.Trace:c.trace(t,...i);break;case A.LogLevel.Debug:c.debug(t,...i);break;case A.LogLevel.Info:c.info(t,...i);break;case A.LogLevel.Warning:c.warn(t,...i);break;case A.LogLevel.Error:c.error(t,...i);break;case A.LogLevel.Critical:c.critical(t,...i);break;case A.LogLevel.Off:break;default:s(g,t,i);break}function s(n,o,...v){c.error("Unknown log level",n),c.error(o,...v)}},getLogLevel:()=>c.getLevel(),proxyResolveTelemetry:g=>{h.$publicLog2("resolveProxy",g)},useHostProxy:b,env:process.env}),u=E(l,d);return r(f,u)}e.connectProxyResolver=I;function E(P,l){const f={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(h=>{f.config=P.getConfiguration("http").get("proxySupport")||"off"});const c={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(h=>{c.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},p,A.createHttpPatch(p,l,{config:"off"},c,!0)),on:Object.assign({},p,A.createHttpPatch(p,l,{config:"on"},c,!0)),override:Object.assign({},p,A.createHttpPatch(p,l,{config:"override"},c,!0)),onRequest:Object.assign({},p,A.createHttpPatch(p,l,f,c,!0)),default:Object.assign(p,A.createHttpPatch(p,l,f,c,!1))},https:{off:Object.assign({},R,A.createHttpPatch(R,l,{config:"off"},c,!0)),on:Object.assign({},R,A.createHttpPatch(R,l,{config:"on"},c,!0)),override:Object.assign({},R,A.createHttpPatch(R,l,{config:"override"},c,!0)),onRequest:Object.assign({},R,A.createHttpPatch(R,l,f,c,!0)),default:Object.assign(R,A.createHttpPatch(R,l,f,c,!1))},tls:Object.assign(C,A.createTlsPatch(C))}}const k=new Map;function r(P,l){return P.getExtensionPathIndex().then(f=>{const c=X.__$__nodeRequire("module"),h=c._load;c._load=function(w,b,d){if(w==="tls")return l.tls;if(w!=="http"&&w!=="https")return h.apply(this,arguments);const u=l[w],g=f.findSubstr(y.URI.file(b.filename).fsPath);let t=k.get(g);if(t||k.set(g,t={}),!t[w]){let i=u.default;g&&g.enableProposedApi&&(i=u[g.proxySupport]||u.onRequest),t[w]=Object.assign({},i)}return t[w]}})}}),define(ge[266],pe([0,1,38,9,74,29,11,8,89,267]),function(X,e,p,R,C,y,A,I,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const r=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(d,u,g,t){const i=l(d,u,g,t),s=u.folder.fsPath;return{cmd:p.spawn(r,i.args,{cwd:s}),rgDiskPath:r,siblingClauses:i.siblingClauses,rgArgs:i,cwd:s}}e.spawnRipgrepCmd=P;function l(d,u,g,t){const i=["--files","--hidden","--case-sensitive"];c([u],g,!1).forEach(n=>{const o=E.anchorGlob(n);if(i.push("-g",o),A.isMacintosh){const v=C.normalizeNFD(o);v!==o&&i.push("-g",v)}});const s=f([u],t,void 0,!1);return s.globArgs.forEach(n=>{const o=`!${E.anchorGlob(n)}`;if(i.push("-g",o),A.isMacintosh){const v=C.normalizeNFD(o);v!==o&&i.push("-g",v)}}),u.disregardIgnoreFiles!==!1?i.push("--no-ignore"):i.push("--no-ignore-parent"),u.ignoreSymlinks||i.push("--follow"),d.exists&&i.push("--quiet"),i.push("--no-config"),u.disregardGlobalIgnoreFiles&&i.push("--no-ignore-global"),{args:i,siblingClauses:s.siblingClauses}}function f(d,u,g,t=!0){const i=[];let s={};return d.forEach(n=>{const o=Object.assign({},n.excludePattern||{},u||{}),v=h(o,t?n.folder.fsPath:void 0,g);i.push(...v.globArgs),v.siblingClauses&&(s=Object.assign(s,v.siblingClauses))}),{globArgs:i,siblingClauses:s}}e.foldersToRgExcludeGlobs=f;function c(d,u,g=!0){const t=[];return d.forEach(i=>{const s=Object.assign({},u||{},i.includePattern||{}),n=h(s,g?i.folder.fsPath:void 0);t.push(...n.globArgs)}),t}e.foldersToIncludeGlobs=c;function h(d,u,g){const t=[],i={};return Object.keys(d).forEach(s=>{if(g&&g.has(s)||!s)return;const n=d[s];s=w(u?_(u,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof n=="boolean"&&n?(s.startsWith("\\\\")&&(s+="**"),t.push(b(s))):n&&n.when&&(i[s]=n)}),{globArgs:t,siblingClauses:i}}function _(d,u){return R.isAbsolute(u)?u:R.join(d,u)}e.getAbsoluteGlob=_;function w(d){return d=I.rtrim(d,"\\"),I.rtrim(d,"/")}function b(d){return y.getRoot(d).toLowerCase()==="c:/"?d.replace(/^c:[/\\]/i,"/"):d}e.fixDriveC=b}),define(ge[268],pe([0,1,38,56,9,99,18,57,30,74,29,11,43,8,15,28,31,266,96]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h,_,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const d=new Set;process.on("exit",()=>{d.forEach(s=>s())});class u{constructor(n){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=n,this.filePattern=n.filePattern||"",this.includePattern=n.includePattern&&E.parse(n.includePattern),this.maxResults=n.maxResults||null,this.exists=!!n.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=b.prepareQuery(this.filePattern).normalizedLowercase),this.globalExcludePattern=n.excludePattern&&E.parse(n.excludePattern),this.folderExcludePatterns=new Map,n.folderQueries.forEach(o=>{const v=Object.assign({},o.excludePattern||{},this.config.excludePattern||{}),m=o.folder.fsPath;n.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==m).forEach(S=>{r.isEqualOrParent(S,m)&&(v[C.relative(m,S)]=!0)}),this.folderExcludePatterns.set(m,new t(v,m))})}cancel(){this.isCanceled=!0}walk(n,o,v,m,S){if(this.fileWalkSW=l.StopWatch.create(!1),this.isCanceled)return S(null,this.isLimitHit);o.forEach(D=>{const a=C.basename(D.fsPath);this.globalExcludePattern&&this.globalExcludePattern(D.fsPath,a)||this.matchFile(v,{relativePath:D.fsPath,searchPath:void 0})}),this.cmdSW=l.StopWatch.create(!1),this.parallel(n,(D,a)=>{this.call(this.cmdTraversal,this,D,v,m,T=>{if(T){const L=I.toErrorMessage(T);console.error(L),this.errors.push(L),a(T,void 0)}else a(null,void 0)})},(D,a)=>{this.fileWalkSW.stop();const T=D?A.coalesce(D)[0]:null;S(T,this.isLimitHit)})}parallel(n,o,v){const m=new Array(n.length),S=new Array(n.length);let D=!1,a=0;if(n.length===0)return v(null,[]);n.forEach((T,L)=>{o(T,(U,G)=>{if(U?(D=!0,m[L]=null,S[L]=U):(m[L]=G,S[L]=null),++a===n.length)return v(D?S:null,m)})})}call(n,o,...v){try{n.apply(o,v)}catch(m){v[v.length-1](m)}}cmdTraversal(n,o,v,m){const S=n.folder.fsPath,D=P.isMacintosh;let a;const T=()=>a&&a.kill();d.add(T);let L=M=>{d.delete(T),L=()=>{},m(M)},U="";const G=this.initDirectoryTree();let te;const V=w.spawnRipgrepCmd(this.config,n,this.config.includePattern,this.folderExcludePatterns.get(n.folder.fsPath).expression);a=V.cmd,te=!Object.keys(V.siblingClauses).length;const N=V.rgArgs.args.map(M=>M.match(/^-/)?M:`'${M}'`).join(" ");let W=`${V.rgDiskPath} ${N}
 - cwd: ${V.cwd}`;V.rgArgs.siblingClauses&&(W+=`
 - Sibling clauses: ${JSON.stringify(V.rgArgs.siblingClauses)}`),v({message:W}),this.cmdResultCount=0,this.collectStdout(a,"utf8",v,(M,q,O)=>{if(M){L(M);return}if(this.isLimitHit){L();return}const B=(U+(D?k.normalizeNFC(q||""):q)).split(`
`);if(O){const $=B.length;B[$-1]=B[$-1].trim(),B[$-1]||B.pop()}else U=B.pop()||"";if(B.length&&B[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=B.length,te){for(const $ of B)if(this.matchFile(o,{base:S,relativePath:$,searchPath:this.getSearchPath(n,$)}),this.isLimitHit){T();break}(O||this.isLimitHit)&&L();return}this.addDirectoryEntries(n,G,S,B,o),O&&(this.matchDirectoryTree(G,S,o),L())})}spawnFindCmd(n){const o=this.folderExcludePatterns.get(n.folder.fsPath),v=o.getBasenameTerms(),m=o.getPathTerms(),S=["-L","."];if(v.length||m.length){S.push("-not","(","(");for(const D of v)S.push("-name",D),S.push("-o");for(const D of m)S.push("-path",D),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),p.spawn("find",S,{cwd:n.folder.fsPath})}readStdout(n,o,v){let m="";this.collectStdout(n,o,()=>{},(S,D,a)=>{if(S){v(S);return}m+=D,a&&v(null,m)})}collectStdout(n,o,v,m){let S=(T,L,U)=>{(T||U)&&(S=()=>{},this.cmdSW&&this.cmdSW.stop()),m(T,L,U)},D=!1;n.stdout?(this.forwardData(n.stdout,o,S),n.stdout.once("data",()=>D=!0)):v({message:"stdout is null"});let a;n.stderr?a=this.collectData(n.stderr):v({message:"stderr is null"}),n.on("error",T=>{S(T)}),n.on("close",T=>{let L;!D&&(L=this.decodeData(a,o))&&i(L)?S(new Error(`command failed with error code ${T}: ${this.decodeData(a,o)}`)):(this.exists&&T===0&&(this.isLimitHit=!0),S(null,"",!0))})}forwardData(n,o,v){const m=new y.StringDecoder(o);return n.on("data",S=>{v(null,m.write(S))}),m}collectData(n){const o=[];return n.on("data",v=>{o.push(v)}),o}decodeData(n,o){const v=new y.StringDecoder(o);return n.map(m=>v.write(m)).join("")}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries(n,{pathToEntries:o},v,m,S){m.indexOf(this.filePattern)!==-1&&this.matchFile(S,{base:v,relativePath:this.filePattern,searchPath:this.getSearchPath(n,this.filePattern)});const D=a=>{const T=C.basename(a),L=C.dirname(a);let U=o[L];U||(U=o[L]=[],D(L)),U.push({base:v,relativePath:a,basename:T,searchPath:this.getSearchPath(n,a)})};m.forEach(D)}matchDirectoryTree({rootEntries:n,pathToEntries:o},v,m){const S=this,D=this.folderExcludePatterns.get(v),a=this.filePattern;function T(L){S.directoriesWalked++;const U=E.hasSiblingFn(()=>L.map(G=>G.basename));for(let G=0,te=L.length;G<te;G++){const V=L[G],{relativePath:N,basename:W}=V;if(D.test(N,W,a!==W?U:void 0))continue;const M=o[N];if(M)T(M);else{if(S.filesWalked++,N===a)continue;S.matchFile(m,V)}if(S.isLimitHit)break}}T(n)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(n,o,v,m,S){const D=n.folder,a=E.hasSiblingFn(()=>v);this.parallel(v,(T,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const U=o?[o,T].join(C.sep):T;if(this.folderExcludePatterns.get(n.folder.fsPath).test(U,T,this.config.filePattern!==T?a:void 0))return L(null);const G=[D.fsPath,U].join(C.sep);R.lstat(G,(te,V)=>{if(te||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(G,V,(N,W)=>N||this.isCanceled||this.isLimitHit?L(null):W.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(G,V,(M,q)=>M||this.isCanceled||this.isLimitHit||(q=q||"",this.walkedPaths[q])?L(null):(this.walkedPaths[q]=!0,h.Promises.readdir(G).then(O=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(n,U,O,m,F=>L(F||null))},O=>{L(null)})))):(this.filesWalked++,U===this.filePattern||this.maxFilesize&&c.isNumber(W.size)&&W.size>this.maxFilesize||this.matchFile(m,{base:D.fsPath,relativePath:U,searchPath:this.getSearchPath(n,U)}),L(null,void 0)))})},T=>{const L=T&&A.coalesce(T);return S(L&&L.length>0?L[0]:void 0)})}matchFile(n,o){this.isFileMatch(o)&&(!this.includePattern||this.includePattern(o.relativePath,C.basename(o.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||n(o))}isFileMatch(n){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return _.isFilePatternMatch(n,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(n,o,v){return o.isSymbolicLink()?R.stat(n,v):v(null,o)}realPathIfNeeded(n,o,v){return o.isSymbolicLink()?R.realpath(n,(m,S)=>m?v(m):v(null,S)):v(null,n)}getSearchPath(n,o){return n.folderName?C.join(n.folderName,o):o}}e.FileWalker=u;class g{constructor(n){this.folderQueries=n.folderQueries,this.extraFiles=n.extraFileResources||[],this.walker=new u(n)}search(n,o,v){this.walker.walk(this.folderQueries,this.extraFiles,n,o,(m,S)=>{v(m,{limitHit:S,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=g;class t{constructor(n,o){this.expression=n,this.root=o,this.init(n)}init(n){let o,v;Object.keys(n).filter(m=>n[m]).forEach(m=>{C.isAbsolute(m)?(o=o||E.getEmptyExpression(),o[m]=n[m]):(v=v||E.getEmptyExpression(),v[m]=n[m])}),this.absoluteParsedExpr=o&&E.parse(o,{trimForExclusions:!0}),this.relativeParsedExpr=v&&E.parse(v,{trimForExclusions:!0})}test(n,o,v){return this.relativeParsedExpr&&this.relativeParsedExpr(n,o,v)||this.absoluteParsedExpr&&this.absoluteParsedExpr(C.join(this.root,n),o,v)}getBasenameTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...E.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...E.getBasenameTerms(this.relativeParsedExpr)),n}getPathTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...E.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...E.getPathTerms(this.relativeParsedExpr)),n}}function i(s){const n=s.trim().split(`
`),o=n[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return f.uppercaseFirstLetter(n[n.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}e.rgErrorMsgForDisplay=i}),define(ge[130],pe([0,1,38,282,99,18,68,30,9,8,2,31,64,283,267,89]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const _=c.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class w{constructor(D){this.outputChannel=D}provideTextSearchResults(D,a,T,L){return this.outputChannel.appendLine(`provideTextSearchResults ${D.pattern}, ${JSON.stringify(Object.assign(Object.assign({},a),{folder:a.folder.toString()}))}`),new Promise((U,G)=>{L.onCancellationRequested(()=>F());const te=i(D,a),V=a.folder.fsPath,N=te.map(we=>we.match(/^-/)?we:`'${we}'`).join(" ");this.outputChannel.appendLine(`${_} ${N}
 - cwd: ${V}`);let W=p.spawn(_,te,{cwd:V});W.on("error",we=>{console.error(we),this.outputChannel.appendLine("Error: "+(we&&we.message)),G(P.serializeSearchError(new P.SearchError(we&&we.message,P.SearchErrorCode.rgProcessError)))});let M=!1;const q=new u(a.maxResults,V,a.previewOptions);q.on("result",we=>{M=!0,$="",T.report(we)});let O=!1;const F=()=>{O=!0,W&&W.kill(),q&&q.cancel()};let B=!1;q.on("hitLimit",()=>{B=!0,F()});let $="";W.stdout.on("data",we=>{q.handleData(we),M||($+=we)});let Y=!1;W.stdout.once("data",()=>Y=!0);let ce="";W.stderr.on("data",we=>{const Re=we.toString();this.outputChannel.appendLine(Re),ce+=Re}),W.on("close",()=>{if(this.outputChannel.appendLine(Y?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(M?"Got result from parser":"No result from parser"),$&&this.outputChannel.appendLine(`Got data without result: ${$}`),this.outputChannel.appendLine(""),O)U({limitHit:B});else{q.flush(),W=null;let we;ce&&!Y&&(we=b(ce))?G(P.serializeSearchError(new P.SearchError(we.message,we.code))):U({limitHit:B})}})})}}e.RipgrepTextSearchEngine=w;function b(S){const D=S.split(`
`),a=D[0].trim();if(D.some(L=>L.startsWith("regex parse error")))return new P.SearchError(d(D),P.SearchErrorCode.regexParseError);const T=a.match(/grep config error: unknown encoding: (.*)/);if(T)return new P.SearchError(`Unknown encoding: ${T[1]}`,P.SearchErrorCode.unknownEncoding);if(a.startsWith("error parsing glob"))return new P.SearchError(a.charAt(0).toUpperCase()+a.substr(1),P.SearchErrorCode.globParseError);if(a.startsWith("the literal"))return new P.SearchError(a.charAt(0).toUpperCase()+a.substr(1),P.SearchErrorCode.invalidLiteral);if(a.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(a,P.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function d(S){const D=["Regex parse error"],a=S.filter(T=>T.startsWith("PCRE2:"));if(a.length>=1){const T=a[0].replace("PCRE2:","");if(T.indexOf(":")!==-1&&T.split(":").length>=2){const L=T.split(":")[1];D.push(":"+L)}}return D.join("")}e.buildRegexParseError=d;class u extends R.EventEmitter{constructor(D,a,T){super();this.maxResults=D,this.rootFolder=a,this.previewOptions=T,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new C.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(D,a){return super.on(D,a),this}handleData(D){if(this.isDone)return;const a=typeof D=="string"?D:this.stringDecoder.write(D);this.handleDecodedData(a)}handleDecodedData(D){let a=D.indexOf(`
`);const T=this.remainder+D;if(a>=0)a+=this.remainder.length;else{this.remainder=T;return}let L=0;for(;a>=0;)this.handleLine(T.substring(L,a).trim()),L=a+1,a=T.indexOf(`
`,L);this.remainder=T.substring(L)}handleLine(D){if(this.isDone||!D)return;let a;try{a=JSON.parse(D)}catch(T){throw new Error(`malformed line from rg: ${D}`)}if(a.type==="match"){const T=g(a.data.path),L=r.URI.file(E.join(this.rootFolder,T)),U=this.createTextSearchMatch(a.data,L);this.onResult(U),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(a.type==="context"){const T=g(a.data.path),L=r.URI.file(E.join(this.rootFolder,T));this.createTextSearchContext(a.data,L).forEach(G=>this.onResult(G))}}createTextSearchMatch(D,a){const T=D.line_number-1,L=g(D.lines),U=Buffer.from(L);let G=0,te=0,V=T;D.submatches.length===0&&D.submatches.push(L.length?{start:0,end:1,match:{text:L[0]}}:{start:0,end:0,match:{text:""}});const N=y.coalesce(D.submatches.map((W,M)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const q=g(W.match),O=U.slice(G,W.start).toString().length,F=te+O,B=t(q),$=V,Y=B.numLines+$,ce=B.numLines>0?B.lastLineLength:B.lastLineLength+F;return G=W.end,te=ce,V=Y,new l.Range($,F,Y,ce)}));return h.createTextSearchResult(a,L,N,this.previewOptions)}createTextSearchContext(D,a){const T=g(D.lines),L=D.line_number;return T.replace(/\r?\n$/,"").split(`
`).map((U,G)=>({text:U,uri:a,lineNumber:L+G}))}onResult(D){this.emit("result",D)}}e.RipgrepParser=u;function g(S){return S.bytes?Buffer.from(S.bytes,"base64").toString():S.text}function t(S){const D=/\n/g;let a=0,T=-1,L;for(;L=D.exec(S);)a++,T=L.index;const U=T>=0?S.length-T-1:S.length;return{numLines:a,lastLineLength:U}}function i(S,D){const a=["--hidden"];a.push(S.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:T,otherIncludes:L}=A.groupBy(D.includes,G=>G.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const G=new Set;L.forEach(te=>{G.add(te)}),a.push("-g","!*"),G.forEach(te=>{s(te).map(h.anchorGlob).forEach(V=>{a.push("-g",V)})})}T&&T.length&&T.forEach(G=>{a.push("-g",G)}),D.excludes.map(h.anchorGlob).forEach(G=>a.push("-g",`!${G}`)),D.maxFileSize&&a.push("--max-filesize",D.maxFileSize+""),D.useIgnoreFiles?a.push("--no-ignore-parent"):a.push("--no-ignore"),D.followSymlinks&&a.push("--follow"),D.encoding&&D.encoding!=="utf8"&&a.push("--encoding",D.encoding),S.pattern==="--"&&(S.isRegExp=!0,S.pattern="\\-\\-"),S.isMultiline&&!S.isRegExp&&(S.pattern=k.escapeRegExpCharacters(S.pattern),S.isRegExp=!0),D.usePCRE2&&a.push("--pcre2"),a.push("--crlf"),S.isRegExp&&(S.pattern=n(S.pattern),a.push("--auto-hybrid-regex"));let U;if(S.isWordMatch){const te=k.createRegExp(S.pattern,!!S.isRegExp,{wholeWord:S.isWordMatch}).source.replace(/\\\//g,"/");a.push("--regexp",te)}else if(S.isRegExp){let G=v(S.pattern);G=m(G),a.push("--regexp",G)}else U=S.pattern,a.push("--fixed-strings");return a.push("--no-config"),D.useGlobalIgnoreFiles||a.push("--no-ignore-global"),a.push("--json"),S.isMultiline&&a.push("--multiline"),D.beforeContext&&a.push("--before-context",D.beforeContext+""),D.afterContext&&a.push("--after-context",D.afterContext+""),a.push("--"),U&&a.push(U),a.push("."),a}function s(S){const D=I.splitGlobAware(S,"/");return D.map((a,T)=>D.slice(0,T+1).join("/"))}e.spreadGlobComponents=s;function n(S){const D=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;S.match(D);)S=S.replace(D,"$1\\x{$2}");const a=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;S.match(a);)S=S.replace(a,"$1\\x{$2}");return S}e.unicodeEscapesToPCRE2=n;const o=S=>S.type==="Assertion"&&S.kind==="lookbehind";function v(S){let D;try{D=new f.RegExpParser().parsePattern(S)}catch(te){return S}let a="",T=0;const L=(te,V,N)=>{a+=S.slice(T,te)+N,T=V},U=[];return new f.RegExpVisitor({onCharacterEnter(te){if(te.raw!=="\\n")return;const V=U[0];if(!V)L(te.start,te.end,"\\r?\\n");else if(!U.some(o))if(V.type==="CharacterClass")if(V.negate){const N=S.slice(V.start+2,te.start)+S.slice(te.end,V.end-1);L(V.start,V.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=S.slice(V.start+1,te.start)+S.slice(te.end,V.end-1);L(V.start,V.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else V.type==="Quantifier"&&L(te.start,te.end,"(?:\\r?\\n)")},onQuantifierEnter(te){U.unshift(te)},onQuantifierLeave(){U.shift()},onCharacterClassRangeEnter(te){U.unshift(te)},onCharacterClassRangeLeave(){U.shift()},onCharacterClassEnter(te){U.unshift(te)},onCharacterClassLeave(){U.shift()},onAssertionEnter(te){o(te)&&U.push(te)},onAssertionLeave(te){U[0]===te&&U.shift()}}).visit(D),a+=S.slice(T),a}e.fixRegexNewline=v;function m(S){return S.replace(/\n/g,"\\r?\\n")}e.fixNewline=m}),define(ge[269],pe([0,1,21,130,114,10]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class A{constructor(k){this.outputChannel=k,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(k,r,P,l){const f=new R.RipgrepTextSearchEngine(this.outputChannel);if(r.folder.scheme===y.Schemas.userData){const c=Object.assign(Object.assign({},r),{folder:r.folder.with({scheme:y.Schemas.file})}),h=new C.Progress(_=>P.report(Object.assign(Object.assign({},_),{uri:_.uri.with({scheme:r.folder.scheme})})));return this.withToken(l,_=>f.provideTextSearchResults(k,c,h,_))}else return this.withToken(l,c=>f.provideTextSearchResults(k,r,P,c))}async withToken(k,r){const P=I(k);this.inProgress.add(P);const l=await r(P.token);return this.inProgress.delete(P),l}dispose(){this.inProgress.forEach(k=>k.cancel())}}e.RipgrepSearchProvider=A;function I(E){const k=new p.CancellationTokenSource;return E.onCancellationRequested(()=>k.cancel()),k}}),define(ge[270],pe([0,1,28,130,129]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class y{constructor(E){this.query=E}search(E,k,r){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(f){r({message:f})}},l=new C.NativeTextSearchManager(this.query,new R.RipgrepTextSearchEngine(P),p);return new Promise((f,c)=>l.search(h=>{k(h.map(A))},E).then(h=>f({limitHit:h.limitHit,type:"success"}),c))}}e.TextSearchEngineAdapter=y;function A(I){return{path:I.resource&&I.resource.fsPath,results:I.results,numMatches:(I.results||[]).reduce((E,k)=>{if(k.ranges){const r=k;return E+(Array.isArray(r.ranges)?r.ranges.length:1)}else return E+1},0)}}}),define(ge[271],pe([0,1,56,284,18,16,14,3,96,9,43,2,41,31,268,270]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,R.gracefulify(p);class _{constructor(){this.caches=Object.create(null)}fileSearch(t){let i;const s=d(t),n=new I.Emitter({onFirstListenerDidAdd:()=>{i=y.createCancelablePromise(o=>this.doFileSearchWithEngine(c.Engine,s,v=>n.fire(v),o)),i.then(o=>n.fire(o),o=>n.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{i.cancel()}});return n.event}textSearch(t){let i;const s=d(t),n=new I.Emitter({onFirstListenerDidAdd:()=>{i=y.createCancelablePromise(o=>this.ripgrepTextSearch(s,v=>n.fire(v),o)),i.then(o=>n.fire(o),o=>n.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{i.cancel()}});return n.event}ripgrepTextSearch(t,i,s){return t.maxFileSize=l.getPlatformLimits(process.arch==="ia32"?0:1).maxFileSize,new h.TextSearchEngineAdapter(t).search(s,i,i)}doFileSearch(t,i,s){return this.doFileSearchWithEngine(c.Engine,t,i,s)}doFileSearchWithEngine(t,i,s,n,o=_.BATCH_SIZE){let v=0;const m=D=>{Array.isArray(D)?(v+=D.length,s(D.map(a=>this.rawMatchToSearchItem(a)))):D.relativePath?(v++,s(this.rawMatchToSearchItem(D))):s(D)};if(i.sortByScore){let D=this.trySortedSearchFromCache(i,m,n);if(!D){const a=i.maxResults?Object.assign({},i,{maxResults:null}):i,T=new t(a);D=this.doSortedSearch(T,i,s,m,n)}return new Promise((a,T)=>{D.then(([L,U])=>{const G=U.map(te=>this.rawMatchToSearchItem(te));this.sendProgress(G,s,o),a(L)},T)})}const S=new t(i);return this.doSearch(S,m,o,n).then(D=>({limitHit:D.limitHit,type:"success",stats:{detailStats:D.stats,type:"searchProcess",fromCache:!1,resultCount:v,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?k.join(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,i,s,n,o){const v=new I.Emitter;let m=y.createCancelablePromise(D=>{let a=[];const T=L=>{Array.isArray(L)?a=L:(n(L),v.fire(L))};return this.doSearch(t,T,-1,D).then(L=>[L,a])}),S;if(i.cacheKey){S=this.getOrCreateCache(i.cacheKey);const D={promise:m,event:v.event,resolved:!1};S.resultsToSearchCache[i.filePattern||""]=D,m.then(()=>{D.resolved=!0},a=>{delete S.resultsToSearchCache[i.filePattern||""]}),m=this.preventCancellation(m)}return m.then(([D,a])=>{const T=S?S.scorerCache:Object.create(null),L=(typeof i.maxResults!="number"||i.maxResults>0)&&r.StopWatch.create(!1);return this.sortResults(i,a,T,o).then(U=>{const G=L?L.elapsed():-1;return[{type:"success",stats:{detailStats:D.stats,sortingTime:G,fromCache:!1,type:"searchProcess",workspaceFolderCount:i.folderQueries.length,resultCount:U.length},messages:D.messages,limitHit:D.limitHit||typeof i.maxResults=="number"&&a.length>i.maxResults},U]})})}getOrCreateCache(t){const i=this.caches[t];return i||(this.caches[t]=new w)}trySortedSearchFromCache(t,i,s){const n=t.cacheKey&&this.caches[t.cacheKey];if(!n)return;const o=this.getResultsFromCache(n,t.filePattern||"",i,s);if(o)return o.then(([v,m,S])=>{const D=r.StopWatch.create(!1);return this.sortResults(t,m,n.scorerCache,s).then(a=>{const T=D.elapsed(),L={fromCache:!0,detailStats:S,type:"searchProcess",resultCount:m.length,sortingTime:T};return[{type:"success",limitHit:v.limitHit||typeof t.maxResults=="number"&&m.length>t.maxResults,stats:L},a]})})}sortResults(t,i,s,n){const o=E.prepareQuery(t.filePattern||""),v=(S,D)=>E.compareItemsByFuzzyScore(S,D,o,!0,b,s),m=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return C.topAsync(i,v,m,1e4,n)}sendProgress(t,i,s){if(s&&s>0)for(let n=0;n<t.length;n+=s)i(t.slice(n,n+s));else i(t)}getResultsFromCache(t,i,s,n){const o=r.StopWatch.create(!1),v=i.indexOf(k.sep)>=0;let m;for(const T in t.resultsToSearchCache)if(i.startsWith(T)){if(v&&T.indexOf(k.sep)<0&&T!=="")continue;const L=t.resultsToSearchCache[T];m={promise:this.preventCancellation(L.promise),event:L.event,resolved:L.resolved};break}if(!m)return null;const S=o.elapsed(),D=r.StopWatch.create(!1),a=m.event(s);return n&&n.onCancellationRequested(()=>{a.dispose()}),m.promise.then(([T,L])=>{if(n&&n.isCancellationRequested)throw A.canceled();const U=[],G=E.prepareQuery(i).normalizedLowercase;for(const te of L)!f.isFilePatternMatch(te,G)||U.push(te);return[T,U,{cacheWasResolved:m.resolved,cacheLookupTime:S,cacheFilterTime:D.elapsed(),cacheEntryCount:L.length}]})}doSearch(t,i,s,n){return new Promise((o,v)=>{let m=[];n&&n.onCancellationRequested(()=>t.cancel()),t.search(S=>{S&&(s?(m.push(S),s>0&&m.length>=s&&(i(m),m=[])):i(S))},S=>{i(S)},(S,D)=>{m.length&&i(m),S?v(S):o(D)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(i,s){return t.then(i,s)}catch(i){return this.then(void 0,i)}finally(i){return t.finally(i)}}}}e.SearchService=_,_.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const b=new class{getItemLabel(g){return k.basename(g.relativePath)}getItemDescription(g){return k.dirname(g.relativePath)}getItemPath(g){return g.relativePath}};function d(g){return Object.assign(Object.assign({},g),{folderQueries:g.folderQueries&&g.folderQueries.map(u),extraFileResources:g.extraFileResources&&g.extraFileResources.map(t=>P.URI.revive(t))})}function u(g){return Object.assign(Object.assign({},g),{folder:P.URI.revive(g.folder)})}}),define(ge[272],pe([0,1,6,2,28,12,31,271,269,89,13,60,27,67,10,129]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let _=class extends f.ExtHostSearch{constructor(b,d,u,g){super(b,u,g);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new k.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(c.Schemas.userData,new E.RipgrepSearchProvider(t)),d.remote.isRemote&&d.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const b=new k.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(c.Schemas.file,new E.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(c.Schemas.file,new I.SearchService)}registerInternalFileSearchProvider(b,d){const u=this._handlePool++;return this._internalFileSearchProvider=d,this._internalFileSearchHandle=u,this._proxy.$registerFileSearchProvider(u,this._transformScheme(b)),p.toDisposable(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(u)})}$provideFileSearchResults(b,d,u,g){const t=f.reviveQuery(u);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,d,t,g):super.$provideFileSearchResults(b,d,u,g)}doInternalFileSearch(b,d,u,g){const t=i=>{if(A.isSerializedFileMatch(i)&&(i=[i]),Array.isArray(i)){this._proxy.$handleFileMatch(b,d,i.map(s=>R.URI.file(s.path)));return}i.message&&this._logService.debug("ExtHostSearch",i.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(u,t,g)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,d){return new h.NativeTextSearchManager(b,d)}};_=Ve([$e(0,r.IExtHostRpcService),$e(1,l.IExtHostInitDataService),$e(2,P.IURITransformerService),$e(3,y.ILogService)],_),e.NativeExtHostSearch=_}),define(ge[131],pe([0,1,285,121,286,3,102,9,100,32,6,22,103,14,11]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class h{constructor(m){this.socket=m,this._errorListener=S=>{if(S){if(S.code==="EPIPE")return;f.onUnexpectedError(S)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(m){const S=D=>m(P.VSBuffer.wrap(D));return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(m){const S=D=>{m({type:0,hadError:D,error:void 0})};return this.socket.on("close",S),{dispose:()=>this.socket.off("close",S)}}onEnd(m){return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(m){if(!this.socket.destroyed)try{this.socket.write(m.buffer,S=>{if(S){if(S.code==="EPIPE")return;f.onUnexpectedError(S)}})}catch(S){if(S.code==="EPIPE")return;f.onUnexpectedError(S)}}end(){this.socket.end()}drain(){return new Promise((m,S)=>{if(this.socket.bufferSize===0){m();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),m()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=h;var _;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize"})(_||(_={}));var w;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(w||(w={}));class b extends r.Disposable{constructor(m,S,D,a){super();this._onDidZlibFlush=this._register(new y.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=m,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=S,this._recordInflateBytes=a,S?(this._zlibInflate=C.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",T=>{console.error(T),f.onUnexpectedError(T),this._onClose.fire({type:0,hadError:!0,error:T})}),this._zlibInflate.on("data",T=>{this._pendingInflateData.push(T)}),D&&(this._zlibInflate.write(D.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=C.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",T=>{console.error(T),f.onUnexpectedError(T),this._onClose.fire({type:0,hadError:!0,error:T})}),this._zlibDeflate.on("data",T=>{this._pendingDeflateData.push(T)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new l.ChunkStream,this._register(this.socket.onData(T=>this._acceptChunk(T))),this._register(this.socket.onClose(T=>this._onClose.fire(T)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?P.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):P.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(m){return this._onData.event(m)}onClose(m){return this._onClose.event(m)}onEnd(m){return this.socket.onEnd(m)}write(m){this._totalOutgoingDataBytes+=m.byteLength,this._zlibDeflate?(this._zlibDeflate.write(m.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let S=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,S=S.slice(0,S.length-4),this._isEnded||this._write(P.VSBuffer.wrap(S),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(m,!1)}_write(m,S){let D=2;m.byteLength<126?D+=0:m.byteLength<2**16?D+=2:D+=8;const a=P.VSBuffer.alloc(D);if(S?a.writeUInt8(194,0):a.writeUInt8(130,0),m.byteLength<126)a.writeUInt8(m.byteLength,1);else if(m.byteLength<2**16){a.writeUInt8(126,1);let T=1;a.writeUInt8(m.byteLength>>>8&255,++T),a.writeUInt8(m.byteLength>>>0&255,++T)}else{a.writeUInt8(127,1);let T=1;a.writeUInt8(0,++T),a.writeUInt8(0,++T),a.writeUInt8(0,++T),a.writeUInt8(0,++T),a.writeUInt8(m.byteLength>>>24&255,++T),a.writeUInt8(m.byteLength>>>16&255,++T),a.writeUInt8(m.byteLength>>>8&255,++T),a.writeUInt8(m.byteLength>>>0&255,++T)}this._totalOutgoingWireBytes+=a.byteLength+m.byteLength,this.socket.write(P.VSBuffer.concat([a,m]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(m){if(m.byteLength!==0){for(this._totalIncomingWireBytes+=m.byteLength,this._incomingData.acceptChunk(m);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const S=this._incomingData.peek(this._state.readLen),a=(S.readUInt8(0)&128)>>>7,T=S.readUInt8(1),L=(T&128)>>>7,U=T&127;this._state.state=2,this._state.readLen=2+(L?4:0)+(U===126?2:0)+(U===127?8:0),this._state.fin=a,this._state.mask=0}else if(this._state.state===2){const S=this._incomingData.read(this._state.readLen),D=S.readUInt8(1),a=(D&128)>>>7;let T=D&127,L=1;T===126?T=S.readUInt8(++L)*2**8+S.readUInt8(++L):T===127&&(T=S.readUInt8(++L)*0+S.readUInt8(++L)*0+S.readUInt8(++L)*0+S.readUInt8(++L)*0+S.readUInt8(++L)*2**24+S.readUInt8(++L)*2**16+S.readUInt8(++L)*2**8+S.readUInt8(++L));let U=0;a&&(U=S.readUInt8(++L)*2**24+S.readUInt8(++L)*2**16+S.readUInt8(++L)*2**8+S.readUInt8(++L)),this._state.state=3,this._state.readLen=T,this._state.mask=U}else if(this._state.state===3){const S=this._incomingData.read(this._state.readLen);d(S,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(S.buffer)),this._zlibInflate.write(S.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const D=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=D.length,this._onData.fire(P.VSBuffer.wrap(D))})):(this._totalIncomingDataBytes+=S.byteLength,this._onData.fire(S))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await y.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=b;function d(v,m){if(m===0)return;let S=v.byteLength>>>2;for(let G=0;G<S;G++){const te=v.readUInt32BE(G*4);v.writeUInt32BE(te^m,G*4)}let D=S*4,a=v.byteLength-D;const T=m>>>24&255,L=m>>>16&255,U=m>>>8&255;a>=1&&v.writeUInt8(v.readUInt8(D)^T,D),a>=2&&v.writeUInt8(v.readUInt8(D+1)^L,D+1),a>=3&&v.writeUInt8(v.readUInt8(D+2)^U,D+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const u={[2]:107,[1]:103};function g(){const v=k.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;let m;return e.XDG_RUNTIME_DIR?m=I.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${v}.sock`):m=I.join(E.tmpdir(),`vscode-ipc-${v}.sock`),i(m),m}e.createRandomIPCHandle=g;function t(v,m,S){const D=p.createHash("md5").update(v).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${S}-${m}-sock`;let a;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?a=I.join(e.XDG_RUNTIME_DIR,`vscode-${D.substr(0,8)}-${S}-${m}.sock`):a=I.join(v,`${S}-${m}.sock`),i(a),a}e.createStaticIPCHandle=t;function i(v){const m=u[c.platform];typeof m=="number"&&v.length>=m&&console.warn(`WARNING: IPC handle "${v}" is longer than ${m} chars, try a shorter --user-data-dir`)}class s extends A.IPCServer{constructor(m){super(s.toClientConnectionEvent(m));this.server=m}static toClientConnectionEvent(m){const S=y.Event.fromNodeEventEmitter(m,"connection");return y.Event.map(S,D=>({protocol:new l.Protocol(new h(D)),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(D,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function n(v){return new Promise((m,S)=>{const D=R.createServer();D.on("error",S),D.listen(v,()=>{D.removeListener("error",S),m(new s(D))})})}e.serve=n;function o(v,m){return new Promise((S,D)=>{const a=R.createConnection(v,()=>{a.removeListener("error",D),S(l.Client.fromSocket(new h(a),m))});a.once("error",D)})}e.connect=o}),define(ge[273],pe([0,1,131,265,56,48,2,190,12]),function(X,e,p,R,C,y,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class k{constructor(l,f,c){this._commands=l,this.logService=f,this._ipcHandlePath=c,this._server=R.createServer((h,_)=>this.onRequest(h,_)),this.setup().catch(h=>(f.error(h),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",l=>this.logService.error(l))}catch(l){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(l,f){const c=[];l.setEncoding("utf8"),l.on("data",h=>c.push(h)),l.on("end",()=>{const h=JSON.parse(c.join(""));switch(h.type){case"open":this.open(h,f);break;case"openExternal":this.openExternal(h,f);break;case"status":this.getStatus(h,f);break;case"extensionManagement":this.manageExtensions(h,f).catch(this.logService.error);break;default:f.writeHead(404),f.write(`Unknown message type: ${h.type}`,_=>{_&&this.logService.error(_)}),f.end();break}})}open(l,f){let{fileURIs:c,folderURIs:h,forceNewWindow:_,diffMode:w,addMode:b,forceReuseWindow:d,gotoLineMode:u,waitMarkerFilePath:g}=l;const t=[];if(Array.isArray(h))for(const i of h)try{t.push({folderUri:A.URI.parse(i)})}catch(s){}if(Array.isArray(c))for(const i of c)try{I.hasWorkspaceFileExtension(i)?t.push({workspaceUri:A.URI.parse(i)}):t.push({fileUri:A.URI.parse(i)})}catch(s){}if(t.length){const i=g?A.URI.file(g):void 0,n={forceNewWindow:_,diffMode:w,addMode:b,gotoLineMode:u,forceReuseWindow:d,preferNewWindow:!d&&!i&&!b,waitMarkerFileURI:i};this._commands.executeCommand("_remoteCLI.windowOpen",t,n)}f.writeHead(200),f.end()}async openExternal(l,f){for(const c of l.uris){const h=A.URI.parse(c),_=h.scheme==="file"?h:c;await this._commands.executeCommand("_remoteCLI.openExternal",_)}f.writeHead(200),f.end()}async manageExtensions(l,f){try{const c=w=>w==null?void 0:w.map(b=>/\.vsix$/i.test(b)?A.URI.parse(b):b),h={list:l.list,install:c(l.install),uninstall:c(l.uninstall),force:l.force},_=await this._commands.executeCommand("_remoteCLI.manageExtensions",h);f.writeHead(200),f.write(_)}catch(c){f.writeHead(500),f.write(String(c),h=>{h&&this.logService.error(h)})}f.end()}async getStatus(l,f){try{const c=await this._commands.executeCommand("_remoteCLI.getSystemStatus");f.writeHead(200),f.write(c),f.end()}catch(c){f.writeHead(500),f.write(String(c),h=>{h&&this.logService.error(h)}),f.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&C.existsSync(this._ipcHandlePath)&&C.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=k;let r=class extends k{constructor(l,f){super(l,f,p.createRandomIPCHandle())}};r=Ve([$e(0,y.IExtHostCommands),$e(1,E.ILogService)],r),e.CLIServer=r}),define(ge[274],pe([0,1,66,261,256,5,264,39,247,2,10,7,273,101]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class c extends C.RequireInterceptor{_installInterceptor(){const w=this,b=X.__$__nodeRequire("module"),d=b._load;b._load=function(g,t,i){for(let s of w._alternatives){let n=s(g);if(n){g=n;break}}return w._factories.has(g)?w._factories.get(g).load(g,k.URI.file(f.realpathSync(t.filename)),s=>d.apply(this,[s,t,i])):d.apply(this,arguments)}}}class h extends I.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const w=this._instaService.invokeFunction(R.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(E.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(l.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(c,w,this._registry).install(),p.mark("code/extHost/didInitAPI");const d=await this._extHostConfiguration.getConfigProvider();await A.connectProxyResolver(this._extHostWorkspace,d,this,this._logService,this._mainThreadTelemetryProxy,this._initData),p.mark("code/extHost/didInitProxyResolver");const u=process.send,g=this._extHostContext.getProxy(y.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?u.apply(process,t):(g.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(w){return w.main}_loadCommonJSModule(w,b,d){if(b.scheme!==r.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let u=null;d.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();try{w&&p.mark(`code/extHost/willLoadExtensionCode/${w.value}`),u=X.__$__nodeRequire(b.fsPath)}catch(g){return Promise.reject(g)}finally{w&&p.mark(`code/extHost/didLoadExtensionCode/${w.value}`),d.codeLoadingStop()}return Promise.resolve(u)}async $setRemoteEnvironment(w){if(!!this._initData.remote.isRemote)for(const b in w){const d=w[b];d===null?delete process.env[b]:process.env[b]=d}}}e.ExtHostExtensionService=h}),define(ge[275],pe([0,1,77,248,249,258,257,272,274,216,250,49,39,62,67,65,33,47,12]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h,_,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),p.registerSingleton(l.IExtHostExtensionService,E.ExtHostExtensionService),p.registerSingleton(b.ILogService,k.ExtHostLogService),p.registerSingleton(P.IExtHostDebugService,A.ExtHostDebugService),p.registerSingleton(f.IExtHostOutputService,R.ExtHostOutputService2),p.registerSingleton(c.IExtHostSearch,I.NativeExtHostSearch),p.registerSingleton(h.IExtHostTask,y.ExtHostTask),p.registerSingleton(_.IExtHostTerminalService,C.ExtHostTerminalService),p.registerSingleton(w.IExtHostTunnelService,r.ExtHostTunnelService)}),define(ge[276],pe([0,1,121,287,66,14,103,131,184,214,259,22,98,28,101,16,262,275]),function(X,e,p,R,C,y,A,I,E,k,r,P,l,f,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let n=0;n<process.execArgv.length;n++)process.execArgv[n]==="--inspect-port=0"&&(process.execArgv.splice(n,1),n--)}();const _=R(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const s=X.__$__nodeRequire("module"),n=s._load;s._load=function(o){if(o==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return n.apply(this,arguments)}})();const w=process.exit.bind(process);function b(s){process.exit=function(n){if(s)w(n);else{const o=new Error("An extension called process.exit() and this was prevented.");console.warn(o.stack)}},process.crash=function(){const n=new Error("An extension called process.crash() and this was prevented.");console.warn(n.stack)}}let d=function(s){w()};function u(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((s,n)=>{let o=null,v=setTimeout(()=>{d("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const m=108e5,S=3e5,D=new h.RunOnceScheduler(()=>d("renderer disconnected for too long (1)"),m),a=new h.RunOnceScheduler(()=>d("renderer disconnected for too long (2)"),S);process.on("message",(L,U)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){const G=P.VSBuffer.wrap(Buffer.from(L.initialDataChunk,"base64"));let te;if(L.skipWebSocketFrames)te=new I.NodeSocket(U);else{const V=P.VSBuffer.wrap(Buffer.from(L.inflateBytes,"base64"));te=new I.WebSocketNodeSocket(new I.NodeSocket(U),L.permessageDeflate,V,!1)}o?(D.cancel(),a.cancel(),o.beginAcceptReconnection(te,G),o.endAcceptReconnection()):(clearTimeout(v),o=new A.PersistentProtocol(te,G),o.onDidDispose(()=>d("renderer disconnected")),s(o),o.onSocketClose(()=>{D.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(a.isScheduled())return;D.isScheduled()&&a.schedule()}});const T={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(T)});{const s=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((n,o)=>{const v=p.createConnection(s,()=>{v.removeListener("error",o),n(new A.PersistentProtocol(new I.NodeSocket(v)))});v.once("error",o),v.on("close",()=>{d("renderer closed the socket")})})}}async function g(){const s=await u();return new class{constructor(){this._onMessage=new A.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,s.onMessage(n=>{k.isMessageOfType(n,2)?(this._terminating=!0,d("received terminate message from renderer")):this._onMessage.fire(n)})}send(n){this._terminating||s.send(n)}drain(){return s.drain()}}}function t(s){return new Promise(n=>{const o=s.onMessage(v=>{o.dispose();const m=JSON.parse(v.toString()),S=m.commit,D=E.default.commit;S&&D&&S!==D&&w(55);const a=[];process.on("unhandledRejection",(U,G)=>{a.push(G),setTimeout(()=>{const te=a.indexOf(G);te>=0&&G.catch(V=>{a.splice(te,1),y.isPromiseCanceledError(V)||(console.warn(`rejected promise not handled within 1 second: ${V}`),V&&V.stack&&console.warn(`stack trace: ${V.stack}`),y.onUnexpectedError(U))})},1e3)}),process.on("rejectionHandled",U=>{const G=a.indexOf(U);G>=0&&a.splice(G,1)}),process.on("uncaughtException",function(U){y.onUnexpectedError(U)});let T=0;setInterval(function(){try{process.kill(m.parentPid,0),T=0}catch(U){U&&U.code==="EPERM"?(T++,T>=3&&d(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${U.message} (code: ${U.code}) (errno: ${U.errno})`)):d(`parent process ${m.parentPid} does not exist anymore: ${U.message} (code: ${U.code}) (errno: ${U.errno})`)}},1e3);let L;try{L=X.__$__nodeRequire("native-watchdog"),L.start(m.parentPid)}catch(U){y.onUnexpectedError(U)}s.send(k.createMessageOfType(0)),n({protocol:s,initData:m})});s.send(k.createMessageOfType(1))})}async function i(){C.mark("code/extHost/willConnectToRenderer");const s=await g();C.mark("code/extHost/didConnectToRenderer");const n=await t(s);C.mark("code/extHost/didWaitForInitData");const{initData:o}=n;b(!!o.environment.extensionTestsLocationURI),o.environment.useHostProxy=_.useHostProxy!==void 0?_.useHostProxy!=="false":void 0;const v=new class{exit(a){w(a)}exists(a){return f.Promises.exists(a)}realpath(a){return c.realpath(a)}};let m=null;if(o.remote.authority&&_.uriTransformerPath)try{const a=X.__$__nodeRequire(_.uriTransformerPath)(o.remote.authority);m=new l.URITransformer(a)}catch(D){console.error(D)}const S=new r.ExtensionHostMain(n.protocol,o,v,m);d=D=>S.terminate(D)}e.startExtensionHostProcess=i}),define(ge[288],pe([0,1,276]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),p.startExtensionHostProcess().catch(R=>console.log(R))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9744231fc12f1aed21089180b3f0394d694bd2a2/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
