/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/errors","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/platform/log/common/log","vs/base/common/arrays","vs/base/common/cancellation","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/platform","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/editor/common/core/range","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/editor/common/core/position","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/iterator","vs/base/common/process","vs/base/common/severity","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/numbers","vs/base/common/codicons","vs/base/common/uint","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/markers/common/markers","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(ee){for(var e=[],m=0,T=ee.length;m<T;m++)e[m]=we[ee[m]];return e};define(we[38],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(T,S){if(!T)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=m}),define(we[75],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const m=Object.prototype.hasOwnProperty;function T(n){const I=[];for(let o in n)m.call(n,o)&&I.push(n[o]);return I}e.values=T;function S(n,I){for(let o in n)if(m.call(n,o)&&I({key:o,value:n[o]},function(){delete n[o]})===!1)return}e.forEach=S;function y(n,I){const o=Object.create(null);for(const f of n){const c=I(f);let d=o[c];d||(d=o[c]=[]),d.push(f)}return o}e.groupBy=y;function k(n){const I=Object.create(null);return n&&n.forEach((o,f)=>{I[f]=o}),I}e.fromMap=k;function D(n,I){const o=[],f=[];for(let c of n)I.has(c)||o.push(c);for(let c of I)n.has(c)||f.push(c);return{removed:o,added:f}}e.diffSets=D;function b(n,I){const o=[],f=[];for(let[c,d]of n)I.has(c)||o.push(d);for(let[c,d]of I)n.has(c)||f.push(d);return{removed:o,added:f}}e.diffMaps=b;class C{constructor(){this.map=new Map}add(I,o){let f=this.map.get(I);f||(f=new Set,this.map.set(I,f)),f.add(o)}delete(I,o){const f=this.map.get(I);!f||(f.delete(o),f.size===0&&this.map.delete(I))}forEach(I,o){const f=this.map.get(I);!f||f.forEach(o)}}e.SetMap=C}),define(we[48],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(k){return(D,b,C)=>{let n=null,I=null;if(typeof C.value=="function"?(n="value",I=C.value):typeof C.get=="function"&&(n="get",I=C.get),!I)throw new Error("not supported");C[n]=k(I,b)}}e.createDecorator=m;function T(k,D,b){let C=null,n=null;if(typeof b.value=="function"?(C="value",n=b.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(C="get",n=b.get),!n)throw new Error("not supported");const I=`$memoize$${D}`;b[C]=function(...o){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,o)}),this[I]}}e.memoize=T;function S(k,D,b){return m((C,n)=>{const I=`$debounce$${n}`,o=`$debounce$result$${n}`;return function(...f){this[o]||(this[o]=b?b():void 0),clearTimeout(this[I]),D&&(this[o]=D(this[o],...f),f=[this[o]]),this[I]=setTimeout(()=>{C.apply(this,f),this[o]=b?b():void 0},k)}})}e.debounce=S;function y(k,D,b){return m((C,n)=>{const I=`$throttle$timer$${n}`,o=`$throttle$result$${n}`,f=`$throttle$lastRun$${n}`,c=`$throttle$pending$${n}`;return function(...d){if(this[o]||(this[o]=b?b():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),D&&(this[o]=D(this[o],...d)),this[c])return;const w=this[f]+k;w<=Date.now()?(this[f]=Date.now(),C.apply(this,[this[o]]),this[o]=b?b():void 0):(this[c]=!0,this[I]=setTimeout(()=>{this[c]=!1,this[f]=Date.now(),C.apply(this,[this[o]]),this[o]=b?b():void 0},w-Date.now()))}})}e.throttle=y}),define(we[11],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=m,e.errorHandler=new m;function T(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=T;function S(g){b(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=S;function y(g){b(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=y;function k(g){if(g instanceof Error){let{name:t,message:i}=g;const s=g.stacktrace||g.stack;return{$isError:!0,name:t,message:i,stack:s}}return g}e.transformErrorForSerialization=k;const D="Canceled";function b(g){return g instanceof Error&&g.name===D&&g.message===D}e.isPromiseCanceledError=b;class C extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=C;function n(){const g=new Error(D);return g.name=g.message,g}e.canceled=n;function I(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=I;function o(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=o;function f(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function c(g){const t=new Error(`${g} has been disposed`);return t.name="DISPOSED",t}e.disposed=c;function d(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=d;class w extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=w;class v extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=v;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function u(g){const t=g;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function h(g,t=Object.create(null)){const i=new Error(g);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=h}),define(we[17],_e([0,1,11]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function T(X,B=0){return X[X.length-(1+B)]}e.tail=T;function S(X){if(X.length===0)throw new Error("Invalid tail call");return[X.slice(0,X.length-1),X[X.length-1]]}e.tail2=S;function y(X,B,U=(Y,V)=>Y===V){if(X===B)return!0;if(!X||!B||X.length!==B.length)return!1;for(let Y=0,V=X.length;Y<V;Y++)if(!U(X[Y],B[Y]))return!1;return!0}e.equals=y;function k(X,B,U){let Y=0,V=X.length-1;for(;Y<=V;){const ce=(Y+V)/2|0,ge=U(X[ce],B);if(ge<0)Y=ce+1;else if(ge>0)V=ce-1;else return ce}return-(Y+1)}e.binarySearch=k;function D(X,B){let U=0,Y=X.length;if(Y===0)return 0;for(;U<Y;){const V=Math.floor((U+Y)/2);B(X[V])?Y=V:U=V+1}return U}e.findFirstInSorted=D;function b(X,B,U){if(X=X|0,X>=B.length)throw new TypeError("invalid index");let Y=B[Math.floor(B.length*Math.random())],V=[],ce=[],ge=[];for(let Ae of B){const $e=U(Ae,Y);$e<0?V.push(Ae):$e>0?ce.push(Ae):ge.push(Ae)}return X<V.length?b(X,V,U):X<V.length+ge.length?ge[0]:b(X-(V.length+ge.length),ce,U)}e.quickSelect=b;function C(X,B){const U=[];let Y;for(const V of X.slice(0).sort(B))!Y||B(Y[0],V)!==0?(Y=[V],U.push(Y)):Y.push(V);return U}e.groupBy=C;function n(X,B,U){const Y=[];function V(Ae,$e,Fe){if($e===0&&Fe.length===0)return;const Ve=Y[Y.length-1];Ve&&Ve.start+Ve.deleteCount===Ae?(Ve.deleteCount+=$e,Ve.toInsert.push(...Fe)):Y.push({start:Ae,deleteCount:$e,toInsert:Fe})}let ce=0,ge=0;for(;;){if(ce===X.length){V(ce,0,B.slice(ge));break}if(ge===B.length){V(ce,X.length-ce,[]);break}const Ae=X[ce],$e=B[ge],Fe=U(Ae,$e);Fe===0?(ce+=1,ge+=1):Fe<0?(V(ce,1,[]),ce+=1):Fe>0&&(V(ce,0,[$e]),ge+=1)}return Y}e.sortedDiff=n;function I(X,B,U){const Y=n(X,B,U),V=[],ce=[];for(const ge of Y)V.push(...X.slice(ge.start,ge.start+ge.deleteCount)),ce.push(...ge.toInsert);return{removed:V,added:ce}}e.delta=I;function o(X,B,U){if(U===0)return[];const Y=X.slice(0,U).sort(B);return c(X,B,Y,U,X.length),Y}e.top=o;function f(X,B,U,Y,V){return U===0?Promise.resolve([]):new Promise((ce,ge)=>{(async()=>{const Ae=X.length,$e=X.slice(0,U).sort(B);for(let Fe=U,Ve=Math.min(U+Y,Ae);Fe<Ae;Fe=Ve,Ve=Math.min(Ve+Y,Ae)){if(Fe>U&&await new Promise(tt=>setTimeout(tt)),V&&V.isCancellationRequested)throw m.canceled();c(X,B,$e,Fe,Ve)}return $e})().then(ce,ge)})}e.topAsync=f;function c(X,B,U,Y,V){for(const ce=U.length;Y<V;Y++){const ge=X[Y];if(B(ge,U[ce-1])<0){U.pop();const Ae=D(U,$e=>B(ge,$e)<0);U.splice(Ae,0,ge)}}}function d(X){return X.filter(B=>!!B)}e.coalesce=d;function w(X){let B=0;for(let U=0;U<X.length;U++)X[U]&&(X[B]=X[U],B+=1);X.length=B}e.coalesceInPlace=w;function v(X,B,U){X.splice(U,0,X.splice(B,1)[0])}e.move=v;function E(X){return!Array.isArray(X)||X.length===0}e.isFalsyOrEmpty=E;function u(X){return Array.isArray(X)&&X.length>0}e.isNonEmptyArray=u;function h(X,B){if(!B)return X.filter((Y,V)=>X.indexOf(Y)===V);const U=Object.create(null);return X.filter(Y=>{const V=B(Y);return U[V]?!1:(U[V]=!0,!0)})}e.distinct=h;function g(X){const B=new Set;return X.filter(U=>B.has(U)?!1:(B.add(U),!0))}e.distinctES6=g;function t(X){const B=Object.create(null);return U=>{const Y=X(U);return B[Y]?!1:(B[Y]=!0,!0)}}e.uniqueFilter=t;function i(X,B){for(let U=X.length-1;U>=0;U--){const Y=X[U];if(B(Y))return U}return-1}e.lastIndex=i;function s(X,B){return X.length>0?X[0]:B}e.firstOrDefault=s;function r(X,B,U=(Y,V)=>Y===V){let Y=0;for(let V=0,ce=Math.min(X.length,B.length);V<ce&&U(X[V],B[V]);V++)Y++;return Y}e.commonPrefixLength=r;function l(X){return[].concat(...X)}e.flatten=l;function _(X,B){let U=typeof B=="number"?X:0;typeof B=="number"?U=X:(U=0,B=X);const Y=[];if(U<=B)for(let V=U;V<B;V++)Y.push(V);else for(let V=U;V>B;V--)Y.push(V);return Y}e.range=_;function p(X,B,U){return X.reduce((Y,V)=>(Y[B(V)]=U?U(V):V,Y),Object.create(null))}e.index=p;function P(X,B){return X.push(B),()=>A(X,B)}e.insert=P;function A(X,B){const U=X.indexOf(B);if(U>-1)return X.splice(U,1),B}e.remove=A;function a(X,B,U){const Y=X.slice(0,B),V=X.slice(B);return Y.concat(U,V)}e.arrayInsert=a;function R(X,B){let U;if(typeof B=="number"){let Y=B;U=()=>{const V=Math.sin(Y++)*179426549;return V-Math.floor(V)}}else U=Math.random;for(let Y=X.length-1;Y>0;Y-=1){const V=Math.floor(U()*(Y+1)),ce=X[Y];X[Y]=X[V],X[V]=ce}}e.shuffle=R;function F(X,B){const U=X.indexOf(B);U>-1&&(X.splice(U,1),X.unshift(B))}e.pushToStart=F;function x(X,B){const U=X.indexOf(B);U>-1&&(X.splice(U,1),X.push(B))}e.pushToEnd=x;function J(X,B){return Array.isArray(X)?X.map(B):B(X)}e.mapArrayOrNot=J;function ae(X){return Array.isArray(X)?X:[X]}e.asArray=ae;function j(X){return X[Math.floor(Math.random()*X.length)]}e.getRandomElement=j;function W(X,B){for(const U of X){const Y=B(U);if(Y!==void 0)return Y}}e.mapFind=W;function Q(X,B){let U=Number.MAX_SAFE_INTEGER,Y=0;return X.forEach((V,ce)=>{const ge=B(V);ge<U&&(U=ge,Y=ce)}),Y}e.minIndex=Q;function M(X,B){let U=Number.MIN_SAFE_INTEGER,Y=0;return X.forEach((V,ce)=>{const ge=B(V);ge>U&&(U=ge,Y=ce)}),Y}e.maxIndex=M}),define(we[49],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(T){const S=this;let y=!1,k;return function(){return y||(y=!0,k=T.apply(S,arguments)),k}}e.once=m}),define(we[50],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class m{constructor(S){this._prefix=S,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=m,e.defaultGenerator=new m("id#")}),define(we[39],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(T){function S(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}T.is=S;const y=Object.freeze([]);function k(){return y}T.empty=k;function*D(g){yield g}T.single=D;function b(g){return g||y}T.from=b;function C(g){return!g||g[Symbol.iterator]().next().done===!0}T.isEmpty=C;function n(g){return g[Symbol.iterator]().next().value}T.first=n;function I(g,t){for(const i of g)if(t(i))return!0;return!1}T.some=I;function o(g,t){for(const i of g)if(t(i))return i}T.find=o;function*f(g,t){for(const i of g)t(i)&&(yield i)}T.filter=f;function*c(g,t){let i=0;for(const s of g)yield t(s,i++)}T.map=c;function*d(...g){for(const t of g)for(const i of t)yield i}T.concat=d;function*w(g){for(const t of g)for(const i of t)yield i}T.concatNested=w;function v(g,t,i){let s=i;for(const r of g)s=t(s,r);return s}T.reduce=v;function*E(g,t,i=g.length){for(t<0&&(t+=g.length),i<0?i+=g.length:i>g.length&&(i=g.length);t<i;t++)yield g[t]}T.slice=E;function u(g,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,g];const s=g[Symbol.iterator]();for(let r=0;r<t;r++){const l=s.next();if(l.done)return[i,T.empty()];i.push(l.value)}return[i,{[Symbol.iterator](){return s}}]}T.consume=u;function h(g,t,i=(s,r)=>s===r){const s=g[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const l=s.next(),_=r.next();if(l.done!==_.done)return!1;if(l.done)return!0;if(!i(l.value,_.value))return!1}}T.equals=h})(m=e.Iterable||(e.Iterable={}))}),define(we[107],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S=e.ParseErrorCode||(e.ParseErrorCode={}));var y;(function(t){t.DEFAULT={allowTrailingComma:!0}})(y=e.ParseOptions||(e.ParseOptions={}));function k(t,i=!1){let s=0,r=t.length,l="",_=0,p=16,P=0;function A(j){let W=0,Q=0;for(;W<j;){const M=t.charCodeAt(s);if(M>=48&&M<=57)Q=Q*16+M-48;else if(M>=65&&M<=70)Q=Q*16+M-65+10;else if(M>=97&&M<=102)Q=Q*16+M-97+10;else break;s++,W++}return W<j&&(Q=-1),Q}function a(j){s=j,l="",_=0,p=16,P=0}function R(){const j=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&C(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&C(t.charCodeAt(s)))for(s++;s<t.length&&C(t.charCodeAt(s));)s++;else return P=3,t.substring(j,s);let W=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&C(t.charCodeAt(s))){for(s++;s<t.length&&C(t.charCodeAt(s));)s++;W=s}else P=3;return t.substring(j,W)}function F(){let j="",W=s;for(;;){if(s>=r){j+=t.substring(W,s),P=2;break}const Q=t.charCodeAt(s);if(Q===34){j+=t.substring(W,s),s++;break}if(Q===92){if(j+=t.substring(W,s),s++,s>=r){P=2;break}switch(t.charCodeAt(s++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:const X=A(4);X>=0?j+=String.fromCharCode(X):P=4;break;default:P=5}W=s;continue}if(Q>=0&&Q<=31)if(b(Q)){j+=t.substring(W,s),P=2;break}else P=6;s++}return j}function x(){if(l="",P=0,_=s,s>=r)return _=r,p=17;let j=t.charCodeAt(s);if(D(j)){do s++,l+=String.fromCharCode(j),j=t.charCodeAt(s);while(D(j));return p=15}if(b(j))return s++,l+=String.fromCharCode(j),j===13&&t.charCodeAt(s)===10&&(s++,l+=`
`),p=14;switch(j){case 123:return s++,p=1;case 125:return s++,p=2;case 91:return s++,p=3;case 93:return s++,p=4;case 58:return s++,p=6;case 44:return s++,p=5;case 34:return s++,l=F(),p=10;case 47:const W=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<r&&!b(t.charCodeAt(s));)s++;return l=t.substring(W,s),p=12}if(t.charCodeAt(s+1)===42){s+=2;const Q=r-1;let M=!1;for(;s<Q;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,M=!0;break}s++}return M||(s++,P=1),l=t.substring(W,s),p=13}return l+=String.fromCharCode(j),s++,p=16;case 45:if(l+=String.fromCharCode(j),s++,s===r||!C(t.charCodeAt(s)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=R(),p=11;default:for(;s<r&&J(j);)s++,j=t.charCodeAt(s);if(_!==s){switch(l=t.substring(_,s),l){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return l+=String.fromCharCode(j),s++,p=16}}function J(j){if(D(j)||b(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ae(){let j;do j=x();while(j>=12&&j<=15);return j}return{setPosition:a,getPosition:()=>s,scan:i?ae:x,getToken:()=>p,getTokenValue:()=>l,getTokenOffset:()=>_,getTokenLength:()=>s-_,getTokenError:()=>P}}e.createScanner=k;function D(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function b(t){return t===10||t===13||t===8232||t===8233}function C(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function I(t,i){const s=[],r=new Object;let l;const _={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function P(A,a,R,F){_.value=A,_.offset=a,_.length=R,_.type=F,_.colonOffset=void 0,l=_}try{u(t,{onObjectBegin:(A,a)=>{if(i<=A)throw r;l=void 0,p=i>A,s.push("")},onObjectProperty:(A,a,R)=>{if(i<a||(P(A,a,R,"property"),s[s.length-1]=A,i<=a+R))throw r},onObjectEnd:(A,a)=>{if(i<=A)throw r;l=void 0,s.pop()},onArrayBegin:(A,a)=>{if(i<=A)throw r;l=void 0,s.push(0)},onArrayEnd:(A,a)=>{if(i<=A)throw r;l=void 0,s.pop()},onLiteralValue:(A,a,R)=>{if(i<a||(P(A,a,R,g(A)),i<=a+R))throw r},onSeparator:(A,a,R)=>{if(i<=a)throw r;if(A===":"&&l&&l.type==="property")l.colonOffset=a,p=!1,l=void 0;else if(A===","){const F=s[s.length-1];typeof F=="number"?s[s.length-1]=F+1:(p=!0,s[s.length-1]=""),l=void 0}}})}catch(A){if(A!==r)throw A}return{path:s,previousNode:l,isAtPropertyKey:p,matches:A=>{let a=0;for(let R=0;a<A.length&&R<s.length;R++)if(A[a]===s[R]||A[a]==="*")a++;else if(A[a]!=="**")return!1;return a===A.length}}}e.getLocation=I;function o(t,i=[],s=y.DEFAULT){let r=null,l=[];const _=[];function p(A){Array.isArray(l)?l.push(A):r!==null&&(l[r]=A)}return u(t,{onObjectBegin:()=>{const A={};p(A),_.push(l),l=A,r=null},onObjectProperty:A=>{r=A},onObjectEnd:()=>{l=_.pop()},onArrayBegin:()=>{const A=[];p(A),_.push(l),l=A,r=null},onArrayEnd:()=>{l=_.pop()},onLiteralValue:p,onError:(A,a,R)=>{i.push({error:A,offset:a,length:R})}},s),l[0]}e.parse=o;function f(t,i=[],s=y.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(A){r.type==="property"&&(r.length=A-r.offset,r=r.parent)}function _(A){return r.children.push(A),A}u(t,{onObjectBegin:A=>{r=_({type:"object",offset:A,length:-1,parent:r,children:[]})},onObjectProperty:(A,a,R)=>{r=_({type:"property",offset:a,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:A,offset:a,length:R,parent:r})},onObjectEnd:(A,a)=>{r.length=A+a-r.offset,r=r.parent,l(A+a)},onArrayBegin:(A,a)=>{r=_({type:"array",offset:A,length:-1,parent:r,children:[]})},onArrayEnd:(A,a)=>{r.length=A+a-r.offset,r=r.parent,l(A+a)},onLiteralValue:(A,a,R)=>{_({type:g(A),offset:a,length:R,parent:r,value:A}),l(a+R)},onSeparator:(A,a,R)=>{r.type==="property"&&(A===":"?r.colonOffset=a:A===","&&l(a))},onError:(A,a,R)=>{i.push({error:A,offset:a,length:R})}},s);const P=r.children[0];return P&&delete P.parent,P}e.parseTree=f;function c(t,i){if(!t)return;let s=t;for(let r of i)if(typeof r=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let l=!1;for(const _ of s.children)if(Array.isArray(_.children)&&_.children[0].value===r){s=_.children[1],l=!0;break}if(!l)return}else{const l=r;if(s.type!=="array"||l<0||!Array.isArray(s.children)||l>=s.children.length)return;s=s.children[l]}return s}e.findNodeAtLocation=c;function d(t){if(!t.parent||!t.parent.children)return[];const i=d(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;i.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&i.push(s)}return i}e.getNodePath=d;function w(t){switch(t.type){case"array":return t.children.map(w);case"object":const i=Object.create(null);for(let s of t.children){const r=s.children[1];r&&(i[s.children[0].value]=w(r))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=w;function v(t,i,s=!1){return i>=t.offset&&i<t.offset+t.length||s&&i===t.offset+t.length}e.contains=v;function E(t,i,s=!1){if(v(t,i,s)){const r=t.children;if(Array.isArray(r))for(let l=0;l<r.length&&r[l].offset<=i;l++){const _=E(r[l],i,s);if(_)return _}return t}}e.findNodeAtOffset=E;function u(t,i,s=y.DEFAULT){const r=k(t,!1);function l(ge){return ge?()=>ge(r.getTokenOffset(),r.getTokenLength()):()=>!0}function _(ge){return ge?Ae=>ge(Ae,r.getTokenOffset(),r.getTokenLength()):()=>!0}const p=l(i.onObjectBegin),P=_(i.onObjectProperty),A=l(i.onObjectEnd),a=l(i.onArrayBegin),R=l(i.onArrayEnd),F=_(i.onLiteralValue),x=_(i.onSeparator),J=l(i.onComment),ae=_(i.onError),j=s&&s.disallowComments,W=s&&s.allowTrailingComma;function Q(){for(;;){const ge=r.scan();switch(r.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:j||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(ge){case 12:case 13:j?M(10):J();break;case 16:M(1);break;case 15:case 14:break;default:return ge}}}function M(ge,Ae=[],$e=[]){if(ae(ge),Ae.length+$e.length>0){let Fe=r.getToken();for(;Fe!==17;){if(Ae.indexOf(Fe)!==-1){Q();break}else if($e.indexOf(Fe)!==-1)break;Fe=Q()}}}function X(ge){const Ae=r.getTokenValue();return ge?F(Ae):P(Ae),Q(),!0}function B(){switch(r.getToken()){case 11:let ge=0;try{ge=JSON.parse(r.getTokenValue()),typeof ge!="number"&&(M(2),ge=0)}catch(Ae){M(2)}F(ge);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return Q(),!0}function U(){return r.getToken()!==10?(M(3,[],[2,5]),!1):(X(!1),r.getToken()===6?(x(":"),Q(),ce()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function Y(){p(),Q();let ge=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(ge||M(4,[],[]),x(","),Q(),r.getToken()===2&&W)break}else ge&&M(6,[],[]);U()||M(4,[],[2,5]),ge=!0}return A(),r.getToken()!==2?M(7,[2],[]):Q(),!0}function V(){a(),Q();let ge=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(ge||M(4,[],[]),x(","),Q(),r.getToken()===4&&W)break}else ge&&M(6,[],[]);ce()||M(4,[],[4,5]),ge=!0}return R(),r.getToken()!==4?M(8,[4],[]):Q(),!0}function ce(){switch(r.getToken()){case 3:return V();case 1:return Y();case 10:return X(!0);default:return B()}}return Q(),r.getToken()===17?s.allowEmptyContent?!0:(M(4,[],[]),!1):ce()?(r.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=u;function h(t,i){let s=k(t),r=[],l,_=0,p;do switch(p=s.getPosition(),l=s.scan(),l){case 12:case 13:case 17:_!==p&&r.push(t.substring(_,p)),i!==void 0&&r.push(s.getTokenValue().replace(/[^\r\n]/g,i)),_=s.getPosition();break}while(l!==17);return r.join("")}e.stripComments=h;function g(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(we[108],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(S){this.executor=S,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(S){this._error=S}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(S){return new m(()=>S(this.getValue()))}}e.Lazy=m}),define(we[7],_e([0,1,49,39]),function(ee,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const S=!1;let y=null;function k(h){y=h}if(e.setDisposableTracker=k,S){const h="__is_disposable_tracked__";y=new class{trackDisposable(g){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{g[h]||console.log(t)},3e3)}markTracked(g){if(g&&g!==d.None)try{g[h]=!0}catch(t){}}}}function D(h){!y||y.markTracked(h)}function b(h){return y&&y.trackDisposable(h),h}e.trackDisposable=b;class C extends Error{constructor(g){super(`Encountered errors while disposing of store. Errors: [${g.join(", ")}]`);this.errors=g}}e.MultiDisposeError=C;function n(h){return typeof h.dispose=="function"&&h.dispose.length===0}e.isDisposable=n;function I(h){if(T.Iterable.is(h)){let g=[];for(const t of h)if(t){D(t);try{t.dispose()}catch(i){g.push(i)}}if(g.length===1)throw g[0];if(g.length>1)throw new C(g);return Array.isArray(h)?[]:h}else if(h)return D(h),h.dispose(),h}e.dispose=I;function o(...h){return h.forEach(D),f(()=>I(h))}e.combinedDisposable=o;function f(h){const g=b({dispose:()=>{D(g),h()}});return g}e.toDisposable=f;class c{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(g){if(!g)return g;if(g===this)throw new Error("Cannot register a disposable on itself!");return D(g),this._isDisposed?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(g),g}}e.DisposableStore=c,c.DISABLE_DISPOSED_WARNING=!1;class d{constructor(){this._store=new c,b(this)}dispose(){D(this),this._store.dispose()}_register(g){if(g===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(g)}}e.Disposable=d,d.None=Object.freeze({dispose(){}});class w{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(g){var t;this._isDisposed||g===this._value||((t=this._value)===null||t===void 0||t.dispose(),g&&D(g),this._value=g)}clear(){this.value=void 0}dispose(){var g;this._isDisposed=!0,D(this),(g=this._value)===null||g===void 0||g.dispose(),this._value=void 0}}e.MutableDisposable=w;class v{constructor(){this.references=new Map}acquire(g,...t){let i=this.references.get(g);i||(i={counter:0,object:this.createReferencedObject(g,...t)},this.references.set(g,i));const{object:s}=i,r=m.once(()=>{--i.counter==0&&(this.destroyReferencedObject(g,i.object),this.references.delete(g))});return i.counter++,{object:s,dispose:r}}}e.ReferenceCollection=v;class E{constructor(g){this.referenceCollection=g}async acquire(g,...t){const i=this.referenceCollection.acquire(g,...t);try{return{object:await i.object,dispose:()=>i.dispose()}}catch(s){throw i.dispose(),s}}}e.AsyncReferenceCollection=E;class u{constructor(g){this.object=g}dispose(){}}e.ImmortalReference=u}),define(we[51],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(y){this.element=y,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class T{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let y=this._first;for(;y!==m.Undefined;){const k=y.next;y.prev=m.Undefined,y.next=m.Undefined,y=k}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,k){const D=new m(y);if(this._first===m.Undefined)this._first=D,this._last=D;else if(k){const C=this._last;this._last=D,D.prev=C,C.next=D}else{const C=this._first;this._first=D,D.next=C,C.prev=D}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(D))}}shift(){if(this._first!==m.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==m.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==m.Undefined&&y.next!==m.Undefined){const k=y.prev;k.next=y.next,y.next.prev=k}else y.prev===m.Undefined&&y.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):y.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):y.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==m.Undefined;)yield y.element,y=y.next}}e.LinkedList=T}),function(ee,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ee=typeof globalThis!="undefined"?globalThis:ee||self,ee.marked=e())}(this,function(){"use strict";function ee(Se,be){for(var Ce=0;Ce<be.length;Ce++){var re=be[Ce];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(Se,re.key,re)}}function e(Se,be,Ce){return be&&ee(Se.prototype,be),Ce&&ee(Se,Ce),Se}function m(Se,be){if(!!Se){if(typeof Se=="string")return T(Se,be);var Ce=Object.prototype.toString.call(Se).slice(8,-1);if(Ce==="Object"&&Se.constructor&&(Ce=Se.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(Se);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return T(Se,be)}}function T(Se,be){(be==null||be>Se.length)&&(be=Se.length);for(var Ce=0,re=new Array(be);Ce<be;Ce++)re[Ce]=Se[Ce];return re}function S(Se,be){var Ce;if(typeof Symbol=="undefined"||Se[Symbol.iterator]==null){if(Array.isArray(Se)||(Ce=m(Se))||be&&Se&&typeof Se.length=="number"){Ce&&(Se=Ce);var re=0;return function(){return re>=Se.length?{done:!0}:{done:!1,value:Se[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Ce=Se[Symbol.iterator](),Ce.next.bind(Ce)}function y(Se){var be={exports:{}};return Se(be,be.exports),be.exports}var k=y(function(Se){function be(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Ce(re){Se.exports.defaults=re}Se.exports={defaults:be(),getDefaults:be,changeDefaults:Ce}}),D=/[&<>"']/,b=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,n=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},o=function(be){return I[be]};function f(Se,be){if(be){if(D.test(Se))return Se.replace(b,o)}else if(C.test(Se))return Se.replace(n,o);return Se}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(Se){return Se.replace(c,function(be,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var w=/(^|[^\[])\^/g;function v(Se,be){Se=Se.source||Se,be=be||"";var Ce={replace:function(de,N){return N=N.source||N,N=N.replace(w,"$1"),Se=Se.replace(de,N),Ce},getRegex:function(){return new RegExp(Se,be)}};return Ce}var E=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Se,be,Ce){if(Se){var re;try{re=decodeURIComponent(d(Ce)).replace(E,"").toLowerCase()}catch(de){return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}be&&!u.test(Ce)&&(Ce=r(be,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(de){return null}return Ce}var g={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(Se,be){g[" "+Se]||(t.test(Se)?g[" "+Se]=Se+"/":g[" "+Se]=P(Se,"/",!0)),Se=g[" "+Se];var Ce=Se.indexOf(":")===-1;return be.substring(0,2)==="//"?Ce?be:Se.replace(i,"$1")+be:be.charAt(0)==="/"?Ce?be:Se.replace(s,"$1")+be:Se+be}var l={exec:function(){}};function _(Se){for(var be=1,Ce,re;be<arguments.length;be++){Ce=arguments[be];for(re in Ce)Object.prototype.hasOwnProperty.call(Ce,re)&&(Se[re]=Ce[re])}return Se}function p(Se,be){var Ce=Se.replace(/\|/g,function(N,G,le){for(var ke=!1,Pe=G;--Pe>=0&&le[Pe]==="\\";)ke=!ke;return ke?"|":" |"}),re=Ce.split(/ \|/),de=0;if(re.length>be)re.splice(be);else for(;re.length<be;)re.push("");for(;de<re.length;de++)re[de]=re[de].trim().replace(/\\\|/g,"|");return re}function P(Se,be,Ce){var re=Se.length;if(re===0)return"";for(var de=0;de<re;){var N=Se.charAt(re-de-1);if(N===be&&!Ce)de++;else if(N!==be&&Ce)de++;else break}return Se.substr(0,re-de)}function A(Se,be){if(Se.indexOf(be[1])===-1)return-1;for(var Ce=Se.length,re=0,de=0;de<Ce;de++)if(Se[de]==="\\")de++;else if(Se[de]===be[0])re++;else if(Se[de]===be[1]&&(re--,re<0))return de;return-1}function a(Se){Se&&Se.sanitize&&!Se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(Se,be){if(be<1)return"";for(var Ce="";be>1;)be&1&&(Ce+=Se),be>>=1,Se+=Se;return Ce+Se}var F={escape:f,unescape:d,edit:v,cleanUrl:h,resolveUrl:r,noopTest:l,merge:_,splitCells:p,rtrim:P,findClosingBracket:A,checkSanitizeDeprecation:a,repeatString:R},x=k.defaults,J=F.rtrim,ae=F.splitCells,j=F.escape,W=F.findClosingBracket;function Q(Se,be,Ce){var re=be.href,de=be.title?j(be.title):null,N=Se[1].replace(/\\([\[\]])/g,"$1");return Se[0].charAt(0)!=="!"?{type:"link",raw:Ce,href:re,title:de,text:N}:{type:"image",raw:Ce,href:re,title:de,text:j(N)}}function M(Se,be){var Ce=Se.match(/^(\s+)(?:```)/);if(Ce===null)return be;var re=Ce[1];return be.split(`
`).map(function(de){var N=de.match(/^\s+/);if(N===null)return de;var G=N[0];return G.length>=re.length?de.slice(re.length):de}).join(`
`)}var X=function(){function Se(Ce){this.options=Ce||x}var be=Se.prototype;return be.space=function(re){var de=this.rules.block.newline.exec(re);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},be.code=function(re){var de=this.rules.block.code.exec(re);if(de){var N=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?N:J(N,`
`)}}},be.fences=function(re){var de=this.rules.block.fences.exec(re);if(de){var N=de[0],G=M(N,de[3]||"");return{type:"code",raw:N,lang:de[2]?de[2].trim():de[2],text:G}}},be.heading=function(re){var de=this.rules.block.heading.exec(re);if(de){var N=de[2].trim();if(/#$/.test(N)){var G=J(N,"#");(this.options.pedantic||!G||/ $/.test(G))&&(N=G.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:N}}},be.nptable=function(re){var de=this.rules.block.nptable.exec(re);if(de){var N={type:"table",header:ae(de[1].replace(/^ *| *\| *$/g,"")),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:de[3]?de[3].replace(/\n$/,"").split(`
`):[],raw:de[0]};if(N.header.length===N.align.length){var G=N.align.length,le;for(le=0;le<G;le++)/^ *-+: *$/.test(N.align[le])?N.align[le]="right":/^ *:-+: *$/.test(N.align[le])?N.align[le]="center":/^ *:-+ *$/.test(N.align[le])?N.align[le]="left":N.align[le]=null;for(G=N.cells.length,le=0;le<G;le++)N.cells[le]=ae(N.cells[le],N.header.length);return N}}},be.hr=function(re){var de=this.rules.block.hr.exec(re);if(de)return{type:"hr",raw:de[0]}},be.blockquote=function(re){var de=this.rules.block.blockquote.exec(re);if(de){var N=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],text:N}}},be.list=function(re){var de=this.rules.block.list.exec(re);if(de){var N=de[0],G=de[2],le=G.length>1,ke={type:"list",raw:N,ordered:le,start:le?+G.slice(0,-1):"",loose:!1,items:[]},Pe=de[0].match(this.rules.block.item),Ne=!1,Be,Ze,Je,Ye,nt,gt,ve,ye,ue=Pe.length;Je=this.rules.block.listItemStart.exec(Pe[0]);for(var z=0;z<ue;z++){if(Be=Pe[z],N=Be,z!==ue-1){if(Ye=this.rules.block.listItemStart.exec(Pe[z+1]),this.options.pedantic?Ye[1].length>Je[1].length:Ye[1].length>Je[0].length||Ye[1].length>3){Pe.splice(z,2,Pe[z]+`
`+Pe[z+1]),z--,ue--;continue}else(!this.options.pedantic||this.options.smartLists?Ye[2][Ye[2].length-1]!==G[G.length-1]:le===(Ye[2].length===1))&&(nt=Pe.slice(z+1).join(`
`),ke.raw=ke.raw.substring(0,ke.raw.length-nt.length),z=ue-1);Je=Ye}Ze=Be.length,Be=Be.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Be.indexOf(`
 `)&&(Ze-=Be.length,Be=this.options.pedantic?Be.replace(/^ {1,4}/gm,""):Be.replace(new RegExp("^ {1,"+Ze+"}","gm"),"")),gt=Ne||/\n\n(?!\s*$)/.test(Be),z!==ue-1&&(Ne=Be.charAt(Be.length-1)===`
`,gt||(gt=Ne)),gt&&(ke.loose=!0),this.options.gfm&&(ve=/^\[[ xX]\] /.test(Be),ye=void 0,ve&&(ye=Be[1]!==" ",Be=Be.replace(/^\[[ xX]\] +/,""))),ke.items.push({type:"list_item",raw:N,task:ve,checked:ye,loose:gt,text:Be})}return ke}},be.html=function(re){var de=this.rules.block.html.exec(re);if(de)return{type:this.options.sanitize?"paragraph":"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):j(de[0]):de[0]}},be.def=function(re){var de=this.rules.block.def.exec(re);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var N=de[1].toLowerCase().replace(/\s+/g," ");return{tag:N,raw:de[0],href:de[2],title:de[3]}}},be.table=function(re){var de=this.rules.block.table.exec(re);if(de){var N={type:"table",header:ae(de[1].replace(/^ *| *\| *$/g,"")),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(N.header.length===N.align.length){N.raw=de[0];var G=N.align.length,le;for(le=0;le<G;le++)/^ *-+: *$/.test(N.align[le])?N.align[le]="right":/^ *:-+: *$/.test(N.align[le])?N.align[le]="center":/^ *:-+ *$/.test(N.align[le])?N.align[le]="left":N.align[le]=null;for(G=N.cells.length,le=0;le<G;le++)N.cells[le]=ae(N.cells[le].replace(/^ *\| *| *\| *$/g,""),N.header.length);return N}}},be.lheading=function(re){var de=this.rules.block.lheading.exec(re);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1]}},be.paragraph=function(re){var de=this.rules.block.paragraph.exec(re);if(de)return{type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1]}},be.text=function(re){var de=this.rules.block.text.exec(re);if(de)return{type:"text",raw:de[0],text:de[0]}},be.escape=function(re){var de=this.rules.inline.escape.exec(re);if(de)return{type:"escape",raw:de[0],text:j(de[1])}},be.tag=function(re,de,N){var G=this.rules.inline.tag.exec(re);if(G)return!de&&/^<a /i.test(G[0])?de=!0:de&&/^<\/a>/i.test(G[0])&&(de=!1),!N&&/^<(pre|code|kbd|script)(\s|>)/i.test(G[0])?N=!0:N&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(G[0])&&(N=!1),{type:this.options.sanitize?"text":"html",raw:G[0],inLink:de,inRawBlock:N,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(G[0]):j(G[0]):G[0]}},be.link=function(re){var de=this.rules.inline.link.exec(re);if(de){var N=de[2].trim();if(!this.options.pedantic&&/^</.test(N)){if(!/>$/.test(N))return;var G=J(N.slice(0,-1),"\\");if((N.length-G.length)%2==0)return}else{var le=W(de[2],"()");if(le>-1){var ke=de[0].indexOf("!")===0?5:4,Pe=ke+de[1].length+le;de[2]=de[2].substring(0,le),de[0]=de[0].substring(0,Pe).trim(),de[3]=""}}var Ne=de[2],Be="";if(this.options.pedantic){var Ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ne);Ze&&(Ne=Ze[1],Be=Ze[3])}else Be=de[3]?de[3].slice(1,-1):"";return Ne=Ne.trim(),/^</.test(Ne)&&(this.options.pedantic&&!/>$/.test(N)?Ne=Ne.slice(1):Ne=Ne.slice(1,-1)),Q(de,{href:Ne&&Ne.replace(this.rules.inline._escapes,"$1"),title:Be&&Be.replace(this.rules.inline._escapes,"$1")},de[0])}},be.reflink=function(re,de){var N;if((N=this.rules.inline.reflink.exec(re))||(N=this.rules.inline.nolink.exec(re))){var G=(N[2]||N[1]).replace(/\s+/g," ");if(G=de[G.toLowerCase()],!G||!G.href){var le=N[0].charAt(0);return{type:"text",raw:le,text:le}}return Q(N,G,N[0])}},be.emStrong=function(re,de,N){N===void 0&&(N="");var G=this.rules.inline.emStrong.lDelim.exec(re);if(!!G&&!(G[3]&&N.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var le=G[1]||G[2]||"";if(!le||le&&(N===""||this.rules.inline.punctuation.exec(N))){var ke=G[0].length-1,Pe,Ne,Be=ke,Ze=0,Je=G[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Je.lastIndex=0,de=de.slice(-1*re.length+ke);(G=Je.exec(de))!=null;)if(Pe=G[1]||G[2]||G[3]||G[4]||G[5]||G[6],!!Pe){if(Ne=Pe.length,G[3]||G[4]){Be+=Ne;continue}else if((G[5]||G[6])&&ke%3&&!((ke+Ne)%3)){Ze+=Ne;continue}if(Be-=Ne,!(Be>0)){if(Be+Ze-Ne<=0&&!de.slice(Je.lastIndex).match(Je)&&(Ne=Math.min(Ne,Ne+Be+Ze)),Math.min(ke,Ne)%2)return{type:"em",raw:re.slice(0,ke+G.index+Ne+1),text:re.slice(1,ke+G.index+Ne)};if(Math.min(ke,Ne)%2==0)return{type:"strong",raw:re.slice(0,ke+G.index+Ne+1),text:re.slice(2,ke+G.index+Ne-1)}}}}}},be.codespan=function(re){var de=this.rules.inline.code.exec(re);if(de){var N=de[2].replace(/\n/g," "),G=/[^ ]/.test(N),le=/^ /.test(N)&&/ $/.test(N);return G&&le&&(N=N.substring(1,N.length-1)),N=j(N,!0),{type:"codespan",raw:de[0],text:N}}},be.br=function(re){var de=this.rules.inline.br.exec(re);if(de)return{type:"br",raw:de[0]}},be.del=function(re){var de=this.rules.inline.del.exec(re);if(de)return{type:"del",raw:de[0],text:de[2]}},be.autolink=function(re,de){var N=this.rules.inline.autolink.exec(re);if(N){var G,le;return N[2]==="@"?(G=j(this.options.mangle?de(N[1]):N[1]),le="mailto:"+G):(G=j(N[1]),le=G),{type:"link",raw:N[0],text:G,href:le,tokens:[{type:"text",raw:G,text:G}]}}},be.url=function(re,de){var N;if(N=this.rules.inline.url.exec(re)){var G,le;if(N[2]==="@")G=j(this.options.mangle?de(N[0]):N[0]),le="mailto:"+G;else{var ke;do ke=N[0],N[0]=this.rules.inline._backpedal.exec(N[0])[0];while(ke!==N[0]);G=j(N[0]),N[1]==="www."?le="http://"+G:le=G}return{type:"link",raw:N[0],text:G,href:le,tokens:[{type:"text",raw:G,text:G}]}}},be.inlineText=function(re,de,N){var G=this.rules.inline.text.exec(re);if(G){var le;return de?le=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(G[0]):j(G[0]):G[0]:le=j(this.options.smartypants?N(G[0]):G[0]),{type:"text",raw:G[0],text:le}}},Se}(),B=F.noopTest,U=F.edit,Y=F.merge,V={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:B,table:B,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};V._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,V._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,V.def=U(V.def).replace("label",V._label).replace("title",V._title).getRegex(),V.bullet=/(?:[*+-]|\d{1,9}[.)])/,V.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,V.item=U(V.item,"gm").replace(/bull/g,V.bullet).getRegex(),V.listItemStart=U(/^( *)(bull)/).replace("bull",V.bullet).getRegex(),V.list=U(V.list).replace(/bull/g,V.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+V.def.source+")").getRegex(),V._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",V._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,V.html=U(V.html,"i").replace("comment",V._comment).replace("tag",V._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),V.paragraph=U(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",V._tag).getRegex(),V.blockquote=U(V.blockquote).replace("paragraph",V.paragraph).getRegex(),V.normal=Y({},V),V.gfm=Y({},V.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),V.gfm.nptable=U(V.gfm.nptable).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",V._tag).getRegex(),V.gfm.table=U(V.gfm.table).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",V._tag).getRegex(),V.pedantic=Y({},V.normal,{html:U(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",V._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:B,paragraph:U(V.normal._paragraph).replace("hr",V.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",V.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ce={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:B,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:B,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ce._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ce.punctuation=U(ce.punctuation).replace(/punctuation/g,ce._punctuation).getRegex(),ce.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ce.escapedEmSt=/\\\*|\\_/g,ce._comment=U(V._comment).replace("(?:-->|$)","-->").getRegex(),ce.emStrong.lDelim=U(ce.emStrong.lDelim).replace(/punct/g,ce._punctuation).getRegex(),ce.emStrong.rDelimAst=U(ce.emStrong.rDelimAst,"g").replace(/punct/g,ce._punctuation).getRegex(),ce.emStrong.rDelimUnd=U(ce.emStrong.rDelimUnd,"g").replace(/punct/g,ce._punctuation).getRegex(),ce._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ce._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ce._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ce.autolink=U(ce.autolink).replace("scheme",ce._scheme).replace("email",ce._email).getRegex(),ce._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ce.tag=U(ce.tag).replace("comment",ce._comment).replace("attribute",ce._attribute).getRegex(),ce._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ce._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ce._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ce.link=U(ce.link).replace("label",ce._label).replace("href",ce._href).replace("title",ce._title).getRegex(),ce.reflink=U(ce.reflink).replace("label",ce._label).getRegex(),ce.reflinkSearch=U(ce.reflinkSearch,"g").replace("reflink",ce.reflink).replace("nolink",ce.nolink).getRegex(),ce.normal=Y({},ce),ce.pedantic=Y({},ce.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:U(/^!?\[(label)\]\((.*?)\)/).replace("label",ce._label).getRegex(),reflink:U(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ce._label).getRegex()}),ce.gfm=Y({},ce.normal,{escape:U(ce.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),ce.gfm.url=U(ce.gfm.url,"i").replace("email",ce.gfm._extended_email).getRegex(),ce.breaks=Y({},ce.gfm,{br:U(ce.br).replace("{2,}","*").getRegex(),text:U(ce.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ge={block:V,inline:ce},Ae=k.defaults,$e=ge.block,Fe=ge.inline,Ve=F.repeatString;function tt(Se){return Se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ke(Se){var be="",Ce,re,de=Se.length;for(Ce=0;Ce<de;Ce++)re=Se.charCodeAt(Ce),Math.random()>.5&&(re="x"+re.toString(16)),be+="&#"+re+";";return be}var Qe=function(){function Se(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||Ae,this.options.tokenizer=this.options.tokenizer||new X,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var re={block:$e.normal,inline:Fe.normal};this.options.pedantic?(re.block=$e.pedantic,re.inline=Fe.pedantic):this.options.gfm&&(re.block=$e.gfm,this.options.breaks?re.inline=Fe.breaks:re.inline=Fe.gfm),this.tokenizer.rules=re}Se.lex=function(re,de){var N=new Se(de);return N.lex(re)},Se.lexInline=function(re,de){var N=new Se(de);return N.inlineTokens(re)};var be=Se.prototype;return be.lex=function(re){return re=re.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(re,this.tokens,!0),this.inline(this.tokens),this.tokens},be.blockTokens=function(re,de,N){de===void 0&&(de=[]),N===void 0&&(N=!0),this.options.pedantic&&(re=re.replace(/^ +$/gm,""));for(var G,le,ke,Pe;re;){if(G=this.tokenizer.space(re)){re=re.substring(G.raw.length),G.type&&de.push(G);continue}if(G=this.tokenizer.code(re)){re=re.substring(G.raw.length),Pe=de[de.length-1],Pe&&Pe.type==="paragraph"?(Pe.raw+=`
`+G.raw,Pe.text+=`
`+G.text):de.push(G);continue}if(G=this.tokenizer.fences(re)){re=re.substring(G.raw.length),de.push(G);continue}if(G=this.tokenizer.heading(re)){re=re.substring(G.raw.length),de.push(G);continue}if(G=this.tokenizer.nptable(re)){re=re.substring(G.raw.length),de.push(G);continue}if(G=this.tokenizer.hr(re)){re=re.substring(G.raw.length),de.push(G);continue}if(G=this.tokenizer.blockquote(re)){re=re.substring(G.raw.length),G.tokens=this.blockTokens(G.text,[],N),de.push(G);continue}if(G=this.tokenizer.list(re)){for(re=re.substring(G.raw.length),ke=G.items.length,le=0;le<ke;le++)G.items[le].tokens=this.blockTokens(G.items[le].text,[],!1);de.push(G);continue}if(G=this.tokenizer.html(re)){re=re.substring(G.raw.length),de.push(G);continue}if(N&&(G=this.tokenizer.def(re))){re=re.substring(G.raw.length),this.tokens.links[G.tag]||(this.tokens.links[G.tag]={href:G.href,title:G.title});continue}if(G=this.tokenizer.table(re)){re=re.substring(G.raw.length),de.push(G);continue}if(G=this.tokenizer.lheading(re)){re=re.substring(G.raw.length),de.push(G);continue}if(N&&(G=this.tokenizer.paragraph(re))){re=re.substring(G.raw.length),de.push(G);continue}if(G=this.tokenizer.text(re)){re=re.substring(G.raw.length),Pe=de[de.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+G.raw,Pe.text+=`
`+G.text):de.push(G);continue}if(re){var Ne="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(Ne);break}else throw new Error(Ne)}}return de},be.inline=function(re){var de,N,G,le,ke,Pe,Ne=re.length;for(de=0;de<Ne;de++)switch(Pe=re[de],Pe.type){case"paragraph":case"text":case"heading":{Pe.tokens=[],this.inlineTokens(Pe.text,Pe.tokens);break}case"table":{for(Pe.tokens={header:[],cells:[]},le=Pe.header.length,N=0;N<le;N++)Pe.tokens.header[N]=[],this.inlineTokens(Pe.header[N],Pe.tokens.header[N]);for(le=Pe.cells.length,N=0;N<le;N++)for(ke=Pe.cells[N],Pe.tokens.cells[N]=[],G=0;G<ke.length;G++)Pe.tokens.cells[N][G]=[],this.inlineTokens(ke[G],Pe.tokens.cells[N][G]);break}case"blockquote":{this.inline(Pe.tokens);break}case"list":{for(le=Pe.items.length,N=0;N<le;N++)this.inline(Pe.items[N].tokens);break}}return re},be.inlineTokens=function(re,de,N,G){de===void 0&&(de=[]),N===void 0&&(N=!1),G===void 0&&(G=!1);var le,ke,Pe=re,Ne,Be,Ze;if(this.tokens.links){var Je=Object.keys(this.tokens.links);if(Je.length>0)for(;(Ne=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)Je.includes(Ne[0].slice(Ne[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Ne.index)+"["+Ve("a",Ne[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ne=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Ne.index)+"["+Ve("a",Ne[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ne=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Ne.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;){if(Be||(Ze=""),Be=!1,le=this.tokenizer.escape(re)){re=re.substring(le.raw.length),de.push(le);continue}if(le=this.tokenizer.tag(re,N,G)){re=re.substring(le.raw.length),N=le.inLink,G=le.inRawBlock;var Ye=de[de.length-1];Ye&&le.type==="text"&&Ye.type==="text"?(Ye.raw+=le.raw,Ye.text+=le.text):de.push(le);continue}if(le=this.tokenizer.link(re)){re=re.substring(le.raw.length),le.type==="link"&&(le.tokens=this.inlineTokens(le.text,[],!0,G)),de.push(le);continue}if(le=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(le.raw.length);var nt=de[de.length-1];le.type==="link"?(le.tokens=this.inlineTokens(le.text,[],!0,G),de.push(le)):nt&&le.type==="text"&&nt.type==="text"?(nt.raw+=le.raw,nt.text+=le.text):de.push(le);continue}if(le=this.tokenizer.emStrong(re,Pe,Ze)){re=re.substring(le.raw.length),le.tokens=this.inlineTokens(le.text,[],N,G),de.push(le);continue}if(le=this.tokenizer.codespan(re)){re=re.substring(le.raw.length),de.push(le);continue}if(le=this.tokenizer.br(re)){re=re.substring(le.raw.length),de.push(le);continue}if(le=this.tokenizer.del(re)){re=re.substring(le.raw.length),le.tokens=this.inlineTokens(le.text,[],N,G),de.push(le);continue}if(le=this.tokenizer.autolink(re,Ke)){re=re.substring(le.raw.length),de.push(le);continue}if(!N&&(le=this.tokenizer.url(re,Ke))){re=re.substring(le.raw.length),de.push(le);continue}if(le=this.tokenizer.inlineText(re,G,tt)){re=re.substring(le.raw.length),le.raw.slice(-1)!=="_"&&(Ze=le.raw.slice(-1)),Be=!0,ke=de[de.length-1],ke&&ke.type==="text"?(ke.raw+=le.raw,ke.text+=le.text):de.push(le);continue}if(re){var gt="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(gt);break}else throw new Error(gt)}}return de},e(Se,null,[{key:"rules",get:function(){return{block:$e,inline:Fe}}}]),Se}(),$=k.defaults,K=F.cleanUrl,ie=F.escape,se=function(){function Se(Ce){this.options=Ce||$}var be=Se.prototype;return be.code=function(re,de,N){var G=(de||"").match(/\S*/)[0];if(this.options.highlight){var le=this.options.highlight(re,G);le!=null&&le!==re&&(N=!0,re=le)}return re=re.replace(/\n$/,"")+`
`,G?'<pre><code class="'+this.options.langPrefix+ie(G,!0)+'">'+(N?re:ie(re,!0))+`</code></pre>
`:"<pre><code>"+(N?re:ie(re,!0))+`</code></pre>
`},be.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},be.html=function(re){return re},be.heading=function(re,de,N,G){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+G.slug(N)+'">'+re+"</h"+de+`>
`:"<h"+de+">"+re+"</h"+de+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(re,de,N){var G=de?"ol":"ul",le=de&&N!==1?' start="'+N+'"':"";return"<"+G+le+`>
`+re+"</"+G+`>
`},be.listitem=function(re){return"<li>"+re+`</li>
`},be.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(re){return"<p>"+re+`</p>
`},be.table=function(re,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+de+`</table>
`},be.tablerow=function(re){return`<tr>
`+re+`</tr>
`},be.tablecell=function(re,de){var N=de.header?"th":"td",G=de.align?"<"+N+' align="'+de.align+'">':"<"+N+">";return G+re+"</"+N+`>
`},be.strong=function(re){return"<strong>"+re+"</strong>"},be.em=function(re){return"<em>"+re+"</em>"},be.codespan=function(re){return"<code>"+re+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(re){return"<del>"+re+"</del>"},be.link=function(re,de,N){if(re=K(this.options.sanitize,this.options.baseUrl,re),re===null)return N;var G='<a href="'+ie(re)+'"';return de&&(G+=' title="'+de+'"'),G+=">"+N+"</a>",G},be.image=function(re,de,N){if(re=K(this.options.sanitize,this.options.baseUrl,re),re===null)return N;var G='<img src="'+re+'" alt="'+N+'"';return de&&(G+=' title="'+de+'"'),G+=this.options.xhtml?"/>":">",G},be.text=function(re){return re},Se}(),q=function(){function Se(){}var be=Se.prototype;return be.strong=function(re){return re},be.em=function(re){return re},be.codespan=function(re){return re},be.del=function(re){return re},be.html=function(re){return re},be.text=function(re){return re},be.link=function(re,de,N){return""+N},be.image=function(re,de,N){return""+N},be.br=function(){return""},Se}(),oe=function(){function Se(){this.seen={}}var be=Se.prototype;return be.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(re,de){var N=re,G=0;if(this.seen.hasOwnProperty(N)){G=this.seen[re];do G++,N=re+"-"+G;while(this.seen.hasOwnProperty(N))}return de||(this.seen[re]=G,this.seen[N]=0),N},be.slug=function(re,de){de===void 0&&(de={});var N=this.serialize(re);return this.getNextSafeSlug(N,de.dryrun)},Se}(),fe=k.defaults,Re=F.unescape,xe=function(){function Se(Ce){this.options=Ce||fe,this.options.renderer=this.options.renderer||new se,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new q,this.slugger=new oe}Se.parse=function(re,de){var N=new Se(de);return N.parse(re)},Se.parseInline=function(re,de){var N=new Se(de);return N.parseInline(re)};var be=Se.prototype;return be.parse=function(re,de){de===void 0&&(de=!0);var N="",G,le,ke,Pe,Ne,Be,Ze,Je,Ye,nt,gt,ve,ye,ue,z,Oe,Ee,We,Xe=re.length;for(G=0;G<Xe;G++)switch(nt=re[G],nt.type){case"space":continue;case"hr":{N+=this.renderer.hr();continue}case"heading":{N+=this.renderer.heading(this.parseInline(nt.tokens),nt.depth,Re(this.parseInline(nt.tokens,this.textRenderer)),this.slugger);continue}case"code":{N+=this.renderer.code(nt.text,nt.lang,nt.escaped);continue}case"table":{for(Je="",Ze="",Pe=nt.header.length,le=0;le<Pe;le++)Ze+=this.renderer.tablecell(this.parseInline(nt.tokens.header[le]),{header:!0,align:nt.align[le]});for(Je+=this.renderer.tablerow(Ze),Ye="",Pe=nt.cells.length,le=0;le<Pe;le++){for(Be=nt.tokens.cells[le],Ze="",Ne=Be.length,ke=0;ke<Ne;ke++)Ze+=this.renderer.tablecell(this.parseInline(Be[ke]),{header:!1,align:nt.align[ke]});Ye+=this.renderer.tablerow(Ze)}N+=this.renderer.table(Je,Ye);continue}case"blockquote":{Ye=this.parse(nt.tokens),N+=this.renderer.blockquote(Ye);continue}case"list":{for(gt=nt.ordered,ve=nt.start,ye=nt.loose,Pe=nt.items.length,Ye="",le=0;le<Pe;le++)z=nt.items[le],Oe=z.checked,Ee=z.task,ue="",z.task&&(We=this.renderer.checkbox(Oe),ye?z.tokens.length>0&&z.tokens[0].type==="text"?(z.tokens[0].text=We+" "+z.tokens[0].text,z.tokens[0].tokens&&z.tokens[0].tokens.length>0&&z.tokens[0].tokens[0].type==="text"&&(z.tokens[0].tokens[0].text=We+" "+z.tokens[0].tokens[0].text)):z.tokens.unshift({type:"text",text:We}):ue+=We),ue+=this.parse(z.tokens,ye),Ye+=this.renderer.listitem(ue,Ee,Oe);N+=this.renderer.list(Ye,gt,ve);continue}case"html":{N+=this.renderer.html(nt.text);continue}case"paragraph":{N+=this.renderer.paragraph(this.parseInline(nt.tokens));continue}case"text":{for(Ye=nt.tokens?this.parseInline(nt.tokens):nt.text;G+1<Xe&&re[G+1].type==="text";)nt=re[++G],Ye+=`
`+(nt.tokens?this.parseInline(nt.tokens):nt.text);N+=de?this.renderer.paragraph(Ye):Ye;continue}default:{var et='Token with "'+nt.type+'" type was not found.';if(this.options.silent){console.error(et);return}else throw new Error(et)}}return N},be.parseInline=function(re,de){de=de||this.renderer;var N="",G,le,ke=re.length;for(G=0;G<ke;G++)switch(le=re[G],le.type){case"escape":{N+=de.text(le.text);break}case"html":{N+=de.html(le.text);break}case"link":{N+=de.link(le.href,le.title,this.parseInline(le.tokens,de));break}case"image":{N+=de.image(le.href,le.title,le.text);break}case"strong":{N+=de.strong(this.parseInline(le.tokens,de));break}case"em":{N+=de.em(this.parseInline(le.tokens,de));break}case"codespan":{N+=de.codespan(le.text);break}case"br":{N+=de.br();break}case"del":{N+=de.del(this.parseInline(le.tokens,de));break}case"text":{N+=de.text(le.text);break}default:{var Pe='Token with "'+le.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}return N},Se}(),pe=F.merge,qe=F.checkSanitizeDeprecation,H=F.escape,te=k.getDefaults,me=k.changeDefaults,Te=k.defaults;function Le(Se,be,Ce){if(typeof Se=="undefined"||Se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");if(typeof be=="function"&&(Ce=be,be=null),be=pe({},Le.defaults,be||{}),qe(be),Ce){var re=be.highlight,de;try{de=Qe.lex(Se,be)}catch(ke){return Ce(ke)}var N=function(Pe){var Ne;if(!Pe)try{Ne=xe.parse(de,be)}catch(Be){Pe=Be}return be.highlight=re,Pe?Ce(Pe):Ce(null,Ne)};if(!re||re.length<3||(delete be.highlight,!de.length))return N();var G=0;Le.walkTokens(de,function(ke){ke.type==="code"&&(G++,setTimeout(function(){re(ke.text,ke.lang,function(Pe,Ne){if(Pe)return N(Pe);Ne!=null&&Ne!==ke.text&&(ke.text=Ne,ke.escaped=!0),G--,G===0&&N()})},0))}),G===0&&N();return}try{var le=Qe.lex(Se,be);return be.walkTokens&&Le.walkTokens(le,be.walkTokens),xe.parse(le,be)}catch(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+H(ke.message+"",!0)+"</pre>";throw ke}}Le.options=Le.setOptions=function(Se){return pe(Le.defaults,Se),me(Le.defaults),Le},Le.getDefaults=te,Le.defaults=Te,Le.use=function(Se){var be=pe({},Se);if(Se.renderer&&function(){var re=Le.defaults.renderer||new se,de=function(le){var ke=re[le];re[le]=function(){for(var Pe=arguments.length,Ne=new Array(Pe),Be=0;Be<Pe;Be++)Ne[Be]=arguments[Be];var Ze=Se.renderer[le].apply(re,Ne);return Ze===!1&&(Ze=ke.apply(re,Ne)),Ze}};for(var N in Se.renderer)de(N);be.renderer=re}(),Se.tokenizer&&function(){var re=Le.defaults.tokenizer||new X,de=function(le){var ke=re[le];re[le]=function(){for(var Pe=arguments.length,Ne=new Array(Pe),Be=0;Be<Pe;Be++)Ne[Be]=arguments[Be];var Ze=Se.tokenizer[le].apply(re,Ne);return Ze===!1&&(Ze=ke.apply(re,Ne)),Ze}};for(var N in Se.tokenizer)de(N);be.tokenizer=re}(),Se.walkTokens){var Ce=Le.defaults.walkTokens;be.walkTokens=function(re){Se.walkTokens(re),Ce&&Ce(re)}}Le.setOptions(be)},Le.walkTokens=function(Se,be){for(var Ce=S(Se),re;!(re=Ce()).done;){var de=re.value;switch(be(de),de.type){case"table":{for(var N=S(de.tokens.header),G;!(G=N()).done;){var le=G.value;Le.walkTokens(le,be)}for(var ke=S(de.tokens.cells),Pe;!(Pe=ke()).done;)for(var Ne=Pe.value,Be=S(Ne),Ze;!(Ze=Be()).done;){var Je=Ze.value;Le.walkTokens(Je,be)}break}case"list":{Le.walkTokens(de.items,be);break}default:de.tokens&&Le.walkTokens(de.tokens,be)}}},Le.parseInline=function(Se,be){if(typeof Se=="undefined"||Se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");be=pe({},Le.defaults,be||{}),qe(be);try{var Ce=Qe.lexInline(Se,be);return be.walkTokens&&Le.walkTokens(Ce,be.walkTokens),xe.parseInline(Ce,be)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+H(re.message+"",!0)+"</pre>";throw re}},Le.Parser=xe,Le.parser=xe.parse,Le.Renderer=se,Le.TextRenderer=q,Le.Lexer=Qe,Le.lexer=Qe.lex,Le.Tokenizer=X,Le.Slugger=oe,Le.parse=Le;var Ge=Le;return Ge}),define(we[76],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function m(k,D,b){return Math.min(Math.max(k,D),b)}e.clamp=m;function T(k,D){return(D+k%D)%D}e.rot=T;class S{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=S;class y{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=y}),function(){function ee(S){const y=[];typeof S=="number"&&y.push("code/timeOrigin",S);function k(b){y.push(b,Date.now())}function D(){const b=[];for(let C=0;C<y.length;C+=2)b.push({name:y[C],startTime:y[C+1]});return b}return{mark:k,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const y=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const k of performance.getEntriesByType("mark"))y.push({name:k.name,startTime:Math.round(S+k.startTime)});return y}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function m(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=m(T))}(),define(we[21],_e([0,1]),function(ee,e){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const T="en";let S=!1,y=!1,k=!1,D=!1,b=!1,C=!1,n=!1,I,o=T,f,c;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const w=typeof((m=d==null?void 0:d.versions)===null||m===void 0?void 0:m.electron)=="string"&&d.type==="renderer";if(e.isElectronSandboxed=w&&(d==null?void 0:d.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=d==null?void 0:d.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!w)c=navigator.userAgent,S=c.indexOf("Windows")>=0,y=c.indexOf("Macintosh")>=0,n=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=c.indexOf("Linux")>=0,C=!0,I=navigator.language,o=I;else if(typeof d=="object"){S=d.platform==="win32",y=d.platform==="darwin",k=d.platform==="linux",D=k&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,I=T,o=T;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const l=JSON.parse(r),_=l.availableLanguages["*"];I=l.locale,o=_||T,f=l._translationsConfigFile}catch(l){}b=!0}else console.error("Unable to resolve platform.");var v;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(v=e.Platform||(e.Platform={}));function E(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=E;let u=0;y?u=1:S?u=3:k&&(u=2),e.isWindows=S,e.isMacintosh=y,e.isLinux=k,e.isLinuxSnap=D,e.isNative=b,e.isWeb=C,e.isIOS=n,e.platform=u,e.userAgent=c,e.language=o;var h;(function(r){function l(){return e.language}r.value=l;function _(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=_;function p(){return e.language==="en"}r.isDefault=p})(h=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=f,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let _=[];e.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeSetImmediateId)for(let A=0,a=_.length;A<a;A++){const R=_[A];if(R.id===P.data.vscodeSetImmediateId){_.splice(A,1),R.callback();return}}});let p=0;return P=>{const A=++p;_.push({id:A,callback:P}),e.globals.postMessage({vscodeSetImmediateId:A},"*")}}if(typeof(d==null?void 0:d.nextTick)=="function")return d.nextTick.bind(d);const l=Promise.resolve();return _=>l.then(_)}();var g;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(g=e.OperatingSystem||(e.OperatingSystem={})),e.OS=y||n?2:S?1:3;let t=!0,i=!1;function s(){if(!i){i=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(we[40],_e([0,1,21]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let T;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const S=m.globals.vscode.process;T={get platform(){return S.platform},get env(){return S.env},cwd(){return S.cwd()},nextTick(y){return m.setImmediate(y)}}}else typeof process!="undefined"?T={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(S){return process.nextTick(S)}}:T={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},nextTick(S){return m.setImmediate(S)},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.platform=T.platform,e.nextTick=T.nextTick}),define(we[15],_e([0,1,40]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const T=65,S=97,y=90,k=122,D=46,b=47,C=92,n=58,I=63;class o extends Error{constructor(h,g,t){let i;typeof g=="string"&&g.indexOf("not ")===0?(i="must not be",g=g.replace(/^not /,"")):i="must be";const s=h.indexOf(".")!==-1?"property":"argument";let r=`The "${h}" ${s} ${i} of type ${g}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function f(u,h){if(typeof u!="string")throw new o(h,"string",u)}function c(u){return u===b||u===C}function d(u){return u===b}function w(u){return u>=T&&u<=y||u>=S&&u<=k}function v(u,h,g,t){let i="",s=0,r=-1,l=0,_=0;for(let p=0;p<=u.length;++p){if(p<u.length)_=u.charCodeAt(p);else{if(t(_))break;_=b}if(t(_)){if(!(r===p-1||l===1))if(l===2){if(i.length<2||s!==2||i.charCodeAt(i.length-1)!==D||i.charCodeAt(i.length-2)!==D){if(i.length>2){const P=i.lastIndexOf(g);P===-1?(i="",s=0):(i=i.slice(0,P),s=i.length-1-i.lastIndexOf(g)),r=p,l=0;continue}else if(i.length!==0){i="",s=0,r=p,l=0;continue}}h&&(i+=i.length>0?`${g}..`:"..",s=2)}else i.length>0?i+=`${g}${u.slice(r+1,p)}`:i=u.slice(r+1,p),s=p-r-1;r=p,l=0}else _===D&&l!==-1?++l:l=-1}return i}function E(u,h){if(h===null||typeof h!="object")throw new o("pathObject","Object",h);const g=h.dir||h.root,t=h.base||`${h.name||""}${h.ext||""}`;return g?g===h.root?`${g}${t}`:`${g}${u}${t}`:t}e.win32={resolve(...u){let h="",g="",t=!1;for(let i=u.length-1;i>=-1;i--){let s;if(i>=0){if(s=u[i],f(s,"path"),s.length===0)continue}else h.length===0?s=m.cwd():(s=m.env[`=${h}`]||m.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==h.toLowerCase()&&s.charCodeAt(2)===C)&&(s=`${h}\\`));const r=s.length;let l=0,_="",p=!1;const P=s.charCodeAt(0);if(r===1)c(P)&&(l=1,p=!0);else if(c(P))if(p=!0,c(s.charCodeAt(1))){let A=2,a=A;for(;A<r&&!c(s.charCodeAt(A));)A++;if(A<r&&A!==a){const R=s.slice(a,A);for(a=A;A<r&&c(s.charCodeAt(A));)A++;if(A<r&&A!==a){for(a=A;A<r&&!c(s.charCodeAt(A));)A++;(A===r||A!==a)&&(_=`\\\\${R}\\${s.slice(a,A)}`,l=A)}}}else l=1;else w(P)&&s.charCodeAt(1)===n&&(_=s.slice(0,2),l=2,r>2&&c(s.charCodeAt(2))&&(p=!0,l=3));if(_.length>0)if(h.length>0){if(_.toLowerCase()!==h.toLowerCase())continue}else h=_;if(t){if(h.length>0)break}else if(g=`${s.slice(l)}\\${g}`,t=p,p&&h.length>0)break}return g=v(g,!t,"\\",c),t?`${h}\\${g}`:`${h}${g}`||"."},normalize(u){f(u,"path");const h=u.length;if(h===0)return".";let g=0,t,i=!1;const s=u.charCodeAt(0);if(h===1)return d(s)?"\\":u;if(c(s))if(i=!0,c(u.charCodeAt(1))){let l=2,_=l;for(;l<h&&!c(u.charCodeAt(l));)l++;if(l<h&&l!==_){const p=u.slice(_,l);for(_=l;l<h&&c(u.charCodeAt(l));)l++;if(l<h&&l!==_){for(_=l;l<h&&!c(u.charCodeAt(l));)l++;if(l===h)return`\\\\${p}\\${u.slice(_)}\\`;l!==_&&(t=`\\\\${p}\\${u.slice(_,l)}`,g=l)}}}else g=1;else w(s)&&u.charCodeAt(1)===n&&(t=u.slice(0,2),g=2,h>2&&c(u.charCodeAt(2))&&(i=!0,g=3));let r=g<h?v(u.slice(g),!i,"\\",c):"";return r.length===0&&!i&&(r="."),r.length>0&&c(u.charCodeAt(h-1))&&(r+="\\"),t===void 0?i?`\\${r}`:r:i?`${t}\\${r}`:`${t}${r}`},isAbsolute(u){f(u,"path");const h=u.length;if(h===0)return!1;const g=u.charCodeAt(0);return c(g)||h>2&&w(g)&&u.charCodeAt(1)===n&&c(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let h,g;for(let s=0;s<u.length;++s){const r=u[s];f(r,"path"),r.length>0&&(h===void 0?h=g=r:h+=`\\${r}`)}if(h===void 0)return".";let t=!0,i=0;if(typeof g=="string"&&c(g.charCodeAt(0))){++i;const s=g.length;s>1&&c(g.charCodeAt(1))&&(++i,s>2&&(c(g.charCodeAt(2))?++i:t=!1))}if(t){for(;i<h.length&&c(h.charCodeAt(i));)i++;i>=2&&(h=`\\${h.slice(i)}`)}return e.win32.normalize(h)},relative(u,h){if(f(u,"from"),f(h,"to"),u===h)return"";const g=e.win32.resolve(u),t=e.win32.resolve(h);if(g===t||(u=g.toLowerCase(),h=t.toLowerCase(),u===h))return"";let i=0;for(;i<u.length&&u.charCodeAt(i)===C;)i++;let s=u.length;for(;s-1>i&&u.charCodeAt(s-1)===C;)s--;const r=s-i;let l=0;for(;l<h.length&&h.charCodeAt(l)===C;)l++;let _=h.length;for(;_-1>l&&h.charCodeAt(_-1)===C;)_--;const p=_-l,P=r<p?r:p;let A=-1,a=0;for(;a<P;a++){const F=u.charCodeAt(i+a);if(F!==h.charCodeAt(l+a))break;F===C&&(A=a)}if(a!==P){if(A===-1)return t}else{if(p>P){if(h.charCodeAt(l+a)===C)return t.slice(l+a+1);if(a===2)return t.slice(l+a)}r>P&&(u.charCodeAt(i+a)===C?A=a:a===2&&(A=3)),A===-1&&(A=0)}let R="";for(a=i+A+1;a<=s;++a)(a===s||u.charCodeAt(a)===C)&&(R+=R.length===0?"..":"\\..");return l+=A,R.length>0?`${R}${t.slice(l,_)}`:(t.charCodeAt(l)===C&&++l,t.slice(l,_))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const h=e.win32.resolve(u);if(h.length<=2)return u;if(h.charCodeAt(0)===C){if(h.charCodeAt(1)===C){const g=h.charCodeAt(2);if(g!==I&&g!==D)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(w(h.charCodeAt(0))&&h.charCodeAt(1)===n&&h.charCodeAt(2)===C)return`\\\\?\\${h}`;return u},dirname(u){f(u,"path");const h=u.length;if(h===0)return".";let g=-1,t=0;const i=u.charCodeAt(0);if(h===1)return c(i)?u:".";if(c(i)){if(g=t=1,c(u.charCodeAt(1))){let l=2,_=l;for(;l<h&&!c(u.charCodeAt(l));)l++;if(l<h&&l!==_){for(_=l;l<h&&c(u.charCodeAt(l));)l++;if(l<h&&l!==_){for(_=l;l<h&&!c(u.charCodeAt(l));)l++;if(l===h)return u;l!==_&&(g=t=l+1)}}}}else w(i)&&u.charCodeAt(1)===n&&(g=h>2&&c(u.charCodeAt(2))?3:2,t=g);let s=-1,r=!0;for(let l=h-1;l>=t;--l)if(c(u.charCodeAt(l))){if(!r){s=l;break}}else r=!1;if(s===-1){if(g===-1)return".";s=g}return u.slice(0,s)},basename(u,h){h!==void 0&&f(h,"ext"),f(u,"path");let g=0,t=-1,i=!0,s;if(u.length>=2&&w(u.charCodeAt(0))&&u.charCodeAt(1)===n&&(g=2),h!==void 0&&h.length>0&&h.length<=u.length){if(h===u)return"";let r=h.length-1,l=-1;for(s=u.length-1;s>=g;--s){const _=u.charCodeAt(s);if(c(_)){if(!i){g=s+1;break}}else l===-1&&(i=!1,l=s+1),r>=0&&(_===h.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=l))}return g===t?t=l:t===-1&&(t=u.length),u.slice(g,t)}for(s=u.length-1;s>=g;--s)if(c(u.charCodeAt(s))){if(!i){g=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":u.slice(g,t)},extname(u){f(u,"path");let h=0,g=-1,t=0,i=-1,s=!0,r=0;u.length>=2&&u.charCodeAt(1)===n&&w(u.charCodeAt(0))&&(h=t=2);for(let l=u.length-1;l>=h;--l){const _=u.charCodeAt(l);if(c(_)){if(!s){t=l+1;break}continue}i===-1&&(s=!1,i=l+1),_===D?g===-1?g=l:r!==1&&(r=1):g!==-1&&(r=-1)}return g===-1||i===-1||r===0||r===1&&g===i-1&&g===t+1?"":u.slice(g,i)},format:E.bind(null,"\\"),parse(u){f(u,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return h;const g=u.length;let t=0,i=u.charCodeAt(0);if(g===1)return c(i)?(h.root=h.dir=u,h):(h.base=h.name=u,h);if(c(i)){if(t=1,c(u.charCodeAt(1))){let A=2,a=A;for(;A<g&&!c(u.charCodeAt(A));)A++;if(A<g&&A!==a){for(a=A;A<g&&c(u.charCodeAt(A));)A++;if(A<g&&A!==a){for(a=A;A<g&&!c(u.charCodeAt(A));)A++;A===g?t=A:A!==a&&(t=A+1)}}}}else if(w(i)&&u.charCodeAt(1)===n){if(g<=2)return h.root=h.dir=u,h;if(t=2,c(u.charCodeAt(2))){if(g===3)return h.root=h.dir=u,h;t=3}}t>0&&(h.root=u.slice(0,t));let s=-1,r=t,l=-1,_=!0,p=u.length-1,P=0;for(;p>=t;--p){if(i=u.charCodeAt(p),c(i)){if(!_){r=p+1;break}continue}l===-1&&(_=!1,l=p+1),i===D?s===-1?s=p:P!==1&&(P=1):s!==-1&&(P=-1)}return l!==-1&&(s===-1||P===0||P===1&&s===l-1&&s===r+1?h.base=h.name=u.slice(r,l):(h.name=u.slice(r,s),h.base=u.slice(r,l),h.ext=u.slice(s,l))),r>0&&r!==t?h.dir=u.slice(0,r-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let h="",g=!1;for(let t=u.length-1;t>=-1&&!g;t--){const i=t>=0?u[t]:m.cwd();f(i,"path"),i.length!==0&&(h=`${i}/${h}`,g=i.charCodeAt(0)===b)}return h=v(h,!g,"/",d),g?`/${h}`:h.length>0?h:"."},normalize(u){if(f(u,"path"),u.length===0)return".";const h=u.charCodeAt(0)===b,g=u.charCodeAt(u.length-1)===b;return u=v(u,!h,"/",d),u.length===0?h?"/":g?"./":".":(g&&(u+="/"),h?`/${u}`:u)},isAbsolute(u){return f(u,"path"),u.length>0&&u.charCodeAt(0)===b},join(...u){if(u.length===0)return".";let h;for(let g=0;g<u.length;++g){const t=u[g];f(t,"path"),t.length>0&&(h===void 0?h=t:h+=`/${t}`)}return h===void 0?".":e.posix.normalize(h)},relative(u,h){if(f(u,"from"),f(h,"to"),u===h||(u=e.posix.resolve(u),h=e.posix.resolve(h),u===h))return"";const g=1,t=u.length,i=t-g,s=1,r=h.length-s,l=i<r?i:r;let _=-1,p=0;for(;p<l;p++){const A=u.charCodeAt(g+p);if(A!==h.charCodeAt(s+p))break;A===b&&(_=p)}if(p===l)if(r>l){if(h.charCodeAt(s+p)===b)return h.slice(s+p+1);if(p===0)return h.slice(s+p)}else i>l&&(u.charCodeAt(g+p)===b?_=p:p===0&&(_=0));let P="";for(p=g+_+1;p<=t;++p)(p===t||u.charCodeAt(p)===b)&&(P+=P.length===0?"..":"/..");return`${P}${h.slice(s+_)}`},toNamespacedPath(u){return u},dirname(u){if(f(u,"path"),u.length===0)return".";const h=u.charCodeAt(0)===b;let g=-1,t=!0;for(let i=u.length-1;i>=1;--i)if(u.charCodeAt(i)===b){if(!t){g=i;break}}else t=!1;return g===-1?h?"/":".":h&&g===1?"//":u.slice(0,g)},basename(u,h){h!==void 0&&f(h,"ext"),f(u,"path");let g=0,t=-1,i=!0,s;if(h!==void 0&&h.length>0&&h.length<=u.length){if(h===u)return"";let r=h.length-1,l=-1;for(s=u.length-1;s>=0;--s){const _=u.charCodeAt(s);if(_===b){if(!i){g=s+1;break}}else l===-1&&(i=!1,l=s+1),r>=0&&(_===h.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=l))}return g===t?t=l:t===-1&&(t=u.length),u.slice(g,t)}for(s=u.length-1;s>=0;--s)if(u.charCodeAt(s)===b){if(!i){g=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":u.slice(g,t)},extname(u){f(u,"path");let h=-1,g=0,t=-1,i=!0,s=0;for(let r=u.length-1;r>=0;--r){const l=u.charCodeAt(r);if(l===b){if(!i){g=r+1;break}continue}t===-1&&(i=!1,t=r+1),l===D?h===-1?h=r:s!==1&&(s=1):h!==-1&&(s=-1)}return h===-1||t===-1||s===0||s===1&&h===t-1&&h===g+1?"":u.slice(h,t)},format:E.bind(null,"/"),parse(u){f(u,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return h;const g=u.charCodeAt(0)===b;let t;g?(h.root="/",t=1):t=0;let i=-1,s=0,r=-1,l=!0,_=u.length-1,p=0;for(;_>=t;--_){const P=u.charCodeAt(_);if(P===b){if(!l){s=_+1;break}continue}r===-1&&(l=!1,r=_+1),P===D?i===-1?i=_:p!==1&&(p=1):i!==-1&&(p=-1)}if(r!==-1){const P=s===0&&g?1:s;i===-1||p===0||p===1&&i===r-1&&i===s+1?h.base=h.name=u.slice(P,r):(h.name=u.slice(P,i),h.base=u.slice(P,r),h.ext=u.slice(i,r))}return s>0?h.dir=u.slice(0,s-1):g&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(we[52],_e([0,1,21]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const T=m.globals.performance&&typeof m.globals.performance.now=="function";class S{constructor(k){this._highResolution=T&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new S(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=S}),define(we[3],_e([0,1,11,49,7,51,52]),function(ee,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(E){E.None=()=>S.Disposable.None;function u(ae){return(j,W=null,Q)=>{let M=!1,X;return X=ae(B=>{if(!M)return X?X.dispose():M=!0,j.call(W,B)},null,Q),M&&X.dispose(),X}}E.once=u;function h(ae,j){return l((W,Q=null,M)=>ae(X=>W.call(Q,j(X)),null,M))}E.map=h;function g(ae,j){return l((W,Q=null,M)=>ae(X=>{j(X),W.call(Q,X)},null,M))}E.forEach=g;function t(ae,j){return l((W,Q=null,M)=>ae(X=>j(X)&&W.call(Q,X),null,M))}E.filter=t;function i(ae){return ae}E.signal=i;function s(...ae){return(j,W=null,Q)=>S.combinedDisposable(...ae.map(M=>M(X=>j.call(W,X),null,Q)))}E.any=s;function r(ae,j,W){let Q=W;return h(ae,M=>(Q=j(Q,M),Q))}E.reduce=r;function l(ae){let j;const W=new o({onFirstListenerAdd(){j=ae(W.fire,W)},onLastListenerRemove(){j.dispose()}});return W.event}function _(ae,j,W=100,Q=!1,M){let X,B,U,Y=0;const V=new o({leakWarningThreshold:M,onFirstListenerAdd(){X=ae(ce=>{Y++,B=j(B,ce),Q&&!U&&(V.fire(B),B=void 0),clearTimeout(U),U=setTimeout(()=>{const ge=B;B=void 0,U=void 0,(!Q||Y>1)&&V.fire(ge),Y=0},W)})},onLastListenerRemove(){X.dispose()}});return V.event}E.debounce=_;function p(ae,j=(W,Q)=>W===Q){let W=!0,Q;return t(ae,M=>{const X=W||!j(M,Q);return W=!1,Q=M,X})}E.latch=p;function P(ae,j){return[E.filter(ae,j),E.filter(ae,W=>!j(W))]}E.split=P;function A(ae,j=!1,W=[]){let Q=W.slice(),M=ae(U=>{Q?Q.push(U):B.fire(U)});const X=()=>{Q&&Q.forEach(U=>B.fire(U)),Q=null},B=new o({onFirstListenerAdd(){M||(M=ae(U=>B.fire(U)))},onFirstListenerDidAdd(){Q&&(j?setTimeout(X):X())},onLastListenerRemove(){M&&M.dispose(),M=null}});return B.event}E.buffer=A;class a{constructor(j){this.event=j}map(j){return new a(h(this.event,j))}forEach(j){return new a(g(this.event,j))}filter(j){return new a(t(this.event,j))}reduce(j,W){return new a(r(this.event,j,W))}latch(){return new a(p(this.event))}debounce(j,W=100,Q=!1,M){return new a(_(this.event,j,W,Q,M))}on(j,W,Q){return this.event(j,W,Q)}once(j,W,Q){return u(this.event)(j,W,Q)}}function R(ae){return new a(ae)}E.chain=R;function F(ae,j,W=Q=>Q){const Q=(...U)=>B.fire(W(...U)),M=()=>ae.on(j,Q),X=()=>ae.removeListener(j,Q),B=new o({onFirstListenerAdd:M,onLastListenerRemove:X});return B.event}E.fromNodeEventEmitter=F;function x(ae,j,W=Q=>Q){const Q=(...U)=>B.fire(W(...U)),M=()=>ae.addEventListener(j,Q),X=()=>ae.removeEventListener(j,Q),B=new o({onFirstListenerAdd:M,onLastListenerRemove:X});return B.event}E.fromDOMEventEmitter=x;function J(ae){return new Promise(j=>u(ae)(j))}E.toPromise=J})(D=e.Event||(e.Event={}));class b{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${b._idPool++}`}start(u){this._stopWatch=new k.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}b._idPool=0;let C=-1;function n(E){const u=C;return C=E,{dispose(){C=u}}}e.setGlobalLeakWarningThreshold=n;class I{constructor(u,h=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=h,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let h=C;if(typeof this.customThreshold=="number"&&(h=this.customThreshold),h<=0||u<h)return;this._stacks||(this._stacks=new Map);const g=new Error().stack.split(`
`).slice(3).join(`
`),t=this._stacks.get(g)||0;if(this._stacks.set(g,t+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=h*.5;let i,s=0;for(const[r,l]of this._stacks)(!i||s<l)&&(i=r,s=l);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${s}):`),console.warn(i)}return()=>{const i=this._stacks.get(g)||0;this._stacks.set(g,i-1)}}}class o{constructor(u){var h;this._disposed=!1,this._options=u,this._leakageMon=C>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((h=this._options)===null||h===void 0?void 0:h._profName)?new b(this._options._profName):void 0}get event(){return this._event||(this._event=(u,h,g)=>{var t;this._listeners||(this._listeners=new y.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(h?[u,h]:u);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,h);const r=(t=this._leakageMon)===null||t===void 0?void 0:t.check(this._listeners.size);let l;return l={dispose:()=>{r&&r(),l.dispose=o._noop,this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},g instanceof S.DisposableStore?g.add(l):Array.isArray(g)&&g.push(l),l}),this._event}fire(u){var h,g;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,u]);for((h=this._perfMon)===null||h===void 0||h.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,i]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,i):t[0].call(t[1],i)}catch(s){m.onUnexpectedError(s)}}(g=this._perfMon)===null||g===void 0||g.stop()}}dispose(){var u,h,g,t,i;this._disposed||(this._disposed=!0,(u=this._listeners)===null||u===void 0||u.clear(),(h=this._deliveryQueue)===null||h===void 0||h.clear(),(t=(g=this._options)===null||g===void 0?void 0:g.onLastListenerRemove)===null||t===void 0||t.call(g),(i=this._leakageMon)===null||i===void 0||i.dispose())}}e.Emitter=o,o._noop=function(){};class f extends o{constructor(u){super(u);this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=u==null?void 0:u.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=f;class c extends f{constructor(u){var h;super(u);this._delay=(h=u.delay)!==null&&h!==void 0?h:100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=c;class d{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new o({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const h={event:u,listener:null};this.events.push(h),this.hasListeners&&this.hook(h);const g=()=>{this.hasListeners&&this.unhook(h);const t=this.events.indexOf(h);this.events.splice(t,1)};return S.toDisposable(T.once(g))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(h=>this.emitter.fire(h))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=d;class w{constructor(){this.buffers=[]}wrapEvent(u){return(h,g,t)=>u(i=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>h.call(g,i)):h.call(g,i)},void 0,t)}bufferEvents(u){const h=[];this.buffers.push(h);const g=u();return this.buffers.pop(),h.forEach(t=>t()),g}}e.EventBufferer=w;class v{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=S.Disposable.None,this.emitter=new o({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=v}),define(we[18],_e([0,1,3]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const T=Object.freeze(function(D,b){const C=setTimeout(D.bind(b),0);return{dispose(){clearTimeout(C)}}});var S;(function(D){function b(C){return C===D.None||C===D.Cancelled||C instanceof y?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}D.isCancellationToken=b,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(S=e.CancellationToken||(e.CancellationToken={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?T:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(b){this._token=void 0,this._parentListener=void 0,this._parentListener=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=S.Cancelled}dispose(b=!1){b&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=S.None}}e.CancellationTokenSource=k}),define(we[77],_e([0,1,3]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class T{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(I){const o=this._icons.get(I.id);o?I.description?o.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const S=new T;e.iconRegistry=S;function y(n,I){return new D(n,I)}e.registerCodicon=y;function k(n){return n?n.replace(/\$\((.*?)\)/g,(I,o)=>` ${o} `).trim():""}e.getCodiconAriaLabel=k;class D{constructor(I,o,f){this.id=I,this.definition=o,this.description=f,S.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function b(n,I){const o=["codicon","codicon-"+n];return I&&o.push("codicon-modifier-"+I),o}e.getClassNamesArray=b;var C;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function o(d){if(d instanceof D)return["codicon","codicon-"+d.id];const w=I.exec(d.id);if(!w)return o(D.error);let[,v,E]=w;const u=["codicon","codicon-"+v];return E&&u.push("codicon-modifier-"+E.substr(1)),u}n.asClassNameArray=o;function f(d){return o(d).join(" ")}n.asClassName=f;function c(d){return"."+o(d).join(".")}n.asCSSSelector=c})(C=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(we[109],_e([0,1,11,7]),function(ee,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function S(u){const h=u;return h?[h.on,h.pause,h.resume,h.destroy].every(g=>typeof g=="function"):!1}e.isReadableStream=S;function y(u){const h=u;return h?S(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=y;function k(u,h){return new D(u,h)}e.newWriteableStream=k;class D{constructor(h,g){this.reducer=h,this.options=g,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){var g;if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof((g=this.options)===null||g===void 0?void 0:g.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(g=>g(h))}emitError(h){this.listeners.error.length===0?m.onUnexpectedError(h):this.listeners.error.slice(0).forEach(g=>g(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,g){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(g),this.resume();break;case"end":this.listeners.end.push(g),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(g),this.state.flowing&&this.flowErrors();break}}removeListener(h,g){if(this.state.destroyed)return;let t;switch(h){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const i=t.indexOf(g);i>=0&&t.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const g=[...this.pendingWritePromises];this.pendingWritePromises.length=0,g.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function b(u,h){const g=[];let t;for(;(t=u.read())!==null;)g.push(t);return h(g)}e.consumeReadable=b;function C(u,h,g){const t=[];let i;for(;(i=u.read())!==null&&t.length<g;)t.push(i);return i===null&&t.length>0?h(t):{read:()=>{if(t.length>0)return t.shift();if(typeof i!="undefined"){const s=i;return i=void 0,s}return u.read()}}}e.peekReadable=C;function n(u,h){return new Promise((g,t)=>{const i=[];I(u,{onData:s=>{h&&i.push(s)},onError:s=>{h?t(s):g(void 0)},onEnd:()=>{g(h?h(i):void 0)}})})}e.consumeStream=n;function I(u,h){u.on("error",g=>h.onError(g)),u.on("end",()=>h.onEnd()),u.on("data",g=>h.onData(g))}e.listenStream=I;function o(u,h){return new Promise((g,t)=>{const i=new T.DisposableStore,s=[],r=p=>{if(s.push(p),s.length>h)return i.dispose(),u.pause(),g({stream:u,buffer:s,ended:!1})},l=p=>t(p),_=()=>g({stream:u,buffer:s,ended:!0});i.add(T.toDisposable(()=>u.removeListener("error",l))),u.on("error",l),i.add(T.toDisposable(()=>u.removeListener("end",_))),u.on("end",_),i.add(T.toDisposable(()=>u.removeListener("data",r))),u.on("data",r)})}e.peekStream=o;function f(u,h){const g=k(h);return g.end(u),g}e.toStream=f;function c(){const u=k(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=c;function d(u){let h=!1;return{read:()=>h?null:(h=!0,u)}}e.toReadable=d;function w(u,h,g){const t=k(g);return I(u,{onData:i=>t.write(h.data(i)),onError:i=>t.error(h.error?h.error(i):i),onEnd:()=>t.end()}),t}e.transform=w;function v(u,h,g){let t=!1;return{read:()=>{const i=h.read();return t?i:(t=!0,i!==null?g([u,i]):u)}}}e.prefixedReadable=v;function E(u,h,g){let t=!1;const i=k(g);return I(h,{onData:s=>t?i.write(s):(t=!0,i.write(g([u,s]))),onError:s=>i.error(s),onEnd:()=>{t||(t=!0,i.write(u)),i.end()}}),i}e.prefixedStream=E}),define(we[8],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function m(N){return!N||typeof N!="string"?!0:N.trim().length===0}e.isFalsyOrWhitespace=m;const T=/{(\d+)}/g;function S(N,...G){return G.length===0?N:N.replace(T,function(le,ke){const Pe=parseInt(ke,10);return isNaN(Pe)||Pe<0||Pe>=G.length?le:G[Pe]})}e.format=S;function y(N){return N.replace(/[<>&]/g,function(G){switch(G){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return G}})}e.escape=y;function k(N){return N.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function D(N,G){let le=0;const ke=G.charCodeAt(0);for(let Pe=N.length-1;Pe>=0;Pe--)N.charCodeAt(Pe)===ke&&le++;return le}e.count=D;function b(N,G,le="\u2026"){return N.length<=G?N:`${N.substr(0,G)}${le}`}e.truncate=b;function C(N,G=" "){const le=n(N,G);return I(le,G)}e.trim=C;function n(N,G){if(!N||!G)return N;const le=G.length;if(le===0||N.length===0)return N;let ke=0;for(;N.indexOf(G,ke)===ke;)ke=ke+le;return N.substring(ke)}e.ltrim=n;function I(N,G){if(!N||!G)return N;const le=G.length,ke=N.length;if(le===0||ke===0)return N;let Pe=ke,Ne=-1;for(;Ne=N.lastIndexOf(G,Pe-1),!(Ne===-1||Ne+le!==Pe);){if(Ne===0)return"";Pe=Ne}return N.substring(0,Pe)}e.rtrim=I;function o(N){return N.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=o;function f(N){return N.replace(/\*/g,"")}e.stripWildcards=f;function c(N,G,le={}){if(!N)throw new Error("Cannot create regex from empty string");G||(N=k(N)),le.wholeWord&&(/\B/.test(N.charAt(0))||(N="\\b"+N),/\B/.test(N.charAt(N.length-1))||(N=N+"\\b"));let ke="";return le.global&&(ke+="g"),le.matchCase||(ke+="i"),le.multiline&&(ke+="m"),le.unicode&&(ke+="u"),new RegExp(N,ke)}e.createRegExp=c;function d(N){return N.source==="^"||N.source==="^$"||N.source==="$"||N.source==="^\\s*$"?!1:!!(N.exec("")&&N.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function w(N){return!!N.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=w;function v(N){return(N.global?"g":"")+(N.ignoreCase?"i":"")+(N.multiline?"m":"")+(N.unicode?"u":"")}e.regExpFlags=v;function E(N){return N.split(/\r\n|\r|\n/)}e.splitLines=E;function u(N){for(let G=0,le=N.length;G<le;G++){const ke=N.charCodeAt(G);if(ke!==32&&ke!==9)return G}return-1}e.firstNonWhitespaceIndex=u;function h(N,G=0,le=N.length){for(let ke=G;ke<le;ke++){const Pe=N.charCodeAt(ke);if(Pe!==32&&Pe!==9)return N.substring(G,ke)}return N.substring(G,le)}e.getLeadingWhitespace=h;function g(N,G=N.length-1){for(let le=G;le>=0;le--){const ke=N.charCodeAt(le);if(ke!==32&&ke!==9)return le}return-1}e.lastNonWhitespaceIndex=g;function t(N,G){return N<G?-1:N>G?1:0}e.compare=t;function i(N,G,le=0,ke=N.length,Pe=0,Ne=G.length){for(;le<ke&&Pe<Ne;le++,Pe++){let Je=N.charCodeAt(le),Ye=G.charCodeAt(Pe);if(Je<Ye)return-1;if(Je>Ye)return 1}const Be=ke-le,Ze=Ne-Pe;return Be<Ze?-1:Be>Ze?1:0}e.compareSubstring=i;function s(N,G){return r(N,G,0,N.length,0,G.length)}e.compareIgnoreCase=s;function r(N,G,le=0,ke=N.length,Pe=0,Ne=G.length){for(;le<ke&&Pe<Ne;le++,Pe++){let Je=N.charCodeAt(le),Ye=G.charCodeAt(Pe);if(Je===Ye)continue;const nt=Je-Ye;if(!(nt===32&&_(Ye))&&!(nt===-32&&_(Je)))return l(Je)&&l(Ye)?nt:i(N.toLowerCase(),G.toLowerCase(),le,ke,Pe,Ne)}const Be=ke-le,Ze=Ne-Pe;return Be<Ze?-1:Be>Ze?1:0}e.compareSubstringIgnoreCase=r;function l(N){return N>=97&&N<=122}e.isLowerAsciiLetter=l;function _(N){return N>=65&&N<=90}e.isUpperAsciiLetter=_;function p(N){return l(N)||_(N)}function P(N,G){return N.length===G.length&&A(N,G)}e.equalsIgnoreCase=P;function A(N,G,le=N.length){for(let ke=0;ke<le;ke++){const Pe=N.charCodeAt(ke),Ne=G.charCodeAt(ke);if(Pe!==Ne){if(p(Pe)&&p(Ne)){const Be=Math.abs(Pe-Ne);if(Be!==0&&Be!==32)return!1}else if(String.fromCharCode(Pe).toLowerCase()!==String.fromCharCode(Ne).toLowerCase())return!1}}return!0}function a(N,G){const le=G.length;return G.length>N.length?!1:A(N,G,le)}e.startsWithIgnoreCase=a;function R(N,G){let le,ke=Math.min(N.length,G.length);for(le=0;le<ke;le++)if(N.charCodeAt(le)!==G.charCodeAt(le))return le;return ke}e.commonPrefixLength=R;function F(N,G){let le,ke=Math.min(N.length,G.length);const Pe=N.length-1,Ne=G.length-1;for(le=0;le<ke;le++)if(N.charCodeAt(Pe-le)!==G.charCodeAt(Ne-le))return le;return ke}e.commonSuffixLength=F;function x(N){return 55296<=N&&N<=56319}e.isHighSurrogate=x;function J(N){return 56320<=N&&N<=57343}e.isLowSurrogate=J;function ae(N,G){return(N-55296<<10)+(G-56320)+65536}e.computeCodePoint=ae;function j(N,G,le){const ke=N.charCodeAt(le);if(x(ke)&&le+1<G){const Pe=N.charCodeAt(le+1);if(J(Pe))return ae(ke,Pe)}return ke}e.getNextCodePoint=j;function W(N,G){const le=N.charCodeAt(G-1);if(J(le)&&G>1){const ke=N.charCodeAt(G-2);if(x(ke))return ae(ke,le)}return le}function Q(N,G){const le=Le.getInstance(),ke=G,Pe=N.length,Ne=j(N,Pe,G);G+=Ne>=65536?2:1;let Be=le.getGraphemeBreakType(Ne);for(;G<Pe;){const Ze=j(N,Pe,G),Je=le.getGraphemeBreakType(Ze);if(me(Be,Je))break;G+=Ze>=65536?2:1,Be=Je}return G-ke}e.nextCharLength=Q;function M(N,G){const le=Le.getInstance(),ke=G,Pe=W(N,G);G-=Pe>=65536?2:1;let Ne=le.getGraphemeBreakType(Pe);for(;G>0;){const Be=W(N,G),Ze=le.getGraphemeBreakType(Be);if(me(Ze,Ne))break;G-=Be>=65536?2:1,Ne=Ze}return ke-G}e.prevCharLength=M;function X(N,G){const le=Le.getInstance(),ke=N.length,Pe=G,Ne=j(N,ke,G),Be=le.getGraphemeBreakType(Ne);G+=Ne>=65536?2:1;let Ze=Be;for(;G<ke;){const Ye=j(N,ke,G),nt=le.getGraphemeBreakType(Ye);if(me(Ze,nt))break;G+=Ye>=65536?2:1,Ze=nt}const Je=G;for(G=Pe,Ze=Be;G>0;){const Ye=W(N,G),nt=le.getGraphemeBreakType(Ye);if(me(nt,Ze))break;G-=Ye>=65536?2:1,Ze=nt}return[G,Je]}function B(N,G){return G>0&&J(N.charCodeAt(G))?X(N,G-1):X(N,G)}e.getCharContainingOffset=B;function U(N){const G=N.length;let le=0,ke=0;for(;ke<G;){const Be=j(N,G,ke);ke+=Be>=65536?2:1,Be<128?le+=1:Be<2048?le+=2:Be<65536?le+=3:le+=4}const Pe=new Uint8Array(le);ke=0;let Ne=0;for(;ke<G;){const Be=j(N,G,ke);ke+=Be>=65536?2:1,Be<128?Pe[Ne++]=Be:Be<2048?(Pe[Ne++]=192|(Be&1984)>>>6,Pe[Ne++]=128|(Be&63)>>>0):Be<65536?(Pe[Ne++]=224|(Be&61440)>>>12,Pe[Ne++]=128|(Be&4032)>>>6,Pe[Ne++]=128|(Be&63)>>>0):(Pe[Ne++]=240|(Be&1835008)>>>18,Pe[Ne++]=128|(Be&258048)>>>12,Pe[Ne++]=128|(Be&4032)>>>6,Pe[Ne++]=128|(Be&63)>>>0)}return Pe}e.encodeUTF8=U;function Y(N){const G=N.byteLength,le=[];let ke=0;for(;ke<G;){const Pe=N[ke];let Ne;if(Pe>=240&&ke+3<G?Ne=(N[ke++]&7)<<18>>>0|(N[ke++]&63)<<12>>>0|(N[ke++]&63)<<6>>>0|(N[ke++]&63)<<0>>>0:Pe>=224&&ke+2<G?Ne=(N[ke++]&15)<<12>>>0|(N[ke++]&63)<<6>>>0|(N[ke++]&63)<<0>>>0:Pe>=192&&ke+1<G?Ne=(N[ke++]&31)<<6>>>0|(N[ke++]&63)<<0>>>0:Ne=N[ke++],Ne>=0&&Ne<=55295||Ne>=57344&&Ne<=65535)le.push(String.fromCharCode(Ne));else if(Ne>=65536&&Ne<=1114111){const Be=Ne-65536,Ze=55296+((Be&1047552)>>>10),Je=56320+((Be&1023)>>>0);le.push(String.fromCharCode(Ze)),le.push(String.fromCharCode(Je))}else le.push(String.fromCharCode(65533))}return le.join("")}e.decodeUTF8=Y;const V=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ce(N){return V.test(N)}e.containsRTL=ce;const ge=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Ae(N){return ge.test(N)}e.containsEmoji=Ae;const $e=/^[\t\n\r\x20-\x7E]*$/;function Fe(N){return $e.test(N)}e.isBasicASCII=Fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ve(N){return e.UNUSUAL_LINE_TERMINATORS.test(N)}e.containsUnusualLineTerminators=Ve;function tt(N){for(let G=0,le=N.length;G<le;G++)if(Ke(N.charCodeAt(G)))return!0;return!1}e.containsFullWidthCharacter=tt;function Ke(N){return N=+N,N>=11904&&N<=55215||N>=63744&&N<=64255||N>=65281&&N<=65374}e.isFullWidthCharacter=Ke;function Qe(N){return N>=127462&&N<=127487||N===8986||N===8987||N===9200||N===9203||N>=9728&&N<=10175||N===11088||N===11093||N>=127744&&N<=128591||N>=128640&&N<=128764||N>=128992&&N<=129003||N>=129280&&N<=129535||N>=129648&&N<=129750}e.isEmojiImprecise=Qe;function $(N,G){if(N.length<G)return N;const le=/\b/g;let ke=0;for(;le.test(N)&&!(N.length-le.lastIndex<G);)ke=le.lastIndex,le.lastIndex+=1;return N.substring(ke).replace(/^\s/,"")}e.lcut=$;const K=/\x1B\x5B[12]?K/g,ie=/\x1b\[\d+m/g,se=/\x1b\[0?m/g;function q(N){return N&&(N=N.replace(K,""),N=N.replace(ie,""),N=N.replace(se,"")),N}e.removeAnsiEscapeCodes=q,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function oe(N){return!!(N&&N.length>0&&N.charCodeAt(0)===65279)}e.startsWithUTF8BOM=oe;function fe(N){return oe(N)?N.substr(1):N}e.stripUTF8BOM=fe;function Re(N,G){if(!N||!G||N.length<G.length)return!1;const le=G.length,ke=N.toLowerCase();let Pe=0,Ne=-1;for(;Pe<le;){const Be=ke.indexOf(G[Pe],Ne+1);if(Be<0)return!1;Ne=Be,Pe++}return!0}e.fuzzyContains=Re;function xe(N,G=!1){return N?(G&&(N=N.replace(/\\./g,"")),N.toLowerCase()!==N):!1}e.containsUppercaseCharacter=xe;function pe(N){return N.charAt(0).toUpperCase()+N.slice(1)}e.uppercaseFirstLetter=pe;function qe(N,G=1){if(G===0)return"";let le=-1;do le=N.indexOf(`
`,le+1),G--;while(G>0&&le>=0);return le===-1?N:(N[le-1]==="\r"&&le--,N.substr(0,le))}e.getNLines=qe;function H(N){const G=90-65+1;return N=N%(2*G),N<G?String.fromCharCode(97+N):String.fromCharCode(65+N-G)}e.singleLetterHash=H;function te(N){return Le.getInstance().getGraphemeBreakType(N)}e.getGraphemeBreakType=te;function me(N,G){return N===0?G!==5&&G!==7:N===2&&G===3?!1:N===4||N===2||N===3||G===4||G===2||G===3?!0:!(N===8&&(G===8||G===9||G===11||G===12)||(N===11||N===9)&&(G===9||G===10)||(N===12||N===10)&&G===10||G===5||G===13||G===7||N===1||N===13&&G===14||N===6&&G===6)}e.breakBetweenGraphemeBreakType=me;var Te;(function(N){N[N.Other=0]="Other",N[N.Prepend=1]="Prepend",N[N.CR=2]="CR",N[N.LF=3]="LF",N[N.Control=4]="Control",N[N.Extend=5]="Extend",N[N.Regional_Indicator=6]="Regional_Indicator",N[N.SpacingMark=7]="SpacingMark",N[N.L=8]="L",N[N.V=9]="V",N[N.T=10]="T",N[N.LV=11]="LV",N[N.LVT=12]="LVT",N[N.ZWJ=13]="ZWJ",N[N.Extended_Pictographic=14]="Extended_Pictographic"})(Te=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Le{constructor(){this._data=Ge()}static getInstance(){return Le._INSTANCE||(Le._INSTANCE=new Le),Le._INSTANCE}getGraphemeBreakType(G){if(G<32)return G===10?3:G===13?2:4;if(G<127)return 0;const le=this._data,ke=le.length/3;let Pe=1;for(;Pe<=ke;)if(G<le[3*Pe])Pe=2*Pe;else if(G>le[3*Pe+1])Pe=2*Pe+1;else return le[3*Pe+2];return 0}}Le._INSTANCE=null;function Ge(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Se(N,G){if(N===0)return 0;const le=be(N,G);if(le!==void 0)return le;const ke=W(G,N);return N-=Ce(ke),N}e.getLeftDeleteOffset=Se;function be(N,G){let le=W(G,N);for(N-=Ce(le);re(le)||le===65039||le===8419;){if(N===0)return;le=W(G,N),N-=Ce(le)}if(!!Qe(le)){if(N>=0){const ke=W(G,N);ke===8205&&(N-=Ce(ke))}return N}}function Ce(N){return N>=65536?2:1}function re(N){return 127995<=N&&N<=127999}var de;(function(N){N[N.zwj=8205]="zwj",N[N.emojiVariantSelector=65039]="emojiVariantSelector",N[N.enclosingKeyCap=8419]="enclosingKeyCap"})(de||(de={}))}),define(we[23],_e([0,1,8,109]),function(ee,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const S=typeof Buffer!="undefined",y=typeof TextEncoder!="undefined",k=typeof TextDecoder!="undefined";let D,b;class C{constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}static alloc(p){return S?new C(Buffer.allocUnsafe(p)):new C(new Uint8Array(p))}static wrap(p){return S&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new C(p)}static fromString(p,P){return!((P==null?void 0:P.dontUseNodeBuffer)||!1)&&S?new C(Buffer.from(p)):y?(D||(D=new TextEncoder),new C(D.encode(p))):new C(m.encodeUTF8(p))}static concat(p,P){if(typeof P=="undefined"){P=0;for(let R=0,F=p.length;R<F;R++)P+=p[R].byteLength}const A=C.alloc(P);let a=0;for(let R=0,F=p.length;R<F;R++){const x=p[R];A.set(x,a),a+=x.byteLength}return A}toString(){return S?this.buffer.toString():k?(b||(b=new TextDecoder),b.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(p,P){return new C(this.buffer.subarray(p,P))}set(p,P){p instanceof C?this.buffer.set(p.buffer,P):this.buffer.set(p,P)}readUInt32BE(p){return o(this.buffer,p)}writeUInt32BE(p,P){f(this.buffer,p,P)}readUInt32LE(p){return c(this.buffer,p)}writeUInt32LE(p,P){d(this.buffer,p,P)}readUInt8(p){return w(this.buffer,p)}writeUInt8(p,P){v(this.buffer,p,P)}}e.VSBuffer=C;function n(_,p){return _[p+0]<<0>>>0|_[p+1]<<8>>>0}e.readUInt16LE=n;function I(_,p,P){_[P+0]=p&255,p=p>>>8,_[P+1]=p&255}e.writeUInt16LE=I;function o(_,p){return _[p]*2**24+_[p+1]*2**16+_[p+2]*2**8+_[p+3]}e.readUInt32BE=o;function f(_,p,P){_[P+3]=p,p=p>>>8,_[P+2]=p,p=p>>>8,_[P+1]=p,p=p>>>8,_[P]=p}e.writeUInt32BE=f;function c(_,p){return _[p+0]<<0>>>0|_[p+1]<<8>>>0|_[p+2]<<16>>>0|_[p+3]<<24>>>0}e.readUInt32LE=c;function d(_,p,P){_[P+0]=p&255,p=p>>>8,_[P+1]=p&255,p=p>>>8,_[P+2]=p&255,p=p>>>8,_[P+3]=p&255}e.writeUInt32LE=d;function w(_,p){return _[p]}e.readUInt8=w;function v(_,p,P){_[P]=p}e.writeUInt8=v;function E(_){return T.consumeReadable(_,p=>C.concat(p))}e.readableToBuffer=E;function u(_){return T.toReadable(_)}e.bufferToReadable=u;function h(_){return T.consumeStream(_,p=>C.concat(p))}e.streamToBuffer=h;async function g(_){return _.ended?C.concat(_.buffer):C.concat([..._.buffer,await h(_.stream)])}e.bufferedStreamToBuffer=g;function t(_){return T.toStream(_,p=>C.concat(p))}e.bufferToStream=t;function i(_){return T.transform(_,{data:p=>typeof p=="string"?C.fromString(p):C.wrap(p)},p=>C.concat(p))}e.streamToBufferReadableStream=i;function s(_){return T.newWriteableStream(p=>C.concat(p),_)}e.newWriteableBufferStream=s;function r(_,p){return T.prefixedReadable(_,p,P=>C.concat(P))}e.prefixedBufferReadable=r;function l(_,p){return T.prefixedStream(_,p,P=>C.concat(P))}e.prefixedBufferStream=l}),define(we[53],_e([0,1,8]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function T(v){return S(v,0)}e.hash=T;function S(v,E){switch(typeof v){case"object":return v===null?y(349,E):Array.isArray(v)?b(v,E):C(v,E);case"string":return D(v,E);case"boolean":return k(v,E);case"number":return y(v,E);case"undefined":return y(937,E);default:return y(617,E)}}e.doHash=S;function y(v,E){return(E<<5)-E+v|0}function k(v,E){return y(v?433:863,E)}function D(v,E){E=y(149417,E);for(let u=0,h=v.length;u<h;u++)E=y(v.charCodeAt(u),E);return E}e.stringHash=D;function b(v,E){return E=y(104579,E),v.reduce((u,h)=>S(h,u),E)}function C(v,E){return E=y(181387,E),Object.keys(v).sort().reduce((u,h)=>(u=D(h,u),S(v[h],u)),E)}class n{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=S(E,this._value),this._value}}e.Hasher=n;var I;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function o(v,E,u=32){const h=u-E,g=~((1<<h)-1);return(v<<E|(g&v)>>>h)>>>0}function f(v,E=0,u=v.byteLength,h=0){for(let g=0;g<u;g++)v[E+g]=h}function c(v,E,u="0"){for(;v.length<E;)v=u+v;return v}function d(v,E=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(u=>u.toString(16).padStart(2,"0")).join(""):c((v>>>0).toString(16),E/4)}e.toHexString=d;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const u=E.length;if(u===0)return;const h=this._buff;let g=this._buffLen,t=this._leftoverHighSurrogate,i,s;for(t!==0?(i=t,s=-1,t=0):(i=E.charCodeAt(0),s=0);;){let r=i;if(m.isHighSurrogate(i))if(s+1<u){const l=E.charCodeAt(s+1);m.isLowSurrogate(l)?(s++,r=m.computeCodePoint(i,l)):r=65533}else{t=i;break}else m.isLowSurrogate(i)&&(r=65533);if(g=this._push(h,g,r),s++,s<u)i=E.charCodeAt(s);else break}this._buffLen=g,this._leftoverHighSurrogate=t}_push(E,u,h){return h<128?E[u++]=h:h<2048?(E[u++]=192|(h&1984)>>>6,E[u++]=128|(h&63)>>>0):h<65536?(E[u++]=224|(h&61440)>>>12,E[u++]=128|(h&4032)>>>6,E[u++]=128|(h&63)>>>0):(E[u++]=240|(h&1835008)>>>18,E[u++]=128|(h&258048)>>>12,E[u++]=128|(h&4032)>>>6,E[u++]=128|(h&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=w._bigBlock32,u=this._buffDV;for(let p=0;p<64;p+=4)E.setUint32(p,u.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)E.setUint32(p,o(E.getUint32(p-12,!1)^E.getUint32(p-32,!1)^E.getUint32(p-56,!1)^E.getUint32(p-64,!1),1),!1);let h=this._h0,g=this._h1,t=this._h2,i=this._h3,s=this._h4,r,l,_;for(let p=0;p<80;p++)p<20?(r=g&t|~g&i,l=1518500249):p<40?(r=g^t^i,l=1859775393):p<60?(r=g&t|g&i|t&i,l=2400959708):(r=g^t^i,l=3395469782),_=o(h,5)+r+s+l+E.getUint32(p*4,!1)&4294967295,s=i,i=t,t=o(g,30),g=h,h=_;this._h0=this._h0+h&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))}),define(we[41],_e([0,1,8]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(T||(T={})),function(S){const y="error",k="warning",D="warn",b="info",C="ignore";function n(o){return o?m.equalsIgnoreCase(y,o)?S.Error:m.equalsIgnoreCase(k,o)||m.equalsIgnoreCase(D,o)?S.Warning:m.equalsIgnoreCase(b,o)?S.Info:S.Ignore:S.Ignore}S.fromValue=n;function I(o){switch(o){case S.Error:return y;case S.Warning:return k;case S.Info:return b;default:return C}}S.toString=I}(T||(T={})),e.default=T}),define(we[10],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(p){return Array.isArray(p)}e.isArray=m;function T(p){return typeof p=="string"}e.isString=T;function S(p){return Array.isArray(p)&&p.every(P=>T(P))}e.isStringArray=S;function y(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}e.isObject=y;function k(p){return typeof p=="number"&&!isNaN(p)}e.isNumber=k;function D(p){return!!p&&typeof p[Symbol.iterator]=="function"}e.isIterable=D;function b(p){return p===!0||p===!1}e.isBoolean=b;function C(p){return typeof p=="undefined"}e.isUndefined=C;function n(p){return!I(p)}e.isDefined=n;function I(p){return C(p)||p===null}e.isUndefinedOrNull=I;function o(p,P){if(!p)throw new Error(P?`Unexpected type, expected '${P}'`:"Unexpected type")}e.assertType=o;function f(p){if(I(p))throw new Error("Assertion Failed: argument is undefined or null");return p}e.assertIsDefined=f;function c(...p){const P=[];for(let A=0;A<p.length;A++){const a=p[A];if(I(a))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);P.push(a)}return P}e.assertAllDefined=c;const d=Object.prototype.hasOwnProperty;function w(p){if(!y(p))return!1;for(let P in p)if(d.call(p,P))return!1;return!0}e.isEmptyObject=w;function v(p){return typeof p=="function"}e.isFunction=v;function E(...p){return p.length>0&&p.every(v)}e.areFunctions=E;function u(p,P){const A=Math.min(p.length,P.length);for(let a=0;a<A;a++)h(p[a],P[a])}e.validateConstraints=u;function h(p,P){if(T(P)){if(typeof p!==P)throw new Error(`argument does not match constraint: typeof ${P}`)}else if(v(P)){try{if(p instanceof P)return}catch(A){}if(!I(p)&&p.constructor===P||P.length===1&&P.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function g(p){let P=[],A=Object.getPrototypeOf(p);for(;Object.prototype!==A;)P=P.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return P}e.getAllPropertyNames=g;function t(p){const P=[];for(const A of g(p))typeof p[A]=="function"&&P.push(A);return P}e.getAllMethodNames=t;function i(p,P){const A=R=>function(){const F=Array.prototype.slice.call(arguments,0);return P(R,F)};let a={};for(const R of p)a[R]=A(R);return a}e.createProxyObject=i;function s(p){return p===null?void 0:p}e.withNullAsUndefined=s;function r(p){return typeof p=="undefined"?null:p}e.withUndefinedAsNull=r;function l(p){return class{constructor(){return new Proxy({},{get(P,A){if(P[A])return P[A];throw new Error(`Not Implemented: ${p}->${String(A)}`)}})}}}e.NotImplementedProxy=l;function _(p){throw new Error("Unreachable")}e.assertNever=_}),define(we[42],_e([0,1,21,8,15,10]),function(ee,e,m,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(s){return s===47||s===92}e.isPathSeparator=k;function D(s){return s.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=D;function b(s){return s.indexOf("/")===-1&&(s=D(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=b;function C(s,r=S.posix.sep){if(!s)return"";const l=s.length,_=s.charCodeAt(0);if(k(_)){if(k(s.charCodeAt(1))&&!k(s.charCodeAt(2))){let P=3;const A=P;for(;P<l&&!k(s.charCodeAt(P));P++);if(A!==P&&!k(s.charCodeAt(P+1))){for(P+=1;P<l;P++)if(k(s.charCodeAt(P)))return s.slice(0,P+1).replace(/[\\/]/g,r)}}return r}else if(v(_)&&s.charCodeAt(1)===58)return k(s.charCodeAt(2))?s.slice(0,2)+r:s.slice(0,2);let p=s.indexOf("://");if(p!==-1){for(p+=3;p<l;p++)if(k(s.charCodeAt(p)))return s.slice(0,p+1)}return""}e.getRoot=C;function n(s){if(!m.isWindows||!s||s.length<5)return!1;let r=s.charCodeAt(0);if(r!==92||(r=s.charCodeAt(1),r!==92))return!1;let l=2;const _=l;for(;l<s.length&&(r=s.charCodeAt(l),r!==92);l++);return!(_===l||(r=s.charCodeAt(l+1),isNaN(r)||r===92))}e.isUNC=n;const I=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(s,r=m.isWindows){const l=r?I:o;return!(!s||s.length===0||/^\s+$/.test(s)||(l.lastIndex=0,l.test(s))||r&&f.test(s)||s==="."||s===".."||r&&s[s.length-1]==="."||r&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=c;function d(s,r,l){const _=s===r;return!l||_?_:!s||!r?!1:T.equalsIgnoreCase(s,r)}e.isEqual=d;function w(s,r,l,_=S.sep){if(s===r)return!0;if(!s||!r||r.length>s.length)return!1;if(l){if(!T.startsWithIgnoreCase(s,r))return!1;if(r.length===s.length)return!0;let P=r.length;return r.charAt(r.length-1)===_&&P--,s.charAt(P)===_}return r.charAt(r.length-1)!==_&&(r+=_),s.indexOf(r)===0}e.isEqualOrParent=w;function v(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=v;function E(s,r){return m.isWindows&&s.endsWith(":")&&(s+=S.sep),S.isAbsolute(s)||(s=S.join(r,s)),s=S.normalize(s),m.isWindows?(s=T.rtrim(s,S.sep),s.endsWith(":")&&(s+=S.sep)):(s=T.rtrim(s,S.sep),s||(s=S.sep)),s}e.sanitizeFilePath=E;function u(s){const r=S.normalize(s);return m.isWindows?s.length>3?!1:h(r)&&(s.length===2||r.charCodeAt(2)===92):r===S.posix.sep}e.isRootOrDriveLetter=u;function h(s){return m.isWindows?v(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function g(s){return h(s)?s[0]:void 0}e.getDriveLetter=g;function t(s,r,l){return r.length>s.length?-1:s===r?0:(l&&(s=s.toLowerCase(),r=r.toLowerCase()),s.indexOf(r))}e.indexOfPath=t;function i(s){const r=s.split(":");let l,_,p;if(r.forEach(P=>{const A=Number(P);y.isNumber(A)?_===void 0?_=A:p===void 0&&(p=A):l=l?[l,P].join(":"):P}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:_!==void 0?_:void 0,column:p!==void 0?p:_!==void 0?1:void 0}}e.parseLineAndColumnAware=i}),define(we[24],_e([0,1,10]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function T(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const w=Array.isArray(d)?[]:{};return Object.keys(d).forEach(v=>{d[v]&&typeof d[v]=="object"?w[v]=T(d[v]):w[v]=d[v]}),w}e.deepClone=T;function S(d){if(!d||typeof d!="object")return d;const w=[d];for(;w.length>0;){const v=w.shift();Object.freeze(v);for(const E in v)if(y.call(v,E)){const u=v[E];typeof u=="object"&&!Object.isFrozen(u)&&w.push(u)}}return d}e.deepFreeze=S;const y=Object.prototype.hasOwnProperty;function k(d,w){return D(d,w,new Set)}e.cloneAndChange=k;function D(d,w,v){if(m.isUndefinedOrNull(d))return d;const E=w(d);if(typeof E!="undefined")return E;if(m.isArray(d)){const u=[];for(const h of d)u.push(D(h,w,v));return u}if(m.isObject(d)){if(v.has(d))throw new Error("Cannot clone recursive data-structure");v.add(d);const u={};for(let h in d)y.call(d,h)&&(u[h]=D(d[h],w,v));return v.delete(d),u}return d}function b(d,w,v=!0){return m.isObject(d)?(m.isObject(w)&&Object.keys(w).forEach(E=>{E in d?v&&(m.isObject(d[E])&&m.isObject(w[E])?b(d[E],w[E],v):d[E]=w[E]):d[E]=w[E]}),d):w}e.mixin=b;function C(d,w){if(d===w)return!0;if(d==null||w===null||w===void 0||typeof d!=typeof w||typeof d!="object"||Array.isArray(d)!==Array.isArray(w))return!1;let v,E;if(Array.isArray(d)){if(d.length!==w.length)return!1;for(v=0;v<d.length;v++)if(!C(d[v],w[v]))return!1}else{const u=[];for(E in d)u.push(E);u.sort();const h=[];for(E in w)h.push(E);if(h.sort(),!C(u,h))return!1;for(v=0;v<u.length;v++)if(!C(d[u[v]],w[u[v]]))return!1}return!0}e.equals=C;function n(d){const w=new Set;return JSON.stringify(d,(v,E)=>{if(m.isObject(E)||Array.isArray(E)){if(w.has(E))return"[Circular]";w.add(E)}return E})}e.safeStringify=n;function I(d,w,v){const E=w(d);return typeof E=="undefined"?v:E}e.getOrDefault=I;function o(d,w){const v=Object.create(null);return!d||!w||Object.keys(w).forEach(u=>{const h=d[u],g=w[u];C(h,g)||(v[u]=g)}),v}e.distinct=o;function f(d,w){const v=w.toLowerCase(),E=Object.keys(d).find(u=>u.toLowerCase()===v);return E?d[E]:d[w]}e.getCaseInsensitive=f;function c(d,w){const v=Object.create(null);for(const E of Object.keys(d))w(E,d[E])&&(v[E]=d[E]);return v}e.filter=c}),define(we[78],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var m;(function(y){y[y.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",y[y.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",y[y.MAX_UINT_8=255]="MAX_UINT_8",y[y.MAX_UINT_16=65535]="MAX_UINT_16",y[y.MAX_UINT_32=4294967295]="MAX_UINT_32",y[y.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m=e.Constants||(e.Constants={}));function T(y){return y<0?0:y>255?255:y|0}e.toUint8=T;function S(y){return y<0?0:y>4294967295?4294967295:y|0}e.toUint32=S}),define(we[2],_e([0,1,21,15]),function(ee,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const S=/^\w[\w\d+.-]*$/,y=/^\//,k=/^\/\//;function D(s,r){if(!s.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!S.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!y.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(s,r){return!s&&!r?"file":s}function C(s,r){switch(s){case"https":case"http":case"file":r?r[0]!==I&&(r=I+r):r=I;break}return r}const n="",I="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(r,l,_,p,P,A=!1){typeof r=="object"?(this.scheme=r.scheme||n,this.authority=r.authority||n,this.path=r.path||n,this.query=r.query||n,this.fragment=r.fragment||n):(this.scheme=b(r,A),this.authority=l||n,this.path=C(this.scheme,_||n),this.query=p||n,this.fragment=P||n,D(this,A))}static isUri(r){return r instanceof f?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return u(this,!1)}with(r){if(!r)return this;let{scheme:l,authority:_,path:p,query:P,fragment:A}=r;return l===void 0?l=this.scheme:l===null&&(l=n),_===void 0?_=this.authority:_===null&&(_=n),p===void 0?p=this.path:p===null&&(p=n),P===void 0?P=this.query:P===null&&(P=n),A===void 0?A=this.fragment:A===null&&(A=n),l===this.scheme&&_===this.authority&&p===this.path&&P===this.query&&A===this.fragment?this:new d(l,_,p,P,A)}static parse(r,l=!1){const _=o.exec(r);return _?new d(_[2]||n,i(_[4]||n),i(_[5]||n),i(_[7]||n),i(_[9]||n),l):new d(n,n,n,n,n)}static file(r){let l=n;if(m.isWindows&&(r=r.replace(/\\/g,I)),r[0]===I&&r[1]===I){const _=r.indexOf(I,2);_===-1?(l=r.substring(2),r=I):(l=r.substring(2,_),r=r.substring(_)||I)}return new d("file",l,r,n,n)}static from(r){const l=new d(r.scheme,r.authority,r.path,r.query,r.fragment);return D(l,!0),l}static joinPath(r,...l){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let _;return m.isWindows&&r.scheme==="file"?_=f.file(T.win32.join(u(r,!0),...l)).path:_=T.posix.join(r.path,...l),r.with({path:_})}toString(r=!1){return h(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof f)return r;{const l=new d(r);return l._formatted=r.external,l._fsPath=r._sep===c?r.fsPath:null,l}}else return r}}e.URI=f;const c=m.isWindows?1:void 0;class d extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(r=!1){return r?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=c),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(s,r){let l,_=-1;for(let p=0;p<s.length;p++){const P=s.charCodeAt(p);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||r&&P===47)_!==-1&&(l+=encodeURIComponent(s.substring(_,p)),_=-1),l!==void 0&&(l+=s.charAt(p));else{l===void 0&&(l=s.substr(0,p));const A=w[P];A!==void 0?(_!==-1&&(l+=encodeURIComponent(s.substring(_,p)),_=-1),l+=A):_===-1&&(_=p)}}return _!==-1&&(l+=encodeURIComponent(s.substring(_))),l!==void 0?l:s}function E(s){let r;for(let l=0;l<s.length;l++){const _=s.charCodeAt(l);_===35||_===63?(r===void 0&&(r=s.substr(0,l)),r+=w[_]):r!==void 0&&(r+=s[l])}return r!==void 0?r:s}function u(s,r){let l;return s.authority&&s.path.length>1&&s.scheme==="file"?l=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?r?l=s.path.substr(1):l=s.path[1].toLowerCase()+s.path.substr(2):l=s.path,m.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=u;function h(s,r){const l=r?E:v;let _="",{scheme:p,authority:P,path:A,query:a,fragment:R}=s;if(p&&(_+=p,_+=":"),(P||p==="file")&&(_+=I,_+=I),P){let F=P.indexOf("@");if(F!==-1){const x=P.substr(0,F);P=P.substr(F+1),F=x.indexOf(":"),F===-1?_+=l(x,!1):(_+=l(x.substr(0,F),!1),_+=":",_+=l(x.substr(F+1),!1)),_+="@"}P=P.toLowerCase(),F=P.indexOf(":"),F===-1?_+=l(P,!1):(_+=l(P.substr(0,F),!1),_+=P.substr(F))}if(A){if(A.length>=3&&A.charCodeAt(0)===47&&A.charCodeAt(2)===58){const F=A.charCodeAt(1);F>=65&&F<=90&&(A=`/${String.fromCharCode(F+32)}:${A.substr(3)}`)}else if(A.length>=2&&A.charCodeAt(1)===58){const F=A.charCodeAt(0);F>=65&&F<=90&&(A=`${String.fromCharCode(F+32)}:${A.substr(2)}`)}_+=l(A,!0)}return a&&(_+="?",_+=l(a,!1)),R&&(_+="#",_+=r?R:v(R,!1)),_}function g(s){try{return decodeURIComponent(s)}catch(r){return s.length>3?s.substr(0,3)+g(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(s){return s.match(t)?s.replace(t,r=>g(r)):s}});var rt=this&&this.__classPrivateFieldSet||function(ee,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,m):S?S.value=m:e.set(ee,m),m},Ue=this&&this.__classPrivateFieldGet||function(ee,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[22],_e([0,1,2,8]),function(ee,e,m,T){"use strict";var S,y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(t,i,s){let r=t.get(i);return r===void 0&&(r=s,t.set(i,r)),r}e.getOrSet=D;function b(t){const i=[];return t.forEach((s,r)=>{i.push(`${r} => ${s}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=b;function C(t){const i=[];return t.forEach(s=>{i.push(s)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=C;class n{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),r=this._value.charCodeAt(this._pos);return s-r}value(){return this._value[this._pos]}}e.StringIterator=n;class I{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?T.compareSubstring(i,this._value,0,i.length,this._from,this._to):T.compareSubstringIgnoreCase(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class o{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?T.compareSubstring(i,this._value,0,i.length,this._from,this._to):T.compareSubstringIgnoreCase(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=o;var f;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(f||(f={}));class c{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new o(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return T.compareIgnoreCase(i,this._value.scheme);if(this._states[this._stateIdx]===2)return T.compareIgnoreCase(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return T.compare(i,this._value.query);if(this._states[this._stateIdx]===5)return T.compare(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=c;class d{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class w{constructor(i){this._iter=i}static forUris(i=()=>!1){return new w(new c(i))}static forPaths(){return new w(new o)}static forStrings(){return new w(new n)}static forConfigKeys(){return new w(new I)}clear(){this._root=void 0}set(i,s){const r=this._iter.reset(i);let l;for(this._root||(this._root=new d,this._root.segment=r.value()),l=this._root;;){const p=r.cmp(l.segment);if(p>0)l.left||(l.left=new d,l.left.segment=r.value()),l=l.left;else if(p<0)l.right||(l.right=new d,l.right.segment=r.value()),l=l.right;else if(r.hasNext())r.next(),l.mid||(l.mid=new d,l.mid.segment=r.value()),l=l.mid;else break}const _=l.value;return l.value=s,l.key=i,_}get(i){var s;return(s=this._getNode(i))===null||s===void 0?void 0:s.value}_getNode(i){const s=this._iter.reset(i);let r=this._root;for(;r;){const l=s.cmp(r.segment);if(l>0)r=r.left;else if(l<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else break}return r}has(i){const s=this._getNode(i);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const r=this._iter.reset(i),l=[];let _=this._root;for(;_;){const p=r.cmp(_.segment);if(p>0)l.push([1,_]),_=_.left;else if(p<0)l.push([-1,_]),_=_.right;else if(r.hasNext())r.next(),l.push([0,_]),_=_.mid;else{for(s?(_.left=void 0,_.mid=void 0,_.right=void 0):_.value=void 0;l.length>0&&_.isEmpty();){let[P,A]=l.pop();switch(P){case 1:A.left=void 0;break;case 0:A.mid=void 0;break;case-1:A.right=void 0;break}_=A}break}}}findSubstr(i){const s=this._iter.reset(i);let r=this._root,l;for(;r;){const _=s.cmp(r.segment);if(_>0)r=r.left;else if(_<0)r=r.right;else if(s.hasNext())s.next(),l=r.value||l,r=r.mid;else break}return r&&r.value||l}findSuperstr(i){const s=this._iter.reset(i);let r=this._root;for(;r;){const l=s.cmp(r.segment);if(l>0)r=r.left;else if(l<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(i){for(const[s,r]of this)i(r,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){if(!i)return;const s=[i];for(;s.length>0;){const r=s.pop();r&&(r.value&&(yield[r.key,r.value]),r.left&&s.push(r.left),r.mid&&s.push(r.mid),r.right&&s.push(r.right))}}}e.TernarySearchTree=w;class v{constructor(i,s){this[S]="ResourceMap",i instanceof v?(this.map=new Map(i.map),this.toKey=s??v.defaultToKey):(this.map=new Map,this.toKey=i??v.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),s),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(let[r,l]of this.map)i(l,m.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield m.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[m.URI.parse(i[0]),i[1]]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[m.URI.parse(i[0]),i[1]]}}e.ResourceMap=v,v.defaultToKey=t=>t.toString();var E;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class u{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,s=0){const r=this._map.get(i);if(!!r)return s!==0&&this.touch(r,s),r.value}set(i,s,r=0){let l=this._map.get(i);if(l)l.value=s,r!==0&&this.touch(l,r);else{switch(l={key:i,value:s,next:void 0,previous:void 0},r){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(i,l),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const r=this._state;let l=this._head;for(;l;){if(s?i.bind(s)(l.value,l.key,this):i(l.value,l.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const i=this,s=this._state;let r=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const _={value:r.key,done:!1};return r=r.next,_}else return{value:void 0,done:!0}}};return l}values(){const i=this,s=this._state;let r=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const _={value:r.value,done:!1};return r=r.next,_}else return{value:void 0,done:!0}}};return l}entries(){const i=this,s=this._state;let r=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const _={value:[r.key,r.value],done:!1};return r=r.next,_}else return{value:void 0,done:!0}}};return l}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,r=this.size;for(;s&&r>i;)this._map.delete(s.key),s=s.next,r--;this._head=s,this._size=r,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,r=i.previous;if(!s||!r)throw new Error("Invalid list");s.previous=r,r.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const r=i.next,l=i.previous;i===this._tail?(l.next=void 0,this._tail=l):(r.previous=l,l.next=r),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const r=i.next,l=i.previous;i===this._head?(r.previous=void 0,this._head=r):(r.previous=l,l.next=r),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,r)=>{i.push([r,s])}),i}fromJSON(i){this.clear();for(const[s,r]of i)this.set(s,r)}}e.LinkedMap=u;class h extends u{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=h;class g{constructor(i){k.set(this,void 0),rt(this,k,i,"f")}get size(){return Ue(this,k,"f").size}forEach(i,s){Ue(this,k,"f").forEach(i,s)}get(i){return Ue(this,k,"f").get(i)}has(i){return Ue(this,k,"f").has(i)}entries(){return Ue(this,k,"f").entries()}keys(){return Ue(this,k,"f").keys()}values(){return Ue(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Ue(this,k,"f").entries()}}e.ReadonlyMapView=g}),define(we[110],_e([0,1,22,8]),function(ee,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function S(...q){return function(oe,fe){for(let Re=0,xe=q.length;Re<xe;Re++){const pe=q[Re](oe,fe);if(pe)return pe}return null}}e.or=S,e.matchesStrictPrefix=y.bind(void 0,!1),e.matchesPrefix=y.bind(void 0,!0);function y(q,oe,fe){if(!fe||fe.length<oe.length)return null;let Re;return q?Re=T.startsWithIgnoreCase(fe,oe):Re=fe.indexOf(oe)===0,Re?oe.length>0?[{start:0,end:oe.length}]:[]:null}function k(q,oe){const fe=oe.toLowerCase().indexOf(q.toLowerCase());return fe===-1?null:[{start:fe,end:fe+q.length}]}e.matchesContiguousSubString=k;function D(q,oe){return b(q.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=D;function b(q,oe,fe,Re){if(fe===q.length)return[];if(Re===oe.length)return null;if(q[fe]===oe[Re]){let xe=null;return(xe=b(q,oe,fe+1,Re+1))?v({start:Re,end:Re+1},xe):null}return b(q,oe,fe,Re+1)}function C(q){return 97<=q&&q<=122}function n(q){return 65<=q&&q<=90}e.isUpper=n;function I(q){return 48<=q&&q<=57}function o(q){return q===32||q===9||q===10||q===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(q=>f.add(q.charCodeAt(0)));function c(q){return o(q)||f.has(q)}function d(q,oe){return q===oe||c(q)&&c(oe)}function w(q){return C(q)||n(q)||I(q)}function v(q,oe){return oe.length===0?oe=[q]:q.end===oe[0].start?oe[0].start=q.start:oe.unshift(q),oe}function E(q,oe){for(let fe=oe;fe<q.length;fe++){const Re=q.charCodeAt(fe);if(n(Re)||I(Re)||fe>0&&!w(q.charCodeAt(fe-1)))return fe}return q.length}function u(q,oe,fe,Re){if(fe===q.length)return[];if(Re===oe.length)return null;if(q[fe]!==oe[Re].toLowerCase())return null;{let xe=null,pe=Re+1;for(xe=u(q,oe,fe+1,Re+1);!xe&&(pe=E(oe,pe))<oe.length;)xe=u(q,oe,fe+1,pe),pe++;return xe===null?null:v({start:Re,end:Re+1},xe)}}function h(q){let oe=0,fe=0,Re=0,xe=0,pe=0;for(let Te=0;Te<q.length;Te++)pe=q.charCodeAt(Te),n(pe)&&oe++,C(pe)&&fe++,w(pe)&&Re++,I(pe)&&xe++;const qe=oe/q.length,H=fe/q.length,te=Re/q.length,me=xe/q.length;return{upperPercent:qe,lowerPercent:H,alphaPercent:te,numericPercent:me}}function g(q){const{upperPercent:oe,lowerPercent:fe}=q;return fe===0&&oe>.6}function t(q){const{upperPercent:oe,lowerPercent:fe,alphaPercent:Re,numericPercent:xe}=q;return fe>.2&&oe<.8&&Re>.6&&xe<.2}function i(q){let oe=0,fe=0,Re=0,xe=0;for(let pe=0;pe<q.length;pe++)Re=q.charCodeAt(pe),n(Re)&&oe++,C(Re)&&fe++,o(Re)&&xe++;return(oe===0||fe===0)&&xe===0?q.length<=30:oe<=5}function s(q,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!i(q)||oe.length>60)return null;const fe=h(oe);if(!t(fe)){if(!g(fe))return null;oe=oe.toLowerCase()}let Re=null,xe=0;for(q=q.toLowerCase();xe<oe.length&&(Re=u(q,oe,0,xe))===null;)xe=E(oe,xe+1);return Re}e.matchesCamelCase=s;function r(q,oe,fe=!1){if(!oe||oe.length===0)return null;let Re=null,xe=0;for(q=q.toLowerCase(),oe=oe.toLowerCase();xe<oe.length&&(Re=l(q,oe,0,xe,fe))===null;)xe=_(oe,xe+1);return Re}e.matchesWords=r;function l(q,oe,fe,Re,xe){if(fe===q.length)return[];if(Re===oe.length)return null;if(d(q.charCodeAt(fe),oe.charCodeAt(Re))){let pe=null,qe=Re+1;if(pe=l(q,oe,fe+1,Re+1,xe),!xe)for(;!pe&&(qe=_(oe,qe))<oe.length;)pe=l(q,oe,fe+1,qe,xe),qe++;return pe===null?null:v({start:Re,end:Re+1},pe)}else return null}function _(q,oe){for(let fe=oe;fe<q.length;fe++)if(c(q.charCodeAt(fe))||fe>0&&c(q.charCodeAt(fe-1)))return fe;return q.length}const p=S(e.matchesPrefix,s,k),P=S(e.matchesPrefix,s,D),A=new m.LRUCache(1e4);function a(q,oe,fe=!1){if(typeof q!="string"||typeof oe!="string")return null;let Re=A.get(q);Re||(Re=new RegExp(T.convertSimple2RegExpPattern(q),"i"),A.set(q,Re));const xe=Re.exec(oe);return xe?[{start:xe.index,end:xe.index+xe[0].length}]:fe?P(q,oe):p(q,oe)}e.matchesFuzzy=a;function R(q,oe){const fe=tt(q,q.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return fe?x(fe):null}e.matchesFuzzy2=R;function F(q,oe,fe,Re,xe,pe){const qe=Math.min(13,q.length);for(;fe<qe;fe++){const H=tt(q,oe,fe,Re,xe,pe,!1);if(H)return H}return[0,pe]}e.anyScore=F;function x(q){if(typeof q=="undefined")return[];const oe=[],fe=q[1];for(let Re=q.length-1;Re>1;Re--){const xe=q[Re]+fe,pe=oe[oe.length-1];pe&&pe.end===xe?pe.end=xe+1:oe.push({start:xe,end:xe+1})}return oe}e.createMatches=x;const J=128;function ae(){const q=[],oe=[];for(let fe=0;fe<=J;fe++)oe[fe]=0;for(let fe=0;fe<=J;fe++)q.push(oe.slice(0));return q}function j(q){const oe=[];for(let fe=0;fe<=q;fe++)oe[fe]=0;return oe}const W=j(2*J),Q=j(2*J),M=ae(),X=ae(),B=ae(),U=!1;function Y(q,oe,fe,Re,xe){function pe(H,te,me=" "){for(;H.length<te;)H=me+H;return H}let qe=` |   |${Re.split("").map(H=>pe(H,3)).join("|")}
`;for(let H=0;H<=fe;H++)H===0?qe+=" |":qe+=`${oe[H-1]}|`,qe+=q[H].slice(0,xe+1).map(te=>pe(te.toString(),3)).join("|")+`
`;return qe}function V(q,oe,fe,Re){q=q.substr(oe),fe=fe.substr(Re),console.log(Y(X,q,q.length,fe,fe.length)),console.log(Y(B,q,q.length,fe,fe.length)),console.log(Y(M,q,q.length,fe,fe.length))}function ce(q,oe){if(oe<0||oe>=q.length)return!1;const fe=q.codePointAt(oe);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise(fe)}}function ge(q,oe){if(oe<0||oe>=q.length)return!1;switch(q.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function Ae(q,oe,fe){return oe[q]!==fe[q]}function $e(q,oe,fe,Re,xe,pe,qe=!1){for(;oe<fe&&xe<pe;)q[oe]===Re[xe]&&(qe&&(W[oe]=xe),oe+=1),xe+=1;return oe===fe}e.isPatternInWord=$e;var Fe;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(Fe||(Fe={}));var Ve;(function(q){q.Default=[-100,0];function oe(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}q.isDefault=oe})(Ve=e.FuzzyScore||(e.FuzzyScore={}));function tt(q,oe,fe,Re,xe,pe,qe){const H=q.length>J?J:q.length,te=Re.length>J?J:Re.length;if(fe>=H||pe>=te||H-fe>te-pe||!$e(oe,fe,H,xe,pe,te,!0))return;Ke(H,te,fe,pe,oe,xe);let me=1,Te=1,Le=fe,Ge=pe;const Se=[!1];for(me=1,Le=fe;Le<H;me++,Le++){const N=W[Le],G=Q[Le],le=Le+1<H?Q[Le+1]:te;for(Te=N-pe+1,Ge=N;Ge<le;Te++,Ge++){let ke=Number.MIN_SAFE_INTEGER,Pe=!1;Ge<=G&&(ke=Qe(q,oe,Le,fe,Re,xe,Ge,te,pe,M[me-1][Te-1]===0,Se));let Ne=0;ke!==Number.MAX_SAFE_INTEGER&&(Pe=!0,Ne=ke+X[me-1][Te-1]);const Be=Ge>N,Ze=Be?X[me][Te-1]+(M[me][Te-1]>0?-5:0):0,Je=Ge>N+1&&M[me][Te-1]>0,Ye=Je?X[me][Te-2]+(M[me][Te-2]>0?-5:0):0;if(Je&&(!Be||Ye>=Ze)&&(!Pe||Ye>=Ne))X[me][Te]=Ye,B[me][Te]=3,M[me][Te]=0;else if(Be&&(!Pe||Ze>=Ne))X[me][Te]=Ze,B[me][Te]=2,M[me][Te]=0;else if(Pe)X[me][Te]=Ne,B[me][Te]=1,M[me][Te]=M[me-1][Te-1]+1;else throw new Error("not possible")}}if(U&&V(q,fe,Re,pe),!Se[0]&&!qe)return;me--,Te--;const be=[X[me][Te],pe];let Ce=0,re=0;for(;me>=1;){let N=Te;do{const G=B[me][N];if(G===3)N=N-2;else if(G===2)N=N-1;else break}while(N>=1);Ce>1&&oe[fe+me-1]===xe[pe+Te-1]&&!Ae(N+pe-1,Re,xe)&&Ce+1>M[me][N]&&(N=Te),N===Te?Ce++:Ce=1,re||(re=N),me--,Te=N-1,be.push(Te)}te===H&&(be[0]+=2);const de=re-H;return be[0]-=de,be}e.fuzzyScore=tt;function Ke(q,oe,fe,Re,xe,pe){let qe=q-1,H=oe-1;for(;qe>=fe&&H>=Re;)xe[qe]===pe[H]&&(Q[qe]=H,qe--),H--}function Qe(q,oe,fe,Re,xe,pe,qe,H,te,me,Te){if(oe[fe]!==pe[qe])return Number.MIN_SAFE_INTEGER;let Le=1,Ge=!1;return qe===fe-Re?Le=q[fe]===xe[qe]?7:5:Ae(qe,xe,pe)&&(qe===0||!Ae(qe-1,xe,pe))?(Le=q[fe]===xe[qe]?7:5,Ge=!0):ce(pe,qe)&&(qe===0||!ce(pe,qe-1))?Le=5:(ce(pe,qe-1)||ge(pe,qe-1))&&(Le=5,Ge=!0),Le>1&&fe===Re&&(Te[0]=!0),Ge||(Ge=Ae(qe,xe,pe)||ce(pe,qe-1)||ge(pe,qe-1)),fe===Re?qe>te&&(Le-=Ge?3:5):me?Le+=Ge?2:0:Le+=Ge?0:1,qe+1===H&&(Le-=Ge?3:5),Le}function $(q,oe,fe,Re,xe,pe,qe){return ie(q,oe,fe,Re,xe,pe,!0,qe)}e.fuzzyScoreGracefulAggressive=$;function K(q,oe,fe,Re,xe,pe,qe){return ie(q,oe,fe,Re,xe,pe,!1,qe)}e.fuzzyScoreGraceful=K;function ie(q,oe,fe,Re,xe,pe,qe,H){let te=tt(q,oe,fe,Re,xe,pe,H);if(te&&!qe)return te;if(q.length>=3){const me=Math.min(7,q.length-1);for(let Te=fe+1;Te<me;Te++){const Le=se(q,Te);if(Le){const Ge=tt(Le,Le.toLowerCase(),fe,Re,xe,pe,H);Ge&&(Ge[0]-=3,(!te||Ge[0]>te[0])&&(te=Ge))}}}return te}function se(q,oe){if(oe+1>=q.length)return;const fe=q[oe],Re=q[oe+1];if(fe!==Re)return q.slice(0,oe)+Re+fe+q.slice(oe+2)}}),define(we[111],_e([0,1,77,110,8]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const y=new RegExp(`\\$\\(${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(`(\\\\)?${y.source}`,"g");function D(d){return d.replace(k,(w,v)=>v?w:`\\${w}`)}e.escapeIcons=D;const b=new RegExp(`\\\\${y.source}`,"g");function C(d){return d.replace(b,w=>`\\${w}`)}e.markdownEscapeEscapedIcons=C;const n=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function I(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(n,(w,v,E,u)=>E?w:v||u||"")}e.stripIcons=I;function o(d){const w=d.indexOf(e.iconStartMarker);return w===-1?{text:d}:f(d,w)}e.parseLabelWithIcons=o;function f(d,w){const v=[];let E="";function u(_){if(_){E+=_;for(const p of _)v.push(t)}}let h=-1,g="",t=0,i,s,r=w;const l=d.length;for(u(d.substr(0,w));r<l;)i=d[r],s=d[r+1],i===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(h=r,u(g),g=e.iconStartMarker,r++):i===")"&&h!==-1?(t+=r-h+1,h=-1,g=""):h!==-1?/^[a-z0-9\-]$/i.test(i)?g+=i:(u(g),h=-1,g=""):u(i),r++;return u(g),{text:E,iconOffsets:v}}function c(d,w,v=!1){const{text:E,iconOffsets:u}=w;if(!u||u.length===0)return T.matchesFuzzy(d,E,v);const h=S.ltrim(E," "),g=E.length-h.length,t=T.matchesFuzzy(d,h,v);if(t)for(const i of t){const s=u[i.start+g]+g;i.start+=s,i.end+=s}return t}e.matchesFuzzyIconAware=c}),define(we[79],_e([0,1,111,11]),function(ee,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var S;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(S=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(f="",c=!1){var d,w;if(this.value=f,typeof this.value!="string")throw T.illegalArgument("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1):(this.isTrusted=(d=c.isTrusted)!==null&&d!==void 0?d:void 0,this.supportThemeIcons=(w=c.supportThemeIcons)!==null&&w!==void 0?w:!1)}appendText(f,c=0){return this.value+=C(this.supportThemeIcons?m.escapeIcons(f):f).replace(/([ \t]+)/g,(d,w)=>"&nbsp;".repeat(w.length)).replace(/^>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,c){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}}e.MarkdownString=y;function k(o){return D(o)?!o.value:Array.isArray(o)?o.every(k):!0}e.isEmptyMarkdownString=k;function D(o){return o instanceof y?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function b(o,f){return o===f?!0:!o||!f?!1:o.value===f.value&&o.isTrusted===f.isTrusted&&o.supportThemeIcons===f.supportThemeIcons}e.markdownStringEqual=b;function C(o){return o.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function n(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function I(o){const f=[],c=o.split("|").map(w=>w.trim());o=c[0];const d=c[1];if(d){const w=/height=(\d+)/.exec(d),v=/width=(\d+)/.exec(d),E=w?w[1]:"",u=v?v[1]:"",h=isFinite(parseInt(u)),g=isFinite(parseInt(E));h&&f.push(`width="${u}"`),g&&f.push(`height="${E}"`)}return{href:o,dimensions:f}}e.parseHrefAndDimensions=I}),define(we[54],_e([0,1,23,8,2]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function y(n){return JSON.stringify(n,b)}e.stringify=y;function k(n){let I=JSON.parse(n);return I=C(I),I}e.parse=k;var D;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(D=e.MarshalledId||(e.MarshalledId={}));function b(n,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:T.regExpFlags(I)}:I}function C(n,I=0){if(!n||I>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return S.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof m.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let o=0;o<n.length;++o)n[o]=C(n[o],I+1);else for(const o in n)Object.hasOwnProperty.call(n,o)&&(n[o]=C(n[o],I+1))}return n}e.revive=C}),define(we[12],_e([0,1,2,21]),function(ee,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var S;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp"})(S=e.Schemas||(e.Schemas={}));class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}set(b,C,n){this._hosts[b]=C,this._ports[b]=n}setConnectionToken(b,C){this._connectionTokens[b]=C}rewrite(b){if(this._delegate)return this._delegate(b);const C=b.authority;let n=this._hosts[C];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const I=this._ports[C],o=this._connectionTokens[C];let f=`path=${encodeURIComponent(b.path)}`;return typeof o=="string"&&(f+=`&tkn=${encodeURIComponent(o)}`),m.URI.from({scheme:T.isWeb?this._preferredWebSchema:S.vscodeRemoteResource,authority:`${n}:${I}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new y;class k{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(b,C,n){const I=this.toUri(b,C);if(I.scheme===S.vscodeRemote)return e.RemoteAuthorities.rewrite(I);let o=!1;return T.isNative&&(n||T.isPreferringBrowserCodeLoad)&&I.scheme===S.file&&(o=!0),I.scheme===S.file&&typeof T.globals.importScripts=="function"&&T.globals.origin==="vscode-file://vscode-app"&&(o=!0),o?I.with({scheme:S.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(b,C){const n=this.toUri(b,C);return n.scheme===S.vscodeFileResource?n.with({scheme:S.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(b,C){return m.URI.isUri(b)?b:m.URI.parse(C.toUrl(b))}}e.FileAccess=new k}),define(we[25],_e([0,1,42,15,2,8,12,21]),function(ee,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(f){return S.uriToFsPath(f,!0)}e.originalFSPath=b;class C{constructor(c){this._ignorePathCasing=c}compare(c,d,w=!1){return c===d?0:y.compare(this.getComparisonKey(c,w),this.getComparisonKey(d,w))}isEqual(c,d,w=!1){return c===d?!0:!c||!d?!1:this.getComparisonKey(c,w)===this.getComparisonKey(d,w)}getComparisonKey(c,d=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,d,w=!1){if(c.scheme===d.scheme){if(c.scheme===k.Schemas.file)return m.isEqualOrParent(b(c),b(d),this._ignorePathCasing(c))&&c.query===d.query&&(w||c.fragment===d.fragment);if(e.isEqualAuthority(c.authority,d.authority))return m.isEqualOrParent(c.path,d.path,this._ignorePathCasing(c),"/")&&c.query===d.query&&(w||c.fragment===d.fragment)}return!1}joinPath(c,...d){return S.URI.joinPath(c,...d)}basenameOrAuthority(c){return e.basename(c)||c.authority}basename(c){return T.posix.basename(c.path)}extname(c){return T.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let d;return c.scheme===k.Schemas.file?d=S.URI.file(T.dirname(b(c))).path:(d=T.posix.dirname(c.path),c.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),d="/")),c.with({path:d})}normalizePath(c){if(!c.path.length)return c;let d;return c.scheme===k.Schemas.file?d=S.URI.file(T.normalize(b(c))).path:d=T.posix.normalize(c.path),c.with({path:d})}relativePath(c,d){if(c.scheme!==d.scheme||!e.isEqualAuthority(c.authority,d.authority))return;if(c.scheme===k.Schemas.file){const E=T.relative(b(c),b(d));return D.isWindows?m.toSlashes(E):E}let w=c.path||"/",v=d.path||"/";if(this._ignorePathCasing(c)){let E=0;for(const u=Math.min(w.length,v.length);E<u&&!(w.charCodeAt(E)!==v.charCodeAt(E)&&w.charAt(E).toLowerCase()!==v.charAt(E).toLowerCase());E++);w=v.substr(0,E)+w.substr(E)}return T.posix.relative(w,v)}resolvePath(c,d){if(c.scheme===k.Schemas.file){const w=S.URI.file(T.resolve(b(c),d));return c.with({authority:w.authority,path:w.path})}return d=m.toPosixPath(d),c.with({path:T.posix.resolve(c.path,d)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,d){return c===d||y.equalsIgnoreCase(c,d)}hasTrailingPathSeparator(c,d=T.sep){if(c.scheme===k.Schemas.file){const w=b(c);return w.length>m.getRoot(w).length&&w[w.length-1]===d}else{const w=c.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,d=T.sep){return e.hasTrailingPathSeparator(c,d)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,d=T.sep){let w=!1;if(c.scheme===k.Schemas.file){const v=b(c);w=v!==void 0&&v.length===m.getRoot(v).length&&v[v.length-1]===d}else{d="/";const v=c.path;w=v.length===1&&v.charCodeAt(v.length-1)===47}return!w&&!e.hasTrailingPathSeparator(c,d)?c.with({path:c.path+"/"}):c}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(f=>f.scheme===k.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new C(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(f,c){const d=[];for(let w=0;w<f.length;w++){const v=c(f[w]);f.some((E,u)=>u===w?!1:e.isEqualOrParent(v,c(E)))||d.push(f[w])}return d}e.distinctParents=n;var I;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function c(d){const w=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(u=>{const[h,g]=u.split(":");h&&g&&w.set(h,g)});const E=d.path.substring(0,d.path.indexOf(";"));return E&&w.set(f.META_DATA_MIME,E),w}f.parseMetaData=c})(I=e.DataUri||(e.DataUri={}));function o(f,c,d){if(c){let w=f.path;return w&&w[0]!==T.posix.sep&&(w=T.posix.sep+w),f.with({scheme:d,authority:c,path:w})}return f.with({scheme:d})}e.toLocalResource=o}),define(we[13],_e([0,1,18,11,3,7,51,25]),function(ee,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(B){return!!B&&typeof B.then=="function"}e.isThenable=b;function C(B){const U=new m.CancellationTokenSource,Y=B(U.token),V=new Promise((ce,ge)=>{U.token.onCancellationRequested(()=>{ge(T.canceled())}),Promise.resolve(Y).then(Ae=>{U.dispose(),ce(Ae)},Ae=>{U.dispose(),ge(Ae)})});return new class{cancel(){U.cancel()}then(ce,ge){return V.then(ce,ge)}catch(ce){return this.then(void 0,ce)}finally(ce){return V.finally(ce)}}}e.createCancelablePromise=C;function n(B,U,Y){return Promise.race([B,new Promise(V=>U.onCancellationRequested(()=>V(Y)))])}e.raceCancellation=n;async function I(B){let U=-1;const Y=B.map((ce,ge)=>ce.then(Ae=>(U=ge,Ae))),V=await Promise.race(Y);return B.forEach((ce,ge)=>{ge!==U&&ce.cancel()}),V}e.raceCancellablePromises=I;function o(B,U,Y){let V;const ce=setTimeout(()=>{V==null||V(void 0),Y==null||Y()},U);return Promise.race([B.finally(()=>clearTimeout(ce)),new Promise(ge=>V=ge)])}e.raceTimeout=o;function f(B){return new Promise((U,Y)=>{const V=B();b(V)?V.then(U,Y):U(V)})}e.asPromise=f;class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const Y=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(Y,Y).then(V)})}return new Promise((Y,V)=>{this.queuedPromise.then(Y,V)})}return this.activePromise=U(),new Promise((Y,V)=>{this.activePromise.then(ce=>{this.activePromise=null,Y(ce)},ce=>{this.activePromise=null,V(ce)})})}}e.Throttler=c;class d{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=d;class w{constructor(){this.promiseMap=new Map}queue(U,Y){var V;const ge=((V=this.promiseMap.get(U))!==null&&V!==void 0?V:Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.promiseMap.get(U)===ge&&this.promiseMap.delete(U)});return this.promiseMap.set(U,ge),ge}}e.SequencerByKey=w;class v{constructor(U){this.defaultDelay=U,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,Y=this.defaultDelay){return this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,ce)=>{this.doResolve=V,this.doReject=ce}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},Y),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(T.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=v;class E{constructor(U){this.delayer=new v(U),this.throttler=new c}trigger(U,Y){return this.delayer.trigger(()=>this.throttler.queue(U),Y)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class u{constructor(){this._isOpen=!1,this._promise=new Promise((U,Y)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class h extends u{constructor(U){super();this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function g(B,U){return U?new Promise((Y,V)=>{const ce=setTimeout(Y,B);U.onCancellationRequested(()=>{clearTimeout(ce),V(T.canceled())})}):C(Y=>g(B,Y))}e.timeout=g;function t(B,U=0){const Y=setTimeout(B,U);return y.toDisposable(()=>clearTimeout(Y))}e.disposableTimeout=t;function i(B){return B.then(void 0,U=>{})}e.ignoreErrors=i;function s(B){const U=[];let Y=0;const V=B.length;function ce(){return Y<V?B[Y++]():null}function ge(Ae){Ae!=null&&U.push(Ae);const $e=ce();return $e?$e.then(ge):Promise.resolve(U)}return Promise.resolve(null).then(ge)}e.sequence=s;function r(B,U=V=>!!V,Y=null){let V=0;const ce=B.length,ge=()=>{if(V>=ce)return Promise.resolve(Y);const Ae=B[V++];return Promise.resolve(Ae()).then(Fe=>U(Fe)?Promise.resolve(Fe):ge())};return ge()}e.first=r;function l(B,U=V=>!!V,Y=null){if(B.length===0)return Promise.resolve(Y);let V=B.length;const ce=()=>{var ge,Ae;V=-1;for(const $e of B)(Ae=(ge=$e).cancel)===null||Ae===void 0||Ae.call(ge)};return new Promise((ge,Ae)=>{for(const $e of B)$e.then(Fe=>{--V>=0&&U(Fe)?(ce(),ge(Fe)):V===0&&ge(Y)}).catch(Fe=>{--V>=0&&(ce(),Ae(Fe))})})}e.firstParallel=l;class _{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new S.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(U){return this._size++,new Promise((Y,V)=>{this.outstandingPromises.push({factory:U,c:Y,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const Y=U.factory();Y.then(U.c,U.e),Y.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=_;class p extends _{constructor(){super(1)}}e.Queue=p;class P{constructor(){this.queues=new Map}queueFor(U,Y=D.extUri){const V=Y.getComparisonKey(U);let ce=this.queues.get(V);return ce||(ce=new p,S.Event.once(ce.onFinished)(()=>{ce==null||ce.dispose(),this.queues.delete(V)}),this.queues.set(V,ce)),ce}dispose(){this.queues.forEach(U=>U.dispose()),this.queues.clear()}}e.ResourceQueue=P;class A{constructor(U,Y){this._token=-1,typeof U=="function"&&typeof Y=="number"&&this.setIfNotSet(U,Y)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,Y){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},Y)}setIfNotSet(U,Y){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},Y))}}e.TimeoutTimer=A;class a{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,Y){this.cancel(),this._token=setInterval(()=>{U()},Y)}}e.IntervalTimer=a;class R{constructor(U,Y){this.timeoutToken=-1,this.runner=U,this.timeout=Y,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class F extends R{constructor(U,Y){super(U,Y);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner&&this.runner(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F;class x extends y.Disposable{constructor(U,Y,V,ce){super();this.maxWorkChunkSize=U,this.maxPendingWork=Y,this.throttleDelay=V,this.handler=ce,this.pendingWork=[],this.throttler=this._register(new y.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(U){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+U.length>this.maxPendingWork)return!1}else if(this.pending+U.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...U),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=x,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const B=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=U=>{const Y=setTimeout(()=>U(B));let V=!1;return{dispose(){V||(V=!0,clearTimeout(Y))}}}}else e.runWhenIdle=(B,U)=>{const Y=requestIdleCallback(B,typeof U=="number"?{timeout:U}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(Y))}}}}();class J{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(Y){this._error=Y}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=J;async function ae(B,U,Y){let V;for(let ce=0;ce<Y;ce++)try{return await B()}catch(ge){V=ge,await g(U)}throw V}e.retry=ae;class j{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var U;(U=this._pending)===null||U===void 0||U.cancel()}setPending(U,Y,V){return this._pending={taskId:U,cancel:()=>V==null?void 0:V(),promise:Y},Y.then(()=>this.donePending(U),()=>this.donePending(U)),Y}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let Y,V;const ce=new Promise((ge,Ae)=>{Y=ge,V=Ae});this._next={run:U,promise:ce,promiseResolve:Y,promiseReject:V}}return this._next.promise}}e.TaskSequentializer=j;class W{constructor(U){this.interval=U,this.lastIncrementTime=0,this.value=0}increment(){const U=Date.now();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=W;class Q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,Y)=>{this.completeCallback=U,this.errorCallback=Y})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(Y=>{this.completeCallback(U),this.resolved=!0,Y()})}error(U){return new Promise(Y=>{this.errorCallback(U),this.rejected=!0,Y()})}cancel(){new Promise(U=>{this.errorCallback(T.canceled()),this.rejected=!0,U()})}}e.DeferredPromise=Q;class M extends S.Emitter{async fireAsync(U,Y,V){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const ce of this._listeners)this._asyncDeliveryQueue.push([ce,U]);for(;this._asyncDeliveryQueue.size>0&&!Y.isCancellationRequested;){const[ce,ge]=this._asyncDeliveryQueue.shift(),Ae=[],$e=Object.assign(Object.assign({},ge),{waitUntil:Fe=>{if(Object.isFrozen(Ae))throw new Error("waitUntil can NOT be called asynchronous");V&&(Fe=V(Fe,typeof ce=="function"?ce:ce[0])),Ae.push(Fe)}});try{typeof ce=="function"?ce.call(void 0,$e):ce[0].call(ce[1],$e)}catch(Fe){T.onUnexpectedError(Fe);continue}Object.freeze(Ae),await X.settled(Ae).catch(Fe=>T.onUnexpectedError(Fe))}}}}e.AsyncEmitter=M;var X;(function(B){async function U(ge){return typeof Promise.allSettled=="function"?Y(ge):V(ge)}B.allSettled=U;async function Y(ge){return Promise.allSettled(ge)}async function V(ge){return Promise.all(ge.map(Ae=>Ae.then($e=>({status:"fulfilled",value:$e}),$e=>({status:"rejected",reason:$e}))))}async function ce(ge){let Ae;const $e=await Promise.all(ge.map(Fe=>Fe.then(Ve=>Ve,Ve=>{Ae||(Ae=Ve)})));if(typeof Ae!="undefined")throw Ae;return $e}B.settled=ce})(X=e.Promises||(e.Promises={}))}),define(we[112],_e([0,1,15,13]),function(ee,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const S=new T.IdleValue(()=>{const A=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:A,collatorIsNumeric:A.resolvedOptions().numeric}}),y=new T.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),k=new T.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(A,a,R=!1){const F=A||"",x=a||"",J=S.value.collator.compare(F,x);return S.value.collatorIsNumeric&&J===0&&F!==x?F<x?-1:1:J}e.compareFileNames=D;function b(A,a){const R=y.value.collator;return A=A||"",a=a||"",g(R,A,a)}e.compareFileNamesDefault=b;function C(A,a){const R=y.value.collator;return A=A||"",a=a||"",r(A,a)||g(R,A,a)}e.compareFileNamesUpper=C;function n(A,a){const R=y.value.collator;return A=A||"",a=a||"",s(A,a)||g(R,A,a)}e.compareFileNamesLower=n;function I(A,a){return A=A||"",a=a||"",A===a?0:A<a?-1:1}e.compareFileNamesUnicode=I;function o(A,a,R=!1){R||(A=A&&A.toLowerCase(),a=a&&a.toLowerCase());const[F,x]=u(A),[J,ae]=u(a);return F!==J?F<J?-1:1:x===ae?0:x<ae?-1:1}e.noIntlCompareFileNames=o;function f(A,a){const[R,F]=u(A),[x,J]=u(a);let ae=S.value.collator.compare(F,J);if(ae===0){if(S.value.collatorIsNumeric&&F!==J)return F<J?-1:1;if(ae=S.value.collator.compare(R,x),S.value.collatorIsNumeric&&ae===0&&R!==x)return R<x?-1:1}return ae}e.compareFileExtensions=f;function c(A,a){A=A||"",a=a||"";const R=h(A),F=h(a),x=y.value.collator,J=k.value.collator;return g(J,R,F)||g(x,A,a)}e.compareFileExtensionsDefault=c;function d(A,a){A=A||"",a=a||"";const R=h(A),F=h(a),x=y.value.collator,J=k.value.collator;return g(J,R,F)||r(A,a)||g(x,A,a)}e.compareFileExtensionsUpper=d;function w(A,a){A=A||"",a=a||"";const R=h(A),F=h(a),x=y.value.collator,J=k.value.collator;return g(J,R,F)||s(A,a)||g(x,A,a)}e.compareFileExtensionsLower=w;function v(A,a){A=A||"",a=a||"";const R=h(A).toLowerCase(),F=h(a).toLowerCase();return R!==F?R<F?-1:1:A!==a?A<a?-1:1:0}e.compareFileExtensionsUnicode=v;const E=/^(.*?)(\.([^.]*))?$/;function u(A,a=!1){const R=A?E.exec(A):[];let F=[R&&R[1]||"",R&&R[3]||""];return a&&(!F[0]&&F[1]||F[0]&&F[0].charAt(0)===".")&&(F=[F[0]+"."+F[1],""]),F}function h(A){const a=A?E.exec(A):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function g(A,a,R){let F=A.compare(a,R);return F!==0?F:a.length!==R.length?a.length<R.length?-1:1:0}function t(A){const a=A.charAt(0);return a.toLocaleUpperCase()!==a}function i(A){const a=A.charAt(0);return a.toLocaleLowerCase()!==a}function s(A,a){return t(A)&&i(a)?-1:i(A)&&t(a)?1:0}function r(A,a){return i(A)&&t(a)?-1:t(A)&&i(a)?1:0}function l(A,a,R=!1){return R||(A=A&&A.toLowerCase(),a=a&&a.toLowerCase()),A===a?0:A<a?-1:1}function _(A,a,R=!1){const F=A.split(m.sep),x=a.split(m.sep),J=F.length-1,ae=x.length-1;let j,W;for(let Q=0;;Q++){if(j=J===Q,W=ae===Q,j&&W)return D(F[Q],x[Q],R);if(j)return-1;if(W)return 1;const M=l(F[Q],x[Q],R);if(M!==0)return M}}e.comparePaths=_;function p(A,a,R){const F=A.toLowerCase(),x=a.toLowerCase(),J=P(A,a,R);if(J)return J;const ae=F.endsWith(R),j=x.endsWith(R);if(ae!==j)return ae?-1:1;const W=D(F,x);return W!==0?W:F.localeCompare(x)}e.compareAnything=p;function P(A,a,R){const F=A.toLowerCase(),x=a.toLowerCase(),J=F.startsWith(R),ae=x.startsWith(R);if(J!==ae)return J?-1:1;if(J&&ae){if(F.length<x.length)return-1;if(F.length>x.length)return 1}return 0}e.compareByPrefix=P}),define(we[27],_e([0,1,8,42,15,22,13]),function(ee,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const b="**",C="/",n="[/\\\\]",I="[^/\\\\]",o=/\//g;function f(U){switch(U){case 0:return"";case 1:return`${I}*?`;default:return`(?:${n}|${I}+${n}|${n}${I}+)*?`}}function c(U,Y){if(!U)return[];const V=[];let ce=!1,ge=!1,Ae="";for(const $e of U){switch($e){case Y:if(!ce&&!ge){V.push(Ae),Ae="";continue}break;case"{":ce=!0;break;case"}":ce=!1;break;case"[":ge=!0;break;case"]":ge=!1;break}Ae+=$e}return Ae&&V.push(Ae),V}e.splitGlobAware=c;function d(U){if(!U)return"";let Y="";const V=c(U,C);if(V.every(ce=>ce===b))Y=".*";else{let ce=!1;V.forEach((ge,Ae)=>{if(ge===b){ce||(Y+=f(2),ce=!0);return}let $e=!1,Fe="",Ve=!1,tt="";for(const Ke of ge){if(Ke!=="}"&&$e){Fe+=Ke;continue}if(Ve&&(Ke!=="]"||!tt)){let Qe;Ke==="-"?Qe=Ke:(Ke==="^"||Ke==="!")&&!tt?Qe="^":Ke===C?Qe="":Qe=m.escapeRegExpCharacters(Ke),tt+=Qe;continue}switch(Ke){case"{":$e=!0;continue;case"[":Ve=!0;continue;case"}":Y+=`(?:${c(Fe,",").map(K=>d(K)).join("|")})`,$e=!1,Fe="";break;case"]":Y+="["+tt+"]",Ve=!1,tt="";break;case"?":Y+=I;continue;case"*":Y+=f(1);continue;default:Y+=m.escapeRegExpCharacters(Ke)}}Ae<V.length-1&&(V[Ae+1]!==b||Ae+2<V.length)&&(Y+=n),ce=!1})}return Y}const w=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new y.LRUCache(1e4),i=function(){return!1},s=function(){return null};function r(U,Y){if(!U)return s;let V;typeof U!="string"?V=U.pattern:V=U,V=V.trim();const ce=`${V}_${!!Y.trimForExclusions}`;let ge=t.get(ce);if(ge)return l(ge,U);let Ae;if(w.test(V)){const $e=V.substr(4);ge=function(Fe,Ve){return typeof Fe=="string"&&Fe.endsWith($e)?V:null}}else(Ae=v.exec(_(V,Y)))?ge=p(Ae[1],V):(Y.trimForExclusions?u:E).test(V)?ge=P(V,Y):(Ae=h.exec(_(V,Y)))?ge=A(Ae[1].substr(1),V,!0):(Ae=g.exec(_(V,Y)))?ge=A(Ae[1],V,!1):ge=a(V);return t.set(ce,ge),l(ge,U)}function l(U,Y){return typeof Y=="string"?U:function(V,ce){return T.isEqualOrParent(V,Y.base)?U(S.relative(Y.base,V),ce):null}}function _(U,Y){return Y.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function p(U,Y){const V=`/${U}`,ce=`\\${U}`,ge=function($e,Fe){return typeof $e!="string"?null:Fe?Fe===U?Y:null:$e===U||$e.endsWith(V)||$e.endsWith(ce)?Y:null},Ae=[U];return ge.basenames=Ae,ge.patterns=[Y],ge.allBasenames=Ae,ge}function P(U,Y){const V=B(U.slice(1,-1).split(",").map(Fe=>r(Fe,Y)).filter(Fe=>Fe!==s),U),ce=V.length;if(!ce)return s;if(ce===1)return V[0];const ge=function(Fe,Ve){for(let tt=0,Ke=V.length;tt<Ke;tt++)if(V[tt](Fe,Ve))return U;return null},Ae=V.find(Fe=>!!Fe.allBasenames);Ae&&(ge.allBasenames=Ae.allBasenames);const $e=V.reduce((Fe,Ve)=>Ve.allPaths?Fe.concat(Ve.allPaths):Fe,[]);return $e.length&&(ge.allPaths=$e),ge}function A(U,Y,V){const ce=S.sep===S.posix.sep,ge=ce?U:U.replace(o,S.sep),Ae=S.sep+ge,$e=S.posix.sep+U,Fe=V?function(Ve,tt){return typeof Ve=="string"&&(Ve===ge||Ve.endsWith(Ae)||!ce&&(Ve===U||Ve.endsWith($e)))?Y:null}:function(Ve,tt){return typeof Ve=="string"&&(Ve===ge||!ce&&Ve===U)?Y:null};return Fe.allPaths=[(V?"*/":"./")+U],Fe}function a(U){try{const Y=new RegExp(`^${d(U)}$`);return function(V){return Y.lastIndex=0,typeof V=="string"&&Y.test(V)?U:null}}catch(Y){return s}}function R(U,Y,V){return!U||typeof Y!="string"?!1:F(U)(Y,void 0,V)}e.match=R;function F(U,Y={}){if(!U)return i;if(typeof U=="string"||j(U)){const V=r(U,Y);if(V===s)return i;const ce=function(ge,Ae){return!!V(ge,Ae)};return V.allBasenames&&(ce.allBasenames=V.allBasenames),V.allPaths&&(ce.allPaths=V.allPaths),ce}return M(U,Y)}e.parse=F;function x(U){if(!U)return;let Y;return V=>(Y||(Y=(U()||Promise.resolve([])).then(ce=>ce?ae(ce):{})),Y.then(ce=>!!ce[V]))}e.hasSiblingPromiseFn=x;function J(U){if(!U)return;let Y;return V=>{if(!Y){const ce=U();Y=ce?ae(ce):{}}return!!Y[V]}}e.hasSiblingFn=J;function ae(U){const Y={};for(const V of U)Y[V]=!0;return Y}function j(U){const Y=U;return Y&&typeof Y.base=="string"&&typeof Y.pattern=="string"}e.isRelativePattern=j;function W(U){return U.allBasenames||[]}e.getBasenameTerms=W;function Q(U){return U.allPaths||[]}e.getPathTerms=Q;function M(U,Y){const V=B(Object.getOwnPropertyNames(U).map(Fe=>X(Fe,U[Fe],Y)).filter(Fe=>Fe!==s)),ce=V.length;if(!ce)return s;if(!V.some(Fe=>!!Fe.requiresSiblings)){if(ce===1)return V[0];const Fe=function(Ke,Qe){for(let $=0,K=V.length;$<K;$++){const ie=V[$](Ke,Qe);if(ie)return ie}return null},Ve=V.find(Ke=>!!Ke.allBasenames);Ve&&(Fe.allBasenames=Ve.allBasenames);const tt=V.reduce((Ke,Qe)=>Qe.allPaths?Ke.concat(Qe.allPaths):Ke,[]);return tt.length&&(Fe.allPaths=tt),Fe}const ge=function(Fe,Ve,tt){let Ke;for(let Qe=0,$=V.length;Qe<$;Qe++){const K=V[Qe];K.requiresSiblings&&tt&&(Ve||(Ve=S.basename(Fe)),Ke||(Ke=Ve.substr(0,Ve.length-S.extname(Fe).length)));const ie=K(Fe,Ve,Ke,tt);if(ie)return ie}return null},Ae=V.find(Fe=>!!Fe.allBasenames);Ae&&(ge.allBasenames=Ae.allBasenames);const $e=V.reduce((Fe,Ve)=>Ve.allPaths?Fe.concat(Ve.allPaths):Fe,[]);return $e.length&&(ge.allPaths=$e),ge}function X(U,Y,V){if(Y===!1)return s;const ce=r(U,V);if(ce===s)return s;if(typeof Y=="boolean")return ce;if(Y){const ge=Y.when;if(typeof ge=="string"){const Ae=($e,Fe,Ve,tt)=>{if(!tt||!ce($e,Fe))return null;const Ke=ge.replace("$(basename)",Ve),Qe=tt(Ke);return k.isThenable(Qe)?Qe.then($=>$?U:null):Qe?U:null};return Ae.requiresSiblings=!0,Ae}}return ce}function B(U,Y){const V=U.filter(Fe=>!!Fe.basenames);if(V.length<2)return U;const ce=V.reduce((Fe,Ve)=>{const tt=Ve.basenames;return tt?Fe.concat(tt):Fe},[]);let ge;if(Y){ge=[];for(let Fe=0,Ve=ce.length;Fe<Ve;Fe++)ge.push(Y)}else ge=V.reduce((Fe,Ve)=>{const tt=Ve.patterns;return tt?Fe.concat(tt):Fe},[]);const Ae=function(Fe,Ve){if(typeof Fe!="string")return null;if(!Ve){let Ke;for(Ke=Fe.length;Ke>0;Ke--){const Qe=Fe.charCodeAt(Ke-1);if(Qe===47||Qe===92)break}Ve=Fe.substr(Ke)}const tt=ce.indexOf(Ve);return tt!==-1?ge[tt]:null};Ae.basenames=ce,Ae.patterns=ge,Ae.allBasenames=ce;const $e=U.filter(Fe=>!Fe.basenames);return $e.push(Ae),$e}}),define(we[80],_e([0,1,2,15,8,12,21,25,42]),function(ee,e,m,T,S,y,k,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function C(r,l,_){if(typeof r=="string"&&(r=m.URI.file(r)),_){const P=_.getWorkspaceFolder(r);if(P){const A=_.getWorkspace().folders.length>1;let a;if(D.isEqual(P.uri,r)?a="":a=D.relativePath(P.uri,r),A){const R=P.name?P.name:D.basename(P.uri);a=a?R+" \u2022 "+a:R}return a}}if(r.scheme!==y.Schemas.file&&r.scheme!==y.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if(b.hasDriveLetter(r.fsPath))return T.normalize(I(r.fsPath));let p=T.normalize(r.fsPath);return!k.isWindows&&(l==null?void 0:l.userHome)&&(p=f(p,l.userHome.fsPath)),p}e.getPathLabel=C;function n(r){if(!r)return;typeof r=="string"&&(r=m.URI.file(r));const l=D.basename(r)||(r.scheme===y.Schemas.file?r.fsPath:r.path);return k.isWindows&&b.isRootOrDriveLetter(l)?I(l):l}e.getBaseLabel=n;function I(r){return b.hasDriveLetter(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=I;let o=Object.create(null);function f(r,l){if(k.isWindows||!r||!l)return r;let _=o.original===l?o.normalized:void 0;return _||(_=`${S.rtrim(l,T.posix.sep)}${T.posix.sep}`,o={original:l,normalized:_}),(k.isLinux?r.startsWith(_):S.startsWithIgnoreCase(r,_))&&(r=`~/${r.substr(_.length)}`),r}e.tildify=f;function c(r,l){return r.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=c;const d="\u2026",w="\\\\",v="~";function E(r,l=T.sep){const _=new Array(r.length);let p=!1;for(let P=0;P<r.length;P++){let A=r[P];if(A===""){_[P]=`.${l}`;continue}if(!A){_[P]=A;continue}p=!0;let a="";A.indexOf(w)===0?(a=A.substr(0,A.indexOf(w)+w.length),A=A.substr(A.indexOf(w)+w.length)):A.indexOf(l)===0?(a=A.substr(0,A.indexOf(l)+l.length),A=A.substr(A.indexOf(l)+l.length)):A.indexOf(v)===0&&(a=A.substr(0,A.indexOf(v)+v.length),A=A.substr(A.indexOf(v)+v.length));const R=A.split(l);for(let F=1;p&&F<=R.length;F++)for(let x=R.length-F;p&&x>=0;x--){p=!1;let J=R.slice(x,x+F).join(l);for(let ae=0;!p&&ae<r.length;ae++)if(ae!==P&&r[ae]&&r[ae].indexOf(J)>-1){const j=x+F===R.length,W=x>0&&r[ae].indexOf(l)>-1?l+J:J,Q=r[ae].endsWith(W);p=!j||Q}if(!p){let ae="";(R[0].endsWith(":")||a!=="")&&(x===1&&(x=0,F++,J=R[0]+l+J),x>0&&(ae=R[0]+l),ae=a+ae),x>0&&(ae=ae+d+l),ae=ae+J,x+F<R.length&&(ae=ae+l+d),_[P]=ae}}p&&(_[P]=A)}return _}e.shorten=E;var u;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function h(r,l=Object.create(null)){const _=[];let p=!1,P="";for(const A of r)if(A==="$"||p&&A==="{")P&&_.push({value:P,type:u.TEXT}),P="",p=!0;else if(A==="}"&&p){const a=l[P];if(typeof a=="string")a.length&&_.push({value:a,type:u.VARIABLE});else if(a){const R=_[_.length-1];(!R||R.type!==u.SEPARATOR)&&_.push({value:a.label,type:u.SEPARATOR})}P="",p=!1}else P+=A;return P&&!p&&_.push({value:P,type:u.TEXT}),_.filter((A,a)=>{if(A.type===u.SEPARATOR){const R=_[a-1],F=_[a+1];return[R,F].every(x=>x&&(x.type===u.VARIABLE||x.type===u.TEXT)&&x.value.length>0)}return!0}).map(A=>A.value).join("")}e.template=h;function g(r,l){return k.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):r.replace(/&&|&/g,_=>_==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function t(r,l){return k.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,""):k.isWindows?r.replace(/&&|&/g,_=>_==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=i;function s(r){const l=r.indexOf("/")!==-1?T.posix:T.win32,_=l.basename(r),p=l.dirname(r);return _.length?{name:_,parentPath:p}:{name:p,parentPath:""}}e.splitName=s}),define(we[81],_e([0,1,15,8,27,12,25]),function(ee,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var D;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown"})(D=e.Mimes||(e.Mimes={}));let b=[],C=[],n=[];function I(i,s=!1){const r=o(i);b.push(r),r.userConfigured?n.push(r):C.push(r),s&&!r.userConfigured&&b.forEach(l=>{l.mime===r.mime||l.userConfigured||(r.extension&&l.extension===r.extension&&console.warn(`Overwriting extension <<${r.extension}>> to now point to mime <<${r.mime}>>`),r.filename&&l.filename===r.filename&&console.warn(`Overwriting filename <<${r.filename}>> to now point to mime <<${r.mime}>>`),r.filepattern&&l.filepattern===r.filepattern&&console.warn(`Overwriting filepattern <<${r.filepattern}>> to now point to mime <<${r.mime}>>`),r.firstline&&l.firstline===r.firstline&&console.warn(`Overwriting firstline <<${r.firstline}>> to now point to mime <<${r.mime}>>`))})}e.registerTextMime=I;function o(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?i.filepattern.toLowerCase():void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(m.posix.sep)>=0:!1}}function f(i){i?(b=b.filter(s=>!s.userConfigured),n=[]):(b=[],C=[],n=[])}e.clearTextMimes=f;function c(i,s){let r;if(i)switch(i.scheme){case y.Schemas.file:r=i.fsPath;break;case y.Schemas.data:r=k.DataUri.parseMetaData(i).get(k.DataUri.META_DATA_LABEL);break;default:r=i.path}if(!r)return[D.unknown];r=r.toLowerCase();const l=m.basename(r),_=d(r,l,n);if(_)return[_,D.text];const p=d(r,l,C);if(p)return[p,D.text];if(s){const P=w(s);if(P)return[P,D.text]}return[D.unknown]}e.guessMimeTypes=c;function d(i,s,r){let l=null,_=null,p=null;for(let P=r.length-1;P>=0;P--){const A=r[P];if(s===A.filenameLowercase){l=A;break}if(A.filepattern&&(!_||A.filepattern.length>_.filepattern.length)){const a=A.filepatternOnPath?i:s;S.match(A.filepatternLowercase,a)&&(_=A)}A.extension&&(!p||A.extension.length>p.extension.length)&&s.endsWith(A.extensionLowercase)&&(p=A)}return l?l.mime:_?_.mime:p?p.mime:null}function w(i){if(T.startsWithUTF8BOM(i)&&(i=i.substr(1)),i.length>0)for(let s=b.length-1;s>=0;s--){const r=b[s];if(!r.firstline)continue;const l=i.match(r.firstline);if(l&&l.length>0)return r.mime}return null}function v(i){return i?typeof i=="string"?i===D.binary||i===D.text||i===D.unknown:i.length===1&&v(i[0]):!0}e.isUnspecific=v;const E={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function u(i){const s=m.extname(i);return E[s.toLowerCase()]}e.getMediaMime=u;function h(i){for(const s in E)if(E[s]===i)return s}e.getExtensionForMimeType=h;const g=/^(.+)\/(.+?)(;.+)?$/;function t(i,s){var r;const l=g.exec(i);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${(r=l[3])!==null&&r!==void 0?r:""}`:s?void 0:i}e.normalizeMimeType=t}),define(we[113],_e([0,1,2]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(n){return n.toJSON()}class S{constructor(I){this._uriTransformer=I}transformIncoming(I){const o=this._uriTransformer.transformIncoming(I);return o===I?I:T(m.URI.from(o))}transformOutgoing(I){const o=this._uriTransformer.transformOutgoing(I);return o===I?I:T(m.URI.from(o))}transformOutgoingURI(I){const o=this._uriTransformer.transformOutgoing(I);return o===I?I:m.URI.from(o)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=S,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function y(n,I,o){if(!n||o>200)return null;if(typeof n=="object"){if(n instanceof m.URI)return I.transformOutgoing(n);for(let f in n)if(Object.hasOwnProperty.call(n,f)){const c=y(n[f],I,o+1);c!==null&&(n[f]=c)}}return null}function k(n,I){const o=y(n,I,0);return o===null?n:o}e.transformOutgoingURIs=k;function D(n,I,o,f){if(!n||f>200)return null;if(typeof n=="object"){if(n.$mid===1)return o?m.URI.revive(I.transformIncoming(n)):I.transformIncoming(n);for(let c in n)if(Object.hasOwnProperty.call(n,c)){const d=D(n[c],I,o,f+1);d!==null&&(n[c]=d)}}return null}function b(n,I){const o=D(n,I,!1,0);return o===null?n:o}e.transformIncomingURIs=b;function C(n,I){const o=D(n,I,!0,0);return o===null?n:o}e.transformAndReviveIncomingURIs=C}),define(we[34],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(b){return m.test(b)}e.isUUID=T;const S=new Uint8Array(16),y=[];for(let b=0;b<256;b++)y.push(b.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(b){for(let C=0;C<b.length;C++)b[C]=Math.floor(Math.random()*256);return b};function D(){k(S),S[6]=S[6]&15|64,S[8]=S[8]&63|128;let b=0,C="";return C+=y[S[b++]],C+=y[S[b++]],C+=y[S[b++]],C+=y[S[b++]],C+="-",C+=y[S[b++]],C+=y[S[b++]],C+="-",C+=y[S[b++]],C+=y[S[b++]],C+="-",C+=y[S[b++]],C+=y[S[b++]],C+="-",C+=y[S[b++]],C+=y[S[b++]],C+=y[S[b++]],C+=y[S[b++]],C+=y[S[b++]],C+=y[S[b++]],C}e.generateUuid=D}),define(we[82],_e([0,1,78]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class T{constructor(D){let b=m.toUint8(D);this._defaultValue=b,this._asciiMap=T._createAsciiMap(b),this._map=new Map}static _createAsciiMap(D){let b=new Uint8Array(256);for(let C=0;C<256;C++)b[C]=D;return b}set(D,b){let C=m.toUint8(b);D>=0&&D<256?this._asciiMap[D]=C:this._map.set(D,C)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=T;var S;(function(k){k[k.False=0]="False",k[k.True=1]="True"})(S||(S={}));class y{constructor(){this._actual=new T(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=y}),define(we[114],_e([0,1,82]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var T;(function(k){k[k.Regular=0]="Regular",k[k.Whitespace=1]="Whitespace",k[k.WordSeparator=2]="WordSeparator"})(T=e.WordCharacterClass||(e.WordCharacterClass={}));class S extends m.CharacterClassifier{constructor(D){super(0);for(let b=0,C=D.length;b<C;b++)this.set(D.charCodeAt(b),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=S;function y(k){let D={};return b=>(D.hasOwnProperty(b)||(D[b]=k(b)),D[b])}e.getMapForWordSeparators=y(k=>new S(k))}),define(we[35],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class m{constructor(S,y){this.lineNumber=S,this.column=y}with(S=this.lineNumber,y=this.column){return S===this.lineNumber&&y===this.column?this:new m(S,y)}delta(S=0,y=0){return this.with(this.lineNumber+S,this.column+y)}equals(S){return m.equals(this,S)}static equals(S,y){return!S&&!y?!0:!!S&&!!y&&S.lineNumber===y.lineNumber&&S.column===y.column}isBefore(S){return m.isBefore(this,S)}static isBefore(S,y){return S.lineNumber<y.lineNumber?!0:y.lineNumber<S.lineNumber?!1:S.column<y.column}isBeforeOrEqual(S){return m.isBeforeOrEqual(this,S)}static isBeforeOrEqual(S,y){return S.lineNumber<y.lineNumber?!0:y.lineNumber<S.lineNumber?!1:S.column<=y.column}static compare(S,y){let k=S.lineNumber|0,D=y.lineNumber|0;if(k===D){let b=S.column|0,C=y.column|0;return b-C}return k-D}clone(){return new m(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(S){return new m(S.lineNumber,S.column)}static isIPosition(S){return S&&typeof S.lineNumber=="number"&&typeof S.column=="number"}}e.Position=m}),define(we[30],_e([0,1,35]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class T{constructor(y,k,D,b){y>D||y===D&&k>b?(this.startLineNumber=D,this.startColumn=b,this.endLineNumber=y,this.endColumn=k):(this.startLineNumber=y,this.startColumn=k,this.endLineNumber=D,this.endColumn=b)}isEmpty(){return T.isEmpty(this)}static isEmpty(y){return y.startLineNumber===y.endLineNumber&&y.startColumn===y.endColumn}containsPosition(y){return T.containsPosition(this,y)}static containsPosition(y,k){return!(k.lineNumber<y.startLineNumber||k.lineNumber>y.endLineNumber||k.lineNumber===y.startLineNumber&&k.column<y.startColumn||k.lineNumber===y.endLineNumber&&k.column>y.endColumn)}containsRange(y){return T.containsRange(this,y)}static containsRange(y,k){return!(k.startLineNumber<y.startLineNumber||k.endLineNumber<y.startLineNumber||k.startLineNumber>y.endLineNumber||k.endLineNumber>y.endLineNumber||k.startLineNumber===y.startLineNumber&&k.startColumn<y.startColumn||k.endLineNumber===y.endLineNumber&&k.endColumn>y.endColumn)}strictContainsRange(y){return T.strictContainsRange(this,y)}static strictContainsRange(y,k){return!(k.startLineNumber<y.startLineNumber||k.endLineNumber<y.startLineNumber||k.startLineNumber>y.endLineNumber||k.endLineNumber>y.endLineNumber||k.startLineNumber===y.startLineNumber&&k.startColumn<=y.startColumn||k.endLineNumber===y.endLineNumber&&k.endColumn>=y.endColumn)}plusRange(y){return T.plusRange(this,y)}static plusRange(y,k){let D,b,C,n;return k.startLineNumber<y.startLineNumber?(D=k.startLineNumber,b=k.startColumn):k.startLineNumber===y.startLineNumber?(D=k.startLineNumber,b=Math.min(k.startColumn,y.startColumn)):(D=y.startLineNumber,b=y.startColumn),k.endLineNumber>y.endLineNumber?(C=k.endLineNumber,n=k.endColumn):k.endLineNumber===y.endLineNumber?(C=k.endLineNumber,n=Math.max(k.endColumn,y.endColumn)):(C=y.endLineNumber,n=y.endColumn),new T(D,b,C,n)}intersectRanges(y){return T.intersectRanges(this,y)}static intersectRanges(y,k){let D=y.startLineNumber,b=y.startColumn,C=y.endLineNumber,n=y.endColumn,I=k.startLineNumber,o=k.startColumn,f=k.endLineNumber,c=k.endColumn;return D<I?(D=I,b=o):D===I&&(b=Math.max(b,o)),C>f?(C=f,n=c):C===f&&(n=Math.min(n,c)),D>C||D===C&&b>n?null:new T(D,b,C,n)}equalsRange(y){return T.equalsRange(this,y)}static equalsRange(y,k){return!!y&&!!k&&y.startLineNumber===k.startLineNumber&&y.startColumn===k.startColumn&&y.endLineNumber===k.endLineNumber&&y.endColumn===k.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(y){return new m.Position(y.endLineNumber,y.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(y){return new m.Position(y.startLineNumber,y.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(y,k){return new T(this.startLineNumber,this.startColumn,y,k)}setStartPosition(y,k){return new T(y,k,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(y){return new T(y.startLineNumber,y.startColumn,y.startLineNumber,y.startColumn)}static fromPositions(y,k=y){return new T(y.lineNumber,y.column,k.lineNumber,k.column)}static lift(y){return y?new T(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):null}static isIRange(y){return y&&typeof y.startLineNumber=="number"&&typeof y.startColumn=="number"&&typeof y.endLineNumber=="number"&&typeof y.endColumn=="number"}static areIntersectingOrTouching(y,k){return!(y.endLineNumber<k.startLineNumber||y.endLineNumber===k.startLineNumber&&y.endColumn<k.startColumn||k.endLineNumber<y.startLineNumber||k.endLineNumber===y.startLineNumber&&k.endColumn<y.startColumn)}static areIntersecting(y,k){return!(y.endLineNumber<k.startLineNumber||y.endLineNumber===k.startLineNumber&&y.endColumn<=k.startColumn||k.endLineNumber<y.startLineNumber||k.endLineNumber===y.startLineNumber&&k.endColumn<=y.startColumn)}static compareRangesUsingStarts(y,k){if(y&&k){const C=y.startLineNumber|0,n=k.startLineNumber|0;if(C===n){const I=y.startColumn|0,o=k.startColumn|0;if(I===o){const f=y.endLineNumber|0,c=k.endLineNumber|0;if(f===c){const d=y.endColumn|0,w=k.endColumn|0;return d-w}return f-c}return I-o}return C-n}return(y?1:0)-(k?1:0)}static compareRangesUsingEnds(y,k){return y.endLineNumber===k.endLineNumber?y.endColumn===k.endColumn?y.startLineNumber===k.startLineNumber?y.startColumn-k.startColumn:y.startLineNumber-k.startLineNumber:y.endColumn-k.endColumn:y.endLineNumber-k.endLineNumber}static spansMultipleLines(y){return y.endLineNumber>y.startLineNumber}}e.Range=T}),define(we[115],_e([0,1,35,30]),function(ee,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var S;(function(k){k[k.LTR=0]="LTR",k[k.RTL=1]="RTL"})(S=e.SelectionDirection||(e.SelectionDirection={}));class y extends T.Range{constructor(D,b,C,n){super(D,b,C,n);this.selectionStartLineNumber=D,this.selectionStartColumn=b,this.positionLineNumber=C,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return y.selectionsEqual(this,D)}static selectionsEqual(D,b){return D.selectionStartLineNumber===b.selectionStartLineNumber&&D.selectionStartColumn===b.selectionStartColumn&&D.positionLineNumber===b.positionLineNumber&&D.positionColumn===b.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,b){return this.getDirection()===0?new y(this.startLineNumber,this.startColumn,D,b):new y(D,b,this.startLineNumber,this.startColumn)}getPosition(){return new m.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(D,b){return this.getDirection()===0?new y(D,b,this.endLineNumber,this.endColumn):new y(this.endLineNumber,this.endColumn,D,b)}static fromPositions(D,b=D){return new y(D.lineNumber,D.column,b.lineNumber,b.column)}static liftSelection(D){return new y(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,b){if(D&&!b||!D&&b)return!1;if(!D&&!b)return!0;if(D.length!==b.length)return!1;for(let C=0,n=D.length;C<n;C++)if(!this.selectionsEqual(D[C],b[C]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,b,C,n,I){return I===0?new y(D,b,C,n):new y(C,n,D,b)}}e.Selection=y}),define(we[83],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var m;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=4]="Right",c[c.Full=7]="Full"})(m=e.OverviewRulerLane||(e.OverviewRulerLane={}));var T;(function(c){c[c.Inline=1]="Inline",c[c.Gutter=2]="Gutter"})(T=e.MinimapPosition||(e.MinimapPosition={}));var S;(function(c){c[c.TextDefined=0]="TextDefined",c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(S=e.EndOfLinePreference||(e.EndOfLinePreference={}));var y;(function(c){c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(y=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(c){c[c.LF=0]="LF",c[c.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(d){this.tabSize=Math.max(1,d.tabSize|0),this.indentSize=d.tabSize|0,this.insertSpaces=Boolean(d.insertSpaces),this.defaultEOL=d.defaultEOL|0,this.trimAutoWhitespace=Boolean(d.trimAutoWhitespace)}equals(d){return this.tabSize===d.tabSize&&this.indentSize===d.indentSize&&this.insertSpaces===d.insertSpaces&&this.defaultEOL===d.defaultEOL&&this.trimAutoWhitespace===d.trimAutoWhitespace}createChangeEvent(d){return{tabSize:this.tabSize!==d.tabSize,indentSize:this.indentSize!==d.indentSize,insertSpaces:this.insertSpaces!==d.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==d.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class b{constructor(d,w){this.range=d,this.matches=w}}e.FindMatch=b;var C;(function(c){c[c.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",c[c.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",c[c.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",c[c.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var n;(function(c){c[c.Left=0]="Left",c[c.Right=1]="Right"})(n=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var I;(function(c){c[c.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(I=e.ModelConstants||(e.ModelConstants={}));class o{constructor(d,w,v,E,u,h){this.identifier=d,this.range=w,this.text=v,this.forceMoveMarkers=E,this.isAutoWhitespaceEdit=u,this._isTracked=h}}e.ValidAnnotatedEditOperation=o;class f{constructor(d,w,v){this.reverseEdits=d,this.changes=w,this.trimAutoWhitespaceLineNumbers=v}}e.ApplyEditsResult=f}),define(we[116],_e([0,1,8,114,35,30,83]),function(ee,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class b{constructor(u,h,g,t){this.searchString=u,this.isRegex=h,this.matchCase=g,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=C(this.searchString):u=this.searchString.indexOf(`
`)>=0;let h=null;try{h=m.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch(t){return null}if(!h)return null;let g=!this.isRegex&&!u;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new n(h,this.wordSeparators?T.getMapForWordSeparators(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=b;function C(E){if(!E||E.length===0)return!1;for(let u=0,h=E.length;u<h;u++)if(E.charCodeAt(u)===92){if(u++,u>=h)break;const t=E.charCodeAt(u);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=C;class n{constructor(u,h,g){this.regex=u,this.wordSeparators=h,this.simpleSearch=g}}e.SearchData=n;function I(E,u,h){if(!h)return new k.FindMatch(E,null);let g=[];for(let t=0,i=u.length;t<i;t++)g[t]=u[t];return new k.FindMatch(E,g)}e.createFindMatch=I;class o{constructor(u){let h=[],g=0;for(let t=0,i=u.length;t<i;t++)u.charCodeAt(t)===10&&(h[g++]=t);this._lineFeedsOffsets=h}findLineFeedCountBeforeOffset(u){const h=this._lineFeedsOffsets;let g=0,t=h.length-1;if(t===-1||u<=h[0])return 0;for(;g<t;){const i=g+((t-g)/2>>0);h[i]>=u?t=i-1:h[i+1]>=u?(g=i,t=i):g=i+1}return g+1}}class f{static findMatches(u,h,g,t,i){const s=h.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(u,g,new v(s.wordSeparators,s.regex),t,i):this._doFindMatchesLineByLine(u,g,s,t,i):[]}static _getMultilineMatchRange(u,h,g,t,i,s){let r,l=0;t?(l=t.findLineFeedCountBeforeOffset(i),r=h+i+l):r=h+i;let _;if(t){let a=t.findLineFeedCountBeforeOffset(i+s.length)-l;_=r+s.length+a}else _=r+s.length;const p=u.getPositionAt(r),P=u.getPositionAt(_);return new y.Range(p.lineNumber,p.column,P.lineNumber,P.column)}static _doFindMatchesMultiline(u,h,g,t,i){const s=u.getOffsetAt(h.getStartPosition()),r=u.getValueInRange(h,1),l=u.getEOL()===`\r
`?new o(r):null,_=[];let p=0,P;for(g.reset(0);P=g.next(r);)if(_[p++]=I(this._getMultilineMatchRange(u,s,r,l,P.index,P[0]),P,t),p>=i)return _;return _}static _doFindMatchesLineByLine(u,h,g,t,i){const s=[];let r=0;if(h.startLineNumber===h.endLineNumber){const _=u.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return r=this._findMatchesInLine(g,_,h.startLineNumber,h.startColumn-1,r,s,t,i),s}const l=u.getLineContent(h.startLineNumber).substring(h.startColumn-1);r=this._findMatchesInLine(g,l,h.startLineNumber,h.startColumn-1,r,s,t,i);for(let _=h.startLineNumber+1;_<h.endLineNumber&&r<i;_++)r=this._findMatchesInLine(g,u.getLineContent(_),_,0,r,s,t,i);if(r<i){const _=u.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);r=this._findMatchesInLine(g,_,h.endLineNumber,0,r,s,t,i)}return s}static _findMatchesInLine(u,h,g,t,i,s,r,l){const _=u.wordSeparators;if(!r&&u.simpleSearch){const A=u.simpleSearch,a=A.length,R=h.length;let F=-a;for(;(F=h.indexOf(A,F+a))!==-1;)if((!_||w(_,h,R,F,a))&&(s[i++]=new k.FindMatch(new y.Range(g,F+1+t,g,F+1+a+t),null),i>=l))return i;return i}const p=new v(u.wordSeparators,u.regex);let P;p.reset(0);do if(P=p.next(h),P&&(s[i++]=I(new y.Range(g,P.index+1+t,g,P.index+1+P[0].length+t),P,r),i>=l))return i;while(P);return i}static findNextMatch(u,h,g,t){const i=h.parseSearchRequest();if(!i)return null;const s=new v(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(u,g,s,t):this._doFindNextMatchLineByLine(u,g,s,t)}static _doFindNextMatchMultiline(u,h,g,t){const i=new S.Position(h.lineNumber,1),s=u.getOffsetAt(i),r=u.getLineCount(),l=u.getValueInRange(new y.Range(i.lineNumber,i.column,r,u.getLineMaxColumn(r)),1),_=u.getEOL()===`\r
`?new o(l):null;g.reset(h.column-1);let p=g.next(l);return p?I(this._getMultilineMatchRange(u,s,l,_,p.index,p[0]),p,t):h.lineNumber!==1||h.column!==1?this._doFindNextMatchMultiline(u,new S.Position(1,1),g,t):null}static _doFindNextMatchLineByLine(u,h,g,t){const i=u.getLineCount(),s=h.lineNumber,r=u.getLineContent(s),l=this._findFirstMatchInLine(g,r,s,h.column,t);if(l)return l;for(let _=1;_<=i;_++){const p=(s+_-1)%i,P=u.getLineContent(p+1),A=this._findFirstMatchInLine(g,P,p+1,1,t);if(A)return A}return null}static _findFirstMatchInLine(u,h,g,t,i){u.reset(t-1);const s=u.next(h);return s?I(new y.Range(g,s.index+1,g,s.index+1+s[0].length),s,i):null}static findPreviousMatch(u,h,g,t){const i=h.parseSearchRequest();if(!i)return null;const s=new v(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(u,g,s,t):this._doFindPreviousMatchLineByLine(u,g,s,t)}static _doFindPreviousMatchMultiline(u,h,g,t){const i=this._doFindMatchesMultiline(u,new y.Range(1,1,h.lineNumber,h.column),g,t,10*D);if(i.length>0)return i[i.length-1];const s=u.getLineCount();return h.lineNumber!==s||h.column!==u.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(u,new S.Position(s,u.getLineMaxColumn(s)),g,t):null}static _doFindPreviousMatchLineByLine(u,h,g,t){const i=u.getLineCount(),s=h.lineNumber,r=u.getLineContent(s).substring(0,h.column-1),l=this._findLastMatchInLine(g,r,s,t);if(l)return l;for(let _=1;_<=i;_++){const p=(i+s-_-1)%i,P=u.getLineContent(p+1),A=this._findLastMatchInLine(g,P,p+1,t);if(A)return A}return null}static _findLastMatchInLine(u,h,g,t){let i=null,s;for(u.reset(0);s=u.next(h);)i=I(new y.Range(g,s.index+1,g,s.index+1+s[0].length),s,t);return i}}e.TextModelSearch=f;function c(E,u,h,g,t){if(g===0)return!0;const i=u.charCodeAt(g-1);if(E.get(i)!==0||i===13||i===10)return!0;if(t>0){const s=u.charCodeAt(g);if(E.get(s)!==0)return!0}return!1}function d(E,u,h,g,t){if(g+t===h)return!0;const i=u.charCodeAt(g+t);if(E.get(i)!==0||i===13||i===10)return!0;if(t>0){const s=u.charCodeAt(g+t-1);if(E.get(s)!==0)return!0}return!1}function w(E,u,h,g,t){return c(E,u,h,g,t)&&d(E,u,h,g,t)}e.isValidMatch=w;class v{constructor(u,h){this._wordSeparators=u,this._searchRegex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(u){this._searchRegex.lastIndex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(u){const h=u.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===h||(g=this._searchRegex.exec(u),!g))return null;const t=g.index,i=g[0].length;if(t===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){m.getNextCodePoint(u,h,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=i,!this._wordSeparators||w(this._wordSeparators,u,h,t,i))return g}while(g);return null}}e.Searcher=v}),define(we[84],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(D=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)D.indexOf(C)>=0||(b+="\\"+C);return b+="\\s]+)",new RegExp(b,"g")}e.DEFAULT_WORD_REGEXP=m();function T(D){let b=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)b=D;else{let C="g";D.ignoreCase&&(C+="i"),D.multiline&&(C+="m"),D.unicode&&(C+="u"),b=new RegExp(D.source,C)}return b.lastIndex=0,b}e.ensureValidWordDefinition=T;const S={maxLen:1e3,windowSize:15,timeBudget:150};function y(D,b,C,n,I=S){if(C.length>I.maxLen){let w=D-I.maxLen/2;return w<0?w=0:n+=w,C=C.substring(w,D+I.maxLen/2),y(D,b,C,n,I)}const o=Date.now(),f=D-1-n;let c=-1,d=null;for(let w=1;!(Date.now()-o>=I.timeBudget);w++){const v=f-I.windowSize*w;b.lastIndex=Math.max(0,v);const E=k(b,C,f,c);if(!E&&d||(d=E,v<=0))break;c=v}if(d){let w={word:d[0],startColumn:n+1+d.index,endColumn:n+1+d.index+d[0].length};return b.lastIndex=0,w}return null}e.getWordAtText=y;function k(D,b,C,n){let I;for(;I=D.exec(b);){const o=I.index||0;if(o<=C&&D.lastIndex>=C)return I;if(n>0&&o>n)return null}return null}}),define(we[117],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var m;(function(k){k[k.None=0]="None",k[k.Indent=1]="Indent",k[k.IndentOutdent=2]="IndentOutdent",k[k.Outdent=3]="Outdent"})(m=e.IndentAction||(e.IndentAction={}));class T{constructor(D){if(this.open=D.open,this.close=D.close,this._standardTokenMask=0,Array.isArray(D.notIn))for(let b=0,C=D.notIn.length;b<C;b++)switch(D.notIn[b]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(D){return(this._standardTokenMask&D)==0}}e.StandardAutoClosingPairConditional=T;class S{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const b of D)y(this.autoClosingPairsOpenByStart,b.open.charAt(0),b),y(this.autoClosingPairsOpenByEnd,b.open.charAt(b.open.length-1),b),y(this.autoClosingPairsCloseByStart,b.close.charAt(0),b),y(this.autoClosingPairsCloseByEnd,b.close.charAt(b.close.length-1),b),b.close.length===1&&b.open.length===1&&y(this.autoClosingPairsCloseSingleChar,b.close,b)}}e.AutoClosingPairs=S;function y(k,D,b){k.has(D)?k.get(D).push(b):k.set(D,[b])}}),define(we[55],_e([0,1,27,15]),function(ee,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function S(y,k,D,b){if(Array.isArray(y)){let C=0;for(const n of y){const I=S(n,k,D,b);if(I===10)return I;I>C&&(C=I)}return C}else{if(typeof y=="string")return b?y==="*"?5:y===D?10:0:0;if(y){const{language:C,pattern:n,scheme:I,hasAccessToAllModels:o}=y;if(!b&&!o)return 0;let f=0;if(I)if(I===k.scheme)f=10;else if(I==="*")f=5;else return 0;if(C)if(C===D)f=10;else if(C==="*")f=Math.max(f,5);else return 0;if(n){let c;if(typeof n=="string"?c=n:c=Object.assign(Object.assign({},n),{base:T.normalize(n.base)}),c===k.fsPath||m.match(c,k.fsPath))f=10;else return 0}return f}else return 0}}e.score=S}),define(we[118],_e([0,1,82]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var T;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(T=e.State||(e.State={}));class S{constructor(c,d,w){const v=new Uint8Array(c*d);for(let E=0,u=c*d;E<u;E++)v[E]=w;this._data=v,this.rows=c,this.cols=d}get(c,d){return this._data[c*this.cols+d]}set(c,d,w){this._data[c*this.cols+d]=w}}e.Uint8Matrix=S;class y{constructor(c){let d=0,w=0;for(let E=0,u=c.length;E<u;E++){let[h,g,t]=c[E];g>d&&(d=g),h>w&&(w=h),t>w&&(w=t)}d++,w++;let v=new S(w,d,0);for(let E=0,u=c.length;E<u;E++){let[h,g,t]=c[E];v.set(h,g,t)}this._states=v,this._maxCharCode=d}nextState(c,d){return d<0||d>=this._maxCharCode?0:this._states.get(c,d)}}e.StateMachine=y;let k=null;function D(){return k===null&&(k=new y([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),k}var b;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(b||(b={}));let C=null;function n(){if(C===null){C=new m.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<f.length;d++)C.set(f.charCodeAt(d),1);const c=".,;";for(let d=0;d<c.length;d++)C.set(c.charCodeAt(d),2)}return C}class I{static _createLink(c,d,w,v,E){let u=E-1;do{const h=d.charCodeAt(u);if(c.get(h)!==2)break;u--}while(u>v);if(v>0){const h=d.charCodeAt(v-1),g=d.charCodeAt(u);(h===40&&g===41||h===91&&g===93||h===123&&g===125)&&u--}return{range:{startLineNumber:w,startColumn:v+1,endLineNumber:w,endColumn:u+2},url:d.substring(v,u+1)}}static computeLinks(c,d=D()){const w=n();let v=[];for(let E=1,u=c.getLineCount();E<=u;E++){const h=c.getLineContent(E),g=h.length;let t=0,i=0,s=0,r=1,l=!1,_=!1,p=!1,P=!1;for(;t<g;){let A=!1;const a=h.charCodeAt(t);if(r===13){let R;switch(a){case 40:l=!0,R=0;break;case 41:R=l?0:1;break;case 91:p=!0,_=!0,R=0;break;case 93:p=!1,R=_?0:1;break;case 123:P=!0,R=0;break;case 125:R=P?0:1;break;case 39:R=s===34||s===96?0:1;break;case 34:R=s===39||s===96?0:1;break;case 96:R=s===39||s===34?0:1;break;case 42:R=s===42?1:0;break;case 124:R=s===124?1:0;break;case 32:R=p?0:1;break;default:R=w.get(a)}R===1&&(v.push(I._createLink(w,h,E,i,t)),A=!0)}else if(r===12){let R;a===91?(_=!0,R=0):R=w.get(a),R===1?A=!0:r=13}else r=d.nextState(r,a),r===0&&(A=!0);A&&(r=1,l=!1,_=!1,P=!1,i=t+1,s=a),t++}r===13&&v.push(I._createLink(w,h,E,i,g))}return v}}e.LinkComputer=I;function o(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:I.computeLinks(f)}e.computeLinks=o}),define(we[119],_e([0,1,3,7]),function(ee,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class S{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new m.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,D){return this._map.set(k,D),this.fire([k]),T.toDisposable(()=>{this._map.get(k)===D&&(this._map.delete(k),this.fire([k]))})}registerPromise(k,D){let b=null,C=!1;return this._promises.set(k,D.then(n=>{this._promises.delete(k),!(C||!n)&&(b=this.register(k,n))})),T.toDisposable(()=>{C=!0,b&&b.dispose()})}getPromise(k){const D=this.get(k);if(D)return Promise.resolve(D);const b=this._promises.get(k);return b?b.then(C=>this.get(k)):null}get(k){return this._map.get(k)||null}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=S}),define(we[85],_e([0,1,23,21]),function(ee,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var S;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(S||(S={}));function y(I){for(let o=0,f=I.length;o<f;o+=4){const c=I[o+0],d=I[o+1],w=I[o+2],v=I[o+3];I[o+0]=v,I[o+1]=w,I[o+2]=d,I[o+3]=c}}function k(I){const o=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return T.isLittleEndian()||y(o),m.VSBuffer.wrap(o)}function D(I){const o=I.buffer;if(T.isLittleEndian()||y(o),o.byteOffset%4==0)return new Uint32Array(o.buffer,o.byteOffset,o.length/4);{const f=new Uint8Array(o.byteLength);return f.set(o),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function b(I){const o=new Uint32Array(C(I));let f=0;if(o[f++]=I.id,I.type==="full")o[f++]=1,o[f++]=I.data.length,o.set(I.data,f),f+=I.data.length;else{o[f++]=2,o[f++]=I.deltas.length;for(const c of I.deltas)o[f++]=c.start,o[f++]=c.deleteCount,c.data?(o[f++]=c.data.length,o.set(c.data,f),f+=c.data.length):o[f++]=0}return k(o)}e.encodeSemanticTokensDto=b;function C(I){let o=0;if(o+=1+1,I.type==="full")o+=1+I.data.length;else{o+=1,o+=(1+1+1)*I.deltas.length;for(const f of I.deltas)f.data&&(o+=f.data.length)}return o}function n(I){const o=D(I);let f=0;const c=o[f++];if(o[f++]===1){const E=o[f++],u=o.subarray(f,f+E);return f+=E,{id:c,type:"full",data:u}}const w=o[f++];let v=[];for(let E=0;E<w;E++){const u=o[f++],h=o[f++],g=o[f++];let t;g>0&&(t=o.subarray(f,f+g),f+=g),v[E]={start:u,deleteCount:h,data:t}}return{id:c,type:"delta",deltas:v}}e.decodeSemanticTokensDto=n}),define(we[86],_e([0,1,78]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class T{constructor(k,D){this.index=k,this.remainder=D}}e.PrefixSumIndexOfResult=T;class S{constructor(k){this.values=k,this.prefixSum=new Uint32Array(k.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(k,D){k=m.toUint32(k);const b=this.values,C=this.prefixSum,n=D.length;return n===0?!1:(this.values=new Uint32Array(b.length+n),this.values.set(b.subarray(0,k),0),this.values.set(b.subarray(k),k+n),this.values.set(D,k),k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(k,D){return k=m.toUint32(k),D=m.toUint32(D),this.values[k]===D?!1:(this.values[k]=D,k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),!0)}removeValues(k,D){k=m.toUint32(k),D=m.toUint32(D);const b=this.values,C=this.prefixSum;if(k>=b.length)return!1;let n=b.length-k;return D>=n&&(D=n),D===0?!1:(this.values=new Uint32Array(b.length-D),this.values.set(b.subarray(0,k),0),this.values.set(b.subarray(k+D),k),this.prefixSum=new Uint32Array(this.values.length),k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(k){return k<0?0:(k=m.toUint32(k),this._getPrefixSum(k))}_getPrefixSum(k){if(k<=this.prefixSumValidIndex[0])return this.prefixSum[k];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),k>=this.values.length&&(k=this.values.length-1);for(let b=D;b<=k;b++)this.prefixSum[b]=this.prefixSum[b-1]+this.values[b];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],k),this.prefixSum[k]}getIndexOf(k){k=Math.floor(k),this.getTotalSum();let D=0,b=this.values.length-1,C=0,n=0,I=0;for(;D<=b;)if(C=D+(b-D)/2|0,n=this.prefixSum[C],I=n-this.values[C],k<I)b=C-1;else if(k>=n)D=C+1;else break;return new T(C,k-I)}}e.PrefixSumComputer=S}),define(we[120],_e([0,1,8,35,86]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class y{constructor(D,b,C,n){this._uri=D,this._lines=b,this._eol=C,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const b=D.changes;for(const C of b)this._acceptDeleteRange(C.range),this._acceptInsertText(new T.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,b=this._lines.length,C=new Uint32Array(b);for(let n=0;n<b;n++)C[n]=this._lines[n].length+D;this._lineStarts=new S.PrefixSumComputer(C)}}_setLineText(D,b){this._lines[D]=b,this._lineStarts&&this._lineStarts.changeValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,b){if(b.length===0)return;let C=m.splitLines(b);if(C.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+C[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}C[C.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+C[0]);let n=new Uint32Array(C.length-1);for(let I=1;I<C.length;I++)this._lines.splice(D.lineNumber+I-1,0,C[I]),n[I-1]=C[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,n)}}e.MirrorTextModel=y}),define(we[121],_e([19,20]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(we[56],_e([0,1,121,10,17]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function y(C,n){return n&&(C.stack||C.stacktrace)?m.localize(0,null,D(C),k(C.stack)||k(C.stacktrace)):D(C)}function k(C){return Array.isArray(C)?C.join(`
`):C}function D(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?m.localize(1,null,C.message):C.message||m.localize(2,null)}function b(C=null,n=!1){if(!C)return m.localize(3,null);if(Array.isArray(C)){const I=S.coalesce(C),o=b(I[0],n);return I.length>1?m.localize(4,null,o,I.length):o}if(T.isString(C))return C;if(C.detail){const I=C.detail;if(I.error)return y(I.error,n);if(I.exception)return y(I.exception,n)}return C.stack?y(C,n):C.message?C.message:m.localize(5,null)}e.toErrorMessage=b}),define(we[122],_e([19,20]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(we[123],_e([0,1,122,21,84]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(H){H[H.None=0]="None",H[H.Keep=1]="Keep",H[H.Brackets=2]="Brackets",H[H.Advanced=3]="Advanced",H[H.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=k;class D{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,me){this._values[te]=me}}e.ValidatedEditorOptions=D;class b{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=b;class C{constructor(te,me,Te,Le){this.id=te,this.name=me,this.defaultValue=Te,this.schema=Le}compute(te,me,Te){return Te}}class n{constructor(te,me=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=me}validate(te){return this.defaultValue}}class I{constructor(te,me,Te,Le){this.id=te,this.name=me,this.defaultValue=Te,this.schema=Le}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,me,Te){return Te}}function o(H,te){return typeof H=="undefined"?te:H==="false"?!1:Boolean(H)}e.boolean=o;class f extends I{constructor(te,me,Te,Le=void 0){typeof Le!="undefined"&&(Le.type="boolean",Le.default=Te),super(te,me,Te,Le)}validate(te){return o(te,this.defaultValue)}}class c extends I{constructor(te,me,Te,Le,Ge,Se=void 0){typeof Se!="undefined"&&(Se.type="integer",Se.default=Te,Se.minimum=Le,Se.maximum=Ge),super(te,me,Te,Se),this.minimum=Le,this.maximum=Ge}static clampedInt(te,me,Te,Le){if(typeof te=="undefined")return me;let Ge=parseInt(te,10);return isNaN(Ge)?me:(Ge=Math.max(Te,Ge),Ge=Math.min(Le,Ge),Ge|0)}validate(te){return c.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class d extends I{constructor(te,me,Te,Le,Ge){typeof Ge!="undefined"&&(Ge.type="number",Ge.default=Te),super(te,me,Te,Ge),this.validationFn=Le}static clamp(te,me,Te){return te<me?me:te>Te?Te:te}static float(te,me){if(typeof te=="number")return te;if(typeof te=="undefined")return me;const Te=parseFloat(te);return isNaN(Te)?me:Te}validate(te){return this.validationFn(d.float(te,this.defaultValue))}}class w extends I{static string(te,me){return typeof te!="string"?me:te}constructor(te,me,Te,Le=void 0){typeof Le!="undefined"&&(Le.type="string",Le.default=Te),super(te,me,Te,Le)}validate(te){return w.string(te,this.defaultValue)}}function v(H,te,me){return typeof H!="string"||me.indexOf(H)===-1?te:H}e.stringSet=v;class E extends I{constructor(te,me,Te,Le,Ge=void 0){typeof Ge!="undefined"&&(Ge.type="string",Ge.enum=Le,Ge.default=Te),super(te,me,Te,Ge),this._allowedValues=Le}validate(te){return v(te,this.defaultValue,this._allowedValues)}}class u extends C{constructor(te,me,Te,Le,Ge,Se,be=void 0){typeof be!="undefined"&&(be.type="string",be.enum=Ge,be.default=Le),super(te,me,Te,be),this._allowedValues=Ge,this._convert=Se}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function h(H){switch(H){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class g extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",description:m.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,me,Te){return Te===0?te.accessibilitySupport:Te}}class t extends C{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:m.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const me=te;return{insertSpace:o(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(H){H[H.Hidden=0]="Hidden",H[H.Blink=1]="Blink",H[H.Smooth=2]="Smooth",H[H.Phase=3]="Phase",H[H.Expand=4]="Expand",H[H.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(H){switch(H){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(H){H[H.Line=1]="Line",H[H.Block=2]="Block",H[H.Underline=3]="Underline",H[H.LineThin=4]="LineThin",H[H.BlockOutline=5]="BlockOutline",H[H.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(H){switch(H){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function _(H){switch(H){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class p extends n{constructor(){super(125,[63,31])}compute(te,me,Te){const Le=["monaco-editor"];return me.get(31)&&Le.push(me.get(31)),te.extraEditorClassName&&Le.push(te.extraEditorClassName),me.get(63)==="default"?Le.push("mouse-default"):me.get(63)==="copy"&&Le.push("mouse-copy"),me.get(98)&&Le.push("showUnused"),me.get(123)&&Le.push("showDeprecated"),Le.join(" ")}}class P extends f{constructor(){super(30,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(te,me,Te){return Te&&te.emptySelectionClipboard}}class A extends C{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:te.seedSearchStringFromSelection,description:m.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[m.localize(9,null),m.localize(10,null),m.localize(11,null)],description:m.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:m.localize(13,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:m.localize(14,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:m.localize(15,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const me=te;return{cursorMoveOnType:o(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:o(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":v(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(me.loop,this.defaultValue.loop)}}}class a extends C{constructor(){super(41,"fontLigatures",a.OFF,{anyOf:[{type:"boolean",description:m.localize(16,null)},{type:"string",description:m.localize(17,null)}],description:m.localize(18,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?a.OFF:te==="true"?a.ON:te:Boolean(te)?a.ON:a.OFF}}e.EditorFontLigatures=a,a.OFF='"liga" off, "calt" off',a.ON='"liga" on, "calt" on';class R extends n{constructor(){super(40)}compute(te,me,Te){return te.fontInfo}}class F extends I{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(19,null)})}validate(te){let me=d.float(te,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(me,6,100)}compute(te,me,Te){return te.fontInfo.fontSize}}class x extends C{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.MINIMUM_VALUE,maximum:x.MAXIMUM_VALUE,errorMessage:m.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(21,null)})}validate(te){return te==="normal"||te==="bold"?te:String(c.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,x.MINIMUM_VALUE,x.MAXIMUM_VALUE))}}x.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],x.MINIMUM_VALUE=1,x.MAXIMUM_VALUE=1e3;class J extends C{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[m.localize(22,null),m.localize(23,null),m.localize(24,null)]},Te=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:m.localize(26,null)},me),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:m.localize(27,null)},me),"editor.gotoLocation.multipleDeclarations":Object.assign({description:m.localize(28,null)},me),"editor.gotoLocation.multipleImplementations":Object.assign({description:m.localize(29,null)},me),"editor.gotoLocation.multipleReferences":Object.assign({description:m.localize(30,null)},me),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,enum:Te,description:m.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,enum:Te,description:m.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,enum:Te,description:m.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,enum:Te,description:m.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,enum:Te,description:m.localize(35,null)}})}validate(te){var me,Te,Le,Ge,Se;if(!te||typeof te!="object")return this.defaultValue;const be=te;return{multiple:v(be.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(me=be.multipleDefinitions)!==null&&me!==void 0?me:v(be.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Te=be.multipleTypeDefinitions)!==null&&Te!==void 0?Te:v(be.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Le=be.multipleDeclarations)!==null&&Le!==void 0?Le:v(be.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Ge=be.multipleImplementations)!==null&&Ge!==void 0?Ge:v(be.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Se=be.multipleReferences)!==null&&Se!==void 0?Se:v(be.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(be.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(be.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(be.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(be.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(be.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ae extends C{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(50,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:m.localize(36,null)},"editor.hover.delay":{type:"number",default:te.delay,description:m.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:m.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const me=te;return{enabled:o(me.enabled,this.defaultValue.enabled),delay:c.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:o(me.sticky,this.defaultValue.sticky)}}}var j;(function(H){H[H.None=0]="None",H[H.Text=1]="Text",H[H.Blocks=2]="Blocks"})(j=e.RenderMinimap||(e.RenderMinimap={}));class W extends n{constructor(){super(128,[46,55,35,62,90,57,58,92,115,118,119,120,2])}compute(te,me,Te){return W.computeLayout(me,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const me=te.height/te.lineHeight,Te=te.scrollBeyondLastLine?me-1:0,Le=(te.viewLineCount+Te)/(te.pixelRatio*te.height),Ge=Math.floor(te.viewLineCount/Le);return{typicalViewportLineCount:me,extraLinesBeyondLastLine:Te,desiredRatio:Le,minimapLineCount:Ge}}static _computeMinimapLayout(te,me){const Te=te.outerWidth,Le=te.outerHeight,Ge=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ge*Le),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Le};const Se=me.stableMinimapLayoutInput,be=Se&&te.outerHeight===Se.outerHeight&&te.lineHeight===Se.lineHeight&&te.typicalHalfwidthCharacterWidth===Se.typicalHalfwidthCharacterWidth&&te.pixelRatio===Se.pixelRatio&&te.scrollBeyondLastLine===Se.scrollBeyondLastLine&&te.minimap.enabled===Se.minimap.enabled&&te.minimap.side===Se.minimap.side&&te.minimap.size===Se.minimap.size&&te.minimap.showSlider===Se.minimap.showSlider&&te.minimap.renderCharacters===Se.minimap.renderCharacters&&te.minimap.maxColumn===Se.minimap.maxColumn&&te.minimap.scale===Se.minimap.scale&&te.verticalScrollbarWidth===Se.verticalScrollbarWidth&&te.isViewportWrapping===Se.isViewportWrapping,Ce=te.lineHeight,re=te.typicalHalfwidthCharacterWidth,de=te.scrollBeyondLastLine,N=te.minimap.renderCharacters;let G=Ge>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const le=te.minimap.maxColumn,ke=te.minimap.size,Pe=te.minimap.side,Ne=te.verticalScrollbarWidth,Be=te.viewLineCount,Ze=te.remainingWidth,Je=te.isViewportWrapping,Ye=N?2:3;let nt=Math.floor(Ge*Le);const gt=nt/Ge;let ve=!1,ye=!1,ue=Ye*G,z=G/Ge,Oe=1;if(ke==="fill"||ke==="fit"){const{typicalViewportLineCount:bt,extraLinesBeyondLastLine:_t,desiredRatio:vt,minimapLineCount:xt}=W.computeContainedMinimapLineCount({viewLineCount:Be,scrollBeyondLastLine:de,height:Le,lineHeight:Ce,pixelRatio:Ge});if(Be/xt>1)ve=!0,ye=!0,G=1,ue=1,z=G/Ge;else{let dt=!1,ut=G+1;if(ke==="fit"){const ht=Math.ceil((Be+_t)*ue);Je&&be&&Ze<=me.stableFitRemainingWidth?(dt=!0,ut=me.stableFitMaxMinimapScale):dt=ht>nt}if(ke==="fill"||dt){ve=!0;const ht=G;ue=Math.min(Ce*Ge,Math.max(1,Math.floor(1/vt))),Je&&be&&Ze<=me.stableFitRemainingWidth&&(ut=me.stableFitMaxMinimapScale),G=Math.min(ut,Math.max(1,Math.floor(ue/Ye))),G>ht&&(Oe=Math.min(2,G/ht)),z=G/Ge/Oe,nt=Math.ceil(Math.max(bt,Be+_t)*ue),Je?(me.stableMinimapLayoutInput=te,me.stableFitRemainingWidth=Ze,me.stableFitMaxMinimapScale=G):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const Ee=Math.floor(le*z),We=Math.min(Ee,Math.max(0,Math.floor((Ze-Ne-2)*z/(re+z)))+e.MINIMAP_GUTTER_WIDTH);let Xe=Math.floor(Ge*We);const et=Xe/Ge;Xe=Math.floor(Xe*Oe);const st=N?1:2,pt=Pe==="left"?0:Te-We-Ne;return{renderMinimap:st,minimapLeft:pt,minimapWidth:We,minimapHeightIsEditorHeight:ve,minimapIsSampling:ye,minimapScale:G,minimapLineHeight:ue,minimapCanvasInnerWidth:Xe,minimapCanvasInnerHeight:nt,minimapCanvasOuterWidth:et,minimapCanvasOuterHeight:gt}}static computeLayout(te,me){const Te=me.outerWidth|0,Le=me.outerHeight|0,Ge=me.lineHeight|0,Se=me.lineNumbersDigitCount|0,be=me.typicalHalfwidthCharacterWidth,Ce=me.maxDigitWidth,re=me.pixelRatio,de=me.viewLineCount,N=te.get(120),G=N==="inherit"?te.get(119):N,le=G==="inherit"?te.get(115):G,ke=te.get(118),Pe=te.get(2),Ne=me.isDominatedByLongLines,Be=te.get(46),Ze=te.get(57).renderType!==0,Je=te.get(58),Ye=te.get(92),nt=te.get(62),gt=te.get(90),ve=gt.verticalScrollbarSize,ye=gt.verticalHasArrows,ue=gt.arrowSize,z=gt.horizontalScrollbarSize,Oe=te.get(55),Ee=te.get(35);let We;if(typeof Oe=="string"&&/^\d+(\.\d+)?ch$/.test(Oe)){const At=parseFloat(Oe.substr(0,Oe.length-2));We=c.clampedInt(At*be,0,0,1e3)}else We=c.clampedInt(Oe,0,0,1e3);Ee&&(We+=16);let Xe=0;if(Ze){const At=Math.max(Se,Je);Xe=Math.round(At*Ce)}let et=0;Be&&(et=Ge);let st=0,pt=st+et,bt=pt+Xe,_t=bt+We;const vt=Te-et-Xe-We;let xt=!1,Et=!1,dt=-1;Pe!==2&&(G==="inherit"&&Ne?(xt=!0,Et=!0):le==="on"||le==="bounded"?Et=!0:le==="wordWrapColumn"&&(dt=ke));const ut=W._computeMinimapLayout({outerWidth:Te,outerHeight:Le,lineHeight:Ge,typicalHalfwidthCharacterWidth:be,pixelRatio:re,scrollBeyondLastLine:Ye,minimap:nt,verticalScrollbarWidth:ve,viewLineCount:de,remainingWidth:vt,isViewportWrapping:Et},me.memory||new b);ut.renderMinimap!==0&&ut.minimapLeft===0&&(st+=ut.minimapWidth,pt+=ut.minimapWidth,bt+=ut.minimapWidth,_t+=ut.minimapWidth);const ht=vt-ut.minimapWidth,Ht=Math.max(1,Math.floor((ht-ve-2)/be)),kt=ye?ue:0;return Et&&(dt=Math.max(1,Ht),le==="bounded"&&(dt=Math.min(dt,ke))),{width:Te,height:Le,glyphMarginLeft:st,glyphMarginWidth:et,lineNumbersLeft:pt,lineNumbersWidth:Xe,decorationsLeft:bt,decorationsWidth:We,contentLeft:_t,contentWidth:ht,minimap:ut,viewportColumn:Ht,isWordWrapMinified:xt,isViewportWrapping:Et,wrappingColumn:dt,verticalScrollbarWidth:ve,horizontalScrollbarHeight:z,overviewRuler:{top:kt,width:ve,height:Le-2*kt,right:0}}}}e.EditorLayoutInfoComputer=W;class Q extends C{constructor(){const te={enabled:!0};super(54,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:m.localize(39,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:o(te.enabled,this.defaultValue.enabled)}}}class M extends C{constructor(){const te={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(124,"inlayHints",te,{"editor.inlayHints.enabled":{type:"boolean",default:te.enabled,description:m.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:te.fontSize,markdownDescription:m.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:te.fontFamily,description:m.localize(42,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const me=te;return{enabled:o(me.enabled,this.defaultValue.enabled),fontSize:c.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(me.fontFamily,this.defaultValue.fontFamily)}}}class X extends d{constructor(){super(56,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,te=>d.clamp(te,0,150),{markdownDescription:m.localize(43,null)})}compute(te,me,Te){return te.fontInfo.lineHeight}}class B extends C{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(62,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:m.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(45,null),m.localize(46,null),m.localize(47,null)],default:te.size,description:m.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:m.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:m.localize(50,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:m.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:m.localize(53,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const me=te;return{enabled:o(me.enabled,this.defaultValue.enabled),size:v(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:v(me.side,this.defaultValue.side,["right","left"]),showSlider:v(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(me.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(me.scale,1,1,3),maxColumn:c.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function U(H){return H==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Y extends C{constructor(){super(72,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(55,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const me=te;return{top:c.clampedInt(me.top,0,0,1e3),bottom:c.clampedInt(me.bottom,0,0,1e3)}}}class V extends C{constructor(){const te={enabled:!0,cycle:!1};super(73,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:m.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:m.localize(57,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const me=te;return{enabled:o(me.enabled,this.defaultValue.enabled),cycle:o(me.cycle,this.defaultValue.cycle)}}}class ce extends n{constructor(){super(126)}compute(te,me,Te){return te.pixelRatio}}class ge extends C{constructor(){const te={other:!0,comments:!1,strings:!1};super(76,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:m.localize(58,null)},comments:{type:"boolean",default:te.comments,description:m.localize(59,null)},other:{type:"boolean",default:te.other,description:m.localize(60,null)}}}],default:te,description:m.localize(61,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const me=te,Te={other:o(me.other,this.defaultValue.other),comments:o(me.comments,this.defaultValue.comments),strings:o(me.strings,this.defaultValue.strings)};return Te.other&&Te.comments&&Te.strings?!0:!Te.other&&!Te.comments&&!Te.strings?!1:Te}return this.defaultValue}}var Ae;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval",H[H.Custom=4]="Custom"})(Ae=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class $e extends C{constructor(){super(57,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(62,null),m.localize(63,null),m.localize(64,null),m.localize(65,null)],default:"on",description:m.localize(66,null)})}validate(te){let me=this.defaultValue.renderType,Te=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(me=4,Te=te):te==="interval"?me=3:te==="relative"?me=2:te==="on"?me=1:me=0),{renderType:me,renderFn:Te}}}function Fe(H){const te=H.get(85);return te==="editable"?H.get(78):te!=="on"}e.filterValidationDecorations=Fe;class Ve extends C{constructor(){const te=[],me={type:"number",description:m.localize(67,null)};super(89,"rulers",te,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:m.localize(68,null),format:"color-hex"}}}]},default:te,description:m.localize(69,null)})}validate(te){if(Array.isArray(te)){let me=[];for(let Te of te)if(typeof Te=="number")me.push({column:c.clampedInt(Te,0,0,1e4),color:null});else if(Te&&typeof Te=="object"){const Le=Te;me.push({column:c.clampedInt(Le.column,0,0,1e4),color:Le.color})}return me.sort((Te,Le)=>Te.column-Le.column),me}return this.defaultValue}}function tt(H,te){if(typeof H!="string")return te;switch(H){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ke extends C{constructor(){super(90,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const me=te,Te=c.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Le=c.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:tt(me.vertical,this.defaultValue.vertical),horizontal:tt(me.horizontal,this.defaultValue.horizontal),useShadows:o(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Te,horizontalSliderSize:c.clampedInt(me.horizontalSliderSize,Te,0,1e3),verticalScrollbarSize:Le,verticalSliderSize:c.clampedInt(me.verticalSliderSize,Le,0,1e3),scrollByPage:o(me.scrollByPage,this.defaultValue.scrollByPage)}}}class Qe extends C{constructor(){const te={enabled:!1,mode:"prefix"};super(52,"inlineSuggest",te,{"editor.inlineSuggest.enabled":{type:"boolean",default:te.enabled,description:m.localize(70,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subwordDiff"],enumDescriptions:[m.localize(71,null),m.localize(72,null)],default:te.mode,description:m.localize(73,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const me=te;return{enabled:o(me.enabled,this.defaultValue.enabled),mode:v(me.mode,this.defaultValue.mode,["prefix","subwordDiff"])}}}class $ extends C{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordDiff",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(104,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(74,null),m.localize(75,null)],default:te.insertMode,description:m.localize(76,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:m.localize(77,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:m.localize(78,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:m.localize(79,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:m.localize(80,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:m.localize(81,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:m.localize(82,null)},"editor.suggest.preview":{type:"boolean",default:te.preview,description:m.localize(83,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subwordDiff"],enumDescriptions:[m.localize(84,null),m.localize(85,null)],default:te.previewMode,description:m.localize(86,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:m.localize(87,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(88,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(89,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(90,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(91,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(92,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(93,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(94,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(95,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(96,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(97,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(98,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(99,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(100,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(101,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(102,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(103,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(104,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(105,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(106,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(107,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(108,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(109,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(110,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(111,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(112,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(113,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(114,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(115,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(116,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(117,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(118,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const me=te;return{insertMode:v(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:o(me.showIcons,this.defaultValue.showIcons),showStatusBar:o(me.showStatusBar,this.defaultValue.showStatusBar),preview:o(me.preview,this.defaultValue.preview),previewMode:v(me.previewMode,this.defaultValue.previewMode,["prefix","subwordDiff"]),showInlineDetails:o(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(me.showMethods,this.defaultValue.showMethods),showFunctions:o(me.showFunctions,this.defaultValue.showFunctions),showConstructors:o(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(me.showDeprecated,this.defaultValue.showDeprecated),showFields:o(me.showFields,this.defaultValue.showFields),showVariables:o(me.showVariables,this.defaultValue.showVariables),showClasses:o(me.showClasses,this.defaultValue.showClasses),showStructs:o(me.showStructs,this.defaultValue.showStructs),showInterfaces:o(me.showInterfaces,this.defaultValue.showInterfaces),showModules:o(me.showModules,this.defaultValue.showModules),showProperties:o(me.showProperties,this.defaultValue.showProperties),showEvents:o(me.showEvents,this.defaultValue.showEvents),showOperators:o(me.showOperators,this.defaultValue.showOperators),showUnits:o(me.showUnits,this.defaultValue.showUnits),showValues:o(me.showValues,this.defaultValue.showValues),showConstants:o(me.showConstants,this.defaultValue.showConstants),showEnums:o(me.showEnums,this.defaultValue.showEnums),showEnumMembers:o(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(me.showKeywords,this.defaultValue.showKeywords),showWords:o(me.showWords,this.defaultValue.showWords),showColors:o(me.showColors,this.defaultValue.showColors),showFiles:o(me.showFiles,this.defaultValue.showFiles),showReferences:o(me.showReferences,this.defaultValue.showReferences),showFolders:o(me.showFolders,this.defaultValue.showFolders),showTypeParameters:o(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(me.showSnippets,this.defaultValue.showSnippets),showUsers:o(me.showUsers,this.defaultValue.showUsers),showIssues:o(me.showIssues,this.defaultValue.showIssues)}}}class K extends C{constructor(){super(100,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(119,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ie extends n{constructor(){super(127,[78])}compute(te,me,Te){return me.get(78)?!0:te.tabFocusMode}}var se;(function(H){H[H.None=0]="None",H[H.Same=1]="Same",H[H.Indent=2]="Indent",H[H.DeepIndent=3]="DeepIndent"})(se=e.WrappingIndent||(e.WrappingIndent={}));function q(H){switch(H){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class oe extends n{constructor(){super(129,[128])}compute(te,me,Te){const Le=me.get(128);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:Le.isWordWrapMinified,isViewportWrapping:Le.isViewportWrapping,wrappingColumn:Le.wrappingColumn}}}const fe="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",xe="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?Re:T.isLinux?xe:fe,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function pe(H){return e.editorOptionsRegistry[H.id]=H,H}var qe;(function(H){H[H.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",H[H.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",H[H.accessibilitySupport=2]="accessibilitySupport",H[H.accessibilityPageSize=3]="accessibilityPageSize",H[H.ariaLabel=4]="ariaLabel",H[H.autoClosingBrackets=5]="autoClosingBrackets",H[H.autoClosingDelete=6]="autoClosingDelete",H[H.autoClosingOvertype=7]="autoClosingOvertype",H[H.autoClosingQuotes=8]="autoClosingQuotes",H[H.autoIndent=9]="autoIndent",H[H.automaticLayout=10]="automaticLayout",H[H.autoSurround=11]="autoSurround",H[H.codeLens=12]="codeLens",H[H.codeLensFontFamily=13]="codeLensFontFamily",H[H.codeLensFontSize=14]="codeLensFontSize",H[H.colorDecorators=15]="colorDecorators",H[H.columnSelection=16]="columnSelection",H[H.comments=17]="comments",H[H.contextmenu=18]="contextmenu",H[H.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",H[H.cursorBlinking=20]="cursorBlinking",H[H.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",H[H.cursorStyle=22]="cursorStyle",H[H.cursorSurroundingLines=23]="cursorSurroundingLines",H[H.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",H[H.cursorWidth=25]="cursorWidth",H[H.disableLayerHinting=26]="disableLayerHinting",H[H.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",H[H.domReadOnly=28]="domReadOnly",H[H.dragAndDrop=29]="dragAndDrop",H[H.emptySelectionClipboard=30]="emptySelectionClipboard",H[H.extraEditorClassName=31]="extraEditorClassName",H[H.fastScrollSensitivity=32]="fastScrollSensitivity",H[H.find=33]="find",H[H.fixedOverflowWidgets=34]="fixedOverflowWidgets",H[H.folding=35]="folding",H[H.foldingStrategy=36]="foldingStrategy",H[H.foldingHighlight=37]="foldingHighlight",H[H.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",H[H.fontFamily=39]="fontFamily",H[H.fontInfo=40]="fontInfo",H[H.fontLigatures=41]="fontLigatures",H[H.fontSize=42]="fontSize",H[H.fontWeight=43]="fontWeight",H[H.formatOnPaste=44]="formatOnPaste",H[H.formatOnType=45]="formatOnType",H[H.glyphMargin=46]="glyphMargin",H[H.gotoLocation=47]="gotoLocation",H[H.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",H[H.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",H[H.hover=50]="hover",H[H.inDiffEditor=51]="inDiffEditor",H[H.inlineSuggest=52]="inlineSuggest",H[H.letterSpacing=53]="letterSpacing",H[H.lightbulb=54]="lightbulb",H[H.lineDecorationsWidth=55]="lineDecorationsWidth",H[H.lineHeight=56]="lineHeight",H[H.lineNumbers=57]="lineNumbers",H[H.lineNumbersMinChars=58]="lineNumbersMinChars",H[H.linkedEditing=59]="linkedEditing",H[H.links=60]="links",H[H.matchBrackets=61]="matchBrackets",H[H.minimap=62]="minimap",H[H.mouseStyle=63]="mouseStyle",H[H.mouseWheelScrollSensitivity=64]="mouseWheelScrollSensitivity",H[H.mouseWheelZoom=65]="mouseWheelZoom",H[H.multiCursorMergeOverlapping=66]="multiCursorMergeOverlapping",H[H.multiCursorModifier=67]="multiCursorModifier",H[H.multiCursorPaste=68]="multiCursorPaste",H[H.occurrencesHighlight=69]="occurrencesHighlight",H[H.overviewRulerBorder=70]="overviewRulerBorder",H[H.overviewRulerLanes=71]="overviewRulerLanes",H[H.padding=72]="padding",H[H.parameterHints=73]="parameterHints",H[H.peekWidgetDefaultFocus=74]="peekWidgetDefaultFocus",H[H.definitionLinkOpensInPeek=75]="definitionLinkOpensInPeek",H[H.quickSuggestions=76]="quickSuggestions",H[H.quickSuggestionsDelay=77]="quickSuggestionsDelay",H[H.readOnly=78]="readOnly",H[H.renameOnType=79]="renameOnType",H[H.renderControlCharacters=80]="renderControlCharacters",H[H.renderIndentGuides=81]="renderIndentGuides",H[H.renderFinalNewline=82]="renderFinalNewline",H[H.renderLineHighlight=83]="renderLineHighlight",H[H.renderLineHighlightOnlyWhenFocus=84]="renderLineHighlightOnlyWhenFocus",H[H.renderValidationDecorations=85]="renderValidationDecorations",H[H.renderWhitespace=86]="renderWhitespace",H[H.revealHorizontalRightPadding=87]="revealHorizontalRightPadding",H[H.roundedSelection=88]="roundedSelection",H[H.rulers=89]="rulers",H[H.scrollbar=90]="scrollbar",H[H.scrollBeyondLastColumn=91]="scrollBeyondLastColumn",H[H.scrollBeyondLastLine=92]="scrollBeyondLastLine",H[H.scrollPredominantAxis=93]="scrollPredominantAxis",H[H.selectionClipboard=94]="selectionClipboard",H[H.selectionHighlight=95]="selectionHighlight",H[H.selectOnLineNumbers=96]="selectOnLineNumbers",H[H.showFoldingControls=97]="showFoldingControls",H[H.showUnused=98]="showUnused",H[H.snippetSuggestions=99]="snippetSuggestions",H[H.smartSelect=100]="smartSelect",H[H.smoothScrolling=101]="smoothScrolling",H[H.stickyTabStops=102]="stickyTabStops",H[H.stopRenderingLineAfter=103]="stopRenderingLineAfter",H[H.suggest=104]="suggest",H[H.suggestFontSize=105]="suggestFontSize",H[H.suggestLineHeight=106]="suggestLineHeight",H[H.suggestOnTriggerCharacters=107]="suggestOnTriggerCharacters",H[H.suggestSelection=108]="suggestSelection",H[H.tabCompletion=109]="tabCompletion",H[H.tabIndex=110]="tabIndex",H[H.unusualLineTerminators=111]="unusualLineTerminators",H[H.useShadowDOM=112]="useShadowDOM",H[H.useTabStops=113]="useTabStops",H[H.wordSeparators=114]="wordSeparators",H[H.wordWrap=115]="wordWrap",H[H.wordWrapBreakAfterCharacters=116]="wordWrapBreakAfterCharacters",H[H.wordWrapBreakBeforeCharacters=117]="wordWrapBreakBeforeCharacters",H[H.wordWrapColumn=118]="wordWrapColumn",H[H.wordWrapOverride1=119]="wordWrapOverride1",H[H.wordWrapOverride2=120]="wordWrapOverride2",H[H.wrappingIndent=121]="wrappingIndent",H[H.wrappingStrategy=122]="wrappingStrategy",H[H.showDeprecated=123]="showDeprecated",H[H.inlayHints=124]="inlayHints",H[H.editorClassName=125]="editorClassName",H[H.pixelRatio=126]="pixelRatio",H[H.tabFocusMode=127]="tabFocusMode",H[H.layoutInfo=128]="layoutInfo",H[H.wrappingInfo=129]="wrappingInfo"})(qe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:pe(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(120,null)})),acceptSuggestionOnEnter:pe(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(121,null),""],markdownDescription:m.localize(122,null)})),accessibilitySupport:pe(new g),accessibilityPageSize:pe(new c(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(123,null)})),ariaLabel:pe(new w(4,"ariaLabel",m.localize(124,null))),autoClosingBrackets:pe(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(125,null),m.localize(126,null),""],description:m.localize(127,null)})),autoClosingDelete:pe(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(128,null),""],description:m.localize(129,null)})),autoClosingOvertype:pe(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(130,null),""],description:m.localize(131,null)})),autoClosingQuotes:pe(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(132,null),m.localize(133,null),""],description:m.localize(134,null)})),autoIndent:pe(new u(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],h,{enumDescriptions:[m.localize(135,null),m.localize(136,null),m.localize(137,null),m.localize(138,null),m.localize(139,null)],description:m.localize(140,null)})),automaticLayout:pe(new f(10,"automaticLayout",!1)),autoSurround:pe(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(141,null),m.localize(142,null),m.localize(143,null),""],description:m.localize(144,null)})),stickyTabStops:pe(new f(102,"stickyTabStops",!1,{description:m.localize(145,null)})),codeLens:pe(new f(12,"codeLens",!0,{description:m.localize(146,null)})),codeLensFontFamily:pe(new w(13,"codeLensFontFamily","",{description:m.localize(147,null)})),codeLensFontSize:pe(new c(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(148,null)})),colorDecorators:pe(new f(15,"colorDecorators",!0,{description:m.localize(149,null)})),columnSelection:pe(new f(16,"columnSelection",!1,{description:m.localize(150,null)})),comments:pe(new t),contextmenu:pe(new f(18,"contextmenu",!0)),copyWithSyntaxHighlighting:pe(new f(19,"copyWithSyntaxHighlighting",!0,{description:m.localize(151,null)})),cursorBlinking:pe(new u(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:m.localize(152,null)})),cursorSmoothCaretAnimation:pe(new f(21,"cursorSmoothCaretAnimation",!1,{description:m.localize(153,null)})),cursorStyle:pe(new u(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],_,{description:m.localize(154,null)})),cursorSurroundingLines:pe(new c(23,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(155,null)})),cursorSurroundingLinesStyle:pe(new E(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(156,null),m.localize(157,null)],description:m.localize(158,null)})),cursorWidth:pe(new c(25,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(159,null)})),disableLayerHinting:pe(new f(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:pe(new f(27,"disableMonospaceOptimizations",!1)),domReadOnly:pe(new f(28,"domReadOnly",!1)),dragAndDrop:pe(new f(29,"dragAndDrop",!0,{description:m.localize(160,null)})),emptySelectionClipboard:pe(new P),extraEditorClassName:pe(new w(31,"extraEditorClassName","")),fastScrollSensitivity:pe(new d(32,"fastScrollSensitivity",5,H=>H<=0?5:H,{markdownDescription:m.localize(161,null)})),find:pe(new A),fixedOverflowWidgets:pe(new f(34,"fixedOverflowWidgets",!1)),folding:pe(new f(35,"folding",!0,{description:m.localize(162,null)})),foldingStrategy:pe(new E(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(163,null),m.localize(164,null)],description:m.localize(165,null)})),foldingHighlight:pe(new f(37,"foldingHighlight",!0,{description:m.localize(166,null)})),unfoldOnClickAfterEndOfLine:pe(new f(38,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(167,null)})),fontFamily:pe(new w(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(168,null)})),fontInfo:pe(new R),fontLigatures2:pe(new a),fontSize:pe(new F),fontWeight:pe(new x),formatOnPaste:pe(new f(44,"formatOnPaste",!1,{description:m.localize(169,null)})),formatOnType:pe(new f(45,"formatOnType",!1,{description:m.localize(170,null)})),glyphMargin:pe(new f(46,"glyphMargin",!0,{description:m.localize(171,null)})),gotoLocation:pe(new J),hideCursorInOverviewRuler:pe(new f(48,"hideCursorInOverviewRuler",!1,{description:m.localize(172,null)})),highlightActiveIndentGuide:pe(new f(49,"highlightActiveIndentGuide",!0,{description:m.localize(173,null)})),hover:pe(new ae),inDiffEditor:pe(new f(51,"inDiffEditor",!1)),letterSpacing:pe(new d(53,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,H=>d.clamp(H,-5,20),{description:m.localize(174,null)})),lightbulb:pe(new Q),lineDecorationsWidth:pe(new I(55,"lineDecorationsWidth",10)),lineHeight:pe(new X),lineNumbers:pe(new $e),lineNumbersMinChars:pe(new c(58,"lineNumbersMinChars",5,1,300)),linkedEditing:pe(new f(59,"linkedEditing",!1,{description:m.localize(175,null)})),links:pe(new f(60,"links",!0,{description:m.localize(176,null)})),matchBrackets:pe(new E(61,"matchBrackets","always",["always","near","never"],{description:m.localize(177,null)})),minimap:pe(new B),mouseStyle:pe(new E(63,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:pe(new d(64,"mouseWheelScrollSensitivity",1,H=>H===0?1:H,{markdownDescription:m.localize(178,null)})),mouseWheelZoom:pe(new f(65,"mouseWheelZoom",!1,{markdownDescription:m.localize(179,null)})),multiCursorMergeOverlapping:pe(new f(66,"multiCursorMergeOverlapping",!0,{description:m.localize(180,null)})),multiCursorModifier:pe(new u(67,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],U,{markdownEnumDescriptions:[m.localize(181,null),m.localize(182,null)],markdownDescription:m.localize(183,null)})),multiCursorPaste:pe(new E(68,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(184,null),m.localize(185,null)],markdownDescription:m.localize(186,null)})),occurrencesHighlight:pe(new f(69,"occurrencesHighlight",!0,{description:m.localize(187,null)})),overviewRulerBorder:pe(new f(70,"overviewRulerBorder",!0,{description:m.localize(188,null)})),overviewRulerLanes:pe(new c(71,"overviewRulerLanes",3,0,3)),padding:pe(new Y),parameterHints:pe(new V),peekWidgetDefaultFocus:pe(new E(74,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(189,null),m.localize(190,null)],description:m.localize(191,null)})),definitionLinkOpensInPeek:pe(new f(75,"definitionLinkOpensInPeek",!1,{description:m.localize(192,null)})),quickSuggestions:pe(new ge),quickSuggestionsDelay:pe(new c(77,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(193,null)})),readOnly:pe(new f(78,"readOnly",!1)),renameOnType:pe(new f(79,"renameOnType",!1,{description:m.localize(194,null),markdownDeprecationMessage:m.localize(195,null)})),renderControlCharacters:pe(new f(80,"renderControlCharacters",!1,{description:m.localize(196,null)})),renderIndentGuides:pe(new f(81,"renderIndentGuides",!0,{description:m.localize(197,null)})),renderFinalNewline:pe(new f(82,"renderFinalNewline",!0,{description:m.localize(198,null)})),renderLineHighlight:pe(new E(83,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(199,null)],description:m.localize(200,null)})),renderLineHighlightOnlyWhenFocus:pe(new f(84,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(201,null)})),renderValidationDecorations:pe(new E(85,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:pe(new E(86,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(202,null),m.localize(203,null),m.localize(204,null),""],description:m.localize(205,null)})),revealHorizontalRightPadding:pe(new c(87,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:pe(new f(88,"roundedSelection",!0,{description:m.localize(206,null)})),rulers:pe(new Ve),scrollbar:pe(new Ke),scrollBeyondLastColumn:pe(new c(91,"scrollBeyondLastColumn",5,0,1073741824,{description:m.localize(207,null)})),scrollBeyondLastLine:pe(new f(92,"scrollBeyondLastLine",!0,{description:m.localize(208,null)})),scrollPredominantAxis:pe(new f(93,"scrollPredominantAxis",!0,{description:m.localize(209,null)})),selectionClipboard:pe(new f(94,"selectionClipboard",!0,{description:m.localize(210,null),included:T.isLinux})),selectionHighlight:pe(new f(95,"selectionHighlight",!0,{description:m.localize(211,null)})),selectOnLineNumbers:pe(new f(96,"selectOnLineNumbers",!0)),showFoldingControls:pe(new E(97,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[m.localize(212,null),m.localize(213,null)],description:m.localize(214,null)})),showUnused:pe(new f(98,"showUnused",!0,{description:m.localize(215,null)})),showDeprecated:pe(new f(123,"showDeprecated",!0,{description:m.localize(216,null)})),inlayHints:pe(new M),snippetSuggestions:pe(new E(99,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(217,null),m.localize(218,null),m.localize(219,null),m.localize(220,null)],description:m.localize(221,null)})),smartSelect:pe(new K),smoothScrolling:pe(new f(101,"smoothScrolling",!1,{description:m.localize(222,null)})),stopRenderingLineAfter:pe(new c(103,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:pe(new $),inlineSuggest:pe(new Qe),suggestFontSize:pe(new c(105,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(223,null)})),suggestLineHeight:pe(new c(106,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(224,null)})),suggestOnTriggerCharacters:pe(new f(107,"suggestOnTriggerCharacters",!0,{description:m.localize(225,null)})),suggestSelection:pe(new E(108,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(226,null),m.localize(227,null),m.localize(228,null)],description:m.localize(229,null)})),tabCompletion:pe(new E(109,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(230,null),m.localize(231,null),m.localize(232,null)],description:m.localize(233,null)})),tabIndex:pe(new c(110,"tabIndex",0,-1,1073741824)),unusualLineTerminators:pe(new E(111,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(234,null),m.localize(235,null),m.localize(236,null)],description:m.localize(237,null)})),useShadowDOM:pe(new f(112,"useShadowDOM",!0)),useTabStops:pe(new f(113,"useTabStops",!0,{description:m.localize(238,null)})),wordSeparators:pe(new w(114,"wordSeparators",S.USUAL_WORD_SEPARATORS,{description:m.localize(239,null)})),wordWrap:pe(new E(115,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(240,null),m.localize(241,null),m.localize(242,null),m.localize(243,null)],description:m.localize(244,null)})),wordWrapBreakAfterCharacters:pe(new w(116,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:pe(new w(117,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:pe(new c(118,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(245,null)})),wordWrapOverride1:pe(new E(119,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:pe(new E(120,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:pe(new u(121,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],q,{enumDescriptions:[m.localize(246,null),m.localize(247,null),m.localize(248,null),m.localize(249,null)],description:m.localize(250,null)})),wrappingStrategy:pe(new E(122,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[m.localize(251,null),m.localize(252,null)],description:m.localize(253,null)})),editorClassName:pe(new p),pixelRatio:pe(new ce),tabFocusMode:pe(new ie),layoutInfo:pe(new W),wrappingInfo:pe(new oe)}}),define(we[124],_e([19,20]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[125],_e([19,20]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[126],_e([19,20]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(we[127],_e([19,20]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(we[128],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[129],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[130],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(we[131],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[132],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[133],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[134],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[135],_e([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[136],_e([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[137],_e([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[138],_e([19,20]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[139],_e([0,1,2]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=e.isResourceEditorInput=void 0;function T(b){const C=b;return m.URI.isUri(C==null?void 0:C.resource)}e.isResourceEditorInput=T;var S;(function(b){b[b.ACTIVATE=0]="ACTIVATE",b[b.RESTORE=1]="RESTORE",b[b.PRESERVE=2]="PRESERVE"})(S=e.EditorActivation||(e.EditorActivation={}));var y;(function(b){b[b.PICK=0]="PICK",b[b.DISABLED=1]="DISABLED",b[b.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(y=e.EditorOverride||(e.EditorOverride={}));var k;(function(b){b[b.API=0]="API",b[b.USER=1]="USER"})(k=e.EditorOpenContext||(e.EditorOpenContext={}));var D;(function(b){b[b.Center=0]="Center",b[b.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",b[b.NearTop=2]="NearTop",b[b.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(D=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[140],_e([0,1,125]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function y(o){return o=o.trim(),o==="*"||T.test(o)}e.isValidVersionStr=y;function k(o){if(!y(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=o.match(T);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=k;function D(o){if(!o)return null;let f=o.majorBase,c=o.majorMustEqual,d=o.minorBase,w=o.minorMustEqual,v=o.patchBase,E=o.patchMustEqual;o.hasCaret&&(f===0||(w=!1),E=!1);let u=0;if(o.preRelease){const h=S.exec(o.preRelease);if(h){const[,g,t,i]=h;u=Date.UTC(Number(g),Number(t)-1,Number(i))}}return{majorBase:f,majorMustEqual:c,minorBase:d,minorMustEqual:w,patchBase:v,patchMustEqual:E,isMinimum:o.hasGreaterEquals,notBefore:u}}e.normalizeVersion=D;function b(o,f,c){let d;typeof o=="string"?d=D(k(o)):d=o;let w;f instanceof Date?w=f.getTime():typeof f=="string"&&(w=new Date(f).getTime());let v;if(typeof c=="string"?v=D(k(c)):v=c,!d||!v)return!1;let E=d.majorBase,u=d.minorBase,h=d.patchBase,g=v.majorBase,t=v.minorBase,i=v.patchBase,s=v.notBefore,r=v.majorMustEqual,l=v.minorMustEqual,_=v.patchMustEqual;return v.isMinimum?E>g?!0:E<g?!1:u>t?!0:u<t||w&&w<s?!1:h>=i:(E===1&&g===0&&(!r||!l||!_)&&(g=1,t=0,i=0,r=!0,l=!1,_=!1),E<g?!1:E>g?!r:u<t?!1:u>t?!l:h<i?!1:h>i?!_:!(w&&w<s))}e.isValidVersion=b;function C(o,f,c,d){return c.isBuiltin||typeof c.main=="undefined"?!0:I(o,f,c.engines.vscode,d)}e.isValidExtensionVersion=C;function n(o,f,c){return o==="*"||I(f,c,o)}e.isEngineValid=n;function I(o,f,c,d=[]){let w=D(k(c));if(!w)return d.push(m.localize(0,null,c)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return d.push(m.localize(1,null,c)),!1}else if(!w.majorMustEqual)return d.push(m.localize(2,null,c)),!1;return b(o,f,w)?!0:(d.push(m.localize(3,null,o,c)),!1)}}),define(we[87],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class m{constructor(y,k=[],D=!1){this.ctor=y,this.staticArguments=k,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=m;const T=(S,...y)=>new m(S,y);e.createSyncDescriptor=T}),define(we[57],_e([0,1,87]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const T=[];function S(k,D,b){D instanceof m.SyncDescriptor||(D=new m.SyncDescriptor(D,[],b)),T.push([k,D])}e.registerSingleton=S;function y(){return T}e.getSingletonServiceDescriptors=y}),define(we[141],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(y){this.incoming=new Map,this.outgoing=new Map,this.data=y}}e.Node=m;class T{constructor(y){this._hashFn=y,this._nodes=new Map}roots(){const y=[];for(let k of this._nodes.values())k.outgoing.size===0&&y.push(k);return y}insertEdge(y,k){const D=this.lookupOrInsertNode(y),b=this.lookupOrInsertNode(k);D.outgoing.set(this._hashFn(k),b),b.incoming.set(this._hashFn(y),D)}removeNode(y){const k=this._hashFn(y);this._nodes.delete(k);for(let D of this._nodes.values())D.outgoing.delete(k),D.incoming.delete(k)}lookupOrInsertNode(y){const k=this._hashFn(y);let D=this._nodes.get(k);return D||(D=new m(y),this._nodes.set(k,D)),D}lookup(y){return this._nodes.get(this._hashFn(y))}isEmpty(){return this._nodes.size===0}toString(){let y=[];for(let[k,D]of this._nodes)y.push(`${k}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return y.join(`
`)}findCycleSlow(){for(let[y,k]of this._nodes){const D=new Set([y]),b=this._findCycle(k,D);if(b)return b}}_findCycle(y,k){for(let[D,b]of y.outgoing){if(k.has(D))return[...k,D].join(" -> ");k.add(D);const C=this._findCycle(b,k);if(C)return C;k.delete(D)}}}e.Graph=T}),define(we[5],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function b(C){return C[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=b})(m=e._util||(e._util={})),e.IInstantiationService=S("instantiationService");function T(D,b,C,n){b[m.DI_TARGET]===b?b[m.DI_DEPENDENCIES].push({id:D,index:C,optional:n}):(b[m.DI_DEPENDENCIES]=[{id:D,index:C,optional:n}],b[m.DI_TARGET]=b)}function S(D){if(m.serviceIds.has(D))return m.serviceIds.get(D);const b=function(C,n,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(b,C,I,!1)};return b.toString=()=>D,m.serviceIds.set(D,b),b}e.createDecorator=S;function y(D){return D}e.refineServiceDecorator=y;function k(D){return function(b,C,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");T(D,b,n,!0)}}e.optional=k}),define(we[142],_e([0,1,5]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=m.createDecorator("modelService");function T(S){return!S.isTooLargeForSyncing()&&!S.isForSimpleWidget}e.shouldSynchronizeModel=T}),define(we[143],_e([0,1,3,53,7,22,76,55,142]),function(ee,e,m,T,S,y,k,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function C(o){return typeof o=="string"?!1:Array.isArray(o)?o.every(C):!!o.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new m.Emitter}get onDidChange(){return this._onDidChange.event}register(f,c){let d={selector:f,provider:c,_score:-1,_time:this._clock++};return this._entries.push(d),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),S.toDisposable(()=>{if(d){let w=this._entries.indexOf(d);w>=0&&(this._entries.splice(w,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),d=void 0)}})}has(f){return this.all(f).length>0}all(f){if(!f)return[];this._updateScores(f);const c=[];for(let d of this._entries)d._score>0&&c.push(d.provider);return c}ordered(f){const c=[];return this._orderedForEach(f,d=>c.push(d.provider)),c}orderedGroups(f){const c=[];let d,w;return this._orderedForEach(f,v=>{d&&w===v._score?d.push(v.provider):(w=v._score,d=[v.provider],c.push(d))}),c}_orderedForEach(f,c){if(!!f){this._updateScores(f);for(const d of this._entries)d._score>0&&c(d)}}_updateScores(f){let c={uri:f.uri.toString(),language:f.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===c.language&&this._lastCandidate.uri===c.uri)){this._lastCandidate=c;for(let d of this._entries)if(d._score=D.score(d.selector,f.uri,f.getLanguageIdentifier().language,b.shouldSynchronizeModel(f)),C(d.selector)&&d._score>0){for(let w of this._entries)w._score=0;d._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(f,c){return f._score<c._score?1:f._score>c._score?-1:f._time<c._time?1:f._time>c._time?-1:0}}e.LanguageFeatureRegistry=n;class I{constructor(f,c,d=Number.MAX_SAFE_INTEGER){this._registry=f,this.min=c,this.max=d,this._cache=new y.LRUCache(50,.7)}_key(f){return f.id+T.hash(this._registry.all(f))}_clamp(f){return f===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(f*1.3)))}get(f){const c=this._key(f),d=this._cache.get(c);return this._clamp(d==null?void 0:d.value)}update(f,c){const d=this._key(f);let w=this._cache.get(d);return w||(w=new k.MovingAverage,this._cache.set(d,w)),w.update(c),this.get(f)}}e.LanguageFeatureRequestDelays=I}),define(we[58],_e([0,1,2,30,143,119,77]),function(ee,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var D;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));class b{constructor(R,F){this.language=R,this.id=F}}e.LanguageIdentifier=b;var C;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var n;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var I;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var o;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",a[a.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(o=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(R){return(R&255)>>>0}static getTokenType(R){return(R&1792)>>>8}static getFontStyle(R){return(R&14336)>>>11}static getForeground(R){return(R&8372224)>>>14}static getBackground(R){return(R&4286578688)>>>23}static getClassNameFromMetadata(R){let F=this.getForeground(R),x="mtk"+F,J=this.getFontStyle(R);return J&1&&(x+=" mtki"),J&2&&(x+=" mtkb"),J&4&&(x+=" mtku"),x}static getInlineStyleFromMetadata(R,F){const x=this.getForeground(R),J=this.getFontStyle(R);let ae=`color: ${F[x]};`;return J&1&&(ae+="font-style: italic;"),J&2&&(ae+="font-weight: bold;"),J&4&&(ae+="text-decoration: underline;"),ae}}e.TokenMetadata=f;var c;(function(a){a[a.Method=0]="Method",a[a.Function=1]="Function",a[a.Constructor=2]="Constructor",a[a.Field=3]="Field",a[a.Variable=4]="Variable",a[a.Class=5]="Class",a[a.Struct=6]="Struct",a[a.Interface=7]="Interface",a[a.Module=8]="Module",a[a.Property=9]="Property",a[a.Event=10]="Event",a[a.Operator=11]="Operator",a[a.Unit=12]="Unit",a[a.Value=13]="Value",a[a.Constant=14]="Constant",a[a.Enum=15]="Enum",a[a.EnumMember=16]="EnumMember",a[a.Keyword=17]="Keyword",a[a.Text=18]="Text",a[a.Color=19]="Color",a[a.File=20]="File",a[a.Reference=21]="Reference",a[a.Customcolor=22]="Customcolor",a[a.Folder=23]="Folder",a[a.TypeParameter=24]="TypeParameter",a[a.User=25]="User",a[a.Issue=26]="Issue",a[a.Snippet=27]="Snippet"})(c=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let a=Object.create(null);return a[0]="symbol-method",a[1]="symbol-function",a[2]="symbol-constructor",a[3]="symbol-field",a[4]="symbol-variable",a[5]="symbol-class",a[6]="symbol-struct",a[7]="symbol-interface",a[8]="symbol-module",a[9]="symbol-property",a[10]="symbol-event",a[11]="symbol-operator",a[12]="symbol-unit",a[13]="symbol-value",a[14]="symbol-constant",a[15]="symbol-enum",a[16]="symbol-enum-member",a[17]="symbol-keyword",a[27]="symbol-snippet",a[18]="symbol-text",a[19]="symbol-color",a[20]="symbol-file",a[21]="symbol-reference",a[22]="symbol-customcolor",a[23]="symbol-folder",a[24]="symbol-type-parameter",a[25]="account",a[26]="issues",function(R){const F=a[R];let x=F&&k.iconRegistry.get(F);return x||(console.info("No codicon found for CompletionItemKind "+R),x=k.Codicon.symbolProperty),x.classNames}}(),e.completionKindFromString=function(){let a=Object.create(null);return a.method=0,a.function=1,a.constructor=2,a.field=3,a.variable=4,a.class=5,a.struct=6,a.interface=7,a.module=8,a.property=9,a.event=10,a.operator=11,a.unit=12,a.value=13,a.constant=14,a.enum=15,a["enum-member"]=16,a.enumMember=16,a.keyword=17,a.snippet=27,a.text=18,a.color=19,a.file=20,a.reference=21,a.customcolor=22,a.folder=23,a["type-parameter"]=24,a.typeParameter=24,a.account=25,a.issue=26,function(R,F){let x=a[R];return typeof x=="undefined"&&!F&&(x=9),x}}();var d;(function(a){a[a.Deprecated=1]="Deprecated"})(d=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(a){a[a.KeepWhitespace=1]="KeepWhitespace",a[a.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var v;(function(a){a[a.Invoke=0]="Invoke",a[a.TriggerCharacter=1]="TriggerCharacter",a[a.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var u;(function(a){a[a.Invoke=1]="Invoke",a[a.Auto=2]="Auto"})(u=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var h;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(h=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var g;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(g=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(a){return a&&m.URI.isUri(a.uri)&&T.Range.isIRange(a.range)&&(T.Range.isIRange(a.originSelectionRange)||T.Range.isIRange(a.targetSelectionRange))}e.isLocationLink=t;var i;(function(a){a[a.File=0]="File",a[a.Module=1]="Module",a[a.Namespace=2]="Namespace",a[a.Package=3]="Package",a[a.Class=4]="Class",a[a.Method=5]="Method",a[a.Property=6]="Property",a[a.Field=7]="Field",a[a.Constructor=8]="Constructor",a[a.Enum=9]="Enum",a[a.Interface=10]="Interface",a[a.Function=11]="Function",a[a.Variable=12]="Variable",a[a.Constant=13]="Constant",a[a.String=14]="String",a[a.Number=15]="Number",a[a.Boolean=16]="Boolean",a[a.Array=17]="Array",a[a.Object=18]="Object",a[a.Key=19]="Key",a[a.Null=20]="Null",a[a.EnumMember=21]="EnumMember",a[a.Struct=22]="Struct",a[a.Event=23]="Event",a[a.Operator=24]="Operator",a[a.TypeParameter=25]="TypeParameter"})(i=e.SymbolKind||(e.SymbolKind={}));var s;(function(a){a[a.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var r;(function(a){const R=new Map;R.set("file",0),R.set("module",1),R.set("namespace",2),R.set("package",3),R.set("class",4),R.set("method",5),R.set("property",6),R.set("field",7),R.set("constructor",8),R.set("enum",9),R.set("interface",10),R.set("function",11),R.set("variable",12),R.set("constant",13),R.set("string",14),R.set("number",15),R.set("boolean",16),R.set("array",17),R.set("object",18),R.set("key",19),R.set("null",20),R.set("enum-member",21),R.set("struct",22),R.set("event",23),R.set("operator",24),R.set("type-parameter",25);const F=new Map;F.set(0,"file"),F.set(1,"module"),F.set(2,"namespace"),F.set(3,"package"),F.set(4,"class"),F.set(5,"method"),F.set(6,"property"),F.set(7,"field"),F.set(8,"constructor"),F.set(9,"enum"),F.set(10,"interface"),F.set(11,"function"),F.set(12,"variable"),F.set(13,"constant"),F.set(14,"string"),F.set(15,"number"),F.set(16,"boolean"),F.set(17,"array"),F.set(18,"object"),F.set(19,"key"),F.set(20,"null"),F.set(21,"enum-member"),F.set(22,"struct"),F.set(23,"event"),F.set(24,"operator"),F.set(25,"type-parameter");function x(j){return R.get(j)}a.fromString=x;function J(j){return F.get(j)}a.toString=J;function ae(j,W){const Q=F.get(j);let M=Q&&k.iconRegistry.get("symbol-"+Q);return M||(console.info("No codicon found for SymbolKind "+j),M=k.Codicon.symbolProperty),`${W?"inline":"block"} ${M.classNames}`}a.toCssClassName=ae})(r=e.SymbolKinds||(e.SymbolKinds={}));class l{constructor(R){this.value=R}}e.FoldingRangeKind=l,l.Comment=new l("comment"),l.Imports=new l("imports"),l.Region=new l("region");var _;(function(a){a[a.Collapsed=0]="Collapsed",a[a.Expanded=1]="Expanded"})(_=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var p;(function(a){a[a.Editing=0]="Editing",a[a.Preview=1]="Preview"})(p=e.CommentMode||(e.CommentMode={}));var P;(function(a){a[a.Other=0]="Other",a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(P=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new S.LanguageFeatureRegistry,e.RenameProviderRegistry=new S.LanguageFeatureRegistry,e.CompletionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new S.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new S.LanguageFeatureRegistry,e.HoverProviderRegistry=new S.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new S.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new S.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new S.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new S.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new S.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.LinkProviderRegistry=new S.LanguageFeatureRegistry,e.ColorProviderRegistry=new S.LanguageFeatureRegistry,e.SelectionRangeRegistry=new S.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.TokenizationRegistry=new y.TokenizationRegistryImpl;var A;(function(a){a[a.None=0]="None",a[a.Option=1]="Option",a[a.Default=2]="Default",a[a.Preferred=3]="Preferred"})(A=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[88],_e([0,1,8,5,21]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let y=S.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",S.isMacintosh),k.set("isLinux",S.isLinux),k.set("isWindows",S.isWindows),k.set("isWeb",S.isWeb),k.set("isMacNative",S.isMacintosh&&!S.isWeb),k.set("isEdge",y.indexOf("Edg/")>=0),k.set("isFirefox",y.indexOf("Firefox")>=0),k.set("isChrome",y.indexOf("Chrome")>=0),k.set("isSafari",y.indexOf("Safari")>=0);const D=Object.prototype.hasOwnProperty;var b;(function(A){A[A.False=0]="False",A[A.True=1]="True",A[A.Defined=2]="Defined",A[A.Not=3]="Not",A[A.Equals=4]="Equals",A[A.NotEquals=5]="NotEquals",A[A.And=6]="And",A[A.Regex=7]="Regex",A[A.NotRegex=8]="NotRegex",A[A.Or=9]="Or",A[A.In=10]="In",A[A.NotIn=11]="NotIn",A[A.Greater=12]="Greater",A[A.GreaterEquals=13]="GreaterEquals",A[A.Smaller=14]="Smaller",A[A.SmallerEquals=15]="SmallerEquals"})(b=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return I.INSTANCE}static true(){return o.INSTANCE}static has(a){return f.create(a)}static equals(a,R){return c.create(a,R)}static notEquals(a,R){return v.create(a,R)}static regex(a,R){return i.create(a,R)}static in(a,R){return d.create(a,R)}static not(a){return E.create(a)}static and(...a){return r.create(a)}static or(...a){return l.create(a)}static greater(a,R){return u.create(a,R)}static less(a,R){return g.create(a,R)}static deserialize(a,R=!1){if(!!a)return this._deserializeOrExpression(a,R)}static _deserializeOrExpression(a,R){let F=a.split("||");return l.create(F.map(x=>this._deserializeAndExpression(x,R)))}static _deserializeAndExpression(a,R){let F=a.split("&&");return r.create(F.map(x=>this._deserializeOne(x,R)))}static _deserializeOne(a,R){if(a=a.trim(),a.indexOf("!=")>=0){let F=a.split("!=");return v.create(F[0].trim(),this._deserializeValue(F[1],R))}if(a.indexOf("==")>=0){let F=a.split("==");return c.create(F[0].trim(),this._deserializeValue(F[1],R))}if(a.indexOf("=~")>=0){let F=a.split("=~");return i.create(F[0].trim(),this._deserializeRegexValue(F[1],R))}if(a.indexOf(" in ")>=0){let F=a.split(" in ");return d.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(a)){const F=a.split(">=");return h.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(a)){const F=a.split(">");return u.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(a)){const F=a.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(a)){const F=a.split("<");return g.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(a)?E.create(a.substr(1).trim()):f.create(a)}static _deserializeValue(a,R){if(a=a.trim(),a==="true")return!0;if(a==="false")return!1;let F=/^'([^']*)'$/.exec(a);return F?F[1].trim():a}static _deserializeRegexValue(a,R){if(m.isFalsyOrWhitespace(a)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=a.indexOf("/"),x=a.lastIndexOf("/");if(F===x||F<0){if(R)throw new Error(`bad regexp-value '${a}', missing /-enclosure`);return console.warn(`bad regexp-value '${a}', missing /-enclosure`),null}let J=a.slice(F+1,x),ae=a[x+1]==="i"?"i":"";try{return new RegExp(J,ae)}catch(j){if(R)throw new Error(`bad regexp-value '${a}', parse error: ${j}`);return console.warn(`bad regexp-value '${a}', parse error: ${j}`),null}}}e.ContextKeyExpr=C;function n(A,a){return A.cmp(a)}class I{constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class o{constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=o,o.INSTANCE=new o;class f{constructor(a){this.key=a,this.type=2}static create(a){const R=k.get(a);return typeof R=="boolean"?R?o.INSTANCE:I.INSTANCE:new f(a)}cmp(a){return a.type!==this.type?this.type-a.type:p(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return E.create(this.key)}}e.ContextKeyDefinedExpr=f;class c{constructor(a,R){this.key=a,this.value=R,this.type=4}static create(a,R){if(typeof R=="boolean")return R?f.create(a):E.create(a);const F=k.get(a);return typeof F=="boolean"?R===(F?"true":"false")?o.INSTANCE:I.INSTANCE:new c(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(a){return a.mapEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyEqualsExpr=c;class d{constructor(a,R){this.key=a,this.valueKey=R,this.type=10}static create(a,R){return new d(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.valueKey,a.key,a.valueKey)}equals(a){return a.type===this.type?this.key===a.key&&this.valueKey===a.valueKey:!1}evaluate(a){const R=a.getValue(this.valueKey),F=a.getValue(this.key);return Array.isArray(R)?R.indexOf(F)>=0:typeof F=="string"&&typeof R=="object"&&R!==null?D.call(R,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(a){return a.mapIn(this.key,this.valueKey)}negate(){return w.create(this)}}e.ContextKeyInExpr=d;class w{constructor(a){this._actual=a,this.type=11}static create(a){return new w(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new w(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotInExpr=w;class v{constructor(a,R){this.key=a,this.value=R,this.type=5}static create(a,R){if(typeof R=="boolean")return R?E.create(a):f.create(a);const F=k.get(a);return typeof F=="boolean"?R===(F?"true":"false")?I.INSTANCE:o.INSTANCE:new v(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(a){return a.mapNotEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=v;class E{constructor(a){this.key=a,this.type=3}static create(a){const R=k.get(a);return typeof R=="boolean"?R?I.INSTANCE:o.INSTANCE:new E(a)}cmp(a){return a.type!==this.type?this.type-a.type:p(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!a.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(a){return a.mapNot(this.key)}negate(){return f.create(this.key)}}e.ContextKeyNotExpr=E;class u{constructor(a,R){this.key=a,this.value=R,this.type=12}static create(a,R){return new u(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=u;class h{constructor(a,R){this.key=a,this.value=R,this.type=13}static create(a,R){return new h(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreaterEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=h;class g{constructor(a,R){this.key=a,this.value=R,this.type=14}static create(a,R){return new g(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmaller(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeySmallerExpr=g;class t{constructor(a,R){this.key=a,this.value=R,this.type=15}static create(a,R){return new t(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmallerEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(a,R){this.key=a,this.regexp=R,this.type=7}static create(a,R){return new i(a,R)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.key<a.key)return-1;if(this.key>a.key)return 1;const R=this.regexp?this.regexp.source:"",F=a.regexp?a.regexp.source:"";return R<F?-1:R>F?1:0}equals(a){if(a.type===this.type){const R=this.regexp?this.regexp.source:"",F=a.regexp?a.regexp.source:"";return this.key===a.key&&R===F}return!1}evaluate(a){let R=a.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const a=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${a}`}keys(){return[this.key]}map(a){return a.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=i;class s{constructor(a){this._actual=a,this.type=8}static create(a){return new s(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new s(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class r{constructor(a){this.expr=a,this.type=6}static create(a){return r._normalizeArr(a)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let R=0,F=this.expr.length;R<F;R++){const x=n(this.expr[R],a.expr[R]);if(x!==0)return x}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let R=0,F=this.expr.length;R<F;R++)if(!this.expr[R].equals(a.expr[R]))return!1;return!0}return!1}evaluate(a){for(let R=0,F=this.expr.length;R<F;R++)if(!this.expr[R].evaluate(a))return!1;return!0}static _normalizeArr(a){const R=[];let F=!1;for(const x of a)if(!!x){if(x.type===1){F=!0;continue}if(x.type===0)return I.INSTANCE;if(x.type===6){R.push(...x.expr);continue}R.push(x)}if(R.length===0&&F)return o.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(n);R.length>1;){const x=R[R.length-1];if(x.type!==9)break;R.pop();const J=R.pop(),ae=l.create(x.expr.map(j=>r.create([j,J])));ae&&(R.push(ae),R.sort(n))}return R.length===1?R[0]:new r(R)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(let R of this.expr)a.push(...R.keys());return a}map(a){return new r(this.expr.map(R=>R.map(a)))}negate(){let a=[];for(let R of this.expr)a.push(R.negate());return l.create(a)}}e.ContextKeyAndExpr=r;class l{constructor(a){this.expr=a,this.type=9}static create(a){const R=l._normalizeArr(a);if(R.length!==0)return R.length===1?R[0]:new l(R)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let R=0,F=this.expr.length;R<F;R++){const x=n(this.expr[R],a.expr[R]);if(x!==0)return x}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let R=0,F=this.expr.length;R<F;R++)if(!this.expr[R].equals(a.expr[R]))return!1;return!0}return!1}evaluate(a){for(let R=0,F=this.expr.length;R<F;R++)if(this.expr[R].evaluate(a))return!0;return!1}static _normalizeArr(a){let R=[],F=!1;if(a){for(let x=0,J=a.length;x<J;x++){const ae=a[x];if(!!ae){if(ae.type===0){F=!0;continue}if(ae.type===1)return[o.INSTANCE];if(ae.type===9){R=R.concat(ae.expr);continue}R.push(ae)}}if(R.length===0&&F)return[I.INSTANCE];R.sort(n)}return R}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(let R of this.expr)a.push(...R.keys());return a}map(a){return new l(this.expr.map(R=>R.map(a)))}negate(){let a=[];for(let F of this.expr)a.push(F.negate());const R=F=>F.type===9?F.expr:[F];for(;a.length>1;){const F=a.shift(),x=a.shift(),J=[];for(const ae of R(F))for(const j of R(x))J.push(C.and(ae,j));a.unshift(C.or(...J))}return a[0]}}e.ContextKeyOrExpr=l;class _ extends f{constructor(a,R,F){super(a);this._defaultValue=R,typeof F=="object"?_._info.push(Object.assign(Object.assign({},F),{key:a})):F!==!0&&_._info.push({key:a,description:F,type:R!=null?typeof R:void 0})}static all(){return _._info.values()}bindTo(a){return a.createKey(this.key,this._defaultValue)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return C.not(this.key)}isEqualTo(a){return C.equals(this.key,a)}notEqualsTo(a){return C.notEquals(this.key,a)}}e.RawContextKey=_,_._info=[],e.IContextKeyService=T.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(A,a){return A<a?-1:A>a?1:0}function P(A,a,R,F){return A<R?-1:A>R?1:a<F?-1:a>F?1:0}}),define(we[144],_e([0,1,5]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=m.createDecorator("environmentService"),e.INativeEnvironmentService=m.refineServiceDecorator(e.IEnvironmentService)}),define(we[26],_e([0,1,8,5]),function(ee,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function S(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkpaceSupportTypeMessage=S;function y(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class D{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,o){if(typeof I=="undefined"||I===null)return typeof o=="undefined"||o===null;if(typeof o=="undefined"||o===null)return!1;if(typeof I=="string"||typeof o=="string"){let f=typeof I=="string"?I:I.value,c=typeof o=="string"?o:o.value;return m.equalsIgnoreCase(f,c)}return I._lower===o._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=D;function b(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function C(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=C,e.IBuiltinExtensionsScannerService=T.createDecorator("IBuiltinExtensionsScannerService")}),define(we[145],_e([0,1,8,26]),function(ee,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function S(f,c){return f.uuid&&c.uuid?f.uuid===c.uuid:f.id===c.id?!0:m.compareIgnoreCase(f.id,c.id)===0}e.areSameExtensions=S;class y{constructor(c,d){this.version=d,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof y?S(this,c)&&this.version===c.version:!1}}e.ExtensionIdentifierWithVersion=y;function k(f,c){return`${f}.${c}`}e.getExtensionId=k;function D(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function b(f,c){return D(k(f,c))}e.getGalleryExtensionId=b;function C(f,c){const d=[],w=v=>{for(const E of d)if(E.some(u=>S(c(u),c(v))))return E;return null};for(const v of f){const E=w(v);E?E.push(v):d.push([v])}return d}e.groupByExtension=C;function n(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function I(f){return Object.assign({id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0)},f.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function o(f){const c=new Set;for(const d of f)d.malicious&&c.add(d.id.id);return c}e.getMaliciousExtensionsSet=o}),define(we[59],_e([0,1,126,15,2,5,8,10,22]),function(ee,e,m,T,S,y,k,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=y.createDecorator("fileService");function C(W){return W.create===!0}e.isFileOpenForWriteOptions=C;var n;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var I;(function(W){W[W.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var o;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock"})(o=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=f;function c(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=c;function d(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function w(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=w;var v;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(Q,M){super(Q);this.code=M}}e.FileSystemProviderError=E;function u(W,Q){const M=new E(W.toString(),Q);return g(M,Q),M}e.createFileSystemProviderError=u;function h(W){return W||u(m.localize(0,null),v.Unknown)}e.ensureFileSystemProviderError=h;function g(W,Q){return W.name=Q?`${Q} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=g;function t(W){if(!W)return v.Unknown;if(W instanceof E)return W.code;const Q=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!Q)return v.Unknown;switch(Q[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=t;function i(W){if(W instanceof P)return W.fileOperationResult;switch(t(W)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var s;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class r{constructor(Q,M,X){this.resource=Q,this.operation=M,this.target=X}isOperation(Q){return this.operation===Q}}e.FileOperationEvent=r;var l;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class _{constructor(Q,M){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const X of Q)switch(X.type){case 1:this.added||(this.added=b.TernarySearchTree.forUris(()=>M)),this.added.set(X.resource,X);break;case 0:this.updated||(this.updated=b.TernarySearchTree.forUris(()=>M)),this.updated.set(X.resource,X);break;case 2:this.deleted||(this.deleted=b.TernarySearchTree.forUris(()=>M)),this.deleted.set(X.resource,X);break}}contains(Q,...M){return this.doContains(Q,{includeChildren:!1},...M)}affects(Q,...M){return this.doContains(Q,{includeChildren:!0},...M)}doContains(Q,M,...X){var B,U,Y,V,ce,ge;if(!Q)return!1;const Ae=X.length>0;return!!((!Ae||X.includes(1))&&(((B=this.added)===null||B===void 0?void 0:B.get(Q))||M.includeChildren&&((U=this.added)===null||U===void 0?void 0:U.findSuperstr(Q)))||(!Ae||X.includes(0))&&(((Y=this.updated)===null||Y===void 0?void 0:Y.get(Q))||M.includeChildren&&((V=this.updated)===null||V===void 0?void 0:V.findSuperstr(Q)))||(!Ae||X.includes(2))&&(((ce=this.deleted)===null||ce===void 0?void 0:ce.findSubstr(Q))||M.includeChildren&&((ge=this.deleted)===null||ge===void 0?void 0:ge.findSuperstr(Q))))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=_;function p(W,Q,M){return!W||!Q||W===Q||Q.length>W.length?!1:(Q.charAt(Q.length-1)!==T.sep&&(Q+=T.sep),M?k.startsWithIgnoreCase(W,Q):W.indexOf(Q)===0)}e.isParent=p;class P extends Error{constructor(Q,M,X){super(Q);this.fileOperationResult=M,this.options=X}}e.FileOperationError=P;class A extends P{constructor(Q,M,X){super(Q,2,X);this.stat=M}}e.NotModifiedSinceFileOperationError=A;var a;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(a=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var R;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(R=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=F;async function x(W,Q){if(!Q.canHandleResource(S.URI.from({scheme:W.scheme})))return new Promise(M=>{const X=Q.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===W.scheme&&B.added&&(X.dispose(),M())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class J{static formatSize(Q){return D.isNumber(Q)||(Q=0),Q<J.KB?m.localize(1,null,Q.toFixed(0)):Q<J.MB?m.localize(2,null,(Q/J.KB).toFixed(2)):Q<J.GB?m.localize(3,null,(Q/J.MB).toFixed(2)):Q<J.TB?m.localize(4,null,(Q/J.GB).toFixed(2)):m.localize(5,null,(Q/J.TB).toFixed(2))}}e.ByteSize=J,J.KB=1024,J.MB=J.KB*J.KB,J.GB=J.MB*J.KB,J.TB=J.GB*J.KB;var ae;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(ae=e.Arch||(e.Arch={}));function j(W){return{maxFileSize:W===0?300*J.MB:16*J.GB,maxHeapSize:W===0?700*J.MB:2*700*J.MB}}e.getPlatformLimits=j}),define(we[60],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...S){this._entries=new Map;for(let[y,k]of S)this.set(y,k)}set(S,y){const k=this._entries.get(S);return this._entries.set(S,y),k}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}e.ServiceCollection=m}),define(we[146],_e([0,1,11,141,87,5,60,13]),function(ee,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const b=!1;class C extends Error{constructor(c){var d;super("cyclic dependency between services");this.message=(d=c.findCycleSlow())!==null&&d!==void 0?d:`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class n{constructor(c=new k.ServiceCollection,d=!1,w){this._activeInstantiations=new Set,this._services=c,this._strict=d,this._parent=w,this._services.set(y.IInstantiationService,this)}createChild(c){return new n(c,this._strict,this)}invokeFunction(c,...d){let w=o.traceInvocation(c),v=!1;try{return c({get:(u,h)=>{if(v)throw m.illegalState("service accessor is only valid during the invocation of its target method");const g=this._getOrCreateServiceInstance(u,w);if(!g&&h!==y.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return g}},...d)}finally{v=!0,w.stop()}}createInstance(c,...d){let w,v;return c instanceof S.SyncDescriptor?(w=o.traceCreation(c.ctor),v=this._createInstance(c.ctor,c.staticArguments.concat(d),w)):(w=o.traceCreation(c),v=this._createInstance(c,d,w)),w.stop(),v}_createInstance(c,d=[],w){let v=y._util.getServiceDependencies(c).sort((h,g)=>h.index-g.index),E=[];for(const h of v){let g=this._getOrCreateServiceInstance(h.id,w);if(!g&&this._strict&&!h.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${h.id}.`);E.push(g)}let u=v.length>0?v[0].index:d.length;if(d.length!==u){console.warn(`[createInstance] First service dependency of ${c.name} at position ${u+1} conflicts with ${d.length} static arguments`);let h=u-d.length;h>0?d=d.concat(new Array(h)):d=d.slice(0,u)}return new c(...[...d,...E])}_setServiceInstance(c,d){if(this._services.get(c)instanceof S.SyncDescriptor)this._services.set(c,d);else if(this._parent)this._parent._setServiceInstance(c,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let d=this._services.get(c);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):d}_getOrCreateServiceInstance(c,d){let w=this._getServiceInstanceOrDescriptor(c);return w instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,w,d.branch(c,!0)):(d.branch(c,!1),w)}_safeCreateAndCacheServiceInstance(c,d,w){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,d,w)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,d,w){const v=new T.Graph(h=>h.id.toString());let E=0;const u=[{id:c,desc:d,_trace:w}];for(;u.length;){const h=u.pop();if(v.lookupOrInsertNode(h),E++>1e3)throw new C(v);for(let g of y._util.getServiceDependencies(h.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(g.id);if(!t&&!g.optional&&console.warn(`[createInstance] ${c} depends on ${g.id} which is NOT registered.`),t instanceof S.SyncDescriptor){const i={id:g.id,desc:t,_trace:h._trace.branch(g.id,!0)};v.insertEdge(h,i),u.push(i)}}}for(;;){const h=v.roots();if(h.length===0){if(!v.isEmpty())throw new C(v);break}for(const{data:g}of h){if(this._getServiceInstanceOrDescriptor(g.id)instanceof S.SyncDescriptor){const i=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,i)}v.removeNode(g)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,d,w=[],v,E){if(this._services.get(c)instanceof S.SyncDescriptor)return this._createServiceInstance(d,w,v,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,d,w,v,E);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(c,d=[],w,v){if(w){const E=new D.IdleValue(()=>this._createInstance(c,d,v));return new Proxy(Object.create(null),{get(u,h){if(h in u)return u[h];let g=E.value,t=g[h];return typeof t!="function"||(t=t.bind(g),u[h]=t),t},set(u,h,g){return E.value[h]=g,!0}})}else return this._createInstance(c,d,v)}}e.InstantiationService=n;var I;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(I||(I={}));class o{constructor(c,d){this.type=c,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return b?new o(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):o._None}static traceCreation(c){return b?new o(0,c.name):o._None}branch(c,d){let w=new o(2,c.toString());return this._dep.push([c,d,w]),w}stop(){let c=Date.now()-this._start;o._totals+=c;let d=!1;function w(E,u){let h=[],g=new Array(E+1).join("	");for(const[t,i,s]of u._dep)if(i&&s){d=!0,h.push(`${g}CREATES -> ${t}`);let r=w(E+1,s);r&&h.push(r)}else h.push(`${g}uses -> ${t}`);return h.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${o._totals.toFixed(2)}ms)`];(c>2||d)&&console.log(v.join(`
`))}}o._None=new class extends o{constructor(){super(-1,null)}stop(){}branch(){return this}},o._totals=0}),define(we[16],_e([0,1,5,7,21,3,56]),function(ee,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=m.createDecorator("logService"),e.ILoggerService=m.createDecorator("loggerService");function D(){return new Date().toISOString()}var b;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;class C extends T.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class n extends C{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(b.Trace)&&this.log(b.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(b.Debug)&&this.log(b.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(b.Info)&&this.log(b.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(b.Warning)&&this.log(b.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(b.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(b.Error,this.format(s))}else this.log(b.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(b.Critical)&&this.log(b.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let s=0;s<t.length;s++){let r=t[s];if(typeof r=="object")try{r=JSON.stringify(r)}catch(l){}i+=(s>0?" ":"")+r}return i}}e.AbstractMessageLogger=n;class I extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!S.isWindows}trace(t,...i){this.getLevel()<=b.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...i):console.log(`[main ${D()}]`,t,...i))}debug(t,...i){this.getLevel()<=b.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...i):console.log(`[main ${D()}]`,t,...i))}info(t,...i){this.getLevel()<=b.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...i):console.log(`[main ${D()}]`,t,...i))}warn(t,...i){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,t,...i):console.warn(`[main ${D()}]`,t,...i))}error(t,...i){this.getLevel()<=b.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,t,...i):console.error(`[main ${D()}]`,t,...i))}critical(t,...i){this.getLevel()<=b.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,t,...i):console.error(`[main ${D()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class o extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=o;class f extends C{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:k.toErrorMessage(t,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class c extends C{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const s of this.logServices)s.trace(t,...i)}debug(t,...i){for(const s of this.logServices)s.debug(t,...i)}info(t,...i){for(const s of this.logServices)s.info(t,...i)}warn(t,...i){for(const s of this.logServices)s.warn(t,...i)}error(t,...i){for(const s of this.logServices)s.error(t,...i)}critical(t,...i){for(const s of this.logServices)s.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=c;class d extends T.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=d;class w extends T.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(s))}))}createLogger(t,i){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(i==null?void 0:i.always)?b.Trace:this.logLevel,i),this.loggers.set(t.toString(),s),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class v{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(t){}getLevel(){return b.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=v;function E(g){if(g.verbose)return b.Trace;if(typeof g.logLevel=="string"){const t=u(g.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function u(g){switch(g){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=u;function h(g){switch(g){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=h}),define(we[89],_e([0,1,5,127,41]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var y;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(y=e.MarkerTag||(e.MarkerTag={}));var k;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(b){function C(c,d){return d-c}b.compare=C;const n=Object.create(null);n[b.Error]=T.localize(0,null),n[b.Warning]=T.localize(1,null),n[b.Info]=T.localize(2,null);function I(c){return n[c]||""}b.toString=I;function o(c){switch(c){case S.default.Error:return b.Error;case S.default.Warning:return b.Warning;case S.default.Info:return b.Info;case S.default.Ignore:return b.Hint}}b.fromSeverity=o;function f(c){switch(c){case b.Error:return S.default.Error;case b.Warning:return S.default.Warning;case b.Info:return S.default.Info;case b.Hint:return S.default.Ignore}}b.toSeverity=f}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(b){const C="";function n(o){return I(o,!0)}b.makeKey=n;function I(o,f){let c=[C];return o.source?c.push(o.source.replace("\xA6","\\\xA6")):c.push(C),o.code?typeof o.code=="string"?c.push(o.code.replace("\xA6","\\\xA6")):c.push(o.code.value.replace("\xA6","\\\xA6")):c.push(C),o.severity!==void 0&&o.severity!==null?c.push(k.toString(o.severity)):c.push(C),o.message&&f?c.push(o.message.replace("\xA6","\\\xA6")):c.push(C),o.startLineNumber!==void 0&&o.startLineNumber!==null?c.push(o.startLineNumber.toString()):c.push(C),o.startColumn!==void 0&&o.startColumn!==null?c.push(o.startColumn.toString()):c.push(C),o.endLineNumber!==void 0&&o.endLineNumber!==null?c.push(o.endLineNumber.toString()):c.push(C),o.endColumn!==void 0&&o.endColumn!==null?c.push(o.endColumn.toString()):c.push(C),c.push(C),c.join("\xA6")}b.makeKeyOptionalMessage=I})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=m.createDecorator("markerService")}),define(we[147],_e([0,1,41,5,3]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=m.default,e.INotificationService=T.createDecorator("notificationService");var y;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.GLOBAL=1]="GLOBAL"})(y=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new b,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=D;class b{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=b}),define(we[148],_e([0,1,7,8,2,5]),function(ee,e,m,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=y.createDecorator("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return m.Disposable.None},registerValidator(){return m.Disposable.None},registerExternalUriResolver(){return m.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return m.Disposable.None},async open(){return!1},async resolveExternalUri(D){return{resolved:D,dispose(){}}}});function k(D,b){return S.URI.isUri(D)?T.equalsIgnoreCase(D.scheme,b):T.startsWithIgnoreCase(D,b+":")}e.matchesScheme=k});var He=this&&this.__decorate||function(ee,e,m,T){var S=arguments.length,y=S<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,m):T,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(ee,e,m,T);else for(var D=ee.length-1;D>=0;D--)(k=ee[D])&&(y=(S<3?k(y):S>3?k(e,m,y):k(e,m))||y);return S>3&&y&&Object.defineProperty(e,m,y),y},ze=this&&this.__param||function(ee,e){return function(m,T){e(m,T,ee)}};define(we[149],_e([0,1,5,18,7,13]),function(ee,e,m,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=m.createDecorator("progressService");var k;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(k=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let b=class extends S.Disposable{constructor(I,o){super();this.deferred=new y.DeferredPromise,o.withProgress(I,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register(S.toDisposable(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};b=He([ze(1,e.IProgressService)],b),e.UnmanagedProgress=b;class C extends S.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new S.DisposableStore)}start(I){this.stop();const o=++this.currentOperationId,f=new T.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{o===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add(S.toDisposable(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add(S.toDisposable(()=>f.cancel())),this.currentOperationDisposables.add(S.toDisposable(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:o,token:f.token,stop:()=>this.doStop(o),isCurrent:()=>this.currentOperationId===o}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=m.createDecorator("editorProgressService")}),define(we[43],_e([0,1,10,38]),function(ee,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.data=new Map}add(k,D){T.ok(m.isString(k)),T.ok(m.isObject(D)),T.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,D)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new S}),define(we[150],_e([0,1,43,3]),function(ee,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function S(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class y{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,C){this.schemasById[S(b)]=C,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new y;m.Registry.add(e.Extensions.JSONContribution,k)}),define(we[61],_e([0,1,124,3,43,10,150]),function(ee,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const b=S.Registry.as(k.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(v,E=!0){this.registerConfigurations([v],E)}registerConfigurations(v,E=!0){const u=[];v.forEach(h=>{u.push(...this.validateAndRegisterProperties(h,E,h.extensionInfo)),this.configurationContributors.push(h),this.registerJSONConfiguration(h)}),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(v){const E=[],u=h=>{if(h.properties)for(const g in h.properties)E.push(g),delete this.configurationProperties[g],this.removeFromSchema(g,h.properties[g]);h.allOf&&h.allOf.forEach(g=>u(g))};for(const h of v){u(h);const g=this.configurationContributors.indexOf(h);g!==-1&&this.configurationContributors.splice(g,1)}b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}registerDefaultConfigurations(v){const E=[],u=[];for(const h of v)for(const g in h)if(E.push(g),e.OVERRIDE_PROPERTY_PATTERN.test(g)){this.defaultValues[g]=Object.assign(Object.assign({},this.defaultValues[g]||{}),h[g]);const t={type:"object",default:this.defaultValues[g],description:m.localize(1,null,g),$ref:e.resourceLanguageSettingsSchemaId};u.push(I(g)),this.configurationProperties[g]=t,this.defaultLanguageConfigurationOverridesNode.properties[g]=t}else{this.defaultValues[g]=h[g];const t=this.configurationProperties[g];t&&(this.updatePropertyDefaultValue(g,t),this.updateSchema(g,t))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}deregisterDefaultConfigurations(v){const E=[];for(const u of v)for(const h in u)if(E.push(h),delete this.defaultValues[h],e.OVERRIDE_PROPERTY_PATTERN.test(h))delete this.configurationProperties[h],delete this.defaultLanguageConfigurationOverridesNode.properties[h];else{const g=this.configurationProperties[h];g&&(this.updatePropertyDefaultValue(h,g),this.updateSchema(h,g))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}notifyConfigurationSchemaUpdated(...v){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(v){for(const E of v)this.overrideIdentifiers.add(E);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(v,E=!0,u,h=3){var g;h=y.isUndefinedOrNull(v.scope)?h:v.scope;let t=[],i=v.properties;if(i)for(let r in i){if(E&&c(r)){delete i[r];continue}const l=i[r];if(this.updatePropertyDefaultValue(r,l),e.OVERRIDE_PROPERTY_PATTERN.test(r)?l.scope=void 0:(l.scope=y.isUndefinedOrNull(l.scope)?h:l.scope,l.restricted=y.isUndefinedOrNull(l.restricted)?!!((g=u==null?void 0:u.restrictedConfigurations)===null||g===void 0?void 0:g.includes(r)):l.restricted),i[r].hasOwnProperty("included")&&!i[r].included){this.excludedConfigurationProperties[r]=i[r],delete i[r];continue}else this.configurationProperties[r]=i[r];!i[r].deprecationMessage&&i[r].markdownDeprecationMessage&&(i[r].deprecationMessage=i[r].markdownDeprecationMessage),t.push(r)}let s=v.allOf;if(s)for(let r of s)t.push(...this.validateAndRegisterProperties(r,E,u,h));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(v){const E=u=>{let h=u.properties;if(h)for(const t in h)this.updateSchema(t,h[t]);let g=u.allOf;g&&g.forEach(E)};E(v)}updateSchema(v,E){switch(e.allSettings.properties[v]=E,E.scope){case 1:e.applicationSettings.properties[v]=E;break;case 2:e.machineSettings.properties[v]=E;break;case 6:e.machineOverridableSettings.properties[v]=E;break;case 3:e.windowSettings.properties[v]=E;break;case 4:e.resourceSettings.properties[v]=E;break;case 5:e.resourceSettings.properties[v]=E,this.resourceLanguageSettingsSchema.properties[v]=E;break}}removeFromSchema(v,E){switch(delete e.allSettings.properties[v],E.scope){case 1:delete e.applicationSettings.properties[v];break;case 2:delete e.machineSettings.properties[v];break;case 6:delete e.machineOverridableSettings.properties[v];break;case 3:delete e.windowSettings.properties[v];break;case 4:case 5:delete e.resourceSettings.properties[v];break}}updateOverridePropertyPatternKey(){for(const v of this.overrideIdentifiers.values()){const E=`[${v}]`,u={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(E,u),e.allSettings.properties[E]=u,e.applicationSettings.properties[E]=u,e.machineSettings.properties[E]=u,e.machineOverridableSettings.properties[E]=u,e.windowSettings.properties[E]=u,e.resourceSettings.properties[E]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(v,E){let u=this.defaultValues[v];y.isUndefined(u)&&(u=E.default),y.isUndefined(u)&&(u=o(E.type)),E.default=u}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function I(w){return w.substring(1,w.length-1)}e.overrideIdentifierFromKey=I;function o(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=o;const f=new C;S.Registry.add(e.Extensions.Configuration,f);function c(w){return w.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(w)?m.localize(5,null,w):f.getConfigurationProperties()[w]!==void 0?m.localize(6,null,w):null:m.localize(4,null)}e.validateProperty=c;function d(){const w=[],v=f.getConfigurationProperties();for(const E of Object.keys(v))w.push([E,v[E].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=d}),define(we[90],_e([0,1,24,10,2,43,5,61]),function(ee,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=k.createDecorator("configurationService");function b(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof S.URI)}e.isConfigurationOverrides=b;var C;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function I(i,s){const r=s?i?s.keys.filter(R=>i.keys.indexOf(R)===-1):[...s.keys]:[],l=i?s?i.keys.filter(R=>s.keys.indexOf(R)===-1):[...i.keys]:[],_=[];if(s&&i){for(const R of i.keys)if(s.keys.indexOf(R)!==-1){const F=v(i.contents,R),x=v(s.contents,R);m.equals(F,x)||_.push(R)}}const p=[],P=R=>{const F={};for(const x of R)for(const J of x.identifiers)F[g(J)]=x;return F},A=s?P(s.overrides):{},a=i?P(i.overrides):{};if(Object.keys(A).length)for(const R of r){const F=A[R];F&&p.push([D.overrideIdentifierFromKey(R),F.keys])}if(Object.keys(a).length)for(const R of l){const F=a[R];F&&p.push([D.overrideIdentifierFromKey(R),F.keys])}if(Object.keys(A).length&&Object.keys(a).length)for(const R of _){const F=a[R],x=A[R];if(F&&x){const J=I({contents:F.contents,keys:F.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});p.push([D.overrideIdentifierFromKey(R),[...J.added,...J.removed,...J.updated]])}}return{added:r,removed:l,updated:_,overrides:p}}e.compare=I;function o(i,s){const r=[];for(const l of Object.keys(i))if(D.OVERRIDE_PROPERTY_PATTERN.test(l)){const _={};for(const p in i[l])_[p]=i[l][p];r.push({identifiers:[D.overrideIdentifierFromKey(l).trim()],keys:Object.keys(_),contents:f(_,s)})}return r}e.toOverrides=o;function f(i,s){const r=Object.create(null);for(let l in i)c(r,l,i[l],s);return r}e.toValuesTree=f;function c(i,s,r,l){const _=s.split("."),p=_.pop();let P=i;for(let A=0;A<_.length;A++){let a=_[A],R=P[a];switch(typeof R){case"undefined":R=P[a]=Object.create(null);break;case"object":break;default:l(`Ignoring ${s} as ${_.slice(0,A+1).join(".")} is ${JSON.stringify(R)}`);return}P=R}if(typeof P=="object"&&P!==null)try{P[p]=r}catch(A){l(`Ignoring ${s} as ${_.join(".")} is ${JSON.stringify(P)}`)}else l(`Ignoring ${s} as ${_.join(".")} is ${JSON.stringify(P)}`)}e.addToValueTree=c;function d(i,s){const r=s.split(".");w(i,r)}e.removeFromValueTree=d;function w(i,s){const r=s.shift();if(s.length===0){delete i[r];return}if(Object.keys(i).indexOf(r)!==-1){const l=i[r];typeof l=="object"&&!Array.isArray(l)&&(w(l,s),Object.keys(l).length===0&&delete i[r])}}function v(i,s,r){function l(P,A){let a=P;for(const R of A){if(typeof a!="object"||a===null)return;a=a[R]}return a}const _=s.split("."),p=l(i,_);return typeof p=="undefined"?r:p}e.getConfigurationValue=v;function E(i,s,r){Object.keys(s).forEach(l=>{l!=="__proto__"&&(l in i?T.isObject(i[l])&&T.isObject(s[l])?E(i[l],s[l],r):r&&(i[l]=s[l]):i[l]=s[l])})}e.merge=E;function u(){const i=y.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=u;function h(){const i=Object.create(null),s=y.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let r in s){let l=s[r].default;c(i,r,l,_=>console.error(`Conflict in default settings: ${_}`))}return i}e.getDefaultValues=h;function g(i){return`[${i}]`}e.keyFromOverrideIdentifier=g;function t(i,s,r){const l=i.inspect(s),_=i.inspect(r);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof _.userValue!="undefined"||typeof _.workspaceValue!="undefined"||typeof _.workspaceFolderValue!="undefined"?_.value:l.defaultValue}e.getMigratedSettingValue=t}),define(we[151],_e([0,1,107,22,17,10,24,2,61,90,43,7,3]),function(ee,e,m,T,S,y,k,D,b,C,n,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},i=[],s=[]){this._contents=t,this._keys=i,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?C.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,i){const s=this.getContentsForOverrideIdentifer(i);return s?t?C.getConfigurationValue(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const r of S.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[r],_=i[r];_&&(typeof l=="object"&&typeof _=="object"?(l=k.deepClone(l),this.mergeContents(l,_)):l=_),s[r]=l}return new f(s,this.keys,this.overrides)}merge(...t){const i=k.deepClone(this.contents),s=k.deepClone(this.overrides),r=[...this.keys];for(const l of t){this.mergeContents(i,l.contents);for(const _ of l.overrides){const[p]=s.filter(P=>S.equals(P.identifiers,_.identifiers));p?this.mergeContents(p.contents,_.contents):s.push(k.deepClone(_))}for(const _ of l.keys)r.indexOf(_)===-1&&r.push(_)}return new f(i,r,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const s of Object.keys(i)){if(s in t&&y.isObject(t[s])&&y.isObject(i[s])){this.mergeContents(t[s],i[s]);continue}t[s]=k.deepClone(i[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?k.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),C.addToValueTree(this.contents,t,i,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&C.removeFromValueTree(this.contents,t)}addKey(t){let i=this.keys.length;for(let s=0;s<i;s++)t.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=f;class c extends f{constructor(){const t=C.getDefaultValues(),i=C.getConfigurationKeys(),s=[];for(const r of Object.keys(t))b.OVERRIDE_PROPERTY_PATTERN.test(r)&&s.push({identifiers:[b.overrideIdentifierFromKey(r).trim()],keys:Object.keys(t[r]),contents:C.toValuesTree(t[r],l=>console.error(`Conflict in default settings file: ${l}`))});super(t,i,s)}}e.DefaultConfigurationModel=c;class d{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!y.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:s,keys:r,overrides:l,restricted:_}=this.doParseRaw(t,i);this._configurationModel=new f(s,r,l),this._restrictedConfigurations=_||[]}doParseContent(t){let i={},s=null,r=[],l=[],_=[];function p(A){Array.isArray(r)?r.push(A):s&&(r[s]=A)}let P={onObjectBegin:()=>{let A={};p(A),l.push(r),r=A,s=null},onObjectProperty:A=>{s=A},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{let A=[];p(A),l.push(r),r=A,s=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:p,onError:(A,a,R)=>{_.push({error:A,offset:a,length:R})}};if(t)try{m.visit(t,P),i=r[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return i}doParseRaw(t,i){const s=n.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,s,!0,i);t=r.raw;const l=C.toValuesTree(t,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),_=Object.keys(t),p=C.toOverrides(t,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:l,keys:_,overrides:p,restricted:r.restricted}}filter(t,i,s,r){if(!(r==null?void 0:r.scopes)&&!(r==null?void 0:r.skipRestricted))return{raw:t,restricted:[]};const l={},_=[];for(let p in t)if(b.OVERRIDE_PROPERTY_PATTERN.test(p)&&s){const P=this.filter(t[p],i,!1,r);l[p]=P.raw,_.push(...P.restricted)}else{const P=i[p],A=P?typeof P.scope!="undefined"?P.scope:3:void 0;(P==null?void 0:P.restricted)&&_.push(p),(A===void 0||r.scopes===void 0||r.scopes.includes(A))&&(r.skipRestricted&&(P==null?void 0:P.restricted)||(l[p]=t[p]))}return{raw:l,restricted:_}}}e.ConfigurationModelParser=d;class w extends I.Disposable{constructor(t,i,s,r){super();this.userSettingsResource=t,this.scopes=i,this.fileService=r,this._onDidChange=this._register(new o.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(o.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class v{constructor(t,i,s=new f,r=new f,l=new T.ResourceMap,_=new f,p=new T.ResourceMap,P=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=r,this._folderConfigurations=l,this._memoryConfiguration=_,this._memoryConfigurationByResource=p,this._freeze=P,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(t,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(t)}updateValue(t,i,s={}){let r;s.resource?(r=this._memoryConfigurationByResource.get(s.resource),r||(r=new f,this._memoryConfigurationByResource.set(s.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(t):r.setValue(t,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,s){const r=this.getConsolidateConfigurationModel(i,s),l=this.getFolderConfigurationModelForResource(i.resource,s),_=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,p=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),P=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),A=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),a=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=l?i.overrideIdentifier?l.freeze().override(i.overrideIdentifier).getValue(t):l.freeze().getValue(t):void 0,x=i.overrideIdentifier?_.override(i.overrideIdentifier).getValue(t):_.getValue(t),J=r.getValue(t),ae=S.distinct(S.flatten(r.overrides.map(j=>j.identifiers))).filter(j=>r.getOverrideValue(t,j)!==void 0);return{defaultValue:p,userValue:P,userLocalValue:A,userRemoteValue:a,workspaceValue:R,workspaceFolderValue:F,memoryValue:x,value:J,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:P!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:A!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:a!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:l==null?void 0:l.freeze().getValue(t),override:i.overrideIdentifier?l==null?void 0:l.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:_.getValue(t),override:i.overrideIdentifier?_.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ae.length?ae:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=i.filter(r=>b.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const l=b.overrideIdentifierFromKey(r),_=this._defaultConfiguration.getKeysForOverrideIdentifier(l),p=t.getKeysForOverrideIdentifier(l),P=[...p.filter(A=>_.indexOf(A)===-1),..._.filter(A=>p.indexOf(A)===-1),..._.filter(A=>!k.equals(this._defaultConfiguration.override(l).getValue(A),t.override(l).getValue(A)))];return[l,P]});return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:r,overrides:l}=C.compare(this.localUserConfiguration,t),_=[...i,...s,...r];return _.length&&this.updateLocalUserConfiguration(t),{keys:_,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:r,overrides:l}=C.compare(this.remoteUserConfiguration,t);let _=[...i,...s,...r];return _.length&&this.updateRemoteUserConfiguration(t),{keys:_,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:r,overrides:l}=C.compare(this.workspaceConfiguration,t);let _=[...i,...s,...r];return _.length&&this.updateWorkspaceConfiguration(t),{keys:_,overrides:l}}compareAndUpdateFolderConfiguration(t,i){const s=this.folderConfigurations.get(t),{added:r,updated:l,removed:_,overrides:p}=C.compare(s,i);let P=[...r,...l,..._];return(P.length||!s)&&this.updateFolderConfiguration(t,i),{keys:P,overrides:p}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:r,removed:l,overrides:_}=C.compare(i,void 0);return{keys:[...s,...r,...l],overrides:_}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let s=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const r=i.getFolder(t);r&&(s=this.getFolderConsolidatedConfiguration(r.uri)||s);const l=this._memoryConfigurationByResource.get(t);l&&(s=s.merge(l))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(i=s.merge(r),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=s}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:s,overrides:r,keys:l}=this._folderConfigurations.get(i);return t.push([i,{contents:s,overrides:r,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),l=t.folders.reduce((_,p)=>(_.set(D.URI.revive(p[0]),this.parseConfigurationModel(p[1])),_),new T.ResourceMap);return new v(i,s,new f,r,l,new f,new T.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=v;function E(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const t=new Set,i=new Map;for(const r of g)r.keys.forEach(l=>t.add(l)),r.overrides.forEach(([l,_])=>{const p=T.getOrSet(i,l,new Set);_.forEach(P=>p.add(P))});const s=[];return i.forEach((r,l)=>s.push([l,[...r.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=E;class u{constructor(t,i,s,r){this.change=t,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=r,this._previousConfiguration=void 0;const l=new Set;t.keys.forEach(p=>l.add(p)),t.overrides.forEach(([,p])=>p.forEach(P=>l.add(P))),this.affectedKeys=[...l.values()];const _=new f;this.affectedKeys.forEach(p=>_.setValue(p,{})),this.affectedKeysTree=_.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,l=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!k.equals(r,l)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let s=C.toValuesTree({[i]:!0},()=>{}),r;for(;typeof s=="object"&&(r=Object.keys(s)[0]);){if(t=t[r],!t)return!1;s=s[r]}return!0}}e.ConfigurationChangeEvent=u;class h extends u{constructor(t,i,s,r){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=s,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=h}),define(we[91],_e([0,1,5]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=m.createDecorator("remoteAuthorityResolverService");var T;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class S extends Error{constructor(k,D=T.Unknown,b){super(k);this._message=k,this._code=D,this._detail=b,this.isHandled=D===T.NotAvailable&&b===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,S.prototype)}static isTemporarilyNotAvailable(k){return k instanceof S&&k._code===T.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof S&&k._code===T.NoResolverFound}static isHandled(k){return k instanceof S&&k.isHandled}}e.RemoteAuthorityResolverError=S}),define(we[92],_e([0,1,12]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function T(C){return C.scheme===m.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=T;function S(C){if(!C)return;const n=C.indexOf("+");return n<0?C:C.substr(0,n)}e.getRemoteName=S;function y(C){return C.scheme!==m.Schemas.file&&C.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=y;function k(C){if(C.folders.length)return C.folders.every(n=>y(n.uri))?C.folders[0].uri:void 0;if(C.configuration&&y(C.configuration))return C.configuration}e.getVirtualWorkspaceLocation=k;function D(C){var n;return(n=k(C))===null||n===void 0?void 0:n.scheme}e.getVirtualWorkspaceScheme=D;function b(C){return k(C)!==void 0}e.isVirtualWorkspace=b}),define(we[152],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class m{constructor(S){this._callback=S,this._terminalBufferMap=new Map}dispose(){for(const S of this._terminalBufferMap.values())S.dispose()}startBuffering(S,y,k=5){let D;return D=y(b=>{const C=typeof b=="string"?b:b.data;let n=this._terminalBufferMap.get(S);if(n){n.data.push(C);return}const I=setTimeout(()=>this.flushBuffer(S),k);n={data:[C],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(S),D.dispose()}},this._terminalBufferMap.set(S,n)}),D}stopBuffering(S){const y=this._terminalBufferMap.get(S);y&&y.dispose()}flushBuffer(S){const y=this._terminalBufferMap.get(S);y&&(this._terminalBufferMap.delete(S),this._callback(S,y.data.join("")))}}e.TerminalDataBufferer=m}),define(we[44],_e([0,1,2,25,5,22]),function(ee,e,m,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=S.createDecorator("contextService");var k;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function D(o){const f=o;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=D;function b(o){const f=o;return!!(f&&typeof f=="object"&&m.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=b;class C{constructor(f,c,d,w){this._id=f,this._configuration=d,this._ignorePathCasing=w,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=C;class n{constructor(f,c){this.raw=c,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return T.joinPath(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function I(o){return new n({uri:o,index:0,name:T.basenameOrAuthority(o)},{uri:o.toString()})}e.toWorkspaceFolder=I}),define(we[62],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class m{constructor(S){this.id=S,this._data=new Map,this._idPool=1}add(S){const y=this._idPool++;return this._data.set(y,S),this.logDebugInfo(),y}get(S,y){return this._data.has(S)?this._data.get(S)[y]:void 0}delete(S){this._data.delete(S),this.logDebugInfo()}logDebugInfo(){!m.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=m,m.enableDebugLogging=!1}),define(we[63],_e([0,1,2,3,5]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=S.createDecorator("IExtHostEditorTabs");class y{constructor(){this._onDidChangeTabs=new T.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(D){this._tabs=D.map(b=>({name:b.name,group:b.group,resource:m.URI.revive(b.resource),isActive:b.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=y}),define(we[45],_e([0,1,12,5]),function(ee,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class S{constructor(){this._systemSchemes=new Set(Object.keys(m.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(k,D){D===null?this._providerInfo.delete(k):this._providerInfo.set(k,D)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=S,e.IExtHostFileSystemInfo=T.createDecorator("IExtHostFileSystemInfo")}),define(we[28],_e([0,1,5]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=m.createDecorator("IExtHostInitDataService")}),define(we[153],_e([0,1,13]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(k,D,b){this._deferredPromises=new Map,this._id=k,this._shared=D,this._storage=b,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new m.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of C.values())n.complete()}catch(n){for(const I of C.values())I.error(n)}})()},0)}get keys(){var k;return Object.entries((k=this._value)!==null&&k!==void 0?k:{}).filter(([,D])=>D!==void 0).map(([D])=>D)}get whenReady(){return this._init}get(k,D){let b=this._value[k];return typeof b=="undefined"&&(b=D),b}update(k,D){this._value[k]=D;let b=this._deferredPromises.get(k);if(b!==void 0)return b.p;const C=new m.DeferredPromise;return this._deferredPromises.set(k,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=T;class S extends T{constructor(k,D){super(k.identifier.value,!0,D);this._extension=k}setKeysForSync(k){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},k)}}e.ExtensionGlobalMemento=S}),define(we[154],_e([0,1,3,2,16]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let y=class{constructor(D,b){this._logService=D,this._notebooksAndEditors=b,this._onDidChangeNotebookDocumentMetadata=new m.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new m.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(D,b,C){this._notebooksAndEditors.getNotebookDocument(T.URI.revive(D)).acceptModelChanged(b,C)}$acceptDirtyStateChanged(D,b){this._notebooksAndEditors.getNotebookDocument(T.URI.revive(D)).acceptDirty(b)}$acceptModelSaved(D){const b=this._notebooksAndEditors.getNotebookDocument(T.URI.revive(D));this._onDidSaveNotebookDocument.fire(b.apiNotebook)}$acceptDocumentPropertiesChanged(D,b){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",D.path,b);const C=this._notebooksAndEditors.getNotebookDocument(T.URI.revive(D));C.acceptDocumentPropertiesChanged(b),b.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:C.apiNotebook})}};y=He([ze(0,S.ILogService)],y),e.ExtHostNotebookDocuments=y}),define(we[14],_e([0,1,5]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=m.createDecorator("IExtHostRpcService");class T{constructor(y){this.getProxy=y.getProxy.bind(y),this.set=y.set.bind(y),this.assertRegistered=y.assertRegistered.bind(y),this.drain=y.drain.bind(y)}}e.ExtHostRpcService=T});var rt=this&&this.__classPrivateFieldSet||function(ee,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,m):S?S.value=m:e.set(ee,m),m},Ue=this&&this.__classPrivateFieldGet||function(ee,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[155],_e([0,1,26,3]),function(ee,e,m,T){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class y{constructor(D,b){S.set(this,void 0),this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._id=m.ExtensionIdentifier.toKey(D.identifier),rt(this,S,b,"f"),Ue(this,S,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(D){return Ue(this,S,"f").get(this._id,D)}store(D,b){return Ue(this,S,"f").store(this._id,D,b)}delete(D){return Ue(this,S,"f").delete(this._id,D)}}e.ExtensionSecrets=y,S=new WeakMap}),define(we[93],_e([0,1,5,3]),function(ee,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class S{constructor(){this._onDidChangeTelemetryEnabled=new T.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(k){this._enabled=k}$onDidChangeTelemetryEnabled(k){this._enabled=k,this._onDidChangeTelemetryEnabled.fire(k)}}e.ExtHostTelemetry=S,e.IExtHostTelemetry=m.createDecorator("IExtHostTelemetry")}),define(we[94],_e([0,1,3]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var T;(function(k){k[k.NewChild=0]="NewChild",k[k.Disposed=1]="Disposed",k[k.Invalidated=2]="Invalidated",k[k.SetProp=3]="SetProp"})(T=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const S=new WeakMap,y=k=>{let D=S.get(k);return D||(D={children:new Map,bus:new m.Emitter},S.set(k,D)),D};e.getPrivateApiFor=y}),define(we[64],_e([0,1,5,3,14]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var y;(function(D){function b(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,protocol:n.protocol}}D.fromApiTunnel=b;function C(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public,protocol:n.protocol}}D.fromServiceTunnel=C})(y=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=m.createDecorator("IExtHostTunnelService");let k=class{constructor(b){this.onDidChangeTunnels=new T.Emitter().event}async $applyCandidateFilter(b){return b}async openTunnel(b,C){}async getTunnels(){return[]}async setTunnelExtensionFunctions(b){return{dispose:()=>{}}}registerPortsAttributesProvider(b,C){return{dispose:()=>{}}}async $providePortAttributes(b,C,n,I,o){return[]}async $forwardPort(b,C){}async $closeTunnel(b){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=He([ze(0,S.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var rt=this&&this.__classPrivateFieldSet||function(ee,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,m):S?S.value=m:e.set(ee,m),m},Ue=this&&this.__classPrivateFieldGet||function(ee,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[6],_e([0,1,17,11,79,22,81,10,2,34,59,91,94]),function(ee,e,m,T,S,y,k,D,b,C,n,I,o){"use strict";var f,c,d,w,v,E,u,h,g,t,i,s,r,l,_,p,P,A;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestRunRequest=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function a(O){function L(){return Reflect.construct(O,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(O,"name")),Object.setPrototypeOf(L,O),Object.setPrototypeOf(L.prototype,O.prototype),L}let R=v=class{constructor(L){f.set(this,void 0),rt(this,f,L,"f")}static from(...L){let ne=L;return new v(function(){if(ne){for(const De of ne)De&&typeof De.dispose=="function"&&De.dispose();ne=void 0}})}dispose(){typeof Ue(this,f,"f")=="function"&&(Ue(this,f,"f").call(this),rt(this,f,void 0,"f"))}};f=new WeakMap,R=v=He([a],R),e.Disposable=R;let F=E=class{constructor(L,ne){if(L<0)throw T.illegalArgument("line must be non-negative");if(ne<0)throw T.illegalArgument("character must be non-negative");this._line=L,this._character=ne}static Min(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let De=1;De<L.length;De++){const je=L[De];je.isBefore(ne)&&(ne=je)}return ne}static Max(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let De=1;De<L.length;De++){const je=L[De];je.isAfter(ne)&&(ne=je)}return ne}static isPosition(L){if(!L)return!1;if(L instanceof E)return!0;let{line:ne,character:De}=L;return typeof ne=="number"&&typeof De=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,ne=0){if(L===null||ne===null)throw T.illegalArgument();let De;return typeof L=="undefined"?De=0:typeof L=="number"?De=L:(De=typeof L.lineDelta=="number"?L.lineDelta:0,ne=typeof L.characterDelta=="number"?L.characterDelta:0),De===0&&ne===0?this:new E(this.line+De,this.character+ne)}with(L,ne=this.character){if(L===null||ne===null)throw T.illegalArgument();let De;return typeof L=="undefined"?De=this.line:typeof L=="number"?De=L:(De=typeof L.line=="number"?L.line:this.line,ne=typeof L.character=="number"?L.character:this.character),De===this.line&&ne===this.character?this:new E(De,ne)}toJSON(){return{line:this.line,character:this.character}}};F=E=He([a],F),e.Position=F;let x=u=class{constructor(L,ne,De,je){let it,ot;if(typeof L=="number"&&typeof ne=="number"&&typeof De=="number"&&typeof je=="number"?(it=new F(L,ne),ot=new F(De,je)):L instanceof F&&ne instanceof F&&(it=L,ot=ne),!it||!ot)throw new Error("Invalid arguments");it.isBefore(ot)?(this._start=it,this._end=ot):(this._start=ot,this._end=it)}static isRange(L){return L instanceof u?!0:L?F.isPosition(L.start)&&F.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof u?this.contains(L._start)&&this.contains(L._end):L instanceof F?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const ne=F.Max(L.start,this._start),De=F.Min(L.end,this._end);if(!ne.isAfter(De))return new u(ne,De)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ne=F.Min(L.start,this._start),De=F.Max(L.end,this.end);return new u(ne,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,ne=this.end){if(L===null||ne===null)throw T.illegalArgument();let De;return L?F.isPosition(L)?De=L:(De=L.start||this.start,ne=L.end||this.end):De=this.start,De.isEqual(this._start)&&ne.isEqual(this.end)?this:new u(De,ne)}toJSON(){return[this.start,this.end]}};x=u=He([a],x),e.Range=x;let J=h=class extends x{constructor(L,ne,De,je){let it,ot;if(typeof L=="number"&&typeof ne=="number"&&typeof De=="number"&&typeof je=="number"?(it=new F(L,ne),ot=new F(De,je)):L instanceof F&&ne instanceof F&&(it=L,ot=ne),!it||!ot)throw new Error("Invalid arguments");super(it,ot);this._anchor=it,this._active=ot}static isSelection(L){return L instanceof h?!0:L?x.isRange(L)&&F.isPosition(L.anchor)&&F.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};J=h=He([a],J),e.Selection=J;class ae{constructor(L,ne,De){if(typeof L!="string"||L.length===0)throw T.illegalArgument("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw T.illegalArgument("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw T.illegalArgument("connectionToken");this.host=L,this.port=Math.round(ne),this.connectionToken=De}}e.ResolvedAuthority=ae;class j extends Error{constructor(L,ne=I.RemoteAuthorityResolverErrorCode.Unknown,De){super(L);this._message=L,this._code=ne,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,j.prototype)}static NotAvailable(L,ne){return new j(L,I.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(L){return new j(L,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=j;var W;(function(O){O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(W=e.EndOfLine||(e.EndOfLine={}));var Q;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(Q=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let M=g=class{constructor(L,ne){this._range=L,this._newText=ne}static isTextEdit(L){return L instanceof g?!0:L?x.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ne){return new g(L,ne)}static insert(L,ne){return g.replace(new x(L,L),ne)}static delete(L){return g.replace(L,"")}static setEndOfLine(L){const ne=new g(new x(new F(0,0),new F(0,0)),"");return ne.newEol=L,ne}get range(){return this._range}set range(L){if(L&&!x.isRange(L))throw T.illegalArgument("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw T.illegalArgument("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw T.illegalArgument("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};M=g=He([a],M),e.TextEdit=M;var X;(function(O){O[O.File=1]="File",O[O.Text=2]="Text",O[O.Cell=3]="Cell",O[O.CellReplace=5]="CellReplace"})(X=e.FileEditType||(e.FileEditType={}));let B=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,ne,De,je){this._edits.push({_type:1,from:L,to:ne,options:De,metadata:je})}createFile(L,ne,De){this._edits.push({_type:1,from:void 0,to:L,options:ne,metadata:De})}deleteFile(L,ne,De){this._edits.push({_type:1,from:L,to:void 0,options:ne,metadata:De})}replaceNotebookMetadata(L,ne,De){this._edits.push({_type:3,metadata:De,uri:L,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(L,ne,De,je,it){let ot,lt,St=[],It;if(qt.isNotebookRange(ne)&&Rt.isNotebookCellDataArray(De)&&!Rt.isNotebookCellDataArray(je)?(ot=ne.start,lt=ne.end,St=De,It=je):typeof ne=="number"&&typeof De=="number"&&Rt.isNotebookCellDataArray(je)&&(ot=ne,lt=De,St=je,It=it),ot===void 0||lt===void 0)throw new Error("Invalid arguments");(ot!==lt||St.length>0)&&this._edits.push({_type:5,uri:L,index:ot,count:lt-ot,cells:St,metadata:It})}replaceNotebookCellMetadata(L,ne,De,je){this._edits.push({_type:3,metadata:je,uri:L,edit:{editType:8,index:ne,metadata:De}})}replace(L,ne,De,je){this._edits.push({_type:2,uri:L,edit:new M(ne,De),metadata:je})}insert(L,ne,De,je){this.replace(L,new x(ne,ne),De,je)}delete(L,ne,De){this.replace(L,ne,"",De)}has(L){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===L.toString())}set(L,ne){if(ne)for(const De of ne)De&&this._edits.push({_type:2,uri:L,edit:De});else{for(let De=0;De<this._edits.length;De++){const je=this._edits[De];je._type===2&&je.uri.toString()===L.toString()&&(this._edits[De]=void 0)}m.coalesceInPlace(this._edits)}}get(L){const ne=[];for(let De of this._edits)De._type===2&&De.uri.toString()===L.toString()&&ne.push(De.edit);return ne}entries(){const L=new y.ResourceMap;for(let ne of this._edits)if(ne._type===2){let De=L.get(ne.uri);De||(De=[ne.uri,[]],L.set(ne.uri,De)),De[1].push(ne.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};B=He([a],B),e.WorkspaceEdit=B;let U=t=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof t?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=t._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ne=this._tabstop++){if(typeof L=="function"){const De=new t;De._tabstop=this._tabstop,L(De),this._tabstop=De._tabstop,L=De.value}else L=t._escape(L);return this.value+="${",this.value+=ne,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ne=this._tabstop++){const De=L.map(je=>je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(L,ne){if(typeof ne=="function"){const De=new t;De._tabstop=this._tabstop,ne(De),this._tabstop=De._tabstop,ne=De.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};U=t=He([a],U),e.SnippetString=U;var Y;(function(O){O[O.Unnecessary=1]="Unnecessary",O[O.Deprecated=2]="Deprecated"})(Y=e.DiagnosticTag||(e.DiagnosticTag={}));var V;(function(O){O[O.Hint=3]="Hint",O[O.Information=2]="Information",O[O.Warning=1]="Warning",O[O.Error=0]="Error"})(V=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ce=i=class{constructor(L,ne){if(this.uri=L,ne)if(ne instanceof x)this.range=ne;else if(ne instanceof F)this.range=new x(ne,ne);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof i?!0:L?x.isRange(L.range)&&b.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ce=i=He([a],ce),e.Location=ce;let ge=class{constructor(L,ne){this.location=L,this.message=ne}static is(L){return L?typeof L.message=="string"&&L.location&&x.isRange(L.location.range)&&b.URI.isUri(L.location.uri):!1}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.location.range.isEqual(ne.location.range)&&L.location.uri.toString()===ne.location.uri.toString()}};ge=He([a],ge),e.DiagnosticRelatedInformation=ge;let Ae=class{constructor(L,ne,De=V.Error){if(!x.isRange(L))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=L,this.message=ne,this.severity=De}toJSON(){return{severity:V[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.severity===ne.severity&&L.code===ne.code&&L.severity===ne.severity&&L.source===ne.source&&L.range.isEqual(ne.range)&&m.equals(L.tags,ne.tags)&&m.equals(L.relatedInformation,ne.relatedInformation,ge.isEqual)}};Ae=He([a],Ae),e.Diagnostic=Ae;let $e=class{constructor(L,ne){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=ne}};$e=He([a],$e),e.Hover=$e;var Fe;(function(O){O[O.Text=0]="Text",O[O.Read=1]="Read",O[O.Write=2]="Write"})(Fe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ve=class{constructor(L,ne=Fe.Text){this.range=L,this.kind=ne}toJSON(){return{range:this.range,kind:Fe[this.kind]}}};Ve=He([a],Ve),e.DocumentHighlight=Ve;var tt;(function(O){O[O.File=0]="File",O[O.Module=1]="Module",O[O.Namespace=2]="Namespace",O[O.Package=3]="Package",O[O.Class=4]="Class",O[O.Method=5]="Method",O[O.Property=6]="Property",O[O.Field=7]="Field",O[O.Constructor=8]="Constructor",O[O.Enum=9]="Enum",O[O.Interface=10]="Interface",O[O.Function=11]="Function",O[O.Variable=12]="Variable",O[O.Constant=13]="Constant",O[O.String=14]="String",O[O.Number=15]="Number",O[O.Boolean=16]="Boolean",O[O.Array=17]="Array",O[O.Object=18]="Object",O[O.Key=19]="Key",O[O.Null=20]="Null",O[O.EnumMember=21]="EnumMember",O[O.Struct=22]="Struct",O[O.Event=23]="Event",O[O.Operator=24]="Operator",O[O.TypeParameter=25]="TypeParameter"})(tt=e.SymbolKind||(e.SymbolKind={}));var Ke;(function(O){O[O.Deprecated=1]="Deprecated"})(Ke=e.SymbolTag||(e.SymbolTag={}));let Qe=s=class{constructor(L,ne,De,je,it){this.name=L,this.kind=ne,this.containerName=it,typeof De=="string"&&(this.containerName=De),je instanceof ce?this.location=je:De instanceof x&&(this.location=new ce(je,De)),s.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:tt[this.kind],location:this.location,containerName:this.containerName}}};Qe=s=He([a],Qe),e.SymbolInformation=Qe;let $=r=class{constructor(L,ne,De,je,it){this.name=L,this.detail=ne,this.kind=De,this.range=je,this.selectionRange=it,this.children=[],r.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(r.validate)}};$=r=He([a],$),e.DocumentSymbol=$;var K;(function(O){O[O.Invoke=1]="Invoke",O[O.Automatic=2]="Automatic"})(K=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ie=class{constructor(L,ne){this.title=L,this.kind=ne}};ie=He([a],ie),e.CodeAction=ie;let se=l=class{constructor(L){this.value=L}append(L){return new l(this.value?this.value+l.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+l.sep)}};se.sep=".",se=l=He([a],se),e.CodeActionKind=se,se.Empty=new se(""),se.QuickFix=se.Empty.append("quickfix"),se.Refactor=se.Empty.append("refactor"),se.RefactorExtract=se.Refactor.append("extract"),se.RefactorInline=se.Refactor.append("inline"),se.RefactorRewrite=se.Refactor.append("rewrite"),se.Source=se.Empty.append("source"),se.SourceOrganizeImports=se.Source.append("organizeImports"),se.SourceFixAll=se.Source.append("fixAll");let q=class{constructor(L,ne){if(this.range=L,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};q=He([a],q),e.SelectionRange=q;class oe{constructor(L,ne,De,je,it,ot){this.kind=L,this.name=ne,this.detail=De,this.uri=je,this.range=it,this.selectionRange=ot}}e.CallHierarchyItem=oe;class fe{constructor(L,ne){this.fromRanges=ne,this.from=L}}e.CallHierarchyIncomingCall=fe;class Re{constructor(L,ne){this.fromRanges=ne,this.to=L}}e.CallHierarchyOutgoingCall=Re;let xe=class{constructor(L,ne){this.range=L,this.command=ne}get isResolved(){return!!this.command}};xe=He([a],xe),e.CodeLens=xe;let pe=_=class{constructor(L,ne=!1){c.set(this,void 0),rt(this,c,new S.MarkdownString(L,{supportThemeIcons:ne}),"f")}static isMarkdownString(L){return L instanceof _?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Ue(this,c,"f").value}set value(L){Ue(this,c,"f").value=L}get isTrusted(){return Ue(this,c,"f").isTrusted}set isTrusted(L){Ue(this,c,"f").isTrusted=L}get supportThemeIcons(){return Ue(this,c,"f").supportThemeIcons}set supportThemeIcons(L){Ue(this,c,"f").supportThemeIcons=L}appendText(L){return Ue(this,c,"f").appendText(L),this}appendMarkdown(L){return Ue(this,c,"f").appendMarkdown(L),this}appendCodeblock(L,ne){return Ue(this,c,"f").appendCodeblock(ne??"",L),this}};c=new WeakMap,pe=_=He([a],pe),e.MarkdownString=pe;let qe=class{constructor(L,ne){this.label=L,this.documentation=ne}};qe=He([a],qe),e.ParameterInformation=qe;let H=class{constructor(L,ne){this.label=L,this.documentation=ne,this.parameters=[]}};H=He([a],H),e.SignatureInformation=H;let te=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};te=He([a],te),e.SignatureHelp=te;var me;(function(O){O[O.Invoke=1]="Invoke",O[O.TriggerCharacter=2]="TriggerCharacter",O[O.ContentChange=3]="ContentChange"})(me=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Te;(function(O){O[O.Other=0]="Other",O[O.Type=1]="Type",O[O.Parameter=2]="Parameter"})(Te=e.InlayHintKind||(e.InlayHintKind={}));let Le=class{constructor(L,ne,De){this.text=L,this.position=ne,this.kind=De}};Le=He([a],Le),e.InlayHint=Le;var Ge;(function(O){O[O.Invoke=0]="Invoke",O[O.TriggerCharacter=1]="TriggerCharacter",O[O.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ge=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Se;(function(O){O[O.Text=0]="Text",O[O.Method=1]="Method",O[O.Function=2]="Function",O[O.Constructor=3]="Constructor",O[O.Field=4]="Field",O[O.Variable=5]="Variable",O[O.Class=6]="Class",O[O.Interface=7]="Interface",O[O.Module=8]="Module",O[O.Property=9]="Property",O[O.Unit=10]="Unit",O[O.Value=11]="Value",O[O.Enum=12]="Enum",O[O.Keyword=13]="Keyword",O[O.Snippet=14]="Snippet",O[O.Color=15]="Color",O[O.File=16]="File",O[O.Reference=17]="Reference",O[O.Folder=18]="Folder",O[O.EnumMember=19]="EnumMember",O[O.Constant=20]="Constant",O[O.Struct=21]="Struct",O[O.Event=22]="Event",O[O.Operator=23]="Operator",O[O.TypeParameter=24]="TypeParameter",O[O.User=25]="User",O[O.Issue=26]="Issue"})(Se=e.CompletionItemKind||(e.CompletionItemKind={}));var be;(function(O){O[O.Deprecated=1]="Deprecated"})(be=e.CompletionItemTag||(e.CompletionItemTag={}));let Ce=class{constructor(L,ne){this.label=L,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&Se[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ce=He([a],Ce),e.CompletionItem=Ce;let re=class{constructor(L=[],ne=!1){this.items=L,this.isIncomplete=ne}};re=He([a],re),e.CompletionList=re;let de=class{constructor(L,ne,De){this.text=L,this.range=ne,this.command=De}};de=He([a],de),e.InlineSuggestion=de;let N=class{constructor(L){this.items=L}};N=He([a],N),e.InlineSuggestions=N;var G;(function(O){O[O.Active=-1]="Active",O[O.Beside=-2]="Beside",O[O.One=1]="One",O[O.Two=2]="Two",O[O.Three=3]="Three",O[O.Four=4]="Four",O[O.Five=5]="Five",O[O.Six=6]="Six",O[O.Seven=7]="Seven",O[O.Eight=8]="Eight",O[O.Nine=9]="Nine"})(G=e.ViewColumn||(e.ViewColumn={}));var le;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(le=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ke;(function(O){O[O.Off=0]="Off",O[O.On=1]="On",O[O.Relative=2]="Relative"})(ke=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(O){O[O.Manual=1]="Manual",O[O.AfterDelay=2]="AfterDelay",O[O.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ne;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(Ne=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Be;(function(O){O[O.Keyboard=1]="Keyboard",O[O.Mouse=2]="Mouse",O[O.Command=3]="Command"})(Be=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ze;(function(O){O[O.OpenOpen=0]="OpenOpen",O[O.ClosedClosed=1]="ClosedClosed",O[O.OpenClosed=2]="OpenClosed",O[O.ClosedOpen=3]="ClosedOpen"})(Ze=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(O){function L(ne){switch(ne){case"keyboard":return O.Keyboard;case"mouse":return O.Mouse;case"api":return O.Command}}O.fromValue=L}(Be=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Je=class{constructor(L,ne){if(ne&&!b.URI.isUri(ne))throw T.illegalArgument("target");if(!x.isRange(L)||L.isEmpty)throw T.illegalArgument("range");this.range=L,this.target=ne}};Je=He([a],Je),e.DocumentLink=Je;let Ye=class{constructor(L,ne,De,je){this.red=L,this.green=ne,this.blue=De,this.alpha=je}};Ye=He([a],Ye),e.Color=Ye;let nt=class{constructor(L,ne){if(ne&&!(ne instanceof Ye))throw T.illegalArgument("color");if(!x.isRange(L)||L.isEmpty)throw T.illegalArgument("range");this.range=L,this.color=ne}};nt=He([a],nt),e.ColorInformation=nt;let gt=class{constructor(L){if(!L||typeof L!="string")throw T.illegalArgument("label");this.label=L}};gt=He([a],gt),e.ColorPresentation=gt;var ve;(function(O){O[O.RGB=0]="RGB",O[O.HEX=1]="HEX",O[O.HSL=2]="HSL"})(ve=e.ColorFormat||(e.ColorFormat={}));var ye;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information"})(ye=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class ue{constructor(L,ne,De){if(this.startIndex=L,this.length=ne,this.tooltip=De,typeof L!="number"||L<0)throw T.illegalArgument("startIndex");if(typeof ne!="number"||ne<1)throw T.illegalArgument("length");if(De!==void 0&&typeof De!="string")throw T.illegalArgument("tooltip")}}e.TerminalLink=ue;class z{constructor(L){this.options=L,typeof L!="object"&&T.illegalArgument("options")}}e.TerminalProfile=z;var Oe;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(Oe=e.TaskRevealKind||(e.TaskRevealKind={}));var Ee;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(Ee=e.TaskPanelKind||(e.TaskPanelKind={}));let We=p=class{constructor(L,ne){if(typeof L!="string"||typeof ne!="string")throw T.illegalArgument("name");this._id=L}static from(L){switch(L){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}get id(){return this._id}};We.Clean=new p("clean","Clean"),We.Build=new p("build","Build"),We.Rebuild=new p("rebuild","Rebuild"),We.Test=new p("test","Test"),We=p=He([a],We),e.TaskGroup=We;function Xe(O){let L="";for(let ne=0;ne<O.length;ne++)L+=O[ne].replace(/,/g,",,")+",";return L}let et=class{constructor(L,ne,De){if(typeof L!="string")throw T.illegalArgument("process");this._args=[],this._process=L,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=De):this._options=ne)}get process(){return this._process}set process(L){if(typeof L!="string")throw T.illegalArgument("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let ne of this._args)L.push(ne);return Xe(L)}};et=He([a],et),e.ProcessExecution=et;let st=class{constructor(L,ne,De){if(this._args=[],Array.isArray(ne)){if(!L)throw T.illegalArgument("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw T.illegalArgument("command");this._command=L,this._args=ne,this._options=De}else{if(typeof L!="string")throw T.illegalArgument("commandLine");this._commandLine=L,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw T.illegalArgument("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw T.illegalArgument("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ne of this._args)L.push(typeof ne=="string"?ne:ne.value);return Xe(L)}};st=He([a],st),e.ShellExecution=st;var pt;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(pt=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class _t{constructor(L){this._callback=L}computeId(){return"customExecution"+C.generateUuid()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=_t;let vt=P=class{constructor(L,ne,De,je,it,ot){this.__deprecated=!1,this._definition=this.definition=L;let lt;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=De,this.execution=je,lt=it,this.__deprecated=!0):ne===bt.Global||ne===bt.Workspace?(this.target=ne,this._name=this.name=De,this._source=this.source=je,this.execution=it,lt=ot):(this.target=ne,this._name=this.name=De,this._source=this.source=je,this.execution=it,lt=ot),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof et?this._definition={type:P.ProcessType,id:this._execution.computeId()}:this._execution instanceof st?this._definition={type:P.ShellType,id:this._execution.computeId()}:this._execution instanceof _t?this._definition={type:P.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:P.EmptyType,id:C.generateUuid()}}get definition(){return this._definition}set definition(L){if(L==null)throw T.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw T.illegalArgument("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const ne=this._definition.type;(P.EmptyType===ne||P.ProcessType===ne||P.ShellType===ne||P.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw T.illegalArgument("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};vt.ExtensionCallbackType="customExecution",vt.ProcessType="process",vt.ShellType="shell",vt.EmptyType="$empty",vt=P=He([a],vt),e.Task=vt;var xt;(function(O){O[O.SourceControl=1]="SourceControl",O[O.Window=10]="Window",O[O.Notification=15]="Notification"})(xt=e.ProgressLocation||(e.ProgressLocation={}));let Et=class{constructor(L,ne=dt.None){this.collapsibleState=ne,b.URI.isUri(L)?this.resourceUri=L:this.label=L}};Et=He([a],Et),e.TreeItem=Et;var dt;(function(O){O[O.None=0]="None",O[O.Collapsed=1]="Collapsed",O[O.Expanded=2]="Expanded"})(dt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ut=class{constructor(L,ne){this.id=L,this.color=ne}};ut=He([a],ut),e.ThemeIcon=ut,ut.File=new ut("file"),ut.Folder=new ut("folder");let ht=class{constructor(L){this.id=L}};ht=He([a],ht),e.ThemeColor=ht;var Ht;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.WorkspaceFolder=3]="WorkspaceFolder"})(Ht=e.ConfigurationTarget||(e.ConfigurationTarget={}));let kt=class{constructor(L,ne){if(typeof L!="string"&&(!L||!b.URI.isUri(L)&&!b.URI.isUri(L.uri)))throw T.illegalArgument("base");if(typeof ne!="string")throw T.illegalArgument("pattern");typeof L=="string"?(this.baseFolder=b.URI.file(L),this.base=L):b.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=ne}};kt=He([a],kt),e.RelativePattern=kt;let At=class{constructor(L,ne,De,je){this.enabled=typeof L=="boolean"?L:!0,typeof ne=="string"&&(this.condition=ne),typeof De=="string"&&(this.hitCondition=De),typeof je=="string"&&(this.logMessage=je)}get id(){return this._id||(this._id=C.generateUuid()),this._id}};At=He([a],At),e.Breakpoint=At;let Kt=class extends At{constructor(L,ne,De,je,it){super(ne,De,je,it);if(L===null)throw T.illegalArgument("location");this.location=L}};Kt=He([a],Kt),e.SourceBreakpoint=Kt;let yt=class extends At{constructor(L,ne,De,je,it){super(ne,De,je,it);this.functionName=L}};yt=He([a],yt),e.FunctionBreakpoint=yt;let en=class extends At{constructor(L,ne,De,je,it,ot,lt){super(je,it,ot,lt);if(!ne)throw T.illegalArgument("dataId");this.label=L,this.dataId=ne,this.canPersist=De}};en=He([a],en),e.DataBreakpoint=en;let tn=class{constructor(L,ne,De){this.command=L,this.args=ne||[],this.options=De}};tn=He([a],tn),e.DebugAdapterExecutable=tn;let mt=class{constructor(L,ne){this.port=L,this.host=ne}};mt=He([a],mt),e.DebugAdapterServer=mt;let Qt=class{constructor(L){this.path=L}};Qt=He([a],Qt),e.DebugAdapterNamedPipeServer=Qt;let zt=class{constructor(L){this.implementation=L}};zt=He([a],zt),e.DebugAdapterInlineImplementation=zt;let nn=class{constructor(L,ne){this.range=L,this.expression=ne}};nn=He([a],nn),e.EvaluatableExpression=nn;var En;(function(O){O[O.Automatic=0]="Automatic",O[O.Explicit=1]="Explicit"})(En=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Dt=class{constructor(L,ne){this.range=L,this.text=ne}};Dt=He([a],Dt),e.InlineValueText=Dt;let Yt=class{constructor(L,ne,De=!0){this.range=L,this.variableName=ne,this.caseSensitiveLookup=De}};Yt=He([a],Yt),e.InlineValueVariableLookup=Yt;let rn=class{constructor(L,ne){this.range=L,this.expression=ne}};rn=He([a],rn),e.InlineValueEvaluatableExpression=rn;let Bt=class{constructor(L,ne){this.frameId=L,this.stoppedLocation=ne}};Bt=He([a],Bt),e.InlineValueContext=Bt;var ct;(function(O){O[O.Changed=1]="Changed",O[O.Created=2]="Created",O[O.Deleted=3]="Deleted"})(ct=e.FileChangeType||(e.FileChangeType={}));let sn=A=class extends Error{constructor(L,ne=n.FileSystemProviderErrorCode.Unknown,De){var je;super(b.URI.isUri(L)?L.toString(!0):L);this.code=(je=De==null?void 0:De.name)!==null&&je!==void 0?je:"Unknown",n.markAsFileSystemProviderError(this,ne),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(L){return new A(L,n.FileSystemProviderErrorCode.FileExists,A.FileExists)}static FileNotFound(L){return new A(L,n.FileSystemProviderErrorCode.FileNotFound,A.FileNotFound)}static FileNotADirectory(L){return new A(L,n.FileSystemProviderErrorCode.FileNotADirectory,A.FileNotADirectory)}static FileIsADirectory(L){return new A(L,n.FileSystemProviderErrorCode.FileIsADirectory,A.FileIsADirectory)}static NoPermissions(L){return new A(L,n.FileSystemProviderErrorCode.NoPermissions,A.NoPermissions)}static Unavailable(L){return new A(L,n.FileSystemProviderErrorCode.Unavailable,A.Unavailable)}};sn=A=He([a],sn),e.FileSystemError=sn;let Tt=class{constructor(L,ne,De){this.start=L,this.end=ne,this.kind=De}};Tt=He([a],Tt),e.FoldingRange=Tt;var Vt;(function(O){O[O.Comment=1]="Comment",O[O.Imports=2]="Imports",O[O.Region=3]="Region"})(Vt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hn;(function(O){O[O.Collapsed=0]="Collapsed",O[O.Expanded=1]="Expanded"})(hn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var yn;(function(O){O[O.Editing=0]="Editing",O[O.Preview=1]="Preview"})(yn=e.CommentMode||(e.CommentMode={}));class fn{constructor(L,ne=[]){this.tokenTypes=L,this.tokenModifiers=ne}}e.SemanticTokensLegend=fn;function Sn(O){return typeof O=="undefined"||D.isStringArray(O)}class Jt{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let ne=0,De=L.tokenTypes.length;ne<De;ne++)this._tokenTypeStrToInt.set(L.tokenTypes[ne],ne);for(let ne=0,De=L.tokenModifiers.length;ne<De;ne++)this._tokenModifierStrToInt.set(L.tokenModifiers[ne],ne)}}push(L,ne,De,je,it){if(typeof L=="number"&&typeof ne=="number"&&typeof De=="number"&&typeof je=="number"&&(typeof it=="number"||typeof it=="undefined"))return typeof it=="undefined"&&(it=0),this._pushEncoded(L,ne,De,je,it);if(x.isRange(L)&&typeof ne=="string"&&Sn(De))return this._push(L,ne,De);throw T.illegalArgument()}_push(L,ne,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const je=L.start.line,it=L.start.character,ot=L.end.character-L.start.character,lt=this._tokenTypeStrToInt.get(ne);let St=0;if(De)for(const It of De){if(!this._tokenModifierStrToInt.has(It))throw new Error("`tokenModifier` is not in the provided legend");const Ft=this._tokenModifierStrToInt.get(It);St|=1<<Ft>>>0}this._pushEncoded(je,it,ot,lt,St)}_pushEncoded(L,ne,De,je,it){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let It=0,Ft=0;for(let Mt=0;Mt<St;Mt++){let Ot=this._data[5*Mt],cn=this._data[5*Mt+1];Ot===0?(Ot=It,cn+=Ft):Ot+=It,this._data[5*Mt]=Ot,this._data[5*Mt+1]=cn,It=Ot,Ft=cn}}let ot=L,lt=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=De,this._data[this._dataLen++]=je,this._data[this._dataLen++]=it,this._prevLine=L,this._prevChar=ne}static _sortAndDeltaEncode(L){let ne=[];const De=L.length/5|0;for(let lt=0;lt<De;lt++)ne[lt]=lt;ne.sort((lt,St)=>{const It=L[5*lt],Ft=L[5*St];if(It===Ft){const Mt=L[5*lt+1],Ot=L[5*St+1];return Mt-Ot}return It-Ft});const je=new Uint32Array(L.length);let it=0,ot=0;for(let lt=0;lt<De;lt++){const St=5*ne[lt],It=L[St+0],Ft=L[St+1],Mt=L[St+2],Ot=L[St+3],cn=L[St+4],Nn=It-it,Hn=Nn===0?Ft-ot:Ft,dn=5*lt;je[dn+0]=Nn,je[dn+1]=Hn,je[dn+2]=Mt,je[dn+3]=Ot,je[dn+4]=cn,it=It,ot=Ft}return je}build(L){return this._dataIsSortedAndDeltaEncoded?new Lt(new Uint32Array(this._data),L):new Lt(Jt._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=Jt;class Lt{constructor(L,ne){this.resultId=ne,this.data=L}}e.SemanticTokens=Lt;class Dn{constructor(L,ne,De){this.start=L,this.deleteCount=ne,this.data=De}}e.SemanticTokensEdit=Dn;class on{constructor(L,ne){this.resultId=ne,this.edits=L}}e.SemanticTokensEdits=on;var an;(function(O){O[O.Separate=0]="Separate",O[O.MergeWithParent=1]="MergeWithParent"})(an=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Cn;(function(O){O[O.Initial=1]="Initial",O[O.Dynamic=2]="Dynamic"})(Cn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Xt=class{constructor(){}};Xt.Back={iconPath:new ut("arrow-left")},Xt=He([a],Xt),e.QuickInputButtons=Xt;var jt;(function(O){O[O.UI=1]="UI",O[O.Workspace=2]="Workspace"})(jt=e.ExtensionKind||(e.ExtensionKind={}));class kn{constructor(L,ne,De){this.badge=L,this.tooltip=ne,this.color=De}static validate(L){if(L.badge&&L.badge.length!==1&&L.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=kn;let ln=class{constructor(L){this.kind=L}};ln=He([a],ln),e.ColorTheme=ln;var In;(function(O){O[O.Light=1]="Light",O[O.Dark=2]="Dark",O[O.HighContrast=3]="HighContrast"})(In=e.ColorThemeKind||(e.ColorThemeKind={}));class qt{constructor(L,ne){if(L<0)throw T.illegalArgument("start must be positive");if(ne<0)throw T.illegalArgument("end must be positive");L<=ne?(this._start=L,this._end=ne):(this._start=ne,this._end=L)}static isNotebookRange(L){return L instanceof qt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let ne=this._start,De=this._end;return L.start!==void 0&&(ne=L.start),L.end!==void 0&&(De=L.end),ne===this._start&&De===this._end?this:new qt(ne,De)}}e.NotebookRange=qt;class Rt{constructor(L,ne,De,je,it,ot,lt){this.kind=L,this.value=ne,this.languageId=De,this.mime=je,this.outputs=it??[],this.metadata=ot,this.executionSummary=lt,Rt.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ne=>Rt.isNotebookCellData(ne))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Rt;class mn{constructor(L){this.cells=L}}e.NotebookData=mn;class Pt{constructor(L,ne){this.data=L,this.mime=ne;const De=k.normalizeMimeType(ne,!0);if(!De)throw new Error("INVALID mime type, must not be empty or falsy: "+ne);this.mime=De}static isNotebookCellOutputItem(L){return L instanceof Pt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const ne={name:L.name,message:L.message,stack:L.stack};return Pt.json(ne,"application/vnd.code.notebook.error")}static stdout(L){return Pt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Pt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ne="application/octet-stream"){return new Pt(L,ne)}static text(L,ne=k.Mimes.text){const De=Ue(Pt,d,"f",w).encode(String(L));return new Pt(De,ne)}static json(L,ne="application/json"){const De=JSON.stringify(L,void 0,"	");return Pt.text(De,ne)}}e.NotebookCellOutputItem=Pt,d=Pt,w={value:new TextEncoder};class $t{constructor(L,ne,De){this.items=$t.ensureUniqueMimeTypes(L,!0),typeof ne=="string"?(this.id=ne,this.metadata=De):(this.id=C.generateUuid(),this.metadata=ne??De)}static isNotebookCellOutput(L){return L instanceof $t?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&D.isArray(L.items)}static ensureUniqueMimeTypes(L,ne=!1){const De=new Set,je=new Set;for(let it=0;it<L.length;it++){const ot=L[it],lt=k.normalizeMimeType(ot.mime);if(!De.has(lt)){De.add(lt);continue}je.add(it),ne&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return je.size===0?L:L.filter((it,ot)=>!je.has(ot))}}e.NotebookCellOutput=$t;var Me;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(Me=e.NotebookCellKind||(e.NotebookCellKind={}));var un;(function(O){O[O.Idle=1]="Idle",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(un=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var gn;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(gn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var ft;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(ft=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Pn{constructor(L,ne){this.text=L,this.alignment=ne}}e.NotebookCellStatusBarItem=Pn;var An;(function(O){O[O.Default=1]="Default",O[O.Preferred=2]="Preferred"})(An=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class pn{constructor(L,ne=[]){this.uri=L,this.provides=m.asArray(ne)}}e.NotebookRendererScript=pn;let Zt=class{constructor(L,ne){this.label=L,this.timestamp=ne}};Zt=He([a],Zt),e.TimelineItem=Zt;var Tn;(function(O){O[O.Production=1]="Production",O[O.Development=2]="Development",O[O.Test=3]="Test"})(Tn=e.ExtensionMode||(e.ExtensionMode={}));var Rn;(function(O){O[O.Node=1]="Node",O[O.Webworker=2]="Webworker"})(Rn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Fn;(function(O){O[O.Other=0]="Other",O[O.Comment=1]="Comment",O[O.String=2]="String",O[O.RegEx=4]="RegEx"})(Fn=e.StandardTokenType||(e.StandardTokenType={}));class Ln{constructor(L,ne){this.ranges=L,this.wordPattern=ne}}e.LinkedEditingRanges=Ln;class vn{constructor(L,ne){this._port=L,this._autoForwardAction=ne}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=vn;var Mn;(function(O){O[O.Unset=0]="Unset",O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(Mn=e.TestResultState||(e.TestResultState={}));var bn;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information",O[O.Hint=3]="Hint"})(bn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var wn;(function(O){O[O.Pending=0]="Pending",O[O.Resolved=1]="Resolved"})(wn=e.TestItemStatus||(e.TestItemStatus={}));const Nt=(O,L,ne,De)=>{let je=ne;return{enumerable:!0,configurable:!1,get(){return je},set(it){De(je,it)||(je=it,O.bus.fire([3,L,it]))}}},Wt=(O,L)=>O===L,Z=(O,L)=>O===L?!0:!O||!L?!1:O.isEqual(L);class he{constructor(L,ne,De=!1){this.tests=L,this.exclude=ne,this.debug=De}}e.TestRunRequest=he;class Ie{constructor(L,ne,De,je,it){this.data=je;const ot=o.getPrivateApiFor(this);if(Object.defineProperties(this,{id:{value:L,enumerable:!0,writable:!1},uri:{value:De,enumerable:!0,writable:!1},parent:{enumerable:!1,value:it,writable:!1},children:{value:new y.ReadonlyMapView(ot.children),enumerable:!0,writable:!1},range:Nt(ot,"range",void 0,Z),label:Nt(ot,"label",ne,Wt),description:Nt(ot,"description",void 0,Wt),runnable:Nt(ot,"runnable",!0,Wt),debuggable:Nt(ot,"debuggable",!1,Wt),status:Nt(ot,"status",wn.Resolved,Wt),error:Nt(ot,"error",void 0,Wt)}),it){if(!(it instanceof Ie))throw new Error(`The "parent" passed in for TestItem ${L} is invalid`);const lt=o.getPrivateApiFor(it);if(lt.children.has(L))throw new Error(`Attempted to insert a duplicate test item ID ${L}`);lt.children.set(L,this),lt.bus.fire([0,this])}}invalidate(){o.getPrivateApiFor(this).bus.fire([2])}dispose(){this.parent&&o.getPrivateApiFor(this.parent).children.delete(this.id),o.getPrivateApiFor(this).bus.fire([1])}}e.TestItemImpl=Ie;class at{constructor(L){this.message=L,this.severity=bn.Error}static diff(L,ne,De){const je=new at(L);return je.expectedOutput=ne,je.actualOutput=De,je}}e.TestMessage=at;var wt;(function(O){O[O.None=0]="None",O[O.Option=1]="Option",O[O.Default=2]="Default",O[O.Preferred=3]="Preferred"})(wt=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Ct;(function(O){O[O.Untrusted=0]="Untrusted",O[O.Trusted=1]="Trusted",O[O.Unspecified=2]="Unspecified"})(Ct=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Wn;(function(O){O[O.Notify=1]="Notify",O[O.OpenBrowser=2]="OpenBrowser",O[O.OpenPreview=3]="OpenPreview",O[O.Silent=4]="Silent",O[O.Ignore=5]="Ignore",O[O.OpenBrowserOnce=6]="OpenBrowserOnce"})(Wn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(we[95],_e([0,1,38,12,8,120,84,6,17]),function(ee,e,m,T,S,y,k,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const C=new Map;function n(c,d){d?C.set(c,d):C.delete(c)}e.setWordDefinitionFor=n;function I(c){return C.get(c)}e.getWordDefinitionFor=I;class o extends y.MirrorTextModel{constructor(d,w,v,E,u,h,g,t){super(w,v,E,u);this._proxy=d,this._languageId=h,this._isDirty=g,this._notebook=t,this._isDisposed=!1}dispose(){m.ok(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return b.equals(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===T.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},get notebook(){return d._notebook},save(){return d._save()},getText(w){return w?d._getTextInRange(w):d.getText()},get eol(){return d._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(w){return d._lineAt(w)},offsetAt(w){return d._offsetAt(w)},positionAt(w){return d._positionAt(w)},validateRange(w){return d._validateRange(w)},validatePosition(w){return d._validatePosition(w)},getWordRangeAtPosition(w,v){return d._getWordRangeAtPosition(w,v)}}}return Object.freeze(this._document)}_acceptLanguageId(d){m.ok(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){m.ok(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const w=this._validateRange(d);if(w.isEmpty)return"";if(w.isSingleLine)return this._lines[w.start.line].substring(w.start.character,w.end.character);const v=this._eol,E=w.start.line,u=w.end.line,h=[];h.push(this._lines[E].substring(w.start.character));for(let g=E+1;g<u;g++)h.push(this._lines[g]);return h.push(this._lines[u].substring(0,w.end.character)),h.join(v)}_lineAt(d){let w;if(d instanceof D.Position?w=d.line:typeof d=="number"&&(w=d),typeof w!="number"||w<0||w>=this._lines.length||Math.floor(w)!==w)throw new Error("Illegal value for `line`");return new f(w,this._lines[w],w===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getPrefixSum(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const w=this._lineStarts.getIndexOf(d),v=this._lines[w.index].length;return new D.Position(w.index,Math.min(w.remainder,v))}_validateRange(d){if(!(d instanceof D.Range))throw new Error("Invalid argument");const w=this._validatePosition(d.start),v=this._validatePosition(d.end);return w===d.start&&v===d.end?d:new D.Range(w.line,w.character,v.line,v.character)}_validatePosition(d){if(!(d instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:w,character:v}=d,E=!1;if(w<0)w=0,v=0,E=!0;else if(w>=this._lines.length)w=this._lines.length-1,v=this._lines[w].length,E=!0;else{const u=this._lines[w].length;v<0?(v=0,E=!0):v>u&&(v=u,E=!0)}return E?new D.Position(w,v):d}_getWordRangeAtPosition(d,w){const v=this._validatePosition(d);if(!w)w=I(this._languageId);else if(S.regExpLeadsToEndlessLoop(w))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${w.source}' because it matches the empty string.`);const E=k.getWordAtText(v.character+1,k.ensureValidWordDefinition(w),this._lines[v.line],0);if(E)return new D.Range(v.line,E.startColumn-1,v.line,E.endColumn-1)}}e.ExtHostDocumentData=o;class f{constructor(d,w,v){this._line=d,this._text=w,this._isLastLine=v}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(we[156],_e([0,1,6,3,86,7,55,22,2,34]),function(ee,e,m,T,S,y,k,D,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(o,f,c,d){this._notebook=c,this._selector=d,this._disposables=new y.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.uri=b.URI.from({scheme:"vscode-concat-doc",path:C.generateUuid()}),this._init(),this._disposables.add(f.onDidChangeDocument(v=>{const E=this._cellUris.get(v.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const w=v=>{v===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(o.onDidChangeNotebookCells(v=>w(v.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new D.ResourceMap;const o=[],f=[];for(const c of this._notebook.getCells())c.kind===m.NotebookCellKind.Code&&(!this._selector||k.score(this._selector,c.document.uri,c.document.languageId,!0))&&(this._cellUris.set(c.document.uri,this._cells.length),this._cells.push(c),o.push(c.document.getText().length+1),f.push(c.document.lineCount));this._cellLengths=new S.PrefixSumComputer(new Uint32Array(o)),this._cellLines=new S.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(o){var f,c;if(!o){let u="";for(const h of this._cells)u+=h.document.getText()+`
`;return u=u.slice(0,-1),u}if(o.isEmpty)return"";const d=this.locationAt(o.start),w=this.locationAt(o.end),v=this._cells[(f=this._cellUris.get(d.uri))!==null&&f!==void 0?f:-1],E=this._cells[(c=this._cellUris.get(w.uri))!==null&&c!==void 0?c:-1];if(!v||!E)return"";if(v===E)return v.document.getText(new m.Range(d.range.start,w.range.end));{const u=v.document.getText(new m.Range(d.range.start,new m.Position(v.document.lineCount,0))),h=E.document.getText(new m.Range(new m.Position(0,0),w.range.end));return u+`
`+h}}offsetAt(o){const f=this._cellLines.getIndexOf(o.line),c=this._cellLengths.getPrefixSum(f.index-1),d=this._cells[f.index].document.offsetAt(o.with(f.remainder));return c+d}positionAt(o){if(typeof o=="number"){const c=this._cellLengths.getIndexOf(o),d=this._cellLines.getPrefixSum(c.index-1);return this._cells[c.index].document.positionAt(c.remainder).translate(d)}const f=this._cellUris.get(o.uri);if(f!==void 0){const c=this._cellLines.getPrefixSum(f-1);return new m.Position(c+o.range.start.line,o.range.start.character)}return new m.Position(0,0)}locationAt(o){m.Range.isRange(o)||(o=new m.Range(o,o));const f=this._cellLines.getIndexOf(o.start.line);let c=f;o.isEmpty||(c=this._cellLines.getIndexOf(o.end.line));const d=new m.Position(f.remainder,o.start.character),w=new m.Position(c.remainder,o.end.character),v=new m.Range(d,w),E=this._cells[f.index];return new m.Location(E.document.uri,E.document.validateRange(v))}contains(o){return this._cellUris.has(o)}validateRange(o){const f=this.validatePosition(o.start),c=this.validatePosition(o.end);return o.with(f,c)}validatePosition(o){const f=this._cellLines.getIndexOf(o.line),c=new m.Position(f.remainder,o.character),d=this._cells[f.index].document.validatePosition(c),w=this._cellLines.getPrefixSum(f.index-1);return new m.Position(w+d.line,d.character)}}e.ExtHostNotebookConcatDocument=n}),define(we[157],_e([0,1,6,14,3]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let y=class{constructor(D){this._actual=new m.ColorTheme(m.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new S.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let b=D==="light"?m.ColorThemeKind.Light:D==="dark"?m.ColorThemeKind.Dark:m.ColorThemeKind.HighContrast;this._actual=new m.ColorTheme(b),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};y=He([ze(0,T.IExtHostRpcService)],y),e.ExtHostTheming=y}),define(we[65],_e([0,1,5]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=m.createDecorator("IURITransformerService");class T{constructor(y){y?(this.transformIncoming=y.transformIncoming.bind(y),this.transformOutgoing=y.transformOutgoing.bind(y),this.transformOutgoingURI=y.transformOutgoingURI.bind(y),this.transformOutgoingScheme=y.transformOutgoingScheme.bind(y)):(this.transformIncoming=k=>k,this.transformOutgoing=k=>k,this.transformOutgoingURI=k=>k,this.transformOutgoingScheme=k=>k)}}e.URITransformerService=T}),define(we[158],_e([0,1,23]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class T{constructor(){this.buffers=[]}add(b){let C=this.buffers.indexOf(b);return C<0&&(C=this.buffers.length,this.buffers.push(b)),C}}function S(D,b){if(b.serializeBuffersForPostMessage){const C=new T,n=(f,c)=>{if(c instanceof ArrayBuffer){const d=C.add(c);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(c)){const d=y(c);if(d){const w=C.add(c.buffer);return{$$vscode_array_buffer_reference$$:!0,index:w,view:{type:d,byteLength:c.byteLength,byteOffset:c.byteOffset}}}}return c},I=JSON.stringify(D,n),o=C.buffers.map(f=>{const c=new Uint8Array(f);return m.VSBuffer.wrap(c)});return{message:I,buffers:o}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=S;function y(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function k(D,b){const C=b.map(o=>{const f=new ArrayBuffer(o.byteLength);return new Uint8Array(f).set(o.buffer),f}),n=b.length?(o,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const c=f,{index:d}=c,w=C[d];if(c.view)switch(c.view.type){case 1:return new Int8Array(w,c.view.byteOffset,c.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(w,c.view.byteOffset,c.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(w,c.view.byteOffset,c.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(w,c.view.byteOffset,c.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(w,c.view.byteOffset,c.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(w,c.view.byteOffset,c.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(w,c.view.byteOffset,c.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(w,c.view.byteOffset,c.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(w,c.view.byteOffset,c.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(w,c.view.byteOffset,c.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(w,c.view.byteOffset,c.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return w}return f}:void 0;return{message:JSON.parse(D,n),arrayBuffers:C}}e.deserializeWebviewMessage=k}),define(we[66],_e([0,1,12,2]),function(ee,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function S(y,k){return y.scheme===m.Schemas.http||y.scheme===m.Schemas.https?y:(k&&k.authority&&k.isRemote&&y.scheme===m.Schemas.file&&(y=T.URI.from({scheme:m.Schemas.vscodeRemote,authority:k.authority,path:y.path})),T.URI.from({scheme:m.Schemas.https,authority:`${y.scheme}+${y.authority}.${e.webviewRootResourceAuthority}`,path:y.path,fragment:y.fragment,query:y.query}))}e.asWebviewUri=S}),define(we[159],_e([0,1,3,7,66]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(D,b,C){this._proxy=D,this._editors=b,this._initData=C,this._handlePool=0,this._disposables=new T.DisposableStore,this._insets=new Map,this._disposables.add(b.onDidChangeVisibleTextEditors(()=>{const n=b.getVisibleTextEditors();for(const I of this._insets.values())n.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,b,C,n,I){let o;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===D){o=u;break}if(!o)throw new Error("not a visible editor");const f=this,c=this._handlePool++,d=new m.Emitter,w=new m.Emitter,v=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(u){return S.asWebviewUri(u,f._initData.remote)}get cspSource(){return S.webviewGenericCspSource}set options(u){this._options=u,f._proxy.$setOptions(c,u)}get options(){return this._options}set html(u){this._html=u,f._proxy.$setHtml(c,u)}get html(){return this._html}get onDidReceiveMessage(){return d.event}postMessage(u){return f._proxy.$postMessage(c,u)}},E=new class{constructor(){this.editor=D,this.line=b,this.height=C,this.webview=v,this.onDidDispose=w.event}dispose(){f._insets.has(c)&&(f._insets.delete(c),f._proxy.$disposeEditorInset(c),w.fire(),w.dispose(),d.dispose())}};return this._proxy.$createEditorInset(c,o.id,o.value.document.uri,b+1,C,n||{},I.identifier,I.extensionLocation),this._insets.set(c,{editor:D,inset:E,onDidReceiveMessage:d}),E}$onDidDispose(D){const b=this._insets.get(D);b&&b.inset.dispose()}$onDidReceiveMessage(D,b){const C=this._insets.get(D);C&&C.onDidReceiveMessage.fire(b)}}e.ExtHostEditorInsets=y}),define(we[160],_e([0,1,3,13,135]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class y{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new m.Emitter,this._onExit=new m.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,b,C,n){const I={command:D};if(b&&Object.keys(b).length>0&&(I.arguments=b),this.internalSend("request",I),typeof n=="number"){const o=setTimeout(()=>{clearTimeout(o);const f=this.pendingRequests.get(I.seq);if(f){this.pendingRequests.delete(I.seq);const c={type:"response",seq:0,request_seq:I.seq,success:!1,command:D,message:S.localize(0,null,n,D)};f(c)}},n)}return C&&this.pendingRequests.set(I.seq,C),I.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,b){return D.type!=="event"||b.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await T.timeout(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":const b=D,C=this.pendingRequests.get(b.request_seq);C&&(this.pendingRequests.delete(b.request_seq),C(b));break}}}internalSend(D,b){b.type=D,b.seq=this.sequence++,this.sendMessage(b)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((b,C)=>D.set(C,b)),await T.timeout(500),D.forEach((b,C)=>{b({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=y}),define(we[161],_e([0,1,8,2,15,24,12]),function(ee,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function b(i,s,r){return i.replace(D,function(l,_){return s&&_.length>0&&_[0]!=="_"?l:r&&r.hasOwnProperty(_)?r[_]:l})}e.formatPII=b;function C(i){const s={};for(const r of Object.keys(i))r.startsWith("!")||(s[r]=i[r]);return s}e.filterExceptionsFromTelemetry=C;function n(i){return i.configuration.request==="attach"&&!I(i)&&(!i.parentSession||n(i.parentSession))}e.isSessionAttach=n;function I(i){let s=i.configuration.type;if(!!s)return s==="vslsShare"&&(s=i.configuration.adapterProxy.configuration.type),m.equalsIgnoreCase(s,"extensionhost")||m.equalsIgnoreCase(s,"pwa-extensionhost")?i:i.parentSession?I(i.parentSession):void 0}e.getExtensionHostDebugSession=I;function o(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=o;function f(i,s,r){let l,_=0,p=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,P=null;for(;P=p.exec(i);){let A=P.index+1,a=A+P[0].length;if(A<=s&&a>=r){l=P[0],_=A;break}}if(l){let A=/\w+/g,a=null;for(;(a=A.exec(l))&&!(a.index+1+_+a[0].length>=r););a&&(l=l.substring(0,A.lastIndex))}return l?{start:_,end:_+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(i){return!!(i&&i.match(c))}e.isUri=d;function w(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(d(i.path))return T.URI.parse(i.path);if(S.isAbsolute(i.path))return T.URI.file(i.path)}return i.path}function v(i){if(typeof i.path=="object"){const s=T.URI.revive(i.path);if(s)return s.scheme===k.Schemas.file?s.fsPath:s.toString()}return i.path}function E(i,s){const r=s?w:v,l=y.deepClone(i);return h(l,(_,p)=>{_&&p&&(p.path=r(p))}),l}e.convertToDAPaths=E;function u(i,s){const r=s?w:v,l=y.deepClone(i);return h(l,(_,p)=>{!_&&p&&(p.path=r(p))}),l}e.convertToVSCPaths=u;function h(i,s){switch(i.type){case"event":const r=i;switch(r.event){case"output":s(!1,r.body.source);break;case"loadedSource":s(!1,r.body.source);break;case"breakpoint":s(!1,r.body.breakpoint.source);break;default:break}break;case"request":const l=i;switch(l.command){case"setBreakpoints":s(!0,l.arguments.source);break;case"breakpointLocations":s(!0,l.arguments.source);break;case"source":s(!0,l.arguments.source);break;case"gotoTargets":s(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(p=>s(!1,p));break;default:break}break;case"response":const _=i;if(_.success&&_.body)switch(_.command){case"stackTrace":_.body.stackFrames.forEach(p=>s(!1,p.source));break;case"loadedSources":_.body.sources.forEach(p=>s(!1,p));break;case"scopes":_.body.scopes.forEach(p=>s(!1,p.source));break;case"setFunctionBreakpoints":_.body.breakpoints.forEach(p=>s(!1,p.source));break;case"setBreakpoints":_.body.breakpoints.forEach(p=>s(!1,p.source));break;default:break}break}}function g(i){return i.filter(s=>{var r;return!((r=s.presentation)===null||r===void 0?void 0:r.hidden)}).sort((s,r)=>s.presentation?r.presentation?s.presentation.group?r.presentation.group?s.presentation.group!==r.presentation.group?s.presentation.group.localeCompare(r.presentation.group):t(s.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(s.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=g;function t(i,s){return typeof i!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:i-s}}),define(we[67],_e([0,1,27,81,12,15,21,88]),function(ee,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var b;(function(a){a[a.Markup=1]="Markup",a[a.Code=2]="Code"})(b=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",T.Mimes.markdown,"image/png","image/jpeg",T.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[T.Mimes.markdown,"application/json",T.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var C;(function(a){a[a.Running=1]="Running",a[a.Idle=2]="Idle"})(C=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(a){a[a.Pending=2]="Pending",a[a.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(a){a[a.WithHardKernelDependency=0]="WithHardKernelDependency",a[a.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",a[a.Pure=2]="Pure",a[a.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var o;(function(a){a.Always="always",a.Never="never",a.Optional="optional"})(o=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(a){a[a.ModelChange=1]="ModelChange",a[a.Move=2]="Move",a[a.ChangeLanguage=5]="ChangeLanguage",a[a.Initialize=6]="Initialize",a[a.ChangeCellMetadata=7]="ChangeCellMetadata",a[a.Output=8]="Output",a[a.OutputItem=9]="OutputItem",a[a.ChangeCellContent=10]="ChangeCellContent",a[a.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",a[a.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",a[a.ChangeCellMime=13]="ChangeCellMime",a[a.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(a){a[a.Handle=0]="Handle",a[a.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(a){a[a.Replace=1]="Replace",a[a.Output=2]="Output",a[a.Metadata=3]="Metadata",a[a.CellLanguage=4]="CellLanguage",a[a.DocumentMetadata=5]="DocumentMetadata",a[a.Move=6]="Move",a[a.OutputItems=7]="OutputItems",a[a.PartialMetadata=8]="PartialMetadata",a[a.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var w;(function(a){a.scheme=S.Schemas.vscodeNotebookCell;const R=/^ch(\d{7,})/;function F(W,Q){return W.with({scheme:a.scheme,fragment:`ch${Q.toString().padStart(7,"0")}${W.scheme!==S.Schemas.file?W.scheme:""}`})}a.generate=F;function x(W){if(W.scheme!==a.scheme)return;const Q=R.exec(W.fragment);return Q?{handle:Number(Q[1]),notebook:W.with({scheme:W.fragment.substr(Q[0].length)||S.Schemas.file,fragment:null})}:void 0}a.parse=x;function J(W){if(W.scheme!==S.Schemas.vscodeNotebookCellMetadata)return;const Q=R.exec(W.fragment);return Q?{handle:Number(Q[1]),notebook:W.with({scheme:W.fragment.substr(Q[0].length)||S.Schemas.file,fragment:null})}:void 0}a.parseCellMetadataUri=J;function ae(W,Q,M){return W.with({scheme:M,fragment:`ch${Q.toString().padStart(7,"0")}${W.scheme!==S.Schemas.file?W.scheme:""}`})}a.generateCellUri=ae;function j(W,Q){if(W.scheme!==Q)return;const M=R.exec(W.fragment);return M?{handle:Number(M[1]),notebook:W.with({scheme:W.fragment.substr(M[0].length)||S.Schemas.file,fragment:null})}:void 0}a.parseCellUri=j})(w=e.CellUri||(e.CellUri={}));const v=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[T.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[T.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function E(a){var R,F;return(F=(R=v.get(a))===null||R===void 0?void 0:R.alwaysSecure)!==null&&F!==void 0?F:!1}e.mimeTypeIsAlwaysSecure=E;function u(a){var R,F;return(F=(R=v.get(a))===null||R===void 0?void 0:R.supportedByCore)!==null&&F!==void 0?F:!1}e.mimeTypeSupportedByCore=u;function h(a){var R,F;return(F=(R=v.get(a))===null||R===void 0?void 0:R.mergeable)!==null&&F!==void 0?F:!1}e.mimeTypeIsMergeable=h;function g(a,R){return k.isWindows&&(a=a.replace(/\//g,"\\"),R=R.replace(/\//g,"\\")),m.match(a,R)}function t(a,R,F){let x=0;for(let J=0;J<R.length;J++){if(g(R[J],a))return x;x++}for(let J=0;J<F.length;J++){if(g(F[J],a))return x;x++}return x}function i(a,R,F){return a.sort((x,J)=>t(x,R,F)-t(J,R,F))}e.sortMimeTypes=i;function s(a,R,F,x=(J,ae)=>J===ae){const J=[];function ae(Q,M,X){if(M===0&&X.length===0)return;const B=J[J.length-1];B&&B.start+B.deleteCount===Q?(B.deleteCount+=M,B.toInsert.push(...X)):J.push({start:Q,deleteCount:M,toInsert:X})}let j=0,W=0;for(;;){if(j===a.length){ae(j,0,R.slice(W));break}if(W===R.length){ae(j,a.length-j,[]);break}const Q=a[j],M=R[W];if(x(Q,M)){j+=1,W+=1;continue}F(M)?(ae(j,1,[]),j+=1):(ae(j,0,[M]),W+=1)}return J}e.diff=s,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(a){a.default="default",a.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function l(a){const R=a;return!!((typeof R.include=="string"||m.isRelativePattern(R.include))&&(typeof R.exclude=="string"||m.isRelativePattern(R.exclude)))}e.isDocumentExcludePattern=l;function _(a,R,F){if(Array.isArray(a.viewType)&&a.viewType.indexOf(R)>=0||a.viewType===R)return!0;if(a.filenamePattern){let x=l(a.filenamePattern)?a.filenamePattern.include:a.filenamePattern,J=l(a.filenamePattern)?a.filenamePattern.exclude:void 0;if(m.match(x,y.basename(F.fsPath).toLowerCase()))return!(J&&m.match(J,y.basename(F.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=_;class p{constructor(R){this.textModel=R}getElements(){const R=new Int32Array(this.textModel.cells.length);for(let F=0;F<this.textModel.cells.length;F++)R[F]=this.textModel.cells[F].getHashValue();return R}}e.CellSequence=p,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var P;(function(a){a[a.Left=1]="Left",a[a.Right=2]="Right"})(P=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class A{static create(R){return`${A._prefix}${R}`}static parse(R){if(R.startsWith(A._prefix))return R.substr(A._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=A,A._prefix="notebook/"}),define(we[162],_e([0,1,137,5,88]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new S.RawContextKey("customExecutionSupported",!0,m.localize(0,null)),e.ShellExecutionSupportedContext=new S.RawContextKey("shellExecutionSupported",!1,m.localize(1,null)),e.ProcessExecutionSupportedContext=new S.RawContextKey("processExecutionSupported",!1,m.localize(2,null)),e.ITaskService=T.createDecorator("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[163],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function m(S){return[...S.entries()]}e.serializeEnvironmentVariableCollection=m;function T(S){return new Map(S)}e.deserializeEnvironmentVariableCollection=T}),define(we[96],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=e.identifyTest=void 0;const m=b=>({testId:b.item.extId,controllerId:b.controllerId});e.identifyTest=m;var T;(function(b){b[b.NotExpandable=0]="NotExpandable",b[b.Expandable=1]="Expandable",b[b.BusyExpanding=2]="BusyExpanding",b[b.Expanded=3]="Expanded"})(T=e.TestItemExpandState||(e.TestItemExpandState={}));const S=(b,C)=>{C.expand!==void 0&&(b.expand=C.expand),C.item!==void 0&&(b.item=b.item?Object.assign(b.item,C.item):C.item)};e.applyTestItemUpdate=S;var y;(function(b){b[b.Add=0]="Add",b[b.Update=1]="Update",b[b.Remove=2]="Remove",b[b.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",b[b.Retire=4]="Retire"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class k{add(C){}update(C){}remove(C,n){}complete(){}}e.IncrementalChangeCollector=k;class D{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(C){const n=this.createChangeCollector();for(const I of C)switch(I[0]){case 0:{const o=I[1];if(o.parent){if(this.items.has(o.parent)){const f=this.items.get(o.parent);f.children.add(o.item.extId);const c=this.createItem(o,f);this.items.set(o.item.extId,c),n.add(c)}}else{const f=this.createItem(o);this.roots.add(f),this.items.set(o.item.extId,f),n.add(f)}o.expand===2&&this.busyControllerCount++;break}case 1:{const o=I[1],f=this.items.get(o.extId);if(!f)break;o.expand!==void 0&&(f.expand===2&&this.busyControllerCount--,o.expand===2&&this.busyControllerCount++),e.applyTestItemUpdate(f,o),n.update(f);break}case 2:{const o=this.items.get(I[1]);if(!o)break;o.parent?this.items.get(o.parent).children.delete(o.item.extId):this.roots.delete(o);const f=[[I[1]]];for(;f.length;)for(const c of f.pop()){const d=this.items.get(c);d&&(f.push(d.children),this.items.delete(c),n.remove(d,d!==o),d.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(I[1]);break;case 3:this.updatePendingRoots(I[1]);break}n.complete()}retireTest(C){}updatePendingRoots(C){this.pendingRootCount+=C}createChangeCollector(){return new k}}e.AbstractIncrementalTestCollection=D}),define(we[164],_e([0,1,15,40,10,24,21,80,138]),function(ee,e,m,T,S,y,k,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{constructor(I,o,f){this._contributedVariables=new Map,this._context=I,this._labelService=o,f&&(this._envVariablesPromise=f.then(c=>this.prepareEnv(c)))}prepareEnv(I){if(k.isWindows){const o=Object.create(null);return Object.keys(I).forEach(f=>{o[f.toLowerCase()]=I[f]}),o}return I}resolveWithEnvironment(I,o,f){return this.recursiveResolve(this.prepareEnv(I),o?o.uri:void 0,f)}async resolveAsync(I,o){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,o)}async resolveAnyBase(I,o,f,c){const d=y.deepClone(o);return k.isWindows&&d.windows?Object.keys(d.windows).forEach(w=>d[w]=d.windows[w]):k.isMacintosh&&d.osx?Object.keys(d.osx).forEach(w=>d[w]=d.osx[w]):k.isLinux&&d.linux&&Object.keys(d.linux).forEach(w=>d[w]=d.linux[w]),delete d.windows,delete d.osx,delete d.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,d,f,c)}async resolveAnyAsync(I,o,f){return this.resolveAnyBase(I,o,f)}async resolveAnyMap(I,o,f){const c=new Map;return{newConfig:await this.resolveAnyBase(I,o,f,c),resolvedVariables:c}}resolveWithInteractionReplace(I,o,f,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,o,f,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,o){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,o)}recursiveResolve(I,o,f,c,d){if(S.isString(f))return this.resolveString(I,o,f,c,d);if(S.isArray(f))return f.map(w=>this.recursiveResolve(I,o,w,c,d));if(S.isObject(f)){let w=Object.create(null);return Object.keys(f).forEach(v=>{const E=this.resolveString(I,o,v,c,d);w[E]=this.recursiveResolve(I,o,f[v],c,d)}),w}return f}resolveString(I,o,f,c,d){return f.replace(C.VARIABLE_REGEXP,(v,E)=>{if(E.includes(C.VARIABLE_LHS))return v;let u=this.evaluateSingleVariable(I,v,E,o,c);return d&&d.set(E,u),u!==v&&S.isString(u)&&u.match(C.VARIABLE_REGEXP)&&(u=this.resolveString(I,o,u,c,d)),u})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,o,f,c,d){let w;const v=f.split(":");v.length>1&&(f=v[0],w=v[1]);const E=()=>{const g=this._context.getFilePath();if(g)return g;throw new Error(b.localize(0,null,o))},u=()=>{const g=E();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error(b.localize(1,null,o,m.basename(g)))},h=()=>{if(w){const g=this._context.getFolderUri(w);if(g)return g;throw new Error(b.localize(2,null,o,w))}if(c)return c;throw this._context.getWorkspaceFolderCount()>1?new Error(b.localize(3,null,o)):new Error(b.localize(4,null,o))};switch(f){case"env":if(w){if(I){const g=I[k.isWindows?w.toLowerCase():w];if(S.isString(g))return g}return""}throw new Error(b.localize(5,null,o));case"config":if(w){const g=this._context.getConfigurationValue(c,w);if(S.isUndefinedOrNull(g))throw new Error(b.localize(6,null,o,w));if(S.isObject(g))throw new Error(b.localize(7,null,o,w));return g}throw new Error(b.localize(8,null,o));case"command":return this.resolveFromMap(o,w,d,"command");case"input":return this.resolveFromMap(o,w,d,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return D.normalizeDriveLetter(this.fsPath(h()));case"cwd":return c||w?D.normalizeDriveLetter(this.fsPath(h())):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return m.basename(this.fsPath(h()));case"lineNumber":const g=this._context.getLineNumber();if(g)return g;throw new Error(b.localize(9,null,o));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error(b.localize(10,null,o));case"file":return E();case"fileWorkspaceFolder":return u();case"relativeFile":return c||w?m.relative(this.fsPath(h()),E()):E();case"relativeFileDirname":const i=m.dirname(E());if(c||w){const _=m.relative(this.fsPath(h()),i);return _.length===0?".":_}return i;case"fileDirname":return m.dirname(E());case"fileExtname":return m.extname(E());case"fileBasename":return m.basename(E());case"fileBasenameNoExtension":const s=m.basename(E());return s.slice(0,s.length-m.extname(s).length);case"fileDirnameBasename":return m.basename(m.dirname(E()));case"execPath":const r=this._context.getExecPath();return r||o;case"execInstallFolder":const l=this._context.getAppRoot();return l||o;case"pathSeparator":return m.sep;default:try{const _=w?`${f}:${w}`:f;return this.resolveFromMap(o,_,d,void 0)}catch(_){return o}}}}resolveFromMap(I,o,f,c){if(o&&f){const d=c===void 0?f[o]:f[c+":"+o];if(typeof d=="string")return d;throw new Error(b.localize(11,null,I))}return I}}e.AbstractVariableResolverService=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[165],_e([0,1,5]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=m.createDecorator("editorGroupsService");var T;(function(o){o[o.UP=0]="UP",o[o.DOWN=1]="DOWN",o[o.LEFT=2]="LEFT",o[o.RIGHT=3]="RIGHT"})(T=e.GroupDirection||(e.GroupDirection={}));var S;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(S=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(o){o[o.FIRST=0]="FIRST",o[o.LAST=1]="LAST",o[o.NEXT=2]="NEXT",o[o.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var k;(function(o){o[o.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",o[o.EVEN=1]="EVEN",o[o.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(o){o[o.COPY_EDITORS=0]="COPY_EDITORS",o[o.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));var b;(function(o){o[o.CREATION_TIME=0]="CREATION_TIME",o[o.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",o[o.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(b=e.GroupsOrder||(e.GroupsOrder={}));var C;(function(o){o[o.GROUP_ACTIVE=0]="GROUP_ACTIVE",o[o.GROUP_INDEX=1]="GROUP_INDEX",o[o.EDITOR_OPEN=2]="EDITOR_OPEN",o[o.EDITOR_CLOSE=3]="EDITOR_CLOSE",o[o.EDITOR_MOVE=4]="EDITOR_MOVE",o[o.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",o[o.EDITOR_LABEL=6]="EDITOR_LABEL",o[o.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",o[o.EDITOR_PIN=8]="EDITOR_PIN",o[o.EDITOR_STICKY=9]="EDITOR_STICKY",o[o.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(C=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(o){o[o.NEW_EDITOR=1]="NEW_EDITOR",o[o.MOVE_EDITOR=2]="MOVE_EDITOR",o[o.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function I(o){return o.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(we[166],_e([0,1,5]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=m.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(we[9],_e([0,1,17,79,222,54,24,10,2,30,58,139,89,67,166,6]),function(ee,e,m,T,S,y,k,D,b,C,n,I,o,f,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var w;(function(ve){function ye(z){const{selectionStartLineNumber:Oe,selectionStartColumn:Ee,positionLineNumber:We,positionColumn:Xe}=z,et=new d.Position(Oe-1,Ee-1),st=new d.Position(We-1,Xe-1);return new d.Selection(et,st)}ve.to=ye;function ue(z){const{anchor:Oe,active:Ee}=z;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:Ee.line+1,positionColumn:Ee.character+1}}ve.from=ue})(w=e.Selection||(e.Selection={}));var v;(function(ve){function ye(z){if(!z)return;const{start:Oe,end:Ee}=z;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:Ee.line+1,endColumn:Ee.character+1}}ve.from=ye;function ue(z){if(!z)return;const{startLineNumber:Oe,startColumn:Ee,endLineNumber:We,endColumn:Xe}=z;return new d.Range(Oe-1,Ee-1,We-1,Xe-1)}ve.to=ue})(v=e.Range||(e.Range={}));var E;(function(ve){function ye(ue){switch(ue){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 4:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}ve.to=ye})(E=e.TokenType||(e.TokenType={}));var u;(function(ve){function ye(z){return new d.Position(z.lineNumber-1,z.column-1)}ve.to=ye;function ue(z){return{lineNumber:z.line+1,column:z.character+1}}ve.from=ue})(u=e.Position||(e.Position={}));var h;(function(ve){function ye(z){switch(z){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}ve.from=ye;function ue(z){switch(z){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}ve.to=ue})(h=e.DiagnosticTag||(e.DiagnosticTag={}));var g;(function(ve){function ye(z){let Oe;return z.code&&(D.isString(z.code)||D.isNumber(z.code)?Oe=String(z.code):Oe={value:String(z.code.value),target:z.code.target}),Object.assign(Object.assign({},v.from(z.range)),{message:z.message,source:z.source,code:Oe,severity:i.from(z.severity),relatedInformation:z.relatedInformation&&z.relatedInformation.map(t.from),tags:Array.isArray(z.tags)?m.coalesce(z.tags.map(h.from)):void 0})}ve.from=ye;function ue(z){var Oe;const Ee=new d.Diagnostic(v.to(z),z.message,i.to(z.severity));return Ee.source=z.source,Ee.code=D.isString(z.code)?z.code:(Oe=z.code)===null||Oe===void 0?void 0:Oe.value,Ee.relatedInformation=z.relatedInformation&&z.relatedInformation.map(t.to),Ee.tags=z.tags&&m.coalesce(z.tags.map(h.to)),Ee}ve.to=ue})(g=e.Diagnostic||(e.Diagnostic={}));var t;(function(ve){function ye(z){return Object.assign(Object.assign({},v.from(z.location.range)),{message:z.message,resource:z.location.uri})}ve.from=ye;function ue(z){return new d.DiagnosticRelatedInformation(new d.Location(z.resource,v.to(z)),z.message)}ve.to=ue})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(ve){function ye(z){switch(z){case d.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}ve.from=ye;function ue(z){switch(z){case o.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}ve.to=ue})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(ve){function ye(z){return typeof z=="number"&&z>=d.ViewColumn.One?z-1:z===d.ViewColumn.Beside?c.SIDE_GROUP:c.ACTIVE_GROUP}ve.from=ye;function ue(z){if(typeof z=="number"&&z>=0)return z+1;throw new Error("invalid 'EditorGroupColumn'")}ve.to=ue})(s=e.ViewColumn||(e.ViewColumn={}));function r(ve){return typeof ve.range!="undefined"}function l(ve){return ve.length===0?!0:!!r(ve[0])}e.isDecorationOptionsArr=l;var _;(function(ve){function ye(Xe){return Xe.map(ve.from)}ve.fromMany=ye;function ue(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function z(Xe){let et;if(ue(Xe)){const{language:_t,value:vt}=Xe;et={value:"```"+_t+`
`+vt+"\n```\n"}}else d.MarkdownString.isMarkdownString(Xe)?et={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons}:typeof Xe=="string"?et={value:Xe}:et={value:""};const st=Object.create(null);et.uris=st;const pt=_t=>{try{let vt=b.URI.parse(_t,!0);vt=vt.with({query:Oe(vt.query,st)}),st[_t]=vt}catch(vt){}return""},bt=new S.Renderer;return bt.link=pt,bt.image=_t=>pt(T.parseHrefAndDimensions(_t).href),S(et.value,{renderer:bt}),et}ve.from=z;function Oe(Xe,et){if(!Xe)return Xe;let st;try{st=y.parse(Xe)}catch(bt){}if(!st)return Xe;let pt=!1;return st=k.cloneAndChange(st,bt=>{if(b.URI.isUri(bt)){const _t=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[_t]=bt,pt=!0,_t}else return}),pt?JSON.stringify(st):Xe}function Ee(Xe){const et=new d.MarkdownString(Xe.value,Xe.supportThemeIcons);return et.isTrusted=Xe.isTrusted,et}ve.to=Ee;function We(Xe){if(!!Xe)return typeof Xe=="string"?Xe:ve.from(Xe)}ve.fromStrict=We})(_=e.MarkdownString||(e.MarkdownString={}));function p(ve){return l(ve)?ve.map(ye=>({range:v.from(ye.range),hoverMessage:Array.isArray(ye.hoverMessage)?_.fromMany(ye.hoverMessage):ye.hoverMessage?_.from(ye.hoverMessage):void 0,renderOptions:ye.renderOptions})):ve.map(ye=>({range:v.from(ye)}))}e.fromRangeOrRangeWithMessage=p;function P(ve){return typeof ve=="undefined"?ve:typeof ve=="string"?b.URI.file(ve):ve}e.pathOrURIToURI=P;var A;(function(ve){function ye(ue){return typeof ue=="undefined"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?P(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}ve.from=ye})(A=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var a;(function(ve){function ye(ue){return typeof ue=="undefined"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?P(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?A.from(ue.before):void 0,after:ue.after?A.from(ue.after):void 0}}ve.from=ye})(a=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(ve){function ye(ue){if(typeof ue=="undefined")return ue;switch(ue){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}ve.from=ye})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var F;(function(ve){function ye(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?R.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?a.from(ue.light):void 0,dark:ue.dark?a.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?P(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?A.from(ue.before):void 0,after:ue.after?A.from(ue.after):void 0}}ve.from=ye})(F=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var x;(function(ve){function ye(z){return{text:z.newText,eol:z.newEol&&H.from(z.newEol),range:v.from(z.range)}}ve.from=ye;function ue(z){const Oe=new d.TextEdit(v.to(z.range),z.text);return Oe.newEol=typeof z.eol=="undefined"?void 0:H.to(z.eol),Oe}ve.to=ue})(x=e.TextEdit||(e.TextEdit={}));var J;(function(ve){function ye(z,Oe,Ee){var We,Xe;const et={edits:[]};if(z instanceof d.WorkspaceEdit)for(let st of z._allEntries())if(st._type===1)et.edits.push({_type:1,oldUri:st.from,newUri:st.to,options:st.options,metadata:st.metadata});else if(st._type===2){const pt=Oe==null?void 0:Oe.getDocument(st.uri);et.edits.push({_type:2,resource:st.uri,edit:x.from(st.edit),modelVersionId:pt==null?void 0:pt.version,metadata:st.metadata})}else st._type===3?et.edits.push({_type:3,metadata:st.metadata,resource:st.uri,edit:st.edit,notebookMetadata:st.notebookMetadata,notebookVersionId:(We=Ee==null?void 0:Ee.getNotebookDocument(st.uri,!0))===null||We===void 0?void 0:We.apiNotebook.version}):st._type===5&&et.edits.push({_type:3,metadata:st.metadata,resource:st.uri,notebookVersionId:(Xe=Ee==null?void 0:Ee.getNotebookDocument(st.uri,!0))===null||Xe===void 0?void 0:Xe.apiNotebook.version,edit:{editType:1,index:st.index,count:st.count,cells:st.cells.map(N.from)}});return et}ve.from=ye;function ue(z){const Oe=new d.WorkspaceEdit;for(const Ee of z.edits)Ee.edit?Oe.replace(b.URI.revive(Ee.resource),v.to(Ee.edit.range),Ee.edit.text):Oe.renameFile(b.URI.revive(Ee.oldUri),b.URI.revive(Ee.newUri),Ee.options);return Oe}ve.to=ue})(J=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ae;(function(ve){const ye=Object.create(null);ye[d.SymbolKind.File]=0,ye[d.SymbolKind.Module]=1,ye[d.SymbolKind.Namespace]=2,ye[d.SymbolKind.Package]=3,ye[d.SymbolKind.Class]=4,ye[d.SymbolKind.Method]=5,ye[d.SymbolKind.Property]=6,ye[d.SymbolKind.Field]=7,ye[d.SymbolKind.Constructor]=8,ye[d.SymbolKind.Enum]=9,ye[d.SymbolKind.Interface]=10,ye[d.SymbolKind.Function]=11,ye[d.SymbolKind.Variable]=12,ye[d.SymbolKind.Constant]=13,ye[d.SymbolKind.String]=14,ye[d.SymbolKind.Number]=15,ye[d.SymbolKind.Boolean]=16,ye[d.SymbolKind.Array]=17,ye[d.SymbolKind.Object]=18,ye[d.SymbolKind.Key]=19,ye[d.SymbolKind.Null]=20,ye[d.SymbolKind.EnumMember]=21,ye[d.SymbolKind.Struct]=22,ye[d.SymbolKind.Event]=23,ye[d.SymbolKind.Operator]=24,ye[d.SymbolKind.TypeParameter]=25;function ue(Oe){return typeof ye[Oe]=="number"?ye[Oe]:6}ve.from=ue;function z(Oe){for(const Ee in ye)if(ye[Ee]===Oe)return Number(Ee);return d.SymbolKind.Property}ve.to=z})(ae=e.SymbolKind||(e.SymbolKind={}));var j;(function(ve){function ye(z){switch(z){case d.SymbolTag.Deprecated:return 1}}ve.from=ye;function ue(z){switch(z){case 1:return d.SymbolTag.Deprecated}}ve.to=ue})(j=e.SymbolTag||(e.SymbolTag={}));var W;(function(ve){function ye(z){return{name:z.name,kind:ae.from(z.kind),tags:z.tags&&z.tags.map(j.from),containerName:z.containerName,location:U.from(z.location)}}ve.from=ye;function ue(z){const Oe=new d.SymbolInformation(z.name,ae.to(z.kind),z.containerName,U.to(z.location));return Oe.tags=z.tags&&z.tags.map(j.to),Oe}ve.to=ue})(W=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Q;(function(ve){function ye(z){var Oe,Ee;const We={name:z.name||"!!MISSING: name!!",detail:z.detail,range:v.from(z.range),selectionRange:v.from(z.selectionRange),kind:ae.from(z.kind),tags:(Ee=(Oe=z.tags)===null||Oe===void 0?void 0:Oe.map(j.from))!==null&&Ee!==void 0?Ee:[]};return z.children&&(We.children=z.children.map(ye)),We}ve.from=ye;function ue(z){const Oe=new d.DocumentSymbol(z.name,z.detail,ae.to(z.kind),v.to(z.range),v.to(z.selectionRange));return m.isNonEmptyArray(z.tags)&&(Oe.tags=z.tags.map(j.to)),z.children&&(Oe.children=z.children.map(ue)),Oe}ve.to=ue})(Q=e.DocumentSymbol||(e.DocumentSymbol={}));var M;(function(ve){function ye(ue){const z=new d.CallHierarchyItem(ae.to(ue.kind),ue.name,ue.detail||"",b.URI.revive(ue.uri),v.to(ue.range),v.to(ue.selectionRange));return z._sessionId=ue._sessionId,z._itemId=ue._itemId,z}ve.to=ye})(M=e.CallHierarchyItem||(e.CallHierarchyItem={}));var X;(function(ve){function ye(ue){return new d.CallHierarchyIncomingCall(M.to(ue.from),ue.fromRanges.map(z=>v.to(z)))}ve.to=ye})(X=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var B;(function(ve){function ye(ue){return new d.CallHierarchyOutgoingCall(M.to(ue.to),ue.fromRanges.map(z=>v.to(z)))}ve.to=ye})(B=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var U;(function(ve){function ye(z){return{range:z.range&&v.from(z.range),uri:z.uri}}ve.from=ye;function ue(z){return new d.Location(b.URI.revive(z.uri),v.to(z.range))}ve.to=ue})(U=e.location||(e.location={}));var Y;(function(ve){function ye(z){const Oe=z,Ee=z;return{originSelectionRange:Oe.originSelectionRange?v.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:Ee.uri,range:v.from(Oe.targetRange?Oe.targetRange:Ee.range),targetSelectionRange:Oe.targetSelectionRange?v.from(Oe.targetSelectionRange):void 0}}ve.from=ye;function ue(z){return{targetUri:b.URI.revive(z.uri),targetRange:v.to(z.range),targetSelectionRange:z.targetSelectionRange?v.to(z.targetSelectionRange):void 0,originSelectionRange:z.originSelectionRange?v.to(z.originSelectionRange):void 0}}ve.to=ue})(Y=e.DefinitionLink||(e.DefinitionLink={}));var V;(function(ve){function ye(z){return{range:v.from(z.range),contents:_.fromMany(z.contents)}}ve.from=ye;function ue(z){return new d.Hover(z.contents.map(_.to),v.to(z.range))}ve.to=ue})(V=e.Hover||(e.Hover={}));var ce;(function(ve){function ye(z){return{range:v.from(z.range),expression:z.expression}}ve.from=ye;function ue(z){return new d.EvaluatableExpression(v.to(z.range),z.expression)}ve.to=ue})(ce=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ge;(function(ve){function ye(z){if(z instanceof d.InlineValueText)return{type:"text",range:v.from(z.range),text:z.text};if(z instanceof d.InlineValueVariableLookup)return{type:"variable",range:v.from(z.range),variableName:z.variableName,caseSensitiveLookup:z.caseSensitiveLookup};if(z instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:v.from(z.range),expression:z.expression};throw new Error("Unknown 'InlineValue' type")}ve.from=ye;function ue(z){switch(z.type){case"text":return{range:v.to(z.range),text:z.text};case"variable":return{range:v.to(z.range),variableName:z.variableName,caseSensitiveLookup:z.caseSensitiveLookup};case"expression":return{range:v.to(z.range),expression:z.expression}}}ve.to=ue})(ge=e.InlineValue||(e.InlineValue={}));var Ae;(function(ve){function ye(z){return{frameId:z.frameId,stoppedLocation:v.from(z.stoppedLocation)}}ve.from=ye;function ue(z){return new d.InlineValueContext(z.frameId,v.to(z.stoppedLocation))}ve.to=ue})(Ae=e.InlineValueContext||(e.InlineValueContext={}));var $e;(function(ve){function ye(z){return{range:v.from(z.range),kind:z.kind}}ve.from=ye;function ue(z){return new d.DocumentHighlight(v.to(z.range),z.kind)}ve.to=ue})($e=e.DocumentHighlight||(e.DocumentHighlight={}));var Fe;(function(ve){function ye(ue){switch(ue){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}ve.to=ye})(Fe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ve;(function(ve){function ye(ue){return{triggerKind:Fe.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}ve.to=ye})(Ve=e.CompletionContext||(e.CompletionContext={}));var tt;(function(ve){function ye(z){switch(z){case d.CompletionItemTag.Deprecated:return 1}}ve.from=ye;function ue(z){switch(z){case 1:return d.CompletionItemTag.Deprecated}}ve.to=ue})(tt=e.CompletionItemTag||(e.CompletionItemTag={}));var Ke;(function(ve){const ye=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function ue(Ee){var We;return(We=ye.get(Ee))!==null&&We!==void 0?We:9}ve.from=ue;const z=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function Oe(Ee){var We;return(We=z.get(Ee))!==null&&We!==void 0?We:d.CompletionItemKind.Property}ve.to=Oe})(Ke=e.CompletionItemKind||(e.CompletionItemKind={}));var Qe;(function(ve){function ye(ue,z){var Oe;const Ee=new d.CompletionItem(ue.label);return Ee.insertText=ue.insertText,Ee.kind=Ke.to(ue.kind),Ee.tags=(Oe=ue.tags)===null||Oe===void 0?void 0:Oe.map(tt.to),Ee.detail=ue.detail,Ee.documentation=T.isMarkdownString(ue.documentation)?_.to(ue.documentation):ue.documentation,Ee.sortText=ue.sortText,Ee.filterText=ue.filterText,Ee.preselect=ue.preselect,Ee.commitCharacters=ue.commitCharacters,C.Range.isIRange(ue.range)?Ee.range=v.to(ue.range):typeof ue.range=="object"&&(Ee.range={inserting:v.to(ue.range.insert),replacing:v.to(ue.range.replace)}),Ee.keepWhitespace=typeof ue.insertTextRules=="undefined"?!1:Boolean(ue.insertTextRules&1),typeof ue.insertTextRules!="undefined"&&ue.insertTextRules&4?Ee.insertText=new d.SnippetString(ue.insertText):(Ee.insertText=ue.insertText,Ee.textEdit=Ee.range instanceof d.Range?new d.TextEdit(Ee.range,Ee.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(Ee.additionalTextEdits=ue.additionalTextEdits.map(We=>x.to(We))),Ee.command=z&&ue.command?z.fromInternal(ue.command):void 0,Ee}ve.to=ye})(Qe=e.CompletionItem||(e.CompletionItem={}));var $;(function(ve){function ye(z){return{label:z.label,documentation:z.documentation?_.fromStrict(z.documentation):void 0}}ve.from=ye;function ue(z){return{label:z.label,documentation:T.isMarkdownString(z.documentation)?_.to(z.documentation):z.documentation}}ve.to=ue})($=e.ParameterInformation||(e.ParameterInformation={}));var K;(function(ve){function ye(z){return{label:z.label,documentation:z.documentation?_.fromStrict(z.documentation):void 0,parameters:Array.isArray(z.parameters)?z.parameters.map($.from):[],activeParameter:z.activeParameter}}ve.from=ye;function ue(z){return{label:z.label,documentation:T.isMarkdownString(z.documentation)?_.to(z.documentation):z.documentation,parameters:Array.isArray(z.parameters)?z.parameters.map($.to):[],activeParameter:z.activeParameter}}ve.to=ue})(K=e.SignatureInformation||(e.SignatureInformation={}));var ie;(function(ve){function ye(z){return{activeSignature:z.activeSignature,activeParameter:z.activeParameter,signatures:Array.isArray(z.signatures)?z.signatures.map(K.from):[]}}ve.from=ye;function ue(z){return{activeSignature:z.activeSignature,activeParameter:z.activeParameter,signatures:Array.isArray(z.signatures)?z.signatures.map(K.to):[]}}ve.to=ue})(ie=e.SignatureHelp||(e.SignatureHelp={}));var se;(function(ve){function ye(z){var Oe;return{text:z.text,position:u.from(z.position),kind:q.from((Oe=z.kind)!==null&&Oe!==void 0?Oe:d.InlayHintKind.Other),whitespaceBefore:z.whitespaceBefore,whitespaceAfter:z.whitespaceAfter}}ve.from=ye;function ue(z){const Oe=new d.InlayHint(z.text,u.to(z.position),q.to(z.kind));return Oe.whitespaceAfter=z.whitespaceAfter,Oe.whitespaceBefore=z.whitespaceBefore,Oe}ve.to=ue})(se=e.InlayHint||(e.InlayHint={}));var q;(function(ve){function ye(z){return z}ve.from=ye;function ue(z){return z}ve.to=ue})(q=e.InlayHintKind||(e.InlayHintKind={}));var oe;(function(ve){function ye(z){return{range:v.from(z.range),url:z.target,tooltip:z.tooltip}}ve.from=ye;function ue(z){let Oe;if(z.url)try{Oe=typeof z.url=="string"?b.URI.parse(z.url,!0):b.URI.revive(z.url)}catch(Ee){}return new d.DocumentLink(v.to(z.range),Oe)}ve.to=ue})(oe=e.DocumentLink||(e.DocumentLink={}));var fe;(function(ve){function ye(z){const Oe=new d.ColorPresentation(z.label);return z.textEdit&&(Oe.textEdit=x.to(z.textEdit)),z.additionalTextEdits&&(Oe.additionalTextEdits=z.additionalTextEdits.map(Ee=>x.to(Ee))),Oe}ve.to=ye;function ue(z){return{label:z.label,textEdit:z.textEdit?x.from(z.textEdit):void 0,additionalTextEdits:z.additionalTextEdits?z.additionalTextEdits.map(Oe=>x.from(Oe)):void 0}}ve.from=ue})(fe=e.ColorPresentation||(e.ColorPresentation={}));var Re;(function(ve){function ye(z){return new d.Color(z[0],z[1],z[2],z[3])}ve.to=ye;function ue(z){return[z.red,z.green,z.blue,z.alpha]}ve.from=ue})(Re=e.Color||(e.Color={}));var xe;(function(ve){function ye(z){return{range:v.from(z.range)}}ve.from=ye;function ue(z){return new d.SelectionRange(v.to(z.range))}ve.to=ue})(xe=e.SelectionRange||(e.SelectionRange={}));var pe;(function(ve){function ye(ue){switch(ue){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}ve.to=ye})(pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var qe;(function(ve){function ye(z){switch(z){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}ve.from=ye;function ue(z){switch(z){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}ve.to=ue})(qe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var H;(function(ve){function ye(z){if(z===d.EndOfLine.CRLF)return 1;if(z===d.EndOfLine.LF)return 0}ve.from=ye;function ue(z){if(z===1)return d.EndOfLine.CRLF;if(z===0)return d.EndOfLine.LF}ve.to=ue})(H=e.EndOfLine||(e.EndOfLine={}));var te;(function(ve){function ye(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ve.from=ye})(te=e.ProgressLocation||(e.ProgressLocation={}));var me;(function(ve){function ye(ue){const z={start:ue.start+1,end:ue.end+1};return ue.kind&&(z.kind=Te.from(ue.kind)),z}ve.from=ye})(me=e.FoldingRange||(e.FoldingRange={}));var Te;(function(ve){function ye(ue){if(ue)switch(ue){case d.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}ve.from=ye})(Te=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Le;(function(ve){function ye(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?v.from(ue.selection):void 0,override:typeof ue.override=="boolean"?I.EditorOverride.DISABLED:void 0}}ve.from=ye})(Le=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ge;(function(ve){function ye(z){return z instanceof d.RelativePattern||typeof z=="string"?z:ue(z)?new d.RelativePattern(z.base,z.pattern):z}ve.from=ye;function ue(z){const Oe=z;return Oe&&typeof Oe.base=="string"&&typeof Oe.pattern=="string"}})(Ge=e.GlobPattern||(e.GlobPattern={}));var Se;(function(ve){function ye(ue){if(ue){if(Array.isArray(ue))return ue.map(ye);if(typeof ue=="string")return ue;{const z=ue;return{language:z.language,scheme:z.scheme,pattern:typeof z.pattern=="undefined"?void 0:Ge.from(z.pattern),exclusive:z.exclusive}}}else return}ve.from=ye})(Se=e.LanguageSelector||(e.LanguageSelector={}));var be;(function(ve){function ye(z){return{start:z.start,end:z.end}}ve.from=ye;function ue(z){return new d.NotebookRange(z.start,z.end)}ve.to=ue})(be=e.NotebookRange||(e.NotebookRange={}));var Ce;(function(ve){function ye(z){return{timing:typeof z.runStartTime=="number"&&typeof z.runEndTime=="number"?{startTime:z.runStartTime,endTime:z.runEndTime}:void 0,executionOrder:z.executionOrder,success:z.lastRunSuccess}}ve.to=ye;function ue(z){var Oe,Ee;return{lastRunSuccess:z.success,runStartTime:(Oe=z.timing)===null||Oe===void 0?void 0:Oe.startTime,runEndTime:(Ee=z.timing)===null||Ee===void 0?void 0:Ee.endTime,executionOrder:z.executionOrder}}ve.from=ue})(Ce=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var re;(function(ve){function ye(z){switch(z){case d.NotebookCellKind.Markup:return f.CellKind.Markup;case d.NotebookCellKind.Code:default:return f.CellKind.Code}}ve.from=ye;function ue(z){switch(z){case f.CellKind.Markup:return d.NotebookCellKind.Markup;case f.CellKind.Code:default:return d.NotebookCellKind.Code}}ve.to=ue})(re=e.NotebookCellKind||(e.NotebookCellKind={}));var de;(function(ve){function ye(z){var Oe;const Ee={metadata:(Oe=z.metadata)!==null&&Oe!==void 0?Oe:Object.create(null),cells:[]};for(let We of z.cells)d.NotebookCellData.validate(We),Ee.cells.push(N.from(We));return Ee}ve.from=ye;function ue(z){const Oe=new d.NotebookData(z.cells.map(N.to));return D.isEmptyObject(z.metadata)||(Oe.metadata=z.metadata),Oe}ve.to=ue})(de=e.NotebookData||(e.NotebookData={}));var N;(function(ve){function ye(z){var Oe;return{cellKind:re.from(z.kind),language:z.languageId,mime:z.mime,source:z.value,metadata:z.metadata,internalMetadata:Ce.from((Oe=z.executionSummary)!==null&&Oe!==void 0?Oe:{}),outputs:z.outputs?z.outputs.map(le.from):[]}}ve.from=ye;function ue(z){return new d.NotebookCellData(re.to(z.cellKind),z.source,z.language,z.mime,z.outputs?z.outputs.map(le.to):void 0,z.metadata,z.internalMetadata?Ce.to(z.internalMetadata):void 0)}ve.to=ue})(N=e.NotebookCellData||(e.NotebookCellData={}));var G;(function(ve){function ye(z){return{mime:z.mime,valueBytes:Array.from(z.data)}}ve.from=ye;function ue(z){return new d.NotebookCellOutputItem(new Uint8Array(z.valueBytes),z.mime)}ve.to=ue})(G=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var le;(function(ve){function ye(z){return{outputId:z.id,items:z.items.map(G.from),metadata:z.metadata}}ve.from=ye;function ue(z){const Oe=z.items.map(G.to);return new d.NotebookCellOutput(Oe,z.outputId,z.metadata)}ve.to=ue})(le=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ke;(function(ve){function ye(Ee){if(Ee!=null){if(Ee instanceof d.RelativePattern||typeof Ee=="string")return Ee;if(Oe(Ee))return new d.RelativePattern(Ee.base,Ee.pattern);if(z(Ee))return{include:Ge.from(Ee.include)||void 0,exclude:Ge.from(Ee.exclude)||void 0}}}ve.from=ye;function ue(Ee){return typeof Ee=="string"?Ee:Oe(Ee)?{base:Ee.base,pattern:Ee.pattern}:{include:Ee.include,exclude:Ee.exclude}}ve.to=ue;function z(Ee){const We=Ee,Xe=Ge.from(We.include);if(!(Xe&&Xe instanceof d.RelativePattern||typeof Xe=="string"))return!1;const et=Ge.from(We.exclude);return!!(et&&et instanceof d.RelativePattern||typeof et=="string")}function Oe(Ee){const We=Ee;return We&&typeof We.base=="string"&&typeof We.pattern=="string"}})(ke=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Pe;(function(ve){function ye(ue){return{backgroundColor:ue.backgroundColor,borderColor:ue.borderColor,top:ue.top?A.from(ue.top):void 0}}ve.from=ye})(Pe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ne;(function(ve){function ye(ue,z,Oe){const Ee=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{alignment:ue.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:z.toInternal(Ee,Oe),text:ue.text,tooltip:ue.tooltip,accessibilityInformation:ue.accessibilityInformation,priority:ue.priority}}ve.from=ye})(Ne=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Be;(function(ve){function ye(ue){var z,Oe,Ee;return{transientOutputs:(z=ue==null?void 0:ue.transientOutputs)!==null&&z!==void 0?z:!1,transientCellMetadata:(Oe=ue==null?void 0:ue.transientCellMetadata)!==null&&Oe!==void 0?Oe:{},transientDocumentMetadata:(Ee=ue==null?void 0:ue.transientDocumentMetadata)!==null&&Ee!==void 0?Ee:{}}}ve.from=ye})(Be=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ze;(function(ve){function ye(z){return{uri:z.uri,provides:z.provides}}ve.from=ye;function ue(z){return new d.NotebookRendererScript(b.URI.revive(z.uri),z.provides)}ve.to=ue})(Ze=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Je;(function(ve){function ye(z){return{message:_.fromStrict(z.message)||"",severity:z.severity,expectedOutput:z.expectedOutput,actualOutput:z.actualOutput,location:z.location?U.from(z.location):void 0}}ve.from=ye;function ue(z){const Oe=new d.TestMessage(typeof z.message=="string"?z.message:_.to(z.message));return Oe.severity=z.severity,Oe.actualOutput=z.actualOutput,Oe.expectedOutput=z.expectedOutput,Oe}ve.to=ue})(Je=e.TestMessage||(e.TestMessage={}));var Ye;(function(ve){function ye(We){var Xe,et;return{extId:We.id,label:We.label,uri:We.uri,range:v.from(We.range)||null,debuggable:(Xe=We.debuggable)!==null&&Xe!==void 0?Xe:!1,description:We.description||null,runnable:(et=We.runnable)!==null&&et!==void 0?et:!0,error:We.error&&_.fromStrict(We.error)||null}}ve.from=ye;function ue(We){return{extId:We.id,label:We.label,uri:We.uri,range:v.from(We.range)||null,debuggable:!1,description:We.description||null,error:null,runnable:!0}}ve.fromResultSnapshot=ue;function z(We){return{id:We.extId,label:We.label,uri:b.URI.revive(We.uri),range:v.to(We.range||void 0),dispose:()=>{},status:d.TestItemStatus.Pending,data:void 0,debuggable:We.debuggable,description:We.description||void 0,runnable:We.runnable}}ve.toPlain=z;function Oe(We,Xe){const et=new d.TestItemImpl(We.extId,We.label,b.URI.revive(We.uri),void 0,Xe);return et.range=v.to(We.range||void 0),et.debuggable=We.debuggable,et.description=We.description||void 0,et.runnable=We.runnable,et}ve.to=Oe;function Ee(We){let Xe;for(const et of We.tests)Xe=Oe(et.item,Xe);return Xe}ve.toItemFromContext=Ee})(Ye=e.TestItem||(e.TestItem={}));var nt;(function(ve){const ye=(z,Oe)=>Object.assign(Object.assign({},Ye.toPlain(z.item)),{taskStates:z.tasks.map(Ee=>({state:Ee.state,duration:Ee.duration,messages:Ee.messages.map(Je.to)})),children:z.children.map(Ee=>Oe.get(Ee)).filter(D.isDefined).map(Ee=>ye(Ee,Oe))});function ue(z){const Oe=[],Ee=new Map;for(const We of z.items)Ee.set(We.item.extId,We),We.direct&&Oe.push(We);return{completedAt:z.completedAt,results:Oe.map(We=>ye(We,Ee))}}ve.to=ue})(nt=e.TestResults||(e.TestResults={}));var gt;(function(ve){function ye(ue){switch(ue){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}ve.to=ye})(gt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(we[167],_e([0,1,2,11,6,9,51]),function(ee,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(C,n,I,o={timeout:1500,errors:3}){this._logService=C,this._documents=n,this._mainThreadBulkEdits=I,this._thresholds=o,this._callbacks=new k.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(n,I,o)=>{const c={dispose:this._callbacks.push([n,I,C])};return Array.isArray(o)&&o.push(c),c}}async $participateInSave(C,n){const I=m.URI.revive(C);let o=!1;const f=setTimeout(()=>o=!0,this._thresholds.timeout),c=[];try{for(let d of[...this._callbacks]){if(o)break;const w=this._documents.getDocument(I),v=await this._deliverEventAsyncAndBlameBadListeners(d,{document:w,reason:y.TextDocumentSaveReason.to(n)});c.push(v)}}finally{clearTimeout(f)}return c}_deliverEventAsyncAndBlameBadListeners([C,n,I],o){const f=this._badListeners.get(C);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,C,n,o).then(()=>!0,c=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(c),!(c instanceof Error)||c.message!=="concurrent_edits"){const d=this._badListeners.get(C);this._badListeners.set(C,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,n,I,o){const f=[],c=Date.now(),{document:d,reason:w}=o,{version:v}=d,E=Object.freeze({document:d,reason:w,waitUntil(u){if(Object.isFrozen(f))throw T.illegalState("waitUntil can not be called async");f.push(Promise.resolve(u))}});try{n.apply(I,[E])}catch(u){return Promise.reject(u)}return Object.freeze(f),new Promise((u,h)=>{const g=setTimeout(()=>h(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(g),u(t)}).catch(t=>{clearTimeout(g),h(t)})}).then(u=>{const h={edits:[]};for(const g of u)if(Array.isArray(g)&&g.every(t=>t instanceof S.TextEdit))for(const{newText:t,newEol:i,range:s}of g)h.edits.push({_type:2,resource:d.uri,edit:{range:s&&y.Range.from(s),text:t,eol:i&&y.EndOfLine.from(i)}});if(h.edits.length!==0)return v===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(we[168],_e([0,1,3,13,27,2,9,6]),function(ee,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class b{constructor(I,o,f,c,d){this._onDidCreate=new m.Emitter,this._onDidChange=new m.Emitter,this._onDidDelete=new m.Emitter,this._config=0,f&&(this._config+=1),c&&(this._config+=2),d&&(this._config+=4);const w=S.parse(o),v=I(E=>{if(!f)for(let u of E.created){const h=y.URI.revive(u);w(h.fsPath)&&this._onDidCreate.fire(h)}if(!c)for(let u of E.changed){const h=y.URI.revive(u);w(h.fsPath)&&this._onDidChange.fire(h)}if(!d)for(let u of E.deleted){const h=y.URI.revive(u);w(h.fsPath)&&this._onDidDelete.fire(h)}});this._disposable=D.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(I,o,f){this._logService=o,this._extHostDocumentsAndEditors=f,this._onFileSystemEvent=new m.Emitter,this._onDidRenameFile=new m.Emitter,this._onDidCreateFile=new m.Emitter,this._onDidDeleteFile=new m.Emitter,this._onWillRenameFile=new T.AsyncEmitter,this._onWillCreateFile=new T.AsyncEmitter,this._onWillDeleteFile=new T.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,o,f,c){return new b(this._onFileSystemEvent.event,I,o,f,c)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,o){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:o.map(f=>({oldUri:y.URI.revive(f.source),newUri:y.URI.revive(f.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:o.map(f=>y.URI.revive(f.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:o.map(f=>y.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,o){return(f,c,d)=>{const w=function(E){f.call(c,E)};return w.extension=I,o.event(w,void 0,d)}}async $onWillRunFileOperation(I,o,f,c){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:o.map(d=>({oldUri:y.URI.revive(d.source),newUri:y.URI.revive(d.target)}))},f,c);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:o.map(d=>y.URI.revive(d.target))},f,c);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:o.map(d=>y.URI.revive(d.target))},f,c)}}async _fireWillEvent(I,o,f,c){const d=new Set,w=[];if(await I.fireAsync(o,c,async(E,u)=>{var h;const g=Date.now(),t=await Promise.resolve(E);t instanceof D.WorkspaceEdit&&(w.push(t),d.add((h=u.extension.displayName)!==null&&h!==void 0?h:u.extension.identifier.value)),Date.now()-g>f&&this._logService.warn("SLOW file-participant",u.extension.identifier)}),c.isCancellationRequested||w.length===0)return;const v={edits:[]};for(let E of w){let{edits:u}=k.WorkspaceEdit.from(E,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(u)}return{edit:v,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=C}),define(we[169],_e([0,1,12,24,2,9,6,67]),function(ee,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class b{constructor(o,f,c,d){this.start=o,this.deletedCount=f,this.deletedItems=c,this.items=d}static asApiEvents(o){return o.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(c=>c.apiCell)}))}}class C{constructor(o,f,c){var d,w,v;this.notebook=o,this._extHostDocument=f,this._cellData=c,this.handle=c.handle,this.uri=S.URI.revive(c.uri),this.cellKind=c.cellKind,this._outputs=c.outputs.map(y.NotebookCellOutput.to),this._internalMetadata=(d=c.internalMetadata)!==null&&d!==void 0?d:{},this._metadata=(w=c.metadata)!==null&&w!==void 0?w:{},this._previousResult=y.NotebookCellExecutionSummary.to((v=c.internalMetadata)!==null&&v!==void 0?v:{})}static asModelAddData(o,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:o}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const o=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return o.notebook.getCellIndex(o)},notebook:o.notebook.apiNotebook,kind:y.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return o._mime},set mime(c){o._mime=c},get outputs(){return o._outputs.slice(0)},get metadata(){return o._metadata},get executionSummary(){return o._previousResult}})}return this._apiCell}setOutputs(o){this._outputs=o.map(y.NotebookCellOutput.to)}setOutputItems(o,f,c){const d=c.map(y.NotebookCellOutputItem.to),w=this._outputs.find(v=>v.id===o);w&&(f||(w.items.length=0),w.items.push(...d))}setMetadata(o){this._metadata=o}setInternalMetadata(o){this._internalMetadata=o,this._previousResult=y.NotebookCellExecutionSummary.to(o)}setMime(o){}}e.ExtHostCell=C;class n{constructor(o,f,c,d,w,v){var E;this._proxy=o,this._textDocumentsAndEditors=f,this._textDocuments=c,this._emitter=d,this.uri=w,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=v.viewType,this._metadata=(E=v.metadata)!==null&&E!==void 0?E:Object.create(null),this._spliceNotebookCells([[0,0,v.cells]],!0),this._versionId=v.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const o=this;this._notebook={get uri(){return o.uri},get version(){return o._versionId},get notebookType(){return o._notebookType},get isDirty(){return o._isDirty},get isUntitled(){return o.uri.scheme===m.Schemas.untitled},get isClosed(){return o._disposed},get metadata(){return o._metadata},get cellCount(){return o._cells.length},cellAt(f){return f=o._validateIndex(f),o._cells[f].apiCell},getCells(f){return(f?o._getCells(f):o._cells).map(d=>d.apiCell)},save(){return o._save()}}}return this._notebook}updateBackup(o){var f;(f=this._backup)===null||f===void 0||f.delete(),this._backup=o}disposeBackup(){var o;(o=this._backup)===null||o===void 0||o.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(o){o.metadata&&(this._metadata=Object.assign(Object.assign({},this._metadata),o.metadata))}acceptDirty(o){this._isDirty=o}acceptModelChanged(o,f){this._versionId=o.versionId,this._isDirty=f;for(const c of o.rawEvents)c.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(c.changes,!1):c.kind===D.NotebookCellsChangeType.Move?this._moveCell(c.index,c.newIdx):c.kind===D.NotebookCellsChangeType.Output?this._setCellOutputs(c.index,c.outputs):c.kind===D.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(c.index,c.outputId,c.append,c.outputItems):c.kind===D.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(c.index,c.language):c.kind===D.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(c.index,c.mime):c.kind===D.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(c.index,c.metadata):c.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(c.index,c.internalMetadata)}_validateIndex(o){return o=o|0,o<0?0:o>=this._cells.length?this._cells.length-1:o}_validateRange(o){let f=o.start|0,c=o.end|0;return f<0&&(f=0),c>this._cells.length&&(c=this._cells.length),o.with({start:f,end:c})}_getCells(o){o=this._validateRange(o);const f=[];for(let c=o.start;c<o.end;c++)f.push(this._cells[c]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(o,f){if(this._disposed)return;const c=[],d=[],w=[];o.reverse().forEach(v=>{const u=v[2].map(t=>{const i=new C(this,this._textDocumentsAndEditors,t);return f||d.push(C.asModelAddData(this.apiNotebook,t)),i}),h=new b(v[0],v[1],[],u),g=this._cells.splice(v[0],v[1],...u);for(const t of g)w.push(t.uri),h.deletedItems.push(t.apiCell);c.push(h)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:w}),f||this._emitter.emitModelChange(T.deepFreeze({document:this.apiNotebook,changes:b.asApiEvents(c)}))}_moveCell(o,f){const c=this._cells.splice(o,1);this._cells.splice(f,0,...c);const d=[new b(o,1,c.map(w=>w.apiCell),[]),new b(f,0,[],c)];this._emitter.emitModelChange(T.deepFreeze({document:this.apiNotebook,changes:b.asApiEvents(d)}))}_setCellOutputs(o,f){const c=this._cells[o];c.setOutputs(f),this._emitter.emitCellOutputsChange(T.deepFreeze({document:this.apiNotebook,cells:[c.apiCell]}))}_setCellOutputItems(o,f,c,d){const w=this._cells[o];w.setOutputItems(f,c,d),this._emitter.emitCellOutputsChange(T.deepFreeze({document:this.apiNotebook,cells:[w.apiCell]}))}_changeCellLanguage(o,f){const c=this._cells[o];c.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(c.uri,f)}_changeCellMime(o,f){const c=this._cells[o];c.apiCell.mime=f}_changeCellMetadata(o,f){const c=this._cells[o],d=c.apiCell.metadata;c.setMetadata(f);const w=c.apiCell.metadata;T.equals(d,w)||this._emitter.emitCellMetadataChange(T.deepFreeze({document:this.apiNotebook,cell:c.apiCell}))}_changeCellInternalMetadata(o,f){var c;const d=this._cells[o],w=d.internalMetadata;if(d.setInternalMetadata(f),w.runState!==f.runState){const v=(c=f.runState)!==null&&c!==void 0?c:k.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange(T.deepFreeze({document:this.apiNotebook,cell:d.apiCell,state:v}))}}getCellFromApiCell(o){return this._cells.find(f=>f.apiCell===o)}getCellFromIndex(o){return this._cells[o]}getCell(o){return this._cells.find(f=>f.handle===o)}getCellIndex(o){return this._cells.indexOf(o)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(we[97],_e([0,1,6,9,11]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class y{constructor(b){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=b}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(b){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:b})}replaceCellMetadata(b,C){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:b,metadata:C})}replaceCells(b,C,n){this._throwIfFinalized(),!(b===C&&n.length===0)&&this._collectedEdits.push({editType:1,index:b,count:C-b,cells:n.map(T.NotebookCellData.from)})}}class k{constructor(b,C,n,I,o,f){this.id=b,this._proxy=C,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=o,this._visibleRanges=I,this._viewColumn=f}get apiEditor(){if(!this._editor){const b=this;this._editor={get document(){return b.notebookData.apiNotebook},get selections(){return b._selections},set selections(C){if(!Array.isArray(C)||!C.every(m.NotebookRange.isNotebookRange))throw S.illegalArgument("selections");b._selections=C,b._trySetSelections(C)},get visibleRanges(){return b._visibleRanges},revealRange(C,n){b._proxy.$tryRevealRange(b.id,T.NotebookRange.from(C),n??m.NotebookEditorRevealType.Default)},get viewColumn(){return b._viewColumn},edit(C){const n=new y(this.document.version);return C(n),b._applyEdit(n.finalize())},setDecorations(C,n){return b.setDecorations(C,n)}},k.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(b){this._visible=b}_acceptVisibleRanges(b){this._visibleRanges=b}_acceptSelections(b){this._selections=b}_trySetSelections(b){this._proxy.$trySetSelections(this.id,b.map(T.NotebookRange.from))}_acceptViewColumn(b){this._viewColumn=b}_applyEdit(b){if(b.cellEdits.length===0)return Promise.resolve(!0);const C=[];let n=-1;for(let I=0;I<b.cellEdits.length;I++){if(n<0){C.push(b.cellEdits[I]),n++;continue}const f=C[n],c=b.cellEdits[I];if(f.editType===1&&c.editType===1&&f.index===c.index){f.cells.push(...b.cellEdits[I].cells),f.count+=b.cellEdits[I].count;continue}C.push(b.cellEdits[I]),n++}return this._proxy.$tryApplyEdits(this.id,b.documentVersionId,C)}setDecorations(b,C){if(!(C.isEmpty&&!this._hasDecorationsForKey.has(b.key)))return C.isEmpty?this._hasDecorationsForKey.delete(b.key):this._hasDecorationsForKey.add(b.key),this._proxy.$trySetDecorations(this.id,T.NotebookRange.from(C),b.key)}}e.ExtHostNotebookEditor=k,k.apiEditorsToExtHost=new WeakMap}),define(we[170],_e([0,1,9,149,130,18,48]),function(ee,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,o,f){const c=this._handles++,{title:d,location:w,cancellable:v}=o,E={label:S.localize(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(c,{location:m.ProgressLocation.from(w),title:d,source:E,cancellable:v},I),this._withProgress(c,f,!!v)}_withProgress(I,o,f){let c;f&&(c=new y.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,c));const d=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),c&&c.dispose()};let w;try{w=o(new C(this._proxy,I),f&&c?c.token:y.CancellationToken.None)}catch(v){throw d(I),v}return w.then(v=>d(I),v=>d(I)),w}$acceptProgressCanceled(I){const o=this._mapHandleToCancellationSource.get(I);o&&(o.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=D;function b(n,I){return n.message=I.message,typeof I.increment=="number"&&(typeof n.increment=="number"?n.increment+=I.increment:n.increment=I.increment),n}class C extends T.Progress{constructor(I,o){super(f=>this.throttledReport(f));this._proxy=I,this._handle=o}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}He([k.throttle(100,(n,I)=>b(n,I),()=>Object.create(null))],C.prototype,"throttledReport",null)}),define(we[98],_e([0,1,38,11,50,9,6]),function(ee,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(o,f,c){const d=D._Keys.nextId();o.$registerTextEditorDecorationType(f.identifier,d,y.DecorationRenderOptions.from(c)),this.value=Object.freeze({key:d,dispose(){o.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=D,D._Keys=new S.IdGenerator("TextEditorDecorationType");class b{constructor(o,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=o,this._documentVersionId=o.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(o,f){this._throwIfFinalized();let c=null;if(o instanceof k.Position)c=new k.Range(o,o);else if(o instanceof k.Range)c=o;else throw new Error("Unrecognized location");this._pushEdit(c,f,!1)}insert(o,f){this._throwIfFinalized(),this._pushEdit(new k.Range(o,o),f,!0)}delete(o){this._throwIfFinalized();let f=null;if(o instanceof k.Range)f=o;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(o,f,c){const d=this._document.validateRange(o);this._collectedEdits.push({range:d,text:f,forceMoveMarkers:c})}setEndOfLine(o){if(this._throwIfFinalized(),o!==k.EndOfLine.LF&&o!==k.EndOfLine.CRLF)throw T.illegalArgument("endOfLine");this._setEndOfLine=o}}e.TextEditorEdit=b;class C{constructor(o,f,c,d){this._proxy=o,this._id=f,this._accept(c),this._logService=d;const w=this;this.value={get tabSize(){return w._tabSize},set tabSize(v){w._setTabSize(v)},get insertSpaces(){return w._insertSpaces},set insertSpaces(v){w._setInsertSpaces(v)},get cursorStyle(){return w._cursorStyle},set cursorStyle(v){w._setCursorStyle(v)},get lineNumbers(){return w._lineNumbers},set lineNumbers(v){w._setLineNumbers(v)}}}_accept(o){this._tabSize=o.tabSize,this._insertSpaces=o.insertSpaces,this._cursorStyle=o.cursorStyle,this._lineNumbers=y.TextEditorLineNumbersStyle.to(o.lineNumbers)}_validateTabSize(o){if(o==="auto")return"auto";if(typeof o=="number"){const f=Math.floor(o);return f>0?f:null}if(typeof o=="string"){const f=parseInt(o,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(o){const f=this._validateTabSize(o);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(o){return o==="auto"?"auto":o==="false"?!1:Boolean(o)}_setInsertSpaces(o){const f=this._validateInsertSpaces(o);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(o){this._cursorStyle!==o&&(this._cursorStyle=o,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:o})))}_setLineNumbers(o){this._lineNumbers!==o&&(this._lineNumbers=o,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:y.TextEditorLineNumbersStyle.from(o)})))}assign(o){const f={};let c=!1;if(typeof o.tabSize!="undefined"){const d=this._validateTabSize(o.tabSize);d==="auto"?(c=!0,f.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,c=!0,f.tabSize=d)}if(typeof o.insertSpaces!="undefined"){const d=this._validateInsertSpaces(o.insertSpaces);d==="auto"?(c=!0,f.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,c=!0,f.insertSpaces=d)}typeof o.cursorStyle!="undefined"&&this._cursorStyle!==o.cursorStyle&&(this._cursorStyle=o.cursorStyle,c=!0,f.cursorStyle=o.cursorStyle),typeof o.lineNumbers!="undefined"&&this._lineNumbers!==o.lineNumbers&&(this._lineNumbers=o.lineNumbers,c=!0,f.lineNumbers=y.TextEditorLineNumbersStyle.from(o.lineNumbers)),c&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(o){o.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=C;class n{constructor(o,f,c,d,w,v,E,u){this.id=o,this._proxy=f,this._logService=c,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=w,this._options=new C(this._proxy,this.id,v,c),this._visibleRanges=E,this._viewColumn=u;const h=this;this.value=Object.freeze({get document(){return d.getValue()},set document(g){throw T.readonly("document")},get selection(){return h._selections&&h._selections[0]},set selection(g){if(!(g instanceof k.Selection))throw T.illegalArgument("selection");h._selections=[g],h._trySetSelection()},get selections(){return h._selections},set selections(g){if(!Array.isArray(g)||g.some(t=>!(t instanceof k.Selection)))throw T.illegalArgument("selections");h._selections=g,h._trySetSelection()},get visibleRanges(){return h._visibleRanges},set visibleRanges(g){throw T.readonly("visibleRanges")},get options(){return h._options.value},set options(g){h._disposed||h._options.assign(g)},get viewColumn(){return h._viewColumn},set viewColumn(g){throw T.readonly("viewColumn")},edit(g,t={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new b(d.getValue(),t);return g(i),h._applyEdit(i)},insertSnippet(g,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=h._selections.map(r=>y.Range.from(r));else if(t instanceof k.Position){const{lineNumber:r,column:l}=y.Position.from(t);s=[{startLineNumber:r,startColumn:l,endLineNumber:r,endColumn:l}]}else if(t instanceof k.Range)s=[y.Range.from(t)];else{s=[];for(const r of t)if(r instanceof k.Range)s.push(y.Range.from(r));else{const{lineNumber:l,column:_}=y.Position.from(r);s.push({startLineNumber:l,startColumn:_,endLineNumber:l,endColumn:_})}}return f.$tryInsertSnippet(o,g.value,s,i)},setDecorations(g,t){const i=t.length===0;i&&!h._hasDecorationsForKey.has(g.key)||(i?h._hasDecorationsForKey.delete(g.key):h._hasDecorationsForKey.add(g.key),h._runOnProxy(()=>{if(y.isDecorationOptionsArr(t))return f.$trySetDecorations(o,g.key,y.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let r=0,l=t.length;r<l;r++){const _=t[r];s[4*r]=_.start.line+1,s[4*r+1]=_.start.character+1,s[4*r+2]=_.end.line+1,s[4*r+3]=_.end.character+1}return f.$trySetDecorationsFast(o,g.key,s)}}))},revealRange(g,t){h._runOnProxy(()=>f.$tryRevealRange(o,y.Range.from(g),t||k.TextEditorRevealType.Default))},show(g){f.$tryShowEditor(o,y.ViewColumn.from(g))},hide(){f.$tryHideEditor(o)}})}dispose(){m.ok(!this._disposed),this._disposed=!0}_acceptOptions(o){m.ok(!this._disposed),this._options._accept(o)}_acceptVisibleRanges(o){m.ok(!this._disposed),this._visibleRanges=o}_acceptViewColumn(o){m.ok(!this._disposed),this._viewColumn=o}_acceptSelections(o){m.ok(!this._disposed),this._selections=o}async _trySetSelection(){const o=this._selections.map(y.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,o)),this.value}_applyEdit(o){const f=o.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const c=f.edits.map(w=>w.range);c.sort((w,v)=>w.end.line===v.end.line?w.end.character===v.end.character?w.start.line===v.start.line?w.start.character-v.start.character:w.start.line-v.start.line:w.end.character-v.end.character:w.end.line-v.end.line);for(let w=0,v=c.length-1;w<v;w++){const E=c[w].end;if(c[w+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=f.edits.map(w=>({range:y.Range.from(w.range),text:w.text,forceMoveMarkers:w.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,d,{setEndOfLine:typeof f.setEndOfLine=="number"?y.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(o){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):o().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=n}),define(we[171],_e([0,1,133,25,2,3,7,13,6,10,17,9,18]),function(ee,e,m,T,S,y,k,D,b,C,n,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(w,v){if(C.isString(w))return{label:w};if(w&&typeof w=="object"&&typeof w.label=="string"){let E;return Array.isArray(w.highlights)&&(E=w.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),E=E.length?E:void 0),{label:w.label,highlights:E}}}class c{constructor(v,E,u){this._proxy=v,this.commands=E,this.logService=u,this.treeViews=new Map;function h(g){return g&&g.$treeViewId&&g.$treeItemHandle}E.registerArgumentProcessor({processArgument:g=>h(g)?this.convertArgument(g):Array.isArray(g)&&g.length>0?g.map(t=>h(t)?this.convertArgument(t):t):g})}registerTreeDataProvider(v,E,u){const h=this.createTreeView(v,{treeDataProvider:E},u);return{dispose:()=>h.dispose()}}createTreeView(v,E,u){if(!E||!E.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=E.dragAndDropController!==void 0,g=this._proxy.$registerTreeViewDataProvider(v,{showCollapseAll:!!E.showCollapseAll,canSelectMany:!!E.canSelectMany,canDragAndDrop:h}),t=this.createExtHostTreeView(v,E,u);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(i){t.message=i},get title(){return t.title},set title(i){t.title=i},get description(){return t.description},set description(i){t.description=i},reveal:(i,s)=>t.reveal(i,s),dispose:async()=>{await g,this.treeViews.delete(v),t.dispose()}}}$getChildren(v,E){const u=this.treeViews.get(v);return u?u.getChildren(E):Promise.reject(new Error(m.localize(0,null,v)))}$onDrop(v,E,u){const h=this.treeViews.get(v);return h?h.onDrop(E,u):Promise.reject(new Error(m.localize(1,null,v)))}async $hasResolve(v){const E=this.treeViews.get(v);if(!E)throw new Error(m.localize(2,null,v));return E.hasResolve}$resolve(v,E,u){const h=this.treeViews.get(v);if(!h)throw new Error(m.localize(3,null,v));return h.resolveTreeItem(E,u)}$setExpanded(v,E,u){const h=this.treeViews.get(v);if(!h)throw new Error(m.localize(4,null,v));h.setExpanded(E,u)}$setSelection(v,E){const u=this.treeViews.get(v);if(!u)throw new Error(m.localize(5,null,v));u.setSelection(E)}$setVisible(v,E){const u=this.treeViews.get(v);if(!u)throw new Error(m.localize(6,null,v));u.setVisible(E)}createExtHostTreeView(v,E,u){const h=new d(v,E,this._proxy,this.commands.converter,this.logService,u);return this.treeViews.set(v,h),h}convertArgument(v){const E=this.treeViews.get(v.$treeViewId);return E?E.getExtensionElement(v.$treeItemHandle):null}}e.ExtHostTreeViews=c;class d extends k.Disposable{constructor(v,E,u,h,g,t){super();if(this.viewId=v,this.proxy=u,this.commands=h,this.logService=g,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new o.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const l of t.contributes.views[r])l.id===v&&(this._title=l.name);this.dataProvider=E.treeDataProvider,this.dndController=E.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(r=>this._onDidChangeData.fire({message:!1,element:r}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let i,s;this._register(y.Event.debounce(this._onDidChangeData.event,(r,l)=>(r||(r={message:!1,elements:[]}),l.element!==!1&&(i||(i=new Promise(_=>s=_),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(l.element)?r.elements.push(...l.element):r.elements.push(l.element)),l.message&&(r.message=!0),r),200,!0)(({message:r,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const _=s;return i=null,this.refresh(l).then(()=>_())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(v=>this.getExtensionElement(v)).filter(v=>!C.isUndefinedOrNull(v))}getChildren(v){const E=v?this.getExtensionElement(v):void 0;if(v&&!E)return this.logService.error(`No tree item with id '${v}' found.`),Promise.resolve([]);const u=this.getChildrenNodes(v);return(u?Promise.resolve(u):this.fetchChildrenNodes(E)).then(h=>h.map(g=>g.item))}getExtensionElement(v){return this.elements.get(v)}reveal(v,E){E=E||{select:!0,focus:!1};const u=C.isUndefinedOrNull(E.select)?!0:E.select,h=C.isUndefinedOrNull(E.focus)?!1:E.focus,g=C.isUndefinedOrNull(E.expand)?!1:E.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.refreshPromise.then(()=>this.resolveUnknownParentChain(v)).then(t=>this.resolveTreeNode(v,t[t.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:t.map(s=>s.item)},{select:u,focus:h,expand:g})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:h,expand:g})}get message(){return this._message}set message(v){this._message=v,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(v){this._title=v,this.proxy.$setTitle(this.viewId,v,this._description)}get description(){return this._description}set description(v){this._description=v,this.proxy.$setTitle(this.viewId,this._title,v)}setExpanded(v,E){const u=this.getExtensionElement(v);u&&(E?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelection(v){n.equals(this._selectedHandles,v)||(this._selectedHandles=v,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(v){v!==this._visible&&(this._visible=v,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(v,E){const u=v.map(g=>this.getExtensionElement(g)).filter(g=>!C.isUndefinedOrNull(g)),h=this.getExtensionElement(E);return u&&h?D.asPromise(()=>{var g;return(g=this.dndController)===null||g===void 0?void 0:g.onDrop(u,h)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(v,E){var u;if(!this.dataProvider.resolveTreeItem)return;const h=this.elements.get(v);if(h){const g=this.nodes.get(h);if(g){const t=(u=await this.dataProvider.resolveTreeItem(g.extensionItem,h,E))!==null&&u!==void 0?u:g.extensionItem;return g.item.tooltip=this.getTooltip(t.tooltip),g.item.command=this.getCommand(g.disposableStore,t.command),g.item}}}resolveUnknownParentChain(v){return this.resolveParent(v).then(E=>E?this.resolveUnknownParentChain(E).then(u=>this.resolveTreeNode(E,u[u.length-1]).then(h=>(u.push(h),u))):Promise.resolve([]))}resolveParent(v){const E=this.nodes.get(v);return E?Promise.resolve(E.parent?this.elements.get(E.parent.item.handle):void 0):D.asPromise(()=>this.dataProvider.getParent(v))}resolveTreeNode(v,E){const u=this.nodes.get(v);return u?Promise.resolve(u):D.asPromise(()=>this.dataProvider.getTreeItem(v)).then(h=>this.createHandle(v,h,E,!0)).then(h=>this.getChildren(E?E.item.handle:void 0).then(()=>{const g=this.getExtensionElement(h);if(g){const t=this.nodes.get(g);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${h}`)}))}getChildrenNodes(v){if(v){let E;if(typeof v=="string"){const u=this.getExtensionElement(v);E=u?this.nodes.get(u):void 0}else E=v;return E&&E.children||null}return this.roots}async fetchChildrenNodes(v){this.clearChildren(v);const E=new o.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=v?this.nodes.get(v):void 0,h=await this.dataProvider.getChildren(v);if(E.token.isCancellationRequested)return[];const g=await Promise.all(n.coalesce(h||[]).map(async t=>{const i=await this.dataProvider.getTreeItem(t);return i&&!E.token.isCancellationRequested?this.createAndRegisterTreeNode(t,i,u):null}));return E.token.isCancellationRequested?[]:n.coalesce(g)}finally{E.dispose()}}refresh(v){if(v.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new o.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(v);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(v){const E=new Set,u=v.map(g=>this.nodes.get(g));for(const g of u)if(g&&!E.has(g.item.handle)){let t=g;for(;t&&t.parent&&u.findIndex(i=>t&&t.parent&&i&&i.item.handle===t.parent.item.handle)===-1;){const i=this.elements.get(t.parent.item.handle);t=i?this.nodes.get(i):void 0}t&&!t.parent&&E.add(g.item.handle)}const h=[];return E.forEach(g=>{const t=this.elements.get(g);if(t){const i=this.nodes.get(t);i&&(!i.parent||!E.has(i.parent.item.handle))&&h.push(g)}}),h}refreshHandles(v){const E={};return Promise.all(v.map(u=>this.refreshNode(u).then(h=>{h&&(E[u]=h.item)}))).then(()=>Object.keys(E).length?this.proxy.$refresh(this.viewId,E):void 0)}refreshNode(v){const E=this.getExtensionElement(v);if(E){const u=this.nodes.get(E);if(u)return this.clearChildren(E),D.asPromise(()=>this.dataProvider.getTreeItem(E)).then(h=>{if(h){const g=this.createTreeNode(E,h,u.parent);return this.updateNodeCache(E,g,u,u.parent),u.dispose(),g}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(v,E,u){const h=this.createTreeNode(v,E,u);if(E.id&&this.elements.has(h.item.handle))throw new Error(m.localize(7,null,E.id));return this.addNodeToCache(v,h),this.addNodeToParentCache(h,u),h}getTooltip(v){return b.MarkdownString.isMarkdownString(v)?I.MarkdownString.from(v):v}getCommand(v,E){return E?this.commands.toInternal(E,v):void 0}createTreeNode(v,E,u){const h=new k.DisposableStore,g=this.createHandle(v,E,u),t=this.getLightIconPath(E);return{item:{handle:g,parentHandle:u?u.item.handle:void 0,label:f(E.label,this.extension),description:E.description,resourceUri:E.resourceUri,tooltip:this.getTooltip(E.tooltip),command:this.getCommand(h,E.command),contextValue:E.contextValue,icon:t,iconDark:this.getDarkIconPath(E)||t,themeIcon:this.getThemeIcon(E),collapsibleState:C.isUndefinedOrNull(E.collapsibleState)?b.TreeItemCollapsibleState.None:E.collapsibleState,accessibilityInformation:E.accessibilityInformation},extensionItem:E,parent:u,children:void 0,disposableStore:h,dispose(){h.dispose()}}}getThemeIcon(v){return v.iconPath instanceof b.ThemeIcon?v.iconPath:void 0}createHandle(v,{id:E,label:u,resourceUri:h},g,t){if(E)return`${d.ID_HANDLE_PREFIX}/${E}`;const i=f(u,this.extension),s=g?g.item.handle:d.LABEL_HANDLE_PREFIX;let r=i?i.label:h?T.basename(h):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const l=this.nodes.has(v)?this.nodes.get(v).item.handle:void 0,_=this.getChildrenNodes(g)||[];let p,P=0;do{if(p=`${s}/${P}:${r}`,t||!this.elements.has(p)||l===p)break;P++}while(P<=_.length);return p}getLightIconPath(v){if(v.iconPath&&!(v.iconPath instanceof b.ThemeIcon))return typeof v.iconPath=="string"||S.URI.isUri(v.iconPath)?this.getIconPath(v.iconPath):this.getIconPath(v.iconPath.light)}getDarkIconPath(v){if(v.iconPath&&!(v.iconPath instanceof b.ThemeIcon)&&v.iconPath.dark)return this.getIconPath(v.iconPath.dark)}getIconPath(v){return S.URI.isUri(v)?v:S.URI.file(v)}addNodeToCache(v,E){this.elements.set(E.item.handle,v),this.nodes.set(v,E)}updateNodeCache(v,E,u,h){this.elements.delete(E.item.handle),this.nodes.delete(v),E.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(v,E);const g=this.getChildrenNodes(h)||[],t=g.filter(i=>i.item.handle===u.item.handle)[0];t&&g.splice(g.indexOf(t),1,E)}addNodeToParentCache(v,E){E?(E.children||(E.children=[]),E.children.push(v)):(this.roots||(this.roots=[]),this.roots.push(v))}clearChildren(v){if(v){const E=this.nodes.get(v);if(E){if(E.children)for(const u of E.children){const h=this.elements.get(u.item.handle);h&&this.clear(h)}E.children=void 0}}else this.clearAll()}clear(v){const E=this.nodes.get(v);if(E){if(E.children)for(const u of E.children){const h=this.elements.get(u.item.handle);h&&this.clear(h)}this.nodes.delete(v),this.elements.delete(E.item.handle),E.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(v=>v.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}d.LABEL_HANDLE_PREFIX="0",d.ID_HANDLE_PREFIX="1"}),define(we[172],_e([0,1,13,18,3,39,7,10,94,9,6,96]),function(ee,e,m,T,S,y,k,D,b,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=void 0;var o;(function(d){d[d.Disconnected=0]="Disconnected",d[d.IsChild=1]="IsChild",d[d.IsParent=2]="IsParent",d[d.IsSame=3]="IsSame"})(o=e.TestPosition||(e.TestPosition={}));class f{constructor(){this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(w){if(this.map.has(w.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${w.item.extId}`);this.map.set(w.item.extId,w),w.parent||this._roots.add(w)}has(w){return this.map.has(w)}delete(w){const v=this.map.get(w);return v?(this.map.delete(w),this._roots.delete(v),!0):!1}get(w){return this.map.get(w)}comparePositions(w,v){const E=typeof w=="string"?this.map.get(w):w,u=typeof v=="string"?this.map.get(v):v;if(!E||!u)return 0;if(E===u)return 3;for(let h=this.map.get(u.parent);h;h=this.map.get(h.parent))if(h===E)return 1;for(let h=this.map.get(E.parent);h;h=this.map.get(h.parent))if(h===u)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=f;class c extends k.Disposable{constructor(w){super();this.controllerId=w,this.testItemToInternal=new Map,this.debounceSendDiff=this._register(new m.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new S.Emitter),this.root=new n.TestItemImpl(`${this.controllerId}Root`,this.controllerId,void 0,void 0,void 0),this.tree=new f,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.addItemInner(this.root,null)}set resolveHandler(w){this._resolveHandler=w;for(const v of this.testItemToInternal.values())this.updateExpandability(v)}get roots(){return y.Iterable.filter(this.testItemToInternal.values(),w=>w.parent===null)}getTestByReference(w){return this.testItemToInternal.get(w)}collectDiff(){const w=this.diff;return this.diff=[],w}pushDiff(w){const v=this.diff[this.diff.length-1];if(v&&w[0]===1){if(v[0]===1&&v[1].extId===w[1].extId){I.applyTestItemUpdate(v[1],w[1]);return}if(v[0]===0&&v[1].item.extId===w[1].extId){I.applyTestItemUpdate(v[1],w[1]);return}}this.diff.push(w),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(w,v){var E;const u=this.tree.get(w);if(!!u){if((u.expandLevels===void 0||v>u.expandLevels)&&(u.expandLevels=v),u.expand===1){const h=this.refreshChildren(u);return h.isSettled?this.expandChildren(u,v-1):h.p.then(()=>this.expandChildren(u,v-1))}else if(u.expand===3)return((E=u.initialExpand)===null||E===void 0?void 0:E.isSettled)===!1?u.initialExpand.p.then(()=>this.expandChildren(u,v-1)):this.expandChildren(u,v-1)}}dispose(){var w;for(const v of this.testItemToInternal.values())(w=v.discoverCts)===null||w===void 0||w.dispose(!0),b.getPrivateApiFor(v.actual).bus.dispose();this.diff=[],super.dispose()}onTestItemEvent(w,v){const E=w==null?void 0:w.actual.id;switch(v[0]){case 2:this.pushDiff([4,E]);break;case 1:this.removeItem(w);break;case 0:this.addItemInner(v[1],w);break;case 3:const[u,h,g]=v;switch(h){case"status":this.updateExpandability(w);break;case"range":this.pushDiff([1,{extId:E,item:{range:C.Range.from(g)}}]);break;case"error":this.pushDiff([1,{extId:E,item:{error:C.MarkdownString.fromStrict(g)||null}}]);break;default:this.pushDiff([1,{extId:E,item:{[h]:g??null}}]);break}break;default:D.assertNever(v[0])}}addItemInner(w,v){if(!(w instanceof n.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${w.id} did not`);if(this.testItemToInternal.has(w))throw new Error(`Attempted to add a single TestItem ${w.id} multiple times to the tree`);if(this.tree.has(w.id))throw new Error(`Attempted to insert a duplicate test item ID ${w.id}`);const E=v?v.item.extId:null,u=v?v.expandLevels:1,h={actual:w,parent:E,item:C.TestItem.from(w),expandLevels:u?u-1:void 0,expand:0,controllerId:this.controllerId};this.tree.add(h),this.testItemToInternal.set(w,h),this.pushDiff([0,{parent:E,controllerId:this.controllerId,expand:h.expand,item:h.item}]);const g=b.getPrivateApiFor(w);g.bus.event(this.onTestItemEvent.bind(this,h)),this.updateExpandability(h);for(const t of g.children.values())this.testItemToInternal.has(t)||this.addItemInner(t,h)}updateExpandability(w){var v;let E;this._resolveHandler?w.actual.status===n.TestItemStatus.Pending?E=w.discoverCts?2:1:((v=w.initialExpand)===null||v===void 0||v.complete(),E=w.actual.children.size>0?3:0):E=0,E!==w.expand&&(w.expand=E,this.pushDiff([1,{extId:w.actual.id,expand:E}]),E===1&&w.expandLevels!==void 0&&this.refreshChildren(w))}expandChildren(w,v){if(v<0)return;const E=[...w.actual.children.values()].map(u=>this.expand(u.id,v)).filter(m.isThenable);if(E.length)return Promise.all(E).then(()=>{})}refreshChildren(w){if(w.discoverCts&&w.discoverCts.dispose(!0),!this._resolveHandler){const v=new m.DeferredPromise;return v.complete(),v}return w.expand=2,w.discoverCts=new T.CancellationTokenSource,this.pushExpandStateUpdate(w),w.initialExpand=new m.DeferredPromise,this._resolveHandler(w.actual,w.discoverCts.token),w.initialExpand}pushExpandStateUpdate(w){this.pushDiff([1,{extId:w.actual.id,expand:w.expand}])}removeItem(w){var v;this.pushDiff([2,w.actual.id]);const E=[w];for(;E.length;){const u=E.pop();if(!!u){(v=u.discoverCts)===null||v===void 0||v.dispose(!0),this.tree.delete(u.item.extId),this.testItemToInternal.delete(u.actual);for(const h of u.actual.children.values())E.push(this.tree.get(h.id))}}}flushDiff(){const w=this.collectDiff();w.length&&this.diffOpEmitter.fire(w)}}e.SingleUseTestCollection=c}),define(we[173],_e([0,1,5,144]),function(ee,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=m.refineServiceDecorator(T.IEnvironmentService)}),define(we[174],_e([0,1,26,3,15]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class y{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=y;class k{constructor(n){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(b),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(m.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(m.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let I of n.activationEvents)I==="onUri"&&(I=`onUri:${m.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(n)}}keepOnly(n){const I=new Set;n.forEach(o=>I.add(m.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>I.has(m.ExtensionIdentifier.toKey(o.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,I){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const o=k._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(o.map(f=>f.identifier)),I.length>0){const f=new Set;I.forEach(c=>f.add(m.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>!f.has(m.ExtensionIdentifier.toKey(c.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new y(o)}static _findLoopingExtensions(n){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(w){this._nodesSet.has(w)||(this._nodesSet.add(w),this._nodesArr.push(w))}addArc(w,v){this.addNode(w),this.addNode(v),this._arcs.has(w)?this._arcs.get(w).push(v):this._arcs.set(w,[v])}getArcs(w){return this._arcs.has(w)?this._arcs.get(w):[]}hasOnlyGoodArcs(w,v){const E=I.getArcs(w);for(let u=0;u<E.length;u++)if(!v.has(E[u]))return!1;return!0}getNodes(){return this._nodesArr}};let o=new Map;for(let w of n){const v=m.ExtensionIdentifier.toKey(w.identifier);if(o.set(v,w),w.extensionDependencies)for(let E of w.extensionDependencies){const u=m.ExtensionIdentifier.toKey(E);I.addArc(v,u)}}let f=new Set;I.getNodes().filter(w=>I.getArcs(w).length===0).forEach(w=>f.add(w));let c=I.getNodes().filter(w=>!f.has(w)),d;do{d=!1;for(let w=0;w<c.length;w++){const v=c[w];I.hasOnlyGoodArcs(v,f)&&(c.splice(w,1),w--,f.add(v),d=!0)}}while(d);return c.map(w=>o.get(w))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(m.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const I=this._activationMap.get(n);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const I=this._extensionsMap.get(m.ExtensionIdentifier.toKey(n));return I||void 0}}e.ExtensionDescriptionRegistry=k;var D;(function(C){C[C.Builtin=0]="Builtin",C[C.User=1]="User",C[C.Dev=2]="Dev"})(D||(D={}));function b(C,n){const I=C.isBuiltin?0:C.isUnderDevelopment?2:1,o=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(I!==o)return I-o;const f=S.posix.basename(C.extensionLocation.path),c=S.posix.basename(n.extensionLocation.path);return f<c?-1:f>c?1:0}}),define(we[175],_e([0,1,23]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var T;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(T=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var S;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(S=e.MessageType||(e.MessageType={}));function y(D){const b=m.VSBuffer.alloc(1);switch(D){case 0:b.writeUInt8(1,0);break;case 1:b.writeUInt8(2,0);break;case 2:b.writeUInt8(3,0);break}return b}e.createMessageOfType=y;function k(D,b){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return b===0;case 2:return b===1;case 3:return b===2;default:return!1}}e.isMessageOfType=k}),define(we[29],_e([0,1,3,2,5,26,145]),function(ee,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new y.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=S.createDecorator("extensionService");class D{constructor(E){this.dependency=E}}e.MissingExtensionDependency=D;var b;(function(v){v[v.LocalProcess=0]="LocalProcess",v[v.LocalWebWorker=1]="LocalWebWorker",v[v.Remote=2]="Remote"})(b=e.ExtensionHostKind||(e.ExtensionHostKind={}));class C{constructor(E,u,h,g){this.codeLoadingTime=E,this.activateCallTime=u,this.activateResolvedTime=h,this.activationReason=g}}e.ActivationTimes=C;class n{constructor(E,u){this.description=E,this.value=u}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var I;(function(v){v[v.Normal=0]="Normal",v[v.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function o(v){v.enableProposedApi||f(v)}e.checkProposedApiEnabled=o;function f(v){throw new Error(`[${v.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`)}e.throwProposedApiError=f;function c(v){return{type:v.isBuiltin?0:1,isBuiltin:v.isBuiltin||v.isUserBuiltin,identifier:{id:k.getGalleryExtensionId(v.publisher,v.name),uuid:v.uuid},manifest:v,location:v.extensionLocation}}e.toExtension=c;function d(v,E){return Object.assign(Object.assign({identifier:new y.ExtensionIdentifier(v.identifier.id),isBuiltin:v.type===0,isUserBuiltin:v.type===1&&v.isBuiltin,isUnderDevelopment:!!E,extensionLocation:v.location},v.manifest),{uuid:v.identifier.uuid})}e.toExtensionDescription=d;class w{constructor(){this.onDidRegisterExtensions=m.Event.None,this.onDidChangeExtensionsStatus=m.Event.None,this.onDidChangeExtensions=m.Event.None,this.onWillActivateByEvent=m.Event.None,this.onDidChangeResponsiveChange=m.Event.None}activateByEvent(E){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(E){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(E){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(E){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(E,u){return Promise.resolve()}_onWillActivateExtension(E){}_onDidActivateExtension(E,u,h,g,t){}_onDidActivateExtensionError(E,u){}_onExtensionRuntimeError(E,u){}_onExtensionHostExit(E){}}e.NullExtensionService=w}),define(we[176],_e([0,1,26,29,16]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class k{constructor(c,d,w,v){this.startup=c,this.codeLoadingTime=d,this.activateCallTime=w,this.activateResolvedTime=v}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class D{constructor(c){this._startup=c,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(c,d){return c===-1||d===-1?-1:d-c}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class b{constructor(c,d,w,v,E,u){this.activationFailed=c,this.activationFailedError=d,this.activationTimes=w,this.module=v,this.exports=E,this.subscriptions=u}}e.ActivatedExtension=b;class C extends b{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=C;class n extends b{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class I extends b{constructor(c){super(!0,c,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let o=class{constructor(c,d,w,v,E){this._logService=E,this._registry=c,this._resolvedExtensionsSet=new Set,d.forEach(u=>this._resolvedExtensionsSet.add(m.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,w.forEach(u=>this._hostExtensionsMap.set(m.ExtensionIdentifier.toKey(u),u)),this._host=v,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(c){const d=m.ExtensionIdentifier.toKey(c);return this._activatedExtensions.has(d)}getActivatedExtension(c){const d=m.ExtensionIdentifier.toKey(c),w=this._activatedExtensions.get(d);if(!w)throw new Error("Extension `"+c.value+"` is not known or not activated");return w}activateByEvent(c,d){if(this._alreadyActivatedEvents[c])return y;const w=this._registry.getExtensionDescriptionsForActivationEvent(c);return this._activateExtensions(w.map(v=>({id:v.identifier,reason:{startup:d,extensionId:v.identifier,activationEvent:c}}))).then(()=>{this._alreadyActivatedEvents[c]=!0})}activateById(c,d){const w=this._registry.getExtensionDescription(c);if(!w)throw new Error("Extension `"+c+"` is not known");return this._activateExtensions([{id:w.identifier,reason:d}])}_handleActivateRequest(c,d,w){if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(c.id))){d[m.ExtensionIdentifier.toKey(c.id)]=c;return}const v=this._registry.getExtensionDescription(c.id);if(!v){const h=new Error(`Cannot activate unknown extension '${c.id.value}'`);this._host.onExtensionActivationError(c.id,h,new T.MissingExtensionDependency(c.id.value)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(c.id),new I(h));return}const E=typeof v.extensionDependencies=="undefined"?[]:v.extensionDependencies;let u=!0;for(let h=0,g=E.length;h<g;h++){const t=E[h];if(this._resolvedExtensionsSet.has(m.ExtensionIdentifier.toKey(t)))continue;const i=this._activatedExtensions.get(m.ExtensionIdentifier.toKey(t));if(i&&!i.activationFailed)continue;if(i&&i.activationFailed){const _=v.displayName||v.identifier.value,p=this._registry.getExtensionDescription(t),P=p&&p.displayName||t,A=new Error(`Cannot activate the '${_}' extension because its dependency '${P}' failed to activate`);A.detail=i.activationFailedError,this._host.onExtensionActivationError(v.identifier,A,null),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(v.identifier),new I(A));return}if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(t))){u=!1,d[m.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(m.ExtensionIdentifier.toKey(t)),reason:c.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){u=!1,d[m.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:c.reason};continue}const r=v.displayName||v.identifier.value,l=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(v.identifier,l,new T.MissingExtensionDependency(t)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(v.identifier),new I(l));return}u?d[m.ExtensionIdentifier.toKey(v.identifier)]=c:w.push(c)}_activateExtensions(c){if(c.length===0||(c=c.filter(E=>!this._activatedExtensions.has(m.ExtensionIdentifier.toKey(E.id))),c.length===0))return Promise.resolve(void 0);const d=Object.create(null),w=[];for(let E=0,u=c.length;E<u;E++)this._handleActivateRequest(c[E],d,w);for(let E=0,u=w.length;E<u;E++){const h=m.ExtensionIdentifier.toKey(w[E].id);d[h]&&delete d[h]}const v=Object.keys(d).map(E=>d[E]);return w.length===0?Promise.all(v.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(v).then(E=>this._activateExtensions(w))}_activateExtension(c,d){const w=m.ExtensionIdentifier.toKey(c);if(this._activatedExtensions.has(w))return Promise.resolve(void 0);const v=this._activatingExtensions.get(w);if(v)return v;const E=this._host.actualActivateExtension(c,d).then(void 0,u=>{const h=new Error;return u&&u.name&&(h.name=u.name),u&&u.message?h.message=`Activating extension '${c.value}' failed: ${u.message}.`:h.message=`Activating extension '${c.value}' failed: ${u}.`,u&&u.stack&&(h.stack=u.stack),this._host.onExtensionActivationError(c,h,null),this._logService.error(`Activating extension ${c.value} failed due to an error:`),this._logService.error(u),new I(u)}).then(u=>{this._activatedExtensions.set(w,u),this._activatingExtensions.delete(w)});return this._activatingExtensions.set(w,E),E}};o=He([ze(4,S.ILogService)],o),e.ExtensionsActivator=o}),define(we[177],_e([0,1,11]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class T{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,k)=>{this._actualOk=y,this._actualErr=k,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):m.onUnexpectedError(y))}then(y,k){return this._ensureActual().then(y,k)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=T}),define(we[99],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class m{constructor(b,C){this.isMain=b,this.sid=C,this.nid=++m.count}}e.ProxyIdentifier=m,m.count=0;const T=[];function S(D){const b=new m(!0,D);return T[b.nid]=b,b}e.createMainContextProxyIdentifier=S;function y(D){const b=new m(!1,D);return T[b.nid]=b,b}e.createExtHostContextProxyIdentifier=y;function k(D){return T[D].sid}e.getStringIdentifierForProxy=k}),define(we[4],_e([0,1,54,2,99]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var y;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(y=e.UIKind||(e.UIKind={}));var k;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var b;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(b=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(C=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var o;(function(u){u.name="$ident";function h(t,i){return Object.defineProperty(t,u.name,{value:i,enumerable:!0}),t}u.mixin=h;function g(t){return t[u.name]}u.of=g})(o=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(h){return h._id=f._n++,h}}e.IdObject=f,f._n=0;var c;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n"})(c=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var d;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(d=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function v(u){if(u&&u.edits)for(const h of u.edits)typeof h.resource=="object"?h.resource=T.URI.revive(h.resource):(h.newUri=T.URI.revive(h.newUri),h.oldUri=T.URI.revive(h.oldUri)),h.metadata&&h.metadata.iconPath&&(h.metadata=m.revive(h.metadata));return u}e.reviveWorkspaceEditDto=v;var E;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:S.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadBulkEdits:S.createMainContextProxyIdentifier("MainThreadBulkEdits"),MainThreadClipboard:S.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:S.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:S.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:S.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:S.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:S.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:S.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:S.createMainContextProxyIdentifier("MainThreadDiagnostics"),MainThreadDialogs:S.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:S.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:S.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:S.createMainContextProxyIdentifier("MainThreadTextEditors"),MainThreadEditorInsets:S.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadEditorTabs:S.createMainContextProxyIdentifier("MainThreadEditorTabs"),MainThreadErrors:S.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:S.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:S.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:S.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:S.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:S.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:S.createMainContextProxyIdentifier("MainThread"),MainThreadMessageService:S.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:S.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:S.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:S.createMainContextProxyIdentifier("MainThreadQuickOpen"),MainThreadStatusBar:S.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadSecretState:S.createMainContextProxyIdentifier("MainThreadSecretState"),MainThreadStorage:S.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:S.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:S.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:S.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadWebviewPanels:S.createMainContextProxyIdentifier("MainThreadWebviewPanels"),MainThreadWebviewViews:S.createMainContextProxyIdentifier("MainThreadWebviewViews"),MainThreadCustomEditors:S.createMainContextProxyIdentifier("MainThreadCustomEditors"),MainThreadUrls:S.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadUriOpeners:S.createMainContextProxyIdentifier("MainThreadUriOpeners"),MainThreadWorkspace:S.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:S.createMainContextProxyIdentifier("MainThreadFileSystem"),MainThreadExtensionService:S.createMainContextProxyIdentifier("MainThreadExtensionService"),MainThreadSCM:S.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:S.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:S.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:S.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:S.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:S.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadNotebookDocuments:S.createMainContextProxyIdentifier("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:S.createMainContextProxyIdentifier("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:S.createMainContextProxyIdentifier("MainThreadNotebookKernels"),MainThreadNotebookRenderers:S.createMainContextProxyIdentifier("MainThreadNotebookRenderers"),MainThreadTheming:S.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:S.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:S.createMainContextProxyIdentifier("MainThreadTimeline"),MainThreadTesting:S.createMainContextProxyIdentifier("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:S.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:S.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:S.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),ExtHostDebugService:S.createExtHostContextProxyIdentifier("ExtHostDebugService"),ExtHostDecorations:S.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:S.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:S.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:S.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:S.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:S.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:S.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:S.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemInfo:S.createExtHostContextProxyIdentifier("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:S.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:S.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),ExtHostQuickOpen:S.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:S.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:S.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:S.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:S.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:S.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:S.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:S.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:S.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:S.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostWebviewPanels:S.createExtHostContextProxyIdentifier("ExtHostWebviewPanels"),ExtHostCustomEditors:S.createExtHostContextProxyIdentifier("ExtHostCustomEditors"),ExtHostWebviewViews:S.createExtHostContextProxyIdentifier("ExtHostWebviewViews"),ExtHostEditorInsets:S.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostEditorTabs:S.createExtHostContextProxyIdentifier("ExtHostEditorTabs"),ExtHostProgress:S.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:S.createMainContextProxyIdentifier("ExtHostComments"),ExtHostSecretState:S.createMainContextProxyIdentifier("ExtHostSecretState"),ExtHostStorage:S.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:S.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostUriOpeners:S.createExtHostContextProxyIdentifier("ExtHostUriOpeners"),ExtHostOutputService:S.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:S.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:S.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostNotebookDocuments:S.createMainContextProxyIdentifier("ExtHostNotebookDocuments"),ExtHostNotebookEditors:S.createMainContextProxyIdentifier("ExtHostNotebookEditors"),ExtHostNotebookKernels:S.createMainContextProxyIdentifier("ExtHostNotebookKernels"),ExtHostNotebookRenderers:S.createMainContextProxyIdentifier("ExtHostNotebookRenderers"),ExtHostTheming:S.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:S.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:S.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:S.createMainContextProxyIdentifier("ExtHostTimeline"),ExtHostTesting:S.createMainContextProxyIdentifier("ExtHostTesting"),ExtHostTelemetry:S.createMainContextProxyIdentifier("ExtHostTelemetry")}}),define(we[68],_e([0,1,4,3,5]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class y{constructor(D){this._onDidChangePassword=new T.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(m.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,b){return this._proxy.$getPassword(D,b)}store(D,b,C){return this._proxy.$setPassword(D,b,C)}delete(D,b){return this._proxy.$deletePassword(D,b)}}e.ExtHostSecretState=y,e.IExtHostSecretState=S.createDecorator("IExtHostSecretState")}),define(we[69],_e([0,1,5,16,4,14]),function(ee,e,m,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=m.createDecorator("IExtHostApiDeprecationService");let k=class{constructor(b,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=b.getProxy(S.MainContext.MainThreadTelemetry)}report(b,C,n){const I=this.getUsageKey(b,C);this._reportedUsages.has(I)||(this._reportedUsages.add(I),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${b}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:b}))}getUsageKey(b,C){return`${b}-${C.identifier.value}`}};k=He([ze(0,y.IExtHostRpcService),ze(1,T.ILogService)],k),e.ExtHostApiDeprecationService=k,e.NullApiDeprecationService=Object.freeze(new class{report(D,b,C){}})}),define(we[178],_e([0,1,3,4,6,26]),function(ee,e,m,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class k{constructor(b){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new m.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new m.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=b.getProxy(T.MainContext.MainThreadAuthentication)}$setProviders(b){return this._providers=b,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(b,C,n,I={}){const o=y.ExtensionIdentifier.toKey(b.identifier),f=this._inFlightRequests.get(o)||[],c=[...n].sort().join(" ");let d=f.find(w=>w.scopes===c);if(d)return d.result;{const w=this._getSession(b,o,C,n,I);d={scopes:c,result:w},f.push(d),this._inFlightRequests.set(o,f);try{await w}finally{const v=f.findIndex(E=>E.scopes===c);v>-1&&(f.splice(v),this._inFlightRequests.set(o,f))}return w}}async _getSession(b,C,n,I,o={}){await this._proxy.$ensureProvider(n);const f=b.displayName||b.name;return this._proxy.$getSession(n,I,C,f,o)}async removeSession(b,C){const n=this._authenticationProviders.get(b);return n?n.provider.removeSession(C):this._proxy.$removeSession(b,C)}registerAuthenticationProvider(b,C,n,I){var o;if(this._authenticationProviders.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this._authenticationProviders.set(b,{label:C,provider:n,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(c=>c.id===b)||this._providers.push({id:b,label:C});const f=n.onDidChangeSessions(c=>{var d,w,v;this._proxy.$sendDidChangeSessions(b,{added:(d=c.added)!==null&&d!==void 0?d:[],changed:(w=c.changed)!==null&&w!==void 0?w:[],removed:(v=c.removed)!==null&&v!==void 0?v:[]})});return this._proxy.$registerAuthenticationProvider(b,C,(o=I==null?void 0:I.supportsMultipleAccounts)!==null&&o!==void 0?o:!1),new S.Disposable(()=>{f.dispose(),this._authenticationProviders.delete(b);const c=this._providers.findIndex(d=>d.id===b);c>-1&&this._providers.splice(c),this._proxy.$unregisterAuthenticationProvider(b)})}$createSession(b,C){const n=this._authenticationProviders.get(b);if(n)return Promise.resolve(n.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,C){const n=this._authenticationProviders.get(b);if(n)return Promise.resolve(n.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,C){const n=this._authenticationProviders.get(b);if(n)return Promise.resolve(n.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,C){return this._onDidChangeSessions.fire({provider:{id:b,label:C}}),Promise.resolve()}$onDidChangeAuthenticationProviders(b,C){return b.forEach(n=>{this._providers.some(I=>I.id===n.id)||this._providers.push(n)}),C.forEach(n=>{const I=this._providers.findIndex(o=>o.id===n.id);I>-1&&this._providers.splice(I)}),this._onDidChangeAuthenticationProviders.fire({added:b,removed:C}),Promise.resolve()}}e.ExtHostAuthentication=k}),define(we[179],_e([0,1,4,14,9]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let y=class{constructor(D,b){this._extHostDocumentsAndEditors=b,this._proxy=D.getProxy(m.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(D){const b=S.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(b)}};y=He([ze(0,T.IExtHostRpcService)],y),e.ExtHostBulkEdits=y}),define(we[180],_e([0,1,4]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(y){const k=y.getProxy(m.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return k.$readText()},writeText(D){return k.$writeText(D)}})}}e.ExtHostClipboard=T}),define(we[70],_e([0,1,10,6,9,24,4,17,16,54,30,35,2,7,5,14]),function(ee,e,m,T,S,y,k,D,b,C,n,I,o,f,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let w=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(k.MainContext.MainThreadCommands),this._logService=i,this.converter=new v(this,s=>{const r=this._apiCommands.get(s);return(r==null?void 0:r.result)===u.Void?r:void 0},i),this._argumentProcessors=[{processArgument(s){return C.revive(s)}},{processArgument(s){return y.cloneAndChange(s,function(r){if(n.Range.isIRange(r))return S.Range.to(r);if(I.Position.isIPosition(r))return S.Position.to(r);if(n.Range.isIRange(r.range)&&o.URI.isUri(r.uri))return S.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...s)=>{const r=t.args.map((_,p)=>{if(!_.validate(s[p]))throw new Error(`Invalid argument '${_.name}' when running '${t.id}', received: ${s[p]}`);return _.convert(s[p])}),l=await this.executeCommand(t.internalId,...r);return t.result.convert(l,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new T.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,s,r,l){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:s,thisArg:r,description:l}),t&&this._proxy.$registerCommand(i),new T.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,s){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const r=y.cloneAndChange(i,function(l){if(l instanceof T.Position)return S.Position.from(l);if(l instanceof T.Range)return S.Range.from(l);if(l instanceof T.Location)return S.location.from(l);if(T.NotebookRange.isNotebookRange(l))return S.NotebookRange.from(l);if(!Array.isArray(l))return l});try{const l=await this._proxy.$executeCommand(t,r,s);return C.revive(l)}catch(l){if(l instanceof Error&&l.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw l}}}async _executeContributedCommand(t,i){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:r,thisArg:l,description:_}=s;if(_)for(let p=0;p<_.args.length;p++)try{m.validateConstraint(i[p],_.args[p].constraint)}catch(P){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${_.args[p].name}' - ${_.args[p].description}`)}try{return await r.apply(l,i)}catch(p){if(t===this.converter.delegatingCommandId){const P=this.converter.getActualCommand(...i);P&&(t=P.command)}throw this._logService.error(p,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(s=>this._argumentProcessors.reduce((r,l)=>l.processArgument(r),s)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(s=>s[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,s]of this._commands){let{description:r}=s;r&&(t[i]=r)}return Promise.resolve(t)}};w=He([ze(0,d.IExtHostRpcService),ze(1,b.ILogService)],w),e.ExtHostCommands=w,e.IExtHostCommands=c.createDecorator("IExtHostCommands");class v{constructor(t,i,s){this._commands=t,this._lookupApiCommand=i,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!t)return;const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const r=this._lookupApiCommand(t.command);if(r)s.id=r.internalId,s.arguments=r.args.map((l,_)=>l.convert(t.arguments&&t.arguments[_]));else if(D.isNonEmptyArray(t.arguments)){const l=++this._cachIdPool;this._cache.set(l,t),i.add(f.toDisposable(()=>{this._cache.delete(l),this._logService.trace("CommandsConverter#DISPOSE",l)})),s.$ident=l,s.id=this.delegatingCommandId,s.arguments=[l],this._logService.trace("CommandsConverter#CREATE",t.command,l)}return s}fromInternal(t){const i=k.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=v;class E{constructor(t,i,s,r){this.name=t,this.description=i,this.validate=s,this.convert=r}optional(){return new E(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new E(t??this.name,i??this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",g=>o.URI.isUri(g),g=>g),E.Position=new E("position","A position in a text document",g=>T.Position.isPosition(g),S.Position.from),E.Range=new E("range","A range in a text document",g=>T.Range.isRange(g),S.Range.from),E.Selection=new E("selection","A selection in a text document",g=>T.Selection.isSelection(g),S.Selection.from),E.Number=new E("number","",g=>typeof g=="number",g=>g),E.String=new E("string","",g=>typeof g=="string",g=>g),E.CallHierarchyItem=new E("item","A call hierarchy item",g=>g instanceof T.CallHierarchyItem,S.CallHierarchyItem.to);class u{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=u,u.Void=new u("no result",g=>g);class h{constructor(t,i,s,r,l){this.id=t,this.internalId=i,this.description=s,this.args=r,this.result=l}}e.ApiCommand=h}),define(we[181],_e([0,1,9,6,58,70,17,85]),function(ee,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const b=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(m.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(o,f)=>{if(k.isFalsyOrEmpty(o))return;class c extends T.SymbolInformation{static to(w){const v=new c(w.name,m.SymbolKind.to(w.kind),w.containerName||"",new T.Location(f[0],m.Range.to(w.range)));return v.detail=w.detail,v.range=v.location.range,v.selectionRange=m.Range.to(w.selectionRange),v.children=w.children?w.children.map(c.to):[],v}}return o.map(c.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",o=>typeof o=="string",o=>o),new y.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(m.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(m.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",o=>Array.isArray(o)&&o.every(f=>T.Position.isPosition(f)),o=>o.map(m.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",o=>o.map(f=>{let c;for(const d of f.reverse())c=new T.SelectionRange(m.Range.to(d),c);return c}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",o=>{const f=[];if(Array.isArray(o))for(let c of o)f.push(...c[1].map(m.WorkspaceSymbol.to));return f})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(m.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(m.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(m.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",o=>{if(!!o){if(o.rejectReason)throw new Error(o.rejectReason);return m.WorkspaceEdit.to(o)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",o=>o.map(m.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new T.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const f=D.decodeSemanticTokensDto(o);if(f.type==="full")return new T.SemanticTokens(f.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new T.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const f=D.decodeSemanticTokensDto(o);if(f.type==="full")return new T.SemanticTokens(f.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(o,f,c)=>{if(!o)return new T.CompletionList([]);const d=o.suggestions.map(w=>m.CompletionItem.to(w,c));return new T.CompletionList(d,o.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",o=>{if(o)return m.SignatureHelp.to(o)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(o,f,c)=>n(d=>new T.CodeLens(m.Range.to(d.range),d.command&&c.fromInternal(d.command)))(o))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",o=>T.Range.isRange(o),o=>T.Selection.isSelection(o)?m.Selection.from(o):m.Range.from(o)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(o,f,c)=>n(d=>{if(d._isSynthetic){if(!d.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(d.command)}else{const w=new T.CodeAction(d.title,d.kind?new T.CodeActionKind(d.kind):void 0);return d.edit&&(w.edit=m.WorkspaceEdit.to(d.edit)),d.command&&(w.command=c.fromInternal(d.command)),w.isPreferred=d.isPreferred,w}})(o))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",o=>o?o.map(f=>new T.ColorInformation(m.Range.to(f.range),m.Color.to(f.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",o=>o instanceof T.Color,m.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",o=>!0,o=>({uri:o.uri,range:m.Range.from(o.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",o=>o?o.map(m.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",o=>o.map(m.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(o=>({viewType:o.viewType,displayName:o.displayName,options:{transientOutputs:o.options.transientOutputs,transientCellMetadata:o.options.transientCellMetadata,transientDocumentMetadata:o.options.transientDocumentMetadata},filenamePattern:o.filenamePattern.map(f=>m.NotebookExclusiveDocumentPattern.to(f))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",o=>o.map(m.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[o,void 0]:[m.ViewColumn.from(o.viewColumn),m.TextEditorOpenOptions.from(o)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[o,void 0]:[m.ViewColumn.from(o.viewColumn),m.TextEditorOpenOptions.from(o)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="object",o=>o&&[m.ViewColumn.from(o.viewColumn),m.TextEditorOpenOptions.from(o)]).optional()],y.ApiCommandResult.Void)];class C{static register(f){b.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=C;function n(o){return f=>{if(Array.isArray(f))return f.map(o)}}function I(o){if(!Array.isArray(o))return;const f=[];for(const c of o)S.isLocationLink(c)?f.push(m.DefinitionLink.to(c)):f.push(m.location.to(c));return f}}),define(we[182],_e([0,1,13,48,3,7,2,58,26,9,6,4]),function(ee,e,m,T,S,y,k,D,b,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class o{constructor(h,g,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=h.getProxy(I.MainContext.MainThreadComments),g.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const s=this._commentControllers.get(i.handle);return s||i}else if(i&&i.$mid===7){const s=this._commentControllers.get(i.commentControlHandle);if(!s)return i;const r=s.getCommentThread(i.commentThreadHandle);return r||i}else if(i&&i.$mid===8){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const r=s.getCommentThread(i.thread.commentThreadHandle);return r?{thread:r,text:i.text}:i}else if(i&&i.$mid===9){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const r=s.getCommentThread(i.thread.commentThreadHandle);if(!r)return i;let l=i.commentUniqueId,_=r.getCommentByUniqueId(l);return _||i}else if(i&&i.$mid===10){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const r=s.getCommentThread(i.thread.commentThreadHandle);if(!r)return i;let l=i.text,_=i.commentUniqueId,p=r.getCommentByUniqueId(_);return p?(p.body=l,p):i}return i}})}createCommentController(h,g,t){const i=o.handlePool++,s=new c(h,i,this._proxy,g,t);this._commentControllers.set(s.handle,s);const r=this._commentControllersByExtension.get(b.ExtensionIdentifier.toKey(h.identifier))||[];return r.push(s),this._commentControllersByExtension.set(b.ExtensionIdentifier.toKey(h.identifier),r),s}$createCommentThreadTemplate(h,g,t){const i=this._commentControllers.get(h);!i||i.$createCommentThreadTemplate(g,t)}async $updateCommentThreadTemplate(h,g,t){const i=this._commentControllers.get(h);!i||i.$updateCommentThreadTemplate(g,t)}$deleteCommentThread(h,g){const t=this._commentControllers.get(h);t&&t.$deleteCommentThread(g)}$provideCommentingRanges(h,g,t){const i=this._commentControllers.get(h);if(!i||!i.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(k.URI.revive(g));return m.asPromise(()=>i.commentingRangeProvider.provideCommentingRanges(s,t)).then(r=>r?r.map(l=>C.Range.from(l)):void 0)}$toggleReaction(h,g,t,i,s){const r=this._commentControllers.get(h);return!r||!r.reactionHandler?Promise.resolve(void 0):m.asPromise(()=>{const l=r.getCommentThread(g);if(l){const _=l.getCommentByUniqueId(i.uniqueIdInThread);if(r!==void 0&&_&&r.reactionHandler)return r.reactionHandler(_,v(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=o,o.handlePool=0;class f{constructor(h,g,t,i,s,r,l){this._proxy=h,this._commentController=g,this._id=t,this._uri=i,this._range=s,this._comments=r,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new S.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputDisposables.value=new y.DisposableStore,this._id===void 0&&(this._id=`${g.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,C.Range.from(this._range),l),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=r}set threadId(h){this._id=h}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(h){h.isEqual(this._range)||(this._range=h,this.modifications.range=h,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(h){this._canReply!==h&&(this._canReply=h,this.modifications.canReply=h,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(h){this._label=h,this.modifications.label=h,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(h){this._contextValue=h,this.modifications.contextValue=h,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(h){this._comments=h,this.modifications.comments=h,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(h){this._collapseState=h,this.modifications.collapsibleState=h,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new y.DisposableStore);const h=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),g={};h("range")&&(g.range=C.Range.from(this._range)),h("label")&&(g.label=this.label),h("contextValue")&&(g.contextValue=this.contextValue),h("comments")&&(g.comments=this._comments.map(t=>d(this,this._commentController,t,this._commentsMap))),h("collapsibleState")&&(g.collapseState=E(this._collapseState)),h("canReply")&&(g.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,g)}getCommentByUniqueId(h){for(let g of this._commentsMap){let t=g[0],i=g[1];if(h===i)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(h=>h.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}f._handlePool=0,He([T.debounce(100)],f.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=f;class c{constructor(h,g,t,i,s){this._extension=h,this._handle=g,this._proxy=t,this._id=i,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,i,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(h){this._reactionHandler=h,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this._options}set options(h){this._options=h,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(h,g,t,i){if(typeof h=="string"){const s=new f(this._proxy,this,h,g,t,i,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new f(this._proxy,this,void 0,h,g,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(h,g){const t=new f(this._proxy,this,void 0,k.URI.revive(h),C.Range.to(g),[],this._extension.identifier);return t.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(h,g){let t=this._threads.get(h);t&&(t.range=C.Range.to(g))}$deleteCommentThread(h){let g=this._threads.get(h);g&&g.dispose(),this._threads.delete(h)}getCommentThread(h){return this._threads.get(h)}dispose(){this._threads.forEach(h=>{h.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function d(u,h,g,t){let i=t.get(g);i||(i=++u.commentHandle,t.set(g,i));const s=g.author&&g.author.iconPath?g.author.iconPath.toString():void 0;return{mode:g.mode,contextValue:g.contextValue,uniqueIdInThread:i,body:C.MarkdownString.from(g.body),userName:g.author.name,userIconPath:s,label:g.label,commentReactions:g.reactions?g.reactions.map(r=>w(r)):void 0}}function w(u){return{label:u.label,iconPath:u.iconPath?C.pathOrURIToURI(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted}}function v(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?k.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1}}function E(u){if(u!==void 0)switch(u){case n.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}}),define(we[100],_e([0,1,2,4,6,5,14,16,17,8,15]),function(ee,e,m,T,S,y,k,D,b,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class _n{constructor(f,c){this._logService=c,this._provider=new Map,this._proxy=f.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,c){const d=_n._handlePool++;this._provider.set(d,{provider:f,extensionId:c}),this._proxy.$registerDecorationProvider(d,c.value);const w=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(v=>{if(!v){this._proxy.$onDidChange(d,null);return}let E=b.asArray(v);if(E.length<=_n._maxEventSize){this._proxy.$onDidChange(d,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",c.value,E.length);const u=E.map(t=>({uri:t,rank:C.count(t.path,"/")})),h=b.groupBy(u,(t,i)=>t.rank-i.rank||C.compare(t.uri.path,i.uri.path));let g=[];e:for(let t of h){let i;for(let s of t){let r=n.dirname(s.uri.path);if(i!==r&&(i=r,g.push(s.uri)>=_n._maxEventSize))break e}}this._proxy.$onDidChange(d,g)});return new S.Disposable(()=>{w==null||w.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(f,c,d){if(!this._provider.has(f))return Object.create(null);const w=Object.create(null),{provider:v,extensionId:E}=this._provider.get(f);return await Promise.all(c.map(async u=>{try{const{uri:h,id:g}=u,t=await Promise.resolve(v.provideFileDecoration(m.URI.revive(h),d));if(!t)return;try{S.FileDecoration.validate(t),w[g]=[t.propagate,t.tooltip,t.badge,t.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${E.value}': ${i}`)}}catch(h){this._logService.error(h)}})),w}};I._handlePool=0,I._maxEventSize=250,I=He([ze(0,k.IExtHostRpcService),ze(1,D.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=y.createDecorator("IExtHostDecorations")}),define(we[183],_e([0,1,128,89,2,4,6,9,3,16,22]),function(ee,e,m,T,S,y,k,D,b,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(c,d,w,v,E){this._name=c,this._owner=d,this._maxDiagnosticsPerFile=w,this._proxy=v,this._onDidChangeDiagnostics=E,this._isDisposed=!1,this._data=new n.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(c,d){if(!c){this.clear();return}this._checkDisposed();let w=[];if(S.URI.isUri(c)){if(!d){this.delete(c);return}this._data.set(c,d.slice()),w=[c]}else if(Array.isArray(c)){w=[];let E;c=[...c].sort(I._compareIndexedTuplesByUri);for(const u of c){const[h,g]=u;if((!E||h.toString()!==E.toString())&&(E&&this._data.get(E).length===0&&this._data.delete(E),E=h,w.push(h),this._data.set(h,[])),g){const t=this._data.get(h);t&&t.push(...g)}else{const t=this._data.get(h);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(w),!this._proxy)return;const v=[];for(let E of w){let u=[];const h=this._data.get(E);if(h)if(h.length>this._maxDiagnosticsPerFile){u=[];const g=[k.DiagnosticSeverity.Error,k.DiagnosticSeverity.Warning,k.DiagnosticSeverity.Information,k.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let i of h)if(i.severity===g[t]&&u.push(D.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;u.push({severity:T.MarkerSeverity.Info,message:m.localize(0,null,h.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=h.map(g=>D.Diagnostic.from(g));v.push([E,u])}this._proxy.$changeMany(this._owner,v)}delete(c){this._checkDisposed(),this._onDidChangeDiagnostics.fire([c]),this._data.delete(c),this._proxy&&this._proxy.$changeMany(this._owner,[[c,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(c,d){this._checkDisposed();for(let w of this._data.keys())c.apply(d,[w,this.get(w),this])}get(c){this._checkDisposed();const d=this._data.get(c);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(c){return this._checkDisposed(),Array.isArray(this._data.get(c))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(c,d){return c[0].toString()<d[0].toString()?-1:c[0].toString()>d[0].toString()?1:0}}e.DiagnosticCollection=I;let o=class Gt{constructor(c,d){this._logService=d,this._collections=new Map,this._onDidChangeDiagnostics=new b.Emitter,this.onDidChangeDiagnostics=b.Event.map(b.Event.debounce(this._onDidChangeDiagnostics.event,Gt._debouncer,50),Gt._mapper),this._proxy=c.getProxy(y.MainContext.MainThreadDiagnostics)}static _debouncer(c,d){return c?c.concat(d):d}static _mapper(c){const d=new n.ResourceMap;for(const w of c)d.set(w,w);return{uris:Object.freeze(Array.from(d.values()))}}createDiagnosticCollection(c,d){const{_collections:w,_proxy:v,_onDidChangeDiagnostics:E,_logService:u}=this,h=new class{$changeMany(i,s){v.$changeMany(i,s),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,i,s.length===0?"CLEARING":s)}$clear(i){v.$clear(i),u.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,i)}dispose(){v.dispose()}};let g;if(!d)d="_generated_diagnostic_collection_name_#"+Gt._idPool++,g=d;else if(!w.has(d))g=d;else{this._logService.warn(`DiagnosticCollection with name '${d}' does already exist.`);do g=d+Gt._idPool++;while(w.has(g))}return new class extends I{constructor(){super(d,g,Gt._maxDiagnosticsPerFile,h,E);w.set(g,this)}dispose(){super.dispose(),w.delete(g)}}}getDiagnostics(c){if(c)return this._getDiagnostics(c);{const d=new Map,w=[];for(const v of this._collections.values())v.forEach((E,u)=>{let h=d.get(E.toString());typeof h=="undefined"&&(h=w.length,d.set(E.toString(),h),w.push([E,[]])),w[h][1]=w[h][1].concat(...u)});return w}}_getDiagnostics(c){let d=[];for(let w of this._collections.values())w.has(c)&&(d=d.concat(w.get(c)));return d}$acceptMarkersChange(c){if(!this._mirrorCollection){const d="_generated_mirror",w=new I(d,d,Gt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(d,w),this._mirrorCollection=w}for(const[d,w]of c)this._mirrorCollection.set(S.URI.revive(d),w.map(D.Diagnostic.to))}};o._idPool=0,o._maxDiagnosticsPerFile=1e3,o=He([ze(1,C.ILogService)],o),e.ExtHostDiagnostics=o}),define(we[184],_e([0,1,2,4]),function(ee,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class S{constructor(k){this._proxy=k.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(k){return this._proxy.$showOpenDialog(k).then(D=>D?D.map(b=>m.URI.revive(b)):void 0)}showSaveDialog(k){return this._proxy.$showSaveDialog(k).then(D=>D?m.URI.revive(D):void 0)}}e.ExtHostDialogs=S}),define(we[185],_e([0,1,11,2,6,4,12,18,8]),function(ee,e,m,T,S,y,k,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(I,o,f){this._documentsAndEditors=o,this._logService=f,this._documentContentProviders=new Map,this._proxy=I.getProxy(y.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,o){if(Object.keys(k.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const f=C._handlePool++;this._documentContentProviders.set(f,o),this._proxy.$registerTextContentProvider(f,I);let c;return typeof o.onDidChange=="function"&&(c=o.onDidChange(d=>{if(d.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(f,d).then(w=>{if(!w&&typeof w!="string")return;const v=this._documentsAndEditors.getDocument(d);if(!v)return;const E=b.splitLines(w);if(!v.equalLines(E))return this._proxy.$onVirtualDocumentChange(d,w)},m.onUnexpectedError)})),new S.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),c&&(c.dispose(),c=void 0)})}$provideTextDocumentContent(I,o){const f=this._documentContentProviders.get(I);return f?Promise.resolve(f.provideTextDocumentContent(T.URI.revive(o),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${o.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(we[186],_e([0,1,3,7,2,4,95,9,10,24]),function(ee,e,m,T,S,y,k,D,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class n{constructor(o,f){this._onDidAddDocument=new m.Emitter,this._onDidRemoveDocument=new m.Emitter,this._onDidChangeDocument=new m.Emitter,this._onDidSaveDocument=new m.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new T.DisposableStore,this._documentLoader=new Map,this._proxy=o.getProxy(y.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(c=>{for(const d of c)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(c=>{for(const d of c)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(o){if(!o)return;const f=this._documentsAndEditors.getDocument(o);if(f)return f}getDocument(o){const f=this.getDocumentData(o);if(!(f==null?void 0:f.document))throw new Error(`Unable to retrieve document from URI '${o}'`);return f.document}ensureDocumentData(o){const f=this._documentsAndEditors.getDocument(o);if(f)return Promise.resolve(f);let c=this._documentLoader.get(o.toString());return c||(c=this._proxy.$tryOpenDocument(o).then(d=>{this._documentLoader.delete(o.toString());const w=S.URI.revive(d);return b.assertIsDefined(this._documentsAndEditors.getDocument(w))},d=>(this._documentLoader.delete(o.toString()),Promise.reject(d))),this._documentLoader.set(o.toString(),c)),c}createDocumentData(o){return this._proxy.$tryCreateDocument(o).then(f=>S.URI.revive(f))}$acceptModelModeChanged(o,f){const c=S.URI.revive(o),d=this._documentsAndEditors.getDocument(c);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(f),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(o){const f=S.URI.revive(o),c=this._documentsAndEditors.getDocument(f);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(o,!1),this._onDidSaveDocument.fire(c.document)}$acceptDirtyStateChanged(o,f){const c=S.URI.revive(o),d=this._documentsAndEditors.getDocument(c);if(!d)throw new Error("unknown document");d._acceptIsDirty(f),this._onDidChangeDocument.fire({document:d.document,contentChanges:[]})}$acceptModelChanged(o,f,c){const d=S.URI.revive(o),w=this._documentsAndEditors.getDocument(d);if(!w)throw new Error("unknown document");w._acceptIsDirty(c),w.onEvents(f),this._onDidChangeDocument.fire(C.deepFreeze({document:w.document,contentChanges:f.changes.map(v=>({range:D.Range.to(v.range),rangeOffset:v.rangeOffset,rangeLength:v.rangeLength,text:v.text}))}))}setWordDefinitionFor(o,f){k.setWordDefinitionFor(o,f)}}e.ExtHostDocuments=n}),define(we[46],_e([0,1,38,3,7,2,5,4,95,14,98,9,16,22,12,39,108]),function(ee,e,m,T,S,y,k,D,b,C,n,I,o,f,c,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class v{constructor(h){this.value=h,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(h,g){this._extHostRpc=h,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new T.Emitter,this._onDidRemoveDocuments=new T.Emitter,this._onDidChangeVisibleTextEditors=new T.Emitter,this._onDidChangeActiveTextEditor=new T.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const g=[],t=[],i=[];if(h.removedDocuments)for(const s of h.removedDocuments){const r=y.URI.revive(s),l=this._documents.get(r);(l==null?void 0:l.unref())&&(this._documents.delete(r),g.push(l.value))}if(h.addedDocuments)for(const s of h.addedDocuments){const r=y.URI.revive(s.uri);let l=this._documents.get(r);if(l&&r.scheme!==c.Schemas.vscodeNotebookCell)throw new Error(`document '${r} already exists!'`);l||(l=new v(new b.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),r,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(r,l),t.push(l.value)),l.ref()}if(h.removedEditors)for(const s of h.removedEditors){const r=this._editors.get(s);this._editors.delete(s),r&&i.push(r)}if(h.addedEditors)for(const s of h.addedEditors){const r=y.URI.revive(s.documentUri);m.ok(this._documents.has(r),`document '${r}' does not exist`),m.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const l=this._documents.get(r).value,_=new n.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new w.Lazy(()=>l.document),s.selections.map(I.Selection.to),s.options,s.visibleRanges.map(p=>I.Range.to(p)),typeof s.editorPosition=="number"?I.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,_)}h.newActiveEditor!==void 0&&(m.ok(h.newActiveEditor===null||this._editors.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this._activeEditorId=h.newActiveEditor),S.dispose(g),S.dispose(i),h.removedDocuments&&this._onDidRemoveDocuments.fire(g),h.addedDocuments&&this._onDidAddDocuments.fire(t),(h.removedEditors||h.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),h.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(h){var g;return(g=this._documents.get(h))===null||g===void 0?void 0:g.value}allDocuments(){return d.Iterable.map(this._documents.values(),h=>h.value)}getEditor(h){return this._editors.get(h)}activeEditor(h){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return h?g:g==null?void 0:g.value}allEditors(){return[...this._editors.values()]}};E=He([ze(0,C.IExtHostRpcService),ze(1,o.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=k.createDecorator("IExtHostDocumentsAndEditors")}),define(we[187],_e([0,1,2,4,7,6,9,118,8,23]),function(ee,e,m,T,S,y,k,D,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const c=this._schemes.indexOf(f);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),c=[];let d,w,v=14,E=14;for(const u of f){let h=d?b.commonPrefixLength(d,u):0;for(h===0?w=1:w=E;h<u.length;h++)h+1===u.length?(v=E,E=9):E+=1,c.push([w,u.toUpperCase().charCodeAt(h),E]),c.push([w,u.toLowerCase().charCodeAt(h),E]),w=E;d=u,E=v}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new D.StateMachine(c)}}provideDocumentLinks(f){this._initStateMachine();const c=[],d=D.LinkComputer.computeLinks({getLineContent(w){return f.lineAt(w-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const w of d){const v=k.DocumentLink.to(w);v.target&&c.push(v)}return c}}class I{constructor(f,c){this._extHostLanguageFeatures=c,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=f.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){var f;(f=this._linkProviderRegistration)===null||f===void 0||f.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,c,d,w={},v){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const E=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(E,d),this._enableProposedApi.set(E,v??!1);let u=2;w.isCaseSensitive&&(u+=1024),w.isReadonly&&(u+=2048),typeof d.copy=="function"&&(u+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&(u+=4),this._proxy.$registerFileSystemProvider(E,c,u).catch(g=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${c}`),console.error(g)});const h=d.onDidChangeFile(g=>{const t=[];for(const i of g){let{uri:s,type:r}=i;if(s.scheme!==c)continue;let l;switch(r){case y.FileChangeType.Changed:l=0;break;case y.FileChangeType.Created:l=1;break;case y.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:l})}this._proxy.$onFileSystemChange(E,t)});return S.toDisposable(()=>{h.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(E),this._enableProposedApi.delete(E),this._proxy.$unregisterProvider(E)})}static _asIStat(f,c){const{type:d,ctime:w,mtime:v,size:E,permissions:u}=f;return c?{type:d,ctime:w,mtime:v,size:E,permissions:u}:{type:d,ctime:w,mtime:v,size:E}}$stat(f,c){return Promise.resolve(this._getFsProvider(f).stat(m.URI.revive(c))).then(d=>{var w;return I._asIStat(d,(w=this._enableProposedApi.get(f))!==null&&w!==void 0?w:!1)})}$readdir(f,c){return Promise.resolve(this._getFsProvider(f).readDirectory(m.URI.revive(c)))}$readFile(f,c){return Promise.resolve(this._getFsProvider(f).readFile(m.URI.revive(c))).then(d=>C.VSBuffer.wrap(d))}$writeFile(f,c,d,w){return Promise.resolve(this._getFsProvider(f).writeFile(m.URI.revive(c),d.buffer,w))}$delete(f,c,d){return Promise.resolve(this._getFsProvider(f).delete(m.URI.revive(c),d))}$rename(f,c,d,w){return Promise.resolve(this._getFsProvider(f).rename(m.URI.revive(c),m.URI.revive(d),w))}$copy(f,c,d,w){const v=this._getFsProvider(f);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(m.URI.revive(c),m.URI.revive(d),w))}$mkdir(f,c){return Promise.resolve(this._getFsProvider(f).createDirectory(m.URI.revive(c)))}$watch(f,c,d,w){const v=this._getFsProvider(f).watch(m.URI.revive(d),w);this._watches.set(c,v)}$unwatch(f,c){const d=this._watches.get(c);d&&(d.dispose(),this._watches.delete(c))}$open(f,c,d){const w=this._getFsProvider(f);if(!w.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(w.open(m.URI.revive(c),d))}$close(f,c){const d=this._getFsProvider(f);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(c))}$read(f,c,d,w){const v=this._getFsProvider(f);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const E=C.VSBuffer.alloc(w);return Promise.resolve(v.read(c,d,E.buffer,0,w)).then(u=>E.slice(0,u))}$write(f,c,d,w){const v=this._getFsProvider(f);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(c,d,w.buffer,0,w.byteLength))}_getFsProvider(f){const c=this._fsProvider.get(f);if(!c){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return c}}e.ExtHostFileSystem=I}),define(we[71],_e([0,1,4,59,6,23,5,14,45]),function(ee,e,m,T,S,y,k,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=class Ut{constructor(I,o){const f=I.getProxy(m.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(c){return f.$stat(c).catch(Ut._handleError)},readDirectory(c){return f.$readdir(c).catch(Ut._handleError)},createDirectory(c){return f.$mkdir(c).catch(Ut._handleError)},async readFile(c){return f.$readFile(c).then(d=>d.buffer).catch(Ut._handleError)},writeFile(c,d){return f.$writeFile(c,y.VSBuffer.wrap(d)).catch(Ut._handleError)},delete(c,d){return f.$delete(c,Object.assign({recursive:!1,useTrash:!1},d)).catch(Ut._handleError)},rename(c,d,w){return f.$rename(c,d,Object.assign({overwrite:!1},w)).catch(Ut._handleError)},copy(c,d,w){return f.$copy(c,d,Object.assign({overwrite:!1},w)).catch(Ut._handleError)},isWritableFileSystem(c){const d=o.getCapabilities(c);if(typeof d=="number")return!(d&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new S.FileSystemError(String(I));if(I.name==="ENOPRO")throw S.FileSystemError.Unavailable(I.message);switch(I.name){case T.FileSystemProviderErrorCode.FileExists:throw S.FileSystemError.FileExists(I.message);case T.FileSystemProviderErrorCode.FileNotFound:throw S.FileSystemError.FileNotFound(I.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw S.FileSystemError.FileNotADirectory(I.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw S.FileSystemError.FileIsADirectory(I.message);case T.FileSystemProviderErrorCode.NoPermissions:throw S.FileSystemError.NoPermissions(I.message);case T.FileSystemProviderErrorCode.Unavailable:throw S.FileSystemError.Unavailable(I.message);default:throw new S.FileSystemError(I.message,I.name)}}};C=He([ze(0,D.IExtHostRpcService),ze(1,b.IExtHostFileSystemInfo)],C),e.ExtHostConsumerFileSystem=C,e.IExtHostConsumerFileSystem=k.createDecorator("IExtHostConsumerFileSystem")}),define(we[188],_e([0,1,7,4]),function(ee,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class S{constructor(k){this._handlePool=0,this._proxy=k.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(k){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,k),m.toDisposable(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=S}),define(we[189],_e([0,1,2,24,9,6,13,4,8,30,17,10,115,7,85,50,62,52,11,3]),function(ee,e,m,T,S,y,k,D,b,C,n,I,o,f,c,d,w,v,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class h{constructor($,K){this._documents=$,this._provider=K}provideDocumentSymbols($,K){const ie=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideDocumentSymbols(ie,K)).then(se=>{if(!n.isFalsyOrEmpty(se))return se[0]instanceof y.DocumentSymbol?se.map(S.DocumentSymbol.from):h._asDocumentSymbolTree(se)})}static _asDocumentSymbolTree($){var K;$=$.slice(0).sort((q,oe)=>{let fe=q.location.range.start.compareTo(oe.location.range.start);return fe===0&&(fe=oe.location.range.end.compareTo(q.location.range.end)),fe});const ie=[],se=[];for(const q of $){const oe={name:q.name||"!!MISSING: name!!",kind:S.SymbolKind.from(q.kind),tags:((K=q.tags)===null||K===void 0?void 0:K.map(S.SymbolTag.from))||[],detail:"",containerName:q.containerName,range:S.Range.from(q.location.range),selectionRange:S.Range.from(q.location.range),children:[]};for(;;){if(se.length===0){se.push(oe),ie.push(oe);break}const fe=se[se.length-1];if(C.Range.containsRange(fe.range,oe.range)&&!C.Range.equalsRange(fe.range,oe.range)){fe.children&&fe.children.push(oe),se.push(oe);break}se.pop()}}return ie}}class g{constructor($,K,ie){this._documents=$,this._commands=K,this._provider=ie,this._cache=new w.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses($,K){const ie=this._documents.getDocument($),se=await this._provider.provideCodeLenses(ie,K);if(!se||K.isCancellationRequested)return;const q=this._cache.add(se),oe=new f.DisposableStore;this._disposables.set(q,oe);const fe={cacheId:q,lenses:[]};for(let Re=0;Re<se.length;Re++)fe.lenses.push({cacheId:[q,Re],range:S.Range.from(se[Re].range),command:this._commands.toInternal(se[Re].command,oe)});return fe}async resolveCodeLens($,K){var ie;const se=$.cacheId&&this._cache.get(...$.cacheId);if(!se)return;let q;if(typeof this._provider.resolveCodeLens!="function"||se.isResolved?q=se:q=await this._provider.resolveCodeLens(se,K),q||(q=se),K.isCancellationRequested)return;const oe=$.cacheId&&this._disposables.get($.cacheId[0]);if(!!oe)return $.command=this._commands.toInternal((ie=q.command)!==null&&ie!==void 0?ie:g._badCmd,oe),$}releaseCodeLenses($){var K;(K=this._disposables.get($))===null||K===void 0||K.dispose(),this._disposables.delete($),this._cache.delete($)}}g._badCmd={command:"missing",title:"!!MISSING: command!!"};function t(Qe){return Array.isArray(Qe)?Qe.map(S.DefinitionLink.from):Qe?[S.DefinitionLink.from(Qe)]:[]}class i{constructor($,K){this._documents=$,this._provider=K}provideDefinition($,K,ie){const se=this._documents.getDocument($),q=S.Position.to(K);return k.asPromise(()=>this._provider.provideDefinition(se,q,ie)).then(t)}}class s{constructor($,K){this._documents=$,this._provider=K}provideDeclaration($,K,ie){const se=this._documents.getDocument($),q=S.Position.to(K);return k.asPromise(()=>this._provider.provideDeclaration(se,q,ie)).then(t)}}class r{constructor($,K){this._documents=$,this._provider=K}provideImplementation($,K,ie){const se=this._documents.getDocument($),q=S.Position.to(K);return k.asPromise(()=>this._provider.provideImplementation(se,q,ie)).then(t)}}class l{constructor($,K){this._documents=$,this._provider=K}provideTypeDefinition($,K,ie){const se=this._documents.getDocument($),q=S.Position.to(K);return k.asPromise(()=>this._provider.provideTypeDefinition(se,q,ie)).then(t)}}class _{constructor($,K){this._documents=$,this._provider=K}provideHover($,K,ie){const se=this._documents.getDocument($),q=S.Position.to(K);return k.asPromise(()=>this._provider.provideHover(se,q,ie)).then(oe=>{if(!(!oe||n.isFalsyOrEmpty(oe.contents)))return oe.range||(oe.range=se.getWordRangeAtPosition(q)),oe.range||(oe.range=new y.Range(q,q)),S.Hover.from(oe)})}}class p{constructor($,K){this._documents=$,this._provider=K}provideEvaluatableExpression($,K,ie){const se=this._documents.getDocument($),q=S.Position.to(K);return k.asPromise(()=>this._provider.provideEvaluatableExpression(se,q,ie)).then(oe=>{if(oe)return S.EvaluatableExpression.from(oe)})}}class P{constructor($,K){this._documents=$,this._provider=K}provideInlineValues($,K,ie,se){const q=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideInlineValues(q,S.Range.to(K),S.InlineValueContext.to(ie),se)).then(oe=>{if(Array.isArray(oe))return oe.map(fe=>S.InlineValue.from(fe))})}}class A{constructor($,K){this._documents=$,this._provider=K}provideDocumentHighlights($,K,ie){const se=this._documents.getDocument($),q=S.Position.to(K);return k.asPromise(()=>this._provider.provideDocumentHighlights(se,q,ie)).then(oe=>{if(Array.isArray(oe))return oe.map(S.DocumentHighlight.from)})}}class a{constructor($,K){this._documents=$,this._provider=K}provideLinkedEditingRanges($,K,ie){const se=this._documents.getDocument($),q=S.Position.to(K);return k.asPromise(()=>this._provider.provideLinkedEditingRanges(se,q,ie)).then(oe=>{if(oe&&Array.isArray(oe.ranges))return{ranges:n.coalesce(oe.ranges.map(S.Range.from)),wordPattern:oe.wordPattern}})}}class R{constructor($,K){this._documents=$,this._provider=K}provideReferences($,K,ie,se){const q=this._documents.getDocument($),oe=S.Position.to(K);return k.asPromise(()=>this._provider.provideReferences(q,oe,ie,se)).then(fe=>{if(Array.isArray(fe))return fe.map(S.location.from)})}}class F{constructor($,K,ie,se,q,oe,fe){this._documents=$,this._commands=K,this._diagnostics=ie,this._provider=se,this._logService=q,this._extension=oe,this._apiDeprecation=fe,this._cache=new w.Cache("CodeAction"),this._disposables=new Map}provideCodeActions($,K,ie,se){const q=this._documents.getDocument($),oe=o.Selection.isISelection(K)?S.Selection.to(K):S.Range.to(K),fe=[];for(const xe of this._diagnostics.getDiagnostics($))if(oe.intersection(xe.range)&&fe.push(xe)>F._maxCodeActionsPerFile)break;const Re={diagnostics:fe,only:ie.only?new y.CodeActionKind(ie.only):void 0,triggerKind:S.CodeActionTriggerKind.to(ie.trigger)};return k.asPromise(()=>this._provider.provideCodeActions(q,oe,Re,se)).then(xe=>{var pe;if(!n.isNonEmptyArray(xe)||se.isCancellationRequested)return;const qe=this._cache.add(xe),H=new f.DisposableStore;this._disposables.set(qe,H);const te=[];for(let me=0;me<xe.length;me++){const Te=xe[me];!Te||(F._isCommand(Te)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),te.push({_isSynthetic:!0,title:Te.title,command:this._commands.toInternal(Te,H)})):(Re.only&&(Te.kind?Re.only.contains(Te.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action is of kind '${Te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),te.push({cacheId:[qe,me],title:Te.title,command:Te.command&&this._commands.toInternal(Te.command,H),diagnostics:Te.diagnostics&&Te.diagnostics.map(S.Diagnostic.from),edit:Te.edit&&S.WorkspaceEdit.from(Te.edit),kind:Te.kind&&Te.kind.value,isPreferred:Te.isPreferred,disabled:(pe=Te.disabled)===null||pe===void 0?void 0:pe.reason})))}return{cacheId:qe,actions:te}})}async resolveCodeAction($,K){var ie;const[se,q]=$,oe=this._cache.get(se,q);if(!oe||F._isCommand(oe)||!this._provider.resolveCodeAction)return;const fe=(ie=await this._provider.resolveCodeAction(oe,K))!==null&&ie!==void 0?ie:oe;return(fe==null?void 0:fe.edit)?S.WorkspaceEdit.from(fe.edit):void 0}releaseCodeActions($){var K;(K=this._disposables.get($))===null||K===void 0||K.dispose(),this._disposables.delete($),this._cache.delete($)}static _isCommand($){return typeof $.command=="string"&&typeof $.title=="string"}}F._maxCodeActionsPerFile=1e3;class x{constructor($,K){this._documents=$,this._provider=K}provideDocumentFormattingEdits($,K,ie){const se=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideDocumentFormattingEdits(se,K,ie)).then(q=>{if(Array.isArray(q))return q.map(S.TextEdit.from)})}}class J{constructor($,K){this._documents=$,this._provider=K}provideDocumentRangeFormattingEdits($,K,ie,se){const q=this._documents.getDocument($),oe=S.Range.to(K);return k.asPromise(()=>this._provider.provideDocumentRangeFormattingEdits(q,oe,ie,se)).then(fe=>{if(Array.isArray(fe))return fe.map(S.TextEdit.from)})}}class ae{constructor($,K){this._documents=$,this._provider=K,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits($,K,ie,se,q){const oe=this._documents.getDocument($),fe=S.Position.to(K);return k.asPromise(()=>this._provider.provideOnTypeFormattingEdits(oe,fe,ie,se,q)).then(Re=>{if(Array.isArray(Re))return Re.map(S.TextEdit.from)})}}class j{constructor($,K){this._provider=$,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols($,K){const ie=D.IdObject.mixin({symbols:[]});return k.asPromise(()=>this._provider.provideWorkspaceSymbols($,K)).then(se=>{if(n.isNonEmptyArray(se))for(const q of se){if(!q)continue;if(!q.name){this._logService.warn("INVALID SymbolInformation, lacks name",q);continue}const oe=D.IdObject.mixin(S.WorkspaceSymbol.from(q));this._symbolCache.set(oe._id,q),ie.symbols.push(oe)}}).then(()=>(ie.symbols.length>0&&this._resultCache.set(ie._id,[ie.symbols[0]._id,ie.symbols[ie.symbols.length-1]._id]),ie))}async resolveWorkspaceSymbol($,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return $;const ie=this._symbolCache.get($._id);if(ie){const se=await k.asPromise(()=>this._provider.resolveWorkspaceSymbol(ie,K));return se&&T.mixin($,S.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols($){const K=this._resultCache.get($);if(K){for(let[ie,se]=K;ie<=se;ie++)this._symbolCache.delete(ie);this._resultCache.delete($)}}}class W{constructor($,K,ie){this._documents=$,this._provider=K,this._logService=ie}static supportsResolving($){return typeof $.prepareRename=="function"}provideRenameEdits($,K,ie,se){const q=this._documents.getDocument($),oe=S.Position.to(K);return k.asPromise(()=>this._provider.provideRenameEdits(q,oe,ie,se)).then(fe=>{if(!!fe)return S.WorkspaceEdit.from(fe)},fe=>{const Re=W._asMessage(fe);return Re?{rejectReason:Re,edits:void 0}:Promise.reject(fe)})}resolveRenameLocation($,K,ie){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument($),q=S.Position.to(K);return k.asPromise(()=>this._provider.prepareRename(se,q,ie)).then(oe=>{let fe,Re;if(y.Range.isRange(oe)?(fe=oe,Re=se.getText(oe)):I.isObject(oe)&&(fe=oe.range,Re=oe.placeholder),!!fe){if(fe.start.line>q.line||fe.end.line<q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(fe),text:Re}}},oe=>{const fe=W._asMessage(oe);return fe?{rejectReason:fe,range:void 0,text:void 0}:Promise.reject(oe)})}static _asMessage($){return typeof $=="string"?$:$ instanceof Error&&typeof $.message=="string"?$.message:void 0}}class Q{constructor($,K){this.resultId=$,this.tokens=K}}class M{constructor($,K){this._documents=$,this._provider=K,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens($,K,ie){const se=this._documents.getDocument($),q=K!==0?this._previousResults.get(K):null;return k.asPromise(()=>q&&typeof q.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(se,q.resultId,ie):this._provider.provideDocumentSemanticTokens(se,ie)).then(oe=>(q&&this._previousResults.delete(K),oe?(oe=M._fixProvidedSemanticTokens(oe),this._send(M._convertToEdits(q,oe),oe)):null))}async releaseDocumentSemanticColoring($){this._previousResults.delete($)}static _fixProvidedSemanticTokens($){return M._isSemanticTokens($)?M._isCorrectSemanticTokens($)?$:new y.SemanticTokens(new Uint32Array($.data),$.resultId):M._isSemanticTokensEdits($)?M._isCorrectSemanticTokensEdits($)?$:new y.SemanticTokensEdits($.edits.map(K=>new y.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),$.resultId):$}static _isSemanticTokens($){return $&&!!$.data}static _isCorrectSemanticTokens($){return $.data instanceof Uint32Array}static _isSemanticTokensEdits($){return $&&Array.isArray($.edits)}static _isCorrectSemanticTokensEdits($){for(const K of $.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits($,K){if(!M._isSemanticTokens(K)||!$||!$.tokens)return K;const ie=$.tokens,se=ie.length,q=K.data,oe=q.length;let fe=0;const Re=Math.min(se,oe);for(;fe<Re&&ie[fe]===q[fe];)fe++;if(fe===se&&fe===oe)return new y.SemanticTokensEdits([],K.resultId);let xe=0;const pe=Re-fe;for(;xe<pe&&ie[se-xe-1]===q[oe-xe-1];)xe++;return new y.SemanticTokensEdits([{start:fe,deleteCount:se-fe-xe,data:q.subarray(fe,oe-xe)}],K.resultId)}_send($,K){if(M._isSemanticTokens($)){const ie=this._nextResultId++;return this._previousResults.set(ie,new Q($.resultId,$.data)),c.encodeSemanticTokensDto({id:ie,type:"full",data:$.data})}if(M._isSemanticTokensEdits($)){const ie=this._nextResultId++;return M._isSemanticTokens(K)?this._previousResults.set(ie,new Q(K.resultId,K.data)):this._previousResults.set(ie,new Q($.resultId)),c.encodeSemanticTokensDto({id:ie,type:"delta",deltas:($.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}e.DocumentSemanticTokensAdapter=M;class X{constructor($,K){this._documents=$,this._provider=K}provideDocumentRangeSemanticTokens($,K,ie){const se=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideDocumentRangeSemanticTokens(se,S.Range.to(K),ie)).then(q=>q?this._send(q):null)}_send($){return c.encodeSemanticTokensDto({id:0,type:"full",data:$.data})}}e.DocumentRangeSemanticTokensAdapter=X;class B{constructor($,K,ie,se,q){this._documents=$,this._commands=K,this._provider=ie,this._apiDeprecation=se,this._extension=q,this._cache=new w.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving($){return typeof $.resolveCompletionItem=="function"}async provideCompletionItems($,K,ie,se){const q=this._documents.getDocument($),oe=S.Position.to(K),fe=q.getWordRangeAtPosition(oe)||new y.Range(oe,oe),Re=fe.with({end:oe}),xe=new v.StopWatch(!0),pe=await k.asPromise(()=>this._provider.provideCompletionItems(q,oe,se,S.CompletionContext.to(ie)));if(!pe||se.isCancellationRequested)return;const qe=Array.isArray(pe)?new y.CompletionList(pe):pe,H=B.supportsResolving(this._provider)?this._cache.add(qe.items):this._cache.add([]),te=new f.DisposableStore;this._disposables.set(H,te);const me=[],Te={x:H,b:me,a:{replace:S.Range.from(fe),insert:S.Range.from(Re)},c:qe.isIncomplete||void 0,d:xe.elapsed()};for(let Le=0;Le<qe.items.length;Le++){const Ge=qe.items[Le],Se=this._convertCompletionItem(Ge,[H,Le],Re,fe);me.push(Se)}return Te}async resolveCompletionItem($,K){if(typeof this._provider.resolveCompletionItem!="function")return;const ie=this._cache.get(...$);if(!ie)return;const se=await k.asPromise(()=>this._provider.resolveCompletionItem(ie,K));if(!!se)return this._convertCompletionItem(se,$)}releaseCompletionItems($){var K;(K=this._disposables.get($))===null||K===void 0||K.dispose(),this._disposables.delete($),this._cache.delete($)}_convertCompletionItem($,K,ie,se){const q=this._disposables.get(K[0]);if(!q)throw Error("DisposableStore is missing...");const oe={x:K,a:$.label,b:$.kind!==void 0?S.CompletionItemKind.from($.kind):void 0,n:$.tags&&$.tags.map(S.CompletionItemTag.from),c:$.detail,d:typeof $.documentation=="undefined"?void 0:S.MarkdownString.fromStrict($.documentation),e:$.sortText!==$.label?$.sortText:void 0,f:$.filterText!==$.label?$.filterText:void 0,g:$.preselect||void 0,i:$.keepWhitespace?1:0,k:$.commitCharacters,l:$.additionalTextEdits&&$.additionalTextEdits.map(S.TextEdit.from),m:this._commands.toInternal($.command,q)};$.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),oe.h=$.textEdit.newText):typeof $.insertText=="string"?oe.h=$.insertText:$.insertText instanceof y.SnippetString&&(oe.h=$.insertText.value,oe.i|=4);let fe;return $.textEdit?fe=$.textEdit.range:$.range&&(fe=$.range),y.Range.isRange(fe)?oe.j=S.Range.from(fe):fe&&(!(ie==null?void 0:ie.isEqual(fe.inserting))||!(se==null?void 0:se.isEqual(fe.replacing)))&&(oe.j={insert:S.Range.from(fe.inserting),replace:S.Range.from(fe.replacing)}),oe}}class U{constructor($,K,ie){this._documents=$,this._provider=K,this._commands=ie,this._cache=new w.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions($,K,ie,se){const q=this._documents.getDocument($),oe=S.Position.to(K),fe=await k.asPromise(()=>this._provider.provideInlineCompletionItems(q,oe,ie,se));if(!fe||se.isCancellationRequested)return;const Re=I.isArray(fe)?{items:fe}:fe,xe=this._cache.add(Re.items);let pe;return{pid:xe,items:Re.items.map((qe,H)=>{let te;return qe.command&&(pe||(pe=new f.DisposableStore,this._disposables.set(xe,pe)),te=this._commands.toInternal(qe.command,pe)),{text:qe.text,range:qe.range?S.Range.from(qe.range):void 0,command:te,idx:H}})}}disposeCompletions($){this._cache.delete($);const K=this._disposables.get($);K&&K.clear(),this._disposables.delete($)}handleDidShowCompletionItem($,K){const ie=this._cache.get($,K);ie&&Y.get(this._provider).fireOnDidShowCompletionItem({completionItem:ie})}}class Y{constructor(){this._onDidShowCompletionItemEmitter=new u.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get($){let K=Y.map.get($);return K||(K=new Y,Y.map.set($,K)),K}fireOnDidShowCompletionItem($){this._onDidShowCompletionItemEmitter.fire($)}}e.InlineCompletionController=Y,Y.map=new WeakMap;class V{constructor($,K){this._documents=$,this._provider=K,this._cache=new w.Cache("SignatureHelp")}provideSignatureHelp($,K,ie,se){const q=this._documents.getDocument($),oe=S.Position.to(K),fe=this.reviveContext(ie);return k.asPromise(()=>this._provider.provideSignatureHelp(q,oe,se,fe)).then(Re=>{if(Re){const xe=this._cache.add([Re]);return Object.assign(Object.assign({},S.SignatureHelp.from(Re)),{id:xe})}})}reviveContext($){let K;if($.activeSignatureHelp){const ie=S.SignatureHelp.to($.activeSignatureHelp),se=this._cache.get($.activeSignatureHelp.id,0);se?(K=se,K.activeSignature=ie.activeSignature,K.activeParameter=ie.activeParameter):K=ie}return Object.assign(Object.assign({},$),{activeSignatureHelp:K})}releaseSignatureHelp($){this._cache.delete($)}}class ce{constructor($,K){this._documents=$,this._provider=K}provideInlayHints($,K,ie){const se=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideInlayHints(se,S.Range.to(K),ie)).then(q=>q?{hints:q.map(S.InlayHint.from)}:void 0)}}class ge{constructor($,K){this._documents=$,this._provider=K,this._cache=new w.Cache("DocumentLink")}async provideLinks($,K){const ie=this._documents.getDocument($),se=await k.asPromise(()=>this._provider.provideDocumentLinks(ie,K));if(!(!Array.isArray(se)||se.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.filter(ge._validateLink).map(S.DocumentLink.from)};{const q=this._cache.add(se),oe={links:[],id:q};for(let fe=0;fe<se.length;fe++){if(!ge._validateLink(se[fe]))continue;const Re=S.DocumentLink.from(se[fe]);Re.cacheId=[q,fe],oe.links.push(Re)}return oe}}}static _validateLink($){return $.target&&$.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink($,K){if(typeof this._provider.resolveDocumentLink!="function")return;const ie=this._cache.get(...$);if(!ie)return;const se=await k.asPromise(()=>this._provider.resolveDocumentLink(ie,K));if(!(!se||!ge._validateLink(se)))return S.DocumentLink.from(se)}releaseLinks($){this._cache.delete($)}}class Ae{constructor($,K){this._documents=$,this._provider=K}provideColors($,K){const ie=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideDocumentColors(ie,K)).then(se=>Array.isArray(se)?se.map(oe=>({color:S.Color.from(oe.color),range:S.Range.from(oe.range)})):[])}provideColorPresentations($,K,ie){const se=this._documents.getDocument($),q=S.Range.to(K.range),oe=S.Color.to(K.color);return k.asPromise(()=>this._provider.provideColorPresentations(oe,{document:se,range:q},ie)).then(fe=>{if(!!Array.isArray(fe))return fe.map(S.ColorPresentation.from)})}}class $e{constructor($,K){this._documents=$,this._provider=K}provideFoldingRanges($,K,ie){const se=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideFoldingRanges(se,K,ie)).then(q=>{if(!!Array.isArray(q))return q.map(S.FoldingRange.from)})}}class Fe{constructor($,K,ie){this._documents=$,this._provider=K,this._logService=ie}provideSelectionRanges($,K,ie){const se=this._documents.getDocument($),q=K.map(S.Position.to);return k.asPromise(()=>this._provider.provideSelectionRanges(se,q,ie)).then(oe=>{if(!n.isNonEmptyArray(oe))return[];if(oe.length!==q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const fe=[];for(let Re=0;Re<q.length;Re++){const xe=[];fe.push(xe);let pe=q[Re],qe=oe[Re];for(;;){if(!qe.range.contains(pe))throw new Error("INVALID selection range, must contain the previous range");if(xe.push(S.SelectionRange.from(qe)),!qe.parent)break;pe=qe.range,qe=qe.parent}}return fe})}}class Ve{constructor($,K){this._documents=$,this._provider=K,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession($,K,ie){const se=this._documents.getDocument($),q=S.Position.to(K),oe=await this._provider.prepareCallHierarchy(se,q,ie);if(!oe)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(oe)?oe.map(Re=>this._cacheAndConvertItem(fe,Re)):[this._cacheAndConvertItem(fe,oe)]}async provideCallsTo($,K,ie){const se=this._itemFromCache($,K);if(!se)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyIncomingCalls(se,ie);if(!!q)return q.map(oe=>({from:this._cacheAndConvertItem($,oe.from),fromRanges:oe.fromRanges.map(fe=>S.Range.from(fe))}))}async provideCallsFrom($,K,ie){const se=this._itemFromCache($,K);if(!se)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyOutgoingCalls(se,ie);if(!!q)return q.map(oe=>({to:this._cacheAndConvertItem($,oe.to),fromRanges:oe.fromRanges.map(fe=>S.Range.from(fe))}))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,K){var ie;const se=this._cache.get($),q={_sessionId:$,_itemId:se.size.toString(36),name:K.name,detail:K.detail,kind:S.SymbolKind.from(K.kind),uri:K.uri,range:S.Range.from(K.range),selectionRange:S.Range.from(K.selectionRange),tags:(ie=K.tags)===null||ie===void 0?void 0:ie.map(S.SymbolTag.from)};return se.set(q._itemId,K),q}_itemFromCache($,K){const ie=this._cache.get($);return ie==null?void 0:ie.get(K)}}class tt{constructor($,K){this.adapter=$,this.extension=K}}class Ke{constructor($,K,ie,se,q,oe,fe){this._adapter=new Map,this._uriTransformer=K,this._proxy=$.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=ie,this._commands=se,this._diagnostics=q,this._logService=oe,this._apiDeprecation=fe}_transformDocumentSelector($){return n.coalesce(n.asArray($).map(K=>this._doTransformDocumentSelector(K)))}_doTransformDocumentSelector($){if(typeof $=="string")return{$serialized:!0,language:$};if($)return{$serialized:!0,language:$.language,scheme:this._transformScheme($.scheme),pattern:typeof $.pattern=="undefined"?void 0:S.GlobPattern.from($.pattern),exclusive:$.exclusive}}_transformScheme($){return this._uriTransformer&&typeof $=="string"?this._uriTransformer.transformOutgoingScheme($):$}_createDisposable($){return new y.Disposable(()=>{this._adapter.delete($),this._proxy.$unregister($)})}_nextHandle(){return Ke._handlePool++}_withAdapter($,K,ie,se,q=!1){const oe=this._adapter.get($);if(!oe)return Promise.resolve(se);if(oe.adapter instanceof K){let fe;oe.extension&&(fe=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${K.name}'`));const Re=ie(oe.adapter,oe.extension),xe=oe.extension;return xe&&Promise.resolve(Re).then(()=>this._logService.trace(`[${xe.identifier.value}] provider DONE after ${Date.now()-fe}ms`),pe=>{q&&pe instanceof E.CancellationError||(this._logService.error(`[${xe.identifier.value}] provider FAILED`),this._logService.error(pe))}),Re}return Promise.reject(new Error("no adapter found"))}_addNewAdapter($,K){const ie=this._nextHandle();return this._adapter.set(ie,new tt($,K)),ie}static _extLabel($){return $.displayName||$.name}registerDocumentSymbolProvider($,K,ie,se){const q=this._addNewAdapter(new h(this._documents,ie),$),oe=se&&se.label||Ke._extLabel($);return this._proxy.$registerDocumentSymbolProvider(q,this._transformDocumentSelector(K),oe),this._createDisposable(q)}$provideDocumentSymbols($,K,ie){return this._withAdapter($,h,se=>se.provideDocumentSymbols(m.URI.revive(K),ie),void 0)}registerCodeLensProvider($,K,ie){const se=this._nextHandle(),q=typeof ie.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new tt(new g(this._documents,this._commands.converter,ie),$)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(K),q);let oe=this._createDisposable(se);if(q!==void 0){const fe=ie.onDidChangeCodeLenses(Re=>this._proxy.$emitCodeLensEvent(q));oe=y.Disposable.from(oe,fe)}return oe}$provideCodeLenses($,K,ie){return this._withAdapter($,g,se=>se.provideCodeLenses(m.URI.revive(K),ie),void 0)}$resolveCodeLens($,K,ie){return this._withAdapter($,g,se=>se.resolveCodeLens(K,ie),void 0)}$releaseCodeLenses($,K){this._withAdapter($,g,ie=>Promise.resolve(ie.releaseCodeLenses(K)),void 0)}registerDefinitionProvider($,K,ie){const se=this._addNewAdapter(new i(this._documents,ie),$);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDefinition($,K,ie,se){return this._withAdapter($,i,q=>q.provideDefinition(m.URI.revive(K),ie,se),[])}registerDeclarationProvider($,K,ie){const se=this._addNewAdapter(new s(this._documents,ie),$);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDeclaration($,K,ie,se){return this._withAdapter($,s,q=>q.provideDeclaration(m.URI.revive(K),ie,se),[])}registerImplementationProvider($,K,ie){const se=this._addNewAdapter(new r(this._documents,ie),$);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideImplementation($,K,ie,se){return this._withAdapter($,r,q=>q.provideImplementation(m.URI.revive(K),ie,se),[])}registerTypeDefinitionProvider($,K,ie){const se=this._addNewAdapter(new l(this._documents,ie),$);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideTypeDefinition($,K,ie,se){return this._withAdapter($,l,q=>q.provideTypeDefinition(m.URI.revive(K),ie,se),[])}registerHoverProvider($,K,ie,se){const q=this._addNewAdapter(new _(this._documents,ie),$);return this._proxy.$registerHoverProvider(q,this._transformDocumentSelector(K)),this._createDisposable(q)}$provideHover($,K,ie,se){return this._withAdapter($,_,q=>q.provideHover(m.URI.revive(K),ie,se),void 0)}registerEvaluatableExpressionProvider($,K,ie,se){const q=this._addNewAdapter(new p(this._documents,ie),$);return this._proxy.$registerEvaluatableExpressionProvider(q,this._transformDocumentSelector(K)),this._createDisposable(q)}$provideEvaluatableExpression($,K,ie,se){return this._withAdapter($,p,q=>q.provideEvaluatableExpression(m.URI.revive(K),ie,se),void 0)}registerInlineValuesProvider($,K,ie,se){const q=typeof ie.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new P(this._documents,ie),$);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(K),q);let fe=this._createDisposable(oe);if(q!==void 0){const Re=ie.onDidChangeInlineValues(xe=>this._proxy.$emitInlineValuesEvent(q));fe=y.Disposable.from(fe,Re)}return fe}$provideInlineValues($,K,ie,se,q){return this._withAdapter($,P,oe=>oe.provideInlineValues(m.URI.revive(K),ie,se,q),void 0)}registerDocumentHighlightProvider($,K,ie){const se=this._addNewAdapter(new A(this._documents,ie),$);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDocumentHighlights($,K,ie,se){return this._withAdapter($,A,q=>q.provideDocumentHighlights(m.URI.revive(K),ie,se),void 0)}registerLinkedEditingRangeProvider($,K,ie){const se=this._addNewAdapter(new a(this._documents,ie),$);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideLinkedEditingRanges($,K,ie,se){return this._withAdapter($,a,async q=>{const oe=await q.provideLinkedEditingRanges(m.URI.revive(K),ie,se);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?Ke._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider($,K,ie){const se=this._addNewAdapter(new R(this._documents,ie),$);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideReferences($,K,ie,se,q){return this._withAdapter($,R,oe=>oe.provideReferences(m.URI.revive(K),ie,se,q),void 0)}registerCodeActionProvider($,K,ie,se){var q,oe;const fe=new f.DisposableStore,Re=this._addNewAdapter(new F(this._documents,this._commands.converter,this._diagnostics,ie,this._logService,$,this._apiDeprecation),$);return this._proxy.$registerQuickFixSupport(Re,this._transformDocumentSelector(K),{providedKinds:(q=se==null?void 0:se.providedCodeActionKinds)===null||q===void 0?void 0:q.map(xe=>xe.value),documentation:(oe=se==null?void 0:se.documentation)===null||oe===void 0?void 0:oe.map(xe=>({kind:xe.kind.value,command:this._commands.converter.toInternal(xe.command,fe)}))},Ke._extLabel($),Boolean(ie.resolveCodeAction)),fe.add(this._createDisposable(Re)),fe}$provideCodeActions($,K,ie,se,q){return this._withAdapter($,F,oe=>oe.provideCodeActions(m.URI.revive(K),ie,se,q),void 0)}$resolveCodeAction($,K,ie){return this._withAdapter($,F,se=>se.resolveCodeAction(K,ie),void 0)}$releaseCodeActions($,K){this._withAdapter($,F,ie=>Promise.resolve(ie.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider($,K,ie){const se=this._addNewAdapter(new x(this._documents,ie),$);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(K),$.identifier,$.displayName||$.name),this._createDisposable(se)}$provideDocumentFormattingEdits($,K,ie,se){return this._withAdapter($,x,q=>q.provideDocumentFormattingEdits(m.URI.revive(K),ie,se),void 0)}registerDocumentRangeFormattingEditProvider($,K,ie){const se=this._addNewAdapter(new J(this._documents,ie),$);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(K),$.identifier,$.displayName||$.name),this._createDisposable(se)}$provideDocumentRangeFormattingEdits($,K,ie,se,q){return this._withAdapter($,J,oe=>oe.provideDocumentRangeFormattingEdits(m.URI.revive(K),ie,se,q),void 0)}registerOnTypeFormattingEditProvider($,K,ie,se){const q=this._addNewAdapter(new ae(this._documents,ie),$);return this._proxy.$registerOnTypeFormattingSupport(q,this._transformDocumentSelector(K),se,$.identifier),this._createDisposable(q)}$provideOnTypeFormattingEdits($,K,ie,se,q,oe){return this._withAdapter($,ae,fe=>fe.provideOnTypeFormattingEdits(m.URI.revive(K),ie,se,q,oe),void 0)}registerWorkspaceSymbolProvider($,K){const ie=this._addNewAdapter(new j(K,this._logService),$);return this._proxy.$registerNavigateTypeSupport(ie),this._createDisposable(ie)}$provideWorkspaceSymbols($,K,ie){return this._withAdapter($,j,se=>se.provideWorkspaceSymbols(K,ie),{symbols:[]})}$resolveWorkspaceSymbol($,K,ie){return this._withAdapter($,j,se=>se.resolveWorkspaceSymbol(K,ie),void 0)}$releaseWorkspaceSymbols($,K){this._withAdapter($,j,ie=>ie.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider($,K,ie){const se=this._addNewAdapter(new W(this._documents,ie,this._logService),$);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(K),W.supportsResolving(ie)),this._createDisposable(se)}$provideRenameEdits($,K,ie,se,q){return this._withAdapter($,W,oe=>oe.provideRenameEdits(m.URI.revive(K),ie,se,q),void 0)}$resolveRenameLocation($,K,ie,se){return this._withAdapter($,W,q=>q.resolveRenameLocation(m.URI.revive(K),ie,se),void 0)}registerDocumentSemanticTokensProvider($,K,ie,se){const q=this._nextHandle(),oe=typeof ie.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(q,new tt(new M(this._documents,ie),$)),this._proxy.$registerDocumentSemanticTokensProvider(q,this._transformDocumentSelector(K),se,oe);let fe=this._createDisposable(q);if(oe){const Re=ie.onDidChangeSemanticTokens(xe=>this._proxy.$emitDocumentSemanticTokensEvent(oe));fe=y.Disposable.from(fe,Re)}return fe}$provideDocumentSemanticTokens($,K,ie,se){return this._withAdapter($,M,q=>q.provideDocumentSemanticTokens(m.URI.revive(K),ie,se),null,!0)}$releaseDocumentSemanticTokens($,K){this._withAdapter($,M,ie=>ie.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider($,K,ie,se){const q=this._addNewAdapter(new X(this._documents,ie),$);return this._proxy.$registerDocumentRangeSemanticTokensProvider(q,this._transformDocumentSelector(K),se),this._createDisposable(q)}$provideDocumentRangeSemanticTokens($,K,ie,se){return this._withAdapter($,X,q=>q.provideDocumentRangeSemanticTokens(m.URI.revive(K),ie,se),null,!0)}registerCompletionItemProvider($,K,ie,se){const q=this._addNewAdapter(new B(this._documents,this._commands.converter,ie,this._apiDeprecation,$),$);return this._proxy.$registerSuggestSupport(q,this._transformDocumentSelector(K),se,B.supportsResolving(ie),`${$.identifier.value}(${se.join("")})`),this._createDisposable(q)}$provideCompletionItems($,K,ie,se,q){return this._withAdapter($,B,oe=>oe.provideCompletionItems(m.URI.revive(K),ie,se,q),void 0)}$resolveCompletionItem($,K,ie){return this._withAdapter($,B,se=>se.resolveCompletionItem(K,ie),void 0)}$releaseCompletionItems($,K){this._withAdapter($,B,ie=>ie.releaseCompletionItems(K),void 0)}registerInlineCompletionsProvider($,K,ie){const se=this._addNewAdapter(new U(this._documents,ie,this._commands.converter),$);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideInlineCompletions($,K,ie,se,q){return this._withAdapter($,U,oe=>oe.provideInlineCompletions(m.URI.revive(K),ie,se,q),void 0)}$handleInlineCompletionDidShow($,K,ie){this._withAdapter($,U,async se=>{se.handleDidShowCompletionItem(K,ie)},void 0)}$freeInlineCompletionsList($,K){this._withAdapter($,U,async ie=>{ie.disposeCompletions(K)},void 0)}registerSignatureHelpProvider($,K,ie,se){const q=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,oe=this._addNewAdapter(new V(this._documents,ie),$);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(K),q),this._createDisposable(oe)}$provideSignatureHelp($,K,ie,se,q){return this._withAdapter($,V,oe=>oe.provideSignatureHelp(m.URI.revive(K),ie,se,q),void 0)}$releaseSignatureHelp($,K){this._withAdapter($,V,ie=>ie.releaseSignatureHelp(K),void 0)}registerInlayHintsProvider($,K,ie){const se=typeof ie.onDidChangeInlayHints=="function"?this._nextHandle():void 0,q=this._addNewAdapter(new ce(this._documents,ie),$);this._proxy.$registerInlayHintsProvider(q,this._transformDocumentSelector(K),se);let oe=this._createDisposable(q);if(se!==void 0){const fe=ie.onDidChangeInlayHints(Re=>this._proxy.$emitInlayHintsEvent(se));oe=y.Disposable.from(oe,fe)}return oe}$provideInlayHints($,K,ie,se){return this._withAdapter($,ce,q=>q.provideInlayHints(m.URI.revive(K),ie,se),void 0)}registerDocumentLinkProvider($,K,ie){const se=this._addNewAdapter(new ge(this._documents,ie),$);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(K),typeof ie.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks($,K,ie){return this._withAdapter($,ge,se=>se.provideLinks(m.URI.revive(K),ie),void 0)}$resolveDocumentLink($,K,ie){return this._withAdapter($,ge,se=>se.resolveLink(K,ie),void 0)}$releaseDocumentLinks($,K){this._withAdapter($,ge,ie=>ie.releaseLinks(K),void 0)}registerColorProvider($,K,ie){const se=this._addNewAdapter(new Ae(this._documents,ie),$);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDocumentColors($,K,ie){return this._withAdapter($,Ae,se=>se.provideColors(m.URI.revive(K),ie),[])}$provideColorPresentations($,K,ie,se){return this._withAdapter($,Ae,q=>q.provideColorPresentations(m.URI.revive(K),ie,se),void 0)}registerFoldingRangeProvider($,K,ie){const se=this._nextHandle(),q=typeof ie.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new tt(new $e(this._documents,ie),$)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(K),q);let oe=this._createDisposable(se);if(q!==void 0){const fe=ie.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(q));oe=y.Disposable.from(oe,fe)}return oe}$provideFoldingRanges($,K,ie,se){return this._withAdapter($,$e,q=>q.provideFoldingRanges(m.URI.revive(K),ie,se),void 0)}registerSelectionRangeProvider($,K,ie){const se=this._addNewAdapter(new Fe(this._documents,ie,this._logService),$);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideSelectionRanges($,K,ie,se){return this._withAdapter($,Fe,q=>q.provideSelectionRanges(m.URI.revive(K),ie,se),[])}registerCallHierarchyProvider($,K,ie){const se=this._addNewAdapter(new Ve(this._documents,ie),$);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$prepareCallHierarchy($,K,ie,se){return this._withAdapter($,Ve,q=>Promise.resolve(q.prepareSession(m.URI.revive(K),ie,se)),void 0)}$provideCallHierarchyIncomingCalls($,K,ie,se){return this._withAdapter($,Ve,q=>q.provideCallsTo(K,ie,se),void 0)}$provideCallHierarchyOutgoingCalls($,K,ie,se){return this._withAdapter($,Ve,q=>q.provideCallsFrom(K,ie,se),void 0)}$releaseCallHierarchy($,K){this._withAdapter($,Ve,ie=>Promise.resolve(ie.releaseSession(K)),void 0)}static _serializeRegExp($){return{pattern:$.source,flags:b.regExpFlags($)}}static _serializeIndentationRule($){return{decreaseIndentPattern:Ke._serializeRegExp($.decreaseIndentPattern),increaseIndentPattern:Ke._serializeRegExp($.increaseIndentPattern),indentNextLinePattern:$.indentNextLinePattern?Ke._serializeRegExp($.indentNextLinePattern):void 0,unIndentedLinePattern:$.unIndentedLinePattern?Ke._serializeRegExp($.unIndentedLinePattern):void 0}}static _serializeOnEnterRule($){return{beforeText:Ke._serializeRegExp($.beforeText),afterText:$.afterText?Ke._serializeRegExp($.afterText):void 0,previousLineText:$.previousLineText?Ke._serializeRegExp($.previousLineText):void 0,action:$.action}}static _serializeOnEnterRules($){return $.map(Ke._serializeOnEnterRule)}setLanguageConfiguration($,K,ie){let{wordPattern:se}=ie;if(se&&b.regExpLeadsToEndlessLoop(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(K,se):this._documents.setWordDefinitionFor(K,void 0),ie.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",$,"Do not use."),ie.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",$,"Do not use.");const q=this._nextHandle(),oe={comments:ie.comments,brackets:ie.brackets,wordPattern:ie.wordPattern?Ke._serializeRegExp(ie.wordPattern):void 0,indentationRules:ie.indentationRules?Ke._serializeIndentationRule(ie.indentationRules):void 0,onEnterRules:ie.onEnterRules?Ke._serializeOnEnterRules(ie.onEnterRules):void 0,__electricCharacterSupport:ie.__electricCharacterSupport,__characterPairSupport:ie.__characterPairSupport};return this._proxy.$setLanguageConfiguration(q,K,oe),this._createDisposable(q)}$setWordDefinitions($){for(const K of $)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=Ke,Ke._handlePool=0}),define(we[190],_e([0,1,4,9,6]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(D,b){this._proxy=D.getProxy(m.MainContext.MainThreadLanguages),this._documents=b}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(D,b){await this._proxy.$changeLanguage(D,b);const C=this._documents.getDocumentData(D);if(!C)throw new Error(`document '${D.toString}' NOT found`);return C.document}async tokenAtPosition(D,b){var C;const n=D.version,I=T.Position.from(b),o=await this._proxy.$tokensAtPosition(D.uri,I),f={type:S.StandardTokenType.Other,range:(C=D.getWordRangeAtPosition(b))!==null&&C!==void 0?C:new S.Range(b.line,b.character,b.line,b.character)};if(!o)return f;const c={range:T.Range.to(o.range),type:T.TokenType.to(o.type)};return!c.range.contains(b)||n!==D.version?f:c}}e.ExtHostLanguages=y}),define(we[191],_e([0,1,4,16,29]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function y(D){return D&&D.title}let k=class{constructor(b,C){this._logService=C,this._proxy=b.getProxy(m.MainContext.MainThreadMessageService)}showMessage(b,C,n,I,o){const f={extension:b};let c;typeof I=="string"||y(I)?c=[I,...o]:(f.modal=I==null?void 0:I.modal,f.useCustom=I==null?void 0:I.useCustom,f.detail=I==null?void 0:I.detail,c=o),f.useCustom&&S.checkProposedApiEnabled(b);const d=[];for(let w=0;w<c.length;w++){const v=c[w];if(typeof v=="string")d.push({title:v,handle:w,isCloseAffordance:!1});else if(typeof v=="object"){let{title:E,isCloseAffordance:u}=v;d.push({title:E,isCloseAffordance:!!u,handle:w})}else this._logService.warn("Invalid message item:",v)}return this._proxy.$showMessage(C,n,f,d).then(w=>{if(typeof w=="number")return c[w]})}};k=He([ze(1,T.ILogService)],k),e.ExtHostMessageService=k}),define(we[192],_e([0,1,23,3,53,7,22,8,10,2,62,4,9,6,169,97]),function(ee,e,m,T,S,y,k,D,b,C,n,I,o,f,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class w{constructor(E,u,h,g,t){this._textDocumentsAndEditors=h,this._textDocuments=g,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new T.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new T.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new T.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new T.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new T.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new T.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=E.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=E.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=E.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=u.converter,u.registerArgumentProcessor({processArgument:i=>{var s;if(i&&i.$mid===12){const r=(s=i.notebookEditor)===null||s===void 0?void 0:s.notebookUri,l=i.cell.handle,_=this._documents.get(r),p=_==null?void 0:_.getCell(l);if(p)return p.apiCell}return i}})}get activeNotebookEditor(){var E;return(E=this._activeNotebookEditor)===null||E===void 0?void 0:E.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(E=>E.apiEditor)}getEditorById(E){const u=this._editors.get(E);if(!u)throw new Error(`unknown text editor: ${E}. known editors: ${[...this._editors.keys()]} `);return u}getIdByEditor(E){for(const[u,h]of this._editors)if(h.apiEditor===E)return u}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(E,u){const h=this._documents.get(E);if(!h&&!u)throw new Error(`NO notebook document for '${E}'`);return h}_getProviderData(E){const u=this._notebookContentProviders.get(E);if(!u)throw new Error(`NO provider for '${E}'`);return u}registerNotebookContentProvider(E,u,h,g,t){if(D.isFalsyOrWhitespace(u))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(u))throw new Error(`Notebook provider for '${u}' already registered`);this._notebookContentProviders.set(u,{extension:E,provider:h});let i;return h.onDidChangeNotebookContentOptions&&(i=h.onDidChangeNotebookContentOptions(()=>{const s=o.NotebookDocumentContentOptions.from(h.options);this._notebookProxy.$updateNotebookProviderOptions(u,s)})),this._notebookProxy.$registerNotebookProvider({id:E.identifier,location:E.extensionLocation},u,o.NotebookDocumentContentOptions.from(g),w._convertNotebookRegistrationData(E,t)),new f.Disposable(()=>{i==null||i.dispose(),this._notebookContentProviders.delete(u),this._notebookProxy.$unregisterNotebookProvider(u)})}static _convertNotebookRegistrationData(E,u){if(!u)return;const h=u.filenamePattern.map(g=>o.NotebookExclusiveDocumentPattern.from(g)).filter(g=>g!==void 0);if(u.filenamePattern&&!h){console.warn(`Notebook content provider view options file name pattern is invalid ${u.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:u.displayName,filenamePattern:h,exclusive:u.exclusive||!1}}registerNotebookCellStatusBarItemProvider(E,u,h){const g=w._notebookStatusBarItemProviderHandlePool++,t=typeof h.onDidChangeCellStatusBarItems=="function"?w._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(g,h),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(g,t,u);let i;return t!==void 0&&(i=h.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(t))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(g),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(g,t),i&&i.dispose()})}async createNotebookDocument(E){const u=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:E.viewType,content:E.content&&o.NotebookData.from(E.content)});return C.URI.revive(u)}async openNotebookDocument(E){const u=this._documents.get(E);if(u)return u.apiNotebook;const h=await this._notebookDocumentsProxy.$tryOpenNotebook(E),g=this._documents.get(C.URI.revive(h));return b.assertIsDefined(g==null?void 0:g.apiNotebook)}async showNotebookDocument(E,u){var h;C.URI.isUri(E)&&(E=await this.openNotebookDocument(E));let g;typeof u=="object"?g={position:o.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selections:u.selections&&u.selections.map(o.NotebookRange.from),pinned:typeof u.preview=="boolean"?!u.preview:void 0}:g={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(E.uri,E.notebookType,g),i=t&&((h=this._editors.get(t))===null||h===void 0?void 0:h.apiEditor);if(i)return i;throw t?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,u,h,g){const t=this._notebookStatusBarItemProviders.get(E),i=C.URI.revive(u),s=this._documents.get(i);if(!s||!t)return;const r=s.getCellFromIndex(h);if(!r)return;const l=await t.provideCellStatusBarItems(r.apiCell,g);if(!l)return;const _=new y.DisposableStore,p=this._statusBarCache.add([_]),A=(Array.isArray(l)?l:[l]).map(a=>o.NotebookStatusBarItem.from(a,this._commandsConverter,_));return{cacheId:p,items:A}}$releaseNotebookCellStatusBarItems(E){this._statusBarCache.delete(E)}registerNotebookSerializer(E,u,h,g,t){if(D.isFalsyOrWhitespace(u))throw new Error("viewType cannot be empty or just whitespace");const i=this._handlePool++;return this._notebookSerializer.set(i,h),this._notebookProxy.$registerNotebookSerializer(i,{id:E.identifier,location:E.extensionLocation},u,o.NotebookDocumentContentOptions.from(g),w._convertNotebookRegistrationData(E,t)),y.toDisposable(()=>{this._notebookProxy.$unregisterNotebookSerializer(i)})}async $dataToNotebook(E,u,h){const g=this._notebookSerializer.get(E);if(!g)throw new Error("NO serializer found");const t=await g.deserializeNotebook(u.buffer,h);return o.NotebookData.from(t)}async $notebookToData(E,u,h){const g=this._notebookSerializer.get(E);if(!g)throw new Error("NO serializer found");const t=await g.serializeNotebook(o.NotebookData.to(u),h);return m.VSBuffer.wrap(t)}async $openNotebook(E,u,h,g,t){var i;const{provider:s}=this._getProviderData(E),r=await s.openNotebook(C.URI.revive(u),{backupId:h,untitledDocumentData:g==null?void 0:g.buffer},t);return{metadata:(i=r.metadata)!==null&&i!==void 0?i:Object.create(null),cells:r.cells.map(o.NotebookCellData.from)}}async $saveNotebook(E,u,h){const g=this.getNotebookDocument(C.URI.revive(u)),{provider:t}=this._getProviderData(E);return await t.saveNotebook(g.apiNotebook,h),!0}async $saveNotebookAs(E,u,h,g){const t=this.getNotebookDocument(C.URI.revive(u)),{provider:i}=this._getProviderData(E);return await i.saveNotebookAs(C.URI.revive(h),t.apiNotebook,g),!0}async $backupNotebook(E,u,h){var g;const t=this.getNotebookDocument(C.URI.revive(u)),i=this._getProviderData(E),s=(g=this._extensionStoragePaths.workspaceValue(i.extension))!==null&&g!==void 0?g:this._extensionStoragePaths.globalValue(i.extension),r=String(S.hash([t.uri.toString(),this._backupIdPool++])),l=C.URI.joinPath(s,r),_=await i.provider.backupNotebook(t.apiNotebook,{destination:l},h);return t.updateBackup(_),_.id}_createExtHostEditor(E,u,h){if(this._editors.has(u))throw new Error(`editor with id ALREADY EXSIST: ${u}`);const g=new d.ExtHostNotebookEditor(u,this._notebookEditorsProxy,E,h.visibleRanges.map(o.NotebookRange.to),h.selections.map(o.NotebookRange.to),typeof h.viewColumn=="number"?o.ViewColumn.to(h.viewColumn):void 0);this._editors.set(u,g)}$acceptDocumentAndEditorsDelta(E){var u,h,g;if(E.removedDocuments)for(const i of E.removedDocuments){const s=C.URI.revive(i),r=this._documents.get(s);r&&(r.dispose(),this._documents.delete(s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(l=>l.document.uri)}),this._onDidCloseNotebookDocument.fire(r.apiNotebook));for(const l of this._editors.values())l.notebookData.uri.toString()===s.toString()&&this._editors.delete(l.id)}if(E.addedDocuments){const i=[];for(const s of E.addedDocuments){const r=C.URI.revive(s.uri);if(this._documents.has(r))throw new Error(`adding EXISTING notebook ${r} `);const l=this,_=new c.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(p){l._onDidChangeNotebookCells.fire(p)},emitCellOutputsChange(p){l._onDidChangeCellOutputs.fire(p)},emitCellMetadataChange(p){l._onDidChangeCellMetadata.fire(p)},emitCellExecutionStateChange(p){l._onDidChangeCellExecutionState.fire(p)}},r,s);i.push(...s.cells.map(p=>c.ExtHostCell.asModelAddData(_.apiNotebook,p))),(u=this._documents.get(r))===null||u===void 0||u.dispose(),this._documents.set(r,_),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:i}),this._onDidOpenNotebookDocument.fire(_.apiNotebook)}}if(E.addedEditors)for(const i of E.addedEditors){if(this._editors.has(i.id))return;const s=C.URI.revive(i.documentUri),r=this._documents.get(s);r&&this._createExtHostEditor(r,i.id,i)}const t=[];if(E.removedEditors)for(const i of E.removedEditors){const s=this._editors.get(i);s&&(this._editors.delete(i),((h=this._activeNotebookEditor)===null||h===void 0?void 0:h.id)===s.id&&(this._activeNotebookEditor=void 0),t.push(s))}if(E.visibleEditors){this._visibleNotebookEditors=E.visibleEditors.map(s=>this._editors.get(s)).filter(s=>!!s);const i=new Set;this._visibleNotebookEditors.forEach(s=>i.add(s.id));for(const s of this._editors.values()){const r=i.has(s.id);s._acceptVisibility(r)}this._visibleNotebookEditors=[...this._editors.values()].map(s=>s).filter(s=>s.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}E.newActiveEditor===null?this._activeNotebookEditor=void 0:E.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(E.newActiveEditor)),E.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((g=this._activeNotebookEditor)===null||g===void 0?void 0:g.apiEditor)}}e.ExtHostNotebookController=w,w._notebookStatusBarItemProviderHandlePool=0}),define(we[193],_e([0,1,3,50,16,4,14,9]),function(ee,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class b{constructor(I,o){const f=b._Keys.nextId();I.$registerNotebookEditorDecorationType(f,D.NotebookDecorationRenderOptions.from(o)),this.value={key:f,dispose(){I.$removeNotebookEditorDecorationType(f)}}}}b._Keys=new T.IdGenerator("NotebookEditorDecorationType");let C=class{constructor(I,o,f){this._logService=I,this._extHostRpc=o,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new m.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new m.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new b(this._extHostRpc.getProxy(y.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,o){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,o);const f=this._notebooksAndEditors.getEditorById(I);o.visibleRanges&&f._acceptVisibleRanges(o.visibleRanges.ranges.map(D.NotebookRange.to)),o.selections&&f._acceptSelections(o.selections.selections.map(D.NotebookRange.to)),o.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:f.apiEditor,visibleRanges:f.apiEditor.visibleRanges}),o.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:f.apiEditor,selections:f.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const o in I)this._notebooksAndEditors.getEditorById(o)._acceptViewColumn(D.ViewColumn.to(I[o]))}};C=He([ze(0,S.ILogService),ze(1,k.IExtHostRpcService)],C),e.ExtHostNotebookEditors=C}),define(we[194],_e([0,1,3,7,4,26,2,9,66,22,13,67,18,17,16,6,29]),function(ee,e,m,T,S,y,k,D,b,C,n,I,o,f,c,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let v=class{constructor(t,i,s,r){this._initData=i,this._extHostNotebook=s,this._logService=r,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(S.MainContext.MainThreadNotebookKernels)}createNotebookController(t,i,s,r,l,_){for(let B of this._kernelData.values())if(B.controller.id===i&&y.ExtensionIdentifier.equals(t.identifier,B.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const p=this._handlePool++,P=this;this._logService.trace(`NotebookController[${p}], CREATED by ${t.identifier.value}, ${i}`);const A=()=>console.warn(`NO execute handler from notebook controller '${J.id}' of extension: '${t.identifier}'`);let a=!1;const R=new T.DisposableStore,F=new m.Emitter,x=new m.Emitter,J={id:`${t.identifier.value}/${i}`,notebookType:s,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:r||t.identifier.value,preloads:_?_.map(D.NotebookRendererScript.from):[]};let ae=l??A,j;this._proxy.$addKernel(p,J).catch(B=>{console.log(B),a=!0});let W=0;const Q=()=>{if(a)return;const B=++W;Promise.resolve().then(()=>{B===W&&this._proxy.$updateKernel(p,J)})},M=new C.ResourceMap,X={get id(){return i},get notebookType(){return J.notebookType},onDidChangeSelectedNotebooks:F.event,get label(){return J.label},set label(B){var U;J.label=(U=B??t.displayName)!==null&&U!==void 0?U:t.name,Q()},get detail(){var B;return(B=J.detail)!==null&&B!==void 0?B:""},set detail(B){J.detail=B,Q()},get description(){var B;return(B=J.description)!==null&&B!==void 0?B:""},set description(B){J.description=B,Q()},get supportedLanguages(){return J.supportedLanguages},set supportedLanguages(B){J.supportedLanguages=B,Q()},get supportsExecutionOrder(){var B;return(B=J.supportsExecutionOrder)!==null&&B!==void 0?B:!1},set supportsExecutionOrder(B){J.supportsExecutionOrder=B,Q()},get rendererScripts(){return J.preloads?J.preloads.map(D.NotebookRendererScript.to):[]},get executeHandler(){return ae},set executeHandler(B){ae=B??A},get interruptHandler(){return j},set interruptHandler(B){j=B,J.supportsInterrupt=Boolean(B),Q()},createNotebookCellExecution(B){if(a)throw new Error("notebook controller is DISPOSED");if(!M.has(B.notebook.uri))throw P._logService.trace(`NotebookController[${p}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(M.keys()).map(U=>U.toString())),new Error(`notebook controller is NOT associated to notebook: ${B.notebook.uri.toString()}`);return P._createNotebookCellExecution(B)},dispose:()=>{a||(this._logService.trace(`NotebookController[${p}], DISPOSED`),a=!0,this._kernelData.delete(p),R.dispose(),F.dispose(),x.dispose(),this._proxy.$removeKernel(p))},updateNotebookAffinity(B,U){P._proxy.$updateNotebookPriority(p,B.uri,U)},onDidReceiveMessage:x.event,postMessage(B,U){return w.checkProposedApiEnabled(t),P._proxy.$postMessage(p,U&&P._extHostNotebook.getIdByEditor(U),B)},asWebviewUri(B){return w.checkProposedApiEnabled(t),b.asWebviewUri(B,P._initData.remote)}};return this._kernelData.set(p,{extensionId:t.identifier,controller:X,onDidReceiveMessage:x,onDidChangeSelection:F,associatedNotebooks:M}),X}$acceptNotebookAssociation(t,i,s){const r=this._kernelData.get(t);if(r){const l=this._extHostNotebook.getNotebookDocument(k.URI.revive(i));s?r.associatedNotebooks.set(l.uri,!0):r.associatedNotebooks.delete(l.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,l.uri.toString(),s),r.onDidChangeSelection.fire({selected:s,notebook:l.apiNotebook})}}async $executeCells(t,i,s){const r=this._kernelData.get(t);if(!r)return;const l=this._extHostNotebook.getNotebookDocument(k.URI.revive(i)),_=[];for(let p of s){const P=l.getCell(p);P&&_.push(P.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,l.uri.toString(),_.length),await r.controller.executeHandler.call(r.controller,_,l.apiNotebook,r.controller)}catch(p){this._logService.error(`NotebookController[${t}] execute cells FAILED`,p),console.error(p)}}async $cancelCells(t,i,s){var r;const l=this._kernelData.get(t);if(!l)return;const _=this._extHostNotebook.getNotebookDocument(k.URI.revive(i));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,_.apiNotebook);else for(let p of s){const P=_.getCell(p);P&&((r=this._activeExecutions.get(P.uri))===null||r===void 0||r.cancel())}}$acceptKernelMessageFromRenderer(t,i,s){const r=this._kernelData.get(t);if(!r)return;const l=this._extHostNotebook.getEditorById(i);r.onDidReceiveMessage.fire(Object.freeze({editor:l.apiEditor,message:s}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const r=new u(s.notebook,s,this._proxy);this._activeExecutions.set(s.uri,r);const l=r.onDidChangeState(()=>{r.state===E.Resolved&&(r.dispose(),l.dispose(),this._activeExecutions.delete(s.uri))});return r.asApiObject()}};v=He([ze(3,c.ILogService)],v),e.ExtHostNotebookKernels=v;var E;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(E||(E={}));class u extends T.Disposable{constructor(t,i,s){super();this._document=t,this._cell=i,this._proxy=s,this._onDidChangeState=new m.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=E.Init,this._tokenSource=this._register(new o.CancellationTokenSource),this._collector=new h(10,r=>this.applyEdits(r)),this._executionOrder=i.internalMetadata.executionOrder,this.mixinMetadata({runState:I.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===E.Init)throw new Error("Must call start before modifying cell output");if(this._state===E.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let i=this._cell;if(t&&(i=this._document.getCellFromApiCell(t)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(t){return t.map(i=>{const s=d.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return s===i.items?D.NotebookCellOutput.from(i):D.NotebookCellOutput.from({items:s,id:i.id,metadata:i.metadata})})}async updateOutputs(t,i,s){const r=this.cellIndexToHandle(i),l=this.validateAndConvertOutputs(f.asArray(t));return this.applyEditSoon({editType:2,handle:r,append:s,outputs:l})}async updateOutputItems(t,i,s){return t=d.NotebookCellOutput.ensureUniqueMimeTypes(f.asArray(t),!0),this.applyEditSoon({editType:7,items:t.map(D.NotebookCellOutputItem.from),outputId:i.id,append:s})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(s){t._executionOrder=s,t.mixinMetadata({executionOrder:s})},start(s){if(t._state===E.Resolved||t._state===E.Started)throw new Error("Cannot call start again");t._state=E.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:I.NotebookCellExecutionState.Executing,runStartTime:s??null})},end(s,r){if(t._state===E.Resolved)throw new Error("Cannot call resolve twice");t._state=E.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:s??null,runEndTime:r??null})},clearOutput(s){return t.verifyStateForOutput(),t.updateOutputs([],s,!1)},appendOutput(s,r){return t.verifyStateForOutput(),t.updateOutputs(s,r,!0)},replaceOutput(s,r){return t.verifyStateForOutput(),t.updateOutputs(s,r,!1)},appendOutputItems(s,r){return t.verifyStateForOutput(),t.updateOutputItems(s,r,!0)},replaceOutputItems(s,r){return t.verifyStateForOutput(),t.updateOutputItems(s,r,!1)}})}}class h{constructor(t,i){this.delay=t,this.callback=i,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=n.timeout(this.delay).then(()=>{this.waitPromise=void 0;const i=this.batch;return this.batch=[],this.callback(i)})),this.waitPromise}}}),define(we[195],_e([0,1,3,4,97]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class y{constructor(D,b){this._extHostNotebook=b,this._rendererMessageEmitters=new Map,this.proxy=D.getProxy(T.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(D,b,C){var n;const I=this._extHostNotebook.getEditorById(D);(n=this._rendererMessageEmitters.get(b))===null||n===void 0||n.fire({editor:I.apiEditor,message:C})}createRendererMessaging(D){return{onDidReceiveMessage:(...C)=>this.getOrCreateEmitterFor(D).event(...C),postMessage:(C,n)=>{const I=S.ExtHostNotebookEditor.apiEditorsToExtHost.get(C);if(!I)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(I.id,D,n)}}}getOrCreateEmitterFor(D){let b=this._rendererMessageEmitters.get(D);return b||(b=new m.Emitter({onLastListenerRemove:()=>{b==null||b.dispose(),this._rendererMessageEmitters.delete(D)}}),this._rendererMessageEmitters.set(D,b),b)}}e.ExtHostNotebookRenderers=y}),define(we[101],_e([0,1,4,3,7,23,5,14]),function(ee,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class b extends S.Disposable{constructor(c,d,w,v){super();this._onDidAppend=this._register(new T.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=c,this._proxy=v,this._id=v.$register(this.name,d,w),this._disposed=!1,this._offset=0}get name(){return this._name}append(c){this.validate(),this._offset+=c?y.VSBuffer.fromString(c).byteLength:0}update(){this._id.then(c=>this._proxy.$update(c))}appendLine(c){this.validate(),this.append(c+`
`)}clear(){this.validate();const c=this._offset;this._id.then(d=>this._proxy.$clear(d,c))}show(c,d){this.validate(),this._id.then(w=>this._proxy.$reveal(w,!!(typeof c=="boolean"?c:d)))}hide(){this.validate(),this._id.then(c=>this._proxy.$close(c))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(c=>this._proxy.$dispose(c)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=b;class C extends b{constructor(c,d){super(c,!1,void 0,d)}append(c){super.append(c),this._id.then(d=>this._proxy.$append(d,c)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=C;class n extends b{constructor(c,d,w){super(c,!0,d,w)}append(c){throw new Error("Not supported")}}class I{constructor(c,d){this.name=c,this._channel=d}append(c){this._channel.then(d=>d.append(c))}appendLine(c){this._channel.then(d=>d.appendLine(c))}clear(){this._channel.then(c=>c.clear())}show(c,d){this._channel.then(w=>w.show(c,d))}hide(){this._channel.then(c=>c.hide())}dispose(){this._channel.then(c=>c.dispose())}}e.LazyOutputChannel=I;let o=class{constructor(c){this._proxy=c.getProxy(m.MainContext.MainThreadOutputService)}$setVisibleChannel(c){}createOutputChannel(c){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");return new C(c,this._proxy)}createOutputChannelFromLogFile(c,d){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");if(!d)throw new Error("illegal argument `file`. must not be falsy");return new n(c,d,this._proxy)}};o=He([ze(0,D.IExtHostRpcService)],o),e.ExtHostOutputService=o,e.IExtHostOutputService=k.createDecorator("IExtHostOutputService")}),define(we[196],_e([0,1,13,18,3,7,4,2,6,11,17,41]),function(ee,e,m,T,S,y,k,D,b,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function o(f,c,d){const w=f.getProxy(k.MainContext.MainThreadQuickOpen);class v{constructor(r,l){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=l}showQuickPick(r,l,_,p=T.CancellationToken.None){this._onDidSelectItem=void 0;const P=Promise.resolve(r),A=++this._instances,a=w.$show(A,{title:_==null?void 0:_.title,placeHolder:_==null?void 0:_.placeHolder,matchOnDescription:_==null?void 0:_.matchOnDescription,matchOnDetail:_==null?void 0:_.matchOnDetail,ignoreFocusLost:_==null?void 0:_.ignoreFocusOut,canPickMany:_==null?void 0:_.canPickMany},p),R={},F=a.then(()=>R);return Promise.race([F,P]).then(x=>{if(x!==R)return P.then(J=>{const ae=[];for(let j=0;j<J.length;j++){const W=J[j];let Q,M,X,B,U;typeof W=="string"?Q=W:(Q=W.label,M=W.description,X=W.detail,B=W.picked,U=W.alwaysShow),ae.push({label:Q,description:M,handle:j,detail:X,picked:B,alwaysShow:U})}return _&&typeof _.onDidSelectItem=="function"&&(this._onDidSelectItem=j=>{_.onDidSelectItem(J[j])}),w.$setItems(A,ae),a.then(j=>{if(typeof j=="number")return J[j];if(Array.isArray(j))return j.map(W=>J[W])})})}).then(void 0,x=>{if(!C.isPromiseCanceledError(x))return w.$setError(A,x),Promise.reject(x)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,l=T.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,w.$input(r,typeof this._validateInput=="function",l).then(void 0,_=>{if(!C.isPromiseCanceledError(_))return Promise.reject(_)})}$validateInput(r){return this._validateInput?m.asPromise(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,l=T.CancellationToken.None){const _=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!_)return;const p=await this._workspace.getWorkspaceFolders2();if(!!p)return p.find(P=>P.uri.toString()===_.uri.toString())}createQuickPick(r,l){const _=new t(r,l,()=>this._sessions.delete(_._id));return this._sessions.set(_._id,_),_}createInputBox(r){const l=new i(r,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(r,l){const _=this._sessions.get(r);_&&_._fireDidChangeValue(l)}$onDidAccept(r){const l=this._sessions.get(r);l&&l._fireDidAccept()}$onDidChangeActive(r,l){const _=this._sessions.get(r);_ instanceof t&&_._fireDidChangeActive(l)}$onDidChangeSelection(r,l){const _=this._sessions.get(r);_ instanceof t&&_._fireDidChangeSelection(l)}$onDidTriggerButton(r,l){const _=this._sessions.get(r);_&&_._fireDidTriggerButton(l)}$onDidHide(r){const l=this._sessions.get(r);l&&l._fireDidHide()}}class E{constructor(r,l){this._extensionId=r,this._onDidDispose=l,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new S.Emitter,this._onDidChangeValueEmitter=new S.Emitter,this._onDidTriggerButtonEmitter=new S.Emitter,this._onDidHideEmitter=new S.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((l,_)=>{const p=l===b.QuickInputButtons.Back?-1:_;this._handlesToButtons.set(p,l)}),this.update({buttons:r.map((l,_)=>({iconPath:u(l.iconPath),tooltip:l.tooltip,handle:l===b.QuickInputButtons.Back?-1:_}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const l=this._handlesToButtons.get(r);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=y.dispose(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),w.$dispose(this._id))}update(r){if(!this._disposed){for(const l of Object.keys(r)){const _=r[l];this._pendingUpdate[l]=_===void 0?null:_}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){w.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}E._nextId=1;function u(s){if(s instanceof b.ThemeIcon)return{id:s.id};const r=g(s),l=h(s);return{dark:typeof r=="string"?D.URI.file(r):r,light:typeof l=="string"?D.URI.file(l):l}}function h(s){return typeof s=="object"&&"light"in s?s.light:s}function g(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends E{constructor(r,l,_){super(r,_);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new S.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new S.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((l,_)=>{this._handlesToItems.set(_,l),this._itemsToHandles.set(l,_)}),this.update({items:r.map((l,_)=>({label:l.label,description:l.description,handle:_,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(r){const l=n.coalesce(r.map(_=>this._handlesToItems.get(_)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(r){const l=n.coalesce(r.map(_=>this._handlesToItems.get(_)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}}class i extends E{constructor(r,l){super(r,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?I.default.Error:I.default.Ignore})}}return new v(c,d)}e.createExtHostQuickOpen=o}),define(we[197],_e([0,1,2,3,48,7,13,4,17,112,16,26,29]),function(ee,e,m,T,S,y,k,D,b,C,n,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(r){if(r)return typeof r.iconPath=="string"?m.URI.file(r.iconPath):r.iconPath}function c(r,l){if(!r.iconPath&&!l.iconPath)return 0;if(r.iconPath){if(!l.iconPath)return 1}else return-1;const _=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath,p=typeof l.iconPath=="string"?l.iconPath:l.iconPath.fsPath;return C.comparePaths(_,p)}function d(r,l){let _=0;if(r.strikeThrough!==l.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==l.faded)return r.faded?1:-1;if(r.tooltip!==l.tooltip)return(r.tooltip||"").localeCompare(l.tooltip||"");if(_=c(r,l),_!==0)return _;if(r.light&&l.light)_=c(r.light,l.light);else{if(r.light)return 1;if(l.light)return-1}if(_!==0)return _;if(r.dark&&l.dark)_=c(r.dark,l.dark);else{if(r.dark)return 1;if(l.dark)return-1}return _}function w(r,l){if(r.command!==l.command)return r.command<l.command?-1:1;if(r.title!==l.title)return r.title<l.title?-1:1;if(r.tooltip!==l.tooltip){if(r.tooltip!==void 0&&l.tooltip!==void 0)return r.tooltip<l.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(l.tooltip!==void 0)return-1}if(r.arguments===l.arguments)return 0;if(r.arguments)if(l.arguments){if(r.arguments.length!==l.arguments.length)return r.arguments.length-l.arguments.length}else return 1;else return-1;for(let _=0;_<r.arguments.length;_++){const p=r.arguments[_],P=l.arguments[_];if(p!==P)return p<P?-1:1}return 0}function v(r,l){let _=C.comparePaths(r.resourceUri.fsPath,l.resourceUri.fsPath,!0);if(_!==0)return _;if(r.command&&l.command)_=w(r.command,l.command);else{if(r.command)return 1;if(l.command)return-1}if(_!==0)return _;if(r.decorations&&l.decorations)_=d(r.decorations,l.decorations);else{if(r.decorations)return 1;if(l.decorations)return-1}return _}function E(r,l){for(let _=0;_<r.length;_++)if(r[_]!==l[_])return!1;return!0}function u(r,l){return r.command===l.command&&r.title===l.title&&r.tooltip===l.tooltip&&(r.arguments&&l.arguments?E(r.arguments,l.arguments):r.arguments===l.arguments)}function h(r,l){return b.equals(r,l,u)}class g{constructor(l,_,p){this._extension=l,this._proxy=_,this._sourceControlHandle=p,this._value="",this._onDidChange=new T.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(l){this._proxy.$setInputBoxValue(this._sourceControlHandle,l),this.updateValue(l)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(l){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,l),this._placeholder=l}get validateInput(){return o.checkProposedApiEnabled(this._extension),this._validateInput}set validateInput(l){if(o.checkProposedApiEnabled(this._extension),l&&typeof l!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=l,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!l)}get visible(){return this._visible}set visible(l){l=!!l,this._visible!==l&&(this._visible=l,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,l))}focus(){o.checkProposedApiEnabled(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(l,_){o.checkProposedApiEnabled(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,l,_)}$onInputBoxValueChange(l){this.updateValue(l)}updateValue(l){this._value=l,this._onDidChange.fire(l)}}e.ExtHostSCMInputBox=g;class t{constructor(l,_,p,P,A){this._proxy=l,this._commands=_,this._sourceControlHandle=p,this._id=P,this._label=A,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new T.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new T.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(l){this._label=l,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,l)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(l){this._hideWhenEmpty=l,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(l){this._resourceStates=[...l],this._onDidUpdateResourceStates.fire()}getResourceState(l){return this._resourceStatesMap.get(l)}$executeResourceCommand(l,_){const p=this._resourceStatesCommandsMap.get(l);return p?k.asPromise(()=>this._commands.executeCommand(p.command,...p.arguments||[],_)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var l;const _=[...this._resourceStates].sort(v),P=b.sortedDiff(this._resourceSnapshot,_,v).map(R=>{const F=R.toInsert.map(x=>{const J=this._resourceHandlePool++;this._resourceStatesMap.set(J,x);const ae=x.resourceUri,j=f(x.decorations),W=x.decorations&&f(x.decorations.light)||j,Q=x.decorations&&f(x.decorations.dark)||j,M=[];let X;if(x.command)if(x.command.command==="vscode.open"||x.command.command==="vscode.diff"){const ge=new y.DisposableStore;X=this._commands.converter.toInternal(x.command,ge),this._resourceStatesDisposablesMap.set(J,ge)}else this._resourceStatesCommandsMap.set(J,x.command);W&&M.push(W),Q&&Q.toString()!==(W==null?void 0:W.toString())&&M.push(Q);const B=x.decorations&&x.decorations.tooltip||"",U=x.decorations&&!!x.decorations.strikeThrough,Y=x.decorations&&!!x.decorations.faded,V=x.contextValue||"";return{rawResource:[J,ae,M,B,U,Y,V,X],handle:J}});return{start:R.start,deleteCount:R.deleteCount,toInsert:F}}),A=P.map(({start:R,deleteCount:F,toInsert:x})=>[R,F,x.map(J=>J.rawResource)]),a=P.reverse();for(const{start:R,deleteCount:F,toInsert:x}of a){const J=x.map(j=>j.handle),ae=this._handlesSnapshot.splice(R,F,...J);for(const j of ae)this._resourceStatesMap.delete(j),this._resourceStatesCommandsMap.delete(j),(l=this._resourceStatesDisposablesMap.get(j))===null||l===void 0||l.dispose(),this._resourceStatesDisposablesMap.delete(j)}return this._resourceSnapshot=_,A}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class i{constructor(l,_,p,P,A,a){this._proxy=_,this._commands=p,this._id=P,this._label=A,this._rootUri=a,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new y.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new T.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new g(l,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,P,A,a)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(l){this._count!==l&&(this._count=l,this._proxy.$updateSourceControl(this.handle,{count:l}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(l){this._quickDiffProvider=l,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!l})}get commitTemplate(){return this._commitTemplate}set commitTemplate(l){l!==this._commitTemplate&&(this._commitTemplate=l,this._proxy.$updateSourceControl(this.handle,{commitTemplate:l}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(l){this._acceptInputDisposables.value=new y.DisposableStore,this._acceptInputCommand=l;const _=this._commands.converter.toInternal(l,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:_})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(l){if(this._statusBarCommands&&l&&h(this._statusBarCommands,l))return;this._statusBarDisposables.value=new y.DisposableStore,this._statusBarCommands=l;const _=(l||[]).map(p=>this._commands.converter.toInternal(p,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:_})}get selected(){return this._selected}createResourceGroup(l,_){const p=new t(this._proxy,this._commands,this.handle,l,_),P=T.Event.once(p.onDidDispose)(()=>this.createdResourceGroups.delete(p));return this.createdResourceGroups.set(p,P),this.eventuallyAddResourceGroups(),p}eventuallyAddResourceGroups(){const l=[],_=[];for(const[p,P]of this.createdResourceGroups){P.dispose();const A=p.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(p),this.eventuallyUpdateResourceStates()});T.Event.once(p.onDidDispose)(()=>{this.updatedResourceGroups.delete(p),A.dispose(),this._groups.delete(p.handle),this._proxy.$unregisterGroup(this.handle,p.handle)}),l.push([p.handle,p.id,p.label,p.features]);const a=p._takeResourceStateSnapshot();a.length>0&&_.push([p.handle,a]),this._groups.set(p.handle,p)}this._proxy.$registerGroups(this.handle,l,_),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const l=[];this.updatedResourceGroups.forEach(_=>{const p=_._takeResourceStateSnapshot();p.length!==0&&l.push([_.handle,p])}),l.length>0&&this._proxy.$spliceResourceStates(this.handle,l),this.updatedResourceGroups.clear()}getResourceGroup(l){return this._groups.get(l)}setSelectionState(l){this._selected=l,this._onDidChangeSelection.fire(l)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(l=>l.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,He([S.debounce(100)],i.prototype,"eventuallyAddResourceGroups",null),He([S.debounce(100)],i.prototype,"eventuallyUpdateResourceStates",null);let s=class On{constructor(l,_,p){this._commands=_,this.logService=p,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new T.Emitter,this._proxy=l.getProxy(D.MainContext.MainThreadSCM),this._telemetry=l.getProxy(D.MainContext.MainThreadTelemetry),_.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===3){const A=this._sourceControls.get(P.sourceControlHandle);if(!A)return P;const a=A.getResourceGroup(P.groupHandle);return a?a.getResourceState(P.handle):P}else if(P&&P.$mid===4){const A=this._sourceControls.get(P.sourceControlHandle);return A?A.getResourceGroup(P.groupHandle):P}else if(P&&P.$mid===5){const A=this._sourceControls.get(P.handle);return A||P}return P}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(l,_,p,P){this.logService.trace("ExtHostSCM#createSourceControl",l.identifier.value,_,p,P),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:l.identifier.value});const A=On._handlePool++,a=new i(l,this._proxy,this._commands,_,p,P);this._sourceControls.set(A,a);const R=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(l.identifier))||[];return R.push(a),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(l.identifier),R),a}getLastInputBox(l){this.logService.trace("ExtHostSCM#getLastInputBox",l.identifier.value);const _=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(l.identifier)),p=_&&_[_.length-1];return p&&p.inputBox}$provideOriginalResource(l,_,p){const P=m.URI.revive(_);this.logService.trace("ExtHostSCM#$provideOriginalResource",l,P.toString());const A=this._sourceControls.get(l);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):k.asPromise(()=>A.quickDiffProvider.provideOriginalResource(P,p)).then(a=>a||null)}$onInputBoxValueChange(l,_){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",l);const p=this._sourceControls.get(l);return p&&p.inputBox.$onInputBoxValueChange(_),Promise.resolve(void 0)}$executeResourceCommand(l,_,p,P){this.logService.trace("ExtHostSCM#$executeResourceCommand",l,_,p);const A=this._sourceControls.get(l);if(!A)return Promise.resolve(void 0);const a=A.getResourceGroup(_);return a?a.$executeResourceCommand(p,P):Promise.resolve(void 0)}$validateInput(l,_,p){this.logService.trace("ExtHostSCM#$validateInput",l);const P=this._sourceControls.get(l);return!P||!P.inputBox.validateInput?Promise.resolve(void 0):k.asPromise(()=>P.inputBox.validateInput(_,p)).then(A=>A?Promise.resolve([A.message,A.type]):Promise.resolve(void 0))}$setSelectedSourceControl(l){var _,p;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",l),l!==void 0&&((_=this._sourceControls.get(l))===null||_===void 0||_.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((p=this._sourceControls.get(this._selectedSourceControlHandle))===null||p===void 0||p.setSelectionState(!1)),this._selectedSourceControlHandle=l,Promise.resolve(void 0)}};s._handlePool=0,s=He([ze(2,n.ILogService)],s),e.ExtHostSCM=s});var rt=this&&this.__classPrivateFieldSet||function(ee,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,m):S?S.value=m:e.set(ee,m),m},Ue=this&&this.__classPrivateFieldGet||function(ee,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[198],_e([0,1,6,4,131,7,9]),function(ee,e,m,T,S,y,k){"use strict";var D,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class C{constructor(f,c,d,w,v=m.StatusBarAlignment.Left,E){D.set(this,void 0),b.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new y.DisposableStore,rt(this,D,f,"f"),rt(this,b,c,"f"),this._entryId=C.ID_GEN++,this._extension=d,this._id=w,this._alignment=v,this._priority=E}get id(){var f;return(f=this._id)!==null&&f!==void 0?f:this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get tooltip2(){return this._tooltip2}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var f;return(f=this._command)===null||f===void 0?void 0:f.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set tooltip2(f){this._tooltip2=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!C.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){var c;((c=this._command)===null||c===void 0?void 0:c.fromApi)!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Ue(this,b,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Ue(this,b,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,D,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var f;this._timeoutHandle=void 0;let c;this._extension?this._id?c=`${this._extension.identifier.value}.${this._id}`:c=this._extension.identifier.value:c=this._id;let d;this._name?d=this._name:d=S.localize(0,null,this._extension.displayName||this._extension.name);let w=this._color;this._backgroundColor&&(w=C.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const v=this._tooltip2!==void 0?k.MarkdownString.fromStrict(this._tooltip2):this.tooltip;Ue(this,D,"f").$setEntry(this._entryId,c,d,this._text,v,(f=this._command)===null||f===void 0?void 0:f.internal,w,this._backgroundColor,this._alignment===m.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=C,D=new WeakMap,b=new WeakMap,C.ID_GEN=0,C.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new m.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",m.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=S.localize(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const c={message:f};return this._messages.unshift(c),this._update(),new m.Disposable(()=>{const d=this._messages.indexOf(c);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class I{constructor(f,c){this._proxy=f.getProxy(T.MainContext.MainThreadStatusBar),this._commands=c,this._statusMessage=new n(this)}createStatusBarEntry(f,c,d,w){return new C(this._proxy,this._commands,f,c,d,w)}setStatusBarMessage(f,c){const d=this._statusMessage.setMessage(f);let w;return typeof c=="number"?w=setTimeout(()=>d.dispose(),c):typeof c!="undefined"&&c.then(()=>d.dispose(),()=>d.dispose()),new m.Disposable(()=>{d.dispose(),clearTimeout(w)})}}e.ExtHostStatusBar=I}),define(we[72],_e([0,1,4,3,5]),function(ee,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class y{constructor(D){this._onDidChangeStorage=new T.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(m.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,b){this._proxy.$registerExtensionStorageKeysToSync(D,b)}getValue(D,b,C){return this._proxy.$getValue(D,b).then(n=>n||C)}setValue(D,b,C){return this._proxy.$setValue(D,b,C)}$acceptValue(D,b,C){this._onDidChangeStorage.fire({shared:D,key:b,value:C})}}e.ExtHostStorage=y,e.IExtHostStorage=S.createDecorator("IExtHostStorage")}),define(we[73],_e([0,1,5,28,16,71,2]),function(ee,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=m.createDecorator("IExtensionStoragePaths");let D=class{constructor(C,n,I){var o;this._logService=n,this._extHostFileSystem=I,this._workspace=(o=C.workspace)!==null&&o!==void 0?o:void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(f=>this._value=f)}async _getOrCreateWorkspaceStoragePath(){var C;if(!this._workspace)return Promise.resolve(void 0);const n=this._workspace.id,I=k.URI.joinPath(this._environment.workspaceStorageHome,n);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch(o){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(k.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(C=k.URI.revive(this._workspace.configuration))===null||C===void 0?void 0:C.toString(),name:this._workspace.name},void 0,2))),I}catch(o){this._logService.error("[ExtHostStorage]",o);return}}workspaceValue(C){if(this._value)return k.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return k.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}};D=He([ze(0,T.IExtHostInitDataService),ze(1,S.ILogService),ze(2,y.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(we[36],_e([0,1,3,4,5,2,14,7,6,132,11,163,18,34,152,10]),function(ee,e,m,T,S,y,k,D,b,C,n,I,o,f,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=S.createDecorator("IExtHostTerminalService");class w{constructor(s,r,l,_){this._proxy=s,this._id=r,this._creationOptions=l,this._name=_,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(P=>this._pidPromiseComplete=P);const p=this;this.value={get name(){return p._name||""},get processId(){return p._pidPromise},get creationOptions(){return p._creationOptions},get exitStatus(){return p._exitStatus},sendText(P,A=!0){p._checkDisposed(),p._proxy.$sendText(p._id,P,A)},show(P){p._checkDisposed(),p._proxy.$show(p._id,P)},hide(){p._checkDisposed(),p._proxy.$hide(p._id)},dispose(){p._disposed||(p._disposed=!0,p._proxy.$dispose(p._id))},get dimensions(){if(!(p._cols===void 0||p._rows===void 0))return{columns:p._cols,rows:p._rows}}}}async create(s,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:s.name,shellPath:d.withNullAsUndefined(s.shellPath),shellArgs:d.withNullAsUndefined(s.shellArgs),cwd:d.withNullAsUndefined(s.cwd),env:d.withNullAsUndefined(s.env),icon:d.withNullAsUndefined(t(s.iconPath)),initialText:d.withNullAsUndefined(s.message),strictEnv:d.withNullAsUndefined(s.strictEnv),hideFromUser:d.withNullAsUndefined(s.hideFromUser),isFeatureTerminal:d.withNullAsUndefined(r==null?void 0:r.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:d.withNullAsUndefined(r==null?void 0:r.useShellEnvironment),isSplitTerminal:d.withNullAsUndefined(r==null?void 0:r.isSplitTerminal)})}async createExtensionTerminal(s,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:r,isSplitTerminal:s}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(s){this._name=s}setExitCode(s){this._exitStatus=Object.freeze({code:s})}setDimensions(s,r){return s===this._cols&&r===this._rows||s===0||r===0?!1:(this._cols=s,this._rows=r,!0)}_setProcessId(s){this._pidPromiseComplete?(this._pidPromiseComplete(s),this._pidPromiseComplete=void 0):this._pidPromise.then(r=>{r!==s&&(this._pidPromise=Promise.resolve(s))})}}e.ExtHostTerminal=w;class v{constructor(s){this._pty=s,this.id=0,this.shouldPersist=!1,this._onProcessData=new m.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new m.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new m.Emitter,this._onProcessTitleChanged=new m.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new m.Emitter,this._onProcessShellTypeChanged=new m.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(s){this._pty.handleInput&&this._pty.handleInput(s)}resize(s,r){this._pty.setDimensions&&this._pty.setDimensions({columns:s,rows:r})}async processBinary(s){}acknowledgeDataEvent(s){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(s){this._pty.onDidWrite(r=>this._onProcessData.fire(r)),this._pty.onDidClose&&this._pty.onDidClose((r=void 0)=>{this._onProcessExit.fire(r===void 0?void 0:r)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r&&{cols:r.columns,rows:r.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(r=>this._onProcessTitleChanged.fire(r)),this._pty.open(s||void 0),this._pty.setDimensions&&s&&this._pty.setDimensions(s),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=v;let E=1,u=class extends D.Disposable{constructor(s,r){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new m.Emitter,this._onDidOpenTerminal=new m.Emitter,this._onDidChangeActiveTerminal=new m.Emitter,this._onDidChangeTerminalDimensions=new m.Emitter,this._proxy=r.getProxy(T.MainContext.MainThreadTerminalService),this._bufferer=new c.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new m.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(s),this._register({dispose:()=>{for(const[l,_]of this._terminalProcesses)_.shutdown(!0)}})}get activeTerminal(){var s;return(s=this._activeTerminal)===null||s===void 0?void 0:s.value}get terminals(){return this._terminals.map(s=>s.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(s){const r=s?this._defaultAutomationProfile:this._defaultProfile;return(r==null?void 0:r.path)||""}getDefaultShellArgs(s){const r=s?this._defaultAutomationProfile:this._defaultProfile;return(r==null?void 0:r.args)||[]}createExtensionTerminal(s,r){const l=new w(this._proxy,f.generateUuid(),s,s.name),_=new v(s.pty);return l.createExtensionTerminal(r==null?void 0:r.isSplitTerminal,t(s.iconPath)).then(p=>{const P=this._setupExtHostProcessListeners(p,_);this._terminalProcessDisposables[p]=P}),this._terminals.push(l),l.value}attachPtyToTerminal(s,r){if(!this._getTerminalById(s))throw new Error(`Cannot resolve terminal with id ${s} for virtual process`);const _=new v(r),p=this._setupExtHostProcessListeners(s,_);this._terminalProcessDisposables[s]=p}async $acceptActiveTerminalChanged(s){const r=this._activeTerminal;if(s===null){this._activeTerminal=void 0,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const l=this._getTerminalById(s);l&&(this._activeTerminal=l,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(s,r){const l=this._getTerminalById(s);l&&this._onDidWriteTerminalData.fire({terminal:l.value,data:r})}async $acceptTerminalDimensions(s,r,l){const _=this._getTerminalById(s);_&&_.setDimensions(r,l)&&this._onDidChangeTerminalDimensions.fire({terminal:_.value,dimensions:_.value.dimensions})}async $acceptTerminalMaximumDimensions(s,r,l){var _;(_=this._terminalProcesses.get(s))===null||_===void 0||_.resize(r,l)}async $acceptTerminalTitleChange(s,r){const l=this._getTerminalById(s);l&&(l.name=r)}async $acceptTerminalClosed(s,r){const l=this._getTerminalObjectIndexById(this._terminals,s);if(l!==null){const _=this._terminals.splice(l,1)[0];_.setExitCode(r),this._onDidCloseTerminal.fire(_.value)}}$acceptTerminalOpened(s,r,l,_){if(r){const A=this._getTerminalObjectIndexById(this._terminals,r);if(A!==null){this._terminals[A]._id=s,this._onDidOpenTerminal.fire(this.terminals[A]),this._terminals[A].isOpen=!0;return}}const p={name:_.name,shellPath:_.executable,shellArgs:_.args,cwd:typeof _.cwd=="string"?_.cwd:y.URI.revive(_.cwd),env:_.env,hideFromUser:_.hideFromUser},P=new w(this._proxy,s,p,l);this._terminals.push(P),this._onDidOpenTerminal.fire(P.value),P.isOpen=!0}async $acceptTerminalProcessId(s,r){const l=this._getTerminalById(s);l&&l._setProcessId(r)}async $startExtensionTerminal(s,r){const l=this._getTerminalById(s);if(!l)return{message:C.localize(0,null,s)};l.isOpen||await new Promise(p=>{const P=this.onDidOpenTerminal(async A=>{A===l.value&&(P.dispose(),p())})});const _=this._terminalProcesses.get(s);_?_.startSendingEvents(r):this._extensionTerminalAwaitingStart[s]={initialDimensions:r}}_setupExtHostProcessListeners(s,r){const l=new D.DisposableStore;l.add(r.onProcessReady(p=>this._proxy.$sendProcessReady(s,p.pid,p.cwd))),l.add(r.onProcessTitleChanged(p=>this._proxy.$sendProcessTitle(s,p))),this._bufferer.startBuffering(s,r.onProcessData),l.add(r.onProcessExit(p=>this._onProcessExit(s,p))),r.onProcessOverrideDimensions&&l.add(r.onProcessOverrideDimensions(p=>this._proxy.$sendOverrideDimensions(s,p))),this._terminalProcesses.set(s,r);const _=this._extensionTerminalAwaitingStart[s];return _&&r instanceof v&&(r.startSendingEvents(_.initialDimensions),delete this._extensionTerminalAwaitingStart[s]),l}$acceptProcessAckDataEvent(s,r){var l;(l=this._terminalProcesses.get(s))===null||l===void 0||l.acknowledgeDataEvent(r)}$acceptProcessInput(s,r){var l;(l=this._terminalProcesses.get(s))===null||l===void 0||l.input(r)}$acceptProcessResize(s,r,l){var _;try{(_=this._terminalProcesses.get(s))===null||_===void 0||_.resize(r,l)}catch(p){if(p.code!=="EPIPE"&&p.code!=="ERR_IPC_CHANNEL_CLOSED")throw p}}$acceptProcessShutdown(s,r){var l;(l=this._terminalProcesses.get(s))===null||l===void 0||l.shutdown(r)}$acceptProcessRequestInitialCwd(s){var r;(r=this._terminalProcesses.get(s))===null||r===void 0||r.getInitialCwd().then(l=>this._proxy.$sendProcessInitialCwd(s,l))}$acceptProcessRequestCwd(s){var r;(r=this._terminalProcesses.get(s))===null||r===void 0||r.getCwd().then(l=>this._proxy.$sendProcessCwd(s,l))}$acceptProcessRequestLatency(s){return s}registerLinkProvider(s){return this._linkProviders.add(s),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new b.Disposable(()=>{this._linkProviders.delete(s),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(s,r,l){if(this._profileProviders.has(r))throw new Error(`Terminal profile provider "${r}" already registered`);return this._profileProviders.set(r,l),this._proxy.$registerProfileProvider(r,s.identifier.value),new b.Disposable(()=>{this._profileProviders.delete(r),this._proxy.$unregisterProfileProvider(r)})}async $createContributedProfileTerminal(s,r){var l;const _=new o.CancellationTokenSource().token,p=await((l=this._profileProviders.get(s))===null||l===void 0?void 0:l.provideTerminalProfile(_));if(!_.isCancellationRequested){if(!p||!("options"in p))throw new Error(`No terminal profile options provided for id "${s}"`);if("pty"in p.options){this.createExtensionTerminal(p.options,{isSplitTerminal:r});return}this.createTerminalFromOptions(p.options,{isSplitTerminal:r})}}async $provideLinks(s,r){const l=this._getTerminalById(s);if(!l)return[];this._terminalLinkCache.delete(s);const _=this._terminalLinkCancellationSource.get(s);_&&_.dispose(!0);const p=new o.CancellationTokenSource;this._terminalLinkCancellationSource.set(s,p);const P=[],A={terminal:l.value,line:r},a=[];for(const x of this._linkProviders)a.push(new Promise(async J=>{p.token.onCancellationRequested(()=>J({provider:x,links:[]}));const ae=await x.provideTerminalLinks(A,p.token)||[];p.token.isCancellationRequested||J({provider:x,links:ae})}));const R=await Promise.all(a);if(p.token.isCancellationRequested)return[];const F=new Map;for(const x of R)x&&x.links.length>0&&P.push(...x.links.map(J=>{const ae={id:E++,startIndex:J.startIndex,length:J.length,label:J.tooltip};return F.set(ae.id,{provider:x.provider,link:J}),ae}));return this._terminalLinkCache.set(s,F),P}$activateLink(s,r){var l;const _=(l=this._terminalLinkCache.get(s))===null||l===void 0?void 0:l.get(r);!_||_.provider.handleTerminalLink(_.link)}_onProcessExit(s,r){this._bufferer.stopBuffering(s),this._terminalProcesses.delete(s),delete this._extensionTerminalAwaitingStart[s];const l=this._terminalProcessDisposables[s];l&&(l.dispose(),delete this._terminalProcessDisposables[s]),this._proxy.$sendProcessExit(s,r)}_getTerminalById(s){return this._getTerminalObjectById(this._terminals,s)}_getTerminalObjectById(s,r){const l=this._getTerminalObjectIndexById(s,r);return l!==null?s[l]:null}_getTerminalObjectIndexById(s,r){let l=null;return s.some((_,p)=>_._id===r?(l=p,!0):!1),l}getEnvironmentVariableCollection(s){let r=this._environmentVariableCollections.get(s.identifier.value);return r||(r=new h,this._setEnvironmentVariableCollection(s.identifier.value,r)),r}_syncEnvironmentVariableCollection(s,r){const l=I.serializeEnvironmentVariableCollection(r.map);this._proxy.$setEnvironmentVariableCollection(s,r.persistent,l.length===0?void 0:l)}$initEnvironmentVariableCollections(s){s.forEach(r=>{const l=r[0],_=new h(r[1]);this._setEnvironmentVariableCollection(l,_)})}$acceptDefaultProfile(s,r){this._defaultProfile=s,this._defaultAutomationProfile=r}_setEnvironmentVariableCollection(s,r){this._environmentVariableCollections.set(s,r),r.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(s,r)})}};u=He([ze(1,k.IExtHostRpcService)],u),e.BaseExtHostTerminalService=u;class h{constructor(s){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new m.Emitter,this.map=new Map(s)}get persistent(){return this._persistent}set persistent(s){this._persistent=s,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(s,r){this._setIfDiffers(s,{value:r,type:b.EnvironmentVariableMutatorType.Replace})}append(s,r){this._setIfDiffers(s,{value:r,type:b.EnvironmentVariableMutatorType.Append})}prepend(s,r){this._setIfDiffers(s,{value:r,type:b.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(s,r){const l=this.map.get(s);(!l||l.value!==r.value||l.type!==r.type)&&(this.map.set(s,r),this._onDidChangeCollection.fire())}get(s){return this.map.get(s)}forEach(s,r){this.map.forEach((l,_)=>s.call(r,_,l,this))}delete(s){this.map.delete(s),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=h;let g=class extends u{constructor(s){super(!1,s)}createTerminal(s,r,l){throw new n.NotSupportedError}createTerminalFromOptions(s,r){throw new n.NotSupportedError}};g=He([ze(0,k.IExtHostRpcService)],g),e.WorkerExtHostTerminalService=g;function t(i){if(!!i)return"id"in i?{id:i.id,color:i.color}:i}});var rt=this&&this.__classPrivateFieldSet||function(ee,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,m):S?S.value=m:e.set(ee,m),m},Ue=this&&this.__classPrivateFieldGet||function(ee,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[199],_e([0,1,17,13,23,18,3,49,39,7,24,10,34,4,14,9,6,172,96]),function(ee,e,m,T,S,y,k,D,b,C,n,I,o,f,c,d,w,v,E){"use strict";var u,h,g,t,i;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(F,x){this.resultsChangedEmitter=new k.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=F.getProxy(f.MainContext.MainThreadTesting),this.observer=new a(this.proxy),this.runTracker=new l(this.proxy),x.registerArgumentProcessor({processArgument:J=>(J==null?void 0:J.$mid)===13?d.TestItem.toItemFromContext(J):J})}createTestController(F){const x=new C.DisposableStore,J=x.add(new v.SingleUseTestCollection(F)),ae=x.add(new T.RunOnceScheduler(()=>J.expand(J.root.id,0),0)),j={root:J.root,createTestRun:(W,Q,M=!0)=>this.runTracker.createTestRun(F,W,Q,M),createTestItem(W,Q,M,X,B){if(!(M instanceof w.TestItemImpl))throw new Error(`The "parent" passed in for TestItem ${W} is invalid`);return new w.TestItemImpl(W,Q,X,B,M)},set resolveChildrenHandler(W){J.resolveHandler=W,W&&ae.schedule()},get resolveChildrenHandler(){return J.resolveHandler},dispose:()=>{x.dispose()}};return this.proxy.$registerTestController(F),x.add(C.toDisposable(()=>this.proxy.$unregisterTestController(F))),this.controllers.set(F,{controller:j,collection:J}),x.add(C.toDisposable(()=>this.controllers.delete(F))),x.add(J.onDidGenerateDiff(W=>this.proxy.$publishDiff(F,W))),j}createTestObserver(){return this.observer.checkout()}async runTests(F,x=y.CancellationToken.None){const J=ae=>ae.map(this.getInternalTestForReference,this).filter(I.isDefined).map(j=>({controllerId:j.controllerId,testId:j.item.extId}));await this.proxy.$runTests({exclude:F.exclude?J(F.exclude).map(ae=>ae.testId):void 0,tests:J(F.tests),debug:F.debug},x)}$publishTestResults(F){this.results=Object.freeze(F.map(x=>n.deepFreeze(d.TestResults.to(x))).concat(this.results).sort((x,J)=>J.completedAt-x.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest({controllerId:F,testId:x},J){var ae;const j=(ae=this.controllers.get(F))===null||ae===void 0?void 0:ae.collection;j&&(await j.expand(x,J<0?Infinity:J),j.flushDiff())}$acceptDiff(F){this.observer.applyDiff(F)}async $runControllerTests(F,x){var J;const ae=this.controllers.get(F.controllerId);if(!ae)return;const{controller:j,collection:W}=ae,Q=F.testIds.map(U=>W.tree.get(U)).filter(I.isDefined),M=F.excludeExtIds.map(U=>ae.collection.tree.get(U)).filter(I.isDefined).filter(U=>Q.some(Y=>W.tree.comparePositions(Y,U)===1));if(!Q.length)return;const X={tests:Q.map(U=>U.actual),exclude:M.map(U=>U.actual),debug:F.debug},B=this.runTracker.prepareForMainThreadTestRun(X,_.fromInternal(F),x);try{await((J=j.runHandler)===null||J===void 0?void 0:J.call(j,X,x))}finally{B.isRunning&&!x.isCancellationRequested&&await k.Event.toPromise(B.onEnd),this.runTracker.cancelRunById(F.runId)}}$cancelExtensionTestRun(F){F===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(F)}getInternalTestForReference(F){var x;return(x=m.mapFind(this.controllers.values(),({collection:J})=>J.getTestByReference(F)))!==null&&x!==void 0?x:this.observer.getMirroredTestDataByReference(F)}};s=He([ze(0,c.IExtHostRpcService)],s),e.ExtHostTesting=s;class r extends C.Disposable{constructor(F,x,J){super();this.dto=F,this.proxy=x,this.task=new Set,this.sharedTestIds=new Set,this.endEmitter=this._register(new k.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new y.CancellationTokenSource(J)),this._register(this.cts.token.onCancellationRequested(()=>{for(const ae of this.task)ae.end()}))}get isRunning(){return this.task.size>0}get id(){return this.dto.id}createRun(F){const x=new p(F,this.cts.token,this.dto,this.sharedTestIds,this.proxy,()=>{this.task.delete(x),this.isRunning||this.dispose()});return this.task.add(x),x}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}}class l{constructor(F){this.proxy=F,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(F,x,J){return this.getTracker(F,x,J)}cancelRunById(F){for(const x of this.tracked.values())if(x.id===F){x.dispose();return}}cancelAllRuns(){for(const F of this.tracked.values())F.dispose()}createTestRun(F,x,J,ae){var j,W;const Q=this.tracked.get(x);if(Q)return Q.createRun(J);const M=_.fromPublic(F,x);this.proxy.$startedExtensionTestRun({debug:x.debug,exclude:(W=(j=x.exclude)===null||j===void 0?void 0:j.map(B=>B.id))!==null&&W!==void 0?W:[],id:M.id,tests:x.tests.map(B=>B.id),persist:ae});const X=this.getTracker(x,M);return X.onEnd(()=>this.proxy.$finishedExtensionTestRun(M.id)),X.createRun(J)}getTracker(F,x,J){const ae=new r(x,this.proxy,J);return this.tracked.set(F,ae),ae.onEnd(()=>this.tracked.delete(F)),ae}}e.TestRunCoordinator=l;class _{constructor(F,x,J,ae){this.controllerId=F,this.id=x,this.include=J,this.exclude=ae}static fromPublic(F,x){var J,ae;return new _(F,o.generateUuid(),new Set(x.tests.map(j=>j.id)),new Set((ae=(J=x.exclude)===null||J===void 0?void 0:J.map(j=>j.id))!==null&&ae!==void 0?ae:b.Iterable.empty()))}static fromInternal(F){return new _(F.controllerId,F.runId,new Set(F.testIds),new Set(F.excludeExtIds))}isIncluded(F){for(let x=F;x;x=x.parent){if(this.include.has(x.id))return!0;if(this.exclude.has(x.id))return!1}return!1}}e.TestRunDto=_;class p{constructor(F,x,J,ae,j,W){this.name=F,this.token=x,u.set(this,void 0),h.set(this,void 0),g.set(this,void 0),t.set(this,void 0),i.set(this,!1),this.taskId=o.generateUuid(),rt(this,t,W,"f"),rt(this,u,j,"f"),rt(this,h,J,"f"),rt(this,g,ae,"f"),j.$startedTestRunTask(J.id,{id:this.taskId,name:F,running:!0})}setState(F,x,J){!Ue(this,i,"f")&&Ue(this,h,"f").isIncluded(F)&&(this.ensureTestIsKnown(F),Ue(this,u,"f").$updateTestStateInRun(Ue(this,h,"f").id,this.taskId,F.id,x,J))}appendMessage(F,x){!Ue(this,i,"f")&&Ue(this,h,"f").isIncluded(F)&&(this.ensureTestIsKnown(F),Ue(this,u,"f").$appendTestMessageInRun(Ue(this,h,"f").id,this.taskId,F.id,d.TestMessage.from(x)))}appendOutput(F){Ue(this,i,"f")||Ue(this,u,"f").$appendOutputToRun(Ue(this,h,"f").id,this.taskId,S.VSBuffer.fromString(F))}end(){Ue(this,i,"f")||(rt(this,i,!0,"f"),Ue(this,u,"f").$finishedTestRunTask(Ue(this,h,"f").id,this.taskId),Ue(this,t,"f").call(this))}ensureTestIsKnown(F){const x=Ue(this,g,"f");if(x.has(F.id))return;const J=[];for(;J.unshift(d.TestItem.from(F)),!(x.has(F.id)||(x.add(F.id),!F.parent));)F=F.parent;Ue(this,u,"f").$addTestsToRun(Ue(this,h,"f").controllerId,Ue(this,h,"f").id,J)}}u=new WeakMap,h=new WeakMap,g=new WeakMap,t=new WeakMap,i=new WeakMap;class P extends E.IncrementalChangeCollector{constructor(F){super();this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(F){this.added.add(F)}update(F){Object.assign(F.revived,d.TestItem.toPlain(F.item)),this.added.has(F)||this.updated.add(F)}remove(F){if(this.added.has(F)){this.added.delete(F);return}if(this.updated.delete(F),F.parent&&this.alreadyRemoved.has(F.parent)){this.alreadyRemoved.add(F.item.extId);return}this.removed.add(F)}getChangeEvent(){const{added:F,updated:x,removed:J}=this;return{get added(){return[...F].map(ae=>ae.revived)},get updated(){return[...x].map(ae=>ae.revived)},get removed(){return[...J].map(ae=>ae.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class A extends E.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new k.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(F){return this.items.get(F)}getMirroredTestDataByReference(F){return this.items.get(F.id)}createItem(F,x){return Object.assign(Object.assign({},F),{revived:d.TestItem.toPlain(F.item),depth:x?x.depth+1:0,children:new Set})}createChangeCollector(){return new P(this.changeEmitter)}}e.MirroredTestCollection=A;class a{constructor(F){this.proxy=F}checkout(){this.current||(this.current=this.createObserverData());const F=this.current;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(x=>x.revived)},dispose:D.once(()=>{--F.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(F){var x;return(x=this.current)===null||x===void 0?void 0:x.tests.getMirroredTestDataByReference(F)}applyDiff(F){var x;(x=this.current)===null||x===void 0||x.tests.apply(F)}createObserverData(){const F=new A;return this.proxy.$subscribeToDiffs(),{observers:0,tests:F}}}}),define(we[200],_e([0,1,3,17,4,98,9,6]),function(ee,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class b{constructor(n,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new m.Emitter,this._onDidChangeTextEditorOptions=new m.Emitter,this._onDidChangeTextEditorVisibleRanges=new m.Emitter,this._onDidChangeTextEditorViewColumn=new m.Emitter,this._onDidChangeActiveTextEditor=new m.Emitter,this._onDidChangeVisibleTextEditors=new m.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(S.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(o=>this._onDidChangeVisibleTextEditors.fire(o)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(o=>this._onDidChangeActiveTextEditor.fire(o))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const I=this._extHostDocumentsAndEditors.allEditors();return n?I:I.map(o=>o.value)}async showTextDocument(n,I,o){let f;typeof I=="number"?f={position:k.ViewColumn.from(I),preserveFocus:o}:typeof I=="object"?f={position:k.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?k.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:f={preserveFocus:!1};const c=await this._proxy.$tryShowTextDocument(n.uri,f),d=c&&this._extHostDocumentsAndEditors.getEditor(c);if(d)return d.value;throw c?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,I){return new y.TextEditorDecorationType(this._proxy,n,I).value}$acceptEditorPropertiesChanged(n,I){const o=this._extHostDocumentsAndEditors.getEditor(n);if(!o)throw new Error("unknown text editor");if(I.options&&o._acceptOptions(I.options),I.selections){const f=I.selections.selections.map(k.Selection.to);o._acceptSelections(f)}if(I.visibleRanges){const f=T.coalesce(I.visibleRanges.map(k.Range.to));o._acceptVisibleRanges(f)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:o.value,options:Object.assign(Object.assign({},I.options),{lineNumbers:k.TextEditorLineNumbersStyle.to(I.options.lineNumbers)})}),I.selections){const f=D.TextEditorSelectionChangeKind.fromValue(I.selections.source),c=I.selections.selections.map(k.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:o.value,selections:c,kind:f})}if(I.visibleRanges){const f=T.coalesce(I.visibleRanges.map(k.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:o.value,visibleRanges:f})}}$acceptEditorPositionData(n){for(const I in n){const o=this._extHostDocumentsAndEditors.getEditor(I);if(!o)throw new Error("Unknown text editor");const f=k.ViewColumn.to(n[I]);o.value.viewColumn!==f&&(o._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:o.value,viewColumn:f}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=b});var $n=this&&this.__rest||function(ee,e){var m={};for(var T in ee)Object.prototype.hasOwnProperty.call(ee,T)&&e.indexOf(T)<0&&(m[T]=ee[T]);if(ee!=null&&typeof Object.getOwnPropertySymbols=="function")for(var S=0,T=Object.getOwnPropertySymbols(ee);S<T.length;S++)e.indexOf(T[S])<0&&Object.prototype.propertyIsEnumerable.call(ee,T[S])&&(m[T[S]]=ee[T[S]]);return m};define(we[201],_e([0,1,2,5,4,7,6]),function(ee,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=T.createDecorator("IExtHostTimeline");class D{constructor(n,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(S.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:o=>{var f,c;if(o&&o.$mid===11){const d=o.uri===void 0?void 0:m.URI.revive(o.uri);return(c=(f=this._itemsBySourceAndUriMap.get(o.source))===null||f===void 0?void 0:f.get(b(d)))===null||c===void 0?void 0:c.get(o.handle)}return o}})}async $getTimeline(n,I,o,f,c){const d=this._providers.get(n);return d==null?void 0:d.provideTimeline(m.URI.revive(I),o,f,c)}registerTimelineProvider(n,I,o,f){const c=new y.DisposableStore,d=this.convertTimelineItem(I.id,f,c).bind(this);let w;I.onDidChange&&(w=I.onDidChange(E=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},E),{id:I.id})),this));const v=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},I),{scheme:n,onDidChange:void 0,async provideTimeline(E,u,h,g){var t;(g==null?void 0:g.resetCache)&&(c.clear(),(t=v.get(I.id))===null||t===void 0||t.clear());const i=await I.provideTimeline(E,u,h);if(i==null)return;const s=d(E,g);return Object.assign(Object.assign({},i),{source:I.id,items:i.items.map(s)})},dispose(){var E;for(const u of v.values())(E=u.get(I.id))===null||E===void 0||E.clear();w==null||w.dispose(),c.dispose()}}))}convertTimelineItem(n,I,o){return(f,c)=>{let d;if(c==null?void 0:c.cacheResults){let w=this._itemsBySourceAndUriMap.get(n);w===void 0&&(w=new Map,this._itemsBySourceAndUriMap.set(n,w));const v=b(f);d=w.get(v),d===void 0&&(d=new Map,w.set(v,d))}return w=>{var v,E;const{iconPath:u}=w,h=$n(w,["iconPath"]),g=`${n}|${(v=w.id)!==null&&v!==void 0?v:w.timestamp}`;d==null||d.set(g,w);let t,i,s;return w.iconPath&&(u instanceof k.ThemeIcon?s={id:u.id}:m.URI.isUri(u)?(t=u,i=u):{light:t,dark:i}=u),Object.assign(Object.assign({},h),{id:(E=h.id)!==null&&E!==void 0?E:void 0,handle:g,source:n,command:w.command?I.toInternal(w.command,o):void 0,icon:t,iconDark:i,themeIcon:s,accessibilityInformation:w.accessibilityInformation})}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),y.toDisposable(()=>{var o;for(const f of this._itemsBySourceAndUriMap.values())(o=f.get(n.id))===null||o===void 0||o.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=D;function b(C){return C==null?void 0:C.toString()}}),define(we[202],_e([0,1,7,12,2,4]),function(ee,e,m,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class k{constructor(b){this._openers=new Map,this._proxy=b.getProxy(y.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(b,C,n,I){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const o=I.schemes.find(f=>!k.supportedSchemes.has(f));if(o)throw new Error(`Scheme '${o}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,n),this._proxy.$registerUriOpener(C,I.schemes,b,I.label),m.toDisposable(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(b,C,n){const I=this._openers.get(b);if(!I)throw new Error(`Unknown opener with id: ${b}`);const o=S.URI.revive(C);return I.canOpenExternalUri(o,n)}async $openUri(b,C,n){const I=this._openers.get(b);if(!I)throw new Error(`Unknown opener id: '${b}'`);return I.openExternalUri(S.URI.revive(C.resolvedUri),{sourceUri:S.URI.revive(C.sourceUri)},n)}}e.ExtHostUriOpeners=k,k.supportedSchemes=new Set([T.Schemas.http,T.Schemas.https])}),define(we[203],_e([0,1,4,2,7,11,26]),function(ee,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(m.MainContext.MainThreadUrls)}registerUriHandler(C,n){if(this.handles.has(k.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const I=D.HandlePool++;return this.handles.add(k.ExtensionIdentifier.toKey(C)),this.handlers.set(I,n),this._proxy.$registerUriHandler(I,C),S.toDisposable(()=>{this.handles.delete(k.ExtensionIdentifier.toKey(C)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(C,n){const I=this.handlers.get(C);if(!I)return Promise.resolve(void 0);try{I.handleUri(T.URI.revive(n))}catch(o){y.onUnexpectedError(o)}return Promise.resolve(void 0)}async createAppUri(C){return T.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=D,D.HandlePool=0});var rt=this&&this.__classPrivateFieldSet||function(ee,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,m):S?S.value=m:e.set(ee,m),m},Ue=this&&this.__classPrivateFieldGet||function(ee,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[47],_e([0,1,3,2,140,158,66,4]),function(ee,e,m,T,S,y,k,D){"use strict";var b,C,n,I,o,f,c,d,w,v,E,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class h{constructor(p,P,A,a,R,F,x){b.set(this,void 0),C.set(this,void 0),n.set(this,void 0),I.set(this,void 0),o.set(this,void 0),f.set(this,void 0),c.set(this,""),d.set(this,void 0),w.set(this,!1),v.set(this,!1),E.set(this,!1),this._onMessageEmitter=new m.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new m.Emitter),this._onDidDispose=Ue(this,u,"f").event,rt(this,b,p,"f"),rt(this,C,P,"f"),rt(this,d,A,"f"),rt(this,I,a,"f"),rt(this,o,R,"f"),rt(this,f,F,"f"),rt(this,E,g(F),"f"),rt(this,n,x,"f")}dispose(){rt(this,w,!0,"f"),Ue(this,u,"f").fire(),Ue(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(p){return rt(this,v,!0,"f"),k.asWebviewUri(p,Ue(this,I,"f").remote)}get cspSource(){return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ue(this,c,"f")}set html(p){this.assertNotDisposed(),Ue(this,c,"f")!==p&&(rt(this,c,p,"f"),!Ue(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(p)&&(rt(this,v,!0,"f"),Ue(this,n,"f").report("Webview vscode-resource: uris",Ue(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,C,"f").$setHtml(Ue(this,b,"f"),p))}get options(){return this.assertNotDisposed(),Ue(this,d,"f")}set options(p){this.assertNotDisposed(),Ue(this,C,"f").$setOptions(Ue(this,b,"f"),s(Ue(this,f,"f"),Ue(this,o,"f"),p)),rt(this,d,p,"f")}async postMessage(p){if(Ue(this,w,"f"))return!1;const P=y.serializeWebviewMessage(p,{serializeBuffersForPostMessage:Ue(this,E,"f")});return Ue(this,C,"f").$postMessage(Ue(this,b,"f"),P.message,...P.buffers)}assertNotDisposed(){if(Ue(this,w,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=h,b=new WeakMap,C=new WeakMap,n=new WeakMap,I=new WeakMap,o=new WeakMap,f=new WeakMap,c=new WeakMap,d=new WeakMap,w=new WeakMap,v=new WeakMap,E=new WeakMap,u=new WeakMap;function g(_){try{const p=S.normalizeVersion(S.parseVersion(_.engines.vscode));return!!p&&p.majorBase>=1&&p.minorBase>=57}catch(p){return!1}}e.shouldSerializeBuffersForPostMessage=g;class t{constructor(p,P,A,a,R){this.initData=P,this.workspace=A,this._logService=a,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=p.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(p,P,...A){const a=this.getWebview(p);if(a){const{message:R}=y.deserializeWebviewMessage(P,A);a._onMessageEmitter.fire(R)}}$onMissingCsp(p,P){this._logService.warn(`${P} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(p,P,A){const a=new h(p,this._webviewProxy,r(P),this.initData,this.workspace,A,this._deprecationService);return this._webviews.set(p,a),a._onDidDispose(()=>{this._webviews.delete(p)}),a}deleteWebview(p){this._webviews.delete(p)}getWebview(p){return this._webviews.get(p)}}e.ExtHostWebviews=t;function i(_){return{id:_.identifier,location:_.extensionLocation}}e.toExtensionData=i;function s(_,p,P){return{enableCommandUris:P.enableCommandUris,enableScripts:P.enableScripts,portMapping:P.portMapping,localResourceRoots:P.localResourceRoots||l(_,p)}}e.serializeWebviewOptions=s;function r(_){var p;return{enableCommandUris:_.enableCommandUris,enableScripts:_.enableScripts,portMapping:_.portMapping,localResourceRoots:(p=_.localResourceRoots)===null||p===void 0?void 0:p.map(P=>T.URI.from(P))}}e.reviveOptions=r;function l(_,p){return[...((p==null?void 0:p.getWorkspaceFolders())||[]).map(P=>P.uri),_.extensionLocation]}}),define(we[204],_e([0,1,18,53,7,12,25,2,9,47,62,4,6]),function(ee,e,m,T,S,y,k,D,b,C,n,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,i){this.document=t,this._storagePath=i,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,i){await this.getEdit(t).undo(),i||this.disposeBackup()}async redo(t,i){await this.getEdit(t).redo(),i||this.disposeBackup()}disposeEdits(t){for(const i of t)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=h(this.document.uri)+this._backupCounter++;return k.joinPath(this._storagePath,t)}updateBackup(t){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const i=this._edits.get(t,0);if(!i)throw new Error("No edit found");return i}}class c{constructor(){this._documents=new Map}get(t,i){return this._documents.get(this.key(t,i))}add(t,i,s){const r=this.key(t,i.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${i.uri}`);const l=new f(i,s);return this._documents.set(r,l),l}delete(t,i){const s=this.key(t,i.uri);this._documents.delete(s)}key(t,i){return`${t}@@@${i}`}}var d;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(d||(d={}));class w{constructor(){this._providers=new Map}addTextProvider(t,i,s){return this.add(0,t,i,s)}addCustomProvider(t,i,s){return this.add(1,t,i,s)}get(t){return this._providers.get(t)}add(t,i,s,r){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:t,extension:s,provider:r}),new o.Disposable(()=>this._providers.delete(i))}}class v{constructor(t,i,s,r,l){this._extHostDocuments=i,this._extensionStoragePaths=s,this._extHostWebview=r,this._extHostWebviewPanels=l,this._editorProviders=new w,this._documents=new c,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,i,s,r){const l=new S.DisposableStore;return E(s)?(l.add(this._editorProviders.addTextProvider(i,t,s)),this._proxy.$registerTextEditorProvider(C.toExtensionData(t),i,r.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},C.shouldSerializeBuffersForPostMessage(t))):(l.add(this._editorProviders.addCustomProvider(i,t,s)),this.supportEditing(s)&&l.add(s.onDidChangeCustomDocument(_=>{const p=this.getCustomDocumentEntry(i,_.document.uri);if(u(_)){const P=p.addEdit(_);this._proxy.$onDidEdit(_.document.uri,i,P,_.label)}else this._proxy.$onContentChange(_.document.uri,i)})),this._proxy.$registerCustomEditorProvider(C.toExtensionData(t),i,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,C.shouldSerializeBuffersForPostMessage(t))),o.Disposable.from(l,new o.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(t,i,s,r,l){var _;const p=this._editorProviders.get(i);if(!p)throw new Error(`No provider found for '${i}'`);if(p.type!==1)throw new Error(`Invalid provide type for '${i}'`);const P=D.URI.revive(t),A=await p.provider.openCustomDocument(P,{backupId:s,untitledDocumentData:r==null?void 0:r.buffer},l);let a;return this.supportEditing(p.provider)&&this._extensionStoragePaths&&(a=(_=this._extensionStoragePaths.workspaceValue(p.extension))!==null&&_!==void 0?_:this._extensionStoragePaths.globalValue(p.extension)),this._documents.add(i,A,a),{editable:this.supportEditing(p.provider)}}async $disposeCustomDocument(t,i){const s=this._editorProviders.get(i);if(!s)throw new Error(`No provider found for '${i}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${i}'`);const r=D.URI.revive(t),{document:l}=this.getCustomDocumentEntry(i,r);this._documents.delete(i,l),l.dispose()}async $resolveWebviewEditor(t,i,s,r,l,_){const p=this._editorProviders.get(s);if(!p)throw new Error(`No provider found for '${s}'`);const P=b.ViewColumn.to(l),A=this._extHostWebview.createNewWebview(i,r.webviewOptions,p.extension),a=this._extHostWebviewPanels.createNewWebviewPanel(i,s,r.title,P,r.panelOptions,A),R=D.URI.revive(t);switch(p.type){case 1:{const{document:F}=this.getCustomDocumentEntry(s,R);return p.provider.resolveCustomEditor(F,a,_)}case 0:{const F=this._extHostDocuments.getDocument(R);return p.provider.resolveCustomTextEditor(F,a,_)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,i,s){this.getCustomDocumentEntry(i,t).disposeEdits(s)}async $onMoveCustomEditor(t,i,s){const r=this._editorProviders.get(s);if(!r)throw new Error(`No provider found for '${s}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const l=this._extHostWebviewPanels.getWebviewPanel(t);if(!l)throw new Error("No webview found");const _=D.URI.revive(i),p=this._extHostDocuments.getDocument(_);await r.provider.moveCustomTextEditor(p,l,m.CancellationToken.None)}async $undo(t,i,s,r){return this.getCustomDocumentEntry(i,t).undo(s,r)}async $redo(t,i,s,r){return this.getCustomDocumentEntry(i,t).redo(s,r)}async $revert(t,i,s){const r=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).revertCustomDocument(r.document,s),r.disposeBackup()}async $onSave(t,i,s){const r=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).saveCustomDocument(r.document,s),r.disposeBackup()}async $onSaveAs(t,i,s,r){const l=this.getCustomDocumentEntry(i,t);return this.getCustomEditorProvider(i).saveCustomDocumentAs(l.document,D.URI.revive(s),r)}async $backup(t,i,s){const r=this.getCustomDocumentEntry(i,t),_=await this.getCustomEditorProvider(i).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},s);return r.updateBackup(_),_.id}getCustomDocumentEntry(t,i){const s=this._documents.get(t,D.URI.revive(i));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const i=this._editorProviders.get(t),s=i==null?void 0:i.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=v;function E(g){return typeof g.resolveCustomTextEditor=="function"}function u(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function h(g){const t=g.scheme===y.Schemas.file||g.scheme===y.Schemas.untitled?g.fsPath:g.toString();return T.hash(t)+""}});var rt=this&&this.__classPrivateFieldSet||function(ee,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,m):S?S.value=m:e.set(ee,m),m},Ue=this&&this.__classPrivateFieldGet||function(ee,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[205],_e([0,1,3,7,2,34,9,47,4,6]),function(ee,e,m,T,S,y,k,D,b,C){"use strict";var n,I,o,f,c,d,w,v,E,u,h,g,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends T.Disposable{constructor(_,p,P,A,a,R,F){super();n.set(this,void 0),I.set(this,void 0),o.set(this,void 0),f.set(this,void 0),c.set(this,void 0),d.set(this,void 0),w.set(this,void 0),v.set(this,void 0),E.set(this,!0),u.set(this,!0),h.set(this,!1),g.set(this,this._register(new m.Emitter)),this.onDidDispose=Ue(this,g,"f").event,t.set(this,this._register(new m.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,rt(this,n,_,"f"),rt(this,I,p,"f"),rt(this,o,P,"f"),rt(this,c,R,"f"),rt(this,v,a,"f"),rt(this,d,A,"f"),rt(this,f,F,"f")}dispose(){Ue(this,h,"f")||(rt(this,h,!0,"f"),Ue(this,g,"f").fire(),Ue(this,I,"f").$disposeWebview(Ue(this,n,"f")),Ue(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,f,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,o,"f")}get title(){return this.assertNotDisposed(),Ue(this,d,"f")}set title(_){this.assertNotDisposed(),Ue(this,d,"f")!==_&&(rt(this,d,_,"f"),Ue(this,I,"f").$setTitle(Ue(this,n,"f"),_))}get iconPath(){return this.assertNotDisposed(),Ue(this,w,"f")}set iconPath(_){this.assertNotDisposed(),Ue(this,w,"f")!==_&&(rt(this,w,_,"f"),Ue(this,I,"f").$setIconPath(Ue(this,n,"f"),S.URI.isUri(_)?{light:_,dark:_}:_))}get options(){return Ue(this,c,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,v,"f")=="number"&&Ue(this,v,"f")<0))return Ue(this,v,"f")}get active(){return this.assertNotDisposed(),Ue(this,u,"f")}get visible(){return this.assertNotDisposed(),Ue(this,E,"f")}_updateViewState(_){Ue(this,h,"f")||(this.active!==_.active||this.visible!==_.visible||this.viewColumn!==_.viewColumn)&&(rt(this,u,_.active,"f"),rt(this,E,_.visible,"f"),rt(this,v,_.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(_,p){this.assertNotDisposed(),Ue(this,I,"f").$reveal(Ue(this,n,"f"),{viewColumn:_?k.ViewColumn.from(_):void 0,preserveFocus:!!p})}assertNotDisposed(){if(Ue(this,h,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,I=new WeakMap,o=new WeakMap,f=new WeakMap,c=new WeakMap,d=new WeakMap,w=new WeakMap,v=new WeakMap,E=new WeakMap,u=new WeakMap,h=new WeakMap,g=new WeakMap,t=new WeakMap;class s{constructor(_,p,P){this.webviews=p,this.workspace=P,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=_.getProxy(b.MainContext.MainThreadWebviewPanels)}static newHandle(){return y.generateUuid()}createWebviewPanel(_,p,P,A,a={}){const R=typeof A=="object"?A.viewColumn:A,F={viewColumn:k.ViewColumn.from(R),preserveFocus:typeof A=="object"&&!!A.preserveFocus},x=D.shouldSerializeBuffersForPostMessage(_),J=s.newHandle();this._proxy.$createWebviewPanel(D.toExtensionData(_),J,p,{title:P,panelOptions:r(a),webviewOptions:D.serializeWebviewOptions(_,this.workspace,a),serializeBuffersForPostMessage:x},F);const ae=this.webviews.createNewWebview(J,a,_);return this.createNewWebviewPanel(J,p,P,R,a,ae)}$onDidChangeWebviewPanelViewStates(_){const p=Object.keys(_);p.sort((P,A)=>{const a=_[P],R=_[A];return a.active?1:R.active?-1:+a.visible-+R.visible});for(const P of p){const A=this.getWebviewPanel(P);if(!A)continue;const a=_[P];A._updateViewState({active:a.active,visible:a.visible,viewColumn:k.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(_){const p=this.getWebviewPanel(_);p==null||p.dispose(),this._webviewPanels.delete(_),this.webviews.deleteWebview(_)}registerWebviewPanelSerializer(_,p,P){if(this._serializers.has(p))throw new Error(`Serializer for '${p}' already registered`);return this._serializers.set(p,{serializer:P,extension:_}),this._proxy.$registerSerializer(p,{serializeBuffersForPostMessage:D.shouldSerializeBuffersForPostMessage(_)}),new C.Disposable(()=>{this._serializers.delete(p),this._proxy.$unregisterSerializer(p)})}async $deserializeWebviewPanel(_,p,P,A){const a=this._serializers.get(p);if(!a)throw new Error(`No serializer found for '${p}'`);const{serializer:R,extension:F}=a,x=this.webviews.createNewWebview(_,P.webviewOptions,F),J=this.createNewWebviewPanel(_,p,P.title,A,P.panelOptions,x);await R.deserializeWebviewPanel(J,P.state)}createNewWebviewPanel(_,p,P,A,a,R){const F=new i(_,this._proxy,p,P,A,a,R);return this._webviewPanels.set(_,F),F}getWebviewPanel(_){return this._webviewPanels.get(_)}}e.ExtHostWebviewPanels=s;function r(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var rt=this&&this.__classPrivateFieldSet||function(ee,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,m):S?S.value=m:e.set(ee,m),m},Ue=this&&this.__classPrivateFieldGet||function(ee,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[206],_e([0,1,3,7,47,4,6]),function(ee,e,m,T,S,y,k){"use strict";var D,b,C,n,I,o,f,c,d,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class v extends T.Disposable{constructor(h,g,t,i,s,r){super();D.set(this,void 0),b.set(this,void 0),C.set(this,void 0),n.set(this,void 0),I.set(this,!1),o.set(this,void 0),f.set(this,void 0),c.set(this,void 0),d.set(this,this._register(new m.Emitter)),this.onDidChangeVisibility=Ue(this,d,"f").event,w.set(this,this._register(new m.Emitter)),this.onDidDispose=Ue(this,w,"f").event,rt(this,C,t,"f"),rt(this,f,i,"f"),rt(this,D,h,"f"),rt(this,b,g,"f"),rt(this,n,s,"f"),rt(this,o,r,"f")}dispose(){Ue(this,I,"f")||(rt(this,I,!0,"f"),Ue(this,w,"f").fire(),Ue(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,f,"f")}set title(h){this.assertNotDisposed(),Ue(this,f,"f")!==h&&(rt(this,f,h,"f"),Ue(this,b,"f").$setWebviewViewTitle(Ue(this,D,"f"),h))}get description(){return this.assertNotDisposed(),Ue(this,c,"f")}set description(h){this.assertNotDisposed(),Ue(this,c,"f")!==h&&(rt(this,c,h,"f"),Ue(this,b,"f").$setWebviewViewDescription(Ue(this,D,"f"),h))}get visible(){return Ue(this,o,"f")}get webview(){return Ue(this,n,"f")}get viewType(){return Ue(this,C,"f")}_setVisible(h){h===Ue(this,o,"f")||Ue(this,I,"f")||(rt(this,o,h,"f"),Ue(this,d,"f").fire())}show(h){this.assertNotDisposed(),Ue(this,b,"f").$show(Ue(this,D,"f"),!!h)}assertNotDisposed(){if(Ue(this,I,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,b=new WeakMap,C=new WeakMap,n=new WeakMap,I=new WeakMap,o=new WeakMap,f=new WeakMap,c=new WeakMap,d=new WeakMap,w=new WeakMap;class E{constructor(h,g){this._extHostWebview=g,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=h.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(h,g,t,i){if(this._viewProviders.has(g))throw new Error(`View provider for '${g}' already registered`);return this._viewProviders.set(g,{provider:t,extension:h}),this._proxy.$registerWebviewViewProvider(S.toExtensionData(h),g,{retainContextWhenHidden:i==null?void 0:i.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new k.Disposable(()=>{this._viewProviders.delete(g),this._proxy.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(h,g,t,i,s){const r=this._viewProviders.get(g);if(!r)throw new Error(`No view provider found for '${g}'`);const{provider:l,extension:_}=r,p=this._extHostWebview.createNewWebview(h,{},_),P=new v(h,this._proxy,g,t,p,!0);this._webviewViews.set(h,P),await l.resolveWebviewView(P,{state:i},s)}async $onDidChangeWebviewViewVisibility(h,g){this.getWebviewView(h)._setVisible(g)}async $disposeWebviewView(h){const g=this.getWebviewView(h);this._webviewViews.delete(h),g.dispose(),this._extHostWebview.deleteWebview(h)}getWebviewView(h){const g=this._webviewViews.get(h);if(!g)throw new Error("No webview found");return g}}e.ExtHostWebviewViews=E}),define(we[102],_e([0,1,3,4,2,12,8,5,14]),function(ee,e,m,T,S,y,k,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class Un{constructor(I){this._onDidChangeWindowState=new m.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Un.InitialState,this._proxy=I.getProxy(T.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(o=>this.$onDidChangeWindowFocus(o))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:I}),this._onDidChangeWindowState.fire(this._state))}openUri(I,o){let f;if(typeof I=="string"){f=I;try{I=S.URI.parse(I)}catch(c){return Promise.reject(`Invalid uri - '${I}'`)}}return k.isFalsyOrWhitespace(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===y.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,f,o)}async asExternalUri(I,o){if(k.isFalsyOrWhitespace(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(I,o);return S.URI.from(f)}};C.InitialState={focused:!0},C=He([ze(0,b.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=D.createDecorator("IExtHostWindow")}),define(we[207],_e([0,1,16,4,28,14]),function(ee,e,m,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let k=class extends m.AbstractLogger{constructor(b,C){super();this._proxy=b.getProxy(T.MainContext.MainThreadLog),this._logFile=C.logFile.toJSON(),this.setLevel(C.logLevel)}$setLevel(b){this.setLevel(b)}trace(b,...C){this.getLevel()<=m.LogLevel.Trace&&this._proxy.$log(this._logFile,m.LogLevel.Trace,Array.from(arguments))}debug(b,...C){this.getLevel()<=m.LogLevel.Debug&&this._proxy.$log(this._logFile,m.LogLevel.Debug,Array.from(arguments))}info(b,...C){this.getLevel()<=m.LogLevel.Info&&this._proxy.$log(this._logFile,m.LogLevel.Info,Array.from(arguments))}warn(b,...C){this.getLevel()<=m.LogLevel.Warning&&this._proxy.$log(this._logFile,m.LogLevel.Warning,Array.from(arguments))}error(b,...C){this.getLevel()<=m.LogLevel.Error&&this._proxy.$log(this._logFile,m.LogLevel.Error,Array.from(arguments))}critical(b,...C){this.getLevel()<=m.LogLevel.Critical&&this._proxy.$log(this._logFile,m.LogLevel.Critical,Array.from(arguments))}flush(){}};k=He([ze(0,y.IExtHostRpcService),ze(1,S.IExtHostInitDataService)],k),e.ExtHostLogService=k}),define(we[208],_e([0,1,13,18,11,3,7,113,177,99,23]),function(ee,e,m,T,S,y,k,D,b,C,n){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function o(r,l){try{return JSON.stringify(r,l)}catch(_){return"null"}}function f(r,l){return JSON.stringify(r,l)}function c(r){return r?(l,_)=>_&&_.$mid===1?r.transformOutgoing(_):_:null}var d;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const v=()=>{},E=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class h extends k.Disposable{constructor(l,_=null,p=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=l,this._logger=_,this._uriTransformer=p,this._uriReplacer=c(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let P=0,A=C.ProxyIdentifier.count;P<A;P++)this._locals[P]=null,this._proxies[P]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new m.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(P=>this._receiveOneMessage(P))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(l=>{this._pendingRPCReplies[l].resolveErr(S.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(l){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(l){this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(l){this._responsiveState!==l&&(this._responsiveState=l,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(l){return this._uriTransformer?D.transformIncomingURIs(l,this._uriTransformer):l}getProxy(l){const{nid:_,sid:p}=l;return this._proxies[_]||(this._proxies[_]=this._createProxy(_,p)),this._proxies[_]}_createProxy(l,_){let p={get:(P,A)=>(typeof A=="string"&&!P[A]&&A.charCodeAt(0)===36&&(P[A]=(...a)=>this._remoteCall(l,A,a)),A===u?_:P[A])};return new Proxy(Object.create(null),p)}set(l,_){return this._locals[l.nid]=_,_}assertRegistered(l){for(let _=0,p=l.length;_<p;_++){const P=l[_];if(!this._locals[P.nid])throw new Error(`Missing actor ${P.sid} (isMain: ${P.isMain})`)}}_receiveOneMessage(l){if(this._isDisposed)return;const _=l.byteLength,p=g.read(l,0),P=p.readUInt8(),A=p.readUInt32();switch(P){case 1:case 2:{let{rpcId:a,method:R,args:F}=t.deserializeRequestJSONArgs(p);this._uriTransformer&&(F=D.transformIncomingURIs(F,this._uriTransformer)),this._receiveRequest(_,A,a,R,F,P===2);break}case 3:case 4:{let{rpcId:a,method:R,args:F}=t.deserializeRequestMixedArgs(p);this._uriTransformer&&(F=D.transformIncomingURIs(F,this._uriTransformer)),this._receiveRequest(_,A,a,R,F,P===4);break}case 5:{this._logger&&this._logger.logIncoming(_,A,0,"ack"),this._onDidReceiveAcknowledge(A);break}case 6:{this._receiveCancel(_,A);break}case 7:{this._receiveReply(_,A,void 0);break}case 9:{let a=t.deserializeReplyOKJSON(p);this._uriTransformer&&(a=D.transformIncomingURIs(a,this._uriTransformer)),this._receiveReply(_,A,a);break}case 8:{let a=t.deserializeReplyOKVSBuffer(p);this._receiveReply(_,A,a);break}case 10:{let a=t.deserializeReplyErrError(p);this._uriTransformer&&(a=D.transformIncomingURIs(a,this._uriTransformer)),this._receiveReplyErr(_,A,a);break}case 11:{this._receiveReplyErr(_,A,void 0);break}default:console.error("received unexpected message"),console.error(l)}}_receiveRequest(l,_,p,P,A,a){this._logger&&this._logger.logIncoming(l,_,1,`receiveRequest ${C.getStringIdentifierForProxy(p)}.${P}(`,A);const R=String(_);let F,x;if(a){const ae=new T.CancellationTokenSource;A.push(ae.token),F=this._invokeHandler(p,P,A),x=()=>ae.cancel()}else F=this._invokeHandler(p,P,A),x=v;this._cancelInvokedHandlers[R]=x;const J=t.serializeAcknowledged(_);this._logger&&this._logger.logOutgoing(J.byteLength,_,1,"ack"),this._protocol.send(J),F.then(ae=>{delete this._cancelInvokedHandlers[R];const j=t.serializeReplyOK(_,ae,this._uriReplacer);this._logger&&this._logger.logOutgoing(j.byteLength,_,1,"reply:",ae),this._protocol.send(j)},ae=>{delete this._cancelInvokedHandlers[R];const j=t.serializeReplyErr(_,ae);this._logger&&this._logger.logOutgoing(j.byteLength,_,1,"replyErr:",ae),this._protocol.send(j)})}_receiveCancel(l,_){this._logger&&this._logger.logIncoming(l,_,1,"receiveCancel");const p=String(_);this._cancelInvokedHandlers[p]&&this._cancelInvokedHandlers[p]()}_receiveReply(l,_,p){this._logger&&this._logger.logIncoming(l,_,0,"receiveReply:",p);const P=String(_);if(!this._pendingRPCReplies.hasOwnProperty(P))return;const A=this._pendingRPCReplies[P];delete this._pendingRPCReplies[P],A.resolveOk(p)}_receiveReplyErr(l,_,p){this._logger&&this._logger.logIncoming(l,_,0,"receiveReplyErr:",p);const P=String(_);if(!this._pendingRPCReplies.hasOwnProperty(P))return;const A=this._pendingRPCReplies[P];delete this._pendingRPCReplies[P];let a;p&&(p.$isError?(a=new Error,a.name=p.name,a.message=p.message,a.stack=p.stack):a=p),A.resolveErr(a)}_invokeHandler(l,_,p){try{return Promise.resolve(this._doInvokeHandler(l,_,p))}catch(P){return Promise.reject(P)}}_doInvokeHandler(l,_,p){const P=this._locals[l];if(!P)throw new Error("Unknown actor "+C.getStringIdentifierForProxy(l));let A=P[_];if(typeof A!="function")throw new Error("Unknown method "+_+" on actor "+C.getStringIdentifierForProxy(l));return A.apply(P,p)}_remoteCall(l,_,p){if(this._isDisposed)return Promise.reject(S.canceled());let P=null;if(p.length>0&&T.CancellationToken.isCancellationToken(p[p.length-1])&&(P=p.pop()),P&&P.isCancellationRequested)return Promise.reject(S.canceled());const A=t.serializeRequestArguments(p,this._uriReplacer),a=++this._lastMessageId,R=String(a),F=new b.LazyPromise;P&&P.onCancellationRequested(()=>{const J=t.serializeCancel(a);this._logger&&this._logger.logOutgoing(J.byteLength,a,0,"cancel"),this._protocol.send(t.serializeCancel(a))}),this._pendingRPCReplies[R]=F,this._onWillSendRequest(a);const x=t.serializeRequest(a,l,_,A,!!P);return this._logger&&this._logger.logOutgoing(x.byteLength,a,0,`request: ${C.getStringIdentifierForProxy(l)}.${_}(`,p),this._protocol.send(x),F}}e.RPCProtocol=h,I=E,h.UNRESPONSIVE_TIME=3*1e3;class g{constructor(l,_){this._buff=l,this._offset=_}static alloc(l,_,p){let P=new g(n.VSBuffer.alloc(p+1+4),0);return P.writeUInt8(l),P.writeUInt32(_),P}static read(l,_){return new g(l,_)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(l){this._buff.writeUInt8(l,this._offset),this._offset+=1}readUInt8(){const l=this._buff.readUInt8(this._offset);return this._offset+=1,l}writeUInt32(l){this._buff.writeUInt32BE(l,this._offset),this._offset+=4}readUInt32(){const l=this._buff.readUInt32BE(this._offset);return this._offset+=4,l}static sizeShortString(l){return 1+l.byteLength}writeShortString(l){this._buff.writeUInt8(l.byteLength,this._offset),this._offset+=1,this._buff.set(l,this._offset),this._offset+=l.byteLength}readShortString(){const l=this._buff.readUInt8(this._offset);this._offset+=1;const p=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,p}static sizeLongString(l){return 4+l.byteLength}writeLongString(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readLongString(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const p=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,p}writeBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}static sizeVSBuffer(l){return 4+l.byteLength}writeVSBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readVSBuffer(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const _=this._buff.slice(this._offset,this._offset+l);return this._offset+=l,_}static sizeMixedArray(l,_){let p=0;p+=1;for(let P=0,A=l.length;P<A;P++){const a=l[P],R=_[P];switch(p+=1,R){case 1:p+=this.sizeLongString(a);break;case 2:p+=this.sizeVSBuffer(a);break;case 3:break}}return p}writeMixedArray(l,_){this._buff.writeUInt8(l.length,this._offset),this._offset+=1;for(let p=0,P=l.length;p<P;p++){const A=l[p];switch(_[p]){case 1:this.writeUInt8(1),this.writeLongString(A);break;case 2:this.writeUInt8(2),this.writeVSBuffer(A);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const l=this._buff.readUInt8(this._offset);this._offset+=1;let _=new Array(l);for(let p=0;p<l;p++)switch(this.readUInt8()){case 1:_[p]=this.readLongString();break;case 2:_[p]=this.readVSBuffer();break;case 3:_[p]=void 0;break}return _}}class t{static _arrayContainsBufferOrUndefined(l){for(let _=0,p=l.length;_<p;_++)if(l[_]instanceof n.VSBuffer||typeof l[_]=="undefined")return!0;return!1}static serializeRequestArguments(l,_){if(this._arrayContainsBufferOrUndefined(l)){let p=[],P=[];for(let A=0,a=l.length;A<a;A++){const R=l[A];R instanceof n.VSBuffer?(p[A]=R,P[A]=2):typeof R=="undefined"?(p[A]=n.VSBuffer.alloc(0),P[A]=3):(p[A]=n.VSBuffer.fromString(f(R,_)),P[A]=1)}return{type:"mixed",args:p,argsType:P}}return{type:"simple",args:f(l,_)}}static serializeRequest(l,_,p,P,A){return P.type==="mixed"?this._requestMixedArgs(l,_,p,P.args,P.argsType,A):this._requestJSONArgs(l,_,p,P.args,A)}static _requestJSONArgs(l,_,p,P,A){const a=n.VSBuffer.fromString(p),R=n.VSBuffer.fromString(P);let F=0;F+=g.sizeUInt8(),F+=g.sizeShortString(a),F+=g.sizeLongString(R);let x=g.alloc(A?2:1,l,F);return x.writeUInt8(_),x.writeShortString(a),x.writeLongString(R),x.buffer}static deserializeRequestJSONArgs(l){const _=l.readUInt8(),p=l.readShortString(),P=l.readLongString();return{rpcId:_,method:p,args:JSON.parse(P)}}static _requestMixedArgs(l,_,p,P,A,a){const R=n.VSBuffer.fromString(p);let F=0;F+=g.sizeUInt8(),F+=g.sizeShortString(R),F+=g.sizeMixedArray(P,A);let x=g.alloc(a?4:3,l,F);return x.writeUInt8(_),x.writeShortString(R),x.writeMixedArray(P,A),x.buffer}static deserializeRequestMixedArgs(l){const _=l.readUInt8(),p=l.readShortString(),P=l.readMixedArray(),A=new Array(P.length);for(let a=0,R=P.length;a<R;a++){const F=P[a];typeof F=="string"?A[a]=JSON.parse(F):A[a]=F}return{rpcId:_,method:p,args:A}}static serializeAcknowledged(l){return g.alloc(5,l,0).buffer}static serializeCancel(l){return g.alloc(6,l,0).buffer}static serializeReplyOK(l,_,p){return typeof _=="undefined"?this._serializeReplyOKEmpty(l):_ instanceof n.VSBuffer?this._serializeReplyOKVSBuffer(l,_):this._serializeReplyOKJSON(l,o(_,p))}static _serializeReplyOKEmpty(l){return g.alloc(7,l,0).buffer}static _serializeReplyOKVSBuffer(l,_){let p=0;p+=g.sizeVSBuffer(_);let P=g.alloc(8,l,p);return P.writeVSBuffer(_),P.buffer}static deserializeReplyOKVSBuffer(l){return l.readVSBuffer()}static _serializeReplyOKJSON(l,_){const p=n.VSBuffer.fromString(_);let P=0;P+=g.sizeLongString(p);let A=g.alloc(9,l,P);return A.writeLongString(p),A.buffer}static deserializeReplyOKJSON(l){const _=l.readLongString();return JSON.parse(_)}static serializeReplyErr(l,_){return _?this._serializeReplyErrEror(l,_):this._serializeReplyErrEmpty(l)}static _serializeReplyErrEror(l,_){const p=n.VSBuffer.fromString(o(S.transformErrorForSerialization(_),null));let P=0;P+=g.sizeLongString(p);let A=g.alloc(10,l,P);return A.writeLongString(p),A.buffer}static deserializeReplyErrError(l){const _=l.readLongString();return JSON.parse(_)}static _serializeReplyErrEmpty(l){return g.alloc(11,l,0).buffer}}var i;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(i||(i={}));var s;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(s||(s={}))}),define(we[209],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const m=function(y){const k=D=>{self.removeEventListener("message",k);const b=D.data;Object.defineProperties(self,{postMessage:{value(C,n){b.postMessage(C,n)}},onmessage:{get(){return b.onmessage},set(C){b.onmessage=C}}}),b.addEventListener("message",C=>{self.dispatchEvent(new MessageEvent("message",{data:C.data}))}),b.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(y)};self.addEventListener("message",k)}.toString();class T extends EventTarget{constructor(y,k,D){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const b=`((${m})('${k}'))`,C=new Blob([b],{type:"application/javascript"}),n=URL.createObjectURL(C),I=new MessageChannel,o=n,f={type:"_newWorker",id:o,port:I.port2,url:n,options:D};y(f,[I.port2]),this.postMessage=I.port1.postMessage.bind(I.port1),this.terminate=()=>{const c={type:"_terminateWorker",id:o};I.port1.postMessage(c),URL.revokeObjectURL(n),I.port1.close(),I.port2.close()},Object.defineProperties(this,{onmessage:{get(){return I.port1.onmessage},set(c){I.port1.onmessage=c}},onmessageerror:{get(){return I.port1.onmessageerror},set(c){I.port1.onmessageerror=c}}}),I.port1.addEventListener("messageerror",c=>{const d=new MessageEvent("messageerror",{data:c.data});this.dispatchEvent(d)}),I.port1.addEventListener("message",c=>{const d=new MessageEvent("message",{data:c.data});this.dispatchEvent(d)}),I.port1.start()}}e.NestedWorker=T}),define(we[210],_e([0,1,5]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=m.createDecorator("remoteAgentService")}),define(we[211],_e([0,1,12,15,21,2,5,92,44,173,210]),function(ee,e,m,T,S,y,k,D,b,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=k.createDecorator("pathService");let I=class xn{constructor(f,c,d,w){this.localUserHome=f,this.remoteAgentService=c,this.environmentService=d,this.contextService=w,this.resolveOS=(async()=>{const v=await this.remoteAgentService.getEnvironment();return(v==null?void 0:v.os)||S.OS})(),this.resolveUserHome=(async()=>{const v=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(v==null?void 0:v.userHome)||f})()}get defaultUriScheme(){return xn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,c){if(f.remoteAuthority)return m.Schemas.vscodeRemote;const d=D.getVirtualWorkspaceScheme(c.getWorkspace());if(d)return d;const w=c.getWorkspace().folders[0];if(w)return w.uri.scheme;const v=c.getWorkspace().configuration;return v?v.scheme:m.Schemas.file}async userHome(f){return(f==null?void 0:f.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?T.win32:T.posix)}async fileURI(f){let c="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const w=f.indexOf("/",2);w===-1?(c=f.substring(2),f="/"):(c=f.substring(2,w),f=f.substring(w)||"/")}return y.URI.from({scheme:m.Schemas.file,authority:c,path:f,query:"",fragment:""})}};I=He([ze(1,n.IRemoteAgentService),ze(2,C.IWorkbenchEnvironmentService),ze(3,b.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(we[103],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class m{constructor(k,D){this.line=k,this.character=D}isBefore(k){return!1}isBeforeOrEqual(k){return!1}isAfter(k){return!1}isAfterOrEqual(k){return!1}isEqual(k){return!1}compareTo(k){return 0}translate(k,D){return new m(0,0)}with(k){return new m(0,0)}}e.Position=m;class T{constructor(k,D,b,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new m(k,D),this.end=new m(b,C)}contains(k){return!1}isEqual(k){return!1}intersection(k){}union(k){return new T(0,0,0,0)}with(k){return new T(0,0,0,0)}}e.Range=T;var S;(function(y){y[y.Information=1]="Information",y[y.Warning=2]="Warning"})(S=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[37],_e([0,1,17,27,24,42,8,5,15,11,103]),function(ee,e,m,T,S,y,k,D,b,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",o=" characters skipped \u27EB",f=(I.length+o.length+5)*2;e.ISearchService=D.createDecorator("searchService");var c;(function(M){M[M.file=0]="file",M[M.text=1]="text"})(c=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(M){M[M.File=1]="File",M[M.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function w(M){return!!M.preview}e.resultIsMatch=w;function v(M){return!!M.resource}e.isFileMatch=v;function E(M){return!!M.message}e.isProgressMessage=E;var u;(function(M){M[M.Normal=0]="Normal",M[M.NewSearchStarted=1]="NewSearchStarted"})(u=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class h{constructor(X){this.resource=X,this.results=[]}}e.FileMatch=h;class g{constructor(X,B,U){this.ranges=B;const Y=Array.isArray(B)?B:[B];if(U&&U.matchLines===1&&t(Y)){X=k.getNLines(X,U.matchLines);let V="",ce=0,ge=0;const Ae=Math.floor(U.charsPerLine/5),$e=[];for(const Fe of Y){const Ve=Math.max(Fe.startColumn-Ae,0),tt=Fe.startColumn+U.charsPerLine;if(Ve>ge+Ae+f){const Ke=I+(Ve-ge)+o;V+=Ke+X.slice(Ve,tt),ce+=Ve-(ge+Ke.length)}else V+=X.slice(ge,tt);$e.push(new s(0,Fe.startColumn-ce,Fe.endColumn-ce)),ge=tt}this.preview={text:V,matches:Array.isArray(this.ranges)?$e:$e[0]}}else{const V=Array.isArray(B)?B[0].startLineNumber:B.startLineNumber;this.preview={text:X,matches:m.mapArrayOrNot(B,ce=>new i(ce.startLineNumber-V,ce.startColumn,ce.endLineNumber-V,ce.endColumn))}}}}e.TextSearchMatch=g;function t(M){const X=M[0].startLineNumber;for(const B of M)if(B.startLineNumber!==X||B.endLineNumber!==X)return!1;return!0}class i{constructor(X,B,U,Y){this.startLineNumber=X,this.startColumn=B,this.endLineNumber=U,this.endColumn=Y}}e.SearchRange=i;class s extends i{constructor(X,B,U){super(X,B,X,U)}}e.OneLineRange=s;var r;(function(M){M.Default="default",M.FileNames="fileNames",M.Type="type",M.Modified="modified",M.CountDescending="countDescending",M.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function l(M,X=!0){const B=M&&M.files&&M.files.exclude,U=X&&M&&M.search&&M.search.exclude;if(!B&&!U)return;if(!B||!U)return B||U;let Y=Object.create(null);return Y=S.mixin(Y,S.deepClone(B)),Y=S.mixin(Y,S.deepClone(U),!0),Y}e.getExcludes=l;function _(M,X){return M.excludePattern&&T.match(M.excludePattern,X)?!1:M.includePattern||M.usingSearchPaths?M.includePattern&&T.match(M.includePattern,X)?!0:M.usingSearchPaths?!!M.folderQueries&&M.folderQueries.some(B=>{const U=B.folder.fsPath;if(y.isEqualOrParent(X,U)){const Y=b.relative(U,X);return!B.includePattern||!!T.match(B.includePattern,Y)}else return!1}):!1:!0}e.pathIncludedInQuery=_;var p;(function(M){M[M.unknownEncoding=1]="unknownEncoding",M[M.regexParseError=2]="regexParseError",M[M.globParseError=3]="globParseError",M[M.invalidLiteral=4]="invalidLiteral",M[M.rgProcessError=5]="rgProcessError",M[M.other=6]="other",M[M.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class P extends Error{constructor(X,B){super(X);this.code=B}}e.SearchError=P;function A(M){const X=M.message;if(C.isPromiseCanceledError(M))return new P(X,p.canceled);try{const B=JSON.parse(X);return new P(B.message,B.code)}catch(B){return new P(X,p.other)}}e.deserializeSearchError=A;function a(M){const X={message:M.message,code:M.code};return new Error(JSON.stringify(X))}e.serializeSearchError=a;function R(M){return M.type==="error"?!0:M.type==="success"}e.isSerializedSearchComplete=R;function F(M){return M.type==="success"}e.isSerializedSearchSuccess=F;function x(M){return!!M.path}e.isSerializedFileMatch=x;function J(M,X){const B=M.searchPath?M.searchPath:M.relativePath;return k.fuzzyContains(B,X)}e.isFilePatternMatch=J;class ae{constructor(X){this.path=X,this.results=[]}addMatch(X){this.results.push(X)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=ae;function j(M,X){const B=Object.assign(Object.assign({},M||{}),X||{});return Object.keys(B).filter(U=>{const Y=B[U];return typeof Y=="boolean"&&Y})}e.resolvePatternsForProvider=j;class W{constructor(X,B){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},X.excludePattern||{}),B.excludePattern||{}),this._parsedExcludeExpression=T.parse(this._excludeExpression);let U=X.includePattern;B.includePattern&&(U?U=Object.assign(Object.assign({},U),B.includePattern):U=B.includePattern),U&&(this._parsedIncludeExpression=T.parse(U))}includedInQuerySync(X,B,U){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(X,B,U)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(X,B,U))}includedInQuery(X,B,U){return Promise.resolve(this._parsedExcludeExpression(X,B,U)).then(V=>!!V).then(V=>V?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(X,B,U)).then(ce=>!!ce):Promise.resolve(!0)).then(V=>V)}hasSiblingExcludeClauses(){return Q(this._excludeExpression)}}e.QueryGlobTester=W;function Q(M){for(const X in M)if(typeof M[X]!="boolean")return!0;return!1}}),define(we[31],_e([0,1,17,13,18,3,22,12,76,25,8,10,2,134,5,16,147,44,45,28,14,6,37,4]),function(ee,e,m,T,S,y,k,D,b,C,n,I,o,f,c,d,w,v,E,u,h,g,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(R,F,x){return new C.ExtUri(J=>p(J,x)).isEqual(R,F)}function r(R,F,x){return s(R.uri,F.uri,x)?0:n.compare(R.uri.toString(),F.uri.toString())}function l(R,F,x){return R.index!==F.index?R.index<F.index?-1:1:s(R.uri,F.uri,x)?n.compare(R.name,F.name):n.compare(R.uri.toString(),F.uri.toString())}function _(R,F,x,J){const ae=R.slice(0).sort((W,Q)=>x(W,Q,J)),j=F.slice(0).sort((W,Q)=>x(W,Q,J));return m.delta(ae,j,(W,Q)=>x(W,Q,J))}function p(R,F){const x=F.getCapabilities(R.scheme);return!(x&&x&1024)}class P extends v.Workspace{constructor(F,x,J,ae,j,W){super(F,J.map(Q=>new v.WorkspaceFolder(Q)),ae,W);this._name=x,this._isUntitled=j,this._workspaceFolders=[],this._structure=k.TernarySearchTree.forUris(W),J.forEach(Q=>{this._workspaceFolders.push(Q),this._structure.set(Q.uri,Q)})}static toExtHostWorkspace(F,x,J,ae){if(!F)return{workspace:null,added:[],removed:[]};const{id:j,name:W,folders:Q,configuration:M,isUntitled:X}=F,B=[],U=x;x?Q.forEach((ge,Ae)=>{const $e=o.URI.revive(ge.uri),Fe=P._findFolder(J||x,$e,ae);Fe?(Fe.name=ge.name,Fe.index=ge.index,B.push(Fe)):B.push({uri:$e,name:ge.name,index:Ae})}):B.push(...Q.map(({uri:ge,name:Ae,index:$e})=>({uri:o.URI.revive(ge),name:Ae,index:$e}))),B.sort((ge,Ae)=>ge.index<Ae.index?-1:1);const Y=new P(j,W,B,M?o.URI.revive(M):null,!!X,ge=>p(ge,ae)),{added:V,removed:ce}=_(U?U.workspaceFolders:[],Y.workspaceFolders,r,ae);return{workspace:Y,added:V,removed:ce}}static _findFolder(F,x,J){for(let ae=0;ae<F.folders.length;ae++){const j=F.workspaceFolders[ae];if(s(j.uri,x,J))return j}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,x){return x&&this._structure.get(F)&&(F=C.dirname(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let A=class{constructor(F,x,J,ae){this._onDidChangeWorkspace=new y.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new y.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=ae,this._extHostFileSystemInfo=J,this._requestIdProvider=new b.Counter,this._barrier=new T.Barrier,this._proxy=F.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(i.MainContext.MainThreadMessageService);const j=x.workspace;this._confirmedWorkspace=j?new P(j.id,j.name,[],j.configuration?o.URI.revive(j.configuration):null,!!j.isUntitled,W=>p(W,J)):void 0}$initializeWorkspace(F,x){this._trusted=x,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?o.URI.from({scheme:D.Schemas.untitled,path:C.basename(C.dirname(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,x,J,...ae){const j=[];if(Array.isArray(ae)&&ae.forEach(B=>{o.URI.isUri(B.uri)&&!j.some(U=>s(U.uri,B.uri,this._extHostFileSystemInfo))&&j.push({uri:B.uri,name:B.name||C.basenameOrAuthority(B.uri)})}),this._unconfirmedWorkspace||[x,J].some(B=>typeof B!="number"||B<0)||J===0&&j.length===0)return!1;const W=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(x+J>W.length)return!1;const Q=W.slice(0);Q.splice(x,J,...j.map(B=>({uri:B.uri,name:B.name||C.basenameOrAuthority(B.uri),index:void 0})));for(let B=0;B<Q.length;B++){const U=Q[B];if(Q.some((Y,V)=>V!==B&&s(U.uri,Y.uri,this._extHostFileSystemInfo)))return!1}Q.forEach((B,U)=>B.index=U);const{added:M,removed:X}=_(W,Q,l,this._extHostFileSystemInfo);if(M.length===0&&X.length===0)return!1;if(this._proxy){const B=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(B,x,J,j).then(void 0,U=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(w.Severity.Error,f.localize(0,null,B,U.toString()),{extension:F},[])})}return this.trySetWorkspaceFolders(Q),!0}getWorkspaceFolder(F,x){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,x)}async getWorkspaceFolder2(F,x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,x)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!this._actualWorkspace)return;const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,x){let J,ae="";if(typeof F=="string"?(J=o.URI.file(F),ae=F):typeof F!="undefined"&&(J=F,ae=F.fsPath),!J)return ae;const j=this.getWorkspaceFolder(J,!0);if(!j)return ae;typeof x=="undefined"&&this._actualWorkspace&&(x=this._actualWorkspace.folders.length>1);let W=C.relativePath(j.uri,J);return x&&j.name&&(W=`${j.name}/${W}`),W}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=P.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:x,added:J,removed:ae}=P.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=x||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:J,removed:ae}))}findFiles(F,x,J,ae,j=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${ae.value}, entryPoint: findFiles`);let W;if(x===null?W=!1:x&&(typeof x=="string"?W=x:W=x.pattern),j&&j.isCancellationRequested)return Promise.resolve([]);const{includePattern:Q,folder:M}=a(F);return this._proxy.$startFileSearch(I.withUndefinedAsNull(Q),I.withUndefinedAsNull(M),I.withUndefinedAsNull(W),I.withUndefinedAsNull(J),j).then(X=>Array.isArray(X)?X.map(B=>o.URI.revive(B)):[])}async findTextInFiles(F,x,J,ae,j=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${ae.value}, entryPoint: findTextInFiles`);const W=this._requestIdProvider.getNext(),Q=typeof x.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:x.previewOptions,{includePattern:M,folder:X}=a(x.include),B=typeof x.exclude=="string"?x.exclude:x.exclude?x.exclude.pattern:void 0,U={ignoreSymlinks:typeof x.followSymlinks=="boolean"?!x.followSymlinks:void 0,disregardIgnoreFiles:typeof x.useIgnoreFiles=="boolean"?!x.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof x.useGlobalIgnoreFiles=="boolean"?!x.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof x.useDefaultExcludes=="boolean"?!x.useDefaultExcludes:!0,fileEncoding:x.encoding,maxResults:x.maxResults,previewOptions:Q,afterContext:x.afterContext,beforeContext:x.beforeContext,includePattern:M,excludePattern:B},Y=!1;if(this._activeSearchCallbacks[W]=V=>{if(Y)return;const ce=o.URI.revive(V.resource);V.results.forEach(ge=>{t.resultIsMatch(ge)?J({uri:ce,preview:{text:ge.preview.text,matches:m.mapArrayOrNot(ge.preview.matches,Ae=>new g.Range(Ae.startLineNumber,Ae.startColumn,Ae.endLineNumber,Ae.endColumn))},ranges:m.mapArrayOrNot(ge.ranges,Ae=>new g.Range(Ae.startLineNumber,Ae.startColumn,Ae.endLineNumber,Ae.endColumn))}):J({uri:ce,text:ge.text,lineNumber:ge.lineNumber})})},j.isCancellationRequested)return{};try{const V=await this._proxy.$startTextSearch(F,I.withUndefinedAsNull(X),U,W,j);return delete this._activeSearchCallbacks[W],V||{}}catch(V){throw delete this._activeSearchCallbacks[W],V}}$handleTextSearchResult(F,x){this._activeSearchCallbacks[x]&&this._activeSearchCallbacks[x](F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trusted(){return this._trusted}requestWorkspaceTrust(F){return this._proxy.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};A=He([ze(0,h.IExtHostRpcService),ze(1,u.IExtHostInitDataService),ze(2,E.IExtHostFileSystemInfo),ze(3,d.ILogService)],A),e.ExtHostWorkspace=A,e.IExtHostWorkspace=c.createDecorator("IExtHostWorkspace");function a(R){let F,x;return R&&(typeof R=="string"?F=R:(F=R.pattern,x=R.baseFolder||o.URI.file(R.base))),{includePattern:F,folder:x}}}),define(we[32],_e([0,1,24,3,31,4,6,151,61,10,13,5,14,16,2]),function(ee,e,m,T,S,y,k,D,b,C,n,I,o,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(i,s){if(s){const r=s.split(".");let l=i;for(let _=0;l&&_<r.length;_++)l=l[r[_]];return l}}function w(i){return i instanceof c.URI}function v(i){return i&&i.uri instanceof c.URI&&i.languageId&&typeof i.languageId=="string"}function E(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function u(i){return i&&i.uri instanceof c.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function h(i){if(w(i))return{resource:i};if(v(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(E(i))return{overrideIdentifier:i.languageId};if(u(i))return{resource:i.uri};if(i===null)return{resource:null}}let g=class{constructor(s,r,l){this._proxy=s.getProxy(y.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=l,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,r){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(s,r))}};g=He([ze(0,o.IExtHostRpcService),ze(1,S.IExtHostWorkspace),ze(2,f.ILogService)],g),e.ExtHostConfiguration=g;class t{constructor(s,r,l,_){this._onDidChangeConfiguration=new T.Emitter,this._proxy=s,this._logService=_,this._extHostWorkspace=r,this._configuration=D.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,r){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,l))}getConfiguration(s,r,l){const _=h(r)||{},p=this._toReadonlyValue(s?d(this._configuration.getValue(void 0,_,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,_,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,_,l==null?void 0:l.identifier);function P(a){if(a==null)return null;if(typeof a=="boolean")return a?1:4;switch(a){case k.ConfigurationTarget.Global:return 1;case k.ConfigurationTarget.Workspace:return 4;case k.ConfigurationTarget.WorkspaceFolder:return 5}}const A={has(a){return typeof d(p,a)!="undefined"},get:(a,R)=>{this._validateConfigurationAccess(s?`${s}.${a}`:a,_,l==null?void 0:l.identifier);let F=d(p,a);if(typeof F=="undefined")F=R;else{let x;const J=(ae,j)=>{let W;const Q=()=>{x=x||m.deepClone(p),W=W||d(x,j)};return C.isObject(ae)?new Proxy(ae,{get:(M,X)=>{if(typeof X=="string"&&X.toLowerCase()==="tojson")return Q(),()=>W;if(x)return W=W||d(x,j),W[X];const B=M[X];return typeof X=="string"?J(B,`${j}.${X}`):B},set:(M,X,B)=>(Q(),W&&(W[X]=B),!0),deleteProperty:(M,X)=>(Q(),W&&delete W[X],!0),defineProperty:(M,X,B)=>(Q(),W&&Object.defineProperty(W,X,B),!0)}):ae};F=J(F,a)}return F},update:(a,R,F,x)=>{a=s?`${s}.${a}`:a;const J=P(F);return R!==void 0?this._proxy.$updateConfigurationOption(J,a,R,_,x):this._proxy.$removeConfigurationOption(J,a,_,x)},inspect:a=>{var R,F,x,J,ae,j,W,Q;a=s?`${s}.${a}`:a;const M=m.deepClone(this._configuration.inspect(a,_,this._extHostWorkspace.workspace));if(M)return{key:a,defaultValue:(R=M.default)===null||R===void 0?void 0:R.value,globalValue:(F=M.user)===null||F===void 0?void 0:F.value,workspaceValue:(x=M.workspace)===null||x===void 0?void 0:x.value,workspaceFolderValue:(J=M.workspaceFolder)===null||J===void 0?void 0:J.value,defaultLanguageValue:(ae=M.default)===null||ae===void 0?void 0:ae.override,globalLanguageValue:(j=M.user)===null||j===void 0?void 0:j.override,workspaceLanguageValue:(W=M.workspace)===null||W===void 0?void 0:W.override,workspaceFolderLanguageValue:(Q=M.workspaceFolder)===null||Q===void 0?void 0:Q.override,languageIds:M.overrideIdentifiers}}};return typeof p=="object"&&m.mixin(A,p,!1),Object.freeze(A)}_toReadonlyValue(s){const r=l=>C.isObject(l)?new Proxy(l,{get:(_,p)=>r(_[p]),set:(_,p,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(_,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(_,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:_=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return r(s)}_validateConfigurationAccess(s,r,l){const _=b.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),p=l?`[${l.value}] `:"";if(_===4){typeof(r==null?void 0:r.resource)=="undefined"&&this._logService.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(_===3){(r==null?void 0:r.resource)&&this._logService.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,r){const l=new D.ConfigurationChangeEvent(s,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(_,p)=>l.affectsConfiguration(_,h(p))})}_toMap(s){return s.reduce((r,l)=>(r.set(l[0],l[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=I.createDecorator("IExtHostConfiguration")});var rt=this&&this.__classPrivateFieldSet||function(ee,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,m):S?S.value=m:e.set(ee,m),m},Ue=this&&this.__classPrivateFieldGet||function(ee,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[104],_e([0,1,2,13,3,4,6,31,46,32,18,36,14,28,5,12,21,16,69,162,11]),function(ee,e,m,T,S,y,k,D,b,C,n,I,o,f,c,d,w,v,E,u,h){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(ae){function j(Q){if(Q!=null)return Q}ae.from=j;function W(Q){if(Q!=null)return Q}ae.to=W})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var i;(function(ae){function j(Q){if(Q!=null)return Q}ae.from=j;function W(Q){if(Q!=null)return Q}ae.to=W})(i=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(ae){function j(Q){if(Q!=null)return Q}ae.from=j;function W(Q){if(Q!=null)return Q}ae.to=W})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(ae){function j(M){if(M){const X=M;return X&&!!X.process}else return!1}ae.is=j;function W(M){if(M==null)return;const X={process:M.process,args:M.args};return M.options&&(X.options=s.from(M.options)),X}ae.from=W;function Q(M){if(M!=null)return new k.ProcessExecution(M.process,M.args,M.options)}ae.to=Q})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var l;(function(ae){function j(Q){if(Q!=null)return Q}ae.from=j;function W(Q){if(Q!=null)return Q}ae.to=W})(l=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var _;(function(ae){function j(M){if(M){const X=M;return X&&(!!X.commandLine||!!X.command)}else return!1}ae.is=j;function W(M){if(M==null)return;const X={};return M.commandLine!==void 0?X.commandLine=M.commandLine:(X.command=M.command,X.args=M.args),M.options&&(X.options=l.from(M.options)),X}ae.from=W;function Q(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new k.ShellExecution(M.commandLine,M.options):new k.ShellExecution(M.command,M.args?M.args:[],M.options)}ae.to=Q})(_=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var p;(function(ae){function j(M){if(M){let X=M;return X&&X.customExecution==="customExecution"}else return!1}ae.is=j;function W(M){return{customExecution:"customExecution"}}ae.from=W;function Q(M,X){return X.get(M)}ae.to=Q})(p=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var P;(function(ae){function j(W,Q){let M;return W.scope!==void 0&&typeof W.scope!="number"?M=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===k.TaskScope.Workspace&&Q&&Q.workspaceFile?M=Q.workspaceFile:M=u.USER_TASKS_GROUP_KEY),{id:W._id,workspaceFolder:M}}ae.from=j})(P=e.TaskHandleDTO||(e.TaskHandleDTO={}));var A;(function(ae){function j(M,X){if(M==null)return[];const B=[];for(let U of M){const Y=W(U,X);Y&&B.push(Y)}return B}ae.fromMany=j;function W(M,X){if(M==null)return;let B;M.execution instanceof k.ProcessExecution?B=r.from(M.execution):M.execution instanceof k.ShellExecution?B=_.from(M.execution):M.execution&&M.execution instanceof k.CustomExecution&&(B=p.from(M.execution));const U=t.from(M.definition);let Y;if(M.scope?typeof M.scope=="number"?Y=M.scope:Y=M.scope.uri:Y=k.TaskScope.Workspace,!U||!Y)return;const V=M.group?M.group.id:void 0;return{_id:M._id,definition:U,name:M.name,source:{extensionId:X.identifier.value,label:M.source,scope:Y},execution:B,isBackground:M.isBackground,group:V,presentationOptions:i.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}ae.from=W;async function Q(M,X,B){if(M==null)return;let U;r.is(M.execution)?U=r.to(M.execution):_.is(M.execution)?U=_.to(M.execution):p.is(M.execution)&&(U=p.to(M._id,B));const Y=t.to(M.definition);let V;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?V=M.source.scope:V=await X.resolveWorkspaceFolder(m.URI.revive(M.source.scope)):V=k.TaskScope.Workspace),!Y||!V)return;const ce=new k.Task(Y,V,M.name,M.source.label,U,M.problemMatchers);return M.isBackground!==void 0&&(ce.isBackground=M.isBackground),M.group!==void 0&&(ce.group=k.TaskGroup.from(M.group)),M.presentationOptions&&(ce.presentationOptions=i.to(M.presentationOptions)),M._id&&(ce._id=M._id),M.detail&&(ce.detail=M.detail),ce}ae.to=Q})(A=e.TaskDTO||(e.TaskDTO={}));var a;(function(ae){function j(Q){return Q}ae.from=j;function W(Q){if(!!Q)return Object.assign(Object.create(null),Q)}ae.to=W})(a=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(j,W,Q){this._id=W,this._task=Q,g.set(this,void 0),rt(this,g,j,"f")}get task(){return this._task}terminate(){Ue(this,g,"f").terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}g=new WeakMap;var F;(function(ae){function j(W){return{id:W._id,task:void 0}}ae.from=j})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let x=class{constructor(j,W,Q,M,X,B,U,Y){this._onDidExecuteTask=new S.Emitter,this._onDidTerminateTask=new S.Emitter,this._onDidTaskProcessStarted=new S.Emitter,this._onDidTaskProcessEnded=new S.Emitter,this._proxy=j.getProxy(y.MainContext.MainThreadTask),this._workspaceProvider=Q,this._editorService=M,this._configurationService=X,this._terminalService=B,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=U,this._deprecationService=Y,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(j,W,Q){if(!Q)return new k.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:W,provider:Q,extension:j}),this._proxy.$registerTaskProvider(M,W),new k.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(j,W){this._proxy.$registerTaskSystem(j,W)}fetchTasks(j){return this._proxy.$fetchTasks(a.from(j)).then(async W=>{const Q=[];for(let M of W){const X=await A.to(M,this._workspaceProvider,this._providedCustomExecutions2);X&&Q.push(X)}return Q})}get taskExecutions(){const j=[];return this._taskExecutions.forEach(W=>j.push(W)),j}terminateTask(j){if(!(j instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(j._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(j,W,Q){const M=this._providedCustomExecutions2.get(j.id);if(M){if(this._activeCustomExecutions2.get(j.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(j.id,M),this._terminalService.attachPtyToTerminal(W,await M.callback(Q))}this._lastStartedTask=j.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(j)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(j){const W=await this.getTaskExecution(j);this._taskExecutionPromises.delete(j.id),this._taskExecutions.delete(j.id),this.customExecutionComplete(j),this._onDidTerminateTask.fire({execution:W})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(j){const W=await this.getTaskExecution(j.id);this._onDidTaskProcessStarted.fire({execution:W,processId:j.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(j){const W=await this.getTaskExecution(j.id);this._onDidTaskProcessEnded.fire({execution:W,exitCode:j.exitCode})}$provideTasks(j,W){const Q=this._handlers.get(j);if(!Q)return Promise.reject(new Error("no handler found"));const M=[],X=T.asPromise(()=>Q.provider.provideTasks(n.CancellationToken.None)).then(B=>this.provideTasksInternal(W,M,Q,B));return new Promise(B=>{X.then(U=>{Promise.all(M).then(()=>{B(U)})})})}async $resolveTask(j,W){const Q=this._handlers.get(j);if(!Q)return Promise.reject(new Error("no handler found"));if(W.definition.type!==Q.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${Q.type}].`);const M=await A.to(W,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const X=await Q.provider.resolveTask(M,n.CancellationToken.None);if(!X)return;this.checkDeprecation(X,Q);const B=A.from(X,Q.extension);if(!B)throw new Error("Unexpected: Task cannot be resolved.");if(X.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(B.execution)&&await this.addCustomExecution(B,X,!0),await this.resolveTaskInternal(B)}nextHandle(){return this._handleCounter++}async addCustomExecution(j,W,Q){const M=await this._proxy.$createTaskId(j);!Q&&!this._providedCustomExecutions2.has(M)&&this._notProvidedCustomExecutions.add(M),this._providedCustomExecutions2.set(M,W.execution)}async getTaskExecution(j,W){if(typeof j=="string"){const X=this._taskExecutionPromises.get(j);if(!X)throw new Error("Unexpected: The specified task is missing an execution");return X}let Q=this._taskExecutionPromises.get(j.id);if(Q)return Q;const M=new Promise(async(X,B)=>{const U=W||await A.to(j.task,this._workspaceProvider,this._providedCustomExecutions2);U?X(new R(this,j.id,U)):B("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(j.id,M),M.then(X=>(this._taskExecutions.set(j.id,X),X),X=>Promise.reject(X))}checkDeprecation(j,W){j._deprecated&&this._deprecationService.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(j){this._activeCustomExecutions2.get(j.id)&&this._activeCustomExecutions2.delete(j.id),this._notProvidedCustomExecutions.has(j.id)&&this._lastStartedTask!==j.id&&(this._providedCustomExecutions2.delete(j.id),this._notProvidedCustomExecutions.delete(j.id));let Q=this._notProvidedCustomExecutions.values(),M=Q.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=Q.next()}};x=He([ze(0,o.IExtHostRpcService),ze(1,f.IExtHostInitDataService),ze(2,D.IExtHostWorkspace),ze(3,b.IExtHostDocumentsAndEditors),ze(4,C.IExtHostConfiguration),ze(5,I.IExtHostTerminalService),ze(6,v.ILogService),ze(7,E.IExtHostApiDeprecationService)],x),e.ExtHostTaskBase=x;let J=class extends x{constructor(j,W,Q,M,X,B,U,Y){super(j,W,Q,M,X,B,U,Y);this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:w.PlatformToString(0)})}async executeTask(j,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const Q=A.from(W,j);if(Q===void 0)throw new Error("Task is not valid");if(p.is(Q.execution))await this.addCustomExecution(Q,W,!1);else throw new h.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(Q),W);return this._proxy.$executeTask(Q).catch(X=>{throw new Error(X)}),M}provideTasksInternal(j,W,Q,M){const X=[];if(M)for(let B of M){this.checkDeprecation(B,Q),(!B.definition||!j[B.definition.type])&&this._logService.warn(`The task [${B.source}, ${B.name}] uses an undefined task type. The task will be ignored in the future.`);const U=A.from(B,Q.extension);U&&p.is(U.execution)?(X.push(U),W.push(this.addCustomExecution(U,B,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:X,extension:Q.extension}}async resolveTaskInternal(j){if(p.is(j.execution))return j;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(j,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,W,Q){}};J=He([ze(0,o.IExtHostRpcService),ze(1,f.IExtHostInitDataService),ze(2,D.IExtHostWorkspace),ze(3,b.IExtHostDocumentsAndEditors),ze(4,C.IExtHostConfiguration),ze(5,I.IExtHostTerminalService),ze(6,v.ILogService),ze(7,E.IExtHostApiDeprecationService)],J),e.WorkerExtHostTask=J,e.IExtHostTask=c.createDecorator("IExtHostTask")}),define(we[212],_e([0,1,17,75,27,80,22,12,15,25,8,10,2,116,136,90,44,165,211,37]),function(ee,e,m,T,S,y,k,D,b,C,n,I,o,f,c,d,w,v,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let h=class{constructor(P,A,a,R){this.configurationService=P,this.workspaceContextService=A,this.editorGroupsService=a,this.pathService=R}text(P,A,a={}){P=this.getContentPattern(P,a);const R=this.configurationService.getValue(),F=A&&A.some(J=>!this.configurationService.getValue({resource:J}).search.useRipgrep),x=this.commonQuery(A==null?void 0:A.map(w.toWorkspaceFolder),a);return Object.assign(Object.assign({},x),{type:2,contentPattern:P,previewOptions:a.previewOptions,maxFileSize:a.maxFileSize,usePCRE2:R.search.usePCRE2||F||!1,beforeContext:a.beforeContext,afterContext:a.afterContext,userDisabledExcludesAndIgnoreFiles:a.disregardExcludeSettings&&a.disregardIgnoreFiles})}getContentPattern(P,A){const a=this.configurationService.getValue();P.isRegExp&&(P.pattern=P.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},P),{wordSeparators:a.editor.wordSeparators});return this.isCaseSensitive(P,A)&&(R.isCaseSensitive=!0),this.isMultiline(P)&&(R.isMultiline=!0),R}file(P,A={}){const a=this.commonQuery(P,A);return Object.assign(Object.assign({},a),{type:1,filePattern:A.filePattern?A.filePattern.trim():A.filePattern,exists:A.exists,sortByScore:A.sortByScore,cacheKey:A.cacheKey})}handleIncludeExclude(P,A){return P?(P=Array.isArray(P)?P.map(r):r(P),A?this.parseSearchPaths(P):{pattern:t(...Array.isArray(P)?P:[P])}):{}}commonQuery(P=[],A={}){const a=this.handleIncludeExclude(A.includePattern,A.expandPatterns),R=this.handleIncludeExclude(A.excludePattern,A.expandPatterns),F=P.length>1,x=(a.searchPaths&&a.searchPaths.length?a.searchPaths.map(j=>this.getFolderQueryForSearchPath(j,A,R)):P.map(j=>this.getFolderQueryForRoot(j,A,R,F))).filter(j=>!!j),J={_reason:A._reason,folderQueries:x,usingSearchPaths:!!(a.searchPaths&&a.searchPaths.length),extraFileResources:A.extraFileResources,excludePattern:R.pattern,includePattern:a.pattern,onlyOpenEditors:A.onlyOpenEditors,maxResults:A.maxResults};if(A.onlyOpenEditors){const W=m.coalesce(m.flatten(this.editorGroupsService.groups.map(M=>M.editors.map(X=>X.resource)))).filter(M=>u.pathIncludedInQuery(J,M.fsPath)),Q=this.commonQueryFromFileList(W);return Object.assign(Object.assign({},J),Q)}const ae=A.extraFileResources&&A.extraFileResources.filter(j=>u.pathIncludedInQuery(J,j.fsPath));return J.extraFileResources=ae&&ae.length?ae:void 0,J}commonQueryFromFileList(P){const A=[],a=new k.ResourceMap,R={};let F=!1;return P.forEach(x=>{var J,ae;if(x.scheme===D.Schemas.walkThrough)return;if(C.isAbsolutePath(x)){const W=(ae=(J=this.workspaceContextService.getWorkspaceFolder(x))===null||J===void 0?void 0:J.uri)!==null&&ae!==void 0?ae:x.with({path:b.dirname(x.fsPath)});let Q=a.get(W);Q||(F=!0,Q={folder:W,includePattern:{}},A.push(Q),a.set(W,Q));const M=b.relative(W.fsPath,x.fsPath);I.assertIsDefined(Q.includePattern)[M.replace(/\\/g,"/")]=!0}else x.fsPath&&(F=!0,R[x.fsPath]=!0)}),{folderQueries:A,includePattern:R,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(P,A){if(A.isSmartCase){if(P.isRegExp){if(n.containsUppercaseCharacter(P.pattern,!0))return!0}else if(n.containsUppercaseCharacter(P.pattern))return!0}return!!P.isCaseSensitive}isMultiline(P){return P.isMultiline||P.isRegExp&&f.isMultilineRegexSource(P.pattern)||P.pattern.indexOf(`
`)>=0?!0:!!P.isMultiline}parseSearchPaths(P){const A=Q=>b.isAbsolute(Q)||/^\.\.?([\/\\]|$)/.test(Q),R=(Array.isArray(P)?P:i(P)).map(Q=>{const M=this.pathService.resolvedUserHome;return M?y.untildify(Q,M.scheme===D.Schemas.file?M.fsPath:M.path):Q}),F=T.groupBy(R,Q=>A(Q)?"searchPaths":"exprSegments"),x=(F.exprSegments||[]).map(Q=>n.rtrim(Q,"/")).map(Q=>n.rtrim(Q,"\\")).map(Q=>(Q[0]==="."&&(Q="*"+Q),s(Q))),J={},ae=this.expandSearchPathPatterns(F.searchPaths||[]);ae&&ae.length&&(J.searchPaths=ae);const j=m.flatten(x),W=t(...j);return W&&(J.pattern=W),J}getExcludesForFolder(P,A){return A.disregardExcludeSettings?void 0:u.getExcludes(P,!A.disregardSearchExcludeSettings)}expandSearchPathPatterns(P){if(!P||!P.length)return[];const A=m.flatten(P.map(R=>{let{pathPortion:F,globPortion:x}=g(R);x&&(x=l(x));const J=this.expandOneSearchPath(F);return m.flatten(J.map(ae=>this.resolveOneSearchPathPattern(ae,x)))})),a=new Map;return A.forEach(R=>{const F=R.searchPath.toString(),x=a.get(F);x?R.pattern&&(x.pattern=x.pattern||{},x.pattern[R.pattern]=!0):a.set(F,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(a.values())}expandOneSearchPath(P){if(b.isAbsolute(P)){const A=this.workspaceContextService.getWorkspace().folders;return A[0]&&A[0].uri.scheme!==D.Schemas.file?[{searchPath:A[0].uri.with({path:P})}]:[{searchPath:o.URI.file(b.normalize(P))}]}if(this.workspaceContextService.getWorkbenchState()===2){const A=this.workspaceContextService.getWorkspace().folders[0].uri;if(P=r(P),P.startsWith("../")||P===".."){const R=b.posix.resolve(A.path,P);return[{searchPath:A.with({path:R})}]}const a=l(P);return[{searchPath:A,pattern:a}]}else{if(P==="./"||P===".\\")return[];{const A=P.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(F=>{const x=A.match(new RegExp(`^${n.escapeRegExpCharacters(F.name)}(?:/(.*)|$)`));return x?{match:x,folder:F}:null}).filter(I.isDefined);if(R.length)return R.map(F=>{const x=F.match[1];return{searchPath:F.folder.uri,pattern:x&&l(x)}});{const F=P.match(/\.[\/\\](.+)[\/\\]?/),x=F?F[1]:P,J=c.localize(0,null,x);throw new Error(J)}}}}resolveOneSearchPathPattern(P,A){const a=P.pattern&&A?`${P.pattern}/${A}`:P.pattern||A,R=[{searchPath:P.searchPath,pattern:a}];return a&&!a.endsWith("**")&&R.push({searchPath:P.searchPath,pattern:a+"/**"}),R}getFolderQueryForSearchPath(P,A,a){const R=this.getFolderQueryForRoot(w.toWorkspaceFolder(P.searchPath),A,a,!1);return R?Object.assign(Object.assign({},R),{includePattern:P.pattern}):null}getFolderQueryForRoot(P,A,a,R){let F;const x=o.URI.isUri(P)?P:P.uri;if(a.searchPaths){const Q=a.searchPaths.filter(M=>C.isEqual(M.searchPath,x))[0];if(Q&&!Q.pattern)return null;Q&&(F=Q.pattern)}const J=this.configurationService.getValue({resource:x}),ae=this.getExcludesForFolder(J,A),j=Object.assign(Object.assign({},ae||{}),F||{}),W=o.URI.isUri(P)?C.basename(P):P.name;return{folder:x,folderName:R?W:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:J.files&&J.files.encoding,disregardIgnoreFiles:typeof A.disregardIgnoreFiles=="boolean"?A.disregardIgnoreFiles:!J.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof A.disregardGlobalIgnoreFiles=="boolean"?A.disregardGlobalIgnoreFiles:!J.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof A.ignoreSymlinks=="boolean"?A.ignoreSymlinks:!J.search.followSymlinks}}};h=He([ze(0,d.IConfigurationService),ze(1,w.IWorkspaceContextService),ze(2,v.IEditorGroupsService),ze(3,E.IPathService)],h),e.QueryBuilder=h;function g(p){const P=p.match(/[\*\{\}\(\)\[\]\?]/);if(P){const A=P.index,a=p.substr(0,A).match(/[/|\\][^/\\]*$/);if(a){let R=p.substr(0,a.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:p.substr((a.index||0)+1)}}}return{pathPortion:p}}function t(...p){return p.length?p.reduce((P,A)=>(P[A]=!0,P),Object.create(null)):void 0}function i(p){return S.splitGlobAware(p,",").map(P=>P.trim()).filter(P=>!!P.length)}function s(p){return[`**/${p}/**`,`**/${p}`].map(A=>A.replace(/\*\*\/\*\*/g,"**"))}function r(p){return p.replace(/\\/g,"/")}function l(p){return r(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function _(p,P){p=m.distinct(p,R=>R.toString());const A=[],a=P.getWorkspace();return p&&p.forEach(R=>{let F;if(P.getWorkbenchState()===2)F=C.relativePath(a.folders[0].uri,R),F&&F!=="."&&(F="./"+F);else{const x=P.getWorkspaceFolder(R);if(x){const J=x.name;if(a.folders.filter(j=>j.name===J).length===1){const j=C.relativePath(x.uri,R);j===""?F=`./${x.name}`:F=`./${x.name}/${j}`}else F=R.fsPath}}F&&A.push(F)}),A}e.resolveResourcesForSearchIncludes=_}),define(we[213],_e([0,1,25,2,18,11,5,212,37,44]),function(ee,e,m,T,S,y,k,D,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function I(d,w){const v=w.activationEvents;if(!v)return Promise.resolve(void 0);const E=[],u=[];for(const r of v)if(/^workspaceContains:/.test(r)){const l=r.substr("workspaceContains:".length);l.indexOf("*")>=0||l.indexOf("?")>=0||d.forceUsingSearch?u.push(l):E.push(l)}if(E.length===0&&u.length===0)return Promise.resolve(void 0);let h;const g=new Promise((r,l)=>{h=r}),t=r=>h({activationEvent:r}),i=Promise.all(E.map(r=>o(d,r,t))).then(()=>{}),s=f(d,w.identifier,u,t);return Promise.all([i,s]).then(()=>{h(void 0)}),g}e.checkActivateWorkspaceContainsExtension=I;async function o(d,w,v){for(const E of d.folders)if(await d.exists(m.joinPath(T.URI.revive(E),w))){v(`workspaceContains:${w}`);return}}async function f(d,w,v,E){if(v.length===0)return Promise.resolve(void 0);const u=new S.CancellationTokenSource,h=d.checkExists(d.folders,v,u.token),g=setTimeout(async()=>{u.cancel(),E(`workspaceContainsTimeout:${v.join(",")}`)},n);let t=!1;try{t=await h}catch(i){y.isPromiseCanceledError(i)||y.onUnexpectedError(i)}u.dispose(),clearTimeout(g),t&&E(`workspaceContains:${v.join(",")}`)}function c(d,w,v,E){const u=d.get(k.IInstantiationService),h=d.get(b.ISearchService),t=u.createInstance(D.QueryBuilder).file(w.map(i=>C.toWorkspaceFolder(T.URI.revive(i))),{_reason:"checkExists",includePattern:v,exists:!0});return h.fileSearch(t,E).then(i=>!!i.limitHit,i=>y.isPromiseCanceledError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=c});var rt=this&&this.__classPrivateFieldSet||function(ee,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,m):S?S.value=m:e.set(ee,m),m},Ue=this&&this.__classPrivateFieldGet||function(ee,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[33],_e([0,1,129,15,74,25,13,7,22,2,16,4,32,176,72,31,29,174,11,26,23,153,6,91,5,28,73,14,60,64,36,3,213,68,155]),function(ee,e,m,T,S,y,k,D,b,C,n,I,o,f,c,d,w,v,E,u,h,g,t,i,s,r,l,_,p,P,A,a,R,F,x){"use strict";var J,ae,j;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=s.createDecorator("IHostUtils");let W=class Bn extends D.Disposable{constructor(B,U,Y,V,ce,ge,Ae,$e,Fe,Ve){super();this._onDidChangeRemoteConnectionData=this._register(new a.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=U,this._extHostContext=Y,this._initData=Ae,this._extHostWorkspace=V,this._extHostConfiguration=ce,this._logService=ge,this._extHostTunnelService=Fe,this._extHostTerminalService=Ve,this._disposables=new D.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new k.Barrier,this._readyToStartExtensionHost=new k.Barrier,this._readyToRunExtensions=new k.Barrier,this._eagerExtensionsActivated=new k.Barrier,this._registry=new v.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new c.ExtHostStorage(this._extHostContext),this._secretState=new F.ExtHostSecretState(this._extHostContext),this._storagePath=$e,this._instaService=B.createChild(new p.ServiceCollection([c.IExtHostStorage,this._storage],[F.IExtHostSecretState,this._secretState]));const tt=new Set;this._initData.hostExtensions.forEach(Ke=>tt.add(u.ExtensionIdentifier.toKey(Ke))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ke,Qe,$)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ke,E.transformErrorForSerialization(Qe),$)},actualActivateExtension:async(Ke,Qe)=>{if(tt.has(u.ExtensionIdentifier.toKey(Ke)))return await this._mainThreadExtensionsProxy.$activateExtension(Ke,Qe),new f.HostExtension;const $=this._registry.getExtensionDescription(Ke);return this._activateExtension($,Qe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),S.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(B){E.onUnexpectedError(B)}}async deactivateAll(){let B=[];try{B=this._registry.getAllExtensionDescriptions().map(ce=>ce.identifier).filter(ce=>this.isActivated(ce)).map(ce=>this._deactivate(ce))}catch(U){}await Promise.all(B)}isActivated(B){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(B):!1}_activateByEvent(B,U){return this._activator.activateByEvent(B,U)}_activateById(B,U){return this._activator.activateById(B,U)}activateByIdWithErrors(B,U){return this._activateById(B,U).then(()=>{const Y=this._activator.getActivatedExtension(B);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(B=>this._registry)}getExtensionExports(B){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(B).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const B=b.TernarySearchTree.forPaths(),U=this._registry.getAllExtensionDescriptions().map(Y=>{if(!!this._getEntryPoint(Y))return this._hostUtils.realpath(Y.extensionLocation.fsPath).then(V=>B.set(C.URI.file(V).fsPath,Y))});this._extensionPathIndex=Promise.all(U).then(()=>B)}return this._extensionPathIndex}_deactivate(B){let U=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(B))return U;const Y=this._activator.getActivatedExtension(B);if(!Y)return U;try{typeof Y.module.deactivate=="function"&&(U=Promise.resolve(Y.module.deactivate()).then(void 0,V=>(this._logService.error(V),Promise.resolve(void 0))))}catch(V){this._logService.error(V)}try{D.dispose(Y.subscriptions)}catch(V){this._logService.error(V)}return U}async _activateExtension(B,U){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(B.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(B.identifier),this._doActivateExtension(B,U).then(Y=>{const V=Y.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(B.identifier,V.codeLoadingTime,V.activateCallTime,V.activateResolvedTime,U),this._logExtensionActivationTimes(B,U,"success",V),Y},Y=>{throw this._logExtensionActivationTimes(B,U,"failure"),Y})}_logExtensionActivationTimes(B,U,Y,V){const ce=Q(B,U);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},ce),V||{}),{outcome:Y}))}_doActivateExtension(B,U){const Y=Q(B,U);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Y);const V=this._getEntryPoint(B);if(!V)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${B.identifier.value} ${JSON.stringify(U)}`),this._logService.flush();const ce=new f.ExtensionActivationTimesBuilder(U.startup);return Promise.all([this._loadCommonJSModule(B.identifier,y.joinPath(B.extensionLocation,V),ce),this._loadExtensionContext(B)]).then(ge=>(S.mark(`code/extHost/willActivateExtension/${B.identifier.value}`),Bn._callActivate(this._logService,B.identifier,ge[0],ge[1],ce))).then(ge=>(S.mark(`code/extHost/didActivateExtension/${B.identifier.value}`),ge))}_loadExtensionContext(B){const U=new g.ExtensionGlobalMemento(B,this._storage),Y=new g.ExtensionMemento(B.identifier.value,!1,this._storage),V=new x.ExtensionSecrets(B,this._secretState),ce=B.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${B.identifier.value}`),Promise.all([U.whenReady,Y.whenReady,this._storagePath.whenReady]).then(()=>{const Ae=this;let $e;return Object.freeze({globalState:U,workspaceState:Y,secrets:V,subscriptions:[],get extensionUri(){return B.extensionLocation},get extensionPath(){return B.extensionLocation.fsPath},asAbsolutePath(Fe){return T.join(B.extensionLocation.fsPath,Fe)},get storagePath(){var Fe;return(Fe=Ae._storagePath.workspaceValue(B))===null||Fe===void 0?void 0:Fe.fsPath},get globalStoragePath(){return Ae._storagePath.globalValue(B).fsPath},get logPath(){return T.join(Ae._initData.logsLocation.fsPath,B.identifier.value)},get logUri(){return C.URI.joinPath(Ae._initData.logsLocation,B.identifier.value)},get storageUri(){return Ae._storagePath.workspaceValue(B)},get globalStorageUri(){return Ae._storagePath.globalValue(B)},get extensionMode(){return ce},get extension(){return $e===void 0&&($e=new M(Ae,B.identifier,B,ge)),$e},get extensionRuntime(){return w.checkProposedApiEnabled(B),Ae.extensionRuntime},get environmentVariableCollection(){return Ae._extHostTerminalService.getEnvironmentVariableCollection(B)}})})}static _callActivate(B,U,Y,V,ce){return Y=Y||{activate:void 0,deactivate:void 0},this._callActivateOptional(B,U,Y,V,ce).then(ge=>new f.ActivatedExtension(!1,null,ce.build(),Y,ge,V.subscriptions))}static _callActivateOptional(B,U,Y,V,ce){if(typeof Y.activate=="function")try{ce.activateCallStart(),B.trace(`ExtensionService#_callActivateOptional ${U.value}`);const ge=typeof global=="object"?global:self,Ae=Y.activate.apply(ge,[V]);return ce.activateCallStop(),ce.activateResolveStart(),Promise.resolve(Ae).then($e=>(ce.activateResolveStop(),$e))}catch(ge){return Promise.reject(ge)}else return Promise.resolve(Y)}_activateOneStartupFinished(B,U){this._activateById(B.identifier,{startup:!1,extensionId:B.identifier,activationEvent:U}).then(void 0,Y=>{this._logService.error(Y)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(S.getMarks());for(const B of this._registry.getAllExtensionDescriptions())if(B.activationEvents)for(const U of B.activationEvents)U==="onStartupFinished"&&this._activateOneStartupFinished(B,U)}_handleEagerExtensions(){const B=this._activateByEvent("*",!0).then(void 0,ce=>{this._logService.error(ce)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ce=>this._handleWorkspaceContainsEagerExtensions(ce.added)));const U=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Y=this._handleWorkspaceContainsEagerExtensions(U),V=Promise.all([B,Y]).then(()=>{});return Promise.race([V,k.timeout(1e4)]).then(()=>{this._activateAllStartupFinished()}),V}_handleWorkspaceContainsEagerExtensions(B){return B.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(U=>this._handleWorkspaceContainsEagerExtension(B,U))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(B,U){if(this.isActivated(U.identifier))return;const Y=!this._initData.remote.isRemote&&!!this._initData.remote.authority,V={folders:B.map(ge=>ge.uri),forceUsingSearch:Y,exists:ge=>this._hostUtils.exists(ge.fsPath),checkExists:(ge,Ae,$e)=>this._mainThreadWorkspaceProxy.$checkExists(ge,Ae,$e)},ce=await R.checkActivateWorkspaceContainsExtension(V,U);if(!!ce)return this._activateById(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:ce.activationEvent}).then(void 0,ge=>this._logService.error(ge))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(B){throw console.error(B),B}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:B,extensionTestsLocationURI:U}=this._initData.environment;if(!B||!U)throw new Error(m.localize(0,null));const Y=await this._loadCommonJSModule(null,U,new f.ExtensionActivationTimesBuilder(!1));if(!Y||typeof Y.run!="function")throw new Error(m.localize(1,null,U.toString()));return new Promise((V,ce)=>{const ge=(Fe,Ve)=>{Fe?ce(Fe):V(typeof Ve=="number"&&Ve>0?1:0)},Ae=y.originalFSPath(U),$e=Y.run(Ae,ge);$e&&$e.then&&$e.then(()=>{V(0)}).catch(Fe=>{ce(Fe.toString())})})}async $extensionTestsExit(B){this._logService.info(`extension host terminating: test runner requested exit with code ${B}`),this._logService.info(`exiting with code ${B}`),this._logService.flush(),this._hostUtils.exit(B)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(B,U){return this._resolvers[B]=U,D.toDisposable(()=>{delete this._resolvers[B]})}async _activateAndGetResolver(B){const U=B.indexOf("+");if(U===-1)throw new Error("Not an authority that can be resolved!");const Y=B.substr(0,U);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Y}`,!1),{authorityPrefix:Y,resolver:this._resolvers[Y]}}async $resolveAuthority(B,U){const{authorityPrefix:Y,resolver:V}=await this._activateAndGetResolver(B);if(!V)return{type:"error",error:{code:i.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Y}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(V)),S.mark(`code/extHost/willResolveAuthority/${Y}`);const ce=await V.resolve(B,{resolveAttempt:U});S.mark(`code/extHost/didResolveAuthorityOK/${Y}`);const ge={authority:B,host:ce.host,port:ce.port,connectionToken:ce.connectionToken},Ae={extensionHostEnv:ce.extensionHostEnv,isTrusted:ce.isTrusted};return{type:"ok",value:{authority:ge,options:Ae,tunnelInformation:{environmentTunnels:ce.environmentTunnels}}}}catch(ce){if(S.mark(`code/extHost/didResolveAuthorityError/${Y}`),ce instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:ce._code,message:ce._message,detail:ce._detail}};throw ce}}async $getCanonicalURI(B,U){const{authorityPrefix:Y,resolver:V}=await this._activateAndGetResolver(B);if(!V)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${Y}`);const ce=C.URI.revive(U);if(typeof V.getCanonicalURI=="undefined")return ce;const ge=await k.asPromise(()=>V.getCanonicalURI(ce));return ge||ce}$startExtensionHost(B){return this._registry.keepOnly(B),this._startExtensionHost()}$activateByEvent(B,U){return U===1?this._activateByEvent(B,!1):this._readyToRunExtensions.wait().then(Y=>this._activateByEvent(B,!1))}async $activate(B,U){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(B)?(await this._activateById(B,U),!0):!1}async $deltaExtensions(B,U){B.forEach(V=>V.extensionLocation=C.URI.revive(V.extensionLocation));const Y=await this.getExtensionPathIndex();return await Promise.all(U.map(async V=>{const ce=this._registry.getExtensionDescription(V);if(!ce)return;const ge=await this._hostUtils.realpath(ce.extensionLocation.fsPath);Y.delete(C.URI.file(ge).fsPath)})),await Promise.all(B.map(async V=>{const ce=await this._hostUtils.realpath(V.extensionLocation.fsPath);Y.set(C.URI.file(ce).fsPath,V)})),this._registry.deltaExtensions(B,U),Promise.resolve(void 0)}async $test_latency(B){return B}async $test_up(B){return B.byteLength}async $test_down(B){let U=h.VSBuffer.alloc(B),Y=Math.random()%256;for(let V=0;V<B;V++)U.writeUInt8(Y,V);return U}async $updateRemoteConnectionData(B){this._remoteConnectionData=B,this._onDidChangeRemoteConnectionData.fire()}};W=He([ze(0,s.IInstantiationService),ze(1,e.IHostUtils),ze(2,_.IExtHostRpcService),ze(3,d.IExtHostWorkspace),ze(4,o.IExtHostConfiguration),ze(5,n.ILogService),ze(6,r.IExtHostInitDataService),ze(7,l.IExtensionStoragePaths),ze(8,P.IExtHostTunnelService),ze(9,A.IExtHostTerminalService)],W),e.AbstractExtHostExtensionService=W;function Q(X,B){return{id:X.identifier.value,name:X.name,extensionVersion:X.version,publisherDisplayName:X.publisher,activationEvents:X.activationEvents?X.activationEvents.join(","):null,isBuiltin:X.isBuiltin,reason:B.activationEvent,reasonId:B.extensionId.value}}e.IExtHostExtensionService=s.createDecorator("IExtHostExtensionService");class M{constructor(B,U,Y,V){J.set(this,void 0),ae.set(this,void 0),j.set(this,void 0),rt(this,J,B,"f"),rt(this,ae,U,"f"),rt(this,j,Y.identifier,"f"),this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=T.normalize(y.originalFSPath(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=V}get isActive(){return Ue(this,J,"f").isActivated(Ue(this,j,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ue(this,J,"f").getExtensionExports(Ue(this,j,"f"))}activate(){return Ue(this,J,"f").activateByIdWithErrors(Ue(this,j,"f"),{startup:!1,extensionId:Ue(this,ae,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=M,J=new WeakMap,ae=new WeakMap,j=new WeakMap}),define(we[105],_e([0,1,15,2,3,13,4,6,160,31,33,46,164,32,161,14,5,10,40,63]),function(ee,e,m,T,S,y,k,D,b,C,n,I,o,f,c,d,w,v,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=w.createDecorator("IExtHostDebugService");let h=class{constructor(p,P,A,a,R,F){this._workspaceService=P,this._extensionService=A,this._editorsService=a,this._configurationService=R,this._editorTabs=F,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new S.Emitter,this._onDidTerminateDebugSession=new S.Emitter,this._onDidChangeActiveDebugSession=new S.Emitter,this._onDidReceiveDebugSessionCustomEvent=new S.Emitter,this._debugServiceProxy=p.getProxy(k.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new S.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(x=>{x.onDidChange(J=>{this.registerAllDebugTypes(x)}),this.registerAllDebugTypes(x)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(p,P){const A=p;if(typeof A.sourceReference=="number"&&A.sourceReference>0){let a=`debug:${encodeURIComponent(A.path||"")}`,R="?";return P&&(a+=`${R}session=${encodeURIComponent(P.id)}`,R="&"),a+=`${R}ref=${A.sourceReference}`,T.URI.parse(a)}else{if(A.path)return T.URI.file(A.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(p){const P=[];for(const A of p.getAllExtensionDescriptions())if(A.contributes){const a=A.contributes.debuggers;if(a&&a.length>0)for(const R of a)c.isDebuggerMainContribution(R)&&P.push(R.type)}this._debugServiceProxy.$registerDebugTypes(P)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const p=[];return this._breakpoints.forEach(P=>p.push(P)),p}addBreakpoints(p){this.startBreakpoints();const P=p.filter(R=>{const F=R.id;return this._breakpoints.has(F)?!1:(this._breakpoints.set(F,R),!0)});this.fireBreakpointChanges(P,[],[]);const A=[],a=new Map;for(const R of P)if(R instanceof D.SourceBreakpoint){let F=a.get(R.location.uri.toString());F||(F={type:"sourceMulti",uri:R.location.uri,lines:[]},a.set(R.location.uri.toString(),F),A.push(F)),F.lines.push({id:R.id,enabled:R.enabled,condition:R.condition,hitCondition:R.hitCondition,logMessage:R.logMessage,line:R.location.range.start.line,character:R.location.range.start.character})}else R instanceof D.FunctionBreakpoint&&A.push({type:"function",id:R.id,enabled:R.enabled,hitCondition:R.hitCondition,logMessage:R.logMessage,condition:R.condition,functionName:R.functionName});return this._debugServiceProxy.$registerBreakpoints(A)}removeBreakpoints(p){this.startBreakpoints();const P=p.filter(F=>this._breakpoints.delete(F.id));this.fireBreakpointChanges([],P,[]);const A=P.filter(F=>F instanceof D.SourceBreakpoint).map(F=>F.id),a=P.filter(F=>F instanceof D.FunctionBreakpoint).map(F=>F.id),R=P.filter(F=>F instanceof D.DataBreakpoint).map(F=>F.id);return this._debugServiceProxy.$unregisterBreakpoints(A,a,R)}startDebugging(p,P,A){return this._debugServiceProxy.$startDebugging(p?p.uri:void 0,P,{parentSessionID:A.parentSession?A.parentSession.id:void 0,repl:A.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:A.noDebug,compact:A.compact})}stopDebugging(p){return this._debugServiceProxy.$stopDebugging(p?p.id:void 0)}registerDebugConfigurationProvider(p,P,A){if(!P)return new D.Disposable(()=>{});const a=this._configProviderHandleCounter++;return this._configProviders.push({type:p,handle:a,provider:P}),this._debugServiceProxy.$registerDebugConfigurationProvider(p,A,!!P.provideDebugConfigurations,!!P.resolveDebugConfiguration,!!P.resolveDebugConfigurationWithSubstitutedVariables,a),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(R=>R.provider!==P),this._debugServiceProxy.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(p,P,A){if(!A)return new D.Disposable(()=>{});if(!this.definesDebugType(p,P))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${P}' debugger.`);if(this.getAdapterDescriptorFactoryByType(P))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:P,handle:a,factory:A}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(P,a),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(R=>R.factory!==A),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(p,P){if(!P)return new D.Disposable(()=>{});const A=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:p,handle:A,factory:P}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(a=>a.factory!==P)})}async $runInTerminal(p,P){return Promise.resolve(void 0)}async $substituteVariables(p,P){if(!this._variableResolver){const[R,F]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(R||[],this._editorsService,F)}let A;const a=await this.getFolder(p);return a&&(A={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(A,P)}createDebugAdapter(p,P){if(p.type==="implementation")return new r(p.implementation)}createSignService(){}async $startDASession(p,P){const A=this,a=await this.getSession(P);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(a.type),a).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const F=this.convertToDto(R),x=this.createDebugAdapter(F,a);if(!x)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const J=x;return this._debugAdapters.set(p,J),this.getDebugAdapterTrackers(a).then(ae=>(ae&&this._debugAdaptersTrackers.set(p,ae),J.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const W=j,Q={type:"response",seq:0,command:W.command,request_seq:W.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(W.arguments.value);Q.body={signature:M},J.sendResponse(Q)}else throw new Error("no signer")}catch(M){Q.success=!1,Q.message=M.message,J.sendResponse(Q)}}else ae&&ae.onDidSendMessage&&ae.onDidSendMessage(j),j=c.convertToVSCPaths(j,!0),A._debugServiceProxy.$acceptDAMessage(p,j)}),J.onError(j=>{ae&&ae.onError&&ae.onError(j),this._debugServiceProxy.$acceptDAError(p,j.name,j.message,j.stack)}),J.onExit(j=>{ae&&ae.onExit&&ae.onExit(v.withNullAsUndefined(j),void 0),this._debugServiceProxy.$acceptDAExit(p,v.withNullAsUndefined(j),void 0)}),ae&&ae.onWillStartSession&&ae.onWillStartSession(),J.startSession()))})}$sendDAMessage(p,P){P=c.convertToDAPaths(P,!1);const A=this._debugAdaptersTrackers.get(p);A&&A.onWillReceiveMessage&&A.onWillReceiveMessage(P);const a=this._debugAdapters.get(p);a&&a.sendMessage(P)}$stopDASession(p){const P=this._debugAdaptersTrackers.get(p);this._debugAdaptersTrackers.delete(p),P&&P.onWillStopSession&&P.onWillStopSession();const A=this._debugAdapters.get(p);return this._debugAdapters.delete(p),A?A.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(p){const P=[],A=[],a=[];if(p.added)for(const R of p.added){const F=R.id;if(F&&!this._breakpoints.has(F)){let x;if(R.type==="function")x=new D.FunctionBreakpoint(R.functionName,R.enabled,R.condition,R.hitCondition,R.logMessage);else if(R.type==="data")x=new D.DataBreakpoint(R.label,R.dataId,R.canPersist,R.enabled,R.hitCondition,R.condition,R.logMessage);else{const J=T.URI.revive(R.uri);x=new D.SourceBreakpoint(new D.Location(J,new D.Position(R.line,R.character)),R.enabled,R.condition,R.hitCondition,R.logMessage)}x._id=F,this._breakpoints.set(F,x),P.push(x)}}if(p.removed)for(const R of p.removed){const F=this._breakpoints.get(R);F&&(this._breakpoints.delete(R),A.push(F))}if(p.changed){for(const R of p.changed)if(R.id){const F=this._breakpoints.get(R.id);if(F){if(F instanceof D.FunctionBreakpoint&&R.type==="function"){const x=F;x.enabled=R.enabled,x.condition=R.condition,x.hitCondition=R.hitCondition,x.logMessage=R.logMessage,x.functionName=R.functionName}else if(F instanceof D.SourceBreakpoint&&R.type==="source"){const x=F;x.enabled=R.enabled,x.condition=R.condition,x.hitCondition=R.hitCondition,x.logMessage=R.logMessage,x.location=new D.Location(T.URI.revive(R.uri),new D.Position(R.line,R.character))}a.push(F)}}}this.fireBreakpointChanges(P,A,a)}$provideDebugConfigurations(p,P,A){return y.asPromise(async()=>{const a=this.getConfigProviderByHandle(p);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const R=await this.getFolder(P);return a.provideDebugConfigurations(R,A)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(p,P,A,a){return y.asPromise(async()=>{const R=this.getConfigProviderByHandle(p);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.getFolder(P);return R.resolveDebugConfiguration(F,A,a)})}$resolveDebugConfigurationWithSubstitutedVariables(p,P,A,a){return y.asPromise(async()=>{const R=this.getConfigProviderByHandle(p);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.getFolder(P);return R.resolveDebugConfigurationWithSubstitutedVariables(F,A,a)})}async $provideDebugAdapter(p,P){const A=this.getAdapterDescriptorFactoryByHandle(p);if(!A)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.getSession(P);return this.getAdapterDescriptor(A,a).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.convertToDto(R)})}async $acceptDebugSessionStarted(p){const P=await this.getSession(p);this._onDidStartDebugSession.fire(P)}async $acceptDebugSessionTerminated(p){const P=await this.getSession(p);P&&(this._onDidTerminateDebugSession.fire(P),this._debugSessions.delete(P.id))}async $acceptDebugSessionActiveChanged(p){this._activeDebugSession=p?await this.getSession(p):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(p,P){const A=await this.getSession(p);A&&A._acceptNameChanged(P)}async $acceptDebugSessionCustomEvent(p,P){const a={session:await this.getSession(p),event:P.event,body:P.body};this._onDidReceiveDebugSessionCustomEvent.fire(a)}convertToDto(p){if(p instanceof D.DebugAdapterExecutable)return{type:"executable",command:p.command,args:p.args,options:p.options};if(p instanceof D.DebugAdapterServer)return{type:"server",port:p.port,host:p.host};if(p instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:p.path};if(p instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:p.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(p){const P=this._adapterFactories.filter(A=>A.type===p);if(P.length>0)return P[0].factory}getAdapterDescriptorFactoryByHandle(p){const P=this._adapterFactories.filter(A=>A.handle===p);if(P.length>0)return P[0].factory}getConfigProviderByHandle(p){const P=this._configProviders.filter(A=>A.handle===p);if(P.length>0)return P[0].provider}definesDebugType(p,P){if(p.contributes){const A=p.contributes.debuggers;if(A&&A.length>0){for(const a of A)if(a.label&&a.type&&a.type===P)return!0}}return!1}getDebugAdapterTrackers(p){const A=p.configuration.type,a=this._trackerFactories.filter(R=>R.type===A||R.type==="*").map(R=>y.asPromise(()=>R.factory.createDebugAdapterTracker(p)).then(F=>F,F=>null));return Promise.race([Promise.all(a).then(R=>{const F=R.filter(x=>!!x);if(F.length>0)return new s(F)}),new Promise((R,F)=>{const x=setTimeout(()=>{clearTimeout(x),F(new Error("timeout"))},1e3)})]).catch(R=>{})}async getAdapterDescriptor(p,P){const A=P.configuration.debugServer;if(typeof A=="number")return Promise.resolve(new D.DebugAdapterServer(A));if(p){const R=await this._extensionService.getExtensionRegistry();return y.asPromise(()=>p.createDebugAdapterDescriptor(P,this.daExecutableFromPackage(P,R))).then(F=>{if(F)return F})}const a=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(P,a))}daExecutableFromPackage(p,P){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(p,P,A){(p.length>0||P.length>0||A.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:p,removed:P,changed:A}))}async getSession(p){if(p)if(typeof p=="string"){const P=this._debugSessions.get(p);if(P)return P}else{let P=this._debugSessions.get(p.id);if(!P){const A=await this.getFolder(p.folderUri),a=p.parent?this._debugSessions.get(p.parent):void 0;P=new g(this._debugServiceProxy,p.id,p.type,p.name,A,p.configuration,a),this._debugSessions.set(P.id,P),this._debugServiceProxy.$sessionCached(P.id)}return P}throw new Error("cannot find session")}getFolder(p){if(p){const P=T.URI.revive(p);return this._workspaceService.resolveWorkspaceFolder(P)}return Promise.resolve(void 0)}};h=He([ze(0,d.IExtHostRpcService),ze(1,C.IExtHostWorkspace),ze(2,n.IExtHostExtensionService),ze(3,I.IExtHostDocumentsAndEditors),ze(4,f.IExtHostConfiguration),ze(5,u.IExtHostEditorTabs)],h),e.ExtHostDebugServiceBase=h;class g{constructor(p,P,A,a,R,F,x){this._debugServiceProxy=p,this._id=P,this._type=A,this._name=a,this._workspaceFolder=R,this._configuration=F,this._parentSession=x}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(p){this._name=p,this._debugServiceProxy.$setDebugSessionName(this._id,p)}get parentSession(){return this._parentSession}_acceptNameChanged(p){this._name=p}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(p,P){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,p,P)}getDebugProtocolBreakpoint(p){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,p.id)}}e.ExtHostDebugSession=g;class t{constructor(p){this.value=Object.freeze({append(P){p.$appendDebugConsole(P)},appendLine(P){this.append(P+`
`)}})}}e.ExtHostDebugConsole=t;class i extends o.AbstractVariableResolverService{constructor(p,P,A,a,R){function F(){if(P){const x=P.activeEditor();if(x)return x.document.uri;const J=a.tabs.filter(ae=>ae.isActive);if(J.length>0)return J[0].resource}}super({getFolderUri:x=>{const J=p.filter(ae=>ae.name===x);if(J&&J.length>0)return J[0].uri},getWorkspaceFolderCount:()=>p.length,getConfigurationValue:(x,J)=>A.getConfiguration(void 0,x).get(J),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{const x=F();if(x)return m.normalize(x.fsPath)},getWorkspaceFolderPathForFile:()=>{if(R){const x=F();if(x){const J=R.getWorkspaceFolder(x);if(J)return m.normalize(J.uri.fsPath)}}},getSelectedText:()=>{if(P){const x=P.activeEditor();if(x&&!x.selection.isEmpty)return x.document.getText(x.selection)}},getLineNumber:()=>{if(P){const x=P.activeEditor();if(x)return String(x.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=i;class s{constructor(p){this.trackers=p}onWillStartSession(){this.trackers.forEach(p=>p.onWillStartSession?p.onWillStartSession():void 0)}onWillReceiveMessage(p){this.trackers.forEach(P=>P.onWillReceiveMessage?P.onWillReceiveMessage(p):void 0)}onDidSendMessage(p){this.trackers.forEach(P=>P.onDidSendMessage?P.onDidSendMessage(p):void 0)}onWillStopSession(){this.trackers.forEach(p=>p.onWillStopSession?p.onWillStopSession():void 0)}onError(p){this.trackers.forEach(P=>P.onError?P.onError(p):void 0)}onExit(p,P){this.trackers.forEach(A=>A.onExit?A.onExit(p,P):void 0)}}class r extends b.AbstractDebugAdapter{constructor(p){super();this.implementation=p,p.onDidSendMessage(P=>{this.acceptMessage(P)})}startSession(){return Promise.resolve(void 0)}sendMessage(p){this.implementation.handleMessage(p)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let l=class extends h{constructor(p,P,A,a,R,F){super(p,P,A,a,R,F)}createVariableResolver(p,P,A){return new i(p,P,A,this._editorTabs)}};l=He([ze(0,d.IExtHostRpcService),ze(1,C.IExtHostWorkspace),ze(2,n.IExtHostExtensionService),ze(3,I.IExtHostDocumentsAndEditors),ze(4,f.IExtHostConfiguration),ze(5,u.IExtHostEditorTabs)],l),e.WorkerExtHostDebugService=l}),define(we[214],_e([0,1,74,2,4,32,29,26,14,28,5,33,40,16]),function(ee,e,m,T,S,y,k,D,b,C,n,I,o,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let c=class{constructor(u,h,g,t,i,s,r){this._apiFactory=u,this._extensionRegistry=h,this._instaService=g,this._extHostConfiguration=t,this._extHostExtensionService=i,this._initData=s,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),m.mark("code/extHost/willWaitForConfig");const u=await this._extHostConfiguration.getConfigProvider();m.mark("code/extHost/didWaitForConfig");const h=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,h,this._extensionRegistry,u,this._logService)),this.register(this._instaService.createInstance(w)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(v,h,this._initData.environment.appUriScheme))}register(u){if(Array.isArray(u.nodeModuleName))for(let h of u.nodeModuleName)this._factories.set(h,u);else this._factories.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this._alternatives.push(h=>u.alternativeModuleName(h))}};c=He([ze(2,n.IInstantiationService),ze(3,y.IExtHostConfiguration),ze(4,I.IExtHostExtensionService),ze(5,C.IExtHostInitDataService),ze(6,f.ILogService)],c),e.RequireInterceptor=c;class d{constructor(u,h,g,t,i){this._apiFactory=u,this._extensionPaths=h,this._extensionRegistry=g,this._configProvider=t,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(u,h){const g=this._extensionPaths.findSubstr(h.fsPath);if(g){let t=this._extApiImpl.get(D.ExtensionIdentifier.toKey(g.identifier));return t||(t=this._apiFactory(g,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(g.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((i,s)=>t+=`	${s} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${h.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(k.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let w=class{constructor(u,h){this.nodeModuleName="keytar";const{environment:g}=h,t=u.getProxy(S.MainContext.MainThreadKeytar);if(g.appRoot){let i=g.appRoot.fsPath;o.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,s)=>t.$getPassword(i,s),setPassword:(i,s,r)=>t.$setPassword(i,s,r),deletePassword:(i,s)=>t.$deletePassword(i,s),findPassword:i=>t.$findPassword(i),findCredentials(i){return t.$findCredentials(i)}}}load(u,h){return this._impl}alternativeModuleName(u){const h=u.length;if(h<=7||!this.alternativeNames)return;const g=h-7;if((u.charAt(g)==="/"||u.charAt(g)==="\\")&&u.endsWith("keytar")&&(u=u.replace(/\\/g,"/"),this.alternativeNames.has(u)))return"keytar"}};w=He([ze(0,b.IExtHostRpcService),ze(1,C.IExtHostInitDataService)],w);let v=class{constructor(u,h,g){this._extensionPaths=u,this._appUriScheme=h,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=g.getProxy(S.MainContext.MainThreadTelemetry);const t=g.getProxy(S.MainContext.MainThreadWindow);this._impl=(i,s)=>{const r=T.URI.parse(i);return s?this.callOriginal(i,s):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,i,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,i,{}):this.callOriginal(i,s)}}load(u,h,g){const t=this._extensionPaths.findSubstr(h.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=g(u),this._impl}callOriginal(u,h){return this.sendNoForwardTelemetry(),this._original(u,h)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};v=He([ze(2,b.IExtHostRpcService)],v)}),define(we[215],_e([0,1,13,11,74,7,2,4,208,16,57,60,28,146,14,65,33,36]),function(ee,e,m,T,S,y,k,D,b,C,n,I,o,f,c,d,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(h,g,t,i){this._disposables=new y.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new b.RPCProtocol(h,null,i),g=E._transform(g,this._rpcProtocol);const s=new I.ServiceCollection(...n.getSingletonServiceDescriptors());s.set(o.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},g)),s.set(c.IExtHostRpcService,new c.ExtHostRpcService(this._rpcProtocol)),s.set(d.IURITransformerService,new d.URITransformerService(i)),s.set(w.IHostUtils,t);const r=new f.InstantiationService(s,!0),l=r.invokeFunction(A=>A.get(v.IExtHostTerminalService));this._disposables.add(l),this._logService=r.invokeFunction(A=>A.get(C.ILogService)),S.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",g),this._extensionService=r.invokeFunction(A=>A.get(w.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const _=new WeakMap;this._extensionService.getExtensionPathIndex().then(A=>{Error.prepareStackTrace=(a,R)=>{let F="",x,J;for(const ae of R)F+=`
	at ${ae.toString()}`,J=ae.getFileName(),!x&&J&&(x=A.findSubstr(J));return _.set(a,x),`${a.name||"Error"}: ${a.message||""}${F}`}});const p=this._rpcProtocol.getProxy(D.MainContext.MainThreadExtensionService),P=this._rpcProtocol.getProxy(D.MainContext.MainThreadErrors);T.setUnexpectedErrorHandler(A=>{const a=T.transformErrorForSerialization(A),R=_.get(A);R?p.$onExtensionRuntimeError(R.identifier,a):P.$onUnexpectedError(a)})}terminate(h){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${h}`),this._logService.flush(),this._disposables.dispose(),T.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const g=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([m.timeout(4e3),g]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(h,g){h.extensions.forEach(i=>i.extensionLocation=k.URI.revive(g.transformIncomingURIs(i.extensionLocation))),h.environment.appRoot=k.URI.revive(g.transformIncomingURIs(h.environment.appRoot));const t=h.environment.extensionDevelopmentLocationURI;return t&&(h.environment.extensionDevelopmentLocationURI=t.map(i=>k.URI.revive(g.transformIncomingURIs(i)))),h.environment.extensionTestsLocationURI=k.URI.revive(g.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=k.URI.revive(g.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=k.URI.revive(g.transformIncomingURIs(h.environment.workspaceStorageHome)),h.logsLocation=k.URI.revive(g.transformIncomingURIs(h.logsLocation)),h.logFile=k.URI.revive(g.transformIncomingURIs(h.logFile)),h.workspace=g.transformIncomingURIs(h.workspace),h}}e.ExtensionHostMain=E}),define(we[216],_e([0,1,15,18,56,27,25,52,37]),function(ee,e,m,T,S,y,k,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(o,f,c){this.config=o,this.provider=f,this.sessionToken=c,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=o.filePattern,this.includePattern=o.includePattern&&y.parse(o.includePattern),this.maxResults=o.maxResults||void 0,this.exists=o.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=o.excludePattern&&y.parse(o.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(o=>o.cancel()),this.activeCancellationTokens=new Set}search(o){const f=this.config.folderQueries||[];return new Promise((c,d)=>{const w=v=>{this.resultCount++,o(v)};if(this.isCanceled)return c({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(v=>{const E=v.toString(),u=m.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,u)||this.matchFile(w,{base:v,basename:u})}),Promise.all(f.map(v=>this.searchInFolder(v,w))).then(v=>{c({limitHit:this.isLimitHit,stats:v[0]||void 0})},v=>{d(new Error(S.toErrorMessage(v)))})})}async searchInFolder(o,f){const c=new T.CancellationTokenSource,d=this.getSearchOptionsForFolder(o),w=this.initDirectoryTree(),v=new b.QueryGlobTester(this.config,o),E=!v.hasSiblingExcludeClauses();let u;try{this.activeCancellationTokens.add(c),u=D.StopWatch.create();const h=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,c.token),g=u.elapsed(),t=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(h&&h.forEach(i=>{const s=m.posix.relative(o.folder.path,i.path);if(E){const r=m.basename(i.path);this.matchFile(f,{base:o.folder,relativePath:s,basename:r});return}this.addDirectoryEntries(w,o.folder,s,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(w,v,f),{providerTime:g,postProcessTime:t.elapsed()})}finally{c.dispose(),this.activeCancellationTokens.delete(c)}}getSearchOptionsForFolder(o){const f=b.resolvePatternsForProvider(this.config.includePattern,o.includePattern),c=b.resolvePatternsForProvider(this.config.excludePattern,o.excludePattern);return{folder:o.folder,excludes:c,includes:f,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const o={rootEntries:[],pathToEntries:Object.create(null)};return o.pathToEntries["."]=o.rootEntries,o}addDirectoryEntries({pathToEntries:o},f,c,d){if(c===this.filePattern){const v=m.basename(this.filePattern);this.matchFile(d,{base:f,relativePath:this.filePattern,basename:v})}function w(v){const E=m.basename(v),u=m.dirname(v);let h=o[u];h||(h=o[u]=[],w(u)),h.push({base:f,relativePath:v,basename:E})}w(c)}matchDirectoryTree({rootEntries:o,pathToEntries:f},c,d){const w=this,v=this.filePattern;function E(u){const h=y.hasSiblingFn(()=>u.map(g=>g.basename));for(let g=0,t=u.length;g<t;g++){const i=u[g],{relativePath:s,basename:r}=i;if(!c.includedInQuerySync(s,r,v!==r?h:void 0))continue;const l=f[s];if(l)E(l);else{if(s===v)continue;w.matchFile(d,i)}if(w.isLimitHit)break}}E(o)}matchFile(o,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||o(f))}}class n{constructor(){this.sessions=new Map}fileSearch(o,f,c,d){const w=this.getSessionTokenSource(o.cacheKey),v=new C(o,f,w&&w.token);let E=0;const u=h=>{E+=h.length,c(h.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(v,n.BATCH_SIZE,u,d).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:h.stats}}))}clearCache(o){const f=this.getSessionTokenSource(o);f&&f.cancel()}getSessionTokenSource(o){if(!!o)return this.sessions.has(o)||this.sessions.set(o,new T.CancellationTokenSource),this.sessions.get(o)}rawMatchToSearchItem(o){return o.relativePath?{resource:k.joinPath(o.base,o.relativePath)}:{resource:o.base}}doSearch(o,f,c,d){d.onCancellationRequested(()=>{o.cancel()});const w=E=>{E&&(v.push(E),f>0&&v.length>=f&&(c(v),v=[]))};let v=[];return o.search(w).then(E=>(v.length&&c(v),E),E=>(v.length&&c(v),Promise.reject(E)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(we[217],_e([0,1,15,17,18,56,25,27,2,37,12,10]),function(ee,e,m,T,S,y,k,D,b,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class o{constructor(u,h,g){this.query=u,this.provider=h,this.fileUtils=g,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(u,h){const g=this.query.folderQueries||[],t=new S.CancellationTokenSource;return h.onCancellationRequested(()=>t.cancel()),new Promise((i,s)=>{this.collector=new c(u);let r=!1;const l=(_,p)=>{if(!r&&!this.isLimitHit){const P=this.resultSize(_);w(_)&&typeof this.query.maxResults=="number"&&this.resultCount+P>this.query.maxResults&&(this.isLimitHit=!0,r=!0,t.cancel(),_=this.trimResultToSize(_,this.query.maxResults-this.resultCount));const A=this.resultSize(_);this.resultCount+=A,(A>0||!w(_))&&this.collector.add(_,p)}};Promise.all(g.map((_,p)=>this.searchInFolder(_,P=>l(P,p),t.token))).then(_=>{t.dispose(),this.collector.flush();const p=_.some(P=>!!P&&!!P.limitHit);i({limitHit:this.isLimitHit||p,messages:T.flatten(_.map(P=>(P==null?void 0:P.message)?I.isArray(P.message)?P.message:[P.message]:[])),stats:{type:"textSearchProvider"}})},_=>{t.dispose();const p=y.toErrorMessage(_);s(new Error(p))})})}resultSize(u){return w(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,h){const g=Array.isArray(u.ranges)?u.ranges:[u.ranges],t=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:g.slice(0,h),preview:{matches:t.slice(0,h),text:u.preview.text},uri:u.uri}}async searchInFolder(u,h,g){const t=new C.QueryGlobTester(this.query,u),i=[],s={report:_=>{if(!this.validateProviderResult(_))return;const p=u.folder.scheme===n.Schemas.file?D.hasSiblingPromiseFn(()=>this.fileUtils.readdir(k.dirname(_.uri))):void 0,P=k.relativePath(u.folder,_.uri);P&&i.push(t.includedInQuery(P,m.basename(P),p).then(A=>{A&&h(_)}))}},r=this.getSearchOptionsForFolder(u),l=await this.provider.provideTextSearchResults(f(this.query.contentPattern),r,s,g);return await Promise.all(i),l}validateProviderResult(u){if(w(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(u){const h=C.resolvePatternsForProvider(this.query.includePattern,u.includePattern),g=C.resolvePatternsForProvider(this.query.excludePattern,u.excludePattern),t={folder:b.URI.from(u.folder),excludes:g,includes:h,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=o;function f(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class c{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new v(512,h=>this.sendItems(h))}add(u,h){this._currentFileMatch&&(this._currentFolderIdx!==h||!k.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=h,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(d(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=c;function d(E){return w(E)?{preview:{matches:T.mapArrayOrNot(E.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:E.preview.text},ranges:T.mapArrayOrNot(E.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function w(E){return!!E.preview}e.extensionResultIsMatch=w;class v{constructor(u,h){this.maxBatchSize=u,this.cb=h,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,h){!u||this.addItemToBatch(u,h)}addItems(u,h){!u||this.addItemsToBatch(u,h)}addItemToBatch(u,h){this.batch.push(u),this.batchSize+=h,this.onUpdate()}addItemsToBatch(u,h){this.batch=this.batch.concat(u),this.batchSize+=h,this.onUpdate()}onUpdate(){this.totalNumberCompleted<v.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},v.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=v,v.TIMEOUT=4e3,v.START_BATCH_AFTER_COUNT=50}),define(we[106],_e([0,1,7,4,5,216,14,65,16,2,217]),function(ee,e,m,T,S,y,k,D,b,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=S.createDecorator("IExtHostSearch");let I=class{constructor(d,w,v){this.extHostRpc=d,this._uriTransformer=w,this._logService=v,this._proxy=this.extHostRpc.getProxy(T.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new y.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,w){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const v=this._handlePool++;return this._textSearchProvider.set(v,w),this._proxy.$registerTextSearchProvider(v,this._transformScheme(d)),m.toDisposable(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}registerFileSearchProvider(d,w){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const v=this._handlePool++;return this._fileSearchProvider.set(v,w),this._proxy.$registerFileSearchProvider(v,this._transformScheme(d)),m.toDisposable(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}$provideFileSearchResults(d,w,v,E){const u=o(v),h=this._fileSearchProvider.get(d);if(h)return this._fileSearchManager.fileSearch(u,h,g=>{this._proxy.$handleFileMatch(d,w,g.map(t=>t.resource))},E);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,w,v,E){const u=this._textSearchProvider.get(d);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const h=o(v);return this.createTextSearchManager(h,u).search(t=>this._proxy.$handleTextMatch(d,w,t),E)}createTextSearchManager(d,w){return new n.TextSearchManager(d,w,{readdir:v=>Promise.resolve([]),toCanonicalName:v=>v})}};I=He([ze(0,k.IExtHostRpcService),ze(1,D.IURITransformerService),ze(2,b.ILogService)],I),e.ExtHostSearch=I;function o(c){return Object.assign(Object.assign({},c),{folderQueries:c.folderQueries&&c.folderQueries.map(f),extraFileResources:c.extraFileResources&&c.extraFileResources.map(d=>C.URI.revive(d))})}e.reviveQuery=o;function f(c){return Object.assign(Object.assign({},c),{folder:C.URI.revive(c.folder)})}}),define(we[218],_e([0,1,18,11,3,41,2,123,83,117,55,59,4,181,180,70,182,32,183,184,185,167,186,46,33,187,168,189,190,191,101,170,196,197,198,72,36,200,171,9,6,203,47,102,31,29,75,159,188,92,100,104,105,106,16,65,14,28,192,157,64,69,178,201,156,73,71,206,204,205,179,45,199,202,68,63,93,194,103,195,12,148,193,154]),function(ee,e,m,T,S,y,k,D,b,C,n,I,o,f,c,d,w,v,E,u,h,g,t,i,s,r,l,_,p,P,A,a,R,F,x,J,ae,j,W,Q,M,X,B,U,Y,V,ce,ge,Ae,$e,Fe,Ve,tt,Ke,Qe,$,K,ie,se,q,oe,fe,Re,xe,pe,qe,H,te,me,Te,Le,Ge,Se,be,Ce,re,de,N,G,le,ke,Pe,Ne,Be){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ze(Je){const Ye=Je.get(ie.IExtHostInitDataService),nt=Je.get(Ge.IExtHostFileSystemInfo),gt=Je.get(H.IExtHostConsumerFileSystem),ve=Je.get(s.IExtHostExtensionService),ye=Je.get(Y.IExtHostWorkspace),ue=Je.get(de.IExtHostTelemetry),z=Je.get(v.IExtHostConfiguration),Oe=Je.get($.IURITransformerService),Ee=Je.get(K.IExtHostRpcService),We=Je.get(J.IExtHostStorage),Xe=Je.get(qe.IExtensionStoragePaths),et=Je.get(Qe.ILogService),st=Je.get(oe.IExtHostTunnelService),pt=Je.get(fe.IExtHostApiDeprecationService),bt=Je.get(U.IExtHostWindow),_t=Je.get(Ce.IExtHostSecretState),vt=Je.get(re.IExtHostEditorTabs);Ee.set(o.ExtHostContext.ExtHostFileSystemInfo,nt),Ee.set(o.ExtHostContext.ExtHostLogService,et),Ee.set(o.ExtHostContext.ExtHostWorkspace,ye),Ee.set(o.ExtHostContext.ExtHostConfiguration,z),Ee.set(o.ExtHostContext.ExtHostExtensionService,ve),Ee.set(o.ExtHostContext.ExtHostStorage,We),Ee.set(o.ExtHostContext.ExtHostTunnelService,st),Ee.set(o.ExtHostContext.ExtHostWindow,bt),Ee.set(o.ExtHostContext.ExtHostSecretState,_t),Ee.set(o.ExtHostContext.ExtHostTelemetry,ue),Ee.set(o.ExtHostContext.ExtHostEditorTabs,vt);const xt=Ee.set(o.ExtHostContext.ExtHostDecorations,Je.get(Fe.IExtHostDecorations)),Et=Ee.set(o.ExtHostContext.ExtHostDocumentsAndEditors,Je.get(i.IExtHostDocumentsAndEditors)),dt=Ee.set(o.ExtHostContext.ExtHostCommands,Je.get(d.IExtHostCommands)),ut=Ee.set(o.ExtHostContext.ExtHostTerminalService,Je.get(ae.IExtHostTerminalService)),ht=Ee.set(o.ExtHostContext.ExtHostDebugService,Je.get(tt.IExtHostDebugService)),Ht=Ee.set(o.ExtHostContext.ExtHostSearch,Je.get(Ke.IExtHostSearch)),kt=Ee.set(o.ExtHostContext.ExtHostTask,Je.get(Ve.IExtHostTask)),At=Ee.set(o.ExtHostContext.ExtHostOutputService,Je.get(A.IExtHostOutputService)),Kt=Ee.set(o.ExtHostContext.ExtHostUrls,new X.ExtHostUrls(Ee)),yt=Ee.set(o.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(Ee,Et)),en=Ee.set(o.ExtHostContext.ExtHostDocumentContentProviders,new h.ExtHostDocumentContentProvider(Ee,Et,et)),tn=Ee.set(o.ExtHostContext.ExtHostDocumentSaveParticipant,new g.ExtHostDocumentSaveParticipant(et,yt,Ee.getProxy(o.MainContext.MainThreadBulkEdits))),mt=Ee.set(o.ExtHostContext.ExtHostNotebook,new se.ExtHostNotebookController(Ee,dt,Et,yt,Xe)),Qt=Ee.set(o.ExtHostContext.ExtHostNotebookDocuments,new Be.ExtHostNotebookDocuments(et,mt)),zt=Ee.set(o.ExtHostContext.ExtHostNotebookEditors,new Ne.ExtHostNotebookEditors(et,Ee,mt)),nn=Ee.set(o.ExtHostContext.ExtHostNotebookKernels,new N.ExtHostNotebookKernels(Ee,Ye,mt,et)),En=Ee.set(o.ExtHostContext.ExtHostNotebookRenderers,new le.ExtHostNotebookRenderers(Ee,mt)),Dt=Ee.set(o.ExtHostContext.ExtHostEditors,new j.ExtHostEditors(Ee,Et)),Yt=Ee.set(o.ExtHostContext.ExtHostTreeViews,new W.ExtHostTreeViews(Ee.getProxy(o.MainContext.MainThreadTreeViews),dt,et)),rn=Ee.set(o.ExtHostContext.ExtHostEditorInsets,new ge.ExtHostEditorInsets(Ee.getProxy(o.MainContext.MainThreadEditorInsets),Dt,Ye)),Bt=Ee.set(o.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(Ee,et)),ct=Ee.set(o.ExtHostContext.ExtHostLanguageFeatures,new _.ExtHostLanguageFeatures(Ee,Oe,yt,dt,Bt,et,pt)),sn=Ee.set(o.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(Ee,ct)),Tt=Ee.set(o.ExtHostContext.ExtHostFileSystemEventService,new l.ExtHostFileSystemEventService(Ee,et,Et)),Vt=Ee.set(o.ExtHostContext.ExtHostQuickOpen,R.createExtHostQuickOpen(Ee,ye,dt)),hn=Ee.set(o.ExtHostContext.ExtHostSCM,new F.ExtHostSCM(Ee,dt,et)),yn=Ee.set(o.ExtHostContext.ExtHostComments,new w.ExtHostComments(Ee,dt,yt)),fn=Ee.set(o.ExtHostContext.ExtHostProgress,new a.ExtHostProgress(Ee.getProxy(o.MainContext.MainThreadProgress))),Sn=Ee.set(o.ExtHostContext.ExtHosLabelService,new Ae.ExtHostLabelService(Ee)),Jt=Ee.set(o.ExtHostContext.ExtHostTheming,new q.ExtHostTheming(Ee)),Lt=Ee.set(o.ExtHostContext.ExtHostAuthentication,new Re.ExtHostAuthentication(Ee)),Dn=Ee.set(o.ExtHostContext.ExtHostTimeline,new xe.ExtHostTimeline(Ee,dt)),on=Ee.set(o.ExtHostContext.ExtHostWebviews,new B.ExtHostWebviews(Ee,{remote:Ye.remote},ye,et,pt)),an=Ee.set(o.ExtHostContext.ExtHostWebviewPanels,new Te.ExtHostWebviewPanels(Ee,on,ye)),Cn=Ee.set(o.ExtHostContext.ExtHostCustomEditors,new me.ExtHostCustomEditors(Ee,yt,Xe,on,an)),Xt=Ee.set(o.ExtHostContext.ExtHostWebviewViews,new te.ExtHostWebviewViews(Ee,on)),jt=Ee.set(o.ExtHostContext.ExtHostTesting,new Se.ExtHostTesting(Ee,dt)),kn=Ee.set(o.ExtHostContext.ExtHostUriOpeners,new be.ExtHostUriOpeners(Ee)),ln=ce.values(o.ExtHostContext);Ee.assertRegistered(ln);const In=new Le.ExtHostBulkEdits(Ee,Et),qt=new c.ExtHostClipboard(Ee),Rt=new P.ExtHostMessageService(Ee,et),mn=new u.ExtHostDialogs(Ee),Pt=new x.ExtHostStatusBar(Ee,dt.converter),$t=new p.ExtHostLanguages(Ee,yt);return f.ExtHostApiCommands.register(dt),function(Me,un,gn){const ft=function(){let Z=!Me.isUnderDevelopment;function he(Ie){Z||(et.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Z=!0)}return function Ie(at){if(Array.isArray(at))at.forEach(Ie);else if(typeof at=="string")he(at);else{const wt=at;typeof wt.scheme=="undefined"&&he(at),!Me.enableProposedApi&&typeof wt.exclusive=="boolean"&&V.throwProposedApiError(Me)}return at}}(),Pn={getSession(Z,he,Ie){return Lt.getSession(Me,Z,he,Ie)},get onDidChangeSessions(){return Lt.onDidChangeSessions},registerAuthenticationProvider(Z,he,Ie,at){return Lt.registerAuthenticationProvider(Z,he,Ie,at)},get onDidChangeAuthenticationProviders(){return V.checkProposedApiEnabled(Me),Lt.onDidChangeAuthenticationProviders},get providers(){return V.checkProposedApiEnabled(Me),Lt.providers},logout(Z,he){return V.checkProposedApiEnabled(Me),Lt.removeSession(Z,he)}},An={registerCommand(Z,he,Ie){return dt.registerCommand(!0,Z,he,Ie)},registerTextEditorCommand(Z,he,Ie){return dt.registerCommand(!0,Z,(...at)=>{const wt=Dt.getActiveTextEditor();if(!wt){et.warn("Cannot execute "+Z+" because there is no active text editor.");return}return wt.edit(Ct=>{he.apply(Ie,[wt,Ct,...at])}).then(Ct=>{Ct||et.warn("Edits from command "+Z+" were not applied.")},Ct=>{et.warn("An error occurred while running command "+Z,Ct)})})},registerDiffInformationCommand:(Z,he,Ie)=>(V.checkProposedApiEnabled(Me),dt.registerCommand(!0,Z,async(...at)=>{const wt=Et.activeEditor(!0);if(!wt){et.warn("Cannot execute "+Z+" because there is no active text editor.");return}const Ct=await Dt.getDiffInformation(wt.id);he.apply(Ie,[Ct,...at])})),executeCommand(Z,...he){return dt.executeCommand(Z,...he)},getCommands(Z=!1){return dt.getCommands(Z)}},pn={get machineId(){return Ye.telemetryInfo.machineId},get sessionId(){return Ye.telemetryInfo.sessionId},get language(){return Ye.environment.appLanguage},get appName(){return Ye.environment.appName},get appRoot(){var Z,he;return(he=(Z=Ye.environment.appRoot)===null||Z===void 0?void 0:Z.fsPath)!==null&&he!==void 0?he:""},get uriScheme(){return Ye.environment.appUriScheme},get clipboard(){return qt.value},get shell(){return ut.getDefaultShell(!1)},get isTelemetryEnabled(){return ue.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ue.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Z=Date.now()-new Date(Ye.telemetryInfo.firstSessionDate).getTime();return isNaN(Z)?!1:Z<1e3*60*60*24},openExternal(Z,he){return bt.openUri(Z,{allowTunneling:!!Ye.remote.authority,allowContributedOpeners:he==null?void 0:he.allowContributedOpeners})},async asExternalUri(Z){if(Z.scheme===Ye.environment.appUriScheme)return Kt.createAppUri(Z);const he=Pe.matchesScheme(Z,ke.Schemas.http)||Pe.matchesScheme(Z,ke.Schemas.https);he||V.checkProposedApiEnabled(Me);try{return await bt.asExternalUri(Z,{allowTunneling:!!Ye.remote.authority})}catch(Ie){if(he)return Z;throw Ie}},get remoteName(){return $e.getRemoteName(Ye.remote.authority)},get uiKind(){return Ye.uiKind}};Ye.environment.extensionTestsLocationURI||Object.freeze(pn);const Zt=Ye.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,Tn={createTestController(Z){return V.checkProposedApiEnabled(Me),jt.createTestController(Z)},createTestObserver(){return V.checkProposedApiEnabled(Me),jt.createTestObserver()},runTests(Z){return V.checkProposedApiEnabled(Me),jt.runTests(Z)},get onDidChangeTestResults(){return V.checkProposedApiEnabled(Me),jt.onResultsChanged},get testResults(){return V.checkProposedApiEnabled(Me),jt.results}},Rn={getExtension(Z){const he=un.getExtensionDescription(Z);if(he)return new s.Extension(ve,Me.identifier,he,Zt)},get all(){return un.getAllExtensionDescriptions().map(Z=>new s.Extension(ve,Me.identifier,Z,Zt))},get onDidChange(){return un.onDidChange}},Fn={createDiagnosticCollection(Z){return Bt.createDiagnosticCollection(Me.identifier,Z)},get onDidChangeDiagnostics(){return Bt.onDidChangeDiagnostics},getDiagnostics:Z=>Bt.getDiagnostics(Z),getLanguages(){return $t.getLanguages()},setTextDocumentLanguage(Z,he){return $t.changeLanguage(Z.uri,he)},match(Z,he){return n.score(Q.LanguageSelector.from(Z),he.uri,he.languageId,!0)},registerCodeActionsProvider(Z,he,Ie){return ct.registerCodeActionProvider(Me,ft(Z),he,Ie)},registerCodeLensProvider(Z,he){return ct.registerCodeLensProvider(Me,ft(Z),he)},registerDefinitionProvider(Z,he){return ct.registerDefinitionProvider(Me,ft(Z),he)},registerDeclarationProvider(Z,he){return ct.registerDeclarationProvider(Me,ft(Z),he)},registerImplementationProvider(Z,he){return ct.registerImplementationProvider(Me,ft(Z),he)},registerTypeDefinitionProvider(Z,he){return ct.registerTypeDefinitionProvider(Me,ft(Z),he)},registerHoverProvider(Z,he){return ct.registerHoverProvider(Me,ft(Z),he,Me.identifier)},registerEvaluatableExpressionProvider(Z,he){return ct.registerEvaluatableExpressionProvider(Me,ft(Z),he,Me.identifier)},registerInlineValuesProvider(Z,he){return ct.registerInlineValuesProvider(Me,ft(Z),he,Me.identifier)},registerDocumentHighlightProvider(Z,he){return ct.registerDocumentHighlightProvider(Me,ft(Z),he)},registerLinkedEditingRangeProvider(Z,he){return ct.registerLinkedEditingRangeProvider(Me,ft(Z),he)},registerReferenceProvider(Z,he){return ct.registerReferenceProvider(Me,ft(Z),he)},registerRenameProvider(Z,he){return ct.registerRenameProvider(Me,ft(Z),he)},registerDocumentSymbolProvider(Z,he,Ie){return ct.registerDocumentSymbolProvider(Me,ft(Z),he,Ie)},registerWorkspaceSymbolProvider(Z){return ct.registerWorkspaceSymbolProvider(Me,Z)},registerDocumentFormattingEditProvider(Z,he){return ct.registerDocumentFormattingEditProvider(Me,ft(Z),he)},registerDocumentRangeFormattingEditProvider(Z,he){return ct.registerDocumentRangeFormattingEditProvider(Me,ft(Z),he)},registerOnTypeFormattingEditProvider(Z,he,Ie,...at){return ct.registerOnTypeFormattingEditProvider(Me,ft(Z),he,[Ie].concat(at))},registerDocumentSemanticTokensProvider(Z,he,Ie){return ct.registerDocumentSemanticTokensProvider(Me,ft(Z),he,Ie)},registerDocumentRangeSemanticTokensProvider(Z,he,Ie){return ct.registerDocumentRangeSemanticTokensProvider(Me,ft(Z),he,Ie)},registerSignatureHelpProvider(Z,he,Ie,...at){return typeof Ie=="object"?ct.registerSignatureHelpProvider(Me,ft(Z),he,Ie):ct.registerSignatureHelpProvider(Me,ft(Z),he,typeof Ie=="undefined"?[]:[Ie,...at])},registerCompletionItemProvider(Z,he,...Ie){return ct.registerCompletionItemProvider(Me,ft(Z),he,Ie)},registerInlineCompletionItemProvider(Z,he){return V.checkProposedApiEnabled(Me),ct.registerInlineCompletionsProvider(Me,ft(Z),he)},registerDocumentLinkProvider(Z,he){return ct.registerDocumentLinkProvider(Me,ft(Z),he)},registerColorProvider(Z,he){return ct.registerColorProvider(Me,ft(Z),he)},registerFoldingRangeProvider(Z,he){return ct.registerFoldingRangeProvider(Me,ft(Z),he)},registerSelectionRangeProvider(Z,he){return ct.registerSelectionRangeProvider(Me,Z,he)},registerCallHierarchyProvider(Z,he){return ct.registerCallHierarchyProvider(Me,Z,he)},setLanguageConfiguration:(Z,he)=>ct.setLanguageConfiguration(Me,Z,he),getTokenInformationAtPosition(Z,he){return V.checkProposedApiEnabled(Me),$t.tokenAtPosition(Z,he)},registerInlayHintsProvider(Z,he){return V.checkProposedApiEnabled(Me),ct.registerInlayHintsProvider(Me,Z,he)}},Ln={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return ut.activeTerminal},get terminals(){return ut.terminals},async showTextDocument(Z,he,Ie){const at=await(k.URI.isUri(Z)?Promise.resolve(vn.openTextDocument(Z)):Promise.resolve(Z));return Dt.showTextDocument(at,he,Ie)},createTextEditorDecorationType(Z){return Dt.createTextEditorDecorationType(Me,Z)},onDidChangeActiveTextEditor(Z,he,Ie){return Dt.onDidChangeActiveTextEditor(Z,he,Ie)},onDidChangeVisibleTextEditors(Z,he,Ie){return Dt.onDidChangeVisibleTextEditors(Z,he,Ie)},onDidChangeTextEditorSelection(Z,he,Ie){return Dt.onDidChangeTextEditorSelection(Z,he,Ie)},onDidChangeTextEditorOptions(Z,he,Ie){return Dt.onDidChangeTextEditorOptions(Z,he,Ie)},onDidChangeTextEditorVisibleRanges(Z,he,Ie){return Dt.onDidChangeTextEditorVisibleRanges(Z,he,Ie)},onDidChangeTextEditorViewColumn(Z,he,Ie){return Dt.onDidChangeTextEditorViewColumn(Z,he,Ie)},onDidCloseTerminal(Z,he,Ie){return ut.onDidCloseTerminal(Z,he,Ie)},onDidOpenTerminal(Z,he,Ie){return ut.onDidOpenTerminal(Z,he,Ie)},onDidChangeActiveTerminal(Z,he,Ie){return ut.onDidChangeActiveTerminal(Z,he,Ie)},onDidChangeTerminalDimensions(Z,he,Ie){return V.checkProposedApiEnabled(Me),ut.onDidChangeTerminalDimensions(Z,he,Ie)},onDidWriteTerminalData(Z,he,Ie){return V.checkProposedApiEnabled(Me),ut.onDidWriteTerminalData(Z,he,Ie)},get state(){return bt.state},onDidChangeWindowState(Z,he,Ie){return bt.onDidChangeWindowState(Z,he,Ie)},showInformationMessage(Z,...he){return Rt.showMessage(Me,y.default.Info,Z,he[0],he.slice(1))},showWarningMessage(Z,...he){return Rt.showMessage(Me,y.default.Warning,Z,he[0],he.slice(1))},showErrorMessage(Z,...he){return Rt.showMessage(Me,y.default.Error,Z,he[0],he.slice(1))},showQuickPick(Z,he,Ie){return Vt.showQuickPick(Z,!!Me.enableProposedApi,he,Ie)},showWorkspaceFolderPick(Z){return Vt.showWorkspaceFolderPick(Z)},showInputBox(Z,he){return Vt.showInput(Z,he)},showOpenDialog(Z){return mn.showOpenDialog(Z)},showSaveDialog(Z){return mn.showSaveDialog(Z)},createStatusBarItem(Z,he,Ie){let at,wt,Ct;return typeof Z=="string"?(at=Z,wt=he,Ct=Ie):(wt=Z,Ct=he),Pt.createStatusBarEntry(Me,at,wt,Ct)},setStatusBarMessage(Z,he){return Pt.setStatusBarMessage(Z,he)},withScmProgress(Z){return pt.report("window.withScmProgress",Me,"Use 'withProgress' instead."),fn.withProgress(Me,{location:M.ProgressLocation.SourceControl},(he,Ie)=>Z({report(at){}}))},withProgress(Z,he){return fn.withProgress(Me,Z,he)},createOutputChannel(Z){return At.createOutputChannel(Z)},createWebviewPanel(Z,he,Ie,at){return an.createWebviewPanel(Me,Z,he,Ie,at)},createWebviewTextEditorInset(Z,he,Ie,at){return V.checkProposedApiEnabled(Me),rn.createWebviewEditorInset(Z,he,Ie,at,Me)},createTerminal(Z,he,Ie){return typeof Z=="object"?"pty"in Z?ut.createExtensionTerminal(Z):ut.createTerminalFromOptions(Z):ut.createTerminal(Z,he,Ie)},registerTerminalLinkProvider(Z){return ut.registerLinkProvider(Z)},registerTerminalProfileProvider(Z,he){return ut.registerProfileProvider(Me,Z,he)},registerTreeDataProvider(Z,he){return Yt.registerTreeDataProvider(Z,he,Me)},createTreeView(Z,he){return Yt.createTreeView(Z,he,Me)},registerWebviewPanelSerializer:(Z,he)=>an.registerWebviewPanelSerializer(Me,Z,he),registerCustomEditorProvider:(Z,he,Ie={})=>Cn.registerCustomEditorProvider(Me,Z,he,Ie),registerFileDecorationProvider(Z){return xt.registerFileDecorationProvider(Z,Me.identifier)},registerUriHandler(Z){return Kt.registerUriHandler(Me.identifier,Z)},createQuickPick(){return Vt.createQuickPick(Me.identifier,!!Me.enableProposedApi)},createInputBox(){return Vt.createInputBox(Me.identifier)},get activeColorTheme(){return Jt.activeColorTheme},onDidChangeActiveColorTheme(Z,he,Ie){return Jt.onDidChangeActiveColorTheme(Z,he,Ie)},registerWebviewViewProvider(Z,he,Ie){return Xt.registerWebviewViewProvider(Me,Z,he,Ie==null?void 0:Ie.webviewOptions)},get activeNotebookEditor(){return V.checkProposedApiEnabled(Me),mt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Z,he,Ie){return V.checkProposedApiEnabled(Me),mt.onDidChangeActiveNotebookEditor(Z,he,Ie)},get visibleNotebookEditors(){return V.checkProposedApiEnabled(Me),mt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return V.checkProposedApiEnabled(Me),mt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Z,he,Ie){return V.checkProposedApiEnabled(Me),zt.onDidChangeNotebookEditorSelection(Z,he,Ie)},onDidChangeNotebookEditorVisibleRanges(Z,he,Ie){return V.checkProposedApiEnabled(Me),zt.onDidChangeNotebookEditorVisibleRanges(Z,he,Ie)},showNotebookDocument(Z,he){return V.checkProposedApiEnabled(Me),mt.showNotebookDocument(Z,he)},registerExternalUriOpener(Z,he,Ie){return V.checkProposedApiEnabled(Me),kn.registerExternalUriOpener(Me.identifier,Z,he,Ie)},get openEditors(){return V.checkProposedApiEnabled(Me),vt.tabs},get onDidChangeOpenEditors(){return V.checkProposedApiEnabled(Me),vt.onDidChangeTabs},getInlineCompletionItemController(Z){return V.checkProposedApiEnabled(Me),_.InlineCompletionController.get(Z)}},vn={get rootPath(){return pt.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ye.getPath()},set rootPath(Z){throw T.readonly()},getWorkspaceFolder(Z){return ye.getWorkspaceFolder(Z)},get workspaceFolders(){return ye.getWorkspaceFolders()},get name(){return ye.name},set name(Z){throw T.readonly()},get workspaceFile(){return ye.workspaceFile},set workspaceFile(Z){throw T.readonly()},updateWorkspaceFolders:(Z,he,...Ie)=>ye.updateWorkspaceFolders(Me,Z,he||0,...Ie),onDidChangeWorkspaceFolders:function(Z,he,Ie){return ye.onDidChangeWorkspace(Z,he,Ie)},asRelativePath:(Z,he)=>ye.getRelativePath(Z,he),findFiles:(Z,he,Ie,at)=>ye.findFiles(Q.GlobPattern.from(Z),Q.GlobPattern.from(he),Ie,Me.identifier,at),findTextInFiles:(Z,he,Ie,at)=>{let wt,Ct;return typeof he=="object"?(wt=he,Ct=Ie):(wt={},Ct=he,at=Ie),ye.findTextInFiles(Z,wt||{},Ct,Me.identifier,at)},saveAll:Z=>ye.saveAll(Z),applyEdit(Z){return In.applyWorkspaceEdit(Z)},createFileSystemWatcher:(Z,he,Ie,at)=>Tt.createFileSystemWatcher(Q.GlobPattern.from(Z),he,Ie,at),get textDocuments(){return yt.getAllDocumentData().map(Z=>Z.document)},set textDocuments(Z){throw T.readonly()},openTextDocument(Z){let he;const Ie=Z;if(typeof Z=="string")he=Promise.resolve(k.URI.file(Z));else if(k.URI.isUri(Z))he=Promise.resolve(Z);else if(!Ie||typeof Ie=="object")he=yt.createDocumentData(Ie);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(at=>yt.ensureDocumentData(at).then(wt=>wt.document))},onDidOpenTextDocument:(Z,he,Ie)=>yt.onDidAddDocument(Z,he,Ie),onDidCloseTextDocument:(Z,he,Ie)=>yt.onDidRemoveDocument(Z,he,Ie),onDidChangeTextDocument:(Z,he,Ie)=>yt.onDidChangeDocument(Z,he,Ie),onDidSaveTextDocument:(Z,he,Ie)=>yt.onDidSaveDocument(Z,he,Ie),onWillSaveTextDocument:(Z,he,Ie)=>tn.getOnWillSaveTextDocumentEvent(Me)(Z,he,Ie),get notebookDocuments(){return mt.notebookDocuments.map(Z=>Z.apiNotebook)},async openNotebookDocument(Z,he){let Ie;if(k.URI.isUri(Z))Ie=Z,await mt.openNotebookDocument(Z);else if(typeof Z=="string")Ie=k.URI.revive(await mt.createNotebookDocument({viewType:Z,content:he}));else throw new Error("Invalid arguments");return mt.getNotebookDocument(Ie).apiNotebook},get onDidOpenNotebookDocument(){return mt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return mt.onDidCloseNotebookDocument},registerNotebookSerializer(Z,he,Ie,at){return mt.registerNotebookSerializer(Me,Z,he,Ie,Me.enableProposedApi?at:void 0)},registerNotebookContentProvider:(Z,he,Ie,at)=>(V.checkProposedApiEnabled(Me),mt.registerNotebookContentProvider(Me,Z,he,Ie,Me.enableProposedApi?at:void 0)),onDidChangeConfiguration:(Z,he,Ie)=>gn.onDidChangeConfiguration(Z,he,Ie),getConfiguration(Z,he){return he=arguments.length===1?void 0:he,gn.getConfiguration(Z,he,Me)},registerTextDocumentContentProvider(Z,he){return en.registerTextDocumentContentProvider(Z,he)},registerTaskProvider:(Z,he)=>(pt.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),kt.registerTaskProvider(Me,Z,he)),registerFileSystemProvider(Z,he,Ie){return sn.registerFileSystemProvider(Me.identifier,Z,he,Ie,Me.enableProposedApi)},get fs(){return gt.value},registerFileSearchProvider:(Z,he)=>(V.checkProposedApiEnabled(Me),Ht.registerFileSearchProvider(Z,he)),registerTextSearchProvider:(Z,he)=>(V.checkProposedApiEnabled(Me),Ht.registerTextSearchProvider(Z,he)),registerRemoteAuthorityResolver:(Z,he)=>(V.checkProposedApiEnabled(Me),ve.registerRemoteAuthorityResolver(Z,he)),registerResourceLabelFormatter:Z=>(V.checkProposedApiEnabled(Me),Sn.$registerResourceLabelFormatter(Z)),onDidCreateFiles:(Z,he,Ie)=>Tt.onDidCreateFile(Z,he,Ie),onDidDeleteFiles:(Z,he,Ie)=>Tt.onDidDeleteFile(Z,he,Ie),onDidRenameFiles:(Z,he,Ie)=>Tt.onDidRenameFile(Z,he,Ie),onWillCreateFiles:(Z,he,Ie)=>Tt.getOnWillCreateFileEvent(Me)(Z,he,Ie),onWillDeleteFiles:(Z,he,Ie)=>Tt.getOnWillDeleteFileEvent(Me)(Z,he,Ie),onWillRenameFiles:(Z,he,Ie)=>Tt.getOnWillRenameFileEvent(Me)(Z,he,Ie),openTunnel:Z=>(V.checkProposedApiEnabled(Me),st.openTunnel(Me,Z).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return V.checkProposedApiEnabled(Me),st.getTunnels()},onDidChangeTunnels:(Z,he,Ie)=>(V.checkProposedApiEnabled(Me),st.onDidChangeTunnels(Z,he,Ie)),registerPortAttributesProvider:(Z,he)=>(V.checkProposedApiEnabled(Me),st.registerPortsAttributesProvider(Z,he)),registerTimelineProvider:(Z,he)=>(V.checkProposedApiEnabled(Me),Dn.registerTimelineProvider(Z,he,Me.identifier,dt.converter)),get isTrusted(){return ye.trusted},requestWorkspaceTrust:Z=>(V.checkProposedApiEnabled(Me),ye.requestWorkspaceTrust(Z)),onDidGrantWorkspaceTrust:(Z,he,Ie)=>ye.onDidGrantWorkspaceTrust(Z,he,Ie)},Mn={get inputBox(){return pt.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),hn.getLastInputBox(Me)},createSourceControl(Z,he,Ie){return hn.createSourceControl(Me,Z,he,Ie)}},bn={createCommentController(Z,he){return yn.createCommentController(Me,Z,he)}},wn={get activeDebugSession(){return ht.activeDebugSession},get activeDebugConsole(){return ht.activeDebugConsole},get breakpoints(){return ht.breakpoints},onDidStartDebugSession(Z,he,Ie){return ht.onDidStartDebugSession(Z,he,Ie)},onDidTerminateDebugSession(Z,he,Ie){return ht.onDidTerminateDebugSession(Z,he,Ie)},onDidChangeActiveDebugSession(Z,he,Ie){return ht.onDidChangeActiveDebugSession(Z,he,Ie)},onDidReceiveDebugSessionCustomEvent(Z,he,Ie){return ht.onDidReceiveDebugSessionCustomEvent(Z,he,Ie)},onDidChangeBreakpoints(Z,he,Ie){return ht.onDidChangeBreakpoints(Z,he,Ie)},registerDebugConfigurationProvider(Z,he,Ie){return ht.registerDebugConfigurationProvider(Z,he,Ie||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Z,he){return ht.registerDebugAdapterDescriptorFactory(Me,Z,he)},registerDebugAdapterTrackerFactory(Z,he){return ht.registerDebugAdapterTrackerFactory(Z,he)},startDebugging(Z,he,Ie){return!Ie||typeof Ie=="object"&&"configuration"in Ie?ht.startDebugging(Z,he,{parentSession:Ie}):ht.startDebugging(Z,he,Ie||{})},stopDebugging(Z){return ht.stopDebugging(Z)},addBreakpoints(Z){return ht.addBreakpoints(Z)},removeBreakpoints(Z){return ht.removeBreakpoints(Z)},asDebugSourceUri(Z,he){return ht.asDebugSourceUri(Z,he)}},Nt={registerTaskProvider:(Z,he)=>kt.registerTaskProvider(Me,Z,he),fetchTasks:Z=>kt.fetchTasks(Z),executeTask:Z=>kt.executeTask(Me,Z),get taskExecutions(){return kt.taskExecutions},onDidStartTask:(Z,he,Ie)=>kt.onDidStartTask(Z,he,Ie),onDidEndTask:(Z,he,Ie)=>kt.onDidEndTask(Z,he,Ie),onDidStartTaskProcess:(Z,he,Ie)=>kt.onDidStartTaskProcess(Z,he,Ie),onDidEndTaskProcess:(Z,he,Ie)=>kt.onDidEndTaskProcess(Z,he,Ie)},Wt={createNotebookController(Z,he,Ie,at,wt){return nn.createNotebookController(Me,Z,he,Ie,at,Me.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(Z,he)=>mt.registerNotebookCellStatusBarItemProvider(Me,Z,he),get onDidSaveNotebookDocument(){return V.checkProposedApiEnabled(Me),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Z){return V.checkProposedApiEnabled(Me),zt.createNotebookEditorDecorationType(Z)},createRendererMessaging(Z){return V.checkProposedApiEnabled(Me),En.createRendererMessaging(Z)},onDidChangeNotebookDocumentMetadata(Z,he,Ie){return V.checkProposedApiEnabled(Me),Qt.onDidChangeNotebookDocumentMetadata(Z,he,Ie)},onDidChangeNotebookCells(Z,he,Ie){return V.checkProposedApiEnabled(Me),mt.onDidChangeNotebookCells(Z,he,Ie)},onDidChangeNotebookCellExecutionState(Z,he,Ie){return V.checkProposedApiEnabled(Me),mt.onDidChangeNotebookCellExecutionState(Z,he,Ie)},onDidChangeCellOutputs(Z,he,Ie){return V.checkProposedApiEnabled(Me),mt.onDidChangeCellOutputs(Z,he,Ie)},onDidChangeCellMetadata(Z,he,Ie){return V.checkProposedApiEnabled(Me),mt.onDidChangeCellMetadata(Z,he,Ie)},createConcatTextDocument(Z,he){return V.checkProposedApiEnabled(Me),new pe.ExtHostNotebookConcatDocument(mt,yt,Z,he)}};return{version:Ye.version,authentication:Pn,commands:An,comments:bn,debug:wn,env:pn,extensions:Rn,languages:Fn,notebooks:Wt,scm:Mn,tasks:Nt,test:Tn,window:Ln,workspace:vn,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:m.CancellationTokenSource,CandidatePortSource:o.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:M.InlineCompletionTriggerKind,EventEmitter:S.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,InlineCompletionItem:M.InlineSuggestion,InlineCompletionList:M.InlineSuggestions,Hover:M.Hover,IndentAction:C.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:b.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TerminalLink:M.TerminalLink,TerminalProfile:M.TerminalProfile,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,UIKind:o.UIKind,Uri:k.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlayHint:M.InlayHint,InlayHintKind:M.InlayHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookRange:M.NotebookRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookRendererScript:M.NotebookRendererScript,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,NotebookCellStatusBarItem:M.NotebookCellStatusBarItem,NotebookControllerAffinity:M.NotebookControllerAffinity,PortAttributes:M.PortAttributes,LinkedEditingRanges:M.LinkedEditingRanges,TestItemStatus:M.TestItemStatus,TestResultState:M.TestResultState,TestRunRequest:M.TestRunRequest,TestMessage:M.TestMessage,TextSearchCompleteMessageType:G.TextSearchCompleteMessageType,TestMessageSeverity:M.TestMessageSeverity,WorkspaceTrustState:M.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ze}),define(we[219],_e([0,1,57,101,31,100,32,70,46,36,104,105,106,73,72,64,69,102,71,45,68,93,63]),function(ee,e,m,T,S,y,k,D,b,C,n,I,o,f,c,d,w,v,E,u,h,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),m.registerSingleton(f.IExtensionStoragePaths,f.ExtensionStoragePaths),m.registerSingleton(w.IExtHostApiDeprecationService,w.ExtHostApiDeprecationService),m.registerSingleton(D.IExtHostCommands,D.ExtHostCommands),m.registerSingleton(k.IExtHostConfiguration,k.ExtHostConfiguration),m.registerSingleton(E.IExtHostConsumerFileSystem,E.ExtHostConsumerFileSystem),m.registerSingleton(I.IExtHostDebugService,I.WorkerExtHostDebugService),m.registerSingleton(y.IExtHostDecorations,y.ExtHostDecorations),m.registerSingleton(b.IExtHostDocumentsAndEditors,b.ExtHostDocumentsAndEditors),m.registerSingleton(u.IExtHostFileSystemInfo,u.ExtHostFileSystemInfo),m.registerSingleton(T.IExtHostOutputService,T.ExtHostOutputService),m.registerSingleton(o.IExtHostSearch,o.ExtHostSearch),m.registerSingleton(c.IExtHostStorage,c.ExtHostStorage),m.registerSingleton(n.IExtHostTask,n.WorkerExtHostTask),m.registerSingleton(C.IExtHostTerminalService,C.WorkerExtHostTerminalService),m.registerSingleton(d.IExtHostTunnelService,d.ExtHostTunnelService),m.registerSingleton(v.IExtHostWindow,v.ExtHostWindow),m.registerSingleton(S.IExtHostWorkspace,S.ExtHostWorkspace),m.registerSingleton(h.IExtHostSecretState,h.ExtHostSecretState),m.registerSingleton(g.IExtHostTelemetry,g.ExtHostTelemetry),m.registerSingleton(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(we[220],_e([0,1,218,33,214,6,13,4,12]),function(ee,e,m,T,S,y,k,D,b){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var n;(function(d){var w;const v=(w=self.trustedTypes)===null||w===void 0?void 0:w.createPolicy("TrustedFunctionWorkaround",{createScript:(u,...h)=>{h.forEach(s=>{var r;if(!((r=self.trustedTypes)===null||r===void 0?void 0:r.isScript(s)))throw new Error("TrustedScripts only, please")});const g=h.slice(0,-1).join(","),t=h.pop().toString();return`(function anonymous(${g}) {
${t}
})`}});function E(...u){return v?self.eval(v.createScript("",...u)):new Function(...u)}d.create=E})(n||(n={}));class I extends S.RequireInterceptor{_installInterceptor(){}getModule(w,v){for(let E of this._alternatives){let u=E(w);if(u){w=u;break}}if(this._factories.has(w))return this._factories.get(w).load(w,v,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class o extends T.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=y.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const w=this._extHostContext.getProxy(D.MainContext.MainThreadConsole);c(w,this._initData.environment.isExtensionDevelopmentDebug);const v=this._instaService.invokeFunction(m.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(I,v,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(w){return w.browser}async _loadCommonJSModule(w,v,E){var u,h,g,t,i,s,r,l;v=v.with({path:f(v.path,".js")}),w&&performance.mark(`code/extHost/willFetchExtensionCode/${w.value}`);const _=await fetch(b.FileAccess.asBrowserUri(v).toString(!0));if(w&&performance.mark(`code/extHost/didFetchExtensionCode/${w.value}`),_.status!==200)throw new Error(_.statusText);const p=await _.text(),P=`${v.toString(!0)}#vscode-extension`,A=`${p}
//# sourceURL=${P}`;let a;try{a=n.create((h=(u=o._ttpExtensionScripts)===null||u===void 0?void 0:u.createScript("module"))!==null&&h!==void 0?h:"module",(t=(g=o._ttpExtensionScripts)===null||g===void 0?void 0:g.createScript("exports"))!==null&&t!==void 0?t:"exports",(s=(i=o._ttpExtensionScripts)===null||i===void 0?void 0:i.createScript("require"))!==null&&s!==void 0?s:"require",(l=(r=o._ttpExtensionScripts)===null||r===void 0?void 0:r.createScript(A))!==null&&l!==void 0?l:A)}catch(J){throw console.error(w?`Loading code for extension ${w.value} failed: ${J.message}`:`Loading code failed: ${J.message}`),console.error(`${v.toString(!0)}${typeof J.line=="number"?` line ${J.line}`:""}${typeof J.column=="number"?` column ${J.column}`:""}`),console.error(J),J}const R={},F={exports:R},x=J=>{const ae=this._fakeModules.getModule(J,v);if(ae===void 0)throw new Error(`Cannot load module '${J}'`);return ae};try{return E.codeLoadingStart(),w&&performance.mark(`code/extHost/willLoadExtensionCode/${w.value}`),a(F,R,x),F.exports!==R?F.exports:R}finally{w&&performance.mark(`code/extHost/didLoadExtensionCode/${w.value}`),E.codeLoadingStop()}}async $setRemoteEnvironment(w){throw new Error("Not supported")}async _waitForDebuggerAttachment(w=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const v=Date.now()+w;for(;Date.now()<v&&!("__jsDebugIsReady"in globalThis);)await k.timeout(10)}}e.ExtHostExtensionService=o,o._ttpExtensionScripts=(C=self.trustedTypes)===null||C===void 0?void 0:C.createPolicy("ExtensionScripts",{createScript:d=>d});function f(d,w){return d.endsWith(w)?d:d+w}function c(d,w){v("info","log"),v("log","log"),v("warn","warn"),v("error","error");function v(h,g){const t=console[h];console[h]=function(){d.$logExtensionHostMessage({type:"__$console",severity:g,arguments:u(arguments)}),w&&t.apply(console,arguments)}}const E=1e5;function u(h){const g=[],t=[];if(h.length)for(let i=0;i<h.length;i++){if(typeof h[i]=="undefined")h[i]="undefined";else if(h[i]instanceof Error){const s=h[i];s.stack?h[i]=s.stack:h[i]=s.toString()}t.push(h[i])}try{const i=JSON.stringify(t,function(s,r){if(r&&typeof r=="object"){if(g.indexOf(r)!==-1)return"[Circular]";g.push(r)}return r});return i.length>E?"Output omitted for a large object that exceeds the limits":i}catch(i){return`Output omitted for an object that cannot be inspected ('${i.toString()}')`}}}}),define(we[221],_e([0,1,57,16,33,220,207]),function(ee,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),m.registerSingleton(S.IExtHostExtensionService,y.ExtHostExtensionService),m.registerSingleton(T.ILogService,k.ExtHostLogService)}),define(we[223],_e([0,1,23,3,175,215,209,15,74,12,2,219,221]),function(ee,e,m,T,S,y,k,D,b,C,n){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0});const o=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const f=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const E=(I=self.trustedTypes)===null||I===void 0?void 0:I.createPolicy("extensionHostWorker",{createScriptURL:h=>h}),u=self.Worker;Worker=function(h,g){/^file:/i.test(h.toString())&&(h=C.FileAccess.asBrowserUri(n.URI.parse(h.toString())).toString(!0));const t=`(function() {
	const ttPolicy = self.trustedTypes ? self.trustedTypes.createPolicy('extensionHostWorker', { createScriptURL: (value) => value }) : undefined;
	const stringUrl = '${h}';
	importScripts(ttPolicy ? ttPolicy.createScriptURL(stringUrl) : stringUrl);
})();
`;g=g||{},g.name=g.name||D.basename(h.toString());const i=new Blob([t],{type:"application/javascript"}),s=URL.createObjectURL(i);return new u(E?E.createScriptURL(s):s,g)}}else self.Worker=class extends k.NestedWorker{constructor(E,u){super(f,E,Object.assign({name:D.basename(E.toString())},u))}};const c=new class{exit(E){o()}async exists(E){return!0}async realpath(E){return E}};class d{constructor(){const u=new MessageChannel,h=new T.Emitter;let g=!1;f(u.port2,[u.port2]),u.port1.onmessage=t=>{const{data:i}=t;if(!(i instanceof ArrayBuffer)){console.warn("UNKNOWN data received",i);return}const s=m.VSBuffer.wrap(new Uint8Array(i,0,i.byteLength));if(S.isMessageOfType(s,2)){g=!0,v("received terminate message from renderer");return}h.fire(s)},this.protocol={onMessage:h.event,send:t=>{if(!g){const i=t.buffer.buffer.slice(t.buffer.byteOffset,t.buffer.byteOffset+t.buffer.byteLength);u.port1.postMessage(i,[i])}}}}}function w(E){return new Promise(u=>{const h=E.onMessage(g=>{h.dispose();const t=JSON.parse(g.toString());E.send(S.createMessageOfType(0)),u({protocol:E,initData:t})});E.send(S.createMessageOfType(1))})}let v=E=>o();(function(){const u=new d;b.mark("code/extHost/willConnectToRenderer"),w(u.protocol).then(h=>{b.mark("code/extHost/didWaitForInitData");const g=new y.ExtensionHostMain(h.protocol,h.initData,c,null);v=t=>g.terminate(t)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9744231fc12f1aed21089180b3f0394d694bd2a2/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
